README file for TrXpl Module

Prepared by C.Ludescher-Furth -- ludescher@pppl.gov 09/28/00

****************
REVISION HISTORY
****************
      date          Description

  Sep. 28, 2000  -- Created 

----------------------------------------------------------------


Index:
   1. CONTENTS
   2. UNPACKING INSTRUCTIONS
   3. DESTINATIONS
   4. BUILDING INSTRUCTIONS
   5. TESTING INSTRUCTIONS
   6. DOCUMENTATION
   7. FINAL INSTALLATION


************
1. CONTENTS:
************
This directory should contain the following files:

README_Trxplib: This file.  Brief descriptions of the other files, and
                instructions for compiling, testing and installing the
                trxplib library libtrxplib.a and its test driver
                trxpl. 

Makefile:       NOTE, "GNU make" must be used
                (usually in /usr/gnu/bin or /usr/local/bin).
		Main Makefile to envoke Makefile(s) in subdirectories.  

-- in subdirectory share:
   Make.flags:        Include file for Makefile, to setup Flags, etc.
   Make.local.sample: Include file for Makefile, to setup non-conventional,
                      site specific locations.

-- in subdirectory trxplib:
   Copy of README
   Makefile
   Sources to build the library libtrxplib.a
	*.f90, *.F90
   Sources for programs:
   	trxpl.F

   Sample input/output files for test:
  	  

-- in subdirectory uflib:
   Makefile
   Sources to build internally used library libuflib.a.
	to read ufiles.

-- in subdirectory ufhdf:
   Makefile
   Sources to build internally used library libufhdf.a.
	to read ufiles of netCDF/ HDF formats.

-- in subdirectory fpreproc:
   Python scripts for fortran pre-processing.

-- in subdirectory include/fpreproc:
   *.h files for source pre-processing.


**************************
2. UNPACKING INSTRUCTIONS:
**************************
Note: Download the module(s) into an empty directory.
  
for tarfiles:
  > gunzip trxplib.tar.gz
  > tar xvf trxplib.tar

or, for zip archives:
  > unzip trxplib.zip


****************
3. DESTINATIONS:
****************
Or where do the files go?
(this refers to building and testing; see FINAL INSTALLATION for end result) 


When you extract the tar file you get sub directories:
./trxplib           --  sources and Makefile
./share             --  include file Make.flags, Make.local.sample
./include/fpreproc  --  *.h files for cpp
./fpreproc          --  scripts for pre-processing of fortran
./uflib             --  to read standard ufiles
./ufhdf             --  to read ufiles of netCDF / HDF format

The makefile will create more sub directories,

lib:     for the library, libtrxplib.a
mod:     for the f90 modules
obj/*:   for compiled objects and pre-processed sources
test:    for the test programs and the sample output files.

By default these directories are created in  
./<MACHINE>, which is determined by Make.flags.
e.g.: if you are running Linux, and the tar file resides in $HOME/foo,
      the directories would be in
      $HOME/foo/LINUX/...

You can overwrite the destination by defining OBJ, as an environment
variable (e.g. export OBJ=/dir1/dir2),
or with make (e.g. "make all OBJ=.").
If OBJ is defined, the destinations will be
$OBJ/lib and $OBJ/test.
If OBJ is defined as "." then, in the example above, the destination
would be $HOME/foo/lib.

The rationale behind <MACHINE> is to facilitate building for various platforms.

Note: If you define OBJ as option to gmake, you have to consistently do so;
      e.g: gmake clean OBJ=., gmake install OBJ=.

 
*************************
4. BUILDING INSTRUCTIONS:
*************************

Required Libraries:
===================
           libxplasma.a   -> NTCC module XPLASMA
           libtrread.a    -> NTCC module TRREAD   
           libpspline.a   -> NTCC module PSPLINE   
	   MDSplus
           lapack
	   blas
           netCDF
	   HDF



Check with your systems administrator where these libraries and modules are.


lapack, blas, HDF and netCDF
----------------------------
lapack, blas, HDF (-ldf -lz) and netCDF are assumed to be in /usr/local/lib,
if not, you can specify the location with LIBROOT,

e.g.: "gmake LIBROOT=/usr/contrib".

If netCDF is in a separate location, specify NETCDF_DIR
e.g.: "gmake NETCDF_DIR=/usr/local/my-netcdf LIBROOT=/my-libroot".

Alternatively you can modify Make.local.sample
and rename it to Make.local.

MDSplus
-------
MdsLib is assumed to be in /usr/local/mdslib/lib
if not, define MDSPLUS_DIR or modify MDSLIB in share/Make.local

If you don't have MDSplus, build the code with
"make NO_MDSPLUS=1" -or- define environment variable NO_MDSPLUS


xplasma, trread and pspline
---------------------------
If your site already has these libraries installed,
specify their location (library and modules) with PREFIX, 

e.g. "gmake PREFIX=/usr/ntcc"

At PPPL these libraries are in /usr/ntcc.

Note: If you don't have all required NTCC libraries, you may download them
      together into the same root directory. The Makefile will build them
      all in one  step.


Building libraries and proprams
-------------------------------- 
> gmake            -- to compile library and link all test programs

> gmake checklibs  -- tells you what the makefile will do
                      (without any action);
                      it says which libraries it will make and
                      which ones it already found and where.

> gmake clean      -- to remove objects
> gmake realclean  -- to remove objects and library

> gmake show_makeflags -- to see what flags, definitions Make will use


Compiling on Linux:
-------------------

By default the Makefile will select Fujitsu f95.

To select a different compiler define
FORTRAN_VARIANT to "Portland"  "NagWare"  "Fujitsu" "Intel" or "Absoft"

e.g.:
setenv FORTRAN_VARIANT Portland (csh)
FORTRAN_VARIANT=Portland; export  FORTRAN_VARIANT (sh)

Alternatively, FORTRAN_VARIANT can be passed directly to the gmake
command, as in:
gmake  FORTRAN_VARIANT=Portland

To use vastf90:
> gmake VAST90=y

To use NAG90: 
> gmake NAG90=y


Compiling on Alpha Linux:
-------------------------
The Makefile assumes the Compaq compiler and specifies the 
 " -assume no2underscores " option.

Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.


Compiling on SUN:
-----------------
The Makefile specifies the -dalign option.
Therefore the calling user software must also be compiled with this
option, or you should edit share/Make.flags to remove the option.



************************
5. TESTING INSTRUCTIONS:
************************

directory $OBJ/test  -or-  <MACHINE>/test  will contain:

trxpl     :  Test driver for trxplib


To run test:
-----------
define environment variable TERMINAL_TYPE = XTERM
 (e.g. export TERMINAL_TYPE=XTERM)

cd <MACHINE>/test

./trxpl

For details see README or http://w3.pppl.gov/~pshare/help/trxplib.htm


************************
6. DOCUMENTATION:
************************

TrXplib Home Page:
http://w3.pppl.gov/NTCC/TrXplib

TrXplib HELP
http://w3.pppl.gov/~pshare/help/trxplib.htm

NTCC Home Page:
http://w3.pppl.gov/NTCC

NOTE:
The `trxpl' source, trxpl.for, can be used as an example of
programming with the trxplib library.

**********************
7. FINAL INSTALLATION:
**********************

Choose or create the root directory in which you wish to install the software.
A common location would be /usr/ntcc, but installation can occur in any
directory where you have appropriate permissions.

You define your choice of root directory via PREFIX.
The default for PREFIX is /usr/ntcc.

The assumptions are:

libraries in:       $PREFIX/lib        = $LIBDIR
f90 modules in:     $PREFIX/mod        = $MODDIR
utility in:         $PREFIX/bin        = $BINDIR
man pages in:       $PREFIX/man/man3   = $MANDIR/man3

To install the software, return to the top directory (the directory,
where you downloaded the tar files) and type

>  gmake install  
    to install into /usr/ntcc/...

>  gmake install PREFIX=/dir1/dir2/
    to install into /dir1/dir2/...

If you want things elsewhere, you can overwrite the default with
> gmake install LIBDIR=/xxx MODDIR=yyy BINDIR=zzz

NOTE:
-----
The library is installed as libtrxplib.a
Users should link with

-L<PREFIX>/lib -ltrxplib

Make sure users know what <PREFIX> is.

After you have installed the software, you can delete the entire tree
with
> cd ..
> rm -r foo
   assuming the previous example.

----------------------------------------------------------------------------

IF YOU HAVE ANY PROBLEMS, PLEASE CONTACT EITHER:


        Doug McCune, Princeton University
                dmccune@pppl.gov
        or

        Christiane Ludescher-Furth, Princeton University
                cludescher@pppl.gov
        or      
                ntcc_webmaster@pppl.gov

subroutine trx_imas(ntheta,ierr)
  use trx_module
  implicit NONE
!
!  read TRANSP MHD equilibrium data; store in xplasma for use via
!  interpolation routines
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer, intent(IN) :: ntheta        ! no. of theta grid pts [-pi,pi]
  integer, intent(OUT) :: ierr         ! completion code, 0=OK
!
!----------------------------
!
  real*4 r4ztheta(ntheta)
  real*8 ztheta(ntheta),zpi
!
! for Psi(R,Z) acquisition (free bdy mode)
  character*64 zlbl
  character*32 zuns
  real*8 :: ztime0,zdelt
!
  integer igot,idum
  integer :: lunzer
!
  real Rarr(ntheta,nsurf),Zarr(ntheta,nsurf)
  real*8 r8Rarr(ntheta,nsurf),r8Zarr(ntheta,nsurf)
!
  real zrho(nsurf),zpsi(nsurf),zpmhd(nsurf),zqmhd(nsurf),zgmhd(nsurf)
  real*8 zbuf(nsurf)
  real ztflux,zpcur
  integer isurf,inx,inxp1
!
  real*8, dimension(:), allocatable :: arr1
  real*8 :: zrcen1,zrcen2,zzcen1,zzcen2,zrtest,zztest,testval,testval2,zdpsi
  real*8 :: zmina(3),zresult
  integer :: ircen1,ircen2,izcen1,izcen2,iraxis,izaxis
  logical :: iexist
!----------------------------
!
  call trx_ready('trx_imas',ierr)
  if(ierr.ne.0) return
!
  ztime0=time0   ! R8
  zdelt =delta_t ! R8
  isurf=nsurf-1
  allocate(arr1(isurf))

  call rpexist_profile('CUR',iexist)

  if (iexist) then
     call r8_t1profil('CUR',zlbl,zuns,ztime0,zdelt, &
          idum,arr1,isurf,igot,ierr)
     if(ierr.ne.0) then
        call zermsg(' ?trx_imas:  "CUR" profile read failed.')
        ierr=1
     endif
  else
     call zermsg(' ?trx_imas:  "CUR" profile does not exist.')
     ierr=1
  end if
  if(ierr.ne.0) then
     deallocate(arr1)
     return
  endif

  inx=igot
  inxp1=inx+1

!
! set up 1d profiles
!
  zbuf=0.0
  zbuf(2:inxp1)=arr1(1:inx)*1.0e-4 ! A/cm**2 -> A/m**2
  call eqm_rhofun(2,id_rho,'icurt',zbuf,1,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'A/m**2',0)
  if(ierr.ne.0) then
     deallocate(arr1)
     return
  endif
!
  call rpexist_profile('PLJB',iexist)
  arr1=0.0
  if (iexist) then
     call r8_t1profil('PLJB',zlbl,zuns,ztime0,zdelt, &
          idum,arr1,isurf,igot,ierr)
     if(ierr.ne.0) then
        call zermsg(' ?trx_imas:  "PLJB" profile read failed.')
        ierr=1
     endif
  else
     call zermsg(' ?trx_imas:  "PLJB" profile does not exist.')
     ierr=1
  end if
  if(ierr.ne.0) then
     deallocate(arr1)
     return
  endif
!
  zbuf=0.0
  zbuf(2:inxp1)=arr1(1:inx)*1.0e-4 ! A*T/cm**2 -> A*T/m**2
  call eqm_rhofun(2,id_rho,'curpll',zbuf,1,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'A*T/m**2',0)
  if(ierr.ne.0) then
     deallocate(arr1)
     return
  endif
!
  return
end subroutine trx_imas
 

C-----------------------------------------------------------------
C  TDB_PRFNXP
C   FIND LEAST POINT IN PROFILE THAT IS GREATER THAN PASSED VALUE
C   ALSO REQUIRE POINT TO BE IN REGION OF CURVE WITH POSITIVE SLOPE,
C   OR THE CURVES ABSOLUTE MAXIMUM.
C
      SUBROUTINE TDB_PRFNXP(ZY,ZX,INUM,ZBASE,ZX1,ILOC,ZTOL)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER inum,iloc,imax,isets,i,ilm1,ilp1,ifnd,ix,imin
      integer lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zx,zbase,zx1,ztol,zy,zcd,zc0,zc1,zx0,zy0,zmax,zmin
!============
      DIMENSION ZX(INUM),ZY(INUM)
C
C  ZX,ZY (INUM)  INPUT PROFILE
C  ZBASE  INPUT BASE VALUE
C  ILOC   OUTPUT INDEX LOCATION
C  ZX1    OUTPUT FIRST X LOCATION
C
C  FIND LEAST POINT ZY(ILOC) .GT. ZBASE
C  RETURN ILOC=0 IF NO SUCH POINT EXISTS
C
      ZCD=.5_R8*ABS(ZX(INUM)-ZX(1))
      ZC0=ZX(1)-2._R8*ZCD
      ZC1=ZC0+ZCD
 1    CONTINUE
C  LOCATE ALSO FIRST RADIUS WHERE PROFILE SLOPE IS INCREASING
      ZX0=ZC0
      zx1=zx0
      zy0=0.0_R8
      ILOC=0
      ZMAX=0.0_R8
      IMAX=0
      IMIN=0
      isets=0
      DO 10 I=1,INUM
         if(i.eq.1) then
            imin=1
            zmin=zy(1)
         else if(zy(i).lt.zmin) then
            imin=i
            zmin=zy(i)
         endif
C  INCR. SLOPE?
         IF(isets.gt.0) GO TO 2
C
         IF(I.EQ.INUM) THEN
            ZX0=ZC1
            zy0=zmin
         else
            IF(ZY(I+1).LE.ZY(I)) GO TO 2
            ZX0=ZC1
            IF(I.GT.1) ZX0=.5_R8*(ZX(I-1)+ZX(I))
            ZY0=ZY(I)
            isets=1
         endif
C
 2       CONTINUE
         IF(ZY(I).LE.ZMAX) GO TO 4
         ZMAX=ZY(I)
         IMAX=I
C
 4       CONTINUE
         IF(ZY(I).LE.ZBASE) GO TO 10
         IF(ILOC.GT.0) GO TO 6
         ILOC=I
C
 6       CONTINUE
         IF(ZY(I).LT.ZY(ILOC)) ILOC=I
 10   CONTINUE
C
      IF(ILOC.EQ.0) GOTO 1000
      IF(IPRFEQ(ZY(ILOC),ZY(IMAX),ZTOL)) ILOC=IMAX
      ZX1=ZX(ILOC)
      ZBASE=ZY(ILOC)*(1.0_R8+ZTOL)
C
      IF(ILOC.EQ.IMAX) GOTO 1000
C---
C
      ILM1=max(1,(ILOC-1))
      IF((ILOC.EQ.1).AND.(ZY(ILOC+1).GT.ZY(ILOC))) GOTO 1000
      IF(ILOC.EQ.INUM) GO TO 100
      IF(ZY(ILOC).EQ.ZY(ILOC+1)) ILOC=ILOC+1
      ILP1=min(INUM,(ILOC+1))
C  MAKE SURE POINT IS NOT A LOCAL SINGULARITY
      IF((ZY(ILOC).LT.ZY(ILM1)).AND.(ZY(ILOC).LT.ZY(ILP1)))
     >     GO TO 1
      IF((ZY(ILOC).GT.ZY(ILM1)).AND.(ZY(ILOC).GT.ZY(ILP1)))
     >     GO TO 1
C  BE SURE TO LOCATE CORRECT FIRST RADIAL LOCATION--
C  IN CASE OF HOLLOW PROFILE
 100  CONTINUE
      IF(ZY(ILOC).LE.ZY0) GO TO 1
      CALL TDB_PRFNXX(ZY,ZX,INUM,ZY(ILOC),ZX0,ZX1,IFND)
      GOTO 1000
C-----
 1000 CONTINUE
      RETURN
C-----

      contains
        logical function iprfeq(zt1,zt2,ztol)
        real*8, intent(in) :: zt1,zt2,ztol

        real*8 :: z1,z2

        Z1=min(ZT1,ZT2)
        Z2=max(ZT1,ZT2)
        IPRFEQ=.FALSE.
        IF(Z2.LE.(1.0_R8+ZTOL)*Z1) IPRFEQ=.TRUE.

        end function iprfeq

      END

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_0(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF(ALLOCATED(ss3%alla_index)) THEN
     IF(ALLOCATED(ss1%alla_index).AND.ALLOCATED(ss2%alla_index)) THEN
        CALL ps_diff("alla_index",ss1%alla_index,ss2%alla_index,ps_error,iout,ierr)
        CALL ps_conformal("alla_index",ss1%alla_index,ss3%alla_index,iout,ierr)
        if(ierr.eq.0) ss3%alla_index = ss1%alla_index
     ELSE IF(ALLOCATED(ss1%alla_index)) THEN
        CALL ps_conformal("alla_index",ss1%alla_index,ss3%alla_index,iout,ierr)
        ss3%alla_index = ss1%alla_index
     ELSE IF(ALLOCATED(ss2%alla_index)) THEN
        CALL ps_conformal("alla_index",ss2%alla_index,ss3%alla_index,iout,ierr)
        ss3%alla_index = ss2%alla_index
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%ALLA_name)) THEN
     IF(ALLOCATED(ss1%ALLA_name).AND.ALLOCATED(ss2%ALLA_name)) THEN
        CALL ps_diff("ALLA_name",ss1%ALLA_name,ss2%ALLA_name,ps_error,iout,ierr)
        CALL ps_conformal("ALLA_name",ss1%ALLA_name,ss3%ALLA_name,iout,ierr)
        if(ierr.eq.0) ss3%ALLA_name = ss1%ALLA_name
     ELSE IF(ALLOCATED(ss1%ALLA_name)) THEN
        CALL ps_conformal("ALLA_name",ss1%ALLA_name,ss3%ALLA_name,iout,ierr)
        ss3%ALLA_name = ss1%ALLA_name
     ELSE IF(ALLOCATED(ss2%ALLA_name)) THEN
        CALL ps_conformal("ALLA_name",ss2%ALLA_name,ss3%ALLA_name,iout,ierr)
        ss3%ALLA_name = ss2%ALLA_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%ALLA_type)) THEN
     IF(ALLOCATED(ss1%ALLA_type).AND.ALLOCATED(ss2%ALLA_type)) THEN
        CALL ps_diff("ALLA_type",ss1%ALLA_type,ss2%ALLA_type,ps_error,iout,ierr)
        CALL ps_conformal("ALLA_type",ss1%ALLA_type,ss3%ALLA_type,iout,ierr)
        if(ierr.eq.0) ss3%ALLA_type = ss1%ALLA_type
     ELSE IF(ALLOCATED(ss1%ALLA_type)) THEN
        CALL ps_conformal("ALLA_type",ss1%ALLA_type,ss3%ALLA_type,iout,ierr)
        ss3%ALLA_type = ss1%ALLA_type
     ELSE IF(ALLOCATED(ss2%ALLA_type)) THEN
        CALL ps_conformal("ALLA_type",ss2%ALLA_type,ss3%ALLA_type,iout,ierr)
        ss3%ALLA_type = ss2%ALLA_type
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%all_index)) THEN
     IF(ALLOCATED(ss1%all_index).AND.ALLOCATED(ss2%all_index)) THEN
        CALL ps_diff("all_index",ss1%all_index,ss2%all_index,ps_error,iout,ierr)
        CALL ps_conformal("all_index",ss1%all_index,ss3%all_index,iout,ierr)
        if(ierr.eq.0) ss3%all_index = ss1%all_index
     ELSE IF(ALLOCATED(ss1%all_index)) THEN
        CALL ps_conformal("all_index",ss1%all_index,ss3%all_index,iout,ierr)
        ss3%all_index = ss1%all_index
     ELSE IF(ALLOCATED(ss2%all_index)) THEN
        CALL ps_conformal("all_index",ss2%all_index,ss3%all_index,iout,ierr)
        ss3%all_index = ss2%all_index
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%ALL_name)) THEN
     IF(ALLOCATED(ss1%ALL_name).AND.ALLOCATED(ss2%ALL_name)) THEN
        CALL ps_diff("ALL_name",ss1%ALL_name,ss2%ALL_name,ps_error,iout,ierr)
        CALL ps_conformal("ALL_name",ss1%ALL_name,ss3%ALL_name,iout,ierr)
        if(ierr.eq.0) ss3%ALL_name = ss1%ALL_name
     ELSE IF(ALLOCATED(ss1%ALL_name)) THEN
        CALL ps_conformal("ALL_name",ss1%ALL_name,ss3%ALL_name,iout,ierr)
        ss3%ALL_name = ss1%ALL_name
     ELSE IF(ALLOCATED(ss2%ALL_name)) THEN
        CALL ps_conformal("ALL_name",ss2%ALL_name,ss3%ALL_name,iout,ierr)
        ss3%ALL_name = ss2%ALL_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%ALL_type)) THEN
     IF(ALLOCATED(ss1%ALL_type).AND.ALLOCATED(ss2%ALL_type)) THEN
        CALL ps_diff("ALL_type",ss1%ALL_type,ss2%ALL_type,ps_error,iout,ierr)
        CALL ps_conformal("ALL_type",ss1%ALL_type,ss3%ALL_type,iout,ierr)
        if(ierr.eq.0) ss3%ALL_type = ss1%ALL_type
     ELSE IF(ALLOCATED(ss1%ALL_type)) THEN
        CALL ps_conformal("ALL_type",ss1%ALL_type,ss3%ALL_type,iout,ierr)
        ss3%ALL_type = ss1%ALL_type
     ELSE IF(ALLOCATED(ss2%ALL_type)) THEN
        CALL ps_conformal("ALL_type",ss2%ALL_type,ss3%ALL_type,iout,ierr)
        ss3%ALL_type = ss2%ALL_type
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%amaxlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%amaxlh).AND.ALLOCATED(ss2%amaxlh)) THEN
        CALL ps_diff("amaxlh",ss1%amaxlh,ss2%amaxlh,icheck,iout,ierr)
        CALL ps_conformal("amaxlh",ss1%amaxlh,ss3%amaxlh,iout,ierr)
        if(ierr.eq.0) ss3%amaxlh = ss1%amaxlh
     ELSE IF(ALLOCATED(ss1%amaxlh)) THEN
        CALL ps_conformal("amaxlh",ss1%amaxlh,ss3%amaxlh,iout,ierr)
        ss3%amaxlh = ss1%amaxlh
     ELSE IF(ALLOCATED(ss2%amaxlh)) THEN
        CALL ps_conformal("amaxlh",ss2%amaxlh,ss3%amaxlh,iout,ierr)
        ss3%amaxlh = ss2%amaxlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%aminlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%aminlh).AND.ALLOCATED(ss2%aminlh)) THEN
        CALL ps_diff("aminlh",ss1%aminlh,ss2%aminlh,icheck,iout,ierr)
        CALL ps_conformal("aminlh",ss1%aminlh,ss3%aminlh,iout,ierr)
        if(ierr.eq.0) ss3%aminlh = ss1%aminlh
     ELSE IF(ALLOCATED(ss1%aminlh)) THEN
        CALL ps_conformal("aminlh",ss1%aminlh,ss3%aminlh,iout,ierr)
        ss3%aminlh = ss1%aminlh
     ELSE IF(ALLOCATED(ss2%aminlh)) THEN
        CALL ps_conformal("aminlh",ss2%aminlh,ss3%aminlh,iout,ierr)
        ss3%aminlh = ss2%aminlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Ang_Href_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Ang_Href_coil).AND.ALLOCATED(ss2%Ang_Href_coil)) THEN
        CALL ps_diff("Ang_Href_coil",ss1%Ang_Href_coil,ss2%Ang_Href_coil,icheck,iout,ierr)
        CALL ps_conformal("Ang_Href_coil",ss1%Ang_Href_coil,ss3%Ang_Href_coil,iout,ierr)
        if(ierr.eq.0) ss3%Ang_Href_coil = ss1%Ang_Href_coil
     ELSE IF(ALLOCATED(ss1%Ang_Href_coil)) THEN
        CALL ps_conformal("Ang_Href_coil",ss1%Ang_Href_coil,ss3%Ang_Href_coil,iout,ierr)
        ss3%Ang_Href_coil = ss1%Ang_Href_coil
     ELSE IF(ALLOCATED(ss2%Ang_Href_coil)) THEN
        CALL ps_conformal("Ang_Href_coil",ss2%Ang_Href_coil,ss3%Ang_Href_coil,iout,ierr)
        ss3%Ang_Href_coil = ss2%Ang_Href_coil
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Ang_Vref_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Ang_Vref_coil).AND.ALLOCATED(ss2%Ang_Vref_coil)) THEN
        CALL ps_diff("Ang_Vref_coil",ss1%Ang_Vref_coil,ss2%Ang_Vref_coil,icheck,iout,ierr)
        CALL ps_conformal("Ang_Vref_coil",ss1%Ang_Vref_coil,ss3%Ang_Vref_coil,iout,ierr)
        if(ierr.eq.0) ss3%Ang_Vref_coil = ss1%Ang_Vref_coil
     ELSE IF(ALLOCATED(ss1%Ang_Vref_coil)) THEN
        CALL ps_conformal("Ang_Vref_coil",ss1%Ang_Vref_coil,ss3%Ang_Vref_coil,iout,ierr)
        ss3%Ang_Vref_coil = ss1%Ang_Vref_coil
     ELSE IF(ALLOCATED(ss2%Ang_Vref_coil)) THEN
        CALL ps_conformal("Ang_Vref_coil",ss2%Ang_Vref_coil,ss3%Ang_Vref_coil,iout,ierr)
        ss3%Ang_Vref_coil = ss2%Ang_Vref_coil
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_ANOM).EQ.1) THEN

     CALL ps_diff("ANOM_Code_Info",ss1%ANOM_Code_Info,ss2%ANOM_Code_Info,icheck,iout,ierr)
     ss3%ANOM_Code_Info = ss1%ANOM_Code_Info
  ENDIF

  IF((ALLOCATED(ss3%anom_evar)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%anom_evar).AND.ALLOCATED(ss2%anom_evar)) THEN
        CALL ps_conformal("anom_evar",ss2%anom_evar,ss3%anom_evar,iout,ierr)
        CALL ps_conformal("anom_evar",ss1%anom_evar,ss3%anom_evar,iout,ierr)
        if(ierr.eq.0) ss3%anom_evar = w1*ss1%anom_evar + (1.0_rspec-w1)*ss2%anom_evar
     ELSE IF(ALLOCATED(ss1%anom_evar)) THEN
        CALL ps_conformal("anom_evar",ss1%anom_evar,ss3%anom_evar,iout,ierr)
        ss3%anom_evar = ss1%anom_evar
     ELSE IF(ALLOCATED(ss2%anom_evar)) THEN
        CALL ps_conformal("anom_evar",ss2%anom_evar,ss3%anom_evar,iout,ierr)
        ss3%anom_evar = ss2%anom_evar
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ant_model)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%ant_model).AND.ALLOCATED(ss2%ant_model)) THEN
        CALL ps_diff("ant_model",ss1%ant_model,ss2%ant_model,icheck,iout,ierr)
        CALL ps_conformal("ant_model",ss1%ant_model,ss3%ant_model,iout,ierr)
        if(ierr.eq.0) ss3%ant_model = ss1%ant_model
     ELSE IF(ALLOCATED(ss1%ant_model)) THEN
        CALL ps_conformal("ant_model",ss1%ant_model,ss3%ant_model,iout,ierr)
        ss3%ant_model = ss1%ant_model
     ELSE IF(ALLOCATED(ss2%ant_model)) THEN
        CALL ps_conformal("ant_model",ss2%ant_model,ss3%ant_model,iout,ierr)
        ss3%ant_model = ss2%ant_model
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap2_halfheight)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap2_halfheight).AND.ALLOCATED(ss2%ap2_halfheight)) THEN
        CALL ps_diff("ap2_halfheight",ss1%ap2_halfheight,ss2%ap2_halfheight,icheck,iout,ierr)
        CALL ps_conformal("ap2_halfheight",ss1%ap2_halfheight,ss3%ap2_halfheight,iout,ierr)
        if(ierr.eq.0) ss3%ap2_halfheight = ss1%ap2_halfheight
     ELSE IF(ALLOCATED(ss1%ap2_halfheight)) THEN
        CALL ps_conformal("ap2_halfheight",ss1%ap2_halfheight,ss3%ap2_halfheight,iout,ierr)
        ss3%ap2_halfheight = ss1%ap2_halfheight
     ELSE IF(ALLOCATED(ss2%ap2_halfheight)) THEN
        CALL ps_conformal("ap2_halfheight",ss2%ap2_halfheight,ss3%ap2_halfheight,iout,ierr)
        ss3%ap2_halfheight = ss2%ap2_halfheight
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap2_halfwidth)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap2_halfwidth).AND.ALLOCATED(ss2%ap2_halfwidth)) THEN
        CALL ps_diff("ap2_halfwidth",ss1%ap2_halfwidth,ss2%ap2_halfwidth,icheck,iout,ierr)
        CALL ps_conformal("ap2_halfwidth",ss1%ap2_halfwidth,ss3%ap2_halfwidth,iout,ierr)
        if(ierr.eq.0) ss3%ap2_halfwidth = ss1%ap2_halfwidth
     ELSE IF(ALLOCATED(ss1%ap2_halfwidth)) THEN
        CALL ps_conformal("ap2_halfwidth",ss1%ap2_halfwidth,ss3%ap2_halfwidth,iout,ierr)
        ss3%ap2_halfwidth = ss1%ap2_halfwidth
     ELSE IF(ALLOCATED(ss2%ap2_halfwidth)) THEN
        CALL ps_conformal("ap2_halfwidth",ss2%ap2_halfwidth,ss3%ap2_halfwidth,iout,ierr)
        ss3%ap2_halfwidth = ss2%ap2_halfwidth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap2_horiz_offset)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap2_horiz_offset).AND.ALLOCATED(ss2%ap2_horiz_offset)) THEN
        CALL ps_diff("ap2_horiz_offset",ss1%ap2_horiz_offset,ss2%ap2_horiz_offset,icheck,iout,ierr)
        CALL ps_conformal("ap2_horiz_offset",ss1%ap2_horiz_offset,ss3%ap2_horiz_offset,iout,ierr)
        if(ierr.eq.0) ss3%ap2_horiz_offset = ss1%ap2_horiz_offset
     ELSE IF(ALLOCATED(ss1%ap2_horiz_offset)) THEN
        CALL ps_conformal("ap2_horiz_offset",ss1%ap2_horiz_offset,ss3%ap2_horiz_offset,iout,ierr)
        ss3%ap2_horiz_offset = ss1%ap2_horiz_offset
     ELSE IF(ALLOCATED(ss2%ap2_horiz_offset)) THEN
        CALL ps_conformal("ap2_horiz_offset",ss2%ap2_horiz_offset,ss3%ap2_horiz_offset,iout,ierr)
        ss3%ap2_horiz_offset = ss2%ap2_horiz_offset
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap2_vert_offset)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap2_vert_offset).AND.ALLOCATED(ss2%ap2_vert_offset)) THEN
        CALL ps_diff("ap2_vert_offset",ss1%ap2_vert_offset,ss2%ap2_vert_offset,icheck,iout,ierr)
        CALL ps_conformal("ap2_vert_offset",ss1%ap2_vert_offset,ss3%ap2_vert_offset,iout,ierr)
        if(ierr.eq.0) ss3%ap2_vert_offset = ss1%ap2_vert_offset
     ELSE IF(ALLOCATED(ss1%ap2_vert_offset)) THEN
        CALL ps_conformal("ap2_vert_offset",ss1%ap2_vert_offset,ss3%ap2_vert_offset,iout,ierr)
        ss3%ap2_vert_offset = ss1%ap2_vert_offset
     ELSE IF(ALLOCATED(ss2%ap2_vert_offset)) THEN
        CALL ps_conformal("ap2_vert_offset",ss2%ap2_vert_offset,ss3%ap2_vert_offset,iout,ierr)
        ss3%ap2_vert_offset = ss2%ap2_vert_offset
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%apolmaxlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%apolmaxlh).AND.ALLOCATED(ss2%apolmaxlh)) THEN
        CALL ps_diff("apolmaxlh",ss1%apolmaxlh,ss2%apolmaxlh,icheck,iout,ierr)
        CALL ps_conformal("apolmaxlh",ss1%apolmaxlh,ss3%apolmaxlh,iout,ierr)
        if(ierr.eq.0) ss3%apolmaxlh = ss1%apolmaxlh
     ELSE IF(ALLOCATED(ss1%apolmaxlh)) THEN
        CALL ps_conformal("apolmaxlh",ss1%apolmaxlh,ss3%apolmaxlh,iout,ierr)
        ss3%apolmaxlh = ss1%apolmaxlh
     ELSE IF(ALLOCATED(ss2%apolmaxlh)) THEN
        CALL ps_conformal("apolmaxlh",ss2%apolmaxlh,ss3%apolmaxlh,iout,ierr)
        ss3%apolmaxlh = ss2%apolmaxlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%apolminlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%apolminlh).AND.ALLOCATED(ss2%apolminlh)) THEN
        CALL ps_diff("apolminlh",ss1%apolminlh,ss2%apolminlh,icheck,iout,ierr)
        CALL ps_conformal("apolminlh",ss1%apolminlh,ss3%apolminlh,iout,ierr)
        if(ierr.eq.0) ss3%apolminlh = ss1%apolminlh
     ELSE IF(ALLOCATED(ss1%apolminlh)) THEN
        CALL ps_conformal("apolminlh",ss1%apolminlh,ss3%apolminlh,iout,ierr)
        ss3%apolminlh = ss1%apolminlh
     ELSE IF(ALLOCATED(ss2%apolminlh)) THEN
        CALL ps_conformal("apolminlh",ss2%apolminlh,ss3%apolminlh,iout,ierr)
        ss3%apolminlh = ss2%apolminlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap_halfheight)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap_halfheight).AND.ALLOCATED(ss2%ap_halfheight)) THEN
        CALL ps_diff("ap_halfheight",ss1%ap_halfheight,ss2%ap_halfheight,icheck,iout,ierr)
        CALL ps_conformal("ap_halfheight",ss1%ap_halfheight,ss3%ap_halfheight,iout,ierr)
        if(ierr.eq.0) ss3%ap_halfheight = ss1%ap_halfheight
     ELSE IF(ALLOCATED(ss1%ap_halfheight)) THEN
        CALL ps_conformal("ap_halfheight",ss1%ap_halfheight,ss3%ap_halfheight,iout,ierr)
        ss3%ap_halfheight = ss1%ap_halfheight
     ELSE IF(ALLOCATED(ss2%ap_halfheight)) THEN
        CALL ps_conformal("ap_halfheight",ss2%ap_halfheight,ss3%ap_halfheight,iout,ierr)
        ss3%ap_halfheight = ss2%ap_halfheight
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap_halfwidth)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap_halfwidth).AND.ALLOCATED(ss2%ap_halfwidth)) THEN
        CALL ps_diff("ap_halfwidth",ss1%ap_halfwidth,ss2%ap_halfwidth,icheck,iout,ierr)
        CALL ps_conformal("ap_halfwidth",ss1%ap_halfwidth,ss3%ap_halfwidth,iout,ierr)
        if(ierr.eq.0) ss3%ap_halfwidth = ss1%ap_halfwidth
     ELSE IF(ALLOCATED(ss1%ap_halfwidth)) THEN
        CALL ps_conformal("ap_halfwidth",ss1%ap_halfwidth,ss3%ap_halfwidth,iout,ierr)
        ss3%ap_halfwidth = ss1%ap_halfwidth
     ELSE IF(ALLOCATED(ss2%ap_halfwidth)) THEN
        CALL ps_conformal("ap_halfwidth",ss2%ap_halfwidth,ss3%ap_halfwidth,iout,ierr)
        ss3%ap_halfwidth = ss2%ap_halfwidth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap_horiz_offset)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap_horiz_offset).AND.ALLOCATED(ss2%ap_horiz_offset)) THEN
        CALL ps_diff("ap_horiz_offset",ss1%ap_horiz_offset,ss2%ap_horiz_offset,icheck,iout,ierr)
        CALL ps_conformal("ap_horiz_offset",ss1%ap_horiz_offset,ss3%ap_horiz_offset,iout,ierr)
        if(ierr.eq.0) ss3%ap_horiz_offset = ss1%ap_horiz_offset
     ELSE IF(ALLOCATED(ss1%ap_horiz_offset)) THEN
        CALL ps_conformal("ap_horiz_offset",ss1%ap_horiz_offset,ss3%ap_horiz_offset,iout,ierr)
        ss3%ap_horiz_offset = ss1%ap_horiz_offset
     ELSE IF(ALLOCATED(ss2%ap_horiz_offset)) THEN
        CALL ps_conformal("ap_horiz_offset",ss2%ap_horiz_offset,ss3%ap_horiz_offset,iout,ierr)
        ss3%ap_horiz_offset = ss2%ap_horiz_offset
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ap_vert_offset)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%ap_vert_offset).AND.ALLOCATED(ss2%ap_vert_offset)) THEN
        CALL ps_diff("ap_vert_offset",ss1%ap_vert_offset,ss2%ap_vert_offset,icheck,iout,ierr)
        CALL ps_conformal("ap_vert_offset",ss1%ap_vert_offset,ss3%ap_vert_offset,iout,ierr)
        if(ierr.eq.0) ss3%ap_vert_offset = ss1%ap_vert_offset
     ELSE IF(ALLOCATED(ss1%ap_vert_offset)) THEN
        CALL ps_conformal("ap_vert_offset",ss1%ap_vert_offset,ss3%ap_vert_offset,iout,ierr)
        ss3%ap_vert_offset = ss1%ap_vert_offset
     ELSE IF(ALLOCATED(ss2%ap_vert_offset)) THEN
        CALL ps_conformal("ap_vert_offset",ss2%ap_vert_offset,ss3%ap_vert_offset,iout,ierr)
        ss3%ap_vert_offset = ss2%ap_vert_offset
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%area)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%area).AND.ALLOCATED(ss2%area)) THEN
        CALL ps_conformal("area",ss2%area,ss3%area,iout,ierr)
        CALL ps_conformal("area",ss1%area,ss3%area,iout,ierr)
        if(ierr.eq.0) ss3%area = w1*ss1%area + (1.0_rspec-w1)*ss2%area
     ELSE IF(ALLOCATED(ss1%area)) THEN
        CALL ps_conformal("area",ss1%area,ss3%area,iout,ierr)
        ss3%area = ss1%area
     ELSE IF(ALLOCATED(ss2%area)) THEN
        CALL ps_conformal("area",ss2%area,ss3%area,iout,ierr)
        ss3%area = ss2%area
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%atormaxlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%atormaxlh).AND.ALLOCATED(ss2%atormaxlh)) THEN
        CALL ps_diff("atormaxlh",ss1%atormaxlh,ss2%atormaxlh,icheck,iout,ierr)
        CALL ps_conformal("atormaxlh",ss1%atormaxlh,ss3%atormaxlh,iout,ierr)
        if(ierr.eq.0) ss3%atormaxlh = ss1%atormaxlh
     ELSE IF(ALLOCATED(ss1%atormaxlh)) THEN
        CALL ps_conformal("atormaxlh",ss1%atormaxlh,ss3%atormaxlh,iout,ierr)
        ss3%atormaxlh = ss1%atormaxlh
     ELSE IF(ALLOCATED(ss2%atormaxlh)) THEN
        CALL ps_conformal("atormaxlh",ss2%atormaxlh,ss3%atormaxlh,iout,ierr)
        ss3%atormaxlh = ss2%atormaxlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%atorminlh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%atorminlh).AND.ALLOCATED(ss2%atorminlh)) THEN
        CALL ps_diff("atorminlh",ss1%atorminlh,ss2%atorminlh,icheck,iout,ierr)
        CALL ps_conformal("atorminlh",ss1%atorminlh,ss3%atorminlh,iout,ierr)
        if(ierr.eq.0) ss3%atorminlh = ss1%atorminlh
     ELSE IF(ALLOCATED(ss1%atorminlh)) THEN
        CALL ps_conformal("atorminlh",ss1%atorminlh,ss3%atorminlh,iout,ierr)
        ss3%atorminlh = ss1%atorminlh
     ELSE IF(ALLOCATED(ss2%atorminlh)) THEN
        CALL ps_conformal("atorminlh",ss2%atorminlh,ss3%atorminlh,iout,ierr)
        ss3%atorminlh = ss2%atorminlh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Balloon_code)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Balloon_code).AND.ALLOCATED(ss2%Balloon_code)) THEN
        CALL ps_diff("Balloon_code",ss1%Balloon_code,ss2%Balloon_code,icheck,iout,ierr)
        CALL ps_conformal("Balloon_code",ss1%Balloon_code,ss3%Balloon_code,iout,ierr)
        if(ierr.eq.0) ss3%Balloon_code = ss1%Balloon_code
     ELSE IF(ALLOCATED(ss1%Balloon_code)) THEN
        CALL ps_conformal("Balloon_code",ss1%Balloon_code,ss3%Balloon_code,iout,ierr)
        ss3%Balloon_code = ss1%Balloon_code
     ELSE IF(ALLOCATED(ss2%Balloon_code)) THEN
        CALL ps_conformal("Balloon_code",ss2%Balloon_code,ss3%Balloon_code,iout,ierr)
        ss3%Balloon_code = ss2%Balloon_code
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Balloon_mapper)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Balloon_mapper).AND.ALLOCATED(ss2%Balloon_mapper)) THEN
        CALL ps_diff("Balloon_mapper",ss1%Balloon_mapper,ss2%Balloon_mapper,icheck,iout,ierr)
        CALL ps_conformal("Balloon_mapper",ss1%Balloon_mapper,ss3%Balloon_mapper,iout,ierr)
        if(ierr.eq.0) ss3%Balloon_mapper = ss1%Balloon_mapper
     ELSE IF(ALLOCATED(ss1%Balloon_mapper)) THEN
        CALL ps_conformal("Balloon_mapper",ss1%Balloon_mapper,ss3%Balloon_mapper,iout,ierr)
        ss3%Balloon_mapper = ss1%Balloon_mapper
     ELSE IF(ALLOCATED(ss2%Balloon_mapper)) THEN
        CALL ps_conformal("Balloon_mapper",ss2%Balloon_mapper,ss3%Balloon_mapper,iout,ierr)
        ss3%Balloon_mapper = ss2%Balloon_mapper
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Balloon_stable)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Balloon_stable).AND.ALLOCATED(ss2%Balloon_stable)) THEN
        CALL ps_diff("Balloon_stable",ss1%Balloon_stable,ss2%Balloon_stable,icheck,iout,ierr)
        CALL ps_conformal("Balloon_stable",ss1%Balloon_stable,ss3%Balloon_stable,iout,ierr)
        if(ierr.eq.0) ss3%Balloon_stable = ss1%Balloon_stable
     ELSE IF(ALLOCATED(ss1%Balloon_stable)) THEN
        CALL ps_conformal("Balloon_stable",ss1%Balloon_stable,ss3%Balloon_stable,iout,ierr)
        ss3%Balloon_stable = ss1%Balloon_stable
     ELSE IF(ALLOCATED(ss2%Balloon_stable)) THEN
        CALL ps_conformal("Balloon_stable",ss2%Balloon_stable,ss3%Balloon_stable,iout,ierr)
        ss3%Balloon_stable = ss2%Balloon_stable
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Balloon_status)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Balloon_status).AND.ALLOCATED(ss2%Balloon_status)) THEN
        CALL ps_diff("Balloon_status",ss1%Balloon_status,ss2%Balloon_status,icheck,iout,ierr)
        CALL ps_conformal("Balloon_status",ss1%Balloon_status,ss3%Balloon_status,iout,ierr)
        if(ierr.eq.0) ss3%Balloon_status = ss1%Balloon_status
     ELSE IF(ALLOCATED(ss1%Balloon_status)) THEN
        CALL ps_conformal("Balloon_status",ss1%Balloon_status,ss3%Balloon_status,iout,ierr)
        ss3%Balloon_status = ss1%Balloon_status
     ELSE IF(ALLOCATED(ss2%Balloon_status)) THEN
        CALL ps_conformal("Balloon_status",ss2%Balloon_status,ss3%Balloon_status,iout,ierr)
        ss3%Balloon_status = ss2%Balloon_status
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%balstab)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%balstab).AND.ALLOCATED(ss2%balstab)) THEN
        CALL ps_conformal("balstab",ss2%balstab,ss3%balstab,iout,ierr)
        CALL ps_conformal("balstab",ss1%balstab,ss3%balstab,iout,ierr)
        if(ierr.eq.0) ss3%balstab = w1*ss1%balstab + (1.0_rspec-w1)*ss2%balstab
     ELSE IF(ALLOCATED(ss1%balstab)) THEN
        CALL ps_conformal("balstab",ss1%balstab,ss3%balstab,iout,ierr)
        ss3%balstab = ss1%balstab
     ELSE IF(ALLOCATED(ss2%balstab)) THEN
        CALL ps_conformal("balstab",ss2%balstab,ss3%balstab,iout,ierr)
        ss3%balstab = ss2%balstab
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%beam_type)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%beam_type).AND.ALLOCATED(ss2%beam_type)) THEN
        CALL ps_diff("beam_type",ss1%beam_type,ss2%beam_type,icheck,iout,ierr)
        CALL ps_conformal("beam_type",ss1%beam_type,ss3%beam_type,iout,ierr)
        if(ierr.eq.0) ss3%beam_type = ss1%beam_type
     ELSE IF(ALLOCATED(ss1%beam_type)) THEN
        CALL ps_conformal("beam_type",ss1%beam_type,ss3%beam_type,iout,ierr)
        ss3%beam_type = ss1%beam_type
     ELSE IF(ALLOCATED(ss2%beam_type)) THEN
        CALL ps_conformal("beam_type",ss2%beam_type,ss3%beam_type,iout,ierr)
        ss3%beam_type = ss2%beam_type
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_bpass_co)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_bpass_co).AND.ALLOCATED(ss2%bidiff_bpass_co)) THEN
        CALL ps_conformal("bidiff_bpass_co",ss2%bidiff_bpass_co,ss3%bidiff_bpass_co,iout,ierr)
        CALL ps_conformal("bidiff_bpass_co",ss1%bidiff_bpass_co,ss3%bidiff_bpass_co,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_bpass_co = w1*ss1%bidiff_bpass_co + (1.0_rspec-w1)*ss2%bidiff_bpass_co
     ELSE IF(ALLOCATED(ss1%bidiff_bpass_co)) THEN
        CALL ps_conformal("bidiff_bpass_co",ss1%bidiff_bpass_co,ss3%bidiff_bpass_co,iout,ierr)
        ss3%bidiff_bpass_co = ss1%bidiff_bpass_co
     ELSE IF(ALLOCATED(ss2%bidiff_bpass_co)) THEN
        CALL ps_conformal("bidiff_bpass_co",ss2%bidiff_bpass_co,ss3%bidiff_bpass_co,iout,ierr)
        ss3%bidiff_bpass_co = ss2%bidiff_bpass_co
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_bpass_ctr)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_bpass_ctr).AND.ALLOCATED(ss2%bidiff_bpass_ctr)) THEN
        CALL ps_conformal("bidiff_bpass_ctr",ss2%bidiff_bpass_ctr,ss3%bidiff_bpass_ctr,iout,ierr)
        CALL ps_conformal("bidiff_bpass_ctr",ss1%bidiff_bpass_ctr,ss3%bidiff_bpass_ctr,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_bpass_ctr = w1*ss1%bidiff_bpass_ctr + (1.0_rspec-w1)*ss2%bidiff_bpass_ctr
     ELSE IF(ALLOCATED(ss1%bidiff_bpass_ctr)) THEN
        CALL ps_conformal("bidiff_bpass_ctr",ss1%bidiff_bpass_ctr,ss3%bidiff_bpass_ctr,iout,ierr)
        ss3%bidiff_bpass_ctr = ss1%bidiff_bpass_ctr
     ELSE IF(ALLOCATED(ss2%bidiff_bpass_ctr)) THEN
        CALL ps_conformal("bidiff_bpass_ctr",ss2%bidiff_bpass_ctr,ss3%bidiff_bpass_ctr,iout,ierr)
        ss3%bidiff_bpass_ctr = ss2%bidiff_bpass_ctr
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_btrap)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_btrap).AND.ALLOCATED(ss2%bidiff_btrap)) THEN
        CALL ps_conformal("bidiff_btrap",ss2%bidiff_btrap,ss3%bidiff_btrap,iout,ierr)
        CALL ps_conformal("bidiff_btrap",ss1%bidiff_btrap,ss3%bidiff_btrap,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_btrap = w1*ss1%bidiff_btrap + (1.0_rspec-w1)*ss2%bidiff_btrap
     ELSE IF(ALLOCATED(ss1%bidiff_btrap)) THEN
        CALL ps_conformal("bidiff_btrap",ss1%bidiff_btrap,ss3%bidiff_btrap,iout,ierr)
        ss3%bidiff_btrap = ss1%bidiff_btrap
     ELSE IF(ALLOCATED(ss2%bidiff_btrap)) THEN
        CALL ps_conformal("bidiff_btrap",ss2%bidiff_btrap,ss3%bidiff_btrap,iout,ierr)
        ss3%bidiff_btrap = ss2%bidiff_btrap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_dpass_co)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_dpass_co).AND.ALLOCATED(ss2%bidiff_dpass_co)) THEN
        CALL ps_conformal("bidiff_dpass_co",ss2%bidiff_dpass_co,ss3%bidiff_dpass_co,iout,ierr)
        CALL ps_conformal("bidiff_dpass_co",ss1%bidiff_dpass_co,ss3%bidiff_dpass_co,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_dpass_co = w1*ss1%bidiff_dpass_co + (1.0_rspec-w1)*ss2%bidiff_dpass_co
     ELSE IF(ALLOCATED(ss1%bidiff_dpass_co)) THEN
        CALL ps_conformal("bidiff_dpass_co",ss1%bidiff_dpass_co,ss3%bidiff_dpass_co,iout,ierr)
        ss3%bidiff_dpass_co = ss1%bidiff_dpass_co
     ELSE IF(ALLOCATED(ss2%bidiff_dpass_co)) THEN
        CALL ps_conformal("bidiff_dpass_co",ss2%bidiff_dpass_co,ss3%bidiff_dpass_co,iout,ierr)
        ss3%bidiff_dpass_co = ss2%bidiff_dpass_co
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_dpass_ctr)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_dpass_ctr).AND.ALLOCATED(ss2%bidiff_dpass_ctr)) THEN
        CALL ps_conformal("bidiff_dpass_ctr",ss2%bidiff_dpass_ctr,ss3%bidiff_dpass_ctr,iout,ierr)
        CALL ps_conformal("bidiff_dpass_ctr",ss1%bidiff_dpass_ctr,ss3%bidiff_dpass_ctr,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_dpass_ctr = w1*ss1%bidiff_dpass_ctr + (1.0_rspec-w1)*ss2%bidiff_dpass_ctr
     ELSE IF(ALLOCATED(ss1%bidiff_dpass_ctr)) THEN
        CALL ps_conformal("bidiff_dpass_ctr",ss1%bidiff_dpass_ctr,ss3%bidiff_dpass_ctr,iout,ierr)
        ss3%bidiff_dpass_ctr = ss1%bidiff_dpass_ctr
     ELSE IF(ALLOCATED(ss2%bidiff_dpass_ctr)) THEN
        CALL ps_conformal("bidiff_dpass_ctr",ss2%bidiff_dpass_ctr,ss3%bidiff_dpass_ctr,iout,ierr)
        ss3%bidiff_dpass_ctr = ss2%bidiff_dpass_ctr
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%bidiff_dtrap)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%bidiff_dtrap).AND.ALLOCATED(ss2%bidiff_dtrap)) THEN
        CALL ps_conformal("bidiff_dtrap",ss2%bidiff_dtrap,ss3%bidiff_dtrap,iout,ierr)
        CALL ps_conformal("bidiff_dtrap",ss1%bidiff_dtrap,ss3%bidiff_dtrap,iout,ierr)
        if(ierr.eq.0) ss3%bidiff_dtrap = w1*ss1%bidiff_dtrap + (1.0_rspec-w1)*ss2%bidiff_dtrap
     ELSE IF(ALLOCATED(ss1%bidiff_dtrap)) THEN
        CALL ps_conformal("bidiff_dtrap",ss1%bidiff_dtrap,ss3%bidiff_dtrap,iout,ierr)
        ss3%bidiff_dtrap = ss1%bidiff_dtrap
     ELSE IF(ALLOCATED(ss2%bidiff_dtrap)) THEN
        CALL ps_conformal("bidiff_dtrap",ss2%bidiff_dtrap,ss3%bidiff_dtrap,iout,ierr)
        ss3%bidiff_dtrap = ss2%bidiff_dtrap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%BphiRZ)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%BphiRZ).AND.ALLOCATED(ss2%BphiRZ)) THEN
        CALL ps_conformal("BphiRZ",ss2%BphiRZ,ss3%BphiRZ,iout,ierr)
        CALL ps_conformal("BphiRZ",ss1%BphiRZ,ss3%BphiRZ,iout,ierr)
        if(ierr.eq.0) ss3%BphiRZ = w1*ss1%BphiRZ + (1.0_rspec-w1)*ss2%BphiRZ
     ELSE IF(ALLOCATED(ss1%BphiRZ)) THEN
        CALL ps_conformal("BphiRZ",ss1%BphiRZ,ss3%BphiRZ,iout,ierr)
        ss3%BphiRZ = ss1%BphiRZ
     ELSE IF(ALLOCATED(ss2%BphiRZ)) THEN
        CALL ps_conformal("BphiRZ",ss2%BphiRZ,ss3%BphiRZ,iout,ierr)
        ss3%BphiRZ = ss2%BphiRZ
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%BRRZ)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%BRRZ).AND.ALLOCATED(ss2%BRRZ)) THEN
        CALL ps_conformal("BRRZ",ss2%BRRZ,ss3%BRRZ,iout,ierr)
        CALL ps_conformal("BRRZ",ss1%BRRZ,ss3%BRRZ,iout,ierr)
        if(ierr.eq.0) ss3%BRRZ = w1*ss1%BRRZ + (1.0_rspec-w1)*ss2%BRRZ
     ELSE IF(ALLOCATED(ss1%BRRZ)) THEN
        CALL ps_conformal("BRRZ",ss1%BRRZ,ss3%BRRZ,iout,ierr)
        ss3%BRRZ = ss1%BRRZ
     ELSE IF(ALLOCATED(ss2%BRRZ)) THEN
        CALL ps_conformal("BRRZ",ss2%BRRZ,ss3%BRRZ,iout,ierr)
        ss3%BRRZ = ss2%BRRZ
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%BZRZ)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%BZRZ).AND.ALLOCATED(ss2%BZRZ)) THEN
        CALL ps_conformal("BZRZ",ss2%BZRZ,ss3%BZRZ,iout,ierr)
        CALL ps_conformal("BZRZ",ss1%BZRZ,ss3%BZRZ,iout,ierr)
        if(ierr.eq.0) ss3%BZRZ = w1*ss1%BZRZ + (1.0_rspec-w1)*ss2%BZRZ
     ELSE IF(ALLOCATED(ss1%BZRZ)) THEN
        CALL ps_conformal("BZRZ",ss1%BZRZ,ss3%BZRZ,iout,ierr)
        ss3%BZRZ = ss1%BZRZ
     ELSE IF(ALLOCATED(ss2%BZRZ)) THEN
        CALL ps_conformal("BZRZ",ss2%BZRZ,ss3%BZRZ,iout,ierr)
        ss3%BZRZ = ss2%BZRZ
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%B_axis = w1*ss1%B_axis + (1.0_rspec-w1)*ss2%B_axis
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%B_axis_vac = w1*ss1%B_axis_vac + (1.0_rspec-w1)*ss2%B_axis_vac
  ENDIF

  IF((ALLOCATED(ss3%b_halfHeight)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_halfHeight).AND.ALLOCATED(ss2%b_halfHeight)) THEN
        CALL ps_diff("b_halfHeight",ss1%b_halfHeight,ss2%b_halfHeight,icheck,iout,ierr)
        CALL ps_conformal("b_halfHeight",ss1%b_halfHeight,ss3%b_halfHeight,iout,ierr)
        if(ierr.eq.0) ss3%b_halfHeight = ss1%b_halfHeight
     ELSE IF(ALLOCATED(ss1%b_halfHeight)) THEN
        CALL ps_conformal("b_halfHeight",ss1%b_halfHeight,ss3%b_halfHeight,iout,ierr)
        ss3%b_halfHeight = ss1%b_halfHeight
     ELSE IF(ALLOCATED(ss2%b_halfHeight)) THEN
        CALL ps_conformal("b_halfHeight",ss2%b_halfHeight,ss3%b_halfHeight,iout,ierr)
        ss3%b_halfHeight = ss2%b_halfHeight
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%b_halfwidth)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_halfwidth).AND.ALLOCATED(ss2%b_halfwidth)) THEN
        CALL ps_diff("b_halfwidth",ss1%b_halfwidth,ss2%b_halfwidth,icheck,iout,ierr)
        CALL ps_conformal("b_halfwidth",ss1%b_halfwidth,ss3%b_halfwidth,iout,ierr)
        if(ierr.eq.0) ss3%b_halfwidth = ss1%b_halfwidth
     ELSE IF(ALLOCATED(ss1%b_halfwidth)) THEN
        CALL ps_conformal("b_halfwidth",ss1%b_halfwidth,ss3%b_halfwidth,iout,ierr)
        ss3%b_halfwidth = ss1%b_halfwidth
     ELSE IF(ALLOCATED(ss2%b_halfwidth)) THEN
        CALL ps_conformal("b_halfwidth",ss2%b_halfwidth,ss3%b_halfwidth,iout,ierr)
        ss3%b_halfwidth = ss2%b_halfwidth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%b_Hdivergence)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_Hdivergence).AND.ALLOCATED(ss2%b_Hdivergence)) THEN
        CALL ps_diff("b_Hdivergence",ss1%b_Hdivergence,ss2%b_Hdivergence,icheck,iout,ierr)
        CALL ps_conformal("b_Hdivergence",ss1%b_Hdivergence,ss3%b_Hdivergence,iout,ierr)
        if(ierr.eq.0) ss3%b_Hdivergence = ss1%b_Hdivergence
     ELSE IF(ALLOCATED(ss1%b_Hdivergence)) THEN
        CALL ps_conformal("b_Hdivergence",ss1%b_Hdivergence,ss3%b_Hdivergence,iout,ierr)
        ss3%b_Hdivergence = ss1%b_Hdivergence
     ELSE IF(ALLOCATED(ss2%b_Hdivergence)) THEN
        CALL ps_conformal("b_Hdivergence",ss2%b_Hdivergence,ss3%b_Hdivergence,iout,ierr)
        ss3%b_Hdivergence = ss2%b_Hdivergence
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%b_Hfocal_length)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_Hfocal_length).AND.ALLOCATED(ss2%b_Hfocal_length)) THEN
        CALL ps_diff("b_Hfocal_length",ss1%b_Hfocal_length,ss2%b_Hfocal_length,icheck,iout,ierr)
        CALL ps_conformal("b_Hfocal_length",ss1%b_Hfocal_length,ss3%b_Hfocal_length,iout,ierr)
        if(ierr.eq.0) ss3%b_Hfocal_length = ss1%b_Hfocal_length
     ELSE IF(ALLOCATED(ss1%b_Hfocal_length)) THEN
        CALL ps_conformal("b_Hfocal_length",ss1%b_Hfocal_length,ss3%b_Hfocal_length,iout,ierr)
        ss3%b_Hfocal_length = ss1%b_Hfocal_length
     ELSE IF(ALLOCATED(ss2%b_Hfocal_length)) THEN
        CALL ps_conformal("b_Hfocal_length",ss2%b_Hfocal_length,ss3%b_Hfocal_length,iout,ierr)
        ss3%b_Hfocal_length = ss2%b_Hfocal_length
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%B_max_lcfs = w1*ss1%B_max_lcfs + (1.0_rspec-w1)*ss2%B_max_lcfs
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%B_min_lcfs = w1*ss1%B_min_lcfs + (1.0_rspec-w1)*ss2%B_min_lcfs
  ENDIF

  IF((ALLOCATED(ss3%B_surfMax)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%B_surfMax).AND.ALLOCATED(ss2%B_surfMax)) THEN
        CALL ps_conformal("B_surfMax",ss2%B_surfMax,ss3%B_surfMax,iout,ierr)
        CALL ps_conformal("B_surfMax",ss1%B_surfMax,ss3%B_surfMax,iout,ierr)
        if(ierr.eq.0) ss3%B_surfMax = w1*ss1%B_surfMax + (1.0_rspec-w1)*ss2%B_surfMax
     ELSE IF(ALLOCATED(ss1%B_surfMax)) THEN
        CALL ps_conformal("B_surfMax",ss1%B_surfMax,ss3%B_surfMax,iout,ierr)
        ss3%B_surfMax = ss1%B_surfMax
     ELSE IF(ALLOCATED(ss2%B_surfMax)) THEN
        CALL ps_conformal("B_surfMax",ss2%B_surfMax,ss3%B_surfMax,iout,ierr)
        ss3%B_surfMax = ss2%B_surfMax
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%B_surfMin)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%B_surfMin).AND.ALLOCATED(ss2%B_surfMin)) THEN
        CALL ps_conformal("B_surfMin",ss2%B_surfMin,ss3%B_surfMin,iout,ierr)
        CALL ps_conformal("B_surfMin",ss1%B_surfMin,ss3%B_surfMin,iout,ierr)
        if(ierr.eq.0) ss3%B_surfMin = w1*ss1%B_surfMin + (1.0_rspec-w1)*ss2%B_surfMin
     ELSE IF(ALLOCATED(ss1%B_surfMin)) THEN
        CALL ps_conformal("B_surfMin",ss1%B_surfMin,ss3%B_surfMin,iout,ierr)
        ss3%B_surfMin = ss1%B_surfMin
     ELSE IF(ALLOCATED(ss2%B_surfMin)) THEN
        CALL ps_conformal("B_surfMin",ss2%B_surfMin,ss3%B_surfMin,iout,ierr)
        ss3%B_surfMin = ss2%B_surfMin
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%b_Vdivergence)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_Vdivergence).AND.ALLOCATED(ss2%b_Vdivergence)) THEN
        CALL ps_diff("b_Vdivergence",ss1%b_Vdivergence,ss2%b_Vdivergence,icheck,iout,ierr)
        CALL ps_conformal("b_Vdivergence",ss1%b_Vdivergence,ss3%b_Vdivergence,iout,ierr)
        if(ierr.eq.0) ss3%b_Vdivergence = ss1%b_Vdivergence
     ELSE IF(ALLOCATED(ss1%b_Vdivergence)) THEN
        CALL ps_conformal("b_Vdivergence",ss1%b_Vdivergence,ss3%b_Vdivergence,iout,ierr)
        ss3%b_Vdivergence = ss1%b_Vdivergence
     ELSE IF(ALLOCATED(ss2%b_Vdivergence)) THEN
        CALL ps_conformal("b_Vdivergence",ss2%b_Vdivergence,ss3%b_Vdivergence,iout,ierr)
        ss3%b_Vdivergence = ss2%b_Vdivergence
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%b_Vfocal_length)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%b_Vfocal_length).AND.ALLOCATED(ss2%b_Vfocal_length)) THEN
        CALL ps_diff("b_Vfocal_length",ss1%b_Vfocal_length,ss2%b_Vfocal_length,icheck,iout,ierr)
        CALL ps_conformal("b_Vfocal_length",ss1%b_Vfocal_length,ss3%b_Vfocal_length,iout,ierr)
        if(ierr.eq.0) ss3%b_Vfocal_length = ss1%b_Vfocal_length
     ELSE IF(ALLOCATED(ss1%b_Vfocal_length)) THEN
        CALL ps_conformal("b_Vfocal_length",ss1%b_Vfocal_length,ss3%b_Vfocal_length,iout,ierr)
        ss3%b_Vfocal_length = ss1%b_Vfocal_length
     ELSE IF(ALLOCATED(ss2%b_Vfocal_length)) THEN
        CALL ps_conformal("b_Vfocal_length",ss2%b_Vfocal_length,ss3%b_Vfocal_length,iout,ierr)
        ss3%b_Vfocal_length = ss2%b_Vfocal_length
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%cdicrf)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%cdicrf).AND.ALLOCATED(ss2%cdicrf)) THEN
        CALL ps_conformal("cdicrf",ss2%cdicrf,ss3%cdicrf,iout,ierr)
        CALL ps_conformal("cdicrf",ss1%cdicrf,ss3%cdicrf,iout,ierr)
        if(ierr.eq.0) ss3%cdicrf = w1*ss1%cdicrf + (1.0_rspec-w1)*ss2%cdicrf
     ELSE IF(ALLOCATED(ss1%cdicrf)) THEN
        CALL ps_conformal("cdicrf",ss1%cdicrf,ss3%cdicrf,iout,ierr)
        ss3%cdicrf = ss1%cdicrf
     ELSE IF(ALLOCATED(ss2%cdicrf)) THEN
        CALL ps_conformal("cdicrf",ss2%cdicrf,ss3%cdicrf,iout,ierr)
        ss3%cdicrf = ss2%cdicrf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%cdicrf_nphi)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%cdicrf_nphi).AND.ALLOCATED(ss2%cdicrf_nphi)) THEN
        CALL ps_conformal("cdicrf_nphi",ss2%cdicrf_nphi,ss3%cdicrf_nphi,iout,ierr)
        CALL ps_conformal("cdicrf_nphi",ss1%cdicrf_nphi,ss3%cdicrf_nphi,iout,ierr)
        if(ierr.eq.0) ss3%cdicrf_nphi = w1*ss1%cdicrf_nphi + (1.0_rspec-w1)*ss2%cdicrf_nphi
     ELSE IF(ALLOCATED(ss1%cdicrf_nphi)) THEN
        CALL ps_conformal("cdicrf_nphi",ss1%cdicrf_nphi,ss3%cdicrf_nphi,iout,ierr)
        ss3%cdicrf_nphi = ss1%cdicrf_nphi
     ELSE IF(ALLOCATED(ss2%cdicrf_nphi)) THEN
        CALL ps_conformal("cdicrf_nphi",ss2%cdicrf_nphi,ss3%cdicrf_nphi,iout,ierr)
        ss3%cdicrf_nphi = ss2%cdicrf_nphi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_anom).AND.ALLOCATED(ss2%chie_anom)) THEN
        CALL ps_conformal("chie_anom",ss2%chie_anom,ss3%chie_anom,iout,ierr)
        CALL ps_conformal("chie_anom",ss1%chie_anom,ss3%chie_anom,iout,ierr)
        if(ierr.eq.0) ss3%chie_anom = w1*ss1%chie_anom + (1.0_rspec-w1)*ss2%chie_anom
     ELSE IF(ALLOCATED(ss1%chie_anom)) THEN
        CALL ps_conformal("chie_anom",ss1%chie_anom,ss3%chie_anom,iout,ierr)
        ss3%chie_anom = ss1%chie_anom
     ELSE IF(ALLOCATED(ss2%chie_anom)) THEN
        CALL ps_conformal("chie_anom",ss2%chie_anom,ss3%chie_anom,iout,ierr)
        ss3%chie_anom = ss2%chie_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_drbm).AND.ALLOCATED(ss2%chie_drbm)) THEN
        CALL ps_conformal("chie_drbm",ss2%chie_drbm,ss3%chie_drbm,iout,ierr)
        CALL ps_conformal("chie_drbm",ss1%chie_drbm,ss3%chie_drbm,iout,ierr)
        if(ierr.eq.0) ss3%chie_drbm = w1*ss1%chie_drbm + (1.0_rspec-w1)*ss2%chie_drbm
     ELSE IF(ALLOCATED(ss1%chie_drbm)) THEN
        CALL ps_conformal("chie_drbm",ss1%chie_drbm,ss3%chie_drbm,iout,ierr)
        ss3%chie_drbm = ss1%chie_drbm
     ELSE IF(ALLOCATED(ss2%chie_drbm)) THEN
        CALL ps_conformal("chie_drbm",ss2%chie_drbm,ss3%chie_drbm,iout,ierr)
        ss3%chie_drbm = ss2%chie_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_etg)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_etg).AND.ALLOCATED(ss2%chie_etg)) THEN
        CALL ps_conformal("chie_etg",ss2%chie_etg,ss3%chie_etg,iout,ierr)
        CALL ps_conformal("chie_etg",ss1%chie_etg,ss3%chie_etg,iout,ierr)
        if(ierr.eq.0) ss3%chie_etg = w1*ss1%chie_etg + (1.0_rspec-w1)*ss2%chie_etg
     ELSE IF(ALLOCATED(ss1%chie_etg)) THEN
        CALL ps_conformal("chie_etg",ss1%chie_etg,ss3%chie_etg,iout,ierr)
        ss3%chie_etg = ss1%chie_etg
     ELSE IF(ALLOCATED(ss2%chie_etg)) THEN
        CALL ps_conformal("chie_etg",ss2%chie_etg,ss3%chie_etg,iout,ierr)
        ss3%chie_etg = ss2%chie_etg
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_glf).AND.ALLOCATED(ss2%chie_glf)) THEN
        CALL ps_conformal("chie_glf",ss2%chie_glf,ss3%chie_glf,iout,ierr)
        CALL ps_conformal("chie_glf",ss1%chie_glf,ss3%chie_glf,iout,ierr)
        if(ierr.eq.0) ss3%chie_glf = w1*ss1%chie_glf + (1.0_rspec-w1)*ss2%chie_glf
     ELSE IF(ALLOCATED(ss1%chie_glf)) THEN
        CALL ps_conformal("chie_glf",ss1%chie_glf,ss3%chie_glf,iout,ierr)
        ss3%chie_glf = ss1%chie_glf
     ELSE IF(ALLOCATED(ss2%chie_glf)) THEN
        CALL ps_conformal("chie_glf",ss2%chie_glf,ss3%chie_glf,iout,ierr)
        ss3%chie_glf = ss2%chie_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_gtcneo).AND.ALLOCATED(ss2%chie_gtcneo)) THEN
        CALL ps_conformal("chie_gtcneo",ss2%chie_gtcneo,ss3%chie_gtcneo,iout,ierr)
        CALL ps_conformal("chie_gtcneo",ss1%chie_gtcneo,ss3%chie_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%chie_gtcneo = w1*ss1%chie_gtcneo + (1.0_rspec-w1)*ss2%chie_gtcneo
     ELSE IF(ALLOCATED(ss1%chie_gtcneo)) THEN
        CALL ps_conformal("chie_gtcneo",ss1%chie_gtcneo,ss3%chie_gtcneo,iout,ierr)
        ss3%chie_gtcneo = ss1%chie_gtcneo
     ELSE IF(ALLOCATED(ss2%chie_gtcneo)) THEN
        CALL ps_conformal("chie_gtcneo",ss2%chie_gtcneo,ss3%chie_gtcneo,iout,ierr)
        ss3%chie_gtcneo = ss2%chie_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_mmm71).AND.ALLOCATED(ss2%chie_mmm71)) THEN
        CALL ps_conformal("chie_mmm71",ss2%chie_mmm71,ss3%chie_mmm71,iout,ierr)
        CALL ps_conformal("chie_mmm71",ss1%chie_mmm71,ss3%chie_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%chie_mmm71 = w1*ss1%chie_mmm71 + (1.0_rspec-w1)*ss2%chie_mmm71
     ELSE IF(ALLOCATED(ss1%chie_mmm71)) THEN
        CALL ps_conformal("chie_mmm71",ss1%chie_mmm71,ss3%chie_mmm71,iout,ierr)
        ss3%chie_mmm71 = ss1%chie_mmm71
     ELSE IF(ALLOCATED(ss2%chie_mmm71)) THEN
        CALL ps_conformal("chie_mmm71",ss2%chie_mmm71,ss3%chie_mmm71,iout,ierr)
        ss3%chie_mmm71 = ss2%chie_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_mtm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_mtm).AND.ALLOCATED(ss2%chie_mtm)) THEN
        CALL ps_conformal("chie_mtm",ss2%chie_mtm,ss3%chie_mtm,iout,ierr)
        CALL ps_conformal("chie_mtm",ss1%chie_mtm,ss3%chie_mtm,iout,ierr)
        if(ierr.eq.0) ss3%chie_mtm = w1*ss1%chie_mtm + (1.0_rspec-w1)*ss2%chie_mtm
     ELSE IF(ALLOCATED(ss1%chie_mtm)) THEN
        CALL ps_conformal("chie_mtm",ss1%chie_mtm,ss3%chie_mtm,iout,ierr)
        ss3%chie_mtm = ss1%chie_mtm
     ELSE IF(ALLOCATED(ss2%chie_mtm)) THEN
        CALL ps_conformal("chie_mtm",ss2%chie_mtm,ss3%chie_mtm,iout,ierr)
        ss3%chie_mtm = ss2%chie_mtm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_nclass).AND.ALLOCATED(ss2%chie_nclass)) THEN
        CALL ps_conformal("chie_nclass",ss2%chie_nclass,ss3%chie_nclass,iout,ierr)
        CALL ps_conformal("chie_nclass",ss1%chie_nclass,ss3%chie_nclass,iout,ierr)
        if(ierr.eq.0) ss3%chie_nclass = w1*ss1%chie_nclass + (1.0_rspec-w1)*ss2%chie_nclass
     ELSE IF(ALLOCATED(ss1%chie_nclass)) THEN
        CALL ps_conformal("chie_nclass",ss1%chie_nclass,ss3%chie_nclass,iout,ierr)
        ss3%chie_nclass = ss1%chie_nclass
     ELSE IF(ALLOCATED(ss2%chie_nclass)) THEN
        CALL ps_conformal("chie_nclass",ss2%chie_nclass,ss3%chie_nclass,iout,ierr)
        ss3%chie_nclass = ss2%chie_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_neo).AND.ALLOCATED(ss2%chie_neo)) THEN
        CALL ps_conformal("chie_neo",ss2%chie_neo,ss3%chie_neo,iout,ierr)
        CALL ps_conformal("chie_neo",ss1%chie_neo,ss3%chie_neo,iout,ierr)
        if(ierr.eq.0) ss3%chie_neo = w1*ss1%chie_neo + (1.0_rspec-w1)*ss2%chie_neo
     ELSE IF(ALLOCATED(ss1%chie_neo)) THEN
        CALL ps_conformal("chie_neo",ss1%chie_neo,ss3%chie_neo,iout,ierr)
        ss3%chie_neo = ss1%chie_neo
     ELSE IF(ALLOCATED(ss2%chie_neo)) THEN
        CALL ps_conformal("chie_neo",ss2%chie_neo,ss3%chie_neo,iout,ierr)
        ss3%chie_neo = ss2%chie_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_ntm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_ntm).AND.ALLOCATED(ss2%chie_ntm)) THEN
        CALL ps_conformal("chie_ntm",ss2%chie_ntm,ss3%chie_ntm,iout,ierr)
        CALL ps_conformal("chie_ntm",ss1%chie_ntm,ss3%chie_ntm,iout,ierr)
        if(ierr.eq.0) ss3%chie_ntm = w1*ss1%chie_ntm + (1.0_rspec-w1)*ss2%chie_ntm
     ELSE IF(ALLOCATED(ss1%chie_ntm)) THEN
        CALL ps_conformal("chie_ntm",ss1%chie_ntm,ss3%chie_ntm,iout,ierr)
        ss3%chie_ntm = ss1%chie_ntm
     ELSE IF(ALLOCATED(ss2%chie_ntm)) THEN
        CALL ps_conformal("chie_ntm",ss2%chie_ntm,ss3%chie_ntm,iout,ierr)
        ss3%chie_ntm = ss2%chie_ntm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_paleo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_paleo).AND.ALLOCATED(ss2%chie_paleo)) THEN
        CALL ps_conformal("chie_paleo",ss2%chie_paleo,ss3%chie_paleo,iout,ierr)
        CALL ps_conformal("chie_paleo",ss1%chie_paleo,ss3%chie_paleo,iout,ierr)
        if(ierr.eq.0) ss3%chie_paleo = w1*ss1%chie_paleo + (1.0_rspec-w1)*ss2%chie_paleo
     ELSE IF(ALLOCATED(ss1%chie_paleo)) THEN
        CALL ps_conformal("chie_paleo",ss1%chie_paleo,ss3%chie_paleo,iout,ierr)
        ss3%chie_paleo = ss1%chie_paleo
     ELSE IF(ALLOCATED(ss2%chie_paleo)) THEN
        CALL ps_conformal("chie_paleo",ss2%chie_paleo,ss3%chie_paleo,iout,ierr)
        ss3%chie_paleo = ss2%chie_paleo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_tglf).AND.ALLOCATED(ss2%chie_tglf)) THEN
        CALL ps_conformal("chie_tglf",ss2%chie_tglf,ss3%chie_tglf,iout,ierr)
        CALL ps_conformal("chie_tglf",ss1%chie_tglf,ss3%chie_tglf,iout,ierr)
        if(ierr.eq.0) ss3%chie_tglf = w1*ss1%chie_tglf + (1.0_rspec-w1)*ss2%chie_tglf
     ELSE IF(ALLOCATED(ss1%chie_tglf)) THEN
        CALL ps_conformal("chie_tglf",ss1%chie_tglf,ss3%chie_tglf,iout,ierr)
        ss3%chie_tglf = ss1%chie_tglf
     ELSE IF(ALLOCATED(ss2%chie_tglf)) THEN
        CALL ps_conformal("chie_tglf",ss2%chie_tglf,ss3%chie_tglf,iout,ierr)
        ss3%chie_tglf = ss2%chie_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_trans).AND.ALLOCATED(ss2%chie_trans)) THEN
        CALL ps_conformal("chie_trans",ss2%chie_trans,ss3%chie_trans,iout,ierr)
        CALL ps_conformal("chie_trans",ss1%chie_trans,ss3%chie_trans,iout,ierr)
        if(ierr.eq.0) ss3%chie_trans = w1*ss1%chie_trans + (1.0_rspec-w1)*ss2%chie_trans
     ELSE IF(ALLOCATED(ss1%chie_trans)) THEN
        CALL ps_conformal("chie_trans",ss1%chie_trans,ss3%chie_trans,iout,ierr)
        ss3%chie_trans = ss1%chie_trans
     ELSE IF(ALLOCATED(ss2%chie_trans)) THEN
        CALL ps_conformal("chie_trans",ss2%chie_trans,ss3%chie_trans,iout,ierr)
        ss3%chie_trans = ss2%chie_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_transcat).AND.ALLOCATED(ss2%chie_transcat)) THEN
        CALL ps_conformal("chie_transcat",ss2%chie_transcat,ss3%chie_transcat,iout,ierr)
        CALL ps_conformal("chie_transcat",ss1%chie_transcat,ss3%chie_transcat,iout,ierr)
        if(ierr.eq.0) ss3%chie_transcat = w1*ss1%chie_transcat + (1.0_rspec-w1)*ss2%chie_transcat
     ELSE IF(ALLOCATED(ss1%chie_transcat)) THEN
        CALL ps_conformal("chie_transcat",ss1%chie_transcat,ss3%chie_transcat,iout,ierr)
        ss3%chie_transcat = ss1%chie_transcat
     ELSE IF(ALLOCATED(ss2%chie_transcat)) THEN
        CALL ps_conformal("chie_transcat",ss2%chie_transcat,ss3%chie_transcat,iout,ierr)
        ss3%chie_transcat = ss2%chie_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chie_w19)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chie_w19).AND.ALLOCATED(ss2%chie_w19)) THEN
        CALL ps_conformal("chie_w19",ss2%chie_w19,ss3%chie_w19,iout,ierr)
        CALL ps_conformal("chie_w19",ss1%chie_w19,ss3%chie_w19,iout,ierr)
        if(ierr.eq.0) ss3%chie_w19 = w1*ss1%chie_w19 + (1.0_rspec-w1)*ss2%chie_w19
     ELSE IF(ALLOCATED(ss1%chie_w19)) THEN
        CALL ps_conformal("chie_w19",ss1%chie_w19,ss3%chie_w19,iout,ierr)
        ss3%chie_w19 = ss1%chie_w19
     ELSE IF(ALLOCATED(ss2%chie_w19)) THEN
        CALL ps_conformal("chie_w19",ss2%chie_w19,ss3%chie_w19,iout,ierr)
        ss3%chie_w19 = ss2%chie_w19
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_anom).AND.ALLOCATED(ss2%chii_anom)) THEN
        CALL ps_conformal("chii_anom",ss2%chii_anom,ss3%chii_anom,iout,ierr)
        CALL ps_conformal("chii_anom",ss1%chii_anom,ss3%chii_anom,iout,ierr)
        if(ierr.eq.0) ss3%chii_anom = w1*ss1%chii_anom + (1.0_rspec-w1)*ss2%chii_anom
     ELSE IF(ALLOCATED(ss1%chii_anom)) THEN
        CALL ps_conformal("chii_anom",ss1%chii_anom,ss3%chii_anom,iout,ierr)
        ss3%chii_anom = ss1%chii_anom
     ELSE IF(ALLOCATED(ss2%chii_anom)) THEN
        CALL ps_conformal("chii_anom",ss2%chii_anom,ss3%chii_anom,iout,ierr)
        ss3%chii_anom = ss2%chii_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_drbm).AND.ALLOCATED(ss2%chii_drbm)) THEN
        CALL ps_conformal("chii_drbm",ss2%chii_drbm,ss3%chii_drbm,iout,ierr)
        CALL ps_conformal("chii_drbm",ss1%chii_drbm,ss3%chii_drbm,iout,ierr)
        if(ierr.eq.0) ss3%chii_drbm = w1*ss1%chii_drbm + (1.0_rspec-w1)*ss2%chii_drbm
     ELSE IF(ALLOCATED(ss1%chii_drbm)) THEN
        CALL ps_conformal("chii_drbm",ss1%chii_drbm,ss3%chii_drbm,iout,ierr)
        ss3%chii_drbm = ss1%chii_drbm
     ELSE IF(ALLOCATED(ss2%chii_drbm)) THEN
        CALL ps_conformal("chii_drbm",ss2%chii_drbm,ss3%chii_drbm,iout,ierr)
        ss3%chii_drbm = ss2%chii_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_glf).AND.ALLOCATED(ss2%chii_glf)) THEN
        CALL ps_conformal("chii_glf",ss2%chii_glf,ss3%chii_glf,iout,ierr)
        CALL ps_conformal("chii_glf",ss1%chii_glf,ss3%chii_glf,iout,ierr)
        if(ierr.eq.0) ss3%chii_glf = w1*ss1%chii_glf + (1.0_rspec-w1)*ss2%chii_glf
     ELSE IF(ALLOCATED(ss1%chii_glf)) THEN
        CALL ps_conformal("chii_glf",ss1%chii_glf,ss3%chii_glf,iout,ierr)
        ss3%chii_glf = ss1%chii_glf
     ELSE IF(ALLOCATED(ss2%chii_glf)) THEN
        CALL ps_conformal("chii_glf",ss2%chii_glf,ss3%chii_glf,iout,ierr)
        ss3%chii_glf = ss2%chii_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_gtcneo).AND.ALLOCATED(ss2%chii_gtcneo)) THEN
        CALL ps_conformal("chii_gtcneo",ss2%chii_gtcneo,ss3%chii_gtcneo,iout,ierr)
        CALL ps_conformal("chii_gtcneo",ss1%chii_gtcneo,ss3%chii_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%chii_gtcneo = w1*ss1%chii_gtcneo + (1.0_rspec-w1)*ss2%chii_gtcneo
     ELSE IF(ALLOCATED(ss1%chii_gtcneo)) THEN
        CALL ps_conformal("chii_gtcneo",ss1%chii_gtcneo,ss3%chii_gtcneo,iout,ierr)
        ss3%chii_gtcneo = ss1%chii_gtcneo
     ELSE IF(ALLOCATED(ss2%chii_gtcneo)) THEN
        CALL ps_conformal("chii_gtcneo",ss2%chii_gtcneo,ss3%chii_gtcneo,iout,ierr)
        ss3%chii_gtcneo = ss2%chii_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_mmm71).AND.ALLOCATED(ss2%chii_mmm71)) THEN
        CALL ps_conformal("chii_mmm71",ss2%chii_mmm71,ss3%chii_mmm71,iout,ierr)
        CALL ps_conformal("chii_mmm71",ss1%chii_mmm71,ss3%chii_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%chii_mmm71 = w1*ss1%chii_mmm71 + (1.0_rspec-w1)*ss2%chii_mmm71
     ELSE IF(ALLOCATED(ss1%chii_mmm71)) THEN
        CALL ps_conformal("chii_mmm71",ss1%chii_mmm71,ss3%chii_mmm71,iout,ierr)
        ss3%chii_mmm71 = ss1%chii_mmm71
     ELSE IF(ALLOCATED(ss2%chii_mmm71)) THEN
        CALL ps_conformal("chii_mmm71",ss2%chii_mmm71,ss3%chii_mmm71,iout,ierr)
        ss3%chii_mmm71 = ss2%chii_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_nclass).AND.ALLOCATED(ss2%chii_nclass)) THEN
        CALL ps_conformal("chii_nclass",ss2%chii_nclass,ss3%chii_nclass,iout,ierr)
        CALL ps_conformal("chii_nclass",ss1%chii_nclass,ss3%chii_nclass,iout,ierr)
        if(ierr.eq.0) ss3%chii_nclass = w1*ss1%chii_nclass + (1.0_rspec-w1)*ss2%chii_nclass
     ELSE IF(ALLOCATED(ss1%chii_nclass)) THEN
        CALL ps_conformal("chii_nclass",ss1%chii_nclass,ss3%chii_nclass,iout,ierr)
        ss3%chii_nclass = ss1%chii_nclass
     ELSE IF(ALLOCATED(ss2%chii_nclass)) THEN
        CALL ps_conformal("chii_nclass",ss2%chii_nclass,ss3%chii_nclass,iout,ierr)
        ss3%chii_nclass = ss2%chii_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%chii_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%chii_neo).AND.ALLOCATED(ss2%chii_neo)) THEN
        CALL ps_conformal("chii_neo",ss2%chii_neo,ss3%chii_neo,iout,ierr)
        CALL ps_conformal("chii_neo",ss1%chii_neo,ss3%chii_neo,iout,ierr)
        if(ierr.eq.0) ss3%chii_neo = w1*ss1%chii_neo + (1.0_rspec-w1)*ss2%chii_neo
     ELSE IF(ALLOCATED(ss1%chii_neo)) THEN
        CALL ps_conformal("chii_neo",ss1%chii_neo,ss3%chii_neo,iout,ierr)
        ss3%chii_neo = ss1%chii_neo
     ELSE IF(ALLOCATED(ss2%chii_neo)) THEN
        CALL ps_conformal("chii_neo",ss2%chii_neo,ss3%chii_neo,iout,ierr)
        ss3%chii_neo = ss2%chii_neo
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_0

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_3(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_phash_grho2b2i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grho2b2i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grho2b2i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grho2b2i","R",indim,idims, &
               "<|grad(rho)|^2/B^2>", &
               "T^-2*m^-2","EQ","STATE_PROFILES", &
               "R|units=T^-2*m^-2|pclin grho2b2i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_grho2r2i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grho2r2i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grho2r2i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grho2r2i","R",indim,idims, &
               "<|grad(rho)|^2/R^2>", &
               "m^-4","EQ","STATE_PROFILES", &
               "R|units=m^-4|pclin grho2r2i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_grho2r3i
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grho2r3i).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grho2r3i","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grho2r3i","R",indim,idims, &
               "<|grad(rho)|^2/R^3>", &
               "m^-5","EQ","STATE_PROFILES", &
               "R|units=m^-5|pclin grho2r3i(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_gri
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gri).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("gri","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("gri","R",indim,idims, &
               "<1/R>", &
               "m^-2","EQ","STATE_PROFILES", &
               "R|units=m^-2|pclin gri(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_grirhoi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%grirhoi).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("grirhoi","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("grirhoi","R",indim,idims, &
               "<1/(R*|grad(rho)|)>", &
               "-","EQ","STATE_PROFILES", &
               "R|units=-|pclin grirhoi(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("growthrate_drbm","R",indim,idims, &
               "growthrate from DRBM model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("growthrate_glf","R",indim,idims, &
               "growthrate from GLF23 model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_max_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_max_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_max_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("growthrate_max_tglf","R",indim,idims, &
               "maximum growthrate from TGLF model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_max_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_mmm.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_mmm,"dim_nky_mmm",ss%nky_mmm)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_mmm
        CALL define_var("growthrate_mmm71","R",indim,idims, &
               "growthrate from mmm71 model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_mmm71(nrho_anomth,nky_mmm)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_mtm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_mtm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_mtm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("growthrate_mtm","R",indim,idims, &
               "growthrate from MTM model", &
               "1/sec","ANOM","STATE_PROFILES", &
               "R|units=1/sec|pclin growthrate_mtm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("growthrate_tglf","R",indim,idims, &
               "growthrate from TGLF model", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_growthrate_vpar
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%growthrate_vpar).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("growthrate_vpar","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("growthrate_vpar","R",indim,idims, &
               "growthrate from parallel velocity shear", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin growthrate_vpar(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_ngsc0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%gs_name).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("gs_name","GAS")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("gs_name","N",indim,idims, &
               "number & name of edge neutral gas sources", &
               "__NONE","GAS","SHOT_CONFIGURATION", &
               "L|gas_source    gs_name(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_g_eq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%g_eq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("g_eq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("g_eq","R",indim,idims, &
               "equilibrium R*|B_phi|", &
               "T*m","EQ","STATE_PROFILES", &
               "R|units=T*m|Spline_00      g_eq(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_hegrilh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%hegrilh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("hegrilh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("hegrilh","R",indim,idims, &
               "need description", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- hegrilh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Hsize_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Hsize_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Hsize_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("Hsize_coil","R",indim,idims, &
               "(Rotatable) Horizontal coil base size", &
               "m","EQ","MACHINE_DESCRIPTION", &
               "R|units=m  Hsize_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_shash_H_einj_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%H_einj_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("H_einj_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_h_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_h_einj_standard,"dim_n_h_einj_standard",ss%n_h_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_h_einj_standard
        CALL define_var("H_einj_standard","R",indim,idims, &
               "H beam table energies", &
               "keV","NBI","MACHINE_DESCRIPTION", &
               "R|units=keV H_einj_standard(n_H_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_H_ffull_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%H_ffull_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("H_ffull_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_h_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_h_einj_standard,"dim_n_h_einj_standard",ss%n_h_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_h_einj_standard
        CALL define_var("H_ffull_standard","R",indim,idims, &
               "H beam full energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- H_ffull_standard(n_H_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_H_fhalf_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%H_fhalf_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("H_fhalf_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_h_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_h_einj_standard,"dim_n_h_einj_standard",ss%n_h_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_h_einj_standard
        CALL define_var("H_fhalf_standard","R",indim,idims, &
               "H beam half energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- H_fhalf_standard(n_H_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_icircuit_coil
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%icircuit_coil).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("icircuit_coil","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_ncoils.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ncoils,"dim_ncoils",ss%ncoils)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ncoils
        CALL define_var("icircuit_coil","I",indim,idims, &
               "index of circuit to which each coil belongs", &
               "__NONE","EQ","SIMULATION_INIT", &
               "I  icircuit_coil(ncoils)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nicrf_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%icrf_src_name).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("icrf_src_name","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("icrf_src_name","N",indim,idims, &
               "number & name of ICRF sources", &
               "__NONE","IC","MACHINE_DESCRIPTION", &
               "L|icrf_source   icrf_src_name(nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_IC_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("IC_Code_Info","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("IC_Code_Info","C*80",indim,idims, &
               "Information: code implementing IC component", &
               "__NONE","IC","SIMULATION_INIT", &
               "C*80   IC_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_IC_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("IC_Data_Info","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("IC_Data_Info","C*80",indim,idims, &
               "information on source of ICRF power data", &
               "__NONE","IC","SIMULATION_INIT", &
               "C*80   IC_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_Imag_ant_coef
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Imag_ant_coef).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("Imag_ant_coef","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_num_nphi_vac.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_num_nphi_vac,"dim_max_num_nphi_vac",ss%max_num_nphi_vac)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_num_nphi_vac
        IF(nids%nid_dim_nicrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nicrf_src,"dim_nicrf_src",ss%nicrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nicrf_src
        CALL define_var("Imag_ant_coef","R",indim,idims, &
               "imag part of Fourier Coef", &
               "Amps/m","IC","SHOT_CONFIGURATION", &
               "R|units=Amps/m Imag_ant_coef(num_nphi_vac(),nicrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_phash_iota
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%iota).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("iota","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("iota","R",indim,idims, &
               "iota profile (1/q)", &
               "-","PLASMA","STATE_PROFILES", &
               "R|units=-|Spline_00  iota(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_shash_isThermal
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%isThermal).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("isThermal","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("isThermal","I",indim,idims, &
               "=1 if minority specie is thermalized", &
               "__NONE","IC","STATE_DATA", &
               "I  isThermal(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_shash_is_recycling
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%is_recycling).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("is_recycling","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("is_recycling","I",indim,idims, &
               "0/1; =1 to for recycling sources", &
               "__NONE","GAS","SHOT_CONFIGURATION", &
               "I  is_recycling(ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_shash_i_npoloidal
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("i_npoloidal","LH")
     ELSE
        indim = 0
        CALL define_var("i_npoloidal","I",indim,idims, &
               "need description", &
               "__NONE","LH","SHOT_CONFIGURATION", &
               "I i_npoloidal")
     ENDIF
  ENDIF

  iaddr = ps_phash_jdotb
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%jdotb).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("jdotb","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("jdotb","R",indim,idims, &
               "<J.B>", &
               "A*T/m^2","EQ","STATE_PROFILES", &
               "R|units=A*T/m^2|Hermite_00     jdotb(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_kccw_Bphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("kccw_Bphi","EQ")
     ELSE
        indim = 0
        CALL define_var("kccw_Bphi","I",indim,idims, &
               "B_phi orientation: +1 means CCW viewed from above", &
               "__NONE","EQ","SHOT_CONFIGURATION", &
               "I  kccw_Bphi = 0")
     ENDIF
  ENDIF

  iaddr = ps_shash_kccw_Jphi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("kccw_Jphi","EQ")
     ELSE
        indim = 0
        CALL define_var("kccw_Jphi","I",indim,idims, &
               "J_phi orientation: +1 means CCW viewed from above", &
               "__NONE","EQ","SHOT_CONFIGURATION", &
               "I  kccw_Jphi = 0")
     ENDIF
  ENDIF

  iaddr = ps_shash_kdens_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("kdens_rfmin","IC")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        CALL define_var("kdens_rfmin","N",indim,idims, &
               '= "fraction" => nmini(i) = fracmin(i)*ne', &
               "__NONE","IC","SIMULATION_INIT", &
               'N  kdens_rfmin = "data"')
     ENDIF
  ENDIF

  iaddr = ps_shash_kvolt_nbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%kvolt_nbi).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("kvolt_nbi","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("kvolt_nbi","R",indim,idims, &
               "energy of each beam source **keV**", &
               "keV","NBI","STATE_DATA", &
               "R|units=keV kvolt_nbi(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_kyrhos_mtm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%kyrhos_mtm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("kyrhos_mtm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("kyrhos_mtm","R",indim,idims, &
               "ky*rhos at max growth rate for MTM model", &
               "-","ANOM","STATE_PROFILES", &
               "R|units=-|pclin kyrhos_mtm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_kyspectrum_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%kyspectrum_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("kyspectrum_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("kyspectrum_tglf","R",indim,idims, &
               "ky-spectrum from TGLF model", &
               "-","ANOM","STATE_PROFILES", &
               "R|units=-|pclin kyspectrum_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Lbscap
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Lbscap).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Lbscap","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Lbscap","R",indim,idims, &
               "distance, source to aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       Lbscap(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Lbscap2
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Lbscap2).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Lbscap2","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Lbscap2","R",indim,idims, &
               "distance, source to 2nd aperture", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       Lbscap2(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Lbsctan
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Lbsctan).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("Lbsctan","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("Lbsctan","R",indim,idims, &
               "distance, source to tangency point", &
               "m","NBI","MACHINE_DESCRIPTION", &
               "R|units=m       Lbsctan(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nlhrf_src
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%lhrf_src_name).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("lhrf_src_name","LH")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("lhrf_src_name","N",indim,idims, &
               "number & name of LHRF sources", &
               "__NONE","LH","MACHINE_DESCRIPTION", &
               "L|lhrf_source   lhrf_src_name(nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_shash_LH_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("LH_Code_Info","LH")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("LH_Code_Info","C*80",indim,idims, &
               "Information: code implementing LH component", &
               "__NONE","LH","SIMULATION_INIT", &
               "C*80   LH_Code_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_LH_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("LH_Data_Info","LH")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("LH_Data_Info","C*80",indim,idims, &
               "Information on source of LHRF power data", &
               "__NONE","LH","SIMULATION_INIT", &
               "C*80   LH_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_LMHD_eq_code
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("LMHD_eq_code","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        CALL define_var("LMHD_eq_code","N",indim,idims, &
               "name of MHD equilibrium refinement code used", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "N  LMHD_eq_code")
     ENDIF
  ENDIF

  iaddr = ps_shash_LMHD_status
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("LMHD_status","LMHD")
     ELSE
        indim = 0
        CALL define_var("LMHD_status","I",indim,idims, &
               "0: OK; =1: at least one code error occurred.", &
               "__NONE","LMHD","STATE_DATA", &
               "I   LMHD_status")
     ENDIF
  ENDIF

  iaddr = ps_shash_lock_machine_descr
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("lock_machine_descr","PLASMA")
     ELSE
        indim = 0
        CALL define_var("lock_machine_descr","I",indim,idims, &
               "Machine_Description section lock", &
               "__NONE","PLASMA","STATE_DATA", &
               "I  lock_machine_descr = 0")
     ENDIF
  ENDIF

  iaddr = ps_shash_lock_shot_config
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("lock_shot_config","PLASMA")
     ELSE
        indim = 0
        CALL define_var("lock_shot_config","I",indim,idims, &
               "Shot_Configuration section lock", &
               "__NONE","PLASMA","STATE_DATA", &
               "I  lock_shot_config = 0")
     ENDIF
  ENDIF

  iaddr = ps_shash_lock_sim_init
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("lock_sim_init","PLASMA")
     ELSE
        indim = 0
        CALL define_var("lock_sim_init","I",indim,idims, &
               "Simulation_Init section lock", &
               "__NONE","PLASMA","STATE_DATA", &
               "I  lock_sim_init = 0")
     ENDIF
  ENDIF

  iaddr = ps_phash_Lpol
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Lpol).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("Lpol","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq,"dim_nrho_eq",ss%nrho_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq
        CALL define_var("Lpol","R",indim,idims, &
               "poloidal path length", &
               "m","EQ","STATE_PROFILES", &
               "R|units=m|Spline Lpol(nrho_eq)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Mercier_stable
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Mercier_stable).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Mercier_stable","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Mercier_stable","I",indim,idims, &
               "0: stable everywhere; =1: unstable somewhere", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Mercier_stable(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_shash_MHD_eq_status
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("MHD_eq_status","LMHD")
     ELSE
        indim = 0
        CALL define_var("MHD_eq_status","I",indim,idims, &
               "0: OK; =1: MHD equilibrium refinement failed", &
               "__NONE","LMHD","STATE_DATA", &
               "I   MHD_eq_status")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_all
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_ALL).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("m_ALL","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_all.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_all,"dp1_nspec_all",ss%nspec_all+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_all
        CALL define_var("m_ALL","R",indim,idims, &
               "ALL specie mass", &
               "kg","PLASMA","SIMULATION_INIT", &
               "S|specie  ALL(0:nspec_all)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_alla
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_ALLA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("m_ALLA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_alla.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_alla,"dp1_nspec_alla",ss%nspec_alla+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_alla
        CALL define_var("m_ALLA","R",indim,idims, &
               "ALLA specie mass", &
               "kg","PLASMA","SIMULATION_INIT", &
               "S|specie  ALLA(0:nspec_alla)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_rfmin
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_RFMIN).AND.ichange) THEN
     IF(cclist(ps_cnum_IC).NE.1) THEN
        CALL ccwarn("m_RFMIN","IC")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_rfmin.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_rfmin,"dim_nspec_rfmin",ss%nspec_rfmin)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_rfmin
        CALL define_var("m_RFMIN","R",indim,idims, &
               "RFMIN specie mass", &
               "kg","IC","SHOT_CONFIGURATION", &
               "S|RF_minority  RFMIN(nspec_rfmin)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_th
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_S).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("m_S","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("m_S","R",indim,idims, &
               "S specie mass", &
               "kg","PLASMA","SHOT_CONFIGURATION", &
               "S|thermal_specie  S(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_tha
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SA).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("m_SA","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_tha.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_tha,"dp1_nspec_tha",ss%nspec_tha+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_tha
        CALL define_var("m_SA","R",indim,idims, &
               "SA specie mass", &
               "kg","PLASMA","SIMULATION_INIT", &
               "S|thermal_specie  SA(0:nspec_tha)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_fusion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SFUS).AND.ichange) THEN
     IF(cclist(ps_cnum_FUS).NE.1) THEN
        CALL ccwarn("m_SFUS","FUS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_fusion.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_fusion,"dim_nspec_fusion",ss%nspec_fusion)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_fusion
        CALL define_var("m_SFUS","R",indim,idims, &
               "SFUS specie mass", &
               "kg","FUS","SHOT_CONFIGURATION", &
               "S|fusion_ion   SFUS(nspec_fusion)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_gas
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SGAS).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("m_SGAS","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("m_SGAS","R",indim,idims, &
               "SGAS specie mass", &
               "kg","GAS","SIMULATION_INIT", &
               "S|neutral_gas  SGAS(nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_imp0
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SIMP0).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("m_SIMP0","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_imp0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_imp0,"dim_nspec_imp0",ss%nspec_imp0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_imp0
        CALL define_var("m_SIMP0","R",indim,idims, &
               "SIMP0 specie mass", &
               "kg","GAS","SIMULATION_INIT", &
               "S|impurity_atoms SIMP0(nspec_imp0)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_impi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SIMPI).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("m_SIMPI","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_impi.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_impi,"dim_nspec_impi",ss%nspec_impi)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_impi
        CALL define_var("m_SIMPI","R",indim,idims, &
               "SIMPI specie mass", &
               "kg","PLASMA","SIMULATION_INIT", &
               "S|impurity_atoms SIMPI(nspec_impi)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nspec_beam
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%m_SNBI).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("m_SNBI","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("m_SNBI","R",indim,idims, &
               "SNBI specie mass", &
               "kg","NBI","SIMULATION_INIT", &
               "S|beam_ion     SNBI(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_n0norm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%n0norm).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("n0norm","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("n0norm","R",indim,idims, &
               "neutral density per unit gas influx (sc0)", &
               "(m^-3)/(#/sec)","GAS","STATE_PROFILES", &
               "R|step|units=(m^-3)/(#/sec)    n0norm(~nrho_gas,nspec_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_n0_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%n0_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("n0_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("n0_halo","R",indim,idims, &
               "halo thermal neutral density", &
               "m^-3","NBI","STATE_PROFILES", &
               "R|units=m^-3|step         n0_halo(~nrho_nbi,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_n0_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%n0_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("n0_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_nspec_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_gas,"dim_nspec_gas",ss%nspec_gas)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_gas
        CALL define_var("n0_reco","R",indim,idims, &
               "reco thermal neutral density", &
               "m^-3","GAS","STATE_PROFILES", &
               "R|units=m^-3|step         n0_reco(~nrho_gas,nspec_gas)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbap2_shape
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbap2_shape).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbap2_shape","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbap2_shape","N",indim,idims, &
               "keyword for optional 2nd aperture", &
               "__NONE","NBI","MACHINE_DESCRIPTION", &
               "N     nbap2_shape(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbap_shape
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbap_shape).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbap_shape","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbap_shape","N",indim,idims, &
               "shape keyword for beam aperture", &
               "__NONE","NBI","MACHINE_DESCRIPTION", &
               "N     nbap_shape(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_phash_nbeami
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbeami).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbeami","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("nbeami","R",indim,idims, &
               "beam species density", &
               "m^-3","NBI","STATE_PROFILES", &
               "R|units=m^-3|alias=n|step  nbeami(~nrho_nbi,nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbeami_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbeami_bdy).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbeami_bdy","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nspec_beam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nspec_beam,"dim_nspec_beam",ss%nspec_beam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nspec_beam
        CALL define_var("nbeami_bdy","R",indim,idims, &
               "beam ion densities at/beyond boundary", &
               "m^-3","NBI","STATE_DATA", &
               "R|units=m^-3  nbeami_bdy(nspec_beam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbion
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbion).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbion","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbion","N",indim,idims, &
               "name of species injected by each beam.", &
               "__NONE","NBI","SHOT_CONFIGURATION", &
               "N  nbion(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_nbion_trace
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%nbion_trace).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("nbion_trace","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("nbion_trace","N",indim,idims, &
               "(if non-blank) beam trace element", &
               "__NONE","NBI","SHOT_CONFIGURATION", &
               "N  nbion_trace(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_shash_NBI_Code_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("NBI_Code_Info","NBI")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("NBI_Code_Info","C*80",indim,idims, &
               "Information: code implementing NBI component", &
               "__NONE","NBI","SIMULATION_INIT", &
               "C*80   NBI_Code_Info")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_3

SUBROUTINE ps_update_file_write_3(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"grho2b2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grho2b2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grho2b2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2r2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grho2r2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grho2r2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2r3i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grho2r3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grho2r3i"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gri",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gri)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gri"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grirhoi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%grirhoi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: grirhoi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_max_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_vpar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%growthrate_vpar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: growthrate_vpar"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gs_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%gs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: gs_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"g_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%g_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: g_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"hegrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%hegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: hegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Hsize_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Hsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Hsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%H_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: H_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%H_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: H_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%H_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: H_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"icircuit_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%icircuit_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: icircuit_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"icrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%icrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: icrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%IC_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: IC_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%IC_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: IC_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Imag_ant_coef",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Imag_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Imag_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"iota",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%iota)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: iota"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"isThermal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%isThermal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: isThermal"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"is_recycling",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%is_recycling)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: is_recycling"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"i_npoloidal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%i_npoloidal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: i_npoloidal"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"jdotb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%jdotb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: jdotb"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Bphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kccw_Bphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kccw_Bphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Jphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kccw_Jphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kccw_Jphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kdens_rfmin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kdens_rfmin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kdens_rfmin"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kvolt_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kvolt_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kvolt_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kyrhos_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kyrhos_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kyrhos_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kyspectrum_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%kyspectrum_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: kyspectrum_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbscap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Lbscap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Lbscap"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbscap2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Lbscap2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Lbscap2"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbsctan",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Lbsctan)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Lbsctan"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lhrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%lhrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: lhrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%LH_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: LH_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%LH_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: LH_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_eq_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%LMHD_eq_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: LMHD_eq_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%LMHD_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: LMHD_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_machine_descr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%lock_machine_descr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: lock_machine_descr"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_shot_config",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%lock_shot_config)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: lock_shot_config"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_sim_init",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%lock_sim_init)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: lock_sim_init"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lpol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Lpol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Lpol"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Mercier_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Mercier_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Mercier_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"MHD_eq_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%MHD_eq_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: MHD_eq_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%m_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: m_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0norm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%n0norm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: n0norm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%n0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: n0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%n0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: n0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbap2_shape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbap2_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbap2_shape"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbap_shape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbap_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbap_shape"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbeami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbeami"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbeami_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbeami_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbeami_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbion",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbion"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbion_trace",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%nbion_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: nbion_trace"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"NBI_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%NBI_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: NBI_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_3

module splitn_module

!     Modifications
!
!     1.23  05Apr2009 -- dmccune@pppl.gov -- splitn has been extensively
!                modified to support updatable namelist elements, i.e.
!                a portion of the TRANSP (trcom only) namelist can now
!                be read as an update, part way through a TRANSP run.
!                At the same time, trcom names maximum length was increased
!                from 16 to 32 characters; name declarations in splitn
!                lengthened accordingly.
!
!    -1.10  29Aug2007                   jim.conboy@jet.uk
!                                       Rolled back 1.10 ; see
!                                       msplitn_par.f90, splitn_io_list.f90
!
!     1.10  22Aug2007                   jim.conboy@jet.uk
!                                       Add splitn_io_list
!                                       Add nc_pre, nc_ext ( string length ) parameters
!                                       #ifdef __JET nc_ext -> 72
!----_^---------------------------------=========================================|
  implicit NONE
!
  save

  ! module to contain the representation of the TRANSP namelist with
  ! default settings, and...
  !
  ! the text of an actual TRANSP namelist (TR.DAT file).

  ! FORTRAN LUN

  integer :: lun = 82      ! TRANSP namelist file i/o LUN

  ! as with the old
  ! f77 splitn, this module and the routines which use it can convert
  ! a TRANSP namelist to the TR.ZDA form needed by f77 TRANSP COMMON-
  ! based namelist reader codes -- but will also support "editing 
  ! operations", and will contain a copy of the contents of the TRANSP
  ! namelist default values and actual values as encoded in the TR.DAT file.

  ! the text of an actual TRANSP namelist (TR.DAT file):

  integer :: curmax = 2000  ! current max no. of lines (expandable)
  integer :: nlines         ! no. of lines in TR.DAT file
  integer :: newline        ! where the next line goes...
  logical :: addblank       ! flag to insert a blank line

  character*150 aline,bline ! a 1-line buffer & a copy
  character*150, dimension(:), allocatable :: textnl  ! TR.DAT file text lines
  integer, dimension(:), allocatable :: lenl  ! abs() = length of each line
  integer, dimension(:), allocatable :: ordl  ! ordering of lines
  integer, dimension(:,:), allocatable :: namfld  ! location of name field
  integer, dimension(:), allocatable :: eqsfld    ! location of "=" sign
  integer, dimension(:,:), allocatable :: valfld  ! location of name field
  integer, dimension(:), allocatable :: cmtfld    ! location of cmt field

  ! this code would write the file out in its proper order:
  !  do i=1,nlines
  !    jl=ordl(i)
  !    if(lenl(jl).ne.0) then
  !      write(lun,'(A)') textnl(jl)(1:abs(lenl(jl)))
  !    endif
  !  enddo
  ! sign(lenl(...)) flags "special" namelist segments e.g. EFITIN
  ! if lenl(jl).eq.0, the line was marked as deleted.

  !-------------------------------------------------
  !  information to enable namelist editing via splitn
  !  cf splitn_put.f90 & splitn_edit_enable.f90

  character*30 :: edit_program = " "
  logical :: edit_enabled = .FALSE.    ! namelist edit lock
  logical :: edit_started = .FALSE.    ! flag if edit(s) have occurred

  !-------------------------------------------------
  ! namelist database (TRANSP & TRDAT combined)
  ! list of known namelist variables, their types, rank, dimensionality, etc.
  ! this is the nxlist.summary namelist, written by TRANSP code generators;
  ! therefore, its syntactic correctness is tested and assured.

  character*120 :: nlfile              ! name of namelist database file
  logical :: have_database = .FALSE.   ! initialization flag

  character*8 cur_naml      ! current namelist (in namelist database file)

  ! the following pertain to output (fortran readable) namelists:

  integer, parameter :: max_namls = 400 ! max no. of distinct namelists
  integer :: nnamls                     ! actual number
  character*8 all_namls(max_namls)      ! the list of namelist names...

  ! number of variables & updatable variables in each namelist
  integer, dimension(:), allocatable :: num_naml_vars
  integer, dimension(:), allocatable :: num_naml_vars_st

  ! index to variables & updatable variables in each namelist
  integer, dimension(:,:), allocatable :: indx_naml_vars
  integer, dimension(:,:), allocatable :: indx_naml_vars_st

  ! formerly in msplitn_par:
  ! now the same for both JET and PPPL versions:

  integer, parameter            :: nc_tri=3    &  !   # char, trigraph
                                  ,nc_pre=16   &  !           pre variable
                                  ,nc_ext=72      !           ext variable

  ! "maxrank" gives the maximum dimensionality or rank of any namelist
  ! array item.  ***Caution*** all of splitn should be checked if this
  ! ever wants to be increased!

  integer, parameter :: maxrank = 4

  type :: var

     character*32 :: name ! name of quantity
     character*5 :: type  ! type: R/I/L/D or C*n C*nn C*nnn
                          ! for real, integer, logical, real*8, character...
     character*8 :: naml  ! namelist to which quantity belongs

     integer :: steerable ! 0 means: not changeable on restart; 1 means:
                          ! changeable on TRDAT rerun; 2 means: changeable
                          ! on TRANSP restart.

     integer :: chsize    ! (char data only): size n of C*n strings.

     integer :: rank      ! dimensionality or rank {0,1,2,3, or 4}
     integer :: dims(2,maxrank) ! dims(1:2,1:rank) -- size of each dimensions
                          ! lower_limit:upper_limit

     character*20 short_dflt   ! default value string (if short)
     integer :: long_dflt_addr ! ptr to default value string (if long)

     integer :: addr      ! ptr to data (as per type)
     integer :: nlinadr   ! ptrs to TR.DAT file lines containing var. elements

     integer :: addr_st   ! update (steering block) offset data address
     integer :: nlinadr_st  ! ptrs to TR.DAT file lines containing update data

  end type var

  !--------------------------------------

  integer, parameter :: len_short=20  ! len(short_dflt) elements

  integer                                :: nvars      ! size of variables list
  type (var), dimension(:), allocatable  :: varlist
  integer, dimension(:), allocatable     :: var_order  ! alphabetic ordering

  ! list of deleted names

  integer :: ndnames  ! number of known deleted names
  character*32, dimension(:), allocatable :: dnames
  ! (names are put on this list to have splitn automatically comment them
  ! out instead of reporting an error, when encountering an undefined name).

  ! data buffers:  current namelist, namelist defaults (_d), write buffer (_w),
  !                previous namelist (_p)

  !--------------------------------------
  ! MOD dmc Mar 2009: namelists are now updatable; update sections can
  ! be added.  The number of update sections can vary from namelist to 
  ! namelist.  The default number of updates is zero.  The n<xxx>_st
  ! variables give the data sizes per data type per update section.

  ! #updates in data records:
  integer :: nupdate,nupdate_w,nupdate_p
  integer, parameter :: nupdate_d = 0

  ! to ease data mgmt, assume an interim maximum number of updates-- 
  ! this is expandable, but allows all data buffer sizes to be kept the
  ! same: for logbuf, nlog + nupdate_max*nlog_st; 
  !       for intbuf, nint + nupdate_max*nint_st, etc.

  integer :: nupdate_max = 2

  integer :: kupdate ! current update block (used by add_nl_line)

  ! updates occur in time sequences; the update times are stored here:
  real*8, dimension(:), allocatable :: tup,tup_d,tup_w,tup_p

  ! updates should occur after TINIT:
  real*8 :: tinit,tinit_d,tinit_w,tinit_p

  real*8 :: tlarge = 654.3d210  ! a very large time...
  ! tlarge is used to indicate absence of actual update blocks in namelists.

  integer :: nxblock  ! index of next update block 

  ! update block locations
  integer, dimension(:), allocatable :: linup

  ! provide upper limit on namelist file size (#lines)
  integer, parameter :: ilarge = 1000000000

  !--------------------------------------

  integer nlog,nlog_st
  logical, dimension(:), allocatable :: logbuf,logbuf_d,logbuf_w,logbuf_p

  integer nint,nint_st
  integer, dimension(:), allocatable :: intbuf,intbuf_d,intbuf_w,intbuf_p

  integer nreal,nreal_st
  real, dimension(:), allocatable :: rbuf,rbuf_d,rbuf_w,rbuf_p

  integer nr8,nr8_st
  real*8, dimension(:), allocatable :: dbuf,dbuf_d,dbuf_w,dbuf_p

  ! the length of a chbuf element is the presumed maximum length of any
  ! CHARACTER namelist variable (should match ch_maxlen):

  integer nchv,nchv_st
  character*128, dimension(:), allocatable :: chbuf,chbuf_d,chbuf_w,chbuf_p, &
       chtmp
  integer, parameter :: ch_maxlen=128
  character*128 :: chval

  !--------------------------------------
  ! indices of TR.DAT file lines which define var data elements
  integer, dimension(:), allocatable :: ilines
  !   note: this is the file position, not the storage position;
  !   text for element j at ordl(ilines(j)).

  ! this array allows for deferred assignmetns to ilines:
  integer :: iline_nstack
  integer, dimension(:,:), allocatable :: iline_stack

  ! and the range of characters within the line giving the element values.
  integer, dimension(:,:), allocatable :: ivrange

  ! associated repeat counts (0 if none)
  integer, dimension(:), allocatable :: krepeat

  ! range of characters specifying repeat count "nnn*"
  integer, dimension(:,:), allocatable :: irrange

  ! long (>len_short char) default value strings
  integer nlong
  character*512, dimension(:), allocatable :: long_dflts

  logical :: previous   ! T if there is a "previous" namelist

  !-----------------------------------------------------------------
  ! parsing-related information

  logical efitin_flag   ! .TRUE. iff reading EFITIN segment of namelist file.
  integer :: nam1,nam2  ! name field limits
  integer :: val1,val2  ! value field limits
  integer :: lcmt,len1  ! comment field start; length of line

  logical merge_flag    ! .TRUE. if namelist file merge operation was done;
  !  if merge_flag is set, only subsequent allowed action is to WRITE...

  integer, parameter :: maxwarn = 100
  character*32 dblasg1(maxwarn)  ! items doubly assigned (no value change)
  character*32 dblasg2(maxwarn)  ! items doubly assigned (value does change)
  character*32 lackdp(maxwarn)   ! floating point item w/o decimal pt
  integer :: kdblasg1(maxwarn)   ! block w/dblasg1 warning
  integer :: kdblasg2(maxwarn)   ! block w/dblasg2 warning
  integer :: klackdp(maxwarn)    ! block w/lackdp warning
  integer :: ndblasg1,ndblasg2,nlackdp  ! sizes of above lists.

  contains
    subroutine init_nl(clear_warn)
      logical, intent(in) :: clear_warn   ! .true. to clear the warning lists

      !  initialize memory-- to receive text image of TRANSP file

      if(allocated(textnl)) then
         deallocate(textnl,lenl,ordl,cmtfld,namfld,eqsfld,valfld)
      endif

      nlines=0

      !  initially assume no "update blocks" in namelist.
      kupdate = 0
      nupdate = 0
      nxblock = 1

      if(allocated(linup)) deallocate(linup)
      allocate(linup(nupdate_max)); linup=ilarge

      if(allocated(tup)) deallocate(tup)
      allocate(tup(nupdate_max)); tup = tlarge

      allocate(textnl(curmax)); textnl=' '
      allocate(lenl(curmax)); lenl=0
      allocate(ordl(curmax)); ordl=0
      allocate(cmtfld(curmax)); cmtfld=0
      allocate(eqsfld(curmax)); eqsfld=0
      allocate(namfld(2,curmax)); namfld=0
      allocate(valfld(2,curmax)); valfld=0

      !  clear warning lists
      if (clear_warn) then
         ndblasg1=0
         ndblasg2=0
         nlackdp=0
         kdblasg1=0
         kdblasg2=0
         klackdp=0
         dblasg1=' '
         dblasg2=' '
         lackdp=' '
      end if

      efitin_flag=.FALSE.
      merge_flag =.FALSE.

    end subroutine init_nl

    subroutine read_nl(filename,ios, quiet)

      ! read a TR.DAT file

      character*(*),intent(in) :: filename  ! path to namelist (TR.DAT) file
      integer, intent(out) :: ios           ! i/o status on open; 0=OK

      logical, intent(in), optional :: quiet

      !----------------------
      integer ieof,iblock
      logical :: iquiet
      !----------------------
      ! first make sure that namelist database
      ! containing namelist variable definitions and default values
      ! has been read in; re-initialize stored namelist values to 
      ! their defaults.

      call read_db(ios)
      if(ios.ne.0) return

      !----------------------
      ! open namelist file

      iquiet=.FALSE.
      if(present(quiet)) iquiet=quiet

      open(unit=lun,file=filename,status='old',iostat=ios)
      if(ios.ne.0) then
         if(.not.iquiet) then
            write(6,*) ' splitn_module(read_nl): open failure, iostat=',ios
            write(6,*) '   filename: ',trim(filename)
         endif
         return
      endif

      !----------------------
      ! read file...

      call init_nl(.true.)

      efitin_flag=.FALSE.

      do
         ! since (A) reads anything, assume iostat is set only for EOF

         read(lun,'(A)',iostat=ieof) aline
         if(ieof.ne.0) exit
        
         iblock=nxblock

         newline= nlines+1

         call parse_line(aline,.TRUE.,ios)
         if(ios.ne.0) exit  ! this is an actual error

         call add_nl_line(aline)

         if(iblock.lt.nxblock) then
            ! an update block was detected -- mark line position
            linup(iblock)=nlines  ! =newline
         endif

      enddo

      close(unit=lun)

      if(efitin_flag) then
         write(6,*) ' %splitn(read_nl): EOF during read of EFITIN namelist', &
              ' (corrected)'
         call clear_fields
         lcmt=1
         newline = nlines+1
         call add_nl_line('/')
         efitin_flag = .FALSE.
      endif

      if(ios.eq.0) then
         call splitn_check_misc(ios)
      endif

      !  save copy of namelist data in write buffers

      logbuf_w=logbuf
      intbuf_w=intbuf
      rbuf_w=rbuf
      dbuf_w=dbuf
      chbuf_w=chbuf

      tup_w=tup
      nupdate_w=nupdate
      tinit_w=tinit

    end subroutine read_nl

    subroutine splitn_check_misc(ierr)

      integer, intent(out) :: ierr

      ! check for double assignments, etc.; can be considered an error
      ! if environment variable is set.

      !--------------------------------------
      integer :: iwarn
      character*20 :: loc_testval
      !--------------------------------------

      ierr = 0

      if(ndblasg1.gt.0) call splitn_printwarn( &
           'namelist elements assigned the same value more than once:', &
           ndblasg1,len(dblasg1(1)),dblasg1,kdblasg1)
      if(ndblasg2.gt.0) call splitn_printwarn( &
           'namelist elements assigned more than once WITH change of value:', &
           ndblasg2,len(dblasg2(1)),dblasg2,kdblasg2)
      if(nlackdp.gt.0) call splitn_printwarn( &
           'namelist element value field(s): decimal point(s) inserted:', &
           nlackdp,len(lackdp(1)),lackdp,klackdp)

      !  DMC: option to make change of value an ERROR instead of a WARNING:
      !  (added Feb 2009):

      call mpi_sget_env('SPLITN_NO_REASSIGN',loc_testval,iwarn)
      call uupper(loc_testval)
      if((loc_testval.eq.'TRUE').AND.(ndblasg2.gt.0)) then
         ierr=999
         write(6,*) ' '
         write(6,*) ' -> Environment variable SPLITN_NO_REASSIGN = "TRUE",'
         write(6,*) ' therefore element value reassignment is deemed an error.'
         write(6,*) ' '
      endif

    end subroutine splitn_check_misc

    subroutine merge_read_nl(filename,tagname,ios)

      ! read a namelist fragment-- append to end; remove earlier copy
      ! of fragment as determined by tag and/or definition of variables

      character*(*),intent(in) :: filename  ! path to namelist (TR.DAT) file
      character*(*),intent(in) :: tagname   ! fragment tag name
      integer, intent(out) :: ios           ! i/o status on open; 0=OK

      !----------------------
      integer ieof,insave,inames
      character*18 fulltag
      character*32, dimension(:), allocatable :: znames
      character*80 nbuf
      character*9 zdate
      character*40 zuser
      integer :: iparen,ilen,i,j,k,ifind
      !----------------------

      if(merge_flag) then
         write(6,*) ' ?splitn_module: namelist already merged; next operation must be a write.'
         ios=1
         return
      endif

      if((nlines.le.0).or.(.not.have_database)) then
         write(6,*) ' ?splitn_module: normal namelist read must be done first'
         write(6,*) '  before attempting merge with 2nd namelist fragment.'
         ios=1
         return
      endif

      kupdate = 0  ! deal with main block only (no update blocks)

      !----------------------
      fulltag = '!$'//tagname
      call ulower(fulltag)
      !----------------------
      ! open namelist file

      open(unit=lun,file=filename,status='old',iostat=ios)
      if(ios.ne.0) then
         write(6,*) ' splitn_module(merge_read_nl): open failure, iostat=',ios
         write(6,*) '   filename: ',trim(filename)
         return
      endif

      !----------------------
      ! read file...

      insave = nlines
      inames = 0

      allocate(znames(nreal+nint+nlog+nr8+nchv))

      call c9date(zdate)
      call sget_user(zuser)

      call clear_fields
      lcmt=3

      call get_newline
      call add_nl_line('  !------------------------------------------------'//&
           ' '//trim(fulltag))

      bline = '  ! '//trim(fulltag)//' inserted on '//zdate//' by user '//zuser
      call get_newline
      call add_nl_line(bline)

      do
         ! since (A) reads anything, assume iostat is set only for EOF

         read(lun,'(A)',iostat=ieof) aline
         if(ieof.ne.0) exit

         call get_newline

         call addtag

         call parse_line(aline,.FALSE.,ios)
         if(ios.ne.0) exit  ! this is an actual error

         if(nam1.gt.0) call addname

         call add_nl_line(aline)

      enddo

      close(unit=lun)

      if(efitin_flag) then
         write(6,*) ' %splitn(read_nl): EOF during read of EFITIN namelist', &
              ' (corrected)'
         call clear_fields
         lcmt=1
         call get_newline
         call add_nl_line('/')
         efitin_flag = .FALSE.
      endif

      !  mark pre-merge lines for deletion if either tag is present or if RHS
      !  variable is on list...

      do i=1,insave
         if(chktag(textnl(i))) then
            lenl(i)=0
         else
            if(namfld(1,i).eq.0) cycle
            ilen=namfld(2,i)-namfld(1,i)+1
            nbuf=textnl(i)(namfld(1,i):namfld(2,i))
            iparen=index(nbuf,'(')
            if(iparen.gt.0) then
               nbuf(iparen:ilen)=' '
            endif
            ilen=len(trim(nbuf))
            call ulower(nbuf(1:ilen))

            ifind=0
            do j=1,inames
               if(nbuf(1:ilen).eq.znames(j)) then
                  ifind=j
                  exit
               endif
            enddo

            if(ifind.gt.0) then
               lenl(i)=0
            endif
         endif
      enddo

      deallocate(znames)
      merge_flag = .TRUE.

      contains
        subroutine addtag

          !  add tag comment to inserted line...

          integer :: ilen,ilenf,insrt

          character*1 :: squot = "'"
          character*1 :: dquot = '"'
          character*1 :: cexcl = '!'
          character*1 :: zquot

          integer :: ic,icmt

          !----------------------------
          ! first look to see if comment is already present.

          if(chktag(aline)) return

          ilen=len(trim(aline))
          ilenf=len(fulltag)

          icmt = 0
          zquot = ' '
          do ic=1,ilen
             if(zquot.eq.' ') then
                if(aline(ic:ic).eq.cexcl) then
                   icmt=ic
                   exit
                endif
                if(aline(ic:ic).eq.squot) zquot=squot
                if(aline(ic:ic).eq.dquot) zquot=dquot
             else
                if(aline(ic:ic).eq.zquot) zquot=' '
             endif
          enddo

          if(icmt.gt.0) then
             !  comment field present -- append to end
             insrt = min((len(aline)-ilenf+1),ilen+2)
          else
             !  no coment field found
             insrt=max(65,min((len(aline)-ilenf+1),ilen+2))
          endif

          aline(insrt:insrt+ilenf-1)=fulltag

        end subroutine addtag

        logical function chktag(zline)

          character*(*), intent(in) :: zline

          bline=zline
          call ulower(bline)
          chktag = index(bline,fulltag).gt.0

        end function chktag

        subroutine addname

          nbuf = aline(nam1:nam2)
          iparen = index(nbuf,'(')
          if(iparen.gt.0) then
             nbuf(iparen:len(nbuf))=' '
          endif

          ilen=len(trim(nbuf))

          call ulower(nbuf(1:ilen))

          ifind=0
          do i=1,inames
             if(nbuf(1:ilen).eq.znames(i)) then
                ifind=i
                exit
             endif
          enddo

          if(ifind.eq.0) then
             inames=inames+1
             znames(inames)=nbuf(1:ilen)
          endif
        end subroutine addname

    end subroutine merge_read_nl

    subroutine get_newline
      ! get new line location before next update block

      addblank = .FALSE.

      if(kupdate.lt.nupdate) then
         newline = linup(kupdate+1)
         if(isblank(newline-1)) then
            newline=newline-1
         else
            addblank=.TRUE.
         endif
      else
         newline = nlines + 1
      endif

    end subroutine get_newline

    !-------------------------------------------------------------------
    subroutine parse_line(aline,ublock,ios)

      ! parse a single namelist input line
      ! <name>[(<indices>,...)] = [<values>,...] [! <comment>]
      ! LHS                       RHS             comment
      !
      ! only one LHS per line.  RHS can have one or more values but
      ! the number should be appropriate as per the storage associated
      ! with the variable specified on the LHS.  The value field can be
      ! null, in which case no assignment is made and the default value
      ! remains in effect.  commas "," separate individual values, and
      ! repeat counts can be used, e.g.
      !
      !   CBALLOON(12) = 2*1.0,3*,,4.4D4
      !
      ! assigns 1.0 to CBALLOON(12:13), skips (14:17) (4 null fields, 3
      ! due to a repeat count, and assigns 4.4D4 to CBALLOON(18).
      !
      ! generally, aline is not modified.  EXCEPTION: decimal points will
      ! be inserted, with warning, in non-null floating point value fields
      ! that lack them.  EXCEPTION2: non-printable characters other than
      ! "tab" removed!
      !
      ! dmc Jan 2003 ...

      character*(*), intent(inout) :: aline  ! line from namelist file
      logical, intent(in) :: ublock          ! .TRUE. to allow update block
      integer, intent(out) :: ios            ! parse status, 0=OK

      !-------------------
      integer i,j,k,icmt,ic1,ic2,iwarncc
      integer ic1a,ic2a,ieqs,ierr,ivals,iblock,iadr
      integer imatch,jj,indx(maxrank),ipass
      character*150 wk
      character*1 zquot
      character*26 zalphab(2)
      real*8 :: uptime

      data zalphab/ &
           'abcdefghijklmnopqrstuvwxyz', &
           'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

      data iwarncc/-3/

      !-------------------

      ipass=0

5     continue  ! re-enter here, if line is commented out on the fly

      ios=0

      ipass = ipass + 1
      if(ipass.gt.2) then
         ios = 99
         write(6,*) ' ?splitn_module(parse_line) ipass>2: internal error.'
         return
      endif

      if(merge_flag) then
         write(6,*) ' ?splitn_module: line parse unavailable after merge.'
         ios=1
         return
      endif

      call clear_fields

      !  get non-blank length of "aline" -- remove any non-printable characters

      len1=0
      do i=len(aline),1,-1
         j=ichar(aline(i:i))
         if(j.ne.9) then
            if((j.lt.32).or.(j.eq.127)) then
               if(iwarncc.lt.0) then
                  iwarncc=iwarncc+1
                  write(6,*) &
                       ' %splitn_module:parse: non-printable character: (', &
                       j,') replaced with blank.'
               endif
               aline(i:i)=' '
               j=32
            endif
         endif
         if(len1.eq.0) then
            if((j.ne.9).and.(j.ne.32)) len1=i
         endif
      enddo

      wk=aline       ! local, writable copy of line.

      zquot=' '      ! use for quote balance checking
      icmt=0         ! location of "!", start of comment
      ic1=0          ! start of non-blank non-"!"-comment section
      ic1a=0         ! last non-blank before "=" sign
      ic2a=0         ! first non-blank after "=" sign
      ic2=0          ! end of non-blank non-"!"-comment section
      ieqs=0         ! first "=" sign in non-comment non-quoted section
      
      i=0

      ! scan the line:  look for comment fields and non-comment section.
      ! Do quote balance checking.  Convert non-comment non-quoted sections
      ! to uppercase.  Detab.

      do
         i=i+1
         if(i.gt.len1) exit

         if(zquot.ne.' ') then
            ! inside quote string: look for matching, closing quote ONLY
            if(wk(i:i).eq.zquot) then
               zquot=' '
               if(ieqs.ne.0) ic2=i
            endif
            cycle

         else if((wk(i:i).eq."'").or.(wk(i:i).eq.'"')) then
            ! start of quote string
            zquot=wk(i:i)
            if((ieqs.ne.0).and.(ic2a.eq.0)) ic2a=i
            cycle

         endif

         ! outside quote string, before "!" comment:

         if(wk(i:i).eq.char(9)) wk(i:i)=' '  ! detab
         if(wk(i:i).eq.' ') cycle

         ! non-blank

         if((wk(i:i).eq.'!').or.(wk(i:i).eq.'$').or. &
              (wk(i:i).eq.'&').or.(wk(i:i).eq.'/')) then
            icmt=i           ! comment field found; exit
            exit
         endif

         ! bounds of non-blank non-comment section

         if(ic1.eq.0) ic1=i
         ic2=i

         if(wk(i:i).eq.'=') then
            if(ieqs.eq.0) ieqs=i
            cycle
         endif

         if(ieqs.eq.0) ic1a=i
         if((ieqs.ne.0).and.(ic2a.eq.0)) ic2a=i

         ! uppercase conversion

         j=index(zalphab(1),wk(i:i))
         if(j.gt.0) wk(i:i)=zalphab(2)(j:j)
      enddo

      ! check for unbalanced quotes:
      if(zquot.ne.' ') then
         write(6,*) '?splitn_module(parse_line): unbalanced quotes detected:'
         write(6,*) ' ',aline(1:len1)
         ios=1
         return
      endif

      lcmt=icmt

      ! OK: check for &<namelist-name> &END or similar construct

      if(icmt.gt.0) then
         if(wk(icmt:icmt).eq.'/') then
            if (ieqs>0 .and. ieqs<icmt) then
               write(6,*) '?splitn_module(parse_line): end of namelist character "/" not allowed with variable definition:'
               write(6,*) ' ',aline(1:len1)
               ios=1
            else
               efitin_flag=.FALSE.  ! end-of-namelist indicator
            end if
            return
         endif

         if((wk(icmt:icmt).eq.'$').or.(wk(icmt:icmt).eq.'&')) then
            if(wk(icmt+1:icmt+4).eq.'END ') then
               efitin_flag=.FALSE.  ! end-of-namelist indicator
            else if(wk(icmt+1:icmt+7).eq.'EFITIN ') then
               if(kupdate.gt.0) then
                  write(6,*) '?splitn_module(parse_line): EFITIN namelist:'
                  write(6,*) ' cannot be positioned after start of update blocks.'
                  ios=1
               else
                  efitin_flag=.TRUE.
               endif
            endif
            return
         endif
      endif

      if(ic1.eq.0) return  ! line is comment-only

      ! it is more than just a comment, so...
      ! OK: must have name = value combination or name = <NULL> combination.

      if(.not.efitin_flag) then
         if((ieqs.eq.0).or.(ic1.ge.ieqs)) then
            write(6,*) &
                 '?splitn_module(parse_line): expected <LHS> = <RHS> form.'
            if(ieqs.eq.0) then
               write(6,*) ' "=" sign not found.'
            else if(ic1.ge.ieqs) then
               write(6,*) ' LHS (left hand side) not found.'
            endif
            write(6,*) ' ',aline(1:len1)
            ios=1
            return
         endif

         nam1=ic1
         nam2=ic1a
         val1=ic2a
         val2=ic2
         if(ic2.le.ieqs) then
            val1=ieqs+1
            val2=ieqs+1   ! null RHS (blank)
            wk(val1:val2)=' '
         else if((ic2a.eq.ic2).and.(wk(ic2:ic2).eq.',')) then
            val1=ieqs+1
            val2=ieqs+1   ! null RHS (",")
            wk(val1:val2)=' '
         endif

         ! parse LHS -- check that name is known & indexing is OK

         call splitn_lhs(wk(nam1:nam2),imatch,indx,maxrank,ierr)
         if(ierr.ne.0) then
            write(6,*) ' ?splitn_module (parse_line): LHS parse error:'
            write(6,*) ' ',aline(1:len1)
            ios=1
            return
         endif

         if(imatch.eq.0) then
            !  ierr=0 && imatch=0 means detected a known deleted namelist name 
            bline = aline
            aline = '  !(splitn_deleted)  '//trim(bline)
            go to 5  ! reprocess line as commented out
         endif

         jj=var_order(imatch)

         ! check value fields of all floating point types for decimal pts.

         if((varlist(jj)%type.eq.'R').or.(varlist(jj)%type.eq.'D')) then
            call splitn_chkdp(aline,wk)
         endif

         if((varlist(jj)%steerable.eq.3).and.(.NOT.ublock)) then
            write(6,*) ' ?splitn_module (parse_line): update block not supported in merge list:'
            write(6,*) ' ',aline(1:len1)
            ios=1
            return
         endif

         ! parse RHS

         if(varlist(jj)%rank.eq.0) then

            if(varlist(jj)%steerable.eq.3) then
               !  may want to make room for more blocks, before RHS parse...
               if(nxblock.ge.nupdate_max) call spxb_expand
            endif

            ! scalar

            call splitn_rhs0(aline(1:len1),wk(val1:val2),ivals,jj)
            if(ivals.ne.1) then
               write(6,*) ' ?splitn_module (parse line): error in line:'
               if(ivals.gt.1) write(6,*) '  too many values for scalar:'
               write(6,*) ' ',aline(1:len1)
               ios=1
               return
            endif

            if(varlist(jj)%steerable.eq.3) then
               iblock=nxblock-1
               if(iblock.eq.0) then
                  iadr = varlist(jj)%addr
               else
                  iadr = nr8 + (iblock-1)*nr8_st + varlist(jj)%addr_st
               endif

               uptime = dbuf(iadr)
               if(iblock.gt.0) then
                  if(uptime.le.tup(iblock)) then
                     write(6,*) ' ?splitn_module (parse line): update block time not in ascending order:'
                     write(6,*) ' ',aline(1:len1)
                     write(6,*) '  prior update time: ',tup(iblock)
                     ios=1
                     return
                  endif
               else
                  if(uptime.le.tinit) then
                     write(6,*) ' ?splitn_module (parse line): first update block time <= TINIT:'
                     write(6,*) ' ',aline(1:len1)
                     write(6,*) '  TINIT in namelist: ',tinit
                     ios=1
                     return
                  endif
               endif

               write(6,*) ' %splitn_module: update block detected, t=',uptime

               tup(nxblock) = uptime
               nupdate = nxblock
               kupdate = nupdate
               nxblock = nxblock + 1
            endif

            if(varlist(jj)%name.eq.'TINIT') then
               iadr = varlist(jj)%addr
               tinit = dbuf(iadr)
            endif
                     
         else

            call splitn_rhs(aline(1:len1),wk(val1:val2),jj,indx,maxrank,ios)

         endif

      else

         ! inside EFITIN namelist...

         if(ic1.gt.0) then
            if(wk(ic1:ic1).eq.'~') then
               write(6,*) ' ?splitn_module (parse_line): error in line:'
               write(6,*) '  "~" variable in EFITIN namelist.'
               write(6,*) ' ',aline(1:len1)
               ios=1
            endif
         endif
         
      endif  ! efitin_flag

    end subroutine parse_line

    !-------------------------------------------------------------------
    subroutine spxb_expand
      ! increase nupdate_max; re-allocate and expand arrays

      integer, parameter :: incr=10  ! add 10 slots per call
      integer :: inumpre             ! previous number
      integer :: isizepre,isizenew   ! for buffers: old & new sizes

      integer :: ii,jj

      real, dimension(:), allocatable :: r4tmp
      real*8, dimension(:), allocatable :: r8tmp
      integer, dimension(:), allocatable :: itmp
      logical, dimension(:), allocatable :: ltmp
      character*128, dimension(:), allocatable :: chtmp
      integer, dimension(:,:), allocatable :: itmp2

      !------------------------------

      inumpre = nupdate_max
      nupdate_max = nupdate_max + incr

      !------------------------------
      !  update times & update marker line counts

      allocate(r8tmp(inumpre))
      allocate(itmp(inumpre))

      r8tmp = tup
      deallocate(tup); allocate(tup(nupdate_max))
      tup(1:inumpre)=r8tmp
      tup(inumpre+1:)=tlarge

      r8tmp = tup_p
      deallocate(tup_p); allocate(tup_p(nupdate_max))
      tup_p(1:inumpre)=r8tmp
      tup_p(inumpre+1:)=tlarge

      r8tmp = tup_d
      deallocate(tup_d); allocate(tup_d(nupdate_max))
      tup_d(1:inumpre)=r8tmp
      tup_d(inumpre+1:)=tlarge

      r8tmp = tup_w
      deallocate(tup_w); allocate(tup_w(nupdate_max))
      tup_w(1:inumpre)=r8tmp
      tup_w(inumpre+1:)=tlarge

      itmp = linup
      deallocate(linup); allocate(linup(nupdate_max))
      linup(1:inumpre)=itmp
      linup(inumpre+1:)=ilarge

      deallocate(r8tmp,itmp)

      !------------------------------
      !  update data buffers...

      if(nlog_st.gt.0) then
         ! logical...

         isizepre = nlog + nlog_st*inumpre
         isizenew = nlog + nlog_st*nupdate_max

         allocate(ltmp(isizepre))

         ltmp=logbuf
         deallocate(logbuf); allocate(logbuf(isizenew))
         logbuf(1:isizepre)=ltmp
         call lset_ucop(logbuf,1,nlog_st,1,0,inumpre,nupdate_max)

         ltmp=logbuf_p
         deallocate(logbuf_p); allocate(logbuf_p(isizenew))
         logbuf_p(1:isizepre)=ltmp
         call lset_ucop(logbuf_p,1,nlog_st,1,0,inumpre,nupdate_max)

         ltmp=logbuf_d
         deallocate(logbuf_d); allocate(logbuf_d(isizenew))
         logbuf_d(1:isizepre)=ltmp
         call lset_ucop(logbuf_d,1,nlog_st,1,0,inumpre,nupdate_max)

         ltmp=logbuf_w
         deallocate(logbuf_w); allocate(logbuf_w(isizenew))
         logbuf_w(1:isizepre)=ltmp
         call lset_ucop(logbuf_w,1,nlog_st,1,0,inumpre,nupdate_max)

         deallocate(ltmp)
      endif

      if(nint_st.gt.0) then
         ! integer...

         isizepre = nint + nint_st*inumpre
         isizenew = nint + nint_st*nupdate_max

         allocate(itmp(isizepre))

         itmp=intbuf
         deallocate(intbuf); allocate(intbuf(isizenew))
         intbuf(1:isizepre)=itmp
         call iset_ucop(intbuf,1,nint_st,1,0,inumpre,nupdate_max)

         itmp=intbuf_p
         deallocate(intbuf_p); allocate(intbuf_p(isizenew))
         intbuf_p(1:isizepre)=itmp
         call iset_ucop(intbuf_p,1,nint_st,1,0,inumpre,nupdate_max)

         itmp=intbuf_d
         deallocate(intbuf_d); allocate(intbuf_d(isizenew))
         intbuf_d(1:isizepre)=itmp
         call iset_ucop(intbuf_d,1,nint_st,1,0,inumpre,nupdate_max)

         itmp=intbuf_w
         deallocate(intbuf_w); allocate(intbuf_w(isizenew))
         intbuf_w(1:isizepre)=itmp
         call iset_ucop(intbuf_w,1,nint_st,1,0,inumpre,nupdate_max)

         deallocate(itmp)
      endif

      if(nreal_st.gt.0) then
         ! real*4...

         isizepre = nreal + nreal_st*inumpre
         isizenew = nreal + nreal_st*nupdate_max

         allocate(r4tmp(isizepre))

         r4tmp=rbuf
         deallocate(rbuf); allocate(rbuf(isizenew))
         rbuf(1:isizepre)=r4tmp
         call rset_ucop(rbuf,1,nreal_st,1,0,inumpre,nupdate_max)

         r4tmp=rbuf_p
         deallocate(rbuf_p); allocate(rbuf_p(isizenew))
         rbuf_p(1:isizepre)=r4tmp
         call rset_ucop(rbuf_p,1,nreal_st,1,0,inumpre,nupdate_max)

         r4tmp=rbuf_d
         deallocate(rbuf_d); allocate(rbuf_d(isizenew))
         rbuf_d(1:isizepre)=r4tmp
         call rset_ucop(rbuf_d,1,nreal_st,1,0,inumpre,nupdate_max)

         r4tmp=rbuf_w
         deallocate(rbuf_w); allocate(rbuf_w(isizenew))
         rbuf_w(1:isizepre)=r4tmp
         call rset_ucop(rbuf_w,1,nreal_st,1,0,inumpre,nupdate_max)

         deallocate(r4tmp)
      endif

      if(nr8_st.gt.0) then
         ! real*8...

         isizepre = nr8 + nr8_st*inumpre
         isizenew = nr8 + nr8_st*nupdate_max

         allocate(r8tmp(isizepre))

         r8tmp=dbuf
         deallocate(dbuf); allocate(dbuf(isizenew))
         dbuf(1:isizepre)=r8tmp
         call dset_ucop(dbuf,1,nr8_st,1,0,inumpre,nupdate_max)

         r8tmp=dbuf_p
         deallocate(dbuf_p); allocate(dbuf_p(isizenew))
         dbuf_p(1:isizepre)=r8tmp
         call dset_ucop(dbuf_p,1,nr8_st,1,0,inumpre,nupdate_max)

         r8tmp=dbuf_d
         deallocate(dbuf_d); allocate(dbuf_d(isizenew))
         dbuf_d(1:isizepre)=r8tmp
         call dset_ucop(dbuf_d,1,nr8_st,1,0,inumpre,nupdate_max)

         r8tmp=dbuf_w
         deallocate(dbuf_w); allocate(dbuf_w(isizenew))
         dbuf_w(1:isizepre)=r8tmp
         call dset_ucop(dbuf_w,1,nr8_st,1,0,inumpre,nupdate_max)

         deallocate(r8tmp)
      endif

      if(nchv_st.gt.0) then
         ! character*128...

         isizepre = nchv + nchv_st*inumpre
         isizenew = nchv + nchv_st*nupdate_max

         allocate(chtmp(isizepre))

         chtmp=chbuf
         deallocate(chbuf); allocate(chbuf(isizenew))
         chbuf(1:isizepre)=chtmp
         call chset_ucop(chbuf,1,nchv_st,1,0,inumpre,nupdate_max)

         chtmp=chbuf_p
         deallocate(chbuf_p); allocate(chbuf_p(isizenew))
         chbuf_p(1:isizepre)=chtmp
         call chset_ucop(chbuf_p,1,nchv_st,1,0,inumpre,nupdate_max)

         chtmp=chbuf_d
         deallocate(chbuf_d); allocate(chbuf_d(isizenew))
         chbuf_d(1:isizepre)=chtmp
         call chset_ucop(chbuf_d,1,nchv_st,1,0,inumpre,nupdate_max)

         chtmp=chbuf_w
         deallocate(chbuf_w); allocate(chbuf_w(isizenew))
         chbuf_w(1:isizepre)=chtmp
         call chset_ucop(chbuf_w,1,nchv_st,1,0,inumpre,nupdate_max)

         deallocate(chtmp)
      endif

      !------------------------------
      !  line tracking arrays...

      isizepre = nreal+nint+nlog+nr8+nchv + &
           inumpre*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st)

      isizenew = nreal+nint+nlog+nr8+nchv + &
           nupdate_max*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st)

      allocate(itmp(isizepre),itmp2(2,isizepre))

      deallocate(iline_stack); allocate(iline_stack(2,isizenew))

      itmp = ilines
      deallocate(ilines); allocate(ilines(isizenew))
      ilines(1:isizepre) = itmp
      ilines(isizepre+1:isizenew) = 0 

      itmp = krepeat
      deallocate(krepeat); allocate(krepeat(isizenew))
      krepeat(1:isizepre) = itmp
      krepeat(isizepre+1:isizenew) = 0 

      itmp2 = ivrange
      deallocate(ivrange); allocate(ivrange(2,isizenew))
      do jj=1,isizenew
         do ii=1,2
            if(jj.le.isizepre) then
               ivrange(ii,jj)=itmp2(ii,jj)
            else
               ivrange(ii,jj)=0
            endif
         enddo
      enddo

      itmp2 = irrange
      deallocate(irrange); allocate(irrange(2,isizenew))
      do jj=1,isizenew
         do ii=1,2
            if(jj.le.isizepre) then
               irrange(ii,jj)=itmp2(ii,jj)
            else
               irrange(ii,jj)=0
            endif
         enddo
      enddo

      deallocate(itmp,itmp2)

    end subroutine spxb_expand
    !-------------------------------------------------------------------
    subroutine clear_fields

      nam1=0; nam2=0 ! name field 
      val1=0; val2=0 ! value field
      lcmt=0         ! start of comment field

      iline_nstack=0 ! clear deferred ilines assignments

    end subroutine clear_fields

    !-------------------------------------------------------------------
    subroutine write_nl(filename,ios, quiet)

      ! write a namelist file

      character*(*),intent(in) :: filename  ! path to namelist (TR.DAT) file
      integer, intent(out) :: ios           ! i/o status on open; 0=OK

      logical, intent(in), optional :: quiet

      integer i,j,ilf
      logical :: iquiet

      iquiet = .FALSE.
      if(present(quiet)) iquiet=quiet

      open(unit=lun,file=filename,status='old',iostat=ios)
      if(ios.eq.0) then
         ! file exists: rename it
         close(unit=lun)
         ilf=len_trim(filename)
         call frename(filename(1:ilf),filename(1:ilf)//'~',ios)
      endif

      open(unit=lun,file=filename,status='new',iostat=ios)
      if(ios.ne.0) then
         if(.not.iquiet) then
            write(6,*) ' splitn_module(write_nl): open failure, iostat=',ios
            write(6,*) '   filename: ',trim(filename)
         endif
         return
      endif

      do i=1,nlines
         j=ordl(i)
         if(lenl(j).ne.0) then
            write(lun,'(A)') textnl(j)(1:abs(lenl(j)))
         endif
      enddo

      close(unit=lun)

    end subroutine write_nl

    logical function isblank(ilini)
      ! return TRUE if indicated line is all blank

      integer, intent(in) :: ilini
      integer :: indx

      if(ilini.eq.0) then
         isblank=.FALSE.
         return
      endif

      indx=ordl(ilini)

      isblank = (namfld(1,indx).eq.0).AND.(eqsfld(indx).eq.0).AND. &
           (valfld(1,indx).eq.0).AND.(cmtfld(indx).eq.0)

    end function isblank

    subroutine add_nl_line(zline)

      ! add a line to the memory image of the file
      ! increase the available memory, if necessary

      ! insert line at location (newline)

      ! NOTE: this routine expects not just the "zline" text is input
      !   but also that nam1:nam2 and val1:val2 and possibly lcmt are set...

      character*(*), intent(in) :: zline   ! line to add

      ! ipos = 0 means: add line at end of current update block (EOB)
      ! ipos = -1 means: add line at end of file (EOF)
      ! ipos > 0 menas: insert line at indicated location; line currently
      !                 at location and subsequent lines are shifted down one.

      integer, dimension(:), allocatable :: ilenl,iordl,icmtfld,ieqsfld
      integer, dimension(:,:), allocatable :: inamfld,ivalfld
      character*150, dimension(:), allocatable :: tmptext
      integer klines,i,j,iposi,iposj,ishift
      integer :: ii,ilin

      !------------------------------------

      iposi=newline
      ishift=1
      if(addblank) ishift=2

      if(nlines+ishift-1.ge.curmax) then
         klines=nlines
         !  will expand memory -- make temporary copies --
         allocate(iordl(klines),ilenl(klines),ieqsfld(klines),tmptext(klines))
         allocate(inamfld(2,klines),ivalfld(2,klines),icmtfld(klines))
         do i=1,klines
            j=ordl(i)    ! copies put in sorted order
            iordl(i)=i
            ilenl(i)=lenl(j)
            tmptext(i)=textnl(j)
            inamfld(1:2,i)=namfld(1:2,j)
            ieqsfld(i)=eqsfld(j)
            ivalfld(1:2,i)=valfld(1:2,j)
            icmtfld(i)=cmtfld(j)
         enddo

         curmax=2*curmax           ! double the allocated memory

         call init_nl(.false.)     ! fetch & initialize

         nlines=klines             ! copy back from temp arrays
         ordl(1:klines)=iordl
         lenl(1:klines)=ilenl
         textnl(1:klines)=tmptext
         namfld(1:2,1:klines)=inamfld
         eqsfld(1:klines)=ieqsfld
         valfld(1:2,1:klines)=ivalfld
         cmtfld(1:klines)=icmtfld

         deallocate(iordl,ilenl,tmptext,ieqsfld)  ! free temp arrays
         deallocate(inamfld,ivalfld,icmtfld)

      endif

      nlines = nlines+1
      textnl(nlines)=zline
      lenl(nlines)=max(1,len_trim(zline))
      if(efitin_flag) lenl(nlines)=-lenl(nlines)
      namfld(1,nlines)=nam1
      namfld(2,nlines)=nam2
      if(namfld(1,nlines).gt.0) then
         eqsfld(nlines)=index(zline,'=')
      else
         eqsfld(nlines)=0
      endif
      valfld(1,nlines)=val1
      valfld(2,nlines)=val2
      cmtfld(nlines)=lcmt

      if(addblank) then
         nlines = nlines + 1
         textnl(nlines)=' '
         lenl(nlines)=1
         if(efitin_flag) lenl(nlines)=-lenl(nlines)
         namfld(1:2,nlines)=0
         eqsfld(nlines)=0
         valfld(1:2,nlines)=0
         cmtfld(nlines)=0
      endif

      if((iposi.ge.nlines).or.(iposi.le.0)) then
         ordl(nlines)=nlines
         if(addblank) ordl(nlines-1)=nlines-1
      else
         do i=nlines,iposi+ishift,-1
            ordl(i)=ordl(i-ishift)
         enddo
         if(addblank) then
            ordl(iposi)=nlines-1
            ordl(iposi+1)=nlines
         else
            ordl(iposi)=nlines
         endif

         do i=1,maxlines(0)
            if(ilines(i).ge.iposi) ilines(i)=ilines(i)+ishift
         enddo

         !  check block bdys also
         do i=1,nupdate_max
            if((linup(i).ge.iposi).and.(linup(i).lt.ilarge)) then
               linup(i)=linup(i)+ishift
            endif
         enddo

      endif

      ! deferred ilines assignment now...
      do i=1,iline_nstack
         ii=iline_stack(1,i)
         ilin=iline_stack(2,i)
         ilines(ii)=ilin
      enddo
      iline_nstack = 0

      addblank = .FALSE.

    end subroutine add_nl_line

    integer function maxlines(idum)

      integer, intent(in) :: idum

      maxlines = nreal+nint+nlog+nr8+nchv
      maxlines = maxlines + &
           nupdate_max*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st)

    end function maxlines

    subroutine read_db(ios)

      ! open file and read namelist database;
      ! acquire default values & initialize actual values for real namelist
      ! file (about to be read).  If database has already been read, then,
      ! just re-initialize the actual values.

      ! namelist file is expected in "standard place", as per the
      ! code, below

      ! mod DMC -- "~UPDATE_TIME" is hardwired in

      integer, intent(out) :: ios           ! i/o status on open; 0=OK

      ! ---------------------------
      character*32 zname         ! var. name, this line
      character*5 ztype          ! var. type, this line
      integer :: ksteer          ! steerability flag
      integer iirank,iidims(2,4) ! rank (0 for scalar, 1 for vector, ...)
                                 ! & dimensions (match dim element of var type)
      integer ichsize            ! size (n) of C*n strings 
      character*512 zdflt        ! default value string

      character*84 iline         ! line buffer (actual file line length <= 80)
      integer i,j,ii,inaml
      integer isize,ivecsz

      integer ivars,ilong,ilog,iint,ichv,ir8,ireal,ilinp,ilf
      integer :: jlog,jint,jchv,jr8,jreal
      integer :: ilog_st,iint_st,ichv_st,ir8_st,ireal_st,ilinp_st
      integer :: ilen_naml,imaxlen_naml,ios2
      integer :: ibefore,imatch

      ! ---------------------------
      ios = 0
      if(have_database) then

         ! not the first namelist read... store old namelist in "_p" buffers
         logbuf_p = logbuf
         intbuf_p = intbuf
         rbuf_p = rbuf
         dbuf_p = dbuf
         chbuf_p = chbuf

         tup_p=tup
         nupdate_p=nupdate
         tinit_p=tinit

         previous = .TRUE.

         ! re-initialize to default state (before real namelist read)
         logbuf = logbuf_d
         intbuf = intbuf_d
         rbuf = rbuf_d
         dbuf = dbuf_d
         chbuf = chbuf_d

         tup=tup_d
         nupdate=nupdate_d  ! zero
         kupdate=0
         nxblock=1

         tinit=tinit_d

         ilines = 0
         ivrange = 0
         krepeat = 0
         irrange = 0

         return

      endif

      ! ---------------------------
      ! find namelist database file

      nlfile='nxlist.summary'
      ilf=len_trim(nlfile)

      open(unit=lun,file=nlfile(1:ilf),status='old', &
           action='READ',iostat=ios)

      if(ios.ne.0) then
         call ufilnam('CONFIGDIR','nxlist.summary',nlfile)
         ilf=len_trim(nlfile)

         open(unit=lun,file=nlfile(1:ilf),status='old', &
              action='READ',iostat=ios)
      endif

      if(ios.ne.0) then
         call ufilnam('NTCCHOME','bin/nxlist.summary',nlfile)
         ilf=len_trim(nlfile)
         open(unit=lun,file=nlfile(1:ilf), &
              status='old',iostat=ios)
      endif
      if(ios.ne.0) then
         call ufilnam('TRANSP_LOCATION','nxlist.summary',nlfile)
         ilf=len_trim(nlfile)
         open(unit=lun,file=nlfile(1:ilf), &
              status='old',iostat=ios)
      endif
      
      if(ios.ne.0) then
         write(6,*) ' ?splitn_module(read_db): cannot find "nxlist.summary".'
         write(6,*) '  (TRANSP namelist definition database not found).'
         return
      endif

      have_database = .TRUE.

      ! the database file is read in two passes.  In the first pass, 
      ! the sizes of lists and data structures are determined; then,
      ! after the necessary arrays have been allocated, the file is
      ! reread with the data being stored in the allocated structures.

      nvars=0
      nlong=0

      nlog=0
      nint=0
      nchv=0
      nr8=0
      nreal=0

      nlog_st=0
      nint_st=0
      nchv_st=0
      nr8_st=0
      nreal_st=0

      nnamls=0

      nupdate=0; nupdate_w=0; nupdate_p=0  ! parameter defines nupdate_d = 0 
      kupdate=0
      nxblock=1

      ilen_naml=0
      imaxlen_naml=0

      ! allocate and define initial update time vectors (dflt: no updates)
      allocate(tup(nupdate_max),tup_d(nupdate_max), &
           tup_p(nupdate_max),tup_w(nupdate_max))

      !-------------------
      !  add space for splitn-defined variables

      nvars = nvars + 1
      nr8 = nr8 + 1
      nr8_st = nr8_st + 1

      !-------------------
      !  find the requisite space

      do 
         read(lun,'(A)',iostat=ios) iline
         if(ios.ne.0) exit

         j=0
         do i=1,len(iline)
            if((iline(i:i).ne.' ').and.(iline.ne.char(9))) then
               j=i
               exit  ! non-whitespace found
            endif
         enddo
         if(j.eq.0) cycle   ! ignore all-blank line

         if(iline(j:j).eq.'#') cycle   ! ignore comment line

         if(iline(j:j).eq.'*') then
            cur_naml=iline(j+1:j+len(cur_naml))  ! set current namelist 
            cycle
         endif

         nvars=nvars+1
         call read1_db(iline,j,zname,ksteer,ztype,ichsize,iirank,iidims,zdflt)

         isize=igsize(iirank,iidims)
         if(ztype.eq.'R') then
            nreal=nreal+isize
            if(ksteer.eq.2) nreal_st=nreal_st+isize
         else if(ztype.eq.'I') then
            nint=nint+isize
            if(ksteer.eq.2) nint_st=nint_st+isize
         else if(ztype.eq.'L') then
            nlog=nlog+isize
            if(ksteer.eq.2) nlog_st=nlog_st+isize
         else if(ztype.eq.'D') then
            nr8=nr8+isize
            if(ksteer.eq.2) nr8_st=nr8_st+isize
         else if(ztype(1:1).eq.'C') then
            nchv=nchv+isize
            if(ksteer.eq.2) nchv_st=nchv_st+isize
         else
            call errmsg_exit( &
                 '?splitn_module: namelist database: uknown type: '//ztype)
         endif
         if(len_trim(zdflt).gt.len_short) then
            nlong=nlong+1
         endif
      enddo

      nreal=max(1,nreal)
      nr8=max(1,nr8)
      nlog=max(1,nlog)
      nint=max(1,nint)
      nchv=max(1,nchv)

      jreal=nreal + nupdate_max*nreal_st
      jr8=nr8 + nupdate_max*nr8_st
      jlog=nlog + nupdate_max*nlog_st
      jint=nint + nupdate_max*nint_st
      jchv=nchv + nupdate_max*nchv_st

      ! OK: have sizes, now allocate and initialize storage arrays

      allocate(intbuf(jint),logbuf(jlog),rbuf(jreal),dbuf(jr8))
      intbuf=0
      logbuf=.FALSE.
      rbuf=0
      dbuf=0
      allocate(chbuf(jchv),long_dflts(nlong)); chbuf=' '; long_dflts=' '
      allocate(varlist(nvars),var_order(nvars)); var_order=0
      allocate(ilines(jreal+jint+jlog+jr8+jchv)); ilines=0
      allocate(ivrange(2,jreal+jint+jlog+jr8+jchv)); ivrange=0
      allocate(krepeat(jreal+jint+jlog+jr8+jchv)); krepeat=0
      allocate(irrange(2,jreal+jint+jlog+jr8+jchv)); irrange=0
      allocate(dnames(nvars)); dnames=' '; ndnames=0

      allocate(iline_stack(2,jreal+jint+jlog+jr8+jchv))

      do i=1,nvars
         varlist(i)%name=' '
         varlist(i)%type=' '
         varlist(i)%naml=' '
         varlist(i)%steerable=0
         varlist(i)%chsize=0
         varlist(i)%rank=0
         varlist(i)%dims=0
         varlist(i)%short_dflt=' '
         varlist(i)%long_dflt_addr=0
         varlist(i)%addr=0
         varlist(i)%nlinadr=0
         varlist(i)%addr_st=0
         varlist(i)%nlinadr_st=0
      enddo

      ivars=0
      ilog=1   ! for data of various types...
      iint=1
      ichv=1
      ireal=1
      ir8=1

      ilong=1  ! for long default strings

      ilinp=1  ! for namelist file line ptrs

      ilog_st=1   ! for data of various types w/in update blocks
      iint_st=1
      ichv_st=1
      ireal_st=1
      ir8_st=1

      ilinp_st=1

      !-------------------
      ! insert splitn-defined variable

      ivars = ivars + 1
      zname = '~UPDATE_TIME'
      ksteer=3    ! special for (splitn)
      ztype='D'
      ichsize=0
      iirank=0
      iidims=0
      zdflt = '654.3d210'

      varlist(ivars)%name=zname
      call insert_var(ivars)   ! maintain alphabetic order
      varlist(ivars)%steerable = ksteer
      varlist(ivars)%type=ztype
      varlist(ivars)%chsize=ichsize
      varlist(ivars)%naml='(splitn)'
      varlist(ivars)%rank=iirank
      varlist(ivars)%dims=iidims
      varlist(ivars)%short_dflt=zdflt(1:len_short)

      isize=1
      ivecsz=1
      varlist(ivars)%addr=ir8
      varlist(ivars)%nlinadr=ilinp
      varlist(ivars)%addr_st=ir8_st
      varlist(ivars)%nlinadr_st=ilinp_st

      call dset_dflt(dbuf(ir8:ir8+isize-1),isize,ivecsz,ivars)
      call dset_ucop(dbuf,ir8,isize,ir8_st,0,0,nupdate_max)

      tlarge = dbuf(ir8)  ! make sure this matches decode

      ir8 = ir8 + isize
      ir8_st = ir8_st + isize
      ilinp = ilinp + isize
      ilinp_st = ilinp_st + isize

      tup=tlarge; tup_d=tlarge; tup_w=tlarge; tup_p=tlarge

      !-------------------
      ! now rewind & reread file; capturing information

      rewind lun

      do 
         read(lun,'(A)',iostat=ios) iline
         if(ios.ne.0) exit

         j=0
         do i=1,len(iline)
            if((iline(i:i).ne.' ').and.(iline.ne.char(9))) then
               j=i
               exit  ! non-whitespace found
            endif
         enddo
         if(j.eq.0) cycle   ! ignore all-blank line

         if(iline(j:j).eq.'#') cycle   ! ignore comment line

         if(iline(j:j).eq.'*') then
            ! start new namelist; record length of prior list
            imaxlen_naml = max(imaxlen_naml,ilen_naml)
            ilen_naml = 0

            cur_naml=iline(j+1:j+len(cur_naml))  ! set current namelist 
            call addlist
            cycle
         endif

         ivars=ivars+1
         call read1_db(iline,j,zname,ksteer,ztype,ichsize,iirank,iidims,zdflt)

         varlist(ivars)%name=zname
         call insert_var(ivars)   ! maintain alphabetic order
         varlist(ivars)%steerable=ksteer
         varlist(ivars)%type=ztype
         varlist(ivars)%chsize=ichsize
         ilen_naml = ilen_naml + 1
         varlist(ivars)%naml=cur_naml
         varlist(ivars)%rank=iirank
         varlist(ivars)%dims=iidims
         if(len_trim(zdflt).gt.len_short) then
            long_dflts(ilong)=zdflt
            varlist(ivars)%long_dflt_addr=ilong
            ilong=ilong+1
         else
            varlist(ivars)%short_dflt=zdflt(1:len_short)
         endif
            
         isize=igsize(iirank,iidims)

         varlist(ivars)%nlinadr=ilinp
         ilinp=ilinp+isize
         if(ksteer.eq.2) then
            varlist(ivars)%nlinadr_st = ilinp_st
            ilinp_st=ilinp_st+isize
         endif

         ivecsz=iidims(2,1)-iidims(1,1)+1
         if(ztype.eq.'R') then
            varlist(ivars)%addr=ireal
            call rset_dflt(rbuf(ireal:ireal+isize-1),isize,ivecsz,ivars)
            if(ksteer.eq.2) then
               varlist(ivars)%addr_st = ireal_st
               call rset_ucop(rbuf,ireal,isize,ireal_st,0,0,nupdate_max)
               ireal_st=ireal_st+isize
            endif
            ireal=ireal+isize
         else if(ztype.eq.'I') then
            varlist(ivars)%addr=iint
            call iset_dflt(intbuf(iint:iint+isize-1),isize,ivecsz,ivars)
            if(ksteer.eq.2) then
               varlist(ivars)%addr_st = iint_st
               call iset_ucop(intbuf,iint,isize,iint_st,0,0,nupdate_max)
               iint_st=iint_st+isize
            endif
            iint=iint+isize
         else if(ztype.eq.'L') then
            varlist(ivars)%addr=ilog
            call lset_dflt(logbuf(ilog:ilog+isize-1),isize,ivecsz,ivars)
            if(ksteer.eq.2) then
               varlist(ivars)%addr_st = ilog_st
               call lset_ucop(logbuf,ilog,isize,ilog_st,0,0,nupdate_max)
               ilog_st=ilog_st+isize
            endif
            ilog=ilog+isize
         else if(ztype.eq.'D') then
            varlist(ivars)%addr=ir8
            call dset_dflt(dbuf(ir8:ir8+isize-1),isize,ivecsz,ivars)
            if(ksteer.eq.2) then
               varlist(ivars)%addr_st = ir8_st
               call dset_ucop(dbuf,ir8,isize,ir8_st,0,0,nupdate_max)
               ir8_st=ir8_st+isize
            endif

            ! capture default TINIT
            if(varlist(ivars)%name.eq.'TINIT') then
               tinit=dbuf(ir8)
               tinit_d=tinit
               tinit_w=tinit
               tinit_p=tinit
            endif

            ir8=ir8+isize
         else if(ztype(1:1).eq.'C') then
            varlist(ivars)%addr=ichv
            allocate(chtmp(ivecsz)); chtmp=' '
            call chset_dflt(chbuf(ichv:ichv+isize-1),chtmp, &
                 isize,ivecsz,ivars)
            deallocate(chtmp)
            if(ksteer.eq.2) then
               varlist(ivars)%addr_st = ichv_st
               call chset_ucop(chbuf,ichv,isize,ichv_st,0,0,nupdate_max)
               ichv_st=ichv_st+isize
            endif
            ichv=ichv+isize
         endif

      enddo

      ios=0
      close(unit=lun)

      ! allocate and save copies of default values;
      ! the originals intbuf, etc., will be modified when a real namelist
      ! is read in.

      allocate(logbuf_d(jlog),intbuf_d(jint))
      allocate(rbuf_d(jreal),dbuf_d(jr8))
      allocate(chbuf_d(jchv))

      logbuf_d=logbuf
      intbuf_d=intbuf
      rbuf_d=rbuf
      dbuf_d=dbuf
      chbuf_d=chbuf

      ! allocate write buffers -- to support program driven namelist
      ! editing operations

      allocate(logbuf_w(jlog),intbuf_w(jint))
      allocate(rbuf_w(jreal),dbuf_w(jr8))
      allocate(chbuf_w(jchv))

      logbuf_w=.FALSE.
      intbuf_w=0
      rbuf_w=0
      dbuf_w=0
      chbuf_w=' '

      ! allocate "previous" buffers -- to support comparison-of-namelist
      ! operations

      allocate(logbuf_p(jlog),intbuf_p(jint))
      allocate(rbuf_p(jreal),dbuf_p(jr8))
      allocate(chbuf_p(jchv))

      logbuf_p=.FALSE.
      intbuf_p=0
      rbuf_p=0
      dbuf_p=0
      chbuf_p=' '

      previous = .FALSE.

      ! compile data on namelist-by-namelist basis

      allocate(num_naml_vars(nnamls),num_naml_vars_st(nnamls))
      allocate(indx_naml_vars(imaxlen_naml,nnamls))
      allocate(indx_naml_vars_st(imaxlen_naml,nnamls))

      num_naml_vars = 0
      num_naml_vars_st = 0

      indx_naml_vars = 0
      indx_naml_vars_st = 0

      do i=1,nvars
         j=var_order(i)
         if(varlist(j)%steerable.eq.3) cycle  ! skip ~UPDATE_TIME variable

         cur_naml=varlist(j)%naml
         inaml = 0
         do ii=1,nnamls
            if(cur_naml.eq.all_namls(ii)) then
               inaml=ii
               exit
            endif
         enddo

         if(inaml.eq.0) then
            write(6,*) ' ?splitn -- failed to locate namelist association for:'
            write(6,*) '  ',varlist(j)%name
         endif

         ii = num_naml_vars(inaml) + 1
         indx_naml_vars(ii,inaml) = j
         num_naml_vars(inaml) = ii

         if(varlist(j)%steerable .eq. 2) then
            ii = num_naml_vars_st(inaml) + 1
            indx_naml_vars_st(ii,inaml) = j
            num_naml_vars_st(inaml) = ii
         endif
      enddo

      !  DMC Apr 2011 -- add list of known deleted names
      nlfile='nx_deleted.dat'

      ilf=len_trim(nlfile)

      open(unit=lun,file=nlfile(1:ilf),status='old', &
           action='READ',iostat=ios2)

      if (ios2.ne.0) then
         call ufilnam('CONFIGDIR','nx_deleted.dat',nlfile)
         ilf=len_trim(nlfile)

         open(unit=lun,file=nlfile(1:ilf),status='old', &
              action='READ',iostat=ios2)
      endif
      if(ios2.ne.0) then
         call ufilnam('NTCCHOME','bin/nx_deleted.dat',nlfile)
         ilf=len_trim(nlfile)
         open(unit=lun,file=nlfile(1:ilf), &
              status='old',iostat=ios2)
      endif
      if(ios2.ne.0) then
         call ufilnam('TRANSP_LOCATION','nx_deleted.dat',nlfile)
         ilf=len_trim(nlfile)
         open(unit=lun,file=nlfile(1:ilf), &
              status='old',iostat=ios2)
      endif

      ! failure to open file results in warning only
      if(ios2.ne.0) then
         write(6,*) &
              ' %splitn: deleted names file "nx_deleted.dat" not found (OK).'
      else
         do
            iline = ' '
            read(lun,'(A)',iostat=ios2) iline
            if(ios2.ne.0) exit

            iline = adjustl(trim(iline))
            if(iline(1:1).eq.'#') cycle

            if(iline.eq.' ') cycle

            ndnames = ndnames + 1
            dnames(ndnames) = trim(iline)
            call uupper(dnames(ndnames))

            call iorder(dnames(ndnames),ibefore,imatch)
            if(imatch.eq.1) then
               write(6,*) &
                    ' %splitn: deleted name restored to namelist: ', &
                    trim(dnames(ndnames))
               dnames(ndnames)=' '
               ndnames = ndnames - 1
            endif

         enddo

         close(unit=lun)
      endif

    end subroutine read_db

    integer function igsize(iirank,iidims)
      
      ! calculate size of object

      integer,intent(in) :: iirank   ! rank of object
      integer,intent(in) :: iidims(2,*) ! dimensioning info

      integer idim

      !-----------------

      igsize=1
      if(iirank.eq.0) return

      do idim=1,iirank
         igsize=igsize*(iidims(2,idim)-iidims(1,idim)+1)
      enddo
    end function igsize

    !--------
    subroutine insert_var(ivars)

      integer, intent(in) :: ivars

      ! maintain alphabetic ordering of namelist variables

      integer :: ibefore,imatch,isave,ii

      !--------------------
      isave=nvars    ! save total no. of vars
      nvars=ivars-1  ! this is the no. currently known

      call iorder(varlist(ivars)%name,ibefore,imatch)  ! position this name
      if(imatch.eq.1) then
         call errmsg_exit( &
              ' ?splitn_module: namelist database: duplicate name: '// &
              varlist(ivars)%name)
      else
         do ii=nvars,ibefore,-1
            var_order(ii+1)=var_order(ii)
         enddo
         var_order(ibefore)=ivars
      endif

      nvars=isave   ! restore total no.

    end subroutine insert_var

    subroutine iorder(zname,ibefore,imatch)

      character*(*), intent(in) :: zname  ! name to find
      integer, intent(out) :: ibefore     ! position found
      integer, intent(out) :: imatch      ! =1 if exact match

      character*32 znam32
      integer jj,imin,imax,itry

      !---------------------------------------------

      imatch=0
      ibefore=0

      znam32=zname

      if(nvars.eq.0) then
         ibefore=1
      else 
         jj=var_order(nvars)
         if(znam32.gt.varlist(jj)%name) ibefore=nvars+1
      endif

      if(ibefore.eq.0) then

         ! binary search

         imin=1
         imax=nvars

         do
            if(imin.eq.imax) then
               ibefore=imin
               jj=var_order(imin)
               if(znam32.eq.varlist(jj)%name) imatch=1
               exit
            endif

            itry=(imin+imax)/2

            jj=var_order(itry)
            if(znam32.le.varlist(jj)%name) then
               imax=itry
            else
               imin=itry+1
            endif
         enddo

      endif
    end subroutine iorder

    !--------
    ! routines to set namelist default values in data buffers

    subroutine set_zdflt(ivar,zdflt,ildflt)

      ! get default string for specified namelist variable (whether
      ! long or short form)

      integer, intent(in) :: ivar           ! the namelist item index
      character*(*), intent(out) :: zdflt   ! the fetched string
      integer, intent(out) :: ildflt        ! non-blank length of string

      !---------------------

      if(varlist(ivar)%long_dflt_addr.gt.0) then
         zdflt=long_dflts(varlist(ivar)%long_dflt_addr)
         ildflt=len_trim(zdflt)
      else
         ildflt=len_trim(varlist(ivar)%short_dflt)
         zdflt(1:ildflt)=varlist(ivar)%short_dflt(1:ildflt)
         zdflt(ildflt+1:ildflt+1)=' '
      endif

    end subroutine set_zdflt


    subroutine rset_dflt(ra,ina,iblk,ivar)

      integer, intent(in) :: ina         ! size of array to reset
      real, intent(out) :: ra(ina)       ! the array
      integer, intent(in) :: iblk        ! set iblk array elements at a time
      integer, intent(in) :: ivar        ! variable owning these defaults

      !-------------------------------

      character*20 ibuf
      real blk(iblk),ztmp

      character*512 zdflt
      integer ildflt

      integer i,ios,inum,icomma,icprev

      !-------------------------------

      ! set default string

      call set_zdflt(ivar,zdflt,ildflt)

      ! get value(s) for one block

      icomma=0
      call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
      if(icomma.gt.ildflt) then
         ! just one value to decode
         ibuf=' '
         ibuf(20-ildflt+1:20)=zdflt(1:ildflt)
         call uupper(ibuf)
         if(ibuf(18:20).EQ.'_R8') then
            read(ibuf(1:17),'(G17.0)',iostat=ios) ztmp
         else
            read(ibuf,'(G20.0)',iostat=ios) ztmp
         endif
         if(ios.eq.0) blk(1:iblk)=ztmp
      else
         do i=1,iblk
            inum=icomma-1-icprev
            ibuf=' '
            ibuf(20-inum+1:20)=zdflt(icprev+1:icomma-1)
            call uupper(ibuf)
            if(ibuf(18:20).EQ.'_R8') then
               read(ibuf(1:17),'(G17.0)',iostat=ios) ztmp
            else
               read(ibuf,'(G20.0)',iostat=ios) ztmp
            endif
            if(ios.ne.0) exit
            blk(i)=ztmp
            if(i.lt.iblk) then
               ! char position of next comma-delimiter
               call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
            endif
         enddo
      endif
      if(ios.ne.0) then
         call errmsg_exit( &
              ' ?splitn_module: unexpected decode error: '//zdflt(1:ildflt))
      endif

      ! apply block to whole array

      do i=1,ina,iblk
         ra(i:i+iblk-1)=blk(1:iblk)
      enddo

    end subroutine rset_dflt

    subroutine dset_dflt(ra,ina,iblk,ivar)

      integer, intent(in) :: ina         ! size of array to reset
      real*8, intent(out) :: ra(ina)     ! the array
      integer, intent(in) :: iblk        ! set iblk array elements at a time
      integer, intent(in) :: ivar        ! variable owning these defaults

      !-------------------------------

      character*20 ibuf
      real*8 blk(iblk),ztmp

      character*512 zdflt
      integer ildflt

      integer i,ios,inum,icomma,icprev

      !-------------------------------

      ! set default string

      call set_zdflt(ivar,zdflt,ildflt)

      ! get value(s) for one block

      icomma=0
      call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
      if(icomma.gt.ildflt) then
         ! just one value to decode
         ibuf=' '
         ibuf(20-ildflt+1:20)=zdflt(1:ildflt)
         call uupper(ibuf)
         if(ibuf(18:20).EQ.'_R8') then
            read(ibuf(1:17),'(G17.0)',iostat=ios) ztmp
         else
            read(ibuf,'(G20.0)',iostat=ios) ztmp
         endif
         if(ios.eq.0) blk(1:iblk)=ztmp
      else
         do i=1,iblk
            inum=icomma-1-icprev
            ibuf=' '
            ibuf(20-inum+1:20)=zdflt(icprev+1:icomma-1)
            call uupper(ibuf)
            if(ibuf(18:20).EQ.'_R8') then
               read(ibuf(1:17),'(G17.0)',iostat=ios) ztmp
            else
               read(ibuf,'(G20.0)',iostat=ios) ztmp
            endif
            if(ios.ne.0) exit
            blk(i)=ztmp
            if(i.lt.iblk) then
               ! char position of next comma-delimiter
               call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
            endif
         enddo
      endif
      if(ios.ne.0) then
         call errmsg_exit( &
              ' ?splitn_module: unexpected decode error: '//zdflt(1:ildflt))
      endif

      ! apply block to whole array

      do i=1,ina,iblk
         ra(i:i+iblk-1)=blk(1:iblk)
      enddo

    end subroutine dset_dflt

    subroutine iset_dflt(ra,ina,iblk,ivar)

      integer, intent(in) :: ina         ! size of array to reset
      integer, intent(out) :: ra(ina)    ! the array
      integer, intent(in) :: iblk        ! set iblk array elements at a time
      integer, intent(in) :: ivar        ! variable owning these defaults

      !-------------------------------

      character*20 ibuf
      integer blk(iblk),ztmp

      character*512 zdflt
      integer ildflt

      integer i,ios,inum,icomma,icprev

      !-------------------------------

      ! set default string

      call set_zdflt(ivar,zdflt,ildflt)

      ! get value(s) for one block

      icomma=0
      call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
      if(icomma.gt.ildflt) then
         ! just one value to decode
         ibuf=' '
         ibuf(20-ildflt+1:20)=zdflt(1:ildflt)
         read(ibuf,'(I20)',iostat=ios) ztmp
         if(ios.eq.0) blk(1:iblk)=ztmp
      else
         do i=1,iblk
            inum=icomma-1-icprev
            ibuf=' '
            ibuf(20-inum+1:20)=zdflt(icprev+1:icomma-1)
            read(ibuf,'(I20)',iostat=ios) ztmp
            if(ios.ne.0) exit
            blk(i)=ztmp
            if(i.lt.iblk) then
               ! char position of next comma-delimiter
               call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
            endif
         enddo
      endif
      if(ios.ne.0) then
         call errmsg_exit( &
              ' ?splitn_module: unexpected decode error: '//zdflt(1:ildflt))
      endif

      ! apply block to whole array

      do i=1,ina,iblk
         ra(i:i+iblk-1)=blk(1:iblk)
      enddo

    end subroutine iset_dflt

    subroutine lset_dflt(ra,ina,iblk,ivar)

      integer, intent(in) :: ina         ! size of array to reset
      logical, intent(out) :: ra(ina)    ! the array
      integer, intent(in) :: iblk        ! set iblk array elements at a time
      integer, intent(in) :: ivar        ! variable owning these defaults

      !-------------------------------

      character*20 ibuf
      logical blk(iblk),ztmp

      character*512 zdflt
      integer ildflt

      integer i,ios,inum,icomma,icprev

      !-------------------------------

      ! set default string

      call set_zdflt(ivar,zdflt,ildflt)

      ! get value(s) for one block

      icomma=0
      call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
      if(icomma.gt.ildflt) then
         ! just one value to decode
         ibuf=' '
         ibuf(20-ildflt+1:20)=zdflt(1:ildflt)
         read(ibuf,'(L20)',iostat=ios) ztmp
         if(ios.eq.0) blk(1:iblk)=ztmp
      else
         do i=1,iblk
            inum=icomma-1-icprev
            ibuf=' '
            ibuf(20-inum+1:20)=zdflt(icprev+1:icomma-1)
            read(ibuf,'(L20)',iostat=ios) ztmp
            if(ios.ne.0) exit
            blk(i)=ztmp
            if(i.lt.iblk) then
               ! char position of next comma-delimiter
               call icomma_get('R',icprev,icomma,zdflt(1:ildflt))
            endif
         enddo
      endif
      if(ios.ne.0) then
         call errmsg_exit( &
              ' ?splitn_module: unexpected decode error: '//zdflt(1:ildflt))
      endif

      ! apply block to whole array

      do i=1,ina,iblk
         ra(i:i+iblk-1)=blk(1:iblk)
      enddo

    end subroutine lset_dflt

    subroutine chset_dflt(cha,chblk,ina,iblk,ivar)

      integer, intent(in) :: ina         ! size of array to reset
      character*(*), intent(inout) :: cha(ina)       ! the array
      integer, intent(in) :: iblk        ! set iblk array elements at a time
      character*(*), intent(inout) :: chblk(iblk)    ! a sub-block
      integer, intent(in) :: ivar        ! naml. variable owning these defaults

      !-------------------------------

      character*512 zdflt
      integer ildflt

      integer i,j,ios,inum,icomma,icprev

      !-------------------------------

      ! set default string

      call set_zdflt(ivar,zdflt,ildflt)

      ! get value(s) for one block

      icomma=0
      call icomma_get('C',icprev,icomma,zdflt(1:ildflt))
      if(icomma.gt.ildflt) then
         ! just one value to decode
         ! do not include quotes
         chblk(1:iblk)(1:ildflt-2)=zdflt(2:ildflt-1)
      else
         do i=1,iblk
            inum=icomma-icprev-3
            chblk(i)(1:inum)=zdflt(icprev+2:icomma-2)
            if(i.lt.iblk) then
               ! char position of next comma-delimiter
               call icomma_get('C',icprev,icomma,zdflt(1:ildflt))
            endif
         enddo
      endif

      ! apply block to whole array

      do i=1,ina,iblk
         cha(i:i+iblk-1)=chblk(1:iblk)
      enddo

    end subroutine chset_dflt

    subroutine rset_ucop(buf,isource,inum,itarg,ilin0,inum0,inmax)

      ! propagate values into update blocks

      real, dimension(:) :: buf
      integer :: isource,inum  ! loc & number to copy
      integer :: itarg         ! loc of 1st copy
      integer :: ilin0         ! if .gt.0: check ilines 
      ! (stop propagation of update copy if text line sets a value)

      integer :: inum0         ! .gt.0: copy from update block instead of main
      integer :: inmax         ! index of last copy

      !--------------
      ! local:
      integer :: ii,inc,ism1,itarg_loc,itarg_lin,iinc_lin
      logical, dimension(:), allocatable :: icopy
      logical :: icontin
      !--------------

      allocate(icopy(inum)); icopy=.TRUE.
      icontin=.TRUE.

      if(inum0.eq.0) then
         ism1 = isource-1
      else
         ism1 = nreal + (inum0-1)*nreal_st + itarg - 1
      endif

      itarg_loc = nreal + (inum0-1)*nreal_st + itarg - 1  ! incremented...

      if(ilin0.eq.0) then
         itarg_lin=0
      else
         iinc_lin = nreal_st+nint_st+nlog_st+nr8_st+nchv_st
         itarg_lin = nreal+nint+nlog+nr8+nchv + (inum0-1)*iinc_lin + ilin0 - 1
      endif

      do ii=inum0+1,inmax
         if(ilin0.gt.0) then
            itarg_lin = itarg_lin + iinc_lin
            icontin=.FALSE.
            do inc=1,inum
               if(ilines(itarg_lin+inc).gt.0) icopy(inc)=.FALSE.
               icontin=icontin.or.icopy(inc)
            enddo
         endif
         if(.not.icontin) exit

         itarg_loc = itarg_loc+nreal_st
         do inc=1,inum
            if(icopy(inc)) then
               buf(itarg_loc+inc) = buf(ism1+inc)
            endif
         enddo
      enddo

    end subroutine rset_ucop

    subroutine dset_ucop(buf,isource,inum,itarg,ilin0,inum0,inmax)

      ! propagate values into update blocks

      real*8, dimension(:) :: buf
      integer :: isource,inum  ! loc & number to copy
      integer :: itarg         ! loc of 1st copy
      integer :: ilin0         ! if .gt.0: check ilines 
      ! (stop propagation of update copy if text line sets a value)

      integer :: inum0         ! .gt.0: copy from update block instead of main
      integer :: inmax         ! update block index of last copy

      !--------------
      ! local:
      integer :: ii,inc,ism1,itarg_loc,itarg_lin,iinc_lin
      logical, dimension(:), allocatable :: icopy
      logical :: icontin
      !--------------

      allocate(icopy(inum)); icopy=.TRUE.
      icontin=.TRUE.

      if(inum0.eq.0) then
         ism1 = isource-1
      else
         ism1 = nr8 + (inum0-1)*nr8_st + itarg - 1
      endif

      itarg_loc = nr8 + (inum0-1)*nr8_st + itarg - 1  ! incremented...

      if(ilin0.eq.0) then
         itarg_lin=0
      else
         iinc_lin = nreal_st+nint_st+nlog_st+nr8_st+nchv_st
         itarg_lin = nreal+nint+nlog+nr8+nchv + (inum0-1)*iinc_lin + ilin0 - 1
      endif

      do ii=inum0+1,inmax
         if(ilin0.gt.0) then
            itarg_lin = itarg_lin + iinc_lin
            icontin=.FALSE.
            do inc=1,inum
               if(ilines(itarg_lin+inc).gt.0) icopy(inc)=.FALSE.
               icontin=icontin.or.icopy(inc)
            enddo
         endif
         if(.not.icontin) exit

         itarg_loc = itarg_loc+nr8_st
         do inc=1,inum
            if(icopy(inc)) then
               buf(itarg_loc+inc) = buf(ism1+inc)
            endif
         enddo
     enddo

    end subroutine dset_ucop

    subroutine iset_ucop(buf,isource,inum,itarg,ilin0,inum0,inmax)

      ! propagate values into update blocks

      integer, dimension(:) :: buf
      integer :: isource,inum  ! loc & number to copy
      integer :: itarg         ! loc of 1st copy
      integer :: ilin0         ! if .gt.0: check ilines 
      ! (stop propagation of update copy if text line sets a value)

      integer :: inum0         ! .gt.0: copy from update block instead of main
      integer :: inmax         ! index of last copy

      !--------------
      ! local:
      integer :: ii,inc,ism1,itarg_loc,itarg_lin,iinc_lin
      logical, dimension(:), allocatable :: icopy
      logical :: icontin
      !--------------

      allocate(icopy(inum)); icopy=.TRUE.
      icontin=.TRUE.

      if(inum0.eq.0) then
         ism1 = isource-1
      else
         ism1 = nint + (inum0-1)*nint_st + itarg - 1
      endif

      itarg_loc = nint + (inum0-1)*nint_st + itarg - 1  ! incremented...

      if(ilin0.eq.0) then
         itarg_lin=0
      else
         iinc_lin = nreal_st+nint_st+nlog_st+nr8_st+nchv_st
         itarg_lin = nreal+nint+nlog+nr8+nchv + (inum0-1)*iinc_lin + ilin0 - 1
      endif

      do ii=inum0+1,inmax
         if(ilin0.gt.0) then
            itarg_lin = itarg_lin + iinc_lin
            icontin=.FALSE.
            do inc=1,inum
               if(ilines(itarg_lin+inc).gt.0) icopy(inc)=.FALSE.
               icontin=icontin.or.icopy(inc)
            enddo
         endif
         if(.not.icontin) exit

         itarg_loc = itarg_loc+nint_st
         do inc=1,inum
            if(icopy(inc)) then
               buf(itarg_loc+inc) = buf(ism1+inc)
            endif
         enddo
      enddo

    end subroutine iset_ucop

    subroutine lset_ucop(buf,isource,inum,itarg,ilin0,inum0,inmax)

      ! propagate values into update blocks

      logical, dimension(:) :: buf
      integer :: isource,inum  ! loc & number to copy
      integer :: itarg         ! loc of 1st copy
      integer :: ilin0         ! if .gt.0: check ilines 
      ! (stop propagation of update copy if text line sets a value)

      integer :: inum0         ! .gt.0: copy from update block instead of main
      integer :: inmax         ! index of last copy

      !--------------
      ! local:
      integer :: ii,inc,ism1,itarg_loc,itarg_lin,iinc_lin
      logical, dimension(:), allocatable :: icopy
      logical :: icontin
      !--------------

      allocate(icopy(inum)); icopy=.TRUE.
      icontin=.TRUE.

      if(inum0.eq.0) then
         ism1 = isource-1
      else
         ism1 = nlog + (inum0-1)*nlog_st + itarg - 1
      endif

      itarg_loc = nlog + (inum0-1)*nlog_st + itarg - 1  ! incremented...

      if(ilin0.eq.0) then
         itarg_lin=0
      else
         iinc_lin = nreal_st+nint_st+nlog_st+nr8_st+nchv_st
         itarg_lin = nreal+nint+nlog+nr8+nchv + (inum0-1)*iinc_lin + ilin0 - 1
      endif

      do ii=inum0+1,inmax
         if(ilin0.gt.0) then
            itarg_lin = itarg_lin + iinc_lin
            icontin=.FALSE.
            do inc=1,inum
               if(ilines(itarg_lin+inc).gt.0) icopy(inc)=.FALSE.
               icontin=icontin.or.icopy(inc)
            enddo
         endif
         if(.not.icontin) exit

         itarg_loc = itarg_loc+nlog_st
         do inc=1,inum
            if(icopy(inc)) then
               buf(itarg_loc+inc) = buf(ism1+inc)
            endif
         enddo
      enddo

    end subroutine lset_ucop

    subroutine chset_ucop(buf,isource,inum,itarg,ilin0,inum0,inmax)

      ! propagate values into update blocks

      character*128, dimension(:) :: buf
      integer :: isource,inum  ! loc & number to copy
      integer :: itarg         ! loc of 1st copy
      integer :: ilin0         ! if .gt.0: check ilines 
      ! (stop propagation of update copy if text line sets a value)

      integer :: inum0         ! .gt.0: copy from update block instead of main
      integer :: inmax         ! index of last copy

      !--------------
      ! local:
      integer :: ii,inc,ism1,itarg_loc,itarg_lin,iinc_lin
      logical, dimension(:), allocatable :: icopy
      logical :: icontin
      !--------------

      allocate(icopy(inum)); icopy=.TRUE.
      icontin=.TRUE.

      if(inum0.eq.0) then
         ism1 = isource-1
      else
         ism1 = nchv + (inum0-1)*nchv_st + itarg - 1
      endif

      itarg_loc = nchv + (inum0-1)*nchv_st + itarg - 1  ! incremented...

      if(ilin0.eq.0) then
         itarg_lin=0
      else
         iinc_lin = nreal_st+nint_st+nlog_st+nr8_st+nchv_st
         itarg_lin = nreal+nint+nlog+nr8+nchv + (inum0-1)*iinc_lin + ilin0 - 1
      endif

      do ii=inum0+1,inmax
         if(ilin0.gt.0) then
            itarg_lin = itarg_lin + iinc_lin
            icontin=.FALSE.
            do inc=1,inum
               if(ilines(itarg_lin+inc).gt.0) icopy(inc)=.FALSE.
               icontin=icontin.or.icopy(inc)
            enddo
         endif
         if(.not.icontin) exit

         itarg_loc = itarg_loc+nchv_st
         do inc=1,inum
            if(icopy(inc)) then
               buf(itarg_loc+inc) = buf(ism1+inc)
            endif
         enddo
      enddo

    end subroutine chset_ucop

    subroutine icomma_get(ztype,icprev,icomma,dstr)

      character*1, intent(in) :: ztype   ! "C" -- character, o.w. non-character
      integer, intent(out) :: icprev     ! previous comma location
      integer, intent(inout) :: icomma   ! next comma location (updated)
      character*(*) dstr                 ! default string

      ! find comma separating fields;
      ! if type is "C" also check for enclosing quotes & ignore commas
      ! inside quoted strings.

      character*1 qchar
      integer i,ild

      ild=len(dstr)

      icprev=icomma
      if(ztype.ne.'C') then

         ! non-character string defaults -- look for comma directly.

         icomma=index(dstr(icprev+1:),',')
         if(icomma.le.0) then
            icomma=ild+1
         else
            icomma=icprev+icomma
         endif
         return

      endif

      ! deal with case of character string defaults

      i=icprev+1
      if((dstr(i:i).ne."'").and.(dstr(i:i).ne.'"')) then
         call errmsg_exit( &
              ' ?splitn_module: expected quote character at start or after'// &
              ' comma: '//dstr)
      endif

      qchar=dstr(i:i)
      do
         i=i+1
         if(i.eq.ild) then
            if(dstr(i:i).ne.qchar) then
               call errmsg_exit( &
                    ' ?splitn_module: namelist database: no closing quote: '//&
                    dstr)
            else
               icomma=ild+1
               exit
            endif
         endif
         if(dstr(i:i).eq.qchar) then
            if(dstr(i+1:i+1).eq.',') then
               icomma=i+1
               exit
            else
               call errmsg_exit( &
                    ' ?splitn_module: expected comma after closing quote: '//&
                    dstr)
            endif
         endif
      enddo
    end subroutine icomma_get

    subroutine read1_db(iline,istart,zname, &
         ksteer,ztype,ichsize,iirank,iidims,zdflt)

      ! parse a line from the database; read continuation lines to
      ! complete parsing if necessary.

      ! error checking is minimal: the database is supposed to have
      ! been written by code generators that have been well debugged.

      character*(*), intent(inout) :: iline   ! input line
      integer, intent(in) :: istart           ! 1st non-blank char in iline

      character*(*), intent(out) :: zname     ! name of namelist variable
      integer, intent(out) :: ksteer          ! T if item is steerable
      character*(*), intent(out) :: ztype     ! type of namelist variable
      integer, intent(out) :: ichsize         ! size of C*nn vars
                                              ! for non-char data: ichsize=0
      integer, intent(out) :: iirank          ! rank (dimensionality) of var.
      integer, intent(out) :: iidims(2,4)     ! actual dimensions
      character*(*), intent(out) :: zdflt     ! namelist var. default values

      !------------------------------------------------
      integer :: ifld   ! field ctr
      integer :: ist    ! start of field
      integer :: ilast_fld  ! last field count (default string)
      integer i,inc,ilen
      integer idim,ic1,ic2,il,icolon,ilz
      character*10 ibuf
      !------------------------------------------------

      iirank=0
      iidims=0
      ichsize=0

      ist=istart
      ifld=0

      ilen=len(iline)

      do
         ! loop over fields

         i=ist

         do
            ! loop over characters: find whitespace
            i=i+1
            if(iline(i:i).eq.' ') exit
            if(iline(i:i).eq.char(9)) exit
            if(i.eq.ilen) then
               call errmsg_exit(' ?splitn_module: missing fields: '//iline)
            endif
         enddo

         ifld = ifld+1
         if(ifld.eq.1) then
            ! name field
            zname=iline(ist:i-1)
            call uupper(zname)

         else if(ifld.eq.2) then
            ! type field (R/I/L/D/C*n)
            ! steerability flag added (dmc Aug 2005)

            ksteer=0
            if(iline(ist:ist).eq.'~') then
               if(cur_naml(1:3).eq.'TRN') then
                  ksteer=2
               else
                  ksteer=1
               endif
               ist=ist+1
            endif

            if(i.gt.(ist+5)) then
               call errmsg_exit(' ?splitn_module: error in type field: '// &
                    iline)
            endif
            ztype=iline(ist:i-1)
            if(ztype(1:2).eq.'C*') then
               ! get size n of C*n variable
               if(i.eq.(ist+3)) then
                  read(iline(ist+2:ist+2),'(I1)') inc
               else if(i.eq.(ist+4)) then
                  read(iline(ist+2:ist+3),'(I2)') inc
               else if(i.eq.(ist+5)) then
                  read(iline(ist+2:ist+4),'(I3)') inc
               endif
               if((inc.le.0).or.(inc.gt.ch_maxlen)) then
                  call errmsg_exit( &
                       ' ?splitn_module: C*n: n<0 or n>ch_maxlen: '//iline)
               endif
               ichsize = inc
            endif

         else if(ifld.eq.3) then
            if(i.gt.ist+1) then
               call errmsg_exit(' ?splitn_module: error in rank field: '// &
                    iline)
            else
               read(iline(i-1:i-1),'(I1)') iirank
               if(iirank.gt.4) THEN
                  call errmsg_exit(' ?splitn_module: exceeded max rank=4: '// &
                       iline)
               else
                  ilast_fld = 4+iirank
               endif
            endif
                  
         else if(ifld.eq.ilast_fld) then
            if(iline(ist:ist).ne.'/') then
               call errmsg_exit( &
                    ' ?splitn_module: cannot find default value string: '// &
                    iline)
            endif

            exit       ! parse default value string in separate loop

         else
            idim = ifld-3   ! which dimension this is...

            ! expect field of form "(n1:n2)"

            if(iline(ist:ist).ne.'(') call errmsg_exit( &
                 ' ?splitn_module: expected "(" at start of dimension field: '//iline)
            if(iline(i-1:i-1).ne.')') call errmsg_exit( &
                 ' ?splitn_module: expected ")" at end of dimension field: '//iline)
            icolon=index(iline(ist:i-1),':')
            if(icolon.le.0) call errmsg_exit( &
                 ' ?splitn_module: expected ":" in dimension field: '//iline)
            icolon=icolon+ist-1
            ic1=ist+1
            ic2=max(ic1,icolon-1)
            il=ic2-ic1+1
            ibuf=' '
            ibuf(10-il+1:10)=iline(ic1:ic2)
            read(ibuf,'(I10)') iidims(1,idim)

            ic1=icolon+1
            ic2=max(ic1,i-2)
            il=ic2-ic1+1
            ibuf=' '
            ibuf(10-il+1:10)=iline(ic1:ic2)
            read(ibuf,'(I10)') iidims(2,idim)

         endif

         ! find start of next field

         do 
            i=i+1
            if((iline(i:i).ne.' ').and.(iline(i:i).ne.char(9))) exit
            if(i.eq.ilen) then
               call errmsg_exit(' ?splitn_module: missing fields: '//iline)
            endif
         enddo

         ist=i       ! non-blank start of next field

      enddo

      ! get default value string

      ilen = len_trim(iline)
      ist = ist+1

      ! first non-blank

      do i=ist,ilen
         if((iline(i:i).ne.' ').and.(iline(i:i).ne.char(9))) exit
      enddo
      if(iline(i:i).eq.'/') call errmsg_exit( &
           ' ?splitn_module: empty default value string: '//iline)

      ilz=1
      ist=i

      ! check for continuation line; check for end; read if necessary

      do
         if(iline(ilen:ilen).eq.'/') then
            ! NO continuation
            zdflt(ilz:)=iline(ist:ilen-1)
            exit

         else if(iline(ilen:ilen).eq.char(92)) then
            ! backslash: continuation
            zdflt(ilz:)=iline(ist:ilen-1)

         else 
            call errmsg_exit( &
                 ' ?splitn_module: default value string syntax error: '// &
                 iline)
         endif

         ilz=len_trim(zdflt) + 1
         read(lun,'(A)') iline

         ilen=len_trim(iline)
         do i=1,ilen
            if((iline(i:i).ne.' ').and.(iline(i:i).ne.char(9))) exit
         enddo
         if(i.eq.ilen) then
            if(iline(i:i).eq.'/') exit  ! terminator found.
         endif

         ist=i  ! and loop back to insert text from this line
      enddo

    end subroutine read1_db

    subroutine addlist

      !  add namelist "cur_naml" to list of namelists, with the following
      !  caveats which are related to backwards compatibility with the
      !  old "splitn" software:
      !
      !   (a) ignore "GENSIS"
      !   (b) put "TRNCHR" at beginning of list
      !   (c) put "TRDATA" at end of list
      !   (d) put TRN001--TRNnnn after "TRNCHR", in order found
      !   (e) put everything else before "TRDATA", in order found.

      integer i,ipos,itest,ios
      integer :: innn=0
      save innn

      !--------------------------------------------
      if(nnamls.eq.0) innn=0

      ! ...ignore GENSIS
      if(cur_naml.eq.'GENSIS') return

      ! ...ignore duplicates, although these are not expected.
      do i=1,nnamls
         if(cur_naml.eq.all_namls(i)) return
      enddo

      ! ...see if form of namelist name is TRNnnn, nnn = 3 digit integer
      itest=-1
      if(cur_naml(1:3).eq.'TRN') then
         read(cur_naml(4:6),'(I3)',iostat=ios) itest
         if(ios.ne.0) itest=-1
      endif

      ! ...find position in list for this namelist
      if(cur_naml.eq.'TRNCHR') then
         ipos=1
         innn=innn+1
      else if(cur_naml.eq.'TRDATA') then
         ipos=nnamls+1
      else if(itest.gt.-1) then
         ! TRNnnn namelist
         innn=innn+1
         ipos=innn
      else
         ! ...none of the above... insert before TRDATA
         if(nnamls.eq.0) then
            ipos=1
         else if(all_namls(nnamls).eq.'TRDATA') then
            ipos=nnamls
         else
            ipos=nnamls+1
         endif
      endif

      ! insert namelist name now

      do i=nnamls,ipos,-1
         all_namls(i+1)=all_namls(i)
      enddo
      all_namls(ipos)=cur_naml

      nnamls=nnamls + 1

    end subroutine addlist

    logical function is_deleted(zname)

      character*(*), intent(in) :: zname

      !  return TRUE if passed name is a known deleted name

      !--------------------------------
      character*32 :: znam32
      integer :: inam
      !--------------------------------

      znam32 = zname
      call uupper(znam32)

      is_deleted = .FALSE.

      do inam=1,ndnames
         if(znam32.eq.dnames(inam)) then
            is_deleted = .TRUE.
            exit
         endif
      enddo

    end function is_deleted

end module splitn_module

!******************** START FILE FILTR6.FOR ; GROUP FILTR6 *************
!
!  FILTR6     DATA SMOOTHING ALGORITHM    D. MCCUNE  5 SEPT 78
!						PPPL
!
!
!     THIS IS AN ALGORITHM TO SMOOTH DATA.  INSTEAD OF
!   USING SPLINE FUNCTIONS, THE ALGORITHM USES A LOCAL
!   WEIGHTED AVERAGE TO GENERATE SMOOTHING ACTION.  THIS HAS
!   THE ADVANTAGE OF AVOIDING THE LARGE COEFFICENT ARRAYS
!   AND WORK SPACES NEEDED BY SPLINE FUNCTION AL
!   GORITHMS; AND IN MANY CASES (IN THE EXPERIENCE
!   OF THE AUTHOR) THE ALGORITHM IS MORE EFFICIENT IN CPU TIME
!   BY AS MUCH AS A FACTOR OF 10.
!
!     THE USER SPECIFIES THE RADIUS OF THE LOCAL WEIGHTED
!   AVERAGE ( CALLED 'DELTA' IN THIS ALGORITHM).  THIS DELTA
!   SHOULD BE SET AS SMALL AS POSSIBLE TO REMOVE 'NOISE' FROM
!   THE DATA SIGNAL, TO ASSURE MAXIMUM EFFICIENCY OF THE ALGOR
!   ITHM.  IF COMPONENTS OF THE SIGNAL OF WAVELENGTH
!   LAMDA OR LESS ARE DEEMED NOISE, DELTA SHOULD BE SET TO APPROX.
!   LAMDA/2.
!     ** note DELTA is an ARRAY ** of same dimension as the input
!   data; DELTA(j) specifies the smoothing delta at pt. j in the
!   input data.
!       IN THIS VERSION THE WEIGHTING FUNCTION IS TRIANGULAR
!   SHAPED, WITH BASE WIDTH TWO*DELTA, SYMMETRIC ABOUT
!   AND PEAKED AT THE POINT WHERE THE
!   LOCAL AVERAGE IS BEING COMPUTED.  THIS FUNCTION WAS
!   FOUND TO GENERATE ALMOST EQUIVALENT SMOOTHING ACTION
!   TO MORE COMPLICATED WEIGHTING FUNCTIONS, WITH A
!   CONSIDERABLE SAVINGS IN CPU TIME.
!   THE FORMULA FOR THE WEIGHTING FUNCTION IS:
!
!   W(X-T)=1./DELTA * (1.-ABS((X-T)/DELTA))
!        IF ABS(X-T) < DELTA,              OR
!   W(X-T)=0. IF ABS(X-T) >= DELTA.
!
!   THIS IS THE WEIGHTING FUNCTION CENTERED AT X.
!
!   THE ALGORITHM EVALUATES THE SMOOTHED DATA CURVE BY
!   COMPUTING THE LOCAL WEIGHTED AVERAGE ABOUT EACH POINT
!   USING THE WEIGHTING FUNCTION:
!
!             INTEGRAL(T=X(J)-DELTA TO X(J)+DELTA)[W(X(J)-T)*F(T)*DT]
!   YSM(J)=  ----------------------------------------------------
!             INTEGRAL(T=X(J)-DELTA TO X(J)+DELTA)[W(X(J)-T)*DT]
!
!   WHERE F(T) IS THE LINEARLY INTERPOLATED (CONTINUOUS, PIECE-
!   WISE LINEAR) FUNCTION OF THE ORIGINAL DATA (X(1),Y(1)) THRU
!   (X(N),Y(N))
!
!
! *******EPSLON FEATURE *********
!
!   IN MANY APPLICATIONS, WE MAY KNOW NOT ONLY THE FREQUENCY
!  OF 'NOISE' IN A SIGNAL, BUT ALSO ITS NOMINAL AMPLITUDE.
!    THEREFORE IT IS DESIRABLE THAT THE ALGORITHM NOT SMOOTH
!    OUT COMPONENTS OF THE SIGNAL WHICH ARE OF AMPLITUDE
!    GREATER THAN THIS NOMINAL AMPLITUDE, EVEN IF
!    THE CORRESPONDING FREQUENCY IS VERY HIGH.  TO THIS END
!    AN 'EPSILON' FEATURE IS PROVIDED IN THIS ALGORITHM.
!      THE USER SPECIFIES A VALLUE EPSLON WHICH SAYS
!    TO THE ALGORITHM, NO POINT SHALL BE MOVED MORE THAN
!    EPSLON FROM THE POINTS  IN THE ORIGINAL DATA.  THIS FEATURE
!    IS VERY USEFUL IF THE CURVE BEING SMOOTHED HAS A 'REAL'
!    FEATURE, TO BE PRESERVED, WHICH IS VERY SHARP OR NARROW, OR
!    WHICH INVOLVES A VERY RAPID RISE OR FALL TIME.
!
!    THE ALGORITHM, AFTER EVALUATING A SMOOTHED DATA CURVE
!    BY THE ABOVE FORMULA, COMPARES THE RESULT WITH THE ORIGINAL
!    DATA. IF AT ANY POINT THE ORDINATE VALUES HAVE CHANGED BY
!    MORE THAN EPSLON, THE SMOOTHED CURVE IN THE VICINITY OF THAT
!    POINT IS REEVALUATED USING A SMALLER, PROGRAM DEFINED
!    DELTA.  THE PROCEDURE IS REPEATED UNTIL THERE ARE NO
!    'EPSLON VIOLATIONS' IN THE SMOOTHED CURVE.
!
!  THE EPSLON VALUES MAY BE PASSED AS AN ARRAY OF DIMENSION
!  NE <= N=DIMENSION OF DATA ARRAYS; TO SPECIFY AN EPSLON
!  'ERROR BAR' FOR EACH POINT INDIVIDUALLY, SPECIFY NE=N;
!  TO USE THE SAME 'ERROR BAR ' FOR ALL POINTS SPECIFY NE=1;
!  IF 1 < NE < N, THE ERROR BAR FOR DATA POINTS J=1 THRU NE
!  IS EPS(J), FOR DATA POINTS J=NE+1 THRU N, THE ERROR BAR
!  IS THE LAST EPSLON, EPS(NE).
!
!  THE WEIGHTED AVERAGE WIDTH DELTA IS ALSO PASSED AS
!  AN ARRAY WHICH MAY CONTAIN DIFFERENT VALUES FOR
!  FOR DIFFERENT DATA POINTS.  HOWEVER,
!  THE USER **MUST** REDEFINE THE DELTA ARRAY BEFORE EACH
!  CALL TO FILTR6, SINCE THE ARRAY MAY BE
!  MODIFIED DURING IMPLIMENTATION OF THE EPSLON FEATURE*****
!
!
!    *** END CONDITIONS ****
!
!  END CONDITION PARAMETERS XENDA (LEFT SIDE) AND XENDB (RIGHT SIDE)
!  MAY BE SET ANYWHERE BETWEEN THE EXTREMES (0 AND 1):
!    XEND_=0:  THE END-POINT IS EFFECTIVELY FIXED
!         (YSM(1) WILL EQUAL Y(1)).  THE WEIGHTED AVERAGE
!         INTEGRAL IN THE VICINITY OF THE ENDPOINT IS CALCULATED
!         BY 'CONTINUING' THE DATA BEYOND THE END-POINT BY
!         REFLECTION ABOUT THE ENDPOINT (E.G. IF (0,0) IS THE
!         ENDPOINT AND (1,1) IS THE NEXT POINT, (-1,-1) IS THE
!         REFLECTED POINT.
!   XEND_ =1:  THE FIRST DERIVATIVE AT THE ENDPOINT IS EFFECTIVELY
!        SET TO ZERO.  THE WEIGHTED AVERAGE IN THE VICINITY
!        OF THE ENDPOINT IS CALCULATED BY 'EXTENDING' THE DATA
!        BEYOND THE ENDPOINT BY REFLECTION ABOUT THE LINE
!        X=CONST. PASSING THRU THE ENDPOINT. (E.G. IF THE END
!        POINT IS (0,0) AND THE NEXT POINT (1,1) THE REFL
!        ECTED POINT IS (-1,1)  ).  THE ENDPOINT WILL BE MOVED
!        BUT BY SYMMETRY OF THE REFLECTION THE SLOPE
!        OF THE SMOOTHED DATA CURVE WILL GO TO ZERO.
!
!   EPSLN2  FEATURE... AN ARRAY OF MULTIPLIERS OF THE ORIGINAL
!        ERROR BARS MAY BE SUPPLIED BY THE USER FOR USE WHEN
!        THE NUMBER OF POINTS INVOLVED IN A VIOLATION IS
!        SMALL.
!
!   ALSO, THE USER MAY USE A DATA 'DROPOUT' FEATURE:
!    (SEE BELOW)
!
!
!    A BASELINE FEATURE IS ALSO AVAILABLE (SEE BELOW)
!
!---------------------------------------------------
!  ARGUMENTS           FILTR6
!
!    X()     INPUT    DATA ABSCISSAE (ORDERED S.T. X(I+1) > X(I))
!    Y1()    INPUT    ORIGINAL DATA ORDINATES *MAY BE MODIFIED
!					BY DATA DROPOUT
!    Y()     OUTPUT   SMOOTHED DATA ORDINATES
!		      (NOTE Y AND Y1 MUST BE DISTINCT ARRAYS
!                     FOR PROPER IMPLEMENTATION OF EPSLON FEATURE)
!    N       INPUT    # OF DATA PTS (DIMENSION OF X,Y1,Y)
!    EPS()   INPUT    'EPSLON' DISCUSSED ABOVE.  (EXCEPT FOR EPS2
!                     FEATURE) NO POINT SHALL BE MOVED MORE THAN
!                     EPS, I.E [ABS(Y1(J)-Y(J)) <= EPS] ALL J.
!                            EPS IN DATA ORDINATE UNITS.
!                     *EPS IS AN ARRAY*
!    NE      INPUT    DIMENSION OF EPS
!    EPS2()  INPUT    'EPSLN2' FEATURE DISCUSSED ABOVE.
!                     MULTIPLIER FOR EPSLON ARRAY FOR SHORT VIOLATIONS
!
!    NEPS2   INPUT    DIMENSION OF EPS2.:
!                        NEPS2=0==> EPSLON FEATURE STRICTLY
!				    IMPLEMENTED
!     			 NEPS2=1==> IF AN ISOLATED VIOLATION OF
!				    EPS INVOLVING ONLY ONE DATA
!   				    PT IS DETECTED, EPS2(1)*EPS
!				    IS USED INSTEAD OF EPS
!                        NEPS2=2==> EPSLON VIOLATION OF LENGTH 1,
!                                   EPS2(1)*EPS USED INSTEAD OF EPS;
!				     VIOLATION OF LENGTH 2 DATA
!				    PTS, EPS2(2)*EPS USED INSTEAD OF EPS
!			 NEPS2 CAN BE ANY NONNEG. INTEGER.
!   DELT() INPUT         'DELTA', RADIUS OF WEIGHTED AVERAGE,
!			 DISCUSSED ABOVE.  **array of size N**
!   IDDF   INPUT	DATA DROPOUT FLAG:
!			=0: DONT USE DATA DROPOUT FEATURE
!			=1: DO USE FEATURE
!   DDV    INPUT	DATA DROPOUT CRITERION: (IF IDDF=1):
!			DATA PT. (X(I),Y1(I)) DROPS OUT IF Y1(I)
!			IS MORE THAN DDV ABOVE OR BELOW THE LINE
!			SEGMENT CONNECTING ITS IMMEDIATE NEIGHBORS
!			Y1(I) IS THEN RESET TO LIE ON SAID LINE
!			SEGMENT.
!    IBLF   INPUT    BASELINE FEATURE FLAG:
!			=0==> DONT PUT IN A BASELINE
!			=1==> DO PUT IN A BASELINE
!
!    BLV    INPUT    BASELINE VALUE (IF IBLF=1):  ALL POINTS IN
!			THE CURVE FOUND TO BE LESS THAN BLV
!			ARE RESET TO EQUAL BLV.
!
!     SM     OUTPUT SUM SQUARED OF (Y1(I)-Y(I)), EXCLUDING
!                   POINTS AT THE BASELINE (IF ANY).
!    *** MODIFIED *** SM= SUM SQUARED OF (Y1(J)-Y(J))
!           DIVIDED BY (MAX[J]ABS(Y1(J)))**2
!           NORMALIZATION TO PREVENT OVERFLOWS
!
!     NDROP  OUTPUT NUMBER OF 'DROPOUT' PTS.
!     NBLRS  OUTPUT NUMBER OF PTS RESET TO THE BASELINE.
!
SUBROUTINE r8filtr6(X,Y1,Y,N,EPS,NE,EPS2,NEPS2,DELT,IDDF,DDV, &
     IBLF,BLV,XENDA,XENDB,SM,NDROP,NBLRS)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, ONE
  implicit none
  ! Arguments
  integer, intent(in)   :: n
  integer, intent(in)   :: ne
  integer, intent(in)   :: neps2
  integer, intent(in)   :: iddf
  integer, intent(in)   :: iblf
  integer, intent(out)  :: ndrop
  integer, intent(out)  :: nblrs
  real(fp), dimension(n),  intent(in)    :: x
  real(fp), dimension(n),  intent(inout) :: y1
  real(fp), dimension(n),  intent(inout) :: y
  real(fp), dimension(n),  intent(in)    :: delt
  real(fp), dimension(ne), intent(in)    :: eps
  real(fp), dimension(*),  intent(in)    :: eps2
  integer, intent(in) :: ddv
  integer, intent(in) :: blv
  real(fp), intent(in) :: xenda,xendb
  real(fp), intent(out) :: sm
  ! Local variables
  integer :: ierr,j,ierr1,j2,n2,je,nel
  real(fp) :: zxp,xend1,xend2,zeps,y1a,y1b,zmax,dy
!
!  START OF EXECUTABLE CODE
!
  NBLRS=0
  NDROP=0
!  DROP DATA PTS IN Y1 ARRAY
  IF(IDDF.EQ.1) CALL r8ddrop(X,Y1,N,DDV,NDROP)
!
  IERR=0
  ZXP=X(1)-(X(2)-X(1))
  DO J=1,N
    IF(ZXP.GE.X(J)) IERR=J   ! CHECKING MONOTONICITY
    ZXP=X(J)
    Y(J)=Y1(J)
  END DO
!
  IF(IERR.NE.0) THEN
    IERR=MAX(2,IERR)
    IERR1=IERR-1
    WRITE(6,1001) IERR1,X(IERR1),IERR,X(IERR)
    SM=ZERO
    RETURN
  ENDIF
1001 FORMAT( &
          ' ?FILTR6:  INPUT "X" ARRAY NOT MONOTONIC, CANNOT SMOOTH:'/ &
          '  X(',I6,')=',1PE13.6,'  X(',I6,')=',1PE13.6/)
  !
  !  SMOOTH ENTIRE REGION IF BASELINE FEATURE NOT IN EFFECT.
  !
  IF(IBLF.EQ.1) GO TO 15
  !
  XEND1=XENDA
  XEND2=XENDB
  CALL r8filter(X,Y1,Y,N,DELT,XEND1,XEND2)

  !  IMPLEMENT EPSLON FEATURE --
  CALL r8fileps(X,Y1,Y,N,DELT,EPS,NE,EPS2,NEPS2,XEND1,XEND2)
  !
  GO TO 500
  !
  !  RESET PTS IF BASELINE FEATURE IS IN EFFECT
  !
 15 CONTINUE
  DO J=1,N
    IF(Y(J).GT.(BLV)) cycle
    NBLRS=NBLRS+1
    Y(J)=BLV
  END DO
  !
  !  SMOOTH BETWEEN PTS RESET TO BASELINE.
  !
  J=0
30 J=J+1
  IF(J.GE.N) GO TO 500
  IF(Y(J).LE.BLV) GO TO 30
  IF(J.GT.1) J=J-1
!  SMOOTHING WILL BE BETWEEN INDICES J AND J2
!
  J2=J
40 J2=J2+1
  IF((Y(J2).GT.BLV).AND.(J2.LT.N)) GO TO 40
  !
  !  DMC MAY 1985 - MODIFYING SMALL INTERVAL HANDLING
  !
  !  IF REGION ABOUT TO BE SMOOTHED IS OF WIDTH LESS THAN DELT,
  !  AND CONTAINS NO PTS MORE THAN EPS ABOVE THE BASE LINE,
  !  RESET THE WHOLE REGION TO THE BASELINE RATHER THAN SMOOTHING.
  !
  !X	IF((X(J2)-X(J)).GT.AMIN1(DELT(J),DELT(J2))) GO TO 45
  !X	DO 42 I=J,J2
  !X	ZEPS=EPS(NE)
  !X	IF(I.LT.NE) ZEPS=EPS(I)
  !X	IF(Y(I).GT.(BLV+ZEPS)) GO TO 45
  !X 42	CONTINUE
  !XC  ZERO OUT THE REGION
  !X	DO 43 I=J,J2
  !X 43	Y(I)=BLV
  !X	GO TO 50
  !
45 N2=J2-J+1
  !  SMOOTH IF THERE ARE ENUF DATA PTS.
  IF(N2.LT.2) THEN
    ZEPS=EPS(NE)
    IF(J.LT.NE) ZEPS=EPS(J)
    IF(Y(J).GT.(BLV+ZEPS)) Y(J)=BLV
    GO TO 50
  ENDIF
  !
  Y1A=Y1(J)
  Y1B=Y1(J2)
  IF(Y1(J).LT.BLV) Y1(J)=BLV
  IF(Y1(J2).LT.BLV) Y1(J2)=BLV
  XEND1=ZERO
  XEND2=ZERO
  IF(J.EQ.1) XEND1=XENDA
  IF(J2.EQ.N) XEND2=XENDB
  CALL r8filter(X(J),Y1(J),Y(J),N2,DELT(J),XEND1,XEND2)
  !  IMPLEMENT EPSLON FEATURE --
  JE=J
  IF(JE.GT.NE) JE=NE
  NEL=NE-JE+1
  !
  CALL r8fileps(X(J),Y1(J),Y(J),N2,DELT(J),EPS(JE),NEL, &
       EPS2,NEPS2,XEND1,XEND2)
  Y1(J)=Y1A
  Y1(J2)=Y1B
!
50 J=J2
  GO TO 30
  !
  !  ***EXIT FROM LOOP.  COMPUTE SM
  !
500 CONTINUE
  SM=ZERO
  !  D. MC CUNE JUNE 1980-- PREVENT OVERFLOW ON CALCULTION OF SM
  !     SM NORMALIZED BY 1/(MAX(ABS(Y1(J)))**2
  !
  ZMAX=ZERO
  DO J=1,N
    ZMAX=max(ZMAX,ABS(Y1(J)))
  END DO
  IF(ZMAX.EQ.ZERO) ZMAX=ONE
  !
  DO J=1,N
    DY=(Y(J)-Y1(J))/ZMAX
    IF((IBLF.EQ.0).OR.(Y(J).GT.BLV)) SM=SM+DY*DY
  END DO
  RETURN
END SUBROUTINE r8filtr6

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_7(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF( ((ALLOCATED(ss2%Rloc_coil)).AND.(ALLOCATED(ss%Rloc_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Rloc_coil = ss%Rloc_coil
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Rmajor_mean = 0
  ENDIF
  IF((ALLOCATED(ss%Rmajor_mean).AND.ALLOCATED(ss2%Rmajor_mean)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%Rmajor_mean = ss%Rmajor_mean
     IF(.not.partial_copy) THEN
        ss2%id_Rmajor_mean = ss%id_Rmajor_mean
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_rMinor_mean = 0
  ENDIF
  IF((ALLOCATED(ss%rMinor_mean).AND.ALLOCATED(ss2%rMinor_mean)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%rMinor_mean = ss%rMinor_mean
     IF(.not.partial_copy) THEN
        ss2%id_rMinor_mean = ss%id_rMinor_mean
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_RUNAWAY).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%RUNAWAY_Code_Info = ss%RUNAWAY_Code_Info
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%RunID = ss%RunID
  ENDIF
  IF( ((ALLOCATED(ss2%R_ant)).AND.(ALLOCATED(ss%R_ant))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%R_ant = ss%R_ant
  ENDIF
  IF( ((ALLOCATED(ss2%R_antgeo)).AND.(ALLOCATED(ss%R_antgeo))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%R_antgeo = ss%R_antgeo
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%R_axis = ss%R_axis
  ENDIF
  IF( ((ALLOCATED(ss2%R_EC_launch)).AND.(ALLOCATED(ss%R_EC_launch))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EC).EQ.1)) ) THEN
     ss2%R_EC_launch = ss%R_EC_launch
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R_geo = 0
  ENDIF
  IF((ALLOCATED(ss%R_geo).AND.ALLOCATED(ss2%R_geo)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_geo = ss%R_geo
     IF(.not.partial_copy) THEN
        ss2%id_R_geo = ss%id_R_geo
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%R_grid).AND.ALLOCATED(ss2%R_grid)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_grid = ss%R_grid
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%R_max_box = ss%R_max_box
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%R_max_lcfs = ss%R_max_lcfs
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R_midp_in = 0
  ENDIF
  IF((ALLOCATED(ss%R_midp_in).AND.ALLOCATED(ss2%R_midp_in)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_midp_in = ss%R_midp_in
     IF(.not.partial_copy) THEN
        ss2%id_R_midp_in = ss%id_R_midp_in
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R_midp_out = 0
  ENDIF
  IF((ALLOCATED(ss%R_midp_out).AND.ALLOCATED(ss2%R_midp_out)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_midp_out = ss%R_midp_out
     IF(.not.partial_copy) THEN
        ss2%id_R_midp_out = ss%id_R_midp_out
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%R_min_box = ss%R_min_box
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%R_min_lcfs = ss%R_min_lcfs
  ENDIF
  IF((ALLOCATED(ss%R_ripple).AND.ALLOCATED(ss2%R_ripple)).AND. &
        ((cclist(ps_cnum_RIPPLE).EQ.1))) THEN
     ss2%R_ripple = ss%R_ripple
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R_surfMax = 0
  ENDIF
  IF((ALLOCATED(ss%R_surfMax).AND.ALLOCATED(ss2%R_surfMax)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_surfMax = ss%R_surfMax
     IF(.not.partial_copy) THEN
        ss2%id_R_surfMax = ss%id_R_surfMax
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R_surfMin = 0
  ENDIF
  IF((ALLOCATED(ss%R_surfMin).AND.ALLOCATED(ss2%R_surfMin)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%R_surfMin = ss%R_surfMin
     IF(.not.partial_copy) THEN
        ss2%id_R_surfMin = ss%id_R_surfMin
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_s0reco)) THEN
     IF(partial_copy) THEN
        ss2%id_s0reco = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%s0reco).AND.ALLOCATED(ss2%s0reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%s0reco = ss%s0reco
     IF(ALLOCATED(ss2%id_s0reco)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_s0reco = ss%id_s0reco
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_s0reco_e = 0
  ENDIF
  IF((ALLOCATED(ss%s0reco_e).AND.ALLOCATED(ss2%s0reco_e)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%s0reco_e = ss%s0reco_e
     IF(.not.partial_copy) THEN
        ss2%id_s0reco_e = ss%id_s0reco_e
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_s0reco_recap)) THEN
     IF(partial_copy) THEN
        ss2%id_s0reco_recap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%s0reco_recap).AND.ALLOCATED(ss2%s0reco_recap)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%s0reco_recap = ss%s0reco_recap
     IF(ALLOCATED(ss2%id_s0reco_recap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_s0reco_recap = ss%id_s0reco_recap
        ENDIF
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%sa_index)).AND.(ALLOCATED(ss%sa_index))) THEN
     ss2%sa_index = ss%sa_index
  ENDIF
  IF((ALLOCATED(ss2%SA_name)).AND.(ALLOCATED(ss%SA_name))) THEN
     ss2%SA_name = ss%SA_name
  ENDIF
  IF((ALLOCATED(ss2%SA_type)).AND.(ALLOCATED(ss%SA_type))) THEN
     ss2%SA_type = ss%SA_type
  ENDIF
  IF(ALLOCATED(ss2%id_sb0halo)) THEN
     IF(partial_copy) THEN
        ss2%id_sb0halo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sb0halo).AND.ALLOCATED(ss2%sb0halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sb0halo = ss%sb0halo
     IF(ALLOCATED(ss2%id_sb0halo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sb0halo = ss%id_sb0halo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sb0halo_recap)) THEN
     IF(partial_copy) THEN
        ss2%id_sb0halo_recap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sb0halo_recap).AND.ALLOCATED(ss2%sb0halo_recap)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sb0halo_recap = ss%sb0halo_recap
     IF(ALLOCATED(ss2%id_sb0halo_recap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sb0halo_recap = ss%id_sb0halo_recap
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_sbedep = 0
  ENDIF
  IF((ALLOCATED(ss%sbedep).AND.ALLOCATED(ss2%sbedep)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sbedep = ss%sbedep
     IF(.not.partial_copy) THEN
        ss2%id_sbedep = ss%id_sbedep
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_sbehalo = 0
  ENDIF
  IF((ALLOCATED(ss%sbehalo).AND.ALLOCATED(ss2%sbehalo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sbehalo = ss%sbehalo
     IF(.not.partial_copy) THEN
        ss2%id_sbehalo = ss%id_sbehalo
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sbsce)) THEN
     IF(partial_copy) THEN
        ss2%id_sbsce = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sbsce).AND.ALLOCATED(ss2%sbsce)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sbsce = ss%sbsce
     IF(ALLOCATED(ss2%id_sbsce)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sbsce = ss%id_sbsce
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sbtherm)) THEN
     IF(partial_copy) THEN
        ss2%id_sbtherm = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sbtherm).AND.ALLOCATED(ss2%sbtherm)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%sbtherm = ss%sbtherm
     IF(ALLOCATED(ss2%id_sbtherm)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sbtherm = ss%id_sbtherm
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%sc0)).AND.(ALLOCATED(ss%sc0))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%sc0 = ss%sc0
  ENDIF
  IF( ((ALLOCATED(ss2%sc0_to_sgas)).AND.(ALLOCATED(ss%sc0_to_sgas))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_GAS).EQ.1)) ) THEN
     ss2%sc0_to_sgas = ss%sc0_to_sgas
  ENDIF
  IF(ALLOCATED(ss2%id_sc_anom)) THEN
     IF(partial_copy) THEN
        ss2%id_sc_anom = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sc_anom).AND.ALLOCATED(ss2%sc_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%sc_anom = ss%sc_anom
     IF(ALLOCATED(ss2%id_sc_anom)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sc_anom = ss%id_sc_anom
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sfsce)) THEN
     IF(partial_copy) THEN
        ss2%id_sfsce = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sfsce).AND.ALLOCATED(ss2%sfsce)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%sfsce = ss%sfsce
     IF(ALLOCATED(ss2%id_sfsce)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sfsce = ss%id_sfsce
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sftherm)) THEN
     IF(partial_copy) THEN
        ss2%id_sftherm = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sftherm).AND.ALLOCATED(ss2%sftherm)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%sftherm = ss%sftherm
     IF(ALLOCATED(ss2%id_sftherm)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sftherm = ss%id_sftherm
        ENDIF
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%SFUS_name)).AND.(ALLOCATED(ss%SFUS_name))) THEN
     ss2%SFUS_name = ss%SFUS_name
  ENDIF
  IF((ALLOCATED(ss2%sfus_to_all)).AND.(ALLOCATED(ss%sfus_to_all))) THEN
     ss2%sfus_to_all = ss%sfus_to_all
  ENDIF
  IF((ALLOCATED(ss2%sfus_to_alla)).AND.(ALLOCATED(ss%sfus_to_alla))) THEN
     ss2%sfus_to_alla = ss%sfus_to_alla
  ENDIF
  IF((ALLOCATED(ss2%SFUS_type)).AND.(ALLOCATED(ss%SFUS_type))) THEN
     ss2%SFUS_type = ss%SFUS_type
  ENDIF
  IF((ALLOCATED(ss2%SGAS_name)).AND.(ALLOCATED(ss%SGAS_name))) THEN
     ss2%SGAS_name = ss%SGAS_name
  ENDIF
  IF((ALLOCATED(ss2%sgas_to_s)).AND.(ALLOCATED(ss%sgas_to_s))) THEN
     ss2%sgas_to_s = ss%sgas_to_s
  ENDIF
  IF((ALLOCATED(ss2%SGAS_type)).AND.(ALLOCATED(ss%SGAS_type))) THEN
     ss2%SGAS_type = ss%SGAS_type
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%shot_number = ss%shot_number
  ENDIF
  IF(ALLOCATED(ss2%id_sii_xs)) THEN
     IF(partial_copy) THEN
        ss2%id_sii_xs = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sii_xs).AND.ALLOCATED(ss2%sii_xs)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%sii_xs = ss%sii_xs
     IF(ALLOCATED(ss2%id_sii_xs)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sii_xs = ss%id_sii_xs
        ENDIF
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%SIMP0_name)).AND.(ALLOCATED(ss%SIMP0_name))) THEN
     ss2%SIMP0_name = ss%SIMP0_name
  ENDIF
  IF((ALLOCATED(ss2%simp0_to_s)).AND.(ALLOCATED(ss%simp0_to_s))) THEN
     ss2%simp0_to_s = ss%simp0_to_s
  ENDIF
  IF((ALLOCATED(ss2%SIMP0_type)).AND.(ALLOCATED(ss%SIMP0_type))) THEN
     ss2%SIMP0_type = ss%SIMP0_type
  ENDIF
  IF((ALLOCATED(ss2%SIMPI_name)).AND.(ALLOCATED(ss%SIMPI_name))) THEN
     ss2%SIMPI_name = ss%SIMPI_name
  ENDIF
  IF((ALLOCATED(ss2%simpi_to_s)).AND.(ALLOCATED(ss%simpi_to_s))) THEN
     ss2%simpi_to_s = ss%simpi_to_s
  ENDIF
  IF((ALLOCATED(ss2%SIMPI_type)).AND.(ALLOCATED(ss%SIMPI_type))) THEN
     ss2%SIMPI_type = ss%SIMPI_type
  ENDIF
  IF((ALLOCATED(ss2%SNBI_name)).AND.(ALLOCATED(ss%SNBI_name))) THEN
     ss2%SNBI_name = ss%SNBI_name
  ENDIF
  IF((ALLOCATED(ss2%snbi_to_all)).AND.(ALLOCATED(ss%snbi_to_all))) THEN
     ss2%snbi_to_all = ss%snbi_to_all
  ENDIF
  IF((ALLOCATED(ss2%snbi_to_alla)).AND.(ALLOCATED(ss%snbi_to_alla))) THEN
     ss2%snbi_to_alla = ss%snbi_to_alla
  ENDIF
  IF((ALLOCATED(ss2%SNBI_type)).AND.(ALLOCATED(ss%SNBI_type))) THEN
     ss2%SNBI_type = ss%SNBI_type
  ENDIF
  IF(ALLOCATED(ss2%id_sn_trans)) THEN
     IF(partial_copy) THEN
        ss2%id_sn_trans = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sn_trans).AND.ALLOCATED(ss2%sn_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%sn_trans = ss%sn_trans
     IF(ALLOCATED(ss2%id_sn_trans)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sn_trans = ss%id_sn_trans
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sn_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_sn_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sn_transcat).AND.ALLOCATED(ss2%sn_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%sn_transcat = ss%sn_transcat
     IF(ALLOCATED(ss2%id_sn_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sn_transcat = ss%id_sn_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sprof0)) THEN
     IF(partial_copy) THEN
        ss2%id_sprof0 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sprof0).AND.ALLOCATED(ss2%sprof0)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%sprof0 = ss%sprof0
     IF(ALLOCATED(ss2%id_sprof0)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sprof0 = ss%id_sprof0
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_sprof0e)) THEN
     IF(partial_copy) THEN
        ss2%id_sprof0e = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%sprof0e).AND.ALLOCATED(ss2%sprof0e)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%sprof0e = ss%sprof0e
     IF(ALLOCATED(ss2%id_sprof0e)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_sprof0e = ss%id_sprof0e
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_spsce)) THEN
     IF(partial_copy) THEN
        ss2%id_spsce = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%spsce).AND.ALLOCATED(ss2%spsce)).AND. &
        ((cclist(ps_cnum_PEL).EQ.1))) THEN
     ss2%spsce = ss%spsce
     IF(ALLOCATED(ss2%id_spsce)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_spsce = ss%id_spsce
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_squareLO = 0
  ENDIF
  IF((ALLOCATED(ss%squareLO).AND.ALLOCATED(ss2%squareLO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%squareLO = ss%squareLO
     IF(.not.partial_copy) THEN
        ss2%id_squareLO = ss%id_squareLO
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_squareUO = 0
  ENDIF
  IF((ALLOCATED(ss%squareUO).AND.ALLOCATED(ss2%squareUO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%squareUO = ss%squareUO
     IF(.not.partial_copy) THEN
        ss2%id_squareUO = ss%id_squareUO
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%sRtcen)).AND.(ALLOCATED(ss%sRtcen))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%sRtcen = ss%sRtcen
  ENDIF
  IF(partial_copy) THEN
     ss2%id_surf = 0
  ENDIF
  IF((ALLOCATED(ss%surf).AND.ALLOCATED(ss2%surf)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%surf = ss%surf
     IF(.not.partial_copy) THEN
        ss2%id_surf = ss%id_surf
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%S_name)).AND.(ALLOCATED(ss%S_name))) THEN
     ss2%S_name = ss%S_name
  ENDIF
  IF((ALLOCATED(ss2%s_to_sa)).AND.(ALLOCATED(ss%s_to_sa))) THEN
     ss2%s_to_sa = ss%s_to_sa
  ENDIF
  IF((ALLOCATED(ss2%S_type)).AND.(ALLOCATED(ss%S_type))) THEN
     ss2%S_type = ss%S_type
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%t0 = ss%t0
  ENDIF
  IF(ALLOCATED(ss2%id_T0cx)) THEN
     IF(partial_copy) THEN
        ss2%id_T0cx = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%T0cx).AND.ALLOCATED(ss2%T0cx)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%T0cx = ss%T0cx
     IF(ALLOCATED(ss2%id_T0cx)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_T0cx = ss%id_T0cx
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_T0sc0)) THEN
     IF(partial_copy) THEN
        ss2%id_T0sc0 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%T0sc0).AND.ALLOCATED(ss2%T0sc0)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%T0sc0 = ss%T0sc0
     IF(ALLOCATED(ss2%id_T0sc0)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_T0sc0 = ss%id_T0sc0
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_T0_halo)) THEN
     IF(partial_copy) THEN
        ss2%id_T0_halo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%T0_halo).AND.ALLOCATED(ss2%T0_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%T0_halo = ss%T0_halo
     IF(ALLOCATED(ss2%id_T0_halo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_T0_halo = ss%id_T0_halo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_T0_reco)) THEN
     IF(partial_copy) THEN
        ss2%id_T0_reco = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%T0_reco).AND.ALLOCATED(ss2%T0_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%T0_reco = ss%T0_reco
     IF(ALLOCATED(ss2%id_T0_reco)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_T0_reco = ss%id_T0_reco
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%t1 = ss%t1
  ENDIF
  IF(ALLOCATED(ss2%id_teflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_teflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%teflux_ky_tglf).AND.ALLOCATED(ss2%teflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%teflux_ky_tglf = ss%teflux_ky_tglf
     IF(ALLOCATED(ss2%id_teflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_teflux_ky_tglf = ss%id_teflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Te_bdy = ss%Te_bdy
  ENDIF
  IF(ALLOCATED(ss2%id_te_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_te_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%te_ky_tglf).AND.ALLOCATED(ss2%te_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%te_ky_tglf = ss%te_ky_tglf
     IF(ALLOCATED(ss2%id_te_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_te_ky_tglf = ss%id_te_ky_tglf
        ENDIF
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_7

module trxpl_gs2_module
  !
  !  MODULE to help with acquisition of TRANSP data for GS2
  !
 
  implicit NONE
  save

  !--  TRANSP run identification information

  character*200 :: transp_path = ' '
  real*8 :: transp_time = 0.0d0
  real*8 :: transp_delt = 0.0d0
  real*8 :: transp_x = 0.0d0
 
  !--  file information

  character*128 :: mpath0,mpath ! (untranslated, translated) template file path
  character*128 :: opath0,opath ! (untranslated, translated) namelist file path

  character*50 :: hostname
  character*50 :: username

  character*50 :: ofile_prefix  ! default output filename: prefix
  character*50 :: ofile_suffix  ! default output filename: suffix

  !--  basic scalar information
 
  integer, parameter :: max_species = 100
 
  integer :: num_species = 0
 
  integer :: num_refn = 1     ! density reference specie, electrons by default.
  integer :: num_reft = 1     ! temperature ref. specie, electrons by default.
  character*2 :: tref_lbl     ! "Ti" or "Te"
  real*8 :: tref              ! actual reference temperature, KeV
  real*8 :: nref              ! actual reference density, m**-3

  real*8 :: ne_grad           ! unrenormalized grad(ne) (for testing)
  real*8 :: sumnz_grad        ! unrenormalized grad(nZ) sum (for testing)
 
  real*8 :: mass_ref = 2.0d0     ! reference mass (AMU, usually:  deuterons)
 
  real*8 :: aminor               ! midplane minor radius (m)
 
  real*8 :: rbzvac               ! vac. R*Bt = g @ bdy.
  real*8 :: r0
  real*8 :: b_t0                 ! (R*Bt)/R0, R0=(Rmin+Rmax)/2, LCFS
 
  !-- Beta as defined per Martha Redi's request
  !   dmc Dec 2002
 
  real*8 :: beta                 ! 403.0*nref*Tref/B_T0/1.d5
 
  !--  profile interpolation option
 
  integer :: iorder              ! 1 for Hermite, 2 for Spline fits
 
  !--  specie information -- physical units
 
  integer id_te,id_ne,id_ti,id_tx,id_tmj,id_rho,id_zeff  ! xplasma id's
 
  real*8 :: zeff_tr,zeff_calc    ! Zeff from TRANSP; Zeff from sum(nZ)/ne
  real*8 :: renorm_nz,renorm_gradnz  ! quasineutrality renormalizations
 
  real*8, dimension(max_species) :: Aplas
  real*8, dimension(max_species) :: Zplas
  integer id_zprof(max_species)  ! Z profiles (for aggregate ion groups)
  integer id_aprof(max_species)  ! A profiles (for aggregate ion groups)
 
  real*8, dimension(max_species) :: Tconv  ! T profile conversion factor
 
  integer id_norig(max_species)  ! spline id -- original density data
  integer id_nsmoo(max_species)  ! spline id -- smoothed density data
  logical nsmoo(max_species)     ! flag to use smoothed data
  real*8 :: dx_smooth_n(max_species)  ! smoothing parameters
 
  integer id_torig(max_species)  ! spline id -- original temperature data
  integer id_tsmoo(max_species)  ! spline id -- smoothed temperature data
  logical tsmoo(max_species)     ! flag to use smoothed data
  real*8 :: dx_smooth_t(max_species)  ! smoothing parameters
 
  logical gsmoo                  ! .TRUE. if ANY profile has been smoothed
  logical gaggr                  ! .TRUE. if ANY ions have been "aggregated".

  logical tmjtx                  ! .TRUE. if TMJ & TX are used, allowing
                                 ! the thermal bulk ion and thermal impurity
                                 ! temperatures to be different
 
  integer ltype(max_species)     ! species type code
                                 !  0 - electrons
                                 !  1 - thermal ions non-impurity
                                 !  2 - impurity
                                 !  3 - beam ion
                                 !  4 - RF tail ions
                                 !  5 - fusion products

  logical fast_aggr              ! .TRUE. if thermal & fast species may be
                                 ! aggregated (default answer: no; user
                                 ! override is allowed).
 
  character*30 slabel(max_species) ! label for each specie
 
  !
  !  GS2 output vectors n/ne, T/Te, m/mref, Z, (1/T)*(dT/drho),
  !                     (1/n)*(dn/drho), "uprime", and collisionality
 
  real*8 nvec(max_species)
  real*8 tvec(max_species)
  real*8 avec(max_species)
  real*8 zvec(max_species)
  real*8 npvec(max_species)
  real*8 tpvec(max_species)
  real*8 upvec(max_species)
  real*8 nuvec(max_species)
 
  character*10, parameter :: zeff_lbl = 'zeff=     '
  character*10, parameter :: num_lbl  = 'nspec=    '
  character*10, parameter :: nvec_lbl = 'dens=     '
  character*10, parameter :: tvec_lbl = 'temp=     '
  character*10, parameter :: avec_lbl = 'mass=     '
  character*10, parameter :: zvec_lbl = 'z=        '
  character*10, parameter :: npvec_lbl= 'fprim=    '
  character*10, parameter :: tpvec_lbl= 'tprim=    '
  character*10, parameter :: upvec_lbl= 'uprim=    '
  character*10, parameter :: nuvec_lbl= 'vnewk=    '
  character*10, parameter :: beta_lbl=  'beta=     '
  character*10, parameter :: irho_lbl=  'irho=     '
  character*10, parameter :: iflux_lbl= 'iflux=    '
  character*10, parameter :: lqeq_lbl=  'local_eq= '
  character*10, parameter :: irhoc_lbl= 'rhoc=     '
 
  character*24, parameter :: nlist_zeff = 'parameters'
  character*24, parameter :: nlist_nspc = 'species_knobs'
  character*24, parameter :: nlist_root = 'species_parameters_'
  character*24, parameter :: nlist_grid = 'theta_grid_eik_knobs'
  character*24, parameter :: nlist_grd2 = 'theta_grid_parameters'
 
  !
  contains
    subroutine trxpl_gs2_reset

      transp_path = ' '
      transp_time = 0.0d0
      transp_delt = 0.0d0
      transp_x = 0.0d0

    end subroutine trxpl_gs2_reset
end module trxpl_gs2_module

subroutine splitn_chkdp(zlin1,zlin2)

  use splitn_module
  implicit NONE

  character*(*), intent(inout) :: zlin1  ! namelist file input line (orig.)
  character*(*), intent(inout) :: zlin2  ! namelist file input line (uppercase)

  !  check that all non-null floating point value fields include a decimal
  !  point (needed for reliable portable reads).  If a value field lacks a
  !  decimal point, then, insert it in both zlin1 and zlin2, and increment
  !  the module's affected line character indices:  val2  lcmt  len1.

  !---------------------------
  integer iscan
  integer iw1,iw2,ir1,ir2,idelim,irepeat,iextra
  integer idp,insrt,inam2
  character*150 ztmp
  !---------------------------

  iscan = val1 - 1

  do
     call splitn_nxgrp(zlin2,iscan,iw1,iw2,idelim,ir1,ir2,irepeat,iextra)
     if(iw2.ge.iw1) then
        !  look for decimal pt.
        idp=index(zlin2(iw1:iw2),'.')

        if(idp.eq.0) then
           !  ...not found: insert & add to warning list
           !     decimal pt to be inserted before exponent field, or,
           !     at the end if there is not exponent field.

           inam2=index(zlin2(nam1:nam2),'(')
           if(inam2.eq.0) then
              inam2=nam2          ! point to end of name
           else
              inam2=inam2+nam1-2  ! point before left parenthesis
           endif
           call splitn_addwarn(zlin2(nam1:inam2),lackdp,nlackdp, &
                len(lackdp(1)),klackdp,maxwarn)

           insrt=index(zlin2(iw1:iw2),'E')
           if(insrt.eq.0) insrt=index(zlin2(iw1:iw2),'D')
           if(insrt.eq.0) then
              insrt=iw2+1
           else
              insrt=insrt+iw1-1
           endif

           ztmp=zlin1(1:insrt-1)//'.'
           ztmp(insrt+1:)=zlin1(insrt:)
           zlin1=ztmp

           ztmp=zlin2(1:insrt-1)//'.'
           ztmp(insrt+1:)=zlin2(insrt:)
           zlin2=ztmp

           iw2=iw2+1
           iscan=iscan+1
           idelim=idelim+1

           len1=len1+1
           if(lcmt.gt.0) lcmt=lcmt+1
           val2=val2+1

        endif

     endif

     if(idelim.ge.val2) then
        exit
     else
        iscan=idelim
     endif
  enddo

end subroutine splitn_chkdp

C  IADCI
C  Devel. from IADC3 -- replace ntmmx with NTIME2
C   Calc. the pointer to an element in the time-interpolated
C                                      FRBC moments C3 array
C       JFS  25 May 95
C
      Function iadci(d, ibase, ita, ixa, ima, iia )
 
      use trdatbuf_obj
      IMPLICIT NONE
      type (trdatbuf) :: d
 
C---------------------------------------------------------------------
 
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ibase,ita,ixa,ima,iia,iadci,in3,isizb
!============
      in3   = (ima + 1) + (iia-1) * (d%mmax+1)
 
      iadci = ibase + (ita-1)
     +              + (ixa-1) * D%NTIME2
     +              + (in3-1) * D%NTIME2 * d%nxmmx
 
      call datbuf_expand(d,iadci,isizb)
 
      Return
 
      End
! 19jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

subroutine tdb_pwrdata_avg(d,zpwr,ierr)
  use trdatbuf_obj
  use trdatbuf_aux
  implicit NONE

  !  get beam parameters averaged over a time step
  !  Mods
  !     dmc Aug 2007: if a time step of zero length is provided, 
  !                   impose instead a very small but finite time step).
  !
  !     08Aug2011     (to rev 15166 )    jim.conboy@ccfe.ac.uk
  !                   Revise error msgs, identify item requested
  !

  type (trdatbuf) :: d   ! trdat data object
  type (pwrget) :: zpwr  ! specification of desired parameters
  integer, intent(out) :: ierr   ! completion code (0=OK)

  integer :: lunmsg_tdb
  integer :: ipwr,iparam,inb,int,iadr,iadrp,ilt,ib,inbx
  real*8 :: zt1,zt2,zfdt,zpfdt,zpdt,ztdat1,ztdat2
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ZEPS = 1.0d-12
  real*8 :: tdbsub_i1,tdbsub_i2

  real*8 :: dtmin_fac,dtmin,zdelt

  character*3 zitem

  logical :: shortn,datlim
  character(len=*), parameter   :: cr="trdatbuf_lib/tdb_pwrdata_avg"
  !------------------------------------------------------
  !  error checks...
  ierr=0    ! think positive

  zpwr%zparam = ZERO

  !  zpwr is expected to have been initialized...
  if(zpwr%nguard.ne.123456789) then
     ierr=1
     write(lunmsg_tdb(0),*) &
          ' ?'//cr//': (pwrget) object was not initialized.'
  endif

  zitem=zpwr%item
  call uupper(zitem)

  shortn=.FALSE.
  datlim=.FALSE.

  if(zitem.eq.'PWR') then
     ipwr = d%lpwrnb
     inbx = d%nbdata
     iparam = d%lpwrnb
     ilt = d%ltimnb
     int = d%ntimnb

  else if(zitem.eq.'VLT') then
     ipwr = d%lpwrnb
     inbx = d%nbdata
     iparam = d%lvltnb
     ilt = d%ltimnb
     int = d%ntimnb

  else if(zitem.eq.'FUL') then
     ipwr = d%lpwrnb
     inbx = d%nbdata
     iparam = d%lfulnb
     ilt = d%ltimnb
     int = d%ntimnb

  else if(zitem.eq.'HLF') then
     ipwr = d%lpwrnb
     inbx = d%nbdata
     iparam = d%lhlfnb
     ilt = d%ltimnb
     int = d%ntimnb

  else if(zitem.eq.'RFP') then
     ipwr = d%lpwrrf
     inbx = d%nantich_d
     iparam = d%lpwrrf
     ilt = d%ltimrf
     int = d%ntimrf

  else if(zitem.eq.'RFF') then
     ipwr = d%lfrqrff    ! timebase difference; cannot use lpwrrf
     shortn = .TRUE.     ! constrain time average btw on & off times
     inbx = d%nantich_d
     iparam = d%lfrqrff
     ilt = d%ltimrff
     int = d%ntimrff

  else if(zitem.eq.'ECP') then
     ipwr = d%lpwrec
     inbx = d%nantech_d
     iparam = d%lpwrec
     ilt = d%ltimec
     int = d%ntimec

  else if(zitem.eq.'ECA') then
     ipwr = d%lfeca      ! timebase difference; cannot use lpwrec
     datlim = .TRUE.     ! constrain time average btw data start/stop times
     inbx = d%nantech_d
     iparam = d%lfeca
     ilt = d%ltimeca
     int = d%ntimeca

  else if(zitem.eq.'ECB') then
     ipwr = d%lfecb      ! timebase difference; cannot use lpwrec
     datlim = .TRUE.     ! constrain time average btw data start/stop times
     inbx = d%nantech_d
     iparam = d%lfecb
     ilt = d%ltimecb
     int = d%ntimecb

  else if(zitem.eq.'LHP') then
     ipwr = d%lpwrlh
     inbx = d%nantlh_d
     iparam = d%lpwrlh
     ilt = d%ltimlh
     int = d%ntimlh

  else
     ierr=3
     write(lunmsg_tdb(0),*) &
          ' ?'//cr//': unrecognized data item: "', zitem,'"'
  endif

  if(ipwr.eq.0) then
     ierr=2
     write(lunmsg_tdb(0),*) &
          ' ?'//cr//': called with no power data available -',zitem
  endif

  if(zpwr%ztime1.gt.zpwr%ztime2) then
     write(lunmsg_tdb(0),*) &
          ' ?'//cr//': averaging times out of order -',zitem
     write(lunmsg_tdb(0),*) &
          '  zpwr%ztime1 = ',zpwr%ztime1,'   zpwr%ztime2 = ',zpwr%ztime2
     if( zpwr%ztime1==0. .and.  zpwr%ztime2== -1. )  &
         write(lunmsg_tdb(0),*) &
           zitem,' parameters were  never set (?) '
     ierr=4
  endif

  if(zpwr%nbeam .ne. inbx) then
     write(lunmsg_tdb(0),*) ' ?',cr,': ',zitem, &
          '-  inconsistent #beams or #antennas in zpwr & d objects:'
     write(lunmsg_tdb(0),*) &
          '  in d = ',inbx,'   in zpwr = ',zpwr%nbeam
     ierr=5
  endif

  inb = zpwr%nbeam

  if(zpwr%tbon(1).gt.zpwr%tboff(1)) then
     write(lunmsg_tdb(0),*) &
          ' ?'//cr//': ',zitem,' - on/off times out of order:'
     write(lunmsg_tdb(0),*) &
          '  zpwr%tbon(1) = ',zpwr%tbon(1),'   zpwr%tboff(1) = ',zpwr%tboff(1)
     if( zpwr%tbon(1) == 0. .and. zpwr%tboff(1)== -1. )  &
        write(lunmsg_tdb(0),*) &
           zitem,' parameters were  never set (?) '
     ierr=6
  endif

  if(ierr.gt.0) then
     return
  endif

  !-----------
  !  OK...

  do ib=1,inb
     if(datlim) then
        ztdat1 = d%datbuf(ilt)
        ztdat2 = d%datbuf(ilt+int-1)
        zt1=max(ztdat1,min(ztdat2,zpwr%ztime1))
        zt2=max(ztdat1,min(ztdat2,zpwr%ztime2))
     else
        zt1=max(zpwr%ztime1,zpwr%tbon(ib))
        zt2=min(zpwr%ztime2,zpwr%tboff(ib))
     endif

     if(zt2.lt.zt1) then
        zpwr%zparam(ib)=ZERO

     else if( ((zt2.lt.zpwr%tbon(ib)).or.(zt1.gt.zpwr%tboff(ib))) .AND. &
          (.not.datlim) ) then
        zpwr%zparam(ib)=ZERO

     else
        dtmin_fac=zeps
        dtmin=max(zeps,zeps*max(abs(zt1),abs(zt2)))
        if(zt2.lt.zt1+dtmin) then
           zt2=zt1+dtmin
        endif

        if(zpwr%pweight) then
           iadrp = ipwr + (ib-1)*int
           iadr = iparam + (ib-1)*int
           zpdt = tdbsub_i1(zt1,zt2,d%datbuf(ilt),int,d%datbuf(iadrp))
           zpfdt = tdbsub_i2(zt1,zt2,d%datbuf(ilt),int, &
                d%datbuf(iadrp),d%datbuf(iadr))
           if(zpdt.le.ZERO) then
              zpwr%zparam(ib)=ZERO
           else
              zpwr%zparam(ib)=zpfdt/zpdt
           endif
        else
           iadr = iparam + (ib-1)*int
           zfdt = tdbsub_i1(zt1,zt2,d%datbuf(ilt),int,d%datbuf(iadr))
           if(shortn.or.datlim) then
              zdelt=(zt2-zt1)
           else
              zdelt=max(dtmin,(zpwr%ztime2-zpwr%ztime1))
           endif
           zpwr%zparam(ib)=zfdt/zdelt
        endif
     endif
  enddo

end subroutine tdb_pwrdata_avg

subroutine trx_wall(ilun,inumR,inumZ,ierr)
!  get the limiter locations; form (R,Z) grid to cover just this space...
!  see trx_wall_RZ (below).
!
  use trx_module, only: symZ

  implicit NONE
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
  integer ilun                ! lun for file read (input)
  integer inumR,inumZ         ! cartesian overlay grid sizes (input)
  integer ierr                ! completion code:  0=OK
!
  real*8 Rmin,Rmax            ! Rmin,Rmax of grid (0.0 for automatic grid)
  real*8 Zmin,Zmax            ! Zmin,Zmax of grid (0.0 for automatic grid)
!
  real*8 :: ztol
!
  symZ = .true.

  Rmin=0.0_R8
  Rmax=0.0_R8
  Zmin=0.0_R8
  Zmax=0.0_R8
  call trx_wall_rz(ilun,Rmin,Rmax,inumR,Zmin,Zmax,inumZ,ierr)
  return
end subroutine trx_wall

subroutine trx_wall_freebdy(ilun,ierr)

  use trx_module
  implicit NONE

  !  use the free bdy (R,Z) grid -- consider it an error if there is none

  integer, intent(in) :: ilun
  integer, intent(out) :: ierr

  !------------------------------
  integer :: lunzer
  !------------------------------

  if(min(nRfree,nZfree).eq.0) then
     ierr=1
     write(lunzer(0),*) ' ? trx_wall_freebdy: called w/o free bdy data.'
     return
  endif

  call trx_wall_grid(ilun,Rgrid_free,nRfree,Zgrid_free,nZfree,ierr)

end subroutine trx_wall_freebdy

subroutine trx_wall_grid(ilun,r8grid,inumR,z8grid,inumZ,ierr)
!  get the limiter locations; apply a prescribed (R,Z) grid


!  get the limiter locations; form (R,Z) grid to cover just this space...
!  see trx_wall_RZ (below).
!
  use trx_module, only: symZ

  implicit NONE
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
  integer ilun                ! lun for file read (input)
  integer inumR,inumZ         ! cartesian overlay grid sizes (input)
  real*8 R8grid(inumR),Z8grid(inumZ)  ! the grids themselves (input)
  integer ierr                ! completion code:  0=OK
!
  real*8 Rmin,Rmax            ! Rmin,Rmax of grid (0.0 for automatic grid)
  real*8 Zmin,Zmax            ! Zmin,Zmax of grid (0.0 for automatic grid)
!
  real*8 :: ztol
  integer :: id_R,id_Z
  integer :: lunzer
!
  symZ = .false.

  Rmin=-1.0_R8
  Rmax=-1.0_R8
  Zmin=-1.0_R8
  Zmax=-1.0_R8
  call trx_wall_rz(ilun,Rmin,Rmax,inumR,Zmin,Zmax,inumZ,ierr)

  ztol=0.01d0*max((Rmax-Rmin),(Zmax-Zmin))

  if((Rmin.lt.r8grid(1)-ztol).or.(Rmax.gt.r8grid(inumR)+ztol).or. &
       (Zmin.lt.z8grid(1)-ztol).or.(Zmax.gt.z8grid(inumZ)+ztol)) then
     write(lunzer(0),*) ' ?? coverage of grid is incomplete.'
     write(lunzer(0),*) '    R grid range: ',r8grid(1),r8grid(inumR)
     write(lunzer(0),*) '    need: ',Rmin,Rmax
     write(lunzer(0),*) '    Z grid range: ',z8grid(1),z8grid(inumZ)
     write(lunzer(0),*) '    need: ',Zmin,Zmax
     ierr=1
  else
     call eqm_rzgrid(r8grid,z8grid,-1,-1,inumR,inumZ,ztol, &
             id_R,id_Z,ierr)
  endif

  return
end subroutine trx_wall_grid
 
subroutine trx_wall_RZ(ilun,Rmin,Rmax,inumR,Zmin,Zmax,inumZ,ierr)
!
!  read from the TRANSP namelist the TRANSP circles & lines
!  limiter specifications, then create this limiter in xplasma,
!  and create an inumR x inumZ cartesian box that covers a
!  rectangular region enclosing both the core plasma and the
!  scrape-off plasma (btw limiter and core plasma)
!
!  MOD DMC Nov. 2006 -- use output database limiter if available...
!
  use trx_module

  implicit NONE
!
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer ilun                ! lun for file read (input)
  real*8 Rmin,Rmax            ! Rmin,Rmax of grid (0.0 for automatic grid)
  real*8 Zmin,Zmax            ! Zmin,Zmax of grid (0.0 for automatic grid)
  integer inumR,inumZ         ! cartesian overlay grid sizes (input)
  integer ierr                ! completion code:  0=OK
!
! **NOTE** Rmin,Rmax,Zmin,Zmax modified on output
!          to give the actual limits used, i.e. taking limiter
!          into account.  If these quantities are non-zero on
!          input, they define a minimum range to be covered,
!          which may be expanded to reach the limiter given
!          in the TRANSP namelist, if necessary.
!
! if Rmin,Rmax,Zmin and Zmax are  all <0, do not set the grid here;
! but DO return the approximate limiter Rmin,Rmax,Zmin,Zmax in these
! variables
!
! mod DMC Jan 2007 -- force Zmin = -Zmax !!
!   required for some physics codes that use geqdsk files generated
!   from xplasma
!
!--------------------------------------------------------------------
!
  integer ncirlm,nlinlm,itype,i,ilims,irank,idims(10)
  real*8, dimension(:), allocatable :: alnlimR,alnlimZ,alnlimt
  real*8, dimension(:), allocatable :: crlimR,crlimZ,crlimrad
  real*8, dimension(:), allocatable :: rpts,ypts
!
  real*8 Rmin_use,Rmax_use,Zmin_use,Zmax_use,zdist
  real*8 zRgrid(-1:inumR+2),zZgrid(-1:inumZ+2)
  real*8 zero,zone,zzdum
  real*8 ratmin,ratmax,zat
  real*8 rp1,yp1,rp2,yp2
!
! SINGLE precision for t1profil interface:
!
  real :: ztdum
  real, dimension(:), allocatable :: r4vals
!
  character*64 zlabel,zxabb
  character*32 zunits
  integer :: imulti,istype,ineed_grid,isize,idum
!
  logical :: nogrid
!
  integer lunzer
!
  data zero/0.0_R8/
  data zone/1.0_R8/
!
!--------------------------------------------------------------------
!    first see if limiter data is in the run output database
!
  nogrid=.FALSE.
  if(max(rmin,rmax,zmin,zmax).lt.zero) nogrid=.TRUE.

  call rplabel('RLIM',zlabel,zunits,imulti,istype)
  if(istype.gt.0) call rplabel('YLIM',zlabel,zunits,imulti,istype)

  if(istype.gt.0) then
     ineed_grid = 1
     call rpdims(istype,irank,idims,zxabb,ierr)
     if(ierr.ne.0) call bad_exit

     isize=idims(1)
     allocate(rpts(isize),ypts(isize),r4vals(isize))

     ztdum=0

     call t1profil('RLIM',zlabel,zunits,ztdum,ztdum, &
          istype,r4vals,isize,idum,ierr)
     if(ierr.ne.0) call bad_exit
     rpts = r4vals*0.01_R8  ! -> m

     call t1profil('YLIM',zlabel,zunits,ztdum,ztdum, &
          istype,r4vals,isize,idum,ierr)
     if(ierr.ne.0) call bad_exit
     ypts = r4vals*0.01_R8  ! -> m

!
! prevent limiter range from extending too far from plasma boundary unless it would cause a failure
!
     call rational_limiter(inumR, ratmin, ratmax, zat, ierr)
     if (ierr.eq.0) then
        rp1 = min(ratmax,max(ratmin,rpts(1)))
        yp1 = min(zat   ,max(-zat,  ypts(1)))

        do i=2,isize
           rp2 = min(ratmax,max(ratmin,rpts(i)))
           yp2 = min(zat   ,max(-zat,  ypts(i)))

           if((rp1.eq.rp2).and.(yp1.eq.yp2)) goto 150  ! eqm_cbdy will fail -- try to avoid this

           rp1=rp2
           yp1=yp2
        end do

        rpts = min(rpts,ratmax)
        rpts = max(rpts,ratmin)
        ypts = min(ypts,zat)
        ypts = max(ypts,-zat)

150     continue
     else
        write(lunzer(0),*) ' !trxplib: unexpected error finding plasma boundary before limiter'  
     end if

     call eqm_cbdy(isize,rpts,ypts,ierr)
     if(ierr.eq.0) then
!
!  fetch (R,Z) limits needed to cover limiters
!
        if(nogrid) then
           call my_eq_bdlims(itype,Rmin,Rmax,Zmin,Zmax,ierr)
        else
           call my_eq_bdlims(itype,Rmin_use,Rmax_use,Zmin_use,Zmax_use,ierr)
        endif
     endif

  else
     write(lunzer(0),*) ' %trxplib: no contour limiter; use namelist...'
!--------------------------------------------------------------------
!    no limiter data in database so...
!
!    read the TRANSP namelist; get limiter / wall information
!
     call tr_getnl_text(ilun,ierr)  ! try reading the namelist
!
!  namelist read completed
!--------------------------------------------------------------------
!  get the limiter info ...
!
!  no. of TRANSP limiters
     call trx_getnlims(ncirlm,nlinlm,ierr)
     if(ierr.ne.0) return
!
!  circular limiters
!
     allocate(crlimR(max(1,ncirlm)))
     allocate(crlimZ(max(1,ncirlm)))
     allocate(crlimrad(max(1,ncirlm)))
     crlimR=0
     crlimZ=0
     crlimrad=0
     if(ncirlm.gt.0) call trx_getcrlim(ncirlm,crlimR,crlimZ,crlimrad,ierr)
     if(ierr.ne.0) go to 200
!
!  line limiters
!
     allocate(alnlimR(max(1,nlinlm)))
     allocate(alnlimZ(max(1,nlinlm)))
     allocate(alnlimt(max(1,nlinlm)))
     alnlimR=0
     alnlimZ=0
     alnlimt=0
     if(nlinlm.gt.0) call trx_getlnlim(nlinlm,alnlimR,alnlimZ,alnlimt,ierr)
     if(ierr.ne.0) go to 100
!
     ilims=nlinlm+ncirlm
     if(ilims.eq.0) then
        call eq_glimrz(zone,Rmin_use,Rmax_use,Zmin_use,Zmax_use,ierr)
        Zmax_use = max(abs(Zmin_use),abs(Zmax_use))
        Zmin_use = -Zmax_use
        if(ierr.ne.0) call bad_exit
        zdist=0.05*(Rmax_use-Rmin_use)
        write(lunzer(0),*) ' %trx_wall: no limiter spec in namelist.'
        write(lunzer(0),*) '  --assuming distance bdy to wall is:  ',zdist
     endif
!
!  OK -- call xplasma setup routine
!
     if((Rmin.eq.zero).and.(Rmax.eq.zero).and. &
          (Zmin.eq.zero).and.(Zmax.eq.zero)) then

        ineed_grid = 0

        if(ilims.gt.0) then
           call eqm_tbdy_grid(nlinlm,alnlimR,alnlimZ,alnlimt, &
                ncirlm,crlimR,crlimZ,crlimrad, &
                inumR,inumZ, &
                id_R,id_Z, ierr)
           call my_eq_bdlims(itype,Rmin,Rmax,Zmin,Zmax,ierr)
        else
           Rmin=Rmin_use-zdist
           Rmax=Rmax_use+zdist
           Zmin=Zmin_use-zdist
           Zmax=Zmax_use+zdist
           call eqm_dbdy_grid(zdist,Rmin,Rmax,Zmin,Zmax, &
                inumR,inumZ, &
                id_R,id_Z, ierr)
        endif
     else
!
!  set up limiters
!
        ineed_grid = 1

        if(ilims.gt.0) then
           call eqm_tbdy(nlinlm,alnlimR,alnlimZ,alnlimt, &
                ncirlm,crlimR,crlimZ,crlimrad, ierr)
           if(ierr.eq.0) then
!
!  fetch (R,Z) limits needed to cover limiters
!
              if(nogrid) then
                 call my_eq_bdlims(itype,Rmin,Rmax,Zmin,Zmax,ierr)
              else
                 call my_eq_bdlims(itype,Rmin_use,Rmax_use,Zmin_use,Zmax_use, &
                      ierr)
              endif
!
           endif
!
        else
!
!  const. dist. limiter
!
           Rmin_use=Rmin_use-zdist
           Rmax_use=Rmax_use+zdist
           Zmin_use=Zmin_use-zdist
           Zmax_use=Zmax_use+zdist
           if(nogrid) then
              Rmin=Rmin_use
              Rmax=Rmax_use
              Zmin=Zmin_use
              Zmax=Zmax_use
           endif
           call eqm_dbdy(zdist,Rmin_use,Rmax_use,Zmin_use,Zmax_use,ierr)
!
        endif
     endif
  endif
!
!  limiter acquired...
!  expand to user specified limits if necessary
!
  if(nogrid) ineed_grid=0
  if(ineed_grid.eq.1) then
     if(ierr.eq.0) then
        if((Rmin.ne.zero).or.(Rmax.ne.zero)) then
           Rmin_use=min(Rmin_use,Rmin)
           Rmax_use=max(Rmax_use,Rmax)
        endif
        if((Zmin.ne.zero).or.(Zmax.ne.zero)) then
           Zmin_use=min(Zmin_use,Zmin)
           Zmax_use=max(Zmax_use,Zmax)
           if (symZ) then
              Zmax_use = max(abs(Zmin_use),abs(Zmax_use))
              Zmin_use = -Zmax_use
           end if
        endif
!
!  generate grids -- 2 zones extra on each side
!
        do i=-1,inumR+2
           zRgrid(i)=Rmin_use+(i-1)*(Rmax_use-Rmin_use)/(inumR-1)
        enddo
        do i=-1,inumZ+2
           zZgrid(i)=Zmin_use+(i-1)*(Zmax_use-Zmin_use)/(inumZ-1)
        enddo
!
!  create the grids in the xplasma module
!
        call eqm_rzgrid(zRgrid,zZgrid,0,0,inumR+4,inumZ+4,1.0E-5_R8, &
             id_R,id_Z,ierr)
!
        Rmin=Rmin_use
        Rmax=Rmax_use
        Zmin=Zmin_use
        Zmax=Zmax_use
!
     endif
  endif

!  cleanup

100 continue
  if(allocated(alnlimR)) then
     deallocate(alnlimR)
     deallocate(alnlimZ)
     deallocate(alnlimt)
  endif

200 continue
  if(allocated(crlimR)) then
     deallocate(crlimR)
     deallocate(crlimZ)
     deallocate(crlimrad)
  endif

  if(allocated(rpts)) deallocate(rpts,ypts,r4vals)

  return

  contains

    subroutine my_eq_bdlims(itype,Rmini,Rmaxi,Zmini,Zmaxi,ierr)
      integer :: itype
      real*8 :: Rmini,Rmaxi,Zmini,Zmaxi
      integer :: ierr

      !  call eq_bdlims; then enforce Zmini = -Zmaxi

      call eq_bdlims(itype,Rmini,Rmaxi,Zmini,Zmaxi,ierr)
      if (symZ) then
         Zmaxi = max(abs(Zmini),abs(Zmaxi))
         Zmini = -Zmaxi
      end if
    end subroutine my_eq_bdlims

    !
    ! expect a real limiter to be within these limits
    !
    subroutine rational_limiter(ir, rrat_min, rrat_max, zrat, ii)
      use xplasma_obj_instance, only: s
      use xplasma_ctran,        only: xplasma_RZminmax_plasma
      implicit none

      real*8, parameter :: RMIN_FRAC = 0.05d0   ! limiter no closer to 0 then RMIN_FRAC*rbdy_min
      real*8, parameter :: RMAX_FAC  = 0.7d0    ! limiter no further from rbdy_max then RMAX_FRAC*rcenter
      real*8, parameter :: ZR_FAC    = 0.7d0    ! limiter no further from |zbdy| then ZR_FAC*rcenter
      
      integer, intent(in)  :: ir        ! number of R grid points
      real*8,  intent(out) :: rrat_min  ! minimum acceptable R of limiter for gridding
      real*8,  intent(out) :: rrat_max  ! maximum acceptable R of limiter for gridding
      real*8,  intent(out) :: zrat      ! maximum acceptable |Z| of limiter for gridding
      integer, intent(out) :: ii        ! nonzero on error

      real*8 :: rm,rp,zm,zp   ! bdy limits
      real*8 :: rc            ! approximate R center

      ii = 0
      call xplasma_RZminmax_plasma(s, rm,rp, zm,zp, ii)
      
      if (ii==0 .and. rm>0.d0 .and. rp>rm .and. zp>zm) then
         rc = (rm+rp)/2.d0
         
         rrat_max = rp + RMAX_FAC*rc
         rrat_min = RMIN_FRAC*rm
         if (ir>1) rrat_min=max(rrat_min, rrat_max*2.5d0/(ir+1))   ! keep ghost zone>0, rrat_min>2*rrat_max/(ir+1)
         
         zrat = max(abs(zm),abs(zp)) + ZR_FAC*rc
      else
         ii = 1
      end if
    end subroutine rational_limiter
end subroutine trx_wall_RZ

subroutine trxpl_ascii_write(apath,kx,kr)
 
  !  write ASCII file of accumulated scalar and profile data...
 
  implicit NONE
 
  character*(*), intent(in) :: apath   ! filename
  integer, intent(in) :: kx            ! grid option for flux coordinate
  integer, intent(in) :: kr            ! grid option for major radius
 
  include 'trxpl.blk'
 
  !------------------------------------------------------
  real*8, dimension(:), allocatable :: zxtmp,zx,zr,zfx,zfr
  integer :: inumx,inumr,intmp,idum,ierr,i,j,k,ios,ilf
  integer :: id_rho=0,id_rhozc=0,id_rmajm=0,id_rmjsym=0,inumpx,inumpr
  !------------------------------------------------------
 
  call eq_ganum('__RHO',id_rho)
  call eq_ganum('RHO_ZC',id_rhozc)
  call eq_ganum('RMAJM',id_rmajm)
  call eq_ganum('RMJSYM',id_rmjsym)
 
  inumpx=0
  inumpr=0
  do i=1,numpro
     if((id_xaxis(i).eq.id_rho).or.(id_xaxis(i).eq.id_rhozc)) then
        inumpx=inumpx+1
     else if((id_xaxis(i).eq.id_rmajm).or.(id_xaxis(i).eq.id_rmjsym)) then
        inumpr=inumpr+1
     else
        write(6,*) 'profile skipped: x axis not recognized: ',prolabs(1:3,i)
     endif
  enddo
 
 
  !  setup user requested flux coord grid
 
  call eq_ngrid(id_rho,intmp)
  allocate(zxtmp(intmp))
  call eq_grid(id_rho,zxtmp,intmp,idum,ierr)
  if(ierr.ne.0) call errmsg_exit(' ?trxpl: code error, trxpl_ascii_write')
 
  if(kx.gt.0) then
     inumx=1+kx*(intmp-1)
     allocate(zx(inumx))
     zx(1)=zxtmp(1)
     do i=2,inumx
        j=1+(i-1)/kx    ! if kx=3: 1 1 2 2 2 3 3 3 ...
        k=i-(j-1)*kx-1  ! if kx=3: 1 2 0 1 2 0 1 2 ...
        if(j.eq.intmp) then
           j=intmp-1
           k=k+kx
        endif
        zx(i)=(zxtmp(j)*(kx-k)+zxtmp(j+1)*k)/kx
     enddo
  else
     inumx=-kx
     allocate(zx(inumx))
     do i=1,inumx
        zx(i)=(zxtmp(1)*(inumx-i)+zxtmp(intmp)*(i-1))/(inumx-1)
     enddo
  endif
  deallocate(zxtmp)
 
  allocate(zfx(inumx))  ! data buffer
 
  !  setup user requested major radius coord grid
 
  call eq_ngrid(id_rmajm,intmp)
  allocate(zxtmp(intmp))
  call eq_grid(id_rmajm,zxtmp,intmp,idum,ierr)
  if(ierr.ne.0) call errmsg_exit(' ?trxpl: code error, trxpl_ascii_write')
 
  if(kr.gt.0) then
     inumr=1+kr*(intmp-1)
     allocate(zr(inumr))
     zr(1)=zxtmp(1)
     do i=2,inumr
        j=1+(i-1)/kr    ! if kr=3: 1 1 2 2 2 3 3 3 ...
        k=i-(j-1)*kr-1  ! if kr=3: 1 2 0 1 2 0 1 2 ...
        if(j.eq.intmp) then
           j=intmp-1
           k=k+kr
        endif
        zr(i)=(zxtmp(j)*(kr-k)+zxtmp(j+1)*k)/kr
     enddo
  else
     inumr=-kr
     allocate(zr(inumr))
     do i=1,inumr
        zr(i)=(zxtmp(1)*(inumr-i)+zxtmp(intmp)*(i-1))/(inumr-1)
     enddo
  endif
  deallocate(zxtmp)
 
  allocate(zfr(inumr))  ! data buffer
 
  !---------------------------------------
  !  open file... move existing one out of way if necessary
 
  ilf=len_trim(apath)
 
  open(unit=99,file=apath,status='old',iostat=ios)
  if(ios.eq.0) then
     close(unit=99)
     write(6,*) ' %trxpl warning: file exists: ',apath(1:ilf)
     write(6,*) '  renamed to: ',apath(1:ilf)//'~'
     call frename(apath(1:ilf),apath(1:ilf)//'~',idum)
  endif
 
  open(unit=99,file=apath,status='new',iostat=ios)
  if(ios.ne.0) then
     write(6,*) ' ?trxpl: open failure: ',apath(1:ilf)
     write(6,*) '  data not written.'
     deallocate(zx,zfx,zr,zfr)
     return
  endif
 
  !---------------------------------------
  !  write scalars
 
  write(99,'(" ---> scalar_info: numsc=",i4)') numsc
  do i=1,numsc
     write(99,1001) sclabs(1,i),sclabs(2,i),sclabs(3,i),scvals(i)
1001 format(1x,a,1x,a,a,1x,' = ',1pd13.6)
  enddo
 
1009 format(1x,1pd13.6)
 
  !---------------------------------------
  !  write profiles vs. x
 
  write(99,'(" ---> profiles_vs_x: numpro=",i4," inumx=",i4," x follows:")') &
       inumpx,inumx
  do i=1,inumx
     write(99,1009) zx(i)
  enddo
  do j=1,numpro
     if((id_xaxis(j).eq.id_rho).or.(id_xaxis(j).eq.id_rhozc)) then
        call eq_rgetf(inumx,zx,id_pros(j),0,zfx,ierr)
        if(ierr.ne.0) call errmsg_exit(' ?trxpl: internal error 1.')
        write(99,1010) prolabs(1,j),prolabs(2,j),prolabs(3,j)
        do i=1,inumx
           write(99,1009) zfx(i)
        enddo
     endif
  enddo
 
  !---------------------------------------
  !  write profiles vs. R
 
  write(99,'(" ---> profiles_vs_R: numpro=",i4," inumR=",i4," R (m) follows:")') &
       inumpr,inumr
  do i=1,inumR
     write(99,1009) zr(i)
  enddo
  do j=1,numpro
     if((id_xaxis(j).eq.id_rmajm).or.(id_xaxis(j).eq.id_rmjsym)) then
        call eq_xgetf(inumr,zr,id_pros(j),0,zfr,ierr)
        if(ierr.ne.0) call errmsg_exit(' ?trxpl: internal error 1.')
        write(99,1010) prolabs(1,j),prolabs(2,j),prolabs(3,j)
        do i=1,inumr
           write(99,1009) zfr(i)
        enddo
     endif
  enddo
 
1010 format(1x,'name: ',a,a,1x,'units: ',a,' data:')
 
  close(unit=99)
 
  deallocate(zx,zfx,zr,zfr)
  write(6,*) ' --------------------------------------- '
  write(6,*) ' succesfully wrote: ',apath(1:ilf)
  write(6,*) ' --------------------------------------- '
 
  return
 
end subroutine trxpl_ascii_write

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy(cclist,ss,ss2,idims_only,idata_only, &
                             icopy_lists, iwant_1deq, &
                             ierr)

  ! Copy plasma state ss -> ss2
  !   this routine ONLY copies the state object in memory
  !   a separate step is needed to deal with backing files & interpolation
  !     data.

  ! cclist(...) control specifies the components for which all grids and
  !   profiles are copied.  If cclist(j)=1 all are copied for component j.
  !   If cclist(j)=0, only scalars, species lists, and item lists are copied;
  !   profiles and grids and grid dimensions for component j are not
  !   copied in this case.

  ! if icopy_lists=0, cclist(j)=0 suppresses copy of item lists for
  ! component j, as well as profiles and grids.  Note that species lists
  ! are shared accross components; copying cannot be suppressed.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to fully copy
                                ! use ps_cc_all to copy all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: idims_only  ! =1 to copy dimensions ONLY: no alloc

  INTEGER, INTENT(IN) :: idata_only  ! =1 to copy data ONLY: non-zero dims
                                     ! MUST match
                                     ! =0: dims are copied.

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,ii,itot,isize,jsize,iertmp
  INTEGER :: ilock_mdescr,ilock_sconfig,ilock_siminit
  LOGICAL :: partial_copy
  !-------------------

  ierr = 0
  iout = SWIM_err_out_file

  IF((idata_only.EQ.1).or.(idims_only.EQ.1)) then
     partial_copy=.TRUE.
  ELSE
     partial_copy=.FALSE.
     DO ii=1,ps_ccount
        IF(ps_cc_all(ii).NE.cclist(ii)) THEN
           partial_copy=.TRUE.
        ENDIF
     ENDDO
  ENDIF

  !---------------------------------------------------
  ! copy array dimensions (grids for indicated components only...)


  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     ss%max_nrz_antgeo = max(ss%max_nrz_antgeo,maxval(ss%nrz_antgeo))
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     ss%max_nspectrumlh_src = max(ss%max_nspectrumlh_src,maxval(ss%nspectrumlh_src))
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     ss%max_num_nphi = max(ss%max_num_nphi,maxval(ss%num_nphi))
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     ss%max_num_nphi_vac = max(ss%max_num_nphi_vac,maxval(ss%num_nphi_vac))
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     ss%max_n_straps = max(ss%max_n_straps,maxval(ss%n_straps))
  ENDIF

  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_IC).EQ.1)) &
           call copydim("max_nrz_antgeo", ss%max_nrz_antgeo,ss2%max_nrz_antgeo)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LH).EQ.1)) &
           call copydim("max_nspectrumlh_src", ss%max_nspectrumlh_src,ss2%max_nspectrumlh_src)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_IC).EQ.1)) &
           call copydim("max_num_nphi", ss%max_num_nphi,ss2%max_num_nphi)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_IC).EQ.1)) &
           call copydim("max_num_nphi_vac", ss%max_num_nphi_vac,ss2%max_num_nphi_vac)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_IC).EQ.1)) &
           call copydim("max_n_straps", ss%max_n_straps,ss2%max_n_straps)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) &
           call copydim("mmodes", ss%mmodes,ss2%mmodes)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) &
           call copydim("nballoon", ss%nballoon,ss2%nballoon)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_NBI).EQ.1)) &
           call copydim("nbeam", ss%nbeam,ss2%nbeam)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EQ).EQ.1)) &
           call copydim("ncircuits", ss%ncircuits,ss2%ncircuits)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EQ).EQ.1)) &
           call copydim("ncoils", ss%ncoils,ss2%ncoils)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) &
           call copydim("ndelta_w", ss%ndelta_w,ss2%ndelta_w)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EC).EQ.1)) &
           call copydim("necrf_src", ss%necrf_src,ss2%necrf_src)
  IF(cclist(ps_cnum_ANOM).EQ.1) &
           call copydim("nefi_anom", ss%nefi_anom,ss2%nefi_anom)
  IF(cclist(ps_cnum_ANOM).EQ.1) &
           call copydim("nefi_anom2", ss%nefi_anom2,ss2%nefi_anom2)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EQ).EQ.1)) &
           call copydim("neqmom", ss%neqmom,ss2%neqmom)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_GAS).EQ.1)) &
           call copydim("ngsc0", ss%ngsc0,ss2%ngsc0)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_IC).EQ.1)) &
           call copydim("nicrf_src", ss%nicrf_src,ss2%nicrf_src)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_ANOM).EQ.1)) &
           call copydim("nky_anomth", ss%nky_anomth,ss2%nky_anomth)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_ANOM).EQ.1)) &
           call copydim("nky_mmm", ss%nky_mmm,ss2%nky_mmm)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LH).EQ.1)) &
           call copydim("nlhrf_src", ss%nlhrf_src,ss2%nlhrf_src)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) &
           call copydim("nnewcomb", ss%nnewcomb,ss2%nnewcomb)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EQ).EQ.1)) &
           call copydim("npsmom", ss%npsmom,ss2%npsmom)
  IF(cclist(ps_cnum_EQ).EQ.1) &
           call copydim("nr", ss%nr,ss2%nr)
  IF(cclist(ps_cnum_PLASMA).EQ.1) &
           call copydim("nrho", ss%nrho,ss2%nrho)
  IF(cclist(ps_cnum_ANOM).EQ.1) &
           call copydim("nrho_anom", ss%nrho_anom,ss2%nrho_anom)
  IF(cclist(ps_cnum_ANOM).EQ.1) &
           call copydim("nrho_anom2", ss%nrho_anom2,ss2%nrho_anom2)
  IF(cclist(ps_cnum_ANOM).EQ.1) &
           call copydim("nrho_anomth", ss%nrho_anomth,ss2%nrho_anomth)
  IF(cclist(ps_cnum_EC).EQ.1) &
           call copydim("nrho_ecrf", ss%nrho_ecrf,ss2%nrho_ecrf)
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(IWANT_1dEQ.eq.1)) &
           call copydim("nrho_eq", ss%nrho_eq,ss2%nrho_eq)
  IF(cclist(ps_cnum_EQ).EQ.1) &
           call copydim("nrho_eq_geo", ss%nrho_eq_geo,ss2%nrho_eq_geo)
  IF(cclist(ps_cnum_FUS).EQ.1) &
           call copydim("nrho_fus", ss%nrho_fus,ss2%nrho_fus)
  IF(cclist(ps_cnum_GAS).EQ.1) &
           call copydim("nrho_gas", ss%nrho_gas,ss2%nrho_gas)
  IF(cclist(ps_cnum_IC).EQ.1) &
           call copydim("nrho_icrf", ss%nrho_icrf,ss2%nrho_icrf)
  IF(cclist(ps_cnum_LH).EQ.1) &
           call copydim("nrho_lhrf", ss%nrho_lhrf,ss2%nrho_lhrf)
  IF(cclist(ps_cnum_LMHD).EQ.1) &
           call copydim("nrho_lmhd", ss%nrho_lmhd,ss2%nrho_lmhd)
  IF(cclist(ps_cnum_RAD).EQ.1) &
           call copydim("nrho_mist", ss%nrho_mist,ss2%nrho_mist)
  IF(cclist(ps_cnum_NBI).EQ.1) &
           call copydim("nrho_nbi", ss%nrho_nbi,ss2%nrho_nbi)
  IF(cclist(ps_cnum_PEL).EQ.1) &
           call copydim("nrho_pel", ss%nrho_pel,ss2%nrho_pel)
  IF(cclist(ps_cnum_RAD).EQ.1) &
           call copydim("nrho_rad", ss%nrho_rad,ss2%nrho_rad)
  IF(cclist(ps_cnum_RUNAWAY).EQ.1) &
           call copydim("nrho_rw", ss%nrho_rw,ss2%nrho_rw)
  IF(cclist(ps_cnum_RIPPLE).EQ.1) &
           call copydim("nr_rip", ss%nr_rip,ss2%nr_rip)
  call copydim("nspec_all", ss%nspec_all,ss2%nspec_all)
  call copydim("nspec_alla", ss%nspec_alla,ss2%nspec_alla)
  call copydim("nspec_beam", ss%nspec_beam,ss2%nspec_beam)
  call copydim("nspec_fusion", ss%nspec_fusion,ss2%nspec_fusion)
  call copydim("nspec_gas", ss%nspec_gas,ss2%nspec_gas)
  call copydim("nspec_imp0", ss%nspec_imp0,ss2%nspec_imp0)
  call copydim("nspec_impi", ss%nspec_impi,ss2%nspec_impi)
  call copydim("nspec_rfmin", ss%nspec_rfmin,ss2%nspec_rfmin)
  call copydim("nspec_th", ss%nspec_th,ss2%nspec_th)
  call copydim("nspec_tha", ss%nspec_tha,ss2%nspec_tha)
  IF(cclist(ps_cnum_EQ).EQ.1) &
           call copydim("nth_eq", ss%nth_eq,ss2%nth_eq)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) &
           call copydim("ntrcat", ss%ntrcat,ss2%ntrcat)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_EQ).EQ.1)) &
           call copydim("num_rzlim", ss%num_rzlim,ss2%num_rzlim)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_RAD).EQ.1)) &
           call copydim("nxs", ss%nxs,ss2%nxs)
  IF(cclist(ps_cnum_EQ).EQ.1) &
           call copydim("nz", ss%nz,ss2%nz)
  IF(cclist(ps_cnum_RIPPLE).EQ.1) &
           call copydim("nz_rip", ss%nz_rip,ss2%nz_rip)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_NBI).EQ.1)) &
           call copydim("n_D_einj_standard", ss%n_D_einj_standard,ss2%n_D_einj_standard)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_NBI).EQ.1)) &
           call copydim("n_H_einj_standard", ss%n_H_einj_standard,ss2%n_H_einj_standard)
  IF((icopy_lists.EQ.1).OR.(cclist(ps_cnum_NBI).EQ.1)) &
           call copydim("n_T_einj_standard", ss%n_T_einj_standard,ss2%n_T_einj_standard)

  IF(ierr.NE.0) return
  IF(idims_only.EQ.1) return

  !---------------------------------------------------
  ! allocate ss2 arrays as allowed by non-zero dimensions

  call plasma_state_empty_alloc(ss2,ierr)
  IF(ierr.NE.0) RETURN

  !---------------------------------------------------
  ! copy scalars and arrays that are allocated...
  ! (but not array dimensions)

  call plasma_state_copy_0(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_1(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_2(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_3(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_4(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_5(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_6(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_7(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_8(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)
  call plasma_state_copy_9(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)

  IF(partial_copy) THEN
     IF(ss2%lock_sim_init.EQ.ps_locked) THEN
        WRITE(iout,*) ' %plasma_state_copy: partial copy: Simulation_Init unlocked.'
        ss2%lock_sim_init = ps_unlocked
     ENDIF
  ENDIF

  ! set hash codes of new copy of state

  ilock_mdescr = ss2%lock_machine_descr
  ilock_sconfig = ss2%lock_shot_config
  ilock_siminit = ss2%lock_sim_init

  ss2%lock_machine_descr = ps_unlocked
  ss2%lock_shot_config = ps_unlocked
  ss2%lock_sim_init = ps_unlocked

  CALL plasma_state_hash_code(ss2,ps_cc_all,iertmp)
  IF(idata_only.NE.1) THEN
     ss2%hash_codes = ss2%new_hash_codes
  ENDIF

  if(cclist(ps_cnum_EQ).eq.1) THEN
     ! copy aux hash codes
     ss2%hash_codes(ps_hash_aux1:ps_hash_aux9+1) = ss%hash_codes(ps_hash_aux1:ps_hash_aux9+1)
     ss2%new_hash_codes(ps_hash_aux1:ps_hash_aux9+1) = ss%new_hash_codes(ps_hash_aux1:ps_hash_aux9+1)

  endif

  ss2%lock_machine_descr = ilock_mdescr
  ss2%lock_shot_config = ilock_sconfig
  ss2%lock_sim_init = ilock_siminit

contains

  subroutine copydim(name,fromdim,todim)

    character*(*), intent(in) :: name
    integer, intent(in) :: fromdim
    integer, intent(inout) :: todim

    if (fromdim.eq.0) then
       continue             ! (old value retained in target state)

    else if(todim.eq.0) then
       if(idata_only.eq.0) then
          todim = fromdim      ! (dimension value is copied)
       endif

    else if(todim.ne.fromdim) then
       ierr = 1             ! (both non-zero and values are unequal)
       write(iout,*) ' ?PLASMA_STATE_COPY: target state array dimension has'
       write(iout,*) '  inconsistent value: dimension name is: '//trim(name)
       write(iout,*) '  source state value: ',fromdim,'; target state value: ',todim
    endif
  end subroutine copydim

END SUBROUTINE plasma_state_copy

C--------------------------------------------------------------------
      subroutine trxpl_path(tpath,ztime0,ztavg,ntheta,
     >   Rmin,Rmax,nR,Zmin,Zmax,nZ,
     >   ibccw,ipccw)
C
C  specify TRANSP runid, desired time, time averaging & #theta pts
C
      implicit NONE
C
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      character*(*) tpath               ! run path (file or MDS+)
      real*8 ztime0                     ! time of interest
      real*8 ztavg                      ! +/- delta(t)
      integer ntheta                    ! #of theta pts for bicubic splines

      real*8 Rmin,Rmax                  ! desired (R) range or 0 for defaults
      real*8 Zmin,Zmax                  ! desired (Z) range or 0 for defaults
      integer nR,nZ                     ! #of (R,Z) pts for external grid

      integer ibccw                     ! +1 for Bt counterclockwise, -1 o.w.
      !  leave at 0 to read from TRANSP "trdatbuf" data
      integer ipccw                     ! +1 for Ip counterclockwise, -1 o.w.
      !  leave at 0 to read from TRANSP "trdatbuf" data
C
C--------------
C
      integer ilt,iert,idcod,ifree
C
      integer icall,icallRZ
C
      character*25 ccwlbl(-1:1)
C
      character*1 zans
C
      real*8 zt1,zt2
      integer :: insc,inpr
C
      real*8, parameter :: ZERO = 0.0d0
C---------------
C  functions...
C
      integer lnout                     ! tty lun
      logical lxout                     ! menu output flag
      logical lchar                     ! response test
      logical lyes                      ! test for "Y" or discard input char
      logical :: ltrx_freebdy           ! test for free bdy data
      real*8 :: r8dcod
C---------------
C
      data ccwlbl/'clockwise ',
     >     'set from TRANSP data','counter-clockwise '/
C
      data icall/0/
      data icallRZ/0/
C
C----------------------------
C
      icall=icall+1
      if(icall.eq.1) then
         ntheta=151
      endif

      icallRZ=icallRZ+1
      if(icallRZ.eq.1) then
         nR=101
         nZ=101
      endif
C
      Rmin=0.0_R8
      Rmax=0.0_R8
      Zmin=0.0_R8
      Zmax=0.0_R8
C
 10   continue
c
      call trxpl_path0(tpath)
      if(tpath.eq.' ') return
      ilt=len_trim(tpath)
C
      call trx_connect(tpath,iert)
      if(iert.ne.0) go to 10
C
      call trx_tlims(zt1,zt2,iert)
      call trx_ntimes(insc,inpr,iert)
      write(6,*) ' '
      write(6,*) ' trxpl:  connected to run ',tpath(1:ilt)
      write(6,'(A,2(1x,1pe12.5))') '   time range (seconds): ',zt1,zt2
      write(6,*) '   #time pts: scalars: ',insc,'; profiles: ',inpr
      write(6,*) ' '
C
      if(ltrx_freebdy(0)) then
         ifree=1
         write(6,*) ' ===> Free Boundary Equilibrium Available.'
         icallRZ = 0

         call trx_freebdy_RZgridSize(nR,nZ)

         call trx_freebdy_RZminmax(Rmin,Rmax,Zmin,Zmax)
      else
         ifree = 0   ! prescribed bdy only
         write(6,*) ' (no free boundary data).'
      endif
      write(6,*) ' '
C
C  OK... now get time of interest   & #ntheta
C
 100  continue
      call ureadr8('trxpl_path:  time of interest:$',ztime0)
      call trxpl_path_dtavg('trxpl_path:  +/- averging time (.ge.0):$',
     >     ztime0,ztavg,zans)
      if(zans.eq.'Q') go to 100
C
      if(lxout(0)) write(lnout(0),*)
     >   ' %for theta reversal test, give ntheta.lt.0:'
      call ureadi('trxpl_path:  #theta pts for 2d splines:$',ntheta)
      if(ifree.eq.0) then
         call ureadi(
     >        'trxpl_path:  #R pts for cartesian overlay grid:$',nR)
         call ureadi(
     >        'trxpl_path:  #Z pts for cartesian overlay grid:$',nZ)
      endif
C
 110  continue
      if(lxout(0)) write(lnout(0),*)
     >     ' "ccw" means "counter-clockwise looking down from above".'
      if(lxout(0)) write(lnout(0),*)
     >     ' ...enter "-1" for clockwise orientation.'
      if(lxout(0)) write(lnout(0),*)
     >     ' ...enter "0" to read orientation from TRANSP data archive.'
      call uread(
     >   'trxpl_path:  enter "1" for if Btoroidal is ccw:$')
      ibccw=idcod(iert)
      if(iert.ne.0) go to 110
      if(abs(ibccw).gt.1) then
         call uermsi(' ccw option:  enter 0, 1 or -1',ibccw,0)
         go to 110
      endif
C
 120  continue
      if(lxout(0)) write(lnout(0),*)
     >     ' "ccw" means "counter-clockwise looking down from above".'
      if(lxout(0)) write(lnout(0),*)
     >     ' ...enter "-1" for clockwise orientation.'
      if(lxout(0)) write(lnout(0),*)
     >     ' ...enter "0" to read orientation from TRANSP data archive.'
      call uread(
     >   'trxpl_path:  enter "1" for if Plasma current is ccw:$')
      ipccw=idcod(iert)
      if(iert.ne.0) go to 120
      if(abs(ipccw).gt.1) then
         call uermsi(' ccw option:  enter 0, 1 or -1',ipccw,0)
         go to 120
      endif
C
 150  continue
      write(lnout(0),*) ' path:  ',tpath
      write(lnout(0),*) ' time of interest:  ',ztime0
      write(lnout(0),*) ' +/- averaging time: ',ztavg
      write(lnout(0),*) ' # of theta pts:    ',abs(ntheta)
      if(ntheta.lt.0) write(lnout(0),*)
     >   ' *** theta reversal test requested *** '
      write(lnout(0),*) ' # of R pts:        ',nR
      write(lnout(0),*) ' # of Z pts:        ',nZ
      write(lnout(0),*) ' Btoroidal orientation is ',ccwlbl(ibccw)
      write(lnout(0),*) ' Plasma current orientation is ',ccwlbl(ipccw)
C
      if((Rmin.eq.0.0_R8).and.(Rmax.eq.0.0_R8).and.
     >   (Zmin.eq.0.0_R8).and.(Zmax.eq.0.0_R8)) then
         write(lnout(0),*) ' (R,Z) grid extent:  to match limiters.'
      else
         write(lnout(0),*) ' (R,Z) grid extent:'
         write(lnout(0),*) '    Rmin=',Rmin,' Rmax=',Rmax
         write(lnout(0),*) '    Zmin=',Zmin,' Zmax=',Zmax
         if(ifree.eq.0) then
            write(lnout(0),*) ' (may be extended to cover limiters).'
         endif
      endif
C
      if(lxout(0)) then
         write(lnout(0),*) 
     >        ' ** enter "C" to control {R,Z}(theta,rho) bdy cond.'
         if(ifree.eq.0) then
            write(lnout(0),*)
     >           ' ** enter "R" to modify (R,Z) grid limits.'
         endif
      endif
      call uread('trxpl_path:  enter "Y" to verify:$')

      if(lchar('R')) then
         if(ifree.eq.0) then
            call ureadr8('trxpl_path:  Rmin:',Rmin)
            call ureadr8('trxpl_path:  Rmax:',Rmax)
            call ureadr8('trxpl_path:  Zmin:',Zmin)
            call ureadr8('trxpl_path:  Zmax:',Zmax)
         else
            call uermsg('cannot change grid (free bdy run)',' ',0)
         endif
         go to 150

      else if(lchar('C')) then
         if(lxout(0)) write(lnout(0),*) 
     >        ' For boundary conditions on {R,Z}(theta,rho):'
         if(lxout(0)) write(lnout(0),*) 
     >        ' Enter other than "Y" for "not a knot" Bdy Condition.'
         call uread(
     >        'enter "Y" for finite difference Boundary Condition:')
         if(lyes(0)) then
            call trx_rzbc_fdiff
         else
            call trx_rzbc_nknot
         endif
         go to 150
      else if(lyes(0)) then
         return                         ! return path to caller
      else
         go to 10
      endif
C
      end
C------------------------------------------------------------------
      subroutine trxpl_path0(tpath)
      character*(*) tpath               ! run path (file or MDS+)

C----------------------------------------------------
C just set the run path
C----------------------------------------------------
C
C  mode
C
      integer, save :: imode            ! mode select
      character*4, save :: zmode(2)     ! FILE/MDS+
C
C  file spec components
C
      character*64, save :: rpath       ! file path to results root directory
      character*50, save :: tokyy       ! results subdirectory (tok.yy)
      character*10, save :: runid       ! runid
C
C  MDS+ spec components
C
      character*50, save :: mds_server  ! server node
      character*20, save :: mds_tree    ! tree name
      character*25, save :: mds_shot    ! shot spec or runid combo
C
      character*180, save :: lpath      ! "literal" path
C        ! syntax: <server>:<tree>(<mds_number>), or,
C                  <server>:<tree>(<tok.yy>,<runid>)
C
      logical, save :: initp = .FALSE.  ! initialization status flag
C
C  misc...
C
      integer :: i,ilenl,ic,id,isl,ilr,ilt,ild,ils,ilxy,imds
C
C  for lpath parse:
C
      integer :: icolon,ilparen,irparen,ifld1,ifld2,ifld3
C
C---------------
C  for env var lookup
C
      character*60 zenv
C
C---------------
C  functions...
C
      integer lnout                     ! tty lun
      logical lxout                     ! menu output flag
      logical lchar                     ! response test
      logical lyes                      ! test for "Y" or discard input char
C
C---------------
C  data stmts
C
      data lpath/'.'/
      data rpath/'ARCDIR'/
      data tokyy/'tok.yy'/
      data runid/'runid'/
C
      data mds_server/'mds_server.ip.address'/
      data mds_tree/'TRANSP'/
      data mds_shot/'tok.yy,runid | shot#'/
C
      data imode/1/
      data zmode/'FILE','MDS+'/
C
C----------------------------------------------------
C
      if(.NOT.initp) then
         initp=.TRUE.

         call sget_env('MDS_TRANSP_SERVER',zenv)
         if(zenv.ne.' ') mds_server=zenv

         call sget_env('MDS_TRANSP_TREE',zenv)
         if(zenv.ne.' ') mds_tree=zenv
      endif

 10   continue
      if(imode.eq.1) then
C
C  file mode ************************
C
         ilr=len_trim(rpath)
         ilt=len_trim(tokyy)
         ild=len_trim(runid)
C
         tpath=zmode(imode)//':'
         ilx=len_trim(tpath)+1
c
         if(rpath.ne.'NONE') then
            tpath(ilx:)=rpath(1:ilr)//'/'
            ilx=len_trim(tpath)+1
         endif
c
         if(tokyy.ne.'NONE') then
            i=index(tokyy,'.')
            if (i .gt. 0) tokyy(i:i) = '/'
            tpath(ilx:)=tokyy(1:ilt)//'/'
            ilx=len_trim(tpath)+1
         endif
c
         tpath(ilx:)=runid(1:ild)
C
         ilt=len_trim(tpath)
C
         if(lxout(0)) then
            write(lnout(0),1001) tpath(1:ilt)
 1001       format(/
     >         ' ...path:  ',a//
     >         ' F -- select FILE mode (no change)'/
     >         ' M -- toggle btw MDS+ and FILE mode'/
     >         ' R -- reset path to results root directory',
     >                ' (enter "none" to use CWD)'/
     >         ' Y -- reset tok.yy (none for CWD)'/
     >         ' D -- reset runid'/
     >         ' P -- provide full path including runid as one word.'/
     >         ' X/Q -- quit:  stop the program.'/
     >         ' A -- accept:  read data at given path location.')
         endif
         call uread('trxpl_path:  enter option:$')
         if(lchar('A')) then
C  quit
            return
         else if(lchar('X').or.lchar('Q')) then
C  exit program (see caller)
            tpath=' '
            return
         else if(lchar('M')) then
C  toggle mode
            imode=3-imode
         else if(lchar('F')) then
            imode=1
         else if(lchar('R')) then
C  reset path
            if(lxout(0)) write(lnout(0),*) ' enter "NONE" to suppress:'
            call ureadw('trxpl_path:  results root directory:$',rpath)
         else if(lchar('Y')) then
C  reset tok.yy
            if(lxout(0)) write(lnout(0),*) ' enter "NONE" to suppress:'
            if (imode .eq. 1) then
               call ureadw('trxpl_path:  TRANSP tok/yy:$',tokyy)
               i=index(tokyy,'.')
               if (i .gt. 0) tokyy(i:i) = '/'
            else
               call ureadw('trxpl_path:  TRANSP tok.yy:$',tokyy)
            endif
         else if(lchar('P')) then 
            call ureadw('trxpl_path: file path (end with runid):$',
     >           lpath)
            ilenl=len(trim(lpath))
            isl=0
            do ic=ilenl,1,-1
               if(lpath(ic:ic).eq.'/') then
                  isl=ic
                  exit
               endif
            enddo

            if(isl.le.1) then
               tokyy='NONE'
               runid=lpath(isl+1:ilenl)
               rpath='.'
            else
               tokyy='NONE'
               rpath=lpath(1:isl-1)
               if(isl.lt.ilenl) then
                  runid=lpath(isl+1:ilenl)
               else
                  runid='?'
               endif
            endif

         else if(lchar('D')) then
C  reset runid
            call ureadw('trxpl_path:  TRANSP runid:$',runid)
         else
C  ?? error ??
            call uermsg(' ?trxpl_path:  invalid option.',' ',0)
         endif
C
      else
C
C  MDS+ mode ****************************
C
         ils=len_trim(mds_server)
         ilt=len_trim(mds_tree)
         ild=len_trim(mds_shot)
C
         tpath=zmode(imode)//':'//mds_server(1:ils)//':'//
     >      mds_tree(1:ilt)//'('//mds_shot(1:ild)//')'
         ilt=len_trim(tpath)
C
         if(lxout(0)) then
            write(lnout(0),1002) tpath(1:ilt)
 1002       format(/
     >         ' ...path:  ',a//
     >         ' F -- select FILE mode'/
     >         ' M -- toggle btw MDS+ and FILE mode'/
     >         ' S -- set MDS+ server'/
     >         ' T -- set MDS+ tree name'/
     >         ' D -- set MDS+ shot# or tok.yy/runid combination'/
     >         ' P -- set "literal" MDS+ path'/
     >         ' X/Q -- quit:  stop the program.'/
     >         ' A -- accept:  read data at given path location.')
         endif
         call uread('trxpl_path:  enter option:$')
         if(lchar('A')) then
C  quit
            return
         else if(lchar('X').or.lchar('Q')) then
C  exit program (see caller)
            tpath=' '
            return
         else if(lchar('M')) then
C  toggle mode
            imode=3-imode
         else if(lchar('F')) then
            imode=1
         else if(lchar('S')) then
C  server
            call ureadw('trxpl_path:  MDS+ server (ip name):$',
     >         mds_server)
         else if(lchar('T')) then
C  tree name
            call ureadw('trxpl_path:  MDS+ tree name:$',
     >         mds_tree)
         else if(lchar('D')) then
C  shot / runid
            call uread('enter "S" for shot#, "D" for tok.yy/runid:$')
            if(lchar('S')) then
               ! this encoder will convert nnnnnAmm -> nnnnn01mm...

               call ureadi_nrun('trxpl_path:  MDS+ shot number:$',imds)

               ! convert integer to left justified string
               mds_shot=' '
               write(mds_shot(1:15),'(I15)') imds
               id=0
               do ic=1,15
                  if(mds_shot(ic:ic).ne.' ') then
                     id=id+1
                     mds_shot(id:id)=mds_shot(ic:ic)
                     mds_shot(ic:ic)=' '
                  endif
               enddo

            else if(lchar('D')) then
               call ureadw('trxpl_path:  TRANSP tok.yy:$',tokyy)
               call ureadw('trxpl_path:  TRANSP runid:$',runid)
               ilt=len_trim(tokyy)
               ild=len_trim(runid)
               if(index(tokyy,'.').eq.0) then
                  ! attempt automatic shot year generation
                  call yygen
                  ilt=len_trim(tokyy)
                  ild=len_trim(runid)
               endif
               mds_shot=tokyy(1:ilt)//','//runid(1:ild)
            else
               call uermsg(' ?trxpl_path:  needed "S" or "D".',' ',0)
            endif
         else if(lchar('P')) then
            call ureadL('trxpl_path:  MDS+ literal path string:$',
     >           lpath)

            istart=1
            if(lpath(1:1).eq.'"') istart=2
            icolon=index(lpath,':')
            ilparen=index(lpath,'(')
            irparen=index(lpath,')')
            ifld1 = icolon-1
            ifld2 = ilparen-icolon-1
            ifld3 = irparen-ilparen-1

            if(min(ifld1,ifld2,ifld3).le.0) then
               call uermsg(
     >              ' ?trxpl_path:  MDS+ literal path syntax error',
     >              trim(lpath),0)
            else
               mds_server = lpath(istart:icolon-1)
               mds_tree = lpath(icolon+1:ilparen-1)
               mds_shot = lpath(ilparen+1:irparen-1)
            endif

         else
C  ?? error ??
            call uermsg(' ?trxpl_path:  invalid option.',' ',0)
         endif
      endif
C
      go to 10

      CONTAINS
        subroutine yygen

          ! given tok.yy string that contains <tok> only, try to generate
          ! yy part.  Functionality available only for certain tokamaks...

          character*26 :: alphab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
          integer :: islen,ishot,istat
          character*6 :: zshot6
          character*2 :: yy

          write(lnout(0),*) 
     >     ' %trxpl_path0(yygen): attempt auto-generation of shot year.'

          islen=0
          do ic=1,len(trim(runid))
             if(index(alphab,runid(ic:ic)).gt.0) then
                islen=ic-1
                exit
             endif
          enddo

          if((islen.ne.5).and.(islen.ne.6)) then
             call uermsg(
     >           'trxpl_path0(yygen): failed to find shot no. in runid',
     >            runid,0)
             runid='runid'
             tokyy='tok.yy'
             return
          endif

          if(islen.eq.5) then
             zshot6=' '//runid(1:5)
          else
             zshot6=runid(1:6)
          endif

          read(zshot6,'(I6)',iostat=istat) ishot
          if(istat.ne.0) then
             call uermsg(
     >           'trxpl_path0(yygen): failed to decode runid shot no.',
     >            runid,0)
             runid='runid'
             tokyy='tok.yy'
             return
          endif

          if((tokyy.eq.'TFTR').or.(tokyy.eq.'AUGD').or.
     >         (tokyy.eq.'EAST').or.(tokyy.eq.'JET').or.
     >         (tokyy.eq.'NSTX').or.(tokyy.eq.'MAST').or.
     >         (tokyy.eq.'D3D')) then

             call get_tokyr(0,0,tokyy,ishot,yy)
             if(yy.eq.' ') then
                call uermsg(
     >               'get_tokyr failed for '//tokyy,zshot,0)
                tokyy='tok.yy'
                runid='runid'
             else
                tokyy=trim(tokyy)//'.'//yy
             endif

          else
             call uermsg(
     >            'shot-year generation unavailable for tokamak',tokyy,
     >            0)
             tokyy='tok.yy'
             runid='runid'
          endif

        end subroutine yygen
      end

      subroutine trxpl_path_dtavg(prompt,ztime0,ztavg,zans)

      !  prompt for +/- delta(t) for time averaging *OR* a pre/post
      !  sawtooth hint

      implicit NONE

      character*(*), intent(in) :: prompt ! UREAD prompt string
      real*8, intent(inout) :: ztime0     ! data time (may be adjusted)
      real*8, intent(inout) :: ztavg      ! +/- averaging time
      character*1, intent(out) :: zans    ! echo back "Q" response to caller

      !--------------------------------
      ! UREAD functions:
      logical :: lxout,lchar
      integer :: lnout
      real*8 :: r8dcod

      integer :: iert
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      !--------------------------------

      zans=' '

      do
         if(lxout(0)) then
            write(lnout(0),*) ' "A": dt_avg=0, hint: pre-sawtooth'
            write(lnout(0),*) ' "B": dt_avg=0, hint: post-sawtooth'
            write(lnout(0),*) ' "Q": choose different time.'
         endif
         call uread('trxpl_path:  +/- averging time (.ge.0):$')
         if(lchar('Q')) then
            zans='Q'
            exit
         else if(lchar('A')) then
            ztavg=0.0d0
            call trx_chk_saw_r8(ztime0,1)
            exit
         else if(lchar('B')) then
            ztavg=0.0d0
            call trx_chk_saw_r8(ztime0,2)
            exit
         else
            ztavg=r8dcod(iert)
            if(iert.ne.0) then
               call uermsg('r8dcod error -- reprompt',' ',0)
            else
               if(ztavg.lt.0.0_R8) ztavg=0.0_R8
               if(ztavg.eq.0.0_R8) call trx_chk_saw_r8(ztime0,0)
               exit
            endif
         endif
      enddo

      return
      end

integer function tdb_nchan_find(d,z2char)

  ! return number of channels for indicated data type, found in trdatbuf buffer

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d                 ! data buffer object
  character*(*), intent(in) :: z2char  ! 2-character code...

  !  a copy of z2char is converted to uppercase before testing
  !  if z2char is uppercase, then,

  !    z2char.eq.'NB' means -- requested information is # of neutral beams
  !
  !    z2char.eq.'EC' means -- requested information is # of ECH antennas
  !       electron cyclotron heating / current drive
  !
  !    z2char.eq.'LH' means -- requested information is # of LH antennas
  !       lower hybrid heating / current drive
  !
  !    z2char.eq.'RF' means -- requested information is # of ICRF antennas
  !       ICRF heating / current drive

  !  if z2char is recognized, the number of beams or antennas is returned;
  !  it could be zero.

  !  if z2char is not recognized, the number -1 is returned and a warning
  !  is written to the tdb log...

  character*3 ztest
  integer :: lunmsg_tdb

  !----------------------

  ztest = z2char(1:min(len(z2char),len(ztest)))
  call uupper(ztest)

  if(ztest.eq.'NB') then
     tdb_nchan_find = d%nbdata

  else if(ztest.eq.'EC') then
     tdb_nchan_find = d%nantech_d

  else if(ztest.eq.'LH') then
     tdb_nchan_find = d%nantlh_d

  else if(ztest.eq.'RF') then
     tdb_nchan_find = d%nantich_d

  else
     tdb_nchan_find = -1
     write(lunmsg_tdb(0),*) &
          ' ?? trdatbuf_lib/tdb_nchan_find -- unrecognized designation: ', &
          trim(ztest)
  endif

end function tdb_nchan_find

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_1(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%chii_ntm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_ntm","R",indim,idims, &
            "Ti-equation, neoclassical diffusivity from NTM model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_ntm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_tglf","R",indim,idims, &
            "Ti-equation, diffusivity from TGLF model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("chii_trans","R",indim,idims, &
            "ion thermal diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|pclin chii_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%chii_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("chii_transcat","R",indim,idims, &
            "Ion energy diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chii_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%chii_w19)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_w19","R",indim,idims, &
            "Ti-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chii_w19(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chimo_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("chimo_trans","R",indim,idims, &
            "angular momentum diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|pclin chimo_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%chimo_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("chimo_transcat","R",indim,idims, &
            "Angular momentum diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chimo_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_anom","R",indim,idims, &
            "momentum-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chiphi_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_drbm","R",indim,idims, &
            "momentum-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chiphi_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_glf","R",indim,idims, &
            "momentum-equation, diffusivity from GLF23 model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chiphi_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_gtcneo","R",indim,idims, &
            "momentum-equation, neoclassical diffusivity from GTC_NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chiphi_gtcneo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_mmm71","R",indim,idims, &
            "momentum-equation, diffusivity term, toroidal", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chiphi_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_neo","R",indim,idims, &
            "momentum-equation, neoclassical diffusivity from NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chiphi_neo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_tglf","R",indim,idims, &
            "momentum-equation, diffusivity from TGLF model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chiphi_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chiphi_w19)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chiphi_w19","R",indim,idims, &
            "momentum-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chiphi_w19(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chitheta_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chitheta_mmm71","R",indim,idims, &
            "momentum-equation, diffusivity term, poloidal", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chitheta_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%circuit_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncircuits",idims(indim))
     CALL define_var("circuit_name","N",indim,idims, &
            "Number & names of circuits", &
            "__NONE","EQ","MACHINE_DESCRIPTION", &
            "L|pf_circuits  circuit_name(ncircuits)")
  ENDIF

  IF(ALLOCATED(ss%coil_apt)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncircuits",idims(indim))
     CALL define_var("coil_apt","R",indim,idims, &
            "SIGNED circuit current", &
            "amps/turn","EQ","STATE_DATA", &
            "R|units=amps/turn coil_apt(ncircuits)")
  ENDIF

  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("coil_in_circuit","N",indim,idims, &
            "circuit to which each coil belongs", &
            "__NONE","EQ","MACHINE_DESCRIPTION", &
            "N  coil_in_circuit(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%coil_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("coil_name","N",indim,idims, &
            "Number & name of axisymmetric coils", &
            "__NONE","EQ","MACHINE_DESCRIPTION", &
            "L|pf_coils     coil_name(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%coil_resispt)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("coil_resispt","R",indim,idims, &
            "coil resistance per turn", &
            "ohms/turn","EQ","MACHINE_DESCRIPTION", &
            "R|units=ohms/turn  coil_resispt(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%curbeam)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("curbeam","R",indim,idims, &
            "beam ion driven current (shielded)", &
            "A","NBI","STATE_PROFILES", &
            "R|step*dA|units=A   curbeam(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%curech)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_ecrf",idims(indim))
     CALL define_var("curech","R",indim,idims, &
            "ECH current drive", &
            "A","EC","STATE_PROFILES", &
            "R|step*dA|units=A   curech(~nrho_ecrf)")
  ENDIF

  IF(ALLOCATED(ss%curech_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_ecrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("curech_src","R",indim,idims, &
            "ECH current drive (by antenna)", &
            "A","EC","STATE_PROFILES", &
            "R|step*dA|units=A   curech_src(~nrho_ecrf,necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%curfusn)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     CALL define_var("curfusn","R",indim,idims, &
            "fusion ion driven current (shielded)", &
            "A","FUS","STATE_PROFILES", &
            "R|step*dA|units=A   curfusn(~nrho_fus)")
  ENDIF

  IF(ALLOCATED(ss%curich)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("curich","R",indim,idims, &
            "total driven current (all IC srcs)", &
            "A","IC","STATE_PROFILES", &
            "R|units=A|step*dA   curich(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%curlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     CALL define_var("curlh","R",indim,idims, &
            "LH current drive", &
            "A","LH","STATE_PROFILES", &
            "R|step*dA|units=A   curlh(~nrho_lhrf)")
  ENDIF

  IF(ALLOCATED(ss%curlh_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("curlh_src","R",indim,idims, &
            "LH current drive (by antenna)", &
            "A","LH","STATE_PROFILES", &
            "R|step*dA|units=A   curlh_src(~nrho_lhrf,nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%curmino)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("curmino","R",indim,idims, &
            "minority ion driven cur (shielded).", &
            "A","IC","STATE_PROFILES", &
            "R|step*dA|units=A   curmino(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%curr_bootstrap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("curr_bootstrap","R",indim,idims, &
            "Neoclassical bootstrap current", &
            "A","PLASMA","STATE_PROFILES", &
            "R|units=A|step*dA   curr_bootstrap(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%curr_ohmic)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("curr_ohmic","R",indim,idims, &
            "Ohmic current", &
            "A","PLASMA","STATE_PROFILES", &
            "R|units=A|step*dA   curr_ohmic(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%curt)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("curt","R",indim,idims, &
            "total enclosed toroidal current", &
            "A","EQ","STATE_PROFILES", &
            "R|units=A|Spline_00   curt(nrho_eq)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("CUR_Data_Info","C*80",indim,idims, &
         "information on source of plasma current data", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   CUR_Data_Info")

  IF(ALLOCATED(ss%cur_rw)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rw",idims(indim))
     CALL define_var("cur_rw","R",indim,idims, &
            "current carried by fast electrons", &
            "A","RUNAWAY","STATE_PROFILES", &
            "R|step*dA|units=A   cur_rw(~nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("d2R_geo_dRHOdTH","R",indim,idims, &
            "flux surfaces R(rho,theta)", &
            "m/-/rad","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("d2Z_geo_dRHOdTH","R",indim,idims, &
            "flux surfaces Z(rho,theta)", &
            "m/-/rad","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%db_mtm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("db_mtm","R",indim,idims, &
            "dB/B from MTM model", &
            "-","ANOM","STATE_PROFILES", &
            "R|units=-|pclin db_mtm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dcur_rw_dVloop)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rw",idims(indim))
     CALL define_var("dcur_rw_dVloop","R",indim,idims, &
            "sensitivity to loop volts", &
            "A/Volt","RUNAWAY","STATE_PROFILES", &
            "R|step*dA|units=A/Volt dcur_rw_dVloop(~nrho_rw)")
  ENDIF

  IF(ALLOCATED(ss%DeltaW_code)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ndelta_w",idims(indim))
     CALL define_var("DeltaW_code","N",indim,idims, &
            "name(s) of delta(W) code(s) used", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "L|Delta_W_codes  DeltaW_code(ndelta_w)")
  ENDIF

  IF(ALLOCATED(ss%DeltaW_mapper)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ndelta_w",idims(indim))
     CALL define_var("DeltaW_mapper","N",indim,idims, &
            "mapper code used for each delta(W) code", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "N  DeltaW_mapper(ndelta_W)")
  ENDIF

  IF(ALLOCATED(ss%DeltaW_stable)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_mmodes",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ndelta_w",idims(indim))
     CALL define_var("DeltaW_stable","I",indim,idims, &
            "0: stable; 1: unstable;", &
            "__NONE","LMHD","STATE_DATA", &
            "I   DeltaW_stable(mmodes,ndelta_W)")
  ENDIF

  IF(ALLOCATED(ss%DeltaW_status)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ndelta_w",idims(indim))
     CALL define_var("DeltaW_status","I",indim,idims, &
            "completion status: Delta(W) codes", &
            "__NONE","LMHD","STATE_DATA", &
            "I   DeltaW_status(ndelta_W)")
  ENDIF

  IF(ALLOCATED(ss%difb_fusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("difb_fusi","R",indim,idims, &
            "fusion ion anomalous diffusivity", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|pclin  difb_fusi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%difb_nbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("difb_nbi","R",indim,idims, &
            "beam ion anomalous diffusivity", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|pclin  difb_nbi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%difb_rfmi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom",idims(indim))
     CALL define_var("difb_rfmi","R",indim,idims, &
            "RF minority ion anomalous diffusivity", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|pclin  difb_rfmi(nrho_anom)")
  ENDIF

  IF(ALLOCATED(ss%diff_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("diff_trans","R",indim,idims, &
            "specie ptcl diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|units=m^2/sec|pclin diff_trans(nrho,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%diff_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("diff_transcat","R",indim,idims, &
            "specie diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|units=m^2/sec|pclin diff_transcat(nrho,0:nspec_th,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%difne_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("difne_nclass","R",indim,idims, &
            "electron-density-equations, neoclassical diffusivity from NCLASS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difne_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%difnh_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("difnh_nclass","R",indim,idims, &
            "main-hydrogenic-density-equations, neoclassical diffusivity from NCLASS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difnh_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%difns_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_anom","R",indim,idims, &
            "density-equations, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  difns_anom(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_drbm","R",indim,idims, &
            "density-equations, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  difns_drbm(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_glf","R",indim,idims, &
            "density-equations, diffusivity from GLF23 model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difns_glf(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_gtcneo","R",indim,idims, &
            "density-equations, neoclassical diffusivity from GTC_NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difns_gtcneo(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_mmm71","R",indim,idims, &
            "density-equations, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  difns_mmm71(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_nclass","R",indim,idims, &
            "density-equations, neoclassical diffusivity from NCLASS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difns_nclass(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_neo","R",indim,idims, &
            "density-equations, neoclassical diffusivity from NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difns_neo(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_tglf","R",indim,idims, &
            "density-equations, diffusivity from TGLF model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difns_tglf(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difns_w19)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("difns_w19","R",indim,idims, &
            "density-equations, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  difns_w19(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%difnx_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("difnx_nclass","R",indim,idims, &
            "main-impurity-density-equations, neoclassical diffusivity from NCLASS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin difnx_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%difnz_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("difnz_mmm71","R",indim,idims, &
            "impurity ion diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  difnz_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dist_fun)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("dist_fun","F",indim,idims, &
            "distribution function filenames", &
            "__NONE","IC","STATE_DATA", &
            "F  dist_fun(0:nspec_alla)")
  ENDIF

  indim = 0
  CALL define_var("dn0out","R",indim,idims, &
         "Hydrogenic neutral density in scrape off region", &
         "m^-3","GAS","STATE_DATA", &
         "R|units=m^-3  dn0out")

  IF(ALLOCATED(ss%dQedGrdte_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("dQedGrdte_tglf","R",indim,idims, &
            "Te flux gradient term from TGLF model", &
            "1/(m*s)","ANOM","STATE_PROFILES", &
            "R|units=1/(m*s)|pclin dQedGrdte_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dQedGrdti_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("dQedGrdti_tglf","R",indim,idims, &
            "Te flux gradient term from TGLF model", &
            "1/(m*s)","ANOM","STATE_PROFILES", &
            "R|units=1/(m*s)|pclin dQedGrdti_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dQidGrdte_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("dQidGrdte_tglf","R",indim,idims, &
            "Ti flux gradient term from TGLF model", &
            "1/(m*s)","ANOM","STATE_PROFILES", &
            "R|units=1/(m*s)|pclin dQidGrdte_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dQidGrdti_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("dQidGrdti_tglf","R",indim,idims, &
            "Ti flux gradient term from TGLF model", &
            "1/(m*s)","ANOM","STATE_PROFILES", &
            "R|units=1/(m*s)|pclin dQidGrdti_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%dR0_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("dR0_momeq_dRHO","R",indim,idims, &
            "R0 of flux surface", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  R0_momeq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("dR_geo_dRHO","R",indim,idims, &
            "flux surfaces R(rho,theta)", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dTH)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("dR_geo_dTH","R",indim,idims, &
            "flux surfaces R(rho,theta)", &
            "m/rad","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit R_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("dxRjcos_momeq_dRHO","R",indim,idims, &
            "scaled R cos moments", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xRjcos_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("dxRjsin_momeq_dRHO","R",indim,idims, &
            "scaled R sin moments", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xRjsin_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("dxZjcos_momeq_dRHO","R",indim,idims, &
            "scaled Z cos moments", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xZjcos_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_neqmom",idims(indim))
     CALL define_var("dxZjsin_momeq_dRHO","R",indim,idims, &
            "scaled Z sin moments", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  xZjsin_momeq(nrho_eq,neqmom)")
  ENDIF

  IF(ALLOCATED(ss%dx_fshield)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("dx_fshield","R",indim,idims, &
            "distance, antenna to Faraday shield", &
            "m","IC","MACHINE_DESCRIPTION", &
            "R|units=m dx_fshield(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%dZ0_momeq_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("dZ0_momeq_dRHO","R",indim,idims, &
            "Z0 of flux surface", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit  Z0_momeq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dRHO)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("dZ_geo_dRHO","R",indim,idims, &
            "flux surfaces Z(rho,theta)", &
            "m/-","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dTH)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nth_eq",idims(indim))
     CALL define_var("dZ_geo_dTH","R",indim,idims, &
            "flux surfaces Z(rho,theta)", &
            "m/rad","EQ","STATE_PROFILES", &
            "R|units=m|Hermite_explicit Z_geo(nrho_eq,nth_eq)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_1


SUBROUTINE plasma_state_store_1(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%chii_ntm)) THEN
     status = nf90_inq_varid(icdf,"chii_ntm",varid)
     status = nf90_put_var(icdf,varid,ss%chii_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_tglf)) THEN
     status = nf90_inq_varid(icdf,"chii_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%chii_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_trans)) THEN
     status = nf90_inq_varid(icdf,"chii_trans",varid)
     status = nf90_put_var(icdf,varid,ss%chii_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_transcat)) THEN
     status = nf90_inq_varid(icdf,"chii_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%chii_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_w19)) THEN
     status = nf90_inq_varid(icdf,"chii_w19",varid)
     status = nf90_put_var(icdf,varid,ss%chii_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chimo_trans)) THEN
     status = nf90_inq_varid(icdf,"chimo_trans",varid)
     status = nf90_put_var(icdf,varid,ss%chimo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chimo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chimo_transcat)) THEN
     status = nf90_inq_varid(icdf,"chimo_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%chimo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chimo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_anom)) THEN
     status = nf90_inq_varid(icdf,"chiphi_anom",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_drbm)) THEN
     status = nf90_inq_varid(icdf,"chiphi_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_glf)) THEN
     status = nf90_inq_varid(icdf,"chiphi_glf",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chiphi_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chiphi_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_neo)) THEN
     status = nf90_inq_varid(icdf,"chiphi_neo",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_tglf)) THEN
     status = nf90_inq_varid(icdf,"chiphi_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_w19)) THEN
     status = nf90_inq_varid(icdf,"chiphi_w19",varid)
     status = nf90_put_var(icdf,varid,ss%chiphi_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chiphi_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chitheta_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chitheta_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%chitheta_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chitheta_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%circuit_name)) THEN
     status = nf90_inq_varid(icdf,"circuit_name",varid)
     status = nf90_put_var(icdf,varid,ss%circuit_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: circuit_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_apt)) THEN
     status = nf90_inq_varid(icdf,"coil_apt",varid)
     status = nf90_put_var(icdf,varid,ss%coil_apt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: coil_apt"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     status = nf90_inq_varid(icdf,"coil_in_circuit",varid)
     status = nf90_put_var(icdf,varid,ss%coil_in_circuit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: coil_in_circuit"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_name)) THEN
     status = nf90_inq_varid(icdf,"coil_name",varid)
     status = nf90_put_var(icdf,varid,ss%coil_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: coil_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_resispt)) THEN
     status = nf90_inq_varid(icdf,"coil_resispt",varid)
     status = nf90_put_var(icdf,varid,ss%coil_resispt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: coil_resispt"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curbeam)) THEN
     status = nf90_inq_varid(icdf,"curbeam",varid)
     status = nf90_put_var(icdf,varid,ss%curbeam)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curbeam"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curech)) THEN
     status = nf90_inq_varid(icdf,"curech",varid)
     status = nf90_put_var(icdf,varid,ss%curech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curech"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curech_src)) THEN
     status = nf90_inq_varid(icdf,"curech_src",varid)
     status = nf90_put_var(icdf,varid,ss%curech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curech_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curfusn)) THEN
     status = nf90_inq_varid(icdf,"curfusn",varid)
     status = nf90_put_var(icdf,varid,ss%curfusn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curfusn"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curich)) THEN
     status = nf90_inq_varid(icdf,"curich",varid)
     status = nf90_put_var(icdf,varid,ss%curich)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curich"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curlh)) THEN
     status = nf90_inq_varid(icdf,"curlh",varid)
     status = nf90_put_var(icdf,varid,ss%curlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curlh_src)) THEN
     status = nf90_inq_varid(icdf,"curlh_src",varid)
     status = nf90_put_var(icdf,varid,ss%curlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curmino)) THEN
     status = nf90_inq_varid(icdf,"curmino",varid)
     status = nf90_put_var(icdf,varid,ss%curmino)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curmino"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curr_bootstrap)) THEN
     status = nf90_inq_varid(icdf,"curr_bootstrap",varid)
     status = nf90_put_var(icdf,varid,ss%curr_bootstrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curr_bootstrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curr_ohmic)) THEN
     status = nf90_inq_varid(icdf,"curr_ohmic",varid)
     status = nf90_put_var(icdf,varid,ss%curr_ohmic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curr_ohmic"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curt)) THEN
     status = nf90_inq_varid(icdf,"curt",varid)
     status = nf90_put_var(icdf,varid,ss%curt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: curt"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"CUR_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%CUR_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: CUR_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%cur_rw)) THEN
     status = nf90_inq_varid(icdf,"cur_rw",varid)
     status = nf90_put_var(icdf,varid,ss%cur_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: cur_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) THEN
     status = nf90_inq_varid(icdf,"d2R_geo_dRHOdTH",varid)
     status = nf90_put_var(icdf,varid,ss%d2R_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: d2R_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) THEN
     status = nf90_inq_varid(icdf,"d2Z_geo_dRHOdTH",varid)
     status = nf90_put_var(icdf,varid,ss%d2Z_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: d2Z_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%db_mtm)) THEN
     status = nf90_inq_varid(icdf,"db_mtm",varid)
     status = nf90_put_var(icdf,varid,ss%db_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: db_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dcur_rw_dVloop)) THEN
     status = nf90_inq_varid(icdf,"dcur_rw_dVloop",varid)
     status = nf90_put_var(icdf,varid,ss%dcur_rw_dVloop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dcur_rw_dVloop"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_code)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_code",varid)
     status = nf90_put_var(icdf,varid,ss%DeltaW_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: DeltaW_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_mapper)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_mapper",varid)
     status = nf90_put_var(icdf,varid,ss%DeltaW_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: DeltaW_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_stable)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_stable",varid)
     status = nf90_put_var(icdf,varid,ss%DeltaW_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: DeltaW_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_status)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_status",varid)
     status = nf90_put_var(icdf,varid,ss%DeltaW_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: DeltaW_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_fusi)) THEN
     status = nf90_inq_varid(icdf,"difb_fusi",varid)
     status = nf90_put_var(icdf,varid,ss%difb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_nbi)) THEN
     status = nf90_inq_varid(icdf,"difb_nbi",varid)
     status = nf90_put_var(icdf,varid,ss%difb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_rfmi)) THEN
     status = nf90_inq_varid(icdf,"difb_rfmi",varid)
     status = nf90_put_var(icdf,varid,ss%difb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%diff_trans)) THEN
     status = nf90_inq_varid(icdf,"diff_trans",varid)
     status = nf90_put_var(icdf,varid,ss%diff_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: diff_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%diff_transcat)) THEN
     status = nf90_inq_varid(icdf,"diff_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%diff_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: diff_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difne_nclass)) THEN
     status = nf90_inq_varid(icdf,"difne_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%difne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnh_nclass)) THEN
     status = nf90_inq_varid(icdf,"difnh_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%difnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_anom)) THEN
     status = nf90_inq_varid(icdf,"difns_anom",varid)
     status = nf90_put_var(icdf,varid,ss%difns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_drbm)) THEN
     status = nf90_inq_varid(icdf,"difns_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%difns_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_glf)) THEN
     status = nf90_inq_varid(icdf,"difns_glf",varid)
     status = nf90_put_var(icdf,varid,ss%difns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"difns_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%difns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_mmm71)) THEN
     status = nf90_inq_varid(icdf,"difns_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%difns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_nclass)) THEN
     status = nf90_inq_varid(icdf,"difns_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%difns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_neo)) THEN
     status = nf90_inq_varid(icdf,"difns_neo",varid)
     status = nf90_put_var(icdf,varid,ss%difns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_tglf)) THEN
     status = nf90_inq_varid(icdf,"difns_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%difns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_w19)) THEN
     status = nf90_inq_varid(icdf,"difns_w19",varid)
     status = nf90_put_var(icdf,varid,ss%difns_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difns_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnx_nclass)) THEN
     status = nf90_inq_varid(icdf,"difnx_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%difnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnz_mmm71)) THEN
     status = nf90_inq_varid(icdf,"difnz_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%difnz_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: difnz_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dist_fun)) THEN
     status = nf90_inq_varid(icdf,"dist_fun",varid)
     status = nf90_put_var(icdf,varid,ss%dist_fun)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dist_fun"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dn0out",varid)
  status = nf90_put_var(icdf,varid,ss%dn0out)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: dn0out"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%dQedGrdte_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQedGrdte_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%dQedGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dQedGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQedGrdti_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQedGrdti_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%dQedGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dQedGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQidGrdte_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQidGrdte_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%dQidGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dQidGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQidGrdti_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQidGrdti_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%dQidGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dQidGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR0_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dR0_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dR0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dR0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dR_geo_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dR_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dR_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dTH)) THEN
     status = nf90_inq_varid(icdf,"dR_geo_dTH",varid)
     status = nf90_put_var(icdf,varid,ss%dR_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dR_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxRjcos_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dxRjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dxRjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxRjsin_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dxRjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dxRjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxZjcos_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dxZjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dxZjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxZjsin_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dxZjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dxZjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dx_fshield)) THEN
     status = nf90_inq_varid(icdf,"dx_fshield",varid)
     status = nf90_put_var(icdf,varid,ss%dx_fshield)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dx_fshield"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ0_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dZ0_momeq_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dZ0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dZ0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dZ_geo_dRHO",varid)
     status = nf90_put_var(icdf,varid,ss%dZ_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dZ_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dTH)) THEN
     status = nf90_inq_varid(icdf,"dZ_geo_dTH",varid)
     status = nf90_put_var(icdf,varid,ss%dZ_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: dZ_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_1

subroutine splitn_wtrans_test

  ! test driver for splitn_wtrans:  load some random changes into
  ! the write buffer arrays; call splitn_wtrans to transfer these
  ! changes into the main buffers and express these changes in the
  ! file text form.

  ! execute after reading a namelist (when dbuf is copied into dbuf_w
  ! and similarly for all the other buffers)

  use splitn_module
  implicit NONE

  !-------------------------------
  integer i,i2,istart,iinc
  !-------------------------------

  kupdate = 0   ! applies to base namelist only

  iinc=1000

  if(nreal.gt.0) then

     istart=max(1,min(nreal,iinc)/2)
     do i=istart,nreal,iinc
        i2=min(nreal,i+2)
        rbuf_w(i:i2)=(rbuf(i)-0.5e0)*2
     enddo

  endif

  if(nr8.gt.0) then

     istart=max(1,min(nr8,iinc)/2)
     do i=istart,nr8,iinc
        i2=min(nr8,i+2)
        dbuf_w(i:i2)=(dbuf(i)-0.5d0)*2
     enddo

  endif

  if(nint.gt.0) then

     istart=max(1,min(nint,iinc)/2)
     do i=istart,nint,iinc
        i2=min(nint,i+2)
        intbuf_w(i:i2)=(intbuf(i)-1)*2
     enddo

  endif

  if(nlog.gt.0) then

     istart=max(1,min(nlog,iinc)/2)
     do i=istart,nlog,iinc
        i2=min(nlog,i+2)
        logbuf_w(i:i2)=.TRUE.
     enddo

  endif

  if(nchv.gt.0) then

     istart=max(1,min(nchv,iinc)/2)
     do i=istart,nchv,iinc
        i2=min(nchv,i+2)
        chbuf_w(i:i2)='Hi'
     enddo

  endif

  call splitn_wtrans

end subroutine splitn_wtrans_test

subroutine splitn_wtrans

  !  transcribe write buffer into main buffer, with update to file text

  use splitn_module
  implicit NONE

  !-----------------------------------
  integer i,idim,iadr0,iadr1,iadc0,iadc1,isize,indx(10),inum,ierr
  integer irank

  logical diff
  !-----------------------------------

  !  loop over all namelist variables

  do i=1,nvars
     isize=1
     irank=varlist(i)%rank
     do idim=1,irank
        isize=isize*(varlist(i)%dims(2,idim)-varlist(i)%dims(1,idim)+1)
     enddo
     iadr0=varlist(i)%addr
     iadr1=iadr0+isize-1
     iadc0=iadr0-1

     do
        !  look for start of change block
        iadc0=iadc0+1
        if(iadc0.gt.iadr1) exit
        diff = .not.is_equal(iadc0)
        if(diff) then
           !  look for end of change block with same value
           iadc1=iadc0-1
           do
              iadc1=iadc1+1
              if(iadc1.eq.iadr1) exit
              if(.not.is_equal2(iadc0,iadc1+1)) exit
           enddo

           inum=iadc1-iadc0+1
           
           if(irank.gt.0) then
              call gen_indx
           endif
           call put

           iadc0=iadc1  ! and resume search...
        endif
     enddo
  enddo
  contains
    subroutine gen_indx
      integer kblock,ind,iwk,irat,ii

      !  generate index 
      indx=0
      iwk=iadc0-iadr0
      do ii=irank,1,-1
         kblock=(varlist(i)%dims(2,ii)-varlist(i)%dims(1,ii))+1
         irat=iwk/kblock
         ind = (iwk - irat*kblock) + varlist(i)%dims(1,ii)
         indx(ii)=ind
         iwk=irat
      enddo
    end subroutine gen_indx

    subroutine put

      !  request transfer

      if(varlist(i)%type.eq.'R') then
         if(irank.eq.0) then
            call splitn_rput_sc(varlist(i)%name,rbuf_w(iadc0),ierr)
         else
            call splitn_rput_ar(varlist(i)%name,rbuf_w(iadc0), &
                 irank,indx(1:irank),inum,ierr)
         endif

      else if(varlist(i)%type.eq.'D') then
         if(irank.eq.0) then
            call splitn_dput_sc(varlist(i)%name,dbuf_w(iadc0),ierr)
         else
            call splitn_dput_ar(varlist(i)%name,dbuf_w(iadc0), &
                 irank,indx(1:irank),inum,ierr)
         endif

      else if(varlist(i)%type.eq.'I') then
         if(irank.eq.0) then
            call splitn_iput_sc(varlist(i)%name,intbuf_w(iadc0),ierr)
         else
            call splitn_iput_ar(varlist(i)%name,intbuf_w(iadc0), &
                 irank,indx(1:irank),inum,ierr)
         endif

      else if(varlist(i)%type.eq.'L') then
         if(irank.eq.0) then
            call splitn_lput_sc(varlist(i)%name,logbuf_w(iadc0),ierr)
         else
            call splitn_lput_ar(varlist(i)%name,logbuf_w(iadc0), &
                 irank,indx(1:irank),inum,ierr)
         endif

      else if(varlist(i)%type(1:1).eq.'C') then
         if(irank.eq.0) then
            call splitn_chput_sc(varlist(i)%name,chbuf_w(iadc0),ierr)
         else
            call splitn_chput_ar(varlist(i)%name,chbuf_w(iadc0), &
                 irank,indx(1:irank),inum,ierr)
         endif

      endif

    end subroutine put

    logical function is_equal(iadc)

      !  return TRUE if main buffer and write buffer elements are equal

      integer, intent(in) :: iadc   ! buffer address

      if(varlist(i)%type.eq.'R') then
         is_equal = rbuf(iadc).eq.rbuf_w(iadc)
      else if(varlist(i)%type.eq.'D') then
         is_equal = dbuf(iadc).eq.dbuf_w(iadc)
      else if(varlist(i)%type.eq.'I') then
         is_equal = intbuf(iadc).eq.intbuf_w(iadc)
      else if(varlist(i)%type.eq.'L') then
         is_equal = logbuf(iadc).and.logbuf_w(iadc)
         is_equal = is_equal.or.((.not.logbuf(iadc)).and.(.not.logbuf_w(iadc)))
      else if(varlist(i)%type(1:1).eq.'C') then
         is_equal = chbuf(iadc).eq.chbuf_w(iadc)
      endif

    end function is_equal
           
    logical function is_equal2(iad1,iad2)

      !  return TRUE if two write buffer elements are equal

      integer, intent(in) :: iad1,iad2   ! buffer addresses

      if(varlist(i)%type.eq.'R') then
         is_equal2 = rbuf_w(iad1).eq.rbuf_w(iad2)
      else if(varlist(i)%type.eq.'D') then
         is_equal2 = dbuf_w(iad1).eq.dbuf_w(iad2)
      else if(varlist(i)%type.eq.'I') then
         is_equal2 = intbuf_w(iad1).eq.intbuf_w(iad2)
      else if(varlist(i)%type.eq.'L') then
         is_equal2 = logbuf_w(iad1).and.logbuf_w(iad2)
         is_equal2 = is_equal2.or. &
              ((.not.logbuf_w(iad1)).and.(.not.logbuf_w(iad2)))
      else if(varlist(i)%type(1:1).eq.'C') then
         is_equal2 = chbuf_w(iad1).eq.chbuf_w(iad2)
      endif

    end function is_equal2
           
end subroutine splitn_wtrans

subroutine splitn_update_check(t_prev_update,t_try,filename,istat,ierr)

  ! check for time to write update namelist.  If it is time, write it.

  use splitn_module
  implicit NONE

  !--------------------------------------

  real*8, intent(inout) :: t_prev_update   ! time of last update
  !  (this is reset to the namelist update time if a namelist is written).

  real*8, intent(in) :: t_try              ! time to check to:
  !  if the update time T satisfies t_prev_update < T <= t_try, write update

  character*(*), intent(in) :: filename    ! name of (path to) file to write

  integer, intent(out) :: istat            ! output status report:
  !  =0: no update written
  !  =1: update written, t_prev_update updated.
  !  =2: update written, t_prev_update updated; additional update time(s)
  !      exist that are <= t_try.

  integer, intent(out) :: ierr             ! error status output (0=OK)

  !--------------------------------------
  integer :: ii,jj,kk,iupdate,ilun
  integer :: inaml,ivar,ilnum,jnaml,ifound
  integer :: ilin_min,ilin_max,ilen,inb
  integer :: inum_base,inum_st,i1,i2
  character*1 :: zquot,char1

  integer, dimension(:), allocatable :: inum_naml
  integer, dimension(:,:), allocatable :: ilins_naml
  character*32 :: znam
  !--------------------------------------

  istat=0
  ierr=0

  do ii=1,nupdate
     if((t_prev_update.lt.tup(ii)).AND.(tup(ii).le.t_try)) then
        istat = 1
        iupdate = ii
        if(ii.lt.nupdate) then
           if(tup(ii+1).le.t_try) then
              istat = 2
           endif
        endif

        exit
     endif
  enddo

  if(istat.gt.0) then

     call find_io_unit(ilun)
     open(unit=ilun,file=filename,status='unknown',iostat=ierr)

     if(ierr.ne.0) then
        write(6,*) ' ?splitn_update_check: could not open: ',trim(filename)
     else
        t_prev_update = tup(iupdate)
        write(6,*) ' %splitn_update_check: writing update: ',trim(filename), &
             ' @ t=',t_prev_update

        ! find range of update lines

        ilin_min=curmax + 1
        ilin_max=0

        inum_base = nreal+nint+nlog+nr8+nchv
        inum_st   = nreal_st+nint_st+nlog_st+nr8_st+nchv_st

        i1 = inum_base + (iupdate-1)*inum_st + 1
        i2 = inum_base + iupdate*inum_st

        do ii=i1,i2
           if(ilines(ii).ne.0) then
              ilin_min=min(ilin_min,ilines(ii))
              ilin_max=max(ilin_max,ilines(ii))
           endif
        enddo

        ! sort lines by namelist

        ilnum=ilin_max-ilin_min+1
        allocate(ilins_naml(ilnum,nnamls),inum_naml(nnamls))
        inum_naml = 0

        jnaml=0
        do ii=ilin_min,ilin_max
           jj=ordl(ii)
           if(lenl(jj).eq.0) cycle

           ! carry over lines without LHS...

           if(namfld(1,jj).eq.0) then
              if(jnaml.gt.0) then
                 kk=inum_naml(jnaml)+1
                 ilins_naml(kk,jnaml)=jj
                 inum_naml(jnaml)=kk
              endif
              cycle
           endif

           znam = textnl(jj)(namfld(1,jj):namfld(2,jj))
           if(znam(1:1).eq.'~') cycle  !skip ~UPDATE_TIME

           !  exclude possible element index reference -- want name only
           kk=index(znam,'(')
           if(kk.gt.0) znam(kk:)=' '

           call uupper(znam)

           ! find namelist to which name belongs; write warning if not found.
           ! (it should always be found).

           do inaml=1,nnamls
              ifound=0
              do kk=1,num_naml_vars_st(inaml)
                 ivar=indx_naml_vars_st(kk,inaml)
                 if(varlist(ivar)%name.eq.znam) then
                    ifound=ivar
                    exit
                 endif
              enddo
              if(ifound.gt.0) then
                 jnaml=inaml
                 kk=inum_naml(jnaml)+1
                 ilins_naml(kk,jnaml)=jj
                 inum_naml(jnaml)=kk
                 exit
              endif
           enddo

           if(ifound.eq.0) then
              write(6,*) ' ?splitn_update_check: sort to namelist failed:'
              write(6,*) '  ',trim(textnl(jj))
           endif
        enddo

        ! write each namelist...
        do inaml=1,nnamls
           if(inum_naml(inaml).eq.0) cycle
           !  OK, not empty...
           cur_naml = all_namls(inaml)
           write(ilun,*) ' '
           write(ilun,*) '&'//trim(cur_naml)

           !  screen out comments & blank lines
           do ii=1,inum_naml(inaml)
              jj=ilins_naml(ii,inaml)
              ilen=abs(lenl(jj))
              zquot=' '
              inb=0
              do kk=1,ilen
                 char1 = textnl(jj)(kk:kk)
                 if((char1.ne.' ').and.(char1.ne.char(9))) inb=kk
                 if(zquot.ne.' ') then
                    if(char1.eq.zquot) zquot=' '
                 else
                    if(char1.eq.'!') then
                       ilen=kk-1
                       if(textnl(jj)(1:ilen).eq.' ') ilen=0
                       exit
                    endif
                 endif
              enddo
              if(inb.eq.0) ilen=0
              if(ilen.eq.0) cycle
              write(ilun,'(A)') trim(textnl(jj)(1:ilen))
           enddo
           write(ilun,*) '/'
        enddo

        close(unit=ilun)

        if(istat.eq.2) write(6,*) ' %splitn: updates pending...'
     endif
  endif

end subroutine splitn_update_check

      subroutine tdb_profin(d, t, ierr)
 
      !  fetch profile data from trdatbuf buffer (d) according to
      !  specifications in target structure (t).
 
      !  time averaging t%delta_t > 0 supported...
 
      use trdatbuf_obj
      use trdatbuf_aux
      use trdatbuf_iface, only: tdb_range_ntimes2,tdb_range_times2,
     >   tdb_rmp_bdy
 
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
      type (profget) :: t
      integer, intent(out) :: ierr  ! completion code (0=OK)
 
      !---------------------------------------
      ! local information: for time averaging...
 
      integer :: int_avg        ! no. of time pts
      real*8 :: zt1,zt2         ! averaging time range
      real*8, dimension(:), allocatable :: zt_avg,zw_avg ! times & weights
 
      type(profget) :: t_use,t_sum
      integer :: it
      integer :: nonlin,lunmsg_tdb
      !---------------------------------------
 
      if(t%delta_t.le.0.0_R8) then
         call tdb_profin1(d, t, ierr) ! no time averaging
      else
         ! *** time averaging needed ***
 
         nonlin = lunmsg_tdb(0)
 
         call tdb_profget_init(t_use,t%nzones,t%idebug)
 
         t_use%item = t%item
         t_use%xibdys = t%xibdys
         t_use%plflxg = t%plflxg
         t_use%rmajmp = t%rmajmp
         t_use%bmidp = t%bmidp
 
         ! t_use%time will be set below...
 
         t_use%delta_t = 0
         t_use%ibdy = t%ibdy
         call tdb_profget_init(t_sum,t%nzones,t%idebug) ! sums are zeroed now.
 
         zt1 = t%time - t%delta_t
         zt2 = t%time + t%delta_t
 
                                ! fetch timebase for averaging...
 
         call tdb_range_ntimes2(d,zt1,zt2,int_avg) ! #time pts in database
 
         int_avg = int_avg+2    ! add in interval end points zt1,zt2
 
         allocate(zt_avg(int_avg),zw_avg(int_avg))
 
         zt_avg(1) = zt1
         zt_avg(int_avg) = zt2
         call tdb_range_times2(d,zt1,zt2,zt_avg(2:int_avg-1),ierr)
 
         if(ierr.ne.0) then
            write(nonlin,*)
     >           ' ?? tdb_profin with time averaging: unexpected error!'
         else
 
                                ! compute weighting factors proportional to dt
 
            zw_avg(1)=(zt_avg(2)-zt_avg(1))/2/(zt2-zt1)
            zw_avg(int_avg)=
     >           (zt_avg(int_avg)-zt_avg(int_avg-1))/2/(zt2-zt1)
            do it=2,int_avg-1
               zw_avg(it)=(zt_avg(it+1)-zt_avg(it-1))/2/(zt2-zt1)
            enddo
 
                                ! compute sum...
 
            do it=1,int_avg
               t_use%time = zt_avg(it)
 
               call tdb_profin1(d, t_use, ierr)
               if(ierr.ne.0) exit
 
               t_sum%data_zc = t_sum%data_zc + zw_avg(it)*t_use%data_zc
               t_sum%data_zb = t_sum%data_zb + zw_avg(it)*t_use%data_zb
 
               if(t%idebug) then
                  t_sum%ecegap = t_sum%ecegap+zw_avg(it)*t_use%ecegap
                  t_sum%asym_zc = t_sum%asym_zc+zw_avg(it)*t_use%asym_zc
                  t_sum%asym_zb = t_sum%asym_zb+zw_avg(it)*t_use%asym_zb
                  t_sum%shift = t_sum%shift+zw_avg(it)*t_use%shift
                  t_sum%datrsym = t_sum%datrsym+zw_avg(it)*t_use%datrsym
                  t_sum%datusym = t_sum%datusym+zw_avg(it)*t_use%datusym
                  t_sum%rmjsym = t_sum%rmjsym+zw_avg(it)*t_use%rmjsym
               endif
            enddo
                                ! all done; transfer output
 
            t%data_zc = t_sum%data_zc
            t%data_zb = t_sum%data_zb
 
            if(t%idebug) then
               t%ecegap = t_sum%ecegap
               t%asym_zc = t_sum%asym_zc
               t%asym_zb = t_sum%asym_zb
               t%shift = t_sum%shift
               t%datrsym = t_sum%datrsym
               t%datusym = t_sum%datusym
               t%xirsym = t_use%xirsym ! does not vary in time
               t%rmjsym = t_sum%rmjsym
            endif
         endif
 
         ! release storage
 
         call tdb_profget_free(t_use)
         call tdb_profget_free(t_sum)
 
         deallocate(zt_avg,zw_avg)
 
      endif
 
      end
!-------------------------------------------------------------------------
      subroutine tdb_profin1(d, t, ierr)
 
      !  fetch profile data from trdatbuf buffer (d) according to
      !  specifications in target structure (t).
 
      !  *** no time averaging *** t%delta_t = ZERO expected
 
      use trdatbuf_obj
      use trdatbuf_aux
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
      type (profget) :: t
      integer, intent(out) :: ierr  ! completion code (0=OK)
 
      !  ierr is set if the profile id is unrecognized or if it is recognized
      !  but there is no such data...
 
      integer :: i,j,iadr,i2zp1
      character*3 :: zid
 
      integer :: nonlin,lunmsg_tdb
 
      real*8 zrmj_old,zrmj_new,zr1,zr2,zr1p,zr2p,zdelr,zf
 
      integer,save :: iwarn=5
 
      !----------------------------------
 
      ierr=1
 
      i=t%iselect
      zid = t%item
      call uupper(zid)
C
      nonlin = lunmsg_tdb(0)
C
C  tdb_profin1 check:
C
      if(t%delta_t.gt.0.0_R8) then
         write(nonlin,*) ' ? tdb_profin1 -- t%delta_t = ',t%delta_t
         write(nonlin,*)
     >        '   this routine does not support time averaging.'
         return
      endif
C
C  check that initialization was done...
C
      if(d%lbx(1).eq.0) then
         ierr=100
         write(nonlin,*)
     >        ' ? tdb_profin: error exit -- "d%lbx" unitialized'
         write(nonlin,*)
     >        ' ? call to "tdb_symini" is needed.'
         return
      endif
 
C
C  check normalization of R grid -- adjust, as may be necessary when
C  a free boundary code seeks data from a fixed boundary TRANSP dataset...
C
      if(t%nzones.le.0) then
         ierr=200
         write(nonlin,*)
     >        ' ? tdb_profin: t%nzones <= ZERO'
         return
      endif
C
      i2zp1=2*t%nzones + 1
      if((t%rmajmp(i2zp1)-t%rmajmp(1)).le.0.0_R8) then
         ierr=300
         write(nonlin,*)
     >        ' ? tdb_profin -- no midplane radii?  t%rmajmp = '
         write(nonlin,*) t%rmajmp(1:i2zp1)
         return
      endif
      if(min(t%rmajmp(i2zp1),t%rmajmp(1)).le.0.0_R8) then
         ierr=300
         write(nonlin,*)
     >        ' ? tdb_profin -- midplane radii <= 0?  t%rmajmp = '
         write(nonlin,*) t%rmajmp(1:i2zp1)
         return
      endif
C
      call tdb_rmp_bdy(d,t%time,zr1,zr2)
C
      zdelr=max(abs(zr1-t%rmajmp(1)),abs(zr2-t%rmajmp(i2zp1)))/
     >     max(zr1,zr2)
      if(zdelr.gt.0.01_R8) then
         if(iwarn.gt.0) then
            iwarn=iwarn-1
            write(nonlin,*) ' %tdb_profin:  t%rmajmp and input data',
     >           ' major radius grids not matched:'
            write(nonlin,*) ' R1(t%rmajmp, data): ',t%rmajmp(1),zr1
            write(nonlin,*) ' R2(t%rmajmp, data): ',t%rmajmp(i2zp1),zr2
            write(nonlin,*) '   (fixup applied).'
         endif
      endif
C
      zr1p=t%rmajmp(1)
      zr2p=t%rmajmp(i2zp1)
      do i=1,i2zp1
         zf = (t%rmajmp(i)-zr1p)/(zr2p-zr1p)
         zrmj_old=t%rmajmp(i)
         zrmj_new=zr1*(1.0_R8-zf)+zr2*zf
         t%rmajmp(i)=zrmj_new
         t%bmidp(i)=zrmj_old*t%bmidp(i)/zrmj_new
      enddo
      i=t%iselect    ! needed for SIM
C
C  if Te(R) data is requested -- provide automatic switching between TER and
C  ECF
C
      if(zid.eq.'TER') then
         if(d%lfter.eq.0) then
            if(d%lfecf.ne.0) then
               zid='ECF'
            endif
         endif
      else if(zid.eq.'ECF') then
         if(d%lfecf.eq.0) then
            if(d%lfter.ne.0) then
               zid='TER'
            endif
         endif
      endif
C
C  Similar equivalence for toroidal rotation data VP2 or OMG
C  (toroidal velocity or angular velocity input signals are all converted
C  to angular velocity in trdat).
C
      if(zid.eq.'OMG') then
         if(d%lfomg.eq.0) then
            if(d%lfvp2.ne.0) then
               zid='VP2'
            endif
         endif
      else if(zid.eq.'VP2') then
         if(d%lfvp2.eq.0) then
            if(d%lfomg.ne.0) then
               zid='OMG'
            endif
         endif
      endif
C
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C
C------------------
      IF(ZID.EQ.'AXR') THEN
        t%IECE=.FALSE.
        IF(D%LFAXR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXAXR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIAXR,D%NSYAXR,
     >        D%LXAXR,D%NXAXR,D%LFAXR,
     >        D%LXSYAXR,D%NXSYAXR,D%LFSYAXR,D%LSSYAXR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'BOL') THEN
        t%IECE=.FALSE.
        IF(D%LFBOL.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXBOL.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIBOL,D%NSYBOL,
     >        D%LXBOL,D%NXBOL,D%LFBOL,
     >        D%LXSYBOL,D%NXSYBOL,D%LFSYBOL,D%LSSYBOL,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'BPA') THEN
        t%IECE=.FALSE.
        IF(D%LFBPA.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXBPA.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIBPA,D%NSYBPA,
     >        D%LXBPA,D%NXBPA,D%LFBPA,
     >        D%LXSYBPA,D%NXSYBPA,D%LFSYBPA,D%LSSYBPA,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'BPB') THEN
        t%IECE=.FALSE.
        IF(D%LFBPB.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXBPB.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIBPB,D%NSYBPB,
     >        D%LXBPB,D%NXBPB,D%LFBPB,
     >        D%LXSYBPB,D%NXSYBPB,D%LFSYBPB,D%LSSYBPB,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'D2F') THEN
        t%IECE=.FALSE.
        IF(D%LFD2F.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXD2F.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRID2F,D%NSYD2F,
     >        D%LXD2F,D%NXD2F,D%LFD2F,
     >        D%LXSYD2F,D%NXSYD2F,D%LFSYD2F,D%LSSYD2F,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DE2') THEN
        t%IECE=.FALSE.
        IF(D%LFDE2.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDE2.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDE2,D%NSYDE2,
     >        D%LXDE2,D%NXDE2,D%LFDE2,
     >        D%LXSYDE2,D%NXSYDE2,D%LFSYDE2,D%LSSYDE2,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DF3') THEN
        t%IECE=.FALSE.
        IF(D%LFDF3.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDF3.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDF3,D%NSYDF3,
     >        D%LXDF3,D%NXDF3,D%LFDF3,
     >        D%LXSYDF3,D%NXSYDF3,D%LFSYDF3,D%LSSYDF3,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DF4') THEN
        t%IECE=.FALSE.
        IF(D%LFDF4.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDF4.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDF4,D%NSYDF4,
     >        D%LXDF4,D%NXDF4,D%LFDF4,
     >        D%LXSYDF4,D%NXSYDF4,D%LFSYDF4,D%LSSYDF4,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DF6') THEN
        t%IECE=.FALSE.
        IF(D%LFDF6.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDF6.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDF6,D%NSYDF6,
     >        D%LXDF6,D%NXDF6,D%LFDF6,
     >        D%LXSYDF6,D%NXSYDF6,D%LFSYDF6,D%LSSYDF6,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DFD') THEN
        t%IECE=.FALSE.
        IF(D%LFDFD.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDFD.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDFD,D%NSYDFD,
     >        D%LXDFD,D%NXDFD,D%LFDFD,
     >        D%LXSYDFD,D%NXSYDFD,D%LFSYDFD,D%LSSYDFD,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DFH') THEN
        t%IECE=.FALSE.
        IF(D%LFDFH.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDFH.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDFH,D%NSYDFH,
     >        D%LXDFH,D%NXDFH,D%LFDFH,
     >        D%LXSYDFH,D%NXSYDFH,D%LFSYDFH,D%LSSYDFH,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'DFT') THEN
        t%IECE=.FALSE.
        IF(D%LFDFT.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXDFT.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIDFT,D%NSYDFT,
     >        D%LXDFT,D%NXDFT,D%LFDFT,
     >        D%LXSYDFT,D%NXSYDFT,D%LFSYDFT,D%LSSYDFT,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'ECF') THEN
        t%IECE=.TRUE.
        IF(D%LFECF.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXECF.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIECF,D%NSYECF,
     >        D%LXECF,D%NXECF,D%LFECF,
     >        D%LXSYECF,D%NXSYECF,D%LFSYECF,D%LSSYECF,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'FEH') THEN
        t%IECE=.FALSE.
        IF(D%LFFEH.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXFEH.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIFEH,D%NSYFEH,
     >        D%LXFEH,D%NXFEH,D%LFFEH,
     >        D%LXSYFEH,D%NXSYFEH,D%LFSYFEH,D%LSSYFEH,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'FEL') THEN
        t%IECE=.FALSE.
        IF(D%LFFEL.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXFEL.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIFEL,D%NSYFEL,
     >        D%LXFEL,D%NXFEL,D%LFFEL,
     >        D%LXSYFEL,D%NXSYFEL,D%LFSYFEL,D%LSSYFEL,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'GRB') THEN
        t%IECE=.FALSE.
        IF(D%LFGRB.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXGRB.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIGRB,D%NSYGRB,
     >        D%LXGRB,D%NXGRB,D%LFGRB,
     >        D%LXSYGRB,D%NXSYGRB,D%LFSYGRB,D%LSSYGRB,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'IBE') THEN
        t%IECE=.FALSE.
        IF(D%LFIBE.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXIBE.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIIBE,D%NSYIBE,
     >        D%LXIBE,D%NXIBE,D%LFIBE,
     >        D%LXSYIBE,D%NXSYIBE,D%LFSYIBE,D%LSSYIBE,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'IBI') THEN
        t%IECE=.FALSE.
        IF(D%LFIBI.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXIBI.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIIBI,D%NSYIBI,
     >        D%LXIBI,D%NXIBI,D%LFIBI,
     >        D%LXSYIBI,D%NXSYIBI,D%LFSYIBI,D%LSSYIBI,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'JBM') THEN
        t%IECE=.FALSE.
        IF(D%LFJBM.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXJBM.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIJBM,D%NSYJBM,
     >        D%LXJBM,D%NXJBM,D%LFJBM,
     >        D%LXSYJBM,D%NXSYJBM,D%LFSYJBM,D%LSSYJBM,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'JEC') THEN
        t%IECE=.FALSE.
        IF(D%LFJEC.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXJEC.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIJEC,D%NSYJEC,
     >        D%LXJEC,D%NXJEC,D%LFJEC,
     >        D%LXSYJEC,D%NXSYJEC,D%LFSYJEC,D%LSSYJEC,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'JIC') THEN
        t%IECE=.FALSE.
        IF(D%LFJIC.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXJIC.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIJIC,D%NSYJIC,
     >        D%LXJIC,D%NXJIC,D%LFJIC,
     >        D%LXSYJIC,D%NXSYJIC,D%LFSYJIC,D%LSSYJIC,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LF3') THEN
        t%IECE=.FALSE.
        IF(D%LFLF3.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLF3.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILF3,D%NSYLF3,
     >        D%LXLF3,D%NXLF3,D%LFLF3,
     >        D%LXSYLF3,D%NXSYLF3,D%LFSYLF3,D%LSSYLF3,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LF4') THEN
        t%IECE=.FALSE.
        IF(D%LFLF4.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLF4.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILF4,D%NSYLF4,
     >        D%LXLF4,D%NXLF4,D%LFLF4,
     >        D%LXSYLF4,D%NXSYLF4,D%LFSYLF4,D%LSSYLF4,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LF6') THEN
        t%IECE=.FALSE.
        IF(D%LFLF6.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLF6.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILF6,D%NSYLF6,
     >        D%LXLF6,D%NXLF6,D%LFLF6,
     >        D%LXSYLF6,D%NXSYLF6,D%LFSYLF6,D%LSSYLF6,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LFD') THEN
        t%IECE=.FALSE.
        IF(D%LFLFD.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLFD.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILFD,D%NSYLFD,
     >        D%LXLFD,D%NXLFD,D%LFLFD,
     >        D%LXSYLFD,D%NXSYLFD,D%LFSYLFD,D%LSSYLFD,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LFH') THEN
        t%IECE=.FALSE.
        IF(D%LFLFH.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLFH.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILFH,D%NSYLFH,
     >        D%LXLFH,D%NXLFH,D%LFLFH,
     >        D%LXSYLFH,D%NXSYLFH,D%LFSYLFH,D%LSSYLFH,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LFT') THEN
        t%IECE=.FALSE.
        IF(D%LFLFT.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLFT.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILFT,D%NSYLFT,
     >        D%LXLFT,D%NXLFT,D%LFLFT,
     >        D%LXSYLFT,D%NXSYLFT,D%LFSYLFT,D%LSSYLFT,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LHE') THEN
        t%IECE=.FALSE.
        IF(D%LFLHE.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLHE.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILHE,D%NSYLHE,
     >        D%LXLHE,D%NXLHE,D%LFLHE,
     >        D%LXSYLHE,D%NXSYLHE,D%LFSYLHE,D%LSSYLHE,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'LHJ') THEN
        t%IECE=.FALSE.
        IF(D%LFLHJ.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXLHJ.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRILHJ,D%NSYLHJ,
     >        D%LXLHJ,D%NXLHJ,D%LFLHJ,
     >        D%LXSYLHJ,D%NXSYLHJ,D%LFSYLHJ,D%LSSYLHJ,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NER') THEN
        t%IECE=.FALSE.
        IF(D%LFNER.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNER.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINER,D%NSYNER,
     >        D%LXNER,D%NXNER,D%LFNER,
     >        D%LXSYNER,D%NXSYNER,D%LFSYNER,D%LSSYNER,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NI3') THEN
        t%IECE=.FALSE.
        IF(D%LFNI3.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNI3.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINI3,D%NSYNI3,
     >        D%LXNI3,D%NXNI3,D%LFNI3,
     >        D%LXSYNI3,D%NXSYNI3,D%LFSYNI3,D%LSSYNI3,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NI4') THEN
        t%IECE=.FALSE.
        IF(D%LFNI4.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNI4.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINI4,D%NSYNI4,
     >        D%LXNI4,D%NXNI4,D%LFNI4,
     >        D%LXSYNI4,D%NXSYNI4,D%LFSYNI4,D%LSSYNI4,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NI6') THEN
        t%IECE=.FALSE.
        IF(D%LFNI6.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNI6.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINI6,D%NSYNI6,
     >        D%LXNI6,D%NXNI6,D%LFNI6,
     >        D%LXSYNI6,D%NXSYNI6,D%LFSYNI6,D%LSSYNI6,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NID') THEN
        t%IECE=.FALSE.
        IF(D%LFNID.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNID.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINID,D%NSYNID,
     >        D%LXNID,D%NXNID,D%LFNID,
     >        D%LXSYNID,D%NXSYNID,D%LFSYNID,D%LSSYNID,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NIH') THEN
        t%IECE=.FALSE.
        IF(D%LFNIH.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNIH.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINIH,D%NSYNIH,
     >        D%LXNIH,D%NXNIH,D%LFNIH,
     >        D%LXSYNIH,D%NXSYNIH,D%LFSYNIH,D%LSSYNIH,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NIM') THEN
        t%IECE=.FALSE.
        IF(D%LFNIM.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNIM.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINIM,D%NSYNIM,
     >        D%LXNIM,D%NXNIM,D%LFNIM,
     >        D%LXSYNIM,D%NXSYNIM,D%LFSYNIM,D%LSSYNIM,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NIT') THEN
        t%IECE=.FALSE.
        IF(D%LFNIT.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNIT.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINIT,D%NSYNIT,
     >        D%LXNIT,D%NXNIT,D%LFNIT,
     >        D%LXSYNIT,D%NXSYNIT,D%LFSYNIT,D%LSSYNIT,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'NMR') THEN
        t%IECE=.FALSE.
        IF(D%LFNMR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXNMR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRINMR,D%NSYNMR,
     >        D%LXNMR,D%NXNMR,D%LFNMR,
     >        D%LXSYNMR,D%NXSYNMR,D%LFSYNMR,D%LSSYNMR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'OMG') THEN
        t%IECE=.FALSE.
        IF(D%LFOMG.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXOMG.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIOMG,D%NSYOMG,
     >        D%LXOMG,D%NXOMG,D%LFOMG,
     >        D%LXSYOMG,D%NXSYOMG,D%LFSYOMG,D%LSSYOMG,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'PRS') THEN
        t%IECE=.FALSE.
        IF(D%LFPRS.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXPRS.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIPRS,D%NSYPRS,
     >        D%LXPRS,D%NXPRS,D%LFPRS,
     >        D%LXSYPRS,D%NXSYPRS,D%LFSYPRS,D%LSSYPRS,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'QBE') THEN
        t%IECE=.FALSE.
        IF(D%LFQBE.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXQBE.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIQBE,D%NSYQBE,
     >        D%LXQBE,D%NXQBE,D%LFQBE,
     >        D%LXSYQBE,D%NXSYQBE,D%LFSYQBE,D%LSSYQBE,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'QBI') THEN
        t%IECE=.FALSE.
        IF(D%LFQBI.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXQBI.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIQBI,D%NSYQBI,
     >        D%LXQBI,D%NXQBI,D%LFQBI,
     >        D%LXSYQBI,D%NXSYQBI,D%LFSYQBI,D%LSSYQBI,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'QEC') THEN
        t%IECE=.FALSE.
        IF(D%LFQEC.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXQEC.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIQEC,D%NSYQEC,
     >        D%LXQEC,D%NXQEC,D%LFQEC,
     >        D%LXSYQEC,D%NXSYQEC,D%LFSYQEC,D%LSSYQEC,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'QIC') THEN
        t%IECE=.FALSE.
        IF(D%LFQIC.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXQIC.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIQIC,D%NSYQIC,
     >        D%LXQIC,D%NXQIC,D%LFQIC,
     >        D%LXSYQIC,D%NXSYQIC,D%LFSYQIC,D%LSSYQIC,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'QPR') THEN
        t%IECE=.FALSE.
        IF(D%LFQPR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXQPR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIQPR,D%NSYQPR,
     >        D%LXQPR,D%NXQPR,D%LFQPR,
     >        D%LXSYQPR,D%NXSYQPR,D%LFSYQPR,D%LSSYQPR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'RES') THEN
        t%IECE=.FALSE.
        IF(D%LFRES.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXRES.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIRES,D%NSYRES,
     >        D%LXRES,D%NXRES,D%LFRES,
     >        D%LXSYRES,D%NXSYRES,D%LFSYRES,D%LSSYRES,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'SBI') THEN
        t%IECE=.FALSE.
        IF(D%LFSBI.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXSBI.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRISBI,D%NSYSBI,
     >        D%LXSBI,D%NXSBI,D%LFSBI,
     >        D%LXSYSBI,D%NXSYSBI,D%LFSYSBI,D%LSSYSBI,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'TER') THEN
        t%IECE=.FALSE.
        IF(D%LFTER.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXTER.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRITER,D%NSYTER,
     >        D%LXTER,D%NXTER,D%LFTER,
     >        D%LXSYTER,D%NXSYTER,D%LFSYTER,D%LSSYTER,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'TI2') THEN
        t%IECE=.FALSE.
        IF(D%LFTI2.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXTI2.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRITI2,D%NSYTI2,
     >        D%LXTI2,D%NXTI2,D%LFTI2,
     >        D%LXSYTI2,D%NXSYTI2,D%LFSYTI2,D%LSSYTI2,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'TQI') THEN
        t%IECE=.FALSE.
        IF(D%LFTQI.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXTQI.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRITQI,D%NSYTQI,
     >        D%LXTQI,D%NXTQI,D%LFTQI,
     >        D%LXSYTQI,D%NXSYTQI,D%LFSYTQI,D%LSSYTQI,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'V2F') THEN
        t%IECE=.FALSE.
        IF(D%LFV2F.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXV2F.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIV2F,D%NSYV2F,
     >        D%LXV2F,D%NXV2F,D%LFV2F,
     >        D%LXSYV2F,D%NXSYV2F,D%LFSYV2F,D%LSSYV2F,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VB2') THEN
        t%IECE=.FALSE.
        IF(D%LFVB2.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVB2.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVB2,D%NSYVB2,
     >        D%LXVB2,D%NXVB2,D%LFVB2,
     >        D%LXSYVB2,D%NXSYVB2,D%LFSYVB2,D%LSSYVB2,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VC3') THEN
        t%IECE=.FALSE.
        IF(D%LFVC3.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVC3.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVC3,D%NSYVC3,
     >        D%LXVC3,D%NXVC3,D%LFVC3,
     >        D%LXSYVC3,D%NXSYVC3,D%LFSYVC3,D%LSSYVC3,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VC4') THEN
        t%IECE=.FALSE.
        IF(D%LFVC4.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVC4.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVC4,D%NSYVC4,
     >        D%LXVC4,D%NXVC4,D%LFVC4,
     >        D%LXSYVC4,D%NXSYVC4,D%LFSYVC4,D%LSSYVC4,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VC6') THEN
        t%IECE=.FALSE.
        IF(D%LFVC6.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVC6.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVC6,D%NSYVC6,
     >        D%LXVC6,D%NXVC6,D%LFVC6,
     >        D%LXSYVC6,D%NXSYVC6,D%LFSYVC6,D%LSSYVC6,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VCD') THEN
        t%IECE=.FALSE.
        IF(D%LFVCD.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVCD.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVCD,D%NSYVCD,
     >        D%LXVCD,D%NXVCD,D%LFVCD,
     >        D%LXSYVCD,D%NXSYVCD,D%LFSYVCD,D%LSSYVCD,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VCH') THEN
        t%IECE=.FALSE.
        IF(D%LFVCH.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVCH.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVCH,D%NSYVCH,
     >        D%LXVCH,D%NXVCH,D%LFVCH,
     >        D%LXSYVCH,D%NXSYVCH,D%LFSYVCH,D%LSSYVCH,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VCT') THEN
        t%IECE=.FALSE.
        IF(D%LFVCT.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVCT.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVCT,D%NSYVCT,
     >        D%LXVCT,D%NXVCT,D%LFVCT,
     >        D%LXSYVCT,D%NXSYVCT,D%LFSYVCT,D%LSSYVCT,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VEE') THEN
        t%IECE=.FALSE.
        IF(D%LFVEE.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVEE.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVEE,D%NSYVEE,
     >        D%LXVEE,D%NXVEE,D%LFVEE,
     >        D%LXSYVEE,D%NXSYVEE,D%LFSYVEE,D%LSSYVEE,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VIE') THEN
        t%IECE=.FALSE.
        IF(D%LFVIE.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVIE.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVIE,D%NSYVIE,
     >        D%LXVIE,D%NXVIE,D%LFVIE,
     >        D%LXSYVIE,D%NXSYVIE,D%LFSYVIE,D%LSSYVIE,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VMO') THEN
        t%IECE=.FALSE.
        IF(D%LFVMO.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVMO.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVMO,D%NSYVMO,
     >        D%LXVMO,D%NXVMO,D%LFVMO,
     >        D%LXSYVMO,D%NXSYVMO,D%LFSYVMO,D%LSSYVMO,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VP2') THEN
        t%IECE=.FALSE.
        IF(D%LFVP2.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVP2.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVP2,D%NSYVP2,
     >        D%LXVP2,D%NXVP2,D%LFVP2,
     >        D%LXSYVP2,D%NXSYVP2,D%LFSYVP2,D%LSSYVP2,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VPO') THEN
        t%IECE=.FALSE.
        IF(D%LFVPO.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVPO.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVPO,D%NSYVPO,
     >        D%LXVPO,D%NXVPO,D%LFVPO,
     >        D%LXSYVPO,D%NXSYVPO,D%LFSYVPO,D%LSSYVPO,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VPR') THEN
        t%IECE=.FALSE.
        IF(D%LFVPR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVPR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVPR,D%NSYVPR,
     >        D%LXVPR,D%NXVPR,D%LFVPR,
     >        D%LXSYVPR,D%NXSYVPR,D%LFSYVPR,D%LSSYVPR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'VTR') THEN
        t%IECE=.FALSE.
        IF(D%LFVTR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXVTR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIVTR,D%NSYVTR,
     >        D%LXVTR,D%NXVTR,D%LFVTR,
     >        D%LXSYVTR,D%NXSYVTR,D%LFSYVTR,D%LSSYVTR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'ZF2') THEN
        t%IECE=.FALSE.
        IF(D%LFZF2.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXZF2.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIZF2,D%NSYZF2,
     >        D%LXZF2,D%NXZF2,D%LFZF2,
     >        D%LXSYZF2,D%NXSYZF2,D%LFSYZF2,D%LSSYZF2,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'ZXR') THEN
        t%IECE=.FALSE.
        IF(D%LFZXR.le.0) then    ! no data
          write(nonlin,*) ' ?? tdb_profli: lf'//zid//' = 0, no data.'
          return
        endif
        IF(D%NXZXR.le.1) then
          write(nonlin,*) ' -> tdb_profli: nx'//zid//' <=1, no profile.'
          ierr=0
          return
        endif
        CALL TDB_PROFLI(d, t, D%NRIZXR,D%NSYZXR,
     >        D%LXZXR,D%NXZXR,D%LFZXR,
     >        D%LXSYZXR,D%NXSYZXR,D%LFSYZXR,D%LSSYZXR,
     >        ierr)
      ENDIF
C
C------------------
      IF(ZID.EQ.'SIM') THEN
        t%IECE=.FALSE.
        IF(D%LFSIM(I).le.0) return  ! no data
        J = D%NISSIM(I)
        CALL TDB_PROFLI(d, t, D%NRISIM(J),D%NSYSIM(J),
     >        D%LXSIM(J),D%NXSIM(J),D%LFSIM(I),
     >        D%LXSYSIM(J),D%NXSYSIM(J),D%LFSYSIM(I),D%LSSYSIM(I),
     >        ierr)
      ENDIF
C
C=>TRDATGEN-
C
      return
      end

subroutine ps_enum_1d_store(iobj,enum_name,iauthor, &
     isize,enum_1d, imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a 1d enumeration of floating point values

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: enum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: isize             ! size of enumeration (1d array)
  REAL(kind=rspec), intent(in) :: enum_1d(isize)  ! the data

  integer, intent(out) :: imod             ! =1 if data is new or modified
  !  =0 on output if data was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,iertmp,idhdr(2)

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real*8, dimension(:), pointer :: r8data
  integer, dimension(:), pointer :: idata

  integer, parameter :: bbtype = 177       ! arbitrary blackbox "type" id

  integer, parameter :: maxsize = 5000
  !--------------------------------------------------

  imod = 0
  nullify(r8data)
  nullify(idata)

  ierr=0
  if(isize.lt.0) then
     ierr=999
     write(iout,*) ' ?ps_enum_1d_store: negative enumeration size: ',isize
  else if(isize.gt.maxsize) then
     ierr=999
     write(iout,*) ' ?ps_enum_1d_store: enumeration size: ',isize, &
          ' exceeds limit: ',maxsize
  endif
  if(ierr.ne.0) return
     
  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_1d_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_1d_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
     return
  endif

  !--------------------------------------------------
  !  look to see if enumeration has already been stored

  call xplasma_blkbxId(s,enum_name,id)

  if(id.ne.0) then
     call xplasma_blackBox_retrieve(s,id,ierr, ia_ptr=idata, r8a_ptr=r8data)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_enum_1d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif

     if(size(idata).ne.2) then
        imod=1   ! integer descriptor size does not match
     else
        if((idata(1).ne.0).or.(idata(2).ne.isize)) then
           imod=1  ! enumeration rank and/or size do not match
        else
           do ii=1,isize
              if(enum_1d(ii).ne.r8data(ii)) then
                 imod=1
                 exit        ! change in data value
              endif
           enddo
        endif
     endif
     nullify(idata)
     nullify(r8data)

  else
     imod=1    ! storing for first time...
  endif

  if(imod.eq.1) then

     idhdr(1) = 0             ! indicates 1d enumeration array
     idhdr(2) = isize

     call xplasma_create_blackBox(s,enum_name,bbtype,id,ierr, &
          iarray=idhdr, r8array=enum_1d)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_enum_1d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif
  endif
  !--------------------------------------------------
  ! clear author

999 continue

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_enum_1d_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_enum_1d_store

subroutine ps_enum_2d_store(iobj,enum_name,iauthor, &
     inume,isize_vec,idim1,enum_2d, imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a list of 1d enumerations of floating point values
  ! rank of resulting array is 2d

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: enum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: inume             ! number of enumerations
  integer, intent(in) :: isize_vec(inume)  ! size of each enumeration (0 OK)
  integer, intent(in) :: idim1             ! 1st dim of data array

  REAL(kind=rspec), intent(in) :: enum_2d(idim1,inume)  ! the data

  integer, intent(out) :: imod             ! =1 if data is new or modified
  !  =0 on output if data was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,ie,ia,iertmp,idhdr(inume+1),isize_tot

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real*8, dimension(:), pointer :: r8data
  integer, dimension(:), pointer :: idata

  integer, parameter :: bbtype = 177       ! arbitrary blackbox "type" id

  integer, parameter :: maxsize = 5000
  !--------------------------------------------------

  imod = 0
  nullify(r8data)
  nullify(idata)

  ierr=0
  if(minval(isize_vec).lt.0) then
     ierr=999
     write(iout,*) ' ?ps_enum_1d_store: negative enumeration size: ',isize_vec
  else if(maxval(isize_vec).gt.maxsize) then
     ierr=999
     write(iout,*) ' ?ps_enum_1d_store: enumeration size: ',isize_vec, &
          ' exceeds limit: ',maxsize
  else if(maxval(isize_vec).gt.idim1) then
     ierr=999
     write(iout,*) ' ?ps_enum_1d_store: enumeration size: ',isize_vec, &
          ' exceeds array dimension: ',idim1
  endif
  if(ierr.ne.0) return

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_enum_2d_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_2d_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
     return
  endif

  !--------------------------------------------------
  !  look to see if enumeration has already been stored

  idhdr(1)=inume
  idhdr(2:inume+1) = isize_vec
  isize_tot = sum(isize_vec)

  call xplasma_blkbxId(s,enum_name,id)

  if(id.ne.0) then
     call xplasma_blackBox_retrieve(s,id,ierr, ia_ptr=idata, r8a_ptr=r8data)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_enum_2d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif

     if(size(idata).ne.(inume+1)) then
        imod=1   ! integer header size does not match
     else
        do ii=1,inume+1
           if(idata(ii).ne.idhdr(ii)) then
              imod=1
              exit   ! headers do not match
           endif
        enddo
        if(imod.eq.0) then
           ! check the data
           ia=0
           do ie=1,inume
              do ii=1,isize_vec(ie)
                 ia=ia+1
                 if(r8data(ia).ne.enum_2d(ii,ie)) then
                    imod=1
                    exit     ! change in data value
                 endif
              enddo
              if(imod.eq.1) exit
           enddo
        endif
     endif
     nullify(idata)
     nullify(r8data)

  else
     imod=1    ! storing for first time...
  endif

  if(imod.eq.1) then

     allocate(r8data(max(1,isize_tot))); r8data(1)=0.0_rspec

     ia=0
     do ie=1,inume
        do ii=1,isize_vec(ie)
           ia=ia+1
           r8data(ia) = enum_2d(ii,ie)
        enddo
     enddo

     call xplasma_create_blackBox(s,enum_name,bbtype,id,ierr, &
          iarray=idhdr, r8array=r8data)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_enum_2d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif
  endif
  !--------------------------------------------------
  ! clear author

999 continue
  if(associated(r8data)) deallocate(r8data)

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_enum_2d_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_enum_2d_store

subroutine ps_inum_1d_store(iobj,inum_name,iauthor, &
     isize,inum_1d, imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a 1d enumeration of INTEGER values

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: inum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: isize             ! size of enumeration (1d array)
  integer, intent(in) :: inum_1d(isize)    ! the data

  integer, intent(out) :: imod             ! =1 if data is new or modified
  !  =0 on output if data was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,iertmp,idhdr(2)

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real*8, dimension(:), pointer :: r8data
  integer, dimension(:), pointer :: idata

  real*8 :: r8dum(1)

  integer, parameter :: bbtype = 178       ! arbitrary blackbox "type" id

  integer, parameter :: maxsize = 5000
  !--------------------------------------------------

  imod = 0
  nullify(r8data)
  nullify(idata)

  ierr=0
  if(isize.lt.0) then
     ierr=999
     write(iout,*) ' ?ps_inum_1d_store: negative enumeration size: ',isize
  else if(isize.gt.maxsize) then
     ierr=999
     write(iout,*) ' ?ps_inum_1d_store: enumeration size: ',isize, &
          ' exceeds limit: ',maxsize
  endif
  if(ierr.ne.0) return
     
  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_1d_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_1d_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
     return
  endif

  !--------------------------------------------------
  !  look to see if enumeration has already been stored

  call xplasma_blkbxId(s,inum_name,id)

  if(id.ne.0) then
     call xplasma_blackBox_retrieve(s,id,ierr, ia_ptr=idata, r8a_ptr=r8data)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_inum_1d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif

     if(size(idata).ne.2+isize) then
        imod=1   ! integer descriptor size does not match
     else
        if((idata(1).ne.0).or.(idata(2).ne.isize)) then
           imod=1  ! enumeration rank and/or size do not match
        else
           do ii=1,isize
              if(inum_1d(ii).ne.idata(ii+2)) then
                 imod=1
                 exit        ! change in data value
              endif
           enddo
        endif
     endif
     nullify(idata)
     nullify(r8data)

  else
     imod=1    ! storing for first time...
  endif

  if(imod.eq.1) then

     r8dum = 0.0_rspec

     allocate(idata(isize+2))

     idata(1) = 0             ! indicates 1d enumeration array
     idata(2) = isize
     idata(3:isize+2) = inum_1d(1:isize)

     call xplasma_create_blackBox(s,inum_name,bbtype,id,ierr, &
          iarray=idata, r8array=r8dum)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_inum_1d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif
  endif
  !--------------------------------------------------
  ! clear author

999 continue
  if(associated(idata)) deallocate(idata)

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_inum_1d_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_inum_1d_store

subroutine ps_inum_2d_store(iobj,inum_name,iauthor, &
     inume,isize_vec,idim1,inum_2d, imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a list of 1d enumerations of floating point values
  ! rank of resulting array is 2d

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: inum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: inume             ! number of enumerations
  integer, intent(in) :: isize_vec(inume)  ! size of each enumeration (0 OK)
  integer, intent(in) :: idim1             ! 1st dim of data array

  integer, intent(in) :: inum_2d(idim1,inume)  ! the data

  integer, intent(out) :: imod             ! =1 if data is new or modified
  !  =0 on output if data was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,ie,ia,iertmp,isize_tot

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real*8, dimension(:), pointer :: r8data
  integer, dimension(:), pointer :: idata

  real*8 :: r8dum(1)

  integer, parameter :: bbtype = 178       ! arbitrary blackbox "type" id

  integer, parameter :: maxsize = 5000
  !--------------------------------------------------

  imod = 0
  nullify(r8data)
  nullify(idata)

  ierr=0
  if(minval(isize_vec).lt.0) then
     ierr=999
     write(iout,*) ' ?ps_inum_2d_store: negative enumeration size: ',isize_vec
  else if(maxval(isize_vec).gt.maxsize) then
     ierr=999
     write(iout,*) ' ?ps_inum_2d_store: enumeration size: ',isize_vec, &
          ' exceeds limit: ',maxsize
  else if(maxval(isize_vec).gt.idim1) then
     ierr=999
     write(iout,*) ' ?ps_inum_2d_store: enumeration size: ',isize_vec, &
          ' exceeds array dimension: ',idim1
  endif
  if(ierr.ne.0) return

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_inum_2d_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_2d_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
     return
  endif

  !--------------------------------------------------
  !  look to see if enumeration has already been stored

  isize_tot = sum(isize_vec)

  call xplasma_blkbxId(s,inum_name,id)

  if(id.ne.0) then
     call xplasma_blackBox_retrieve(s,id,ierr, ia_ptr=idata, r8a_ptr=r8data)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_inum_2d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif

     if(size(idata).ne.(inume+1+isize_tot)) then
        imod=1   ! integer header size does not match
     else
        if(idata(1).ne.inume) then
           imod=1
        endif
        if(imod.eq.0) then
           do ii=1,inume
              if(idata(ii+1).ne.isize_vec(ii)) then
                 imod=1
                 exit   ! headers do not match
              endif
           enddo
        endif
        if(imod.eq.0) then
           ! check the data
           ia=inume+1
           do ie=1,inume
              do ii=1,isize_vec(ie)
                 ia=ia+1
                 if(idata(ia).ne.inum_2d(ii,ie)) then
                    imod=1
                    exit     ! change in data value
                 endif
              enddo
              if(imod.eq.1) exit
           enddo
        endif
     endif
     nullify(idata)
     nullify(r8data)

  else
     imod=1    ! storing for first time...
  endif

  if(imod.eq.1) then

     r8dum=0.0_rspec
     allocate(idata(1+inume+isize_tot))

     idata(1)=inume
     idata(2:inume+1)=isize_vec

     ia=inume+1
     do ie=1,inume
        do ii=1,isize_vec(ie)
           ia=ia+1
           idata(ia) = inum_2d(ii,ie)
        enddo
     enddo

     call xplasma_create_blackBox(s,inum_name,bbtype,id,ierr, &
          iarray=idata, r8array=r8dum)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_inum_2d_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=101
        go to 999
     endif
  endif
  !--------------------------------------------------
  ! clear author

999 continue
  if(associated(idata)) deallocate(idata)

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_inum_2d_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_inum_2d_store

subroutine ps_enum_1d_get(iobj,enum_name,iauthor, &
     isize_dim, isize,enum_1d, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! retrieve a 1d enumeration of floating point values

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: enum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: isize_dim         ! max size of enumeration (1d array)
  integer, intent(out) :: isize            ! actual size
  REAL(kind=rspec), intent(out) :: enum_1d(isize_dim)  ! the data

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,iertmp,idhdr(2),iasize,r8asize

  character*32 pauth

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  ierr=0

  isize=0
  enum_1d=0.0_rspec

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_enum_1d_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find list ID

  call xplasma_blkbxId(s,enum_name,id)
  if(id.eq.0) then
     write(iout,*) ' ?ps_enum_1d_get: enumeration data not found: '// &
          trim(enum_name)
     ierr=801
     return
  endif

  !--------------------------------------------------
  !  fetch and check info

  call xplasma_blackbox_info(s,id,ierr, isize=iasize, r8size=r8asize, &
       author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_1d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
  else
     if(iauthor.gt.0) then
        if(trim(ps_cnames(iauthor)).ne.trim(pauth)) then
           write(iout,*) ' ?ps_enum_1d_get: author label mismatch:'
           write(iout,*) '  data ',trim(enum_name),' has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=801
        endif
     endif
  endif

  if(ierr.ne.0) return

  if((iasize.ne.2).or.(r8asize.gt.isize_dim)) then 
     write(iout,*) ' ?ps_enum_1d_get: "'//trim(enum_name)//'" data object sizes not consistent:'
     write(iout,*) '  expected integer size=2, got: ',iasize
     write(iout,*) '  expected floating pt size <= ',isize_dim,', got:',r8asize
     ierr=801
     return
  endif

  !--------------------------------------------------
  ! OK fetch the data

  call xplasma_blackbox_retrieve(s,id,ierr, &
       iarray=idhdr,r8array=enum_1d(1:r8asize))
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_1d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
     return
  endif

  if((idhdr(1).ne.0).and.(idhdr(1).ne.1)) then
     ierr=801
     write(iout,*) ' ?ps_enum_1d_get: 1st integer header value: ',idhdr(1), &
          '; should be zero or one.'
  endif

  if(idhdr(2).ne.r8asize) then
     ierr=801
     write(iout,*) ' ?ps_enum_1d_get: 2nd integer header value: ',idhdr(2), &
          ' does not match enum_1d size: ',r8asize
  else
     isize=idhdr(2)
  endif

end subroutine ps_enum_1d_get

subroutine ps_enum_2d_get(iobj,enum_name,iauthor, &
     inume,isize_vec, idim1,enum_2d, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! retrieve a 2d enumeration of floating point values
  !    isize_vec(1:inume)
  !    for j=1:inume
  !       enum_2d(1:isize_vec(j),j)

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: enum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: inume             ! number of enumerations expected
  ! (data object must match this)

  integer, intent(out) :: isize_vec(inume) ! sizes of enumerations
  integer, intent(in) :: idim1             ! enum_2d array dimension

  REAL(kind=rspec), intent(out) :: enum_2d(idim1,inume)  ! the data

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,ie,ia,iertmp,iasize,r8asize,isize_max

  integer, dimension(:), pointer :: idata
  real(kind=rspec), dimension(:), pointer :: r8data

  character*32 pauth

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  ierr=0

  isize_vec=0
  enum_2d=0.0_rspec

  nullify(r8data)
  nullify(idata)

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_enum_2d_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find list ID

  call xplasma_blkbxId(s,enum_name,id)
  if(id.eq.0) then
     write(iout,*) ' ?ps_enum_2d_get: enumeration data not found: '// &
          trim(enum_name)
     ierr=801
     return
  endif

  !--------------------------------------------------
  !  fetch and check info

  call xplasma_blackbox_info(s,id,ierr, isize=iasize, r8size=r8asize, &
       author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_2d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
  else
     if(iauthor.gt.0) then
        if(trim(ps_cnames(iauthor)).ne.trim(pauth)) then
           write(iout,*) ' ?ps_enum_2d_get: author label mismatch:'
           write(iout,*) '  data ',trim(enum_name),' has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=801
        endif
     endif
  endif

  if(ierr.ne.0) return

  if((iasize.ne.1+inume)) then 
     write(iout,*) ' ?ps_enum_2d_get: "'//trim(enum_name)//'" data object sizes not consistent:'
     write(iout,*) '  expected integer size=',inume+1,', got: ',iasize
     ierr=801
     return
  endif

  !--------------------------------------------------
  ! OK fetch the data

  call xplasma_blackbox_retrieve(s,id,ierr, &
       ia_ptr=idata,r8a_ptr=r8data)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_2d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
     return
  endif

  if(idata(1).ne.inume) then
     ierr=801
     write(iout,*) ' ?ps_enum_2d_get: 1st integer header value: ',idata(1), &
          '; should match #enumerations:',inume
  endif

  isize_max=maxval(idata(2:inume+1))
  if(isize_max.gt.idim1) then
     ierr=801
     write(iout,*) ' ?ps_enum_2d_get: max enumeration size: ',isize_max, &
          ' exceeds array dimension: ',idim1
     write(iout,*) '  error retrieving enumeration object: '// &
          trim(enum_name)
  endif
  if(ierr.ne.0) return

  isize_vec=idata(2:inume+1)

  ia=0
  do ie=1,inume
     do ii=1,isize_vec(ie)
        ia=ia+1
        if(ia.gt.r8asize) then
           ierr=801
        else
           enum_2d(ii,ie)=r8data(ia)
        endif
     enddo
  enddo

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_enum_2d_get: enumeration data size: ',r8asize
     write(iout,*) '  not consistent with header information.'
     write(iout,*) '  error retrieving enumeration object: '// &
          trim(enum_name)
  endif

  nullify(r8data)
  nullify(idata)

end subroutine ps_enum_2d_get

subroutine ps_inum_1d_get(iobj,inum_name,iauthor, &
     isize_dim, isize,inum_1d, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! retrieve a 1d enumeration of integer values

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: inum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: isize_dim         ! max size of enumeration (1d array)
  integer, intent(out) :: isize            ! actual size
  integer, intent(out) :: inum_1d(isize_dim)  ! the data

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,iertmp,idhdr(2),iasize,r8asize
  
  integer, dimension(:), pointer :: idata
  real*8, dimension(:), pointer :: r8data

  character*32 pauth

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  ierr=0

  isize=0
  inum_1d=0

  nullify(idata)
  nullify(r8data)

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_inum_1d_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find list ID

  call xplasma_blkbxId(s,inum_name,id)
  if(id.eq.0) then
     write(iout,*) ' ?ps_inum_1d_get: enumeration data not found: '// &
          trim(inum_name)
     ierr=801
     return
  endif

  !--------------------------------------------------
  !  fetch and check info

  call xplasma_blackbox_info(s,id,ierr, isize=iasize, r8size=r8asize, &
       author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_1d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
  else
     if(iauthor.gt.0) then
        if(trim(ps_cnames(iauthor)).ne.trim(pauth)) then
           write(iout,*) ' ?ps_inum_1d_get: author label mismatch:'
           write(iout,*) '  data ',trim(inum_name),' has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=801
        endif
     endif
  endif

  if(ierr.ne.0) return

  !--------------------------------------------------
  ! OK fetch the data

  call xplasma_blackbox_retrieve(s,id,ierr, &
       ia_ptr=idata, r8a_ptr=r8data)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_1d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
     return
  endif

  if((idata(1).ne.0).and.(idata(1).ne.1)) then
     ierr=801
     write(iout,*) ' ?ps_inum_1d_get: 1st integer header value: ',idata(1), &
          '; should be zero or one.'
  endif

  isize=idata(2)
  if(isize.gt.isize_dim) then
     ierr=801
     write(iout,*) ' ?ps_inum_1d_get: size of integer enumeration: ',idata(2),&
          ' in '//trim(inum_name)
     write(iout,*) '  exceeds size of array provided: ',isize_dim
  else
     if(size(idata).ne.isize+2) then
        write(iout,*) ' ?ps_inum_1d_get: in '//trim(inum_name)// &
             ' size of integer does not match'
        write(iout,*) '  header size of ',isize,': ',size(idata)-2
     else
        inum_1d(1:isize) = idata(3:isize+2)
     endif
  endif

end subroutine ps_inum_1d_get

subroutine ps_inum_2d_get(iobj,inum_name,iauthor, &
     inume,isize_vec, idim1,inum_2d, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 9 Jun 2008

  ! XPLASMA2 implementation of plasma_state subroutine
  ! retrieve a 2d enumeration of integer values
  !    isize_vec(1:inume)
  !    for j=1:inume
  !       inum_2d(1:isize_vec(j),j)

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container

  character*(*), intent(in) :: inum_name   ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: inume             ! number of enumerations expected
  ! (data object must match this)

  integer, intent(out) :: isize_vec(inume) ! sizes of enumerations
  integer, intent(in) :: idim1             ! inum_2d array dimension

  integer, intent(out) :: inum_2d(idim1,inume)  ! the data

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,ii,ie,ia,iertmp,iasize,r8asize,isize_max

  integer, dimension(:), pointer :: idata
  real(kind=rspec), dimension(:), pointer :: r8data

  character*32 pauth

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  ierr=0

  isize_vec=0
  inum_2d=0.0_rspec

  nullify(r8data)
  nullify(idata)

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_inum_2d_get: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  find list ID

  call xplasma_blkbxId(s,inum_name,id)
  if(id.eq.0) then
     write(iout,*) ' ?ps_inum_2d_get: enumeration data not found: '// &
          trim(inum_name)
     ierr=801
     return
  endif

  !--------------------------------------------------
  !  fetch and check info

  call xplasma_blackbox_info(s,id,ierr, isize=iasize, r8size=r8asize, &
       author=pauth)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_2d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
  else
     if(iauthor.gt.0) then
        if(trim(ps_cnames(iauthor)).ne.trim(pauth)) then
           write(iout,*) ' ?ps_inum_2d_get: author label mismatch:'
           write(iout,*) '  data ',trim(inum_name),' has: "',trim(pauth), &
                '"; passed author reference: "',trim(ps_cnames(iauthor)),'".'
           ierr=801
        endif
     endif
  endif

  if(ierr.ne.0) return

  !--------------------------------------------------
  ! OK fetch the data

  call xplasma_blackbox_retrieve(s,id,ierr, &
       ia_ptr=idata,r8a_ptr=r8data)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_2d_get: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=801
     return
  endif

  if(idata(1).ne.inume) then
     ierr=801
     write(iout,*) ' ?ps_inum_2d_get: 1st integer header value: ',idata(1), &
          '; should match #enumerations:',inume
     write(iout,*) '  error retrieving integer enumeration object: '// &
          trim(inum_name)
  endif

  isize_max=maxval(idata(2:inume+1))
  if(isize_max.gt.idim1) then
     ierr=801
     write(iout,*) ' ?ps_inum_2d_get: max enumeration size: ',isize_max, &
          ' exceeds array dimension: ',idim1
     write(iout,*) '  error retrieving integer enumeration object: '// &
          trim(inum_name)
  endif
  if(ierr.ne.0) return

  isize_vec=idata(2:inume+1)

  ia=inume+1
  do ie=1,inume
     do ii=1,isize_vec(ie)
        ia=ia+1
        if(ia.le.iasize) then
           inum_2d(ii,ie)=idata(ia)
        else
           ierr=801
        endif
     enddo
  enddo

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_inum_2d_get: enumeration data size: ',iasize
     write(iout,*) '  not consistent with header information.'
     write(iout,*) '  error retrieving integer enumeration object: '// &
          trim(inum_name)
  endif

  nullify(r8data)
  nullify(idata)

end subroutine ps_inum_2d_get

subroutine trx_gen_lh_files(ss, fpath,runid,ierr)

  ! (called from trx_gen_state) -- generate files for driving LH codes
  ! when Plasma State derived data is available

  ! The plasma state (SS) has been loaded!
  ! SPLITN access to TRANSP namelist variables is also available.

  use plasma_state_mod
  use trx_module

  implicit NONE

  type (plasma_state) :: ss           ! state object...

  character*(*), intent(in) :: fpath  ! directory in which to write files
  character*(*), intent(in) :: runid  ! TRANSP runid
  integer, intent(out) :: ierr   ! completion status, 0=OK

  !-----------------------
  logical :: dirsw
  character*300 :: zdsave

  integer :: inuma  ! number of antennas or sources
  integer :: lunzer,iant

  character*6 :: ichant
  character*6, dimension(:), allocatable :: ichaa ! ascii encoded antenna #s
  !-----------------------

  ierr = 0

  ! # antennas; form ascii encoded list of antenna numbers

  inuma=ss%nlhrf_src
  if(inuma.le.0) then
     write(lunzer(0),*) ' %trx_gen_lh_files: no LH sources found.'
     return
  endif

  allocate(ichaa(inuma))

  do iant=1,inuma
     write(ichant,'(i6)') iant
     ichaa(iant)=trim(adjustl(ichant))
  enddo

  !----------------------------------------------------
  if((fpath.ne.' ').AND.(fpath.ne.'.')) then
     ! cd to output directory
     dirsw=.TRUE.
     call sget_cwd(zdsave)
     call sset_cwd(fpath,ierr)
     if(ierr.ne.0) return
  else
     dirsw=.FALSE.
  endif

  !----------------------------------------------------
  if(dirsw) then
     ! cd back to original directory
     call sset_cwd(zdsave,ierr)
  endif

end subroutine trx_gen_lh_files

      real*8 function tdb_zyget(d,zid,i)
 
c   for 3d profile set indicated, get i'th y axis value
c
c   e.g. for multiple impurity model (sim) helper function
c   get stored charge state information...
 
      use trdatbuf_obj
      implicit NONE
      type (trdatbuf) :: d
      character*3, intent(in) :: zid  ! 3d profile set identifier
      integer,intent(in) :: i         ! get i'th element of y axis
 
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C
C------------------
      IF(ZID.EQ.'SIM') THEN
        tdb_zyget = d%datbuf(d%lySIM+i-1)
      ENDIF
C
C=>TRDATGEN-
 
      return
      end

subroutine trx_init
 
! initialize/clear trx -- transp data access & interpolation
! ...use when "connecting" to a new run
 
  use trx_module
  implicit NONE
 
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  integer :: init = 0
  save init
 
! -------------------------
 
  d_data_avail = .FALSE.

  !  d_init_flag is initialized once only in the module
  !  (should not be reset)

  if(init.eq.0) then
     call initcpl
     init=1
  endif
 
  nsctime=0
  nprtime=0
  nxmax=0
  nmax=0
  nsurf=0
  nrmajm=0
  nrmjsym=0
 
  ksym=0
  nmoms=0

  itype_x=0
  itype_xb=0
  itype_Rmajm=0
  itype_Rmjsym=0

  id_rho=0
  id_rhozc=0
  id_chi=0
  id_R=0
  id_Z=0
  id_Rmajm=0
  id_Rmjsym=0

  run_label = ' '
  tdev = ' '

  tmin=0.0_R8
  tmax=0.0_R8
 
  itset=0
  time0=0.0_R8
  delta_t=0.0_R8
 
  call trx_bc_init
 
  units_status= -1
  xaxis_id = -1
  prof_iord = -1
 
  call tr_getnl_clear

!------------------------------

  mds_arch_flag = .FALSE.
  file_path = ' '

!------------------------------

  nRfree=0
  nZfree=0
  ifound_Psi0=0
  if(allocated(Rgrid_free)) deallocate(Rgrid_free)
  if(allocated(Zgrid_free)) deallocate(Zgrid_free)
  if(allocated(PsiRZ_free)) deallocate(PsiRZ_free)
  raxis_mhd=0.0_R8
  zaxis_mhd=0.0_R8
  Psi0_mhd=0.0_R8

  return
 
end subroutine trx_init
 
subroutine trx_bc_init
 
! (re)initialize standard boundary conditions & delete over-rides
 
  use trx_module
  implicit NONE
 
! --------------------
!
!  defaults:  f' -> 0 on axis
!  unconstrained at edge
!
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
  ibc_axis = 1
  zbc_axis = 0.0E0_R8
  ibc_edge = 0
  zbc_edge = 0.0_R8    ! (unused unless ibc_edge is changed)
!
!  defaults:  no over-rides
!
  ival_axis = 0
  zval_axis = 0.0_R8   ! (unused unless an over-ride is set)
  ival_edge = 0
  zval_edge = 0.0_R8   ! (unused unless an over-ride is set)
!
!  defaults:  no sign changing extrapolation
!
  isign_check = 1
  zsign_lim =0.25_R8   ! extrapolation not below 1/4 * sign(Edge)*mod(Edge)
  return
!
end subroutine trx_bc_init

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_9(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%velte_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velte_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"velte_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_nclass)) THEN
     status = nf90_inq_varid(icdf,"velte_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velte_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_neo)) THEN
     status = nf90_inq_varid(icdf,"velte_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_neo = 0.0_rspec
           CALL ncerr_name(2,status,"velte_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_paleo)) THEN
     status = nf90_inq_varid(icdf,"velte_paleo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_paleo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_paleo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_paleo = 0.0_rspec
           CALL ncerr_name(2,status,"velte_paleo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_tglf)) THEN
     status = nf90_inq_varid(icdf,"velte_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"velte_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_anom)) THEN
     status = nf90_inq_varid(icdf,"velti_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_anom = 0.0_rspec
           CALL ncerr_name(2,status,"velti_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_glf)) THEN
     status = nf90_inq_varid(icdf,"velti_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_glf = 0.0_rspec
           CALL ncerr_name(2,status,"velti_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velti_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"velti_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velti_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"velti_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_nclass)) THEN
     status = nf90_inq_varid(icdf,"velti_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velti_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_neo)) THEN
     status = nf90_inq_varid(icdf,"velti_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_neo = 0.0_rspec
           CALL ncerr_name(2,status,"velti_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velti_tglf)) THEN
     status = nf90_inq_varid(icdf,"velti_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velti_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velti_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velti_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"velti_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vie_trans)) THEN
     status = nf90_inq_varid(icdf,"vie_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vie_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vie_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%vie_trans = 0.0_rspec
           CALL ncerr_name(2,status,"vie_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vie_transcat)) THEN
     status = nf90_inq_varid(icdf,"vie_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vie_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vie_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%vie_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"vie_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vmo_trans)) THEN
     status = nf90_inq_varid(icdf,"vmo_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vmo_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vmo_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%vmo_trans = 0.0_rspec
           CALL ncerr_name(2,status,"vmo_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vmo_transcat)) THEN
     status = nf90_inq_varid(icdf,"vmo_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vmo_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vmo_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%vmo_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"vmo_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vn_trans)) THEN
     status = nf90_inq_varid(icdf,"vn_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vn_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vn_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%vn_trans = 0.0_rspec
           CALL ncerr_name(2,status,"vn_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vn_transcat)) THEN
     status = nf90_inq_varid(icdf,"vn_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vn_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vn_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%vn_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"vn_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vol)) THEN
     status = nf90_inq_varid(icdf,"vol",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vol")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vol)
        IF(status.NE.NF90_NOERR) THEN
           ss%vol = 0.0_rspec
           CALL ncerr_name(2,status,"vol")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vphi0_av)) THEN
     status = nf90_inq_varid(icdf,"vphi0_av",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vphi0_av")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vphi0_av)
        IF(status.NE.NF90_NOERR) THEN
           ss%vphi0_av = 0.0_rspec
           CALL ncerr_name(2,status,"vphi0_av")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vpol_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"vpol_Data_Info")
  ELSE
     ilen = len(ss%vpol_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%vpol_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%vpol_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%vpol_Data_Info = " "
        CALL ncerr_name(2,status,"vpol_Data_Info")
     ELSE
        CALL denull(ss%vpol_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vpol_inmp)) THEN
     status = nf90_inq_varid(icdf,"vpol_inmp",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vpol_inmp")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vpol_inmp)
        IF(status.NE.NF90_NOERR) THEN
           ss%vpol_inmp = 0.0_rspec
           CALL ncerr_name(2,status,"vpol_inmp")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vpol_is_input)) THEN
     status = nf90_inq_varid(icdf,"vpol_is_input",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vpol_is_input")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vpol_is_input)
        IF(status.NE.NF90_NOERR) THEN
           ss%vpol_is_input = 0
           CALL ncerr_name(2,status,"vpol_is_input")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vpol_omp)) THEN
     status = nf90_inq_varid(icdf,"vpol_omp",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vpol_omp")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vpol_omp)
        IF(status.NE.NF90_NOERR) THEN
           ss%vpol_omp = 0.0_rspec
           CALL ncerr_name(2,status,"vpol_omp")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     status = nf90_inq_varid(icdf,"VRep_coil_count",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"VRep_coil_count")
     ELSE
        status = nf90_get_var(icdf,varid,ss%VRep_coil_count)
        IF(status.NE.NF90_NOERR) THEN
           ss%VRep_coil_count = 0
           CALL ncerr_name(2,status,"VRep_coil_count")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     status = nf90_inq_varid(icdf,"Vrep_coil_spacing",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Vrep_coil_spacing")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Vrep_coil_spacing)
        IF(status.NE.NF90_NOERR) THEN
           ss%Vrep_coil_spacing = 0.0_rspec
           CALL ncerr_name(2,status,"Vrep_coil_spacing")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Vsize_coil)) THEN
     status = nf90_inq_varid(icdf,"Vsize_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Vsize_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Vsize_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Vsize_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Vsize_coil")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vsur",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"vsur")
  ELSE
     status = nf90_get_var(icdf,varid,ss%vsur)
     IF(status.NE.NF90_NOERR) THEN
        ss%vsur = 0.0_rspec
        CALL ncerr_name(2,status,"vsur")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"VSUR_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"VSUR_Data_Info")
  ELSE
     ilen = len(ss%VSUR_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%VSUR_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%VSUR_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%VSUR_Data_Info = " "
        CALL ncerr_name(2,status,"VSUR_Data_Info")
     ELSE
        CALL denull(ss%VSUR_Data_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vtor_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"vtor_Data_Info")
  ELSE
     ilen = len(ss%vtor_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%vtor_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%vtor_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%vtor_Data_Info = " "
        CALL ncerr_name(2,status,"vtor_Data_Info")
     ELSE
        CALL denull(ss%vtor_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vtor_inmp)) THEN
     status = nf90_inq_varid(icdf,"vtor_inmp",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vtor_inmp")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vtor_inmp)
        IF(status.NE.NF90_NOERR) THEN
           ss%vtor_inmp = 0.0_rspec
           CALL ncerr_name(2,status,"vtor_inmp")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vtor_is_input)) THEN
     status = nf90_inq_varid(icdf,"vtor_is_input",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vtor_is_input")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vtor_is_input)
        IF(status.NE.NF90_NOERR) THEN
           ss%vtor_is_input = 0
           CALL ncerr_name(2,status,"vtor_is_input")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vtor_omp)) THEN
     status = nf90_inq_varid(icdf,"vtor_omp",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vtor_omp")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vtor_omp)
        IF(status.NE.NF90_NOERR) THEN
           ss%vtor_omp = 0.0_rspec
           CALL ncerr_name(2,status,"vtor_omp")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%V_loop)) THEN
     status = nf90_inq_varid(icdf,"V_loop",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"V_loop")
     ELSE
        status = nf90_get_var(icdf,varid,ss%V_loop)
        IF(status.NE.NF90_NOERR) THEN
           ss%V_loop = 0.0_rspec
           CALL ncerr_name(2,status,"V_loop")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%v_pars)) THEN
     status = nf90_inq_varid(icdf,"v_pars",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"v_pars")
     ELSE
        status = nf90_get_var(icdf,varid,ss%v_pars)
        IF(status.NE.NF90_NOERR) THEN
           ss%v_pars = 0.0_rspec
           CALL ncerr_name(2,status,"v_pars")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%v_pers)) THEN
     status = nf90_inq_varid(icdf,"v_pers",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"v_pers")
     ELSE
        status = nf90_get_var(icdf,varid,ss%v_pers)
        IF(status.NE.NF90_NOERR) THEN
           ss%v_pers = 0.0_rspec
           CALL ncerr_name(2,status,"v_pers")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"wt_nphi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%wt_nphi)
        IF(status.NE.NF90_NOERR) THEN
           ss%wt_nphi = 0.0_rspec
           CALL ncerr_name(2,status,"wt_nphi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_abs)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi_abs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"wt_nphi_abs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%wt_nphi_abs)
        IF(status.NE.NF90_NOERR) THEN
           ss%wt_nphi_abs = 0.0_rspec
           CALL ncerr_name(2,status,"wt_nphi_abs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%wt_nphi_ext)) THEN
     status = nf90_inq_varid(icdf,"wt_nphi_ext",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"wt_nphi_ext")
     ELSE
        status = nf90_get_var(icdf,varid,ss%wt_nphi_ext)
        IF(status.NE.NF90_NOERR) THEN
           ss%wt_nphi_ext = 0.0_rspec
           CALL ncerr_name(2,status,"wt_nphi_ext")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xRjcos_momeq)) THEN
     status = nf90_inq_varid(icdf,"xRjcos_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xRjcos_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xRjcos_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%xRjcos_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"xRjcos_momeq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xRjsin_momeq)) THEN
     status = nf90_inq_varid(icdf,"xRjsin_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xRjsin_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xRjsin_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%xRjsin_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"xRjsin_momeq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xs)) THEN
     status = nf90_inq_varid(icdf,"xs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xs)
        IF(status.NE.NF90_NOERR) THEN
           ss%xs = 0.0_rspec
           CALL ncerr_name(2,status,"xs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xs_name)) THEN
     status = nf90_inq_varid(icdf,"xs_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xs_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xs_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%xs_name = " "
           CALL ncerr_name(2,status,"xs_name")
        ELSE
           CALL denull_vec(ss%xs_name,ss%nxs)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xZjcos_momeq)) THEN
     status = nf90_inq_varid(icdf,"xZjcos_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xZjcos_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xZjcos_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%xZjcos_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"xZjcos_momeq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%xZjsin_momeq)) THEN
     status = nf90_inq_varid(icdf,"xZjsin_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"xZjsin_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%xZjsin_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%xZjsin_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"xZjsin_momeq")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z0max",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z0max")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z0max)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z0max = 2
        CALL ncerr_name(2,status,"Z0max")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z0_momeq)) THEN
     status = nf90_inq_varid(icdf,"Z0_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z0_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z0_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z0_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"Z0_momeq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zbap)) THEN
     status = nf90_inq_varid(icdf,"Zbap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zbap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zbap)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zbap = 0.0_rspec
           CALL ncerr_name(2,status,"Zbap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zbsc)) THEN
     status = nf90_inq_varid(icdf,"Zbsc",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zbsc")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zbsc)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zbsc = 0.0_rspec
           CALL ncerr_name(2,status,"Zbsc")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zeff)) THEN
     status = nf90_inq_varid(icdf,"Zeff",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zeff")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zeff)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zeff = 0.0_rspec
           CALL ncerr_name(2,status,"Zeff")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ZEFF_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"ZEFF_Data_Info")
  ELSE
     ilen = len(ss%ZEFF_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%ZEFF_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%ZEFF_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%ZEFF_Data_Info = " "
        CALL ncerr_name(2,status,"ZEFF_Data_Info")
     ELSE
        CALL denull(ss%ZEFF_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zeff_fi)) THEN
     status = nf90_inq_varid(icdf,"Zeff_fi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zeff_fi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zeff_fi)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zeff_fi = 0.0_rspec
           CALL ncerr_name(2,status,"Zeff_fi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zeff_th)) THEN
     status = nf90_inq_varid(icdf,"Zeff_th",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zeff_th")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zeff_th)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zeff_th = 0.0_rspec
           CALL ncerr_name(2,status,"Zeff_th")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp1",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Zimp1")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Zimp1)
     IF(status.NE.NF90_NOERR) THEN
        ss%Zimp1 = 2
        CALL ncerr_name(2,status,"Zimp1")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Zimp2",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Zimp2")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Zimp2)
     IF(status.NE.NF90_NOERR) THEN
        ss%Zimp2 = 1000
        CALL ncerr_name(2,status,"Zimp2")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%zlim)) THEN
     status = nf90_inq_varid(icdf,"zlim",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"zlim")
     ELSE
        status = nf90_get_var(icdf,varid,ss%zlim)
        IF(status.NE.NF90_NOERR) THEN
           ss%zlim = 0.0_rspec
           CALL ncerr_name(2,status,"zlim")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Zloc_coil)) THEN
     status = nf90_inq_varid(icdf,"Zloc_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Zloc_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Zloc_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Zloc_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Zloc_coil")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_ant)) THEN
     status = nf90_inq_varid(icdf,"Z_ant",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_ant")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_ant)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_ant = 0.0_rspec
           CALL ncerr_name(2,status,"Z_ant")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_antgeo)) THEN
     status = nf90_inq_varid(icdf,"Z_antgeo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_antgeo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_antgeo)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_antgeo = 0.0_rspec
           CALL ncerr_name(2,status,"Z_antgeo")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_axis",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z_axis")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z_axis)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z_axis = 0.0_rspec
        CALL ncerr_name(2,status,"Z_axis")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"Z_EC_launch",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_EC_launch")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_EC_launch)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_EC_launch = 0.0_rspec
           CALL ncerr_name(2,status,"Z_EC_launch")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_geo)) THEN
     status = nf90_inq_varid(icdf,"Z_geo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_geo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_geo)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_geo = 0.0_rspec
           CALL ncerr_name(2,status,"Z_geo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_grid)) THEN
     status = nf90_inq_varid(icdf,"Z_grid",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_grid")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_grid)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_grid = 0.0_rspec
           CALL ncerr_name(2,status,"Z_grid")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_box",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z_max_box")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z_max_box)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z_max_box = 0.0_rspec
        CALL ncerr_name(2,status,"Z_max_box")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_max_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z_max_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z_max_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"Z_max_lcfs")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_midp)) THEN
     status = nf90_inq_varid(icdf,"Z_midp",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_midp")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_midp)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_midp = 0.0_rspec
           CALL ncerr_name(2,status,"Z_midp")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     status = nf90_inq_varid(icdf,"Z_mid_ant",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_mid_ant")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_mid_ant)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_mid_ant = 0.0_rspec
           CALL ncerr_name(2,status,"Z_mid_ant")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_box",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z_min_box")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z_min_box)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z_min_box = 0.0_rspec
        CALL ncerr_name(2,status,"Z_min_box")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Z_min_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Z_min_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Z_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%Z_min_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"Z_min_lcfs")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_ripple)) THEN
     status = nf90_inq_varid(icdf,"Z_ripple",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_ripple")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_ripple)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_ripple = 0.0_rspec
           CALL ncerr_name(2,status,"Z_ripple")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_surfMax)) THEN
     status = nf90_inq_varid(icdf,"Z_surfMax",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_surfMax")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_surfMax)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_surfMax = 0.0_rspec
           CALL ncerr_name(2,status,"Z_surfMax")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Z_surfMin)) THEN
     status = nf90_inq_varid(icdf,"Z_surfMin",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Z_surfMin")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Z_surfMin)
        IF(status.NE.NF90_NOERR) THEN
           ss%Z_surfMin = 0.0_rspec
           CALL ncerr_name(2,status,"Z_surfMin")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_9

subroutine tdb_getmmx(d,zt,xib,zrmc2,zymc2,mj,mimom,lcentr,nzp1,zdrshaf)
 
  use trdatbuf_obj
  use tdbsub_uts
  IMPLICIT NONE
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
  type (trdatbuf) :: d
  REAL*8,intent(in) :: zt    ! time at which to fetch moments
 
  integer, intent(in) :: mj  ! flux surface array dimension for zrmc2,zymc2
  integer, intent(in) :: mimom ! moments array dimension for zrmc2,zymc2

  real*8,intent(in) :: xib(mj) ! flux surfaces (xib(j)=sqrt(Phi/Philim) at
  ! surface "j").
  
  REAL*8,intent(out) :: zrmc2(mj,0:mimom,2),zymc2(mj,0:mimom,2)
                           ! asymmetric Fourier moments set at xi bdys
 
  REAL*8,intent(out) :: zdrshaf(mj)
                           ! "Shafranov" shift of interior surfaces
                           ! relative to the boundary surface
 
  integer :: lcentr        ! index to magnetic axis
  integer :: nzp1          ! no. of surfaces including mag. axis

  ! using the MMX data, fetch the current equilibrium geometry.
  ! this routine MUST NOT be called unless the MMX data exists.
 
  !----------------------------------------------------
  ! local:
 
  ! local splines...
 
  REAL*8, dimension(:), allocatable :: zwk
  REAL*8, dimension(:,:), allocatable :: zxpkg
  REAL*8, dimension(:,:,:,:), allocatable :: zsrmc,zsymc
 
  ! for time interpolation:
 
  integer it    ! time index
  REAL*8 zf       ! fraction to next index pt.
 
  integer iadr,iady,ics,im,ix,j,ilt,int,idum,ierr
  REAL*8 zdum,zrin,zrout,zymid
 
  integer iadci   ! indexing function trulib/iadci.for
  integer ict(3)

  integer :: lunmsg_tdb
 
  integer :: lep1,lcp1,nzones,imaxe

  data ict/1,0,0/
 
  !----------------------------------------------------

  lcp1=lcentr+1
  nzones=nzp1-1
  lep1=lcentr+nzones
 
  if(d%LDMMX.eq.0) then
     write(lunmsg_tdb(0),*) ' ??? GETMMX called but there is no MMX data.'
     call bad_exit
  endif
 
  if(d%NXMMX.le.1) then
     !  if d%NXMMX=1 there is only boundary data and this routine should
     !  still not be called.
     write(lunmsg_tdb(0),*) ' ??? GETMMX called but there is no MMX x grid.'
     call bad_exit
  endif
 
  if(d%NMOMD.ne.d%MMAX) then
     write(lunmsg_tdb(0),*) ' ??? GETMMX: mmax=',d%MMAX,' nmomd=',d%NMOMD
     write(lunmsg_tdb(0),*) '     these quantities were expected to be equal.'
     call bad_exit
  endif
 
  imaxe = d%mmx_maxe  ! max scaling exponent for moments
  if(imaxe.eq.0) imaxe = 16  ! the old default set here.

  zrmc2=0; zymc2=0
 
  ilt=d%ltime2
  int=d%ntime2
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt,it,zf)
 
  allocate(zwk(d%NXMMX))
  allocate(zxpkg(d%NXMMX,4),zsrmc(4,d%NXMMX,0:d%MMAX,2),zsymc(4,d%NXMMX,0:d%MMAX,2))
 
  zdum=0.0_R8
  call genxpkg(d%NXMMX,d%DATBUF(d%LXMMX),zxpkg,0,0,0,zdum,-3,ierr)
  if(ierr.ne.0) then
     call errmsg_exit(' ?getmmx: unexpected spline "genxpkg" error.')
  endif
 
  !  time interpolate scaled moments on orig. data grid
 
  do ics=1,2
     do im=0,d%MMAX
        do ix=1,d%NXMMX
           iadr=iadci(d, d%LDMMX, it, ix, im, ics)
           zsrmc(1,ix,im,ics)=d%DATBUF(iadr)*(1-zf)+d%DATBUF(iadr+1)*zf
           iady=iadci(d, d%LDMMX, it, ix, im, ics+2)
           zsymc(1,ix,im,ics)=d%DATBUF(iady)*(1-zf)+d%DATBUF(iady+1)*zf
        enddo
     enddo
  enddo
 
  !  set up splines
 
  zdum=0.0_R8
  do ics=1,2
     do im=0,d%MMAX
        call cspline(d%DATBUF(d%LXMMX),d%NXMMX,zsrmc(1,1,im,ics),0,zdum,0,zdum,zwk, &
             d%NXMMX,idum,ierr)
        if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "cspline" error.')
        call cspline(d%DATBUF(d%LXMMX),d%NXMMX,zsymc(1,1,im,ics),0,zdum,0,zdum,zwk, &
             d%NXMMX,idum,ierr)
        if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "cspline" error.')
     enddo
  enddo
 
  !  map to TRANSP grid
 
  do ics=1,2
     do im=0,d%MMAX
        if(im.eq.0) then
 
           ! 0'th moment can have non zero value on axis
 
           call spvec(ict,nzp1,xib(lcentr),nzp1, &
                zrmc2(lcentr:lep1,im,ics),d%NXMMX,zxpkg,zsrmc(1,1,im,ics), &
                idum,ierr)
           if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "spvec" (spline evaluation) error 1.')
           call spvec(ict,nzp1,xib(lcentr),nzp1, &
                zymc2(lcentr:lep1,im,ics),d%NXMMX,zxpkg,zsymc(1,1,im,ics), &
                idum,ierr)
           if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "spvec" (spline evaluation) error 2.')
 
        else
 
           ! higher moments always zero on axis
 
           call spvec(ict,nzones,xib(lcp1),nzones, &
                zrmc2(lcp1:lep1,im,ics),d%NXMMX,zxpkg,zsrmc(1,1,im,ics), &
                idum,ierr)
           if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "spvec" (spline evaluation) error 1.')
           call spvec(ict,nzones,xib(lcp1),nzones, &
                zymc2(lcp1:lep1,im,ics),d%NXMMX,zxpkg,zsymc(1,1,im,ics), &
                idum,ierr)
           if(ierr.ne.0) call errmsg_exit(' ?getmmx: unexpected "spvec" (spline evaluation) error 2.')
 
           ! scale the moments
 
           zrmc2(lcp1:lep1,im,ics)=zrmc2(lcp1:lep1,im,ics)* &
                xib(lcp1:lep1)**min(im,imaxe)
           zymc2(lcp1:lep1,im,ics)=zymc2(lcp1:lep1,im,ics)* &
                xib(lcp1:lep1)**min(im,imaxe)
 
        endif
     enddo
  enddo
 
  !  compute axis shift
 
  zdrshaf = 0
  zdrshaf(lcentr)=zrmc2(lcentr,0,1)
  do j=lcp1,lep1
     call r8_getmpa(zrmc2(j,0:mimom,1:2),zymc2(j,0:mimom,1:2),mimom,d%NMOMD, &
          zrin,zrout,zymid)
     zdrshaf(j)=0.5_R8*(zrin+zrout)
  enddo
 
  !  shift is defined relative to outer bdy
 
  zdrshaf(lcentr:lep1) = zdrshaf(lcentr:lep1) - zdrshaf(lep1)
 
end subroutine tdb_getmmx

integer function lunmsg_tdb(idum)

  ! return i/o unit number for trdatbuf_lib messages

  use tdb_static
  implicit NONE
  integer :: idum

  lunmsg_tdb = lunmsg_trdatbuf

end function lunmsg_tdb

subroutine tdb_lunmsg_set(ilun_new)

  ! set new i/o unit number for trdatbuf_lib messages

  use tdb_static
  implicit NONE
  integer, intent(in) :: ilun_new

  lunmsg_trdatbuf = ilun_new

end subroutine tdb_lunmsg_set

logical function tdb_fallback(d,ztri,ztime,zresult)
  !
  ! ** NEW SEP 1984 **  bolometer profile data can "fall back to time
  !     series" in which case interpretation is that the total 
  !     radiated power (Watts) was measured, instead of a power 
  !     density

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: ztri  ! trigraph of candidate data
  ! for "fall back to time series"
  real*8, intent(in) :: ztime        ! time to which to interpolate
  real*8, intent(out) :: zresult     ! result, if data is found
  ! the function value is .TRUE., and the interpolated value is returned,
  ! if "fallback to time series" data is present; otherwise the function
  ! returns .FALSE. and zresult=ZERO.

  !------------------------------------------

  character*3 ztest
  integer :: if,ib0,ib1,ilt,int
  real*8 :: zf

  !------------------------------------------
  !  this could be generated code, if we ever
  !  need a lot of these... (dmc May 2005)

  ztest=ztri(1:min(3,len(ztri)))
  if(ztest.eq.'BOL') then
     if(d%nxbol.eq.1) then
        ilt=d%ltime2
        int=d%ntime2
        tdb_fallback=.TRUE.
        call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,ztime,if,zf)
        IB1=d%LFBOL+IF
        IB0=IB1-1
        zresult=d%DATBUF(IB0)+ZF*(d%DATBUF(IB1)-d%DATBUF(IB0))
     else
        tdb_fallback=.FALSE.
        zresult=ZERO
     endif
  else
     tdb_fallback=.FALSE.
     zresult=ZERO
  endif

end function tdb_fallback

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_7(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Rloc_coil).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Rloc_coil)
  ENDIF
  IF(ALLOCATED(ss%Rloc_coil)) then
     jsize = SIZE(ss%Rloc_coil)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Rloc_coil already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Rloc_coil(ss%ncoils))
     ss%Rloc_coil = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%Rmajor_mean).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Rmajor_mean)
  ENDIF
  IF(ALLOCATED(ss%Rmajor_mean)) then
     jsize = SIZE(ss%Rmajor_mean)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Rmajor_mean already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Rmajor_mean(ss%nrho_eq_geo))
     ss%Rmajor_mean = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%rMinor_mean).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%rMinor_mean)
  ENDIF
  IF(ALLOCATED(ss%rMinor_mean)) then
     jsize = SIZE(ss%rMinor_mean)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: rMinor_mean already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%rMinor_mean(ss%nrho_eq_geo))
     ss%rMinor_mean = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%R_ant).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_ant)
  ENDIF
  IF(ALLOCATED(ss%R_ant)) then
     jsize = SIZE(ss%R_ant)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_ant already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_ant(ss%nicrf_src))
     ss%R_ant = 0.0_rspec
  ENDIF

  isize = (ss%max_nrz_antgeo)*(ss%nicrf_src)
  IF(ALLOCATED(ss%R_antgeo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_antgeo)
  ENDIF
  IF(ALLOCATED(ss%R_antgeo)) then
     jsize = SIZE(ss%R_antgeo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_antgeo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_antgeo(ss%max_nrz_antgeo,ss%nicrf_src))
     ss%R_antgeo = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%R_EC_launch).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_EC_launch)
  ENDIF
  IF(ALLOCATED(ss%R_EC_launch)) then
     jsize = SIZE(ss%R_EC_launch)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_EC_launch already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_EC_launch(ss%necrf_src))
     ss%R_EC_launch = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%R_geo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_geo)
  ENDIF
  IF(ALLOCATED(ss%R_geo)) then
     jsize = SIZE(ss%R_geo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_geo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_geo(ss%nrho_eq,ss%nth_eq))
     ss%R_geo = 0.0_rspec
  ENDIF

  isize = (ss%nr)
  IF(ALLOCATED(ss%R_grid).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_grid)
  ENDIF
  IF(ALLOCATED(ss%R_grid)) then
     jsize = SIZE(ss%R_grid)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_grid already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_grid(ss%nr))
     ss%R_grid = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%R_midp_in).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_midp_in)
  ENDIF
  IF(ALLOCATED(ss%R_midp_in)) then
     jsize = SIZE(ss%R_midp_in)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_midp_in already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_midp_in(ss%nrho_eq_geo))
     ss%R_midp_in = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%R_midp_out).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_midp_out)
  ENDIF
  IF(ALLOCATED(ss%R_midp_out)) then
     jsize = SIZE(ss%R_midp_out)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_midp_out already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_midp_out(ss%nrho_eq_geo))
     ss%R_midp_out = 0.0_rspec
  ENDIF

  isize = (ss%nr_rip)
  IF(ALLOCATED(ss%R_ripple).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_ripple)
  ENDIF
  IF(ALLOCATED(ss%R_ripple)) then
     jsize = SIZE(ss%R_ripple)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_ripple already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_ripple(ss%nr_rip))
     ss%R_ripple = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%R_surfMax).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_surfMax)
  ENDIF
  IF(ALLOCATED(ss%R_surfMax)) then
     jsize = SIZE(ss%R_surfMax)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_surfMax already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_surfMax(ss%nrho_eq_geo))
     ss%R_surfMax = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%R_surfMin).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%R_surfMin)
  ENDIF
  IF(ALLOCATED(ss%R_surfMin)) then
     jsize = SIZE(ss%R_surfMin)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: R_surfMin already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%R_surfMin(ss%nrho_eq_geo))
     ss%R_surfMin = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%s0reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%s0reco)
  ENDIF
  IF(ALLOCATED(ss%s0reco)) then
     jsize = SIZE(ss%s0reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: s0reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%s0reco(ss%nrho_gas-1,ss%nspec_gas))
     ss%s0reco = 0.0_rspec
     ALLOCATE(ss%id_s0reco(ss%nspec_gas))
     ss%id_s0reco = 0
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%s0reco_e).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%s0reco_e)
  ENDIF
  IF(ALLOCATED(ss%s0reco_e)) then
     jsize = SIZE(ss%s0reco_e)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: s0reco_e already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%s0reco_e(ss%nrho_gas-1))
     ss%s0reco_e = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%s0reco_recap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%s0reco_recap)
  ENDIF
  IF(ALLOCATED(ss%s0reco_recap)) then
     jsize = SIZE(ss%s0reco_recap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: s0reco_recap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%s0reco_recap(ss%nrho_gas-1,ss%nspec_gas))
     ss%s0reco_recap = 0.0_rspec
     ALLOCATE(ss%id_s0reco_recap(ss%nspec_gas))
     ss%id_s0reco_recap = 0
  ENDIF

  isize = (ss%nspec_all+1)
  IF(ss%nspec_all.LE.0) isize = 0
  IF(ALLOCATED(ss%sa_index).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sa_index)
  ENDIF
  IF(ALLOCATED(ss%sa_index)) then
     jsize = SIZE(ss%sa_index)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sa_index already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sa_index(0:ss%nspec_all))
     ss%sa_index = 0
  ENDIF

  isize = (ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%SA_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SA_name)
  ENDIF
  IF(ALLOCATED(ss%SA_name)) then
     jsize = SIZE(ss%SA_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SA_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SA_name(0:ss%nspec_tha))
     ss%SA_name = " "
  ENDIF

  isize = (ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%SA_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SA_type)
  ENDIF
  IF(ALLOCATED(ss%SA_type)) then
     jsize = SIZE(ss%SA_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SA_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SA_type(0:ss%nspec_tha))
     ss%SA_type = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%sb0halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sb0halo)
  ENDIF
  IF(ALLOCATED(ss%sb0halo)) then
     jsize = SIZE(ss%sb0halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sb0halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sb0halo(ss%nrho_nbi-1,ss%nspec_gas))
     ss%sb0halo = 0.0_rspec
     ALLOCATE(ss%id_sb0halo(ss%nspec_gas))
     ss%id_sb0halo = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%sb0halo_recap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sb0halo_recap)
  ENDIF
  IF(ALLOCATED(ss%sb0halo_recap)) then
     jsize = SIZE(ss%sb0halo_recap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sb0halo_recap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sb0halo_recap(ss%nrho_nbi-1,ss%nspec_gas))
     ss%sb0halo_recap = 0.0_rspec
     ALLOCATE(ss%id_sb0halo_recap(ss%nspec_gas))
     ss%id_sb0halo_recap = 0
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%sbedep).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sbedep)
  ENDIF
  IF(ALLOCATED(ss%sbedep)) then
     jsize = SIZE(ss%sbedep)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sbedep already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sbedep(ss%nrho_nbi-1))
     ss%sbedep = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%sbehalo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sbehalo)
  ENDIF
  IF(ALLOCATED(ss%sbehalo)) then
     jsize = SIZE(ss%sbehalo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sbehalo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sbehalo(ss%nrho_nbi-1))
     ss%sbehalo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%sbsce).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sbsce)
  ENDIF
  IF(ALLOCATED(ss%sbsce)) then
     jsize = SIZE(ss%sbsce)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sbsce already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sbsce(ss%nrho_nbi-1,0:ss%nspec_tha))
     ss%sbsce = 0.0_rspec
     ALLOCATE(ss%id_sbsce(0:ss%nspec_tha))
     ss%id_sbsce = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_beam)
  IF(ALLOCATED(ss%sbtherm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sbtherm)
  ENDIF
  IF(ALLOCATED(ss%sbtherm)) then
     jsize = SIZE(ss%sbtherm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sbtherm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sbtherm(ss%nrho_nbi-1,ss%nspec_beam))
     ss%sbtherm = 0.0_rspec
     ALLOCATE(ss%id_sbtherm(ss%nspec_beam))
     ss%id_sbtherm = 0
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%sc0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sc0)
  ENDIF
  IF(ALLOCATED(ss%sc0)) then
     jsize = SIZE(ss%sc0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sc0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sc0(ss%ngsc0))
     ss%sc0 = 0.0_rspec
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%sc0_to_sgas).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sc0_to_sgas)
  ENDIF
  IF(ALLOCATED(ss%sc0_to_sgas)) then
     jsize = SIZE(ss%sc0_to_sgas)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sc0_to_sgas already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sc0_to_sgas(ss%ngsc0))
     ss%sc0_to_sgas = 0
  ENDIF

  isize = (ss%nrho_anomth-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%sc_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sc_anom)
  ENDIF
  IF(ALLOCATED(ss%sc_anom)) then
     jsize = SIZE(ss%sc_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sc_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sc_anom(ss%nrho_anomth-1,0:ss%nspec_th))
     ss%sc_anom = 0.0_rspec
     ALLOCATE(ss%id_sc_anom(0:ss%nspec_th))
     ss%id_sc_anom = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%sfsce).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sfsce)
  ENDIF
  IF(ALLOCATED(ss%sfsce)) then
     jsize = SIZE(ss%sfsce)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sfsce already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sfsce(ss%nrho_fus-1,0:ss%nspec_tha))
     ss%sfsce = 0.0_rspec
     ALLOCATE(ss%id_sfsce(0:ss%nspec_tha))
     ss%id_sfsce = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%sftherm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sftherm)
  ENDIF
  IF(ALLOCATED(ss%sftherm)) then
     jsize = SIZE(ss%sftherm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sftherm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sftherm(ss%nrho_fus-1,ss%nspec_fusion))
     ss%sftherm = 0.0_rspec
     ALLOCATE(ss%id_sftherm(ss%nspec_fusion))
     ss%id_sftherm = 0
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%SFUS_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SFUS_name)
  ENDIF
  IF(ALLOCATED(ss%SFUS_name)) then
     jsize = SIZE(ss%SFUS_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SFUS_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SFUS_name(ss%nspec_fusion))
     ss%SFUS_name = " "
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%sfus_to_all).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sfus_to_all)
  ENDIF
  IF(ALLOCATED(ss%sfus_to_all)) then
     jsize = SIZE(ss%sfus_to_all)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sfus_to_all already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sfus_to_all(ss%nspec_fusion))
     ss%sfus_to_all = 0
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%sfus_to_alla).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sfus_to_alla)
  ENDIF
  IF(ALLOCATED(ss%sfus_to_alla)) then
     jsize = SIZE(ss%sfus_to_alla)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sfus_to_alla already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sfus_to_alla(ss%nspec_fusion))
     ss%sfus_to_alla = 0
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%SFUS_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SFUS_type)
  ENDIF
  IF(ALLOCATED(ss%SFUS_type)) then
     jsize = SIZE(ss%SFUS_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SFUS_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SFUS_type(ss%nspec_fusion))
     ss%SFUS_type = 0
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%SGAS_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SGAS_name)
  ENDIF
  IF(ALLOCATED(ss%SGAS_name)) then
     jsize = SIZE(ss%SGAS_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SGAS_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SGAS_name(ss%nspec_gas))
     ss%SGAS_name = " "
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%sgas_to_s).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sgas_to_s)
  ENDIF
  IF(ALLOCATED(ss%sgas_to_s)) then
     jsize = SIZE(ss%sgas_to_s)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sgas_to_s already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sgas_to_s(ss%nspec_gas))
     ss%sgas_to_s = 0
  ENDIF

  isize = (ss%nspec_gas)
  IF(ALLOCATED(ss%SGAS_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SGAS_type)
  ENDIF
  IF(ALLOCATED(ss%SGAS_type)) then
     jsize = SIZE(ss%SGAS_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SGAS_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SGAS_type(ss%nspec_gas))
     ss%SGAS_type = 0
  ENDIF

  isize = (ss%nrho_mist-1)*(ss%nspec_th+1)*(ss%nxs)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%sii_xs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sii_xs)
  ENDIF
  IF(ALLOCATED(ss%sii_xs)) then
     jsize = SIZE(ss%sii_xs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sii_xs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sii_xs(ss%nrho_mist-1,0:ss%nspec_th,ss%nxs))
     ss%sii_xs = 0.0_rspec
     ALLOCATE(ss%id_sii_xs(0:ss%nspec_th,ss%nxs))
     ss%id_sii_xs = 0
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%SIMP0_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SIMP0_name)
  ENDIF
  IF(ALLOCATED(ss%SIMP0_name)) then
     jsize = SIZE(ss%SIMP0_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SIMP0_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SIMP0_name(ss%nspec_imp0))
     ss%SIMP0_name = " "
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%simp0_to_s).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%simp0_to_s)
  ENDIF
  IF(ALLOCATED(ss%simp0_to_s)) then
     jsize = SIZE(ss%simp0_to_s)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: simp0_to_s already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%simp0_to_s(ss%nspec_imp0))
     ss%simp0_to_s = 0
  ENDIF

  isize = (ss%nspec_imp0)
  IF(ALLOCATED(ss%SIMP0_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SIMP0_type)
  ENDIF
  IF(ALLOCATED(ss%SIMP0_type)) then
     jsize = SIZE(ss%SIMP0_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SIMP0_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SIMP0_type(ss%nspec_imp0))
     ss%SIMP0_type = 0
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%SIMPI_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SIMPI_name)
  ENDIF
  IF(ALLOCATED(ss%SIMPI_name)) then
     jsize = SIZE(ss%SIMPI_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SIMPI_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SIMPI_name(ss%nspec_impi))
     ss%SIMPI_name = " "
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%simpi_to_s).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%simpi_to_s)
  ENDIF
  IF(ALLOCATED(ss%simpi_to_s)) then
     jsize = SIZE(ss%simpi_to_s)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: simpi_to_s already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%simpi_to_s(ss%nspec_impi))
     ss%simpi_to_s = 0
  ENDIF

  isize = (ss%nspec_impi)
  IF(ALLOCATED(ss%SIMPI_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SIMPI_type)
  ENDIF
  IF(ALLOCATED(ss%SIMPI_type)) then
     jsize = SIZE(ss%SIMPI_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SIMPI_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SIMPI_type(ss%nspec_impi))
     ss%SIMPI_type = 0
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%SNBI_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SNBI_name)
  ENDIF
  IF(ALLOCATED(ss%SNBI_name)) then
     jsize = SIZE(ss%SNBI_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SNBI_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SNBI_name(ss%nspec_beam))
     ss%SNBI_name = " "
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%snbi_to_all).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%snbi_to_all)
  ENDIF
  IF(ALLOCATED(ss%snbi_to_all)) then
     jsize = SIZE(ss%snbi_to_all)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: snbi_to_all already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%snbi_to_all(ss%nspec_beam))
     ss%snbi_to_all = 0
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%snbi_to_alla).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%snbi_to_alla)
  ENDIF
  IF(ALLOCATED(ss%snbi_to_alla)) then
     jsize = SIZE(ss%snbi_to_alla)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: snbi_to_alla already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%snbi_to_alla(ss%nspec_beam))
     ss%snbi_to_alla = 0
  ENDIF

  isize = (ss%nspec_beam)
  IF(ALLOCATED(ss%SNBI_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%SNBI_type)
  ENDIF
  IF(ALLOCATED(ss%SNBI_type)) then
     jsize = SIZE(ss%SNBI_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: SNBI_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%SNBI_type(ss%nspec_beam))
     ss%SNBI_type = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%sn_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sn_trans)
  ENDIF
  IF(ALLOCATED(ss%sn_trans)) then
     jsize = SIZE(ss%sn_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sn_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sn_trans(ss%nrho-1,0:ss%nspec_th))
     ss%sn_trans = 0.0_rspec
     ALLOCATE(ss%id_sn_trans(0:ss%nspec_th))
     ss%id_sn_trans = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)*(ss%ntrcat)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%sn_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sn_transcat)
  ENDIF
  IF(ALLOCATED(ss%sn_transcat)) then
     jsize = SIZE(ss%sn_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sn_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sn_transcat(ss%nrho-1,0:ss%nspec_th,ss%ntrcat))
     ss%sn_transcat = 0.0_rspec
     ALLOCATE(ss%id_sn_transcat(0:ss%nspec_th,ss%ntrcat))
     ss%id_sn_transcat = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)*(ss%ngsc0)
  IF(ALLOCATED(ss%sprof0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sprof0)
  ENDIF
  IF(ALLOCATED(ss%sprof0)) then
     jsize = SIZE(ss%sprof0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sprof0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sprof0(ss%nrho_gas-1,ss%nspec_gas,ss%ngsc0))
     ss%sprof0 = 0.0_rspec
     ALLOCATE(ss%id_sprof0(ss%nspec_gas,ss%ngsc0))
     ss%id_sprof0 = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%sprof0e).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sprof0e)
  ENDIF
  IF(ALLOCATED(ss%sprof0e)) then
     jsize = SIZE(ss%sprof0e)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sprof0e already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sprof0e(ss%nrho_gas-1,ss%ngsc0))
     ss%sprof0e = 0.0_rspec
     ALLOCATE(ss%id_sprof0e(ss%ngsc0))
     ss%id_sprof0e = 0
  ENDIF

  isize = (ss%nrho_pel-1)*(ss%nspec_tha+1)
  IF(ss%nspec_tha.LE.0) isize = 0
  IF(ALLOCATED(ss%spsce).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%spsce)
  ENDIF
  IF(ALLOCATED(ss%spsce)) then
     jsize = SIZE(ss%spsce)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: spsce already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%spsce(ss%nrho_pel-1,0:ss%nspec_tha))
     ss%spsce = 0.0_rspec
     ALLOCATE(ss%id_spsce(0:ss%nspec_tha))
     ss%id_spsce = 0
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%squareLO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%squareLO)
  ENDIF
  IF(ALLOCATED(ss%squareLO)) then
     jsize = SIZE(ss%squareLO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: squareLO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%squareLO(ss%nrho_eq_geo))
     ss%squareLO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%squareUO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%squareUO)
  ENDIF
  IF(ALLOCATED(ss%squareUO)) then
     jsize = SIZE(ss%squareUO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: squareUO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%squareUO(ss%nrho_eq_geo))
     ss%squareUO = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%sRtcen).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%sRtcen)
  ENDIF
  IF(ALLOCATED(ss%sRtcen)) then
     jsize = SIZE(ss%sRtcen)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: sRtcen already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%sRtcen(ss%nbeam))
     ss%sRtcen = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%surf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%surf)
  ENDIF
  IF(ALLOCATED(ss%surf)) then
     jsize = SIZE(ss%surf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: surf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%surf(ss%nrho_eq))
     ss%surf = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%S_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%S_name)
  ENDIF
  IF(ALLOCATED(ss%S_name)) then
     jsize = SIZE(ss%S_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: S_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%S_name(0:ss%nspec_th))
     ss%S_name = " "
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%s_to_sa).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%s_to_sa)
  ENDIF
  IF(ALLOCATED(ss%s_to_sa)) then
     jsize = SIZE(ss%s_to_sa)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: s_to_sa already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%s_to_sa(0:ss%nspec_th))
     ss%s_to_sa = 0
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%S_type).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%S_type)
  ENDIF
  IF(ALLOCATED(ss%S_type)) then
     jsize = SIZE(ss%S_type)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: S_type already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%S_type(0:ss%nspec_th))
     ss%S_type = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%T0cx).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T0cx)
  ENDIF
  IF(ALLOCATED(ss%T0cx)) then
     jsize = SIZE(ss%T0cx)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T0cx already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T0cx(ss%nrho_gas-1,ss%ngsc0))
     ss%T0cx = 0.0_rspec
     ALLOCATE(ss%id_T0cx(ss%ngsc0))
     ss%id_T0cx = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)*(ss%ngsc0)
  IF(ALLOCATED(ss%T0sc0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T0sc0)
  ENDIF
  IF(ALLOCATED(ss%T0sc0)) then
     jsize = SIZE(ss%T0sc0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T0sc0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T0sc0(ss%nrho_gas-1,ss%nspec_gas,ss%ngsc0))
     ss%T0sc0 = 0.0_rspec
     ALLOCATE(ss%id_T0sc0(ss%nspec_gas,ss%ngsc0))
     ss%id_T0sc0 = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%T0_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T0_halo)
  ENDIF
  IF(ALLOCATED(ss%T0_halo)) then
     jsize = SIZE(ss%T0_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T0_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T0_halo(ss%nrho_nbi-1,ss%nspec_gas))
     ss%T0_halo = 0.0_rspec
     ALLOCATE(ss%id_T0_halo(ss%nspec_gas))
     ss%id_T0_halo = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%T0_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T0_reco)
  ENDIF
  IF(ALLOCATED(ss%T0_reco)) then
     jsize = SIZE(ss%T0_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T0_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T0_reco(ss%nrho_gas-1,ss%nspec_gas))
     ss%T0_reco = 0.0_rspec
     ALLOCATE(ss%id_T0_reco(ss%nspec_gas))
     ss%id_T0_reco = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%teflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%teflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%teflux_ky_tglf)) then
     jsize = SIZE(ss%teflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: teflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%teflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%teflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_teflux_ky_tglf(ss%nky_anomth))
     ss%id_teflux_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%te_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%te_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%te_ky_tglf)) then
     jsize = SIZE(ss%te_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: te_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%te_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%te_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_te_ky_tglf(ss%nky_anomth))
     ss%id_te_ky_tglf = 0
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_7

subroutine trxpl_imasrd2d_cdf(filenam)

  !  read NetCDF file containing data for IMAS database, namely:
  ! 
  !   nR, nZ, & R & Z grids: Rr, Zz, [m]
  !   BR(R,Z), BZ(R,Z), Btor(R,Z), all in  [T]
  !   G(R,Z) -- g-function, R*Bt, [t*m]
  !   psi(R,Z) - poloidal flux, tflux(R,Z) - toroidal flux, in [Wb]
  !   theta(R,Z) - equilibrium poloidal angle, [rad]
  !   curt(R,Z) - total enclosed toroidal current(R,Z) density, [A/m**2]
  !   curpll(R,Z) -  parallel current(R,Z) density , ~<J.B>/|B|', [A/m**2] ...
  ! 

  use netcdf
!  use logmod
  implicit NONE

  character*(*), intent(in) :: filenam  ! filename
  real*8 :: ztime0          ! time of interest
  real*8 :: ztavg           ! +/- delta(t) time averaging
  integer :: nbccw          ! Btoroidal orientation
  integer :: npccw          ! Plasma current orientation
  ! convention is +1 "ccw" means "counter-clockwise looking down from above"
  !               -1  for clockwise orientation
  real*8 dxtend                       ! amount of extension of grid beyond
                                      ! plasma bdy, subject to conditions

  integer :: nR,nZ                    ! gridsizes
  integer :: nbdy                     ! bdy contour size

  real*8, dimension(:), allocatable :: Rr,Zz  ! grids

  real*8, dimension(:), allocatable :: Rbdy,Zbdy    ! plasma bdy sequence

  !  (R,Z) variables, as described above:

  real*8, dimension(:,:), allocatable :: br,bz,bb,bt,psi,tflux,curt,curpll,theta,gfun
  real*8 ::  r_mag_axis,z_mag_axis

  !  constants, as described above, and...

  real*8, parameter :: ZERO = 0.0d0

  !  additional items
  ! local:

  character*100 zfilenam
  character*30 :: cvar
  integer ierr
  integer :: icdf,id
  integer ilf
  !-------------------------------------------------------------------

  ierr = 0

  if(filenam.eq.' ') then
     zfilenam = "trxpl_imas.cdf"
  else
     zfilenam = filenam
  endif
  !  read NetCDF file for IMAS

  call check(nf90_open(trim(adjustl(zfilenam)),NF90_NOWRITE,icdf),trim(adjustl(zfilenam)))

  !  ** NetCDF dimensions **
  nr=0
  nz=0
  nbdy=0
  cvar='nr'
  call check_inq(icdf,trim(cvar),id,ierr)
  call check( nf90_get_var(icdf,id,nr),cvar)
  if(nr.le.0) then
     write(*,*)' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0'
!     call errorLog(' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0')
     ierr=1
     return
  endif
  cvar='nz'
  call check_inq(icdf,trim(cvar),id,ierr)
  call check( nf90_get_var(icdf,id,nz),cvar)
  if(nz.le.0) then
     write(*,*)' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0'
!     call errorLog(' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0')
     ierr=1
     return
  endif
  cvar='nbdy'
  call check_inq(icdf,trim(cvar),id,ierr)
  call check( nf90_get_var(icdf,id,nbdy),cvar)
  if(nbdy.le.0) then
     write(*,*)' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0. DATA for BDY ignored'
!     call errorLog(' trxpl_imasrd2d_cdf:'//trim(cvar)//' le 0. DATA for BDY ignored')
  endif


  cvar='time' !sec
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,ztime0),cvar)

  cvar='avg_delta_t' !sec
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,ztavg),cvar)

  cvar='nbccw' !sec
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,nbccw),cvar)

  if(nbccw.eq.0) then
     write(*,*)' trxpl_imasrd2d_cdf:'//trim(cvar)//' eq 0'
!     call errorLog(' trxpl_imasrd2d_cdf:'//trim(cvar)//' eq 0')
     return
  endif

  cvar='npccw' !sec
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,npccw),cvar)

  if(npccw.eq.0) then
     write(*,*)' trxpl_imasrd2d_cdf:'//trim(cvar)//' eq 0'
!     call errorLog(' trxpl_imasrd2d_cdf:'//trim(cvar)//' eq 0')
     return
  endif

  allocate(rr(nr),zz(nz),br(nr,nz),bz (nr,nz),bt(nr,nz),theta(nr,nz),&
       &psi(nr,nz),tflux(nr,nz),curt(nr,nz),curpll(nr,nz),gfun(nr,nz))
 
  rr=ZERO
  zz=ZERO
  br=ZERO
  bz=ZERO
  bt=ZERO
  theta=ZERO
  psi=ZERO
  tflux=ZERO
  curt=ZERO
  curpll=ZERO
  gfun=ZERO

  cvar='rr' !m
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,rr(1:nr)),cvar)

  cvar='zz' !m
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,zz(1:nz)),cvar)

  cvar='theta' !rad
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,theta(1:nr,1:nz)),cvar)

  cvar='br' !T
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,br(1:nr,1:nz)),cvar)

  cvar='bz' !T
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,bz(1:nr,1:nz)),cvar)

  cvar='bt' !T
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,bt(1:nr,1:nz)),cvar)

  cvar='psi' !Wb
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,psi(1:nr,1:nz)),cvar)

  cvar='tflux' !Wb
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,tflux(1:nr,1:nz)),cvar)

  cvar='gfun' !T*m
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,gfun(1:nr,1:nz)),cvar)

  cvar='curt' !A/m**2
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,curt(1:nr,1:nz)),cvar)

  cvar='curpll' !A/m**2
  call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
  call check( nf90_get_var(icdf,id,curpll(1:nr,1:nz)),cvar)

  !  plasma bdy & scrape-off information
  if(nbdy.gt.0) then
     cvar='r_mag_axis' !m
     call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
     call check( nf90_get_var(icdf,id,r_mag_axis),cvar)

     cvar='z_mag_axis' !m
     call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
     call check( nf90_get_var(icdf,id,z_mag_axis),cvar)
     
     cvar='dxtend' !m
     call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
     call check( nf90_get_var(icdf,id,dxtend),cvar)

     allocate(rbdy(nbdy),zbdy(nbdy))
     rbdy=ZERO
     zbdy=ZERO

     cvar='rbdy' !m
     call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
     call check( nf90_get_var(icdf,id,rbdy(1:nbdy)),cvar)

     cvar='zbdy' !m
     call check_inq(icdf,trim(cvar),id,ierr) !get var. ID
     call check( nf90_get_var(icdf,id,zbdy(1:nbdy)),cvar)

     if(allocated(rbdy)) deallocate(rbdy,zbdy)

  endif
    ierr = nf90_close(icdf)
    if(ierr.ne.0) then
       write(*,*)' trxpl_imasrd2d_cdf: cannot close file: '//trim(zfilenam)
!       call errorLog(' trxpl_imasrd2d_cdf: cannot close file: '//trim(zfilenam))
    endif       
    if(allocated(rr)) deallocate(rr,zz,br,bz ,bt,theta,psi,tflux,curt,curpll,gfun)

    return

contains 

  subroutine check(status,varnam)
    integer, intent ( in) :: status 
    character*(*),intent(in) :: varnam ! dimension name input 
    
    if(status /= nf90_noerr) then 
       write(*,*)' trxpl_imasrd2d_cdf: error:'& 
            &// trim(nf90_strerror(status))//' for var.= '//trim(varnam)
!       call errorLog(' trxpl_imasrd2d_cdf: error:'& 
!            &// trim(nf90_strerror(status))//' for var.= '//trim(varnam))
!       call bad_exit 
    end if
  end subroutine check

  subroutine check_inq_dim(i_cdf,varnam,idim,ierrcdf) 
    integer,intent(in) :: i_cdf
    integer,intent(out) :: ierrcdf 
    character*(*),intent(in) :: varnam ! dimension name input 
    integer, intent(out) :: idim        ! dimension size returned 
    integer ::id !var ID 
    ierrcdf = nf90_inq_dimid(i_cdf,trim(varnam),id) 
    if(ierrcdf.ne.0) then 
       write(*,*)' trxpl_imasrd2d_cdf: NO such dim='//trim(varnam)
!       call errorLog(' trxpl_imasrd2d_cdf: NO such dim='//trim(varnam))
!       call bad_exit 
    endif 
    ierrcdf = nf90_inquire_dimension(i_cdf,id,len=idim) 
    if(ierrcdf.ne.0) then 
       write(*,*)' trxpl_imasrd2d_cdf: error '//nf90_strerror(ierrcdf)//'for var.'//trim(varnam)
!       call errorLog(' trxpl_imasrd2d_cdf: error '//nf90_strerror(ierrcdf)//'for var.'//trim(varnam))
!       call bad_exit 
    endif 
    if(idim.le.0) then 
       write(*,*)' trxpl_imasrd2d_cdf: 0 value for dimension '//trim(varnam)
 !      call errorLog(' trxpl_imasrd2d_cdf: 0 value for dimension '//trim(varnam))
!       call bad_exit 
    endif 
  end subroutine check_inq_dim

  subroutine check_inq(i_cdf,varnam,id,ierrcdf)
    integer,intent(in) :: i_cdf
    integer,intent(out) :: id,ierrcdf
    character*(*),intent(in) :: varnam 
    ierrcdf = nf90_inq_varid(i_cdf,trim(varnam),id) 
    if(ierrcdf.ne.0) then 
       write(*,*)' trxpl_imasrd2d_cdf: NO such var='//trim(varnam)
!       call errorLog(' trxpl_imasrd2d_cdf: NO such var='//trim(varnam))
!       call bad_exit 
    endif 
  end subroutine check_inq 

end subroutine trxpl_imasrd2d_cdf

subroutine splitn_update_ntimes(inum)

  ! return the number of update times in the current namelist

  use splitn_module
  implicit NONE

  integer, intent(out) :: inum

  !--------------------------

  if((nlines.le.0).or.(.not.have_database)) then
     write(6,*) ' ?splitn_update_times: no namelist has been read.'
     inum = 0
  else
     inum = nupdate
  endif

end subroutine splitn_update_ntimes

subroutine splitn_update_times(inum,ztimes,ierr)

  ! return the times of update blocks in namelist

  use splitn_module
  implicit NONE

  integer, intent(in) :: inum
  real*8, intent(out) :: ztimes(inum)
  integer, intent(out) :: ierr  ! status return code, 0=OK

  !----------------------------
  ! return ierr=1 & ztimes=0.0 if there are no update blocks.
  ! return ierr=2 & ztimes=0.0 if there are update blocks but nupdate > inum
  ! otherwise return ierr=0 and the times in ztimes(1:nupdate), and zeroes 
  !   in ztimes(j), j>nupdate.
  !----------------------------

  ztimes = 0.0d0
  ierr = 0

  if(nupdate.eq.0) then
     write(6,*) &
          ' %splitn_update_times: there are no update blocks in the namelist.'
     ierr = 1
     return
  endif

  if(inum.lt.nupdate) then
     write(6,*) &
          ' ?splitn_update_times: array dimension for update times too small:'
     write(6,*) '  received: inum=',inum,'; actual #updates = ',nupdate
     ierr = 2
     return
  endif

  ztimes(1:nupdate) = tup(1:nupdate)

end subroutine splitn_update_times

subroutine splitn_update_nxtime(prev_time,next_time)

  ! return the first update time after the passed time (prev_time)

  use splitn_module
  implicit NONE

  real*8, intent(in) :: prev_time
  real*8, intent(out) :: next_time

  !----------------------------------------
  integer :: ii
  !----------------------------------------

  next_time = 1.0d34

  do ii=nupdate,1,-1
     if(tup(ii).gt.prev_time) next_time=tup(ii)
  enddo

end subroutine splitn_update_nxtime

subroutine splitn_update_blkid(ztime,blkstr)

  ! return update block ID: "[0]" for initial block prior to any update, 
  !   "[1]" for 1st block
  !   "[2]" for 2nd block
  !      ..etc..  according to the time provided

  implicit NONE

  real*8, intent(in) :: ztime
  character*(*), intent(out) :: blkstr

  !------------------------
  integer :: inum
  real*8, dimension(:), allocatable :: ztimes
  integer :: ii,iblk,ierr
  !------------------------

  blkstr="[0]"

  call splitn_update_ntimes(inum)

  allocate(ztimes(inum)); ztimes=0.0d0

  call splitn_update_times(inum,ztimes,ierr)
  if(ierr.ne.0) return

  if(ztime.lt.ztimes(1)) then
     deallocate(ztimes)
     return
  endif

  do ii=1,inum
     if(ztimes(ii).gt.ztime) exit
     iblk=ii
  enddo

  if(iblk.lt.10) then
     write(blkstr,'("[",i1,"]")') iblk
  else if(iblk.lt.100) then
     write(blkstr,'("[",i2,"]")') iblk
  else if(iblk.lt.1000) then
     write(blkstr,'("[",i3,"]")') iblk
  else if(iblk.lt.10000) then
     write(blkstr,'("[",i4,"]")') iblk
  else if(iblk.lt.100000) then
     write(blkstr,'("[",i5,"]")') iblk
  else
     write(blkstr,'("[",i6,"]")') iblk
  endif

  deallocate(ztimes)

end subroutine splitn_update_blkid

subroutine trx_mks_conv(zname,zconv,zuns_out,iwarn)
!
!  find MKS conversion factor for named quantity
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zname    ! name of data item
  real*8, intent(out) :: zconv         ! conversion factor for data item
  character(*), intent(out) :: zuns_out ! units label (after mks conversion)
  integer, intent(out) :: iwarn        ! conversion warning flag, =0: OK
!
!  if the conversion cannot be done, zconv=1.0 is returned and a warning
!  message is written, and a warning flag is set.
!
!-------------
!  ...local
!
  character(64) :: zlbl
  character(32) :: zuns,zuns_mks
  integer :: imulti
  integer :: istype
!
  real zconvr4
!-------------
!
  call rplabel(zname,zlbl,zuns,imulti,istype)
  call rp_mks_conv(zname,zuns,zuns_mks,zconvr4,iwarn)
!
  zconv=zconvr4
  zuns_out=zuns_mks
!
  return
  end

subroutine tdb_tlims(d,zd_tinit,zd_ftime)
  use trdatbuf_obj
  implicit NONE
  !
  !  return time range covered by trdatbuf data
  !
  type (trdatbuf) :: d
  real*8, intent(out) :: zd_tinit  ! start time
  real*8, intent(out) :: zd_ftime  ! stop time

  zd_tinit = d%datbuf(1)
  zd_ftime = d%datbuf(2)

end subroutine tdb_tlims

subroutine tdb_tlim_ok(d,zd_ftime_ok)
  use trdatbuf_obj
  implicit NONE
  !
  !  return time beyond which a code failure should be ignored
  !  (allows experimentalists to set off time after disruption,
  !  without leading to a crash requiring manual intervention 
  !  for run to completion -- FTIME_OK in the TRANSP namelist).
  !
  type (trdatbuf) :: d
  real*8, intent(out) :: zd_ftime_ok  ! stop time

  zd_ftime_ok = d%datbuf(10)

end subroutine tdb_tlim_ok

subroutine splitn_getsize(zname,isize,ierr)

  !  get the size (number of array elements or 1 if scalar) of a namelist 
  !  object.  Information on multiple dimension not returned; total size only.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(out) :: isize         ! size of object
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch
  character*32 znam32
  !---------------------------

  ierr = 1

  znam32=zname
  call uupper(znam32)

  if(.not.have_database) then
     write(6,*) '?splitn_iget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo

  isize=ii
  ierr = 0

end subroutine splitn_getsize

subroutine splitn_getdims(zname,irank,irank_max,dims,isize,ierr)

  !  get the size (number of array elements or 1 if scalar) of a namelist 
  !  object along with array dimension information

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(out) :: irank         ! rank of object (0=scalar, 1=vector..)
  integer, intent(in) :: irank_max      ! max rank (dim of dim array)
  integer, intent(out) :: dims(2,irank_max) ! dimensioning info
  integer, intent(out) :: isize         ! total size of object
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch
  character*32 znam32
  !---------------------------

  ierr = 1

  znam32=zname
  call uupper(znam32)

  if(.not.have_database) then
     write(6,*) '?splitn_iget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  irank = varlist(jj)%rank
  dims = 0
  isize = 0

  if(irank.gt.irank_max) then
     write(6,*) '?splitn_getdims: max rank exceeded: ',irank_max,irank
  else
     ii=1
     do i=1,irank
        dims(1:2,i)=varlist(jj)%dims(1:2,i)
        ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
     enddo
  endif

  isize=ii
  ierr = 0

end subroutine splitn_getdims

subroutine splitn_get_type(zname,ztype,ichsize,ierr)

  !  get the datatype (real/integer/logical/double/character) of a namelist 
  !  object.  If type Character*nnn return nnn also.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  character*(*), intent(out) :: ztype   ! (CHARACTER*5) datatype code:
  !  R/I/L/D/C*nnn
  integer, intent(out) :: ichsize       ! if C*n -- number of characters n
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,jj,ivar,imatch
  character*32 znam32
  !---------------------------

  ierr = 1

  znam32=zname
  call uupper(znam32)

  if(.not.have_database) then
     write(6,*) '?splitn_iget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  ztype = varlist(jj)%type
  ichsize = 0
  if(ztype(1:2).eq.'C*') ichsize = varlist(jj)%chsize
  ierr = 0

end subroutine splitn_get_type

subroutine splitn_get_dstr(zname,dstr,ierr)

  !  get the string which defines the object's default value.
  !  if the passed string is too short a truncated string is returned
  !  without error or warning indicated.  SPLITN default strings are
  !  never more than 512 characters long.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  character*(*), intent(out) :: dstr    ! default specifier
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,jj,ivar,imatch,ilen,jlen,klen,iadr
  character*32 znam32
  !---------------------------

  ierr = 1

  znam32=zname
  call uupper(znam32)

  if(.not.have_database) then
     write(6,*) '?splitn_iget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  dstr = ' '
  iadr=varlist(jj)%long_dflt_addr
  if(iadr.eq.0) then
     ilen=len_trim(varlist(jj)%short_dflt)
     jlen=len(dstr)
     klen=min(ilen,jlen)
     dstr(1:klen)=varlist(jj)%short_dflt(1:klen)
  else
     ilen=len_trim(long_dflts(iadr))
     jlen=len(dstr)
     klen=min(ilen,jlen)
     dstr(1:klen)=long_dflts(iadr)(1:klen)
  endif
  ierr = 0

end subroutine splitn_get_dstr

subroutine splitn_get_trustat(zname,iupdate,ierr)

  ! return iupdate=1 if quantity (zname) is TRANSP-namelist-updatable.
  ! otherwise return iupdate=0.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer,intent(out) :: iupdate        ! =0: not updatable;
                                   ! =1: updatable via TRANSP update namelist

  integer,intent(out) :: ierr           ! status return code 0=OK

  !-----------------------------------
  character*32 :: znam32
  integer :: indbr1,ivar,imatch,jj
  !-----------------------------------

  ierr = 0

  indbr1 = index(zname,'[')
  if(indbr1.gt.1) then
     znam32 = zname(1:indbr1-1)
  else
     znam32 = zname
  endif
  call uupper(znam32)
 
  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     ierr=1
     write(6,*) '?splitn_get_trustat: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)
 
  iupdate = 0

  if(varlist(jj)%steerable.eq.2) then
     iupdate = 1
  endif

end subroutine splitn_get_trustat

subroutine splitn_get_udetails(zname,iupdatable, &
     idefault,inum_update,inmax,iupdate_vector,ierr)

  !  get default/update status information on item:
  !    (a) whether it is updatable (trdat only or trdat & TRANSP);
  !    (b) whether its (initial) value is defaulted
  !    (c) whether value change updates exist after initial setting
  !    (d) vector indicating which blocks contain updates

  !  for arrays-- a non-default initial value for any array element
  !    means, the whole array is considered to have a non-default value;
  !    similarly, if any array element is changed on update, the whole
  !    array is considered to have been changed.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer,intent(out) :: iupdatable     ! =0: not updatable; =1: trdat only
                                        ! >1: updatable in TRANSP

  integer,intent(out) :: idefault       ! =-1: no text, default initial value
                                        ! =0: text present, still the default
                                        ! =1: non-default value
                                        !     (this implies text is present)

  integer,intent(out) :: inum_update    ! number of update blocks w/changes

  integer,intent(in) :: inmax           ! array size for iupdate_vector

  integer,intent(out) :: iupdate_vector(inmax) ! update status vector:
                                        ! iupdate_vector(j) for update block #j
                                        !   -1 means: no text, no value change
                                        !    0 means: text but no value change
                                        !    1 means: value change
                                        !      (this implies text is present).

  integer,intent(out) :: ierr           ! status return code 0=OK

  !---------------------------
  integer i,ii,jj,ivar,imatch,ilen,isize,ichsize,itext,iup,iadl0,iadl1,iadl2,ic
  character*32 znam32
  character*40 zcombo
  character*5 :: ztype
  character*1 :: dtype
  character*6 :: zi6
  character*8 :: zupid

  real, dimension(:), allocatable :: r0,r1
  real*8, dimension(:), allocatable :: d0,d1
  integer, dimension(:), allocatable :: i0,i1
  logical, dimension(:), allocatable :: L0,L1
  integer, parameter :: iwid=128
  character*(iwid), dimension(:), allocatable :: ch0,ch1

  !---------------------------
  ! default outputs:

  ierr = 1

  iupdatable = 0
  idefault = -1
  inum_update = 0
  iupdate_vector = -1

  !---------------------------
  ! check name
  znam32=zname
  call uupper(znam32)

  if(.not.have_database) then
     write(6,*) '?splitn_get_udetails: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_get_udetails: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)
  
  !---------------------------
  !  Name is OK

  iupdatable = varlist(jj)%steerable

  if((iupdatable.ge.2).and.(nupdate.gt.inmax)) then
     write(6,*) '?splitn_get_udetails: update status vector size too small:'
     write(6,*) ' received: ',inmax,'; need: ',nupdate,'.'
     return
  endif

  !---------------------------
  !  Error checks OK

  ierr=0

  !  get size for internal use

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  isize=ii

  !  look for text.  If no text, then, default values apply and there
  !  are no updates and this is known without further checking...

  itext = 0
  do ii=1,isize
     if(ilines(varlist(jj)%nlinadr+ii-1).ne.0) then
        itext = 1
        idefault = 0   ! text detected
        exit
     endif
  enddo

  iadl0 = nreal + nr8 + nint + nlog + nchv
  iadl1 = nreal_st + nr8_st + nint_st + nlog_st + nchv_st

  if((itext.eq.0).and.(iupdatable.ge.2)) then
     ! look for update text...
     do iup=1,nupdate
        do ii=1,isize
           iadl2 = iadl0 + (iup-1)*iadl1 + varlist(jj)%nlinadr_st + ii - 1
           if(ilines(iadl2).ne.0) then
              itext=1
              iupdate_vector(iup)=0  ! text detected
              exit
           endif
        enddo
     enddo
  endif

  if(itext.eq.0) then
     ! the quantity is never referenced in the namelist text; therefore,
     ! its default value applies throughout -- we are done here.
     return
  endif

  ztype = varlist(jj)%type
  ichsize = 0
  if(ztype(1:2).eq.'C*') ichsize = varlist(jj)%chsize

  !-----------------------------
  ! OK, text exists: scan through values to determine changes

  dtype = ztype(1:1)

  if(dtype.eq.'R') then
     allocate(r0(isize),r1(isize))
  else if(dtype.eq.'I') then
     allocate(i0(isize),i1(isize))
  else if(dtype.eq.'D') then
     allocate(d0(isize),d1(isize))
  else if(dtype.eq.'L') then
     allocate(L0(isize),L1(isize))
  else if(dtype.eq.'C') then
     allocate(ch0(isize),ch1(isize))
  endif

  do
     ! check defaults...
     if(dtype.eq.'R') then
        call splitn_rgetd(zname,isize,r0,ierr); if(ierr.ne.0) exit
        r1=r0
        call splitn_rget(zname,isize,r1,ierr); if(ierr.ne.0) exit
        do ii=1,isize
           if(r0(ii).ne.r1(ii)) then
              idefault=1  ! value change detected
              exit
           endif
        enddo

     else if(dtype.eq.'I') then
        call splitn_igetd(zname,isize,i0,ierr); if(ierr.ne.0) exit
        i1=i0
        call splitn_iget(zname,isize,i1,ierr); if(ierr.ne.0) exit
        do ii=1,isize
           if(i0(ii).ne.i1(ii)) then
              idefault=1  ! value change detected
              exit
           endif
        enddo

     else if(dtype.eq.'D') then
        call splitn_dgetd(zname,isize,d0,ierr); if(ierr.ne.0) exit
        d1=d0
        call splitn_dget(zname,isize,d1,ierr); if(ierr.ne.0) exit
        do ii=1,isize
           if(d0(ii).ne.d1(ii)) then
              idefault=1  ! value change detected
              exit
           endif
        enddo

     else if(dtype.eq.'L') then
        call splitn_Lgetd(zname,isize,L0,ierr); if(ierr.ne.0) exit
        L1=L0
        call splitn_Lget(zname,isize,L1,ierr); if(ierr.ne.0) exit
        do ii=1,isize
           if((L0(ii).AND.(.not.L1(ii))) .OR. ((.not.L0(ii)).AND.L1(ii))) then
              idefault=1  ! value change detected
              exit
           endif
        enddo

     else if(dtype.eq.'C') then
        call splitn_cgetd(zname,iwid,isize,ch0,ierr); if(ierr.ne.0) exit
        ch1=ch0
        call splitn_cget(zname,iwid,isize,ch1,ierr); if(ierr.ne.0) exit
        do ii=1,isize
           if(ch0(ii).ne.ch1(ii)) then
              idefault=1  ! value change detected
              exit
           endif
        enddo

     endif

     ! check update blocks...
     if(iupdatable.le.1) exit

     do iup=1,nupdate
        
        ! update reference string
        zi6=' '
        write(zi6,'(i6)') iup
        ic=1
        do ii=5,1,-1
           if(zi6(ii:ii).eq.' ') then
              ic=ii+1
              exit
           endif
        enddo

        zupid = '['//zi6(ic:6)//']'
        zcombo = trim(zname)//trim(zupid)

        if(dtype.eq.'R') then

           r0=r1
           call splitn_rget(zcombo,isize,r1,ierr); if(ierr.ne.0) exit
           do ii=1,isize
              if(r0(ii).ne.r1(ii)) then
                 inum_update = inum_update + 1
                 iupdate_vector(iup)=1  ! value change detected
                 exit
              endif
           enddo

        else if(dtype.eq.'I') then

           i0=i1
           call splitn_iget(zcombo,isize,i1,ierr); if(ierr.ne.0) exit
           do ii=1,isize
              if(i0(ii).ne.i1(ii)) then
                 inum_update = inum_update + 1
                 iupdate_vector(iup)=1  ! value change detected
                 exit
              endif
           enddo

        else if(dtype.eq.'D') then

           d0=d1
           call splitn_dget(zcombo,isize,d1,ierr); if(ierr.ne.0) exit
           do ii=1,isize
              if(d0(ii).ne.d1(ii)) then
                 inum_update = inum_update + 1
                 iupdate_vector(iup)=1  ! value change detected
                 exit
              endif
           enddo

        else if(dtype.eq.'L') then

           L0=L1
           call splitn_lget(zcombo,isize,L1,ierr); if(ierr.ne.0) exit
           do ii=1,isize
              if((L0(ii).AND.(.not.L1(ii))) .OR. &
                   ((.not.L0(ii)).AND.L1(ii))) then
                 inum_update = inum_update + 1
                 iupdate_vector(iup)=1  ! value change detected
                 exit
              endif
           enddo

        else if(dtype.eq.'C') then

           ch0=ch1
           call splitn_cget(zcombo,isize,ch1,ierr); if(ierr.ne.0) exit
           do ii=1,isize
              if(ch0(ii).ne.ch1(ii)) then
                 inum_update = inum_update + 1
                 iupdate_vector(iup)=1  ! value change detected
                 exit
              endif
           enddo

        endif
     enddo

     exit
  enddo

  if(dtype.eq.'R') then
     deallocate(r0,r1)
  else if(dtype.eq.'I') then
     deallocate(i0,i1)
  else if(dtype.eq.'D') then
     deallocate(d0,d1)
  else if(dtype.eq.'L') then
     deallocate(L0,L1)
  else if(dtype.eq.'C') then
     deallocate(ch0,ch1)
  endif

end subroutine splitn_get_udetails

subroutine splitn_update_report

  ! report updated quantities -- #of updates

  use splitn_module
  implicit NONE

  integer :: ii,jj,kk,iany

  integer :: inmax,idefault,iupdatable,inum_update,ierr,isum
  integer, dimension(:), allocatable :: iupdate_vector
  !---------------------------------------

  inmax=max(1,nupdate)
  allocate(iupdate_vector(inmax))

  iany = 0
  do ii=1,nvars
     jj=var_order(ii)
     if(varlist(jj)%name.eq.'~UPDATE_TIME') cycle

     call splitn_get_udetails(varlist(jj)%name, iupdatable, &
          idefault, inum_update, inmax, iupdate_vector, ierr)

     isum=0
     do kk=1,inmax
        if(iupdate_vector(kk).gt.-1) isum=isum+1
     enddo

     if(isum.gt.0) then
        iany = iany + 1
        if(iany.eq.1) then
           write(6,*) ' '
           write(6,*) ' %splitn_update_report: update namelists report:'
           write(6,*) '  (some references are not updates-- i.e. if value matches prior setting).'
           write(6,*) ' '
        endif
        write(6,*) varlist(jj)%name,' ...has ',isum,' reference(s) and ',inum_update,' update(s).'
     endif
  enddo

  if(iany.gt.0) write(6,*) ' '

end subroutine splitn_update_report

subroutine trx_bxtr(ibccw,ipccw,irzflag,ierr)

  use trx_module
  use trx_bxtr_options
  implicit NONE

!
!  form the B field bicubic splines in the core plasma, and,
!  optionally, extrapolate field to cover (R,Z) rectangular grid.
!
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  integer, intent(inout) :: ibccw ! Btoroidal:  1 for ccw, -1 for cw
  integer, intent(inout) :: ipccw ! Itoroidal:  1 for ccw, -1 for cw

! if the "ccw" variables are 0 on input, try to set them from trdatbuf data...

  integer, intent(in) :: irzflag ! =1:  extrapolate field to (R,Z) region
!   if free boundary data is present, the field is defined over the (R,Z)
!   region, regardless of this switch setting.
!
  integer, intent(out) :: ierr ! completion code, 0=OK
!
!--------------------------------
  external eqm_brz_adhoc,eqm_brzx,eqm_bpsi
!--------------------------------
!
  integer :: lunzer,iwarn,ident=0
  integer :: iccwb,iccwj,ilun,istat
  logical :: ilccw(1),ifreebdy
  integer :: irzflag1
!
!--------------------------------
!
  irzflag1 = irzflag
  if((nRfree.gt.0).and.(nZfree.gt.0)) then
     irzflag1 = 1
     ifreebdy=.TRUE.
  else
     ifreebdy=.FALSE.
  endif

  ierr=0

  if((ibccw.eq.0).or.(ipccw.eq.0)) then
     call trx_trdatbuf_connect(iwarn)
     if(d_data_avail) then
        call tdb_ccwchk(d,iccwb,iccwj)
        if(ibccw.eq.0) then
           ibccw = iccwb
           if(ibccw.eq.0) write(lunzer(0),*) &
                ' ?trx_bxtr: Bphi CCW sign not found in TRANSP archive data.'
        endif
        if(ipccw.eq.0) then
           ipccw = iccwj
           if(ipccw.eq.0) write(lunzer(0),*) &
                ' ?trx_bxtr: Jphi CCW sign not found in TRANSP archive data.'
        endif
     else
        write(lunzer(0),*) ' ?trx_bxtr: TRANSP archive data access failed;'// &
             ' cannot set ibccw or ipccw.'
     endif
  endif

  if((ibccw.ne.1).and.(ibccw.ne.-1)) then
     ierr=ierr+1
     write(lunzer(0),*) ' ?trx_bxtr:  ibccw must be +/-1; ibccw=',ibccw
  endif
  if((ipccw.ne.1).and.(ipccw.ne.-1)) then
     ierr=ierr+1
     write(lunzer(0),*) ' ?trx_bxtr:  ipccw must be +/-1; ipccw=',ipccw
  endif
  if(ierr.gt.0) then
     write(lunzer(0),*) ' %trx_bxtr:  RECOVERY attempt: check namelist.'
     call find_io_unit(ilun)
     call tr_getnl_text(ilun,ierr)
     if(ierr.eq.0) then

        !  NLBCCW
        call tr_getnl_logvec('NLBCCW',ilccw,1,istat)
        if(istat.lt.0) then
           ierr=ierr+1
           write(lunzer(0),*) ' ?trx_bxtr: error accessing NLBCCW.'
        else if(istat.eq.0) then
           write(lunzer(0),*) ' %trx_bxtr: NLBCCW defaulted, .TRUE. assumed.'
           ibccw=1
        else
           if(ilccw(1)) then
              ibccw=1
              write(lunzer(0),*) ' %trx_bxtr: found NLBCCW=.TRUE.'
           else
              ibccw=-1
              write(lunzer(0),*) ' %trx_bxtr: found NLBCCW=.FALSE.'
           endif
        endif

        !  NLJCCW
        call tr_getnl_logvec('NLJCCW',ilccw,1,istat)
        if(istat.lt.0) then
           ierr=ierr+1
           write(lunzer(0),*) ' ?trx_bxtr: error accessing NLJCCW.'
        else if(istat.eq.0) then
           write(lunzer(0),*) ' %trx_bxtr: NLJCCW defaulted, .TRUE. assumed.'
           ipccw=1
        else
           if(ilccw(1)) then
              ipccw=1
              write(lunzer(0),*) ' %trx_bxtr: found NLJCCW=.TRUE.'
           else
              ipccw=-1
              write(lunzer(0),*) ' %trx_bxtr: found NLJCCW=.FALSE.'
           endif
        endif

     endif
  endif
  if(ierr.ne.0) return
!
!  compute interior field
!
  call eqm_bset(ibccw,ipccw)
!
!  computer extrapolated field on (R,Z) grid
!
  if(irzflag1.eq.1) then
     if(ifreebdy) then
        call trx_psirz_load(ierr)
        if(ierr.eq.0) then
           call eqm_brz(eqm_bpsi, edge_smooth ,ierr)
        endif
     else
        if(extrap_method.eq.1) then
           call eqm_brz(eqm_brz_adhoc, edge_smooth ,ierr)
        else
           call eqm_brz(eqm_brzx, edge_smooth ,ierr)
        endif
     endif
  endif
  if(ierr.ne.0) return
!
!  store units
!
  call eq_gfnum('Bmod',ident)
  call trx_ustore(ierr,ident,0,-99,'T',0)
  if(ierr.ne.0) return
!
  call eq_gfnum('BR',ident)
  call trx_ustore(ierr,ident,0,-99,'T',0)
  if(ierr.ne.0) return
!
  call eq_gfnum('BZ',ident)
  call trx_ustore(ierr,ident,0,-99,'T',0)
  if(ierr.ne.0) return
!
  if(irzflag1.eq.1) then
     call eq_gfnum('Bphi',ident)
     call trx_ustore(ierr,ident,0,-99,'T',0)
     if(ierr.ne.0) return
  endif
!
  return
!
end subroutine trx_bxtr

subroutine ps_coordchk(xobj,coord_tag,gridname,gridId,iauthor, &
     coord_id,n,grid_data,iout,ierr)

  !----------------------------------------
  ! D. McCune 9 Oct 2006
  ! internal routine for xplasma2 implementation of plasma state
  ! check coord_tag string & translate into an xplasma2 coord ID;
  ! check that range of grid data provided is appropriate.

  ! This routine called indirectly from generated code -- not expected
  ! to be called directly from user components
  !
  ! NB DMC 10 Aug 2007 -- add ps_coordTag internal routine -- given
  !                       coord ID return coord_tag
  !----------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  type (interp_object) :: xobj
  character*(*), intent(in) :: coord_tag   ! "RHO", "TH", "R", or "Z", ...
  character*(*), intent(in) :: gridname    ! NAME of grid 
  integer, intent(in) :: gridId            ! ID of grid
  integer, intent(in) :: iauthor           ! author (component) index

  integer, intent(out) :: coord_id         ! xplasma coord ID

  integer, intent(in) :: n                 ! expected grid data size
  REAL(KIND=rspec) :: grid_data(n)         ! grid data (input; may be checked).

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr              ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...
  
  logical :: periodic

  REAL(KIND=rspec) :: bdytol,ztol,xmin,xmax
  real(KIND=rspec), parameter :: pi = 3.1415926535897931_rspec

  type (xplasma), pointer :: s
  integer :: inum,idc,ilenc
  character*3 :: suffix
  character*32 coord_name

  logical :: not_periodic = .FALSE.

  !--------------------------------------------------

  ierr = 0

  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, bdytol=bdytol)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_coordchk: unexpected error in xplasma_global_info:'
     call xplasma_error(s,ierr,iout)
     ierr=99
     return
  endif

  !--------------------------------------------------
  ! *** if this if-then-else series changes, please
  !     make matching changes in ps_coordTag, below...

  if(coord_tag.eq.'TH') then
     coord_id = xplasma_theta_coord
     periodic = .TRUE.

  else if(coord_tag.eq.'PHI') then
     coord_id = xplasma_phi_coord
     periodic = .TRUE.

  else if(coord_tag.eq.'R') then
     periodic = .FALSE.
     if(ps_cnames(iauthor).eq.'EQ') then
        coord_id = xplasma_R_coord
     else
        inum=0
        coord_name='__R_'//trim(ps_cnames(iauthor))
        ilenc=len(trim(coord_name))+3
        do 
           inum=inum+1
           write(suffix,'(I3.3)') inum
           coord_name(ilenc-2:ilenc)=suffix
           call xplasma_coordId(s,coord_name,idc)
           if(idc.eq.0) exit
           call xplasma_coord_info(s,idc,ierr,xmin=xmin,xmax=xmax)
           ztol=1.0e-10_rspec*max(abs(xmin),abs(xmax))
           if(max(abs(xmin-grid_data(1)),abs(xmax-grid_data(n))).le.ztol) then
              exit  ! coord idc is OK
           endif
        enddo
        !  if suitable coordinate was not found, create one.
        if(idc.eq.0) then
           call xplasma_create_coord(s,coord_name,not_periodic,idc,ierr, &
                label='R ('//trim(ps_cnames(iauthor))//')',units='m')
        endif
        coord_id = idc
     endif

  else if(coord_tag.eq.'Z') then
     periodic = .FALSE.
     if(ps_cnames(iauthor).eq.'EQ') then
        coord_id = xplasma_Z_coord
     else
        inum=0
        coord_name='__Z_'//trim(ps_cnames(iauthor))
        ilenc=len(trim(coord_name))+3
        do 
           inum=inum+1
           write(suffix,'(I3.3)') inum
           coord_name(ilenc-2:ilenc)=suffix
           call xplasma_coordId(s,coord_name,idc)
           if(idc.eq.0) exit
           call xplasma_coord_info(s,idc,ierr,xmin=xmin,xmax=xmax)
           ztol=1.0e-10_rspec*max(abs(xmin),abs(xmax))
           if(max(abs(xmin-grid_data(1)),abs(xmax-grid_data(n))).le.ztol) then
              exit  ! coord idc is OK
           endif
        enddo
        !  if suitable coordinate was not found, create one.
        if(idc.eq.0) then
           call xplasma_create_coord(s,coord_name,not_periodic,idc,ierr, &
                label='Z ('//trim(ps_cnames(iauthor))//')',units='m')
        endif
        coord_id = idc
     endif

  else if(coord_tag.eq.'E') then
     ! energy
     periodic = .FALSE.
     inum=0
     coord_name='__E_'//trim(ps_cnames(iauthor))
     ilenc=len(trim(coord_name))+3
     do 
        inum=inum+1
        write(suffix,'(I3.3)') inum
        coord_name(ilenc-2:ilenc)=suffix
        call xplasma_coordId(s,coord_name,idc)
        if(idc.eq.0) exit
        call xplasma_coord_info(s,idc,ierr,xmin=xmin,xmax=xmax)
        ztol=1.0e-10_rspec*max(abs(xmin),abs(xmax))
        if(max(abs(xmin-grid_data(1)),abs(xmax-grid_data(n))).le.ztol) then
           exit  ! coord idc is OK
        endif
     enddo
        !  if suitable coordinate was not found, create one.
     if(idc.eq.0) then
        call xplasma_create_coord(s,coord_name,not_periodic,idc,ierr, &
             label='E ('//trim(ps_cnames(iauthor))//')',units='keV')
     endif
     coord_id = idc

  else if(coord_tag.eq.'KY') then
     ! energy
     periodic = .FALSE.
     inum=0
     coord_name='__KY'//trim(ps_cnames(iauthor))
     ilenc=len(trim(coord_name))+3
     do
        inum=inum+1
        write(suffix,'(I3.3)') inum
        coord_name(ilenc-2:ilenc)=suffix
        call xplasma_coordId(s,coord_name,idc)
        if(idc.eq.0) exit
        call xplasma_coord_info(s,idc,ierr,xmin=xmin,xmax=xmax)
        ztol=1.0e-10_rspec*max(abs(xmin),abs(xmax))
        if(max(abs(xmin-grid_data(1)),abs(xmax-grid_data(n))).le.ztol) then
           exit  ! coord idc is OK
        endif
     enddo
        !  if suitable coordinate was not found, create one.
     if(idc.eq.0) then
        call xplasma_create_coord(s,coord_name,not_periodic,idc,ierr, &
             label='KY ('//trim(ps_cnames(iauthor))//')',units='a.u.')
     endif
     coord_id = idc

  else if(coord_tag.eq.'RHO') then
     coord_id = xplasma_rho_coord
     periodic = .FALSE.

     ztol = bdytol
     if((abs(grid_data(1)).gt.bdytol).OR. &
          (abs(grid_data(n)-1.0_rspec).gt.bdytol)) then

        ierr=99
        write(iout,*) ' ?ps_coordchk: range error in grid "',trim(gridname),'".'
        write(iout,*) '  "RHO" grid range not [0:1]'
        write(iout,*) '  1st value:  ',grid_data(1)
        write(iout,*) '  last value: ',grid_data(n)

     endif

  else

     write(iout,*) ' ?ps_coordchk: for grid "',trim(gridname),'",' 
     write(iout,*) '  coordinate tag "',trim(coord_tag),'" not recognized.'
     ierr=99
  endif

  !  end of if-then-else block for coord IDs and tags
  !--------------------------------------------------

  if(ierr.ne.0) return

  if(periodic) then

     ztol = 2*pi*bdytol

     ! grid data must either have range [-pi:pi] or [0:2pi]

     if((abs(grid_data(1)+pi).gt.ztol).OR. &
          (abs(grid_data(n)-pi).gt.ztol)) then
        if((abs(grid_data(1)).gt.ztol).OR. &
             (abs(grid_data(n)-2*pi).gt.ztol)) then

           ierr=99
           write(iout,*) ' ?ps_coordchk: range error in grid "',trim(gridname),'".'
           write(iout,*) '  periodic grid "',trim(coord_tag),'" range'
           write(iout,*) '     should be either [-pi:pi] or [0:2*pi].'
           write(iout,*) '  1st value:  ',grid_data(1)
           write(iout,*) '  last value: ',grid_data(n)
        endif
     endif

  endif

end subroutine ps_coordchk
           
        
subroutine ps_coordTag(xobj,idc,tag)

  ! internal routine for ps_xplasma

  ! given a coordinate tag, return a tag coordinate string, consistent
  ! with the string -> tag mapping of subroutine ps_coordchk


  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_constants_mod  ! PARAMETERs ps_* defined here
  use swim_global_data_mod, only: rspec
  implicit NONE

  !-----------------------
  type (interp_object) :: xobj
  integer, intent(in) :: idc      ! coordinate tag
  character*(*), intent(out) :: tag
  integer :: ierr,itype
  character*32 :: cname

  type (xplasma), pointer :: s
  !-----------------------

  tag = '??'

  if(idc.eq.xplasma_rho_coord) then
     tag = 'RHO'

  else if(idc.eq.xplasma_theta_coord) then
     tag = 'TH'

  else if(idc.eq.xplasma_phi_coord) then
     tag = 'PHI'

  else if(idc.eq.xplasma_R_coord) then
     tag = 'R'

  else if(idc.eq.xplasma_Z_coord) then
     tag = 'Z'

  else

     s => xobj%s_xpobj
     call xplasma_get_item_info(s,idc,ierr,name=cname,itype=itype)
     write(*,*) 'cname=',cname
     if(itype.eq.xplasma_coordType) then
        if(cname(1:3).eq.'__R') tag='R'
        if(cname(1:3).eq.'__Z') tag='Z'
        if(cname(1:3).eq.'__E') tag='E'
     endif

  endif

end subroutine ps_coordTag

 
SUBROUTINE trdatbuf_intmod_sub2(s,ivarsize,idimvs,intbuf,idimi)
  ! ** gensis_f90.py generated code, do NOT edit **
 
  use trdatbuf_obj
  IMPLICIT NONE
 
  type(trdatbuf) :: s
  integer :: idimvs,idimi
  integer :: ivarsize(idimvs)
  integer :: intbuf(idimi)
 
  integer :: i,i1,i2
 
  !----------------------
 
  i=0
  i1=0
  i2=0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LADR_ZA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LADR_ZAF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPDE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPMAP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPMU
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPSP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAEPTS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAIMPS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LAIMPX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATALP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATBDI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATCUR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATDFL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATDTG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATDTS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATDTX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATEDI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATEHP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATELI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATFGW
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATFIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATFMN
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATFMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGAS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATGIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATHAL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATIBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATIEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATIIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATILH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATL2B
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATLAD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATLID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATNTX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATOGF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATORC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPEB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPF0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPFL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPIB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPLF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPLH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATPOS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRBZ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRCY
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRMN
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATRTP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSBT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSFA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSFL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSFP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATSP3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTET
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTGF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTPI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTQT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTRC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTRF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATTXI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATVPH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATVSB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATVSF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATXKF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATZEF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATZFA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATZIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDATZPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDMDF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDMFR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDMMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDPFC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LDPFC_PRE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LEFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFAEPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFAEPP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFECA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFECB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFREE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFRQRFF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFSYZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFULNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LFZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LHLFNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LLIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LMOMD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPELDA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPHSLH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPMDF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPWREC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPWRLH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPWRNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LPWRRF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRMFR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRMP_BDY1
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRMP_BDY2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LRPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSEVENT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LSSYZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTABORT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTHFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIME1
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIME2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMECA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMECB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMLH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMRF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTIMRFF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LTSAW
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LVLTNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXMMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXPFC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXSYZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXZIMPS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXZIMPX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXZIMPXS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LXZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LYRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LYRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LZFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%LZPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%MMAX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%MMX_MAXE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%MTRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%MTRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NANTECH_D
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NANTICH_D
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NANTLH_D
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NBDATA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDEAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDMDF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDMFR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDMMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDPAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDPFC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NDPFC_PRE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NEFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NFRBCODE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NFRBMODE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NGMAX_D
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NHECFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NHFMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NIMDF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NISSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NISX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NITSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NITX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NKAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NLIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMAPSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMDXKF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMIMP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMOMD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMUAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NMZEFF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NNSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NPACK
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NPAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NPELDA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NPMDF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NPMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRHIS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRHIX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRID2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRILHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRINMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRISBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRISIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRITER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRITI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRITQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRIZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRMFR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NRPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSAWFLAG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSC_FMT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSEVENT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSEVPER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSEVTBL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSEVWDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSFAST_D
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NSYZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTABORT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTAEP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTHFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIME1
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIME2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMECA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMECB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMLH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMNB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMRF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTIMRFF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTPSI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NTSAW
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFD0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFDB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFDP
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFDQ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFDR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFDS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXFS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXMMX
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNE0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNM0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXPFC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYAXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYBOL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYBPA
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYBPB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYD2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDE2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYDFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYECF
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYFEH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYFEL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYGRB
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYIBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYIBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYJBM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYJEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYJIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLF3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLF4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLF6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLFD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLFH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLFT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLHE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYLHJ
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYMSE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNI3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNI4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNI6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNID
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNIH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNIT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYNMR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYOMG
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYPRS
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYQBE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYQBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYQEC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYQIC
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYQPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYRES
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYSBI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYSIM
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXSYZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXTE0
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXTER
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXTI2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXTQI
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXV2F
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVB2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVC3
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVC4
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVC6
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVCD
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVCH
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVCT
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVEE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVIE
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVMO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVPO
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVPR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXVTR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXZEF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXZF2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NXZXR
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NYRP2
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NYRPL
 
      i=i+1
      i1=i2+1
      i2=i2+ivarsize(i)
      intbuf(i1:i2) = s%NZPSI
 
END SUBROUTINE trdatbuf_intmod_sub2

subroutine trx_bxtr_method_set(imethod)

  use trx_bxtr_options
  implicit NONE

  integer, intent(in) :: imethod
  !  imethod = 1 -- ad hoc extrapolator (recommended & default)
  !  imethod = 2 -- del.B = 0 extrapolator

  extrap_method = max(1,min(2,imethod))

end subroutine trx_bxtr_method_set

subroutine trx_bxtr_method_get(imethod)

  use trx_bxtr_options
  implicit NONE

  integer, intent(out) :: imethod
  !  imethod = 1 -- ad hoc extrapolator (recommended & default)
  !  imethod = 2 -- del.B = 0 extrapolator

  imethod = extrap_method

end subroutine trx_bxtr_method_get

subroutine trx_bxtr_smooth_set(zsmooth)

  use trx_bxtr_options
  implicit NONE

  real*8, intent(in) :: zsmooth ! edge smoothing parameter (meters)
  real*8, parameter :: ZERO = 0.0d0

  edge_smooth = max(ZERO,zsmooth)

end subroutine trx_bxtr_smooth_set

subroutine trx_bxtr_smooth_get(zsmooth)

  use trx_bxtr_options
  implicit NONE

  real*8, intent(out) :: zsmooth ! edge smoothing parameter (meters)

  zsmooth = edge_smooth

end subroutine trx_bxtr_smooth_get

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_2(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%n_d_einj_standard)
  IF(ALLOCATED(ss%D_einj_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%D_einj_standard)
  ENDIF
  IF(ALLOCATED(ss%D_einj_standard)) then
     jsize = SIZE(ss%D_einj_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: D_einj_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%D_einj_standard(ss%n_d_einj_standard))
     ss%D_einj_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_d_einj_standard)
  IF(ALLOCATED(ss%D_ffull_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%D_ffull_standard)
  ENDIF
  IF(ALLOCATED(ss%D_ffull_standard)) then
     jsize = SIZE(ss%D_ffull_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: D_ffull_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%D_ffull_standard(ss%n_d_einj_standard))
     ss%D_ffull_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_d_einj_standard)
  IF(ALLOCATED(ss%D_fhalf_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%D_fhalf_standard)
  ENDIF
  IF(ALLOCATED(ss%D_fhalf_standard)) then
     jsize = SIZE(ss%D_fhalf_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: D_fhalf_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%D_fhalf_standard(ss%n_d_einj_standard))
     ss%D_fhalf_standard = 0.0_rspec
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%e0_av).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%e0_av)
  ENDIF
  IF(ALLOCATED(ss%e0_av)) then
     jsize = SIZE(ss%e0_av)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: e0_av already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%e0_av(ss%ngsc0))
     ss%e0_av = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%ecrf_src_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ecrf_src_name)
  ENDIF
  IF(ALLOCATED(ss%ecrf_src_name)) then
     jsize = SIZE(ss%ecrf_src_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ecrf_src_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ecrf_src_name(ss%necrf_src))
     ss%ecrf_src_name = " "
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_Beam_Elongation).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_Beam_Elongation)
  ENDIF
  IF(ALLOCATED(ss%EC_Beam_Elongation)) then
     jsize = SIZE(ss%EC_Beam_Elongation)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_Beam_Elongation already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_Beam_Elongation(ss%necrf_src))
     ss%EC_Beam_Elongation = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_Half_Power_Angle).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_Half_Power_Angle)
  ENDIF
  IF(ALLOCATED(ss%EC_Half_Power_Angle)) then
     jsize = SIZE(ss%EC_Half_Power_Angle)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_Half_Power_Angle already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_Half_Power_Angle(ss%necrf_src))
     ss%EC_Half_Power_Angle = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_Omode_Fraction).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_Omode_Fraction)
  ENDIF
  IF(ALLOCATED(ss%EC_Omode_Fraction)) then
     jsize = SIZE(ss%EC_Omode_Fraction)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_Omode_Fraction already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_Omode_Fraction(ss%necrf_src))
     ss%EC_Omode_Fraction = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_phi_aim).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_phi_aim)
  ENDIF
  IF(ALLOCATED(ss%EC_phi_aim)) then
     jsize = SIZE(ss%EC_phi_aim)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_phi_aim already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_phi_aim(ss%necrf_src))
     ss%EC_phi_aim = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_PRINC_CURV_HOR)
  ENDIF
  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) then
     jsize = SIZE(ss%EC_PRINC_CURV_HOR)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_PRINC_CURV_HOR already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_PRINC_CURV_HOR(ss%necrf_src))
     ss%EC_PRINC_CURV_HOR = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_PRINC_CURV_VERT)
  ENDIF
  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) then
     jsize = SIZE(ss%EC_PRINC_CURV_VERT)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_PRINC_CURV_VERT already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_PRINC_CURV_VERT(ss%necrf_src))
     ss%EC_PRINC_CURV_VERT = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_PRINC_WIDTH_HOR)
  ENDIF
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) then
     jsize = SIZE(ss%EC_PRINC_WIDTH_HOR)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_PRINC_WIDTH_HOR already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_PRINC_WIDTH_HOR(ss%necrf_src))
     ss%EC_PRINC_WIDTH_HOR = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_PRINC_WIDTH_VERT)
  ENDIF
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) then
     jsize = SIZE(ss%EC_PRINC_WIDTH_VERT)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_PRINC_WIDTH_VERT already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_PRINC_WIDTH_VERT(ss%necrf_src))
     ss%EC_PRINC_WIDTH_VERT = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%EC_theta_aim).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%EC_theta_aim)
  ENDIF
  IF(ALLOCATED(ss%EC_theta_aim)) then
     jsize = SIZE(ss%EC_theta_aim)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: EC_theta_aim already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%EC_theta_aim(ss%necrf_src))
     ss%EC_theta_aim = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%ee_mobility_factor).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ee_mobility_factor)
  ENDIF
  IF(ALLOCATED(ss%ee_mobility_factor)) then
     jsize = SIZE(ss%ee_mobility_factor)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ee_mobility_factor already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ee_mobility_factor(ss%nrho_anomth))
     ss%ee_mobility_factor = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Einj_max).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Einj_max)
  ENDIF
  IF(ALLOCATED(ss%Einj_max)) then
     jsize = SIZE(ss%Einj_max)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Einj_max already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Einj_max(ss%nbeam))
     ss%Einj_max = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Einj_min).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Einj_min)
  ENDIF
  IF(ALLOCATED(ss%Einj_min)) then
     jsize = SIZE(ss%Einj_min)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Einj_min already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Einj_min(ss%nbeam))
     ss%Einj_min = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%elong).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%elong)
  ENDIF
  IF(ALLOCATED(ss%elong)) then
     jsize = SIZE(ss%elong)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: elong already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%elong(ss%nrho_eq_geo))
     ss%elong = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_beam)
  IF(ALLOCATED(ss%eperp_beami).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eperp_beami)
  ENDIF
  IF(ALLOCATED(ss%eperp_beami)) then
     jsize = SIZE(ss%eperp_beami)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eperp_beami already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eperp_beami(ss%nrho_nbi-1,ss%nspec_beam))
     ss%eperp_beami = 0.0_rspec
     ALLOCATE(ss%id_eperp_beami(ss%nspec_beam))
     ss%id_eperp_beami = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%eperp_fusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eperp_fusi)
  ENDIF
  IF(ALLOCATED(ss%eperp_fusi)) then
     jsize = SIZE(ss%eperp_fusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eperp_fusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eperp_fusi(ss%nrho_fus-1,ss%nspec_fusion))
     ss%eperp_fusi = 0.0_rspec
     ALLOCATE(ss%id_eperp_fusi(ss%nspec_fusion))
     ss%id_eperp_fusi = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nspec_rfmin)
  IF(ALLOCATED(ss%eperp_mini).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eperp_mini)
  ENDIF
  IF(ALLOCATED(ss%eperp_mini)) then
     jsize = SIZE(ss%eperp_mini)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eperp_mini already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eperp_mini(ss%nrho_icrf-1,ss%nspec_rfmin))
     ss%eperp_mini = 0.0_rspec
     ALLOCATE(ss%id_eperp_mini(ss%nspec_rfmin))
     ss%id_eperp_mini = 0
  ENDIF

  isize = (ss%nrho_rw-1)
  IF(ALLOCATED(ss%eperp_rw).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eperp_rw)
  ENDIF
  IF(ALLOCATED(ss%eperp_rw)) then
     jsize = SIZE(ss%eperp_rw)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eperp_rw already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eperp_rw(ss%nrho_rw-1))
     ss%eperp_rw = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_beam)
  IF(ALLOCATED(ss%epll_beami).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%epll_beami)
  ENDIF
  IF(ALLOCATED(ss%epll_beami)) then
     jsize = SIZE(ss%epll_beami)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: epll_beami already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%epll_beami(ss%nrho_nbi-1,ss%nspec_beam))
     ss%epll_beami = 0.0_rspec
     ALLOCATE(ss%id_epll_beami(ss%nspec_beam))
     ss%id_epll_beami = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%epll_fusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%epll_fusi)
  ENDIF
  IF(ALLOCATED(ss%epll_fusi)) then
     jsize = SIZE(ss%epll_fusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: epll_fusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%epll_fusi(ss%nrho_fus-1,ss%nspec_fusion))
     ss%epll_fusi = 0.0_rspec
     ALLOCATE(ss%id_epll_fusi(ss%nspec_fusion))
     ss%id_epll_fusi = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nspec_rfmin)
  IF(ALLOCATED(ss%epll_mini).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%epll_mini)
  ENDIF
  IF(ALLOCATED(ss%epll_mini)) then
     jsize = SIZE(ss%epll_mini)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: epll_mini already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%epll_mini(ss%nrho_icrf-1,ss%nspec_rfmin))
     ss%epll_mini = 0.0_rspec
     ALLOCATE(ss%id_epll_mini(ss%nspec_rfmin))
     ss%id_epll_mini = 0
  ENDIF

  isize = (ss%nrho_rw-1)
  IF(ALLOCATED(ss%epll_rw).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%epll_rw)
  ENDIF
  IF(ALLOCATED(ss%epll_rw)) then
     jsize = SIZE(ss%epll_rw)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: epll_rw already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%epll_rw(ss%nrho_rw-1))
     ss%epll_rw = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%Epot).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Epot)
  ENDIF
  IF(ALLOCATED(ss%Epot)) then
     jsize = SIZE(ss%Epot)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Epot already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Epot(ss%nrho))
     ss%Epot = 0.0_rspec
  ENDIF

  isize = (ss%neqmom)
  IF(ALLOCATED(ss%eqmom_num).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eqmom_num)
  ENDIF
  IF(ALLOCATED(ss%eqmom_num)) then
     jsize = SIZE(ss%eqmom_num)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eqmom_num already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eqmom_num(ss%neqmom))
     ss%eqmom_num = " "
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%eta_parallel).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%eta_parallel)
  ENDIF
  IF(ALLOCATED(ss%eta_parallel)) then
     jsize = SIZE(ss%eta_parallel)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: eta_parallel already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%eta_parallel(ss%nrho))
     ss%eta_parallel = 0.0_rspec
  ENDIF

  isize = (ss%nefi_anom)
  IF(ALLOCATED(ss%E_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%E_anom)
  ENDIF
  IF(ALLOCATED(ss%E_anom)) then
     jsize = SIZE(ss%E_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: E_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%E_anom(ss%nefi_anom))
     ss%E_anom = 0.0_rspec
  ENDIF

  isize = (ss%nefi_anom2)
  IF(ALLOCATED(ss%E_anom2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%E_anom2)
  ENDIF
  IF(ALLOCATED(ss%E_anom2)) then
     jsize = SIZE(ss%E_anom2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: E_anom2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%E_anom2(ss%nefi_anom2))
     ss%E_anom2 = 0.0_rspec
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_bpass_co).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_bpass_co)
  ENDIF
  IF(ALLOCATED(ss%fidiff_bpass_co)) then
     jsize = SIZE(ss%fidiff_bpass_co)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_bpass_co already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_bpass_co(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_bpass_co = 0.0_rspec
     ALLOCATE(ss%id_fidiff_bpass_co(ss%nspec_fusion))
     ss%id_fidiff_bpass_co = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_bpass_ctr).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_bpass_ctr)
  ENDIF
  IF(ALLOCATED(ss%fidiff_bpass_ctr)) then
     jsize = SIZE(ss%fidiff_bpass_ctr)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_bpass_ctr already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_bpass_ctr(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_bpass_ctr = 0.0_rspec
     ALLOCATE(ss%id_fidiff_bpass_ctr(ss%nspec_fusion))
     ss%id_fidiff_bpass_ctr = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_btrap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_btrap)
  ENDIF
  IF(ALLOCATED(ss%fidiff_btrap)) then
     jsize = SIZE(ss%fidiff_btrap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_btrap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_btrap(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_btrap = 0.0_rspec
     ALLOCATE(ss%id_fidiff_btrap(ss%nspec_fusion))
     ss%id_fidiff_btrap = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_dpass_co).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_dpass_co)
  ENDIF
  IF(ALLOCATED(ss%fidiff_dpass_co)) then
     jsize = SIZE(ss%fidiff_dpass_co)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_dpass_co already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_dpass_co(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_dpass_co = 0.0_rspec
     ALLOCATE(ss%id_fidiff_dpass_co(ss%nspec_fusion))
     ss%id_fidiff_dpass_co = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_dpass_ctr).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_dpass_ctr)
  ENDIF
  IF(ALLOCATED(ss%fidiff_dpass_ctr)) then
     jsize = SIZE(ss%fidiff_dpass_ctr)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_dpass_ctr already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_dpass_ctr(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_dpass_ctr = 0.0_rspec
     ALLOCATE(ss%id_fidiff_dpass_ctr(ss%nspec_fusion))
     ss%id_fidiff_dpass_ctr = 0
  ENDIF

  isize = (ss%nefi_anom2)*(ss%nrho_anom2)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%fidiff_dtrap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fidiff_dtrap)
  ENDIF
  IF(ALLOCATED(ss%fidiff_dtrap)) then
     jsize = SIZE(ss%fidiff_dtrap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fidiff_dtrap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fidiff_dtrap(ss%nefi_anom2,ss%nrho_anom2,ss%nspec_fusion))
     ss%fidiff_dtrap = 0.0_rspec
     ALLOCATE(ss%id_fidiff_dtrap(ss%nspec_fusion))
     ss%id_fidiff_dtrap = 0
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%Fi_depletion).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Fi_depletion)
  ENDIF
  IF(ALLOCATED(ss%Fi_depletion)) then
     jsize = SIZE(ss%Fi_depletion)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Fi_depletion already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Fi_depletion(ss%nrho-1))
     ss%Fi_depletion = 0.0_rspec
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%fracmin).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fracmin)
  ENDIF
  IF(ALLOCATED(ss%fracmin)) then
     jsize = SIZE(ss%fracmin)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fracmin already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fracmin(ss%nspec_rfmin))
     ss%fracmin = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%fracpslh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%fracpslh)
  ENDIF
  IF(ALLOCATED(ss%fracpslh)) then
     jsize = SIZE(ss%fracpslh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: fracpslh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%fracpslh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%fracpslh = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%frac_full).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%frac_full)
  ENDIF
  IF(ALLOCATED(ss%frac_full)) then
     jsize = SIZE(ss%frac_full)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: frac_full already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%frac_full(ss%nbeam))
     ss%frac_full = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%frac_half).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%frac_half)
  ENDIF
  IF(ALLOCATED(ss%frac_half)) then
     jsize = SIZE(ss%frac_half)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: frac_half already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%frac_half(ss%nbeam))
     ss%frac_half = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%freq_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_drbm)
  ENDIF
  IF(ALLOCATED(ss%freq_drbm)) then
     jsize = SIZE(ss%freq_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_drbm(ss%nrho_anomth))
     ss%freq_drbm = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%freq_ec).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_ec)
  ENDIF
  IF(ALLOCATED(ss%freq_ec)) then
     jsize = SIZE(ss%freq_ec)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_ec already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_ec(ss%necrf_src))
     ss%freq_ec = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%freq_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_glf)
  ENDIF
  IF(ALLOCATED(ss%freq_glf)) then
     jsize = SIZE(ss%freq_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_glf(ss%nrho_anomth))
     ss%freq_glf = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%freq_ic).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_ic)
  ENDIF
  IF(ALLOCATED(ss%freq_ic)) then
     jsize = SIZE(ss%freq_ic)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_ic already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_ic(ss%nicrf_src))
     ss%freq_ic = 0.0_rspec
  ENDIF

  isize = (ss%nlhrf_src)
  IF(ALLOCATED(ss%freq_lh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_lh)
  ENDIF
  IF(ALLOCATED(ss%freq_lh)) then
     jsize = SIZE(ss%freq_lh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_lh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_lh(ss%nlhrf_src))
     ss%freq_lh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%freq_max_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_max_tglf)
  ENDIF
  IF(ALLOCATED(ss%freq_max_tglf)) then
     jsize = SIZE(ss%freq_max_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_max_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_max_tglf(ss%nrho_anomth))
     ss%freq_max_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_mmm)
  IF(ALLOCATED(ss%freq_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_mmm71)
  ENDIF
  IF(ALLOCATED(ss%freq_mmm71)) then
     jsize = SIZE(ss%freq_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_mmm71(ss%nrho_anomth,ss%nky_mmm))
     ss%freq_mmm71 = 0.0_rspec
     ALLOCATE(ss%id_freq_mmm71(ss%nky_mmm))
     ss%id_freq_mmm71 = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%freq_mtm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_mtm)
  ENDIF
  IF(ALLOCATED(ss%freq_mtm)) then
     jsize = SIZE(ss%freq_mtm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_mtm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_mtm(ss%nrho_anomth))
     ss%freq_mtm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%freq_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%freq_tglf)
  ENDIF
  IF(ALLOCATED(ss%freq_tglf)) then
     jsize = SIZE(ss%freq_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: freq_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%freq_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%freq_tglf = 0.0_rspec
     ALLOCATE(ss%id_freq_tglf(ss%nky_anomth))
     ss%id_freq_tglf = 0
  ENDIF

  isize = (ss%mmodes)*(ss%ndelta_w)
  IF(ALLOCATED(ss%gamma_lmhd).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gamma_lmhd)
  ENDIF
  IF(ALLOCATED(ss%gamma_lmhd)) then
     jsize = SIZE(ss%gamma_lmhd)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gamma_lmhd already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gamma_lmhd(ss%mmodes,ss%ndelta_w))
     ss%gamma_lmhd = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gamma_nc).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gamma_nc)
  ENDIF
  IF(ALLOCATED(ss%gamma_nc)) then
     jsize = SIZE(ss%gamma_nc)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gamma_nc already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gamma_nc(ss%nrho_eq_geo))
     ss%gamma_nc = 0.0_rspec
  ENDIF

  isize = (ss%ngsc0)
  IF(ALLOCATED(ss%gas_atom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gas_atom)
  ENDIF
  IF(ALLOCATED(ss%gas_atom)) then
     jsize = SIZE(ss%gas_atom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gas_atom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gas_atom(ss%ngsc0))
     ss%gas_atom = " "
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gb1).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gb1)
  ENDIF
  IF(ALLOCATED(ss%gb1)) then
     jsize = SIZE(ss%gb1)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gb1 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gb1(ss%nrho_eq_geo))
     ss%gb1 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gb2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gb2)
  ENDIF
  IF(ALLOCATED(ss%gb2)) then
     jsize = SIZE(ss%gb2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gb2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gb2(ss%nrho_eq_geo))
     ss%gb2 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gb2i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gb2i)
  ENDIF
  IF(ALLOCATED(ss%gb2i)) then
     jsize = SIZE(ss%gb2i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gb2i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gb2i(ss%nrho_eq_geo))
     ss%gb2i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gbr2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gbr2)
  ENDIF
  IF(ALLOCATED(ss%gbr2)) then
     jsize = SIZE(ss%gbr2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gbr2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gbr2(ss%nrho_eq_geo))
     ss%gbr2 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gncfb2h).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gncfb2h)
  ENDIF
  IF(ALLOCATED(ss%gncfb2h)) then
     jsize = SIZE(ss%gncfb2h)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gncfb2h already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gncfb2h(ss%nrho_eq_geo))
     ss%gncfb2h = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gncfh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gncfh)
  ENDIF
  IF(ALLOCATED(ss%gncfh)) then
     jsize = SIZE(ss%gncfh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gncfh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gncfh(ss%nrho_eq_geo))
     ss%gncfh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gr1).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gr1)
  ENDIF
  IF(ALLOCATED(ss%gr1)) then
     jsize = SIZE(ss%gr1)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gr1 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gr1(ss%nrho_eq_geo))
     ss%gr1 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gr2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gr2)
  ENDIF
  IF(ALLOCATED(ss%gr2)) then
     jsize = SIZE(ss%gr2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gr2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gr2(ss%nrho_eq_geo))
     ss%gr2 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gr2i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gr2i)
  ENDIF
  IF(ALLOCATED(ss%gr2i)) then
     jsize = SIZE(ss%gr2i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gr2i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gr2i(ss%nrho_eq_geo))
     ss%gr2i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gr2rho2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gr2rho2)
  ENDIF
  IF(ALLOCATED(ss%gr2rho2)) then
     jsize = SIZE(ss%gr2rho2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gr2rho2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gr2rho2(ss%nrho_eq_geo))
     ss%gr2rho2 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%gr3i).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%gr3i)
  ENDIF
  IF(ALLOCATED(ss%gr3i)) then
     jsize = SIZE(ss%gr3i)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: gr3i already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%gr3i(ss%nrho_eq_geo))
     ss%gr3i = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grho1).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grho1)
  ENDIF
  IF(ALLOCATED(ss%grho1)) then
     jsize = SIZE(ss%grho1)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grho1 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grho1(ss%nrho_eq_geo))
     ss%grho1 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%grho2).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%grho2)
  ENDIF
  IF(ALLOCATED(ss%grho2)) then
     jsize = SIZE(ss%grho2)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: grho2 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%grho2(ss%nrho_eq_geo))
     ss%grho2 = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_2

subroutine splitn_write(fname,ios)

  !  WRITE a TRANSP namelist to file...

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: fname     ! filename
  integer, intent(out) :: ios            ! completion status code, 0=OK

  !--------------------------------------

  call write_nl(fname,ios)

end subroutine splitn_write

subroutine splitn_write_with_removals(fname,nd,dlist,ios)

  !  WRITE a TRANSP namelist to file, commenting out items dlist(1:nd)
  !  namelist is read back for test purposes and to restore self consistency
  !  of memory representation.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: fname     ! filename
  integer, intent(in) :: nd              ! size of list of deletion names
  character*(*), intent(in) :: dlist(nd) ! names of items to delete
  integer, intent(out) :: ios            ! completion status code, 0=OK

  !--------------------------------------
  character*32 :: dtest1,dtest2
  integer :: i,j,k,imatch,icn1,icn2
  character*150 :: locbuf
  !--------------------------------------

  do i=1,nlines
     j=ordl(i)
     if(eqsfld(j).gt.0) then

        !  name field present in text line; get name
        icn1 = namfld(1,j)
        icn2 = namfld(2,j)
        dtest1 = textnl(j)(icn1:icn2)
        call uupper(dtest1)  ! uppercase

        !  is name in the deletion list?
        imatch = 0
        do k=1,nd
           dtest2 = dlist(k)
           call uupper(dtest2)  ! uppercase
           if(dtest1.eq.dtest2) then
              imatch = k
              exit
           endif
        enddo

        if(imatch.gt.0) then
           !  comment it out
           locbuf = ' !!(ptransp) '//trim(textnl(j))
           textnl(j) = locbuf
           lenl(j) = len(trim(locbuf))
        endif
     endif
  enddo

  ! write...

  call write_nl(fname,ios)

  if(ios.ne.0) then
     write(6,*) ' ?splitn_write_with_removals: error during write... '

  else
     ! read back...

     write(6,*) ' =>splitn_write_with_removals: write OK, readback... '
     call read_nl(fname,ios)
     if(ios.ne.0) then
        write(6,*) ' ?splitn_write_with_removals: error on read back... '
     else
        write(6,*) ' =>splitn_write_with_removals: readback OK... '
     endif
  endif

end subroutine splitn_write_with_removals  

subroutine splitn_write_alt(fname,ios)

  !  WRITE a TRANSP namelist into the splitn_module ...
  !  USING alternate information 

  !  *** this is for debugging only ***

  !  generally the output of this should match the output of a
  !  splitn_write call, but some style changes (handling of comma-
  !  delimiters for example) could occur

  !  specifically, it is known that splitn_write and splitn_write_alt
  !  output won't match if any of the following are true:
  !    a) there are tabs (ctrl^I's) in the input namelist file (tabs
  !       are allowed, but not tracked in the data arrays used here).
  !    b) there are quantities whose values are assigned more than once
  !       in the namelist file (warnings are also generated), even if the
  !       duplicate assignment does not change the value.  A blank field
  !       will appear in the test output.
  !    c) there are instances where the last character of a value
  !       (not the last value on the line) and subsequent delimitting
  !       comma are separated by whitespace (legal but not tracked).
  !    d) thare are instances where the last value on an input line is
  !       followed by a comma (which is legal but not required, and not
  !       saved in the data arrays used by splitn_write_alt).

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: fname     ! filename
  integer, intent(out) :: ios            ! completion status code, 0=OK

  !--------------------------------------
  integer ilf,i,j,k,istop,ilinp,ilinq
  character*150, dimension(:), allocatable :: ztext
  !--------------------------------------

  open(unit=lun,file=fname,status='old',iostat=ios)
  if(ios.eq.0) then
     ! file exists: rename it
     close(unit=lun)
     ilf=len_trim(fname)
     call frename(fname(1:ilf),fname(1:ilf)//'~',ios)
  endif

  open(unit=lun,file=fname,status='new',iostat=ios)
  if(ios.ne.0) return

  !------------> allocate temporary array; set to blank

  allocate(ztext(nlines)); ztext=' '

  !------------> put LHS and equal signs in place

  do i=1,nlines
     j=ordl(i)
     if(eqsfld(j).gt.0) then
        k=eqsfld(j)
        ztext(i)(k:k)='='
        nam1=namfld(1,j)
        nam2=namfld(2,j)
        ztext(i)(nam1:nam2)=textnl(j)(nam1:nam2)
     endif
  enddo

  !------------> insert values with repeat counts & trailing commas

  i=0
  istop=maxlines(0)
  do
     i=i+1
     if(i.gt.istop) exit

     ilinp=ilines(i)
     if(ilinp.eq.0) cycle

     ilinq=ordl(ilinp)

     if(krepeat(i).gt.0) then
        val1=irrange(1,i)
        val2=ivrange(2,i)
        ztext(ilinp)(val1:val2+1)=textnl(ilinq)(val1:irrange(2,i))// &
             textnl(ilinq)(ivrange(1,i):val2)//','
        i=i+krepeat(i)-1
     else
        val1=ivrange(1,i)
        val2=ivrange(2,i)
        ztext(ilinp)(val1:val2+1)=textnl(ilinq)(val1:val2)//','
     endif
  enddo

  !------------> erase end-of-line trailing commas

  do i=1,nlines
     j = max(1,len_trim(ztext(i)))
     if(ztext(i)(j:j).eq.',') ztext(i)(j:j)=' '
  enddo

  !------------> put comments in place

  do i=1,nlines
     j=ordl(i)
     if(cmtfld(j).gt.0) then
        ztext(i)(cmtfld(j):) = textnl(j)(cmtfld(j):)
     endif
  enddo

  !------------> write

  do i=1,nlines
     j = max(1,len_trim(ztext(i)))
     write(lun,'(A)') ztext(i)(1:j)
  enddo

  close(unit=lun)

end subroutine splitn_write_alt

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_8(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_transcat
        w%list_elems(isize) = "tq_transcat"
        w%elem_descr(isize) = "toroidal angular momentum transport"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho-1,ntrcat)"
        IF(ALLOCATED(ss%tq_transcat)) THEN
           IF(ss%hash_codes(ps_phash_tq_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang
        w%list_elems(isize) = "triang"
        w%elem_descr(isize) = "triangularity (symmetrized)"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triang)) THEN
           IF(ss%hash_codes(ps_phash_triang).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triangL
        w%list_elems(isize) = "triangL"
        w%elem_descr(isize) = "lower triangularity"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triangL)) THEN
           IF(ss%hash_codes(ps_phash_triangL).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triangU
        w%list_elems(isize) = "triangU"
        w%elem_descr(isize) = "upper triangularity"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triangU)) THEN
           IF(ss%hash_codes(ps_phash_triangU).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang_miller_L
        w%list_elems(isize) = "triang_miller_L"
        w%elem_descr(isize) = "Miller lower triangularity"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triang_miller_L)) THEN
           IF(ss%hash_codes(ps_phash_triang_miller_L).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang_miller_U
        w%list_elems(isize) = "triang_miller_U"
        w%elem_descr(isize) = "Miller upper triangularity"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triang_miller_U)) THEN
           IF(ss%hash_codes(ps_phash_triang_miller_U).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Ts
        w%list_elems(isize) = "Ts"
        w%elem_descr(isize) = "thermal specie temperature"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%Ts)) THEN
           IF(ss%hash_codes(ps_phash_Ts).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NS"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tzflux_ky_tglf
        w%list_elems(isize) = "tzflux_ky_tglf"
        w%elem_descr(isize) = "impurity density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%tzflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_tzflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tz_ky_tglf
        w%list_elems(isize) = "tz_ky_tglf"
        w%elem_descr(isize) = "impurity density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%tz_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_tz_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_ns
        w%list_elems(isize) = "upwind_pfrac_ns"
        w%elem_descr(isize) = "specie density forward upwind fractions"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho,0:nspec_th)"
        IF(ALLOCATED(ss%upwind_pfrac_ns)) THEN
           IF(ss%hash_codes(ps_phash_upwind_pfrac_ns).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_omega
        w%list_elems(isize) = "upwind_pfrac_omega"
        w%elem_descr(isize) = "omega (ang. velocity) forward upwind fraction"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%upwind_pfrac_omega)) THEN
           IF(ss%hash_codes(ps_phash_upwind_pfrac_omega).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_Te
        w%list_elems(isize) = "upwind_pfrac_Te"
        w%elem_descr(isize) = "Te (electron energy advection) forward upwind fraction"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%upwind_pfrac_Te)) THEN
           IF(ss%hash_codes(ps_phash_upwind_pfrac_Te).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_Ti
        w%list_elems(isize) = "upwind_pfrac_Ti"
        w%elem_descr(isize) = "Ti (ion energy advection) forward upwind fraction"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%upwind_pfrac_Ti)) THEN
           IF(ss%hash_codes(ps_phash_upwind_pfrac_Ti).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vee_trans
        w%list_elems(isize) = "vee_trans"
        w%elem_descr(isize) = "electron energy radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%vee_trans)) THEN
           IF(ss%hash_codes(ps_phash_vee_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vee_transcat
        w%list_elems(isize) = "vee_transcat"
        w%elem_descr(isize) = "Electron energy radial velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%vee_transcat)) THEN
           IF(ss%hash_codes(ps_phash_vee_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_fusi
        w%list_elems(isize) = "velb_fusi"
        w%elem_descr(isize) = "fusion ion anom. radial velocity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%velb_fusi)) THEN
           IF(ss%hash_codes(ps_phash_velb_fusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_nbi
        w%list_elems(isize) = "velb_nbi"
        w%elem_descr(isize) = "beam ion anom. radial velocity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%velb_nbi)) THEN
           IF(ss%hash_codes(ps_phash_velb_nbi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_rfmi
        w%list_elems(isize) = "velb_rfmi"
        w%elem_descr(isize) = "RF minority ion anom. radial velocity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%velb_rfmi)) THEN
           IF(ss%hash_codes(ps_phash_velb_rfmi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velne_nclass
        w%list_elems(isize) = "velne_nclass"
        w%elem_descr(isize) = "electron-density-equations, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velne_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velne_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velnh_nclass
        w%list_elems(isize) = "velnh_nclass"
        w%elem_descr(isize) = "main-hydrogenic-density-equations, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velnh_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velnh_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velni_drbm
        w%list_elems(isize) = "velni_drbm"
        w%elem_descr(isize) = "ion convective velocity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velni_drbm)) THEN
           IF(ss%hash_codes(ps_phash_velni_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_anom
        w%list_elems(isize) = "velns_anom"
        w%elem_descr(isize) = "density-equations, advective velocity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_anom)) THEN
           IF(ss%hash_codes(ps_phash_velns_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_glf
        w%list_elems(isize) = "velns_glf"
        w%elem_descr(isize) = "density-equations, advective velocity term from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_glf)) THEN
           IF(ss%hash_codes(ps_phash_velns_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_gtcneo
        w%list_elems(isize) = "velns_gtcneo"
        w%elem_descr(isize) = "density-equations, advective velocity term from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_velns_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_mmm71
        w%list_elems(isize) = "velns_mmm71"
        w%elem_descr(isize) = "density-equations, advective velocity term from MMM71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_velns_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_nclass
        w%list_elems(isize) = "velns_nclass"
        w%elem_descr(isize) = "density-equations, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velns_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_neo
        w%list_elems(isize) = "velns_neo"
        w%elem_descr(isize) = "density-equations, advective velocity term from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_neo)) THEN
           IF(ss%hash_codes(ps_phash_velns_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_tglf
        w%list_elems(isize) = "velns_tglf"
        w%elem_descr(isize) = "density-equations, advective velocity term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%velns_tglf)) THEN
           IF(ss%hash_codes(ps_phash_velns_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velnx_nclass
        w%list_elems(isize) = "velnx_nclass"
        w%elem_descr(isize) = "main-impurity-density-equations, advective velocity term from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velnx_nclass)) THEN
           IF(ss%hash_codes(ps_phash_velnx_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_anom
        w%list_elems(isize) = "velpphi_anom"
        w%elem_descr(isize) = "momentum-equation, advective velocity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_anom)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_glf
        w%list_elems(isize) = "velpphi_glf"
        w%elem_descr(isize) = "momentum-equation, advective velocity term from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_glf)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_gtcneo
        w%list_elems(isize) = "velpphi_gtcneo"
        w%elem_descr(isize) = "momentum-equation, advective velocity term from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_mmm71
        w%list_elems(isize) = "velpphi_mmm71"
        w%elem_descr(isize) = "momentum-equation, advective velocity term from MMM71 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_neo
        w%list_elems(isize) = "velpphi_neo"
        w%elem_descr(isize) = "momentum-equation, advective velocity term from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_neo)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_tglf
        w%list_elems(isize) = "velpphi_tglf"
        w%elem_descr(isize) = "momentum-equation, advective velocity term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velpphi_tglf)) THEN
           IF(ss%hash_codes(ps_phash_velpphi_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_anom
        w%list_elems(isize) = "velte_anom"
        w%elem_descr(isize) = "Te-equation, advective velocity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%velte_anom)) THEN
           IF(ss%hash_codes(ps_phash_velte_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_8

subroutine splitn_addwarn(item0,zlist,nlist,iwid,klist,maxlist)

  ! build alphabetic list; discard item without warning if it is a duplicate
  ! or if the maximum list size has been reached.
  !
  ! these are expected to be very short lists so we don't bother with n*log(n)
  ! sorting methods.

  use splitn_module, only: kupdate
  implicit NONE

  character*(*), intent(in) :: item0 ! item to add
  integer, intent(inout) :: nlist    ! current list size (prior to add)
  integer, intent(in) :: iwid        ! width of list elements
  integer, intent(in) :: maxlist     ! maximum list size
  character*(iwid), intent(inout) :: zlist(maxlist)  ! list being added to
  integer, intent(inout) :: klist(maxlist)  ! update block index
  
  !-------------------------------------------

  character*(iwid) item
  integer i,ipos

  !-------------------------------------------

  item=item0

  if(nlist.eq.maxlist) return         ! ignore max length exceeded

  ipos=nlist+1
  do i=1,nlist
     if((item.eq.zlist(i)).and.(kupdate.eq.klist(i))) then
        return  ! ignore duplicates
     endif
     if(item.le.zlist(nlist)) ipos=i
  enddo

  !  insert in list, maintaining alphabetic order

  do i=nlist,ipos,-1
     zlist(i+1)=zlist(i)
     klist(i+1)=klist(i)
  enddo

  zlist(ipos)=item
  klist(ipos)=kupdate

  nlist=nlist+1

end subroutine splitn_addwarn

! MODIFICATION -- DMC March 2009 -- account for namelist update blocks
!   if the zname argument is appended with an update index reference of the
!   form "[<num>]", this means, fetch the namelist value from the <num>'th
!   update block.  If this construct is "[0]" or omitted, fetch the initial
!   namelist value (as before).

subroutine splitn_iget(zname,isize,array,ierr)

  !  get an INTEGER namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  integer, intent(out) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_iget',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  iblock=max(0,min(nupdate,iblock))

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_iget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_iget: not an INTEGER object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_iget: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
  else
     ii=nint + (iblock-1)*nint_st + varlist(jj)%addr_st
  endif

  ierr = 0
  array = intbuf(ii:ii+isize-1)

end subroutine splitn_iget

subroutine splitn_lget(zname,isize,array,ierr)

  !  get a LOGICAL namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  logical, intent(out) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = .FALSE.

  call splitn_bdecode1('splitn_lget',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  iblock=max(0,min(nupdate,iblock))

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_lget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_lget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lget: not a LOGICAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_lget: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
  else
     ii=nlog + (iblock-1)*nlog_st + varlist(jj)%addr_st
  endif

  ierr = 0
  array = logbuf(ii:ii+isize-1)

end subroutine splitn_lget

subroutine splitn_rget(zname,isize,array,ierr)

  !  get an REAL namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real, intent(out) :: array(isize)     ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_rget',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  iblock=max(0,min(nupdate,iblock))

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_rget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_rget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'R') then
     write(6,*) '?splitn_rget: not a REAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_rget: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
  else
     ii=nreal + (iblock-1)*nreal_st + varlist(jj)%addr_st
  endif

  ierr = 0
  array = rbuf(ii:ii+isize-1)

end subroutine splitn_rget

subroutine splitn_dget(zname,isize,array,ierr)

  !  get an REAL*8 namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real*8, intent(out) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_dget',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  iblock=max(0,min(nupdate,iblock))

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_dget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_dget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'D') then
     write(6,*) '?splitn_dget: not a REAL*8 object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_dget: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
  else
     ii=nr8 + (iblock-1)*nr8_st + varlist(jj)%addr_st
  endif

  ierr = 0
  array = dbuf(ii:ii+isize-1)

end subroutine splitn_dget

subroutine splitn_cget(zname,iwid,isize,array,ierr)

  !  get an CHARACTER*n namelist object
  !  isize *must* match the actual size of the object.
  !  iwid must be .ge. the actual width of object elements.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: iwid           ! width of object array elements
  integer, intent(in) :: isize          ! size of object (# of elements)
  character*(iwid), intent(out) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = ' '

  call splitn_bdecode1('splitn_cget',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  iblock=max(0,min(nupdate,iblock))

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_cget: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_cget: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_cget: not a CHARACTER*nn object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_cget: array size mismatch: expected=',isize, &
          ' found=',ii
     return
  endif

  if(iwid.lt.varlist(jj)%chsize) then
     write(6,*) '?splitn_cget: passed character element size too small: ', &
          'have=',iwid,' need=',varlist(jj)%chsize
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
  else
     ii=nchv + (iblock-1)*nchv_st + varlist(jj)%addr_st
  endif

  ierr = 0
  do i=1,isize
     array(i) = chbuf(ii+i-1)
  enddo

end subroutine splitn_cget

subroutine tdb_find_next_sawtime(d,zprev_time,ztime)

  ! get the next sawtooth time -- a time greater than zprev_time but
  ! also between TINIT and FTIME.  If no such time exists, a very large
  ! value us returned for ztime; all times in SECONDS

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  real*8, intent(in) :: zprev_time   ! preceding time (input)
  real*8, intent(inout) :: ztime     ! time found or a huge time (output)

  !----------
  integer :: it
  real*8 :: ztnext
  real*8, parameter :: zlarge = 1.0D34
  !----------

  if(d%ltsaw.eq.0) then
     ztime = zlarge      ! in this case there are no sawteeth, ever
  else if (d%datbuf(d%ltsaw+d%ntsaw-1).le.zprev_time) then
     ztime = zlarge      ! no more sawteeth
  else
     ! find the next sawtooth.  This is not an efficient search.  It can be
     ! improved should that ever be necessary.
     do it = 1,d%ntsaw
        ztnext = d%datbuf(d%ltsaw+it-1)
        if(ztnext.gt.zprev_time) then
           ztime = ztnext
           exit
        endif
     enddo
  endif

end subroutine tdb_find_next_sawtime

subroutine tdb_num_sawtimes(d,ntsaw)
  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(out) :: ntsaw  ! number of sawtooth times in trdat buffer

  ntsaw = d%ntsaw
end subroutine tdb_num_sawtimes

subroutine tdb_sawtimes(d,ztimes,inum)
  use trdatbuf_obj
  implicit NONE

  !  return sawtooth times; print warning if inum does not match the
  !  actual number.  If inum is too small, the first inum sawtooth times
  !  are returned; if inum is too large, the extra array elements are set
  !  to a large number.

  type (trdatbuf) :: d
  integer, intent(in) :: inum
  real*8, intent(out) :: ztimes(inum)

  integer :: inuma,lunmsg_tdb
  real*8, parameter :: zlarge = 1.0d34

  if(inum.ne.d%ntsaw) then
     write(lunmsg_tdb(0),*) ' %tdb_sawtimes warning: argument inum=',inum
     write(lunmsg_tdb(0),*) '  this does not match the number of sawtooth'
     write(lunmsg_tdb(0),*) '  event times in the trdat buffer: ',d%ntsaw
     if(inum.gt.d%ntsaw) then
        ztimes(d%ntsaw+1:inum)=zlarge
     endif
  endif

  inuma=min(inum,d%ntsaw)
  ztimes(1:inuma)=d%datbuf(d%ltsaw:d%ltsaw+inuma-1)
end subroutine tdb_sawtimes

subroutine tdb_post_sawtime(d,ztime_pre,ztime_post,iwarn)

  !  given event start (SAWTOOTH) time return event end time

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  real*8, intent(in) :: ztime_pre   ! time at start of event
  real*8, intent(out) :: ztime_post ! time at end of event
  integer, intent(out) :: iwarn     ! 0=OK; 1=no sawtooth events
                                    ! 2= sawtooth events exist but ztime_pre
                                    !    does not match any of them...

  !  if the warning flag is set to a non-zero value, ztime_post = ztime_pre
  !  is returned.

  !---------------------
  real*8 :: zdt_avg, zdt_min, zdt_tol, zdt_fnd
  integer :: ilt,int,ilas,it
  !---------------------

  if(d%nsawflag.ne.1) then
     iwarn=1
     ztime_post=ztime_pre
     return
  endif

  ilt=d%ltime2
  int=d%ntime2
  ilas=ilt+int-1

  zdt_avg=(d%datbuf(ilas) - d%datbuf(ilt))/int
  zdt_min=minval(d%datbuf(ilt+1:ilas)-d%datbuf(ilt:ilas-1))
  !  zdt_min should be the sawtooth event duration
  zdt_tol=zdt_min/5

  iwarn=-1
  do it=1,int-1
     if(abs(ztime_pre-d%datbuf(ilt+it-1)).le.zdt_tol) then
        zdt_fnd=d%datbuf(ilt+it)-d%datbuf(ilt+it-1)
        if(zdt_fnd.gt.zdt_min+zdt_tol) then
           iwarn=2
           ztime_post=ztime_pre
        else
           iwarn=0
           ztime_post=d%datbuf(ilt+it)  ! the next time...
        endif
        exit
     endif
  enddo

  if(iwarn.eq.-1) then
     iwarn=2
     ztime_post=ztime_pre
  endif

end subroutine tdb_post_sawtime

subroutine tdb_post_peltime(d,ztime_pre,ztime_post,iwarn)

  !  given event start (PELLET) time return event end time

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  real*8, intent(in) :: ztime_pre   ! time at start of event
  real*8, intent(out) :: ztime_post ! time at end of event
  integer, intent(out) :: iwarn     ! 0=OK; 
                                    ! 2= no such event time found...

  !  if the warning flag is set to a non-zero value, ztime_post = ztime_pre
  !  is returned.

  !---------------------
  real*8 :: zdt_avg, zdt_min, zdt_tol, zdt_fnd
  integer :: ilt,int,ilas,it
  !---------------------

  ilt=d%ltime2
  int=d%ntime2
  ilas=ilt+int-1

  zdt_avg=(d%datbuf(ilas) - d%datbuf(ilt))/int
  zdt_min=minval(d%datbuf(ilt+1:ilas)-d%datbuf(ilt:ilas-1))
  !  zdt_min should be the pellet event duration
  zdt_tol=zdt_min/5

  iwarn=-1
  do it=1,int-1
     if(abs(ztime_pre-d%datbuf(ilt+it-1)).le.zdt_tol) then
        zdt_fnd=d%datbuf(ilt+it)-d%datbuf(ilt+it-1)
        if(zdt_fnd.gt.zdt_min+zdt_tol) then
           iwarn=2
           ztime_post=ztime_pre
        else
           iwarn=0
           ztime_post=d%datbuf(ilt+it)  ! the next time...
        endif
        exit
     endif
  enddo

  if(iwarn.eq.-1) then
     iwarn=2
     ztime_post=ztime_pre
  endif

end subroutine tdb_post_peltime

subroutine trx_psi0(ifind,psi0)

  !  return Psi0 data (poloidal flux diff, mag. axis to machine axis)
  !  if available

  use trx_module
  implicit NONE

  !  result is based on most recently read TRANSP data

  integer, intent(out) :: ifind   ! =1: data available; =0: not available
  real*8,  intent(out) :: Psi0    ! Psi0 data (if ifind=1) or ZERO (if ifind=0)

  !-----------------------

  if(ifound_psi0.eq.1) then
     ifind=1
     Psi0 = Psi0_mhd
  else
     ifind=0
     Psi0 = 0.0d0
  endif

end subroutine trx_psi0

subroutine trx_getlnlim(nlinlm,alnlimR,alnlimZ,alnlimt,ierr)
!
!  read TRANSP line limiter information from namelist
!
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer, intent(in) :: nlinlm        ! expected number of line limiters
!
! output:
!
  real*8 alnlimR(nlinlm),alnlimZ(nlinlm) ! (R,Z) of point on line limiter
  real*8 alnlimt(nlinlm)               ! angle of orientation of line
!
  integer, intent(out) :: ierr         ! completion code, 0=OK
!
!---------------------------------
!
  integer istat
  integer lt,lunzer
!
!---------------------------------
!
  ierr = 0
!
  lt=lunzer(0)
  call tr_getnl_r8vec('ALNLMR',alnlimR,nlinlm,istat)
  if(istat.ne.nlinlm) then
     write(lt,*) ' %trx_getlnlim:  tr_getnl_r8vec(ALNLMR) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=nlinlm=',nlinlm
     if(istat.lt.nlinlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        alnlimR(istat+1:nlinlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
 
!
  call tr_getnl_r8vec('ALNLMY',alnlimZ,nlinlm,istat)
  if(istat.ne.nlinlm) then
     write(lt,*) ' %trx_getlnlim:  tr_getnl_r8vec(ALNLMZ) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=nlinlm=',nlinlm
     if(istat.lt.nlinlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        alnlimZ(istat+1:nlinlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
 
!
  call tr_getnl_r8vec('ALNLMT',alnlimt,nlinlm,istat)
  if(istat.ne.nlinlm) then
     write(lt,*) ' %trx_getlnlim:  tr_getnl_r8vec(ALNLMT) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=nlinlm=',nlinlm
     if(istat.lt.nlinlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        alnlimt(istat+1:nlinlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
 
!
! convert to meters; standardize orientation angle
!
  alnlimR=0.01_R8*alnlimR
  alnlimZ=0.01_R8*alnlimZ
  alnlimt=180.0_R8-alnlimt
!
  return
  end

subroutine trx_wr_stimes(spath,ierr)

  ! write file of sawtooth times -- 1st record = #of sawteeth
  ! subsequently, one time per record

  ! use data recorded in module -- report error if none is found

  use trx_module
  implicit NONE

  character*(*), intent(in) :: spath
  integer, intent(out) :: ierr

  !------------------------------------------
  integer :: it,inum,ilun
  integer :: lunzer
  !------------------------------------------

  ierr=0
  if(.not.allocated(kevent)) then
     write(lunzer(0),*) &
          ' ?trx_wr_stimes: no sawtooth data; connect to run first.'
     ierr=1
     return
  endif

  inum=0
  do it=1,nsctime
     if(kevent(it).eq.2) inum=inum+1
  enddo

  call find_io_unit(ilun)

  open(unit=ilun,file=trim(spath),status='unknown',iostat=ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          ' ?trx_wr_stimes: open failure, filename was: '//trim(spath)
     return
  endif

  write(ilun, &
       '(1x,i5,"  ! #sawteeth (1x,i5) // times (1x,1pe13.6) one per line")') &
       inum

  do it=1,nsctime
     if(kevent(it).eq.2) then
        write(ilun,'(1x,1pe13.6)') time_saw(it)
     endif
  enddo

  close(unit=ilun)

end subroutine trx_wr_stimes

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_8(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nr_rip)*(ss%nz_rip)
  IF(ALLOCATED(ss%tfrip2_log).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tfrip2_log)
  ENDIF
  IF(ALLOCATED(ss%tfrip2_log)) then
     jsize = SIZE(ss%tfrip2_log)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tfrip2_log already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tfrip2_log(ss%nr_rip,ss%nz_rip))
     ss%tfrip2_log = 0.0_rspec
  ENDIF

  isize = (ss%nr_rip)*(ss%nz_rip)
  IF(ALLOCATED(ss%tfrip_log).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tfrip_log)
  ENDIF
  IF(ALLOCATED(ss%tfrip_log)) then
     jsize = SIZE(ss%tfrip_log)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tfrip_log already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tfrip_log(ss%nr_rip,ss%nz_rip))
     ss%tfrip_log = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%thegrilh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%thegrilh)
  ENDIF
  IF(ALLOCATED(ss%thegrilh)) then
     jsize = SIZE(ss%thegrilh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: thegrilh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%thegrilh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%thegrilh = 0.0_rspec
  ENDIF

  isize = (ss%nth_eq)
  IF(ALLOCATED(ss%th_eq).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%th_eq)
  ENDIF
  IF(ALLOCATED(ss%th_eq)) then
     jsize = SIZE(ss%th_eq)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: th_eq already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%th_eq(ss%nth_eq))
     ss%th_eq = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%Ti).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Ti)
  ENDIF
  IF(ALLOCATED(ss%Ti)) then
     jsize = SIZE(ss%Ti)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Ti already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Ti(ss%nrho-1))
     ss%Ti = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%tiflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tiflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%tiflux_ky_tglf)) then
     jsize = SIZE(ss%tiflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tiflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tiflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%tiflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_tiflux_ky_tglf(ss%nky_anomth))
     ss%id_tiflux_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%ti_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ti_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%ti_ky_tglf)) then
     jsize = SIZE(ss%ti_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ti_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ti_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%ti_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_ti_ky_tglf(ss%nky_anomth))
     ss%id_ti_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth-1)
  IF(ALLOCATED(ss%tmodel).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tmodel)
  ENDIF
  IF(ALLOCATED(ss%tmodel)) then
     jsize = SIZE(ss%tmodel)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tmodel already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tmodel(ss%nrho_anomth-1))
     ss%tmodel = 0.0_rspec
  ENDIF

  isize = (ss%nballoon)
  IF(ALLOCATED(ss%Tornum_balcrit).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Tornum_balcrit)
  ENDIF
  IF(ALLOCATED(ss%Tornum_balcrit)) then
     jsize = SIZE(ss%Tornum_balcrit)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Tornum_balcrit already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Tornum_balcrit(ss%nballoon))
     ss%Tornum_balcrit = 0
  ENDIF

  isize = (ss%mmodes)
  IF(ALLOCATED(ss%Tor_mode_label).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Tor_mode_label)
  ENDIF
  IF(ALLOCATED(ss%Tor_mode_label)) then
     jsize = SIZE(ss%Tor_mode_label)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Tor_mode_label already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Tor_mode_label(ss%mmodes))
     ss%Tor_mode_label = " "
  ENDIF

  isize = (ss%mmodes)
  IF(ALLOCATED(ss%Tor_mode_No).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Tor_mode_No)
  ENDIF
  IF(ALLOCATED(ss%Tor_mode_No)) then
     jsize = SIZE(ss%Tor_mode_No)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Tor_mode_No already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Tor_mode_No(ss%mmodes))
     ss%Tor_mode_No = 0
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%tq0_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tq0_reco)
  ENDIF
  IF(ALLOCATED(ss%tq0_reco)) then
     jsize = SIZE(ss%tq0_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tq0_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tq0_reco(ss%nrho_gas-1))
     ss%tq0_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqb0_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqb0_halo)
  ENDIF
  IF(ALLOCATED(ss%tqb0_halo)) then
     jsize = SIZE(ss%tqb0_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqb0_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqb0_halo(ss%nrho_nbi-1))
     ss%tqb0_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqbe).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqbe)
  ENDIF
  IF(ALLOCATED(ss%tqbe)) then
     jsize = SIZE(ss%tqbe)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqbe already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqbe(ss%nrho_nbi-1))
     ss%tqbe = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqbi)
  ENDIF
  IF(ALLOCATED(ss%tqbi)) then
     jsize = SIZE(ss%tqbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqbi(ss%nrho_nbi-1))
     ss%tqbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqbjxb).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqbjxb)
  ENDIF
  IF(ALLOCATED(ss%tqbjxb)) then
     jsize = SIZE(ss%tqbjxb)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqbjxb already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqbjxb(ss%nrho_nbi-1))
     ss%tqbjxb = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqbth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqbth)
  ENDIF
  IF(ALLOCATED(ss%tqbth)) then
     jsize = SIZE(ss%tqbth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqbth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqbth(ss%nrho_nbi-1))
     ss%tqbth = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqcx_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqcx_halo)
  ENDIF
  IF(ALLOCATED(ss%tqcx_halo)) then
     jsize = SIZE(ss%tqcx_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqcx_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqcx_halo(ss%nrho_nbi-1))
     ss%tqcx_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%tqcx_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqcx_reco)
  ENDIF
  IF(ALLOCATED(ss%tqcx_reco)) then
     jsize = SIZE(ss%tqcx_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqcx_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqcx_reco(ss%nrho_gas-1))
     ss%tqcx_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%tqioniz).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqioniz)
  ENDIF
  IF(ALLOCATED(ss%tqioniz)) then
     jsize = SIZE(ss%tqioniz)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqioniz already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqioniz(ss%nrho_gas-1,ss%ngsc0))
     ss%tqioniz = 0.0_rspec
     ALLOCATE(ss%id_tqioniz(ss%ngsc0))
     ss%id_tqioniz = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%tqqcx).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqqcx)
  ENDIF
  IF(ALLOCATED(ss%tqqcx)) then
     jsize = SIZE(ss%tqqcx)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqqcx already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqqcx(ss%nrho_gas-1,ss%ngsc0))
     ss%tqqcx = 0.0_rspec
     ALLOCATE(ss%id_tqqcx(ss%ngsc0))
     ss%id_tqqcx = 0
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%tqsc_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqsc_halo)
  ENDIF
  IF(ALLOCATED(ss%tqsc_halo)) then
     jsize = SIZE(ss%tqsc_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqsc_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqsc_halo(ss%nrho_nbi-1))
     ss%tqsc_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%tqsc_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tqsc_reco)
  ENDIF
  IF(ALLOCATED(ss%tqsc_reco)) then
     jsize = SIZE(ss%tqsc_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tqsc_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tqsc_reco(ss%nrho_gas-1))
     ss%tqsc_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth-1)
  IF(ALLOCATED(ss%tq_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tq_anom)
  ENDIF
  IF(ALLOCATED(ss%tq_anom)) then
     jsize = SIZE(ss%tq_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tq_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tq_anom(ss%nrho_anomth-1))
     ss%tq_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%tq_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tq_trans)
  ENDIF
  IF(ALLOCATED(ss%tq_trans)) then
     jsize = SIZE(ss%tq_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tq_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tq_trans(ss%nrho-1))
     ss%tq_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%ntrcat)
  IF(ALLOCATED(ss%tq_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tq_transcat)
  ENDIF
  IF(ALLOCATED(ss%tq_transcat)) then
     jsize = SIZE(ss%tq_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tq_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tq_transcat(ss%nrho-1,ss%ntrcat))
     ss%tq_transcat = 0.0_rspec
     ALLOCATE(ss%id_tq_transcat(ss%ntrcat))
     ss%id_tq_transcat = 0
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%trace_flag).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%trace_flag)
  ENDIF
  IF(ALLOCATED(ss%trace_flag)) then
     jsize = SIZE(ss%trace_flag)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: trace_flag already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%trace_flag(ss%nbeam))
     ss%trace_flag = 0
  ENDIF

  isize = (ss%ntrcat)
  IF(ALLOCATED(ss%trcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%trcat)
  ENDIF
  IF(ALLOCATED(ss%trcat)) then
     jsize = SIZE(ss%trcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: trcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%trcat(ss%ntrcat))
     ss%trcat = " "
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%triang).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%triang)
  ENDIF
  IF(ALLOCATED(ss%triang)) then
     jsize = SIZE(ss%triang)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: triang already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%triang(ss%nrho_eq_geo))
     ss%triang = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%triangL).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%triangL)
  ENDIF
  IF(ALLOCATED(ss%triangL)) then
     jsize = SIZE(ss%triangL)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: triangL already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%triangL(ss%nrho_eq_geo))
     ss%triangL = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%triangU).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%triangU)
  ENDIF
  IF(ALLOCATED(ss%triangU)) then
     jsize = SIZE(ss%triangU)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: triangU already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%triangU(ss%nrho_eq_geo))
     ss%triangU = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%triang_miller_L).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%triang_miller_L)
  ENDIF
  IF(ALLOCATED(ss%triang_miller_L)) then
     jsize = SIZE(ss%triang_miller_L)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: triang_miller_L already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%triang_miller_L(ss%nrho_eq_geo))
     ss%triang_miller_L = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%triang_miller_U).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%triang_miller_U)
  ENDIF
  IF(ALLOCATED(ss%triang_miller_U)) then
     jsize = SIZE(ss%triang_miller_U)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: triang_miller_U already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%triang_miller_U(ss%nrho_eq_geo))
     ss%triang_miller_U = 0.0_rspec
  ENDIF

  isize = (ss%ntrcat)
  IF(ALLOCATED(ss%trmodels).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%trmodels)
  ENDIF
  IF(ALLOCATED(ss%trmodels)) then
     jsize = SIZE(ss%trmodels)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: trmodels already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%trmodels(ss%ntrcat))
     ss%trmodels = " "
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%Ts).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Ts)
  ENDIF
  IF(ALLOCATED(ss%Ts)) then
     jsize = SIZE(ss%Ts)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Ts already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Ts(ss%nrho-1,0:ss%nspec_th))
     ss%Ts = 0.0_rspec
     ALLOCATE(ss%id_Ts(0:ss%nspec_th))
     ss%id_Ts = 0
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%Ts_is_input).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Ts_is_input)
  ENDIF
  IF(ALLOCATED(ss%Ts_is_input)) then
     jsize = SIZE(ss%Ts_is_input)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Ts_is_input already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Ts_is_input(0:ss%nspec_th))
     ss%Ts_is_input = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%tzflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tzflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%tzflux_ky_tglf)) then
     jsize = SIZE(ss%tzflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tzflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tzflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%tzflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_tzflux_ky_tglf(ss%nky_anomth))
     ss%id_tzflux_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%tz_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%tz_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%tz_ky_tglf)) then
     jsize = SIZE(ss%tz_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: tz_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%tz_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%tz_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_tz_ky_tglf(ss%nky_anomth))
     ss%id_tz_ky_tglf = 0
  ENDIF

  isize = (ss%n_t_einj_standard)
  IF(ALLOCATED(ss%T_einj_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T_einj_standard)
  ENDIF
  IF(ALLOCATED(ss%T_einj_standard)) then
     jsize = SIZE(ss%T_einj_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T_einj_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T_einj_standard(ss%n_t_einj_standard))
     ss%T_einj_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_t_einj_standard)
  IF(ALLOCATED(ss%T_ffull_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T_ffull_standard)
  ENDIF
  IF(ALLOCATED(ss%T_ffull_standard)) then
     jsize = SIZE(ss%T_ffull_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T_ffull_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T_ffull_standard(ss%n_t_einj_standard))
     ss%T_ffull_standard = 0.0_rspec
  ENDIF

  isize = (ss%n_t_einj_standard)
  IF(ALLOCATED(ss%T_fhalf_standard).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%T_fhalf_standard)
  ENDIF
  IF(ALLOCATED(ss%T_fhalf_standard)) then
     jsize = SIZE(ss%T_fhalf_standard)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: T_fhalf_standard already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%T_fhalf_standard(ss%n_t_einj_standard))
     ss%T_fhalf_standard = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%upwind_pfrac_ns).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%upwind_pfrac_ns)
  ENDIF
  IF(ALLOCATED(ss%upwind_pfrac_ns)) then
     jsize = SIZE(ss%upwind_pfrac_ns)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: upwind_pfrac_ns already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%upwind_pfrac_ns(ss%nrho,0:ss%nspec_th))
     ss%upwind_pfrac_ns = 0.0_rspec
     ALLOCATE(ss%id_upwind_pfrac_ns(0:ss%nspec_th))
     ss%id_upwind_pfrac_ns = 0
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%upwind_pfrac_omega).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%upwind_pfrac_omega)
  ENDIF
  IF(ALLOCATED(ss%upwind_pfrac_omega)) then
     jsize = SIZE(ss%upwind_pfrac_omega)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: upwind_pfrac_omega already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%upwind_pfrac_omega(ss%nrho))
     ss%upwind_pfrac_omega = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%upwind_pfrac_Te).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%upwind_pfrac_Te)
  ENDIF
  IF(ALLOCATED(ss%upwind_pfrac_Te)) then
     jsize = SIZE(ss%upwind_pfrac_Te)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: upwind_pfrac_Te already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%upwind_pfrac_Te(ss%nrho))
     ss%upwind_pfrac_Te = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%upwind_pfrac_Ti).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%upwind_pfrac_Ti)
  ENDIF
  IF(ALLOCATED(ss%upwind_pfrac_Ti)) then
     jsize = SIZE(ss%upwind_pfrac_Ti)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: upwind_pfrac_Ti already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%upwind_pfrac_Ti(ss%nrho))
     ss%upwind_pfrac_Ti = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%vee_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vee_trans)
  ENDIF
  IF(ALLOCATED(ss%vee_trans)) then
     jsize = SIZE(ss%vee_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vee_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vee_trans(ss%nrho))
     ss%vee_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%vee_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%vee_transcat)
  ENDIF
  IF(ALLOCATED(ss%vee_transcat)) then
     jsize = SIZE(ss%vee_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: vee_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%vee_transcat(ss%nrho,ss%ntrcat))
     ss%vee_transcat = 0.0_rspec
     ALLOCATE(ss%id_vee_transcat(ss%ntrcat))
     ss%id_vee_transcat = 0
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%velb_fusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velb_fusi)
  ENDIF
  IF(ALLOCATED(ss%velb_fusi)) then
     jsize = SIZE(ss%velb_fusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velb_fusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velb_fusi(ss%nrho_anom))
     ss%velb_fusi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%velb_nbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velb_nbi)
  ENDIF
  IF(ALLOCATED(ss%velb_nbi)) then
     jsize = SIZE(ss%velb_nbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velb_nbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velb_nbi(ss%nrho_anom))
     ss%velb_nbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%velb_rfmi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velb_rfmi)
  ENDIF
  IF(ALLOCATED(ss%velb_rfmi)) then
     jsize = SIZE(ss%velb_rfmi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velb_rfmi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velb_rfmi(ss%nrho_anom))
     ss%velb_rfmi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velne_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velne_nclass)
  ENDIF
  IF(ALLOCATED(ss%velne_nclass)) then
     jsize = SIZE(ss%velne_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velne_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velne_nclass(ss%nrho_anomth))
     ss%velne_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velnh_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velnh_nclass)
  ENDIF
  IF(ALLOCATED(ss%velnh_nclass)) then
     jsize = SIZE(ss%velnh_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velnh_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velnh_nclass(ss%nrho_anomth))
     ss%velnh_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velni_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velni_drbm)
  ENDIF
  IF(ALLOCATED(ss%velni_drbm)) then
     jsize = SIZE(ss%velni_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velni_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velni_drbm(ss%nrho_anomth))
     ss%velni_drbm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_anom)
  ENDIF
  IF(ALLOCATED(ss%velns_anom)) then
     jsize = SIZE(ss%velns_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_anom(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_anom = 0.0_rspec
     ALLOCATE(ss%id_velns_anom(0:ss%nspec_th))
     ss%id_velns_anom = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_glf)
  ENDIF
  IF(ALLOCATED(ss%velns_glf)) then
     jsize = SIZE(ss%velns_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_glf(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_glf = 0.0_rspec
     ALLOCATE(ss%id_velns_glf(0:ss%nspec_th))
     ss%id_velns_glf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%velns_gtcneo)) then
     jsize = SIZE(ss%velns_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_gtcneo(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_gtcneo = 0.0_rspec
     ALLOCATE(ss%id_velns_gtcneo(0:ss%nspec_th))
     ss%id_velns_gtcneo = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_mmm71)
  ENDIF
  IF(ALLOCATED(ss%velns_mmm71)) then
     jsize = SIZE(ss%velns_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_mmm71(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_mmm71 = 0.0_rspec
     ALLOCATE(ss%id_velns_mmm71(0:ss%nspec_th))
     ss%id_velns_mmm71 = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_nclass)
  ENDIF
  IF(ALLOCATED(ss%velns_nclass)) then
     jsize = SIZE(ss%velns_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_nclass(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_nclass = 0.0_rspec
     ALLOCATE(ss%id_velns_nclass(0:ss%nspec_th))
     ss%id_velns_nclass = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_neo)
  ENDIF
  IF(ALLOCATED(ss%velns_neo)) then
     jsize = SIZE(ss%velns_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_neo(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_neo = 0.0_rspec
     ALLOCATE(ss%id_velns_neo(0:ss%nspec_th))
     ss%id_velns_neo = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%velns_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velns_tglf)
  ENDIF
  IF(ALLOCATED(ss%velns_tglf)) then
     jsize = SIZE(ss%velns_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velns_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velns_tglf(ss%nrho_anomth,0:ss%nspec_th))
     ss%velns_tglf = 0.0_rspec
     ALLOCATE(ss%id_velns_tglf(0:ss%nspec_th))
     ss%id_velns_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velnx_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velnx_nclass)
  ENDIF
  IF(ALLOCATED(ss%velnx_nclass)) then
     jsize = SIZE(ss%velnx_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velnx_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velnx_nclass(ss%nrho_anomth))
     ss%velnx_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_anom)
  ENDIF
  IF(ALLOCATED(ss%velpphi_anom)) then
     jsize = SIZE(ss%velpphi_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_anom(ss%nrho_anomth))
     ss%velpphi_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_glf)
  ENDIF
  IF(ALLOCATED(ss%velpphi_glf)) then
     jsize = SIZE(ss%velpphi_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_glf(ss%nrho_anomth))
     ss%velpphi_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%velpphi_gtcneo)) then
     jsize = SIZE(ss%velpphi_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_gtcneo(ss%nrho_anomth))
     ss%velpphi_gtcneo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_mmm71)
  ENDIF
  IF(ALLOCATED(ss%velpphi_mmm71)) then
     jsize = SIZE(ss%velpphi_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_mmm71(ss%nrho_anomth))
     ss%velpphi_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_neo)
  ENDIF
  IF(ALLOCATED(ss%velpphi_neo)) then
     jsize = SIZE(ss%velpphi_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_neo(ss%nrho_anomth))
     ss%velpphi_neo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velpphi_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velpphi_tglf)
  ENDIF
  IF(ALLOCATED(ss%velpphi_tglf)) then
     jsize = SIZE(ss%velpphi_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velpphi_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velpphi_tglf(ss%nrho_anomth))
     ss%velpphi_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_anom)
  ENDIF
  IF(ALLOCATED(ss%velte_anom)) then
     jsize = SIZE(ss%velte_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_anom(ss%nrho_anomth))
     ss%velte_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_glf)
  ENDIF
  IF(ALLOCATED(ss%velte_glf)) then
     jsize = SIZE(ss%velte_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_glf(ss%nrho_anomth))
     ss%velte_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%velte_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%velte_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%velte_gtcneo)) then
     jsize = SIZE(ss%velte_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: velte_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%velte_gtcneo(ss%nrho_anomth))
     ss%velte_gtcneo = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_8

!--------------------------------------------------------------------
      subroutine trxpl_get_profile(zname)
 
      implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
      include 'trxpl.blk'
      character*10, intent(inout) :: zname   ! name of profile
 
      ! get a profile; add it to the list.
 
      !----------------------------
      logical lxout,lyes
      integer lnout
      character*1 yesno(0:1)
      !----------------------------
      yesno(0)='N'
      yesno(1)='Y'
 
      if(lxout(0)) then
         write(lnout(0),*) ' interpolation order: ',iordr
         write(lnout(0),*) ' [R,Z] extend option: ',yesno(ixtnd)
         if(ixtnd.eq.1) write(lnout(0),*) '    scrape-off length: ',
     >      zlamda,' m.'
         write(lnout(0),*) ' enter ".M" to modify option settings.'
      endif
 
      do
         if(lxout(0)) write(lnout(0),*) ' enter ".Q" to exit.'
         call ureadw('trxpl:  enter name of TRANSP/RPLOT profile:$',
     >      zname)
 
         if(zname.eq.'.Q') exit
 
         if(zname.eq.'.M') then
            if(lxout(0)) then
               write(lnout(0),1010)
 1010          format(/
     >      ' TRANSP profile interpolation can be:'/
     >      '    order 0:  piecewise linear'/
     >      '    order 1:  Hermite piecewise cubic'/
     >      '    order 2:  cubic spline.'/
     >      ' Profile functions of flux surface label "x" with interp-'/
     >      ' polation order 1 or 2 can optionally be extended'/
     >      ' beyond the plasma boundary to cover the (R,Z) grid.'/
     >      ' The extrapolation is set by specifying a scrape-off'/
     >      ' distance parameter lamda, then the function outside'/
     >      ' the core plasma obeys '/
     >      '    f=f(bdy)*exp(-d/lamda),'/
     >      ' where d=[distance to nearest boundary point].'/
     >      ' For flat extrapolation choose lamda = 0.0;'/
     >      ' Profile functions of major radius will not be extended.')
            endif
 
            call ureadi(
     >         'trxpl:  interpolation order:  0 or 1 or 2:$',iordr)
            iordr=max(0,min(2,iordr))
 
            if(iordr.gt.0) then
               call uread('trxpl: invoke profile extension? (Y/N):$')
               if(lyes(0)) then
                  ixtnd=1
                  call ureadr8('trxpl: extension scrape-off length:$',
     >               zlamda)
               else
                  ixtnd=0
               endif
            endif
 
         else
 
            call trxpl_add_profile(zname)
            if(lxout(0)) write(lnout(0),*) 
     >         '  Use ".Q" then "D" option to examine data.'
 
         endif
 
      enddo
 
      return
      end

subroutine ps_rezone_rho(ss,nrho,rho,nids,ids,idws,curdens,nonorm,zsmoo, &
     ansa,dvola,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 16 Oct 2006
  !
  ! XPLASMA2 implementation of plasma_state subroutine
  !   rezone a list of profiles such that their (possibly weighted) 
  !   volume- or area- integrals are conserved.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  implicit NONE

  !-----------------------
  !  passed arguments:

  type (plasma_state) :: ss              ! object containing profile to rezone

  integer, intent(in) :: nrho  ! size of target rho grid -- rho BDYs
  REAL(KIND=rspec), intent(in) :: rho(nrho)  ! target rho grid -- BDYs

  integer, intent(in) :: nids  ! number of profiles to evaluate
  integer, intent(in) :: ids(nids)  ! the profile IDs
  integer, intent(in) :: idws(nids) ! weighting profile IDs (0 for no profile)

  logical :: curdens         ! .TRUE. for AREA instead of VOLUME normalization

  logical :: nonorm          ! for quantities which are densities, undo the
  !  density normalization, if nonorm=.TRUE.; for averaged value profiles
  !  (Temperatures, average energies, rotation velocities) this switch has
  !  no effect.

  logical :: zsmoo           ! .TRUE. for integral smoothing operator

  REAL(KIND=rspec), intent(out) :: ansa(nrho-1,nids)  ! interpolation results

  REAL(KIND=rspec), intent(out) :: dvola(nrho-1)      ! zone volumes (or areas)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  integer :: ii,irank,igrid,igrid2,jgrid,jgrid2,icoord,idv,id_intg
  logical :: jccw
  character*32 :: profname1,profname2
  REAL(KIND=rspec) bdytol
  REAL(KIND=rspec), dimension(:), allocatable :: zvol,zarea
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(ss%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_rezone_rho: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_global_info(s,ierr, bdytol = bdytol)

  if((abs(rho(1)).gt.bdytol).or. &
       (abs(rho(nrho)-1.0_rspec).gt.bdytol)) then
     write(iout,*) ' ?ps_rho_rezone: input rho grid does not span [0:1]:'
     write(iout,*) '  rho(1) = ',rho(1)
     write(iout,*) '  rho(',nrho,') = ',rho(nrho)
     ierr = 999
     return
  endif

  !  look to 1st profile ID to define grids and interpolation type

  call xplasma_prof_info(s,ids(1),ierr, name=profname1, gridId1=igrid, &
       gridId2=igrid2, rank=irank)
  
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rezone_rho: 1st xplasma_prof_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  if(irank.gt.2) then
     write(iout,*) ' ?ps_rezone_rho: profile id=',ids(1), &
          ' name="',trim(profname1),'" has rank: ',irank
     write(iout,*) '  rank too high:'
     write(iout,*) '  This profile not eligible for rho rezone operation.'
     ierr=77
     return
  endif

  call xplasma_grid_info(s,igrid,ierr, coord=icoord)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rezone_rho: xplasma_grid_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  if(.not.((icoord.eq.xplasma_theta_coord).or. &
       (icoord.eq.xplasma_rho_coord))) then
     write(iout,*) ' ?ps_rezone_rho: profile id=',ids(1), &
          ' name="',trim(profname1),'" defined over'
     write(iout,*) '  grid other than rho or theta.'
     write(iout,*) '  This profile not eligible for rho rezone operation.'
     ierr=77
     return
  endif

  if(irank.eq.1) then

     if(.not.(icoord.eq.xplasma_rho_coord)) then
        write(iout,*) ' ?ps_rezone_rho: rank 1 profile id=',ids(1), &
             ' name="',trim(profname1),'" defined over'
        write(iout,*) '  grid other than rho.'
        write(iout,*) '  This profile not eligible for rho rezone operation.'
        ierr=77
        return
     endif

  else if(irank.eq.2) then

     call xplasma_grid_info(s,igrid2,ierr, coord=icoord)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_rezone_rho: xplasma_grid_info call failed:'
        call xplasma_error(s,ierr,iout)
        ierr=77
        return
     endif

     if(.not.((icoord.eq.xplasma_theta_coord).or. &
          (icoord.eq.xplasma_rho_coord))) then
        write(iout,*) ' ?ps_rezone_rho: profile id=',ids(1), &
             ' name="',trim(profname1),'" defined over'
        write(iout,*) '  grid other than rho or theta.'
        write(iout,*) '  This profile not eligible for rho rezone operation.'
        ierr=77
        return
     endif
  endif

  !  check that all additional profiles are on the same grid and of same
  !  rank and spline type...

  do ii=2,nids

     call xplasma_prof_info(s,ids(ii),ierr, name=profname2, gridId1=jgrid, &
          gridId2=jgrid2)
  
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_rezone_rho: 2nd xplasma_prof_info call failed:'
        call xplasma_error(s,ierr,iout)
        ierr=77
        return
     endif

     if((igrid.ne.jgrid).or.(igrid2.ne.jgrid2)) then
        write(iout,*) ' ?ps_rezone_rho: profiles "', &
             trim(profname1),'" and "',trim(profname2),'" are'
        write(iout,*) '  not defined over the same grids-- use separate'
        write(iout,*) '  interpolation calls.'
        ierr=77
        return
     endif

  enddo

  !  make sure the normalizing profile is defined...

  call xplasma_blkbxId(s,'__RZ_RHO_INTEGRATOR',id_intg)

  idv=0
  if(curdens) then
     allocate(zarea(nrho))
     if(id_intg.gt.0) then
        call xplasma_area(s,rho,zarea,ierr)
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_rezone_rho: xplasma_area call error:'
           call xplasma_error(s,ierr,iout)
        else
           call xplasma_profId(s,'XPLASMA_AREA',idv)
        endif
     else if(ss%id_area.gt.0) then
        call xplasma_eval_prof(s,ss%id_area,rho,zarea,ierr)
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_rezone_rho: area profile interpolation error:'
           call xplasma_error(s,ierr,iout)
        else
           idv=ss%id_area
        endif
     endif
     if(ierr.eq.0) then
        do ii=1,nrho-1
           dvola(ii)=zarea(ii+1)-zarea(ii)
        enddo
     endif
     deallocate(zarea)

  else
     allocate(zvol(nrho))
     if(id_intg.gt.0) then
        call xplasma_volume(s,rho,zvol,ierr)
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_rezone_rho: xplasma_volume call error:'
           call xplasma_error(s,ierr,iout)
        else
           call xplasma_profId(s,'XPLASMA_VOLUME',idv)
        endif
     else if(ss%id_vol.gt.0) then
        call xplasma_eval_prof(s,ss%id_vol,rho,zvol,ierr)
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_rezone_rho: volume profile interpolation error:'
           call xplasma_error(s,ierr,iout)
        else
           idv=ss%id_vol
        endif
     endif
     if(ierr.eq.0) then
        do ii=1,nrho-1
           dvola(ii)=zvol(ii+1)-zvol(ii)
        enddo
     endif
     deallocate(zvol)

  endif
  if(ierr.ne.0) return

  if(irank.eq.1) then

     call xplasma_avg1d(s,rho,idv,ids,ansa,ierr,idw=idws,ismoo=zsmoo)
     if(ierr.eq.0) then
        !  undo volume/area normalization if switch is set
        if(nonorm) then
           do ii=1,nids
              if(idws(ii).eq.0) then
                 ansa(1:nrho-1,ii)=ansa(1:nrho-1,ii)*dvola
              endif
           enddo
        endif
     else
        write(iout,*) ' ?ps_rezone_rho: xplasma_avg1d error:'
        call xplasma_error(s,ierr,iout)
        ansa=0
     endif

  else

     ierr=999
     write(iout,*) ' ?? ps_rezone: rank > 1 not implemented yet.'

  endif

end subroutine ps_rezone_rho

subroutine ps_rezone_chk(ss,id_intg,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 16 Oct 2006
  !
  ! XPLASMA2 implementation of plasma_state subroutine
  !   rezone a list of profiles such that their (possibly weighted) 
  !   volume- or area- integrals are conserved.
  !
  ! Check if rezone operation is available:
  !   If so, silently set id_intg to a positive number
  !   If not, print a brief warning and set id_intg = 0.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  implicit NONE

  !-----------------------
  !  passed arguments:

  type (plasma_state) :: ss       ! object to check

  integer, intent(out) :: id_intg ! integrator ID (if exists) or 0

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(ss%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_rezone_chk: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_blkbxId(s,'__RZ_RHO_INTEGRATOR',id_intg)

  if(id_intg.eq.0) then
     if((ss%id_vol.eq.0).or.(ss%id_area.eq.0)) then
        write(iout,*) &
             ' %ps_rezone_chk: no rezone operator available (no MHD equilibrium).'
     else
        id_intg=10000000  ! rezones can proceed
     endif
  endif

end subroutine ps_rezone_chk

c-------------------------------------------------------------------
      subroutine trxpl_mkgs2_aggr(npts,rho,n,T,sum1,sum2,sum3,sum4)
c
      use trxpl_gs2_module
      implicit NONE
c
      integer npts                      ! no. of pts in profiles
      real*8 rho(npts)                  ! radial flux coordinate
c
c  work arrays...
c
      real*8 n(npts),T(npts)            ! n & T of ions
      real*8 sum1(npts),sum2(npts)      ! n*Z and n*Z*Z sums
      real*8 sum3(npts),sum4(npts)      ! n*A and n*T sums
c
c---------------------------------------------
      real*8 nsum(npts)
      logical iexclud(num_species),iaggr(num_species)
      logical lxout,lchar,lyes,ltmp,ltmp2
      integer lnout,i,j,k,ion,ierr,iopts,ktype
      integer ibc1,ibc2,ishift
      real*8 zbc1,zbc2
c
      integer icounts(0:7)
      character*17 lbls(0:7),mklbl
      integer ilist(num_species,7),inlist(7)
      character*1 cid(7)
c
      data lbls/'electrons','thermal ions','impurity ions','beam ions',
     >     'RF tail ions','fusion products','all fast ions',
     >     'therm + fast ions'/
c
      data mklbl/'?aggregator'/     ! marker label for ions aggregated away
c
      data cid/'1','2','3','4','5','6','7'/
c
c---------------------------------------------
c
      iexclud=.false.
      iaggr=.false.
c
      inlist=0
      ilist=0
c
      i=lnout(0)
c
      if(gsmoo) then
         write(i,*) ' *** cannot aggregate ion species after smoothing!'
         write(i,*) '     to redo, go to smoothing routine and request'
         write(i,*) '     to cancel all smoothing.'
         call upaust(0)
         call uclear
         return
      endif
      if(gaggr) then
         write(i,*) ' *** ion species were already aggregated!'
         write(i,*) '     to redo, go back to top of program and reread'
         write(i,*) '     the input data...'
         call upaust(0)
         call uclear
         return
      endif
c
 10   continue
      icounts=0
      do j=1,num_species
         if((.not.iexclud(j)).and.(.not.iaggr(j))) then
            icounts(ltype(j))=icounts(ltype(j))+1
            if(ltype(j).gt.2) icounts(6)=icounts(6)+1
         endif
      enddo
c
c  if any fast ions or thermal ions are already aggregated, fast + thermal 
c  aggregation is not an option -- impurity aggregation (inlist(2)) not a
c  factor.
c
      if(max(inlist(1),inlist(3),inlist(4),inlist(5),inlist(6)).eq.0)
     >     then
         icounts(7)=icounts(1)+icounts(6) ! fast + thermal
      else
         icounts(7)=0           ! cannot aggregate fast & thermal
      endif
c
      i=lnout(0)
      if(lxout(0)) then
         write(i,*) ' %trxpl_mkgs2_aggr -- species of like type can be'
         write(i,*) '  "aggregated" into a nominal ion specie a, with'
         write(i,*) ' '
         write(i,*) '     Za = sum[i]ni*Zi^2/sum[i]ni*Zi'
         write(i,*) '     na = sum[i]ni*Zi/Za'
         write(i,*) '     Ta = sum[i]ni*Ti/sum[i]ni'
         write(i,*) '     Aa = sum[i]ni*Ai/sum[i]ni'
         write(i,*) ' '
         write(i,*) '  and the sums are over a selected subset of ion'
         write(i,*) '  species.  Note that Z and A become profile'
         write(i,*) '  functions.'
         write(i,*) ' '
         write(i,*)
     >    '  On entry to trxpl_mkgs2_aggr, exclusion flags are cleared.'
         write(i,*) ' '
         do j=1,num_species
            if(j.eq.1) then
               ltmp=.TRUE.
               ltmp2=.FALSE.
            else
               ltmp=iexclud(j)
               ltmp2=iaggr(j)
            endif
            write(i,1001) j,slabel(j),ltmp,ltmp2
 1001       format(' specie ',i3,'.  ',a,' EXCLUDED = ',L1,
     >         ' AGGREGATED = ',L1)
         enddo
         write(i,*) ' '
      endif
      iopts=0
      if(icounts(1).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "I" to aggregate thermal ion species'
      endif
      if(icounts(2).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "X" to aggregate impurity ion species'
      endif
      if(icounts(3).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "B" to aggregate beam ion species'
      endif
      if(icounts(4).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "R" to aggregate RF tail ion species'
      endif
      if(icounts(5).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "P" to aggregate fusion product species'
      endif
      if(icounts(6).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "F" to aggregate all fast ion species'
      endif
      if(icounts(7).gt.1) then
         iopts=iopts+1
         write(i,*) ' -> enter "G" to aggregate thermal and fast '//
     >        'species together.'
      endif
      if(iopts.gt.0) then
         write(i,*) ' -> enter "Z" to set exclude flag for a specie'
      else
         write(i,*)
     >      ' ** no more ion species can be aggregated at this time.'
      endif
      write(i,*) ' -> enter "A" to accept & execute aggregations.'
      write(i,*) '   (caution:  cannot re-enter this routine after "A")'
      write(i,*) ' -> enter "Q" to quit without aggregating ions.'
c
      call uread('trxpl_mkgs2_agg:  ion aggregation option:$')
c
      ktype=0
c
      if(lchar('Q')) then
         return
      else if(lchar('A')) then
         go to 200
      else if(lchar('Z')) then
         j=0
         if(lxout(0)) write(i,*) ' enter "0" to skip this...'
         call ureadi(' enter id number of ion specie to exclude:$',j)
         if(j.eq.0) go to 10
         if((j.le.1).or.(j.gt.num_species)) then
            call uermsi('%trxpl_mkgs2:  invalid specie id:',j,0)
         else
            iexclud(j)=.TRUE.
         endif
         go to 10
      endif
      if(icounts(1).gt.1) then
         if(lchar('I')) then
            ktype=1
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(2).gt.1) then
         if(lchar('X')) then
            ktype=2
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(3).gt.1) then
         if(lchar('B')) then
            ktype=3
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(4).gt.1) then
         if(lchar('R')) then
            ktype=4
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(5).gt.1) then
         if(lchar('P')) then
            ktype=5
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(6).gt.1) then
         if(lchar('F')) then
            ktype=6
            go to 100  ! avoid further "lchar" calls
         endif
      endif
      if(icounts(7).gt.1) then
         if(lchar('G')) then
            write(i,*) ' %CAUTION -- wide variation in energy may occur'
            write(i,*) '  between thermal and fast species.'
            call uread(
     >           ' verify aggregation of thermal and fast species?'//
     >           ' (Y/N):$')
            if(.not.lyes(0)) go to 10
            ktype=7
            go to 100  ! avoid further "lchar" calls
         endif
      endif
c
 100  continue
      if(ktype.eq.0) then
         call uermsg('%trxpl_mkgs2_agg:  invalid option code.',' ',0)
         go to 10
      endif
c
      do j=1,num_species
         if(.not.iexclud(j)) then
            if(  (ltype(j).eq.ktype) .or.
     >           ((ktype.eq.6).and.(ltype(j).gt.2)) .or.
     >           ((ktype.eq.7).and.((ltype(j).eq.1).or.(ltype(j).gt.2)))
     >           ) then
               inlist(ktype)=inlist(ktype)+1
               ilist(inlist(ktype),ktype)=j
               iaggr(j)=.TRUE.
            endif
         endif
      enddo
c
      go to 10
c
 200  continue
c
      ibc1=1
      zbc1=0.0d0
      ibc2=0
      zbc2=0.0d0
c
      if(inlist(7).gt.0) then
         fast_aggr=.TRUE.
      else
         fast_aggr=.FALSE.
      endif
c
      do j=1,7
         if(inlist(j).gt.0) then
            nsum = 0.0d0
            sum1 = 0.0d0
            sum2 = 0.0d0
            sum3 = 0.0d0
            sum4 = 0.0d0
            do k=1,inlist(j)
               ion=ilist(k,j)
c
               call eq_rgetf(npts,rho,id_norig(ion),0,n,ierr)
               if(ierr.ne.0) call errmsg_exit('?trxpl_gs2_aggr 1??')
c
               call eq_rgetf(npts,rho,id_torig(ion),0,T,ierr)
               if(ierr.ne.0) call errmsg_exit('?trxpl_gs2_aggr 2??')
               T=T*Tconv(ion)
c
               nsum=nsum+n
               sum1=sum1+n*Zplas(ion)
               sum2=sum2+n*Zplas(ion)*Zplas(ion)
               sum3=sum3+n*Aplas(ion)
               sum4=sum4+n*T
c
               Aplas(ion)=0.0d0
               Zplas(ion)=0.0d0
               Tconv(ion)=1.0d0
               id_norig(ion)=0
               id_torig(ion)=0
               ltype(ion)=0
               slabel(ion)=mklbl
c
            enddo
c
            sum3=sum3/nsum              ! <A>
            sum4=sum4/nsum              ! <T>
            sum2=sum2/sum1              ! <Z>          ... conserve zeff
            sum1=sum1/sum2              ! new density      & quasineutrality
c
            ion=ilist(1,j)
            ltype(ion)=j
            slabel(ion)=lbls(j)//' (aggregate)'
c
c  store the new aggregate ion specie parameters as spline or hermite
c  ...in place of the first of the ions that is being aggregated away
c
            call eqm_rhofun(iorder,id_rho,'N_AGGR'//cid(j),sum1,
     >         ibc1,zbc1,ibc2,zbc2,id_norig(ion),ierr)
            if(ierr.ne.0) call errmsg_exit(
     >         ' ?trxpl_mkgs2_aggr:  eqm_rhofun error (n)')
c
            if(j.gt.2) then
               call eqm_rhofun(iorder,id_rho,'T_AGGR'//cid(j),sum4,
     >            ibc1,zbc1,ibc2,zbc2,id_torig(ion),ierr)
               if(ierr.ne.0) call errmsg_exit(
     >            ' ?trxpl_mkgs2_aggr:  eqm_rhofun error (T)')
            else
               ! thermal ions stick with original Ti or Tx/Tmj
               if(j.eq.1) id_torig(ion)=id_tmj
               if(j.eq.2) id_torig(ion)=id_tx
            endif
c
            call eqm_rhofun(iorder,id_rho,'Z_AGGR'//cid(j),sum2,
     >         ibc1,zbc1,ibc2,zbc2,id_zprof(ion),ierr)
            if(ierr.ne.0) call errmsg_exit(
     >         ' ?trxpl_mkgs2_aggr:  eqm_rhofun error (Z)')
c
            call eqm_rhofun(iorder,id_rho,'A_AGGR'//cid(j),sum3,
     >         ibc1,zbc1,ibc2,zbc2,id_aprof(ion),ierr)
            if(ierr.ne.0) call errmsg_exit(
     >         ' ?trxpl_mkgs2_aggr:  eqm_rhofun error (A)')
c
            gaggr=.TRUE.
c
         endif        ! #aggregate-list.gt.1
c
      enddo
c
      if(.not.gaggr) then
         write(i,*) ' %no ions aggregated-- can re-enter.'
      else
c
c  squeeze out ion species being aggregated away
c
         ishift=0
         do k=1,num_species
            if(slabel(k).eq.mklbl) then
               ishift=ishift+1
            else if(ishift.gt.0) then
               Aplas(k-ishift)=Aplas(k)
               Zplas(k-ishift)=Zplas(k)
               id_zprof(k-ishift)=id_zprof(k)
               id_aprof(k-ishift)=id_aprof(k)
               Tconv(k-ishift)=Tconv(k)
               id_norig(k-ishift)=id_norig(k)
               id_torig(k-ishift)=id_torig(k)
               ltype(k-ishift)=ltype(k)
               slabel(k-ishift)=slabel(k)
            endif
         enddo
c
         num_species=num_species-ishift
         if(num_reft.gt.1) then
            do k=1,num_species
               if(ltype(k).eq.1) num_reft=k ! take last non-impurity therm. ion
            enddo
         endif
 
      endif
c
      return
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_4(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! kyrhos_mtm
        w%list_elems(isize) = "kyrhos_mtm"
        w%elem_descr(isize) = "ky*rhos at max growth rate for MTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%kyrhos_mtm)) THEN
           IF(ss%hash_codes(ps_phash_kyrhos_mtm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! kyspectrum_tglf
        w%list_elems(isize) = "kyspectrum_tglf"
        w%elem_descr(isize) = "ky-spectrum from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%kyspectrum_tglf)) THEN
           IF(ss%hash_codes(ps_phash_kyspectrum_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Lpol
        w%list_elems(isize) = "Lpol"
        w%elem_descr(isize) = "poloidal path length"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%Lpol)) THEN
           IF(ss%hash_codes(ps_phash_Lpol).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0norm
        w%list_elems(isize) = "n0norm"
        w%elem_descr(isize) = "neutral density per unit gas influx (sc0)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "(m^-3)/(#/sec)"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas,ngsc0)"
        IF(ALLOCATED(ss%n0norm)) THEN
           IF(ss%hash_codes(ps_phash_n0norm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0_halo
        w%list_elems(isize) = "n0_halo"
        w%elem_descr(isize) = "halo thermal neutral density"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%n0_halo)) THEN
           IF(ss%hash_codes(ps_phash_n0_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0_reco
        w%list_elems(isize) = "n0_reco"
        w%elem_descr(isize) = "reco thermal neutral density"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas)"
        IF(ALLOCATED(ss%n0_reco)) THEN
           IF(ss%hash_codes(ps_phash_n0_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nbeami
        w%list_elems(isize) = "nbeami"
        w%elem_descr(isize) = "beam species density"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_nbi-1,nspec_beam)"
        IF(ALLOCATED(ss%nbeami)) THEN
           IF(ss%hash_codes(ps_phash_nbeami).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! neflux_ky_tglf
        w%list_elems(isize) = "neflux_ky_tglf"
        w%elem_descr(isize) = "electron density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%neflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_neflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ne_ky_tglf
        w%list_elems(isize) = "ne_ky_tglf"
        w%elem_descr(isize) = "electron density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%ne_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_ne_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nfusi
        w%list_elems(isize) = "nfusi"
        w%elem_descr(isize) = "fusion ion density"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_fus-1,nspec_fusion)"
        IF(ALLOCATED(ss%nfusi)) THEN
           IF(ss%hash_codes(ps_phash_nfusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ngradb2_av
        w%list_elems(isize) = "ngradb2_av"
        w%elem_descr(isize) = "<(B.grad(B)/|B|)^2>"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T^2*m^-2"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%ngradb2_av)) THEN
           IF(ss%hash_codes(ps_phash_ngradb2_av).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ni
        w%list_elems(isize) = "ni"
        w%elem_descr(isize) = "total thermal ion density"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%ni)) THEN
           IF(ss%hash_codes(ps_phash_ni).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! niflux_ky_tglf
        w%list_elems(isize) = "niflux_ky_tglf"
        w%elem_descr(isize) = "ion density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%niflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_niflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ni_ky_tglf
        w%list_elems(isize) = "ni_ky_tglf"
        w%elem_descr(isize) = "ion density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%ni_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_ni_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nmini
        w%list_elems(isize) = "nmini"
        w%elem_descr(isize) = "minority species density"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_icrf-1,nspec_rfmin)"
        IF(ALLOCATED(ss%nmini)) THEN
           IF(ss%hash_codes(ps_phash_nmini).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nmodel
        w%list_elems(isize) = "nmodel"
        w%elem_descr(isize) = "target density profile"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_anomth-1)"
        IF(ALLOCATED(ss%nmodel)) THEN
           IF(ss%hash_codes(ps_phash_nmodel).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nrw
        w%list_elems(isize) = "nrw"
        w%elem_descr(isize) = "runaway electron density"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho_rw-1)"
        IF(ALLOCATED(ss%nrw)) THEN
           IF(ss%hash_codes(ps_phash_nrw).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ns
        w%list_elems(isize) = "ns"
        w%elem_descr(isize) = "thermal specie density"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%ns)) THEN
           IF(ss%hash_codes(ps_phash_ns).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nzflux_ky_tglf
        w%list_elems(isize) = "nzflux_ky_tglf"
        w%elem_descr(isize) = "impurity density flux spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%nzflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_nzflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nz_ky_tglf
        w%list_elems(isize) = "nz_ky_tglf"
        w%elem_descr(isize) = "impurity density fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%nz_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_nz_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0cx
        w%list_elems(isize) = "omeg0cx"
        w%elem_descr(isize) = "effective neutral angular velocity for CX torque"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%omeg0cx)) THEN
           IF(ss%hash_codes(ps_phash_omeg0cx).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*TQQCX"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0sc0
        w%list_elems(isize) = "omeg0sc0"
        w%elem_descr(isize) = "toroidal angular velocity"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "(rad/sec)"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas,ngsc0)"
        IF(ALLOCATED(ss%omeg0sc0)) THEN
           IF(ss%hash_codes(ps_phash_omeg0sc0).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0NORM"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0_halo
        w%list_elems(isize) = "omeg0_halo"
        w%elem_descr(isize) = "halo neutral toroidal angular velocity"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%omeg0_halo)) THEN
           IF(ss%hash_codes(ps_phash_omeg0_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0_HALO"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0_reco
        w%list_elems(isize) = "omeg0_reco"
        w%elem_descr(isize) = "reco neutral toroidal angular velocity"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas)"
        IF(ALLOCATED(ss%omeg0_reco)) THEN
           IF(ss%hash_codes(ps_phash_omeg0_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*N0_RECO"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omegat
        w%list_elems(isize) = "omegat"
        w%elem_descr(isize) = "ion toroidal angular velocity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%omegat)) THEN
           IF(ss%hash_codes(ps_phash_omegat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omega_exb
        w%list_elems(isize) = "omega_exb"
        w%elem_descr(isize) = "ExB flow shear rate"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%omega_exb)) THEN
           IF(ss%hash_codes(ps_phash_omega_exb).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! p0_reco
        w%list_elems(isize) = "p0_reco"
        w%elem_descr(isize) = "power in recombination neutral source"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%p0_reco)) THEN
           IF(ss%hash_codes(ps_phash_p0_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pb0_halo
        w%list_elems(isize) = "pb0_halo"
        w%elem_descr(isize) = "power in halo neutral source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pb0_halo)) THEN
           IF(ss%hash_codes(ps_phash_pb0_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbe
        w%list_elems(isize) = "pbe"
        w%elem_descr(isize) = "electron heating by all beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pbe)) THEN
           IF(ss%hash_codes(ps_phash_pbe).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbi
        w%list_elems(isize) = "pbi"
        w%elem_descr(isize) = "thermal ion heating by all beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pbi)) THEN
           IF(ss%hash_codes(ps_phash_pbi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbth
        w%list_elems(isize) = "pbth"
        w%elem_descr(isize) = "thermalization of beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pbth)) THEN
           IF(ss%hash_codes(ps_phash_pbth).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pcx_halo
        w%list_elems(isize) = "pcx_halo"
        w%elem_descr(isize) = "beam halo driven CX power"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pcx_halo)) THEN
           IF(ss%hash_codes(ps_phash_pcx_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pcx_reco
        w%list_elems(isize) = "pcx_reco"
        w%elem_descr(isize) = "reco driven CX power"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%pcx_reco)) THEN
           IF(ss%hash_codes(ps_phash_pcx_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! peech
        w%list_elems(isize) = "peech"
        w%elem_descr(isize) = "electron heating by ECH"
        w%component(isize) = "EC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_ecrf-1)"
        IF(ALLOCATED(ss%peech)) THEN
           IF(ss%hash_codes(ps_phash_peech).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! peech_src
        w%list_elems(isize) = "peech_src"
        w%elem_descr(isize) = "ECH heating (by antenna)"
        w%component(isize) = "EC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_ecrf-1,necrf_src)"
        IF(ALLOCATED(ss%peech_src)) THEN
           IF(ss%hash_codes(ps_phash_peech_src).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pelh
        w%list_elems(isize) = "pelh"
        w%elem_descr(isize) = "electron heating by LH"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_lhrf-1)"
        IF(ALLOCATED(ss%pelh)) THEN
           IF(ss%hash_codes(ps_phash_pelh).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_4

#include "fpreproc/byte_declare.h"

! ----------- I/O ------------
subroutine c_splitn_read(cfilename, ios)
  implicit none
  byte_declare :: cfilename(*)    ! C name
  integer      :: ios             ! error flag

  character*256 :: filename   ! fortran name

  call cstring(filename,cfilename,'2F')
  call splitn_read(filename,ios)
end subroutine c_splitn_read

subroutine c_splitn_write(cfilename, ios)
  implicit none
  byte_declare :: cfilename(*)    ! C name
  integer      :: ios             ! error flag

  character*256 :: filename   ! fortran name

  call cstring(filename,cfilename,'2F')
  call splitn_write(filename,ios)
end subroutine c_splitn_write

subroutine c_splitn_merge_write(cfnam_in, cfnam_bck, cfnam_out, ctag, ios)
  implicit none
  byte_declare :: cfnam_in(*)     ! C name of 2nd input
  byte_declare :: cfnam_bck(*)    ! C name of backup file
  byte_declare :: cfnam_out(*)    ! C name of output file
  byte_declare :: ctag(*)         ! C name of tag
  integer      :: ios             ! error flag

  character*256 :: fnam_in   ! fortran name
  character*256 :: fnam_bck  ! fortran name
  character*256 :: fnam_out  ! fortran name
  character*20  :: tag       ! fortran name

  call cstring(fnam_in,cfnam_in,'2F')
  call cstring(fnam_bck,cfnam_bck,'2F')
  call cstring(fnam_out,cfnam_out,'2F')
  call cstring(tag,ctag,'2F')
  call splitn_merge_write(fnam_in,fnam_bck,fnam_out,tag,ios)
end subroutine c_splitn_merge_write

subroutine c_splitn_edit_enable(cprogram_name)
  implicit none
  byte_declare :: cprogram_name(*)    ! C name
 
  character*32 :: program_name  ! fortran name
  call cstring(program_name, cprogram_name, '2F')
  call splitn_edit_enable(program_name)
end subroutine c_splitn_edit_enable

! ----------------- info ----------------
subroutine c_splitn_get_info(cname,itype,irank,nd,idims,isize,ichsize,ierr)
  implicit none
  byte_declare :: cname(*)    ! input, C name
  integer      :: itype       ! output, 0->int, 1->logical, 2->real, 3->double, 4->character, -1->?
  integer      :: irank       ! output, rank of variable
  integer      :: nd          ! input,  dimension of idims
  integer      :: idims(2,nd) ! output, dimensions (fortran ordering)
  integer      :: isize       ! output, total number of array elements
  integer      :: ichsize     ! output, number of characters for character type
  integer      :: ierr        ! output, nonzero on error

  character*64 :: zname  ! fortran name
  character*8  :: ztype  ! character type
  character*1  :: zt     ! first character of type
  
  call cstring(zname,cname,'2F')
  itype=-1
  irank=0
  ichsize=0
  idims=0
  
  call splitn_get_type(zname,ztype,ichsize,ierr)
  zt = ztype(1:1)
  if (ierr==0) then
    if (zt=='I') then
      itype=0
    else if (zt=='L') then
      itype=1
    else if (zt=='R') then
      itype=2
    else if (zt=='D') then
      itype=3
    else if (zt=='C') then
      itype=4
    else 
      itype=-1
      ierr=1
      return
    end if
    
    call splitn_getdims(zname,irank,nd,idims,isize,ierr)
  end if
end subroutine c_splitn_get_info

! ---------------- get defaults --------------
subroutine c_splitn_igetd(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_igetd(zname,isize,array,ierr)
end subroutine c_splitn_igetd

!
! boolean get which returns integer 0,1 depending on .false.,.true. of data
!
subroutine c_splitn_bgetd(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data, 0->false, 1->true
  integer      :: ierr        ! nonzero on error

  integer      :: i
  character*64 :: zname          ! fortran name
  logical      :: zarray(isize)  ! fortran logical

  call cstring(zname,cname,'2F')
  call splitn_lgetd(zname,isize,zarray,ierr)
  if (ierr==0) then
     do i=1,isize
        if (zarray(i)) then
           array(i)=1
        else
           array(i)=0
        end if
     end do
  end if
end subroutine c_splitn_bgetd

subroutine c_splitn_lgetd(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  logical      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_lgetd(zname,isize,array,ierr)
end subroutine c_splitn_lgetd


subroutine c_splitn_rgetd(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real         :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_rgetd(zname,isize,array,ierr)
end subroutine c_splitn_rgetd


subroutine c_splitn_dgetd(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real*8       :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_dgetd(zname,isize,array,ierr)
end subroutine c_splitn_dgetd


subroutine c_splitn_cgetd(cname,iwid,isize,carray,ierr)
  implicit none

  byte_declare :: cname(*)    ! C name
  integer      :: iwid        ! C width, 1 more then fortran width
  integer      :: isize       ! size of object
  byte_declare :: carray(*)   ! data
  integer      :: ierr        ! nonzero on error

  integer :: i
  character*64 :: zname               ! fortran name
  character*(iwid-1) :: array(isize)  ! fortran data

  call cstring(zname,cname,'2F')

  call splitn_cgetd(zname,iwid-1,isize,array,ierr)
  if (ierr==0) then
     do i=1,isize
        call cstring(array(i),carray((i-1)*iwid+1),'2C')
        carray(i*iwid)=0   ! 0 terminated
     end do
  end if
end subroutine c_splitn_cgetd

!
! --------------------- getf -------------------
!
!  The *_*getf(...) subroutines only return value elements explicitly set
!  in the namelist file.  Elements in the array argument which are not 
!  explicitly set are left unmodified.
!
subroutine c_splitn_igetf(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_igetf(zname,isize,array,ierr)
end subroutine c_splitn_igetf


subroutine c_splitn_lgetf(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  logical      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_lgetf(zname,isize,array,ierr)
end subroutine c_splitn_lgetf


subroutine c_splitn_rgetf(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real         :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_rgetf(zname,isize,array,ierr)
end subroutine c_splitn_rgetf


subroutine c_splitn_dgetf(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real*8       :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_dgetf(zname,isize,array,ierr)
end subroutine c_splitn_dgetf


subroutine c_splitn_cgetf(cname,iwid,isize,carray,ierr)
  implicit none

  byte_declare :: cname(*)    ! C name
  integer      :: iwid        ! C width, 1 more then fortran width
  integer      :: isize       ! size of object
  byte_declare :: carray(*)   ! data
  integer      :: ierr        ! nonzero on error

  integer :: i
  character*64 :: zname             ! fortran name
  character*(iwid-1) :: array(isize)  ! fortran data
  character*(iwid-1) :: ctest       ! test string for being set by function call

  do i=1, iwid-1
     ctest(i:i) = "&"
  end do

  call cstring(zname,cname,'2F')
  do i=1,isize
     array(i) = ctest            ! mark string as unset
  end do

  call splitn_cgetf(zname,iwid-1,isize,array,ierr)
  if (ierr==0) then
     do i=1,isize
        if (array(i) /= ctest) then
           call cstring(array(i),carray((i-1)*iwid+1),'2C')  ! only change if different
           carray(i*iwid)=0   ! 0 terminated
        end if
     end do
  end if
end subroutine c_splitn_cgetf

!
! --------------------- get -------------------
!
!  The *_*get(...) subroutines return all of the values in the namelist buffer.
!
subroutine c_splitn_iget(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_iget(zname,isize,array,ierr)
end subroutine c_splitn_iget

!
! boolean get which returns integer 0,1 depending on .false.,.true. of data
!
subroutine c_splitn_bget(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data, 0->false, 1->true
  integer      :: ierr        ! nonzero on error

  integer      :: i
  character*64 :: zname          ! fortran name
  logical      :: zarray(isize)  ! fortran logical

  call cstring(zname,cname,'2F')
  call splitn_lget(zname,isize,zarray,ierr)
  if (ierr==0) then
     do i=1,isize
        if (zarray(i)) then
           array(i)=1
        else
           array(i)=0
        end if
     end do
  end if
end subroutine c_splitn_bget


subroutine c_splitn_rget(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real         :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_rget(zname,isize,array,ierr)
end subroutine c_splitn_rget


subroutine c_splitn_dget(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real*8       :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_dget(zname,isize,array,ierr)
end subroutine c_splitn_dget

!
!  get an CHARACTER*n namelist object
!  isize *must* match the actual size of the object.
!  iwid must be .ge. the actual width of object elements.
!
subroutine c_splitn_cget(cname,iwid,isize,carray,ierr)
  implicit none

  byte_declare :: cname(*)    ! C name
  integer      :: iwid        ! C width, 1 more then fortran width
  integer      :: isize       ! size of object
  byte_declare :: carray(*)   ! data of size at least iwid*isize
  integer      :: ierr        ! nonzero on error

  integer :: i
  character*64 :: zname             ! fortran name
  character*(iwid-1) :: array(isize)  ! fortran data

  call cstring(zname,cname,'2F')
  call splitn_cget(zname,iwid-1,isize,array,ierr)
  if (ierr==0) then
     do i=1,isize
        call cstring(array(i),carray((i-1)*iwid+1),'2C')  ! only change if different
        carray(i*iwid)=0   ! 0 terminated
     end do
  end if
end subroutine c_splitn_cget


! --------------------- putw -------------------
subroutine c_splitn_iputw(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_iputw(zname,isize,array,ierr)
end subroutine c_splitn_iputw


subroutine c_splitn_lputw(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  logical      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_lputw(zname,isize,array,ierr)
end subroutine c_splitn_lputw

!
! boolean put which transfers .false,.true. depending on 0,nonzero of integer argument
!
subroutine c_splitn_bputw(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  integer      :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  integer      :: i
  character*64 :: zname         ! fortran name
  logical      :: zarray(isize) ! fortran array

  call cstring(zname,cname,'2F')
  zarray = (/ (array(i)/=0, i=1,isize) /)
  call splitn_lputw(zname,isize,zarray,ierr)
end subroutine c_splitn_bputw


subroutine c_splitn_rputw(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real         :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_rputw(zname,isize,array,ierr)
end subroutine c_splitn_rputw


subroutine c_splitn_dputw(cname,isize,array,ierr)
  implicit none
  byte_declare :: cname(*)    ! C name
  integer      :: isize       ! size of object
  real*8       :: array(*)    ! data
  integer      :: ierr        ! nonzero on error

  character*64 :: zname  ! fortran name
  call cstring(zname,cname,'2F')
  call splitn_dputw(zname,isize,array,ierr)
end subroutine c_splitn_dputw


subroutine c_splitn_cputw(cname,iwid,isize,carray,ierr)
  implicit none

  byte_declare :: cname(*)    ! C name
  integer      :: iwid        ! C width, 1 more then fortran width
  integer      :: isize       ! size of object
  byte_declare :: carray(*)   ! data
  integer      :: ierr        ! nonzero on error

  integer :: i
  character*64       :: zname         ! fortran name
  character*(iwid-1) :: array(isize)  ! fortran data

  call cstring(zname,cname,'2F')
  do i=1,isize
     call cstring(array(i),carray((i-1)*iwid+1),'2F')
  end do

  call splitn_cputw(zname,iwid-1,isize,array,ierr)
end subroutine c_splitn_cputw

C----------------------------------------------
C  COMPUTE R/A VECTOR FOR DATA INTERPOLATION
C
      SUBROUTINE TDB_ROVERA(t,INRI,iarat,ZX,drshaf,izones)
      use trdatbuf_aux
      IMPLICIT NONE
      type (profget) :: t
C
C  dmc 4 May 1993 -- for INRI <= 4 this is a midplane spatial coordinate
C  dmc June 2005 -- if IARAT <> 0 this is a normalized aspect ratio
C
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER inri,iz,j,icen,iarat
!============
      integer :: izones
      REAL*8 ZX(izones),drshaf(izones)
      real*8 :: zr1,zr2,zr1p,zr2p,za1,za2,zra
C
      icen=izones
      if(inri.ge.5) then
C
C  flux coordinate
C
         drshaf = 0.0_R8
         if(t%ibdy) then
            zx=t%xibdys
         else
            do j=1,izones-1
               zx(j)=0.5_R8*(t%xibdys(j)+t%xibdys(j+1))
            enddo
            zx(izones)=t%xibdys(izones)+0.5_R8*
     >           (t%xibdys(izones)-t%xibdys(izones-1))
         endif
      else if(iarat.ge.0) then
C
C  minor or major radius coordinate
C
         za2=t%rmajmp(t%nrmaj)-t%rmajmp(1)
         zra=0.5_R8*(t%rmajmp(t%nrmaj)+t%rmajmp(1))
         if(t%ibdy) then
            zx(1)=0.0_R8
            drshaf(1)=t%rmajmp(icen)-zra
            do j=1,izones-1
               zr1=t%rmajmp(icen-j)
               zr2=t%rmajmp(icen+j)
               zx(j+1)=(zr2-zr1)/za2
               drshaf(j+1)=0.5_R8*(zr2+zr1)-zra
            enddo
         else
            zr1=t%rmajmp(icen)
            zr2=zr1
            do j=1,izones-1
               zr1p=zr1
               zr2p=zr2
               zr1=t%rmajmp(icen-j)
               zr2=t%rmajmp(icen+j)
               zx(j)=0.5_R8*(zr2+zr2p-(zr1+zr1p))/za2
               drshaf(j)=0.25_R8*(zr2+zr2p+zr1+zr1p) - zra
            enddo
            zx(izones)=2.0_r8-zx(izones-1)
            drshaf(izones) = 0.0_R8
         endif
      else
C
C  normalized aspect ratio -- used for final mapping of presymmetrized data
C
         drshaf = 0.0_R8
C
C  bdy aspect ratio for normalization:
C
         za2 = (t%rmajmp(t%nrmaj)-t%rmajmp(1))/
     >        (t%rmajmp(t%nrmaj)+t%rmajmp(1))
C
         if(t%ibdy) then
            zx(1)=0.0_R8
            do j=1,izones-1
               if(iarat.gt.0) then
                  zr1=t%rmajmp(icen-j)
                  zr2=t%rmajmp(icen+j)
               else
                  zr1=1.0_R8/t%bmidp(icen-j)
                  zr2=1.0_R8/t%bmidp(icen+j)
               endif
               za1=(zr2-zr1)/(zr2+zr1)
               zx(j+1)=za1/za2
            enddo
         else
            if(iarat.gt.0) then
               zr1=t%rmajmp(icen)
            else
               zr1=1.0_R8/t%bmidp(icen)
            endif
            zr2=zr1
            do j=1,izones-1
               zr1p=zr1
               zr2p=zr2
               if(iarat.gt.0) then
                  zr1=t%rmajmp(icen-j)
                  zr2=t%rmajmp(icen+j)
               else
                  zr1=1.0_R8/t%bmidp(icen-j)
                  zr2=1.0_R8/t%bmidp(icen+j)
               endif
               ! avg aspect ratio half way btw two surfaces
               za1=((zr2+zr2p)-(zr1+zr1p))/((zr2+zr2p)+(zr1+zr1p))
               zx(j)=za1/za2
            enddo
            zx(izones)=2.0_r8-zx(izones-1) ! 1/2 zone width beyond...
         endif
      endif
      RETURN
      END

C------------------------------------------------------------
C  interpolation for "standard" trdatbuf f(t) items
C
C---------------
C  Background information:  a code generator is used to create
C  data channels for TRANSP/trdatbuf-- this makes it easy to add 
C  new data channels e.g. as new measurements are invented on
C  tokamak experiments.
C
C  The input file for the code generator, trdatgen, is a file 
C  called trdatgen.spec.  This file defines profile channels,
C  scalar channels, and "special handling" channels.  An f(t)
C  item is a scalar channel.
C
C  Each channel has a 3 character name or "trigraph".  For 
C  example, the name for plasma current is "CUR".  The header
C  entry for CUR in trdatgen.spec looks like:
C
C      *CUR(TIM)        { 'plasma current',     'amps' }
C
C  Another example:
C      *VSF(TIM)        { 'surface voltage',    'volts' }
C
C  The generated code uses the trigraphs CUR and VSF to generate various
C  named component connected with the lookup and time interpolation of 
C  plasma current and surface voltage, respectively.
C
C  Any header entry in trdatgen.spec that starts with
C
C      *<trigraph>(TIM)
C
C  specifies a scalar channel, the data for which can be interpolated
C  using the software described here, provided that the data exists
C  for a given trdatbuf object.
C
C  For any given instance of a trdatbuf object, all scalar channel data
C  is defined over a single shared time base, i.e. a 1d strictly ascending
C  finite sequence of time values, in seconds.  The time base and the 
C  associated scalar channel data are not necessarily evenly spaced in
C  time.
C
C---------------
C  What to do in your code (what follows assumes you have instantiated
C  a trdatbuf object "d" and have read its contents in from a trdatbuf
C  file.  Your code would then have access to the declarations
C      use trdatbuf_module
C      type (trdatbuf) :: d
C  but of course a different name could be chosen for the trdatbuf 
C  object.  Then:
C
C      logical :: cur_exist
C      integer :: cur_addr
C
C  (do this maybe once at the start or restart of a run-- but not every 
C  timestep, since the results won't change and the lookup could be slow):
C      cur_exist = TDB_PRESENT1(d,"CUR",cur_addr)
C
C  and later when an interpolation to a particular time is needed:
C
C      real*8 :: ztime     ! desired time (in) (seconds).
C      integer :: it1,it2  ! time bin indices
C      real*8 :: zf1,zf2   ! linear interpolation factors
C      real*8 :: cur_now   ! the CUR data at the desired time (out)
C      real*8 :: vsf_now   ! the VSF data at the desired time (out)
C
C  call TDB_LOOKUP1(d,ztime,it1,it2,zf1,zf2)         ! time bin lookup
C  cur_now = TDB_FINTRP1(d,cur_addr,it1,it2,zf1,zf2) ! get CUR at ztime
C  vsf_now = TDB_FINTRP1(d,vsf_addr,it1,it2,zf1,zf2) ! get VSF at ztime.
C
C  Note that the TDB_LOOKUP1 call is done once; it sets it1,it2,zf1,zf2
C  which are then reused in multiple subsequent linear interpolations,
C  avoiding repeated calculations of the lookup in the scalar channels'
C  time base inside the trdatbuf object.  This takes advantage of the 
C  fact that all scalar channels share a common time base, for efficiency.
C
C  The interfaces to the logical function TDB_PRESENT1, the subroutine
C  TDB_LOOKUP1, and the real*8 function TDB_FINTRP1, are all defined by
C  use association via the module, i.e. "use trdatbuf_module".
C
C------------------------------------------------------------
C  TDB_LOOKUP1
C
C  PREPARE TO INTERPOLATE ON A FUNCTION OF TIME
C
C  ZTIME-- TIME TO INTERPOLATE TO
C  ILOC-- LOCATION OF FCN IN BUFFER
c
c  interpolation formula for data stored at location ILOC
c  will be ...
c
c    result = d%datbuf(iloc+it1)*zf1 + d%datbuf(iloc+it2)*zf2
C
c  ** see REAL*8 function TDB_FINTRP1, below...
c
c------------
C
      SUBROUTINE TDB_LOOKUP1(d,ztime,it1,it2,zf1,zf2)
C
      use trdatbuf_obj
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  no use of SAVEd variables; repetitive calls at the same time will
C  cause look up calculation to be repeated.
C
      type (trdatbuf) :: d
      real*8, intent(in) :: ztime
      integer, intent(out) :: it1,it2  ! time offsets btw which ZTIME lies
      real*8, intent(out) :: zf1,zf2   ! linear interpolation factors
C
      integer :: int,ilt,ilt1,ilt2
      real*8 :: ztinit,zftime,zfac
      real*8, parameter :: ONE = 1.0d0
C
C-------------------------------------
C
      ilt=d%ltime1
      int=d%ntime1
      ztinit = d%datbuf(ilt)
      zftime = d%datbuf(ilt+int-1)
C
C check bounds
C
      if(ztime.le.ztinit) then
         it1=0
         it2=1
         zf1=1
         zf2=0
         return
      endif
      if(ztime.ge.zftime) then
         it1=int-2
         it2=int-1
         zf1=0
         zf2=1
         return
      endif
C
C initial lookup estimate
C
      zfac=(ztime-ztinit)/(zftime-ztinit)
      it1=zfac*int
      it1=max(0,min(int-2,it1))
      ilt1=ilt+it1

      do
         ilt2=ilt1+1
         if(d%datbuf(ilt1).gt.ztime) then
            ilt1=ilt1-1
            cycle
         else if(d%datbuf(ilt2).lt.ztime) then
            ilt1=ilt1+1
            cycle
         else
            exit
         endif
      enddo
C
C time bin found:
      it1=ilt1-ilt
      it2=it1+1
      ztinit=d%datbuf(ilt1)
      zftime=d%datbuf(ilt2)
C
C displacement within the bin:
      zf2=(ztime-ztinit)/(zftime-ztinit)
      zf1=ONE-zf2

      return
      end
C-------------------
      real*8 function TDB_FINTRP1(d,iloc,it1,it2,zf1,zf2)
C
      use trdatbuf_obj
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
      type (trdatbuf) :: d
      integer, intent(in) :: iloc     ! data location
      integer, intent(in) :: it1,it2  ! time offsets btw which ZTIME lies
      real*8, intent(in) :: zf1,zf2   ! linear interpolation factors
C
      integer lunmsg_tdb
C
      if(iloc.le.0) then
         write(lunmsg_tdb(0),*) ' ?TDB_FINTRP1: invalid address: ',iloc
         TDB_FINTRP1 = 0
      else
         TDB_FINTRP1 = d%datbuf(iloc+it1)*zf1 + d%datbuf(iloc+it2)*zf2
      endif
C
      return
      end

C------------------------------------------------------------
C  TDB_PRFINV -- modularized version, no trcom dependency (dmc May 2005)
C
C  GENERALIZED GEOMETRY VERSION-- OCT 1983
C  SYMMETRIZE 2 SIDED PROFILE WITH 2X ONION SKIN ALGORITHM
C    DIFFERS FROM ORIGINAL VERSION IN THAT INDEPENDENT COORDINATE
C  IS DIMENSIONLESS LOCATION X =(R-R0)/A RATHER THAN RADII IN CM
C
C  INPUT DATA IS IN WORKBUF(LBX(1)..)
C  INPUT X VECTOR IS ZXI(INXI)
C   INPUT ZXMAX= MAX X OF INTEREST FOR OUTPUT PROFILE
C
C  SYMMETRIZED OUTPUT PROFILE IS PUT IN WORKBUF(LBX(2)..) (F) AND
C   WORKBUF(LBX(3)..) (CORRESPONDING X VALUES); AND SHIFT FCN <X> IS
C   STORED IN WORKBUF(LBX(5)..)
C
C  OUTPUT PASSED INTEGER INUMR = NUMBER OF PTS IN OUTPUT PROFILES
C   VARIES DEPENDING ON NATURE OF INPUT PROFILE
C
C
      SUBROUTINE TDB_PRFINV(d,ZXI,INUMI,INUMR,ZXMAX)
C
      use trdatbuf_obj
      IMPLICIT NONE

      type (trdatbuf) :: d

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  CHECK DATA FOR 3-PT FLAT SPOTS
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER inumi,inumr,in1,in2,i,iadr0,iadr1,iadr2,iloc,ioff
      INTEGER ilocd1,ifound,ioffm1,iwarn,iadr,lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zxmax,zxi,ztol,zdata,zx1,zx2,zx3
!============
      DIMENSION ZXI(INUMI)
C
      DATA IWARN/3/
      DATA ZTOL/1.E-10_R8/
C
C--------------------------------------------------------------------
C
C  ATTEMPT TO REMOVE ALL DATA FLATSPOTS, THEN CHECK ...
C
      CALL TDB_PRFLAX(d%WORKBUF(d%LBX(1)),INUMI)
C
      IN1=INUMI-1
      IN2=INUMI-2
      DO 10 I=1,IN2
         IADR0=d%LBX(1)+I-1
         IADR1=IADR0+1
         IADR2=IADR1+1
         IF((d%WORKBUF(IADR0).EQ.d%WORKBUF(IADR1)).AND.
     >        (d%WORKBUF(IADR1).EQ.d%WORKBUF(IADR2))) GO TO 9000
 10   CONTINUE
C
C  INITIALIZE FUNCTION (MINOR RADIUS VS. DATA ITEM)
C
      INUMR=1
      d%WORKBUF(d%LBX(2))=0.0_R8
      d%WORKBUF(d%LBX(3))=ZXMAX
      d%WORKBUF(d%LBX(5))=0.0_R8
      ZDATA=ZTOL
C
 100  CONTINUE
C  FIND NEXT DATA POINT-- START OF CHORD
      CALL TDB_PRFNXP(d%WORKBUF(d%LBX(1)),ZXI,INUMI,ZDATA,ZX1,ILOC,ZTOL)
C  FINISHED?
      IF(ILOC.EQ.0) GO TO 500
C  ADD POINT TO DEFINITION
      INUMR=INUMR+1
C
      IOFF=INUMR-1
      ILOCD1=d%LBX(1)+ILOC-1
C
      d%WORKBUF(d%LBX(2)+IOFF)=d%WORKBUF(ILOCD1)
      d%WORKBUF(d%LBX(3)+IOFF)=0.0_R8
      d%WORKBUF(d%LBX(5)+IOFF)=0.0_R8
      ZDATA=d%WORKBUF(ILOCD1)*(1.0_R8+ZTOL)
C  FIND OTHER END OF CHORD
 15   CALL TDB_PRFNXX(d%WORKBUF(d%LBX(1)),ZXI,INUMI,
     >              d%WORKBUF(ILOCD1),ZX1,ZX2,IFOUND)
C  FOUND?
      IF(IFOUND.NE.0) GO TO 20
C  NOT FOUND.  IGNORE POINT
      INUMR=INUMR-1
      GO TO 100
C  FOUND.  CHECK FOR HOLLOW PROFILE
 20   CONTINUE
      d%WORKBUF(d%LBX(3)+IOFF)=d%WORKBUF(d%LBX(3)+IOFF)+0.5_R8*(ZX2-ZX1)
      d%WORKBUF(d%LBX(5)+IOFF)=
     >     d%WORKBUF(d%LBX(5)+IOFF)+0.25_R8*(ZX2-ZX1)*(ZX2+ZX1)
C
C  DONE IF AT MAXIMUM: R=0
      IF(d%WORKBUF(d%LBX(3)+IOFF).EQ.0.0_R8) GO TO 500
C
C  CHECK FOR ANOTHER INTERCEPT-- PROBABLY INDICATING A HOLLOW PROFILE
C  INPUT
C
      CALL TDB_PRFNXX(d%WORKBUF(d%LBX(1)),ZXI,INUMI,d%WORKBUF(ILOCD1),
     >              ZX2,ZX3,IFOUND)
      IF(IFOUND.NE.0) GO TO 90
C  CHECK THAT NO DUPLICATE POINT IS TAKEN
      IF(INUMR.EQ.1) GO TO 100
      IOFFM1=INUMR-2
      IF((d%WORKBUF(d%LBX(2)+IOFF).EQ.d%WORKBUF(d%LBX(2)+IOFFM1)).OR.
     >     (d%WORKBUF(d%LBX(3)+IOFF).EQ.d%WORKBUF(d%LBX(3)+IOFFM1))) 
     >     THEN
         INUMR=INUMR-1
      ELSE
C  NORMALIZE <X>
         d%WORKBUF(d%LBX(5)+IOFF)=
     >        d%WORKBUF(d%LBX(5)+IOFF)/d%WORKBUF(d%LBX(3)+IOFF)
      ENDIF
      GO TO 100
C  WARNING ON HOLLOW PROFILES
 90   CONTINUE
      IWARN=IWARN-1
      IF (IWARN.GT.0) write(lunmsg_tdb(0),*)
     >  'WARNING - HOLLOW DATA PROFILE DETECTED SR TDB_PRFINV'
      ZX1=ZX3
      GO TO 15
C----------
C  EXIT
 500  CONTINUE
      IF(INUMR.GT.1) THEN
C  GET SHIFT OF CENTER (PEAK) PT.
        IADR=d%LBX(5)+INUMR-1
        d%WORKBUF(IADR)=ZX1
        RETURN
      ENDIF
C---
C  ERROR
C
 9000 CONTINUE
c
c  flat spot should have been removed by tdb_prlfax...
c
      CALL errmsg_exit(
     >  '? ERROR IN TDB_PRFINV/PROFE2/PROFEX: DATA FLATSPOT   ')
      END

      subroutine splitn_rhs0(zline,zrhs,ivals,jj)
C
      use splitn_module
      implicit NONE
C
C  check RHS of scalar value assignment; verify there is only one value.
C
C  input:
C
      character*(*), intent(in) :: zline  ! input line
      character*(*), intent(in) :: zrhs ! RHS of namelist assignment
C                    **NO leading or trailing blanks**
C
      integer,intent(out) :: ivals      ! #values found (1 expected).
      integer,intent(in) :: jj          ! index to namelist item definition.
C
C  output:
C
CC      integer ivals                     ! =1 if only one RHS value
C                   =0 if type error
C                   .gt.1 if multiple RHS values.
C
C---------------------------------------------
      integer iextra,irepeat,idelim,iw1,iw2,iadr,iadlp,itmp,ier
      integer ir1,ir2
      integer :: iadls
C
      real rsave(1)
      real*8 dsave(1)
      integer isave(1)
      logical lsave(1)
      character*150 chsave(1)
C
      integer ichange                   ! detect change in value
C
C---------------------------------------------
C
      ivals=1
      call splitn_nxgrp(zrhs,0,iw1,iw2,idelim,ir1,ir2,irepeat,iextra)
      if(iextra.gt.0) then
         write(6,*)
     >      ' ?splitn: extraneous characters after quote string.'
         ivals=0
         return
      endif
C
      if(irepeat.ne.1) then
         write(6,*) ' ?splitn_rhs0: repeat count for scalar value.'
         ivals=irepeat
         return
      else
C
         ichange=0
         ivals=1
         if(kupdate.eq.0) then
            iadr=varlist(jj)%addr
            iadlp=varlist(jj)%nlinadr
            itmp=varlist(jj)%addr_st
         else
            ! we got through splitn_lhs; we know this is an updatable quantity
            itmp=varlist(jj)%nlinadr_st
            iadlp = nreal+nint+nlog+nr8+nchv +
     >           (kupdate-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st)
     >           + itmp
            itmp=varlist(jj)%addr_st
         endif
         if(iw2.ge.iw1) then
            if(varlist(jj)%type.eq.'R') then
               if(kupdate.gt.0) then
                  iadr = nreal + (kupdate-1)*nreal_st + itmp
               endif
               rsave=rbuf(iadr:iadr)
               call splitn_rdcod(zrhs(iw1:iw2),rbuf(iadr:iadr),1,ier)
               if(rbuf(iadr).ne.rsave(1)) ichange=1
               if(varlist(jj)%steerable.eq.2) then
                  iadls = varlist(jj)%nlinadr_st
                  call rset_ucop(rbuf,iadr,1,itmp,iadls,kupdate,
     >                 nupdate_max)
               endif
            else if(varlist(jj)%type.eq.'I') then
               if(kupdate.gt.0) then
                  iadr = nint + (kupdate-1)*nint_st + itmp
               endif
               isave=intbuf(iadr:iadr)
               call splitn_idcod(zrhs(iw1:iw2),intbuf(iadr:iadr),1,ier)
               if(intbuf(iadr).ne.isave(1)) ichange=1
               if(varlist(jj)%steerable.eq.2) then
                  iadls = varlist(jj)%nlinadr_st
                  call iset_ucop(intbuf,iadr,1,itmp,iadls,kupdate,
     >                 nupdate_max)
               endif
            else if(varlist(jj)%type.eq.'L') then
               if(kupdate.gt.0) then
                  iadr = nlog + (kupdate-1)*nlog_st + itmp
               endif
               lsave=logbuf(iadr:iadr)
               call splitn_ldcod(zrhs(iw1:iw2),logbuf(iadr:iadr),1,ier)
               if(lsave(1)) then
                  if(.not.logbuf(iadr)) ichange=1
               else
                  if(logbuf(iadr)) ichange=1
               endif
               if(varlist(jj)%steerable.eq.2) then
                  iadls = varlist(jj)%nlinadr_st
                  call lset_ucop(logbuf,iadr,1,itmp,iadls,kupdate,
     >                 nupdate_max)
               endif
            else if(varlist(jj)%type.eq.'D') then
               if(kupdate.gt.0) then
                  iadr = nr8 + (kupdate-1)*nr8_st + itmp
               endif
               dsave=dbuf(iadr:iadr)
               call splitn_ddcod(zrhs(iw1:iw2),dbuf(iadr:iadr),1,ier)
               if(dbuf(iadr).ne.dsave(1)) ichange=1
               if(varlist(jj)%steerable.eq.2) then
                  iadls = varlist(jj)%nlinadr_st
                  call dset_ucop(dbuf,iadr,1,itmp,iadls,kupdate,
     >                 nupdate_max)
               endif
            else if(varlist(jj)%type(1:1).eq.'C') then
               if(kupdate.gt.0) then
                  iadr = nchv + (kupdate-1)*nchv_st + itmp
               endif
               chsave=chbuf(iadr:iadr)
               call splitn_cdcod(zrhs(iw1:iw2),
     >            varlist(jj)%chsize,chbuf(iadr:iadr),1,ier)
               if(chbuf(iadr).ne.chsave(1)) ichange=1
               if(varlist(jj)%steerable.eq.2) then
                  iadls = varlist(jj)%nlinadr_st
                  call chset_ucop(chbuf,iadr,1,itmp,iadls,kupdate,
     >                 nupdate_max)
               endif
            endif
         else
            write(6,*) ' ?splitn_rhs0: null value field.'
            write(6,*) '  line starts: ',trim(zline)
            ier=1                       ! null value
         endif

         if(ier.gt.0) then
            ivals=0                     ! type mismatch
         else
            if(idelim.lt.len(zrhs)) then
               write(6,*) ' ?splitn_rhs0: multiple values for scalar.'
               ivals=2                  ! multiple values
            endif
         endif
      endif
C
      if(ivals.eq.1) then
         if(ilines(iadlp).ne.0) then
            if(ichange.eq.0) then
               call splitn_addwarn(zline(nam1:nam2),dblasg1,ndblasg1,
     >            len(dblasg1(1)),kdblasg1,maxwarn)
            else
               call splitn_addwarn(zline(nam1:nam2),dblasg2,ndblasg2,
     >            len(dblasg2(1)),kdblasg2,maxwarn)
            endif
         endif

         iline_nstack = iline_nstack + 1
         iline_stack(1,iline_nstack) = iadlp
         iline_stack(2,iline_nstack) = newline

         !xxx  ilines(iadlp)=newline   -- deferred, see add_nl_line in module

         ivrange(:,iadlp)=0
         irrange(:,iadlp)=0
         krepeat(iadlp)=0

         if(iw2.ge.iw1) then
            ivrange(1,iadlp)=iw1+val1-1
            ivrange(2,iadlp)=iw2+val1-1
         endif
      endif
C
      return
      end

      subroutine ts_write_r8(out_file,cdf_file,rlabel,trpath,
     >     time_r8,deltat_r8,ierr_open)

c! R8 interface to ts_write_r4
c!    actual file write is in ascii, 5 decimal digit precision.

      implicit NONE

      character*(*), intent(in) :: out_file  ! ASCII output file
      character*(*), intent(in) :: cdf_file  ! NetCDF output file

      ! if both the above are blank this routine returns without writing
      ! any file, issuing a warning.

      ! if out_file is non-blank the named ascii file is written and saved.
      ! if cdf_file is non-blank the named NetCDF file is written and saved.
      ! if cdf_file is non-blank but out_file is blank, a temporary ascii
      ! file is used, but not saved.

      character*(*), intent(in) :: rlabel   ! run label
      character*(*), intent(in) :: trpath   ! file or MDS+ path to run

      real*8, intent(in) :: time_r8    ! time slice time in run
      real*8, intent(in) :: deltat_r8  ! +/- averaging time

      integer, intent(out) :: ierr_open  ! file open status code, 0=OK

c     
c-------------------------------
c
c  convert to real
c

      real :: time,deltat

c-------------------------------

      time = time_r8
      deltat = deltat_r8

      call ts_write_r4(out_file,cdf_file,rlabel,trpath, 
     >     time,deltat,ierr_open)

      return
      end

C---------------------------------------------------------------------------
      subroutine ts_write_r4(out_file,cdf_file,rlabel,trpath, 
     >     time,deltat,ierr_open)

C! write TIME_SLICES file of TRANSP data, ascii file, on unit (iu).
C! close the file when done.

C! file OPEN in calling program...
C!  this code was original in the codesys/source/time_slices/time_slices.for
C!  driver code; converted to subroutine DMC 7 Jan 2009

      implicit NONE

      character*(*), intent(in) :: out_file  ! ASCII output file
      character*(*), intent(in) :: cdf_file  ! NetCDF output file

      ! if both the above are blank this routine returns without writing
      ! any file, issuing a warning.

      ! if out_file is non-blank the named ascii file is written and saved.
      ! if cdf_file is non-blank the named NetCDF file is written and saved.
      ! if cdf_file is non-blank but out_file is blank, a temporary ascii
      ! file is used, but not saved.

      character*(*), intent(in) :: rlabel   ! run label
      character*(*), intent(in) :: trpath   ! file or MDS+ path to run

      real, intent(in) :: time    ! time slice time in run
      real, intent(in) :: deltat  ! +/- averaging time

      integer, intent(out) :: ierr_open  ! file open status code, 0=OK
C
C information messages written on stdout via fortran unit 6
C
      !-----------------------------------------
      ! local variables

      character*10 abrev,abrev2         ! symbol abbreviation
 
      real sdata                        ! for scalar data...

      integer :: ier                    ! status code

      integer nzones                    ! no. radial zones
 
      ! no. scalar time pts, no. profile time pts, size of largest
      ! non-temporal coordinate, size of largest f(x,t) object:
 
      integer nsctime,nprtime,nxmax,nmax

      real, dimension(:), allocatable :: pbuf  ! profile buffer
      integer :: igot                   ! return size
c
      real :: tsl_min,tsl_max  ! fast ion slowing down time min & max
c
      character*24 realtime
      character*60 hostname,username,zlabel,zunits
      integer ilhost,iluser
      integer itypex,itypexb
      integer :: ic,ii,iu,icdf,itmp,istat
c
      integer :: inumsc,inumpro
c
      integer, parameter :: imom_max = 64
      integer, parameter :: imom_min = 1
      integer :: imom,imom_save,imom_start
      character*53 :: mlabel

      character*120 :: zfile,zfile_nbstep

      character*20 :: nubeam_repeat
      integer :: idtms,idts,idt1,idt2,idt3,idtct

      !-----------------------------------------
      ! multi impurity upgrade DMC Jan 2009

      integer :: n_species,n_thi,n_thx,n_bi,n_rfi,n_fusi,idum

      character*10, dimension(:,:), allocatable :: abrev_imp
      real, dimension(:), allocatable :: zz_imp,aa_imp
      integer, dimension(:), allocatable :: izc_imp

      ! check for multiple RF minority also-- warn if more than 1

      character*10, dimension(:,:), allocatable :: abrev_rf
      real, dimension(:), allocatable :: zz_rf,aa_rf
      integer, dimension(:), allocatable :: izc_rf
      real :: xzmini,amini

      !-----------------------------------------
      ! up-down symmetry flag
      logical :: nlsym
      real :: plhgt

      !-----------------------------------------
      ! misc

      logical :: i_dravfac

      !-----------------------------------------
      ! function declaration


      !-----------------------------------------
      ! executable code

      ierr_open = 0
      if((out_file.eq.' ').and.(cdf_file.eq.' ')) then
         write(6,*) ' %ts_write_r4: no output file specified.'
         return
      endif

      if(out_file.ne.' ') then
         itmp=0
         zfile = out_file
         call nbstep_filename(zfile)
      else
         call tmpfile_d('ts_write_r4',zfile,itmp)
         if(itmp.eq.0) then
            write(6,*) ' %ts_write_r4: temporary file naming error.'
            ierr_open=1
            return
         endif
         call nbstep_filename(cdf_file)
      endif

      call find_io_unit(iu)
      open(unit=iu,file=trim(zfile),status='unknown',iostat=istat)

      if(istat.ne.0) then
         ierr_open = 2
         write(6,*) ' ?ts_write_r4: open failure: '//trim(zfile)
         return
      endif

      write(6,*) ' '
      write(6,*) ' TIME_SLICES I/O modified DMC Jan 2009: quieter...'
      write(6,*) ' since run contents vary, '//
     >     '"not found" warnings are expected.'
      write(6,*) ' '
c
c  species info -- only used for impurities at present
c
      call rd_nspecies(n_species,n_thi,n_thx,n_bi,n_rfi,n_fusi)
C
      if(n_thx.gt.1) then
         write(6,*) ' %note: multiple impurities detected.'
         write(6,*) ' '
         allocate(izc_imp(n_thx),aa_imp(n_thx),zz_imp(n_thx),
     >        abrev_imp(4,n_thx))
         call rd_thxspec(n_thx,abrev_imp,zz_imp,aa_imp,izc_imp,idum)
      else
         write(6,*) ' %note: single impurity: XZIMP, AIMP, NIMP used.'
         write(6,*) ' '
      endif
C
      if(n_rfi.gt.0) then
         write(6,*) ' %note: RF minority detected.'
         write(6,*) ' '
         if(n_rfi.gt.1) then
            write(6,*) 
     >         ' ?ts_write: of multiple RF species only one is written.'
            write(6,*) ' '
         endif
         allocate(izc_rf(n_rfi),aa_rf(n_rfi),zz_rf(n_rfi),
     >        abrev_rf(4,n_rfi))
         call rd_rfspec(n_rfi,abrev_rf,zz_rf,aa_rf,izc_rf,idum)
         xzmini = zz_rf(1)
         amini = aa_rf(1)
      else
         xzmini = 0.0
         amini = 0.0
      endif
C
C  run size stats
C
      call rpstats(nsctime,nprtime,nxmax,nmax)
c
c  get buffer for profile function data
c
      allocate(pbuf(nxmax))             ! profile buffers
      pbuf=0

C  read/write scalars
 
      inumsc = 0

      write(iu,10) trim(rlabel),trim(trpath),time,deltat,max(1,n_thx)
  10  format(' Run "',a,'" TRREAD path "',a,'"'/
     &  ' Scalars:  time = ',f10.4,' averaged +/- ',f10.4,' seconds.',
     &  '  #imp = ',i3)
 
      abrev='BZXR'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,40) sdata,abrev
  40  format('   vacuum BZ * major_radius =',f10.4,'    [Tesla*cm] ',
     &  'RPLOT abrev = ',a10)
 
      if(n_thx.le.1) then
         abrev='XZIMP'
         call get_scalar(abrev,time,deltat,sdata)
         write(iu,45) sdata,abrev
 45      format('   atomic charge of impurity=',f10.4,'    [no units] ',
     &        'RPLOT abrev = ',a10)
 
         abrev='AIMP'
         call get_scalar(abrev,time,deltat,sdata)
         write(iu,46) sdata,abrev
 46      format('   atomic mass of impurity  =',f10.4,'    [no units] ',
     &        'RPLOT abrev = ',a10)
      else
         do ii=1,n_thx
            inumsc=inumsc+1
            abrev=' '
            if(ii.lt.10) then
               write(abrev,'("ZIMP_",i1)') ii
            else
               write(abrev,'("ZIMP_",i2)') ii
            endif

            write(iu,1047) 
     >           '   atomic charge imp: '//abrev_imp(1,ii)(6:10)//' ',
     >           zz_imp(ii),abrev

            inumsc=inumsc+1
            abrev=' '
            if(ii.lt.10) then
               write(abrev,'("AIMP_",i1)') ii
            else
               write(abrev,'("AIMP_",i2)') ii
            endif

            write(iu,1047) 
     >           '   atomic mass   imp: '//abrev_imp(1,ii)(6:10)//' ',
     >           aa_imp(ii),abrev
         enddo
      endif

      inumsc = inumsc + 1
      abrev='XZMINI'
      write(iu,1046) '   atomic charge RF minority=',xzmini,abrev

      inumsc = inumsc + 1
      abrev='AMINI'
      write(iu,1046) '   atomic mass RF minority  =',amini,abrev

 1046 format(a,f10.4,'    [no units] ','RPLOT abrev = ',a10)
 1047 format(a,'=',f10.4,'    [no units] ','RPLOT abrev = ',a10)

      abrev='PCUR'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,797) sdata,abrev
 797  format('   plasma current           =',1pe11.4,'   [Amps]     ',
     &  'RPLOT abrev = ',a10)
 
      abrev='RAXIS'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,798) sdata,abrev
 798  format('   R of magnetic axis       =',f10.4,'    [cm]       ',
     &  'RPLOT abrev = ',a10)
 
      abrev='YAXIS'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,799) sdata,abrev
 799  format('   Z of magnetic axis       =',f10.4,'    [cm]       ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ_H'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,47) sdata,abrev
  47  format('   H-NBI power              =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ_D'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,49) sdata,abrev
  49  format('   D-NBI power              =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ_T'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,50) sdata,abrev
  50  format('   T-NBI power              =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ_3'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,800) sdata,abrev
 800  format('   He3-NBI power            =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ_4'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,801) sdata,abrev
 801  format('   He4-NBI power            =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PINJ'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,51) sdata,abrev
  51  format('   total-NBI power          =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC_H'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,52) sdata,abrev
  52  format('   co-H-NBI frac            =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC_D'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,53) sdata,abrev
  53  format('   co-D-NBI frac            =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC_T'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,54) sdata,abrev
  54  format('   co-T-NBI frac            =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC_3'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,802) sdata,abrev
 802  format('   co-He3-NBI frac          =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC_4'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,803) sdata,abrev
 803  format('   co-He4-NBI frac          =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='COFRC'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,56) sdata,abrev
  56  format('   co-NBI frac (all beams)  =',1pe11.4,'   [no units] ',
     &  'RPLOT abrev = ',a10)
 
      abrev='POHT'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,60) sdata,abrev
  60  format('   Ohmic power              =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PICHTOT'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,61) sdata,abrev
  61  format('   ICRF antenna power       =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PLH'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,62) sdata,abrev
  62  format('   LHCD power               =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
 
      abrev='PECIN'
      call get_scalar(abrev,time,deltat,sdata)
      write(iu,63) sdata,abrev
  63  format('   ECRF input power         =',1pe11.4,'   [Watts]    ',
     &  'RPLOT abrev = ',a10)
  
c
c  read/write profiles
c
      inumpro = 0

      write(iu,11) trim(rlabel),trim(trpath),time,deltat
 11   format(' Run "',a,'" TRREAD path "',a,'"'/
     &  ' Profiles:  time = ',f10.4,' averaged +/- ',f10.4,' seconds.') 
c
c  first get no. of zones (not always 20 anymore)
c
      call t1profil('X',zlabel,zunits,time,deltat,itypex,
     >   pbuf,nxmax,igot,ier)
      nzones=igot
      write(6,12) nzones
      write(iu,12) nzones
 12   format(' Nzones = ',i4)
 
      call t1profil('XB',zlabel,zunits,time,deltat,itypexb,
     >   pbuf,nxmax,igot,ier)
c
c  now get profile values
c
      abrev='X'
      write(iu,70) abrev
  70  format(' Zone centrs = sq_rt(norm toroidal flux) (~r/a)       ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='XB'
      write(iu,71) abrev
  71  format(' XB = zone bdry sq_root(normlz toroidal flux)         ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DAREA'
      write(iu,72) abrev
  72  format(' Zone cross section area             [cm**2]       @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DVOL'
      write(iu,73) abrev
  73  format(' Zone volume                         [cm**3]       @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DRAV'
      write(iu,10073) abrev
10073 format(' Zone spacing <dr>                   [cm]          @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DRAVFAC'
      call rpexist_profile(abrev,i_dravfac)
      write(iu,10173) abrev
10173 format('<1/dr><dr> (DRAVFAC/DRAV -> <grad>)  [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      if(i_dravfac) then
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
      else
         pbuf = 1.0
         call get_profil(' ',time,deltat,nxmax,pbuf,igot)
      endif

      abrev='SURF'
      write(iu,74) abrev
  74  format(' Flux surface area                   [cm**2]      @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='RMJMP'
      write(iu,80) abrev
  80  format(' Midplane major radius               [cm]         @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='RMNMP'
      write(iu,81) abrev
  81  format(' Midplane minor radius               [cm]         @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='SSHAF'
      write(iu,82) abrev
  82  format(' Shafranov shift                     [cm]         @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='GR2I'
      write(iu,83) abrev
  83  format(' surf-vol-avg <1/R**2>               [/cm2]       @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='ELONG'
      write(iu,75) abrev
 75   format(' Flux surface elongation             [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TRIANG'
      write(iu,76) abrev
 76   format(' Flux surface triangularity          [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TRIANGU'
      write(iu,77) abrev
 77   format(' Flux surf. upper triangularity      [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TRIANGL'
      write(iu,78) abrev
 78   format(' Flux surf. lower triangularity      [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='SQUARE_UO'
      write(iu,79) abrev
 79   format(' Flux surf upper outer squareness    [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='SQUARE_LO'
      write(iu,84) abrev
 84   format(' Flux surf lower outer squareness    [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TRFLX'
      write(iu,95) abrev
  95  format(' Toroidal flux                       [Webers]     @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PLFLX'
      write(iu,96) abrev
  96  format(' Poloidal Flux                       [Webers]     @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BPOL'
      write(iu,97) abrev
  97  format(' Poloidal field                      [Tesla]      @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NE'
      write(iu,100) abrev
  100 format(' Electron dens                       [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NH'
      write(iu,101) abrev
  101 format(' Thermal hydrogen density            [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='ND'
      write(iu,102) abrev
  102 format(' Thermal deut dens                   [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NT'
      write(iu,103) abrev
  103 format(' Thermal tritium dens                [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(n_thx.le.1) then
         abrev='NIMP'
         write(iu,104) abrev
 104     format(
     &        ' Impurity density                    [/cm**3]      @X ',
     &        'RPLOT abrev = ',a10)
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
      else
         do ii=1,n_thx
            abrev=abrev_imp(1,ii)
            abrev2=' '
            if(ii.lt.10) then
               write(abrev2,'("NIMP_",i1)') ii
            else
               write(abrev2,'("NIMP_",i2)') ii
            endif
            write(iu,1044) ' Impurity density:  '//abrev,abrev2
            call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
         enddo
      endif
 1044 format(a,'       [/cm**3]      @X ',
     &     'RPLOT abrev = ',a10)
 
      abrev='NI'
      write(iu,105) abrev
  105 format(' Thermal ion dens NH+ND+NT+NIMP+NHE3+...  [/cm3]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NFI'  ! **NOTE** use FDENS_4 in get_profil!
      write(iu,106) abrev
  106 format(' Fusion ion dens                     [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NHE3'
      write(iu,107) abrev
  107 format(' Thermal He3 dens                    [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NHE4'
      write(iu,108) abrev
  108 format(' Thermal He4 dens                    [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='NMINI'
      write(iu,109) abrev
  109 format(' ICRH minority dens                  [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS'
      write(iu,119) abrev
  119 format(' Total beam ion dens                 [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS_H'
      write(iu,120) abrev
  120 format(' Hydrogen beam ion density           [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS_D'
      write(iu,121) abrev
  121 format(' Deuterium beam ion density          [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS_T'
      write(iu,122) abrev
  122 format(' Tritium beam ion density            [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS_3'
      write(iu,810) abrev
 810  format(' Helium-3 beam ion density           [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BDENS_4'
      write(iu,811) abrev
 811  format(' Helium-4 beam ion density           [/cm**3]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DIVFE'
      write(iu,123) abrev
  123 format(' Divergence(el flux)                 [n/cm3/sec]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DIVFI'
      write(iu,124) abrev
  124 format(' Divergence(ion flux)                [n/cm3/sec]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='DFINT'
      write(iu,125) abrev
  125 format(' Divergence(impurity flux)           [n/cm3/sec]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TX'
      write(iu,130) abrev
  130 format(' Impurity Temperature                [eV]          @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TI'
      write(iu,131) abrev
  131 format(' Hydrogenic Temperature              [eV]          @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TE'
      write(iu,132) abrev
  132 format(' Electron Temperature                [eV]          @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='CUR'
      write(iu,135) abrev
  135 format(' Total current                       [Amps/cm**2]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='CURBS'
      write(iu,136) abrev
  136 format(' Bootstrap current                   [Amps/cm**2]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='CURB'
      write(iu,137) abrev
  137 format(' Beam driven current                 [Amps/cm**2]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='LHCUR'
      write(iu,138) abrev
  138 format(' Lower Hybrid driven current         [Amps/cm**2]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='ECCUR'
      write(iu,139) abrev
  139 format(' ECRH current                        [Amps/cm**2]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PLJB'
      write(iu,140) abrev
  140 format(' surf-vol-avg <J*B>                  [Amp*T/cm**2] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='GFUN'
      write(iu,141) abrev
  141 format(' para/diamagnetism correction        [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='Q'
      write(iu,145) abrev
  145 format(' q_psi                               [no units]   @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UE'
      write(iu,146) abrev
  146 format(' Ele energy dens 3*NE*TE/2           [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UI'
      write(iu,147) abrev
  147 format(' Ion energy dens 3*NI*TI/2           [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPAR_H'
      write(iu,150) abrev
  150 format(' H-beam parall energy dens           [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPRP_H'
      write(iu,151) abrev
  151 format(' H-beam perpend energy dens          [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPAR_D'
      write(iu,153) abrev
  153 format(' D-beam parall energy dens           [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPRP_D'
      write(iu,154) abrev
  154 format(' D-beam perpend energy dens          [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPAR_T'
      write(iu,155) abrev
  155 format(' T-beam parall energy dens           [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPRP_T'
      write(iu,196) abrev
  196 format(' T-beam perpend energy dens          [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPAR_3'
      write(iu,156) abrev
 156  format(' He3-beam parall energy dens         [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPRP_3'
      write(iu,157) abrev
 157  format(' He3-beam perpend energy dens        [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPAR_4'
      write(iu,158) abrev
 158  format(' He4-beam parall energy dens         [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UBPRP_4'
      write(iu,159) abrev
 159  format(' He4-beam perpend energy dens        [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UMINPA'
      write(iu,160) abrev
 160  format(' RF minority parall energy dens      [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UMINPP'
      write(iu,161) abrev
 161  format(' RF minority perpend energy dens     [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UFIPA'
      write(iu,197) abrev
  197 format(' Fusion ion paral energy dens        [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UFIPP'
      write(iu,198) abrev
  198 format(' Fusion ion perpend energy dens      [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UPHI'
      write(iu,199) abrev
  199 format(' Rotation energy dens                [Joules/cm3]  @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UFASTPA'
      write(iu,200) abrev
  200 format(' Fast ion par energ dens (UBPAR_D+UBPAR_T+UFIPA)   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UFASTPP'
      write(iu,201) abrev
  201 format(' Fast ion prp energ dens (UBPRP_D+UBPRP_T+UFIPP)   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='UTOTL'
      write(iu,202) abrev
  202 format(' Tot energy den (UE+UI+UPHI+UFASTPA+UFASTPP)       @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='FTOTDT'
      write(iu,211) abrev
  211 format(' DT neut emission rate               [n/cm3/sec]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TTNTX'
      write(iu,212) abrev
  212 format(' Total neutron emission rate         [n/cm3/sec]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTE'
      write(iu,213) abrev
  213 format(' Electron Toroidal beta              [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTI'
      write(iu,214) abrev
  214 format(' Thermal Ion Toroidal beta           [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTPL'
      write(iu,215) abrev
  215 format(' Thermal Toroidal beta (=BTE+BTI)    [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTBE'
      write(iu,216) abrev
  216 format(' Beam Toroidal beta                  [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTMIN'
      write(iu,217) abrev
  217 format(' ICRF Minority Toroidal beta         [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTFI'
      write(iu,218) abrev
  218 format(' Fusion ion Toroidal beta            [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='BTTOT'
      write(iu,219) abrev
  219 format(' Total Toroidal beta (=BTPL+BTBM+BTMIN+BTFI)       @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PPLAS'
      write(iu,220) abrev
  220 format(' Thermal Pressure 2(UI+UE)/3         [Pascals]     @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PTOWB'
      write(iu,221) abrev
  221 format(' Total Press (Therm+3*UPHI/2+UFASTPA+UFASTPP/2)    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PMHD_IN'
      write(iu,251) abrev
  251 format(' Total Pressure (as input to MHD EQ solver)        @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='ZEFFP'
      write(iu,222) abrev
  222 format(' Plasma composition Z_eff            [no units]    @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='ETA_USE'
      write(iu,223) abrev
  223 format(' Resistivity used or inferred        [OHM*CM]      @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PBE'
      write(iu,226) abrev
  226 format(' beam-ele heating power              [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PBI'
      write(iu,227) abrev
  227 format(' beam-ion heating power              [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PBTH'
      write(iu,228) abrev
  228 format(' beam-thermalization heating power   [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PFE'
      write(iu,233) abrev
  233 format(' alpha-ele heating power             [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PFI'
      write(iu,234) abrev
  234 format(' alpha-ion heating power             [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='QICHE'
      write(iu,235) abrev
  235 format(' ICRH direct el heating power        [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='QICHI'
      write(iu,236) abrev
  236 format(' ICRH direct ion heating power       [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='QICHMIN'
      write(iu,237) abrev
  237 format(' ICRH minority ion heating power     [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='QICHA'
      write(iu,238) abrev
  238 format(' ICRH total heating power            [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PELH'
      write(iu,239) abrev
  239 format(' LowerHybrid-ele heating power       [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='PEECH'
      write(iu,240) abrev
  240 format(' ECRH-ele heating power              [Watts/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='TQIN'
      write(iu,730) abrev
  730 format(' Total Input Torque                   [Nt-m/cm**3] @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='OMEGA'
      write(iu,250) abrev
  250 format(' thermal plasma toroidal rotation    [radians/s]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='OMEGB'
      write(iu,241) abrev
  241 format(' beam toroidal rotation              [radians/s]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='OMEGF_4'
      write(iu,242) abrev
  242 format(' fusion alpha toroidal rotation      [radians/s]   @X ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='EPOTRO'
      write(iu,243) abrev
  243 format(' Radial Potential due to rotaion     [Volts]      @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='EPOTNC'
      write(iu,244) abrev
  244 format(' Radial Potential due to rotation NCLASS [Volts]  @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      abrev='VRPOT'
      write(iu,245) abrev
  245 format(' Radial Electrical Potential         [Volts]      @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      tsl_min = 1.0e20
      tsl_max = 0.0

      abrev='TSL1A_H'
      write(iu,246) abrev
 246  format(' H (co) beam slowing down time       [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update

      abrev='TSL1B_H'
      write(iu,247) abrev
 247  format(' H (ctr) beam slowing down time      [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1A_D'
      write(iu,248) abrev
 248  format(' D (co) beam slowing down time       [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1B_D'
      write(iu,249) abrev
 249  format(' D (ctr) beam slowing down time      [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1A_T'
      write(iu,260) abrev
 260  format(' T (co) beam slowing down time       [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1B_T'
      write(iu,261) abrev
 261  format(' T (ctr) beam slowing down time      [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1A_3'
      write(iu,262) abrev
 262  format(' He3 (co) beam slowing down time     [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1B_3'
      write(iu,263) abrev
 263  format(' He3 (ctr) beam slowing down time    [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1A_4'
      write(iu,252) abrev
 252  format(' He4 (co) beam slowing down time     [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TSL1B_4'
      write(iu,253) abrev
 253  format(' He4 (ctr) beam slowing down time    [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TFSL_4'
      write(iu,254) abrev
 254  format(' He4 fusion alpha slowing down time  [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TFSL_3'
      write(iu,255) abrev
 255  format(' He3 fusion ion slowing down time    [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update
 
      abrev='TFSL_T'
      write(iu,256) abrev
 256  format(' T fusion ion slowing down time      [s]          @XB ',
     &  'RPLOT abrev = ',a10)
      call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      if(igot.gt.0) call tsl_update

      write(6,*) ' ...minimum fast ion slowing down time: ',tsl_min
      write(6,*) ' ...maximum fast ion slowing down time: ',tsl_max

      ! next format stmt #: 265 recommended
      !-----------------------

      write(iu,400)
  400 format(' Fourier moments of flux surfaces')

      ! modified DMC Jan 2009 -- at physicist request, write all files
      ! as if equilibrium is up-down ASYMMETRIC.  So, for up-down symmetric
      ! data, map RMMnn -> RMCnn w/RMSnn zero; map YMMnn -> YMSnn w/YMCnn zero.
      ! EXCEPTION:  scalar PLHGT -> YMC00 in case of updown symmetry.

      abrev='RMM01'
      call rpexist_profile(abrev,nlsym)
      if(nlsym) then
         ! get plasma vertical offset (allowed in up-down symmetric equilibria)
         abrev='ZPLAS'
         call t1scalar(abrev,zlabel,zunits,time,deltat,plhgt,idum)
      endif

  500 format(1x,a,'RPLOT abrev = ',a10)

      ! try updown symmetric moments
      do imom=0,imom_max
         abrev=' '
         write(abrev,'("RMM",i2.2)') imom
         call gen_mlabel(imom,'symm R cos(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         if(nlsym) then
            abrev='RMC01'  ! this will force zeroes in nlsym=T case...
         endif
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
         if((igot.eq.0).and.(imom.ge.imom_min)) exit
      enddo

      do imom=0,imom_max
         abrev=' '
         write(abrev,'("YMM",i2.2)') imom
         call gen_mlabel(imom,'symm Y sin(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         if(nlsym) then
            abrev='RMC01'  ! this will force zeroes in nlsym=T case...
         endif
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
         if((igot.eq.0).and.(imom.ge.imom_min)) exit
      enddo

      ! try R & Y asym cos moments (start at 0)
      ! the number of non-zero R cos moments sets the number for the rest

      do imom=0,imom_max
         abrev=' '
         write(abrev,'("RMC",i2.2)') imom
         call gen_mlabel(imom,'asym R cos(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         if(nlsym) then
            abrev(1:3)='RMM'
         endif
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
         if((igot.eq.0).and.(imom.ge.imom_min)) exit
         imom_save=imom + 1
      enddo

      if(nlsym) then
         abrev='YMC00'
         imom=0
         call gen_mlabel(imom,'asym Y cos(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         pbuf(1:nzones)=plhgt
         ! call with ' ' to use pbuf provided
         call get_profil(' ',time,deltat,nxmax,pbuf,igot)
         imom_start=1
      else
         imom_start=0
      endif

      do imom=imom_start,imom_save
         abrev=' '
         write(abrev,'("YMC",i2.2)') imom
         call gen_mlabel(imom,'asym Y cos(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
      enddo

      ! try R & Y asym sin moments (start at 1)

      do imom=1,imom_save
         abrev=' '
         write(abrev,'("RMS",i2.2)') imom
         call gen_mlabel(imom,'asym R sin(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
      enddo

      do imom=1,imom_save
         abrev=' '
         write(abrev,'("YMS",i2.2)') imom
         call gen_mlabel(imom,'asym Y sin(k*theta) moment  [cm]')
         write(iu,500) mlabel,abrev
         if(nlsym) then
            abrev(1:3)='YMM'
         endif
         call get_profil(abrev,time,deltat,nxmax,pbuf,igot)
      enddo
 
      !----------------------------
      ! trailing labels...
 
      call fdate(realtime)
 
      call sget_host(hostname)
      ilhost=len_trim(hostname)
 
      call sget_user(username)
      iluser=len_trim(username)
 
      write(iu,997) realtime,hostname(1:ilhost),username(1:iluser)
      write(iu,998)
      write(iu,999)
  997 format(' file writen on ',a24/
     >   ' on node ',a,' by physicist: ',a)
  998 format(' Warning: Preliminary results.')
  999 format(' Check with physicist before using in publications.')
 
      ! ascii file write completed.

      !----------------------------
      !  NetCDF file

      if(cdf_file.ne.' ') then

         call ts_cdf_write(cdf_file,iu,inumsc,inumpro,nzones,ierr_open)

      endif

      !----------------------------
      if(itmp.gt.0) then
         close (unit=iu, status='delete')
      else
         close (unit=iu)  ! keep ASCII file
      endif

      !----------------------------
      if(tsl_max.gt.0.0) then
         idtms = 1000.0*(tsl_min/5)  ! integer timestep in milliseconds
         idtms = min(9999,max(5,idtms))  ! 5ms minimum
         idtct = 1.3333e3*tsl_max/idtms  ! number of timesteps to cover
                                ! (4/3) maximum slowing down time

         idts = idtms/1000
         idtms = idtms - 1000*idts
         idt1 = idtms/100
         idtms = idtms - 100*idt1
         idt2 = idtms/10
         idtms = idtms - 10*idt2
         idt3 = idtms

         nubeam_repeat=' '
         write(nubeam_repeat,'(i5,"x",i1,".",3(i1))') idtct,
     >        idts,idt1,idt2,idt3
         !  compress
         ii=0
         do ic=1,len(nubeam_repeat)
            if(nubeam_repeat(ic:ic).ne.' ') then
               ii=ii+1
               if(ii.lt.ic) nubeam_repeat(ii:ii)=nubeam_repeat(ic:ic)
            endif
         enddo
         nubeam_repeat(ii+1:)=' '

         write(6,*) ' NUBEAM_REPEAT_COUNT advice based on '//
     >        'slowing down times: '//trim(nubeam_repeat)

         open(unit=iu,file=trim(zfile_nbstep),status='unknown',
     >        iostat=istat)
         if(istat.eq.0) then
            write(iu,7701) trim(nubeam_repeat)
            close(unit=iu)
            write(6,*) ' %wrote: '//trim(zfile_nbstep)
         else
            write(6,*) ' ?open failure: '//trim(zfile_nbstep)
         endif

 7701    format(' suggested NUBEAM_REPEAT_COUNT time step setting:',
     >        1x,a)
      endif

      if(allocated(pbuf)) deallocate(pbuf)
      if(allocated(izc_imp)) deallocate(izc_imp,zz_imp,aa_imp,abrev_imp)
      if(allocated(izc_rf)) deallocate(izc_rf,zz_rf,aa_rf,abrev_rf)

      return

      !---------------------------
      CONTAINS
      !---------------------------

      subroutine get_scalar(abrev,time,deltat,sdata)
 
      implicit NONE
 
c  get one scalar -- CONTAINed subroutine
 
      character*(*), intent(in) :: abrev ! scalar item name
      real,intent(in) :: time,deltat    ! time +/- averaging delta(t)
      real,intent(out) :: sdata         ! data read (or ZERO if not found)
 
      character*50 zlabel,zunits
      integer ierr
      logical :: iexist

      inumsc = inumsc + 1

      call rpexist_scalar(abrev,iexist)

      sdata=0.0
      if(.not.iexist) then
         write(6,*) ' %scalar not found: ',trim(abrev)

      else
         call t1scalar(abrev,zlabel,zunits,time,deltat,sdata,ierr)
         if(ierr.ne.0) then
            write(6,*) ' ?? unexpected t1scalar error on: ',trim(abrev)
            sdata=0.0
         endif
      endif
 
      return
      end subroutine get_scalar
 
c-----------------------------------------------------------------------
      subroutine get_profil(abrev,time,deltat,nxmax,pbuf,igot)
 
      implicit NONE
 
c  get one profile -- CONTAINed subroutine
 
      character*(*), intent(in) :: abrev ! profile name
      real, intent(in) :: time,deltat   ! time +/- averaging delta(t)
      integer, intent(in) :: nxmax      ! buffer size
      real, intent(out) :: pbuf(nxmax)  ! buffer
      integer, intent(out) :: igot      ! no. of values retrieved.
 
      character zlabel*32,zunits*16
      integer itype,ierr,j1,j2,k,iuse
      logical :: iexist

      ! mod: if abrev is blank, assume caller has filled pbuf

      inumpro = inumpro + 1

      if(abrev.eq.' ') then
         iuse=nzones
         igot=nzones

      else
         call rpexist_profile(abrev,iexist)
 
         if(.not.iexist) then
            write(6,*) ' %profile not found: ',trim(abrev)
            pbuf = 0.0
            igot = 0
            iuse = nzones

         else
            call t1profil(abrev,zlabel,zunits,time,deltat,itype,
     >           pbuf,nxmax,igot,ierr)
 
            if(ierr.ne.0) then
               pbuf=0.0
               igot = 0
               iuse = nzones
               write(6,*) ' ?? unexpected t1profil error on: ',
     >              trim(abrev)
            else
               iuse = igot      ! the usual case...
            endif
         endif
      endif
 
      do j1=1,iuse,5
         j2=min(iuse,j1+4)
         write(iu,801) (pbuf(k),k=j1,j2)
      enddo
  801 format(5(2x,1pe11.4))
 
      return
      end subroutine get_profil

c-----------------------------------------------------------------------
      subroutine gen_mlabel(k,tag)
      
      ! generate label for moments profile

      integer, intent(in) :: k
      character*(*) :: tag

      integer :: kmod,ktens

      mlabel=' '

      if(k.lt.10) then
         if(k.eq.1) then
            write(mlabel,'("k=",i1,"st ",a)') k,tag
         else if(k.eq.2) then
            write(mlabel,'("k=",i1,"nd ",a)') k,tag
         else if(k.eq.3) then
            write(mlabel,'("k=",i1,"rd ",a)') k,tag
         else
            write(mlabel,'("k=",i1,"th ",a)') k,tag
         endif
      else if(k.lt.20) then
         write(mlabel,'("k=",i2,"th ",a)') k,tag
      else
         ktens=k/10
         kmod = k - 10*ktens
         if(kmod.eq.1) then
            write(mlabel,'("k=",i2,"st ",a)') k,tag
         else if(kmod.eq.2) then
            write(mlabel,'("k=",i2,"nd ",a)') k,tag
         else if(kmod.eq.3) then
            write(mlabel,'("k=",i2,"rd ",a)') k,tag
         else
            write(mlabel,'("k=",i2,"th ",a)') k,tag
         endif
      endif

      mlabel(50:52)='@XB'

      end subroutine gen_mlabel

      subroutine tsl_update

        ! find min & max of non-zero slowing down times...
        do ii=1,igot
           if(pbuf(ii).gt.0.0) then
              tsl_min=min(tsl_min,pbuf(ii))
              tsl_max=max(tsl_max,pbuf(ii))
           endif
        enddo

      end subroutine tsl_update
      
      subroutine nbstep_filename(zname)
      
        ! form filename "<root>.nbstep" to contain NUBEAM time step
        ! recommendation in form <repeat_count>x<time_step>...

        character*(*), intent(in) :: zname

        integer :: ic,idot,ibrk,ilen

        ilen = len(trim(zname))
        idot = 0
        do ic = ilen,1,-1
           if(zname(ic:ic).eq.'/') exit
           if(zname(ic:ic).eq.'.') then
              idot=ic
              exit
           endif
        enddo

        if(idot.eq.0) then
           ibrk=ilen
        else
           ibrk=idot-1
        endif

        zfile_nbstep = zname(1:ibrk)//'.nbstep'

      end subroutine nbstep_filename

      !-----------------------------
      END  ! subroutine ts_write_r4
      !-----------------------------

      subroutine trxpl_mkgs2_summ(lunt,zlbl)
c
      use trxpl_gs2_module
      implicit NONE
c
c  write summary of plasma species
c
      integer, intent(in) :: lunt       ! where to write
      character*(*), intent(in) :: zlbl ! what to write for Z & A
c
c  zlbl is used with aggregate species where Z & A are profiles.
c
c----------------------------------------
      integer i
c----------------------------------------
c
         write(lunt,*) ' '
         write(lunt,1001)
 1001    format(
     >   ' #    label                           Z      ',
     >      'A/mref  Tsmooth Nsmooth'/
     >   ' ---  ------------------------------ ------- ',
     >      '------- ------- -------')
         do i=1,num_species
            if(id_zprof(i).eq.0) then
               write(lunt,1002) i, slabel(i),Zplas(i),Aplas(i),
     >            tsmoo(i),nsmoo(i)
 1002          format(1x,i3,'. ',a30,1x,f7.4,1x,f7.4,2(3x,l1,4x))
            else
               write(lunt,1012) i, slabel(i),zlbl,
     >            tsmoo(i),nsmoo(i)
 1012          format(1x,i3,'. ',a30,1x,a15,2(3x,l1,4x))
            endif
         enddo
c
         return
         end

subroutine tdb_nplas(d,inum)
  ! return number of non-impurity main plasma thermal species
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  integer, intent(out) :: inum  ! number of species returned

  inum = d%ngmax_d

end subroutine tdb_nplas

subroutine tdb_nfast(d,inum)
  ! return number of fast ion species
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  integer, intent(out) :: inum  ! number of species returned

  inum = d%nsfast_d

end subroutine tdb_nfast

subroutine tdb_plas(d,inum,zz,aa,ierr)
  ! return (in REAL*8 vectors) the Z & A values of main plasma species
  ! e.g. in a D,T plasma zz(1:2) = 1.0, 1.0 & aa(1:2) = 2.0, 3.0 returned.
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  integer, intent(in) :: inum  ! number of species (see tdb_nplas)
  real*8, intent(out) :: zz(inum)  ! Z values (atomic numbers) returned.
  real*8, intent(out) :: aa(inum)  ! A values (atomic weights) returned.
  integer, intent(out) :: ierr ! error code (0=OK) (1 means inum too small)

  integer :: inumi,ia

  zz = 0
  aa = 0

  if(inum.lt.d%ngmax_d) then
     ierr = 1
  else
     inumi = d%ngmax_d
     ia = d%ladr_za
     zz(1:inumi) = d%datbuf(ia:ia+inumi-1)
     ia = ia + inumi
     aa(1:inumi) = d%datbuf(ia:ia+inumi-1)
  endif

end subroutine tdb_plas
      
subroutine tdb_fast(d,inum,zz,aa,ierr)
  ! return (in REAL*8 vectors) the Z & A values of fast ion species
  ! e.g. for D,He3 beams zz(1:2) = 1.0, 2.0 & aa(1:2) = 2.0, 3.0 returned.
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  integer, intent(in) :: inum  ! number of species (see tdb_nfast)
  real*8, intent(out) :: zz(inum)  ! Z values (atomic numbers) returned.
  real*8, intent(out) :: aa(inum)  ! A values (atomic weights) returned.
  integer, intent(out) :: ierr ! error code (0=OK) (1 means inum too small)

  integer :: inumi,ia

  zz = 0
  aa = 0

  if(inum.lt.d%nsfast_d) then
     ierr = 1
  else
     inumi = d%nsfast_d
     ia = d%ladr_zaf
     zz(1:inumi) = d%datbuf(ia:ia+inumi-1)
     ia = ia + inumi
     aa(1:inumi) = d%datbuf(ia:ia+inumi-1)
  endif

end subroutine tdb_fast

subroutine trx_ntimes(insc,inpr,ierr)

  !   return the number of times in the run

  use trx_module
  implicit NONE

  integer, intent(OUT) :: insc     ! # of times, SCALAR f(t) data
  integer, intent(OUT) :: inpr     ! # of times, PROFILE f(x,t) data
  integer, intent(OUT) :: ierr     ! completion code: 0=OK

  !----------------------------------
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer lunzer
  !----------------------------------

  if(nsurf.eq.0) then
     write(lunzer(0),*) ' ?trx_ntimes: nsurf=0:  use trx_connect first!'
     ierr=1
     return
  endif

  ierr=0
  insc=nsctime
  inpr=nprtime

  return
end subroutine trx_ntimes

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_contents_sini(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !local:

  INTEGER :: id,inum
  INTEGER :: i1,i2,i3,i4

  !----------------

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! alla_index
        w%list_elems(isize) = "alla_index"
        w%elem_descr(isize) = "species index in original lists"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_alla)"
        IF(ALLOCATED(ss%alla_index)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_alla
              IF((ss%alla_index(I1).NE.0).AND.(ss%alla_index(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! all_index
        w%list_elems(isize) = "all_index"
        w%elem_descr(isize) = "species index in original lists"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_all)"
        IF(ALLOCATED(ss%all_index)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_all
              IF((ss%all_index(I1).NE.0).AND.(ss%all_index(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ANOM_Code_Info
        w%list_elems(isize) = "ANOM_Code_Info"
        w%elem_descr(isize) = "Information: code implementing ANOM component"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%ANOM_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Balloon_mapper
        w%list_elems(isize) = "Balloon_mapper"
        w%elem_descr(isize) = "mapper code used for each ballooning code"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nballoon)"
        IF(ALLOCATED(ss%Balloon_mapper)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nballoon
              IF(ss%Balloon_mapper(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! CUR_Data_Info
        w%list_elems(isize) = "CUR_Data_Info"
        w%elem_descr(isize) = "information on source of plasma current data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%CUR_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! DeltaW_mapper
        w%list_elems(isize) = "DeltaW_mapper"
        w%elem_descr(isize) = "mapper code used for each delta(W) code"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(ndelta_w)"
        IF(ALLOCATED(ss%DeltaW_mapper)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ndelta_w
              IF(ss%DeltaW_mapper(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EC_Code_Info
        w%list_elems(isize) = "EC_Code_Info"
        w%elem_descr(isize) = "Information: code implementing EC component"
        w%component(isize) = "EC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%EC_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EC_Data_Info
        w%list_elems(isize) = "EC_Data_Info"
        w%elem_descr(isize) = "information on source of ECRF power data"
        w%component(isize) = "EC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%EC_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EQ_Code_Info
        w%list_elems(isize) = "EQ_Code_Info"
        w%elem_descr(isize) = "Information: code implementing EQ component"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%EQ_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EQ_Data_Info
        w%list_elems(isize) = "EQ_Data_Info"
        w%elem_descr(isize) = "Information: source of EQ input data"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%EQ_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! fracmin
        w%list_elems(isize) = "fracmin"
        w%elem_descr(isize) = 'minority density fraction if kdens_rfmin="fraction"'
        w%component(isize) = "IC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nspec_rfmin)"
        IF(ALLOCATED(ss%fracmin)) THEN
           IF(MAXVAL(ABS(ss%fracmin)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! FUS_Code_Info
        w%list_elems(isize) = "FUS_Code_Info"
        w%elem_descr(isize) = "Information: code implementing FUS component"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%FUS_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! GAS_Code_Info
        w%list_elems(isize) = "GAS_Code_Info"
        w%elem_descr(isize) = "Information: code implementing GAS component"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%GAS_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Global_label
        w%list_elems(isize) = "Global_label"
        w%elem_descr(isize) = "Run Label"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%Global_label.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! icircuit_coil
        w%list_elems(isize) = "icircuit_coil"
        w%elem_descr(isize) = "index of circuit to which each coil belongs"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ncoils)"
        IF(ALLOCATED(ss%icircuit_coil)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ncoils
              IF((ss%icircuit_coil(I1).NE.0).AND.(ss%icircuit_coil(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! IC_Code_Info
        w%list_elems(isize) = "IC_Code_Info"
        w%elem_descr(isize) = "Information: code implementing IC component"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%IC_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! IC_Data_Info
        w%list_elems(isize) = "IC_Data_Info"
        w%elem_descr(isize) = "information on source of ICRF power data"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%IC_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! kdens_rfmin
        w%list_elems(isize) = "kdens_rfmin"
        w%elem_descr(isize) = '= "fraction" => nmini(i) = fracmin(i)*ne'
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%kdens_rfmin.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LH_Code_Info
        w%list_elems(isize) = "LH_Code_Info"
        w%elem_descr(isize) = "Information: code implementing LH component"
        w%component(isize) = "LH"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%LH_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LH_Data_Info
        w%list_elems(isize) = "LH_Data_Info"
        w%elem_descr(isize) = "Information on source of LHRF power data"
        w%component(isize) = "LH"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%LH_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LMHD_eq_code
        w%list_elems(isize) = "LMHD_eq_code"
        w%elem_descr(isize) = "name of MHD equilibrium refinement code used"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%LMHD_eq_code.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! NBI_Code_Info
        w%list_elems(isize) = "NBI_Code_Info"
        w%elem_descr(isize) = "Information: code implementing NBI component"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%NBI_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! NBI_Data_Info
        w%list_elems(isize) = "NBI_Data_Info"
        w%elem_descr(isize) = "information on source of beam power & voltage data"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%NBI_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Newcomb_mapper
        w%list_elems(isize) = "Newcomb_mapper"
        w%elem_descr(isize) = "mapper code used for each Newcomb code"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(nnewcomb)"
        IF(ALLOCATED(ss%Newcomb_mapper)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nnewcomb
              IF(ss%Newcomb_mapper(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nky_anomth
        w%list_elems(isize) = "nky_anomth"
        w%elem_descr(isize) = "number of points, ky grid ( anomalous data over ky spectrum)"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%nky_anomth.EQ.0).OR.(ss%nky_anomth.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nky_mmm
        w%list_elems(isize) = "nky_mmm"
        w%elem_descr(isize) = "number of points, ky grid for MMM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%nky_mmm.EQ.0).OR.(ss%nky_mmm.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nmom
        w%list_elems(isize) = "nmom"
        w%elem_descr(isize) = "number of Fourier (R,Z) moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%nmom.EQ.0).OR.(ss%nmom.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ns_Data_Info
        w%list_elems(isize) = "ns_Data_Info"
        w%elem_descr(isize) = "information on source of Density data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%ns_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PEL_Code_Info
        w%list_elems(isize) = "PEL_Code_Info"
        w%elem_descr(isize) = "Information: code implementing PELLET component"
        w%component(isize) = "PEL"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%PEL_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PEL_Data_Info
        w%list_elems(isize) = "PEL_Data_Info"
        w%elem_descr(isize) = "Information: on source of pellet injection"
        w%component(isize) = "PEL"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%PEL_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PLASMA_Code_Info
        w%list_elems(isize) = "PLASMA_Code_Info"
        w%elem_descr(isize) = "Information: code managing PLASMA component"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%PLASMA_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RAD_Code_Info
        w%list_elems(isize) = "RAD_Code_Info"
        w%elem_descr(isize) = "Information: code implementing RAD component"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%RAD_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RAD_Data_Info
        w%list_elems(isize) = "RAD_Data_Info"
        w%elem_descr(isize) = "Information on source of radiated power data"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%RAD_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! rfmin_to_all
        w%list_elems(isize) = "rfmin_to_all"
        w%elem_descr(isize) = 'map rfmin index to "all" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_rfmin)"
        IF(ALLOCATED(ss%rfmin_to_all)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_rfmin
              IF((ss%rfmin_to_all(I1).NE.0).AND.(ss%rfmin_to_all(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! rfmin_to_alla
        w%list_elems(isize) = "rfmin_to_alla"
        w%elem_descr(isize) = 'map rfmin index to "alla" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_rfmin)"
        IF(ALLOCATED(ss%rfmin_to_alla)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_rfmin
              IF((ss%rfmin_to_alla(I1).NE.0).AND.(ss%rfmin_to_alla(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RUNAWAY_Code_Info
        w%list_elems(isize) = "RUNAWAY_Code_Info"
        w%elem_descr(isize) = "Information: code implementing RUNAWAY component"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%RUNAWAY_Code_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RunID
        w%list_elems(isize) = "RunID"
        w%elem_descr(isize) = "Run ID"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%RunID.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sa_index
        w%list_elems(isize) = "sa_index"
        w%elem_descr(isize) = "species index in original lists"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_all)"
        IF(ALLOCATED(ss%sa_index)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_all
              IF((ss%sa_index(I1).NE.0).AND.(ss%sa_index(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sc0_to_sgas
        w%list_elems(isize) = "sc0_to_sgas"
        w%elem_descr(isize) = "index map from neutral source to neutral species"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%sc0_to_sgas)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ngsc0
              IF((ss%sc0_to_sgas(I1).NE.0).AND.(ss%sc0_to_sgas(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sfus_to_all
        w%list_elems(isize) = "sfus_to_all"
        w%elem_descr(isize) = 'map sfus index to "all" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_fusion)"
        IF(ALLOCATED(ss%sfus_to_all)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_fusion
              IF((ss%sfus_to_all(I1).NE.0).AND.(ss%sfus_to_all(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sfus_to_alla
        w%list_elems(isize) = "sfus_to_alla"
        w%elem_descr(isize) = 'map sfus index to "alla" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_fusion)"
        IF(ALLOCATED(ss%sfus_to_alla)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_fusion
              IF((ss%sfus_to_alla(I1).NE.0).AND.(ss%sfus_to_alla(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sgas_to_s
        w%list_elems(isize) = "sgas_to_s"
        w%elem_descr(isize) = 'map sgas index to "s" list'
        w%component(isize) = "GAS"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_gas)"
        IF(ALLOCATED(ss%sgas_to_s)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_gas
              IF((ss%sgas_to_s(I1).NE.0).AND.(ss%sgas_to_s(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! simp0_to_s
        w%list_elems(isize) = "simp0_to_s"
        w%elem_descr(isize) = 'map simp0 index to "s" list'
        w%component(isize) = "GAS"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_imp0)"
        IF(ALLOCATED(ss%simp0_to_s)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_imp0
              IF((ss%simp0_to_s(I1).NE.0).AND.(ss%simp0_to_s(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! simpi_to_s
        w%list_elems(isize) = "simpi_to_s"
        w%elem_descr(isize) = 'map simpi index to "s" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_impi)"
        IF(ALLOCATED(ss%simpi_to_s)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_impi
              IF((ss%simpi_to_s(I1).NE.0).AND.(ss%simpi_to_s(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! snbi_to_all
        w%list_elems(isize) = "snbi_to_all"
        w%elem_descr(isize) = 'map snbi index to "all" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_beam)"
        IF(ALLOCATED(ss%snbi_to_all)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_beam
              IF((ss%snbi_to_all(I1).NE.0).AND.(ss%snbi_to_all(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! snbi_to_alla
        w%list_elems(isize) = "snbi_to_alla"
        w%elem_descr(isize) = 'map snbi index to "alla" list'
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_beam)"
        IF(ALLOCATED(ss%snbi_to_alla)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_beam
              IF((ss%snbi_to_alla(I1).NE.0).AND.(ss%snbi_to_alla(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! s_to_sa
        w%list_elems(isize) = "s_to_sa"
        w%elem_descr(isize) = "address in sa species list"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%s_to_sa)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_th
              IF((ss%s_to_sa(I1).NE.0).AND.(ss%s_to_sa(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! tfinal
        w%list_elems(isize) = "tfinal"
        w%elem_descr(isize) = "stop time of simulation (may be adjustable)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        IF(ss%tfinal.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! TF_Data_Info
        w%list_elems(isize) = "TF_Data_Info"
        w%elem_descr(isize) = "information on source of toroidal field data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%TF_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! tinit
        w%list_elems(isize) = "tinit"
        w%elem_descr(isize) = "start time of simulation"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        IF(ss%tinit.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Tor_mode_No
        w%list_elems(isize) = "Tor_mode_No"
        w%elem_descr(isize) = "(from input) Toroidal modes monitored"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(mmodes)"
        IF(ALLOCATED(ss%Tor_mode_No)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%mmodes
              IF((ss%Tor_mode_No(I1).NE.0).AND.(ss%Tor_mode_No(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! trace_flag
        w%list_elems(isize) = "trace_flag"
        w%elem_descr(isize) = "trace element flag"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%trace_flag)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nbeam
              IF((ss%trace_flag(I1).NE.0).AND.(ss%trace_flag(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! trmodels
        w%list_elems(isize) = "trmodels"
        w%elem_descr(isize) = "short description or ID of transport models"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(ntrcat)"
        IF(ALLOCATED(ss%trmodels)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ntrcat
              IF(ss%trmodels(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Ts_Data_Info
        w%list_elems(isize) = "Ts_Data_Info"
        w%elem_descr(isize) = "information on source of Temperature data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%Ts_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! vpol_Data_Info
        w%list_elems(isize) = "vpol_Data_Info"
        w%elem_descr(isize) = "information on source of poloidal velocity data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%vpol_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! VSUR_Data_Info
        w%list_elems(isize) = "VSUR_Data_Info"
        w%elem_descr(isize) = "information on source of surface voltage data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%VSUR_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! vtor_Data_Info
        w%list_elems(isize) = "vtor_Data_Info"
        w%elem_descr(isize) = "information on source of toroidal velocity data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%vtor_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Z0max
        w%list_elems(isize) = "Z0max"
        w%elem_descr(isize) = "maximum Z of non-impurity species"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%Z0max.EQ.0).OR.(ss%Z0max.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ZEFF_Data_Info
        w%list_elems(isize) = "ZEFF_Data_Info"
        w%elem_descr(isize) = "information on source of Zeff data"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%ZEFF_Data_Info.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Zimp1
        w%list_elems(isize) = "Zimp1"
        w%elem_descr(isize) = "lower limit on Z of impurity in reduced species list SA;"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%Zimp1.EQ.0).OR.(ss%Zimp1.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Zimp2
        w%list_elems(isize) = "Zimp2"
        w%elem_descr(isize) = "upper limit on Z of impurity in SA species list;"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%Zimp2.EQ.0).OR.(ss%Zimp2.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_sini

!.........................................................................
!         SUBROUTINE TR_GETNL_LINES
!.........................................................................
 
subroutine tr_getnl_lines(ilun,ierr)
!
  use tr_getnl
  implicit NONE
!
  integer ilun                ! lun for file read (input)
  integer ierr                ! completion code:  0=OK
!
  integer iline,lt,lunzer
  character*120 zline
!------------------------------
!
  lt=lunzer(0)
 
10 continue
 
  read(ilun,'(A)',end=99) zline
  nltext_nlines=nltext_nlines+1
  go to 10
 
99 continue
 
  if(nltext_nlines.eq.0) then
     ierr=1
     nltext_nlines=0
     nltext_status=1
     write(lt,*) ' ?? trx_get_nltext:  namelist file has no lines.'
     go to 199
  endif
 
  rewind(ilun)
  if(allocated(nltext)) deallocate(nltext)
  if(allocated(nltext_lens)) deallocate(nltext_lens)
  allocate(nltext(nltext_nlines))
  allocate(nltext_lens(nltext_nlines))
 
  if(allocated(mltext)) deallocate(mltext)
  if(allocated(mltext_lens)) deallocate(mltext_lens)
  allocate(mltext(nltext_nlines+50))
  allocate(mltext_lens(nltext_nlines+50))
  mltext_nlines=nltext_nlines
 
  do iline=1,nltext_nlines
     read(ilun,'(A)') nltext(iline)
     call tr_getnl_cleanup(nltext(iline))
     nltext_lens(iline)=len_trim(nltext(iline))
     mltext(iline)=nltext(iline)
  enddo
 
199 continue
 
  close(unit=ilun)
 
  return
end subroutine tr_getnl_lines
 
subroutine tr_getnl_cleanup(zline)
  ! detab lines
 
  implicit NONE
 
  character*(*) zline
 
  integer i,il
  character*1 ztab,zquot,c
 
  !--------------------------------------
 
  ztab=char(9)
  zquot=' '
 
  il=len_trim(zline)
  do i=1,il
     c=zline(i:i)
     if(zquot.ne.' ') then
        if(c.eq.zquot) zquot=' '  ! closing quote
     else
        if(c.eq.'"') then
           zquot = c              ! opening double quote
        else if(c.eq."'") then
           zquot = c              ! opening single quote
        else if(c.eq.'!') then
           exit                   ! terminating comment
        else if(c.eq.ztab) then
           zline(i:i)=' '         ! detab lines (not cmts or quoted strings)
        endif
     endif
  enddo
 
end subroutine tr_getnl_cleanup

c------------------------------------------------------------------
      subroutine trxpl_ufiles(tokdev,zdate,scvals,sclabs,numsc)
c
c  Ufile write interface
c
c  can write profiles as Ufiles.  All Ufiles will incorporate all scalars.
c  can either write f(rho) 1d Ufiles or 2d Ufiles f(R,Z) if the profile
c  has been extended to the (R,Z) space.
c
c  ** caution ** Ufiles are single precision.  Precision will be lost.
c
c  inputs:  passed arguments
c  outputs:  Ufiles.
c
c  scalars:
c
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
      character*4 tokdev                ! tokamak id
      character*10 zdate                ! shot date
c
      integer numsc                     ! number of scalars
      real*8 scvals(numsc)              ! scalar values
      character*10 sclabs(3,numsc)      ! scalar names, labels, units.
c
c------------------------------------------------
c  profile information (to be fetched from trxplib routines)
c
      integer, parameter :: maxpr = 1000
      integer numpr                     ! number of profiles
      integer idlist(maxpr)             ! xplasma id # for each profile
      character*10 prlabel(3,maxpr)     ! profiles labels, units
      integer pr_magdim(maxpr)          ! presence code:  f(rho,...)
      integer pr_magord(maxpr)          ! spline ordering
      integer pr_rzdim(maxpr)           ! presence code:  f(R,Z,...)
      integer pr_rzord(maxpr)           ! spline ordering
c
c  pr_magdim(j)=0 if its f(R,Z) only
c  pr_rzdim(j)=0 if no f(R,Z) is available.
c
c----------------------------------------------------------
      integer i,j,k,inc,ierr,ilz,idim,ityp
      integer inumR,inumZ,inumrho,inumth,inumphi,istat,iwarn
      integer iBR,iBZ,iBphi,ishot,ixid
      logical default
c
      real*8 Rmin,Rmax,Zmin,Zmax,rhomin,rhomax,thmin,thmax
c
      real*8, dimension(:), allocatable :: rhoarr,tharr,Rarr,Zarr,data1
      real*8, dimension(:,:), allocatable :: data2
      real*8, dimension(:), allocatable :: wk
c
      integer lnout
      logical lxout,lchar,lyes
      character*70 zline
      character*10 zanswer
      character*10 zdate2,zshot,zdigs
      character*20 zuflbl
c
      character*10 rholab(3),thlab(3),Rlab(3),Zlab(3)
      character*4 jlbl
c
c
      save inumR,inumZ,inumrho,inumth,inumphi
      data default/.TRUE./
      data zdigs/'0123456789'/
c
c----------------------------------------------------------
c
      rholab(1)='rho'
      rholab(2)=' '
      rholab(3)=' '
c
      thmin=0.0_R8
      thmax=2.0_R8*acos(-1.0_R8)
c
      thlab(1)='theta'
      thlab(2)=' '
      thlab(3)='radians'
c
      Rlab(1)='R'
      Rlab(2)=' '
      Rlab(3)='m'
c
      Zlab(1)='Z'
      Zlab(2)=' '
      Zlab(3)='m'
c
      jlbl(1:4)='ZLHS'
c
c  how many digits in shot no.?
c
      j=10
      do i=1,10
         if(index(zdigs,sclabs(3,1)(i:i)).eq.0) then
            j=i-1
            exit
         endif
      enddo
c
      if(j.gt.6) then
         if((sclabs(3,1)(1:1).eq.'7').or.
     >      (sclabs(3,1)(1:1).eq.'8').or.
     >      (sclabs(3,1)(1:1).eq.'9')) then
            zdate2='19'//sclabs(3,1)(1:2)
         else
            zdate2='20'//sclabs(3,1)(1:2)
         endif
         read(sclabs(3,1)(j-5:j),'(I6)') ishot
      else
         if((zdate(1:1).eq.'7').or.
     >      (zdate(1:1).eq.'8').or.
     >      (zdate(1:1).eq.'9')) then
            zdate2='19'//zdate(1:2)
         else
            zdate2='20'//zdate(1:2)
         endif
         zshot=' '
         zshot(6-j+1:6)=sclabs(3,1)(1:j) ! right justify
         read(zshot(1:6),'(I6)') ishot
      endif
c
      numpr=0
c
      k=0
      call trx_uget_next(k)
c
      iBR=0
      iBZ=0
      iBphi=0
c
      do while(k.gt.0)
c
c  get the profile information
c
         numpr=numpr+1
         idlist(numpr)=k
         if(numpr.gt.maxpr) then
            call errmsg_exit(' ?? trxpl_ufiles:  too many profiles.')
         else
            call trx_uget(k,ixid,prlabel(1,numpr),prlabel(3,numpr),
     >         istat,ierr)
            if(prlabel(1,numpr).eq.'BR') iBR=k
            if(prlabel(1,numpr).eq.'BZ') iBZ=k
            if(prlabel(1,numpr).eq.'BPHI') iBphi=k
            if(ierr.ne.0) then
               write(lnout(0),*) ' ?? trxpl_ufiles:  trx_uget error.'
               numpr=numpr-1
            else
               if(istat.gt.0) then
                  write(lnout(0),*) ' %caution:  may not be MKS:  ',
     >               prlabel(1,numpr),prlabel(3,numpr)
               endif
               prlabel(2,numpr)='(trxpl)'
               call eq_fun(k,pr_magdim(numpr),pr_magord(numpr),
     >            pr_rzdim(numpr),pr_rzord(numpr),iwarn,ierr)
               if((iwarn.gt.0).or.(ierr.gt.0)) then
                  write(lnout(0),*)
     >               ' %eq_fun error on:  ',prlabel(1,numpr)
                  numpr=numpr-1
               else
c  kluge for Bmod
                  if(prlabel(1,numpr).eq.'BMOD') then
                     pr_rzord(numpr)=1
                     pr_rzdim(numpr)=2
                  endif
               endif
            endif
         endif
         call trx_uget_next(k)
      enddo
c
      if(lxout(0)) then
         write(lnout(0),*) ' '
         write(lnout(0),*) ' trxpl_ufiles:  available profiles:'
         write(lnout(0),*) '   S=Spline  H=Hermite  L=Linear Pieces'
         write(lnout(0),*) ' name       units      f(rho)',
     >      ' f(rho,theta) f(R,Z)'
         write(lnout(0),*) ' '
         do i=1,numpr
            zline=' '//prlabel(1,i)//' '//prlabel(3,i)
            j=pr_magord(i)+2
            if(pr_magdim(i).eq.1) zline(26:26)=jlbl(j:j)
            if(pr_magdim(i).eq.2) zline(36:36)=jlbl(j:j)
            j=pr_rzord(i)+2
            if(pr_rzdim(i).eq.2) zline(46:46)=jlbl(j:j)
            write(lnout(0),*) zline
         enddo
         write(lnout(0),*) ' '
      endif
c
      if(default) call eq_ngrids(inumrho,inumth,inumphi,inumR,inumZ)
c
      call eq_rzlims(Rmin,Rmax,Zmin,Zmax,ierr)
      if(ierr.ne.0) return
      call eq_rholim(rhomin,rhomax)
c
 10   continue
      if(lxout(0)) then
         write(lnout(0),1000) 'flux grid (x)',inumrho,rhomin,rhomax
         write(lnout(0),1000) 'theta grid (th)',inumth,thmin,thmax
         write(lnout(0),1000) 'major rad (R)',inumR,Rmin,Rmax
         write(lnout(0),1000) 'elevation (Z)',inumZ,Zmin,Zmax
 1000    format(1x,a,' npts = ',i4,' min = ',1pd11.4,' max = ',1pd11.4)
         write(lnout(0),1001)
 1001    format(/
     >      ' enter a profile name for Ufile write options, or...'/
     >      ' enter "N" to reset grid sizes, or...'/
     >      ' enter "Q!" for Q profile'/
     >      ' enter "Q" to quit.')
      endif
c
      call ureadw('trxpl_ufiles:  enter option:$',zanswer)
c
      if(zanswer.eq.'Q') then
c
c  quit
c
         return
c
      else if(zanswer.eq.'N') then
c
c  set grid sizes
c
         call uread(' enter "Y" to select default sizes:$')
         if(lyes(0)) then
            default=.TRUE.
            call eq_ngrids(inumrho,inumth,inumphi,inumR,inumZ)
         else
            default=.FALSE.
            call ureadi(' no. of x pts (min 4):$',inumrho)
            inumrho=max(4,inumrho)
            call ureadi(' no. of th pts (min 4):$',inumth)
            inumrho=max(4,inumth)
            call ureadi(' no. of R pts (min 4):$',inumR)
            inumR=max(4,inumR)
            call ureadi(' no. of Z pts (min 4):$',inumZ)
            inumZ=max(4,inumZ)
         endif
c
      else
         if(zanswer.eq.'Q!') zanswer='Q'
         k=0
         do i=1,numpr
            if(zanswer.eq.prlabel(1,i)) k=i
         enddo
         if(k.eq.0) then
            call uermsg('?unrecognized profile name: ',zanswer,0)
         else
            ilz=len_trim(zanswer)
            if(pr_magdim(k).eq.0) then
               ityp=3
               idim=2
               zuflbl=zanswer(1:ilz)//' f(R,Z)'
            else if(pr_rzdim(k).eq.0) then
               if(pr_magdim(k).eq.1) then
                  ityp=1
                  idim=1
                  zuflbl=zanswer(1:ilz)//' f(rho)'
               else
                  ityp=2
                  idim=2
                  zuflbl=zanswer(1:ilz)//' f(rho,theta)'
               endif
            else
               call uread(
     >            ' enter "1" for mag coords., "2" for f(R,Z) Ufile:$')
               if(lchar('1')) then
                  if(pr_magdim(k).eq.1) then
                     ityp=1
                     idim=1
                     zuflbl=zanswer(1:ilz)//' f(rho)'
                  else
                     ityp=2
                     idim=2
                     zuflbl=zanswer(1:ilz)//' f(rho,theta)'
                  endif
               else if(lchar('2')) then
                  ityp=3
                  idim=2
                  zuflbl=zanswer(1:ilz)//' f(R,Z)'
               else
                  call uermsg(' must answer "1" or "2".',' ',0)
                  go to 10
               endif
            endif
c
            if(lxout(0)) then
               write(lnout(0),*) ' Ufile:  ',zuflbl,
     >            ' on evenly spaced grid.'
            endif
            call uread(' enter "Y" to verify:$')
            if(lyes(0)) then
c
               call ureadi(' shot number for naming Ufile:$',ishot)
               if(ityp.eq.1) then
c
c  1d Ufile
c
                  allocate(rhoarr(inumrho))
                  allocate(data1(inumrho))
                  do i=1,inumrho
                     rhoarr(i)=rhomin+(i-1)*(rhomax-rhomin)/(inumrho-1)
                  enddo
c
c  interpolation
c
                  call eq_rgetf(inumrho,rhoarr,idlist(k),0,data1,ierr)
                  if(ierr.eq.0) then
c
c  get filename, open, write, close
c
                     call ufnter(99,zuflbl)
                     call ufopwr(99,ishot,ierr)
                     if(ierr.eq.0) then
                        call r8_uf1dwr(99,tokdev,zdate2,
     >                     rhoarr,data1,inumrho,0,
     >                     rholab,prlabel(1,k),numsc,scvals,sclabs,ierr)
                     endif
                     call ufclos(99)
                  endif
c
                  deallocate(rhoarr)
                  deallocate(data1)
c
               else if(ityp.eq.2) then
c
c  2d Ufile f(rho,theta)
c
                  allocate(rhoarr(inumrho))
                  allocate(data1(inumrho))
 
                  do i=1,inumrho
                     rhoarr(i)=rhomin+(i-1)*(rhomax-rhomin)/(inumrho-1)
                  enddo
 
                  allocate(tharr(inumth))
                  do i=1,inumth
                     tharr(i)=thmin+(i-1)*(thmax-thmin)/(inumth-1)
                  enddo
 
                  allocate(data2(inumrho,inumth))
 
                  do j=1,inumth
                     data1=tharr(j)
c
c  for each theta value get all rho values
c
                     call eq_frhochi(inumrho,rhoarr,data1,1,idlist(k),
     >                  inumrho,data2(1,j),ierr)
                     if(ierr.ne.0) exit
                  enddo
c
c  get filename, open, write, close
c
                  if(ierr.eq.0) then
                     call ufnter(99,zuflbl)
                     call ufopwr(99,ishot,ierr)
                     if(ierr.eq.0) then
                        call r8_uf2dwr(99,tokdev,zdate2,
     >                     data2,inumrho,rhoarr,inumrho,tharr,inumth,0,
     >                     prlabel(1,k),rholab,thlab,
     >                     numsc,scvals,sclabs,ierr)
                     endif
                     call ufclos(99)
                  endif
c
                  deallocate(rhoarr)
                  deallocate(tharr)
                  deallocate(data1)
                  deallocate(data2)
c
               else if(ityp.eq.3) then
c
c  2d Ufile f(R,Z)
c
                  allocate(Rarr(inumR))
                  allocate(Zarr(inumZ))
                  allocate(data1(inumR))
                  allocate(data2(inumR,inumZ))
                  if(prlabel(1,k).eq.'BMOD') allocate(wk(inumR))
c
                  do i=1,inumR
                     Rarr(i)=Rmin+(i-1)*(Rmax-Rmin)/(inumR-1)
                  enddo
c
                  do i=1,inumZ
                     Zarr(i)=Zmin+(i-1)*(Zmax-Zmin)/(inumZ-1)
                  enddo
c
                  do j=1,inumZ
                     data1=Zarr(j)
c
c  for each Z interpolate to all R values
c
                     if(prlabel(1,k).ne.'BMOD') then
                        call eq_frz(inumR,Rarr,data1,1,idlist(k),inumR,
     >                     data2(1,j),ierr)
                     else
                        call eq_frz(inumR,Rarr,data1,1,iBR,inumR,
     >                     wk,ierr)
                        if(ierr.ne.0) exit
                        data2(1:inumR,j)=wk**2
                        call eq_frz(inumR,Rarr,data1,1,iBZ,inumR,
     >                     wk,ierr)
                        if(ierr.ne.0) exit
                        data2(1:inumR,j)=data2(1:inumR,j)+wk**2
                        call eq_frz(inumR,Rarr,data1,1,iBphi,inumR,
     >                     wk,ierr)
                        data2(1:inumR,j)=data2(1:inumR,j)+wk**2
                        data2(1:inumR,j)=sqrt(data2(1:inumR,j))
                     endif
                     if(ierr.ne.0) exit
                  enddo
                  if(ierr.eq.0) then
c
c  get filename, open, write, close
c
                     call ufnter(99,zuflbl)
                     call ufopwr(99,ishot,ierr)
                     if(ierr.eq.0) then
                        call r8_uf2dwr(99,tokdev,zdate2,
     >                     data2,inumR,Rarr,inumR,Zarr,inumZ,0,
     >                     prlabel(1,k),Rlab,Zlab,
     >                     numsc,scvals,sclabs,ierr)
                     endif
                     call ufclos(99)
                  endif
c
                  deallocate(Rarr)
                  deallocate(Zarr)
                  deallocate(data1)
                  deallocate(data2)
                  if(prlabel(1,k).eq.'BMOD') deallocate(wk)
               endif
            endif                       ! Ufile write request verified.
c
         endif                          ! profile name verified.
      endif                             ! option select.
c
      go to 10
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_0(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF((ALLOCATED(ss2%alla_index)).AND.(ALLOCATED(ss%alla_index))) THEN
     ss2%alla_index = ss%alla_index
  ENDIF
  IF((ALLOCATED(ss2%ALLA_name)).AND.(ALLOCATED(ss%ALLA_name))) THEN
     ss2%ALLA_name = ss%ALLA_name
  ENDIF
  IF((ALLOCATED(ss2%ALLA_type)).AND.(ALLOCATED(ss%ALLA_type))) THEN
     ss2%ALLA_type = ss%ALLA_type
  ENDIF
  IF((ALLOCATED(ss2%all_index)).AND.(ALLOCATED(ss%all_index))) THEN
     ss2%all_index = ss%all_index
  ENDIF
  IF((ALLOCATED(ss2%ALL_name)).AND.(ALLOCATED(ss%ALL_name))) THEN
     ss2%ALL_name = ss%ALL_name
  ENDIF
  IF((ALLOCATED(ss2%ALL_type)).AND.(ALLOCATED(ss%ALL_type))) THEN
     ss2%ALL_type = ss%ALL_type
  ENDIF
  IF( ((ALLOCATED(ss2%amaxlh)).AND.(ALLOCATED(ss%amaxlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%amaxlh = ss%amaxlh
  ENDIF
  IF( ((ALLOCATED(ss2%aminlh)).AND.(ALLOCATED(ss%aminlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%aminlh = ss%aminlh
  ENDIF
  IF( ((ALLOCATED(ss2%Ang_Href_coil)).AND.(ALLOCATED(ss%Ang_Href_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Ang_Href_coil = ss%Ang_Href_coil
  ENDIF
  IF( ((ALLOCATED(ss2%Ang_Vref_coil)).AND.(ALLOCATED(ss%Ang_Vref_coil))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%Ang_Vref_coil = ss%Ang_Vref_coil
  ENDIF
  IF((cclist(ps_cnum_ANOM).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%ANOM_Code_Info = ss%ANOM_Code_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_anom_evar = 0
  ENDIF
  IF((ALLOCATED(ss%anom_evar).AND.ALLOCATED(ss2%anom_evar)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%anom_evar = ss%anom_evar
     IF(.not.partial_copy) THEN
        ss2%id_anom_evar = ss%id_anom_evar
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%ant_model)).AND.(ALLOCATED(ss%ant_model))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%ant_model = ss%ant_model
  ENDIF
  IF( ((ALLOCATED(ss2%ap2_halfheight)).AND.(ALLOCATED(ss%ap2_halfheight))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap2_halfheight = ss%ap2_halfheight
  ENDIF
  IF( ((ALLOCATED(ss2%ap2_halfwidth)).AND.(ALLOCATED(ss%ap2_halfwidth))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap2_halfwidth = ss%ap2_halfwidth
  ENDIF
  IF( ((ALLOCATED(ss2%ap2_horiz_offset)).AND.(ALLOCATED(ss%ap2_horiz_offset))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap2_horiz_offset = ss%ap2_horiz_offset
  ENDIF
  IF( ((ALLOCATED(ss2%ap2_vert_offset)).AND.(ALLOCATED(ss%ap2_vert_offset))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap2_vert_offset = ss%ap2_vert_offset
  ENDIF
  IF( ((ALLOCATED(ss2%apolmaxlh)).AND.(ALLOCATED(ss%apolmaxlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%apolmaxlh = ss%apolmaxlh
  ENDIF
  IF( ((ALLOCATED(ss2%apolminlh)).AND.(ALLOCATED(ss%apolminlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%apolminlh = ss%apolminlh
  ENDIF
  IF( ((ALLOCATED(ss2%ap_halfheight)).AND.(ALLOCATED(ss%ap_halfheight))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap_halfheight = ss%ap_halfheight
  ENDIF
  IF( ((ALLOCATED(ss2%ap_halfwidth)).AND.(ALLOCATED(ss%ap_halfwidth))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap_halfwidth = ss%ap_halfwidth
  ENDIF
  IF( ((ALLOCATED(ss2%ap_horiz_offset)).AND.(ALLOCATED(ss%ap_horiz_offset))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap_horiz_offset = ss%ap_horiz_offset
  ENDIF
  IF( ((ALLOCATED(ss2%ap_vert_offset)).AND.(ALLOCATED(ss%ap_vert_offset))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%ap_vert_offset = ss%ap_vert_offset
  ENDIF
  IF(partial_copy) THEN
     ss2%id_area = 0
  ENDIF
  IF((ALLOCATED(ss%area).AND.ALLOCATED(ss2%area)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%area = ss%area
     IF(.not.partial_copy) THEN
        ss2%id_area = ss%id_area
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%atormaxlh)).AND.(ALLOCATED(ss%atormaxlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%atormaxlh = ss%atormaxlh
  ENDIF
  IF( ((ALLOCATED(ss2%atorminlh)).AND.(ALLOCATED(ss%atorminlh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%atorminlh = ss%atorminlh
  ENDIF
  IF( ((ALLOCATED(ss2%Balloon_code)).AND.(ALLOCATED(ss%Balloon_code))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Balloon_code = ss%Balloon_code
  ENDIF
  IF( ((ALLOCATED(ss2%Balloon_mapper)).AND.(ALLOCATED(ss%Balloon_mapper))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Balloon_mapper = ss%Balloon_mapper
  ENDIF
  IF( ((ALLOCATED(ss2%Balloon_stable)).AND.(ALLOCATED(ss%Balloon_stable))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Balloon_stable = ss%Balloon_stable
  ENDIF
  IF( ((ALLOCATED(ss2%Balloon_status)).AND.(ALLOCATED(ss%Balloon_status))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Balloon_status = ss%Balloon_status
  ENDIF
  IF(partial_copy) THEN
     ss2%id_balstab = 0
  ENDIF
  IF((ALLOCATED(ss%balstab).AND.ALLOCATED(ss2%balstab)).AND. &
        ((cclist(ps_cnum_LMHD).EQ.1))) THEN
     ss2%balstab = ss%balstab
     IF(.not.partial_copy) THEN
        ss2%id_balstab = ss%id_balstab
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%beam_type)).AND.(ALLOCATED(ss%beam_type))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%beam_type = ss%beam_type
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_bpass_co)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_bpass_co = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_bpass_co).AND.ALLOCATED(ss2%bidiff_bpass_co)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_bpass_co = ss%bidiff_bpass_co
     IF(ALLOCATED(ss2%id_bidiff_bpass_co)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_bpass_co = ss%id_bidiff_bpass_co
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_bpass_ctr)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_bpass_ctr = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_bpass_ctr).AND.ALLOCATED(ss2%bidiff_bpass_ctr)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_bpass_ctr = ss%bidiff_bpass_ctr
     IF(ALLOCATED(ss2%id_bidiff_bpass_ctr)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_bpass_ctr = ss%id_bidiff_bpass_ctr
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_btrap)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_btrap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_btrap).AND.ALLOCATED(ss2%bidiff_btrap)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_btrap = ss%bidiff_btrap
     IF(ALLOCATED(ss2%id_bidiff_btrap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_btrap = ss%id_bidiff_btrap
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_dpass_co)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_dpass_co = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_dpass_co).AND.ALLOCATED(ss2%bidiff_dpass_co)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_dpass_co = ss%bidiff_dpass_co
     IF(ALLOCATED(ss2%id_bidiff_dpass_co)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_dpass_co = ss%id_bidiff_dpass_co
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_dpass_ctr)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_dpass_ctr = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_dpass_ctr).AND.ALLOCATED(ss2%bidiff_dpass_ctr)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_dpass_ctr = ss%bidiff_dpass_ctr
     IF(ALLOCATED(ss2%id_bidiff_dpass_ctr)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_dpass_ctr = ss%id_bidiff_dpass_ctr
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_bidiff_dtrap)) THEN
     IF(partial_copy) THEN
        ss2%id_bidiff_dtrap = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%bidiff_dtrap).AND.ALLOCATED(ss2%bidiff_dtrap)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%bidiff_dtrap = ss%bidiff_dtrap
     IF(ALLOCATED(ss2%id_bidiff_dtrap)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_bidiff_dtrap = ss%id_bidiff_dtrap
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_BphiRZ = 0
  ENDIF
  IF((ALLOCATED(ss%BphiRZ).AND.ALLOCATED(ss2%BphiRZ)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%BphiRZ = ss%BphiRZ
     IF(.not.partial_copy) THEN
        ss2%id_BphiRZ = ss%id_BphiRZ
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_BRRZ = 0
  ENDIF
  IF((ALLOCATED(ss%BRRZ).AND.ALLOCATED(ss2%BRRZ)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%BRRZ = ss%BRRZ
     IF(.not.partial_copy) THEN
        ss2%id_BRRZ = ss%id_BRRZ
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_BZRZ = 0
  ENDIF
  IF((ALLOCATED(ss%BZRZ).AND.ALLOCATED(ss2%BZRZ)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%BZRZ = ss%BZRZ
     IF(.not.partial_copy) THEN
        ss2%id_BZRZ = ss%id_BZRZ
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%B_axis = ss%B_axis
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%B_axis_vac = ss%B_axis_vac
  ENDIF
  IF( ((ALLOCATED(ss2%b_halfHeight)).AND.(ALLOCATED(ss%b_halfHeight))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_halfHeight = ss%b_halfHeight
  ENDIF
  IF( ((ALLOCATED(ss2%b_halfwidth)).AND.(ALLOCATED(ss%b_halfwidth))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_halfwidth = ss%b_halfwidth
  ENDIF
  IF( ((ALLOCATED(ss2%b_Hdivergence)).AND.(ALLOCATED(ss%b_Hdivergence))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_Hdivergence = ss%b_Hdivergence
  ENDIF
  IF( ((ALLOCATED(ss2%b_Hfocal_length)).AND.(ALLOCATED(ss%b_Hfocal_length))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_Hfocal_length = ss%b_Hfocal_length
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%B_max_lcfs = ss%B_max_lcfs
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%B_min_lcfs = ss%B_min_lcfs
  ENDIF
  IF(partial_copy) THEN
     ss2%id_B_surfMax = 0
  ENDIF
  IF((ALLOCATED(ss%B_surfMax).AND.ALLOCATED(ss2%B_surfMax)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%B_surfMax = ss%B_surfMax
     IF(.not.partial_copy) THEN
        ss2%id_B_surfMax = ss%id_B_surfMax
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_B_surfMin = 0
  ENDIF
  IF((ALLOCATED(ss%B_surfMin).AND.ALLOCATED(ss2%B_surfMin)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%B_surfMin = ss%B_surfMin
     IF(.not.partial_copy) THEN
        ss2%id_B_surfMin = ss%id_B_surfMin
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%b_Vdivergence)).AND.(ALLOCATED(ss%b_Vdivergence))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_Vdivergence = ss%b_Vdivergence
  ENDIF
  IF( ((ALLOCATED(ss2%b_Vfocal_length)).AND.(ALLOCATED(ss%b_Vfocal_length))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%b_Vfocal_length = ss%b_Vfocal_length
  ENDIF
  IF(ALLOCATED(ss2%id_cdicrf)) THEN
     IF(partial_copy) THEN
        ss2%id_cdicrf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%cdicrf).AND.ALLOCATED(ss2%cdicrf)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%cdicrf = ss%cdicrf
     IF(ALLOCATED(ss2%id_cdicrf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_cdicrf = ss%id_cdicrf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_cdicrf_nphi)) THEN
     IF(partial_copy) THEN
        ss2%id_cdicrf_nphi = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%cdicrf_nphi).AND.ALLOCATED(ss2%cdicrf_nphi)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%cdicrf_nphi = ss%cdicrf_nphi
     IF(ALLOCATED(ss2%id_cdicrf_nphi)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_cdicrf_nphi = ss%id_cdicrf_nphi
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_anom = 0
  ENDIF
  IF((ALLOCATED(ss%chie_anom).AND.ALLOCATED(ss2%chie_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_anom = ss%chie_anom
     IF(.not.partial_copy) THEN
        ss2%id_chie_anom = ss%id_chie_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%chie_drbm).AND.ALLOCATED(ss2%chie_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_drbm = ss%chie_drbm
     IF(.not.partial_copy) THEN
        ss2%id_chie_drbm = ss%id_chie_drbm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_etg = 0
  ENDIF
  IF((ALLOCATED(ss%chie_etg).AND.ALLOCATED(ss2%chie_etg)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_etg = ss%chie_etg
     IF(.not.partial_copy) THEN
        ss2%id_chie_etg = ss%id_chie_etg
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_glf = 0
  ENDIF
  IF((ALLOCATED(ss%chie_glf).AND.ALLOCATED(ss2%chie_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_glf = ss%chie_glf
     IF(.not.partial_copy) THEN
        ss2%id_chie_glf = ss%id_chie_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%chie_gtcneo).AND.ALLOCATED(ss2%chie_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_gtcneo = ss%chie_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_chie_gtcneo = ss%id_chie_gtcneo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%chie_mmm71).AND.ALLOCATED(ss2%chie_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_mmm71 = ss%chie_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_chie_mmm71 = ss%id_chie_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_mtm = 0
  ENDIF
  IF((ALLOCATED(ss%chie_mtm).AND.ALLOCATED(ss2%chie_mtm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_mtm = ss%chie_mtm
     IF(.not.partial_copy) THEN
        ss2%id_chie_mtm = ss%id_chie_mtm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%chie_nclass).AND.ALLOCATED(ss2%chie_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_nclass = ss%chie_nclass
     IF(.not.partial_copy) THEN
        ss2%id_chie_nclass = ss%id_chie_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_neo = 0
  ENDIF
  IF((ALLOCATED(ss%chie_neo).AND.ALLOCATED(ss2%chie_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_neo = ss%chie_neo
     IF(.not.partial_copy) THEN
        ss2%id_chie_neo = ss%id_chie_neo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_ntm = 0
  ENDIF
  IF((ALLOCATED(ss%chie_ntm).AND.ALLOCATED(ss2%chie_ntm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_ntm = ss%chie_ntm
     IF(.not.partial_copy) THEN
        ss2%id_chie_ntm = ss%id_chie_ntm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_paleo = 0
  ENDIF
  IF((ALLOCATED(ss%chie_paleo).AND.ALLOCATED(ss2%chie_paleo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_paleo = ss%chie_paleo
     IF(.not.partial_copy) THEN
        ss2%id_chie_paleo = ss%id_chie_paleo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%chie_tglf).AND.ALLOCATED(ss2%chie_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_tglf = ss%chie_tglf
     IF(.not.partial_copy) THEN
        ss2%id_chie_tglf = ss%id_chie_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_trans = 0
  ENDIF
  IF((ALLOCATED(ss%chie_trans).AND.ALLOCATED(ss2%chie_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chie_trans = ss%chie_trans
     IF(.not.partial_copy) THEN
        ss2%id_chie_trans = ss%id_chie_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_chie_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_chie_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%chie_transcat).AND.ALLOCATED(ss2%chie_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chie_transcat = ss%chie_transcat
     IF(ALLOCATED(ss2%id_chie_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_chie_transcat = ss%id_chie_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chie_w19 = 0
  ENDIF
  IF((ALLOCATED(ss%chie_w19).AND.ALLOCATED(ss2%chie_w19)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chie_w19 = ss%chie_w19
     IF(.not.partial_copy) THEN
        ss2%id_chie_w19 = ss%id_chie_w19
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_anom = 0
  ENDIF
  IF((ALLOCATED(ss%chii_anom).AND.ALLOCATED(ss2%chii_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_anom = ss%chii_anom
     IF(.not.partial_copy) THEN
        ss2%id_chii_anom = ss%id_chii_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%chii_drbm).AND.ALLOCATED(ss2%chii_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_drbm = ss%chii_drbm
     IF(.not.partial_copy) THEN
        ss2%id_chii_drbm = ss%id_chii_drbm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_glf = 0
  ENDIF
  IF((ALLOCATED(ss%chii_glf).AND.ALLOCATED(ss2%chii_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_glf = ss%chii_glf
     IF(.not.partial_copy) THEN
        ss2%id_chii_glf = ss%id_chii_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%chii_gtcneo).AND.ALLOCATED(ss2%chii_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_gtcneo = ss%chii_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_chii_gtcneo = ss%id_chii_gtcneo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%chii_mmm71).AND.ALLOCATED(ss2%chii_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_mmm71 = ss%chii_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_chii_mmm71 = ss%id_chii_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%chii_nclass).AND.ALLOCATED(ss2%chii_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_nclass = ss%chii_nclass
     IF(.not.partial_copy) THEN
        ss2%id_chii_nclass = ss%id_chii_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_neo = 0
  ENDIF
  IF((ALLOCATED(ss%chii_neo).AND.ALLOCATED(ss2%chii_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_neo = ss%chii_neo
     IF(.not.partial_copy) THEN
        ss2%id_chii_neo = ss%id_chii_neo
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_0

!  trx_prof -- get conversion factor, read & scale profile
!  trx_kprof -- read & scale profile
!
!--------------------------------------------------------------------
!  get units conversion profile, then, read & scale profile (trx_kprof,
!  below)
!
subroutine trx_prof(zname,zuns_mks,iordr,ident,ierr)
 
  use trx_module
  implicit NONE
 
! ...arguments
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zname          ! name of desired profile
  character(*), intent(out) :: zuns_mks      ! mks units label of profile
  integer, intent(in)      :: iordr          ! desired order of fit
  integer, intent(out)     :: ident          ! xplasma object id#
  integer, intent(out)     :: ierr           ! completion code, 0=OK
 
! ...local
 
  real*8                   :: zconv          ! units conversion factor
  integer                  :: iwarn          ! units conversion warning
  integer                  :: ixid           ! x axis id
 
! ------------------------------
 
  call trx_mks_conv(zname,zconv,zuns_mks,iwarn)
  call trx_kprof(zname,iordr,zconv,ident,ixid,ierr)
  call trx_ustore(ierr,ident,ixid,iordr,zuns_mks,iwarn)
 
  return
end subroutine trx_prof
!--------------------------------------------------------------------
!  read a TRANSP profile & interpolate/extrapolate to flux surfaces
!  from zone centers if necessary; scale by units conversion factor
!
subroutine trx_kprof(zname,iordr,zconv,ident,ixid,ierr)
 
  use trx_module
  implicit NONE
 
! ...arguments
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zname          ! name of desired profile
  integer, intent(in)      :: iordr          ! desired order of fit
  real*8, intent(in)       :: zconv          ! units conversion factor
  integer, intent(out)     :: ident          ! xplasma object id#
  integer, intent(out)     :: ixid           ! xplasma axis id#
  integer, intent(out)     :: ierr           ! completion code, 0=OK
 
! ...local
 
  real, dimension(nxmax) :: zbuf     ! data read in
  real*8, dimension(nxmax) :: zbuf1  ! converted to real*8
!
  real*8, dimension(nsurf+1) :: zbuf2  ! interp./extrapolated to flux surfaces
  real*8 :: zdum
!
  character(64) :: zlabel            ! label
  character(32) :: zunits            ! units
!
  integer :: istype,ixgot            ! type code, #gotten
  integer :: lunzer
  integer :: iordri,iuser,iclass,idnum_rp
!
! ------------------------------
!
  ierr=0
  ixid=0
  ident=0
!
  call trx_ready('trx_prof',ierr)
  if(ierr.ne.0) return
!
  call eq_gfnum(zname,ident)
  iordri = iordr
  if(ident.ne.0) then
     if(prof_iord(ident).eq.-99) then
        write(lunzer(0),*) '?trx_prof: ',zname,' reserved by TRXPLIB.'
        ierr=1
        return
     endif
     call idchek(zname,idnum_rp,iclass,iuser,0)
     if(iuser.eq.0) then
        return  ! TRREAD immutable object; we have it already...
     else
        iordri=100+iordr  ! replaceable object -- but does type match?
     endif
  endif
!
  call t1profil(zname,zlabel,zunits,time0,delta_t, &
       istype,zbuf,nxmax,ixgot, ierr)
  if(ierr.ne.0) return
!
  zdum=0
!
  if((istype.ne.itype_x).and.(istype.ne.itype_xb).and. &
       (istype.ne.itype_rmajm).and.(istype.ne.itype_rmjsym)) then
     write(lunzer(0),*) '?trx_prof:  ',zname,':  ', &
          'neither a function of x (flux zones or surfaces)'
     write(lunzer(0),*) '            nor a function of major radius.'
     ierr=1
     return
  endif
!
  if((istype.eq.itype_x).or.(istype.eq.itype_xb)) then
     if(ixgot.ne.(nsurf-1)) then
        write(lunzer(0),*) '?trx_prof:  ',zname,':  ixgot+1 .ne. nsurf'
        write(lunzer(0),*) ' (this is unexpected) ixgot=',ixgot,' nsurf=',nsurf
        ierr=1
        return
     endif
  else if(istype.eq.itype_rmajm) then
     if(ixgot.ne.nrmajm) then
        write(lunzer(0),*) '?trx_prof: f(Rmajm) no. of points ixgot=',ixgot
        write(lunzer(0),*) ' expected: NRmajm = ',NRmajm
        ierr=2
        return
     endif
  else if(istype.eq.itype_rmjsym) then
     if(ixgot.ne.nrmjsym) then
        write(lunzer(0),*) '?trx_prof: f(Rmjsym) no. of points ixgot=',ixgot
        write(lunzer(0),*) ' expected: NRmjsym = ',NRmjsym
        ierr=3
        return
     endif
  endif
!
!  OK
!
  zbuf1(1:ixgot) = zbuf(1:ixgot)*zconv
!
  if(istype.eq.itype_xb) then
!
!  copy & extrapolate axial value
!
     zbuf2(2:nsurf)=zbuf1(1:nsurf-1)
     if(ival_axis.eq.1) then
        zbuf2(1)=zval_axis
     else
        if((ibc_axis.eq.1).and.(zbc_axis.eq.0.0E0_R8)) then
!
!  assuming f' -> 0 on axis
!
           zbuf2(1) = zbuf1(1) - (zbuf1(2)-zbuf1(1))*afac0b
        else
!
!  linear extrapolation
!
           zbuf2(1) = zbuf1(1) - (zbuf1(2)-zbuf1(1))*afaclinb
!
        endif
!  extrapolation limit check
        if(isign_check.eq.1) then
           if(zbuf1(1).lt.0.0E0_R8) then
              zbuf2(1)=min(zsign_lim*zbuf1(1),zbuf2(1))
           else if(zbuf1(1).gt.0.0E0_R8) then
              zbuf2(1)=max(zsign_lim*zbuf1(1),zbuf2(1))
           endif
        endif
!
     endif
!
  else if(istype.eq.itype_x) then
!
!  take zone centered data; extrapolate at edges.
!
     zbuf2(2:nsurf)=zbuf1(1:nsurf-1)
!
     if(ival_axis.eq.1) then
        zbuf2(1)=zval_axis
     else
        if((ibc_axis.eq.1).and.(zbc_axis.eq.0.0E0_R8)) then
!
!  assuming f' -> 0 on axis
!
           zbuf2(1) = zbuf1(1) - (zbuf1(2)-zbuf1(1))*afac0
        else
!
!  linear extrapolation
!
           zbuf2(1) = zbuf1(1) - (zbuf1(2)-zbuf1(1))*afaclin
!
        endif
!  extrapolation limit check
        if(isign_check.eq.1) then
           if(zbuf1(1).lt.0.0E0_R8) then
              zbuf2(1)=min(zsign_lim*zbuf1(1),zbuf2(1))
           else if(zbuf1(1).gt.0.0E0_R8) then
              zbuf2(1)=max(zsign_lim*zbuf1(1),zbuf2(1))
           endif
        endif
!
     endif
!
! now... do boundary ... note use of zbuf2(nsurf+1);
!  zbuf2(2:nsurf) will be reset to the original, uninterpolated
!  data values...
!
     if(ival_edge.eq.1) then
        zbuf2(nsurf+1)=zval_edge
     else
        if((ibc_edge.eq.1).and.(zbc_edge.eq.0.0E0_R8)) then
!
!  assuming f' -> 0 on edge
!
           zbuf2(nsurf+1) = &
                zbuf1(nsurf-1) - (zbuf1(nsurf-2)-zbuf1(nsurf-1))*efac0
        else
!
!  linear extrapolation
!
           zbuf2(nsurf+1) = &
                zbuf1(nsurf-1) - (zbuf1(nsurf-2)-zbuf1(nsurf-1))*efaclin
!
        endif
!  extrapolation limit check
        if(isign_check.eq.1) then
           if(zbuf1(nsurf-1).lt.0.0E0_R8) then
              zbuf2(nsurf+1)=min(zsign_lim*zbuf1(nsurf-1),zbuf2(nsurf+1))
           else if(zbuf1(nsurf-1).gt.0.0E0_R8) then
              zbuf2(nsurf+1)=max(zsign_lim*zbuf1(nsurf-1),zbuf2(nsurf+1))
           endif
        endif
     endif
!
  endif       ! zone ctr / zone bdy
!
!  OK... set up the interpolation object
!
  if(istype.eq.itype_xb) then
     ixid=id_rho
     call eqm_rhofun(iordri,id_rho,zname,zbuf2, &
          ibc_axis,zbc_axis,ibc_edge,zbc_edge, &
          ident,ierr)
 
  else if(istype.eq.itype_x) then
     ixid=id_rhozc
     call eqm_rhofun(iordri,id_rhozc,zname,zbuf2, &
          ibc_axis,zbc_axis,ibc_edge,zbc_edge, &
          ident,ierr)
 
  else if(istype.eq.itype_rmajm) then
     ixid=id_rmajm
     call eqm_f1d(iordri,id_rmajm,zname,zbuf1(1:nrmajm), &
          0,zdum,0,zdum, ident,ierr)
 
  else if(istype.eq.itype_rmjsym) then
     ixid=id_rmjsym
     call eqm_f1d(iordri,id_rmjsym,zname,zbuf1(1:nrmjsym), &
          0,zdum,0,zdum, ident,ierr)
 
  endif
!
!  re-init BC flags
!
  call trx_bc_init

end subroutine trx_kprof

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_erase(ss,ierr)

  ! deallocate state object and reset all scalars to their initial values
  !   (empty state made identical to its initial instantiation)

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss    ! state object whose elements are reinitialized
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,isize
  !-------------------

  iout = SWIM_err_out_file

  !  clear associated xplasma structures...
  call ps_init_xpl(ss%iobj,iout,ierr)  ! ierr return ignored.

  call plasma_state_free(ss,ierr)

  !  ss%itag, ss%chtag, ss%iobj not touched...

  ss%version_id = ps_version_id  ! this goes with ps code version

  ss%hash_codes = ps_unInit
  ss%new_hash_codes = ps_unInit
  ss%saved_hash_codes = ps_unInit

  ss%active_dims = 0

  ss%ANOM_Code_Info = " "

  ss%id_anom_evar = 0

  ss%id_area = 0

  ss%id_balstab = 0

  ss%id_BphiRZ = 0

  ss%id_BRRZ = 0

  ss%id_BZRZ = 0

  ss%B_axis = 0.0_rspec

  ss%B_axis_vac = 0.0_rspec

  ss%B_max_lcfs = 0.0_rspec

  ss%B_min_lcfs = 0.0_rspec

  ss%id_B_surfMax = 0

  ss%id_B_surfMin = 0

  ss%id_chie_anom = 0

  ss%id_chie_drbm = 0

  ss%id_chie_etg = 0

  ss%id_chie_glf = 0

  ss%id_chie_gtcneo = 0

  ss%id_chie_mmm71 = 0

  ss%id_chie_mtm = 0

  ss%id_chie_nclass = 0

  ss%id_chie_neo = 0

  ss%id_chie_ntm = 0

  ss%id_chie_paleo = 0

  ss%id_chie_tglf = 0

  ss%id_chie_trans = 0

  ss%id_chie_w19 = 0

  ss%id_chii_anom = 0

  ss%id_chii_drbm = 0

  ss%id_chii_glf = 0

  ss%id_chii_gtcneo = 0

  ss%id_chii_mmm71 = 0

  ss%id_chii_nclass = 0

  ss%id_chii_neo = 0

  ss%id_chii_ntm = 0

  ss%id_chii_tglf = 0

  ss%id_chii_trans = 0

  ss%id_chii_w19 = 0

  ss%id_chimo_trans = 0

  ss%id_chiphi_anom = 0

  ss%id_chiphi_drbm = 0

  ss%id_chiphi_glf = 0

  ss%id_chiphi_gtcneo = 0

  ss%id_chiphi_mmm71 = 0

  ss%id_chiphi_neo = 0

  ss%id_chiphi_tglf = 0

  ss%id_chiphi_w19 = 0

  ss%id_chitheta_mmm71 = 0

  ss%id_curbeam = 0

  ss%id_curech = 0

  ss%id_curfusn = 0

  ss%id_curich = 0

  ss%id_curlh = 0

  ss%id_curmino = 0

  ss%id_curr_bootstrap = 0

  ss%id_curr_ohmic = 0

  ss%id_curt = 0

  ss%CUR_Data_Info = " "

  ss%id_cur_rw = 0

  ss%id_db_mtm = 0

  ss%id_dcur_rw_dVloop = 0

  ss%id_difb_fusi = 0

  ss%id_difb_nbi = 0

  ss%id_difb_rfmi = 0

  ss%id_difne_nclass = 0

  ss%id_difnh_nclass = 0

  ss%id_difnx_nclass = 0

  ss%id_difnz_mmm71 = 0

  ss%dn0out = 0.0_rspec

  ss%id_dQedGrdte_tglf = 0

  ss%id_dQedGrdti_tglf = 0

  ss%id_dQidGrdte_tglf = 0

  ss%id_dQidGrdti_tglf = 0

  ss%EC_Code_Info = " "

  ss%EC_Data_Info = " "

  ss%id_ee_mobility_factor = 0

  ss%eldot = 0.0_rspec

  ss%id_elong = 0

  ss%id_eperp_rw = 0

  ss%id_epll_rw = 0

  ss%id_Epot = 0

  ss%eqdsk_file = " "

  ss%EQ_Code_Info = " "

  ss%EQ_Data_Info = " "

  ss%id_eta_parallel = 0

  ss%id_Fi_depletion = 0

  ss%id_freq_drbm = 0

  ss%id_freq_glf = 0

  ss%id_freq_max_tglf = 0

  ss%id_freq_mtm = 0

  ss%FUS_Code_Info = " "

  ss%id_gamma_nc = 0

  ss%GAS_Code_Info = " "

  ss%id_gb1 = 0

  ss%id_gb2 = 0

  ss%id_gb2i = 0

  ss%id_gbr2 = 0

  ss%geometry = " "

  ss%Global_label = " "

  ss%id_gncfb2h = 0

  ss%id_gncfh = 0

  ss%id_gr1 = 0

  ss%id_gr2 = 0

  ss%id_gr2i = 0

  ss%id_gr2rho2 = 0

  ss%id_gr3i = 0

  ss%id_grho1 = 0

  ss%id_grho2 = 0

  ss%id_grho2b2i = 0

  ss%id_grho2r2i = 0

  ss%id_grho2r3i = 0

  ss%id_gri = 0

  ss%id_grirhoi = 0

  ss%id_growthrate_drbm = 0

  ss%id_growthrate_glf = 0

  ss%id_growthrate_max_tglf = 0

  ss%id_growthrate_mtm = 0

  ss%id_g_eq = 0

  ss%IC_Code_Info = " "

  ss%IC_Data_Info = " "

  ss%id_iota = 0

  ss%i_npoloidal = ps_unInit

  ss%id_jdotb = 0

  ss%kccw_Bphi = 0

  ss%kccw_Jphi = 0

  ss%kdens_rfmin = "data"

  ss%id_kyrhos_mtm = 0

  ss%LH_Code_Info = " "

  ss%LH_Data_Info = " "

  ss%LMHD_eq_code = " "

  ss%LMHD_status = ps_unInit

  ss%lock_machine_descr = 0

  ss%lock_shot_config = 0

  ss%lock_sim_init = 0

  ss%id_Lpol = 0

  ss%max_nrz_antgeo = 0

  ss%max_nspectrumlh_src = 0

  ss%max_num_nphi = 0

  ss%max_num_nphi_vac = 0

  ss%max_n_straps = 0

  ss%MHD_eq_status = ps_unInit

  ss%mmodes = 0

  ss%nballoon = 0

  ss%nbeam = 0

  ss%NBI_Code_Info = " "

  ss%NBI_Data_Info = " "

  ss%ncircuits = 0

  ss%ncoils = 0

  ss%ndelta_w = 0

  ss%nebar = 0.0_rspec

  ss%necrf_src = 0

  ss%nefi_anom = 0

  ss%nefi_anom2 = 0

  ss%neqmom = 0

  ss%id_ngradb2_av = 0

  ss%ngsc0 = 0

  ss%id_ni = 0

  ss%nicrf_src = 0

  ss%nky_anomth = 0

  ss%nky_mmm = 0

  ss%nlhrf_src = 0

  ss%nmdifb = 0

  ss%id_nmodel = 0

  ss%nmodel_bdy = 0.0_rspec

  ss%nmom = 16

  ss%nnewcomb = 0

  ss%npsmom = 0

  ss%nr = 0

  ss%nrho = 0

  ss%nrho_anom = 0

  ss%nrho_anom2 = 0

  ss%nrho_anomth = 0

  ss%nrho_ecrf = 0

  ss%nrho_eq = 0

  ss%nrho_eq_geo = 0

  ss%nrho_fus = 0

  ss%nrho_gas = 0

  ss%nrho_icrf = 0

  ss%nrho_lhrf = 0

  ss%nrho_lmhd = 0

  ss%nrho_mist = 0

  ss%nrho_nbi = 0

  ss%nrho_pel = 0

  ss%nrho_rad = 0

  ss%nrho_rw = 0

  ss%id_nrw = 0

  ss%nr_rip = 0

  ss%nspec_all = 0

  ss%nspec_alla = 0

  ss%nspec_beam = 0

  ss%nspec_fusion = 0

  ss%nspec_gas = 0

  ss%nspec_imp0 = 0

  ss%nspec_impi = 0

  ss%nspec_rfmin = 0

  ss%nspec_th = 0

  ss%nspec_tha = 0

  ss%ns_Data_Info = " "

  ss%ntf_coil2 = ps_unInit

  ss%ntf_coils = ps_unInit

  ss%nth_eq = 0

  ss%ntrcat = 0

  ss%num_rzlim = 0

  ss%nxs = 0

  ss%nz = 0

  ss%nz_rip = 0

  ss%n_D_einj_standard = 0

  ss%n_H_einj_standard = 0

  ss%n_T_einj_standard = 0

  ss%id_omegat = 0

  ss%omegat_bdy = 0.0_rspec

  ss%id_omega_exb = 0

  ss%id_p0_reco = 0

  ss%id_pb0_halo = 0

  ss%id_pbe = 0

  ss%id_pbi = 0

  ss%id_pbth = 0

  ss%id_pcx_halo = 0

  ss%id_pcx_reco = 0

  ss%id_peech = 0

  ss%id_pelh = 0

  ss%PEL_Code_Info = " "

  ss%PEL_Data_Info = " "

  ss%id_pe_anom = 0

  ss%id_pe_trans = 0

  ss%id_pfuse = 0

  ss%id_pfusi = 0

  ss%id_pfusth = 0

  ss%id_phit = 0

  ss%id_picth = 0

  ss%id_pilh = 0

  ss%id_pi_anom = 0

  ss%id_pi_trans = 0

  ss%PLASMA_Code_Info = " "

  ss%id_pmine = 0

  ss%id_pmini = 0

  ss%id_pminth = 0

  ss%id_pohme = 0

  ss%id_prad = 0

  ss%id_prad_br = 0

  ss%id_prad_cy = 0

  ss%id_prad_li = 0

  ss%id_psc_halo = 0

  ss%id_psc_reco = 0

  ss%id_psipol = 0

  ss%id_PsiRZ = 0

  ss%Psi_to_machine_axis = 0.0_rspec

  ss%id_psmom_errck = 0

  ss%id_P_eq = 0

  ss%id_qcomp_e = 0

  ss%id_qcomp_i = 0

  ss%id_qie = 0

  ss%id_qrot_conv = 0

  ss%id_qrot_diff = 0

  ss%id_q_eq = 0

  ss%id_R0_momeq = 0

  ss%RAD_Code_Info = " "

  ss%RAD_Data_Info = " "

  ss%id_res_te = 0

  ss%id_res_ti = 0

  ss%id_res_tq = 0

  ss%rho_bdy_omegat = 0.0_rspec

  ss%rho_bdy_Te = 0.0_rspec

  ss%rho_bdy_Ti = 0.0_rspec

  ss%id_Rmajor_mean = 0

  ss%id_rMinor_mean = 0

  ss%RUNAWAY_Code_Info = " "

  ss%RunID = " "

  ss%R_axis = 0.0_rspec

  ss%id_R_geo = 0

  ss%R_max_box = 0.0_rspec

  ss%R_max_lcfs = 0.0_rspec

  ss%id_R_midp_in = 0

  ss%id_R_midp_out = 0

  ss%R_min_box = 0.0_rspec

  ss%R_min_lcfs = 0.0_rspec

  ss%id_R_surfMax = 0

  ss%id_R_surfMin = 0

  ss%id_s0reco_e = 0

  ss%id_sbedep = 0

  ss%id_sbehalo = 0

  ss%shot_number = ps_unInit

  ss%id_squareLO = 0

  ss%id_squareUO = 0

  ss%id_surf = 0

  ss%t0 = 0.0_rspec

  ss%t1 = 0.0_rspec

  ss%Te_bdy = 0.0_rspec

  ss%tfinal = 0.0_rspec

  ss%id_tfrip2_log = 0

  ss%id_tfrip_log = 0

  ss%TF_Data_Info = " "

  ss%id_Ti = 0

  ss%tinit = 0.0_rspec

  ss%Ti_bdy = 0.0_rspec

  ss%id_tmodel = 0

  ss%tmodel_bdy = 0.0_rspec

  ss%tokamak_id = " "

  ss%id_tq0_reco = 0

  ss%id_tqb0_halo = 0

  ss%id_tqbe = 0

  ss%id_tqbi = 0

  ss%id_tqbjxb = 0

  ss%id_tqbth = 0

  ss%id_tqcx_halo = 0

  ss%id_tqcx_reco = 0

  ss%id_tqsc_halo = 0

  ss%id_tqsc_reco = 0

  ss%id_tq_anom = 0

  ss%id_tq_trans = 0

  ss%id_triang = 0

  ss%id_triangL = 0

  ss%id_triangU = 0

  ss%id_triang_miller_L = 0

  ss%id_triang_miller_U = 0

  ss%Ts_Data_Info = " "

  ss%id_upwind_pfrac_omega = 0

  ss%id_upwind_pfrac_Te = 0

  ss%id_upwind_pfrac_Ti = 0

  ss%id_vee_trans = 0

  ss%id_velb_fusi = 0

  ss%id_velb_nbi = 0

  ss%id_velb_rfmi = 0

  ss%id_velne_nclass = 0

  ss%id_velnh_nclass = 0

  ss%id_velni_drbm = 0

  ss%id_velnx_nclass = 0

  ss%id_velpphi_anom = 0

  ss%id_velpphi_glf = 0

  ss%id_velpphi_gtcneo = 0

  ss%id_velpphi_mmm71 = 0

  ss%id_velpphi_neo = 0

  ss%id_velpphi_tglf = 0

  ss%id_velte_anom = 0

  ss%id_velte_glf = 0

  ss%id_velte_gtcneo = 0

  ss%id_velte_mmm71 = 0

  ss%id_velte_nclass = 0

  ss%id_velte_neo = 0

  ss%id_velte_paleo = 0

  ss%id_velte_tglf = 0

  ss%id_velti_anom = 0

  ss%id_velti_glf = 0

  ss%id_velti_gtcneo = 0

  ss%id_velti_mmm71 = 0

  ss%id_velti_nclass = 0

  ss%id_velti_neo = 0

  ss%id_velti_tglf = 0

  ss%id_vie_trans = 0

  ss%id_vmo_trans = 0

  ss%id_vol = 0

  ss%vpol_Data_Info = " "

  ss%vsur = 0.0_rspec

  ss%VSUR_Data_Info = " "

  ss%vtor_Data_Info = " "

  ss%id_V_loop = 0

  ss%Z0max = 2

  ss%id_Z0_momeq = 0

  ss%id_Zeff = 0

  ss%ZEFF_Data_Info = " "

  ss%id_Zeff_fi = 0

  ss%id_Zeff_th = 0

  ss%Zimp1 = 2

  ss%Zimp2 = 1000

  ss%Z_axis = 0.0_rspec

  ss%id_Z_geo = 0

  ss%Z_max_box = 0.0_rspec

  ss%Z_max_lcfs = 0.0_rspec

  ss%id_Z_midp = 0

  ss%Z_min_box = 0.0_rspec

  ss%Z_min_lcfs = 0.0_rspec

  ss%id_Z_surfMax = 0

  ss%id_Z_surfMin = 0


END SUBROUTINE plasma_state_erase

!--------------------------------------------------------------------
      subroutine trxpl_add_profile(zname)
 
      implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
      include 'trxpl.blk'
      character*10, intent(inout) :: zname   ! name of profile
 
      ! add profile to the list.
 
      !----------------------------
      integer ilz,ierr,lnout,ident,i,idup,istat,ixid,inum
      !----------------------------
 
      ilz=len_trim(zname)
 
      idup=0
      do i=1,numpro
         if(prolabs(1,i)//prolabs(2,i).eq.zname) then
            idup=i
            write(lnout(0),*) ' %caution: duplicate name: ',zname
            exit
         endif
      enddo
 
      if(idup.gt.0) then
         inum=idup
      else
         numpro=numpro+1
         prolabs(1,numpro)=zname
         prolabs(2,numpro)=' '
         inum=numpro
      endif
 
      call trx_prof(zname,prolabs(3,inum),iordr,ident,ierr)
      if((ierr.eq.0).and.(ixtnd.eq.1)) then
         call eqm_rzfun(ident,zlamda,1,0.0_R8,ierr)
         if(ierr.ne.0) then
            write(lnout(0),*)
     >         ' %trxpl:  (R,Z) grid extrapolation failed, ',
     >         'ierr = ',ierr,' zname = ',zname
            write(lnout(0),*) ' profile accepted anyway.'
            ierr=0
         endif
      endif
      if(ierr.eq.0) then
         call trx_uget(ident,ixid,
     >      prolabs(1,inum),prolabs(3,inum),
     >      istat,ierr)
         if(ierr.ne.0) then
            write(lnout(0),*)
     >         ' %trxpl: MKS conversion error detected (trx_uget)'
            ierr=0
         else
            id_xaxis(inum)=ixid
         endif
      endif
 
      if(ierr.ne.0) then
         write(lnout(0),*)
     >      ' %trxpl:  profile ',zname(1:ilz),' not added.'
         if(idup.eq.0) numpro=numpro-1
      else
         id_pros(numpro)=ident
         write(lnout(0),*) ' %trxpl: ',zname,' OK.'
         write(lnout(0),*) '  Units: ',prolabs(3,numpro),'.'
      endif
 
      return
      end

subroutine ps_rho_zonint(iobj, idi, integ_name, nvec, ansv, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 4 Apr 2007

  ! XPLASMA2 implementation of plasma_state subroutine to get numerically
  !   integrated metric quantities

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: idi   ! handle for integrator (0 if fail)

  character*(*), intent(in) :: integ_name  ! NAME of integration
  !  e.g. "dVol" for zone volumes

  integer, intent(in) :: nvec              ! size of answer array
  !  this size must = [integrator grid size] or [integrator grid size] - 1,
  !  depending on the type of integration
  !    the integrator grid size is known to the xplasma software via "idi".

  real(kind=rspec) :: ansv(nvec)           ! result of integration

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_rho_zonint: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  perform the integration with error checking...

  call xplasma_rho_zonint(s,idi,integ_name,ansv,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rho_zonint: integration "', &
          trim(integ_name),'" failed in xplasma:'
     call xplasma_error(s,ierr,iout)
     ansv = 0.0_rspec
     return
  endif

end subroutine ps_rho_zonint

!
!  The *_*getf(...) subroutines only return value elements explicitly set
!  in the namelist file.  Elements not explicitly set are left unmodified.
!
!  dmc Jan 2005: added splitn_getf_flag, see below...
!
!  MODIFIED dmc Mar 2009: update blocks: some namelist quantities are now
!    updatable, i.e., can be modified via read of an update namelist, which
!    is trackable in splitn.  Append the update block number in syntax
!    "[<num>]" to have the routine check for updates of the quantity in
!    block #<num>.  Where updates are specified, element values of the
!    passed array are set.  If this suffix is omitted or "[0]" the initial 
!    namelist is referred to, as before.  If a quantity is not updatable 
!    but "[<num>]" is specified with <num> .gt. 0, then, no quantities are set.
!
subroutine splitn_igetf(zname,isize,array,ierr)

  !  get an INTEGER namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  integer, intent(inout) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock,ilin
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_igetf',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_igetf: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_igetf: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_igetf: not an INTEGER object: ',znam32
     return
  endif

  iblock=max(0,min(nupdate,iblock))
  if((iblock.gt.0).AND.varlist(jj)%steerable.le.1) then
     return  ! no changes possible
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_igetf: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
     ilin=varlist(jj)%nlinadr
  else
     ii = nint + (iblock-1)*nint_st + varlist(jj)%addr_st
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(ilin+ia-1).ne.0) then
        array(ia) = intbuf(ii+ia-1)
     endif
  enddo

end subroutine splitn_igetf

subroutine splitn_lgetf(zname,isize,array,ierr)

  !  get a LOGICAL namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  logical, intent(inout) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock,ilin
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_lgetf',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_lgetf: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_lgetf: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lgetf: not a LOGICAL object: ',znam32
     return
  endif

  iblock=max(0,min(nupdate,iblock))
  if((iblock.gt.0).AND.varlist(jj)%steerable.le.1) then
     return  ! no changes possible
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_lgetf: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
     ilin=varlist(jj)%nlinadr
  else
     ii = nlog + (iblock-1)*nlog_st + varlist(jj)%addr_st
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(ilin+ia-1).ne.0) then
        array(ia) = logbuf(ii+ia-1)
     endif
  enddo

end subroutine splitn_lgetf

subroutine splitn_rgetf(zname,isize,array,ierr)

  !  get an REAL namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real, intent(inout) :: array(isize)     ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock,ilin
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_rgetf',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_rgetf: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_rgetf: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'R') then
     write(6,*) '?splitn_rgetf: not a REAL object: ',znam32
     return
  endif

  iblock=max(0,min(nupdate,iblock))
  if((iblock.gt.0).AND.varlist(jj)%steerable.le.1) then
     return  ! no changes possible
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_rgetf: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
     ilin=varlist(jj)%nlinadr
  else
     ii = nreal + (iblock-1)*nreal_st + varlist(jj)%addr_st
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(ilin+ia-1).ne.0) then
        array(ia) = rbuf(ii+ia-1)
     endif
  enddo

end subroutine splitn_rgetf

subroutine splitn_dgetf(zname,isize,array,ierr)

  !  get an REAL*8 namelist object
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real*8, intent(inout) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock,ilin
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_dgetf',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_dgetf: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_dgetf: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'D') then
     write(6,*) '?splitn_dgetf: not a REAL*8 object: ',znam32
     return
  endif

  iblock=max(0,min(nupdate,iblock))
  if((iblock.gt.0).AND.varlist(jj)%steerable.le.1) then
     return  ! no changes possible
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_dgetf: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
     ilin=varlist(jj)%nlinadr
  else
     ii = nr8 + (iblock-1)*nr8_st + varlist(jj)%addr_st
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(ilin+ia-1).ne.0) then
        array(ia) = dbuf(ii+ia-1)
     endif
  enddo

end subroutine splitn_dgetf

subroutine splitn_cgetf(zname,iwid,isize,array,ierr)

  !  get an CHARACTER*n namelist object
  !  isize *must* match the actual size of the object.
  !  iwid must be .ge. the actual width of object elements.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: iwid           ! width of object array elements
  integer, intent(in) :: isize          ! size of object (# of elements)
  character*(iwid), intent(inout) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock,ilin
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_cgetf',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_cgetf: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_cgetf: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_cgetf: not a CHARACTER*nn object: ',znam32
     return
  endif

  iblock=max(0,min(nupdate,iblock))
  if((iblock.gt.0).AND.varlist(jj)%steerable.le.1) then
     return  ! no changes possible
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_cgetf: array size mismatch: expected=',isize, &
          ' found=',ii
     return
  endif

  if(iwid.lt.varlist(jj)%chsize) then
     write(6,*) '?splitn_cgetf: passed character element size too small: ', &
          'have=',iwid,' need=',varlist(jj)%chsize
     return
  endif

  if(iblock.eq.0) then
     ii=varlist(jj)%addr
     ilin=varlist(jj)%nlinadr
  else
     ii = nchv + (iblock-1)*nchv_st + varlist(jj)%addr_st
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(ilin+ia-1).ne.0) then
        array(ia) = chbuf(ii+ia-1)
     endif
  enddo

end subroutine splitn_cgetf

subroutine splitn_getf_flag(zname,isize,array,ierr)

  !  set each element of a logical array according as a quantity
  !  is defined in the file or from the defaults.  The quantity can be
  !  of any data type.
  ! 
  !  on output, array(j)=.TRUE. means the corresponding namelist element
  !  is defined in the namelist file; .FALSE. means the definition comes
  !  from the namelist default settings.  If the quantity is explicitly
  !  in the namelist file, .TRUE. is returned for corresponding array
  !  elements, even if the explictly assigned value matches the default
  !  value.
  !
  !  the information pertains to the initial namelist settings; update
  !  blocks are not taken into account.  See splitn_getu_flag(...)

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  logical, intent(out) :: array(isize)  ! file definition flags
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = .FALSE.

  call splitn_bdecode1('splitn_getf_flag',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_getf_flag: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_getf_flag: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_getf_flag: size mismatch: expected=',isize,' found=',ii
     return
  endif

  ierr = 0
  do ia=1,isize
     if(ilines(varlist(jj)%nlinadr+ia-1).ne.0) then
        array(ia) = .TRUE.
     endif
  enddo

end subroutine splitn_getf_flag

subroutine splitn_getu_flag(zname,isize,array,ierr)

  !  set each element of a logical array according as a quantity
  !  is specified in a namelist file update blocks or in any of a set
  !  of blocks.  The quantity can be of any data type.
  ! 
  !  on output, array(j)=.TRUE. means the corresponding namelist element
  !  is set (even if the value is not actually changed); .FALSE. means it 
  !  does not appear in the specified update block(s).

  !  The "zname" argument controls which update blocks to check:

  !  if the bare name is specified, or if it is appended with "[*]" or "[:]"
  !  or "[0]", all update blocks are checked.  If "[2]" is appended, only 
  !  update block #2 is checked; if "[2:4]" is appended, 2,3, and 4 are 
  !  checked.  (see subroutine splitn_bdecode2).

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  logical, intent(out) :: array(isize)  ! file definition flags
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ia,ivar,imatch,iblock1,iblock2,iblock,ilin
  character*32 znam32
  !---------------------------

  array = .FALSE.

  call splitn_bdecode2('splitn_getf_flag',zname,znam32,iblock1,iblock2,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_getf_flag: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_getf_flag: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_getf_flag: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(nupdate.eq.0) then
     return  ! there are no updates in the file.
  endif

  if(varlist(jj)%steerable.le.1) then
     return  ! the quantity is not updatable: so, no updates.
  endif

  if((iblock1.eq.0).and.(iblock2.eq.0)) then
     iblock1=1
     iblock2=nupdate
  endif

  if(iblock1.eq.0) iblock1 = 1

  ierr = 0

  do iblock = iblock1,iblock2
     ilin = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
     do ia=1,isize
        if(ilines(ilin+ia-1).ne.0) then
           array(ia) = .TRUE.
        endif
     enddo
  enddo

end subroutine splitn_getu_flag

!.....................................................................
!         SUBROUTINE TR_PUTNL_LINES
!......................................................................
 
subroutine tr_putnl_lines(ilun,ierr)
!
  use tr_getnl
  implicit NONE
!
  integer ilun                ! lun for file write (input argument)
  integer ierr                ! completion code:  0=OK
!
  integer lt,lunzer
!------------------------------
 
  lt = lunzer(0)

  call tr_putnl_write(ilun,ierr)

  if(ierr.ne.0) then
     write(lt,*) ' ?tr_putnl_lines: write error.'
     if(mltext_nlines.eq.0) then
        write(lt,*) '  module does not contain a namelist.'
     endif
  endif
 
  if(allocated(nltext)) deallocate(nltext)
  if(allocated(nltext_lens)) deallocate(nltext_lens)
  if(allocated(mltext)) deallocate(mltext)
  if(allocated(mltext_lens)) deallocate(mltext_lens)
 
  close(unit=ilun)
 
  return
end subroutine tr_putnl_lines

subroutine tr_putnl_write(ilun,ierr)
!
  use tr_getnl
  implicit NONE
!
  integer ilun                ! lun for file write (input argument)
  integer ierr                ! completion code:  0=OK
!
  integer iline,ilen
!------------------------------
  
  if(mltext_nlines.eq.0) then
     ierr = 1

  else
     ierr = 0

     do iline=1,mltext_nlines
        ilen=len_trim(mltext(iline))
        write(ilun,'(A)') mltext(iline)(1:ilen)
        mltext_lens(iline)=len_trim(mltext(iline))
     enddo
  endif

end subroutine tr_putnl_write

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_5(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%nthinlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nthinlh)
  ENDIF
  IF(ALLOCATED(ss%nthinlh)) then
     jsize = SIZE(ss%nthinlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nthinlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nthinlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%nthinlh = 0
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%Nturns).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Nturns)
  ENDIF
  IF(ALLOCATED(ss%Nturns)) then
     jsize = SIZE(ss%Nturns)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Nturns already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Nturns(ss%ncoils))
     ss%Nturns = 0
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%num_nphi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%num_nphi)
  ENDIF
  IF(ALLOCATED(ss%num_nphi)) then
     jsize = SIZE(ss%num_nphi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: num_nphi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%num_nphi(ss%nicrf_src))
     ss%num_nphi = 0
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%num_nphi_vac).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%num_nphi_vac)
  ENDIF
  IF(ALLOCATED(ss%num_nphi_vac)) then
     jsize = SIZE(ss%num_nphi_vac)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: num_nphi_vac already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%num_nphi_vac(ss%nicrf_src))
     ss%num_nphi_vac = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%nzflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nzflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%nzflux_ky_tglf)) then
     jsize = SIZE(ss%nzflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nzflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nzflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%nzflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_nzflux_ky_tglf(ss%nky_anomth))
     ss%id_nzflux_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%nz_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nz_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%nz_ky_tglf)) then
     jsize = SIZE(ss%nz_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nz_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nz_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%nz_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_nz_ky_tglf(ss%nky_anomth))
     ss%id_nz_ky_tglf = 0
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%n_straps).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%n_straps)
  ENDIF
  IF(ALLOCATED(ss%n_straps)) then
     jsize = SIZE(ss%n_straps)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: n_straps already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%n_straps(ss%nicrf_src))
     ss%n_straps = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%ngsc0)
  IF(ALLOCATED(ss%omeg0cx).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omeg0cx)
  ENDIF
  IF(ALLOCATED(ss%omeg0cx)) then
     jsize = SIZE(ss%omeg0cx)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omeg0cx already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omeg0cx(ss%nrho_gas-1,ss%ngsc0))
     ss%omeg0cx = 0.0_rspec
     ALLOCATE(ss%id_omeg0cx(ss%ngsc0))
     ss%id_omeg0cx = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)*(ss%ngsc0)
  IF(ALLOCATED(ss%omeg0sc0).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omeg0sc0)
  ENDIF
  IF(ALLOCATED(ss%omeg0sc0)) then
     jsize = SIZE(ss%omeg0sc0)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omeg0sc0 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omeg0sc0(ss%nrho_gas-1,ss%nspec_gas,ss%ngsc0))
     ss%omeg0sc0 = 0.0_rspec
     ALLOCATE(ss%id_omeg0sc0(ss%nspec_gas,ss%ngsc0))
     ss%id_omeg0sc0 = 0
  ENDIF

  isize = (ss%nrho_nbi-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%omeg0_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omeg0_halo)
  ENDIF
  IF(ALLOCATED(ss%omeg0_halo)) then
     jsize = SIZE(ss%omeg0_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omeg0_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omeg0_halo(ss%nrho_nbi-1,ss%nspec_gas))
     ss%omeg0_halo = 0.0_rspec
     ALLOCATE(ss%id_omeg0_halo(ss%nspec_gas))
     ss%id_omeg0_halo = 0
  ENDIF

  isize = (ss%nrho_gas-1)*(ss%nspec_gas)
  IF(ALLOCATED(ss%omeg0_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omeg0_reco)
  ENDIF
  IF(ALLOCATED(ss%omeg0_reco)) then
     jsize = SIZE(ss%omeg0_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omeg0_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omeg0_reco(ss%nrho_gas-1,ss%nspec_gas))
     ss%omeg0_reco = 0.0_rspec
     ALLOCATE(ss%id_omeg0_reco(ss%nspec_gas))
     ss%id_omeg0_reco = 0
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%omegat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omegat)
  ENDIF
  IF(ALLOCATED(ss%omegat)) then
     jsize = SIZE(ss%omegat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omegat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omegat(ss%nrho-1))
     ss%omegat = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%omega_exb).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%omega_exb)
  ENDIF
  IF(ALLOCATED(ss%omega_exb)) then
     jsize = SIZE(ss%omega_exb)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: omega_exb already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%omega_exb(ss%nrho_anomth))
     ss%omega_exb = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%p0_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%p0_reco)
  ENDIF
  IF(ALLOCATED(ss%p0_reco)) then
     jsize = SIZE(ss%p0_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: p0_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%p0_reco(ss%nrho_gas-1))
     ss%p0_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%pb0_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pb0_halo)
  ENDIF
  IF(ALLOCATED(ss%pb0_halo)) then
     jsize = SIZE(ss%pb0_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pb0_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pb0_halo(ss%nrho_nbi-1))
     ss%pb0_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%pbe).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pbe)
  ENDIF
  IF(ALLOCATED(ss%pbe)) then
     jsize = SIZE(ss%pbe)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pbe already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pbe(ss%nrho_nbi-1))
     ss%pbe = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%pbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pbi)
  ENDIF
  IF(ALLOCATED(ss%pbi)) then
     jsize = SIZE(ss%pbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pbi(ss%nrho_nbi-1))
     ss%pbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%pbth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pbth)
  ENDIF
  IF(ALLOCATED(ss%pbth)) then
     jsize = SIZE(ss%pbth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pbth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pbth(ss%nrho_nbi-1))
     ss%pbth = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%pcx_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pcx_halo)
  ENDIF
  IF(ALLOCATED(ss%pcx_halo)) then
     jsize = SIZE(ss%pcx_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pcx_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pcx_halo(ss%nrho_nbi-1))
     ss%pcx_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%pcx_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pcx_reco)
  ENDIF
  IF(ALLOCATED(ss%pcx_reco)) then
     jsize = SIZE(ss%pcx_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pcx_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pcx_reco(ss%nrho_gas-1))
     ss%pcx_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_ecrf-1)
  IF(ALLOCATED(ss%peech).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%peech)
  ENDIF
  IF(ALLOCATED(ss%peech)) then
     jsize = SIZE(ss%peech)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: peech already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%peech(ss%nrho_ecrf-1))
     ss%peech = 0.0_rspec
  ENDIF

  isize = (ss%nrho_ecrf-1)*(ss%necrf_src)
  IF(ALLOCATED(ss%peech_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%peech_src)
  ENDIF
  IF(ALLOCATED(ss%peech_src)) then
     jsize = SIZE(ss%peech_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: peech_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%peech_src(ss%nrho_ecrf-1,ss%necrf_src))
     ss%peech_src = 0.0_rspec
     ALLOCATE(ss%id_peech_src(ss%necrf_src))
     ss%id_peech_src = 0
  ENDIF

  isize = (ss%nrho_lhrf-1)
  IF(ALLOCATED(ss%pelh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pelh)
  ENDIF
  IF(ALLOCATED(ss%pelh)) then
     jsize = SIZE(ss%pelh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pelh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pelh(ss%nrho_lhrf-1))
     ss%pelh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf-1)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%pelh_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pelh_src)
  ENDIF
  IF(ALLOCATED(ss%pelh_src)) then
     jsize = SIZE(ss%pelh_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pelh_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pelh_src(ss%nrho_lhrf-1,ss%nlhrf_src))
     ss%pelh_src = 0.0_rspec
     ALLOCATE(ss%id_pelh_src(ss%nlhrf_src))
     ss%id_pelh_src = 0
  ENDIF

  isize = (ss%nrho_anomth-1)
  IF(ALLOCATED(ss%pe_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pe_anom)
  ENDIF
  IF(ALLOCATED(ss%pe_anom)) then
     jsize = SIZE(ss%pe_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pe_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pe_anom(ss%nrho_anomth-1))
     ss%pe_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%pe_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pe_trans)
  ENDIF
  IF(ALLOCATED(ss%pe_trans)) then
     jsize = SIZE(ss%pe_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pe_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pe_trans(ss%nrho-1))
     ss%pe_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%ntrcat)
  IF(ALLOCATED(ss%pe_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pe_transcat)
  ENDIF
  IF(ALLOCATED(ss%pe_transcat)) then
     jsize = SIZE(ss%pe_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pe_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pe_transcat(ss%nrho-1,ss%ntrcat))
     ss%pe_transcat = 0.0_rspec
     ALLOCATE(ss%id_pe_transcat(ss%ntrcat))
     ss%id_pe_transcat = 0
  ENDIF

  isize = (ss%nrho_fus-1)
  IF(ALLOCATED(ss%pfuse).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pfuse)
  ENDIF
  IF(ALLOCATED(ss%pfuse)) then
     jsize = SIZE(ss%pfuse)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pfuse already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pfuse(ss%nrho_fus-1))
     ss%pfuse = 0.0_rspec
  ENDIF

  isize = (ss%nrho_fus-1)
  IF(ALLOCATED(ss%pfusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pfusi)
  ENDIF
  IF(ALLOCATED(ss%pfusi)) then
     jsize = SIZE(ss%pfusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pfusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pfusi(ss%nrho_fus-1))
     ss%pfusi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_fus-1)
  IF(ALLOCATED(ss%pfusth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pfusth)
  ENDIF
  IF(ALLOCATED(ss%pfusth)) then
     jsize = SIZE(ss%pfusth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pfusth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pfusth(ss%nrho_fus-1))
     ss%pfusth = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%Phibsc).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Phibsc)
  ENDIF
  IF(ALLOCATED(ss%Phibsc)) then
     jsize = SIZE(ss%Phibsc)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Phibsc already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Phibsc(ss%nbeam))
     ss%Phibsc = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%phiflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%phiflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%phiflux_ky_tglf)) then
     jsize = SIZE(ss%phiflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: phiflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%phiflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%phiflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_phiflux_ky_tglf(ss%nky_anomth))
     ss%id_phiflux_ky_tglf = 0
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%phigrilh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%phigrilh)
  ENDIF
  IF(ALLOCATED(ss%phigrilh)) then
     jsize = SIZE(ss%phigrilh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: phigrilh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%phigrilh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%phigrilh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%phit).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%phit)
  ENDIF
  IF(ALLOCATED(ss%phit)) then
     jsize = SIZE(ss%phit)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: phit already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%phit(ss%nrho_eq))
     ss%phit = 0.0_rspec
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%Phi_EC_launch).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Phi_EC_launch)
  ENDIF
  IF(ALLOCATED(ss%Phi_EC_launch)) then
     jsize = SIZE(ss%Phi_EC_launch)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Phi_EC_launch already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Phi_EC_launch(ss%necrf_src))
     ss%Phi_EC_launch = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%picrf_abs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picrf_abs)
  ENDIF
  IF(ALLOCATED(ss%picrf_abs)) then
     jsize = SIZE(ss%picrf_abs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picrf_abs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picrf_abs(ss%nicrf_src))
     ss%picrf_abs = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%picrf_ext).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picrf_ext)
  ENDIF
  IF(ALLOCATED(ss%picrf_ext)) then
     jsize = SIZE(ss%picrf_ext)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picrf_ext already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picrf_ext(ss%nicrf_src))
     ss%picrf_ext = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%max_num_nphi)*(ss%nicrf_src)*(ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%picrf_nphi_srcs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picrf_nphi_srcs)
  ENDIF
  IF(ALLOCATED(ss%picrf_nphi_srcs)) then
     jsize = SIZE(ss%picrf_nphi_srcs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picrf_nphi_srcs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picrf_nphi_srcs(ss%nrho_icrf-1,ss%max_num_nphi,ss%nicrf_src,0:ss%nspec_alla))
     ss%picrf_nphi_srcs = 0.0_rspec
     ALLOCATE(ss%id_picrf_nphi_srcs(ss%max_num_nphi,ss%nicrf_src,0:ss%nspec_alla))
     ss%id_picrf_nphi_srcs = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nicrf_src)*(ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%picrf_srcs).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picrf_srcs)
  ENDIF
  IF(ALLOCATED(ss%picrf_srcs)) then
     jsize = SIZE(ss%picrf_srcs)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picrf_srcs already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picrf_srcs(ss%nrho_icrf-1,ss%nicrf_src,0:ss%nspec_alla))
     ss%picrf_srcs = 0.0_rspec
     ALLOCATE(ss%id_picrf_srcs(ss%nicrf_src,0:ss%nspec_alla))
     ss%id_picrf_srcs = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%picrf_totals).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picrf_totals)
  ENDIF
  IF(ALLOCATED(ss%picrf_totals)) then
     jsize = SIZE(ss%picrf_totals)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picrf_totals already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picrf_totals(ss%nrho_icrf-1,0:ss%nspec_alla))
     ss%picrf_totals = 0.0_rspec
     ALLOCATE(ss%id_picrf_totals(0:ss%nspec_alla))
     ss%id_picrf_totals = 0
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%picth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%picth)
  ENDIF
  IF(ALLOCATED(ss%picth)) then
     jsize = SIZE(ss%picth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: picth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%picth(ss%nrho_icrf-1))
     ss%picth = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf-1)
  IF(ALLOCATED(ss%pilh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pilh)
  ENDIF
  IF(ALLOCATED(ss%pilh)) then
     jsize = SIZE(ss%pilh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pilh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pilh(ss%nrho_lhrf-1))
     ss%pilh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf-1)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%pilh_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pilh_src)
  ENDIF
  IF(ALLOCATED(ss%pilh_src)) then
     jsize = SIZE(ss%pilh_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pilh_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pilh_src(ss%nrho_lhrf-1,ss%nlhrf_src))
     ss%pilh_src = 0.0_rspec
     ALLOCATE(ss%id_pilh_src(ss%nlhrf_src))
     ss%id_pilh_src = 0
  ENDIF

  isize = (ss%nrho_anomth-1)
  IF(ALLOCATED(ss%pi_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pi_anom)
  ENDIF
  IF(ALLOCATED(ss%pi_anom)) then
     jsize = SIZE(ss%pi_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pi_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pi_anom(ss%nrho_anomth-1))
     ss%pi_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%pi_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pi_trans)
  ENDIF
  IF(ALLOCATED(ss%pi_trans)) then
     jsize = SIZE(ss%pi_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pi_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pi_trans(ss%nrho-1))
     ss%pi_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)*(ss%ntrcat)
  IF(ALLOCATED(ss%pi_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pi_transcat)
  ENDIF
  IF(ALLOCATED(ss%pi_transcat)) then
     jsize = SIZE(ss%pi_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pi_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pi_transcat(ss%nrho-1,ss%ntrcat))
     ss%pi_transcat = 0.0_rspec
     ALLOCATE(ss%id_pi_transcat(ss%ntrcat))
     ss%id_pi_transcat = 0
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%pmine).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pmine)
  ENDIF
  IF(ALLOCATED(ss%pmine)) then
     jsize = SIZE(ss%pmine)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pmine already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pmine(ss%nrho_icrf-1))
     ss%pmine = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%pmini).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pmini)
  ENDIF
  IF(ALLOCATED(ss%pmini)) then
     jsize = SIZE(ss%pmini)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pmini already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pmini(ss%nrho_icrf-1))
     ss%pmini = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%pminth).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pminth)
  ENDIF
  IF(ALLOCATED(ss%pminth)) then
     jsize = SIZE(ss%pminth)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pminth already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pminth(ss%nrho_icrf-1))
     ss%pminth = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%pohme).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pohme)
  ENDIF
  IF(ALLOCATED(ss%pohme)) then
     jsize = SIZE(ss%pohme)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pohme already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pohme(ss%nrho-1))
     ss%pohme = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%pot_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%pot_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%pot_ky_tglf)) then
     jsize = SIZE(ss%pot_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: pot_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%pot_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%pot_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_pot_ky_tglf(ss%nky_anomth))
     ss%id_pot_ky_tglf = 0
  ENDIF

  isize = (ss%necrf_src)
  IF(ALLOCATED(ss%power_ec).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%power_ec)
  ENDIF
  IF(ALLOCATED(ss%power_ec)) then
     jsize = SIZE(ss%power_ec)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: power_ec already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%power_ec(ss%necrf_src))
     ss%power_ec = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%power_ic).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%power_ic)
  ENDIF
  IF(ALLOCATED(ss%power_ic)) then
     jsize = SIZE(ss%power_ic)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: power_ic already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%power_ic(ss%nicrf_src))
     ss%power_ic = 0.0_rspec
  ENDIF

  isize = (ss%nlhrf_src)
  IF(ALLOCATED(ss%power_lh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%power_lh)
  ENDIF
  IF(ALLOCATED(ss%power_lh)) then
     jsize = SIZE(ss%power_lh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: power_lh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%power_lh(ss%nlhrf_src))
     ss%power_lh = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%power_nbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%power_nbi)
  ENDIF
  IF(ALLOCATED(ss%power_nbi)) then
     jsize = SIZE(ss%power_nbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: power_nbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%power_nbi(ss%nbeam))
     ss%power_nbi = 0.0_rspec
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%power_nbi_trace).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%power_nbi_trace)
  ENDIF
  IF(ALLOCATED(ss%power_nbi_trace)) then
     jsize = SIZE(ss%power_nbi_trace)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: power_nbi_trace already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%power_nbi_trace(ss%nbeam))
     ss%power_nbi_trace = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rad-1)
  IF(ALLOCATED(ss%prad).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%prad)
  ENDIF
  IF(ALLOCATED(ss%prad)) then
     jsize = SIZE(ss%prad)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: prad already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%prad(ss%nrho_rad-1))
     ss%prad = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rad-1)
  IF(ALLOCATED(ss%prad_br).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%prad_br)
  ENDIF
  IF(ALLOCATED(ss%prad_br)) then
     jsize = SIZE(ss%prad_br)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: prad_br already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%prad_br(ss%nrho_rad-1))
     ss%prad_br = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rad-1)
  IF(ALLOCATED(ss%prad_cy).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%prad_cy)
  ENDIF
  IF(ALLOCATED(ss%prad_cy)) then
     jsize = SIZE(ss%prad_cy)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: prad_cy already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%prad_cy(ss%nrho_rad-1))
     ss%prad_cy = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rad-1)
  IF(ALLOCATED(ss%prad_li).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%prad_li)
  ENDIF
  IF(ALLOCATED(ss%prad_li)) then
     jsize = SIZE(ss%prad_li)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: prad_li already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%prad_li(ss%nrho_rad-1))
     ss%prad_li = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%psc_halo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psc_halo)
  ENDIF
  IF(ALLOCATED(ss%psc_halo)) then
     jsize = SIZE(ss%psc_halo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psc_halo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psc_halo(ss%nrho_nbi-1))
     ss%psc_halo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_gas-1)
  IF(ALLOCATED(ss%psc_reco).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psc_reco)
  ENDIF
  IF(ALLOCATED(ss%psc_reco)) then
     jsize = SIZE(ss%psc_reco)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psc_reco already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psc_reco(ss%nrho_gas-1))
     ss%psc_reco = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%psipol).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%psipol)
  ENDIF
  IF(ALLOCATED(ss%psipol)) then
     jsize = SIZE(ss%psipol)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: psipol already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%psipol(ss%nrho_eq))
     ss%psipol = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_5

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_8(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("tfinal",ss1%tfinal,ss2%tfinal,icheck,iout,ierr)
     ss3%tfinal = ss1%tfinal
  ENDIF

  IF((ALLOCATED(ss3%tfrip2_log)).AND.(cclist(ps_cnum_RIPPLE).EQ.1)) THEN
     IF(ALLOCATED(ss1%tfrip2_log).AND.ALLOCATED(ss2%tfrip2_log)) THEN
        CALL ps_conformal("tfrip2_log",ss2%tfrip2_log,ss3%tfrip2_log,iout,ierr)
        CALL ps_conformal("tfrip2_log",ss1%tfrip2_log,ss3%tfrip2_log,iout,ierr)
        if(ierr.eq.0) ss3%tfrip2_log = w1*ss1%tfrip2_log + (1.0_rspec-w1)*ss2%tfrip2_log
     ELSE IF(ALLOCATED(ss1%tfrip2_log)) THEN
        CALL ps_conformal("tfrip2_log",ss1%tfrip2_log,ss3%tfrip2_log,iout,ierr)
        ss3%tfrip2_log = ss1%tfrip2_log
     ELSE IF(ALLOCATED(ss2%tfrip2_log)) THEN
        CALL ps_conformal("tfrip2_log",ss2%tfrip2_log,ss3%tfrip2_log,iout,ierr)
        ss3%tfrip2_log = ss2%tfrip2_log
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tfrip_log)).AND.(cclist(ps_cnum_RIPPLE).EQ.1)) THEN
     IF(ALLOCATED(ss1%tfrip_log).AND.ALLOCATED(ss2%tfrip_log)) THEN
        CALL ps_conformal("tfrip_log",ss2%tfrip_log,ss3%tfrip_log,iout,ierr)
        CALL ps_conformal("tfrip_log",ss1%tfrip_log,ss3%tfrip_log,iout,ierr)
        if(ierr.eq.0) ss3%tfrip_log = w1*ss1%tfrip_log + (1.0_rspec-w1)*ss2%tfrip_log
     ELSE IF(ALLOCATED(ss1%tfrip_log)) THEN
        CALL ps_conformal("tfrip_log",ss1%tfrip_log,ss3%tfrip_log,iout,ierr)
        ss3%tfrip_log = ss1%tfrip_log
     ELSE IF(ALLOCATED(ss2%tfrip_log)) THEN
        CALL ps_conformal("tfrip_log",ss2%tfrip_log,ss3%tfrip_log,iout,ierr)
        ss3%tfrip_log = ss2%tfrip_log
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("TF_Data_Info",ss1%TF_Data_Info,ss2%TF_Data_Info,icheck,iout,ierr)
     ss3%TF_Data_Info = ss1%TF_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%thegrilh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%thegrilh).AND.ALLOCATED(ss2%thegrilh)) THEN
        CALL ps_diff("thegrilh",ss1%thegrilh,ss2%thegrilh,icheck,iout,ierr)
        CALL ps_conformal("thegrilh",ss1%thegrilh,ss3%thegrilh,iout,ierr)
        if(ierr.eq.0) ss3%thegrilh = ss1%thegrilh
     ELSE IF(ALLOCATED(ss1%thegrilh)) THEN
        CALL ps_conformal("thegrilh",ss1%thegrilh,ss3%thegrilh,iout,ierr)
        ss3%thegrilh = ss1%thegrilh
     ELSE IF(ALLOCATED(ss2%thegrilh)) THEN
        CALL ps_conformal("thegrilh",ss2%thegrilh,ss3%thegrilh,iout,ierr)
        ss3%thegrilh = ss2%thegrilh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%th_eq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%th_eq).AND.ALLOCATED(ss2%th_eq)) THEN
        CALL ps_diff("th_eq",ss1%th_eq,ss2%th_eq,ps_error,iout,ierr)
        CALL ps_conformal("th_eq",ss1%th_eq,ss3%th_eq,iout,ierr)
        if(ierr.eq.0) ss3%th_eq = ss1%th_eq
     ELSE IF(ALLOCATED(ss1%th_eq)) THEN
        CALL ps_conformal("th_eq",ss1%th_eq,ss3%th_eq,iout,ierr)
        ss3%th_eq = ss1%th_eq
     ELSE IF(ALLOCATED(ss2%th_eq)) THEN
        CALL ps_conformal("th_eq",ss2%th_eq,ss3%th_eq,iout,ierr)
        ss3%th_eq = ss2%th_eq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Ti)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Ti).AND.ALLOCATED(ss2%Ti)) THEN
        CALL ps_conformal("Ti",ss2%Ti,ss3%Ti,iout,ierr)
        CALL ps_conformal("Ti",ss1%Ti,ss3%Ti,iout,ierr)
        if(ierr.eq.0) ss3%Ti = w1*ss1%Ti + (1.0_rspec-w1)*ss2%Ti
     ELSE IF(ALLOCATED(ss1%Ti)) THEN
        CALL ps_conformal("Ti",ss1%Ti,ss3%Ti,iout,ierr)
        ss3%Ti = ss1%Ti
     ELSE IF(ALLOCATED(ss2%Ti)) THEN
        CALL ps_conformal("Ti",ss2%Ti,ss3%Ti,iout,ierr)
        ss3%Ti = ss2%Ti
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tiflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%tiflux_ky_tglf).AND.ALLOCATED(ss2%tiflux_ky_tglf)) THEN
        CALL ps_conformal("tiflux_ky_tglf",ss2%tiflux_ky_tglf,ss3%tiflux_ky_tglf,iout,ierr)
        CALL ps_conformal("tiflux_ky_tglf",ss1%tiflux_ky_tglf,ss3%tiflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%tiflux_ky_tglf = w1*ss1%tiflux_ky_tglf + (1.0_rspec-w1)*ss2%tiflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%tiflux_ky_tglf)) THEN
        CALL ps_conformal("tiflux_ky_tglf",ss1%tiflux_ky_tglf,ss3%tiflux_ky_tglf,iout,ierr)
        ss3%tiflux_ky_tglf = ss1%tiflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%tiflux_ky_tglf)) THEN
        CALL ps_conformal("tiflux_ky_tglf",ss2%tiflux_ky_tglf,ss3%tiflux_ky_tglf,iout,ierr)
        ss3%tiflux_ky_tglf = ss2%tiflux_ky_tglf
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("tinit",ss1%tinit,ss2%tinit,icheck,iout,ierr)
     ss3%tinit = ss1%tinit
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%Ti_bdy = w1*ss1%Ti_bdy + (1.0_rspec-w1)*ss2%Ti_bdy
  ENDIF

  IF((ALLOCATED(ss3%ti_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%ti_ky_tglf).AND.ALLOCATED(ss2%ti_ky_tglf)) THEN
        CALL ps_conformal("ti_ky_tglf",ss2%ti_ky_tglf,ss3%ti_ky_tglf,iout,ierr)
        CALL ps_conformal("ti_ky_tglf",ss1%ti_ky_tglf,ss3%ti_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%ti_ky_tglf = w1*ss1%ti_ky_tglf + (1.0_rspec-w1)*ss2%ti_ky_tglf
     ELSE IF(ALLOCATED(ss1%ti_ky_tglf)) THEN
        CALL ps_conformal("ti_ky_tglf",ss1%ti_ky_tglf,ss3%ti_ky_tglf,iout,ierr)
        ss3%ti_ky_tglf = ss1%ti_ky_tglf
     ELSE IF(ALLOCATED(ss2%ti_ky_tglf)) THEN
        CALL ps_conformal("ti_ky_tglf",ss2%ti_ky_tglf,ss3%ti_ky_tglf,iout,ierr)
        ss3%ti_ky_tglf = ss2%ti_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tmodel)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%tmodel).AND.ALLOCATED(ss2%tmodel)) THEN
        CALL ps_conformal("tmodel",ss2%tmodel,ss3%tmodel,iout,ierr)
        CALL ps_conformal("tmodel",ss1%tmodel,ss3%tmodel,iout,ierr)
        if(ierr.eq.0) ss3%tmodel = w1*ss1%tmodel + (1.0_rspec-w1)*ss2%tmodel
     ELSE IF(ALLOCATED(ss1%tmodel)) THEN
        CALL ps_conformal("tmodel",ss1%tmodel,ss3%tmodel,iout,ierr)
        ss3%tmodel = ss1%tmodel
     ELSE IF(ALLOCATED(ss2%tmodel)) THEN
        CALL ps_conformal("tmodel",ss2%tmodel,ss3%tmodel,iout,ierr)
        ss3%tmodel = ss2%tmodel
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_ANOM).EQ.1) THEN
     ss3%tmodel_bdy = w1*ss1%tmodel_bdy + (1.0_rspec-w1)*ss2%tmodel_bdy
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("tokamak_id",ss1%tokamak_id,ss2%tokamak_id,icheck,iout,ierr)
     ss3%tokamak_id = ss1%tokamak_id
  ENDIF

  IF((ALLOCATED(ss3%Tornum_balcrit)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Tornum_balcrit).AND.ALLOCATED(ss2%Tornum_balcrit)) THEN
        CALL ps_diff("Tornum_balcrit",ss1%Tornum_balcrit,ss2%Tornum_balcrit,icheck,iout,ierr)
        CALL ps_conformal("Tornum_balcrit",ss1%Tornum_balcrit,ss3%Tornum_balcrit,iout,ierr)
        if(ierr.eq.0) ss3%Tornum_balcrit = ss1%Tornum_balcrit
     ELSE IF(ALLOCATED(ss1%Tornum_balcrit)) THEN
        CALL ps_conformal("Tornum_balcrit",ss1%Tornum_balcrit,ss3%Tornum_balcrit,iout,ierr)
        ss3%Tornum_balcrit = ss1%Tornum_balcrit
     ELSE IF(ALLOCATED(ss2%Tornum_balcrit)) THEN
        CALL ps_conformal("Tornum_balcrit",ss2%Tornum_balcrit,ss3%Tornum_balcrit,iout,ierr)
        ss3%Tornum_balcrit = ss2%Tornum_balcrit
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Tor_mode_label)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Tor_mode_label).AND.ALLOCATED(ss2%Tor_mode_label)) THEN
        CALL ps_diff("Tor_mode_label",ss1%Tor_mode_label,ss2%Tor_mode_label,icheck,iout,ierr)
        CALL ps_conformal("Tor_mode_label",ss1%Tor_mode_label,ss3%Tor_mode_label,iout,ierr)
        if(ierr.eq.0) ss3%Tor_mode_label = ss1%Tor_mode_label
     ELSE IF(ALLOCATED(ss1%Tor_mode_label)) THEN
        CALL ps_conformal("Tor_mode_label",ss1%Tor_mode_label,ss3%Tor_mode_label,iout,ierr)
        ss3%Tor_mode_label = ss1%Tor_mode_label
     ELSE IF(ALLOCATED(ss2%Tor_mode_label)) THEN
        CALL ps_conformal("Tor_mode_label",ss2%Tor_mode_label,ss3%Tor_mode_label,iout,ierr)
        ss3%Tor_mode_label = ss2%Tor_mode_label
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Tor_mode_No)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%Tor_mode_No).AND.ALLOCATED(ss2%Tor_mode_No)) THEN
        CALL ps_diff("Tor_mode_No",ss1%Tor_mode_No,ss2%Tor_mode_No,icheck,iout,ierr)
        CALL ps_conformal("Tor_mode_No",ss1%Tor_mode_No,ss3%Tor_mode_No,iout,ierr)
        if(ierr.eq.0) ss3%Tor_mode_No = ss1%Tor_mode_No
     ELSE IF(ALLOCATED(ss1%Tor_mode_No)) THEN
        CALL ps_conformal("Tor_mode_No",ss1%Tor_mode_No,ss3%Tor_mode_No,iout,ierr)
        ss3%Tor_mode_No = ss1%Tor_mode_No
     ELSE IF(ALLOCATED(ss2%Tor_mode_No)) THEN
        CALL ps_conformal("Tor_mode_No",ss2%Tor_mode_No,ss3%Tor_mode_No,iout,ierr)
        ss3%Tor_mode_No = ss2%Tor_mode_No
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tq0_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%tq0_reco).AND.ALLOCATED(ss2%tq0_reco)) THEN
        CALL ps_conformal("tq0_reco",ss2%tq0_reco,ss3%tq0_reco,iout,ierr)
        CALL ps_conformal("tq0_reco",ss1%tq0_reco,ss3%tq0_reco,iout,ierr)
        if(ierr.eq.0) ss3%tq0_reco = w1*ss1%tq0_reco + (1.0_rspec-w1)*ss2%tq0_reco
     ELSE IF(ALLOCATED(ss1%tq0_reco)) THEN
        CALL ps_conformal("tq0_reco",ss1%tq0_reco,ss3%tq0_reco,iout,ierr)
        ss3%tq0_reco = ss1%tq0_reco
     ELSE IF(ALLOCATED(ss2%tq0_reco)) THEN
        CALL ps_conformal("tq0_reco",ss2%tq0_reco,ss3%tq0_reco,iout,ierr)
        ss3%tq0_reco = ss2%tq0_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqb0_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqb0_halo).AND.ALLOCATED(ss2%tqb0_halo)) THEN
        CALL ps_conformal("tqb0_halo",ss2%tqb0_halo,ss3%tqb0_halo,iout,ierr)
        CALL ps_conformal("tqb0_halo",ss1%tqb0_halo,ss3%tqb0_halo,iout,ierr)
        if(ierr.eq.0) ss3%tqb0_halo = w1*ss1%tqb0_halo + (1.0_rspec-w1)*ss2%tqb0_halo
     ELSE IF(ALLOCATED(ss1%tqb0_halo)) THEN
        CALL ps_conformal("tqb0_halo",ss1%tqb0_halo,ss3%tqb0_halo,iout,ierr)
        ss3%tqb0_halo = ss1%tqb0_halo
     ELSE IF(ALLOCATED(ss2%tqb0_halo)) THEN
        CALL ps_conformal("tqb0_halo",ss2%tqb0_halo,ss3%tqb0_halo,iout,ierr)
        ss3%tqb0_halo = ss2%tqb0_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqbe)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqbe).AND.ALLOCATED(ss2%tqbe)) THEN
        CALL ps_conformal("tqbe",ss2%tqbe,ss3%tqbe,iout,ierr)
        CALL ps_conformal("tqbe",ss1%tqbe,ss3%tqbe,iout,ierr)
        if(ierr.eq.0) ss3%tqbe = w1*ss1%tqbe + (1.0_rspec-w1)*ss2%tqbe
     ELSE IF(ALLOCATED(ss1%tqbe)) THEN
        CALL ps_conformal("tqbe",ss1%tqbe,ss3%tqbe,iout,ierr)
        ss3%tqbe = ss1%tqbe
     ELSE IF(ALLOCATED(ss2%tqbe)) THEN
        CALL ps_conformal("tqbe",ss2%tqbe,ss3%tqbe,iout,ierr)
        ss3%tqbe = ss2%tqbe
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqbi)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqbi).AND.ALLOCATED(ss2%tqbi)) THEN
        CALL ps_conformal("tqbi",ss2%tqbi,ss3%tqbi,iout,ierr)
        CALL ps_conformal("tqbi",ss1%tqbi,ss3%tqbi,iout,ierr)
        if(ierr.eq.0) ss3%tqbi = w1*ss1%tqbi + (1.0_rspec-w1)*ss2%tqbi
     ELSE IF(ALLOCATED(ss1%tqbi)) THEN
        CALL ps_conformal("tqbi",ss1%tqbi,ss3%tqbi,iout,ierr)
        ss3%tqbi = ss1%tqbi
     ELSE IF(ALLOCATED(ss2%tqbi)) THEN
        CALL ps_conformal("tqbi",ss2%tqbi,ss3%tqbi,iout,ierr)
        ss3%tqbi = ss2%tqbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqbjxb)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqbjxb).AND.ALLOCATED(ss2%tqbjxb)) THEN
        CALL ps_conformal("tqbjxb",ss2%tqbjxb,ss3%tqbjxb,iout,ierr)
        CALL ps_conformal("tqbjxb",ss1%tqbjxb,ss3%tqbjxb,iout,ierr)
        if(ierr.eq.0) ss3%tqbjxb = w1*ss1%tqbjxb + (1.0_rspec-w1)*ss2%tqbjxb
     ELSE IF(ALLOCATED(ss1%tqbjxb)) THEN
        CALL ps_conformal("tqbjxb",ss1%tqbjxb,ss3%tqbjxb,iout,ierr)
        ss3%tqbjxb = ss1%tqbjxb
     ELSE IF(ALLOCATED(ss2%tqbjxb)) THEN
        CALL ps_conformal("tqbjxb",ss2%tqbjxb,ss3%tqbjxb,iout,ierr)
        ss3%tqbjxb = ss2%tqbjxb
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqbth)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqbth).AND.ALLOCATED(ss2%tqbth)) THEN
        CALL ps_conformal("tqbth",ss2%tqbth,ss3%tqbth,iout,ierr)
        CALL ps_conformal("tqbth",ss1%tqbth,ss3%tqbth,iout,ierr)
        if(ierr.eq.0) ss3%tqbth = w1*ss1%tqbth + (1.0_rspec-w1)*ss2%tqbth
     ELSE IF(ALLOCATED(ss1%tqbth)) THEN
        CALL ps_conformal("tqbth",ss1%tqbth,ss3%tqbth,iout,ierr)
        ss3%tqbth = ss1%tqbth
     ELSE IF(ALLOCATED(ss2%tqbth)) THEN
        CALL ps_conformal("tqbth",ss2%tqbth,ss3%tqbth,iout,ierr)
        ss3%tqbth = ss2%tqbth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqcx_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqcx_halo).AND.ALLOCATED(ss2%tqcx_halo)) THEN
        CALL ps_conformal("tqcx_halo",ss2%tqcx_halo,ss3%tqcx_halo,iout,ierr)
        CALL ps_conformal("tqcx_halo",ss1%tqcx_halo,ss3%tqcx_halo,iout,ierr)
        if(ierr.eq.0) ss3%tqcx_halo = w1*ss1%tqcx_halo + (1.0_rspec-w1)*ss2%tqcx_halo
     ELSE IF(ALLOCATED(ss1%tqcx_halo)) THEN
        CALL ps_conformal("tqcx_halo",ss1%tqcx_halo,ss3%tqcx_halo,iout,ierr)
        ss3%tqcx_halo = ss1%tqcx_halo
     ELSE IF(ALLOCATED(ss2%tqcx_halo)) THEN
        CALL ps_conformal("tqcx_halo",ss2%tqcx_halo,ss3%tqcx_halo,iout,ierr)
        ss3%tqcx_halo = ss2%tqcx_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqcx_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqcx_reco).AND.ALLOCATED(ss2%tqcx_reco)) THEN
        CALL ps_conformal("tqcx_reco",ss2%tqcx_reco,ss3%tqcx_reco,iout,ierr)
        CALL ps_conformal("tqcx_reco",ss1%tqcx_reco,ss3%tqcx_reco,iout,ierr)
        if(ierr.eq.0) ss3%tqcx_reco = w1*ss1%tqcx_reco + (1.0_rspec-w1)*ss2%tqcx_reco
     ELSE IF(ALLOCATED(ss1%tqcx_reco)) THEN
        CALL ps_conformal("tqcx_reco",ss1%tqcx_reco,ss3%tqcx_reco,iout,ierr)
        ss3%tqcx_reco = ss1%tqcx_reco
     ELSE IF(ALLOCATED(ss2%tqcx_reco)) THEN
        CALL ps_conformal("tqcx_reco",ss2%tqcx_reco,ss3%tqcx_reco,iout,ierr)
        ss3%tqcx_reco = ss2%tqcx_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqioniz)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqioniz).AND.ALLOCATED(ss2%tqioniz)) THEN
        CALL ps_conformal("tqioniz",ss2%tqioniz,ss3%tqioniz,iout,ierr)
        CALL ps_conformal("tqioniz",ss1%tqioniz,ss3%tqioniz,iout,ierr)
        if(ierr.eq.0) ss3%tqioniz = w1*ss1%tqioniz + (1.0_rspec-w1)*ss2%tqioniz
     ELSE IF(ALLOCATED(ss1%tqioniz)) THEN
        CALL ps_conformal("tqioniz",ss1%tqioniz,ss3%tqioniz,iout,ierr)
        ss3%tqioniz = ss1%tqioniz
     ELSE IF(ALLOCATED(ss2%tqioniz)) THEN
        CALL ps_conformal("tqioniz",ss2%tqioniz,ss3%tqioniz,iout,ierr)
        ss3%tqioniz = ss2%tqioniz
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqqcx)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqqcx).AND.ALLOCATED(ss2%tqqcx)) THEN
        CALL ps_conformal("tqqcx",ss2%tqqcx,ss3%tqqcx,iout,ierr)
        CALL ps_conformal("tqqcx",ss1%tqqcx,ss3%tqqcx,iout,ierr)
        if(ierr.eq.0) ss3%tqqcx = w1*ss1%tqqcx + (1.0_rspec-w1)*ss2%tqqcx
     ELSE IF(ALLOCATED(ss1%tqqcx)) THEN
        CALL ps_conformal("tqqcx",ss1%tqqcx,ss3%tqqcx,iout,ierr)
        ss3%tqqcx = ss1%tqqcx
     ELSE IF(ALLOCATED(ss2%tqqcx)) THEN
        CALL ps_conformal("tqqcx",ss2%tqqcx,ss3%tqqcx,iout,ierr)
        ss3%tqqcx = ss2%tqqcx
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqsc_halo)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqsc_halo).AND.ALLOCATED(ss2%tqsc_halo)) THEN
        CALL ps_conformal("tqsc_halo",ss2%tqsc_halo,ss3%tqsc_halo,iout,ierr)
        CALL ps_conformal("tqsc_halo",ss1%tqsc_halo,ss3%tqsc_halo,iout,ierr)
        if(ierr.eq.0) ss3%tqsc_halo = w1*ss1%tqsc_halo + (1.0_rspec-w1)*ss2%tqsc_halo
     ELSE IF(ALLOCATED(ss1%tqsc_halo)) THEN
        CALL ps_conformal("tqsc_halo",ss1%tqsc_halo,ss3%tqsc_halo,iout,ierr)
        ss3%tqsc_halo = ss1%tqsc_halo
     ELSE IF(ALLOCATED(ss2%tqsc_halo)) THEN
        CALL ps_conformal("tqsc_halo",ss2%tqsc_halo,ss3%tqsc_halo,iout,ierr)
        ss3%tqsc_halo = ss2%tqsc_halo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tqsc_reco)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%tqsc_reco).AND.ALLOCATED(ss2%tqsc_reco)) THEN
        CALL ps_conformal("tqsc_reco",ss2%tqsc_reco,ss3%tqsc_reco,iout,ierr)
        CALL ps_conformal("tqsc_reco",ss1%tqsc_reco,ss3%tqsc_reco,iout,ierr)
        if(ierr.eq.0) ss3%tqsc_reco = w1*ss1%tqsc_reco + (1.0_rspec-w1)*ss2%tqsc_reco
     ELSE IF(ALLOCATED(ss1%tqsc_reco)) THEN
        CALL ps_conformal("tqsc_reco",ss1%tqsc_reco,ss3%tqsc_reco,iout,ierr)
        ss3%tqsc_reco = ss1%tqsc_reco
     ELSE IF(ALLOCATED(ss2%tqsc_reco)) THEN
        CALL ps_conformal("tqsc_reco",ss2%tqsc_reco,ss3%tqsc_reco,iout,ierr)
        ss3%tqsc_reco = ss2%tqsc_reco
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tq_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%tq_anom).AND.ALLOCATED(ss2%tq_anom)) THEN
        CALL ps_conformal("tq_anom",ss2%tq_anom,ss3%tq_anom,iout,ierr)
        CALL ps_conformal("tq_anom",ss1%tq_anom,ss3%tq_anom,iout,ierr)
        if(ierr.eq.0) ss3%tq_anom = w1*ss1%tq_anom + (1.0_rspec-w1)*ss2%tq_anom
     ELSE IF(ALLOCATED(ss1%tq_anom)) THEN
        CALL ps_conformal("tq_anom",ss1%tq_anom,ss3%tq_anom,iout,ierr)
        ss3%tq_anom = ss1%tq_anom
     ELSE IF(ALLOCATED(ss2%tq_anom)) THEN
        CALL ps_conformal("tq_anom",ss2%tq_anom,ss3%tq_anom,iout,ierr)
        ss3%tq_anom = ss2%tq_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tq_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%tq_trans).AND.ALLOCATED(ss2%tq_trans)) THEN
        CALL ps_conformal("tq_trans",ss2%tq_trans,ss3%tq_trans,iout,ierr)
        CALL ps_conformal("tq_trans",ss1%tq_trans,ss3%tq_trans,iout,ierr)
        if(ierr.eq.0) ss3%tq_trans = w1*ss1%tq_trans + (1.0_rspec-w1)*ss2%tq_trans
     ELSE IF(ALLOCATED(ss1%tq_trans)) THEN
        CALL ps_conformal("tq_trans",ss1%tq_trans,ss3%tq_trans,iout,ierr)
        ss3%tq_trans = ss1%tq_trans
     ELSE IF(ALLOCATED(ss2%tq_trans)) THEN
        CALL ps_conformal("tq_trans",ss2%tq_trans,ss3%tq_trans,iout,ierr)
        ss3%tq_trans = ss2%tq_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tq_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%tq_transcat).AND.ALLOCATED(ss2%tq_transcat)) THEN
        CALL ps_conformal("tq_transcat",ss2%tq_transcat,ss3%tq_transcat,iout,ierr)
        CALL ps_conformal("tq_transcat",ss1%tq_transcat,ss3%tq_transcat,iout,ierr)
        if(ierr.eq.0) ss3%tq_transcat = w1*ss1%tq_transcat + (1.0_rspec-w1)*ss2%tq_transcat
     ELSE IF(ALLOCATED(ss1%tq_transcat)) THEN
        CALL ps_conformal("tq_transcat",ss1%tq_transcat,ss3%tq_transcat,iout,ierr)
        ss3%tq_transcat = ss1%tq_transcat
     ELSE IF(ALLOCATED(ss2%tq_transcat)) THEN
        CALL ps_conformal("tq_transcat",ss2%tq_transcat,ss3%tq_transcat,iout,ierr)
        ss3%tq_transcat = ss2%tq_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%trace_flag)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%trace_flag).AND.ALLOCATED(ss2%trace_flag)) THEN
        CALL ps_diff("trace_flag",ss1%trace_flag,ss2%trace_flag,icheck,iout,ierr)
        CALL ps_conformal("trace_flag",ss1%trace_flag,ss3%trace_flag,iout,ierr)
        if(ierr.eq.0) ss3%trace_flag = ss1%trace_flag
     ELSE IF(ALLOCATED(ss1%trace_flag)) THEN
        CALL ps_conformal("trace_flag",ss1%trace_flag,ss3%trace_flag,iout,ierr)
        ss3%trace_flag = ss1%trace_flag
     ELSE IF(ALLOCATED(ss2%trace_flag)) THEN
        CALL ps_conformal("trace_flag",ss2%trace_flag,ss3%trace_flag,iout,ierr)
        ss3%trace_flag = ss2%trace_flag
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%trcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%trcat).AND.ALLOCATED(ss2%trcat)) THEN
        CALL ps_diff("trcat",ss1%trcat,ss2%trcat,icheck,iout,ierr)
        CALL ps_conformal("trcat",ss1%trcat,ss3%trcat,iout,ierr)
        if(ierr.eq.0) ss3%trcat = ss1%trcat
     ELSE IF(ALLOCATED(ss1%trcat)) THEN
        CALL ps_conformal("trcat",ss1%trcat,ss3%trcat,iout,ierr)
        ss3%trcat = ss1%trcat
     ELSE IF(ALLOCATED(ss2%trcat)) THEN
        CALL ps_conformal("trcat",ss2%trcat,ss3%trcat,iout,ierr)
        ss3%trcat = ss2%trcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%triang)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%triang).AND.ALLOCATED(ss2%triang)) THEN
        CALL ps_conformal("triang",ss2%triang,ss3%triang,iout,ierr)
        CALL ps_conformal("triang",ss1%triang,ss3%triang,iout,ierr)
        if(ierr.eq.0) ss3%triang = w1*ss1%triang + (1.0_rspec-w1)*ss2%triang
     ELSE IF(ALLOCATED(ss1%triang)) THEN
        CALL ps_conformal("triang",ss1%triang,ss3%triang,iout,ierr)
        ss3%triang = ss1%triang
     ELSE IF(ALLOCATED(ss2%triang)) THEN
        CALL ps_conformal("triang",ss2%triang,ss3%triang,iout,ierr)
        ss3%triang = ss2%triang
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%triangL)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%triangL).AND.ALLOCATED(ss2%triangL)) THEN
        CALL ps_conformal("triangL",ss2%triangL,ss3%triangL,iout,ierr)
        CALL ps_conformal("triangL",ss1%triangL,ss3%triangL,iout,ierr)
        if(ierr.eq.0) ss3%triangL = w1*ss1%triangL + (1.0_rspec-w1)*ss2%triangL
     ELSE IF(ALLOCATED(ss1%triangL)) THEN
        CALL ps_conformal("triangL",ss1%triangL,ss3%triangL,iout,ierr)
        ss3%triangL = ss1%triangL
     ELSE IF(ALLOCATED(ss2%triangL)) THEN
        CALL ps_conformal("triangL",ss2%triangL,ss3%triangL,iout,ierr)
        ss3%triangL = ss2%triangL
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%triangU)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%triangU).AND.ALLOCATED(ss2%triangU)) THEN
        CALL ps_conformal("triangU",ss2%triangU,ss3%triangU,iout,ierr)
        CALL ps_conformal("triangU",ss1%triangU,ss3%triangU,iout,ierr)
        if(ierr.eq.0) ss3%triangU = w1*ss1%triangU + (1.0_rspec-w1)*ss2%triangU
     ELSE IF(ALLOCATED(ss1%triangU)) THEN
        CALL ps_conformal("triangU",ss1%triangU,ss3%triangU,iout,ierr)
        ss3%triangU = ss1%triangU
     ELSE IF(ALLOCATED(ss2%triangU)) THEN
        CALL ps_conformal("triangU",ss2%triangU,ss3%triangU,iout,ierr)
        ss3%triangU = ss2%triangU
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%triang_miller_L)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%triang_miller_L).AND.ALLOCATED(ss2%triang_miller_L)) THEN
        CALL ps_conformal("triang_miller_L",ss2%triang_miller_L,ss3%triang_miller_L,iout,ierr)
        CALL ps_conformal("triang_miller_L",ss1%triang_miller_L,ss3%triang_miller_L,iout,ierr)
        if(ierr.eq.0) ss3%triang_miller_L = w1*ss1%triang_miller_L + (1.0_rspec-w1)*ss2%triang_miller_L
     ELSE IF(ALLOCATED(ss1%triang_miller_L)) THEN
        CALL ps_conformal("triang_miller_L",ss1%triang_miller_L,ss3%triang_miller_L,iout,ierr)
        ss3%triang_miller_L = ss1%triang_miller_L
     ELSE IF(ALLOCATED(ss2%triang_miller_L)) THEN
        CALL ps_conformal("triang_miller_L",ss2%triang_miller_L,ss3%triang_miller_L,iout,ierr)
        ss3%triang_miller_L = ss2%triang_miller_L
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%triang_miller_U)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%triang_miller_U).AND.ALLOCATED(ss2%triang_miller_U)) THEN
        CALL ps_conformal("triang_miller_U",ss2%triang_miller_U,ss3%triang_miller_U,iout,ierr)
        CALL ps_conformal("triang_miller_U",ss1%triang_miller_U,ss3%triang_miller_U,iout,ierr)
        if(ierr.eq.0) ss3%triang_miller_U = w1*ss1%triang_miller_U + (1.0_rspec-w1)*ss2%triang_miller_U
     ELSE IF(ALLOCATED(ss1%triang_miller_U)) THEN
        CALL ps_conformal("triang_miller_U",ss1%triang_miller_U,ss3%triang_miller_U,iout,ierr)
        ss3%triang_miller_U = ss1%triang_miller_U
     ELSE IF(ALLOCATED(ss2%triang_miller_U)) THEN
        CALL ps_conformal("triang_miller_U",ss2%triang_miller_U,ss3%triang_miller_U,iout,ierr)
        ss3%triang_miller_U = ss2%triang_miller_U
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%trmodels)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%trmodels).AND.ALLOCATED(ss2%trmodels)) THEN
        CALL ps_diff("trmodels",ss1%trmodels,ss2%trmodels,icheck,iout,ierr)
        CALL ps_conformal("trmodels",ss1%trmodels,ss3%trmodels,iout,ierr)
        if(ierr.eq.0) ss3%trmodels = ss1%trmodels
     ELSE IF(ALLOCATED(ss1%trmodels)) THEN
        CALL ps_conformal("trmodels",ss1%trmodels,ss3%trmodels,iout,ierr)
        ss3%trmodels = ss1%trmodels
     ELSE IF(ALLOCATED(ss2%trmodels)) THEN
        CALL ps_conformal("trmodels",ss2%trmodels,ss3%trmodels,iout,ierr)
        ss3%trmodels = ss2%trmodels
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Ts)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Ts).AND.ALLOCATED(ss2%Ts)) THEN
        CALL ps_conformal("Ts",ss2%Ts,ss3%Ts,iout,ierr)
        CALL ps_conformal("Ts",ss1%Ts,ss3%Ts,iout,ierr)
        if(ierr.eq.0) ss3%Ts = w1*ss1%Ts + (1.0_rspec-w1)*ss2%Ts
     ELSE IF(ALLOCATED(ss1%Ts)) THEN
        CALL ps_conformal("Ts",ss1%Ts,ss3%Ts,iout,ierr)
        ss3%Ts = ss1%Ts
     ELSE IF(ALLOCATED(ss2%Ts)) THEN
        CALL ps_conformal("Ts",ss2%Ts,ss3%Ts,iout,ierr)
        ss3%Ts = ss2%Ts
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("Ts_Data_Info",ss1%Ts_Data_Info,ss2%Ts_Data_Info,icheck,iout,ierr)
     ss3%Ts_Data_Info = ss1%Ts_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%Ts_is_input)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Ts_is_input).AND.ALLOCATED(ss2%Ts_is_input)) THEN
        CALL ps_diff("Ts_is_input",ss1%Ts_is_input,ss2%Ts_is_input,icheck,iout,ierr)
        CALL ps_conformal("Ts_is_input",ss1%Ts_is_input,ss3%Ts_is_input,iout,ierr)
        if(ierr.eq.0) ss3%Ts_is_input = ss1%Ts_is_input
     ELSE IF(ALLOCATED(ss1%Ts_is_input)) THEN
        CALL ps_conformal("Ts_is_input",ss1%Ts_is_input,ss3%Ts_is_input,iout,ierr)
        ss3%Ts_is_input = ss1%Ts_is_input
     ELSE IF(ALLOCATED(ss2%Ts_is_input)) THEN
        CALL ps_conformal("Ts_is_input",ss2%Ts_is_input,ss3%Ts_is_input,iout,ierr)
        ss3%Ts_is_input = ss2%Ts_is_input
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tzflux_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%tzflux_ky_tglf).AND.ALLOCATED(ss2%tzflux_ky_tglf)) THEN
        CALL ps_conformal("tzflux_ky_tglf",ss2%tzflux_ky_tglf,ss3%tzflux_ky_tglf,iout,ierr)
        CALL ps_conformal("tzflux_ky_tglf",ss1%tzflux_ky_tglf,ss3%tzflux_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%tzflux_ky_tglf = w1*ss1%tzflux_ky_tglf + (1.0_rspec-w1)*ss2%tzflux_ky_tglf
     ELSE IF(ALLOCATED(ss1%tzflux_ky_tglf)) THEN
        CALL ps_conformal("tzflux_ky_tglf",ss1%tzflux_ky_tglf,ss3%tzflux_ky_tglf,iout,ierr)
        ss3%tzflux_ky_tglf = ss1%tzflux_ky_tglf
     ELSE IF(ALLOCATED(ss2%tzflux_ky_tglf)) THEN
        CALL ps_conformal("tzflux_ky_tglf",ss2%tzflux_ky_tglf,ss3%tzflux_ky_tglf,iout,ierr)
        ss3%tzflux_ky_tglf = ss2%tzflux_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%tz_ky_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%tz_ky_tglf).AND.ALLOCATED(ss2%tz_ky_tglf)) THEN
        CALL ps_conformal("tz_ky_tglf",ss2%tz_ky_tglf,ss3%tz_ky_tglf,iout,ierr)
        CALL ps_conformal("tz_ky_tglf",ss1%tz_ky_tglf,ss3%tz_ky_tglf,iout,ierr)
        if(ierr.eq.0) ss3%tz_ky_tglf = w1*ss1%tz_ky_tglf + (1.0_rspec-w1)*ss2%tz_ky_tglf
     ELSE IF(ALLOCATED(ss1%tz_ky_tglf)) THEN
        CALL ps_conformal("tz_ky_tglf",ss1%tz_ky_tglf,ss3%tz_ky_tglf,iout,ierr)
        ss3%tz_ky_tglf = ss1%tz_ky_tglf
     ELSE IF(ALLOCATED(ss2%tz_ky_tglf)) THEN
        CALL ps_conformal("tz_ky_tglf",ss2%tz_ky_tglf,ss3%tz_ky_tglf,iout,ierr)
        ss3%tz_ky_tglf = ss2%tz_ky_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T_einj_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%T_einj_standard).AND.ALLOCATED(ss2%T_einj_standard)) THEN
        CALL ps_diff("T_einj_standard",ss1%T_einj_standard,ss2%T_einj_standard,icheck,iout,ierr)
        CALL ps_conformal("T_einj_standard",ss1%T_einj_standard,ss3%T_einj_standard,iout,ierr)
        if(ierr.eq.0) ss3%T_einj_standard = ss1%T_einj_standard
     ELSE IF(ALLOCATED(ss1%T_einj_standard)) THEN
        CALL ps_conformal("T_einj_standard",ss1%T_einj_standard,ss3%T_einj_standard,iout,ierr)
        ss3%T_einj_standard = ss1%T_einj_standard
     ELSE IF(ALLOCATED(ss2%T_einj_standard)) THEN
        CALL ps_conformal("T_einj_standard",ss2%T_einj_standard,ss3%T_einj_standard,iout,ierr)
        ss3%T_einj_standard = ss2%T_einj_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T_ffull_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%T_ffull_standard).AND.ALLOCATED(ss2%T_ffull_standard)) THEN
        CALL ps_diff("T_ffull_standard",ss1%T_ffull_standard,ss2%T_ffull_standard,icheck,iout,ierr)
        CALL ps_conformal("T_ffull_standard",ss1%T_ffull_standard,ss3%T_ffull_standard,iout,ierr)
        if(ierr.eq.0) ss3%T_ffull_standard = ss1%T_ffull_standard
     ELSE IF(ALLOCATED(ss1%T_ffull_standard)) THEN
        CALL ps_conformal("T_ffull_standard",ss1%T_ffull_standard,ss3%T_ffull_standard,iout,ierr)
        ss3%T_ffull_standard = ss1%T_ffull_standard
     ELSE IF(ALLOCATED(ss2%T_ffull_standard)) THEN
        CALL ps_conformal("T_ffull_standard",ss2%T_ffull_standard,ss3%T_ffull_standard,iout,ierr)
        ss3%T_ffull_standard = ss2%T_ffull_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%T_fhalf_standard)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%T_fhalf_standard).AND.ALLOCATED(ss2%T_fhalf_standard)) THEN
        CALL ps_diff("T_fhalf_standard",ss1%T_fhalf_standard,ss2%T_fhalf_standard,icheck,iout,ierr)
        CALL ps_conformal("T_fhalf_standard",ss1%T_fhalf_standard,ss3%T_fhalf_standard,iout,ierr)
        if(ierr.eq.0) ss3%T_fhalf_standard = ss1%T_fhalf_standard
     ELSE IF(ALLOCATED(ss1%T_fhalf_standard)) THEN
        CALL ps_conformal("T_fhalf_standard",ss1%T_fhalf_standard,ss3%T_fhalf_standard,iout,ierr)
        ss3%T_fhalf_standard = ss1%T_fhalf_standard
     ELSE IF(ALLOCATED(ss2%T_fhalf_standard)) THEN
        CALL ps_conformal("T_fhalf_standard",ss2%T_fhalf_standard,ss3%T_fhalf_standard,iout,ierr)
        ss3%T_fhalf_standard = ss2%T_fhalf_standard
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%upwind_pfrac_ns)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%upwind_pfrac_ns).AND.ALLOCATED(ss2%upwind_pfrac_ns)) THEN
        CALL ps_conformal("upwind_pfrac_ns",ss2%upwind_pfrac_ns,ss3%upwind_pfrac_ns,iout,ierr)
        CALL ps_conformal("upwind_pfrac_ns",ss1%upwind_pfrac_ns,ss3%upwind_pfrac_ns,iout,ierr)
        if(ierr.eq.0) ss3%upwind_pfrac_ns = w1*ss1%upwind_pfrac_ns + (1.0_rspec-w1)*ss2%upwind_pfrac_ns
     ELSE IF(ALLOCATED(ss1%upwind_pfrac_ns)) THEN
        CALL ps_conformal("upwind_pfrac_ns",ss1%upwind_pfrac_ns,ss3%upwind_pfrac_ns,iout,ierr)
        ss3%upwind_pfrac_ns = ss1%upwind_pfrac_ns
     ELSE IF(ALLOCATED(ss2%upwind_pfrac_ns)) THEN
        CALL ps_conformal("upwind_pfrac_ns",ss2%upwind_pfrac_ns,ss3%upwind_pfrac_ns,iout,ierr)
        ss3%upwind_pfrac_ns = ss2%upwind_pfrac_ns
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%upwind_pfrac_omega)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%upwind_pfrac_omega).AND.ALLOCATED(ss2%upwind_pfrac_omega)) THEN
        CALL ps_conformal("upwind_pfrac_omega",ss2%upwind_pfrac_omega,ss3%upwind_pfrac_omega,iout,ierr)
        CALL ps_conformal("upwind_pfrac_omega",ss1%upwind_pfrac_omega,ss3%upwind_pfrac_omega,iout,ierr)
        if(ierr.eq.0) ss3%upwind_pfrac_omega = w1*ss1%upwind_pfrac_omega + (1.0_rspec-w1)*ss2%upwind_pfrac_omega
     ELSE IF(ALLOCATED(ss1%upwind_pfrac_omega)) THEN
        CALL ps_conformal("upwind_pfrac_omega",ss1%upwind_pfrac_omega,ss3%upwind_pfrac_omega,iout,ierr)
        ss3%upwind_pfrac_omega = ss1%upwind_pfrac_omega
     ELSE IF(ALLOCATED(ss2%upwind_pfrac_omega)) THEN
        CALL ps_conformal("upwind_pfrac_omega",ss2%upwind_pfrac_omega,ss3%upwind_pfrac_omega,iout,ierr)
        ss3%upwind_pfrac_omega = ss2%upwind_pfrac_omega
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%upwind_pfrac_Te)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%upwind_pfrac_Te).AND.ALLOCATED(ss2%upwind_pfrac_Te)) THEN
        CALL ps_conformal("upwind_pfrac_Te",ss2%upwind_pfrac_Te,ss3%upwind_pfrac_Te,iout,ierr)
        CALL ps_conformal("upwind_pfrac_Te",ss1%upwind_pfrac_Te,ss3%upwind_pfrac_Te,iout,ierr)
        if(ierr.eq.0) ss3%upwind_pfrac_Te = w1*ss1%upwind_pfrac_Te + (1.0_rspec-w1)*ss2%upwind_pfrac_Te
     ELSE IF(ALLOCATED(ss1%upwind_pfrac_Te)) THEN
        CALL ps_conformal("upwind_pfrac_Te",ss1%upwind_pfrac_Te,ss3%upwind_pfrac_Te,iout,ierr)
        ss3%upwind_pfrac_Te = ss1%upwind_pfrac_Te
     ELSE IF(ALLOCATED(ss2%upwind_pfrac_Te)) THEN
        CALL ps_conformal("upwind_pfrac_Te",ss2%upwind_pfrac_Te,ss3%upwind_pfrac_Te,iout,ierr)
        ss3%upwind_pfrac_Te = ss2%upwind_pfrac_Te
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%upwind_pfrac_Ti)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%upwind_pfrac_Ti).AND.ALLOCATED(ss2%upwind_pfrac_Ti)) THEN
        CALL ps_conformal("upwind_pfrac_Ti",ss2%upwind_pfrac_Ti,ss3%upwind_pfrac_Ti,iout,ierr)
        CALL ps_conformal("upwind_pfrac_Ti",ss1%upwind_pfrac_Ti,ss3%upwind_pfrac_Ti,iout,ierr)
        if(ierr.eq.0) ss3%upwind_pfrac_Ti = w1*ss1%upwind_pfrac_Ti + (1.0_rspec-w1)*ss2%upwind_pfrac_Ti
     ELSE IF(ALLOCATED(ss1%upwind_pfrac_Ti)) THEN
        CALL ps_conformal("upwind_pfrac_Ti",ss1%upwind_pfrac_Ti,ss3%upwind_pfrac_Ti,iout,ierr)
        ss3%upwind_pfrac_Ti = ss1%upwind_pfrac_Ti
     ELSE IF(ALLOCATED(ss2%upwind_pfrac_Ti)) THEN
        CALL ps_conformal("upwind_pfrac_Ti",ss2%upwind_pfrac_Ti,ss3%upwind_pfrac_Ti,iout,ierr)
        ss3%upwind_pfrac_Ti = ss2%upwind_pfrac_Ti
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vee_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vee_trans).AND.ALLOCATED(ss2%vee_trans)) THEN
        CALL ps_conformal("vee_trans",ss2%vee_trans,ss3%vee_trans,iout,ierr)
        CALL ps_conformal("vee_trans",ss1%vee_trans,ss3%vee_trans,iout,ierr)
        if(ierr.eq.0) ss3%vee_trans = w1*ss1%vee_trans + (1.0_rspec-w1)*ss2%vee_trans
     ELSE IF(ALLOCATED(ss1%vee_trans)) THEN
        CALL ps_conformal("vee_trans",ss1%vee_trans,ss3%vee_trans,iout,ierr)
        ss3%vee_trans = ss1%vee_trans
     ELSE IF(ALLOCATED(ss2%vee_trans)) THEN
        CALL ps_conformal("vee_trans",ss2%vee_trans,ss3%vee_trans,iout,ierr)
        ss3%vee_trans = ss2%vee_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vee_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vee_transcat).AND.ALLOCATED(ss2%vee_transcat)) THEN
        CALL ps_conformal("vee_transcat",ss2%vee_transcat,ss3%vee_transcat,iout,ierr)
        CALL ps_conformal("vee_transcat",ss1%vee_transcat,ss3%vee_transcat,iout,ierr)
        if(ierr.eq.0) ss3%vee_transcat = w1*ss1%vee_transcat + (1.0_rspec-w1)*ss2%vee_transcat
     ELSE IF(ALLOCATED(ss1%vee_transcat)) THEN
        CALL ps_conformal("vee_transcat",ss1%vee_transcat,ss3%vee_transcat,iout,ierr)
        ss3%vee_transcat = ss1%vee_transcat
     ELSE IF(ALLOCATED(ss2%vee_transcat)) THEN
        CALL ps_conformal("vee_transcat",ss2%vee_transcat,ss3%vee_transcat,iout,ierr)
        ss3%vee_transcat = ss2%vee_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velb_fusi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velb_fusi).AND.ALLOCATED(ss2%velb_fusi)) THEN
        CALL ps_conformal("velb_fusi",ss2%velb_fusi,ss3%velb_fusi,iout,ierr)
        CALL ps_conformal("velb_fusi",ss1%velb_fusi,ss3%velb_fusi,iout,ierr)
        if(ierr.eq.0) ss3%velb_fusi = w1*ss1%velb_fusi + (1.0_rspec-w1)*ss2%velb_fusi
     ELSE IF(ALLOCATED(ss1%velb_fusi)) THEN
        CALL ps_conformal("velb_fusi",ss1%velb_fusi,ss3%velb_fusi,iout,ierr)
        ss3%velb_fusi = ss1%velb_fusi
     ELSE IF(ALLOCATED(ss2%velb_fusi)) THEN
        CALL ps_conformal("velb_fusi",ss2%velb_fusi,ss3%velb_fusi,iout,ierr)
        ss3%velb_fusi = ss2%velb_fusi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velb_nbi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velb_nbi).AND.ALLOCATED(ss2%velb_nbi)) THEN
        CALL ps_conformal("velb_nbi",ss2%velb_nbi,ss3%velb_nbi,iout,ierr)
        CALL ps_conformal("velb_nbi",ss1%velb_nbi,ss3%velb_nbi,iout,ierr)
        if(ierr.eq.0) ss3%velb_nbi = w1*ss1%velb_nbi + (1.0_rspec-w1)*ss2%velb_nbi
     ELSE IF(ALLOCATED(ss1%velb_nbi)) THEN
        CALL ps_conformal("velb_nbi",ss1%velb_nbi,ss3%velb_nbi,iout,ierr)
        ss3%velb_nbi = ss1%velb_nbi
     ELSE IF(ALLOCATED(ss2%velb_nbi)) THEN
        CALL ps_conformal("velb_nbi",ss2%velb_nbi,ss3%velb_nbi,iout,ierr)
        ss3%velb_nbi = ss2%velb_nbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velb_rfmi)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velb_rfmi).AND.ALLOCATED(ss2%velb_rfmi)) THEN
        CALL ps_conformal("velb_rfmi",ss2%velb_rfmi,ss3%velb_rfmi,iout,ierr)
        CALL ps_conformal("velb_rfmi",ss1%velb_rfmi,ss3%velb_rfmi,iout,ierr)
        if(ierr.eq.0) ss3%velb_rfmi = w1*ss1%velb_rfmi + (1.0_rspec-w1)*ss2%velb_rfmi
     ELSE IF(ALLOCATED(ss1%velb_rfmi)) THEN
        CALL ps_conformal("velb_rfmi",ss1%velb_rfmi,ss3%velb_rfmi,iout,ierr)
        ss3%velb_rfmi = ss1%velb_rfmi
     ELSE IF(ALLOCATED(ss2%velb_rfmi)) THEN
        CALL ps_conformal("velb_rfmi",ss2%velb_rfmi,ss3%velb_rfmi,iout,ierr)
        ss3%velb_rfmi = ss2%velb_rfmi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velne_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velne_nclass).AND.ALLOCATED(ss2%velne_nclass)) THEN
        CALL ps_conformal("velne_nclass",ss2%velne_nclass,ss3%velne_nclass,iout,ierr)
        CALL ps_conformal("velne_nclass",ss1%velne_nclass,ss3%velne_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velne_nclass = w1*ss1%velne_nclass + (1.0_rspec-w1)*ss2%velne_nclass
     ELSE IF(ALLOCATED(ss1%velne_nclass)) THEN
        CALL ps_conformal("velne_nclass",ss1%velne_nclass,ss3%velne_nclass,iout,ierr)
        ss3%velne_nclass = ss1%velne_nclass
     ELSE IF(ALLOCATED(ss2%velne_nclass)) THEN
        CALL ps_conformal("velne_nclass",ss2%velne_nclass,ss3%velne_nclass,iout,ierr)
        ss3%velne_nclass = ss2%velne_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velnh_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velnh_nclass).AND.ALLOCATED(ss2%velnh_nclass)) THEN
        CALL ps_conformal("velnh_nclass",ss2%velnh_nclass,ss3%velnh_nclass,iout,ierr)
        CALL ps_conformal("velnh_nclass",ss1%velnh_nclass,ss3%velnh_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velnh_nclass = w1*ss1%velnh_nclass + (1.0_rspec-w1)*ss2%velnh_nclass
     ELSE IF(ALLOCATED(ss1%velnh_nclass)) THEN
        CALL ps_conformal("velnh_nclass",ss1%velnh_nclass,ss3%velnh_nclass,iout,ierr)
        ss3%velnh_nclass = ss1%velnh_nclass
     ELSE IF(ALLOCATED(ss2%velnh_nclass)) THEN
        CALL ps_conformal("velnh_nclass",ss2%velnh_nclass,ss3%velnh_nclass,iout,ierr)
        ss3%velnh_nclass = ss2%velnh_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velni_drbm)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velni_drbm).AND.ALLOCATED(ss2%velni_drbm)) THEN
        CALL ps_conformal("velni_drbm",ss2%velni_drbm,ss3%velni_drbm,iout,ierr)
        CALL ps_conformal("velni_drbm",ss1%velni_drbm,ss3%velni_drbm,iout,ierr)
        if(ierr.eq.0) ss3%velni_drbm = w1*ss1%velni_drbm + (1.0_rspec-w1)*ss2%velni_drbm
     ELSE IF(ALLOCATED(ss1%velni_drbm)) THEN
        CALL ps_conformal("velni_drbm",ss1%velni_drbm,ss3%velni_drbm,iout,ierr)
        ss3%velni_drbm = ss1%velni_drbm
     ELSE IF(ALLOCATED(ss2%velni_drbm)) THEN
        CALL ps_conformal("velni_drbm",ss2%velni_drbm,ss3%velni_drbm,iout,ierr)
        ss3%velni_drbm = ss2%velni_drbm
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_anom).AND.ALLOCATED(ss2%velns_anom)) THEN
        CALL ps_conformal("velns_anom",ss2%velns_anom,ss3%velns_anom,iout,ierr)
        CALL ps_conformal("velns_anom",ss1%velns_anom,ss3%velns_anom,iout,ierr)
        if(ierr.eq.0) ss3%velns_anom = w1*ss1%velns_anom + (1.0_rspec-w1)*ss2%velns_anom
     ELSE IF(ALLOCATED(ss1%velns_anom)) THEN
        CALL ps_conformal("velns_anom",ss1%velns_anom,ss3%velns_anom,iout,ierr)
        ss3%velns_anom = ss1%velns_anom
     ELSE IF(ALLOCATED(ss2%velns_anom)) THEN
        CALL ps_conformal("velns_anom",ss2%velns_anom,ss3%velns_anom,iout,ierr)
        ss3%velns_anom = ss2%velns_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_glf).AND.ALLOCATED(ss2%velns_glf)) THEN
        CALL ps_conformal("velns_glf",ss2%velns_glf,ss3%velns_glf,iout,ierr)
        CALL ps_conformal("velns_glf",ss1%velns_glf,ss3%velns_glf,iout,ierr)
        if(ierr.eq.0) ss3%velns_glf = w1*ss1%velns_glf + (1.0_rspec-w1)*ss2%velns_glf
     ELSE IF(ALLOCATED(ss1%velns_glf)) THEN
        CALL ps_conformal("velns_glf",ss1%velns_glf,ss3%velns_glf,iout,ierr)
        ss3%velns_glf = ss1%velns_glf
     ELSE IF(ALLOCATED(ss2%velns_glf)) THEN
        CALL ps_conformal("velns_glf",ss2%velns_glf,ss3%velns_glf,iout,ierr)
        ss3%velns_glf = ss2%velns_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_gtcneo).AND.ALLOCATED(ss2%velns_gtcneo)) THEN
        CALL ps_conformal("velns_gtcneo",ss2%velns_gtcneo,ss3%velns_gtcneo,iout,ierr)
        CALL ps_conformal("velns_gtcneo",ss1%velns_gtcneo,ss3%velns_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%velns_gtcneo = w1*ss1%velns_gtcneo + (1.0_rspec-w1)*ss2%velns_gtcneo
     ELSE IF(ALLOCATED(ss1%velns_gtcneo)) THEN
        CALL ps_conformal("velns_gtcneo",ss1%velns_gtcneo,ss3%velns_gtcneo,iout,ierr)
        ss3%velns_gtcneo = ss1%velns_gtcneo
     ELSE IF(ALLOCATED(ss2%velns_gtcneo)) THEN
        CALL ps_conformal("velns_gtcneo",ss2%velns_gtcneo,ss3%velns_gtcneo,iout,ierr)
        ss3%velns_gtcneo = ss2%velns_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_mmm71).AND.ALLOCATED(ss2%velns_mmm71)) THEN
        CALL ps_conformal("velns_mmm71",ss2%velns_mmm71,ss3%velns_mmm71,iout,ierr)
        CALL ps_conformal("velns_mmm71",ss1%velns_mmm71,ss3%velns_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%velns_mmm71 = w1*ss1%velns_mmm71 + (1.0_rspec-w1)*ss2%velns_mmm71
     ELSE IF(ALLOCATED(ss1%velns_mmm71)) THEN
        CALL ps_conformal("velns_mmm71",ss1%velns_mmm71,ss3%velns_mmm71,iout,ierr)
        ss3%velns_mmm71 = ss1%velns_mmm71
     ELSE IF(ALLOCATED(ss2%velns_mmm71)) THEN
        CALL ps_conformal("velns_mmm71",ss2%velns_mmm71,ss3%velns_mmm71,iout,ierr)
        ss3%velns_mmm71 = ss2%velns_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_nclass).AND.ALLOCATED(ss2%velns_nclass)) THEN
        CALL ps_conformal("velns_nclass",ss2%velns_nclass,ss3%velns_nclass,iout,ierr)
        CALL ps_conformal("velns_nclass",ss1%velns_nclass,ss3%velns_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velns_nclass = w1*ss1%velns_nclass + (1.0_rspec-w1)*ss2%velns_nclass
     ELSE IF(ALLOCATED(ss1%velns_nclass)) THEN
        CALL ps_conformal("velns_nclass",ss1%velns_nclass,ss3%velns_nclass,iout,ierr)
        ss3%velns_nclass = ss1%velns_nclass
     ELSE IF(ALLOCATED(ss2%velns_nclass)) THEN
        CALL ps_conformal("velns_nclass",ss2%velns_nclass,ss3%velns_nclass,iout,ierr)
        ss3%velns_nclass = ss2%velns_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_neo).AND.ALLOCATED(ss2%velns_neo)) THEN
        CALL ps_conformal("velns_neo",ss2%velns_neo,ss3%velns_neo,iout,ierr)
        CALL ps_conformal("velns_neo",ss1%velns_neo,ss3%velns_neo,iout,ierr)
        if(ierr.eq.0) ss3%velns_neo = w1*ss1%velns_neo + (1.0_rspec-w1)*ss2%velns_neo
     ELSE IF(ALLOCATED(ss1%velns_neo)) THEN
        CALL ps_conformal("velns_neo",ss1%velns_neo,ss3%velns_neo,iout,ierr)
        ss3%velns_neo = ss1%velns_neo
     ELSE IF(ALLOCATED(ss2%velns_neo)) THEN
        CALL ps_conformal("velns_neo",ss2%velns_neo,ss3%velns_neo,iout,ierr)
        ss3%velns_neo = ss2%velns_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velns_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velns_tglf).AND.ALLOCATED(ss2%velns_tglf)) THEN
        CALL ps_conformal("velns_tglf",ss2%velns_tglf,ss3%velns_tglf,iout,ierr)
        CALL ps_conformal("velns_tglf",ss1%velns_tglf,ss3%velns_tglf,iout,ierr)
        if(ierr.eq.0) ss3%velns_tglf = w1*ss1%velns_tglf + (1.0_rspec-w1)*ss2%velns_tglf
     ELSE IF(ALLOCATED(ss1%velns_tglf)) THEN
        CALL ps_conformal("velns_tglf",ss1%velns_tglf,ss3%velns_tglf,iout,ierr)
        ss3%velns_tglf = ss1%velns_tglf
     ELSE IF(ALLOCATED(ss2%velns_tglf)) THEN
        CALL ps_conformal("velns_tglf",ss2%velns_tglf,ss3%velns_tglf,iout,ierr)
        ss3%velns_tglf = ss2%velns_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velnx_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velnx_nclass).AND.ALLOCATED(ss2%velnx_nclass)) THEN
        CALL ps_conformal("velnx_nclass",ss2%velnx_nclass,ss3%velnx_nclass,iout,ierr)
        CALL ps_conformal("velnx_nclass",ss1%velnx_nclass,ss3%velnx_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velnx_nclass = w1*ss1%velnx_nclass + (1.0_rspec-w1)*ss2%velnx_nclass
     ELSE IF(ALLOCATED(ss1%velnx_nclass)) THEN
        CALL ps_conformal("velnx_nclass",ss1%velnx_nclass,ss3%velnx_nclass,iout,ierr)
        ss3%velnx_nclass = ss1%velnx_nclass
     ELSE IF(ALLOCATED(ss2%velnx_nclass)) THEN
        CALL ps_conformal("velnx_nclass",ss2%velnx_nclass,ss3%velnx_nclass,iout,ierr)
        ss3%velnx_nclass = ss2%velnx_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_anom).AND.ALLOCATED(ss2%velpphi_anom)) THEN
        CALL ps_conformal("velpphi_anom",ss2%velpphi_anom,ss3%velpphi_anom,iout,ierr)
        CALL ps_conformal("velpphi_anom",ss1%velpphi_anom,ss3%velpphi_anom,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_anom = w1*ss1%velpphi_anom + (1.0_rspec-w1)*ss2%velpphi_anom
     ELSE IF(ALLOCATED(ss1%velpphi_anom)) THEN
        CALL ps_conformal("velpphi_anom",ss1%velpphi_anom,ss3%velpphi_anom,iout,ierr)
        ss3%velpphi_anom = ss1%velpphi_anom
     ELSE IF(ALLOCATED(ss2%velpphi_anom)) THEN
        CALL ps_conformal("velpphi_anom",ss2%velpphi_anom,ss3%velpphi_anom,iout,ierr)
        ss3%velpphi_anom = ss2%velpphi_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_glf).AND.ALLOCATED(ss2%velpphi_glf)) THEN
        CALL ps_conformal("velpphi_glf",ss2%velpphi_glf,ss3%velpphi_glf,iout,ierr)
        CALL ps_conformal("velpphi_glf",ss1%velpphi_glf,ss3%velpphi_glf,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_glf = w1*ss1%velpphi_glf + (1.0_rspec-w1)*ss2%velpphi_glf
     ELSE IF(ALLOCATED(ss1%velpphi_glf)) THEN
        CALL ps_conformal("velpphi_glf",ss1%velpphi_glf,ss3%velpphi_glf,iout,ierr)
        ss3%velpphi_glf = ss1%velpphi_glf
     ELSE IF(ALLOCATED(ss2%velpphi_glf)) THEN
        CALL ps_conformal("velpphi_glf",ss2%velpphi_glf,ss3%velpphi_glf,iout,ierr)
        ss3%velpphi_glf = ss2%velpphi_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_gtcneo).AND.ALLOCATED(ss2%velpphi_gtcneo)) THEN
        CALL ps_conformal("velpphi_gtcneo",ss2%velpphi_gtcneo,ss3%velpphi_gtcneo,iout,ierr)
        CALL ps_conformal("velpphi_gtcneo",ss1%velpphi_gtcneo,ss3%velpphi_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_gtcneo = w1*ss1%velpphi_gtcneo + (1.0_rspec-w1)*ss2%velpphi_gtcneo
     ELSE IF(ALLOCATED(ss1%velpphi_gtcneo)) THEN
        CALL ps_conformal("velpphi_gtcneo",ss1%velpphi_gtcneo,ss3%velpphi_gtcneo,iout,ierr)
        ss3%velpphi_gtcneo = ss1%velpphi_gtcneo
     ELSE IF(ALLOCATED(ss2%velpphi_gtcneo)) THEN
        CALL ps_conformal("velpphi_gtcneo",ss2%velpphi_gtcneo,ss3%velpphi_gtcneo,iout,ierr)
        ss3%velpphi_gtcneo = ss2%velpphi_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_mmm71).AND.ALLOCATED(ss2%velpphi_mmm71)) THEN
        CALL ps_conformal("velpphi_mmm71",ss2%velpphi_mmm71,ss3%velpphi_mmm71,iout,ierr)
        CALL ps_conformal("velpphi_mmm71",ss1%velpphi_mmm71,ss3%velpphi_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_mmm71 = w1*ss1%velpphi_mmm71 + (1.0_rspec-w1)*ss2%velpphi_mmm71
     ELSE IF(ALLOCATED(ss1%velpphi_mmm71)) THEN
        CALL ps_conformal("velpphi_mmm71",ss1%velpphi_mmm71,ss3%velpphi_mmm71,iout,ierr)
        ss3%velpphi_mmm71 = ss1%velpphi_mmm71
     ELSE IF(ALLOCATED(ss2%velpphi_mmm71)) THEN
        CALL ps_conformal("velpphi_mmm71",ss2%velpphi_mmm71,ss3%velpphi_mmm71,iout,ierr)
        ss3%velpphi_mmm71 = ss2%velpphi_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_neo).AND.ALLOCATED(ss2%velpphi_neo)) THEN
        CALL ps_conformal("velpphi_neo",ss2%velpphi_neo,ss3%velpphi_neo,iout,ierr)
        CALL ps_conformal("velpphi_neo",ss1%velpphi_neo,ss3%velpphi_neo,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_neo = w1*ss1%velpphi_neo + (1.0_rspec-w1)*ss2%velpphi_neo
     ELSE IF(ALLOCATED(ss1%velpphi_neo)) THEN
        CALL ps_conformal("velpphi_neo",ss1%velpphi_neo,ss3%velpphi_neo,iout,ierr)
        ss3%velpphi_neo = ss1%velpphi_neo
     ELSE IF(ALLOCATED(ss2%velpphi_neo)) THEN
        CALL ps_conformal("velpphi_neo",ss2%velpphi_neo,ss3%velpphi_neo,iout,ierr)
        ss3%velpphi_neo = ss2%velpphi_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velpphi_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velpphi_tglf).AND.ALLOCATED(ss2%velpphi_tglf)) THEN
        CALL ps_conformal("velpphi_tglf",ss2%velpphi_tglf,ss3%velpphi_tglf,iout,ierr)
        CALL ps_conformal("velpphi_tglf",ss1%velpphi_tglf,ss3%velpphi_tglf,iout,ierr)
        if(ierr.eq.0) ss3%velpphi_tglf = w1*ss1%velpphi_tglf + (1.0_rspec-w1)*ss2%velpphi_tglf
     ELSE IF(ALLOCATED(ss1%velpphi_tglf)) THEN
        CALL ps_conformal("velpphi_tglf",ss1%velpphi_tglf,ss3%velpphi_tglf,iout,ierr)
        ss3%velpphi_tglf = ss1%velpphi_tglf
     ELSE IF(ALLOCATED(ss2%velpphi_tglf)) THEN
        CALL ps_conformal("velpphi_tglf",ss2%velpphi_tglf,ss3%velpphi_tglf,iout,ierr)
        ss3%velpphi_tglf = ss2%velpphi_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_anom).AND.ALLOCATED(ss2%velte_anom)) THEN
        CALL ps_conformal("velte_anom",ss2%velte_anom,ss3%velte_anom,iout,ierr)
        CALL ps_conformal("velte_anom",ss1%velte_anom,ss3%velte_anom,iout,ierr)
        if(ierr.eq.0) ss3%velte_anom = w1*ss1%velte_anom + (1.0_rspec-w1)*ss2%velte_anom
     ELSE IF(ALLOCATED(ss1%velte_anom)) THEN
        CALL ps_conformal("velte_anom",ss1%velte_anom,ss3%velte_anom,iout,ierr)
        ss3%velte_anom = ss1%velte_anom
     ELSE IF(ALLOCATED(ss2%velte_anom)) THEN
        CALL ps_conformal("velte_anom",ss2%velte_anom,ss3%velte_anom,iout,ierr)
        ss3%velte_anom = ss2%velte_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_glf).AND.ALLOCATED(ss2%velte_glf)) THEN
        CALL ps_conformal("velte_glf",ss2%velte_glf,ss3%velte_glf,iout,ierr)
        CALL ps_conformal("velte_glf",ss1%velte_glf,ss3%velte_glf,iout,ierr)
        if(ierr.eq.0) ss3%velte_glf = w1*ss1%velte_glf + (1.0_rspec-w1)*ss2%velte_glf
     ELSE IF(ALLOCATED(ss1%velte_glf)) THEN
        CALL ps_conformal("velte_glf",ss1%velte_glf,ss3%velte_glf,iout,ierr)
        ss3%velte_glf = ss1%velte_glf
     ELSE IF(ALLOCATED(ss2%velte_glf)) THEN
        CALL ps_conformal("velte_glf",ss2%velte_glf,ss3%velte_glf,iout,ierr)
        ss3%velte_glf = ss2%velte_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_gtcneo).AND.ALLOCATED(ss2%velte_gtcneo)) THEN
        CALL ps_conformal("velte_gtcneo",ss2%velte_gtcneo,ss3%velte_gtcneo,iout,ierr)
        CALL ps_conformal("velte_gtcneo",ss1%velte_gtcneo,ss3%velte_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%velte_gtcneo = w1*ss1%velte_gtcneo + (1.0_rspec-w1)*ss2%velte_gtcneo
     ELSE IF(ALLOCATED(ss1%velte_gtcneo)) THEN
        CALL ps_conformal("velte_gtcneo",ss1%velte_gtcneo,ss3%velte_gtcneo,iout,ierr)
        ss3%velte_gtcneo = ss1%velte_gtcneo
     ELSE IF(ALLOCATED(ss2%velte_gtcneo)) THEN
        CALL ps_conformal("velte_gtcneo",ss2%velte_gtcneo,ss3%velte_gtcneo,iout,ierr)
        ss3%velte_gtcneo = ss2%velte_gtcneo
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_8

logical function tdb_steerxcep(id,ilev)
  !------------------------------------------------
  ! generally, trdatbuf identifiers beginning with L (addresses)
  ! are steerable; those beginning with other letters (usually N) are
  ! not, with the exception of identifiers defined in the DATA statement
  ! here...
  !------------------------------------------------
  character*(*), intent(in) :: id
  integer,intent(out) :: ilev    ! see explanation...

  ! on output, if tdb_steerxcep = .TRUE.:
  !   ilev=0 means the item value can change but only if both instances are
  !          non-zero
  !   ilev=1 means the item value can change with no restriction
  !
  !------------------------------------------------
  integer :: i
  character*16 :: zid
  integer, parameter :: nids = 15
  character*16 :: zid_xcep(nids)

  data zid_xcep/'NTIME1','NTIME2', &
       '~NTSAW','~NSAWFLAG','~LPELDA','~NPELDA', &
       'NTIMNB','NTIMRF','NTIMRFF','NTIMEC','NTIMLH', &
       'NDMMX','NDFS','NTPSI','NDPSI'/
  !------------------------------------------------

  zid=id
  call uupper(zid)

  ilev = -1

  if(zid(1:1).eq.'L') then
     tdb_steerxcep = .TRUE.
     ilev = 0
     do i=1,nids
        if('~'//trim(zid).eq.trim(zid_xcep(i))) ilev = 1
     enddo

  else
     tdb_steerxcep = .FALSE.
     do i=1,nids
        if(trim(zid).eq.trim(zid_xcep(i))) then
           tdb_steerxcep=.TRUE.
           ilev = 0
        else if('~'//trim(zid).eq.trim(zid_xcep(i))) then
           tdb_steerxcep=.TRUE.
           ilev = 1
        endif
     enddo
  endif

end function tdb_steerxcep

module trdatbuf_intmod
  !
  ! **generated by gensis_f90.py -- do not edit!
 
  IMPLICIT NONE
 
  ! module containing trdatbuf object integer data names, sizes and values
  !   for use with MDSplus I/O
 
  integer, parameter :: nivar = 904
  ! number of integer, parameter variables in trdatbuf object
 
  integer :: ivarsize(nivar+1)
  ! size (dimensions) of integer variables in trdatbuf object
 
  integer :: ilen2
  ! computed length for intbuf (=sum(ivarsize(1:nivar+1))
 
  integer, dimension(:), allocatable :: intbuf
  ! concatenation of all integer data in trdatbuf object
                                                ! for use in MDSplus I/O
 
  character*16 :: ivarname(nivar+1)
  ! names of integer variables in trdatbuf object
 
  contains
 
    subroutine intmod_init
 
      call trdatbuf_intmod_sub1(ivarname,ivarsize,nivar+1)
 
      ilen2 = sum(ivarsize)
      allocate(intbuf(ilen2))
 
      return
 
    end subroutine intmod_init
 
    subroutine fill_intbuf(s)
      use trdatbuf_obj
 
      type(trdatbuf) :: s
 
      call trdatbuf_intmod_sub2(s,ivarsize,nivar+1,intbuf,ilen2)
 
      return
 
    end subroutine fill_intbuf
 
    subroutine get_intbuf(s)
      use trdatbuf_obj
 
      type(trdatbuf) :: s
 
      ! gensis_f90 mod: allow recovery from singleton deletions, only...
 
      call trdatbuf_intmod_sub3(s,ivarsize,ivarname,nivar+1,intbuf,ilen2)
 
      return
 
    end subroutine get_intbuf
 
end module trdatbuf_intmod

 
SUBROUTINE trdatbuf_intmod_sub3(s,ivarsize,ivarname,idimvs,intbuf,idimi)
  ! ** gensis_f90.py generated code, do NOT edit **
 
  use trdatbuf_obj
  IMPLICIT NONE
 
  type(trdatbuf) :: s
  integer :: idimvs,idimi
  integer :: ivarsize(idimvs)
  character*(*) :: ivarname(idimvs)
  integer :: intbuf(idimi)
 
  integer :: i,i1,i2
 
  !----------------------
  ! gensis_f90 mod: allow recovery from singleton deletions, only...
  !----------------------
 
  i=0
  i1=0
  i2=ivarsize(1) - 1
 
      do while ( i < 904)
 
         i = i + 1
         i1 = i1 + 1
         i2 = i2 + 1
 
         if(ivarname(i).eq.' ') exit
         if(ichar(ivarname(i)(1:1)).eq.0) exit
 
           call trdatbuf_intcopy('LADR_ZA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LADR_ZA)
           call trdatbuf_intcopy('LADR_ZAF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LADR_ZAF)
           call trdatbuf_intcopy('LAEPDE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPDE)
           call trdatbuf_intcopy('LAEPDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPDP)
           call trdatbuf_intcopy('LAEPE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPE)
           call trdatbuf_intcopy('LAEPMAP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPMAP)
           call trdatbuf_intcopy('LAEPMU',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPMU)
           call trdatbuf_intcopy('LAEPP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPP)
           call trdatbuf_intcopy('LAEPSP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPSP)
           call trdatbuf_intcopy('LAEPTS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAEPTS)
           call trdatbuf_intcopy('LAIMPS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAIMPS)
           call trdatbuf_intcopy('LAIMPX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LAIMPX)
           call trdatbuf_intcopy('LDATALP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATALP)
           call trdatbuf_intcopy('LDATBDI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATBDI)
           call trdatbuf_intcopy('LDATCUR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATCUR)
           call trdatbuf_intcopy('LDATDFL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATDFL)
           call trdatbuf_intcopy('LDATDTG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATDTG)
           call trdatbuf_intcopy('LDATDTS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATDTS)
           call trdatbuf_intcopy('LDATDTX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATDTX)
           call trdatbuf_intcopy('LDATEDI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATEDI)
           call trdatbuf_intcopy('LDATEHP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATEHP)
           call trdatbuf_intcopy('LDATELI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATELI)
           call trdatbuf_intcopy('LDATFGW',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATFGW)
           call trdatbuf_intcopy('LDATFIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATFIE)
           call trdatbuf_intcopy('LDATFMN',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATFMN)
           call trdatbuf_intcopy('LDATFMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATFMX)
           call trdatbuf_intcopy('LDATGAS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGAS)
           call trdatbuf_intcopy('LDATGF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGF3)
           call trdatbuf_intcopy('LDATGF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGF4)
           call trdatbuf_intcopy('LDATGF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGF6)
           call trdatbuf_intcopy('LDATGFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGFD)
           call trdatbuf_intcopy('LDATGFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGFH)
           call trdatbuf_intcopy('LDATGFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGFT)
           call trdatbuf_intcopy('LDATGIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATGIE)
           call trdatbuf_intcopy('LDATHAL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATHAL)
           call trdatbuf_intcopy('LDATIBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATIBM)
           call trdatbuf_intcopy('LDATIEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATIEC)
           call trdatbuf_intcopy('LDATIIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATIIC)
           call trdatbuf_intcopy('LDATILH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATILH)
           call trdatbuf_intcopy('LDATL2B',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATL2B)
           call trdatbuf_intcopy('LDATLAD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATLAD)
           call trdatbuf_intcopy('LDATLID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATLID)
           call trdatbuf_intcopy('LDATNTX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATNTX)
           call trdatbuf_intcopy('LDATOGF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATOGF)
           call trdatbuf_intcopy('LDATORC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATORC)
           call trdatbuf_intcopy('LDATPBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPBE)
           call trdatbuf_intcopy('LDATPBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPBI)
           call trdatbuf_intcopy('LDATPEB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPEB)
           call trdatbuf_intcopy('LDATPEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPEC)
           call trdatbuf_intcopy('LDATPF0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPF0)
           call trdatbuf_intcopy('LDATPFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPFH)
           call trdatbuf_intcopy('LDATPFL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPFL)
           call trdatbuf_intcopy('LDATPIB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPIB)
           call trdatbuf_intcopy('LDATPIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPIC)
           call trdatbuf_intcopy('LDATPLF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPLF)
           call trdatbuf_intcopy('LDATPLH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPLH)
           call trdatbuf_intcopy('LDATPOS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATPOS)
           call trdatbuf_intcopy('LDATRBZ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRBZ)
           call trdatbuf_intcopy('LDATRC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRC3)
           call trdatbuf_intcopy('LDATRC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRC4)
           call trdatbuf_intcopy('LDATRC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRC6)
           call trdatbuf_intcopy('LDATRCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRCD)
           call trdatbuf_intcopy('LDATRCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRCH)
           call trdatbuf_intcopy('LDATRCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRCT)
           call trdatbuf_intcopy('LDATRCY',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRCY)
           call trdatbuf_intcopy('LDATRMN',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRMN)
           call trdatbuf_intcopy('LDATRTP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATRTP)
           call trdatbuf_intcopy('LDATSBT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSBT)
           call trdatbuf_intcopy('LDATSF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSF3)
           call trdatbuf_intcopy('LDATSFA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSFA)
           call trdatbuf_intcopy('LDATSFL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSFL)
           call trdatbuf_intcopy('LDATSFP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSFP)
           call trdatbuf_intcopy('LDATSFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSFT)
           call trdatbuf_intcopy('LDATSP3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATSP3)
           call trdatbuf_intcopy('LDATTET',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTET)
           call trdatbuf_intcopy('LDATTGF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTGF)
           call trdatbuf_intcopy('LDATTIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTIT)
           call trdatbuf_intcopy('LDATTPI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTPI)
           call trdatbuf_intcopy('LDATTQT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTQT)
           call trdatbuf_intcopy('LDATTRC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTRC)
           call trdatbuf_intcopy('LDATTRF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTRF)
           call trdatbuf_intcopy('LDATTXI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATTXI)
           call trdatbuf_intcopy('LDATVPH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATVPH)
           call trdatbuf_intcopy('LDATVSB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATVSB)
           call trdatbuf_intcopy('LDATVSF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATVSF)
           call trdatbuf_intcopy('LDATXKF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATXKF)
           call trdatbuf_intcopy('LDATZEF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATZEF)
           call trdatbuf_intcopy('LDATZFA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATZFA)
           call trdatbuf_intcopy('LDATZIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATZIM)
           call trdatbuf_intcopy('LDATZPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDATZPL)
           call trdatbuf_intcopy('LDMDF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDMDF)
           call trdatbuf_intcopy('LDMFR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDMFR)
           call trdatbuf_intcopy('LDMMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDMMX)
           call trdatbuf_intcopy('LDMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDMSE)
           call trdatbuf_intcopy('LDPFC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDPFC)
           call trdatbuf_intcopy('LDPFC_PRE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LDPFC_PRE)
           call trdatbuf_intcopy('LEFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFD0)
           call trdatbuf_intcopy('LEFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFDB)
           call trdatbuf_intcopy('LEFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFDP)
           call trdatbuf_intcopy('LEFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFDQ)
           call trdatbuf_intcopy('LEFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFDR)
           call trdatbuf_intcopy('LEFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LEFDS)
           call trdatbuf_intcopy('LFAEPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFAEPA)
           call trdatbuf_intcopy('LFAEPP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFAEPP)
           call trdatbuf_intcopy('LFAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFAXR)
           call trdatbuf_intcopy('LFBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFBOL)
           call trdatbuf_intcopy('LFBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFBPA)
           call trdatbuf_intcopy('LFBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFBPB)
           call trdatbuf_intcopy('LFD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFD2F)
           call trdatbuf_intcopy('LFDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDE2)
           call trdatbuf_intcopy('LFDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDF3)
           call trdatbuf_intcopy('LFDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDF4)
           call trdatbuf_intcopy('LFDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDF6)
           call trdatbuf_intcopy('LFDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDFD)
           call trdatbuf_intcopy('LFDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDFH)
           call trdatbuf_intcopy('LFDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFDFT)
           call trdatbuf_intcopy('LFECA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFECA)
           call trdatbuf_intcopy('LFECB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFECB)
           call trdatbuf_intcopy('LFECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFECF)
           call trdatbuf_intcopy('LFFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFD0)
           call trdatbuf_intcopy('LFFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFDB)
           call trdatbuf_intcopy('LFFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFDP)
           call trdatbuf_intcopy('LFFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFDQ)
           call trdatbuf_intcopy('LFFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFDR)
           call trdatbuf_intcopy('LFFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFDS)
           call trdatbuf_intcopy('LFFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFEH)
           call trdatbuf_intcopy('LFFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFFEL)
           call trdatbuf_intcopy('LFGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFGRB)
           call trdatbuf_intcopy('LFIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFIBE)
           call trdatbuf_intcopy('LFIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFIBI)
           call trdatbuf_intcopy('LFJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFJBM)
           call trdatbuf_intcopy('LFJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFJEC)
           call trdatbuf_intcopy('LFJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFJIC)
           call trdatbuf_intcopy('LFLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLF3)
           call trdatbuf_intcopy('LFLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLF4)
           call trdatbuf_intcopy('LFLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLF6)
           call trdatbuf_intcopy('LFLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLFD)
           call trdatbuf_intcopy('LFLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLFH)
           call trdatbuf_intcopy('LFLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLFT)
           call trdatbuf_intcopy('LFLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLHE)
           call trdatbuf_intcopy('LFLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFLHJ)
           call trdatbuf_intcopy('LFMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFMSE)
           call trdatbuf_intcopy('LFNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNER)
           call trdatbuf_intcopy('LFNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNI3)
           call trdatbuf_intcopy('LFNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNI4)
           call trdatbuf_intcopy('LFNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNI6)
           call trdatbuf_intcopy('LFNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNID)
           call trdatbuf_intcopy('LFNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNIH)
           call trdatbuf_intcopy('LFNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNIM)
           call trdatbuf_intcopy('LFNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNIT)
           call trdatbuf_intcopy('LFNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFNMR)
           call trdatbuf_intcopy('LFOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFOMG)
           call trdatbuf_intcopy('LFPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFPRS)
           call trdatbuf_intcopy('LFPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFPSI)
           call trdatbuf_intcopy('LFQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFQBE)
           call trdatbuf_intcopy('LFQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFQBI)
           call trdatbuf_intcopy('LFQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFQEC)
           call trdatbuf_intcopy('LFQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFQIC)
           call trdatbuf_intcopy('LFQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFQPR)
           call trdatbuf_intcopy('LFREE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFREE)
           call trdatbuf_intcopy('LFRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFRES)
           call trdatbuf_intcopy('LFRQRFF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFRQRFF)
           call trdatbuf_intcopy('LFSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSBI)
           call trdatbuf_intcopy_a('LFSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSIM)
           call trdatbuf_intcopy('LFSYAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYAXR)
           call trdatbuf_intcopy('LFSYBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYBOL)
           call trdatbuf_intcopy('LFSYBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYBPA)
           call trdatbuf_intcopy('LFSYBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYBPB)
           call trdatbuf_intcopy('LFSYD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYD2F)
           call trdatbuf_intcopy('LFSYDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDE2)
           call trdatbuf_intcopy('LFSYDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDF3)
           call trdatbuf_intcopy('LFSYDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDF4)
           call trdatbuf_intcopy('LFSYDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDF6)
           call trdatbuf_intcopy('LFSYDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDFD)
           call trdatbuf_intcopy('LFSYDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDFH)
           call trdatbuf_intcopy('LFSYDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYDFT)
           call trdatbuf_intcopy('LFSYECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYECF)
           call trdatbuf_intcopy('LFSYFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYFEH)
           call trdatbuf_intcopy('LFSYFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYFEL)
           call trdatbuf_intcopy('LFSYGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYGRB)
           call trdatbuf_intcopy('LFSYIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYIBE)
           call trdatbuf_intcopy('LFSYIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYIBI)
           call trdatbuf_intcopy('LFSYJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYJBM)
           call trdatbuf_intcopy('LFSYJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYJEC)
           call trdatbuf_intcopy('LFSYJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYJIC)
           call trdatbuf_intcopy('LFSYLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLF3)
           call trdatbuf_intcopy('LFSYLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLF4)
           call trdatbuf_intcopy('LFSYLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLF6)
           call trdatbuf_intcopy('LFSYLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLFD)
           call trdatbuf_intcopy('LFSYLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLFH)
           call trdatbuf_intcopy('LFSYLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLFT)
           call trdatbuf_intcopy('LFSYLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLHE)
           call trdatbuf_intcopy('LFSYLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYLHJ)
           call trdatbuf_intcopy('LFSYMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYMSE)
           call trdatbuf_intcopy('LFSYNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNER)
           call trdatbuf_intcopy('LFSYNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNI3)
           call trdatbuf_intcopy('LFSYNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNI4)
           call trdatbuf_intcopy('LFSYNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNI6)
           call trdatbuf_intcopy('LFSYNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNID)
           call trdatbuf_intcopy('LFSYNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNIH)
           call trdatbuf_intcopy('LFSYNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNIM)
           call trdatbuf_intcopy('LFSYNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNIT)
           call trdatbuf_intcopy('LFSYNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYNMR)
           call trdatbuf_intcopy('LFSYOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYOMG)
           call trdatbuf_intcopy('LFSYPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYPRS)
           call trdatbuf_intcopy('LFSYQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYQBE)
           call trdatbuf_intcopy('LFSYQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYQBI)
           call trdatbuf_intcopy('LFSYQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYQEC)
           call trdatbuf_intcopy('LFSYQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYQIC)
           call trdatbuf_intcopy('LFSYQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYQPR)
           call trdatbuf_intcopy('LFSYRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYRES)
           call trdatbuf_intcopy('LFSYSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYSBI)
           call trdatbuf_intcopy_a('LFSYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYSIM)
           call trdatbuf_intcopy('LFSYTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYTER)
           call trdatbuf_intcopy('LFSYTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYTI2)
           call trdatbuf_intcopy('LFSYTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYTQI)
           call trdatbuf_intcopy('LFSYV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYV2F)
           call trdatbuf_intcopy('LFSYVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVB2)
           call trdatbuf_intcopy('LFSYVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVC3)
           call trdatbuf_intcopy('LFSYVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVC4)
           call trdatbuf_intcopy('LFSYVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVC6)
           call trdatbuf_intcopy('LFSYVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVCD)
           call trdatbuf_intcopy('LFSYVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVCH)
           call trdatbuf_intcopy('LFSYVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVCT)
           call trdatbuf_intcopy('LFSYVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVEE)
           call trdatbuf_intcopy('LFSYVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVIE)
           call trdatbuf_intcopy('LFSYVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVMO)
           call trdatbuf_intcopy('LFSYVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVP2)
           call trdatbuf_intcopy('LFSYVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVPO)
           call trdatbuf_intcopy('LFSYVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVPR)
           call trdatbuf_intcopy('LFSYVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYVTR)
           call trdatbuf_intcopy('LFSYZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYZF2)
           call trdatbuf_intcopy('LFSYZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFSYZXR)
           call trdatbuf_intcopy('LFTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFTER)
           call trdatbuf_intcopy('LFTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFTI2)
           call trdatbuf_intcopy('LFTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFTQI)
           call trdatbuf_intcopy('LFULNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFULNB)
           call trdatbuf_intcopy('LFV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFV2F)
           call trdatbuf_intcopy('LFVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVB2)
           call trdatbuf_intcopy('LFVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVC3)
           call trdatbuf_intcopy('LFVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVC4)
           call trdatbuf_intcopy('LFVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVC6)
           call trdatbuf_intcopy('LFVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVCD)
           call trdatbuf_intcopy('LFVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVCH)
           call trdatbuf_intcopy('LFVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVCT)
           call trdatbuf_intcopy('LFVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVEE)
           call trdatbuf_intcopy('LFVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVIE)
           call trdatbuf_intcopy('LFVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVMO)
           call trdatbuf_intcopy('LFVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVP2)
           call trdatbuf_intcopy('LFVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVPO)
           call trdatbuf_intcopy('LFVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVPR)
           call trdatbuf_intcopy('LFVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFVTR)
           call trdatbuf_intcopy('LFZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFZF2)
           call trdatbuf_intcopy('LFZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LFZXR)
           call trdatbuf_intcopy('LHLFNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LHLFNB)
           call trdatbuf_intcopy('LLIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LLIM)
           call trdatbuf_intcopy('LMOMD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LMOMD)
           call trdatbuf_intcopy('LPELDA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPELDA)
           call trdatbuf_intcopy('LPHSLH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPHSLH)
           call trdatbuf_intcopy('LPMDF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPMDF)
           call trdatbuf_intcopy('LPMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPMSE)
           call trdatbuf_intcopy('LPWREC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPWREC)
           call trdatbuf_intcopy('LPWRLH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPWRLH)
           call trdatbuf_intcopy('LPWRNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPWRNB)
           call trdatbuf_intcopy('LPWRRF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LPWRRF)
           call trdatbuf_intcopy('LRFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRFS)
           call trdatbuf_intcopy('LRMFR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRMFR)
           call trdatbuf_intcopy('LRMP_BDY1',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRMP_BDY1)
           call trdatbuf_intcopy('LRMP_BDY2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRMP_BDY2)
           call trdatbuf_intcopy('LRMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRMSE)
           call trdatbuf_intcopy('LRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRP2)
           call trdatbuf_intcopy('LRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRPL)
           call trdatbuf_intcopy('LRPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LRPSI)
           call trdatbuf_intcopy('LSEVENT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSEVENT)
           call trdatbuf_intcopy('LSSYAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYAXR)
           call trdatbuf_intcopy('LSSYBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYBOL)
           call trdatbuf_intcopy('LSSYBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYBPA)
           call trdatbuf_intcopy('LSSYBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYBPB)
           call trdatbuf_intcopy('LSSYD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYD2F)
           call trdatbuf_intcopy('LSSYDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDE2)
           call trdatbuf_intcopy('LSSYDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDF3)
           call trdatbuf_intcopy('LSSYDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDF4)
           call trdatbuf_intcopy('LSSYDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDF6)
           call trdatbuf_intcopy('LSSYDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDFD)
           call trdatbuf_intcopy('LSSYDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDFH)
           call trdatbuf_intcopy('LSSYDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYDFT)
           call trdatbuf_intcopy('LSSYECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYECF)
           call trdatbuf_intcopy('LSSYFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYFEH)
           call trdatbuf_intcopy('LSSYFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYFEL)
           call trdatbuf_intcopy('LSSYGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYGRB)
           call trdatbuf_intcopy('LSSYIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYIBE)
           call trdatbuf_intcopy('LSSYIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYIBI)
           call trdatbuf_intcopy('LSSYJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYJBM)
           call trdatbuf_intcopy('LSSYJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYJEC)
           call trdatbuf_intcopy('LSSYJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYJIC)
           call trdatbuf_intcopy('LSSYLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLF3)
           call trdatbuf_intcopy('LSSYLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLF4)
           call trdatbuf_intcopy('LSSYLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLF6)
           call trdatbuf_intcopy('LSSYLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLFD)
           call trdatbuf_intcopy('LSSYLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLFH)
           call trdatbuf_intcopy('LSSYLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLFT)
           call trdatbuf_intcopy('LSSYLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLHE)
           call trdatbuf_intcopy('LSSYLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYLHJ)
           call trdatbuf_intcopy('LSSYMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYMSE)
           call trdatbuf_intcopy('LSSYNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNER)
           call trdatbuf_intcopy('LSSYNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNI3)
           call trdatbuf_intcopy('LSSYNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNI4)
           call trdatbuf_intcopy('LSSYNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNI6)
           call trdatbuf_intcopy('LSSYNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNID)
           call trdatbuf_intcopy('LSSYNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNIH)
           call trdatbuf_intcopy('LSSYNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNIM)
           call trdatbuf_intcopy('LSSYNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNIT)
           call trdatbuf_intcopy('LSSYNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYNMR)
           call trdatbuf_intcopy('LSSYOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYOMG)
           call trdatbuf_intcopy('LSSYPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYPRS)
           call trdatbuf_intcopy('LSSYQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYQBE)
           call trdatbuf_intcopy('LSSYQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYQBI)
           call trdatbuf_intcopy('LSSYQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYQEC)
           call trdatbuf_intcopy('LSSYQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYQIC)
           call trdatbuf_intcopy('LSSYQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYQPR)
           call trdatbuf_intcopy('LSSYRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYRES)
           call trdatbuf_intcopy('LSSYSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYSBI)
           call trdatbuf_intcopy_a('LSSYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYSIM)
           call trdatbuf_intcopy('LSSYTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYTER)
           call trdatbuf_intcopy('LSSYTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYTI2)
           call trdatbuf_intcopy('LSSYTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYTQI)
           call trdatbuf_intcopy('LSSYV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYV2F)
           call trdatbuf_intcopy('LSSYVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVB2)
           call trdatbuf_intcopy('LSSYVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVC3)
           call trdatbuf_intcopy('LSSYVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVC4)
           call trdatbuf_intcopy('LSSYVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVC6)
           call trdatbuf_intcopy('LSSYVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVCD)
           call trdatbuf_intcopy('LSSYVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVCH)
           call trdatbuf_intcopy('LSSYVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVCT)
           call trdatbuf_intcopy('LSSYVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVEE)
           call trdatbuf_intcopy('LSSYVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVIE)
           call trdatbuf_intcopy('LSSYVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVMO)
           call trdatbuf_intcopy('LSSYVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVP2)
           call trdatbuf_intcopy('LSSYVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVPO)
           call trdatbuf_intcopy('LSSYVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVPR)
           call trdatbuf_intcopy('LSSYVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYVTR)
           call trdatbuf_intcopy('LSSYZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYZF2)
           call trdatbuf_intcopy('LSSYZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LSSYZXR)
           call trdatbuf_intcopy('LTABORT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTABORT)
           call trdatbuf_intcopy('LTAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTAEP)
           call trdatbuf_intcopy('LTFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFD0)
           call trdatbuf_intcopy('LTFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFDB)
           call trdatbuf_intcopy('LTFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFDP)
           call trdatbuf_intcopy('LTFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFDQ)
           call trdatbuf_intcopy('LTFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFDR)
           call trdatbuf_intcopy('LTFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTFDS)
           call trdatbuf_intcopy('LTHFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTHFS)
           call trdatbuf_intcopy('LTIME1',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIME1)
           call trdatbuf_intcopy('LTIME2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIME2)
           call trdatbuf_intcopy('LTIMEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMEC)
           call trdatbuf_intcopy('LTIMECA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMECA)
           call trdatbuf_intcopy('LTIMECB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMECB)
           call trdatbuf_intcopy('LTIMLH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMLH)
           call trdatbuf_intcopy('LTIMNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMNB)
           call trdatbuf_intcopy('LTIMRF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMRF)
           call trdatbuf_intcopy('LTIMRFF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTIMRFF)
           call trdatbuf_intcopy('LTPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTPSI)
           call trdatbuf_intcopy('LTSAW',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LTSAW)
           call trdatbuf_intcopy('LVLTNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LVLTNB)
           call trdatbuf_intcopy('LXAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXAXR)
           call trdatbuf_intcopy('LXBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXBOL)
           call trdatbuf_intcopy('LXBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXBPA)
           call trdatbuf_intcopy('LXBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXBPB)
           call trdatbuf_intcopy('LXD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXD2F)
           call trdatbuf_intcopy('LXDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDE2)
           call trdatbuf_intcopy('LXDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDF3)
           call trdatbuf_intcopy('LXDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDF4)
           call trdatbuf_intcopy('LXDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDF6)
           call trdatbuf_intcopy('LXDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDFD)
           call trdatbuf_intcopy('LXDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDFH)
           call trdatbuf_intcopy('LXDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXDFT)
           call trdatbuf_intcopy('LXECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXECF)
           call trdatbuf_intcopy('LXFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFD0)
           call trdatbuf_intcopy('LXFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFDB)
           call trdatbuf_intcopy('LXFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFDP)
           call trdatbuf_intcopy('LXFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFDQ)
           call trdatbuf_intcopy('LXFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFDR)
           call trdatbuf_intcopy('LXFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFDS)
           call trdatbuf_intcopy('LXFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFEH)
           call trdatbuf_intcopy('LXFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFEL)
           call trdatbuf_intcopy('LXFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXFS)
           call trdatbuf_intcopy('LXGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXGRB)
           call trdatbuf_intcopy('LXIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXIBE)
           call trdatbuf_intcopy('LXIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXIBI)
           call trdatbuf_intcopy('LXJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXJBM)
           call trdatbuf_intcopy('LXJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXJEC)
           call trdatbuf_intcopy('LXJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXJIC)
           call trdatbuf_intcopy('LXLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLF3)
           call trdatbuf_intcopy('LXLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLF4)
           call trdatbuf_intcopy('LXLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLF6)
           call trdatbuf_intcopy('LXLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLFD)
           call trdatbuf_intcopy('LXLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLFH)
           call trdatbuf_intcopy('LXLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLFT)
           call trdatbuf_intcopy('LXLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLHE)
           call trdatbuf_intcopy('LXLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXLHJ)
           call trdatbuf_intcopy('LXMMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXMMX)
           call trdatbuf_intcopy('LXMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXMSE)
           call trdatbuf_intcopy('LXNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNER)
           call trdatbuf_intcopy('LXNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNI3)
           call trdatbuf_intcopy('LXNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNI4)
           call trdatbuf_intcopy('LXNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNI6)
           call trdatbuf_intcopy('LXNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNID)
           call trdatbuf_intcopy('LXNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNIH)
           call trdatbuf_intcopy('LXNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNIM)
           call trdatbuf_intcopy('LXNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNIT)
           call trdatbuf_intcopy('LXNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXNMR)
           call trdatbuf_intcopy('LXOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXOMG)
           call trdatbuf_intcopy('LXPFC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXPFC)
           call trdatbuf_intcopy('LXPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXPRS)
           call trdatbuf_intcopy('LXQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXQBE)
           call trdatbuf_intcopy('LXQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXQBI)
           call trdatbuf_intcopy('LXQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXQEC)
           call trdatbuf_intcopy('LXQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXQIC)
           call trdatbuf_intcopy('LXQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXQPR)
           call trdatbuf_intcopy('LXRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXRES)
           call trdatbuf_intcopy('LXRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXRP2)
           call trdatbuf_intcopy('LXRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXRPL)
           call trdatbuf_intcopy('LXSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSBI)
           call trdatbuf_intcopy_a('LXSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSIM)
           call trdatbuf_intcopy('LXSYAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYAXR)
           call trdatbuf_intcopy('LXSYBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYBOL)
           call trdatbuf_intcopy('LXSYBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYBPA)
           call trdatbuf_intcopy('LXSYBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYBPB)
           call trdatbuf_intcopy('LXSYD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYD2F)
           call trdatbuf_intcopy('LXSYDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDE2)
           call trdatbuf_intcopy('LXSYDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDF3)
           call trdatbuf_intcopy('LXSYDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDF4)
           call trdatbuf_intcopy('LXSYDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDF6)
           call trdatbuf_intcopy('LXSYDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDFD)
           call trdatbuf_intcopy('LXSYDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDFH)
           call trdatbuf_intcopy('LXSYDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYDFT)
           call trdatbuf_intcopy('LXSYECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYECF)
           call trdatbuf_intcopy('LXSYFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYFEH)
           call trdatbuf_intcopy('LXSYFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYFEL)
           call trdatbuf_intcopy('LXSYGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYGRB)
           call trdatbuf_intcopy('LXSYIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYIBE)
           call trdatbuf_intcopy('LXSYIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYIBI)
           call trdatbuf_intcopy('LXSYJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYJBM)
           call trdatbuf_intcopy('LXSYJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYJEC)
           call trdatbuf_intcopy('LXSYJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYJIC)
           call trdatbuf_intcopy('LXSYLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLF3)
           call trdatbuf_intcopy('LXSYLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLF4)
           call trdatbuf_intcopy('LXSYLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLF6)
           call trdatbuf_intcopy('LXSYLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLFD)
           call trdatbuf_intcopy('LXSYLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLFH)
           call trdatbuf_intcopy('LXSYLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLFT)
           call trdatbuf_intcopy('LXSYLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLHE)
           call trdatbuf_intcopy('LXSYLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYLHJ)
           call trdatbuf_intcopy('LXSYMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYMSE)
           call trdatbuf_intcopy('LXSYNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNER)
           call trdatbuf_intcopy('LXSYNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNI3)
           call trdatbuf_intcopy('LXSYNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNI4)
           call trdatbuf_intcopy('LXSYNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNI6)
           call trdatbuf_intcopy('LXSYNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNID)
           call trdatbuf_intcopy('LXSYNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNIH)
           call trdatbuf_intcopy('LXSYNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNIM)
           call trdatbuf_intcopy('LXSYNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNIT)
           call trdatbuf_intcopy('LXSYNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYNMR)
           call trdatbuf_intcopy('LXSYOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYOMG)
           call trdatbuf_intcopy('LXSYPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYPRS)
           call trdatbuf_intcopy('LXSYQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYQBE)
           call trdatbuf_intcopy('LXSYQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYQBI)
           call trdatbuf_intcopy('LXSYQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYQEC)
           call trdatbuf_intcopy('LXSYQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYQIC)
           call trdatbuf_intcopy('LXSYQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYQPR)
           call trdatbuf_intcopy('LXSYRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYRES)
           call trdatbuf_intcopy('LXSYSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYSBI)
           call trdatbuf_intcopy_a('LXSYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYSIM)
           call trdatbuf_intcopy('LXSYTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYTER)
           call trdatbuf_intcopy('LXSYTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYTI2)
           call trdatbuf_intcopy('LXSYTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYTQI)
           call trdatbuf_intcopy('LXSYV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYV2F)
           call trdatbuf_intcopy('LXSYVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVB2)
           call trdatbuf_intcopy('LXSYVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVC3)
           call trdatbuf_intcopy('LXSYVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVC4)
           call trdatbuf_intcopy('LXSYVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVC6)
           call trdatbuf_intcopy('LXSYVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVCD)
           call trdatbuf_intcopy('LXSYVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVCH)
           call trdatbuf_intcopy('LXSYVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVCT)
           call trdatbuf_intcopy('LXSYVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVEE)
           call trdatbuf_intcopy('LXSYVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVIE)
           call trdatbuf_intcopy('LXSYVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVMO)
           call trdatbuf_intcopy('LXSYVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVP2)
           call trdatbuf_intcopy('LXSYVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVPO)
           call trdatbuf_intcopy('LXSYVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVPR)
           call trdatbuf_intcopy('LXSYVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYVTR)
           call trdatbuf_intcopy('LXSYZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYZF2)
           call trdatbuf_intcopy('LXSYZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXSYZXR)
           call trdatbuf_intcopy('LXTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXTER)
           call trdatbuf_intcopy('LXTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXTI2)
           call trdatbuf_intcopy('LXTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXTQI)
           call trdatbuf_intcopy('LXV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXV2F)
           call trdatbuf_intcopy('LXVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVB2)
           call trdatbuf_intcopy('LXVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVC3)
           call trdatbuf_intcopy('LXVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVC4)
           call trdatbuf_intcopy('LXVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVC6)
           call trdatbuf_intcopy('LXVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVCD)
           call trdatbuf_intcopy('LXVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVCH)
           call trdatbuf_intcopy('LXVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVCT)
           call trdatbuf_intcopy('LXVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVEE)
           call trdatbuf_intcopy('LXVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVIE)
           call trdatbuf_intcopy('LXVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVMO)
           call trdatbuf_intcopy('LXVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVP2)
           call trdatbuf_intcopy('LXVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVPO)
           call trdatbuf_intcopy('LXVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVPR)
           call trdatbuf_intcopy('LXVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXVTR)
           call trdatbuf_intcopy('LXZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXZF2)
           call trdatbuf_intcopy('LXZIMPS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXZIMPS)
           call trdatbuf_intcopy('LXZIMPX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXZIMPX)
           call trdatbuf_intcopy('LXZIMPXS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXZIMPXS)
           call trdatbuf_intcopy('LXZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LXZXR)
           call trdatbuf_intcopy('LYRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LYRP2)
           call trdatbuf_intcopy('LYRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LYRPL)
           call trdatbuf_intcopy('LYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LYSIM)
           call trdatbuf_intcopy('LZFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LZFS)
           call trdatbuf_intcopy('LZPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%LZPSI)
           call trdatbuf_intcopy('MMAX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%MMAX)
           call trdatbuf_intcopy('MMX_MAXE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%MMX_MAXE)
           call trdatbuf_intcopy('MTRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%MTRP2)
           call trdatbuf_intcopy('MTRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%MTRPL)
           call trdatbuf_intcopy('NANTECH_D',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NANTECH_D)
           call trdatbuf_intcopy('NANTICH_D',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NANTICH_D)
           call trdatbuf_intcopy('NANTLH_D',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NANTLH_D)
           call trdatbuf_intcopy('NBDATA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NBDATA)
           call trdatbuf_intcopy('NDEAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDEAEP)
           call trdatbuf_intcopy('NDFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDFS)
           call trdatbuf_intcopy('NDMDF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDMDF)
           call trdatbuf_intcopy('NDMFR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDMFR)
           call trdatbuf_intcopy('NDMMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDMMX)
           call trdatbuf_intcopy('NDMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDMSE)
           call trdatbuf_intcopy('NDPAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDPAEP)
           call trdatbuf_intcopy('NDPFC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDPFC)
           call trdatbuf_intcopy('NDPFC_PRE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NDPFC_PRE)
           call trdatbuf_intcopy('NEAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEAEP)
           call trdatbuf_intcopy('NEFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFD0)
           call trdatbuf_intcopy('NEFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFDB)
           call trdatbuf_intcopy('NEFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFDP)
           call trdatbuf_intcopy('NEFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFDQ)
           call trdatbuf_intcopy('NEFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFDR)
           call trdatbuf_intcopy('NEFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NEFDS)
           call trdatbuf_intcopy('NFRBCODE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NFRBCODE)
           call trdatbuf_intcopy('NFRBMODE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NFRBMODE)
           call trdatbuf_intcopy('NGMAX_D',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NGMAX_D)
           call trdatbuf_intcopy('NHECFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NHECFT)
           call trdatbuf_intcopy('NHFMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NHFMX)
           call trdatbuf_intcopy('NIMDF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NIMDF)
           call trdatbuf_intcopy_a('NISSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NISSIM)
           call trdatbuf_intcopy_a('NISX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NISX)
           call trdatbuf_intcopy_a('NITSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NITSIM)
           call trdatbuf_intcopy_a('NITX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NITX)
           call trdatbuf_intcopy('NKAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NKAEP)
           call trdatbuf_intcopy('NLIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NLIM)
           call trdatbuf_intcopy_a('NMAPSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMAPSIM)
           call trdatbuf_intcopy('NMDXKF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMDXKF)
           call trdatbuf_intcopy('NMIMP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMIMP)
           call trdatbuf_intcopy('NMOMD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMOMD)
           call trdatbuf_intcopy('NMUAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMUAEP)
           call trdatbuf_intcopy('NMZEFF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NMZEFF)
           call trdatbuf_intcopy('NNSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NNSIM)
           call trdatbuf_intcopy('NPACK',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NPACK)
           call trdatbuf_intcopy('NPAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NPAEP)
           call trdatbuf_intcopy('NPELDA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NPELDA)
           call trdatbuf_intcopy('NPMDF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NPMDF)
           call trdatbuf_intcopy('NPMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NPMSE)
           call trdatbuf_intcopy('NRHIS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRHIS)
           call trdatbuf_intcopy('NRHIX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRHIX)
           call trdatbuf_intcopy('NRIAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIAXR)
           call trdatbuf_intcopy('NRIBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIBOL)
           call trdatbuf_intcopy('NRIBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIBPA)
           call trdatbuf_intcopy('NRIBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIBPB)
           call trdatbuf_intcopy('NRID2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRID2F)
           call trdatbuf_intcopy('NRIDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDE2)
           call trdatbuf_intcopy('NRIDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDF3)
           call trdatbuf_intcopy('NRIDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDF4)
           call trdatbuf_intcopy('NRIDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDF6)
           call trdatbuf_intcopy('NRIDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDFD)
           call trdatbuf_intcopy('NRIDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDFH)
           call trdatbuf_intcopy('NRIDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIDFT)
           call trdatbuf_intcopy('NRIECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIECF)
           call trdatbuf_intcopy('NRIFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFD0)
           call trdatbuf_intcopy('NRIFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFDB)
           call trdatbuf_intcopy('NRIFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFDP)
           call trdatbuf_intcopy('NRIFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFDQ)
           call trdatbuf_intcopy('NRIFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFDR)
           call trdatbuf_intcopy('NRIFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFDS)
           call trdatbuf_intcopy('NRIFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFEH)
           call trdatbuf_intcopy('NRIFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIFEL)
           call trdatbuf_intcopy('NRIGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIGRB)
           call trdatbuf_intcopy('NRIIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIIBE)
           call trdatbuf_intcopy('NRIIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIIBI)
           call trdatbuf_intcopy('NRIJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIJBM)
           call trdatbuf_intcopy('NRIJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIJEC)
           call trdatbuf_intcopy('NRIJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIJIC)
           call trdatbuf_intcopy('NRILF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILF3)
           call trdatbuf_intcopy('NRILF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILF4)
           call trdatbuf_intcopy('NRILF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILF6)
           call trdatbuf_intcopy('NRILFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILFD)
           call trdatbuf_intcopy('NRILFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILFH)
           call trdatbuf_intcopy('NRILFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILFT)
           call trdatbuf_intcopy('NRILHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILHE)
           call trdatbuf_intcopy('NRILHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRILHJ)
           call trdatbuf_intcopy('NRIMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIMSE)
           call trdatbuf_intcopy('NRINER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINER)
           call trdatbuf_intcopy('NRINI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINI3)
           call trdatbuf_intcopy('NRINI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINI4)
           call trdatbuf_intcopy('NRINI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINI6)
           call trdatbuf_intcopy('NRINID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINID)
           call trdatbuf_intcopy('NRINIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINIH)
           call trdatbuf_intcopy('NRINIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINIM)
           call trdatbuf_intcopy('NRINIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINIT)
           call trdatbuf_intcopy('NRINMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRINMR)
           call trdatbuf_intcopy('NRIOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIOMG)
           call trdatbuf_intcopy('NRIPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIPRS)
           call trdatbuf_intcopy('NRIQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIQBE)
           call trdatbuf_intcopy('NRIQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIQBI)
           call trdatbuf_intcopy('NRIQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIQEC)
           call trdatbuf_intcopy('NRIQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIQIC)
           call trdatbuf_intcopy('NRIQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIQPR)
           call trdatbuf_intcopy('NRIRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIRES)
           call trdatbuf_intcopy('NRISBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRISBI)
           call trdatbuf_intcopy_a('NRISIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRISIM)
           call trdatbuf_intcopy('NRITER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRITER)
           call trdatbuf_intcopy('NRITI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRITI2)
           call trdatbuf_intcopy('NRITQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRITQI)
           call trdatbuf_intcopy('NRIV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIV2F)
           call trdatbuf_intcopy('NRIVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVB2)
           call trdatbuf_intcopy('NRIVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVC3)
           call trdatbuf_intcopy('NRIVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVC4)
           call trdatbuf_intcopy('NRIVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVC6)
           call trdatbuf_intcopy('NRIVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVCD)
           call trdatbuf_intcopy('NRIVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVCH)
           call trdatbuf_intcopy('NRIVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVCT)
           call trdatbuf_intcopy('NRIVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVEE)
           call trdatbuf_intcopy('NRIVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVIE)
           call trdatbuf_intcopy('NRIVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVMO)
           call trdatbuf_intcopy('NRIVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVP2)
           call trdatbuf_intcopy('NRIVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVPO)
           call trdatbuf_intcopy('NRIVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVPR)
           call trdatbuf_intcopy('NRIVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIVTR)
           call trdatbuf_intcopy('NRIZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIZF2)
           call trdatbuf_intcopy('NRIZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRIZXR)
           call trdatbuf_intcopy('NRMFR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRMFR)
           call trdatbuf_intcopy('NRMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRMSE)
           call trdatbuf_intcopy('NRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRP2)
           call trdatbuf_intcopy('NRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRPL)
           call trdatbuf_intcopy('NRPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NRPSI)
           call trdatbuf_intcopy('NSAWFLAG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSAWFLAG)
           call trdatbuf_intcopy('NSC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSC)
           call trdatbuf_intcopy('NSC_FMT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSC_FMT)
           call trdatbuf_intcopy('NSEVENT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSEVENT)
           call trdatbuf_intcopy('NSEVPER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSEVPER)
           call trdatbuf_intcopy('NSEVTBL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSEVTBL)
           call trdatbuf_intcopy('NSEVWDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSEVWDS)
           call trdatbuf_intcopy('NSFAST_D',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSFAST_D)
           call trdatbuf_intcopy('NSYAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYAXR)
           call trdatbuf_intcopy('NSYBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYBOL)
           call trdatbuf_intcopy('NSYBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYBPA)
           call trdatbuf_intcopy('NSYBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYBPB)
           call trdatbuf_intcopy('NSYD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYD2F)
           call trdatbuf_intcopy('NSYDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDE2)
           call trdatbuf_intcopy('NSYDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDF3)
           call trdatbuf_intcopy('NSYDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDF4)
           call trdatbuf_intcopy('NSYDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDF6)
           call trdatbuf_intcopy('NSYDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDFD)
           call trdatbuf_intcopy('NSYDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDFH)
           call trdatbuf_intcopy('NSYDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYDFT)
           call trdatbuf_intcopy('NSYECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYECF)
           call trdatbuf_intcopy('NSYFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYFEH)
           call trdatbuf_intcopy('NSYFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYFEL)
           call trdatbuf_intcopy('NSYGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYGRB)
           call trdatbuf_intcopy('NSYIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYIBE)
           call trdatbuf_intcopy('NSYIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYIBI)
           call trdatbuf_intcopy('NSYJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYJBM)
           call trdatbuf_intcopy('NSYJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYJEC)
           call trdatbuf_intcopy('NSYJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYJIC)
           call trdatbuf_intcopy('NSYLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLF3)
           call trdatbuf_intcopy('NSYLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLF4)
           call trdatbuf_intcopy('NSYLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLF6)
           call trdatbuf_intcopy('NSYLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLFD)
           call trdatbuf_intcopy('NSYLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLFH)
           call trdatbuf_intcopy('NSYLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLFT)
           call trdatbuf_intcopy('NSYLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLHE)
           call trdatbuf_intcopy('NSYLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYLHJ)
           call trdatbuf_intcopy('NSYMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYMSE)
           call trdatbuf_intcopy('NSYNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNER)
           call trdatbuf_intcopy('NSYNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNI3)
           call trdatbuf_intcopy('NSYNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNI4)
           call trdatbuf_intcopy('NSYNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNI6)
           call trdatbuf_intcopy('NSYNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNID)
           call trdatbuf_intcopy('NSYNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNIH)
           call trdatbuf_intcopy('NSYNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNIM)
           call trdatbuf_intcopy('NSYNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNIT)
           call trdatbuf_intcopy('NSYNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYNMR)
           call trdatbuf_intcopy('NSYOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYOMG)
           call trdatbuf_intcopy('NSYPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYPRS)
           call trdatbuf_intcopy('NSYQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYQBE)
           call trdatbuf_intcopy('NSYQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYQBI)
           call trdatbuf_intcopy('NSYQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYQEC)
           call trdatbuf_intcopy('NSYQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYQIC)
           call trdatbuf_intcopy('NSYQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYQPR)
           call trdatbuf_intcopy('NSYRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYRES)
           call trdatbuf_intcopy('NSYSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYSBI)
           call trdatbuf_intcopy_a('NSYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYSIM)
           call trdatbuf_intcopy('NSYTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYTER)
           call trdatbuf_intcopy('NSYTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYTI2)
           call trdatbuf_intcopy('NSYTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYTQI)
           call trdatbuf_intcopy('NSYV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYV2F)
           call trdatbuf_intcopy('NSYVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVB2)
           call trdatbuf_intcopy('NSYVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVC3)
           call trdatbuf_intcopy('NSYVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVC4)
           call trdatbuf_intcopy('NSYVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVC6)
           call trdatbuf_intcopy('NSYVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVCD)
           call trdatbuf_intcopy('NSYVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVCH)
           call trdatbuf_intcopy('NSYVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVCT)
           call trdatbuf_intcopy('NSYVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVEE)
           call trdatbuf_intcopy('NSYVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVIE)
           call trdatbuf_intcopy('NSYVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVMO)
           call trdatbuf_intcopy('NSYVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVP2)
           call trdatbuf_intcopy('NSYVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVPO)
           call trdatbuf_intcopy('NSYVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVPR)
           call trdatbuf_intcopy('NSYVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYVTR)
           call trdatbuf_intcopy('NSYZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYZF2)
           call trdatbuf_intcopy('NSYZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NSYZXR)
           call trdatbuf_intcopy('NTABORT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTABORT)
           call trdatbuf_intcopy('NTAEP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTAEP)
           call trdatbuf_intcopy('NTFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFD0)
           call trdatbuf_intcopy('NTFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFDB)
           call trdatbuf_intcopy('NTFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFDP)
           call trdatbuf_intcopy('NTFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFDQ)
           call trdatbuf_intcopy('NTFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFDR)
           call trdatbuf_intcopy('NTFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTFDS)
           call trdatbuf_intcopy('NTHFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTHFS)
           call trdatbuf_intcopy('NTIME1',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIME1)
           call trdatbuf_intcopy('NTIME2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIME2)
           call trdatbuf_intcopy('NTIMEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMEC)
           call trdatbuf_intcopy('NTIMECA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMECA)
           call trdatbuf_intcopy('NTIMECB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMECB)
           call trdatbuf_intcopy('NTIMLH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMLH)
           call trdatbuf_intcopy('NTIMNB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMNB)
           call trdatbuf_intcopy('NTIMRF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMRF)
           call trdatbuf_intcopy('NTIMRFF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTIMRFF)
           call trdatbuf_intcopy('NTPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTPSI)
           call trdatbuf_intcopy('NTSAW',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NTSAW)
           call trdatbuf_intcopy('NXAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXAXR)
           call trdatbuf_intcopy('NXBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXBOL)
           call trdatbuf_intcopy('NXBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXBPA)
           call trdatbuf_intcopy('NXBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXBPB)
           call trdatbuf_intcopy('NXD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXD2F)
           call trdatbuf_intcopy('NXDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDE2)
           call trdatbuf_intcopy('NXDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDF3)
           call trdatbuf_intcopy('NXDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDF4)
           call trdatbuf_intcopy('NXDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDF6)
           call trdatbuf_intcopy('NXDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDFD)
           call trdatbuf_intcopy('NXDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDFH)
           call trdatbuf_intcopy('NXDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXDFT)
           call trdatbuf_intcopy('NXECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXECF)
           call trdatbuf_intcopy('NXFD0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFD0)
           call trdatbuf_intcopy('NXFDB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFDB)
           call trdatbuf_intcopy('NXFDP',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFDP)
           call trdatbuf_intcopy('NXFDQ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFDQ)
           call trdatbuf_intcopy('NXFDR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFDR)
           call trdatbuf_intcopy('NXFDS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFDS)
           call trdatbuf_intcopy('NXFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFEH)
           call trdatbuf_intcopy('NXFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFEL)
           call trdatbuf_intcopy('NXFS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXFS)
           call trdatbuf_intcopy('NXGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXGRB)
           call trdatbuf_intcopy('NXIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXIBE)
           call trdatbuf_intcopy('NXIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXIBI)
           call trdatbuf_intcopy('NXJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXJBM)
           call trdatbuf_intcopy('NXJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXJEC)
           call trdatbuf_intcopy('NXJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXJIC)
           call trdatbuf_intcopy('NXLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLF3)
           call trdatbuf_intcopy('NXLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLF4)
           call trdatbuf_intcopy('NXLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLF6)
           call trdatbuf_intcopy('NXLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLFD)
           call trdatbuf_intcopy('NXLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLFH)
           call trdatbuf_intcopy('NXLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLFT)
           call trdatbuf_intcopy('NXLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLHE)
           call trdatbuf_intcopy('NXLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXLHJ)
           call trdatbuf_intcopy('NXMMX',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXMMX)
           call trdatbuf_intcopy('NXMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXMSE)
           call trdatbuf_intcopy('NXNE0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNE0)
           call trdatbuf_intcopy('NXNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNER)
           call trdatbuf_intcopy('NXNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNI3)
           call trdatbuf_intcopy('NXNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNI4)
           call trdatbuf_intcopy('NXNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNI6)
           call trdatbuf_intcopy('NXNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNID)
           call trdatbuf_intcopy('NXNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNIH)
           call trdatbuf_intcopy('NXNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNIM)
           call trdatbuf_intcopy('NXNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNIT)
           call trdatbuf_intcopy('NXNM0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNM0)
           call trdatbuf_intcopy('NXNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXNMR)
           call trdatbuf_intcopy('NXOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXOMG)
           call trdatbuf_intcopy('NXPFC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXPFC)
           call trdatbuf_intcopy('NXPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXPRS)
           call trdatbuf_intcopy('NXQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXQBE)
           call trdatbuf_intcopy('NXQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXQBI)
           call trdatbuf_intcopy('NXQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXQEC)
           call trdatbuf_intcopy('NXQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXQIC)
           call trdatbuf_intcopy('NXQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXQPR)
           call trdatbuf_intcopy('NXRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXRES)
           call trdatbuf_intcopy('NXRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXRP2)
           call trdatbuf_intcopy('NXRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXRPL)
           call trdatbuf_intcopy('NXSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSBI)
           call trdatbuf_intcopy_a('NXSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSIM)
           call trdatbuf_intcopy('NXSYAXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYAXR)
           call trdatbuf_intcopy('NXSYBOL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYBOL)
           call trdatbuf_intcopy('NXSYBPA',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYBPA)
           call trdatbuf_intcopy('NXSYBPB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYBPB)
           call trdatbuf_intcopy('NXSYD2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYD2F)
           call trdatbuf_intcopy('NXSYDE2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDE2)
           call trdatbuf_intcopy('NXSYDF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDF3)
           call trdatbuf_intcopy('NXSYDF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDF4)
           call trdatbuf_intcopy('NXSYDF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDF6)
           call trdatbuf_intcopy('NXSYDFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDFD)
           call trdatbuf_intcopy('NXSYDFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDFH)
           call trdatbuf_intcopy('NXSYDFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYDFT)
           call trdatbuf_intcopy('NXSYECF',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYECF)
           call trdatbuf_intcopy('NXSYFEH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYFEH)
           call trdatbuf_intcopy('NXSYFEL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYFEL)
           call trdatbuf_intcopy('NXSYGRB',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYGRB)
           call trdatbuf_intcopy('NXSYIBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYIBE)
           call trdatbuf_intcopy('NXSYIBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYIBI)
           call trdatbuf_intcopy('NXSYJBM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYJBM)
           call trdatbuf_intcopy('NXSYJEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYJEC)
           call trdatbuf_intcopy('NXSYJIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYJIC)
           call trdatbuf_intcopy('NXSYLF3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLF3)
           call trdatbuf_intcopy('NXSYLF4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLF4)
           call trdatbuf_intcopy('NXSYLF6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLF6)
           call trdatbuf_intcopy('NXSYLFD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLFD)
           call trdatbuf_intcopy('NXSYLFH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLFH)
           call trdatbuf_intcopy('NXSYLFT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLFT)
           call trdatbuf_intcopy('NXSYLHE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLHE)
           call trdatbuf_intcopy('NXSYLHJ',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYLHJ)
           call trdatbuf_intcopy('NXSYMSE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYMSE)
           call trdatbuf_intcopy('NXSYNER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNER)
           call trdatbuf_intcopy('NXSYNI3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNI3)
           call trdatbuf_intcopy('NXSYNI4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNI4)
           call trdatbuf_intcopy('NXSYNI6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNI6)
           call trdatbuf_intcopy('NXSYNID',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNID)
           call trdatbuf_intcopy('NXSYNIH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNIH)
           call trdatbuf_intcopy('NXSYNIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNIM)
           call trdatbuf_intcopy('NXSYNIT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNIT)
           call trdatbuf_intcopy('NXSYNMR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYNMR)
           call trdatbuf_intcopy('NXSYOMG',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYOMG)
           call trdatbuf_intcopy('NXSYPRS',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYPRS)
           call trdatbuf_intcopy('NXSYQBE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYQBE)
           call trdatbuf_intcopy('NXSYQBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYQBI)
           call trdatbuf_intcopy('NXSYQEC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYQEC)
           call trdatbuf_intcopy('NXSYQIC',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYQIC)
           call trdatbuf_intcopy('NXSYQPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYQPR)
           call trdatbuf_intcopy('NXSYRES',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYRES)
           call trdatbuf_intcopy('NXSYSBI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYSBI)
           call trdatbuf_intcopy_a('NXSYSIM',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYSIM)
           call trdatbuf_intcopy('NXSYTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYTER)
           call trdatbuf_intcopy('NXSYTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYTI2)
           call trdatbuf_intcopy('NXSYTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYTQI)
           call trdatbuf_intcopy('NXSYV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYV2F)
           call trdatbuf_intcopy('NXSYVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVB2)
           call trdatbuf_intcopy('NXSYVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVC3)
           call trdatbuf_intcopy('NXSYVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVC4)
           call trdatbuf_intcopy('NXSYVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVC6)
           call trdatbuf_intcopy('NXSYVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVCD)
           call trdatbuf_intcopy('NXSYVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVCH)
           call trdatbuf_intcopy('NXSYVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVCT)
           call trdatbuf_intcopy('NXSYVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVEE)
           call trdatbuf_intcopy('NXSYVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVIE)
           call trdatbuf_intcopy('NXSYVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVMO)
           call trdatbuf_intcopy('NXSYVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVP2)
           call trdatbuf_intcopy('NXSYVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVPO)
           call trdatbuf_intcopy('NXSYVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVPR)
           call trdatbuf_intcopy('NXSYVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYVTR)
           call trdatbuf_intcopy('NXSYZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYZF2)
           call trdatbuf_intcopy('NXSYZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXSYZXR)
           call trdatbuf_intcopy('NXTE0',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXTE0)
           call trdatbuf_intcopy('NXTER',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXTER)
           call trdatbuf_intcopy('NXTI2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXTI2)
           call trdatbuf_intcopy('NXTQI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXTQI)
           call trdatbuf_intcopy('NXV2F',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXV2F)
           call trdatbuf_intcopy('NXVB2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVB2)
           call trdatbuf_intcopy('NXVC3',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVC3)
           call trdatbuf_intcopy('NXVC4',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVC4)
           call trdatbuf_intcopy('NXVC6',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVC6)
           call trdatbuf_intcopy('NXVCD',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVCD)
           call trdatbuf_intcopy('NXVCH',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVCH)
           call trdatbuf_intcopy('NXVCT',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVCT)
           call trdatbuf_intcopy('NXVEE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVEE)
           call trdatbuf_intcopy('NXVIE',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVIE)
           call trdatbuf_intcopy('NXVMO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVMO)
           call trdatbuf_intcopy('NXVP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVP2)
           call trdatbuf_intcopy('NXVPO',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVPO)
           call trdatbuf_intcopy('NXVPR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVPR)
           call trdatbuf_intcopy('NXVTR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXVTR)
           call trdatbuf_intcopy('NXZEF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXZEF2)
           call trdatbuf_intcopy('NXZF2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXZF2)
           call trdatbuf_intcopy('NXZXR',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NXZXR)
           call trdatbuf_intcopy('NYRP2',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NYRP2)
           call trdatbuf_intcopy('NYRPL',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NYRPL)
           call trdatbuf_intcopy('NZPSI',ivarname(i),i,i1,i2,intbuf,ivarsize,s%NZPSI)
 
      enddo
 
END SUBROUTINE trdatbuf_intmod_sub3

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_6(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF(partial_copy) THEN
     ss2%id_PsiRZ = 0
  ENDIF
  IF((ALLOCATED(ss%PsiRZ).AND.ALLOCATED(ss2%PsiRZ)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%PsiRZ = ss%PsiRZ
     IF(.not.partial_copy) THEN
        ss2%id_PsiRZ = ss%id_PsiRZ
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_EQ).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Psi_to_machine_axis = ss%Psi_to_machine_axis
  ENDIF
  IF(partial_copy) THEN
     ss2%id_psmom_errck = 0
  ENDIF
  IF((ALLOCATED(ss%psmom_errck).AND.ALLOCATED(ss2%psmom_errck)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%psmom_errck = ss%psmom_errck
     IF(.not.partial_copy) THEN
        ss2%id_psmom_errck = ss%id_psmom_errck
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_psmom_nc)) THEN
     IF(partial_copy) THEN
        ss2%id_psmom_nc = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%psmom_nc).AND.ALLOCATED(ss2%psmom_nc)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%psmom_nc = ss%psmom_nc
     IF(ALLOCATED(ss2%id_psmom_nc)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_psmom_nc = ss%id_psmom_nc
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%psmom_num)).AND.(ALLOCATED(ss%psmom_num))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%psmom_num = ss%psmom_num
  ENDIF
  IF(partial_copy) THEN
     ss2%id_P_eq = 0
  ENDIF
  IF((ALLOCATED(ss%P_eq).AND.ALLOCATED(ss2%P_eq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%P_eq = ss%P_eq
     IF(.not.partial_copy) THEN
        ss2%id_P_eq = ss%id_P_eq
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%qatom_ALL)).AND.(ALLOCATED(ss%qatom_ALL))) THEN
     ss2%qatom_ALL = ss%qatom_ALL
  ENDIF
  IF((ALLOCATED(ss2%qatom_ALLA)).AND.(ALLOCATED(ss%qatom_ALLA))) THEN
     ss2%qatom_ALLA = ss%qatom_ALLA
  ENDIF
  IF((ALLOCATED(ss2%qatom_RFMIN)).AND.(ALLOCATED(ss%qatom_RFMIN))) THEN
     ss2%qatom_RFMIN = ss%qatom_RFMIN
  ENDIF
  IF((ALLOCATED(ss2%qatom_S)).AND.(ALLOCATED(ss%qatom_S))) THEN
     ss2%qatom_S = ss%qatom_S
  ENDIF
  IF((ALLOCATED(ss2%qatom_SA)).AND.(ALLOCATED(ss%qatom_SA))) THEN
     ss2%qatom_SA = ss%qatom_SA
  ENDIF
  IF((ALLOCATED(ss2%qatom_SFUS)).AND.(ALLOCATED(ss%qatom_SFUS))) THEN
     ss2%qatom_SFUS = ss%qatom_SFUS
  ENDIF
  IF((ALLOCATED(ss2%qatom_SGAS)).AND.(ALLOCATED(ss%qatom_SGAS))) THEN
     ss2%qatom_SGAS = ss%qatom_SGAS
  ENDIF
  IF((ALLOCATED(ss2%qatom_SIMP0)).AND.(ALLOCATED(ss%qatom_SIMP0))) THEN
     ss2%qatom_SIMP0 = ss%qatom_SIMP0
  ENDIF
  IF((ALLOCATED(ss2%qatom_SIMPI)).AND.(ALLOCATED(ss%qatom_SIMPI))) THEN
     ss2%qatom_SIMPI = ss%qatom_SIMPI
  ENDIF
  IF((ALLOCATED(ss2%qatom_SNBI)).AND.(ALLOCATED(ss%qatom_SNBI))) THEN
     ss2%qatom_SNBI = ss%qatom_SNBI
  ENDIF
  IF(ALLOCATED(ss2%id_qbeami)) THEN
     IF(partial_copy) THEN
        ss2%id_qbeami = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%qbeami).AND.ALLOCATED(ss2%qbeami)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%qbeami = ss%qbeami
     IF(ALLOCATED(ss2%id_qbeami)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_qbeami = ss%id_qbeami
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_qcomp_e = 0
  ENDIF
  IF((ALLOCATED(ss%qcomp_e).AND.ALLOCATED(ss2%qcomp_e)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%qcomp_e = ss%qcomp_e
     IF(.not.partial_copy) THEN
        ss2%id_qcomp_e = ss%id_qcomp_e
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_qcomp_i = 0
  ENDIF
  IF((ALLOCATED(ss%qcomp_i).AND.ALLOCATED(ss2%qcomp_i)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%qcomp_i = ss%qcomp_i
     IF(.not.partial_copy) THEN
        ss2%id_qcomp_i = ss%id_qcomp_i
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_qie = 0
  ENDIF
  IF((ALLOCATED(ss%qie).AND.ALLOCATED(ss2%qie)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%qie = ss%qie
     IF(.not.partial_copy) THEN
        ss2%id_qie = ss%id_qie
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_qioniz)) THEN
     IF(partial_copy) THEN
        ss2%id_qioniz = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%qioniz).AND.ALLOCATED(ss2%qioniz)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%qioniz = ss%qioniz
     IF(ALLOCATED(ss2%id_qioniz)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_qioniz = ss%id_qioniz
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%ql_operator)).AND.(ALLOCATED(ss%ql_operator))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%ql_operator = ss%ql_operator
  ENDIF
  IF(ALLOCATED(ss2%id_qqcx)) THEN
     IF(partial_copy) THEN
        ss2%id_qqcx = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%qqcx).AND.ALLOCATED(ss2%qqcx)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%qqcx = ss%qqcx
     IF(ALLOCATED(ss2%id_qqcx)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_qqcx = ss%id_qqcx
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_qrot_conv = 0
  ENDIF
  IF((ALLOCATED(ss%qrot_conv).AND.ALLOCATED(ss2%qrot_conv)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%qrot_conv = ss%qrot_conv
     IF(.not.partial_copy) THEN
        ss2%id_qrot_conv = ss%id_qrot_conv
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_qrot_diff = 0
  ENDIF
  IF((ALLOCATED(ss%qrot_diff).AND.ALLOCATED(ss2%qrot_diff)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%qrot_diff = ss%qrot_diff
     IF(.not.partial_copy) THEN
        ss2%id_qrot_diff = ss%id_qrot_diff
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%q_ALL)).AND.(ALLOCATED(ss%q_ALL))) THEN
     ss2%q_ALL = ss%q_ALL
  ENDIF
  IF((ALLOCATED(ss2%q_ALLA)).AND.(ALLOCATED(ss%q_ALLA))) THEN
     ss2%q_ALLA = ss%q_ALLA
  ENDIF
  IF(partial_copy) THEN
     ss2%id_q_eq = 0
  ENDIF
  IF((ALLOCATED(ss%q_eq).AND.ALLOCATED(ss2%q_eq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%q_eq = ss%q_eq
     IF(.not.partial_copy) THEN
        ss2%id_q_eq = ss%id_q_eq
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%q_RFMIN)).AND.(ALLOCATED(ss%q_RFMIN))) THEN
     ss2%q_RFMIN = ss%q_RFMIN
  ENDIF
  IF((ALLOCATED(ss2%q_S)).AND.(ALLOCATED(ss%q_S))) THEN
     ss2%q_S = ss%q_S
  ENDIF
  IF((ALLOCATED(ss2%q_SA)).AND.(ALLOCATED(ss%q_SA))) THEN
     ss2%q_SA = ss%q_SA
  ENDIF
  IF((ALLOCATED(ss2%q_SFUS)).AND.(ALLOCATED(ss%q_SFUS))) THEN
     ss2%q_SFUS = ss%q_SFUS
  ENDIF
  IF((ALLOCATED(ss2%q_SGAS)).AND.(ALLOCATED(ss%q_SGAS))) THEN
     ss2%q_SGAS = ss%q_SGAS
  ENDIF
  IF((ALLOCATED(ss2%q_SIMP0)).AND.(ALLOCATED(ss%q_SIMP0))) THEN
     ss2%q_SIMP0 = ss%q_SIMP0
  ENDIF
  IF((ALLOCATED(ss2%q_SIMPI)).AND.(ALLOCATED(ss%q_SIMPI))) THEN
     ss2%q_SIMPI = ss%q_SIMPI
  ENDIF
  IF((ALLOCATED(ss2%q_SNBI)).AND.(ALLOCATED(ss%q_SNBI))) THEN
     ss2%q_SNBI = ss%q_SNBI
  ENDIF
  IF(partial_copy) THEN
     ss2%id_R0_momeq = 0
  ENDIF
  IF((ALLOCATED(ss%R0_momeq).AND.ALLOCATED(ss2%R0_momeq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%R0_momeq = ss%R0_momeq
     IF(.not.partial_copy) THEN
        ss2%id_R0_momeq = ss%id_R0_momeq
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_RAD).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%RAD_Code_Info = ss%RAD_Code_Info
  ENDIF
  IF((cclist(ps_cnum_RAD).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%RAD_Data_Info = ss%RAD_Data_Info
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinb0i)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinb0i = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinb0i).AND.ALLOCATED(ss2%rate_sinb0i)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%rate_sinb0i = ss%rate_sinb0i
     IF(ALLOCATED(ss2%id_rate_sinb0i)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinb0i = ss%id_rate_sinb0i
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinb0x)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinb0x = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinb0x).AND.ALLOCATED(ss2%rate_sinb0x)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%rate_sinb0x = ss%rate_sinb0x
     IF(ALLOCATED(ss2%id_rate_sinb0x)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinb0x = ss%id_rate_sinb0x
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinb0xs)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinb0xs = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinb0xs).AND.ALLOCATED(ss2%rate_sinb0xs)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%rate_sinb0xs = ss%rate_sinb0xs
     IF(ALLOCATED(ss2%id_rate_sinb0xs)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinb0xs = ss%id_rate_sinb0xs
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinf0i)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinf0i = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinf0i).AND.ALLOCATED(ss2%rate_sinf0i)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%rate_sinf0i = ss%rate_sinf0i
     IF(ALLOCATED(ss2%id_rate_sinf0i)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinf0i = ss%id_rate_sinf0i
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinf0x)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinf0x = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinf0x).AND.ALLOCATED(ss2%rate_sinf0x)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%rate_sinf0x = ss%rate_sinf0x
     IF(ALLOCATED(ss2%id_rate_sinf0x)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinf0x = ss%id_rate_sinf0x
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_rate_sinf0xs)) THEN
     IF(partial_copy) THEN
        ss2%id_rate_sinf0xs = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%rate_sinf0xs).AND.ALLOCATED(ss2%rate_sinf0xs)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%rate_sinf0xs = ss%rate_sinf0xs
     IF(ALLOCATED(ss2%id_rate_sinf0xs)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_rate_sinf0xs = ss%id_rate_sinf0xs
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%Real_ant_coef)).AND.(ALLOCATED(ss%Real_ant_coef))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%Real_ant_coef = ss%Real_ant_coef
  ENDIF
  IF(ALLOCATED(ss2%id_res_sn)) THEN
     IF(partial_copy) THEN
        ss2%id_res_sn = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%res_sn).AND.ALLOCATED(ss2%res_sn)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%res_sn = ss%res_sn
     IF(ALLOCATED(ss2%id_res_sn)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_res_sn = ss%id_res_sn
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_res_te = 0
  ENDIF
  IF((ALLOCATED(ss%res_te).AND.ALLOCATED(ss2%res_te)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%res_te = ss%res_te
     IF(.not.partial_copy) THEN
        ss2%id_res_te = ss%id_res_te
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_res_ti = 0
  ENDIF
  IF((ALLOCATED(ss%res_ti).AND.ALLOCATED(ss2%res_ti)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%res_ti = ss%res_ti
     IF(.not.partial_copy) THEN
        ss2%id_res_ti = ss%id_res_ti
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_res_tq = 0
  ENDIF
  IF((ALLOCATED(ss%res_tq).AND.ALLOCATED(ss2%res_tq)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%res_tq = ss%res_tq
     IF(.not.partial_copy) THEN
        ss2%id_res_tq = ss%id_res_tq
     ENDIF
  ENDIF
  IF((ALLOCATED(ss2%RFMIN_name)).AND.(ALLOCATED(ss%RFMIN_name))) THEN
     ss2%RFMIN_name = ss%RFMIN_name
  ENDIF
  IF((ALLOCATED(ss2%rfmin_to_all)).AND.(ALLOCATED(ss%rfmin_to_all))) THEN
     ss2%rfmin_to_all = ss%rfmin_to_all
  ENDIF
  IF((ALLOCATED(ss2%rfmin_to_alla)).AND.(ALLOCATED(ss%rfmin_to_alla))) THEN
     ss2%rfmin_to_alla = ss%rfmin_to_alla
  ENDIF
  IF((ALLOCATED(ss2%RFMIN_type)).AND.(ALLOCATED(ss%RFMIN_type))) THEN
     ss2%RFMIN_type = ss%RFMIN_type
  ENDIF
  IF((ALLOCATED(ss%rho).AND.ALLOCATED(ss2%rho)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%rho = ss%rho
  ENDIF
  IF( ((ALLOCATED(ss2%rhopsi0lh)).AND.(ALLOCATED(ss%rhopsi0lh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%rhopsi0lh = ss%rhopsi0lh
  ENDIF
  IF((ALLOCATED(ss%rho_anom).AND.ALLOCATED(ss2%rho_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%rho_anom = ss%rho_anom
  ENDIF
  IF((ALLOCATED(ss%rho_anom2).AND.ALLOCATED(ss2%rho_anom2)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%rho_anom2 = ss%rho_anom2
  ENDIF
  IF((ALLOCATED(ss%rho_anomth).AND.ALLOCATED(ss2%rho_anomth)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%rho_anomth = ss%rho_anomth
  ENDIF
  IF( ((ALLOCATED(ss2%rho_bdy_ns)).AND.(ALLOCATED(ss%rho_bdy_ns))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%rho_bdy_ns = ss%rho_bdy_ns
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%rho_bdy_omegat = ss%rho_bdy_omegat
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%rho_bdy_Te = ss%rho_bdy_Te
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%rho_bdy_Ti = ss%rho_bdy_Ti
  ENDIF
  IF((ALLOCATED(ss%rho_ecrf).AND.ALLOCATED(ss2%rho_ecrf)).AND. &
        ((cclist(ps_cnum_EC).EQ.1))) THEN
     ss2%rho_ecrf = ss%rho_ecrf
  ENDIF
  IF((ALLOCATED(ss%rho_eq).AND.ALLOCATED(ss2%rho_eq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%rho_eq = ss%rho_eq
  ENDIF
  IF((ALLOCATED(ss%rho_eq_geo).AND.ALLOCATED(ss2%rho_eq_geo)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%rho_eq_geo = ss%rho_eq_geo
  ENDIF
  IF((ALLOCATED(ss%rho_fus).AND.ALLOCATED(ss2%rho_fus)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%rho_fus = ss%rho_fus
  ENDIF
  IF((ALLOCATED(ss%rho_gas).AND.ALLOCATED(ss2%rho_gas)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%rho_gas = ss%rho_gas
  ENDIF
  IF((ALLOCATED(ss%rho_icrf).AND.ALLOCATED(ss2%rho_icrf)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%rho_icrf = ss%rho_icrf
  ENDIF
  IF((ALLOCATED(ss%rho_lhrf).AND.ALLOCATED(ss2%rho_lhrf)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%rho_lhrf = ss%rho_lhrf
  ENDIF
  IF((ALLOCATED(ss%rho_lmhd).AND.ALLOCATED(ss2%rho_lmhd)).AND. &
        ((cclist(ps_cnum_LMHD).EQ.1))) THEN
     ss2%rho_lmhd = ss%rho_lmhd
  ENDIF
  IF((ALLOCATED(ss%rho_mist).AND.ALLOCATED(ss2%rho_mist)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%rho_mist = ss%rho_mist
  ENDIF
  IF((ALLOCATED(ss%rho_nbi).AND.ALLOCATED(ss2%rho_nbi)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%rho_nbi = ss%rho_nbi
  ENDIF
  IF((ALLOCATED(ss%rho_pel).AND.ALLOCATED(ss2%rho_pel)).AND. &
        ((cclist(ps_cnum_PEL).EQ.1))) THEN
     ss2%rho_pel = ss%rho_pel
  ENDIF
  IF((ALLOCATED(ss%rho_rad).AND.ALLOCATED(ss2%rho_rad)).AND. &
        ((cclist(ps_cnum_RAD).EQ.1))) THEN
     ss2%rho_rad = ss%rho_rad
  ENDIF
  IF((ALLOCATED(ss%rho_rw).AND.ALLOCATED(ss2%rho_rw)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%rho_rw = ss%rho_rw
  ENDIF
  IF( ((ALLOCATED(ss2%rlim)).AND.(ALLOCATED(ss%rlim))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%rlim = ss%rlim
  ENDIF

END SUBROUTINE plasma_state_copy_6

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_4(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  status = nf90_inq_varid(icdf,"NBI_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"NBI_Data_Info")
  ELSE
     ilen = len(ss%NBI_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%NBI_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%NBI_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%NBI_Data_Info = " "
        CALL ncerr_name(2,status,"NBI_Data_Info")
     ELSE
        CALL denull(ss%NBI_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbi_src_name)) THEN
     status = nf90_inq_varid(icdf,"nbi_src_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbi_src_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbi_src_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbi_src_name = " "
           CALL ncerr_name(2,status,"nbi_src_name")
        ELSE
           CALL denull_vec(ss%nbi_src_name,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbshape)) THEN
     status = nf90_inq_varid(icdf,"nbshape",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nbshape")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nbshape)
        IF(status.NE.NF90_NOERR) THEN
           ss%nbshape = " "
           CALL ncerr_name(2,status,"nbshape")
        ELSE
           CALL denull_vec(ss%nbshape,ss%nbeam)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nebar",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"nebar")
  ELSE
     status = nf90_get_var(icdf,varid,ss%nebar)
     IF(status.NE.NF90_NOERR) THEN
        ss%nebar = 0.0_rspec
        CALL ncerr_name(2,status,"nebar")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%neflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"neflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"neflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%neflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%neflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"neflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_code)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_code",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Newcomb_code")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Newcomb_code)
        IF(status.NE.NF90_NOERR) THEN
           ss%Newcomb_code = " "
           CALL ncerr_name(2,status,"Newcomb_code")
        ELSE
           CALL denull_vec(ss%Newcomb_code,ss%nnewcomb)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_mapper)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_mapper",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Newcomb_mapper")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Newcomb_mapper)
        IF(status.NE.NF90_NOERR) THEN
           ss%Newcomb_mapper = " "
           CALL ncerr_name(2,status,"Newcomb_mapper")
        ELSE
           CALL denull_vec(ss%Newcomb_mapper,ss%nnewcomb)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_stable)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_stable",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Newcomb_stable")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Newcomb_stable)
        IF(status.NE.NF90_NOERR) THEN
           ss%Newcomb_stable = 0
           CALL ncerr_name(2,status,"Newcomb_stable")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Newcomb_status)) THEN
     status = nf90_inq_varid(icdf,"Newcomb_status",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Newcomb_status")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Newcomb_status)
        IF(status.NE.NF90_NOERR) THEN
           ss%Newcomb_status = 0
           CALL ncerr_name(2,status,"Newcomb_status")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ne_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ne_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ne_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ne_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%ne_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"ne_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nfusi)) THEN
     status = nf90_inq_varid(icdf,"nfusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nfusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nfusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%nfusi = 0.0_rspec
           CALL ncerr_name(2,status,"nfusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nfusi_bdy)) THEN
     status = nf90_inq_varid(icdf,"nfusi_bdy",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nfusi_bdy")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nfusi_bdy)
        IF(status.NE.NF90_NOERR) THEN
           ss%nfusi_bdy = 0.0_rspec
           CALL ncerr_name(2,status,"nfusi_bdy")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ngradb2_av)) THEN
     status = nf90_inq_varid(icdf,"ngradb2_av",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ngradb2_av")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ngradb2_av)
        IF(status.NE.NF90_NOERR) THEN
           ss%ngradb2_av = 0.0_rspec
           CALL ncerr_name(2,status,"ngradb2_av")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ni)) THEN
     status = nf90_inq_varid(icdf,"ni",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ni")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ni)
        IF(status.NE.NF90_NOERR) THEN
           ss%ni = 0.0_rspec
           CALL ncerr_name(2,status,"ni")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%niflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"niflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"niflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%niflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%niflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"niflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ni_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ni_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ni_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ni_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%ni_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"ni_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmdifb",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"nmdifb")
  ELSE
     status = nf90_get_var(icdf,varid,ss%nmdifb)
     IF(status.NE.NF90_NOERR) THEN
        ss%nmdifb = 0
        CALL ncerr_name(2,status,"nmdifb")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nmini)) THEN
     status = nf90_inq_varid(icdf,"nmini",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nmini")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nmini)
        IF(status.NE.NF90_NOERR) THEN
           ss%nmini = 0.0_rspec
           CALL ncerr_name(2,status,"nmini")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nmini_bdy)) THEN
     status = nf90_inq_varid(icdf,"nmini_bdy",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nmini_bdy")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nmini_bdy)
        IF(status.NE.NF90_NOERR) THEN
           ss%nmini_bdy = 0.0_rspec
           CALL ncerr_name(2,status,"nmini_bdy")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nmodel)) THEN
     status = nf90_inq_varid(icdf,"nmodel",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nmodel")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nmodel)
        IF(status.NE.NF90_NOERR) THEN
           ss%nmodel = 0.0_rspec
           CALL ncerr_name(2,status,"nmodel")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmodel_bdy",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"nmodel_bdy")
  ELSE
     status = nf90_get_var(icdf,varid,ss%nmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        ss%nmodel_bdy = 0.0_rspec
        CALL ncerr_name(2,status,"nmodel_bdy")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nmom",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"nmom")
  ELSE
     status = nf90_get_var(icdf,varid,ss%nmom)
     IF(status.NE.NF90_NOERR) THEN
        ss%nmom = 16
        CALL ncerr_name(2,status,"nmom")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nnkparlh)) THEN
     status = nf90_inq_varid(icdf,"nnkparlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nnkparlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nnkparlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%nnkparlh = 0
           CALL ncerr_name(2,status,"nnkparlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nnkpollh)) THEN
     status = nf90_inq_varid(icdf,"nnkpollh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nnkpollh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nnkpollh)
        IF(status.NE.NF90_NOERR) THEN
           ss%nnkpollh = 0
           CALL ncerr_name(2,status,"nnkpollh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nnktorlh)) THEN
     status = nf90_inq_varid(icdf,"nnktorlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nnktorlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nnktorlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%nnktorlh = 0
           CALL ncerr_name(2,status,"nnktorlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nphi)) THEN
     status = nf90_inq_varid(icdf,"nphi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nphi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nphi)
        IF(status.NE.NF90_NOERR) THEN
           ss%nphi = 0
           CALL ncerr_name(2,status,"nphi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nrw)) THEN
     status = nf90_inq_varid(icdf,"nrw",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nrw")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nrw)
        IF(status.NE.NF90_NOERR) THEN
           ss%nrw = 0.0_rspec
           CALL ncerr_name(2,status,"nrw")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     status = nf90_inq_varid(icdf,"nrz_antgeo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nrz_antgeo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nrz_antgeo)
        IF(status.NE.NF90_NOERR) THEN
           ss%nrz_antgeo = 0
           CALL ncerr_name(2,status,"nrz_antgeo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ns)) THEN
     status = nf90_inq_varid(icdf,"ns",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ns")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ns)
        IF(status.NE.NF90_NOERR) THEN
           ss%ns = 0.0_rspec
           CALL ncerr_name(2,status,"ns")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     status = nf90_inq_varid(icdf,"nspectrumlh_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nspectrumlh_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nspectrumlh_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%nspectrumlh_src = 0
           CALL ncerr_name(2,status,"nspectrumlh_src")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ns_bdy)) THEN
     status = nf90_inq_varid(icdf,"ns_bdy",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ns_bdy")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ns_bdy)
        IF(status.NE.NF90_NOERR) THEN
           ss%ns_bdy = 0.0_rspec
           CALL ncerr_name(2,status,"ns_bdy")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ns_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"ns_Data_Info")
  ELSE
     ilen = len(ss%ns_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%ns_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%ns_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%ns_Data_Info = " "
        CALL ncerr_name(2,status,"ns_Data_Info")
     ELSE
        CALL denull(ss%ns_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ns_is_input)) THEN
     status = nf90_inq_varid(icdf,"ns_is_input",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ns_is_input")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ns_is_input)
        IF(status.NE.NF90_NOERR) THEN
           ss%ns_is_input = 0
           CALL ncerr_name(2,status,"ns_is_input")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ntf_coil2",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"ntf_coil2")
  ELSE
     status = nf90_get_var(icdf,varid,ss%ntf_coil2)
     IF(status.NE.NF90_NOERR) THEN
        ss%ntf_coil2 = ps_unInit
        CALL ncerr_name(2,status,"ntf_coil2")
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_4

!  DMC -- get event table data via trdatbuf object

!  See trdatusub/set_sevent.f90 for code where this data is defined
!  See use in datcor/trgdat_exec.for from which these routines are called

subroutine tdb_sevtbl_adr0(d,iadr0)
  use trdatbuf_obj
  implicit NONE

  !  return start location of SEV table
  type (trdatbuf) :: d
  integer, intent(out) :: iadr0

  iadr0 = d%lsevent
end subroutine tdb_sevtbl_adr0

subroutine tdb_sevtbl_ntot(d,ntot)
  use trdatbuf_obj
  implicit NONE

  !  return start location of SEV table
  type (trdatbuf) :: d
  integer, intent(out) :: ntot

  if(d%lsevent.eq.0) then
     ntot=0
  else
     ntot = 1 + d%nsevtbl + d%nsevtbl*d%nsevper*d%nsevwds
  endif

end subroutine tdb_sevtbl_ntot

subroutine tdb_sevtbl_stats(d,nwds,ntabls,ntims)
  use trdatbuf_obj
  implicit NONE

  !  return start location of SEV table
  type (trdatbuf) :: d
  integer, intent(out) :: nwds,ntabls,ntims

  if(d%lsevent.eq.0) then
     nwds=0
     ntabls=0
     ntims=0
  else
     nwds = d%nsevwds
     ntims= d%nsevper
     ntabls = d%nsevtbl
  endif

end subroutine tdb_sevtbl_stats

subroutine tdb_sevtbl_get1(data,ibase, nwds,ntabls,ntims, itabl,itim, dentry)

  ! return a single table entry (nwds words)

  implicit NONE

  real*8, intent(in) :: data(*)
  integer, intent(in) :: ibase   ! location of first word of SEV data
  !  (in d%datbuf this is iadr0 returned by tdb_sevtbl_adr0)

  integer, intent(in) :: nwds,ntabls,ntims  ! SEV data stats
  !  (as returned by tdb_sevtbl_stats)

  integer, intent(in) :: itabl  ! table number (btw 1 and ntabls inclusive)
  integer, intent(in) :: itim   ! time index (btw 1 and ntims inclusive)

  real*8, intent(out) :: dentry(nwds)  ! the table entry 

  ! if any of the stats are zero return all zeroes

  !---------------------------
  integer :: iadr0,iadr1,iadr2
  !---------------------------

  if(nwds.le.0) return
  if(min(ntabls,ntims).le.0) then
     dentry=0.0d0
     return
  endif

  iadr0 = ibase + ntabls + 1  ! address of first table entry

  iadr1 = iadr0 + ((itabl-1)*ntims + (itim-1))*nwds
  iadr2 = iadr1 + nwds - 1

  dentry = data(iadr1:iadr2)

end subroutine tdb_sevtbl_get1

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_1(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"chii_ntm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chii_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chii_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chii_w19"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chimo_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chimo_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chimo_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chimo_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chimo_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chimo_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chiphi_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chiphi_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chiphi_w19"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"chitheta_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%chitheta_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: chitheta_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"circuit_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%circuit_name)
     status = nf90_get_var(icdf,varid,ss%circuit_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: circuit_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("circuit_name",ss%circuit_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_apt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%coil_apt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: coil_apt"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_in_circuit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%coil_in_circuit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: coil_in_circuit"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%coil_name)
     status = nf90_get_var(icdf,varid,ss%coil_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: coil_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("coil_name",ss%coil_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"coil_resispt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%coil_resispt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: coil_resispt"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curbeam",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curbeam)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curbeam"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curech",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curech"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curech_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curech_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curfusn",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curfusn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curfusn"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curich",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curich)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curich"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curlh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curlh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curmino",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curmino)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curmino"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curr_bootstrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curr_bootstrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curr_bootstrap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curr_ohmic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curr_ohmic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curr_ohmic"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"curt",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%curt)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: curt"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"CUR_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%CUR_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: CUR_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"cur_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%cur_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: cur_rw"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"d2R_geo_dRHOdTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%d2R_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: d2R_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"d2Z_geo_dRHOdTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%d2Z_geo_dRHOdTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: d2Z_geo_dRHOdTH"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"db_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%db_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: db_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dcur_rw_dVloop",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dcur_rw_dVloop)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dcur_rw_dVloop"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%DeltaW_code)
     status = nf90_get_var(icdf,varid,ss%DeltaW_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: DeltaW_code"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("DeltaW_code",ss%DeltaW_code)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_mapper",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%DeltaW_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: DeltaW_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%DeltaW_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: DeltaW_stable"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"DeltaW_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%DeltaW_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: DeltaW_status"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difb_rfmi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"diff_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%diff_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: diff_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"diff_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%diff_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: diff_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difne_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnh_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difns_w19",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difns_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difns_w19"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnx_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"difnz_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%difnz_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: difnz_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dist_fun",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dist_fun)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dist_fun"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dn0out",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dn0out)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dn0out"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQedGrdte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dQedGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dQedGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQedGrdti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dQedGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dQedGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQidGrdte_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dQidGrdte_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dQidGrdte_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dQidGrdti_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dQidGrdti_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dQidGrdti_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR0_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dR0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dR0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR_geo_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dR_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dR_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dR_geo_dTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dR_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dR_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxRjcos_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dxRjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dxRjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxRjsin_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dxRjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dxRjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxZjcos_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dxZjcos_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dxZjcos_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dxZjsin_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dxZjsin_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dxZjsin_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dx_fshield",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dx_fshield)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dx_fshield"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ0_momeq_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dZ0_momeq_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dZ0_momeq_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ_geo_dRHO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dZ_geo_dRHO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dZ_geo_dRHO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dZ_geo_dTH",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%dZ_geo_dTH)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: dZ_geo_dTH"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_1

      subroutine tdb_symini(d,nzones)
      !
      !  set up workspace for presymmetrization & mapping of profiles
      !  size of workspace depends on target application's number of zones
      !  and the number of zones in the input data
      !
 
      use trdatbuf_obj
      implicit NONE
      type (trdatbuf) :: d
      integer, intent(in) :: nzones   ! no. of radial zones in caller's grid
 
      !----------------------------
      integer :: iwrk,i,j
      !----------------------------
 
      IWRK=2*(NZONES+2)
C
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C
      IF((D%LFAXR.GT.0).AND.(D%NSYAXR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXAXR + 1))
C
      IF((D%LFBOL.GT.0).AND.(D%NSYBOL.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXBOL + 1))
C
      IF((D%LFBPA.GT.0).AND.(D%NSYBPA.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXBPA + 1))
C
      IF((D%LFBPB.GT.0).AND.(D%NSYBPB.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXBPB + 1))
C
      IF((D%LFD2F.GT.0).AND.(D%NSYD2F.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXD2F + 1))
C
      IF((D%LFDE2.GT.0).AND.(D%NSYDE2.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDE2 + 1))
C
      IF((D%LFDF3.GT.0).AND.(D%NSYDF3.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDF3 + 1))
C
      IF((D%LFDF4.GT.0).AND.(D%NSYDF4.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDF4 + 1))
C
      IF((D%LFDF6.GT.0).AND.(D%NSYDF6.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDF6 + 1))
C
      IF((D%LFDFD.GT.0).AND.(D%NSYDFD.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDFD + 1))
C
      IF((D%LFDFH.GT.0).AND.(D%NSYDFH.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDFH + 1))
C
      IF((D%LFDFT.GT.0).AND.(D%NSYDFT.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXDFT + 1))
C
      IF((D%LFECF.GT.0).AND.(D%NSYECF.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXECF + 1))
C
      IF((D%LFFEH.GT.0).AND.(D%NSYFEH.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXFEH + 1))
C
      IF((D%LFFEL.GT.0).AND.(D%NSYFEL.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXFEL + 1))
C
      IF((D%LFGRB.GT.0).AND.(D%NSYGRB.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXGRB + 1))
C
      IF((D%LFIBE.GT.0).AND.(D%NSYIBE.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXIBE + 1))
C
      IF((D%LFIBI.GT.0).AND.(D%NSYIBI.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXIBI + 1))
C
      IF((D%LFJBM.GT.0).AND.(D%NSYJBM.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXJBM + 1))
C
      IF((D%LFJEC.GT.0).AND.(D%NSYJEC.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXJEC + 1))
C
      IF((D%LFJIC.GT.0).AND.(D%NSYJIC.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXJIC + 1))
C
      IF((D%LFLF3.GT.0).AND.(D%NSYLF3.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLF3 + 1))
C
      IF((D%LFLF4.GT.0).AND.(D%NSYLF4.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLF4 + 1))
C
      IF((D%LFLF6.GT.0).AND.(D%NSYLF6.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLF6 + 1))
C
      IF((D%LFLFD.GT.0).AND.(D%NSYLFD.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLFD + 1))
C
      IF((D%LFLFH.GT.0).AND.(D%NSYLFH.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLFH + 1))
C
      IF((D%LFLFT.GT.0).AND.(D%NSYLFT.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLFT + 1))
C
      IF((D%LFLHE.GT.0).AND.(D%NSYLHE.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLHE + 1))
C
      IF((D%LFLHJ.GT.0).AND.(D%NSYLHJ.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXLHJ + 1))
C
      IF((D%LFNER.GT.0).AND.(D%NSYNER.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNER + 1))
C
      IF((D%LFNI3.GT.0).AND.(D%NSYNI3.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNI3 + 1))
C
      IF((D%LFNI4.GT.0).AND.(D%NSYNI4.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNI4 + 1))
C
      IF((D%LFNI6.GT.0).AND.(D%NSYNI6.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNI6 + 1))
C
      IF((D%LFNID.GT.0).AND.(D%NSYNID.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNID + 1))
C
      IF((D%LFNIH.GT.0).AND.(D%NSYNIH.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNIH + 1))
C
      IF((D%LFNIM.GT.0).AND.(D%NSYNIM.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNIM + 1))
C
      IF((D%LFNIT.GT.0).AND.(D%NSYNIT.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNIT + 1))
C
      IF((D%LFNMR.GT.0).AND.(D%NSYNMR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXNMR + 1))
C
      IF((D%LFOMG.GT.0).AND.(D%NSYOMG.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXOMG + 1))
C
      IF((D%LFPRS.GT.0).AND.(D%NSYPRS.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXPRS + 1))
C
      IF((D%LFQBE.GT.0).AND.(D%NSYQBE.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXQBE + 1))
C
      IF((D%LFQBI.GT.0).AND.(D%NSYQBI.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXQBI + 1))
C
      IF((D%LFQEC.GT.0).AND.(D%NSYQEC.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXQEC + 1))
C
      IF((D%LFQIC.GT.0).AND.(D%NSYQIC.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXQIC + 1))
C
      IF((D%LFQPR.GT.0).AND.(D%NSYQPR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXQPR + 1))
C
      IF((D%LFRES.GT.0).AND.(D%NSYRES.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXRES + 1))
C
      IF((D%LFSBI.GT.0).AND.(D%NSYSBI.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXSBI + 1))
C
      IF((D%LFTER.GT.0).AND.(D%NSYTER.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXTER + 1))
C
      IF((D%LFTI2.GT.0).AND.(D%NSYTI2.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXTI2 + 1))
C
      IF((D%LFTQI.GT.0).AND.(D%NSYTQI.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXTQI + 1))
C
      IF((D%LFV2F.GT.0).AND.(D%NSYV2F.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXV2F + 1))
C
      IF((D%LFVB2.GT.0).AND.(D%NSYVB2.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVB2 + 1))
C
      IF((D%LFVC3.GT.0).AND.(D%NSYVC3.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVC3 + 1))
C
      IF((D%LFVC4.GT.0).AND.(D%NSYVC4.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVC4 + 1))
C
      IF((D%LFVC6.GT.0).AND.(D%NSYVC6.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVC6 + 1))
C
      IF((D%LFVCD.GT.0).AND.(D%NSYVCD.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVCD + 1))
C
      IF((D%LFVCH.GT.0).AND.(D%NSYVCH.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVCH + 1))
C
      IF((D%LFVCT.GT.0).AND.(D%NSYVCT.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVCT + 1))
C
      IF((D%LFVEE.GT.0).AND.(D%NSYVEE.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVEE + 1))
C
      IF((D%LFVIE.GT.0).AND.(D%NSYVIE.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVIE + 1))
C
      IF((D%LFVMO.GT.0).AND.(D%NSYVMO.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVMO + 1))
C
      IF((D%LFVP2.GT.0).AND.(D%NSYVP2.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVP2 + 1))
C
      IF((D%LFVPO.GT.0).AND.(D%NSYVPO.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVPO + 1))
C
      IF((D%LFVPR.GT.0).AND.(D%NSYVPR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVPR + 1))
C
      IF((D%LFVTR.GT.0).AND.(D%NSYVTR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXVTR + 1))
C
      IF((D%LFZF2.GT.0).AND.(D%NSYZF2.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXZF2 + 1))
C
      IF((D%LFZXR.GT.0).AND.(D%NSYZXR.EQ.1))
     >    IWRK = MAX(IWRK,(D%NXZXR + 1))
C
      DO I = 1, D%NNSIM
        J = D%NISSIM(I)
        IF((D%LFSIM(I).GT.0).AND.(D%NSYSIM(J).EQ.1))
     >      IWRK = MAX(IWRK,(D%NXSIM(J) + 1))
      END DO
C
C
C=>TRDATGEN-
C
      DO 5 I=1,8
        d%NBX(I)=IWRK
        CALL TDB_WORKALO(d,IWRK,d%LBX(I))
 5    CONTINUE
C
      return
      end

subroutine tdb_get_rzsizes(d,inumR,inumZ)

  !  get sizes of R and Z grids to go with Psi(R,Z) data vs. time

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d

  integer,intent(out) :: inumR,inumZ  ! the grid sizes, or 0 if none found.

  !------------------------------------

  inumR = d%nRpsi
  inumZ = d%nZpsi

end subroutine tdb_get_rzsizes

  subroutine trxpl_orbit_prof(ilnum)


  include 'trxpl.blk'

!    uread stuff
!
      integer, parameter :: r8=selected_real_kind(12,100)
      integer lnout,ilnum
      logical lxout,lchar,lyes

      integer :: nspec,n_species,iorder,lrho,ierror,ik,il,          &
                 id_zeff,id_pot,idcod,ipoints,ii
      integer, dimension(:), allocatable :: id_ns,id_ts,id_ion,     &
                                            id_imp,itype,Izc
      character*20, dimension(:), allocatable :: slbl
      character*50 :: zunit_zeff,zunit_pot
      real*8 :: drho
      real*8, dimension(:), allocatable :: rho,Zr8,Ar8,zaimpd,      &
                                           zzimpd,zziond,zaiond
      real*8, dimension(:,:), allocatable :: zrhoni,zrhonz
      real*8 :: zadumn,zzdumn,zadumd,zzdumd,zzdif
      real*8 :: zaplasmave,zzplasmave,zaimpave,zzimpave,zrhoelcal
      real*8, allocatable :: zaplasm(:),zzplasm(:),zaimp(:),zzimp(:)
                            
      real*8, allocatable :: zrhoel(:),zrhoplasm(:),zrhoimp(:),       &
                                       zeffc(:),zte(:),zti(:),zpot(:)

!
! Code for writing the profiles for the
! non-Boozer version of Roscoe's orbit code. 
! K. Indireshkumar (05/2004)
!
         lrho_loop: do

            call uread(                                             &
               'ENTER NUMBER OF GRID POINTS OR "Q" TO QUIT:$$')

            ierror=0
            if (lchar('Q')) then
               lrho=21
               print *,'Number of zones set to ',lrho
            else
               lrho=idcod(ierror)
            endif

            if (ierror.ne.0) cycle lrho_loop

            exit lrho_loop

         end do lrho_loop

         if (allocated(rho)) deallocate(rho)
         allocate(rho(lrho))

         rho(1)=0.0
         drho=1.0_r8/(lrho-1)
         do ik=2,lrho
            rho(ik)=rho(ik-1)+drho
         enddo
         rho(lrho)=1.0_r8

         call trx_nspec(nspec)

         if(allocated(id_ns)) deallocate(id_ns)
         if(allocated(id_ts)) deallocate(id_ts)
         if(allocated(id_ion)) deallocate(id_ion)
         if(allocated(id_imp)) deallocate(id_imp)
         if(allocated(slbl)) deallocate(slbl)
         if(allocated(itype)) deallocate(itype)
         if(allocated(Zr8)) deallocate(Zr8)
         if(allocated(Ar8)) deallocate(Ar8)
         if(allocated(Zr8)) deallocate(Zr8)
         if(allocated(zziond)) deallocate(zziond)
         if(allocated(zaiond)) deallocate(zaiond)
         if(allocated(zzimpd)) deallocate(zzimpd)
         if(allocated(zaimpd)) deallocate(zaimpd)
         if(allocated(zeffc)) deallocate(zeffc)
         if (allocated(zte)) deallocate(zte)
         if (allocated(zti)) deallocate(zti)
         if (allocated(zpot)) deallocate(zpot)

         allocate(id_ns(nspec),id_ts(nspec),id_ion(nspec),id_imp(nspec))
         allocate(slbl(nspec),itype(nspec),Zr8(nspec),Ar8(nspec),Izc(nspec))
         allocate(zziond(nspec),zaiond(nspec),zzimpd(nspec),zaimpd(nspec))

         allocate(zaplasm(lrho),zzplasm(lrho),zaimp(lrho),zzimp(lrho))
         allocate(zrhoel(lrho),zrhoplasm(lrho),zrhoimp(lrho),zeffc(lrho))
         allocate(zte(lrho),zti(lrho),zpot(lrho))

         iorder=1

         call trx_spec_lbl(nspec,n_species,slbl,itype,Zr8,Ar8,IZc)

         call trxpl_species(nspec,iorder,'T',id_ts)

         call trxpl_species(nspec,iorder,'N',id_ns)

         inumion=0
         inumimp=0
         do ii=1,nspec
           if (itype(ii).eq.-1) then

            ! Get electron temp and density

            call eq_rgetf(lrho,rho,id_ts(ii),0,zte,ierr)
            if(ierr.ne.0) then
             write(6,*) ' ?trxpl: error interpolating electron temp profile'
            endif
            
            call eq_rgetf(lrho,rho,id_ns(ii),0,zrhoel,ierr)
            if (ierr.ne.0) then
             write(6,*) ' ?trxpl: error interpolating electron density profile'
            endif

           elseif (itype(ii).eq.1) then

           ! Decide if the specie is main ion and
           ! get the temperature

            inumion=inumion+1
            zziond(inumion)=Zr8(ii)
            zaiond(inumion)=Ar8(ii)
            id_ion(inumion)=id_ns(ii)
            call eq_rgetf(lrho,rho,id_ts(ii),0,zti,ierr)
            if (ierr.ne.0) then
             write(6,*) ' ?trxpl: error interpolating ion temperature profile'
            endif

           elseif(itype(ii).eq.2) then

           ! Decide if the specie is impurity 
           !  (multiple impurity scenario) 

            inumimp=inumimp+1
            zzimpd(inumimp)=Zr8(ii)
            zaimpd(inumimp)=Ar8(ii)
            id_imp(inumimp)=id_ns(ii)

           elseif(itype(ii).eq.3) then

           ! Decide if the specie is impurity 
           !  (single ``model'' impurity scenario) 

            inumimp=inumimp+1
            zzimpd(inumimp)=Zr8(ii)
            zaimpd(inumimp)=Ar8(ii)
            id_imp(inumimp)=id_ns(ii)

           endif
          enddo

          if(allocated(zrhoni)) deallocate(zrhoni)
          if(allocated(zrhonz)) deallocate(zrhonz)
          allocate(zrhoni(1:lrho,1:inumion))
          allocate(zrhonz(1:lrho,1:inumimp))
            
! Interpolate ion and imputrity densities to lrho grid

         call eq_rgetff(lrho,rho,inumion,id_ion,0,lrho,zrhoni,ierr)

         if(ierr.ne.0) then
            write(6,*) ' ?trxpl: error interpolating ion density profiles'
         endif

         call eq_rgetff(lrho,rho,inumimp,id_imp,0,lrho,zrhonz,ierr)

         if(ierr.ne.0) then
            write(6,*) ' ?trxpl: error interpolating impurity density profiles'
         endif

         zadumn=0.0
         zadumd=0.0
         zzdumn=0.0
         zzdumd=0.0
         zaplasmave=0.0
         zzplasmave=0.0
         ipoints=0
         do ii=1,lrho
          do ig=1,inumion
            zadumn=zadumn+zaiond(ig)*zrhoni(ii, ig)
            zadumd=zadumd+zrhoni(ii, ig)
            zzdumn=zzdumn+zziond(ig)*zziond(ig)*zrhoni(ii, ig)
            zzdumd=zzdumd+zziond(ig)*zrhoni(ii, ig)
          enddo
          zaplasm(ii)=zadumn/zadumd
          zzplasm(ii)=zzdumn/zzdumd
          zaplasmave=zaplasmave+zaplasm(ii)
          zzplasmave=zzplasmave+zzplasm(ii)
          ipoints=ipoints+1
         enddo
         zaplasmave=zaplasmave/ipoints
         zzplasmave=zzplasmave/ipoints

         zadumn=0.0
         zadumd=0.0
         zzdumn=0.0
         zzdumd=0.0
         zaimpave=0.0
         zzimpave=0.0
         ipoints=0
         do ii=1,lrho
          do ig=1,inumimp
           zadumn=zadumn+zaimpd(ig)*zrhonz(ii,ig)
           zadumd=zadumd+zrhonz(ii,ig)
           zzdumn=zzdumn+zzimpd(ig)*zzimpd(ig)*zrhonz(ii,ig)
           zzdumd=zzdumd+zzimpd(ig)*zrhonz(ii,ig)
          enddo
          zzimp(ii)=zzdumn/zzdumd
          zaimp(ii)=zadumn/zadumd
          zaimpave=zaimpave+zaimp(ii)
          zzimpave=zzimpave+zzimp(ii)
          ipoints=ipoints+1
         enddo

         zaimpave=zaimpave/ipoints
         zzimpave=zzimpave/ipoints

         call trx_prof('ZEFFP',zunit_zeff,1,id_zeff,ierr)

         call eq_rgetf(lrho,rho,id_zeff,0,zeffc,ierr)

         call trx_prof('VRPOT',zunit_pot,1,id_pot,ierr)

         if (ierr.eq.0) then

          call eq_rgetf(lrho,rho,id_pot,0,zpot,ierr)

         else

          write(6,*) ' ?trxpl: VRPOT cannot be accessed; proceeding with pot=0'

          zpot(:)=0.0_r8

         endif

         zzdif=zzplasmave-zzimpave

         do ii=1,lrho
          zrhoplasm(ii)=(zrhoel(ii)/zzplasmave)*((zeffc(ii)-zzimpave)/zzdif)
          zrhoimp(ii)=(zrhoel(ii)/zzimpave)*((zzplasmave-zeffc(ii))/zzdif)
         enddo

! Convert densities to cm^{-3}

    zrhoel(:)=1.E-6*zrhoel(:)
    zrhoplasm(:)=1.E-6*zrhoplasm(:)
    zrhoimp(:)=1.E-6*zrhoimp(:)

    
    print *,'Printing diagnostic information'
    print *,'zaplasmave= ',zaplasmave
    print *,'zzplasmave= ',zzplasmave
    print *,' '
    print *,'zaimpave= ',zaimpave
    print *,'zzimpave= ',zzimpave
    print *,' '

    do ii=1,lrho
     zaplasm(ii)=zaplasmave
     zzplasm(ii)=zzplasmave
     zaimp(ii)=zaimpave
     zzimp(ii)=zzimpave
    enddo

    write (ilnum,'((a))') '        XI        '
    write (ilnum,'(5(e19.9))') (rho(ik),ik=1,lrho)
    write (ilnum,'((a))') '        Z_i        '
    write (ilnum,'(5(e19.9))') (zzplasm(ik),ik=1,lrho)
    write (ilnum,'((a))') '        A_i        '
    write (ilnum,'(5(e19.9))') (zaplasm(ik),ik=1,lrho)
    write (ilnum,'((a))') '        Z_I        '
    write (ilnum,'(5(e19.9))') (zzimp(ik),ik=1,lrho)
    write (ilnum,'((a))') '        A_I        '
    write (ilnum,'(5(e19.9))') (zaimp(ik),ik=1,lrho)
    write (ilnum,'((a))') '        n_e        '
    write (ilnum,'(5(e19.9))') (zrhoel(ik),ik=1,lrho)
    write (ilnum,'((a))') '        n_i        '
    write (ilnum,'(5(e19.9))') (zrhoplasm(ik),ik=1,lrho)
    write (ilnum,'((a))') '        n_I        '
    write (ilnum,'(5(e19.9))') (zrhoimp(ik),ik=1,lrho)
    write (ilnum,'((a))') '        t_e        '
    write (ilnum,'(5(e19.9))') (zte(ik),ik=1,lrho)
    write (ilnum,'((a))') '        t_i        '
    write (ilnum,'(5(e19.9))') (zti(ik),ik=1,lrho)
    write (ilnum,'((a))') '        pot        '
    write (ilnum,'(5(e19.9))') (zpot(ik),ik=1,lrho)

    deallocate(rho,zrhoni,zrhonz)
    deallocate(id_ns,id_ts,id_ion,id_imp)
    deallocate(slbl,itype,Zr8,Ar8,Izc)
    deallocate(zziond,zaiond,zzimpd,zaimpd)
    deallocate(zaplasm,zzplasm,zaimp,zzimp)
    deallocate(zrhoel,zrhoplasm,zrhoimp,zeffc)
    deallocate(zte,zti,zpot)

  end subroutine trxpl_orbit_prof

!******************** START FILE FILERS.FOR ; GROUP FILTR6 ******************
!
!  FILERS    SEEK OUT NEXT REGION WHERE SMOOTHED DATA VIOLATES
!            EPSLON ERROR BARS ON ORIGINAL DATA
!
!  JS=LOCATION AT WHICH TO START SEARCH
!
!  IND(6)  INDEX DESCRIPTION OF ERROR  IND(1)=0 ==> NO ERROR
!          FOUND  (OUTPUT)
!          IND(3),IND(4) DELIMIT ACTUAL VIOLATIONS WITHIN A
!          REGION WHERE THE DIVERGENCE (Y-YSM) IS OF THE SAME
!          SIGN   (X,Y (DIM(N)) ARE RAW DATA, YSM IS SMOOTHED DATA)
!          IND(2),IND(5) DELIMIT REGION WHERE (Y-YSM) IS OF THE
!          SAME SIGN
!          IND(1),IND(6) DELIMIT REGION WITHIN DELTA(IND(2))
!            OF X(IND(3)) (ON THE RIGHT); AND DELTA(IND(5))
!            OF X(IND(4)) (ON THE LEFT) ;  THIS IS THE REGION
!            WHERE A CORRECTION WILL BE APPLIED
!
!  EPS(NE) ARRAY CONTAINS ERROR BARS FOR POINTS 1 THRU NE; IF
!          J>NE, EPS(NE) IS USED AS THE ERROR BAR FOR
!          THE JTH DATA POINT.
!
!   EPS2(NE2):  IF A REGION OF SAME SIGN DIVERGENCE (Y-YSM)
!              CONTAINS ND LESS THAN NE2 DATA POINTS, THEN THE
!            ERROR BAR WILL BE MULTIPLIED BY THE FACTOR
!              EPS2(ND) ... THIS ALLOWS A LESS STIFF ERROR
!              BAR CRITERION FOR VIOLATIONS OF SHORT WIDTH
!
SUBROUTINE r8filers(X,Y,YSM,N,DELTA,EPS,NE,EPS2,NE2,IND,JS)
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, HALF, ONE
  implicit none
  ! Arguments
  integer, intent(in) :: N, NE, NE2, js
  real(fp), dimension(n), intent(in)  :: x, y
  real(fp), dimension(ne), intent(in) :: eps
  real(fp), dimension(1), intent(in)  :: eps2
  real(fp), dimension(n), intent(out) :: ysm, delta
  integer, dimension(6), intent(out) :: ind
  ! Local variables
  integer :: j,jlp,ierrf,isign0,je1,je2,js2,jd2,js1,jd1, &
       j2,jlp2,nse,jst,isign
  real(fp) :: dymax,dy,x0,zemax,zetes
  !
  integer, external :: r8ierfcn
  !
  !  CLEAR ERROR FLAG
  !
  IND(1)=0
  !
  IF(JS.GT.N) RETURN
  !  FIND FIRST EPSLON VIOLATION
  DO J=JS,N
    DYMAX=ZERO
    JLP=J
    IERRF=r8ierfcn(Y,YSM,N,JLP,EPS,NE,DY,ISIGN0)
    IF(IERRF.EQ.0) cycle
    !  POSSIBLE ERROR DETECTED
    DYMAX=max(DYMAX,DY)
    IF(J.LT.N) GO TO 10
    JE1=N
    JE2=N
    JS2=N
    JD2=N
    GO TO 40
    !
10  CONTINUE
    JE1=J
    IF(JE1.GT.1) GO TO 20
    JS1=1
    JD1=1
    !  FIND  JE2=IND(4),  JS2=IND(5)
20  CONTINUE
    JE2=JE1
    DO J2=JE1,N
      JLP2=J2
      IERRF=r8ierfcn(Y,YSM,N,JLP2,EPS,NE,DY,ISIGN)
      DYMAX=max(DYMAX,DY)
      IF(ISIGN.NE.ISIGN0) GO TO 35
      IF(IERRF.EQ.1) JE2=J2
    END DO
    J2=N+1
35  CONTINUE
    JS2=J2-1
    !  FIND JD2 (IND(6))
    X0=X(JE2)
    DO J2=JE2,N
      IF((X(J2)-X0).GT.DELTA(J2)) GO TO 38
    END DO
    J2=N
38  CONTINUE
    JD2=J2
!
    IF(JE1.EQ.1) GO TO 60
!  FIND JS1  (IND(2))
40  CONTINUE
    DO J2=JE1-1,1,-1
      JLP2=J2
      IERRF=r8ierfcn(Y,YSM,N,JLP2,EPS,NE,DY,ISIGN)
      IF(ISIGN.NE.ISIGN0) GO TO 55
    END DO
    J2=0
55  CONTINUE
    JS1=J2+1
!  FIND JD1 (IND(1))
    X0=X(JE1)
    DO J2=JE1,1,-1
      IF((X0-X(J2)).GT.DELTA(J2)) GO TO 58
    END DO
    J2=1
58  CONTINUE
    JD1=J2
    !  DOES EPS2 ARRAY COME TO BEAR ?
60  CONTINUE
    NSE=JS2-JS1+1
    IF(NSE.GT.NE2) GO TO 80
    !  MAYBE
    ZEMAX=EPS(NE)*EPS2(NSE)
    IF(JE1.GE.NE) GO TO 75
    JST=min(JE2,NE)
    ZEMAX=ZERO
    DO J2=JE1,JST
      ZETES=EPS(J2)*EPS2(NSE)
      ZEMAX=max(ZEMAX,ZETES)
    END DO
75  CONTINUE
    IF(ZEMAX.GE.DYMAX) cycle
    !  ERROR DEFINATELY DETECTED
80  CONTINUE
    IND(1)=JD1
    IND(2)=JS1
    IND(3)=JE1
    IND(4)=JE2
    IND(5)=JS2
    IND(6)=JD2
    GO TO 200
    !
    !  END OF LOOPT
    !
  END DO
200 CONTINUE
  RETURN
END SUBROUTINE r8filers

subroutine ps_xhashes_get(iobj,xhash,iout,ierr)

  ! fetch the xplasma hashes

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !================================
  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer :: xhash(ps_hash_total) ! xplasma data hash codes
  integer, intent(in) :: iout     ! LUN for messages
  integer, intent(out) :: ierr    ! completion status, 0=OK
  !================================

  ! local:
  logical :: inew  ! flag if hash entry is new in xplasma
  integer :: id
  integer, dimension(:), pointer :: ia_ptr
  real*8, dimension(:), pointer :: r8a_ptr
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------

  ierr = 0
  xhash = ps_unInit

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_xhashes_get: invalid or unitialized xplasma object.'
     return
  endif

  call xpobj_blkbx(xobj,xpobj_hash_name,ps_hash_total,r8hash_size, &
       inew,id,ia_ptr,r8a_ptr,iout,ierr)
  if(ierr.ne.0) return

  xhash = ia_ptr

  nullify(ia_ptr)
  nullify(r8a_ptr)

end subroutine ps_xhashes_get

subroutine ps_xhashes_put(iobj,xhash,iout,ierr)

  ! replace the xplasma hashes with updated values

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !================================
  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer :: xhash(ps_hash_total) ! xplasma data hash codes
  integer, intent(in) :: iout     ! LUN for messages
  integer, intent(out) :: ierr    ! completion status, 0=OK
  !================================

  ! local:
  logical :: inew  ! flag if hash entry is new in xplasma
  integer :: id
  integer, dimension(:), pointer :: ia_ptr
  real*8, dimension(:), pointer :: r8a_ptr
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------

  ierr = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_xhashes_put: invalid or unitialized xplasma object.'
     return
  endif

  call xpobj_blkbx(xobj,xpobj_hash_name,ps_hash_total,r8hash_size, &
       inew,id,ia_ptr,r8a_ptr,iout,ierr)
  if(ierr.ne.0) return

  ia_ptr = xhash

  nullify(ia_ptr)
  nullify(r8a_ptr)

end subroutine ps_xhashes_put

subroutine trxplib_ps_connect(ss, ierr)

  ! initialize connection to TRANSP run & write test data
  ! use the working state (ss) as passed

  ! this routine should only be called internally within trxplib

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  !-----------------------------------
  ! arguments:

  type (plasma_state) :: ss     ! working state
  integer, intent(out) :: ierr  ! status code 0=normal

  !-----------------------------------
  ! local:

  character*250 :: tpath,spath

  integer :: lunzer,nonlin

  logical :: lheavy_save

  real*8 :: zt1,zt2
  real*8 :: Rmin,Rmax,Zmin,Zmax

  !-----------------------------------
  ! load all needed run data in memory...
  !   (rplot memory now uses dynamic expansion capability as an option)

  call datmgr_no_delete

  !-----------------------------------
  ! construct tpath

  ierr = 0
  nonlin = lunzer(0)

  lheavy_save = lheavy
  lheavy = .TRUE.

  if(lmds) then
     tpath = "MDS+:"//trim(rpath)
  else
     tpath = "FILE:"//trim(rpath)
  endif

  do 
     !  connect to run data...
     call trx_connect(tpath, ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?trxplib_ps_connect: trx_connect error.'
        exit
     endif

     !  discover time range...
     call trx_tlims(zt1,zt2, ierr)
     if(ierr.ne.0) exit

     !  write sawtooth times...
     spath = trim(opath)//'/sawtimes.dat'
     call trx_wr_stimes(spath, ierr)
     if(ierr.ne.0) exit

     !  write profile times...
     spath = trim(opath)//'/protimes.dat'
     call trx_wr_protimes(spath, ierr)
     if(ierr.ne.0) exit

     !  write test data: "heavy" state at 1st available time

     saw_hint = 0
     delta_t = 0.0d0

     tselect = zt1

     !  this routine also sets internal labels: geqdsk_lbl, runid
     call trxplib_ps_xplasma_ini(ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?trxplib_ps_connect: trxplib_ps_xplasma_ini error.'
        exit
     endif

     ps_file = trim(runid)//'_init.cdf'

     call trxplib_ps_write1(ss, .TRUE., ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?trxplib_ps_connect: _init state write error.'
        exit
     endif

     exit
  enddo

  lheavy = lheavy_save

end subroutine trxplib_ps_connect

C-----------------------------------------------------------------------
C  TDB_CHKPROF -- CHECK THAT POINTERS ARE IN ORDER FOR TRDAT MAPPED PROFILES
C
C  ** GENERATED CODE ** TRDATGEN / DMC 3 MAY 1991
C
      SUBROUTINE TDB_CHKPROF(d,ISTOP)
C
      use trdatbuf_obj
      IMPLICIT NONE
 
      type (trdatbuf) :: d
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER istop,ier,i,j
!============
      CHARACTER*25 ZZLABEL    ! build label for 3d profile
C
C-----------------------------------------------------------------------
C
      ISTOP=0
C
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C
      CALL TDBSUB_CK2A(d,'AXR',
     >     D%LFAXR,D%LXAXR,D%NXAXR,D%NRIAXR,D%NSYAXR,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'BOL',
     >     D%LFBOL,D%LXBOL,D%NXBOL,D%NRIBOL,D%NSYBOL,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'BPA',
     >     D%LFBPA,D%LXBPA,D%NXBPA,D%NRIBPA,D%NSYBPA,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'BPB',
     >     D%LFBPB,D%LXBPB,D%NXBPB,D%NRIBPB,D%NSYBPB,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'D2F',
     >     D%LFD2F,D%LXD2F,D%NXD2F,D%NRID2F,D%NSYD2F,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DE2',
     >     D%LFDE2,D%LXDE2,D%NXDE2,D%NRIDE2,D%NSYDE2,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DF3',
     >     D%LFDF3,D%LXDF3,D%NXDF3,D%NRIDF3,D%NSYDF3,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DF4',
     >     D%LFDF4,D%LXDF4,D%NXDF4,D%NRIDF4,D%NSYDF4,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DF6',
     >     D%LFDF6,D%LXDF6,D%NXDF6,D%NRIDF6,D%NSYDF6,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DFD',
     >     D%LFDFD,D%LXDFD,D%NXDFD,D%NRIDFD,D%NSYDFD,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DFH',
     >     D%LFDFH,D%LXDFH,D%NXDFH,D%NRIDFH,D%NSYDFH,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'DFT',
     >     D%LFDFT,D%LXDFT,D%NXDFT,D%NRIDFT,D%NSYDFT,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'ECF',
     >     D%LFECF,D%LXECF,D%NXECF,D%NRIECF,D%NSYECF,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'FEH',
     >     D%LFFEH,D%LXFEH,D%NXFEH,D%NRIFEH,D%NSYFEH,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'FEL',
     >     D%LFFEL,D%LXFEL,D%NXFEL,D%NRIFEL,D%NSYFEL,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'GRB',
     >     D%LFGRB,D%LXGRB,D%NXGRB,D%NRIGRB,D%NSYGRB,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'IBE',
     >     D%LFIBE,D%LXIBE,D%NXIBE,D%NRIIBE,D%NSYIBE,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'IBI',
     >     D%LFIBI,D%LXIBI,D%NXIBI,D%NRIIBI,D%NSYIBI,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'JBM',
     >     D%LFJBM,D%LXJBM,D%NXJBM,D%NRIJBM,D%NSYJBM,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'JEC',
     >     D%LFJEC,D%LXJEC,D%NXJEC,D%NRIJEC,D%NSYJEC,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'JIC',
     >     D%LFJIC,D%LXJIC,D%NXJIC,D%NRIJIC,D%NSYJIC,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LF3',
     >     D%LFLF3,D%LXLF3,D%NXLF3,D%NRILF3,D%NSYLF3,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LF4',
     >     D%LFLF4,D%LXLF4,D%NXLF4,D%NRILF4,D%NSYLF4,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LF6',
     >     D%LFLF6,D%LXLF6,D%NXLF6,D%NRILF6,D%NSYLF6,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LFD',
     >     D%LFLFD,D%LXLFD,D%NXLFD,D%NRILFD,D%NSYLFD,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LFH',
     >     D%LFLFH,D%LXLFH,D%NXLFH,D%NRILFH,D%NSYLFH,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LFT',
     >     D%LFLFT,D%LXLFT,D%NXLFT,D%NRILFT,D%NSYLFT,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LHE',
     >     D%LFLHE,D%LXLHE,D%NXLHE,D%NRILHE,D%NSYLHE,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'LHJ',
     >     D%LFLHJ,D%LXLHJ,D%NXLHJ,D%NRILHJ,D%NSYLHJ,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NER',
     >     D%LFNER,D%LXNER,D%NXNER,D%NRINER,D%NSYNER,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NI3',
     >     D%LFNI3,D%LXNI3,D%NXNI3,D%NRINI3,D%NSYNI3,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NI4',
     >     D%LFNI4,D%LXNI4,D%NXNI4,D%NRINI4,D%NSYNI4,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NI6',
     >     D%LFNI6,D%LXNI6,D%NXNI6,D%NRINI6,D%NSYNI6,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NID',
     >     D%LFNID,D%LXNID,D%NXNID,D%NRINID,D%NSYNID,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NIH',
     >     D%LFNIH,D%LXNIH,D%NXNIH,D%NRINIH,D%NSYNIH,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NIM',
     >     D%LFNIM,D%LXNIM,D%NXNIM,D%NRINIM,D%NSYNIM,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NIT',
     >     D%LFNIT,D%LXNIT,D%NXNIT,D%NRINIT,D%NSYNIT,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'NMR',
     >     D%LFNMR,D%LXNMR,D%NXNMR,D%NRINMR,D%NSYNMR,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'OMG',
     >     D%LFOMG,D%LXOMG,D%NXOMG,D%NRIOMG,D%NSYOMG,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'PRS',
     >     D%LFPRS,D%LXPRS,D%NXPRS,D%NRIPRS,D%NSYPRS,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'QBE',
     >     D%LFQBE,D%LXQBE,D%NXQBE,D%NRIQBE,D%NSYQBE,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'QBI',
     >     D%LFQBI,D%LXQBI,D%NXQBI,D%NRIQBI,D%NSYQBI,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'QEC',
     >     D%LFQEC,D%LXQEC,D%NXQEC,D%NRIQEC,D%NSYQEC,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'QIC',
     >     D%LFQIC,D%LXQIC,D%NXQIC,D%NRIQIC,D%NSYQIC,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'QPR',
     >     D%LFQPR,D%LXQPR,D%NXQPR,D%NRIQPR,D%NSYQPR,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'RES',
     >     D%LFRES,D%LXRES,D%NXRES,D%NRIRES,D%NSYRES,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'SBI',
     >     D%LFSBI,D%LXSBI,D%NXSBI,D%NRISBI,D%NSYSBI,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'TER',
     >     D%LFTER,D%LXTER,D%NXTER,D%NRITER,D%NSYTER,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'TI2',
     >     D%LFTI2,D%LXTI2,D%NXTI2,D%NRITI2,D%NSYTI2,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'TQI',
     >     D%LFTQI,D%LXTQI,D%NXTQI,D%NRITQI,D%NSYTQI,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'V2F',
     >     D%LFV2F,D%LXV2F,D%NXV2F,D%NRIV2F,D%NSYV2F,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VB2',
     >     D%LFVB2,D%LXVB2,D%NXVB2,D%NRIVB2,D%NSYVB2,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VC3',
     >     D%LFVC3,D%LXVC3,D%NXVC3,D%NRIVC3,D%NSYVC3,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VC4',
     >     D%LFVC4,D%LXVC4,D%NXVC4,D%NRIVC4,D%NSYVC4,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VC6',
     >     D%LFVC6,D%LXVC6,D%NXVC6,D%NRIVC6,D%NSYVC6,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VCD',
     >     D%LFVCD,D%LXVCD,D%NXVCD,D%NRIVCD,D%NSYVCD,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VCH',
     >     D%LFVCH,D%LXVCH,D%NXVCH,D%NRIVCH,D%NSYVCH,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VCT',
     >     D%LFVCT,D%LXVCT,D%NXVCT,D%NRIVCT,D%NSYVCT,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VEE',
     >     D%LFVEE,D%LXVEE,D%NXVEE,D%NRIVEE,D%NSYVEE,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VIE',
     >     D%LFVIE,D%LXVIE,D%NXVIE,D%NRIVIE,D%NSYVIE,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VMO',
     >     D%LFVMO,D%LXVMO,D%NXVMO,D%NRIVMO,D%NSYVMO,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VP2',
     >     D%LFVP2,D%LXVP2,D%NXVP2,D%NRIVP2,D%NSYVP2,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VPO',
     >     D%LFVPO,D%LXVPO,D%NXVPO,D%NRIVPO,D%NSYVPO,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VPR',
     >     D%LFVPR,D%LXVPR,D%NXVPR,D%NRIVPR,D%NSYVPR,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'VTR',
     >     D%LFVTR,D%LXVTR,D%NXVTR,D%NRIVTR,D%NSYVTR,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'ZF2',
     >     D%LFZF2,D%LXZF2,D%NXZF2,D%NRIZF2,D%NSYZF2,IER)
      IF(IER.NE.0) ISTOP=1
C
      CALL TDBSUB_CK2A(d,'ZXR',
     >     D%LFZXR,D%LXZXR,D%NXZXR,D%NRIZXR,D%NSYZXR,IER)
      IF(IER.NE.0) ISTOP=1
C
      DO I = 1, 300
        J = D%NISSIM(I)
        IF (J==0) EXIT
        WRITE(ZZLABEL,'(A,I3,A,I5)') 'SIM SET:',J,', TOT:',I
        CALL TDBSUB_CK2A(d,ZZLABEL,D%LFSIM(I),D%LXSIM(J),
     >              D%NXSIM(J),D%NRISIM(J),D%NSYSIM(J),IER)
        IF(IER.NE.0) ISTOP=1
      END DO
C
C
C=>TRDATGEN-
C
      RETURN
      END
! 20jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

subroutine tdb_izminmax(d,izmin,izmax)

  !  if d%LDATZIM > 0 & d%NTIME1 > 0:
  !     return izmin and izmax corresponding to min and max Zimp
  !     as stored in d%datbuf(d%LDATZIM:d%LDATZIM+d%NTIME1-1)

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  integer :: izmin,izmax

  !-----------------

  real*8 :: zmin,zmax,ztest
  integer :: ii,indx

  !---------------------------

  izmin=0
  izmax=0

  if(d%ldatzim.eq.0) return
  if(d%ntime1.eq.0) return

  zmin=d%datbuf(d%ldatzim)
  zmax=zmin

  do ii=1,d%ntime1
     indx = d%ldatzim + ii - 1
     zmin=min(zmin,d%datbuf(indx))
     zmax=max(zmax,d%datbuf(indx))
  enddo

  izmin = zmin
  izmax = zmax
  ztest = izmax

  if(ztest.lt.zmax) izmax=izmax+1

end subroutine tdb_izminmax

subroutine ts_cdf_write(filename,iu,inumsc,inumpro,nzones,ierr_open)

  ! create a NetCDF version of the traditional ASCII TRANSP "time_slices"
  ! dataset

  ! the ASCII file has just been written and is open on unit (iu) --
  ! rewind to read back

  ! See: ts_write.for -- routine that writes the ASCII file.

  use netcdf
  implicit NONE

  character*(*), intent(in) :: filename   ! NetCDF filename

  integer, intent(in) :: iu               ! I/O unit number, open ASCII file

  integer, intent(in) :: inumsc           ! number of scalar values
  integer, intent(in) :: inumpro          ! number of profiles
  integer, intent(in) :: nzones           ! number of spatial pts in profiles

  integer, intent(out) :: ierr_open       ! NetCDF file open status 0=OK

  !-----------------------------------------------
  integer :: icdf  ! open NetCDF file identifier

  !-------------
  ! header data

  character*40 tr_label   ! TRANSP run global label
  character*120 tr_path   ! TRANSP run file or MDS+ path

  real*8 :: time          ! time of time slice (s)
  real*8 :: avg_delta_t   ! averaging time +/- around (time) (s)

  !-------------
  ! trailer data

  character*40 wdate,nodename,username
  character*120 disclaimer

  !-------------
  ! labels for time data
  character*20 tunits
  character*60 tlabel,avg_tlabel

  !-------------
  ! scalar data
  character*20, dimension(:), allocatable :: snames
  real*8, dimension(:), allocatable :: svals
  character*20, dimension(:), allocatable :: sunits
  character*60, dimension(:), allocatable :: slabels

  !-------------
  ! profile data
  character*20, dimension(:), allocatable :: pnames
  real*8, dimension(:,:), allocatable :: pvals
  character*20, dimension(:), allocatable :: punits
  character*60, dimension(:), allocatable :: plabels
  integer, dimension(:), allocatable :: itypex

  !-----------------------------------------------

  character*150 :: linbuf,save_linbuf

  character*12 :: fdcod
  integer :: il1,il2,ilen,ii,jj,ic,icsave,istat
  integer :: ivar,itype
  integer :: idim20,idim40,idim60,idim120
  integer :: idim,idimx,idimxb

  !-----------------------------------------------
  !  executable code

  !  OPEN NetCDF file

  ierr_open = 0
  istat = nf90_create(trim(filename),NF90_CLOBBER,icdf)
  if(istat.ne.NF90_NOERR) then
     write(6,*) ' ?ts_cdf_write: open failure: '//trim(filename)
     ierr_open = 3
     return
  endif

  ! OK 
  rewind(iu)

  allocate(snames(inumsc),sunits(inumsc))
  allocate(svals(inumsc),slabels(inumsc))

  allocate(pnames(inumpro),punits(inumpro),itypex(inumpro))
  allocate(pvals(nzones,inumpro),plabels(inumpro))

  tunits = 's'
  tlabel = 'selected time of TRANSP data'
  avg_tlabel='averaging delta(time) +/-'

  !--------------------------
  !  read ASCII data: HEADER

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf
  save_linbuf = linbuf

  il1 = index(linbuf,'Run') + 3
  il2 = index(linbuf,'TRREAD path')

  call fld_delim('"',il1,il2)
  tr_label = linbuf(il1:il2)

  il1 = il2 + 10
  il2 = len(trim(linbuf))

  call fld_delim('"',il1,il2)
  tr_path = linbuf(il1:il2)

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf
  il1 = index(linbuf,'=')
  il2 = index(linbuf,'averaged')
  call fld_delim(' ',il1,il2)
  call fld_decod(linbuf(il1:il2),time)

  il1 = index(linbuf,'+/-')
  il2 = index(linbuf,'second')
  call fld_delim(' ',il1,il2)
  call fld_decod(linbuf(il1:il2),avg_delta_t)

  !--------------------------
  !  read ASCII data: SCALARS

  do ii=1,inumsc
     linbuf=' '
     read(unit=iu,fmt='(A)') linbuf

     il2 = index(linbuf,'[')
     il1 = il2-14
     call fld_delim(' ',il1,il2)
     call fld_decod(linbuf(il1:il2),svals(ii))

     ic=il1
     do 
        ic=ic-1
        if(linbuf(ic:ic).eq.'=') exit
        if(ic.eq.0) exit
     enddo

     il1=1
     il2=ic
     call fld_delim(' ',il1,il2)
     if(linbuf(ic-1:ic-1).ne.' ') il2=ic  ! correction if no trailing blank
     if(linbuf(1:1).ne.' ') il1=1
     slabels(ii) = linbuf(il1:il2)

     do
        ic=ic+1
        if(ic.gt.len(linbuf)) exit
        if(linbuf(ic:ic).eq.'[') then
           il1 = ic + 1
        else if(linbuf(ic:ic).eq.']') then
           il2 = ic - 1
           exit
        endif
     enddo

     sunits(ii) = linbuf(il1:il2)

     il1 = index(linbuf,'RPLOT abrev = ')
     il1 = il1 + 14
     il2 = len(trim(linbuf))

     snames(ii) = linbuf(il1:il2)

  enddo

  !--------------------------
  !  read ASCII data: PROFILES

  ii = 0
  do 
     linbuf=' '
     read(unit=iu,fmt='(A)') linbuf
     il1 = index(linbuf,'RPLOT abrev = ')
     if(il1.le.0) cycle

     ! found one...

     ii = ii + 1

     il1 = il1 + 14
     il2 = len(trim(linbuf))

     pnames(ii) = linbuf(il1:il2)

     if(pnames(ii).eq.'X') then
        itypex(ii)=1
        punits(ii) = 'no units'
        il2 = il1-14
        il1 = 1
        call fld_delim(' ',il1,il2)
        plabels(ii)= linbuf(il1:il2)

     else if(pnames(ii).eq.'XB') then
        itypex(ii)=2
        punits(ii) = 'no units'
        il2 = il1-14
        il1 = 1
        call fld_delim(' ',il1,il2)
        plabels(ii)= linbuf(il1:il2)

     else
        ic = il1 - 15
        do 
           if(linbuf(ic:ic).eq.'@') exit
           ic = ic -1
           if(ic.eq.0) exit
        enddo

        if(linbuf(ic+1:ic+2).eq.'X ') then
           itypex(ii)=1
        else if(linbuf(ic+1:ic+2).eq.'XB') then
           itypex(ii)=2
        else
           itypex(ii)=0
           write(6,*) ' %ts_cdf_write: parse failure on line:'
           write(6,*) '  '//trim(linbuf)
           plabels(ii)=' '
           punits(ii)=' '
        endif

        if(itypex(ii).gt.0) then
           icsave=ic
           do
              ic=ic-1
              if(ic.eq.0) exit  ! some entries omit units

              if(linbuf(ic:ic).eq.']') then
                 il2=ic-1
              else if(linbuf(ic:ic).eq.'[') then
                 il1=ic+1
                 exit
              endif
           enddo
           if(ic.eq.0) then
              ! if units were omitted use prior profile's units
              punits(ii)=punits(ii-1)
              ic=icsave
              il1=ic-1
           else
              punits(ii)=linbuf(il1:il2)
           endif

           il2=il1
           il1=1
           call fld_delim(' ',il1,il2)
           if(linbuf(ic-1:ic-1).ne.' ') il2=ic  ! correction if no trailing blank
           if(linbuf(1:1).ne.' ') il1=1

           plabels(ii) = linbuf(il1:il2)
        endif

     endif

     ! parse out values

     jj = 0
     do 
        linbuf=' '
        read(unit=iu,fmt='(A)') linbuf
        ilen = len(trim(linbuf))

        il1 = 1
        do
           jj = jj + 1
           call fld_next(il1,il2)
           call fld_decod(linbuf(il1:il2),pvals(jj,ii))
           if(il2.eq.ilen) exit
           il1 = il2 + 1
        enddo
        if(jj.eq.nzones) exit
     enddo

     if(ii.eq.inumpro) exit
  enddo

  !--------------------------
  !  read ASCII data: TRAILER

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf

  il1=index(linbuf,' on ') + 4
  il2=len(trim(linbuf))

  wdate = linbuf(il1:il2)

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf

  il1=index(linbuf,' on node ') + 4
  il2=index(linbuf,' by ')
  call fld_delim(' ',il1,il2)
  nodename = linbuf(il1:il2)

  il1 = il2 + 5
  il2 = len(trim(linbuf)) + 1
  call fld_delim(' ',il1,il2)
  username = linbuf(il1:il2)

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf

  disclaimer = linbuf
  il1 = len(trim(disclaimer))

  linbuf=' '
  read(unit=iu,fmt='(A)') linbuf

  disclaimer(il1+3:) = trim(linbuf)

  !--------------------------
  ! file read complete; NetCDF definitions

  !  lengths of labels
  istat = nf90_def_dim(icdf,"char_len_20",20,idim20)
  istat = nf90_def_dim(icdf,"char_len_40",40,idim40)
  istat = nf90_def_dim(icdf,"char_len_60",60,idim60)
  istat = nf90_def_dim(icdf,"char_len_120",120,idim120)

  !  header

  itype = NF90_CHAR

  istat = nf90_def_var(icdf,'TR_label',itype,idim40,ivar)
  istat = nf90_def_var(icdf,'TR_path',itype,idim120,ivar)

  itype = NF90_DOUBLE

  istat = nf90_def_var(icdf,'time',itype,ivar)
  istat = nf90_put_att(icdf,ivar,'units',tunits)
  istat = nf90_put_att(icdf,ivar,'label',tlabel)

  istat = nf90_def_var(icdf,'avg_delta_t',itype,ivar)
  istat = nf90_put_att(icdf,ivar,'units',tunits)
  istat = nf90_put_att(icdf,ivar,'label',avg_tlabel)

  !  scalars

  itype = NF90_DOUBLE

  do ii=1,inumsc
     istat = nf90_def_var(icdf,snames(ii),itype,ivar)
     istat = nf90_put_att(icdf,ivar,'units',sunits(ii))
     istat = nf90_put_att(icdf,ivar,'label',slabels(ii))
  enddo

  ! profile data

  ! these two dimensions match but are distinguished according as data
  ! is vs. X or XB; this is also indicated by attribute

  istat = nf90_def_dim(icdf,"dim_X",nzones,idimx)
  istat = nf90_def_dim(icdf,"dim_XB",nzones,idimxb)

  !  trailer

  itype = NF90_DOUBLE

  do ii=1,inumpro
     if(itypex(ii).eq.1) then
        idim=idimx
     else
        idim=idimxb
     endif
     istat = nf90_def_var(icdf,pnames(ii),itype,idim,ivar)
     istat = nf90_put_att(icdf,ivar,'units',punits(ii))
     istat = nf90_put_att(icdf,ivar,'label',plabels(ii))
     if(itypex(ii).eq.1) then
        istat = nf90_put_att(icdf,ivar,'vs','X')
     else
        istat = nf90_put_att(icdf,ivar,'vs','XB')
     endif
  enddo

  itype = NF90_CHAR

  istat = nf90_def_var(icdf,'wdate',itype,idim40,ivar)
  istat = nf90_def_var(icdf,'nodename',itype,idim40,ivar)
  istat = nf90_def_var(icdf,'username',itype,idim40,ivar)
  istat = nf90_def_var(icdf,'Disclaimer',itype,idim120,ivar)

  !--------------------------
  ! NetCDF writes
 
  ! header data
  istat = nf90_enddef(icdf)  ! exit definition mode
 
  istat = nf90_inq_varid(icdf,"TR_label",ivar)
  istat = nf90_put_var(icdf,ivar,tr_label)
 
  istat = nf90_inq_varid(icdf,"TR_path",ivar)
  istat = nf90_put_var(icdf,ivar,tr_path)
 
  istat = nf90_inq_varid(icdf,"time",ivar)
  istat = nf90_put_var(icdf,ivar,time)
 
  istat = nf90_inq_varid(icdf,"avg_delta_t",ivar)
  istat = nf90_put_var(icdf,ivar,avg_delta_t)

  ! scalar data

  do ii=1,inumsc
     istat = nf90_inq_varid(icdf,snames(ii),ivar)
     istat = nf90_put_var(icdf,ivar,svals(ii))
  enddo

  ! profile data

  do ii=1,inumpro
     istat = nf90_inq_varid(icdf,pnames(ii),ivar)
     istat = nf90_put_var(icdf,ivar,pvals(:,ii)) 
  enddo

  ! trailer data       
  istat = nf90_inq_varid(icdf,"wdate",ivar)
  istat = nf90_put_var(icdf,ivar,wdate)
 
  istat = nf90_inq_varid(icdf,"nodename",ivar)
  istat = nf90_put_var(icdf,ivar,nodename)
 
  istat = nf90_inq_varid(icdf,"username",ivar)
  istat = nf90_put_var(icdf,ivar,username)
 
  istat = nf90_inq_varid(icdf,"Disclaimer",ivar)
  istat = nf90_put_var(icdf,ivar,disclaimer)



  !--------------------------
  ! finish up

  istat = nf90_close(icdf)

  deallocate(snames,sunits,svals,slabels)
  deallocate(pnames,punits,pvals,plabels,itypex)

CONTAINS

  subroutine fld_delim(dchar,i1,i2)

    ! linbuf(i1:i2) gives the aproximate location of the field value sought;
    ! use delimiter character (dchar) to narrow the location to the precise
    ! range covered by the data field.

    character*1, intent(in) :: dchar
    integer, intent(inout) :: i1,i2

    !------------------------
    integer :: idgot
    !------------------------

    idgot = 0
    do 
       if(idgot.eq.0) then
          if(linbuf(i1:i1).eq.dchar) then
             idgot = 1
          endif
          i1=i1+1
          cycle

       else
          if(linbuf(i1:i1).ne.dchar) then
             exit
          else
             i1=i1+1
             cycle
          endif
       endif
    enddo

    idgot = 0
    do 
       if(idgot.eq.0) then
          if(linbuf(i2:i2).eq.dchar) then
             idgot = 1
          endif
          i2=i2-1
          cycle

       else
          if(linbuf(i2:i2).ne.dchar) then
             exit
          else
             i2=i2-1
             cycle
          endif
       endif
    enddo

  end subroutine fld_delim

  subroutine fld_next(il1,il2)

    ! find next non-blank field for decoding
    ! start searching at linbuf(il1:il1)

    integer, intent(inout) :: il1  ! beginning of field, on exit
    integer, intent(out) :: il2    ! end of field

    do
       if(linbuf(il1:il1).ne.' ') exit
       il1 = il1 + 1
    enddo

    il2=il1
    do
       if(linbuf(il2+1:il2+1).eq.' ') exit
       il2=il2 + 1
    enddo

  end subroutine fld_next

  subroutine fld_decod(fstr,valr8)

    character*(*), intent(in) :: fstr
    real*8, intent(out) :: valr8

    ! decode a floating pt number, max length .le. 12 assumed

    integer :: ilenf

    !-----------------

    ilenf=len(trim(fstr))

    fdcod=' '
    fdcod(12-ilenf+1:12) = fstr(1:ilenf)

    read(fdcod,'(G12.0)') valr8

  end subroutine fld_decod

end subroutine ts_cdf_write

subroutine trx_gen_ech_files(ss, fpath,runid,ierr)

  ! (called from trx_gen_state) -- generate files for driving ECH codes
  ! when Plasma State derived data is available

  ! The plasma state (PS) has been loaded!
  ! SPLITN access to TRANSP namelist variables is also available.

  ! maintenance note: this routine generates TORAY input files so the 
  ! code has much in common with heatlib/toraymain.f90

  use plasma_state_mod
  use trx_module

  use echmod_typedef

  implicit NONE

  type (plasma_state) :: ss           ! state object to use...

  character*(*), intent(in) :: fpath  ! directory in which to write files
  character*(*), intent(in) :: runid  ! TRANSP runid
  integer, intent(out) :: ierr   ! completion status, 0=OK

  !  local...
  !-----------------------------------------------------
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  !-----------------------------------------------------
  real*8, parameter :: zminpow = 0.001_R8

  logical :: dirsw
  character*300 :: zdsave
  character*120 :: zlabel

  type (toray_numeric) :: tn
  type (toray_gafit)   :: tg

  integer :: inuma  ! number of antennas or sources
  integer :: nonlin,lunzer,iant,isize,iray,iset,ig,jk,inray,idamp,ilun
  integer :: istat,icta

  character*6 :: ichant
  character*6, dimension(:), allocatable :: ichaa ! ascii encoded antenna #s

  real*8 :: zfmu0,zrfmod,zx00,zz00,zthet,zphai,zbhalf,           &
       zbsratio,zr0,zb0,zrmins,zpowinj,                     &
       zctim,zsmax,zsmaxtor,sumint 

  character*1 :: bslash = '\\'  ! unix needs escaped backslash

  !-----------------------------------------------------
  !  TORAY/ECH namelist variables

  integer :: nraygaus,ngafittor,nharmtor,mn0tor,ngzntor,modelctor
  real*8 :: dstor,dsmintor,fdouttor,powinctor,relerrtor,abserrtor,pwrfmntor
  logical :: nlcqldat,iswitch

  integer, dimension(:), allocatable :: mraytor
  real*8, dimension(:), allocatable :: crtor

  integer, dimension(:), allocatable :: ndampech,idampech,nrayech

  logical, dimension(:), allocatable :: iactive

  !-----------------------------------------------------
  !
  !         GEQDSK file related variables and arrays
  !
 
  character*80 z_geqroot,z_psiin
  
  integer inR,inZ,inB,inprof

  real*8 :: zgafsep   ! "GAFSEP" for TORAY: keep small, 1e-5/#zones
  ! (see comments in toray.f90)

  !-----------------------

  ierr = 0

  nonlin = lunzer(0)

  write(nonlin,*) ' '
  write(nonlin,*) ' %trx_gen_ech_files: look for TORAY and GENRAY inputs...'

  call loc_splitn_lget1('nltoray',iswitch)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?NLTORAY access error (ignored)'
     ierr=0
  else
     if(iswitch) then
        write(nonlin,*) ' ...the TRANSP run used TORAY'
     else
        write(nonlin,*) ' ...the TRANSP run did not use TORAY: TORAY controls may not be set correctly.'
     endif
  endif

  call loc_splitn_lget1('nlgen_ech',iswitch)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?NLGEN_ECH access error (ignored)'
     ierr=0
  else
     if(iswitch) then
        write(nonlin,*) ' ...the TRANSP run used GENRAY for ECH'
     else
        write(nonlin,*) ' ...the TRANSP run did not use GENRAY for ECH;'
        write(nonlin,*) '    default GENRAY template file will be sought.'
     endif
  endif

  call loc_splitn_lget1('nltorbeam',iswitch)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?NLTORBEAM access error (ignored)'
     ierr=0
  else
     if(iswitch) then
        write(nonlin,*) ' ...the TRANSP run used TORBEAM for ECH'
     else
        write(nonlin,*) ' ...the TRANSP run did not use TORBEAM for ECH'
     endif
  endif

  call find_io_unit(ilun)

  ! # antennas; form ascii encoded list of antenna numbers

  inuma=ss%necrf_src
  if(inuma.le.0) then
     write(nonlin,*) ' %trx_gen_ech_files: no ECH sources found.'
     return
  endif

  allocate(ichaa(inuma),iactive(inuma))

  icta=0
  do iant=1,inuma
     write(ichant,'(i6)') iant
     ichaa(iant)=trim(adjustl(ichant))
     if(ss%power_ec(iant).gt.zminpow) then
        icta=icta+1
        write(nonlin,*) ' trx_gen_ech_files: antenna #',iant,' has power.'
        iactive(iant)=.TRUE.
     else
        iactive(iant)=.FALSE.
     endif
  enddo

  if(icta.le.0) then
     write(nonlin,*) ' %trx_gen_ech_files: no ECH antennas have power.'
     return
  endif

  !----------------------------------------------------
  if((fpath.ne.' ').AND.(fpath.ne.'.')) then
     ! cd to output directory
     dirsw=.TRUE.
     call sget_cwd(zdsave)
     call sset_cwd(fpath,ierr)
     if(ierr.ne.0) return
  else
     dirsw=.FALSE.
  endif

  do
     !----------------------------------------------------
     ! TORAY profile size

     call loc_splitn_iget1('NPROFTOR',inprof); if(ierr.ne.0) exit

     ! put rho_ecrf grid into ps

     ss%nrho_ecrf = inprof
     call ps_alloc_plasma_state(ierr, state=ss)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?trx_gen_ech_files: rho_ecrf allocate error.'
        exit
     endif

     ss%rho_ecrf(1)=0.0_R8
     ss%rho_ecrf(inprof)=1.0_R8
     do jk=2,inprof-1
        ss%rho_ecrf(jk)=(jk-1)*1.0_R8/(inprof-1)
     enddo

     ! equilibrium data...

     zgafsep = 1.0d-5/inprof   ! "GAFSEP" for TORAY: keep small, 1e-5/#zones

     z_geqroot='eqdskin'
     z_psiin='psiin'

     inR=129
     inZ=129
     inB=129

     !  write G-eqdsk:

     write(nonlin,*) '   ...file: '//trim(z_geqroot)
     call ps_geqdsk_write_nRZ(ss,z_geqroot, &
          'trxpl:trx_gen_ech_files, TRANSP id: '//trim(runid)//' ', &
          inR,inZ,inB,nonlin,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) '?trx_gen_ech_files: ps_geqdsk_write_nRZ error.'
        ierr=1
        exit
     endif

     !  read G-eqdsk; write psiin:

     write(nonlin,*) '   ...file: '//trim(z_psiin)
     call ps_psiin_write(ss,nonlin,z_geqroot,z_psiin,inprof,zgafsep, &
          ierr)
     if(ierr.ne.0) then
        write(nonlin,*) '?trx_gen_ech_files: ps_psiin_write error.'
        ierr=1
        exit
     endif

     !  write toray.in & gafit.in

     write(nonlin,*) ' '
     write(nonlin,*) ' ...acquire TRANSP namelist variables; write files: toray.in and gafit.in'

     zlabel = 'ECH and ECCD (trxpl:trx_gen_ech_files)'

     call loc_splitn_dget1('smaxtor',zsmaxtor); if(ierr.ne.0) exit

     if(zsmaxtor.le.0.0_R8) then
        zsmaxtor = 2*100.0d0*ss%r_axis  ! default max ray length
     endif

     call toray_numeric_adflts(tn) ! set array defaults

     call loc_splitn_iget1('nraygaus',nraygaus); if(ierr.ne.0) exit

     call splitn_getsize('MRAYTOR',isize,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array size error.'
        ierr=1
        exit
     endif

     allocate(mraytor(isize),crtor(isize))

     call splitn_iget('MRAYTOR',isize,mraytor,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array read error.'
        ierr=1
        exit
     endif

     call splitn_dget('CRTOR',isize,crtor,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array read error.'
        ierr=1
        exit
     endif

     iset = 0
     do iray=1,nraygaus
        if (mraytor(iray).le.0) then
           continue  ! use toray_numeric default
        else
           tn%mray(iray) = mraytor(iray)   ! use non-zero namelist value
        endif

        if (crtor(iray).ne.0.0_r8) then
           iset = iset + 1   ! non-zero namelist value exists
        endif
     enddo

     if(iset.gt.1) then
        tn%cr = crtor       ! set from namelist if any non-zero values found
     endif

     call loc_splitn_iget1('ngafittor',ngafittor); if(ierr.ne.0) exit
     call loc_splitn_iget1('nharmtor',nharmtor); if(ierr.ne.0) exit
     call loc_splitn_iget1('mn0tor',mn0tor); if(ierr.ne.0) exit
     call loc_splitn_iget1('ngzntor',ngzntor); if(ierr.ne.0) exit
     call loc_splitn_iget1('modelctor',modelctor); if(ierr.ne.0) exit

     call loc_splitn_lget1('nlcqldat',nlcqldat); if(ierr.ne.0) exit

     call loc_splitn_dget1('dstor',dstor); if(ierr.ne.0) exit
     call loc_splitn_dget1('dsmintor',dsmintor); if(ierr.ne.0) exit
     call loc_splitn_dget1('fdouttor',fdouttor); if(ierr.ne.0) exit
     call loc_splitn_dget1('powinctor',powinctor); if(ierr.ne.0) exit
     call loc_splitn_dget1('relerrtor',relerrtor); if(ierr.ne.0) exit
     call loc_splitn_dget1('abserrtor',abserrtor); if(ierr.ne.0) exit
     call loc_splitn_dget1('pwrfmntor',pwrfmntor); if(ierr.ne.0) exit

     tn%igafit = ngafittor
     tn%smax = zsmaxtor
     tn%ds = dstor
     tn%dsmin = dsmintor

     tn%fdout = fdouttor
     tn%powinc = powinctor
     tn%relerr = relerrtor
     tn%abserr = abserrtor

     tn%nharm = nharmtor
     tn%mn0 = mn0tor

     tn%gauszone = ngzntor
     tn%modelc = modelctor
     tn%pwrfmin = pwrfmntor

     tn%cqldat = nlcqldat

     tg%ipsi = 0
     tg%gafsep = zgafsep

     call toray_namelist_wr(zlabel, tn, tg, ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?trx_gen_ech_files: toray_namelist_wr error.'
        exit
     endif

     ! compute number of rays implied by mray(...) settings; this will
     ! override TRANSP namelist nrayech(...) control

     inray=0
     do ig=1,ngzntor
        inray = inray + tn%mray(ig)
     enddo

     call splitn_getsize('NDAMPECH',isize,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array size error.'
        ierr=1
        exit
     endif

     allocate(ndampech(isize),idampech(isize),nrayech(isize))

     call splitn_iget('NDAMPECH',isize,ndampech,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array read error.'
        ierr=1
        exit
     endif

     call splitn_iget('NRAYECH',isize,nrayech,ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' %trx_gen_ech_files: namelist array read error.'
        ierr=1
        exit
     endif

     call echin_ck_dampmod(ss%necrf_src,ndampech,idampech,nonlin)

     ! loop to prepare antenna-specific input files

     do iant=1,ss%necrf_src

        if (iactive(iant)) then

           idamp=idampech(iant)
           if(inray.ne.nrayech(iant)) then
              write(nonlin,*) &
                   ' %trx_gen_ech_files: nrayech(',iant,')=',nrayech(iant), &
                   ' overridden! '
              write(nonlin,*) '  ray pattern with ngzntor = ',ngzntor, &
                   ' requires inray=',inray
           endif

           zfmu0= ss%freq_ec(iant)
           zrfmod= ss%EC_Omode_fraction(iant) 
           zx00= 100.0_R8*ss%R_EC_launch(iant)
           zz00= 100.0_R8*ss%Z_EC_launch(iant)
           zthet=ss%EC_theta_aim(iant)
           zphai=ss%EC_phi_aim(iant)
           zbhalf=ss%EC_Half_Power_Angle(iant)
           zbsratio=ss%EC_Beam_Elongation(iant)
           
           write(nonlin,*) ' ... write: echin_ant'//trim(ichaa(iant))
           call ps2echin(ss,iant,idamp,inray, nonlin, &
                'echin_ant'//ichaa(iant), ierr)

           if(ierr.ne.0) call errmsg_exit(' ?toraymain: ps2echin error! ')
        else
           ! if the power is zero, do not leave echin file hanging around
           call fdelete('echin_ant'//ichaa(iant),istat)
        endif
     enddo
     ! end of pseudo-loop to write ECH model input files
     exit
  enddo

  !----------------------------------------------------
  !  write script to drive TORAY

  open(unit=ilun,file='toray_job.csh',status='unknown')
  write(nonlin,*) ' ...write toray_job.csh -- supply TORAY executable as argument...'

  write(ilun,1001)
1001 format('#! /bin/csh -f'/ &
          '#'/'# toray driver script '/ &
          '# $1 is the command to run GA TORAY'/'#'/ &
          '  set toray_command = $1')

  do iant=1,ss%necrf_src
     if(iactive(iant)) then
        write(ilun,1002) trim(ichaa(iant)),trim(ichaa(iant))
1002    format(/'  cp echin_ant',a,' echin'/'  $toray_command'/ &
             '  mv toray.nc toray.nc_ant',a)
     endif
  enddo

  close(unit=ilun)

  !----------------------------------------------------
  !  GENRAY...

  do
     ! look for genray.in template file

     write(nonlin,*) ' ...look for GENRAY template namelist... '
     call trx_genray_in_search(nonlin,ierr)
     if(ierr.ne.0) then
        ! this is kind of normal: only some tokamaks have GENRAY template
        ! data available...
        write(nonlin,*) ' %trx_gen_ech_files: GENRAY not available.'
        ierr=0
        exit
     endif

     exit
  enddo

  !----------------------------------------------------
  !  write script to drive GENRAY

  open(unit=ilun,file='genray_job.csh',status='unknown')
  write(nonlin,*) ' ...write genray_job.csh -- supply GENRAY executable as argument...'

  write(ilun,2001)
2001 format('#! /bin/csh -f'/ &
          '#'/'# genray driver script '/ &
          '# $1 is the command to run GENRAY'/'#'/ &
          '  set genray_command = $1'/ &
          '#'/'  prepare_genray_input "init" "EC" "1" "./genray.in" ', &
            '"disabled" "disabled" "yes" >& prep0.log '/ &
          '  if ( $status ) then'/ &
          '    echo "prepare_genray_input init error (see prep0.log)."'/ &
          '    exit 1'/ &
          '  endif'/'#')

  icta=0
  do iant=1,ss%necrf_src
     if(iactive(iant)) then
        icta=icta+1
        write(ilun,*) '######################'
        write(ilun,*) '#  antenna # '//trim(ichaa(iant))
        write(ilun,*) '######################'
        write(ilun,*) ' echo "antenna # '//trim(ichaa(iant))//'"'
        write(ilun,2002) trim(ichaa(iant)),trim(ichaa(iant)), &
             trim(ichaa(iant)),bslash,bslash, &
             trim(ichaa(iant)),trim(ichaa(iant)), &
             trim(ichaa(iant)),trim(ichaa(iant)),trim(ichaa(iant)), &
             trim(ichaa(iant))
2002    format(/'  cp genray_ech.template genray.in'/ &
             '  prepare_genray_input "step" "EC" "',a, &
                '" "./genray.in" "disabled" "disabled" "yes" >& prep',a,'.log'/ &
             '  if ( $status ) then'/ &
             '    echo "prepare_genray_input step error. (see prep',a,'.log)"'/ &
             '    exit 1'/ &
             '  endif'/ &
             '  #...dmc Oct 2010: merge_namelist step added.'/ &
             '  mv genray.in genray.fortran'/ &
             '  merge_namelist  template=genray_ech.template ',a/ &
             '     fortran=genray.fortran  output=genray.in ',a/ &
             '       >& merge',a,'.log'/ &
             '  if ( $status ) then'/ &
             '    echo "merge_namelist error. (see merge',a,'.log)"'/ &
             '    exit 1'/ &
             '  endif'/ &
             '  cp genray.in genray.in_ant',a// &
             '  $genray_command >& genray',a,'.log'/ &
             '  if ( $status ) then'/ &
             '    echo "genray step error (see genray',a,'.log)"'/ &
             '    exit 1'/ &
             '  endif'/ &
             '  cp genray.nc genray.nc_ant',a)

        if(icta.eq.1) then
           ichant = '-'//trim(ichaa(iant))
        else
           ichant = ichaa(iant)
        endif

        write(ilun,2003) trim(ichant)
2003    format(/'  process_genray_output "EC" "',a,'"'/ &
             '  if ( $status ) then'/ &
             '    echo "process_genray_output error."'/ &
             '    exit 1'/ &
             '  endif')
     endif
  enddo

  close(unit=ilun)

  !----------------------------------------------------
  if(dirsw) then
     ! cd back to original directory
     call sset_cwd(zdsave,ierr)
  endif

CONTAINS

  subroutine loc_splitn_iget1(zname,ival)
    character*(*), intent(in) :: zname
    integer, intent(out) :: ival

    ival = 0
    call splitn_iget(zname,1,ival,ierr)
    if(ierr.ne.0) then
       write(nonlin,*) ' %trx_gen_ech_files: namelist integer value error: ', &
            trim(zname)
       ierr=1
    endif
  end subroutine loc_splitn_iget1

  subroutine loc_splitn_dget1(zname,dval)
    character*(*), intent(in) :: zname
    real*8, intent(out) :: dval

    dval = 0.0d0
    call splitn_dget(zname,1,dval,ierr)
    if(ierr.ne.0) then
       write(nonlin,*) ' %trx_gen_ech_files: namelist real*8 value error: ', &
            trim(zname)
       ierr=1
    endif
  end subroutine loc_splitn_dget1

  subroutine loc_splitn_lget1(zname,lval)
    character*(*), intent(in) :: zname
    logical, intent(out) :: lval

    lval = .FALSE.
    call splitn_lget(zname,1,lval,ierr)
    if(ierr.ne.0) then
       write(nonlin,*) ' %trx_gen_ech_files: namelist logical value error: ', &
            trim(zname)
       ierr=1
    endif
  end subroutine loc_splitn_lget1

end subroutine trx_gen_ech_files

      subroutine ufupper(ilun)
C
C  set the filename and .ext to lower case -- for unix filenames,
C  case control option (dmc 26 Sep 1994)
C
      USE UFILES
C
      integer ilun
C
C------------------------------------
C
C  CHECK CHANNEL STATUS
C
      CALL UFINIT
      CALL UFLCHK(ILUN,'UFUPPER   ',ICHAN,IER)
      IF(IER.NE.0) GO TO 9000
      IF(UFSTAT(ICHAN).NE.0) THEN
        CALL UERSTA(ICHAN,'UFUPPER   ')
        GO TO 9000
      ENDIF
C
C  OK
C
        call uupper(uprfix(ichan))
        call uupper(uextnd(ichan))
C
 9000   continue
        return
        end

      subroutine rd_cstringarr(arg,array,numa,ier)
C
C  read data at expression (arg) into array (array)
C  return error code ier, 0 = normal
C
C---------------------------------
C History:
C 11/18/99 CAL: new calling arguments for mds_value
C
C------------------------------
      use UFILES
C
      character*(*) arg
      character*(*) array(numa)
      integer ier
C
      character*128 zerrmsg
C
      integer     idescr_cstringarr, iretl
C
C----------------------------------
C
      ier=0
      ila=max(1,len_trim(arg))
C
      istat=mds_value(arg(1:ila),idescr_cstringarr(array,numa,1),iretl)
      if(mod(istat,2).ne.1) then
         call ufmds_err('UFMDS_READ',istat,ier,zerrmsg,ilm)
         write(ufelun,9510) arg(1:ila),zerrmsg(1:ilm)
 9510    format('  reading MDS+ signal data: ',a/2x,a)
      endif
C
      return
      end

subroutine trdatbuf_intcopy(str1,str2,i,i1,i2,intbuf,ivarsize,idest)

  character*(*), intent(in) :: str1,str2
  integer, intent(inout) :: i,i1,i2
  integer, intent(in) :: intbuf(*),ivarsize(*)
  integer, intent(inout) :: idest

  if(str1.eq.str2) then
     idest = intbuf(i1)
     i=i+1
     i1=i2+1
     i2=i2+ivarsize(i)
  endif

end subroutine trdatbuf_intcopy


subroutine trdatbuf_intcopy_a(str1,str2,i,i1,i2,intbuf,ivarsize,idest_a)

  character*(*), intent(in) :: str1,str2
  integer, intent(inout) :: i,i1,i2
  integer, intent(in) :: intbuf(*),ivarsize(*)
  integer, intent(inout) :: idest_a(*)

  if(str1.eq.str2) then
     idest_a(1:ivarsize(i)) = intbuf(i1:i2)
     i=i+1
     i1=i2+1
     i2=i2+ivarsize(i)
  endif

end subroutine trdatbuf_intcopy_a

C----------------------------------------------------------------
C  TDB_PRFINS
C
C  INTERPOLATE SYMMETRIZED DATA TO DESIRED X COORDINATES
C   CONVERT <X> FCN TO A "SHAFRANOV SHIFT" PROFILE
C   INPUT (PASSED):
C     INUMR--  NUMBER OF PTS IN SYMMETRIZED UNINTERPOLATED DATA PROFILES
C     ZXF(INXF)-- TARGET X LOCATIONS AT WHICH TO INTERPOLATE PROFILES
C         (COMMON):
C     WORKBUF(LBX(2)..): DATA (UNINTERPOLATED)
C     WORKBUF(LBX(3)..): CORRESPONDING X LOCATIONS
C     WORKBUF(LBX(5)..): AVG <X> FCN (SEE COMMENTS IN CALLER, PRESYM)
C
C   OUTPUT (COMMON):
C     WORKBUF(LBX(7)..): DATA INTERPOLATED TO PTS ZXF(1..INXF)
C     WORKBUF(LBX(8)..): INTERPOLATED "EXPERIMENTAL FLUX SURFACE SHIFT"
C                       AT EACH PT ZXF(IX)
C
C---------
C
      SUBROUTINE TDB_PRFINS(d,zr1,zr2,IMAP,INUMR,ZXF,INXF)
C
      use trdatbuf_obj
      IMPLICIT NONE

      type (trdatbuf) :: d
      real*8, intent(in) :: zr1,zr2 ! bdy midplane intercepts

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER inxf,inumr,inm1,i,im1,ix,ix1,ix2,iy1,iy2,is1,is2,ixm1
      integer :: inumleft,imap
      integer :: lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zxf,zx,zlfac,rminrd
!============
      DIMENSION ZXF(INXF)
C
C------------------------------------------------------------
      real*8 :: za_bdy          ! aspect ratio at boundary
      real*8 :: zr0             ! major radius defined from boundary @midplane
      real*8 :: zrmin           ! minor radius defined from boundary @midplane
C
      real*8 :: za1,za2,zx1,zx2 ! aspect ratios; normalized aspect ratios
      real*8 :: zrmj_tmp,zrmn_tmp ! local major and minor radii
C
C------------------------------------------------------------
C
      zr0=(zr1+zr2)/2
      zrmin=(zr2-zr1)/2
      za_bdy=(zr2-zr1)/(zr2+zr1)
C
C   INPUT DATA VALUES MONOTONICALLY **INCREASING**
C   INPUT X PTS MONOTONICALLY **DECREASING**
C
      INM1=INUMR-1
      DO 10 I=1,INM1
         IM1=I-1
         IF(d%WORKBUF(d%LBX(2)+I).LE.d%WORKBUF(d%LBX(2)+IM1)) GO TO 9100
         IF(d%WORKBUF(d%LBX(3)+I).GE.d%WORKBUF(d%LBX(3)+IM1)) GO TO 9100
 10   CONTINUE
C
C  OK-- INSERT DATA IN STANDARD FORM
C
      inumleft=inumr
      DO 50 IX=1,INXF
         ZX=ZXF(IX)
C
         DO 40 I=inumleft,2,-1
C  ADRESSES  X, DATA(X), SHIFT(DATA(X))
            IX1=d%LBX(3)+I-1
            IX2=IX1-1
            IY1=d%LBX(2)+I-1
            IY2=IY1-1
            IS1=d%LBX(5)+I-1
            IS2=IS1-1
C
            zrmn_tmp=zrmin*d%workbuf(ix1)
            if(imap.eq.1) then
               zx1=zrmn_tmp/zrmin
            else
               zrmj_tmp=zrmin*d%workbuf(is1)+zr0
               za1=zrmn_tmp/zrmj_tmp
               zx1=za1/za_bdy
            endif
C
            zrmn_tmp=zrmin*d%workbuf(ix2)
            if(imap.eq.1) then
               zx2=zrmn_tmp/zrmin
            else
               zrmj_tmp=zrmin*d%workbuf(is2)+zr0
               za2=zrmn_tmp/zrmj_tmp
               zx2=za2/za_bdy
            endif
C
            IF((zx1.LE.ZX).AND.(zx2.GE.ZX))  GO TO 45
 40      CONTINUE
C     PT OUT OF RANGE
         if(ix.eq.inxf) then
            if(abs(zx2-zx).lt.1.0d-5) then
               i=2
               go to 45
            endif
         endif
         write(lunmsg_tdb(0),*) 
     >        '? SR TDB_PRFINS<PROFE2<PROFEX X PT OUT OF RANGE:'
         write(lunmsg_tdb(0),*) ' x-target ',inxf,zxf(1:inxf)
         GO TO 9500
C--/OK
 45      CONTINUE
C
         inumleft=i
         ZLFAC=(ZX-ZX1)/(ZX2-ZX1)
C
         IXM1=IX-1
         d%WORKBUF(d%LBX(7)+IXM1)=
     >        d%WORKBUF(IY1)+(d%WORKBUF(IY2)-d%WORKBUF(IY1))*ZLFAC
C  STORE DEDUCED SHAFRANOV SHIFT
         d%WORKBUF(d%LBX(8)+IXM1)=zrmin*
     >        (d%WORKBUF(IS1)+(d%WORKBUF(IS2)-d%WORKBUF(IS1))*ZLFAC)
 50   CONTINUE
      RETURN
C------
C  ERRORS
C
 9100 CONTINUE
      write(lunmsg_tdb(0),*) 
     >  '? SR TDB_PRFINS<PROFE2<PROFEX MONOTONICITY VIOLATION'
 9500 CONTINUE
      write(lunmsg_tdb(0),*) 'WORKBUF:F',inumr,
     >     d%WORKBUF(d%LBX(2):d%LBX(2)+inumr-1)
      write(lunmsg_tdb(0),*) 'WORKBUF:X',inumr,
     >     d%WORKBUF(d%LBX(3):d%LBX(2)+inumr-1)
      call bad_exit   
C
      END

subroutine mds_wr_source_shot(ztok,nshot,istat)

  ! write SOURCE_SHOT
  ! but if ztok = "CMOD" and SOURCE_SHOT is already defined, do not overwrite!

  implicit NONE

  character*(*), intent(in) :: ztok
  integer, intent(in) :: nshot

  integer, intent(out) :: istat  ! MDS style, return =1 for normal exit

  !---------------------------------------------
  character*4 ztoka
  integer :: idescr_long,ishot,ilun,jstat,isize
  integer :: mds_value  ! mdstransp
  integer :: MdsPut     ! native MDSplus
  integer :: lnout  ! ureadsub LUN function
  !---------------------------------------------

  istat = 1  ! default: no error

  ztoka=ztok
  call uupper(ztoka)

  if(ztoka.eq.'CMOD') then
     ilun = lnout(0)
     jstat = mds_value(':SOURCE_SHOT',idescr_long(ISHOT),isize)

     if (mod(jstat,2).eq.1) then
        if(ishot.gt.0) then
           write(ilun,*) ' CMOD tree SOURCE_SHOT = ',ishot,' not changed.'
           RETURN
        else
           write(ilun,*) ' CMOD tree SOURCE_SHOT = ',ishot,' reset to: ',nshot
        endif
     else
        write(ilun,*) ' CMOD tree SOURCE_SHOT could not be read; set to: ',nshot
     endif
  endif

  istat = MdsPut('SOURCE_SHOT'//CHAR(0),'$'//CHAR(0),idescr_long(nshot),0, &
       isize)

end subroutine mds_wr_source_shot

subroutine trx_msgs(lun,zfile)
!
!  redirect warning and error messages to the indicated lun & file.
!  if the file on lun has already been opened, pass zfile = ' '
!
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer lun           ! fortran lun for messages (input)
  character*(*) zfile   ! file for messages, or blank (input)
!
!-------------------------------
  integer ierr
!
  call eqm_msgs(lun,zfile,ierr)
  if(ierr.ne.0) then
     write(lun,*) ' ?trx_msgs:  eqm_msgs returned ierr = ',ierr
  endif
!
  call plc_msgs(lun,' ')
!
  return
end subroutine trx_msgs

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_5(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pelh_src
        w%list_elems(isize) = "pelh_src"
        w%elem_descr(isize) = "LH electron heating by antenna"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_lhrf-1,nlhrf_src)"
        IF(ALLOCATED(ss%pelh_src)) THEN
           IF(ss%hash_codes(ps_phash_pelh_src).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_anom
        w%list_elems(isize) = "pe_anom"
        w%elem_descr(isize) = "anomalous electron heating"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_anomth-1)"
        IF(ALLOCATED(ss%pe_anom)) THEN
           IF(ss%hash_codes(ps_phash_pe_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_trans
        w%list_elems(isize) = "pe_trans"
        w%elem_descr(isize) = "electron transport (loss) power"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%pe_trans)) THEN
           IF(ss%hash_codes(ps_phash_pe_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_transcat
        w%list_elems(isize) = "pe_transcat"
        w%elem_descr(isize) = "electron transport"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1,ntrcat)"
        IF(ALLOCATED(ss%pe_transcat)) THEN
           IF(ss%hash_codes(ps_phash_pe_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfuse
        w%list_elems(isize) = "pfuse"
        w%elem_descr(isize) = "electron heating by all fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_fus-1)"
        IF(ALLOCATED(ss%pfuse)) THEN
           IF(ss%hash_codes(ps_phash_pfuse).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfusi
        w%list_elems(isize) = "pfusi"
        w%elem_descr(isize) = "thermal ion heating by all fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_fus-1)"
        IF(ALLOCATED(ss%pfusi)) THEN
           IF(ss%hash_codes(ps_phash_pfusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfusth
        w%list_elems(isize) = "pfusth"
        w%elem_descr(isize) = "thermalization of fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_fus-1)"
        IF(ALLOCATED(ss%pfusth)) THEN
           IF(ss%hash_codes(ps_phash_pfusth).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! phiflux_ky_tglf
        w%list_elems(isize) = "phiflux_ky_tglf"
        w%elem_descr(isize) = "momentum fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%phiflux_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_phiflux_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! phit
        w%list_elems(isize) = "phit"
        w%elem_descr(isize) = "toroidal flux vs. rho"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "Wb"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%phit)) THEN
           IF(ss%hash_codes(ps_phash_phit).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_nphi_srcs
        w%list_elems(isize) = "picrf_nphi_srcs"
        w%elem_descr(isize) = "direct ICRF power deposition"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1,max_num_nphi,nicrf_src,0:nspec_alla)"
        IF(ALLOCATED(ss%picrf_nphi_srcs)) THEN
           IF(ss%hash_codes(ps_phash_picrf_nphi_srcs).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_srcs
        w%list_elems(isize) = "picrf_srcs"
        w%elem_descr(isize) = "direct ICRF power deposition"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1,nicrf_src,0:nspec_alla)"
        IF(ALLOCATED(ss%picrf_srcs)) THEN
           IF(ss%hash_codes(ps_phash_picrf_srcs).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_totals
        w%list_elems(isize) = "picrf_totals"
        w%elem_descr(isize) = "direct ICRF power deposition"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1,0:nspec_alla)"
        IF(ALLOCATED(ss%picrf_totals)) THEN
           IF(ss%hash_codes(ps_phash_picrf_totals).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picth
        w%list_elems(isize) = "picth"
        w%elem_descr(isize) = "direct thermal ion heating by ICRF"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%picth)) THEN
           IF(ss%hash_codes(ps_phash_picth).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pilh
        w%list_elems(isize) = "pilh"
        w%elem_descr(isize) = "ion heating by LH"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_lhrf-1)"
        IF(ALLOCATED(ss%pilh)) THEN
           IF(ss%hash_codes(ps_phash_pilh).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pilh_src
        w%list_elems(isize) = "pilh_src"
        w%elem_descr(isize) = "LH ion heating by antenna"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_lhrf-1,nlhrf_src)"
        IF(ALLOCATED(ss%pilh_src)) THEN
           IF(ss%hash_codes(ps_phash_pilh_src).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_anom
        w%list_elems(isize) = "pi_anom"
        w%elem_descr(isize) = "anomalous ion heating"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_anomth-1)"
        IF(ALLOCATED(ss%pi_anom)) THEN
           IF(ss%hash_codes(ps_phash_pi_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_trans
        w%list_elems(isize) = "pi_trans"
        w%elem_descr(isize) = "ion transport (loss) power"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%pi_trans)) THEN
           IF(ss%hash_codes(ps_phash_pi_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_transcat
        w%list_elems(isize) = "pi_transcat"
        w%elem_descr(isize) = "ion transport"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1,ntrcat)"
        IF(ALLOCATED(ss%pi_transcat)) THEN
           IF(ss%hash_codes(ps_phash_pi_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pmine
        w%list_elems(isize) = "pmine"
        w%elem_descr(isize) = "electron heating by minority ions"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%pmine)) THEN
           IF(ss%hash_codes(ps_phash_pmine).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pmini
        w%list_elems(isize) = "pmini"
        w%elem_descr(isize) = "thermal ion heating by minority ions"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%pmini)) THEN
           IF(ss%hash_codes(ps_phash_pmini).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pminth
        w%list_elems(isize) = "pminth"
        w%elem_descr(isize) = "(de)thermalization of minority ions"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%pminth)) THEN
           IF(ss%hash_codes(ps_phash_pminth).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pohme
        w%list_elems(isize) = "pohme"
        w%elem_descr(isize) = "Ohmic heating of electrons"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%pohme)) THEN
           IF(ss%hash_codes(ps_phash_pohme).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pot_ky_tglf
        w%list_elems(isize) = "pot_ky_tglf"
        w%elem_descr(isize) = "potential fluctuation spectrum"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "GB"
        w%c256val(isize) = "(nrho_anomth,nky_anomth)"
        IF(ALLOCATED(ss%pot_ky_tglf)) THEN
           IF(ss%hash_codes(ps_phash_pot_ky_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad
        w%list_elems(isize) = "prad"
        w%elem_descr(isize) = "total radiated power"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_rad-1)"
        IF(ALLOCATED(ss%prad)) THEN
           IF(ss%hash_codes(ps_phash_prad).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_br
        w%list_elems(isize) = "prad_br"
        w%elem_descr(isize) = "bremsstrahlung contribution"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_rad-1)"
        IF(ALLOCATED(ss%prad_br)) THEN
           IF(ss%hash_codes(ps_phash_prad_br).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_cy
        w%list_elems(isize) = "prad_cy"
        w%elem_descr(isize) = "cyclotron radiation contribution"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_rad-1)"
        IF(ALLOCATED(ss%prad_cy)) THEN
           IF(ss%hash_codes(ps_phash_prad_cy).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_li
        w%list_elems(isize) = "prad_li"
        w%elem_descr(isize) = "line radiation contribution"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_rad-1)"
        IF(ALLOCATED(ss%prad_li)) THEN
           IF(ss%hash_codes(ps_phash_prad_li).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psc_halo
        w%list_elems(isize) = "psc_halo"
        w%elem_descr(isize) = "beam halo power: recapture - pb0_halo"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%psc_halo)) THEN
           IF(ss%hash_codes(ps_phash_psc_halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psc_reco
        w%list_elems(isize) = "psc_reco"
        w%elem_descr(isize) = "reco power: recapture - p0_reco"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%psc_reco)) THEN
           IF(ss%hash_codes(ps_phash_psc_reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psipol
        w%list_elems(isize) = "psipol"
        w%elem_descr(isize) = "poloidal flux vs. rho"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "Wb/rad"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%psipol)) THEN
           IF(ss%hash_codes(ps_phash_psipol).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! PsiRZ
        w%list_elems(isize) = "PsiRZ"
        w%elem_descr(isize) = "Psi(R,Z)"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "Wb/rad"
        w%c256val(isize) = "(nr,nz)"
        IF(ALLOCATED(ss%PsiRZ)) THEN
           IF(ss%hash_codes(ps_phash_PsiRZ).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psmom_errck
        w%list_elems(isize) = "psmom_errck"
        w%elem_descr(isize) = "PS moments sum convergence"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%psmom_errck)) THEN
           IF(ss%hash_codes(ps_phash_psmom_errck).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psmom_nc
        w%list_elems(isize) = "psmom_nc"
        w%elem_descr(isize) = "PS moments"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^-2"
        w%c256val(isize) = "(nrho_eq_geo,npsmom)"
        IF(ALLOCATED(ss%psmom_nc)) THEN
           IF(ss%hash_codes(ps_phash_psmom_nc).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! P_eq
        w%list_elems(isize) = "P_eq"
        w%elem_descr(isize) = "equilibrium scalar pressure"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "Pa"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%P_eq)) THEN
           IF(ss%hash_codes(ps_phash_P_eq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qbeami
        w%list_elems(isize) = "qbeami"
        w%elem_descr(isize) = "average beam ion charge"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "C"
        w%c256val(isize) = "(nrho_nbi-1,nspec_beam)"
        IF(ALLOCATED(ss%qbeami)) THEN
           IF(ss%hash_codes(ps_phash_qbeami).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NBEAMI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qcomp_e
        w%list_elems(isize) = "qcomp_e"
        w%elem_descr(isize) = "Compressional electron heating"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qcomp_e)) THEN
           IF(ss%hash_codes(ps_phash_qcomp_e).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_5

subroutine trx_spec_prof(maxn,n_species,iorder,zident,id_array,ierr)
!
!  set up the indicated profiles:
!    zident.eq.'N'  --  densities, for all plasma species
!    zident.eq.'T'  --  temperatures, for all plasma species
!    zident.eq.'<EPERP>' -- average perpendicular energy / particle, all...
!    zident.eq.'<EPLL>' -- average parallel energy / particle, all...
!
!  it is allowed for some or all of the profiles to be already defined.
!
  implicit NONE
!
  integer, intent(in) :: maxn           ! max no. of species expected
  integer, intent(out) :: n_species     ! actual no. of species found
  integer, intent(in) :: iorder         ! fit order (e.g. 1 for Hermite)
  character*(*), intent(in) :: zident   ! "N" or "T" or "<EPERP>" or "<EPLL>"
!    (case insensitive test is used)
!
  integer, intent(out) :: id_array(maxn)  ! ids of indicated profiles
  integer, intent(out) :: ierr          ! completion code, 0=OK
!
!----------------------------------
!
  character*20, dimension(:), allocatable :: slbl
  character*10, dimension(:,:), allocatable :: abray
  integer, dimension(:), allocatable :: ifast,itype,izc
  real, dimension(:), allocatable :: aar4,zzr4
  integer :: i,id=0,idum,iwarn,lunzer
  real*8 factor,offset
  character*10 ztest
  character*16 zunits
  character*20 zname
  logical :: iexist
!
!----------------------------------
!  check number of species available...
!
  id_array=0
  call trx_nspec(n_species)
  if(n_species.eq.0) then
     ierr=1
     return
  endif
  if(n_species.gt.maxn) then
     write(lunzer(0),*) '?trx_spec_prof:  maxn=',maxn,' but: n_species=', &
          n_species
     n_species=0
     ierr=1
     return
  endif
!
!  allocate arrays, get species information, with trread call...
!
  allocate(slbl(n_species))
  allocate(abray(4,n_species))
  allocate(ifast(n_species),itype(n_species),izc(n_species))
  allocate(aar4(n_species),zzr4(n_species))
!
  call rd_species(n_species,idum,slbl,abray,itype,ifast,zzr4,aar4,izc)
!
  ztest=zident
  call uupper(ztest)       ! uppercase conversion (just in case)
!
  do i=1,n_species
     if(ztest.eq.'N') then
!
!  get densities
!
        call eq_gfnum(abray(1,i),id)
        if(id.ne.0) then
           continue        ! accept the old definition
        else
           call trx_prof(abray(1,i),zunits,iorder,id,ierr)
           if(ierr.ne.0) then
              write(lunzer(0),*) '?trx_spec_prof:  trx_prof error on: ', &
                   abray(1,i)
              exit
           endif
        endif
 
     else if(ztest.eq.'T') then
!
!  get temperatures.  for ifast(i).eq.1, convert from <E>
!
        call eq_gfnum(abray(2,i),id)
        if(id.ne.0) then
           continue        ! accept the old definition
        else
           call trx_prof(abray(2,i),zunits,iorder,id,ierr)
           if(ierr.ne.0) then
              write(lunzer(0),*) '?trx_spec_prof:  trx_prof error on: ', &
                   abray(2,i)
              exit
           endif
        endif
!
!  T = 2/3<E>
!
        if(ifast(i).eq.1) then
           idum=id
           zname='T23_'//abray(2,i)
           call eq_gfnum(zname,id)
           if(id.eq.0) then
              factor=2.0d0/3.0d0
              offset=0.0d0
              call trx_lintrans(idum,factor,offset,zname,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_lintrans error on: ',zname
                 exit
              endif
           endif
        endif
!
     else if(ztest.eq.'<EPERP>') then
!
!  <Eperp>
!
        if(ifast(i).eq.0) then
!  thermal population:  <Eperp>=T
           call eq_gfnum(abray(2,i),id)
           if(id.ne.0) then
              continue        ! accept the old definition
           else
              call trx_prof(abray(2,i),zunits,iorder,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_prof error on: ',abray(2,i)
                 exit
              endif
           endif
        else if(ifast(i).eq.1) then
!  beam or fusion product
!  transp/rplot calculator expression => <Eperp>, EV
           zname='E_'//abray(3,i)
           call eq_gfnum(zname,id)
           if(id.eq.0) then
              call rpexist_profile(zname,iexist)
              if(.NOT.iexist) then
                 call trx_calc(zname,'Eperp','EV', &
                      abray(3,i)//'*'//abray(1,i)// &
                      '/(1.602e-19*max(1,'//abray(1,i)//'**2))', &
                      iwarn,ierr)
                 if(ierr.ne.0) then
                    write(lunzer(0),*) &
                         '?trx_spec_prof:  trx_calc error on: ',abray(3,i)
                    exit
                 endif
              endif
              call trx_prof(zname,zunits,iorder,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_prof error on: '//zname
                 exit
              endif
           endif
        else if(ifast(i).eq.2) then
!  RF tail:  just use the function
           call eq_gfnum(abray(3,i),id)
           if(id.ne.0) then
              continue        ! accept the old definition
           else
              call trx_prof(abray(3,i),zunits,iorder,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_prof error on: ',abray(3,i)
                 exit
              endif
           endif
        endif
     else if(ztest.eq.'<EPLL>') then
!
!  <Epll>
!
        if(ifast(i).eq.0) then
!  thermal population:  <Epll>=0.5*T
           zname='Epll_'//abray(2,i)
           call eq_gfnum(zname,id)
           if(id.ne.0) then
              continue        ! accept the old definition
           else
              call eq_gfnum(abray(2,i),id)
              if(id.eq.0) then
                 call trx_prof(abray(2,i),zunits,iorder,id,ierr)
                 if(ierr.ne.0) then
                    write(lunzer(0),*) &
                         '?trx_spec_prof: trx_prof error on: Epll_'//abray(2,i)
                    exit
                 endif
              endif
              idum=id
              factor=1.0d0/2.0d0
              offset=0.0d0
              call trx_lintrans(idum,factor,offset,zname,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_lintrans error on: ',zname
                 exit
              endif
           endif
        else if(ifast(i).eq.1) then
!  beam or fusion product
!  transp/rplot calculator expression => <Epll>, EV
           zname='E_'//abray(4,i)
           call eq_gfnum(zname,id)
           if(id.eq.0) then
              call rpexist_profile(zname,iexist)
              if(.NOT.iexist) then
                 call trx_calc(zname,'Epll','EV', &
                      abray(4,i)//'*'//abray(1,i)// &
                      '/(1.602e-19*max(1,'//abray(1,i)//'**2))', &
                      iwarn,ierr)
                 if(ierr.ne.0) then
                    write(lunzer(0),*) &
                         '?trx_spec_prof:  trx_calc error on: ',abray(4,i)
                    exit
                 endif
              endif
              call trx_prof(zname,zunits,iorder,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_prof error on: ',zname
                 exit
              endif
           endif
        else if(ifast(i).eq.2) then
!  RF tail:  just use the function
           call eq_gfnum(abray(4,i),id)
           if(id.ne.0) then
              continue        ! accept the old definition
           else
              call trx_prof(abray(4,i),zunits,iorder,id,ierr)
              if(ierr.ne.0) then
                 write(lunzer(0),*) &
                      '?trx_spec_prof:  trx_prof error on: ',abray(4,i)
                 exit
              endif
           endif
        endif
     else
        ierr=1
        write(lunzer(0),*) '?trx_spec_prof: ident unknown: ',zident
        exit
     endif
!
     id_array(i)=id
!
  enddo
!
  deallocate(slbl,abray)
  deallocate(ifast,itype,izc)
  deallocate(aar4,zzr4)
!
  return
!
end subroutine trx_spec_prof

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_7(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%Rloc_coil)) THEN
     status = nf90_inq_varid(icdf,"Rloc_coil",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Rloc_coil")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Rloc_coil)
        IF(status.NE.NF90_NOERR) THEN
           ss%Rloc_coil = 0.0_rspec
           CALL ncerr_name(2,status,"Rloc_coil")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Rmajor_mean)) THEN
     status = nf90_inq_varid(icdf,"Rmajor_mean",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Rmajor_mean")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Rmajor_mean)
        IF(status.NE.NF90_NOERR) THEN
           ss%Rmajor_mean = 0.0_rspec
           CALL ncerr_name(2,status,"Rmajor_mean")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rMinor_mean)) THEN
     status = nf90_inq_varid(icdf,"rMinor_mean",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rMinor_mean")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rMinor_mean)
        IF(status.NE.NF90_NOERR) THEN
           ss%rMinor_mean = 0.0_rspec
           CALL ncerr_name(2,status,"rMinor_mean")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RUNAWAY_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"RUNAWAY_Code_Info")
  ELSE
     ilen = len(ss%RUNAWAY_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%RUNAWAY_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%RUNAWAY_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%RUNAWAY_Code_Info = " "
        CALL ncerr_name(2,status,"RUNAWAY_Code_Info")
     ELSE
        CALL denull(ss%RUNAWAY_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RunID",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"RunID")
  ELSE
     ilen = len(ss%RunID)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%RunID = " "
     status = nf90_get_var(icdf,varid,ss%RunID(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%RunID = " "
        CALL ncerr_name(2,status,"RunID")
     ELSE
        CALL denull(ss%RunID)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_ant)) THEN
     status = nf90_inq_varid(icdf,"R_ant",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_ant")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_ant)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_ant = 0.0_rspec
           CALL ncerr_name(2,status,"R_ant")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_antgeo)) THEN
     status = nf90_inq_varid(icdf,"R_antgeo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_antgeo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_antgeo)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_antgeo = 0.0_rspec
           CALL ncerr_name(2,status,"R_antgeo")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_axis",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"R_axis")
  ELSE
     status = nf90_get_var(icdf,varid,ss%R_axis)
     IF(status.NE.NF90_NOERR) THEN
        ss%R_axis = 0.0_rspec
        CALL ncerr_name(2,status,"R_axis")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"R_EC_launch",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_EC_launch")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_EC_launch)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_EC_launch = 0.0_rspec
           CALL ncerr_name(2,status,"R_EC_launch")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_geo)) THEN
     status = nf90_inq_varid(icdf,"R_geo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_geo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_geo)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_geo = 0.0_rspec
           CALL ncerr_name(2,status,"R_geo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_grid)) THEN
     status = nf90_inq_varid(icdf,"R_grid",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_grid")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_grid)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_grid = 0.0_rspec
           CALL ncerr_name(2,status,"R_grid")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_box",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"R_max_box")
  ELSE
     status = nf90_get_var(icdf,varid,ss%R_max_box)
     IF(status.NE.NF90_NOERR) THEN
        ss%R_max_box = 0.0_rspec
        CALL ncerr_name(2,status,"R_max_box")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"R_max_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%R_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%R_max_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"R_max_lcfs")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_midp_in)) THEN
     status = nf90_inq_varid(icdf,"R_midp_in",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_midp_in")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_midp_in)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_midp_in = 0.0_rspec
           CALL ncerr_name(2,status,"R_midp_in")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_midp_out)) THEN
     status = nf90_inq_varid(icdf,"R_midp_out",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_midp_out")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_midp_out)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_midp_out = 0.0_rspec
           CALL ncerr_name(2,status,"R_midp_out")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_box",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"R_min_box")
  ELSE
     status = nf90_get_var(icdf,varid,ss%R_min_box)
     IF(status.NE.NF90_NOERR) THEN
        ss%R_min_box = 0.0_rspec
        CALL ncerr_name(2,status,"R_min_box")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_lcfs",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"R_min_lcfs")
  ELSE
     status = nf90_get_var(icdf,varid,ss%R_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        ss%R_min_lcfs = 0.0_rspec
        CALL ncerr_name(2,status,"R_min_lcfs")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_ripple)) THEN
     status = nf90_inq_varid(icdf,"R_ripple",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_ripple")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_ripple)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_ripple = 0.0_rspec
           CALL ncerr_name(2,status,"R_ripple")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_surfMax)) THEN
     status = nf90_inq_varid(icdf,"R_surfMax",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_surfMax")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_surfMax)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_surfMax = 0.0_rspec
           CALL ncerr_name(2,status,"R_surfMax")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R_surfMin)) THEN
     status = nf90_inq_varid(icdf,"R_surfMin",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R_surfMin")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R_surfMin)
        IF(status.NE.NF90_NOERR) THEN
           ss%R_surfMin = 0.0_rspec
           CALL ncerr_name(2,status,"R_surfMin")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco)) THEN
     status = nf90_inq_varid(icdf,"s0reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"s0reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%s0reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%s0reco = 0.0_rspec
           CALL ncerr_name(2,status,"s0reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco_e)) THEN
     status = nf90_inq_varid(icdf,"s0reco_e",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"s0reco_e")
     ELSE
        status = nf90_get_var(icdf,varid,ss%s0reco_e)
        IF(status.NE.NF90_NOERR) THEN
           ss%s0reco_e = 0.0_rspec
           CALL ncerr_name(2,status,"s0reco_e")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s0reco_recap)) THEN
     status = nf90_inq_varid(icdf,"s0reco_recap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"s0reco_recap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%s0reco_recap)
        IF(status.NE.NF90_NOERR) THEN
           ss%s0reco_recap = 0.0_rspec
           CALL ncerr_name(2,status,"s0reco_recap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sa_index)) THEN
     status = nf90_inq_varid(icdf,"sa_index",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sa_index")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sa_index)
        IF(status.NE.NF90_NOERR) THEN
           ss%sa_index = 0
           CALL ncerr_name(2,status,"sa_index")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SA_name)) THEN
     status = nf90_inq_varid(icdf,"SA_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SA_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SA_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SA_name = " "
           CALL ncerr_name(2,status,"SA_name")
        ELSE
           CALL denull_vec(ss%SA_name,ss%nspec_tha+1)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SA_type)) THEN
     status = nf90_inq_varid(icdf,"SA_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SA_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SA_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SA_type = 0
           CALL ncerr_name(2,status,"SA_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sb0halo)) THEN
     status = nf90_inq_varid(icdf,"sb0halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sb0halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sb0halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%sb0halo = 0.0_rspec
           CALL ncerr_name(2,status,"sb0halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sb0halo_recap)) THEN
     status = nf90_inq_varid(icdf,"sb0halo_recap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sb0halo_recap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sb0halo_recap)
        IF(status.NE.NF90_NOERR) THEN
           ss%sb0halo_recap = 0.0_rspec
           CALL ncerr_name(2,status,"sb0halo_recap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbedep)) THEN
     status = nf90_inq_varid(icdf,"sbedep",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sbedep")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sbedep)
        IF(status.NE.NF90_NOERR) THEN
           ss%sbedep = 0.0_rspec
           CALL ncerr_name(2,status,"sbedep")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbehalo)) THEN
     status = nf90_inq_varid(icdf,"sbehalo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sbehalo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sbehalo)
        IF(status.NE.NF90_NOERR) THEN
           ss%sbehalo = 0.0_rspec
           CALL ncerr_name(2,status,"sbehalo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbsce)) THEN
     status = nf90_inq_varid(icdf,"sbsce",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sbsce")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sbsce)
        IF(status.NE.NF90_NOERR) THEN
           ss%sbsce = 0.0_rspec
           CALL ncerr_name(2,status,"sbsce")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sbtherm)) THEN
     status = nf90_inq_varid(icdf,"sbtherm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sbtherm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sbtherm)
        IF(status.NE.NF90_NOERR) THEN
           ss%sbtherm = 0.0_rspec
           CALL ncerr_name(2,status,"sbtherm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc0)) THEN
     status = nf90_inq_varid(icdf,"sc0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sc0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sc0)
        IF(status.NE.NF90_NOERR) THEN
           ss%sc0 = 0.0_rspec
           CALL ncerr_name(2,status,"sc0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc0_to_sgas)) THEN
     status = nf90_inq_varid(icdf,"sc0_to_sgas",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sc0_to_sgas")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sc0_to_sgas)
        IF(status.NE.NF90_NOERR) THEN
           ss%sc0_to_sgas = 0
           CALL ncerr_name(2,status,"sc0_to_sgas")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sc_anom)) THEN
     status = nf90_inq_varid(icdf,"sc_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sc_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sc_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%sc_anom = 0.0_rspec
           CALL ncerr_name(2,status,"sc_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfsce)) THEN
     status = nf90_inq_varid(icdf,"sfsce",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sfsce")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sfsce)
        IF(status.NE.NF90_NOERR) THEN
           ss%sfsce = 0.0_rspec
           CALL ncerr_name(2,status,"sfsce")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sftherm)) THEN
     status = nf90_inq_varid(icdf,"sftherm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sftherm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sftherm)
        IF(status.NE.NF90_NOERR) THEN
           ss%sftherm = 0.0_rspec
           CALL ncerr_name(2,status,"sftherm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SFUS_name)) THEN
     status = nf90_inq_varid(icdf,"SFUS_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SFUS_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SFUS_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SFUS_name = " "
           CALL ncerr_name(2,status,"SFUS_name")
        ELSE
           CALL denull_vec(ss%SFUS_name,ss%nspec_fusion)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfus_to_all)) THEN
     status = nf90_inq_varid(icdf,"sfus_to_all",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sfus_to_all")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sfus_to_all)
        IF(status.NE.NF90_NOERR) THEN
           ss%sfus_to_all = 0
           CALL ncerr_name(2,status,"sfus_to_all")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sfus_to_alla)) THEN
     status = nf90_inq_varid(icdf,"sfus_to_alla",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sfus_to_alla")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sfus_to_alla)
        IF(status.NE.NF90_NOERR) THEN
           ss%sfus_to_alla = 0
           CALL ncerr_name(2,status,"sfus_to_alla")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SFUS_type)) THEN
     status = nf90_inq_varid(icdf,"SFUS_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SFUS_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SFUS_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SFUS_type = 0
           CALL ncerr_name(2,status,"SFUS_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SGAS_name)) THEN
     status = nf90_inq_varid(icdf,"SGAS_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SGAS_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SGAS_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SGAS_name = " "
           CALL ncerr_name(2,status,"SGAS_name")
        ELSE
           CALL denull_vec(ss%SGAS_name,ss%nspec_gas)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sgas_to_s)) THEN
     status = nf90_inq_varid(icdf,"sgas_to_s",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sgas_to_s")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sgas_to_s)
        IF(status.NE.NF90_NOERR) THEN
           ss%sgas_to_s = 0
           CALL ncerr_name(2,status,"sgas_to_s")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SGAS_type)) THEN
     status = nf90_inq_varid(icdf,"SGAS_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SGAS_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SGAS_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SGAS_type = 0
           CALL ncerr_name(2,status,"SGAS_type")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"shot_number",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"shot_number")
  ELSE
     status = nf90_get_var(icdf,varid,ss%shot_number)
     IF(status.NE.NF90_NOERR) THEN
        ss%shot_number = ps_unInit
        CALL ncerr_name(2,status,"shot_number")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sii_xs)) THEN
     status = nf90_inq_varid(icdf,"sii_xs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sii_xs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sii_xs)
        IF(status.NE.NF90_NOERR) THEN
           ss%sii_xs = 0.0_rspec
           CALL ncerr_name(2,status,"sii_xs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMP0_name)) THEN
     status = nf90_inq_varid(icdf,"SIMP0_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SIMP0_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SIMP0_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SIMP0_name = " "
           CALL ncerr_name(2,status,"SIMP0_name")
        ELSE
           CALL denull_vec(ss%SIMP0_name,ss%nspec_imp0)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%simp0_to_s)) THEN
     status = nf90_inq_varid(icdf,"simp0_to_s",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"simp0_to_s")
     ELSE
        status = nf90_get_var(icdf,varid,ss%simp0_to_s)
        IF(status.NE.NF90_NOERR) THEN
           ss%simp0_to_s = 0
           CALL ncerr_name(2,status,"simp0_to_s")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMP0_type)) THEN
     status = nf90_inq_varid(icdf,"SIMP0_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SIMP0_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SIMP0_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SIMP0_type = 0
           CALL ncerr_name(2,status,"SIMP0_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMPI_name)) THEN
     status = nf90_inq_varid(icdf,"SIMPI_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SIMPI_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SIMPI_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SIMPI_name = " "
           CALL ncerr_name(2,status,"SIMPI_name")
        ELSE
           CALL denull_vec(ss%SIMPI_name,ss%nspec_impi)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%simpi_to_s)) THEN
     status = nf90_inq_varid(icdf,"simpi_to_s",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"simpi_to_s")
     ELSE
        status = nf90_get_var(icdf,varid,ss%simpi_to_s)
        IF(status.NE.NF90_NOERR) THEN
           ss%simpi_to_s = 0
           CALL ncerr_name(2,status,"simpi_to_s")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SIMPI_type)) THEN
     status = nf90_inq_varid(icdf,"SIMPI_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SIMPI_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SIMPI_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SIMPI_type = 0
           CALL ncerr_name(2,status,"SIMPI_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SNBI_name)) THEN
     status = nf90_inq_varid(icdf,"SNBI_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SNBI_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SNBI_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%SNBI_name = " "
           CALL ncerr_name(2,status,"SNBI_name")
        ELSE
           CALL denull_vec(ss%SNBI_name,ss%nspec_beam)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%snbi_to_all)) THEN
     status = nf90_inq_varid(icdf,"snbi_to_all",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"snbi_to_all")
     ELSE
        status = nf90_get_var(icdf,varid,ss%snbi_to_all)
        IF(status.NE.NF90_NOERR) THEN
           ss%snbi_to_all = 0
           CALL ncerr_name(2,status,"snbi_to_all")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%snbi_to_alla)) THEN
     status = nf90_inq_varid(icdf,"snbi_to_alla",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"snbi_to_alla")
     ELSE
        status = nf90_get_var(icdf,varid,ss%snbi_to_alla)
        IF(status.NE.NF90_NOERR) THEN
           ss%snbi_to_alla = 0
           CALL ncerr_name(2,status,"snbi_to_alla")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%SNBI_type)) THEN
     status = nf90_inq_varid(icdf,"SNBI_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"SNBI_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%SNBI_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%SNBI_type = 0
           CALL ncerr_name(2,status,"SNBI_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sn_trans)) THEN
     status = nf90_inq_varid(icdf,"sn_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sn_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sn_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%sn_trans = 0.0_rspec
           CALL ncerr_name(2,status,"sn_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sn_transcat)) THEN
     status = nf90_inq_varid(icdf,"sn_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sn_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sn_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%sn_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"sn_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sprof0)) THEN
     status = nf90_inq_varid(icdf,"sprof0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sprof0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sprof0)
        IF(status.NE.NF90_NOERR) THEN
           ss%sprof0 = 0.0_rspec
           CALL ncerr_name(2,status,"sprof0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sprof0e)) THEN
     status = nf90_inq_varid(icdf,"sprof0e",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sprof0e")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sprof0e)
        IF(status.NE.NF90_NOERR) THEN
           ss%sprof0e = 0.0_rspec
           CALL ncerr_name(2,status,"sprof0e")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%spsce)) THEN
     status = nf90_inq_varid(icdf,"spsce",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"spsce")
     ELSE
        status = nf90_get_var(icdf,varid,ss%spsce)
        IF(status.NE.NF90_NOERR) THEN
           ss%spsce = 0.0_rspec
           CALL ncerr_name(2,status,"spsce")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%squareLO)) THEN
     status = nf90_inq_varid(icdf,"squareLO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"squareLO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%squareLO)
        IF(status.NE.NF90_NOERR) THEN
           ss%squareLO = 0.0_rspec
           CALL ncerr_name(2,status,"squareLO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%squareUO)) THEN
     status = nf90_inq_varid(icdf,"squareUO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"squareUO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%squareUO)
        IF(status.NE.NF90_NOERR) THEN
           ss%squareUO = 0.0_rspec
           CALL ncerr_name(2,status,"squareUO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%sRtcen)) THEN
     status = nf90_inq_varid(icdf,"sRtcen",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"sRtcen")
     ELSE
        status = nf90_get_var(icdf,varid,ss%sRtcen)
        IF(status.NE.NF90_NOERR) THEN
           ss%sRtcen = 0.0_rspec
           CALL ncerr_name(2,status,"sRtcen")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%surf)) THEN
     status = nf90_inq_varid(icdf,"surf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"surf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%surf)
        IF(status.NE.NF90_NOERR) THEN
           ss%surf = 0.0_rspec
           CALL ncerr_name(2,status,"surf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%S_name)) THEN
     status = nf90_inq_varid(icdf,"S_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"S_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%S_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%S_name = " "
           CALL ncerr_name(2,status,"S_name")
        ELSE
           CALL denull_vec(ss%S_name,ss%nspec_th+1)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%s_to_sa)) THEN
     status = nf90_inq_varid(icdf,"s_to_sa",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"s_to_sa")
     ELSE
        status = nf90_get_var(icdf,varid,ss%s_to_sa)
        IF(status.NE.NF90_NOERR) THEN
           ss%s_to_sa = 0
           CALL ncerr_name(2,status,"s_to_sa")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%S_type)) THEN
     status = nf90_inq_varid(icdf,"S_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"S_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%S_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%S_type = 0
           CALL ncerr_name(2,status,"S_type")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t0",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"t0")
  ELSE
     status = nf90_get_var(icdf,varid,ss%t0)
     IF(status.NE.NF90_NOERR) THEN
        ss%t0 = 0.0_rspec
        CALL ncerr_name(2,status,"t0")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0cx)) THEN
     status = nf90_inq_varid(icdf,"T0cx",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T0cx")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T0cx)
        IF(status.NE.NF90_NOERR) THEN
           ss%T0cx = 0.0_rspec
           CALL ncerr_name(2,status,"T0cx")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0sc0)) THEN
     status = nf90_inq_varid(icdf,"T0sc0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T0sc0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T0sc0)
        IF(status.NE.NF90_NOERR) THEN
           ss%T0sc0 = 0.0_rspec
           CALL ncerr_name(2,status,"T0sc0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0_halo)) THEN
     status = nf90_inq_varid(icdf,"T0_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T0_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T0_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%T0_halo = 0.0_rspec
           CALL ncerr_name(2,status,"T0_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T0_reco)) THEN
     status = nf90_inq_varid(icdf,"T0_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T0_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T0_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%T0_reco = 0.0_rspec
           CALL ncerr_name(2,status,"T0_reco")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t1",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"t1")
  ELSE
     status = nf90_get_var(icdf,varid,ss%t1)
     IF(status.NE.NF90_NOERR) THEN
        ss%t1 = 0.0_rspec
        CALL ncerr_name(2,status,"t1")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%teflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"teflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"teflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%teflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%teflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"teflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Te_bdy",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Te_bdy")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Te_bdy)
     IF(status.NE.NF90_NOERR) THEN
        ss%Te_bdy = 0.0_rspec
        CALL ncerr_name(2,status,"Te_bdy")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%te_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"te_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"te_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%te_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%te_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"te_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_7

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_2(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! diff_transcat
        w%list_elems(isize) = "diff_transcat"
        w%elem_descr(isize) = "specie diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho,0:nspec_th,ntrcat)"
        IF(ALLOCATED(ss%diff_transcat)) THEN
           IF(ss%hash_codes(ps_phash_diff_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difne_nclass
        w%list_elems(isize) = "difne_nclass"
        w%elem_descr(isize) = "electron-density-equations, neoclassical diffusivity from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%difne_nclass)) THEN
           IF(ss%hash_codes(ps_phash_difne_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnh_nclass
        w%list_elems(isize) = "difnh_nclass"
        w%elem_descr(isize) = "main-hydrogenic-density-equations, neoclassical diffusivity from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%difnh_nclass)) THEN
           IF(ss%hash_codes(ps_phash_difnh_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_anom
        w%list_elems(isize) = "difns_anom"
        w%elem_descr(isize) = "density-equations, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_anom)) THEN
           IF(ss%hash_codes(ps_phash_difns_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_drbm
        w%list_elems(isize) = "difns_drbm"
        w%elem_descr(isize) = "density-equations, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_drbm)) THEN
           IF(ss%hash_codes(ps_phash_difns_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_glf
        w%list_elems(isize) = "difns_glf"
        w%elem_descr(isize) = "density-equations, diffusivity from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_glf)) THEN
           IF(ss%hash_codes(ps_phash_difns_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_gtcneo
        w%list_elems(isize) = "difns_gtcneo"
        w%elem_descr(isize) = "density-equations, neoclassical diffusivity from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_difns_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_mmm71
        w%list_elems(isize) = "difns_mmm71"
        w%elem_descr(isize) = "density-equations, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_difns_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_nclass
        w%list_elems(isize) = "difns_nclass"
        w%elem_descr(isize) = "density-equations, neoclassical diffusivity from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_nclass)) THEN
           IF(ss%hash_codes(ps_phash_difns_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_neo
        w%list_elems(isize) = "difns_neo"
        w%elem_descr(isize) = "density-equations, neoclassical diffusivity from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_neo)) THEN
           IF(ss%hash_codes(ps_phash_difns_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_tglf
        w%list_elems(isize) = "difns_tglf"
        w%elem_descr(isize) = "density-equations, diffusivity from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_tglf)) THEN
           IF(ss%hash_codes(ps_phash_difns_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_w19
        w%list_elems(isize) = "difns_w19"
        w%elem_descr(isize) = "density-equations, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth,0:nspec_th)"
        IF(ALLOCATED(ss%difns_w19)) THEN
           IF(ss%hash_codes(ps_phash_difns_w19).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnx_nclass
        w%list_elems(isize) = "difnx_nclass"
        w%elem_descr(isize) = "main-impurity-density-equations, neoclassical diffusivity from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%difnx_nclass)) THEN
           IF(ss%hash_codes(ps_phash_difnx_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnz_mmm71
        w%list_elems(isize) = "difnz_mmm71"
        w%elem_descr(isize) = "impurity ion diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%difnz_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_difnz_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQedGrdte_tglf
        w%list_elems(isize) = "dQedGrdte_tglf"
        w%elem_descr(isize) = "Te flux gradient term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "1/(m*s)"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%dQedGrdte_tglf)) THEN
           IF(ss%hash_codes(ps_phash_dQedGrdte_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQedGrdti_tglf
        w%list_elems(isize) = "dQedGrdti_tglf"
        w%elem_descr(isize) = "Te flux gradient term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "1/(m*s)"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%dQedGrdti_tglf)) THEN
           IF(ss%hash_codes(ps_phash_dQedGrdti_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQidGrdte_tglf
        w%list_elems(isize) = "dQidGrdte_tglf"
        w%elem_descr(isize) = "Ti flux gradient term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "1/(m*s)"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%dQidGrdte_tglf)) THEN
           IF(ss%hash_codes(ps_phash_dQidGrdte_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQidGrdti_tglf
        w%list_elems(isize) = "dQidGrdti_tglf"
        w%elem_descr(isize) = "Ti flux gradient term from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "1/(m*s)"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%dQidGrdti_tglf)) THEN
           IF(ss%hash_codes(ps_phash_dQidGrdti_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ee_mobility_factor
        w%list_elems(isize) = "ee_mobility_factor"
        w%elem_descr(isize) = "chi_e/chi_i"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%ee_mobility_factor)) THEN
           IF(ss%hash_codes(ps_phash_ee_mobility_factor).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! elong
        w%list_elems(isize) = "elong"
        w%elem_descr(isize) = "elongation (b/a)"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%elong)) THEN
           IF(ss%hash_codes(ps_phash_elong).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_beami
        w%list_elems(isize) = "eperp_beami"
        w%elem_descr(isize) = "beam species <Eperp>, lab frame"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_nbi-1,nspec_beam)"
        IF(ALLOCATED(ss%eperp_beami)) THEN
           IF(ss%hash_codes(ps_phash_eperp_beami).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NBEAMI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_fusi
        w%list_elems(isize) = "eperp_fusi"
        w%elem_descr(isize) = "fusion ion <Eperp>, lab frame"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_fus-1,nspec_fusion)"
        IF(ALLOCATED(ss%eperp_fusi)) THEN
           IF(ss%hash_codes(ps_phash_eperp_fusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NFUSI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_mini
        w%list_elems(isize) = "eperp_mini"
        w%elem_descr(isize) = "minority species <Eperp>, lab frame"
        w%component(isize) = "IC"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_icrf-1,nspec_rfmin)"
        IF(ALLOCATED(ss%eperp_mini)) THEN
           IF(ss%hash_codes(ps_phash_eperp_mini).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NMINI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_rw
        w%list_elems(isize) = "eperp_rw"
        w%elem_descr(isize) = "runaway electron <Eperp>"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_rw-1)"
        IF(ALLOCATED(ss%eperp_rw)) THEN
           IF(ss%hash_codes(ps_phash_eperp_rw).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NRW"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_beami
        w%list_elems(isize) = "epll_beami"
        w%elem_descr(isize) = "beam species <Epll>, lab frame"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_nbi-1,nspec_beam)"
        IF(ALLOCATED(ss%epll_beami)) THEN
           IF(ss%hash_codes(ps_phash_epll_beami).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NBEAMI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_fusi
        w%list_elems(isize) = "epll_fusi"
        w%elem_descr(isize) = "fusion ion <Epll>, lab frame"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_fus-1,nspec_fusion)"
        IF(ALLOCATED(ss%epll_fusi)) THEN
           IF(ss%hash_codes(ps_phash_epll_fusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NFUSI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_mini
        w%list_elems(isize) = "epll_mini"
        w%elem_descr(isize) = "minority species <Epll>, lab frame"
        w%component(isize) = "IC"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_icrf-1,nspec_rfmin)"
        IF(ALLOCATED(ss%epll_mini)) THEN
           IF(ss%hash_codes(ps_phash_epll_mini).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NMINI"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_rw
        w%list_elems(isize) = "epll_rw"
        w%elem_descr(isize) = "runaway electron <Epll>"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho_rw-1)"
        IF(ALLOCATED(ss%epll_rw)) THEN
           IF(ss%hash_codes(ps_phash_epll_rw).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*NRW"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Epot
        w%list_elems(isize) = "Epot"
        w%elem_descr(isize) = "radial electrostatic potential"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%Epot)) THEN
           IF(ss%hash_codes(ps_phash_Epot).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eta_parallel
        w%list_elems(isize) = "eta_parallel"
        w%elem_descr(isize) = "parallel electrical resistivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "ohm*m"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%eta_parallel)) THEN
           IF(ss%hash_codes(ps_phash_eta_parallel).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_bpass_co
        w%list_elems(isize) = "fidiff_bpass_co"
        w%elem_descr(isize) = "fusion ion diffusivity: co barely passing orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_bpass_co)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_bpass_co).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_bpass_ctr
        w%list_elems(isize) = "fidiff_bpass_ctr"
        w%elem_descr(isize) = "fusion ion diffusivity: ctr barely passing orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_bpass_ctr)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_bpass_ctr).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_btrap
        w%list_elems(isize) = "fidiff_btrap"
        w%elem_descr(isize) = "fusion ion diffusivity: barely trapped orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_btrap)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_btrap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dpass_co
        w%list_elems(isize) = "fidiff_dpass_co"
        w%elem_descr(isize) = "fusion ion diffusivity: co passing |vpll/v| -> 1"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_dpass_co)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_dpass_co).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dpass_ctr
        w%list_elems(isize) = "fidiff_dpass_ctr"
        w%elem_descr(isize) = "fusion ion diffusivity: ctr passing |vpll/v| -> 1"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_dpass_ctr)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_dpass_ctr).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dtrap
        w%list_elems(isize) = "fidiff_dtrap"
        w%elem_descr(isize) = "fusion ion diffusivity: deeply trapped orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_fusion)"
        IF(ALLOCATED(ss%fidiff_dtrap)) THEN
           IF(ss%hash_codes(ps_phash_fidiff_dtrap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_2

      REAL*8 function tdb_get_rpld(d,ztime,zRi,zYi,ier)
!
! get TF ripple magnitude in form: log(B~/B)
!
      use trdatbuf_obj
      use tdbsub_uts
      IMPLICIT NONE

      type (trdatbuf) :: d
      REAL*8,intent(in) :: ztime ! time at which to interpolate
      REAL*8,intent(in) :: zRi,zYi ! (R,Y) location, cm
      integer, intent(out) :: ier ! exit code, 0=OK
!
!============
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER isym,indr,indy,i11,i12,i21,i22,ilt,inumt,it
      integer :: lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zr0,zrmax,zy0,zymax,zdr,zdy,zyion,zrion,zda,zdb,zdc
      REAL*8 zdd,zr11,zy11,zp1,zp2,zdbpt,zft
!============
!
!  get ripple data at indicated location; flat extrapolation
!  actually:  log(B~/B)  (natural log)
!
!
!---------------------------------------
!
      tdb_get_rpld=-50.0_R8
      ier=0
      if(min(d%LXRPL,d%LYRPL,d%LRPL).le.0) then
         write(lunmsg_tdb(0),*) 
     >        ' ?tdb_get_rpld:  null pointers for ripple data!'
         return
      endif
!
      ZR0=d%DATBUF(d%LXRPL)
      ZRMAX=d%DATBUF(d%LXRPL+d%NXRPL-1)
      ZY0=d%DATBUF(d%LYRPL)
      ZYMAX=d%DATBUF(d%LYRPL+d%NYRPL-1)
      IF(ABS(ZY0).LE.1.0E-2_R8*ABS(ZYMAX)) THEN
         ISYM=1
      ELSE
         ISYM=0
      ENDIF
!
      ZDR=d%DATBUF(d%LXRPL+1)-ZR0
      ZDY=d%DATBUF(d%LYRPL+1)-ZY0
!
      ZYION=zYi
!
!	SET ZYION=-ZYION IF ION BELOW MIDPLANE
!
      IF((ISYM.EQ.1).AND.(ZYION.LE.0)) ZYION=-ZYION
      ZYION=MAX(ZY0,MIN(ZYMAX,ZYION))
      ZRION=MAX(ZR0,MIN(ZRMAX,zRi))
!
      INDR=1+int((ZRION-ZR0)/ZDR)
      INDR=MAX(1,MIN((d%NXRPL-1),INDR))
      do 
         if(d%datbuf(d%lxrpl+indr-1).gt.ZRION) then
            indr=indr-1
         else if(d%datbuf(d%lxrpl+indr).lt.ZRION) then
            indr=indr+1
         else
            exit
         endif
      enddo

      INDY=1+int((ZYION-ZY0)/ZDY)
      INDY=MAX(1,MIN((d%NYRPL-1),INDY))
      do 
         if(d%datbuf(d%lyrpl+indy-1).gt.ZYION) then
            indy=indy-1
         else if(d%datbuf(d%lyrpl+indy).lt.ZYION) then
            indy=indy+1
         else
            exit
         endif
      enddo

      if(d%mtrpl.eq.1) then

         ilt=d%ltime2
         inumt=d%ntime2
         call tdbsub_lookup(d%datbuf(ilt:ilt+inumt-1),inumt,ztime,
     >        it,zft)

         i11=d%lrpl + (it-1) + d%ntime2*(indR-1) + 
     >        d%ntime2*d%nxrpl*(indY-1)
         I12 = I11 + d%ntime2
         I21 = I11 + d%ntime2*d%nxrpl
         I22 = I21 + d%ntime2

         ZDA = d%DATBUF(I11)*(1-ZFT) + d%DATBUF(I11+1)*ZFT
         ZDB = d%DATBUF(I12)*(1-ZFT) + d%DATBUF(I12+1)*ZFT
         ZDC = d%DATBUF(I21)*(1-ZFT) + d%DATBUF(I21+1)*ZFT
         ZDD = d%DATBUF(I22)*(1-ZFT) + d%DATBUF(I22+1)*ZFT

      else
         ! time invariant...

         I11=(INDY-1)*d%NXRPL+INDR+d%LRPL-1
         I12=I11+1
         I21=I11+d%NXRPL
         I22=I21+1
!
!  FIND LOG OF RIPPLE AT EACH CORNER OF BOX AROUND MC ION
!
         ZDA=d%DATBUF(I11)
         ZDB=d%DATBUF(I12)
         ZDC=d%DATBUF(I21)
         ZDD=d%DATBUF(I22)
      endif
!
! ------------------------------------------------------------------------
!
      ZR11=d%DATBUF(d%LXRPL-1+INDR)
      ZDR =d%DATBUF(d%LXRPL+INDR)-ZR11
      ZY11=d%DATBUF(d%LYRPL-1+INDY)
      ZDY =d%DATBUF(d%LYRPL+INDY)-ZY11
!
      ZP1=(ZRION-ZR11)/ZDR
      ZP2=(ZYION-ZY11)/ZDY
!
      ZDBPT=ZDA+ZP1*(ZDB-ZDA)+(ZDC+(ZDD-ZDC)*ZP1)*ZP2-(ZDA+ZP1
     <   *(ZDB-ZDA))*ZP2
!
      tdb_get_rpld = ZDBPT
!
      return
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_prune_grids(cclist,ss,ierr)

  ! for each component deactivated in cclist(:), remove component grids
  ! and any profiles which use these grids

  ! if the EQ component is deactivated, remove equilibrium-derived quantities.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components
                                !   cclist(j)=0 => remove grids of component j

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,iertmp
  !-------------------

  iout = SWIM_err_out_file

  ierr = 0

  IF(cclist(ps_cnum_EQ).eq.0) call ps_purge_equilibrium(ss%iobj, iout, ierr)


  IF(cclist(ps_cnum_ANOM).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_ANOM,"E_ANOM",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_ANOM).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_ANOM,"E_ANOM2",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_PLASMA).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_PLASMA,"RHO",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_ANOM).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_ANOM,"RHO_ANOM",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_ANOM).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_ANOM,"RHO_ANOM2",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_ANOM).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_ANOM,"RHO_ANOMTH",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EC).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EC,"RHO_ECRF",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EQ).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EQ,"RHO_EQ",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EQ).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EQ,"RHO_EQ_GEO",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_FUS).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_FUS,"RHO_FUS",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_GAS).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_GAS,"RHO_GAS",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_IC).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_IC,"RHO_ICRF",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_LH).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_LH,"RHO_LHRF",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_LMHD).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_LMHD,"RHO_LMHD",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_RAD).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_RAD,"RHO_MIST",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_NBI).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_NBI,"RHO_NBI",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_PEL).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_PEL,"RHO_PEL",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_RAD).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_RAD,"RHO_RAD",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_RUNAWAY).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_RUNAWAY,"RHO_RW",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EQ).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EQ,"R_GRID",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_RIPPLE).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_RIPPLE,"R_RIPPLE",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EQ).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EQ,"TH_EQ",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_EQ).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_EQ,"Z_GRID",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF

  IF(cclist(ps_cnum_RIPPLE).eq.0) THEN
     CALL ps_remove_grid(ss%iobj,ps_cnum_RIPPLE,"Z_RIPPLE",iout,iertmp)
     ierr=MAX(ierr,iertmp)
  ENDIF


END SUBROUTINE plasma_state_prune_grids

!  trx_scal -- get conversion factor, read & scale scalar
!  trx_kscal -- read & scale scalar
!  trxc_scal -- C interface to trx_scal
!  trxc_kscal -- C interface to trxc_scal
!
!--------------------------------------------------------------------
!  get units conversion, then, read & scale scalar (trx_kscal,
!  below)
!
subroutine trx_scal(zname,zuns_mks,zval,ierr)
 
  use trx_module
  implicit NONE
 
! ...arguments
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zname          ! name of desired scalar
  character(*), intent(out) :: zuns_mks      ! mks units label of profile
  real*8, intent(out)        :: zval         ! scalar value returned
  integer, intent(out)     :: ierr           ! completion code, 0=OK
 
! ...local
 
  real*8                   :: zconv          ! units conversion factor
  integer                  :: iwarn          ! units conversion warning
 
! ------------------------------
 
  call trx_mks_conv(zname,zconv,zuns_mks,iwarn)
  call trx_kscal(zname,zconv,zval,ierr)
 
  return
end subroutine trx_scal
!--------------------------------------------------------------------
!  read a TRANSP scalar & interpolate/extrapolate to flux surfaces
!  from zone centers if necessary; scale by units conversion factor
!
subroutine trx_kscal(zname,zconv,zval,ierr)
 
  use trx_module
  implicit NONE
 
! ...arguments
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zname          ! name of desired scalar
  real*8, intent(in)       :: zconv          ! units conversion factor
  real*8, intent(out)      :: zval           ! scalar value returned
  integer, intent(out)     :: ierr           ! completion code, 0=OK
 
! ...local
!
  character(64) :: zlabel            ! label
  character(32) :: zunits            ! units
!
  integer :: istype                  ! type code
  integer :: lunzer
!
  real zvalr4
! ------------------------------
!
  call trx_ready('trx_scal',ierr)
  if(ierr.ne.0) return
!
  call t1scalar(zname,zlabel,zunits,time0,delta_t, zvalr4, ierr)
  zval=zvalr4*zconv
!
  return
end subroutine trx_kscal

C---------------------------------------------------------------
C  TDB_PRFNXX
C   FIND NEXT INTERSECTION OF LINE Y=CONSTANT IN PROFILE Y(X)
C
      SUBROUTINE TDB_PRFNXX(ZY,ZX,INUM,ZYC,ZX1,ZX2,IFOUND)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER inum,ifound,i,istart,ilast,ip1,i2
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zx,zyc,zx1,zx2,zy,zmax
!============
      DIMENSION ZY(INUM),ZX(INUM)
C
C  ZY,ZX (INUM)  INPUT PROFILE
C   ZYC  CONSTANT Y VALUE.  LOOK FOR INTERSECTIONS OF PROFILE WITH
C        LINE Y=ZYC (INPUT)
C   ZX1  INPUT STARTING LOCATION FOR SEARCH
C   ZX2  OUTPUT INTERSECTION LOCATED
C IFOUND OUTPUT =1 IF INTERSECTION FOUND, 0 OTHERWISE
C
      zx2=zx1
      IFOUND=0
C  RETURN ZX2=ZX1 IF ZYC= THE MAXIMUM IN THE PROFILE
      ZMAX=ZY(1)
      DO 5 I=1,INUM
      ZMAX=max(ZMAX,ZY(I))
 5    CONTINUE
      IF(ZMAX.NE.ZYC) GO TO 7
      IFOUND=1
      ZX2=ZX1
      GOTO 1000
C
 7    CONTINUE
C
C  LOCATE STARTING INDEX
      DO 10 I=1,INUM
      IF(ZX(I).GT.ZX1) GO TO 20
 10   CONTINUE
C  NO SUCH POINT
      GOTO 1000
 20   CONTINUE
      ISTART=I
C  CANNOT START AT END
      IF(ISTART.EQ.INUM) GOTO 1000
C
      ILAST=INUM-1
C
C  SCAN FOR INTERSECTIONS
C
      DO 30 I=ISTART,ILAST
      IP1=I+1
      IF((ZY(I).GT.ZYC).AND.(ZY(IP1).LE.ZYC)) GO TO 35
      IF((ZY(I).LT.ZYC).AND.(ZY(IP1).GE.ZYC)) GO TO 35
      GO TO 30
C  CHECK THAT POINT ZY(IP1) NOT A LOCAL SINGULARITY
 35   CONTINUE
      IF(ZY(IP1).NE.ZYC) GO TO 40
      IF(IP1.EQ.INUM) GO TO 40
      I2=IP1+1
      IF(ZY(IP1).EQ.ZY(I2)) I2=min(INUM,I2+1)
C  IGNORE INTERSECTION IF IT IS JUST "KISSING" A LOCAL EXTREMUM
      IF((ZY(I).GT.ZY(IP1)).AND.(ZY(I2).GT.ZY(IP1))) GO TO 30
      IF((ZY(I).LT.ZY(IP1)).AND.(ZY(I2).LT.ZY(IP1))) GO TO 30
      GO TO 40
C
 30   CONTINUE
C  NO SUCH POINT
      GOTO 1000
C  INTERSECTION FOUND
 40   CONTINUE
      IFOUND=1
      IF(ZY(I).NE.ZY(IP1)) GO TO 50
      ZX2=ZX(IP1)
      GOTO 1000
C
 50   CONTINUE
      ZX2=ZX(I)+(ZX(IP1)-ZX(I))*(ZY(I)-ZYC)/(ZY(I)-ZY(IP1))
      GOTO 1000
C-------
 1000 continue
cdbg      write(6,1001) zyc,zx1,zx2,ifound
cdbg 1001 format(' TDB_PRFNXX zyc=',1x,1pe13.6,' zx1,zx2=',2(1x,1pe13.6),
cdbg     >   ' ifound = ',i2)
      return
C
      	END

 
!
! ------------------- wr_doublearr -----------------
!
! put a real*8 array into the tree
!
subroutine wr_doublearr(ilun, mds_path, name, value, nvalue, ier)
 
  implicit none
 
  integer,       intent(in)    :: ilun         ! logical unit for messages
  integer,       intent(in)    :: nvalue         ! size of value
  character*(*), intent(in)    :: mds_path     ! path to current node
  character*(*), intent(in)    :: name         ! new signal node to create
  real*8, dimension(:), intent(in)    :: value(nvalue)        ! string to place in tree
  integer,       intent(out)   :: ier          ! error flag
 
  logical,external :: lmds_errstat
  integer,external :: MdsPut, idescr_doublearr, mds_add_node
  integer          :: dsc, stat, nid, n, idims(1)
  character*150    :: expr
 
  ier=0
  expr = trim(mds_path)//':'//trim(name)
 
  print *, '%trdatbuf_tomds: putting ' // trim(expr)
 
  nid = mds_add_node(trim(expr),'numeric',stat)
  if (nid .le. 0) then
     write(ilun,'(/a)') '?trdatbuf_tomds.wr_doublearr: error creating node '//expr
     ier=1
     return
  end if
 
  n=1
  idims(1)=nvalue
  dsc = idescr_doublearr(value, idims, n)
  stat=MdsPut(trim(expr)//char(0),'$'//char(0),dsc,0)
  if (lmds_errstat(ilun, stat)) then
     write(ilun,'(/a)') '?trdatbuf_tomds.wr_doublearr: error putting '//name
     ier=1
  end if
 
end subroutine wr_doublearr
 

subroutine tdb_ripple0(d,icoils,zphi)
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d

  !  information on TF ripple field -- primary component

  integer, intent(out) :: icoils  ! no. of TF coils (TF ripples)
  real*8, intent(out) :: zphi ! shift of 1st coil rel. phi=0 (radians)

  icoils = d%datbuf(6) + 0.0001d0  ! slightly exceeds integer value
  zphi = d%datbuf(7)

end subroutine tdb_ripple0

subroutine tdb_ripple0_2(d,icoils,zphi)
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d

  !  information on TF ripple field -- secondary component

  integer, intent(out) :: icoils  ! no. of TF coils (TF ripples)
  real*8, intent(out) :: zphi ! shift of 1st coil rel. phi=0 (radians)

  icoils = d%datbuf(12) + 0.0001d0  ! slightly exceeds integer value
  zphi = d%datbuf(13)

end subroutine tdb_ripple0_2

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_print_category(ilun,iname)

  ! print category to which named item (iname) belongs
  ! any item which contains (iname) as a substring is printed

  implicit NONE

  integer, intent(in) :: ilun
  character*(*), intent(in) :: iname

  !------------------------------------
  ! local:

  character*32 :: uname  ! iname -> uppercase
  character*32 :: pname  ! iname in form to print
  integer :: ii,ict

  logical, save :: sym_init = .FALSE.
  character*32, dimension(:,:), allocatable, save :: sym_list

  !------------------------------------
  integer, parameter :: numsym = 765

  !------------------------------------

  if(.NOT.sym_init) then
     sym_init = .TRUE.
     allocate(sym_list(2,numsym))
     call ps_print_category_init1(2, numsym, sym_list)
     call ps_print_category_init2(2, numsym, sym_list)
     call ps_print_category_init3(2, numsym, sym_list)
     call ps_print_category_init4(2, numsym, sym_list)
     call ps_print_category_init5(2, numsym, sym_list)
     call ps_print_category_init6(2, numsym, sym_list)
     call ps_print_category_init7(2, numsym, sym_list)
     call ps_print_category_init8(2, numsym, sym_list)
  endif

  uname = iname
  call uupper(uname)

  ict = 0
  do ii=1,numsym
     if(index(sym_list(1,ii),trim(uname)).gt.0) then
        ict = ict + 1
        pname = adjustr(sym_list(1,ii))
        write(ilun,'(A)') "  "//pname//":  "//trim(sym_list(2,ii))
     endif
  enddo

  if(ict.eq.0) then
     write(ilun,*) ' *** nothing found for: '//trim(uname)
  endif

END SUBROUTINE ps_print_category

SUBROUTINE ps_print_category_init1(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,1) = 'ALLA_INDEX'; sym_list(2,1) = 'simulation_initialization'
   sym_list(1,2) = 'ALLA_NAME'; sym_list(2,2) = 'species_list'
   sym_list(1,3) = 'ALLA_TYPE'; sym_list(2,3) = 'species_list'
   sym_list(1,4) = 'ALL_INDEX'; sym_list(2,4) = 'simulation_initialization'
   sym_list(1,5) = 'ALL_NAME'; sym_list(2,5) = 'species_list'
   sym_list(1,6) = 'ALL_TYPE'; sym_list(2,6) = 'species_list'
   sym_list(1,7) = 'AMAXLH'; sym_list(2,7) = 'shot_configuration'
   sym_list(1,8) = 'AMINLH'; sym_list(2,8) = 'shot_configuration'
   sym_list(1,9) = 'ANG_HREF_COIL'; sym_list(2,9) = 'machine_description'
   sym_list(1,10) = 'ANG_VREF_COIL'; sym_list(2,10) = 'machine_description'
   sym_list(1,11) = 'ANOM_CODE_INFO'; sym_list(2,11) = 'simulation_initialization'
   sym_list(1,12) = 'ANOM_EVAR'; sym_list(2,12) = 'profile'
   sym_list(1,13) = 'ANT_MODEL'; sym_list(2,13) = 'machine_description'
   sym_list(1,14) = 'AP2_HALFHEIGHT'; sym_list(2,14) = 'machine_description'
   sym_list(1,15) = 'AP2_HALFWIDTH'; sym_list(2,15) = 'machine_description'
   sym_list(1,16) = 'AP2_HORIZ_OFFSET'; sym_list(2,16) = 'machine_description'
   sym_list(1,17) = 'AP2_VERT_OFFSET'; sym_list(2,17) = 'machine_description'
   sym_list(1,18) = 'APOLMAXLH'; sym_list(2,18) = 'shot_configuration'
   sym_list(1,19) = 'APOLMINLH'; sym_list(2,19) = 'shot_configuration'
   sym_list(1,20) = 'AP_HALFHEIGHT'; sym_list(2,20) = 'machine_description'
   sym_list(1,21) = 'AP_HALFWIDTH'; sym_list(2,21) = 'machine_description'
   sym_list(1,22) = 'AP_HORIZ_OFFSET'; sym_list(2,22) = 'machine_description'
   sym_list(1,23) = 'AP_VERT_OFFSET'; sym_list(2,23) = 'machine_description'
   sym_list(1,24) = 'AREA'; sym_list(2,24) = 'profile'
   sym_list(1,25) = 'ATORMAXLH'; sym_list(2,25) = 'shot_configuration'
   sym_list(1,26) = 'ATORMINLH'; sym_list(2,26) = 'shot_configuration'
   sym_list(1,27) = 'BALLOON_CODE'; sym_list(2,27) = 'item_list'
   sym_list(1,28) = 'BALLOON_MAPPER'; sym_list(2,28) = 'simulation_initialization'
   sym_list(1,29) = 'BALLOON_STABLE'; sym_list(2,29) = 'state_data'
   sym_list(1,30) = 'BALLOON_STATUS'; sym_list(2,30) = 'state_data'
   sym_list(1,31) = 'BALSTAB'; sym_list(2,31) = 'profile'
   sym_list(1,32) = 'BEAM_TYPE'; sym_list(2,32) = 'machine_description'
   sym_list(1,33) = 'BIDIFF_BPASS_CO'; sym_list(2,33) = 'profile'
   sym_list(1,34) = 'BIDIFF_BPASS_CTR'; sym_list(2,34) = 'profile'
   sym_list(1,35) = 'BIDIFF_BTRAP'; sym_list(2,35) = 'profile'
   sym_list(1,36) = 'BIDIFF_DPASS_CO'; sym_list(2,36) = 'profile'
   sym_list(1,37) = 'BIDIFF_DPASS_CTR'; sym_list(2,37) = 'profile'
   sym_list(1,38) = 'BIDIFF_DTRAP'; sym_list(2,38) = 'profile'
   sym_list(1,39) = 'BPHIRZ'; sym_list(2,39) = 'profile'
   sym_list(1,40) = 'BRRZ'; sym_list(2,40) = 'profile'
   sym_list(1,41) = 'BZRZ'; sym_list(2,41) = 'profile'
   sym_list(1,42) = 'B_AXIS'; sym_list(2,42) = 'state_data'
   sym_list(1,43) = 'B_AXIS_VAC'; sym_list(2,43) = 'state_data'
   sym_list(1,44) = 'B_HALFHEIGHT'; sym_list(2,44) = 'machine_description'
   sym_list(1,45) = 'B_HALFWIDTH'; sym_list(2,45) = 'machine_description'
   sym_list(1,46) = 'B_HDIVERGENCE'; sym_list(2,46) = 'machine_description'
   sym_list(1,47) = 'B_HFOCAL_LENGTH'; sym_list(2,47) = 'machine_description'
   sym_list(1,48) = 'B_MAX_LCFS'; sym_list(2,48) = 'state_data'
   sym_list(1,49) = 'B_MIN_LCFS'; sym_list(2,49) = 'state_data'
   sym_list(1,50) = 'B_SURFMAX'; sym_list(2,50) = 'profile'
   sym_list(1,51) = 'B_SURFMIN'; sym_list(2,51) = 'profile'
   sym_list(1,52) = 'B_VDIVERGENCE'; sym_list(2,52) = 'machine_description'
   sym_list(1,53) = 'B_VFOCAL_LENGTH'; sym_list(2,53) = 'machine_description'
   sym_list(1,54) = 'CDICRF'; sym_list(2,54) = 'profile'
   sym_list(1,55) = 'CDICRF_NPHI'; sym_list(2,55) = 'profile'
   sym_list(1,56) = 'CHIE_ANOM'; sym_list(2,56) = 'profile'
   sym_list(1,57) = 'CHIE_DRBM'; sym_list(2,57) = 'profile'
   sym_list(1,58) = 'CHIE_ETG'; sym_list(2,58) = 'profile'
   sym_list(1,59) = 'CHIE_GLF'; sym_list(2,59) = 'profile'
   sym_list(1,60) = 'CHIE_GTCNEO'; sym_list(2,60) = 'profile'
   sym_list(1,61) = 'CHIE_MMM71'; sym_list(2,61) = 'profile'
   sym_list(1,62) = 'CHIE_MTM'; sym_list(2,62) = 'profile'
   sym_list(1,63) = 'CHIE_NCLASS'; sym_list(2,63) = 'profile'
   sym_list(1,64) = 'CHIE_NEO'; sym_list(2,64) = 'profile'
   sym_list(1,65) = 'CHIE_NTM'; sym_list(2,65) = 'profile'
   sym_list(1,66) = 'CHIE_PALEO'; sym_list(2,66) = 'profile'
   sym_list(1,67) = 'CHIE_TGLF'; sym_list(2,67) = 'profile'
   sym_list(1,68) = 'CHIE_TRANS'; sym_list(2,68) = 'profile'
   sym_list(1,69) = 'CHIE_TRANSCAT'; sym_list(2,69) = 'profile'
   sym_list(1,70) = 'CHIE_W19'; sym_list(2,70) = 'profile'
   sym_list(1,71) = 'CHII_ANOM'; sym_list(2,71) = 'profile'
   sym_list(1,72) = 'CHII_DRBM'; sym_list(2,72) = 'profile'
   sym_list(1,73) = 'CHII_GLF'; sym_list(2,73) = 'profile'
   sym_list(1,74) = 'CHII_GTCNEO'; sym_list(2,74) = 'profile'
   sym_list(1,75) = 'CHII_MMM71'; sym_list(2,75) = 'profile'
   sym_list(1,76) = 'CHII_NCLASS'; sym_list(2,76) = 'profile'
   sym_list(1,77) = 'CHII_NEO'; sym_list(2,77) = 'profile'
   sym_list(1,78) = 'CHII_NTM'; sym_list(2,78) = 'profile'
   sym_list(1,79) = 'CHII_TGLF'; sym_list(2,79) = 'profile'
   sym_list(1,80) = 'CHII_TRANS'; sym_list(2,80) = 'profile'
   sym_list(1,81) = 'CHII_TRANSCAT'; sym_list(2,81) = 'profile'
   sym_list(1,82) = 'CHII_W19'; sym_list(2,82) = 'profile'
   sym_list(1,83) = 'CHIMO_TRANS'; sym_list(2,83) = 'profile'
   sym_list(1,84) = 'CHIMO_TRANSCAT'; sym_list(2,84) = 'profile'
   sym_list(1,85) = 'CHIPHI_ANOM'; sym_list(2,85) = 'profile'
   sym_list(1,86) = 'CHIPHI_DRBM'; sym_list(2,86) = 'profile'
   sym_list(1,87) = 'CHIPHI_GLF'; sym_list(2,87) = 'profile'
   sym_list(1,88) = 'CHIPHI_GTCNEO'; sym_list(2,88) = 'profile'
   sym_list(1,89) = 'CHIPHI_MMM71'; sym_list(2,89) = 'profile'
   sym_list(1,90) = 'CHIPHI_NEO'; sym_list(2,90) = 'profile'
   sym_list(1,91) = 'CHIPHI_TGLF'; sym_list(2,91) = 'profile'
   sym_list(1,92) = 'CHIPHI_W19'; sym_list(2,92) = 'profile'
   sym_list(1,93) = 'CHITHETA_MMM71'; sym_list(2,93) = 'profile'
   sym_list(1,94) = 'CIRCUIT_NAME'; sym_list(2,94) = 'item_list'
   sym_list(1,95) = 'COIL_APT'; sym_list(2,95) = 'state_data'
   sym_list(1,96) = 'COIL_IN_CIRCUIT'; sym_list(2,96) = 'machine_description'
   sym_list(1,97) = 'COIL_NAME'; sym_list(2,97) = 'item_list'
   sym_list(1,98) = 'COIL_RESISPT'; sym_list(2,98) = 'machine_description'
   sym_list(1,99) = 'CURBEAM'; sym_list(2,99) = 'profile'
   sym_list(1,100) = 'CURECH'; sym_list(2,100) = 'profile'
END SUBROUTINE ps_print_category_init1

SUBROUTINE ps_print_category_init2(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,101) = 'CURECH_SRC'; sym_list(2,101) = 'profile'
   sym_list(1,102) = 'CURFUSN'; sym_list(2,102) = 'profile'
   sym_list(1,103) = 'CURICH'; sym_list(2,103) = 'profile'
   sym_list(1,104) = 'CURLH'; sym_list(2,104) = 'profile'
   sym_list(1,105) = 'CURLH_SRC'; sym_list(2,105) = 'profile'
   sym_list(1,106) = 'CURMINO'; sym_list(2,106) = 'profile'
   sym_list(1,107) = 'CURR_BOOTSTRAP'; sym_list(2,107) = 'profile'
   sym_list(1,108) = 'CURR_OHMIC'; sym_list(2,108) = 'profile'
   sym_list(1,109) = 'CURT'; sym_list(2,109) = 'profile'
   sym_list(1,110) = 'CUR_DATA_INFO'; sym_list(2,110) = 'simulation_initialization'
   sym_list(1,111) = 'CUR_RW'; sym_list(2,111) = 'profile'
   sym_list(1,112) = 'D2R_GEO_DRHODTH'; sym_list(2,112) = 'derivative_profile'
   sym_list(1,113) = 'D2Z_GEO_DRHODTH'; sym_list(2,113) = 'derivative_profile'
   sym_list(1,114) = 'DB_MTM'; sym_list(2,114) = 'profile'
   sym_list(1,115) = 'DCUR_RW_DVLOOP'; sym_list(2,115) = 'profile'
   sym_list(1,116) = 'DELTAW_CODE'; sym_list(2,116) = 'item_list'
   sym_list(1,117) = 'DELTAW_MAPPER'; sym_list(2,117) = 'simulation_initialization'
   sym_list(1,118) = 'DELTAW_STABLE'; sym_list(2,118) = 'state_data'
   sym_list(1,119) = 'DELTAW_STATUS'; sym_list(2,119) = 'state_data'
   sym_list(1,120) = 'DIFB_FUSI'; sym_list(2,120) = 'profile'
   sym_list(1,121) = 'DIFB_NBI'; sym_list(2,121) = 'profile'
   sym_list(1,122) = 'DIFB_RFMI'; sym_list(2,122) = 'profile'
   sym_list(1,123) = 'DIFF_TRANS'; sym_list(2,123) = 'profile'
   sym_list(1,124) = 'DIFF_TRANSCAT'; sym_list(2,124) = 'profile'
   sym_list(1,125) = 'DIFNE_NCLASS'; sym_list(2,125) = 'profile'
   sym_list(1,126) = 'DIFNH_NCLASS'; sym_list(2,126) = 'profile'
   sym_list(1,127) = 'DIFNS_ANOM'; sym_list(2,127) = 'profile'
   sym_list(1,128) = 'DIFNS_DRBM'; sym_list(2,128) = 'profile'
   sym_list(1,129) = 'DIFNS_GLF'; sym_list(2,129) = 'profile'
   sym_list(1,130) = 'DIFNS_GTCNEO'; sym_list(2,130) = 'profile'
   sym_list(1,131) = 'DIFNS_MMM71'; sym_list(2,131) = 'profile'
   sym_list(1,132) = 'DIFNS_NCLASS'; sym_list(2,132) = 'profile'
   sym_list(1,133) = 'DIFNS_NEO'; sym_list(2,133) = 'profile'
   sym_list(1,134) = 'DIFNS_TGLF'; sym_list(2,134) = 'profile'
   sym_list(1,135) = 'DIFNS_W19'; sym_list(2,135) = 'profile'
   sym_list(1,136) = 'DIFNX_NCLASS'; sym_list(2,136) = 'profile'
   sym_list(1,137) = 'DIFNZ_MMM71'; sym_list(2,137) = 'profile'
   sym_list(1,138) = 'DIST_FUN'; sym_list(2,138) = 'state_data'
   sym_list(1,139) = 'DN0OUT'; sym_list(2,139) = 'state_data'
   sym_list(1,140) = 'DQEDGRDTE_TGLF'; sym_list(2,140) = 'profile'
   sym_list(1,141) = 'DQEDGRDTI_TGLF'; sym_list(2,141) = 'profile'
   sym_list(1,142) = 'DQIDGRDTE_TGLF'; sym_list(2,142) = 'profile'
   sym_list(1,143) = 'DQIDGRDTI_TGLF'; sym_list(2,143) = 'profile'
   sym_list(1,144) = 'DR0_MOMEQ_DRHO'; sym_list(2,144) = 'derivative_profile'
   sym_list(1,145) = 'DR_GEO_DRHO'; sym_list(2,145) = 'derivative_profile'
   sym_list(1,146) = 'DR_GEO_DTH'; sym_list(2,146) = 'derivative_profile'
   sym_list(1,147) = 'DXRJCOS_MOMEQ_DRHO'; sym_list(2,147) = 'derivative_profile'
   sym_list(1,148) = 'DXRJSIN_MOMEQ_DRHO'; sym_list(2,148) = 'derivative_profile'
   sym_list(1,149) = 'DXZJCOS_MOMEQ_DRHO'; sym_list(2,149) = 'derivative_profile'
   sym_list(1,150) = 'DXZJSIN_MOMEQ_DRHO'; sym_list(2,150) = 'derivative_profile'
   sym_list(1,151) = 'DX_FSHIELD'; sym_list(2,151) = 'machine_description'
   sym_list(1,152) = 'DZ0_MOMEQ_DRHO'; sym_list(2,152) = 'derivative_profile'
   sym_list(1,153) = 'DZ_GEO_DRHO'; sym_list(2,153) = 'derivative_profile'
   sym_list(1,154) = 'DZ_GEO_DTH'; sym_list(2,154) = 'derivative_profile'
   sym_list(1,155) = 'D_EINJ_STANDARD'; sym_list(2,155) = 'machine_description'
   sym_list(1,156) = 'D_FFULL_STANDARD'; sym_list(2,156) = 'machine_description'
   sym_list(1,157) = 'D_FHALF_STANDARD'; sym_list(2,157) = 'machine_description'
   sym_list(1,158) = 'E0_AV'; sym_list(2,158) = 'state_data'
   sym_list(1,159) = 'ECRF_SRC_NAME'; sym_list(2,159) = 'item_list'
   sym_list(1,160) = 'EC_BEAM_ELONGATION'; sym_list(2,160) = 'machine_description'
   sym_list(1,161) = 'EC_CODE_INFO'; sym_list(2,161) = 'simulation_initialization'
   sym_list(1,162) = 'EC_DATA_INFO'; sym_list(2,162) = 'simulation_initialization'
   sym_list(1,163) = 'EC_HALF_POWER_ANGLE'; sym_list(2,163) = 'machine_description'
   sym_list(1,164) = 'EC_OMODE_FRACTION'; sym_list(2,164) = 'shot_configuration'
   sym_list(1,165) = 'EC_PHI_AIM'; sym_list(2,165) = 'shot_configuration'
   sym_list(1,166) = 'EC_PRINC_CURV_HOR'; sym_list(2,166) = 'machine_description'
   sym_list(1,167) = 'EC_PRINC_CURV_VERT'; sym_list(2,167) = 'machine_description'
   sym_list(1,168) = 'EC_PRINC_WIDTH_HOR'; sym_list(2,168) = 'machine_description'
   sym_list(1,169) = 'EC_PRINC_WIDTH_VERT'; sym_list(2,169) = 'machine_description'
   sym_list(1,170) = 'EC_THETA_AIM'; sym_list(2,170) = 'shot_configuration'
   sym_list(1,171) = 'EE_MOBILITY_FACTOR'; sym_list(2,171) = 'profile'
   sym_list(1,172) = 'EINJ_MAX'; sym_list(2,172) = 'machine_description'
   sym_list(1,173) = 'EINJ_MIN'; sym_list(2,173) = 'machine_description'
   sym_list(1,174) = 'ELDOT'; sym_list(2,174) = 'state_data'
   sym_list(1,175) = 'ELONG'; sym_list(2,175) = 'profile'
   sym_list(1,176) = 'EPERP_BEAMI'; sym_list(2,176) = 'profile'
   sym_list(1,177) = 'EPERP_FUSI'; sym_list(2,177) = 'profile'
   sym_list(1,178) = 'EPERP_MINI'; sym_list(2,178) = 'profile'
   sym_list(1,179) = 'EPERP_RW'; sym_list(2,179) = 'profile'
   sym_list(1,180) = 'EPLL_BEAMI'; sym_list(2,180) = 'profile'
   sym_list(1,181) = 'EPLL_FUSI'; sym_list(2,181) = 'profile'
   sym_list(1,182) = 'EPLL_MINI'; sym_list(2,182) = 'profile'
   sym_list(1,183) = 'EPLL_RW'; sym_list(2,183) = 'profile'
   sym_list(1,184) = 'EPOT'; sym_list(2,184) = 'profile'
   sym_list(1,185) = 'EQDSK_FILE'; sym_list(2,185) = 'state_data'
   sym_list(1,186) = 'EQMOM_NUM'; sym_list(2,186) = 'item_list'
   sym_list(1,187) = 'EQ_CODE_INFO'; sym_list(2,187) = 'simulation_initialization'
   sym_list(1,188) = 'EQ_DATA_INFO'; sym_list(2,188) = 'simulation_initialization'
   sym_list(1,189) = 'ETA_PARALLEL'; sym_list(2,189) = 'profile'
   sym_list(1,190) = 'E_ANOM'; sym_list(2,190) = 'grid'
   sym_list(1,191) = 'E_ANOM2'; sym_list(2,191) = 'grid'
   sym_list(1,192) = 'FIDIFF_BPASS_CO'; sym_list(2,192) = 'profile'
   sym_list(1,193) = 'FIDIFF_BPASS_CTR'; sym_list(2,193) = 'profile'
   sym_list(1,194) = 'FIDIFF_BTRAP'; sym_list(2,194) = 'profile'
   sym_list(1,195) = 'FIDIFF_DPASS_CO'; sym_list(2,195) = 'profile'
   sym_list(1,196) = 'FIDIFF_DPASS_CTR'; sym_list(2,196) = 'profile'
   sym_list(1,197) = 'FIDIFF_DTRAP'; sym_list(2,197) = 'profile'
   sym_list(1,198) = 'FI_DEPLETION'; sym_list(2,198) = 'profile'
   sym_list(1,199) = 'FRACMIN'; sym_list(2,199) = 'simulation_initialization'
   sym_list(1,200) = 'FRACPSLH'; sym_list(2,200) = 'shot_configuration'
END SUBROUTINE ps_print_category_init2

SUBROUTINE ps_print_category_init3(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,201) = 'FRAC_FULL'; sym_list(2,201) = 'state_data'
   sym_list(1,202) = 'FRAC_HALF'; sym_list(2,202) = 'state_data'
   sym_list(1,203) = 'FREQ_DRBM'; sym_list(2,203) = 'profile'
   sym_list(1,204) = 'FREQ_EC'; sym_list(2,204) = 'shot_configuration'
   sym_list(1,205) = 'FREQ_GLF'; sym_list(2,205) = 'profile'
   sym_list(1,206) = 'FREQ_IC'; sym_list(2,206) = 'shot_configuration'
   sym_list(1,207) = 'FREQ_LH'; sym_list(2,207) = 'shot_configuration'
   sym_list(1,208) = 'FREQ_MAX_TGLF'; sym_list(2,208) = 'profile'
   sym_list(1,209) = 'FREQ_MMM71'; sym_list(2,209) = 'profile'
   sym_list(1,210) = 'FREQ_MTM'; sym_list(2,210) = 'profile'
   sym_list(1,211) = 'FREQ_TGLF'; sym_list(2,211) = 'profile'
   sym_list(1,212) = 'FUS_CODE_INFO'; sym_list(2,212) = 'simulation_initialization'
   sym_list(1,213) = 'GAMMA_LMHD'; sym_list(2,213) = 'state_data'
   sym_list(1,214) = 'GAMMA_NC'; sym_list(2,214) = 'profile'
   sym_list(1,215) = 'GAS_ATOM'; sym_list(2,215) = 'shot_configuration'
   sym_list(1,216) = 'GAS_CODE_INFO'; sym_list(2,216) = 'simulation_initialization'
   sym_list(1,217) = 'GB1'; sym_list(2,217) = 'profile'
   sym_list(1,218) = 'GB2'; sym_list(2,218) = 'profile'
   sym_list(1,219) = 'GB2I'; sym_list(2,219) = 'profile'
   sym_list(1,220) = 'GBR2'; sym_list(2,220) = 'profile'
   sym_list(1,221) = 'GEOMETRY'; sym_list(2,221) = 'machine_description'
   sym_list(1,222) = 'GLOBAL_LABEL'; sym_list(2,222) = 'simulation_initialization'
   sym_list(1,223) = 'GNCFB2H'; sym_list(2,223) = 'profile'
   sym_list(1,224) = 'GNCFH'; sym_list(2,224) = 'profile'
   sym_list(1,225) = 'GR1'; sym_list(2,225) = 'profile'
   sym_list(1,226) = 'GR2'; sym_list(2,226) = 'profile'
   sym_list(1,227) = 'GR2I'; sym_list(2,227) = 'profile'
   sym_list(1,228) = 'GR2RHO2'; sym_list(2,228) = 'profile'
   sym_list(1,229) = 'GR3I'; sym_list(2,229) = 'profile'
   sym_list(1,230) = 'GRHO1'; sym_list(2,230) = 'profile'
   sym_list(1,231) = 'GRHO2'; sym_list(2,231) = 'profile'
   sym_list(1,232) = 'GRHO2B2I'; sym_list(2,232) = 'profile'
   sym_list(1,233) = 'GRHO2R2I'; sym_list(2,233) = 'profile'
   sym_list(1,234) = 'GRHO2R3I'; sym_list(2,234) = 'profile'
   sym_list(1,235) = 'GRI'; sym_list(2,235) = 'profile'
   sym_list(1,236) = 'GRIRHOI'; sym_list(2,236) = 'profile'
   sym_list(1,237) = 'GROWTHRATE_DRBM'; sym_list(2,237) = 'profile'
   sym_list(1,238) = 'GROWTHRATE_GLF'; sym_list(2,238) = 'profile'
   sym_list(1,239) = 'GROWTHRATE_MAX_TGLF'; sym_list(2,239) = 'profile'
   sym_list(1,240) = 'GROWTHRATE_MMM71'; sym_list(2,240) = 'profile'
   sym_list(1,241) = 'GROWTHRATE_MTM'; sym_list(2,241) = 'profile'
   sym_list(1,242) = 'GROWTHRATE_TGLF'; sym_list(2,242) = 'profile'
   sym_list(1,243) = 'GROWTHRATE_VPAR'; sym_list(2,243) = 'profile'
   sym_list(1,244) = 'GS_NAME'; sym_list(2,244) = 'item_list'
   sym_list(1,245) = 'G_EQ'; sym_list(2,245) = 'profile'
   sym_list(1,246) = 'HEGRILH'; sym_list(2,246) = 'shot_configuration'
   sym_list(1,247) = 'HSIZE_COIL'; sym_list(2,247) = 'machine_description'
   sym_list(1,248) = 'H_EINJ_STANDARD'; sym_list(2,248) = 'machine_description'
   sym_list(1,249) = 'H_FFULL_STANDARD'; sym_list(2,249) = 'machine_description'
   sym_list(1,250) = 'H_FHALF_STANDARD'; sym_list(2,250) = 'machine_description'
   sym_list(1,251) = 'ICIRCUIT_COIL'; sym_list(2,251) = 'simulation_initialization'
   sym_list(1,252) = 'ICRF_SRC_NAME'; sym_list(2,252) = 'item_list'
   sym_list(1,253) = 'IC_CODE_INFO'; sym_list(2,253) = 'simulation_initialization'
   sym_list(1,254) = 'IC_DATA_INFO'; sym_list(2,254) = 'simulation_initialization'
   sym_list(1,255) = 'IMAG_ANT_COEF'; sym_list(2,255) = 'shot_configuration'
   sym_list(1,256) = 'IOTA'; sym_list(2,256) = 'profile'
   sym_list(1,257) = 'ISTHERMAL'; sym_list(2,257) = 'state_data'
   sym_list(1,258) = 'IS_RECYCLING'; sym_list(2,258) = 'shot_configuration'
   sym_list(1,259) = 'I_NPOLOIDAL'; sym_list(2,259) = 'shot_configuration'
   sym_list(1,260) = 'JDOTB'; sym_list(2,260) = 'profile'
   sym_list(1,261) = 'KCCW_BPHI'; sym_list(2,261) = 'shot_configuration'
   sym_list(1,262) = 'KCCW_JPHI'; sym_list(2,262) = 'shot_configuration'
   sym_list(1,263) = 'KDENS_RFMIN'; sym_list(2,263) = 'simulation_initialization'
   sym_list(1,264) = 'KVOLT_NBI'; sym_list(2,264) = 'state_data'
   sym_list(1,265) = 'KYRHOS_MTM'; sym_list(2,265) = 'profile'
   sym_list(1,266) = 'KYSPECTRUM_TGLF'; sym_list(2,266) = 'profile'
   sym_list(1,267) = 'LBSCAP'; sym_list(2,267) = 'machine_description'
   sym_list(1,268) = 'LBSCAP2'; sym_list(2,268) = 'machine_description'
   sym_list(1,269) = 'LBSCTAN'; sym_list(2,269) = 'machine_description'
   sym_list(1,270) = 'LHRF_SRC_NAME'; sym_list(2,270) = 'item_list'
   sym_list(1,271) = 'LH_CODE_INFO'; sym_list(2,271) = 'simulation_initialization'
   sym_list(1,272) = 'LH_DATA_INFO'; sym_list(2,272) = 'simulation_initialization'
   sym_list(1,273) = 'LMHD_EQ_CODE'; sym_list(2,273) = 'simulation_initialization'
   sym_list(1,274) = 'LMHD_STATUS'; sym_list(2,274) = 'state_data'
   sym_list(1,275) = 'LOCK_MACHINE_DESCR'; sym_list(2,275) = 'state_data'
   sym_list(1,276) = 'LOCK_SHOT_CONFIG'; sym_list(2,276) = 'state_data'
   sym_list(1,277) = 'LOCK_SIM_INIT'; sym_list(2,277) = 'state_data'
   sym_list(1,278) = 'LPOL'; sym_list(2,278) = 'profile'
   sym_list(1,279) = 'MAX_NRZ_ANTGEO'; sym_list(2,279) = 'enumeration_limit'
   sym_list(1,280) = 'MAX_NSPECTRUMLH_SRC'; sym_list(2,280) = 'enumeration_limit'
   sym_list(1,281) = 'MAX_NUM_NPHI'; sym_list(2,281) = 'enumeration_limit'
   sym_list(1,282) = 'MAX_NUM_NPHI_VAC'; sym_list(2,282) = 'enumeration_limit'
   sym_list(1,283) = 'MAX_N_STRAPS'; sym_list(2,283) = 'enumeration_limit'
   sym_list(1,284) = 'MERCIER_STABLE'; sym_list(2,284) = 'state_data'
   sym_list(1,285) = 'MHD_EQ_STATUS'; sym_list(2,285) = 'state_data'
   sym_list(1,286) = 'MMODES'; sym_list(2,286) = 'item_list'
   sym_list(1,287) = 'M_ALL'; sym_list(2,287) = 'species_list'
   sym_list(1,288) = 'M_ALLA'; sym_list(2,288) = 'species_list'
   sym_list(1,289) = 'M_RFMIN'; sym_list(2,289) = 'species_list'
   sym_list(1,290) = 'M_S'; sym_list(2,290) = 'species_list'
   sym_list(1,291) = 'M_SA'; sym_list(2,291) = 'species_list'
   sym_list(1,292) = 'M_SFUS'; sym_list(2,292) = 'species_list'
   sym_list(1,293) = 'M_SGAS'; sym_list(2,293) = 'species_list'
   sym_list(1,294) = 'M_SIMP0'; sym_list(2,294) = 'species_list'
   sym_list(1,295) = 'M_SIMPI'; sym_list(2,295) = 'species_list'
   sym_list(1,296) = 'M_SNBI'; sym_list(2,296) = 'species_list'
   sym_list(1,297) = 'N0NORM'; sym_list(2,297) = 'profile'
   sym_list(1,298) = 'N0_HALO'; sym_list(2,298) = 'profile'
   sym_list(1,299) = 'N0_RECO'; sym_list(2,299) = 'profile'
   sym_list(1,300) = 'NBALLOON'; sym_list(2,300) = 'item_list'
END SUBROUTINE ps_print_category_init3

SUBROUTINE ps_print_category_init4(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,301) = 'NBAP2_SHAPE'; sym_list(2,301) = 'machine_description'
   sym_list(1,302) = 'NBAP_SHAPE'; sym_list(2,302) = 'machine_description'
   sym_list(1,303) = 'NBEAM'; sym_list(2,303) = 'item_list'
   sym_list(1,304) = 'NBEAMI'; sym_list(2,304) = 'profile'
   sym_list(1,305) = 'NBEAMI_BDY'; sym_list(2,305) = 'state_data'
   sym_list(1,306) = 'NBION'; sym_list(2,306) = 'shot_configuration'
   sym_list(1,307) = 'NBION_TRACE'; sym_list(2,307) = 'shot_configuration'
   sym_list(1,308) = 'NBI_CODE_INFO'; sym_list(2,308) = 'simulation_initialization'
   sym_list(1,309) = 'NBI_DATA_INFO'; sym_list(2,309) = 'simulation_initialization'
   sym_list(1,310) = 'NBI_SRC_NAME'; sym_list(2,310) = 'item_list'
   sym_list(1,311) = 'NBSHAPE'; sym_list(2,311) = 'machine_description'
   sym_list(1,312) = 'NCIRCUITS'; sym_list(2,312) = 'item_list'
   sym_list(1,313) = 'NCOILS'; sym_list(2,313) = 'item_list'
   sym_list(1,314) = 'NDELTA_W'; sym_list(2,314) = 'item_list'
   sym_list(1,315) = 'NEBAR'; sym_list(2,315) = 'state_data'
   sym_list(1,316) = 'NECRF_SRC'; sym_list(2,316) = 'item_list'
   sym_list(1,317) = 'NEFI_ANOM'; sym_list(2,317) = 'grid'
   sym_list(1,318) = 'NEFI_ANOM2'; sym_list(2,318) = 'grid'
   sym_list(1,319) = 'NEFLUX_KY_TGLF'; sym_list(2,319) = 'profile'
   sym_list(1,320) = 'NEQMOM'; sym_list(2,320) = 'item_list'
   sym_list(1,321) = 'NEWCOMB_CODE'; sym_list(2,321) = 'item_list'
   sym_list(1,322) = 'NEWCOMB_MAPPER'; sym_list(2,322) = 'simulation_initialization'
   sym_list(1,323) = 'NEWCOMB_STABLE'; sym_list(2,323) = 'state_data'
   sym_list(1,324) = 'NEWCOMB_STATUS'; sym_list(2,324) = 'state_data'
   sym_list(1,325) = 'NE_KY_TGLF'; sym_list(2,325) = 'profile'
   sym_list(1,326) = 'NFUSI'; sym_list(2,326) = 'profile'
   sym_list(1,327) = 'NFUSI_BDY'; sym_list(2,327) = 'state_data'
   sym_list(1,328) = 'NGRADB2_AV'; sym_list(2,328) = 'profile'
   sym_list(1,329) = 'NGSC0'; sym_list(2,329) = 'item_list'
   sym_list(1,330) = 'NI'; sym_list(2,330) = 'profile'
   sym_list(1,331) = 'NICRF_SRC'; sym_list(2,331) = 'item_list'
   sym_list(1,332) = 'NIFLUX_KY_TGLF'; sym_list(2,332) = 'profile'
   sym_list(1,333) = 'NI_KY_TGLF'; sym_list(2,333) = 'profile'
   sym_list(1,334) = 'NKY_ANOMTH'; sym_list(2,334) = 'simulation_initialization'
   sym_list(1,335) = 'NKY_MMM'; sym_list(2,335) = 'simulation_initialization'
   sym_list(1,336) = 'NLHRF_SRC'; sym_list(2,336) = 'item_list'
   sym_list(1,337) = 'NMDIFB'; sym_list(2,337) = 'state_data'
   sym_list(1,338) = 'NMINI'; sym_list(2,338) = 'profile'
   sym_list(1,339) = 'NMINI_BDY'; sym_list(2,339) = 'state_data'
   sym_list(1,340) = 'NMODEL'; sym_list(2,340) = 'profile'
   sym_list(1,341) = 'NMODEL_BDY'; sym_list(2,341) = 'state_data'
   sym_list(1,342) = 'NMOM'; sym_list(2,342) = 'simulation_initialization'
   sym_list(1,343) = 'NNEWCOMB'; sym_list(2,343) = 'item_list'
   sym_list(1,344) = 'NNKPARLH'; sym_list(2,344) = 'shot_configuration'
   sym_list(1,345) = 'NNKPOLLH'; sym_list(2,345) = 'shot_configuration'
   sym_list(1,346) = 'NNKTORLH'; sym_list(2,346) = 'shot_configuration'
   sym_list(1,347) = 'NPHI'; sym_list(2,347) = 'shot_configuration'
   sym_list(1,348) = 'NPSMOM'; sym_list(2,348) = 'item_list'
   sym_list(1,349) = 'NR'; sym_list(2,349) = 'grid'
   sym_list(1,350) = 'NRHO'; sym_list(2,350) = 'grid'
   sym_list(1,351) = 'NRHO_ANOM'; sym_list(2,351) = 'grid'
   sym_list(1,352) = 'NRHO_ANOM2'; sym_list(2,352) = 'grid'
   sym_list(1,353) = 'NRHO_ANOMTH'; sym_list(2,353) = 'grid'
   sym_list(1,354) = 'NRHO_ECRF'; sym_list(2,354) = 'grid'
   sym_list(1,355) = 'NRHO_EQ'; sym_list(2,355) = 'grid'
   sym_list(1,356) = 'NRHO_EQ_GEO'; sym_list(2,356) = 'grid'
   sym_list(1,357) = 'NRHO_FUS'; sym_list(2,357) = 'grid'
   sym_list(1,358) = 'NRHO_GAS'; sym_list(2,358) = 'grid'
   sym_list(1,359) = 'NRHO_ICRF'; sym_list(2,359) = 'grid'
   sym_list(1,360) = 'NRHO_LHRF'; sym_list(2,360) = 'grid'
   sym_list(1,361) = 'NRHO_LMHD'; sym_list(2,361) = 'grid'
   sym_list(1,362) = 'NRHO_MIST'; sym_list(2,362) = 'grid'
   sym_list(1,363) = 'NRHO_NBI'; sym_list(2,363) = 'grid'
   sym_list(1,364) = 'NRHO_PEL'; sym_list(2,364) = 'grid'
   sym_list(1,365) = 'NRHO_RAD'; sym_list(2,365) = 'grid'
   sym_list(1,366) = 'NRHO_RW'; sym_list(2,366) = 'grid'
   sym_list(1,367) = 'NRW'; sym_list(2,367) = 'profile'
   sym_list(1,368) = 'NRZ_ANTGEO'; sym_list(2,368) = 'machine_description'
   sym_list(1,369) = 'NR_RIP'; sym_list(2,369) = 'grid'
   sym_list(1,370) = 'NS'; sym_list(2,370) = 'profile'
   sym_list(1,371) = 'NSPECTRUMLH_SRC'; sym_list(2,371) = 'shot_configuration'
   sym_list(1,372) = 'NSPEC_ALL'; sym_list(2,372) = 'species_list'
   sym_list(1,373) = 'NSPEC_ALLA'; sym_list(2,373) = 'species_list'
   sym_list(1,374) = 'NSPEC_BEAM'; sym_list(2,374) = 'species_list'
   sym_list(1,375) = 'NSPEC_FUSION'; sym_list(2,375) = 'species_list'
   sym_list(1,376) = 'NSPEC_GAS'; sym_list(2,376) = 'species_list'
   sym_list(1,377) = 'NSPEC_IMP0'; sym_list(2,377) = 'species_list'
   sym_list(1,378) = 'NSPEC_IMPI'; sym_list(2,378) = 'species_list'
   sym_list(1,379) = 'NSPEC_RFMIN'; sym_list(2,379) = 'species_list'
   sym_list(1,380) = 'NSPEC_TH'; sym_list(2,380) = 'species_list'
   sym_list(1,381) = 'NSPEC_THA'; sym_list(2,381) = 'species_list'
   sym_list(1,382) = 'NS_BDY'; sym_list(2,382) = 'state_data'
   sym_list(1,383) = 'NS_DATA_INFO'; sym_list(2,383) = 'simulation_initialization'
   sym_list(1,384) = 'NS_IS_INPUT'; sym_list(2,384) = 'state_data'
   sym_list(1,385) = 'NTF_COIL2'; sym_list(2,385) = 'machine_description'
   sym_list(1,386) = 'NTF_COILS'; sym_list(2,386) = 'machine_description'
   sym_list(1,387) = 'NTHINLH'; sym_list(2,387) = 'shot_configuration'
   sym_list(1,388) = 'NTH_EQ'; sym_list(2,388) = 'grid'
   sym_list(1,389) = 'NTRCAT'; sym_list(2,389) = 'item_list'
   sym_list(1,390) = 'NTURNS'; sym_list(2,390) = 'machine_description'
   sym_list(1,391) = 'NUM_NPHI'; sym_list(2,391) = 'shot_configuration'
   sym_list(1,392) = 'NUM_NPHI_VAC'; sym_list(2,392) = 'shot_configuration'
   sym_list(1,393) = 'NUM_RZLIM'; sym_list(2,393) = 'machine_description'
   sym_list(1,394) = 'NXS'; sym_list(2,394) = 'item_list'
   sym_list(1,395) = 'NZ'; sym_list(2,395) = 'grid'
   sym_list(1,396) = 'NZFLUX_KY_TGLF'; sym_list(2,396) = 'profile'
   sym_list(1,397) = 'NZ_KY_TGLF'; sym_list(2,397) = 'profile'
   sym_list(1,398) = 'NZ_RIP'; sym_list(2,398) = 'grid'
   sym_list(1,399) = 'N_D_EINJ_STANDARD'; sym_list(2,399) = 'machine_description'
   sym_list(1,400) = 'N_H_EINJ_STANDARD'; sym_list(2,400) = 'machine_description'
END SUBROUTINE ps_print_category_init4

SUBROUTINE ps_print_category_init5(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,401) = 'N_STRAPS'; sym_list(2,401) = 'shot_configuration'
   sym_list(1,402) = 'N_T_EINJ_STANDARD'; sym_list(2,402) = 'machine_description'
   sym_list(1,403) = 'OMEG0CX'; sym_list(2,403) = 'profile'
   sym_list(1,404) = 'OMEG0SC0'; sym_list(2,404) = 'profile'
   sym_list(1,405) = 'OMEG0_HALO'; sym_list(2,405) = 'profile'
   sym_list(1,406) = 'OMEG0_RECO'; sym_list(2,406) = 'profile'
   sym_list(1,407) = 'OMEGAT'; sym_list(2,407) = 'profile'
   sym_list(1,408) = 'OMEGAT_BDY'; sym_list(2,408) = 'state_data'
   sym_list(1,409) = 'OMEGA_EXB'; sym_list(2,409) = 'profile'
   sym_list(1,410) = 'P0_RECO'; sym_list(2,410) = 'profile'
   sym_list(1,411) = 'PB0_HALO'; sym_list(2,411) = 'profile'
   sym_list(1,412) = 'PBE'; sym_list(2,412) = 'profile'
   sym_list(1,413) = 'PBI'; sym_list(2,413) = 'profile'
   sym_list(1,414) = 'PBTH'; sym_list(2,414) = 'profile'
   sym_list(1,415) = 'PCX_HALO'; sym_list(2,415) = 'profile'
   sym_list(1,416) = 'PCX_RECO'; sym_list(2,416) = 'profile'
   sym_list(1,417) = 'PEECH'; sym_list(2,417) = 'profile'
   sym_list(1,418) = 'PEECH_SRC'; sym_list(2,418) = 'profile'
   sym_list(1,419) = 'PELH'; sym_list(2,419) = 'profile'
   sym_list(1,420) = 'PELH_SRC'; sym_list(2,420) = 'profile'
   sym_list(1,421) = 'PEL_CODE_INFO'; sym_list(2,421) = 'simulation_initialization'
   sym_list(1,422) = 'PEL_DATA_INFO'; sym_list(2,422) = 'simulation_initialization'
   sym_list(1,423) = 'PE_ANOM'; sym_list(2,423) = 'profile'
   sym_list(1,424) = 'PE_TRANS'; sym_list(2,424) = 'profile'
   sym_list(1,425) = 'PE_TRANSCAT'; sym_list(2,425) = 'profile'
   sym_list(1,426) = 'PFUSE'; sym_list(2,426) = 'profile'
   sym_list(1,427) = 'PFUSI'; sym_list(2,427) = 'profile'
   sym_list(1,428) = 'PFUSTH'; sym_list(2,428) = 'profile'
   sym_list(1,429) = 'PHIBSC'; sym_list(2,429) = 'machine_description'
   sym_list(1,430) = 'PHIFLUX_KY_TGLF'; sym_list(2,430) = 'profile'
   sym_list(1,431) = 'PHIGRILH'; sym_list(2,431) = 'shot_configuration'
   sym_list(1,432) = 'PHIT'; sym_list(2,432) = 'profile'
   sym_list(1,433) = 'PHI_EC_LAUNCH'; sym_list(2,433) = 'machine_description'
   sym_list(1,434) = 'PICRF_ABS'; sym_list(2,434) = 'state_data'
   sym_list(1,435) = 'PICRF_EXT'; sym_list(2,435) = 'state_data'
   sym_list(1,436) = 'PICRF_NPHI_SRCS'; sym_list(2,436) = 'profile'
   sym_list(1,437) = 'PICRF_SRCS'; sym_list(2,437) = 'profile'
   sym_list(1,438) = 'PICRF_TOTALS'; sym_list(2,438) = 'profile'
   sym_list(1,439) = 'PICTH'; sym_list(2,439) = 'profile'
   sym_list(1,440) = 'PILH'; sym_list(2,440) = 'profile'
   sym_list(1,441) = 'PILH_SRC'; sym_list(2,441) = 'profile'
   sym_list(1,442) = 'PI_ANOM'; sym_list(2,442) = 'profile'
   sym_list(1,443) = 'PI_TRANS'; sym_list(2,443) = 'profile'
   sym_list(1,444) = 'PI_TRANSCAT'; sym_list(2,444) = 'profile'
   sym_list(1,445) = 'PLASMA_CODE_INFO'; sym_list(2,445) = 'simulation_initialization'
   sym_list(1,446) = 'PMINE'; sym_list(2,446) = 'profile'
   sym_list(1,447) = 'PMINI'; sym_list(2,447) = 'profile'
   sym_list(1,448) = 'PMINTH'; sym_list(2,448) = 'profile'
   sym_list(1,449) = 'POHME'; sym_list(2,449) = 'profile'
   sym_list(1,450) = 'POT_KY_TGLF'; sym_list(2,450) = 'profile'
   sym_list(1,451) = 'POWER_EC'; sym_list(2,451) = 'state_data'
   sym_list(1,452) = 'POWER_IC'; sym_list(2,452) = 'state_data'
   sym_list(1,453) = 'POWER_LH'; sym_list(2,453) = 'state_data'
   sym_list(1,454) = 'POWER_NBI'; sym_list(2,454) = 'state_data'
   sym_list(1,455) = 'POWER_NBI_TRACE'; sym_list(2,455) = 'state_data'
   sym_list(1,456) = 'PRAD'; sym_list(2,456) = 'profile'
   sym_list(1,457) = 'PRAD_BR'; sym_list(2,457) = 'profile'
   sym_list(1,458) = 'PRAD_CY'; sym_list(2,458) = 'profile'
   sym_list(1,459) = 'PRAD_LI'; sym_list(2,459) = 'profile'
   sym_list(1,460) = 'PSC_HALO'; sym_list(2,460) = 'profile'
   sym_list(1,461) = 'PSC_RECO'; sym_list(2,461) = 'profile'
   sym_list(1,462) = 'PSIPOL'; sym_list(2,462) = 'profile'
   sym_list(1,463) = 'PSIRZ'; sym_list(2,463) = 'profile'
   sym_list(1,464) = 'PSI_TO_MACHINE_AXIS'; sym_list(2,464) = 'state_data'
   sym_list(1,465) = 'PSMOM_ERRCK'; sym_list(2,465) = 'profile'
   sym_list(1,466) = 'PSMOM_NC'; sym_list(2,466) = 'profile'
   sym_list(1,467) = 'PSMOM_NUM'; sym_list(2,467) = 'item_list'
   sym_list(1,468) = 'P_EQ'; sym_list(2,468) = 'profile'
   sym_list(1,469) = 'QATOM_ALL'; sym_list(2,469) = 'species_list'
   sym_list(1,470) = 'QATOM_ALLA'; sym_list(2,470) = 'species_list'
   sym_list(1,471) = 'QATOM_RFMIN'; sym_list(2,471) = 'species_list'
   sym_list(1,472) = 'QATOM_S'; sym_list(2,472) = 'species_list'
   sym_list(1,473) = 'QATOM_SA'; sym_list(2,473) = 'species_list'
   sym_list(1,474) = 'QATOM_SFUS'; sym_list(2,474) = 'species_list'
   sym_list(1,475) = 'QATOM_SGAS'; sym_list(2,475) = 'species_list'
   sym_list(1,476) = 'QATOM_SIMP0'; sym_list(2,476) = 'species_list'
   sym_list(1,477) = 'QATOM_SIMPI'; sym_list(2,477) = 'species_list'
   sym_list(1,478) = 'QATOM_SNBI'; sym_list(2,478) = 'species_list'
   sym_list(1,479) = 'QBEAMI'; sym_list(2,479) = 'profile'
   sym_list(1,480) = 'QCOMP_E'; sym_list(2,480) = 'profile'
   sym_list(1,481) = 'QCOMP_I'; sym_list(2,481) = 'profile'
   sym_list(1,482) = 'QIE'; sym_list(2,482) = 'profile'
   sym_list(1,483) = 'QIONIZ'; sym_list(2,483) = 'profile'
   sym_list(1,484) = 'QL_OPERATOR'; sym_list(2,484) = 'state_data'
   sym_list(1,485) = 'QQCX'; sym_list(2,485) = 'profile'
   sym_list(1,486) = 'QROT_CONV'; sym_list(2,486) = 'profile'
   sym_list(1,487) = 'QROT_DIFF'; sym_list(2,487) = 'profile'
   sym_list(1,488) = 'Q_ALL'; sym_list(2,488) = 'species_list'
   sym_list(1,489) = 'Q_ALLA'; sym_list(2,489) = 'species_list'
   sym_list(1,490) = 'Q_EQ'; sym_list(2,490) = 'profile'
   sym_list(1,491) = 'Q_RFMIN'; sym_list(2,491) = 'species_list'
   sym_list(1,492) = 'Q_S'; sym_list(2,492) = 'species_list'
   sym_list(1,493) = 'Q_SA'; sym_list(2,493) = 'species_list'
   sym_list(1,494) = 'Q_SFUS'; sym_list(2,494) = 'species_list'
   sym_list(1,495) = 'Q_SGAS'; sym_list(2,495) = 'species_list'
   sym_list(1,496) = 'Q_SIMP0'; sym_list(2,496) = 'species_list'
   sym_list(1,497) = 'Q_SIMPI'; sym_list(2,497) = 'species_list'
   sym_list(1,498) = 'Q_SNBI'; sym_list(2,498) = 'species_list'
   sym_list(1,499) = 'R0_MOMEQ'; sym_list(2,499) = 'profile'
   sym_list(1,500) = 'RAD_CODE_INFO'; sym_list(2,500) = 'simulation_initialization'
END SUBROUTINE ps_print_category_init5

SUBROUTINE ps_print_category_init6(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,501) = 'RAD_DATA_INFO'; sym_list(2,501) = 'simulation_initialization'
   sym_list(1,502) = 'RATE_SINB0I'; sym_list(2,502) = 'profile'
   sym_list(1,503) = 'RATE_SINB0X'; sym_list(2,503) = 'profile'
   sym_list(1,504) = 'RATE_SINB0XS'; sym_list(2,504) = 'profile'
   sym_list(1,505) = 'RATE_SINF0I'; sym_list(2,505) = 'profile'
   sym_list(1,506) = 'RATE_SINF0X'; sym_list(2,506) = 'profile'
   sym_list(1,507) = 'RATE_SINF0XS'; sym_list(2,507) = 'profile'
   sym_list(1,508) = 'REAL_ANT_COEF'; sym_list(2,508) = 'shot_configuration'
   sym_list(1,509) = 'RES_SN'; sym_list(2,509) = 'profile'
   sym_list(1,510) = 'RES_TE'; sym_list(2,510) = 'profile'
   sym_list(1,511) = 'RES_TI'; sym_list(2,511) = 'profile'
   sym_list(1,512) = 'RES_TQ'; sym_list(2,512) = 'profile'
   sym_list(1,513) = 'RFMIN_NAME'; sym_list(2,513) = 'species_list'
   sym_list(1,514) = 'RFMIN_TO_ALL'; sym_list(2,514) = 'simulation_initialization'
   sym_list(1,515) = 'RFMIN_TO_ALLA'; sym_list(2,515) = 'simulation_initialization'
   sym_list(1,516) = 'RFMIN_TYPE'; sym_list(2,516) = 'species_list'
   sym_list(1,517) = 'RHO'; sym_list(2,517) = 'grid'
   sym_list(1,518) = 'RHOPSI0LH'; sym_list(2,518) = 'shot_configuration'
   sym_list(1,519) = 'RHO_ANOM'; sym_list(2,519) = 'grid'
   sym_list(1,520) = 'RHO_ANOM2'; sym_list(2,520) = 'grid'
   sym_list(1,521) = 'RHO_ANOMTH'; sym_list(2,521) = 'grid'
   sym_list(1,522) = 'RHO_BDY_NS'; sym_list(2,522) = 'state_data'
   sym_list(1,523) = 'RHO_BDY_OMEGAT'; sym_list(2,523) = 'state_data'
   sym_list(1,524) = 'RHO_BDY_TE'; sym_list(2,524) = 'state_data'
   sym_list(1,525) = 'RHO_BDY_TI'; sym_list(2,525) = 'state_data'
   sym_list(1,526) = 'RHO_ECRF'; sym_list(2,526) = 'grid'
   sym_list(1,527) = 'RHO_EQ'; sym_list(2,527) = 'grid'
   sym_list(1,528) = 'RHO_EQ_GEO'; sym_list(2,528) = 'grid'
   sym_list(1,529) = 'RHO_FUS'; sym_list(2,529) = 'grid'
   sym_list(1,530) = 'RHO_GAS'; sym_list(2,530) = 'grid'
   sym_list(1,531) = 'RHO_ICRF'; sym_list(2,531) = 'grid'
   sym_list(1,532) = 'RHO_LHRF'; sym_list(2,532) = 'grid'
   sym_list(1,533) = 'RHO_LMHD'; sym_list(2,533) = 'grid'
   sym_list(1,534) = 'RHO_MIST'; sym_list(2,534) = 'grid'
   sym_list(1,535) = 'RHO_NBI'; sym_list(2,535) = 'grid'
   sym_list(1,536) = 'RHO_PEL'; sym_list(2,536) = 'grid'
   sym_list(1,537) = 'RHO_RAD'; sym_list(2,537) = 'grid'
   sym_list(1,538) = 'RHO_RW'; sym_list(2,538) = 'grid'
   sym_list(1,539) = 'RLIM'; sym_list(2,539) = 'machine_description'
   sym_list(1,540) = 'RLOC_COIL'; sym_list(2,540) = 'machine_description'
   sym_list(1,541) = 'RMAJOR_MEAN'; sym_list(2,541) = 'profile'
   sym_list(1,542) = 'RMINOR_MEAN'; sym_list(2,542) = 'profile'
   sym_list(1,543) = 'RUNAWAY_CODE_INFO'; sym_list(2,543) = 'simulation_initialization'
   sym_list(1,544) = 'RUNID'; sym_list(2,544) = 'simulation_initialization'
   sym_list(1,545) = 'R_ANT'; sym_list(2,545) = 'shot_configuration'
   sym_list(1,546) = 'R_ANTGEO'; sym_list(2,546) = 'machine_description'
   sym_list(1,547) = 'R_AXIS'; sym_list(2,547) = 'state_data'
   sym_list(1,548) = 'R_EC_LAUNCH'; sym_list(2,548) = 'machine_description'
   sym_list(1,549) = 'R_GEO'; sym_list(2,549) = 'profile'
   sym_list(1,550) = 'R_GRID'; sym_list(2,550) = 'grid'
   sym_list(1,551) = 'R_MAX_BOX'; sym_list(2,551) = 'machine_description'
   sym_list(1,552) = 'R_MAX_LCFS'; sym_list(2,552) = 'state_data'
   sym_list(1,553) = 'R_MIDP_IN'; sym_list(2,553) = 'profile'
   sym_list(1,554) = 'R_MIDP_OUT'; sym_list(2,554) = 'profile'
   sym_list(1,555) = 'R_MIN_BOX'; sym_list(2,555) = 'machine_description'
   sym_list(1,556) = 'R_MIN_LCFS'; sym_list(2,556) = 'state_data'
   sym_list(1,557) = 'R_RIPPLE'; sym_list(2,557) = 'grid'
   sym_list(1,558) = 'R_SURFMAX'; sym_list(2,558) = 'profile'
   sym_list(1,559) = 'R_SURFMIN'; sym_list(2,559) = 'profile'
   sym_list(1,560) = 'S0RECO'; sym_list(2,560) = 'profile'
   sym_list(1,561) = 'S0RECO_E'; sym_list(2,561) = 'profile'
   sym_list(1,562) = 'S0RECO_RECAP'; sym_list(2,562) = 'profile'
   sym_list(1,563) = 'SA_INDEX'; sym_list(2,563) = 'simulation_initialization'
   sym_list(1,564) = 'SA_NAME'; sym_list(2,564) = 'species_list'
   sym_list(1,565) = 'SA_TYPE'; sym_list(2,565) = 'species_list'
   sym_list(1,566) = 'SB0HALO'; sym_list(2,566) = 'profile'
   sym_list(1,567) = 'SB0HALO_RECAP'; sym_list(2,567) = 'profile'
   sym_list(1,568) = 'SBEDEP'; sym_list(2,568) = 'profile'
   sym_list(1,569) = 'SBEHALO'; sym_list(2,569) = 'profile'
   sym_list(1,570) = 'SBSCE'; sym_list(2,570) = 'profile'
   sym_list(1,571) = 'SBTHERM'; sym_list(2,571) = 'profile'
   sym_list(1,572) = 'SC0'; sym_list(2,572) = 'state_data'
   sym_list(1,573) = 'SC0_TO_SGAS'; sym_list(2,573) = 'simulation_initialization'
   sym_list(1,574) = 'SC_ANOM'; sym_list(2,574) = 'profile'
   sym_list(1,575) = 'SFSCE'; sym_list(2,575) = 'profile'
   sym_list(1,576) = 'SFTHERM'; sym_list(2,576) = 'profile'
   sym_list(1,577) = 'SFUS_NAME'; sym_list(2,577) = 'species_list'
   sym_list(1,578) = 'SFUS_TO_ALL'; sym_list(2,578) = 'simulation_initialization'
   sym_list(1,579) = 'SFUS_TO_ALLA'; sym_list(2,579) = 'simulation_initialization'
   sym_list(1,580) = 'SFUS_TYPE'; sym_list(2,580) = 'species_list'
   sym_list(1,581) = 'SGAS_NAME'; sym_list(2,581) = 'species_list'
   sym_list(1,582) = 'SGAS_TO_S'; sym_list(2,582) = 'simulation_initialization'
   sym_list(1,583) = 'SGAS_TYPE'; sym_list(2,583) = 'species_list'
   sym_list(1,584) = 'SHOT_NUMBER'; sym_list(2,584) = 'shot_configuration'
   sym_list(1,585) = 'SII_XS'; sym_list(2,585) = 'profile'
   sym_list(1,586) = 'SIMP0_NAME'; sym_list(2,586) = 'species_list'
   sym_list(1,587) = 'SIMP0_TO_S'; sym_list(2,587) = 'simulation_initialization'
   sym_list(1,588) = 'SIMP0_TYPE'; sym_list(2,588) = 'species_list'
   sym_list(1,589) = 'SIMPI_NAME'; sym_list(2,589) = 'species_list'
   sym_list(1,590) = 'SIMPI_TO_S'; sym_list(2,590) = 'simulation_initialization'
   sym_list(1,591) = 'SIMPI_TYPE'; sym_list(2,591) = 'species_list'
   sym_list(1,592) = 'SNBI_NAME'; sym_list(2,592) = 'species_list'
   sym_list(1,593) = 'SNBI_TO_ALL'; sym_list(2,593) = 'simulation_initialization'
   sym_list(1,594) = 'SNBI_TO_ALLA'; sym_list(2,594) = 'simulation_initialization'
   sym_list(1,595) = 'SNBI_TYPE'; sym_list(2,595) = 'species_list'
   sym_list(1,596) = 'SN_TRANS'; sym_list(2,596) = 'profile'
   sym_list(1,597) = 'SN_TRANSCAT'; sym_list(2,597) = 'profile'
   sym_list(1,598) = 'SPROF0'; sym_list(2,598) = 'profile'
   sym_list(1,599) = 'SPROF0E'; sym_list(2,599) = 'profile'
   sym_list(1,600) = 'SPSCE'; sym_list(2,600) = 'profile'
END SUBROUTINE ps_print_category_init6

SUBROUTINE ps_print_category_init7(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,601) = 'SQUARELO'; sym_list(2,601) = 'profile'
   sym_list(1,602) = 'SQUAREUO'; sym_list(2,602) = 'profile'
   sym_list(1,603) = 'SRTCEN'; sym_list(2,603) = 'machine_description'
   sym_list(1,604) = 'SURF'; sym_list(2,604) = 'profile'
   sym_list(1,605) = 'S_NAME'; sym_list(2,605) = 'species_list'
   sym_list(1,606) = 'S_TO_SA'; sym_list(2,606) = 'simulation_initialization'
   sym_list(1,607) = 'S_TYPE'; sym_list(2,607) = 'species_list'
   sym_list(1,608) = 'T0'; sym_list(2,608) = 'state_data'
   sym_list(1,609) = 'T0CX'; sym_list(2,609) = 'profile'
   sym_list(1,610) = 'T0SC0'; sym_list(2,610) = 'profile'
   sym_list(1,611) = 'T0_HALO'; sym_list(2,611) = 'profile'
   sym_list(1,612) = 'T0_RECO'; sym_list(2,612) = 'profile'
   sym_list(1,613) = 'T1'; sym_list(2,613) = 'state_data'
   sym_list(1,614) = 'TEFLUX_KY_TGLF'; sym_list(2,614) = 'profile'
   sym_list(1,615) = 'TE_BDY'; sym_list(2,615) = 'state_data'
   sym_list(1,616) = 'TE_KY_TGLF'; sym_list(2,616) = 'profile'
   sym_list(1,617) = 'TFINAL'; sym_list(2,617) = 'simulation_initialization'
   sym_list(1,618) = 'TFRIP2_LOG'; sym_list(2,618) = 'profile'
   sym_list(1,619) = 'TFRIP_LOG'; sym_list(2,619) = 'profile'
   sym_list(1,620) = 'TF_DATA_INFO'; sym_list(2,620) = 'simulation_initialization'
   sym_list(1,621) = 'THEGRILH'; sym_list(2,621) = 'shot_configuration'
   sym_list(1,622) = 'TH_EQ'; sym_list(2,622) = 'grid'
   sym_list(1,623) = 'TI'; sym_list(2,623) = 'profile'
   sym_list(1,624) = 'TIFLUX_KY_TGLF'; sym_list(2,624) = 'profile'
   sym_list(1,625) = 'TINIT'; sym_list(2,625) = 'simulation_initialization'
   sym_list(1,626) = 'TI_BDY'; sym_list(2,626) = 'state_data'
   sym_list(1,627) = 'TI_KY_TGLF'; sym_list(2,627) = 'profile'
   sym_list(1,628) = 'TMODEL'; sym_list(2,628) = 'profile'
   sym_list(1,629) = 'TMODEL_BDY'; sym_list(2,629) = 'state_data'
   sym_list(1,630) = 'TOKAMAK_ID'; sym_list(2,630) = 'machine_description'
   sym_list(1,631) = 'TORNUM_BALCRIT'; sym_list(2,631) = 'state_data'
   sym_list(1,632) = 'TOR_MODE_LABEL'; sym_list(2,632) = 'item_list'
   sym_list(1,633) = 'TOR_MODE_NO'; sym_list(2,633) = 'simulation_initialization'
   sym_list(1,634) = 'TQ0_RECO'; sym_list(2,634) = 'profile'
   sym_list(1,635) = 'TQB0_HALO'; sym_list(2,635) = 'profile'
   sym_list(1,636) = 'TQBE'; sym_list(2,636) = 'profile'
   sym_list(1,637) = 'TQBI'; sym_list(2,637) = 'profile'
   sym_list(1,638) = 'TQBJXB'; sym_list(2,638) = 'profile'
   sym_list(1,639) = 'TQBTH'; sym_list(2,639) = 'profile'
   sym_list(1,640) = 'TQCX_HALO'; sym_list(2,640) = 'profile'
   sym_list(1,641) = 'TQCX_RECO'; sym_list(2,641) = 'profile'
   sym_list(1,642) = 'TQIONIZ'; sym_list(2,642) = 'profile'
   sym_list(1,643) = 'TQQCX'; sym_list(2,643) = 'profile'
   sym_list(1,644) = 'TQSC_HALO'; sym_list(2,644) = 'profile'
   sym_list(1,645) = 'TQSC_RECO'; sym_list(2,645) = 'profile'
   sym_list(1,646) = 'TQ_ANOM'; sym_list(2,646) = 'profile'
   sym_list(1,647) = 'TQ_TRANS'; sym_list(2,647) = 'profile'
   sym_list(1,648) = 'TQ_TRANSCAT'; sym_list(2,648) = 'profile'
   sym_list(1,649) = 'TRACE_FLAG'; sym_list(2,649) = 'simulation_initialization'
   sym_list(1,650) = 'TRCAT'; sym_list(2,650) = 'item_list'
   sym_list(1,651) = 'TRIANG'; sym_list(2,651) = 'profile'
   sym_list(1,652) = 'TRIANGL'; sym_list(2,652) = 'profile'
   sym_list(1,653) = 'TRIANGU'; sym_list(2,653) = 'profile'
   sym_list(1,654) = 'TRIANG_MILLER_L'; sym_list(2,654) = 'profile'
   sym_list(1,655) = 'TRIANG_MILLER_U'; sym_list(2,655) = 'profile'
   sym_list(1,656) = 'TRMODELS'; sym_list(2,656) = 'simulation_initialization'
   sym_list(1,657) = 'TS'; sym_list(2,657) = 'profile'
   sym_list(1,658) = 'TS_DATA_INFO'; sym_list(2,658) = 'simulation_initialization'
   sym_list(1,659) = 'TS_IS_INPUT'; sym_list(2,659) = 'state_data'
   sym_list(1,660) = 'TZFLUX_KY_TGLF'; sym_list(2,660) = 'profile'
   sym_list(1,661) = 'TZ_KY_TGLF'; sym_list(2,661) = 'profile'
   sym_list(1,662) = 'T_EINJ_STANDARD'; sym_list(2,662) = 'machine_description'
   sym_list(1,663) = 'T_FFULL_STANDARD'; sym_list(2,663) = 'machine_description'
   sym_list(1,664) = 'T_FHALF_STANDARD'; sym_list(2,664) = 'machine_description'
   sym_list(1,665) = 'UPWIND_PFRAC_NS'; sym_list(2,665) = 'profile'
   sym_list(1,666) = 'UPWIND_PFRAC_OMEGA'; sym_list(2,666) = 'profile'
   sym_list(1,667) = 'UPWIND_PFRAC_TE'; sym_list(2,667) = 'profile'
   sym_list(1,668) = 'UPWIND_PFRAC_TI'; sym_list(2,668) = 'profile'
   sym_list(1,669) = 'VEE_TRANS'; sym_list(2,669) = 'profile'
   sym_list(1,670) = 'VEE_TRANSCAT'; sym_list(2,670) = 'profile'
   sym_list(1,671) = 'VELB_FUSI'; sym_list(2,671) = 'profile'
   sym_list(1,672) = 'VELB_NBI'; sym_list(2,672) = 'profile'
   sym_list(1,673) = 'VELB_RFMI'; sym_list(2,673) = 'profile'
   sym_list(1,674) = 'VELNE_NCLASS'; sym_list(2,674) = 'profile'
   sym_list(1,675) = 'VELNH_NCLASS'; sym_list(2,675) = 'profile'
   sym_list(1,676) = 'VELNI_DRBM'; sym_list(2,676) = 'profile'
   sym_list(1,677) = 'VELNS_ANOM'; sym_list(2,677) = 'profile'
   sym_list(1,678) = 'VELNS_GLF'; sym_list(2,678) = 'profile'
   sym_list(1,679) = 'VELNS_GTCNEO'; sym_list(2,679) = 'profile'
   sym_list(1,680) = 'VELNS_MMM71'; sym_list(2,680) = 'profile'
   sym_list(1,681) = 'VELNS_NCLASS'; sym_list(2,681) = 'profile'
   sym_list(1,682) = 'VELNS_NEO'; sym_list(2,682) = 'profile'
   sym_list(1,683) = 'VELNS_TGLF'; sym_list(2,683) = 'profile'
   sym_list(1,684) = 'VELNX_NCLASS'; sym_list(2,684) = 'profile'
   sym_list(1,685) = 'VELPPHI_ANOM'; sym_list(2,685) = 'profile'
   sym_list(1,686) = 'VELPPHI_GLF'; sym_list(2,686) = 'profile'
   sym_list(1,687) = 'VELPPHI_GTCNEO'; sym_list(2,687) = 'profile'
   sym_list(1,688) = 'VELPPHI_MMM71'; sym_list(2,688) = 'profile'
   sym_list(1,689) = 'VELPPHI_NEO'; sym_list(2,689) = 'profile'
   sym_list(1,690) = 'VELPPHI_TGLF'; sym_list(2,690) = 'profile'
   sym_list(1,691) = 'VELTE_ANOM'; sym_list(2,691) = 'profile'
   sym_list(1,692) = 'VELTE_GLF'; sym_list(2,692) = 'profile'
   sym_list(1,693) = 'VELTE_GTCNEO'; sym_list(2,693) = 'profile'
   sym_list(1,694) = 'VELTE_MMM71'; sym_list(2,694) = 'profile'
   sym_list(1,695) = 'VELTE_NCLASS'; sym_list(2,695) = 'profile'
   sym_list(1,696) = 'VELTE_NEO'; sym_list(2,696) = 'profile'
   sym_list(1,697) = 'VELTE_PALEO'; sym_list(2,697) = 'profile'
   sym_list(1,698) = 'VELTE_TGLF'; sym_list(2,698) = 'profile'
   sym_list(1,699) = 'VELTI_ANOM'; sym_list(2,699) = 'profile'
   sym_list(1,700) = 'VELTI_GLF'; sym_list(2,700) = 'profile'
END SUBROUTINE ps_print_category_init7

SUBROUTINE ps_print_category_init8(i1,i2,sym_list)
   implicit none
   integer,      intent(in)    :: i1,i2
   character*32, intent(inout) :: sym_list(i1,i2)

   sym_list(1,701) = 'VELTI_GTCNEO'; sym_list(2,701) = 'profile'
   sym_list(1,702) = 'VELTI_MMM71'; sym_list(2,702) = 'profile'
   sym_list(1,703) = 'VELTI_NCLASS'; sym_list(2,703) = 'profile'
   sym_list(1,704) = 'VELTI_NEO'; sym_list(2,704) = 'profile'
   sym_list(1,705) = 'VELTI_TGLF'; sym_list(2,705) = 'profile'
   sym_list(1,706) = 'VIE_TRANS'; sym_list(2,706) = 'profile'
   sym_list(1,707) = 'VIE_TRANSCAT'; sym_list(2,707) = 'profile'
   sym_list(1,708) = 'VMO_TRANS'; sym_list(2,708) = 'profile'
   sym_list(1,709) = 'VMO_TRANSCAT'; sym_list(2,709) = 'profile'
   sym_list(1,710) = 'VN_TRANS'; sym_list(2,710) = 'profile'
   sym_list(1,711) = 'VN_TRANSCAT'; sym_list(2,711) = 'profile'
   sym_list(1,712) = 'VOL'; sym_list(2,712) = 'profile'
   sym_list(1,713) = 'VPHI0_AV'; sym_list(2,713) = 'state_data'
   sym_list(1,714) = 'VPOL_DATA_INFO'; sym_list(2,714) = 'simulation_initialization'
   sym_list(1,715) = 'VPOL_INMP'; sym_list(2,715) = 'profile'
   sym_list(1,716) = 'VPOL_IS_INPUT'; sym_list(2,716) = 'state_data'
   sym_list(1,717) = 'VPOL_OMP'; sym_list(2,717) = 'profile'
   sym_list(1,718) = 'VREP_COIL_COUNT'; sym_list(2,718) = 'machine_description'
   sym_list(1,719) = 'VREP_COIL_SPACING'; sym_list(2,719) = 'machine_description'
   sym_list(1,720) = 'VSIZE_COIL'; sym_list(2,720) = 'machine_description'
   sym_list(1,721) = 'VSUR'; sym_list(2,721) = 'state_data'
   sym_list(1,722) = 'VSUR_DATA_INFO'; sym_list(2,722) = 'simulation_initialization'
   sym_list(1,723) = 'VTOR_DATA_INFO'; sym_list(2,723) = 'simulation_initialization'
   sym_list(1,724) = 'VTOR_INMP'; sym_list(2,724) = 'profile'
   sym_list(1,725) = 'VTOR_IS_INPUT'; sym_list(2,725) = 'state_data'
   sym_list(1,726) = 'VTOR_OMP'; sym_list(2,726) = 'profile'
   sym_list(1,727) = 'V_LOOP'; sym_list(2,727) = 'profile'
   sym_list(1,728) = 'V_PARS'; sym_list(2,728) = 'profile'
   sym_list(1,729) = 'V_PERS'; sym_list(2,729) = 'profile'
   sym_list(1,730) = 'WT_NPHI'; sym_list(2,730) = 'shot_configuration'
   sym_list(1,731) = 'WT_NPHI_ABS'; sym_list(2,731) = 'state_data'
   sym_list(1,732) = 'WT_NPHI_EXT'; sym_list(2,732) = 'state_data'
   sym_list(1,733) = 'XRJCOS_MOMEQ'; sym_list(2,733) = 'profile'
   sym_list(1,734) = 'XRJSIN_MOMEQ'; sym_list(2,734) = 'profile'
   sym_list(1,735) = 'XS'; sym_list(2,735) = 'state_data'
   sym_list(1,736) = 'XS_NAME'; sym_list(2,736) = 'item_list'
   sym_list(1,737) = 'XZJCOS_MOMEQ'; sym_list(2,737) = 'profile'
   sym_list(1,738) = 'XZJSIN_MOMEQ'; sym_list(2,738) = 'profile'
   sym_list(1,739) = 'Z0MAX'; sym_list(2,739) = 'simulation_initialization'
   sym_list(1,740) = 'Z0_MOMEQ'; sym_list(2,740) = 'profile'
   sym_list(1,741) = 'ZBAP'; sym_list(2,741) = 'machine_description'
   sym_list(1,742) = 'ZBSC'; sym_list(2,742) = 'machine_description'
   sym_list(1,743) = 'ZEFF'; sym_list(2,743) = 'profile'
   sym_list(1,744) = 'ZEFF_DATA_INFO'; sym_list(2,744) = 'simulation_initialization'
   sym_list(1,745) = 'ZEFF_FI'; sym_list(2,745) = 'profile'
   sym_list(1,746) = 'ZEFF_TH'; sym_list(2,746) = 'profile'
   sym_list(1,747) = 'ZIMP1'; sym_list(2,747) = 'simulation_initialization'
   sym_list(1,748) = 'ZIMP2'; sym_list(2,748) = 'simulation_initialization'
   sym_list(1,749) = 'ZLIM'; sym_list(2,749) = 'machine_description'
   sym_list(1,750) = 'ZLOC_COIL'; sym_list(2,750) = 'machine_description'
   sym_list(1,751) = 'Z_ANT'; sym_list(2,751) = 'shot_configuration'
   sym_list(1,752) = 'Z_ANTGEO'; sym_list(2,752) = 'machine_description'
   sym_list(1,753) = 'Z_AXIS'; sym_list(2,753) = 'state_data'
   sym_list(1,754) = 'Z_EC_LAUNCH'; sym_list(2,754) = 'machine_description'
   sym_list(1,755) = 'Z_GEO'; sym_list(2,755) = 'profile'
   sym_list(1,756) = 'Z_GRID'; sym_list(2,756) = 'grid'
   sym_list(1,757) = 'Z_MAX_BOX'; sym_list(2,757) = 'machine_description'
   sym_list(1,758) = 'Z_MAX_LCFS'; sym_list(2,758) = 'state_data'
   sym_list(1,759) = 'Z_MIDP'; sym_list(2,759) = 'profile'
   sym_list(1,760) = 'Z_MID_ANT'; sym_list(2,760) = 'shot_configuration'
   sym_list(1,761) = 'Z_MIN_BOX'; sym_list(2,761) = 'machine_description'
   sym_list(1,762) = 'Z_MIN_LCFS'; sym_list(2,762) = 'state_data'
   sym_list(1,763) = 'Z_RIPPLE'; sym_list(2,763) = 'grid'
   sym_list(1,764) = 'Z_SURFMAX'; sym_list(2,764) = 'profile'
   sym_list(1,765) = 'Z_SURFMIN'; sym_list(2,765) = 'profile'
END SUBROUTINE ps_print_category_init8

subroutine tdb_get_rzgrids(d,inumR,Rgrid,inumZ,Zgrid,ier)

  !  get R and Z grids -- but, passed argument grid sizes must match or
  !  an error code is set and a message is printed.

  !  see sister subroutine "tdb_get_rzsizes"...

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d

  integer,intent(in) :: inumR,inumZ   ! the grid sizes
  real*8 :: Rgrid(inumR),Zgrid(inumZ) ! the grids, set if sizes match
  integer, intent(out) :: ier         ! status code: 0=OK

  !------------------------------------
  integer :: nonlin,lunmsg_tdb
  !------------------------------------

  ier = 0

  nonlin = lunmsg_tdb(0)

  if(inumR.ne.d%nRpsi) then
     ier = ier + 1
     write(nonlin,*) ' ?tdb_get_RZgrids: R grid size mismatch.'
     write(nonlin,*) '  Correct size is: ',d%nRpsi,'; passed size is: ',inumR
  endif

  if(inumZ.ne.d%nZpsi) then
     ier = ier + 1
     write(nonlin,*) ' ?tdb_get_RZgrids: Z grid size mismatch.'
     write(nonlin,*) '  Correct size is: ',d%nZpsi,'; passed size is: ',inumZ
  endif

  if(ier.ne.0) return

  if(inumR.gt.0) then
     Rgrid = d%datbuf(d%lRpsi:d%lRpsi+d%nRpsi-1)
  endif

  if(inumZ.gt.0) then
     Zgrid = d%datbuf(d%lZpsi:d%lZpsi+d%nZpsi-1)
  endif

end subroutine tdb_get_rzgrids

subroutine ps_xpdebug(iobj)

  !------------------------------------------------------------
  ! D. McCune May 11 2009

  ! access xplasma debug plots -- DEBUG COMPILE to get this access
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
#ifdef __DEBUG
  use eqi_intg_module     ! sp_debug pointer
#endif

  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)       ! xplasma opaque container
  !--------------------------------------------------
  type (interp_object) :: xobj
  !--------------------------------------------------

#ifdef __DEBUG
  xobj = transfer(iobj,xobj)
  sp_debug => xobj%s_xpobj

  call xplasma_debug
#else
  write(6,*) ' ?ps_xpdebug -- dummy code called.'
#endif

end subroutine ps_xpdebug

subroutine tdb_merge_test(id,ivala,ivalb,inum,itest)

  ! steering merge test primitive for two trdatbuf objects
  !
  ! return TRUE if item is steerable (value allowed to change)
  !  or if item is not steerable but all values are identical.

  character*(*), intent(in) :: id  ! identifier
  integer, intent(in) :: inum      ! array sizes
  integer, intent(in) :: ivala(inum),ivalb(inum)  ! actual values (dataset a&b)
  logical, intent(out) :: itest    ! result of current test

  !--------------
  logical tdb_steerxcep
  integer :: i,ilev,imin,imax
  !--------------

  itest = tdb_steerxcep(id,ilev)
  if(itest) then
     if(ilev.eq.1) then
        continue  ! change in value is allowed (unconditional)
     else
        ! not allowed to have one element zero and the other non-zero, but,
        ! other changes in value are allowed
        do i=1,inum
           imin=min(abs(ivala(i)),abs(ivalb(i)))
           imax=max(abs(ivala(i)),abs(ivalb(i)))
           if((imin.le.0).and.(imax.ne.0)) then
              itest=.FALSE.
              exit
           endif
        enddo
     endif
  else
     ! change in value not allowed: test
     do i=1,inum
        itest = ivala(i).eq.ivalb(i)
        if(.not.itest) exit
     enddo
  endif

end subroutine tdb_merge_test

subroutine trx_uget(ident,ixid,zname,zunits,istat,ierr)
!
  use trx_module
  implicit NONE
!
!  return the name & units of the item associated with xplasma id "ident".
!
  integer, intent(in) :: ident         ! xplasma id of item
  integer, intent(out) :: ixid         ! x-axis id of item (0 if not 1d).
  character(10), intent(out) :: zname  ! name of item
  character(10), intent(out) :: zunits ! physical units
  integer, intent(out) :: istat        ! MKS status (0=OK, 1=warning)
  integer, intent(out) :: ierr         ! completion code, 0=OK
!
!---------------------------------------
! get xplasma name
!
  call eq_get_fname(ident,zname)
  if(zname.eq.' ') then
     ierr=1
  else
     ierr=0
     zunits=prof_units(ident)
     istat=units_status(ident)
     if(istat.lt.0) ierr=1
     ixid=xaxis_id(ident)
     if(ixid.lt.0) ierr=1
  endif
!
  return
end subroutine trx_uget
 
subroutine trx_uget_next(ident)
!
  use trx_module
  implicit NONE
!
!   return id of next item with units
!
  integer, intent(inout) :: ident      ! search start / search result
!
!   on input, ident gives search start point:  start at (ident+1)
!  on output, ident=N means item N is next; ident=0 means no more items.
!
  integer jdent
!
  do while (ident.lt.maxid)
     ident=ident+1
     if(units_status(ident).ge.0) return
  end do
  ident = 0
  return
end subroutine trx_uget_next

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_1(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF(partial_copy) THEN
     ss2%id_chii_ntm = 0
  ENDIF
  IF((ALLOCATED(ss%chii_ntm).AND.ALLOCATED(ss2%chii_ntm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_ntm = ss%chii_ntm
     IF(.not.partial_copy) THEN
        ss2%id_chii_ntm = ss%id_chii_ntm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%chii_tglf).AND.ALLOCATED(ss2%chii_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_tglf = ss%chii_tglf
     IF(.not.partial_copy) THEN
        ss2%id_chii_tglf = ss%id_chii_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_trans = 0
  ENDIF
  IF((ALLOCATED(ss%chii_trans).AND.ALLOCATED(ss2%chii_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chii_trans = ss%chii_trans
     IF(.not.partial_copy) THEN
        ss2%id_chii_trans = ss%id_chii_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_chii_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_chii_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%chii_transcat).AND.ALLOCATED(ss2%chii_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chii_transcat = ss%chii_transcat
     IF(ALLOCATED(ss2%id_chii_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_chii_transcat = ss%id_chii_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chii_w19 = 0
  ENDIF
  IF((ALLOCATED(ss%chii_w19).AND.ALLOCATED(ss2%chii_w19)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chii_w19 = ss%chii_w19
     IF(.not.partial_copy) THEN
        ss2%id_chii_w19 = ss%id_chii_w19
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chimo_trans = 0
  ENDIF
  IF((ALLOCATED(ss%chimo_trans).AND.ALLOCATED(ss2%chimo_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chimo_trans = ss%chimo_trans
     IF(.not.partial_copy) THEN
        ss2%id_chimo_trans = ss%id_chimo_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_chimo_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_chimo_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%chimo_transcat).AND.ALLOCATED(ss2%chimo_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%chimo_transcat = ss%chimo_transcat
     IF(ALLOCATED(ss2%id_chimo_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_chimo_transcat = ss%id_chimo_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_anom = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_anom).AND.ALLOCATED(ss2%chiphi_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_anom = ss%chiphi_anom
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_anom = ss%id_chiphi_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_drbm).AND.ALLOCATED(ss2%chiphi_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_drbm = ss%chiphi_drbm
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_drbm = ss%id_chiphi_drbm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_glf = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_glf).AND.ALLOCATED(ss2%chiphi_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_glf = ss%chiphi_glf
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_glf = ss%id_chiphi_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_gtcneo).AND.ALLOCATED(ss2%chiphi_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_gtcneo = ss%chiphi_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_gtcneo = ss%id_chiphi_gtcneo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_mmm71).AND.ALLOCATED(ss2%chiphi_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_mmm71 = ss%chiphi_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_mmm71 = ss%id_chiphi_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_neo = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_neo).AND.ALLOCATED(ss2%chiphi_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_neo = ss%chiphi_neo
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_neo = ss%id_chiphi_neo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_tglf).AND.ALLOCATED(ss2%chiphi_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_tglf = ss%chiphi_tglf
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_tglf = ss%id_chiphi_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chiphi_w19 = 0
  ENDIF
  IF((ALLOCATED(ss%chiphi_w19).AND.ALLOCATED(ss2%chiphi_w19)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chiphi_w19 = ss%chiphi_w19
     IF(.not.partial_copy) THEN
        ss2%id_chiphi_w19 = ss%id_chiphi_w19
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_chitheta_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%chitheta_mmm71).AND.ALLOCATED(ss2%chitheta_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%chitheta_mmm71 = ss%chitheta_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_chitheta_mmm71 = ss%id_chitheta_mmm71
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%circuit_name)).AND.(ALLOCATED(ss%circuit_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%circuit_name = ss%circuit_name
  ENDIF
  IF( ((ALLOCATED(ss2%coil_apt)).AND.(ALLOCATED(ss%coil_apt))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%coil_apt = ss%coil_apt
  ENDIF
  IF( ((ALLOCATED(ss2%coil_in_circuit)).AND.(ALLOCATED(ss%coil_in_circuit))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%coil_in_circuit = ss%coil_in_circuit
  ENDIF
  IF( ((ALLOCATED(ss2%coil_name)).AND.(ALLOCATED(ss%coil_name))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%coil_name = ss%coil_name
  ENDIF
  IF( ((ALLOCATED(ss2%coil_resispt)).AND.(ALLOCATED(ss%coil_resispt))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_EQ).EQ.1)) ) THEN
     ss2%coil_resispt = ss%coil_resispt
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curbeam = 0
  ENDIF
  IF((ALLOCATED(ss%curbeam).AND.ALLOCATED(ss2%curbeam)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%curbeam = ss%curbeam
     IF(.not.partial_copy) THEN
        ss2%id_curbeam = ss%id_curbeam
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curech = 0
  ENDIF
  IF((ALLOCATED(ss%curech).AND.ALLOCATED(ss2%curech)).AND. &
        ((cclist(ps_cnum_EC).EQ.1))) THEN
     ss2%curech = ss%curech
     IF(.not.partial_copy) THEN
        ss2%id_curech = ss%id_curech
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_curech_src)) THEN
     IF(partial_copy) THEN
        ss2%id_curech_src = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%curech_src).AND.ALLOCATED(ss2%curech_src)).AND. &
        ((cclist(ps_cnum_EC).EQ.1))) THEN
     ss2%curech_src = ss%curech_src
     IF(ALLOCATED(ss2%id_curech_src)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_curech_src = ss%id_curech_src
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curfusn = 0
  ENDIF
  IF((ALLOCATED(ss%curfusn).AND.ALLOCATED(ss2%curfusn)).AND. &
        ((cclist(ps_cnum_FUS).EQ.1))) THEN
     ss2%curfusn = ss%curfusn
     IF(.not.partial_copy) THEN
        ss2%id_curfusn = ss%id_curfusn
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curich = 0
  ENDIF
  IF((ALLOCATED(ss%curich).AND.ALLOCATED(ss2%curich)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%curich = ss%curich
     IF(.not.partial_copy) THEN
        ss2%id_curich = ss%id_curich
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curlh = 0
  ENDIF
  IF((ALLOCATED(ss%curlh).AND.ALLOCATED(ss2%curlh)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%curlh = ss%curlh
     IF(.not.partial_copy) THEN
        ss2%id_curlh = ss%id_curlh
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_curlh_src)) THEN
     IF(partial_copy) THEN
        ss2%id_curlh_src = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%curlh_src).AND.ALLOCATED(ss2%curlh_src)).AND. &
        ((cclist(ps_cnum_LH).EQ.1))) THEN
     ss2%curlh_src = ss%curlh_src
     IF(ALLOCATED(ss2%id_curlh_src)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_curlh_src = ss%id_curlh_src
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curmino = 0
  ENDIF
  IF((ALLOCATED(ss%curmino).AND.ALLOCATED(ss2%curmino)).AND. &
        ((cclist(ps_cnum_IC).EQ.1))) THEN
     ss2%curmino = ss%curmino
     IF(.not.partial_copy) THEN
        ss2%id_curmino = ss%id_curmino
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curr_bootstrap = 0
  ENDIF
  IF((ALLOCATED(ss%curr_bootstrap).AND.ALLOCATED(ss2%curr_bootstrap)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%curr_bootstrap = ss%curr_bootstrap
     IF(.not.partial_copy) THEN
        ss2%id_curr_bootstrap = ss%id_curr_bootstrap
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curr_ohmic = 0
  ENDIF
  IF((ALLOCATED(ss%curr_ohmic).AND.ALLOCATED(ss2%curr_ohmic)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%curr_ohmic = ss%curr_ohmic
     IF(.not.partial_copy) THEN
        ss2%id_curr_ohmic = ss%id_curr_ohmic
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_curt = 0
  ENDIF
  IF((ALLOCATED(ss%curt).AND.ALLOCATED(ss2%curt)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%curt = ss%curt
     IF(.not.partial_copy) THEN
        ss2%id_curt = ss%id_curt
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%CUR_Data_Info = ss%CUR_Data_Info
  ENDIF
  IF(partial_copy) THEN
     ss2%id_cur_rw = 0
  ENDIF
  IF((ALLOCATED(ss%cur_rw).AND.ALLOCATED(ss2%cur_rw)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%cur_rw = ss%cur_rw
     IF(.not.partial_copy) THEN
        ss2%id_cur_rw = ss%id_cur_rw
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%d2R_geo_dRHOdTH).AND.ALLOCATED(ss2%d2R_geo_dRHOdTH)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%d2R_geo_dRHOdTH = ss%d2R_geo_dRHOdTH
  ENDIF
  IF((ALLOCATED(ss%d2Z_geo_dRHOdTH).AND.ALLOCATED(ss2%d2Z_geo_dRHOdTH)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%d2Z_geo_dRHOdTH = ss%d2Z_geo_dRHOdTH
  ENDIF
  IF(partial_copy) THEN
     ss2%id_db_mtm = 0
  ENDIF
  IF((ALLOCATED(ss%db_mtm).AND.ALLOCATED(ss2%db_mtm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%db_mtm = ss%db_mtm
     IF(.not.partial_copy) THEN
        ss2%id_db_mtm = ss%id_db_mtm
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_dcur_rw_dVloop = 0
  ENDIF
  IF((ALLOCATED(ss%dcur_rw_dVloop).AND.ALLOCATED(ss2%dcur_rw_dVloop)).AND. &
        ((cclist(ps_cnum_RUNAWAY).EQ.1))) THEN
     ss2%dcur_rw_dVloop = ss%dcur_rw_dVloop
     IF(.not.partial_copy) THEN
        ss2%id_dcur_rw_dVloop = ss%id_dcur_rw_dVloop
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%DeltaW_code)).AND.(ALLOCATED(ss%DeltaW_code))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%DeltaW_code = ss%DeltaW_code
  ENDIF
  IF( ((ALLOCATED(ss2%DeltaW_mapper)).AND.(ALLOCATED(ss%DeltaW_mapper))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%DeltaW_mapper = ss%DeltaW_mapper
  ENDIF
  IF( ((ALLOCATED(ss2%DeltaW_stable)).AND.(ALLOCATED(ss%DeltaW_stable))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%DeltaW_stable = ss%DeltaW_stable
  ENDIF
  IF( ((ALLOCATED(ss2%DeltaW_status)).AND.(ALLOCATED(ss%DeltaW_status))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%DeltaW_status = ss%DeltaW_status
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difb_fusi = 0
  ENDIF
  IF((ALLOCATED(ss%difb_fusi).AND.ALLOCATED(ss2%difb_fusi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difb_fusi = ss%difb_fusi
     IF(.not.partial_copy) THEN
        ss2%id_difb_fusi = ss%id_difb_fusi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difb_nbi = 0
  ENDIF
  IF((ALLOCATED(ss%difb_nbi).AND.ALLOCATED(ss2%difb_nbi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difb_nbi = ss%difb_nbi
     IF(.not.partial_copy) THEN
        ss2%id_difb_nbi = ss%id_difb_nbi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difb_rfmi = 0
  ENDIF
  IF((ALLOCATED(ss%difb_rfmi).AND.ALLOCATED(ss2%difb_rfmi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difb_rfmi = ss%difb_rfmi
     IF(.not.partial_copy) THEN
        ss2%id_difb_rfmi = ss%id_difb_rfmi
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_diff_trans)) THEN
     IF(partial_copy) THEN
        ss2%id_diff_trans = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%diff_trans).AND.ALLOCATED(ss2%diff_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%diff_trans = ss%diff_trans
     IF(ALLOCATED(ss2%id_diff_trans)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_diff_trans = ss%id_diff_trans
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_diff_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_diff_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%diff_transcat).AND.ALLOCATED(ss2%diff_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%diff_transcat = ss%diff_transcat
     IF(ALLOCATED(ss2%id_diff_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_diff_transcat = ss%id_diff_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difne_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%difne_nclass).AND.ALLOCATED(ss2%difne_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difne_nclass = ss%difne_nclass
     IF(.not.partial_copy) THEN
        ss2%id_difne_nclass = ss%id_difne_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difnh_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%difnh_nclass).AND.ALLOCATED(ss2%difnh_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difnh_nclass = ss%difnh_nclass
     IF(.not.partial_copy) THEN
        ss2%id_difnh_nclass = ss%id_difnh_nclass
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_anom)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_anom = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_anom).AND.ALLOCATED(ss2%difns_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_anom = ss%difns_anom
     IF(ALLOCATED(ss2%id_difns_anom)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_anom = ss%id_difns_anom
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_drbm)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_drbm = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_drbm).AND.ALLOCATED(ss2%difns_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_drbm = ss%difns_drbm
     IF(ALLOCATED(ss2%id_difns_drbm)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_drbm = ss%id_difns_drbm
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_glf)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_glf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_glf).AND.ALLOCATED(ss2%difns_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_glf = ss%difns_glf
     IF(ALLOCATED(ss2%id_difns_glf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_glf = ss%id_difns_glf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_gtcneo)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_gtcneo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_gtcneo).AND.ALLOCATED(ss2%difns_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_gtcneo = ss%difns_gtcneo
     IF(ALLOCATED(ss2%id_difns_gtcneo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_gtcneo = ss%id_difns_gtcneo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_mmm71)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_mmm71 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_mmm71).AND.ALLOCATED(ss2%difns_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_mmm71 = ss%difns_mmm71
     IF(ALLOCATED(ss2%id_difns_mmm71)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_mmm71 = ss%id_difns_mmm71
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_nclass)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_nclass = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_nclass).AND.ALLOCATED(ss2%difns_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_nclass = ss%difns_nclass
     IF(ALLOCATED(ss2%id_difns_nclass)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_nclass = ss%id_difns_nclass
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_neo)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_neo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_neo).AND.ALLOCATED(ss2%difns_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_neo = ss%difns_neo
     IF(ALLOCATED(ss2%id_difns_neo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_neo = ss%id_difns_neo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_tglf).AND.ALLOCATED(ss2%difns_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_tglf = ss%difns_tglf
     IF(ALLOCATED(ss2%id_difns_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_tglf = ss%id_difns_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_difns_w19)) THEN
     IF(partial_copy) THEN
        ss2%id_difns_w19 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%difns_w19).AND.ALLOCATED(ss2%difns_w19)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difns_w19 = ss%difns_w19
     IF(ALLOCATED(ss2%id_difns_w19)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_difns_w19 = ss%id_difns_w19
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difnx_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%difnx_nclass).AND.ALLOCATED(ss2%difnx_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difnx_nclass = ss%difnx_nclass
     IF(.not.partial_copy) THEN
        ss2%id_difnx_nclass = ss%id_difnx_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_difnz_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%difnz_mmm71).AND.ALLOCATED(ss2%difnz_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%difnz_mmm71 = ss%difnz_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_difnz_mmm71 = ss%id_difnz_mmm71
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%dist_fun)).AND.(ALLOCATED(ss%dist_fun))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%dist_fun = ss%dist_fun
  ENDIF
  IF((cclist(ps_cnum_GAS).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%dn0out = ss%dn0out
  ENDIF
  IF(partial_copy) THEN
     ss2%id_dQedGrdte_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%dQedGrdte_tglf).AND.ALLOCATED(ss2%dQedGrdte_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%dQedGrdte_tglf = ss%dQedGrdte_tglf
     IF(.not.partial_copy) THEN
        ss2%id_dQedGrdte_tglf = ss%id_dQedGrdte_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_dQedGrdti_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%dQedGrdti_tglf).AND.ALLOCATED(ss2%dQedGrdti_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%dQedGrdti_tglf = ss%dQedGrdti_tglf
     IF(.not.partial_copy) THEN
        ss2%id_dQedGrdti_tglf = ss%id_dQedGrdti_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_dQidGrdte_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%dQidGrdte_tglf).AND.ALLOCATED(ss2%dQidGrdte_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%dQidGrdte_tglf = ss%dQidGrdte_tglf
     IF(.not.partial_copy) THEN
        ss2%id_dQidGrdte_tglf = ss%id_dQidGrdte_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_dQidGrdti_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%dQidGrdti_tglf).AND.ALLOCATED(ss2%dQidGrdti_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%dQidGrdti_tglf = ss%dQidGrdti_tglf
     IF(.not.partial_copy) THEN
        ss2%id_dQidGrdti_tglf = ss%id_dQidGrdti_tglf
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%dR0_momeq_dRHO).AND.ALLOCATED(ss2%dR0_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%dR0_momeq_dRHO = ss%dR0_momeq_dRHO
  ENDIF
  IF((ALLOCATED(ss%dR_geo_dRHO).AND.ALLOCATED(ss2%dR_geo_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dR_geo_dRHO = ss%dR_geo_dRHO
  ENDIF
  IF((ALLOCATED(ss%dR_geo_dTH).AND.ALLOCATED(ss2%dR_geo_dTH)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dR_geo_dTH = ss%dR_geo_dTH
  ENDIF
  IF((ALLOCATED(ss%dxRjcos_momeq_dRHO).AND.ALLOCATED(ss2%dxRjcos_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dxRjcos_momeq_dRHO = ss%dxRjcos_momeq_dRHO
  ENDIF
  IF((ALLOCATED(ss%dxRjsin_momeq_dRHO).AND.ALLOCATED(ss2%dxRjsin_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dxRjsin_momeq_dRHO = ss%dxRjsin_momeq_dRHO
  ENDIF
  IF((ALLOCATED(ss%dxZjcos_momeq_dRHO).AND.ALLOCATED(ss2%dxZjcos_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dxZjcos_momeq_dRHO = ss%dxZjcos_momeq_dRHO
  ENDIF
  IF((ALLOCATED(ss%dxZjsin_momeq_dRHO).AND.ALLOCATED(ss2%dxZjsin_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dxZjsin_momeq_dRHO = ss%dxZjsin_momeq_dRHO
  ENDIF
  IF( ((ALLOCATED(ss2%dx_fshield)).AND.(ALLOCATED(ss%dx_fshield))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_IC).EQ.1)) ) THEN
     ss2%dx_fshield = ss%dx_fshield
  ENDIF
  IF((ALLOCATED(ss%dZ0_momeq_dRHO).AND.ALLOCATED(ss2%dZ0_momeq_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1).OR.(iwant_1deq.eq.1))) THEN
     ss2%dZ0_momeq_dRHO = ss%dZ0_momeq_dRHO
  ENDIF
  IF((ALLOCATED(ss%dZ_geo_dRHO).AND.ALLOCATED(ss2%dZ_geo_dRHO)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dZ_geo_dRHO = ss%dZ_geo_dRHO
  ENDIF
  IF((ALLOCATED(ss%dZ_geo_dTH).AND.ALLOCATED(ss2%dZ_geo_dTH)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%dZ_geo_dTH = ss%dZ_geo_dTH
  ENDIF

END SUBROUTINE plasma_state_copy_1

module tr_getnl
!
  save
!
!  namelist text
!
  integer :: nltext_status = 99  ! -1 -- not read, 0 -- read, 1 -- error
  integer :: nltext_nlines = 0   ! #of lines in namelist text
  integer :: mltext_nlines = 0   ! #of lines in expanded namelist text
  character(120), dimension(:), allocatable :: nltext
  character(120), dimension(:), allocatable :: mltext
  integer, dimension(:), allocatable :: nltext_lens
  integer, dimension(:), allocatable :: mltext_lens
!
end module

 
SUBROUTINE trdatbuf_intmod_sub1(ivarname,ivarsize,idim)
  ! ** gensis_f90.py generated code, do NOT edit **
 
  IMPLICIT NONE
 
  integer :: idim
  character*(*) ivarname(idim)
  integer ivarsize(idim)
 
      ivarname(1) = 'LADR_ZA'
      ivarname(2) = 'LADR_ZAF'
      ivarname(3) = 'LAEPDE'
      ivarname(4) = 'LAEPDP'
      ivarname(5) = 'LAEPE'
      ivarname(6) = 'LAEPMAP'
      ivarname(7) = 'LAEPMU'
      ivarname(8) = 'LAEPP'
      ivarname(9) = 'LAEPSP'
      ivarname(10) = 'LAEPTS'
      ivarname(11) = 'LAIMPS'
      ivarname(12) = 'LAIMPX'
      ivarname(13) = 'LDATALP'
      ivarname(14) = 'LDATBDI'
      ivarname(15) = 'LDATCUR'
      ivarname(16) = 'LDATDFL'
      ivarname(17) = 'LDATDTG'
      ivarname(18) = 'LDATDTS'
      ivarname(19) = 'LDATDTX'
      ivarname(20) = 'LDATEDI'
      ivarname(21) = 'LDATEHP'
      ivarname(22) = 'LDATELI'
      ivarname(23) = 'LDATFGW'
      ivarname(24) = 'LDATFIE'
      ivarname(25) = 'LDATFMN'
      ivarname(26) = 'LDATFMX'
      ivarname(27) = 'LDATGAS'
      ivarname(28) = 'LDATGF3'
      ivarname(29) = 'LDATGF4'
      ivarname(30) = 'LDATGF6'
      ivarname(31) = 'LDATGFD'
      ivarname(32) = 'LDATGFH'
      ivarname(33) = 'LDATGFT'
      ivarname(34) = 'LDATGIE'
      ivarname(35) = 'LDATHAL'
      ivarname(36) = 'LDATIBM'
      ivarname(37) = 'LDATIEC'
      ivarname(38) = 'LDATIIC'
      ivarname(39) = 'LDATILH'
      ivarname(40) = 'LDATL2B'
      ivarname(41) = 'LDATLAD'
      ivarname(42) = 'LDATLID'
      ivarname(43) = 'LDATNTX'
      ivarname(44) = 'LDATOGF'
      ivarname(45) = 'LDATORC'
      ivarname(46) = 'LDATPBE'
      ivarname(47) = 'LDATPBI'
      ivarname(48) = 'LDATPEB'
      ivarname(49) = 'LDATPEC'
      ivarname(50) = 'LDATPF0'
      ivarname(51) = 'LDATPFH'
      ivarname(52) = 'LDATPFL'
      ivarname(53) = 'LDATPIB'
      ivarname(54) = 'LDATPIC'
      ivarname(55) = 'LDATPLF'
      ivarname(56) = 'LDATPLH'
      ivarname(57) = 'LDATPOS'
      ivarname(58) = 'LDATRBZ'
      ivarname(59) = 'LDATRC3'
      ivarname(60) = 'LDATRC4'
      ivarname(61) = 'LDATRC6'
      ivarname(62) = 'LDATRCD'
      ivarname(63) = 'LDATRCH'
      ivarname(64) = 'LDATRCT'
      ivarname(65) = 'LDATRCY'
      ivarname(66) = 'LDATRMN'
      ivarname(67) = 'LDATRTP'
      ivarname(68) = 'LDATSBT'
      ivarname(69) = 'LDATSF3'
      ivarname(70) = 'LDATSFA'
      ivarname(71) = 'LDATSFL'
      ivarname(72) = 'LDATSFP'
      ivarname(73) = 'LDATSFT'
      ivarname(74) = 'LDATSP3'
      ivarname(75) = 'LDATTET'
      ivarname(76) = 'LDATTGF'
      ivarname(77) = 'LDATTIT'
      ivarname(78) = 'LDATTPI'
      ivarname(79) = 'LDATTQT'
      ivarname(80) = 'LDATTRC'
      ivarname(81) = 'LDATTRF'
      ivarname(82) = 'LDATTXI'
      ivarname(83) = 'LDATVPH'
      ivarname(84) = 'LDATVSB'
      ivarname(85) = 'LDATVSF'
      ivarname(86) = 'LDATXKF'
      ivarname(87) = 'LDATZEF'
      ivarname(88) = 'LDATZFA'
      ivarname(89) = 'LDATZIM'
      ivarname(90) = 'LDATZPL'
      ivarname(91) = 'LDMDF'
      ivarname(92) = 'LDMFR'
      ivarname(93) = 'LDMMX'
      ivarname(94) = 'LDMSE'
      ivarname(95) = 'LDPFC'
      ivarname(96) = 'LDPFC_PRE'
      ivarname(97) = 'LEFD0'
      ivarname(98) = 'LEFDB'
      ivarname(99) = 'LEFDP'
      ivarname(100) = 'LEFDQ'
      ivarname(101) = 'LEFDR'
      ivarname(102) = 'LEFDS'
      ivarname(103) = 'LFAEPA'
      ivarname(104) = 'LFAEPP'
      ivarname(105) = 'LFAXR'
      ivarname(106) = 'LFBOL'
      ivarname(107) = 'LFBPA'
      ivarname(108) = 'LFBPB'
      ivarname(109) = 'LFD2F'
      ivarname(110) = 'LFDE2'
      ivarname(111) = 'LFDF3'
      ivarname(112) = 'LFDF4'
      ivarname(113) = 'LFDF6'
      ivarname(114) = 'LFDFD'
      ivarname(115) = 'LFDFH'
      ivarname(116) = 'LFDFT'
      ivarname(117) = 'LFECA'
      ivarname(118) = 'LFECB'
      ivarname(119) = 'LFECF'
      ivarname(120) = 'LFFD0'
      ivarname(121) = 'LFFDB'
      ivarname(122) = 'LFFDP'
      ivarname(123) = 'LFFDQ'
      ivarname(124) = 'LFFDR'
      ivarname(125) = 'LFFDS'
      ivarname(126) = 'LFFEH'
      ivarname(127) = 'LFFEL'
      ivarname(128) = 'LFGRB'
      ivarname(129) = 'LFIBE'
      ivarname(130) = 'LFIBI'
      ivarname(131) = 'LFJBM'
      ivarname(132) = 'LFJEC'
      ivarname(133) = 'LFJIC'
      ivarname(134) = 'LFLF3'
      ivarname(135) = 'LFLF4'
      ivarname(136) = 'LFLF6'
      ivarname(137) = 'LFLFD'
      ivarname(138) = 'LFLFH'
      ivarname(139) = 'LFLFT'
      ivarname(140) = 'LFLHE'
      ivarname(141) = 'LFLHJ'
      ivarname(142) = 'LFMSE'
      ivarname(143) = 'LFNER'
      ivarname(144) = 'LFNI3'
      ivarname(145) = 'LFNI4'
      ivarname(146) = 'LFNI6'
      ivarname(147) = 'LFNID'
      ivarname(148) = 'LFNIH'
      ivarname(149) = 'LFNIM'
      ivarname(150) = 'LFNIT'
      ivarname(151) = 'LFNMR'
      ivarname(152) = 'LFOMG'
      ivarname(153) = 'LFPRS'
      ivarname(154) = 'LFPSI'
      ivarname(155) = 'LFQBE'
      ivarname(156) = 'LFQBI'
      ivarname(157) = 'LFQEC'
      ivarname(158) = 'LFQIC'
      ivarname(159) = 'LFQPR'
      ivarname(160) = 'LFREE'
      ivarname(161) = 'LFRES'
      ivarname(162) = 'LFRQRFF'
      ivarname(163) = 'LFSBI'
      ivarname(164) = 'LFSIM'
      ivarname(165) = 'LFSYAXR'
      ivarname(166) = 'LFSYBOL'
      ivarname(167) = 'LFSYBPA'
      ivarname(168) = 'LFSYBPB'
      ivarname(169) = 'LFSYD2F'
      ivarname(170) = 'LFSYDE2'
      ivarname(171) = 'LFSYDF3'
      ivarname(172) = 'LFSYDF4'
      ivarname(173) = 'LFSYDF6'
      ivarname(174) = 'LFSYDFD'
      ivarname(175) = 'LFSYDFH'
      ivarname(176) = 'LFSYDFT'
      ivarname(177) = 'LFSYECF'
      ivarname(178) = 'LFSYFEH'
      ivarname(179) = 'LFSYFEL'
      ivarname(180) = 'LFSYGRB'
      ivarname(181) = 'LFSYIBE'
      ivarname(182) = 'LFSYIBI'
      ivarname(183) = 'LFSYJBM'
      ivarname(184) = 'LFSYJEC'
      ivarname(185) = 'LFSYJIC'
      ivarname(186) = 'LFSYLF3'
      ivarname(187) = 'LFSYLF4'
      ivarname(188) = 'LFSYLF6'
      ivarname(189) = 'LFSYLFD'
      ivarname(190) = 'LFSYLFH'
      ivarname(191) = 'LFSYLFT'
      ivarname(192) = 'LFSYLHE'
      ivarname(193) = 'LFSYLHJ'
      ivarname(194) = 'LFSYMSE'
      ivarname(195) = 'LFSYNER'
      ivarname(196) = 'LFSYNI3'
      ivarname(197) = 'LFSYNI4'
      ivarname(198) = 'LFSYNI6'
      ivarname(199) = 'LFSYNID'
      ivarname(200) = 'LFSYNIH'
      ivarname(201) = 'LFSYNIM'
      ivarname(202) = 'LFSYNIT'
      ivarname(203) = 'LFSYNMR'
      ivarname(204) = 'LFSYOMG'
      ivarname(205) = 'LFSYPRS'
      ivarname(206) = 'LFSYQBE'
      ivarname(207) = 'LFSYQBI'
      ivarname(208) = 'LFSYQEC'
      ivarname(209) = 'LFSYQIC'
      ivarname(210) = 'LFSYQPR'
      ivarname(211) = 'LFSYRES'
      ivarname(212) = 'LFSYSBI'
      ivarname(213) = 'LFSYSIM'
      ivarname(214) = 'LFSYTER'
      ivarname(215) = 'LFSYTI2'
      ivarname(216) = 'LFSYTQI'
      ivarname(217) = 'LFSYV2F'
      ivarname(218) = 'LFSYVB2'
      ivarname(219) = 'LFSYVC3'
      ivarname(220) = 'LFSYVC4'
      ivarname(221) = 'LFSYVC6'
      ivarname(222) = 'LFSYVCD'
      ivarname(223) = 'LFSYVCH'
      ivarname(224) = 'LFSYVCT'
      ivarname(225) = 'LFSYVEE'
      ivarname(226) = 'LFSYVIE'
      ivarname(227) = 'LFSYVMO'
      ivarname(228) = 'LFSYVP2'
      ivarname(229) = 'LFSYVPO'
      ivarname(230) = 'LFSYVPR'
      ivarname(231) = 'LFSYVTR'
      ivarname(232) = 'LFSYZF2'
      ivarname(233) = 'LFSYZXR'
      ivarname(234) = 'LFTER'
      ivarname(235) = 'LFTI2'
      ivarname(236) = 'LFTQI'
      ivarname(237) = 'LFULNB'
      ivarname(238) = 'LFV2F'
      ivarname(239) = 'LFVB2'
      ivarname(240) = 'LFVC3'
      ivarname(241) = 'LFVC4'
      ivarname(242) = 'LFVC6'
      ivarname(243) = 'LFVCD'
      ivarname(244) = 'LFVCH'
      ivarname(245) = 'LFVCT'
      ivarname(246) = 'LFVEE'
      ivarname(247) = 'LFVIE'
      ivarname(248) = 'LFVMO'
      ivarname(249) = 'LFVP2'
      ivarname(250) = 'LFVPO'
      ivarname(251) = 'LFVPR'
      ivarname(252) = 'LFVTR'
      ivarname(253) = 'LFZF2'
      ivarname(254) = 'LFZXR'
      ivarname(255) = 'LHLFNB'
      ivarname(256) = 'LLIM'
      ivarname(257) = 'LMOMD'
      ivarname(258) = 'LPELDA'
      ivarname(259) = 'LPHSLH'
      ivarname(260) = 'LPMDF'
      ivarname(261) = 'LPMSE'
      ivarname(262) = 'LPWREC'
      ivarname(263) = 'LPWRLH'
      ivarname(264) = 'LPWRNB'
      ivarname(265) = 'LPWRRF'
      ivarname(266) = 'LRFS'
      ivarname(267) = 'LRMFR'
      ivarname(268) = 'LRMP_BDY1'
      ivarname(269) = 'LRMP_BDY2'
      ivarname(270) = 'LRMSE'
      ivarname(271) = 'LRP2'
      ivarname(272) = 'LRPL'
      ivarname(273) = 'LRPSI'
      ivarname(274) = 'LSEVENT'
      ivarname(275) = 'LSSYAXR'
      ivarname(276) = 'LSSYBOL'
      ivarname(277) = 'LSSYBPA'
      ivarname(278) = 'LSSYBPB'
      ivarname(279) = 'LSSYD2F'
      ivarname(280) = 'LSSYDE2'
      ivarname(281) = 'LSSYDF3'
      ivarname(282) = 'LSSYDF4'
      ivarname(283) = 'LSSYDF6'
      ivarname(284) = 'LSSYDFD'
      ivarname(285) = 'LSSYDFH'
      ivarname(286) = 'LSSYDFT'
      ivarname(287) = 'LSSYECF'
      ivarname(288) = 'LSSYFEH'
      ivarname(289) = 'LSSYFEL'
      ivarname(290) = 'LSSYGRB'
      ivarname(291) = 'LSSYIBE'
      ivarname(292) = 'LSSYIBI'
      ivarname(293) = 'LSSYJBM'
      ivarname(294) = 'LSSYJEC'
      ivarname(295) = 'LSSYJIC'
      ivarname(296) = 'LSSYLF3'
      ivarname(297) = 'LSSYLF4'
      ivarname(298) = 'LSSYLF6'
      ivarname(299) = 'LSSYLFD'
      ivarname(300) = 'LSSYLFH'
      ivarname(301) = 'LSSYLFT'
      ivarname(302) = 'LSSYLHE'
      ivarname(303) = 'LSSYLHJ'
      ivarname(304) = 'LSSYMSE'
      ivarname(305) = 'LSSYNER'
      ivarname(306) = 'LSSYNI3'
      ivarname(307) = 'LSSYNI4'
      ivarname(308) = 'LSSYNI6'
      ivarname(309) = 'LSSYNID'
      ivarname(310) = 'LSSYNIH'
      ivarname(311) = 'LSSYNIM'
      ivarname(312) = 'LSSYNIT'
      ivarname(313) = 'LSSYNMR'
      ivarname(314) = 'LSSYOMG'
      ivarname(315) = 'LSSYPRS'
      ivarname(316) = 'LSSYQBE'
      ivarname(317) = 'LSSYQBI'
      ivarname(318) = 'LSSYQEC'
      ivarname(319) = 'LSSYQIC'
      ivarname(320) = 'LSSYQPR'
      ivarname(321) = 'LSSYRES'
      ivarname(322) = 'LSSYSBI'
      ivarname(323) = 'LSSYSIM'
      ivarname(324) = 'LSSYTER'
      ivarname(325) = 'LSSYTI2'
      ivarname(326) = 'LSSYTQI'
      ivarname(327) = 'LSSYV2F'
      ivarname(328) = 'LSSYVB2'
      ivarname(329) = 'LSSYVC3'
      ivarname(330) = 'LSSYVC4'
      ivarname(331) = 'LSSYVC6'
      ivarname(332) = 'LSSYVCD'
      ivarname(333) = 'LSSYVCH'
      ivarname(334) = 'LSSYVCT'
      ivarname(335) = 'LSSYVEE'
      ivarname(336) = 'LSSYVIE'
      ivarname(337) = 'LSSYVMO'
      ivarname(338) = 'LSSYVP2'
      ivarname(339) = 'LSSYVPO'
      ivarname(340) = 'LSSYVPR'
      ivarname(341) = 'LSSYVTR'
      ivarname(342) = 'LSSYZF2'
      ivarname(343) = 'LSSYZXR'
      ivarname(344) = 'LTABORT'
      ivarname(345) = 'LTAEP'
      ivarname(346) = 'LTFD0'
      ivarname(347) = 'LTFDB'
      ivarname(348) = 'LTFDP'
      ivarname(349) = 'LTFDQ'
      ivarname(350) = 'LTFDR'
      ivarname(351) = 'LTFDS'
      ivarname(352) = 'LTHFS'
      ivarname(353) = 'LTIME1'
      ivarname(354) = 'LTIME2'
      ivarname(355) = 'LTIMEC'
      ivarname(356) = 'LTIMECA'
      ivarname(357) = 'LTIMECB'
      ivarname(358) = 'LTIMLH'
      ivarname(359) = 'LTIMNB'
      ivarname(360) = 'LTIMRF'
      ivarname(361) = 'LTIMRFF'
      ivarname(362) = 'LTPSI'
      ivarname(363) = 'LTSAW'
      ivarname(364) = 'LVLTNB'
      ivarname(365) = 'LXAXR'
      ivarname(366) = 'LXBOL'
      ivarname(367) = 'LXBPA'
      ivarname(368) = 'LXBPB'
      ivarname(369) = 'LXD2F'
      ivarname(370) = 'LXDE2'
      ivarname(371) = 'LXDF3'
      ivarname(372) = 'LXDF4'
      ivarname(373) = 'LXDF6'
      ivarname(374) = 'LXDFD'
      ivarname(375) = 'LXDFH'
      ivarname(376) = 'LXDFT'
      ivarname(377) = 'LXECF'
      ivarname(378) = 'LXFD0'
      ivarname(379) = 'LXFDB'
      ivarname(380) = 'LXFDP'
      ivarname(381) = 'LXFDQ'
      ivarname(382) = 'LXFDR'
      ivarname(383) = 'LXFDS'
      ivarname(384) = 'LXFEH'
      ivarname(385) = 'LXFEL'
      ivarname(386) = 'LXFS'
      ivarname(387) = 'LXGRB'
      ivarname(388) = 'LXIBE'
      ivarname(389) = 'LXIBI'
      ivarname(390) = 'LXJBM'
      ivarname(391) = 'LXJEC'
      ivarname(392) = 'LXJIC'
      ivarname(393) = 'LXLF3'
      ivarname(394) = 'LXLF4'
      ivarname(395) = 'LXLF6'
      ivarname(396) = 'LXLFD'
      ivarname(397) = 'LXLFH'
      ivarname(398) = 'LXLFT'
      ivarname(399) = 'LXLHE'
      ivarname(400) = 'LXLHJ'
      ivarname(401) = 'LXMMX'
      ivarname(402) = 'LXMSE'
      ivarname(403) = 'LXNER'
      ivarname(404) = 'LXNI3'
      ivarname(405) = 'LXNI4'
      ivarname(406) = 'LXNI6'
      ivarname(407) = 'LXNID'
      ivarname(408) = 'LXNIH'
      ivarname(409) = 'LXNIM'
      ivarname(410) = 'LXNIT'
      ivarname(411) = 'LXNMR'
      ivarname(412) = 'LXOMG'
      ivarname(413) = 'LXPFC'
      ivarname(414) = 'LXPRS'
      ivarname(415) = 'LXQBE'
      ivarname(416) = 'LXQBI'
      ivarname(417) = 'LXQEC'
      ivarname(418) = 'LXQIC'
      ivarname(419) = 'LXQPR'
      ivarname(420) = 'LXRES'
      ivarname(421) = 'LXRP2'
      ivarname(422) = 'LXRPL'
      ivarname(423) = 'LXSBI'
      ivarname(424) = 'LXSIM'
      ivarname(425) = 'LXSYAXR'
      ivarname(426) = 'LXSYBOL'
      ivarname(427) = 'LXSYBPA'
      ivarname(428) = 'LXSYBPB'
      ivarname(429) = 'LXSYD2F'
      ivarname(430) = 'LXSYDE2'
      ivarname(431) = 'LXSYDF3'
      ivarname(432) = 'LXSYDF4'
      ivarname(433) = 'LXSYDF6'
      ivarname(434) = 'LXSYDFD'
      ivarname(435) = 'LXSYDFH'
      ivarname(436) = 'LXSYDFT'
      ivarname(437) = 'LXSYECF'
      ivarname(438) = 'LXSYFEH'
      ivarname(439) = 'LXSYFEL'
      ivarname(440) = 'LXSYGRB'
      ivarname(441) = 'LXSYIBE'
      ivarname(442) = 'LXSYIBI'
      ivarname(443) = 'LXSYJBM'
      ivarname(444) = 'LXSYJEC'
      ivarname(445) = 'LXSYJIC'
      ivarname(446) = 'LXSYLF3'
      ivarname(447) = 'LXSYLF4'
      ivarname(448) = 'LXSYLF6'
      ivarname(449) = 'LXSYLFD'
      ivarname(450) = 'LXSYLFH'
      ivarname(451) = 'LXSYLFT'
      ivarname(452) = 'LXSYLHE'
      ivarname(453) = 'LXSYLHJ'
      ivarname(454) = 'LXSYMSE'
      ivarname(455) = 'LXSYNER'
      ivarname(456) = 'LXSYNI3'
      ivarname(457) = 'LXSYNI4'
      ivarname(458) = 'LXSYNI6'
      ivarname(459) = 'LXSYNID'
      ivarname(460) = 'LXSYNIH'
      ivarname(461) = 'LXSYNIM'
      ivarname(462) = 'LXSYNIT'
      ivarname(463) = 'LXSYNMR'
      ivarname(464) = 'LXSYOMG'
      ivarname(465) = 'LXSYPRS'
      ivarname(466) = 'LXSYQBE'
      ivarname(467) = 'LXSYQBI'
      ivarname(468) = 'LXSYQEC'
      ivarname(469) = 'LXSYQIC'
      ivarname(470) = 'LXSYQPR'
      ivarname(471) = 'LXSYRES'
      ivarname(472) = 'LXSYSBI'
      ivarname(473) = 'LXSYSIM'
      ivarname(474) = 'LXSYTER'
      ivarname(475) = 'LXSYTI2'
      ivarname(476) = 'LXSYTQI'
      ivarname(477) = 'LXSYV2F'
      ivarname(478) = 'LXSYVB2'
      ivarname(479) = 'LXSYVC3'
      ivarname(480) = 'LXSYVC4'
      ivarname(481) = 'LXSYVC6'
      ivarname(482) = 'LXSYVCD'
      ivarname(483) = 'LXSYVCH'
      ivarname(484) = 'LXSYVCT'
      ivarname(485) = 'LXSYVEE'
      ivarname(486) = 'LXSYVIE'
      ivarname(487) = 'LXSYVMO'
      ivarname(488) = 'LXSYVP2'
      ivarname(489) = 'LXSYVPO'
      ivarname(490) = 'LXSYVPR'
      ivarname(491) = 'LXSYVTR'
      ivarname(492) = 'LXSYZF2'
      ivarname(493) = 'LXSYZXR'
      ivarname(494) = 'LXTER'
      ivarname(495) = 'LXTI2'
      ivarname(496) = 'LXTQI'
      ivarname(497) = 'LXV2F'
      ivarname(498) = 'LXVB2'
      ivarname(499) = 'LXVC3'
      ivarname(500) = 'LXVC4'
      ivarname(501) = 'LXVC6'
      ivarname(502) = 'LXVCD'
      ivarname(503) = 'LXVCH'
      ivarname(504) = 'LXVCT'
      ivarname(505) = 'LXVEE'
      ivarname(506) = 'LXVIE'
      ivarname(507) = 'LXVMO'
      ivarname(508) = 'LXVP2'
      ivarname(509) = 'LXVPO'
      ivarname(510) = 'LXVPR'
      ivarname(511) = 'LXVTR'
      ivarname(512) = 'LXZF2'
      ivarname(513) = 'LXZIMPS'
      ivarname(514) = 'LXZIMPX'
      ivarname(515) = 'LXZIMPXS'
      ivarname(516) = 'LXZXR'
      ivarname(517) = 'LYRP2'
      ivarname(518) = 'LYRPL'
      ivarname(519) = 'LYSIM'
      ivarname(520) = 'LZFS'
      ivarname(521) = 'LZPSI'
      ivarname(522) = 'MMAX'
      ivarname(523) = 'MMX_MAXE'
      ivarname(524) = 'MTRP2'
      ivarname(525) = 'MTRPL'
      ivarname(526) = 'NANTECH_D'
      ivarname(527) = 'NANTICH_D'
      ivarname(528) = 'NANTLH_D'
      ivarname(529) = 'NBDATA'
      ivarname(530) = 'NDEAEP'
      ivarname(531) = 'NDFS'
      ivarname(532) = 'NDMDF'
      ivarname(533) = 'NDMFR'
      ivarname(534) = 'NDMMX'
      ivarname(535) = 'NDMSE'
      ivarname(536) = 'NDPAEP'
      ivarname(537) = 'NDPFC'
      ivarname(538) = 'NDPFC_PRE'
      ivarname(539) = 'NEAEP'
      ivarname(540) = 'NEFD0'
      ivarname(541) = 'NEFDB'
      ivarname(542) = 'NEFDP'
      ivarname(543) = 'NEFDQ'
      ivarname(544) = 'NEFDR'
      ivarname(545) = 'NEFDS'
      ivarname(546) = 'NFRBCODE'
      ivarname(547) = 'NFRBMODE'
      ivarname(548) = 'NGMAX_D'
      ivarname(549) = 'NHECFT'
      ivarname(550) = 'NHFMX'
      ivarname(551) = 'NIMDF'
      ivarname(552) = 'NISSIM'
      ivarname(553) = 'NISX'
      ivarname(554) = 'NITSIM'
      ivarname(555) = 'NITX'
      ivarname(556) = 'NKAEP'
      ivarname(557) = 'NLIM'
      ivarname(558) = 'NMAPSIM'
      ivarname(559) = 'NMDXKF'
      ivarname(560) = 'NMIMP'
      ivarname(561) = 'NMOMD'
      ivarname(562) = 'NMUAEP'
      ivarname(563) = 'NMZEFF'
      ivarname(564) = 'NNSIM'
      ivarname(565) = 'NPACK'
      ivarname(566) = 'NPAEP'
      ivarname(567) = 'NPELDA'
      ivarname(568) = 'NPMDF'
      ivarname(569) = 'NPMSE'
      ivarname(570) = 'NRHIS'
      ivarname(571) = 'NRHIX'
      ivarname(572) = 'NRIAXR'
      ivarname(573) = 'NRIBOL'
      ivarname(574) = 'NRIBPA'
      ivarname(575) = 'NRIBPB'
      ivarname(576) = 'NRID2F'
      ivarname(577) = 'NRIDE2'
      ivarname(578) = 'NRIDF3'
      ivarname(579) = 'NRIDF4'
      ivarname(580) = 'NRIDF6'
      ivarname(581) = 'NRIDFD'
      ivarname(582) = 'NRIDFH'
      ivarname(583) = 'NRIDFT'
      ivarname(584) = 'NRIECF'
      ivarname(585) = 'NRIFD0'
      ivarname(586) = 'NRIFDB'
      ivarname(587) = 'NRIFDP'
      ivarname(588) = 'NRIFDQ'
      ivarname(589) = 'NRIFDR'
      ivarname(590) = 'NRIFDS'
      ivarname(591) = 'NRIFEH'
      ivarname(592) = 'NRIFEL'
      ivarname(593) = 'NRIGRB'
      ivarname(594) = 'NRIIBE'
      ivarname(595) = 'NRIIBI'
      ivarname(596) = 'NRIJBM'
      ivarname(597) = 'NRIJEC'
      ivarname(598) = 'NRIJIC'
      ivarname(599) = 'NRILF3'
      ivarname(600) = 'NRILF4'
      ivarname(601) = 'NRILF6'
      ivarname(602) = 'NRILFD'
      ivarname(603) = 'NRILFH'
      ivarname(604) = 'NRILFT'
      ivarname(605) = 'NRILHE'
      ivarname(606) = 'NRILHJ'
      ivarname(607) = 'NRIMSE'
      ivarname(608) = 'NRINER'
      ivarname(609) = 'NRINI3'
      ivarname(610) = 'NRINI4'
      ivarname(611) = 'NRINI6'
      ivarname(612) = 'NRINID'
      ivarname(613) = 'NRINIH'
      ivarname(614) = 'NRINIM'
      ivarname(615) = 'NRINIT'
      ivarname(616) = 'NRINMR'
      ivarname(617) = 'NRIOMG'
      ivarname(618) = 'NRIPRS'
      ivarname(619) = 'NRIQBE'
      ivarname(620) = 'NRIQBI'
      ivarname(621) = 'NRIQEC'
      ivarname(622) = 'NRIQIC'
      ivarname(623) = 'NRIQPR'
      ivarname(624) = 'NRIRES'
      ivarname(625) = 'NRISBI'
      ivarname(626) = 'NRISIM'
      ivarname(627) = 'NRITER'
      ivarname(628) = 'NRITI2'
      ivarname(629) = 'NRITQI'
      ivarname(630) = 'NRIV2F'
      ivarname(631) = 'NRIVB2'
      ivarname(632) = 'NRIVC3'
      ivarname(633) = 'NRIVC4'
      ivarname(634) = 'NRIVC6'
      ivarname(635) = 'NRIVCD'
      ivarname(636) = 'NRIVCH'
      ivarname(637) = 'NRIVCT'
      ivarname(638) = 'NRIVEE'
      ivarname(639) = 'NRIVIE'
      ivarname(640) = 'NRIVMO'
      ivarname(641) = 'NRIVP2'
      ivarname(642) = 'NRIVPO'
      ivarname(643) = 'NRIVPR'
      ivarname(644) = 'NRIVTR'
      ivarname(645) = 'NRIZF2'
      ivarname(646) = 'NRIZXR'
      ivarname(647) = 'NRMFR'
      ivarname(648) = 'NRMSE'
      ivarname(649) = 'NRP2'
      ivarname(650) = 'NRPL'
      ivarname(651) = 'NRPSI'
      ivarname(652) = 'NSAWFLAG'
      ivarname(653) = 'NSC'
      ivarname(654) = 'NSC_FMT'
      ivarname(655) = 'NSEVENT'
      ivarname(656) = 'NSEVPER'
      ivarname(657) = 'NSEVTBL'
      ivarname(658) = 'NSEVWDS'
      ivarname(659) = 'NSFAST_D'
      ivarname(660) = 'NSYAXR'
      ivarname(661) = 'NSYBOL'
      ivarname(662) = 'NSYBPA'
      ivarname(663) = 'NSYBPB'
      ivarname(664) = 'NSYD2F'
      ivarname(665) = 'NSYDE2'
      ivarname(666) = 'NSYDF3'
      ivarname(667) = 'NSYDF4'
      ivarname(668) = 'NSYDF6'
      ivarname(669) = 'NSYDFD'
      ivarname(670) = 'NSYDFH'
      ivarname(671) = 'NSYDFT'
      ivarname(672) = 'NSYECF'
      ivarname(673) = 'NSYFEH'
      ivarname(674) = 'NSYFEL'
      ivarname(675) = 'NSYGRB'
      ivarname(676) = 'NSYIBE'
      ivarname(677) = 'NSYIBI'
      ivarname(678) = 'NSYJBM'
      ivarname(679) = 'NSYJEC'
      ivarname(680) = 'NSYJIC'
      ivarname(681) = 'NSYLF3'
      ivarname(682) = 'NSYLF4'
      ivarname(683) = 'NSYLF6'
      ivarname(684) = 'NSYLFD'
      ivarname(685) = 'NSYLFH'
      ivarname(686) = 'NSYLFT'
      ivarname(687) = 'NSYLHE'
      ivarname(688) = 'NSYLHJ'
      ivarname(689) = 'NSYMSE'
      ivarname(690) = 'NSYNER'
      ivarname(691) = 'NSYNI3'
      ivarname(692) = 'NSYNI4'
      ivarname(693) = 'NSYNI6'
      ivarname(694) = 'NSYNID'
      ivarname(695) = 'NSYNIH'
      ivarname(696) = 'NSYNIM'
      ivarname(697) = 'NSYNIT'
      ivarname(698) = 'NSYNMR'
      ivarname(699) = 'NSYOMG'
      ivarname(700) = 'NSYPRS'
      ivarname(701) = 'NSYQBE'
      ivarname(702) = 'NSYQBI'
      ivarname(703) = 'NSYQEC'
      ivarname(704) = 'NSYQIC'
      ivarname(705) = 'NSYQPR'
      ivarname(706) = 'NSYRES'
      ivarname(707) = 'NSYSBI'
      ivarname(708) = 'NSYSIM'
      ivarname(709) = 'NSYTER'
      ivarname(710) = 'NSYTI2'
      ivarname(711) = 'NSYTQI'
      ivarname(712) = 'NSYV2F'
      ivarname(713) = 'NSYVB2'
      ivarname(714) = 'NSYVC3'
      ivarname(715) = 'NSYVC4'
      ivarname(716) = 'NSYVC6'
      ivarname(717) = 'NSYVCD'
      ivarname(718) = 'NSYVCH'
      ivarname(719) = 'NSYVCT'
      ivarname(720) = 'NSYVEE'
      ivarname(721) = 'NSYVIE'
      ivarname(722) = 'NSYVMO'
      ivarname(723) = 'NSYVP2'
      ivarname(724) = 'NSYVPO'
      ivarname(725) = 'NSYVPR'
      ivarname(726) = 'NSYVTR'
      ivarname(727) = 'NSYZF2'
      ivarname(728) = 'NSYZXR'
      ivarname(729) = 'NTABORT'
      ivarname(730) = 'NTAEP'
      ivarname(731) = 'NTFD0'
      ivarname(732) = 'NTFDB'
      ivarname(733) = 'NTFDP'
      ivarname(734) = 'NTFDQ'
      ivarname(735) = 'NTFDR'
      ivarname(736) = 'NTFDS'
      ivarname(737) = 'NTHFS'
      ivarname(738) = 'NTIME1'
      ivarname(739) = 'NTIME2'
      ivarname(740) = 'NTIMEC'
      ivarname(741) = 'NTIMECA'
      ivarname(742) = 'NTIMECB'
      ivarname(743) = 'NTIMLH'
      ivarname(744) = 'NTIMNB'
      ivarname(745) = 'NTIMRF'
      ivarname(746) = 'NTIMRFF'
      ivarname(747) = 'NTPSI'
      ivarname(748) = 'NTSAW'
      ivarname(749) = 'NXAXR'
      ivarname(750) = 'NXBOL'
      ivarname(751) = 'NXBPA'
      ivarname(752) = 'NXBPB'
      ivarname(753) = 'NXD2F'
      ivarname(754) = 'NXDE2'
      ivarname(755) = 'NXDF3'
      ivarname(756) = 'NXDF4'
      ivarname(757) = 'NXDF6'
      ivarname(758) = 'NXDFD'
      ivarname(759) = 'NXDFH'
      ivarname(760) = 'NXDFT'
      ivarname(761) = 'NXECF'
      ivarname(762) = 'NXFD0'
      ivarname(763) = 'NXFDB'
      ivarname(764) = 'NXFDP'
      ivarname(765) = 'NXFDQ'
      ivarname(766) = 'NXFDR'
      ivarname(767) = 'NXFDS'
      ivarname(768) = 'NXFEH'
      ivarname(769) = 'NXFEL'
      ivarname(770) = 'NXFS'
      ivarname(771) = 'NXGRB'
      ivarname(772) = 'NXIBE'
      ivarname(773) = 'NXIBI'
      ivarname(774) = 'NXJBM'
      ivarname(775) = 'NXJEC'
      ivarname(776) = 'NXJIC'
      ivarname(777) = 'NXLF3'
      ivarname(778) = 'NXLF4'
      ivarname(779) = 'NXLF6'
      ivarname(780) = 'NXLFD'
      ivarname(781) = 'NXLFH'
      ivarname(782) = 'NXLFT'
      ivarname(783) = 'NXLHE'
      ivarname(784) = 'NXLHJ'
      ivarname(785) = 'NXMMX'
      ivarname(786) = 'NXMSE'
      ivarname(787) = 'NXNE0'
      ivarname(788) = 'NXNER'
      ivarname(789) = 'NXNI3'
      ivarname(790) = 'NXNI4'
      ivarname(791) = 'NXNI6'
      ivarname(792) = 'NXNID'
      ivarname(793) = 'NXNIH'
      ivarname(794) = 'NXNIM'
      ivarname(795) = 'NXNIT'
      ivarname(796) = 'NXNM0'
      ivarname(797) = 'NXNMR'
      ivarname(798) = 'NXOMG'
      ivarname(799) = 'NXPFC'
      ivarname(800) = 'NXPRS'
      ivarname(801) = 'NXQBE'
      ivarname(802) = 'NXQBI'
      ivarname(803) = 'NXQEC'
      ivarname(804) = 'NXQIC'
      ivarname(805) = 'NXQPR'
      ivarname(806) = 'NXRES'
      ivarname(807) = 'NXRP2'
      ivarname(808) = 'NXRPL'
      ivarname(809) = 'NXSBI'
      ivarname(810) = 'NXSIM'
      ivarname(811) = 'NXSYAXR'
      ivarname(812) = 'NXSYBOL'
      ivarname(813) = 'NXSYBPA'
      ivarname(814) = 'NXSYBPB'
      ivarname(815) = 'NXSYD2F'
      ivarname(816) = 'NXSYDE2'
      ivarname(817) = 'NXSYDF3'
      ivarname(818) = 'NXSYDF4'
      ivarname(819) = 'NXSYDF6'
      ivarname(820) = 'NXSYDFD'
      ivarname(821) = 'NXSYDFH'
      ivarname(822) = 'NXSYDFT'
      ivarname(823) = 'NXSYECF'
      ivarname(824) = 'NXSYFEH'
      ivarname(825) = 'NXSYFEL'
      ivarname(826) = 'NXSYGRB'
      ivarname(827) = 'NXSYIBE'
      ivarname(828) = 'NXSYIBI'
      ivarname(829) = 'NXSYJBM'
      ivarname(830) = 'NXSYJEC'
      ivarname(831) = 'NXSYJIC'
      ivarname(832) = 'NXSYLF3'
      ivarname(833) = 'NXSYLF4'
      ivarname(834) = 'NXSYLF6'
      ivarname(835) = 'NXSYLFD'
      ivarname(836) = 'NXSYLFH'
      ivarname(837) = 'NXSYLFT'
      ivarname(838) = 'NXSYLHE'
      ivarname(839) = 'NXSYLHJ'
      ivarname(840) = 'NXSYMSE'
      ivarname(841) = 'NXSYNER'
      ivarname(842) = 'NXSYNI3'
      ivarname(843) = 'NXSYNI4'
      ivarname(844) = 'NXSYNI6'
      ivarname(845) = 'NXSYNID'
      ivarname(846) = 'NXSYNIH'
      ivarname(847) = 'NXSYNIM'
      ivarname(848) = 'NXSYNIT'
      ivarname(849) = 'NXSYNMR'
      ivarname(850) = 'NXSYOMG'
      ivarname(851) = 'NXSYPRS'
      ivarname(852) = 'NXSYQBE'
      ivarname(853) = 'NXSYQBI'
      ivarname(854) = 'NXSYQEC'
      ivarname(855) = 'NXSYQIC'
      ivarname(856) = 'NXSYQPR'
      ivarname(857) = 'NXSYRES'
      ivarname(858) = 'NXSYSBI'
      ivarname(859) = 'NXSYSIM'
      ivarname(860) = 'NXSYTER'
      ivarname(861) = 'NXSYTI2'
      ivarname(862) = 'NXSYTQI'
      ivarname(863) = 'NXSYV2F'
      ivarname(864) = 'NXSYVB2'
      ivarname(865) = 'NXSYVC3'
      ivarname(866) = 'NXSYVC4'
      ivarname(867) = 'NXSYVC6'
      ivarname(868) = 'NXSYVCD'
      ivarname(869) = 'NXSYVCH'
      ivarname(870) = 'NXSYVCT'
      ivarname(871) = 'NXSYVEE'
      ivarname(872) = 'NXSYVIE'
      ivarname(873) = 'NXSYVMO'
      ivarname(874) = 'NXSYVP2'
      ivarname(875) = 'NXSYVPO'
      ivarname(876) = 'NXSYVPR'
      ivarname(877) = 'NXSYVTR'
      ivarname(878) = 'NXSYZF2'
      ivarname(879) = 'NXSYZXR'
      ivarname(880) = 'NXTE0'
      ivarname(881) = 'NXTER'
      ivarname(882) = 'NXTI2'
      ivarname(883) = 'NXTQI'
      ivarname(884) = 'NXV2F'
      ivarname(885) = 'NXVB2'
      ivarname(886) = 'NXVC3'
      ivarname(887) = 'NXVC4'
      ivarname(888) = 'NXVC6'
      ivarname(889) = 'NXVCD'
      ivarname(890) = 'NXVCH'
      ivarname(891) = 'NXVCT'
      ivarname(892) = 'NXVEE'
      ivarname(893) = 'NXVIE'
      ivarname(894) = 'NXVMO'
      ivarname(895) = 'NXVP2'
      ivarname(896) = 'NXVPO'
      ivarname(897) = 'NXVPR'
      ivarname(898) = 'NXVTR'
      ivarname(899) = 'NXZEF2'
      ivarname(900) = 'NXZF2'
      ivarname(901) = 'NXZXR'
      ivarname(902) = 'NYRP2'
      ivarname(903) = 'NYRPL'
      ivarname(904) = 'NZPSI'
      ivarname(905)='                '
      ivarsize(1) = 1
      ivarsize(2) = 1
      ivarsize(3) = 1
      ivarsize(4) = 1
      ivarsize(5) = 1
      ivarsize(6) = 1
      ivarsize(7) = 1
      ivarsize(8) = 1
      ivarsize(9) = 1
      ivarsize(10) = 1
      ivarsize(11) = 1
      ivarsize(12) = 1
      ivarsize(13) = 1
      ivarsize(14) = 1
      ivarsize(15) = 1
      ivarsize(16) = 1
      ivarsize(17) = 1
      ivarsize(18) = 1
      ivarsize(19) = 1
      ivarsize(20) = 1
      ivarsize(21) = 1
      ivarsize(22) = 1
      ivarsize(23) = 1
      ivarsize(24) = 1
      ivarsize(25) = 1
      ivarsize(26) = 1
      ivarsize(27) = 1
      ivarsize(28) = 1
      ivarsize(29) = 1
      ivarsize(30) = 1
      ivarsize(31) = 1
      ivarsize(32) = 1
      ivarsize(33) = 1
      ivarsize(34) = 1
      ivarsize(35) = 1
      ivarsize(36) = 1
      ivarsize(37) = 1
      ivarsize(38) = 1
      ivarsize(39) = 1
      ivarsize(40) = 1
      ivarsize(41) = 1
      ivarsize(42) = 1
      ivarsize(43) = 1
      ivarsize(44) = 1
      ivarsize(45) = 1
      ivarsize(46) = 1
      ivarsize(47) = 1
      ivarsize(48) = 1
      ivarsize(49) = 1
      ivarsize(50) = 1
      ivarsize(51) = 1
      ivarsize(52) = 1
      ivarsize(53) = 1
      ivarsize(54) = 1
      ivarsize(55) = 1
      ivarsize(56) = 1
      ivarsize(57) = 1
      ivarsize(58) = 1
      ivarsize(59) = 1
      ivarsize(60) = 1
      ivarsize(61) = 1
      ivarsize(62) = 1
      ivarsize(63) = 1
      ivarsize(64) = 1
      ivarsize(65) = 1
      ivarsize(66) = 1
      ivarsize(67) = 1
      ivarsize(68) = 1
      ivarsize(69) = 1
      ivarsize(70) = 1
      ivarsize(71) = 1
      ivarsize(72) = 1
      ivarsize(73) = 1
      ivarsize(74) = 1
      ivarsize(75) = 1
      ivarsize(76) = 1
      ivarsize(77) = 1
      ivarsize(78) = 1
      ivarsize(79) = 1
      ivarsize(80) = 1
      ivarsize(81) = 1
      ivarsize(82) = 1
      ivarsize(83) = 1
      ivarsize(84) = 1
      ivarsize(85) = 1
      ivarsize(86) = 1
      ivarsize(87) = 1
      ivarsize(88) = 1
      ivarsize(89) = 1
      ivarsize(90) = 1
      ivarsize(91) = 1
      ivarsize(92) = 1
      ivarsize(93) = 1
      ivarsize(94) = 1
      ivarsize(95) = 1
      ivarsize(96) = 1
      ivarsize(97) = 1
      ivarsize(98) = 1
      ivarsize(99) = 1
      ivarsize(100) = 1
      ivarsize(101) = 1
      ivarsize(102) = 1
      ivarsize(103) = 1
      ivarsize(104) = 1
      ivarsize(105) = 1
      ivarsize(106) = 1
      ivarsize(107) = 1
      ivarsize(108) = 1
      ivarsize(109) = 1
      ivarsize(110) = 1
      ivarsize(111) = 1
      ivarsize(112) = 1
      ivarsize(113) = 1
      ivarsize(114) = 1
      ivarsize(115) = 1
      ivarsize(116) = 1
      ivarsize(117) = 1
      ivarsize(118) = 1
      ivarsize(119) = 1
      ivarsize(120) = 1
      ivarsize(121) = 1
      ivarsize(122) = 1
      ivarsize(123) = 1
      ivarsize(124) = 1
      ivarsize(125) = 1
      ivarsize(126) = 1
      ivarsize(127) = 1
      ivarsize(128) = 1
      ivarsize(129) = 1
      ivarsize(130) = 1
      ivarsize(131) = 1
      ivarsize(132) = 1
      ivarsize(133) = 1
      ivarsize(134) = 1
      ivarsize(135) = 1
      ivarsize(136) = 1
      ivarsize(137) = 1
      ivarsize(138) = 1
      ivarsize(139) = 1
      ivarsize(140) = 1
      ivarsize(141) = 1
      ivarsize(142) = 1
      ivarsize(143) = 1
      ivarsize(144) = 1
      ivarsize(145) = 1
      ivarsize(146) = 1
      ivarsize(147) = 1
      ivarsize(148) = 1
      ivarsize(149) = 1
      ivarsize(150) = 1
      ivarsize(151) = 1
      ivarsize(152) = 1
      ivarsize(153) = 1
      ivarsize(154) = 1
      ivarsize(155) = 1
      ivarsize(156) = 1
      ivarsize(157) = 1
      ivarsize(158) = 1
      ivarsize(159) = 1
      ivarsize(160) = 1
      ivarsize(161) = 1
      ivarsize(162) = 1
      ivarsize(163) = 1
      ivarsize(164) = 300
      ivarsize(165) = 1
      ivarsize(166) = 1
      ivarsize(167) = 1
      ivarsize(168) = 1
      ivarsize(169) = 1
      ivarsize(170) = 1
      ivarsize(171) = 1
      ivarsize(172) = 1
      ivarsize(173) = 1
      ivarsize(174) = 1
      ivarsize(175) = 1
      ivarsize(176) = 1
      ivarsize(177) = 1
      ivarsize(178) = 1
      ivarsize(179) = 1
      ivarsize(180) = 1
      ivarsize(181) = 1
      ivarsize(182) = 1
      ivarsize(183) = 1
      ivarsize(184) = 1
      ivarsize(185) = 1
      ivarsize(186) = 1
      ivarsize(187) = 1
      ivarsize(188) = 1
      ivarsize(189) = 1
      ivarsize(190) = 1
      ivarsize(191) = 1
      ivarsize(192) = 1
      ivarsize(193) = 1
      ivarsize(194) = 1
      ivarsize(195) = 1
      ivarsize(196) = 1
      ivarsize(197) = 1
      ivarsize(198) = 1
      ivarsize(199) = 1
      ivarsize(200) = 1
      ivarsize(201) = 1
      ivarsize(202) = 1
      ivarsize(203) = 1
      ivarsize(204) = 1
      ivarsize(205) = 1
      ivarsize(206) = 1
      ivarsize(207) = 1
      ivarsize(208) = 1
      ivarsize(209) = 1
      ivarsize(210) = 1
      ivarsize(211) = 1
      ivarsize(212) = 1
      ivarsize(213) = 300
      ivarsize(214) = 1
      ivarsize(215) = 1
      ivarsize(216) = 1
      ivarsize(217) = 1
      ivarsize(218) = 1
      ivarsize(219) = 1
      ivarsize(220) = 1
      ivarsize(221) = 1
      ivarsize(222) = 1
      ivarsize(223) = 1
      ivarsize(224) = 1
      ivarsize(225) = 1
      ivarsize(226) = 1
      ivarsize(227) = 1
      ivarsize(228) = 1
      ivarsize(229) = 1
      ivarsize(230) = 1
      ivarsize(231) = 1
      ivarsize(232) = 1
      ivarsize(233) = 1
      ivarsize(234) = 1
      ivarsize(235) = 1
      ivarsize(236) = 1
      ivarsize(237) = 1
      ivarsize(238) = 1
      ivarsize(239) = 1
      ivarsize(240) = 1
      ivarsize(241) = 1
      ivarsize(242) = 1
      ivarsize(243) = 1
      ivarsize(244) = 1
      ivarsize(245) = 1
      ivarsize(246) = 1
      ivarsize(247) = 1
      ivarsize(248) = 1
      ivarsize(249) = 1
      ivarsize(250) = 1
      ivarsize(251) = 1
      ivarsize(252) = 1
      ivarsize(253) = 1
      ivarsize(254) = 1
      ivarsize(255) = 1
      ivarsize(256) = 1
      ivarsize(257) = 1
      ivarsize(258) = 1
      ivarsize(259) = 1
      ivarsize(260) = 1
      ivarsize(261) = 1
      ivarsize(262) = 1
      ivarsize(263) = 1
      ivarsize(264) = 1
      ivarsize(265) = 1
      ivarsize(266) = 1
      ivarsize(267) = 1
      ivarsize(268) = 1
      ivarsize(269) = 1
      ivarsize(270) = 1
      ivarsize(271) = 1
      ivarsize(272) = 1
      ivarsize(273) = 1
      ivarsize(274) = 1
      ivarsize(275) = 1
      ivarsize(276) = 1
      ivarsize(277) = 1
      ivarsize(278) = 1
      ivarsize(279) = 1
      ivarsize(280) = 1
      ivarsize(281) = 1
      ivarsize(282) = 1
      ivarsize(283) = 1
      ivarsize(284) = 1
      ivarsize(285) = 1
      ivarsize(286) = 1
      ivarsize(287) = 1
      ivarsize(288) = 1
      ivarsize(289) = 1
      ivarsize(290) = 1
      ivarsize(291) = 1
      ivarsize(292) = 1
      ivarsize(293) = 1
      ivarsize(294) = 1
      ivarsize(295) = 1
      ivarsize(296) = 1
      ivarsize(297) = 1
      ivarsize(298) = 1
      ivarsize(299) = 1
      ivarsize(300) = 1
      ivarsize(301) = 1
      ivarsize(302) = 1
      ivarsize(303) = 1
      ivarsize(304) = 1
      ivarsize(305) = 1
      ivarsize(306) = 1
      ivarsize(307) = 1
      ivarsize(308) = 1
      ivarsize(309) = 1
      ivarsize(310) = 1
      ivarsize(311) = 1
      ivarsize(312) = 1
      ivarsize(313) = 1
      ivarsize(314) = 1
      ivarsize(315) = 1
      ivarsize(316) = 1
      ivarsize(317) = 1
      ivarsize(318) = 1
      ivarsize(319) = 1
      ivarsize(320) = 1
      ivarsize(321) = 1
      ivarsize(322) = 1
      ivarsize(323) = 300
      ivarsize(324) = 1
      ivarsize(325) = 1
      ivarsize(326) = 1
      ivarsize(327) = 1
      ivarsize(328) = 1
      ivarsize(329) = 1
      ivarsize(330) = 1
      ivarsize(331) = 1
      ivarsize(332) = 1
      ivarsize(333) = 1
      ivarsize(334) = 1
      ivarsize(335) = 1
      ivarsize(336) = 1
      ivarsize(337) = 1
      ivarsize(338) = 1
      ivarsize(339) = 1
      ivarsize(340) = 1
      ivarsize(341) = 1
      ivarsize(342) = 1
      ivarsize(343) = 1
      ivarsize(344) = 1
      ivarsize(345) = 1
      ivarsize(346) = 1
      ivarsize(347) = 1
      ivarsize(348) = 1
      ivarsize(349) = 1
      ivarsize(350) = 1
      ivarsize(351) = 1
      ivarsize(352) = 1
      ivarsize(353) = 1
      ivarsize(354) = 1
      ivarsize(355) = 1
      ivarsize(356) = 1
      ivarsize(357) = 1
      ivarsize(358) = 1
      ivarsize(359) = 1
      ivarsize(360) = 1
      ivarsize(361) = 1
      ivarsize(362) = 1
      ivarsize(363) = 1
      ivarsize(364) = 1
      ivarsize(365) = 1
      ivarsize(366) = 1
      ivarsize(367) = 1
      ivarsize(368) = 1
      ivarsize(369) = 1
      ivarsize(370) = 1
      ivarsize(371) = 1
      ivarsize(372) = 1
      ivarsize(373) = 1
      ivarsize(374) = 1
      ivarsize(375) = 1
      ivarsize(376) = 1
      ivarsize(377) = 1
      ivarsize(378) = 1
      ivarsize(379) = 1
      ivarsize(380) = 1
      ivarsize(381) = 1
      ivarsize(382) = 1
      ivarsize(383) = 1
      ivarsize(384) = 1
      ivarsize(385) = 1
      ivarsize(386) = 1
      ivarsize(387) = 1
      ivarsize(388) = 1
      ivarsize(389) = 1
      ivarsize(390) = 1
      ivarsize(391) = 1
      ivarsize(392) = 1
      ivarsize(393) = 1
      ivarsize(394) = 1
      ivarsize(395) = 1
      ivarsize(396) = 1
      ivarsize(397) = 1
      ivarsize(398) = 1
      ivarsize(399) = 1
      ivarsize(400) = 1
      ivarsize(401) = 1
      ivarsize(402) = 1
      ivarsize(403) = 1
      ivarsize(404) = 1
      ivarsize(405) = 1
      ivarsize(406) = 1
      ivarsize(407) = 1
      ivarsize(408) = 1
      ivarsize(409) = 1
      ivarsize(410) = 1
      ivarsize(411) = 1
      ivarsize(412) = 1
      ivarsize(413) = 1
      ivarsize(414) = 1
      ivarsize(415) = 1
      ivarsize(416) = 1
      ivarsize(417) = 1
      ivarsize(418) = 1
      ivarsize(419) = 1
      ivarsize(420) = 1
      ivarsize(421) = 1
      ivarsize(422) = 1
      ivarsize(423) = 1
      ivarsize(424) = 8
      ivarsize(425) = 1
      ivarsize(426) = 1
      ivarsize(427) = 1
      ivarsize(428) = 1
      ivarsize(429) = 1
      ivarsize(430) = 1
      ivarsize(431) = 1
      ivarsize(432) = 1
      ivarsize(433) = 1
      ivarsize(434) = 1
      ivarsize(435) = 1
      ivarsize(436) = 1
      ivarsize(437) = 1
      ivarsize(438) = 1
      ivarsize(439) = 1
      ivarsize(440) = 1
      ivarsize(441) = 1
      ivarsize(442) = 1
      ivarsize(443) = 1
      ivarsize(444) = 1
      ivarsize(445) = 1
      ivarsize(446) = 1
      ivarsize(447) = 1
      ivarsize(448) = 1
      ivarsize(449) = 1
      ivarsize(450) = 1
      ivarsize(451) = 1
      ivarsize(452) = 1
      ivarsize(453) = 1
      ivarsize(454) = 1
      ivarsize(455) = 1
      ivarsize(456) = 1
      ivarsize(457) = 1
      ivarsize(458) = 1
      ivarsize(459) = 1
      ivarsize(460) = 1
      ivarsize(461) = 1
      ivarsize(462) = 1
      ivarsize(463) = 1
      ivarsize(464) = 1
      ivarsize(465) = 1
      ivarsize(466) = 1
      ivarsize(467) = 1
      ivarsize(468) = 1
      ivarsize(469) = 1
      ivarsize(470) = 1
      ivarsize(471) = 1
      ivarsize(472) = 1
      ivarsize(473) = 8
      ivarsize(474) = 1
      ivarsize(475) = 1
      ivarsize(476) = 1
      ivarsize(477) = 1
      ivarsize(478) = 1
      ivarsize(479) = 1
      ivarsize(480) = 1
      ivarsize(481) = 1
      ivarsize(482) = 1
      ivarsize(483) = 1
      ivarsize(484) = 1
      ivarsize(485) = 1
      ivarsize(486) = 1
      ivarsize(487) = 1
      ivarsize(488) = 1
      ivarsize(489) = 1
      ivarsize(490) = 1
      ivarsize(491) = 1
      ivarsize(492) = 1
      ivarsize(493) = 1
      ivarsize(494) = 1
      ivarsize(495) = 1
      ivarsize(496) = 1
      ivarsize(497) = 1
      ivarsize(498) = 1
      ivarsize(499) = 1
      ivarsize(500) = 1
      ivarsize(501) = 1
      ivarsize(502) = 1
      ivarsize(503) = 1
      ivarsize(504) = 1
      ivarsize(505) = 1
      ivarsize(506) = 1
      ivarsize(507) = 1
      ivarsize(508) = 1
      ivarsize(509) = 1
      ivarsize(510) = 1
      ivarsize(511) = 1
      ivarsize(512) = 1
      ivarsize(513) = 1
      ivarsize(514) = 1
      ivarsize(515) = 1
      ivarsize(516) = 1
      ivarsize(517) = 1
      ivarsize(518) = 1
      ivarsize(519) = 1
      ivarsize(520) = 1
      ivarsize(521) = 1
      ivarsize(522) = 1
      ivarsize(523) = 1
      ivarsize(524) = 1
      ivarsize(525) = 1
      ivarsize(526) = 1
      ivarsize(527) = 1
      ivarsize(528) = 1
      ivarsize(529) = 1
      ivarsize(530) = 1
      ivarsize(531) = 1
      ivarsize(532) = 1
      ivarsize(533) = 1
      ivarsize(534) = 1
      ivarsize(535) = 1
      ivarsize(536) = 1
      ivarsize(537) = 1
      ivarsize(538) = 1
      ivarsize(539) = 1
      ivarsize(540) = 1
      ivarsize(541) = 1
      ivarsize(542) = 1
      ivarsize(543) = 1
      ivarsize(544) = 1
      ivarsize(545) = 1
      ivarsize(546) = 1
      ivarsize(547) = 1
      ivarsize(548) = 1
      ivarsize(549) = 1
      ivarsize(550) = 1
      ivarsize(551) = 1
      ivarsize(552) = 300
      ivarsize(553) = 300
      ivarsize(554) = 8
      ivarsize(555) = 8
      ivarsize(556) = 1
      ivarsize(557) = 1
      ivarsize(558) = 300
      ivarsize(559) = 1
      ivarsize(560) = 1
      ivarsize(561) = 1
      ivarsize(562) = 1
      ivarsize(563) = 1
      ivarsize(564) = 1
      ivarsize(565) = 1
      ivarsize(566) = 1
      ivarsize(567) = 1
      ivarsize(568) = 1
      ivarsize(569) = 1
      ivarsize(570) = 1
      ivarsize(571) = 1
      ivarsize(572) = 1
      ivarsize(573) = 1
      ivarsize(574) = 1
      ivarsize(575) = 1
      ivarsize(576) = 1
      ivarsize(577) = 1
      ivarsize(578) = 1
      ivarsize(579) = 1
      ivarsize(580) = 1
      ivarsize(581) = 1
      ivarsize(582) = 1
      ivarsize(583) = 1
      ivarsize(584) = 1
      ivarsize(585) = 1
      ivarsize(586) = 1
      ivarsize(587) = 1
      ivarsize(588) = 1
      ivarsize(589) = 1
      ivarsize(590) = 1
      ivarsize(591) = 1
      ivarsize(592) = 1
      ivarsize(593) = 1
      ivarsize(594) = 1
      ivarsize(595) = 1
      ivarsize(596) = 1
      ivarsize(597) = 1
      ivarsize(598) = 1
      ivarsize(599) = 1
      ivarsize(600) = 1
      ivarsize(601) = 1
      ivarsize(602) = 1
      ivarsize(603) = 1
      ivarsize(604) = 1
      ivarsize(605) = 1
      ivarsize(606) = 1
      ivarsize(607) = 1
      ivarsize(608) = 1
      ivarsize(609) = 1
      ivarsize(610) = 1
      ivarsize(611) = 1
      ivarsize(612) = 1
      ivarsize(613) = 1
      ivarsize(614) = 1
      ivarsize(615) = 1
      ivarsize(616) = 1
      ivarsize(617) = 1
      ivarsize(618) = 1
      ivarsize(619) = 1
      ivarsize(620) = 1
      ivarsize(621) = 1
      ivarsize(622) = 1
      ivarsize(623) = 1
      ivarsize(624) = 1
      ivarsize(625) = 1
      ivarsize(626) = 8
      ivarsize(627) = 1
      ivarsize(628) = 1
      ivarsize(629) = 1
      ivarsize(630) = 1
      ivarsize(631) = 1
      ivarsize(632) = 1
      ivarsize(633) = 1
      ivarsize(634) = 1
      ivarsize(635) = 1
      ivarsize(636) = 1
      ivarsize(637) = 1
      ivarsize(638) = 1
      ivarsize(639) = 1
      ivarsize(640) = 1
      ivarsize(641) = 1
      ivarsize(642) = 1
      ivarsize(643) = 1
      ivarsize(644) = 1
      ivarsize(645) = 1
      ivarsize(646) = 1
      ivarsize(647) = 1
      ivarsize(648) = 1
      ivarsize(649) = 1
      ivarsize(650) = 1
      ivarsize(651) = 1
      ivarsize(652) = 1
      ivarsize(653) = 1
      ivarsize(654) = 1
      ivarsize(655) = 1
      ivarsize(656) = 1
      ivarsize(657) = 1
      ivarsize(658) = 1
      ivarsize(659) = 1
      ivarsize(660) = 1
      ivarsize(661) = 1
      ivarsize(662) = 1
      ivarsize(663) = 1
      ivarsize(664) = 1
      ivarsize(665) = 1
      ivarsize(666) = 1
      ivarsize(667) = 1
      ivarsize(668) = 1
      ivarsize(669) = 1
      ivarsize(670) = 1
      ivarsize(671) = 1
      ivarsize(672) = 1
      ivarsize(673) = 1
      ivarsize(674) = 1
      ivarsize(675) = 1
      ivarsize(676) = 1
      ivarsize(677) = 1
      ivarsize(678) = 1
      ivarsize(679) = 1
      ivarsize(680) = 1
      ivarsize(681) = 1
      ivarsize(682) = 1
      ivarsize(683) = 1
      ivarsize(684) = 1
      ivarsize(685) = 1
      ivarsize(686) = 1
      ivarsize(687) = 1
      ivarsize(688) = 1
      ivarsize(689) = 1
      ivarsize(690) = 1
      ivarsize(691) = 1
      ivarsize(692) = 1
      ivarsize(693) = 1
      ivarsize(694) = 1
      ivarsize(695) = 1
      ivarsize(696) = 1
      ivarsize(697) = 1
      ivarsize(698) = 1
      ivarsize(699) = 1
      ivarsize(700) = 1
      ivarsize(701) = 1
      ivarsize(702) = 1
      ivarsize(703) = 1
      ivarsize(704) = 1
      ivarsize(705) = 1
      ivarsize(706) = 1
      ivarsize(707) = 1
      ivarsize(708) = 8
      ivarsize(709) = 1
      ivarsize(710) = 1
      ivarsize(711) = 1
      ivarsize(712) = 1
      ivarsize(713) = 1
      ivarsize(714) = 1
      ivarsize(715) = 1
      ivarsize(716) = 1
      ivarsize(717) = 1
      ivarsize(718) = 1
      ivarsize(719) = 1
      ivarsize(720) = 1
      ivarsize(721) = 1
      ivarsize(722) = 1
      ivarsize(723) = 1
      ivarsize(724) = 1
      ivarsize(725) = 1
      ivarsize(726) = 1
      ivarsize(727) = 1
      ivarsize(728) = 1
      ivarsize(729) = 1
      ivarsize(730) = 1
      ivarsize(731) = 1
      ivarsize(732) = 1
      ivarsize(733) = 1
      ivarsize(734) = 1
      ivarsize(735) = 1
      ivarsize(736) = 1
      ivarsize(737) = 1
      ivarsize(738) = 1
      ivarsize(739) = 1
      ivarsize(740) = 1
      ivarsize(741) = 1
      ivarsize(742) = 1
      ivarsize(743) = 1
      ivarsize(744) = 1
      ivarsize(745) = 1
      ivarsize(746) = 1
      ivarsize(747) = 1
      ivarsize(748) = 1
      ivarsize(749) = 1
      ivarsize(750) = 1
      ivarsize(751) = 1
      ivarsize(752) = 1
      ivarsize(753) = 1
      ivarsize(754) = 1
      ivarsize(755) = 1
      ivarsize(756) = 1
      ivarsize(757) = 1
      ivarsize(758) = 1
      ivarsize(759) = 1
      ivarsize(760) = 1
      ivarsize(761) = 1
      ivarsize(762) = 1
      ivarsize(763) = 1
      ivarsize(764) = 1
      ivarsize(765) = 1
      ivarsize(766) = 1
      ivarsize(767) = 1
      ivarsize(768) = 1
      ivarsize(769) = 1
      ivarsize(770) = 1
      ivarsize(771) = 1
      ivarsize(772) = 1
      ivarsize(773) = 1
      ivarsize(774) = 1
      ivarsize(775) = 1
      ivarsize(776) = 1
      ivarsize(777) = 1
      ivarsize(778) = 1
      ivarsize(779) = 1
      ivarsize(780) = 1
      ivarsize(781) = 1
      ivarsize(782) = 1
      ivarsize(783) = 1
      ivarsize(784) = 1
      ivarsize(785) = 1
      ivarsize(786) = 1
      ivarsize(787) = 1
      ivarsize(788) = 1
      ivarsize(789) = 1
      ivarsize(790) = 1
      ivarsize(791) = 1
      ivarsize(792) = 1
      ivarsize(793) = 1
      ivarsize(794) = 1
      ivarsize(795) = 1
      ivarsize(796) = 1
      ivarsize(797) = 1
      ivarsize(798) = 1
      ivarsize(799) = 1
      ivarsize(800) = 1
      ivarsize(801) = 1
      ivarsize(802) = 1
      ivarsize(803) = 1
      ivarsize(804) = 1
      ivarsize(805) = 1
      ivarsize(806) = 1
      ivarsize(807) = 1
      ivarsize(808) = 1
      ivarsize(809) = 1
      ivarsize(810) = 8
      ivarsize(811) = 1
      ivarsize(812) = 1
      ivarsize(813) = 1
      ivarsize(814) = 1
      ivarsize(815) = 1
      ivarsize(816) = 1
      ivarsize(817) = 1
      ivarsize(818) = 1
      ivarsize(819) = 1
      ivarsize(820) = 1
      ivarsize(821) = 1
      ivarsize(822) = 1
      ivarsize(823) = 1
      ivarsize(824) = 1
      ivarsize(825) = 1
      ivarsize(826) = 1
      ivarsize(827) = 1
      ivarsize(828) = 1
      ivarsize(829) = 1
      ivarsize(830) = 1
      ivarsize(831) = 1
      ivarsize(832) = 1
      ivarsize(833) = 1
      ivarsize(834) = 1
      ivarsize(835) = 1
      ivarsize(836) = 1
      ivarsize(837) = 1
      ivarsize(838) = 1
      ivarsize(839) = 1
      ivarsize(840) = 1
      ivarsize(841) = 1
      ivarsize(842) = 1
      ivarsize(843) = 1
      ivarsize(844) = 1
      ivarsize(845) = 1
      ivarsize(846) = 1
      ivarsize(847) = 1
      ivarsize(848) = 1
      ivarsize(849) = 1
      ivarsize(850) = 1
      ivarsize(851) = 1
      ivarsize(852) = 1
      ivarsize(853) = 1
      ivarsize(854) = 1
      ivarsize(855) = 1
      ivarsize(856) = 1
      ivarsize(857) = 1
      ivarsize(858) = 1
      ivarsize(859) = 8
      ivarsize(860) = 1
      ivarsize(861) = 1
      ivarsize(862) = 1
      ivarsize(863) = 1
      ivarsize(864) = 1
      ivarsize(865) = 1
      ivarsize(866) = 1
      ivarsize(867) = 1
      ivarsize(868) = 1
      ivarsize(869) = 1
      ivarsize(870) = 1
      ivarsize(871) = 1
      ivarsize(872) = 1
      ivarsize(873) = 1
      ivarsize(874) = 1
      ivarsize(875) = 1
      ivarsize(876) = 1
      ivarsize(877) = 1
      ivarsize(878) = 1
      ivarsize(879) = 1
      ivarsize(880) = 1
      ivarsize(881) = 1
      ivarsize(882) = 1
      ivarsize(883) = 1
      ivarsize(884) = 1
      ivarsize(885) = 1
      ivarsize(886) = 1
      ivarsize(887) = 1
      ivarsize(888) = 1
      ivarsize(889) = 1
      ivarsize(890) = 1
      ivarsize(891) = 1
      ivarsize(892) = 1
      ivarsize(893) = 1
      ivarsize(894) = 1
      ivarsize(895) = 1
      ivarsize(896) = 1
      ivarsize(897) = 1
      ivarsize(898) = 1
      ivarsize(899) = 1
      ivarsize(900) = 1
      ivarsize(901) = 1
      ivarsize(902) = 1
      ivarsize(903) = 1
      ivarsize(904) = 1
      ivarsize(905)=0
 
END SUBROUTINE trdatbuf_intmod_sub1

C-----------------------------------------------------------------------
C  PHDA00 -- INITIALIZE READ/WRITE OPERATION ON PH.DAT FILE
C    ROUTINE IS CALLED FROM GENERATED SUBROUTINE PHDATA
C
      SUBROUTINE PHDA00(KLUN)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER klun
!============
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
C---------------------------------------------------------------
C
      IFLAG=0
      ZNAMSV='$BEGIN  '
C
      RETURN
      END
C-----------------------------------------------------------------------
C  PHDAWR -- WRITE OPERATION ON PH.DAT FILE
C    ROUTINE IS CALLED FROM GENERATED SUBROUTINE PHDATA
C
      SUBROUTINE PHDAWR(KLUN,ZNAME,IVAL,INVAL)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER inval,klun,iwrote,iwp1,ilft
!============
      CHARACTER*(*) ZNAME
      INTEGER IVAL(INVAL)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C  ZNAME -- CHARACTER*(*) NAME OF ITEM TO WRITE
C  IVAL(INVAL) -- DIMENSION AND VALUE OF ITEM (INTEGER ARRAY) TO WRITE
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
C---------------------------------------------------------------
C
      ZNAM16=ZNAME
      IF(ZNAM16(1:8).EQ.'ZZZ-END-') THEN
C  WRITE END OF HEADER MARKER
        WRITE(KLUN,'(A)') ZNAME
      ELSE
C  WRITE DATA
        IWROTE=0
 10     CONTINUE
        IF(IWROTE.LT.INVAL) THEN
          IF(IWROTE.EQ.0) THEN
C  WRITE 1ST RECORD INCLUDING ITEM NAME
            ZBUF=ZNAM16//':'
            CALL PHDAW1(KLUN,2,IVAL,INVAL)
            IWROTE=4
          ELSE
C  WRITE ADDL RECORDS TO INCLUDE ALL DATA, IF NECESSARY
            ZBUF=' '
            IWP1=IWROTE+1
            ILFT=INVAL-IWROTE
            CALL PHDAW1(KLUN,0,IVAL(IWP1),ILFT)
            IWROTE=IWROTE+6
          ENDIF
          GO TO 10
        ENDIF
      ENDIF
      ZNAMSV=ZNAM16
C
      RETURN
      END
C-----------------------------------------------------------------------
C  PHDAW1 -- WRITE DATA TO PH.DAT FILE
C
      SUBROUTINE PHDAW1(KLUN,IOFF,IVAL,INVAL)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER ioff,inval,klun,ifld,ic,imax,inum,i,icx,il,ilnb
!============
      INTEGER IVAL(INVAL)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C  IOFF --  FIELD OFFSET (E.G. 1 MEANS SKIP FIRST FIELD)
C  IVAL(INVAL) -- DATA TO WRITE (INTEGERS)
C
C  THIS ROUTINE WRITES ONE LINE OF DATA, WHICH IS AT MOST 6
C  ITEMS ENCODED I13
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
C---------------------------------------------------------------
C
      IFLD=13
C
      IC=IOFF*IFLD+1
C
      IMAX=6-IOFF
C
      INUM=min(INVAL,IMAX)
C
      IC=IC-IFLD
      DO 10 I=1,INUM
        IC=IC+IFLD
        ICX=IC+IFLD-1
        WRITE(ZBUF(IC:ICX),'(I13)') IVAL(I)
 10   CONTINUE
C
      IL=LEN(ZBUF)
      DO 20 IC=IL,1,-1
        IF(ZBUF(IC:IC).NE.' ') GO TO 30
 20   CONTINUE
      IC=1
 30   ILNB=IC
C
      WRITE(KLUN,'(A)') ZBUF(1:ILNB)
C
      RETURN
      END
C-----------------------------------------------------------------------
C  PHDARD -- READ OPERATION ON PH.DAT FILE
C    ROUTINE IS CALLED FROM GENERATED SUBROUTINE PHDATA
C
      SUBROUTINE PHDARD(KLUN,ZNAME,IVAL,INVAL,IER)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER inval,ier,klun,i,iread,irp1,ilft
!============
      CHARACTER*(*) ZNAME
      INTEGER IVAL(INVAL)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C  ZNAME -- CHARACTER*(*) NAME OF ITEM TO READ
C  IVAL(INVAL) -- DIMENSION AND VALUE OF ITEM (INTEGER ARRAY) TO READ
C
C  IER -- RETURN CODE =0 IF OK OR CAUTIONS ONLY
C         =1 IF UNEXPECTED E-O-F
C         =2 IF OTHER ERROR
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
      integer :: lunmsg_tdb
C
C---------------------------------------------------------------
C  DEFAULT OUTPUT -- CLEAR VALUES TO ZERO
C
      DO 5 I=1,INVAL
        IVAL(I)=0
 5    CONTINUE
C
      ZNAM16=ZNAME
C
 10   CONTINUE
C  GET NEXT NAME FROM FILE...
      CALL PHDAR1(KLUN,1,IER)
      IF(IER.NE.0) GO TO 1000
C
      IF(ZNAMSV.EQ.ZNAM16) THEN
C  GO READ THE DATA
        GO TO 100
C
      ELSE IF(ZNAMSV.LT.ZNAM16) THEN
        WRITE(LUNMSG_TDB(0),1001) ZNAMSV
 1001 FORMAT(
     >' %PHDARD-- IGNORED UNRECOGNIZED NAME "',A,'" IN PH.DAT FILE')
        IFLAG=0
        GO TO 10
C
      ELSE
        WRITE(LUNMSG_TDB(0),1002) ZNAM16
 1002 FORMAT(
     >' %PHDARD-- DATA FOR "',A,'" NOT FOUND IN PH.DAT FILE')
        IER = 2
        GO TO 1000
      ENDIF
C
C  HAVE THE RIGHT NAME -- PROCESS INPUT DATA
C
 100  CONTINUE
      IF(ZNAM16(1:8).EQ.'ZZZ-END-') GO TO 1000
C
      IREAD=0
 110  CONTINUE
      IF(IREAD.LT.INVAL) THEN
        IF(IREAD.EQ.0) THEN
C  READ DATA ON SAME LINE WITH NAME
          CALL PHDAR2(KLUN,2,IVAL,INVAL,IER)
          IF(IER.NE.0) GO TO 1000
          IREAD=4
          IFLAG=0
        ELSE
C  READ ADDL RECORDS TO GET ALL DATA, IF NECESSARY
          IRP1=IREAD+1
          ILFT=INVAL-IREAD
          CALL PHDAR1(KLUN,0,IER)
          IF(IER.NE.0) GO TO 110
          IF(IFLAG.EQ.2) THEN
C  ONLY PROCESS IF THIS IS A DATA RECORD
            CALL PHDAR2(KLUN,0,IVAL(IRP1),ILFT,IER)
            IF(IER.NE.0) GO TO 1000
            IREAD=IREAD+6
            IFLAG=0
          ELSE
            WRITE(LUNMSG_TDB(0),1003) ZNAM16
 1003 FORMAT(
     >' %PHDARD -- MISSING PH.DAT DATA RECORD DETECTED, NAME="',A,'"')
            GO TO 1000
          ENDIF
        ENDIF
        GO TO 110
      ENDIF
C
C  EXIT
C
 1000 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
C  PHDAR1 -- READ RECORD FROM PH.DAT FILE
C
      SUBROUTINE PHDAR1(KLUN,ICALL,IER)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C  ICALL -- =1:  LOOK FOR A RECORD WITH A NAME HEADER
C           =0:  JUST READ A RECORD
C
C  IER -- RETURN CODE =0 IF OK
C         =1 IF UNEXPECTED E-O-F
C         =2 IF OTHER ERROR
C
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER icall,ier,klun
!============
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
C---------------------------------------------------------------
C  ON ENTRY, IFLAG=1 MEANS I HAVE ALREADY READ A RECORD WITH A NAME
C  FIELD; IFLAG=2 MEANS I HAVE ALREADY READ A RECORD WITH DATA ONLY
C
 10   CONTINUE
      IF((ICALL.EQ.1).AND.(IFLAG.NE.1)) IFLAG=0
C
C  NOW IFLAG.GT.0 MEANS WE ALREADY HAVE READ THE DATA
C
      IER=0
      IF(IFLAG.GT.0) RETURN
C
      READ(KLUN,'(A)',END=202,ERR=203) ZBUF
C
      IF((ZBUF(1:1).GE.'A').AND.(ZBUF(1:1).LE.'Z')) THEN
        IFLAG=1
        ZNAMSV=ZBUF(1:16)
      ELSE
        IFLAG=2
      ENDIF
C
      GO TO 10
C
 202  CONTINUE
      IER=1
      RETURN
C
 203  CONTINUE
      IER=2
      RETURN
C
      END
C
C-----------------------------------------------------------------------
C  PHDAR2 -- READ/INTERPRET DATA FROM PH.DAT FILE
C
      SUBROUTINE PHDAR2(KLUN,IOFF,IVAL,INVAL,IER)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER ioff,inval,ier,klun,ifld,ic,imax,inum,i,icx
!============
      INTEGER IVAL(INVAL)
C
C  KLUN -- L.U.N. OF OPEN PH.DAT FILE
C  IOFF -- FIELD OFFSET
C  IVAL(INVAL) -- DIMENSION AND VALUE OF ITEM (INTEGER ARRAY) TO READ
C
C  IER -- RETURN CODE =0 IF OK OR CAUTIONS ONLY
C         =1 IF UNEXPECTED E-O-F
C         =2 IF OTHER ERROR
C
C  READ INTEGER DATA BY DECODING 13 CHARACTER FIELDS
C  SEE ROUTINE PHDAW1 WHICH WROTE THE DATA BEING READ HERE
C
C---------------------------------------------------------------
C  COMMON BLOCKS SHARED BTW PHDAXX SUBROUTINES
      INTEGER IFLAG,IBUF(6)
      CHARACTER*16 ZNAMSV,ZNAM16
      CHARACTER*80 ZBUFSV,ZBUF
      COMMON/PHDAIO1/ ZNAMSV,ZNAM16,ZBUFSV,ZBUF
      COMMON/PHDAIO2/ IFLAG,IBUF
C
C---------------------------------------------------------------
      IER=0
C
      IFLD=13
C
      IC=IOFF*IFLD+1
C
      IMAX=6-IOFF
C
      INUM=min(INVAL,IMAX)
C
      IC=IC-IFLD
      DO 10 I=1,INUM
        IC=IC+IFLD
        ICX=IC+IFLD-1
        READ(ZBUF(IC:ICX),'(I13)',ERR=203) IVAL(I)
 10   CONTINUE
C
      RETURN
C
 203  CONTINUE
      IER=2
      RETURN
C
      END
C-----------------------------------------------------------------------
C******************** END FILE OLYMPS.FOR ; GROUP OLYMPS ***************
C*DECK Z2
! 19jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

module trx_bxtr_options

  ! mini-options module for trx_bxtr

  ! extrap_method = 1 for faster, ad hoc method (default: recommended)
  ! extrap_method = 2 for del.B=0, del x B = 0 "while smooth" extrapolator

  integer :: extrap_method = 1  

  ! edge smoothing parameter (meters) -- default: none
  ! note: xplasma will not permit edge_smooth to be more than a small
  !       fraction of the plasma width.

  real*8 :: edge_smooth = 0.0d0

end module trx_bxtr_options

!--------------------------------------------------------------------
      subroutine trxpl_add_scalar(zname)
 
      implicit NONE
 
      include 'trxpl.blk'
      character*10, intent(in) :: zname   ! name of scalar
 
      ! add a scalar to the list.
 
      !----------------------------
      integer i,ilz,ierr,lnout,idup
      logical lxout
      !----------------------------
 
      ilz=len_trim(zname)
 
      numsc=numsc+1
      sclabs(1,numsc)=zname
      ilz=min(10,ilz+1)
      sclabs(1,numsc)(ilz:ilz)=':'
      sclabs(2,numsc)=zname
 
      idup=numsc
      do i=1,numsc-1
         if(sclabs(1,numsc).eq.sclabs(1,i)) then
            idup=i
         endif
      enddo
 
      if(idup.lt.numsc) then
         write(lnout(0),*) ' %duplicate name: ',zname
         numsc=numsc-1
         ierr=0
      else
         call trx_scal(zname,sclabs(3,numsc),scvals(numsc),ierr)
      endif
 
      if(ierr.ne.0) then
         write(6,*) ' %trxpl:  scalar ',zname(1:ilz),' not added.'
         numsc=numsc-1
      else
         write(6,*) sclabs(1,idup),' ',sclabs(3,idup),
     >      ' = ',scvals(idup)
      endif
 
      return
      end
 

!  ** trxplib_ps_io ** 
!  Control extraction of Plasma States from TRANSP archives
!
!  For many applications the following call sequence should serve:
!
!  (first call to connect to run -- be sure to check ierr return value):
!      call trxplib_ps_open(rdtype,rdpath,outpath,oprfix,ierr)
!         character*(*), intent(in) :: rdtype  !  "MDS+" or "FILE"
!         character*(*), intent(in) :: rdpath  ! path to run data
!         character*(*), intent(in) :: outpath ! path to directory for output
!         character*(*), intent(in) :: oprfix  ! PS file prefix (blank OK)
!         integer, intent(out) :: ierr       ! completion status, 0=OK
!
!            (this will write protimes.dat, sawtimes.dat, and a "test" state
!             including machine description, in trim(outpath)... ).
!
!  (multiple calls for each desired time_of_interest...)
!      call trxplib_ps_write(time_of_interest,ps_filename,ierr)
!         real*8, intent(in) :: time_of_interest    ! desired time
!         character*(*), intent(in) :: ps_filename  ! desired output filename
!         integer, intent(out) :: ierr       ! completion status, 0=OK
!
!    --- OR ---
!
!      call trxplib_ps_get(time_of_interest,<state_object>,ierr)
!         this returns a filled-in state object (no file is written)
!
!      there is no time averaging if these calls are used.
!
!  (final call to disconnect from run)
!      call trxplib_ps_close
!
!---------------------------------------------------
!  control routine, call any time:
!     trxplib_mhdeq_opt(...)  ! specify if output states should include
!                             ! MHD equilibrium flux surface geometry data
!
!     (see code, below, for explanation of calling arguments).
!---------------------------------------------------
!  additional routines, to be called PRIOR to trxplib_ps_open
!
!     trxplib_ps_reset  ! set defaults; if connected to run, disconnect now
!     trxplib_ps_nTheta(...)  ! set n_theta (generally default value is OK)
!     trxplib_ps_nRZ(...)  ! set nR and nZ (defaults OK: will be overridden
!                          ! in cases where TRANSP free boundary data exists).
!     trxplib_ccw_options(...)  ! CCW control options
!
!  Except for trxplib_ps_reset these routines have no effect on currently
!  opened run, if called after trxplib_ps_open(...)
!
!     (see code, below, for explanation of calling arguments).
!---------------------------------------------------
!  additional write routine:
!
!     trxplib_ps_write_opt(...)
!
!  works like trxplib_ps_write but with control over time averaging
!
!       --- OR ---
!
!     trxplib_ps_get_opt(...)
!
!  works like trxplib_ps_get but with control over time averaging
!
!     (see code, below, for explanation of calling arguments).
!---------------------------------------------------
!  The software may write messages-- to stdout (fortran unit 6) by default.
!  It shares message I/O control with "rplot" (TRANSP data access) libraries.
!  To redirect such messages, "rplot" library calls are used:
!
!     call plc_msgs(<lun>,filename) ...to open <filename> on integer unit <lun>
!                                   and write messages there, or,
!
!     call plc_msgs(<lun>,' ') ...to just write on integeru unit <lun>;
!                              presumably the caller has opened a file.


!--------------------------------------------------------------------------
subroutine trxplib_ps_open(rdtype,rdpath,outpath,oprfix,ierr)

  ! open connection to run...

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  character*(*), intent(in) :: rdtype  !  "MDS+" or "FILE"
  character*(*), intent(in) :: rdpath  ! path to run data
  character*(*), intent(in) :: outpath ! path to directory for output
  character*(*), intent(in) :: oprfix  ! PS time series output file prefix

  integer, intent(out) :: ierr         ! completion status, 0=OK

  !-------------------
  !  local:

  type (plasma_state) :: wkps

  integer :: nonlin,lunzer,ilun,ilen,istat,ierloc
  character*10 :: ztest,pidstr
  character*200 :: tfile

  !-------------------------------------------------
  ! executable code:

  ierr = 0

  nonlin = lunzer(0)  ! LUN for messages

  call find_io_unit(ilun)  ! LUN for output files
  call sget_pid_str(pidstr,ilen)  ! PID of current process

  !-------------------
  ! mark run as NOT open
  !-------------------

  ready = .FALSE.

  !-------------------
  ! test argument: rdtype
  !-------------------

  ztest = rdtype
  call uupper(ztest)

  if(ztest.eq.'MDS+') then
     lmds = .TRUE.
  else if(ztest.eq.'FILE') then
     lmds = .FALSE.
  else

     ierr=1
     write(nonlin,*) &
          ' ?trxplib_ps_open: 1st argument (rdtype) invalid or blank: '// &
          trim(rdtype)
     return
  endif

  !-------------------
  ! test argument: opath
  !   (have to be able to write a file here)
  !-------------------

  tfile = trim(outpath)//'/'//pidstr(1:ilen)//'.tmp'
  open(unit=ilun,file=tfile,status='unknown',iostat=istat)

  if(istat.ne.0) then
     ierr=1
     write(nonlin,*) &
          ' ?trxplib_ps_open: file open test unsuccessful in output directory:'
     write(nonlin,*) '   '//trim(outpath)
     return
  endif

  write(unit=ilun,fmt='(A)',iostat=istat) ' this is a test '

  if(istat.ne.0) then
     ierr=1
     write(nonlin,*) &
          ' ?trxplib_ps_open: file write test failed in output directory:'
     write(nonlin,*) '   '//trim(outpath)
  endif

  close(unit=ilun,status='delete')
  if(ierr.ne.0) return

  !-------------------
  !  OK...
  !-------------------

  rpath = rdpath
  opath = outpath

  call ps_init_user_state(wkps, "wkps_trxplib", ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_open: work state initialization failure.'
     return
  endif

  ps_prefix = oprfix

  call trxplib_ps_connect(wkps,ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_open: connect failure: '//trim(rdpath)
     return
  endif

  call ps_free_user_state(wkps, ierloc)
  if(ierloc.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_open: error deallocating work state (ignored).'
  endif

end subroutine trxplib_ps_open

!--------------------------------------------------------------------------
subroutine trxplib_ps_write(time,filename,ierr)

  ! write a Plasma State file -- no time averaging, no sawtooth hint

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  real*8, intent(in) :: time    ! time at which to extract data
  character*(*), intent(in) :: filename  ! root name of PS file
                                ! NOTE: ".cdf" appended, NetCDF file

  integer, intent(out) :: ierr  ! exit status code, 0=OK

  !---------------------------
  ! local:

  integer :: nonlin,lunzer
  integer :: ierloc
  type (plasma_state) :: wkps
  !---------------------------

  ierr = 0

  nonlin = lunzer(0)  ! LUN for messages

  saw_hint = 0
  delta_t = 0.0d0

  tselect = time
  ps_file = filename//'.cdf'

  call ps_init_user_state(wkps, "wkps_trxplib", ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write: work state initialization failure.'
     return
  endif

  call trxplib_ps_xplasma_ini(ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write: trxplib_ps_xplasma_ini failure.'
     return
  endif

  call trxplib_ps_write1(wkps, .FALSE., ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write: trxplib_ps_write1 failure.'
     return
  endif

  call ps_free_user_state(wkps, ierloc)
  if(ierloc.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write: error deallocating work state (ignored).'
  endif

end subroutine trxplib_ps_write

!--------------------------------------------------------------------------
subroutine trxplib_ps_get(time,ss,ierr)

  ! write a Plasma State file -- no time averaging, no sawtooth hint

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  real*8, intent(in) :: time    ! time at which to extract data
  type (plasma_state) :: ss     ! plasma state object, retuned with data
  !  CAUTION: any old data previously in (ss) is replaced.

  integer, intent(out) :: ierr  ! exit status code, 0=OK

  !---------------------------
  ! local:
  integer :: nonlin,lunzer
  !---------------------------

  ierr = 0

  nonlin = lunzer(0)  ! LUN for messages

  saw_hint = 0
  delta_t = 0.0d0

  tselect = time
  ps_file = 'NONE'

  call trxplib_ps_xplasma_ini(ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_get: trxplib_ps_xplasma_ini failure.'
     return
  endif

  call trxplib_ps_write1(ss, .FALSE., ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_get: trxplib_ps_write1 failure.'
     return
  endif

end subroutine trxplib_ps_get

!--------------------------------------------------------------------------
subroutine trxplib_ps_write_opt(time,filename,nhint_saw,delt_avg,ierr)

  ! write a Plasma State file -- no time averaging, no sawtooth hint

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  real*8, intent(in) :: time    ! time at which to extract data
  character*(*), intent(in) :: filename  ! root name of PS file
                                ! NOTE: ".cdf" appended, NetCDF file

  integer, intent(in) :: nhint_saw  ! sawtooth hint:
  !                             ! =1: look for post-sawtooth time(s)
  !                             ! =-1: look for pre-sawtooth time(s)
  !                             ! =0: no hint, use exact time provided

  real*8, intent(in) :: delt_avg  ! +/- averaging time for extracted data

  integer, intent(out) :: ierr  ! exit status code, 0=OK

  !---------------------------
  ! local:

  integer :: nonlin,lunzer
  integer :: ierloc
  type (plasma_state) :: wkps
  !---------------------------

  ierr = 0

  nonlin = lunzer(0)  ! LUN for messages

  saw_hint = nhint_saw
  saw_hint = max(-1, min(1, saw_hint))

  delta_t = abs(delt_avg)

  tselect = time
  ps_file = filename//'.cdf'

  call ps_init_user_state(wkps, "wkps_trxplib", ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write_opt: work state initialization failure.'
     return
  endif

  call trxplib_ps_xplasma_ini(ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write_opt: trxplib_ps_xplasma_ini failure.'
     return
  endif

  call trxplib_ps_write1(wkps, .FALSE., ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write_opt: trxplib_ps_write1 failure.'
     return
  endif

  call ps_free_user_state(wkps, ierloc)
  if(ierloc.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write_opt: error deallocating work state (ignored).'
  endif

end subroutine trxplib_ps_write_opt

!--------------------------------------------------------------------------
subroutine trxplib_ps_get_opt(time,ss,nhint_saw,delt_avg,ierr)

  ! write a Plasma State file -- no time averaging, no sawtooth hint

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  real*8, intent(in) :: time    ! time at which to extract data
  type (plasma_state) :: ss     ! plasma state object, retuned with data
  !  CAUTION: any old data previously in (ss) is replaced.

  integer, intent(in) :: nhint_saw  ! sawtooth hint:
  !                             ! =1: look for post-sawtooth time(s)
  !                             ! =-1: look for pre-sawtooth time(s)
  !                             ! =0: no hint, use exact time provided

  real*8, intent(in) :: delt_avg  ! +/- averaging time for extracted data

  integer, intent(out) :: ierr  ! exit status code, 0=OK

  !---------------------------
  ! local:
  integer :: nonlin,lunzer
  !---------------------------

  ierr = 0

  nonlin = lunzer(0)  ! LUN for messages

  saw_hint = nhint_saw
  saw_hint = max(-1, min(1, saw_hint))

  delta_t = abs(delt_avg)

  tselect = time
  ps_file = 'NONE'

  call trxplib_ps_xplasma_ini(ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_get_opt: trxplib_ps_xplasma_ini failure.'
     return
  endif

  call trxplib_ps_write1(ss, .FALSE., ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_get_opt: trxplib_ps_write1 failure.'
     return
  endif

end subroutine trxplib_ps_get_opt

!--------------------------------------------------------------------------
subroutine trxplib_ps_close

  ! disconnect from run (no arguments)

  use trxplib_ps_options
  implicit NONE

  !---------------------------

  ready = .FALSE.

end subroutine trxplib_ps_close

!--------------------------------------------------------------------------
subroutine trxplib_mhdeq_opt(option)

  ! specify TRUE for "heavy" state with MHD flux surfaces include
  ! otherwise specify FALSE

  ! if this routine is never called, TRUE is in effect

  use trxplib_ps_options
  implicit NONE

  logical, intent(in) :: option

  !---------------------------

  lheavy = option

end subroutine trxplib_mhdeq_opt

!--------------------------------------------------------------------------
subroutine trxplib_ps_reset

  ! reset I/O module defaults (no arguments)
  ! (this disconnects from any currently open run)

  use trxplib_ps_options
  implicit NONE

  !---------------------------

  call reset

end subroutine trxplib_ps_reset

!--------------------------------------------------------------------------
subroutine trxplib_ccw_options(Bccw,Jccw)

  ! control CCW options (CCW stands for "counter-clockwise")

  ! toroidal field:
  !   Bccw=1 means, force B_phi to point CCW in tokamak as viewed from above
  !   Bccw=-1 means force B_phi to point CW
  !   Bccw=0 means, use the orientation found in the TRANSP run data

  ! toroidal current:
  !   Jccw=1 means, force J_phi to point CCW in tokamak as viewed from above
  !   Jccw=-1 means force J_phi to point CW
  !   Jccw=0 means, use the orientation found in the TRANSP run data

  use trxplib_ps_options
  implicit NONE

  integer, intent(in) :: Bccw  ! B_phi orientation control
  integer, intent(in) :: Jccw  ! J_phi orientation control

  !---------------------------

  Bccw_hint = max(-1,min(1, Bccw))

  Jccw_hint = max(-1,min(1, Jccw))

end subroutine trxplib_ccw_options

!--------------------------------------------------------------------------
subroutine trxplib_ps_ntheta(nth)

  ! specify number of poloidal angle points, in MHD equilibrium flux surfaces
  ! numerical representation

  use trxplib_ps_options
  implicit NONE

  integer, intent(in) :: nth

  !---------------------------
  !  local:
  integer :: nonlin,lunzer
  !---------------------------

  nonlin = lunzer(0)

  n_theta = max(65,nth)
  
  if(n_theta.ne.nth) then
     write(nonlin,*) ' %trxplib_ps_ntheta: minimum value (65) imposed.'
     write(nonlin,*) '  input value was overridden: ',nth
  endif

end subroutine trxplib_ps_ntheta

!--------------------------------------------------------------------------
subroutine trxplib_ps_nRZ(nRi,nZi)

  ! specify number of (R,Z) cartesian grid points for
  ! numerical representation of free boundary MHD equilibria

  use trxplib_ps_options
  implicit NONE

  integer, intent(in) :: nRi,nZi   ! the R & Z grid sizes, respectively

  !---------------------------
  !  local:
  integer :: nonlin,lunzer
  !---------------------------

  nonlin = lunzer(0)

  nR = max(65,nRi)
  nZ = max(65,nZi)
  
  if((nR.ne.nRi).OR.(nZ.ne.nZi)) then
     write(nonlin,*) ' %trxplib_ps_nRZ: minimum value (65) imposed.'
     write(nonlin,*) '  input value(s) overridden: ',nR,nZ
  endif

end subroutine trxplib_ps_nRZ

C-----------------------------------------------------------------------
C
      SUBROUTINE TDB_PROFLI(d, t, INRI,INSY,
     >        ILX,INX,ILF,
     >        ILXSY,INXSY,ILFSY,ILSSY,
     >        ierr)
C
      use trdatbuf_obj
      use trdatbuf_aux
      use trdatbuf_iface, only: tdb_xilmp, tdb_xisymp
C
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  dmc -- May 2005 -- modular implementation -- no trcom
C         f90 derived types are employed...
C
      type (trdatbuf) :: d
      type (profget) :: t
C
C  DMC -- **REDESIGNED INTERFACE** -- 17 MAR 1992
C   THE CODE IS BEING RESTRUCTURED FOR USE WITH THE OUTPUT OF THE NEW
C   VERSION TRDAT PROGRAM.  TRDAT OUTPUTS AND TRANSP COMMON NOW CONTAIN
C   THE SAME THINGS FOR EACH PROFILE INPUT DATA TYPE.  TDB_PROFLI PROCESSES
C   THE INTERPOLATION OF PROFILE DATA USING ALL OF THESE FORMS OF INFO
C   FOR ALL TYPES OF INPUT PROFILE DATA
C
C   INPUTS:  CONTROL OPTIONS, TIME TO INTERPOLATE TO, POINTERS TO
C     PROFILE DATA IN DATBUF
C
C   OUTPUTS:  THE interpolated DATA 
C
C   optional debug outputs, if t%idebug = T
C     DATA ASSYMETRY profile IF SYMMETRIZED HERE.
C     THE SHIFT PROFILE (IF SLICE AND STACK PRESYMMETRIZATION WAS USED)
C     AND MAPPING CHECKS VS. MAJOR RADIUS -- the original data vs. major
C     radius; the symmetrized data vs. major radius, for comparison.
C
C  DMC - 1986 - NEW ROUTINE - INTERPOLATE PROFILE DATA
C   COPIED FROM OLD CODE, PROFE1.FOR, JAN 1986.
C   GENERALIZED ROUTINE ALLOWS SAME TECHNIQUES TO BE USED IN
C   INTERPOLATING DATA OTHER THAN ELECTRON TEMPERATURE AND DENSITY.
C
C  SUBROUTINES OF TDB_PROFLI - CF PFSETR.FOR (DEFINE INTERPOLATION TARGET
C  DATA) AND INT2D.FOR (EXECUTE INTERPOLATION ON 2D ARRAY)
C
C  ARGUMENTS (INPUT)
C
C    INRI - TYPE OF NORMALIZED RADIAL VECTOR USED TO STORE THE 2D
C     DATA ARRAY (WHICH IS TO BE INTERPOLATED HERE)
C      =1:  MIDPLANE RADIUS - OUTSIDE HALF OF PLASMA
C          SHAFRANOV CORRECTION MAY BE EMPLOYED
C      =2:  MIDPLANE RADIUS - INSIDE HALF OF PLASMA
C      =3:  MIDPLANE RADIUS, 2 SIDED DATA, BOTH SIDES OF PLASMA
C      =4:  ABEL INVERTED DATA MINOR RADIUS; NO SHAFRANOV CORRECTION
C    DATA MAY ALSO BE TEMPERATURE VS ECE FREQUENCY; SEE IECE SWITCH...
C    NOTE:  NEGATIVE INRI VALUES MAY BE ENCOUNTERED IN TRDAT -- THESE
C      INDICATE AN INPUT UFILE WITH SPATIAL COORDINATE ALREADY NORM-
C      ALIZED; THE ABSOLUTE VALUE IS USED IN THIS ROUTINE
C      =5:  (new dmc 4 May 1993)  *** DATA HAS ALREADY BEEN MAPPED ***
C          TO normalized sqrt(tor.flux) "XI" coordinate.
C      =6:  data is mapped to normalized poloidal flux (no SQRT)
C      =7:  data mapped to normalized SQRT(pol.flux)
C      =8:  data mapped to normalized toroidal flux (no SQRT)
C
C    INSY - SYMMETRIZATION OPTION
C     VALID FOR INRI=3 ONLY:
C      =1:  SLICE AND STACK; DATA HAS BEEN PRESYMMETRIZED.
C      =2:  IN/OUT AVERAGE, PERFORMED HERE.
C      =3:  weighted IN/OUT AVERAGE, PERFORMED HERE ALSO
C      =4:  "R weighted in/out average".  Use the TRANSP MHD 
C           geometry to determine the locations of the two intercepts of each 
C           flux surface with the midplane. The weighted average of the profile 
C           at the inner and outer flux surfaces is given by
C               Navg = (Nin*Rin+Nout*Rout)/(Rin+Rout)
C           where Rin,Rout are the major radii at the inner and outer flux surface
C           midplane intercepts.  Same Notes applies as for NSYxxx=2.  This option
C           is mainly provided as a compatibility feature, since old versions of
C           TRANSP applied this weight when symmetrizing electron density (NER)
C           data and other density profiles, under NSYxxx=2.
C
C
C    in "t"
C     t%iece is .TRUE. IFF data is Te vs. ECE frequency 
C
C    t%ibdy = T TO INTERPOLATE DATA DIRECTLY TO ZONE BDY'S THEN FILL IN
C      ZONE CTRS  O.W. USE OLD ALGORITHM: INTERPOLATE DIRECTLY TO CTR'S
C      AND FILL IN BDY'S -- USE THIS FOR CHI(E) AND OTHER BDY - ORIENTED
C      DATA
C    +++> t%IBDY .AND. t%IECE NOT COMPATIBLE <+++
C
C    ILX - POINTER TO 2D STORED DATA X (RADIUS) PTS
C    INX - NUMBER OF X PTS IN 2D STORED DATA
C    ILF - POINTER TO 2D STORED DATA
C
C  THESE POINTERS POINT TO OUTPUT OF SLICE AND STACK PRESYMMETRIZER:
C    ILXSY - POINTER TO 2D STORED DATA X PTS -- PRESYMMETRIZED
C    INXSY - NUMBER OF X PTS IN 2D STORED DATA -- PRESYMMETRIZED
C    ILFSY - POINTER TO 2D STORED DATA -- PRESYMMETRIZED
C    ILSSY - POINTER TO 2D STORED DATA SHIFT PROFILE -- PRESYMMETRIZED
C
C
C
C    t%TIME - ** TIME ** TO INTERPOLATE DATA
C
C
C
C --------------
C  OUTPUT DATA
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER insy,ibdy,ilx,inx,ilf,ilxsy,inxsy,ilfsy
      INTEGER ilssy,inri,ierr,inria,iabs,j,ihece,iloop,iz,i,ilxuse
      INTEGER inxuse,ilfuse,iltuse,intime,il,izones,iixtrp,isgn
      INTEGER i2,iadr,icenr,i1,ioff,jp1,iorig,jm1
      integer :: nonlin,nout,lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ztime,ztol,ztl1,ztl2,zslp,zf2,zf1
!============
C
C  WORKSPACE
C
      real*8, dimension(:), allocatable :: zdatw
C
      REAL*8 ZW1,ZW2,zr1,zr2,zr1p,zr2p
C
      INTEGER INOUT(2)
C
C  PFSETR ROUTINE ALSO USED PARTS OF COMMON ARRAY WORKBUF FOR WORKSPACE
C
      LOGICAL ILDBUG  ! .TRUE. FOR EXTRA DEBUG OUTPUT
      DATA ILDBUG/.FALSE./
C
C----------------------
C
C  EXECUTABLE CODE
C
C    PART 1.  COMPUTE ZDATA AND ZDATW -- PROFILES MAPPED TO TRANSP
C    FLUX SURFACES, AND AN OPTIONAL ASSYMETRY FACTOR
C
C    DEFINE THE INTERPOLATION TARGET POSITIONS
C    IN THE COORDINATES IN WHICH THE 2D DATA IS STORED...
C
      ztime = t%time

      IZONES=t%NZONES+1
      allocate(zdatw(izones)); zdatw = 0.0_R8

      if(t%ibdy) then
         ibdy = 1
      else
         ibdy = 0
      endif

      IERR=0

      if(t%idebug) then
         call tdb_xilmp(t%nzones,t%xibdys,t%xilmp)
         call tdb_xisymp(t%nzones,t%xibdys,t%rmajmp,t%xirsym,t%rmjsym)
      endif

      nonlin = lunmsg_tdb(0)
      nout = nonlin

      if (ilf .eq. 0 .and. ilfsy .eq. 0) then
         write(nonlin,*)
     >        'DATA POINTERS PASSED TO TDB_PROFLI ARE ZERO'
         ierr = 1
         goto 40100
      end if
C
      INRIA=IABS(INRI)
C
      IF((INRIA.LE.0).OR.(INRIA.GT.8)) THEN
         WRITE(NONLIN,9000) INRI
 9000    FORMAT(' ?TDB_PROFLI:  ILLEGAL INPUT DATA RADIAL TYPE INRI=',
     >        I12)
         IERR=1
      ENDIF
C
      IF((t%iece).AND.(IBDY.EQ.1)) THEN
        WRITE(NONLIN,9001)
 9001   FORMAT(
     >       ' ?TDB_PROFLI ERROR:  BOTH FLAGS IECE AND IBDY ARE ACTIVE')
        IERR=1
      ENDIF
C
      IF((INRIA.EQ.3).AND.((INSY.LT.1).OR.(INSY.GT.4))) THEN
        WRITE(NONLIN,9002) INSY
 9002   FORMAT(' ?TDB_PROFLI:  ILLEGAL SYMMETRIZATION CODE INSY=',I12)
        IERR=1
      ENDIF
C
      IF((INRIA.NE.3).AND.(INSY.NE.0)) THEN
        WRITE(NONLIN,9003) INSY
 9003   FORMAT(' ?TDB_PROFLI:  NON-ZERO SYMMETRIZATION CODE INSY=',I12)
        IERR=1
      ENDIF
C
      IF(IERR.NE.0) GO TO 40100
C
      IF(t%iece) THEN
        IHECE=d%NHECFT
      ELSE
        IHECE=0
      ENDIF
C
      IF(IHECE.GT.0) THEN
C  IF THE ECE DATA WAS MAPPED IN PRESYMMETRIZATION, DO NOT TRY
C  TO MAP IT AGAIN...!
        IF((INRIA.EQ.3).AND.(INSY.EQ.1)) IHECE=-1
      ENDIF
C
      CALL TDB_PFSETR(d,t,INRIA,INSY,IHECE,IBDY,ILOOP,INOUT)
      if(iloop.eq.0) then
         ierr=777
         go to 40100
      endif
C
C  CLEAR THE OUTPUT ARRAYS
C
      t%data_zc = 0.0_R8
      t%data_zb = 0.0_R8
C
      if(t%idebug) then
         t%asym_zc = 0.0_R8
         t%asym_zb = 0.0_R8
         t%shift = 0.0_R8
         t%datrsym = 0.0_R8
         t%datusym = 0.0_R8
      endif
C
C  ASSUME LINEAR INTERPOLATION IS OK
C
C  CHOOSE DATA SOURCE
      IF((INRIA.EQ.3).AND.(INSY.EQ.1)) THEN
C  PRESYMMETRIZED
        iorig=0
        ILXUSE=ILXSY
        INXUSE=INXSY
        ILFUSE=ILFSY
        ILTUSE=d%LTIME2
        INTIME=d%NTIME2
C  ERROR CHECK ON TIME RANGE:
        ZTL1=d%DATBUF(d%LTIME2)
        ZTL2=d%DATBUF(d%LTIME2+d%NTIME2-1)

        ztol = 1.0e-12_R8*max(1.0_R8,(ZTL2-ZTL1))

        if((ZTIME.LT.ZTL1).and.(ZTIME.ge.(ZTL1-ztol))) then
           ztime=ZTL1
        endif

        if((ZTIME.GT.ZTL2).and.(ZTIME.le.(ZTL2+ztol))) then
           ztime=ZTL2
        endif

        IF((ZTIME.LT.ZTL1).OR.(ZTIME.GT.ZTL2)) THEN
          WRITE(NONLIN,9901) ZTL1,ZTL2,ZTIME
          ierr=999
          go to 40100
        ENDIF

 9901   FORMAT(/
     >' ?TDB_PROFLI -- CALL TO INTERPOLATE PRESYMMETRIZED DATA IS OUT'/
     >'  OF BOUNDS IN TIME.  PRESYMMETRIZED DATA RANGE IS'/
     >'  ',1PE14.7,' TO ',1PE14.7,' SECONDS; INTERPOLATION IS'/
     >'  REQUESTED AT ',1PE14.7,' SECONDS.'/)

      ELSE
C  ORIGINAL
        iorig=1
        ILXUSE=ILX
        INXUSE=INX
        ILFUSE=ILF
        ILTUSE=d%LTIME2
        INTIME=d%NTIME2
      ENDIF
C
C  LOOP OVER INNER/OUTER HALF; OR ONE HALF ONLY -- SEE PFSETR ROUTINE
C
      DO IL=1,ILOOP
C
         ZSLP=0.0_R8
         IIXTRP=1
C
         if(iorig.eq.1) then
            CALL INT2D(d%DATBUF(ILTUSE),INTIME,
     1           d%DATBUF(ILXUSE),INXUSE,
     2           d%DATBUF(ILFUSE),INTIME,INXUSE,
     3           ZTIME,
     4           d%WORKBUF(d%LBX(IL)), IZONES,
     4           d%WORKBUF(d%LBX(3)),
     5           ZSLP,
     6           IIXTRP, ILDBUG, IERR, NOUT)
         else
            CALL INT2D(d%DATBUF(ILTUSE),INTIME,
     1           d%DATBUF(ILXUSE),INXUSE,
     2           d%DATBUF(ILFUSE),INTIME,INXUSE,
     3           ZTIME,
     4           d%WORKBUF(d%LBX(IL)), IZONES,
     4           d%WORKBUF(d%LBX(3)),
     5           ZSLP,
     6           IIXTRP, ILDBUG, IERR, NOUT)
         endif
C
         IF(IERR.NE.0) GO TO 40100
C
C		--------------------------------
C		1.6	STORE NEW DATA VALUES
C		--------------------------------
C
C  SET UP FOR EXTRACTION OF ASYMMETRY TERM.
C  SIGN=+1 FOR FIRST SIDE (IL=1), -1 FOR SECOND SIDE (IL=2)
C
         ISGN=3-2*IL
         ZF2=.5_R8*(ILOOP-1)
C
         ZF1=1.0_R8/ILOOP
C
         DO I = 1,izones
C  CHECK FOR INDEX ORDER REVERSAL BTW. MINOR AND MAJOR RADIAL COORD
            I2=I-1
            IF(INOUT(IL).EQ.2) I2=izones-I
            IADR=d%LBX(3)+I2
            if(ibdy.eq.0) then
               t%data_zc(i)=t%data_zc(i) + ZF1*d%WORKBUF(IADR)
            else
               t%data_zb(i)=t%data_zb(i) + ZF1*d%WORKBUF(IADR)
            endif
            if(t%idebug) then
               if((i.gt.1).or.(ibdy.eq.0)) then
                  zdatw(i)=zdatw(i)+ ISGN*ZF2*d%WORKBUF(IADR)
               endif
            endif
         enddo
C
C  END OF INNER/OUTER DATA-HALF LOOP
C
      enddo
C
C  IF DATA IS 2-SIDED ADJUST ZDATA TO BE THE VOLUME-WEIGHTED FLUX
C  SURFACE AVERAGE - ASSUMING A COS(POL. ANGLE) VARIATION IN DENSITY
C  ALONG THE FLUX SURFACE OR WHEN INSY=3, WEIGHT BASED ON FLUX
C  SURFACE SPACING.
C
      IF(INRIA.EQ.3) THEN
         IF (INSY.EQ.3) THEN
            DO J=1,izones
               if((ibdy.eq.0).or.(j.gt.1)) then
                  call profli_nsy3(J,ZW1,ZW2)
                  if(ibdy.eq.0) then
                     t%data_zc(j)=t%data_zc(j) + 
     >                    zdatw(j)*(ZW2-ZW1)/(ZW2+ZW1)
                  END IF
               endif
            END DO
         ELSE IF (INSY.EQ.4) THEN
            zr1=t%rmajmp(izones)
            zr2=zr1
            DO J=1,izones
               if((ibdy.eq.0).or.(j.gt.1)) then
                  if(ibdy.eq.1) then
                     zr1=t%rmajmp(izones-j+1)
                     zr2=t%rmajmp(izones+j-1)
                     t%data_zb(j)=t%data_zb(j)+
     >                    0.5_R8*zdatw(j)*(zr2-zr1)/(zr2+zr1)
                  else
                     zr1p=zr2
                     zr2p=zr2
                     zr1=t%rmajmp(izones-j+1)
                     zr2=t%rmajmp(izones+j-1)
                     t%data_zc(j)=t%data_zc(j)+
     >                    0.5_R8*zdatw(j)*(zr2+zr2p-(zr1+zr1p))/
     >                    (zr2+zr2p+zr1+zr1p)
                  endif
               endif
            enddo
         END IF
      ENDIF
C
C  FILL IN VALUES NOT INTERPOLATED FROM DATA
C   I.E. BDY'S IF CTR'S WERE GOTTEN FROM DATA
C   OR CTR'S IF BDY'S WERE GOTTEN FROM DATA
C
      if(t%idebug) then
         if(ibdy.eq.0) then
            t%asym_zc = zdatw
         else
            t%asym_zb = zdatw
         endif
      endif

      IF(IBDY.EQ.0) THEN
         t%data_zb(1)=t%data_zc(1)
         if(t%idebug) t%asym_zb(1)=0.0_R8
         do j=2,izones
            t%data_zb(j)=0.5_R8*(t%data_zc(j-1)+t%data_zc(j))
            if(t%idebug) then
               t%asym_zb(j)=0.5_R8*(t%asym_zc(j-1)+t%asym_zc(j))
            endif
         enddo
      else
         t%data_zc(izones)=t%data_zb(izones)
         if(t%idebug) t%asym_zc(izones)=t%asym_zb(izones)
         DO J=2,izones
            t%data_zc(j-1)=0.5_R8*(t%data_zb(j-1)+t%data_zb(j))
            if(t%idebug) then
               t%asym_zc(j-1)=0.5_R8*(t%asym_zb(j-1)+t%asym_zb(j))
            endif
         enddo
C
      ENDIF
C
C-----------------------------------------------------------------------
C  PART 2.  COMPUTE THE INFERRED SHIFT -- ACTUALLY, INTERPOLATE THE
C  OUTPUT OF THE PRESYMMETRIZER
C
      IF((INRIA.EQ.3).AND.(INSY.EQ.1).and.(t%idebug)) THEN
C
        ZSLP=0.0_R8
        CALL INT2D(d%DATBUF(d%LTIME2),d%NTIME2,
     1			d%DATBUF(ILXSY),INXSY,
     2			d%DATBUF(ILSSY),d%NTIME2,INXSY,
     3			ZTIME,
     4			t%xibdys, IZONES,
     4			t%shift,
     5			ZSLP,
     6			IIXTRP, ILDBUG, IERR, NOUT)
C
        IF(IERR.NE.0) GO TO 40100
C
      ENDIF
C
C-----------------------------------------------------------------------
C  PART 3.  COMPUTE THE DATA FOR THE OUTPUT SYMMETRIZATION / MAPPING
C  MULTIGRAPH  ("TECOM" STYLE MULTIGRAPH FOR RPLOT)
C
C  THE ORIGINAL DATA IS SIMPLY MAPPED TO THE TWO SIDED OUTPUT ARRAY
C
      if(t%idebug) then

         ICENR=2*t%nzones + 3
         t%datrsym(icenr) = t%data_zb(1)

         t%datrsym(1:2) = t%data_zc(izones)
         t%datrsym(t%nrsym-1:t%nrsym) = t%data_zc(izones)
C
         IOFF=0
         DO J=2,izones
            JM1=J-1
            IOFF=IOFF+1
            t%datrsym(ICENR+IOFF)=t%data_zc(JM1)
            t%datrsym(ICENR-IOFF)=t%data_zc(JM1)
            IOFF=IOFF+1
            t%datrsym(ICENR+IOFF)=t%data_zb(J)
            t%datrsym(ICENR-IOFF)=t%data_zb(J)
         enddo
      endif
C
C  THE UNMAPPED DATA WILL BE INTERPOLATED DIRECTLY FROM THE ORIGINAL
C  DATA -- WITH A POSSIBLE ECE MAP
C
      if(t%idebug) then
         if(t%iece) IHECE = d%nhecft ! even if data was presymmetrized...
         CALL TDB_UNMAP(d,t,INRIA,IHECE,ZTIME,ILX,INX,ILF,ierr)
      endif
C
40100 continue
      deallocate(zdatw)
      RETURN
 
      contains
 
      !
      ! --------------- profli_nsy3 --------------
      ! compute the weighting functions for INSY=3 option
      ! w1=Rin*dRin, w2=Rout*dRout
      !
      subroutine profli_nsy3(J,W1,W2)
      implicit none
 
      integer, intent(in) :: j     ! flux zone/boundary
      real*8, intent(out) :: w1,w2 ! inside and outside weight factors
      integer :: jrout, jop, jom   ! JR index for outer boundary and +-
      integer :: jrin,  jip, jim   ! JR index for inner boundary and +-
      real*8  :: zrout, zrin       ! major radius at outer and inner
      real*8  :: zdout, zdin       ! width of major radius at outer and inner
      integer :: jmax              ! max JR index
 
      jmax = 2*t%nzones+1
 
      jrout = (t%nzones+1)+(j-1)
      jop   = min(jmax,jrout+1)
      jom   = max(1,jrout-1)
 
      jrin  = (t%nzones+1)-(j-1)
      jip   = min(jmax,jrin+1)
      jim   = max(1,jrin-1)
 
      if (ibdy.eq.1) then
         ! boundary
         zrout = t%rmajmp(jrout)
         zrin  = t%rmajmp(jrin)
         zdout = (t%rmajmp(jop)-t%rmajmp(jom))/(jop-jom)
         zdin  = (t%rmajmp(jip)-t%rmajmp(jim))/(jip-jim)
      else
         zrout = 0.5D0*(t%rmajmp(jrout)+t%rmajmp(jop))
         zrin  = 0.5D0*(t%rmajmp(jrin)+t%rmajmp(jim))
         zdout = (t%rmajmp(jop)-t%rmajmp(jop-1))
         zdin  = (t%rmajmp(jim+1)-t%rmajmp(jim))
      end if
 
      w1 = zrin*zdin
      w2 = zrout*zdout
 
      end subroutine profli_nsy3
 
      END

subroutine ps_mdescr_gfile_read(gfilename,ss,ierr)

  ! hand coded routine -- update machine description elements from G eqdsk
  ! file:  Box Rmin/max & Zmin/max, and axisymmetric limiter

  USE plasma_state_definition_mod
  USE geqdsk_nomds_mod
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: gfilename  ! path to G-eqdsk (MDS+ path OK).
  TYPE (plasma_state) :: ss     ! state containing data to write
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !----------------------
  integer :: ilun,iout,inum,ilun_tmp
  TYPE(geqdsk) :: geq
  !----------------------

  iout = SWIM_err_out_file

  call find_io_unit(ilun_tmp)

  call geq_getlun(ilun)            ! save this
  call geq_setlun(ilun_tmp)        ! use this unit for any fortran I/O

  do
     call geq_init(geq, gfilename, ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mdescr_gfile_read: file or MDS+ access failure:'
        write(iout,*) '  gfilename was: '//trim(gfilename)
        exit
     endif

     ! OK -- set box limits

     ss%R_min_box = geq%RLeft_m
     ss%R_max_box = geq%RLeft_m + geq%Rdim_m

     ss%Z_min_box = geq%Zmid_m - geq%Zdim_m/2
     ss%Z_max_box = geq%Zmid_m + geq%Zdim_m/2

     ! OK -- set limiter

     inum = geq%limitr
     ss%num_rzlim = inum

     if(allocated(ss%rlim)) deallocate(ss%rlim)
     if(allocated(ss%zlim)) deallocate(ss%zlim)

     call plasma_state_empty_alloc(ss,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mdescr_gfile_read: plasma_state_empty_alloc error.'
        exit
     endif

     ss%rlim(1:inum) = geq%rlim_m(1:inum)
     ss%zlim(1:inum) = geq%zlim_m(1:inum)

     exit
  enddo

  call geq_setlun(ilun)            ! restore prior geq LUN
end subroutine ps_mdescr_gfile_read

subroutine splitn_printwarn(msg,nlist,iwid,list,klist)

  !  if list is not empty, print message and display affected items

  implicit NONE
  character*(*), intent(in) :: msg   ! message to print (no trailing blanks)
  integer, intent(in) :: nlist       ! length of list
  integer, intent(in) :: iwid        ! width of list elements
  character*(iwid), intent(in) :: list(nlist)  ! the list
  integer, intent(in) :: klist(nlist)   ! block affiliation of list

  !---------------------------------------
  character*78 buf
  integer i,j,jb,toggle,maxblock
  character*6 :: bencod
  !---------------------------------------

  if(nlist.eq.0) return

  write(6,*) ' ' 
  write(6,*) msg

  maxblock=0
  toggle=0

  do i=1,nlist
     if(toggle.eq.0) then
        if(klist(i).gt.0) then
           call mk_bencod
           buf='  '//trim(list(i))//'['//bencod(jb:6)//']'
        else
           buf='  '//list(i)
        endif
     else
        if(klist(i).gt.0) then
           call mk_bencod
           buf(40:)=trim(list(i))//'['//bencod(jb:6)//']'
        else
           buf(40:)=list(i)
        endif
        write(6,*) buf
     endif
     toggle=1-toggle   ! 0,1,0,1,...
  enddo

  if(toggle.eq.1) write(6,*) buf
  if(maxblock.gt.0) then
     write(6,*) &
          '  "[ ]" indicates warning pertaining to indicated update block.'
  endif

CONTAINS

  subroutine mk_bencod

    maxblock = max(maxblock,klist(i))
    bencod=' '
    write(bencod,'(i6)') klist(i)
    jb=1
    do j=5,1,-1
       if(bencod(j:j).eq.' ') then
          jb=j+1
          exit
       endif
    enddo

  end subroutine mk_bencod

end subroutine splitn_printwarn

subroutine trxplib_ps_xplasma_ini(ierr)

  ! init TRANSP MHDeq xplasma representation

  use trxplib_ps_options
  implicit NONE

  !------------------------------
  ! passed:

  integer, intent(out) :: ierr   ! exit code, 0=OK

  !------------------------------
  ! local:

  integer :: iwarn,ilun_wall,irzflag,ilparen,ilblank,lunzer,ifind
  integer :: ilt,ilz
  character*40 :: errstr,zrun_label
  character*10 :: zdate
  character*12 :: ztime
  character*4 :: ztok

  logical :: ltrx_freebdy ! test for free bdy data

  real*8 :: Psi0,Rmin,Rmax,Zmin,Zmax

  !------------------------------

  zdate=' '
  call c9date(zdate)
  call tget_rlbl(ztok,zrun_label)

  ilparen=index(zrun_label,'(')

  if(ilparen.gt.0) then
     runid=zrun_label(1:max(1,ilparen-1))
  else
     ilblank=index(zrun_label,' ')
     runid=zrun_label(ilblank+1:len(trim(zrun_label)))
  endif

  if(saw_hint.eq.-1) then
     call trx_chk_saw_r8(tselect,1)
  else if(saw_hint.eq.1) then
     call trx_chk_saw_r8(tselect,2)
  else
     call trx_chk_saw_r8(tselect,0)
  endif

  do
     errstr = "trx_time"
     call trx_time(tselect, delta_t, iwarn, ierr)
     if(ierr.ne.0) exit

     errstr = "trx_init_xplasma"
     call trx_init_xplasma(ierr)
     if(ierr.ne.0) exit

     call trx_set_threverse(0)

     !  get the core equilibrium

     errstr = "trx_mhd"
     call trx_mhd(n_theta, ierr)
     if(ierr.ne.0) exit

     !  get the limiter; determine (R,Z) range if necessary

     call find_io_unit(ilun_wall)
     if(ltrx_freebdy(0)) then

        errstr = "trx_wall_freebdy"
        call trx_wall_freebdy(ilun_wall,ierr)

     else

        Rmin = 0.0d0
        Rmax = 0.0d0

        Zmin = 0.0d0
        Zmax = 0.0d0

        errstr = "trx_wall_RZ"
        call trx_wall_RZ(ilun_wall,Rmin,Rmax,nR,Zmin,Zmax,nZ,ierr)

     endif
     if(ierr.ne.0) exit

     !  set up field extrapolation; specify signs...
     irzflag=1
     errstr = "trx_bxtr"
     call trx_bxtr(Bccw_hint,Jccw_hint,irzflag,ierr)
     if(ierr.ne.0) exit

     call trx_psi0(ifind,Psi0)
     if(ifind.eq.0) then
        geqdsk_lbl='TRXPL '//zdate//'*'
     else
        ! trxplib has Psi0 data only for "fb" free boundary cases
        geqdsk_lbl='TRXfb '//zdate//'*'
     endif

     ilt=len_trim(geqdsk_lbl)+2
     geqdsk_lbl(ilt:)=ztok

     ilt=len_trim(geqdsk_lbl)+2
     geqdsk_lbl(ilt:)=runid

     ilt=len_trim(geqdsk_lbl)+2
     geqdsk_lbl(ilt:)='t='

     ilt=len_trim(geqdsk_lbl)
     if(delta_t.gt.0) geqdsk_lbl(ilt:ilt)='~'
     ilz=min(12,(len(geqdsk_lbl)-ilt))

     write(ztime,'(f12.5)') tselect
     geqdsk_lbl(ilt+1:ilt+ilz)=ztime(1:ilz)

     exit
  enddo

  if(ierr.ne.0) then
     write(lunzer(0),*) ' ?trxplib_ps_xplasma_ini: error in subroutine: '//trim(errstr)
  endif

end subroutine trxplib_ps_xplasma_ini

! this collection of routines returns information on the plasma boundary
! based on equilibrium boundary (or entire equilibrium) contained in the
! trdatbuf object passed...

subroutine tdb_bdy_type(d,ibtype)
  use trdatbuf_obj

  ! return the type of boundary data available:
  !   ibtype = 1 -- updown symmetric
  !   ibtype = 0 -- updown asymmetric
  !   ibtype = -1 -- no data

  implicit NONE
  type (trdatbuf) :: d
  integer, intent(out) :: ibtype

  if(d%datbuf(5).gt.0.0d0) then
     ibtype=1
  else if(d%datbuf(5).lt.0.0d0) then
     ibtype=-1
  else
     ibtype=0
  endif

end subroutine tdb_bdy_type

subroutine tdb_bdy_timefac(d,ztime,it,zf)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  !  get time interpolation factor for boundary Fourier moments

  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(in) :: ztime    ! time (seconds)
  integer, intent(out) :: it     ! time bin
  real*8, intent(out) :: zf      ! interpolation factor w/in bin

  !  interpolation of f(t) item stored at datbuf(istart)
  !  will be:  result = d%datbuf(istart+it-1) + &
  !                        zf*d%(datbuf(istart+it)-d%datbuf(istart+it-1))

  integer :: iamoms,ilt,int
  !------------------------------------

  iamoms = max(d%ldmmx,d%lmomd)
  if(iamoms.eq.0) then
     !  must be using R0(t) and a(t) only -- on ltime1 timebase
     ilt = d%ltime1
     int = d%ntime1
     call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,ztime,it,zf)

  else
     !  general moments data on ltime2 timebase
     ilt = d%ltime2
     int= d%ntime2
     call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,ztime,it,zf)

  endif

end subroutine tdb_bdy_timefac

real*8 function tdb_bdy_getmom(d,it,zf,imom,itype)
  !
  !  get Fourier moment of plasma boundary
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(in) :: it     ! time bin index
  real*8, intent(in) :: zf      ! time interpolation factor
  integer, intent(in) :: imom   ! moment index
  integer, intent(in) :: itype  ! moment type

  ! TDB_MOMS_RCOS or TDB_MOMS_RSIN or TDB_MOMS_ZCOS or TDB_MOMS_ZSIN
  ! ...function value -- the Fourier moment -- in cm

  integer :: iamoms,jr0,jr1,jr2,jy1,jy2,iadd,ja,iadci,ibtype
  logical :: ilsym

  !------------------------

  iamoms = max(d%ldmmx,d%lmomd)

  call tdb_bdy_type(d,ibtype)
  ilsym = ( ibtype .gt. 0) ! .TRUE. => updown symmetric data stored

  tdb_bdy_getmom = ZERO

  if(ibtype.lt.0) return   ! (no data -- always return ZERO)

  if(iamoms.eq.0) then
     !  must be using R0(t) and a(t) only -- on ltime1 timebase
     if(imom.eq.0) then
        if(itype.eq.TDB_MOMS_RCOS) then
           if(d%ldatpos.gt.0) then
              tdb_bdy_getmom = d%datbuf(d%ldatpos+it-1) + &
                   zf*(d%datbuf(d%ldatpos+it)-d%datbuf(d%ldatpos+it-1))
           endif
        endif
     else if(imom.eq.1) then
        if((itype.eq.TDB_MOMS_RCOS).or.(itype.eq.TDB_MOMS_ZSIN)) then
           if(d%ldatrmn.gt.0) then
              tdb_bdy_getmom = d%datbuf(d%ldatrmn+it-1) + &
                   zf*(d%datbuf(d%ldatrmn+it)-d%datbuf(d%ldatrmn+it-1))
           endif
        endif
     endif

  else if(d%ldmmx.gt.0) then
     !
     ! extracting boundary from full equilibrium dataset
     !
     if(imom.le.d%nmomd) then
        ja = iadci(d, d%ldmmx, it, d%nxmmx, imom, itype)
        tdb_bdy_getmom = d%datbuf(ja) + &
             zf*(d%datbuf(ja+1)-d%datbuf(ja))
     endif

  else
     ! d%ldmom.gt.0 -- general boundary dataset
     if(ilsym) then
        !
        ! only symmetric boundary data was stored
        !
        call momind(d,it,jr0,jr1,jy1)
        if(imom.eq.0) then
           if(itype.eq.TDB_MOMS_RCOS) then
              tdb_bdy_getmom = d%datbuf(jr0) + &
                   zf*(d%datbuf(jr0+1)-d%datbuf(jr0))
           endif
        else if(imom.le.d%nmomd) then
           if(itype.eq.TDB_MOMS_RCOS) then
              iadd=(imom-1)*d%ntime2
              jr1=jr1+iadd
              tdb_bdy_getmom = d%datbuf(jr1) + &
                   zf*(d%datbuf(jr1+1)-d%datbuf(jr1))
           else if(itype.eq.TDB_MOMS_ZSIN) then
              iadd=(imom-1)*d%ntime2
              jy1=jy1+iadd
              tdb_bdy_getmom = d%datbuf(jy1) + &
                   zf*(d%datbuf(jy1+1)-d%datbuf(jy1))
           endif
        endif
     else
        !
        ! asymmetric boundary data was stored
        !
        if(imom.le.d%nmomd) then
           call momind3(d,it,jr1,jr2,jy1,jy2)
           iadd = imom*d%ntime2
           if(itype.eq.TDB_MOMS_RCOS) then
              ja=jr1+iadd
           else if(itype.eq.TDB_MOMS_RSIN) then
              ja=jr2+iadd
           else if(itype.eq.TDB_MOMS_ZCOS) then
              ja=jy1+iadd
           else if(itype.eq.TDB_MOMS_ZSIN) then
              ja=jy2+iadd
           endif
           tdb_bdy_getmom = d%datbuf(ja) + &
                zf*(d%datbuf(ja+1)-d%datbuf(ja))
        endif
     endif
  endif
end function tdb_bdy_getmom



subroutine tdb_bdy_getmoms(d,it,zf,rmcb,ymcb,nmom)
  !
  !  get ALL Fourier moments of plasma boundary
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(in) :: it     ! time bin index
  real*8, intent(in) :: zf      ! time interpolation factor
  integer, intent(in) :: nmom      ! number of moments
  real*8, dimension(0:nmom,2) :: rmcb,ymcb  ! boundary harmonics 0:nmom, cos:sin
  real*8 :: tdb_bdy_getmom

  integer :: im

  do im=0,nmom
     rmcb(im,1)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_RCOS) ! Rcos mom.
     rmcb(im,2)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_RSIN)
     ymcb(im,1)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_ZCOS)
     ymcb(im,2)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_ZSIN) ! Zsin mom.
  enddo

  return
end subroutine tdb_bdy_getmoms

module trdatbuf_iface

  ! interface for "public" routines in trdatbuf_lib
  ! also define constants useful for this interface...

  include 'trdatbuf_constants.incl'

  interface

     SUBROUTINE TDB_DATALO(d,ISIZE,ILOC)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d          ! data buffer
       integer, intent(in) :: isize  ! size of chunk to allocate
       integer, intent(out) :: iloc  ! address of chunk allocated
     end subroutine TDB_DATALO

     SUBROUTINE TDB_WORKALO(d,ISIZE,ILOC)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d          ! data buffer
       integer, intent(in) :: isize  ! size of chunk to allocate
       integer, intent(out) :: iloc  ! address of chunk allocated
     end subroutine TDB_WORKALO

     subroutine tdb_find_nmoms(d,imoms,icirc)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d          ! data buffer
       integer, intent(out) :: imoms,icirc
       ! return imoms = # of moments (0:imoms) in Fourier expansion
       ! return icirc = 1 if circular flux surfaces (minor & major radius only)
       !                are in use (this is very rare).
     end subroutine tdb_find_nmoms

     SUBROUTINE TDB_LOOKUP1(d,ztime,it1,it2,zf1,zf2)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       real*8, intent(in) :: ztime
       integer, intent(out) :: it1,it2  ! time offsets btw which ZTIME lies
       real*8, intent(out) :: zf1,zf2   ! linear interpolation factors
     end subroutine TDB_LOOKUP1

     real*8 function tdb_fintrp1(d,iloc,it1,it2,zf1,zf2)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       integer, intent(in) :: iloc     ! data location
       integer, intent(in) :: it1,it2  ! time offsets btw which ZTIME lies
       real*8, intent(in) :: zf1,zf2   ! linear interpolation factors
     end function TDB_FINTRP1

     subroutine tdb_rmp_bdy(d,ztime,zr1,zr2)
       !  find midplane boundary intercept radii at the indicated time

       use trdatbuf_obj
       implicit NONE

       type(trdatbuf) :: d          ! data buffer object
       real*8, intent(in) :: ztime  ! time (seconds)

       real*8, intent(out) :: zr1   ! inner intercept major radius (cm)
       real*8, intent(out) :: zr2   ! outer intercept major radius (cm)
     end subroutine tdb_rmp_bdy

     logical function tdb_logchk_special(d,zitem,iwarn)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       character*(*), intent(in) :: zitem   ! item queried
       integer, intent(out) :: iwarn        ! 0: OK; 1: item not recognized
     end function TDB_LOGCHK_SPECIAL

     logical function tdb_logchk_nbi(d,zsubset,iwarn)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       character*(*), intent(in) :: zsubset ! NBI subset data item queried
       integer, intent(out) :: iwarn        ! 0: OK; 1: item not recognized
     end function TDB_LOGCHK_NBI

     logical function tdb_zeff_simple(d,ilev)
       ! return TRUE if Zeff can be had by a simple interpolation
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       integer, intent(out) :: ilev   ! 1: Zeff=f(t); 2: Zeff=f(x,t); 3: other
     end function tdb_zeff_simple

     logical function tdb_imp_single(d,xzimp,aimp)
       ! return TRUE if the TRANSP run has but a single impurity species
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       real*8, intent(out) :: xzimp  ! Z of impurity (0 if time dependent)
       real*8, intent(out) :: aimp   ! A of impurity (0 if time dependent)
     end function tdb_imp_single

     integer function tdb_nchan_find(d,z2char)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       character*(*), intent(in) :: z2char  ! "NB" or "EC" or "LH" or (IC)"RF"
     end function tdb_nchan_find

     subroutine tdb_find_next_sawtime(d,zprev_time,ztime)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       real*8, intent(in) :: zprev_time   ! preceding time (input)
       real*8, intent(out) :: ztime       ! time found or a huge time (output)
     end subroutine TDB_FIND_NEXT_SAWTIME

     subroutine tdb_num_sawtimes(d,ntsaw)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       integer, intent(out) :: ntsaw  ! number of sawtooth times 
     end subroutine TDB_NUM_SAWTIMES

     subroutine tdb_sawtimes(d,ztimes,inum)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       integer, intent(in) :: inum
       real*8, intent(inout) :: ztimes(inum)
     end subroutine TDB_SAWTIMES

     subroutine tdb_post_sawtime(d,ztime_pre,ztime_post,iwarn)
       use trdatbuf_obj
       implicit NONE
       !  given event start (SAWTOOTH) time return event end time
       type (trdatbuf) :: d
       real*8, intent(in) :: ztime_pre   ! time at start of event
       real*8, intent(out) :: ztime_post ! time at end of event
       integer, intent(out) :: iwarn     ! 0=OK; 1=no sawtooth events
       ! 2= sawtooth events exist but ztime_pre
       !    does not match any of them...
     end subroutine TDB_POST_SAWTIME

     subroutine tdb_post_peltime(d,ztime_pre,ztime_post,iwarn)
       use trdatbuf_obj
       implicit NONE
       !  given event start (PELLET) time return event end time
       type (trdatbuf) :: d
       real*8, intent(in) :: ztime_pre   ! time at start of event
       real*8, intent(out) :: ztime_post ! time at end of event
       integer, intent(out) :: iwarn     ! 0=OK; 
                                    ! 2= no such event time found...
     end subroutine TDB_POST_PELTIME

     subroutine tdb_npel(d,inpel)
       use trdatbuf_obj
       implicit NONE
       !  return number of pellet events
       type (trdatbuf) :: d
       integer, intent(out) :: inpel ! number of pellets this run
     end subroutine tdb_npel

     subroutine tdb_pelda(d,ipel,p,ierr)
       use trdatbuf_obj
       use trdatbuf_aux
       implicit NONE
       !  return data associated with a particular pellet
       type (trdatbuf) :: d
       integer, intent(in) :: ipel   ! index of desired pellet data (ipel'th pellet)
       type (pelget) :: p            ! pellet data returned here
       integer, intent(out) :: ierr  ! return .ne.0 if ipel input out of range
     end subroutine tdb_pelda

     subroutine tdb_pwrdata_avg(d,znbi,ierr)
       use trdatbuf_obj
       use trdatbuf_aux
       implicit NONE
       !  get beam parameters averaged over a time step
       type (trdatbuf) :: d   ! trdat data object
       type (pwrget) :: znbi  ! specification of desired parameters; return val
       integer, intent(out) :: ierr   ! completion code (0=OK)
     end subroutine tdb_pwrdata_avg

     ! data on MHD equilibrium boundary...

     subroutine tdb_bdy_timefac(d,ztime,iti,zfi)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       real*8, intent(in) :: ztime    ! time (seconds)
       integer, intent(out) :: iti    ! time bin index
       real*8, intent(out) :: zfi     ! time interpolation factor
       !                                   half-width (cm)
     end subroutine tdb_bdy_timefac

     real*8 function tdb_bdy_getmom(d,iti,zfi,imom,itype)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       integer, intent(in) :: iti    ! time bin index
       real*8, intent(in) :: zfi     ! time interpolation factor
       integer, intent(in) :: imom   ! moment index
       integer, intent(in) :: itype  ! moment type
       ! TBD_MOMS_RCOS or TBD_MOMS_RSIN or TBD_MOMS_ZCOS or TBD_MOMS_ZSIN
       ! ...function value in cm
     end function tdb_bdy_getmom
     
     ! data on impurities...

     logical function tdb_tokamakium(d)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d   ! return TRUE if "tokamakium" impurity is present
     end function TDB_TOKAMAKIUM

     subroutine tdb_imp_elems(d,xzimps,aimps)
       use trdatbuf_obj
       implicit NONE
       !  for multi-impurity model only...
       type (trdatbuf) :: d
       real*8, dimension(:) :: xzimps,aimps  ! Z & A vectors
     end subroutine tdb_imp_elems

     subroutine tdb_imp_ions(d,xzimpx,xzimpxs,aimpx)
       use trdatbuf_obj
       implicit NONE
       !  for multi-impurity model only...
       type (trdatbuf) :: d
       real*8, dimension(:) :: xzimpx !  charge on ion e.g. Z(C+4)=4
       real*8, dimension(:) :: xzimpxs !  atomic number e.g. Z(C+4)=6
       real*8, dimension(:) :: aimpx  !  atomic weight e.g. A(C+4)=14 if Carbon-14
     end subroutine tdb_imp_ions

     ! time invariant information in PH.DAT file...
     subroutine tdb_ccwchk(d,i_bccw,i_jccw)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       !  ccw means "counter-clockwise looking down from above"
       integer, intent(out) :: i_bccw ! 1: ccw, -1: cw, 0: unspecified (B_phi)
       integer, intent(out) :: i_jccw ! 1: ccw, -1: cw, 0: unspecified (J_phi)
     end subroutine tdb_ccwchk

     subroutine tdb_ripple0(d,icoils,zphi)
       use trdatbuf_obj
       implicit NONE
       type (trdatbuf) :: d
       !  information on TF ripple field
       integer, intent(out) :: icoils  ! no. of TF coils (TF ripples)
       real*8, intent(out) :: zphi ! shift of 1st coil rel. phi=0 (radians)
     end subroutine tdb_ripple0

     subroutine tdb_tlims(d,zd_tinit,zd_ftime)
       use trdatbuf_obj
       implicit NONE
       !
       !  return time range covered by trdatbuf data
       !
       type (trdatbuf) :: d
       real*8, intent(out) :: zd_tinit  ! start time
       real*8, intent(out) :: zd_ftime  ! stop time
     end subroutine tdb_tlims

     subroutine tdb_tlim_ok(d,zd_ftime_ok)
       use trdatbuf_obj
       implicit NONE
       !
       !  return time beyond which a code failure should be ignored
       !  (user can specify this as an option, e.g. if data at end of
       !  shot is suspect, e.g. a disrupted shot).
       !
       type (trdatbuf) :: d
       real*8, intent(out) :: zd_ftime_ok ! stop time for crash/abort handling
     end subroutine tdb_tlim_ok

     subroutine tdb_chkprof(d,istop)
       use trdatbuf_obj
       implicit NONE
       !
       !  check all input profile controls & x axes
       !  messages may be generated; all errors should result in cancellation
       !  of job.
       !
       type (trdatbuf) :: d
       integer, intent(out) :: istop    ! =0: OK; =1: error reported.
     end subroutine tdb_chkprof

      subroutine tdb_symini(d,nzones)
        !
        !  set up workspace for presymmetrization & mapping of profiles
        !  size of workspace depends on target application's number of zones
        !  and the number of zones in the input data
        !
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(in) :: nzones   ! no. of radial zones in caller's grid
      end subroutine tdb_symini

      subroutine tdb_ntimes(d,intime1,intime2)
        !  return sizes of tdb input 1d f(t) timebase and 2d f(t,x) timebase
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(out) :: intime1
        integer, intent(out) :: intime2
      end subroutine tdb_ntimes

      subroutine tdb_range_ntimes1(d,zt1,zt2,intime1)
        !  return no. of pts in tdb input 1d f(t) timebase within the time
        !  range (zt1,zt2)
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        real*8, intent(in) :: zt1,zt2  ! time range
        integer, intent(out) :: intime1 ! no. of time points returned
      end subroutine tdb_range_ntimes1

      subroutine tdb_range_times1(d,zt1,zt2,ztimes,ierr)
        !  return the time points in tdb input 1d f(t) timebase within the time
        !  range (zt1,zt2)
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        real*8, intent(in) :: zt1,zt2 ! time range
        real*8, intent(inout) :: ztimes(:) ! time points returned
        integer, intent(out) :: ierr ! error (ierr=1) if ztimes array too small
      end subroutine tdb_range_times1

      subroutine tdb_range_ntimes2(d,zt1,zt2,intime2)
        !  return no. of pts in tdb input 1d f(t) timebase within the time
        !  range (zt1,zt2)
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        real*8, intent(in) :: zt1,zt2  ! time range
        integer, intent(out) :: intime2 ! no. of time points returned
      end subroutine tdb_range_ntimes2

      subroutine tdb_range_times2(d,zt1,zt2,ztimes,ierr)
        !  return the time points in tdb input 1d f(t) timebase within the time
        !  range (zt1,zt2)
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        real*8, intent(in) :: zt1,zt2 ! time range
        real*8, intent(inout) :: ztimes(:) ! time points returned
        integer, intent(out) :: ierr ! error (ierr=1) if ztimes array too small
      end subroutine tdb_range_times2

      subroutine tdb_nplas(d,inum)
        ! return number of non-impurity main plasma thermal species
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(out) :: inum  ! number of species returned
      end subroutine tdb_nplas

      subroutine tdb_nfast(d,inum)
        ! return number of fast ion species
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(out) :: inum  ! number of species returned
      end subroutine tdb_nfast

      subroutine tdb_plas(d,inum,zz,aa,ierr)
        ! return (in REAL*8 vectors) the Z & A values of main plasma species
        ! e.g. in a D,T plasma zz(1:2) = 1.0, 1.0 & aa(1:2) = 2.0, 3.0 returned.
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(in) :: inum  ! number of species (see tdb_nplas)
        real*8, intent(out) :: zz(inum)  ! Z values (atomic numbers) returned.
        real*8, intent(out) :: aa(inum)  ! A values (atomic weights) returned.
        integer, intent(out) :: ierr ! error code (0=OK) (1 means inum too small)
      end subroutine tdb_plas
      
      subroutine tdb_fast(d,inum,zz,aa,ierr)
        ! return (in REAL*8 vectors) the Z & A values of fast ion species
        ! e.g. for D,He3 beams zz(1:2) = 1.0, 2.0 & aa(1:2) = 2.0, 3.0 returned.
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(in) :: inum  ! number of species (see tdb_nfast)
        real*8, intent(out) :: zz(inum)  ! Z values (atomic numbers) returned.
        real*8, intent(out) :: aa(inum)  ! A values (atomic weights) returned.
        integer, intent(out) :: ierr ! error code (0=OK) (1 means inum too small)
      end subroutine tdb_fast
      
      subroutine tdb_onoff_atime(d,z2char,zthresh,zdtfix,ton,toff,ierr)
        ! for power-channel data (NB,EC,LH,RF) define the on and off times:
        !   ton = min(on times for any channel) (*output*)
        !   toff = max(off times for any channel) (*output*)
        !
        !   z2char => chooses heating channel:
        !     "nb" or "NB" -- neutral beams
        !     "ec" -- ECH/ECCD
        !     "lh" -- Lower Hybrid
        !     "rf" -- ICRF   
        !   all tests of z2char value are case insensitive
        ! 
        !   zthresh = threshhold:
        !     if positive -- a power, in watts, must be < 20% of the maximum
        !                    power ever occurring on any channel
        !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
        !                    power threshold becomes -zthresh * (maximum power
        !                    ever occurring on any channel).
        !
        !   zdtfix -- time to search from first/last powers satisfying thresh-
        !             hold, for an actual 0 or negative power...
        !
        !   ierr is set only if there is no data or if z2char is unrecognized;
        !   if the zthresh limit has to be adjusted to conform to rules, a 
        !   warning message is written but ierr is not set.
        !
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
        real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
        real*8, intent(in) :: zdtfix         ! time to search from threshhold
        real*8, intent(out) :: ton,toff      ! on/off times (seconds)
        integer, intent(out) :: ierr         ! completion code; 0=OK
      end subroutine tdb_onoff_atime

      subroutine tdb_onoff_times(d,z2char,zthresh,zdtfix,tonarr,toffarr,ierr)
        ! for power-channel data (NB,EC,LH,RF) define the on and off times:
        !   tonarr(i) = on time for channel #i (i.e. beam or antenna) (*output*)
        !   toffarr(i) = off time for channel #i (*output*)
        !
        !   z2char => chooses heating channel:
        !     "nb" or "NB" -- neutral beams
        !     "ec" -- ECH/ECCD
        !     "lh" -- Lower Hybrid
        !     "rf" -- ICRF   
        !   all tests of z2char value are case insensitive
        ! 
        !   zthresh = threshhold:
        !     if positive -- a power, in watts, must be < 20% of the maximum
        !                    power ever occurring on any channel
        !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
        !                    power threshold becomes -zthresh * (maximum power
        !                    ever occurring on any channel).
        !
        !   zdtfix -- time to search from first/last powers satisfying thresh-
        !             hold, for an actual 0 or negative power...
        !
        !   ierr is set only if there is no data or if z2char is unrecognized;
        !   if the zthresh limit has to be adjusted to conform to rules, a 
        !   warning message is written but ierr is not set.
        !
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
        real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
        real*8, intent(in) :: zdtfix         ! time to search from threshhold
        real*8, intent(out), dimension(:) :: tonarr,toffarr  ! on/off times (seconds)
        integer, intent(out) :: ierr         ! completion code; 0=OK
      end subroutine tdb_onoff_times

      logical function tdb_fallback(d,ztri,ztime,zresult)
        !
        ! check for "fall back to time series" data
        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        character*(*), intent(in) :: ztri  ! trigraph of candidate data
        ! for "fall back to time series"
        real*8, intent(in) :: ztime        ! time to which to interpolate
        real*8, intent(out) :: zresult     ! result, if data is found
        ! the function value is .TRUE., and the interpolated value is returned,
        ! if "fallback to time series" data is present; otherwise the function
        ! returns .FALSE. and zresult=ZERO.
      end function tdb_fallback

      REAL*8 function tdb_get_rpld(d,ztime,zRi,zYi,ier)
        !
        ! get TF ripple magnitude in form: log(B~/B)
        !
        use trdatbuf_obj
        IMPLICIT NONE
        type (trdatbuf) :: d
        REAL*8,intent(in) :: ztime   ! time at which to interpolate
        REAL*8,intent(in) :: zRi,zYi ! (R,Y) location, cm
        integer, intent(out) :: ier ! exit code, 0=OK
      end function tdb_get_rpld

      REAL*8 function tdb_get_rpld2(d,ztime,zRi,zYi,ier)
        !
        ! get 2nd component of TF ripple magnitude in form: log(B~/B)
        !
        use trdatbuf_obj
        IMPLICIT NONE
        type (trdatbuf) :: d
        REAL*8,intent(in) :: ztime   ! time at which to interpolate
        REAL*8,intent(in) :: zRi,zYi ! (R,Y) location, cm
        integer, intent(out) :: ier ! exit code, 0=OK
      end function tdb_get_rpld2
 
      subroutine tdb_getmmx(d,zt,xib,zrmc2,zymc2,mj,mimom,lcentr,nzp1,zdrshaf)
        use trdatbuf_obj
        IMPLICIT NONE
 
        type (trdatbuf) :: d
        REAL*8,intent(in) :: zt    ! time at which to fetch moments
        integer, intent(in) :: mj  ! flux surface array dim. for zrmc2,zymc2
        integer, intent(in) :: mimom ! moments array dimension for zrmc2,zymc2

        real*8,intent(in) :: xib(mj) ! flux surfaces (xib(j)=sqrt(Phi/Philim) 
        ! at surface "j"); xib(lcentr:lcentr+nzp1-1) are used
  
        REAL*8,intent(out) :: zrmc2(mj,0:mimom,2),zymc2(mj,0:mimom,2)
        ! asymmetric Fourier moments set at xi bdys (lcentr:lcentr+nzp1-1)
 
        REAL*8,intent(out) :: zdrshaf(mj)
        ! "Shafranov" shift of interior surfaces
        ! relative to the boundary surface
 
        integer :: lcentr        ! index to magnetic axis
        integer :: nzp1          ! no. of surfaces including mag. axis
      end subroutine tdb_getmmx

      real*8 function tdb_zyget(d,zid,i)

        !  multiple impurity model (sim) helper function -- get charge state
        !  or get non-spatial / non-temporal 3rd coordinate for general 3d
        !  profile input...

        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        character*3,intent(in) :: zid  ! profile set identifier e.g. "SIM"
        integer,intent(in) :: i        ! get i'th element

      end function tdb_zyget
     
      subroutine tdb_profin(d,t,ierr)

        ! retrieve profile from trdatbuf buffer (d)
        ! to target time & spatical grid as specified in (t),
        ! desired profile also identified in (t)
        ! return ierr=0 if successful.

        use trdatbuf_obj
        use trdatbuf_aux
        implicit NONE
        type (trdatbuf) :: d
        type (profget) :: t
        integer, intent(out) :: ierr

      end subroutine tdb_profin

      subroutine tdb_maksym(d,ierr)

        ! presymmetrize all pre-symmetrizable profile data
        ! over the time range available

        use trdatbuf_obj
        implicit NONE
        type (trdatbuf) :: d
        integer, intent(out) :: ierr

      end subroutine tdb_maksym

     subroutine tdb_nzones(nzones,nrmaj,nrsym)
       integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)
       integer, intent(out) :: nrmaj  ! (2*nzones+1) no. of flux surface
       !                                midplane intercepts
       integer, intent(out) :: nrsym  ! (4*nzones+5) size of midplane test
       !                                grid (zone bdys & surfaces + 2
       !                                extrapolation points at each end).
     end subroutine tdb_nzones

     subroutine tdb_xilmp(nzones,xibdys,xilmp)
       integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)
       real*8, dimension(:), intent(in) :: xibdys  ! (nzones+1) x @ zone bdys
       real*8, dimension(:), intent(out) :: xilmp  ! (2*nzones+1) x @midplane
       !                                flux surface intercepts
     end subroutine tdb_xilmp

     subroutine tdb_xisymp(nzones,xibdys,rmajmp,xirsym,rmjsym)
       integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)
       real*8, dimension(:), intent(in) :: xibdys  ! (nzones+1) x @ zone bdys
       real*8, dimension(:), intent(in) :: rmajmp  ! (2*nzones+1) major radius
       !         at flux surface midplane intercepts (cm)
       real*8, dimension(:), intent(out) :: xirsym ! (4*nzones+5) x @midplane
       !         (double-density grid with 2 pt extension @ bdys)
       real*8, dimension(:), intent(out) :: rmjsym ! (4*nzones+5) R @midplane
       !         (double-density grid with 2 pt extension @ bdys) (cm)
     end subroutine tdb_xisymp

      subroutine tdb_bdy_getmoms(d,it,zf,rmcb,ymcb,nmom)
        use trdatbuf_obj
         implicit NONE
        type (trdatbuf) :: d
        integer, intent(in) :: it     ! time bin index
        real*8, intent(in) :: zf      ! time interpolation factor
        integer, intent(in) :: nmom      ! number of moments
        real*8, dimension(0:nmom,2) :: rmcb,ymcb  ! boundary harmonics 0:nmom, cos:sin
      end subroutine tdb_bdy_getmoms

      subroutine trdatbuf_open(filename,mode,ncid)
        ! open NetCDF file containing trdatbuf object

        character*(*), intent(in) :: filename ! path to NetCDF file
        character*(*), intent(in) :: mode     ! "r" or "R" for read
                                              ! "w" or "W" for write
        integer, intent(out) :: ncid          ! NetCDF channel # returned
        ! note: if the NetCDF open fails, ncid=0 is returned.
      end subroutine trdatbuf_open

      subroutine trdatbuf_write(kcdf,d,ierr)
        !  write a trdatbuf object
        use trdatbuf_obj

        integer, intent(in) :: kcdf  ! id of NetCDF file open for write
        type (trdatbuf) :: d         ! trdatbuf object
        integer, intent(out) :: ierr ! error code returned (0=OK)

      end subroutine trdatbuf_write

      subroutine trdatbuf_read(kcdf,d,ierr)
        !  read a trdatbuf object
        use trdatbuf_obj

        integer, intent(in) :: kcdf  ! id of NetCDF file open for read
        type (trdatbuf) :: d         ! trdatbuf object
        integer, intent(out) :: ierr ! error code returned (0=OK)

      end subroutine trdatbuf_read

      subroutine trdatbuf_close(ncid)
        ! close NetCDF file; return ncid=0

        integer, intent(inout) :: ncid
      end subroutine trdatbuf_close

  end interface
end module trdatbuf_iface

c-------------------------------------------------------------------
      subroutine trxpl_mkgs2_smoo(tlabel)
c
c  control smoothing of profile data
c
      use trxpl_gs2_module
      implicit NONE
c
      character*(*) tlabel              ! plotting label
c
c---------------------------------------------
c
      logical lxout,lchar
      integer luntty,lnout
      logical insmoo(num_species),itsmoo(num_species)
      logical ismoo_save(num_species),igsmoo
      integer i,j,k,nrho
      integer idcod,iert,ierr
c
      real*8, dimension(:), allocatable :: rho,f,fsm,epsilon,delta
      real*8, dimension(:), allocatable :: nprof,zprof
      real*8 zlarge,zdum,enda,endb,zbc1,zbc2
      integer idum1,idum2,ibc1,ibc2,iord
c
      character*20 zname,zunits,zpre
      integer :: id=0,idsm
      integer itiflag,inzflag
c
c---------------------------------------------
c
      luntty=lnout(0)
      if(gsmoo) then
         write(luntty,*) ' %trxpl_mkgs2_smoo:'
         write(luntty,*) '  some smoothing was already done; smoothing'
         write(luntty,*) '  takes the original data (only) as input,'
         write(luntty,*) '  prior smoothed data may be replaced.'
      endif
c
      call eq_ngrid(id_rho,nrho)
c
      allocate(rho(nrho),f(nrho),fsm(nrho),epsilon(nrho),delta(nrho))
c
      call eq_grid(id_rho,rho,nrho,k,ierr)
      if(ierr.ne.0) then
         call errmsg_exit('?trxpl_mkgs2_smoo: eq_grid error!')
      endif
c
      zlarge=1.0d35
      epsilon=zlarge
c
      enda=1.0d0         ! center endpt, smooth s.t. grad(f)->0
      endb=0.5d0         ! edge endpt, default smooth
c
      ibc1=1
      zbc1=0.0d0
      ibc2=0
      zbc2=0.0d0
c
 10   continue
c
      insmoo=.FALSE.
      itsmoo=.FALSE.
      igsmoo=.FALSE.
c
      if(lxout(0)) then
         write(luntty,1001)
 1001    format(/
     >      'trxpl_mkgs2_smoo options:'/
     >      ' A -- smooth ALL density profiles'/
     >      ' B -- smooth all ion density profiles,'/
     >      '      renormalize sum(ni*Zi) to ne (quasineutrality)'/
     >      ' C -- smooth all but a few ion density profiles,'/
     >      '      renormalize sum(ni*Zi) to ne (quasineutrality)'/
     >      ' P -- **plot** smoothed & unsmoothed profile'/
     >      ' T -- smooth the electron temperature'/
     >      ' S -- smooth the ion temperature(s) (thermal plasma)'/
     >      ' U -- smooth a selected fast ion "temperature" profile'/
     >      ' V -- smooth ALL temperature profiles'/
     >      ' X -- discard all smoothed data'/
     >      ' Q -- quit')
      endif
      call uread('trxpl_mkgs2_smoo menu option:$')
c
      if(lchar('Q')) then
c
c  exit
c
         go to 900
      else if(lchar('X')) then
c
c  discard smoothed data
c
         gsmoo=.FALSE.
         tsmoo=.FALSE.
         nsmoo=.FALSE.
         dx_smooth_n=0
         dx_smooth_t=0
      else if(lchar('P')) then
c
c  plot smoothed profile
c
         i=1
 15      continue
         if(lxout(0)) call trxpl_mkgs2_summ(luntty,' (profile data)')
         call uread('enter "T" for temperature, "N" for density:$')
         if(lchar('Q')) then
            go to 10
         else if(lchar('N')) then
            j=1
         else if(lchar('T')) then
            j=2
         else
            call uermsg('?trxpl_mkgs2_smoo:  expected "T" "N" or "Q".',
     >         ' ',0)
            go to 15
         endif
c
         call ureadi('select species number to plot:$',i)
         if((i.lt.1).or.(i.gt.num_species)) then
            j=0
         else if(j.eq.1) then
            if(.not.nsmoo(i)) j=0
         else if(j.eq.2) then
            if(.not.tsmoo(i)) j=0
         endif
         if(j.eq.0) then
            call uermsg('?trxpl_mkgs2_smoo: no smoothed profile.',
     >         ' ',0)
            go to 15
         endif
c
         if(j.eq.1) then
            id=id_norig(i)
            idsm=id_nsmoo(i)
            zunits='/m^3'
            zpre='Density,'
         else if(j.eq.2) then
            id=id_torig(i)
            idsm=id_tsmoo(i)
            zunits='keV'
            zpre='Temperature,'
         endif
c
         call eq_rgetf(nrho,rho,id,0,f,ierr)
         if(ierr.ne.0) call errmsg_exit('??trxpl_mkgs2_smoo 77 ?')
         call eq_rgetf(nrho,rho,idsm,0,fsm,ierr)
         if(ierr.ne.0) call errmsg_exit('??trxpl_mkgs2_smoo 78 ?')
c
         if(id.eq.id_torig(i)) then
            f=Tconv(i)*f    ! conversion factor for temperature not density
            fsm=Tconv(i)*fsm
         endif
c
         call r8_grafx2(rho,f,fsm,nrho,' ',zunits,transp_path,tlabel,
     >      zpre//slabel(i)//' vs. rho, dashed curve smoothed.')
c
         go to 15
c
      else if(lchar('A')) then
c
c  smooth all densities
c
         igsmoo=.TRUE.
         insmoo=.TRUE.
      else if(lchar('B')) then
c
c  smooth densities:  all but electron density
c
         igsmoo=.TRUE.
         insmoo=.TRUE.
         insmoo(1)=.FALSE.
c
      else if(lchar('C')) then
c
c  smooth most density profiles
c  select which ion density profiles not to smooth; use subroutine
c  to show available species
c
         insmoo=.TRUE.
         insmoo(1)=.FALSE.
         ismoo_save=nsmoo(1:num_species)
         nsmoo(1:num_species)=insmoo
 20      continue
         if(lxout(0)) call trxpl_mkgs2_summ(luntty,' (profile data)')
         call uread('enter # of specie to exclude, or "Q":$')
         if(lchar('Q')) go to 30
         i=idcod(iert)
         if(iert.ne.0) go to 20
         if((i.lt.1).or.(i.gt.num_species)) then
            call uermsi(
     >         '?trxpl_mkgs2_smoo:  enter species code btw 1 and ',
     >         num_species,0)
            go to 20
         endif
         insmoo(i)=.FALSE.
         nsmoo(i)=.FALSE.
         go to 20
 30      continue
         nsmoo(1:num_species)=ismoo_save
         igsmoo=.FALSE.
         do i=1,num_species
            if(insmoo(i)) igsmoo=.TRUE.
         enddo
c
      else if(lchar('T')) then
c
c  smooth electron temperature
c
         igsmoo=.TRUE.
         itsmoo(1)=.TRUE.
      else if(lchar('S')) then
c
c  smooth ion temperature
c
         igsmoo=.TRUE.
         do i=1,num_species
            if((ltype(i).eq.1).or.(ltype(i).eq.2)) itsmoo(i)=.TRUE.
         enddo
c
      else if(lchar('U')) then
c
c  smooth a fast ion "temperature" profile
c
 50      continue
         if(lxout(0)) call trxpl_mkgs2_summ(luntty,' (profile data)')
         call uread('enter # of FAST ion specie to smooth, or "Q":$')
         if(.not.lchar('Q')) then
            i=idcod(iert)
            if(iert.ne.0) go to 50
            if((i.lt.1).or.(i.gt.num_species)) then
               call uermsi(
     >          '?trxpl_mkgs2_smoo:  enter valid species code, max is ',
     >            num_species,0)
               go to 50
            else if(ltype(i).le.2) then
               call uermsg('?trxpl_mkgs2_smoo:  not a FAST specie:',
     >            slabel(i),0)
               go to 50
            endif
            itsmoo(i)=.TRUE.
            igsmoo=.TRUE.
         endif
c
      else if(lchar('V')) then
c
c  smooth ALL "tempererature" profiles thermal & fast
c
         itsmoo=.TRUE.
         igsmoo=.TRUE.
c
      else
         call uermsg('?trxpl_mkgs2_smoo: invalid option.',' ',0)
      endif
c
      if(igsmoo) then
         if(lxout(0)) then
            write(luntty,*)
     >         ' smoothing parameter "delta" is in units of "rho"'
            write(luntty,*)
     >         ' base of triangular weighting function for smoothing'
            write(luntty,*)
     >         ' convolution is of width 2*delta.  The allowed range'
            write(luntty,*)
     >         ' for delta is between 0.0 and 0.2.'
            delta(1)=0.0
         endif
         call ureadr8('enter smoothing delta (0 for no smoothing):$',
     >      delta(1))
         delta=max(0.0d0,min(0.2d0,delta(1)))
         if(delta(1).gt.0.0) then
            itiflag=0
            inzflag=0
            do i=1,num_species
               j=0
               if(insmoo(i)) then
                  j=1
                  call eq_rgetf(nrho,rho,id_norig(i),0,f,ierr)
                  if(ierr.ne.0)
     >               call errmsg_exit('??trxpl_mkgs2_smoo 87 ?')
                  fsm=f
                  call eq_get_fname(id_norig(i),zname)
               else if(itsmoo(i)) then
                  j=2
                  call eq_rgetf(nrho,rho,id_torig(i),0,f,ierr)
                  if(ierr.ne.0)
     >               call errmsg_exit('??trxpl_mkgs2_smoo 88 ?')
                  fsm=f
                  call eq_get_fname(id_torig(i),zname)
               endif
               if(j.gt.0) then
c
c  id name for smoothed profile
                  k=min(len(zname)-2,len_trim(zname)+1)
                  zname(k:k+2)='_SM'
c
c  calculate smoothed profile
                  call r8filtr6(rho,f,fsm,nrho,
     >               epsilon,nrho,epsilon,0,delta,0,epsilon,
     >               0,epsilon,enda,endb,zdum,idum1,idum2)
c
c  store or replace result
                  call eq_gfnum(zname,id)
                  if(id.eq.0) then
                     iord=iorder
                  else
                     iord=99
                  endif
c  make the spline
                  call eqm_rhofun(iord,id_rho,zname,fsm,
     >               ibc1,zbc1,ibc2,zbc2,id,ierr)
                  if(ierr.ne.0) then
                     write(luntty,*)
     >                  ' ?? trxpl_mkgs2_smoo: eqm_rhofun error.'
                  else
                     gsmoo=.TRUE.
                     if(j.eq.1) then
                        id_nsmoo(i)=id
                        nsmoo(i)=.TRUE.
                        inzflag=1
                        dx_smooth_n(i)=delta(1)
                     else
                        id_tsmoo(i)=id
                        tsmoo(i)=.TRUE.
                        dx_smooth_t(i)=delta(1)
                     endif
                  endif
               endif                    ! j.gt.0, i.e. profile to be smoothed
c
            enddo                       ! species loop
c
c  if a density was smoothed, do quasineutrality renormalization
            if(inzflag.gt.0) then
               allocate(nprof(nrho),zprof(nrho))
c  compute renormalization profile
               fsm=0.0d0
               do i=1,num_species
                  if(nsmoo(i)) then
                     id=id_nsmoo(i)
                  else
                     id=id_norig(i)
                  endif
                  call eq_rgetf(nrho,rho,id,0,nprof,ierr)
                  if(ierr.ne.0)
     >               call errmsg_exit('??trxpl_mkgs2_smoo 45 ?')
                  if(ltype(i).eq.0) then
                     f=nprof
                  else
                     zprof=Zplas(i)
                     if(id_zprof(i).gt.0) then
                        call eq_rgetf(nrho,rho,id_zprof(i),0,zprof,ierr)
                        if(ierr.ne.0)
     >                     call errmsg_exit('??trxpl_mkgs2_smoo 46 ?')
                     endif
                     fsm=fsm + nprof*Zprof
                  endif
               enddo
c  renormalization profile
               f=f/fsm
               write(luntty,*) ' '
               write(luntty,*) 'quasineutrality renormalization factor:'
               do i=1,nrho
                  write(luntty,*) ' surface no. ',i,' factor = ',f(i)
               enddo
               write(luntty,*) ' '
c  apply renormalization profile & store
               do i=1,num_species
                  if((ltype(i).gt.0).and.nsmoo(i)) then
                     call eq_get_fname(id_nsmoo(i),zname)
                     call eq_rgetf(nrho,rho,id_nsmoo(i),0,nprof,ierr)
                     if(ierr.ne.0)
     >                  call errmsg_exit('??trxpl_mkgs2_smoo 47 ?')
                     nprof=f*nprof
                     call eqm_rhofun(99,id_rho,zname,nprof,
     >                  ibc1,zbc1,ibc2,zbc2,id,ierr)
                     if((ierr.ne.0).or.(id.ne.id_nsmoo(i))) then
                        call errmsg_exit(
     >                ' ??trxpl_mkgs2_smoo:  renorm eqm_rhofun error!')
                     endif
                  endif
               enddo
c
               deallocate(nprof,zprof)
            endif
c
         endif                          ! non-zero smoothing parameter
      endif                             ! smoothing was requested
c
      go to 10                          ! reprompt now
c
 900  continue
c
      deallocate(rho,f,fsm,epsilon,delta,stat=k)  ! ignore status code
c
      return
      end

!
! RGA, parse the path string for info
!
! apath has the format for unix file  <path>/<runid>
!                      for mds        MDS+:<server-name>:<tree-name>(<shot-number>)
!                                     MDS+:<server-name>:<tree-name>(<tok.yy>,<runid>)
!
! returns as much information as possible
!
subroutine trx_extract_path(apath, ishot, aserver, atree, ashot, adir, adevice, arunid, ayear)
  implicit none

  character*(*), intent(in)  :: apath    ! parse this path
  integer,       intent(in)  :: ishot    ! shot number from namelist if available, used to guess runid

  character*(*), intent(out) :: aserver  ! mdsplus server
  character*(*), intent(out) :: atree    ! mdsplus server
  integer,       intent(out) :: ashot    ! mdsplus shot number or 0
  character*(*), intent(out) :: adir     ! directory name
  character*(*), intent(out) :: adevice  ! tokamak
  character*(*), intent(out) :: arunid   ! best guess at runid
  integer,       intent(out) :: ayear    ! year if known otherwise -1
  
  character*26,parameter :: alpha = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'  

  logical      :: ifixtree             ! .true. if a tree called transp should be called transp_<tok>
  character*5  :: a5
  character*16 :: rin                  ! temporary
  character*20 :: ccshot,tokyy         ! shot number and <tok>.<yy>
  integer      :: k,n,m
  integer      :: i1,i2,ic1,ic2,ix,iy  ! temp indices into apath
  
  aserver="" ; atree=""   ; ashot=0
  adevice="" ; arunid=""  ; ayear=-1
  adir=""
  
  i1=0 ; i2=0 ; ic1=0 ; ic2=0
  tokyy    = ""
  ifixtree = .false.
  
  ! look for MDS+:<stuff>:<stuff>(<stuff>)
  if (len(apath)>5) then
     a5 = apath(1:5)
     call ulower(a5)
     if (a5 == 'mds+:') then
        i1 = index(apath,':')
        if (i1>0 .and. len(apath)>i1) then
           i2 = index(apath(i1+1:),':')+i1
           if (i2>i1 .and. len(apath)>i2) then
              ic1 = index(apath(i2+1:),'(')+i2
              if (ic1>i2 .and. len(apath)>ic1+1) then
                 ic2 = index(apath(ic1+1:),')')+ic1
              end if
           end if
        end if
     end if
  end if
  
  if (i1>0 .and. i2>i1 .and. ic1>i2 .and. ic2>ic1) then
     !
     ! MDS+:<stuff>:<stuff>(<stuff>) format
     !
     aserver = adjustl(apath(i1+1:i2-1))
     atree   = adjustl(apath(i2+1:ic1-1))
     call ulower(atree)
     call ulower(aserver)

     ix = index(apath(ic1+1:ic2-1),',')+ic1  ! distinguish between (<shot-number>) and (<tok.yy>,<runid>)
     if (ix>ic1) then
        ! <tok.yy>,<runid>
        if (ix>ic1+1) tokyy  = adjustl(apath(ic1+1:ix-1))
        if (ic2>ix+1) arunid = adjustl(apath(ix+1:ic2-1))
        ifixtree = .true.
     else
        ! <shot-number>
        rin = adjustl(apath(ic1+1:ic2-1))
        read(rin,'(i10)',err=20) ashot
        goto 10
20      ashot=0
10      continue
        if (ashot>0 .and. ishot>0) then     ! guess runid from mds_shot and transp shot number
           k = ashot - ishot*10000          ! for 37065Z47,  2647 = 370652647 - 370650000
           n = k/100                        ! 'Z'
           m = mod(k,100)                   ! 47
           if (k>=100 .and. k<=2699 .and. n>=1 .and. n<=26 .and. m>=0) then   ! A00 to Z99
              write(ccshot,'(i9)') ishot
              write(a5,'(i2)') m
              ccshot = adjustl(ccshot)
              a5     = adjustl(a5)
              if (m>9) then
                 arunid = trim(ccshot)//alpha(n:n)//a5(1:2)
              else
                 arunid = trim(ccshot)//alpha(n:n)//'0'//a5(1:1)
              end if
           end if
        end if

        ! look for device if transpgrid server and tree transp_<tok>
        if (len_trim(aserver)>=10 .and. len_trim(atree)>7) then
           if (aserver(1:10)=="transpgrid" .and. atree(1:7)=="transp_") then
              adevice = atree(8:)
           end if
        end if
     end if
  else if (i1==0) then
     !
     ! unix path, might be in form
     ! <stuff>/<tok>.<yy>/<runid>
     !
     i1 = index(apath,'/',.true.)
     if (i1>0) then
        if (i1<len_trim(apath)) then
           arunid = trim(adjustl(apath(i1+1:)))
           call uupper(arunid)
           ix = index(arunid,'.CDF',.true.)     ! might be 37065Z45.CDF
           if (ix>1) arunid = arunid(:ix-1)
        end if
        i1 = max(1,i1-1)            ! in case of '/'
        adir = adjustl(apath(1:i1))
        i2 = index(adir,'/',.true.)
        if (i2>1 .and. i2<len_trim(adir)) tokyy = trim(adir(i2+1:))  ! might be tokyy
     end if
  end if
  
  !
  ! extract from <tok>.<yy>
  !
  if (len_trim(tokyy)>0) then
     iy = index(tokyy,'.')
     if (iy>1 .and. iy<len_trim(tokyy)) then
        adevice = trim(adjustl(tokyy(:iy-1)))
        rin = adjustl(tokyy(iy+1:))
        read(rin,'(i9)',err=40) ayear
        goto 30
40      ayear=-1
        adevice = ""
30      continue
        if (ayear>=0 .and. ayear<1900) then
           if (ayear<70) then
              ayear=2000+ayear
           else
              ayear=1900+ayear
           end if
        end if
        if (ayear<=1900 .or. ayear>2100) then
           ayear=-1 ; adevice=""
        end if
     end if
  end if

  call uupper(adevice)
  call uupper(arunid) 

  if (ifixtree .and. atree=="transp" .and. len_trim(adevice)>0) then  ! convert to standard mdsplus tree format
     atree = "transp_"//trim(adevice)
     call ulower(atree)
     if (len_trim(arunid)>0) then
        call mkbeastid(arunid,ashot,ccshot)
     end if
  end if

  !
  ! if can't find runid use ishot
  !
  if (len_trim(arunid)==0 .and. len(arunid)>=9) then
     write(arunid,'(i9)') ishot  ! punt
  end if
end subroutine trx_extract_path

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


subroutine ps_sconfig_namelist_read(init,filename,tmp_filename,ss,ierr)

  ! from current contents of state, write shot configuration namelist

  USE plasma_state_mod
  IMPLICIT NONE

  LOGICAL, INTENT(IN) :: init                  ! .TRUE. to pre-initialize
  ! state variables prior to namelist read (caution -- could cause problems
  ! if partial configuration dataset is already in the state).

  CHARACTER*(*), INTENT(IN) :: filename        ! file to contain namelist
  CHARACTER*(*), INTENT(IN) :: tmp_filename    ! namelist (comments removed)
  !  (leave tmp_filename blank to get internally generated filename)
  TYPE (plasma_state) :: ss     ! state containing data to read
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------------------
  INTEGER :: iout,iertmp,isize,isiz0,ii
  INTEGER :: ilun_namel
  !-------------------------------
  INTEGER :: shot_number
  INTEGER, dimension(ps_max_static) :: iAMU_S
  INTEGER, dimension(ps_max_static) :: iZatom_S
  INTEGER, dimension(ps_max_static) :: iZion_S
  CHARACTER*32, dimension(ps_max_static) :: nbion
  CHARACTER*32, dimension(ps_max_static) :: nbion_trace
  INTEGER, dimension(ps_max_static) :: iAMU_SFUS
  INTEGER, dimension(ps_max_static) :: iZatom_SFUS
  INTEGER, dimension(ps_max_static) :: iZion_SFUS
  INTEGER, dimension(ps_max_static) :: iAMU_RFMIN
  INTEGER, dimension(ps_max_static) :: iZatom_RFMIN
  INTEGER, dimension(ps_max_static) :: iZion_RFMIN
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: freq_ic
  INTEGER, dimension(ps_max_static_2d) :: n_straps
  INTEGER :: max_n_straps
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: R_ant
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: Z_ant
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: Z_mid_ant
  INTEGER, dimension(ps_max_static_2d) :: num_nphi_vac
  INTEGER :: max_num_nphi_vac
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: Real_ant_coef
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: Imag_ant_coef
  INTEGER, dimension(ps_max_static_2d) :: num_nphi
  INTEGER :: max_num_nphi
  INTEGER, dimension(ps_max_static_2d,ps_max_static_2d) :: nphi
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: wt_nphi
  INTEGER :: kccw_Bphi
  INTEGER :: kccw_Jphi
  CHARACTER*32, dimension(ps_max_static) :: gs_name
  CHARACTER*32, dimension(ps_max_static) :: gas_atom
  INTEGER, dimension(ps_max_static) :: is_recycling
  CHARACTER*32, dimension(ps_max_static) :: xs_name
  REAL(KIND=rspec), dimension(ps_max_static) :: freq_ec
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_theta_aim
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_phi_aim
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_Omode_Fraction
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: freq_lh
  INTEGER, dimension(ps_max_static_2d) :: nspectrumlh_src
  INTEGER :: max_nspectrumlh_src
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: aminlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: amaxlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: atorminlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: atormaxlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: apolminlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: apolmaxlh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: fracpslh
  INTEGER :: i_npoloidal
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: rhopsi0lh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: thegrilh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: phigrilh
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: hegrilh
  INTEGER, dimension(ps_max_static_2d,ps_max_static_2d) :: nthinlh
  INTEGER, dimension(ps_max_static_2d,ps_max_static_2d) :: nnkparlh
  INTEGER, dimension(ps_max_static_2d,ps_max_static_2d) :: nnktorlh
  INTEGER, dimension(ps_max_static_2d,ps_max_static_2d) :: nnkpollh

  NAMELIST /sconfig/ &
       shot_number, &
       iAMU_S,iZatom_S,iZion_S, &
       nbion, &
       nbion_trace, &
       iAMU_SFUS,iZatom_SFUS,iZion_SFUS, &
       iAMU_RFMIN,iZatom_RFMIN,iZion_RFMIN, &
       freq_ic, &
       n_straps, &
       max_n_straps, &
       R_ant, &
       Z_ant, &
       Z_mid_ant, &
       num_nphi_vac, &
       max_num_nphi_vac, &
       Real_ant_coef, &
       Imag_ant_coef, &
       num_nphi, &
       max_num_nphi, &
       nphi, &
       wt_nphi, &
       kccw_Bphi, &
       kccw_Jphi, &
       gs_name, &
       gas_atom, &
       is_recycling, &
       xs_name, &
       freq_ec, &
       EC_theta_aim, &
       EC_phi_aim, &
       EC_Omode_Fraction, &
       freq_lh, &
       nspectrumlh_src, &
       max_nspectrumlh_src, &
       aminlh, &
       amaxlh, &
       atorminlh, &
       atormaxlh, &
       apolminlh, &
       apolmaxlh, &
       fracpslh, &
       i_npoloidal, &
       rhopsi0lh, &
       thegrilh, &
       phigrilh, &
       hegrilh, &
       nthinlh, &
       nnkparlh, &
       nnktorlh, &
       nnkpollh
  !---------------------------------------

  iout = SWIM_err_out_file

  ierr = 0

  ! initialize local namelist variables to state values
  IF(init) ss%shot_number = 0
  shot_number = ss%shot_number
  iAMU_S = ps_unInit
  iZatom_S = ps_unInit
  iZion_S = ps_unInit
  nbion = " "
  IF(ALLOCATED(ss%nbion)) THEN
     isize = size(nbion)
     IF(init) THEN
        ss%nbion(1:isize) = nbion(1:isize)
     ELSE
        nbion(1:isize) = ss%nbion(1:isize)
     ENDIF
  ENDIF
  nbion_trace = " "
  IF(ALLOCATED(ss%nbion_trace)) THEN
     isize = size(nbion_trace)
     IF(init) THEN
        ss%nbion_trace(1:isize) = nbion_trace(1:isize)
     ELSE
        nbion_trace(1:isize) = ss%nbion_trace(1:isize)
     ENDIF
  ENDIF
  iAMU_SFUS = ps_unInit
  iZatom_SFUS = ps_unInit
  iZion_SFUS = ps_unInit
  iAMU_RFMIN = ps_unInit
  iZatom_RFMIN = ps_unInit
  iZion_RFMIN = ps_unInit
  freq_ic = 0.0_rspec
  IF(ALLOCATED(ss%freq_ic)) THEN
     isize = size(freq_ic)
     IF(init) THEN
        ss%freq_ic(1:isize) = freq_ic(1:isize)
     ELSE
        freq_ic(1:isize) = ss%freq_ic(1:isize)
     ENDIF
  ENDIF
  n_straps = ps_unInit
  IF(ALLOCATED(ss%n_straps)) THEN
     isize = size(n_straps)
     IF(init) THEN
        ss%n_straps(1:isize) = n_straps(1:isize)
     ELSE
        n_straps(1:isize) = ss%n_straps(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%max_n_straps = 0
  max_n_straps = ss%max_n_straps
  R_ant = 0.0_rspec
  IF(ALLOCATED(ss%R_ant)) THEN
     isize = size(R_ant)
     IF(init) THEN
        ss%R_ant(1:isize) = R_ant(1:isize)
     ELSE
        R_ant(1:isize) = ss%R_ant(1:isize)
     ENDIF
  ENDIF
  Z_ant = 0.0_rspec
  IF(ALLOCATED(ss%Z_ant)) THEN
     isize = size(Z_ant)
     IF(init) THEN
        ss%Z_ant(1:isize) = Z_ant(1:isize)
     ELSE
        Z_ant(1:isize) = ss%Z_ant(1:isize)
     ENDIF
  ENDIF
  Z_mid_ant = 0.0_rspec
  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     isize = size(Z_mid_ant)
     IF(init) THEN
        ss%Z_mid_ant(1:isize) = Z_mid_ant(1:isize)
     ELSE
        Z_mid_ant(1:isize) = ss%Z_mid_ant(1:isize)
     ENDIF
  ENDIF
  num_nphi_vac = ps_unInit
  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     isize = size(num_nphi_vac)
     IF(init) THEN
        ss%num_nphi_vac(1:isize) = num_nphi_vac(1:isize)
     ELSE
        num_nphi_vac(1:isize) = ss%num_nphi_vac(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%max_num_nphi_vac = 0
  max_num_nphi_vac = ss%max_num_nphi_vac
  Real_ant_coef = 0.0_rspec
  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     isiz0 = size(Real_ant_coef,1)
     isize = size(Real_ant_coef,2)
     IF(init) THEN
        ss%Real_ant_coef(1:isiz0,1:isize) = Real_ant_coef(1:isiz0,1:isize)
     ELSE
        Real_ant_coef(1:isiz0,1:isize) = ss%Real_ant_coef(1:isiz0,1:isize)
     ENDIF
  ENDIF
  Imag_ant_coef = 0.0_rspec
  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     isiz0 = size(Imag_ant_coef,1)
     isize = size(Imag_ant_coef,2)
     IF(init) THEN
        ss%Imag_ant_coef(1:isiz0,1:isize) = Imag_ant_coef(1:isiz0,1:isize)
     ELSE
        Imag_ant_coef(1:isiz0,1:isize) = ss%Imag_ant_coef(1:isiz0,1:isize)
     ENDIF
  ENDIF
  num_nphi = ps_unInit
  IF(ALLOCATED(ss%num_nphi)) THEN
     isize = size(num_nphi)
     IF(init) THEN
        ss%num_nphi(1:isize) = num_nphi(1:isize)
     ELSE
        num_nphi(1:isize) = ss%num_nphi(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%max_num_nphi = 0
  max_num_nphi = ss%max_num_nphi
  nphi = ps_unInit
  IF(ALLOCATED(ss%nphi)) THEN
     isiz0 = size(nphi,1)
     isize = size(nphi,2)
     IF(init) THEN
        ss%nphi(1:isiz0,1:isize) = nphi(1:isiz0,1:isize)
     ELSE
        nphi(1:isiz0,1:isize) = ss%nphi(1:isiz0,1:isize)
     ENDIF
  ENDIF
  wt_nphi = 0.0_rspec
  IF(ALLOCATED(ss%wt_nphi)) THEN
     isiz0 = size(wt_nphi,1)
     isize = size(wt_nphi,2)
     IF(init) THEN
        ss%wt_nphi(1:isiz0,1:isize) = wt_nphi(1:isiz0,1:isize)
     ELSE
        wt_nphi(1:isiz0,1:isize) = ss%wt_nphi(1:isiz0,1:isize)
     ENDIF
  ENDIF
  IF(init) ss%kccw_Bphi = 0
  kccw_Bphi = ss%kccw_Bphi
  IF(init) ss%kccw_Jphi = 0
  kccw_Jphi = ss%kccw_Jphi
  gs_name = " "
  IF(ALLOCATED(ss%gs_name)) THEN
     isize = size(gs_name)
     IF(init) THEN
        ss%gs_name(1:isize) = gs_name(1:isize)
     ELSE
        gs_name(1:isize) = ss%gs_name(1:isize)
     ENDIF
  ENDIF
  gas_atom = " "
  IF(ALLOCATED(ss%gas_atom)) THEN
     isize = size(gas_atom)
     IF(init) THEN
        ss%gas_atom(1:isize) = gas_atom(1:isize)
     ELSE
        gas_atom(1:isize) = ss%gas_atom(1:isize)
     ENDIF
  ENDIF
  is_recycling = ps_unInit
  IF(ALLOCATED(ss%is_recycling)) THEN
     isize = size(is_recycling)
     IF(init) THEN
        ss%is_recycling(1:isize) = is_recycling(1:isize)
     ELSE
        is_recycling(1:isize) = ss%is_recycling(1:isize)
     ENDIF
  ENDIF
  xs_name = " "
  IF(ALLOCATED(ss%xs_name)) THEN
     isize = size(xs_name)
     IF(init) THEN
        ss%xs_name(1:isize) = xs_name(1:isize)
     ELSE
        xs_name(1:isize) = ss%xs_name(1:isize)
     ENDIF
  ENDIF
  freq_ec = 0.0_rspec
  IF(ALLOCATED(ss%freq_ec)) THEN
     isize = size(freq_ec)
     IF(init) THEN
        ss%freq_ec(1:isize) = freq_ec(1:isize)
     ELSE
        freq_ec(1:isize) = ss%freq_ec(1:isize)
     ENDIF
  ENDIF
  EC_theta_aim = 0.0_rspec
  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     isize = size(EC_theta_aim)
     IF(init) THEN
        ss%EC_theta_aim(1:isize) = EC_theta_aim(1:isize)
     ELSE
        EC_theta_aim(1:isize) = ss%EC_theta_aim(1:isize)
     ENDIF
  ENDIF
  EC_phi_aim = 0.0_rspec
  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     isize = size(EC_phi_aim)
     IF(init) THEN
        ss%EC_phi_aim(1:isize) = EC_phi_aim(1:isize)
     ELSE
        EC_phi_aim(1:isize) = ss%EC_phi_aim(1:isize)
     ENDIF
  ENDIF
  EC_Omode_Fraction = 0.0_rspec
  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     isize = size(EC_Omode_Fraction)
     IF(init) THEN
        ss%EC_Omode_Fraction(1:isize) = EC_Omode_Fraction(1:isize)
     ELSE
        EC_Omode_Fraction(1:isize) = ss%EC_Omode_Fraction(1:isize)
     ENDIF
  ENDIF
  freq_lh = 0.0_rspec
  IF(ALLOCATED(ss%freq_lh)) THEN
     isize = size(freq_lh)
     IF(init) THEN
        ss%freq_lh(1:isize) = freq_lh(1:isize)
     ELSE
        freq_lh(1:isize) = ss%freq_lh(1:isize)
     ENDIF
  ENDIF
  nspectrumlh_src = ps_unInit
  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     isize = size(nspectrumlh_src)
     IF(init) THEN
        ss%nspectrumlh_src(1:isize) = nspectrumlh_src(1:isize)
     ELSE
        nspectrumlh_src(1:isize) = ss%nspectrumlh_src(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%max_nspectrumlh_src = 0
  max_nspectrumlh_src = ss%max_nspectrumlh_src
  aminlh = 0.0_rspec
  IF(ALLOCATED(ss%aminlh)) THEN
     isiz0 = size(aminlh,1)
     isize = size(aminlh,2)
     IF(init) THEN
        ss%aminlh(1:isiz0,1:isize) = aminlh(1:isiz0,1:isize)
     ELSE
        aminlh(1:isiz0,1:isize) = ss%aminlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  amaxlh = 0.0_rspec
  IF(ALLOCATED(ss%amaxlh)) THEN
     isiz0 = size(amaxlh,1)
     isize = size(amaxlh,2)
     IF(init) THEN
        ss%amaxlh(1:isiz0,1:isize) = amaxlh(1:isiz0,1:isize)
     ELSE
        amaxlh(1:isiz0,1:isize) = ss%amaxlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  atorminlh = 0.0_rspec
  IF(ALLOCATED(ss%atorminlh)) THEN
     isiz0 = size(atorminlh,1)
     isize = size(atorminlh,2)
     IF(init) THEN
        ss%atorminlh(1:isiz0,1:isize) = atorminlh(1:isiz0,1:isize)
     ELSE
        atorminlh(1:isiz0,1:isize) = ss%atorminlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  atormaxlh = 0.0_rspec
  IF(ALLOCATED(ss%atormaxlh)) THEN
     isiz0 = size(atormaxlh,1)
     isize = size(atormaxlh,2)
     IF(init) THEN
        ss%atormaxlh(1:isiz0,1:isize) = atormaxlh(1:isiz0,1:isize)
     ELSE
        atormaxlh(1:isiz0,1:isize) = ss%atormaxlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  apolminlh = 0.0_rspec
  IF(ALLOCATED(ss%apolminlh)) THEN
     isiz0 = size(apolminlh,1)
     isize = size(apolminlh,2)
     IF(init) THEN
        ss%apolminlh(1:isiz0,1:isize) = apolminlh(1:isiz0,1:isize)
     ELSE
        apolminlh(1:isiz0,1:isize) = ss%apolminlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  apolmaxlh = 0.0_rspec
  IF(ALLOCATED(ss%apolmaxlh)) THEN
     isiz0 = size(apolmaxlh,1)
     isize = size(apolmaxlh,2)
     IF(init) THEN
        ss%apolmaxlh(1:isiz0,1:isize) = apolmaxlh(1:isiz0,1:isize)
     ELSE
        apolmaxlh(1:isiz0,1:isize) = ss%apolmaxlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  fracpslh = 0.0_rspec
  IF(ALLOCATED(ss%fracpslh)) THEN
     isiz0 = size(fracpslh,1)
     isize = size(fracpslh,2)
     IF(init) THEN
        ss%fracpslh(1:isiz0,1:isize) = fracpslh(1:isiz0,1:isize)
     ELSE
        fracpslh(1:isiz0,1:isize) = ss%fracpslh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  IF(init) ss%i_npoloidal = 0
  i_npoloidal = ss%i_npoloidal
  rhopsi0lh = 0.0_rspec
  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     isiz0 = size(rhopsi0lh,1)
     isize = size(rhopsi0lh,2)
     IF(init) THEN
        ss%rhopsi0lh(1:isiz0,1:isize) = rhopsi0lh(1:isiz0,1:isize)
     ELSE
        rhopsi0lh(1:isiz0,1:isize) = ss%rhopsi0lh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  thegrilh = 0.0_rspec
  IF(ALLOCATED(ss%thegrilh)) THEN
     isiz0 = size(thegrilh,1)
     isize = size(thegrilh,2)
     IF(init) THEN
        ss%thegrilh(1:isiz0,1:isize) = thegrilh(1:isiz0,1:isize)
     ELSE
        thegrilh(1:isiz0,1:isize) = ss%thegrilh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  phigrilh = 0.0_rspec
  IF(ALLOCATED(ss%phigrilh)) THEN
     isiz0 = size(phigrilh,1)
     isize = size(phigrilh,2)
     IF(init) THEN
        ss%phigrilh(1:isiz0,1:isize) = phigrilh(1:isiz0,1:isize)
     ELSE
        phigrilh(1:isiz0,1:isize) = ss%phigrilh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  hegrilh = 0.0_rspec
  IF(ALLOCATED(ss%hegrilh)) THEN
     isiz0 = size(hegrilh,1)
     isize = size(hegrilh,2)
     IF(init) THEN
        ss%hegrilh(1:isiz0,1:isize) = hegrilh(1:isiz0,1:isize)
     ELSE
        hegrilh(1:isiz0,1:isize) = ss%hegrilh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  nthinlh = ps_unInit
  IF(ALLOCATED(ss%nthinlh)) THEN
     isiz0 = size(nthinlh,1)
     isize = size(nthinlh,2)
     IF(init) THEN
        ss%nthinlh(1:isiz0,1:isize) = nthinlh(1:isiz0,1:isize)
     ELSE
        nthinlh(1:isiz0,1:isize) = ss%nthinlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  nnkparlh = ps_unInit
  IF(ALLOCATED(ss%nnkparlh)) THEN
     isiz0 = size(nnkparlh,1)
     isize = size(nnkparlh,2)
     IF(init) THEN
        ss%nnkparlh(1:isiz0,1:isize) = nnkparlh(1:isiz0,1:isize)
     ELSE
        nnkparlh(1:isiz0,1:isize) = ss%nnkparlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  nnktorlh = ps_unInit
  IF(ALLOCATED(ss%nnktorlh)) THEN
     isiz0 = size(nnktorlh,1)
     isize = size(nnktorlh,2)
     IF(init) THEN
        ss%nnktorlh(1:isiz0,1:isize) = nnktorlh(1:isiz0,1:isize)
     ELSE
        nnktorlh(1:isiz0,1:isize) = ss%nnktorlh(1:isiz0,1:isize)
     ENDIF
  ENDIF
  nnkpollh = ps_unInit
  IF(ALLOCATED(ss%nnkpollh)) THEN
     isiz0 = size(nnkpollh,1)
     isize = size(nnkpollh,2)
     IF(init) THEN
        ss%nnkpollh(1:isiz0,1:isize) = nnkpollh(1:isiz0,1:isize)
     ELSE
        nnkpollh(1:isiz0,1:isize) = ss%nnkpollh(1:isiz0,1:isize)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%S_type)) THEN
     ierr = ierr + 1
     write(iout,*) " ?sconfig namelist read error: state element S already allocated."
  ENDIF

  IF(ALLOCATED(ss%SFUS_type)) THEN
     ierr = ierr + 1
     write(iout,*) " ?sconfig namelist read error: state element SFUS already allocated."
  ENDIF

  IF(ALLOCATED(ss%RFMIN_type)) THEN
     ierr = ierr + 1
     write(iout,*) " ?sconfig namelist read error: state element RFMIN already allocated."
  ENDIF

  IF(ierr.GT.0) RETURN

  ! OK: open namelist file, strip comments.
  !     namelist to be read on ilun_namel after this call:

  CALL ps_namel_strip(filename,tmp_filename,ilun_namel,iout,ierr)

  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?namelist file OPEN or READ error: '//trim(filename)
     RETURN
  ENDIF

  READ(UNIT=ilun_namel,NML=sconfig)

  CLOSE(UNIT=ilun_namel,status="DELETE")

  ! check list quantities; infer dimensions

  CALL ps_namrd_slist_chk("S", &
       ps_max_static,iAMU_S,iZatom_S,iZion_S,ss%NSPEC_TH,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_slist_chk("SFUS", &
       ps_max_static,iAMU_SFUS,iZatom_SFUS,iZion_SFUS,ss%NSPEC_FUSION,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_slist_chk("RFMIN", &
       ps_max_static,iAMU_RFMIN,iZatom_RFMIN,iZion_RFMIN,ss%NSPEC_RFMIN,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  ss%max_n_straps = max_n_straps

  ss%max_num_nphi_vac = max_num_nphi_vac

  ss%max_num_nphi = max_num_nphi

  CALL ps_namrd_ilist_chk("gs_name", &
       ps_max_static,gs_name,ss%NGSC0,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_ilist_chk("xs_name", &
       ps_max_static,xs_name,ss%NXS,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  ss%max_nspectrumlh_src = max_nspectrumlh_src

  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?sconfig namelist list check errors after read."
     RETURN
  ENDIF

  ! OK, allocate arrays per dimensioning in namelist
  CALL plasma_state_empty_alloc(ss,ierr)
  IF(ierr.NE.0) RETURN

  ! Now pick up any vector dimensions

  isize = ss%NICRF_SRC
  ss%n_straps(1:isize) = n_straps(1:isize)

  isize = ss%NICRF_SRC
  ss%num_nphi_vac(1:isize) = num_nphi_vac(1:isize)

  isize = ss%NICRF_SRC
  ss%num_nphi(1:isize) = num_nphi(1:isize)

  isize = ss%NGSC0
  ss%is_recycling(1:isize) = is_recycling(1:isize)

  isize = ss%NLHRF_SRC
  ss%nspectrumlh_src(1:isize) = nspectrumlh_src(1:isize)

  ! OK, allocate arrays per vector dimensioning in namelist
  CALL plasma_state_empty_alloc(ss,ierr)
  IF(ierr.NE.0) RETURN

  ! Now copy namelist variables into state
  ss%shot_number = shot_number

  IF(ALLOCATED(ss%qatom_S)) THEN
     CALL ps_species_convert(-1, -1, 0, &
          ss%qatom_S(0), ss%q_S(0), ss%m_S(0), ierr)
     IF(ierr.NE.0) RETURN

     DO II = 1,ss%NSPEC_TH
        CALL ps_species_convert(iZatom_S(ii),iZion_S(ii),iAMU_S(ii), &
             ss%qatom_S(ii), ss%q_S(ii), ss%m_S(ii), ierr)
        IF(ierr.NE.0) RETURN
     ENDDO
  ENDIF


  IF(ALLOCATED(ss%nbion)) THEN
     isize = ss%NBEAM
     ss%nbion(1:isize) = nbion(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nbion_trace)) THEN
     isize = ss%NBEAM
     ss%nbion_trace(1:isize) = nbion_trace(1:isize)
  ENDIF

  IF(ALLOCATED(ss%qatom_SFUS)) THEN
     DO II = 1,ss%NSPEC_FUSION
        CALL ps_species_convert(iZatom_SFUS(ii),iZion_SFUS(ii),iAMU_SFUS(ii), &
             ss%qatom_SFUS(ii), ss%q_SFUS(ii), ss%m_SFUS(ii), ierr)
        IF(ierr.NE.0) RETURN
     ENDDO
  ENDIF


  IF(ALLOCATED(ss%qatom_RFMIN)) THEN
     DO II = 1,ss%NSPEC_RFMIN
        CALL ps_species_convert(iZatom_RFMIN(ii),iZion_RFMIN(ii),iAMU_RFMIN(ii), &
             ss%qatom_RFMIN(ii), ss%q_RFMIN(ii), ss%m_RFMIN(ii), ierr)
        IF(ierr.NE.0) RETURN
     ENDDO
  ENDIF


  IF(ALLOCATED(ss%freq_ic)) THEN
     isize = ss%NICRF_SRC
     ss%freq_ic(1:isize) = freq_ic(1:isize)
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     isize = ss%NICRF_SRC
     ss%n_straps(1:isize) = n_straps(1:isize)
  ENDIF

  IF(ALLOCATED(ss%R_ant)) THEN
     isize = ss%NICRF_SRC
     ss%R_ant(1:isize) = R_ant(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Z_ant)) THEN
     isize = ss%NICRF_SRC
     ss%Z_ant(1:isize) = Z_ant(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Z_mid_ant)) THEN
     isize = ss%NICRF_SRC
     ss%Z_mid_ant(1:isize) = Z_mid_ant(1:isize)
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     isize = ss%NICRF_SRC
     ss%num_nphi_vac(1:isize) = num_nphi_vac(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     isiz0 = maxval(ss%NUM_NPHI_VAC)
     isize = ss%NICRF_SRC
     ss%Real_ant_coef(1:isiz0,1:isize) = Real_ant_coef(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     isiz0 = maxval(ss%NUM_NPHI_VAC)
     isize = ss%NICRF_SRC
     ss%Imag_ant_coef(1:isiz0,1:isize) = Imag_ant_coef(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     isize = ss%NICRF_SRC
     ss%num_nphi(1:isize) = num_nphi(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nphi)) THEN
     isiz0 = maxval(ss%NUM_NPHI)
     isize = ss%NICRF_SRC
     ss%nphi(1:isiz0,1:isize) = nphi(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%wt_nphi)) THEN
     isiz0 = maxval(ss%NUM_NPHI)
     isize = ss%NICRF_SRC
     ss%wt_nphi(1:isiz0,1:isize) = wt_nphi(1:isiz0,1:isize)
  ENDIF
  ss%kccw_Bphi = kccw_Bphi
  ss%kccw_Jphi = kccw_Jphi

  IF(ALLOCATED(ss%gs_name)) THEN
     isize = ss%NGSC0
     ss%gs_name(1:isize) = gs_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%gas_atom)) THEN
     isize = ss%NGSC0
     ss%gas_atom(1:isize) = gas_atom(1:isize)
  ENDIF

  IF(ALLOCATED(ss%is_recycling)) THEN
     isize = ss%NGSC0
     ss%is_recycling(1:isize) = is_recycling(1:isize)
  ENDIF

  IF(ALLOCATED(ss%xs_name)) THEN
     isize = ss%NXS
     ss%xs_name(1:isize) = xs_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%freq_ec)) THEN
     isize = ss%NECRF_SRC
     ss%freq_ec(1:isize) = freq_ec(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     isize = ss%NECRF_SRC
     ss%EC_theta_aim(1:isize) = EC_theta_aim(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     isize = ss%NECRF_SRC
     ss%EC_phi_aim(1:isize) = EC_phi_aim(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     isize = ss%NECRF_SRC
     ss%EC_Omode_Fraction(1:isize) = EC_Omode_Fraction(1:isize)
  ENDIF

  IF(ALLOCATED(ss%freq_lh)) THEN
     isize = ss%NLHRF_SRC
     ss%freq_lh(1:isize) = freq_lh(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nspectrumlh_src)) THEN
     isize = ss%NLHRF_SRC
     ss%nspectrumlh_src(1:isize) = nspectrumlh_src(1:isize)
  ENDIF

  IF(ALLOCATED(ss%aminlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%aminlh(1:isiz0,1:isize) = aminlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%amaxlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%amaxlh(1:isiz0,1:isize) = amaxlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%atorminlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%atorminlh(1:isiz0,1:isize) = atorminlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%atormaxlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%atormaxlh(1:isiz0,1:isize) = atormaxlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%apolminlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%apolminlh(1:isiz0,1:isize) = apolminlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%apolmaxlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%apolmaxlh(1:isiz0,1:isize) = apolmaxlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%fracpslh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%fracpslh(1:isiz0,1:isize) = fracpslh(1:isiz0,1:isize)
  ENDIF
  ss%i_npoloidal = i_npoloidal

  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%rhopsi0lh(1:isiz0,1:isize) = rhopsi0lh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%thegrilh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%thegrilh(1:isiz0,1:isize) = thegrilh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%phigrilh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%phigrilh(1:isiz0,1:isize) = phigrilh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%hegrilh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%hegrilh(1:isiz0,1:isize) = hegrilh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%nthinlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%nthinlh(1:isiz0,1:isize) = nthinlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%nnkparlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%nnkparlh(1:isiz0,1:isize) = nnkparlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%nnktorlh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%nnktorlh(1:isiz0,1:isize) = nnktorlh(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%nnkpollh)) THEN
     isiz0 = maxval(ss%NSPECTRUMLH_SRC)
     isize = ss%NLHRF_SRC
     ss%nnkpollh(1:isiz0,1:isize) = nnkpollh(1:isiz0,1:isize)
  ENDIF


END SUBROUTINE ps_sconfig_namelist_read

module trx_module
 
!  module "COMMON" for trx library -- TRANSP data access and interpolation
!
!-----------------------
!  mod DMC Feb 2008 -- use trdatbuf_module
!  create ability to access TRDAT (TRANSP input) datasets
!-----------------------

  use trdatbuf_module
  implicit NONE
  SAVE

!  New Feb 2008:

  Type (trdatbuf) :: d
  logical :: d_init_flag = .FALSE.
  logical :: d_data_avail = .FALSE.

  logical :: symZ = .TRUE.   ! .true. to symmetrize the grid limits in Z.  This causes problems
                             ! when using a free boundary grid which is not centered in Z.
!-------------------------------
!  original trx_module variables follow...
!
!  basic statistics
!
  integer :: nsctime         ! number of points in scalar timebase
  integer :: nprtime         ! number of points in profile timebase
  integer :: nxmax           ! max no. of points, any x axis
  integer :: nmax            ! max no. of points,
  integer :: nsurf           ! no. of flux surfaces, including mag. axis
  integer :: nrmajm          ! no. of major radius points (RMAJM)
  integer :: nrmjsym         ! no. of major radius points (RMJSYM)
!
  integer :: ksym            ! =0: updown symmetric; =1: updown asymmetric
  integer :: nmoms           ! no. of moments, TRANSP equilibrium.
!
!  profile type identification
!
  integer :: itype_x         ! type code:  zone centered profiles
  integer :: itype_xb        ! type code:  bdy centered profiles
  integer :: itype_Rmajm     ! type code:  vs. RMAJM
  integer :: itype_Rmjsym    ! type code:  vs. RMJSYM
!
!  free boundary information
!
  integer :: nRfree,nZfree
  integer :: ifound_Psi0=0
  real*8, dimension(:), allocatable :: Rgrid_free,Zgrid_free
  real*8, dimension(:,:), allocatable :: PsiRZ_free
  real*8 :: raxis_mhd,zaxis_mhd
  real*8 :: Psi0_mhd = 0.0d0
!
!  grid identification -- (rho,chi), (R,Z)
!
  integer :: id_rho          ! flux surface grid
  integer :: id_rhozc        ! flux zone centered grid augmented w/ axis & bdy
  integer :: id_chi          ! poloidal angle grid
  integer :: id_R            ! R grid
  integer :: id_Z            ! Z grid
  integer :: id_Rmajm        ! TRANSP RMAJM grid
  integer :: id_Rmjsym       ! TRANSP RMJSYM grid
!
!  (the following is used to enable reversing direction of increasing
!   theta given by TRANSP-- for software testing purposes)
!
  integer :: th_reverse = 0  ! set =1 to reverse theta order
!
  integer :: isign_rzbc = 1  ! set =-1 to get finite difference BC applied
                             ! to R(theta,rho) and Z(theta,rho) profiles.
!
!  extrapolation factors
!
  real*8 afac0,afaclin       ! zone 1 ctr -> axis
  real*8 efac0,efaclin       ! zone N ctr -> edge
  real*8 afac0b,afaclinb     ! surface 1 -> axis
!
!  controls for spline boundary conditions
!
  integer :: ibc_axis        ! axial boundary conditions
  real*8  :: zbc_axis        ! axial BC data item
  integer :: ibc_edge        ! edge boundary condition
  real*8  :: zbc_edge        ! edge BC data item
!
!  extrapolation over-ride controls
!
  integer :: ival_axis       ! axial value over-ride flag
  real*8  :: zval_axis       ! axial over-ride value
  integer :: ival_edge       ! edge value over-ride flag
  real*8  :: zval_edge       ! edge over-ride value
!
!  extrapolation limit controls --
!    don't let extrapolation change sign or get too close to zero
!
  integer :: isign_check     ! check that extrapolation doesn't change sign
  real*8  :: zsign_lim       ! zsign_lim*(edge value) = nearest approach to 0.0
!
!  edge value means non-extrapolated value nearest to the edge.
!  -------------
!  TRANSP run id
!
  character(40) :: run_label
!
!  tokamak id
!
  character(4) :: tdev
!
!  time information
!
  real :: tmin               ! minimum time in run
  real :: tmax               ! maximum time in run
!
  real, dimension(:), allocatable :: time_sc,time_pr,time_saw
  integer, dimension(:), allocatable :: kevent ! (indexed on scalar time grid)
  !  kevent(j) = 1 means: time_sc(j) at start of sawtooth;
  !  kevent(j) = 2 means: time_sc(j) at end of sawtooth; event at time_saw(j).
  !  kevent(j) = 0 means: between sawteeth, or, unknown

  integer :: itset           ! flag that slice time has been set (=1 if so)
  real :: time0              ! time of interest
  real :: delta_t            ! +/- delta_t, time to average over
!
! units information
!
  integer, parameter :: maxid=4096
!
  integer xaxis_id(maxid)          ! xplasma x-axis id for 1d objects
  character(10) prof_units(maxid)  ! units label, vs. xplasma id#
  integer units_status(maxid)      ! status code
!   -1 = undefined
!    0 = OK, MKS conversion succeeded
!    1 = MKS conversion failed, original TRANSP units & label are used.
  integer prof_iord(maxid)         ! interp. order -- e.g. 1 for Hermite
!
!--------------------------------------
! TRANSP data file access information

  logical :: mds_arch_flag  ! =.TRUE. -- using MDS+ TRANSP data
  character*120 file_path   ! path to TRANSP files (if mds_sock_id = 0)

end module trx_module

subroutine tdb_ccwchk(d,i_bccw,i_jccw)
  !
  ! if available in trdatbuf object, set direction of B_phi and J_phi...
  !
  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  !  ccw means "counter-clockwise looking down from above"
  integer, intent(out) :: i_bccw  ! 1: ccw, -1: cw, 0: unspecified (B_phi)
  integer, intent(out) :: i_jccw  ! 1: ccw, -1: cw, 0: unspecified (J_phi)

  i_bccw=0
  i_jccw=0

  if(abs(d%DATBUF(3)).gt.0.1) then
     if(d%DATBUF(3).gt.0.0) then
        i_bccw=1
     else
        i_bccw=-1
     endif
  endif
  
  if(abs(d%DATBUF(4)).gt.0.1) then
     if(d%DATBUF(4).gt.0.0) then
        i_jccw=1
     else
        i_jccw=-1
     endif
  endif

end subroutine tdb_ccwchk

C-------------------------------------------------------------------
C  TDB_PRFLAX
C  D. MC CUNE 10JUN-1982
C  ADD ON TO ELECTRON DATA PROFILE SYMMETRIZATION SYSTEM--
C  REPLACE FLATSPOTS IN THE UNSYMMETRIZED PROFILE WITH VERY
C  GENTLE SLOPES, PRIOR TO CARRYING OUT SYMMETRIZATION OPERATION
C
      SUBROUTINE TDB_PRFLAX(DATA,N)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER n,i,il,ilp1,ist,istm1,ifin,imid,inum,iabs,isign
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ztol,dtol,dstm1,dsum,dfnp1,davg,dinc,dnew,dav2,dcen0
!============
      real*8 DATA(N)
C
      DATA ZTOL/1.E-5_R8/
C  DEFINE TOLERANCE FOR DETERMINING FLATNESS
      DTOL=0.0_R8
      DO 10 I=1,N
      DTOL=max(DTOL,ABS(DATA(I)))
 10   CONTINUE
C  ZTOL* MAX MODULUS
      DTOL=ZTOL*DTOL
C-----
C  LOCATE ALL FLAT SPOTS
      IL=0
 20   CONTINUE
      IL=IL+1
      IF(IL.GE.N) GO TO 500
C  TEST FOR FLATSPOT
      ILP1=IL+1
      IF(ABS(DATA(ILP1)-DATA(IL)).GT.DTOL) GO TO 20
C  START OF FLATSPOT DETECTED
      IST=IL
      ISTM1=IL-1
      DSTM1=0.0_R8
      IF(ISTM1.GT.0) DSTM1=DATA(ISTM1)
      DSUM=DATA(IL)
C  FIND END OF FLATSPOT
 30   CONTINUE
      IL=IL+1
      DSUM=DSUM+DATA(IL)
      IF(IL.GE.N) GO TO 100
      ILP1=IL+1
      IF(ABS(DATA(ILP1)-DATA(IL)).LE.DTOL) GO TO 30
C  END OF FLATSPOT FOUND
 100  CONTINUE
      DFNP1=0.0_R8
      IF(IL.LT.N) DFNP1=DATA(ILP1)
      IFIN=IL
      IMID=(IST+IFIN)/2
C
      INUM=IFIN-IST+1
      DAVG=DSUM/INUM
C
C  DECIDE ON SKEWED STRAIGHT LINE OR TRIANGLE PATTERN TO REPLACE
C  DATA FLATSPOT
      IF(ABS(DSTM1-DFNP1).LE.DTOL) GO TO 200
C  SKEWED STRAIGHT LINE REPLACEMENT
      DINC=DTOL/INUM
      ISIGN=1
      IF(DFNP1.LT.DSTM1) ISIGN=-1
C
      DO 150 I=IST,IFIN
      DNEW=ISIGN*(I-IMID)*DINC + DAVG
      DATA(I)=DNEW
 150  CONTINUE
C  RE-ENTER LOOP TO CHECK FOR MORE FLATSPOTS
      GO TO 20
C  TRIANGULAR PATTERN REPLACEMENT
 200  CONTINUE
      DAV2=.5_R8*(DSTM1+DFNP1)
      ISIGN=1
      IF(DAV2.LT.DAVG) ISIGN=-1
      DINC=DTOL/INUM
      DCEN0=DAVG-0.25_R8*ISIGN*INUM*DINC
C
      DO 250 I=IST,IFIN
      DNEW=DCEN0+ISIGN*IABS(IMID-I)*DINC
      DATA(I)=DNEW
 250  CONTINUE
C  REENTER LOOP TO FIND FLATSPOTS
      GO TO 20
C-----
C  EXIT
 500  CONTINUE
      RETURN
      END

subroutine ps_species_list_get(iobj, listname, iauthor, dim1, dim2, &
     elem_names, qatoms, qvals, mvals, itypes, max_prior, alt_component, &
     iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! fetch a species list, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: listname    ! NAME of list to fetch

  integer, intent(in) :: iauthor           ! author ID (checked if non-zero)

  integer, intent(in) :: dim1,dim2         ! array dimension limits

  character*(*), intent(out) :: elem_names(dim1:dim2) ! specie names

  REAL(kind=rspec), intent(out) :: qatoms(dim1:dim2)  ! atomic charges (C)
  REAL(kind=rspec), intent(out) :: qvals(dim1:dim2)   ! specie charges (C)
  REAL(kind=rspec), intent(out) :: mvals(dim1:dim2)   ! specie masses (kg)
  integer, intent(out) :: itypes(dim1:dim2)           ! specie type

  integer, intent(in) :: max_prior         ! max prior names
  character*(*), intent(in) :: alt_component(max_prior) ! prior component names

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: ielems,ie,iz,itype
  character*32 units,section
  character*128 tmp_label
  integer, dimension(:), allocatable :: ivals
  REAL(kind=rspec), dimension(:), allocatable :: r8vals
  character*80, dimension(:), allocatable :: chvals

  character*32 dummy_altlist(max_prior)
  character*32 dummy_altelems(max_prior,dim1:dim2)

  !--------------------------------------------------

  if(dim2.lt.dim1) then
     ierr=901
     write(iout,*) ' ?ps_species_list_get: dimensioning error:'
     write(iout,*) '  list dimension lower limit: ',dim1
     write(iout,*) '  list dimension upper limit: ',dim2
     return
  endif

  !--------------------------------------------------
  !  set up to use ps_list_get call

  dummy_altlist = ' '
  dummy_altelems = ' '

  allocate(ivals(dim1:dim2),r8vals(dim1:dim2),chvals(dim1:dim2))

  ielems = dim2 - dim1 + 1

  section = 'SPECIES_LIST'
  units = '*'
  elem_names = '*'

  call ps_list_get(section, iobj, listname, &
       iauthor, units, tmp_label, &
       max_prior, dummy_altlist, alt_component, &
       ielems, elem_names, dummy_altelems, ivals, r8vals, chvals, &
       iout, ierr)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_species_list_get: error code = ',ierr
     write(iout,*) '  returned by ps_list_get call.'
     return
  endif

  qvals = ps_xe * ivals   ! convert charge count (Z) to charge (C).

  mvals = ps_mp * r8vals  ! convert atomic weight, AMU, to mass (kg).

  do ie=dim1,dim2
     read(chvals(ie),'(2x,i3,6x,i3)') iz,itype
     qatoms(ie) = ps_xe * iz
     itypes(ie) = itype
  enddo

end subroutine ps_species_list_get

!
!  connect to a TRANSP run.
!
!---------------------------------------------------------------
subroutine trx_connect(path,ierr)
!
!  ** fortran interface **
!
  use trx_module
  implicit NONE
!
!  connect to a TRANSP run at specified "path:"
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(IN) :: path   ! path / runid
  integer, intent(OUT) :: ierr       ! completion code, 0=OK
!
!    MDS+ path syntax:
!                 MDS+:<server-name>:<tree-name>(<shot-number>) or
!                 MDS+:<server-name>:<tree-name>(<tok.yy>,<runid>)
!
!    file path syntax:  <path>/<runid> or just <runid>
!
!--------------------------
!  local:
  character(64) :: zlbl
  character(32) :: zuns
  character(10) :: zxabb(8)
!
  integer imulti,istype,idims(10),irank,ilen
!
  integer lunzer
!
  integer, parameter :: maxa1=5001
  real*8 :: array1(maxa1)
  real*8 :: ztime
  real*8, parameter :: ZERO = 0.0d0
!
  logical :: iexist
!
!--------------------------
! ...initialize, then,
! ...use trread routine; set stats on run size...
!
  call trx_init
!
  call kconnect(path,run_label,nsctime,nprtime,nxmax,nmax, ierr)
  if(ierr.ne.0) then
     call trx_init
     return
  endif

  mds_arch_flag = (path(1:4).eq.'MDS+')

  if(.NOT.mds_arch_flag) then
     call ufilnam(path(6:),' ',file_path)
     !  remove trailing "/": path string ends in runid, not subdirectory
     ilen = len(trim(file_path))
     if(file_path(ilen:ilen).eq.'/') file_path(ilen:ilen)=' '
  else
     file_path = ' '
  endif

!
! get better labels...
!
  call tget_rlbl(tdev,run_label)
!
! OK... set tmin & tmax
!
  call trx_connect_tlims(ierr)
  if(ierr.ne.0) return
!
! OK... set no. of flux surfaces...
!
!
  call rplabel('XB',zlbl,zuns,imulti,istype)
  if(istype.le.0) then
     write(lunzer(0),*) ' ?trx_connect:  no "XB" profile in run:  ',run_label
     ierr=1
     return
  else
     itype_xb=istype
  endif
!
  call rpdims(istype,irank,idims,zxabb,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) ' ?trx_connect:  "rpdims" error in run:  ',run_label
     ierr=1
     return
  endif
!
  nsurf=idims(1)+1
  call eqm_select('trx_connect',1)  ! clear xplasma
!
! also:  get X axis type id
!
  call rplabel('X',zlbl,zuns,imulti,istype)
  if(istype.le.0) then
     write(lunzer(0),*) ' ?trx_connect:  no "X" profile in run:  ',run_label
     ierr=1
     return
  else
     itype_x=istype
  endif
!
!-----------------------------------------
! check for free boundary data

  write(lunzer(0),*) ' %trx_connect: probing for free boundary data.'

  ztime = 0.5d0*(tmin+tmax)

  call rpexist_profile('RGRID',iexist)
  if(iexist) then
     call r8_t1profil('RGRID',zlbl,zuns,ztime,ZERO, &
          istype,array1,maxa1,nRfree,ierr)
     allocate(Rgrid_free(nRfree))
     Rgrid_free = array1(1:nRfree)*0.01_R8  ! -> m

     call r8_t1profil('ZGRID',zlbl,zuns,ztime,ZERO, &
          istype,array1,maxa1,nZfree,ierr)
     if(ierr.ne.0) then
        write(lunzer(0),*) &
             ' ?trx_connect: unexpected ZGRID read error after RGRID OK.'
        call trx_init
        ierr=1
        return
     endif

     allocate(Zgrid_free(nZfree))
     Zgrid_free = array1(1:nZfree)*0.01_R8  ! -> m
     
     allocate(PsiRZ_free(nRfree,nZfree)); PsiRZ_free = ZERO

     ifound_psi0=0
     call rpexist_scalar('PSI0_TR',iexist); if(iexist) ifound_psi0=1
  else
     ierr=0
     write(lunzer(0),*) ' (no free boundary data).'
  endif

  return
end subroutine trx_connect
!--------------------------------------------
subroutine trx_connect_tlims(ierr)
!
!  fetch time limits
!
  use trx_module
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer ierr
!
! temporary array for sawtooth times
!
  integer iret
  integer lunzer
!
  logical :: iexist
  integer :: it,jt
!------------------------------
!
  ierr=0
!
  if(allocated(time_sc)) then
     deallocate(time_sc,time_pr,time_saw,kevent)
  endif

  allocate(time_sc(nsctime),time_saw(nsctime),time_pr(nprtime))
  allocate(kevent(nsctime)); kevent = 0

  call rptime_s(time_sc,nsctime,iret)
  if(iret.ne.nsctime) then
     write(lunzer(0),*) ' ?trx_connect:  internal inconsistency!'
     write(lunzer(0),*) '  nsctime = ',nsctime,' ...but, iret = ',iret
     ierr=1
     return
  endif
  tmin=time_sc(1)
  tmax=time_sc(nsctime)
!
  call rptime_p(time_pr,nprtime,iret)
  if(iret.ne.nprtime) then
     write(lunzer(0),*) ' ?trx_connect:  internal inconsistency!'
     write(lunzer(0),*) '  nprtime = ',nprtime,' ...but, iret = ',iret
     ierr=1
     return
  endif
  tmin=min(tmin,time_pr(1))
  tmax=max(tmax,time_pr(nprtime))
!
!  see if sawtooth times are available
  call rpexist_scalar('tlastsaw',iexist)
  jt = 0
  if(iexist) then
     call rpscalar('tlastsaw',time_saw,nsctime,iret,ierr)
     do it=2,nsctime
        if(time_saw(it).gt.time_saw(it-1)) then
           kevent(it)=2
           kevent(it-1)=1
           jt = jt + 1
        endif
     enddo
  endif
  if(jt.eq.0) then
     write(lunzer(0),*) ' %trx_connect_tlims: no sawteeth found.'
  else
     write(lunzer(0),*) ' %trx_connect_tlims: found ',jt,' sawteeth.'
  endif

  return
end subroutine trx_connect_tlims
!----------------------------------------------------------------------------
subroutine trx_init_xplasma(ierr)
!
!  read rho-axis (TRANSP XB data)
!
  use trx_module
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer, intent(OUT) :: ierr       ! completion code, 0=OK
!
  real zbuf(nsurf)  ! standard profiles
  real zbufr(nxmax) ! profiles vs. major radius
!
  real*8 zrho(nsurf+1),zdavg,zsq1,zsq2,zrho1,zrho2,zconv,ztime_r8
  real*8 zbufr8(nxmax)
!
  character(64) zlbl
  character(32) zuns
!
  integer istype,imax,igot,ieven,i,iwarn
  integer lunzer
!
!----------------------------
! re-initialize xplasma & trxplib units data
!
  units_status = -1
  xaxis_id = -1
  prof_units = ' '
  prof_iord = -1
!
! ...will read 2d axisymmetric transp mhd eq.
  call eqm_select('transp(trxplib) '//trim(run_label),1)
  ztime_r8 = time0
  call eqm_time(ztime_r8)
!
! ---> create grid of flux surfaces, augment TRANSP data w/ mag. axis
!
  imax=nsurf-1
  call t1profil('XB',zlbl,zuns,time0,delta_t, &
       & istype,zbuf,imax,igot,ierr)
  if(ierr.ne.0) return
!
  zrho(1)=0.0_R8
  zrho(2:nsurf-1)=zbuf(1:imax-1)   ! copy & convert to REAL*8
  zrho(nsurf)=1.0_R8               ! but make sure =1 at bdy
!
  call eqm_rho(zrho,nsurf,1.0e-4_R8,id_rho,ierr)
!
!  ---> create complementary grid of flux zone ctrs augmented with mag. axis
!  and plasma bdy
!
  call t1profil('X',zlbl,zuns,time0,delta_t, &
       & istype,zbuf,imax,igot,ierr)
  if(ierr.ne.0) return
!
  zrho(1)=0.0_R8
  zrho(2:nsurf)=zbuf(1:imax)   ! copy & convert to REAL*8
  zrho(nsurf+1)=1.0_R8
!
  call eqm_uaxis('rho_zc',id_rho,0,zrho,nsurf+1,1.0e-6_R8,id_rhozc,ierr)
!
! ---> extrapolation factors
!
  ieven=1
  zdavg=(zrho(nsurf)-zrho(1))/imax
  do i=1,imax
     if(abs(zdavg-(zrho(i+1)-zrho(i))).gt.(1.0E-4_R8*imax*zdavg)) ieven=0
  enddo
  if(ieven.eq.1) then
     afac0b=1.0E0_R8/3.0E0_R8
     afaclinb=1.0E0_R8
     afac0=1.0E0_R8/8.0E0_R8
     afaclin=0.5E0_R8
     efac0=afac0
     efaclin=afaclin
  else
     zsq1=(zrho(2)-zrho(1))**2
     zsq2=(zrho(3)-zrho(1))**2
     afac0b=zsq1/(zsq2-zsq1)
     afaclinb=(zrho(2)-zrho(1))/(zrho(3)-zrho(2))
!
     zrho1=0.5_R8*(zrho(1)+zrho(2))
     zrho2=0.5_R8*(zrho(2)+zrho(3))
     zsq1=(zrho1-zrho(1))**2
     zsq2=(zrho2-zrho(1))**2
     afac0=zsq1/(zsq2-zsq1)
     afaclin=(zrho1-zrho(1))/(zrho2-zrho1)
!
     zrho1=0.5_R8*(zrho(nsurf-1)+zrho(nsurf))
     zrho2=0.5_R8*(zrho(nsurf-2)+zrho(nsurf-1))
     zsq1=(zrho(nsurf)-zrho1)**2
     zsq2=(zrho(nsurf)-zrho2)**2
     efac0=zsq1/(zsq2-zsq1)
     efaclin=(zrho(nsurf)-zrho1)/(zrho1-zrho2)
  endif
!
! ---> major radius grids (optional): standard grid, TRDAT grid
!
  call t1profil('RMAJM',zlbl,zuns,time0,delta_t, &
       & istype,zbufR,nxmax,igot,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          & 'trx_init_xplasma warning: RMAJM (major radius) grid: not found.'
     ierr=0  ! OK
     return
  endif
  call trx_mks_conv('RMAJM',zconv,zuns,iwarn)
!
  zbufR8(1:igot)=zconv*zbufR(1:igot)
  call eqm_uaxis('Rmajm',0,0,zbufR8,igot, &
       & 1.0e-6_R8*zbufR8(igot),id_rmajm,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          & 'trx_init_xplasma warning: eqm_uaxis error on RMAJM.'
     ierr=0
     return
  endif
  itype_rmajm=istype
  nrmajm=igot
!
! TRDAT grid
!
  call t1profil('RMJSYM',zlbl,zuns,time0,delta_t, &
       & istype,zbufR,nxmax,igot,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          & 'trx_init_xplasma warning: RMJSYM (major radius) grid: not found.'
     ierr=0  ! OK
     return
  endif
  call trx_mks_conv('RMJSYM',zconv,zuns,iwarn)
!
  zbufR8(1:igot)=zconv*zbufR(1:igot)
  call eqm_uaxis('Rmjsym',0,0,zbufR8,igot, &
       & 1.0e-6_R8*zbufR8(igot),id_rmjsym,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          & 'trx_init_xplasma warning: eqm_uaxis error on RMJSYM.'
     ierr=0
     return
  endif
  itype_rmjsym=istype
  nrmjsym=igot
 
  return
end subroutine trx_init_xplasma

C-----------------------------------------------------------------------
C  TDB_SYMXMAP -- MAP ECE FREQUENCIES TO NORMALIZED RADIUS FOR PRESYMMETRIZ-
C    ATION OF ECE DATA
C
C  modularization -- DMC May 2005
C
C  R vector defined from frequency vector of ECE data, using vacuum map,
C  for presymmetrization purposes.  The data will be symmetrized to a
C  coordinate of relative midplane aspect ratio, but in the context of
C  ECE data this becomes ratio ((1/B1)-(1/B2))/((1/B1)+(1/B2)) and will
C  be interpreted at such when the presymmetrized data is used-- i.e.
C  by this means presymmetrization can be done early, in trdat, before
C  internal adjustments to the field strength are known...
C
C  at end the nominal R is converted to the usual x = (R-Rmaj)/Rmin
C
C  (DMC June 2005)
C
      SUBROUTINE TDB_SYMXMAP(d,zr1,zr2,zrbz,ILX,INX,IWORK)
C
      use trdatbuf_obj
      IMPLICIT NONE

      type (trdatbuf) :: d
      real*8, intent(in) :: zrbz ! external (R*Bz) used for B estimate here.
      real*8, intent(in) :: zr1,zr2 ! midplane bdy intercept locations
      integer, intent(in) :: ilx ! address of frequencies
      integer, intent(in) :: inx ! no. of frequencies
      integer, intent(in) :: iwork ! where to put corresponding midplane coord

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  PASSED INPUT
C  ------------
C    ILX   -- ADDRESS OF ECE FREQUENCIES
C    INX   -- NUMBER OF ECE FREQUENCIES
C    IWORK -- ADDRESS WHERE CORRESPONDING RADII MAY BE STORED
C
C  OUTPUT TO WORKBUF(IWORK ... IWORK+INX-1)
C
C  note DMC July 1992 -- to support calls from TRDAT debug test code,
C    allow the possibility that the time TG1 and TG2 profile quantities
C    below have not been computed, in which case the arrays BIMDP1 and
C    BMIDP2 are assumed to contain the B field data, set up by the
C    TRDAT test code.
C
C-----------------------------------------------------------------------
C  local...
      integer :: ix
      real*8 :: zfreq,zbfreq,zrfreq,zzrmaj,zzrmin,zx
C
C-----------------------------------------------------------------------
C
C  MAP THE FREQUENCIES to vacuum field based "major radii"
C
      zzrmaj=(zr2+zr1)/2
      zzrmin=(zr2-zr1)/2
C
      DO 300 IX=1,INX           ! scan frequencies (low->high)
         ZFREQ=d%DATBUF(ILX+IX-1)
         ZBFREQ=ZFREQ/(28.0_R8*d%NHECFT)
         ZRFREQ=ZRBZ/ZBFREQ
C
C  SO THE CORRESPONDING X VALUE IS...
C
         ZX=(ZRFREQ-ZZRMAJ)/ZZRMIN
C
C  SAVE IN REVERSED ORDER
C
         d%WORKBUF(IWORK+INX-IX)=ZX ! (low->high; R ~ 1/f roughly)
C
 300  CONTINUE
C
      RETURN
      END

subroutine ps_intrp2(nvec,xvec1,xvec2,id,iobj,ideriv1,ideriv2,iccw_th, &
     ansvec,iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 13 Oct 2006
  !
  ! XPLASMA2 implementation of plasma_state subroutine
  ! interpolate a 2d profile to a vector of target points.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer, intent(in) :: nvec  ! size of interpolation target vector
  REAL(KIND=rspec), intent(in) :: xvec1(nvec),xvec2(nvec)
         ! interpolation target vector (2d)

  integer, intent(in) :: id    ! profile ID

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: ideriv1,ideriv2   ! derivative control:
  !  0 for profile value; 1 for d[profile]/dx; 2 for d2[profile]/dx2
  !  1 control for each coordinate

  integer, intent(in) :: iccw_th  ! poloidal angle orientation control (CCW)

  REAL(KIND=rspec), intent(out) :: ansvec(nvec)  ! interpolation results

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  integer :: igrid1,igrid2,icoord1,icoord2,irank
  logical :: jccw1,jccw2
  character*32 :: profname

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_intrp2: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_prof_info(s,id,ierr, name=profname, gridId1=igrid1, &
       gridId2=igrid2,rank=irank)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp2: xplasma_prof_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  if(irank.ne.2) then
     write(iout,*) ' ?ps_intrp2: profile id=',id,' name="',trim(profname), &
          '" has rank: ',irank
     write(iout,*) '  This profile cannot be evaluated by 2d interpolation.'
     ierr=77
     return
  endif

  call xplasma_grid_info(s,igrid1,ierr, coord=icoord1)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp2: xplasma_grid_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  call xplasma_grid_info(s,igrid2,ierr, coord=icoord2)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp2: xplasma_grid_info call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

  if(icoord1.eq.xplasma_theta_coord) then
     jccw1 = (iccw_th.ne.ps_ccw_reverse)
  else
     jccw1 = .TRUE.
  endif

  if(icoord2.eq.xplasma_theta_coord) then
     jccw2 = (iccw_th.ne.ps_ccw_reverse)
  else
     jccw2 = .TRUE.
  endif

  call xplasma_eval_prof(s,id,icoord1,xvec1,icoord2,xvec2,ansvec,ierr, &
       ideriv1=ideriv1,ideriv2=ideriv2,ccwflag1=jccw1,ccwflag2=jccw2)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_intrp2: xplasma_eval_prof call failed:'
     call xplasma_error(s,ierr,iout)
     ierr=77
     return
  endif

end subroutine ps_intrp2

subroutine splitn_lunset(ilun)

  use splitn_module
  implicit NONE

  ! set FORTRAN LUN for splitn i/o operations

  integer, intent(in) :: ilun

  lun = ilun

end subroutine splitn_lunset

subroutine splitn_lunget(jlun)

  use splitn_module
  implicit NONE

  ! get FORTRAN LUN for splitn i/o operations

  integer, intent(out) :: jlun

  jlun = lun

end subroutine splitn_lunget

c------------------------------------------------------------
c  these routines write the GS2 namelist, generally by inserting
c  or replacing records at key points in a template file.
c------------------------------------------------------------
      subroutine trxpl_nlist_find(luni,lparams,lzeff,lbeta,lsknobs,
     >     lgrid,lgrd2)
c
c  find record number of key namelists in template file
c  when done, rewind the file.
c
      use trxpl_gs2_module
      implicit NONE
c
      integer, intent(in) :: luni       ! file lun
      integer, intent(out) :: lparams   ! parameters namelist (0 if not found)
      integer, intent(out) :: lzeff     ! zeff= line in parameters namelist
      integer, intent(out) :: lbeta     ! beta= line in parameters namelist
      integer, intent(out) :: lsknobs   ! species_knobs namelist or 0
      integer, intent(out) :: lgrid(4)  ! grid namelist (all 0 if not found)
c                lgrid(1), whole namelist
c                lgrid(2), irho record
c                lgrid(3), iflux record
c                lgrid(4), local_eq record

      integer, intent(out) :: lgrd2(2)  ! grd2 namelist (all 0 if not found)
c                lgrd2(1), whole namelist
c                lgrd2(2), rhoc record
c
c------------------------------------
c
      integer irec
      character*128 zline
      integer i,inb,ieqs,ilen
      character*50 ztest1,ztest2
      logical iflag                     ! .TRUE.:  seek zeff= line...
      logical jflag                     ! .TRUE.:  seek irho,iflux,local_eq...
      logical kflag                     ! .TRUE.:  seek rhoc= line...
      logical inlist                    ! .TRUE.:  inside namelist...
c
c------------------------------------
c
      iflag=.FALSE.
      jflag=.FALSE.
      kflag=.FALSE.
      inlist=.FALSE.
      irec=0
c
      lparams=0
      lzeff=0
      lbeta=0
      lsknobs=0
      lgrid=0
      lgrd2=0
c
      do
c
         read(luni,'(A)',end=99) zline
         irec=irec+1
         ilen=len_trim(zline)
c
         inb=0
         do i=1,ilen
            if((zline(i:i).ne.' ').and.(zline(i:i).ne.char(9))) then
               inb=i
               exit
            endif
         enddo
         if(inb.eq.0) cycle
c
         if(inlist) then
c
c  inside a namelist... look for end
            if(zline(inb:inb).eq.'/') then
               inlist=.FALSE.
               iflag=.FALSE.
               jflag=.FALSE.
            else
               if(iflag) then
c
c  look for zeff= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='ZEFF'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lzeff=irec      ! found the "zeff=" line
                     endif
                  endif
c
c  look for beta= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='BETA'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lbeta=irec      ! found the "zeff=" line
                     endif
                  endif
 
               else if(jflag) then
c
c  look for irho= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='IRHO'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lgrid(2)=irec ! found the "irho=" line
                     endif
                  endif
c
c  look for iflux= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='IFLUX'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lgrid(3)=irec ! found the "iflux=" line
                     endif
                  endif
c
c  look for local_eq= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='LOCAL_EQ'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lgrid(4)=irec ! found the "local_eq=" line
                     endif
                  endif
               else if(kflag) then
c
c  look for rhoc= line...
c
                  ieqs=index(zline,'=')
                  if(ieqs.gt.0) then
                     ztest1='RHOC'
                     ztest2=zline(inb:ieqs-1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lgrd2(2)=irec ! found the "rhoc=" line
                     endif
                  endif
               endif            ! iflag/jflag/kflag tests

            endif               ! "/" test
c
         else
c
c  looking for a namelist...
c
            if(zline(inb:inb).eq.'&') then
c
c  got one...
c
               inlist=.TRUE.
               i=index(zline(inb:ilen+1),' ')+inb-2
               ztest1=nlist_zeff
               ztest2=zline(inb+1:i)
               call uupper(ztest1)
               call uupper(ztest2)
               if(ztest1.eq.ztest2) then
                  lparams=irec          ! "parameters" namelist
                  iflag=.TRUE.
               else
                  ztest1=nlist_nspc
                  call uupper(ztest1)
                  if(ztest1.eq.ztest2) then
                     lsknobs=irec
                  else
                     ztest1=nlist_grid
                     call uupper(ztest1)
                     if(ztest1.eq.ztest2) then
                        lgrid(1)=irec
                        jflag=.TRUE.
                     else
                        ztest1=nlist_grd2
                        call uupper(ztest1)
                        if(ztest1.eq.ztest2) then
                           lgrd2(1)=irec
                           kflag=.TRUE.
                        endif
                     endif
                  endif
               endif
c
            endif                       ! "&" test
         endif
c
      enddo
c
 99   continue
      rewind(luni)
      return
c
      end
 
c------------------------------------------------------------
      subroutine trxpl_nlist_copy(luni,luno,lparams,lzeff,lbeta,lsknobs,
     >     lgrid,lgrd2)
c
c copy from template to output file-- pause when data needs to be inserted
c
      use trxpl_gs2_module
      implicit NONE
c
      integer luni                      ! LUN of open template file
      integer luno                      ! LUN of open namelist output file
c
      integer lparams                   ! record # of parameters namelist or 0
      integer lzeff                     ! record # of zeff= record or 0
      integer lbeta                     ! record # of beta= record or 0
      integer lsknobs                   ! record # of species_knobs nl or 0
      integer :: lgrid(4)               ! grid namelist (all 0 if not found)
c                lgrid(1), whole namelist
c                lgrid(2), irho record
c                lgrid(3), iflux record
c                lgrid(4), local_eq record
      integer :: lgrd2(2)               ! grd2 namelist (all 0 if not found)
c                lgrd2(1), whole namelist
c                lgrd2(2), rhoc record
c
c----------------------------------------------
c
      integer irec
      character*128 zline
      integer i,j,inb,ilen
      logical lskip,prev_blank
c
      character*50 ztest1,ztest2
c
c----------------------------------------------
c
      lskip=.FALSE.
      prev_blank=.FALSE.
c
      irec=0
c
      do
         read(luni,'(A)',end=99) zline
         irec=irec+1
         ilen=len_trim(zline)
c
         if(irec.eq.lgrid(2)) then
            write(luno,'(1x,a,"  !_trxpl")') irho_lbl//' 1'
            prev_blank=.FALSE.
         else if(irec.eq.lgrid(3)) then
            write(luno,'(1x,a,"  !_trxpl")') iflux_lbl//' 1'
            prev_blank=.FALSE.
         else if(irec.eq.lgrid(4)) then
            write(luno,'(1x,a,"  !_trxpl")') lqeq_lbl//' .FALSE.'
            prev_blank=.FALSE.
         else if(irec.eq.lgrd2(2)) then
            write(luno,'(1x,a,1pe19.12,"  !_trxpl")') irhoc_lbl,transp_x
            prev_blank=.FALSE.
         else if(irec.eq.lzeff) then
c  replace "zeff=" line with trxpl version; this is inside the &parameters
c  namelist
            write(luno,'(1x,a,1pe19.12,"  !_trxpl")') zeff_lbl,zeff_calc
            prev_blank=.FALSE.
            cycle
         else if(irec.eq.lbeta) then
c  replace "beta=" line with trxpl version; this is inside the &parameters
c  namelist
            write(luno,'(1x,a,1pe19.12,"  !_trxpl")') beta_lbl,beta
            prev_blank=.FALSE.
            cycle
         else if((irec.eq.lparams).and.
     >         ((lzeff.eq.0).or.(lbeta.eq.0)) ) then
            if(lzeff.eq.0) then
c  there was no "zeff=" line to replace, so, insert it here at the
c   beginning of the &parameters namelist
               write(luno,'(A)') zline(1:ilen)
               write(luno,'(1x,a,1pe19.12,"  !_trxpl")')
     >            zeff_lbl,zeff_calc
               prev_blank=.FALSE.
            endif
            if(lbeta.eq.0) then
c  there was no "beta=" line to replace, so, insert it here at the
c   beginning of the &parameters namelist
               write(luno,'(A)') zline(1:ilen)
               write(luno,'(1x,a,1pe19.12,"  !_trxpl")')
     >            beta_lbl,beta
               prev_blank=.FALSE.
            endif
            cycle
         else if(irec.eq.lsknobs) then
c  &species_knobs namelist found.
            lskip=.TRUE.
c  if there was no &parameters namelist, write one here.
c  write the &species_knobs and the &species_parameters_* namelists now
            call trxpl_nlist_write_all(luno,
     >           (lparams.eq.0),(lgrid(1).eq.0),(lgrd2(1).eq.0))
            prev_blank=.FALSE.
            cycle
c
         else
c
c  ordinary record... copy unless skip flag is set.
c  set skip flag if this is a &species_parameters_* namelist record
c  clear skip flag if this is an end-of-namelist record.
c
c  find first nonblank...
c
            inb=0
            do i=1,ilen
               if((zline(i:i).ne.' ').and.(zline(i:i).ne.char(9))) then
                  inb=i
                  exit
               endif
            enddo
c
c  inb= address of first nonblank, or, zero if the whole line is blank
c
            if(lskip) then
               if(inb.gt.0) then
                  if(zline(inb:inb).eq.'/') then
                     lskip=.FALSE.      ! clear:  end-of-namelist record.
                  endif
               endif
c
               cycle                    ! no write
c
            else
c
c  no skip flag-- will write, unless this line starts a &species_parameters
c  namelist.  So... check for namelist record
c
               if(inb.gt.0) then
                  if(zline(inb:inb).eq.'&') then
                     i=len_trim(nlist_root)
                     ztest1=nlist_root
                     ztest2=zline(inb+1:inb+i)
                     call uupper(ztest1)
                     call uupper(ztest2)
                     if(ztest1.eq.ztest2) then
                        lskip=.TRUE.    ! &species_parameter_* nl detected
                        cycle
                     endif
                  endif
               endif
c
c  fall through:  do copy the record, unless it is an old trxpl comment
c  record, or the 2nd blank record in a row...
c
               if(zline(1:8).ne.'!_trxpl:') then
                  if((inb.gt.0).or.(.not.prev_blank)) then
c
                     write(luno,'(A)') zline(1:ilen)
                     if(inb.eq.0) then
                        prev_blank=.TRUE.
                     else
                        prev_blank=.FALSE.
                     endif
c
c  write here any missing items in grid namelist
c
                     if(irec.eq.lgrid(1)) then
                        if(lgrid(2).eq.0) then
                           write(luno,'(1x,a,"  !_trxpl")') 
     >                          irho_lbl//' 1'
                        endif
                        if(lgrid(3).eq.0) then
                           write(luno,'(1x,a,"  !_trxpl")')
     >                          iflux_lbl//' 1'
                        endif
                        if(lgrid(4).eq.0) then
                           write(luno,'(1x,a,"  !_trxpl")')
     >                          lqeq_lbl//' .FALSE.'
                        endif
                     endif
c
                     if(irec.eq.lgrd2(1)) then
                        if(lgrd2(2).eq.0) then
                           write(luno,'(1x,a,1x,1pe19.12,"  !_trxpl")')
     >                          irhoc_lbl,transp_x
                        endif
                     endif
c
                  endif
               endif
               cycle
            endif
c
         endif                          ! record count match tests
      enddo
c
c  EOF
c
 99   continue
c
c  write data here, if necessary...
c
      if(lsknobs.eq.0) then
         call trxpl_nlist_write_all(luno,(lparams.eq.0),(lgrid(1).eq.0),
     >        (lgrd2(1).eq.0))
      endif
c
c  do not close files: this is done by caller
c
      return
      end
c------------------------------------------------------------------
      subroutine trxpl_nlist_write_all(luno,iflag,jflag,kflag)
c
c  write the GS2 namelist fragment
c
      use trxpl_gs2_module
      implicit NONE
c
      integer luno                      ! LUN where to write
      logical iflag                     ! .TRUE. to write &parameters namelist
c                                       ! ... with "zeff= ..." record
      logical jflag                     ! .TRUE. to write &theta_grid_eik_knobs
c                                       ! namelist with irho, iflux, local_eq
      logical kflag             ! .TRUE. to write &theta_grid_parameters
c                               ! namelist with "rhoc= ..." record
c-----------------------------
c
      integer i,j
c
c-----------------------------
      if(iflag) then
         i=len_trim(nlist_zeff)
         write(luno,1005) nlist_zeff(1:i),zeff_lbl,zeff_calc,
     >        beta_lbl,beta
      endif
c
 1005 format(/
     >     '&',a/
     >     1x,a,1pe19.12,'  !_trxpl'/
     >     1x,a,1pe19.12,'  !_trxpl'/
     >     '/')
c
      if(jflag) then
         write(luno,1006) trim(nlist_grid),irho_lbl//' 1',
     >        iflux_lbl//' 1',lqeq_lbl//' .FALSE.'
      endif
c
 1006 format(/
     >     '&',a/
     >     1x,a,'  !_trxpl'/
     >     1x,a,'  !_trxpl'/
     >     1x,a,'  !_trxpl'/
     >     '/')
c
      if(kflag) then
         write(luno,1007) trim(nlist_grd2),irhoc_lbl,transp_x
      endif
c
 1007 format(/
     >     '&',a/
     >     1x,a,1pe19.12,'  !_trxpl'/
     >     '/')
c
      i=len_trim(nlist_nspc)
      write(luno,1011) nlist_nspc(1:i),num_lbl,num_species
 1011 format(/
     >   '&',a/1x,a,i6,'  !_trxpl'/'/')
c
      do j=1,num_species
         call trxpl_mkgs2_write1(luno,j)
      enddo
c
      return
      end

      subroutine splitn_lhs(zlhs,imatch,indx,imaxrank,ierr)
C
C  parse LHS of namelist line
C  Find variable name, find indexing.
C
C   <namelist-name>[(indx1,indx2,...)] = RHS...
C
      use splitn_module
      implicit NONE
C
      character*(*),intent(in) :: zlhs  ! input line's LHS
C                         **NO leading or trailing blanks**
C
      integer, intent(out) :: imatch    ! output variable match index
C                ....0 if no match
C
      integer, intent(in) :: imaxrank    ! max rank of namelist variables
      integer, intent(out) :: indx(imaxrank) ! output start index (arrays only)
      integer, intent(out) :: ierr      ! status code: 0=OK
C
C--------------------
      integer ilen,i,iw1,iw2,ilparen,irparen,ilb
      integer ibefore,jj,irank,inumdim,ic,iprev,id,ir
      integer idcod_splitn
C
      character*50 ztest
      character*20 berr
C
      integer, parameter :: maxlen = 32  ! change to 32 to allow 32 char names
C
C--------------------
C
C  1.  find var. name; 1st non-blank...
C
      imatch=0
      do i=1,imaxrank
         indx(i)=0
      enddo
C
      ierr=0
C
      ilen=len(zlhs)
C
      iw1=1
C
      ilparen=index(zlhs,'(')

      if(ilparen.eq.0) then
         iw2=ilen
         irparen=0
      else
         irparen=ilen
         do i=ilparen-1,1,-1
            if((zlhs(i:i).ne.' ').and.(zlhs(i:i).ne.char(9))) then
               iw2=i
               exit
            endif
         enddo
         if(zlhs(irparen:irparen).ne.')') then
            write(6,*) ' ?splitn_lhs: closing parenthesis missing or ',
     >         'misplaced.'
            ierr=1
         endif
      endif
C
      ztest=zlhs(iw1:iw2)
      call uupper(ztest)
      if((iw2-iw1+1).gt.maxlen) then
         write(6,*) ' ?splitn_lhs: name too long or invalid: "',
     >      zlhs(iw1:iw2),'"'
         imatch=0
      else
         call iorder(ztest,ibefore,imatch)
      endif
      if(imatch.eq.0) then
         if(.NOT.is_deleted(ztest)) then
            write(6,*) ' ?splitn_lhs: unrecognized name in namelist: "',
     >           zlhs(iw1:iw2),'"'
            jj=var_order(ibefore)
            ierr=1
         else
            write(6,*) ' %splitn_lhs: commenting out deleted item: "',
     >           zlhs(iw1:iw2),'"'
         endif
      endif
C
      if(ierr.ne.0) return
      if(imatch.eq.0) return
C
      imatch=ibefore                    ! this is the item order#
C
      jj=var_order(imatch)
      irank=varlist(jj)%rank
C
C  steerability check
C
      if(kupdate.gt.0) then
         if(varlist(jj)%steerable.le.1) then
            write(6,*) 
     >           ' ?splitn_lhs: variable in update block not '//
     >           'updatable: "',zlhs(iw1:iw2),'"'
            write(6,'(a,1pe13.6)') '  ~UPDATE_TIME (sec) is: ',
     >           tup(kupdate)
            write(6,*) '    update block index: ',kupdate
            ierr=1
         endif
      endif
      if(ierr.ne.0) return
C
      do i=1,irank
         indx(i)=varlist(jj)%dims(1,i)
      enddo
C
C  OK have match & initial address.  Look for = sign or subscripts
C
      if(ilparen.eq.0) return  ! initial address OK
C
C  subscripts inside zlhs(ilparen:irparen)
C
      inumdim=0
      iprev=ilparen
      ic=ilparen
C
 60   continue
      ic=ic+1
      if(zlhs(ic:ic).eq.',') go to 70
      if(zlhs(ic:ic).eq.')') go to 70
      go to 60
C
 70   continue
      inumdim=inumdim+1
      if(inumdim.gt.irank) go to 98
      if(iprev+1.gt.ic-1) go to 99
      id=idcod_splitn(zlhs(iprev+1:ic-1),ierr)
      if(ierr.ne.0) go to 99
      indx(inumdim)=id
      if(zlhs(ic:ic).eq.')') then
         if(inumdim.lt.irank) go to 98
      else
         iprev=ic
         go to 60                       ! next dim
      endif
C
C  check subscript bounds
C
      do ir=1,irank
         berr='out of bounds low'
         if(indx(ir).lt.varlist(jj)%dims(1,ir)) go to 97
         berr='out of bounds high'
         if(indx(ir).gt.varlist(jj)%dims(2,ir)) go to 97
      enddo
C
C  successful decode of address.
C
 80   continue
C
      return
C
C  errors
C
 97   continue
      ilb=len_trim(berr)
      write(6,9701) ir,berr(1:ilb)
 9701 format(' ?splitn_lhs -- subscript bounds check error:'/
     >'  subscript #',i1,' is ',a,'.')
      ierr=1
      return
C
 98   continue
      write(6,'('' ?splitn_lhs -- wrong no. of subscripts.'')')
      ierr=1
      return
C
 99   continue
      write(6,'('' ?splitn_lhs -- decode error in subscript.'')')
      ierr=1
      return
C
      end

c-------------------------------------------------------------------
      subroutine trxpl_gs2_get(zrho,ierr)
c
c  get all GS2 parameters at a single flux surface location
c
      use trxpl_gs2_module
      implicit NONE
c
      real*8, intent(in) :: zrho        ! the flux surface location (btw 0 & 1)
      integer, intent(out) :: ierr      ! completion code, 0=OK
c
c---------------------------------------------------
c
      integer idlist_n(num_species),idlist_t(num_species)
c
      integer i,j,k
c
      real*8 zminm,coulog,nufac,zsum,zderiv,ztest
c
c---------------------------------------------------
c
      zminm=1.0d-4                      ! min n & T (instead of zero)
c
      call eq_rgetf(1,zrho,id_zeff,0,zeff_tr,ierr)
      if(ierr.ne.0) return
c
      do i=1,num_species
c
         upvec(i)=0
c
         if(id_zprof(i).ne.0) then
            call eq_rgetf(1,zrho,id_zprof(i),0,zvec(i),ierr)
            if(ierr.ne.0) return
         else
            zvec(i)=zplas(i)
         endif
c
         if(id_aprof(i).ne.0) then
            call eq_rgetf(1,zrho,id_aprof(i),0,avec(i),ierr)
            if(ierr.ne.0) return
         else
            avec(i)=aplas(i)
         endif
c
         if(nsmoo(i)) then
            idlist_n(i)=id_nsmoo(i)
         else
            idlist_n(i)=id_norig(i)
         endif
c
         if(tsmoo(i)) then
            idlist_t(i)=id_tsmoo(i)
         else
            idlist_t(i)=id_torig(i)
         endif
c
      enddo
c
      call eq_rgetff(1,zrho,num_species,idlist_n,0,1,nvec,ierr)
      if(ierr.ne.0) return
c
      call eq_rgetff(1,zrho,num_species,idlist_n,1,1,npvec,ierr)
      if(ierr.ne.0) return
c
      call eq_rgetff(1,zrho,num_species,idlist_t,0,1,tvec,ierr)
      if(ierr.ne.0) return
c
      call eq_rgetff(1,zrho,num_species,idlist_t,1,1,tpvec,ierr)
      if(ierr.ne.0) return
c
      nvec(1:num_species)=max(zminm,nvec(1:num_species))
      tvec(1:num_species)=max(zminm,tvec(1:num_species))
c
      npvec(1:num_species)=-npvec(1:num_species)/nvec(1:num_species)
      tpvec(1:num_species)=-tpvec(1:num_species)/tvec(1:num_species)
c
      tvec(1:num_species)=tconv(1:num_species)*tvec(1:num_species)
c
c  dZ/drho correction...
c
      do i=1,num_species
         if(id_zprof(i).ne.0) then
            call eq_rgetf(1,zrho,id_zprof(i),1,zderiv,ierr)
            if(ierr.ne.0) return
            npvec(i)=npvec(i)-zderiv/zvec(i)
         endif
      enddo
c
c renorm for precise quasineutrality -- hold electron data fixed
c densities:
      zsum=0.0d0
      do i=2,num_species
         zsum=zsum+nvec(i)*zvec(i)
      enddo
      zsum=nvec(1)/zsum
      nvec(2:num_species)=zsum*nvec(2:num_species)
      renorm_nz=zsum
c
c also for derivatives:
c
      ztest=(nvec(1)*npvec(1))
      if(zrho.eq.0.0d0) then
         zsum=1.0d0
      else
         zsum=0.0d0
         do i=2,num_species
            zsum=zsum+nvec(i)*zvec(i)*npvec(i)
         enddo
         sumnz_grad = zsum                   ! save in module
         ne_grad = ztest                     ! save in module
         if((1.d-20*zsum*ztest).le.0.0d0) then
            zsum=1.0d0
         else
            ztest=abs(ztest)
            zsum=abs(zsum)
            if(ztest.gt.1.5d0*zsum) then
               zsum=1.5d0
            else if(ztest.lt.(2.0d0/3.0d0)*zsum) then
               zsum=(2.0d0/3.0d0)
            else
               zsum=ztest/zsum
            endif
         endif
      endif
      npvec(2:num_species)=zsum*npvec(2:num_species)
      renorm_gradnz=zsum
c
c calculate zeff
c
      zeff_calc=0.0d0
      do i=2,num_species
         zeff_calc=zeff_calc+nvec(i)*zvec(i)*zvec(i)
      enddo
      zeff_calc=zeff_calc/nvec(1)
c
c  ok... now evaluate the collisionalities
c  using the formula in the GS2 namelist documentation
c
c  **electrons are species #1
c
c  **note assumption: nref=ne.
c  ****but**** Tref=Te **or** Tref=Ti is now allowed (dmc Jan 2003).
c
c     ==>it used to be that Tref=Te was hardwired.
c
c  reference density and temperature -- normalization applied *AFTER*
c  evaluation of collisionalities
c
      nref=nvec(num_refn)
      tref=tvec(num_reft)
c
c  electron collisionality -- note select use of Tref
c
      coulog = 15.94d0 - 0.5d0 * log(nvec(1)/(1.0d19*tvec(1)*tvec(1)))
      nuvec(1) = 0.00279d0*coulog*(nvec(1)/1.0d19)/(tvec(1)**1.5)*
     >   aminor*sqrt(mass_ref/tref)
c
c  ion collisionalities
c
      do i=2,num_species
         nufac=nuvec(1)*zvec(i)*zvec(i)*
     >      sqrt(avec(1)/avec(i))*(tvec(1)/tvec(i))**1.5
         nuvec(i)=0.0d0
         do j=1,num_species
            nuvec(i)=nuvec(i)+(nvec(j)/nvec(1))*zvec(j)*zvec(j)*2.0d0/
     >         (1.0d0+sqrt((avec(i)/avec(j))*(tvec(j)/tvec(i))))
         enddo
         nuvec(i)=nuvec(i)*nufac
      enddo
c
c  compute "beta" in terms of reference n,T ...
c
      beta = 403.0d0*nref*1.0d-19*tref/
     >   1.0d5/(b_t0*b_t0)
c
c  after collisionalities evaluation... normalize densities and temperatures
c  to their reference values...
c
      nvec(1:num_species)=nvec(1:num_species)/nref ! n renormalization
      tvec(1:num_species)=tvec(1:num_species)/tref ! T renormalization
c
      return
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_7(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"Rloc_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Rloc_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Rloc_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Rmajor_mean",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Rmajor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Rmajor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rMinor_mean",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rMinor_mean)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rMinor_mean"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RUNAWAY_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%RUNAWAY_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RUNAWAY_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RunID",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%RunID)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RunID"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_ant",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_ant)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_ant"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_antgeo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_antgeo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_axis"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_geo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_grid",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%R_grid)
     status = nf90_get_var(icdf,varid,ss%R_grid)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_grid"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("R_grid",ss%R_grid)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_max_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_max_box"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_max_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_max_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_max_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_midp_in",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_midp_in)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_midp_in"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_midp_out",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_midp_out)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_midp_out"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_box",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_min_box)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_min_box"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_min_lcfs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_min_lcfs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_min_lcfs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_ripple",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%R_ripple)
     status = nf90_get_var(icdf,varid,ss%R_ripple)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_ripple"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("R_ripple",ss%R_ripple)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_surfMax",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R_surfMin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%s0reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: s0reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco_e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%s0reco_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: s0reco_e"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s0reco_recap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%s0reco_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: s0reco_recap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sa_index",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sa_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sa_index"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SA_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SA_name)
     status = nf90_get_var(icdf,varid,ss%SA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SA_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SA_name",ss%SA_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SA_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SA_type)
     status = nf90_get_var(icdf,varid,ss%SA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SA_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SA_type",ss%SA_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sb0halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sb0halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sb0halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sb0halo_recap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sb0halo_recap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sb0halo_recap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbedep",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sbedep)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sbedep"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbehalo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sbehalo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sbehalo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sbsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sbsce"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sbtherm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sbtherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sbtherm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sc0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc0_to_sgas",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sc0_to_sgas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sc0_to_sgas"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sc_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sc_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sc_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sfsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sfsce"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sftherm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sftherm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sftherm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SFUS_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SFUS_name)
     status = nf90_get_var(icdf,varid,ss%SFUS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SFUS_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SFUS_name",ss%SFUS_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfus_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sfus_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sfus_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sfus_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sfus_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sfus_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SFUS_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SFUS_type)
     status = nf90_get_var(icdf,varid,ss%SFUS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SFUS_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SFUS_type",ss%SFUS_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SGAS_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SGAS_name)
     status = nf90_get_var(icdf,varid,ss%SGAS_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SGAS_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SGAS_name",ss%SGAS_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sgas_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sgas_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sgas_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SGAS_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SGAS_type)
     status = nf90_get_var(icdf,varid,ss%SGAS_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SGAS_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SGAS_type",ss%SGAS_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"shot_number",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%shot_number)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: shot_number"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sii_xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sii_xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sii_xs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMP0_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SIMP0_name)
     status = nf90_get_var(icdf,varid,ss%SIMP0_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SIMP0_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SIMP0_name",ss%SIMP0_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"simp0_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%simp0_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: simp0_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMP0_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SIMP0_type)
     status = nf90_get_var(icdf,varid,ss%SIMP0_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SIMP0_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SIMP0_type",ss%SIMP0_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMPI_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SIMPI_name)
     status = nf90_get_var(icdf,varid,ss%SIMPI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SIMPI_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SIMPI_name",ss%SIMPI_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"simpi_to_s",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%simpi_to_s)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: simpi_to_s"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SIMPI_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SIMPI_type)
     status = nf90_get_var(icdf,varid,ss%SIMPI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SIMPI_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SIMPI_type",ss%SIMPI_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SNBI_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%SNBI_name)
     status = nf90_get_var(icdf,varid,ss%SNBI_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SNBI_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("SNBI_name",ss%SNBI_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"snbi_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%snbi_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: snbi_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"snbi_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%snbi_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: snbi_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"SNBI_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%SNBI_type)
     status = nf90_get_var(icdf,varid,ss%SNBI_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: SNBI_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("SNBI_type",ss%SNBI_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sn_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sn_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sn_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sn_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sn_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sn_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sprof0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sprof0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sprof0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sprof0e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sprof0e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sprof0e"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"spsce",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%spsce)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: spsce"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"squareLO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%squareLO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: squareLO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"squareUO",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%squareUO)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: squareUO"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"sRtcen",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%sRtcen)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: sRtcen"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"surf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%surf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: surf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"S_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%S_name)
     status = nf90_get_var(icdf,varid,ss%S_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: S_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("S_name",ss%S_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"s_to_sa",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%s_to_sa)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: s_to_sa"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"S_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%S_type)
     status = nf90_get_var(icdf,varid,ss%S_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: S_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("S_type",ss%S_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%t0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: t0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0cx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T0cx"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"t1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%t1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: t1"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"teflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%teflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: teflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Te_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Te_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Te_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"te_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%te_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: te_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_7

      subroutine tdb_xyprof(d,zid,ztime1,ztime2,inx,iny,zdata,ierr)
 
      !  time interpolate f(t,x,y) profile to zdata(x,y) -- no space interp.
      !  data array sizes (inx,iny) must match.
 
      !  if ztime1.ne.ztime2, time average between the two times.
 
      use trdatbuf_obj
 
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
 
      character*(*), intent(in) :: zid  ! data identification e.g. "PSI"
      real*8, intent(in) :: ztime1,ztime2  ! target time(s) for interpolation
      ! or averaging
 
      integer, intent(in) :: inx   ! size of first grid e.g. R if type f(R,Z)
      integer, intent(in) :: iny   ! size of 2nd grid e.g. Z if type f(R,Z)
 
      real*8, intent(out) :: zdata(inx,iny)  ! time interpolated data
 
      integer, intent(out) :: ierr  ! completion code (0=OK)
 
      real*8 :: tdbsub_i1  ! time integration utility routine
      !---------------------------------------
      ! local information:
 
      character*10 :: zidi
 
      integer :: nonlin,lunmsg_tdb,imatch
      integer :: inxd,inyd
      integer :: intd,it1,ia1,ia2,ix,iy
      real*8 :: zfract,zdat1,zdat2,zt1,zt2
 
      real*8, parameter :: ZERO = 0.0d0
      real*8, parameter ::  ONE = 1.0d0
      !---------------------------------------
 
      nonlin = lunmsg_tdb(0)
 
      zidi = zid
      call uupper(zidi)
 
      imatch = 0
 
c  set initial values for output variables...
 
      ierr=0
      zdata = ZERO
 
      zt1=max(ztime1,ztime2)
      zt2=min(ztime1,ztime2)
C
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C  FD0
      if(zidi.eq.'FD0') then
         imatch=1
         if(d%LFFD0.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFD0
         inxd = d%NEFD0
         inyd = d%NXFD0
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FD0'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFD0),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFD0+ia1)
                  zdat2 = d%datbuf(d%LFFD0+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFD0),intd,d%datbuf(d%LFFD0+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  FDB
      if(zidi.eq.'FDB') then
         imatch=1
         if(d%LFFDB.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFDB
         inxd = d%NEFDB
         inyd = d%NXFDB
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FDB'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFDB),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFDB+ia1)
                  zdat2 = d%datbuf(d%LFFDB+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFDB),intd,d%datbuf(d%LFFDB+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  FDP
      if(zidi.eq.'FDP') then
         imatch=1
         if(d%LFFDP.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFDP
         inxd = d%NEFDP
         inyd = d%NXFDP
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FDP'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFDP),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFDP+ia1)
                  zdat2 = d%datbuf(d%LFFDP+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFDP),intd,d%datbuf(d%LFFDP+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  FDQ
      if(zidi.eq.'FDQ') then
         imatch=1
         if(d%LFFDQ.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFDQ
         inxd = d%NEFDQ
         inyd = d%NXFDQ
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FDQ'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFDQ),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFDQ+ia1)
                  zdat2 = d%datbuf(d%LFFDQ+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFDQ),intd,d%datbuf(d%LFFDQ+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  FDR
      if(zidi.eq.'FDR') then
         imatch=1
         if(d%LFFDR.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFDR
         inxd = d%NEFDR
         inyd = d%NXFDR
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FDR'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFDR),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFDR+ia1)
                  zdat2 = d%datbuf(d%LFFDR+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFDR),intd,d%datbuf(d%LFFDR+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  FDS
      if(zidi.eq.'FDS') then
         imatch=1
         if(d%LFFDS.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTFDS
         inxd = d%NEFDS
         inyd = d%NXFDS
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: FDS'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTFDS),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFFDS+ia1)
                  zdat2 = d%datbuf(d%LFFDS+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTFDS),intd,d%datbuf(d%LFFDS+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C  PSI
      if(zidi.eq.'PSI') then
         imatch=1
         if(d%LFPSI.le.0) then
            write(nonlin,*) ' %tdb_xyprof: no '//trim(zidi)//' data.'
            return
         endif
         intd = d%NTPSI
         inxd = d%NRPSI
         inyd = d%NZPSI
         if((inx.ne.inxd).or.(iny.ne.inyd)) then
            write(nonlin,*) 'error in tdb_xyprof call: PSI'
            write(nonlin,*) ' array sizes mismatch:'
            write(nonlin,*) ' data nx = ',inxd,'; passed nx=',inx
            write(nonlin,*) ' data ny = ',inyd,'; passed ny=',iny
            ierr=1
            return
         endif
         if(zt2.eq.zt1) then
            call tdbsub_slookup(d%datbuf(d%LTPSI),intd,zt1,it1,zfract)
         else
            it1=1
         endif
         do iy = 1,iny
            do ix = 1,inx
               ia1 = ((iy-1)*inx + (ix-1))*intd + (it1-1)
               ia2 = ia1 + 1
               if(zt2.eq.zt1) then
                  zdat1 = d%datbuf(d%LFPSI+ia1)
                  zdat2 = d%datbuf(d%LFPSI+ia2)
                  zdata(ix,iy) = zdat1*(ONE-zfract) + zfract*zdat2
               else
                  zdata(ix,iy) = tdbsub_i1(zt1,zt2,
     >                 d%datbuf(d%LTPSI),intd,d%datbuf(d%LFPSI+ia1))/
     >                 (zt2-zt1)
               endif
            enddo
         enddo
      endif
C
C=>TRDATGEN-
C
      if(imatch.eq.0) then
         write(nonlin,*) 'error in tdb_xyprof subroutine:'
         write(nonlin,*) ' ID '//trim(zidi)//' not recognized.'
         write(nonlin,*) ' ID of f(t,x,y) profile was expected.'
         ierr=2
      endif
 
      return
      end

subroutine trx_lintrans(id_orig,factor,offset,new_name,id_new,ierr)
!
!  form a new function of the form factor*[old function]+offset
!    i.e. a linear transformation of an old function
!
!  at present only items of form f(rho) are supported, and the
!  interpolation order must be at least 0 (piecewise linear).
!
!  these restrictions can be moved later, if there is a reason to do so...
!  dmc 1 May 2001
!
  implicit NONE
 
  integer, intent(in) :: id_orig        ! xplasma id of original function
  real*8, intent(in) :: factor,offset   ! defining the linear transformation
  character*(*), intent(in) :: new_name ! desired name of new function
 
  integer, intent(out) :: id_new        ! xplasma id of resulting new function
  integer, intent(out) :: ierr          ! completion code, 0=OK
 
!-----------------------------
 
  integer irank,id_rho,id_chi,id_phi,iorder
  integer nrho,idum,ierdum
  integer ibc1,ibc2
 
  integer lunzer
  character*20 zname
!
  real*8 bcs(2),rhobdys(2)
  real*8, dimension(:), allocatable :: rho,f
!-----------------------------
!
!  look up old function...
!
  call eq_xid_mag(id_orig,irank,id_rho,id_chi,id_phi,iorder,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) '?trx_lintrans:  invalid id_orig:  ',id_orig
     return
  else
     if((irank.ne.1).or.(iorder.lt.0).or.(id_rho.eq.0)) then
        call eq_get_fname(id_orig,zname)
        write(lunzer(0),*) '?trx_lintrans:  cannot transform:  ',zname
        if((irank.ne.1).or.(id_rho.eq.0)) &
             write(lunzer(0),*) ' function is not of the form f(rho).'
        if(iorder.lt.0) &
             write(lunzer(0),*) ' invalid interpolation order: ',iorder
        ierr=1
        return
     endif
  endif
!
!  get old function's rho grid
!
  call eq_ngrid(id_rho,nrho)
!
  allocate(rho(nrho),f(nrho))
  call eq_grid(id_rho,rho,nrho,idum,ierdum)
  rhobdys(1)=rho(1)
  rhobdys(2)=rho(nrho)
!
!  evaluate function on it's old grid
!
  call eq_rgetf(nrho,rho,id_orig,0,f,ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) '?trx_lintrans: eq_rgetf error (1).'
     go to 999
  endif
!
!  get BCs
!
  if(iorder.ge.1) then
     call eq_rgetf(2,rhobdys,id_orig,1,bcs,ierr)
     if(ierr.ne.0) then
        write(lunzer(0),*) '?trx_lintrans: eq_rgetf error (2).'
        go to 999
     endif
     ibc1=1
     ibc2=1
  else
     ibc1=0
     ibc2=0
     bcs=0
  endif
!
!  transform f
!
  f= factor*f + offset
!
!  transform BCs
!
  bcs= factor*bcs
!
!  set up new function...
!
  call eqm_rhofun(iorder,id_rho,new_name,f, &
       ibc1,bcs(1),ibc2,bcs(2), &
       id_new,ierr)
!
!  all done
!
999 continue
  deallocate(f,rho)
  return
end subroutine trx_lintrans

logical function tdb_logchk_special(d,zitem,iwarn)
  ! dmc Apr 2005
  ! logical query -- presence (T) or absence (F) of "special" data items
  ! in trdat buffer.

  ! the items covered are those not handled by the code generator:
  !   "RPL" -- TF ripple vs. (R,Z)
  !   "RP2" -- TF ripple vs. (R,Z) 2nd component
  !   "NB2" -- beam power/voltage/etc data vs. time
  !   "RFP" -- ICRF antenna power vs. time
  !   "RFF" -- ICRF frequencies vs. time
  !   "LHP" -- LH antenna powers vs. time
  !   "ECP" -- ECH antenna powers vs. time
  !   "ECA" -- ECH poloidal aiming vs. time
  !   "ECB" -- ECH toroidal aiming vs. time
  !   "MMX" -- complete MHD equilibrium (inside plasma bdy) vs. time -- moments
  !   "RFS" -- complete MHD equilibrium (inside plasma bdy) vs. time -- spline
  !   "PSI" -- free boundary MHD equilibrium data Psi(R,Z,t)
  !   "LIM" -- EFIT style (R,Z) contour piecewise linear axisymmetric limiter
  !   "SAW" -- sawtooth event times
  !   "PEL" -- pellet event times
  !
  ! cf codesys/source/misc/trdatgen.spec -- all the above "trigraphs" are 
  ! associated with "special_handling" i.e. hand coded data channels.  Many,
  ! but not necessarily all, special handling channels are supported in this
  ! routine.

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: zitem   ! item queried
  integer, intent(out) :: iwarn        ! 0: OK; 1: item not recognized

  ! in case an item is unrecognized, this function prints out a warning,
  ! returns iwarn=1, and function value .FALSE.
  !----------------------------------------------
  integer lunmsg_tdb
  character*20 zitemc
  !----------------------------------------------

  iwarn=0
  tdb_logchk_special = .FALSE.

  zitemc=zitem
!-call uupper(trim(zitemc))   jec 22Dec2009  fails under debug compilation
  call uupper(     zitemc )

  if(zitemc.eq.'RPL') then
     tdb_logchk_special = ( d%lrpl .gt. 0 )

  else if(zitemc.eq.'RP2') then
     tdb_logchk_special = ( d%lrp2 .gt. 0 )

  else if(zitemc.eq.'NB2') then
     tdb_logchk_special = ( d%lpwrnb .gt. 0 )

  else if(zitemc.eq.'RFP') then
     tdb_logchk_special = ( d%lpwrrf .gt. 0 )

  else if(zitemc.eq.'RFF') then
     tdb_logchk_special = ( d%lfrqrff .gt. 0 )

  else if(zitemc.eq.'LHP') then
     tdb_logchk_special = ( d%lpwrlh .gt. 0 )

  else if(zitemc.eq.'ECP') then
     tdb_logchk_special = ( d%lpwrec .gt. 0 )

  else if(zitemc.eq.'ECA') then
     tdb_logchk_special = ( d%lfeca .gt. 0 )

  else if(zitemc.eq.'ECB') then
     tdb_logchk_special = ( d%lfecb .gt. 0 )

  else if(zitemc.eq.'MMX') then
     tdb_logchk_special = ( d%ldmmx .gt. 0 ) .and. ( d%nxmmx .gt. 1 )

  else if(zitemc.eq.'RFS') then
     tdb_logchk_special = ( d%lrfs .gt. 0 )

  else if(zitemc.eq.'PSI') then
     tdb_logchk_special = ( d%lfpsi .gt. 0 )

  else if(zitemc.eq.'LIM') then
     tdb_logchk_special = ( d%llim .gt. 0 )

  else if(zitemc.eq.'SAW') then
     tdb_logchk_special = ( d%ltsaw .gt. 0 )

  else if(zitemc.eq.'PEL') then
     tdb_logchk_special = ( d%npelda .gt. 0 )
     
  else
     write(lunmsg_tdb(0),*) &
          ' ?? trdatbuf_lib/tdb_logchk_special -- unrecognized data type: ', &
          trim(zitemc)
     iwarn=1
  endif

end function tdb_logchk_special

logical function tdb_logchk_nbi(d,zsubset,iwarn)
  ! dmc Apr 2005
  ! logical query -- presence (T) or absence (F) of NBI-related data items
  ! in trdat buffer.
  !
  ! if NB2 data is not in the buffer at all, always return F = FALSE.
  !
  ! known subset names:
  !   "PWR" -- beam power
  !   "VLT" -- beam voltage (full energy injected ptcls)
  !   "FUL" -- full energy fraction (#/sec)/(total #/sec)
  !   "HLF" -- half energy fraction (#/sec)/(total #/sec)
  !
  ! this code is matched to code in trdatusub which acquires NBI-related
  ! time dependent data...

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: zsubset ! subset item queried
  integer, intent(out) :: iwarn        ! 0: OK; 1: item not recognized

  ! in case an item is unrecognized, this function prints out a warning,
  ! returns iwarn=1, and function value .FALSE.
  !----------------------------------------------
  integer lunmsg_tdb
  character*20 zitemc
  !----------------------------------------------

  zitemc = zsubset
!-call uupper(trim(zitemc))   jec 22Dec2009  fails under debug compilation
  call uupper(     zitemc )

  iwarn = 0
  tdb_logchk_nbi=.FALSE.

  ! if there is no power data, there is no NBI data at all...

  if(d%lpwrnb.eq.0) then
     return
  endif

  ! there is some data...

  if(zitemc.eq.'PWR') then
     tdb_logchk_nbi = ( d%lpwrnb .gt. 0 )

  else if(zitemc.eq.'VLT') then
     tdb_logchk_nbi = ( d%lvltnb .gt. 0 )

  else if(zitemc.eq.'FUL') then
     tdb_logchk_nbi = ( d%lfulnb .gt. 0 )

  else if(zitemc.eq.'HLF') then
     tdb_logchk_nbi = ( d%lhlfnb .gt. 0 )

  else
     write(lunmsg_tdb(0),*) &
          ' ?? trdatbuf_lib/tdb_logchk_nbi -- unrecognized subset type: ', &
          trim(zitemc)
     iwarn=1
  endif

end function tdb_logchk_nbi

c--------------------------------------------------------------
      subroutine trxpl_sc_init(ztime0,ztavg,
     >   tokdev,runid,zdate,scvals,sclabs,numsc,maxsc)
c
c  setup, initialize:  scalar values and scalar labels arrays
c
c  "Ufiles" style scalars
c
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
c  input:
      real*8 ztime0                     ! time of interest (secs)
      real*8 ztavg                      ! +/- averaging time (secs)
      integer maxsc                     ! max no. of scalars
c
c  output:
      character*4 tokdev                ! device label
      character*(*) runid               ! runid
      character*10 zdate                ! shot date
      real*8 scvals(maxsc)              ! scalar values
      character*10 sclabs(3,maxsc)      ! scalar labels
      integer numsc                     ! actual number of defined scalars
c
c----------------------------------
      integer i,ilparen,irparen,ilblank,istyle,ierr,ilr,itmp
      character*40 run_label
      character*4 zmds
      integer lunzer
c----------------------------------
c
      numsc=0
      do i=1,maxsc
         scvals(i)=0.0_R8
         sclabs(1,i)=' '
         sclabs(2,i)=' '
         sclabs(3,i)=' '
      enddo
c
c  1st scalar will contains RUNID information
c
c  get tokdev and run_label information
c  use trread routine
c
      call tget_rlbl(tokdev,run_label)
      write(6,*) ' tokdev    = "',trim(tokdev),'"'
      write(6,*) ' run_label = "',trim(run_label),'"'
c
      numsc=1
      sclabs(1,numsc)='RUNID:'
      ilparen=index(run_label,'(')
      zdate=' ???? '
      if(ilparen.gt.0) then
         istyle=1
         irparen=index(run_label,')')
         if(irparen.le.0) then
            write(lunzer(0),*)
     >         ' %run_label:  no closing parentheses: ',run_label
            irparen=max(ilparen+2,len_trim(run_label))
         endif
         sclabs(2,numsc)=run_label(1:max(1,ilparen-1))
         sclabs(3,numsc)=run_label(ilparen+1:irparen-1)
         runid=sclabs(2,numsc)
      else
         istyle=2
         ilblank=index(run_label,' ')
         sclabs(2,numsc)=run_label(1:max(1,ilblank-1))
         itmp=index(sclabs(2,numsc),'.')
         if(itmp.gt.0) zdate=sclabs(2,numsc)(itmp+1:)
         sclabs(3,numsc)=run_label(ilblank+1:ilblank+10)
         runid=sclabs(3,numsc)
      endif
      write(6,*) ' runid     = "',trim(runid),'"'
c
c  see if this is MDS+ or a file
c
      call tgethost(zmds,run_label)
      if(zmds.eq.'MDS+') then
         scvals(numsc)=istyle
      else
         scvals(numsc)=0.0_R8
      endif
c
c  save the hostname
c
      numsc=numsc+1
      if(zmds.eq.'MDS+') then
         sclabs(1,numsc)='MDS_HOST:'
      else
         sclabs(1,numsc)='FILE_HOST:'
      endif
      sclabs(2,numsc)=run_label(1:10)
      sclabs(3,numsc)=run_label(11:20)
      scvals(numsc)=scvals(numsc-1)
c
c  save the username
c
      numsc=numsc+1
      call sget_user(run_label)
      sclabs(1,numsc)='USER:'
      sclabs(2,numsc)=run_label(1:10)
      sclabs(3,numsc)=run_label(11:20)
      scvals(numsc)=0.0_R8
c
c  save the time of interest and averaging time
c
      numsc=numsc+1
      scvals(numsc)=ztime0
      sclabs(1,numsc)='TIME:'
      sclabs(2,numsc)='time'
      sclabs(3,numsc)='s'
c
      numsc=numsc+1
      scvals(numsc)=ztavg
      sclabs(1,numsc)='DT_AVG:'
      sclabs(2,numsc)='avg +/-'
      sclabs(3,numsc)='s'
c
c  OK -- put plasma current in last scalar.  additional scalars beyond
c  this will be at the user's discretion
c
      numsc=numsc+1
      sclabs(1,numsc)='PCUR:'
      sclabs(2,numsc)='PCUR'
      call trx_scal('PCUR',run_label,scvals(numsc),ierr)
      sclabs(3,numsc)=run_label
c
      return
      end

subroutine splitn_iput_ar(zname,ivalue,irank,ind0,inum,ierr)

  ! assign new value to elements of an INTEGER array

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of array variable
  integer, intent(in) :: ivalue       ! new value to assign
  integer, intent(in) :: irank        ! rank of array (must match)
  integer, intent(in) :: ind0(irank)  ! start index for assignment
  integer, intent(in) :: inum         ! number of elements to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ioff,isize,iblock,ilinadr,iadst,ilinst
  character*32 znam32,istr
  !--------------------------------------

  call splitn_bdecode1('splitn_iput_ar',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_iput_ar',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_iput_ar: not INTEGER: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.eq.0) then
     write(6,*) '?splitn_iput_ar: use splitn_iput_sc to assign SCALAR.'
     ierr=1
  endif

  if(varlist(jj)%rank.ne.irank) then
     write(6,*) '?splitn_iput_ar: rank mismatch: ',trim(znam32)
     write(6,*) ' object rank = ',varlist(jj)%rank,'; passed rank = ',irank
     ierr=1
  endif

  if(inum.le.0) then
     write(6,*) '?splitn_iput_ar: inum=',inum
     write(6,*) ' number of elements to copy (inum) must be a positive number.'
     ierr=1
  endif

  if(ierr.ne.0) return

  do ii=1,irank
     if((ind0(ii).lt.varlist(jj)%dims(1,ii)).or. &
          (ind0(ii).gt.varlist(jj)%dims(2,ii)) ) then
        ierr=1
        write(6,*) '?splitn_iput_ar: subscript bounds on dimension #',ii
        write(6,*) ' passed value = ',ind0(ii),' not in range ', &
             varlist(jj)%dims(1,ii),':',varlist(jj)%dims(2,ii)
     endif
  enddo
  if(ierr.ne.0) return

  ioff=0
  isize=1
  do ii=irank,1,-1
     ioff = ioff + (ind0(ii)-varlist(jj)%dims(1,ii))*isize
     isize = isize*(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii)+1)
  enddo

  if(ioff+inum.gt.isize) then
     write(6,*) '?splitn_iput_ar: ind0 = (',ind0,'); inum=',inum
     write(6,*) ' write reference beyond end of array.'
     ierr=1
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock
 
  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr + ioff
     ilinadr = varlist(jj)%nlinadr
  else
     ii = nint + (iblock-1)*nint_st + iadst + ioff
     ilinadr = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  intbuf(ii:ii+inum-1)=ivalue
  if(varlist(jj)%steerable.eq.2) then
     call iset_ucop(intbuf,ii,inum,iadst+ioff,ilinst+ioff,kupdate,nupdate_max)
  endif

  istr=' '
  write(istr,'(I16)') ivalue
  call splitn_put_ar_str(jj,isize,ioff,inum,znam32,istr,ilinadr)

end subroutine splitn_iput_ar

subroutine splitn_lput_ar(zname,lvalue,irank,ind0,inum,ierr)

  ! assign new value to elements of an LOGICAL array

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of array variable
  logical, intent(in) :: lvalue       ! new value to assign
  integer, intent(in) :: irank        ! rank of array (must match)
  integer, intent(in) :: ind0(irank)  ! start index for assignment
  integer, intent(in) :: inum         ! number of elements to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ioff,isize,iblock,ilinadr,iadst,ilinst
  character*32 znam32
  character*2 lstr
  !--------------------------------------

  call splitn_bdecode1('splitn_lput_ar',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_lput_ar',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lput_ar: not LOGICAL: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.eq.0) then
     write(6,*) '?splitn_lput_ar: use splitn_lput_sc to assign SCALAR.'
     ierr=1
  endif

  if(varlist(jj)%rank.ne.irank) then
     write(6,*) '?splitn_lput_ar: rank mismatch: ',trim(znam32)
     write(6,*) ' object rank = ',varlist(jj)%rank,'; passed rank = ',irank
     ierr=1
  endif

  if(inum.le.0) then
     write(6,*) '?splitn_lput_ar: inum=',inum
     write(6,*) ' number of elements to copy (inum) must be a positive number.'
     ierr=1
  endif

  if(ierr.ne.0) return

  do ii=1,irank
     if((ind0(ii).lt.varlist(jj)%dims(1,ii)).or. &
          (ind0(ii).gt.varlist(jj)%dims(2,ii)) ) then
        ierr=1
        write(6,*) '?splitn_lput_ar: subscript bounds on dimension #',ii
        write(6,*) ' passed value = ',ind0(ii),' not in range ', &
             varlist(jj)%dims(1,ii),':',varlist(jj)%dims(2,ii)
     endif
  enddo
  if(ierr.ne.0) return

  ioff=0
  isize=1
  do ii=irank,1,-1
     ioff = ioff + (ind0(ii)-varlist(jj)%dims(1,ii))*isize
     isize = isize*(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii)+1)
  enddo

  if(ioff+inum.gt.isize) then
     write(6,*) '?splitn_lput_ar: ind0 = (',ind0,'); inum=',inum
     write(6,*) ' write reference beyond end of array.'
     ierr=1
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock
 
  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr + ioff
     ilinadr = varlist(jj)%nlinadr
  else
     ii = nlog + (iblock-1)*nlog_st + iadst + ioff
     ilinadr = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  logbuf(ii:ii+inum-1)=lvalue
  if(varlist(jj)%steerable.eq.2) then
     call lset_ucop(logbuf,ii,inum,iadst+ioff,ilinst+ioff,kupdate,nupdate_max)
  endif

  if(lvalue) then
     lstr='.T'
  else
     lstr='.F'
  endif
  call splitn_put_ar_str(jj,isize,ioff,inum,znam32,lstr,ilinadr)

end subroutine splitn_lput_ar

subroutine splitn_rput_ar(zname,rvalue,irank,ind0,inum,ierr)

  ! assign new REAL value to elements of a REAL or REAL*8 array

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of array variable
  real, intent(in) :: rvalue          ! new value to assign
  integer, intent(in) :: irank        ! rank of array (must match)
  integer, intent(in) :: ind0(irank)  ! start index for assignment
  integer, intent(in) :: inum         ! number of elements to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ioff,isize,iblock,ilinadr,iadst,ilinst
  character*32 znam32
  character*20 rstr
  character*1 echar
  !--------------------------------------

  call splitn_bdecode1('splitn_rput_ar',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_rput_ar',znam32,jj,ierr)
  if(ierr.ne.0) return

  if((varlist(jj)%type.ne.'R').and.(varlist(jj)%type.ne.'D')) then
     write(6,*) '?splitn_rput_ar: not FLOATING POINT: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.eq.0) then
     write(6,*) '?splitn_rput_ar: use splitn_rput_sc to assign SCALAR.'
     ierr=1
  endif

  if(varlist(jj)%rank.ne.irank) then
     write(6,*) '?splitn_rput_ar: rank mismatch: ',trim(znam32)
     write(6,*) ' object rank = ',varlist(jj)%rank,'; passed rank = ',irank
     ierr=1
  endif

  if(inum.le.0) then
     write(6,*) '?splitn_rput_ar: inum=',inum
     write(6,*) ' number of elements to copy (inum) must be a positive number.'
     ierr=1
  endif

  if(ierr.ne.0) return

  do ii=1,irank
     if((ind0(ii).lt.varlist(jj)%dims(1,ii)).or. &
          (ind0(ii).gt.varlist(jj)%dims(2,ii)) ) then
        ierr=1
        write(6,*) '?splitn_rput_ar: subscript bounds on dimension #',ii
        write(6,*) ' passed value = ',ind0(ii),' not in range ', &
             varlist(jj)%dims(1,ii),':',varlist(jj)%dims(2,ii)
     endif
  enddo
  if(ierr.ne.0) return

  ioff=0
  isize=1
  do ii=irank,1,-1
     ioff = ioff + (ind0(ii)-varlist(jj)%dims(1,ii))*isize
     isize = isize*(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii)+1)
  enddo

  if(ioff+inum.gt.isize) then
     write(6,*) '?splitn_rput_ar: ind0 = (',ind0,'); inum=',inum
     write(6,*) ' write reference beyond end of array.'
     ierr=1
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock
 
  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr + ioff
     ilinadr = varlist(jj)%nlinadr
  else
     if(varlist(jj)%type.eq.'R') then
        ii = nreal + (iblock-1)*nreal_st + iadst + ioff
     else
        ii = nr8 + (iblock-1)*nr8_st + iadst + ioff
     endif
     ilinadr = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  if(varlist(jj)%type.eq.'R') then
     rbuf(ii:ii+inum-1)=rvalue
     if(varlist(jj)%steerable.eq.2) then
        call rset_ucop(rbuf,ii,inum,iadst+ioff,ilinst+ioff, &
             kupdate,nupdate_max)
     endif
     echar='e'
  else
     dbuf(ii:ii+inum-1)=rvalue
     if(varlist(jj)%steerable.eq.2) then
        call dset_ucop(dbuf,ii,inum,iadst+ioff,ilinst+ioff, &
             kupdate,nupdate_max)
     endif
     echar='d'
  endif

  rstr=' '
  write(rstr,'(1pe13.6)') rvalue
  call splitn_fput_clean(rstr,echar)
  call splitn_put_ar_str(jj,isize,ioff,inum,znam32,rstr,ilinadr)

end subroutine splitn_rput_ar

subroutine splitn_dput_ar(zname,dvalue,irank,ind0,inum,ierr)

  ! assign new REAL*8 value to elements of a REAL or REAL*8 array

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of array variable
  real*8, intent(in) :: dvalue        ! new value to assign
  integer, intent(in) :: irank        ! rank of array (must match)
  integer, intent(in) :: ind0(irank)  ! start index for assignment
  integer, intent(in) :: inum         ! number of elements to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ioff,isize,iblock,ilinadr,iadst,ilinst
  character*32 znam32
  character*20 dstr
  character*1 echar
  !--------------------------------------

  call splitn_bdecode1('splitn_dput_ar',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_dput_ar',znam32,jj,ierr)
  if(ierr.ne.0) return

  if((varlist(jj)%type.ne.'R').and.(varlist(jj)%type.ne.'D')) then
     write(6,*) '?splitn_dput_ar: not FLOATING POINT: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.eq.0) then
     write(6,*) '?splitn_dput_ar: use splitn_dput_sc to assign SCALAR.'
     ierr=1
  endif

  if(varlist(jj)%rank.ne.irank) then
     write(6,*) '?splitn_dput_ar: rank mismatch: ',trim(znam32)
     write(6,*) ' object rank = ',varlist(jj)%rank,'; passed rank = ',irank
     ierr=1
  endif

  if(inum.le.0) then
     write(6,*) '?splitn_dput_ar: inum=',inum
     write(6,*) ' number of elements to copy (inum) must be a positive number.'
     ierr=1
  endif

  if(ierr.ne.0) return

  do ii=1,irank
     if((ind0(ii).lt.varlist(jj)%dims(1,ii)).or. &
          (ind0(ii).gt.varlist(jj)%dims(2,ii)) ) then
        ierr=1
        write(6,*) '?splitn_dput_ar: subscript bounds on dimension #',ii
        write(6,*) ' passed value = ',ind0(ii),' not in range ', &
             varlist(jj)%dims(1,ii),':',varlist(jj)%dims(2,ii)
     endif
  enddo
  if(ierr.ne.0) return

  ioff=0
  isize=1
  do ii=irank,1,-1
     ioff = ioff + (ind0(ii)-varlist(jj)%dims(1,ii))*isize
     isize = isize*(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii)+1)
  enddo

  if(ioff+inum.gt.isize) then
     write(6,*) '?splitn_dput_ar: ind0 = (',ind0,'); inum=',inum
     write(6,*) ' write reference beyond end of array.'
     ierr=1
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock
 
  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr + ioff
     ilinadr = varlist(jj)%nlinadr
  else
     if(varlist(jj)%type.eq.'R') then
        ii = nreal + (iblock-1)*nreal_st + iadst + ioff
     else
        ii = nr8 + (iblock-1)*nr8_st + iadst + ioff
     endif
     ilinadr = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  if(varlist(jj)%type.eq.'R') then
     rbuf(ii:ii+inum-1)=dvalue
     if(varlist(jj)%steerable.eq.2) then
        call rset_ucop(rbuf,ii,inum,iadst+ioff,ilinst+ioff, &
             kupdate,nupdate_max)
     endif
     echar='e'
  else
     dbuf(ii:ii+inum-1)=dvalue
     if(varlist(jj)%steerable.eq.2) then
        call dset_ucop(dbuf,ii,inum,iadst+ioff,ilinst+ioff, &
             kupdate,nupdate_max)
     endif
     echar='d'
  endif

  dstr=' '
  write(dstr,'(1pd19.12)') dvalue
  call splitn_fput_clean(dstr,echar)
  call splitn_put_ar_str(jj,isize,ioff,inum,znam32,dstr,ilinadr)

end subroutine splitn_dput_ar

subroutine splitn_chput_ar(zname,chvalue,irank,ind0,inum,ierr)

  ! assign new value to elements of an CHARACTER*n array

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of array variable
  character*(*), intent(in) :: chvalue ! new value to assign
  integer, intent(in) :: irank        ! rank of array (must match)
  integer, intent(in) :: ind0(irank)  ! start index for assignment
  integer, intent(in) :: inum         ! number of elements to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ioff,isize,iblock,ilinadr,iadst,ilinst
  integer :: ilen,ic,it
  character*32 znam32
  character*1 zdelim
  !--------------------------------------

  call splitn_bdecode1('splitn_chput_ar',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_chput_ar',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_chput_ar: not CHARACTER: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.eq.0) then
     write(6,*) '?splitn_chput_ar: use splitn_chput_sc to assign SCALAR.'
     ierr=1
  endif

  if(varlist(jj)%rank.ne.irank) then
     write(6,*) '?splitn_chput_ar: rank mismatch: ',trim(znam32)
     write(6,*) ' object rank = ',varlist(jj)%rank,'; passed rank = ',irank
     ierr=1
  endif

  if(len_trim(chvalue).gt.varlist(jj)%chsize) then
     write(6,*) '?splitn_chput_ar: string value too long: "',trim(chvalue),'"'
     write(6,*) ' ',trim(znam32),' is CHARACTER*',varlist(jj)%chsize
     ierr=1
  endif

  if(inum.le.0) then
     write(6,*) '?splitn_chput_ar: inum=',inum
     write(6,*) ' number of elements to copy (inum) must be a positive number.'
     ierr=1
  endif

  if(ierr.ne.0) return

  do ii=1,irank
     if((ind0(ii).lt.varlist(jj)%dims(1,ii)).or. &
          (ind0(ii).gt.varlist(jj)%dims(2,ii)) ) then
        ierr=1
        write(6,*) '?splitn_chput_ar: subscript bounds on dimension #',ii
        write(6,*) ' passed value = ',ind0(ii),' not in range ', &
             varlist(jj)%dims(1,ii),':',varlist(jj)%dims(2,ii)
     endif
  enddo
  if(ierr.ne.0) return

  ioff=0
  isize=1
  do ii=irank,1,-1
     ioff = ioff + (ind0(ii)-varlist(jj)%dims(1,ii))*isize
     isize = isize*(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii)+1)
  enddo

  if(ioff+inum.gt.isize) then
     write(6,*) '?splitn_chput_ar: ind0 = (',ind0,'); inum=',inum
     write(6,*) ' write reference beyond end of array.'
     ierr=1
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock
 
  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr + ioff
     ilinadr = varlist(jj)%nlinadr
  else
     ii = nchv + (iblock-1)*nchv_st + iadst + ioff
     ilinadr = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  chbuf(ii:ii+inum-1)=chvalue
  if(varlist(jj)%steerable.eq.2) then
     call chset_ucop(chbuf,ii,inum,iadst+ioff,ilinst+ioff, &
          kupdate,nupdate_max)
  endif

  zdelim = "'"
  if(index(chvalue,zdelim).gt.0) then
     if(index(chvalue,'"').eq.0) zdelim = '"'
  endif

  chval=' '
  chval(1:1)=zdelim
  it=1

  do ic=1,max(1,len_trim(chvalue))
     it=it+1
     chval(it:it)=chvalue(ic:ic)
     if(chvalue(ic:ic).eq.zdelim) then
        it=it+1
        chval(it:it)=chvalue(ic:ic)
     endif
  enddo

  it=it+1
  chval(it:it)=zdelim

  call splitn_put_ar_str(jj,isize,ioff,inum,znam32,chval,ilinadr)

end subroutine splitn_chput_ar

subroutine splitn_put_ar_str(jj,isize,ioff,inum,zname,zvalue,ilinadr)

  ! insert into namelist file text arrays
  !   text to reflect change in namelist data
  !   a minimal edit of existing text is the goal.

  use splitn_module
  implicit NONE

  integer, intent(in) :: jj               ! namelist array variable index
  integer, intent(in) :: isize            ! size of array
  integer, intent(in) :: ioff             ! offset to first assigned element
  integer, intent(in) :: inum             ! number of elements to assign
  character*(*), intent(in) :: zname      ! variable name
  character*(*), intent(in) :: zvalue     ! assigned value
  integer, intent(in) :: ilinadr          ! ptr to text line address

  !  value could have both leading and trailing blanks; these need
  !  to be removed

  integer iv1,iv2,ic,ilen
  integer in1,in2,ir1,ir2,ii1,ii2,i,j,ia
  integer iv1a,iv2a,ir1a,ir2a,ilenc,iv1r,iv2r
  integer knum_new,knum_old
  character*10 zrepeat
  character*30 zindices
  character*140 ztrailer,zcmt
  integer itrailer,itrailv1
  integer ilina,inumpq,imatch,isign
  integer, dimension(:), allocatable :: ilinps,joffs,joffx
  integer idiff,icmt,irank,joff,jnum,koff,knum,koffx,joffz
  integer :: ilinqs

  logical aorder,istraddle

  !-----------------------------------

  allocate(ilinps(2*isize),joffs(2*isize),joffx(2*isize))

  in1 = 1   ! name field assumed to be left justified
  in2 = len_trim(zname)

  iv2 = len_trim(zvalue)

  do ic=1,len(zvalue)
     if(zvalue(ic:ic).ne.' ') then
        iv1=ic
        exit
     endif
  enddo

  ! non-blank part is zvalue(iv1:iv2).

  ilen=iv2-iv1+1

  !-----------
  irank = varlist(jj)%rank  ! dimensionality of array object
  ilina = ilinadr

  inumpq = 0  ! no. of file lines which define elements in this array
  do i=1,isize
     if(ilines(ilina+i-1).ne.0) then
        imatch=0
        do j=1,inumpq
           if(ilines(ilina+i-1).eq.ilinps(j)) then
              imatch=j 
              exit
           endif
        enddo
        if(imatch.eq.0) then
           inumpq=inumpq+1
           joffs(inumpq)=i-1
           ilinps(inumpq)=ilines(ilina+i-1)
           joffx(inumpq)=i-1
        else
           joffx(imatch)=i-1
        endif
     endif
  enddo
  aorder=.TRUE.
  do j=2,inumpq
     if(joffs(j).le.joffx(j-1)) then
        aorder=.FALSE.
        write(6,*) ' %splitn_put_ar_str warning: for namelist array ', &
             trim(zname)
        write(6,*) '  duplicate value assignments cannot be separated;'
        write(6,*) '  new values written to end of file.'
        write(6,*) '  user should edit file to clean up duplications.'
        exit
     endif
  enddo
     
  if((inumpq.eq.0).or.(.not.aorder)) then
     !  new item -- not previously referenced in namelist file text

     ilina = ilinadr + ioff
     call get_newline
     call add_new_line(ioff,inum,newline)  ! put to end of block
     
  else
     !  item previously referenced

     joff=ioff
     koff=ioff+inum  ! beyond end of assignments
     jnum=inum

     if(joff.lt.joffs(1)) then
        !  some elements of index lower than the lowest previously
        !  assigned in the file text ... are assigned here.

        ilina = ilinadr + joff
        
        !  insert in line before the line which previously assigned
        !  the lowest indexed value.
        call add_new_line(joff,min(koff-joff,joffs(1)-joff),ilinps(1))

        joff=joffs(1)   ! start of values still to be assigned
        jnum=koff-joff  ! number of such values (0 if less than 0)

     endif

     !  now loop over previous assignments; if block being reassigned
     !  intersects previous assignment, edit it; if not, insert a new line.

     do j=1,inumpq
        ilinqs = ordl(ilinps(j))
        if(jnum.le.0) exit

        isign=1
        if(lenl(ilinqs).lt.0) isign=-1

        if(j.eq.inumpq) then
           koffx=koff
        else
           koffx=joffs(j+1)
        endif
        if(joff.lt.koffx) then
           ! something needs to be written in vicinity of line (ilinps(j)).

           knum=min(koff-joff,koffx-joff)  ! #of elements to be assigned here
           joffz=joff+knum-1

           if(joff.le.joffx(j)) then
              ! need to modify line (ilinps(j)) stored at (ilinqs)

              lcmt=cmtfld(ilinqs)  ! save off comment (if any)
              if(lcmt.gt.0) then
                 zcmt=textnl(ilinqs)(lcmt:)
                 textnl(ilinqs)(lcmt:)=' '
                 ilenc=len_trim(zcmt)
                 icmt=lcmt
              else
                 zcmt=' '
                 ilenc=0
                 icmt=0
              endif

              ilina = ilinadr

              ! tentative range of value text to be replaced:
              if(irrange(1,ilina+joff).gt.0) then
                 iv1r=irrange(1,ilina+joff)
              else
                 iv1r=ivrange(1,ilina+joff)
              endif
              val2=valfld(2,ilinqs)
              iv2r=val2
              if(joffz.lt.joffx(j)) then
                 if(irrange(1,ilina+joff+1).gt.0) then
                    iv2r=irrange(1,ilina+joff+1)-1
                 else
                    iv2r=ivrange(1,ilina+joff+1)-1
                 endif
              endif

              itrailer=0
              itrailv1=0
              ztrailer=' '
              istraddle=.FALSE.
              if((joffz.lt.joffx(j)).and.(joffs(j).lt.joff)) then
                 if((krepeat(ilina+joff).gt.0).and. &
                      (irrange(1,ilina+joff).eq.irrange(1,ilina+joffz))) then
                    istraddle = .TRUE.
                    !  this is set if the SAME repeat count block covers
                    !  both the first and last elements of the new assignment.
                 endif
              endif

              if(joffz.lt.joffx(j)) then
                 ! at the end of the assignment line are some values that
                 ! are to remain unchanged; find them...
                 knum_new=0
                 ir1a=irrange(1,ilina+joffz)
                 ir2a=irrange(2,ilina+joffz)
                 if((krepeat(ilina+joffz).gt.1).and. &
                      (irrange(1,ilina+joffz).eq.irrange(1,ilina+joffz+1))) &
                      then
                    knum_old=krepeat(ilina+joffz)
                    knum_new=1
                    do
                       if(irrange(1,ilina+joffz).ne. &
                            irrange(1,ilina+joffz+knum_new+1)) exit
                       knum_new=knum_new+1
                    enddo
                 endif
                 if(knum_new.eq.1) then
                    ! lose repeat count
                    itrailv1=2
                    ztrailer= &
                         ','//textnl(ilinqs)(ivrange(1,ilina+joffz):val2)
                    if(.not.istraddle) then
                       textnl(ilinqs)(irrange(1,ilina+joffz):val2)=' '
                    else
                       textnl(ilinqs)(ivrange(2,ilina+joffz)+1:val2)=' '
                    endif
                    krepeat(ilina+joffz+1)=0
                    irrange(1:2,ilina+joffz+1)=0  ! ivrange not known yet
                 else if(knum_new.gt.1) then
                    ! reduce repeat count
                    call gen_zrepeat(knum_new)
                    itrailv1=2+(ir2-ir1)+1
                    ztrailer=','//zrepeat(ir1:ir2)// &
                         textnl(ilinqs)(ivrange(1,ilina+joffz):val2)
                    if(.not.istraddle) then
                       textnl(ilinqs)(irrange(1,ilina+joffz):val2)=' '
                    else
                       textnl(ilinqs)(ivrange(2,ilina+joffz)+1:val2)=' '
                    endif
                    krepeat(ilina+joffz+1:ilina+joffz+knum_new)=knum_new
                    irrange(1,ilina+joffz+1:ilina+joffz+knum_new)= &
                         irrange(2,ilina+joffz+1:ilina+joffz+knum_new) - &
                         (ir2-ir1)   ! final ivrange/irrange not known yet
                 else
                    ! no intersecting repeat count
                    ii1=iv2r+1
                    ztrailer=','//textnl(ilinqs)(ii1:val2)
                    itrailv1=2+ivrange(1,ilina+joffz+1)-ii1
                    textnl(ilinqs)(ii1:val2)=' '
                 endif
                 itrailer=len_trim(ztrailer)
              endif

              if(joff.gt.joffs(j)) then
                 ! at the start of block of values assigned by this
                 ! line are some (at least one) which should not
                 ! be changed.  However, the last sub-block could
                 ! have a repeat count that needs to be modified.
                 knum_new=0
                 if((krepeat(ilina+joff).gt.1).and. &
                      (irrange(1,ilina+joff).eq.irrange(1,ilina+joff-1))) then
                    knum_old=krepeat(ilina+joff)
                    knum_new=1
                    do
                       if(irrange(1,ilina+joff).ne. &
                            irrange(1,ilina+joff-knum_new-1)) exit
                       knum_new=knum_new+1
                    enddo
                 endif
                 ir1a=irrange(1,ilina+joff)
                 ir2a=irrange(2,ilina+joff)
                 iv1a=ivrange(1,ilina+joff)
                 iv2a=ivrange(2,ilina+joff)
                 if(knum_new.eq.1) then
                    ! lose repeat count
                    aline(iv1a:iv2a)=textnl(ilinqs)(iv1a:iv2a)
                    textnl(ilinqs)(ir1a:iv2a)=' '
                    ir2a=ir1a+(iv2a-iv1a)+1
                    textnl(ilinqs)(ir1a:ir2a)=aline(iv1a:iv2a)//','
                    iv1r=ir2a+1  ! replace after...
                    krepeat(ilina+joff-1)=0
                    irrange(1:2,ilina+joff-1)=0
                    ivrange(1,ilina+joff-1)=ir1a
                    ivrange(2,ilina+joff-1)=ir2a-1
                 else if(knum_new.gt.1) then
                    ! reduce repeat count
                    call gen_zrepeat(knum_new)
                    ir1=ir2-(ir2a-ir1a)
                    textnl(ilinqs)(ir1a:ir2a)=zrepeat(ir1:ir2)
                    krepeat(ilina+joff-knum_new:ilina+joff-1)=knum_new
                    textnl(ilinqs)(iv2a+1:iv2a+1)=','
                    iv1r=iv2a+2  ! replace after...
                 endif
              endif

              !  replacement section...

              val1=iv1r
              textnl(ilinqs)(val1:)=' '
              if(knum.gt.1) then
                 call gen_zrepeat(knum)
                 val2=val1+(ir2-ir1)+1+(iv2-iv1)
                 iv1a=val1+(ir2-ir1)+1
                 iv2a=val2
              else
                 val2=val1+iv2-iv1
                 iv1a=val1
                 iv2a=val2
              endif
              call insert_val(ilinps(j),ilinqs,knum,ilina+joff)
              len1=len_trim(textnl(ilinqs))

              ! re-insert trailer if necessary

              if(itrailer.gt.0) then
                 textnl(ilinqs)(len1+1:len1+itrailer)=ztrailer(1:itrailer)
                 idiff=len1+itrailv1-ivrange(1,ilina+joffz+1)
                 do ia=ilina+joffz+1,ilina+joffx(j)
                    if(irrange(1,ia).gt.0) then
                       irrange(1:2,ia)=irrange(1:2,ia)+idiff
                    endif
                    ivrange(1:2,ia)=ivrange(1:2,ia)+idiff
                 enddo
                 len1=len_trim(textnl(ilinqs))
              endif

              valfld(2,ilinqs)=len1

              ! re-insert comment -- decide current or next line.

              cmtfld(ilinqs)=0
              if(ilenc.gt.0) then
                 lcmt = max(lcmt,len1+2)
                 if(lcmt+len_trim(zcmt)-1.lt.80) then
                    textnl(ilinqs)(lcmt:)=zcmt
                    cmtfld(ilinqs)=lcmt
                 else
                    aline=' '
                    aline(icmt:icmt+ilenc-1)=zcmt(1:ilenc)
                    call clear_fields
                    lcmt=icmt
                    newline = ilinps(j)+1
                    call add_nl_line(aline)
                 endif
              endif

              lenl(ilinqs)=isign*max(1,len_trim(textnl(ilinqs)))

           else
              ! new values being assigned are not already assigned in this line
              ! insert new line just after (ilinps(j))
              
              ilina = ilinadr + joff
              call add_new_line(joff,knum,ilinps(j)+1)

           endif

           joff=koffx   ! start of values still to be assigned
           jnum=koff-joff  ! number of such values (0 if less than 0)

        endif
     enddo
              
  endif

  deallocate(ilinps,joffs,joffx)

  contains
     subroutine add_new_line(ioff,inum,ipos)

       integer, intent(in) :: ioff ! offset rel. start address of array
       integer, intent(in) :: inum ! no. of values (repeat count)
       integer, intent(in) :: ipos ! where to put line in file (0 for end)

       integer ip,inump,ishift

       !  write  <name>(<indices>) = <repeat>*<value>
       !  line into file text memory

       newline = ipos

       call clear_fields
       if(inum.eq.1) then
          if(ioff.eq.0) then
             aline = ' '//zname(in1:in2)//' = '//zvalue(iv1:iv2)
             nam1=2
             nam2=2+in2-in1
          else
             call gen_zindices(ioff)
             aline = ' '//zname(in1:in2)//zindices(ii1:ii2)// &
                  ' = '//zvalue(iv1:iv2)
             nam1=2
             nam2=2+in2-in1+1+ii2-ii1
          endif
          val1=nam2+4
          val2=val1+iv2-iv1
          iv1a=val1
          iv2a=val2
       else
          call gen_zrepeat(inum)
          if(ioff.eq.0) then
             aline = ' '//zname(in1:in2)// &
                  ' = '//zrepeat(ir1:ir2)//zvalue(iv1:iv2)
             nam1=2
             nam2=2+in2-in1
          else
             call gen_zindices(ioff)
             aline = ' '//zname(in1:in2)//zindices(ii1:ii2)// &
                  ' = '//zrepeat(ir1:ir2)//zvalue(iv1:iv2)
             nam1=2
             nam2=2+in2-in1+1+ii2-ii1
          endif
          val1=nam2+4
          val2=val1+ir2-ir1+1+iv2-iv1
          ir2a=val1+ir2-ir1
          ir1a=val1
          iv2a=val2
          iv1a=val1+ir2-ir1+1
       endif

       call add_nl_line(aline)

       inump=min(nlines,ipos)

       ! maintain sort order consistency in line pointer arrays

       do ip=1,inumpq
          if(ilinps(ip).ge.inump) ilinps(ip)=ilinps(ip)+1
       enddo

       ilines(ilina:ilina+inum-1)=inump

       ivrange(1,ilina:ilina+inum-1)=iv1a
       ivrange(2,ilina:ilina+inum-1)=iv2a
       if(inum.gt.1) then
          krepeat(ilina:ilina+inum-1)=inum
          irrange(1,ilina:ilina+inum-1)=ir1a
          irrange(2,ilina:ilina+inum-1)=ir2a
       else
          krepeat(ilina)=0
          irrange(1:2,ilina)=0
       endif

     end subroutine add_new_line

     subroutine gen_zrepeat(inum)
       integer, intent(in) :: inum
       integer k
       ! generate repeat count substring & set non-blank limits ir1:ir2

       write(zrepeat,'(I9,"*")') inum
       ir2=10
       do k=1,ir2
          if(zrepeat(k:k).ne.' ') then
             ir1=k
             exit
          endif
       enddo
     end subroutine gen_zrepeat

     subroutine gen_zindices(ioff)
       integer,intent(in) :: ioff   ! offset from array base address

       character*10 zinda(irank)
       integer kblock,ind,iwk,irat,ii,ic,iz

       !  generate array subscript string and set non-blank indices ii1:ii2

       iwk=ioff
       do ii=irank,1,-1
          kblock=(varlist(jj)%dims(2,ii)-varlist(jj)%dims(1,ii))+1
          irat=iwk/kblock
          ind = (iwk - irat*kblock) + varlist(jj)%dims(1,ii)
          write(zinda(ii),'(I10)') ind
          iwk=irat
       enddo

       zindices='('
       iz=1

       do ii=1,irank
          do ic=1,10
             if(zinda(ii)(ic:ic).ne.' ') then
                iz=iz+1
                zindices(iz:iz)=zinda(ii)(ic:ic)
             endif
          enddo
          iz=iz+1
          if(ii.eq.irank) then
             zindices(iz:iz)=')'
          else
             zindices(iz:iz)=','
          endif
       enddo

       ii1=1
       ii2=iz
     end subroutine gen_zindices

     subroutine insert_val(ilinp,ilinq,knum,ilina)
       integer,intent(in) :: ilinp   ! line no. in file
       integer,intent(in) :: ilinq   ! text array address
       integer,intent(in) :: knum    ! no. of values (repeat count)
       integer,intent(in) :: ilina   ! element address in ilines, etc.

       if(knum.gt.1) then
          textnl(ilinq)(val1:val2)= zrepeat(ir1:ir2)//zvalue(iv1:iv2)
          krepeat(ilina:ilina+knum-1)=knum
          irrange(1,ilina:ilina+knum-1)=val1
          irrange(2,ilina:ilina+knum-1)=val1+(ir2-ir1)
       else
          textnl(ilinq)(val1:val2)= zvalue(iv1:iv2)
          krepeat(ilina)=0
          irrange(1,ilina)=0
          irrange(2,ilina)=0
       endif
       ilines(ilina:ilina+knum-1)=ilinp
       ivrange(1,ilina:ilina+knum-1)=iv1a
       ivrange(2,ilina:ilina+knum-1)=iv2a
       
     end subroutine insert_val

end subroutine splitn_put_ar_str

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_slists(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:
  INTEGER :: icomponent,imod
  CHARACTER*32 :: listname
  INTEGER :: ahash(ps_max_static)
  !-----------------------

  ahash(1) = ps_dhash_NSPEC_ALL
  IF(ALLOCATED(ss%ALL_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_ALL"
     icomponent = ps_cnum_PLASMA
     CALL ps_species_list_store(ss%iobj,listname,icomponent,0,ss%nspec_all, &
          ss%ALL_name,ss%qatom_ALL,ss%q_ALL,ss%m_ALL,ss%ALL_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_ALLA
  IF(ALLOCATED(ss%ALLA_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_ALLA"
     icomponent = ps_cnum_PLASMA
     CALL ps_species_list_store(ss%iobj,listname,icomponent,0,ss%nspec_alla, &
          ss%ALLA_name,ss%qatom_ALLA,ss%q_ALLA,ss%m_ALLA,ss%ALLA_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_BEAM
  IF(ALLOCATED(ss%SNBI_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SNBI"
     icomponent = ps_cnum_NBI
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_beam, &
          ss%SNBI_name,ss%qatom_SNBI,ss%q_SNBI,ss%m_SNBI,ss%SNBI_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_FUSION
  IF(ALLOCATED(ss%SFUS_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SFUS"
     icomponent = ps_cnum_FUS
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_fusion, &
          ss%SFUS_name,ss%qatom_SFUS,ss%q_SFUS,ss%m_SFUS,ss%SFUS_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_GAS
  IF(ALLOCATED(ss%SGAS_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SGAS"
     icomponent = ps_cnum_GAS
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_gas, &
          ss%SGAS_name,ss%qatom_SGAS,ss%q_SGAS,ss%m_SGAS,ss%SGAS_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_IMP0
  IF(ALLOCATED(ss%SIMP0_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SIMP0"
     icomponent = ps_cnum_GAS
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_imp0, &
          ss%SIMP0_name,ss%qatom_SIMP0,ss%q_SIMP0,ss%m_SIMP0,ss%SIMP0_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_IMPI
  IF(ALLOCATED(ss%SIMPI_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SIMPI"
     icomponent = ps_cnum_PLASMA
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_impi, &
          ss%SIMPI_name,ss%qatom_SIMPI,ss%q_SIMPI,ss%m_SIMPI,ss%SIMPI_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_RFMIN
  IF(ALLOCATED(ss%RFMIN_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_RFMIN"
     icomponent = ps_cnum_IC
     CALL ps_species_list_store(ss%iobj,listname,icomponent,1,ss%nspec_rfmin, &
          ss%RFMIN_name,ss%qatom_RFMIN,ss%q_RFMIN,ss%m_RFMIN,ss%RFMIN_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_TH
  IF(ALLOCATED(ss%S_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_S"
     icomponent = ps_cnum_PLASMA
     CALL ps_species_list_store(ss%iobj,listname,icomponent,0,ss%nspec_th, &
          ss%S_name,ss%qatom_S,ss%q_S,ss%m_S,ss%S_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_NSPEC_THA
  IF(ALLOCATED(ss%SA_name).AND.hcheck(1,1)) THEN
     listname = "PS_SPECIES_SA"
     icomponent = ps_cnum_PLASMA
     CALL ps_species_list_store(ss%iobj,listname,icomponent,0,ss%nspec_tha, &
          ss%SA_name,ss%qatom_SA,ss%q_SA,ss%m_SA,ss%SA_type, &
          imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_slists

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store(filename,ss,icheck,ierr)

  ! store (i.e. write to file) plasma state

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  CHARACTER*(*), INTENT(IN) :: filename        ! state file
  TYPE (plasma_state) :: ss     ! state data to write
  INTEGER, INTENT(in) :: icheck ! =0 to skip equilibrium check
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-----------------------
  ! if filename is blank, plasma state is loaded into xplasma
  ! and hash codes are updated, but, no NetCDF file is written.
  !-----------------------

  INTEGER :: icdf,iout,varid,dimid,status,iertot,ival,ii,isize
  INTEGER :: idims(20),indim
  CHARACTER*80 :: nc_errmsg
  CHARACTER*32 :: dimname

  !-----------------------
  ! Initialization...

  iout = SWIM_err_out_file

  ss%version_id = ps_version_id

  !------------------------------------
  ! reload equilibrium and other data in xplasma, with checks, as needed...
  ! ...hand maintained code orchestrates:
  !     0. plasma_state_empty_alloc; update ps_active_dims(...)
  !     1. compute new_hash_codes
  !     2. xplasma update of equilibrium as needed based on hash codes
  !     3. xplasma update of data and profiles as needed
  !     4. "zonwt" update
  !     5. update of derived quantities in xplasma.

  CALL ps_xload_check(ss,iout,icheck,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?plasma_state_store: error in ps_xload_check."
     ierr = 9999
     RETURN
  ENDIF

  CALL plasma_state_xload(ss,ierr)
  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?plasma_state_store: error in plasma_state_xload."
     ierr = 9999
     RETURN
  ENDIF

  !------------------------------------
  ! in this routine, everything is written out, so no need to keep
  ! old hash codes.

  ss%hash_codes = ss%new_hash_codes

  !------------------------------------
  ! if no filename is provided, we are done!

  IF(filename.eq.' ') RETURN
  !------------------------------------
  ! if a filename is provided, create (clobber!) a new NetCDF file

  status = nf90_create(trim(filename),NF90_CLOBBER,icdf)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr(status)
     WRITE(iout,*) ' ?plasma_state_store: file create failure: "'//trim(filename)//'".'
     ierr=9999
     RETURN
  ENDIF

  !------------------------------------

  ! *** Array Dimensions ***

  ss%active_dims = 0
  iertot = 0

  IF(ss%max_nrz_antgeo.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%max_nrz_antgeo
     status = nf90_def_dim(icdf,"dim_max_nrz_antgeo",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_max_nrz_antgeo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%max_nspectrumlh_src.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
     ival = ss%max_nspectrumlh_src
     status = nf90_def_dim(icdf,"dim_max_nspectrumlh_src",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_max_nspectrumlh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%max_num_nphi.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%max_num_nphi
     status = nf90_def_dim(icdf,"dim_max_num_nphi",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_max_num_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%max_num_nphi_vac.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%max_num_nphi_vac
     status = nf90_def_dim(icdf,"dim_max_num_nphi_vac",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_max_num_nphi_vac"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%max_n_straps.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%max_n_straps
     status = nf90_def_dim(icdf,"dim_max_n_straps",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_max_n_straps"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%mmodes.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
     ival = ss%mmodes
     status = nf90_def_dim(icdf,"dim_mmodes",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_mmodes"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nballoon.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
     ival = ss%nballoon
     status = nf90_def_dim(icdf,"dim_nballoon",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nballoon"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nbeam.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%nbeam
     status = nf90_def_dim(icdf,"dim_nbeam",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nbeam"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%ncircuits.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%ncircuits
     status = nf90_def_dim(icdf,"dim_ncircuits",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_ncircuits"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%ncoils.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%ncoils
     status = nf90_def_dim(icdf,"dim_ncoils",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_ncoils"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%ndelta_w.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
     ival = ss%ndelta_w
     status = nf90_def_dim(icdf,"dim_ndelta_w",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_ndelta_w"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%necrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_EC) = ss%active_dims(ps_cnum_EC) + 1
     ival = ss%necrf_src
     status = nf90_def_dim(icdf,"dim_necrf_src",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_necrf_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nefi_anom.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nefi_anom
     status = nf90_def_dim(icdf,"dim_nefi_anom",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nefi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nefi_anom2.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nefi_anom2
     status = nf90_def_dim(icdf,"dim_nefi_anom2",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nefi_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%neqmom.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%neqmom
     status = nf90_def_dim(icdf,"dim_neqmom",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_neqmom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%ngsc0.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
     ival = ss%ngsc0
     status = nf90_def_dim(icdf,"dim_ngsc0",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_ngsc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nicrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%nicrf_src
     status = nf90_def_dim(icdf,"dim_nicrf_src",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nicrf_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nky_anomth.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nky_anomth
     status = nf90_def_dim(icdf,"dim_nky_anomth",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nky_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nky_mmm.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nky_mmm
     status = nf90_def_dim(icdf,"dim_nky_mmm",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nky_mmm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nlhrf_src.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
     ival = ss%nlhrf_src
     status = nf90_def_dim(icdf,"dim_nlhrf_src",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nlhrf_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nnewcomb.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
     ival = ss%nnewcomb
     status = nf90_def_dim(icdf,"dim_nnewcomb",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nnewcomb"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%npsmom.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%npsmom
     status = nf90_def_dim(icdf,"dim_npsmom",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_npsmom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nr.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%nr
     status = nf90_def_dim(icdf,"dim_nr",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nr"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nrho - 1
     status = nf90_def_dim(icdf,"dm1_nrho",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho
     status = nf90_def_dim(icdf,"dim_nrho",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_anom.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nrho_anom
     status = nf90_def_dim(icdf,"dim_nrho_anom",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_anom2.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nrho_anom2
     status = nf90_def_dim(icdf,"dim_nrho_anom2",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_anomth.GT.0) THEN
     ss%active_dims(ps_cnum_ANOM) = ss%active_dims(ps_cnum_ANOM) + 1
     ival = ss%nrho_anomth - 1
     status = nf90_def_dim(icdf,"dm1_nrho_anomth",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_anomth
     status = nf90_def_dim(icdf,"dim_nrho_anomth",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_ecrf.GT.0) THEN
     ss%active_dims(ps_cnum_EC) = ss%active_dims(ps_cnum_EC) + 1
     ival = ss%nrho_ecrf - 1
     status = nf90_def_dim(icdf,"dm1_nrho_ecrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_ecrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_ecrf
     status = nf90_def_dim(icdf,"dim_nrho_ecrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_ecrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_eq.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%nrho_eq
     status = nf90_def_dim(icdf,"dim_nrho_eq",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_eq_geo.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%nrho_eq_geo
     status = nf90_def_dim(icdf,"dim_nrho_eq_geo",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_eq_geo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_fus.GT.0) THEN
     ss%active_dims(ps_cnum_FUS) = ss%active_dims(ps_cnum_FUS) + 1
     ival = ss%nrho_fus - 1
     status = nf90_def_dim(icdf,"dm1_nrho_fus",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_fus"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_fus
     status = nf90_def_dim(icdf,"dim_nrho_fus",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_fus"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_gas.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
     ival = ss%nrho_gas - 1
     status = nf90_def_dim(icdf,"dm1_nrho_gas",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_gas"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_gas
     status = nf90_def_dim(icdf,"dim_nrho_gas",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_gas"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_icrf.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%nrho_icrf - 1
     status = nf90_def_dim(icdf,"dm1_nrho_icrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_icrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_icrf
     status = nf90_def_dim(icdf,"dim_nrho_icrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_icrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_lhrf.GT.0) THEN
     ss%active_dims(ps_cnum_LH) = ss%active_dims(ps_cnum_LH) + 1
     ival = ss%nrho_lhrf - 1
     status = nf90_def_dim(icdf,"dm1_nrho_lhrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_lhrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_lhrf
     status = nf90_def_dim(icdf,"dim_nrho_lhrf",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_lhrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_lmhd.GT.0) THEN
     ss%active_dims(ps_cnum_LMHD) = ss%active_dims(ps_cnum_LMHD) + 1
     ival = ss%nrho_lmhd
     status = nf90_def_dim(icdf,"dim_nrho_lmhd",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_mist.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
     ival = ss%nrho_mist - 1
     status = nf90_def_dim(icdf,"dm1_nrho_mist",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_mist"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_mist
     status = nf90_def_dim(icdf,"dim_nrho_mist",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_mist"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_nbi.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%nrho_nbi - 1
     status = nf90_def_dim(icdf,"dm1_nrho_nbi",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_nbi
     status = nf90_def_dim(icdf,"dim_nrho_nbi",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_pel.GT.0) THEN
     ss%active_dims(ps_cnum_PEL) = ss%active_dims(ps_cnum_PEL) + 1
     ival = ss%nrho_pel - 1
     status = nf90_def_dim(icdf,"dm1_nrho_pel",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_pel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_pel
     status = nf90_def_dim(icdf,"dim_nrho_pel",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_pel"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_rad.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
     ival = ss%nrho_rad - 1
     status = nf90_def_dim(icdf,"dm1_nrho_rad",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_rad"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_rad
     status = nf90_def_dim(icdf,"dim_nrho_rad",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_rad"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nrho_rw.GT.0) THEN
     ss%active_dims(ps_cnum_RUNAWAY) = ss%active_dims(ps_cnum_RUNAWAY) + 1
     ival = ss%nrho_rw - 1
     status = nf90_def_dim(icdf,"dm1_nrho_rw",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dm1_nrho_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nrho_rw
     status = nf90_def_dim(icdf,"dim_nrho_rw",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nrho_rw"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nr_rip.GT.0) THEN
     ss%active_dims(ps_cnum_RIPPLE) = ss%active_dims(ps_cnum_RIPPLE) + 1
     ival = ss%nr_rip
     status = nf90_def_dim(icdf,"dim_nr_rip",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nr_rip"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_all.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nspec_all
     status = nf90_def_dim(icdf,"dim_nspec_all",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nspec_all + 1
     status = nf90_def_dim(icdf,"dp1_nspec_all",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dp1_nspec_all"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_alla.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nspec_alla
     status = nf90_def_dim(icdf,"dim_nspec_alla",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nspec_alla + 1
     status = nf90_def_dim(icdf,"dp1_nspec_alla",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dp1_nspec_alla"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_beam.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%nspec_beam
     status = nf90_def_dim(icdf,"dim_nspec_beam",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_beam"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_fusion.GT.0) THEN
     ss%active_dims(ps_cnum_FUS) = ss%active_dims(ps_cnum_FUS) + 1
     ival = ss%nspec_fusion
     status = nf90_def_dim(icdf,"dim_nspec_fusion",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_fusion"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_gas.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
     ival = ss%nspec_gas
     status = nf90_def_dim(icdf,"dim_nspec_gas",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_gas"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_imp0.GT.0) THEN
     ss%active_dims(ps_cnum_GAS) = ss%active_dims(ps_cnum_GAS) + 1
     ival = ss%nspec_imp0
     status = nf90_def_dim(icdf,"dim_nspec_imp0",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_imp0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_impi.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nspec_impi
     status = nf90_def_dim(icdf,"dim_nspec_impi",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_impi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_rfmin.GT.0) THEN
     ss%active_dims(ps_cnum_IC) = ss%active_dims(ps_cnum_IC) + 1
     ival = ss%nspec_rfmin
     status = nf90_def_dim(icdf,"dim_nspec_rfmin",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_rfmin"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_th.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nspec_th
     status = nf90_def_dim(icdf,"dim_nspec_th",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_th"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nspec_th + 1
     status = nf90_def_dim(icdf,"dp1_nspec_th",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dp1_nspec_th"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nspec_tha.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%nspec_tha
     status = nf90_def_dim(icdf,"dim_nspec_tha",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nspec_tha"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
     ival = ss%nspec_tha + 1
     status = nf90_def_dim(icdf,"dp1_nspec_tha",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dp1_nspec_tha"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nth_eq.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%nth_eq
     status = nf90_def_dim(icdf,"dim_nth_eq",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nth_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%ntrcat.GT.0) THEN
     ss%active_dims(ps_cnum_PLASMA) = ss%active_dims(ps_cnum_PLASMA) + 1
     ival = ss%ntrcat
     status = nf90_def_dim(icdf,"dim_ntrcat",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_ntrcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%num_rzlim.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%num_rzlim
     status = nf90_def_dim(icdf,"dim_num_rzlim",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_num_rzlim"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nxs.GT.0) THEN
     ss%active_dims(ps_cnum_RAD) = ss%active_dims(ps_cnum_RAD) + 1
     ival = ss%nxs
     status = nf90_def_dim(icdf,"dim_nxs",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nxs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nz.GT.0) THEN
     ss%active_dims(ps_cnum_EQ) = ss%active_dims(ps_cnum_EQ) + 1
     ival = ss%nz
     status = nf90_def_dim(icdf,"dim_nz",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nz"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%nz_rip.GT.0) THEN
     ss%active_dims(ps_cnum_RIPPLE) = ss%active_dims(ps_cnum_RIPPLE) + 1
     ival = ss%nz_rip
     status = nf90_def_dim(icdf,"dim_nz_rip",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_nz_rip"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%n_D_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%n_D_einj_standard
     status = nf90_def_dim(icdf,"dim_n_d_einj_standard",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_n_d_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%n_H_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%n_H_einj_standard
     status = nf90_def_dim(icdf,"dim_n_h_einj_standard",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_n_h_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ss%n_T_einj_standard.GT.0) THEN
     ss%active_dims(ps_cnum_NBI) = ss%active_dims(ps_cnum_NBI) + 1
     ival = ss%n_T_einj_standard
     status = nf90_def_dim(icdf,"dim_n_t_einj_standard",ival,dimid)
     IF(status.NE.NF90_NOERR) THEN
        write(iout,*) " error defining dimension: dim_n_t_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_def_dim(icdf,"ps_clen_32",32,dimid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining dimension: ps_clen_32"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_def_dim(icdf,"ps_clen_256",256,dimid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining dimension: ps_clen_256"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_def_dim(icdf,"ps_clen_80",80,dimid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining dimension: ps_clen_80"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  ! hash codes dimension
  status = nf90_def_dim(icdf,"ps_hash_dim",ps_hash_total,dimid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining dimension:  ps_hash_dim"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  ! hash codes array
  idims(1)=dimid
  status = nf90_def_var(icdf,"hash_codes",NF90_INT, &
            dimids = idims(1:1), varid=varid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining:  hash_codes array variable."
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?plasma_state_store: error defining NetCDF dimensions."
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ELSE
     ierr = 0
  ENDIF

  !-------------------------------------------------
  !  define variables with attributes


  status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
  status = nf90_def_var(icdf,"version_id",NF90_CHAR, &
            dimids = idims(1:1), varid=varid)
  IF(status.NE.NF90_NOERR) THEN
     write(iout,*) " error defining:  version_id character string."
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  !  define variables with attributes -- subroutine calls

  call plasma_state_store_def_0(ss,icdf,iout,iertot)
  call plasma_state_store_def_1(ss,icdf,iout,iertot)
  call plasma_state_store_def_2(ss,icdf,iout,iertot)
  call plasma_state_store_def_3(ss,icdf,iout,iertot)
  call plasma_state_store_def_4(ss,icdf,iout,iertot)
  call plasma_state_store_def_5(ss,icdf,iout,iertot)
  call plasma_state_store_def_6(ss,icdf,iout,iertot)
  call plasma_state_store_def_7(ss,icdf,iout,iertot)
  call plasma_state_store_def_8(ss,icdf,iout,iertot)
  call plasma_state_store_def_9(ss,icdf,iout,iertot)

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?plasma_state_store: error defining NetCDF variables."
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ELSE
     ierr = 0
  ENDIF

  !------------------------------------
  ! transfer the data to NetCDF

  status = nf90_enddef(icdf)  ! exit definition mode

  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: nf90_enddef error"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  iertot = 0

  status = nf90_inq_varid(icdf,"version_id",varid)
  status = nf90_put_var(icdf,varid,ps_version_id)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing version_id"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  status = nf90_inq_varid(icdf,"hash_codes",varid)
  status = nf90_put_var(icdf,varid,ss%hash_codes)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing hash_codes"
     CALL ncerr(status)
     ierr = 9999
     status = nf90_close(icdf)
     RETURN
  ENDIF

  !  write variables -- subroutine calls

  call plasma_state_store_0(ss,icdf,iout,iertot)
  call plasma_state_store_1(ss,icdf,iout,iertot)
  call plasma_state_store_2(ss,icdf,iout,iertot)
  call plasma_state_store_3(ss,icdf,iout,iertot)
  call plasma_state_store_4(ss,icdf,iout,iertot)
  call plasma_state_store_5(ss,icdf,iout,iertot)
  call plasma_state_store_6(ss,icdf,iout,iertot)
  call plasma_state_store_7(ss,icdf,iout,iertot)
  call plasma_state_store_8(ss,icdf,iout,iertot)
  call plasma_state_store_9(ss,icdf,iout,iertot)

  status = nf90_close(icdf)

  IF(iertot.GT.0) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing NetCDF variables."
     ierr = 9999
     RETURN
  ELSE
     ierr = 0
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store

c-------------------------------------------------------------------
      subroutine trxpl_mkgs2_zef(npts,rho,n,z,zef1,zef2,nzsum1,nzsum2,
     >   esum1,esum2,zeffdata)
c
c  compute Zeff before/after smoothing.  If no smoothing, zef1=zef2
c
      use trxpl_gs2_module
c
      implicit NONE
c
      integer npts                      ! no. of pts
      real*8 rho(npts)                  ! evaluation grid
      real*8 n(npts),z(npts)            ! work arrays to store specie n & Z
      real*8 zef1(npts),zef2(npts)      ! Zeff before & after smoothing
      real*8 nzsum1(npts),nzsum2(npts)  ! 1/ne * n*Z sum before & after smooth
      real*8 esum1(npts),esum2(npts)    ! energy density (jles/m^3)
      real*8 zeffdata(npts)             ! Zeff data
c
c-----------------------
      real*8 ne(npts),nesm(npts),t(npts),tsm(npts),const
      integer j,ierr
c
c-----------------------
c
c  convert n*T, ptcl-keV/m^3, to Jles/m^3
c
      const=1.5d0*1.602d-16
c
      zef1=0.0d0
      zef2=0.0d0
c
      call eq_rgetf(npts,rho,id_norig(1),0,ne,ierr)
      if(ierr.ne.0)
     >   call errmsg_exit('?trxpl_mkgs2_zef rgetf error #0')
      if(nsmoo(1)) then
         call eq_rgetf(npts,rho,id_nsmoo(1),0,nesm,ierr)
         if(ierr.ne.0)
     >      call errmsg_exit('?trxpl_mkgs2_zef rgetf error #0A')
      else
         nesm=ne
      endif
c
      call eq_rgetf(npts,rho,id_torig(1),0,t,ierr)
      if(ierr.ne.0)
     >   call errmsg_exit('?trxpl_mkgs2_zef rgetf error #0C')
      if(tsmoo(1)) then
         call eq_rgetf(npts,rho,id_tsmoo(1),0,tsm,ierr)
         if(ierr.ne.0)
     >      call errmsg_exit('?trxpl_mkgs2_zef rgetf error #0D')
      else
         tsm=t
      endif
c
      call eq_rgetf(npts,rho,id_zeff,0,zeffdata,ierr)
      if(ierr.ne.0)
     >   call errmsg_exit('?trxpl_mkgs2_zef rgetf error #0E')
c
      t=t*Tconv(1)
      tsm=tsm*Tconv(1)
c
      nzsum1=0.0
      nzsum2=0.0
c
      esum1=ne*t*const
      esum2=nesm*tsm*const
c
      do j=1,num_species
         if(ltype(j).gt.0) then
c
c  this is an ion species
c
            if(id_zprof(j).gt.0) then
               call eq_rgetf(npts,rho,id_zprof(j),0,Z,ierr)
               if(ierr.ne.0)
     >            call errmsg_exit('?trxpl_mkgs2_zef rgetf error #9')
            else
               Z=Zplas(j)
            endif
c
            call eq_rgetf(npts,rho,id_norig(j),0,n,ierr)
            if(ierr.ne.0)
     >         call errmsg_exit('?trxpl_mkgs2_zef rgetf error #1')
c
            zef1=zef1+n*Z*Z
            nzsum1=nzsum1+n*Z
c
            call eq_rgetf(npts,rho,id_torig(j),0,t,ierr)
            if(ierr.ne.0)
     >         call errmsg_exit('?trxpl_mkgs2_zef rgetf error #1A')
            t=t*Tconv(j)
c
            esum1=esum1+n*t*const
c
            if(nsmoo(j)) then
               call eq_rgetf(npts,rho,id_nsmoo(j),0,n,ierr)
               if(ierr.ne.0)
     >            call errmsg_exit('?trxpl_mkgs2_zef rgetf error #2')
            endif
c
            if(tsmoo(j)) then
               call eq_rgetf(npts,rho,id_tsmoo(j),0,t,ierr)
               if(ierr.ne.0)
     >            call errmsg_exit('?trxpl_mkgs2_zef rgetf error #2')
               t=t*Tconv(j)
            endif
c
            zef2=zef2+n*Z*Z
            nzsum2=nzsum2+n*Z
            esum2=esum2+n*t*const
c
         endif
      enddo
c
      zef1=zef1/ne    ! Zeff = sum(ni*Zi**2)/ne
      zef2=zef2/nesm
c
      nzsum1=nzsum1/ne
      nzsum2=nzsum2/nesm
c
      write(6,*) 'trxpl_mkgs2_zef quasineutrality check:'
      write(6,*) '  (interpolation effects cause small deviations)'
      write(6,*) 'original data:  range ',minval(nzsum1),maxval(nzsum1)
      write(6,*) 'smoothed data:  range ',minval(nzsum2),maxval(nzsum2)
c
      return
      end

subroutine ps_remove_grid(iobj,iauthor,gname,iout,ierr)

  !  Update plasma state time
  !  XPLASMA2 implementation -- DMC Oct 10 2006

  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed:

  integer :: iobj(ps_container_size)     ! xplasma opaque container
  integer, intent(in) :: iauthor  ! component or author index
  character*(*), intent(in) :: gname   ! name of grid
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-------------------------------------------------------------------------
  !  local:
  
  integer :: id_grid,iertmp

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_remove_grid: invalid or unitialized xplasma object.'
     return
  endif

  !----------------------
  call xplasma_gridId(s,gname,id_grid)
  if(id_grid.eq.0) return

  !----------------------

  call xplasma_author_set(s, ps_cnames(iauthor), ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_remove_grid: xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  call xplasma_remove_grid(s, id_grid, ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_remove_grid: xplasma_remove_grid error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  call xplasma_author_clear(s, ps_cnames(iauthor), iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_remove_grid: xplasma_author_clear error:'
     call xplasma_error(s,iertmp,iout)
     ierr = iertmp
  endif

end subroutine ps_remove_grid

   subroutine add_tmplt(lun, runid, opt, stat)
      implicit none
! Input
      integer         lun           ! for error messages
      character*(*)   runid         ! runid
      integer         opt           ! 
! Return
      integer         stat

!
 integer, parameter            ::  n_rf=3

 character*3,  dimension(n_rf) ::  rf_type
 character*30                  ::  x_name
 character*200                 ::  t_name
 character*17                  ::  node
 character*8                   ::  code_type(2,2)

 logical                       :: ex
 integer                       :: mdsstat
 integer                       :: nid,     i,k

! Functions
 integer                       :: mds_add_node


 rf_type(1) = "ECH"
 rf_type(2) = "LHH"
 rf_type(3) = "ICH"

 code_type(1,1) = 'RFTMP'    ; code_type(2,1) = 'GENRAY'
 code_type(1,2) = 'CQL3DTMP' ; code_type(2,2) = 'CQL3D'

 do k = 1, size(code_type,2)
    do i =1,n_rf
       x_name=trim(runid)//'_'//trim(rf_type(i))//'.'//trim(adjustl(code_type(1,k)))
       !print *, 'looking for '//trim(x_name)
       inquire(file=x_name,exist=ex,iostat=stat)
       if (ex) then
          print *,'found '//trim(x_name)
          open(29,file=x_name,status='OLD',iostat=stat, &
               action="read")
          if (stat .eq. 0) then
             read(29,'(A)',iostat=stat) t_name
             close(29)
             if (stat .eq. 0) then
                node='.NML'
                nid = mds_add_node(trim(node),'structure',mdsstat)
                if (nid .le. 0) then
                   call mdsmsg(lun, &
                        '?add_tmplt: error creating '//trim(node)//'  - stat:',mdsstat)
                   go to 900
                endif
                node='.NML:'//trim(adjustl(code_type(2,k)))//'_'//trim(rf_type(i))
                nid = mds_add_node(trim(node),'text',mdsstat)
                print*,'nid =',nid
                if (nid .le. 0) then
                   call mdsmsg(lun, &
                        '?add_tmplt: error creating '//trim(node)//'  - stat:',mdsstat)
                else
                   print*,' call add_file ',node,' ',trim(t_name)
                   call add_file(lun,runid,node,trim(t_name),' ',' ',' ',stat)
                   if (stat .ne. 0) then
                      write(lun,'(" ?add_tmplt -- error adding ",a)') node
                   endif
                endif
             else
                write(lun,'(" ?add_tmplt -- error opening ",a,i6)') x_name,stat
             endif
          else
             write(lun,'(" ?add_tmplt -- error reading ",a,i6)') x_name,stat
          endif
       endif
900    continue
    enddo
 end do
 return
 end

subroutine trx_time(ztime,zdelta,iwarn,ierr)
  use trx_module
  implicit NONE
!
!   set the time and delta_t for fetching/averaging data
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  real*8, intent(IN) :: ztime      ! time of interest, seconds
  real*8, intent(IN) :: zdelta     ! delta(time), +/- for averaging, seconds
  integer, intent(OUT) :: iwarn    ! warn if ztime-zdelta or ztime+zdelta
                                   ! ...is outside the limit
 
  integer, intent(OUT) :: ierr     ! completion code: 0=OK
!
!-----------------------------
!
  integer lunzer
!
  real ztime_r4,zdelta_r4
!
!-----------------------------
!
  ierr=0
  iwarn=0
!
  ztime_r4=ztime
  zdelta_r4=zdelta
!
  if(nsctime.eq.0) then
     write(lunzer(0),*) ' ?trx_time:  call trx_connect first!'
     ierr=1
     return
  endif
!
!  set module variables...
!
  itset=1
!
  time0=max(tmin,min(tmax,ztime_r4))
  if(time0.ne.ztime_r4) iwarn=1
!
  delta_t=abs(zdelta_r4)
!
  if((time0+delta_t).gt.tmax) iwarn=1
  if((time0-delta_t).lt.tmin) iwarn=1
!
  return
end subroutine trx_time

      subroutine trxpl_mkgs2(tpath,ztime0,ztavg,ierr)
c
c  make GS2 namelists -- information on plasma species
c
c  also, extensive plotting of GS2-related profiles:  temperatures,
c    densities, derivatives, with optional normalization to "reference"
c    temperatures and densities.
c
c  profiles can be smoothed & GS2 namelists written at multiple spatial
c    locations.
c
c  ion species can be "aggregated" -- one species slot representing a
c    sum of several actual ion species (summed density, and <T>,<Z>,<A>
c    done so as to preserve Zeff and quasineutrality contribution).
c
c----------------------------------------------
c
      use trxpl_gs2_module
      use periodic_table_mod
c
      implicit NONE
c
      character*(*), intent(in) :: tpath    ! TRANSP run specification
      real*8, intent(in) :: ztime0          ! time of interest
      real*8, intent(in) :: ztavg           ! +/- delta(t) time averaging
      integer, intent(out) :: ierr          ! completion code, 0=OK
c
c-----------------------------------------------
      real*8 zrhomin,zrhomax,zrmin,zrmax,zzmin,zzmax,zmpme,zminm
c
      integer :: id,idz,id_g=0
      integer i,j,k,ierimp
      integer ifirst
      integer idum1,idum2,idum3,idum4
c
      integer isize,jsize
      character*10, dimension(:), allocatable :: zimplist,zimplabl
      integer, dimension(:), allocatable :: izim,icim
      real, dimension(:), allocatable :: aaim
c
      integer iansr
      logical lxout,lchar
      integer lnout,idcod
c
c  TRANSP multigraph information
c
      integer istype,imulti
      character*10 zname
      character*32 zunits
      character*64 zlabel
      integer infuns
      integer isigns(max_species)
      integer ias(max_species)
      integer izs(max_species)
      character*10 zmembs(max_species)
c
c
      integer nrho,nintrp,inper,ispecie,iert,istat
      real*8, dimension(:), allocatable :: rho_grid,rho_intrp
      real*8, dimension(:), allocatable :: data_grid,data_intrp
      real*8, dimension(:), allocatable :: deriv_grid,deriv_intrp
      real*8, dimension(:), allocatable :: zsum1,zsum2,zsum3,zsum4,
     >   zsum5,zsum6,zsum7
c
      real*8 zrat,zfac
c
      character*30 wlabel,wunits
      character*70 tlabel
c
c  multiplot labels & work arrays
c
      character*60 mnlab(3)
      character*17 kylab(5)
      integer, parameter :: max_mp=15
      character*10 lbfun(max_mp)
      integer iself(max_mp),nc(max_mp)
      real*8 zdum(max_mp),zconv
      integer infmp,idmp,iwant
      real*8, dimension(:,:), allocatable :: mprho,mpfun
c
      logical plotn,ideriv,nnorm
c-----------------------------------------------
c
      zmpme = 1.8362d3  ! mp/me, proton/electron mass ratio
      zminm = 1.0d-4    ! min temperature & density (instead of zero)
c
      tlabel=' '
      write(tlabel,999) ztime0,ztavg
 999  format(' time of interest = ',1pe11.4,' +/- ',1pe11.4,' seconds.')
c
      if((tpath.ne.transp_path).or.(ztime0.ne.transp_time).or.
     >   (ztavg.ne.transp_delt)) then
 
         transp_path = tpath
         transp_time = ztime0
         transp_delt = ztavg

         mpath0 = ' '
         mpath = ' '
         opath0 = ' '
         opath = ' '

         ofile_prefix='trgs2'
         ofile_suffix='naml.dat'

         username = ' '
         hostname = ' '

         call sget_user(username)
         call sget_host(hostname)
 
         num_species = 0

         tref_lbl='Te'
         num_reft = 1        ! Tref=Te by default, but Tref=Ti can be selected.
         num_refn = 1        ! nref=ne always!

         Tref=0
         nref=0

         tmjtx = .FALSE.     ! by default use same Ti for bulk & impurities
 
         mass_ref = 0.0d0
c
c  get minor radius from equilibrium
c
         call eq_rholim(zrhomin,zrhomax)
         call eq_glimrz(zrhomax,zrmin,zrmax,zzmin,zzmax,ierr)
         if(ierr.ne.0) then
            call uermsg('?trxpl_mkgs2:  eq_glimrz error during setup.',
     >         ' ',0)
            transp_path=' '
            return
         endif
c
         aminor = (zrmax-zrmin)/2.0d0
         R0 = (zrmax+zrmin)/2.0d0
c
         call eq_gfnum('g',id_g)
         call eq_rgetf(1,zrhomax,id_g,0,b_t0,ierr)  ! vacuum R*Bt
         if(ierr.ne.0)then
            call uermsg('?trxpl_mkgs2:  eq_rgetf("G") error.',
     >         ' ',0)
            transp_path=' '
            return
         endif
c
         b_t0=b_t0/R0                   ! reference B field, Tesla
c
c  query user about desired fit order ... & other options
c
         j=0
         do
            if(lxout(0)) then
               write(lnout(0),1001) tref_lbl,tmjtx,mass_ref, 
     >            mpath(1:len_trim(mpath)),opath(1:len_trim(opath)),
     >            ofile_prefix(1:len_trim(ofile_prefix)),
     >            ofile_suffix(1:len_trim(ofile_suffix))
 1001          format(/
     >            ' ==> trxpl_mkgs2 version: 13-Jun-2005 (dmc)'/
     >            ' TRXPL_MKGS2 configuration options:'/
     >            '     currently Tref = ',a/
     >            '     flag to use TX & TMJ = ',L1/
     >            ' "I" to make Tref = Ti (bulk ion temperature)'/
     >            ' "E" to make Tref = Te (electron temperature)'/
     >            ' "S" for separation of impurity and bulk ion'/
     >            '     temperatures (use TRANSP "TX" and "TMJ" data)'/
     >            ' "A" to assume same Ti for all thermal species'/
     >            '     (use TRANSP "TI" data)'/
     >           ' "M" to set reference mass (currently: ',1pd10.3,')'//
     >            '     directory for template files: ',a/
     >            '     directory for namelist files: ',a/
     >            '     default namelist filename prefix: ',a/
     >            '     default namelist filename suffix: ',a/
     >            ' "T" to set directory path for namelist templates'/
     >          ' "N" to set directory path for namelist output files'/
     >            ' "F" to set filename default prefix & suffix:'//
     >            ' "1" to choose C1 Hermite profiles and CONTINUE...'/
     >            ' "2" to choose C2 Spline profiles and CONTINUE...'/
     >            ' "Q" to quit (immediate exit from TRXPL_MKGS2)'/)
            endif
            call uread(
     >         'trxpl_mkgs2:  enter "1" for C1 Hermite, '//
     >         'enter "2" for C2 spline profiles:$')
            if(lchar('Q')) then
               ierr=1
               transp_path=' '
               return
            else if(lchar('1')) then
               iorder=1
               exit
            else if(lchar('2')) then
               iorder=2
               exit
            else if(lchar('T')) then
               call trxpl_gs2_path('TEMPLATE_FILES',mpath0,mpath)
            else if(lchar('N')) then
               call trxpl_gs2_path('OUTPUT_NAMELISTS',opath0,opath)
            else if(lchar('F')) then
               call ureadw('trxpl_mkgs2: default prefix:$',ofile_prefix)
               call ureadw('trxpl_mkgs2: default suffix:$',ofile_suffix)
            else if(lchar('I')) then
               ! option enabled dmc 13 May 2004 -- after collisionality
               ! formula verification/correction by M. Redi
               !  (see trxpl_gs2_get.for)
               num_reft=2
               tref_lbl='Ti'
            else if(lchar('E')) then
               num_reft=1
               tref_lbl='Te'
            else if(lchar('A')) then
               tmjtx=.FALSE.
            else if(lchar('S')) then
               tmjtx=.TRUE.
            else if(lchar('M')) then
               if(lxout(0)) write(lnout(0),*) ' enter 3 for "T"...'
               j=2
               call ureadi(
     >            'trxpl_mkgs2:  reference Mass: 1 for "H",'//
     >            ' 2 for "D":$',j)
               j=max(1,min(3,j))
               mass_ref = j
            else
               call uermsg('?trxpl_mkgs2:  unrecognized option.',' ',0)
            endif
         enddo
c
c  query user about reference mass (if it has not been set
c
         if(j.eq.0) then
            do 
               if(lxout(0)) write(lnout(0),*) ' enter 3 for "T"...'
               j=2                      ! default: "D"
               call ureadi(
     >            'trxpl_mkgs2:  reference Mass: 1 for "H",'//
     >            ' 2 for "D":$',j)
               if((j.lt.1).or.(j.gt.3)) then
                  call uermsg('?trxpl_mkgs2:  enter "1", "2" or "3".',
     >               ' ',0)
               else
                  mass_ref=j
                  exit
               endif
            enddo
         endif
c
c  clear smooth flags & non-thermal flags
c
         gsmoo=.FALSE.
         gaggr=.FALSE.
         fast_aggr=.FALSE.
         nsmoo=.FALSE.
         tsmoo=.FALSE.
         dx_smooth_n=0
         dx_smooth_t=0
c
         ltype=0
c
c  clear Z, A and profile id arrays
c
         Aplas = 0.0d0
         Zplas = 0.0d0
         id_zprof=0
         id_aprof=0
c
         id_norig=0
         id_nsmoo=0
c
         id_torig=0
         id_tsmoo=0
c
c------------------------------------
c
c  get the ion temperature
c
         call trx_prof('TI',zunits,iorder,id_ti,ierr)
         if(ierr.ne.0) then
            call uermsg('TRANSP profile access failed','TI',0)
            transp_path=' '
            return
         endif
c
         if(tmjtx) then
            call trx_prof('TX',zunits,iorder,id_tx,ierr)
            if(ierr.ne.0) then
               write(6,*) ' %warning -- reverting to use "TI" only.'
               call uermsg('TRANSP profile access failed','TX',0)
               tmjtx=.FALSE.
            endif
         endif
         if(tmjtx) then
            call trx_prof('TMJ',zunits,iorder,id_tmj,ierr)
            if(ierr.ne.0) then
               write(6,*) ' %warning -- reverting to use "TI" only.'
               call uermsg('TRANSP profile access failed','TMJ',0)
               tmjtx=.FALSE.
            endif
         endif
c
         if(.not.tmjtx) then
            id_tmj=id_ti
            id_tx=id_ti
         endif
c
c  get the electron data
c
         num_species = num_species + 1
         j = num_species
c
         Aplas(j) = 1.0d0/(mass_ref*zmpme)
         Zplas(j) = -1.0d0
         Tconv(j) = 1.0d0
c
         call trx_prof('NE',zunits,iorder,id_norig(j),ierr)
         id_ne=id_norig(j)
         if(ierr.ne.0) then
            call uermsg('TRANSP profile access failed','NE',0)
            transp_path=' '
            return
         endif
c
         call trx_prof('TE',zunits,iorder,id_torig(j),ierr)
         id_te=id_torig(j)
         if(ierr.ne.0) then
            call uermsg('TRANSP profile access failed','TE',0)
            transp_path=' '
            return
         endif
c
         ltype(j)=0
         slabel(j)='electron'
c
c  get Zeff (for comparisons)
c
         call trx_prof('ZEFFP',zunits,iorder,id_zeff,ierr)
         if(ierr.ne.0) then
            call uermsg('TRANSP profile access failed','ZEFFP',0)
            transp_path=' '
            return
         endif
c
c-------------------------------------
c
c  get the non-impurity thermal species data
c
         call rpmulti('PDENS',istype,zlabel,zunits,infuns,isigns,zmembs,
     >      ierr)
         if(ierr.ne.0) then
            call uermsg('TRANSP "PDENS" multigraph not found.',' ',0)
            transp_path=' '
            return
         endif
c
c  check status of members...
c
         call rdi_ckpdens(infuns,zmembs,ias,izs,ierr)
         if(ierr.ne.0) then
            call uermsg('TRANSP "PDENS" member: Z unknown:',
     >         zmembs(ierr),0)
            transp_path=' '
            return
         endif
c
c  setup each of the thermal ion species
c
         do i=1,infuns
            if(izs(i).gt.0) then
               num_species=num_species+1
               j=num_species
               ltype(j)=1
               if(num_reft.gt.1) num_reft=j ! be sure to get an ltype=1 specie
               id_torig(j)=id_tmj
               Aplas(j)=ias(i)/mass_ref
               Zplas(j)=izs(i)
               Tconv(j)=1.0d0
               call trx_prof(zmembs(i),zunits,iorder,id_norig(j),ierr)
               if(ierr.ne.0) then
                  call uermsg('TRANSP profile access failed',
     >               zmembs(i),0)
                  transp_path=' '
                  return
               endif
               slabel(j)=zmembs(i)(2:)
               k=len_trim(slabel(j))+2
               slabel(j)(k:)='thermal ion'
            endif
         enddo
c
c----------------------------------------
c
c  get the impurity thermal species data
c
         call rpnlist('profile:NIMP_',1,isize)
         if(isize.gt.0) then
            allocate(zimplist(isize))
            call rplist('profile:NIMP_',1,zimplist,isize,jsize,ierr)
            if(ierr.ne.0) then
               call uermsg(
     >            'TRANSP impurity profile information access error.',
     >            ' ',0)
               transp_path=' '
               deallocate(zimplist)
               return
            endif
         endif
c
c  OK:  look for impurity species.  If none are found, we will assume
c  a single impurity model (NIMP, XZIMP)
c
         jsize=0
         if(isize.gt.0) then
            allocate(aaim(isize),icim(isize),izim(isize))
            allocate(zimplabl(isize))
            do i=1,isize
               aaim(i)=0.0
               icim(i)=0
               izim(i)=0
               call uupper(zimplist(i))
               if((zimplist(i)(1:5).eq.'NIMP_').and.
     >            (index(zimplist(i)(6:10),'_').gt.0)) then
c  label has the TRANSP form for a specific impurity ion...
                  call rplabel(zimplist(i),zlabel,zunits,imulti,istype)
                  j=index(zlabel,' ')-1    ! TRANSP impurity ion code
c
c  impurity code has forms like "C+6", "O+8", "Ni+28", etc.
                  call inv_periodic_table(zlabel(1:j),.TRUE.,
     >               izim(i),aaim(i),icim(i))
                  if(izim(i).gt.0) then
                     jsize=jsize+1           ! found one...
                     zimplabl(i)=zlabel(1:j) ! save the id label
                  endif
               endif
            enddo
         endif
c
         ierimp=0
         if(jsize.eq.0) then
c  traditional single impurity model:  note Z & A can vary in time
            call rplabel('NIMP',zlabel,zunits,imulti,istype)
            if(istype.eq.1) then
               num_species=num_species+1
               j=num_species
               ltype(j)=2
               id_torig(j)=id_tx
               call trx_scal('XZIMP',zunits,Zplas(j),ierimp)
               if(ierimp.ne.0) call uermsg('XZIMP read failure',' ',0)
               if(ierimp.eq.0) then
                  call trx_scal('AIMP',zunits,Aplas(j),ierimp)
                  if(ierimp.ne.0) call uermsg('AIMP read failure',' ',0)
                  Aplas(j)=Aplas(j)/mass_ref
               endif
               Tconv(j)=1.0d0
               if(ierimp.eq.0) then
                  call trx_prof('NIMP',zunits,iorder,id_norig(j),ierimp)
                  if(ierimp.ne.0) call uermsg('NIMP read failure',' ',0)
                  slabel(j)='impurity'
                  k=len_trim(slabel(j))+2
                  slabel(j)(k:)='thermal ion'
               endif
            endif
         else
c  multi impurity model
            do i=1,isize
               if(izim(i).gt.0) then
                  num_species=num_species+1
                  j=num_species
                  ltype(j)=2
                  id_torig(j)=id_tx
                  Zplas(j)=icim(i)
                  Aplas(j)=aaim(i)/mass_ref
                  Tconv(j)=1.0d0
                  call trx_prof(zimplist(i),zunits,iorder,id_norig(j),
     >               ierimp)
                  if(ierimp.ne.0)
     >               call uermsg('read failure',zimplist(i),0)
                  slabel(j)=zimplabl(i)
                  k=len_trim(slabel(j))+2
                  slabel(j)(k:)='impurity thermal ion'
                  if(ierimp.gt.0) exit
               endif
            enddo
         endif
c
c  deallocate impurity access stuff
c
         if(isize.gt.0) then
            deallocate(zimplist)
            deallocate(zimplabl)
            deallocate(aaim,icim,izim)
         endif
c
c  report if there were errors
c
         if(ierimp.gt.0) then
            call uermsg(
     >         '?trxpl_mkgs2:  errors reading impurity ion data',' ',0)
            transp_path=' '
            return
         endif
c
c----------------------------------------
c  fast species...
c
         zrat=2.0d0/3.0d0
         call trxpl_gs2fas(3,'BDENSS','BDENS','EBEAM',zrat,ierr)
         if(ierr.ne.0) then
            call uermsg('?trxpl_mkgs2:  error reading beam species',
     >         ' ',0)
            transp_path=' '
            return
         endif
c
         zrat=1.0d0
         call trxpl_gs2fas(4,'RFDENS','NMINI','TMINI',zrat,ierr)
         if(ierr.ne.0) then
            call uermsg('?trxpl_mkgs2:  error reading RF minorities',
     >         ' ',0)
            transp_path=' '
            return
         endif
c
         zrat=2.0d0/3.0d0
         call trxpl_gs2fas(5,'FDENSS','FDENS','EFUSN',zrat,ierr)
         if(ierr.ne.0) then
            call uermsg('?trxpl_mkgs2:  error reading fusion products',
     >         ' ',0)
            transp_path=' '
            return
         endif
         write(lnout(0),*)
     >      ' (note-- "unrecognized item name" warnings referring to'
         write(lnout(0),*)
     >      ' BDENSS or RFDENS or FDENSS can be ignored; these messages'
         write(lnout(0),*)
     >  ' occur when a TRANSP run lacks a category of fast ion species)'
c
c----------------------------------------
c  all done acquiring species data
c
      endif
c
c----------------------------------------
c
c  get radial grid information
c
      call eq_xid_mag(id_ne,idum1,id_rho,idum2,idum3,idum4,ierr)
      if(id_rho.eq.0) call errmsg_exit('?trxpl_mkgs2: id_rho=0??')
      call eq_ngrid(id_rho,nrho)
c
      allocate(rho_grid(nrho),data_grid(nrho),deriv_grid(nrho))
c
      inper=10
      nintrp=inper*(nrho-1)+1
      allocate(rho_intrp(nintrp),data_intrp(nintrp),deriv_intrp(nintrp))
      allocate(zsum1(nintrp),zsum2(nintrp),zsum3(nintrp),zsum4(nintrp))
      allocate(zsum5(nintrp),zsum6(nintrp),zsum7(nintrp))
c
      call eq_grid(id_rho,rho_grid,nrho,k,ierr)
      if(ierr.ne.0) call errmsg_exit(
     >   '?trxpl_mkgs2: eq_grid ierr.ne.0??')
c
      rho_intrp(nintrp)=rho_grid(nrho)
      do i=1,nrho-1
         do j=1,inper
            k=inper*(i-1)+j
            rho_intrp(k)=
     >         ((j-1)*rho_grid(i+1)+(inper-j+1)*rho_grid(i))/inper
         enddo
      enddo
c
c  user data examination loop
c
      plotn=.true.
      ideriv=.false.
      nnorm=.false.
      ispecie=1
      zrat=Tconv(ispecie)
      ifirst=1
c
 100  continue
c
      if(plotn) then
         if(nsmoo(ispecie)) then
            id=id_nsmoo(ispecie)
         else
            id=id_norig(ispecie)
         endif
         idz=id_zprof(ispecie)
         if(.not.ideriv) then
            if(nnorm) then
               wlabel='Density * (1/ne)'
               wunits=' '
            else
               wlabel='Density'
               wunits='/m^3'
            endif
         else
            wlabel='-(1/(nZ))*(d(nZ)/drho)'
            wunits=' '
         endif
      else
         if(tsmoo(ispecie)) then
            id=id_tsmoo(ispecie)
         else
            id=id_torig(ispecie)
         endif
         idz=id_zprof(ispecie)
         if(.not.ideriv) then
            if(nnorm) then
               wlabel='Temperature * (1/'//tref_lbl//')'
               wunits=' '
            else
               wlabel='Temperature'
               wunits='keV'
            endif
         else
            wlabel='-(1/T)*(dT/drho)'
            wunits=' '
         endif
      endif
c
      if(lxout(0)) then
         write(lnout(0),*) ' '
         if(iorder.eq.1) then
            write(lnout(0),*) '   profile interpolation:  C1 Hermite.'
         else
            write(lnout(0),*) '   profile interpolation:  C2 Spline.'
         endif
c
         call trxpl_mkgs2_summ(lnout(0),' see "Z" option')
c
         write(lnout(0),*) ' '
         if(gsmoo) write(lnout(0),*)
     >      ' ** some or all profiles were smoothed **'
         write(lnout(0),*) ' plotting:  ',wlabel,' SELECTED specie = #',
     >      ispecie
         write(lnout(0),*) ' '
         write(lnout(0),1003) ifirst
 1003    format(
     >      ' ==> trxpl_mkgs2 version: 13-Jun-2005 (dmc)'/
     >      ' trxpl_mkgs2 options:'/
     >      '  <a number> -- to change SELECTED plasma specie'/
     >      '  N -- to select density'/
     >      '  T -- to select temperature'/
     >      '  F -- to select the data itself'/
     >      '  G -- to select data normalized to reference data'/
     >      '  D -- to select -(1/data)(d(data)/drho)'/
     >      '  A -- (optional) set 1st specie for multiplot (',i3,')'//
     >      '  C -- collisionality (and other) interpolated multiplots'/
     >      '       (C, M options test different evaluation methods)'/
     >      '  M -- make multiplot-- data points only, all species.'/
     >      '  P -- plot, show data points and interpolation.'/
     >      '  Z -- print/plot Z, A, or Zeff data (Edens also).'//
     >      '  R -- reduce number of ion species via aggregation'/
     >     '  S -- smooth selected data profiles (or cancel smoothing)'//
     >      '  W -- ** write GS2 namelist file'/
     >      '  Q -- quit')
      endif
      call uread('trxpl_mkgs2 option:$')
c
      if(lchar('Q')) then
         if(ierr.eq.0) then
            write(lnout(0),*) ' trxpl_mkgs2: normal exit.'
         endif
         go to 1000   ! *** for now ***
      else if(lchar('W')) then
         call trxpl_mkgs2_write(tlabel)
      else if(lchar('N')) then
         plotn=.TRUE.
      else if(lchar('T')) then
         plotn=.FALSE.
      else if(lchar('D')) then
         ideriv=.TRUE.
         nnorm=.FALSE.
      else if(lchar('F')) then
         ideriv=.FALSE.
         nnorm=.FALSE.
      else if(lchar('G')) then
         ideriv=.FALSE.
         nnorm=.TRUE.
      else if(lchar('A')) then
         call ureadi('enter new multiplot 1st specie number:$',ifirst)
         ifirst=max(1,min(num_species,ifirst))
      else if(lchar('P')) then
         call eq_rgetf(nrho,rho_grid,id,0,data_grid,ierr)
         if(ierr.ne.0) call errmsg_exit('?trxpl_mkgs2: eq_rgetf 1??')
         if(.not.plotn) data_grid=zrat*data_grid
         data_grid=max(zminm,data_grid)
         call eq_rgetf(nintrp,rho_intrp,id,0,data_intrp,ierr)
         if(ierr.ne.0) call errmsg_exit('?trxpl_mkgs2: eq_rgetf 2??')
         if(.not.plotn) data_intrp=zrat*data_intrp
         data_intrp=max(zminm,data_intrp)
c
         if(ideriv) then
            call eq_rgetf(nrho,rho_grid,id,1,deriv_grid,ierr)
            if(ierr.ne.0) call errmsg_exit('?trxpl_mkgs2: eq_rgetf 3??')
            call eq_rgetf(nintrp,rho_intrp,id,1,deriv_intrp,ierr)
            if(ierr.ne.0) call errmsg_exit('?trxpl_mkgs2: eq_rgetf 4??')
            if(plotn) then
c  density (& nZ)...
               if(idz.eq.0) then
                  data_grid=-deriv_grid/data_grid   ! Z indep. of rho
                  data_intrp=-deriv_intrp/data_intrp
               else
c  Z variation, need to compute -((1/n)*(dn/drho)+(1/Z)*(dZ/drho))
                  call eq_rgetf(nrho,rho_grid,idz,0,zsum1,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 3A??')
                  call eq_rgetf(nintrp,rho_intrp,idz,0,zsum3,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 4A??')
                  call eq_rgetf(nrho,rho_grid,idz,1,zsum2,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 3B??')
                  call eq_rgetf(nintrp,rho_intrp,idz,1,zsum4,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 4B??')
c
                  data_grid=-( (deriv_grid/data_grid) +
     >               (zsum2(1:nrho)/zsum1(1:nrho)) )
                  data_intrp=-( (deriv_intrp/data_intrp) +
     >               (zsum4/zsum3) )
               endif
c
            else
c  Temperature...
               zfac=zrat
               data_grid=-zfac*deriv_grid/data_grid
               data_intrp=-zfac*deriv_intrp/data_intrp
            endif
         endif
c
         if(nnorm) then
            if(plotn) then
               if(nsmoo(num_refn)) then
                  call eq_rgetf(nrho,rho_grid,id_nsmoo(num_refn),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 5??')
                  call eq_rgetf(nintrp,rho_intrp,id_nsmoo(num_refn),0,
     >               deriv_intrp,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 6??')
               else
                  call eq_rgetf(nrho,rho_grid,id_norig(num_refn),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 5A??')
                  call eq_rgetf(nintrp,rho_intrp,id_norig(num_refn),0,
     >               deriv_intrp,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 6A??')
               endif
            else
               if(tsmoo(num_reft)) then
                  call eq_rgetf(nrho,rho_grid,id_tsmoo(num_reft),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 7??')
                  call eq_rgetf(nintrp,rho_intrp,id_tsmoo(num_reft),0,
     >               deriv_intrp,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 8??')
               else
                  call eq_rgetf(nrho,rho_grid,id_torig(num_reft),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 7A??')
                  call eq_rgetf(nintrp,rho_intrp,id_torig(num_reft),0,
     >               deriv_intrp,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 8A??')
               endif
            endif
c
c  "deriv" arrays now contain reference parameter -- not a derivative
c
            data_grid=data_grid/deriv_grid
            data_intrp=data_intrp/deriv_intrp
         endif
c
         call r8_grafxf(rho_intrp,data_intrp,nintrp,
     >      rho_grid,data_grid,nrho,' ',wunits,tpath,tlabel,
     >      slabel(ispecie)//wlabel//' vs. rho')
c
      else if(lchar('C')) then
c
 110     continue
         mnlab(1)=tpath
         mnlab(2)=tlabel
         kylab=' '
         kylab(1)='plasma species:'
         if(lxout(0)) then
            write(lnout(0),2001)
 2001       format(' plot points evaluated as for GS2 namelist...'/
     >         ' choose one option for plot:'/
     >         '  N - density (normalized)'/
     >         '  T - temperature (normalized)'/
     >         '  F - (1/(nZ))*(d(nZ)/drho)'/
     >         '  G - (1/T)*(dT/drho)'/
     >         '  M - mass (normalized)'/
     >         '  Z - charge'/
     >         '  Y - Zeff comparison'/
     >         '  U - "uprime" (currently zero)'/
     >         '  C - collisionalities'/
     >         '  P - plot d( sum(nZ) )/drho & d(ne)/drho'/
     >         '  S - quasineutrality renormalization factors'/
     >         '  Q - quit this menu')
         endif
         call uread('GS2 eval plot option:$')
         if(lchar('Q')) then
            go to 100
         else if(lchar('N')) then
            iwant=1
            mnlab(3)='n/nref (nref=ne) vs. rho'
         else if(lchar('T')) then
            iwant=2
            mnlab(3)='T/Tref (Tref='//Tref_lbl//') vs. rho'
         else if(lchar('F')) then
            iwant=3
            mnlab(3)='-(1/(nZ))*(d(nZ)/drho) vs. rho'
         else if(lchar('G')) then
            iwant=4
            mnlab(3)='-(1/T)*(dT/drho) vs. rho'
         else if(lchar('M')) then
            iwant=5
            write(mnlab(3),'(''m/mref (mref='',f7.4,'' AMU) vs. rho'')')
     >         mass_ref
         else if(lchar('Z')) then
            iwant=6
            mnlab(3)='Z vs. rho'
         else if(lchar('U')) then
            iwant=7
            mnlab(3)='"uprime" vs. rho'
         else if(lchar('C')) then
            iwant=8
            mnlab(3)='collisionalities (GS2 formula) vs. rho'
         else if(lchar('Y')) then
            iwant=9
            mnlab(3)='Zeff (TRANSP data; computed) vs. rho'
         else if(lchar('S')) then
            iwant=10
            mnlab(3)=
     >         '(nz) and grad(nz) quasineutrality renormalizations'
         else if(lchar('P')) then
            iwant=11
            mnlab(3)=
     >         'grad(ne) and un-renormalized grad(sum(nz)) vs. rho'
         else
            call uermsg('?invalid GS2 eval plot option',' ',0)
            go to 110
         endif
c
         infmp=min(max_mp,num_species-ifirst+1)
         if(iwant.eq.9) infmp=2
         if(iwant.eq.10) infmp=2
         if(iwant.eq.11) infmp=2
c
         allocate(mprho(nintrp,infmp),mpfun(nintrp,infmp))
c
         do i=1,infmp
            j=ifirst+i-1
            nc(i)=nintrp
            iself(i)=i
            zdum(i)=j
            if(iwant.lt.9) then
               lbfun(i)=
     >            slabel(j)(1:len(lbfun(i))) ! will be truncated
            endif
         enddo
         if(iwant.eq.9) then
            lbfun(1)='Zeff_TR'
            lbfun(2)='Zeff_calc'
         endif
         if(iwant.eq.10) then
            lbfun(1)='nz_renorm'
            lbfun(2)='dnz_renorm'
         endif
         if(iwant.eq.11) then
            lbfun(1)='grad(ne)'
            lbfun(2)='grad(nz+*)'
         endif
c
         wunits=' '
         do i=1,nintrp
            call trxpl_gs2_get(rho_intrp(i),ierr)  ! see nvec, etc., in module
            if(ierr.ne.0) then
               call uermsg(' ?trxpl_gs2_get evaluation error.',' ',0)
               go to 100
            endif
c
            mprho(i,1:infmp)=rho_intrp(i)
            if(iwant.eq.1) then
               mpfun(i,1:infmp)=nvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.2) then
               mpfun(i,1:infmp)=tvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.3) then
               mpfun(i,1:infmp)=npvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.4) then
               mpfun(i,1:infmp)=tpvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.5) then
               mpfun(i,1:infmp)=avec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.6) then
               mpfun(i,1:infmp)=zvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.7) then
               mpfun(i,1:infmp)=upvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.8) then
               mpfun(i,1:infmp)=nuvec(ifirst:ifirst+infmp-1)
            else if(iwant.eq.9) then
               mpfun(i,1)=zeff_tr
               mpfun(i,2)=zeff_calc
            else if(iwant.eq.10) then
               mpfun(i,1)=renorm_nz
               mpfun(i,2)=renorm_gradnz
            else if(iwant.eq.11) then
               mpfun(i,1)=ne_grad
               mpfun(i,2)=sumnz_grad
            endif
         enddo
c
         iself(1)=-iself(1)  ! signal functions not contours
         call r8_grfmm1(mprho,mpfun,nintrp,
     >      nc,infmp,zdum,infmp,iself,infmp,
     >      ' ',wunits,mnlab,kylab,lbfun)
c
         deallocate(mprho,mpfun)
         go to 110
c
      else if(lchar('M')) then
c
         mnlab(1)=tpath
         mnlab(2)=tlabel
         mnlab(3)=wlabel//' vs. rho'
         kylab=' '
         kylab(1)='plasma species:'
c
         infmp=min(max_mp,num_species-ifirst+1)
c
         allocate(mprho(nrho,infmp),mpfun(nrho,infmp))
c
         if(nnorm) then
            if(plotn) then
               if(nsmoo(num_refn)) then
                  call eq_rgetf(nrho,rho_grid,id_nsmoo(num_refn),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 10??')
               else
                  call eq_rgetf(nrho,rho_grid,id_norig(num_refn),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 10A??')
               endif
            else
               if(tsmoo(num_reft)) then
                  call eq_rgetf(nrho,rho_grid,id_tsmoo(num_reft),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 11??')
               else
                  call eq_rgetf(nrho,rho_grid,id_torig(num_reft),0,
     >               deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 11A??')
               endif
            endif
         endif
 
         do i=1,infmp
            j=ifirst+i-1
            nc(i)=nrho
            iself(i)=i
            zdum(i)=j
            lbfun(i)=
     >         slabel(j)(1:len(lbfun(i))) ! will be truncated
            mprho(1:nrho,i)=rho_grid
            if(plotn) then
               if(nsmoo(i)) then
                  idmp=id_nsmoo(i)
               else
                  idmp=id_norig(i)
               endif
               zconv=1.0d0
            else
               if(tsmoo(i)) then
                  idmp=id_tsmoo(i)
               else
                  idmp=id_torig(i)
               endif
               zconv=Tconv(i)
            endif
            call eq_rgetf(nrho,rho_grid,idmp,0,data_grid,ierr)
            if(ierr.ne.0) call errmsg_exit(
     >         '?trxpl_mkgs2: eq_rgetf 12??')
            if(ideriv) then
               call eq_rgetf(nrho,rho_grid,idmp,1,deriv_grid,ierr)
               if(ierr.ne.0) call errmsg_exit(
     >            '?trxpl_mkgs2: eq_rgetf 13??')
               mpfun(1:nrho,i)=-deriv_grid/data_grid
               if(plotn.and.(id_zprof(i).ne.0)) then
!  dZ/drho term...
                  idmp=id_zprof(i)
                  call eq_rgetf(nrho,rho_grid,idmp,0,data_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 12A??')
                  call eq_rgetf(nrho,rho_grid,idmp,1,deriv_grid,ierr)
                  if(ierr.ne.0) call errmsg_exit(
     >               '?trxpl_mkgs2: eq_rgetf 13A??')
                  mpfun(1:nrho,i)=mpfun(1:nrho,i)-deriv_grid/data_grid
               endif
            else if(nnorm) then
               mpfun(1:nrho,i)=zconv*data_grid/deriv_grid
            else
               mpfun(1:nrho,i)=zconv*data_grid
            endif
         enddo
c
         iself(1)=-iself(1)  ! signal functions not contours
         call r8_grfmm1(mprho,mpfun,nrho,
     >      nc,infmp,zdum,infmp,iself,infmp,
     >      ' ',wunits,mnlab,kylab,lbfun)
c
         deallocate(mprho,mpfun)
c
      else if(lchar('Z')) then
         if(lxout(0)) write(lnout(0),*)
     >      ' enter "1", "2", or...'
         if(lxout(0)) write(lnout(0),*)
     >      ' enter "3" for quasineutrality plot;'
         if(lxout(0)) write(lnout(0),*)
     >      ' enter "4" for energy density plot;'
         call uread('enter "1" for Zeff, "2" for Z & A information:$')
         if(lchar('1')) then
            iansr=1
         else if(lchar('2')) then
            iansr=2
         else if(lchar('3')) then
            iansr=3
         else if(lchar('4')) then
            iansr=4
         else if(lchar('Q')) then
            iansr=0
         else
            iansr=0
            call uermsg('?expected "Q" or "1" or "2" or "4"',' ',0)
         endif
c
         if((iansr.eq.1).or.(iansr.eq.3).or.(iansr.eq.4)) then
c  evaluate Zeff(s) and quasineutrality
            call trxpl_mkgs2_zef(nintrp,rho_intrp,
     >         data_intrp,deriv_intrp,zsum1,zsum2,zsum3,zsum4,
     >         zsum5,zsum6,zsum7)
            if(iansr.eq.1) then
c  Zeff
               if(gsmoo) then
                  call r8_grafx3(rho_intrp,zsum1,zsum2,zsum7,nintrp,
     >               ' ',' ',tpath,tlabel,
     >               'Zeff before/after smoothing & data, vs. rho')
               else
                  call r8_grafx2(rho_intrp,zsum1,zsum7,nintrp,
     >               ' ',' ',tpath,tlabel,
     >               'Zeff calculated & Zeff(TRANSP) vs. rho')
               endif
            else if(iansr.eq.3) then
c  quasineutrality
               if(gsmoo) then
                  call r8_grafx2(rho_intrp,zsum3,zsum4,nintrp,
     >               ' ',' ',tpath,tlabel,
     >              '(1/ne)*sum(ni*Zi) before/after smoothing, vs. rho')
               else
                  call r8_grafx1(rho_intrp,zsum3,nintrp,
     >               ' ',' ',tpath,tlabel,
     >               '(1/ne)*sum(ni*Zi) vs. rho')
               endif
            else if(iansr.eq.4) then
c  energy density
               if(gsmoo) then
                  call r8_grafx2(rho_intrp,zsum5,zsum6,nintrp,
     >               ' ','Jles/m^3',tpath,tlabel,
     >              'energy density before/after smoothing, vs. rho')
               else
                  call r8_grafx1(rho_intrp,zsum5,nintrp,
     >               ' ','Jles/m^3',tpath,tlabel,
     >               'energy density vs. rho')
               endif
            endif
 
         else if(iansr.eq.2) then
            if(id_zprof(ispecie).eq.0) then
               write(lnout(0),*) ' '
               write(lnout(0),*) tpath
               write(lnout(0),*) tlabel
               write(lnout(0),*) slabel(ispecie)
               write(lnout(0),*) '  Z = ',Zplas(ispecie),'  A = ',
     >            Aplas(ispecie)
               write(lnout(0),*) '  A normalized by reference mass:  ',
     >            mass_ref
               call upaust(0)
            else
               call eq_rgetf(nintrp,rho_intrp,id_zprof(ispecie),0,
     >            data_intrp,ierr)
               if(ierr.ne.0) call errmsg_exit(
     >            '?trxpl_mkgs2: eq_rgetf 20??')
               call eq_rgetf(nintrp,rho_intrp,id_aprof(ispecie),0,
     >            deriv_intrp,ierr)
               if(ierr.ne.0) call errmsg_exit(
     >            '?trxpl_mkgs2: eq_rgetf 21??')
               call r8_grafx2(rho_intrp,data_intrp,deriv_intrp,nintrp,
     >            ' ',' ',tpath,tlabel,
     >            slabel(ispecie)//'Z & A/Mref vs. rho')
            endif
         endif
c
      else if(lchar('R')) then
c
c  aggregate ion species
c
         call trxpl_mkgs2_aggr(nrho,rho_grid,data_grid,deriv_grid,
     >      zsum1,zsum2,data_intrp,deriv_intrp)
c
c  reset specie to electrons
c
         ispecie=1
         zrat=Tconv(1)
c
      else if(lchar('S')) then
c
c  smooth data
c
         call trxpl_mkgs2_smoo(tlabel)
c
      else
c
c  fall through:  assume a species code was entered
c
         j=idcod(iert)
         if(iert.eq.0) ispecie=j
         ispecie=max(1,min(num_species,j))
         zrat=Tconv(ispecie)
      endif
c
      go to 100
c
c  exit
c
 1000 continue
      deallocate(rho_grid,data_grid,deriv_grid,stat=istat)
      deallocate(rho_intrp,data_intrp,deriv_intrp,stat=istat)
      deallocate(zsum1,zsum2,zsum3,zsum4,zsum5,zsum6,zsum7,stat=istat)
c
      return
c
      end

c
c----------------------------------------------------------------
c
c  reset module -- when new TRANSP run is selected...
c
      subroutine trxpl_mkgs2_reset
c
      use trxpl_gs2_module
c
      call trxpl_gs2_reset
c
      return
      end

subroutine trxpl_gs2_oname(zfile)

  ! generate default output filename for GS2 namelist

  use trxpl_gs2_module
  implicit NONE
  character*(*), intent(out) :: zfile

  !--------------------------------------------
  integer ilpre,ilsuf
  character*50 ztmp1,ztmp2,ztmp3
  integer il1,il2,il3
  !--------------------------------------------

  ilpre=len_trim(ofile_prefix)
  ilsuf=len_trim(ofile_suffix)

  call xpand(ztmp1,'t',transp_time,il1)
  call xpand(ztmp2,'dt',transp_delt,il2)
  call xpand(ztmp3,'x',transp_x,il3)

  zfile(1:)=ofile_prefix(1:ilpre)// &
       '_'//ztmp1(1:il1)// &
       '_'//ztmp2(1:il2)// &
       '_'//ztmp3(1:il3)// &
       '_'//ofile_suffix(1:ilsuf)

contains
  subroutine xpand(ztmp,zss,zval,ilen)

    !  generate a filename piece   nnnXnnn

    character*(*), intent(out) :: ztmp   ! filename piece
    character*(*), intent(in) :: zss     ! substring replacing "." point
    real*8, intent(in) :: zval           ! value to encode
    integer, intent(out) :: ilen         ! length of assembled piece at end

    !---------> local:
    character*10 ibuf
    character*3 irem
    integer ilss,ii,jj,kk
    integer intval,irem000
    real*8 znum,zuse
    !---------------------------------

    ilss=len_trim(zss)

    zuse = zval + 0.5d-3  ! for rounding

    if(zuse.ge.1.0d9) then
       ztmp='999999999'//zss(1:ilss)//'999'
    else if(zuse.lt.1.0d-3) then
       ztmp='0'//zss(1:ilss)//'000'
    else

       intval = zuse             ! integer part (seconds)
       write(ibuf,'(I10)') intval
       do ii=1,10
          if(ibuf(ii:ii).ne.' ') then
             jj=ii
             exit
          endif
       enddo

       znum = 1.0d3*(zuse - intval)
       intval = znum             ! fractional part (milliseconds)
       intval = max(0,min(999,intval))
       write(irem,'(I3.3)') intval

       ztmp = ibuf(jj:10)//zss(1:ilss)//irem

    endif

    ilen=len_trim(ztmp)

  end subroutine xpand

end subroutine trxpl_gs2_oname

      subroutine splitn_nxgrp(zline,iprev,iw1,iw2,idelim,
     >   ir1,ir2,irepeat,iextra)
C
C find next group of values: could be one value followed by a
C comma or end of line, or just the end of line (a null value),
C or nn*(a value) or nn* & end of line (nn null values).
C
C  input
C
      character*(*) zline               ! namelist line input
      integer iprev                     ! start search at: "=" or prev. ",".
C                                         or whitespace delimiter
C  output
C    iw1:iw2 -- range of characters giving value field (null value: iw2<iw1);
C    ir1:ir2 -- range of characters giving repeat count field, with "*",
C               or 0:0.
C
      integer iw1,iw2                   ! delimit found value
C         iw2.lt.iw1 on output means:  null value
C
      integer idelim                    ! terminating delimiter / EOL
C
      integer ir1,ir2                   ! repeat count found (both 0 if none)
      integer irepeat                   ! repeat count
C
      integer iextra                    ! =0: OK, .gt.0: extraneous chars
C
C  iextra is set if there are extraneous characters after the value
C  but before the delimiter.
C
C--------------------------------------
C
      character*10 zdigs
C
      data zdigs/'0123456789'/
C--------------------------------------
C
C  the following is the answer if a null value is detected
C
      iextra=0
      iw1=iprev+1
      iw2=iprev
      ir1=0
      ir2=0
      irepeat=1
      ilen=len(zline)
      idelim=ilen
C
      ic=iprev
C
C  find first non-white-space character
C
 10   continue
      ic=ic+1
      if(ic.gt.idelim) then
C  EOL, all blank
         return
      endif
      if(zline(ic:ic).eq.' ') go to 10
      if(zline(ic:ic).eq.char(9)) go to 10
C
C  non-blank found...
C
      if(zline(ic:ic).eq.',') then
         idelim=ic
         return                         ! null value
      endif
C
C  non-null... digit?
C
      idig=index(zdigs,zline(ic:ic))
      if(idig.eq.0) go to 50
C
C  yes, digit(s)...
      ic0=ic
      icount=idig-1
C
C  looking at an integer...
C
 20   continue
      ic=ic+1
      if(ic.gt.ilen) then
         iw1=ic0
         iw2=ilen
         idelim=ilen
         irepeat=1
         return                         ! a single integer
      endif
C
      idig=index(zdigs,zline(ic:ic))
      if(idig.gt.0) then
         icount=10*icount+(idig-1)
         go to 20
      endif
C
C  not a digit.  Look for first nonblank.
C
      ic1=ic-1
      ic=ic1
 30   continue
      ic=ic+1
      if(ic.gt.ilen) then
         iw1=ic0
         iw2=ic1
         idelim=ilen
         irepeat=1
         return                         ! a single integer
      endif
      if(zline(ic:ic).eq.' ') go to 30
      if(zline(ic:ic).eq.char(9)) go to 30
C
C  a non-blank.  comma is a delimiter.
C
      if(zline(ic:ic).eq.',') then
         iw1=ic0
         iw2=ic1
         idelim=ic
         irepeat=1
         return                         ! a single integer
      endif
C
C  a "*" means a repeat count
C
      if(zline(ic:ic).eq.'*') then
         ir1=ic0
         ir2=ic
         irepeat=icount
C
C  look for next non-blank
 40      continue
         ic=ic+1
         if(ic.gt.ilen) then
            return                      ! repeated nulls
         endif
         if(zline(ic:ic).eq.' ') go to 40
         if(zline(ic:ic).eq.char(9)) go to 40
C  nonblank
         if(zline(ic:ic).eq.',') then
            idelim=ic
            return                      ! repeated nulls
         endif
C  nonblank, noncomma -- a value
         go to 50
      else
C
C  it was not a repeat count; must have been a value of some kind
C
         ic=ic0
         go to 50
      endif
C
C------------------------------
C  we have a value starting at ic
C
 50   continue
      iw1=ic
      if(zline(ic:ic).eq.'"') go to 80 ! quote string
      if(zline(ic:ic).eq."'") go to 80 ! quote string
C
C  non quoted value ends at next non-blank
C
 60   continue
      ic=ic+1
      if(ic.gt.ilen) then
         iw2=ilen
         idelim=ilen
         return
      endif
      if(zline(ic:ic).eq.',') then
         iw2=ic-1
         idelim=ic
         return
      endif
      if((zline(ic:ic).eq.' ').or.(zline(ic:ic).eq.char(9))) then
         iw2=ic-1
         go to 100
      endif
      go to 60
C
C  quote string
C
 80   continue
C
C  look for terminating quote
C
      ic=ic+1
      if(ic.gt.ilen) then
         iw2=ilen
         idelim=ilen
         return
      endif
      if(zline(ic:ic).eq.'''') then
         if(ic.lt.ilen) then
            if(zline(ic+1:ic+1).eq.'''') then
               ic=ic+1                  ! paired quotes '' -> literal '
               go to 80
            endif
         endif
      else
         go to 80                       ! not a quote
      endif
C
C  have end of quote string-- must be delimited by whitespace or
C  comma or EOL
C
      iw2=ic
      if(iw2.ge.ilen) go to 100
      ii=ic+1
      if((zline(ii:ii).ne.',').and.(zline(ii:ii).ne.' ').and.
     >   (zline(ii:ii).ne.char(9))) then
         iextra=1                       ! bogus extra chars after quote string
      endif
      go to 100
C
 100  continue
C
C  now look for terminating delimiter
C
      ic=ic+1
      if(ic.gt.ilen) then
         idelim=ilen
         return
      endif
C
      if(zline(ic:ic).eq.',') then
         idelim=ic
         return
      endif
      if(zline(ic:ic).eq.' ') go to 100
      if(zline(ic:ic).eq.char(9)) go to 100
C
C  non-blank non comma:
C  assume whitespace delimiter
C
      idelim=ic-1
      return
C
      end
 

subroutine tdb_rmp_bdy(d,ztime,zr1,zr2)

  !  find midplane boundary intercept radii at the indicated time

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE

  type(trdatbuf) :: d          ! data buffer object
  real*8, intent(in) :: ztime  ! time (seconds)

  real*8, intent(out) :: zr1   ! inner intercept major radius (cm)
  real*8, intent(out) :: zr2   ! outer intercept major radius (cm)

  !---------------------------------------------
  integer :: it1,iltime,intime,ilr1,ilr2
  real*8 :: zf1
  !---------------------------------------------

  iltime = d%ltime2
  intime = d%ntime2

  call tdbsub_lookup(d%datbuf(iltime:iltime+intime-1),intime,ztime,it1,zf1)

  ilr1 = d%lrmp_bdy1
  ilr2 = d%lrmp_bdy2

  zr1 = (ONE-zf1)*d%datbuf(ilr1+it1-1) + zf1*d%datbuf(ilr1+it1)
  zr2 = (ONE-zf1)*d%datbuf(ilr2+it1-1) + zf1*d%datbuf(ilr2+it1)

end subroutine tdb_rmp_bdy

subroutine tdb_rmp_bdy_minmax(d,zrmin,zrmax)

  !  find the minimum inner boundary intercept radius and the maximum
  !  outer boundary intercept radius over all available times

  use trdatbuf_obj
  implicit NONE

  type(trdatbuf) :: d          ! data buffer object

  real*8, intent(out) :: zrmin ! inner intercept major radius (cm) -- MINIMUM
  real*8, intent(out) :: zrmax ! outer intercept major radius (cm) -- MAXIMUM

  !---------------------------------------------
  integer :: intime,ilr1,ilr2
  !---------------------------------------------

  intime = d%ntime2
  ilr1 = d%lrmp_bdy1
  ilr2 = d%lrmp_bdy2

  zrmin = minval(d%datbuf(ilr1:ilr1+intime-1))
  zrmax = maxval(d%datbuf(ilr2:ilr2+intime-1))

end subroutine tdb_rmp_bdy_minmax

C-----------------------------------------------------------------------
C  TDB_MAKSYM -- PRESYMMETRIZE PROFILE DATA FOR NEXT GEOMETRY FRAME
C
c  dmc -- modularization -- May 2005
c    dependence on trcom removed!
c
C  NEW DMC JULY 1991 -- PORTIONS GENERATED BY TRDATGEN!
C
C  The purpose of this routine is to perform onion skin symmetrization
C  on any input profile data for which this symmetrization algorithm is
C  requested.
C
C  Symmetrization is carried out over the entire time range of the
C  data (on the LTIME2 - NTIME2 time grid).  For normal data, the
C  symmetrized data is stored vs. minor radius; for ECE it is stored
C  vs. a normalized aspect ratio (related to (1/mod(B)).  This allows
C  the symmetrization to be done without prior knowledge
C  of the flux surface equilibrium geometry.
C
      SUBROUTINE TDB_MAKSYM(d,IER)
C
C--------------------------------------
C
      use trdatbuf_obj
 
      IMPLICIT NONE
 
      type (trdatbuf) :: d
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ier,imap
      INTEGER jsav,i,j,idum_lxsy,idum_nxsy,isizb,ineed
      integer :: nonlin,lunmsg_tdb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ztl
!============
      CHARACTER*25 ZZLABEL        ! label for 3d profile ID
C
C--------------------------------------
C
      IER=0
C
      nonlin = lunmsg_tdb(0)
C
C  check that initialization was done...
C
      if(d%lbx(1).eq.0) then
         ier=100
         write(nonlin,*)
     >        ' ? tdb_maksym: error exit -- "d%lbx" unitialized'
         write(nonlin,*)
     >        ' ? call to "tdb_symini" is needed.'
         return
      endif
C
C  A GAP is left IN workBUF STARTING AT workBUF(LFREE_W)
C  AND LEAVING ROOM FOR NBX(1) = MAX NO. X PTS IN PROFILE DATA
C  DATA POINTS -- USED AS A WORKSPACE BY EXECSYM
C
      call trdatbuf_expand(d%WORKBUF,d%lfree_w+d%nbx(1),isizb)
C
C  NBX(1) WAS COMPUTED IN SUBROUTINE TR2INI
C
C=>TRDATGEN+
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C
      IF((IABS(D%NRIAXR).EQ.3).AND.(D%NSYAXR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'AXR',IMAP,
     >       D%LXAXR,D%NXAXR,D%LFAXR,
     >       D%LXSYAXR,D%NXSYAXR,D%LFSYAXR,D%LSSYAXR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIBOL).EQ.3).AND.(D%NSYBOL.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'BOL',IMAP,
     >       D%LXBOL,D%NXBOL,D%LFBOL,
     >       D%LXSYBOL,D%NXSYBOL,D%LFSYBOL,D%LSSYBOL, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIBPA).EQ.3).AND.(D%NSYBPA.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'BPA',IMAP,
     >       D%LXBPA,D%NXBPA,D%LFBPA,
     >       D%LXSYBPA,D%NXSYBPA,D%LFSYBPA,D%LSSYBPA, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIBPB).EQ.3).AND.(D%NSYBPB.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'BPB',IMAP,
     >       D%LXBPB,D%NXBPB,D%LFBPB,
     >       D%LXSYBPB,D%NXSYBPB,D%LFSYBPB,D%LSSYBPB, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRID2F).EQ.3).AND.(D%NSYD2F.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'D2F',IMAP,
     >       D%LXD2F,D%NXD2F,D%LFD2F,
     >       D%LXSYD2F,D%NXSYD2F,D%LFSYD2F,D%LSSYD2F, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDE2).EQ.3).AND.(D%NSYDE2.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DE2',IMAP,
     >       D%LXDE2,D%NXDE2,D%LFDE2,
     >       D%LXSYDE2,D%NXSYDE2,D%LFSYDE2,D%LSSYDE2, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDF3).EQ.3).AND.(D%NSYDF3.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DF3',IMAP,
     >       D%LXDF3,D%NXDF3,D%LFDF3,
     >       D%LXSYDF3,D%NXSYDF3,D%LFSYDF3,D%LSSYDF3, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDF4).EQ.3).AND.(D%NSYDF4.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DF4',IMAP,
     >       D%LXDF4,D%NXDF4,D%LFDF4,
     >       D%LXSYDF4,D%NXSYDF4,D%LFSYDF4,D%LSSYDF4, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDF6).EQ.3).AND.(D%NSYDF6.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DF6',IMAP,
     >       D%LXDF6,D%NXDF6,D%LFDF6,
     >       D%LXSYDF6,D%NXSYDF6,D%LFSYDF6,D%LSSYDF6, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDFD).EQ.3).AND.(D%NSYDFD.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DFD',IMAP,
     >       D%LXDFD,D%NXDFD,D%LFDFD,
     >       D%LXSYDFD,D%NXSYDFD,D%LFSYDFD,D%LSSYDFD, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDFH).EQ.3).AND.(D%NSYDFH.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DFH',IMAP,
     >       D%LXDFH,D%NXDFH,D%LFDFH,
     >       D%LXSYDFH,D%NXSYDFH,D%LFSYDFH,D%LSSYDFH, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIDFT).EQ.3).AND.(D%NSYDFT.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'DFT',IMAP,
     >       D%LXDFT,D%NXDFT,D%LFDFT,
     >       D%LXSYDFT,D%NXSYDFT,D%LFSYDFT,D%LSSYDFT, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIECF).EQ.3).AND.(D%NSYECF.EQ.1)) THEN
        IMAP = 2
        CALL TDB_EXECSYM(d,'ECF',IMAP,
     >       D%LXECF,D%NXECF,D%LFECF,
     >       D%LXSYECF,D%NXSYECF,D%LFSYECF,D%LSSYECF, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIFEH).EQ.3).AND.(D%NSYFEH.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'FEH',IMAP,
     >       D%LXFEH,D%NXFEH,D%LFFEH,
     >       D%LXSYFEH,D%NXSYFEH,D%LFSYFEH,D%LSSYFEH, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIFEL).EQ.3).AND.(D%NSYFEL.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'FEL',IMAP,
     >       D%LXFEL,D%NXFEL,D%LFFEL,
     >       D%LXSYFEL,D%NXSYFEL,D%LFSYFEL,D%LSSYFEL, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIGRB).EQ.3).AND.(D%NSYGRB.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'GRB',IMAP,
     >       D%LXGRB,D%NXGRB,D%LFGRB,
     >       D%LXSYGRB,D%NXSYGRB,D%LFSYGRB,D%LSSYGRB, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIIBE).EQ.3).AND.(D%NSYIBE.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'IBE',IMAP,
     >       D%LXIBE,D%NXIBE,D%LFIBE,
     >       D%LXSYIBE,D%NXSYIBE,D%LFSYIBE,D%LSSYIBE, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIIBI).EQ.3).AND.(D%NSYIBI.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'IBI',IMAP,
     >       D%LXIBI,D%NXIBI,D%LFIBI,
     >       D%LXSYIBI,D%NXSYIBI,D%LFSYIBI,D%LSSYIBI, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIJBM).EQ.3).AND.(D%NSYJBM.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'JBM',IMAP,
     >       D%LXJBM,D%NXJBM,D%LFJBM,
     >       D%LXSYJBM,D%NXSYJBM,D%LFSYJBM,D%LSSYJBM, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIJEC).EQ.3).AND.(D%NSYJEC.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'JEC',IMAP,
     >       D%LXJEC,D%NXJEC,D%LFJEC,
     >       D%LXSYJEC,D%NXSYJEC,D%LFSYJEC,D%LSSYJEC, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIJIC).EQ.3).AND.(D%NSYJIC.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'JIC',IMAP,
     >       D%LXJIC,D%NXJIC,D%LFJIC,
     >       D%LXSYJIC,D%NXSYJIC,D%LFSYJIC,D%LSSYJIC, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILF3).EQ.3).AND.(D%NSYLF3.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LF3',IMAP,
     >       D%LXLF3,D%NXLF3,D%LFLF3,
     >       D%LXSYLF3,D%NXSYLF3,D%LFSYLF3,D%LSSYLF3, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILF4).EQ.3).AND.(D%NSYLF4.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LF4',IMAP,
     >       D%LXLF4,D%NXLF4,D%LFLF4,
     >       D%LXSYLF4,D%NXSYLF4,D%LFSYLF4,D%LSSYLF4, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILF6).EQ.3).AND.(D%NSYLF6.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LF6',IMAP,
     >       D%LXLF6,D%NXLF6,D%LFLF6,
     >       D%LXSYLF6,D%NXSYLF6,D%LFSYLF6,D%LSSYLF6, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILFD).EQ.3).AND.(D%NSYLFD.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LFD',IMAP,
     >       D%LXLFD,D%NXLFD,D%LFLFD,
     >       D%LXSYLFD,D%NXSYLFD,D%LFSYLFD,D%LSSYLFD, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILFH).EQ.3).AND.(D%NSYLFH.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LFH',IMAP,
     >       D%LXLFH,D%NXLFH,D%LFLFH,
     >       D%LXSYLFH,D%NXSYLFH,D%LFSYLFH,D%LSSYLFH, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILFT).EQ.3).AND.(D%NSYLFT.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LFT',IMAP,
     >       D%LXLFT,D%NXLFT,D%LFLFT,
     >       D%LXSYLFT,D%NXSYLFT,D%LFSYLFT,D%LSSYLFT, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILHE).EQ.3).AND.(D%NSYLHE.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LHE',IMAP,
     >       D%LXLHE,D%NXLHE,D%LFLHE,
     >       D%LXSYLHE,D%NXSYLHE,D%LFSYLHE,D%LSSYLHE, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRILHJ).EQ.3).AND.(D%NSYLHJ.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'LHJ',IMAP,
     >       D%LXLHJ,D%NXLHJ,D%LFLHJ,
     >       D%LXSYLHJ,D%NXSYLHJ,D%LFSYLHJ,D%LSSYLHJ, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINER).EQ.3).AND.(D%NSYNER.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NER',IMAP,
     >       D%LXNER,D%NXNER,D%LFNER,
     >       D%LXSYNER,D%NXSYNER,D%LFSYNER,D%LSSYNER, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINI3).EQ.3).AND.(D%NSYNI3.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NI3',IMAP,
     >       D%LXNI3,D%NXNI3,D%LFNI3,
     >       D%LXSYNI3,D%NXSYNI3,D%LFSYNI3,D%LSSYNI3, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINI4).EQ.3).AND.(D%NSYNI4.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NI4',IMAP,
     >       D%LXNI4,D%NXNI4,D%LFNI4,
     >       D%LXSYNI4,D%NXSYNI4,D%LFSYNI4,D%LSSYNI4, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINI6).EQ.3).AND.(D%NSYNI6.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NI6',IMAP,
     >       D%LXNI6,D%NXNI6,D%LFNI6,
     >       D%LXSYNI6,D%NXSYNI6,D%LFSYNI6,D%LSSYNI6, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINID).EQ.3).AND.(D%NSYNID.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NID',IMAP,
     >       D%LXNID,D%NXNID,D%LFNID,
     >       D%LXSYNID,D%NXSYNID,D%LFSYNID,D%LSSYNID, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINIH).EQ.3).AND.(D%NSYNIH.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NIH',IMAP,
     >       D%LXNIH,D%NXNIH,D%LFNIH,
     >       D%LXSYNIH,D%NXSYNIH,D%LFSYNIH,D%LSSYNIH, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINIM).EQ.3).AND.(D%NSYNIM.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NIM',IMAP,
     >       D%LXNIM,D%NXNIM,D%LFNIM,
     >       D%LXSYNIM,D%NXSYNIM,D%LFSYNIM,D%LSSYNIM, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINIT).EQ.3).AND.(D%NSYNIT.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NIT',IMAP,
     >       D%LXNIT,D%NXNIT,D%LFNIT,
     >       D%LXSYNIT,D%NXSYNIT,D%LFSYNIT,D%LSSYNIT, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRINMR).EQ.3).AND.(D%NSYNMR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'NMR',IMAP,
     >       D%LXNMR,D%NXNMR,D%LFNMR,
     >       D%LXSYNMR,D%NXSYNMR,D%LFSYNMR,D%LSSYNMR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIOMG).EQ.3).AND.(D%NSYOMG.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'OMG',IMAP,
     >       D%LXOMG,D%NXOMG,D%LFOMG,
     >       D%LXSYOMG,D%NXSYOMG,D%LFSYOMG,D%LSSYOMG, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIPRS).EQ.3).AND.(D%NSYPRS.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'PRS',IMAP,
     >       D%LXPRS,D%NXPRS,D%LFPRS,
     >       D%LXSYPRS,D%NXSYPRS,D%LFSYPRS,D%LSSYPRS, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIQBE).EQ.3).AND.(D%NSYQBE.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'QBE',IMAP,
     >       D%LXQBE,D%NXQBE,D%LFQBE,
     >       D%LXSYQBE,D%NXSYQBE,D%LFSYQBE,D%LSSYQBE, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIQBI).EQ.3).AND.(D%NSYQBI.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'QBI',IMAP,
     >       D%LXQBI,D%NXQBI,D%LFQBI,
     >       D%LXSYQBI,D%NXSYQBI,D%LFSYQBI,D%LSSYQBI, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIQEC).EQ.3).AND.(D%NSYQEC.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'QEC',IMAP,
     >       D%LXQEC,D%NXQEC,D%LFQEC,
     >       D%LXSYQEC,D%NXSYQEC,D%LFSYQEC,D%LSSYQEC, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIQIC).EQ.3).AND.(D%NSYQIC.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'QIC',IMAP,
     >       D%LXQIC,D%NXQIC,D%LFQIC,
     >       D%LXSYQIC,D%NXSYQIC,D%LFSYQIC,D%LSSYQIC, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIQPR).EQ.3).AND.(D%NSYQPR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'QPR',IMAP,
     >       D%LXQPR,D%NXQPR,D%LFQPR,
     >       D%LXSYQPR,D%NXSYQPR,D%LFSYQPR,D%LSSYQPR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIRES).EQ.3).AND.(D%NSYRES.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'RES',IMAP,
     >       D%LXRES,D%NXRES,D%LFRES,
     >       D%LXSYRES,D%NXSYRES,D%LFSYRES,D%LSSYRES, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRISBI).EQ.3).AND.(D%NSYSBI.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'SBI',IMAP,
     >       D%LXSBI,D%NXSBI,D%LFSBI,
     >       D%LXSYSBI,D%NXSYSBI,D%LFSYSBI,D%LSSYSBI, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRITER).EQ.3).AND.(D%NSYTER.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'TER',IMAP,
     >       D%LXTER,D%NXTER,D%LFTER,
     >       D%LXSYTER,D%NXSYTER,D%LFSYTER,D%LSSYTER, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRITI2).EQ.3).AND.(D%NSYTI2.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'TI2',IMAP,
     >       D%LXTI2,D%NXTI2,D%LFTI2,
     >       D%LXSYTI2,D%NXSYTI2,D%LFSYTI2,D%LSSYTI2, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRITQI).EQ.3).AND.(D%NSYTQI.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'TQI',IMAP,
     >       D%LXTQI,D%NXTQI,D%LFTQI,
     >       D%LXSYTQI,D%NXSYTQI,D%LFSYTQI,D%LSSYTQI, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIV2F).EQ.3).AND.(D%NSYV2F.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'V2F',IMAP,
     >       D%LXV2F,D%NXV2F,D%LFV2F,
     >       D%LXSYV2F,D%NXSYV2F,D%LFSYV2F,D%LSSYV2F, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVB2).EQ.3).AND.(D%NSYVB2.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VB2',IMAP,
     >       D%LXVB2,D%NXVB2,D%LFVB2,
     >       D%LXSYVB2,D%NXSYVB2,D%LFSYVB2,D%LSSYVB2, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVC3).EQ.3).AND.(D%NSYVC3.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VC3',IMAP,
     >       D%LXVC3,D%NXVC3,D%LFVC3,
     >       D%LXSYVC3,D%NXSYVC3,D%LFSYVC3,D%LSSYVC3, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVC4).EQ.3).AND.(D%NSYVC4.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VC4',IMAP,
     >       D%LXVC4,D%NXVC4,D%LFVC4,
     >       D%LXSYVC4,D%NXSYVC4,D%LFSYVC4,D%LSSYVC4, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVC6).EQ.3).AND.(D%NSYVC6.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VC6',IMAP,
     >       D%LXVC6,D%NXVC6,D%LFVC6,
     >       D%LXSYVC6,D%NXSYVC6,D%LFSYVC6,D%LSSYVC6, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVCD).EQ.3).AND.(D%NSYVCD.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VCD',IMAP,
     >       D%LXVCD,D%NXVCD,D%LFVCD,
     >       D%LXSYVCD,D%NXSYVCD,D%LFSYVCD,D%LSSYVCD, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVCH).EQ.3).AND.(D%NSYVCH.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VCH',IMAP,
     >       D%LXVCH,D%NXVCH,D%LFVCH,
     >       D%LXSYVCH,D%NXSYVCH,D%LFSYVCH,D%LSSYVCH, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVCT).EQ.3).AND.(D%NSYVCT.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VCT',IMAP,
     >       D%LXVCT,D%NXVCT,D%LFVCT,
     >       D%LXSYVCT,D%NXSYVCT,D%LFSYVCT,D%LSSYVCT, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVEE).EQ.3).AND.(D%NSYVEE.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VEE',IMAP,
     >       D%LXVEE,D%NXVEE,D%LFVEE,
     >       D%LXSYVEE,D%NXSYVEE,D%LFSYVEE,D%LSSYVEE, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVIE).EQ.3).AND.(D%NSYVIE.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VIE',IMAP,
     >       D%LXVIE,D%NXVIE,D%LFVIE,
     >       D%LXSYVIE,D%NXSYVIE,D%LFSYVIE,D%LSSYVIE, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVMO).EQ.3).AND.(D%NSYVMO.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VMO',IMAP,
     >       D%LXVMO,D%NXVMO,D%LFVMO,
     >       D%LXSYVMO,D%NXSYVMO,D%LFSYVMO,D%LSSYVMO, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVP2).EQ.3).AND.(D%NSYVP2.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VP2',IMAP,
     >       D%LXVP2,D%NXVP2,D%LFVP2,
     >       D%LXSYVP2,D%NXSYVP2,D%LFSYVP2,D%LSSYVP2, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVPO).EQ.3).AND.(D%NSYVPO.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VPO',IMAP,
     >       D%LXVPO,D%NXVPO,D%LFVPO,
     >       D%LXSYVPO,D%NXSYVPO,D%LFSYVPO,D%LSSYVPO, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVPR).EQ.3).AND.(D%NSYVPR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VPR',IMAP,
     >       D%LXVPR,D%NXVPR,D%LFVPR,
     >       D%LXSYVPR,D%NXSYVPR,D%LFSYVPR,D%LSSYVPR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIVTR).EQ.3).AND.(D%NSYVTR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'VTR',IMAP,
     >       D%LXVTR,D%NXVTR,D%LFVTR,
     >       D%LXSYVTR,D%NXSYVTR,D%LFSYVTR,D%LSSYVTR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIZF2).EQ.3).AND.(D%NSYZF2.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'ZF2',IMAP,
     >       D%LXZF2,D%NXZF2,D%LFZF2,
     >       D%LXSYZF2,D%NXSYZF2,D%LFSYZF2,D%LSSYZF2, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      IF((IABS(D%NRIZXR).EQ.3).AND.(D%NSYZXR.EQ.1)) THEN
        IMAP = 1
        CALL TDB_EXECSYM(d,'ZXR',IMAP,
     >       D%LXZXR,D%NXZXR,D%LFZXR,
     >       D%LXSYZXR,D%NXSYZXR,D%LFSYZXR,D%LSSYZXR, IER)
        IF(IER.NE.0) GO TO 999
      ENDIF
C
      JSAV=-99
      DO I = 1, 300
        J = D%NISSIM(I)
        IF (J==0) EXIT
        IF((D%LFSIM(I).NE.0).AND.(IABS(D%NRISIM(J)).EQ.3)
     >     .AND.(D%NSYSIM(J).EQ.1)) THEN
          IMAP = 1
          WRITE(ZZLABEL,'(A,I3,A,I5)') 'SIM SET:',J,', TOT:',I
          CALL TDB_EXECSYM(d,ZZLABEL,IMAP,
     >           D%LXSIM(J),D%NXSIM(J),D%LFSIM(I),
     >           idum_LXSY,idum_NXSY,D%LFSYSIM(I),D%LSSYSIM(I),IER)
          IF(IER.NE.0) GO TO 999
          IF (J .NE. JSAV) THEN
            D%LXSYSIM(J) = idum_LXSY
            D%NXSYSIM(J) = idum_NXSY
            JSAV = J
          ELSE
            IF (idum_NXSY .NE. D%NXSYSIM(J)) IER=1
            CALL MKDBCOMP(d, D%LXSYSIM(J), idum_LXSY,
     >           MIN(D%NXSYSIM(J),idum_NXSY),IER)
            IF(IER.NE.0) THEN
              write(nonlin,*)
     > ' ?TDB_MAKSYM: SYMMETRIZED X-AXIS DO NOT MATCH IN 3D PROFILE'
              write(nonlin,*)' ?TDB_MAKSYM: DATA SET SIM'
              GOTO 999
            END IF
          END IF
        END IF
      END DO
C
C
C=>TRDATGEN-
C
      GO TO 1000
C
C  ERROR
C
 999  CONTINUE
      IER=1
C
C  EXIT
C
 1000 CONTINUE
      RETURN
      END
 
C
C ------------------------ MKDBCOMP --------------------------------
C
C COMPARES THE DATA IN THE datbuf AT TWO ADDRESSES FOR (near)EQUALITY
C
      SUBROUTINE MKDBCOMP(d, ILX1, ILX2, INX, IER)
 
      use trdatbuf_obj
      IMPLICIT NONE
 
      type (trdatbuf) :: d
 
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      INTEGER ILX1              ! address of data number 1 in datbuf
      INTEGER ILX2              ! address of data number 2 in datbuf
      INTEGER INX               ! length of data
      INTEGER IER               ! return true on error -- do not change IER if no error
      INTEGER J                 ! loop variable
 
      REAL*8 ZSCALE             ! scale factor for data
      REAL*8 Z1,Z2              ! data at one point
 
      zscale = 1.0d-35          ! approximate scale of x-axis
      do j = 1, inx
         z1 = d%DATBUF(ilx1+j-1)
         z2 = d%DATBUF(ilx2+j-1)
         zscale = max(abs(z1),abs(z2),zscale)
      end do
 
      do j = 1, inx
         z1 = d%DATBUF(ilx1+j-1)
         z2 = d%DATBUF(ilx2+j-1)
         if (abs(z2-z1)/zscale .GT. 1.E-5_R8) IER=1
      end do
 
      END
! 20jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

subroutine trx_mhd(ntheta,ierr)
  use trx_module
  implicit NONE
!
!  read TRANSP MHD equilibrium data; store in xplasma for use via
!  interpolation routines
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer, intent(IN) :: ntheta        ! no. of theta grid pts [-pi,pi]
  integer, intent(OUT) :: ierr         ! completion code, 0=OK
!
!----------------------------
!
  real*4 r4ztheta(ntheta)
  real*8 ztheta(ntheta),zpi
!
! for Psi(R,Z) acquisition (free bdy mode)
  character*64 zlbl
  character*32 zuns
  real*8 :: ztime0,zdelt
!
  integer i,iR,iZ,igot,idum,idumR,idumZ
  integer :: lunzer
!
  real Rarr(ntheta,nsurf),Zarr(ntheta,nsurf)
  real*8 r8Rarr(ntheta,nsurf),r8Zarr(ntheta,nsurf)
!
  real zrho(nsurf),zpsi(nsurf),zpmhd(nsurf),zqmhd(nsurf),zgmhd(nsurf)
  real*8 zbuf(nsurf)
  real ztflux,zpcur
!
  real*8, dimension(:), allocatable :: arr1
  real*8 :: zrcen1,zrcen2,zzcen1,zzcen2,zrtest,zztest,testval,testval2,zdpsi
  real*8 :: zmina(3),zresult
  integer :: ircen1,ircen2,izcen1,izcen2,iraxis,izaxis
  logical :: iexist
!----------------------------
!
  call trx_ready('trx_mhd',ierr)
  if(ierr.ne.0) return
!
  zpi=acos(-1.0E0_R8)
!
  do i=1,ntheta
     ztheta(i) = -zpi + (i-1)*2.0E0_R8*zpi/(ntheta-1)
     if(th_reverse.eq.0) then
        r4ztheta(i)=ztheta(i)
     else
        r4ztheta(ntheta-i+1)=ztheta(i)
     endif
  enddo
!
  call eqm_chi(ztheta,0,ntheta,1.0E-4_R8,id_chi,ierr)
  if(ierr.ne.0) return
!
  call t1mhdeq(time0,delta_t,nsurf,ntheta,igot,'MKS',r4ztheta, &
       Rarr,Zarr,zrho,zpsi,zpmhd,zqmhd,zgmhd,ztflux,zpcur,ierr)
  if(ierr.ne.0) return
!
  ztime0=time0   ! R8
  zdelt =delta_t ! R8

  ! make Psi profiles zero on axis -- they should be close already

  if(abs(zpsi(1)).gt.1.0d-4*abs(zpsi(nsurf))) then
     write(lunzer(0),*) ' %trx_mhd: 1d profile Psi(rho): Psi(0)=',zpsi(1)
     write(lunzer(0),*) '  reset to zero...'
  endif
  zdpsi = zpsi(1)
  zpsi = zpsi - zdpsi
!
  if((nRfree.gt.0).and.(nZfree.gt.0)) then
     ! retrieve Psi(R,Z) also...
     allocate(arr1(nRfree*nZfree))

     call rpexist_profile('PSIRZ',iexist)

     if (iexist) then
        call r8_t1profil('PSIRZ',zlbl,zuns,ztime0,zdelt, &
             idum,arr1,nRfree*nZfree,igot,ierr)

     else if (ifound_psi0.eq.1) then
        call r8_t1scalar('PSI0_TR',zlbl,zuns,ztime0,zdelt,Psi0_mhd,ierr)

        if (ierr==0) then
           call r8_t1profil('APSIRZ',zlbl,zuns,ztime0,zdelt, &
                idum,arr1,nRfree*nZfree,igot,ierr)
           if (ierr==0) then
              arr1 = arr1 - Psi0_mhd  ! psi relative to machine axis now psi relative to mag axis
           end if
        end if
     else
        ierr=1
     end if

     if(ierr.ne.0) then
        deallocate(arr1)
        return
     endif
     iZ=1
     iR=0
     do i=1,nRfree*nZfree
        iR=iR+1
        if(iR.gt.nRfree) then
           iR=1
           iZ=iZ+1
        endif
        psiRZ_free(iR,iZ)=arr1(i)
     enddo
     ! also need axis location -- cannot ignore error
     call r8_t1scalar('RAXIS',zlbl,zuns,ztime0,zdelt,raxis_mhd,ierr)
     if(ierr.ne.0) return
     raxis_mhd = 0.01_R8*raxis_mhd

     call r8_t1scalar('YAXIS',zlbl,zuns,ztime0,zdelt,zaxis_mhd,ierr)
     if(ierr.ne.0) return
     zaxis_mhd = 0.01_R8*zaxis_mhd

     if(ifound_psi0.eq.1) then
        call r8_t1scalar('PSI0_TR',zlbl,zuns,ztime0,zdelt,Psi0_mhd,ierr)
        if(ierr.ne.0) return
        call eqm_save_psi0(Psi0_mhd,ierr)
        if(ierr.ne.0) return
     else
        Psi0_mhd=0.0_R8
     endif

     ! use axis information to normalize Psi(R,Z): 0 on axis (approximately)
     zrcen1 = 0.9*raxis_mhd
     zrcen2 = 1.1*raxis_mhd
     zzcen1 = zaxis_mhd - 0.1*raxis_mhd
     zzcen2 = zaxis_mhd + 0.1*raxis_mhd

     zrtest = 100*raxis_mhd
     zztest = zrtest

     ircen1=0
     ircen2=0
     do ir=1,nRfree
        if(Rgrid_free(ir).lt.zrcen1) ircen1=ir
        if(Rgrid_free(ir).gt.zrcen2) then
           ircen2=ir
           exit
        endif
        testval = abs(Rgrid_free(ir)-Raxis_mhd)
        if(testval.lt.zRtest) then
           iraxis=ir
           zRtest=testval
        endif
     enddo

     izcen1=0
     izcen2=0
     do iz=1,nZfree
        if(Zgrid_free(iz).lt.zZcen1) izcen1=iz
        if(Zgrid_free(iz).gt.zZcen2) then
           izcen2=iz
           exit
        endif
        testval = abs(Zgrid_free(iz)-Zaxis_mhd)
        if(testval.lt.zZtest) then
           izaxis=iz
           zZtest=testval
        endif
     enddo

     ! see if Psi(axis) local minimum or maximum

     testval = PsiRZ_free(iraxis,izaxis)
     testval2 = (PsiRZ_free(ircen1,izcen1)+PsiRZ_free(ircen2,izcen1)+ &
          PsiRZ_free(ircen1,izcen2)+PsiRZ_free(ircen2,izcen2))*0.25_R8

     if(testval.gt.testval2) then
        ! local maximum: flip Psi

        PsiRZ_free = -PsiRZ_free
        testval = -testval
     endif

     ! find actual minimum
     do iZ=izcen1,izcen2
        do iR=ircen1,ircen2
           if(PsiRZ_free(iR,iZ).lt.testval) then
              testval = PsiRZ_free(iR,iZ)
              iRaxis=iR
              iZaxis=iZ
           endif
        enddo
     enddo

     ! 2nd order adjustment -- use CONTAIN'ed subroutine

     call fmin1d(Rgrid_free(iRaxis-1:iRaxis+1), &
          PsiRz_free(iRaxis-1:iRaxis+1,iZaxis-1), zmina(1))

     call fmin1d(Rgrid_free(iRaxis-1:iRaxis+1), &
          PsiRz_free(iRaxis-1:iRaxis+1,iZaxis), zmina(2))

     call fmin1d(Rgrid_free(iRaxis-1:iRaxis+1), &
          PsiRz_free(iRaxis-1:iRaxis+1,iZaxis+1), zmina(3))

     call fmin1d(Zgrid_free(iZaxis-1:iZaxis+1), zmina, zresult)

     testval = zresult

     if(abs(testval).gt.1.0d-4*abs(zpsi(nsurf))) then
        write(lunzer(0),*) ' %trx_mhd: 2d profile Psi(R,Z): Psi(axis)=', &
             testval
        write(lunzer(0),*) '  reset to zero...'
     endif

     PsiRZ_free = PsiRZ_free - testval
        
  else
     ! no Psi(R,Z): try to read axis values but ignore error
     call r8_t1scalar('RAXIS',zlbl,zuns,ztime0,zdelt,raxis_mhd,ierr)
     raxis_mhd = 0.01_R8*raxis_mhd
     call r8_t1scalar('YAXIS',zlbl,zuns,ztime0,zdelt,zaxis_mhd,ierr)
     zaxis_mhd = 0.01_R8*zaxis_mhd
     ierr = 0

  endif
!
  call rp_eq_symflag(ksym)  ! updown (a)symmetry
  call rp_eq_nmoms(nmoms)   ! no. of moments in TRANSP equilibrium
  call xmoments_kmom_set(nmoms)  ! tell XPLASMA
!
! set up 1d profiles
!
  zbuf=ztflux*zrho*zrho
  call eqm_rhofun(2,id_rho,'phitor',zbuf,1,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'Wb',0)
  if(ierr.ne.0) return
!
  zbuf=zpsi
  call eqm_rhofun(2,id_rho,'psi',zbuf,1,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'Wb/rad',0)
  if(ierr.ne.0) return
!
  zbuf=zgmhd
  call eqm_rhofun(2,id_rho,'g',zbuf,1,0.0E0_R8,1,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'T*m',0)
  if(ierr.ne.0) return
!
  zbuf=zpmhd
  call eqm_rhofun(2,id_rho,'pmhd',zbuf,1,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,'Pa',0)
  if(ierr.ne.0) return

  call eqm_mark_pmhd(idum,ierr)  ! mark the pressure profile
  if(ierr.ne.0) return
!
  zbuf=zqmhd
  call eqm_rhofun(2,id_rho,'q',zbuf,0,0.0E0_R8,0,0.0E0_R8,idum,ierr)
  call trx_ustore(ierr,idum,id_rho,-99,' ',0)
  if(ierr.ne.0) return
!
  r8Rarr=Rarr
  r8Zarr=Zarr
!
  call eqm_rzmag(r8Rarr,r8Zarr,ntheta,nsurf,2*isign_rzbc,idumR,idumZ,ierr)
  call trx_ustore(ierr,idumR,0,-99,'m',0)
  call trx_ustore(ierr,idumZ,0,-99,'m',0)
  if(ierr.ne.0) return
!
  return

CONTAINS
  subroutine fmin1d(xa,fa,ans)

    real*8, dimension(:) :: xa   ! x array -- 3 values actually
    real*8, dimension(:) :: fa   ! f(x) array -- 3 values

    real*8, intent(out) :: ans   ! min value

    ! use a parabolic fit to 3 pts to estimate min/max value
    ! (in trx_mhd it will be a minimum, because the search is in vicinity
    ! of minimum of Psi(R,Z)).

    !-------------------------------------------
    real*8 :: xm,xp   ! distances from x(2)
    real*8 :: fm,fp   ! f(1)-f(2),f(3)-f(2)
    real*8 :: a,b,denom,xminloc
    !-------------------------------------------
    ! check against singular cases...

    if((fa(1).eq.fa(2)).AND.(fa(2).eq.fa(3))) then
       ans = fa(2)
       return
    endif

    if((fa(1).lt.fa(2)).AND.(fa(2).lt.fa(3))) then
       ans = fa(1)
       return
    endif

    if((fa(1).gt.fa(2)).AND.(fa(2).gt.fa(3))) then
       ans = fa(3)
       return
    endif

    !-------------------------------------------
    ! OK do parabolic fit

    xm = xa(2)-xa(1)
    xp = xa(3)-xa(2)

    fm = fa(1)-fa(2)
    fp = fa(3)-fa(2)

    ! look for parabola p which satisfies: p(0)=0, p(-xm)=fm, p(xp)=fp
    !   p = a*x**2 + b*x;  a*xm**2 - b*xm = fm;  a*xp**2 + b*x = fp

    denom = xm*xp*(xm+xp)
    a = (fm*xp + fp*xm)/denom
    b = (fp*xm*xm - fm*xp*xp)/denom

    !   find p'=0,  p' = 2*a*x + b = 0 => x_min = -b/2*a;
    !        then p_min = a*x_min**2 + b*x_min

    xminloc = -b/(2*a)

    ans = xminloc*(a*xminloc + b)

    ans = ans + fa(2)   ! add this back in...

  end subroutine fmin1d

end subroutine trx_mhd
 
!----------------------------------------------------------------------
!  the following is used for testing...
 
subroutine trx_set_threverse(ival)
 
  use trx_module
  implicit NONE
 
  integer ival            ! =1:  reverse theta; =0: don't.
 
  th_reverse=max(0,min(1,ival))
 
  return
 
end subroutine trx_set_threverse

subroutine trxpl_fwr2d_cdf(tpath,ztime0,ztavg)

  !  write NetCDF file containing data for FWR2D, namely:
  ! 
  !   nR, nZ, & R & Z grids: Rr, Zz, ...
  ! 
  !   ne(R,Z)[m**-3], Te(R,Z)[KeV], |B|(R,Z)[T], and derived quantities:
  !   omega0(R,Z), omegaxl(R,Z), omegaxr(R,Z) defined as follows:
  !
  !   omega0 = sqrt( (ne*ee**2) / (eps0*me*sqrt(1+5*Te/511)) ) = omega[pe]
  !   omega[ce] = (ee*|B|) / (me*sqrt(1+5*Te/511))
  !   omega_xl = sqrt(omega[ce]**2/4 + omega0**2) - omega[ce]/2
  !   omega_xr = sqrt(omega[ce]**2/4 + omega0**2) + omega[ce]/2
  !
  !     where ee = electron charge = 1.6022e-19 Coulombs
  !           me = electron mass   = 9.1099e-31 kg
  !           eps0 = vac. permittivity = 8.8542e-12 F/m
  !

  implicit NONE

  character*(*), intent(in) :: tpath    ! TRANSP run specification
  real*8, intent(in) :: ztime0          ! time of interest
  real*8, intent(in) :: ztavg           ! +/- delta(t) time averaging

  include 'trxpl.blk'  !... to communicate with trxpl_add_profile

  real*8 Rminx,Rmaxx,Zminx,Zmaxx      ! limits of xplasma grid
  real*8 Rminpl,Rmaxpl,Zminpl,Zmaxpl  ! limits of plasma boundary
  real*8 Rmin,Rmax,Zmin,Zmax          ! limits of grid for FWR2D

  real*8 dxtend                       ! amount of extension of grid beyond
                                      ! plasma bdy, subject to conditions

  real*8 lamda_ne,lamda_Te            ! scrape-off thicknesses, for
                                      ! ne & Te, respectively.

  integer :: nR,nZ                    ! gridsizes
  integer :: nbdy                     ! bdy contour size

  real*8, dimension(:), allocatable :: Rr,Zz  ! grids

  real*8, dimension(:), allocatable :: Rbdy,Zbdy    ! plasma bdy sequence

  !  (R,Z) variables, as described above:

  real*8, dimension(:,:), allocatable :: ne,te,bb,bpol,ti,qrz
  real*8, dimension(:,:), allocatable :: omega_pe,omega_xl,omega_xr
  real*8, dimension(:,:), allocatable :: omega_ce

  !  constants, as described above, and...

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: ee = 1.6022d-19   
  real*8, parameter :: me = 9.1099d-31
  real*8, parameter :: eps0 = 8.8542d-12
  real*8, parameter :: c2pi = 6.2831853071795862D+00

  !  additional items

  integer, parameter :: igmin = 10      ! sanity limits on gridsizes
  integer, parameter :: igmax = 2000

  integer ierr,lnout
  logical lxout,lchar,lyes
  character*120 zfile
  character*35 tlabel
  character*10 zname

  real*8 zrhomin,zrhomax
  real*8 zne_bdy,zte_bdy,zti_bdy

  real*8 ztite
  integer :: idq

  real*8 dens_0,dens_a,gamma_dens
  real*8 temp_0,temp_a,gamma_temp

  real*8 r_mag_axis,z_mag_axis

  integer ingen

  !-------------------------------------------------------------------

  tlabel=' '
  write(tlabel,999) ztime0,ztavg
999 format('t = ',1pd11.4,' +/- ',1pd11.4,' s.')
  ztite =1.0

  !-------------------------------------------------------------------
  !  xplasma has already been set up
  !-------------------------------------------------------------------

  !  get plasma & grid R,Z limits

  call eq_rholim(zrhomin,zrhomax)  ! axis & bdy rho

  call eq_rzlims(Rminx,Rmaxx,Zminx,Zmaxx,ierr)  ! xplasma grid limits
  if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rzlims error.')

  call eq_glimrz(zrhomax,Rminpl,Rmaxpl,Zminpl,Zmaxpl,ierr)  ! plasma bdy limits
  if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_glimrz error.')

  !--------------------------------
  !  set default controls

  lamda_ne = 0.01d0   ! scrape-off thickness, m
  lamda_te = 0.01d0   ! scrape-off thickness, m
  dxtend = 0.05d0     ! grid extension beyond plasma boundary, m
  nR = 101            ! number of R grid points
  nZ = 101            ! number of Z grid points

  !--------------------------------
  !  default for analytic profiles
  !  these are only used if tpath(1:7)='GENXPL:'; otherwise TRANSP data
  !  is expected to be available.

  dens_0=6.0d19
  dens_a=ZERO
  gamma_dens=ONE

  temp_0=10.0d0
  temp_a=ZERO
  gamma_temp=3.0d0

  !--------------------------------
  !  user specification of controls

  do

     Rmin=max(Rminx,Rminpl/2,Rminpl-dxtend)
     Rmax=min(Rmaxx,Rmaxpl+dxtend)
     Zmin=max(Zminx,Zminpl-dxtend)
     Zmax=min(Zmaxx,Zmaxpl+dxtend)

     if(lxout(0)) then
        write(lnout(0),1001) nR,Rmin,Rmax, &
             nZ,Zmin,Zmax,dxtend, &
             lamda_ne,lamda_Te
1001    format(/' FWR2D grid (meters):'/ &
             5x,i4,' R points with Rmin=',1pd11.4,' & Rmax=',1pd11.4/ &
             5x,i4,' Z points with Zmin=',1pd11.4,' & Zmax=',1pd11.4/ &
             ' based on nominal extension of ',1pd11.4,' m beyond plasma bdy.'/ &
             ' scrape-off distance for electron density (m):     ',1pd11.4/ &
             ' scrape-off distance for electron temperature (m): ',1pd11.4/ &
             /'trxpl_fwr2d options:'/ &
             ' "R" -- change number of R grid points'/ &
             ' "Z" -- change number of Z grid points'/ &
             ' "X" -- change extension distance beyond plasma boundary'/ &
             '        (extension constrained by xplasma grid limits)'/ &
             ' "D" -- change scrape-off width (m) for density'/ &
             ' "T" -- change scrape-off width (m) for temperature'/ &
             '        ("D" & "T" control extrapolation of data beyond plasma bdy).'/ &
             ' "A" -- accept parameters and proceed'/ &
             ' "Q" -- quit (without writing data).'/)
        if(tpath(1:7).eq.'GENXPL:') then
           write(lnout(0),1002) 'density','n','n','n','n','n', &
                'm**-3','n',dens_0,'n',dens_a,'n',gamma_dens
           write(lnout(0),1002) 'temperature','T','T','T','T','T', &
                'KeV','T',temp_0,'T',temp_a,'T',gamma_temp
1002       format(1x,a,':',t15,a,'(x) = (',a,'_0 - ',a,'_a)*(1-x**2)', &
                '**gamma_',a,' + ',a,'_a (',a,'); x = r/a and'/ &
                '    ',a,'_0 = ',1pd11.4,'  ',a,'_a = ',1pd11.4, &
                '  gamma_',a,' = ',1pd11.4)
           write(lnout(0),1003) ztite
1003       format(' "P" -- set parameters for analytic profiles.'/ &
                ' "I" -- set ratio Ti/Te (to define Ti profile), current ', &
                'value: ',1pd11.4)
        endif
     endif

     call uread('trxpl_fwr2d: choose option:$')

     if(lchar('Q')) then
        return   ! do not write data

     else if(lchar('A')) then
        exit     ! proceed with parameters as selected

     else if(lchar('R')) then
        ! set nR
        if(lxout(0)) write(lnout(0),1004) igmin,igmax
        call ureadi('number of R grid points (nR):$',nR)
        nR=max(igmin,min(igmax,nR))

     else if(lchar('Z')) then
        ! set nZ
        if(lxout(0)) write(lnout(0),1004) igmin,igmax
        call ureadi('number of Z grid points (nZ):$',nZ)
        nZ=max(igmin,min(igmax,nZ))

     else if(lchar('X')) then
        ! set dxtend
        call ureadr8('grid extension beyond plasma bdy (m):$',dxtend)
        dxtend=abs(dxtend)

     else if(lchar('D')) then
        ! set lamda_ne
        call ureadr8('density scrape-off width (m):$',lamda_ne)
        lamda_ne=abs(lamda_ne)

     else if(lchar('T')) then
        ! set lamda_te
        call ureadr8('temperature scrape-off width (m):$',lamda_te)
        lamda_te=abs(lamda_te)

     else if(lchar('P')) then
        if(tpath(1:7).ne.'GENXPL:') then
           call uermsg( &
                '?trxpl_fwr2d: analytic profiles option not available.',' ',0)
        else
           call get3('m**-3','n_0',dens_0,'n_a',dens_a,'gamma_n',gamma_dens)
           call get3('KeV','T_0',temp_0,'T_a',temp_a,'gamma_T',gamma_temp)
        endif
     else if(lchar('I')) then
        if(tpath(1:7).ne.'GENXPL:') then
           call uermsg( &
                '?trxpl_fwr2d: analytic profile Ti/Te option not available.', &
                ' ',0)
        else
           call ureadr8('Ti/Te (btw 0.1 and 10.0):',ztite)
           if(ztite.lt.0.1d0) ztite=0.1d0
           if(ztite.gt.10.0d0) ztite=10.0d0
        endif
     else
        call uermsg('?trxpl_fwr2d: unrecognized option code.',' ',0)
     endif

1004    format(' minimum gridsize: ',i4,' maximum gridsize: ',i4)
  enddo

  !----------------------------------
  !  acquire temperature and density data in xplasma
  !   Hermite bicubic with scrape-off extrapolation

  if(tpath(1:7).ne.'GENXPL:') then
     ixtnd=1
     iordr=1

     zlamda=lamda_ne
     zname='NE'
     call trxpl_add_profile(zname)
     if(numpro.ne.1) return

     zlamda=lamda_te
     zname='TE'
     call trxpl_add_profile(zname)
     if(numpro.ne.2) return

     zlamda=lamda_te
     zname='TI'
     call trxpl_add_profile(zname)
     if(numpro.ne.3) return

  else
     ingen=2*max(50,nR,nZ)+1
     call gen_addprof(dens_0,dens_a,gamma_dens,'NE',lamda_ne,1)
     call gen_addprof(temp_0,temp_a,gamma_temp,'TE',lamda_te,2)
     call gen_addprof(ztite*temp_0,ztite*temp_a,gamma_temp,'TI',lamda_te,2)

  endif

  call eq_gfnum('Q',idq)
  if(idq.eq.0) call eq_gfnum('QMHD',idq)
  if(idq.gt.0) then
     zlamda=1.0d30
     call eqm_rzfun(idq,zlamda,1,ZERO,ierr)
     if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eqm_rzfun error.')
  else
     call errmsg_exit('?trxpl_fwr2d: no Q profile data.')
  endif

  !----------------------------------
  !  allocate local arrays

  nbdy=2*(nR+nZ)
  allocate(Rr(nR),Zz(nZ))
  allocate(Rbdy(nbdy),Zbdy(nbdy))
  allocate(ne(nR,nZ),Te(nR,nZ),bb(nR,nZ),bpol(nR,nZ),Ti(nR,nZ),qrz(nR,nZ))
  allocate(omega_pe(nR,nZ),omega_ce(nR,nZ),omega_xl(nR,nZ),omega_xr(nR,nZ))

  call calculate

  call display

  call uread(' write NetCDF file for FWR2D? (Y/N):$')

  if(lyes(0)) then
     zfile=' '
     call unixfile('trxpl_fwr2d',zfile)
     call write_cdf
  endif

  deallocate(Rr,Zz)
  deallocate(Rbdy,Zbdy)
  deallocate(ne,Te,bb,bpol,Ti,qrz,omega_pe,omega_ce,omega_xl,omega_xr)

contains

  !====================================================================
  subroutine calculate

    !  compute 2d profiles wanted by fwr2d

    real*8 rhovec(nbdy),thvec(nbdy),phivec(nbdy)
    real*8 ztmp(nR),zwk(nR,7)
    integer i,j,k,iregion(nbdy)
    integer :: id_te=0,id_ne=0,id_BR=0,id_BZ=0,id_Bphi=0,id_ti,id_q,ids(7)
    real*8 nemin,nemax
    integer inemin,jnemin

    !  mag axis...

    rhovec(1)=zrhomin
    thvec(1)=ZERO
    phivec(1)=ZERO
    call eq_rzget(1,rhovec(1:1),thvec(1:1),phivec(1:1),rbdy(1:1),zbdy(1:1), &
         iregion(1:1),ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rzget error @axis.')
    r_mag_axis=rbdy(1)
    z_mag_axis=zbdy(1)

    !  ids ...

    call eq_gfnum('TE',id_te); ids(1)=id_te
    call eq_gfnum('NE',id_ne); ids(2)=id_ne
    call eq_gfnum('BR',id_br); ids(3)=id_br
    call eq_gfnum('BZ',id_bz); ids(4)=id_bz
    call eq_gfnum('Bphi',id_bphi); ids(5)=id_bphi
    call eq_gfnum('TI',id_ti); ids(6)=id_ti
    call eq_gfnum('Q',id_q); ids(7)=id_q

    call eq_rgetf(1,zrhomax,id_te,0,zte_bdy,ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rgetf bdy Te error.')
    zte_bdy=max(ZERO,zte_bdy)

    call eq_rgetf(1,zrhomax,id_ti,0,zti_bdy,ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rgetf bdy Ti error.')
    zti_bdy=max(ZERO,zti_bdy)

    call eq_rgetf(1,zrhomax,id_ne,0,zne_bdy,ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rgetf bdy ne error.')
    zne_bdy=max(ZERO,zne_bdy)

    !  plasma boundary contour

    rhovec = zrhomax
    phivec = 0
    do i=1,nbdy
       thvec(i) = (i-1)*c2pi/(nbdy-1)
    enddo

    call eq_rzget(nbdy,rhovec,thvec,phivec,rbdy,zbdy,iregion,ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_rzget error.')

    rbdy(nbdy)=rbdy(1)  ! guarantee exact closure of the bdy contour
    zbdy(nbdy)=zbdy(1)

    !  form R & Z grids

    do i=1,nR
       Rr(i)=(Rmin*(nR-i)+Rmax*(i-1))/(nR-1)
    enddo

    do i=1,nZ
       Zz(i)=(Zmin*(nZ-i)+Zmax*(i-1))/(nZ-1)
    enddo

    !  interpolate ne,Te,B field data ... 1 row at a time

    do i=1,nZ
       ztmp=Zz(i)
       call eq_frz(nR,Rr,ztmp,7,ids,nR,zwk,ierr)
       if(ierr.ne.0) call errmsg_exit('?trxpl_fwr2d: eq_frz error.')

       te(1:nR,i)=max(1.0d-4*zte_bdy,zwk(1:nR,1))
       ne(1:nR,i)=max(1.0d-4*zne_bdy,zwk(1:nR,2))
       bb(1:nr,i)=sqrt( zwk(1:nR,3)**2 + zwk(1:nR,4)**2 + zwk(1:nR,5)**2 )
       bpol(1:nr,i)=sqrt( zwk(1:nR,3)**2 + zwk(1:nR,4)**2 )
       ti(1:nR,i)=max(1.0d-4*zti_bdy,zwk(1:nR,6))
       qrz(1:nR,i)=zwk(1:nR,7)

    enddo

    nemin=ne(1,1)
    inemin=1
    jnemin=1
    nemax=nemin
    do j=1,nZ
       do i=1,nR
          nemax=max(nemax,ne(i,j))
          if(ne(i,j).lt.nemin) then
             inemin=i
             jnemin=j
             nemin=ne(i,j)
          endif
       enddo
    enddo

    write(lnout(0),'(A,1PD11.4)') ' minimum electron density: ',nemin
    !  write(lnout(0),'(A,1PD11.4,A,1PD11.4)') '    at R=',Rr(inemin), &
    !       ' Z=',Zz(jnemin)
    write(lnout(0),'(A,1PD11.4)') ' maximum electron density: ',nemax

    !  compute omegas ... these are NRxNZ expressions...

    omega_pe = sqrt(ne*ee*ee/(eps0*me*(1 + 5*te/511)))
    omega_ce = ee*bb/(me*(1 + 5*te/511))

    omega_xl = sqrt((omega_ce**2)/4 + omega_pe**2) - omega_ce/2
    omega_xr = sqrt((omega_ce**2)/4 + omega_pe**2) + omega_ce/2

  end subroutine calculate

  !====================================================================
  subroutine display

    real*8 wk(max(nR,nZ))

    wk = 0

    do
 
       if(lxout(0)) then
          write(lnout(0),1001) r_mag_axis,z_mag_axis
1001      format(' (R,Z) of magnetic axis (m):',2(1x,1pe11.4)/ &
               /'display options:'/ &
               ' "N" -- ne(R,Z)'/ &
               ' "T" -- Te(R,Z)'/ &
               ' "A" -- |Bpol|(R,Z)'/ &
               ' "B" -- |B|(R,Z)'/ &
               ' "I" -- Ti(R,Z)'/ &
               ' "J" -- q(R,Z)'/ &
               ' "P" -- omega_pe(R,Z)'/ &
               ' "C" -- omega_ce(R,Z)'/ &
               ' "1" -- omega_xl(R,Z)'/ & 
               ' "2" -- omega_xr(R,Z)'/ &
               ' "X" -- xplasma debug plots.'/ &
               ' "Q" -- quit plotting menu.'/ &
               )
       endif

       call uread('trxpl_fwr2d(display): specify plotting option:$')

       if(lchar('N')) then
          call r8_grf3f1(Rr,ne,Zz,wk,nR,nZ,nR, &
               'R','electron density','Z', &
               'm','m**-3','m', tpath,tlabel,0)
          
       else if(lchar('T')) then
          call r8_grf3f1(Rr,Te,Zz,wk,nR,nZ,nR, &
               'R','electron temperature','Z', &
               'm','KeV','m', tpath,tlabel,0)
          
       else if(lchar('I')) then
          call r8_grf3f1(Rr,Ti,Zz,wk,nR,nZ,nR, &
               'R','ion temperature','Z', &
               'm','KeV','m', tpath,tlabel,0)

       else if(lchar('A')) then
          call r8_grf3f1(Rr,bpol,Zz,wk,nR,nZ,nR, &
               'R','|Bpol|','Z', &
               'm','T','m', tpath,tlabel,0)

       else if(lchar('B')) then
          call r8_grf3f1(Rr,bb,Zz,wk,nR,nZ,nR, &
               'R','|B|','Z', &
               'm','T','m', tpath,tlabel,0)

       else if(lchar('J')) then
          call r8_grf3f1(Rr,qrz,Zz,wk,nR,nZ,nR, &
               'R','q','Z', &
               'm',' ','m', tpath,tlabel,0)
          
       else if(lchar('P')) then
          call r8_grf3f1(Rr,omega_pe,Zz,wk,nR,nZ,nR, &
               'R','omega_pe','Z', &
               'm','s**-1','m', tpath,tlabel,0)
          
       else if(lchar('C')) then
          call r8_grf3f1(Rr,omega_ce,Zz,wk,nR,nZ,nR, &
               'R','omega_ce','Z', &
               'm','s**-1','m', tpath,tlabel,0)
          
       else if(lchar('1')) then
          call r8_grf3f1(Rr,omega_xl,Zz,wk,nR,nZ,nR, &
               'R','omega_xl','Z', &
               'm','s**-1','m', tpath,tlabel,0)
          
       else if(lchar('2')) then
          call r8_grf3f1(Rr,omega_xr,Zz,wk,nR,nZ,nR, &
               'R','omega_xr','Z', &
               'm','s**-1','m', tpath,tlabel,0)
          
       else if(lchar('X')) then
          call eqdbg_plot

       else if(lchar('Q')) then
          exit
       else
          call uermsg('?trxpl_fwr2d(display): unrecogized option.',' ',0)
       endif

    enddo

  end subroutine display

  !====================================================================
  subroutine get3(zunits,z0,f0,za,fa,zexp,fexp)

    character*(*), intent(in) :: zunits   ! units label

    character*(*), intent(in) :: z0       ! central value label
    real*8, intent(inout) :: f0

    character*(*), intent(in) :: za       ! edge value label
    real*8, intent(inout) :: fa

    character*(*), intent(in) :: zexp     ! exponent value label
    real*8, intent(inout) :: fexp

    !------------------------------------------

    call ureadr8(z0//' ('//zunits//'):$',f0)
    f0=max(ZERO,f0)

    call ureadr8(za//' ('//zunits//'):$',fa)
    fa=max(ZERO,fa)

    call ureadr8(zexp//' (dimensionless):$',fexp)
    fexp=max(1.0d-3,fexp)

  end subroutine get3

  !====================================================================
  subroutine gen_addprof(f0,fa,gamma,zname,lamda,ict)

    !  set up analytic profile in XPLASMA; extend to (R,Z) grid also.

    real*8,intent(in) :: f0    ! axial value of function
    real*8,intent(in) :: fa    ! edge value of function
    real*8,intent(in) :: gamma ! exponent (see formula)
    character*(*), intent(in) :: zname   ! profile name
    real*8,intent(in) :: lamda ! scrape-off width (m)
    integer, intent(in) :: ict ! fcn count; if =1, define x axis to XPLASMA

    !--------------------------
    real*8 :: xx(ingen),ff(ingen)
    character*8 :: xname = 'x_genadd'
    integer :: i,id_rho=0,id_x=0,ibc0,ibc1,id_out,ierr,iordr,iordrz
    real*8 :: zbc0,zbc1
    !--------------------------

    xx(1)=ZERO
    xx(ingen)=ONE
    do i=2,ingen-1
       xx(i)=(i-1)*xx(ingen)/(ingen-1)
    enddo

    if(ict.eq.1) then
       ! define "alternate" x axis to XPLASMA
       call eq_ganum('__RHO',id_rho)
       call eqm_uaxis(xname,id_rho,0,xx,ingen,1.0d-8,id_x,ierr)
    else
       ! fetch "alternate" x axis id
       call eq_ganum(xname,id_x)
    endif

    !  compute the profile...

    do i=1,ingen
       ff(i)=(f0-fa)*(ONE-xx(i)*xx(i))**gamma + fa
    enddo

    !  create the XPLASMA spline...

    zbc0=ZERO;  zbc1=ZERO
    ibc0=1;     ibc1=1
    if(gamma.lt.1.25d0) ibc1=0

    call eq_gfnum(zname,id_out)
    if(id_out.gt.0) then
       iordr=102  ! replacement spline
       iordrz=101 ! replacement Hermite in (R,Z) space
    else
       iordr=2    ! spline
       iordrz=1   ! Hermite in (R,Z) space
    endif

    call eqm_rhofun(iordr,id_x,zname,ff, &
         ibc0,zbc0,ibc1,zbc1, id_out, ierr)

    !  extend to (R,Z) space

    call eqm_rzfun(id_out,lamda,iordrz,ZERO,ierr)

  end subroutine gen_addprof
  !====================================================================
  subroutine write_cdf

    use ezcdf

    integer ncid,ierr,ilf

    !  write NetCDF file for FWR2D

    ilf=len_trim(zfile)

    call cdf_open(ncid,zfile(1:ilf),'w',ierr)
    if(ierr.ne.0) then
       write(lnout(0),*) ' ?trxpl_fwr2d: NetCDF open failure: ',zfile(1:ilf)

    else

       !  ** NetCDF definitions **

       !  TRANSP data source info
       call cdf_define(ncid,'TRANSP_path',tpath)
       call cdf_define(ncid,'time',ztime0)
       call cdf_define(ncid,'avg_delta_t',ztavg)
       
       !  grids
       call cdf_define(ncid,'nr',nR)
       call cdf_define(ncid,'nz',nZ)
       call cdf_define(ncid,'rr',Rr)
       call cdf_define(ncid,'zz',Zz)

       !  main data
       call cdf_define(ncid,'ne',ne)
       call cdf_define(ncid,'te',te)
       call cdf_define(ncid,'ti',ti)
       call cdf_define(ncid,'bb',bb)
       call cdf_define(ncid,'bpol',bpol)
       call cdf_define(ncid,'qrz',qrz)
       call cdf_define(ncid,'omega_pe',omega_pe)
       call cdf_define(ncid,'omega_ce',omega_ce)
       call cdf_define(ncid,'omega_xl',omega_xl)
       call cdf_define(ncid,'omega_xr',omega_xr)

       !  plasma bdy & scrape-off information
       call cdf_define(ncid,'r_mag_axis',r_mag_axis)
       call cdf_define(ncid,'z_mag_axis',z_mag_axis)
       call cdf_define(ncid,'dxtend',dxtend)
       call cdf_define(ncid,'lamda_ne',lamda_ne)
       call cdf_define(ncid,'lamda_te',lamda_te)
       call cdf_define(ncid,'nbdy',nbdy)
       call cdf_define(ncid,'rbdy',Rbdy)
       call cdf_define(ncid,'zbdy',Zbdy)

       !  ** NetCDF writes **

       !  TRANSP data source info
       call cdf_write(ncid,'TRANSP_path',tpath)
       call cdf_write(ncid,'time',ztime0)
       call cdf_write(ncid,'avg_delta_t',ztavg)

       !  grids
       call cdf_write(ncid,'nr',nR)
       call cdf_write(ncid,'nz',nZ)
       call cdf_write(ncid,'rr',Rr)
       call cdf_write(ncid,'zz',Zz)

       !  main data
       call cdf_write(ncid,'ne',ne)
       call cdf_write(ncid,'te',te)
       call cdf_write(ncid,'ti',ti)
       call cdf_write(ncid,'bb',bb)
       call cdf_write(ncid,'bpol',bpol)
       call cdf_write(ncid,'qrz',qrz)
       call cdf_write(ncid,'omega_pe',omega_pe)
       call cdf_write(ncid,'omega_ce',omega_ce)
       call cdf_write(ncid,'omega_xl',omega_xl)
       call cdf_write(ncid,'omega_xr',omega_xr)

       !  plasma bdy & scrape-off information
       call cdf_write(ncid,'r_mag_axis',r_mag_axis)
       call cdf_write(ncid,'z_mag_axis',z_mag_axis)
       call cdf_write(ncid,'dxtend',dxtend)
       call cdf_write(ncid,'lamda_ne',lamda_ne)
       call cdf_write(ncid,'lamda_te',lamda_te)
       call cdf_write(ncid,'nbdy',nbdy)
       call cdf_write(ncid,'rbdy',Rbdy)
       call cdf_write(ncid,'zbdy',Zbdy)

       !  ** all done **

       call cdf_close(ncid)

    endif

  end subroutine write_cdf

end subroutine trxpl_fwr2d_cdf

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_write_def_8(ss,icdf,cclist,nids,iout,iwarn,iertot)


  ! Define updated data

  USE plasma_state_definition_mod
  USE netcdf
  USE ps_nidlist_defn
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  TYPE (nidlist) :: nids       ! defined dimensions list
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------
  LOGICAL :: plasma_state_hash_match,ichange

  INTEGER :: varid,pvarid,vvarid,dimid,status,iertmp,iaddr
  INTEGER :: idims(20),indim,ival,ii,ierr
  CHARACTER*80 :: nc_errmsg

  !-------------------

  ierr = 0   ! local

  iaddr = ps_shash_tfinal
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("tfinal","PLASMA")
     ELSE
        indim = 0
        CALL define_var("tfinal","R",indim,idims, &
               "stop time of simulation (may be adjustable)", &
               "sec","PLASMA","SIMULATION_INIT", &
               "R  tfinal")
     ENDIF
  ENDIF

  iaddr = ps_phash_tfrip2_log
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tfrip2_log).AND.ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("tfrip2_log","RIPPLE")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr_rip,"dim_nr_rip",ss%nr_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr_rip
        IF(nids%nid_dim_nz_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz_rip,"dim_nz_rip",ss%nz_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz_rip
        CALL define_var("tfrip2_log","R",indim,idims, &
               "2nd component of TF ripple", &
               "-","RIPPLE","STATE_PROFILES", &
               "R|pclin  tfrip2_log(nR_rip,nZ_rip)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tfrip_log
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tfrip_log).AND.ichange) THEN
     IF(cclist(ps_cnum_RIPPLE).NE.1) THEN
        CALL ccwarn("tfrip_log","RIPPLE")
     ELSE
        indim = 0
        IF(nids%nid_dim_nr_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nr_rip,"dim_nr_rip",ss%nr_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nr_rip
        IF(nids%nid_dim_nz_rip.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nz_rip,"dim_nz_rip",ss%nz_rip)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nz_rip
        CALL define_var("tfrip_log","R",indim,idims, &
               "TF ripple: log((Bmax-Bmin)/(Bmax+Bmin))", &
               "-","RIPPLE","STATE_PROFILES", &
               "R|pclin  tfrip_log(nR_rip,nZ_rip)")
     ENDIF
  ENDIF

  iaddr = ps_shash_TF_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("TF_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("TF_Data_Info","C*80",indim,idims, &
               "information on source of toroidal field data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   TF_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_thegrilh
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%thegrilh).AND.ichange) THEN
     IF(cclist(ps_cnum_LH).NE.1) THEN
        CALL ccwarn("thegrilh","LH")
     ELSE
        indim = 0
        IF(nids%nid_dim_max_nspectrumlh_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_max_nspectrumlh_src,"dim_max_nspectrumlh_src",ss%max_nspectrumlh_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_max_nspectrumlh_src
        IF(nids%nid_dim_nlhrf_src.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nlhrf_src,"dim_nlhrf_src",ss%nlhrf_src)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nlhrf_src
        CALL define_var("thegrilh","R",indim,idims, &
               "need description", &
               "-","LH","SHOT_CONFIGURATION", &
               "R|units=- thegrilh(nspectrumlh_src(),nlhrf_src)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_nth_eq
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%th_eq).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("th_eq","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nth_eq.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nth_eq,"dim_nth_eq",ss%nth_eq)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nth_eq
        CALL define_var("th_eq","R",indim,idims, &
               "theta grid (EQ)", &
               "rad","EQ","SIMULATION_INIT", &
               "G|CCW   th_eq(nth_eq)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Ti
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Ti).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Ti","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("Ti","R",indim,idims, &
               "ion temperature", &
               "keV","PLASMA","STATE_PROFILES", &
               "R|units=keV|step*ni Ti(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tiflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tiflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tiflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("tiflux_ky_tglf","R",indim,idims, &
               "ion density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin tiflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_tinit
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("tinit","PLASMA")
     ELSE
        indim = 0
        CALL define_var("tinit","R",indim,idims, &
               "start time of simulation", &
               "sec","PLASMA","SIMULATION_INIT", &
               "R  tinit")
     ENDIF
  ENDIF

  iaddr = ps_shash_Ti_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Ti_bdy","PLASMA")
     ELSE
        indim = 0
        CALL define_var("Ti_bdy","R",indim,idims, &
               "Ion temperature at/beyond boundary", &
               "KeV","PLASMA","STATE_DATA", &
               "R Ti_bdy")
     ENDIF
  ENDIF

  iaddr = ps_phash_ti_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%ti_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("ti_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("ti_ky_tglf","R",indim,idims, &
               "ion density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin ti_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tmodel
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tmodel).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tmodel","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        CALL define_var("tmodel","R",indim,idims, &
               "target temperature profile", &
               "keV","ANOM","STATE_PROFILES", &
               "R|units=keV|step*nmodel   tmodel(~nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_tmodel_bdy
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tmodel_bdy","ANOM")
     ELSE
        indim = 0
        CALL define_var("tmodel_bdy","R",indim,idims, &
               "model temperature, boundary value", &
               "keV","ANOM","STATE_DATA", &
               "R|units=keV    tmodel_bdy")
     ENDIF
  ENDIF

  iaddr = ps_shash_tokamak_id
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("tokamak_id","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        CALL define_var("tokamak_id","N",indim,idims, &
               "Tokamak (Machine Description) ID", &
               "__NONE","PLASMA","MACHINE_DESCRIPTION", &
               "N  tokamak_id")
     ENDIF
  ENDIF

  iaddr = ps_shash_Tornum_balcrit
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Tornum_balcrit).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Tornum_balcrit","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_nballoon.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nballoon,"dim_nballoon",ss%nballoon)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nballoon
        CALL define_var("Tornum_balcrit","I",indim,idims, &
               "critical toroidal mode number for ballooning", &
               "__NONE","LMHD","STATE_DATA", &
               "I   Tornum_balcrit(nballoon)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_mmodes
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Tor_mode_label).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Tor_mode_label","LMHD")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_mmodes.EQ.0) THEN
           CALL define_dim(nids%nid_dim_mmodes,"dim_mmodes",ss%mmodes)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_mmodes
        CALL define_var("Tor_mode_label","N",indim,idims, &
               "Toroidal modes to monitor", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "L|toroidal_modes Tor_mode_label(mmodes)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Tor_mode_No
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Tor_mode_No).AND.ichange) THEN
     IF(cclist(ps_cnum_LMHD).NE.1) THEN
        CALL ccwarn("Tor_mode_No","LMHD")
     ELSE
        indim = 0
        IF(nids%nid_dim_mmodes.EQ.0) THEN
           CALL define_dim(nids%nid_dim_mmodes,"dim_mmodes",ss%mmodes)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_mmodes
        CALL define_var("Tor_mode_No","I",indim,idims, &
               "(from input) Toroidal modes monitored", &
               "__NONE","LMHD","SIMULATION_INIT", &
               "I   Tor_mode_No(mmodes)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tq0_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tq0_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("tq0_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("tq0_reco","R",indim,idims, &
               "torque of recombination neutral source", &
               "Nt*m","GAS","STATE_PROFILES", &
               "R|step*dV   tq0_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqb0_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqb0_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqb0_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqb0_halo","R",indim,idims, &
               "torque of halo neutral source", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqb0_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqbe
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqbe).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqbe","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqbe","R",indim,idims, &
               "collisional beam torque to electrons", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqbe(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqbi).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqbi","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqbi","R",indim,idims, &
               "collisional beam torque to thermal ions", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqbi(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqbjxb
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqbjxb).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqbjxb","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqbjxb","R",indim,idims, &
               "JxB beam torque", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqbjxb(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqbth
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqbth).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqbth","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqbth","R",indim,idims, &
               "momentum in thermalization of beam ions", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqbth(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqcx_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqcx_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqcx_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqcx_halo","R",indim,idims, &
               "beam halo driven CX momentum torque", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqcx_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqcx_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqcx_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("tqcx_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("tqcx_reco","R",indim,idims, &
               "reco driven CX momentum torque", &
               "Nt*m","GAS","STATE_PROFILES", &
               "R|step*dV   tqcx_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqioniz
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqioniz).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("tqioniz","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("tqioniz","R",indim,idims, &
               "ionization torque per unit influx (sc0)", &
               "Nt*m/(#/sec)","GAS","STATE_PROFILES", &
               "R|step*dV|units=Nt*m/(#/sec)     tqioniz(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqqcx
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqqcx).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("tqqcx","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        IF(nids%nid_dim_ngsc0.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ngsc0,"dim_ngsc0",ss%ngsc0)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ngsc0
        CALL define_var("tqqcx","R",indim,idims, &
               "cx torque per unit influx per (omeg0-omegi)", &
               "Nt*m/(#/sec)/(rad/sec)","GAS","STATE_PROFILES", &
               "R|step*dV|units=Nt*m/(#/sec)/(rad/sec)  tqqcx(~nrho_gas,ngsc0)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqsc_halo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqsc_halo).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("tqsc_halo","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_nbi.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_nbi,"dm1_nrho_nbi",ss%nrho_nbi-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_nbi
        CALL define_var("tqsc_halo","R",indim,idims, &
               "beam halo torque: recapture - tqb0_halo", &
               "Nt*m","NBI","STATE_PROFILES", &
               "R|step*dV   tqsc_halo(~nrho_nbi)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tqsc_reco
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tqsc_reco).AND.ichange) THEN
     IF(cclist(ps_cnum_GAS).NE.1) THEN
        CALL ccwarn("tqsc_reco","GAS")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_gas.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_gas,"dm1_nrho_gas",ss%nrho_gas-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_gas
        CALL define_var("tqsc_reco","R",indim,idims, &
               "reco torque: recapture - tq0_reco", &
               "Nt*m","GAS","STATE_PROFILES", &
               "R|step*dV   tqsc_reco(~nrho_gas)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tq_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tq_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tq_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho_anomth,"dm1_nrho_anomth",ss%nrho_anomth-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho_anomth
        CALL define_var("tq_anom","R",indim,idims, &
               "anomalous torque", &
               "Nt*m","ANOM","STATE_PROFILES", &
               "R|units=Nt*m|step*dV  tq_anom(~nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tq_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tq_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("tq_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        CALL define_var("tq_trans","R",indim,idims, &
               "angular momentum transport (loss)", &
               "Nt*m","PLASMA","STATE_PROFILES", &
               "R|units=Nt*m|step*dV  tq_trans(~nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tq_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tq_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("tq_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("tq_transcat","R",indim,idims, &
               "toroidal angular momentum transport", &
               "Nt*m","PLASMA","STATE_PROFILES", &
               "R|step*dV|units=Nt*m  tq_transcat(~nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_shash_trace_flag
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%trace_flag).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("trace_flag","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_nbeam.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nbeam,"dim_nbeam",ss%nbeam)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nbeam
        CALL define_var("trace_flag","I",indim,idims, &
               "trace element flag", &
               "__NONE","NBI","SIMULATION_INIT", &
               "I  trace_flag(nbeam)")
     ENDIF
  ENDIF

  iaddr = ps_dhash_ntrcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%trcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("trcat","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_32
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("trcat","N",indim,idims, &
               "Application defined list of", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "L|TR_categories  trcat(ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_triang
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%triang).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("triang","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("triang","R",indim,idims, &
               "triangularity (symmetrized)", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  triang(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_triangL
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%triangL).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("triangL","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("triangL","R",indim,idims, &
               "lower triangularity", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  triangL(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_triangU
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%triangU).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("triangU","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("triangU","R",indim,idims, &
               "upper triangularity", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  triangU(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_triang_miller_L
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%triang_miller_L).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("triang_miller_L","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("triang_miller_L","R",indim,idims, &
               "Miller lower triangularity", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  triang_miller_L(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_phash_triang_miller_U
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%triang_miller_U).AND.ichange) THEN
     IF(cclist(ps_cnum_EQ).NE.1) THEN
        CALL ccwarn("triang_miller_U","EQ")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_eq_geo.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_eq_geo,"dim_nrho_eq_geo",ss%nrho_eq_geo)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_eq_geo
        CALL define_var("triang_miller_U","R",indim,idims, &
               "Miller upper triangularity", &
               "-","EQ","STATE_PROFILES", &
               "R|pclin  triang_miller_U(nrho_eq_geo)")
     ENDIF
  ENDIF

  iaddr = ps_shash_trmodels
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%trmodels).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("trmodels","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_256
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("trmodels","C*256",indim,idims, &
               "short description or ID of transport models", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*256 trmodels(ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_Ts
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Ts).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Ts","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dm1_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dm1_nrho,"dm1_nrho",ss%nrho-1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dm1_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("Ts","R",indim,idims, &
               "thermal specie temperature", &
               "keV","PLASMA","STATE_PROFILES", &
               "R|units=keV|alias=T|step*ns  Ts(~nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_shash_Ts_Data_Info
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Ts_Data_Info","PLASMA")
     ELSE
        indim = 1
        idims(1)=nids%nid_clen_80
        CALL define_var("Ts_Data_Info","C*80",indim,idims, &
               "information on source of Temperature data", &
               "__NONE","PLASMA","SIMULATION_INIT", &
               "C*80   Ts_Data_Info")
     ENDIF
  ENDIF

  iaddr = ps_shash_Ts_is_input
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%Ts_is_input).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("Ts_is_input","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("Ts_is_input","I",indim,idims, &
               "specie temperature measurement flag", &
               "__NONE","PLASMA","STATE_DATA", &
               "I Ts_is_input(0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tzflux_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tzflux_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tzflux_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("tzflux_ky_tglf","R",indim,idims, &
               "impurity density flux spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin tzflux_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_tz_ky_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%tz_ky_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("tz_ky_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dim_nky_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nky_anomth,"dim_nky_anomth",ss%nky_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nky_anomth
        CALL define_var("tz_ky_tglf","R",indim,idims, &
               "impurity density fluctuation spectrum", &
               "GB","ANOM","STATE_PROFILES", &
               "R|units=GB|pclin tz_ky_tglf(nrho_anomth,nky_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_shash_T_einj_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T_einj_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("T_einj_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_t_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_t_einj_standard,"dim_n_t_einj_standard",ss%n_t_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_t_einj_standard
        CALL define_var("T_einj_standard","R",indim,idims, &
               "T beam table energies", &
               "keV","NBI","MACHINE_DESCRIPTION", &
               "R|units=keV T_einj_standard(n_T_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_T_ffull_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T_ffull_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("T_ffull_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_t_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_t_einj_standard,"dim_n_t_einj_standard",ss%n_t_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_t_einj_standard
        CALL define_var("T_ffull_standard","R",indim,idims, &
               "T beam full energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- T_ffull_standard(n_T_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_shash_T_fhalf_standard
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%T_fhalf_standard).AND.ichange) THEN
     IF(cclist(ps_cnum_NBI).NE.1) THEN
        CALL ccwarn("T_fhalf_standard","NBI")
     ELSE
        indim = 0
        IF(nids%nid_dim_n_t_einj_standard.EQ.0) THEN
           CALL define_dim(nids%nid_dim_n_t_einj_standard,"dim_n_t_einj_standard",ss%n_t_einj_standard)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_n_t_einj_standard
        CALL define_var("T_fhalf_standard","R",indim,idims, &
               "T beam half energy fractions", &
               "-","NBI","MACHINE_DESCRIPTION", &
               "R|units=- T_fhalf_standard(n_T_einj_standard)")
     ENDIF
  ENDIF

  iaddr = ps_phash_upwind_pfrac_ns
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%upwind_pfrac_ns).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("upwind_pfrac_ns","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("upwind_pfrac_ns","R",indim,idims, &
               "specie density forward upwind fractions", &
               "-","PLASMA","STATE_PROFILES", &
               "R|units=-|pclin upwind_pfrac_ns(nrho,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_upwind_pfrac_omega
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%upwind_pfrac_omega).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("upwind_pfrac_omega","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("upwind_pfrac_omega","R",indim,idims, &
               "omega (ang. velocity) forward upwind fraction", &
               "-","PLASMA","STATE_PROFILES", &
               "R|pclin upwind_pfrac_omega(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_upwind_pfrac_Te
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%upwind_pfrac_Te).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("upwind_pfrac_Te","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("upwind_pfrac_Te","R",indim,idims, &
               "Te (electron energy advection) forward upwind fraction", &
               "-","PLASMA","STATE_PROFILES", &
               "R|pclin upwind_pfrac_Te(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_upwind_pfrac_Ti
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%upwind_pfrac_Ti).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("upwind_pfrac_Ti","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("upwind_pfrac_Ti","R",indim,idims, &
               "Ti (ion energy advection) forward upwind fraction", &
               "-","PLASMA","STATE_PROFILES", &
               "R|pclin upwind_pfrac_Ti(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vee_trans
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vee_trans).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vee_trans","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        CALL define_var("vee_trans","R",indim,idims, &
               "electron energy radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|pclin   vee_trans(nrho)")
     ENDIF
  ENDIF

  iaddr = ps_phash_vee_transcat
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%vee_transcat).AND.ichange) THEN
     IF(cclist(ps_cnum_PLASMA).NE.1) THEN
        CALL ccwarn("vee_transcat","PLASMA")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho,"dim_nrho",ss%nrho)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho
        IF(nids%nid_dim_ntrcat.EQ.0) THEN
           CALL define_dim(nids%nid_dim_ntrcat,"dim_ntrcat",ss%ntrcat)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_ntrcat
        CALL define_var("vee_transcat","R",indim,idims, &
               "Electron energy radial velocity", &
               "m/sec","PLASMA","STATE_PROFILES", &
               "R|units=m/sec|pclin vee_transcat(nrho,ntrcat)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velb_fusi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velb_fusi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velb_fusi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("velb_fusi","R",indim,idims, &
               "fusion ion anom. radial velocity", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|pclin  velb_fusi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velb_nbi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velb_nbi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velb_nbi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("velb_nbi","R",indim,idims, &
               "beam ion anom. radial velocity", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|pclin  velb_nbi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velb_rfmi
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velb_rfmi).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velb_rfmi","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anom.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anom,"dim_nrho_anom",ss%nrho_anom)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anom
        CALL define_var("velb_rfmi","R",indim,idims, &
               "RF minority ion anom. radial velocity", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|pclin  velb_rfmi(nrho_anom)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velne_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velne_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velne_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velne_nclass","R",indim,idims, &
               "electron-density-equations, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velne_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velnh_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velnh_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velnh_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velnh_nclass","R",indim,idims, &
               "main-hydrogenic-density-equations, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velnh_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velni_drbm
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velni_drbm).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velni_drbm","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velni_drbm","R",indim,idims, &
               "ion convective velocity", &
               "m/s","ANOM","STATE_PROFILES", &
               "R|units=m/s|pclin velni_drbm(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_anom","R",indim,idims, &
               "density-equations, advective velocity term", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velns_anom(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_glf","R",indim,idims, &
               "density-equations, advective velocity term from GLF23 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velns_glf(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_gtcneo","R",indim,idims, &
               "density-equations, advective velocity term from GTC_NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velns_gtcneo(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_mmm71","R",indim,idims, &
               "density-equations, advective velocity term from MMM71 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velns_mmm71(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_nclass","R",indim,idims, &
               "density-equations, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velns_nclass(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_neo","R",indim,idims, &
               "density-equations, advective velocity term from NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velns_neo(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velns_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velns_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velns_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        IF(nids%nid_dp1_nspec_th.EQ.0) THEN
           CALL define_dim(nids%nid_dp1_nspec_th,"dp1_nspec_th",ss%nspec_th+1)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dp1_nspec_th
        CALL define_var("velns_tglf","R",indim,idims, &
               "density-equations, advective velocity term from TGLF model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velns_tglf(nrho_anomth,0:nspec_th)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velnx_nclass
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velnx_nclass).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velnx_nclass","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velnx_nclass","R",indim,idims, &
               "main-impurity-density-equations, advective velocity term from NCLASS model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velnx_nclass(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_anom","R",indim,idims, &
               "momentum-equation, advective velocity term", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velpphi_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_glf","R",indim,idims, &
               "momentum-equation, advective velocity term from GLF23 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velpphi_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_gtcneo","R",indim,idims, &
               "momentum-equation, advective velocity term from GTC_NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velpphi_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_mmm71
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_mmm71).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_mmm71","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_mmm71","R",indim,idims, &
               "momentum-equation, advective velocity term from MMM71 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velpphi_mmm71(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_neo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_neo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_neo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_neo","R",indim,idims, &
               "momentum-equation, advective velocity term from NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velpphi_neo(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velpphi_tglf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velpphi_tglf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velpphi_tglf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velpphi_tglf","R",indim,idims, &
               "momentum-equation, advective velocity term from TGLF model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin velpphi_tglf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_anom
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_anom).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_anom","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_anom","R",indim,idims, &
               "Te-equation, advective velocity term", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velte_anom(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_glf
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_glf).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_glf","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_glf","R",indim,idims, &
               "Te-equation, advective velocity term from GLF23 model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velte_glf(nrho_anomth)")
     ENDIF
  ENDIF

  iaddr = ps_phash_velte_gtcneo
  ichange = .NOT.plasma_state_hash_match(ss,iaddr,iertmp)
  IF(ALLOCATED(ss%velte_gtcneo).AND.ichange) THEN
     IF(cclist(ps_cnum_ANOM).NE.1) THEN
        CALL ccwarn("velte_gtcneo","ANOM")
     ELSE
        indim = 0
        IF(nids%nid_dim_nrho_anomth.EQ.0) THEN
           CALL define_dim(nids%nid_dim_nrho_anomth,"dim_nrho_anomth",ss%nrho_anomth)
           IF(ierr.NE.0) THEN
               iertot=iertot+1
               RETURN
           ENDIF
        ENDIF
        indim = indim + 1
        idims(indim) = nids%nid_dim_nrho_anomth
        CALL define_var("velte_gtcneo","R",indim,idims, &
               "Te-equation, advective velocity term from GTC_NEO model", &
               "m/sec","ANOM","STATE_PROFILES", &
               "R|units=m/sec|pclin  velte_gtcneo(nrho_anomth)")
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE define_dim(dimid,dname,idval)
        INTEGER, intent(out) :: dimid
        CHARACTER*(*), INTENT(in) :: dname
        INTEGER, intent(in) :: idval

        status = nf90_def_dim(icdf,dname,idval,dimid)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) ' ?ps_update_file_write: error defining dimension "'// &
                 trim(dname)//'".'
           IERR=9999
        ENDIF
     END SUBROUTINE define_dim



     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib



     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr



     SUBROUTINE ccwarn(varnam,compnam)

        CHARACTER*(*), intent(in) :: varnam   ! name of variable or array
        CHARACTER*(*), intent(in) :: compnam  ! name of component

        if(iwarn.eq.0) then
           write(iout,*) ' '
           write(iout,*) ' %ps_update_file_write: modified state elements'
           write(iout,*) '  exist which were not written due to the "cclist"'
           write(iout,*) '  input variable which screens out elements from'
           write(iout,*) '  selected components: cclist = ',cclist,';'
           write(iout,*) '  element values of 1 indicate components that are'
           write(iout,*) '  enabled for write.'
           write(iout,*) ' '
        endif

        iwarn = iwarn + 1

        write(iout,*) ' %ps_update_file_write: modified: ss%'// &
             trim(varnam)//' ('//trim(compnam)//' component) NOT WRITTEN.'

     END SUBROUTINE ccwarn

END SUBROUTINE ps_update_file_write_def_8

SUBROUTINE ps_update_file_write_8(ss,icdf,cclist,iucount,iout,iwarn,iertot)


  ! Write updated data

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: cclist(ps_ccount)  ! component selection
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iwarn   ! warn count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  CHARACTER*80 :: nc_errmsg

  !-------------------


  status = nf90_inq_varid(icdf,"tfinal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tfinal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tfinal"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tfrip2_log",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tfrip2_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tfrip2_log"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tfrip_log",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tfrip_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tfrip_log"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"TF_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%TF_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: TF_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"thegrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%thegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: thegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"th_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%th_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: th_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tiflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tinit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tinit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tinit"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ti_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ti_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ti_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ti_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%ti_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: ti_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tmodel"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tmodel_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tokamak_id",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tokamak_id)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tokamak_id"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tornum_balcrit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Tornum_balcrit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Tornum_balcrit"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tor_mode_label",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Tor_mode_label)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Tor_mode_label"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tor_mode_No",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Tor_mode_No)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Tor_mode_No"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tq0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tq0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqb0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbe",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqbe"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbjxb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqbjxb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqbjxb"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqbth"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqcx_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqcx_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqioniz",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqioniz"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqqcx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqqcx"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqsc_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqsc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqsc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqsc_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tqsc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tqsc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tq_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tq_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tq_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tq_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tq_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tq_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trace_flag",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%trace_flag)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: trace_flag"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%trcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: trcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%triang)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: triang"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triangL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%triangL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: triangL"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triangU",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%triangU)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: triangU"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang_miller_L",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%triang_miller_L)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: triang_miller_L"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang_miller_U",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%triang_miller_U)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: triang_miller_U"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trmodels",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%trmodels)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: trmodels"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ts)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ts"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ts_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ts_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%Ts_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: Ts_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tzflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tz_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%tz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: tz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%T_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: T_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: upwind_pfrac_ns"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_omega",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_omega)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: upwind_pfrac_omega"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_Te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_Te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: upwind_pfrac_Te"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%upwind_pfrac_Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: upwind_pfrac_Ti"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vee_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vee_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vee_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vee_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%vee_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: vee_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_rfmi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velne_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velnh_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velni_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velni_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velni_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velnx_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velpphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velpphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_put_var(icdf,varid,ss%velte_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_write:  error storing updated quantity: velte_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF
  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE ps_update_file_write_8

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_6(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"PsiRZ",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%PsiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: PsiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Psi_to_machine_axis",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Psi_to_machine_axis)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Psi_to_machine_axis"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_errck",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%psmom_errck)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psmom_errck"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_nc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%psmom_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psmom_nc"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psmom_num",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%psmom_num)
     status = nf90_get_var(icdf,varid,ss%psmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("psmom_num",ss%psmom_num)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"P_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%P_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: P_eq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_ALL)
     status = nf90_get_var(icdf,varid,ss%qatom_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_ALL",ss%qatom_ALL)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_ALLA)
     status = nf90_get_var(icdf,varid,ss%qatom_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_ALLA",ss%qatom_ALLA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_RFMIN)
     status = nf90_get_var(icdf,varid,ss%qatom_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_RFMIN",ss%qatom_RFMIN)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_S)
     status = nf90_get_var(icdf,varid,ss%qatom_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_S"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_S",ss%qatom_S)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SA)
     status = nf90_get_var(icdf,varid,ss%qatom_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SA",ss%qatom_SA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SFUS)
     status = nf90_get_var(icdf,varid,ss%qatom_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SFUS",ss%qatom_SFUS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SGAS)
     status = nf90_get_var(icdf,varid,ss%qatom_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SGAS",ss%qatom_SGAS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SIMP0)
     status = nf90_get_var(icdf,varid,ss%qatom_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SIMP0",ss%qatom_SIMP0)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SIMPI)
     status = nf90_get_var(icdf,varid,ss%qatom_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SIMPI",ss%qatom_SIMPI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qatom_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%qatom_SNBI)
     status = nf90_get_var(icdf,varid,ss%qatom_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qatom_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("qatom_SNBI",ss%qatom_SNBI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qbeami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qbeami"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qcomp_e",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qcomp_e)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qcomp_e"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qcomp_i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qcomp_i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qcomp_i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qie",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qie)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qie"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qioniz",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qioniz"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ql_operator",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ql_operator)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ql_operator"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qqcx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qqcx"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qrot_conv",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qrot_conv)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qrot_conv"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"qrot_diff",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%qrot_diff)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: qrot_diff"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_ALL)
     status = nf90_get_var(icdf,varid,ss%q_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_ALL",ss%q_ALL)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_ALLA)
     status = nf90_get_var(icdf,varid,ss%q_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_ALLA",ss%q_ALLA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%q_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_eq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_RFMIN)
     status = nf90_get_var(icdf,varid,ss%q_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_RFMIN",ss%q_RFMIN)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_S)
     status = nf90_get_var(icdf,varid,ss%q_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_S"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_S",ss%q_S)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SA)
     status = nf90_get_var(icdf,varid,ss%q_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SA",ss%q_SA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SFUS)
     status = nf90_get_var(icdf,varid,ss%q_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SFUS",ss%q_SFUS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SGAS)
     status = nf90_get_var(icdf,varid,ss%q_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SGAS",ss%q_SGAS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SIMP0)
     status = nf90_get_var(icdf,varid,ss%q_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SIMP0",ss%q_SIMP0)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SIMPI)
     status = nf90_get_var(icdf,varid,ss%q_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SIMPI",ss%q_SIMPI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"q_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%q_SNBI)
     status = nf90_get_var(icdf,varid,ss%q_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: q_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("q_SNBI",ss%q_SNBI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"R0_momeq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%R0_momeq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: R0_momeq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%RAD_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RAD_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%RAD_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RAD_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinb0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinb0i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0x",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinb0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinb0x"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinb0xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinb0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinb0xs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinf0i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinf0i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0x",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinf0x)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinf0x"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rate_sinf0xs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rate_sinf0xs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rate_sinf0xs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Real_ant_coef",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Real_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Real_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_sn",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%res_sn)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: res_sn"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%res_te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: res_te"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%res_ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: res_ti"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"res_tq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%res_tq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: res_tq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RFMIN_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%RFMIN_name)
     status = nf90_get_var(icdf,varid,ss%RFMIN_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RFMIN_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("RFMIN_name",ss%RFMIN_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rfmin_to_all",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rfmin_to_all)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rfmin_to_all"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rfmin_to_alla",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rfmin_to_alla)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rfmin_to_alla"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RFMIN_type",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL ichk_zero(ss%RFMIN_type)
     status = nf90_get_var(icdf,varid,ss%RFMIN_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: RFMIN_type"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL ichk_hash("RFMIN_type",ss%RFMIN_type)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho)
     status = nf90_get_var(icdf,varid,ss%rho)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho",ss%rho)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rhopsi0lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rhopsi0lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rhopsi0lh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_anom)
     status = nf90_get_var(icdf,varid,ss%rho_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_anom",ss%rho_anom)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anom2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_anom2)
     status = nf90_get_var(icdf,varid,ss%rho_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_anom2",ss%rho_anom2)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_anomth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_anomth)
     status = nf90_get_var(icdf,varid,ss%rho_anomth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_anomth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_anomth",ss%rho_anomth)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rho_bdy_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_bdy_ns"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_omegat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rho_bdy_omegat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_bdy_omegat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rho_bdy_Te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_bdy_Te"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rho_bdy_Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_bdy_Ti"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_ecrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_ecrf)
     status = nf90_get_var(icdf,varid,ss%rho_ecrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_ecrf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_ecrf",ss%rho_ecrf)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_eq)
     status = nf90_get_var(icdf,varid,ss%rho_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_eq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_eq",ss%rho_eq)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_eq_geo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_eq_geo)
     status = nf90_get_var(icdf,varid,ss%rho_eq_geo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_eq_geo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_eq_geo",ss%rho_eq_geo)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_fus",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_fus)
     status = nf90_get_var(icdf,varid,ss%rho_fus)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_fus"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_fus",ss%rho_fus)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_gas",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_gas)
     status = nf90_get_var(icdf,varid,ss%rho_gas)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_gas"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_gas",ss%rho_gas)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_icrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_icrf)
     status = nf90_get_var(icdf,varid,ss%rho_icrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_icrf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_icrf",ss%rho_icrf)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_lhrf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_lhrf)
     status = nf90_get_var(icdf,varid,ss%rho_lhrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_lhrf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_lhrf",ss%rho_lhrf)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_lmhd",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_lmhd)
     status = nf90_get_var(icdf,varid,ss%rho_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_lmhd",ss%rho_lmhd)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_mist",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_mist)
     status = nf90_get_var(icdf,varid,ss%rho_mist)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_mist"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_mist",ss%rho_mist)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_nbi)
     status = nf90_get_var(icdf,varid,ss%rho_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_nbi",ss%rho_nbi)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_pel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_pel)
     status = nf90_get_var(icdf,varid,ss%rho_pel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_pel"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_pel",ss%rho_pel)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_rad",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_rad)
     status = nf90_get_var(icdf,varid,ss%rho_rad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_rad"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_rad",ss%rho_rad)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%rho_rw)
     status = nf90_get_var(icdf,varid,ss%rho_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rho_rw"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("rho_rw",ss%rho_rw)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rlim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%rlim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: rlim"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_6

subroutine ps_name_check(listname,dim1,dim2,names,iout,ierr)

  !---------------------------------------------------------------------
  ! D. McCune Oct. 8 2006
  !   Part of plasma state implementation
  !   No actual xplasma2 dependency in this code; the only NTCC
  !   dependency is use of subroutine "uupper" to convert a character
  !   string to uppercase.
  !---------------------------------------------------------------------

  !---------------------------------------------------------------------
  ! what this subroutine does:
  !
  ! check names-- 
  !   (a) all must be non-blank;
  !   (b) all must consist of alphanumeric characters and "_"
  !   (c) no duplications within list, after uppercase conversion
  !---------------------------------------------------------------------

  implicit NONE

  character*(*), intent(in) :: listname  ! name of list of names...
  integer, intent(in) :: dim1,dim2       ! start & stop dimensions

  character*(*), intent(inout) :: names(dim1:dim2)  ! the list of names

  integer, intent(in) :: iout            ! Fortran LUN for output messages

  integer, intent(out) :: ierr           ! status code on exit, 0=OK

  !--------------------------
  ! local:

  integer :: i,j,ic,idups

  character*37, parameter :: legal = "ABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789"

  character*32 zname1,zname2
  !--------------------------

  ierr=0
  if(dim1.gt.dim2) return

  !  check for blanks...

  do i=dim1,dim2
     if(names(i).eq.' ') then
        if(ierr.eq.0) then 
           ierr=601
           write(iout,*) ' ?ps_name_check: blank names detected in: ', &
                trim(listname)
           write(iout,*) '  list is dimensioned (',dim1,':',dim2,').'
        endif
        write(iout,*) '  ...name #',i,' is blank.'
     endif
  enddo

  if(ierr.ne.0) then
     do i=dim1,dim2
        write(names(i),'(a3,i2.2)') 'var', i
        write(iout,*) '  ...reset name #',i,' to ', names(i)
     end do
  end if

  if(ierr.ne.0) return

  !  check for illegal characters...

  do i=dim1,dim2
     zname1=names(i)
     call uupper(zname1)
     do ic=1,len(trim(zname1))
        if(index(legal,zname1(ic:ic)).eq.0) then
           if(ierr.eq.0) then
              ierr=602
              write(iout,*) ' ?ps_name_check: illegal character(s) detected.'
              write(iout,*) '  in list "',trim(listname),'" -- non-alphanumeric, not "_":'
                  
              write(iout,*) '  list is dimensioned (',dim1,':',dim2,').'
           endif
           write(iout,*) '  ...name #',i,' is: "',trim(names(i)),'"'
           exit
        endif
     enddo
  enddo

  if(ierr.ne.0) return

  !  check for duplication

  idups=0

  do j=dim1,dim2-1
     zname2=names(j)
     call uupper(zname2)
     do i=j+1,dim2
        zname1=names(i)
        call uupper(zname1)
        if(zname1.eq.zname2) idups = idups+1
     enddo
  enddo

  if(idups.gt.0) then
     ierr=603
     write(iout,*) ' ?ps_name_check: duplicates in list of names "', &
          trim(listname),'".'
     write(iout,*) '  list of names:'
     do i=dim1,dim2
        write(iout,*) '    name #',i,':  "',trim(names(i)),'".'
     enddo
  endif

end subroutine ps_name_check

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_4(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbi_src_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbi_src_name)
  ENDIF
  IF(ALLOCATED(ss%nbi_src_name)) then
     jsize = SIZE(ss%nbi_src_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbi_src_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbi_src_name(ss%nbeam))
     ss%nbi_src_name = " "
  ENDIF

  isize = (ss%nbeam)
  IF(ALLOCATED(ss%nbshape).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nbshape)
  ENDIF
  IF(ALLOCATED(ss%nbshape)) then
     jsize = SIZE(ss%nbshape)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nbshape already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nbshape(ss%nbeam))
     ss%nbshape = " "
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%neflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%neflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%neflux_ky_tglf)) then
     jsize = SIZE(ss%neflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: neflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%neflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%neflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_neflux_ky_tglf(ss%nky_anomth))
     ss%id_neflux_ky_tglf = 0
  ENDIF

  isize = (ss%nnewcomb)
  IF(ALLOCATED(ss%Newcomb_code).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Newcomb_code)
  ENDIF
  IF(ALLOCATED(ss%Newcomb_code)) then
     jsize = SIZE(ss%Newcomb_code)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Newcomb_code already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Newcomb_code(ss%nnewcomb))
     ss%Newcomb_code = " "
  ENDIF

  isize = (ss%nnewcomb)
  IF(ALLOCATED(ss%Newcomb_mapper).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Newcomb_mapper)
  ENDIF
  IF(ALLOCATED(ss%Newcomb_mapper)) then
     jsize = SIZE(ss%Newcomb_mapper)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Newcomb_mapper already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Newcomb_mapper(ss%nnewcomb))
     ss%Newcomb_mapper = " "
  ENDIF

  isize = (ss%mmodes)*(ss%nnewcomb)
  IF(ALLOCATED(ss%Newcomb_stable).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Newcomb_stable)
  ENDIF
  IF(ALLOCATED(ss%Newcomb_stable)) then
     jsize = SIZE(ss%Newcomb_stable)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Newcomb_stable already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Newcomb_stable(ss%mmodes,ss%nnewcomb))
     ss%Newcomb_stable = 0
  ENDIF

  isize = (ss%nnewcomb)
  IF(ALLOCATED(ss%Newcomb_status).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%Newcomb_status)
  ENDIF
  IF(ALLOCATED(ss%Newcomb_status)) then
     jsize = SIZE(ss%Newcomb_status)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: Newcomb_status already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%Newcomb_status(ss%nnewcomb))
     ss%Newcomb_status = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%ne_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ne_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%ne_ky_tglf)) then
     jsize = SIZE(ss%ne_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ne_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ne_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%ne_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_ne_ky_tglf(ss%nky_anomth))
     ss%id_ne_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_fus-1)*(ss%nspec_fusion)
  IF(ALLOCATED(ss%nfusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nfusi)
  ENDIF
  IF(ALLOCATED(ss%nfusi)) then
     jsize = SIZE(ss%nfusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nfusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nfusi(ss%nrho_fus-1,ss%nspec_fusion))
     ss%nfusi = 0.0_rspec
     ALLOCATE(ss%id_nfusi(ss%nspec_fusion))
     ss%id_nfusi = 0
  ENDIF

  isize = (ss%nspec_fusion)
  IF(ALLOCATED(ss%nfusi_bdy).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nfusi_bdy)
  ENDIF
  IF(ALLOCATED(ss%nfusi_bdy)) then
     jsize = SIZE(ss%nfusi_bdy)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nfusi_bdy already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nfusi_bdy(ss%nspec_fusion))
     ss%nfusi_bdy = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq_geo)
  IF(ALLOCATED(ss%ngradb2_av).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ngradb2_av)
  ENDIF
  IF(ALLOCATED(ss%ngradb2_av)) then
     jsize = SIZE(ss%ngradb2_av)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ngradb2_av already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ngradb2_av(ss%nrho_eq_geo))
     ss%ngradb2_av = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%ni).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ni)
  ENDIF
  IF(ALLOCATED(ss%ni)) then
     jsize = SIZE(ss%ni)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ni already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ni(ss%nrho-1))
     ss%ni = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%niflux_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%niflux_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%niflux_ky_tglf)) then
     jsize = SIZE(ss%niflux_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: niflux_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%niflux_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%niflux_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_niflux_ky_tglf(ss%nky_anomth))
     ss%id_niflux_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nky_anomth)
  IF(ALLOCATED(ss%ni_ky_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ni_ky_tglf)
  ENDIF
  IF(ALLOCATED(ss%ni_ky_tglf)) then
     jsize = SIZE(ss%ni_ky_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ni_ky_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ni_ky_tglf(ss%nrho_anomth,ss%nky_anomth))
     ss%ni_ky_tglf = 0.0_rspec
     ALLOCATE(ss%id_ni_ky_tglf(ss%nky_anomth))
     ss%id_ni_ky_tglf = 0
  ENDIF

  isize = (ss%nrho_icrf-1)*(ss%nspec_rfmin)
  IF(ALLOCATED(ss%nmini).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nmini)
  ENDIF
  IF(ALLOCATED(ss%nmini)) then
     jsize = SIZE(ss%nmini)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nmini already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nmini(ss%nrho_icrf-1,ss%nspec_rfmin))
     ss%nmini = 0.0_rspec
     ALLOCATE(ss%id_nmini(ss%nspec_rfmin))
     ss%id_nmini = 0
  ENDIF

  isize = (ss%nspec_rfmin)
  IF(ALLOCATED(ss%nmini_bdy).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nmini_bdy)
  ENDIF
  IF(ALLOCATED(ss%nmini_bdy)) then
     jsize = SIZE(ss%nmini_bdy)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nmini_bdy already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nmini_bdy(ss%nspec_rfmin))
     ss%nmini_bdy = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth-1)
  IF(ALLOCATED(ss%nmodel).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nmodel)
  ENDIF
  IF(ALLOCATED(ss%nmodel)) then
     jsize = SIZE(ss%nmodel)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nmodel already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nmodel(ss%nrho_anomth-1))
     ss%nmodel = 0.0_rspec
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%nnkparlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nnkparlh)
  ENDIF
  IF(ALLOCATED(ss%nnkparlh)) then
     jsize = SIZE(ss%nnkparlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nnkparlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nnkparlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%nnkparlh = 0
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%nnkpollh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nnkpollh)
  ENDIF
  IF(ALLOCATED(ss%nnkpollh)) then
     jsize = SIZE(ss%nnkpollh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nnkpollh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nnkpollh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%nnkpollh = 0
  ENDIF

  isize = (ss%max_nspectrumlh_src)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%nnktorlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nnktorlh)
  ENDIF
  IF(ALLOCATED(ss%nnktorlh)) then
     jsize = SIZE(ss%nnktorlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nnktorlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nnktorlh(ss%max_nspectrumlh_src,ss%nlhrf_src))
     ss%nnktorlh = 0
  ENDIF

  isize = (ss%max_num_nphi)*(ss%nicrf_src)
  IF(ALLOCATED(ss%nphi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nphi)
  ENDIF
  IF(ALLOCATED(ss%nphi)) then
     jsize = SIZE(ss%nphi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nphi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nphi(ss%max_num_nphi,ss%nicrf_src))
     ss%nphi = 0
  ENDIF

  isize = (ss%nrho_rw-1)
  IF(ALLOCATED(ss%nrw).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nrw)
  ENDIF
  IF(ALLOCATED(ss%nrw)) then
     jsize = SIZE(ss%nrw)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nrw already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nrw(ss%nrho_rw-1))
     ss%nrw = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%nrz_antgeo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nrz_antgeo)
  ENDIF
  IF(ALLOCATED(ss%nrz_antgeo)) then
     jsize = SIZE(ss%nrz_antgeo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nrz_antgeo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nrz_antgeo(ss%nicrf_src))
     ss%nrz_antgeo = 0
  ENDIF

  isize = (ss%nrho-1)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%ns).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ns)
  ENDIF
  IF(ALLOCATED(ss%ns)) then
     jsize = SIZE(ss%ns)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ns already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ns(ss%nrho-1,0:ss%nspec_th))
     ss%ns = 0.0_rspec
     ALLOCATE(ss%id_ns(0:ss%nspec_th))
     ss%id_ns = 0
  ENDIF

  isize = (ss%nlhrf_src)
  IF(ALLOCATED(ss%nspectrumlh_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%nspectrumlh_src)
  ENDIF
  IF(ALLOCATED(ss%nspectrumlh_src)) then
     jsize = SIZE(ss%nspectrumlh_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: nspectrumlh_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%nspectrumlh_src(ss%nlhrf_src))
     ss%nspectrumlh_src = 0
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%ns_bdy).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ns_bdy)
  ENDIF
  IF(ALLOCATED(ss%ns_bdy)) then
     jsize = SIZE(ss%ns_bdy)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ns_bdy already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ns_bdy(0:ss%nspec_th))
     ss%ns_bdy = 0.0_rspec
  ENDIF

  isize = (ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%ns_is_input).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%ns_is_input)
  ENDIF
  IF(ALLOCATED(ss%ns_is_input)) then
     jsize = SIZE(ss%ns_is_input)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: ns_is_input already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%ns_is_input(0:ss%nspec_th))
     ss%ns_is_input = 0
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_4

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_3(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"grho2b2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grho2b2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grho2b2i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2r2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grho2r2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grho2r2i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2r3i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grho2r3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grho2r3i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gri",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gri)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gri"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grirhoi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grirhoi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grirhoi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_max_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"growthrate_vpar",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%growthrate_vpar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: growthrate_vpar"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gs_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%gs_name)
     status = nf90_get_var(icdf,varid,ss%gs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gs_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("gs_name",ss%gs_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"g_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%g_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: g_eq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"hegrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%hegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: hegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Hsize_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Hsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Hsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%H_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: H_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%H_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: H_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"H_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%H_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: H_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"icircuit_coil",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%icircuit_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: icircuit_coil"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"icrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%icrf_src_name)
     status = nf90_get_var(icdf,varid,ss%icrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: icrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("icrf_src_name",ss%icrf_src_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%IC_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: IC_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%IC_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: IC_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Imag_ant_coef",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Imag_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Imag_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"iota",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%iota)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: iota"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"isThermal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%isThermal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: isThermal"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"is_recycling",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%is_recycling)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: is_recycling"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"i_npoloidal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%i_npoloidal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: i_npoloidal"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"jdotb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%jdotb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: jdotb"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Bphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kccw_Bphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kccw_Bphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Jphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kccw_Jphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kccw_Jphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kdens_rfmin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kdens_rfmin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kdens_rfmin"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kvolt_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kvolt_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kvolt_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kyrhos_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kyrhos_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kyrhos_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kyspectrum_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%kyspectrum_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: kyspectrum_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbscap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Lbscap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Lbscap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbscap2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Lbscap2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Lbscap2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lbsctan",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Lbsctan)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Lbsctan"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lhrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%lhrf_src_name)
     status = nf90_get_var(icdf,varid,ss%lhrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: lhrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("lhrf_src_name",ss%lhrf_src_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%LH_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: LH_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%LH_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: LH_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_eq_code",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%LMHD_eq_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: LMHD_eq_code"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%LMHD_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: LMHD_status"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_machine_descr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%lock_machine_descr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: lock_machine_descr"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_shot_config",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%lock_shot_config)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: lock_shot_config"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"lock_sim_init",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%lock_sim_init)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: lock_sim_init"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Lpol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Lpol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Lpol"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Mercier_stable",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Mercier_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Mercier_stable"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"MHD_eq_status",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%MHD_eq_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: MHD_eq_status"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_ALL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_ALL)
     status = nf90_get_var(icdf,varid,ss%m_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_ALL",ss%m_ALL)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_ALLA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_ALLA)
     status = nf90_get_var(icdf,varid,ss%m_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_ALLA",ss%m_ALLA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_RFMIN",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_RFMIN)
     status = nf90_get_var(icdf,varid,ss%m_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_RFMIN",ss%m_RFMIN)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_S",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_S)
     status = nf90_get_var(icdf,varid,ss%m_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_S"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_S",ss%m_S)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SA",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SA)
     status = nf90_get_var(icdf,varid,ss%m_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SA"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SA",ss%m_SA)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SFUS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SFUS)
     status = nf90_get_var(icdf,varid,ss%m_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SFUS",ss%m_SFUS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SGAS",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SGAS)
     status = nf90_get_var(icdf,varid,ss%m_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SGAS",ss%m_SGAS)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SIMP0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SIMP0)
     status = nf90_get_var(icdf,varid,ss%m_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SIMP0",ss%m_SIMP0)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SIMPI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SIMPI)
     status = nf90_get_var(icdf,varid,ss%m_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SIMPI",ss%m_SIMPI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"m_SNBI",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%m_SNBI)
     status = nf90_get_var(icdf,varid,ss%m_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: m_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("m_SNBI",ss%m_SNBI)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0norm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%n0norm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: n0norm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%n0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: n0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%n0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: n0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbap2_shape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbap2_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbap2_shape"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbap_shape",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbap_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbap_shape"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbeami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbeami"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbeami_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbeami_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbeami_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbion",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbion"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nbion_trace",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nbion_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nbion_trace"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"NBI_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%NBI_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: NBI_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_3

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_contents_alloc(itype,icomponent,w,ierr)

  !  get counts on various tables of contents

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (ps_list_window) :: w     ! list window structure allocated

  INTEGER, INTENT(OUT) :: ierr   ! status completion code (0 = OK)

  !local:

  INTEGER :: iout,isize

  !----------------
  iout = SWIM_err_out_file
  ierr = 0

  call free_window(w)

  isize = 0

  if(itype.eq.ps_grid_dims) then
     ! grid
     w%list_name='Grids'
  else if(itype.eq.ps_species_lists) then
     ! species list
     w%list_name='Species_Lists'
  else if(itype.eq.ps_item_lists) then
     ! item list
     w%list_name='Item_Lists'
  else if(itype.eq.ps_machine_descr) then
     ! machine description
     w%list_name='Machine_Description'
  else if(itype.eq.ps_shot_config) then
     ! shot configuration
     w%list_name='Shot_Configuration'
  else if(itype.eq.ps_sim_control) then
     ! simulation initialization data
     w%list_name='Simulation_Init'
  else if(itype.eq.ps_data) then
     ! time varying state data
     w%list_name='State_Data'
  else if(itype.eq.ps_profiles) then
     ! profile data
     w%list_name='Profiles'
  else if(itype.eq.ps_enum_dims) then
     ! enumeration dimensions
     w%list_name='Enumeration_Dimensions'
  else
     write(iout,'(a,i5,a)') '?ps_contents_alloc: itype = ',itype,' invalid.'
     ierr = 1
     return
  endif


  ! Enumeration Dimensions

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nky_anomth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nky_mmm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nrz_antgeo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nspectrumlh_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! num_nphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! num_nphi_vac
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! num_rzlim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_D_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_H_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_straps
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_T_einj_standard
     ENDIF
  ENDIF
  ! Species Lists

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_all
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_alla
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_beam
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_fusion
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_gas
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_imp0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_impi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_rfmin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_th
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! nspec_tha
     ENDIF
  ENDIF

  ! Item Lists

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! mmodes
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nballoon
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nbeam
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ncircuits
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ncoils
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ndelta_w
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! necrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! neqmom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ngsc0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nicrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nlhrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nnewcomb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! npsmom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ntrcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nxs
     ENDIF
  ENDIF

  ! Grids

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nefi_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nefi_anom2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_anom2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_anomth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_ecrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_eq_geo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_fus
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_gas
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_icrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_lhrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_lmhd
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_mist
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_pel
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_rad
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nrho_rw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nr_rip
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nth_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nz
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! nz_rip
     ENDIF
  ENDIF

  ! Machine Description

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Ang_Href_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Ang_Vref_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ant_model
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_halfheight
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_halfwidth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_horiz_offset
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap2_vert_offset
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_halfheight
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_halfwidth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_horiz_offset
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ap_vert_offset
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! beam_type
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_halfHeight
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_halfwidth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Hdivergence
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Hfocal_length
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Vdivergence
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! b_Vfocal_length
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! coil_in_circuit
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! coil_resispt
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! dx_fshield
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_ffull_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! D_fhalf_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_Beam_Elongation
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_Half_Power_Angle
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_CURV_HOR
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_CURV_VERT
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_WIDTH_HOR
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EC_PRINC_WIDTH_VERT
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Einj_max
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Einj_min
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! geometry
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Hsize_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_ffull_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! H_fhalf_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbscap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbscap2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Lbsctan
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbap2_shape
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbap_shape
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nbshape
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! nrz_antgeo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ntf_coil2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! ntf_coils
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Nturns
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! num_rzlim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_D_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_H_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! n_T_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Phibsc
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Phi_EC_launch
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! rlim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Rloc_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_antgeo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_EC_launch
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_max_box
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! R_min_box
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! sRtcen
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! tokamak_id
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_einj_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_ffull_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! T_fhalf_standard
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! VRep_coil_count
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Vrep_coil_spacing
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Vsize_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zbap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zbsc
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! zlim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Zloc_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_antgeo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_EC_launch
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_max_box
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! Z_min_box
     ENDIF
  ENDIF

  ! Shot Configuration

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! amaxlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! aminlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! apolmaxlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! apolminlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! atormaxlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! atorminlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_Omode_Fraction
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_phi_aim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EC_theta_aim
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! fracpslh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_ec
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_ic
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! freq_lh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! gas_atom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! hegrilh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Imag_ant_coef
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! is_recycling
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! i_npoloidal
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! kccw_Bphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! kccw_Jphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nbion
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nbion_trace
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnkparlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnkpollh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nnktorlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nspectrumlh_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! nthinlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! num_nphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! num_nphi_vac
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! n_straps
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! phigrilh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Real_ant_coef
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! rhopsi0lh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! R_ant
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! shot_number
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! thegrilh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! wt_nphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Z_ant
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! Z_mid_ant
     ENDIF
  ENDIF

  ! Simulation Init

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! alla_index
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! all_index
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ANOM_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Balloon_mapper
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! CUR_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! DeltaW_mapper
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EC_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EC_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EQ_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! EQ_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! fracmin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! FUS_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! GAS_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Global_label
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! icircuit_coil
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! IC_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! IC_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! kdens_rfmin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LH_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LH_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! LMHD_eq_code
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! NBI_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! NBI_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Newcomb_mapper
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nky_anomth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nky_mmm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! nmom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ns_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PEL_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PEL_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! PLASMA_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RAD_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RAD_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! rfmin_to_all
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! rfmin_to_alla
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RUNAWAY_Code_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! RunID
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sa_index
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sc0_to_sgas
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sfus_to_all
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sfus_to_alla
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! sgas_to_s
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! simp0_to_s
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! simpi_to_s
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! snbi_to_all
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! snbi_to_alla
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! s_to_sa
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! tfinal
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! TF_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! tinit
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Tor_mode_No
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! trace_flag
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! trmodels
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Ts_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! vpol_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! VSUR_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! vtor_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Z0max
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ZEFF_Data_Info
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Zimp1
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! Zimp2
     ENDIF
  ENDIF

  ! State Data

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Balloon_stable
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Balloon_status
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_axis
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_axis_vac
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_max_lcfs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_min_lcfs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! coil_apt
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! DeltaW_stable
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! DeltaW_status
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! dist_fun
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! dn0out
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! e0_av
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! eldot
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! eqdsk_file
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! frac_full
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! frac_half
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! gamma_lmhd
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! isThermal
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! kvolt_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LMHD_status
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_machine_descr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_shot_config
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_sim_init
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Mercier_stable
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! MHD_eq_status
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nbeami_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nebar
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Newcomb_stable
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Newcomb_status
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nfusi_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmdifb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmini_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmodel_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ns_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ns_is_input
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! omegat_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! picrf_abs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! picrf_ext
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_ec
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_ic
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_lh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_nbi_trace
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Psi_to_machine_axis
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ql_operator
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_ns
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_omegat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_Te
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_Ti
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_axis
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_max_lcfs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_min_lcfs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! sc0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! t0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! t1
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Te_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Ti_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! tmodel_bdy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Tornum_balcrit
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Ts_is_input
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vphi0_av
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vpol_is_input
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vsur
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vtor_is_input
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! wt_nphi_abs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! wt_nphi_ext
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! xs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_axis
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_max_lcfs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_min_lcfs
     ENDIF
  ENDIF

  ! Profiles

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! anom_evar
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! area
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! balstab
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_bpass_co
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_bpass_ctr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_btrap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dpass_co
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dpass_ctr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dtrap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BphiRZ
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BRRZ
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BZRZ
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! B_surfMax
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! B_surfMin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cdicrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cdicrf_nphi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_etg
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_mtm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_ntm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_paleo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_w19
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_ntm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_w19
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chimo_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chimo_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_w19
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chitheta_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curbeam
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curech
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curech_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curfusn
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curich
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curlh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curlh_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curmino
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curr_bootstrap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curr_ohmic
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curt
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cur_rw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! db_mtm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dcur_rw_dVloop
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_fusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_rfmi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! diff_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! diff_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difne_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnh_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difns_w19
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnx_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difnz_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQedGrdte_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQedGrdti_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQidGrdte_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dQidGrdti_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ee_mobility_factor
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! elong
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_beami
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_fusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_mini
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eperp_rw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_beami
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_fusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_mini
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! epll_rw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Epot
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! eta_parallel
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_bpass_co
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_bpass_ctr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_btrap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dpass_co
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dpass_ctr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! fidiff_dtrap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Fi_depletion
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_max_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_mtm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! freq_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gamma_nc
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb1
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gb2i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gbr2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gncfb2h
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gncfh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr1
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr2rho2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gr3i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho1
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2b2i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2r2i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grho2r3i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! gri
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! grirhoi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_max_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_mtm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! growthrate_vpar
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! g_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! iota
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! jdotb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! kyrhos_mtm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! kyspectrum_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Lpol
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0norm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! n0_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nbeami
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! neflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ne_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nfusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ngradb2_av
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ni
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! niflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ni_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nmini
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nmodel
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nrw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ns
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nzflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! nz_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0cx
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0sc0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omeg0_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omegat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! omega_exb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! p0_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pb0_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbe
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pbth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pcx_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pcx_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! peech
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! peech_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pelh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pelh_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pe_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfuse
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pfusth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! phiflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! phit
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_nphi_srcs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_srcs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picrf_totals
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! picth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pilh
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pilh_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pi_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pmine
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pmini
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pminth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pohme
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! pot_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_br
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_cy
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! prad_li
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psc_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psc_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psipol
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! PsiRZ
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psmom_errck
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! psmom_nc
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! P_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qbeami
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qcomp_e
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qcomp_i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qie
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qioniz
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qqcx
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qrot_conv
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qrot_diff
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! q_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R0_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0x
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0xs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0i
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0x
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0xs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_sn
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_te
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_ti
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_tq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Rmajor_mean
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rMinor_mean
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_geo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_midp_in
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_midp_out
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_surfMax
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_surfMin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco_e
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco_recap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sb0halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sb0halo_recap
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbedep
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbehalo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbsce
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbtherm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sc_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sfsce
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sftherm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sii_xs
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sn_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sn_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sprof0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sprof0e
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! spsce
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! squareLO
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! squareUO
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! surf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0cx
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0sc0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! T0_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! teflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! te_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tfrip2_log
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tfrip_log
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Ti
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tiflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ti_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tmodel
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq0_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqb0_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbe
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbjxb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqbth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqcx_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqcx_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqioniz
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqqcx
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqsc_halo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tqsc_reco
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tq_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triangL
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triangU
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang_miller_L
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! triang_miller_U
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Ts
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tzflux_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! tz_ky_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_ns
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_omega
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_Te
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! upwind_pfrac_Ti
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vee_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vee_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_fusi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velb_rfmi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velne_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velnh_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velni_drbm
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velns_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velnx_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velpphi_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_paleo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velte_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_glf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_gtcneo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_mmm71
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_nclass
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_neo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! velti_tglf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vie_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vie_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vmo_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vmo_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vn_trans
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vn_transcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vol
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vpol_inmp
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vpol_omp
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vtor_inmp
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! vtor_omp
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! V_loop
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! v_pars
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! v_pers
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xRjcos_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xRjsin_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xZjcos_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! xZjsin_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z0_momeq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff_fi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Zeff_th
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_geo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_midp
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_surfMax
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Z_surfMin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ANOM_DIFFUS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ANOM_VELOC
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HALO_POWER
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HALO_TORQUE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HEATING
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_TORQUE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BMINMAX
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! COMPRESSION
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! DIFFUSIVITY
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_BAXIS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_BLCFS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EQ_BSIGNS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_FILES
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_RZAXIS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EQ_RZBOX
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_RZLCFS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! FUSION_HEATING
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ICRF_CONTROLS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LMHD_FLAGS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LOCK_VARIABLES
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! LOWER_HYBRID_HEATING
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! MIDPLANE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! MINORITY_HEATING
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RADIAL_VELOCITY
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RADIATED_POWERS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RECO_POWER
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RECO_TORQUE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RESIDUAL
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! RHO_BDY_SOLVE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RIPPLE_FIELDS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RMAJMIN
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ROTATION_DISSIPATION
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RZMINMAX
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! SURFACE_VOLTAGE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! SURFSHAPE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! TEMPERATURE_BCS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! TIME_RANGE
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! TIME_STEP
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! TRANSPORT
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! TRIANG_MILLER
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! UPWIND_FORWARD_FRACTIONS
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ZEFF_GROUP
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ZIMP_SA
     ENDIF
  ENDIF


  w%size = isize

  allocate(w%list_elems(isize)); w%list_elems = ' '
  allocate(w%elem_descr(isize)); w%elem_descr = ' '
  allocate(w%ival(isize)); w%ival = 0
  allocate(w%component(isize)); w%component = ' '

  allocate(w%vecsizes(isize)); w%vecsizes = 0

  if((itype.eq.ps_data).or.(itype.eq.ps_profiles).or. &
       (itype.eq.ps_machine_descr).or.(itype.eq.ps_shot_config).or. &
       (itype.eq.ps_sim_control)) then

     allocate(w%c256val(isize)); w%c256val = ' '
     allocate(w%elem_units(isize)); w%elem_units = ' '
     if(itype.eq.ps_profiles) then
        allocate(w%val_field(isize)); w%val_field = ' '
     endif

  else

     allocate(w%val_field(isize)); w%val_field = ' '

  endif

END SUBROUTINE ps_contents_alloc

subroutine tdb_find_nmoms(d,imoms,icirc)

  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d

  integer, intent(out) :: imoms,icirc

  ! return imoms = # of moments (0:imoms) in Fourier expansion
  ! return icirc = 1 if circular flux surfaces (minor & major radius only)
  !                are in use (this is very rare).

  imoms = 1
  icirc = 1

  if(d%ldmmx.gt.0) then
     imoms=d%mmax
     icirc=0
  else
     imoms=d%nmomd
     icirc=0
  endif

end subroutine tdb_find_nmoms

subroutine tdb_getrzfs_sizes(d,mth,mxi)
 
  !  get th and xi grid sizes for explicit R(theta,xi), Z(theta,xi)
  !  flux surface data

  use trdatbuf_obj
  IMPLICIT NONE

  type (trdatbuf) :: d
  integer, intent(out) :: mth  ! th (poloidal angle) grid size
  integer, intent(out) :: mxi  ! xi (sqrt(phi/philim)) radial grid size
  !-------------------------

  mth = d%nthfs
  mxi = d%nxfs

end subroutine tdb_getrzfs_sizes

subroutine tdb_getrzfs_xi(d,xi,nmax,ngot)

  !  get xi grid for explicit R(theta,xi), Z(theta,xi)
  !  flux surface data

  use trdatbuf_obj
  IMPLICIT NONE

  type (trdatbuf) :: d
  integer, intent(in) :: nmax      ! size of xi array provided
  real*8, intent(out) :: xi(nmax)  ! xi array
  integer, intent(out) :: ngot     ! number of xi values returned

  ! ngot=0 & xi = 0 is returned if there is no such data available or
  ! if nmax is too small.  In either case a warning message is printed.

  !-------------------------
  integer :: lunmsg_tdb
  !-------------------------

  ngot = 0
  xi = 0

  if(d%nxfs.eq.0) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs_xi:  no data available'
     return
  endif

  if(d%nxfs.gt.nmax) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs_xi:  passed xi grid size too small:'
     write(lunmsg_tdb(0),*) '  nmax (passed): ',nmax
     write(lunmsg_tdb(0),*) '  grid size in "d": ',d%nxfs
     return
  endif

  ngot = d%nxfs

  xi(1:ngot) = d%datbuf(d%lxfs:d%lxfs+d%nxfs-1)

end subroutine tdb_getrzfs_xi

subroutine tdb_getrzfs_th(d,th,nmax,ngot)

  !  get th grid for explicit R(theta,xi), Z(theta,xi)
  !  flux surface data

  use trdatbuf_obj
  IMPLICIT NONE

  type (trdatbuf) :: d
  integer, intent(in) :: nmax      ! size of th array provided
  real*8, intent(out) :: th(nmax)  ! th array
  integer, intent(out) :: ngot     ! number of th values returned

  ! ngot=0 & th = 0 is returned if there is no such data available or
  ! if nmax is too small.  In either case a warning message is printed.

  !-------------------------
  integer :: lunmsg_tdb
  !-------------------------

  ngot = 0
  th = 0

  if(d%nthfs.eq.0) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs_th:  no data available'
     return
  endif

  if(d%nthfs.gt.nmax) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs_th:  passed th grid size too small:'
     write(lunmsg_tdb(0),*) '  nmax (passed): ',nmax
     write(lunmsg_tdb(0),*) '  grid size in "d": ',d%nthfs
     return
  endif

  ngot = d%nthfs

  th(1:ngot) = d%datbuf(d%lthfs:d%lthfs+d%nthfs-1)

end subroutine tdb_getrzfs_th

subroutine tdb_getrzfs(d,zt,mth,mxi,rsurf,zsurf,ierr)

  !  get explicit R(theta,xi), Z(theta,xi) flux surface data interpolated
  !  to time "zt".  Array sizes provided must match the available data
  !  precisely, else ierr=1 is set and a message is printed.

  use trdatbuf_obj
  use tdbsub_uts
  IMPLICIT NONE

  type (trdatbuf) :: d
  real*8, intent(in) :: zt   ! time (seconds) to which to interpolate data

  integer, intent(in) :: mth,mxi  ! array dimensions -- must match!
  !  these are for the th (poloidal angle) and xi (radial flux coordinate)
  !  grids respectively

  real*8, intent(out) :: rsurf(mth,mxi)  ! R(th,xi)
  real*8, intent(out) :: zsurf(mth,mxi)  ! Z(th,xi)

  integer, intent(out) :: ierr           ! status code, 0=OK

  !--------------------------
  integer :: lunmsg_tdb
  integer :: ixi,ith,iad,ilt,int,it,ildr,ildz,incr
  real*8 :: zf
  !--------------------------

  ierr=0

  if(mth.ne.d%nthfs) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs: "th" array dimension mismatch:'
     write(lunmsg_tdb(0),*) '  passed value (mth):  ',mth
     write(lunmsg_tdb(0),*) '  stored value in "d": ',d%nthfs
     ierr=1
  endif

  if(mxi.ne.d%nxfs) then
     write(lunmsg_tdb(0),*) ' ?tdb_getrzfs: "xi" array dimension mismatch:'
     write(lunmsg_tdb(0),*) '  passed value (mxi):  ',mxi
     write(lunmsg_tdb(0),*) '  stored value in "d": ',d%nxfs
     ierr=1
  endif

  if(ierr.ne.0) then
     rsurf = 0
     zsurf = 0
     return
  endif

  !--------------------------------------
  !  error checks complete; interpolate the data

  !  get time interpolation factors (it:it+1) (zf=0.0 ->it; zf=1.0 ->it+1)
   
  ilt=d%ltime2
  int=d%ntime2
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt,it,zf)

  ildr=d%lrfs
  ildz=d%lzfs

  do ith=1,mth
     do ixi=1,mxi
        incr = int*((ixi-1)*mth + (ith-1))

        iad = ildr + incr + (it-1)
        rsurf(ith,ixi) = d%datbuf(iad)*(ONE-zf) + d%datbuf(iad+1)*zf

        iad = ildz + incr + (it-1)
        zsurf(ith,ixi) = d%datbuf(iad)*(ONE-zf) + d%datbuf(iad+1)*zf

     enddo
  enddo

end subroutine tdb_getrzfs

module trdatbuf_aux

  !  define auxilliary types to facilitate access to trdatbuf data...

  integer, parameter :: tdbaux_maxnb = 200

  type pwrget

     !  access to power vs. time datasets (e.g. beam or RF powers)

     character*3 :: item    ! NBI data item to fetch/average
     real*8 :: ztime1       ! start of time averaging window
     real*8 :: ztime2       ! end of time averaging window
     logical :: pweight     ! .TRUE. for power weighted average
     integer :: nbeam       ! no. of beams -- expected to match trdatbuf nbdata
     real*8 :: tbon(tdbaux_maxnb)  ! on times for beams (1:nbeam)
     real*8 :: tboff(tdbaux_maxnb) ! off times for beams (1:nbeam)
     integer :: nguard      ! if not equal to 123456789 assume not initialized.

     real*8 :: zparam(tdbaux_maxnb) ! return vector...

  end type pwrget

  type pelget
     real*8 :: tpel         ! pellet injection time (seconds)
     real*8 :: tpele        ! pellet injector end time (seconds)
     real*8 :: freqpel      ! pellet injection frequency (Hz)
     real*8 :: apel         ! A of pellet main component (H isotope)
     real*8 :: apel2        ! A of 2nd pellet component (H isotope)
     real*8 :: fpel2        ! fraction of 2nd component (usually 0.0)
     integer :: nmpela      ! pellet treatment option request (to TRANSP)
                            ! 0: density discontinuity, no ablation calculation
                            ! 1: density discontinuity, ablation calculated
                            ! 2: no density continuity, ablation calculated
     real*8 :: plrsta       ! major radius of injection into VV (cm)
     real*8 :: plysta       ! elevation above midplane of injection (cm)
     real*8 :: plphia       ! toroidal angle of injection (degrees)
                            ! 0 = dead perp, inward; + -> with plasma current
     real*8 :: plthea       ! poloidal angle of injection (degrees)
                            ! 0 = horizonta, + -> pointed upward
     real*8 :: pelvel       ! pellet velocity (cm/sec)
     real*8 :: pelrad       ! pellet radius (cm)
     integer :: kpellet     ! pellet ablation model
                            
  end type pelget

  type profget

     !  access to profile datasets

     !----------------------------------------
     !  input information...

     character*3 :: item      ! profile item desired...  e.g. "NER"

     integer :: iselect       ! profile selection w/in item (3d sets only)
                              !  (nb dmc June 2005 -- only an issue for
                              !  multi-impurity data) -- default value =0 OK

     integer :: nzones        ! number of zones in target grid

     !  to map data vs. normalized toroidal flux or norm. sqrt. tor. flux:

     real*8, dimension(:), pointer :: xibdys  ! (nzones+1) x @ zone bdys
     !      x is sqrt(Phi/Philim) ref enclosed toroidal flux at zone surfaces
     !      xibdys(1)=0; xibdys(nzones+1)=1 expected.

     !  to map data vs. normalized poloidal flux or norm. sqrt. pol. flux:

     real*8, dimension(:), pointer :: plflxg  ! (nzones+1) enclosed poloidal
     !      flux "psi" (Wb/2pi); Bpol = (1/R)*grad(psi)
     !      at zone bdys; plflxg(1)=0 expected.

     !  to map data vs. major or minor radius coordinate:

     real*8, dimension(:), pointer :: rmajmp  ! (2*nzones+1) major radii at
     !      flux zone boundary / midplane intercepts (cm).  RMAJMP(nzones+1)
     !      gives the magnetic axis; RMAJMP(1)= plasma boundary at midplane,
     !      small major radius side; RMAJMP(2*nzones+1) = plasma boundary at
     !      midplane, large major radius side.

     !  to map data vs. ECE frequency:

     real*8, dimension(:), pointer :: bmidp   ! (2*nzones+1) total B field (T)
     !      vs. major radius (rmajmp) along the midplane

     !  for all data items:

     real*8 :: time           ! time at which data is required (seconds)

     real*8 :: delta_t        ! average from time-delta_t to time+delta_t
                              ! default: delta_t = ZERO

     logical :: ibdy          ! T to interpolate to boundaries & fill in zones
                              ! F to interpolate to zone centers & fill in bdys
     !----------------------------------------
     !  internal:

     logical :: idebug        ! T to request extra output pertaining to
                              ! mapping or symmetrization of data
                              ! default: F

     logical :: iece          ! T for data vs. EC resonance frequency
     ! (trdatbuf object knows the harmonic frequency)

     integer :: nguard        ! used to verify object initialization
     integer :: nrmaj         ! 2*nzones + 1 -- rmajmp dimension
     integer :: nrsym         ! 4*nzones + 5 -- rmjsym dimension

     !  the following can be treated as output if desired by caller...
     !  these are only defined if idebug=T

     real*8, dimension(:), pointer :: xilmp
                              ! signed normalized sqrt tor flux on rmajmp grid

     !----------------------------------------
     !  output profiles: data & asymmetry profiles in data units...

     real*8, dimension(:), pointer :: data_zc ! (nzones+1) profile at zone
     !  centers, including a dummy zone, 1/2 zone width beyond plasma boundary

     real*8, dimension(:), pointer :: data_zb ! (nzones+1) profile at zone
     !  boundaries

     !----------------------------------------
     !  additional outputs created only if idebug=T...
     !
     !  for data that is input 2-sided vs. major radius and symmetrized
     !  by in/out averaging (nsyxxx=2 option):

     real*8, dimension(:), pointer :: asym_zc ! (nzones+1) profile asymmetry
     !  at zone centers (averaged value - measured value on large major radius
     !  side)

     real*8, dimension(:), pointer :: asym_zb ! (nzones+1) profile asymmetry
     !  at zone boundaries

     !  for data that is input 2-sided vs. major radius and symmetrized by
     !  the "slice and stack" method:

     real*8, dimension(:), pointer :: shift ! (nzones+1) inferred shift of
     !  flux surfaces relative to plasma boundary (cm)

     !  data mapped to fine major radius grid (in data units)

     real*8, dimension(:), pointer :: rmjsym
                              ! fine (nrsym) radial grid for symmetrization
                              ! comparison outputs
     real*8, dimension(:), pointer :: xirsym
                              ! signed normalized sqrt tor flux on rmjsym grid
                              ! range slightly greater than [-1,-1].

     real*8, dimension(:), pointer :: datrsym ! symmetrized data vs. rmjsym
     
     real*8, dimension(:), pointer :: datusym ! unsymmetrized data va. rmjsym

     real*8 :: ecegap   ! maximal B(R) monotonicity gap (cm)
     !  in high beta tokamak shots dB/dR can change sign due to diamagnetic
     !  effects, screening part of the plasma from view of an ECE temperature
     !  diagnostic; this number estimates the maximum such gap occurring
     !  it is calculated only if t%iece = .TRUE. and t%idebug = .TRUE.

  end type profget

  !----------------------------------------------

  contains

    subroutine tdb_pwrget_init(znbi)

      type(pwrget) :: znbi

      znbi%item = '???'
      znbi%ztime1 = 0
      znbi%ztime2 = -1
      znbi%pweight = .FALSE.
      znbi%nbeam = 0
      znbi%nguard = 123456789
      znbi%tbon(1) = 0
      znbi%tboff(1) = -1

    end subroutine tdb_pwrget_init

    subroutine tdb_profget_init(t,izones,idebug)

      type(profget) :: t
      integer, intent(in) :: izones
      logical, intent(in) :: idebug

      t%nguard = 123456789         ! indicate initialization of item
      t%item = '???'
      t%iselect = 0

      t%nzones = izones
      call tdb_nzones(t%nzones,t%nrmaj,t%nrsym)

      t%idebug = idebug

      allocate(t%xibdys(t%nzones+1)); t%xibdys = 0
      allocate(t%plflxg(t%nzones+1)); t%plflxg = 0
      allocate(t%rmajmp(t%nrmaj)); t%rmajmp = 0
      allocate(t%bmidp(t%nrmaj)); t%bmidp = 0

      if(t%idebug) then
         allocate(t%xilmp(t%nrmaj)); t%xilmp = 0
         allocate(t%xirsym(t%nrsym)); t%xirsym = 0
         allocate(t%rmjsym(t%nrsym)); t%rmjsym = 0
      else
         nullify(t%xilmp)
         nullify(t%xirsym)
         nullify(t%rmjsym)
      endif

      t%time = 0
      t%delta_t = 0
      t%ibdy = .FALSE.
      t%iece = .FALSE.

      !  space for output...

      t%ecegap = 0
      allocate(t%data_zc(t%nzones+1)); t%data_zc = 0
      allocate(t%data_zb(t%nzones+1)); t%data_zb = 0

      if(t%idebug) then
         allocate(t%asym_zc(t%nzones+1)); t%asym_zc = 0
         allocate(t%asym_zb(t%nzones+1)); t%asym_zb = 0
         allocate(t%shift(t%nzones+1)); t%shift = 0
         allocate(t%datrsym(t%nrsym)); t%datrsym = 0
         allocate(t%datusym(t%nrsym)); t%datusym = 0
      else
         nullify(t%asym_zc)
         nullify(t%asym_zb)
         nullify(t%shift)
         nullify(t%datrsym)
         nullify(t%datusym)
      endif
    end subroutine tdb_profget_init

    subroutine tdb_profget_free(t)

      type(profget) :: t

      deallocate(t%xibdys,t%plflxg,t%rmajmp,t%bmidp)
      deallocate(t%data_zc,t%data_zb)
      if(t%idebug) then
         deallocate(t%xilmp,t%xirsym,t%rmjsym)
         deallocate(t%asym_zc,t%asym_zb,t%shift,t%datrsym,t%datusym)
      endif

      t%nguard = 0   ! object de-initialized...

    end subroutine tdb_profget_free

end module trdatbuf_aux

subroutine trx_label(zlbl)
 
  use trx_module
  implicit NONE
 
  character*(*) zlbl
 
!
!  return label for current TRANSP run
!  if no run is connected, a blank label is returned
!
  if(nsurf.eq.0) then
     zlbl=' '
  else
     zlbl=run_label
  endif
!
  return
end subroutine trx_label

C Read 3D CDF U-file
C Called from uf3drd
C
C 08/15/97 CAL
C
C----------------------------------------------------------------------------
C
      subroutine ucdf3r(lun,option,
     &            f,n_f1,n_f2, x,n_x, y,n_y, xz,n_z, iproc,
     &            nx, ny, nz, iflag,
     &            flab,xlab,ylab,xzlab,
     &            retn)
 
      use UFILES
      implicit none
 
      include "netcdf.inc"
 
C Input:
      integer lun
      integer option   ! 1 = get Dimensions
C                      ! 2 = get data arrays
      integer n_f1, n_f2, n_x, n_y, n_z, iflag
C Return:
      integer      nx, ny, nz, iproc
      character*30 flab, xlab, ylab, xzlab
      real         x(n_x), y(n_y), xz(n_z), f(n_f1,n_f2,n_z)
      integer retn
 
C Definitions for CDF
      integer   nvars, ngatts, unlimid, nsc
      integer   var_id
      integer   nvdims(3)
      character*10 dimnam(3)
      integer dims(3), st(3), cnt(3)
      integer rank
 
C Definitions for processing
      integer       ichan, file_id
 
      character*20  fl,   xl,   yl, xzl
      character*10  fu,   xu,   yu, xzu
      integer       i, j, k
C--------------------------------------------------------
C
C
C get file name
      call uflchk(lun,'ucdf3r',ichan,retn)
      if (retn .ne. 0) return
      file_id = ufid(ichan)
C
      if (option .eq. 1) then       ! get Dimensions
C Inquire about file
         retn = nf_inq(file_id, rank, nvars, ngatts, unlimid)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9000) NF_STRERROR(retn)
 9000       format(' % UCDF3R: nf_inq'/,
     >           '     ',a)
            return
         end if
C
C Inquire dimensions
         do i=1,3
            retn = nf_inq_dim(file_id,i,dimnam(i),dims(i))
            if (retn .ne. NF_NOERR) then
               write(ufelun,9001) i, NF_STRERROR(retn)
 9001          format(' % UCDF3R: nf_inq_dim',i2/,
     >              '     ',a)
               return
            end if
C            type *,dimnam(i),dims(i)
         end do
         nx = dims(1)
         ny = dims(2)
         nz = dims(3)
C-----------------------------------------------------------------------
      else if (option .eq. 2) then
C
 
C Get data attributes
         nsc = nvars - rank - 1
         var_id = nsc+1
         retn = nf_get_att_text(file_id,var_id,'long_name',fl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
 9002       format(' % UCDF3R: nf_get_att_text id =',i3/,
     >           '     ',a)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',fu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         flab=fl(1:20)//fu(1:10)
 
C Get X attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',xl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',xu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         xlab=xl(1:20)//xu(1:10)
 
C get Y attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',yl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',yu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         ylab=yl(1:20)//yu(1:10)
C
C get Z attributes
         var_id = var_id + 1
         retn = nf_get_att_text(file_id,var_id,'long_name',xzl)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         retn = nf_get_att_text(file_id,var_id,'units',xzu)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
         xzlab=xzl(1:20)//xzu(1:10)
C
C
C Read X
         var_id =  nsc+2
         retn = nf_get_var_real(file_id, var_id, x)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
 
C get array data
         var_id = nsc + 1          ! Data is 1st variable after Scalars
         if (iflag .eq. 1) then    ! Read continuously into buffer
            retn = nf_get_var_real(file_id, var_id, f)
            if (retn .ne. NF_NOERR) then
               write(ufelun,9003) var_id, NF_STRERROR(retn)
 9003          format(' % UCDF3R: nf_get_var_real id =',i3/,
     >              '     ',a)
               return
            end if
         else                     ! Read according to dimensions
            st(1) = 1
            cnt(1) = dims(1)      ! x count
            cnt(2) = 1
            cnt(3) = 1
            do k = 1, dims(3)
               st(3) = k
               do j = 1,dims(2) ! For each Y : read slab into f
                  st(2) = j     ! Start of slab
                  retn = nf_get_vara_real(file_id, var_id,st,cnt,
     >                                    f(1,j,k))
                  if (retn .ne. NF_NOERR) then
                     write(ufelun,9004) var_id, NF_STRERROR(retn)
 9004                format(' % UCDF3R: nf_get_vara_real id =',i3/,
     >                    '     ',a)
                     return
                  end if
               end do
            end do
         end if
C
C Read Y
         var_id = nsc+3
         retn = nf_get_var_real(file_id, var_id, y)
         if (retn .ne. NF_NOERR) then
            write(ufelun,9002) var_id, NF_STRERROR(retn)
            return
         end if
      end if
 
C Read Z
!MG bug 03/03/2014
!      var_id = nsc+3
      var_id = nsc+4
      retn = nf_get_var_real(file_id, var_id, xz)
      if (retn .ne. NF_NOERR) then
         write(ufelun,9002) var_id, NF_STRERROR(retn)
         return
      end if
 
      return
      end
 
 
 
 
 
 
 
 
 
 

subroutine splitn_print_varinfo(iluno,runid,zname,ierr)

  implicit NONE

  !  print out formatted information on a variable in a namelist

  integer, intent(in) :: iluno        ! Fortran LUN to use for output
  character*(*), intent(in) :: runid  ! namelist identification
  character*(*), intent(in) :: zname  ! variable name

  integer, intent(out) :: ierr        ! status code returned (0=OK)

  !--------------------------------------------------------
  ! local:

  character*5 :: ztype
  integer :: ichsize,irank,idims(2,10),idim1,isize,ir,iadr
  integer :: j3a,j3b,j2a,j2b,j3,j2,ii,ic,nupdate
  integer :: iupdatable,idefault,inum_update,inmax,isum,iup
  integer, dimension(:), allocatable :: iupdate_vector
  character*80 zwk
  character*32 zsave
  character*10 zpiece
  character*128 zdflt
  character*132 zchunk

  character*6 zi6
  character*8 zblk
  character*40 zcombo

  character*128, dimension(:), allocatable :: zcdata,zcdat0
  integer, dimension(:), allocatable :: idata,idat0
  logical, dimension(:), allocatable :: ildata,ildat0
  real, dimension(:), allocatable :: zrdata,zrdat0
  real*8, dimension(:), allocatable :: zddata,zddat0

  real*8, dimension(:), allocatable :: tup

  logical, dimension(:), allocatable :: dflt_flags
  logical :: all_dflt

  !--------------------------------------------------------
  !  get update count & times first...
  call splitn_update_ntimes(nupdate)
  if(nupdate.gt.0) then
     allocate(tup(nupdate))
     call splitn_update_times(nupdate,tup,ierr)
  endif

  !  OK get item data type

  call splitn_get_type(zname,ztype,ichsize,ierr)
  if(ierr.ne.0) then
     write(iluno,*) ' ?variable type could not be found:'
     write(iluno,*) trim(runid)//' namelist variable "'//trim(zname)
     return
  endif

  write(iluno,*) ' '
  write(iluno,*) trim(runid)//' namelist variable "'//trim(zname)//'":'

  if(ztype(1:1).eq.'R') then
     write(iluno,*) '  data type:  R (4 byte REAL)'//'; * denotes default value'
  else if(ztype(1:1).eq.'D') then
     write(iluno,*) '  data type:  D (8 byte REAL)'//'; * denotes default value'
  else if(ztype(1:1).eq.'I') then
     write(iluno,*) '  data type:  I (INTEGER)'//'; * denotes default value'
  else if(ztype(1:1).eq.'L') then
     write(iluno,*) '  data type:  L (LOGICAL)'//'; * denotes default value'
  else if(ztype(1:1).eq.'C') then
     write(iluno,*) '  data type:  ',ztype, &
          ' -- string length up to ',ichsize,'; * denotes default value'
  endif

  ! get and display shape of object (scalar/array)

  idim1=0
  call splitn_getdims(zname,irank,10,idims,isize,ierr)
  if(ierr.ne.0) then
     write(iluno,*) ' ?splitn_getdims error (unexpected).'
     return
  endif

  ! if rank > 3, only the rank is displayed (future upgrade possible but
  ! no rank > 3 namelist items exist at present...)

  if(irank.eq.0) then
     write(iluno,*) '  Scalar'
  else if(irank.gt.3) then
     write(iluno,*) '  Array, rank: ',irank,' (rank>3, values not displayed).'
     return
  else

     !  print the dimensions...

     idim1=idims(2,1)-idims(1,1)+1
     if(irank.eq.1) zwk='  Vector, dimension: ('
     if(irank.eq.2) zwk='  2d Array, dimension: ('
     if(irank.eq.3) zwk='  3d Array, dimension: ('
     zsave='---> '//trim(zname)//'('
     do ir=1,irank
        zpiece=' '
        write(zpiece,'(I10)') idims(1,ir)
        call addwk(zwk,zpiece,1)
        call addwk(zwk,':',1)
        if(ir.eq.1) then
           call addwk(zsave,zpiece,1)
           call addwk(zsave,':',1)
        endif
        write(zpiece,'(I10)') idims(2,ir)
        call addwk(zwk,zpiece,1)
        if(ir.eq.1) then
           call addwk(zsave,zpiece,1)
        endif
        if(ir.lt.irank) then
           call addwk(zwk,',',1)
        else
           call addwk(zwk,')',1)
        endif
     enddo
     write(iluno,*) trim(zwk),' #items = ',isize
  endif

  ! default specifier string for item (controls value when item is not
  ! explicitly in namelist)

  call splitn_get_dstr(zname,zdflt,ierr)
  if(ierr.ne.0) then
     write(iluno,*) ' ?splitn_get_dstr error (unexpected).'
     return
  endif
  write(iluno,*) '  Default value specifier: ',trim(zdflt)

  ! get update status

  inmax=max(1,nupdate)
  allocate(iupdate_vector(inmax))

  call splitn_get_udetails(zname,iupdatable, &
       idefault,inum_update,inmax,iupdate_vector,ierr)
  if(ierr.ne.0) then
     write(iluno,*) ' ?splitn_get_udetails error (unexpected).'
     return
  endif

  isum=0
  if((iupdatable.gt.1).and.(nupdate.gt.0)) then
     do ii=1,inmax
        if(iupdate_vector(ii).ge.0) isum = isum + 1
     enddo
  else
     inum_update = 0      ! just to be sure...
     iupdate_vector = -1
  endif

  if(iupdatable.eq.0) then
     write(iluno,*) '  Item not updatable.'
  else if(iupdatable.eq.1) then
     write(iluno,*) '  Item updatable via "trdat" rerun.'
  else
     write(iluno,*) '  Item updatable via TRANSP update namelist.'
  endif

  write(iluno,*) ' '
  if(iupdatable.le.1) then
     if(idefault.eq.-1) then
        write(iluno,*) '  -> Item has default value (not referenced in the namelist).'
     else if(idefault.eq.0) then
        write(iluno,*) '  -> Item is referenced in namelist but retains its default value.'
     else if(idefault.eq.1) then
        write(iluno,*) '  -> Item has non-default value(s).'
     endif
  else
     if(idefault.eq.-1) then
        write(iluno,*) '  -> Item initially has default value (not referenced in main namelist).'
     else if(idefault.eq.0) then
        write(iluno,*) '  -> Item is referenced in main namelist; initially retains its default value.'
     else if(idefault.eq.1) then
        write(iluno,*) '  -> Item starts with non-default value(s).'
     endif
  endif

  if(iupdatable.gt.1) then
     write(iluno,*) ' '
     if(isum.eq.0) then
        write(iluno,*) '  Item is not referenced in update namelists.'
     else
        write(iluno,*) '  Item is referenced ',isum,' time(s) in update namelist(s).'
        write(iluno,*) '  Value changes occur ',inum_update,' time(s).'
     endif
  endif

  ! allocate buffer and get the actual values

  allocate(dflt_flags(isize))

  if(ztype(1:1).eq.'R') then
     allocate(zrdata(isize),zrdat0(isize))
     call splitn_rgetd(zname,isize,zrdat0,ierr)
  else if(ztype(1:1).eq.'D') then
     allocate(zddata(isize),zddat0(isize))
     call splitn_dgetd(zname,isize,zddat0,ierr)
  else if(ztype(1:1).eq.'I') then
     allocate(idata(isize),idat0(isize))
     call splitn_igetd(zname,isize,idat0,ierr)
  else if(ztype(1:1).eq.'L') then
     allocate(ildata(isize),ildat0(isize))
     call splitn_lgetd(zname,isize,ildat0,ierr)
  else if(ztype(1:1).eq.'C') then
     allocate(zcdata(isize),zcdat0(isize))
     call splitn_cgetd(zname,len(zcdata(1)),isize,zcdat0,ierr)
  else
     write(iluno,*) ' ?datatype "'//ztype//'" unrecognized.'
     ierr=99
  endif
  if(ierr.ne.0) return

  ! display values

  do iup = 0, nupdate

     if((iup.gt.0).and.(iupdate_vector(iup).le.0)) cycle

     if(iup.gt.0) then
        write(iluno,*) ' '
        write(iluno,*) '  At namelist update #',iup, &
             ' @time=',tup(iup),' seconds: '
     else if(iupdatable.gt.1) then
        write(iluno,*) ' '
        write(iluno,*) '  Initially: '
     endif

     zi6=' '
     write(zi6,'(i6)') iup
     ic=1
     do ii=len(zi6)-1,1,-1
        if(zi6(ii:ii).eq.' ') then
           ic=ii+1
           exit
        endif
     enddo

     zblk = '['//zi6(ic:len(zi6))//']'
     zcombo = trim(zname)//trim(zblk)

     if(ztype(1:1).eq.'R') then
        call splitn_rget(zcombo,isize,zrdata,ierr)
     else if(ztype(1:1).eq.'D') then
        call splitn_dget(zcombo,isize,zddata,ierr)
     else if(ztype(1:1).eq.'I') then
        call splitn_iget(zcombo,isize,idata,ierr)
     else if(ztype(1:1).eq.'L') then
        call splitn_lget(zcombo,isize,ildata,ierr)
     else if(ztype(1:1).eq.'C') then
        call splitn_cget(zcombo,len(zcdata(1)),isize,zcdata,ierr)
     endif

     ! update dflt_flags(...)
     all_dflt=.TRUE.
     do ii=1,isize
        if(ztype(1:1).eq.'R') then
           dflt_flags(ii) = (zrdata(ii).eq.zrdat0(ii))
        else if(ztype(1:1).eq.'D') then
           dflt_flags(ii) = (zddata(ii).eq.zddat0(ii))
        else if(ztype(1:1).eq.'I') then
           dflt_flags(ii) = (idata(ii).eq.idat0(ii))
        else if(ztype(1:1).eq.'L') then
           dflt_flags(ii) = .NOT.( &
                   (ildata(ii).AND.(.not.ildat0(ii))) .OR. &
                   (ildat0(ii).AND.(.not.ildata(ii))) )
        else if(ztype(1:1).eq.'C') then
           dflt_flags(ii) = (zcdata(ii).eq.zcdat0(ii))
        endif
        all_dflt = all_dflt.AND.dflt_flags(ii)
     enddo

     if(ierr.ne.0) then
        write(iluno,*) ' ?splitn_print_varinfo: error reading: ',trim(zcombo)
     else
        if(irank.eq.0) then

           ! display scalar values

           if(dflt_flags(1)) then
              zdflt='*'
           else
              zdflt=' '
           endif
           if(ztype(1:1).eq.'R') then
              write(iluno,1001) trim(zname),zrdata(1),zdflt
1001          format(/' ---> ',a,' = ',1pe12.5,a1)
           else if(ztype(1:1).eq.'D') then
              write(iluno,1002) trim(zname),zddata(1),zdflt
1002          format(/' ---> ',a,' = ',1pd12.5,a1)
           else if(ztype(1:1).eq.'I') then
              write(iluno,1003) trim(zname),idata(1),zdflt
1003          format(/' ---> ',a,' = ',i10,a1)
           else if(ztype(1:1).eq.'L') then
              write(iluno,1004) trim(zname),ildata(1),zdflt
1004          format(/' ---> ',a,' = ',L1,a1)
           else if(ztype(1:1).eq.'C') then
              write(iluno,1005) trim(zname),trim(zcdata(1)),zdflt
1005          format(/' ---> ',a,' = "',a,'"',a1)
           endif
        else

           ! display vector/array values; max rank of 3

           j3a=1; j3b=1
           j2a=1; j2b=1
           if(irank.ge.3) then
              j3a=idims(1,3); j3b=idims(2,3)
           endif
           if(irank.ge.2) then
              j2a=idims(1,2); j2b=idims(2,2)
           endif
           iadr=1-idim1
           do j3=j3a,j3b
              do j2=j2a,j2b
                 iadr=iadr+idim1
                 call prinvec  ! print values (iadr:iadr+idim1-1)
              enddo
           enddo
        endif
     endif
  enddo

  ! deallocate buffers

  deallocate(dflt_flags)
  if(ztype(1:1).eq.'R') then
     deallocate(zrdata,zrdat0)
  else if(ztype(1:1).eq.'D') then
     deallocate(zddata,zddat0)
  else if(ztype(1:1).eq.'I') then
     deallocate(idata,idat0)
  else if(ztype(1:1).eq.'L') then
     deallocate(ildata,ildat0)
  else if(ztype(1:1).eq.'C') then
     deallocate(zcdata,zcdat0)
  endif

  write(iluno,*) ' '

contains

  subroutine prinvec
    integer :: iper,ict,ia,is,id,isqz

    ! print array data

    if(ztype(1:1).eq.'R') then
       iper=14
    else if(ztype(1:1).eq.'D') then
       iper=14
    else if(ztype(1:1).eq.'I') then
       iper=12
    else if(ztype(1:1).eq.'L') then
       iper=3
    else if(ztype(1:1).eq.'C') then
       iper=80
    endif

    zwk = zsave
    if(irank.eq.1) then
       call addwk(zwk,'):',1)
    else if(irank.eq.2) then
       write(zpiece,'(I10)') j2
       call addwk(zwk,','//zpiece//'):',1)
    else if(irank.eq.3) then
       write(zpiece,'(I10)') j2
       call addwk(zwk,','//zpiece,1)
       write(zpiece,'(I10)') j3
       call addwk(zwk,','//zpiece//'):',1)
    endif

    write(iluno,*) ' '
    write(iluno,'(1x,a)') trim(zwk); zwk=' '
    if(all_dflt) then
       write(iluno,*) '   (all elements are set to their default values).'
       return
    endif

    ia=iadr-1
    do ict=1,idim1
       ia=ia+1
       zchunk=' '
       isqz=1
       if(ztype(1:1).eq.'R') then
          write(zchunk,'(1pe12.5)') zrdata(ia)
       else if(ztype(1:1).eq.'D') then
          write(zchunk,'(1pd12.5)') zddata(ia)
       else if(ztype(1:1).eq.'I') then
          write(zchunk,'(i10)') idata(ia)
       else if(ztype(1:1).eq.'L') then
          write(zchunk,'(L1)') ildata(ia)
       else if(ztype(1:1).eq.'C') then
          if(zcdata(ia).eq.' ') then
             zchunk = '" "'
             isqz=0
          else
             zchunk = '"'//trim(zcdata(ia))//'"'
          endif
       endif
       if(dflt_flags(ia)) call addwk(zchunk,'*',1)
       is = len_trim(zwk)
       id = 2-iper
       do
          id=id+iper
          if(id.gt.is) then
             zwk(id:id)='.'
             call addwk(zwk,zchunk,isqz)
             zwk(id:id)=' '
             exit
          endif
       enddo
       if(len_trim(zwk)+2+iper.ge.80) then
          write(iluno,'(1x,a)') trim(zwk); zwk=' '
       endif
    enddo
    
    if(len_trim(zwk).gt.0) then
       write(iluno,'(1x,a)') trim(zwk); zwk=' '
    endif
    
  end subroutine prinvec

  subroutine addwk(zstr,zstr_add,isqueeze)
    character*(*), intent(inout) :: zstr
    character*(*), intent(in) :: zstr_add
    integer :: isqueeze

    ! append to char string, squeezing out blanks if isqueeze=1

    integer :: iii,jjj,jlen

    jlen=len_trim(zstr_add)
    iii=len_trim(zstr)
    do jjj=1,jlen
       if((isqueeze.ne.1).or.(zstr_add(jjj:jjj).ne.' ')) then
          iii=iii+1
          zstr(iii:iii)=zstr_add(jjj:jjj)
       endif
    enddo
  end subroutine addwk

end subroutine splitn_print_varinfo

      subroutine trxpl_master
c
c  (used to be the trxpl main program...)
c  (this routine is called directly from the driver, trxpl/trxpl.for,
c   and that is all trxpl.for does).
c
c  trxpl main program source code
c  ------------------------------
c
c  `trxpl' allows detailed wide ranging access to time-slice data
c  extracted from completed TRANSP runs.
c
c  The data is read into "xplasma" via the "trxplib" subroutine library,
c  using "trread" and the legacy rplot-related libraries it calls to read
c  the actual TRANSP data.
c
c  By using trxplib/xplasma:
c
c    (a) all of the data has been converted to MKS physical units
c    (b) all of the data is presented as cubic-spline or cubic-Hermite
c        piecewise continuous & differentiable functions, allowing for
c        regridding according to user requirements.
c    (c) a complete MHD equilibrium description, with extrapolation to
c        cover a user-specified RxZ rectangle, is contained in the 
c        "xplasma" representation.
c    (d) any number of additional profiles and scalars may be accessed.
c    (e) additional profiles & scalars can be generated using the legacy
c        rplot calculator, but, MKS conversion becomes a user 
c        responsibility.
c
c  The user selects a "time of interest" t, and at averaging time delta_t,
c  so that the data presented is a time average over the range 
c      [t-delta_t, t+delta_t].
c
c  Once the desired data has been acquired, several outputs may be selected:
c
c    (a) equilibrium representation files in various formats:
c        G-eqdsk, Jon-Menard file, Alan-Glasser file, ...
c    (b) namelist data for GS2 may be generated
c    (c) NetCDF data for FWR2D may be generated
c        ...
c        ...
c
      implicit NONE
c
c---------------------------
c
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
c
c  misc.
      integer iwarn,ierr,ilt,ilz,irzflag,ieq,iws,ilun,jlun,ilenf
c
c  time of interest & averaging time
      real*8 ztime0,ztavg,zdelt_lead
      integer :: intime0  ! index in prof timebase to 1st time at/after ztime0
      integer :: intbegin ! index in prof timebase to begin state extraction...
      integer :: insc,inpr,idum,ichar1,iopen,ios
      integer :: istat
      character*12 zctime
      character*1 :: char1
      character*26 :: alphab = 'abcdefghijklmnopqrstuvwxyz'
c
c  user controlled grid sizes
      integer ntheta,nR,nZ,nR_orig,nZ_orig
c
c  direction of Btoroidal and Itoroidal
c
      integer ibccw,ipccw
c
c  non-blank length of character string
c
c  path to TRANSP run
      character*128 apath,tpath,fpath,gpath,hpath,spath,rpath,zpath
      integer ixtra,i,j,inr,inx,inx_state,ier,id_rho,inrho,ilenr,ilens
      integer :: ilenp
c
c  name and units of function
      character*10 zname,ztest
      character*16 zunits
c  calculator expression
      character*80 zexpr
c
c  Xplasma save filename
      character*80 zfile
c  Ufile labels
      character*4 tokdev
      character*12 runid
      character*10 zdate
c
      character*40 rlabel
c
c  (Ufile) scalars ... & profile list
c
      include 'trxpl.blk'
c
c  uread stuff
      integer lnout
      logical lxout,lchar,lyes
c
c  (R,Z) grid limits
      real*8 Rmin,Rmax,Zmin,Zmax
      real*8 Rmin_orig,Rmax_orig,Zmin_orig,Zmax_orig
c
c  (R,Z) limits of last flux surface
      real*8 Rmin1,Rmax1,Zmin1,Zmax1,zmid1,zhgt1
c
c  MHD Equilibrium ESI (L. Zakharov format)
c  related
c
      integer :: irho,ichi,inerr,id_ne=0
      real*8  ztflux
      character*50 :: zuns_mks
c
c  GEQDSK id label & other GEQDSK stuff
c
      character*48 geqdsk_lbl
      character*10 zttmp
      integer nh_geqdsk,nv_geqdsk,nb_geqdsk
 
      real*8 :: zcur
      integer :: id_psi=0,id_pmhd=0,id_q=0,id_g=0
c
c  CURRAY specific arrays and other infor
c
      integer :: nspec,n_species,iorder,lrho,ierror,ik,il,
     >           idcod,idvolt
      integer, dimension(:), allocatable :: id_ns,id_ts,itype,Izc
      character*20, dimension(:), allocatable :: slbl
      character*20 :: zunit_volt
      character*1 zans
      real*8 :: drho
      real*8, dimension(:), allocatable :: rho,zvalv,Zr8,Ar8
      real*8, dimension(:,:), allocatable :: zvaln,zvalt
      real*8, dimension(:), allocatable :: ztimes_p
c
      integer igs2,inaux,iaux,ierloc
c
      character*150 :: mdescr
c
c---------------------------------------
c  initializations
c
      ztime0=0.0
      ztavg=0.0
c
      fpath=' '
      gpath=' '
      hpath=' '
c
      call uinitg("TRXPL")
c
      write(6,*) ' '
      write(6,*) ' TRXPL version update: 4 Nov 2010'
      write(6,*) ' D. McCune, 2000--2010: TRANSP time slice extractor.'
      write(6,*) ' '
c
      call datmgr_no_delete   ! "datmgr" buffer can now be expanded 
c
c  have user specify runid, time, dt(avg), ntheta
c  trxpl - specific call
c
 10   continue
c
      call trxpl_mkgs2_reset
c
      call trxpl_path(tpath,ztime0,ztavg,ntheta,
     >   Rmin,Rmax,nR,Zmin,Zmax,nZ,ibccw,ipccw)
c
      if(tpath.eq.' ') then
         call uexita(0)
         stop  ! normal "trxpl" program exit
      endif
c
      nR_orig = nR
      nZ_orig = nZ
c
      Rmin_orig = Rmin
      Rmax_orig = Rmax
      Zmin_orig = Zmin
      Zmax_orig = Zmax
c
      ilt=len_trim(tpath)
c
c  connect to TRANSP run (file or MDS+)
c  get the radial coordinate "rho" = normalized sqrt(toroidal flux)
c
ccc      call trx_connect(tpath,ierr)
c
c  no, this now done in trxpl_path
c
c  get profile time vector

      call trx_ntimes(insc,inpr,idum)
      if(allocated(ztimes_p)) deallocate(ztimes_p)
      allocate(ztimes_p(inpr))
      call r8_rptime_p(ztimes_p,inpr,idum)
c
c  select the time of interest in the data
c  user selected the time either in "trxpl_path" (above) or in the "T"
c  menu option (below)
c
 15   continue
c
      intime0=inpr
c
      do i=1,inpr
         if(ztimes_p(i).ge.ztime0) then
            intime0=i
            exit
         endif
      enddo
c
c  call CONTAIN'd routine to establish xplasma @indicated time
c
      call loc_trx_get
      if(ierr.ne.0) go to 10
c
 20   continue
c
      if(lxout(0)) write(lnout(0),1000) Rmin1,Rmax1,numsc
 1000 format(/
     >' ...minimum R on boundary surface = ',1pd11.4/
     >' ...maximum R on boundary surface = ',1pd11.4//
     >' ...no. of scalars:  ',i3/
     >'  [caution: for GS2 choose "M" first;',
     >   ' for FWR2D choose "R" first.]'/
     >' C -- RPLOT calculator'/
     >' D -- display data'/
     >' P -- choose profiles'/
     >' S -- choose scalars'/
     >' E -- extract equilibrium Fourier moments'/
     >' I -- get all specie temperatures & densities (NOT for GS2)'//
     >' A -- write ascii file of scalars and profiles'/
     >' F -- write TRANSP equilibrium (Alan Glasser file)'/
     >' G -- write GEQDSK'/
     >' H -- write (Jon Menard style) psipqgRZ file'/
     >' J -- write species temperatures & densities (PPL TESTING only)'/
     >' L -- Write Equilibrium in ESI format (Leonid Zakharov style)'/
     >' N -- Write profiles for use by orbit'/
     >' U -- write Ufiles'/
     >' W -- write XPLASMA save NetCDF save file'//
     >' M -- read specie temperatures & densities; make GS2 namelists'/
     >' R -- read TE & NE; write NetCDF file for FWR2D ',
     >   '(reflectometry code)'//
     >' B -- write TRANSP equilibriumRZ NetCDF file for IMAS DataBase'//
     >' X -- extract data for PLASMA STATE file'/
     >'      (e.g. data for GENRAY/TORAY)'//
     >' T -- choose data from different time'/
     >' 1 -- for "time_slices" formatted output file'/
     >' Q -- quit (or get new run)')
      call uread('trxpl:  option select:$')
c
      if(lchar('Q')) then
         !  new RUN
         go to 10
 
      else if(lchar('1')) then
  
         call grunlb2(rlabel)

         if(lxout(0)) then
            write(lnout(0),*) 
     >           ' Note: data written in "TRANSP" units, not MKS.'
            write(lnout(0),*)
     >           ' Enter filename root, e.g "foo" => ASCII file is'
            write(lnout(0),*)
     >           ' written as "foo.dat"; NetCDF file as "foo.cdf".'
         endif

         spath=' '
         call unixfile('time_slices output <file_path>/<file_root>',
     >        spath)

         call ts_write_r8(trim(spath)//'.dat',trim(spath)//'.cdf',
     >        rlabel,tpath,ztime0,ztavg,ierr)
         if(ierr.ne.0) then
            call uermsi(' ?trxpl_master: time_slices write error.',
     >           ierr,0)
         endif

         go to 20

      else if(lchar('T')) then
         !  new TIME
         do
            call ureadr8('trxpl:  new time:$',ztime0)
            call trxpl_path_dtavg('trxpl: +/- delta(t) averaging time:',
     >           ztime0,ztavg,zans)
            if(zans.eq.'Q') then
               cycle
            else
               exit
            endif
         enddo
         go to 15
 
      else if(lchar('S')) then
         !  loop to get SCALAR data
         if(numsc.eq.maxsc) then
            call uermsi('?max no. of scalars reached: ',maxsc,0)
         else
            call trxpl_get_scalar(zname)
         endif
 
      else if(lchar('P')) then
         !  loop to get PROFILE data
         if(igs2.gt.0) then
            call uermsg(
     >         '%trxpl:  after "M" is used, "P" is not available.',
     >         ' ',0)
            go to 20
         endif
         if(numpro.eq.maxpro) then
            call uermsi('?max no. of profiles reached: ',maxpro,0)
         else
            call trxpl_get_profile(zname)
         endif
 
      else if(lchar('E')) then
         !  get equilibrium moments data
c
c  the moments scaling used in trxpl_eqmoms was found to be unsafe:
c  moments do not always scale as x**n -- it depends on the choice of
c  representation  --  dmc Nov 2006
c
         write(lnout(0),*) 
     >        ' Note: if you need "E" option contact dmccune@pppl.gov.'
         call uermsg(
     >        '?trxpl_master: option disabled for technical reasons',
     >        ' ',0)
ccc         do
ccc            if(lxout(0)) then
ccc               write(lnout(0),1088)
ccc 1088          format(/' Equilibrium moments options:'/
ccc     >            ' "S" -- scalar -- boundary moments only.'/
ccc     >            ' "P" -- profile -- moments profiles.'/
ccc     >            ' "A" -- both "S" and "P", redundancy accepted.'/
ccc     >            ' "Q" -- quit (do nothing)'/)
ccc            endif
ccc            call uread('TRXPL: Eq.moments sub-option:$')
ccc            if(lchar('Q')) then
ccc               ieq=0
ccc            else if(lchar('S')) then
ccc               ieq=1
ccc            else if(lchar('P')) then
ccc               ieq=2
ccc            else if(lchar('A')) then
ccc               ieq=3
ccc            else
ccc               call uermsg('?trxpl(eq.moments): invalid option.',' ',0)
ccc               cycle
ccc            endif
ccc            exit
ccc         enddo
ccc         if(ieq.gt.0) call trxpl_eqmoms(ieq)
 
      else if(lchar('A')) then
         !  write ASCII file of scalar & profile information gotten so far.
         call unixfile('Ascii output filename',apath)
         if((apath.ne.'Q ').and.(apath.ne.'q ')) then
            if(lxout(0)) then
               write(lnout(0),1099)
 1099          format(/
     >            ' enter grid option k:'/
     >            '   k=+1 for TRANSP grid'/
     >            '   k=+2 for TRANSP grid double density'/
     >            '    ...'/
     >            '   k=+5 for TRANSP grid quintuple density'/
     >            '   k=-N for N evenly spaced points; 20 <= N <= 1000'/
     >            '   ...radial flux coordinate "x" is the usual'/
     >            '   sqrt(normalized-toroidal-flux)'/
     >            )
            endif
 
            inr=1
            inx=1
 
            do
               call ureadi(
     >            'enter grid option "k" for radial flux coordinate:',
     >            inx)
               if((inx.eq.0).or.(inx.gt.5).or.(inx.lt.-1000).or.
     >            ((inx.gt.-20).and.(inx.le.0)) ) then
                  call uermsi(
     >               ' require k=1,2,3,4,5 or in range [-1000,-20].',
     >               inx,0)
               else
                  exit
               endif
            enddo
 
            do
               call ureadi('enter grid option "k" for Major Radius:',
     >            inr)
               if((inr.eq.0).or.(inr.gt.5).or.(inr.lt.-1000).or.
     >            ((inr.gt.-20).and.(inr.le.0)) ) then
                  call uermsi(
     >               ' require k=1,2,3,4,5 or in range [-1000,-20].',
     >               inr,0)
               else
                  exit
               endif
            enddo
 
            !----------------------------------------------
            call trxpl_ascii_write(apath,inx,inr)
            !----------------------------------------------
 
         endif
 
      else if(lchar('C')) then
         !  RPLOT CALCULATOR
         if(lxout(0)) then
            write(6,*)
     >         ' %caution -- although MKS conversion of standard TRANSP'
            write(6,*)
     >         '  profiles is automatic, the calculator must work in'
            write(6,*)
     >         '  "TRANSP" units;',
     >         ' user is responsible for labeling calculation results.'
         endif
         call ureadl('trxpl:  enter formula, or "Q" to quit:$',zexpr)
         if(zexpr.eq.'Q') go to 20
         zname=' '
         call ureadw('trxpl:  name of item to compute:$',zname)
         if(zname.eq.' ') then
            call uermsg(' ?trxpl:  non-blank name required.',' ',0)
            go to 20
         endif
         zunits=' '
         if(lxout(0)) then
            write(6,*)
     >        ' If calculation succeeds, trxpl "P" option will be able'
            write(6,*)
     >         ' access results and do most MKS conversions.'
         endif
         call ureadw('trxpl:  enter expected TRANSP physical units:$',
     >         zunits)
         call trx_calc(zname,zname//' (trxpl)',zunits,zexpr,iwarn,ierr)
         if(iwarn.gt.0) then
            write(6,*) ' %arithmetic errors occurred (trapped to zero)'
         endif
         if(ierr.gt.0) then
            write(6,*) ' %calculation failed.'
         endif
 
      else if(lchar('D')) then
         !  DISPLAY data with XPLASMA tool
         do i=1,numsc
            write(6,1001)
     >         i,sclabs(1,i),sclabs(2,i),sclabs(3,i),scvals(i)
         enddo
 1001    format(' scalar #',i3,':  ',3(a10,1x),'= ',1pd11.4)
c
c----------------------------------
         call eqdbg_plot
c----------------------------------
c
      else if(lchar('M')) then
 
         !--------------------------------------------------------------
         !  **** GS2 **** namelist generator
 
         if(numpro.gt.0) then
            call uermsg(
     >         '%trxpl:  after other options are used,'//
     >         ' "M" is not available.',
     >         ' ',0)
         else
            ilt=len_trim(tpath)
            call trxpl_mkgs2(tpath(1:ilt),ztime0,ztavg,ierr)
            igs2=1
            if(ierr.eq.0) then
               write(6,*) 'GS2 processing completed OK.'
            else
               write(6,*) 'GS2 (trxpl_mkgs2) error code, ierr=',ierr
            endif
         endif
c
      else if(lchar('R')) then
 
         !--------------------------------------------------------------
         !  **** FWR2D **** file generator
 
         if(numpro.gt.0) then
            call uermsg(
     >         '%trxpl:  after other options are used,'//
     >         ' "R" is not available.',
     >         ' ',0)
         else
            ilt=len_trim(tpath)
            call trxpl_fwr2d_cdf(tpath(1:ilt),ztime0,ztavg)
         endif
 
      else if(lchar('B')) then
 
         !--------------------------------------------------------------
         !  ****IMAS/ITER **** file generator
 
         if(numpro.gt.0) then
            call uermsg(
     >         '%trxpl:  after other options are used,'//
     >         ' "B" is not available.',
     >         ' ',0)
         else
 
            ilt=len_trim(tpath)

!     call trx_imas(ntheta,ierr)
            if(ierr.ne.0) then
               write(6,*) ' ?trxpl:  error in trx_imas:  ',tpath(1:ilt)
               return
            endif
            call trxpl_imaswr2d_cdf(tpath(1:ilt),ztime0,ztavg,
     >           ibccw,ipccw)
         endif
 
      else if(lchar('U')) then
         !  Ufile output option (no recent maintenance dmc 12/2002!)
         call trxpl_ufiles(tokdev,zdate,scvals,sclabs,numsc)

      else if(lchar('W')) then
         call ureadLw('Please give XPLASMA save filename:',zfile)

         call eq_save(zfile,ierr)
         write(6,*) trim(zfile),' written, status code (0=OK): ',ierr

      else if(lchar('L')) then
         ! Write Equilibrium in ESI format (L. Zakharov format)

         irho=21
         ichi=65

         open (99, file='esiA.00', status='replace')

         call eq_gfnum('pmhd',id_pmhd)

         call trx_scal('TFLUX',zuns_mks,ztflux,inerr)

         call trx_prof('NE',zuns_mks,1,id_ne,inerr)

         call eq_esia(99,irho,ichi,ztflux,id_pmhd,id_ne)

         close(99)

      else if(lchar('N')) then
         ! Write profiles for use by Roscoe's Orbit 

         open (99, file='nbi_profile.dat', status='replace')

         call trxpl_orbit_prof(99)

         close(99)

      else if(lchar('G')) then
         !  write GEQDSK file
 
         call wr_geq   ! contained routine...

      else if(lchar('I')) then
c
c        fetch temperature, density, Eperp and Epll for all charged
c        particle species ... thermal and non-thermal alike
c
         call trx_nspec(nspec)
 
         if(allocated(id_ns)) deallocate(id_ns)
         if(allocated(id_ts)) deallocate(id_ts)
         if(allocated(slbl)) deallocate(slbl)
         if(allocated(itype)) deallocate(itype)
         if(allocated(Zr8)) deallocate(Zr8)
         if(allocated(Ar8)) deallocate(Ar8)
         if(allocated(Izc)) deallocate(Izc)
         if(allocated(zvaln)) deallocate(zvaln)
         if(allocated(zvalt)) deallocate(zvalt)
         if(allocated(zvalv)) deallocate(zvalv)
         allocate(id_ns(nspec))
         allocate(id_ts(nspec))
         allocate(slbl(nspec))
         allocate(itype(nspec))
         allocate(Zr8(nspec))
         allocate(Ar8(nspec))
         allocate(Izc(nspec))
         allocate(zvaln(1:lrho,1:nspec))
         allocate(zvalt(1:lrho,1:nspec))
         allocate(zvalv(1:lrho))
 
         iorder=1
 
         call trx_spec_lbl(nspec,n_species,slbl,itype,Zr8,Ar8,IZc)
         do i=1,nspec
            if(itype(i).eq.3) then
               iordr=1
               ixtnd=0
               zname='AIMPJ'
               call trxpl_add_profile(zname)  ! for model impurity
               zname='XZIMPJ'
               call trxpl_add_profile(zname) ! for model impurity
               zname=' '
            endif
         enddo
 
         call trxpl_species(nspec,iorder,'T',id_ts)
 
         call trxpl_species(nspec,iorder,'<Eperp>',id_ts)
 
         call trxpl_species(nspec,iorder,'<Epll>',id_ts)
 
         call trxpl_species(nspec,iorder,'N',id_ns)
c
      else if(lchar('J')) then
c
c     *** test code ***
c
c Code corresponding to option J (CURRAY) written by
c K. Indireshkumar (08/2002)
c
         lrho_loop: do
 
            call uread(
     >         'ENTER NUMBER OF GRID POINTS OR "Q" TO QUIT:$$')
 
            ierror=0
            if (lchar('Q')) then
               lrho=51
               print *,'Number of zones set to ',lrho
            else
               lrho=idcod(ierror)
            endif
 
            if (ierror.ne.0) cycle lrho_loop
 
            exit lrho_loop
 
         end do lrho_loop
 
         if (allocated(rho)) deallocate(rho)
         allocate(rho(lrho))
 
         rho(1)=0.0
         drho=1.0/(lrho-1)
         do ik=2,lrho
            rho(ik)=rho(ik-1)+drho
         enddo
c
         call trx_nspec(nspec)
 
         if(allocated(id_ns)) deallocate(id_ns)
         if(allocated(id_ts)) deallocate(id_ts)
         if(allocated(slbl)) deallocate(slbl)
         if(allocated(itype)) deallocate(itype)
         if(allocated(Zr8)) deallocate(Zr8)
         if(allocated(Ar8)) deallocate(Ar8)
         if(allocated(Izc)) deallocate(Izc)
         if(allocated(zvaln)) deallocate(zvaln)
         if(allocated(zvalt)) deallocate(zvalt)
         if(allocated(zvalv)) deallocate(zvalv)
         allocate(id_ns(nspec))
         allocate(id_ts(nspec))
         allocate(slbl(nspec))
         allocate(itype(nspec))
         allocate(Zr8(nspec))
         allocate(Ar8(nspec))
         allocate(Izc(nspec))
         allocate(zvaln(1:lrho,1:nspec))
         allocate(zvalt(1:lrho,1:nspec))
         allocate(zvalv(1:lrho))
 
         iorder=1
 
         call trx_spec_lbl(nspec,n_species,slbl,itype,Zr8,Ar8,IZc)
 
         call trxpl_species(nspec,iorder,'T',id_ts)
 
         call trxpl_species(nspec,iorder,'N',id_ns)
 
c Interpolate densities to lrho grid
 
         call eq_rgetff(lrho,rho,nspec,id_ns,0,lrho,zvaln,ierr)
 
         if(ierr.ne.0) then
            write(6,*) ' ?trxpl: error interpolating density profiles'
         endif
 
c Interpolate temperatures to lrho grid
 
         call eq_rgetff(lrho,rho,nspec,id_ts,0,lrho,zvalt,ierr)
 
         if(ierr.ne.0) then
            write(6,*) ' ?trxpl: error interpolating temp profiles'
         endif
 
c  Acquire the id for loop voltage profile
 
         call trx_prof("V",zunit_volt,iorder,idvolt,ierr)
 
         if(ierr.ne.0) then
            write(6,*) ' ?trxpl:  error getting voltage profile id'
         endif
 
c Interpolate voltage to lrho grid
 
         call eq_rgetf(lrho,rho,idvolt,0,zvalv,ierr)
 
c Write profile (density and temperature) and voltage data to
c a file.
 
         open(2,file='test.out',status='unknown')
 
         write(2,*) lrho
         write(2,*) nspec
         write(2,*)
         write(2,'(5(1X,E16.9))') (rho(ik),ik=1,lrho)
         do ik=1,nspec
            write(2,*)
            write(2,'(f19.12)')Zr8(ik)
            write(2,'(f19.12)')Ar8(ik)
            write(2,*)
            write(2,'(5(1X,E16.9))')(zvaln(il,ik),il=1,lrho)
            write(2,*)
            write(2,'(5(1X,E16.9))')(zvalt(il,ik),il=1,lrho)
         enddo
 
         write(2,*)
         write(2,'(5(1X,E16.9))')(zvalv(ik),ik=1,lrho)
 
         close(2)
c
c
      else if(lchar('F')) then
c
c  TREQ file (for Alan Glasser)
c
         call unixfile('treq filename',fpath)
         call eq_gfnum('psi',id_psi)
         call eq_gfnum('pmhd',id_pmhd)
         call eq_gfnum('q',id_q)
         call eq_gfnum('g',id_g)
c
         open(unit=99,file=fpath,status='unknown',
     >      iostat=ierr)
c
         if(ierr.ne.0) then
            write(lnout(0),*) ' ?trxpl:  open failure:  ',fpath
            call uermsg(' %trxpl:  error opening file.',' ',0)
         else
            call trxpl_wrtreq(99,id_psi,id_pmhd,id_q,id_g,ierr)
            close(unit=99)
            if(ierr.ne.0) call uermsg(
     >         ' %trxpl:  error writing file.',fpath,0)
         endif
c
      else if(lchar('H')) then
c
c  Jon Menard style psipqgRZ file
c
         ixtra=0
         if(lxout(0)) then
            write(lnout(0),*)
     >         ' By default, the radial grid of this file is the'
            write(lnout(0),*)
     >         ' the original TRANSP grid (ixtra=0).'
            write(lnout(0),*)
     >         ' to insert extra points (ixtra points per radial zone),'
            write(lnout(0),*)
     >         ' set ixtra to a value between 1 and 10.'
            write(lnout(0),*)
         endif
         call ureadi('trxpl:  extra points per zone (ixtra):$',ixtra)
         ixtra=max(0,min(10,ixtra))
         call unixfile('psipqgRZ filename',hpath)
         call eq_gfnum('pmhd',id_pmhd)
         call eq_gfnum('q',id_q)
 
         call eq_psipqgrz(hpath,ixtra,id_pmhd,id_q,ierr)
 
         write(lnout(0),*)
     >      'eq_psipqgrz completion code (0=normal):',ierr
c
c------------------------
      else if(lchar('X')) then
c
c  extract plasma state(s) (also write G-EQDSK file as needed by state)
c  99 is a fortran LUN
c
        ilun = 99   ! LUN for GEQ file (set to 0 to suppress)
        call eq_ganum('__RHO',id_rho)
        call eq_ngrid(id_rho,inrho)
        inx_state=max(20,(inrho-1))
        do 
          if(lxout(0)) then
            write(lnout(0),*) inrho-1,' zones in original TRANSP run.'
            write(lnout(0),*) inx_state,' zones to be written in state.'
            write(lnout(0),*) ' ..."light" state output flag: ',
     >           (ilun.eq.0)
            call trxplib_getnum_mdescr(inaux)
            if(inaux.eq.0) then
               write(lnout(0),*) ' machine description list: EMPTY'
            else
               write(lnout(0),*) ' machine description list:'
               do iaux=1,inaux
                  call trxplib_getname_mdescr(iaux,mdescr)
                  write(lnout(0),*) '    '//trim(mdescr)
               enddo
            endif
            write(lnout(0),2000)
 2000       format(/
     >           ' "L" -- "light" state output option;'/
     >           ' "H" -- "heavy" state output option;'/
     >      '        (heavy state includes Psi(R,Z) & MHD equilibrium)'/
     >           ' "M" -- add/remove machine description files'/
     >           ' "N" -- change number of zones in output state file;'/
     >           ' "P" -- print recent events & slowing down times;'/
     >           ' "F" -- write events & slowing down times to file;'/
     >           ' "T" -- write time series of plasma states;'/
     >           '        (no time averaging; trxpl input is reset!);'/
     >        ' "S" -- write file containing all known sawtooth times.'/
     >        ' "O" -- write file containing all profile output times.'/
     >           ' "W" -- write single state file (+GENRAY option).'/
     >           ' "Q" -- quit without writing.'/)
          endif

          call uread('trxpl state file I/O option:')

          if(lchar('Q')) then
             go to 20

          else if(lchar('L')) then
             ilun = 0

          else if(lchar('M')) then
             if(lxout(0)) then
                write(lnout(0),*) ' enter "0" to clear list;'
                write(lnout(0),*) ' enter "Q" to exit w/o change;'
             endif
             call ureadLw('machine description filename:',mdescr)
             if(mdescr.eq.'q') cycle
             if(mdescr.eq.'Q') cycle
             if(mdescr.eq.'0') then
                call trxplib_clear_mdescr
             else
                call trxplib_add_mdescr(mdescr,ierloc)
                if(ierloc.ne.0) then
                   write(lnout(0),*) ' %trxpl_master: could not add: '//
     >                  trim(mdescr)
                endif
             endif

          else if(lchar('H')) then
             ilun = 99

          else if(lchar('N')) then
             call ureadi(
     >            'Enter number of radial zones in state profiles',
     >            inx_state)

          else if(lchar('P')) then
             call tausl(' ')

          else if(lchar('F')) then
             spath=' '
             call unixfile('event & slowing down times report',spath)
             call tausl(spath)

          else if(lchar('S')) then
             spath=' '
             call unixfile('file of sawtooth times',spath)
             call trx_wr_stimes(spath,ierr)
             if(ierr.ne.0) then
                call uermsi(' ?trx_wr_stimes returned error code',
     >               ierr,0)
             endif

          else if(lchar('O')) then
             spath=' '
             call unixfile('file of profile output times',spath)
             call trx_wr_protimes(spath,ierr)
             if(ierr.ne.0) then
                call uermsi(' ?trx_wr_protimes returned error code',
     >               ierr,0)
             endif

          else if(lchar('T')) then
             if(lxout(0)) then
                write(lnout(0),'(a,1pe12.5)') ' current time t0: ',
     >               ztime0
                write(lnout(0),*) ' time series of states to be written'
                write(lnout(0),*) ' from t0-delta_t to t0 at TRANSP run'
                write(lnout(0),*) ' output times; delta_t=0 to skip...'
             endif

             zdelt_lead = 0.0d0
             call ureadr8('trxpl_master: enter lead time delta_t:',
     >            zdelt_lead)

             if(zdelt_lead.le.0.0d0) cycle

             if(lxout(0)) then
                write(lnout(0),*) 
     >               ' specify directory for output files'
                write(lnout(0),*) 
     >               ' or "Q" for current working directory.'
                write(lnout(0),*)
     >               ' output filenames will encode time in form:'
                if(ilun.eq.0) then
                   write(lnout(0),*) 
     >                  '   <tok>_<runid>_nnxnnnn_1d.*'
                else
                   write(lnout(0),*) 
     >                  '   <tok>_<runid>_nnxnnnn.*'
                endif
                write(lnout(0),*) 
     >               ' all listed in <tok>_<runid>_states.list...'
             endif

             spath=' '
             call unixpath(spath,rpath,ilenr)

             iopen=0
             do i=1,inpr
                if(ztimes_p(i).gt.(ztime0-zdelt_lead)) then
                   intbegin=max(1,(i-1))
                   exit
                endif
             enddo

             char1=' '
             ichar1=0

             do i=intbegin,intime0
                write(6,*) ' '
                write(6,*) ' ====================== '
                write(6,'(1x,a,1x,i4,1x,f12.4)') 'processing time',
     >               i,ztimes_p(i)

                zctime=' '
                write(zctime,'(f12.4)') ztimes_p(i)

                ztime0 = ztimes_p(i)
                ztavg  = 0.0

                call loc_trx_get  ! restart trxplib data, @ new time...

                call trx_init_state(ier)  ! re-init state
                if(ier.ne.0) then
                   write(lnout(0),*) ' ?? trx_init_state: error. '
                   exit
                endif

                zpath = spath  ! save preceding file path

                if(rpath.eq.' ') then
                   spath='.'
                else 
                   spath=rpath
                endif

                ilenr = len(trim(spath))
                if(spath(ilenr:ilenr).ne.'/') then
                   ilenr=ilenr+1
                   spath(ilenr:ilenr) = '/'
                endif
                ilenp=ilenr+1   ! 1st char of filename after directory path

                spath = trim(spath)//trim(tokdev)//'_'//trim(runid)
                ilens = len(trim(spath))  ! save this root len <tok>_<runid>
                ilenr = ilens + 1
                spath(ilenr:ilenr)='_'
                
                do j=1,len(zctime)
                   if(zctime(j:j).ne.' ') then
                      ilenr = ilenr + 1
                      if(zctime(j:j).eq.'-') then
                         spath(ilenr:ilenr)='m'
                      else if(zctime(j:j).eq.'.') then
                         spath(ilenr:ilenr)='x'
                      else
                         spath(ilenr:ilenr)=zctime(j:j)
                      endif
                   endif
                enddo

                if(ilun.eq.0) then
                   spath(ilenr+1:ilenr+3)='_1d'
                   ilenr=ilenr+3
                endif

                if(spath.eq.zpath) then
                   ichar1=ichar1+1
                   if(ichar1.gt.len(alphab)) then
                      write(6,*) ' ?? trxpl_master: too many states '//
     >                     'at nearly the same time.'
                      exit
                   else
                      char1 = alphab(ichar1:ichar1)
                   endif
                   ilenr=ilenr+1
                   if(ilun.eq.0) then
                      spath(ilenr-3:ilenr)=char1//'_1d'
                   else
                      spath(ilenr:ilenr)=char1
                   endif
                else
                   ichar1=0
                   char1=' '
                endif

                if(i.eq.intbegin) then
                   iws=2  ! write machine description, 1st call only
                else
                   iws=1  ! don't write machine description, nth call
                endif

                call trx_gen_state(ilun,
     >               geqdsk_lbl,tokdev,runid,inx_state,spath,
     >               iws,1,ier)

                write(lnout(0),*) ' trx_gen_state completed, status = ',
     >               ier,' (0 is normal).'
                if(ier.ne.0) exit

                if(i.eq.intbegin) then
                   call frename(spath(1:ilenr)//'.mdescr',
     >                  spath(1:ilens)//'.mdescr',istat)
                   call frename(spath(1:ilenr)//'.sconfig',
     >                  spath(1:ilens)//'.sconfig',istat)

                   ! start list file
                   open(unit=98,file=spath(1:ilens)//'.list',
     >                  status='unknown',iostat=ios)
                   if(ios.ne.0) then
                      write(6,*) 
     >                     ' ?? trxpl_master: list file open failure.'
                      exit
                   else
                      iopen=1
                   endif

                   j=index(geqdsk_lbl,'t=') - 1
                   j=max(1,j)

                   write(98,'(1x,a,i4)') geqdsk_lbl(1:j)//'  Nstates: ',
     >                  intime0-intbegin+1

                endif

                write(98,'(2x,1pe13.6,2x,a)') ztimes_p(i),
     >               spath(ilenp:ilenr)//'.cdf'

             enddo

             if(iopen.eq.1) close(unit=98)

             go to 10  ! get new runid & time

          else if(lchar('W')) then

             if(lxout(0)) write(lnout(0),2001)
 2001        format(
     >        ' --> enter %ECH or <file_path>/%ECH for ECH data '/
     >        '     package (assist TORAY/GENRAY comparisons).'//
     >        ' Output files:'/
     >        '   <file_path>/<file_root>.geq = G-EQDSK'/
     >        '   <file_path>/<file_root>.cdf = Plasma State'/
     >        '   <file_path>/<file_root>.mdescr = Machine Description'/
     >        '   <file_path>/<file_root>.sconfig = Shot Configuration'/
     >            )
             spath=' '
             call unixfile(
     >            'Plasma state output <file_path>/<file_root>',spath)

             jlun = ilun

             ilenf=len(trim(spath))
             ztest=spath(max(1,ilenf-3):ilenf)
             call uupper(ztest)
             if(ztest.eq.'%ECH') then
                write(lnout(0),*) ' ** ECH package: cur_state.cdf etc.'
                spath(ilenf-3:ilenf)=ztest
                jlun=99 ! force "heavy" state
             endif

             call trx_init_state(ier)
             write(lnout(0),*) ' trx_init_state status = ',ier

             iws=2
             call trx_gen_state(jlun,
     >            geqdsk_lbl,tokdev,runid,inx_state,spath,
     >            iws,1,ier)

             write(lnout(0),*) ' trx_gen_state completed, status = ',
     >            ier,' (0 is normal).'

             go to 20  ! return to main loop
          else
             call uermsg('option code not understood.',' ',0)

          endif
        enddo
c
c------------------------
c
      else
         call uermsg('?invalid option.',' ',0)
      endif
      go to 20
c
c-----------------------------------------------------------------------------
c
      contains

      !-----------------------------------
         subroutine wr_geq

           ! contained routine to write G-EQDSK file

           gpath=' '  ! if blank on exit, file was not written successfully.

           nh_geqdsk=nR
           nv_geqdsk=nZ
           nb_geqdsk=201
c
           write(lnout(0),*) ' GEQDSK label string:  ',geqdsk_lbl
           if(lxout(0)) write(lnout(0),*)
     >          ' %enter "0" to abort GEQDSK write.'
c
           call ureadi(' trxpl:  #horizontal pts for GEQDSK file:',
     >          nh_geqdsk)
           if(nh_geqdsk.eq.0) then
              return
           else
              nh_geqdsk=max(32,min(500,nh_geqdsk))
           endif
c
           call ureadi(' trxpl:  #vertical pts for GEQDSK file:',
     >          nv_geqdsk)
           if(nv_geqdsk.eq.0) then
              return
           else
              nv_geqdsk=max(32,min(500,nv_geqdsk))
           endif
c
           call ureadi(' trxpl:  #bdy contour pts for GEQDSK file:',
     >          nb_geqdsk)
           if(nb_geqdsk.eq.0) then
              return
           else
              nb_geqdsk=max(32,min(500,nb_geqdsk))
           endif
c
c------------------------
c
           write(lnout(0),*) ' GEQDSK label string:  ',geqdsk_lbl
           if(lxout(0)) write(lnout(0),*) 
     >          ' enter "Q" to quit w/o write.'
           call unixfile('GEQDSK filename',gpath)
           if(gpath.eq.'q ') then
              gpath=' '
              return
           endif
           if(gpath.eq.'Q ') then
              gpath=' '
              return
           endif
c
           open(unit=99,file=gpath,status='unknown',
     >          iostat=ierr)
c
           if(ierr.eq.0) then
              call eq_gfnum('pmhd',id_pmhd)
              call eq_gfnum('q',id_q)
              call eq_geqdsk(99,geqdsk_lbl,Rmin,Rmax,Zmin,Zmax,zcur,
     >             id_pmhd,id_q,nh_geqdsk,nv_geqdsk,nb_geqdsk,ierr)
              if(ierr.ne.0) then
                 gpath=' '
                 close(unit=99,status='DELETE')
              else
                 close(unit=99)
              endif
           else
              write(lnout(0),*)
     >             ' %trxpl:  GEQDSK file open failure:  ',ierr
              gpath=' '
           endif
           if(ierr.ne.0) then
              call uermsg(' %trxpl:  error writing GEQDSK file.',' ',0)
              gpath=' '
           endif

           return
         end subroutine wr_geq

      !-----------------------------------
      !-----------------------------------

         subroutine loc_trx_get
c
c  load xplasma @ time ztime0 w/avg +/- ztavg, for current run
c
           logical :: ltrx_freebdy ! test for free bdy data
c
           integer :: ifind
           real*8 :: psi0
c
c-------------
c
           nR=nR_orig
           nZ=nZ_orig
c
           Rmin = Rmin_orig
           Rmax = Rmax_orig
           Zmin = Zmin_orig
           Zmax = Zmax_orig
c
           call trx_time(ztime0,ztavg,iwarn,ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl:  error in trx_time:  ',tpath(1:ilt)
              return
           endif
c
           call trx_init_xplasma(ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl:  error in trx_init_xplasma:  ',
     >             tpath(1:ilt)
              return
           endif
c
c  get the internal equilibrium data
c  this sets up a poloidal angle grid "theta" (cf ntheta)
c  this sets up in "xplasma" the profiles:
c        PMHD - Pascals
c         g  - tesla*m
c         q  - no units
c       psi  - poloidal flux, Webers
c       phi  - toroidal flux, Webers
c       R(rho,theta), Z(rho,theta)
c
c  dmc Sept 20, 2000 -- enable theta reverse (for debugging purposes)
c
           if(ntheta.lt.0) then
              call trx_set_threverse(1)
              ntheta=-ntheta
           else
              call trx_set_threverse(0)
           endif
c
           call trx_mhd(ntheta,ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl:  error in trx_mhd:  ',tpath(1:ilt)
              return
           endif
c
c  get the limiters (from the namelist); set up an (R,Z) rectangular grid
c
           if(ltrx_freebdy(0)) then
              call trx_wall_freebdy(99,ierr)
           else
              call trx_wall_RZ(99,Rmin,Rmax,nR,Zmin,Zmax,nZ,ierr)
           endif
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl:  error in trx_wall:  ',tpath(1:ilt)
              return
           endif
c
c  get B field components on flux grid;
c  extrapolate B field components onto the (R,Z) grid
c
c  after this call we have Bmod(rho,theta)
c                          BR(rho,theta) or BR(R,Z)
c                          BZ(rho,theta) or BZ(R,Z)
c                                           Bphi(R,Z)
c
           irzflag=1
           call trx_bxtr(ibccw,ipccw,irzflag,ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl: trx_bxtr error status: ',ierr
           endif
c
c  initialize scalar data array & labels
c  trxpl - specific call ... prepare some Ufile labeling info
c
           call trxpl_sc_init(ztime0,ztavg,
     >          tokdev,runid,zdate,scvals,sclabs,numsc,maxsc)
c
           zcur=scvals(numsc)   ! plasma current, amps
c
c  initialize GEQDSK label
c
           zttmp=' '
           call c9date(zttmp)
c
c
c  NOTE: for TRANSP run w/o free boundary data: important that this 
c        label start with "TRXPL"; "TRXfb" used to identify TRANSP runs
c        with free boundary data
c
           call trx_psi0(ifind,Psi0)
           if(ifind.eq.0) then
              geqdsk_lbl='TRXPL '//zttmp
           else
              ! trxplib has Psi0 data only for "fb" free boundary cases
              geqdsk_lbl='TRXfb '//zttmp
           endif
c
           ilt=len_trim(geqdsk_lbl)+2
           geqdsk_lbl(ilt:)=tokdev
c
           ilt=len_trim(geqdsk_lbl)+2
           geqdsk_lbl(ilt:)=sclabs(2,1)
c
           ilt=len_trim(geqdsk_lbl)+2
           geqdsk_lbl(ilt:)=sclabs(3,1)
c
           ilt=len_trim(geqdsk_lbl)+2
           geqdsk_lbl(ilt:)='t='
c
           ilt=len_trim(geqdsk_lbl)
           if(ztavg.gt.0) geqdsk_lbl(ilt:ilt)='~'
           ilz=min(10,(len(geqdsk_lbl)-ilt))
c
           write(zttmp,'(f10.5)') ztime0
           geqdsk_lbl(ilt+1:ilt+ilz)=zttmp(1:ilz)
c
c  get profile and scalar functions / calculator results as
c  requested by user... first fetch from xplasma the (R,Z) grid limits.
c
           call eq_glimrz(1.0_R8,rmin1,rmax1,zmin1,zmax1,ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?trxpl:  eq_glimrz failure.'
              return
           endif
           if(rmin.gt.0.95*rmin1) then
              write(6,*)
     >      ' %trxpl: Rmin reset to safely enclose inner bdy of plasma.'
              write(6,*) '  old Rmin: ',rmin,' new Rmin: ',0.95*rmin1
              rmin=0.95*rmin1
           endif
           if(rmax.lt.1.05*rmax1) then
              write(6,*)
     >      ' %trxpl: Rmax reset to safely enclose outer bdy of plasma.'
              write(6,*) '  old Rmax: ',rmax,' new Rmax: ',1.05*rmax1
              rmax=1.05*rmax1
           endif
           zmid1=(zmin1+zmax1)/2
           zhgt1=(zmax1-zmin1)/2
           if(zmin.gt.zmid1-1.05*zhgt1) then
              write(6,*)
     >      ' %trxpl: Zmin reset to safely enclose lower bdy of plasma.'
              write(6,*) 
     >             '  old Zmin: ',zmin,' new Zmin: ',zmid1-1.05*zhgt1
              zmin=zmid1-1.05*zhgt1
           endif
           if(zmax.lt.zmid1+1.05*zhgt1) then
              write(6,*)
     >      ' %trxpl: Zmax reset to safely enclose upper bdy of plasma.'
              write(6,*) 
     >             '  old Zmax: ',zmax,' new Zmax: ',zmid1+1.05*zhgt1
              zmax=zmid1+1.05*zhgt1
           endif
c
           zlamda=0.01_r8*(rmax1-rmin1)
c
           igs2=0
           numpro=0
           prolabs=' '
           id_pros=0
           id_xaxis=0
           ixtnd=0
           iordr=1

           return
        end subroutine loc_trx_get

      !-----------------------------------
      !-----------------------------------

        subroutine tausl(zfile)

           ! write "slowing down & events" report
           
           character*(*), intent(in) :: zfile  ! file to write (blank for tty)

           !------------------------------------------
           integer :: iolun,ios,if,iordr,itmp,iwarn,irho,itype,id
           real*8, dimension(:), allocatable :: zrho,zvol,zrhozc
           real*8, dimension(:), allocatable :: zden,ztau
           real, dimension(:), allocatable :: zscdata  ! ** single precision **
           real, dimension(:), allocatable :: zsclist
           real*8 :: ztausl,ztsum,zdsum,zdv,ztmin
           character*120 :: zfilu,zline
           character*20 zuns
           character*32 zlbl
           character*50 zrlabel
           logical :: iexist
           integer :: insaw,ingot,ii
           !------------------------------------------
           integer, parameter :: nf_species = 9
           logical :: ihave(nf_species)
           character*32 :: f_species_lbl(nf_species) = (/ 
     >          'H beam ions   ','D beam ions   ','T beam ions   ',
     >          'He3 beam ions ','He4 beam ions ',
     >          'fusion alphas ','fusion He3    ',
     >          'fusion T      ','fusion protons' /)
           character*10 :: f_dens(nf_species) = (/
     >          'BDENS_H', 'BDENS_D', 'BDENS_T', 'BDENS_3', 'BDENS_4',
     >          'FDENS_4', 'FDENS_3', 'FDENS_T', 'FDENS_P' /)
           character*10 :: f_spec1(nf_species) = (/
     >          'TSL1A_H','TSL1A_D','TSL1A_T','TSL1A_3','TSL1A_4',
     >          'TFSL_4 ','TFSL_3 ','TFSL_T ','TFSL_P ' /)
           character*10 :: f_spec2(nf_species) = (/
     >          'TSL1B_H','TSL1B_D','TSL1B_T','TSL1B_3','TSL1B_4',
     >          '       ','       ','       ','       ' /)
           integer :: itype1(nf_species) = (/ 1,1,1,1,1, 3,3,3,3 /)
           integer :: itype2(nf_species) = (/ 2,2,2,2,2, 0,0,0,0 /)

           character*32 :: ztyp_lbl(3) = (/
     >          'full energy co-injected     ',
     >          'full energy counter-injected',
     >          'nominal birth energy        ' /)
           !------------------------------------------

           if(zfile.eq.' ') then
              itmp=1
              call tmpfile_d('trxpl_tausl',zfilu,idum)
           else
              itmp=0
              zfilu=zfile
           endif

           do
              allocate(zrho(inrho),zvol(inrho))
              call eq_grid(id_rho,zrho,inrho,idum,ierr)
              if(ierr.ne.0) exit

              call eq_volume(inrho,zrho,0,zvol,ierr)
              if(ierr.ne.0) exit
           
              allocate(zrhozc(inrho-1))
              zrhozc = 0.5d0*(zrho(1:inrho-1)+zrho(2:inrho))

              allocate(zden(inrho-1),ztau(inrho-1))

                                ! use I/O unit 99 for file
                                ! like rest of trxpl_master.for
              iolun=99
              open(unit=iolun,file=trim(zfilu),status='unknown',
     >             iostat=ios)
              if(ios.ne.0) then
                 call uermsg('apparent file open failure',zfilu,0)
                 exit
              endif
                                ! write report...
              call trx_label(zrlabel)
              write(iolun,3001) trim(zrlabel),ztime0,ztavg
 3001         format("TRANSP ",a,"; time0=",
     >             1pe13.6,"s; delta_t=",1pe13.6,"s")
              write(iolun,'(1x,A)') 
     >             'Density weighted averaged'//
     >             ' approximate slowing down times:'

              write(6,*) ' trxpl_tausl: probing for fast ion species...'
              ztausl = 0.0d0
                                ! loop over possible species...
              do if=1,nf_species
                 call rpexist_profile(f_dens(if),iexist)
                 if(.not.iexist) cycle

                 call trx_prof(f_dens(if),zuns,1,id,iwarn)
                 if(id.eq.0) cycle

                 call eq_rgetf(inrho-1,zrhozc,id,0,zden,idum)

                 call trx_prof(f_spec1(if),zuns,1,id,iwarn)
                 if(id.eq.0) cycle

                 call eq_rgetf(inrho-1,zrhozc,id,0,ztau,idum)

                 zdsum = 0.0d0
                 ztsum = 0.0d0
                 do irho=1,inrho-1
                    zdv = zvol(irho+1)-zvol(irho)
                    zdsum = zdsum + zden(irho)*zdv
                    ztsum = ztsum + ztau(irho)*zden(irho)*zdv
                 enddo
                 if(zdsum.le.0.0d0) then
                    ztsum = 0.0d0
                 else
                    ztsum = ztsum/zdsum
                 endif

                 itype=itype1(if)
                 write(iolun,'(1x,1pe12.5,a)') ztsum,
     >                ' seconds: '//trim(f_species_lbl(if))//' at '//
     >                trim(ztyp_lbl(itype))

                 ztausl = max(ztausl,ztsum)

                 if(f_spec2(if).eq.' ') cycle

                 call trx_prof(f_spec2(if),zuns,1,id,iwarn)
                 if(id.eq.0) cycle

                 call eq_rgetf(inrho-1,zrhozc,id,0,ztau,idum)

                 zdsum = 0.0d0
                 ztsum = 0.0d0
                 do irho=1,inrho-1
                    zdv = zvol(irho+1)-zvol(irho)
                    zdsum = zdsum + zden(irho)*zdv
                    ztsum = ztsum + ztau(irho)*zden(irho)*zdv
                 enddo
                 if(zdsum.le.0.0d0) then
                    ztsum = 0.0d0
                 else
                    ztsum = ztsum/zdsum
                 endif

                 itype=itype2(if)
                 write(iolun,'(1x,1pe12.5,a)') ztsum,
     >                ' seconds: '//trim(f_species_lbl(if))//' at '//
     >                trim(ztyp_lbl(itype))

                 ztausl = max(ztausl,ztsum)

              enddo
              write(iolun,'(1x,a,1pe12.5,a)') 'max slowing down time:',
     >             ztausl,' seconds.'

                                ! look for sawteeth
              insaw = 0

              call rpexist_scalar('TLASTSAW',iexist)
              if(iexist) then
                 call trx_ntimes(insc,inpr,idum)
                 allocate(zscdata(insc),zsclist(insc))
                 call rpscalar('TLASTSAW',zscdata,insc,ingot,iwarn)

                 ztmin=ztime0-2*ztausl
                 do ii=1,ingot
                    if((ztmin.le.zscdata(ii)).AND.
     >                   (zscdata(ii).le.ztimes_p(intime0)) ) then
                       if(insaw.gt.0) then
                          if(zscdata(ii).ne.zsclist(insaw)) then
                             insaw=insaw + 1
                             zsclist(insaw)=zscdata(ii)
                          endif
                       else
                          insaw=1
                          zsclist(1)=zscdata(ii)
                       endif
                    endif
                 enddo
              endif

              write(iolun,'(1x,a,i4)') 'Number of recent sawteeth: ',
     >             insaw
              do ii=1,insaw
                 write(iolun,'(4x,1pe13.6)') zsclist(ii)
              enddo

              if(iolun.eq.99) then
                 if(itmp.eq.0) then
                    close(unit=iolun)
                 else
                    rewind(iolun)
                    write(6,*) ' '
                    write(6,*) ' trxpl_tausl results:'
                    write(6,*) ' '
                    do
                       read(iolun,'(A)',iostat=ios) zline
                       if(ios.ne.0) exit
                       write(6,*) trim(zline)
                    enddo
                    write(6,*) ' '
                    close(unit=iolun,status='delete')
                 endif
              endif

              exit
           enddo
           if(allocated(zrho)) deallocate(zrho)
           if(allocated(zrhozc)) deallocate(zrhozc)
           if(allocated(zvol)) deallocate(zvol)
           if(allocated(zden)) deallocate(zden)
           if(allocated(ztau)) deallocate(ztau)
           if(allocated(zscdata)) deallocate(zscdata)
           if(allocated(zsclist)) deallocate(zsclist)

           return
        end subroutine tausl

      end

c-----------------------------------------------------------------------
      subroutine trxpl_wrtreq(lun,id_psi,id_pmhd,id_qmhd,id_gmhd,ierr)
c
c  write "Alan Glasser" style TREQ (transp equilibrium) ascii file.
c  these files also used by "test_xplasma" and see xplasma/rdtreq.f90.
c  (dmc June 2002)
c
c--------------------------------------------------------
      implicit NONE
      integer, intent(in) :: lun        ! Fortran LUN of file open for write
      integer, intent(in) :: id_psi,id_pmhd,id_qmhd,id_gmhd
                                        ! xplasma id's of eq. profiles.
      integer, intent(out) :: ierr      ! output status code (0=OK)
c
c--------------------------------------------------------
c
      character*80 str
      integer ilen
c
      integer :: id_rho=0,id_theta=0,nrho,ntheta
      integer i,j,igot
c
      real*8 ztime,zdelta_t,zscval
c
      real*8, dimension(:), allocatable :: rhotmp,thtmp,ftmp,rhovec,
     >   phvec
      integer, dimension(:), allocatable :: nregion
      real*8, dimension(:,:), allocatable :: rr,zz
c--------------------------------------------------------
 1001 format(1x,a)
 1002 format(1x,1pd13.6)
 1003 format(1x,i6)
 1004 format(5(1x,1pd13.6))
c
c  label
c
      call trx_label(str)
      ilen=len_trim(str)
 
      write(lun,1001) 'TRANSP runid/path:'
      write(lun,1001) str(1:ilen)
c
c  times
c
      call trx_gtime(ztime,zdelta_t,ierr)
      if(ierr.ne.0) return
 
      write(lun,1001) 'time:  data time, seconds:'
      write(lun,1002) ztime
      write(lun,1001) 'tavg:  +/- averaging time, seconds:'
      write(lun,1002) zdelta_t
c
c  plasma current
c
      call trx_scal('PCUR',str,zscval,ierr)
      if(ierr.ne.0) return
 
      write(lun,1001) 'pcur:  plasma current, Amps:'
      write(lun,1002) zscval
c
c  enclosed toroidal flux
c
      call trx_scal('TFLUX',str,zscval,ierr)
      if(ierr.ne.0) return
 
      write(lun,1001) 'tflux:  enclosed toroidal flux, Webers:'
      write(lun,1002) zscval
c
c  grids
c
      call eq_ganum('__RHO',id_rho)
      call eq_ganum('__CHI',id_theta)
 
      call eq_ngrid(id_rho,nrho)
      call eq_ngrid(id_theta,ntheta)
 
      write(lun,1001) 'ntheta:  theta grid size:'
      write(lun,1003) ntheta
 
      write(lun,1001) 'nsurf:  no. of flux surfaces:'
      write(lun,1003) nrho
c
      allocate(rhotmp(nrho),thtmp(ntheta))
 
      call eq_grid(id_rho,rhotmp,nrho,igot,ierr)
      if(ierr.ne.0) go to 999
 
      call eq_grid(id_theta,thtmp,ntheta,igot,ierr)
      if(ierr.ne.0) go to 999
 
c  put theta in positive range [0,2pi]
      zscval=thtmp(1)
      thtmp(1)=0.0
      do j=2,ntheta
         thtmp(j)=thtmp(j)-zscval
      enddo
 
c  write the grid values:
      write(lun,1001) 'theta:  theta grid, radians:'
      write(lun,1004) (thtmp(j),j=1,ntheta)
 
      write(lun,1001)
     >   'rho:  flux surface label, normalized sqrt(tor. flux):'
      write(lun,1004) (rhotmp(j),j=1,nrho)
c
c  write profiles
c
      allocate(ftmp(nrho))
c
c  psi
c
      call eq_rgetf(nrho,rhotmp,id_psi,0,ftmp,ierr)
      if(ierr.ne.0) go to 999
c
      write(lun,1001) 'psi:  poloidal flux, Webers/radian:'
      write(lun,1004) (ftmp(j),j=1,nrho)
c
c  pmhd
c
      call eq_rgetf(nrho,rhotmp,id_pmhd,0,ftmp,ierr)
      if(ierr.ne.0) go to 999
c
      write(lun,1001) 'pmhd:  pressure, Pascals:'
      write(lun,1004) (ftmp(j),j=1,nrho)
c
c  qmhd
c
      call eq_rgetf(nrho,rhotmp,id_qmhd,0,ftmp,ierr)
      if(ierr.ne.0) go to 999
c
      write(lun,1001) 'qmhd:  q profile:'
      write(lun,1004) (ftmp(j),j=1,nrho)
c
c  gmhd
c
      call eq_rgetf(nrho,rhotmp,id_gmhd,0,ftmp,ierr)
      if(ierr.ne.0) go to 999
c
      write(lun,1001) 'gmhd:  g profile (R*Bt), m*Tesla:'
      write(lun,1004) (ftmp(j),j=1,nrho)
c
c  (R,Z)
c
      allocate(nregion(ntheta))
      allocate(rhovec(ntheta),phvec(ntheta))
      allocate(rr(ntheta,nrho),zz(ntheta,nrho))
c
      phvec=0
c
      do j=1,nrho
         rhovec=rhotmp(j)
         call eq_rzget(ntheta,rhovec,thtmp,phvec,
     >      rr(1:ntheta,j),zz(1:ntheta,j),nregion,ierr)
         if(ierr.ne.0) go to 999
      enddo
c
      write(lun,1001) 'R:  R, m:  ((R(i,j),i=1,ntheta),j=1,nsurf)'
      write(lun,1004) ((rr(i,j),i=1,ntheta),j=1,nrho)
 
      write(lun,1001) 'Z:  Z, m:  ((Z(i,j),i=1,ntheta),j=1,nsurf)'
      write(lun,1004) ((zz(i,j),i=1,ntheta),j=1,nrho)
c
 999  continue
c
      if(allocated(rhotmp)) deallocate(rhotmp)
      if(allocated(thtmp)) deallocate(thtmp)
      if(allocated(ftmp)) deallocate(ftmp)
 
      if(allocated(nregion)) deallocate(nregion)
      if(allocated(rhovec)) deallocate(rhovec,phvec)
      if(allocated(rr)) deallocate(rr,zz)
 
      return
      end

C******************** START FILE TDB_PRESYM.FOR ; GROUP TDB_PRESYM ***********
C------------------------------------------------------------
C  TDB_PRESYM  -- modularized vsn of old PRESYM -- no trcom dependency.
C
C  INTERFACE MODIFIED DMC JULY 1991 -- PART OF GENERAL REWRITE OF THE
C  METHODS FOR ACQUIRING/INTERPOLATING UFILES INPUT DATA PROFILES IN
C  TRANSP (TRDAT UPGRADE)
C
C  TDB_PRESYM IS NOW CALLED FROM EXECSYM WHICH IS CALLED FROM MAKSYM;
C  PRESYMMETRIZATION IS CARRIED OUT IN TRDAT -- during setup of a
C  TRANSP run.
C
C  PRESYMMETRIZE TWO-SIDED PROFILE DATA-- MASTER
C  ROUTINE
C
C  THE INTERFACE HAS BEEN GENERALIZED -- NOT JUST ELECTRON TEMPERATURE
C  OR DENSITY DATA, BUT ANY DATA MAY BE USED AS INPUT.  **HOWEVER** THE
C  DATA MUST STILL BE POSITIVE AND TEND TOWARDS ZERO AT THE EDGES *****
C
C  VERSION FOR GENERALIZED GEOMETRY-- INPUT COORDINATE IS
C  DEFINED RELATIVE TO GENERALIZED SPATIAL LOCATION
C    X = (R-R0)/A  WHERE R0 AND A ARE THE PLASMA MAJOR AND
C  MINOR RADII.
C
C  THE PLASMA INNER BDY IS AT X = -1; THE OUTER BDY AT X = +1
C
C  presymmetrized output is stored on a relative minor radius, or
C  for ECE data, relative aspect ratio (will be (1/mod(B)) aspect ratio
C  at final lookup time).
C    xa=0 --> mag. axis
C    xa=1 --> region of f(xa) > f(1) has aspect ratio (R2-R1)/(R2+R1)
C
C  THIS ROUTINE CONVERTS A 2-SIDED PROFILE COVERING
C  X = (-1,+1) PLUS SOME SLOP OVER THE EDGES, TO A ONE-SIDED
C  PROFILE CONVERING X = (0,1) PLUS some margin.
C
C  APPROACH:  "2X ONION SKIN ALGORITHM"-- F0(X) IS TURNED INTO
C   THE INVERTED MONOTONIC FCN X(F) BY THE RULE
C   X(F) = THE LENGTH OF X (POSSIBLY MULTIPLE SEGMENTS) FOR
C          WHICH F0(X) .LE. F
C
C  THE ADDITIONAL QUANITY <X>(F) = THE AVERAGE X FOR WHICH
C          F0(X) .GE. F   IS ALSO CALCULATED.
C
C  NOTE THAT X(FMAX)=0.0 AND <X>(FMAX)= LOCATION OF PEAK VALUE
C   OF UNSYMMETRIZED INPUT PROFILE.
C
C  THE ALGORITHM EXPECTS THE INPUT PROFILE F0 TO BE POSITIVE
C   AND TO TEND TOWARDS ZERO AT THE EDGES
C
C  -----------------
C
C  PASSED ARGUMENTS:
C   ILX0 - LOCATION OF X VECTOR DEFINING F0
C   INX0 - NUMBER OF PTS IN X VECTOR FOR F0
C   ILX  - TARGET X VECTOR FOR SYMMETRIZED DATA (SHOULD COVER
C          RANGE APPROX (0,1) -- SEE EXECSYM
C   INX  - NUMBER OF PTS IN TARGET
C
C  THE PROFILE TO BE SYMMETRIZED IS IN COMMON:
C    WORKBUF(LBX(1)) THRU WORKBUF(LBX(1)+INX0-1)
C  WHICH IS DEFINED AT NORMALIZE SPATIAL COORDINATES
C    WORKBUF(ILX0) THRU WORKBUF(ILX0+INX0-1)
C
C  THE SYMMETRIZED DATA IS TO BE MAPPED TO NORMALIZED SPATIAL COORDS
C    DATBUF(ILX) THRU DATBUF(ILX+INX-1)
C
C  DATA IS IN WORKBUF ARRAY IN [TRANSP] COMMON
C
C  WORKBUF WORK AREAS (WORKBUF(LBX(IJ)...)) ARE USED BY THE
C  SYMMETRIZATION ALGORITHM
C
C  OUTPUT:
C   WORKBUF(LBX(7) TO LBX(7)+INX-1) CONTAINS SYMMETRIZED PROFILE
C  INTERPOLATED TO TARGET X VECTOR
C   WORKBUF(LBX(8) TO LBX(8)+INX-1) CONTAINS PROFILE <X>*RMINOR
C  INTERPOLATED TO TARGET X VECTOR.  THIS DEFINES A "PHENOMEN-
C  OLOGICAL" SHAFRANOV SHIFT CORRESPONDING TO THE INPUT PROFILE
C  DATA
C
C--------------------------------------------------------
C
      SUBROUTINE TDB_PRESYM(d,zr1,zr2,IMAP,ILX0,INX0,ILX,INX)
C
      use trdatbuf_obj
      IMPLICIT NONE

      type (trdatbuf) :: d
      real*8 zr1,zr2            ! midplane bdy intercepts

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
C  CALCULATE X(F), <X>(F)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER inx0,ilx,inx,ilx0,inumr,IMAP
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zxmax
!============
!
      ZXMAX=max(d%DATBUF(ILX+INX-1),
     >   0.5001_R8*(d%WORKBUF(ILX0+INX0-1)-d%WORKBUF(ILX0)))
      CALL TDB_PRFINV(d,d%WORKBUF(ILX0),INX0,INUMR,ZXMAX)
C
C  INUMR IS THE LENGTH OF THESE FCNS:
C    INVERTED F IN WORKBUF(LBX(2)..)-- *MONOTONIC INCREASING SEQUENCE
C    AT X LOCATIONS IN WORKBUF(LBX(3)..)-- *MONOTONIC DECREASING SEQUENCE
C    WITH <X> IN WORKBUF(LBX(5)..)
C
C  INVERT TO OUTPUT PROFILE F(X) AND CONVERT <X> TO A SHIFT IN CM, AND
C  INTERPOLATE TO TARGET X LOCATIONS
C
C  IMAP=1 -> normal;  IMAP=2 -> ECE
C
      CALL TDB_PRFINS(d,zr1,zr2,IMAP,INUMR,d%DATBUF(ILX),INX)
C
C  RESULTS IN WORKBUF(LBX(7)..) = F; WORKBUF(LBX(8)..) = SHIFT.
C
      RETURN
      END
C******************** END FILE TDB_PRESYM.FOR ; GROUP TDB_PRESYM **************

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge(cclist,w1,ss1,ss2,ss3,icheck,ierr)

  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  ! cclist(...) control specifies the components for which data are merged.
  !   If cclist(j)=1 all data are merged for component j.
  !   If cclist(j)=0, data merger suppressed for this component.
  !   NOTE: species list data if present is checked, regardless of cclist(...).

  ! Non-floating-point data is copied from ss1
  ! with warnings if ss1 & ss2 values do not match & icheck = ps_warn
  ! with error messages and ierr set if values do not match & icheck = ps_error

  ! if an array is not allocated in (ss3):
  !    no action taken, regardless of allocation status in (ss1) or (ss2).

  ! if an array is allocated in (ss3) but in neither (ss1) nor (ss2):
  !    no action taken.

  ! if an array element is allocated in all of {(ss1),(ss2),(ss3)}:
  !    all must be conformal in shape; for grids, (ss1) & (ss2) values
  !    must match as well.
  !       for floating point in state_data or state_profile sections:
  !           ss3 <-- w1*ss1 + (1-w1)*ss2 formula ... is applied.
  !       for everything else: ss1 values copied to ss3.

  ! for quantities associated with species lists, values must match...

  ! if an array element is allocated in {(ss1),(ss3)}, not (ss2):
  !    (ss1) values are copied to (ss3); all arrays must be conformal in shape.

  ! if an array element is allocated in {(ss2),(ss3)}, not (ss1):
  !    (ss2) values are copied to (ss3); all arrays must be conformal in shape.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------
  INTEGER :: iout,isize
  INTEGER :: ilock_mdescr,ilock_sconfig,ilock_siminit,iertmp
  !-------------------

  iout = SWIM_err_out_file
  ierr = 0

  call plasma_state_merge_0(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_1(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_2(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_3(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_4(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_5(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_6(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_7(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_8(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)
  call plasma_state_merge_9(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)

  ! set hash codes of new copy of state

  ilock_mdescr = ss3%lock_machine_descr
  ilock_sconfig = ss3%lock_shot_config
  ilock_siminit = ss3%lock_sim_init

  ss3%lock_machine_descr = ps_unlocked
  ss3%lock_shot_config = ps_unlocked
  ss3%lock_sim_init = ps_unlocked

  CALL plasma_state_hash_code(ss3,ps_cc_all,iertmp)
  ss3%hash_codes = ss3%new_hash_codes

  ss3%lock_machine_descr = ilock_mdescr
  ss3%lock_shot_config = ilock_sconfig
  ss3%lock_sim_init = ilock_siminit

END SUBROUTINE plasma_state_merge

subroutine ps_update_cur(ps,pcur,zrho_brk,iout,ierr)

  !  update the plasma state profiles related to current:
  !     ps%curt(1:ps%nrho_eq) -- enclosed toroidal current w/in flux surfaces
  !     ps%jdotb(1:ps%nrho_eq) -- <J.B> (positive sign convention)

  !  the total toroidal plasma current (Amps) is input: pcur
  !  in the range [zrho_brk:1.0] an interpolation is done to obtain a match
  !  with the total current specified.

  !  *** it is assumed *** that an up-to-date equilibrium has been stored
  !  in the state.  This routine checks that <|grad(rho)|**2/R**2> is up-to-date.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated

  REAL(KIND=rspec), intent(in) :: pcur    ! the total plasma current
  REAL(KIND=rspec), intent(in) :: zrho_brk  ! point at which to start ps%curt
                                          ! interpolation to match pcur

  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:
  integer :: ii,ibrk,inrho,inlim,imod
  integer :: id3(3),ideriv3(3)
  REAL(KIND=rspec), dimension(:,:), allocatable :: zwk
  REAL(KIND=rspec) :: zdelrho,zrhobrk,zdpsidrho,zdvdrho,zrho2r2i
  REAL(KIND=rspec) :: aicur,bicur,x1,x2,x3,xxx,zdrho

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real(kind=rspec), parameter :: z2pi   = 6.2831853071795862_rspec
  real(kind=rspec), parameter :: zmu0   = 2*z2pi*1.0e-7_rspec

  !-----------------------
  !  init check
  call ps_tagchk('ps_update_cur',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  !  get xplasma object pointer
  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  id3(1) = ps%id_psipol;    ideriv3(1)=1
  id3(2) = ps%id_vol;       ideriv3(2)=1
  id3(3) = ps%id_grho2r2i;  ideriv3(3)=0

  !-------------------------------
  !  get number of pts; set bdy values
  inrho = ps%nrho_eq

  ps%curt(1) = 0.0_rspec
  ps%curt(inrho) = pcur

  !-------------------------------
  allocate(zwk(inrho,3))

  call xplasma_eval_prof(s,id3,ps%rho_eq,zwk,ierr,ideriv1s=ideriv3)
  if(ierr.ne.0) then
     deallocate(zwk)
     ps%curt=0.0_rspec
     ps%jdotb=0.0_rspec
     write(iout,*) ' ?ps_update_cur: failed to interpolate data needed for curt evaluation:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  !-------------------------------
  !  break location (constrained)
  zrhobrk = max(0.8_rspec,min(0.98_rspec,zrho_brk))

  !  offset of break from edge
  zdelrho = 1.0_rspec - zrhobrk
  inlim = 1.0_rspec/zdelrho + 0.5_rspec

  !  if inrho.le.inlim, no interpolation will be done; the edge value of curt
  !  is simply set to pcur.

  if(inrho.gt.inlim) then
     ibrk=inrho-2
  else
     ibrk=inrho-1
  endif

  zdrho = (ps%rho_eq(inrho)-ps%rho_eq(inrho-1))/100

  do ii=2,ibrk
     zdpsidrho = zwk(ii,1)
     zdvdrho = zwk(ii,2)
     zrho2r2i = zwk(ii,3)
     ps%curt(ii) = zrho2r2i*zdvdrho*zdpsidrho/(z2pi*zmu0)
     if(inrho.gt.inlim) then
        if(ps%rho_eq(ii).ge.zrhobrk-zdrho) then
           ibrk=ii
           exit
        endif
     endif
  enddo

  deallocate(zwk)

  zrhobrk = ps%rho_eq(ibrk)

  if(inrho.gt.inlim) then
     ! parabolic piece fit to reach known total toroidal current
     x1=zrhobrk-ps%rho_eq(ibrk-1)
     x2=zrhobrk-ps%rho_eq(ibrk-2)
     ! parabolic fit to get slope d(icurt)/dx at zrhobrk:
     bicur = (x2*x2*(ps%curt(ibrk-1)-ps%curt(ibrk)) - &
          x1*x1*(ps%curt(ibrk-2)-ps%curt(ibrk))) / (x1*x2*(x1-x2))
     ! parabolic fit to match point and slope at zrhobrk and reach the
     ! boundary value ps%curt(inrho):
     x3=ps%rho_eq(inrho)-zrhobrk
     aicur = (ps%curt(inrho)-ps%curt(ibrk)-bicur*x3)/(x3*x3)
     do ii=ibrk+1,inrho-1
        xxx = ps%rho_eq(ii)-zrhobrk
        ps%curt(ii)=ps%curt(ibrk) + xxx*(bicur + xxx*aicur)
     enddo
  endif

  ! copied with small changes from plasma_state/plasma_state_xload.f90:
  ! make the spline:

  CALL ps_1d_prof_store(ps%iobj,"curt","RHO_EQ", &
       "A",ps_cnum_eq,"total enclosed toroidal current",ps_spline,ps_bc_grad00, &
       ps%nrho_eq,0, &
       ps%curt,ps%id_curt, &
       imod,iout,ierr)

  call ps_update_jdotb(ps,iout,ierr)

end subroutine ps_update_cur


subroutine ps_update_jdotb(ps,iout,ierr)

  ! compute <J.B> from g(rho) and I(rho) profiles

  ! <J.B> on axis: j*g(0)/R_axis; j = d2(curt)/drho2 / d2(Area)/drho2
  ! <J.B> off axis: 2pi*[g*d(curt)/drho - curt*dg/drho]/(dVol/drho)

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated

  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: inrho,id,jj
  real*8, dimension(:), allocatable :: zg,zdgdrho,zi,zdidrho,zdvdrho,zrho

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real(kind=rspec), parameter :: z2pi   = 6.2831853071795862_rspec

  !-----------------
  !  get xplasma object pointer
  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  !  set up for calculation; allocate arrays

  inrho = ps%nrho_eq
  allocate(zrho(inrho)); zrho = ps%rho_eq

  allocate(zg(inrho),zdgdrho(inrho),zi(inrho),zdidrho(inrho),zdvdrho(inrho))

  ps%jdotb = 0.0_rspec

  do 
     call xplasma_volume(s,zrho,zdvdrho,ierr,ideriv=1)  ! dVol/drho vs. rho
     if(ierr.ne.0) exit

     id = ps%id_curt
     call xplasma_eval_prof(s,id,zrho,zi,ierr, ideriv1=0)     ! I(rho)
     if(ierr.ne.0) exit
     call xplasma_eval_prof(s,id,zrho,zdidrho,ierr, ideriv1=1)  ! dI/drho
     if(ierr.ne.0) exit

     id = ps%id_g_eq
     call xplasma_eval_prof(s,id,zrho,zg,ierr, ideriv1=0)     ! g(rho)
     if(ierr.ne.0) exit
     call xplasma_eval_prof(s,id,zrho,zdgdrho,ierr, ideriv1=1)  ! dg/drho
     if(ierr.ne.0) exit

     do jj=2,inrho
        ps%jdotb(jj) = z2pi*(zg(jj)*zdidrho(jj)-zi(jj)*zdgdrho(jj)) / &
             zdvdrho(jj)
     enddo

     !  axial extrapolation (quadratic)

     ps%jdotb(1)=(zrho(3)**2*ps%jdotb(2) - zrho(2)**2*ps%jdotb(3)) / &
          (zrho(3)**2-zrho(2)**2)

     exit
  enddo

  deallocate(zrho,zi,zdidrho,zg,zdgdrho,zdvdrho)

  !-----------------------
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_jdotb: error during <J.B> evaluation:'
     call xplasma_error(s,iout,ierr)
  endif

end subroutine ps_update_jdotb

subroutine trx_ustore(ierr_ck,ident,ixid,iordr,zunits,istat)
!
  use trx_module
  implicit NONE
!
!   add units label to profile label array
!
  integer, intent(inout) :: ierr_ck       ! error status code
  integer, intent(in) :: ident            ! xplasma id of profile
  integer, intent(in) :: ixid             ! x axis id (for 1d objects)
  integer, intent(in) :: iordr            ! interp. order (for 1d objects)
  !  ixid=iordr=0 expected for scalars
  character(*), intent(in) :: zunits      ! units label
  integer, intent(in) :: istat            ! units conversion flag
!
!   if ierr_ck=1, there was an error setting up the profile; just exit.
!   if ierr_ck=0, then ierr_ck will be set to 1 if  ident  is out of range.
!
!   ident -- xplasma index, being reused in trx_module to index into
!   arrays:  prof_units(...), mks_status(...)
!
!   zunits -- the units label
!
!   istat --   =0: MKS conversion was OK; =1: MKS conversion failure
!                                             TRANSP units used.
!-----------------------------------
  integer lunzer
!-----------------------------------
!
  if(ierr_ck.ne.0) return
!
  if((ident.le.0).or.(ident.gt.maxid)) then
     write(lunzer(0),*) ' ?trx_ustore:  item id = ',ident,' out of range.'
     ierr_ck=1
     return
  endif
!
  prof_units(ident)=zunits
  units_status(ident)=istat
  xaxis_id(ident)=ixid
  prof_iord(ident)=iordr
!
  call eqm_set_units(ident,zunits,ierr_ck)
!
  return
!
end subroutine trx_ustore

subroutine tdb_npel(d,inpel)
  use trdatbuf_obj
  implicit NONE
  !  return number of pellet events
  type (trdatbuf) :: d
  integer, intent(out) :: inpel ! number of pellets this run

  inpel = d%npelda

end subroutine tdb_npel

subroutine tdb_pelda(d,ipel,p,ierr)
  use trdatbuf_obj
  use trdatbuf_aux
  implicit NONE
  !  return data associated with a particular pellet
  type (trdatbuf) :: d
  integer, intent(in) :: ipel   ! index of desired pellet data (ipel'th pellet)
  type (pelget) :: p            ! pellet data returned here
  integer, intent(out) :: ierr  ! return .ne.0 if ipel input out of range

  !-------------------------------------
  integer :: iadr,ifield,ifields
  !-------------------------------------

  if((ipel.le.0).or.(ipel.gt.d%npelda)) then
     ierr=1
     return
  endif

  ierr=0

  iadr=d%lpelda
  ifields = d%datbuf(iadr) + 0.1

  ifield = 0

  iadr=d%lpelda + ipel - d%npelda
  do
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     iadr = iadr + d%npelda
     p%tpel = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%apel = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%apel2 = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%fpel2 = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%nmpela = d%datbuf(iadr) + 0.1

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%plrsta = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%plysta = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%plphia = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%plthea = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%pelrad = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%pelvel = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%kpellet = d%datbuf(iadr) + 0.1

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%tpele = d%datbuf(iadr)

     iadr = iadr + d%npelda
     ifield = ifield+1
     if(ifield.gt.ifields) exit
     p%freqpel = d%datbuf(iadr)

     exit
  enddo

end subroutine tdb_pelda

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_2(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"D_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%D_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: D_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"D_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%D_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: D_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"D_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%D_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: D_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"e0_av",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%e0_av)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: e0_av"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ecrf_src_name",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%ecrf_src_name)
     status = nf90_get_var(icdf,varid,ss%ecrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ecrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("ecrf_src_name",ss%ecrf_src_name)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Beam_Elongation",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_Beam_Elongation)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_Beam_Elongation"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Half_Power_Angle",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_Half_Power_Angle)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_Half_Power_Angle"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Omode_Fraction",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_Omode_Fraction)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_Omode_Fraction"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_phi_aim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_phi_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_phi_aim"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_CURV_HOR",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_PRINC_CURV_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_PRINC_CURV_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_CURV_VERT",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_PRINC_CURV_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_PRINC_CURV_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_HOR",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_PRINC_WIDTH_HOR)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_PRINC_WIDTH_HOR"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_VERT",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_PRINC_WIDTH_VERT)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_PRINC_WIDTH_VERT"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_theta_aim",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EC_theta_aim)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EC_theta_aim"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ee_mobility_factor",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ee_mobility_factor)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ee_mobility_factor"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Einj_max",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Einj_max)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Einj_max"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Einj_min",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Einj_min)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Einj_min"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eldot",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eldot)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eldot"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"elong",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%elong)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: elong"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_beami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eperp_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eperp_beami"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eperp_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eperp_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_mini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eperp_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eperp_mini"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eperp_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eperp_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eperp_rw"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_beami",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%epll_beami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: epll_beami"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%epll_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: epll_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_mini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%epll_mini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: epll_mini"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"epll_rw",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%epll_rw)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: epll_rw"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Epot",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Epot)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Epot"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqdsk_file",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eqdsk_file)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eqdsk_file"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqmom_num",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%eqmom_num)
     status = nf90_get_var(icdf,varid,ss%eqmom_num)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eqmom_num"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("eqmom_num",ss%eqmom_num)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EQ_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EQ_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%EQ_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: EQ_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eta_parallel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%eta_parallel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: eta_parallel"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"E_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%E_anom)
     status = nf90_get_var(icdf,varid,ss%E_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: E_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("E_anom",ss%E_anom)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"E_anom2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%E_anom2)
     status = nf90_get_var(icdf,varid,ss%E_anom2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: E_anom2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("E_anom2",ss%E_anom2)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_bpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_bpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_btrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dpass_co",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dpass_ctr",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fidiff_dtrap",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Fi_depletion",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Fi_depletion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Fi_depletion"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fracmin",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fracmin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fracmin"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"fracpslh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%fracpslh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: fracpslh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"frac_full",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%frac_full)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: frac_full"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"frac_half",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%frac_half)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: frac_half"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_ec",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_ec"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_ic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_ic"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_lh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_max_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_mtm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"freq_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%freq_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: freq_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"FUS_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%FUS_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: FUS_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gamma_lmhd",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gamma_lmhd)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gamma_lmhd"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gamma_nc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gamma_nc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gamma_nc"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gas_atom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gas_atom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gas_atom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"GAS_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%GAS_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: GAS_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gb1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gb1"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gb2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gb2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gb2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gb2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gb2i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gbr2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gbr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gbr2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"geometry",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%geometry)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: geometry"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Global_label",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Global_label)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Global_label"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gncfb2h",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gncfb2h)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gncfb2h"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gncfh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gncfh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gncfh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gr1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gr1"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gr2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gr2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gr2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gr2i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr2rho2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gr2rho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gr2rho2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"gr3i",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%gr3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: gr3i"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho1",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grho1)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grho1"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"grho2",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%grho2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: grho2"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_2

subroutine trxpl_gs2_path(zlbl,zpath0,zpath)

  ! ** set directory path to file object ** by user input

  implicit NONE

  character*(*), intent(in) :: zlbl   ! label of object for which to set
  !                                     directory path
  character*(*), intent(inout) :: zpath0  ! directory path (untranslated)
  character*(*), intent(inout) :: zpath   ! directory path (translated)

  !--------------------------------------------
  logical lxout,lchar
  integer lnout,ilz,ilu
  character*120 ztmp
  !--------------------------------------------

  ilz=len_trim(zlbl)
  if(lxout(0)) write(lnout(0),*) &
       'trxpl_mkgs2: set directory path for: ',zlbl(1:ilz)

  call unixpath(zpath0,zpath,ilu)
  if(zpath0(1:1).eq.'~') call fixup(zpath0)
  if(zpath(1:1).eq.'~') call fixup(zpath)

contains
  subroutine fixup(zpath1)
    character*(*), intent(inout) :: zpath1

    ! expand leading "~" in pathname

    integer ilt,ilz

    ztmp=' '
    call sget_env('HOME',ztmp)
    ilt=len_trim(ztmp)
    ilz=len_trim(zpath1)
    zpath1 = ztmp(1:ilt)//zpath1(2:ilz)  ! replace leading "~"

  end subroutine fixup

end subroutine trxpl_gs2_path

subroutine trx_spec_edge(maxn,n_species,sgas,srcy,ierr)

  ! retrieve the gas flow and recycling sources -- scalars for each thermal
  ! plasma species

  implicit NONE

  integer, intent(in) :: maxn           ! max no. of species expected
  integer, intent(out) :: n_species     ! actual no. of species found

  real*8, intent(out) :: sgas(maxn)     ! gasflow sources, N/sec
  real*8, intent(out) :: srcy(maxn)     ! recycling sources, N/sec

  !  these are effective sources, i.e. #ionizations/sec inside the
  !  plasma core (a smaller number than the species' neutral influxes)

  integer, intent(out) :: ierr          ! completion code, 0=OK

  !----------------------------------

  real :: zz(maxn),aa(maxn)
  integer :: izc(maxn)
  integer :: i,igot,iertmp

  character*10 agas(maxn),arcy(maxn)
  character*20 zuns_mks
  real*8 :: zval

  integer :: lunzer
  !----------------------------------

  ierr = 0
  sgas = 0
  srcy = 0

  call rd_th_scedg(maxn,agas,arcy,zz,aa,izc,igot)
  if(igot.eq.-1) then
     write(lunzer(0),*) ' ?trx_spec_edge: error in rd_th_scedg call.'
     ierr=1
     return
  endif

  do i=1,igot
     call trx_scal(agas(i),zuns_mks,zval,iertmp)
     if(iertmp.ne.0) then
        write(lunzer(0),*) ' ?trx_spec_edge: failed to acquire: ',agas(i)
        ierr=1
     endif
     sgas(i)=zval

     call trx_scal(arcy(i),zuns_mks,zval,iertmp)
     if(iertmp.ne.0) then
        write(lunzer(0),*) ' ?trx_spec_edge: failed to acquire: ',arcy(i)
        ierr=1
     endif
     srcy(i)=zval
  enddo

end subroutine trx_spec_edge

subroutine tdb_ebmax(d,zebmax)
  use trdatbuf_obj
  implicit NONE
  !
  !  return the maximum beam energy found in the data
  !
  type (trdatbuf) :: d
  real*8, intent(out) :: zebmax  ! max beam energy

  if(d%nsc.eq.10) then
     zebmax = 0.0d0        ! old trdat files do not have this...
  else
     zebmax = d%datbuf(11)
  endif

end subroutine tdb_ebmax

subroutine splitn_igetd(zname,isize,array,ierr)

  !  get an INTEGER namelist object *default values*
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object ("[<num>]" ignored).
  integer, intent(in) :: isize          ! size of object
  integer, intent(out) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_igetd',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_igetd: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_igetd: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_igetd: not an INTEGER object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_igetd: size mismatch: expected=',isize,' found=',ii
     return
  endif

  ii=varlist(jj)%addr

  ierr = 0
  array = intbuf_d(ii:ii+isize-1)

end subroutine splitn_igetd

subroutine splitn_lgetd(zname,isize,array,ierr)

  !  get a LOGICAL namelist object *default values*
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object ("[<num>]" ignored).
  integer, intent(in) :: isize          ! size of object
  logical, intent(out) :: array(isize)  ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = .FALSE.

  call splitn_bdecode1('splitn_lgetd',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_lgetd: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_lgetd: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lgetd: not a LOGICAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_lgetd: size mismatch: expected=',isize,' found=',ii
     return
  endif

  ii=varlist(jj)%addr

  ierr = 0
  array = logbuf_d(ii:ii+isize-1)

end subroutine splitn_lgetd

subroutine splitn_rgetd(zname,isize,array,ierr)

  !  get an REAL namelist object *default values*
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object ("[<num>]" ignored).
  integer, intent(in) :: isize          ! size of object
  real, intent(out) :: array(isize)     ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_rgetd',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_rgetd: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_rgetd: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'R') then
     write(6,*) '?splitn_rgetd: not a REAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_rgetd: size mismatch: expected=',isize,' found=',ii
     return
  endif

  ii=varlist(jj)%addr

  ierr = 0
  array = rbuf_d(ii:ii+isize-1)

end subroutine splitn_rgetd

subroutine splitn_dgetd(zname,isize,array,ierr)

  !  get an REAL*8 namelist object *default values*
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object ("[<num>]" ignored).
  integer, intent(in) :: isize          ! size of object
  real*8, intent(out) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = 0

  call splitn_bdecode1('splitn_dgetd',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_dgetd: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_dgetd: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'D') then
     write(6,*) '?splitn_dgetd: not a REAL*8 object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_dgetd: size mismatch: expected=',isize,' found=',ii
     return
  endif

  ii=varlist(jj)%addr

  ierr = 0
  array = dbuf_d(ii:ii+isize-1)

end subroutine splitn_dgetd

subroutine splitn_cgetd(zname,iwid,isize,array,ierr)

  !  get an CHARACTER*n namelist object  *default values*
  !  isize *must* match the actual size of the object.
  !  iwid must be .ge. the actual width of object elements.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object ("[<num>]" ignored).
  integer, intent(in) :: iwid           ! width of object array elements
  integer, intent(in) :: isize          ! size of object (# of elements)
  character*(iwid), intent(out) :: array(isize)   ! object data (returned)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  array = ' '

  call splitn_bdecode1('splitn_cgetd',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_cgetd: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_cgetd: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_cgetd: not a CHARACTER*nn object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_cgetd: array size mismatch: expected=',isize, &
          ' found=',ii
     return
  endif

  if(iwid.lt.varlist(jj)%chsize) then
     write(6,*) '?splitn_cgetd: passed character element size too small: ', &
          'have=',iwid,' need=',varlist(jj)%chsize
     return
  endif

  ii=varlist(jj)%addr

  ierr = 0
  do i=1,isize
     array(i) = chbuf_d(ii+i-1)
  enddo

end subroutine splitn_cgetd

subroutine ps_update_fromxplasma(ps,iout,ierr)

  !  Update plasma state "ps" with the equilibrium in
  !  the modified xplasma state.
  !
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state)  :: ps      ! plasma state object to be updated
  integer, intent(in)  :: iout    ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  integer :: id_rho, id_chi, id_rgrid, id_zgrid, id_lim
  integer :: nrho, ntheta, nr, nz, nlim
  integer :: itype, id_p, ii, jj
  integer :: iflag_rho,iflag_th,iflag_RZ,iflag_lim,iertmp
 
  integer :: id_psipol,iwarn,idi,id_R,id_Z
  integer :: kccw_Bphi, kccw_Jphi

  real(rspec), dimension(:), allocatable :: xp_rho,xp_theta,xp_rgrid,xp_zgrid
  real(rspec), dimension(:), allocatable :: xp_rlim,xp_zlim

  real(KIND=rspec), dimension(:), allocatable :: pprof
  real(KIND=rspec), dimension(:,:), allocatable :: r_geo_xpl,z_geo_xpl
  real(KIND=rspec), dimension(:,:,:), allocatable :: r_dgeo_xpl,z_dgeo_xpl

  real(KIND=rspec), parameter :: ZERO  = 0.0_rspec
  real(KIND=rspec), parameter :: TWOPI = 6.2831853071795862_rspec
  real(KIND=rspec), parameter ::    PI = 3.1415926535897931_rspec

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-------------------------------------------------------------------------
  ! executable code...

  call ps_tagchk('ps_update_fromxplasma',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  if(ps_debug.ge.2) then
     write(iout,*) 'ps_update_fromxplasma: set equilibrium from modified xplasma'
  endif

  call ps_reset_mhdeq_hash(ps)

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s, ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: invalid or unitialized xplasma object.'
     return
  endif

  !----------------------

  call xplasma_author_set(s,'EQ',ierr)
  if (ierr/=0) then
     call xplasma_error(s,ierr,iout)
     return
  end if

  ! ---------------------
  ! grab xplasma grids and limiter

  call fetch_grid("__RHO",   id_rho,   nrho,   xp_rho)   ; if (ierr/=0) goto 999
  call fetch_grid("__CHI",   id_chi,   ntheta, xp_theta) ; if (ierr/=0) goto 999
  call fetch_grid("__Rgrid", id_rgrid, nr,     xp_rgrid) ; if (ierr/=0) goto 999
  call fetch_grid("__Zgrid", id_zgrid, nz,     xp_zgrid) ; if (ierr/=0) goto 999

  call xplasma_find_item(s,'__LIMITER',id_lim,iertmp,nf_noerr=.TRUE.)
  if(id_lim.eq.0) then 
     ierr=9999
     write(iout,*) ' ?ps_update_fromxplasma: no limiter in xplasma object'
     go to 999
  endif

  call xplasma_lim_info(s, ierr, npts=nlim, itype=itype)
  if(ierr.eq.0) then
     if (itype/=100) then
        write(iout,*) ' ?ps_update_fromxplasma: can not handle a lines & circle limiter'
        ierr=9999 ; goto 999
     end if

     allocate(xp_rlim(nlim), xp_zlim(nlim))

     call xplasma_lim_info(s, ierr, rpts=xp_rlim, zpts=xp_zlim)

     if(ierr.ne.0) then
        write(iout,*) ' ?ps_update_fromxplasma: error fetching limiter points'
        ierr=9999 ; goto 999
     endif
  else
     write(iout,*) ' ?ps_update_fromxplasma: xplasma_lim_info error:'
     call xplasma_error(s,ierr,iout)
     ierr=9999 ; goto 999
  endif

  ! ---------------------
  ! check xplasma grids

  if (max(abs(xp_rho(1)),abs(xp_rho(nrho)-1.0_rspec)).gt. &
       1.0e-10_rspec) then
     write(iout,*) ' ?ps_update_fromxplasma: rho grid limits are not [0,1]'
     ierr=1 ; goto 999
  else
     call chk_spacing('__RHO',xp_rho,ierr)
     if (ierr/=0) goto 999
  endif

  if(abs(xp_theta(ntheta)-xp_theta(1)-twopi).gt.1.0e-1_rspec) then   ! theta can be unevenly spaced
     !  difference not close to twopi
     write(iout,*) ' ?ps_update_fromxplasma: theta grid limits do not have 2pi range'
     ierr=1 ; goto 999
  endif

  ! ---------------------
  ! check xplasma grids against defined plasma_state grids

  iflag_rho = 0
  iflag_th  = 0
  iflag_RZ  = 0
  iflag_lim = 0

  if(ps%nrho_eq.eq.0 .or. .not. allocated(ps%rho_eq)) then
     call simcon_check('ps%nrho_eq'); if (ierr.ne.0) go to 999
     ps%nrho_eq = nrho
     iflag_rho=1
  else if (ps%nrho_eq/=nrho) then
     write(iout,*) ' ?ps_update_fromxplasma: mismatch in rho grid size between plasma_state and xplasma'
     ierr=1 ; goto 999
  else if (ps%rho_eq(nrho)<0.5_rspec) then
     call simcon_check('ps%nrho_eq'); if (ierr.ne.0) go to 999      ! might be allocated and not defined
  else if (maxval(abs(xp_rho-ps%rho_eq))>1.e-5_rspec) then
     write(iout,*) ' ?ps_update_fromxplasma: rho grid difference between plasma_state and xplasma'   ! probably an unevenly space ps grid
     ierr=1 ; goto 999
  end if

  if(ps%nth_eq.eq.0 .or. .not. allocated(ps%th_eq)) then
     call simcon_check('ps%nth_eq'); if (ierr.ne.0) go to 999
     ps%nth_eq = ntheta
     iflag_th=1
  else if (ps%nth_eq/=ntheta) then
     write(iout,*) ' ?ps_update_fromxplasma: mismatch in theta grid size between plasma_state and xplasma'
     ierr=1 ; goto 999
  else if (ps%th_eq(ntheta)<0.5_rspec) then
     call simcon_check('ps%nth_eq'); if (ierr.ne.0) go to 999      ! might be allocated and not defined
  else if (maxval(abs(xp_theta-ps%th_eq))>1.e-3_rspec) then
     write(iout,*) ' ?ps_update_fromxplasma: theta grid difference between plasma_state and xplasma'  
     ierr=1 ; goto 999
  end if

  if(ps%num_rzlim.eq.0 .or. .not. allocated(ps%rlim)) then
     call mdescr_check('ps%num_rzlim'); if (ierr.ne.0) go to 999
     ps%num_rzlim = nlim
     iflag_lim=1
  else if (ps%num_rzlim/=nlim) then
     write(iout,*) ' ?ps_update_fromxplasma: mismatch in limiter size between plasma_state and xplasma'
     ierr=1 ; goto 999
  else if (maxval(abs(xp_rlim-ps%rlim))>1.e-6_rspec .or. maxval(abs(xp_zlim-ps%zlim))>1.e-6_rspec) then
     call mdescr_check('ps%num_rzlim'); if (ierr.ne.0) go to 999
  end if

  if(ps%nR.eq.0 .or. .not. allocated(ps%R_grid)) then
     call simcon_check('ps%nR'); if (ierr.ne.0) go to 999
     ps%nR = nr
     ps%nZ = nz
     iflag_RZ=1
  else if (ps%nR/=nr .or. ps%nZ/=nz) then
     write(iout,*) ' ?ps_update_fromxplasma: mismatch in R,Z grid size between plasma_state and xplasma'
     ierr=1 ; goto 999
  else if (minval(ps%R_grid)<=0._rspec) then
     call simcon_check('ps%nR'); if (ierr.ne.0) go to 999      ! might be allocated and not defined
  else if (maxval(abs(xp_rgrid-ps%R_grid))>1.e-6_rspec .or. maxval(abs(xp_zgrid-ps%Z_grid))>1.e-6_rspec) then
     write(iout,*) ' ?ps_update_fromxplasma: R,Z grid difference between plasma_state and xplasma'  
     ierr=1 ; goto 999
  end if
 
  !  fetch kmom; store in state element ps%nmom
  call xplasma_global_info(s, ierr, kmom=ps%nmom )
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: error in xplasma_global_info:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  ! convert P(rho) from Hermite to Spline as this is what plasma state expects

  call xplasma_profId(s,'P',id_p)
  if (id_p<=0) then
     write(iout,*) " %ps_update_fromxplasma: could not find pressure profile 'P'"
     ierr=1 ; goto 999
  end if

  call xplasma_prof_info(s,id_p,ierr, gridId1=id_rho, splineType=itype)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: error in xplasma_prof_info:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  if (itype/=2) then
     allocate(pprof(nrho))
 
     call xplasma_eval_prof(s,id_p,pprof,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' %ps_update_fromxplasma: error in xplasma_eval_prof:'
        call xplasma_error(s,ierr,iout)
        go to 999
     endif

     call xplasma_create_1dprof(s,'P',id_rho,pprof,id_p,ierr, &
          ispline=2,ibca=1,zbca=ZERO,ibcb=0, &
          label='MHD equilibrium pressure',units='Pa')
     if(ierr.ne.0) then
        write(iout,*) ' %ps_update_fromxplasma: error in xplasma_create_1dprof'
        call xplasma_error(s,ierr,iout)
        go to 999
     endif
  end if


  !----------------------
  !  allocate arrays associated with grids whose sizes were just defined
  !  (if necessary)

  if (iflag_rho>0) write(iout,*) ' %ps_update_fromxplasma: allocating nrho   = ',nrho
  if (iflag_th>0)  write(iout,*) ' %ps_update_fromxplasma: allocating ntheta = ',ntheta
  if (iflag_RZ>0)  write(iout,*) ' %ps_update_fromxplasma: allocating nr,nz  = ',nr,",",nz
  if (iflag_lim>0) write(iout,*) ' %ps_update_fromxplasma: allocating nlim   = ',nlim

  ierr=0

  if(max(iflag_rho,iflag_th,iflag_RZ,iflag_lim).gt.0) then
     call plasma_state_empty_alloc(ps,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_update_fromxplasma: error in plasma_state_empty_alloc.'
        go to 999
     endif
  endif

  ps%rho_eq = xp_rho
  ps%th_eq  = xp_theta
  
  ps%R_grid = xp_rgrid
  ps%Z_grid = xp_zgrid

  ps%rlim = xp_rlim
  ps%zlim = xp_zlim

  !----------------------
  !  load state copy of Psi(R,Z)

  call xplasma_profId(s,'Psi_RZ',id_psipol)
  if(id_psipol.eq.0) then
     ierr=1
     write(iout,*) ' ?ps_update_fromxplasma: "Psi_RZ" not found.'
     go to 999
  endif

  call xplasma_eval_prof(s,id_psipol,ps%psirz,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: xplasma error fetching PsiRZ:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif
  ps%id_psirz=id_psipol

  !---------------------------------------------------------
  !  OK -- set scalar EQ data

  !  R & Z extrema -- see subroutine, below
  !  check for change; if there is a change; check machine description lock.

  call ps_update_rzbox(ps,iout,ierr)
  if (ierr/=0) goto 999

  !  Field signs; check for shot configuration lock...

  call xplasma_global_info(s,ierr, bphi_ccw = kccw_Bphi, jphi_ccw = kccw_Jphi)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: unexpected  xplasma_global_info call error:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  if((kccw_Bphi.ne.ps%kccw_Bphi).or.(kccw_Jphi.ne.ps%kccw_Jphi)) then
     if(ps%lock_shot_config.eq.ps_locked) then
        ierr=9999
        write(iout,*) &
             ' ?ps_update_fromxplasma: attempt to change field orientation when'
        write(iout,*) &
             '  the shot configuration data has already been locked.'
        write(iout,*) ' kccw_Bphi locked value: ',ps%kccw_Bphi, &
             '; new value:',kccw_Bphi
        write(iout,*) ' kccw_Jphi locked value: ',ps%kccw_Jphi, &
             '; new value:',kccw_Jphi
        go to 999
     endif
     if(ps%lock_shot_config.eq.ps_monitor) then
        write(iout,*) ' %ps_update_fromxplasma: field orientations set:'
        write(iout,*) '  kccw_Bphi = ',kccw_Bphi,'; kccw_Jphi=',kccw_Jphi
     endif
     ps%kccw_Bphi = kccw_Bphi
     ps%kccw_Jphi = kccw_Jphi
  endif

  ! --scalars derived from equilibrium and field

  call ps_mhdeq_derived_scalars(ps,iout,ierr)
  if(ierr.ne.0) go to 999

  ! profiles vs. (rho)

  call eqpro('P',ps%P_eq,ps%id_P_eq); if(ierr.ne.0) go to 999
  call eqpro('G',ps%g_eq,ps%id_g_eq); if(ierr.ne.0) go to 999
  call eqpro('Q',ps%q_eq,ps%id_q_eq); if(ierr.ne.0) go to 999
  call eqpro('PHITOR',ps%phit,ps%id_phit); if(ierr.ne.0) go to 999
  call eqpro('PSI',ps%psipol,ps%id_psipol); if(ierr.ne.0) go to 999
  call eqpro('ICURT',ps%curt,ps%id_curt); if(ierr.ne.0) go to 999

  allocate(r_geo_xpl(ps%nth_eq,ps%nrho_eq))
  allocate(z_geo_xpl(ps%nth_eq,ps%nrho_eq))
  allocate(r_dgeo_xpl(3,ps%nth_eq,ps%nrho_eq))
  allocate(z_dgeo_xpl(3,ps%nth_eq,ps%nrho_eq))

  call xplasma_profId(s,'R',id_R)
  call xplasma_profId(s,'Z',id_Z)

  call xplasma_eval_prof(s,id_R,r_geo_xpl,ierr,zcoeff=r_dgeo_xpl)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: R_geo fetch error:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  call xplasma_eval_prof(s,id_Z,z_geo_xpl,ierr,zcoeff=z_dgeo_xpl)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: Z_geo fetch error:'
     call xplasma_error(s,ierr,iout)
     go to 999
  endif

  ps%id_R_geo = id_R
  ps%id_Z_geo = id_Z

  do jj=1,ps%nth_eq
     do ii=1,ps%nrho_eq
        ps%R_geo(ii,jj) = r_geo_xpl(jj,ii)
        ps%Z_geo(ii,jj) = Z_geo_xpl(jj,ii)

        ps%dR_geo_drho(ii,jj) = r_dgeo_xpl(2,jj,ii)
        ps%dR_geo_dth(ii,jj) = r_dgeo_xpl(1,jj,ii)
        ps%d2R_geo_drhodth(ii,jj) = r_dgeo_xpl(3,jj,ii)

        ps%dZ_geo_drho(ii,jj) = z_dgeo_xpl(2,jj,ii)
        ps%dZ_geo_dth(ii,jj) = z_dgeo_xpl(1,jj,ii)
        ps%d2Z_geo_drhodth(ii,jj) = z_dgeo_xpl(3,jj,ii)
     enddo
  enddo

  call eqpro2d('BPHI_RZ',ps%BphiRZ,ps%id_BphiRZ); if(ierr.ne.0) go to 999
  call eqpro2d('BR_RZ',ps%BRRZ,ps%id_BRRZ); if(ierr.ne.0) go to 999
  call eqpro2d('BZ_RZ',ps%BZRZ,ps%id_BZRZ); if(ierr.ne.0) go to 999

  !---------------------------------------------------------
  ! set EQ derived profiles...

  call ps_mhdeq_volumes(ps,iout,ierr)
  if(ierr.ne.0) go to 999

  call ps_mhdeq_fsmoms(ps,iout,ierr)
  if(ierr.ne.0) go to 999

  call ps_update_jdotb(ps,iout,ierr)
  if(ierr.ne.0) go to 999

999 continue
  call xplasma_author_clear(s,'EQ',iertmp)
  if (iertmp/=0) then
     call xplasma_error(s,iertmp,iout)
     ierr=1
  end if

  if (allocated(xp_rho))   deallocate(xp_rho)     ! deallocate just in case
  if (allocated(xp_theta)) deallocate(xp_theta)
  if (allocated(xp_rgrid)) deallocate(xp_rgrid)
  if (allocated(xp_zgrid)) deallocate(xp_zgrid)
  if (allocated(xp_rlim))  deallocate(xp_rlim)
  if (allocated(xp_zlim))  deallocate(xp_zlim)
  if (allocated(pprof))    deallocate(pprof)

  if (allocated(r_geo_xpl))  deallocate(r_geo_xpl)
  if (allocated(z_geo_xpl))  deallocate(z_geo_xpl)
  if (allocated(r_dgeo_xpl)) deallocate(r_dgeo_xpl)
  if (allocated(z_dgeo_xpl)) deallocate(z_dgeo_xpl)

  if(ierr.ne.0) then
     ierr=999
     write(iout,*) ' ?ps_update_fromxplasma: an error was detected.'
  else
     if(ps_debug.ge.2) then
        write(iout,*) ' ps_update_fromxplasma: MHD equilibrium OK, normal exit.'
        write(iout,*) ' '
     endif
  endif

  CONTAINS

    subroutine fetch_grid(sd,id,nd,xd)
      character*(*),intent(in)  :: sd     ! name of grid
      integer,      intent(out) :: id     ! id of grid
      integer,      intent(out) :: nd     ! size of grid
      real(rspec),  allocatable :: xd(:)  ! allocated grid if no error
      
      ierr=0
      nd=0
      
      call xplasma_gridId(s, sd, id)
      if (id<=0) then
         write(iout, *) ' %ps_update_fromxplasma: unable to find '//sd//' grid'
         ierr=1 ; return
      end if
      
      call xplasma_grid_size(s, id, nd, ierr)
      if (ierr/=0) nd=0
      if (nd<=0) then
         write(iout, *) ' %ps_update_fromxplasma: error fetching size of '//sd//' grid'
         ierr=1 ; return
      end if
      
      allocate(xd(nd))
      
      call xplasma_grid(s,id,xd,ierr)
      if (ierr/=0) then
         write(iout, *) ' %ps_update_fromxplasma: error fetching data for '//sd//' grid'
         ierr=1 ; return
      end if
    end subroutine fetch_grid


    subroutine chk_spacing(gname, grid, iflag)
      character*(*), intent(in) :: gname
      real(kind=rspec), dimension(:), intent(in) :: grid
      integer, intent(out) :: iflag

      integer :: isize,ii
      real(kind=rspec) :: dxg

      iflag = 1  ! signal unevenly spaced grid or empty grid
      isize = size(grid)
      if(isize.lt.2) then
         write(iout,*) ' ?ps_update_fromxplasma: '//gname//' grid is too small'
         return
      end if

      iflag = 0  ! signal evenly spaced grid
      if(isize.eq.2) return

      dxg = (grid(isize) - grid(1))/(isize-1)
      if(dxg.le.0.0_rspec) then
         iflag = 1
         write(iout,*) ' ?ps_update_fromxplasma: '//gname//' grid has null range'
         return
      endif

      do ii=1,isize-1
         if(abs(dxg - (grid(ii+1)-grid(ii))).gt.1.0e-9_rspec*dxg) then
            iflag = 1
            write(iout,*) ' ?ps_update_fromxplasma: '//gname//' grid not evenly spaced'
            return
         endif
      enddo

    end subroutine chk_spacing

    subroutine mdescr_check(name_in)
      character*(*), intent(in) :: name_in

      if(ps%lock_machine_descr.eq.ps_locked) then
         ierr=1
         write(iout,*) ' ?ps_update_fromxplasma: machine description is locked;'
         write(iout,*) '  detected request to change: ',trim(name_in)
      endif
    end subroutine mdescr_check

    subroutine simcon_check(name_in)
      character*(*), intent(in) :: name_in

      if(ps%lock_sim_init.eq.ps_locked) then
         ierr=1
         write(iout,*) ' ?ps_update_fromxplasma: simulation initialization is locked;'
         write(iout,*) '  detected request to change: ',trim(name_in)
      endif
    end subroutine simcon_check

    subroutine eqpro(name_in,array,id)
      character*(*), intent(in) :: name_in
      REAL(KIND=rspec), dimension(:), intent(out) :: array ! result
      integer,intent(out) :: id

      !  fetch profile on original rho_eq grid

      call xplasma_profId(s,name_in,idi)
      if(idi.eq.0) then
         write(iout,*) ' ?ps_update_fromxplasma: expected profile not found after g file read: ',trim(name_in)
         ierr = 1
         array = ZERO
         id = 0
         return
      endif

      call xplasma_eval_prof(s,idi,array,ierr)
      if(ierr.ne.0) then
         write(iout,*) ' ?ps_update_fromxplasma: xplasma_eval_prof error:'
         call xplasma_error(s,ierr,iout)
         array = ZERO
         id = 0
         return
      endif

      id = idi

    end subroutine eqpro

    subroutine eqpro2d(name_in,array,id)
      character*(*), intent(in) :: name_in
      REAL(KIND=rspec), dimension(:,:), intent(out) :: array ! result
      integer, intent(out) :: id

      !  fetch profile on original 2d grid

      call xplasma_profId(s,name_in,idi)
      if(idi.eq.0) then
         write(iout,*) ' ?ps_update_fromxplasma: expected profile not found after g file read: ',trim(name_in)
         ierr = 1
         array = ZERO
         id = 0
         return
      endif

      call xplasma_eval_prof(s,idi,array,ierr)
      if(ierr.ne.0) then
         write(iout,*) ' ?ps_update_fromxplasma: xplasma_eval_prof error:'
         call xplasma_error(s,ierr,iout)
         array = ZERO
         id = 0
         return
      endif

      id = idi

    end subroutine eqpro2d

end subroutine ps_update_fromxplasma


subroutine ps_reset_mhdeq_hash(ps)

  !  Reset hash codes related to MHDEQ-derived quantities:  good to do
  !  when the geometry is being explicitly updated.

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated

  !-----------------------
  !  local:

  integer :: ia,iaddr1,iaddr2

  !-----------------------

  iaddr1 = ps_hash_aux1
  iaddr2 = size(ps%hash_codes)

  do ia=iaddr1,iaddr2
     ps%hash_codes(ia)=ps_unInit
  enddo

end subroutine ps_reset_mhdeq_hash

subroutine ps_mhdeq_derived_scalars(ps,iout,ierr)

  !  Update plasma state "ps" with derived scalars from equilibrium
  !  XPLASMA2 implementation -- DMC Oct 10 2006

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
  !  local:

  integer :: idg,idum
  real(KIND=rspec), parameter :: ONE  = 1.0_rspec

  !-----------------------
  !    PLASMA (LCFS = last closed flux surface-- although actually the 
  !    boundary will be shifted in slightly from the precise separatrix
  !    surface, in cases of diverted plasmas).

  call ps_tagchk('ps_mhdeq_derived_scalars',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_RZminmax_plasma(s, &
       ps%R_min_lcfs, ps%R_max_lcfs, ps%Z_min_lcfs, ps%Z_max_lcfs, &
       ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_derived_scalars: unexpected xplasma_RZminmax_plasma call error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  !  mod(B) extrema

  call xplasma_Bminmax(s, ONE, ierr, bmin=ps%B_min_lcfs, bmax=ps%B_max_lcfs)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_derived_scalars: unexpected xplasma_Bminmax call error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  !  Axial values

  call xplasma_mag_axis(s,ierr, &
       Raxis=ps%R_axis, Zaxis=ps%Z_axis, Baxis=ps%B_axis)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_derived_scalars: unexpected xplasma_mag_axis call error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  !  Vacuum field -- g(1)/R_axis

  call xplasma_profId(s,'G',idg)
  call xplasma_eval_prof(s,idg,ONE,ps%B_axis_vac,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_derived_scalars: unexpected "G" xplasma_eval_prof call error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  ps%B_axis_vac = ps%B_axis_vac/ps%R_axis  ! |B_vac @ axis| = g(1)/R_axis

  call xplasma_get_psi0(s,ps%Psi_to_machine_axis,idum,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_derived_scalars: unexpected xplasma_get_Psi0 call error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

end subroutine ps_mhdeq_derived_scalars

subroutine ps_update_fromxplasma_integ(ps,iout,idi,ierr)

  !  Called from ps_mhdeq_volumes

  !  Create an integrator for flux surface integrals and averages
  !  on the ps%rho_eq grid 

  !  Integrator ownership set to xplasma_xmhd --> removed when equilibrium
  !  changes.

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps       ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages

  integer, intent(out) :: idi     ! ID of integrator, returned (0 if error)
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:
  integer :: iertmp
  character*32, parameter :: iiname = '_ps_update_fromxplasma_integ          '

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_blkbxId(s,iiname,idi)
  if(idi.ne.0) return

  !  integrator not found: create it...

  call xplasma_author_set(s,xplasma_xmhd,iertmp)

  call xplasma_create_integ(s,trim(iiname),ps%rho_eq,idi,ierr, &
       cache_enable = .TRUE.)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma_integ: unexpected xplasma error:'
     call xplasma_error(s,ierr,iout)
  endif

  call xplasma_author_clear(s,xplasma_xmhd,iertmp)

end subroutine ps_update_fromxplasma_integ

subroutine ps_mhdeq_volumes(ps,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium:
  !  enclosed volumes, cross sectional areas, surface areas of flux
  !  surfaces, and poloidal path length.

  !  A hash code test is used to determine whether the profiles need
  !  updating.  If they do, then so do all other flux surface averages;
  !  the others are then zeroed out here.  Separate routines are provided
  !  for computation of these additional flux surface averages and
  !  integrations.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: ii,jj,idi,kf1,kf2,idiff,iaddr

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_tagchk('ps_mhdeq_volumes',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  if(ps%nrho_eq.eq.0) then
     ierr=1
     write(iout,*) ' ?ps_update_volumes: called but no rho_eq grid found.'
     return
  endif

  !-----------------------
  !  hash code test

  loc_cclist = ps_cczero
  loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
  call plasma_state_hash_code(ps,loc_cclist,ierr)
  if(ierr.ne.0) return

  idiff=0
  call ps_rzsurf_hash(ps,kf1,kf2)

  iaddr=ps_hash_aux1

  ps%new_hash_codes(iaddr)=kf1
  if(kf1.ne.ps%hash_codes(iaddr)) then
     ps%hash_codes(iaddr)=kf1
     idiff=idiff+1
  endif

  iaddr=iaddr+1
  ps%new_hash_codes(iaddr)=kf2
  if(kf2.ne.ps%hash_codes(iaddr)) then
     ps%hash_codes(iaddr)=kf2
     idiff=idiff+1
  endif

  if(idiff.eq.0) return

  !-----------------------
  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_mhdeq_volumes: invalid or unitialized xplasma object.'
     return
  endif

  ! setup up for flux surface averaging and integration...

  call ps_update_fromxplasma_integ(ps,iout,idi,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' (error in call from ps_mhdeq_volumes).'
     return
  endif

  ! compute flux surface averages and integrals -- surface oriented -- save
  ! as profiles

  call doi('Vol',ps%vol); if(ierr.ne.0) return
  call doi('Area',ps%area); if(ierr.ne.0) return
  call doi('Surf',ps%surf); if(ierr.ne.0) return
  call doi('Lpol',ps%lpol); if(ierr.ne.0) return

  ! auxilliary flux surface averages NOT recomputed here...
  ! (a time interpolation of these quantities may suffice).

#ifdef __DEBUG
  if(allocated(ps%gr2i)) then
     write(iout,*) 'ps_mhdeq_volumes: updates possible for: <1/R**2>, etc.'
  endif
#endif

  CONTAINS

    subroutine doi(ilabel,array)
      character*(*), intent(in) :: ilabel     ! integration tag
      REAL(KIND=rspec), dimension(:), intent(out) :: array ! result

      !  compute numerical integration; store results in array

      array = ZERO
      call xplasma_rho_zonint(s,idi,ilabel,array,ierr)
      if(ierr.ne.0) then
         write(iout,*) ' ?ps_mhdeq_volumes: unexpected error in xplasma_rho_zonint("',ilabel,'",...)'
         call xplasma_error(s,ierr,iout)
      endif

    end subroutine doi

end subroutine ps_mhdeq_volumes

subroutine ps_rzsurf_hash(ps,kf1,kf2)

  !------------------------------------------------------------
  ! compute hash of hash codes for: rho_eq grid, th_eq grid, R_geo, Z_geo,
  ! and derivatives.
  !
  ! this routine assumes that ps%new_hash_codes(...) have been updated,
  ! at least for the EQ component.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_hash_code
  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be checked
  integer, intent(out) :: kf1,kf2         ! hash code pair

  !-----------------------
  integer :: iaddr,ipair(2),iout
  !-----------------------

  kf1=0
  kf2=0
  if(.not.allocated(ps%rho_eq)) return
  if(.not.allocated(ps%th_eq)) return

  iaddr=ps_dhash_nrho_eq

  kf1=ps%new_hash_codes(iaddr)
  kf2=ps%new_hash_codes(iaddr+1)

  call addpair(ps_dhash_nth_eq)

  call addpair(ps_phash_R_geo)
  call addpair(ps_phash_dR_geo_drho)
  call addpair(ps_phash_dR_geo_dth)
  call addpair(ps_phash_d2R_geo_drhodth)

  call addpair(ps_phash_R_geo)
  call addpair(ps_phash_dR_geo_drho)
  call addpair(ps_phash_dR_geo_dth)
  call addpair(ps_phash_d2R_geo_drhodth)

  if(ps_debug.ge.2) then
     iout=SWIM_err_out_file
     write(iout,*) ' ........ps_rzsurf_hash:  ',kf1,kf2
  endif

  contains
    subroutine addpair(iarg)
      integer :: iarg

      iaddr=iarg
      ipair(1)=ps%new_hash_codes(iaddr)
      ipair(2)=ps%new_hash_codes(iaddr+1)

      call hashCode(ipair,kf1,kf2)
    end subroutine addpair
end subroutine ps_rzsurf_hash

subroutine ps_mhdeq_fsmoms(ps,iout,ierr)

  ! extract Fourier Spline moments (fsmoms) from xplasma representation
  ! make these available in the Plasma State object (ps)

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps       ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  integer :: im,inorm
  integer :: ikmom,ikmaxe
  character*3 :: zint

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_tagchk('ps_mhdeq_fsmoms',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  if(ps%neqmom.eq.0) then
     ikmom=ps%nmom
     ps%neqmom = ikmom
     call plasma_state_empty_alloc(ps,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_fsmoms: moments array alloc failure.'
        return
     endif
     ! plasma state neqmom dimension labels...
     do im=1,ikmom
        zint=' '
        if(im.le.9) then
           write(zint(1:1),'(I1)') im
        else if(im.le.99) then
           write(zint(1:2),'(I2)') im
        else
           write(zint(1:3),'(I3)') im
        endif
        ps%eqmom_num(im)=zint
     enddo
  else
     ikmom=ps%neqmom
     ps%nmom=ikmom
  endif

  ikmaxe=1  ! higher moments scaled by 1/x only, not 1/x**N, N>1.

  call xplasma_kmom_set(s,ikmom,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_fsmoms: xplasma_kmom_set error:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  call xpmom_free(s)

  ! recompute and extract Fourier Spline (scaled moments) & derivatives

  inorm=1  ! return scaled moments xRj, xRj~, xZj, xZj~

  ! R = R0 + sum(j=1:nmom)[rho*(xRj*cos(j*theta)+xRj~*sin(j*theta))]
  ! Z = Z0 + sum(j=1:nmom)[rho*(xZj~*cos(j*theta)+xZj*sin(j*theta))]
  !     (scaled moment needs factor applied to get to sin & cos coefficients)

  call xpmom_get1(s,ps%rho_eq,inorm,0,ierr, &
       rcmom=ps%R0_momeq, zcmom=ps%Z0_momeq, ideriv=0)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_fsmoms: xpmom_get1 (R0,Z0) error: '
     call xplasma_error(s,ierr,iout)
     return
  endif

  call xpmom_get1(s,ps%rho_eq,inorm,0,ierr, &
       rcmom=ps%dR0_momeq_drho, zcmom=ps%dZ0_momeq_drho, ideriv=1)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_fsmoms: xpmom_get1 (R0,Z0 derivatives) error: '
     call xplasma_error(s,ierr,iout)
     return
  endif

  do im=1,ps%neqmom

     call xpmom_get1(s,ps%rho_eq,inorm,im,ierr, &
          rcmom=ps%xRjcos_momeq(:,im), rsmom=ps%xRjsin_momeq(:,im), &
          zcmom=ps%xZjcos_momeq(:,im), zsmom=ps%xZjsin_momeq(:,im), &
          ideriv = 0)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_fsmoms: xpmom_get1 (Rj,Zj) error: '
        call xplasma_error(s,ierr,iout)
        return
     endif

     call xpmom_get1(s,ps%rho_eq,inorm,im,ierr, &
          rcmom=ps%dxRjcos_momeq_drho(:,im), &
          rsmom=ps%dxRjsin_momeq_drho(:,im), &
          zcmom=ps%dxZjcos_momeq_drho(:,im), &
          zsmom=ps%dxZjsin_momeq_drho(:,im), &
          ideriv = 1)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_fsmoms: xpmom_get1 (Rj,Zj deriv.) error: '
        call xplasma_error(s,ierr,iout)
        return
     endif

  enddo

end subroutine ps_mhdeq_fsmoms

subroutine ps_update_brz(ps,iout,ierr)

  ! after Psi(R,Z), Psi(rho), [R,Z](rho,theta), and g(rho) have been set up
  ! and the field components computed, retrieve these for the plasma state.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:
  integer :: iersum
  integer :: id_Bphi,id_BR,id_BZ
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_tagchk('ps_update_brz',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: invalid or unitialized xplasma object.'
     return
  endif

  iersum = 0

  call xplasma_profId(s,'BPHI_RZ',id_Bphi)
  if(id_Bphi.eq.0) then
     write(iout,*) ' ?ps_update_brz:  BPHI_RZ expected, not found in xplasma.'
     iersum = iersum + 1
  endif

  call xplasma_profId(s,'BR_RZ',id_BR)
  if(id_Bphi.eq.0) then
     write(iout,*) ' ?ps_update_brz:  BR_RZ expected, not found in xplasma.'
     iersum = iersum + 1
  endif

  call xplasma_profId(s,'BZ_RZ',id_BZ)
  if(id_Bphi.eq.0) then
     write(iout,*) ' ?ps_update_brz:  BZ_RZ expected, not found in xplasma.'
     iersum = iersum + 1
  endif

  if(iersum.ne.0) then
     ierr=9999
     return
  endif

  call xplasma_eval_prof(s,id_Bphi,ps%BphiRZ,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: xplasma error fetching Bphi_RZ:'
     call xplasma_error(s,ierr,iout)
     iersum = iersum + 1
  endif
  ps%id_BphiRZ = id_Bphi

  call xplasma_eval_prof(s,id_BR,ps%BRRZ,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: xplasma error fetching BR_RZ:'
     call xplasma_error(s,ierr,iout)
     iersum = iersum + 1
  endif
  ps%id_BRRZ = id_BR

  call xplasma_eval_prof(s,id_BZ,ps%BZRZ,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_update_fromxplasma: xplasma error fetching BZ_RZ:'
     call xplasma_error(s,ierr,iout)
     iersum = iersum + 1
  endif
  ps%id_BZRZ = id_BZ

  if(iersum.ne.0) then
     ierr=9999
     return
  endif
  
end subroutine ps_update_brz

subroutine ps_update_rzbox(ps,iout,ierr)

  !------------------------------------------------------------
  ! update (R,Z) extrema -- checking that the machine description
  ! is not locked, if there is a change.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  integer :: iflag
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
  ! set box extrema from (R,Z) GRID

  call ps_tagchk('ps_update_rzbox',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_update_fromxplasma: invalid or unitialized xplasma object.'
     return
  endif

  if(.not.allocated(ps%R_grid)) return
  if(.not.allocated(ps%Z_grid)) return

  if((ps%R_min_box.ne.ps%R_grid(1)).OR. &
       (ps%R_max_box.ne.ps%R_grid(ps%nR)).OR. &
       (ps%Z_min_box.ne.ps%Z_grid(1)).OR. &
       (ps%Z_max_box.ne.ps%Z_grid(ps%nZ))) then

     if(ps%lock_machine_descr.eq.ps_locked) then
        iflag = 1
        ierr = 9999
        write(iout,*) ' ?ps_update_rzbox: attempt to update [R,Z] box after'
        write(iout,*) '  machine description is locked:'
     else if(ps%lock_machine_descr.eq.ps_monitor) then
        iflag = 1
        ierr = 0
        write(iout,*) ' %ps_update_rzbox: change in [R,Z] box extrema:'
     else
        iflag = 0
        ierr = 0
     endif

     if(iflag.eq.1) then
        write(iout,'(4(1x,a13))') ' ','box',' ','grid'
        write(iout,'(2(1x,a13,1x,1pe13.6))') &
             'R_min_box',ps%R_min_box,'R_grid(1)',ps%R_grid(1)
        write(iout,'(2(1x,a13,1x,1pe13.6))') &
             'R_max_box',ps%R_max_box,'R_grid(nR)',ps%R_grid(ps%nR)
        write(iout,'(2(1x,a13,1x,1pe13.6))') &
             'Z_min_box',ps%Z_min_box,'Z_grid(1)',ps%Z_grid(1)
        write(iout,'(2(1x,a13,1x,1pe13.6))') &
             'Z_max_box',ps%Z_max_box,'Z_grid(nZ)',ps%Z_grid(ps%nZ)
     endif

     if(ierr.eq.0) then
        ps%R_min_box = ps%R_grid(1)
        ps%R_max_box = ps%R_grid(ps%nR)

        ps%Z_min_box = ps%Z_grid(1)
        ps%Z_max_box = ps%Z_grid(ps%nZ)
     endif
  endif

end subroutine ps_update_rzbox

subroutine rd_trdatbuf(nonlin, d, zserver, ztree, zshot, ztok, iyear, ishot,  ier)

  !  1.  connect to server & open tree
  !  2.  read trdatbuf data
  !  3.  disconnect

  Use trdatbuf_module

  implicit none

  integer :: ishot       ! mds+ shot
  integer :: ier         ! error flag
  integer :: isocket     ! from conopn
  integer :: iyear       ! two digit year
  integer :: nonlin      ! lun for error messages

  character*80  :: zshot    ! runid
  character*120 :: zserver  ! mds+ server
  character*80  :: ztree    ! mds+ tree
  character*20  :: ztok     ! tokamak
  character*40  :: zchild   ! temp

  integer       :: stat

  Type (trdatbuf) :: d

  call mds_conopn(nonlin, zserver, ztree, zshot, ztok, iyear, ishot, isocket, 3, ier)
  if (ier/=0) then
     write(nonlin,'(/a)')     '?trdatbuf_frommds: error opening the tree'
     goto 999     
  else
!     write(*,*) ' mds_conopn successful'
  end if

  call rd_trdatbuf_mds(d,ier)

  if (ier/=0) then
     write(nonlin,'(/a)')     '?trdatbuf_frommds: error reading the tree'
     go to 990
  endif

990 continue

  call MdsCacheDisconnect
  stat=0

999 continue

  return
end subroutine rd_trdatbuf


subroutine rd_trdatbuf_mds(d,ier)

  !  read trdatbuf data from open tree
  !  do not connect, open, or disconnect.

  Use trdatbuf_module
  Use trdatbuf_intmod

  implicit NONE

  Type (trdatbuf) :: d
  integer, intent(out) :: ier   ! status code returned (0=OK)

  !----------------------
  integer :: ilen        !  size of datbuf
  integer :: nivarx        ! number of integer variables in ivarname & ivarsize
  integer :: iparams(3)     !  sizes of MDSplus arrays
  integer :: isize       ! size of datbuf returned from datbuf_expand

  real*8, dimension(:), allocatable :: datbuf
  !----------------------

  ier = 0

  call rd_longarr('.TRBUFDATA:PARAMS',iparams,3,ier)
  if (ier/=0) goto 990

  nivarx = iparams(1)
  ilen = iparams(2)
  ilen2 = iparams(3)

  if(allocated(intbuf)) then
     if(size(intbuf).ne.ilen2) then
        deallocate(intbuf)  ! not sure if the size will really change...
        allocate(intbuf(ilen2))
     endif
  else
     allocate(intbuf(ilen2))
  endif

  call rd_longarr('.TRBUFDATA:INTBUF',intbuf,ilen2,ier)
  if (ier/=0) goto 990

  allocate(datbuf(ilen))
  call rd_doublearr('.TRBUFDATA:DATBUF',datbuf, ILEN,ier)
  if (ier/=0) goto 990

  ivarname= ' '  ! clear to blank first...

  call rd_cstringarr('.TRBUFDATA:IVARNAME',ivarname, nivarx,ier)
  if (ier/=0) goto 990

  call rd_longarr('.TRBUFDATA:IVARSIZE',ivarsize,nivarx,ier)
  if (ier/=0) goto 990

  call trdatbuf_init(d)

  call get_intbuf(d)
  call datbuf_expand(d,ilen,isize)

  d%DATBUF(1:ilen) = datbuf

990 continue

  return
end subroutine rd_trdatbuf_mds

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents(itype,icomponent,ss,w,ierr)

  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(OUT) :: ierr   ! status code on exit, 0=normal

  !local:

  INTEGER :: iout,isize,id,inum
  INTEGER :: i1,i2,i3,i4

  !----------------
  iout = SWIM_err_out_file
  ierr = 0

  isize = 0

  ! Enumeration Dimensions

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nky_anomth
        w%list_elems(isize) = "nky_anomth"
        w%elem_descr(isize) = "number of points, ky grid ( anomalous data over ky spectrum)"
        w%component(isize) = "ANOM"
        w%ival(isize) = ss%nky_anomth
        w%val_field(isize) = "nky_anomth"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! nky_mmm
        w%list_elems(isize) = "nky_mmm"
        w%elem_descr(isize) = "number of points, ky grid for MMM model"
        w%component(isize) = "ANOM"
        w%ival(isize) = ss%nky_mmm
        w%val_field(isize) = "nky_mmm"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! max_nrz_antgeo
        w%list_elems(isize) = "max_nrz_antgeo"
        w%elem_descr(isize) = "Maximum size of variable length enumeration: NRZ_ANTGEO"
        w%component(isize) = "IC"
        w%ival(isize) = ss%max_nrz_antgeo
        w%val_field(isize) = "nrz_antgeo(nicrf_src)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! max_nspectrumlh_src
        w%list_elems(isize) = "max_nspectrumlh_src"
        w%elem_descr(isize) = "Maximum size of variable length enumeration: NSPECTRUMLH_SRC"
        w%component(isize) = "LH"
        w%ival(isize) = ss%max_nspectrumlh_src
        w%val_field(isize) = "nspectrumlh_src(nlhrf_src)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! max_num_nphi
        w%list_elems(isize) = "max_num_nphi"
        w%elem_descr(isize) = "Maximum size of variable length enumeration: NUM_NPHI"
        w%component(isize) = "IC"
        w%ival(isize) = ss%max_num_nphi
        w%val_field(isize) = "num_nphi(nicrf_src)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! max_num_nphi_vac
        w%list_elems(isize) = "max_num_nphi_vac"
        w%elem_descr(isize) = "Maximum size of variable length enumeration: NUM_NPHI_VAC"
        w%component(isize) = "IC"
        w%ival(isize) = ss%max_num_nphi_vac
        w%val_field(isize) = "num_nphi_vac(nicrf_src)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! num_rzlim
        w%list_elems(isize) = "num_rzlim"
        w%elem_descr(isize) = "number of points, axisymmetric (R,Z) limiter"
        w%component(isize) = "EQ"
        w%ival(isize) = ss%num_rzlim
        w%val_field(isize) = "num_rzlim"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_D_einj_standard
        w%list_elems(isize) = "n_D_einj_standard"
        w%elem_descr(isize) = "no. pts in D beam energy fractions table"
        w%component(isize) = "NBI"
        w%ival(isize) = ss%n_d_einj_standard
        w%val_field(isize) = "n_D_einj_standard"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_H_einj_standard
        w%list_elems(isize) = "n_H_einj_standard"
        w%elem_descr(isize) = "no. pts in H beam energy fractions table"
        w%component(isize) = "NBI"
        w%ival(isize) = ss%n_h_einj_standard
        w%val_field(isize) = "n_H_einj_standard"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! max_n_straps
        w%list_elems(isize) = "max_n_straps"
        w%elem_descr(isize) = "Maximum size of variable length enumeration: N_STRAPS"
        w%component(isize) = "IC"
        w%ival(isize) = ss%max_n_straps
        w%val_field(isize) = "n_straps(nicrf_src)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_enum_dims) THEN
        isize = isize + 1  ! n_T_einj_standard
        w%list_elems(isize) = "n_T_einj_standard"
        w%elem_descr(isize) = "no. pts in T beam energy fractions table"
        w%component(isize) = "NBI"
        w%ival(isize) = ss%n_t_einj_standard
        w%val_field(isize) = "n_T_einj_standard"
     ENDIF
  ENDIF
  ! Species Lists

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! ALL
        w%list_elems(isize) = "ALL"
        w%elem_descr(isize) = "all species"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(0:nspec_all)"
        IF(ss%nspec_all.EQ.0) then
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = ss%nspec_all +1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! ALLA
        w%list_elems(isize) = "ALLA"
        w%elem_descr(isize) = "all species abridged"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(0:nspec_alla)"
        IF(ss%nspec_alla.EQ.0) then
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = ss%nspec_alla +1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SNBI
        w%list_elems(isize) = "SNBI"
        w%elem_descr(isize) = "beam ion species"
        w%component(isize) = "NBI"
        w%val_field(isize) = "(nspec_beam)"
        w%ival(isize) = ss%nspec_beam
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SFUS
        w%list_elems(isize) = "SFUS"
        w%elem_descr(isize) = "fusion product ion species"
        w%component(isize) = "FUS"
        w%val_field(isize) = "(nspec_fusion)"
        w%ival(isize) = ss%nspec_fusion
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SGAS
        w%list_elems(isize) = "SGAS"
        w%elem_descr(isize) = "atomic neutral species in plasma core"
        w%component(isize) = "GAS"
        w%val_field(isize) = "(nspec_gas)"
        w%ival(isize) = ss%nspec_gas
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SIMP0
        w%list_elems(isize) = "SIMP0"
        w%elem_descr(isize) = "atomic impurity species in simulation"
        w%component(isize) = "GAS"
        w%val_field(isize) = "(nspec_imp0)"
        w%ival(isize) = ss%nspec_imp0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SIMPI
        w%list_elems(isize) = "SIMPI"
        w%elem_descr(isize) = "impurity ion species in simulation"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(nspec_impi)"
        w%ival(isize) = ss%nspec_impi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! RFMIN
        w%list_elems(isize) = "RFMIN"
        w%elem_descr(isize) = "ICRF minority species"
        w%component(isize) = "IC"
        w%val_field(isize) = "(nspec_rfmin)"
        w%ival(isize) = ss%nspec_rfmin
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! S
        w%list_elems(isize) = "S"
        w%elem_descr(isize) = "thermal species list"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(0:nspec_th)"
        IF(ss%nspec_th.EQ.0) then
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = ss%nspec_th +1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_species_lists) THEN
        isize = isize + 1  ! SA
        w%list_elems(isize) = "SA"
        w%elem_descr(isize) = "thermal species abridged"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(0:nspec_tha)"
        IF(ss%nspec_tha.EQ.0) then
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = ss%nspec_tha +1
        ENDIF
     ENDIF
  ENDIF

  ! Item Lists

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! Tor_mode_label
        w%list_elems(isize) = "Tor_mode_label"
        w%elem_descr(isize) = "Toroidal modes to monitor"
        w%component(isize) = "LMHD"
        w%val_field(isize) = "(mmodes)"
        w%ival(isize) = ss%mmodes
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! Balloon_code
        w%list_elems(isize) = "Balloon_code"
        w%elem_descr(isize) = "name(s) of Ballooning code(s) used"
        w%component(isize) = "LMHD"
        w%val_field(isize) = "(nballoon)"
        w%ival(isize) = ss%nballoon
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! nbi_src_name
        w%list_elems(isize) = "nbi_src_name"
        w%elem_descr(isize) = "number & name of neutral beams"
        w%component(isize) = "NBI"
        w%val_field(isize) = "(nbeam)"
        w%ival(isize) = ss%nbeam
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! circuit_name
        w%list_elems(isize) = "circuit_name"
        w%elem_descr(isize) = "Number & names of circuits"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(ncircuits)"
        w%ival(isize) = ss%ncircuits
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! coil_name
        w%list_elems(isize) = "coil_name"
        w%elem_descr(isize) = "Number & name of axisymmetric coils"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(ncoils)"
        w%ival(isize) = ss%ncoils
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! DeltaW_code
        w%list_elems(isize) = "DeltaW_code"
        w%elem_descr(isize) = "name(s) of delta(W) code(s) used"
        w%component(isize) = "LMHD"
        w%val_field(isize) = "(ndelta_w)"
        w%ival(isize) = ss%ndelta_w
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! ecrf_src_name
        w%list_elems(isize) = "ecrf_src_name"
        w%elem_descr(isize) = "number & name of ECRF sources"
        w%component(isize) = "EC"
        w%val_field(isize) = "(necrf_src)"
        w%ival(isize) = ss%necrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! eqmom_num
        w%list_elems(isize) = "eqmom_num"
        w%elem_descr(isize) = "Equilibrium moments"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(neqmom)"
        w%ival(isize) = ss%neqmom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! gs_name
        w%list_elems(isize) = "gs_name"
        w%elem_descr(isize) = "number & name of edge neutral gas sources"
        w%component(isize) = "GAS"
        w%val_field(isize) = "(ngsc0)"
        w%ival(isize) = ss%ngsc0
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! icrf_src_name
        w%list_elems(isize) = "icrf_src_name"
        w%elem_descr(isize) = "number & name of ICRF sources"
        w%component(isize) = "IC"
        w%val_field(isize) = "(nicrf_src)"
        w%ival(isize) = ss%nicrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! lhrf_src_name
        w%list_elems(isize) = "lhrf_src_name"
        w%elem_descr(isize) = "number & name of LHRF sources"
        w%component(isize) = "LH"
        w%val_field(isize) = "(nlhrf_src)"
        w%ival(isize) = ss%nlhrf_src
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! Newcomb_code
        w%list_elems(isize) = "Newcomb_code"
        w%elem_descr(isize) = "name(s) of Newcomb code(s) used"
        w%component(isize) = "LMHD"
        w%val_field(isize) = "(nnewcomb)"
        w%ival(isize) = ss%nnewcomb
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! psmom_num
        w%list_elems(isize) = "psmom_num"
        w%elem_descr(isize) = "Pfirsch-Schlutter moments"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(npsmom)"
        w%ival(isize) = ss%npsmom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! trcat
        w%list_elems(isize) = "trcat"
        w%elem_descr(isize) = "Application defined list of"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(ntrcat)"
        w%ival(isize) = ss%ntrcat
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_item_lists) THEN
        isize = isize + 1  ! xs_name
        w%list_elems(isize) = "xs_name"
        w%elem_descr(isize) = "number & name of impurity sources"
        w%component(isize) = "RAD"
        w%val_field(isize) = "(nxs)"
        w%ival(isize) = ss%nxs
     ENDIF
  ENDIF

  ! Grids

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! E_anom
        w%list_elems(isize) = "E_anom"
        w%elem_descr(isize) = "(optional) energy grid (1d profiles)"
        w%component(isize) = "ANOM"
        w%val_field(isize) = "(nefi_anom)"
        w%ival(isize) = ss%nefi_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! E_anom2
        w%list_elems(isize) = "E_anom2"
        w%elem_descr(isize) = "energy grid (2d anomalous transport profiles)"
        w%component(isize) = "ANOM"
        w%val_field(isize) = "(nefi_anom2)"
        w%ival(isize) = ss%nefi_anom2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! R_grid
        w%list_elems(isize) = "R_grid"
        w%elem_descr(isize) = "R grid"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(nr)"
        w%ival(isize) = ss%nr
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho
        w%list_elems(isize) = "rho"
        w%elem_descr(isize) = "rho grid (PLASMA)"
        w%component(isize) = "PLASMA"
        w%val_field(isize) = "(nrho)"
        w%ival(isize) = ss%nrho
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_anom
        w%list_elems(isize) = "rho_anom"
        w%elem_descr(isize) = "rho grid (1d anomalous transport profiles)"
        w%component(isize) = "ANOM"
        w%val_field(isize) = "(nrho_anom)"
        w%ival(isize) = ss%nrho_anom
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_anom2
        w%list_elems(isize) = "rho_anom2"
        w%elem_descr(isize) = "rho grid (2d anomalous transport profiles)"
        w%component(isize) = "ANOM"
        w%val_field(isize) = "(nrho_anom2)"
        w%ival(isize) = ss%nrho_anom2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_anomth
        w%list_elems(isize) = "rho_anomth"
        w%elem_descr(isize) = "rho grid (1d anomalous data for 1d"
        w%component(isize) = "ANOM"
        w%val_field(isize) = "(nrho_anomth)"
        w%ival(isize) = ss%nrho_anomth
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_ecrf
        w%list_elems(isize) = "rho_ecrf"
        w%elem_descr(isize) = "rho grid -- ECRF"
        w%component(isize) = "EC"
        w%val_field(isize) = "(nrho_ecrf)"
        w%ival(isize) = ss%nrho_ecrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_eq
        w%list_elems(isize) = "rho_eq"
        w%elem_descr(isize) = "rho grid (EQ)"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(nrho_eq)"
        w%ival(isize) = ss%nrho_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_eq_geo
        w%list_elems(isize) = "rho_eq_geo"
        w%elem_descr(isize) = "rho grid (EQ flux surface averages)"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(nrho_eq_geo)"
        w%ival(isize) = ss%nrho_eq_geo
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_fus
        w%list_elems(isize) = "rho_fus"
        w%elem_descr(isize) = "rho grid -- Fusion products model"
        w%component(isize) = "FUS"
        w%val_field(isize) = "(nrho_fus)"
        w%ival(isize) = ss%nrho_fus
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_gas
        w%list_elems(isize) = "rho_gas"
        w%elem_descr(isize) = "rho grid (GAS -- neutral gas model)"
        w%component(isize) = "GAS"
        w%val_field(isize) = "(nrho_gas)"
        w%ival(isize) = ss%nrho_gas
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_icrf
        w%list_elems(isize) = "rho_icrf"
        w%elem_descr(isize) = "rho grid (RF)"
        w%component(isize) = "IC"
        w%val_field(isize) = "(nrho_icrf)"
        w%ival(isize) = ss%nrho_icrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_lhrf
        w%list_elems(isize) = "rho_lhrf"
        w%elem_descr(isize) = "rho grid -- LHRF"
        w%component(isize) = "LH"
        w%val_field(isize) = "(nrho_lhrf)"
        w%ival(isize) = ss%nrho_lhrf
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_lmhd
        w%list_elems(isize) = "rho_lmhd"
        w%elem_descr(isize) = "rho grid (LMHD component)"
        w%component(isize) = "LMHD"
        w%val_field(isize) = "(nrho_lmhd)"
        w%ival(isize) = ss%nrho_lmhd
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_mist
        w%list_elems(isize) = "rho_mist"
        w%elem_descr(isize) = "rho grid (PLASMA) impurity-driven sources"
        w%component(isize) = "RAD"
        w%val_field(isize) = "(nrho_mist)"
        w%ival(isize) = ss%nrho_mist
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_nbi
        w%list_elems(isize) = "rho_nbi"
        w%elem_descr(isize) = "rho grid -- NBI"
        w%component(isize) = "NBI"
        w%val_field(isize) = "(nrho_nbi)"
        w%ival(isize) = ss%nrho_nbi
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PEL).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_pel
        w%list_elems(isize) = "rho_pel"
        w%elem_descr(isize) = "rho grid -- PEL"
        w%component(isize) = "PEL"
        w%val_field(isize) = "(nrho_pel)"
        w%ival(isize) = ss%nrho_pel
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_rad
        w%list_elems(isize) = "rho_rad"
        w%elem_descr(isize) = "rho grid (RAD)"
        w%component(isize) = "RAD"
        w%val_field(isize) = "(nrho_rad)"
        w%ival(isize) = ss%nrho_rad
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! rho_rw
        w%list_elems(isize) = "rho_rw"
        w%elem_descr(isize) = "rho grid -- RUNAWAY electrons"
        w%component(isize) = "RUNAWAY"
        w%val_field(isize) = "(nrho_rw)"
        w%ival(isize) = ss%nrho_rw
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! R_ripple
        w%list_elems(isize) = "R_ripple"
        w%elem_descr(isize) = "R grid for TF ripple field(s)"
        w%component(isize) = "RIPPLE"
        w%val_field(isize) = "(nr_rip)"
        w%ival(isize) = ss%nr_rip
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! th_eq
        w%list_elems(isize) = "th_eq"
        w%elem_descr(isize) = "theta grid (EQ)"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(nth_eq)"
        w%ival(isize) = ss%nth_eq
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! Z_grid
        w%list_elems(isize) = "Z_grid"
        w%elem_descr(isize) = "Z grid"
        w%component(isize) = "EQ"
        w%val_field(isize) = "(nz)"
        w%ival(isize) = ss%nz
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_grid_dims) THEN
        isize = isize + 1  ! Z_ripple
        w%list_elems(isize) = "Z_ripple"
        w%elem_descr(isize) = "Z grid for TF ripple field(s)"
        w%component(isize) = "RIPPLE"
        w%val_field(isize) = "(nz_rip)"
        w%ival(isize) = ss%nz_rip
     ENDIF
  ENDIF

  ! Machine Description

  CALL plasma_state_contents_mdescr(itype,icomponent,ss,w,isize)


  ! Shot Configuration

  CALL plasma_state_contents_sconfig(itype,icomponent,ss,w,isize)


  ! Simulation Init

  CALL plasma_state_contents_sini(itype,icomponent,ss,w,isize)


  ! State Data

  CALL plasma_state_contents_sdata(itype,icomponent,ss,w,isize)


  ! Profiles (split large file for faster compiling)

  CALL plasma_state_contents_profs_0(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_1(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_2(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_3(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_4(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_5(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_6(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_7(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_8(itype,icomponent,ss,w,isize)
  CALL plasma_state_contents_profs_9(itype,icomponent,ss,w,isize)


  ! Profile groups

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ANOM_DIFFUS
        w%list_elems(isize) = "ANOM_DIFFUS"
        w%elem_descr(isize) = "{difb_nbi,difb_fusi,difb_rfmi}"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%difb_rfmi)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ANOM_VELOC
        w%list_elems(isize) = "ANOM_VELOC"
        w%elem_descr(isize) = "{velb_nbi,velb_fusi,velb_rfmi}"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%velb_rfmi)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HALO_POWER
        w%list_elems(isize) = "BEAM_HALO_POWER"
        w%elem_descr(isize) = "{pb0_halo,psc_halo,pcx_halo}"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pcx_halo)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HALO_TORQUE
        w%list_elems(isize) = "BEAM_HALO_TORQUE"
        w%elem_descr(isize) = "{tqb0_halo,tqsc_halo,tqcx_halo}"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqcx_halo)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_HEATING
        w%list_elems(isize) = "BEAM_HEATING"
        w%elem_descr(isize) = "{pbe,pbi,pbth}"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%pbth)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BEAM_TORQUE
        w%list_elems(isize) = "BEAM_TORQUE"
        w%elem_descr(isize) = "{tqbe,tqbi,tqbjxb,tqbth}"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%tqbth)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BMINMAX
        w%list_elems(isize) = "BMINMAX"
        w%elem_descr(isize) = "{B_surfMax,B_surfMin}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%B_surfMin)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! COMPRESSION
        w%list_elems(isize) = "COMPRESSION"
        w%elem_descr(isize) = "{qcomp_e,qcomp_i}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qcomp_i)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! DIFFUSIVITY
        w%list_elems(isize) = "DIFFUSIVITY"
        w%elem_descr(isize) = "{chie_trans,chii_trans,chimo_trans}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%chimo_trans)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_BAXIS
        w%list_elems(isize) = "EQ_BAXIS"
        w%elem_descr(isize) = "{B_axis,B_axis_vac}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_BLCFS
        w%list_elems(isize) = "EQ_BLCFS"
        w%elem_descr(isize) = "{B_min_lcfs,B_max_lcfs}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_shot_config) THEN
        isize = isize + 1  ! EQ_BSIGNS
        w%list_elems(isize) = "EQ_BSIGNS"
        w%elem_descr(isize) = "{kccw_Bphi,kccw_Jphi}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_FILES
        w%list_elems(isize) = "EQ_FILES"
        w%elem_descr(isize) = "{eqdsk_file}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_RZAXIS
        w%list_elems(isize) = "EQ_RZAXIS"
        w%elem_descr(isize) = "{R_axis,Z_axis}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_machine_descr) THEN
        isize = isize + 1  ! EQ_RZBOX
        w%list_elems(isize) = "EQ_RZBOX"
        w%elem_descr(isize) = "{R_min_box,R_max_box,Z_min_box,Z_max_box}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! EQ_RZLCFS
        w%list_elems(isize) = "EQ_RZLCFS"
        w%elem_descr(isize) = "{R_min_lcfs,R_max_lcfs,Z_min_lcfs,Z_max_lcfs}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! FUSION_HEATING
        w%list_elems(isize) = "FUSION_HEATING"
        w%elem_descr(isize) = "{pfuse,pfusi,pfusth}"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_fus-1)"
        IF(ALLOCATED(ss%pfusth)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ICRF_CONTROLS
        w%list_elems(isize) = "ICRF_CONTROLS"
        w%elem_descr(isize) = "{kdens_rfmin}"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LMHD_FLAGS
        w%list_elems(isize) = "LMHD_FLAGS"
        w%elem_descr(isize) = "{MHD_eq_status,LMHD_status}"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LOCK_VARIABLES
        w%list_elems(isize) = "LOCK_VARIABLES"
        w%elem_descr(isize) = "{lock_machine_descr,lock_shot_config,lock_sim_init}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! LOWER_HYBRID_HEATING
        w%list_elems(isize) = "LOWER_HYBRID_HEATING"
        w%elem_descr(isize) = "{pelh,pilh}"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_lhrf-1)"
        IF(ALLOCATED(ss%pilh)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! MIDPLANE
        w%list_elems(isize) = "MIDPLANE"
        w%elem_descr(isize) = "{Z_midp,R_midp_in,R_midp_out}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%R_midp_out)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! MINORITY_HEATING
        w%list_elems(isize) = "MINORITY_HEATING"
        w%elem_descr(isize) = "{pmine,pmini,pminth}"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%pminth)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RADIAL_VELOCITY
        w%list_elems(isize) = "RADIAL_VELOCITY"
        w%elem_descr(isize) = "{vee_trans,vie_trans,vmo_trans}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%vmo_trans)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RADIATED_POWERS
        w%list_elems(isize) = "RADIATED_POWERS"
        w%elem_descr(isize) = "{prad,prad_cy,prad_br,prad_li}"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_rad-1)"
        IF(ALLOCATED(ss%prad_li)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RECO_POWER
        w%list_elems(isize) = "RECO_POWER"
        w%elem_descr(isize) = "{p0_reco,psc_reco,pcx_reco}"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%pcx_reco)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RECO_TORQUE
        w%list_elems(isize) = "RECO_TORQUE"
        w%elem_descr(isize) = "{tq0_reco,tqsc_reco,tqcx_reco}"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "Nt*m"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%tqcx_reco)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RESIDUAL
        w%list_elems(isize) = "RESIDUAL"
        w%elem_descr(isize) = "{res_te,res_ti}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Norm"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%res_ti)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! RHO_BDY_SOLVE
        w%list_elems(isize) = "RHO_BDY_SOLVE"
        w%elem_descr(isize) = "{rho_bdy_Te,rho_bdy_Ti,rho_bdy_omegat}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RIPPLE).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RIPPLE_FIELDS
        w%list_elems(isize) = "RIPPLE_FIELDS"
        w%elem_descr(isize) = "{tfrip_log,tfrip2_log}"
        w%component(isize) = "RIPPLE"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nr_rip,nz_rip)"
        IF(ALLOCATED(ss%tfrip2_log)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RMAJMIN
        w%list_elems(isize) = "RMAJMIN"
        w%elem_descr(isize) = "{Rmajor_mean,rMinor_mean}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%rMinor_mean)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ROTATION_DISSIPATION
        w%list_elems(isize) = "ROTATION_DISSIPATION"
        w%elem_descr(isize) = "{qrot_conv,qrot_diff}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qrot_diff)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! RZMINMAX
        w%list_elems(isize) = "RZMINMAX"
        w%elem_descr(isize) = "{R_surfMax,R_surfMin,Z_surfMax,Z_surfMin}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%Z_surfMin)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! SURFACE_VOLTAGE
        w%list_elems(isize) = "SURFACE_VOLTAGE"
        w%elem_descr(isize) = "{vsur}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Volts"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! SURFSHAPE
        w%list_elems(isize) = "SURFSHAPE"
        w%elem_descr(isize) = "{elong,triang,triangU,triangL,squareUO,squareLO}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%squareLO)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! TEMPERATURE_BCS
        w%list_elems(isize) = "TEMPERATURE_BCS"
        w%elem_descr(isize) = "{Te_bdy,Ti_bdy}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "KeV"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! TIME_RANGE
        w%list_elems(isize) = "TIME_RANGE"
        w%elem_descr(isize) = "{tinit,tfinal}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! TIME_STEP
        w%list_elems(isize) = "TIME_STEP"
        w%elem_descr(isize) = "{t0,t1}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! TRANSPORT
        w%list_elems(isize) = "TRANSPORT"
        w%elem_descr(isize) = "{pe_trans,pi_trans}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%pi_trans)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! TRIANG_MILLER
        w%list_elems(isize) = "TRIANG_MILLER"
        w%elem_descr(isize) = "{triang_miller_U,triang_miller_L}"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%triang_miller_L)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! UPWIND_FORWARD_FRACTIONS
        w%list_elems(isize) = "UPWIND_FORWARD_FRACTIONS"
        w%elem_descr(isize) = "{upwind_pfrac_Te,upwind_pfrac_Ti,upwind_pfrac_omega}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%upwind_pfrac_omega)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! ZEFF_GROUP
        w%list_elems(isize) = "ZEFF_GROUP"
        w%elem_descr(isize) = "{Zeff,Zeff_th,Zeff_fi}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%Zeff_fi)) THEN
           w%ival(isize) = 2
        ELSE
           w%ival(isize) = -2
        ENDIF
        w%val_field(isize) = "STEP*NS(:,PS_ELEC_INDEX)"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_sim_control) THEN
        isize = isize + 1  ! ZIMP_SA
        w%list_elems(isize) = "ZIMP_SA"
        w%elem_descr(isize) = "{Zimp1,Zimp2}"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        w%ival(isize) = 2
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_contents

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_5(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  indim = 0
  CALL define_var("ntf_coils","I",indim,idims, &
         "number of TF coils", &
         "__NONE","RIPPLE","MACHINE_DESCRIPTION", &
         "I ntf_coils")

  IF(ALLOCATED(ss%nthinlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("nthinlh","I",indim,idims, &
            "need description", &
            "__NONE","LH","SHOT_CONFIGURATION", &
            "I nthinlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Nturns)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Nturns","I",indim,idims, &
            "SIGNED number of conductor turns wrapped in each coil", &
            "__NONE","EQ","MACHINE_DESCRIPTION", &
            "I  Nturns(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("num_nphi","I",indim,idims, &
            "number of non-zero n_phi values", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "I|ENUM:nphi  num_nphi(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("num_nphi_vac","I",indim,idims, &
            "number of non-zero n_phi values", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "I|ENUM num_nphi_vac(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%nzflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("nzflux_ky_tglf","R",indim,idims, &
            "impurity density flux spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin nzflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%nz_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("nz_ky_tglf","R",indim,idims, &
            "impurity density fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin nz_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("n_straps","I",indim,idims, &
            "number of straps in the antenna", &
            "__NONE","IC","SHOT_CONFIGURATION", &
            "I|ENUM n_straps(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%omeg0cx)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("omeg0cx","R",indim,idims, &
            "effective neutral angular velocity for CX torque", &
            "rad/sec","GAS","STATE_PROFILES", &
            "R|step*tqqcx|units=rad/sec  omeg0cx(~nrho_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%omeg0sc0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("omeg0sc0","R",indim,idims, &
            "toroidal angular velocity", &
            "(rad/sec)","GAS","STATE_PROFILES", &
            "R|step*n0norm|units=(rad/sec)  omeg0sc0(~nrho_gas,nspec_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%omeg0_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("omeg0_halo","R",indim,idims, &
            "halo neutral toroidal angular velocity", &
            "rad/sec","NBI","STATE_PROFILES", &
            "R|units=rad/sec|step*n0_halo  omeg0_halo(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%omeg0_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("omeg0_reco","R",indim,idims, &
            "reco neutral toroidal angular velocity", &
            "rad/sec","GAS","STATE_PROFILES", &
            "R|units=rad/sec|step*n0_reco  omeg0_reco(~nrho_gas,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%omegat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("omegat","R",indim,idims, &
            "ion toroidal angular velocity", &
            "rad/sec","PLASMA","STATE_PROFILES", &
            "R|units=rad/sec|step*ni  omegat(~nrho)")
  ENDIF

  indim = 0
  CALL define_var("omegat_bdy","R",indim,idims, &
         "toroidal angular velocity at/beyond boundary", &
         "rad/sec","PLASMA","STATE_DATA", &
         "R|units=rad/sec  omegat_bdy")

  IF(ALLOCATED(ss%omega_exb)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("omega_exb","R",indim,idims, &
            "ExB flow shear rate", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin omega_exb(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%p0_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("p0_reco","R",indim,idims, &
            "power in recombination neutral source", &
            "W","GAS","STATE_PROFILES", &
            "R|step*dV   p0_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%pb0_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("pb0_halo","R",indim,idims, &
            "power in halo neutral source", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   pb0_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%pbe)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("pbe","R",indim,idims, &
            "electron heating by all beam ions", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   pbe(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%pbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("pbi","R",indim,idims, &
            "thermal ion heating by all beam ions", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   pbi(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%pbth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("pbth","R",indim,idims, &
            "thermalization of beam ions", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   pbth(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%pcx_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("pcx_halo","R",indim,idims, &
            "beam halo driven CX power", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   pcx_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%pcx_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("pcx_reco","R",indim,idims, &
            "reco driven CX power", &
            "W","GAS","STATE_PROFILES", &
            "R|step*dV   pcx_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%peech)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_ecrf",idims(indim))
     CALL define_var("peech","R",indim,idims, &
            "electron heating by ECH", &
            "W","EC","STATE_PROFILES", &
            "R|step*dV|units=W   peech(~nrho_ecrf)")
  ENDIF

  IF(ALLOCATED(ss%peech_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_ecrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("peech_src","R",indim,idims, &
            "ECH heating (by antenna)", &
            "W","EC","STATE_PROFILES", &
            "R|step*dV|units=W   peech_src(~nrho_ecrf,necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%pelh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     CALL define_var("pelh","R",indim,idims, &
            "electron heating by LH", &
            "W","LH","STATE_PROFILES", &
            "R|step*dV   pelh(~nrho_lhrf)")
  ENDIF

  IF(ALLOCATED(ss%pelh_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("pelh_src","R",indim,idims, &
            "LH electron heating by antenna", &
            "W","LH","STATE_PROFILES", &
            "R|step*dV|units=W   pelh_src(~nrho_lhrf,nlhrf_src)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("PEL_Code_Info","C*80",indim,idims, &
         "Information: code implementing PELLET component", &
         "__NONE","PEL","SIMULATION_INIT", &
         "C*80   PEL_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("PEL_Data_Info","C*80",indim,idims, &
         "Information: on source of pellet injection", &
         "__NONE","PEL","SIMULATION_INIT", &
         "C*80   PEL_Data_Info")

  IF(ALLOCATED(ss%pe_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     CALL define_var("pe_anom","R",indim,idims, &
            "anomalous electron heating", &
            "W","ANOM","STATE_PROFILES", &
            "R|units=W|step*dV  pe_anom(~nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%pe_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("pe_trans","R",indim,idims, &
            "electron transport (loss) power", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   pe_trans(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%pe_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("pe_transcat","R",indim,idims, &
            "electron transport", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV|units=W  pe_transcat(~nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%pfuse)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     CALL define_var("pfuse","R",indim,idims, &
            "electron heating by all fusion ions", &
            "W","FUS","STATE_PROFILES", &
            "R|step*dV   pfuse(~nrho_fus)")
  ENDIF

  IF(ALLOCATED(ss%pfusi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     CALL define_var("pfusi","R",indim,idims, &
            "thermal ion heating by all fusion ions", &
            "W","FUS","STATE_PROFILES", &
            "R|step*dV   pfusi(~nrho_fus)")
  ENDIF

  IF(ALLOCATED(ss%pfusth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_fus",idims(indim))
     CALL define_var("pfusth","R",indim,idims, &
            "thermalization of fusion ions", &
            "W","FUS","STATE_PROFILES", &
            "R|step*dV   pfusth(~nrho_fus)")
  ENDIF

  IF(ALLOCATED(ss%Phibsc)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Phibsc","R",indim,idims, &
            "toroidal location of beam source", &
            "degrees","NBI","MACHINE_DESCRIPTION", &
            "R|units=degrees       Phibsc(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%phiflux_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("phiflux_ky_tglf","R",indim,idims, &
            "momentum fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin phiflux_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%phigrilh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("phigrilh","R",indim,idims, &
            "need description", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- phigrilh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%phit)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("phit","R",indim,idims, &
            "toroidal flux vs. rho", &
            "Wb","EQ","STATE_PROFILES", &
            "R|units=Wb|Spline_00       phit(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("Phi_EC_launch","R",indim,idims, &
            "Phi of center of launcher", &
            "degrees","EC","MACHINE_DESCRIPTION", &
            "R|units=degrees  Phi_EC_launch(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%picrf_abs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("picrf_abs","R",indim,idims, &
            "RF power absorbed inside plasma", &
            "W","IC","STATE_DATA", &
            "R|units=W picrf_abs(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%picrf_ext)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("picrf_ext","R",indim,idims, &
            "RF power deposited outside plasma", &
            "W","IC","STATE_DATA", &
            "R|units=W picrf_ext(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%picrf_nphi_srcs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("picrf_nphi_srcs","R",indim,idims, &
            "direct ICRF power deposition", &
            "W","IC","STATE_PROFILES", &
            "R|units=W|alias=picrf_nphi_|step*dV   picrf_nphi_srcs(~nrho_icrf,num_nphi(),nicrf_src,0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%picrf_srcs)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("picrf_srcs","R",indim,idims, &
            "direct ICRF power deposition", &
            "W","IC","STATE_PROFILES", &
            "R|units=W|alias=picrfs_|step*dV   picrf_srcs(~nrho_icrf,nicrf_src,0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%picrf_totals)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("picrf_totals","R",indim,idims, &
            "direct ICRF power deposition", &
            "W","IC","STATE_PROFILES", &
            "R|units=W|alias=picrf_|step*dV    picrf_totals(~nrho_icrf,0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%picth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("picth","R",indim,idims, &
            "direct thermal ion heating by ICRF", &
            "W","IC","STATE_PROFILES", &
            "R|step*dV|units=W   picth(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%pilh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     CALL define_var("pilh","R",indim,idims, &
            "ion heating by LH", &
            "W","LH","STATE_PROFILES", &
            "R|step*dV   pilh(~nrho_lhrf)")
  ENDIF

  IF(ALLOCATED(ss%pilh_src)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_lhrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("pilh_src","R",indim,idims, &
            "LH ion heating by antenna", &
            "W","LH","STATE_PROFILES", &
            "R|step*dV|units=W   pilh_src(~nrho_lhrf,nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%pi_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_anomth",idims(indim))
     CALL define_var("pi_anom","R",indim,idims, &
            "anomalous ion heating", &
            "W","ANOM","STATE_PROFILES", &
            "R|units=W|step*dV  pi_anom(~nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%pi_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("pi_trans","R",indim,idims, &
            "ion transport (loss) power", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV   pi_trans(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%pi_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("pi_transcat","R",indim,idims, &
            "ion transport", &
            "W","PLASMA","STATE_PROFILES", &
            "R|step*dV|units=W  pi_transcat(~nrho,ntrcat)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("PLASMA_Code_Info","C*80",indim,idims, &
         "Information: code managing PLASMA component", &
         "__NONE","PLASMA","SIMULATION_INIT", &
         "C*80   PLASMA_Code_Info")

  IF(ALLOCATED(ss%pmine)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("pmine","R",indim,idims, &
            "electron heating by minority ions", &
            "W","IC","STATE_PROFILES", &
            "R|step*dV   pmine(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%pmini)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("pmini","R",indim,idims, &
            "thermal ion heating by minority ions", &
            "W","IC","STATE_PROFILES", &
            "R|step*dV   pmini(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%pminth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     CALL define_var("pminth","R",indim,idims, &
            "(de)thermalization of minority ions", &
            "W","IC","STATE_PROFILES", &
            "R|step*dV   pminth(~nrho_icrf)")
  ENDIF

  IF(ALLOCATED(ss%pohme)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho",idims(indim))
     CALL define_var("pohme","R",indim,idims, &
            "Ohmic heating of electrons", &
            "W","PLASMA","STATE_PROFILES", &
            "R|units=W|step*dV   pohme(~nrho)")
  ENDIF

  IF(ALLOCATED(ss%pot_ky_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("pot_ky_tglf","R",indim,idims, &
            "potential fluctuation spectrum", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin pot_ky_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%power_ec)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_necrf_src",idims(indim))
     CALL define_var("power_ec","R",indim,idims, &
            "power on each ECRF source", &
            "W","EC","STATE_DATA", &
            "R|units=W  power_ec(necrf_src)")
  ENDIF

  IF(ALLOCATED(ss%power_ic)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("power_ic","R",indim,idims, &
            "power on each ICRF source", &
            "W","IC","STATE_DATA", &
            "R|units=W  power_ic(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%power_lh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("power_lh","R",indim,idims, &
            "power on each LHRF source", &
            "W","LH","STATE_DATA", &
            "R|units=W  power_lh(nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%power_nbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("power_nbi","R",indim,idims, &
            "power on each beam source", &
            "W","NBI","STATE_DATA", &
            "R|units=W  power_nbi(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%power_nbi_trace)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("power_nbi_trace","R",indim,idims, &
            "power injected as trace element (if any)", &
            "W","NBI","STATE_DATA", &
            "R|units=W  power_nbi_trace(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%prad)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rad",idims(indim))
     CALL define_var("prad","R",indim,idims, &
            "total radiated power", &
            "W","RAD","STATE_PROFILES", &
            "R|step*dV  prad(~nrho_rad)")
  ENDIF

  IF(ALLOCATED(ss%prad_br)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rad",idims(indim))
     CALL define_var("prad_br","R",indim,idims, &
            "bremsstrahlung contribution", &
            "W","RAD","STATE_PROFILES", &
            "R|step*dV  prad_br(~nrho_rad)")
  ENDIF

  IF(ALLOCATED(ss%prad_cy)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rad",idims(indim))
     CALL define_var("prad_cy","R",indim,idims, &
            "cyclotron radiation contribution", &
            "W","RAD","STATE_PROFILES", &
            "R|step*dV  prad_cy(~nrho_rad)")
  ENDIF

  IF(ALLOCATED(ss%prad_li)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_rad",idims(indim))
     CALL define_var("prad_li","R",indim,idims, &
            "line radiation contribution", &
            "W","RAD","STATE_PROFILES", &
            "R|step*dV  prad_li(~nrho_rad)")
  ENDIF

  IF(ALLOCATED(ss%psc_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     CALL define_var("psc_halo","R",indim,idims, &
            "beam halo power: recapture - pb0_halo", &
            "W","NBI","STATE_PROFILES", &
            "R|step*dV   psc_halo(~nrho_nbi)")
  ENDIF

  IF(ALLOCATED(ss%psc_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     CALL define_var("psc_reco","R",indim,idims, &
            "reco power: recapture - p0_reco", &
            "W","GAS","STATE_PROFILES", &
            "R|step*dV   psc_reco(~nrho_gas)")
  ENDIF

  IF(ALLOCATED(ss%psipol)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("psipol","R",indim,idims, &
            "poloidal flux vs. rho", &
            "Wb/rad","EQ","STATE_PROFILES", &
            "R|units=Wb/rad|Spline_00   psipol(nrho_eq)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_5


SUBROUTINE plasma_state_store_5(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  status = nf90_inq_varid(icdf,"ntf_coils",varid)
  status = nf90_put_var(icdf,varid,ss%ntf_coils)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: ntf_coils"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%nthinlh)) THEN
     status = nf90_inq_varid(icdf,"nthinlh",varid)
     status = nf90_put_var(icdf,varid,ss%nthinlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nthinlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Nturns)) THEN
     status = nf90_inq_varid(icdf,"Nturns",varid)
     status = nf90_put_var(icdf,varid,ss%Nturns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Nturns"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     status = nf90_inq_varid(icdf,"num_nphi",varid)
     status = nf90_put_var(icdf,varid,ss%num_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: num_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     status = nf90_inq_varid(icdf,"num_nphi_vac",varid)
     status = nf90_put_var(icdf,varid,ss%num_nphi_vac)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: num_nphi_vac"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nzflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"nzflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%nzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nz_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"nz_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%nz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     status = nf90_inq_varid(icdf,"n_straps",varid)
     status = nf90_put_var(icdf,varid,ss%n_straps)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: n_straps"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0cx)) THEN
     status = nf90_inq_varid(icdf,"omeg0cx",varid)
     status = nf90_put_var(icdf,varid,ss%omeg0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omeg0cx"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0sc0)) THEN
     status = nf90_inq_varid(icdf,"omeg0sc0",varid)
     status = nf90_put_var(icdf,varid,ss%omeg0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omeg0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0_halo)) THEN
     status = nf90_inq_varid(icdf,"omeg0_halo",varid)
     status = nf90_put_var(icdf,varid,ss%omeg0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omeg0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0_reco)) THEN
     status = nf90_inq_varid(icdf,"omeg0_reco",varid)
     status = nf90_put_var(icdf,varid,ss%omeg0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omeg0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omegat)) THEN
     status = nf90_inq_varid(icdf,"omegat",varid)
     status = nf90_put_var(icdf,varid,ss%omegat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omegat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat_bdy",varid)
  status = nf90_put_var(icdf,varid,ss%omegat_bdy)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: omegat_bdy"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%omega_exb)) THEN
     status = nf90_inq_varid(icdf,"omega_exb",varid)
     status = nf90_put_var(icdf,varid,ss%omega_exb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: omega_exb"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%p0_reco)) THEN
     status = nf90_inq_varid(icdf,"p0_reco",varid)
     status = nf90_put_var(icdf,varid,ss%p0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: p0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pb0_halo)) THEN
     status = nf90_inq_varid(icdf,"pb0_halo",varid)
     status = nf90_put_var(icdf,varid,ss%pb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbe)) THEN
     status = nf90_inq_varid(icdf,"pbe",varid)
     status = nf90_put_var(icdf,varid,ss%pbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pbe"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbi)) THEN
     status = nf90_inq_varid(icdf,"pbi",varid)
     status = nf90_put_var(icdf,varid,ss%pbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbth)) THEN
     status = nf90_inq_varid(icdf,"pbth",varid)
     status = nf90_put_var(icdf,varid,ss%pbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pbth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pcx_halo)) THEN
     status = nf90_inq_varid(icdf,"pcx_halo",varid)
     status = nf90_put_var(icdf,varid,ss%pcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pcx_reco)) THEN
     status = nf90_inq_varid(icdf,"pcx_reco",varid)
     status = nf90_put_var(icdf,varid,ss%pcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%peech)) THEN
     status = nf90_inq_varid(icdf,"peech",varid)
     status = nf90_put_var(icdf,varid,ss%peech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: peech"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%peech_src)) THEN
     status = nf90_inq_varid(icdf,"peech_src",varid)
     status = nf90_put_var(icdf,varid,ss%peech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: peech_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pelh)) THEN
     status = nf90_inq_varid(icdf,"pelh",varid)
     status = nf90_put_var(icdf,varid,ss%pelh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pelh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pelh_src)) THEN
     status = nf90_inq_varid(icdf,"pelh_src",varid)
     status = nf90_put_var(icdf,varid,ss%pelh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pelh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%PEL_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: PEL_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%PEL_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: PEL_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%pe_anom)) THEN
     status = nf90_inq_varid(icdf,"pe_anom",varid)
     status = nf90_put_var(icdf,varid,ss%pe_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pe_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pe_trans)) THEN
     status = nf90_inq_varid(icdf,"pe_trans",varid)
     status = nf90_put_var(icdf,varid,ss%pe_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pe_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pe_transcat)) THEN
     status = nf90_inq_varid(icdf,"pe_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%pe_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pe_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfuse)) THEN
     status = nf90_inq_varid(icdf,"pfuse",varid)
     status = nf90_put_var(icdf,varid,ss%pfuse)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pfuse"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfusi)) THEN
     status = nf90_inq_varid(icdf,"pfusi",varid)
     status = nf90_put_var(icdf,varid,ss%pfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pfusi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfusth)) THEN
     status = nf90_inq_varid(icdf,"pfusth",varid)
     status = nf90_put_var(icdf,varid,ss%pfusth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pfusth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Phibsc)) THEN
     status = nf90_inq_varid(icdf,"Phibsc",varid)
     status = nf90_put_var(icdf,varid,ss%Phibsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Phibsc"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phiflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"phiflux_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%phiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: phiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phigrilh)) THEN
     status = nf90_inq_varid(icdf,"phigrilh",varid)
     status = nf90_put_var(icdf,varid,ss%phigrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: phigrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phit)) THEN
     status = nf90_inq_varid(icdf,"phit",varid)
     status = nf90_put_var(icdf,varid,ss%phit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: phit"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"Phi_EC_launch",varid)
     status = nf90_put_var(icdf,varid,ss%Phi_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Phi_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_abs)) THEN
     status = nf90_inq_varid(icdf,"picrf_abs",varid)
     status = nf90_put_var(icdf,varid,ss%picrf_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picrf_abs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_ext)) THEN
     status = nf90_inq_varid(icdf,"picrf_ext",varid)
     status = nf90_put_var(icdf,varid,ss%picrf_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picrf_ext"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_nphi_srcs)) THEN
     status = nf90_inq_varid(icdf,"picrf_nphi_srcs",varid)
     status = nf90_put_var(icdf,varid,ss%picrf_nphi_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picrf_nphi_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_srcs)) THEN
     status = nf90_inq_varid(icdf,"picrf_srcs",varid)
     status = nf90_put_var(icdf,varid,ss%picrf_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picrf_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_totals)) THEN
     status = nf90_inq_varid(icdf,"picrf_totals",varid)
     status = nf90_put_var(icdf,varid,ss%picrf_totals)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picrf_totals"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picth)) THEN
     status = nf90_inq_varid(icdf,"picth",varid)
     status = nf90_put_var(icdf,varid,ss%picth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: picth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pilh)) THEN
     status = nf90_inq_varid(icdf,"pilh",varid)
     status = nf90_put_var(icdf,varid,ss%pilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pilh_src)) THEN
     status = nf90_inq_varid(icdf,"pilh_src",varid)
     status = nf90_put_var(icdf,varid,ss%pilh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pilh_src"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_anom)) THEN
     status = nf90_inq_varid(icdf,"pi_anom",varid)
     status = nf90_put_var(icdf,varid,ss%pi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_trans)) THEN
     status = nf90_inq_varid(icdf,"pi_trans",varid)
     status = nf90_put_var(icdf,varid,ss%pi_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pi_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_transcat)) THEN
     status = nf90_inq_varid(icdf,"pi_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%pi_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pi_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PLASMA_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%PLASMA_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: PLASMA_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%pmine)) THEN
     status = nf90_inq_varid(icdf,"pmine",varid)
     status = nf90_put_var(icdf,varid,ss%pmine)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pmine"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pmini)) THEN
     status = nf90_inq_varid(icdf,"pmini",varid)
     status = nf90_put_var(icdf,varid,ss%pmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pmini"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pminth)) THEN
     status = nf90_inq_varid(icdf,"pminth",varid)
     status = nf90_put_var(icdf,varid,ss%pminth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pminth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pohme)) THEN
     status = nf90_inq_varid(icdf,"pohme",varid)
     status = nf90_put_var(icdf,varid,ss%pohme)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pohme"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pot_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"pot_ky_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%pot_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: pot_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_ec)) THEN
     status = nf90_inq_varid(icdf,"power_ec",varid)
     status = nf90_put_var(icdf,varid,ss%power_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: power_ec"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_ic)) THEN
     status = nf90_inq_varid(icdf,"power_ic",varid)
     status = nf90_put_var(icdf,varid,ss%power_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: power_ic"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_lh)) THEN
     status = nf90_inq_varid(icdf,"power_lh",varid)
     status = nf90_put_var(icdf,varid,ss%power_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: power_lh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_nbi)) THEN
     status = nf90_inq_varid(icdf,"power_nbi",varid)
     status = nf90_put_var(icdf,varid,ss%power_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: power_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_nbi_trace)) THEN
     status = nf90_inq_varid(icdf,"power_nbi_trace",varid)
     status = nf90_put_var(icdf,varid,ss%power_nbi_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: power_nbi_trace"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad)) THEN
     status = nf90_inq_varid(icdf,"prad",varid)
     status = nf90_put_var(icdf,varid,ss%prad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: prad"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_br)) THEN
     status = nf90_inq_varid(icdf,"prad_br",varid)
     status = nf90_put_var(icdf,varid,ss%prad_br)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: prad_br"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_cy)) THEN
     status = nf90_inq_varid(icdf,"prad_cy",varid)
     status = nf90_put_var(icdf,varid,ss%prad_cy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: prad_cy"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_li)) THEN
     status = nf90_inq_varid(icdf,"prad_li",varid)
     status = nf90_put_var(icdf,varid,ss%prad_li)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: prad_li"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psc_halo)) THEN
     status = nf90_inq_varid(icdf,"psc_halo",varid)
     status = nf90_put_var(icdf,varid,ss%psc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psc_reco)) THEN
     status = nf90_inq_varid(icdf,"psc_reco",varid)
     status = nf90_put_var(icdf,varid,ss%psc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psipol)) THEN
     status = nf90_inq_varid(icdf,"psipol",varid)
     status = nf90_put_var(icdf,varid,ss%psipol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: psipol"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_5

      logical function tdb_xyprof_present(d,zid)
 
      ! return TRUE if data for id (ZID) exits; otherwise FALSE
      ! no error or warning if ZID is not a known name
 
      use trdatbuf_obj
 
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
 
      character*(*), intent(in) :: zid  ! (3 letter) profile ID, e.g. "PSI"
      !---------------------------------------
      character*10 zidi
      !---------------------------------------
 
      zidi = zid
      call uupper(zidi)
 
      tdb_xyprof_present = .FALSE.
 
C=>TRDATGEN+LOGIC
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
      if(zidi.eq.'FD0') then
         tdb_xyprof_present = (d%LFFD0.gt.0)
      endif
 
      if(zidi.eq.'FDB') then
         tdb_xyprof_present = (d%LFFDB.gt.0)
      endif
 
      if(zidi.eq.'FDP') then
         tdb_xyprof_present = (d%LFFDP.gt.0)
      endif
 
      if(zidi.eq.'FDQ') then
         tdb_xyprof_present = (d%LFFDQ.gt.0)
      endif
 
      if(zidi.eq.'FDR') then
         tdb_xyprof_present = (d%LFFDR.gt.0)
      endif
 
      if(zidi.eq.'FDS') then
         tdb_xyprof_present = (d%LFFDS.gt.0)
      endif
 
      if(zidi.eq.'PSI') then
         tdb_xyprof_present = (d%LFPSI.gt.0)
      endif
 
C
C=>TRDATGEN-
 
      return
      end
 
C===========================================================================
      subroutine tdb_xysizes(d,zid,ztyp,inx,iny,ierr)
 
      !  find grid sizes in trdatbuf object (d) for profile (zid) of type
      !    ztyp='RZ' for f(R,Z); ztyp='Ex' for f(E,x).
 
      use trdatbuf_obj
 
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
 
      character*(*), intent(in) :: zid  ! (3 letter) profile ID, e.g. "PSI"
      character*(*), intent(in) :: ztyp ! (2 letter) profile type:
      !   "RZ" for f(R,Z); "Ex" for f(E,x); case blind comparison is used
 
      integer, intent(out) :: inx   ! size of first grid e.g. R if type f(R,Z)
      integer, intent(out) :: iny   ! size of 2nd grid e.g. Z if type f(R,Z)
 
      integer, intent(out) :: ierr  ! completion code (0=OK)
 
      !---------------------------------------
      ! local information:
 
      character*10 :: zidi
      character*3 :: ztypi
 
      integer :: nonlin,lunmsg_tdb,imatch
 
      !---------------------------------------
 
      nonlin = lunmsg_tdb(0)
 
      zidi = zid
      call uupper(zidi)
 
      ztypi = ztyp
      call uupper(ztypi)
 
      imatch = 0
 
c  set initial values for output variables...
 
      ierr=0
      inx=0
      iny=0
C
C=>TRDATGEN+NUM
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C  FD0
      if(zidi.eq.'FD0') then
         imatch=1
         if(d%LFFD0.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFD0
         iny = d%NXFD0
      endif
C  FDB
      if(zidi.eq.'FDB') then
         imatch=1
         if(d%LFFDB.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFDB
         iny = d%NXFDB
      endif
C  FDP
      if(zidi.eq.'FDP') then
         imatch=1
         if(d%LFFDP.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFDP
         iny = d%NXFDP
      endif
C  FDQ
      if(zidi.eq.'FDQ') then
         imatch=1
         if(d%LFFDQ.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFDQ
         iny = d%NXFDQ
      endif
C  FDR
      if(zidi.eq.'FDR') then
         imatch=1
         if(d%LFFDR.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFDR
         iny = d%NXFDR
      endif
C  FDS
      if(zidi.eq.'FDS') then
         imatch=1
         if(d%LFFDS.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         inx = d%NEFDS
         iny = d%NXFDS
      endif
C  PSI
      if(zidi.eq.'PSI') then
         imatch=1
         if(d%LFPSI.le.0) then
            write(nonlin,*) ' %tdb_xysizes: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'RZ') then
            write(nonlin,*) 'error in tdb_xysizes subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: RZ'
            ierr=1
            return
         endif
         inx = d%NRPSI
         iny = d%NZPSI
      endif
C
C=>TRDATGEN-
C
      if(imatch.eq.0) then
         write(nonlin,*) 'error in tdb_xysizes subroutine:'
         write(nonlin,*) ' ID '//trim(zidi)//' not recognized.'
         write(nonlin,*) ' ID of f(t,x,y) profile was expected.'
         ierr=2
      endif
 
      return
      end
 
C===========================================================================
      subroutine tdb_xygrids(d,zid,ztyp,x,inxi,inxgot,y,inyi,inygot,
     >     ierr)
 
      !  retrieve grids in trdatbuf object (d) for profile (zid) of type
      !    ztyp='RZ' for f(R,Z); ztyp='Ex' for f(E,x).
 
      use trdatbuf_obj
 
      implicit NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
 
      type (trdatbuf) :: d
 
      character*(*), intent(in) :: zid  ! (3 letter) profile ID, e.g. "PSI"
      character*(*), intent(in) :: ztyp ! (2 letter) profile type:
      !   "RZ" for f(R,Z); "Ex" for f(E,x); case blind comparison is used
 
      integer, intent(in) :: inxi   ! size of X array provided
      real*8, intent(out) :: x(inxi) ! X array
      integer, intent(out) :: inxgot ! number of values returned
 
      integer, intent(in) :: inyi   ! size of Y array provided
      real*8, intent(out) :: y(inyi) ! Y array
      integer, intent(out) :: inygot ! number of values returned
 
      integer, intent(out) :: ierr  ! completion code (0=OK)
 
      !---------------------------------------
      ! local information:
 
      character*10 :: zidi
      character*3 :: ztypi
 
      integer :: nonlin,lunmsg_tdb,imatch
      integer :: iloc1,iloc2
 
      !---------------------------------------
 
      nonlin = lunmsg_tdb(0)
 
      zidi = zid
      call uupper(zidi)
 
      ztypi = ztyp
      call uupper(ztypi)
 
      imatch = 0
 
c  set initial values for output variables...
 
      ierr=0
      inxgot=0
      inygot=0
c
      x=0.0d0
      y=0.0d0
C
C=>TRDATGEN+ARRAY
!
!    ******************************************
!    * TRDATGEN GENERATED CODE -- DO NOT EDIT *
!    ******************************************
!
!    code generation ends at C=>TRDATGEN- line
!
!
C  FD0
      if(zidi.eq.'FD0') then
         imatch=1
         if(d%LFFD0.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFD0) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFD0'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFD0
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFD0) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFD0'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFD0
            ierr=1
            return
         endif
         iloc1 = d%LEFD0
         inxgot = d%NEFD0
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFD0
         inygot = d%NXFD0
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  FDB
      if(zidi.eq.'FDB') then
         imatch=1
         if(d%LFFDB.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFDB) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFDB'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFDB
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFDB) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFDB'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFDB
            ierr=1
            return
         endif
         iloc1 = d%LEFDB
         inxgot = d%NEFDB
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFDB
         inygot = d%NXFDB
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  FDP
      if(zidi.eq.'FDP') then
         imatch=1
         if(d%LFFDP.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFDP) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFDP'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFDP
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFDP) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFDP'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFDP
            ierr=1
            return
         endif
         iloc1 = d%LEFDP
         inxgot = d%NEFDP
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFDP
         inygot = d%NXFDP
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  FDQ
      if(zidi.eq.'FDQ') then
         imatch=1
         if(d%LFFDQ.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFDQ) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFDQ'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFDQ
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFDQ) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFDQ'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFDQ
            ierr=1
            return
         endif
         iloc1 = d%LEFDQ
         inxgot = d%NEFDQ
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFDQ
         inygot = d%NXFDQ
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  FDR
      if(zidi.eq.'FDR') then
         imatch=1
         if(d%LFFDR.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFDR) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFDR'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFDR
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFDR) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFDR'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFDR
            ierr=1
            return
         endif
         iloc1 = d%LEFDR
         inxgot = d%NEFDR
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFDR
         inygot = d%NXFDR
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  FDS
      if(zidi.eq.'FDS') then
         imatch=1
         if(d%LFFDS.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'EX') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: Ex'
            ierr=1
            return
         endif
         if(inxi.lt.d%NEFDS) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NEFDS'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NEFDS
            ierr=1
            return
         endif
         if(inyi.lt.d%NXFDS) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NXFDS'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NXFDS
            ierr=1
            return
         endif
         iloc1 = d%LEFDS
         inxgot = d%NEFDS
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LXFDS
         inygot = d%NXFDS
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C  PSI
      if(zidi.eq.'PSI') then
         imatch=1
         if(d%LFPSI.le.0) then
            write(nonlin,*) ' %tdb_xygrids: no '//trim(zidi)//' data.'
            return
         endif
         if(ztypi.ne.'RZ') then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' value of ztyp argument: ',ztyp
            write(nonlin,*) ' for ',zidi,' profile expected: RZ'
            ierr=1
            return
         endif
         if(inxi.lt.d%NRPSI) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' x array size too small for: NRPSI'
            write(nonlin,*) ' got: ',inxi,' need: ',d%NRPSI
            ierr=1
            return
         endif
         if(inyi.lt.d%NZPSI) then
            write(nonlin,*) 'error in tdb_xygrids subroutine:'
            write(nonlin,*) ' y array size too small for: NZPSI'
            write(nonlin,*) ' got: ',inyi,' need: ',d%NZPSI
            ierr=1
            return
         endif
         iloc1 = d%LRPSI
         inxgot = d%NRPSI
         iloc2 = iloc1 + inxgot - 1
         x(1:inxgot) = d%datbuf(iloc1:iloc2)
         iloc1 = d%LZPSI
         inygot = d%NZPSI
         iloc2 = iloc1 + inygot - 1
         y(1:inygot) = d%datbuf(iloc1:iloc2)
      endif
C
C=>TRDATGEN-
C
      if(imatch.eq.0) then
         write(nonlin,*) 'error in tdb_xygrids subroutine:'
         write(nonlin,*) ' ID '//trim(zidi)//' not recognized.'
         write(nonlin,*) ' ID of f(t,x,y) profile was expected.'
         ierr=2
      endif
 
      return
      end
 

subroutine ps_rhotmp(iobj,nrho,rho,itmp,id,iout,ierr)

  !------------------------------------------------------------
  ! create a temporary rho grid
  ! use ps_freetmp(id,iout) to remove it when done
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: nrho     ! rho grid size
  REAL(KIND=rspec), intent(in) :: rho(nrho)   ! the grid values

  integer, intent(in) :: itmp     ! number to use for temporary name generation
  !  if multiple temporary grids are created, differing values of itmp are
  !  needed to separate them (i.e. give them different names in xplasma).
  !    abs(itmp) is used.

  integer, intent(out) :: id      ! ID returned (0 if error occurs)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  !  local:
  integer :: iertmp,jtmp
  character*32 :: tmpname
  character*32, parameter :: authname = "PS_XPLASMA2"
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  id = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_rhotmp: invalid or unitialized xplasma object.'
     return
  endif

  tmpname = ' '
  jtmp=abs(itmp)
  write(tmpname,'("__TMPRHO_",i5.5)') jtmp

  call xplasma_author_set(s,authname,iertmp)
  
  call xplasma_create_grid(s,tmpname,xplasma_rho_coord,rho,id,ierr)

  call xplasma_author_clear(s,authname,iertmp)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rhotmp: xplasma error creating temporary rho grid:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_rhotmp

C-----------------------------------------------------------------------
C  UFSCAD  ADD/DELETE/MODIFY SCALARS IN A UFILES FILE
C
      SUBROUTINE UFSCAD(ILUN,ISHOT,NSCMAX,NSC,SCVAL,SCLAB,
     >    IORDER,ILUNC)
C
      LOGICAL, EXTERNAL :: LCHAR,LXOUT,LYES,LYESC
C
      REAL SCVAL(NSCMAX)    ! SCALAR VALUES
      INTEGER IORDER(NSCMAX)   ! ORDERING WORKSPACE FOR UFSCLK
      CHARACTER*10 SCLAB(3,NSCMAX)  ! SCALAR LABELS
C
      CHARACTER*10 ZKEY,ZLBL,ZUNS
C
C  SEE SUBROUTINE UFSCLK -- WHERE MOST OF THESE ARGUMENTS ARE USED
C  AND EXPLAINED
C
C  NSCMAX = MAX NO. OF SCALARS
C  NSC = CURRENT ACTUAL NO. OF SCALARS
C
C  MENU
C
 10   CONTINUE
      CALL NEUPAG
 11   CONTINUE
      IF(LXOUT(0)) WRITE(LNOUT(0),1001) NSC
 1001 FORMAT(/' UFSCAD OPTIONS:'/
     >  ' A -- ADD A SCALAR (VALUE, LABEL WILL BE REQUESTED)'/
     >  ' D -- DELETE A SCALAR   [CURRENT NO. OF SCALARS = ',I3,' ]'/
     >  ' M -- DISPLAY AND/OR MODIFY VALUES OF SCALARS'/
     >  ' Q -- QUIT (EXIT THIS ROUTINE)'/)
C
      CALL UREAD('UFSCAD:  ENTER OPTION CODE:$$')
C
      IF(LCHAR('A')) THEN
C  ADD A SCALAR
C
        IF(NSC.EQ.NSCMAX) THEN
          CALL UERMSI('UFSCAD:  SCALAR LIST IS FULL',NSCMAX,0)
          GO TO 11
        ENDIF
C
        CALL UFGKEY(ZKEY)
        ISC=0
        IF(NSC.GT.0) ISC=IUFKEY(ZKEY,SCLAB,NSC)
        IF(ISC.GT.0) THEN
          CALL UERMSG('UFSCAD:  SCALAR ALREADY EXISTS',ZKEY,0)
          GO TO 11
        ENDIF
C
        ZVAL=0.0
        CALL UREADF('UFSCAD:  ENTER VALUE OF NEW SCALAR:$$',ZVAL)
        ZLBL='DUMMY'
        CALL UREADL('UFSCAD:  ENTER 10 CHAR LABEL FOR SCALAR:$$',ZLBL)
        ZUNS='NONE'
        CALL UREADW('UFSCAD:  ENTER 10 CHAR UNITS FOR SCALAR:$$',ZUNS)
C
        NSC=NSC+1
        SCVAL(NSC)=ZVAL
        SCLAB(1,NSC)=ZKEY
        SCLAB(2,NSC)=ZLBL
        SCLAB(3,NSC)=ZUNS
C
        WRITE(ILUNC,7000) SCLAB(1,NSC),ZVAL
 7000   FORMAT(1X,'*** SCALAR "',A10,'" = ',1PE11.4,' ADDED TO LIST')
C
      ELSE IF(LCHAR('D')) THEN
C  DELETE A SCALAR
C
        IF(NSC.GT.0) THEN
          CALL UFGKEY(ZKEY)
          ISC=IUFKEY(ZKEY,SCLAB,NSC)
          IF(ISC.EQ.0) THEN
            CALL UERMSG('UFSCAD:  NO SUCH SCALAR',ZKEY,0)
            GO TO 11
          ELSE
C
            WRITE(ILUNC,7001) SCLAB(1,ISC)
 7001       FORMAT(1X,'*** SCALAR "',A10,'" DELETED FROM LIST')
            DO 50 I=ISC+1,NSC
              IM1=I-1
      	SCVAL(IM1)=SCVAL(I)
      	SCLAB(1,IM1)=SCLAB(1,I)
      	SCLAB(2,IM1)=SCLAB(2,I)
      	SCLAB(3,IM1)=SCLAB(3,I)
 50         CONTINUE
            NSC=NSC-1
          ENDIF
        ELSE
          CALL UERMSG('UFSCAD:  THE SCALAR LIST IS EMPTY',' ',0)
          GO TO 11
        ENDIF
C
      ELSE IF(LCHAR('M')) THEN
C  DISPLAY/MODIFY SCALARS
C
        IF(NSC.GT.0) THEN
          CALL UFSCLK(ILUN,ISHOT,NSC,SCVAL,SCLAB,IORDER,1,ILUNC)
        ELSE
          CALL UERMSG('UFSCAD:  THE SCALAR LIST IS EMPTY',' ',0)
          GO TO 11
        ENDIF
C
      ELSE IF(LCHAR('Q')) THEN
C  EXIT
        RETURN
C
      ELSE
        CALL UERMSG('UFSCAD:  ILLEGAL OPCODE',' ',0)
        GO TO 11
      ENDIF
C
      GO TO 10
C
      END

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_0(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%alla_index)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("alla_index","I",indim,idims, &
            "species index in original lists", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I alla_index(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%ALLA_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("ALLA_name","N",indim,idims, &
            "all species abridged", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|specie  ALLA(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%ALLA_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("ALLA_type","I",indim,idims, &
            "ALLA specie types", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|specie  ALLA(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%all_index)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("all_index","I",indim,idims, &
            "species index in original lists", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "I all_index(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%ALL_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("ALL_name","N",indim,idims, &
            "all species", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|specie  ALL(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%ALL_type)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("ALL_type","I",indim,idims, &
            "ALL specie types", &
            "__NONE","PLASMA","SIMULATION_INIT", &
            "S|specie  ALL(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%amaxlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("amaxlh","R",indim,idims, &
            "width of the spectrum peak", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- amaxlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%aminlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("aminlh","R",indim,idims, &
            "parallel mode number, center of the spectrum peak", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- aminlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Ang_Href_coil","R",indim,idims, &
            "angle w.r.t. horizontal of coil base", &
            "degrees","EQ","MACHINE_DESCRIPTION", &
            "R|units=degrees Ang_Href_coil(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Ang_Vref_coil","R",indim,idims, &
            "angle w.r.t. vertical of coil sides", &
            "degrees","EQ","MACHINE_DESCRIPTION", &
            "R|units=degrees Ang_Vref_coil(ncoils)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("ANOM_Code_Info","C*80",indim,idims, &
         "Information: code implementing ANOM component", &
         "__NONE","ANOM","SIMULATION_INIT", &
         "C*80   ANOM_Code_Info")

  IF(ALLOCATED(ss%anom_evar)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom",idims(indim))
     CALL define_var("anom_evar","R",indim,idims, &
            "anomalous transport energy variation", &
            "-","ANOM","STATE_PROFILES", &
            "R|pclin|units=- anom_evar(nefi_anom)")
  ENDIF

  IF(ALLOCATED(ss%ant_model)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_256",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("ant_model","F",indim,idims, &
            "antenna model filenames (1 per antenna source)", &
            "__NONE","IC","MACHINE_DESCRIPTION", &
            "F ant_model(nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap2_halfheight","R",indim,idims, &
            "aperture half-height", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap2_halfheight(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap2_halfwidth","R",indim,idims, &
            "2nd aperture half-width", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap2_halfwidth(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap2_horiz_offset","R",indim,idims, &
            "horizontal offset, 2nd aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap2_horiz_offset(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap2_vert_offset","R",indim,idims, &
            "vertical offset, 2nd aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap2_vert_offset(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%apolmaxlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("apolmaxlh","R",indim,idims, &
            "poloidal mode number right of lumps", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- apolmaxlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%apolminlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("apolminlh","R",indim,idims, &
            "poloidal mode number left of lumps", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- apolminlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%ap_halfheight)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap_halfheight","R",indim,idims, &
            "aperture half-height", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap_halfheight(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap_halfwidth","R",indim,idims, &
            "aperture half-width", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap_halfwidth(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap_horiz_offset","R",indim,idims, &
            "horizontal offset of aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap_horiz_offset(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("ap_vert_offset","R",indim,idims, &
            "vertical offset of aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m         ap_vert_offset(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%area)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("area","R",indim,idims, &
            "enclosed area", &
            "m^2","EQ","STATE_PROFILES", &
            "R|units=m^2|Spline_00 area(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%atormaxlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("atormaxlh","R",indim,idims, &
            "toroidal mode number right of lumps", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- atormaxlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%atorminlh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("atorminlh","R",indim,idims, &
            "toroidal mode number left of lumps", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- atorminlh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Balloon_code)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Balloon_code","N",indim,idims, &
            "name(s) of Ballooning code(s) used", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "L|Balloon_codes  Balloon_code(nballoon)")
  ENDIF

  IF(ALLOCATED(ss%Balloon_mapper)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Balloon_mapper","N",indim,idims, &
            "mapper code used for each ballooning code", &
            "__NONE","LMHD","SIMULATION_INIT", &
            "N  Balloon_mapper(nballoon)")
  ENDIF

  IF(ALLOCATED(ss%Balloon_stable)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Balloon_stable","I",indim,idims, &
            "0: stable everywhere; =1: unstable somewhere", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Balloon_stable(nballoon)")
  ENDIF

  IF(ALLOCATED(ss%Balloon_status)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Balloon_status","I",indim,idims, &
            "completion status: Ballooning codes", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Balloon_status(nballoon)")
  ENDIF

  IF(ALLOCATED(ss%balstab)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_lmhd",idims(indim))
     CALL define_var("balstab","R",indim,idims, &
            "Ballooning/Mercier stability indicator", &
            "-","LMHD","STATE_PROFILES", &
            "R|units=-|pclin balstab(nrho_lmhd)")
  ENDIF

  IF(ALLOCATED(ss%beam_type)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("beam_type","N",indim,idims, &
            "beam type:", &
            "__NONE","NBI","MACHINE_DESCRIPTION", &
            "N     beam_type(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_co)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_bpass_co","R",indim,idims, &
            "beam ion diffusivity: co barely passing orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_bpass_co(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_ctr)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_bpass_ctr","R",indim,idims, &
            "beam ion diffusivity: ctr barely passing orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_bpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_btrap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_btrap","R",indim,idims, &
            "beam ion diffusivity: barely trapped orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_btrap(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_co)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_dpass_co","R",indim,idims, &
            "beam ion diffusivity: co passing |vpll/v| -> 1", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_dpass_co(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_ctr)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_dpass_ctr","R",indim,idims, &
            "beam ion diffusivity: ctr passing |vpll/v| -> 1", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_dpass_ctr(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%bidiff_dtrap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nefi_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anom2",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("bidiff_dtrap","R",indim,idims, &
            "beam ion diffusivity: deeply trapped orbits", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  bidiff_dtrap(nefi_anom2,nrho_anom2,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%BphiRZ)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz",idims(indim))
     CALL define_var("BphiRZ","R",indim,idims, &
            "Toroidal field", &
            "T","EQ","STATE_PROFILES", &
            "R|units=T|Hermite      BphiRZ(nR,nZ)")
  ENDIF

  IF(ALLOCATED(ss%BRRZ)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz",idims(indim))
     CALL define_var("BRRZ","R",indim,idims, &
            "R component of poloidal field", &
            "T","EQ","STATE_PROFILES", &
            "R|units=T|Hermite      BRRZ(nR,nZ)")
  ENDIF

  IF(ALLOCATED(ss%BZRZ)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nr",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nz",idims(indim))
     CALL define_var("BZRZ","R",indim,idims, &
            "Z component of poloidal field", &
            "T","EQ","STATE_PROFILES", &
            "R|units=T|Hermite      BZRZ(nR,nZ)")
  ENDIF

  indim = 0
  CALL define_var("B_axis","R",indim,idims, &
         "|B| at magnetic axis", &
         "T","EQ","STATE_DATA", &
         "R  B_axis")

  indim = 0
  CALL define_var("B_axis_vac","R",indim,idims, &
         "vacuum B field at axis", &
         "T","EQ","STATE_DATA", &
         "R  B_axis_vac")

  IF(ALLOCATED(ss%b_halfHeight)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_halfHeight","R",indim,idims, &
            "beam half-height at source", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       b_halfHeight(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%b_halfwidth)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_halfwidth","R",indim,idims, &
            "beam half-width at source", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       b_halfwidth(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_Hdivergence","R",indim,idims, &
            "horizontal divergence (D) of beam", &
            "degrees","NBI","MACHINE_DESCRIPTION", &
            "R|units=degrees   b_Hdivergence(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_Hfocal_length","R",indim,idims, &
            "horizontal focal length", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       b_Hfocal_length(nbeam)")
  ENDIF

  indim = 0
  CALL define_var("B_max_lcfs","R",indim,idims, &
         "|B|_max of last closed flux surface", &
         "T","EQ","STATE_DATA", &
         "R  B_max_lcfs")

  indim = 0
  CALL define_var("B_min_lcfs","R",indim,idims, &
         "|B|_min of last closed flux surface", &
         "T","EQ","STATE_DATA", &
         "R  B_min_lcfs")

  IF(ALLOCATED(ss%B_surfMax)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("B_surfMax","R",indim,idims, &
            "max mod(B) on flux surface", &
            "T","EQ","STATE_PROFILES", &
            "R|pclin  B_surfMax(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%B_surfMin)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("B_surfMin","R",indim,idims, &
            "min mod(B) on flux surface", &
            "T","EQ","STATE_PROFILES", &
            "R|pclin  B_surfMin(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_Vdivergence","R",indim,idims, &
            "vertical divergence (D) of beam", &
            "degrees","NBI","MACHINE_DESCRIPTION", &
            "R|units=degrees   b_Vdivergence(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("b_Vfocal_length","R",indim,idims, &
            "vertical focal length", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       b_Vfocal_length(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%cdicrf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("cdicrf","R",indim,idims, &
            "ICRF current drive", &
            "A","IC","STATE_PROFILES", &
            "R|units=A|step*dA   cdicrf(~nrho_icrf,nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%cdicrf_nphi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_icrf",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("cdicrf_nphi","R",indim,idims, &
            "ICRF current drive", &
            "A","IC","STATE_PROFILES", &
            "R|units=A|step*dA   cdicrf_nphi(~nrho_icrf,num_nphi(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%chie_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_anom","R",indim,idims, &
            "Te-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chie_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_drbm","R",indim,idims, &
            "Te-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chie_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_etg)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_etg","R",indim,idims, &
            "Te-equation, diffusivity term ETG model", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chie_etg(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_glf","R",indim,idims, &
            "Te-equation, diffusivity from GLF23 model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_gtcneo","R",indim,idims, &
            "Te-equation, neoclassical diffusivity from GTC_NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_gtcneo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_mmm71","R",indim,idims, &
            "Te-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chie_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_mtm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_mtm","R",indim,idims, &
            "Te-equation, thermal diffusivity term MTM model", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chie_mtm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_nclass","R",indim,idims, &
            "Te-equation, neoclassical diffusivity from NCLASS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_neo","R",indim,idims, &
            "Te-equation, neoclassical diffusivity from NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_neo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_ntm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_ntm","R",indim,idims, &
            "Te-equation, neoclassical diffusivity from NTM model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_ntm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_paleo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_paleo","R",indim,idims, &
            "Te-equation, diffusivity term PALEO model", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chie_paleo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_tglf","R",indim,idims, &
            "Te-equation, diffusivity from TGLF model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chie_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chie_trans)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("chie_trans","R",indim,idims, &
            "electron thermal diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|pclin chie_trans(nrho)")
  ENDIF

  IF(ALLOCATED(ss%chie_transcat)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ntrcat",idims(indim))
     CALL define_var("chie_transcat","R",indim,idims, &
            "Electron energy diffusivity", &
            "m^2/sec","PLASMA","STATE_PROFILES", &
            "R|units=m^2/sec|pclin chie_transcat(nrho,ntrcat)")
  ENDIF

  IF(ALLOCATED(ss%chie_w19)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chie_w19","R",indim,idims, &
            "Te-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chie_w19(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_anom)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_anom","R",indim,idims, &
            "Ti-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chii_anom(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_drbm","R",indim,idims, &
            "Ti-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chii_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_glf","R",indim,idims, &
            "Ti-equation, diffusivity from GLF23 model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_gtcneo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_gtcneo","R",indim,idims, &
            "Ti-equation, neoclassical diffusivity from GTC_NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_gtcneo(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_mmm71","R",indim,idims, &
            "Ti-equation, diffusivity term", &
            "m^2/sec","ANOM","STATE_PROFILES", &
            "R|units=m^2/sec|pclin  chii_mmm71(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_nclass)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_nclass","R",indim,idims, &
            "Ti-equation, neoclassical diffusivity from NCALSS model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_nclass(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%chii_neo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("chii_neo","R",indim,idims, &
            "Ti-equation, neoclassical diffusivity from NEO model", &
            "m^2/s","ANOM","STATE_PROFILES", &
            "R|units=m^2/s|pclin chii_neo(nrho_anomth)")
  ENDIF

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_0


SUBROUTINE plasma_state_store_0(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%alla_index)) THEN
     status = nf90_inq_varid(icdf,"alla_index",varid)
     status = nf90_put_var(icdf,varid,ss%alla_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: alla_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALLA_name)) THEN
     status = nf90_inq_varid(icdf,"ALLA_name",varid)
     status = nf90_put_var(icdf,varid,ss%ALLA_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ALLA_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALLA_type)) THEN
     status = nf90_inq_varid(icdf,"ALLA_type",varid)
     status = nf90_put_var(icdf,varid,ss%ALLA_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ALLA_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%all_index)) THEN
     status = nf90_inq_varid(icdf,"all_index",varid)
     status = nf90_put_var(icdf,varid,ss%all_index)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: all_index"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALL_name)) THEN
     status = nf90_inq_varid(icdf,"ALL_name",varid)
     status = nf90_put_var(icdf,varid,ss%ALL_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ALL_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ALL_type)) THEN
     status = nf90_inq_varid(icdf,"ALL_type",varid)
     status = nf90_put_var(icdf,varid,ss%ALL_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ALL_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%amaxlh)) THEN
     status = nf90_inq_varid(icdf,"amaxlh",varid)
     status = nf90_put_var(icdf,varid,ss%amaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: amaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%aminlh)) THEN
     status = nf90_inq_varid(icdf,"aminlh",varid)
     status = nf90_put_var(icdf,varid,ss%aminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: aminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     status = nf90_inq_varid(icdf,"Ang_Href_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Ang_Href_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Ang_Href_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     status = nf90_inq_varid(icdf,"Ang_Vref_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Ang_Vref_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Ang_Vref_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ANOM_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%ANOM_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: ANOM_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%anom_evar)) THEN
     status = nf90_inq_varid(icdf,"anom_evar",varid)
     status = nf90_put_var(icdf,varid,ss%anom_evar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: anom_evar"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ant_model)) THEN
     status = nf90_inq_varid(icdf,"ant_model",varid)
     status = nf90_put_var(icdf,varid,ss%ant_model)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ant_model"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     status = nf90_inq_varid(icdf,"ap2_halfheight",varid)
     status = nf90_put_var(icdf,varid,ss%ap2_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap2_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"ap2_halfwidth",varid)
     status = nf90_put_var(icdf,varid,ss%ap2_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap2_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     status = nf90_inq_varid(icdf,"ap2_horiz_offset",varid)
     status = nf90_put_var(icdf,varid,ss%ap2_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap2_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     status = nf90_inq_varid(icdf,"ap2_vert_offset",varid)
     status = nf90_put_var(icdf,varid,ss%ap2_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap2_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%apolmaxlh)) THEN
     status = nf90_inq_varid(icdf,"apolmaxlh",varid)
     status = nf90_put_var(icdf,varid,ss%apolmaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: apolmaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%apolminlh)) THEN
     status = nf90_inq_varid(icdf,"apolminlh",varid)
     status = nf90_put_var(icdf,varid,ss%apolminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: apolminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_halfheight)) THEN
     status = nf90_inq_varid(icdf,"ap_halfheight",varid)
     status = nf90_put_var(icdf,varid,ss%ap_halfheight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap_halfheight"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"ap_halfwidth",varid)
     status = nf90_put_var(icdf,varid,ss%ap_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     status = nf90_inq_varid(icdf,"ap_horiz_offset",varid)
     status = nf90_put_var(icdf,varid,ss%ap_horiz_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap_horiz_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     status = nf90_inq_varid(icdf,"ap_vert_offset",varid)
     status = nf90_put_var(icdf,varid,ss%ap_vert_offset)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: ap_vert_offset"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%area)) THEN
     status = nf90_inq_varid(icdf,"area",varid)
     status = nf90_put_var(icdf,varid,ss%area)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: area"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%atormaxlh)) THEN
     status = nf90_inq_varid(icdf,"atormaxlh",varid)
     status = nf90_put_var(icdf,varid,ss%atormaxlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: atormaxlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%atorminlh)) THEN
     status = nf90_inq_varid(icdf,"atorminlh",varid)
     status = nf90_put_var(icdf,varid,ss%atorminlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: atorminlh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_code)) THEN
     status = nf90_inq_varid(icdf,"Balloon_code",varid)
     status = nf90_put_var(icdf,varid,ss%Balloon_code)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Balloon_code"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_mapper)) THEN
     status = nf90_inq_varid(icdf,"Balloon_mapper",varid)
     status = nf90_put_var(icdf,varid,ss%Balloon_mapper)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Balloon_mapper"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_stable)) THEN
     status = nf90_inq_varid(icdf,"Balloon_stable",varid)
     status = nf90_put_var(icdf,varid,ss%Balloon_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Balloon_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Balloon_status)) THEN
     status = nf90_inq_varid(icdf,"Balloon_status",varid)
     status = nf90_put_var(icdf,varid,ss%Balloon_status)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Balloon_status"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%balstab)) THEN
     status = nf90_inq_varid(icdf,"balstab",varid)
     status = nf90_put_var(icdf,varid,ss%balstab)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: balstab"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%beam_type)) THEN
     status = nf90_inq_varid(icdf,"beam_type",varid)
     status = nf90_put_var(icdf,varid,ss%beam_type)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: beam_type"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_co)) THEN
     status = nf90_inq_varid(icdf,"bidiff_bpass_co",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_bpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_bpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_bpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"bidiff_bpass_ctr",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_bpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_bpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_btrap)) THEN
     status = nf90_inq_varid(icdf,"bidiff_btrap",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_btrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_btrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_co)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dpass_co",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_dpass_co)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_dpass_co"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dpass_ctr",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_dpass_ctr)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_dpass_ctr"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%bidiff_dtrap)) THEN
     status = nf90_inq_varid(icdf,"bidiff_dtrap",varid)
     status = nf90_put_var(icdf,varid,ss%bidiff_dtrap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: bidiff_dtrap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BphiRZ)) THEN
     status = nf90_inq_varid(icdf,"BphiRZ",varid)
     status = nf90_put_var(icdf,varid,ss%BphiRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: BphiRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BRRZ)) THEN
     status = nf90_inq_varid(icdf,"BRRZ",varid)
     status = nf90_put_var(icdf,varid,ss%BRRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: BRRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%BZRZ)) THEN
     status = nf90_inq_varid(icdf,"BZRZ",varid)
     status = nf90_put_var(icdf,varid,ss%BZRZ)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: BZRZ"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis",varid)
  status = nf90_put_var(icdf,varid,ss%B_axis)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: B_axis"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"B_axis_vac",varid)
  status = nf90_put_var(icdf,varid,ss%B_axis_vac)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: B_axis_vac"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%b_halfHeight)) THEN
     status = nf90_inq_varid(icdf,"b_halfHeight",varid)
     status = nf90_put_var(icdf,varid,ss%b_halfHeight)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_halfHeight"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_halfwidth)) THEN
     status = nf90_inq_varid(icdf,"b_halfwidth",varid)
     status = nf90_put_var(icdf,varid,ss%b_halfwidth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_halfwidth"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     status = nf90_inq_varid(icdf,"b_Hdivergence",varid)
     status = nf90_put_var(icdf,varid,ss%b_Hdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_Hdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     status = nf90_inq_varid(icdf,"b_Hfocal_length",varid)
     status = nf90_put_var(icdf,varid,ss%b_Hfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_Hfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"B_max_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%B_max_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: B_max_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"B_min_lcfs",varid)
  status = nf90_put_var(icdf,varid,ss%B_min_lcfs)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: B_min_lcfs"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%B_surfMax)) THEN
     status = nf90_inq_varid(icdf,"B_surfMax",varid)
     status = nf90_put_var(icdf,varid,ss%B_surfMax)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: B_surfMax"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%B_surfMin)) THEN
     status = nf90_inq_varid(icdf,"B_surfMin",varid)
     status = nf90_put_var(icdf,varid,ss%B_surfMin)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: B_surfMin"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     status = nf90_inq_varid(icdf,"b_Vdivergence",varid)
     status = nf90_put_var(icdf,varid,ss%b_Vdivergence)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_Vdivergence"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     status = nf90_inq_varid(icdf,"b_Vfocal_length",varid)
     status = nf90_put_var(icdf,varid,ss%b_Vfocal_length)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: b_Vfocal_length"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%cdicrf)) THEN
     status = nf90_inq_varid(icdf,"cdicrf",varid)
     status = nf90_put_var(icdf,varid,ss%cdicrf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: cdicrf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%cdicrf_nphi)) THEN
     status = nf90_inq_varid(icdf,"cdicrf_nphi",varid)
     status = nf90_put_var(icdf,varid,ss%cdicrf_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: cdicrf_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_anom)) THEN
     status = nf90_inq_varid(icdf,"chie_anom",varid)
     status = nf90_put_var(icdf,varid,ss%chie_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_drbm)) THEN
     status = nf90_inq_varid(icdf,"chie_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%chie_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_etg)) THEN
     status = nf90_inq_varid(icdf,"chie_etg",varid)
     status = nf90_put_var(icdf,varid,ss%chie_etg)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_etg"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_glf)) THEN
     status = nf90_inq_varid(icdf,"chie_glf",varid)
     status = nf90_put_var(icdf,varid,ss%chie_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chie_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%chie_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chie_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%chie_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_mtm)) THEN
     status = nf90_inq_varid(icdf,"chie_mtm",varid)
     status = nf90_put_var(icdf,varid,ss%chie_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_nclass)) THEN
     status = nf90_inq_varid(icdf,"chie_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%chie_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_neo)) THEN
     status = nf90_inq_varid(icdf,"chie_neo",varid)
     status = nf90_put_var(icdf,varid,ss%chie_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_ntm)) THEN
     status = nf90_inq_varid(icdf,"chie_ntm",varid)
     status = nf90_put_var(icdf,varid,ss%chie_ntm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_ntm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_paleo)) THEN
     status = nf90_inq_varid(icdf,"chie_paleo",varid)
     status = nf90_put_var(icdf,varid,ss%chie_paleo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_paleo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_tglf)) THEN
     status = nf90_inq_varid(icdf,"chie_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%chie_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_trans)) THEN
     status = nf90_inq_varid(icdf,"chie_trans",varid)
     status = nf90_put_var(icdf,varid,ss%chie_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_trans"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_transcat)) THEN
     status = nf90_inq_varid(icdf,"chie_transcat",varid)
     status = nf90_put_var(icdf,varid,ss%chie_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chie_w19)) THEN
     status = nf90_inq_varid(icdf,"chie_w19",varid)
     status = nf90_put_var(icdf,varid,ss%chie_w19)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chie_w19"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_anom)) THEN
     status = nf90_inq_varid(icdf,"chii_anom",varid)
     status = nf90_put_var(icdf,varid,ss%chii_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_anom"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_drbm)) THEN
     status = nf90_inq_varid(icdf,"chii_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%chii_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_glf)) THEN
     status = nf90_inq_varid(icdf,"chii_glf",varid)
     status = nf90_put_var(icdf,varid,ss%chii_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chii_gtcneo",varid)
     status = nf90_put_var(icdf,varid,ss%chii_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chii_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%chii_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_nclass)) THEN
     status = nf90_inq_varid(icdf,"chii_nclass",varid)
     status = nf90_put_var(icdf,varid,ss%chii_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_neo)) THEN
     status = nf90_inq_varid(icdf,"chii_neo",varid)
     status = nf90_put_var(icdf,varid,ss%chii_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: chii_neo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_0

      integer function idcod_splitn(zint,ierr)
C
C  decode an integer -- splitn subroutine
C
C  input:
C
      character*(*) zint                !character string containing integer
C
C  output:
C
      integer ierr                      !exit code, 0=OK
C
C     function value:  the value of the integer.
C
      character*10 zintbuf
C-----------------------------
C
      ierr=1
      idcod_splitn=0
C
      ilen=len(zint)
C
C  first nonblank:
C
      do ic=1,ilen
         if((zint(ic:ic).ne.' ').and.(zint(ic:ic).ne.char(9))) go to 10
      enddo
C
C  all blank (this is an error)
C
      return
C
 10   continue
      ic1=ic
C
C  last nonblank
C
      do ic=ilen,1,-1
         if((zint(ic:ic).ne.' ').and.(zint(ic:ic).ne.char(9))) go to 20
      enddo
C
 20   continue
      ic2=ic
C
C  OK try to read as a number
C
      ilc=ic2-ic1+1
      if(ilc.gt.len(zintbuf)) return    ! error:  field too long
C
      ia=len(zintbuf)-ilc+1
      zintbuf=' '
      zintbuf(ia:ia+ilc-1)=zint(ic1:ic2)
C
      read(zintbuf,'(I10)',err=90) ians
      go to 100
C
C  error
C
 90   continue
      return
C
C  OK
C
 100  continue
      ierr=0
      idcod_splitn=ians
      return
      end

subroutine wr_trdatbuf(nonlin, d, zserver, ztree, zshot, ztok, iyear, ishot, ier)
  Use trdatbuf_module
  Use trdatbuf_intmod

  implicit none


  integer :: ishot       ! mds+ shot
  integer :: ier         ! error flag
  integer :: isocket     ! from conopn
  integer :: iyear       ! two digit year
  integer :: nonlin      ! lun for error messages
  integer :: ilen        !  size of datbuf
  integer :: iparams(3)     !  sizes of MDSplus arrays

  character*80  :: zshot    ! runid
  character*120 :: zserver  ! mds+ server
  character*80  :: ztree    ! mds+ tree
  character*20  :: ztok     ! tokamak
  character*10  :: zyear    ! year of shot
  character*10  :: zpulse   ! pulse string
  character*80  :: zerr     ! error string
  character*40  :: zchild   ! temp
  character*1   :: bcks

  integer :: stat

  Type (trdatbuf) :: d

  call mds_conopn(nonlin, zserver, ztree, zshot, ztok, iyear, ishot, isocket, 4, ier)
  if (ier/=0) then
     write(nonlin,'(/a)')     '?trdatbuf_tomds: error opening the tree'
     goto 999
  else
!     write(*,*) ' mds_conopn successful'
  end if

! 10/11/05 CLF: don't delete
!   call tcldelete(nonlin,ier)  ! delete .TRBUFDATA node

  !
  ! ------------- start processing -----------------
  !
  !
  ! ------------- build .TRBUFDATA child ---------------
  ! Create .TRBUFDATA child
  !
  zchild = '.TRBUFDATA'
  call trnode_child(nonlin, zchild, ier)
  if (ier/=0) goto 990
!  write(*,*) ' trnode_child2 successful'

!
! write DATBUF real data

  ILEN = d%LFREE - 1
  call wr_doublearr(nonlin, zchild, 'DATBUF', d%datbuf, ILEN, ier)
  if (ier/=0) goto 990
!  write(*,*) ' wr_doublearr successful '

  call intmod_init
  call fill_intbuf(d)
!
! write IVARSIZE integer data
  call wr_longarr(nonlin, zchild, 'IVARSIZE', ivarsize, nivar, ier)
  if (ier/=0) goto 990
!  write(*,*) ' wr_longarr successful '

!
! write IVARNAME character data
  call wr_cstringarr(nonlin, zchild, 'IVARNAME', ivarname, nivar, ier)
  if (ier/=0) goto 990
!  write(*,*) ' wr_cstringarr successful '
!
! write INTBUF integer data
  ilen2=size(intbuf)
  call wr_longarr(nonlin, zchild, 'INTBUF', intbuf, ilen2, ier)
  if (ier/=0) goto 990
!  write(*,*) ' wr_longarr successful '

  iparams = (/nivar, ilen, ilen2/)
!  write(*,*) "iparams=",iparams
!
! write PARAMS integer data
  call wr_longarr(nonlin, zchild, 'PARAMS', iparams, 3, ier)
  if (ier/=0) goto 990
!  write(*,*) ' wr_longarr successful '


  call tclwrite(nonlin, ier)                 ; if (ier/=0) goto 990
  call tree_close(nonlin, ishot, ztree, ier) ; if (ier/=0) goto 990
!  write(*,*) "tree_close2 OK"

990 continue
  call MdsCacheDisconnect
  stat=0
999 continue


  return
end subroutine wr_trdatbuf

c------------------------------------------------------------
      subroutine trxpl_mkgs2_write1(luno,is)
c
c  write the species namelists -- one at a time
c
      use trxpl_gs2_module
      implicit NONE
c
      integer luno                      ! output LUN of open file
      integer is                        ! specie index
c
c-----------------------------
c
      integer i,k
c
      character*30 znlist
      character*5 zint
c
c-----------------------------
c
      znlist=nlist_root
      i=len_trim(znlist)+1
c
c  form namelist name
c
      write(zint,'(I5)') is
      do k=1,len(zint)
         if(zint(k:k).ne.' ') exit
      enddo
      znlist(i:)=zint(k:len(zint))
      k=len_trim(znlist)
c
c  write specie namelist
c
      write(luno,1012) slabel(is),dx_smooth_n(is),dx_smooth_t(is),
     >   znlist(1:k)
      write(luno,1013) zvec_lbl,zvec(is)
      write(luno,1013) avec_lbl,avec(is)
      write(luno,1013) nvec_lbl,nvec(is)
      write(luno,1013) tvec_lbl,tvec(is)
      write(luno,1013) tpvec_lbl,tpvec(is)
      write(luno,1013) npvec_lbl,npvec(is)
      write(luno,1013) upvec_lbl,upvec(is)
      write(luno,1013) nuvec_lbl,nuvec(is)
c
      if(ltype(is).eq.0) then
         write(luno,1014)
      else
         write(luno,1015)
      endif
c
      return
c
 1012 format(/'!_trxpl: ',a,' dx_smooth_n=',f6.3,
     >   ' dx_smooth_t=',f6.3//'&',a)
cxx 1012 format(/'!_trxpl: ',a//'&',a)
 1013 format(' ',a,1pe19.12,'  !_trxpl')
 1014 format(" type='electron'  !_trxpl"/"/")
 1015 format(" type='ion'  !_trxpl"/"/")
c
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_1(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_nclass
        w%list_elems(isize) = "chii_nclass"
        w%elem_descr(isize) = "Ti-equation, neoclassical diffusivity from NCALSS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_nclass)) THEN
           IF(ss%hash_codes(ps_phash_chii_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_neo
        w%list_elems(isize) = "chii_neo"
        w%elem_descr(isize) = "Ti-equation, neoclassical diffusivity from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_neo)) THEN
           IF(ss%hash_codes(ps_phash_chii_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_ntm
        w%list_elems(isize) = "chii_ntm"
        w%elem_descr(isize) = "Ti-equation, neoclassical diffusivity from NTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_ntm)) THEN
           IF(ss%hash_codes(ps_phash_chii_ntm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_tglf
        w%list_elems(isize) = "chii_tglf"
        w%elem_descr(isize) = "Ti-equation, diffusivity from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_tglf)) THEN
           IF(ss%hash_codes(ps_phash_chii_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_trans
        w%list_elems(isize) = "chii_trans"
        w%elem_descr(isize) = "ion thermal diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%chii_trans)) THEN
           IF(ss%hash_codes(ps_phash_chii_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_transcat
        w%list_elems(isize) = "chii_transcat"
        w%elem_descr(isize) = "Ion energy diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%chii_transcat)) THEN
           IF(ss%hash_codes(ps_phash_chii_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_w19
        w%list_elems(isize) = "chii_w19"
        w%elem_descr(isize) = "Ti-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_w19)) THEN
           IF(ss%hash_codes(ps_phash_chii_w19).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chimo_trans
        w%list_elems(isize) = "chimo_trans"
        w%elem_descr(isize) = "angular momentum diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%chimo_trans)) THEN
           IF(ss%hash_codes(ps_phash_chimo_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chimo_transcat
        w%list_elems(isize) = "chimo_transcat"
        w%elem_descr(isize) = "Angular momentum diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%chimo_transcat)) THEN
           IF(ss%hash_codes(ps_phash_chimo_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_anom
        w%list_elems(isize) = "chiphi_anom"
        w%elem_descr(isize) = "momentum-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_anom)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_drbm
        w%list_elems(isize) = "chiphi_drbm"
        w%elem_descr(isize) = "momentum-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_drbm)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_glf
        w%list_elems(isize) = "chiphi_glf"
        w%elem_descr(isize) = "momentum-equation, diffusivity from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_glf)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_gtcneo
        w%list_elems(isize) = "chiphi_gtcneo"
        w%elem_descr(isize) = "momentum-equation, neoclassical diffusivity from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_mmm71
        w%list_elems(isize) = "chiphi_mmm71"
        w%elem_descr(isize) = "momentum-equation, diffusivity term, toroidal"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_neo
        w%list_elems(isize) = "chiphi_neo"
        w%elem_descr(isize) = "momentum-equation, neoclassical diffusivity from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_neo)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_tglf
        w%list_elems(isize) = "chiphi_tglf"
        w%elem_descr(isize) = "momentum-equation, diffusivity from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_tglf)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chiphi_w19
        w%list_elems(isize) = "chiphi_w19"
        w%elem_descr(isize) = "momentum-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chiphi_w19)) THEN
           IF(ss%hash_codes(ps_phash_chiphi_w19).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chitheta_mmm71
        w%list_elems(isize) = "chitheta_mmm71"
        w%elem_descr(isize) = "momentum-equation, diffusivity term, poloidal"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chitheta_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_chitheta_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curbeam
        w%list_elems(isize) = "curbeam"
        w%elem_descr(isize) = "beam ion driven current (shielded)"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%curbeam)) THEN
           IF(ss%hash_codes(ps_phash_curbeam).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curech
        w%list_elems(isize) = "curech"
        w%elem_descr(isize) = "ECH current drive"
        w%component(isize) = "EC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_ecrf-1)"
        IF(ALLOCATED(ss%curech)) THEN
           IF(ss%hash_codes(ps_phash_curech).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curech_src
        w%list_elems(isize) = "curech_src"
        w%elem_descr(isize) = "ECH current drive (by antenna)"
        w%component(isize) = "EC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_ecrf-1,necrf_src)"
        IF(ALLOCATED(ss%curech_src)) THEN
           IF(ss%hash_codes(ps_phash_curech_src).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curfusn
        w%list_elems(isize) = "curfusn"
        w%elem_descr(isize) = "fusion ion driven current (shielded)"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_fus-1)"
        IF(ALLOCATED(ss%curfusn)) THEN
           IF(ss%hash_codes(ps_phash_curfusn).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curich
        w%list_elems(isize) = "curich"
        w%elem_descr(isize) = "total driven current (all IC srcs)"
        w%component(isize) = "IC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%curich)) THEN
           IF(ss%hash_codes(ps_phash_curich).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curlh
        w%list_elems(isize) = "curlh"
        w%elem_descr(isize) = "LH current drive"
        w%component(isize) = "LH"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_lhrf-1)"
        IF(ALLOCATED(ss%curlh)) THEN
           IF(ss%hash_codes(ps_phash_curlh).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curlh_src
        w%list_elems(isize) = "curlh_src"
        w%elem_descr(isize) = "LH current drive (by antenna)"
        w%component(isize) = "LH"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_lhrf-1,nlhrf_src)"
        IF(ALLOCATED(ss%curlh_src)) THEN
           IF(ss%hash_codes(ps_phash_curlh_src).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curmino
        w%list_elems(isize) = "curmino"
        w%elem_descr(isize) = "minority ion driven cur (shielded)."
        w%component(isize) = "IC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_icrf-1)"
        IF(ALLOCATED(ss%curmino)) THEN
           IF(ss%hash_codes(ps_phash_curmino).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curr_bootstrap
        w%list_elems(isize) = "curr_bootstrap"
        w%elem_descr(isize) = "Neoclassical bootstrap current"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%curr_bootstrap)) THEN
           IF(ss%hash_codes(ps_phash_curr_bootstrap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curr_ohmic
        w%list_elems(isize) = "curr_ohmic"
        w%elem_descr(isize) = "Ohmic current"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%curr_ohmic)) THEN
           IF(ss%hash_codes(ps_phash_curr_ohmic).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! curt
        w%list_elems(isize) = "curt"
        w%elem_descr(isize) = "total enclosed toroidal current"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%curt)) THEN
           IF(ss%hash_codes(ps_phash_curt).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cur_rw
        w%list_elems(isize) = "cur_rw"
        w%elem_descr(isize) = "current carried by fast electrons"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_rw-1)"
        IF(ALLOCATED(ss%cur_rw)) THEN
           IF(ss%hash_codes(ps_phash_cur_rw).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! db_mtm
        w%list_elems(isize) = "db_mtm"
        w%elem_descr(isize) = "dB/B from MTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%db_mtm)) THEN
           IF(ss%hash_codes(ps_phash_db_mtm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RUNAWAY).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! dcur_rw_dVloop
        w%list_elems(isize) = "dcur_rw_dVloop"
        w%elem_descr(isize) = "sensitivity to loop volts"
        w%component(isize) = "RUNAWAY"
        w%elem_units(isize) = "A/Volt"
        w%c256val(isize) = "(nrho_rw-1)"
        IF(ALLOCATED(ss%dcur_rw_dVloop)) THEN
           IF(ss%hash_codes(ps_phash_dcur_rw_dVloop).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_fusi
        w%list_elems(isize) = "difb_fusi"
        w%elem_descr(isize) = "fusion ion anomalous diffusivity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%difb_fusi)) THEN
           IF(ss%hash_codes(ps_phash_difb_fusi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_nbi
        w%list_elems(isize) = "difb_nbi"
        w%elem_descr(isize) = "beam ion anomalous diffusivity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%difb_nbi)) THEN
           IF(ss%hash_codes(ps_phash_difb_nbi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! difb_rfmi
        w%list_elems(isize) = "difb_rfmi"
        w%elem_descr(isize) = "RF minority ion anomalous diffusivity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anom)"
        IF(ALLOCATED(ss%difb_rfmi)) THEN
           IF(ss%hash_codes(ps_phash_difb_rfmi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! diff_trans
        w%list_elems(isize) = "diff_trans"
        w%elem_descr(isize) = "specie ptcl diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho,0:nspec_th)"
        IF(ALLOCATED(ss%diff_trans)) THEN
           IF(ss%hash_codes(ps_phash_diff_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_1

subroutine trxpl_gs2_file(zlbl,zpath0,zpath,zfile)

  implicit NONE

  character*(*), intent(in) :: zlbl   ! label for file being asked about
  character*(*), intent(inout) :: zpath0  ! untranslated path
  character*(*), intent(inout) :: zpath   ! translated path
  character*(*), intent(out) :: zfile ! full filename

  integer ilz,ilp,ipre
  integer ilpre,ilsuf
  integer lnout
  character*120 zcwd
  logical lxout

  !--------------------------------

  ilz=len_trim(zlbl)

  if(lxout(0)) then
     if(zpath0.ne.' ') then
        ilp=len_trim(zpath)
        write(lnout(0),*) 'current path setting: ',zpath(1:ilp)
     else
        write(lnout(0),*) 'current path setting: current working directory.'
     endif
     write(lnout(0),*) 'enter "P" to set directory path first.'
     write(lnout(0),*) 'otherwise enter filename:'
  endif

  if(zlbl(1:8).eq.'TEMPLATE') then
     zfile(1:)='template.dat'
  else if(zlbl(1:6).eq.'OUTPUT') then
     call trxpl_gs2_oname(zfile)
  else
     zfile(1:)='file.dat'
  endif

  do
     call unixfile(zlbl,zfile)
     if(zfile.eq.'P') then
        call trxpl_gs2_path(zlbl,zpath0,zpath)
     else
        exit
     endif
  enddo

  if(len_trim(zfile).gt.1) then
     !  assume real filename.  prepend path, unless overridden.
     ipre=0
     if((zfile(1:1).ne.'/').and.(zfile(1:1).ne.'~')) ipre=1
     if(ipre.eq.1) then
        if(zpath.eq.' ') then
           zcwd=' '
           call sget_cwd(zcwd)
        else
           zcwd=zpath
        endif
        ilp=len_trim(zcwd)
        if(zcwd(ilp:ilp).ne.'/') then
           ilp=ilp+1
           zcwd(ilp:ilp)='/'
        endif
        ilz=len_trim(zfile)
        zfile = zcwd(1:ilp)//zfile(1:ilz)
     endif
  endif

end subroutine trxpl_gs2_file

subroutine trx_tlims(stime,ftime,ierr)
 
  use trx_module
  implicit NONE
 
!
!  return the start time and stop time, seconds, of the current run.
!  return ierr.ne.0 if no run is connected.
!
  real*8, intent(out) :: stime      ! start time of run (seconds)
  real*8, intent(out) :: ftime      ! stop time of run (seconds)
!
  integer ierr                      ! completion code, 0=OK
!
!----------------------------------
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
  integer lunzer
!----------------------------------
!
  stime=0.0_R8
  ftime=0.0_R8
!
  if(nsurf.eq.0) then
     write(lunzer(0),*) ' ?trx_tlims: nsurf=0:  use trx_connect first!'
     ierr=1
     return
  endif
!
  ierr=0
  stime=tmin
  ftime=tmax
!
  return
end subroutine trx_tlims

subroutine trx_getnlims(ncirlm,nlinlm,ierr)
!
!  read TRANSP namelist to get NLINLM (# of line limiters)
!                   and to get NCIRLM (# of circle limiters)
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer ncirlm,nlinlm   ! TRANSP limiter counts
  integer ierr            ! completion code:  0 = OK
!
!  *caution* ncirlm=0 and/or nlinlm=0 is possible
!----------------------------------------------------
!
  ierr=0
  call tr_getnl_intvec('NLINLM',nlinlm,1,istat)
  if(istat.eq.0) then
     nlinlm=0
  else if(istat.eq.1) then
     if(nlinlm.lt.0) ierr=ierr+1
  else
     ierr=ierr+1
  endif
!
  call tr_getnl_intvec('NCIRLM',ncirlm,1,istat)
  if(istat.eq.0) then
     ncirlm=0
  else if(istat.eq.1) then
     if(ncirlm.lt.0) ierr=ierr+1
  else
     ierr=ierr+1
  endif
!
  return
  end

subroutine trx_wr_protimes(ppath,ierr)

  ! write file of profile output times -- 1st record = #of times
  ! subsequently, one time per record

  ! use data recorded in module -- report error if none is found

  use trx_module
  use trxplib_ps_options
  implicit NONE

  character*(*), intent(in) :: ppath
  integer, intent(out) :: ierr

  !------------------------------------------
  character*30 :: prev_file
  integer :: it,inum,ilun
  integer :: lunzer
  !------------------------------------------

  ierr=0
  if(.not.allocated(time_pr)) then
     write(lunzer(0),*) &
          ' ?trx_wr_protimes: no profile time data; connect to run first.'
     ierr=1
     return
  endif

  inum=nprtime

  call find_io_unit(ilun)

  open(unit=ilun,file=trim(ppath),status='unknown',iostat=ierr)
  if(ierr.ne.0) then
     write(lunzer(0),*) &
          ' ?trx_wr_protimes: open failure, filename was: '//trim(ppath)
     return
  endif

  write(ilun, &
       '(1x,i5,"  ! #profile (1x,i5) // times (1x,1pe13.6) one per line")') &
       inum

  prev_file = ' '
  do it=1,nprtime
     call trx_wr_encode_r4(ilun,time_pr(it),ps_prefix,prev_file)
  enddo

  close(unit=ilun)

end subroutine trx_wr_protimes

subroutine trx_wr_encode_r4(ilun,ztime,zprefix,prev_file)

  ! write protimes.dat or sawtimes.dat lines;
  ! append filename substring

  ! in output record, character positions(1:20) : 1x,1pe13.6
  ! in output record, character positions(20:)  : filename piece

  ! time argument in R4

  implicit NONE

  integer, intent(in) :: ilun
  real, intent(in) :: ztime
  character*(*), intent(in) :: zprefix
  character*(*), intent(inout) :: prev_file

  !----------------------------------
  ! LOCAL:
  character*20 time_encod
  character*30 file_encod,wk
  character*10 zint,zmant
  character*1 char1
  integer :: ic,id,ii,ilen,iexp,idot,inb
  integer :: jexp
  !----------------------------------

  if(zprefix.eq.' ') then
     write(ilun,'(1x,1pe13.6)') ztime
     return
  endif

  time_encod=' '
  write(time_encod,'(1x,1pe13.6)') ztime
  file_encod = time_encod

  ilen = len(trim(file_encod))

  ! find exponent character

  do ic=ilen,1,-1
     char1 = file_encod(ic:ic)
     if((char1.eq.'e').OR.(char1.eq.'E').OR. &
          (char1.eq.'d').OR.(char1.eq.'D')) then
        iexp=ic
        exit
     endif
  enddo
  zint = file_encod(iexp+1:)
  zint = adjustR(zint)
  read(zint,'(I10)') jexp

  if((jexp.gt.6).or.(jexp.lt.-2)) then
     ! preserve scientific notation in filename piece
     wk = file_encod
     do ic=1,ilen
        char1 = wk(ic:ic)
        if(char1.eq.'-') then
           wk(ic:ic)='m'
        else if(char1.eq.'+') then
           wk(ic:ic)='p'
        else if(char1.eq.'.') then
           wk(ic:ic)='x'
        else if((char1.eq.'e').OR.(char1.eq.'E').OR. &
          (char1.eq.'d').OR.(char1.eq.'D')) then
           wk(ic:ic)='E'
        endif
     enddo
  else
     ! discard exponent; move decimal point
     file_encod(iexp:)=' '
     ilen = len(trim(file_encod))

     idot=0
     inb=0
     do ic=1,ilen
        if(file_encod(ic:ic).ne.' ') then
           if(inb.eq.0) inb=ic
        endif
        if(file_encod(ic:ic).eq.'.') then
           idot=ic
           exit
        endif
     enddo

     wk = ' '

     if(jexp.lt.0) then
        if(ztime.lt.(0.0)) then
           if(jexp.eq.-1) then
              wk(inb:) = 'm0x'
              id=0
              ii=inb+2
           else if(jexp.eq.-2) then
              wk(inb:) = 'm0x0'
              id=1
              ii=inb+3
           endif
        else
           if(jexp.eq.-1) then
              wk(inb:) = '0x'
              id=0
              ii=inb+1
           else if(jexp.eq.-2) then
              wk(inb:) = '0x0'
              id=1
              ii=inb+2
           endif
        endif

        do ic=1,ilen
           if(file_encod(ic:ic).eq.'+') cycle
           if(file_encod(ic:ic).eq.'-') cycle
           if(file_encod(ic:ic).eq.'.') cycle
           if(file_encod(ic:ic).eq.' ') cycle
           ii = ii + 1
           id = id + 1
           wk(ii:ii)=file_encod(ic:ic)
           if(id.ge.6) exit
        enddo

     else
        if(ztime.lt.(0.0)) then
           wk(inb:) = 'm'
           id=-1
           ii=inb
        else
           id=-1
           ii=inb-1
        endif

        do ic=1,ilen
           if(file_encod(ic:ic).eq.'+') cycle
           if(file_encod(ic:ic).eq.'-') cycle
           if(file_encod(ic:ic).eq.'.') cycle
           if(file_encod(ic:ic).eq.' ') cycle
           ii = ii + 1
           id = id + 1
           wk(ii:ii)=file_encod(ic:ic)
           if(id.ge.6) exit
           jexp = jexp-1
           if(jexp.eq.-1) then
              ii = ii + 1
              wk(ii:ii)='x'
           endif
        enddo
     endif

  endif

  wk = adjustL(wk)
  file_encod = trim(zprefix)//trim(wk)//'.cdf'

  if(file_encod.eq.prev_file) then
     file_encod = trim(file_encod)//'a'
  endif

  prev_file = file_encod

  write(ilun,'(a,a)') time_encod,trim(file_encod)

end subroutine trx_wr_encode_r4

      subroutine splitn_zeff_switches(izmod,ldatzef,
     >     NLZEFM,NLZFIN,NLZFI2,NLZVBR,NLZVB2,NLZFXI,NLZSIM,NLZEFA)
C
C  set Zeff data switches according to table value (izmod=nzefmod(j))
C
C  this routine with passed arguments so that code outside TRANSP can use..
C
      implicit NONE

      integer, intent(in) :: izmod   ! integer control value
      integer, intent(in) :: ldatzef ! 1d Zeff signal data address
      !  (set .gt.0 to allow NLZFIN to be set)

      logical, intent(out) :: NLZEFM ! T for Zeff from resistivity (vsur match)
      logical, intent(out) :: NLZFIN ! T for Zeff from Zeff(t) input signal
      logical, intent(out) :: NLZFI2 ! T for Zeff from Zeff(x,t) input signal
      logical, intent(out) :: NLZVBR ! T for Zeff from VB chordal data
      logical, intent(out) :: NLZVB2 ! T for Zeff from VB array data
      logical, intent(out) :: NLZFXI ! T for Zeff from single impurity density
      logical, intent(out) :: NLZSIM ! T for Zeff from impurity densities
      logical, intent(out) :: NLZEFA ! T for Zeff profile shaping
      ! (NLZEFA used with scalar input options NLZFIN, NLZVBR)

      !---------------------------------

      NLZEFM=.FALSE.
      NLZFIN=.FALSE.
      NLZFI2=.FALSE.
      NLZVBR=.FALSE.
      NLZVB2=.FALSE.
      NLZFXI=.FALSE.
      NLZSIM=.FALSE.
      NLZEFA=.FALSE.
C
      if(izmod.eq.1) then
         NLZEFM=.TRUE.
C
      else if(izmod.eq.2) then
         NLZFIN= (ldatzef.gt.0)
C
      else if(izmod.eq.3) then
         NLZFI2=.TRUE.
C
      else if(izmod.eq.4) then
         NLZVBR=.TRUE.
C
      else if(izmod.eq.5) then
         NLZVB2=.TRUE.
C
      else if(izmod.eq.6) then
         NLZFXI=.TRUE.
C
      else if(izmod.eq.7) then
         NLZFIN= (ldatzef.gt.0)
         NLZEFA=.TRUE.
C
      else if(izmod.eq.8) then
         NLZVBR=.TRUE.
         NLZEFA=.TRUE.
C
      else if(izmod.eq.9) then
         NLZVBR=.TRUE.
         NLZFXI=.TRUE.
C
      else if(izmod.eq.10) then
         NLZSIM=.TRUE.          ! zeff from multiple impurities
C
      else if(izmod.eq.11) then
         NLZVBR=.TRUE.          ! zeff from multiple impurities normalizd by VB
         NLZSIM=.TRUE.
C
      endif
C
      return
      end

subroutine splitn_bdecode1(subname,zinput,zname,iblock,ierr)

  !  decode string <name> -> <name>(uppercase) & iblock=0
  !                <zname>[<num>] -> <name>(uppercase) & iblock=<num>

  !  example: "alpha_e[2]" -> zname="ALPHA_E", iblock=2

  !  error condition: <num> fails to decode as integer, (i8)
  !---------------------------

  character*(*), intent(in) :: subname    ! name of calling subroutine
  character*(*), intent(in) :: zinput     ! string containing: <zname>[<num>]

  character*(*), intent(out) :: zname     ! name only, output in uppercase
  integer, intent(out) :: iblock          ! block number (0 if absent)
  integer, intent(out) :: ierr            ! status code (0=OK)

  !---------------------------
  ! local:
  integer :: ibr1,ibr2   ! brackets
  integer :: ilen
  character*8 zi8
  !---------------------------

  ierr = 0
  iblock = 0
  zname = '??'

  ibr1 = index(zinput,'[')
  ibr2 = index(zinput,']')

  if((ibr1.eq.ibr2).and.(ibr1.le.0)) then

     ! no bracketed number

     iblock = 0
     zname = zinput
     call uupper(zname)

  else

     if(ibr1.eq.1) then
        write(6,*) '?'//trim(subname)//': no name before "[" in input:'
        write(6,*) ' '//trim(zinput)
        ierr = 1
        return
     endif

     zname = zinput(1:ibr1-1)
     call uupper(zname)

     if(ibr2.lt.ibr1) then
        write(6,*) '?'//trim(subname)//': "]" before "[" in input:'
        write(6,*) ' '//trim(zinput)
        ierr = 1
        return
     endif

     if(ibr2.gt.(ibr1+1)) then
        ilen = ibr2 - ibr1 - 1
        if(ilen.gt.8) then
           write(6,*) '?'//trim(subname)//': argument inside "[,]" too long:'
           write(6,*) ' '//trim(zinput)
           ierr = 1
           return
        endif

        zi8=' '
        zi8(8-ilen+1:8) = zinput(ibr1+1:ibr2-1)
        read(zi8,'(I8)',iostat=ierr) iblock
        if(ierr.ne.0) then
           write(6,*) '?'//trim(subname)//': integer decode failed inside "[,]".'
           write(6,*) ' '//trim(zinput)
           ierr = 1
           iblock = 0
           return
        endif

     endif

  endif

end subroutine splitn_bdecode1

subroutine splitn_bdecode2(subname,zinput,zname,iblock1,iblock2,ierr)

  !  decode string <name> -> <name>(uppercase) & iblock1=iblock2=0
  !                <zname>[<num>] -> <name>(uppercase) & 
  !                                     iblock1=iblock2=<num>
  !                <zname>[<num1>:<num2>] -> <name>(uppercase) & 
  !                                     iblock1=<num1>, iblock2=<num2>
  !                <zname>[*] -> <name>(uppercase) & iblock1=0 & iblock2=N
  !                                     where N=nupdate = #updates that exist.

  !  examples: "alpha_e[2]" -> zname="ALPHA_E", iblock1=iblock2=2
  !            "alpha_e"    -> zname="ALPHA_E", iblock1=iblock2=0
  !            "alpha_e[1:3]" -> zname="ALPHA_E", iblock1=1, iblock2=3
  !            "alpha_e[*]" -> zname="ALPHA_E", iblock1=0, iblock2=nupdate

  !  error condition: <num> fails to decode as integer, (i8)
  !---------------------------

  character*(*), intent(in) :: subname    ! name of calling subroutine
  character*(*), intent(in) :: zinput     ! string containing: <zname>[<num>]

  character*(*), intent(out) :: zname     ! name only, output in uppercase
  integer, intent(out) :: iblock1,iblock2 ! range of block numbers out
  integer, intent(out) :: ierr            ! status code (0=OK)

  !---------------------------
  ! local:
  integer :: ibr1,ibr2   ! brackets
  integer :: icolon      ! colon
  integer :: ilen
  integer :: nupdate
  character*8 zi8
  !---------------------------

  ierr = 0
  iblock1 = 0
  iblock2 = 0
  zname = '??'

  call splitn_update_ntimes(nupdate)

  ibr1 = index(zinput,'[')
  ibr2 = index(zinput,']')
  icolon = index(zinput,':')

  if((ibr1.eq.ibr2).and.(ibr1.le.0)) then

     ! no bracketed number(s)

     zname = zinput
     call uupper(zname)

  else

     if(ibr1.eq.1) then
        call errmsg('no name before "[" in input:')
        return
     endif

     zname = zinput(1:ibr1-1)
     call uupper(zname)

     if(ibr2.lt.ibr1) then
        call errmsg('"]" before "[" in input:')
        return
     endif

     ! ibr2 > ibr1 now established.

     if(zinput(ibr1:ibr2).eq.'[*]') then
        iblock1=0
        iblock2=nupdate
        ierr = 0
        return
     endif

     if(icolon.gt.0) then
        if((icolon.lt.ibr1).or.(icolon.gt.ibr2)) then
           call errmsg('misplaced colon.')
           return
        endif
     endif

     ! if icolon gt 0:  ibr1 < icolon < ibr2 established.

     if(zinput(ibr1:ibr2).eq.'[:]') then
        iblock1=0
        iblock2=nupdate
        ierr = 0
        return
     endif

     if(icolon.eq.0) then
        if(ibr2.gt.(ibr1+1)) then
           ilen = ibr2 - ibr1 - 1
           call chklen; if(ierr.ne.0) return

           zi8=' '
           zi8(8-ilen+1:8) = zinput(ibr1+1:ibr2-1)
           read(zi8,'(I8)',iostat=ierr) iblock1
           if(ierr.ne.0) then
              call errmsg('integer decode failed inside "[,]".')
              iblock1 = 0
              return
           endif
           iblock2 = iblock1
        else
           ! "[]"
           iblock1 = 0
           iblock2 = 0
        endif

     else
        if(icolon.eq.ibr1+1) then
           iblock1=0
        else
           ilen = icolon - ibr1 - 1
           call chklen; if(ierr.ne.0) return

           zi8=' '
           zi8(8-ilen+1:8) = zinput(ibr1+1:icolon-1)
           read(zi8,'(I8)',iostat=ierr) iblock1
           if(ierr.ne.0) then
              call errmsg('integer decode failed inside "[,]".')
              iblock1 = 0
              return
           else
              iblock1=max(0,min(nupdate,iblock1))
           endif
        endif

        if(icolon.eq.ibr2-1) then
           iblock2=nupdate
        else
           ilen = ibr2 - icolon - 1
           call chklen; if(ierr.ne.0) return

           zi8=' '
           zi8(8-ilen+1:8) = zinput(icolon+1:ibr2-1)
           read(zi8,'(I8)',iostat=ierr) iblock2
           if(ierr.ne.0) then
              call errmsg('integer decode failed inside "[,]".')
              iblock2 = iblock1
              return
           else
              iblock2=max(0,min(nupdate,iblock2))
           endif

           if(iblock1.gt.iblock2) then
              call errmsg('integer indices out of order.')
           endif

        endif


     endif

  endif

CONTAINS

  subroutine chklen
    if(ilen.gt.8) then
       write(6,*) '?'//trim(subname)//': argument inside "[,]" too long:'
       write(6,*) ' '//trim(zinput)
       ierr = 1
    endif
  end subroutine chklen

  subroutine errmsg(msg)
    character*(*), intent(in) :: msg

    write(6,*) '?'//trim(subname)//': '//trim(msg)
    write(6,*) ' '//trim(zinput)
    ierr = 1

  end subroutine errmsg

end subroutine splitn_bdecode2

subroutine splitn_iputw(zname,isize,array,ierr)

  !  put an INTEGER namelist object in the write buffer;
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  integer, intent(in) :: array(isize)   ! object data (copied to write buffer)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_iputw',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_iputw: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_iputw: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_iputw: not an INTEGER object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_iputw: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))

  if(iblock.eq.0) then
     ii = varlist(jj)%addr
  else
     ii = nint + (iblock-1)*nint_st + varlist(jj)%addr_st
  endif

  ierr = 0
  intbuf_w(ii:ii+isize-1) = array

end subroutine splitn_iputw

subroutine splitn_lputw(zname,isize,array,ierr)

  !  put a LOGICAL namelist object in the write buffer;
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  logical, intent(in) :: array(isize)   ! object data (copied to write buffer)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_lputw',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_lputw: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_lputw: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lputw: not a LOGICAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_lputw: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))

  if(iblock.eq.0) then
     ii = varlist(jj)%addr
  else
     ii = nlog + (iblock-1)*nlog_st + varlist(jj)%addr_st
  endif

  ierr = 0
  logbuf_w(ii:ii+isize-1) = array

end subroutine splitn_lputw

subroutine splitn_rputw(zname,isize,array,ierr)

  !  put an REAL namelist object in the write buffer;
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real, intent(in) :: array(isize)      ! object data (copied to write buffer)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_rputw',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_rputw: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_rputw: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'R') then
     write(6,*) '?splitn_rputw: not a REAL object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_rputw: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))

  if(iblock.eq.0) then
     ii = varlist(jj)%addr
  else
     ii = nreal + (iblock-1)*nreal_st + varlist(jj)%addr_st
  endif

  ierr = 0
  rbuf_w(ii:ii+isize-1) = array

end subroutine splitn_rputw

subroutine splitn_dputw(zname,isize,array,ierr)

  !  put an REAL*8 namelist object in the write buffer;
  !  isize *must* match the actual size of the object.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: isize          ! size of object
  real*8, intent(in) :: array(isize)    ! object data (copied to write buffer)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_dputw',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_notilda('splitn_dputw',znam32,ierr)
  if(ierr.ne.0) return

  ierr = 1  ! assume for now...

  if(.not.have_database) then
     write(6,*) '?splitn_dputw: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_dputw: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type.ne.'D') then
     write(6,*) '?splitn_dputw: not a REAL*8 object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_dputw: size mismatch: expected=',isize,' found=',ii
     return
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))

  if(iblock.eq.0) then
     ii = varlist(jj)%addr
  else
     ii = nr8 + (iblock-1)*nr8_st + varlist(jj)%addr_st
  endif

  if(isize.eq.1) then
     if((varlist(jj)%name.eq.'TINIT').and.(array(1).ge.tup_w(1))) then
        write(6,*) '?splitn_dputw: new TINIT value .ge. 1st update time:', &
             array(1),tup_w(1)
        return
     else
        tinit_w=array(1)
     endif
  endif

  ierr = 0
  dbuf_w(ii:ii+isize-1) = array

end subroutine splitn_dputw

subroutine splitn_cputw(zname,iwid,isize,array,ierr)

  !  put a CHARACTER*n namelist object in the write buffer;
  !  isize *must* match the actual size of the object.
  !  iwid must be .le. the actual width of object elements.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname    ! name of object
  integer, intent(in) :: iwid           ! width of object array elements
  integer, intent(in) :: isize          ! size of object (# of elements)
  character*(iwid), intent(in) :: array(isize)   ! object data (copied)
  integer, intent(out) :: ierr          ! completion code (0=OK)

  !---------------------------
  integer i,ii,jj,ivar,imatch,iblock,iwuse
  character*32 znam32
  !---------------------------

  call splitn_bdecode1('splitn_cputw',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?splitn_cputw: no namelist has been read.'
     return
  endif

  call iorder(znam32,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?splitn_cputw: unrecognized name: ',znam32
     return
  endif

  jj = var_order(ivar)

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_cputw: not a CHARACTER*nn object: ',znam32
     return
  endif

  ii=1
  do i=1,varlist(jj)%rank
     ii=ii*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
  enddo
  if(ii.ne.isize) then
     write(6,*) '?splitn_cputw: array size mismatch: expected=',isize, &
          ' found=',ii
     return
  endif

  iwuse=iwid
  if(iwid.gt.varlist(jj)%chsize) then
     iwuse=1
     do i=1,isize
        iwuse=max(iwuse,len_trim(array(i)))
     enddo
     if(iwuse.gt.varlist(jj)%chsize) then
        write(6,*) &
             '?splitn_cputw: passed character element size too large: ', &
             ' passed=',iwid,' allowed=',varlist(jj)%chsize
        write(6,*) ' max non-blank width = ',iwuse
        write(6,*) ' trailing blanks ignored in size comparison.'
        return
     endif
  endif

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))

  if(iblock.eq.0) then
     ii = varlist(jj)%addr
  else
     ii = nchv + (iblock-1)*nchv_st + varlist(jj)%addr_st
  endif

  ierr = 0
  do i=1,isize
     chbuf_w(ii+i-1)=array(i)(1:iwuse)
  enddo

end subroutine splitn_cputw

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_5(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  status = nf90_inq_varid(icdf,"ntf_coils",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"ntf_coils")
  ELSE
     status = nf90_get_var(icdf,varid,ss%ntf_coils)
     IF(status.NE.NF90_NOERR) THEN
        ss%ntf_coils = ps_unInit
        CALL ncerr_name(2,status,"ntf_coils")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nthinlh)) THEN
     status = nf90_inq_varid(icdf,"nthinlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nthinlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nthinlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%nthinlh = 0
           CALL ncerr_name(2,status,"nthinlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Nturns)) THEN
     status = nf90_inq_varid(icdf,"Nturns",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Nturns")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Nturns)
        IF(status.NE.NF90_NOERR) THEN
           ss%Nturns = 0
           CALL ncerr_name(2,status,"Nturns")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%num_nphi)) THEN
     status = nf90_inq_varid(icdf,"num_nphi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"num_nphi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%num_nphi)
        IF(status.NE.NF90_NOERR) THEN
           ss%num_nphi = 0
           CALL ncerr_name(2,status,"num_nphi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%num_nphi_vac)) THEN
     status = nf90_inq_varid(icdf,"num_nphi_vac",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"num_nphi_vac")
     ELSE
        status = nf90_get_var(icdf,varid,ss%num_nphi_vac)
        IF(status.NE.NF90_NOERR) THEN
           ss%num_nphi_vac = 0
           CALL ncerr_name(2,status,"num_nphi_vac")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nzflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"nzflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nzflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nzflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%nzflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"nzflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nz_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"nz_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"nz_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%nz_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%nz_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"nz_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n_straps)) THEN
     status = nf90_inq_varid(icdf,"n_straps",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"n_straps")
     ELSE
        status = nf90_get_var(icdf,varid,ss%n_straps)
        IF(status.NE.NF90_NOERR) THEN
           ss%n_straps = 0
           CALL ncerr_name(2,status,"n_straps")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0cx)) THEN
     status = nf90_inq_varid(icdf,"omeg0cx",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omeg0cx")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omeg0cx)
        IF(status.NE.NF90_NOERR) THEN
           ss%omeg0cx = 0.0_rspec
           CALL ncerr_name(2,status,"omeg0cx")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0sc0)) THEN
     status = nf90_inq_varid(icdf,"omeg0sc0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omeg0sc0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omeg0sc0)
        IF(status.NE.NF90_NOERR) THEN
           ss%omeg0sc0 = 0.0_rspec
           CALL ncerr_name(2,status,"omeg0sc0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0_halo)) THEN
     status = nf90_inq_varid(icdf,"omeg0_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omeg0_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omeg0_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%omeg0_halo = 0.0_rspec
           CALL ncerr_name(2,status,"omeg0_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omeg0_reco)) THEN
     status = nf90_inq_varid(icdf,"omeg0_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omeg0_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omeg0_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%omeg0_reco = 0.0_rspec
           CALL ncerr_name(2,status,"omeg0_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omegat)) THEN
     status = nf90_inq_varid(icdf,"omegat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omegat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omegat)
        IF(status.NE.NF90_NOERR) THEN
           ss%omegat = 0.0_rspec
           CALL ncerr_name(2,status,"omegat")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat_bdy",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"omegat_bdy")
  ELSE
     status = nf90_get_var(icdf,varid,ss%omegat_bdy)
     IF(status.NE.NF90_NOERR) THEN
        ss%omegat_bdy = 0.0_rspec
        CALL ncerr_name(2,status,"omegat_bdy")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%omega_exb)) THEN
     status = nf90_inq_varid(icdf,"omega_exb",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"omega_exb")
     ELSE
        status = nf90_get_var(icdf,varid,ss%omega_exb)
        IF(status.NE.NF90_NOERR) THEN
           ss%omega_exb = 0.0_rspec
           CALL ncerr_name(2,status,"omega_exb")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%p0_reco)) THEN
     status = nf90_inq_varid(icdf,"p0_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"p0_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%p0_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%p0_reco = 0.0_rspec
           CALL ncerr_name(2,status,"p0_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pb0_halo)) THEN
     status = nf90_inq_varid(icdf,"pb0_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pb0_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pb0_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%pb0_halo = 0.0_rspec
           CALL ncerr_name(2,status,"pb0_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbe)) THEN
     status = nf90_inq_varid(icdf,"pbe",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pbe")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pbe)
        IF(status.NE.NF90_NOERR) THEN
           ss%pbe = 0.0_rspec
           CALL ncerr_name(2,status,"pbe")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbi)) THEN
     status = nf90_inq_varid(icdf,"pbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%pbi = 0.0_rspec
           CALL ncerr_name(2,status,"pbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pbth)) THEN
     status = nf90_inq_varid(icdf,"pbth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pbth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pbth)
        IF(status.NE.NF90_NOERR) THEN
           ss%pbth = 0.0_rspec
           CALL ncerr_name(2,status,"pbth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pcx_halo)) THEN
     status = nf90_inq_varid(icdf,"pcx_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pcx_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pcx_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%pcx_halo = 0.0_rspec
           CALL ncerr_name(2,status,"pcx_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pcx_reco)) THEN
     status = nf90_inq_varid(icdf,"pcx_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pcx_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pcx_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%pcx_reco = 0.0_rspec
           CALL ncerr_name(2,status,"pcx_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%peech)) THEN
     status = nf90_inq_varid(icdf,"peech",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"peech")
     ELSE
        status = nf90_get_var(icdf,varid,ss%peech)
        IF(status.NE.NF90_NOERR) THEN
           ss%peech = 0.0_rspec
           CALL ncerr_name(2,status,"peech")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%peech_src)) THEN
     status = nf90_inq_varid(icdf,"peech_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"peech_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%peech_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%peech_src = 0.0_rspec
           CALL ncerr_name(2,status,"peech_src")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pelh)) THEN
     status = nf90_inq_varid(icdf,"pelh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pelh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pelh)
        IF(status.NE.NF90_NOERR) THEN
           ss%pelh = 0.0_rspec
           CALL ncerr_name(2,status,"pelh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pelh_src)) THEN
     status = nf90_inq_varid(icdf,"pelh_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pelh_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pelh_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%pelh_src = 0.0_rspec
           CALL ncerr_name(2,status,"pelh_src")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"PEL_Code_Info")
  ELSE
     ilen = len(ss%PEL_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%PEL_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%PEL_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%PEL_Code_Info = " "
        CALL ncerr_name(2,status,"PEL_Code_Info")
     ELSE
        CALL denull(ss%PEL_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"PEL_Data_Info")
  ELSE
     ilen = len(ss%PEL_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%PEL_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%PEL_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%PEL_Data_Info = " "
        CALL ncerr_name(2,status,"PEL_Data_Info")
     ELSE
        CALL denull(ss%PEL_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pe_anom)) THEN
     status = nf90_inq_varid(icdf,"pe_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pe_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pe_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%pe_anom = 0.0_rspec
           CALL ncerr_name(2,status,"pe_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pe_trans)) THEN
     status = nf90_inq_varid(icdf,"pe_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pe_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pe_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%pe_trans = 0.0_rspec
           CALL ncerr_name(2,status,"pe_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pe_transcat)) THEN
     status = nf90_inq_varid(icdf,"pe_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pe_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pe_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%pe_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"pe_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfuse)) THEN
     status = nf90_inq_varid(icdf,"pfuse",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pfuse")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pfuse)
        IF(status.NE.NF90_NOERR) THEN
           ss%pfuse = 0.0_rspec
           CALL ncerr_name(2,status,"pfuse")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfusi)) THEN
     status = nf90_inq_varid(icdf,"pfusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pfusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pfusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%pfusi = 0.0_rspec
           CALL ncerr_name(2,status,"pfusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pfusth)) THEN
     status = nf90_inq_varid(icdf,"pfusth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pfusth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pfusth)
        IF(status.NE.NF90_NOERR) THEN
           ss%pfusth = 0.0_rspec
           CALL ncerr_name(2,status,"pfusth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Phibsc)) THEN
     status = nf90_inq_varid(icdf,"Phibsc",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Phibsc")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Phibsc)
        IF(status.NE.NF90_NOERR) THEN
           ss%Phibsc = 0.0_rspec
           CALL ncerr_name(2,status,"Phibsc")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phiflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"phiflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"phiflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%phiflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%phiflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"phiflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phigrilh)) THEN
     status = nf90_inq_varid(icdf,"phigrilh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"phigrilh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%phigrilh)
        IF(status.NE.NF90_NOERR) THEN
           ss%phigrilh = 0.0_rspec
           CALL ncerr_name(2,status,"phigrilh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%phit)) THEN
     status = nf90_inq_varid(icdf,"phit",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"phit")
     ELSE
        status = nf90_get_var(icdf,varid,ss%phit)
        IF(status.NE.NF90_NOERR) THEN
           ss%phit = 0.0_rspec
           CALL ncerr_name(2,status,"phit")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     status = nf90_inq_varid(icdf,"Phi_EC_launch",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Phi_EC_launch")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Phi_EC_launch)
        IF(status.NE.NF90_NOERR) THEN
           ss%Phi_EC_launch = 0.0_rspec
           CALL ncerr_name(2,status,"Phi_EC_launch")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_abs)) THEN
     status = nf90_inq_varid(icdf,"picrf_abs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picrf_abs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picrf_abs)
        IF(status.NE.NF90_NOERR) THEN
           ss%picrf_abs = 0.0_rspec
           CALL ncerr_name(2,status,"picrf_abs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_ext)) THEN
     status = nf90_inq_varid(icdf,"picrf_ext",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picrf_ext")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picrf_ext)
        IF(status.NE.NF90_NOERR) THEN
           ss%picrf_ext = 0.0_rspec
           CALL ncerr_name(2,status,"picrf_ext")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_nphi_srcs)) THEN
     status = nf90_inq_varid(icdf,"picrf_nphi_srcs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picrf_nphi_srcs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picrf_nphi_srcs)
        IF(status.NE.NF90_NOERR) THEN
           ss%picrf_nphi_srcs = 0.0_rspec
           CALL ncerr_name(2,status,"picrf_nphi_srcs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_srcs)) THEN
     status = nf90_inq_varid(icdf,"picrf_srcs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picrf_srcs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picrf_srcs)
        IF(status.NE.NF90_NOERR) THEN
           ss%picrf_srcs = 0.0_rspec
           CALL ncerr_name(2,status,"picrf_srcs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picrf_totals)) THEN
     status = nf90_inq_varid(icdf,"picrf_totals",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picrf_totals")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picrf_totals)
        IF(status.NE.NF90_NOERR) THEN
           ss%picrf_totals = 0.0_rspec
           CALL ncerr_name(2,status,"picrf_totals")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%picth)) THEN
     status = nf90_inq_varid(icdf,"picth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"picth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%picth)
        IF(status.NE.NF90_NOERR) THEN
           ss%picth = 0.0_rspec
           CALL ncerr_name(2,status,"picth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pilh)) THEN
     status = nf90_inq_varid(icdf,"pilh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pilh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pilh)
        IF(status.NE.NF90_NOERR) THEN
           ss%pilh = 0.0_rspec
           CALL ncerr_name(2,status,"pilh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pilh_src)) THEN
     status = nf90_inq_varid(icdf,"pilh_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pilh_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pilh_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%pilh_src = 0.0_rspec
           CALL ncerr_name(2,status,"pilh_src")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_anom)) THEN
     status = nf90_inq_varid(icdf,"pi_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pi_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pi_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%pi_anom = 0.0_rspec
           CALL ncerr_name(2,status,"pi_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_trans)) THEN
     status = nf90_inq_varid(icdf,"pi_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pi_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pi_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%pi_trans = 0.0_rspec
           CALL ncerr_name(2,status,"pi_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pi_transcat)) THEN
     status = nf90_inq_varid(icdf,"pi_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pi_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pi_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%pi_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"pi_transcat")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PLASMA_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"PLASMA_Code_Info")
  ELSE
     ilen = len(ss%PLASMA_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%PLASMA_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%PLASMA_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%PLASMA_Code_Info = " "
        CALL ncerr_name(2,status,"PLASMA_Code_Info")
     ELSE
        CALL denull(ss%PLASMA_Code_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pmine)) THEN
     status = nf90_inq_varid(icdf,"pmine",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pmine")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pmine)
        IF(status.NE.NF90_NOERR) THEN
           ss%pmine = 0.0_rspec
           CALL ncerr_name(2,status,"pmine")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pmini)) THEN
     status = nf90_inq_varid(icdf,"pmini",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pmini")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pmini)
        IF(status.NE.NF90_NOERR) THEN
           ss%pmini = 0.0_rspec
           CALL ncerr_name(2,status,"pmini")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pminth)) THEN
     status = nf90_inq_varid(icdf,"pminth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pminth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pminth)
        IF(status.NE.NF90_NOERR) THEN
           ss%pminth = 0.0_rspec
           CALL ncerr_name(2,status,"pminth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pohme)) THEN
     status = nf90_inq_varid(icdf,"pohme",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pohme")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pohme)
        IF(status.NE.NF90_NOERR) THEN
           ss%pohme = 0.0_rspec
           CALL ncerr_name(2,status,"pohme")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%pot_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"pot_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"pot_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%pot_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%pot_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"pot_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_ec)) THEN
     status = nf90_inq_varid(icdf,"power_ec",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"power_ec")
     ELSE
        status = nf90_get_var(icdf,varid,ss%power_ec)
        IF(status.NE.NF90_NOERR) THEN
           ss%power_ec = 0.0_rspec
           CALL ncerr_name(2,status,"power_ec")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_ic)) THEN
     status = nf90_inq_varid(icdf,"power_ic",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"power_ic")
     ELSE
        status = nf90_get_var(icdf,varid,ss%power_ic)
        IF(status.NE.NF90_NOERR) THEN
           ss%power_ic = 0.0_rspec
           CALL ncerr_name(2,status,"power_ic")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_lh)) THEN
     status = nf90_inq_varid(icdf,"power_lh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"power_lh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%power_lh)
        IF(status.NE.NF90_NOERR) THEN
           ss%power_lh = 0.0_rspec
           CALL ncerr_name(2,status,"power_lh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_nbi)) THEN
     status = nf90_inq_varid(icdf,"power_nbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"power_nbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%power_nbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%power_nbi = 0.0_rspec
           CALL ncerr_name(2,status,"power_nbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%power_nbi_trace)) THEN
     status = nf90_inq_varid(icdf,"power_nbi_trace",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"power_nbi_trace")
     ELSE
        status = nf90_get_var(icdf,varid,ss%power_nbi_trace)
        IF(status.NE.NF90_NOERR) THEN
           ss%power_nbi_trace = 0.0_rspec
           CALL ncerr_name(2,status,"power_nbi_trace")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad)) THEN
     status = nf90_inq_varid(icdf,"prad",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"prad")
     ELSE
        status = nf90_get_var(icdf,varid,ss%prad)
        IF(status.NE.NF90_NOERR) THEN
           ss%prad = 0.0_rspec
           CALL ncerr_name(2,status,"prad")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_br)) THEN
     status = nf90_inq_varid(icdf,"prad_br",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"prad_br")
     ELSE
        status = nf90_get_var(icdf,varid,ss%prad_br)
        IF(status.NE.NF90_NOERR) THEN
           ss%prad_br = 0.0_rspec
           CALL ncerr_name(2,status,"prad_br")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_cy)) THEN
     status = nf90_inq_varid(icdf,"prad_cy",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"prad_cy")
     ELSE
        status = nf90_get_var(icdf,varid,ss%prad_cy)
        IF(status.NE.NF90_NOERR) THEN
           ss%prad_cy = 0.0_rspec
           CALL ncerr_name(2,status,"prad_cy")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%prad_li)) THEN
     status = nf90_inq_varid(icdf,"prad_li",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"prad_li")
     ELSE
        status = nf90_get_var(icdf,varid,ss%prad_li)
        IF(status.NE.NF90_NOERR) THEN
           ss%prad_li = 0.0_rspec
           CALL ncerr_name(2,status,"prad_li")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psc_halo)) THEN
     status = nf90_inq_varid(icdf,"psc_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psc_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psc_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%psc_halo = 0.0_rspec
           CALL ncerr_name(2,status,"psc_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psc_reco)) THEN
     status = nf90_inq_varid(icdf,"psc_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psc_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psc_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%psc_reco = 0.0_rspec
           CALL ncerr_name(2,status,"psc_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psipol)) THEN
     status = nf90_inq_varid(icdf,"psipol",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psipol")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psipol)
        IF(status.NE.NF90_NOERR) THEN
           ss%psipol = 0.0_rspec
           CALL ncerr_name(2,status,"psipol")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_5

subroutine splitn_update_mod(itime,ztime,ierr)

  ! modify the time of update #itime
  ! return an error code if (a) block #itime does not exist or (b) the 
  !   modification would cause the update time sequence to be non-monotonic.

  use splitn_module
  implicit NONE

  integer, intent(in) :: itime   ! block index
  real*8, intent(in) :: ztime    ! new time desired for block
  integer, intent(out) :: ierr   ! return code, 0=OK

  real*8 :: zlim_low,zlim_high
  integer :: ii,jj,kk
  character*20 dstr
  character*32 znam32
  !-------------------------
  ierr = 0

  if((itime.le.0).or.(itime.gt.nupdate)) then
     write(6,*) ' ?splitn_update_mod: update block #',itime,' does not exist.'
     ierr = 1
     return
  endif

  ! check monotonicity

  if(itime.eq.1) then
     zlim_low = tinit
  else
     zlim_low = tup(itime-1)
  endif

  if(tinit.ge.ztime) then
     write(6,*) ' ?splitn_update_mod: update time: ',ztime,' seconds is'
     write(6,*) '  at/before namelist TINIT = ',tinit,' and so cannot be used.'
     ierr = 1
     return
  endif

  if(zlim_low.ge.ztime) then
     write(6,*) ' ?splitn_update_mod: update time: ',ztime,' seconds is'
     write(6,*) '  at/before the preceding update block time: ',zlim_low
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  zlim_high=tlarge
  if(itime.lt.nupdate) zlim_high=tup(itime+1)

  if(ztime.ge.zlim_high) then
     write(6,*) ' ?splitn_update_mod: update time: ',ztime,' seconds is'
     write(6,*) '  at/after the following update block time: ',zlim_high
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  ! OK...................

  znam32='~UPDATE_TIME'

  call splitn_put_chk('splitn_update_mod',znam32,jj,ierr)
  if(ierr.ne.0) return

  ! the update time value "belongs" to the preceding block...

  if(itime.le.1) then
     ii=varlist(jj)%addr   ! 1st time -> main body
     kk=varlist(jj)%nlinadr
  else
     ! nth time -> (n-1)'th block
     ii=nr8 + (itime-2)*nr8_st + varlist(jj)%addr_st
     kk=nreal+nint+nlog+nr8+nchv + &
          (itime-2)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  dbuf(ii)=ztime   ! reset here
  tup(itime)=ztime

  ! now reset the corresponding text

  dstr=' '
  write(dstr,'(1pd19.12)') ztime
  call splitn_fput_clean(dstr,'d')
  call splitn_put_sc_str(kk,znam32,dstr)

end subroutine splitn_update_mod

subroutine splitn_update_append_N(ztimes,ntimes,ierr)

  ! append N update blocks at the indicated times.
  ! requirements:
  !    ztimes(1).gt.[last existing update_time in file]
  !    ztimes in strict ascending order

  use splitn_module
  implicit NONE

  integer, intent(in) :: ntimes ! # of update times
  real*8, intent(in) :: ztimes(ntimes) ! update times in strict ascending order

  integer, intent(out) :: ierr   ! return code, 0=OK

  !-------------------------
  integer :: itime, ier2
  !-------------------------

  ierr = 0

  do itime=2,ntimes
     if(ztimes(itime).le.ztimes(itime-1)) then
        write(6,*) ' ?splitn_update_append_N: update times not ascending:'
        write(6,*) '    ztimes(',itime-1,') = ',ztimes(itime-1)
        write(6,*) '    ztimes(',itime,') = ',ztimes(itime)
        ierr = 1
        exit
     endif
  enddo

  if(ierr.ne.0) return

  do itime=1,ntimes

     call splitn_update_append(ztimes(itime),ier2)

  enddo

end subroutine splitn_update_append_N

subroutine splitn_update_append(ztime,ierr)

  ! append an update block at the indicated time.
  ! return an error if the addition would cause a non-monotonic time sequence.

  use splitn_module
  implicit NONE

  real*8, intent(in) :: ztime    ! time desired for new block
  integer, intent(out) :: ierr   ! return code, 0=OK

  character*20 dstr
  character*32 znam32
  integer :: iadr,jj,iadl
  !------------------------

  ierr = 0

  if(nupdate.gt.0) then
     if(ztime.le.tup(nupdate)) then
        write(6,*) ' ?splitn_update_append: the specified time: ',ztime
        write(6,*) '  is less than or equal to the last update time already'
        write(6,*) '  in the namelist: ',tup(nupdate)
        write(6,*) '  The times must be maintained in strict increasing order.'
        ierr=1
        return
     endif
  endif

  ! OK....................

  znam32 = '~UPDATE_TIME'

  call splitn_put_chk('splitn_update_mod',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(nupdate.eq.0) then
     iadr = varlist(jj)%addr
     iadl = varlist(jj)%nlinadr
  else
     iadr = nr8 + (nupdate-1)*nr8_st + varlist(jj)%addr_st
     iadl=nreal+nint+nlog+nr8+nchv + &
          (nupdate-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + &
          varlist(jj)%nlinadr_st
  endif

  dbuf(iadr)=ztime

  ! now append the corresponding text

  kupdate=nupdate    ! internally ~update_time belongs in preceding block
  nupdate=nupdate+1
  nxblock=nxblock+1
  if(nxblock.gt.nupdate_max) call spxb_expand

  tup(nupdate)=ztime
 
  ! now append the corresponding text

  linup(nupdate)=nlines+2

  dstr=' '
  write(dstr,'(1pd19.12)') ztime
  call splitn_fput_clean(dstr,'d')

  call clear_fields
  newline = nlines + 1
  call add_nl_line(' ')

  newline = nlines + 1
  aline = ' ~update_time = '//trim(dstr)

  call parse_line(aline,.TRUE.,ierr)
  if(ierr.ne.0) return

  call add_nl_line(aline)

  call clear_fields
  newline = nlines + 1
  call add_nl_line(' ')

  kupdate = nupdate

  call splitn_put_edit_mark(0)

end subroutine splitn_update_append

subroutine splitn_update_remove(ztime,ierr)

  ! remove update blocks at/after the indicated time.
  ! report an error if no such blocks exist.

  use splitn_module
  implicit NONE

  real*8, intent(in) :: ztime    ! time desired for new block
  integer, intent(out) :: ierr   ! return code, 0=OK

  integer :: ii,jj,iupdate,istart

  !-------------------------
  ierr = 0

  if(nupdate.eq.0) then
     write(6,*) ' %splitn_update_remove: there are no updates to remove.'
     return
  endif

  if(ztime.gt.tup(nupdate)) then
     write(6,*) ' %splitn_update_remove: the removal time t=',ztime,' seconds'
     write(6,*) '  is after the last existing update time: ',tup(nupdate)
     write(6,*) '  so, no action is taken.'
     return
  endif

  do ii=nupdate,1,-1
     if(tup(ii).ge.ztime) iupdate=ii
  enddo

  ! OK....................
  ! mark corresponding text lines as removed...

  istart=linup(iupdate)
  do
     if(istart.eq.1) exit
     if(isblank(istart-1)) then
        istart = istart-1
     else
        exit
     endif
  enddo

  do ii=istart,nlines
     jj=ordl(ii)
     lenl(jj)=0  ! mark text line as deleted
  enddo

  ! make sure text references are zeroed out also

  istart = nreal+nint+nlog+nr8+nchv + &
       (iupdate-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + 1

  do ii=istart,maxlines(0)
     ilines(ii)=0
     krepeat(ii)=0
     ivrange(:,ii)=0
     irrange(:,ii)=0
  enddo

  tup(iupdate:)=tlarge
  linup(iupdate:)=ilarge

  nxblock=iupdate
  nupdate=iupdate - 1
  kupdate=nupdate

  ! mark

  call splitn_put_edit_mark(1)

end subroutine splitn_update_remove

subroutine splitn_update_insert(itime,ztime,ierr)

  ! before current update block (itime) insert a new update block at
  ! time ztime.
  ! return an error code if (a) block #itime does not exist or (b) the 
  !   modification would cause the update time sequence to be non-monotonic.

  ! method: use a temporary file...

  use splitn_module
  implicit NONE

  integer, intent(in) :: itime   ! block index, before which to insert.
  real*8, intent(in) :: ztime    ! time desired for new block to be inserted.
  integer, intent(out) :: ierr   ! return code, 0=OK

  real*8 :: zlim_low,zlim_high
  integer :: ilun                ! I/O channel for temporary file
  character*150 ztmpfil
  integer :: ilz,ii,jj,idum
  character*20 dstr

  character*50 zprog
  logical :: istarted

  !-------------------------
  ierr = 0

  if((itime.le.0).or.(itime.gt.nupdate)) then
     write(6,*) ' ?splitn_update_insert: block #',itime,' does not exist.'
     ierr = 1
     return
  endif

  ! check monotonicity

  if(itime.eq.1) then
     zlim_low = tinit
  else
     zlim_low = tup(itime-1)
  endif

  if(tinit.ge.ztime) then
     write(6,*) ' ?splitn_update_insert: insert time: ',ztime,' seconds is'
     write(6,*) '  at/before namelist TINIT = ',tinit,' and so cannot be used.'
     ierr = 1
     return
  endif

  if(zlim_low.ge.ztime) then
     write(6,*) ' ?splitn_update_insert: insert time: ',ztime,' seconds is'
     write(6,*) '  at/before the preceding update block time: ',zlim_low
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  zlim_high=tup(itime)

  if(ztime.ge.zlim_high) then
     write(6,*) ' ?splitn_update_insert: update time: ',ztime,' seconds is'
     write(6,*) '  at/after the insert target block time: ',zlim_high
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  ! OK...................

  dstr=' '
  write(dstr,'(1pd19.12)') ztime
  call splitn_fput_clean(dstr,'d')

  ! find temporary file

  call find_io_unit(ilun)
  call tmpfile_d('usplitn',ztmpfil,ilz)

  open(unit=ilun,file=ztmpfil(1:ilz),status='unknown',iostat=ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?splitn_update_insert: file operation failed.'
     return
  endif

  do ii=1,nlines

     if(ii.eq.linup(itime)) then
        write(ilun,*) ' ' 
        write(ilun,'(" ~update_time = ",a,"  ! inserted by ",a)') &
             trim(dstr),edit_program
        write(ilun,*) ' ' 
     endif

     jj=ordl(ii)
     if(lenl(jj).ne.0) then
        write(ilun,'(A)') textnl(jj)(1:abs(lenl(jj)))
     endif
  enddo

  close(unit=ilun)

  istarted = edit_started
  zprog = edit_program

  call splitn_read(ztmpfil,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? '//trim(edit_program)// &
          ' -- file readback error; cannot continue!'
     call bad_exit
  else
     call fdelete(ztmpfil,idum)
  endif

  edit_enabled=.TRUE.
  edit_program=zprog
  edit_started=istarted

  call splitn_put_edit_mark(0)  ! put in program tag...

end subroutine splitn_update_insert

subroutine splitn_update_insert_N(itime,ztimes,ntimes,ierr)

  ! before current update block (itime) insert a new set of update blocks
  ! times ztimes(1:ntimes).
  ! return an error code if (a) block #itime does not exist or (b) the 
  !   modification would cause the update time sequence to be non-monotonic.

  ! method: use a temporary file...

  use splitn_module
  implicit NONE

  integer, intent(in) :: itime   ! block index, before which to insert.
  integer, intent(in) :: ntimes  ! #of times
  real*8, intent(in) :: ztimes(ntimes)   ! times desired for new blocks 
  integer, intent(out) :: ierr   ! return code, 0=OK

  real*8 :: zlim_low,zlim_high
  integer :: ilun                ! I/O channel for temporary file
  character*150 ztmpfil
  integer :: ilz,ii,jj,idum,jtime
  character*20, dimension(:), allocatable :: dstr

  character*50 zprog
  logical :: istarted

  !-------------------------
  ierr = 0

  if((itime.le.0).or.(itime.gt.nupdate)) then
     write(6,*) ' ?splitn_update_insert: block #',itime,' does not exist.'
     ierr = 1
  endif

  ! check monotonicity of passed list of times
  do jtime=2,ntimes
     if(ztimes(jtime).le.ztimes(jtime-1)) then
        write(6,*) ' ?splitn_update_insert_N: update times not ascending:'
        write(6,*) '    ztimes(',jtime-1,') = ',ztimes(jtime-1)
        write(6,*) '    ztimes(',jtime,') = ',ztimes(jtime)
        ierr = 1
        exit
     endif
  enddo
  if(ierr.ne.0) return

  ! check monotonicity expected after insertion

  if(itime.eq.1) then
     zlim_low = tinit
  else
     zlim_low = tup(itime-1)
  endif

  if(tinit.ge.ztimes(1)) then
     write(6,*) ' ?splitn_update_insert: insert time: ',ztimes(1),' seconds is'
     write(6,*) '  at/before namelist TINIT = ',tinit,' and so cannot be used.'
     ierr = 1
     return
  endif

  if(zlim_low.ge.ztimes(1)) then
     write(6,*) ' ?splitn_update_insert: insert time: ',ztimes(1),' seconds is'
     write(6,*) '  at/before the preceding update block time: ',zlim_low
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  zlim_high=tup(itime)

  if(ztimes(ntimes).ge.zlim_high) then
     write(6,*) ' ?splitn_update_insert: update time: ',ztimes(ntimes), &
          ' seconds is'
     write(6,*) '  at/after the insert target block time: ',zlim_high
     write(6,*) '  and so cannot be used.'
     ierr = 1
     return
  endif

  ! OK...................

  allocate(dstr(ntimes))

  dstr=' '
  do jtime=1,ntimes
     write(dstr(jtime),'(1pd19.12)') ztimes(jtime)
     call splitn_fput_clean(dstr(jtime),'d')
  enddo

  ! find temporary file

  call find_io_unit(ilun)
  call tmpfile_d('usplitn',ztmpfil,ilz)

  open(unit=ilun,file=ztmpfil(1:ilz),status='unknown',iostat=ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?splitn_update_insert: file operation failed.'
     return
  endif

  do ii=1,nlines

     if(ii.eq.linup(itime)) then
        write(ilun,*) ' ' 
        do jtime=1,ntimes
           write(ilun,'(" ~update_time = ",a,"  ! inserted by ",a)') &
                trim(dstr(jtime)),edit_program
           write(ilun,*) ' ' 
        enddo
     endif

     jj=ordl(ii)
     if(lenl(jj).ne.0) then
        write(ilun,'(A)') textnl(jj)(1:abs(lenl(jj)))
     endif
  enddo

  close(unit=ilun)

  istarted = edit_started
  zprog = edit_program

  call splitn_read(ztmpfil,ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?? '//trim(edit_program)// &
          ' -- file readback error; cannot continue!'
     call bad_exit
  else
     call fdelete(ztmpfil,idum)
  endif

  edit_enabled=.TRUE.
  edit_program=zprog
  edit_started=istarted

  call splitn_put_edit_mark(0)  ! put in program tag...

end subroutine splitn_update_insert_N

subroutine tdb_ntimes(d,intime1,intime2)
  !
  !  return sizes of trdatbuf input 1d f(t) timebase and 2d f(t,x) timebase

  use trdatbuf_obj
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(out) :: intime1
  integer, intent(out) :: intime2

  intime1 = d%ntime1
  intime2 = d%ntime2

end subroutine tdb_ntimes

subroutine tdb_range_ntimes1(d,zt1,zt2,intime1)

  !  return no. of pts in tdb input 1d f(t) timebase within the time
  !  range (zt1,zt2)

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(in) :: zt1,zt2  ! time range
  integer, intent(out) :: intime1 ! no. of time points returned

  !----------------
  integer :: it1,it2,ilt,int
  real*8 :: zf1,zf2
  !----------------

  ilt=d%ltime1
  int=d%ntime1
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt1,it1,zf1)
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt2,it2,zf2)

  if(d%datbuf(ilt+it1-1).lt.zt1) it1=it1+1
  if(d%datbuf(ilt+it2).le.zt2) it2=it2+1

  intime1=it2-it1+1

end subroutine tdb_range_ntimes1

subroutine tdb_range_times1(d,zt1,zt2,ztimes,ierr)

  !  return the time points in tdb input 1d f(t) timebase within the time
  !  range (zt1,zt2)

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(in) :: zt1,zt2 ! time range
  real*8, intent(inout) :: ztimes(:) ! time points returned
  integer, intent(out) :: ierr ! error (ierr=1) if ztimes array too small

  !----------------
  integer :: it1,it2,ilt,int,intime1
  real*8 :: zf1,zf2
  !----------------

  ilt=d%ltime1
  int=d%ntime1
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt1,it1,zf1)
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt2,it2,zf2)

  if(d%datbuf(ilt+it1-1).lt.zt1) it1=it1+1
  if(d%datbuf(ilt+it2).le.zt2) it2=it2+1

  intime1=it2-it1+1

  ztimes=0
  if(size(ztimes).lt.intime1) then
     ierr=1
  else
     ierr=0
     ztimes(1:intime1)=d%datbuf(ilt+it1-1:ilt+it2-1)
  endif

end subroutine tdb_range_times1

subroutine tdb_range_ntimes2(d,zt1,zt2,intime2)

  !  return no. of pts in tdb input 2d f(x,t) timebase within the time
  !  range (zt1,zt2)

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(in) :: zt1,zt2  ! time range
  integer, intent(out) :: intime2 ! no. of time points returned

  !----------------
  integer :: it1,it2,ilt,int
  real*8 :: zf1,zf2
  !----------------

  ilt=d%ltime2
  int=d%ntime2
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt1,it1,zf1)
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt2,it2,zf2)

  if(d%datbuf(ilt+it1-1).lt.zt1) it1=it1+1
  if(d%datbuf(ilt+it2).le.zt2) it2=it2+1

  intime2=it2-it1+1

end subroutine tdb_range_ntimes2

subroutine tdb_range_times2(d,zt1,zt2,ztimes,ierr)

  !  return the time points in tdb input 2d f(x,t) timebase within the time
  !  range (zt1,zt2)

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(in) :: zt1,zt2 ! time range
  real*8, intent(inout) :: ztimes(:) ! time points returned
  integer, intent(out) :: ierr ! error (ierr=1) if ztimes array too small

  !----------------
  integer :: it1,it2,ilt,int,intime2
  real*8 :: zf1,zf2
  !----------------

  ilt=d%ltime2
  int=d%ntime2
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt1,it1,zf1)
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,zt2,it2,zf2)

  if(d%datbuf(ilt+it1-1).lt.zt1) it1=it1+1
  if(d%datbuf(ilt+it2).le.zt2) it2=it2+1

  intime2=it2-it1+1

  ztimes=0
  if(size(ztimes).lt.intime2) then
     ierr=1
  else
     ierr=0
     ztimes(1:intime2)=d%datbuf(ilt+it1-1:ilt+it2-1)
  endif

end subroutine tdb_range_times2

subroutine tdbsub_onoff(time,intime,pdata,inchan,zthresh,zdtfix,ton,toff)

  use tdbsub_uts
  implicit NONE

  !  analyze power channel data for on/off times
  !  see tdb_onoff_times.f90 comments for definition of "zthresh" & "zdtfix"

  integer, intent(in) :: intime  ! # of times
  real*8, intent(in) :: time(intime)  ! the time values
  integer, intent(in) :: inchan  ! # of channels (i.e beams or RF antennas)
  real*8, intent(in) :: pdata(intime,inchan)

  real*8, intent(in) :: zthresh  ! power threshhold, watts or -fraction
  real*8, intent(in) :: zdtfix   ! time to search around threshhold points

  real*8, intent(out) :: ton(inchan)  ! inferred on times
  real*8, intent(out) :: toff(inchan) ! inferred off times

  !----------------------------------------
  real*8 :: zthresha
  integer :: ichan,it,it1,it2,ifound
  real*8 :: ztfound,zpfound
  !----------------------------------------

  call tdbsub_onoff_thresh(intime,pdata,inchan,zthresh,zthresha)

  do ichan=1,inchan
     !  find first time with power above threshhold
     ifound=0
     do it=1,intime
        if(pdata(it,ichan).gt.zthresha) then
           ifound=it
           exit
        endif
     enddo

     if(ifound.eq.0) then
        ! if nothing is found, set on/off times to very large numbers
        ton(ichan)=EPSINV
        toff(ichan)=EPSINV
        cycle
     endif

     ztfound=time(ifound)
     zpfound=zthresha
     do it=ifound,1,-1
        it1=min(ifound,(it+1))
        if((ztfound-time(it)).ge.zdtfix) exit
        if(pdata(it,ichan).lt.zpfound*0.1d0) then
           it1=it+1
           exit
        endif
     enddo

     if(it1.eq.ifound) then
        ton(ichan)=time(max(1,(it1-1)))
     else
        ton(ichan)=HALF*(time(it1)+time(max(1,it1-1)))
     endif

     !  find last time with power above threshhold -- something exists
     !  or the loop would have exited above...

     ifound=0
     do it=intime,1,-1
        if(pdata(it,ichan).gt.zthresha) then
           ifound=it
           exit
        endif
     enddo

     ztfound=time(ifound)
     zpfound=pdata(ifound,ichan)
     do it=ifound,intime
        it2=max(ifound,(it-1))
        if((time(it)-ztfound).ge.zdtfix) exit
        if(pdata(it,ichan).lt.zpfound*0.1d0) then
           it2=it-1
           exit
        endif
     enddo

     if(it2.eq.ifound) then
        toff(ichan)=time(min(intime,it2+1))
     else
        toff(ichan)=HALF*(time(it2)+time(min(intime,it2+1)))
     endif
  enddo

end subroutine tdbsub_onoff

subroutine tdbsub_next_on(time,intime,pdata,inchan,zthresh,zdtfix,tprev,tnext)

  use tdbsub_uts
  implicit NONE

  !  find the first "on time" for power data, following time tprev
  !  This is defined as a time when one or more channels are "on", immediately
  !  following a time (.gt.tprev) when all are off.

  !  mod DMC Feb 2010 -- bugfix -- for all to count as off, they must remain
  !  off for at least 2 consecutive time points-- otherwise false on/off
  !  events were detectable with very close times, causing time step
  !  controller problems...

  !  see tdb_onoff_times.f90 comments for definition of "zthresh" & "zdtfix"

  !  NOTE: it is assumed, without checking, that the times are in strict
  !  ascending order.

  integer, intent(in) :: intime  ! # of times
  real*8, intent(in) :: time(intime)  ! the time values
  integer, intent(in) :: inchan  ! # of channels (i.e beams or RF antennas)
  real*8, intent(in) :: pdata(intime,inchan)

  real*8, intent(in) :: zthresh  ! power threshhold, watts or -fraction
  real*8, intent(in) :: zdtfix   ! time to search around threshhold points

  real*8, intent(in) :: tprev    ! prior time; return tnext > tprev
  real*8, intent(out) :: tnext   ! time of next transition from zero to finite
  !  power...

  !----------------------------------------
  real*8 :: zthresha
  integer :: ichan,it,it0,it1,it2,ifound,icount
  real*8 :: ztfound,zpfound,zptest
  integer :: ichan_with_power(inchan)
  !----------------------------------------

  call tdbsub_onoff_thresh(intime,pdata,inchan,zthresh,zthresha)

  if(tprev.ge.time(intime)) then
     ! no more times
     tnext = EPSINV
     return
  endif

  ! we now know that a time t > tprev exists; find the first one...

  if(tprev.lt.time(1)) then
     it0=1
     it1=1  ! just set up to find the first ontime...

  else
     ! (tprev.eq.time(1)) lands here...

     do it=1,intime
        if(time(it).gt.tprev) then
           it0=it
           exit
        endif
     enddo

     ! find the first time, at/after it0, where all the powers are below
     ! the threshhold for 2 consecutive time points

     it1 = -1
     do it=it0,intime-1
        ifound=0
        do ichan=1,inchan
           if(max(pdata(it,ichan),pdata(it+1,ichan)).gt.zthresha) then
              ifound=it
              exit
           endif
        enddo

        if(ifound.eq.0) then
           it1=it
           exit
        endif
     enddo

     if(it1.eq.-1) then
        ! no times with near zero power, after tprev
        tnext = EPSINV
        return
     endif

  endif

  ! find the first time, after it1, where one or more powers are above
  ! the threshhold

  it2 = -1
  ichan_with_power = 0

  do it=it1,intime
     ifound=0
     do ichan=1,inchan
        if(pdata(it,ichan).gt.zthresha) then
           ifound=it
           ichan_with_power(ichan)=1
        endif
     enddo

     if(ifound.gt.0) then
        it2=it
        exit
     endif
  enddo

  if(it2.eq.-1) then
     ! no times with power above threshhold, after zero after tprev
     tnext = EPSINV
     return
  endif

  ifound=it2
  ztfound=time(ifound)
  zpfound=zthresha

  do it=ifound,1,-1
     it1=min(ifound,(it+1))
     if((ztfound-time(it)).ge.zdtfix) exit

     icount=0
     do ichan=1,inchan
        if(ichan_with_power(ichan).eq.1) then
           if(pdata(it,ichan).ge.zpfound*0.1d0) then
              icount=icount+1
           else
              ichan_with_power(ichan)=0
           endif
        endif
     enddo

     if(icount.eq.0) then
        it1=it+1
        exit
     endif
  enddo

  if(it1.eq.ifound) then
     tnext=time(max(1,(it1-1)))
  else
     tnext=HALF*(time(it1)+time(max(1,it1-1)))
  endif

end subroutine tdbsub_next_on

subroutine tdbsub_onoff_thresh(intime,pdata,inchan,zthresh,zthresha)

  use tdbsub_uts
  implicit NONE

  ! get the absolute power threshold
  ! (see tdb_onoff_times.f90 comments...)

  integer, intent(in) :: intime   ! no. of time points in channel data
  integer, intent(in) :: inchan   ! no. of channels

  real*8, intent(in) :: pdata(intime,inchan)  ! channel data (power)

  real*8, intent(in) :: zthresh   ! threshhold control

  real*8, intent(out) :: zthresha ! absolute threshold (in power units)

  !----------------------------------------
  real*8 :: zmax
  real*8, parameter :: zmaxf=0.20d0
  real*8, parameter :: zminf=0.0001d0
  integer :: ichan,it,it1,it2,ifound
  real*8 :: ztfound,zpfound
  !----------------------------------------

  zmax=maxval(pdata)
  zmax=max(ONE,zmax)  ! at least one watt, please...

  if(zthresh.ge.ZERO) then
     ! threshhold in watts, but constrain according to data extrema
     zthresha = max(zminf*zmax,min(zmaxf*zmax,zthresh))
  else
     ! fraction
     zthresha=max(zminf,min(zmaxf,-zthresh))
     zthresha=zthresha*zmax
  endif

end subroutine tdbsub_onoff_thresh

MODULE mds_readnode
  implicit none

  INTERFACE mds_read_node
     MODULE PROCEDURE mds_read_int, &
                      mds_read_float, &
                      mds_read_text
  END INTERFACE

  integer, PARAMETER :: r4 = SELECTED_REAL_KIND(6,37)
  integer, PARAMETER :: r8 = SELECTED_REAL_KIND(12,100)

CONTAINS
!-----------------------------------------------------------------

  SUBROUTINE mds_read_int(lun,node,ivalue,ier)
     implicit none
     integer,       intent(in)  :: lun       ! lun for error message
     character*(*), intent(in)  :: node      ! mds node name
     integer,       intent(in)  :: ivalue    !  0 = success
     integer,       intent(out) :: ier       !  0 = success
                                             ! -1 = Node does not exist
                                             !  1 = any other error
! MDSplus
      integer ::      Mds_Value, idescr_long
      integer ::      descr, mds__long
      integer ::      nid, ndsc
! Local
      integer ::      retl
      integer ::      stat
      character*100 :: expr


! Check if node exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      expr='getnci("'//node//'","NID_NUMBER")'
      stat = Mds_Value(trim(expr),ndsc,retl)
      if (mod(stat,2) .ne. 1) then
         if (stat .ne. 265388144) then     !  Node Not Found
            call mdsmsg(lun, 'MdsValue('//trim(expr)//')', stat)
         endif
         ier = -1
         return
      endif

! Get Value
      stat = Mds_Value(node,idescr_long(ivalue),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//node//')',stat)
         ier=1
         return
      endif
  END SUBROUTINE 

  SUBROUTINE mds_read_float(lun,node,fvalue,ier)
     implicit none
     integer,       intent(in)  :: lun       ! lun for error message
     character*(*), intent(in)  :: node      ! mds node name
     REAL(KIND=r4), intent(in)  :: fvalue    !  
     integer,       intent(out) :: ier       !  0 = success
                                             ! -1 = Node does not exist
                                             !  1 = any other error
! MDSplus
      integer ::      Mds_Value, idescr_float
      integer ::      descr, mds__long
      integer ::      nid, ndsc
! Local
      integer ::      retl
      integer ::      stat
      character*100 :: expr


! Check if node exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      expr='getnci("'//node//'","NID_NUMBER")'
      stat = Mds_Value(trim(expr),ndsc,retl)
      if (mod(stat,2) .ne. 1) then
         if (stat .ne. 265388144) then     !  Node Not Found
            call mdsmsg(lun, 'MdsValue('//trim(expr)//')', stat)
         endif
         ier = -1
         return
      endif

! Get Value
      stat = Mds_Value(node,idescr_float(fvalue),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//node//')',stat)
         ier=1
         return
      endif
  END SUBROUTINE
  SUBROUTINE mds_read_text(lun,node,string,ier)
     implicit none
     integer,       intent(in)  :: lun       ! lun for error message
     character*(*), intent(in)  :: node      ! mds node name
     character*(*), intent(out) :: string    ! text node
     integer,       intent(out) :: ier       !  0 = success
                                             ! -1 = Node does not exist
                                             !  1 = any other error
! MDSplus
      integer ::      Mds_Value, idescr_cstring
      integer ::      descr, mds__long
      integer ::      nid, ndsc
! Local
      integer ::      retl
      integer ::      stat
      character*100 :: expr


! Check if node exists
      nid=0
      ndsc = descr(mds__long(), nid, 0)
      expr='getnci("'//node//'","NID_NUMBER")'
      stat = Mds_Value(trim(expr),ndsc,retl)
      if (mod(stat,2) .ne. 1) then
         if (stat .ne. 265388144) then     !  Node Not Found
            call mdsmsg(lun, 'MdsValue('//trim(expr)//')', stat)
         endif
         ier = -1
         return
      endif

! Get Value
      stat = Mds_Value(node,idescr_cstring(string),retl)
      if (mod(stat,2).ne.1) then
         call mdsmsg(lun, 'Mds_Value('//node//')',stat)
         ier=1
         return
      endif
  END SUBROUTINE 
 
END MODULE mds_readnode

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

MODULE ps_nidlist_defn

  TYPE :: nidlist

     INTEGER :: nid_dim_max_nrz_antgeo
     INTEGER :: nid_dim_max_nspectrumlh_src
     INTEGER :: nid_dim_max_num_nphi
     INTEGER :: nid_dim_max_num_nphi_vac
     INTEGER :: nid_dim_max_n_straps
     INTEGER :: nid_dim_mmodes
     INTEGER :: nid_dim_nballoon
     INTEGER :: nid_dim_nbeam
     INTEGER :: nid_dim_ncircuits
     INTEGER :: nid_dim_ncoils
     INTEGER :: nid_dim_ndelta_w
     INTEGER :: nid_dim_necrf_src
     INTEGER :: nid_dim_nefi_anom
     INTEGER :: nid_dim_nefi_anom2
     INTEGER :: nid_dim_neqmom
     INTEGER :: nid_dim_ngsc0
     INTEGER :: nid_dim_nicrf_src
     INTEGER :: nid_dim_nky_anomth
     INTEGER :: nid_dim_nky_mmm
     INTEGER :: nid_dim_nlhrf_src
     INTEGER :: nid_dim_nnewcomb
     INTEGER :: nid_dim_npsmom
     INTEGER :: nid_dim_nr
     INTEGER :: nid_dm1_nrho
     INTEGER :: nid_dim_nrho
     INTEGER :: nid_dim_nrho_anom
     INTEGER :: nid_dim_nrho_anom2
     INTEGER :: nid_dm1_nrho_anomth
     INTEGER :: nid_dim_nrho_anomth
     INTEGER :: nid_dm1_nrho_ecrf
     INTEGER :: nid_dim_nrho_ecrf
     INTEGER :: nid_dim_nrho_eq
     INTEGER :: nid_dim_nrho_eq_geo
     INTEGER :: nid_dm1_nrho_fus
     INTEGER :: nid_dim_nrho_fus
     INTEGER :: nid_dm1_nrho_gas
     INTEGER :: nid_dim_nrho_gas
     INTEGER :: nid_dm1_nrho_icrf
     INTEGER :: nid_dim_nrho_icrf
     INTEGER :: nid_dm1_nrho_lhrf
     INTEGER :: nid_dim_nrho_lhrf
     INTEGER :: nid_dim_nrho_lmhd
     INTEGER :: nid_dm1_nrho_mist
     INTEGER :: nid_dim_nrho_mist
     INTEGER :: nid_dm1_nrho_nbi
     INTEGER :: nid_dim_nrho_nbi
     INTEGER :: nid_dm1_nrho_pel
     INTEGER :: nid_dim_nrho_pel
     INTEGER :: nid_dm1_nrho_rad
     INTEGER :: nid_dim_nrho_rad
     INTEGER :: nid_dm1_nrho_rw
     INTEGER :: nid_dim_nrho_rw
     INTEGER :: nid_dim_nr_rip
     INTEGER :: nid_dim_nspec_all
     INTEGER :: nid_dp1_nspec_all
     INTEGER :: nid_dim_nspec_alla
     INTEGER :: nid_dp1_nspec_alla
     INTEGER :: nid_dim_nspec_beam
     INTEGER :: nid_dim_nspec_fusion
     INTEGER :: nid_dim_nspec_gas
     INTEGER :: nid_dim_nspec_imp0
     INTEGER :: nid_dim_nspec_impi
     INTEGER :: nid_dim_nspec_rfmin
     INTEGER :: nid_dim_nspec_th
     INTEGER :: nid_dp1_nspec_th
     INTEGER :: nid_dim_nspec_tha
     INTEGER :: nid_dp1_nspec_tha
     INTEGER :: nid_dim_nth_eq
     INTEGER :: nid_dim_ntrcat
     INTEGER :: nid_dim_num_rzlim
     INTEGER :: nid_dim_nxs
     INTEGER :: nid_dim_nz
     INTEGER :: nid_dim_nz_rip
     INTEGER :: nid_dim_n_d_einj_standard
     INTEGER :: nid_dim_n_h_einj_standard
     INTEGER :: nid_dim_n_t_einj_standard
     INTEGER :: nid_clen_32
     INTEGER :: nid_clen_256
     INTEGER :: nid_clen_80


  END TYPE nidlist

END MODULE ps_nidlist_defn

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_6(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%PsiRZ)) THEN
     status = nf90_inq_varid(icdf,"PsiRZ",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"PsiRZ")
     ELSE
        status = nf90_get_var(icdf,varid,ss%PsiRZ)
        IF(status.NE.NF90_NOERR) THEN
           ss%PsiRZ = 0.0_rspec
           CALL ncerr_name(2,status,"PsiRZ")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Psi_to_machine_axis",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Psi_to_machine_axis")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Psi_to_machine_axis)
     IF(status.NE.NF90_NOERR) THEN
        ss%Psi_to_machine_axis = 0.0_rspec
        CALL ncerr_name(2,status,"Psi_to_machine_axis")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psmom_errck)) THEN
     status = nf90_inq_varid(icdf,"psmom_errck",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psmom_errck")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psmom_errck)
        IF(status.NE.NF90_NOERR) THEN
           ss%psmom_errck = 0.0_rspec
           CALL ncerr_name(2,status,"psmom_errck")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psmom_nc)) THEN
     status = nf90_inq_varid(icdf,"psmom_nc",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psmom_nc")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psmom_nc)
        IF(status.NE.NF90_NOERR) THEN
           ss%psmom_nc = 0.0_rspec
           CALL ncerr_name(2,status,"psmom_nc")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%psmom_num)) THEN
     status = nf90_inq_varid(icdf,"psmom_num",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"psmom_num")
     ELSE
        status = nf90_get_var(icdf,varid,ss%psmom_num)
        IF(status.NE.NF90_NOERR) THEN
           ss%psmom_num = " "
           CALL ncerr_name(2,status,"psmom_num")
        ELSE
           CALL denull_vec(ss%psmom_num,ss%npsmom)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%P_eq)) THEN
     status = nf90_inq_varid(icdf,"P_eq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"P_eq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%P_eq)
        IF(status.NE.NF90_NOERR) THEN
           ss%P_eq = 0.0_rspec
           CALL ncerr_name(2,status,"P_eq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_ALL)) THEN
     status = nf90_inq_varid(icdf,"qatom_ALL",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_ALL")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_ALL)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_ALL = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_ALL")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_ALLA)) THEN
     status = nf90_inq_varid(icdf,"qatom_ALLA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_ALLA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_ALLA)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_ALLA = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_ALLA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"qatom_RFMIN",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_RFMIN")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_RFMIN)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_RFMIN = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_RFMIN")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_S)) THEN
     status = nf90_inq_varid(icdf,"qatom_S",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_S")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_S)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_S = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_S")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SA)) THEN
     status = nf90_inq_varid(icdf,"qatom_SA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SA)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SA = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SFUS)) THEN
     status = nf90_inq_varid(icdf,"qatom_SFUS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SFUS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SFUS)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SFUS = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SFUS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SGAS)) THEN
     status = nf90_inq_varid(icdf,"qatom_SGAS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SGAS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SGAS)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SGAS = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SGAS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"qatom_SIMP0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SIMP0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SIMP0)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SIMP0 = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SIMP0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"qatom_SIMPI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SIMPI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SIMPI)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SIMPI = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SIMPI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qatom_SNBI)) THEN
     status = nf90_inq_varid(icdf,"qatom_SNBI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qatom_SNBI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qatom_SNBI)
        IF(status.NE.NF90_NOERR) THEN
           ss%qatom_SNBI = 0.0_rspec
           CALL ncerr_name(2,status,"qatom_SNBI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qbeami)) THEN
     status = nf90_inq_varid(icdf,"qbeami",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qbeami")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qbeami)
        IF(status.NE.NF90_NOERR) THEN
           ss%qbeami = 0.0_rspec
           CALL ncerr_name(2,status,"qbeami")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qcomp_e)) THEN
     status = nf90_inq_varid(icdf,"qcomp_e",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qcomp_e")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qcomp_e)
        IF(status.NE.NF90_NOERR) THEN
           ss%qcomp_e = 0.0_rspec
           CALL ncerr_name(2,status,"qcomp_e")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qcomp_i)) THEN
     status = nf90_inq_varid(icdf,"qcomp_i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qcomp_i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qcomp_i)
        IF(status.NE.NF90_NOERR) THEN
           ss%qcomp_i = 0.0_rspec
           CALL ncerr_name(2,status,"qcomp_i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qie)) THEN
     status = nf90_inq_varid(icdf,"qie",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qie")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qie)
        IF(status.NE.NF90_NOERR) THEN
           ss%qie = 0.0_rspec
           CALL ncerr_name(2,status,"qie")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qioniz)) THEN
     status = nf90_inq_varid(icdf,"qioniz",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qioniz")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qioniz)
        IF(status.NE.NF90_NOERR) THEN
           ss%qioniz = 0.0_rspec
           CALL ncerr_name(2,status,"qioniz")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ql_operator)) THEN
     status = nf90_inq_varid(icdf,"ql_operator",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ql_operator")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ql_operator)
        IF(status.NE.NF90_NOERR) THEN
           ss%ql_operator = " "
           CALL ncerr_name(2,status,"ql_operator")
        ELSE
           CALL denull_vec(ss%ql_operator,ss%nspec_alla+1)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qqcx)) THEN
     status = nf90_inq_varid(icdf,"qqcx",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qqcx")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qqcx)
        IF(status.NE.NF90_NOERR) THEN
           ss%qqcx = 0.0_rspec
           CALL ncerr_name(2,status,"qqcx")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qrot_conv)) THEN
     status = nf90_inq_varid(icdf,"qrot_conv",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qrot_conv")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qrot_conv)
        IF(status.NE.NF90_NOERR) THEN
           ss%qrot_conv = 0.0_rspec
           CALL ncerr_name(2,status,"qrot_conv")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%qrot_diff)) THEN
     status = nf90_inq_varid(icdf,"qrot_diff",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"qrot_diff")
     ELSE
        status = nf90_get_var(icdf,varid,ss%qrot_diff)
        IF(status.NE.NF90_NOERR) THEN
           ss%qrot_diff = 0.0_rspec
           CALL ncerr_name(2,status,"qrot_diff")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_ALL)) THEN
     status = nf90_inq_varid(icdf,"q_ALL",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_ALL")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_ALL)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_ALL = 0.0_rspec
           CALL ncerr_name(2,status,"q_ALL")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_ALLA)) THEN
     status = nf90_inq_varid(icdf,"q_ALLA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_ALLA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_ALLA)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_ALLA = 0.0_rspec
           CALL ncerr_name(2,status,"q_ALLA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_eq)) THEN
     status = nf90_inq_varid(icdf,"q_eq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_eq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_eq)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_eq = 0.0_rspec
           CALL ncerr_name(2,status,"q_eq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"q_RFMIN",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_RFMIN")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_RFMIN)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_RFMIN = 0.0_rspec
           CALL ncerr_name(2,status,"q_RFMIN")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_S)) THEN
     status = nf90_inq_varid(icdf,"q_S",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_S")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_S)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_S = 0.0_rspec
           CALL ncerr_name(2,status,"q_S")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SA)) THEN
     status = nf90_inq_varid(icdf,"q_SA",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SA")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SA)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SA = 0.0_rspec
           CALL ncerr_name(2,status,"q_SA")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SFUS)) THEN
     status = nf90_inq_varid(icdf,"q_SFUS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SFUS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SFUS)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SFUS = 0.0_rspec
           CALL ncerr_name(2,status,"q_SFUS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SGAS)) THEN
     status = nf90_inq_varid(icdf,"q_SGAS",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SGAS")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SGAS)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SGAS = 0.0_rspec
           CALL ncerr_name(2,status,"q_SGAS")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"q_SIMP0",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SIMP0")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SIMP0)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SIMP0 = 0.0_rspec
           CALL ncerr_name(2,status,"q_SIMP0")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"q_SIMPI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SIMPI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SIMPI)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SIMPI = 0.0_rspec
           CALL ncerr_name(2,status,"q_SIMPI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%q_SNBI)) THEN
     status = nf90_inq_varid(icdf,"q_SNBI",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"q_SNBI")
     ELSE
        status = nf90_get_var(icdf,varid,ss%q_SNBI)
        IF(status.NE.NF90_NOERR) THEN
           ss%q_SNBI = 0.0_rspec
           CALL ncerr_name(2,status,"q_SNBI")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%R0_momeq)) THEN
     status = nf90_inq_varid(icdf,"R0_momeq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"R0_momeq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%R0_momeq)
        IF(status.NE.NF90_NOERR) THEN
           ss%R0_momeq = 0.0_rspec
           CALL ncerr_name(2,status,"R0_momeq")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"RAD_Code_Info")
  ELSE
     ilen = len(ss%RAD_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%RAD_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%RAD_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%RAD_Code_Info = " "
        CALL ncerr_name(2,status,"RAD_Code_Info")
     ELSE
        CALL denull(ss%RAD_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"RAD_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"RAD_Data_Info")
  ELSE
     ilen = len(ss%RAD_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%RAD_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%RAD_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%RAD_Data_Info = " "
        CALL ncerr_name(2,status,"RAD_Data_Info")
     ELSE
        CALL denull(ss%RAD_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0i)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinb0i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinb0i)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinb0i = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinb0i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0x)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0x",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinb0x")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinb0x)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinb0x = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinb0x")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinb0xs)) THEN
     status = nf90_inq_varid(icdf,"rate_sinb0xs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinb0xs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinb0xs)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinb0xs = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinb0xs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0i)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinf0i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinf0i)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinf0i = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinf0i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0x)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0x",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinf0x")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinf0x)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinf0x = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinf0x")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rate_sinf0xs)) THEN
     status = nf90_inq_varid(icdf,"rate_sinf0xs",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rate_sinf0xs")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rate_sinf0xs)
        IF(status.NE.NF90_NOERR) THEN
           ss%rate_sinf0xs = 0.0_rspec
           CALL ncerr_name(2,status,"rate_sinf0xs")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Real_ant_coef)) THEN
     status = nf90_inq_varid(icdf,"Real_ant_coef",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Real_ant_coef")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Real_ant_coef)
        IF(status.NE.NF90_NOERR) THEN
           ss%Real_ant_coef = 0.0_rspec
           CALL ncerr_name(2,status,"Real_ant_coef")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_sn)) THEN
     status = nf90_inq_varid(icdf,"res_sn",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"res_sn")
     ELSE
        status = nf90_get_var(icdf,varid,ss%res_sn)
        IF(status.NE.NF90_NOERR) THEN
           ss%res_sn = 0.0_rspec
           CALL ncerr_name(2,status,"res_sn")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_te)) THEN
     status = nf90_inq_varid(icdf,"res_te",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"res_te")
     ELSE
        status = nf90_get_var(icdf,varid,ss%res_te)
        IF(status.NE.NF90_NOERR) THEN
           ss%res_te = 0.0_rspec
           CALL ncerr_name(2,status,"res_te")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_ti)) THEN
     status = nf90_inq_varid(icdf,"res_ti",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"res_ti")
     ELSE
        status = nf90_get_var(icdf,varid,ss%res_ti)
        IF(status.NE.NF90_NOERR) THEN
           ss%res_ti = 0.0_rspec
           CALL ncerr_name(2,status,"res_ti")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%res_tq)) THEN
     status = nf90_inq_varid(icdf,"res_tq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"res_tq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%res_tq)
        IF(status.NE.NF90_NOERR) THEN
           ss%res_tq = 0.0_rspec
           CALL ncerr_name(2,status,"res_tq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%RFMIN_name)) THEN
     status = nf90_inq_varid(icdf,"RFMIN_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"RFMIN_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%RFMIN_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%RFMIN_name = " "
           CALL ncerr_name(2,status,"RFMIN_name")
        ELSE
           CALL denull_vec(ss%RFMIN_name,ss%nspec_rfmin)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_all)) THEN
     status = nf90_inq_varid(icdf,"rfmin_to_all",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rfmin_to_all")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rfmin_to_all)
        IF(status.NE.NF90_NOERR) THEN
           ss%rfmin_to_all = 0
           CALL ncerr_name(2,status,"rfmin_to_all")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rfmin_to_alla)) THEN
     status = nf90_inq_varid(icdf,"rfmin_to_alla",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rfmin_to_alla")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rfmin_to_alla)
        IF(status.NE.NF90_NOERR) THEN
           ss%rfmin_to_alla = 0
           CALL ncerr_name(2,status,"rfmin_to_alla")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%RFMIN_type)) THEN
     status = nf90_inq_varid(icdf,"RFMIN_type",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"RFMIN_type")
     ELSE
        status = nf90_get_var(icdf,varid,ss%RFMIN_type)
        IF(status.NE.NF90_NOERR) THEN
           ss%RFMIN_type = 0
           CALL ncerr_name(2,status,"RFMIN_type")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho)) THEN
     status = nf90_inq_varid(icdf,"rho",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho = 0.0_rspec
           CALL ncerr_name(2,status,"rho")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rhopsi0lh)) THEN
     status = nf90_inq_varid(icdf,"rhopsi0lh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rhopsi0lh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rhopsi0lh)
        IF(status.NE.NF90_NOERR) THEN
           ss%rhopsi0lh = 0.0_rspec
           CALL ncerr_name(2,status,"rhopsi0lh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anom)) THEN
     status = nf90_inq_varid(icdf,"rho_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_anom = 0.0_rspec
           CALL ncerr_name(2,status,"rho_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anom2)) THEN
     status = nf90_inq_varid(icdf,"rho_anom2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_anom2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_anom2)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_anom2 = 0.0_rspec
           CALL ncerr_name(2,status,"rho_anom2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_anomth)) THEN
     status = nf90_inq_varid(icdf,"rho_anomth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_anomth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_anomth)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_anomth = 0.0_rspec
           CALL ncerr_name(2,status,"rho_anomth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_bdy_ns)) THEN
     status = nf90_inq_varid(icdf,"rho_bdy_ns",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_bdy_ns")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_bdy_ns)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_bdy_ns = 0.0_rspec
           CALL ncerr_name(2,status,"rho_bdy_ns")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_omegat",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"rho_bdy_omegat")
  ELSE
     status = nf90_get_var(icdf,varid,ss%rho_bdy_omegat)
     IF(status.NE.NF90_NOERR) THEN
        ss%rho_bdy_omegat = 0.0_rspec
        CALL ncerr_name(2,status,"rho_bdy_omegat")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Te",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"rho_bdy_Te")
  ELSE
     status = nf90_get_var(icdf,varid,ss%rho_bdy_Te)
     IF(status.NE.NF90_NOERR) THEN
        ss%rho_bdy_Te = 0.0_rspec
        CALL ncerr_name(2,status,"rho_bdy_Te")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"rho_bdy_Ti",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"rho_bdy_Ti")
  ELSE
     status = nf90_get_var(icdf,varid,ss%rho_bdy_Ti)
     IF(status.NE.NF90_NOERR) THEN
        ss%rho_bdy_Ti = 0.0_rspec
        CALL ncerr_name(2,status,"rho_bdy_Ti")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_ecrf)) THEN
     status = nf90_inq_varid(icdf,"rho_ecrf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_ecrf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_ecrf)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_ecrf = 0.0_rspec
           CALL ncerr_name(2,status,"rho_ecrf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_eq)) THEN
     status = nf90_inq_varid(icdf,"rho_eq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_eq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_eq)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_eq = 0.0_rspec
           CALL ncerr_name(2,status,"rho_eq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_eq_geo)) THEN
     status = nf90_inq_varid(icdf,"rho_eq_geo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_eq_geo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_eq_geo)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_eq_geo = 0.0_rspec
           CALL ncerr_name(2,status,"rho_eq_geo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_fus)) THEN
     status = nf90_inq_varid(icdf,"rho_fus",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_fus")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_fus)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_fus = 0.0_rspec
           CALL ncerr_name(2,status,"rho_fus")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_gas)) THEN
     status = nf90_inq_varid(icdf,"rho_gas",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_gas")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_gas)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_gas = 0.0_rspec
           CALL ncerr_name(2,status,"rho_gas")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_icrf)) THEN
     status = nf90_inq_varid(icdf,"rho_icrf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_icrf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_icrf)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_icrf = 0.0_rspec
           CALL ncerr_name(2,status,"rho_icrf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_lhrf)) THEN
     status = nf90_inq_varid(icdf,"rho_lhrf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_lhrf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_lhrf)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_lhrf = 0.0_rspec
           CALL ncerr_name(2,status,"rho_lhrf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_lmhd)) THEN
     status = nf90_inq_varid(icdf,"rho_lmhd",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_lmhd")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_lmhd)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_lmhd = 0.0_rspec
           CALL ncerr_name(2,status,"rho_lmhd")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_mist)) THEN
     status = nf90_inq_varid(icdf,"rho_mist",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_mist")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_mist)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_mist = 0.0_rspec
           CALL ncerr_name(2,status,"rho_mist")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_nbi)) THEN
     status = nf90_inq_varid(icdf,"rho_nbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_nbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_nbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_nbi = 0.0_rspec
           CALL ncerr_name(2,status,"rho_nbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_pel)) THEN
     status = nf90_inq_varid(icdf,"rho_pel",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_pel")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_pel)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_pel = 0.0_rspec
           CALL ncerr_name(2,status,"rho_pel")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_rad)) THEN
     status = nf90_inq_varid(icdf,"rho_rad",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_rad")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_rad)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_rad = 0.0_rspec
           CALL ncerr_name(2,status,"rho_rad")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rho_rw)) THEN
     status = nf90_inq_varid(icdf,"rho_rw",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rho_rw")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rho_rw)
        IF(status.NE.NF90_NOERR) THEN
           ss%rho_rw = 0.0_rspec
           CALL ncerr_name(2,status,"rho_rw")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%rlim)) THEN
     status = nf90_inq_varid(icdf,"rlim",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"rlim")
     ELSE
        status = nf90_get_var(icdf,varid,ss%rlim)
        IF(status.NE.NF90_NOERR) THEN
           ss%rlim = 0.0_rspec
           CALL ncerr_name(2,status,"rlim")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_6

!
! Set of trdatbuf subroutines for accessing free boundary data.
!

!
! --------------- tdb_freebdy_timefac ------------
! get the interpolation factor at ztime.  All free boundary data is
! currently mapped to LTIME2.
!
subroutine tdb_freebdy_timefac(d,ztime,it,zf)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  implicit NONE

  type(trdatbuf)       :: d       ! trdatbuf
  real*8,  intent(in)  :: ztime   ! time (seconds)
  integer, intent(out) :: it      ! time bin
  real*8,  intent(out) :: zf      ! interpolation factor w/in bin

  integer :: ilt, int

  ilt = d%ltime2
  int = d%ntime2
  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,ztime,it,zf)
end subroutine tdb_freebdy_timefac

!
! --------------- tdb_freebdy_pretimefac ------------
! get the interpolation factor at ztime for the pre TINIT data.  All pre TINIT data is
! currently mapped to LTIMEC.
!
subroutine tdb_freebdy_pretimefac(d,ztime,it,zf)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  implicit NONE

  type(trdatbuf)       :: d       ! trdatbuf
  real*8,  intent(in)  :: ztime   ! time (seconds)
  integer, intent(out) :: it      ! time bin
  real*8,  intent(out) :: zf      ! interpolation factor w/in bin

  integer :: ilt, int

  ilt = d%ltimec
  int = d%ntimec

  if (ilt<=0 .or. int<=0) then
     print *, '?tdb_freebdy_pretimefac: unexpectedly no TINIT_PRECOIL data'
     call bad_exit
  end if

  call tdbsub_lookup(d%datbuf(ilt:ilt+int-1),int,ztime,it,zf)
end subroutine tdb_freebdy_pretimefac

!
! ------------ tdb_freebdy_dims ----------
! Return the dimensions associated with the free boundary data.
!
subroutine tdb_freebdy_dims(d, npfc)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  implicit NONE

  type(trdatbuf)       :: d       ! trdatbuf
  integer, intent(out) :: npfc    ! number of poloidal field coils or 0 if none

  npfc = d%NXPFC
end subroutine tdb_freebdy_dims


!
! ------------ tdb_freebdy_pfccurs -------------
! Return the poloidal field coil currents at a time.  An error is
! returned if there are no currents or the dimension of the input
! array is incorrect.
!
subroutine tdb_freebdy_pfccurs(d, ztime, n, cur, ier)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  implicit NONE

  type(trdatbuf)       :: d       ! trdatbuf
  real*8,  intent(in)  :: ztime   ! time (seconds)
  integer, intent(in)  :: n       ! number of currents expected
  real*8,  intent(out) :: cur(n)  ! poloidal field coil currents returned
  integer, intent(out) :: ier     ! nonzero on error

  integer :: ldpfc   ! datbuf address of start of pfc data
  integer :: npfc    ! number of currents from trdatbuf
  integer :: nt2     ! number of time points for data
  integer :: it      ! time bin
  integer :: ix      ! loop variable
  real*8  :: zf      ! interpolation factor w/in bin

  integer,external :: lunmsg_tdb

  ier=0

  npfc  = d%NXPFC
  ldpfc = d%LDPFC

  if (ldpfc<=0 .or. npfc<=0) then
     write(lunmsg_tdb(0),'(a)') '?tdb_freebdy_pfccurs: there is no poloidal field coil current data'
     ier=1 ; return
  end if

  if (n/=npfc) then
     write(lunmsg_tdb(0),'(a)')    '?tdb_freebdy_pfccurs: mismatch in number of PFC currents'
     write(lunmsg_tdb(0),'(a,i5)') '      expected:  ', n
     write(lunmsg_tdb(0),'(a,i5)') '      available: ', npfc
     ier=1 ; return
  end if

  call tdb_freebdy_timefac(d,ztime,it,zf)

  nt2 = d%NTIME2
  do ix = 1, npfc
     cur(ix) = (1.d0-zf)*d%datbuf(ldpfc+(it-1)+(ix-1)*nt2)+zf*d%datbuf(ldpfc+it+(ix-1)*nt2)
  end do
end subroutine tdb_freebdy_pfccurs

!
! ------------ tdb_freebdy_pre_pfc_pcur -------------
! Return the poloidal field coil currents and plamsa current at a pre TINIT time.  An error is
! returned if there are no currents or the dimension of the input array is incorrect.
!
subroutine tdb_freebdy_pre_pfc_pcur(d, ztime, n, cur, pcur, ier)
  use trdatbuf_obj
  use tdbsub_uts  ! private

  implicit NONE

  type(trdatbuf)       :: d       ! trdatbuf
  real*8,  intent(in)  :: ztime   ! time (seconds)
  integer, intent(in)  :: n       ! number of currents expected
  real*8,  intent(out) :: cur(n)  ! poloidal field coil currents returned
  real*8,  intent(out) :: pcur    ! plasma current returned, if not defined in input this will be 0.
  integer, intent(out) :: ier     ! nonzero on error

  integer :: ldpfc   ! datbuf address of start of pfc data
  integer :: npfc    ! number of currents from trdatbuf
  integer :: nt2     ! number of time points for data
  integer :: it      ! time bin
  integer :: ix      ! loop variable
  real*8  :: zf      ! interpolation factor w/in bin

  integer,external :: lunmsg_tdb

  ier=0

  npfc  = d%NXPFC
  ldpfc = d%LDPFC_PRE

  if (ldpfc<=0 .or. npfc<=0 .or. d%NTIMEC<=0) then
     write(lunmsg_tdb(0),'(a)') '?tdb_freebdy_pre_pfc_pcur: there is no poloidal field coil current data pre TINIT'
     ier=1 ; return
  end if

  if (n/=npfc) then
     write(lunmsg_tdb(0),'(a)')    '?tdb_freebdy_pre_pfc_pcur: mismatch in number of PFC currents'
     write(lunmsg_tdb(0),'(a,i5)') '      expected:  ', n
     write(lunmsg_tdb(0),'(a,i5)') '      available: ', npfc
     ier=1 ; return
  end if

  call tdb_freebdy_pretimefac(d,ztime,it,zf)

  nt2 = d%NTIMEC
  do ix = 1, npfc
     cur(ix) = (1.d0-zf)*d%datbuf(ldpfc+(it-1)+(ix-1)*nt2)+zf*d%datbuf(ldpfc+it+(ix-1)*nt2)
  end do

  pcur = (1.d0-zf)*d%datbuf(ldpfc+(it-1)+npfc*nt2)+zf*d%datbuf(ldpfc+it+npfc*nt2)
end subroutine tdb_freebdy_pre_pfc_pcur

!..............................................................
!                  SUBROUTINE TR_GETNL_FTEXT
!..............................................................
 
subroutine tr_getnl_ftext(zpath,zrunid,iluni,ierr)
!
  use tr_getnl
  implicit NONE
!
  character*(*) zpath         ! path to file (blank if cwd), input
  character*(*) zrunid        ! runid, input
  integer iluni               ! abs(iluni) = lun for file read (input)
  integer ierr                ! completion code:  0=OK
!
! if iluni.lt.0 the final tr_getnl_lines call is skipped
!
!    read the TRANSP namelist -- filepath and runid provided
!
  integer lt,ilz,ilr,ilzf
  character*196 zfile,zfile2
!
  integer lunzer,ilun
!
!------------------------------------------
!
  ilun=abs(iluni)
!
  lt=lunzer(0)
!
  ilr=len_trim(zrunid)
  if(zpath.eq.' ') then
     zfile=zrunid(1:ilr)//'TR.DAT'
     zfile2=zfile
     call ulower(zfile2)
  else
     ilz=len_trim(zpath)
     if((zpath(ilz:ilz).ne.'/').and.(zpath(ilz:ilz).ne.']')) then
        zfile=zpath(1:ilz)//'/'//zrunid(1:ilr)//'TR.DAT'
     else
        zfile=zpath(1:ilz)//zrunid(1:ilr)//'TR.DAT'
     endif
     ilzf=len_trim(zfile)
     zfile2=zfile
     call ulower(zfile2(ilz+1:ilzf))
  endif
!
  open(unit=ilun,file=zfile,status='old',iostat=ierr)
  if(ierr.ne.0) open(unit=ilun,file=zfile2,status='old',iostat=ierr)
  if(ierr.ne.0) then
     write(lt,*) ' ?? trx_get_nltext:  namelist file open failure.'
     write(lt,*) '    filename was:  ',zfile
     ierr=1
     nltext_nlines=0
     nltext_status=1
     return
  endif
!
!  OK
!
  nltext_status=0
  nltext_nlines=0
!
  if(iluni.gt.0) call tr_getnl_lines(ilun,ierr)
  return
end subroutine tr_getnl_ftext

C-----------------------------------------------------------------------
C  TDB_UNMAP -- INTERPOLATE THE UNMAPPED INPUT PROFILE DATA
C
      SUBROUTINE TDB_UNMAP(d,t, INRIA,IHECE,ZTIME,ILX,INX,ILF, ierr)
C
C  THIS SUBROUTINE IS CALLED FROM PROFLI -- THE PASSED ARGUMENTS
C  ARE ALL PROFLI PASSED ARGUMENTS, DESCRIBED IN THE COMMENTS NEAR
C  THE TOP OF PROFLI.FOR
C
C  INPUT:  INRIA=IABS(INRI),IHECE,ZTIME,ILX,INX,ILF
C  OUTPUT:  t%datusym(...)
C
      use trdatbuf_obj
      use trdatbuf_aux
      IMPLICIT NONE

      type (trdatbuf) :: d
      type (profget) :: t

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ihece,ilx,inx,ilf,inria,ierr,iixtrp,icenr,i,ii,irefl
      INTEGER icen,inc,incf,ippin,ippout,j,ipp,i3,i2,i1,imin,igap
      INTEGER insave,ifreq,ipatch,iisave
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ztime,zxi,zsign,zpf,zslp,zfbin,zfbout,zfcur,zfnew,zdr
      REAL*8 zr1,zd1,zr2,zd2,zrden
!============
C
C  INRIA SPECIFIES THE DATA MAPPING OPTION
C
C  IHECE.EQ.0 IF THIS IS NORMAL PROFILE DATA
C  IHECE.EQ.<harmonic> IF THIS IS ECE DATA
C
C  ZTIME -- INTERPOLATION TARGET TIME
C
C  ILX,INX,ILF -- POINTERS TO THE DATA
C
C  LOCAL STUFF:
      real*8, dimension(:), allocatable :: zxl,ztemp
      real*8 :: rminrd,rmajrd
C
      LOGICAL ILDBUG  ! .TRUE. FOR EXTRA DEBUG OUTPUT
      DATA ILDBUG/.FALSE./
C
      integer isave(2,10),nrsym,nrmaj,nzones,izp1
      integer :: nonlin, lunmsg_tdb
C
C-----------------------------------------------------------------------
C
      IERR=0
      IIXTRP=0
C
      t%ecegap = 0
C
      nonlin = lunmsg_tdb(0)
C
      nrsym = t%nrsym
      nrmaj = t%nrmaj
      nzones = t%nzones
      izp1=nzones+1
      rminrd=0.5_R8*(t%rmajmp(nrmaj)-t%rmajmp(1))
      rmajrd=0.5_R8*(t%rmajmp(nrmaj)+t%rmajmp(1))
C
      allocate(zxl(nrsym),ztemp(nrsym))
C
      IF(IHECE.EQ.0) THEN
C  NON-ECE DATA
         ICENR=2*NZONES+3
         DO I=1,NRSYM
            IF((INRIA.EQ.5).OR.(INRIA.EQ.8)) THEN
               ZXL(I)=t%XIRSYM(I)
               if(inria.eq.8) zxl(i)=abs(zxl(i))*zxl(i)
            else if((inria.eq.6).or.(inria.eq.7)) then
               zxi=t%xirsym(i)
               if(zxi.lt.0.0_R8) then
                  zsign=-1.0_R8
                  zxi=-zxi
               else
                  zsign=+1.0_R8
               endif
               if(zxi.ge.1.0_R8) then
                  zpf=t%plflxg(izp1)+(t%plflxg(izp1)-t%plflxg(nzones))*
     1               (zxi-1.0_R8)/(t%xibdys(izp1)-t%xibdys(nzones))
               else
                  ii=1+nzones*zxi
                  ii=min(nzones,max(1,ii))
 88               continue
                  if(zxi.lt.t%xibdys(ii)) then
                     ii=ii-1
                     go to 88
                  else if(zxi.gt.t%xibdys(ii+1)) then
                     ii=ii+1
                     go to 88
                  endif
                  zpf=t%plflxg(ii)+(t%plflxg(ii+1)-t%plflxg(ii))*
     1               (zxi-t%xibdys(ii))/(t%xibdys(ii+1)-t%xibdys(ii))
                  zpf=max(0.0_R8,zpf)
               endif
               zxl(i)=zsign*zpf/t%plflxg(izp1)
               if(inria.eq.7) zxl(i)=zsign*sqrt(zpf/t%plflxg(izp1))
            ELSE IF(INRIA.EQ.4) THEN
               IREFL=ICENR-(I-ICENR)
               ZXL(I)=0.5_R8*(t%RMJSYM(I)-t%RMJSYM(IREFL))/RMINRD
            ELSE
               ZXL(I)=(t%RMJSYM(I)-RMAJRD)/RMINRD
            ENDIF
         ENDDO
C
         ZSLP=0.0_R8
         CALL INT2D(d%DATBUF(d%LTIME2),d%NTIME2,
     1			d%DATBUF(ILX),INX,
     2			d%DATBUF(ILF),d%NTIME2,INX,
     3			ZTIME,
     4			ZXL, NRSYM,
     4			t%datusym,
     5			ZSLP,
     6			IIXTRP, ILDBUG, IERR, NONLIN)
C
      ELSE
C
C  ECE DATA WITH RADIUS TO FREQUENCY MAP
C
        ICEN=NZONES+1
        ICENR=2*NZONES+3
        ZXL(ICENR)=28.0_R8*IHECE*t%BMIDP(icen)
C
        INC=0
        INCF=0
        IPPIN=ICEN
        IPPOUT=ICEN
        DO J=2,izp1
C  BUILD DBL RESOLUTION FREQUENCY VECTOR -- INTERPOLATION TARGET
C  ORDER IS REVERSED FROM ORDER OF MAJOR RADII
          INC=INC+1
          INCF=INCF+1
C
          IPP=IPPIN
          IPPIN=ICEN-INCF
          ZFBIN=0.5_R8*(t%bmidp(IPPIN)+t%bmidp(IPP))
          ZXL(ICENR+INC)=28.0_R8*IHECE*ZFBIN
C
          IPP=IPPOUT
          IPPOUT=ICEN+INCF
          ZFBOUT=0.5_R8*(t%bmidp(IPPOUT)+t%bmidp(IPP))
          ZXL(ICENR-INC)=28.0_R8*IHECE*ZFBOUT
C
          INC=INC+1
C
          ZXL(ICENR+INC)=28.0_R8*IHECE*t%bmidp(ippin)
          ZXL(ICENR-INC)=28.0_R8*IHECE*t%bmidp(ippout)
C
        ENDDO
C
        ZXL(2)=ZXL(3)*T%RMJSYM(2)/T%RMJSYM(3)
        ZXL(1)=ZXL(3)*T%RMJSYM(1)/T%RMJSYM(3)
C
        I3=4*NZONES+3
        I2=4*NZONES+4
        I1=4*NZONES+5
        ZXL(I2)=ZXL(I3)*T%RMJSYM(I2)/T%RMJSYM(I3)
        ZXL(I1)=ZXL(I3)*T%RMJSYM(I1)/T%RMJSYM(I3)
C
C  DMC Oct 17 1995
C  enforce monotonicity of ZXL (ECE frequencies); print out warning
C  if non-monotonicity occurs.  This indicates a B(R) singularity.
C
        imin=1
        zfcur=zxl(1)
        igap=0
        insave=0
C
        do ifreq=2,nrsym
           zfnew=1.000001_R8*zfcur
           if(zxl(ifreq).le.zfnew) then
              igap=ifreq
              zxl(ifreq)=zfnew
              ipatch=0
           else
              ipatch=1
           endif
           if(ifreq.eq.nrsym) ipatch=1
           if(ipatch.eq.1) then
              if(igap.gt.0) then
                 zdR=t%rmjsym(nrsym+1-imin)-t%rmjsym(nrsym+1-igap)
                 write(nonlin,9900) zdR
                 t%ecegap=max(t%ecegap,zdR)
                 insave=insave+1
                 isave(1,insave)=imin+1
                 isave(2,insave)=igap
                 igap=0
              endif
              imin=ifreq
           endif
           zfcur=zxl(ifreq)
        enddo
 9900   format(' %TDB_UNMAP -- B(R) singularity, ECE gap of approx. ',
     1       1pe11.4,' cm.')
C
        if(igap.gt.0) then
           write(nonlin,9991)
           ierr=99
           go to 900
 9991      format(
     >   ' ?TDB_UNMAP -- highest frequency data pt in B(R) singularity')
        endif
C
        ZSLP=0.0_R8
        CALL INT2D(d%DATBUF(d%LTIME2),d%NTIME2,
     1			d%DATBUF(ILX),INX,
     2			d%DATBUF(ILF),d%NTIME2,INX,
     3			ZTIME,
     4			ZXL, NRSYM,
     4			ZTEMP,
     5			ZSLP,
     6			IIXTRP, ILDBUG, IERR, NONLIN)
C
C  ORDER REVERSAL AGAIN FOR OUTPUT PLOT
C
        DO I=1,NRSYM
          t%datusym(I)=ZTEMP(NRSYM+1-I)
        ENDDO
C
C  patch singularities
        do iisave=1,insave
           i1=nrsym+1-isave(2,iisave)
           i2=nrsym+1-isave(1,iisave)
           if((i1.eq.1).or.(i2.eq.nrsym)) then
              write(nonlin,9992)
 9992         format(
     >             ' ?TDB_UNMAP -- B(R) singularity at bdy of ECE data'/
     >             '           mapping depends on extrapolation.')
              if(i1.eq.1) i1=2
              if(i2.eq.nrsym) i2=nrsym-1
           endif
C
           zr1=t%rmjsym(i1-1)
           zd1=t%datusym(i1-1)
           zr2=t%rmjsym(i2+1)
           zd2=t%datusym(i2+1)
C
           zrden=1.0_R8/(zr2-zr1)
           do ii=i1,i2
              t%datusym(ii)=zd1+(t%rmjsym(ii)-zr1)*(zd2-zd1)*zrden
           enddo
        enddo
C
      ENDIF  ! ECE / not ECE
C
      IF(IERR.GT.0) THEN
        if(IHECE.gt.0) then
           write(nonlin,9901) t%item
        else
           write(nonlin,9902) t%item
        endif
 9901   format(' ?TDB_UNMAP -- INT2D error processing ECE data ',a)
 9902   format(' ?TDB_UNMAP -- INT2D error processing non-ECE data ',a)
      ENDIF
C
 900  continue
      deallocate(zxl,ztemp)
      RETURN
      END

subroutine ps_rzsurf_sdata(ps, idim1,idim2, Rarr,Zarr, idim_rho, inth, &
     ibcR0,zbcR0, ibcR1,zbcR1, ibcZ0,zbcZ0, ibcZ1,zbcZ1, &
     iout,ierr)

  !  Update plasma state "ps" with equilibrium flux surfaces from data
  !  XPLASMA2 implementation -- DMC Feb 2008

  !  All dimensioning is explicit; error checking is minimal.
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated

  integer, intent(in) :: idim1,idim2      ! Rarr & Zarr dimensions
  real(KIND=rspec), intent(in) :: Rarr(idim1,idim2), Zarr(idim1,idim2)

  integer, intent(in) :: idim_rho         ! indicate which dimension is "rho"
  ! 1 for 1st dimension; 2 for 2nd dimension

  integer, intent(in) :: inth             ! "th" dimensions for bdy cond data

  integer, intent(in) :: ibcR0            ! rho=0 BC type code (0="not a knot")
  real(KIND=rspec), intent(in) :: zbcR0(inth)  ! rho=0 BC data

  integer, intent(in) :: ibcR1            ! rho=1 BC type code (1="not a knot")
  real(KIND=rspec), intent(in) :: zbcR1(inth)  ! rho=1 BC data

  integer, intent(in) :: ibcZ0            ! rho=0 BC type code (0="not a knot")
  real(KIND=rspec), intent(in) :: zbcZ0(inth)  ! rho=0 BC data

  integer, intent(in) :: ibcZ1            ! rho=1 BC type code (1="not a knot")
  real(KIND=rspec), intent(in) :: zbcZ1(inth)  ! rho=1 BC data

  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: inrho,inth1,id_rho,id_th,id_R,id_Z,ii,jj,iertmp

  real(KIND=rspec), dimension(:,:), allocatable :: r_geo_xpl,z_geo_xpl
  real(KIND=rspec), dimension(:,:,:), allocatable :: r_dgeo_xpl,z_dgeo_xpl

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  !-------------------------------------------------------------------------
  ! executable code...

  call ps_tagchk('ps_rzsurf_sdata',ps%itag,iout,ierr)
  if(ierr.ne.0) return

  if(ps_debug.ge.2) then
     write(iout,*) 'ps_rzsurf_sdata: set flux surface geometry from'// &
          ' passed data.'
  endif

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_rzsurf_sdata: invalid or unitialized xplasma object.'
     return
  endif

  if(idim_rho.ge.2) then
     inrho=idim2
     inth1=idim1
  else
     inrho=idim1
     inth1=idim2
  endif

  if((inrho.ne.ps%nrho_eq).or.(inth1.ne.ps%nth_eq)) then
     write(iout,*) ' ?ps_rzsurf_sdata:  Rarr and Zarr array dimensions not'// &
          ' consistent with'
     write(iout,*) '  state object rho_eq and th_eq grid sizes: ', &
          ps%nrho_eq, ps%nth_eq
     ierr=999
     return
  endif

  if(inth.ne.inth1) then
     write(iout,*) ' ?ps_rzsurf_sdata:  theta dimension for Rarr and Zarr'
     write(iout,*) '     not consistent with bdy condition data dimension.'
     ierr=999
     return
  endif

  !----------------------
  ! OK...
  !----------------------

  call xplasma_author_set(s,'EQ',iertmp)

  !----------------------

  call xplasma_gridId(s,'RHO_EQ',id_rho)
  call xplasma_gridId(s,'TH_EQ',id_th)

  if(idim_rho.ge.2) then
     call xplasma_rzmag(s,id_th,id_rho, Rarr,Zarr, &
          id_R,id_Z,ierr, &
          ibc0=ibcR0,Rbc0=zbcR0,Zbc0=zbcZ0, &
          ibc1=ibcR1,Rbc1=zbcR1,Zbc1=zbcZ1)
  else
     call xplasma_rzmag(s,id_rho,id_th, Rarr,Zarr, &
          id_R,id_Z,ierr, &
          ibc0=ibcR0,Rbc0=zbcR0,Zbc0=zbcZ0, &
          ibc1=ibcR1,Rbc1=zbcR1,Zbc1=zbcZ1)
  endif

  if(ierr.ne.0) then
     call xplasma_error(s,ierr,iout)
     write(iout,*) ' ?error occured in ps_rzsurf_sdata: (R,Z) load operation.'
     return
  endif

  !----------------------
  !  Now, convert internal representation to equivalent bicubic Hermite;
  !----------------------

  call xplasma_hermitize(s,id_R,iertmp)
  if(iertmp.gt.0) then
     call xplasma_error(s,iertmp,iout)
     ierr=iertmp
  endif

  call xplasma_hermitize(s,id_Z,iertmp)
  if(iertmp.gt.0) then
     call xplasma_error(s,iertmp,iout)
     ierr=iertmp
  endif

  if(ierr.ne.0) then
     write(iout,*) &
          ' ?error occured in ps_rzsurf_sdata: (R,Z) Hermite conversion.'
     return
  endif
  !----------------------

  call xplasma_author_clear(s,'EQ',iertmp)

  !----------------------
  !  then retrieve data and store in state element arrays

  allocate(r_geo_xpl(inth,inrho))
  allocate(z_geo_xpl(inth,inrho))
  allocate(r_dgeo_xpl(3,inth,inrho))
  allocate(z_dgeo_xpl(3,inth,inrho))

  do
     call xplasma_eval_prof(s,id_R,r_geo_xpl,ierr,zcoeff=r_dgeo_xpl)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_update_mhdeq: R_geo fetch error:'
        call xplasma_error(s,ierr,iout)
        exit
     endif

     call xplasma_eval_prof(s,id_Z,z_geo_xpl,ierr,zcoeff=z_dgeo_xpl)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_update_mhdeq: Z_geo fetch error:'
        call xplasma_error(s,ierr,iout)
        exit
     endif

     do jj=1,inth
        do ii=1,inrho
           ps%R_geo(ii,jj) = r_geo_xpl(jj,ii)
           ps%Z_geo(ii,jj) = z_geo_xpl(jj,ii)

           ps%dR_geo_drho(ii,jj) = r_dgeo_xpl(2,jj,ii)
           ps%dR_geo_dth(ii,jj) = r_dgeo_xpl(1,jj,ii)
           ps%d2R_geo_drhodth(ii,jj) = r_dgeo_xpl(3,jj,ii)

           ps%dZ_geo_drho(ii,jj) = z_dgeo_xpl(2,jj,ii)
           ps%dZ_geo_dth(ii,jj) = z_dgeo_xpl(1,jj,ii)
           ps%d2Z_geo_drhodth(ii,jj) = z_dgeo_xpl(3,jj,ii)
        enddo
     enddo
     exit
  enddo

  deallocate(r_geo_xpl,z_geo_xpl)
  deallocate(r_dgeo_xpl,z_dgeo_xpl)

  ! and finally: derived metric flux surface averages and integrals:

  if(ierr.eq.0) then
     call ps_mhdeq_volumes(ps,iout,ierr)
     if(ierr.eq.0) then
        call ps_mhdeq_fsmoms(ps,iout,ierr)
     endif
  endif

end subroutine ps_rzsurf_sdata

subroutine trxplib_ps_write1(ss, ini_flag, ierr)

  ! write a state file  
  ! use the working state (ss) as passed

  ! this routine should only be called internally within trxplib

  use plasma_state_mod
  use trxplib_ps_options
  implicit NONE

  !-----------------------------------
  ! arguments:

  type (plasma_state) :: ss     ! working state
  logical, intent(in) :: ini_flag  ! .TRUE. if called from trxplib_ps_connect
  integer, intent(out) :: ierr  ! status code 0=normal

  !-----------------------------------
  ! local:

  logical :: out_flag
  integer :: lunzer,nonlin,ilun,iws
  character*250 :: spath
  !-----------------------------------

  ierr = 0

  nonlin = lunzer(0)

  if(lheavy) then
     ilun=1
  else
     ilun=0
  endif

  call trx_init_state_obj(ss,ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxplib_ps_write1: trx_init_state_obj error.'
     return
  endif

  out_flag = (ps_file.ne."NONE")

  if(ini_flag) then
     iws=2
  else
     if(out_flag) then
        iws=1
     else
        iws=0
        ilun=0
     endif
  endif

  spath = trim(opath)//'/'//trim(ps_file)

  if(ilun.eq.1) call find_io_unit(ilun)

  call trx_gen_state_obj(ss, ilun, geqdsk_lbl, spath, iws, ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' trxplib_ps_write1: trx_gen_state_obj error detected.'
  endif

end subroutine trxplib_ps_write1

subroutine toray2ps(filenam,powech,curfac,iant,ss,iout,ierr)

  ! extract data from one TORAY run, load Plasma State output profiles
  ! and map TORAY output from netCDF file to the Plasma State.

  use plasma_state_mod
  use ezcdf

  implicit NONE

  character*(*), intent(in) :: filenam  ! filename, "toray.nc" used if blank

  real*8, intent(in) :: powech   ! ECH injected power, this antenna/run
  real*8, intent(in) :: curfac   ! anomaly factor for current, =1.0 usually

  integer, intent(in) :: iant    ! antenna index

  type (plasma_state) :: ss      ! Plasma State object

  integer, intent(in) :: iout    ! I/O unit for error messages

  integer, intent(out) :: ierr   ! completion status, 0=OK

  !---------------------
  ! local:

  character*100 zfilenam

  integer :: ncid,dimlens(3),iz,inz,inz_exp
  character*5 xtype

  real*8, dimension(:), allocatable :: pei_data,curi_data,xdata,xtest,tmp_prof
  real*8 :: xtol,zcp,zpp,zincr

  !---------------------

  ierr = 0

  if(filenam.eq.' ') then
     zfilenam = "toray.nc"
  else
     zfilenam = filenam
  endif

  !---------------------
  ! error check...

  if(ss%nrho_ecrf.eq.0) then
     write(iout,*) ' ?toray2ps: ECRF grid has not been set up.'
     ierr=1
  endif

  if(ss%necrf_src.eq.0) then
     write(iout,*) ' ?toray2ps: no ECRF sources in Plasma State (ss).'
     ierr=1
  else if((iant.lt.1).or.(iant.gt.ss%necrf_src)) then
     write(iout,*) ' ?toray2ps: Antenna index: ',iant
     write(iout,*) '  not in expected range: 1 to necrf_src = ',ss%necrf_src
     ierr=1
  endif

  if(.not.allocated(ss%peech_src)) then
     write(iout,*) ' ?toray2ps: Plasma State ECH profiles not allocated.'
     ierr = 1
  endif

  if(ierr.ne.0) return

  ss%peech_src(:,iant) = 0.0d0
  ss%curech_src(:,iant) = 0.0d0

  !---------------------
  inz_exp = ss%nrho_ecrf - 1   ! expected number of bins

  !---------------------
  ! open the file...

  call cdf_open(ncid,trim(zfilenam),'r',ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?toray2ps: NetCDF open failure: '//trim(zfilenam)
     return
  endif

  !---------------------
  ! read the profile size...

  call cdf_inquire(ncid,'xmrho',dimlens,xtype)
  inz = dimlens(1)

  !---------------------
  ! allocate buffers...

  allocate(pei_data(inz),curi_data(inz),xdata(inz),xtest(inz+1))

  !---------------------
  ! read data & close file...

  call cdf_read(ncid,'xmrho',xdata)
  call cdf_read(ncid,'tpowde',pei_data)
  call cdf_read(ncid,'tidept',curi_data)

  call cdf_close(ncid)

  !---------------------
  ! grid  for re-zoning
  xtest(1)=0.0d0
  xtest(2:inz) = 0.5d0*(xdata(1:inz-1)+xdata(2:inz))
  xtest(inz+1)=1.0d0

  !---------------------
  ! OK: load the data: W/bin, A/bin
  allocate(tmp_prof(inz))
  zpp=0.0d0
  zcp=0.0d0
  tmp_prof=0.0d0

  do iz=1,inz
     zincr = pei_data(iz) - zpp
     tmp_prof(iz)= zincr*powech
     zpp = pei_data(iz)
  enddo
  call ps_user_rezone1(xtest, ss%rho_ecrf, tmp_prof,&
       ss%peech_src(1:inz_exp,iant), ierr, state=ss)

  tmp_prof=0.0d0
  do iz=1,inz
     zincr = curi_data(iz) - zcp
     tmp_prof(iz) = zincr*powech*curfac
     zcp = curi_data(iz)
  enddo
  call ps_user_rezone1(xtest, ss%rho_ecrf, tmp_prof,&
       ss%curech_src(1:inz_exp,iant), ierr, state=ss)
  !
  !---------------------
  !  all done.


  deallocate(pei_data,curi_data,xdata,xtest,tmp_prof)

end subroutine toray2ps

logical function ltrx_freebdy(idum)

  use trx_module
  implicit NONE

  !  return .TRUE. if free boundary data are available, o.w. .FALSE.

  integer :: idum    ! dummy argument (not currently used)

  !---------------------------

  ltrx_freebdy = (nRfree.gt.0).AND.(nZfree.gt.0)

end function ltrx_freebdy

subroutine trx_freebdy_RZgridSize(inumR,inumZ)

  use trx_module
  implicit NONE

  !  return the {R,Z} grid sizes for free boundary Psi(R,Z) data
  !  If no such data in the current run, return (0,0)

  integer, intent(out) :: inumR  ! R grid size
  integer, intent(out) :: inumZ  ! Z grid size
  !---------------------------

  inumR = nRfree
  inumZ = nZfree

end subroutine trx_freebdy_RZgridSize

subroutine trx_freebdy_RZminmax(zRmin,zRmax,zZmin,zZmax)

  use trx_module
  implicit NONE

  !  return the {R,Z} grid limits for free boundary Psi(R,Z) data
  !  If no such data in the current run, return (0,0,0,0)

  real*8, intent(out) :: zRmin,zRmax  ! R grid limits (m)
  real*8, intent(out) :: zZmin,zZmax  ! Z grid limits (m)
  !---------------------------

  if(nRfree.eq.0) then
     zRmin=0
     zRmax=0
  else
     zRmin=Rgrid_free(1)
     zRmax=Rgrid_free(nRfree)
  endif

  if(nZfree.eq.0) then
     zZmin=0
     zZmax=0
  else
     zZmin=Zgrid_free(1)
     zZmax=Zgrid_free(nZfree)
  endif

end subroutine trx_freebdy_RZminmax

subroutine trx_freebdy_RZgrids(inRmax,inRgot,zRgrid,inZmax,inZgot,zZgrid,ierr)

  use trx_module
  implicit NONE

  !  return the {R,Z} grids for free boundary data.
  !  If no such data in the current run, return zeroes in (inRgot,inZgot);
  !  ierr=0 is returned even if there is no data.

  !  The error return code ierr is set only if the array sizes provided are
  !  to small to receive the grid data.

  integer, intent(in) :: inRmax       ! R grid passed array size
  integer, intent(out) :: inRgot      ! actual number of data points returned
  real*8 :: zRgrid(inRmax)      ! the grid in zRgrid(1:inRgot)

  integer, intent(in) :: inZmax       ! Z grid passed array size
  integer, intent(out) :: inZgot      ! actual number of data points returned
  real*8 :: zZgrid(inZmax)      ! the grid in zZgrid(1:inZgot)

  integer, intent(out) :: ierr        ! completion code (0=OK)
  !---------------------------
  integer :: lunzer
  !---------------------------

  ierr = 0
  inRgot = 0
  inZgot = 0

  if(nRfree.eq.0) return
  if(nZfree.eq.0) return

  if(nRfree.gt.inRmax) then
     write(lunzer(0),*) ' ?trx_freebdy_RZgrids: array size too small:'
     write(lunzer(0),*) '  array size inRmax=',inRmax,'; need at least: ',nRfree
     ierr=1
  endif

  if(nZfree.gt.inZmax) then
     write(lunzer(0),*) ' ?trx_freebdy_RZgrids: array size too small:'
     write(lunzer(0),*) '  array size inZmax=',inZmax,'; need at least: ',nZfree
     ierr=1
  endif

  if(ierr.ne.0) return

  inRgot = nRfree
  inZgot = nZfree
  zRgrid(1:inRgot) = Rgrid_free
  zZgrid(1:inZgot) = Zgrid_free

end subroutine trx_freebdy_RZgrids

subroutine ps_mhdeq_pchk(ps,ipprime,insmoo,rho_smoo,delrho_smoo,iout,ierr)

  !  Given a state "ps" which imbeds an equilibrium representation read
  !  from a g file, update the pressure profile to improve smoothness of 
  !  grad(P).

  !  Two options are provided:

  !     ipprime=1 -- recompute pressure by integrating dP/dpsi in from
  !                  the edge, starting from the existing P(bdy).

  !     explicit smoothing -- [rho_smoo(1:insmoo),delrho_smoo(1:insmoo)]
  !                  to specify radially varying smoothing using a moving
  !                  triangular weighted average

  !                  Psmoo(rho) = avg[rho-delrho_smoo:rho+delrho_smoo]{P(rho)}

  !                  rho_smoo must be monotonic increasing but need not cover
  !                  [0:1] and may contain just one point (insmoo=1 OK).

  !                  delrho_smoo=0.0 means no smoothing; 
  !                        0.0 <= delrho_smoo(j) <= 0.2 expected everywhere.

  !                  delrho_smoo is interpolated linearly (and extrapolated 
  !                  flat) to cover the rho of the pressure profile data.

  !  NOTE: this routine is related to ps_update_mhdeq -- it assumes xplasma
  !        data to be present that was read from a G-eqdsk file.  Therefore,
  !        this routine should be called only just after a state has been 
  !        loaded from G-eqdsk by ps_update_mhdeq(...).
  !        
  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions

  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps       ! plasma state object to be updated

  integer, intent(in) :: ipprime  ! =0: no PPRIME correction; =1: use PPRIME

  integer, intent(in) :: insmoo   ! number of smoothing parameter data points
  real(KIND=rspec), intent(in) :: rho_smoo(insmoo)     ! rho values
  real(KIND=rspec), intent(in) :: delrho_smoo(insmoo)  ! values vs rho

  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  integer :: ii,indx,id_p,ismoo,imono,irange,inrho,idum1,idum2

  type (interp_object) :: xobj
  type (xplasma), pointer :: s

  real(KIND=rspec), dimension(:), allocatable :: pp,psm,del,eps
  real(KIND=rspec) :: zrho,zrhop,zbc0,zbc1,zdum1
  !-----------------------
  !  argument error checking

  ierr=0

  ismoo=0

  if((ipprime.lt.0).or.(ipprime.gt.1)) then
     write(iout,*) ' ?ps_mhdeq_pchk: "ipprime" argument value invalid: ', &
          ipprime
     write(iout,*) '  0 or 1 was expected.'
     ierr = ierr + 1
  endif

  imono=1
  irange=1

  zrho=0.0_rspec

  do ii=1,insmoo
     zrhop=zrho
     zrho=max(0.0_rspec,min(1.0_rspec, rho_smoo(ii)))

     if((rho_smoo(ii).lt.-0.001_rspec).or.(rho_smoo(ii).gt.1.001_rspec)) then
        if(imono.eq.1) then
           write(iout,*) ' ?ps_mhdeq_pchk: rho_smoo value not btw 0 and 1: ', &
                rho_smoo(ii)
           imono=0
        endif
        ierr = ierr + 1
     endif

     if((delrho_smoo(ii).lt.-0.001_rspec).or. &
          (delrho_smoo(ii).gt.0.201_rspec)) then
        if(irange.eq.1) then
           write(iout,*) &
                ' ?ps_mhdeq_pchk: delrho_smoo value not btw 0.0 and0.2: ', &
                delrho_smoo(ii)
           irange=0
        endif
        ierr = ierr + 1
     endif

     if(ii.gt.1) then
        if(zrho.le.zrhop) then
           if(imono.eq.1) then
              write(iout,*) &
                   ' ?ps_mhdeq_pchk: rho_smoo(...) not monotonic: ', &
                   zrho,zrhop
              imono=0
           endif
           ierr = ierr + 1
        endif
     endif

     if(delrho_smoo(ii).gt.0.0_rspec) ismoo = 1
  enddo

  if(ierr.ne.0) then
     ierr=9999
     write(iout,*) ' ?ps_mhdeq_pchk: argument input data error.'
     return
  endif

  if((ismoo.eq.0).and.(ipprime.eq.0)) then
     return  ! nothing to be done
  endif

  !------------------------------------------------------
  !  OK... process data...

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_profId(s,'P',id_p)

  if(ipprime.eq.1) then
     call xplasma_geqdsk_ppadj(s,ierr,match_auth=.TRUE.)
  endif

  call xplasma_eval_prof(s,id_p,ps%rho_eq,ps%p_eq, ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_pchk: xplasma P profile eval error:'
     call xplasma_error(s,ierr,iout)
     ierr=9999
     return
  endif

  if(ismoo.eq.0) return

  inrho = ps%nrho_eq
  allocate(pp(inrho),psm(inrho),del(inrho),eps(inrho))

  eps = 1.0e20_rspec

  pp = ps%p_eq
  psm = 0.0_rspec

  indx = 1
  do ii=1,inrho
     if(ps%rho_eq(ii).le.rho_smoo(1)) then
        del(ii)=delrho_smoo(1)
     else if(ps%rho_eq(ii).ge.rho_smoo(insmoo)) then
        del(ii)=delrho_smoo(insmoo)

     else
        do 
           if(ps%rho_eq(ii).gt.rho_smoo(indx+1)) then
              indx=indx+1
           else
              exit
           endif
        enddo

        del(ii) = delrho_smoo(indx) + (ps%rho_eq(ii)-rho_smoo(indx))* &
             (delrho_smoo(indx+1)-delrho_smoo(indx))/ &
             (rho_smoo(indx+1)-rho_smoo(indx))
     endif
  enddo

  zbc0=1.0_rspec   ! dP/drho -> 0 @ rho=0
  zbc1=0.5_rspec   ! intermediate smoothing BC @ rho=1

  call r8filtr6(ps%rho_eq, pp, psm, inrho, eps, inrho, eps(1:1), 0, del, &
       0,eps(1), 0,del(1), zbc0, zbc1, zdum1, idum1,idum2)

  ps%p_eq = psm

  deallocate(pp,psm,del,eps)

end subroutine ps_mhdeq_pchk

subroutine trx_trdatbuf_connect(iwarn)
 
  ! connect to TRDATBUF (TRANSP input data) dataset, if available

  ! mod DMC May 2009 -- add PH.CDF data to MDS+ disk cache, if flags are set

  use trx_module
  implicit NONE

  integer, intent(out) :: iwarn

  !------------------------------------
  integer :: lunzer,icdf,imiss,ier_cache
  character*200 zfile

  logical mds_cache_active,mds_cache_exclusive
  external mds_cache_active,mds_cache_exclusive

  !------------------------------------

  iwarn=0
  if(d_data_avail) return

  if(.not.d_init_flag) then
     call trdatbuf_init(d)
     d_init_flag = .TRUE.
  else
     call trdatbuf_reInit(d)
  endif

  if(mds_arch_flag) then

     iwarn=1
     imiss=0
     if(mds_cache_active(0)) then
        ! try to read from MDS+ cache
        call mds_cache_fname(0,'PH.CDF',zfile,ier_cache)
        if(ier_cache.ne.0) then
           if(mds_cache_exclusive(0)) then
              write(lunzer(0),*) &
                   ' ?trx_trdatbuf_connect: cache software error.'
              write(lunzer(0),*) &
                   '  RPLOT_CACHE_ONLY = TRUE -> no trdatbuf data.'
              iwarn=1
              return
           else
              write(lunzer(0),*) &
                   ' %trx_trdatbuf_connect: cache software error; revert to MDS+'
           endif
        else
           ! filename OK; open then read...
           call trdatbuf_open(zfile,"R",icdf)
           if(icdf.eq.0) then
              if(mds_cache_exclusive(0)) then
                 write(lunzer(0),*) &
                      ' ?trx_trdatbuf_connect: trdatbuf cache file not found.'
                 write(lunzer(0),*) &
                      '  RPLOT_CACHE_ONLY = TRUE -> no trdatbuf data.'
                 iwarn=1
                 return
              else
                 write(lunzer(0),*) &
                      ' %trx_trdatbuf_connect: cache miss, revert to MDS+'
                 imiss=1
              endif
           else
              ! file opened OK; read...
              call trdatbuf_read(icdf,d,iwarn)
              call trdatbuf_close(icdf)
              if(iwarn.ne.0) then
                 if(mds_cache_exclusive(0)) then
                    write(lunzer(0),*) &
                         ' ?trx_trdatbuf_connect: cache file read error.'
                    write(lunzer(0),*) &
                         '  RPLOT_CACHE_ONLY = TRUE -> no trdatbuf data.'
                    iwarn=1
                    return
                 else
                    write(lunzer(0),*) &
                         ' %trx_trdatbuf_connect: cache read error, revert to MDS+'
                    imiss=1
                 endif
              else
                 d_data_avail = .TRUE.  ! cache data read OK; iwarn=0 now
              endif
           endif
        endif

     endif

     if(iwarn.ne.0) then
        ! try read from MDS+ tree

        call rd_trdatbuf_mds(d,iwarn)
        if(iwarn.ne.0) then
           write(lunzer(0),*) ' %trx_trdatbuf_connect: no experimental data in MDS+ tree'
        else
           d_data_avail = .TRUE.
           if(imiss.eq.1) then
              ! cache is active; attempt cache file write
              call trdatbuf_open(zfile,"W",icdf)
              if(icdf.eq.0) then
                 ier_cache=1
              else
                 call trdatbuf_write(icdf,d,ier_cache)
                 call trdatbuf_close(icdf)
              endif
              if(ier_cache.ne.0) then
                 write(lunzer(0),*) ' %trx_datbuf_connect: cache write failed.'
              endif
           endif
        endif
     endif

  else
     
     ! try read from file

     zfile = trim(file_path)//'PH.CDF'

     call trdatbuf_open(zfile,"r",icdf)
     call trdatbuf_read(icdf,d,iwarn)
     call trdatbuf_close(icdf)

     if(iwarn.ne.0) then
        write(lunzer(0),*) ' %trx_trdatbuf_connect: experimental data file not found.'
     else
        d_data_avail = .TRUE.
     endif

  endif

end subroutine trx_trdatbuf_connect

subroutine trx_getcrlim(ncirlm,crlimR,crlimZ,crlimrad,ierr)
!
!  read TRANSP circle limiter information from namelist
!
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  integer, intent(in) :: ncirlm        ! expected number of circular limiters
!
! output:
!
  real*8 crlimR(ncirlm),crlimZ(ncirlm) ! (R,Z) of centers of circles
  real*8 crlimrad(ncirlm)              ! radii of circular limiters
!
  integer, intent(out) :: ierr         ! completion code, 0=OK
!
!---------------------------------
!
  integer istat
  integer lt,lunzer
!
!---------------------------------
  ierr = 0
!
  lt=lunzer(0)
  call tr_getnl_r8vec('CRLMR1',crlimR,ncirlm,istat)
  if(istat.ne.ncirlm) then
     write(lt,*) ' %trx_getcrlim:  tr_getnl_r8vec(CRLMR1) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=ncirlm=',ncirlm
     if(istat.lt.ncirlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        crlimR(istat+1:ncirlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
 
!
  call tr_getnl_r8vec('CRLMY1',crlimZ,ncirlm,istat)
  if(istat.ne.ncirlm) then
     write(lt,*) ' %trx_getcrlim:  tr_getnl_r8vec(CRLMY1) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=ncirlm=',ncirlm
     if(istat.lt.ncirlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        crlimZ(istat+1:ncirlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
 
!
  call tr_getnl_r8vec('CRLMRD',crlimrad,ncirlm,istat)
  if(istat.ne.ncirlm) then
     write(lt,*) ' %trx_getcrlim:  tr_getnl_r8vec(CRLMRD) returned istat = ', &
          istat
     write(lt,*) '  expected:  istat=ncirlm=',ncirlm
     if(istat.lt.ncirlm) then
        write(lt,*) ' %too few values; 0.0 assumed for remainder.'
        crlimrad(istat+1:ncirlm)=0.0_R8
     else
        write(lt,*) ' ?too many values.'
        ierr=1
        return
     endif
  endif
!
! convert to meters
!
  crlimR=0.01_R8*crlimR
  crlimZ=0.01_R8*crlimZ
  crlimrad=0.01_R8*crlimrad
!
  return
  end

  !
  ! **generated by gensis_f90.py -- do not edit!
  !
 
!-----------------------------------------
 
subroutine trdatbuf_def_cdf(ncid,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  write PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
  include 'netcdf.inc'
 
  integer, intent(in) :: ncid    ! NetCDF dataset ID
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  integer :: ilen,j, ier, status
  integer :: idum = 0
 
  !-------------------------
  kerr = 0
 
  ilen = z%lfree - 1
 
  CALL phcdf_define_int(ncid,'LADR_ZA',1)
  CALL phcdf_define_int(ncid,'LADR_ZAF',1)
  CALL phcdf_define_int(ncid,'LAEPDE',1)
  CALL phcdf_define_int(ncid,'LAEPDP',1)
  CALL phcdf_define_int(ncid,'LAEPE',1)
  CALL phcdf_define_int(ncid,'LAEPMAP',1)
  CALL phcdf_define_int(ncid,'LAEPMU',1)
  CALL phcdf_define_int(ncid,'LAEPP',1)
  CALL phcdf_define_int(ncid,'LAEPSP',1)
  CALL phcdf_define_int(ncid,'LAEPTS',1)
  CALL phcdf_define_int(ncid,'LAIMPS',1)
  CALL phcdf_define_int(ncid,'LAIMPX',1)
  CALL phcdf_define_int(ncid,'LDATALP',1)
  CALL phcdf_define_int(ncid,'LDATBDI',1)
  CALL phcdf_define_int(ncid,'LDATCUR',1)
  CALL phcdf_define_int(ncid,'LDATDFL',1)
  CALL phcdf_define_int(ncid,'LDATDTG',1)
  CALL phcdf_define_int(ncid,'LDATDTS',1)
  CALL phcdf_define_int(ncid,'LDATDTX',1)
  CALL phcdf_define_int(ncid,'LDATEDI',1)
  CALL phcdf_define_int(ncid,'LDATEHP',1)
  CALL phcdf_define_int(ncid,'LDATELI',1)
  CALL phcdf_define_int(ncid,'LDATFGW',1)
  CALL phcdf_define_int(ncid,'LDATFIE',1)
  CALL phcdf_define_int(ncid,'LDATFMN',1)
  CALL phcdf_define_int(ncid,'LDATFMX',1)
  CALL phcdf_define_int(ncid,'LDATGAS',1)
  CALL phcdf_define_int(ncid,'LDATGF3',1)
  CALL phcdf_define_int(ncid,'LDATGF4',1)
  CALL phcdf_define_int(ncid,'LDATGF6',1)
  CALL phcdf_define_int(ncid,'LDATGFD',1)
  CALL phcdf_define_int(ncid,'LDATGFH',1)
  CALL phcdf_define_int(ncid,'LDATGFT',1)
  CALL phcdf_define_int(ncid,'LDATGIE',1)
  CALL phcdf_define_int(ncid,'LDATHAL',1)
  CALL phcdf_define_int(ncid,'LDATIBM',1)
  CALL phcdf_define_int(ncid,'LDATIEC',1)
  CALL phcdf_define_int(ncid,'LDATIIC',1)
  CALL phcdf_define_int(ncid,'LDATILH',1)
  CALL phcdf_define_int(ncid,'LDATL2B',1)
  CALL phcdf_define_int(ncid,'LDATLAD',1)
  CALL phcdf_define_int(ncid,'LDATLID',1)
  CALL phcdf_define_int(ncid,'LDATNTX',1)
  CALL phcdf_define_int(ncid,'LDATOGF',1)
  CALL phcdf_define_int(ncid,'LDATORC',1)
  CALL phcdf_define_int(ncid,'LDATPBE',1)
  CALL phcdf_define_int(ncid,'LDATPBI',1)
  CALL phcdf_define_int(ncid,'LDATPEB',1)
  CALL phcdf_define_int(ncid,'LDATPEC',1)
  CALL phcdf_define_int(ncid,'LDATPF0',1)
  CALL phcdf_define_int(ncid,'LDATPFH',1)
  CALL phcdf_define_int(ncid,'LDATPFL',1)
  CALL phcdf_define_int(ncid,'LDATPIB',1)
  CALL phcdf_define_int(ncid,'LDATPIC',1)
  CALL phcdf_define_int(ncid,'LDATPLF',1)
  CALL phcdf_define_int(ncid,'LDATPLH',1)
  CALL phcdf_define_int(ncid,'LDATPOS',1)
  CALL phcdf_define_int(ncid,'LDATRBZ',1)
  CALL phcdf_define_int(ncid,'LDATRC3',1)
  CALL phcdf_define_int(ncid,'LDATRC4',1)
  CALL phcdf_define_int(ncid,'LDATRC6',1)
  CALL phcdf_define_int(ncid,'LDATRCD',1)
  CALL phcdf_define_int(ncid,'LDATRCH',1)
  CALL phcdf_define_int(ncid,'LDATRCT',1)
  CALL phcdf_define_int(ncid,'LDATRCY',1)
  CALL phcdf_define_int(ncid,'LDATRMN',1)
  CALL phcdf_define_int(ncid,'LDATRTP',1)
  CALL phcdf_define_int(ncid,'LDATSBT',1)
  CALL phcdf_define_int(ncid,'LDATSF3',1)
  CALL phcdf_define_int(ncid,'LDATSFA',1)
  CALL phcdf_define_int(ncid,'LDATSFL',1)
  CALL phcdf_define_int(ncid,'LDATSFP',1)
  CALL phcdf_define_int(ncid,'LDATSFT',1)
  CALL phcdf_define_int(ncid,'LDATSP3',1)
  CALL phcdf_define_int(ncid,'LDATTET',1)
  CALL phcdf_define_int(ncid,'LDATTGF',1)
  CALL phcdf_define_int(ncid,'LDATTIT',1)
  CALL phcdf_define_int(ncid,'LDATTPI',1)
  CALL phcdf_define_int(ncid,'LDATTQT',1)
  CALL phcdf_define_int(ncid,'LDATTRC',1)
  CALL phcdf_define_int(ncid,'LDATTRF',1)
  CALL phcdf_define_int(ncid,'LDATTXI',1)
  CALL phcdf_define_int(ncid,'LDATVPH',1)
  CALL phcdf_define_int(ncid,'LDATVSB',1)
  CALL phcdf_define_int(ncid,'LDATVSF',1)
  CALL phcdf_define_int(ncid,'LDATXKF',1)
  CALL phcdf_define_int(ncid,'LDATZEF',1)
  CALL phcdf_define_int(ncid,'LDATZFA',1)
  CALL phcdf_define_int(ncid,'LDATZIM',1)
  CALL phcdf_define_int(ncid,'LDATZPL',1)
  CALL phcdf_define_int(ncid,'LDMDF',1)
  CALL phcdf_define_int(ncid,'LDMFR',1)
  CALL phcdf_define_int(ncid,'LDMMX',1)
  CALL phcdf_define_int(ncid,'LDMSE',1)
  CALL phcdf_define_int(ncid,'LDPFC',1)
  CALL phcdf_define_int(ncid,'LDPFC_PRE',1)
  CALL phcdf_define_int(ncid,'LEFD0',1)
  CALL phcdf_define_int(ncid,'LEFDB',1)
  CALL phcdf_define_int(ncid,'LEFDP',1)
  CALL phcdf_define_int(ncid,'LEFDQ',1)
  CALL phcdf_define_int(ncid,'LEFDR',1)
  CALL phcdf_define_int(ncid,'LEFDS',1)
  CALL phcdf_define_int(ncid,'LFAEPA',1)
  CALL phcdf_define_int(ncid,'LFAEPP',1)
  CALL phcdf_define_int(ncid,'LFAXR',1)
  CALL phcdf_define_int(ncid,'LFBOL',1)
  CALL phcdf_define_int(ncid,'LFBPA',1)
  CALL phcdf_define_int(ncid,'LFBPB',1)
  CALL phcdf_define_int(ncid,'LFD2F',1)
  CALL phcdf_define_int(ncid,'LFDE2',1)
  CALL phcdf_define_int(ncid,'LFDF3',1)
  CALL phcdf_define_int(ncid,'LFDF4',1)
  CALL phcdf_define_int(ncid,'LFDF6',1)
  CALL phcdf_define_int(ncid,'LFDFD',1)
  CALL phcdf_define_int(ncid,'LFDFH',1)
  CALL phcdf_define_int(ncid,'LFDFT',1)
  CALL phcdf_define_int(ncid,'LFECA',1)
  CALL phcdf_define_int(ncid,'LFECB',1)
  CALL phcdf_define_int(ncid,'LFECF',1)
  CALL phcdf_define_int(ncid,'LFFD0',1)
  CALL phcdf_define_int(ncid,'LFFDB',1)
  CALL phcdf_define_int(ncid,'LFFDP',1)
  CALL phcdf_define_int(ncid,'LFFDQ',1)
  CALL phcdf_define_int(ncid,'LFFDR',1)
  CALL phcdf_define_int(ncid,'LFFDS',1)
  CALL phcdf_define_int(ncid,'LFFEH',1)
  CALL phcdf_define_int(ncid,'LFFEL',1)
  CALL phcdf_define_int(ncid,'LFGRB',1)
  CALL phcdf_define_int(ncid,'LFIBE',1)
  CALL phcdf_define_int(ncid,'LFIBI',1)
  CALL phcdf_define_int(ncid,'LFJBM',1)
  CALL phcdf_define_int(ncid,'LFJEC',1)
  CALL phcdf_define_int(ncid,'LFJIC',1)
  CALL phcdf_define_int(ncid,'LFLF3',1)
  CALL phcdf_define_int(ncid,'LFLF4',1)
  CALL phcdf_define_int(ncid,'LFLF6',1)
  CALL phcdf_define_int(ncid,'LFLFD',1)
  CALL phcdf_define_int(ncid,'LFLFH',1)
  CALL phcdf_define_int(ncid,'LFLFT',1)
  CALL phcdf_define_int(ncid,'LFLHE',1)
  CALL phcdf_define_int(ncid,'LFLHJ',1)
  CALL phcdf_define_int(ncid,'LFMSE',1)
  CALL phcdf_define_int(ncid,'LFNER',1)
  CALL phcdf_define_int(ncid,'LFNI3',1)
  CALL phcdf_define_int(ncid,'LFNI4',1)
  CALL phcdf_define_int(ncid,'LFNI6',1)
  CALL phcdf_define_int(ncid,'LFNID',1)
  CALL phcdf_define_int(ncid,'LFNIH',1)
  CALL phcdf_define_int(ncid,'LFNIM',1)
  CALL phcdf_define_int(ncid,'LFNIT',1)
  CALL phcdf_define_int(ncid,'LFNMR',1)
  CALL phcdf_define_int(ncid,'LFOMG',1)
  CALL phcdf_define_int(ncid,'LFPRS',1)
  CALL phcdf_define_int(ncid,'LFPSI',1)
  CALL phcdf_define_int(ncid,'LFQBE',1)
  CALL phcdf_define_int(ncid,'LFQBI',1)
  CALL phcdf_define_int(ncid,'LFQEC',1)
  CALL phcdf_define_int(ncid,'LFQIC',1)
  CALL phcdf_define_int(ncid,'LFQPR',1)
  CALL phcdf_define_int(ncid,'LFREE',1)
  CALL phcdf_define_int(ncid,'LFRES',1)
  CALL phcdf_define_int(ncid,'LFRQRFF',1)
  CALL phcdf_define_int(ncid,'LFSBI',1)
  CALL phcdf_define_int(ncid,'LFSIM',300)
  CALL phcdf_define_int(ncid,'LFSYAXR',1)
  CALL phcdf_define_int(ncid,'LFSYBOL',1)
  CALL phcdf_define_int(ncid,'LFSYBPA',1)
  CALL phcdf_define_int(ncid,'LFSYBPB',1)
  CALL phcdf_define_int(ncid,'LFSYD2F',1)
  CALL phcdf_define_int(ncid,'LFSYDE2',1)
  CALL phcdf_define_int(ncid,'LFSYDF3',1)
  CALL phcdf_define_int(ncid,'LFSYDF4',1)
  CALL phcdf_define_int(ncid,'LFSYDF6',1)
  CALL phcdf_define_int(ncid,'LFSYDFD',1)
  CALL phcdf_define_int(ncid,'LFSYDFH',1)
  CALL phcdf_define_int(ncid,'LFSYDFT',1)
  CALL phcdf_define_int(ncid,'LFSYECF',1)
  CALL phcdf_define_int(ncid,'LFSYFEH',1)
  CALL phcdf_define_int(ncid,'LFSYFEL',1)
  CALL phcdf_define_int(ncid,'LFSYGRB',1)
  CALL phcdf_define_int(ncid,'LFSYIBE',1)
  CALL phcdf_define_int(ncid,'LFSYIBI',1)
  CALL phcdf_define_int(ncid,'LFSYJBM',1)
  CALL phcdf_define_int(ncid,'LFSYJEC',1)
  CALL phcdf_define_int(ncid,'LFSYJIC',1)
  CALL phcdf_define_int(ncid,'LFSYLF3',1)
  CALL phcdf_define_int(ncid,'LFSYLF4',1)
  CALL phcdf_define_int(ncid,'LFSYLF6',1)
  CALL phcdf_define_int(ncid,'LFSYLFD',1)
  CALL phcdf_define_int(ncid,'LFSYLFH',1)
  CALL phcdf_define_int(ncid,'LFSYLFT',1)
  CALL phcdf_define_int(ncid,'LFSYLHE',1)
  CALL phcdf_define_int(ncid,'LFSYLHJ',1)
  CALL phcdf_define_int(ncid,'LFSYMSE',1)
  CALL phcdf_define_int(ncid,'LFSYNER',1)
  CALL phcdf_define_int(ncid,'LFSYNI3',1)
  CALL phcdf_define_int(ncid,'LFSYNI4',1)
  CALL phcdf_define_int(ncid,'LFSYNI6',1)
  CALL phcdf_define_int(ncid,'LFSYNID',1)
  CALL phcdf_define_int(ncid,'LFSYNIH',1)
  CALL phcdf_define_int(ncid,'LFSYNIM',1)
  CALL phcdf_define_int(ncid,'LFSYNIT',1)
  CALL phcdf_define_int(ncid,'LFSYNMR',1)
  CALL phcdf_define_int(ncid,'LFSYOMG',1)
  CALL phcdf_define_int(ncid,'LFSYPRS',1)
  CALL phcdf_define_int(ncid,'LFSYQBE',1)
  CALL phcdf_define_int(ncid,'LFSYQBI',1)
  CALL phcdf_define_int(ncid,'LFSYQEC',1)
  CALL phcdf_define_int(ncid,'LFSYQIC',1)
  CALL phcdf_define_int(ncid,'LFSYQPR',1)
  CALL phcdf_define_int(ncid,'LFSYRES',1)
  CALL phcdf_define_int(ncid,'LFSYSBI',1)
  CALL phcdf_define_int(ncid,'LFSYSIM',300)
  CALL phcdf_define_int(ncid,'LFSYTER',1)
  CALL phcdf_define_int(ncid,'LFSYTI2',1)
  CALL phcdf_define_int(ncid,'LFSYTQI',1)
  CALL phcdf_define_int(ncid,'LFSYV2F',1)
  CALL phcdf_define_int(ncid,'LFSYVB2',1)
  CALL phcdf_define_int(ncid,'LFSYVC3',1)
  CALL phcdf_define_int(ncid,'LFSYVC4',1)
  CALL phcdf_define_int(ncid,'LFSYVC6',1)
  CALL phcdf_define_int(ncid,'LFSYVCD',1)
  CALL phcdf_define_int(ncid,'LFSYVCH',1)
  CALL phcdf_define_int(ncid,'LFSYVCT',1)
  CALL phcdf_define_int(ncid,'LFSYVEE',1)
  CALL phcdf_define_int(ncid,'LFSYVIE',1)
  CALL phcdf_define_int(ncid,'LFSYVMO',1)
  CALL phcdf_define_int(ncid,'LFSYVP2',1)
  CALL phcdf_define_int(ncid,'LFSYVPO',1)
  CALL phcdf_define_int(ncid,'LFSYVPR',1)
  CALL phcdf_define_int(ncid,'LFSYVTR',1)
  CALL phcdf_define_int(ncid,'LFSYZF2',1)
  CALL phcdf_define_int(ncid,'LFSYZXR',1)
  CALL phcdf_define_int(ncid,'LFTER',1)
  CALL phcdf_define_int(ncid,'LFTI2',1)
  CALL phcdf_define_int(ncid,'LFTQI',1)
  CALL phcdf_define_int(ncid,'LFULNB',1)
  CALL phcdf_define_int(ncid,'LFV2F',1)
  CALL phcdf_define_int(ncid,'LFVB2',1)
  CALL phcdf_define_int(ncid,'LFVC3',1)
  CALL phcdf_define_int(ncid,'LFVC4',1)
  CALL phcdf_define_int(ncid,'LFVC6',1)
  CALL phcdf_define_int(ncid,'LFVCD',1)
  CALL phcdf_define_int(ncid,'LFVCH',1)
  CALL phcdf_define_int(ncid,'LFVCT',1)
  CALL phcdf_define_int(ncid,'LFVEE',1)
  CALL phcdf_define_int(ncid,'LFVIE',1)
  CALL phcdf_define_int(ncid,'LFVMO',1)
  CALL phcdf_define_int(ncid,'LFVP2',1)
  CALL phcdf_define_int(ncid,'LFVPO',1)
  CALL phcdf_define_int(ncid,'LFVPR',1)
  CALL phcdf_define_int(ncid,'LFVTR',1)
  CALL phcdf_define_int(ncid,'LFZF2',1)
  CALL phcdf_define_int(ncid,'LFZXR',1)
  CALL phcdf_define_int(ncid,'LHLFNB',1)
  CALL phcdf_define_int(ncid,'LLIM',1)
  CALL phcdf_define_int(ncid,'LMOMD',1)
  CALL phcdf_define_int(ncid,'LPELDA',1)
  CALL phcdf_define_int(ncid,'LPHSLH',1)
  CALL phcdf_define_int(ncid,'LPMDF',1)
  CALL phcdf_define_int(ncid,'LPMSE',1)
  CALL phcdf_define_int(ncid,'LPWREC',1)
  CALL phcdf_define_int(ncid,'LPWRLH',1)
  CALL phcdf_define_int(ncid,'LPWRNB',1)
  CALL phcdf_define_int(ncid,'LPWRRF',1)
  CALL phcdf_define_int(ncid,'LRFS',1)
  CALL phcdf_define_int(ncid,'LRMFR',1)
  CALL phcdf_define_int(ncid,'LRMP_BDY1',1)
  CALL phcdf_define_int(ncid,'LRMP_BDY2',1)
  CALL phcdf_define_int(ncid,'LRMSE',1)
  CALL phcdf_define_int(ncid,'LRP2',1)
  CALL phcdf_define_int(ncid,'LRPL',1)
  CALL phcdf_define_int(ncid,'LRPSI',1)
  CALL phcdf_define_int(ncid,'LSEVENT',1)
  CALL phcdf_define_int(ncid,'LSSYAXR',1)
  CALL phcdf_define_int(ncid,'LSSYBOL',1)
  CALL phcdf_define_int(ncid,'LSSYBPA',1)
  CALL phcdf_define_int(ncid,'LSSYBPB',1)
  CALL phcdf_define_int(ncid,'LSSYD2F',1)
  CALL phcdf_define_int(ncid,'LSSYDE2',1)
  CALL phcdf_define_int(ncid,'LSSYDF3',1)
  CALL phcdf_define_int(ncid,'LSSYDF4',1)
  CALL phcdf_define_int(ncid,'LSSYDF6',1)
  CALL phcdf_define_int(ncid,'LSSYDFD',1)
  CALL phcdf_define_int(ncid,'LSSYDFH',1)
  CALL phcdf_define_int(ncid,'LSSYDFT',1)
  CALL phcdf_define_int(ncid,'LSSYECF',1)
  CALL phcdf_define_int(ncid,'LSSYFEH',1)
  CALL phcdf_define_int(ncid,'LSSYFEL',1)
  CALL phcdf_define_int(ncid,'LSSYGRB',1)
  CALL phcdf_define_int(ncid,'LSSYIBE',1)
  CALL phcdf_define_int(ncid,'LSSYIBI',1)
  CALL phcdf_define_int(ncid,'LSSYJBM',1)
  CALL phcdf_define_int(ncid,'LSSYJEC',1)
  CALL phcdf_define_int(ncid,'LSSYJIC',1)
  CALL phcdf_define_int(ncid,'LSSYLF3',1)
  CALL phcdf_define_int(ncid,'LSSYLF4',1)
  CALL phcdf_define_int(ncid,'LSSYLF6',1)
  CALL phcdf_define_int(ncid,'LSSYLFD',1)
  CALL phcdf_define_int(ncid,'LSSYLFH',1)
  CALL phcdf_define_int(ncid,'LSSYLFT',1)
  CALL phcdf_define_int(ncid,'LSSYLHE',1)
  CALL phcdf_define_int(ncid,'LSSYLHJ',1)
  CALL phcdf_define_int(ncid,'LSSYMSE',1)
  CALL phcdf_define_int(ncid,'LSSYNER',1)
  CALL phcdf_define_int(ncid,'LSSYNI3',1)
  CALL phcdf_define_int(ncid,'LSSYNI4',1)
  CALL phcdf_define_int(ncid,'LSSYNI6',1)
  CALL phcdf_define_int(ncid,'LSSYNID',1)
  CALL phcdf_define_int(ncid,'LSSYNIH',1)
  CALL phcdf_define_int(ncid,'LSSYNIM',1)
  CALL phcdf_define_int(ncid,'LSSYNIT',1)
  CALL phcdf_define_int(ncid,'LSSYNMR',1)
  CALL phcdf_define_int(ncid,'LSSYOMG',1)
  CALL phcdf_define_int(ncid,'LSSYPRS',1)
  CALL phcdf_define_int(ncid,'LSSYQBE',1)
  CALL phcdf_define_int(ncid,'LSSYQBI',1)
  CALL phcdf_define_int(ncid,'LSSYQEC',1)
  CALL phcdf_define_int(ncid,'LSSYQIC',1)
  CALL phcdf_define_int(ncid,'LSSYQPR',1)
  CALL phcdf_define_int(ncid,'LSSYRES',1)
  CALL phcdf_define_int(ncid,'LSSYSBI',1)
  CALL phcdf_define_int(ncid,'LSSYSIM',300)
  CALL phcdf_define_int(ncid,'LSSYTER',1)
  CALL phcdf_define_int(ncid,'LSSYTI2',1)
  CALL phcdf_define_int(ncid,'LSSYTQI',1)
  CALL phcdf_define_int(ncid,'LSSYV2F',1)
  CALL phcdf_define_int(ncid,'LSSYVB2',1)
  CALL phcdf_define_int(ncid,'LSSYVC3',1)
  CALL phcdf_define_int(ncid,'LSSYVC4',1)
  CALL phcdf_define_int(ncid,'LSSYVC6',1)
  CALL phcdf_define_int(ncid,'LSSYVCD',1)
  CALL phcdf_define_int(ncid,'LSSYVCH',1)
  CALL phcdf_define_int(ncid,'LSSYVCT',1)
  CALL phcdf_define_int(ncid,'LSSYVEE',1)
  CALL phcdf_define_int(ncid,'LSSYVIE',1)
  CALL phcdf_define_int(ncid,'LSSYVMO',1)
  CALL phcdf_define_int(ncid,'LSSYVP2',1)
  CALL phcdf_define_int(ncid,'LSSYVPO',1)
  CALL phcdf_define_int(ncid,'LSSYVPR',1)
  CALL phcdf_define_int(ncid,'LSSYVTR',1)
  CALL phcdf_define_int(ncid,'LSSYZF2',1)
  CALL phcdf_define_int(ncid,'LSSYZXR',1)
  CALL phcdf_define_int(ncid,'LTABORT',1)
  CALL phcdf_define_int(ncid,'LTAEP',1)
  CALL phcdf_define_int(ncid,'LTFD0',1)
  CALL phcdf_define_int(ncid,'LTFDB',1)
  CALL phcdf_define_int(ncid,'LTFDP',1)
  CALL phcdf_define_int(ncid,'LTFDQ',1)
  CALL phcdf_define_int(ncid,'LTFDR',1)
  CALL phcdf_define_int(ncid,'LTFDS',1)
  CALL phcdf_define_int(ncid,'LTHFS',1)
  CALL phcdf_define_int(ncid,'LTIME1',1)
  CALL phcdf_define_int(ncid,'LTIME2',1)
  CALL phcdf_define_int(ncid,'LTIMEC',1)
  CALL phcdf_define_int(ncid,'LTIMECA',1)
  CALL phcdf_define_int(ncid,'LTIMECB',1)
  CALL phcdf_define_int(ncid,'LTIMLH',1)
  CALL phcdf_define_int(ncid,'LTIMNB',1)
  CALL phcdf_define_int(ncid,'LTIMRF',1)
  CALL phcdf_define_int(ncid,'LTIMRFF',1)
  CALL phcdf_define_int(ncid,'LTPSI',1)
  CALL phcdf_define_int(ncid,'LTSAW',1)
  CALL phcdf_define_int(ncid,'LVLTNB',1)
  CALL phcdf_define_int(ncid,'LXAXR',1)
  CALL phcdf_define_int(ncid,'LXBOL',1)
  CALL phcdf_define_int(ncid,'LXBPA',1)
  CALL phcdf_define_int(ncid,'LXBPB',1)
  CALL phcdf_define_int(ncid,'LXD2F',1)
  CALL phcdf_define_int(ncid,'LXDE2',1)
  CALL phcdf_define_int(ncid,'LXDF3',1)
  CALL phcdf_define_int(ncid,'LXDF4',1)
  CALL phcdf_define_int(ncid,'LXDF6',1)
  CALL phcdf_define_int(ncid,'LXDFD',1)
  CALL phcdf_define_int(ncid,'LXDFH',1)
  CALL phcdf_define_int(ncid,'LXDFT',1)
  CALL phcdf_define_int(ncid,'LXECF',1)
  CALL phcdf_define_int(ncid,'LXFD0',1)
  CALL phcdf_define_int(ncid,'LXFDB',1)
  CALL phcdf_define_int(ncid,'LXFDP',1)
  CALL phcdf_define_int(ncid,'LXFDQ',1)
  CALL phcdf_define_int(ncid,'LXFDR',1)
  CALL phcdf_define_int(ncid,'LXFDS',1)
  CALL phcdf_define_int(ncid,'LXFEH',1)
  CALL phcdf_define_int(ncid,'LXFEL',1)
  CALL phcdf_define_int(ncid,'LXFS',1)
  CALL phcdf_define_int(ncid,'LXGRB',1)
  CALL phcdf_define_int(ncid,'LXIBE',1)
  CALL phcdf_define_int(ncid,'LXIBI',1)
  CALL phcdf_define_int(ncid,'LXJBM',1)
  CALL phcdf_define_int(ncid,'LXJEC',1)
  CALL phcdf_define_int(ncid,'LXJIC',1)
  CALL phcdf_define_int(ncid,'LXLF3',1)
  CALL phcdf_define_int(ncid,'LXLF4',1)
  CALL phcdf_define_int(ncid,'LXLF6',1)
  CALL phcdf_define_int(ncid,'LXLFD',1)
  CALL phcdf_define_int(ncid,'LXLFH',1)
  CALL phcdf_define_int(ncid,'LXLFT',1)
  CALL phcdf_define_int(ncid,'LXLHE',1)
  CALL phcdf_define_int(ncid,'LXLHJ',1)
  CALL phcdf_define_int(ncid,'LXMMX',1)
  CALL phcdf_define_int(ncid,'LXMSE',1)
  CALL phcdf_define_int(ncid,'LXNER',1)
  CALL phcdf_define_int(ncid,'LXNI3',1)
  CALL phcdf_define_int(ncid,'LXNI4',1)
  CALL phcdf_define_int(ncid,'LXNI6',1)
  CALL phcdf_define_int(ncid,'LXNID',1)
  CALL phcdf_define_int(ncid,'LXNIH',1)
  CALL phcdf_define_int(ncid,'LXNIM',1)
  CALL phcdf_define_int(ncid,'LXNIT',1)
  CALL phcdf_define_int(ncid,'LXNMR',1)
  CALL phcdf_define_int(ncid,'LXOMG',1)
  CALL phcdf_define_int(ncid,'LXPFC',1)
  CALL phcdf_define_int(ncid,'LXPRS',1)
  CALL phcdf_define_int(ncid,'LXQBE',1)
  CALL phcdf_define_int(ncid,'LXQBI',1)
  CALL phcdf_define_int(ncid,'LXQEC',1)
  CALL phcdf_define_int(ncid,'LXQIC',1)
  CALL phcdf_define_int(ncid,'LXQPR',1)
  CALL phcdf_define_int(ncid,'LXRES',1)
  CALL phcdf_define_int(ncid,'LXRP2',1)
  CALL phcdf_define_int(ncid,'LXRPL',1)
  CALL phcdf_define_int(ncid,'LXSBI',1)
  CALL phcdf_define_int(ncid,'LXSIM',8)
  CALL phcdf_define_int(ncid,'LXSYAXR',1)
  CALL phcdf_define_int(ncid,'LXSYBOL',1)
  CALL phcdf_define_int(ncid,'LXSYBPA',1)
  CALL phcdf_define_int(ncid,'LXSYBPB',1)
  CALL phcdf_define_int(ncid,'LXSYD2F',1)
  CALL phcdf_define_int(ncid,'LXSYDE2',1)
  CALL phcdf_define_int(ncid,'LXSYDF3',1)
  CALL phcdf_define_int(ncid,'LXSYDF4',1)
  CALL phcdf_define_int(ncid,'LXSYDF6',1)
  CALL phcdf_define_int(ncid,'LXSYDFD',1)
  CALL phcdf_define_int(ncid,'LXSYDFH',1)
  CALL phcdf_define_int(ncid,'LXSYDFT',1)
  CALL phcdf_define_int(ncid,'LXSYECF',1)
  CALL phcdf_define_int(ncid,'LXSYFEH',1)
  CALL phcdf_define_int(ncid,'LXSYFEL',1)
  CALL phcdf_define_int(ncid,'LXSYGRB',1)
  CALL phcdf_define_int(ncid,'LXSYIBE',1)
  CALL phcdf_define_int(ncid,'LXSYIBI',1)
  CALL phcdf_define_int(ncid,'LXSYJBM',1)
  CALL phcdf_define_int(ncid,'LXSYJEC',1)
  CALL phcdf_define_int(ncid,'LXSYJIC',1)
  CALL phcdf_define_int(ncid,'LXSYLF3',1)
  CALL phcdf_define_int(ncid,'LXSYLF4',1)
  CALL phcdf_define_int(ncid,'LXSYLF6',1)
  CALL phcdf_define_int(ncid,'LXSYLFD',1)
  CALL phcdf_define_int(ncid,'LXSYLFH',1)
  CALL phcdf_define_int(ncid,'LXSYLFT',1)
  CALL phcdf_define_int(ncid,'LXSYLHE',1)
  CALL phcdf_define_int(ncid,'LXSYLHJ',1)
  CALL phcdf_define_int(ncid,'LXSYMSE',1)
  CALL phcdf_define_int(ncid,'LXSYNER',1)
  CALL phcdf_define_int(ncid,'LXSYNI3',1)
  CALL phcdf_define_int(ncid,'LXSYNI4',1)
  CALL phcdf_define_int(ncid,'LXSYNI6',1)
  CALL phcdf_define_int(ncid,'LXSYNID',1)
  CALL phcdf_define_int(ncid,'LXSYNIH',1)
  CALL phcdf_define_int(ncid,'LXSYNIM',1)
  CALL phcdf_define_int(ncid,'LXSYNIT',1)
  CALL phcdf_define_int(ncid,'LXSYNMR',1)
  CALL phcdf_define_int(ncid,'LXSYOMG',1)
  CALL phcdf_define_int(ncid,'LXSYPRS',1)
  CALL phcdf_define_int(ncid,'LXSYQBE',1)
  CALL phcdf_define_int(ncid,'LXSYQBI',1)
  CALL phcdf_define_int(ncid,'LXSYQEC',1)
  CALL phcdf_define_int(ncid,'LXSYQIC',1)
  CALL phcdf_define_int(ncid,'LXSYQPR',1)
  CALL phcdf_define_int(ncid,'LXSYRES',1)
  CALL phcdf_define_int(ncid,'LXSYSBI',1)
  CALL phcdf_define_int(ncid,'LXSYSIM',8)
  CALL phcdf_define_int(ncid,'LXSYTER',1)
  CALL phcdf_define_int(ncid,'LXSYTI2',1)
  CALL phcdf_define_int(ncid,'LXSYTQI',1)
  CALL phcdf_define_int(ncid,'LXSYV2F',1)
  CALL phcdf_define_int(ncid,'LXSYVB2',1)
  CALL phcdf_define_int(ncid,'LXSYVC3',1)
  CALL phcdf_define_int(ncid,'LXSYVC4',1)
  CALL phcdf_define_int(ncid,'LXSYVC6',1)
  CALL phcdf_define_int(ncid,'LXSYVCD',1)
  CALL phcdf_define_int(ncid,'LXSYVCH',1)
  CALL phcdf_define_int(ncid,'LXSYVCT',1)
  CALL phcdf_define_int(ncid,'LXSYVEE',1)
  CALL phcdf_define_int(ncid,'LXSYVIE',1)
  CALL phcdf_define_int(ncid,'LXSYVMO',1)
  CALL phcdf_define_int(ncid,'LXSYVP2',1)
  CALL phcdf_define_int(ncid,'LXSYVPO',1)
  CALL phcdf_define_int(ncid,'LXSYVPR',1)
  CALL phcdf_define_int(ncid,'LXSYVTR',1)
  CALL phcdf_define_int(ncid,'LXSYZF2',1)
  CALL phcdf_define_int(ncid,'LXSYZXR',1)
  CALL phcdf_define_int(ncid,'LXTER',1)
  CALL phcdf_define_int(ncid,'LXTI2',1)
  CALL phcdf_define_int(ncid,'LXTQI',1)
  CALL phcdf_define_int(ncid,'LXV2F',1)
  CALL phcdf_define_int(ncid,'LXVB2',1)
  CALL phcdf_define_int(ncid,'LXVC3',1)
  CALL phcdf_define_int(ncid,'LXVC4',1)
  CALL phcdf_define_int(ncid,'LXVC6',1)
  CALL phcdf_define_int(ncid,'LXVCD',1)
  CALL phcdf_define_int(ncid,'LXVCH',1)
  CALL phcdf_define_int(ncid,'LXVCT',1)
  CALL phcdf_define_int(ncid,'LXVEE',1)
  CALL phcdf_define_int(ncid,'LXVIE',1)
  CALL phcdf_define_int(ncid,'LXVMO',1)
  CALL phcdf_define_int(ncid,'LXVP2',1)
  CALL phcdf_define_int(ncid,'LXVPO',1)
  CALL phcdf_define_int(ncid,'LXVPR',1)
  CALL phcdf_define_int(ncid,'LXVTR',1)
  CALL phcdf_define_int(ncid,'LXZF2',1)
  CALL phcdf_define_int(ncid,'LXZIMPS',1)
  CALL phcdf_define_int(ncid,'LXZIMPX',1)
  CALL phcdf_define_int(ncid,'LXZIMPXS',1)
  CALL phcdf_define_int(ncid,'LXZXR',1)
  CALL phcdf_define_int(ncid,'LYRP2',1)
  CALL phcdf_define_int(ncid,'LYRPL',1)
  CALL phcdf_define_int(ncid,'LYSIM',1)
  CALL phcdf_define_int(ncid,'LZFS',1)
  CALL phcdf_define_int(ncid,'LZPSI',1)
  CALL phcdf_define_int(ncid,'MMAX',1)
  CALL phcdf_define_int(ncid,'MMX_MAXE',1)
  CALL phcdf_define_int(ncid,'MTRP2',1)
  CALL phcdf_define_int(ncid,'MTRPL',1)
  CALL phcdf_define_int(ncid,'NANTECH_D',1)
  CALL phcdf_define_int(ncid,'NANTICH_D',1)
  CALL phcdf_define_int(ncid,'NANTLH_D',1)
  CALL phcdf_define_int(ncid,'NBDATA',1)
  CALL phcdf_define_int(ncid,'NDEAEP',1)
  CALL phcdf_define_int(ncid,'NDFS',1)
  CALL phcdf_define_int(ncid,'NDMDF',1)
  CALL phcdf_define_int(ncid,'NDMFR',1)
  CALL phcdf_define_int(ncid,'NDMMX',1)
  CALL phcdf_define_int(ncid,'NDMSE',1)
  CALL phcdf_define_int(ncid,'NDPAEP',1)
  CALL phcdf_define_int(ncid,'NDPFC',1)
  CALL phcdf_define_int(ncid,'NDPFC_PRE',1)
  CALL phcdf_define_int(ncid,'NEAEP',1)
  CALL phcdf_define_int(ncid,'NEFD0',1)
  CALL phcdf_define_int(ncid,'NEFDB',1)
  CALL phcdf_define_int(ncid,'NEFDP',1)
  CALL phcdf_define_int(ncid,'NEFDQ',1)
  CALL phcdf_define_int(ncid,'NEFDR',1)
  CALL phcdf_define_int(ncid,'NEFDS',1)
  CALL phcdf_define_int(ncid,'NFRBCODE',1)
  CALL phcdf_define_int(ncid,'NFRBMODE',1)
  CALL phcdf_define_int(ncid,'NGMAX_D',1)
  CALL phcdf_define_int(ncid,'NHECFT',1)
  CALL phcdf_define_int(ncid,'NHFMX',1)
  CALL phcdf_define_int(ncid,'NIMDF',1)
  CALL phcdf_define_int(ncid,'NISSIM',300)
  CALL phcdf_define_int(ncid,'NISX',300)
  CALL phcdf_define_int(ncid,'NITSIM',8)
  CALL phcdf_define_int(ncid,'NITX',8)
  CALL phcdf_define_int(ncid,'NKAEP',1)
  CALL phcdf_define_int(ncid,'NLIM',1)
  CALL phcdf_define_int(ncid,'NMAPSIM',300)
  CALL phcdf_define_int(ncid,'NMDXKF',1)
  CALL phcdf_define_int(ncid,'NMIMP',1)
  CALL phcdf_define_int(ncid,'NMOMD',1)
  CALL phcdf_define_int(ncid,'NMUAEP',1)
  CALL phcdf_define_int(ncid,'NMZEFF',1)
  CALL phcdf_define_int(ncid,'NNSIM',1)
  CALL phcdf_define_int(ncid,'NPACK',1)
  CALL phcdf_define_int(ncid,'NPAEP',1)
  CALL phcdf_define_int(ncid,'NPELDA',1)
  CALL phcdf_define_int(ncid,'NPMDF',1)
  CALL phcdf_define_int(ncid,'NPMSE',1)
  CALL phcdf_define_int(ncid,'NRHIS',1)
  CALL phcdf_define_int(ncid,'NRHIX',1)
  CALL phcdf_define_int(ncid,'NRIAXR',1)
  CALL phcdf_define_int(ncid,'NRIBOL',1)
  CALL phcdf_define_int(ncid,'NRIBPA',1)
  CALL phcdf_define_int(ncid,'NRIBPB',1)
  CALL phcdf_define_int(ncid,'NRID2F',1)
  CALL phcdf_define_int(ncid,'NRIDE2',1)
  CALL phcdf_define_int(ncid,'NRIDF3',1)
  CALL phcdf_define_int(ncid,'NRIDF4',1)
  CALL phcdf_define_int(ncid,'NRIDF6',1)
  CALL phcdf_define_int(ncid,'NRIDFD',1)
  CALL phcdf_define_int(ncid,'NRIDFH',1)
  CALL phcdf_define_int(ncid,'NRIDFT',1)
  CALL phcdf_define_int(ncid,'NRIECF',1)
  CALL phcdf_define_int(ncid,'NRIFD0',1)
  CALL phcdf_define_int(ncid,'NRIFDB',1)
  CALL phcdf_define_int(ncid,'NRIFDP',1)
  CALL phcdf_define_int(ncid,'NRIFDQ',1)
  CALL phcdf_define_int(ncid,'NRIFDR',1)
  CALL phcdf_define_int(ncid,'NRIFDS',1)
  CALL phcdf_define_int(ncid,'NRIFEH',1)
  CALL phcdf_define_int(ncid,'NRIFEL',1)
  CALL phcdf_define_int(ncid,'NRIGRB',1)
  CALL phcdf_define_int(ncid,'NRIIBE',1)
  CALL phcdf_define_int(ncid,'NRIIBI',1)
  CALL phcdf_define_int(ncid,'NRIJBM',1)
  CALL phcdf_define_int(ncid,'NRIJEC',1)
  CALL phcdf_define_int(ncid,'NRIJIC',1)
  CALL phcdf_define_int(ncid,'NRILF3',1)
  CALL phcdf_define_int(ncid,'NRILF4',1)
  CALL phcdf_define_int(ncid,'NRILF6',1)
  CALL phcdf_define_int(ncid,'NRILFD',1)
  CALL phcdf_define_int(ncid,'NRILFH',1)
  CALL phcdf_define_int(ncid,'NRILFT',1)
  CALL phcdf_define_int(ncid,'NRILHE',1)
  CALL phcdf_define_int(ncid,'NRILHJ',1)
  CALL phcdf_define_int(ncid,'NRIMSE',1)
  CALL phcdf_define_int(ncid,'NRINER',1)
  CALL phcdf_define_int(ncid,'NRINI3',1)
  CALL phcdf_define_int(ncid,'NRINI4',1)
  CALL phcdf_define_int(ncid,'NRINI6',1)
  CALL phcdf_define_int(ncid,'NRINID',1)
  CALL phcdf_define_int(ncid,'NRINIH',1)
  CALL phcdf_define_int(ncid,'NRINIM',1)
  CALL phcdf_define_int(ncid,'NRINIT',1)
  CALL phcdf_define_int(ncid,'NRINMR',1)
  CALL phcdf_define_int(ncid,'NRIOMG',1)
  CALL phcdf_define_int(ncid,'NRIPRS',1)
  CALL phcdf_define_int(ncid,'NRIQBE',1)
  CALL phcdf_define_int(ncid,'NRIQBI',1)
  CALL phcdf_define_int(ncid,'NRIQEC',1)
  CALL phcdf_define_int(ncid,'NRIQIC',1)
  CALL phcdf_define_int(ncid,'NRIQPR',1)
  CALL phcdf_define_int(ncid,'NRIRES',1)
  CALL phcdf_define_int(ncid,'NRISBI',1)
  CALL phcdf_define_int(ncid,'NRISIM',8)
  CALL phcdf_define_int(ncid,'NRITER',1)
  CALL phcdf_define_int(ncid,'NRITI2',1)
  CALL phcdf_define_int(ncid,'NRITQI',1)
  CALL phcdf_define_int(ncid,'NRIV2F',1)
  CALL phcdf_define_int(ncid,'NRIVB2',1)
  CALL phcdf_define_int(ncid,'NRIVC3',1)
  CALL phcdf_define_int(ncid,'NRIVC4',1)
  CALL phcdf_define_int(ncid,'NRIVC6',1)
  CALL phcdf_define_int(ncid,'NRIVCD',1)
  CALL phcdf_define_int(ncid,'NRIVCH',1)
  CALL phcdf_define_int(ncid,'NRIVCT',1)
  CALL phcdf_define_int(ncid,'NRIVEE',1)
  CALL phcdf_define_int(ncid,'NRIVIE',1)
  CALL phcdf_define_int(ncid,'NRIVMO',1)
  CALL phcdf_define_int(ncid,'NRIVP2',1)
  CALL phcdf_define_int(ncid,'NRIVPO',1)
  CALL phcdf_define_int(ncid,'NRIVPR',1)
  CALL phcdf_define_int(ncid,'NRIVTR',1)
  CALL phcdf_define_int(ncid,'NRIZF2',1)
  CALL phcdf_define_int(ncid,'NRIZXR',1)
  CALL phcdf_define_int(ncid,'NRMFR',1)
  CALL phcdf_define_int(ncid,'NRMSE',1)
  CALL phcdf_define_int(ncid,'NRP2',1)
  CALL phcdf_define_int(ncid,'NRPL',1)
  CALL phcdf_define_int(ncid,'NRPSI',1)
  CALL phcdf_define_int(ncid,'NSAWFLAG',1)
  CALL phcdf_define_int(ncid,'NSC',1)
  CALL phcdf_define_int(ncid,'NSC_FMT',1)
  CALL phcdf_define_int(ncid,'NSEVENT',1)
  CALL phcdf_define_int(ncid,'NSEVPER',1)
  CALL phcdf_define_int(ncid,'NSEVTBL',1)
  CALL phcdf_define_int(ncid,'NSEVWDS',1)
  CALL phcdf_define_int(ncid,'NSFAST_D',1)
  CALL phcdf_define_int(ncid,'NSYAXR',1)
  CALL phcdf_define_int(ncid,'NSYBOL',1)
  CALL phcdf_define_int(ncid,'NSYBPA',1)
  CALL phcdf_define_int(ncid,'NSYBPB',1)
  CALL phcdf_define_int(ncid,'NSYD2F',1)
  CALL phcdf_define_int(ncid,'NSYDE2',1)
  CALL phcdf_define_int(ncid,'NSYDF3',1)
  CALL phcdf_define_int(ncid,'NSYDF4',1)
  CALL phcdf_define_int(ncid,'NSYDF6',1)
  CALL phcdf_define_int(ncid,'NSYDFD',1)
  CALL phcdf_define_int(ncid,'NSYDFH',1)
  CALL phcdf_define_int(ncid,'NSYDFT',1)
  CALL phcdf_define_int(ncid,'NSYECF',1)
  CALL phcdf_define_int(ncid,'NSYFEH',1)
  CALL phcdf_define_int(ncid,'NSYFEL',1)
  CALL phcdf_define_int(ncid,'NSYGRB',1)
  CALL phcdf_define_int(ncid,'NSYIBE',1)
  CALL phcdf_define_int(ncid,'NSYIBI',1)
  CALL phcdf_define_int(ncid,'NSYJBM',1)
  CALL phcdf_define_int(ncid,'NSYJEC',1)
  CALL phcdf_define_int(ncid,'NSYJIC',1)
  CALL phcdf_define_int(ncid,'NSYLF3',1)
  CALL phcdf_define_int(ncid,'NSYLF4',1)
  CALL phcdf_define_int(ncid,'NSYLF6',1)
  CALL phcdf_define_int(ncid,'NSYLFD',1)
  CALL phcdf_define_int(ncid,'NSYLFH',1)
  CALL phcdf_define_int(ncid,'NSYLFT',1)
  CALL phcdf_define_int(ncid,'NSYLHE',1)
  CALL phcdf_define_int(ncid,'NSYLHJ',1)
  CALL phcdf_define_int(ncid,'NSYMSE',1)
  CALL phcdf_define_int(ncid,'NSYNER',1)
  CALL phcdf_define_int(ncid,'NSYNI3',1)
  CALL phcdf_define_int(ncid,'NSYNI4',1)
  CALL phcdf_define_int(ncid,'NSYNI6',1)
  CALL phcdf_define_int(ncid,'NSYNID',1)
  CALL phcdf_define_int(ncid,'NSYNIH',1)
  CALL phcdf_define_int(ncid,'NSYNIM',1)
  CALL phcdf_define_int(ncid,'NSYNIT',1)
  CALL phcdf_define_int(ncid,'NSYNMR',1)
  CALL phcdf_define_int(ncid,'NSYOMG',1)
  CALL phcdf_define_int(ncid,'NSYPRS',1)
  CALL phcdf_define_int(ncid,'NSYQBE',1)
  CALL phcdf_define_int(ncid,'NSYQBI',1)
  CALL phcdf_define_int(ncid,'NSYQEC',1)
  CALL phcdf_define_int(ncid,'NSYQIC',1)
  CALL phcdf_define_int(ncid,'NSYQPR',1)
  CALL phcdf_define_int(ncid,'NSYRES',1)
  CALL phcdf_define_int(ncid,'NSYSBI',1)
  CALL phcdf_define_int(ncid,'NSYSIM',8)
  CALL phcdf_define_int(ncid,'NSYTER',1)
  CALL phcdf_define_int(ncid,'NSYTI2',1)
  CALL phcdf_define_int(ncid,'NSYTQI',1)
  CALL phcdf_define_int(ncid,'NSYV2F',1)
  CALL phcdf_define_int(ncid,'NSYVB2',1)
  CALL phcdf_define_int(ncid,'NSYVC3',1)
  CALL phcdf_define_int(ncid,'NSYVC4',1)
  CALL phcdf_define_int(ncid,'NSYVC6',1)
  CALL phcdf_define_int(ncid,'NSYVCD',1)
  CALL phcdf_define_int(ncid,'NSYVCH',1)
  CALL phcdf_define_int(ncid,'NSYVCT',1)
  CALL phcdf_define_int(ncid,'NSYVEE',1)
  CALL phcdf_define_int(ncid,'NSYVIE',1)
  CALL phcdf_define_int(ncid,'NSYVMO',1)
  CALL phcdf_define_int(ncid,'NSYVP2',1)
  CALL phcdf_define_int(ncid,'NSYVPO',1)
  CALL phcdf_define_int(ncid,'NSYVPR',1)
  CALL phcdf_define_int(ncid,'NSYVTR',1)
  CALL phcdf_define_int(ncid,'NSYZF2',1)
  CALL phcdf_define_int(ncid,'NSYZXR',1)
  CALL phcdf_define_int(ncid,'NTABORT',1)
  CALL phcdf_define_int(ncid,'NTAEP',1)
  CALL phcdf_define_int(ncid,'NTFD0',1)
  CALL phcdf_define_int(ncid,'NTFDB',1)
  CALL phcdf_define_int(ncid,'NTFDP',1)
  CALL phcdf_define_int(ncid,'NTFDQ',1)
  CALL phcdf_define_int(ncid,'NTFDR',1)
  CALL phcdf_define_int(ncid,'NTFDS',1)
  CALL phcdf_define_int(ncid,'NTHFS',1)
  CALL phcdf_define_int(ncid,'NTIME1',1)
  CALL phcdf_define_int(ncid,'NTIME2',1)
  CALL phcdf_define_int(ncid,'NTIMEC',1)
  CALL phcdf_define_int(ncid,'NTIMECA',1)
  CALL phcdf_define_int(ncid,'NTIMECB',1)
  CALL phcdf_define_int(ncid,'NTIMLH',1)
  CALL phcdf_define_int(ncid,'NTIMNB',1)
  CALL phcdf_define_int(ncid,'NTIMRF',1)
  CALL phcdf_define_int(ncid,'NTIMRFF',1)
  CALL phcdf_define_int(ncid,'NTPSI',1)
  CALL phcdf_define_int(ncid,'NTSAW',1)
  CALL phcdf_define_int(ncid,'NXAXR',1)
  CALL phcdf_define_int(ncid,'NXBOL',1)
  CALL phcdf_define_int(ncid,'NXBPA',1)
  CALL phcdf_define_int(ncid,'NXBPB',1)
  CALL phcdf_define_int(ncid,'NXD2F',1)
  CALL phcdf_define_int(ncid,'NXDE2',1)
  CALL phcdf_define_int(ncid,'NXDF3',1)
  CALL phcdf_define_int(ncid,'NXDF4',1)
  CALL phcdf_define_int(ncid,'NXDF6',1)
  CALL phcdf_define_int(ncid,'NXDFD',1)
  CALL phcdf_define_int(ncid,'NXDFH',1)
  CALL phcdf_define_int(ncid,'NXDFT',1)
  CALL phcdf_define_int(ncid,'NXECF',1)
  CALL phcdf_define_int(ncid,'NXFD0',1)
  CALL phcdf_define_int(ncid,'NXFDB',1)
  CALL phcdf_define_int(ncid,'NXFDP',1)
  CALL phcdf_define_int(ncid,'NXFDQ',1)
  CALL phcdf_define_int(ncid,'NXFDR',1)
  CALL phcdf_define_int(ncid,'NXFDS',1)
  CALL phcdf_define_int(ncid,'NXFEH',1)
  CALL phcdf_define_int(ncid,'NXFEL',1)
  CALL phcdf_define_int(ncid,'NXFS',1)
  CALL phcdf_define_int(ncid,'NXGRB',1)
  CALL phcdf_define_int(ncid,'NXIBE',1)
  CALL phcdf_define_int(ncid,'NXIBI',1)
  CALL phcdf_define_int(ncid,'NXJBM',1)
  CALL phcdf_define_int(ncid,'NXJEC',1)
  CALL phcdf_define_int(ncid,'NXJIC',1)
  CALL phcdf_define_int(ncid,'NXLF3',1)
  CALL phcdf_define_int(ncid,'NXLF4',1)
  CALL phcdf_define_int(ncid,'NXLF6',1)
  CALL phcdf_define_int(ncid,'NXLFD',1)
  CALL phcdf_define_int(ncid,'NXLFH',1)
  CALL phcdf_define_int(ncid,'NXLFT',1)
  CALL phcdf_define_int(ncid,'NXLHE',1)
  CALL phcdf_define_int(ncid,'NXLHJ',1)
  CALL phcdf_define_int(ncid,'NXMMX',1)
  CALL phcdf_define_int(ncid,'NXMSE',1)
  CALL phcdf_define_int(ncid,'NXNE0',1)
  CALL phcdf_define_int(ncid,'NXNER',1)
  CALL phcdf_define_int(ncid,'NXNI3',1)
  CALL phcdf_define_int(ncid,'NXNI4',1)
  CALL phcdf_define_int(ncid,'NXNI6',1)
  CALL phcdf_define_int(ncid,'NXNID',1)
  CALL phcdf_define_int(ncid,'NXNIH',1)
  CALL phcdf_define_int(ncid,'NXNIM',1)
  CALL phcdf_define_int(ncid,'NXNIT',1)
  CALL phcdf_define_int(ncid,'NXNM0',1)
  CALL phcdf_define_int(ncid,'NXNMR',1)
  CALL phcdf_define_int(ncid,'NXOMG',1)
  CALL phcdf_define_int(ncid,'NXPFC',1)
  CALL phcdf_define_int(ncid,'NXPRS',1)
  CALL phcdf_define_int(ncid,'NXQBE',1)
  CALL phcdf_define_int(ncid,'NXQBI',1)
  CALL phcdf_define_int(ncid,'NXQEC',1)
  CALL phcdf_define_int(ncid,'NXQIC',1)
  CALL phcdf_define_int(ncid,'NXQPR',1)
  CALL phcdf_define_int(ncid,'NXRES',1)
  CALL phcdf_define_int(ncid,'NXRP2',1)
  CALL phcdf_define_int(ncid,'NXRPL',1)
  CALL phcdf_define_int(ncid,'NXSBI',1)
  CALL phcdf_define_int(ncid,'NXSIM',8)
  CALL phcdf_define_int(ncid,'NXSYAXR',1)
  CALL phcdf_define_int(ncid,'NXSYBOL',1)
  CALL phcdf_define_int(ncid,'NXSYBPA',1)
  CALL phcdf_define_int(ncid,'NXSYBPB',1)
  CALL phcdf_define_int(ncid,'NXSYD2F',1)
  CALL phcdf_define_int(ncid,'NXSYDE2',1)
  CALL phcdf_define_int(ncid,'NXSYDF3',1)
  CALL phcdf_define_int(ncid,'NXSYDF4',1)
  CALL phcdf_define_int(ncid,'NXSYDF6',1)
  CALL phcdf_define_int(ncid,'NXSYDFD',1)
  CALL phcdf_define_int(ncid,'NXSYDFH',1)
  CALL phcdf_define_int(ncid,'NXSYDFT',1)
  CALL phcdf_define_int(ncid,'NXSYECF',1)
  CALL phcdf_define_int(ncid,'NXSYFEH',1)
  CALL phcdf_define_int(ncid,'NXSYFEL',1)
  CALL phcdf_define_int(ncid,'NXSYGRB',1)
  CALL phcdf_define_int(ncid,'NXSYIBE',1)
  CALL phcdf_define_int(ncid,'NXSYIBI',1)
  CALL phcdf_define_int(ncid,'NXSYJBM',1)
  CALL phcdf_define_int(ncid,'NXSYJEC',1)
  CALL phcdf_define_int(ncid,'NXSYJIC',1)
  CALL phcdf_define_int(ncid,'NXSYLF3',1)
  CALL phcdf_define_int(ncid,'NXSYLF4',1)
  CALL phcdf_define_int(ncid,'NXSYLF6',1)
  CALL phcdf_define_int(ncid,'NXSYLFD',1)
  CALL phcdf_define_int(ncid,'NXSYLFH',1)
  CALL phcdf_define_int(ncid,'NXSYLFT',1)
  CALL phcdf_define_int(ncid,'NXSYLHE',1)
  CALL phcdf_define_int(ncid,'NXSYLHJ',1)
  CALL phcdf_define_int(ncid,'NXSYMSE',1)
  CALL phcdf_define_int(ncid,'NXSYNER',1)
  CALL phcdf_define_int(ncid,'NXSYNI3',1)
  CALL phcdf_define_int(ncid,'NXSYNI4',1)
  CALL phcdf_define_int(ncid,'NXSYNI6',1)
  CALL phcdf_define_int(ncid,'NXSYNID',1)
  CALL phcdf_define_int(ncid,'NXSYNIH',1)
  CALL phcdf_define_int(ncid,'NXSYNIM',1)
  CALL phcdf_define_int(ncid,'NXSYNIT',1)
  CALL phcdf_define_int(ncid,'NXSYNMR',1)
  CALL phcdf_define_int(ncid,'NXSYOMG',1)
  CALL phcdf_define_int(ncid,'NXSYPRS',1)
  CALL phcdf_define_int(ncid,'NXSYQBE',1)
  CALL phcdf_define_int(ncid,'NXSYQBI',1)
  CALL phcdf_define_int(ncid,'NXSYQEC',1)
  CALL phcdf_define_int(ncid,'NXSYQIC',1)
  CALL phcdf_define_int(ncid,'NXSYQPR',1)
  CALL phcdf_define_int(ncid,'NXSYRES',1)
  CALL phcdf_define_int(ncid,'NXSYSBI',1)
  CALL phcdf_define_int(ncid,'NXSYSIM',8)
  CALL phcdf_define_int(ncid,'NXSYTER',1)
  CALL phcdf_define_int(ncid,'NXSYTI2',1)
  CALL phcdf_define_int(ncid,'NXSYTQI',1)
  CALL phcdf_define_int(ncid,'NXSYV2F',1)
  CALL phcdf_define_int(ncid,'NXSYVB2',1)
  CALL phcdf_define_int(ncid,'NXSYVC3',1)
  CALL phcdf_define_int(ncid,'NXSYVC4',1)
  CALL phcdf_define_int(ncid,'NXSYVC6',1)
  CALL phcdf_define_int(ncid,'NXSYVCD',1)
  CALL phcdf_define_int(ncid,'NXSYVCH',1)
  CALL phcdf_define_int(ncid,'NXSYVCT',1)
  CALL phcdf_define_int(ncid,'NXSYVEE',1)
  CALL phcdf_define_int(ncid,'NXSYVIE',1)
  CALL phcdf_define_int(ncid,'NXSYVMO',1)
  CALL phcdf_define_int(ncid,'NXSYVP2',1)
  CALL phcdf_define_int(ncid,'NXSYVPO',1)
  CALL phcdf_define_int(ncid,'NXSYVPR',1)
  CALL phcdf_define_int(ncid,'NXSYVTR',1)
  CALL phcdf_define_int(ncid,'NXSYZF2',1)
  CALL phcdf_define_int(ncid,'NXSYZXR',1)
  CALL phcdf_define_int(ncid,'NXTE0',1)
  CALL phcdf_define_int(ncid,'NXTER',1)
  CALL phcdf_define_int(ncid,'NXTI2',1)
  CALL phcdf_define_int(ncid,'NXTQI',1)
  CALL phcdf_define_int(ncid,'NXV2F',1)
  CALL phcdf_define_int(ncid,'NXVB2',1)
  CALL phcdf_define_int(ncid,'NXVC3',1)
  CALL phcdf_define_int(ncid,'NXVC4',1)
  CALL phcdf_define_int(ncid,'NXVC6',1)
  CALL phcdf_define_int(ncid,'NXVCD',1)
  CALL phcdf_define_int(ncid,'NXVCH',1)
  CALL phcdf_define_int(ncid,'NXVCT',1)
  CALL phcdf_define_int(ncid,'NXVEE',1)
  CALL phcdf_define_int(ncid,'NXVIE',1)
  CALL phcdf_define_int(ncid,'NXVMO',1)
  CALL phcdf_define_int(ncid,'NXVP2',1)
  CALL phcdf_define_int(ncid,'NXVPO',1)
  CALL phcdf_define_int(ncid,'NXVPR',1)
  CALL phcdf_define_int(ncid,'NXVTR',1)
  CALL phcdf_define_int(ncid,'NXZEF2',1)
  CALL phcdf_define_int(ncid,'NXZF2',1)
  CALL phcdf_define_int(ncid,'NXZXR',1)
  CALL phcdf_define_int(ncid,'NYRP2',1)
  CALL phcdf_define_int(ncid,'NYRPL',1)
  CALL phcdf_define_int(ncid,'NZPSI',1)
  CALL phcdf_define_double(ncid,'DATBUF',ILEN)
 
 
  status = nf_enddef(ncid)
  if(status.ne.NF_NOERR) kerr=1
 
  return
 
end subroutine trdatbuf_def_cdf
 
!-----------------------------------------
 
subroutine trdatbuf_wr_cdf(kcdf,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  write PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
  include 'netcdf.inc'
 
  integer, intent(in) :: KCDF    ! NetCDF file id
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  integer :: ilen,j, ier
  integer :: idum = 0
 
  !-------------------------
  kerr = 0
 
  ilen = z%lfree - 1
 
  CALL phcdf_write_int(KCDF,'LADR_ZA',z%LADR_ZA,1)
  CALL phcdf_write_int(KCDF,'LADR_ZAF',z%LADR_ZAF,1)
  CALL phcdf_write_int(KCDF,'LAEPDE',z%LAEPDE,1)
  CALL phcdf_write_int(KCDF,'LAEPDP',z%LAEPDP,1)
  CALL phcdf_write_int(KCDF,'LAEPE',z%LAEPE,1)
  CALL phcdf_write_int(KCDF,'LAEPMAP',z%LAEPMAP,1)
  CALL phcdf_write_int(KCDF,'LAEPMU',z%LAEPMU,1)
  CALL phcdf_write_int(KCDF,'LAEPP',z%LAEPP,1)
  CALL phcdf_write_int(KCDF,'LAEPSP',z%LAEPSP,1)
  CALL phcdf_write_int(KCDF,'LAEPTS',z%LAEPTS,1)
  CALL phcdf_write_int(KCDF,'LAIMPS',z%LAIMPS,1)
  CALL phcdf_write_int(KCDF,'LAIMPX',z%LAIMPX,1)
  CALL phcdf_write_int(KCDF,'LDATALP',z%LDATALP,1)
  CALL phcdf_write_int(KCDF,'LDATBDI',z%LDATBDI,1)
  CALL phcdf_write_int(KCDF,'LDATCUR',z%LDATCUR,1)
  CALL phcdf_write_int(KCDF,'LDATDFL',z%LDATDFL,1)
  CALL phcdf_write_int(KCDF,'LDATDTG',z%LDATDTG,1)
  CALL phcdf_write_int(KCDF,'LDATDTS',z%LDATDTS,1)
  CALL phcdf_write_int(KCDF,'LDATDTX',z%LDATDTX,1)
  CALL phcdf_write_int(KCDF,'LDATEDI',z%LDATEDI,1)
  CALL phcdf_write_int(KCDF,'LDATEHP',z%LDATEHP,1)
  CALL phcdf_write_int(KCDF,'LDATELI',z%LDATELI,1)
  CALL phcdf_write_int(KCDF,'LDATFGW',z%LDATFGW,1)
  CALL phcdf_write_int(KCDF,'LDATFIE',z%LDATFIE,1)
  CALL phcdf_write_int(KCDF,'LDATFMN',z%LDATFMN,1)
  CALL phcdf_write_int(KCDF,'LDATFMX',z%LDATFMX,1)
  CALL phcdf_write_int(KCDF,'LDATGAS',z%LDATGAS,1)
  CALL phcdf_write_int(KCDF,'LDATGF3',z%LDATGF3,1)
  CALL phcdf_write_int(KCDF,'LDATGF4',z%LDATGF4,1)
  CALL phcdf_write_int(KCDF,'LDATGF6',z%LDATGF6,1)
  CALL phcdf_write_int(KCDF,'LDATGFD',z%LDATGFD,1)
  CALL phcdf_write_int(KCDF,'LDATGFH',z%LDATGFH,1)
  CALL phcdf_write_int(KCDF,'LDATGFT',z%LDATGFT,1)
  CALL phcdf_write_int(KCDF,'LDATGIE',z%LDATGIE,1)
  CALL phcdf_write_int(KCDF,'LDATHAL',z%LDATHAL,1)
  CALL phcdf_write_int(KCDF,'LDATIBM',z%LDATIBM,1)
  CALL phcdf_write_int(KCDF,'LDATIEC',z%LDATIEC,1)
  CALL phcdf_write_int(KCDF,'LDATIIC',z%LDATIIC,1)
  CALL phcdf_write_int(KCDF,'LDATILH',z%LDATILH,1)
  CALL phcdf_write_int(KCDF,'LDATL2B',z%LDATL2B,1)
  CALL phcdf_write_int(KCDF,'LDATLAD',z%LDATLAD,1)
  CALL phcdf_write_int(KCDF,'LDATLID',z%LDATLID,1)
  CALL phcdf_write_int(KCDF,'LDATNTX',z%LDATNTX,1)
  CALL phcdf_write_int(KCDF,'LDATOGF',z%LDATOGF,1)
  CALL phcdf_write_int(KCDF,'LDATORC',z%LDATORC,1)
  CALL phcdf_write_int(KCDF,'LDATPBE',z%LDATPBE,1)
  CALL phcdf_write_int(KCDF,'LDATPBI',z%LDATPBI,1)
  CALL phcdf_write_int(KCDF,'LDATPEB',z%LDATPEB,1)
  CALL phcdf_write_int(KCDF,'LDATPEC',z%LDATPEC,1)
  CALL phcdf_write_int(KCDF,'LDATPF0',z%LDATPF0,1)
  CALL phcdf_write_int(KCDF,'LDATPFH',z%LDATPFH,1)
  CALL phcdf_write_int(KCDF,'LDATPFL',z%LDATPFL,1)
  CALL phcdf_write_int(KCDF,'LDATPIB',z%LDATPIB,1)
  CALL phcdf_write_int(KCDF,'LDATPIC',z%LDATPIC,1)
  CALL phcdf_write_int(KCDF,'LDATPLF',z%LDATPLF,1)
  CALL phcdf_write_int(KCDF,'LDATPLH',z%LDATPLH,1)
  CALL phcdf_write_int(KCDF,'LDATPOS',z%LDATPOS,1)
  CALL phcdf_write_int(KCDF,'LDATRBZ',z%LDATRBZ,1)
  CALL phcdf_write_int(KCDF,'LDATRC3',z%LDATRC3,1)
  CALL phcdf_write_int(KCDF,'LDATRC4',z%LDATRC4,1)
  CALL phcdf_write_int(KCDF,'LDATRC6',z%LDATRC6,1)
  CALL phcdf_write_int(KCDF,'LDATRCD',z%LDATRCD,1)
  CALL phcdf_write_int(KCDF,'LDATRCH',z%LDATRCH,1)
  CALL phcdf_write_int(KCDF,'LDATRCT',z%LDATRCT,1)
  CALL phcdf_write_int(KCDF,'LDATRCY',z%LDATRCY,1)
  CALL phcdf_write_int(KCDF,'LDATRMN',z%LDATRMN,1)
  CALL phcdf_write_int(KCDF,'LDATRTP',z%LDATRTP,1)
  CALL phcdf_write_int(KCDF,'LDATSBT',z%LDATSBT,1)
  CALL phcdf_write_int(KCDF,'LDATSF3',z%LDATSF3,1)
  CALL phcdf_write_int(KCDF,'LDATSFA',z%LDATSFA,1)
  CALL phcdf_write_int(KCDF,'LDATSFL',z%LDATSFL,1)
  CALL phcdf_write_int(KCDF,'LDATSFP',z%LDATSFP,1)
  CALL phcdf_write_int(KCDF,'LDATSFT',z%LDATSFT,1)
  CALL phcdf_write_int(KCDF,'LDATSP3',z%LDATSP3,1)
  CALL phcdf_write_int(KCDF,'LDATTET',z%LDATTET,1)
  CALL phcdf_write_int(KCDF,'LDATTGF',z%LDATTGF,1)
  CALL phcdf_write_int(KCDF,'LDATTIT',z%LDATTIT,1)
  CALL phcdf_write_int(KCDF,'LDATTPI',z%LDATTPI,1)
  CALL phcdf_write_int(KCDF,'LDATTQT',z%LDATTQT,1)
  CALL phcdf_write_int(KCDF,'LDATTRC',z%LDATTRC,1)
  CALL phcdf_write_int(KCDF,'LDATTRF',z%LDATTRF,1)
  CALL phcdf_write_int(KCDF,'LDATTXI',z%LDATTXI,1)
  CALL phcdf_write_int(KCDF,'LDATVPH',z%LDATVPH,1)
  CALL phcdf_write_int(KCDF,'LDATVSB',z%LDATVSB,1)
  CALL phcdf_write_int(KCDF,'LDATVSF',z%LDATVSF,1)
  CALL phcdf_write_int(KCDF,'LDATXKF',z%LDATXKF,1)
  CALL phcdf_write_int(KCDF,'LDATZEF',z%LDATZEF,1)
  CALL phcdf_write_int(KCDF,'LDATZFA',z%LDATZFA,1)
  CALL phcdf_write_int(KCDF,'LDATZIM',z%LDATZIM,1)
  CALL phcdf_write_int(KCDF,'LDATZPL',z%LDATZPL,1)
  CALL phcdf_write_int(KCDF,'LDMDF',z%LDMDF,1)
  CALL phcdf_write_int(KCDF,'LDMFR',z%LDMFR,1)
  CALL phcdf_write_int(KCDF,'LDMMX',z%LDMMX,1)
  CALL phcdf_write_int(KCDF,'LDMSE',z%LDMSE,1)
  CALL phcdf_write_int(KCDF,'LDPFC',z%LDPFC,1)
  CALL phcdf_write_int(KCDF,'LDPFC_PRE',z%LDPFC_PRE,1)
  CALL phcdf_write_int(KCDF,'LEFD0',z%LEFD0,1)
  CALL phcdf_write_int(KCDF,'LEFDB',z%LEFDB,1)
  CALL phcdf_write_int(KCDF,'LEFDP',z%LEFDP,1)
  CALL phcdf_write_int(KCDF,'LEFDQ',z%LEFDQ,1)
  CALL phcdf_write_int(KCDF,'LEFDR',z%LEFDR,1)
  CALL phcdf_write_int(KCDF,'LEFDS',z%LEFDS,1)
  CALL phcdf_write_int(KCDF,'LFAEPA',z%LFAEPA,1)
  CALL phcdf_write_int(KCDF,'LFAEPP',z%LFAEPP,1)
  CALL phcdf_write_int(KCDF,'LFAXR',z%LFAXR,1)
  CALL phcdf_write_int(KCDF,'LFBOL',z%LFBOL,1)
  CALL phcdf_write_int(KCDF,'LFBPA',z%LFBPA,1)
  CALL phcdf_write_int(KCDF,'LFBPB',z%LFBPB,1)
  CALL phcdf_write_int(KCDF,'LFD2F',z%LFD2F,1)
  CALL phcdf_write_int(KCDF,'LFDE2',z%LFDE2,1)
  CALL phcdf_write_int(KCDF,'LFDF3',z%LFDF3,1)
  CALL phcdf_write_int(KCDF,'LFDF4',z%LFDF4,1)
  CALL phcdf_write_int(KCDF,'LFDF6',z%LFDF6,1)
  CALL phcdf_write_int(KCDF,'LFDFD',z%LFDFD,1)
  CALL phcdf_write_int(KCDF,'LFDFH',z%LFDFH,1)
  CALL phcdf_write_int(KCDF,'LFDFT',z%LFDFT,1)
  CALL phcdf_write_int(KCDF,'LFECA',z%LFECA,1)
  CALL phcdf_write_int(KCDF,'LFECB',z%LFECB,1)
  CALL phcdf_write_int(KCDF,'LFECF',z%LFECF,1)
  CALL phcdf_write_int(KCDF,'LFFD0',z%LFFD0,1)
  CALL phcdf_write_int(KCDF,'LFFDB',z%LFFDB,1)
  CALL phcdf_write_int(KCDF,'LFFDP',z%LFFDP,1)
  CALL phcdf_write_int(KCDF,'LFFDQ',z%LFFDQ,1)
  CALL phcdf_write_int(KCDF,'LFFDR',z%LFFDR,1)
  CALL phcdf_write_int(KCDF,'LFFDS',z%LFFDS,1)
  CALL phcdf_write_int(KCDF,'LFFEH',z%LFFEH,1)
  CALL phcdf_write_int(KCDF,'LFFEL',z%LFFEL,1)
  CALL phcdf_write_int(KCDF,'LFGRB',z%LFGRB,1)
  CALL phcdf_write_int(KCDF,'LFIBE',z%LFIBE,1)
  CALL phcdf_write_int(KCDF,'LFIBI',z%LFIBI,1)
  CALL phcdf_write_int(KCDF,'LFJBM',z%LFJBM,1)
  CALL phcdf_write_int(KCDF,'LFJEC',z%LFJEC,1)
  CALL phcdf_write_int(KCDF,'LFJIC',z%LFJIC,1)
  CALL phcdf_write_int(KCDF,'LFLF3',z%LFLF3,1)
  CALL phcdf_write_int(KCDF,'LFLF4',z%LFLF4,1)
  CALL phcdf_write_int(KCDF,'LFLF6',z%LFLF6,1)
  CALL phcdf_write_int(KCDF,'LFLFD',z%LFLFD,1)
  CALL phcdf_write_int(KCDF,'LFLFH',z%LFLFH,1)
  CALL phcdf_write_int(KCDF,'LFLFT',z%LFLFT,1)
  CALL phcdf_write_int(KCDF,'LFLHE',z%LFLHE,1)
  CALL phcdf_write_int(KCDF,'LFLHJ',z%LFLHJ,1)
  CALL phcdf_write_int(KCDF,'LFMSE',z%LFMSE,1)
  CALL phcdf_write_int(KCDF,'LFNER',z%LFNER,1)
  CALL phcdf_write_int(KCDF,'LFNI3',z%LFNI3,1)
  CALL phcdf_write_int(KCDF,'LFNI4',z%LFNI4,1)
  CALL phcdf_write_int(KCDF,'LFNI6',z%LFNI6,1)
  CALL phcdf_write_int(KCDF,'LFNID',z%LFNID,1)
  CALL phcdf_write_int(KCDF,'LFNIH',z%LFNIH,1)
  CALL phcdf_write_int(KCDF,'LFNIM',z%LFNIM,1)
  CALL phcdf_write_int(KCDF,'LFNIT',z%LFNIT,1)
  CALL phcdf_write_int(KCDF,'LFNMR',z%LFNMR,1)
  CALL phcdf_write_int(KCDF,'LFOMG',z%LFOMG,1)
  CALL phcdf_write_int(KCDF,'LFPRS',z%LFPRS,1)
  CALL phcdf_write_int(KCDF,'LFPSI',z%LFPSI,1)
  CALL phcdf_write_int(KCDF,'LFQBE',z%LFQBE,1)
  CALL phcdf_write_int(KCDF,'LFQBI',z%LFQBI,1)
  CALL phcdf_write_int(KCDF,'LFQEC',z%LFQEC,1)
  CALL phcdf_write_int(KCDF,'LFQIC',z%LFQIC,1)
  CALL phcdf_write_int(KCDF,'LFQPR',z%LFQPR,1)
  CALL phcdf_write_int(KCDF,'LFREE',z%LFREE,1)
  CALL phcdf_write_int(KCDF,'LFRES',z%LFRES,1)
  CALL phcdf_write_int(KCDF,'LFRQRFF',z%LFRQRFF,1)
  CALL phcdf_write_int(KCDF,'LFSBI',z%LFSBI,1)
  CALL phcdf_write_int(KCDF,'LFSIM',z%LFSIM,300)
  CALL phcdf_write_int(KCDF,'LFSYAXR',z%LFSYAXR,1)
  CALL phcdf_write_int(KCDF,'LFSYBOL',z%LFSYBOL,1)
  CALL phcdf_write_int(KCDF,'LFSYBPA',z%LFSYBPA,1)
  CALL phcdf_write_int(KCDF,'LFSYBPB',z%LFSYBPB,1)
  CALL phcdf_write_int(KCDF,'LFSYD2F',z%LFSYD2F,1)
  CALL phcdf_write_int(KCDF,'LFSYDE2',z%LFSYDE2,1)
  CALL phcdf_write_int(KCDF,'LFSYDF3',z%LFSYDF3,1)
  CALL phcdf_write_int(KCDF,'LFSYDF4',z%LFSYDF4,1)
  CALL phcdf_write_int(KCDF,'LFSYDF6',z%LFSYDF6,1)
  CALL phcdf_write_int(KCDF,'LFSYDFD',z%LFSYDFD,1)
  CALL phcdf_write_int(KCDF,'LFSYDFH',z%LFSYDFH,1)
  CALL phcdf_write_int(KCDF,'LFSYDFT',z%LFSYDFT,1)
  CALL phcdf_write_int(KCDF,'LFSYECF',z%LFSYECF,1)
  CALL phcdf_write_int(KCDF,'LFSYFEH',z%LFSYFEH,1)
  CALL phcdf_write_int(KCDF,'LFSYFEL',z%LFSYFEL,1)
  CALL phcdf_write_int(KCDF,'LFSYGRB',z%LFSYGRB,1)
  CALL phcdf_write_int(KCDF,'LFSYIBE',z%LFSYIBE,1)
  CALL phcdf_write_int(KCDF,'LFSYIBI',z%LFSYIBI,1)
  CALL phcdf_write_int(KCDF,'LFSYJBM',z%LFSYJBM,1)
  CALL phcdf_write_int(KCDF,'LFSYJEC',z%LFSYJEC,1)
  CALL phcdf_write_int(KCDF,'LFSYJIC',z%LFSYJIC,1)
  CALL phcdf_write_int(KCDF,'LFSYLF3',z%LFSYLF3,1)
  CALL phcdf_write_int(KCDF,'LFSYLF4',z%LFSYLF4,1)
  CALL phcdf_write_int(KCDF,'LFSYLF6',z%LFSYLF6,1)
  CALL phcdf_write_int(KCDF,'LFSYLFD',z%LFSYLFD,1)
  CALL phcdf_write_int(KCDF,'LFSYLFH',z%LFSYLFH,1)
  CALL phcdf_write_int(KCDF,'LFSYLFT',z%LFSYLFT,1)
  CALL phcdf_write_int(KCDF,'LFSYLHE',z%LFSYLHE,1)
  CALL phcdf_write_int(KCDF,'LFSYLHJ',z%LFSYLHJ,1)
  CALL phcdf_write_int(KCDF,'LFSYMSE',z%LFSYMSE,1)
  CALL phcdf_write_int(KCDF,'LFSYNER',z%LFSYNER,1)
  CALL phcdf_write_int(KCDF,'LFSYNI3',z%LFSYNI3,1)
  CALL phcdf_write_int(KCDF,'LFSYNI4',z%LFSYNI4,1)
  CALL phcdf_write_int(KCDF,'LFSYNI6',z%LFSYNI6,1)
  CALL phcdf_write_int(KCDF,'LFSYNID',z%LFSYNID,1)
  CALL phcdf_write_int(KCDF,'LFSYNIH',z%LFSYNIH,1)
  CALL phcdf_write_int(KCDF,'LFSYNIM',z%LFSYNIM,1)
  CALL phcdf_write_int(KCDF,'LFSYNIT',z%LFSYNIT,1)
  CALL phcdf_write_int(KCDF,'LFSYNMR',z%LFSYNMR,1)
  CALL phcdf_write_int(KCDF,'LFSYOMG',z%LFSYOMG,1)
  CALL phcdf_write_int(KCDF,'LFSYPRS',z%LFSYPRS,1)
  CALL phcdf_write_int(KCDF,'LFSYQBE',z%LFSYQBE,1)
  CALL phcdf_write_int(KCDF,'LFSYQBI',z%LFSYQBI,1)
  CALL phcdf_write_int(KCDF,'LFSYQEC',z%LFSYQEC,1)
  CALL phcdf_write_int(KCDF,'LFSYQIC',z%LFSYQIC,1)
  CALL phcdf_write_int(KCDF,'LFSYQPR',z%LFSYQPR,1)
  CALL phcdf_write_int(KCDF,'LFSYRES',z%LFSYRES,1)
  CALL phcdf_write_int(KCDF,'LFSYSBI',z%LFSYSBI,1)
  CALL phcdf_write_int(KCDF,'LFSYSIM',z%LFSYSIM,300)
  CALL phcdf_write_int(KCDF,'LFSYTER',z%LFSYTER,1)
  CALL phcdf_write_int(KCDF,'LFSYTI2',z%LFSYTI2,1)
  CALL phcdf_write_int(KCDF,'LFSYTQI',z%LFSYTQI,1)
  CALL phcdf_write_int(KCDF,'LFSYV2F',z%LFSYV2F,1)
  CALL phcdf_write_int(KCDF,'LFSYVB2',z%LFSYVB2,1)
  CALL phcdf_write_int(KCDF,'LFSYVC3',z%LFSYVC3,1)
  CALL phcdf_write_int(KCDF,'LFSYVC4',z%LFSYVC4,1)
  CALL phcdf_write_int(KCDF,'LFSYVC6',z%LFSYVC6,1)
  CALL phcdf_write_int(KCDF,'LFSYVCD',z%LFSYVCD,1)
  CALL phcdf_write_int(KCDF,'LFSYVCH',z%LFSYVCH,1)
  CALL phcdf_write_int(KCDF,'LFSYVCT',z%LFSYVCT,1)
  CALL phcdf_write_int(KCDF,'LFSYVEE',z%LFSYVEE,1)
  CALL phcdf_write_int(KCDF,'LFSYVIE',z%LFSYVIE,1)
  CALL phcdf_write_int(KCDF,'LFSYVMO',z%LFSYVMO,1)
  CALL phcdf_write_int(KCDF,'LFSYVP2',z%LFSYVP2,1)
  CALL phcdf_write_int(KCDF,'LFSYVPO',z%LFSYVPO,1)
  CALL phcdf_write_int(KCDF,'LFSYVPR',z%LFSYVPR,1)
  CALL phcdf_write_int(KCDF,'LFSYVTR',z%LFSYVTR,1)
  CALL phcdf_write_int(KCDF,'LFSYZF2',z%LFSYZF2,1)
  CALL phcdf_write_int(KCDF,'LFSYZXR',z%LFSYZXR,1)
  CALL phcdf_write_int(KCDF,'LFTER',z%LFTER,1)
  CALL phcdf_write_int(KCDF,'LFTI2',z%LFTI2,1)
  CALL phcdf_write_int(KCDF,'LFTQI',z%LFTQI,1)
  CALL phcdf_write_int(KCDF,'LFULNB',z%LFULNB,1)
  CALL phcdf_write_int(KCDF,'LFV2F',z%LFV2F,1)
  CALL phcdf_write_int(KCDF,'LFVB2',z%LFVB2,1)
  CALL phcdf_write_int(KCDF,'LFVC3',z%LFVC3,1)
  CALL phcdf_write_int(KCDF,'LFVC4',z%LFVC4,1)
  CALL phcdf_write_int(KCDF,'LFVC6',z%LFVC6,1)
  CALL phcdf_write_int(KCDF,'LFVCD',z%LFVCD,1)
  CALL phcdf_write_int(KCDF,'LFVCH',z%LFVCH,1)
  CALL phcdf_write_int(KCDF,'LFVCT',z%LFVCT,1)
  CALL phcdf_write_int(KCDF,'LFVEE',z%LFVEE,1)
  CALL phcdf_write_int(KCDF,'LFVIE',z%LFVIE,1)
  CALL phcdf_write_int(KCDF,'LFVMO',z%LFVMO,1)
  CALL phcdf_write_int(KCDF,'LFVP2',z%LFVP2,1)
  CALL phcdf_write_int(KCDF,'LFVPO',z%LFVPO,1)
  CALL phcdf_write_int(KCDF,'LFVPR',z%LFVPR,1)
  CALL phcdf_write_int(KCDF,'LFVTR',z%LFVTR,1)
  CALL phcdf_write_int(KCDF,'LFZF2',z%LFZF2,1)
  CALL phcdf_write_int(KCDF,'LFZXR',z%LFZXR,1)
  CALL phcdf_write_int(KCDF,'LHLFNB',z%LHLFNB,1)
  CALL phcdf_write_int(KCDF,'LLIM',z%LLIM,1)
  CALL phcdf_write_int(KCDF,'LMOMD',z%LMOMD,1)
  CALL phcdf_write_int(KCDF,'LPELDA',z%LPELDA,1)
  CALL phcdf_write_int(KCDF,'LPHSLH',z%LPHSLH,1)
  CALL phcdf_write_int(KCDF,'LPMDF',z%LPMDF,1)
  CALL phcdf_write_int(KCDF,'LPMSE',z%LPMSE,1)
  CALL phcdf_write_int(KCDF,'LPWREC',z%LPWREC,1)
  CALL phcdf_write_int(KCDF,'LPWRLH',z%LPWRLH,1)
  CALL phcdf_write_int(KCDF,'LPWRNB',z%LPWRNB,1)
  CALL phcdf_write_int(KCDF,'LPWRRF',z%LPWRRF,1)
  CALL phcdf_write_int(KCDF,'LRFS',z%LRFS,1)
  CALL phcdf_write_int(KCDF,'LRMFR',z%LRMFR,1)
  CALL phcdf_write_int(KCDF,'LRMP_BDY1',z%LRMP_BDY1,1)
  CALL phcdf_write_int(KCDF,'LRMP_BDY2',z%LRMP_BDY2,1)
  CALL phcdf_write_int(KCDF,'LRMSE',z%LRMSE,1)
  CALL phcdf_write_int(KCDF,'LRP2',z%LRP2,1)
  CALL phcdf_write_int(KCDF,'LRPL',z%LRPL,1)
  CALL phcdf_write_int(KCDF,'LRPSI',z%LRPSI,1)
  CALL phcdf_write_int(KCDF,'LSEVENT',z%LSEVENT,1)
  CALL phcdf_write_int(KCDF,'LSSYAXR',z%LSSYAXR,1)
  CALL phcdf_write_int(KCDF,'LSSYBOL',z%LSSYBOL,1)
  CALL phcdf_write_int(KCDF,'LSSYBPA',z%LSSYBPA,1)
  CALL phcdf_write_int(KCDF,'LSSYBPB',z%LSSYBPB,1)
  CALL phcdf_write_int(KCDF,'LSSYD2F',z%LSSYD2F,1)
  CALL phcdf_write_int(KCDF,'LSSYDE2',z%LSSYDE2,1)
  CALL phcdf_write_int(KCDF,'LSSYDF3',z%LSSYDF3,1)
  CALL phcdf_write_int(KCDF,'LSSYDF4',z%LSSYDF4,1)
  CALL phcdf_write_int(KCDF,'LSSYDF6',z%LSSYDF6,1)
  CALL phcdf_write_int(KCDF,'LSSYDFD',z%LSSYDFD,1)
  CALL phcdf_write_int(KCDF,'LSSYDFH',z%LSSYDFH,1)
  CALL phcdf_write_int(KCDF,'LSSYDFT',z%LSSYDFT,1)
  CALL phcdf_write_int(KCDF,'LSSYECF',z%LSSYECF,1)
  CALL phcdf_write_int(KCDF,'LSSYFEH',z%LSSYFEH,1)
  CALL phcdf_write_int(KCDF,'LSSYFEL',z%LSSYFEL,1)
  CALL phcdf_write_int(KCDF,'LSSYGRB',z%LSSYGRB,1)
  CALL phcdf_write_int(KCDF,'LSSYIBE',z%LSSYIBE,1)
  CALL phcdf_write_int(KCDF,'LSSYIBI',z%LSSYIBI,1)
  CALL phcdf_write_int(KCDF,'LSSYJBM',z%LSSYJBM,1)
  CALL phcdf_write_int(KCDF,'LSSYJEC',z%LSSYJEC,1)
  CALL phcdf_write_int(KCDF,'LSSYJIC',z%LSSYJIC,1)
  CALL phcdf_write_int(KCDF,'LSSYLF3',z%LSSYLF3,1)
  CALL phcdf_write_int(KCDF,'LSSYLF4',z%LSSYLF4,1)
  CALL phcdf_write_int(KCDF,'LSSYLF6',z%LSSYLF6,1)
  CALL phcdf_write_int(KCDF,'LSSYLFD',z%LSSYLFD,1)
  CALL phcdf_write_int(KCDF,'LSSYLFH',z%LSSYLFH,1)
  CALL phcdf_write_int(KCDF,'LSSYLFT',z%LSSYLFT,1)
  CALL phcdf_write_int(KCDF,'LSSYLHE',z%LSSYLHE,1)
  CALL phcdf_write_int(KCDF,'LSSYLHJ',z%LSSYLHJ,1)
  CALL phcdf_write_int(KCDF,'LSSYMSE',z%LSSYMSE,1)
  CALL phcdf_write_int(KCDF,'LSSYNER',z%LSSYNER,1)
  CALL phcdf_write_int(KCDF,'LSSYNI3',z%LSSYNI3,1)
  CALL phcdf_write_int(KCDF,'LSSYNI4',z%LSSYNI4,1)
  CALL phcdf_write_int(KCDF,'LSSYNI6',z%LSSYNI6,1)
  CALL phcdf_write_int(KCDF,'LSSYNID',z%LSSYNID,1)
  CALL phcdf_write_int(KCDF,'LSSYNIH',z%LSSYNIH,1)
  CALL phcdf_write_int(KCDF,'LSSYNIM',z%LSSYNIM,1)
  CALL phcdf_write_int(KCDF,'LSSYNIT',z%LSSYNIT,1)
  CALL phcdf_write_int(KCDF,'LSSYNMR',z%LSSYNMR,1)
  CALL phcdf_write_int(KCDF,'LSSYOMG',z%LSSYOMG,1)
  CALL phcdf_write_int(KCDF,'LSSYPRS',z%LSSYPRS,1)
  CALL phcdf_write_int(KCDF,'LSSYQBE',z%LSSYQBE,1)
  CALL phcdf_write_int(KCDF,'LSSYQBI',z%LSSYQBI,1)
  CALL phcdf_write_int(KCDF,'LSSYQEC',z%LSSYQEC,1)
  CALL phcdf_write_int(KCDF,'LSSYQIC',z%LSSYQIC,1)
  CALL phcdf_write_int(KCDF,'LSSYQPR',z%LSSYQPR,1)
  CALL phcdf_write_int(KCDF,'LSSYRES',z%LSSYRES,1)
  CALL phcdf_write_int(KCDF,'LSSYSBI',z%LSSYSBI,1)
  CALL phcdf_write_int(KCDF,'LSSYSIM',z%LSSYSIM,300)
  CALL phcdf_write_int(KCDF,'LSSYTER',z%LSSYTER,1)
  CALL phcdf_write_int(KCDF,'LSSYTI2',z%LSSYTI2,1)
  CALL phcdf_write_int(KCDF,'LSSYTQI',z%LSSYTQI,1)
  CALL phcdf_write_int(KCDF,'LSSYV2F',z%LSSYV2F,1)
  CALL phcdf_write_int(KCDF,'LSSYVB2',z%LSSYVB2,1)
  CALL phcdf_write_int(KCDF,'LSSYVC3',z%LSSYVC3,1)
  CALL phcdf_write_int(KCDF,'LSSYVC4',z%LSSYVC4,1)
  CALL phcdf_write_int(KCDF,'LSSYVC6',z%LSSYVC6,1)
  CALL phcdf_write_int(KCDF,'LSSYVCD',z%LSSYVCD,1)
  CALL phcdf_write_int(KCDF,'LSSYVCH',z%LSSYVCH,1)
  CALL phcdf_write_int(KCDF,'LSSYVCT',z%LSSYVCT,1)
  CALL phcdf_write_int(KCDF,'LSSYVEE',z%LSSYVEE,1)
  CALL phcdf_write_int(KCDF,'LSSYVIE',z%LSSYVIE,1)
  CALL phcdf_write_int(KCDF,'LSSYVMO',z%LSSYVMO,1)
  CALL phcdf_write_int(KCDF,'LSSYVP2',z%LSSYVP2,1)
  CALL phcdf_write_int(KCDF,'LSSYVPO',z%LSSYVPO,1)
  CALL phcdf_write_int(KCDF,'LSSYVPR',z%LSSYVPR,1)
  CALL phcdf_write_int(KCDF,'LSSYVTR',z%LSSYVTR,1)
  CALL phcdf_write_int(KCDF,'LSSYZF2',z%LSSYZF2,1)
  CALL phcdf_write_int(KCDF,'LSSYZXR',z%LSSYZXR,1)
  CALL phcdf_write_int(KCDF,'LTABORT',z%LTABORT,1)
  CALL phcdf_write_int(KCDF,'LTAEP',z%LTAEP,1)
  CALL phcdf_write_int(KCDF,'LTFD0',z%LTFD0,1)
  CALL phcdf_write_int(KCDF,'LTFDB',z%LTFDB,1)
  CALL phcdf_write_int(KCDF,'LTFDP',z%LTFDP,1)
  CALL phcdf_write_int(KCDF,'LTFDQ',z%LTFDQ,1)
  CALL phcdf_write_int(KCDF,'LTFDR',z%LTFDR,1)
  CALL phcdf_write_int(KCDF,'LTFDS',z%LTFDS,1)
  CALL phcdf_write_int(KCDF,'LTHFS',z%LTHFS,1)
  CALL phcdf_write_int(KCDF,'LTIME1',z%LTIME1,1)
  CALL phcdf_write_int(KCDF,'LTIME2',z%LTIME2,1)
  CALL phcdf_write_int(KCDF,'LTIMEC',z%LTIMEC,1)
  CALL phcdf_write_int(KCDF,'LTIMECA',z%LTIMECA,1)
  CALL phcdf_write_int(KCDF,'LTIMECB',z%LTIMECB,1)
  CALL phcdf_write_int(KCDF,'LTIMLH',z%LTIMLH,1)
  CALL phcdf_write_int(KCDF,'LTIMNB',z%LTIMNB,1)
  CALL phcdf_write_int(KCDF,'LTIMRF',z%LTIMRF,1)
  CALL phcdf_write_int(KCDF,'LTIMRFF',z%LTIMRFF,1)
  CALL phcdf_write_int(KCDF,'LTPSI',z%LTPSI,1)
  CALL phcdf_write_int(KCDF,'LTSAW',z%LTSAW,1)
  CALL phcdf_write_int(KCDF,'LVLTNB',z%LVLTNB,1)
  CALL phcdf_write_int(KCDF,'LXAXR',z%LXAXR,1)
  CALL phcdf_write_int(KCDF,'LXBOL',z%LXBOL,1)
  CALL phcdf_write_int(KCDF,'LXBPA',z%LXBPA,1)
  CALL phcdf_write_int(KCDF,'LXBPB',z%LXBPB,1)
  CALL phcdf_write_int(KCDF,'LXD2F',z%LXD2F,1)
  CALL phcdf_write_int(KCDF,'LXDE2',z%LXDE2,1)
  CALL phcdf_write_int(KCDF,'LXDF3',z%LXDF3,1)
  CALL phcdf_write_int(KCDF,'LXDF4',z%LXDF4,1)
  CALL phcdf_write_int(KCDF,'LXDF6',z%LXDF6,1)
  CALL phcdf_write_int(KCDF,'LXDFD',z%LXDFD,1)
  CALL phcdf_write_int(KCDF,'LXDFH',z%LXDFH,1)
  CALL phcdf_write_int(KCDF,'LXDFT',z%LXDFT,1)
  CALL phcdf_write_int(KCDF,'LXECF',z%LXECF,1)
  CALL phcdf_write_int(KCDF,'LXFD0',z%LXFD0,1)
  CALL phcdf_write_int(KCDF,'LXFDB',z%LXFDB,1)
  CALL phcdf_write_int(KCDF,'LXFDP',z%LXFDP,1)
  CALL phcdf_write_int(KCDF,'LXFDQ',z%LXFDQ,1)
  CALL phcdf_write_int(KCDF,'LXFDR',z%LXFDR,1)
  CALL phcdf_write_int(KCDF,'LXFDS',z%LXFDS,1)
  CALL phcdf_write_int(KCDF,'LXFEH',z%LXFEH,1)
  CALL phcdf_write_int(KCDF,'LXFEL',z%LXFEL,1)
  CALL phcdf_write_int(KCDF,'LXFS',z%LXFS,1)
  CALL phcdf_write_int(KCDF,'LXGRB',z%LXGRB,1)
  CALL phcdf_write_int(KCDF,'LXIBE',z%LXIBE,1)
  CALL phcdf_write_int(KCDF,'LXIBI',z%LXIBI,1)
  CALL phcdf_write_int(KCDF,'LXJBM',z%LXJBM,1)
  CALL phcdf_write_int(KCDF,'LXJEC',z%LXJEC,1)
  CALL phcdf_write_int(KCDF,'LXJIC',z%LXJIC,1)
  CALL phcdf_write_int(KCDF,'LXLF3',z%LXLF3,1)
  CALL phcdf_write_int(KCDF,'LXLF4',z%LXLF4,1)
  CALL phcdf_write_int(KCDF,'LXLF6',z%LXLF6,1)
  CALL phcdf_write_int(KCDF,'LXLFD',z%LXLFD,1)
  CALL phcdf_write_int(KCDF,'LXLFH',z%LXLFH,1)
  CALL phcdf_write_int(KCDF,'LXLFT',z%LXLFT,1)
  CALL phcdf_write_int(KCDF,'LXLHE',z%LXLHE,1)
  CALL phcdf_write_int(KCDF,'LXLHJ',z%LXLHJ,1)
  CALL phcdf_write_int(KCDF,'LXMMX',z%LXMMX,1)
  CALL phcdf_write_int(KCDF,'LXMSE',z%LXMSE,1)
  CALL phcdf_write_int(KCDF,'LXNER',z%LXNER,1)
  CALL phcdf_write_int(KCDF,'LXNI3',z%LXNI3,1)
  CALL phcdf_write_int(KCDF,'LXNI4',z%LXNI4,1)
  CALL phcdf_write_int(KCDF,'LXNI6',z%LXNI6,1)
  CALL phcdf_write_int(KCDF,'LXNID',z%LXNID,1)
  CALL phcdf_write_int(KCDF,'LXNIH',z%LXNIH,1)
  CALL phcdf_write_int(KCDF,'LXNIM',z%LXNIM,1)
  CALL phcdf_write_int(KCDF,'LXNIT',z%LXNIT,1)
  CALL phcdf_write_int(KCDF,'LXNMR',z%LXNMR,1)
  CALL phcdf_write_int(KCDF,'LXOMG',z%LXOMG,1)
  CALL phcdf_write_int(KCDF,'LXPFC',z%LXPFC,1)
  CALL phcdf_write_int(KCDF,'LXPRS',z%LXPRS,1)
  CALL phcdf_write_int(KCDF,'LXQBE',z%LXQBE,1)
  CALL phcdf_write_int(KCDF,'LXQBI',z%LXQBI,1)
  CALL phcdf_write_int(KCDF,'LXQEC',z%LXQEC,1)
  CALL phcdf_write_int(KCDF,'LXQIC',z%LXQIC,1)
  CALL phcdf_write_int(KCDF,'LXQPR',z%LXQPR,1)
  CALL phcdf_write_int(KCDF,'LXRES',z%LXRES,1)
  CALL phcdf_write_int(KCDF,'LXRP2',z%LXRP2,1)
  CALL phcdf_write_int(KCDF,'LXRPL',z%LXRPL,1)
  CALL phcdf_write_int(KCDF,'LXSBI',z%LXSBI,1)
  CALL phcdf_write_int(KCDF,'LXSIM',z%LXSIM,8)
  CALL phcdf_write_int(KCDF,'LXSYAXR',z%LXSYAXR,1)
  CALL phcdf_write_int(KCDF,'LXSYBOL',z%LXSYBOL,1)
  CALL phcdf_write_int(KCDF,'LXSYBPA',z%LXSYBPA,1)
  CALL phcdf_write_int(KCDF,'LXSYBPB',z%LXSYBPB,1)
  CALL phcdf_write_int(KCDF,'LXSYD2F',z%LXSYD2F,1)
  CALL phcdf_write_int(KCDF,'LXSYDE2',z%LXSYDE2,1)
  CALL phcdf_write_int(KCDF,'LXSYDF3',z%LXSYDF3,1)
  CALL phcdf_write_int(KCDF,'LXSYDF4',z%LXSYDF4,1)
  CALL phcdf_write_int(KCDF,'LXSYDF6',z%LXSYDF6,1)
  CALL phcdf_write_int(KCDF,'LXSYDFD',z%LXSYDFD,1)
  CALL phcdf_write_int(KCDF,'LXSYDFH',z%LXSYDFH,1)
  CALL phcdf_write_int(KCDF,'LXSYDFT',z%LXSYDFT,1)
  CALL phcdf_write_int(KCDF,'LXSYECF',z%LXSYECF,1)
  CALL phcdf_write_int(KCDF,'LXSYFEH',z%LXSYFEH,1)
  CALL phcdf_write_int(KCDF,'LXSYFEL',z%LXSYFEL,1)
  CALL phcdf_write_int(KCDF,'LXSYGRB',z%LXSYGRB,1)
  CALL phcdf_write_int(KCDF,'LXSYIBE',z%LXSYIBE,1)
  CALL phcdf_write_int(KCDF,'LXSYIBI',z%LXSYIBI,1)
  CALL phcdf_write_int(KCDF,'LXSYJBM',z%LXSYJBM,1)
  CALL phcdf_write_int(KCDF,'LXSYJEC',z%LXSYJEC,1)
  CALL phcdf_write_int(KCDF,'LXSYJIC',z%LXSYJIC,1)
  CALL phcdf_write_int(KCDF,'LXSYLF3',z%LXSYLF3,1)
  CALL phcdf_write_int(KCDF,'LXSYLF4',z%LXSYLF4,1)
  CALL phcdf_write_int(KCDF,'LXSYLF6',z%LXSYLF6,1)
  CALL phcdf_write_int(KCDF,'LXSYLFD',z%LXSYLFD,1)
  CALL phcdf_write_int(KCDF,'LXSYLFH',z%LXSYLFH,1)
  CALL phcdf_write_int(KCDF,'LXSYLFT',z%LXSYLFT,1)
  CALL phcdf_write_int(KCDF,'LXSYLHE',z%LXSYLHE,1)
  CALL phcdf_write_int(KCDF,'LXSYLHJ',z%LXSYLHJ,1)
  CALL phcdf_write_int(KCDF,'LXSYMSE',z%LXSYMSE,1)
  CALL phcdf_write_int(KCDF,'LXSYNER',z%LXSYNER,1)
  CALL phcdf_write_int(KCDF,'LXSYNI3',z%LXSYNI3,1)
  CALL phcdf_write_int(KCDF,'LXSYNI4',z%LXSYNI4,1)
  CALL phcdf_write_int(KCDF,'LXSYNI6',z%LXSYNI6,1)
  CALL phcdf_write_int(KCDF,'LXSYNID',z%LXSYNID,1)
  CALL phcdf_write_int(KCDF,'LXSYNIH',z%LXSYNIH,1)
  CALL phcdf_write_int(KCDF,'LXSYNIM',z%LXSYNIM,1)
  CALL phcdf_write_int(KCDF,'LXSYNIT',z%LXSYNIT,1)
  CALL phcdf_write_int(KCDF,'LXSYNMR',z%LXSYNMR,1)
  CALL phcdf_write_int(KCDF,'LXSYOMG',z%LXSYOMG,1)
  CALL phcdf_write_int(KCDF,'LXSYPRS',z%LXSYPRS,1)
  CALL phcdf_write_int(KCDF,'LXSYQBE',z%LXSYQBE,1)
  CALL phcdf_write_int(KCDF,'LXSYQBI',z%LXSYQBI,1)
  CALL phcdf_write_int(KCDF,'LXSYQEC',z%LXSYQEC,1)
  CALL phcdf_write_int(KCDF,'LXSYQIC',z%LXSYQIC,1)
  CALL phcdf_write_int(KCDF,'LXSYQPR',z%LXSYQPR,1)
  CALL phcdf_write_int(KCDF,'LXSYRES',z%LXSYRES,1)
  CALL phcdf_write_int(KCDF,'LXSYSBI',z%LXSYSBI,1)
  CALL phcdf_write_int(KCDF,'LXSYSIM',z%LXSYSIM,8)
  CALL phcdf_write_int(KCDF,'LXSYTER',z%LXSYTER,1)
  CALL phcdf_write_int(KCDF,'LXSYTI2',z%LXSYTI2,1)
  CALL phcdf_write_int(KCDF,'LXSYTQI',z%LXSYTQI,1)
  CALL phcdf_write_int(KCDF,'LXSYV2F',z%LXSYV2F,1)
  CALL phcdf_write_int(KCDF,'LXSYVB2',z%LXSYVB2,1)
  CALL phcdf_write_int(KCDF,'LXSYVC3',z%LXSYVC3,1)
  CALL phcdf_write_int(KCDF,'LXSYVC4',z%LXSYVC4,1)
  CALL phcdf_write_int(KCDF,'LXSYVC6',z%LXSYVC6,1)
  CALL phcdf_write_int(KCDF,'LXSYVCD',z%LXSYVCD,1)
  CALL phcdf_write_int(KCDF,'LXSYVCH',z%LXSYVCH,1)
  CALL phcdf_write_int(KCDF,'LXSYVCT',z%LXSYVCT,1)
  CALL phcdf_write_int(KCDF,'LXSYVEE',z%LXSYVEE,1)
  CALL phcdf_write_int(KCDF,'LXSYVIE',z%LXSYVIE,1)
  CALL phcdf_write_int(KCDF,'LXSYVMO',z%LXSYVMO,1)
  CALL phcdf_write_int(KCDF,'LXSYVP2',z%LXSYVP2,1)
  CALL phcdf_write_int(KCDF,'LXSYVPO',z%LXSYVPO,1)
  CALL phcdf_write_int(KCDF,'LXSYVPR',z%LXSYVPR,1)
  CALL phcdf_write_int(KCDF,'LXSYVTR',z%LXSYVTR,1)
  CALL phcdf_write_int(KCDF,'LXSYZF2',z%LXSYZF2,1)
  CALL phcdf_write_int(KCDF,'LXSYZXR',z%LXSYZXR,1)
  CALL phcdf_write_int(KCDF,'LXTER',z%LXTER,1)
  CALL phcdf_write_int(KCDF,'LXTI2',z%LXTI2,1)
  CALL phcdf_write_int(KCDF,'LXTQI',z%LXTQI,1)
  CALL phcdf_write_int(KCDF,'LXV2F',z%LXV2F,1)
  CALL phcdf_write_int(KCDF,'LXVB2',z%LXVB2,1)
  CALL phcdf_write_int(KCDF,'LXVC3',z%LXVC3,1)
  CALL phcdf_write_int(KCDF,'LXVC4',z%LXVC4,1)
  CALL phcdf_write_int(KCDF,'LXVC6',z%LXVC6,1)
  CALL phcdf_write_int(KCDF,'LXVCD',z%LXVCD,1)
  CALL phcdf_write_int(KCDF,'LXVCH',z%LXVCH,1)
  CALL phcdf_write_int(KCDF,'LXVCT',z%LXVCT,1)
  CALL phcdf_write_int(KCDF,'LXVEE',z%LXVEE,1)
  CALL phcdf_write_int(KCDF,'LXVIE',z%LXVIE,1)
  CALL phcdf_write_int(KCDF,'LXVMO',z%LXVMO,1)
  CALL phcdf_write_int(KCDF,'LXVP2',z%LXVP2,1)
  CALL phcdf_write_int(KCDF,'LXVPO',z%LXVPO,1)
  CALL phcdf_write_int(KCDF,'LXVPR',z%LXVPR,1)
  CALL phcdf_write_int(KCDF,'LXVTR',z%LXVTR,1)
  CALL phcdf_write_int(KCDF,'LXZF2',z%LXZF2,1)
  CALL phcdf_write_int(KCDF,'LXZIMPS',z%LXZIMPS,1)
  CALL phcdf_write_int(KCDF,'LXZIMPX',z%LXZIMPX,1)
  CALL phcdf_write_int(KCDF,'LXZIMPXS',z%LXZIMPXS,1)
  CALL phcdf_write_int(KCDF,'LXZXR',z%LXZXR,1)
  CALL phcdf_write_int(KCDF,'LYRP2',z%LYRP2,1)
  CALL phcdf_write_int(KCDF,'LYRPL',z%LYRPL,1)
  CALL phcdf_write_int(KCDF,'LYSIM',z%LYSIM,1)
  CALL phcdf_write_int(KCDF,'LZFS',z%LZFS,1)
  CALL phcdf_write_int(KCDF,'LZPSI',z%LZPSI,1)
  CALL phcdf_write_int(KCDF,'MMAX',z%MMAX,1)
  CALL phcdf_write_int(KCDF,'MMX_MAXE',z%MMX_MAXE,1)
  CALL phcdf_write_int(KCDF,'MTRP2',z%MTRP2,1)
  CALL phcdf_write_int(KCDF,'MTRPL',z%MTRPL,1)
  CALL phcdf_write_int(KCDF,'NANTECH_D',z%NANTECH_D,1)
  CALL phcdf_write_int(KCDF,'NANTICH_D',z%NANTICH_D,1)
  CALL phcdf_write_int(KCDF,'NANTLH_D',z%NANTLH_D,1)
  CALL phcdf_write_int(KCDF,'NBDATA',z%NBDATA,1)
  CALL phcdf_write_int(KCDF,'NDEAEP',z%NDEAEP,1)
  CALL phcdf_write_int(KCDF,'NDFS',z%NDFS,1)
  CALL phcdf_write_int(KCDF,'NDMDF',z%NDMDF,1)
  CALL phcdf_write_int(KCDF,'NDMFR',z%NDMFR,1)
  CALL phcdf_write_int(KCDF,'NDMMX',z%NDMMX,1)
  CALL phcdf_write_int(KCDF,'NDMSE',z%NDMSE,1)
  CALL phcdf_write_int(KCDF,'NDPAEP',z%NDPAEP,1)
  CALL phcdf_write_int(KCDF,'NDPFC',z%NDPFC,1)
  CALL phcdf_write_int(KCDF,'NDPFC_PRE',z%NDPFC_PRE,1)
  CALL phcdf_write_int(KCDF,'NEAEP',z%NEAEP,1)
  CALL phcdf_write_int(KCDF,'NEFD0',z%NEFD0,1)
  CALL phcdf_write_int(KCDF,'NEFDB',z%NEFDB,1)
  CALL phcdf_write_int(KCDF,'NEFDP',z%NEFDP,1)
  CALL phcdf_write_int(KCDF,'NEFDQ',z%NEFDQ,1)
  CALL phcdf_write_int(KCDF,'NEFDR',z%NEFDR,1)
  CALL phcdf_write_int(KCDF,'NEFDS',z%NEFDS,1)
  CALL phcdf_write_int(KCDF,'NFRBCODE',z%NFRBCODE,1)
  CALL phcdf_write_int(KCDF,'NFRBMODE',z%NFRBMODE,1)
  CALL phcdf_write_int(KCDF,'NGMAX_D',z%NGMAX_D,1)
  CALL phcdf_write_int(KCDF,'NHECFT',z%NHECFT,1)
  CALL phcdf_write_int(KCDF,'NHFMX',z%NHFMX,1)
  CALL phcdf_write_int(KCDF,'NIMDF',z%NIMDF,1)
  CALL phcdf_write_int(KCDF,'NISSIM',z%NISSIM,300)
  CALL phcdf_write_int(KCDF,'NISX',z%NISX,300)
  CALL phcdf_write_int(KCDF,'NITSIM',z%NITSIM,8)
  CALL phcdf_write_int(KCDF,'NITX',z%NITX,8)
  CALL phcdf_write_int(KCDF,'NKAEP',z%NKAEP,1)
  CALL phcdf_write_int(KCDF,'NLIM',z%NLIM,1)
  CALL phcdf_write_int(KCDF,'NMAPSIM',z%NMAPSIM,300)
  CALL phcdf_write_int(KCDF,'NMDXKF',z%NMDXKF,1)
  CALL phcdf_write_int(KCDF,'NMIMP',z%NMIMP,1)
  CALL phcdf_write_int(KCDF,'NMOMD',z%NMOMD,1)
  CALL phcdf_write_int(KCDF,'NMUAEP',z%NMUAEP,1)
  CALL phcdf_write_int(KCDF,'NMZEFF',z%NMZEFF,1)
  CALL phcdf_write_int(KCDF,'NNSIM',z%NNSIM,1)
  CALL phcdf_write_int(KCDF,'NPACK',z%NPACK,1)
  CALL phcdf_write_int(KCDF,'NPAEP',z%NPAEP,1)
  CALL phcdf_write_int(KCDF,'NPELDA',z%NPELDA,1)
  CALL phcdf_write_int(KCDF,'NPMDF',z%NPMDF,1)
  CALL phcdf_write_int(KCDF,'NPMSE',z%NPMSE,1)
  CALL phcdf_write_int(KCDF,'NRHIS',z%NRHIS,1)
  CALL phcdf_write_int(KCDF,'NRHIX',z%NRHIX,1)
  CALL phcdf_write_int(KCDF,'NRIAXR',z%NRIAXR,1)
  CALL phcdf_write_int(KCDF,'NRIBOL',z%NRIBOL,1)
  CALL phcdf_write_int(KCDF,'NRIBPA',z%NRIBPA,1)
  CALL phcdf_write_int(KCDF,'NRIBPB',z%NRIBPB,1)
  CALL phcdf_write_int(KCDF,'NRID2F',z%NRID2F,1)
  CALL phcdf_write_int(KCDF,'NRIDE2',z%NRIDE2,1)
  CALL phcdf_write_int(KCDF,'NRIDF3',z%NRIDF3,1)
  CALL phcdf_write_int(KCDF,'NRIDF4',z%NRIDF4,1)
  CALL phcdf_write_int(KCDF,'NRIDF6',z%NRIDF6,1)
  CALL phcdf_write_int(KCDF,'NRIDFD',z%NRIDFD,1)
  CALL phcdf_write_int(KCDF,'NRIDFH',z%NRIDFH,1)
  CALL phcdf_write_int(KCDF,'NRIDFT',z%NRIDFT,1)
  CALL phcdf_write_int(KCDF,'NRIECF',z%NRIECF,1)
  CALL phcdf_write_int(KCDF,'NRIFD0',z%NRIFD0,1)
  CALL phcdf_write_int(KCDF,'NRIFDB',z%NRIFDB,1)
  CALL phcdf_write_int(KCDF,'NRIFDP',z%NRIFDP,1)
  CALL phcdf_write_int(KCDF,'NRIFDQ',z%NRIFDQ,1)
  CALL phcdf_write_int(KCDF,'NRIFDR',z%NRIFDR,1)
  CALL phcdf_write_int(KCDF,'NRIFDS',z%NRIFDS,1)
  CALL phcdf_write_int(KCDF,'NRIFEH',z%NRIFEH,1)
  CALL phcdf_write_int(KCDF,'NRIFEL',z%NRIFEL,1)
  CALL phcdf_write_int(KCDF,'NRIGRB',z%NRIGRB,1)
  CALL phcdf_write_int(KCDF,'NRIIBE',z%NRIIBE,1)
  CALL phcdf_write_int(KCDF,'NRIIBI',z%NRIIBI,1)
  CALL phcdf_write_int(KCDF,'NRIJBM',z%NRIJBM,1)
  CALL phcdf_write_int(KCDF,'NRIJEC',z%NRIJEC,1)
  CALL phcdf_write_int(KCDF,'NRIJIC',z%NRIJIC,1)
  CALL phcdf_write_int(KCDF,'NRILF3',z%NRILF3,1)
  CALL phcdf_write_int(KCDF,'NRILF4',z%NRILF4,1)
  CALL phcdf_write_int(KCDF,'NRILF6',z%NRILF6,1)
  CALL phcdf_write_int(KCDF,'NRILFD',z%NRILFD,1)
  CALL phcdf_write_int(KCDF,'NRILFH',z%NRILFH,1)
  CALL phcdf_write_int(KCDF,'NRILFT',z%NRILFT,1)
  CALL phcdf_write_int(KCDF,'NRILHE',z%NRILHE,1)
  CALL phcdf_write_int(KCDF,'NRILHJ',z%NRILHJ,1)
  CALL phcdf_write_int(KCDF,'NRIMSE',z%NRIMSE,1)
  CALL phcdf_write_int(KCDF,'NRINER',z%NRINER,1)
  CALL phcdf_write_int(KCDF,'NRINI3',z%NRINI3,1)
  CALL phcdf_write_int(KCDF,'NRINI4',z%NRINI4,1)
  CALL phcdf_write_int(KCDF,'NRINI6',z%NRINI6,1)
  CALL phcdf_write_int(KCDF,'NRINID',z%NRINID,1)
  CALL phcdf_write_int(KCDF,'NRINIH',z%NRINIH,1)
  CALL phcdf_write_int(KCDF,'NRINIM',z%NRINIM,1)
  CALL phcdf_write_int(KCDF,'NRINIT',z%NRINIT,1)
  CALL phcdf_write_int(KCDF,'NRINMR',z%NRINMR,1)
  CALL phcdf_write_int(KCDF,'NRIOMG',z%NRIOMG,1)
  CALL phcdf_write_int(KCDF,'NRIPRS',z%NRIPRS,1)
  CALL phcdf_write_int(KCDF,'NRIQBE',z%NRIQBE,1)
  CALL phcdf_write_int(KCDF,'NRIQBI',z%NRIQBI,1)
  CALL phcdf_write_int(KCDF,'NRIQEC',z%NRIQEC,1)
  CALL phcdf_write_int(KCDF,'NRIQIC',z%NRIQIC,1)
  CALL phcdf_write_int(KCDF,'NRIQPR',z%NRIQPR,1)
  CALL phcdf_write_int(KCDF,'NRIRES',z%NRIRES,1)
  CALL phcdf_write_int(KCDF,'NRISBI',z%NRISBI,1)
  CALL phcdf_write_int(KCDF,'NRISIM',z%NRISIM,8)
  CALL phcdf_write_int(KCDF,'NRITER',z%NRITER,1)
  CALL phcdf_write_int(KCDF,'NRITI2',z%NRITI2,1)
  CALL phcdf_write_int(KCDF,'NRITQI',z%NRITQI,1)
  CALL phcdf_write_int(KCDF,'NRIV2F',z%NRIV2F,1)
  CALL phcdf_write_int(KCDF,'NRIVB2',z%NRIVB2,1)
  CALL phcdf_write_int(KCDF,'NRIVC3',z%NRIVC3,1)
  CALL phcdf_write_int(KCDF,'NRIVC4',z%NRIVC4,1)
  CALL phcdf_write_int(KCDF,'NRIVC6',z%NRIVC6,1)
  CALL phcdf_write_int(KCDF,'NRIVCD',z%NRIVCD,1)
  CALL phcdf_write_int(KCDF,'NRIVCH',z%NRIVCH,1)
  CALL phcdf_write_int(KCDF,'NRIVCT',z%NRIVCT,1)
  CALL phcdf_write_int(KCDF,'NRIVEE',z%NRIVEE,1)
  CALL phcdf_write_int(KCDF,'NRIVIE',z%NRIVIE,1)
  CALL phcdf_write_int(KCDF,'NRIVMO',z%NRIVMO,1)
  CALL phcdf_write_int(KCDF,'NRIVP2',z%NRIVP2,1)
  CALL phcdf_write_int(KCDF,'NRIVPO',z%NRIVPO,1)
  CALL phcdf_write_int(KCDF,'NRIVPR',z%NRIVPR,1)
  CALL phcdf_write_int(KCDF,'NRIVTR',z%NRIVTR,1)
  CALL phcdf_write_int(KCDF,'NRIZF2',z%NRIZF2,1)
  CALL phcdf_write_int(KCDF,'NRIZXR',z%NRIZXR,1)
  CALL phcdf_write_int(KCDF,'NRMFR',z%NRMFR,1)
  CALL phcdf_write_int(KCDF,'NRMSE',z%NRMSE,1)
  CALL phcdf_write_int(KCDF,'NRP2',z%NRP2,1)
  CALL phcdf_write_int(KCDF,'NRPL',z%NRPL,1)
  CALL phcdf_write_int(KCDF,'NRPSI',z%NRPSI,1)
  CALL phcdf_write_int(KCDF,'NSAWFLAG',z%NSAWFLAG,1)
  CALL phcdf_write_int(KCDF,'NSC',z%NSC,1)
  CALL phcdf_write_int(KCDF,'NSC_FMT',z%NSC_FMT,1)
  CALL phcdf_write_int(KCDF,'NSEVENT',z%NSEVENT,1)
  CALL phcdf_write_int(KCDF,'NSEVPER',z%NSEVPER,1)
  CALL phcdf_write_int(KCDF,'NSEVTBL',z%NSEVTBL,1)
  CALL phcdf_write_int(KCDF,'NSEVWDS',z%NSEVWDS,1)
  CALL phcdf_write_int(KCDF,'NSFAST_D',z%NSFAST_D,1)
  CALL phcdf_write_int(KCDF,'NSYAXR',z%NSYAXR,1)
  CALL phcdf_write_int(KCDF,'NSYBOL',z%NSYBOL,1)
  CALL phcdf_write_int(KCDF,'NSYBPA',z%NSYBPA,1)
  CALL phcdf_write_int(KCDF,'NSYBPB',z%NSYBPB,1)
  CALL phcdf_write_int(KCDF,'NSYD2F',z%NSYD2F,1)
  CALL phcdf_write_int(KCDF,'NSYDE2',z%NSYDE2,1)
  CALL phcdf_write_int(KCDF,'NSYDF3',z%NSYDF3,1)
  CALL phcdf_write_int(KCDF,'NSYDF4',z%NSYDF4,1)
  CALL phcdf_write_int(KCDF,'NSYDF6',z%NSYDF6,1)
  CALL phcdf_write_int(KCDF,'NSYDFD',z%NSYDFD,1)
  CALL phcdf_write_int(KCDF,'NSYDFH',z%NSYDFH,1)
  CALL phcdf_write_int(KCDF,'NSYDFT',z%NSYDFT,1)
  CALL phcdf_write_int(KCDF,'NSYECF',z%NSYECF,1)
  CALL phcdf_write_int(KCDF,'NSYFEH',z%NSYFEH,1)
  CALL phcdf_write_int(KCDF,'NSYFEL',z%NSYFEL,1)
  CALL phcdf_write_int(KCDF,'NSYGRB',z%NSYGRB,1)
  CALL phcdf_write_int(KCDF,'NSYIBE',z%NSYIBE,1)
  CALL phcdf_write_int(KCDF,'NSYIBI',z%NSYIBI,1)
  CALL phcdf_write_int(KCDF,'NSYJBM',z%NSYJBM,1)
  CALL phcdf_write_int(KCDF,'NSYJEC',z%NSYJEC,1)
  CALL phcdf_write_int(KCDF,'NSYJIC',z%NSYJIC,1)
  CALL phcdf_write_int(KCDF,'NSYLF3',z%NSYLF3,1)
  CALL phcdf_write_int(KCDF,'NSYLF4',z%NSYLF4,1)
  CALL phcdf_write_int(KCDF,'NSYLF6',z%NSYLF6,1)
  CALL phcdf_write_int(KCDF,'NSYLFD',z%NSYLFD,1)
  CALL phcdf_write_int(KCDF,'NSYLFH',z%NSYLFH,1)
  CALL phcdf_write_int(KCDF,'NSYLFT',z%NSYLFT,1)
  CALL phcdf_write_int(KCDF,'NSYLHE',z%NSYLHE,1)
  CALL phcdf_write_int(KCDF,'NSYLHJ',z%NSYLHJ,1)
  CALL phcdf_write_int(KCDF,'NSYMSE',z%NSYMSE,1)
  CALL phcdf_write_int(KCDF,'NSYNER',z%NSYNER,1)
  CALL phcdf_write_int(KCDF,'NSYNI3',z%NSYNI3,1)
  CALL phcdf_write_int(KCDF,'NSYNI4',z%NSYNI4,1)
  CALL phcdf_write_int(KCDF,'NSYNI6',z%NSYNI6,1)
  CALL phcdf_write_int(KCDF,'NSYNID',z%NSYNID,1)
  CALL phcdf_write_int(KCDF,'NSYNIH',z%NSYNIH,1)
  CALL phcdf_write_int(KCDF,'NSYNIM',z%NSYNIM,1)
  CALL phcdf_write_int(KCDF,'NSYNIT',z%NSYNIT,1)
  CALL phcdf_write_int(KCDF,'NSYNMR',z%NSYNMR,1)
  CALL phcdf_write_int(KCDF,'NSYOMG',z%NSYOMG,1)
  CALL phcdf_write_int(KCDF,'NSYPRS',z%NSYPRS,1)
  CALL phcdf_write_int(KCDF,'NSYQBE',z%NSYQBE,1)
  CALL phcdf_write_int(KCDF,'NSYQBI',z%NSYQBI,1)
  CALL phcdf_write_int(KCDF,'NSYQEC',z%NSYQEC,1)
  CALL phcdf_write_int(KCDF,'NSYQIC',z%NSYQIC,1)
  CALL phcdf_write_int(KCDF,'NSYQPR',z%NSYQPR,1)
  CALL phcdf_write_int(KCDF,'NSYRES',z%NSYRES,1)
  CALL phcdf_write_int(KCDF,'NSYSBI',z%NSYSBI,1)
  CALL phcdf_write_int(KCDF,'NSYSIM',z%NSYSIM,8)
  CALL phcdf_write_int(KCDF,'NSYTER',z%NSYTER,1)
  CALL phcdf_write_int(KCDF,'NSYTI2',z%NSYTI2,1)
  CALL phcdf_write_int(KCDF,'NSYTQI',z%NSYTQI,1)
  CALL phcdf_write_int(KCDF,'NSYV2F',z%NSYV2F,1)
  CALL phcdf_write_int(KCDF,'NSYVB2',z%NSYVB2,1)
  CALL phcdf_write_int(KCDF,'NSYVC3',z%NSYVC3,1)
  CALL phcdf_write_int(KCDF,'NSYVC4',z%NSYVC4,1)
  CALL phcdf_write_int(KCDF,'NSYVC6',z%NSYVC6,1)
  CALL phcdf_write_int(KCDF,'NSYVCD',z%NSYVCD,1)
  CALL phcdf_write_int(KCDF,'NSYVCH',z%NSYVCH,1)
  CALL phcdf_write_int(KCDF,'NSYVCT',z%NSYVCT,1)
  CALL phcdf_write_int(KCDF,'NSYVEE',z%NSYVEE,1)
  CALL phcdf_write_int(KCDF,'NSYVIE',z%NSYVIE,1)
  CALL phcdf_write_int(KCDF,'NSYVMO',z%NSYVMO,1)
  CALL phcdf_write_int(KCDF,'NSYVP2',z%NSYVP2,1)
  CALL phcdf_write_int(KCDF,'NSYVPO',z%NSYVPO,1)
  CALL phcdf_write_int(KCDF,'NSYVPR',z%NSYVPR,1)
  CALL phcdf_write_int(KCDF,'NSYVTR',z%NSYVTR,1)
  CALL phcdf_write_int(KCDF,'NSYZF2',z%NSYZF2,1)
  CALL phcdf_write_int(KCDF,'NSYZXR',z%NSYZXR,1)
  CALL phcdf_write_int(KCDF,'NTABORT',z%NTABORT,1)
  CALL phcdf_write_int(KCDF,'NTAEP',z%NTAEP,1)
  CALL phcdf_write_int(KCDF,'NTFD0',z%NTFD0,1)
  CALL phcdf_write_int(KCDF,'NTFDB',z%NTFDB,1)
  CALL phcdf_write_int(KCDF,'NTFDP',z%NTFDP,1)
  CALL phcdf_write_int(KCDF,'NTFDQ',z%NTFDQ,1)
  CALL phcdf_write_int(KCDF,'NTFDR',z%NTFDR,1)
  CALL phcdf_write_int(KCDF,'NTFDS',z%NTFDS,1)
  CALL phcdf_write_int(KCDF,'NTHFS',z%NTHFS,1)
  CALL phcdf_write_int(KCDF,'NTIME1',z%NTIME1,1)
  CALL phcdf_write_int(KCDF,'NTIME2',z%NTIME2,1)
  CALL phcdf_write_int(KCDF,'NTIMEC',z%NTIMEC,1)
  CALL phcdf_write_int(KCDF,'NTIMECA',z%NTIMECA,1)
  CALL phcdf_write_int(KCDF,'NTIMECB',z%NTIMECB,1)
  CALL phcdf_write_int(KCDF,'NTIMLH',z%NTIMLH,1)
  CALL phcdf_write_int(KCDF,'NTIMNB',z%NTIMNB,1)
  CALL phcdf_write_int(KCDF,'NTIMRF',z%NTIMRF,1)
  CALL phcdf_write_int(KCDF,'NTIMRFF',z%NTIMRFF,1)
  CALL phcdf_write_int(KCDF,'NTPSI',z%NTPSI,1)
  CALL phcdf_write_int(KCDF,'NTSAW',z%NTSAW,1)
  CALL phcdf_write_int(KCDF,'NXAXR',z%NXAXR,1)
  CALL phcdf_write_int(KCDF,'NXBOL',z%NXBOL,1)
  CALL phcdf_write_int(KCDF,'NXBPA',z%NXBPA,1)
  CALL phcdf_write_int(KCDF,'NXBPB',z%NXBPB,1)
  CALL phcdf_write_int(KCDF,'NXD2F',z%NXD2F,1)
  CALL phcdf_write_int(KCDF,'NXDE2',z%NXDE2,1)
  CALL phcdf_write_int(KCDF,'NXDF3',z%NXDF3,1)
  CALL phcdf_write_int(KCDF,'NXDF4',z%NXDF4,1)
  CALL phcdf_write_int(KCDF,'NXDF6',z%NXDF6,1)
  CALL phcdf_write_int(KCDF,'NXDFD',z%NXDFD,1)
  CALL phcdf_write_int(KCDF,'NXDFH',z%NXDFH,1)
  CALL phcdf_write_int(KCDF,'NXDFT',z%NXDFT,1)
  CALL phcdf_write_int(KCDF,'NXECF',z%NXECF,1)
  CALL phcdf_write_int(KCDF,'NXFD0',z%NXFD0,1)
  CALL phcdf_write_int(KCDF,'NXFDB',z%NXFDB,1)
  CALL phcdf_write_int(KCDF,'NXFDP',z%NXFDP,1)
  CALL phcdf_write_int(KCDF,'NXFDQ',z%NXFDQ,1)
  CALL phcdf_write_int(KCDF,'NXFDR',z%NXFDR,1)
  CALL phcdf_write_int(KCDF,'NXFDS',z%NXFDS,1)
  CALL phcdf_write_int(KCDF,'NXFEH',z%NXFEH,1)
  CALL phcdf_write_int(KCDF,'NXFEL',z%NXFEL,1)
  CALL phcdf_write_int(KCDF,'NXFS',z%NXFS,1)
  CALL phcdf_write_int(KCDF,'NXGRB',z%NXGRB,1)
  CALL phcdf_write_int(KCDF,'NXIBE',z%NXIBE,1)
  CALL phcdf_write_int(KCDF,'NXIBI',z%NXIBI,1)
  CALL phcdf_write_int(KCDF,'NXJBM',z%NXJBM,1)
  CALL phcdf_write_int(KCDF,'NXJEC',z%NXJEC,1)
  CALL phcdf_write_int(KCDF,'NXJIC',z%NXJIC,1)
  CALL phcdf_write_int(KCDF,'NXLF3',z%NXLF3,1)
  CALL phcdf_write_int(KCDF,'NXLF4',z%NXLF4,1)
  CALL phcdf_write_int(KCDF,'NXLF6',z%NXLF6,1)
  CALL phcdf_write_int(KCDF,'NXLFD',z%NXLFD,1)
  CALL phcdf_write_int(KCDF,'NXLFH',z%NXLFH,1)
  CALL phcdf_write_int(KCDF,'NXLFT',z%NXLFT,1)
  CALL phcdf_write_int(KCDF,'NXLHE',z%NXLHE,1)
  CALL phcdf_write_int(KCDF,'NXLHJ',z%NXLHJ,1)
  CALL phcdf_write_int(KCDF,'NXMMX',z%NXMMX,1)
  CALL phcdf_write_int(KCDF,'NXMSE',z%NXMSE,1)
  CALL phcdf_write_int(KCDF,'NXNE0',z%NXNE0,1)
  CALL phcdf_write_int(KCDF,'NXNER',z%NXNER,1)
  CALL phcdf_write_int(KCDF,'NXNI3',z%NXNI3,1)
  CALL phcdf_write_int(KCDF,'NXNI4',z%NXNI4,1)
  CALL phcdf_write_int(KCDF,'NXNI6',z%NXNI6,1)
  CALL phcdf_write_int(KCDF,'NXNID',z%NXNID,1)
  CALL phcdf_write_int(KCDF,'NXNIH',z%NXNIH,1)
  CALL phcdf_write_int(KCDF,'NXNIM',z%NXNIM,1)
  CALL phcdf_write_int(KCDF,'NXNIT',z%NXNIT,1)
  CALL phcdf_write_int(KCDF,'NXNM0',z%NXNM0,1)
  CALL phcdf_write_int(KCDF,'NXNMR',z%NXNMR,1)
  CALL phcdf_write_int(KCDF,'NXOMG',z%NXOMG,1)
  CALL phcdf_write_int(KCDF,'NXPFC',z%NXPFC,1)
  CALL phcdf_write_int(KCDF,'NXPRS',z%NXPRS,1)
  CALL phcdf_write_int(KCDF,'NXQBE',z%NXQBE,1)
  CALL phcdf_write_int(KCDF,'NXQBI',z%NXQBI,1)
  CALL phcdf_write_int(KCDF,'NXQEC',z%NXQEC,1)
  CALL phcdf_write_int(KCDF,'NXQIC',z%NXQIC,1)
  CALL phcdf_write_int(KCDF,'NXQPR',z%NXQPR,1)
  CALL phcdf_write_int(KCDF,'NXRES',z%NXRES,1)
  CALL phcdf_write_int(KCDF,'NXRP2',z%NXRP2,1)
  CALL phcdf_write_int(KCDF,'NXRPL',z%NXRPL,1)
  CALL phcdf_write_int(KCDF,'NXSBI',z%NXSBI,1)
  CALL phcdf_write_int(KCDF,'NXSIM',z%NXSIM,8)
  CALL phcdf_write_int(KCDF,'NXSYAXR',z%NXSYAXR,1)
  CALL phcdf_write_int(KCDF,'NXSYBOL',z%NXSYBOL,1)
  CALL phcdf_write_int(KCDF,'NXSYBPA',z%NXSYBPA,1)
  CALL phcdf_write_int(KCDF,'NXSYBPB',z%NXSYBPB,1)
  CALL phcdf_write_int(KCDF,'NXSYD2F',z%NXSYD2F,1)
  CALL phcdf_write_int(KCDF,'NXSYDE2',z%NXSYDE2,1)
  CALL phcdf_write_int(KCDF,'NXSYDF3',z%NXSYDF3,1)
  CALL phcdf_write_int(KCDF,'NXSYDF4',z%NXSYDF4,1)
  CALL phcdf_write_int(KCDF,'NXSYDF6',z%NXSYDF6,1)
  CALL phcdf_write_int(KCDF,'NXSYDFD',z%NXSYDFD,1)
  CALL phcdf_write_int(KCDF,'NXSYDFH',z%NXSYDFH,1)
  CALL phcdf_write_int(KCDF,'NXSYDFT',z%NXSYDFT,1)
  CALL phcdf_write_int(KCDF,'NXSYECF',z%NXSYECF,1)
  CALL phcdf_write_int(KCDF,'NXSYFEH',z%NXSYFEH,1)
  CALL phcdf_write_int(KCDF,'NXSYFEL',z%NXSYFEL,1)
  CALL phcdf_write_int(KCDF,'NXSYGRB',z%NXSYGRB,1)
  CALL phcdf_write_int(KCDF,'NXSYIBE',z%NXSYIBE,1)
  CALL phcdf_write_int(KCDF,'NXSYIBI',z%NXSYIBI,1)
  CALL phcdf_write_int(KCDF,'NXSYJBM',z%NXSYJBM,1)
  CALL phcdf_write_int(KCDF,'NXSYJEC',z%NXSYJEC,1)
  CALL phcdf_write_int(KCDF,'NXSYJIC',z%NXSYJIC,1)
  CALL phcdf_write_int(KCDF,'NXSYLF3',z%NXSYLF3,1)
  CALL phcdf_write_int(KCDF,'NXSYLF4',z%NXSYLF4,1)
  CALL phcdf_write_int(KCDF,'NXSYLF6',z%NXSYLF6,1)
  CALL phcdf_write_int(KCDF,'NXSYLFD',z%NXSYLFD,1)
  CALL phcdf_write_int(KCDF,'NXSYLFH',z%NXSYLFH,1)
  CALL phcdf_write_int(KCDF,'NXSYLFT',z%NXSYLFT,1)
  CALL phcdf_write_int(KCDF,'NXSYLHE',z%NXSYLHE,1)
  CALL phcdf_write_int(KCDF,'NXSYLHJ',z%NXSYLHJ,1)
  CALL phcdf_write_int(KCDF,'NXSYMSE',z%NXSYMSE,1)
  CALL phcdf_write_int(KCDF,'NXSYNER',z%NXSYNER,1)
  CALL phcdf_write_int(KCDF,'NXSYNI3',z%NXSYNI3,1)
  CALL phcdf_write_int(KCDF,'NXSYNI4',z%NXSYNI4,1)
  CALL phcdf_write_int(KCDF,'NXSYNI6',z%NXSYNI6,1)
  CALL phcdf_write_int(KCDF,'NXSYNID',z%NXSYNID,1)
  CALL phcdf_write_int(KCDF,'NXSYNIH',z%NXSYNIH,1)
  CALL phcdf_write_int(KCDF,'NXSYNIM',z%NXSYNIM,1)
  CALL phcdf_write_int(KCDF,'NXSYNIT',z%NXSYNIT,1)
  CALL phcdf_write_int(KCDF,'NXSYNMR',z%NXSYNMR,1)
  CALL phcdf_write_int(KCDF,'NXSYOMG',z%NXSYOMG,1)
  CALL phcdf_write_int(KCDF,'NXSYPRS',z%NXSYPRS,1)
  CALL phcdf_write_int(KCDF,'NXSYQBE',z%NXSYQBE,1)
  CALL phcdf_write_int(KCDF,'NXSYQBI',z%NXSYQBI,1)
  CALL phcdf_write_int(KCDF,'NXSYQEC',z%NXSYQEC,1)
  CALL phcdf_write_int(KCDF,'NXSYQIC',z%NXSYQIC,1)
  CALL phcdf_write_int(KCDF,'NXSYQPR',z%NXSYQPR,1)
  CALL phcdf_write_int(KCDF,'NXSYRES',z%NXSYRES,1)
  CALL phcdf_write_int(KCDF,'NXSYSBI',z%NXSYSBI,1)
  CALL phcdf_write_int(KCDF,'NXSYSIM',z%NXSYSIM,8)
  CALL phcdf_write_int(KCDF,'NXSYTER',z%NXSYTER,1)
  CALL phcdf_write_int(KCDF,'NXSYTI2',z%NXSYTI2,1)
  CALL phcdf_write_int(KCDF,'NXSYTQI',z%NXSYTQI,1)
  CALL phcdf_write_int(KCDF,'NXSYV2F',z%NXSYV2F,1)
  CALL phcdf_write_int(KCDF,'NXSYVB2',z%NXSYVB2,1)
  CALL phcdf_write_int(KCDF,'NXSYVC3',z%NXSYVC3,1)
  CALL phcdf_write_int(KCDF,'NXSYVC4',z%NXSYVC4,1)
  CALL phcdf_write_int(KCDF,'NXSYVC6',z%NXSYVC6,1)
  CALL phcdf_write_int(KCDF,'NXSYVCD',z%NXSYVCD,1)
  CALL phcdf_write_int(KCDF,'NXSYVCH',z%NXSYVCH,1)
  CALL phcdf_write_int(KCDF,'NXSYVCT',z%NXSYVCT,1)
  CALL phcdf_write_int(KCDF,'NXSYVEE',z%NXSYVEE,1)
  CALL phcdf_write_int(KCDF,'NXSYVIE',z%NXSYVIE,1)
  CALL phcdf_write_int(KCDF,'NXSYVMO',z%NXSYVMO,1)
  CALL phcdf_write_int(KCDF,'NXSYVP2',z%NXSYVP2,1)
  CALL phcdf_write_int(KCDF,'NXSYVPO',z%NXSYVPO,1)
  CALL phcdf_write_int(KCDF,'NXSYVPR',z%NXSYVPR,1)
  CALL phcdf_write_int(KCDF,'NXSYVTR',z%NXSYVTR,1)
  CALL phcdf_write_int(KCDF,'NXSYZF2',z%NXSYZF2,1)
  CALL phcdf_write_int(KCDF,'NXSYZXR',z%NXSYZXR,1)
  CALL phcdf_write_int(KCDF,'NXTE0',z%NXTE0,1)
  CALL phcdf_write_int(KCDF,'NXTER',z%NXTER,1)
  CALL phcdf_write_int(KCDF,'NXTI2',z%NXTI2,1)
  CALL phcdf_write_int(KCDF,'NXTQI',z%NXTQI,1)
  CALL phcdf_write_int(KCDF,'NXV2F',z%NXV2F,1)
  CALL phcdf_write_int(KCDF,'NXVB2',z%NXVB2,1)
  CALL phcdf_write_int(KCDF,'NXVC3',z%NXVC3,1)
  CALL phcdf_write_int(KCDF,'NXVC4',z%NXVC4,1)
  CALL phcdf_write_int(KCDF,'NXVC6',z%NXVC6,1)
  CALL phcdf_write_int(KCDF,'NXVCD',z%NXVCD,1)
  CALL phcdf_write_int(KCDF,'NXVCH',z%NXVCH,1)
  CALL phcdf_write_int(KCDF,'NXVCT',z%NXVCT,1)
  CALL phcdf_write_int(KCDF,'NXVEE',z%NXVEE,1)
  CALL phcdf_write_int(KCDF,'NXVIE',z%NXVIE,1)
  CALL phcdf_write_int(KCDF,'NXVMO',z%NXVMO,1)
  CALL phcdf_write_int(KCDF,'NXVP2',z%NXVP2,1)
  CALL phcdf_write_int(KCDF,'NXVPO',z%NXVPO,1)
  CALL phcdf_write_int(KCDF,'NXVPR',z%NXVPR,1)
  CALL phcdf_write_int(KCDF,'NXVTR',z%NXVTR,1)
  CALL phcdf_write_int(KCDF,'NXZEF2',z%NXZEF2,1)
  CALL phcdf_write_int(KCDF,'NXZF2',z%NXZF2,1)
  CALL phcdf_write_int(KCDF,'NXZXR',z%NXZXR,1)
  CALL phcdf_write_int(KCDF,'NYRP2',z%NYRP2,1)
  CALL phcdf_write_int(KCDF,'NYRPL',z%NYRPL,1)
  CALL phcdf_write_int(KCDF,'NZPSI',z%NZPSI,1)
  CALL phcdf_write_double(KCDF,'DATBUF',z%DATBUF,ILEN)
 
  return
 
end subroutine trdatbuf_wr_cdf
 
!-----------------------------------------
 
subroutine trdatbuf_rd_cdf(kcdf,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  read PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
  include 'netcdf.inc'
 
  integer, intent(in) :: KCDF    ! NetCDF file id
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  integer :: ilen,isizb,j,idum
 
  ! The follow are needed for ezcdf inquiry calls (cdf_inquire)
  character*4 :: xtype
  integer, dimension(3) :: dimlens
  integer :: ier !  error code
 
  !---------------------------------------
!  call phda00(kcdf)
 
  CALL phcdf_read_int(KCDF,'LADR_ZA',z%LADR_ZA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LADR_ZAF',z%LADR_ZAF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPDE',z%LAEPDE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPDP',z%LAEPDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPE',z%LAEPE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPMAP',z%LAEPMAP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPMU',z%LAEPMU,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPP',z%LAEPP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPSP',z%LAEPSP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAEPTS',z%LAEPTS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAIMPS',z%LAIMPS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LAIMPX',z%LAIMPX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATALP',z%LDATALP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATBDI',z%LDATBDI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATCUR',z%LDATCUR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATDFL',z%LDATDFL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATDTG',z%LDATDTG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATDTS',z%LDATDTS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATDTX',z%LDATDTX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATEDI',z%LDATEDI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATEHP',z%LDATEHP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATELI',z%LDATELI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATFGW',z%LDATFGW,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATFIE',z%LDATFIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATFMN',z%LDATFMN,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATFMX',z%LDATFMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGAS',z%LDATGAS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGF3',z%LDATGF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGF4',z%LDATGF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGF6',z%LDATGF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGFD',z%LDATGFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGFH',z%LDATGFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGFT',z%LDATGFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATGIE',z%LDATGIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATHAL',z%LDATHAL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATIBM',z%LDATIBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATIEC',z%LDATIEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATIIC',z%LDATIIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATILH',z%LDATILH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATL2B',z%LDATL2B,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATLAD',z%LDATLAD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATLID',z%LDATLID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATNTX',z%LDATNTX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATOGF',z%LDATOGF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATORC',z%LDATORC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPBE',z%LDATPBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPBI',z%LDATPBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPEB',z%LDATPEB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPEC',z%LDATPEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPF0',z%LDATPF0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPFH',z%LDATPFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPFL',z%LDATPFL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPIB',z%LDATPIB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPIC',z%LDATPIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPLF',z%LDATPLF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPLH',z%LDATPLH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATPOS',z%LDATPOS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRBZ',z%LDATRBZ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRC3',z%LDATRC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRC4',z%LDATRC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRC6',z%LDATRC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRCD',z%LDATRCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRCH',z%LDATRCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRCT',z%LDATRCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRCY',z%LDATRCY,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRMN',z%LDATRMN,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATRTP',z%LDATRTP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSBT',z%LDATSBT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSF3',z%LDATSF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSFA',z%LDATSFA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSFL',z%LDATSFL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSFP',z%LDATSFP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSFT',z%LDATSFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATSP3',z%LDATSP3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTET',z%LDATTET,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTGF',z%LDATTGF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTIT',z%LDATTIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTPI',z%LDATTPI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTQT',z%LDATTQT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTRC',z%LDATTRC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTRF',z%LDATTRF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATTXI',z%LDATTXI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATVPH',z%LDATVPH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATVSB',z%LDATVSB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATVSF',z%LDATVSF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATXKF',z%LDATXKF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATZEF',z%LDATZEF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATZFA',z%LDATZFA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATZIM',z%LDATZIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDATZPL',z%LDATZPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDMDF',z%LDMDF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDMFR',z%LDMFR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDMMX',z%LDMMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDMSE',z%LDMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDPFC',z%LDPFC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LDPFC_PRE',z%LDPFC_PRE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFD0',z%LEFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFDB',z%LEFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFDP',z%LEFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFDQ',z%LEFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFDR',z%LEFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LEFDS',z%LEFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFAEPA',z%LFAEPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFAEPP',z%LFAEPP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFAXR',z%LFAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFBOL',z%LFBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFBPA',z%LFBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFBPB',z%LFBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFD2F',z%LFD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDE2',z%LFDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDF3',z%LFDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDF4',z%LFDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDF6',z%LFDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDFD',z%LFDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDFH',z%LFDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFDFT',z%LFDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFECA',z%LFECA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFECB',z%LFECB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFECF',z%LFECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFD0',z%LFFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFDB',z%LFFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFDP',z%LFFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFDQ',z%LFFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFDR',z%LFFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFDS',z%LFFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFEH',z%LFFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFFEL',z%LFFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFGRB',z%LFGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFIBE',z%LFIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFIBI',z%LFIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFJBM',z%LFJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFJEC',z%LFJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFJIC',z%LFJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLF3',z%LFLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLF4',z%LFLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLF6',z%LFLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLFD',z%LFLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLFH',z%LFLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLFT',z%LFLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLHE',z%LFLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFLHJ',z%LFLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFMSE',z%LFMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNER',z%LFNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNI3',z%LFNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNI4',z%LFNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNI6',z%LFNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNID',z%LFNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNIH',z%LFNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNIM',z%LFNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNIT',z%LFNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFNMR',z%LFNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFOMG',z%LFOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFPRS',z%LFPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFPSI',z%LFPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFQBE',z%LFQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFQBI',z%LFQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFQEC',z%LFQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFQIC',z%LFQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFQPR',z%LFQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFREE',z%LFREE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFRES',z%LFRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFRQRFF',z%LFRQRFF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSBI',z%LFSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSIM',z%LFSIM,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYAXR',z%LFSYAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYBOL',z%LFSYBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYBPA',z%LFSYBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYBPB',z%LFSYBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYD2F',z%LFSYD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDE2',z%LFSYDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDF3',z%LFSYDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDF4',z%LFSYDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDF6',z%LFSYDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDFD',z%LFSYDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDFH',z%LFSYDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYDFT',z%LFSYDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYECF',z%LFSYECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYFEH',z%LFSYFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYFEL',z%LFSYFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYGRB',z%LFSYGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYIBE',z%LFSYIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYIBI',z%LFSYIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYJBM',z%LFSYJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYJEC',z%LFSYJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYJIC',z%LFSYJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLF3',z%LFSYLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLF4',z%LFSYLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLF6',z%LFSYLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLFD',z%LFSYLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLFH',z%LFSYLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLFT',z%LFSYLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLHE',z%LFSYLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYLHJ',z%LFSYLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYMSE',z%LFSYMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNER',z%LFSYNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNI3',z%LFSYNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNI4',z%LFSYNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNI6',z%LFSYNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNID',z%LFSYNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNIH',z%LFSYNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNIM',z%LFSYNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNIT',z%LFSYNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYNMR',z%LFSYNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYOMG',z%LFSYOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYPRS',z%LFSYPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYQBE',z%LFSYQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYQBI',z%LFSYQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYQEC',z%LFSYQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYQIC',z%LFSYQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYQPR',z%LFSYQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYRES',z%LFSYRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYSBI',z%LFSYSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYSIM',z%LFSYSIM,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYTER',z%LFSYTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYTI2',z%LFSYTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYTQI',z%LFSYTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYV2F',z%LFSYV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVB2',z%LFSYVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVC3',z%LFSYVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVC4',z%LFSYVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVC6',z%LFSYVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVCD',z%LFSYVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVCH',z%LFSYVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVCT',z%LFSYVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVEE',z%LFSYVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVIE',z%LFSYVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVMO',z%LFSYVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVP2',z%LFSYVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVPO',z%LFSYVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVPR',z%LFSYVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYVTR',z%LFSYVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYZF2',z%LFSYZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFSYZXR',z%LFSYZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFTER',z%LFTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFTI2',z%LFTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFTQI',z%LFTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFULNB',z%LFULNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFV2F',z%LFV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVB2',z%LFVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVC3',z%LFVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVC4',z%LFVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVC6',z%LFVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVCD',z%LFVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVCH',z%LFVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVCT',z%LFVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVEE',z%LFVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVIE',z%LFVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVMO',z%LFVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVP2',z%LFVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVPO',z%LFVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVPR',z%LFVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFVTR',z%LFVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFZF2',z%LFZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LFZXR',z%LFZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LHLFNB',z%LHLFNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LLIM',z%LLIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LMOMD',z%LMOMD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPELDA',z%LPELDA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPHSLH',z%LPHSLH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPMDF',z%LPMDF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPMSE',z%LPMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPWREC',z%LPWREC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPWRLH',z%LPWRLH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPWRNB',z%LPWRNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LPWRRF',z%LPWRRF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRFS',z%LRFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRMFR',z%LRMFR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRMP_BDY1',z%LRMP_BDY1,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRMP_BDY2',z%LRMP_BDY2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRMSE',z%LRMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRP2',z%LRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRPL',z%LRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LRPSI',z%LRPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSEVENT',z%LSEVENT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYAXR',z%LSSYAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYBOL',z%LSSYBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYBPA',z%LSSYBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYBPB',z%LSSYBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYD2F',z%LSSYD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDE2',z%LSSYDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDF3',z%LSSYDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDF4',z%LSSYDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDF6',z%LSSYDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDFD',z%LSSYDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDFH',z%LSSYDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYDFT',z%LSSYDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYECF',z%LSSYECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYFEH',z%LSSYFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYFEL',z%LSSYFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYGRB',z%LSSYGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYIBE',z%LSSYIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYIBI',z%LSSYIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYJBM',z%LSSYJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYJEC',z%LSSYJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYJIC',z%LSSYJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLF3',z%LSSYLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLF4',z%LSSYLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLF6',z%LSSYLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLFD',z%LSSYLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLFH',z%LSSYLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLFT',z%LSSYLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLHE',z%LSSYLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYLHJ',z%LSSYLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYMSE',z%LSSYMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNER',z%LSSYNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNI3',z%LSSYNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNI4',z%LSSYNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNI6',z%LSSYNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNID',z%LSSYNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNIH',z%LSSYNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNIM',z%LSSYNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNIT',z%LSSYNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYNMR',z%LSSYNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYOMG',z%LSSYOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYPRS',z%LSSYPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYQBE',z%LSSYQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYQBI',z%LSSYQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYQEC',z%LSSYQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYQIC',z%LSSYQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYQPR',z%LSSYQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYRES',z%LSSYRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYSBI',z%LSSYSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYSIM',z%LSSYSIM,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYTER',z%LSSYTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYTI2',z%LSSYTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYTQI',z%LSSYTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYV2F',z%LSSYV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVB2',z%LSSYVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVC3',z%LSSYVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVC4',z%LSSYVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVC6',z%LSSYVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVCD',z%LSSYVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVCH',z%LSSYVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVCT',z%LSSYVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVEE',z%LSSYVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVIE',z%LSSYVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVMO',z%LSSYVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVP2',z%LSSYVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVPO',z%LSSYVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVPR',z%LSSYVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYVTR',z%LSSYVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYZF2',z%LSSYZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LSSYZXR',z%LSSYZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTABORT',z%LTABORT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTAEP',z%LTAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFD0',z%LTFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFDB',z%LTFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFDP',z%LTFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFDQ',z%LTFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFDR',z%LTFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTFDS',z%LTFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTHFS',z%LTHFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIME1',z%LTIME1,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIME2',z%LTIME2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMEC',z%LTIMEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMECA',z%LTIMECA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMECB',z%LTIMECB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMLH',z%LTIMLH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMNB',z%LTIMNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMRF',z%LTIMRF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTIMRFF',z%LTIMRFF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTPSI',z%LTPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LTSAW',z%LTSAW,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LVLTNB',z%LVLTNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXAXR',z%LXAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXBOL',z%LXBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXBPA',z%LXBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXBPB',z%LXBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXD2F',z%LXD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDE2',z%LXDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDF3',z%LXDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDF4',z%LXDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDF6',z%LXDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDFD',z%LXDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDFH',z%LXDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXDFT',z%LXDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXECF',z%LXECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFD0',z%LXFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFDB',z%LXFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFDP',z%LXFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFDQ',z%LXFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFDR',z%LXFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFDS',z%LXFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFEH',z%LXFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFEL',z%LXFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXFS',z%LXFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXGRB',z%LXGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXIBE',z%LXIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXIBI',z%LXIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXJBM',z%LXJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXJEC',z%LXJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXJIC',z%LXJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLF3',z%LXLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLF4',z%LXLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLF6',z%LXLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLFD',z%LXLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLFH',z%LXLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLFT',z%LXLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLHE',z%LXLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXLHJ',z%LXLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXMMX',z%LXMMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXMSE',z%LXMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNER',z%LXNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNI3',z%LXNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNI4',z%LXNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNI6',z%LXNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNID',z%LXNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNIH',z%LXNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNIM',z%LXNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNIT',z%LXNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXNMR',z%LXNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXOMG',z%LXOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXPFC',z%LXPFC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXPRS',z%LXPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXQBE',z%LXQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXQBI',z%LXQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXQEC',z%LXQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXQIC',z%LXQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXQPR',z%LXQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXRES',z%LXRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXRP2',z%LXRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXRPL',z%LXRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSBI',z%LXSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSIM',z%LXSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYAXR',z%LXSYAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYBOL',z%LXSYBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYBPA',z%LXSYBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYBPB',z%LXSYBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYD2F',z%LXSYD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDE2',z%LXSYDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDF3',z%LXSYDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDF4',z%LXSYDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDF6',z%LXSYDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDFD',z%LXSYDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDFH',z%LXSYDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYDFT',z%LXSYDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYECF',z%LXSYECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYFEH',z%LXSYFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYFEL',z%LXSYFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYGRB',z%LXSYGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYIBE',z%LXSYIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYIBI',z%LXSYIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYJBM',z%LXSYJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYJEC',z%LXSYJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYJIC',z%LXSYJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLF3',z%LXSYLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLF4',z%LXSYLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLF6',z%LXSYLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLFD',z%LXSYLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLFH',z%LXSYLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLFT',z%LXSYLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLHE',z%LXSYLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYLHJ',z%LXSYLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYMSE',z%LXSYMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNER',z%LXSYNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNI3',z%LXSYNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNI4',z%LXSYNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNI6',z%LXSYNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNID',z%LXSYNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNIH',z%LXSYNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNIM',z%LXSYNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNIT',z%LXSYNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYNMR',z%LXSYNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYOMG',z%LXSYOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYPRS',z%LXSYPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYQBE',z%LXSYQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYQBI',z%LXSYQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYQEC',z%LXSYQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYQIC',z%LXSYQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYQPR',z%LXSYQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYRES',z%LXSYRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYSBI',z%LXSYSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYSIM',z%LXSYSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYTER',z%LXSYTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYTI2',z%LXSYTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYTQI',z%LXSYTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYV2F',z%LXSYV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVB2',z%LXSYVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVC3',z%LXSYVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVC4',z%LXSYVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVC6',z%LXSYVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVCD',z%LXSYVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVCH',z%LXSYVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVCT',z%LXSYVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVEE',z%LXSYVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVIE',z%LXSYVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVMO',z%LXSYVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVP2',z%LXSYVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVPO',z%LXSYVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVPR',z%LXSYVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYVTR',z%LXSYVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYZF2',z%LXSYZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXSYZXR',z%LXSYZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXTER',z%LXTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXTI2',z%LXTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXTQI',z%LXTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXV2F',z%LXV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVB2',z%LXVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVC3',z%LXVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVC4',z%LXVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVC6',z%LXVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVCD',z%LXVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVCH',z%LXVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVCT',z%LXVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVEE',z%LXVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVIE',z%LXVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVMO',z%LXVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVP2',z%LXVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVPO',z%LXVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVPR',z%LXVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXVTR',z%LXVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXZF2',z%LXZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXZIMPS',z%LXZIMPS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXZIMPX',z%LXZIMPX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXZIMPXS',z%LXZIMPXS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LXZXR',z%LXZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LYRP2',z%LYRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LYRPL',z%LYRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LYSIM',z%LYSIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LZFS',z%LZFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'LZPSI',z%LZPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'MMAX',z%MMAX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'MMX_MAXE',z%MMX_MAXE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'MTRP2',z%MTRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'MTRPL',z%MTRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NANTECH_D',z%NANTECH_D,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NANTICH_D',z%NANTICH_D,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NANTLH_D',z%NANTLH_D,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NBDATA',z%NBDATA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDEAEP',z%NDEAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDFS',z%NDFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDMDF',z%NDMDF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDMFR',z%NDMFR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDMMX',z%NDMMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDMSE',z%NDMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDPAEP',z%NDPAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDPFC',z%NDPFC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NDPFC_PRE',z%NDPFC_PRE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEAEP',z%NEAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFD0',z%NEFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFDB',z%NEFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFDP',z%NEFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFDQ',z%NEFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFDR',z%NEFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NEFDS',z%NEFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NFRBCODE',z%NFRBCODE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NFRBMODE',z%NFRBMODE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NGMAX_D',z%NGMAX_D,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NHECFT',z%NHECFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NHFMX',z%NHFMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NIMDF',z%NIMDF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NISSIM',z%NISSIM,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NISX',z%NISX,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NITSIM',z%NITSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NITX',z%NITX,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NKAEP',z%NKAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NLIM',z%NLIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMAPSIM',z%NMAPSIM,300,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMDXKF',z%NMDXKF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMIMP',z%NMIMP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMOMD',z%NMOMD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMUAEP',z%NMUAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NMZEFF',z%NMZEFF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NNSIM',z%NNSIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NPACK',z%NPACK,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NPAEP',z%NPAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NPELDA',z%NPELDA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NPMDF',z%NPMDF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NPMSE',z%NPMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRHIS',z%NRHIS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRHIX',z%NRHIX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIAXR',z%NRIAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIBOL',z%NRIBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIBPA',z%NRIBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIBPB',z%NRIBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRID2F',z%NRID2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDE2',z%NRIDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDF3',z%NRIDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDF4',z%NRIDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDF6',z%NRIDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDFD',z%NRIDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDFH',z%NRIDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIDFT',z%NRIDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIECF',z%NRIECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFD0',z%NRIFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFDB',z%NRIFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFDP',z%NRIFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFDQ',z%NRIFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFDR',z%NRIFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFDS',z%NRIFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFEH',z%NRIFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIFEL',z%NRIFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIGRB',z%NRIGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIIBE',z%NRIIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIIBI',z%NRIIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIJBM',z%NRIJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIJEC',z%NRIJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIJIC',z%NRIJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILF3',z%NRILF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILF4',z%NRILF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILF6',z%NRILF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILFD',z%NRILFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILFH',z%NRILFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILFT',z%NRILFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILHE',z%NRILHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRILHJ',z%NRILHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIMSE',z%NRIMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINER',z%NRINER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINI3',z%NRINI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINI4',z%NRINI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINI6',z%NRINI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINID',z%NRINID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINIH',z%NRINIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINIM',z%NRINIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINIT',z%NRINIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRINMR',z%NRINMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIOMG',z%NRIOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIPRS',z%NRIPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIQBE',z%NRIQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIQBI',z%NRIQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIQEC',z%NRIQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIQIC',z%NRIQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIQPR',z%NRIQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIRES',z%NRIRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRISBI',z%NRISBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRISIM',z%NRISIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRITER',z%NRITER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRITI2',z%NRITI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRITQI',z%NRITQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIV2F',z%NRIV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVB2',z%NRIVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVC3',z%NRIVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVC4',z%NRIVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVC6',z%NRIVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVCD',z%NRIVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVCH',z%NRIVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVCT',z%NRIVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVEE',z%NRIVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVIE',z%NRIVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVMO',z%NRIVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVP2',z%NRIVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVPO',z%NRIVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVPR',z%NRIVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIVTR',z%NRIVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIZF2',z%NRIZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRIZXR',z%NRIZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRMFR',z%NRMFR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRMSE',z%NRMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRP2',z%NRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRPL',z%NRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NRPSI',z%NRPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSAWFLAG',z%NSAWFLAG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSC',z%NSC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSC_FMT',z%NSC_FMT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSEVENT',z%NSEVENT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSEVPER',z%NSEVPER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSEVTBL',z%NSEVTBL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSEVWDS',z%NSEVWDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSFAST_D',z%NSFAST_D,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYAXR',z%NSYAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYBOL',z%NSYBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYBPA',z%NSYBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYBPB',z%NSYBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYD2F',z%NSYD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDE2',z%NSYDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDF3',z%NSYDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDF4',z%NSYDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDF6',z%NSYDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDFD',z%NSYDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDFH',z%NSYDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYDFT',z%NSYDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYECF',z%NSYECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYFEH',z%NSYFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYFEL',z%NSYFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYGRB',z%NSYGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYIBE',z%NSYIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYIBI',z%NSYIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYJBM',z%NSYJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYJEC',z%NSYJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYJIC',z%NSYJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLF3',z%NSYLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLF4',z%NSYLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLF6',z%NSYLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLFD',z%NSYLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLFH',z%NSYLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLFT',z%NSYLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLHE',z%NSYLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYLHJ',z%NSYLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYMSE',z%NSYMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNER',z%NSYNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNI3',z%NSYNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNI4',z%NSYNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNI6',z%NSYNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNID',z%NSYNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNIH',z%NSYNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNIM',z%NSYNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNIT',z%NSYNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYNMR',z%NSYNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYOMG',z%NSYOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYPRS',z%NSYPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYQBE',z%NSYQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYQBI',z%NSYQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYQEC',z%NSYQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYQIC',z%NSYQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYQPR',z%NSYQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYRES',z%NSYRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYSBI',z%NSYSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYSIM',z%NSYSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYTER',z%NSYTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYTI2',z%NSYTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYTQI',z%NSYTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYV2F',z%NSYV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVB2',z%NSYVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVC3',z%NSYVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVC4',z%NSYVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVC6',z%NSYVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVCD',z%NSYVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVCH',z%NSYVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVCT',z%NSYVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVEE',z%NSYVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVIE',z%NSYVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVMO',z%NSYVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVP2',z%NSYVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVPO',z%NSYVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVPR',z%NSYVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYVTR',z%NSYVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYZF2',z%NSYZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NSYZXR',z%NSYZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTABORT',z%NTABORT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTAEP',z%NTAEP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFD0',z%NTFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFDB',z%NTFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFDP',z%NTFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFDQ',z%NTFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFDR',z%NTFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTFDS',z%NTFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTHFS',z%NTHFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIME1',z%NTIME1,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIME2',z%NTIME2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMEC',z%NTIMEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMECA',z%NTIMECA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMECB',z%NTIMECB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMLH',z%NTIMLH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMNB',z%NTIMNB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMRF',z%NTIMRF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTIMRFF',z%NTIMRFF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTPSI',z%NTPSI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NTSAW',z%NTSAW,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXAXR',z%NXAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXBOL',z%NXBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXBPA',z%NXBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXBPB',z%NXBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXD2F',z%NXD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDE2',z%NXDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDF3',z%NXDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDF4',z%NXDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDF6',z%NXDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDFD',z%NXDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDFH',z%NXDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXDFT',z%NXDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXECF',z%NXECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFD0',z%NXFD0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFDB',z%NXFDB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFDP',z%NXFDP,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFDQ',z%NXFDQ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFDR',z%NXFDR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFDS',z%NXFDS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFEH',z%NXFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFEL',z%NXFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXFS',z%NXFS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXGRB',z%NXGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXIBE',z%NXIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXIBI',z%NXIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXJBM',z%NXJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXJEC',z%NXJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXJIC',z%NXJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLF3',z%NXLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLF4',z%NXLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLF6',z%NXLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLFD',z%NXLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLFH',z%NXLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLFT',z%NXLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLHE',z%NXLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXLHJ',z%NXLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXMMX',z%NXMMX,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXMSE',z%NXMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNE0',z%NXNE0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNER',z%NXNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNI3',z%NXNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNI4',z%NXNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNI6',z%NXNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNID',z%NXNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNIH',z%NXNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNIM',z%NXNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNIT',z%NXNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNM0',z%NXNM0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXNMR',z%NXNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXOMG',z%NXOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXPFC',z%NXPFC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXPRS',z%NXPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXQBE',z%NXQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXQBI',z%NXQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXQEC',z%NXQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXQIC',z%NXQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXQPR',z%NXQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXRES',z%NXRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXRP2',z%NXRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXRPL',z%NXRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSBI',z%NXSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSIM',z%NXSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYAXR',z%NXSYAXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYBOL',z%NXSYBOL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYBPA',z%NXSYBPA,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYBPB',z%NXSYBPB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYD2F',z%NXSYD2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDE2',z%NXSYDE2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDF3',z%NXSYDF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDF4',z%NXSYDF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDF6',z%NXSYDF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDFD',z%NXSYDFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDFH',z%NXSYDFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYDFT',z%NXSYDFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYECF',z%NXSYECF,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYFEH',z%NXSYFEH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYFEL',z%NXSYFEL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYGRB',z%NXSYGRB,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYIBE',z%NXSYIBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYIBI',z%NXSYIBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYJBM',z%NXSYJBM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYJEC',z%NXSYJEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYJIC',z%NXSYJIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLF3',z%NXSYLF3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLF4',z%NXSYLF4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLF6',z%NXSYLF6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLFD',z%NXSYLFD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLFH',z%NXSYLFH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLFT',z%NXSYLFT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLHE',z%NXSYLHE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYLHJ',z%NXSYLHJ,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYMSE',z%NXSYMSE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNER',z%NXSYNER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNI3',z%NXSYNI3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNI4',z%NXSYNI4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNI6',z%NXSYNI6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNID',z%NXSYNID,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNIH',z%NXSYNIH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNIM',z%NXSYNIM,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNIT',z%NXSYNIT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYNMR',z%NXSYNMR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYOMG',z%NXSYOMG,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYPRS',z%NXSYPRS,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYQBE',z%NXSYQBE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYQBI',z%NXSYQBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYQEC',z%NXSYQEC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYQIC',z%NXSYQIC,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYQPR',z%NXSYQPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYRES',z%NXSYRES,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYSBI',z%NXSYSBI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYSIM',z%NXSYSIM,8,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYTER',z%NXSYTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYTI2',z%NXSYTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYTQI',z%NXSYTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYV2F',z%NXSYV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVB2',z%NXSYVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVC3',z%NXSYVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVC4',z%NXSYVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVC6',z%NXSYVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVCD',z%NXSYVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVCH',z%NXSYVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVCT',z%NXSYVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVEE',z%NXSYVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVIE',z%NXSYVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVMO',z%NXSYVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVP2',z%NXSYVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVPO',z%NXSYVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVPR',z%NXSYVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYVTR',z%NXSYVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYZF2',z%NXSYZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXSYZXR',z%NXSYZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXTE0',z%NXTE0,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXTER',z%NXTER,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXTI2',z%NXTI2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXTQI',z%NXTQI,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXV2F',z%NXV2F,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVB2',z%NXVB2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVC3',z%NXVC3,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVC4',z%NXVC4,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVC6',z%NXVC6,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVCD',z%NXVCD,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVCH',z%NXVCH,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVCT',z%NXVCT,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVEE',z%NXVEE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVIE',z%NXVIE,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVMO',z%NXVMO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVP2',z%NXVP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVPO',z%NXVPO,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVPR',z%NXVPR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXVTR',z%NXVTR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXZEF2',z%NXZEF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXZF2',z%NXZF2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NXZXR',z%NXZXR,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NYRP2',z%NYRP2,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NYRPL',z%NYRPL,1,KERR)
  if(KERR.eq.2) return
  CALL phcdf_read_int(KCDF,'NZPSI',z%NZPSI,1,KERR)
  if(KERR.eq.2) return
 
  ilen = z%lfree-1
  call datbuf_expand(z,ilen,isizb)
  CALL phcdf_read_double(KCDF,'DATBUF',z%DATBUF,ILEN,KERR)
 
  return
 
end subroutine trdatbuf_rd_cdf
 
!-----------------------------------------
 
subroutine trdatbuf_write(kcdf,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  write PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
 
  integer, intent(in) :: KCDF    ! NetCDF file id
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  !-------------------------
 
  call trdatbuf_def_cdf(kcdf,z,kerr)
  if(kerr.ne.0) return
 
  call trdatbuf_wr_cdf(kcdf,z,kerr)
 
end subroutine trdatbuf_write
subroutine trdatbuf_read(kcdf,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  read PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
 
  integer, intent(in) :: KCDF    ! NetCDF file id -- file open for read
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  !---------------------------------------
  call trdatbuf_rd_cdf(kcdf,z,kerr)
 
end subroutine trdatbuf_read
 
!-----------------------------------------
subroutine trdatbuf_wk_write(klun,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  write PH.TMP ascii file (legacy TRANSP format)
  !
  !  file contains contents of trdatbuf compound data type "z" workspace...
 
  use trdatbuf_obj
  implicit NONE
 
  integer, intent(in) :: KLUN    ! fortran LUN
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  integer :: ilen,j
  integer :: idum = 0
 
  !-------------------------
  call phda00(klun)
  kerr = 0
 
  ilen = z%lfree_w - 1
  ilen = max(1,ilen)
 
  CALL PHDAWR(KLUN,'LBX',z%LBX,8)
  CALL PHDAWR(KLUN,'LFREE_W',z%LFREE_W,1)
  CALL PHDAWR(KLUN,'NBX',z%NBX,8)
  CALL PHDAWR(KLUN,'ZZZ-END-OF-HEADR',IDUM,1)
  WRITE(KLUN,1002) (z%WORKBUF(j),j=1,ILEN)
 
  return
 
1002 format(3(1PD23.16))
 
end subroutine trdatbuf_wk_write
 
!-----------------------------------------
 
subroutine trdatbuf_wk_read(klun,z,kerr)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  !  read PH.CDF ascii file (legacy TRANSP format)
  !  (plan to replace with NetCDF file eventually)
  !
  !  file contains contents of trdatbuf compound data type "z"
 
  use trdatbuf_obj
  implicit NONE
 
  integer, intent(in) :: KLUN    ! fortran LUN
  type (trdatbuf) :: z
  integer, intent(out) :: KERR   ! completion code, 0=OK
 
  integer :: ilen,isizb,j,idum
 
  !---------------------------------------
  call phda00(klun)
 
  CALL PHDARD(KLUN,'LBX',z%LBX,8,KERR)
  if(KERR.ne.0) return
  CALL PHDARD(KLUN,'LFREE_W',z%LFREE_W,1,KERR)
  if(KERR.ne.0) return
  CALL PHDARD(KLUN,'NBX',z%NBX,8,KERR)
  if(KERR.ne.0) return
  CALL PHDARD(KLUN,'ZZZ-END-OF-HEADR',IDUM,1,KERR)
  if(KERR.ne.0) return
 
  ilen = z%lfree_w-1
  ilen = max(1,ilen)
  call datbuf_expand(z,ilen,isizb)
  READ(KLUN,1002,iostat=kerr) (z%WORKBUF(j),j=1,ILEN)
 
  return
 
1002 format(3(1PD23.16))
 
end subroutine trdatbuf_wk_read

C******************** START FILE SPLITN.FOR ; GROUP SPLITN *************
C
      INTEGER FUNCTION SPLITN(zpath,zfile,ICRUN)
C
      use splitn_module
C
      implicit NONE
C
C  READS A NAMELIST DATA FILE AND SPLITS THE VARIABLES
C
C  modified WIE 09 Apr 1997 -- add in EFITIN namelist --
C    pass it thru to <runid>TR.EFITIN .. cf ADDNL
C
C  modified DMC 16 Nov 1994 -- directory path argument zpath added
C    this argument specifies the source directory for the tr.dat
C    file; if blank, the current working directory is assumed.
C    if non-blank, the argument should be left justified in the
C    passed character string with only trailing blanks allowed.
C    Full punctuation appropriate to the current OS should be
C    supplied (e.g. include trailing "/" if this is unix).
C
C  ALSO DROPS COMMENTS
C  FIRST DRAFT BY M. THOMPSON, EXPANDED BY D. MC CUNE
C
C  redone dmc Dec 2002 -- partitioning of namelist driven from
C  "nxlist.summary" file...
C
C
C  ***return value***  SPLITN=1 -- successful!
C                             anything else: error
C
C--------------------------------------------------------------------
C
      character*(*) zpath  ! optional path (directory) for namelist
      character*(*) zfile  ! optional filename for namelist
      CHARACTER*(*) ICRUN  ! namelist run-id
C
C--------------------------------------------------------------------
C
      CHARACTER FNAMI*128  ! input filename (generic TRANSP namelist)
      CHARACTER FNAMO*20   ! output filename (fortran readable namelist)
C
C---------------------------------------------------
      integer i,inb,inc,imds,ios
C
C  some for debugging...
C
      integer j,k,il,inum,ia,ilinp,ilinq,iadr
C
C---------------------------------------------------
C
      imds = 1
C
      inc=index(ICRUN,' ')-1
      if(inc.lt.0) inc=len(ICRUN)
C
      if(zpath.eq.' ') then
         if(zfile.eq.' ') then
C try MDSplus extracted file first
            imds = 2
            FNAMI=ICRUN(1:INC)//'TR.DAT_MDS'
         else
            FNAMI=zfile
         endif
      else
         inb=index(zpath,' ')-1
         if(inb.lt.0) inb=len(zpath)
         if(zfile.eq.' ') then
            FNAMI=zpath(1:inb)//ICRUN(1:INC)//'TR.DAT'
         else
            FNAMI=zpath(1:inb)//zfile
         endif
      endif
C
      FNAMO=ICRUN(1:INC)//'TR.ZDA'
C
      i=1
      SPLITN=0
      do while (i .le. imds .and. splitn .eq. 0)
C
C  SPLITN namelist read: quiet operation:
         call read_nl(fnami,ios, quiet=.TRUE.)
C
         IF(IOS.EQ.0) THEN
            SPLITN=1
         else if (imds .eq. 2 .and. i .eq. 1) then
C try regular namelist
            FNAMI=ICRUN(1:INC)//'TR.DAT'
         else
            RETURN              ! TR.DAT NAMELIST FILE NOT OPENED.
         ENDIF
         i=i+1
      end do
C
C  make sure no old TR.ZDA files are left around.
C
      open(unit=lun,file=fnamo,status='old',iostat=ios)
      if(ios.eq.0) then
                                        ! delete the file
         close(unit=lun)
         call fdelete(fnamo,ios)
      endif
C
C  write fortran readable namelists (TR.ZDA file).
C
      if(splitn.eq.1) then
         call splitn_f77(fnamo,ios)
         if(ios.ne.0) splitn=0
      endif
C
#ifdef __DEBUG
      do i=1,nvars
         j=var_order(i)
         write(6,*) '--------------------------------'
         write(6,*) ' name: ',varlist(j)%name
         write(6,*) ' type: ',varlist(j)%type,
     >      ' ... chsize = ',varlist(j)%chsize
         write(6,*) ' belonging to: ',varlist(j)%naml
         write(6,*) ' rank: ',varlist(j)%rank
         inum=1
         do k=1,varlist(j)%rank
            write(6,*) '    dim. ',k,':  (',varlist(j)%dims(1,k),':',
     >         varlist(j)%dims(2,k),')'
            inum=inum*(varlist(j)%dims(2,k)-varlist(j)%dims(1,k)+1)
         enddo
         write(6,*) '    size: ',inum
         if(varlist(j)%short_dflt.ne.' ') then
            write(6,*) ' short default string: ',
     >         varlist(j)%short_dflt
         endif
         k=varlist(j)%long_dflt_addr
         if(k.gt.0) then
            il=len_trim(long_dflts(k))
            write(6,*) ' long default string: ',long_dflts(k)(1:il)
         endif
         write(6,*) ' ======='
         ia=varlist(j)%nlinadr
         ilinp=0
         do k=ia,ia+inum-1
            if(ilines(k).ne.0) then
               if(ilines(k).ne.ilinp) then
                  ilinp=ilines(k)
                  ilinq=ordl(ilinp)
                  il=len_trim(textnl(ilinq))
                  write(6,*) '   file: ',textnl(ilinq)(1:il)
               endif
            endif
         enddo
         write(6,*) ' ======='
         write(6,*) ' values:'
         do k=1,inum
            iadr=varlist(j)%addr + k - 1
            if(varlist(j)%type(1:1).eq.'C') then
               il=len_trim(chbuf(iadr))
               write(6,*) '    ',chbuf(iadr)(1:il)
            else if(varlist(j)%type.eq.'R') then
               write(6,*) '    ',rbuf(iadr)
            else if(varlist(j)%type.eq.'I') then
               write(6,*) '    ',intbuf(iadr)
            else if(varlist(j)%type.eq.'L') then
               write(6,*) '    ',logbuf(iadr)
            else if(varlist(j)%type.eq.'D') then
               write(6,*) '    ',dbuf(iadr)
            endif
         enddo
      enddo
#endif
C     
      return
      end

C******************** START FILE MOMIND3.FOR ; GROUP MOMIND3 *************
C---------------------------------------------------------------------
C  MOMIND3
C   GIVEN THE TIME INDEX RETURN THE INDICES TO: THE 0TH R MOMENT
C     AND THE 0th  Y MOMENT OF THE BDY MOMENTS
C     FOURIER EXPANSION.
 
 
      SUBROUTINE MOMIND3(d, IT,IR1,IR2,IY1,IY2)
 
 
C   (BACKGROUND)
C     THE PLASMA BDY IS REPRESENTED AS A FOURIER MOMENTS EXPANSION
C   THE TIME DEPENDENT MOMENTS ARE READ BY TRDAT IN 1 3-D UFILE ".MRY" (OR
C   TIME INDEPENDENT BDY MOMENTS SPECIFIED BY NAMELIST).
C     THIS DATA IS INTERPOLATED TO A FIXED TIME GRID COVERING THE
C   ACTUAL TIME OF EXPERIMENT TO BE ANALYZED BY TRANSP.  THE
C   INTERPOLATED DATA IS STORED IN TRANSP COMMON ARRAY DATBUF.
C   TRDAT WRITES OUT AN IMAGE OF THE COMMON BLOCK CONTAINING DATBUF
C   WHICH IS READ BY TRANSP TO MAKE AN ACTUAL RUN
C
C     THIS ROUTINE HELPS LOOK UP THE INTERPOLATED MOMENTS DATA.
C      03/25/94 tbt Made from MOMIND
 
      use trdatbuf_obj
      IMPLICIT NONE
      type (trdatbuf) :: d
C
C  PASSED INPUT-- IT= DESIRED TIME INDEX
C  COMMON INPUT:
C   DATBUF  DATA BUFFER
C     MOMENTS DATA STORED TIME CONTIGUOUS, I.E.
C     0TH MOMENT AT ALL TIMES, THEN 1ST MOMENT AT ALL TIME, ETC.
C   NMOMD  NUMBER OF MOMENTS STORED IN DATBUF
C   NTIME2  NUMBER OF TIME PTS FOR MOMENTS AND 2D DATA IN DATBUF
C   LMOMD  ADDRESS OF FIRST WORD OF MOMENTS DATA IN DATBUF
C
C  PASSED OUTPUT
 
C   IR1    ADDRESS OF 0th R MOMENT
C          (IR1+1 ADDRESS TO 1st R MOMENT, ...)
C   IY1    ADDRESS OF 0th Y MOMENT
C          (IY1+1 ADDRESS TO 1st Y MOMENT, ...)
C
C---------------------------------
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ir1,ir2,iy1,iy2,it,itm1
!============
      ITM1=IT-1
C
      IR1=D%LMOMD+ITM1
      IR2=IR1+D%NTIME2*(D%NMOMD+1)
      IY1=IR1+(D%NMOMD+1)*D%NTIME2*2
      IY2=IR1+(D%NMOMD+1)*D%NTIME2*3
C
      RETURN
      END
C******************** END FILE MOMIND3.FOR ; GROUP MOMIND3 ***************
! 19jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

C----------------------------------------------------------------------
C  COPY_GENNML_SUB -- SUBROUTINE to copy Genray template namelist 
C
C  calling arguments only, trcom & TRDATA not used...
C
      SUBROUTINE COPY_GENNML_SUB(ctok,runid,genray_ech_template, 
     >        kmdsplus,mds_server,mds_tree,
     >        ztarget,
     >        nonlin,ier)

      use execsystem 
      IMPLICIT NONE

C-----------------------------------------------------------------------
C  subroutine arguments:
      
      character*(*), intent(in) :: ctok   ! tokamak ID
      character*(*), intent(in) :: runid  ! TRANSP run ID
      character*(*), intent(in) :: genray_ech_template  ! template name

      integer, intent(inout) :: kmdsplus  ! flag, =1 or 2 for MDS+ access
      !  if =2, assume MDS+ tree is open;
      !    RETURNED VALUE is set to 0 if MDSplus access failed.

      character*(*), intent(in) :: mds_server  ! MDS+ server
      character*(*), intent(in) :: mds_tree    ! MDS+ tree name

      character*(*), intent(in) :: ztarget   ! where to copy the file

      integer, intent(in) :: nonlin       ! I/O unit for messages

      integer, intent(out) :: ier ! status return code, 0=OK
      
      character*17 :: subr = 'COPY_GENNML_SUB: '
!
! MDSplus Fortran interface
!
      integer Mds_Value,idescr_long,idescr_cstringarr,idescr_cstring
      integer isize,status,idims(2)

!  buffer for text

      integer :: iline,inlines
      character*150, dimension(:), allocatable :: nltext

C-----------------------------------------------------------------------
C  local:

      INTEGER istat,iltok,ilnurd,ilun

      character*150 zval1,zval2
      character*200 ztmppath,ztag,zprefix
      character*300 zgentmplfile,zcmd
      character*3   zcp

C-----------------------------------------------------------------------
C
      ier=0
C
C----------

      zcp='cp'

      ILTOK=ILNURD(CTOK)

C  Set the default template namelist

      zval1=' '
      zval2=' '
      call sget_env('LOCAL',zval1)
      call sget_env('TRANSP_LOCATION',zval2)

      if(zval1.ne.' ') then
         zprefix = '$LOCAL/tables'
      else if(zval2.ne.' ') then
         zprefix = '$TRANSP_LOCATION'
      else
         zprefix = 'unknown'
      endif

      zgentmplfile=trim(zprefix)//'/rf_nml/'
     >          //'GENRAY_ECH_STANDARD.IN'

C  Get the namelist input template filename

      ztmppath=trim(adjustl(GENRAY_ECH_TEMPLATE))

! check if mdsplus 

      kmdsplus = max(0,min(2,kmdsplus))

      if(kmdsplus.eq.2) then
         write(nonlin,*) 
     >        ' copy_gennml_sub: try direct read on MDS+ server...'
         status = Mds_Value('size(.NML:GENRAY_ECH)',
     >        idescr_long(inlines),isize)
         if (mod(status,2).ne.1) then
            call mdserr(nonlin, 
     >           'Mds_Value(''size(.NML:GENRAY_ECH)'',..)', status)
            write(nonlin,*) ' %GENRAY template not found in MDS+...'
            kmdsplus = 0
         else if(inlines.le.0) then
            write(nonlin,*) ' %GENRAY template length is zero in MDS+'
            kmdsplus = 0
         else
            allocate(nltext(inlines)); nltext = ' '
            idims(1)=inlines
            idims(2)=0

            status = Mds_Value('.NML:GENRAY_ECH',
     >           idescr_cstringarr(NLTEXT,idims,1),isize)
            if (mod(status,2).ne.1) then
               call mdserr(nonlin, 
     >              'Mds_Value(''.NML:GENRAY_ECH'',..)', status)
               write(nonlin,*) ' %GENRAY template read error in MDS+...'
               kmdsplus = 0
            else
               ! OK...
               call find_io_unit(ilun)
               open(unit=ilun,file=ztarget,status='unknown')
               do iline=1,inlines
                  write(ilun,'(A)') trim(nltext(iline))
               enddo
               close(unit=ilun)
               deallocate(nltext)
               RETURN  ! all done
            endif
            deallocate(nltext)
         endif
      endif

      if(kmdsplus.eq.1) then
         write(nonlin,*) ' copy_gennml_sub: template fetch via '//
     >        '"mds_get_inf" subprocess...'
         zcmd='mds_get_inf s '//trim(MDS_SERVER)//
     >        ' t '//trim(MDS_TREE)//
     >        ' r '//trim(runid)//
     >        ' l .NML:GENRAY_ECH q'
         write(nonlin,*) subr//trim(zcmd)
         istat=jsystem(trim(zcmd))
         if (istat .ne. 0) then
            write(nonlin,*) subr,
     >           ' failed to extract .NML:GENRAY_ECH'
            write(nonlin,*) '   (now look for template file).'
            kmdsplus=0
         else
            zgentmplfile=trim(runid)//'..NML:GENRAY_ECH'
            zcp='mv '
         endif
      endif

      if(kmdsplus.eq.0) then
         write(nonlin,*) subr,'namelist: GENRAY_ECH_TEMPLATE= "',
     >        trim(ztmppath),'"'
         IF(ztmppath.NE.' ') then
            IF((ztmppath(1:1).NE.'~').AND.(ztmppath(1:1).NE.'/').AND.
     >           (ztmppath(1:1).NE.'.')) then
               write(nonlin,*) subr//' file tag: '//trim(ztmppath)
               ztag=ztmppath
               call uupper(ztag)
               zgentmplfile=trim(zprefix)//'/rf_nml/'
     >              //'GENRAY_ECH_'//trim(adjustl(ztag))
     >              //'.IN'
            ELSE
               zgentmplfile=ztmppath
            ENDIF
         ELSE 
!     default template file
            write(nonlin,*) subr//
     >           'GENRAY_ECH_TEMPLATE is blank; Default used'
         ENDIF 
      endif

      write(nonlin,*) subr//'Genray template file= '
      write(nonlin,*) '    '//trim(zgentmplfile)

      zcmd=zcp//trim(adjustl(zgentmplfile))//' '
     >     //trim(adjustl(ztarget))
      write(nonlin,*) subr//'zcmd= ',trim(zcmd)

      istat=jsystem(trim(zcmd)) 
      ier=abs(istat)
      write(nonlin,*) subr//' file copy status (0 is normal): ',ier

      RETURN
      END

subroutine splitn_rdcod(word,rbuf,num,ier)

  ! REAL decode of character string

  implicit NONE

  character*(*), intent(in) :: word   ! string to decode: no leading or
  !                                   ! trailing blanks

  integer, intent(in) :: num          ! no. of copies to store (repeat count)
  real, intent(out) :: rbuf(num)      ! where to store results

  integer, intent(out) :: ier         ! completion code (0=OK)

  !------------------------------------------
  ! if an error occurs, rbuf is not modified and a message
  ! is written on unit 6.
  ! a DECIMAL POINT must be contained in the input string.
  !------------------------------------------

  integer ildp,ilen

  character*30 jbuf

  real zval

  !------------------------------------------

  ier=0
  ildp = index(word,'.')
  if(ildp.le.0) then
     write(6,*) ' ?splitn_dcod: no decimal point in floating point number: "',&
          word,'"'
     ier=2
     return
  endif

  ilen=len(word)
  if(ilen.gt.30) then
     write(6,*) ' ?splitn_dcod: floating point number too long: ',word
     ier=3
     return
  endif

  jbuf=' '
  jbuf(30-ilen+1:30)=word
  call uupper(jbuf)
  if(jbuf(28:30).eq.'_R8') then
     read(jbuf(1:27),'(G27.0)',iostat=ier) zval
  else
     read(jbuf,'(G30.0)',iostat=ier) zval
  endif

  if(ier.ne.0) then
     write(6,*) ' ?splitn_dcod: error decoding as floating point: "', &
          word,'"'
     ier=1
     return
  endif

  ! OK

  rbuf(1:num)=zval

end subroutine splitn_rdcod

subroutine splitn_ddcod(word,dbuf,num,ier)

  ! REAL*8 decode of character string

  implicit NONE

  character*(*), intent(in) :: word   ! string to decode: no leading or
  !                                   ! trailing blanks

  integer, intent(in) :: num          ! no. of copies to store (repeat count)
  real*8, intent(out) :: dbuf(num)    ! where to store results

  integer, intent(out) :: ier         ! completion code (0=OK)

  !------------------------------------------
  ! if an error occurs, dbuf is not modified and a message
  ! is written on unit 6.
  ! a DECIMAL POINT must be contained in the input string.
  !------------------------------------------

  integer ildp,ilen

  character*30 jbuf

  real*8 zval

  !------------------------------------------

  ier=0
  ildp = index(word,'.')
  if(ildp.le.0) then
     write(6,*) ' ?splitn_dcod: no decimal point in floating point number: "',&
          word,'"'
     ier=2
     return
  endif

  ilen=len(word)
  if(ilen.gt.30) then
     write(6,*) ' ?splitn_dcod: floating point number too long: ',word
     ier=3
     return
  endif

  jbuf=' '
  jbuf(30-ilen+1:30)=word
  call uupper(jbuf)
  if(jbuf(28:30).eq.'_R8') then
     read(jbuf(1:27),'(G27.0)',iostat=ier) zval
  else
     read(jbuf,'(G30.0)',iostat=ier) zval
  endif

  if(ier.ne.0) then
     write(6,*) ' ?splitn_dcod: error decoding as floating point: "', &
          word,'"'
     ier=1
     return
  endif

  ! OK

  dbuf(1:num)=zval

end subroutine splitn_ddcod

subroutine splitn_idcod(word,ibuf,num,ier)

  ! INTEGER decode of character string

  implicit NONE

  character*(*), intent(in) :: word   ! string to decode: no leading or
  !                                   ! trailing blanks

  integer, intent(in) :: num          ! no. of copies to store (repeat count)
  integer, intent(out) :: ibuf(num)   ! where to store results

  integer, intent(out) :: ier         ! completion code (0=OK)

  !------------------------------------------
  ! if an error occurs, ibuf is not modified and a message
  ! is written on unit 6.
  !------------------------------------------

  integer ilen

  character*30 jbuf

  integer ival

  !------------------------------------------

  ier=0
  ilen=len(word)
  if(ilen.gt.30) then
     write(6,*) ' ?splitn_dcod: integer too long: ',word
     ier=3
     return
  endif

  jbuf=' '
  jbuf(30-ilen+1:30)=word
  read(jbuf,'(I30)',iostat=ier) ival

  if(ier.ne.0) then
     write(6,*) ' ?splitn_dcod: error decoding as integer: "', &
          word,'"'
     ier=1
     return
  endif

  ! OK

  ibuf(1:num)=ival

end subroutine splitn_idcod

subroutine splitn_ldcod(word,ibuf,num,ier)

  ! LOGICAL decode of character string

  implicit NONE

  character*(*), intent(in) :: word   ! string to decode: no leading or
  !                                   ! trailing blanks

  integer, intent(in) :: num          ! no. of copies to store (repeat count)
  logical, intent(out) :: ibuf(num)   ! where to store results

  integer, intent(out) :: ier         ! completion code (0=OK)

  !------------------------------------------
  ! if an error occurs, ibuf is not modified and a message
  ! is written on unit 6.
  !------------------------------------------

  integer ilen

  character*30 jbuf

  logical ival

  !------------------------------------------

  ier=0
  ilen=len(word)
  if(ilen.gt.30) then
     write(6,*) ' ?splitn_dcod: logical value too long: ',word
     ier=3
     return
  endif

  jbuf=' '
  jbuf(30-ilen+1:30)=word
  read(jbuf,'(L30)',iostat=ier) ival

  if(ier.ne.0) then
     write(6,*) ' ?splitn_dcod: error decoding as logical(T/F): "', &
          word,'"'
     ier=1
     return
  endif

  ! OK

  ibuf(1:num)=ival

end subroutine splitn_ldcod

subroutine splitn_cdcod(word,maxlen,cbuf,num,ier)

  ! CHARACTER decode of character string

  implicit NONE

  character*(*), intent(in) :: word   ! string to decode: no leading or
  !                                   ! trailing blanks; enclosed in quotes!

  integer, intent(in) :: maxlen       ! maximum length of enclosed string
  !                                   ! not counting trailing blanks

  integer, intent(in) :: num          ! no. of copies to store (repeat count)
  character*(*), intent(out) :: cbuf(num)   ! where to store results

  integer, intent(out) :: ier         ! completion code (0=OK)

  !------------------------------------------
  ! if an error occurs, cbuf is not modified and a message
  ! is written on unit 6.
  !------------------------------------------

  integer ilen
  character*128 cval

  !------------------------------------------

  ier=0
  ilen=len(word)

  cval=' '
  if( ((word(1:1).ne."'").and.(word(1:1).ne.'"')) .or. &
       (word(1:1).ne.word(ilen:ilen)) ) then
     write(6,*) ' ?splitn_dcod: string not enclosed in matching quotes: ', &
          word
     ier=1
     return
  endif

  ! OK

  if(ilen.le.len(cval)+2) then
     cval=word(2:ilen-1)
     ilen=ilen-2
  else
     write(6,*) " ?splitn_dcod: warning: internal buffer too small."
     ilen=maxlen+1
  endif

  if(ilen.gt.maxlen) then
     write(6,*) " ?splitn_dcod: string length error."
     ier=2
  else
     ier=0
  endif

  cbuf(1:num)=cval

end subroutine splitn_cdcod

subroutine ps_protmp(iobj,idrho,npro,pro,itmp,intrp,id,iout,ierr)

  !------------------------------------------------------------
  ! create a temporary f(rho) profile.
  ! use ps_freetmp(id,iout) to remove it when done
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: idrho    ! ID of rho grid over which data is defined

  integer, intent(in) :: npro     ! profile data size (must be consistent with
  !                                 idrho and intrp choices).

  REAL(KIND=rspec), intent(in) :: pro(npro)   ! the profile values

  integer, intent(in) :: itmp     ! number to use for temporary name generation
  !  if multiple temporary profiles are created, differing values of itmp are
  !  needed to separate them (i.e. give them different names in xplasma).
  !    abs(itmp) is used.

  integer, intent(in) :: intrp    ! interpolation method for profile
  !                       -1: zonal step function
  !                        0: piecewise linear
  !                        1: C1 cubic Hermite
  !                        2: C2 cubic Spline

  integer, intent(out) :: id      ! ID returned (0 if error occurs)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  !  local:
  integer :: iertmp,jtmp
  character*32 :: tmpname
  character*32, parameter :: authname = "PS_XPLASMA2"

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  id = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_protmp: invalid or unitialized xplasma object.'
     return
  endif

  tmpname = ' '
  jtmp=abs(itmp)
  write(tmpname,'("__TMPF_",i5.5)') jtmp

  call xplasma_author_set(s,authname,iertmp)
  
  call xplasma_create_prof(s,tmpname,idrho,pro,id,ierr, ispline=intrp)

  call xplasma_author_clear(s,authname,iertmp)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rhotmp: xplasma error creating temporary profile:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_protmp

subroutine ps_wprotmp(iobj,idrho,npro,pro,itmp,intrp,id,iout,ierr)

  !------------------------------------------------------------
  ! create a temporary f(rho) "weight" profile (should be positive definite).
  ! use ps_freetmp(id,iout) to remove it when done
  !   arguments same is ps_protmp; this function returns an error
  !   if pro(1:npro) changes sign; it returns ierr=ID=0 if pro(1:npro)
  !   is identically zero everywhere.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  integer, intent(in) :: idrho    ! ID of rho grid over which data is defined

  integer, intent(in) :: npro     ! profile data size (must be consistent with
  !                                 idrho and intrp choices).

  REAL(KIND=rspec), intent(in) :: pro(npro)   ! the profile values

  integer, intent(in) :: itmp     ! number to use for temporary name generation
  !  if multiple temporary profiles are created, differing values of itmp are
  !  needed to separate them (i.e. give them different names in xplasma).
  !    abs(itmp) is used.

  integer, intent(in) :: intrp    ! interpolation method for profile
  !                       -1: zonal step function
  !                        0: piecewise linear
  !                        1: C1 cubic Hermite
  !                        2: C2 cubic Spline

  integer, intent(out) :: id      ! ID returned (0 if error occurs)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)

  !-----------------------
  !  local:
  REAL(KIND=rspec) :: promin,promax
  REAL(KIND=rspec), parameter :: ZERO = 0.0_rspec
  !-----------------------

  id = 0

  promin = minval(pro)
  promax = maxval(pro)

  if((promin.eq.ZERO).and.(promax.eq.ZERO)) then
     ierr = 0
     return    ! no weighting profile (identically ZERO)
  endif

  if(promin*promax.lt.ZERO) then
     ierr = 999
     write(iout,*) ' ?ps_wprotmp: profile weight data changes sign:'
     write(iout,*) '   minval(pro) = ',promin
     write(iout,*) '   maxval(pro) = ',promax
     return
  endif

  !  OK -- use standard routine to set up temporary profile

  call ps_protmp(iobj,idrho,npro,pro,itmp,intrp,id,iout,ierr)

end subroutine ps_wprotmp

subroutine tdb_onoff_atime(d,z2char,zthresh,zdtfix,ton,toff,ierr)
  ! for power-channel data (NB,EC,LH,RF) define the on and off times:
  !   ton = min(on times for any channel) (*output*)
  !   toff = max(off times for any channel) (*output*)
  !
  !   z2char => chooses heating channel:
  !     "nb" or "NB" -- neutral beams
  !     "ec" -- ECH/ECCD
  !     "lh" -- Lower Hybrid
  !     "rf" -- ICRF   
  !   all tests of z2char value are case insensitive
  !
  !   zthresh = threshhold:
  !     if positive -- a power, in watts, must be < 20% of the maximum
  !                    power ever occurring on any channel
  !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
  !                    power threshold becomes -zthresh * (maximum power
  !                    ever occurring on any channel).
  !
  !   zdtfix -- time to search from first/last powers satisfying thresh-
  !             hold, for an actual 0 or negative power,
  !             or power < threshhold/10
  !
  !   ierr is set only if there is no data or if z2char is unrecognized;
  !        if the threshhold input is out of range it is overridden without
  !        warning
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
  real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
  real*8, intent(in) :: zdtfix         ! time to search from threshhold
  real*8, intent(out) :: ton,toff      ! on/off times (seconds)
  integer, intent(out) :: ierr         ! completion code; 0=OK

  !-----------------------------------
  real*8, dimension(:), allocatable :: tonarr,toffarr
  integer :: inchan,intim,ilpwr,iltim,ifound,i
  !-----------------------------------

  ton=ZERO
  toff=ZERO
  ierr=0

  call tdb_pwrset_find(d,z2char,'tdb_onoff_atime',iltim,intim,ilpwr,inchan, &
       ierr)
  if(ierr.gt.0) return
        
  allocate(tonarr(inchan),toffarr(inchan))

  call tdbsub_onoff(d%datbuf(iltim),intim,d%datbuf(ilpwr),inchan, &
       zthresh,zdtfix,tonarr,toffarr)

  ton=epsinv
  toff=-epsinv
  ifound=0
  do i=1,inchan
     if(tonarr(i).lt.epsinv) then
        ton=min(ton,tonarr(i))
        toff=max(toff,toffarr(i))
        ifound=ifound+1
     endif
  enddo

  if(ifound.eq.0) then
     toff=epsinv*1.001  ! they never come on...
  endif

  deallocate(tonarr,toffarr)
  
end subroutine tdb_onoff_atime

subroutine tdb_onoff_nxtime(d,z2char,zthresh,zdtfix,tprev,tnext,ierr)
  ! for power-channel data (NB,EC,LH,RF) define the "next" on time, after tprev
  !
  ! the "next" on time is a time when power reappears after being zero (or
  ! nearly so) on all channels.  The precise meaning of "nearly so" is in
  ! the threshhold definition.
  !
  !   z2char => chooses heating channel:
  !     "nb" or "NB" -- neutral beams
  !     "ec" -- ECH/ECCD
  !     "lh" -- Lower Hybrid
  !     "rf" -- ICRF   
  !   all tests of z2char value are case insensitive
  !
  !   zthresh = threshhold:
  !     if positive -- a power, in watts, must be < 20% of the maximum
  !                    power ever occurring on any channel
  !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
  !                    power threshold becomes -zthresh * (maximum power
  !                    ever occurring on any channel).
  !
  !   zdtfix -- time to search from first/last powers satisfying thresh-
  !             hold, for an actual 0 or negative power, 
  !             or power < threshhold/10
  !
  !   ierr is set only if there is no data or if z2char is unrecognized.
  !        if the threshhold input is out of range it is overridden without
  !        warning
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
  real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
  real*8, intent(in) :: zdtfix         ! time to search from threshhold
  real*8, intent(in) :: tprev          ! previous time, after which to search

  real*8, intent(out) :: tnext         ! next time of transition from zero to
  !              non-zero power.  If not found, tnext=EPSINV is returned:
  !              a very large time value.

  integer, intent(out) :: ierr         ! completion code; 0=OK

  !-----------------------------------
  integer :: inchan,intim,ilpwr,iltim
  !-----------------------------------

  tnext=EPSINV
  ierr=0

  call tdb_pwrset_find(d,z2char,'tdb_onoff_nxtime',iltim,intim,ilpwr,inchan, &
       ierr)
  if(ierr.gt.0) return
        
  call tdbsub_next_on(d%datbuf(iltim),intim,d%datbuf(ilpwr),inchan, &
       zthresh,zdtfix,tprev,tnext)

end subroutine tdb_onoff_nxtime

subroutine tdb_pwrset_find(d,z2char,zsubr,iltim,intim,ilpwr,inchan,ierr)
  !
  !  find power vs. (time,channel #) dataset
  !
  !   z2char => chooses heating channel:
  !     "nb" or "NB" -- neutral beams
  !     "ec" -- ECH/ECCD
  !     "lh" -- Lower Hybrid
  !     "rf" -- ICRF   
  !   all tests of z2char value are case insensitive
  !

  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
  character*(*), intent(in) :: zsubr   ! caller ID string (for error message)
  integer, intent(out) :: iltim        ! address of time data
  integer, intent(out) :: intim        ! number of time points
  integer, intent(out) :: ilpwr        ! address of power data
  integer, intent(out) :: inchan       ! number of power channels
  integer, intent(out) :: ierr         ! status code returned: 0=normal
  !
  !  note ierr=1 is returned if inchan=0, but, this could be a normal situation
  !  indicating e.g. a simulation where there is no heating of the type 
  !  requested
  !
  !-----------------------------------------
  integer :: lunmsg_tdb
  !-----------------------------------------
  !  local variables:
  character*3 :: ztest3
  !-----------------------------------------

  iltim=0
  intim=0
  ilpwr=0
  inchan=0
  ierr=0

  ztest3=z2char(1:min(3,len(z2char)))
  call uupper(ztest3)

  !  look for antenna or NB set...

  !  expect channel based data (NB powers, RF antennas etc)

  if(ztest3.eq.'NB') then
     inchan=d%nbdata
     if(inchan.eq.0) then
        ierr=1
     else
        ilpwr=d%lpwrnb
        iltim=d%ltimnb
        intim=d%ntimnb
     endif
  else if(ztest3.eq.'EC') then
     inchan=d%nantech_d
     if(inchan.eq.0) then
        ierr=1
     else
        ilpwr=d%lpwrec
        iltim=d%ltimec
        intim=d%ntimec
     endif
  else if(ztest3.eq.'LH') then
     inchan=d%nantlh_d
     if(inchan.eq.0) then
        ierr=1
     else
        ilpwr=d%lpwrlh
        iltim=d%ltimlh
        intim=d%ntimlh
     endif
  else if(ztest3.eq.'RF') then
     inchan=d%nantich_d
     if(inchan.eq.0) then
        ierr=1
     else
        ilpwr=d%lpwrrf
        iltim=d%ltimrf
        intim=d%ntimrf
     endif
  else
     ierr=2
     write(lunmsg_tdb(0),*) &
          ' ? trdatbuf_lib/'//trim(zsubr)//': unrecognized ', &
          'channel identifier: "',trim(z2char),'".'
  endif

end subroutine tdb_pwrset_find

subroutine tdb_onoff_atime1(d,ntri,ztris,zthresh,zdtfix,ton,toff,ierr)
  ! for a set of time series data Pj(t) define the on and off times:
  !   ton = min(on times for any channel) (*output*)
  !   toff = max(off times for any channel) (*output*)
  !
  !   ztris(1:ntri) -- trigraphs of scalar functions
  !
  !   zthresh = threshhold:
  !     if positive -- a power, in watts, must be < 20% of the maximum
  !                    power ever occurring on any channel
  !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
  !                    power threshold becomes -zthresh * (maximum power
  !                    ever occurring on any channel).
  !
  !   zdtfix -- time to search from first/last powers satisfying thresh-
  !             hold, for an actual 0 or negative power...
  !
  !   ierr is set only if there is no data or if z2char is unrecognized;
  !   if the zthresh limit has to be adjusted to conform to rules, a 
  !   warning message is written but ierr is not set.
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(in) :: ntri          ! no. of trigraphs
  character*(*), intent(in) :: ztris(ntri)  ! trigraph names
  real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
  real*8, intent(in) :: zdtfix         ! time to search from threshhold
  real*8, intent(out) :: ton,toff      ! on/off times (seconds)
  integer, intent(out) :: ierr         ! completion code; 0=OK

  !-----------------------------------
  real*8, dimension(:), allocatable :: tonarr,toffarr
  real*8, dimension(:,:), allocatable :: zpwrs
  character*3 :: ztest3
  integer :: inchan,intim,iltim,lunmsg_tdb,ifound,i
  integer :: iadscal
  !-----------------------------------

  ton=epsinv
  toff=1.01*epsinv

  ierr=0

  iltim = d%ltime1
  intim = d%ntime1
  inchan = ntri

  allocate(zpwrs(intim,ntri)); zpwrs=ZERO
  ifound = 0

  do i=1,ntri
     ztest3=ztris(i)
     call uupper(ztest3)

     if(tdb_defined1(d,ztest3)) then

     !  look for scalar function...

        if(tdb_present1(d,ztest3,iadscal)) then

           ifound = ifound + 1
           zpwrs(1:intim,i) = d%datbuf(iadscal:iadscal+intim-1)

        endif

     else

        write(lunmsg_tdb(0),*) ' ?tdb_onoff_atime1: not a scalar function: ', &
             ztest3
        ierr=ierr+1
        
     endif
  enddo

  if((ierr.gt.0).or.(ifound.eq.0)) then
     deallocate(zpwrs)
     return
  endif
        
  allocate(tonarr(inchan),toffarr(inchan))

  call tdbsub_onoff(d%datbuf(iltim),intim,zpwrs,inchan, &
       zthresh,zdtfix,tonarr,toffarr)
  deallocate(zpwrs)

  ton=epsinv
  toff=-epsinv
  ifound=0
  do i=1,inchan
     if(tonarr(i).lt.epsinv) then
        ton=min(ton,tonarr(i))
        toff=max(toff,toffarr(i))
        ifound=ifound+1
     endif
  enddo

  if(ifound.eq.0) then
     toff=epsinv*1.01  ! they never come on...
  endif

  deallocate(tonarr,toffarr)
  
end subroutine tdb_onoff_atime1

subroutine tdb_onoff_atime2(d,ntri,ztris,zthresh,zdtfix,ton,toff,ierr)
  ! for a set of profiles Pj(t,x) define the on and off times:
  !   ton = min(on times for any profile) (*output*)
  !   toff = max(off times for any profile) (*output*)
  !
  !   ztris(1:ntri) -- trigraphs of scalar functions
  !
  !   zthresh = threshhold:
  !     if non-negative -- same as zthresh=-0.05 here
  !        (total power not usable, we don't know it here)
  !
  !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
  !                    power threshold becomes -zthresh * (maximum power
  !                    ever occurring on any channel).
  !
  !   zdtfix -- time to search from first/last powers satisfying thresh-
  !             hold, for an actual 0 or negative power...
  !
  !   ierr is set only if the trigraphs are unrecognized.
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  integer, intent(in) :: ntri          ! no. of trigraphs
  character*(*), intent(in) :: ztris(ntri)  ! trigraph names
  real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
  real*8, intent(in) :: zdtfix         ! time to search from threshhold
  real*8, intent(out) :: ton,toff      ! on/off times (seconds)
  integer, intent(out) :: ierr         ! completion code; 0=OK

  !-----------------------------------
  real*8, dimension(:), allocatable :: tonarr,toffarr
  real*8, dimension(:,:),  allocatable :: zpwrs
  real*8 :: zthreshi
  character*3 :: ztest3
  integer :: inchan,intim,iltim,lunmsg_tdb,ifound,i,it,ix,inx
  integer :: iadprof,iadscal,iadxpro,inxpro,iadxt
  !-----------------------------------

  ton=epsinv
  toff=1.01*epsinv
  ierr=0

  iltim=d%ltime2
  intim=d%ntime2
  inchan=ntri

  allocate(zpwrs(intim,inchan)); zpwrs = ZERO
  ifound = 0

  do i=1,ntri
     ztest3=ztris(i)
     call uupper(ztest3)

     if(tdb_defined2(d,ztest3)) then

        !  look for profile function...

        if(tdb_present2(d,ztest3,iadprof,iadxpro,inxpro)) then

           ifound = ifound+1

           if(inxpro.eq.0) then
              ierr=3
              write(lunmsg_tdb(0),*) &
                   ' ?? tdb_onoff_atime: cannot infer on/off time from: '//ztest3
              write(lunmsg_tdb(0),*) '    profile type not supported.'
           else

              do ix=1,inxpro
                 do it=1,intim

                    iadxt=iadprof+(ix-1)*intim + it - 1
                    zpwrs(it,i) = zpwrs(it,i) + d%datbuf(iadxt)

                 enddo
              enddo
           endif

        endif

     else

        write(lunmsg_tdb(0),*) ' ?tdb_onoff_atime2: not a profile function: ',&
             ztest3
        ierr=1

     endif
  enddo

  if((ierr.gt.0).or.(ifound.eq.0)) then
     deallocate(zpwrs)
     return
  endif
        
  allocate(tonarr(inchan),toffarr(inchan))

  zthreshi=zthresh
  if(zthreshi.ge.ZERO) zthreshi=-0.05d0

  call tdbsub_onoff(d%datbuf(iltim),intim,zpwrs,inchan, &
       zthreshi,zdtfix,tonarr,toffarr)
  deallocate(zpwrs)

  ton=epsinv
  toff=-epsinv
  ifound=0
  do i=1,inchan
     if(tonarr(i).lt.epsinv) then
        ton=min(ton,tonarr(i))
        toff=max(toff,toffarr(i))
        ifound=ifound+1
     endif
  enddo

  if(ifound.eq.0) then
     toff=epsinv*1.01  ! they never come on...
  endif

  deallocate(tonarr,toffarr)
  
end subroutine tdb_onoff_atime2

subroutine tdb_onoff_times(d,z2char,zthresh,zdtfix,tonarr,toffarr,ierr)
  ! for power-channel data (NB,EC,LH,RF) define the on and off times:
  !   tonarr(i) = on time for channel #i (i.e. beam or antenna) (*output*)
  !   toffarr(i) = off time for channel #i (*output*)
  !
  !   z2char => chooses heating channel:
  !     "nb" or "NB" -- neutral beams
  !     "ec" -- ECH/ECCD
  !     "lh" -- Lower Hybrid
  !     "rf" -- ICRF   
  !   all tests of z2char value are case insensitive
  ! 
  !   zthresh = threshhold:
  !     if positive -- a power, in watts, must be < 20% of the maximum
  !                    power ever occurring on any channel
  !     if negative -- (-1) * a fraction (no units) -- btw -0.0001 and -0.20 --
  !                    power threshold becomes -zthresh * (maximum power
  !                    ever occurring on any channel).
  !
  !   zdtfix -- time to search from first/last powers satisfying thresh-
  !             hold, for an actual 0 or negative power...
  !
  !   ierr is set only if there is no data or if z2char is unrecognized;
  !   if the zthresh limit has to be adjusted to conform to rules, a 
  !   warning message is written but ierr is not set.
  !
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: z2char  ! channel type NB/LH/EC/RF
  real*8, intent(in) :: zthresh        ! on/off threshhold (see comments)
  real*8, intent(in) :: zdtfix         ! time to search from threshhold
  real*8, intent(out), dimension(:) :: tonarr,toffarr  ! on/off times (seconds)
  integer, intent(out) :: ierr         ! completion code; 0=OK

  !-----------------------------------
  integer :: inchan,intim,ilpwr,iltim,lunmsg_tdb,ifound,i
  !-----------------------------------

  ierr=0

  call tdb_pwrset_find(d,z2char,'tdb_onoff_times',iltim,intim,ilpwr,inchan, &
       ierr)

  if(size(tonarr).lt.inchan) then
     write(lunmsg_tdb(0),*) ' ? trdatbuf_lib/tdb_onoff_times: "tonarr" array',&
          ' size too small:'
     write(lunmsg_tdb(0),*) '   need: ',inchan
     write(lunmsg_tdb(0),*) '    got: ',size(tonarr)
     ierr=3
  endif

  if(size(toffarr).lt.inchan) then
     write(lunmsg_tdb(0),*) ' ? trdatbuf_lib/tdb_onoff_times: "toffarr" array',&
          ' size too small:'
     write(lunmsg_tdb(0),*) '   need: ',inchan
     write(lunmsg_tdb(0),*) '    got: ',size(toffarr)
     ierr=4
  endif

  if(ierr.gt.0) return

  call tdbsub_onoff(d%datbuf(iltim),intim,d%datbuf(ilpwr),inchan, &
       zthresh,zdtfix,tonarr(1:inchan),toffarr(1:inchan))
  
end subroutine tdb_onoff_times

subroutine tdb_onoff_zscal(d,ztri,zton,ztoff,ierr)

  !  zero out a scalar function outside a given time range
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: ztri  ! trigraph of data to modify
  real*8, intent(in) :: zton,ztoff   ! on/off times
  integer, intent(out) :: ierr       ! 0 if OK, set if ztri invalid...

  !------------------------
  integer :: iaddr,iltim,intim,it
  !------------------------

  if(tdb_present1(d,ztri,iaddr)) then
     iltim=d%ltime1
     intim=d%ntime1
     do it=1,intim
        if((d%datbuf(iltim+it-1).lt.zton).or. &
             (d%datbuf(iltim+it-1).gt.ztoff)) then
           d%datbuf(iaddr+it-1) = ZERO
        endif
     enddo

     ierr = 0

  else

     ierr = 1

  endif
end subroutine tdb_onoff_zscal

subroutine tdb_onoff_zprof(d,ztri,zton,ztoff,ierr)

  !  zero out a profile function outside a given time range
  use trdatbuf_obj
  use tdbsub_uts  ! private
  implicit NONE

  type (trdatbuf) :: d
  character*(*), intent(in) :: ztri  ! trigraph of data to modify
  real*8, intent(in) :: zton,ztoff   ! on/off times
  integer, intent(out) :: ierr       ! 0 if OK, set if ztri invalid...

  !------------------------
  integer :: iaddr,iaddx,inumx,iltim,intim,it,ix
  !------------------------

  if(tdb_present2(d,ztri,iaddr,iaddx,inumx)) then
     if(inumx.eq.0) then
        ierr = 2
     else
        iltim=d%ltime2
        intim=d%ntime2
        do it=1,intim
           if((d%datbuf(iltim+it-1).lt.zton).or. &
                (d%datbuf(iltim+it-1).gt.ztoff)) then
              do ix=1,inumx
                 d%datbuf(iaddr+(ix-1)*intim+it-1) = ZERO
              enddo
           endif
        enddo
        ierr = 0
     endif

  else

     ierr = 1

  endif
end subroutine tdb_onoff_zprof

subroutine ps_list_store(section, iobj, listname, &
     iauthor, units, label, &
     nelems, elem_names, elem_ivals, elem_r8vals, elem_labels, &
     imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a list of values, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  character*(*), intent(in) :: section     ! plasma state section name

  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: listname    ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID
  character*(*), intent(in) :: units       ! units label

  character*(*), intent(in) :: label       ! label for whole list

  integer, intent(in) :: nelems            ! list size

  character*(*), intent(in) :: elem_names(nelems) ! element names

  integer, intent(in) :: elem_ivals(nelems)   ! element integer values
  REAL(kind=rspec), intent(in) :: elem_r8vals(nelems)  ! element values
  character*(*), intent(in) :: elem_labels(nelems)  ! element labels or
                                           ! character data

  integer, intent(out) :: imod             ! =1 if profile is new or modified
  !  =0 on output if profile was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------
  ! local...

  integer :: id,istat,iertmp

  !--------------------------------------------------

  imod = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_list_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_list_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif
  if(ierr.ne.0) return

  !--------------------------------------------------
  !  write the list

  call xplasma_create_list(s,listname,elem_names,id,ierr, &
       label=label, units=units, &
       ivals=elem_ivals, r8vals=elem_r8vals, chvals=elem_labels, &
       change_status = istat)

  imod = min(1,istat)
       
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_list_store: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

  !--------------------------------------------------
  ! clear author

  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_list_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_list_store

subroutine ps_list_update_r8(iobj, listname, iauthor, &
     nelems, elem_r8vals, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! insert list of (modified) floating point values in existing list
  !    this is used in computing scalar reduced values from profiles
  !    modification of values is not checked, because, modifications
  !    to the profile itself was already checked (it is assumed).

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: listname    ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: nelems            ! list size

  REAL(kind=rspec), intent(in) :: elem_r8vals(nelems)  ! element values

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: id,iertmp

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_list_update: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  !  set author

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_list_update_r8: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif
  if(ierr.ne.0) return

  !--------------------------------------------------
  
  call xplasma_listId(s,listname,id)
  if(id.eq.0) then
     write(iout,*) ' ?ps_list_update_r8: expected list not found: ', &
          trim(listname)
     ierr=103
     goto 999
  endif

  call xplasma_setList_r8vals(s,id,elem_r8vals,ierr)
  if(ierr.ne.0) then
     write(iout,*) &
          ' ?ps_list_update_r8: unexpected xplasma_setList_r8vals error:'
     call xplasma_error(s,ierr,iout)
     ierr=105
     goto 999
  endif

  !--------------------------------------------------
  ! clear author

999 continue
  call xplasma_author_clear(s,ps_cnames(iauthor),iertmp)
  if(iertmp.ne.0) then
     write(iout,*) ' ?ps_list_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=101
  endif

end subroutine ps_list_update_r8

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_xload_singl(ss,xhash,iout,ierr)

  ! called from plasma_state_xload: check grids; store in xplasma structure

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER :: xhash(ps_hash_total)  ! hash data
  INTEGER, INTENT(IN) :: iout   ! LUN for messages
  INTEGER, INTENT(INOUT) :: ierr   ! completion code (set if error occurs)

  !-----------------------
  ! local:

  INTEGER, PARAMETER :: max_local = 4

  INTEGER :: icomponent,imod,nitems
  CHARACTER*32 :: listname,enum_name,units
  CHARACTER*80 :: label
  INTEGER :: ahash(ps_max_static)

  CHARACTER*32 :: item_names(max_local)
  INTEGER :: item_ivals(max_local)
  REAL(KIND=rspec) :: item_r8vals(max_local)
  CHARACTER*256 :: item_c256(max_local)
  !-----------------------

  ahash(1) = ps_shash_ANOM_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "ANOM_CODE_INFO"
     icomponent = ps_cnum_ANOM
     units = " "
     label = "Information: code implementing ANOM component"
     nitems = 1
     item_names(1) = "ANOM_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%ANOM_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_CUR_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "CUR_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of plasma current data"
     nitems = 1
     item_names(1) = "CUR_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%CUR_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_dn0out
  IF(hcheck(1,1)) THEN
     listname = "DN0OUT"
     icomponent = ps_cnum_GAS
     units = "m^-3"
     label = "Hydrogenic neutral density in scrape off region"
     nitems = 1
     item_names(1) = "dn0out"
     item_r8vals(1) = ss%dn0out
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_D_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "D_EINJ_STANDARD"
     enum_name = "D_EINJ_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "keV"
     label = "D beam table energies"
     nitems = 1
     item_names(1) = "D_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_d_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%D_einj_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_d_einj_standard,ss%D_einj_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_D_ffull_standard
  IF(hcheck(1,1)) THEN
     listname = "D_FFULL_STANDARD"
     enum_name = "D_FFULL_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "D beam full energy fractions"
     nitems = 1
     item_names(1) = "D_ffull_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_d_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%D_ffull_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_d_einj_standard,ss%D_ffull_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_D_fhalf_standard
  IF(hcheck(1,1)) THEN
     listname = "D_FHALF_STANDARD"
     enum_name = "D_FHALF_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "D beam half energy fractions"
     nitems = 1
     item_names(1) = "D_fhalf_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_d_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%D_fhalf_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_d_einj_standard,ss%D_fhalf_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_EC_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "EC_CODE_INFO"
     icomponent = ps_cnum_EC
     units = " "
     label = "Information: code implementing EC component"
     nitems = 1
     item_names(1) = "EC_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%EC_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_EC_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "EC_DATA_INFO"
     icomponent = ps_cnum_EC
     units = " "
     label = "information on source of ECRF power data"
     nitems = 1
     item_names(1) = "EC_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%EC_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_eldot
  IF(hcheck(1,1)) THEN
     listname = "ELDOT"
     icomponent = ps_cnum_PLASMA
     units = "1/sec"
     label = "[d(Philim)/dt]/[2*Philim]"
     nitems = 1
     item_names(1) = "eldot"
     item_r8vals(1) = ss%eldot
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_EQ_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "EQ_CODE_INFO"
     icomponent = ps_cnum_EQ
     units = " "
     label = "Information: code implementing EQ component"
     nitems = 1
     item_names(1) = "EQ_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%EQ_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_EQ_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "EQ_DATA_INFO"
     icomponent = ps_cnum_EQ
     units = " "
     label = "Information: source of EQ input data"
     nitems = 1
     item_names(1) = "EQ_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%EQ_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_FUS_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "FUS_CODE_INFO"
     icomponent = ps_cnum_FUS
     units = " "
     label = "Information: code implementing FUS component"
     nitems = 1
     item_names(1) = "FUS_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%FUS_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_GAS_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "GAS_CODE_INFO"
     icomponent = ps_cnum_GAS
     units = " "
     label = "Information: code implementing GAS component"
     nitems = 1
     item_names(1) = "GAS_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%GAS_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_geometry
  IF(hcheck(1,1)) THEN
     listname = "GEOMETRY"
     icomponent = ps_cnum_EQ
     units = " "
     label = "path to file(s) vac. vessel & coil descr."
     nitems = 1
     item_names(1) = "geometry"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%geometry
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_Global_label
  IF(hcheck(1,1)) THEN
     listname = "GLOBAL_LABEL"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "Run Label"
     nitems = 1
     item_names(1) = "Global_label"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%Global_label
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_H_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "H_EINJ_STANDARD"
     enum_name = "H_EINJ_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "keV"
     label = "H beam table energies"
     nitems = 1
     item_names(1) = "H_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_h_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%H_einj_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_h_einj_standard,ss%H_einj_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_H_ffull_standard
  IF(hcheck(1,1)) THEN
     listname = "H_FFULL_STANDARD"
     enum_name = "H_FFULL_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "H beam full energy fractions"
     nitems = 1
     item_names(1) = "H_ffull_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_h_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%H_ffull_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_h_einj_standard,ss%H_ffull_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_H_fhalf_standard
  IF(hcheck(1,1)) THEN
     listname = "H_FHALF_STANDARD"
     enum_name = "H_FHALF_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "H beam half energy fractions"
     nitems = 1
     item_names(1) = "H_fhalf_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_h_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%H_fhalf_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_h_einj_standard,ss%H_fhalf_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_IC_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "IC_CODE_INFO"
     icomponent = ps_cnum_IC
     units = " "
     label = "Information: code implementing IC component"
     nitems = 1
     item_names(1) = "IC_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%IC_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_IC_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "IC_DATA_INFO"
     icomponent = ps_cnum_IC
     units = " "
     label = "information on source of ICRF power data"
     nitems = 1
     item_names(1) = "IC_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%IC_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_i_npoloidal
  IF(hcheck(1,1)) THEN
     listname = "I_NPOLOIDAL"
     icomponent = ps_cnum_LH
     units = " "
     label = "need description"
     nitems = 1
     item_names(1) = "i_npoloidal"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%i_npoloidal
     item_c256(1) = " "
     CALL ps_list_store("SHOT_CONFIGURATION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_LH_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "LH_CODE_INFO"
     icomponent = ps_cnum_LH
     units = " "
     label = "Information: code implementing LH component"
     nitems = 1
     item_names(1) = "LH_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%LH_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_LH_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "LH_DATA_INFO"
     icomponent = ps_cnum_LH
     units = " "
     label = "Information on source of LHRF power data"
     nitems = 1
     item_names(1) = "LH_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%LH_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_LMHD_eq_code
  IF(hcheck(1,1)) THEN
     listname = "LMHD_EQ_CODE"
     icomponent = ps_cnum_LMHD
     units = " "
     label = "name of MHD equilibrium refinement code used"
     nitems = 1
     item_names(1) = "LMHD_eq_code"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%LMHD_eq_code
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_NBI_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "NBI_CODE_INFO"
     icomponent = ps_cnum_NBI
     units = " "
     label = "Information: code implementing NBI component"
     nitems = 1
     item_names(1) = "NBI_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%NBI_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_NBI_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "NBI_DATA_INFO"
     icomponent = ps_cnum_NBI
     units = " "
     label = "information on source of beam power & voltage data"
     nitems = 1
     item_names(1) = "NBI_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%NBI_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_nebar
  IF(hcheck(1,1)) THEN
     listname = "NEBAR"
     icomponent = ps_cnum_PLASMA
     units = "#/m^2"
     label = "line-averaged electron density"
     nitems = 1
     item_names(1) = "nebar"
     item_r8vals(1) = ss%nebar
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_nky_anomth
  IF(hcheck(1,1)) THEN
     listname = "NKY_ANOMTH"
     icomponent = ps_cnum_ANOM
     units = " "
     label = "number of points, ky grid ( anomalous data over ky spectrum)"
     nitems = 1
     item_names(1) = "nky_anomth"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%nky_anomth
     item_c256(1) = " "
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_nky_mmm
  IF(hcheck(1,1)) THEN
     listname = "NKY_MMM"
     icomponent = ps_cnum_ANOM
     units = " "
     label = "number of points, ky grid for MMM model"
     nitems = 1
     item_names(1) = "nky_mmm"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%nky_mmm
     item_c256(1) = " "
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_nmdifb
  IF(hcheck(1,1)) THEN
     listname = "NMDIFB"
     icomponent = ps_cnum_ANOM
     units = " "
     label = "type of fast ion diffusivity"
     nitems = 1
     item_names(1) = "nmdifb"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%nmdifb
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_nmodel_bdy
  IF(hcheck(1,1)) THEN
     listname = "NMODEL_BDY"
     icomponent = ps_cnum_ANOM
     units = "m^-3"
     label = "model density, boundary value"
     nitems = 1
     item_names(1) = "nmodel_bdy"
     item_r8vals(1) = ss%nmodel_bdy
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_nmom
  IF(hcheck(1,1)) THEN
     listname = "NMOM"
     icomponent = ps_cnum_EQ
     units = " "
     label = "number of Fourier (R,Z) moments"
     nitems = 1
     item_names(1) = "nmom"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%nmom
     item_c256(1) = " "
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_ns_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "NS_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of Density data"
     nitems = 1
     item_names(1) = "ns_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%ns_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_ntf_coil2
  IF(hcheck(1,1)) THEN
     listname = "NTF_COIL2"
     icomponent = ps_cnum_RIPPLE
     units = " "
     label = "number of TF coils involved in inducing 2nd component"
     nitems = 1
     item_names(1) = "ntf_coil2"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%ntf_coil2
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_ntf_coils
  IF(hcheck(1,1)) THEN
     listname = "NTF_COILS"
     icomponent = ps_cnum_RIPPLE
     units = " "
     label = "number of TF coils"
     nitems = 1
     item_names(1) = "ntf_coils"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%ntf_coils
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_num_rzlim
  IF(hcheck(1,1)) THEN
     listname = "NUM_RZLIM"
     icomponent = ps_cnum_EQ
     units = " "
     label = "number of points, axisymmetric (R,Z) limiter"
     nitems = 1
     item_names(1) = "num_rzlim"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%num_rzlim
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_n_D_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "N_D_EINJ_STANDARD"
     icomponent = ps_cnum_NBI
     units = " "
     label = "no. pts in D beam energy fractions table"
     nitems = 1
     item_names(1) = "n_D_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_D_einj_standard
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_n_H_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "N_H_EINJ_STANDARD"
     icomponent = ps_cnum_NBI
     units = " "
     label = "no. pts in H beam energy fractions table"
     nitems = 1
     item_names(1) = "n_H_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_H_einj_standard
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_dhash_n_T_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "N_T_EINJ_STANDARD"
     icomponent = ps_cnum_NBI
     units = " "
     label = "no. pts in T beam energy fractions table"
     nitems = 1
     item_names(1) = "n_T_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_T_einj_standard
     item_c256(1) = " "
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_omegat_bdy
  IF(hcheck(1,1)) THEN
     listname = "OMEGAT_BDY"
     icomponent = ps_cnum_PLASMA
     units = "rad/sec"
     label = "toroidal angular velocity at/beyond boundary"
     nitems = 1
     item_names(1) = "omegat_bdy"
     item_r8vals(1) = ss%omegat_bdy
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_PEL_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "PEL_CODE_INFO"
     icomponent = ps_cnum_PEL
     units = " "
     label = "Information: code implementing PELLET component"
     nitems = 1
     item_names(1) = "PEL_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%PEL_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_PEL_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "PEL_DATA_INFO"
     icomponent = ps_cnum_PEL
     units = " "
     label = "Information: on source of pellet injection"
     nitems = 1
     item_names(1) = "PEL_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%PEL_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_PLASMA_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "PLASMA_CODE_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "Information: code managing PLASMA component"
     nitems = 1
     item_names(1) = "PLASMA_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%PLASMA_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_Psi_to_machine_axis
  IF(hcheck(1,1)) THEN
     listname = "PSI_TO_MACHINE_AXIS"
     icomponent = ps_cnum_EQ
     units = "Wb/rad"
     label = "delta(Psi) from magnetic axis to machine axis"
     nitems = 1
     item_names(1) = "Psi_to_machine_axis"
     item_r8vals(1) = ss%Psi_to_machine_axis
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_RAD_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "RAD_CODE_INFO"
     icomponent = ps_cnum_RAD
     units = " "
     label = "Information: code implementing RAD component"
     nitems = 1
     item_names(1) = "RAD_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%RAD_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_RAD_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "RAD_DATA_INFO"
     icomponent = ps_cnum_RAD
     units = " "
     label = "Information on source of radiated power data"
     nitems = 1
     item_names(1) = "RAD_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%RAD_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_rlim
  IF(hcheck(1,1)) THEN
     listname = "RLIM"
     enum_name = "RLIM__RVEC"
     icomponent = ps_cnum_EQ
     units = "m"
     label = "R points in closed (R,Z) contour sequence"
     nitems = 1
     item_names(1) = "rlim"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%num_rzlim
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%rlim)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%num_rzlim,ss%rlim,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_RUNAWAY_Code_Info
  IF(hcheck(1,1)) THEN
     listname = "RUNAWAY_CODE_INFO"
     icomponent = ps_cnum_RUNAWAY
     units = " "
     label = "Information: code implementing RUNAWAY component"
     nitems = 1
     item_names(1) = "RUNAWAY_Code_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%RUNAWAY_Code_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_RunID
  IF(hcheck(1,1)) THEN
     listname = "RUNID"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "Run ID"
     nitems = 1
     item_names(1) = "RunID"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%RunID
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_shot_number
  IF(hcheck(1,1)) THEN
     listname = "SHOT_NUMBER"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "integer shot number"
     nitems = 1
     item_names(1) = "shot_number"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%shot_number
     item_c256(1) = " "
     CALL ps_list_store("SHOT_CONFIGURATION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_TF_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "TF_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of toroidal field data"
     nitems = 1
     item_names(1) = "TF_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%TF_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_tmodel_bdy
  IF(hcheck(1,1)) THEN
     listname = "TMODEL_BDY"
     icomponent = ps_cnum_ANOM
     units = "keV"
     label = "model temperature, boundary value"
     nitems = 1
     item_names(1) = "tmodel_bdy"
     item_r8vals(1) = ss%tmodel_bdy
     item_ivals(1) = 0
     item_c256(1) = " "
     CALL ps_list_store("STATE_DATA", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_tokamak_id
  IF(hcheck(1,1)) THEN
     listname = "TOKAMAK_ID"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "Tokamak (Machine Description) ID"
     nitems = 1
     item_names(1) = "tokamak_id"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%tokamak_id
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_Ts_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "TS_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of Temperature data"
     nitems = 1
     item_names(1) = "Ts_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%Ts_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_T_einj_standard
  IF(hcheck(1,1)) THEN
     listname = "T_EINJ_STANDARD"
     enum_name = "T_EINJ_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "keV"
     label = "T beam table energies"
     nitems = 1
     item_names(1) = "T_einj_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_t_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%T_einj_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_t_einj_standard,ss%T_einj_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_T_ffull_standard
  IF(hcheck(1,1)) THEN
     listname = "T_FFULL_STANDARD"
     enum_name = "T_FFULL_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "T beam full energy fractions"
     nitems = 1
     item_names(1) = "T_ffull_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_t_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%T_ffull_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_t_einj_standard,ss%T_ffull_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_T_fhalf_standard
  IF(hcheck(1,1)) THEN
     listname = "T_FHALF_STANDARD"
     enum_name = "T_FHALF_STANDARD__RVEC"
     icomponent = ps_cnum_NBI
     units = "-"
     label = "T beam half energy fractions"
     nitems = 1
     item_names(1) = "T_fhalf_standard"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%n_t_einj_standard
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%T_fhalf_standard)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%n_t_einj_standard,ss%T_fhalf_standard,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

  ahash(1) = ps_shash_vpol_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "VPOL_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of poloidal velocity data"
     nitems = 1
     item_names(1) = "vpol_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%vpol_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_VSUR_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "VSUR_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of surface voltage data"
     nitems = 1
     item_names(1) = "VSUR_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%VSUR_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_vtor_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "VTOR_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of toroidal velocity data"
     nitems = 1
     item_names(1) = "vtor_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%vtor_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_Z0max
  IF(hcheck(1,1)) THEN
     listname = "Z0MAX"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "maximum Z of non-impurity species"
     nitems = 1
     item_names(1) = "Z0max"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%Z0max
     item_c256(1) = " "
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_ZEFF_Data_Info
  IF(hcheck(1,1)) THEN
     listname = "ZEFF_DATA_INFO"
     icomponent = ps_cnum_PLASMA
     units = " "
     label = "information on source of Zeff data"
     nitems = 1
     item_names(1) = "ZEFF_Data_Info"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = 0
     item_c256(1) = ss%ZEFF_Data_Info
     CALL ps_list_store("SIMULATION_INIT", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_shash_zlim
  IF(hcheck(1,1)) THEN
     listname = "ZLIM"
     enum_name = "ZLIM__RVEC"
     icomponent = ps_cnum_EQ
     units = "m"
     label = "Z points in closed (R,Z) contour sequence"
     nitems = 1
     item_names(1) = "zlim"
     item_r8vals(1) = 0.0_rspec
     item_ivals(1) = ss%num_rzlim
     item_c256(1) = "__enumeration__"
     CALL ps_list_store("MACHINE_DESCRIPTION", ss%iobj, &
          listname,icomponent,units,label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
     IF(ALLOCATED(ss%zlim)) THEN
        CALL ps_enum_1d_store(ss%iobj,enum_name,icomponent, &
             ss%num_rzlim,ss%zlim,imod,iout,ierr)
        IF(ierr.NE.0) RETURN
     ENDIF
  ENDIF

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload_singl

subroutine ps_filename(chtag,spath,sfile,suffix)

  ! form filename for state file I/O
  ! typically:
  !   trim(spath)/<chtag>_state.cdf

  implicit NONE

  character*(*), intent(in) :: chtag  ! state object tag string
  character*(*), intent(in) :: spath  ! file path (directory)

  character*(*), intent(out) :: sfile ! full file name

  character*(*), intent(in) :: suffix ! suffix to filename (if non-blank)
  !  '_'//trim(suffix) can be added to base filename

  !  All generated filenames end in ".cdf".  The suffix, if present, is
  !  applied to the base filename.

  !-------------------------------
  integer :: ilen
  !-------------------------------

  if(spath.eq.' ') then

     if(suffix.eq.' ') then
        sfile = trim(chtag)//'_state.cdf'
     else
        sfile = trim(chtag)//'_state_'//trim(suffix)//'.cdf'
     endif

  else
     ilen = len(trim(spath))
     if(spath(ilen:ilen).eq.'/') ilen=ilen-1

     if(suffix.eq.' ') then
        sfile = spath(1:ilen)//'/'//trim(chtag)//'_state.cdf'
     else
        sfile = spath(1:ilen)//'/'//trim(chtag)// &
             '_state_'//trim(suffix)//'.cdf'
     endif
  endif

end subroutine ps_filename

subroutine tdbsub_slookup(zt,int,zt1,it1,zfrac1)

  ! call access w/o module: tdbsub_lookup(...)

  use tdbsub_uts
  implicit NONE

  integer, intent(in) :: int
  real*8, intent(in)  :: zt(int)
  real*8, intent(in) :: zt1
  integer, intent(out) :: it1
  real*8, intent(out) :: zfrac1

  call tdbsub_lookup(zt,int,zt1,it1,zfrac1)

end subroutine tdbsub_slookup

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_2(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%D_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"D_einj_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"D_einj_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%D_einj_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%D_einj_standard = 0.0_rspec
           CALL ncerr_name(2,status,"D_einj_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"D_ffull_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"D_ffull_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%D_ffull_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%D_ffull_standard = 0.0_rspec
           CALL ncerr_name(2,status,"D_ffull_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"D_fhalf_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"D_fhalf_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%D_fhalf_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%D_fhalf_standard = 0.0_rspec
           CALL ncerr_name(2,status,"D_fhalf_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%e0_av)) THEN
     status = nf90_inq_varid(icdf,"e0_av",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"e0_av")
     ELSE
        status = nf90_get_var(icdf,varid,ss%e0_av)
        IF(status.NE.NF90_NOERR) THEN
           ss%e0_av = 0.0_rspec
           CALL ncerr_name(2,status,"e0_av")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"ecrf_src_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ecrf_src_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ecrf_src_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%ecrf_src_name = " "
           CALL ncerr_name(2,status,"ecrf_src_name")
        ELSE
           CALL denull_vec(ss%ecrf_src_name,ss%necrf_src)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     status = nf90_inq_varid(icdf,"EC_Beam_Elongation",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_Beam_Elongation")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_Beam_Elongation)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_Beam_Elongation = 0.0_rspec
           CALL ncerr_name(2,status,"EC_Beam_Elongation")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"EC_Code_Info")
  ELSE
     ilen = len(ss%EC_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%EC_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%EC_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%EC_Code_Info = " "
        CALL ncerr_name(2,status,"EC_Code_Info")
     ELSE
        CALL denull(ss%EC_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EC_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"EC_Data_Info")
  ELSE
     ilen = len(ss%EC_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%EC_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%EC_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%EC_Data_Info = " "
        CALL ncerr_name(2,status,"EC_Data_Info")
     ELSE
        CALL denull(ss%EC_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     status = nf90_inq_varid(icdf,"EC_Half_Power_Angle",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_Half_Power_Angle")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_Half_Power_Angle)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_Half_Power_Angle = 0.0_rspec
           CALL ncerr_name(2,status,"EC_Half_Power_Angle")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_Omode_Fraction)) THEN
     status = nf90_inq_varid(icdf,"EC_Omode_Fraction",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_Omode_Fraction")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_Omode_Fraction)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_Omode_Fraction = 0.0_rspec
           CALL ncerr_name(2,status,"EC_Omode_Fraction")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_phi_aim)) THEN
     status = nf90_inq_varid(icdf,"EC_phi_aim",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_phi_aim")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_phi_aim)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_phi_aim = 0.0_rspec
           CALL ncerr_name(2,status,"EC_phi_aim")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_CURV_HOR",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_PRINC_CURV_HOR")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_PRINC_CURV_HOR)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_PRINC_CURV_HOR = 0.0_rspec
           CALL ncerr_name(2,status,"EC_PRINC_CURV_HOR")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_CURV_VERT",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_PRINC_CURV_VERT")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_PRINC_CURV_VERT)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_PRINC_CURV_VERT = 0.0_rspec
           CALL ncerr_name(2,status,"EC_PRINC_CURV_VERT")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_HOR",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_PRINC_WIDTH_HOR")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_PRINC_WIDTH_HOR)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_PRINC_WIDTH_HOR = 0.0_rspec
           CALL ncerr_name(2,status,"EC_PRINC_WIDTH_HOR")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     status = nf90_inq_varid(icdf,"EC_PRINC_WIDTH_VERT",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_PRINC_WIDTH_VERT")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_PRINC_WIDTH_VERT)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_PRINC_WIDTH_VERT = 0.0_rspec
           CALL ncerr_name(2,status,"EC_PRINC_WIDTH_VERT")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%EC_theta_aim)) THEN
     status = nf90_inq_varid(icdf,"EC_theta_aim",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"EC_theta_aim")
     ELSE
        status = nf90_get_var(icdf,varid,ss%EC_theta_aim)
        IF(status.NE.NF90_NOERR) THEN
           ss%EC_theta_aim = 0.0_rspec
           CALL ncerr_name(2,status,"EC_theta_aim")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ee_mobility_factor)) THEN
     status = nf90_inq_varid(icdf,"ee_mobility_factor",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ee_mobility_factor")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ee_mobility_factor)
        IF(status.NE.NF90_NOERR) THEN
           ss%ee_mobility_factor = 0.0_rspec
           CALL ncerr_name(2,status,"ee_mobility_factor")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Einj_max)) THEN
     status = nf90_inq_varid(icdf,"Einj_max",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Einj_max")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Einj_max)
        IF(status.NE.NF90_NOERR) THEN
           ss%Einj_max = 0.0_rspec
           CALL ncerr_name(2,status,"Einj_max")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Einj_min)) THEN
     status = nf90_inq_varid(icdf,"Einj_min",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Einj_min")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Einj_min)
        IF(status.NE.NF90_NOERR) THEN
           ss%Einj_min = 0.0_rspec
           CALL ncerr_name(2,status,"Einj_min")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eldot",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"eldot")
  ELSE
     status = nf90_get_var(icdf,varid,ss%eldot)
     IF(status.NE.NF90_NOERR) THEN
        ss%eldot = 0.0_rspec
        CALL ncerr_name(2,status,"eldot")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%elong)) THEN
     status = nf90_inq_varid(icdf,"elong",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"elong")
     ELSE
        status = nf90_get_var(icdf,varid,ss%elong)
        IF(status.NE.NF90_NOERR) THEN
           ss%elong = 0.0_rspec
           CALL ncerr_name(2,status,"elong")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_beami)) THEN
     status = nf90_inq_varid(icdf,"eperp_beami",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eperp_beami")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eperp_beami)
        IF(status.NE.NF90_NOERR) THEN
           ss%eperp_beami = 0.0_rspec
           CALL ncerr_name(2,status,"eperp_beami")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_fusi)) THEN
     status = nf90_inq_varid(icdf,"eperp_fusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eperp_fusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eperp_fusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%eperp_fusi = 0.0_rspec
           CALL ncerr_name(2,status,"eperp_fusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_mini)) THEN
     status = nf90_inq_varid(icdf,"eperp_mini",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eperp_mini")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eperp_mini)
        IF(status.NE.NF90_NOERR) THEN
           ss%eperp_mini = 0.0_rspec
           CALL ncerr_name(2,status,"eperp_mini")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eperp_rw)) THEN
     status = nf90_inq_varid(icdf,"eperp_rw",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eperp_rw")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eperp_rw)
        IF(status.NE.NF90_NOERR) THEN
           ss%eperp_rw = 0.0_rspec
           CALL ncerr_name(2,status,"eperp_rw")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_beami)) THEN
     status = nf90_inq_varid(icdf,"epll_beami",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"epll_beami")
     ELSE
        status = nf90_get_var(icdf,varid,ss%epll_beami)
        IF(status.NE.NF90_NOERR) THEN
           ss%epll_beami = 0.0_rspec
           CALL ncerr_name(2,status,"epll_beami")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_fusi)) THEN
     status = nf90_inq_varid(icdf,"epll_fusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"epll_fusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%epll_fusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%epll_fusi = 0.0_rspec
           CALL ncerr_name(2,status,"epll_fusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_mini)) THEN
     status = nf90_inq_varid(icdf,"epll_mini",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"epll_mini")
     ELSE
        status = nf90_get_var(icdf,varid,ss%epll_mini)
        IF(status.NE.NF90_NOERR) THEN
           ss%epll_mini = 0.0_rspec
           CALL ncerr_name(2,status,"epll_mini")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%epll_rw)) THEN
     status = nf90_inq_varid(icdf,"epll_rw",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"epll_rw")
     ELSE
        status = nf90_get_var(icdf,varid,ss%epll_rw)
        IF(status.NE.NF90_NOERR) THEN
           ss%epll_rw = 0.0_rspec
           CALL ncerr_name(2,status,"epll_rw")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Epot)) THEN
     status = nf90_inq_varid(icdf,"Epot",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Epot")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Epot)
        IF(status.NE.NF90_NOERR) THEN
           ss%Epot = 0.0_rspec
           CALL ncerr_name(2,status,"Epot")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"eqdsk_file",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"eqdsk_file")
  ELSE
     status = nf90_get_var(icdf,varid,ss%eqdsk_file)
     IF(status.NE.NF90_NOERR) THEN
        ss%eqdsk_file = " "
        CALL ncerr_name(2,status,"eqdsk_file")
     ELSE
        CALL denull(ss%eqdsk_file)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eqmom_num)) THEN
     status = nf90_inq_varid(icdf,"eqmom_num",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eqmom_num")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eqmom_num)
        IF(status.NE.NF90_NOERR) THEN
           ss%eqmom_num = " "
           CALL ncerr_name(2,status,"eqmom_num")
        ELSE
           CALL denull_vec(ss%eqmom_num,ss%neqmom)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"EQ_Code_Info")
  ELSE
     ilen = len(ss%EQ_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%EQ_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%EQ_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%EQ_Code_Info = " "
        CALL ncerr_name(2,status,"EQ_Code_Info")
     ELSE
        CALL denull(ss%EQ_Code_Info)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"EQ_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"EQ_Data_Info")
  ELSE
     ilen = len(ss%EQ_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%EQ_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%EQ_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%EQ_Data_Info = " "
        CALL ncerr_name(2,status,"EQ_Data_Info")
     ELSE
        CALL denull(ss%EQ_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%eta_parallel)) THEN
     status = nf90_inq_varid(icdf,"eta_parallel",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"eta_parallel")
     ELSE
        status = nf90_get_var(icdf,varid,ss%eta_parallel)
        IF(status.NE.NF90_NOERR) THEN
           ss%eta_parallel = 0.0_rspec
           CALL ncerr_name(2,status,"eta_parallel")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%E_anom)) THEN
     status = nf90_inq_varid(icdf,"E_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"E_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%E_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%E_anom = 0.0_rspec
           CALL ncerr_name(2,status,"E_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%E_anom2)) THEN
     status = nf90_inq_varid(icdf,"E_anom2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"E_anom2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%E_anom2)
        IF(status.NE.NF90_NOERR) THEN
           ss%E_anom2 = 0.0_rspec
           CALL ncerr_name(2,status,"E_anom2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_co)) THEN
     status = nf90_inq_varid(icdf,"fidiff_bpass_co",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_bpass_co")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_bpass_co)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_bpass_co = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_bpass_co")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_bpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"fidiff_bpass_ctr",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_bpass_ctr")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_bpass_ctr)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_bpass_ctr = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_bpass_ctr")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_btrap)) THEN
     status = nf90_inq_varid(icdf,"fidiff_btrap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_btrap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_btrap)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_btrap = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_btrap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_co)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dpass_co",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_dpass_co")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_dpass_co)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_dpass_co = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_dpass_co")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dpass_ctr)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dpass_ctr",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_dpass_ctr")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_dpass_ctr)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_dpass_ctr = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_dpass_ctr")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fidiff_dtrap)) THEN
     status = nf90_inq_varid(icdf,"fidiff_dtrap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fidiff_dtrap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fidiff_dtrap)
        IF(status.NE.NF90_NOERR) THEN
           ss%fidiff_dtrap = 0.0_rspec
           CALL ncerr_name(2,status,"fidiff_dtrap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Fi_depletion)) THEN
     status = nf90_inq_varid(icdf,"Fi_depletion",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Fi_depletion")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Fi_depletion)
        IF(status.NE.NF90_NOERR) THEN
           ss%Fi_depletion = 0.0_rspec
           CALL ncerr_name(2,status,"Fi_depletion")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fracmin)) THEN
     status = nf90_inq_varid(icdf,"fracmin",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fracmin")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fracmin)
        IF(status.NE.NF90_NOERR) THEN
           ss%fracmin = 0.0_rspec
           CALL ncerr_name(2,status,"fracmin")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%fracpslh)) THEN
     status = nf90_inq_varid(icdf,"fracpslh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"fracpslh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%fracpslh)
        IF(status.NE.NF90_NOERR) THEN
           ss%fracpslh = 0.0_rspec
           CALL ncerr_name(2,status,"fracpslh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%frac_full)) THEN
     status = nf90_inq_varid(icdf,"frac_full",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"frac_full")
     ELSE
        status = nf90_get_var(icdf,varid,ss%frac_full)
        IF(status.NE.NF90_NOERR) THEN
           ss%frac_full = 0.0_rspec
           CALL ncerr_name(2,status,"frac_full")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%frac_half)) THEN
     status = nf90_inq_varid(icdf,"frac_half",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"frac_half")
     ELSE
        status = nf90_get_var(icdf,varid,ss%frac_half)
        IF(status.NE.NF90_NOERR) THEN
           ss%frac_half = 0.0_rspec
           CALL ncerr_name(2,status,"frac_half")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_drbm)) THEN
     status = nf90_inq_varid(icdf,"freq_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"freq_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_ec)) THEN
     status = nf90_inq_varid(icdf,"freq_ec",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_ec")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_ec)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_ec = 0.0_rspec
           CALL ncerr_name(2,status,"freq_ec")
        ELSE
           CALL ps_varchk(ss,"freq_ec",icdf,varid,iout)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_glf)) THEN
     status = nf90_inq_varid(icdf,"freq_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_glf = 0.0_rspec
           CALL ncerr_name(2,status,"freq_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_ic)) THEN
     status = nf90_inq_varid(icdf,"freq_ic",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_ic")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_ic)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_ic = 0.0_rspec
           CALL ncerr_name(2,status,"freq_ic")
        ELSE
           CALL ps_varchk(ss,"freq_ic",icdf,varid,iout)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_lh)) THEN
     status = nf90_inq_varid(icdf,"freq_lh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_lh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_lh)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_lh = 0.0_rspec
           CALL ncerr_name(2,status,"freq_lh")
        ELSE
           CALL ps_varchk(ss,"freq_lh",icdf,varid,iout)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_max_tglf)) THEN
     status = nf90_inq_varid(icdf,"freq_max_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_max_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_max_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_max_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"freq_max_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_mmm71)) THEN
     status = nf90_inq_varid(icdf,"freq_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"freq_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_mtm)) THEN
     status = nf90_inq_varid(icdf,"freq_mtm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_mtm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_mtm)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_mtm = 0.0_rspec
           CALL ncerr_name(2,status,"freq_mtm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%freq_tglf)) THEN
     status = nf90_inq_varid(icdf,"freq_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"freq_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%freq_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%freq_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"freq_tglf")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"FUS_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"FUS_Code_Info")
  ELSE
     ilen = len(ss%FUS_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%FUS_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%FUS_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%FUS_Code_Info = " "
        CALL ncerr_name(2,status,"FUS_Code_Info")
     ELSE
        CALL denull(ss%FUS_Code_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gamma_lmhd)) THEN
     status = nf90_inq_varid(icdf,"gamma_lmhd",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gamma_lmhd")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gamma_lmhd)
        IF(status.NE.NF90_NOERR) THEN
           ss%gamma_lmhd = 0.0_rspec
           CALL ncerr_name(2,status,"gamma_lmhd")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gamma_nc)) THEN
     status = nf90_inq_varid(icdf,"gamma_nc",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gamma_nc")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gamma_nc)
        IF(status.NE.NF90_NOERR) THEN
           ss%gamma_nc = 0.0_rspec
           CALL ncerr_name(2,status,"gamma_nc")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gas_atom)) THEN
     status = nf90_inq_varid(icdf,"gas_atom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gas_atom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gas_atom)
        IF(status.NE.NF90_NOERR) THEN
           ss%gas_atom = " "
           CALL ncerr_name(2,status,"gas_atom")
        ELSE
           CALL denull_vec(ss%gas_atom,ss%ngsc0)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"GAS_Code_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"GAS_Code_Info")
  ELSE
     ilen = len(ss%GAS_Code_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%GAS_Code_Info = " "
     status = nf90_get_var(icdf,varid,ss%GAS_Code_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%GAS_Code_Info = " "
        CALL ncerr_name(2,status,"GAS_Code_Info")
     ELSE
        CALL denull(ss%GAS_Code_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gb1)) THEN
     status = nf90_inq_varid(icdf,"gb1",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gb1")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gb1)
        IF(status.NE.NF90_NOERR) THEN
           ss%gb1 = 0.0_rspec
           CALL ncerr_name(2,status,"gb1")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gb2)) THEN
     status = nf90_inq_varid(icdf,"gb2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gb2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gb2)
        IF(status.NE.NF90_NOERR) THEN
           ss%gb2 = 0.0_rspec
           CALL ncerr_name(2,status,"gb2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gb2i)) THEN
     status = nf90_inq_varid(icdf,"gb2i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gb2i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gb2i)
        IF(status.NE.NF90_NOERR) THEN
           ss%gb2i = 0.0_rspec
           CALL ncerr_name(2,status,"gb2i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gbr2)) THEN
     status = nf90_inq_varid(icdf,"gbr2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gbr2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gbr2)
        IF(status.NE.NF90_NOERR) THEN
           ss%gbr2 = 0.0_rspec
           CALL ncerr_name(2,status,"gbr2")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"geometry",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"geometry")
  ELSE
     status = nf90_get_var(icdf,varid,ss%geometry)
     IF(status.NE.NF90_NOERR) THEN
        ss%geometry = " "
        CALL ncerr_name(2,status,"geometry")
     ELSE
        CALL denull(ss%geometry)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Global_label",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Global_label")
  ELSE
     ilen = len(ss%Global_label)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%Global_label = " "
     status = nf90_get_var(icdf,varid,ss%Global_label(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%Global_label = " "
        CALL ncerr_name(2,status,"Global_label")
     ELSE
        CALL denull(ss%Global_label)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gncfb2h)) THEN
     status = nf90_inq_varid(icdf,"gncfb2h",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gncfb2h")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gncfb2h)
        IF(status.NE.NF90_NOERR) THEN
           ss%gncfb2h = 0.0_rspec
           CALL ncerr_name(2,status,"gncfb2h")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gncfh)) THEN
     status = nf90_inq_varid(icdf,"gncfh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gncfh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gncfh)
        IF(status.NE.NF90_NOERR) THEN
           ss%gncfh = 0.0_rspec
           CALL ncerr_name(2,status,"gncfh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr1)) THEN
     status = nf90_inq_varid(icdf,"gr1",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gr1")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gr1)
        IF(status.NE.NF90_NOERR) THEN
           ss%gr1 = 0.0_rspec
           CALL ncerr_name(2,status,"gr1")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2)) THEN
     status = nf90_inq_varid(icdf,"gr2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gr2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gr2)
        IF(status.NE.NF90_NOERR) THEN
           ss%gr2 = 0.0_rspec
           CALL ncerr_name(2,status,"gr2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2i)) THEN
     status = nf90_inq_varid(icdf,"gr2i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gr2i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gr2i)
        IF(status.NE.NF90_NOERR) THEN
           ss%gr2i = 0.0_rspec
           CALL ncerr_name(2,status,"gr2i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr2rho2)) THEN
     status = nf90_inq_varid(icdf,"gr2rho2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gr2rho2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gr2rho2)
        IF(status.NE.NF90_NOERR) THEN
           ss%gr2rho2 = 0.0_rspec
           CALL ncerr_name(2,status,"gr2rho2")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gr3i)) THEN
     status = nf90_inq_varid(icdf,"gr3i",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"gr3i")
     ELSE
        status = nf90_get_var(icdf,varid,ss%gr3i)
        IF(status.NE.NF90_NOERR) THEN
           ss%gr3i = 0.0_rspec
           CALL ncerr_name(2,status,"gr3i")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho1)) THEN
     status = nf90_inq_varid(icdf,"grho1",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grho1")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grho1)
        IF(status.NE.NF90_NOERR) THEN
           ss%grho1 = 0.0_rspec
           CALL ncerr_name(2,status,"grho1")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2)) THEN
     status = nf90_inq_varid(icdf,"grho2",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"grho2")
     ELSE
        status = nf90_get_var(icdf,varid,ss%grho2)
        IF(status.NE.NF90_NOERR) THEN
           ss%grho2 = 0.0_rspec
           CALL ncerr_name(2,status,"grho2")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_2

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_0(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! anom_evar
        w%list_elems(isize) = "anom_evar"
        w%elem_descr(isize) = "anomalous transport energy variation"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nefi_anom)"
        IF(ALLOCATED(ss%anom_evar)) THEN
           IF(ss%hash_codes(ps_phash_anom_evar).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! area
        w%list_elems(isize) = "area"
        w%elem_descr(isize) = "enclosed area"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m^2"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%area)) THEN
           IF(ss%hash_codes(ps_phash_area).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE_00"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! balstab
        w%list_elems(isize) = "balstab"
        w%elem_descr(isize) = "Ballooning/Mercier stability indicator"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_lmhd)"
        IF(ALLOCATED(ss%balstab)) THEN
           IF(ss%hash_codes(ps_phash_balstab).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_bpass_co
        w%list_elems(isize) = "bidiff_bpass_co"
        w%elem_descr(isize) = "beam ion diffusivity: co barely passing orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_bpass_co)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_bpass_co).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_bpass_ctr
        w%list_elems(isize) = "bidiff_bpass_ctr"
        w%elem_descr(isize) = "beam ion diffusivity: ctr barely passing orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_bpass_ctr)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_bpass_ctr).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_btrap
        w%list_elems(isize) = "bidiff_btrap"
        w%elem_descr(isize) = "beam ion diffusivity: barely trapped orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_btrap)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_btrap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dpass_co
        w%list_elems(isize) = "bidiff_dpass_co"
        w%elem_descr(isize) = "beam ion diffusivity: co passing |vpll/v| -> 1"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_dpass_co)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_dpass_co).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dpass_ctr
        w%list_elems(isize) = "bidiff_dpass_ctr"
        w%elem_descr(isize) = "beam ion diffusivity: ctr passing |vpll/v| -> 1"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_dpass_ctr)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_dpass_ctr).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! bidiff_dtrap
        w%list_elems(isize) = "bidiff_dtrap"
        w%elem_descr(isize) = "beam ion diffusivity: deeply trapped orbits"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nefi_anom2,nrho_anom2,nspec_beam)"
        IF(ALLOCATED(ss%bidiff_dtrap)) THEN
           IF(ss%hash_codes(ps_phash_bidiff_dtrap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BphiRZ
        w%list_elems(isize) = "BphiRZ"
        w%elem_descr(isize) = "Toroidal field"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nr,nz)"
        IF(ALLOCATED(ss%BphiRZ)) THEN
           IF(ss%hash_codes(ps_phash_BphiRZ).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BRRZ
        w%list_elems(isize) = "BRRZ"
        w%elem_descr(isize) = "R component of poloidal field"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nr,nz)"
        IF(ALLOCATED(ss%BRRZ)) THEN
           IF(ss%hash_codes(ps_phash_BRRZ).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! BZRZ
        w%list_elems(isize) = "BZRZ"
        w%elem_descr(isize) = "Z component of poloidal field"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nr,nz)"
        IF(ALLOCATED(ss%BZRZ)) THEN
           IF(ss%hash_codes(ps_phash_BZRZ).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! B_surfMax
        w%list_elems(isize) = "B_surfMax"
        w%elem_descr(isize) = "max mod(B) on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%B_surfMax)) THEN
           IF(ss%hash_codes(ps_phash_B_surfMax).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! B_surfMin
        w%list_elems(isize) = "B_surfMin"
        w%elem_descr(isize) = "min mod(B) on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%B_surfMin)) THEN
           IF(ss%hash_codes(ps_phash_B_surfMin).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cdicrf
        w%list_elems(isize) = "cdicrf"
        w%elem_descr(isize) = "ICRF current drive"
        w%component(isize) = "IC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_icrf-1,nicrf_src)"
        IF(ALLOCATED(ss%cdicrf)) THEN
           IF(ss%hash_codes(ps_phash_cdicrf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! cdicrf_nphi
        w%list_elems(isize) = "cdicrf_nphi"
        w%elem_descr(isize) = "ICRF current drive"
        w%component(isize) = "IC"
        w%elem_units(isize) = "A"
        w%c256val(isize) = "(nrho_icrf-1,max_num_nphi,nicrf_src)"
        IF(ALLOCATED(ss%cdicrf_nphi)) THEN
           IF(ss%hash_codes(ps_phash_cdicrf_nphi).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DA"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_anom
        w%list_elems(isize) = "chie_anom"
        w%elem_descr(isize) = "Te-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_anom)) THEN
           IF(ss%hash_codes(ps_phash_chie_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_drbm
        w%list_elems(isize) = "chie_drbm"
        w%elem_descr(isize) = "Te-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_drbm)) THEN
           IF(ss%hash_codes(ps_phash_chie_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_etg
        w%list_elems(isize) = "chie_etg"
        w%elem_descr(isize) = "Te-equation, diffusivity term ETG model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_etg)) THEN
           IF(ss%hash_codes(ps_phash_chie_etg).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_glf
        w%list_elems(isize) = "chie_glf"
        w%elem_descr(isize) = "Te-equation, diffusivity from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_glf)) THEN
           IF(ss%hash_codes(ps_phash_chie_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_gtcneo
        w%list_elems(isize) = "chie_gtcneo"
        w%elem_descr(isize) = "Te-equation, neoclassical diffusivity from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_chie_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_mmm71
        w%list_elems(isize) = "chie_mmm71"
        w%elem_descr(isize) = "Te-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_chie_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_mtm
        w%list_elems(isize) = "chie_mtm"
        w%elem_descr(isize) = "Te-equation, thermal diffusivity term MTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_mtm)) THEN
           IF(ss%hash_codes(ps_phash_chie_mtm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_nclass
        w%list_elems(isize) = "chie_nclass"
        w%elem_descr(isize) = "Te-equation, neoclassical diffusivity from NCLASS model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_nclass)) THEN
           IF(ss%hash_codes(ps_phash_chie_nclass).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_neo
        w%list_elems(isize) = "chie_neo"
        w%elem_descr(isize) = "Te-equation, neoclassical diffusivity from NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_neo)) THEN
           IF(ss%hash_codes(ps_phash_chie_neo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_ntm
        w%list_elems(isize) = "chie_ntm"
        w%elem_descr(isize) = "Te-equation, neoclassical diffusivity from NTM model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_ntm)) THEN
           IF(ss%hash_codes(ps_phash_chie_ntm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_paleo
        w%list_elems(isize) = "chie_paleo"
        w%elem_descr(isize) = "Te-equation, diffusivity term PALEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_paleo)) THEN
           IF(ss%hash_codes(ps_phash_chie_paleo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_tglf
        w%list_elems(isize) = "chie_tglf"
        w%elem_descr(isize) = "Te-equation, diffusivity from TGLF model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_tglf)) THEN
           IF(ss%hash_codes(ps_phash_chie_tglf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_trans
        w%list_elems(isize) = "chie_trans"
        w%elem_descr(isize) = "electron thermal diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho)"
        IF(ALLOCATED(ss%chie_trans)) THEN
           IF(ss%hash_codes(ps_phash_chie_trans).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_transcat
        w%list_elems(isize) = "chie_transcat"
        w%elem_descr(isize) = "Electron energy diffusivity"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho,ntrcat)"
        IF(ALLOCATED(ss%chie_transcat)) THEN
           IF(ss%hash_codes(ps_phash_chie_transcat).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chie_w19
        w%list_elems(isize) = "chie_w19"
        w%elem_descr(isize) = "Te-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chie_w19)) THEN
           IF(ss%hash_codes(ps_phash_chie_w19).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_anom
        w%list_elems(isize) = "chii_anom"
        w%elem_descr(isize) = "Ti-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_anom)) THEN
           IF(ss%hash_codes(ps_phash_chii_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_drbm
        w%list_elems(isize) = "chii_drbm"
        w%elem_descr(isize) = "Ti-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_drbm)) THEN
           IF(ss%hash_codes(ps_phash_chii_drbm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_glf
        w%list_elems(isize) = "chii_glf"
        w%elem_descr(isize) = "Ti-equation, diffusivity from GLF23 model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_glf)) THEN
           IF(ss%hash_codes(ps_phash_chii_glf).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_gtcneo
        w%list_elems(isize) = "chii_gtcneo"
        w%elem_descr(isize) = "Ti-equation, neoclassical diffusivity from GTC_NEO model"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/s"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_gtcneo)) THEN
           IF(ss%hash_codes(ps_phash_chii_gtcneo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! chii_mmm71
        w%list_elems(isize) = "chii_mmm71"
        w%elem_descr(isize) = "Ti-equation, diffusivity term"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^2/sec"
        w%c256val(isize) = "(nrho_anomth)"
        IF(ALLOCATED(ss%chii_mmm71)) THEN
           IF(ss%hash_codes(ps_phash_chii_mmm71).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_0

      program trxpl
c
c  This program, originally just a test driver for the "trread" and
c  "xplasma" libraries, now has a variety of real applictions.
c
c  For reasons of technical convenience, all of the driver code has
c  been moved into the trxpl_work subroutine library-- the main driver
c  routine in that library is "trxpl_master".
c
c  See trxpl_work/trxpl_master.for for more comments.
c    --dmc Jan 2003
c
      implicit NONE
c
      call trxpl_master
c
      stop
      end

module trxplib_ps_options

  implicit NONE
  SAVE

  ! module to hold data options for accessing Plasma State data from
  ! TRANSP archives

  !---------------------------------
  ! path information

  logical :: lmds = .TRUE.  ! .TRUE. to use MDSplus server
  !                         ! ...or .FALSE. to use files

  character*200 :: rpath = ' '   ! path to run:
  !  if(lmds) syntax is <server>:<treename>(<run-ident>)
  !  if(.NOT.lmds) syntax is <directory-path>/<runid> or just <runid>

  character*200 :: opath = ' '   ! directory path for output file data
  !  (blank for current working directory

  character*100 :: ps_file = ' ' ! Plasma State filename

  character*10 :: ps_prefix= ' ' ! prefix for time series PS output

  !---------------------------------
  ! time slice selection information
  real*8 :: tselect = 0.0d0      ! time of interest

  integer :: saw_hint = 0        ! -1: pre-sawtooth; +1: post; 0: no hint
  real*8 :: delta_t = 0.0d0      ! +/- averaging time
  !  time average is over range [tselect-deltat:tselect+deltat] but without
  !  crossing sawtooth event boundary

  !---------------------------------
  ! equilibrium data representation & other options

  integer :: n_theta = 151       ! #poloidal angle pts in flux surfaces

  !  the following will be reset to match data, if the TRANSP run accessed
  !  has free boundary information

  integer :: nR = 101            ! #pts, R axis, (R,Z) overlay grid
  integer :: nZ = 101            ! #pts, Z axis, (R,Z) overlay grid

  integer :: Bccw_hint = 0       ! +1: force B_phi ccw viewed from above;
  !                              ! -1: force B_phi cw viewed from above
  !    leave at zero to use the orientation data saved in the archived run data

  integer :: Jccw_hint = 0       ! +1: force J_phi ccw viewed from above;
  !                              ! -1: force J_phi cw viewed from above
  !    leave at zero to use the orientation data saved in the archived run data

  !---------------------------------
  ! Plasma State options

  logical :: lheavy=.TRUE.   ! .TRUE. to output "heavy-weight" states (incl 2d 
                      ! MHD equilibrium data; .FALSE. to output "light-weight"
                      ! states

  !---------------------------------
  ! DMC Nov 2010
  ! auxilliary machine description files (max 100)
  ! contents are made available in "ps_aux" during trx_gen_state_geq execution
  ! the machine description files are read in trx_init_state_obj --
  ! see trxplib/trx_gen_state.f90

  integer, parameter :: max_naux = 100
  integer :: naux_mdescr = 0
  character*150 aux_mdescr(max_naux)
  !---------------------------------

  ! internal status

  logical :: ready = .FALSE.

  !---------------------------------
  ! internal labeling data

  character*48 :: geqdsk_lbl
  character*20 :: runid

  !-------------------------------------------------------------------------
CONTAINS

  subroutine reset
    ! restore default settings

    lmds = .TRUE.
    rpath = ' '
    opath = ' '
    ps_file = ' '

    tselect = 0.0d0
    saw_hint = 0
    delta_t = 0.0d0

    n_theta = 151
    nR = 101
    nZ = 101
    Bccw_hint = 0
    Jccw_hint = 0

    lheavy = .TRUE.

    ready = .FALSE.

  end subroutine reset

end module trxplib_ps_options

subroutine r8_qksmooth(n,x,f,delta,bc0,bc1,ier)
 
  ! use R8FILTR6 for quick smooth
  ! on output f is smoothed using moving triangular weighting function
  ! convolution; half width of weighting function is delta.
  ! x(1:n) is expected to be strict ascending.
 
  use iso_c_binding, only: fp => c_double
  use physconst_mod, only: ZERO, ONE
  implicit none

  ! Arguments
  integer,  intent(in)    :: n     ! size of x & f
  real(fp), intent(in)    :: x(n)  ! independent coordinate of f(x)
  real(fp), intent(inout) :: f(n)  ! dependent coordinate of f(x) smoothed on output
  real(fp), intent(in)    :: delta ! smoothing parameter, in units of x
                                   ! x-half-width of triangular weighting fcn
                                   ! delta <= 0 ==> no smoothing.
                                   ! delta <= (x(n)-x(1))/4 is enforced.
  real(fp), intent(in)    :: bc0   ! bdy cond at x(1), btw 0 and 1
  real(fp), intent(in)    :: bc1   ! bdy cond at x(n), btw 0 and 1
  integer,  intent(out)   :: ier  ! =0: OK; =1: ERROR

  ! possible errors: x(1:n) not strict ascending; BC not btw 0 and 1.
 
  ! boundary conditions: =0 means endpoint is fixed during smoothing
  !                         (minimal smoothing at endpoint)
  !                      =1 means df/dx -> 0 at endpoint
  !                         (maximal smoothing at endpoint)
  ! separate boundary condition control for each boundary or endpoint.
 
  ! Local variables
  real(fp) :: deltax,epsx,zdum1
  integer :: i,idum1,idum2  
  real(fp), dimension(:), allocatable :: del,eps,fwk

  !----------------------------------
  !  error checking...
 
  ier=0
  if(delta.le.ZERO) then
    return                ! no smoothing
  else if((bc0.lt.ZERO).or.(bc0.gt.ONE)) then
    ier=1
  else if((bc1.lt.ZERO).or.(bc1.gt.ONE)) then
    ier=1
  else
    do i=1,n-1
      if(x(i+1).le.x(i)) ier=1
    enddo
  endif

  if(ier.ne.0) return

  deltax=max(ZERO,min( (x(n)-x(1))/4, delta))
  epsx=max(ONE, 10*maxval(abs(f)))

  allocate(del(n),eps(n),fwk(n))

  fwk=f
  del=deltax
  eps=epsx

  call r8filtr6(x,fwk,f,n,eps,n,eps,0,del, &
       0,ZERO,0,ZERO,bc0,bc1,zdum1,idum1,idum2)
 
  deallocate(del,eps,fwk)

  return
end subroutine r8_qksmooth

C-----------------------------------------------------------------------
C  TDB_EXECSYM -- execute presymmetrization of a profile at a few time pts
C
C  NEW JULY 1991 -- DMC
C   mod dmc May 2005 -- modularization; remove trcom dependency.
C
      SUBROUTINE TDB_EXECSYM(d,
     >     ZDATID,IMAP,ILX,INX,ILF,
     >     ILXSY,INXSY,ILFSY,ILSSY,
     >     IER)
C
      use trdatbuf_obj
      use tdbsub_uts

      IMPLICIT NONE

      type (trdatbuf) :: d

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ilx,inx,ilf,ilxsy,inxsy,ilfsy,ilssy,ier,imap,it1
      integer irbz1,ilt1,int1
      INTEGER iwork,isiz,j,ioff,it,itm1,itt,ix,ia1,ia2,iout,jm1
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zx0,zxmax,ztime,zt1,zt2,zfac2,zfac1,zdata
      real*8 :: zrbz,zr1,zr2
!============
      Character*(*) zdatid
C
C  INPUTS
C    d -- the trdatbuf object being operated on
C
C    IMAP=1 --> INPUT PROFILE VS. NORMALIZED MAJOR RADIUS
C    IMAP=2 --> INPUT PROFILE VS. ECE FREQUENCY IN GHZ
C
C    presymmetrization is now done at all (NTIME2) time points; 
C    use of normalized midplane aspect ratio output grid enables this to be
C    done without prior knowledge of flux surface equilibrium geometry.
C
C    ILX -- ADDRESS OF X AXIS OF INPUT PROFILE DATA
C    INX -- NUMBER OF PTS IN X AXIS OF INPUT PROFILE DATA
C    ILF -- ADDRESS OF INPUT PROFILE DATA ITSELF
C
C  OUTPUTS
C    ILXSY -- ADDRESS OF X AXIS OF DATA AFTER SYMMETRIZATION
C    INXSY -- NUMBER OF PTS OF X AXIS OF SYMMETRIZED DATA
C    ILFSY -- ADDRESS OF THE SYMMETRIZED DATA
C    ILSSY -- THE SHIFT IMPLIED BY THE SYMMETRIZATION OF THIS PROFILE
C      THE DATA ITSELF IS PUT INTO THE COMMON ARRAY DATBUF
C
C    IER = 0 --> NORMAL SUCCESSFUL COMPLETION
C    IER = 1 --> ERROR
C
C----------------------------------
C
C  THIS SUBROUTINE CALLS ESSENTIALLY THE SAME CODE THAT HAS LONG BEEN
C  USED IN TRANSP FOR PRESYMMETRIZATION OF DATA (FORMERLY CALLED FROM
C  SUBROUTINE TR2INI FROM AUXVAL).  THE ONION SKIN ALGORITHM IS ENTERED
C  VIA SUBROUTINE PRESYM.  CODE COMMENTS DESCRIBE DETAILS OF THE
C  ALGORITHM; A DESCRIPTION CAN ALSO BE FOUND IN $ TRANSPHELP under
C  $ TRANSPHELP OPER NAMELIST DATA_SYMM ...
C
C  The interface to PRESYM has been modified slightly.  The internal
C  workspaces WORKBUF(LBX(j)..LBX(j)+NBX(j)-1) are used!  These work
C  areas are set up in TR2INI which is called once in subroutine
C  AUXVAL at the start of a TRANSP run.
C
C----------------------------------
      integer :: itest,nzones,nonlin,lunmsg_tdb
C----------------------------------
C
      IER=0
      IF(ILF.LE.0) RETURN      ! DO NOTHING IF THERE IS NO DATA
C
      nonlin = lunmsg_tdb(0)
C
      if(imap.eq.2) then
         if(d%ldatrbz.eq.0) then
            write(nonlin,*) ' ?TDB_EXECSYM -- external magnetic field'
            write(nonlin,*) '  (R*Bz) vs. time must be provided for'
            write(nonlin,*) '  presymmetrization of ECE Temperature.'
            ier=1
            return
         endif
         !  time vector location and size for RBZ
         ilt1=d%ltime1
         int1=d%ntime1
         irbz1=d%ldatrbz
      endif
C
C  PTR TO WORKSPACE (CF CALLER, MAKSYM.FOR)
C
      IWORK=d%LFREE_W
C
C  SIZE OF X AXIS FOR SYMMETRIZED DATA
      INXSY=INX/2+1
C
C  ALLOCATE SPACE FOR X AXIS OF SYMMETRIZED DATA
      CALL TDB_DATALO(d,INXSY,ILXSY)
C
C  ALLOCATE SPACE FOR THE SYMMETRIZED DATA ITSELF
C  ALLOCATE SPACE FOR THE SYMMETRIZATION IMPLIED SHIFT PROFILE
      ISIZ=INXSY*d%NTIME2
      CALL TDB_DATALO(d,ISIZ,ILFSY)
      CALL TDB_DATALO(d,ISIZ,ILSSY)
C
C  DEFINE NEW X VECTOR OF SYMMETRIZED DATA
C  this will be based on minor radius or midplane aspect ratio -- 0 = mag 
C  axis, 1 = plasma boundary, (R2-R1)/(R2+R1) where R1 and R2 are
C  the inner and outer midplane R intercepts, would be aspect ratio (used
C  for ECE data).
C
      ZX0=0.0_R8
      ZXMAX=1.075_R8
C
      DO 20 J=1,INXSY
        IOFF=J-1
        d%DATBUF(ILXSY+IOFF)=ZX0+((ZXMAX-ZX0)*IOFF)/(INXSY-1)
 20   CONTINUE
C
C  NOW SYMMETRIZE THE DATA PROFILE AT EACH TIME IN THE SYMMETRIZATION
C  TIMEBASE
C
      WRITE(NONLIN,1001) ZDATID
 1001 FORMAT(' %TDB_EXECSYM:  PRESYMMETRIZE THE "',A,'" DATA')
C
      DO 60 IT=1,d%NTIME2
C
C  current time
C
        ITM1=IT-1
        ZTIME=d%DATBUF(d%LTIME2+ITM1)
C
C  get midplane intercepts
C
        zr1=d%datbuf(d%lrmp_bdy1+itm1)
        zr2=d%datbuf(d%lrmp_bdy2+itm1)
C
C  COPY THE ORIG DATA X AXIS-- DO FREQUENCY TO RADIUS MAP AND ORDER
C  REVERSAL IF THIS IS ECE DATA
C
        IF(IMAP.EQ.1) THEN
C  COPY
           d%WORKBUF(iwork:iwork+inx-1)=d%DATBUF(ilx:ilx+inx-1)
        ELSE
C  ECE MAP (get vacuum field)
           call tdbsub_lookup(d%datbuf(ilt1:ilt1+int1-1),int1,ztime,
     >          it1,zfac1)
           zrbz=d%datbuf(irbz1+it1-1)*(ONE-zfac1)+
     >          d%datbuf(irbz1+it1)*zfac1
           CALL TDB_SYMXMAP(d,zr1,zr2,zrbz,ILX,INX,IWORK)
        ENDIF
C
C  COPY THE PROFILE DATA AND STORE; REVERSE ORDER IF THIS IS
C  ECE DATA
C
        DO 40 IX=1,INX
           IA1=ILF+(IX-1)*d%NTIME2+ITM1
           ZDATA=d%DATBUF(IA1)
           IF(IMAP.EQ.1) THEN
              IOUT=d%LBX(1)+IX-1
           ELSE
              IOUT=d%LBX(1)+INX-IX
           ENDIF
           d%WORKBUF(IOUT)=ZDATA
 40     CONTINUE
C
C  PRESYMMETRIZE THE DATA
C
        CALL TDB_PRESYM(d,zr1,zr2,IMAP,IWORK,INX,ILXSY,INXSY)
C
C  SAVE THE RESULTS
C
        DO 50 J=1,INXSY
           JM1=J-1
           IOFF=d%NTIME2*JM1+ITM1
C
C  THE DATA ITSELF
           d%DATBUF(ILFSY+IOFF)=d%WORKBUF(d%LBX(7)+JM1)
C
C  THE CORRESPONDING IMPLIED SHIFT PROFILE
           d%DATBUF(ILSSY+IOFF)=d%WORKBUF(d%LBX(8)+JM1)
 50     CONTINUE
C
 59     CONTINUE
 60   CONTINUE
C
      RETURN
      END

subroutine trx_gtime(ztime,zdelta_t,ierr)
 
  use trx_module
  implicit NONE
 
!
!   return currently set time of interest
!   ierr is set if time of interest has not been set
!
  real*8 ztime             ! time of interest (seconds) (returned)
  real*8 zdelta_t          ! +/- averaging time (seconds) (returned)
  integer ierr             ! completion coee, 0=OK (returned)
!
!-------------------------------
!
  if(itset.eq.0) then
     ztime=0.0
     zdelta_t=0.0
     ierr=1
  else
     ztime=time0
     zdelta_t=delta_t
     ierr=0
  endif
!
  return
end subroutine trx_gtime

subroutine tr_getnl_intvec(zname,intvec,maxval,istat)
!
  use tr_getnl
  implicit NONE
!
!  get a vector of integers corresponding to namelist name "zname"
!
  character*(*), intent(in) :: zname       ! namelist name
  integer, intent(in) :: maxval            ! dimension of results vector
  integer, dimension(maxval), intent(out) :: intvec  ! results vector
  integer, intent(out) :: istat
!
!  on output:
!
! normal returns:
!  istat = 0 -- no values found
!  istat = N, 1.le.N.le.maxval -- N values found, stored in intvec(1:N)
!
! error returns:
!  istat = -1 -- error (e.g. namelist was never read)
!  istat = -N, N.gt.maxval -- N values were found, intvec(1:maxval) set
!          to the first maxval of them, there are too many values to
!          return them all
!
!-------------------------------------
!
  integer i,ierr,iersum,ils
!
  character(32), dimension(maxval) :: svalues
  integer nvalues
!
  integer lunzer,lt
!
!-------------------------------------
!
  call tr_getnl_strvals(zname,svalues,maxval,nvalues,ierr)
!
  if(ierr.ne.0) then
     istat=-1
     return
  endif
!
  if(nvalues.eq.0) then
     istat=0
     return
  endif
!
  iersum=0
  do i=1,min(nvalues,maxval)
     read(svalues(i),'(I32)',iostat=ierr) intvec(i)
     if(ierr.ne.0) then
        lt=lunzer(0)
        write(lt,*) '%tr_getnl_intvec: integer decode error:'
        ils=len_trim(zname)
        write(lt,*) ' namelist item:  ',zname(1:ils),'(',i,')=',svalues(i)
        iersum=iersum+ierr
     endif
  enddo
!
  if(iersum.gt.0) then
     istat=-1
     return
  endif
!
  if(nvalues.gt.maxval) then
     istat=-nvalues
  else
     istat=nvalues
  endif
!
  return
  end

subroutine trxpl_eqmoms(ieq)
 
  implicit NONE
 
  integer,intent(in) :: ieq   ! equilibrium moments select flag:
  !
  !  ieq=1 -- boundary only
  !  ieq=2 -- profiles only
  !  ieq=3 -- both
  !
  !  boundary -- write Fourier moments of boundary
  !    in asymmetric form, but for updown symmetry the R sin moments
  !    and Z cos moments are strictly zero EXCEPT that Z0 is incremented
  !    by the "plasma height" TRANSP variable (ZPLAS).
  !
  !  interior -- write moments profiles in normalized form
  !       Rcm_norm(x) = Rcm(x)/x**m  e.g. for m'th R cos moments profiles.
  !  (this improves the numerical properties of interpolations on these
  !  profiles; and, xplasma deals intelligently with the axial singularity).
  !
  !  use xplasma routines to provide the moments...
  !---------------------------------------------------
 
  include 'trxpl.blk'
 
  !---------------------------------------------------
  integer :: id_rho=0,inrho,idum,inmom,ierr
  logical :: do_eq_bdy,do_eq_prof,isym
  real*8, dimension(:), allocatable :: zrho,zbuf
  real*8 :: plhgt
  character*10 zname,zuns
  !---------------------------------------------------
 
  call eq_ganum('__RHO',id_rho)
  call eq_ngrid(id_rho,inrho)
 
  allocate(zrho(inrho),zbuf(inrho)); zbuf=0
 
  call eq_grid(id_rho,zrho,inrho,idum,ierr)
  if(ierr.ne.0) call errmsg_exit(' ?trxpl: internal error 2.')
 
  call rp_eq_symflag(idum)
  isym = .not.(idum.eq.1)    ! isym=.TRUE. => updown symmetry
  if(isym) then
     call trx_scal('ZPLAS',zname,zuns,plhgt,ierr)
     if(ierr.ne.0) plhgt=0
  else
     plhgt=0
  endif
 
  do_eq_bdy  = (ieq.eq.1).or.(ieq.eq.3)
  do_eq_prof = (ieq.eq.2).or.(ieq.eq.3)
 
  call xmoments_kmom_get(inmom)
 
  if(do_eq_bdy) call getm(inrho,inrho)
  if(do_eq_prof) call getm(1,inrho)
 
  deallocate(zrho,zbuf)
 
  contains
    subroutine getm(i1,i2)
 
      integer :: i1,i2   ! range of pts this call
 
      integer im,inum,inorm
      real*8, dimension(:,:), allocatable :: rc,rs,zc,zs
 
      inum=i2-i1+1
      if(inum.eq.1) then
         inorm=0
      else
         inorm=1
      endif
 
      allocate(rc(0:inmom,i1:i2),rs(0:inmom,i1:i2), &
           zc(0:inmom,i1:i2),zs(0:inmom,i1:i2))
 
      ! 0'th moments
      call eqmom_Rcos(zrho(i1:i2),inum,inorm,0,rc(0,i1:i2),idum)
      if(isym) then
         zc(0,i1:i2)=plhgt
      else
         call eqmom_Zcos(zrho(i1:i2),inum,inorm,0,zc(0,i1:i2),idum)
      endif
 
      ! higher moments
      do im=1,inmom
         call eqmom_Rcos(zrho(i1:i2),inum,inorm,im,rc(im,i1:i2),idum)
         call eqmom_Zsin(zrho(i1:i2),inum,inorm,im,zs(im,i1:i2),idum)
         if(isym) then
            rs(im,i1:i2)=0
            zc(im,i1:i2)=0
         else
            call eqmom_Rsin(zrho(i1:i2),inum,inorm,im,rs(im,i1:i2),idum)
            call eqmom_Zcos(zrho(i1:i2),inum,inorm,im,zc(im,i1:i2),idum)
         endif
      enddo
 
      if(inum.eq.1) then
         call addsc('_R0_B',rc(0,i1))
         call addsc('_Z0_B',zc(0,i1))
         do im=1,inmom
            zname=' '
            if(im.lt.10) write(zname,"('_R',i1,'C_B')") im
            if(im.ge.10) write(zname,"('_R',i2,'C_B')") im
            call addsc(zname,rc(im,i1))
            if(im.lt.10) write(zname,"('_R',i1,'S_B')") im
            if(im.ge.10) write(zname,"('_R',i2,'S_B')") im
            call addsc(zname,rs(im,i1))
            if(im.lt.10) write(zname,"('_Z',i1,'C_B')") im
            if(im.ge.10) write(zname,"('_Z',i2,'C_B')") im
            call addsc(zname,zc(im,i1))
            if(im.lt.10) write(zname,"('_Z',i1,'S_B')") im
            if(im.ge.10) write(zname,"('_Z',i2,'S_B')") im
            call addsc(zname,zs(im,i1))
         enddo
      else
         call addpr('_R0',rc(0,i1:i2))
         call addpr('_Z0',zc(0,i1:i2))
         do im=1,inmom
            zname=' '
            if(im.lt.10) write(zname,"('_R',i1,'C_X')") im
            if(im.ge.10) write(zname,"('_R',i2,'C_X')") im
            call addpr(zname,rc(im,i1:i2))
            if(im.lt.10) write(zname,"('_R',i1,'S_X')") im
            if(im.ge.10) write(zname,"('_R',i2,'S_X')") im
            call addpr(zname,rs(im,i1:i2))
            if(im.lt.10) write(zname,"('_Z',i1,'C_X')") im
            if(im.ge.10) write(zname,"('_Z',i2,'C_X')") im
            call addpr(zname,zc(im,i1:i2))
            if(im.lt.10) write(zname,"('_Z',i1,'S_X')") im
            if(im.ge.10) write(zname,"('_Z',i2,'S_X')") im
            call addpr(zname,zs(im,i1:i2))
         enddo
      endif
 
      deallocate(rc,rs,zc,zs)
    end subroutine getm
 
    subroutine addsc(znamsc,zval)
      character*(*) znamsc   ! scalar name
      real*8 zval            ! value
 
      integer idup,i
 
      idup=0
      do i=1,numsc
         if(znamsc.eq.sclabs(1,i)) then
            idup=i
            exit
         endif
      enddo
 
      if(idup.eq.0) then
         numsc=numsc+1
         sclabs(1,numsc)=znamsc
         sclabs(2,numsc)=' '
         sclabs(3,numsc)='m'
         scvals(numsc)=zval
      endif
 
    end subroutine addsc
 
    subroutine addpr(znampr,zvals)
      character*(*) znampr   ! profile name
      real*8 zvals(*)        ! values
 
      integer idup,i
      real*8 zdum
 
      idup=0
      do i=1,numpro
         if(znampr.eq.prolabs(1,i)) then
            idup=i
            exit
         endif
      enddo
 
      if(idup.eq.0) then
         numpro=numpro+1
         prolabs(1,numpro)=znampr
         prolabs(2,numpro)=' '
         prolabs(3,numpro)='m'
         id_xaxis(numpro)=id_rho
         call eqm_rhofun(2,id_rho,znampr,zvals,0,zdum,0,zdum, &
              id_pros(numpro),ierr)
         if(ierr.ne.0) call errmsg_exit(' ?trxpl: internal error no. 3')
      endif
    end subroutine addpr
 
end subroutine trxpl_eqmoms

C******************** START FILE MOMIND.FOR ; GROUP MOMIND *************
C---------------------------------------------------------------------
C  MOMIND
C   GIVEN THE TIME INDEX RETURN THE INDICES TO: THE 0TH R MOMENT
C     THE 1ST R MOMENT AND THE 1ST Y MOMENT OF THE BDY MOMENTS
C     FOURIER EXPANSION.
C
C   (BACKGROUND)
C     THE PLASMA BDY IS REPRESENTED AS A FOURIER MOMENTS EXPANSION
C   THE TIME DEPENDENT MOMENTS ARE READ BY TRDAT IN 3 UFILES (OR
C   TIME INDEPENDENT BDY MOMENTS SPECIFIED BY NAMELIST).
C     THIS DATA IS INTERPOLATED TO A FIXED TIME GRID COVERING THE
C   ACTUAL TIME OF EXPERIMENT TO BE ANALYZED BY TRANSP.  THE
C   INTERPOLATED DATA IS STORED IN TRANSP COMMON ARRAY DATBUF.
C   TRDAT WRITES OUT AN IMAGE OF THE COMMON BLOCK CONTAINING DATBUF
C   WHICH IS READ BY TRANSP TO MAKE AN ACTUAL RUN
C
C     THIS ROUTINE HELPS LOOK UP THE INTERPOLATED MOMENTS DATA.
C
      SUBROUTINE MOMIND(d, IT,IR0,IR1,IY1)
C
      use trdatbuf_obj
      IMPLICIT NONE
      type (trdatbuf) :: d
C
C  PASSED INPUT-- IT= DESIRED TIME INDEX
C  COMMON INPUT:
C   DATBUF  DATA BUFFER
C     MOMENTS DATA STORED TIME CONTIGUOUS, I.E.
C     0TH MOMENT AT ALL TIMES, THEN 1ST MOMENT AT ALL TIME, ETC.
C   NMOMD  NUMBER OF MOMENTS STORED IN DATBUF
C   NTIME2  NUMBER OF TIME PTS FOR MOMENTS AND 2D DATA IN DATBUF
C   LMOMD  ADDRESS OF FIRST WORD OF MOMENTS DATA IN DATBUF
C
C  PASSED OUTPUT
C   IR0    ADDRESS OF 0TH R MOMENT
C   IR1    ADDRESS OF 1ST R MOMENT
C          (IR1+1 ADDRESS TO 2ND R MOMENT, ...)
C   IY1    ADDRESS OF 1ST R MOMENT
C          (IY1+1 ADDRESS TO 2ND Y MOMENT, ...)
C
C---------------------------------
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER ir0,ir1,iy1,it,itm1
!============
      ITM1=IT-1
C
      IR0=D%LMOMD+ITM1
      IR1=IR0+D%NTIME2
      IY1=IR1+D%NMOMD*D%NTIME2
C
      RETURN
      END
C******************** END FILE MOMIND.FOR ; GROUP MOMIND ***************
! 19jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

subroutine trx_nb_sublist(ss_tr,ss_ref,inum_tr,inb_sublist,ilun,imatch,istat)

  ! compare reference neutral beam machine description to TRANSP description
  ! the TRANSP description is expected (hoped?) to be a subset with matching
  ! order

  use plasma_state_mod
  implicit NONE

  type (plasma_state) :: ss_tr   ! TRANSP state & machine description
  type (plasma_state) :: ss_ref  ! reference machine description

  integer :: inum_tr             ! number of beams, TRANSP machine description
  integer, intent(out) :: inb_sublist(inum_tr)  ! mapping tr -> ref

  integer, intent(in) :: ilun    ! LUN for messages
  integer, intent(out) :: imatch ! =1 if lists are identical, =0 otherwise
  integer, intent(out) :: istat  ! =0 if tr list matches or is ordered subset
                                 ! =1 otherwise

  !-----------------------------------
  ! local:

  integer :: inum_ref,ib_tr,ib_ref
  real*8, parameter :: ztol = 0.5d-3  ! 1/2 mm
  real*8 :: zdiff

  !-----------------------------------

  inb_sublist(:) = 0

  imatch=0
  istat=1

  inum_ref = ss_ref%nbeam

  if(inum_ref.lt.inum_tr) then
     write(ilun,*) ' %trx_nb_sublist: TRANSP machine description #beams = ',inum_tr
     write(ilun,*) '  reference machine description #beams = ',inum_ref
     write(ilun,*) '  TRANSP count exceeds reference count.'
     return
  endif

  !  OK total beam counts are consistent
  istat=0

  ib_ref = 0
  do ib_tr = 1,inum_tr
     do
        ib_ref = ib_ref + 1
        if(ib_ref.gt.inum_ref) then
           istat=1
           inb_sublist(:)=0
           write(ilun,*) ' %trx_nb_sublist: could not match TRANSP beam# ',ib_tr
           write(ilun,*) '  with beam from reference list.'
           exit
        endif

        zdiff = max(abs(ss_tr%sRtcen(ib_tr)-ss_ref%sRtcen(ib_ref)), &
             abs(ss_tr%Lbsctan(ib_tr)-ss_ref%Lbsctan(ib_ref)), &
             abs(ss_tr%Lbscap(ib_tr)-ss_ref%Lbscap(ib_ref)), &
             abs(ss_tr%Zbsc(ib_tr)-ss_ref%Zbsc(ib_ref)), &
             abs(ss_tr%Zbap(ib_tr)-ss_ref%Zbap(ib_ref)) )

        if(zdiff.gt.ztol) cycle

        ! match OK

        inb_sublist(ib_tr) = ib_ref
        exit
     enddo
     if(istat.eq.1) exit
  enddo

  if(istat.eq.0) then
     if(inum_tr.eq.inum_ref) imatch = 1
     if(imatch.eq.1) then
        write(ilun,*) ' %trx_nb_sublist:  TRANSP and reference beam lists match fully.'
     else
        write(ilun,*) ' %trx_nb_sublist:  TRANSP beams sublist is ordered subset of reference list.'
     endif
  endif

end subroutine trx_nb_sublist

logical function tdb_zeff_simple(d,ilev)
  ! return TRUE if Zeff can be had by a simple interpolation
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  integer, intent(out) :: ilev   ! 1: Zeff=f(t); 2: Zeff=f(x,t); 3: other

  if((d%nmzeff.eq.1).or.(d%nmzeff.eq.2)) then
     tdb_zeff_simple=.TRUE.
     ilev = d%nmzeff
  else
     tdb_zeff_simple=.FALSE.
     ilev = 3
  endif

end function tdb_zeff_simple

logical function tdb_imp_single(d,xzimp,aimp)
  ! return TRUE if the TRANSP run has but a single impurity species
  use trdatbuf_obj
  implicit NONE
  type (trdatbuf) :: d
  real*8, intent(out) :: xzimp  ! Z of impurity (0 if time dependent)
  real*8, intent(out) :: aimp   ! A of impurity (0 if time dependent)

  if(d%nmimp.eq.0) then
     tdb_imp_single = .TRUE.
     xzimp = d%datbuf(8)     ! can be zero...
     aimp = d%datbuf(9)      ! can be zero...
  else
     tdb_imp_single = .FALSE.
     xzimp = 0
     aimp = 0
  endif

end function tdb_imp_single

! MOD DMC Apr 2009 -- update namelist variables can also be modified.
!  append construct "[<num>]" to the argument (zname) to specify which
!  namelist update block to change.  If the construct is omitted or
!  matches "[0]", then, edit the main namelist (as before).  If "[1]"
!  edit the instance in the 1st update block, "[2]" to edit the instance
!  in the 2nd update block, etc.

!  for non-updatable quantities the appended construct can still be present
!  but it is ignored; the main namelist value (the only one that exists) is
!  modified.


subroutine splitn_iput_sc(zname,ivalue,ierr)

  ! assign a new value to an INTEGER scalar

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of scalar variable
  integer, intent(in) :: ivalue       ! new value to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ilina,iblock,ilinst,iadst
  character*32 znam32,istr
  !--------------------------------------

  call splitn_bdecode1('splitn_iput_sc',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_iput_sc',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type.ne.'I') then
     write(6,*) '?splitn_iput_sc: not INTEGER: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.ne.0) then
     write(6,*) '?splitn_iput_sc: not a SCALAR: ',trim(znam32)
     ierr=1
  endif
  if(ierr.ne.0) return

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock

  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr
     ilina = varlist(jj)%nlinadr
  else
     ii = nint + (iblock-1)*nint_st + iadst
     ilina = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  intbuf(ii)=ivalue
  if(varlist(jj)%steerable.eq.2) then
     call iset_ucop(intbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
  endif

  istr=' '
  write(istr,'(I16)') ivalue
  call splitn_put_sc_str(ilina,znam32,istr)

end subroutine splitn_iput_sc

subroutine splitn_lput_sc(zname,lvalue,ierr)

  ! assign a new value to an LOGICAL scalar

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of scalar variable
  logical, intent(in) :: lvalue       ! new value to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ilina,iblock,ilinst,iadst
  character*32 znam32
  character*2 lstr
  !--------------------------------------

  call splitn_bdecode1('splitn_lput_sc',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_lput_sc',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type.ne.'L') then
     write(6,*) '?splitn_lput_sc: not LOGICAL: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.ne.0) then
     write(6,*) '?splitn_iput_sc: not a SCALAR: ',trim(znam32)
     ierr=1
  endif
  if(ierr.ne.0) return

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock

  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr
     ilina = varlist(jj)%nlinadr
  else
     ii = nlog + (iblock-1)*nlog_st + iadst
     ilina = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  logbuf(ii)=lvalue
  if(varlist(jj)%steerable.eq.2) then
     call lset_ucop(logbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
  endif

  if(lvalue) then
     lstr='.T'
  else
     lstr='.F'
  endif

  call splitn_put_sc_str(ilina,znam32,lstr)

end subroutine splitn_lput_sc

subroutine splitn_rput_sc(zname,rvalue,ierr)

  ! assign a new REAL value to a REAL or REAL*8 scalar

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of scalar variable
  real, intent(in) :: rvalue          ! new value to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ilina,iblock,ilinst,iadst
  character*32 znam32
  character*20 rstr
  character*1 echar
  real*8 :: dtest
  !--------------------------------------

  call splitn_bdecode1('splitn_rput_sc',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_rput_sc',znam32,jj,ierr)
  if(ierr.ne.0) return

  call splitn_put_notilda('splitn_rput_sc',znam32,ierr)
  if(ierr.ne.0) return

  if((varlist(jj)%type.ne.'R').and.(varlist(jj)%type.ne.'D')) then
     write(6,*) '?splitn_rput_sc: not FLOATING POINT: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.ne.0) then
     write(6,*) '?splitn_iput_sc: not a SCALAR: ',trim(znam32)
     ierr=1
  endif
  if(ierr.ne.0) return

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock

  ilinst = varlist(jj)%nlinadr_st
  iadst  = varlist(jj)%addr_st
  if(varlist(jj)%type.eq.'R') then
     if(iblock.eq.0) then
        ii = varlist(jj)%addr
        ilina = varlist(jj)%nlinadr
     else
        ii = nreal + (iblock-1)*nreal_st + iadst
        ilina = nreal+nint+nlog+nr8+nchv + &
             (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
     endif
     rbuf(ii)=rvalue
     echar='e'

     if(varlist(jj)%steerable.eq.2) then
        call rset_ucop(rbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
     endif
  else
     if(iblock.eq.0) then
        ii = varlist(jj)%addr
        ilina = varlist(jj)%nlinadr
     else
        ii = nr8 + (iblock-1)*nr8_st + iadst
        ilina = nreal+nint+nlog+nr8+nchv + &
             (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
     endif
     dtest=rvalue
     if(varlist(jj)%name.eq.'TINIT') then
        if(dtest.ge.tup(1)) then
           write(6,*) '?splitn_rput_sc: new TINIT value >= update time: ', &
                dtest,tup(1)
           ierr=2
        else
           dbuf(ii)=dtest
           tinit=dtest
        endif
     else
        dbuf(ii)=dtest
     endif
     echar='d'

     if(varlist(jj)%steerable.eq.2) then
        call dset_ucop(dbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
     endif
  endif
  if(ierr.ne.0) return

  rstr=' '
  write(rstr,'(1pe13.6)') rvalue
  call splitn_fput_clean(rstr,echar)
  call splitn_put_sc_str(ilina,znam32,rstr)

end subroutine splitn_rput_sc

subroutine splitn_dput_sc(zname,dvalue,ierr)

  ! assign a new REAL*8 value to a REAL or REAL*8 scalar

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of scalar variable
  real*8, intent(in) :: dvalue        ! new value to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ilina,iblock,ilinst,iadst
  character*32 znam32
  character*20 dstr
  character*1 echar
  !--------------------------------------

  call splitn_bdecode1('splitn_dput_sc',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_dput_sc',znam32,jj,ierr)
  if(ierr.ne.0) return

  call splitn_put_notilda('splitn_dput_sc',znam32,ierr)
  if(ierr.ne.0) return

  if((varlist(jj)%type.ne.'R').and.(varlist(jj)%type.ne.'D')) then
     write(6,*) '?splitn_dput_sc: not FLOATING POINT: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.ne.0) then
     write(6,*) '?splitn_iput_sc: not a SCALAR: ',trim(znam32)
     ierr=1
  endif
  if(ierr.ne.0) return

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock

  iadst  = varlist(jj)%addr_st
  ilinst = varlist(jj)%nlinadr_st
  if(varlist(jj)%type.eq.'R') then
     if(iblock.eq.0) then
        ii = varlist(jj)%addr
        ilina = varlist(jj)%nlinadr
     else
        ii = nreal + (iblock-1)*nreal_st + iadst
        ilina = nreal+nint+nlog+nr8+nchv + &
             (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
     endif
     rbuf(ii)=dvalue
     echar='e'

     if(varlist(jj)%steerable.eq.2) then
        call rset_ucop(rbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
     endif
  else
     if(iblock.eq.0) then
        ii = varlist(jj)%addr
        ilina = varlist(jj)%nlinadr
     else
        ii = nr8 + (iblock-1)*nr8_st + iadst
        ilina = nreal+nint+nlog+nr8+nchv + &
             (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
     endif
     if(varlist(jj)%name.eq.'TINIT') then
        if(dvalue.ge.tup(1)) then
           write(6,*) '?splitn_rput_sc: new TINIT value >= update time: ', &
                dvalue,tup(1)
           ierr=2
        else
           dbuf(ii)=dvalue
           tinit=dvalue
        endif
     else
        dbuf(ii)=dvalue
     endif
     echar='d'

     if(varlist(jj)%steerable.eq.2) then
        call dset_ucop(dbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
     endif
  endif
  if(ierr.ne.0) return

  dstr=' '
  write(dstr,'(1pd19.12)') dvalue
  call splitn_fput_clean(dstr,echar)
  call splitn_put_sc_str(ilina,znam32,dstr)

end subroutine splitn_dput_sc

subroutine splitn_chput_sc(zname,chvalue,ierr)

  ! assign a new value to an CHARACTER*n scalar

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zname  ! name of scalar variable
  character*(*), intent(in) :: chvalue ! new value to assign

  integer, intent(out) :: ierr        ! completion code, 0=OK

  !--------------------------------------
  integer :: jj,ii,ilen,ic,it
  integer :: ilina,iblock,ilinst,iadst
  character*32 znam32
  character*1 zdelim
  !--------------------------------------

  call splitn_bdecode1('splitn_chput_sc',zname,znam32,iblock,ierr)
  if(ierr.ne.0) return

  call splitn_put_chk('splitn_chput_sc',znam32,jj,ierr)
  if(ierr.ne.0) return

  if(varlist(jj)%type(1:1).ne.'C') then
     write(6,*) '?splitn_chput_sc: not CHARACTER: ',trim(znam32)
     ierr=1
  endif

  if(varlist(jj)%rank.ne.0) then
     write(6,*) '?splitn_chput_sc: not a SCALAR: ',trim(znam32)
     ierr=1
  endif

  if(len_trim(chvalue).gt.varlist(jj)%chsize) then
     write(6,*) '?splitn_chput_sc: string value too long: "',trim(chvalue),'"'
     write(6,*) ' ',trim(znam32),' is CHARACTER*',varlist(jj)%chsize
     ierr=1
  endif
  if(ierr.ne.0) return

  if(varlist(jj)%steerable.ne.2) iblock=0
  iblock=max(0,min(nupdate,iblock))
  kupdate = iblock

  iadst  = varlist(jj)%addr_st
  ilinst = varlist(jj)%nlinadr_st
  if(iblock.eq.0) then
     ii = varlist(jj)%addr
     ilina = varlist(jj)%nlinadr
  else
     ii = nchv + (iblock-1)*nchv_st + iadst
     ilina = nreal+nint+nlog+nr8+nchv + &
          (iblock-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + ilinst
  endif

  chbuf(ii)=chvalue
  if(varlist(jj)%steerable.eq.2) then
     call chset_ucop(chbuf,ii,1,iadst,ilinst,kupdate,nupdate_max)
  endif

  zdelim = "'"
  if(index(chvalue,zdelim).gt.0) then
     if(index(chvalue,'"').eq.0) zdelim = '"'
  endif

  chval=' '
  chval(1:1)=zdelim
  it=1

  do ic=1,max(1,len_trim(chvalue))
     it=it+1
     chval(it:it)=chvalue(ic:ic)
     if(chvalue(ic:ic).eq.zdelim) then
        it=it+1
        chval(it:it)=chvalue(ic:ic)
     endif
  enddo

  it=it+1
  chval(it:it)=zdelim

  call splitn_put_sc_str(ilina,znam32,chval)

end subroutine splitn_chput_sc

subroutine splitn_put_chk(subname,zname,jj,ierr)

  ! verify existence of a named item; return its index if found.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: subname   ! name of caller (for error msg)
  character*(*), intent(in) :: zname     ! name of namelist variable 
  integer, intent(out) :: jj             ! index to variable descriptor
  integer, intent(out) :: ierr           ! completion code (0=OK)

  !------------------------------
  integer ivar,imatch
  !------------------------------

  ierr = 1

  if(.not.have_database) then
     write(6,*) '?'//trim(subname)//': no namelist has been read.'
     return
  endif

  ierr = 0

  call iorder(zname,ivar,imatch)
  if(imatch.eq.0) then
     write(6,*) '?'//trim(subname)//': unrecognized name: ',trim(zname)
     ierr = 1
  endif

  if(.not.edit_enabled) then
     write(6,*) '?'//trim(subname)//': namelist edit not enabled.'
     ierr = 1
  endif

  if(ierr.ne.0) then
     jj = 0
  else
     jj = var_order(ivar)
     call splitn_put_edit_mark(0)
  endif

end subroutine splitn_put_chk

subroutine splitn_put_edit_mark(iforce)

  use splitn_module
  implicit NONE

  ! if this is the first change:
  ! insert edit marker @ EOF

  integer, intent(in) :: iforce  ! if =1, force a mark; if =0, chk edit_started

  integer :: icur

  if((.not.edit_started).or.(iforce.eq.1)) then
     edit_started=.TRUE.
     !  add a line marking the edit

     call clear_fields
     lcmt=3
     aline = '  ! '//trim(edit_program)//' ('
     icur = len_trim(aline) + 1
     call sget_user(aline(icur:len(aline)))
     icur = len_trim(aline) + 1
     aline(icur:icur)=','
     icur = icur+2
     call fdate(aline(icur:len(aline)))
     icur = len_trim(aline) + 1
     aline(icur:icur)=')'

     newline = nlines + 1
     call add_nl_line(aline)  ! add to end of file text array
  endif

end subroutine splitn_put_edit_mark

subroutine splitn_put_notilda(subname,zname,ierr)

  character*(*), intent(in) :: subname  ! name of calling subroutine
  character*(*), intent(in) :: zname    ! variable name
  integer, intent(out) :: ierr          ! status code returned, 0=OK

  ierr=0
  if(zname(1:1).eq.'~') then
     write(6,*) ' ?'//trim(subname)//': update of '//trim(zname)
     write(6,*) '  cannot be done with this call.'
     ierr = 1
  endif

end subroutine splitn_put_notilda

subroutine splitn_fput_clean(dstr,echar)

  ! shorten an encoded floating point string
  ! n.nnnnEmm -> nn.nnn where appropriate; drop trailing 0's, etc.

  !  examples:  1.200000E+01 -> 12.0
  !             7.000000E-01 ->  0.7
  !             6.300000E+23 ->  6.3e23

  implicit NONE
  character*(*), intent(inout) :: dstr  ! floating pt no. in string form
  character*1, intent(in) :: echar      ! character to use for exponent symbol

  !--------------------
  character*4 cexp
  integer iexp,ic,ilen,ie1,ie2,iechar,ine,istop,imove
  !--------------------
  ! first find and decode the exponent; substitute "echar"

  ilen=len(dstr)
  ie1=0
  ie2=0
  do ic=ilen,1,-1
     if(ie2.eq.0) then
        if(dstr(ic:ic).ne.' ') then
           ie2=ic
        endif
     else
        if((dstr(ic:ic).eq.'E').or.(dstr(ic:ic).eq.'e').or. &
             (dstr(ic:ic).eq.'D').or.(dstr(ic:ic).eq.'d')) then
           iechar=ic
           ie1=ic+1
           exit
        endif
     endif
  enddo

  cexp=' '
  ine=ie2-ie1+1
  cexp(4-ine+1:4)=dstr(ie1:ie2)
  read(cexp,'(I4)') iexp  ! encode exponent
  dstr(iechar:)=' '       ! delete exponent from string
  !debug    write(6,*) ' iexp = ',iexp,' dstr = ',dstr

  istop=5
  if(iexp.eq.1) istop=6
  if(iexp.eq.2) istop=7
  if(iexp.eq.-1) istop=4

  !  now strip off any trailing zeroes

  imove=iechar
  do ic=iechar-1,istop,-1
     if(dstr(ic:ic).eq.'0') then
        imove=ic
     else
        exit
     endif
  enddo

  dstr(imove:iechar-1)=' '
  if(iexp.eq.-1) then
     do ic=imove-1,4,-1
        dstr(ic+1:ic+1)=dstr(ic:ic)
     enddo
     dstr(4:4)=dstr(2:2)
     dstr(2:2)='0'
  else if(iexp.eq.0) then
     continue
  else if(iexp.eq.1) then
     dstr(3:3)=dstr(4:4)
     dstr(4:4)='.'
  else if(iexp.eq.2) then
     dstr(3:3)=dstr(4:4)
     dstr(4:4)=dstr(5:5)
     dstr(5:5)='.'
  else
     dstr(imove:imove)=echar
     ic=imove+1
     if(iexp.gt.0) then
        if(iexp.lt.10) then
           write(dstr(ic:ic),'(I1)') iexp
        else if(iexp.lt.100) then
           write(dstr(ic:ic+1),'(I2)') iexp
        else
           write(dstr(ic:ic+2),'(I3)') iexp
        endif
     else
        if(iexp.gt.-10) then
           write(dstr(ic:ic+1),'(I2)') iexp
        else if(iexp.gt.-100) then
           write(dstr(ic:ic+2),'(I3)') iexp
        else
           write(dstr(ic:ic+3),'(I4)') iexp
        endif
     endif
  endif

end subroutine splitn_fput_clean

subroutine splitn_put_sc_str(ilina,zname,zvalue)

  ! insert into namelist file text arrays

  use splitn_module
  implicit NONE

  integer, intent(in) :: ilina            ! ptr to line information
  character*(*), intent(in) :: zname      ! variable name
  character*(*), intent(in) :: zvalue     ! assigned value

  !  value could have both leading and trailing blanks; these need
  !  to be removed

  integer iv1,iv2,ic,ilen
  integer in1,in2
  integer ilinp,ilinq
  integer idiff,icmt,isign,ishift

  !-----------------------------------

  in1 = 1   ! name field assumed to be left justified
  in2 = len_trim(zname)

  iv2 = len_trim(zvalue)

  do ic=1,len(zvalue)
     if(zvalue(ic:ic).ne.' ') then
        iv1=ic
        exit
     endif
  enddo

  ! non-blank part is zvalue(iv1:iv2).

  ilen=iv2-iv1+1

  !-----------

  ilinp = ilines(ilina)
  if(ilinp.eq.0) then
     !  new item -- not previously referenced in namelist file text
     isign=1
     call clear_fields
     aline = ' '//zname(in1:in2)//' = '//zvalue(iv1:iv2)

     call get_newline

     lcmt = 0

     nam1 = 2
     nam2 = nam1 + (in2-in1)

     val1 = nam2 + 4
     val2 = val1 + (iv2-iv1)
     
     call add_nl_line(aline)

     ilines(ilina) = newline
     irrange(:,ilina) = 0
     krepeat(ilina) = 0
     ivrange(1,ilina) = val1
     ivrange(2,ilina) = val2

  else
     ilinq = ordl(ilinp)
     isign=1
     if(lenl(ilinq).lt.0) isign=-1
     lcmt=cmtfld(ilinq)
     val1=valfld(1,ilinq)
     val2=valfld(2,ilinq)
     textnl(ilinq)(val1:val2)=' '
     val2=val1+iv2-iv1
     valfld(2,ilinq)=val2

     ivrange(1,ilina)=val1
     ivrange(2,ilina)=val2

     len1=len_trim(textnl(ilinq))
     if((lcmt.eq.0).or.(lcmt.gt.val2+1)) then
        textnl(ilinq)(val1:val2)=zvalue(iv1:iv2)
     else
        idiff = val2+2 - lcmt
        if(len1+idiff.lt.80) then
           !  move comment over to the right
           aline(lcmt+idiff:len1+idiff)=textnl(ilinq)(lcmt:len1)
           textnl(ilinq)(lcmt:)=' '
           textnl(ilinq)(val1:val2)=zvalue(iv1:iv2)
           textnl(ilinq)(lcmt+idiff:len1+idiff)=aline(lcmt+idiff:len1+idiff)
           cmtfld(ilinq)=lcmt+idiff
        else
           !  put comment on next line
           newline = ilinp+1
           aline=' '
           aline(lcmt:len1)=textnl(ilinq)(lcmt:len1)
           textnl(ilinq)(lcmt:)=' '
           textnl(ilinq)(val1:val2)=zvalue(iv1:iv2)
           cmtfld(ilinq)=0
           icmt=lcmt
           call clear_fields
           lcmt=icmt
           call add_nl_line(aline)
        endif
     endif
     lenl(ilinq)=isign*max(1,len_trim(textnl(ilinq)))

  endif
end subroutine splitn_put_sc_str

subroutine splitn_diff(ilun,idiff,ierr)

  ! compare contents of current and previous namelist
  ! write warning messages on unit ILUN (if it is non-zero)
  ! number of variables with differences found returned in IDIFF
  ! number of changed "non-TRDAT-steerable" variables retuned in IERR
  ! IERR = -1 returned if there is no previous namelist

  ! NOTE: this compares the main namelist values only.  Update namelists
  ! are ignored: all variables in update namelists are TRDAT-steerable.

  !  Mods
  !    06Apr2009    jim.conboy@jet.uk    BUGFIX
  !                 idiff is inout
  !                 skip 'lookbehind' if no differences ; label do/enddo 
  !                 ToDo :
  !                        Another arg to control output level
  !                        rank 2 variables - subscripts ??
  !
  !    29Mar2009    jim.conboy@jet.uk [ build date 'Jan 24 04:30:36', JET vn 44
  !                 New - print all differences, if idiff /= 0 on entry
  !                 ( See splitn_comp )
  !
  !    29Mar2009    jim.conboy@jet.uk [ build date 'Jan 24 04:30:36', JET vn 43]
  !                 BUGfix - test only 1st char of type, for character variable
  !

  use splitn_module
  implicit NONE

  integer, intent(in)    :: ILUN  ! i/o channel for warnings, or 0 for "quiet"
  integer, intent(inout) :: IDIFF ! # of changed variables found
  integer, intent(out)   :: IERR  ! # of non-steerable changed variables or...
  !                              -1 if there is no previous namelist to compare

  !-----------------------------------------------
  ! local
  integer, parameter            :: nszmax = 20& ! max diffs /variable to print
                                  ,ncbuf  = 20

  integer                       :: ivar,jj,isize,i,ii,iadd,ilog

  integer                       :: isame        ! last element with same difference
!
  logical                       :: lprt_all     ! .T to print all differences
  !
  character(len=2)              :: csteer       ! flag 'non steerable' parameter
  character(len=8)              :: cix          ! prints range of var index
  !
  character(len=ncbuf),&
           dimension(2,nszmax)  ::  cdbuf       !  list of diffs
  integer, dimension(nszmax)    ::  ixszdf &    !  index of different elements
                                   ,ixszdf2     !  .. ptr for consec diff elems


  !-----------------------------------------------
  ! verify presence of prior namelist for comparison...

  lprt_all = (idiff.ne.0)

  idiff = -1
  ierr = -1
  if(.not.previous) then
     if(ilun.gt.0) then
        write(ilun,*) ' %splitn_diff -- no prior namelist => ierr = -1'
     endif
     return
  endif

  !-----------------------------------------------
  ! prior namelist exists

  idiff = 0
  ierr = 0

  lvar: do ivar = 1,nvars
     jj = var_order(ivar)

     isize=1
     do i=1,varlist(jj)%rank
        isize=isize*(varlist(jj)%dims(2,i)-varlist(jj)%dims(1,i)+1)
     enddo
     ii = varlist(jj)%addr

     iadd = 0  ! count differences, this variable...

     lelem: do i=ii,ii+isize-1

        if(varlist(jj)%type.eq.'I')         then
           if(intbuf(i).ne.intbuf_p(i))  then
              iadd = iadd + 1
              ixszdf(iadd) = 1+i-ii
              write(cdbuf(1,iadd),'(i20)')  intbuf(i)
              write(cdbuf(2,iadd),'(i20)')  intbuf_p(i)
           endif

        else if(varlist(jj)%type.eq.'L')     then
           ilog = 0
           if(logbuf(i)) ilog = ilog + 1
           if(logbuf_p(i)) ilog = ilog + 1
           if(ilog.eq.1)                 then  ! 0 means both F, 2 means both T
              iadd = iadd + 1
              ixszdf(iadd) = 1+i-ii
              write(cdbuf(1,iadd),'(19x,l1)')  logbuf(i)
              write(cdbuf(2,iadd),'(19x,l1)')  logbuf_p(i)
           endif

        else if(varlist(jj)%type.eq.'R')    then
           if(rbuf(i).ne.rbuf_p(i))      then
              iadd = iadd + 1
              ixszdf(iadd) = 1+i-ii
              write(cdbuf(1,iadd),'(f20.6)')  rbuf(i)
              write(cdbuf(2,iadd),'(f20.6)')  rbuf_p(i)
           endif

        else if(varlist(jj)%type.eq.'D')    then
           if(dbuf(i).ne.dbuf_p(i))      then
              iadd = iadd + 1
              ixszdf(iadd) = 1+i-ii
              write(cdbuf(1,iadd),'(1PG20.6)')  dbuf(i)
              write(cdbuf(2,iadd),'(1PG20.6)')  dbuf_p(i)
           endif

        else if(varlist(jj)%type(1:1).eq.'C')       then
!d-        print *, trim(varlist(jj)%name), &
!d-             trim(chbuf(i)), trim(chbuf_p(i))
           if(chbuf(i).ne.chbuf_p(i))     then
              iadd = iadd + 1
              ixszdf(iadd)  = 1+i-ii
              cdbuf(1,iadd)(:ncbuf) = chbuf(i)
              cdbuf(2,iadd)(:ncbuf) = chbuf_p(i)
           endif
!
        endif
        if ( iadd == 0 )                                cycle lelem
!       lookbehind to avoid printing 'same' differences

        if(iadd.gt.0) then
           ixszdf2(iadd) = ixszdf(iadd)
           if( iadd == 1 )                                 then
              isame = 1
           else 
              if(      ixszdf(iadd-1) + 1 == 1+i-ii     &
                   .and. cdbuf(1,iadd) == cdbuf(1,iadd-1) &
                   .and. cdbuf(2,iadd) == cdbuf(2,iadd-1) )  then
                 ixszdf2(isame) = ixszdf(iadd)
              else 
                 isame = iadd
              endif
           endif
        endif
     enddo lelem

     if(iadd.gt.0) then
        ! difference detected...

        idiff = idiff + 1
        if( lprt_all )      then
           if( varlist(jj)%steerable.ne.0 ) then
              csteer = '  '
           else
              csteer = '* '
              ierr = ierr + 1
           endif
           cix = '        '
           if( isize > 1 ) &
                write(cix,'(i3,a2,i3)') ixszdf(1), '..', ixszdf2(1)
           if( ixszdf2(1) == ixszdf(1) )  then
              cix(4:8) = '     '
              isame = 1
           else
              isame = ixszdf2(1)
           endif
!
           write(ilun,'(4x,4a,t35,a,2x,a,t70,a)')  &
                csteer, varlist(jj)%type,'changed ', &
                trim(varlist(jj)%name), cix, cdbuf(1,1),cdbuf(2,1)
           if(iadd .gt. 1 )                           then
              ix: do i=2,iadd
                 if (i <= isame )               cycle ix
                 write(cix,'(i3,a2,i3)') ixszdf(i), '..', ixszdf2(i)
                 if( ixszdf2(i) == ixszdf(i) ) cix(4:8) = '     '
                 isame = ixszdf2(i)
                 write(ilun,'(t35,a,2x,a,t70,a)') &
                      cix, cdbuf(1,i),cdbuf(2,i)
              enddo ix
              write(ilun,*) ' '
           endif
        else
           if( varlist(jj)%steerable.eq.0) then
              ierr = ierr + 1
              write(6,*) &
                   ' %splitn_diff: value change in non-TRDAT-steerable quantity: ',trim(varlist(jj)%name)
           endif
        endif

     endif

  enddo lvar

end subroutine splitn_diff

subroutine trx_genray_in_search(nonlin,ierr)

  ! look for genray template input file; write copy as "genray_ech.template"
  !
  ! if connected to run via MDSplus, try run cache data and then mds_get_inf
  ! if connected via files look for <runid>_genray_ech.in
  !
  ! The above will not succeed if <runid> did not use GENRAY for ECH.  In
  ! this case, copy the file from $LOCAL/tables/nml or $TRANSP_LOCATION...

  use trx_module

  implicit NONE

  integer, intent(in) :: nonlin ! I/O unit for messages
  integer, intent(out) :: ierr  ! completion status, 0=OK

  !-------------------------------
  character*40 :: ztarget
  character*150 :: genray_ech_template
  character*140 :: fdisk,fdir,mds_server,mds_tree
  character*200 :: arch_file,zfile
  character*20 :: runid,tfile
  logical :: ilmds

  integer :: ilun,kmdsplus,istat,imiss,iat,ilen,ier_cache,idum

  ! cache status routines

  logical mds_cache_active,mds_cache_exclusive
  external mds_cache_active,mds_cache_exclusive
  !-------------------------------

  ierr=0

  call find_io_unit(ilun)

  tfile = "genray_ech.template"

  call trread_dd(fdisk,fdir,runid,ilmds,ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' %trx_genray_in_search: run path lookup error.'
     return
  endif

  if(ilmds) then
     write(nonlin,*) ' ...look for GENRAY template in MDS+ run data... '
     imiss=0
     if(mds_cache_active(0)) then
        call mds_cache_fname(0,'GENRAY_ECH.DAT',zfile,ier_cache)
        if(ier_cache.ne.0) then
           if(mds_cache_exclusive(0)) then
              write(nonlin,*) ' ?trx_genray_in_search: namelist not in cache;'
              write(nonlin,*) '  RPLOT_CACHE_ONLY = TRUE -> no MDS+ recovery.'
              ierr=1
              return
           else
              write(nonlin,*) ' %trx_genray_in_search: cache miss, use MDS+.'
              imiss=1  ! normal cache miss
           endif
        else
           write(nonlin,*) ' '
           write(nonlin,*) ' (...attempting copy from MDS+ cache...) '
           call text_copy(trim(zfile),trim(tfile),istat)
           if(istat.ne.0) then
              if(mds_cache_exclusive(0)) then
                 write(nonlin,*) &
                      ' ?trx_genray_in_search: namelist not in cache;'
                 write(nonlin,*) &
                      '  RPLOT_CACHE_ONLY = TRUE -> no MDS+ recovery.'
                 ierr=1
                 return
              else
                 write(nonlin,*) &
                      ' %trx_genray_in_search: OK: cache miss, use MDS+.'
                 imiss=1  ! normal cache miss
              endif
           else
              write(nonlin,*) &
                   ' %trx_genray_in_search: MDS+ archived GENRAY template file was copied.'
              return
           endif
        endif
     endif

     write(nonlin,*) ' ...contact MDS+ server... '
     kmdsplus=2
     iat = index(fdisk,'@')
     ilen = len(trim(fdisk))
     if(iat.le.6) then
        ierr=1
        write(nonlin,*) ' ?trx_genray_in_search: MDS+ path data parse error.'
        write(nonlin,*) '   fdisk: ',trim(fdisk)
        write(nonlin,*) '    fdir: ',trim(fdir)
        return
     endif

     mds_server = fdisk(6:iat-1)
     mds_tree   = fdisk(iat+1:ilen)

  else
     kmdsplus=0
     mds_server=' '
     mds_tree=' '

     write(nonlin,*) ' ...look for GENRAY template namelist in run archive files... '
     arch_file = trim(fdir)//'/'//trim(runid)//'_genray_ech.in'
     open(unit=ilun,file=arch_file,status='old',action='READ',iostat=istat)
     if(istat.ne.0) then
        write(nonlin,*) ' %trx_genray_in_search: GENRAY template not found in archive files (OK).'
        write(nonlin,*) '  A '//trim(tdev)//' standard template will be sought.'
     else
        close(unit=ilun)
        call text_copy(trim(arch_file),trim(tfile),istat)
        if(istat.ne.0) then
           write(nonlin,*) ' ?trx_genray_in_search: archive file copy error.'
        else
           write(nonlin,*) ' %trx_genray_in_search: archived GENRAY template file was copied.'
           return
        endif
     endif
  endif
  
  call splitn_cget('GENRAY_ECH_TEMPLATE',len(genray_ech_template),1, &
       genray_ech_template,ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' %trx_genray_in_search: could not fetch GENRAY_ECH_TEMPLATE namelist variable.'
     return
  endif

  if(genray_ech_template.ne.' ') then
     write(nonlin,*) ' ...TRANSP namelist points at non-default GENRAY template ID: '//trim(genray_ech_template)
  endif

  call copy_gennml_sub(tdev,runid,genray_ech_template, &
       kmdsplus,mds_server,mds_tree, &
       tfile, &
       nonlin,ierr)

  ! insert in CACHE if indicated...

  if(ierr.eq.0) then
     if((kmdsplus.gt.0).AND.(imiss.eq.1)) then
        write(nonlin,*) ' GENRAY template from MDS+ server ... saved in local disk cache... '
        call text_copy(trim(tfile),trim(zfile),idum)
     endif
  endif

end subroutine trx_genray_in_search

subroutine splitn_read(fname,ios)

  !  READ a TRANSP namelist into the splitn_module ...

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: fname     ! filename
  integer, intent(out) :: ios            ! completion status code, 0=OK

  !--------------------------------------

  call read_nl(fname,ios)

end subroutine splitn_read

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_9(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%velte_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_mmm71).AND.ALLOCATED(ss2%velte_mmm71)) THEN
        CALL ps_conformal("velte_mmm71",ss2%velte_mmm71,ss3%velte_mmm71,iout,ierr)
        CALL ps_conformal("velte_mmm71",ss1%velte_mmm71,ss3%velte_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%velte_mmm71 = w1*ss1%velte_mmm71 + (1.0_rspec-w1)*ss2%velte_mmm71
     ELSE IF(ALLOCATED(ss1%velte_mmm71)) THEN
        CALL ps_conformal("velte_mmm71",ss1%velte_mmm71,ss3%velte_mmm71,iout,ierr)
        ss3%velte_mmm71 = ss1%velte_mmm71
     ELSE IF(ALLOCATED(ss2%velte_mmm71)) THEN
        CALL ps_conformal("velte_mmm71",ss2%velte_mmm71,ss3%velte_mmm71,iout,ierr)
        ss3%velte_mmm71 = ss2%velte_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_nclass).AND.ALLOCATED(ss2%velte_nclass)) THEN
        CALL ps_conformal("velte_nclass",ss2%velte_nclass,ss3%velte_nclass,iout,ierr)
        CALL ps_conformal("velte_nclass",ss1%velte_nclass,ss3%velte_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velte_nclass = w1*ss1%velte_nclass + (1.0_rspec-w1)*ss2%velte_nclass
     ELSE IF(ALLOCATED(ss1%velte_nclass)) THEN
        CALL ps_conformal("velte_nclass",ss1%velte_nclass,ss3%velte_nclass,iout,ierr)
        ss3%velte_nclass = ss1%velte_nclass
     ELSE IF(ALLOCATED(ss2%velte_nclass)) THEN
        CALL ps_conformal("velte_nclass",ss2%velte_nclass,ss3%velte_nclass,iout,ierr)
        ss3%velte_nclass = ss2%velte_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_neo).AND.ALLOCATED(ss2%velte_neo)) THEN
        CALL ps_conformal("velte_neo",ss2%velte_neo,ss3%velte_neo,iout,ierr)
        CALL ps_conformal("velte_neo",ss1%velte_neo,ss3%velte_neo,iout,ierr)
        if(ierr.eq.0) ss3%velte_neo = w1*ss1%velte_neo + (1.0_rspec-w1)*ss2%velte_neo
     ELSE IF(ALLOCATED(ss1%velte_neo)) THEN
        CALL ps_conformal("velte_neo",ss1%velte_neo,ss3%velte_neo,iout,ierr)
        ss3%velte_neo = ss1%velte_neo
     ELSE IF(ALLOCATED(ss2%velte_neo)) THEN
        CALL ps_conformal("velte_neo",ss2%velte_neo,ss3%velte_neo,iout,ierr)
        ss3%velte_neo = ss2%velte_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_paleo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_paleo).AND.ALLOCATED(ss2%velte_paleo)) THEN
        CALL ps_conformal("velte_paleo",ss2%velte_paleo,ss3%velte_paleo,iout,ierr)
        CALL ps_conformal("velte_paleo",ss1%velte_paleo,ss3%velte_paleo,iout,ierr)
        if(ierr.eq.0) ss3%velte_paleo = w1*ss1%velte_paleo + (1.0_rspec-w1)*ss2%velte_paleo
     ELSE IF(ALLOCATED(ss1%velte_paleo)) THEN
        CALL ps_conformal("velte_paleo",ss1%velte_paleo,ss3%velte_paleo,iout,ierr)
        ss3%velte_paleo = ss1%velte_paleo
     ELSE IF(ALLOCATED(ss2%velte_paleo)) THEN
        CALL ps_conformal("velte_paleo",ss2%velte_paleo,ss3%velte_paleo,iout,ierr)
        ss3%velte_paleo = ss2%velte_paleo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velte_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velte_tglf).AND.ALLOCATED(ss2%velte_tglf)) THEN
        CALL ps_conformal("velte_tglf",ss2%velte_tglf,ss3%velte_tglf,iout,ierr)
        CALL ps_conformal("velte_tglf",ss1%velte_tglf,ss3%velte_tglf,iout,ierr)
        if(ierr.eq.0) ss3%velte_tglf = w1*ss1%velte_tglf + (1.0_rspec-w1)*ss2%velte_tglf
     ELSE IF(ALLOCATED(ss1%velte_tglf)) THEN
        CALL ps_conformal("velte_tglf",ss1%velte_tglf,ss3%velte_tglf,iout,ierr)
        ss3%velte_tglf = ss1%velte_tglf
     ELSE IF(ALLOCATED(ss2%velte_tglf)) THEN
        CALL ps_conformal("velte_tglf",ss2%velte_tglf,ss3%velte_tglf,iout,ierr)
        ss3%velte_tglf = ss2%velte_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_anom).AND.ALLOCATED(ss2%velti_anom)) THEN
        CALL ps_conformal("velti_anom",ss2%velti_anom,ss3%velti_anom,iout,ierr)
        CALL ps_conformal("velti_anom",ss1%velti_anom,ss3%velti_anom,iout,ierr)
        if(ierr.eq.0) ss3%velti_anom = w1*ss1%velti_anom + (1.0_rspec-w1)*ss2%velti_anom
     ELSE IF(ALLOCATED(ss1%velti_anom)) THEN
        CALL ps_conformal("velti_anom",ss1%velti_anom,ss3%velti_anom,iout,ierr)
        ss3%velti_anom = ss1%velti_anom
     ELSE IF(ALLOCATED(ss2%velti_anom)) THEN
        CALL ps_conformal("velti_anom",ss2%velti_anom,ss3%velti_anom,iout,ierr)
        ss3%velti_anom = ss2%velti_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_glf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_glf).AND.ALLOCATED(ss2%velti_glf)) THEN
        CALL ps_conformal("velti_glf",ss2%velti_glf,ss3%velti_glf,iout,ierr)
        CALL ps_conformal("velti_glf",ss1%velti_glf,ss3%velti_glf,iout,ierr)
        if(ierr.eq.0) ss3%velti_glf = w1*ss1%velti_glf + (1.0_rspec-w1)*ss2%velti_glf
     ELSE IF(ALLOCATED(ss1%velti_glf)) THEN
        CALL ps_conformal("velti_glf",ss1%velti_glf,ss3%velti_glf,iout,ierr)
        ss3%velti_glf = ss1%velti_glf
     ELSE IF(ALLOCATED(ss2%velti_glf)) THEN
        CALL ps_conformal("velti_glf",ss2%velti_glf,ss3%velti_glf,iout,ierr)
        ss3%velti_glf = ss2%velti_glf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_gtcneo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_gtcneo).AND.ALLOCATED(ss2%velti_gtcneo)) THEN
        CALL ps_conformal("velti_gtcneo",ss2%velti_gtcneo,ss3%velti_gtcneo,iout,ierr)
        CALL ps_conformal("velti_gtcneo",ss1%velti_gtcneo,ss3%velti_gtcneo,iout,ierr)
        if(ierr.eq.0) ss3%velti_gtcneo = w1*ss1%velti_gtcneo + (1.0_rspec-w1)*ss2%velti_gtcneo
     ELSE IF(ALLOCATED(ss1%velti_gtcneo)) THEN
        CALL ps_conformal("velti_gtcneo",ss1%velti_gtcneo,ss3%velti_gtcneo,iout,ierr)
        ss3%velti_gtcneo = ss1%velti_gtcneo
     ELSE IF(ALLOCATED(ss2%velti_gtcneo)) THEN
        CALL ps_conformal("velti_gtcneo",ss2%velti_gtcneo,ss3%velti_gtcneo,iout,ierr)
        ss3%velti_gtcneo = ss2%velti_gtcneo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_mmm71)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_mmm71).AND.ALLOCATED(ss2%velti_mmm71)) THEN
        CALL ps_conformal("velti_mmm71",ss2%velti_mmm71,ss3%velti_mmm71,iout,ierr)
        CALL ps_conformal("velti_mmm71",ss1%velti_mmm71,ss3%velti_mmm71,iout,ierr)
        if(ierr.eq.0) ss3%velti_mmm71 = w1*ss1%velti_mmm71 + (1.0_rspec-w1)*ss2%velti_mmm71
     ELSE IF(ALLOCATED(ss1%velti_mmm71)) THEN
        CALL ps_conformal("velti_mmm71",ss1%velti_mmm71,ss3%velti_mmm71,iout,ierr)
        ss3%velti_mmm71 = ss1%velti_mmm71
     ELSE IF(ALLOCATED(ss2%velti_mmm71)) THEN
        CALL ps_conformal("velti_mmm71",ss2%velti_mmm71,ss3%velti_mmm71,iout,ierr)
        ss3%velti_mmm71 = ss2%velti_mmm71
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_nclass)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_nclass).AND.ALLOCATED(ss2%velti_nclass)) THEN
        CALL ps_conformal("velti_nclass",ss2%velti_nclass,ss3%velti_nclass,iout,ierr)
        CALL ps_conformal("velti_nclass",ss1%velti_nclass,ss3%velti_nclass,iout,ierr)
        if(ierr.eq.0) ss3%velti_nclass = w1*ss1%velti_nclass + (1.0_rspec-w1)*ss2%velti_nclass
     ELSE IF(ALLOCATED(ss1%velti_nclass)) THEN
        CALL ps_conformal("velti_nclass",ss1%velti_nclass,ss3%velti_nclass,iout,ierr)
        ss3%velti_nclass = ss1%velti_nclass
     ELSE IF(ALLOCATED(ss2%velti_nclass)) THEN
        CALL ps_conformal("velti_nclass",ss2%velti_nclass,ss3%velti_nclass,iout,ierr)
        ss3%velti_nclass = ss2%velti_nclass
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_neo)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_neo).AND.ALLOCATED(ss2%velti_neo)) THEN
        CALL ps_conformal("velti_neo",ss2%velti_neo,ss3%velti_neo,iout,ierr)
        CALL ps_conformal("velti_neo",ss1%velti_neo,ss3%velti_neo,iout,ierr)
        if(ierr.eq.0) ss3%velti_neo = w1*ss1%velti_neo + (1.0_rspec-w1)*ss2%velti_neo
     ELSE IF(ALLOCATED(ss1%velti_neo)) THEN
        CALL ps_conformal("velti_neo",ss1%velti_neo,ss3%velti_neo,iout,ierr)
        ss3%velti_neo = ss1%velti_neo
     ELSE IF(ALLOCATED(ss2%velti_neo)) THEN
        CALL ps_conformal("velti_neo",ss2%velti_neo,ss3%velti_neo,iout,ierr)
        ss3%velti_neo = ss2%velti_neo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%velti_tglf)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%velti_tglf).AND.ALLOCATED(ss2%velti_tglf)) THEN
        CALL ps_conformal("velti_tglf",ss2%velti_tglf,ss3%velti_tglf,iout,ierr)
        CALL ps_conformal("velti_tglf",ss1%velti_tglf,ss3%velti_tglf,iout,ierr)
        if(ierr.eq.0) ss3%velti_tglf = w1*ss1%velti_tglf + (1.0_rspec-w1)*ss2%velti_tglf
     ELSE IF(ALLOCATED(ss1%velti_tglf)) THEN
        CALL ps_conformal("velti_tglf",ss1%velti_tglf,ss3%velti_tglf,iout,ierr)
        ss3%velti_tglf = ss1%velti_tglf
     ELSE IF(ALLOCATED(ss2%velti_tglf)) THEN
        CALL ps_conformal("velti_tglf",ss2%velti_tglf,ss3%velti_tglf,iout,ierr)
        ss3%velti_tglf = ss2%velti_tglf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vie_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vie_trans).AND.ALLOCATED(ss2%vie_trans)) THEN
        CALL ps_conformal("vie_trans",ss2%vie_trans,ss3%vie_trans,iout,ierr)
        CALL ps_conformal("vie_trans",ss1%vie_trans,ss3%vie_trans,iout,ierr)
        if(ierr.eq.0) ss3%vie_trans = w1*ss1%vie_trans + (1.0_rspec-w1)*ss2%vie_trans
     ELSE IF(ALLOCATED(ss1%vie_trans)) THEN
        CALL ps_conformal("vie_trans",ss1%vie_trans,ss3%vie_trans,iout,ierr)
        ss3%vie_trans = ss1%vie_trans
     ELSE IF(ALLOCATED(ss2%vie_trans)) THEN
        CALL ps_conformal("vie_trans",ss2%vie_trans,ss3%vie_trans,iout,ierr)
        ss3%vie_trans = ss2%vie_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vie_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vie_transcat).AND.ALLOCATED(ss2%vie_transcat)) THEN
        CALL ps_conformal("vie_transcat",ss2%vie_transcat,ss3%vie_transcat,iout,ierr)
        CALL ps_conformal("vie_transcat",ss1%vie_transcat,ss3%vie_transcat,iout,ierr)
        if(ierr.eq.0) ss3%vie_transcat = w1*ss1%vie_transcat + (1.0_rspec-w1)*ss2%vie_transcat
     ELSE IF(ALLOCATED(ss1%vie_transcat)) THEN
        CALL ps_conformal("vie_transcat",ss1%vie_transcat,ss3%vie_transcat,iout,ierr)
        ss3%vie_transcat = ss1%vie_transcat
     ELSE IF(ALLOCATED(ss2%vie_transcat)) THEN
        CALL ps_conformal("vie_transcat",ss2%vie_transcat,ss3%vie_transcat,iout,ierr)
        ss3%vie_transcat = ss2%vie_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vmo_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vmo_trans).AND.ALLOCATED(ss2%vmo_trans)) THEN
        CALL ps_conformal("vmo_trans",ss2%vmo_trans,ss3%vmo_trans,iout,ierr)
        CALL ps_conformal("vmo_trans",ss1%vmo_trans,ss3%vmo_trans,iout,ierr)
        if(ierr.eq.0) ss3%vmo_trans = w1*ss1%vmo_trans + (1.0_rspec-w1)*ss2%vmo_trans
     ELSE IF(ALLOCATED(ss1%vmo_trans)) THEN
        CALL ps_conformal("vmo_trans",ss1%vmo_trans,ss3%vmo_trans,iout,ierr)
        ss3%vmo_trans = ss1%vmo_trans
     ELSE IF(ALLOCATED(ss2%vmo_trans)) THEN
        CALL ps_conformal("vmo_trans",ss2%vmo_trans,ss3%vmo_trans,iout,ierr)
        ss3%vmo_trans = ss2%vmo_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vmo_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vmo_transcat).AND.ALLOCATED(ss2%vmo_transcat)) THEN
        CALL ps_conformal("vmo_transcat",ss2%vmo_transcat,ss3%vmo_transcat,iout,ierr)
        CALL ps_conformal("vmo_transcat",ss1%vmo_transcat,ss3%vmo_transcat,iout,ierr)
        if(ierr.eq.0) ss3%vmo_transcat = w1*ss1%vmo_transcat + (1.0_rspec-w1)*ss2%vmo_transcat
     ELSE IF(ALLOCATED(ss1%vmo_transcat)) THEN
        CALL ps_conformal("vmo_transcat",ss1%vmo_transcat,ss3%vmo_transcat,iout,ierr)
        ss3%vmo_transcat = ss1%vmo_transcat
     ELSE IF(ALLOCATED(ss2%vmo_transcat)) THEN
        CALL ps_conformal("vmo_transcat",ss2%vmo_transcat,ss3%vmo_transcat,iout,ierr)
        ss3%vmo_transcat = ss2%vmo_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vn_trans)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vn_trans).AND.ALLOCATED(ss2%vn_trans)) THEN
        CALL ps_conformal("vn_trans",ss2%vn_trans,ss3%vn_trans,iout,ierr)
        CALL ps_conformal("vn_trans",ss1%vn_trans,ss3%vn_trans,iout,ierr)
        if(ierr.eq.0) ss3%vn_trans = w1*ss1%vn_trans + (1.0_rspec-w1)*ss2%vn_trans
     ELSE IF(ALLOCATED(ss1%vn_trans)) THEN
        CALL ps_conformal("vn_trans",ss1%vn_trans,ss3%vn_trans,iout,ierr)
        ss3%vn_trans = ss1%vn_trans
     ELSE IF(ALLOCATED(ss2%vn_trans)) THEN
        CALL ps_conformal("vn_trans",ss2%vn_trans,ss3%vn_trans,iout,ierr)
        ss3%vn_trans = ss2%vn_trans
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vn_transcat)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vn_transcat).AND.ALLOCATED(ss2%vn_transcat)) THEN
        CALL ps_conformal("vn_transcat",ss2%vn_transcat,ss3%vn_transcat,iout,ierr)
        CALL ps_conformal("vn_transcat",ss1%vn_transcat,ss3%vn_transcat,iout,ierr)
        if(ierr.eq.0) ss3%vn_transcat = w1*ss1%vn_transcat + (1.0_rspec-w1)*ss2%vn_transcat
     ELSE IF(ALLOCATED(ss1%vn_transcat)) THEN
        CALL ps_conformal("vn_transcat",ss1%vn_transcat,ss3%vn_transcat,iout,ierr)
        ss3%vn_transcat = ss1%vn_transcat
     ELSE IF(ALLOCATED(ss2%vn_transcat)) THEN
        CALL ps_conformal("vn_transcat",ss2%vn_transcat,ss3%vn_transcat,iout,ierr)
        ss3%vn_transcat = ss2%vn_transcat
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vol)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%vol).AND.ALLOCATED(ss2%vol)) THEN
        CALL ps_conformal("vol",ss2%vol,ss3%vol,iout,ierr)
        CALL ps_conformal("vol",ss1%vol,ss3%vol,iout,ierr)
        if(ierr.eq.0) ss3%vol = w1*ss1%vol + (1.0_rspec-w1)*ss2%vol
     ELSE IF(ALLOCATED(ss1%vol)) THEN
        CALL ps_conformal("vol",ss1%vol,ss3%vol,iout,ierr)
        ss3%vol = ss1%vol
     ELSE IF(ALLOCATED(ss2%vol)) THEN
        CALL ps_conformal("vol",ss2%vol,ss3%vol,iout,ierr)
        ss3%vol = ss2%vol
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vphi0_av)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%vphi0_av).AND.ALLOCATED(ss2%vphi0_av)) THEN
        CALL ps_conformal("vphi0_av",ss2%vphi0_av,ss3%vphi0_av,iout,ierr)
        CALL ps_conformal("vphi0_av",ss1%vphi0_av,ss3%vphi0_av,iout,ierr)
        if(ierr.eq.0) ss3%vphi0_av = w1*ss1%vphi0_av + (1.0_rspec-w1)*ss2%vphi0_av
     ELSE IF(ALLOCATED(ss1%vphi0_av)) THEN
        CALL ps_conformal("vphi0_av",ss1%vphi0_av,ss3%vphi0_av,iout,ierr)
        ss3%vphi0_av = ss1%vphi0_av
     ELSE IF(ALLOCATED(ss2%vphi0_av)) THEN
        CALL ps_conformal("vphi0_av",ss2%vphi0_av,ss3%vphi0_av,iout,ierr)
        ss3%vphi0_av = ss2%vphi0_av
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("vpol_Data_Info",ss1%vpol_Data_Info,ss2%vpol_Data_Info,icheck,iout,ierr)
     ss3%vpol_Data_Info = ss1%vpol_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%vpol_inmp)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vpol_inmp).AND.ALLOCATED(ss2%vpol_inmp)) THEN
        CALL ps_conformal("vpol_inmp",ss2%vpol_inmp,ss3%vpol_inmp,iout,ierr)
        CALL ps_conformal("vpol_inmp",ss1%vpol_inmp,ss3%vpol_inmp,iout,ierr)
        if(ierr.eq.0) ss3%vpol_inmp = w1*ss1%vpol_inmp + (1.0_rspec-w1)*ss2%vpol_inmp
     ELSE IF(ALLOCATED(ss1%vpol_inmp)) THEN
        CALL ps_conformal("vpol_inmp",ss1%vpol_inmp,ss3%vpol_inmp,iout,ierr)
        ss3%vpol_inmp = ss1%vpol_inmp
     ELSE IF(ALLOCATED(ss2%vpol_inmp)) THEN
        CALL ps_conformal("vpol_inmp",ss2%vpol_inmp,ss3%vpol_inmp,iout,ierr)
        ss3%vpol_inmp = ss2%vpol_inmp
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vpol_is_input)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vpol_is_input).AND.ALLOCATED(ss2%vpol_is_input)) THEN
        CALL ps_diff("vpol_is_input",ss1%vpol_is_input,ss2%vpol_is_input,icheck,iout,ierr)
        CALL ps_conformal("vpol_is_input",ss1%vpol_is_input,ss3%vpol_is_input,iout,ierr)
        if(ierr.eq.0) ss3%vpol_is_input = ss1%vpol_is_input
     ELSE IF(ALLOCATED(ss1%vpol_is_input)) THEN
        CALL ps_conformal("vpol_is_input",ss1%vpol_is_input,ss3%vpol_is_input,iout,ierr)
        ss3%vpol_is_input = ss1%vpol_is_input
     ELSE IF(ALLOCATED(ss2%vpol_is_input)) THEN
        CALL ps_conformal("vpol_is_input",ss2%vpol_is_input,ss3%vpol_is_input,iout,ierr)
        ss3%vpol_is_input = ss2%vpol_is_input
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vpol_omp)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vpol_omp).AND.ALLOCATED(ss2%vpol_omp)) THEN
        CALL ps_conformal("vpol_omp",ss2%vpol_omp,ss3%vpol_omp,iout,ierr)
        CALL ps_conformal("vpol_omp",ss1%vpol_omp,ss3%vpol_omp,iout,ierr)
        if(ierr.eq.0) ss3%vpol_omp = w1*ss1%vpol_omp + (1.0_rspec-w1)*ss2%vpol_omp
     ELSE IF(ALLOCATED(ss1%vpol_omp)) THEN
        CALL ps_conformal("vpol_omp",ss1%vpol_omp,ss3%vpol_omp,iout,ierr)
        ss3%vpol_omp = ss1%vpol_omp
     ELSE IF(ALLOCATED(ss2%vpol_omp)) THEN
        CALL ps_conformal("vpol_omp",ss2%vpol_omp,ss3%vpol_omp,iout,ierr)
        ss3%vpol_omp = ss2%vpol_omp
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%VRep_coil_count)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%VRep_coil_count).AND.ALLOCATED(ss2%VRep_coil_count)) THEN
        CALL ps_diff("VRep_coil_count",ss1%VRep_coil_count,ss2%VRep_coil_count,icheck,iout,ierr)
        CALL ps_conformal("VRep_coil_count",ss1%VRep_coil_count,ss3%VRep_coil_count,iout,ierr)
        if(ierr.eq.0) ss3%VRep_coil_count = ss1%VRep_coil_count
     ELSE IF(ALLOCATED(ss1%VRep_coil_count)) THEN
        CALL ps_conformal("VRep_coil_count",ss1%VRep_coil_count,ss3%VRep_coil_count,iout,ierr)
        ss3%VRep_coil_count = ss1%VRep_coil_count
     ELSE IF(ALLOCATED(ss2%VRep_coil_count)) THEN
        CALL ps_conformal("VRep_coil_count",ss2%VRep_coil_count,ss3%VRep_coil_count,iout,ierr)
        ss3%VRep_coil_count = ss2%VRep_coil_count
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Vrep_coil_spacing)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Vrep_coil_spacing).AND.ALLOCATED(ss2%Vrep_coil_spacing)) THEN
        CALL ps_diff("Vrep_coil_spacing",ss1%Vrep_coil_spacing,ss2%Vrep_coil_spacing,icheck,iout,ierr)
        CALL ps_conformal("Vrep_coil_spacing",ss1%Vrep_coil_spacing,ss3%Vrep_coil_spacing,iout,ierr)
        if(ierr.eq.0) ss3%Vrep_coil_spacing = ss1%Vrep_coil_spacing
     ELSE IF(ALLOCATED(ss1%Vrep_coil_spacing)) THEN
        CALL ps_conformal("Vrep_coil_spacing",ss1%Vrep_coil_spacing,ss3%Vrep_coil_spacing,iout,ierr)
        ss3%Vrep_coil_spacing = ss1%Vrep_coil_spacing
     ELSE IF(ALLOCATED(ss2%Vrep_coil_spacing)) THEN
        CALL ps_conformal("Vrep_coil_spacing",ss2%Vrep_coil_spacing,ss3%Vrep_coil_spacing,iout,ierr)
        ss3%Vrep_coil_spacing = ss2%Vrep_coil_spacing
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Vsize_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Vsize_coil).AND.ALLOCATED(ss2%Vsize_coil)) THEN
        CALL ps_diff("Vsize_coil",ss1%Vsize_coil,ss2%Vsize_coil,icheck,iout,ierr)
        CALL ps_conformal("Vsize_coil",ss1%Vsize_coil,ss3%Vsize_coil,iout,ierr)
        if(ierr.eq.0) ss3%Vsize_coil = ss1%Vsize_coil
     ELSE IF(ALLOCATED(ss1%Vsize_coil)) THEN
        CALL ps_conformal("Vsize_coil",ss1%Vsize_coil,ss3%Vsize_coil,iout,ierr)
        ss3%Vsize_coil = ss1%Vsize_coil
     ELSE IF(ALLOCATED(ss2%Vsize_coil)) THEN
        CALL ps_conformal("Vsize_coil",ss2%Vsize_coil,ss3%Vsize_coil,iout,ierr)
        ss3%Vsize_coil = ss2%Vsize_coil
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%vsur = w1*ss1%vsur + (1.0_rspec-w1)*ss2%vsur
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("VSUR_Data_Info",ss1%VSUR_Data_Info,ss2%VSUR_Data_Info,icheck,iout,ierr)
     ss3%VSUR_Data_Info = ss1%VSUR_Data_Info
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("vtor_Data_Info",ss1%vtor_Data_Info,ss2%vtor_Data_Info,icheck,iout,ierr)
     ss3%vtor_Data_Info = ss1%vtor_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%vtor_inmp)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vtor_inmp).AND.ALLOCATED(ss2%vtor_inmp)) THEN
        CALL ps_conformal("vtor_inmp",ss2%vtor_inmp,ss3%vtor_inmp,iout,ierr)
        CALL ps_conformal("vtor_inmp",ss1%vtor_inmp,ss3%vtor_inmp,iout,ierr)
        if(ierr.eq.0) ss3%vtor_inmp = w1*ss1%vtor_inmp + (1.0_rspec-w1)*ss2%vtor_inmp
     ELSE IF(ALLOCATED(ss1%vtor_inmp)) THEN
        CALL ps_conformal("vtor_inmp",ss1%vtor_inmp,ss3%vtor_inmp,iout,ierr)
        ss3%vtor_inmp = ss1%vtor_inmp
     ELSE IF(ALLOCATED(ss2%vtor_inmp)) THEN
        CALL ps_conformal("vtor_inmp",ss2%vtor_inmp,ss3%vtor_inmp,iout,ierr)
        ss3%vtor_inmp = ss2%vtor_inmp
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vtor_is_input)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vtor_is_input).AND.ALLOCATED(ss2%vtor_is_input)) THEN
        CALL ps_diff("vtor_is_input",ss1%vtor_is_input,ss2%vtor_is_input,icheck,iout,ierr)
        CALL ps_conformal("vtor_is_input",ss1%vtor_is_input,ss3%vtor_is_input,iout,ierr)
        if(ierr.eq.0) ss3%vtor_is_input = ss1%vtor_is_input
     ELSE IF(ALLOCATED(ss1%vtor_is_input)) THEN
        CALL ps_conformal("vtor_is_input",ss1%vtor_is_input,ss3%vtor_is_input,iout,ierr)
        ss3%vtor_is_input = ss1%vtor_is_input
     ELSE IF(ALLOCATED(ss2%vtor_is_input)) THEN
        CALL ps_conformal("vtor_is_input",ss2%vtor_is_input,ss3%vtor_is_input,iout,ierr)
        ss3%vtor_is_input = ss2%vtor_is_input
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%vtor_omp)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%vtor_omp).AND.ALLOCATED(ss2%vtor_omp)) THEN
        CALL ps_conformal("vtor_omp",ss2%vtor_omp,ss3%vtor_omp,iout,ierr)
        CALL ps_conformal("vtor_omp",ss1%vtor_omp,ss3%vtor_omp,iout,ierr)
        if(ierr.eq.0) ss3%vtor_omp = w1*ss1%vtor_omp + (1.0_rspec-w1)*ss2%vtor_omp
     ELSE IF(ALLOCATED(ss1%vtor_omp)) THEN
        CALL ps_conformal("vtor_omp",ss1%vtor_omp,ss3%vtor_omp,iout,ierr)
        ss3%vtor_omp = ss1%vtor_omp
     ELSE IF(ALLOCATED(ss2%vtor_omp)) THEN
        CALL ps_conformal("vtor_omp",ss2%vtor_omp,ss3%vtor_omp,iout,ierr)
        ss3%vtor_omp = ss2%vtor_omp
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%V_loop)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%V_loop).AND.ALLOCATED(ss2%V_loop)) THEN
        CALL ps_conformal("V_loop",ss2%V_loop,ss3%V_loop,iout,ierr)
        CALL ps_conformal("V_loop",ss1%V_loop,ss3%V_loop,iout,ierr)
        if(ierr.eq.0) ss3%V_loop = w1*ss1%V_loop + (1.0_rspec-w1)*ss2%V_loop
     ELSE IF(ALLOCATED(ss1%V_loop)) THEN
        CALL ps_conformal("V_loop",ss1%V_loop,ss3%V_loop,iout,ierr)
        ss3%V_loop = ss1%V_loop
     ELSE IF(ALLOCATED(ss2%V_loop)) THEN
        CALL ps_conformal("V_loop",ss2%V_loop,ss3%V_loop,iout,ierr)
        ss3%V_loop = ss2%V_loop
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%v_pars)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%v_pars).AND.ALLOCATED(ss2%v_pars)) THEN
        CALL ps_conformal("v_pars",ss2%v_pars,ss3%v_pars,iout,ierr)
        CALL ps_conformal("v_pars",ss1%v_pars,ss3%v_pars,iout,ierr)
        if(ierr.eq.0) ss3%v_pars = w1*ss1%v_pars + (1.0_rspec-w1)*ss2%v_pars
     ELSE IF(ALLOCATED(ss1%v_pars)) THEN
        CALL ps_conformal("v_pars",ss1%v_pars,ss3%v_pars,iout,ierr)
        ss3%v_pars = ss1%v_pars
     ELSE IF(ALLOCATED(ss2%v_pars)) THEN
        CALL ps_conformal("v_pars",ss2%v_pars,ss3%v_pars,iout,ierr)
        ss3%v_pars = ss2%v_pars
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%v_pers)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%v_pers).AND.ALLOCATED(ss2%v_pers)) THEN
        CALL ps_conformal("v_pers",ss2%v_pers,ss3%v_pers,iout,ierr)
        CALL ps_conformal("v_pers",ss1%v_pers,ss3%v_pers,iout,ierr)
        if(ierr.eq.0) ss3%v_pers = w1*ss1%v_pers + (1.0_rspec-w1)*ss2%v_pers
     ELSE IF(ALLOCATED(ss1%v_pers)) THEN
        CALL ps_conformal("v_pers",ss1%v_pers,ss3%v_pers,iout,ierr)
        ss3%v_pers = ss1%v_pers
     ELSE IF(ALLOCATED(ss2%v_pers)) THEN
        CALL ps_conformal("v_pers",ss2%v_pers,ss3%v_pers,iout,ierr)
        ss3%v_pers = ss2%v_pers
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%wt_nphi)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%wt_nphi).AND.ALLOCATED(ss2%wt_nphi)) THEN
        CALL ps_diff("wt_nphi",ss1%wt_nphi,ss2%wt_nphi,icheck,iout,ierr)
        CALL ps_conformal("wt_nphi",ss1%wt_nphi,ss3%wt_nphi,iout,ierr)
        if(ierr.eq.0) ss3%wt_nphi = ss1%wt_nphi
     ELSE IF(ALLOCATED(ss1%wt_nphi)) THEN
        CALL ps_conformal("wt_nphi",ss1%wt_nphi,ss3%wt_nphi,iout,ierr)
        ss3%wt_nphi = ss1%wt_nphi
     ELSE IF(ALLOCATED(ss2%wt_nphi)) THEN
        CALL ps_conformal("wt_nphi",ss2%wt_nphi,ss3%wt_nphi,iout,ierr)
        ss3%wt_nphi = ss2%wt_nphi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%wt_nphi_abs)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%wt_nphi_abs).AND.ALLOCATED(ss2%wt_nphi_abs)) THEN
        CALL ps_conformal("wt_nphi_abs",ss2%wt_nphi_abs,ss3%wt_nphi_abs,iout,ierr)
        CALL ps_conformal("wt_nphi_abs",ss1%wt_nphi_abs,ss3%wt_nphi_abs,iout,ierr)
        if(ierr.eq.0) ss3%wt_nphi_abs = w1*ss1%wt_nphi_abs + (1.0_rspec-w1)*ss2%wt_nphi_abs
     ELSE IF(ALLOCATED(ss1%wt_nphi_abs)) THEN
        CALL ps_conformal("wt_nphi_abs",ss1%wt_nphi_abs,ss3%wt_nphi_abs,iout,ierr)
        ss3%wt_nphi_abs = ss1%wt_nphi_abs
     ELSE IF(ALLOCATED(ss2%wt_nphi_abs)) THEN
        CALL ps_conformal("wt_nphi_abs",ss2%wt_nphi_abs,ss3%wt_nphi_abs,iout,ierr)
        ss3%wt_nphi_abs = ss2%wt_nphi_abs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%wt_nphi_ext)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%wt_nphi_ext).AND.ALLOCATED(ss2%wt_nphi_ext)) THEN
        CALL ps_conformal("wt_nphi_ext",ss2%wt_nphi_ext,ss3%wt_nphi_ext,iout,ierr)
        CALL ps_conformal("wt_nphi_ext",ss1%wt_nphi_ext,ss3%wt_nphi_ext,iout,ierr)
        if(ierr.eq.0) ss3%wt_nphi_ext = w1*ss1%wt_nphi_ext + (1.0_rspec-w1)*ss2%wt_nphi_ext
     ELSE IF(ALLOCATED(ss1%wt_nphi_ext)) THEN
        CALL ps_conformal("wt_nphi_ext",ss1%wt_nphi_ext,ss3%wt_nphi_ext,iout,ierr)
        ss3%wt_nphi_ext = ss1%wt_nphi_ext
     ELSE IF(ALLOCATED(ss2%wt_nphi_ext)) THEN
        CALL ps_conformal("wt_nphi_ext",ss2%wt_nphi_ext,ss3%wt_nphi_ext,iout,ierr)
        ss3%wt_nphi_ext = ss2%wt_nphi_ext
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xRjcos_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%xRjcos_momeq).AND.ALLOCATED(ss2%xRjcos_momeq)) THEN
        CALL ps_conformal("xRjcos_momeq",ss2%xRjcos_momeq,ss3%xRjcos_momeq,iout,ierr)
        CALL ps_conformal("xRjcos_momeq",ss1%xRjcos_momeq,ss3%xRjcos_momeq,iout,ierr)
        if(ierr.eq.0) ss3%xRjcos_momeq = w1*ss1%xRjcos_momeq + (1.0_rspec-w1)*ss2%xRjcos_momeq
     ELSE IF(ALLOCATED(ss1%xRjcos_momeq)) THEN
        CALL ps_conformal("xRjcos_momeq",ss1%xRjcos_momeq,ss3%xRjcos_momeq,iout,ierr)
        ss3%xRjcos_momeq = ss1%xRjcos_momeq
     ELSE IF(ALLOCATED(ss2%xRjcos_momeq)) THEN
        CALL ps_conformal("xRjcos_momeq",ss2%xRjcos_momeq,ss3%xRjcos_momeq,iout,ierr)
        ss3%xRjcos_momeq = ss2%xRjcos_momeq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xRjsin_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%xRjsin_momeq).AND.ALLOCATED(ss2%xRjsin_momeq)) THEN
        CALL ps_conformal("xRjsin_momeq",ss2%xRjsin_momeq,ss3%xRjsin_momeq,iout,ierr)
        CALL ps_conformal("xRjsin_momeq",ss1%xRjsin_momeq,ss3%xRjsin_momeq,iout,ierr)
        if(ierr.eq.0) ss3%xRjsin_momeq = w1*ss1%xRjsin_momeq + (1.0_rspec-w1)*ss2%xRjsin_momeq
     ELSE IF(ALLOCATED(ss1%xRjsin_momeq)) THEN
        CALL ps_conformal("xRjsin_momeq",ss1%xRjsin_momeq,ss3%xRjsin_momeq,iout,ierr)
        ss3%xRjsin_momeq = ss1%xRjsin_momeq
     ELSE IF(ALLOCATED(ss2%xRjsin_momeq)) THEN
        CALL ps_conformal("xRjsin_momeq",ss2%xRjsin_momeq,ss3%xRjsin_momeq,iout,ierr)
        ss3%xRjsin_momeq = ss2%xRjsin_momeq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xs)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%xs).AND.ALLOCATED(ss2%xs)) THEN
        CALL ps_conformal("xs",ss2%xs,ss3%xs,iout,ierr)
        CALL ps_conformal("xs",ss1%xs,ss3%xs,iout,ierr)
        if(ierr.eq.0) ss3%xs = w1*ss1%xs + (1.0_rspec-w1)*ss2%xs
     ELSE IF(ALLOCATED(ss1%xs)) THEN
        CALL ps_conformal("xs",ss1%xs,ss3%xs,iout,ierr)
        ss3%xs = ss1%xs
     ELSE IF(ALLOCATED(ss2%xs)) THEN
        CALL ps_conformal("xs",ss2%xs,ss3%xs,iout,ierr)
        ss3%xs = ss2%xs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xs_name)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%xs_name).AND.ALLOCATED(ss2%xs_name)) THEN
        CALL ps_diff("xs_name",ss1%xs_name,ss2%xs_name,icheck,iout,ierr)
        CALL ps_conformal("xs_name",ss1%xs_name,ss3%xs_name,iout,ierr)
        if(ierr.eq.0) ss3%xs_name = ss1%xs_name
     ELSE IF(ALLOCATED(ss1%xs_name)) THEN
        CALL ps_conformal("xs_name",ss1%xs_name,ss3%xs_name,iout,ierr)
        ss3%xs_name = ss1%xs_name
     ELSE IF(ALLOCATED(ss2%xs_name)) THEN
        CALL ps_conformal("xs_name",ss2%xs_name,ss3%xs_name,iout,ierr)
        ss3%xs_name = ss2%xs_name
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xZjcos_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%xZjcos_momeq).AND.ALLOCATED(ss2%xZjcos_momeq)) THEN
        CALL ps_conformal("xZjcos_momeq",ss2%xZjcos_momeq,ss3%xZjcos_momeq,iout,ierr)
        CALL ps_conformal("xZjcos_momeq",ss1%xZjcos_momeq,ss3%xZjcos_momeq,iout,ierr)
        if(ierr.eq.0) ss3%xZjcos_momeq = w1*ss1%xZjcos_momeq + (1.0_rspec-w1)*ss2%xZjcos_momeq
     ELSE IF(ALLOCATED(ss1%xZjcos_momeq)) THEN
        CALL ps_conformal("xZjcos_momeq",ss1%xZjcos_momeq,ss3%xZjcos_momeq,iout,ierr)
        ss3%xZjcos_momeq = ss1%xZjcos_momeq
     ELSE IF(ALLOCATED(ss2%xZjcos_momeq)) THEN
        CALL ps_conformal("xZjcos_momeq",ss2%xZjcos_momeq,ss3%xZjcos_momeq,iout,ierr)
        ss3%xZjcos_momeq = ss2%xZjcos_momeq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%xZjsin_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%xZjsin_momeq).AND.ALLOCATED(ss2%xZjsin_momeq)) THEN
        CALL ps_conformal("xZjsin_momeq",ss2%xZjsin_momeq,ss3%xZjsin_momeq,iout,ierr)
        CALL ps_conformal("xZjsin_momeq",ss1%xZjsin_momeq,ss3%xZjsin_momeq,iout,ierr)
        if(ierr.eq.0) ss3%xZjsin_momeq = w1*ss1%xZjsin_momeq + (1.0_rspec-w1)*ss2%xZjsin_momeq
     ELSE IF(ALLOCATED(ss1%xZjsin_momeq)) THEN
        CALL ps_conformal("xZjsin_momeq",ss1%xZjsin_momeq,ss3%xZjsin_momeq,iout,ierr)
        ss3%xZjsin_momeq = ss1%xZjsin_momeq
     ELSE IF(ALLOCATED(ss2%xZjsin_momeq)) THEN
        CALL ps_conformal("xZjsin_momeq",ss2%xZjsin_momeq,ss3%xZjsin_momeq,iout,ierr)
        ss3%xZjsin_momeq = ss2%xZjsin_momeq
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("Z0max",ss1%Z0max,ss2%Z0max,icheck,iout,ierr)
     ss3%Z0max = ss1%Z0max
  ENDIF

  IF((ALLOCATED(ss3%Z0_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z0_momeq).AND.ALLOCATED(ss2%Z0_momeq)) THEN
        CALL ps_conformal("Z0_momeq",ss2%Z0_momeq,ss3%Z0_momeq,iout,ierr)
        CALL ps_conformal("Z0_momeq",ss1%Z0_momeq,ss3%Z0_momeq,iout,ierr)
        if(ierr.eq.0) ss3%Z0_momeq = w1*ss1%Z0_momeq + (1.0_rspec-w1)*ss2%Z0_momeq
     ELSE IF(ALLOCATED(ss1%Z0_momeq)) THEN
        CALL ps_conformal("Z0_momeq",ss1%Z0_momeq,ss3%Z0_momeq,iout,ierr)
        ss3%Z0_momeq = ss1%Z0_momeq
     ELSE IF(ALLOCATED(ss2%Z0_momeq)) THEN
        CALL ps_conformal("Z0_momeq",ss2%Z0_momeq,ss3%Z0_momeq,iout,ierr)
        ss3%Z0_momeq = ss2%Z0_momeq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Zbap)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zbap).AND.ALLOCATED(ss2%Zbap)) THEN
        CALL ps_diff("Zbap",ss1%Zbap,ss2%Zbap,icheck,iout,ierr)
        CALL ps_conformal("Zbap",ss1%Zbap,ss3%Zbap,iout,ierr)
        if(ierr.eq.0) ss3%Zbap = ss1%Zbap
     ELSE IF(ALLOCATED(ss1%Zbap)) THEN
        CALL ps_conformal("Zbap",ss1%Zbap,ss3%Zbap,iout,ierr)
        ss3%Zbap = ss1%Zbap
     ELSE IF(ALLOCATED(ss2%Zbap)) THEN
        CALL ps_conformal("Zbap",ss2%Zbap,ss3%Zbap,iout,ierr)
        ss3%Zbap = ss2%Zbap
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Zbsc)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zbsc).AND.ALLOCATED(ss2%Zbsc)) THEN
        CALL ps_diff("Zbsc",ss1%Zbsc,ss2%Zbsc,icheck,iout,ierr)
        CALL ps_conformal("Zbsc",ss1%Zbsc,ss3%Zbsc,iout,ierr)
        if(ierr.eq.0) ss3%Zbsc = ss1%Zbsc
     ELSE IF(ALLOCATED(ss1%Zbsc)) THEN
        CALL ps_conformal("Zbsc",ss1%Zbsc,ss3%Zbsc,iout,ierr)
        ss3%Zbsc = ss1%Zbsc
     ELSE IF(ALLOCATED(ss2%Zbsc)) THEN
        CALL ps_conformal("Zbsc",ss2%Zbsc,ss3%Zbsc,iout,ierr)
        ss3%Zbsc = ss2%Zbsc
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Zeff)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zeff).AND.ALLOCATED(ss2%Zeff)) THEN
        CALL ps_conformal("Zeff",ss2%Zeff,ss3%Zeff,iout,ierr)
        CALL ps_conformal("Zeff",ss1%Zeff,ss3%Zeff,iout,ierr)
        if(ierr.eq.0) ss3%Zeff = w1*ss1%Zeff + (1.0_rspec-w1)*ss2%Zeff
     ELSE IF(ALLOCATED(ss1%Zeff)) THEN
        CALL ps_conformal("Zeff",ss1%Zeff,ss3%Zeff,iout,ierr)
        ss3%Zeff = ss1%Zeff
     ELSE IF(ALLOCATED(ss2%Zeff)) THEN
        CALL ps_conformal("Zeff",ss2%Zeff,ss3%Zeff,iout,ierr)
        ss3%Zeff = ss2%Zeff
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("ZEFF_Data_Info",ss1%ZEFF_Data_Info,ss2%ZEFF_Data_Info,icheck,iout,ierr)
     ss3%ZEFF_Data_Info = ss1%ZEFF_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%Zeff_fi)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zeff_fi).AND.ALLOCATED(ss2%Zeff_fi)) THEN
        CALL ps_conformal("Zeff_fi",ss2%Zeff_fi,ss3%Zeff_fi,iout,ierr)
        CALL ps_conformal("Zeff_fi",ss1%Zeff_fi,ss3%Zeff_fi,iout,ierr)
        if(ierr.eq.0) ss3%Zeff_fi = w1*ss1%Zeff_fi + (1.0_rspec-w1)*ss2%Zeff_fi
     ELSE IF(ALLOCATED(ss1%Zeff_fi)) THEN
        CALL ps_conformal("Zeff_fi",ss1%Zeff_fi,ss3%Zeff_fi,iout,ierr)
        ss3%Zeff_fi = ss1%Zeff_fi
     ELSE IF(ALLOCATED(ss2%Zeff_fi)) THEN
        CALL ps_conformal("Zeff_fi",ss2%Zeff_fi,ss3%Zeff_fi,iout,ierr)
        ss3%Zeff_fi = ss2%Zeff_fi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Zeff_th)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zeff_th).AND.ALLOCATED(ss2%Zeff_th)) THEN
        CALL ps_conformal("Zeff_th",ss2%Zeff_th,ss3%Zeff_th,iout,ierr)
        CALL ps_conformal("Zeff_th",ss1%Zeff_th,ss3%Zeff_th,iout,ierr)
        if(ierr.eq.0) ss3%Zeff_th = w1*ss1%Zeff_th + (1.0_rspec-w1)*ss2%Zeff_th
     ELSE IF(ALLOCATED(ss1%Zeff_th)) THEN
        CALL ps_conformal("Zeff_th",ss1%Zeff_th,ss3%Zeff_th,iout,ierr)
        ss3%Zeff_th = ss1%Zeff_th
     ELSE IF(ALLOCATED(ss2%Zeff_th)) THEN
        CALL ps_conformal("Zeff_th",ss2%Zeff_th,ss3%Zeff_th,iout,ierr)
        ss3%Zeff_th = ss2%Zeff_th
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("Zimp1",ss1%Zimp1,ss2%Zimp1,icheck,iout,ierr)
     ss3%Zimp1 = ss1%Zimp1
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN

     CALL ps_diff("Zimp2",ss1%Zimp2,ss2%Zimp2,icheck,iout,ierr)
     ss3%Zimp2 = ss1%Zimp2
  ENDIF

  IF((ALLOCATED(ss3%zlim)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%zlim).AND.ALLOCATED(ss2%zlim)) THEN
        CALL ps_diff("zlim",ss1%zlim,ss2%zlim,icheck,iout,ierr)
        CALL ps_conformal("zlim",ss1%zlim,ss3%zlim,iout,ierr)
        if(ierr.eq.0) ss3%zlim = ss1%zlim
     ELSE IF(ALLOCATED(ss1%zlim)) THEN
        CALL ps_conformal("zlim",ss1%zlim,ss3%zlim,iout,ierr)
        ss3%zlim = ss1%zlim
     ELSE IF(ALLOCATED(ss2%zlim)) THEN
        CALL ps_conformal("zlim",ss2%zlim,ss3%zlim,iout,ierr)
        ss3%zlim = ss2%zlim
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Zloc_coil)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Zloc_coil).AND.ALLOCATED(ss2%Zloc_coil)) THEN
        CALL ps_diff("Zloc_coil",ss1%Zloc_coil,ss2%Zloc_coil,icheck,iout,ierr)
        CALL ps_conformal("Zloc_coil",ss1%Zloc_coil,ss3%Zloc_coil,iout,ierr)
        if(ierr.eq.0) ss3%Zloc_coil = ss1%Zloc_coil
     ELSE IF(ALLOCATED(ss1%Zloc_coil)) THEN
        CALL ps_conformal("Zloc_coil",ss1%Zloc_coil,ss3%Zloc_coil,iout,ierr)
        ss3%Zloc_coil = ss1%Zloc_coil
     ELSE IF(ALLOCATED(ss2%Zloc_coil)) THEN
        CALL ps_conformal("Zloc_coil",ss2%Zloc_coil,ss3%Zloc_coil,iout,ierr)
        ss3%Zloc_coil = ss2%Zloc_coil
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_ant)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_ant).AND.ALLOCATED(ss2%Z_ant)) THEN
        CALL ps_diff("Z_ant",ss1%Z_ant,ss2%Z_ant,icheck,iout,ierr)
        CALL ps_conformal("Z_ant",ss1%Z_ant,ss3%Z_ant,iout,ierr)
        if(ierr.eq.0) ss3%Z_ant = ss1%Z_ant
     ELSE IF(ALLOCATED(ss1%Z_ant)) THEN
        CALL ps_conformal("Z_ant",ss1%Z_ant,ss3%Z_ant,iout,ierr)
        ss3%Z_ant = ss1%Z_ant
     ELSE IF(ALLOCATED(ss2%Z_ant)) THEN
        CALL ps_conformal("Z_ant",ss2%Z_ant,ss3%Z_ant,iout,ierr)
        ss3%Z_ant = ss2%Z_ant
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_antgeo)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_antgeo).AND.ALLOCATED(ss2%Z_antgeo)) THEN
        CALL ps_diff("Z_antgeo",ss1%Z_antgeo,ss2%Z_antgeo,icheck,iout,ierr)
        CALL ps_conformal("Z_antgeo",ss1%Z_antgeo,ss3%Z_antgeo,iout,ierr)
        if(ierr.eq.0) ss3%Z_antgeo = ss1%Z_antgeo
     ELSE IF(ALLOCATED(ss1%Z_antgeo)) THEN
        CALL ps_conformal("Z_antgeo",ss1%Z_antgeo,ss3%Z_antgeo,iout,ierr)
        ss3%Z_antgeo = ss1%Z_antgeo
     ELSE IF(ALLOCATED(ss2%Z_antgeo)) THEN
        CALL ps_conformal("Z_antgeo",ss2%Z_antgeo,ss3%Z_antgeo,iout,ierr)
        ss3%Z_antgeo = ss2%Z_antgeo
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%Z_axis = w1*ss1%Z_axis + (1.0_rspec-w1)*ss2%Z_axis
  ENDIF

  IF((ALLOCATED(ss3%Z_EC_launch)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_EC_launch).AND.ALLOCATED(ss2%Z_EC_launch)) THEN
        CALL ps_diff("Z_EC_launch",ss1%Z_EC_launch,ss2%Z_EC_launch,icheck,iout,ierr)
        CALL ps_conformal("Z_EC_launch",ss1%Z_EC_launch,ss3%Z_EC_launch,iout,ierr)
        if(ierr.eq.0) ss3%Z_EC_launch = ss1%Z_EC_launch
     ELSE IF(ALLOCATED(ss1%Z_EC_launch)) THEN
        CALL ps_conformal("Z_EC_launch",ss1%Z_EC_launch,ss3%Z_EC_launch,iout,ierr)
        ss3%Z_EC_launch = ss1%Z_EC_launch
     ELSE IF(ALLOCATED(ss2%Z_EC_launch)) THEN
        CALL ps_conformal("Z_EC_launch",ss2%Z_EC_launch,ss3%Z_EC_launch,iout,ierr)
        ss3%Z_EC_launch = ss2%Z_EC_launch
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_geo)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_geo).AND.ALLOCATED(ss2%Z_geo)) THEN
        CALL ps_conformal("Z_geo",ss2%Z_geo,ss3%Z_geo,iout,ierr)
        CALL ps_conformal("Z_geo",ss1%Z_geo,ss3%Z_geo,iout,ierr)
        if(ierr.eq.0) ss3%Z_geo = w1*ss1%Z_geo + (1.0_rspec-w1)*ss2%Z_geo
     ELSE IF(ALLOCATED(ss1%Z_geo)) THEN
        CALL ps_conformal("Z_geo",ss1%Z_geo,ss3%Z_geo,iout,ierr)
        ss3%Z_geo = ss1%Z_geo
     ELSE IF(ALLOCATED(ss2%Z_geo)) THEN
        CALL ps_conformal("Z_geo",ss2%Z_geo,ss3%Z_geo,iout,ierr)
        ss3%Z_geo = ss2%Z_geo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_grid)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_grid).AND.ALLOCATED(ss2%Z_grid)) THEN
        CALL ps_diff("Z_grid",ss1%Z_grid,ss2%Z_grid,ps_error,iout,ierr)
        CALL ps_conformal("Z_grid",ss1%Z_grid,ss3%Z_grid,iout,ierr)
        if(ierr.eq.0) ss3%Z_grid = ss1%Z_grid
     ELSE IF(ALLOCATED(ss1%Z_grid)) THEN
        CALL ps_conformal("Z_grid",ss1%Z_grid,ss3%Z_grid,iout,ierr)
        ss3%Z_grid = ss1%Z_grid
     ELSE IF(ALLOCATED(ss2%Z_grid)) THEN
        CALL ps_conformal("Z_grid",ss2%Z_grid,ss3%Z_grid,iout,ierr)
        ss3%Z_grid = ss2%Z_grid
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("Z_max_box",ss1%Z_max_box,ss2%Z_max_box,icheck,iout,ierr)
     ss3%Z_max_box = ss1%Z_max_box
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%Z_max_lcfs = w1*ss1%Z_max_lcfs + (1.0_rspec-w1)*ss2%Z_max_lcfs
  ENDIF

  IF((ALLOCATED(ss3%Z_midp)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_midp).AND.ALLOCATED(ss2%Z_midp)) THEN
        CALL ps_conformal("Z_midp",ss2%Z_midp,ss3%Z_midp,iout,ierr)
        CALL ps_conformal("Z_midp",ss1%Z_midp,ss3%Z_midp,iout,ierr)
        if(ierr.eq.0) ss3%Z_midp = w1*ss1%Z_midp + (1.0_rspec-w1)*ss2%Z_midp
     ELSE IF(ALLOCATED(ss1%Z_midp)) THEN
        CALL ps_conformal("Z_midp",ss1%Z_midp,ss3%Z_midp,iout,ierr)
        ss3%Z_midp = ss1%Z_midp
     ELSE IF(ALLOCATED(ss2%Z_midp)) THEN
        CALL ps_conformal("Z_midp",ss2%Z_midp,ss3%Z_midp,iout,ierr)
        ss3%Z_midp = ss2%Z_midp
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_mid_ant)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_mid_ant).AND.ALLOCATED(ss2%Z_mid_ant)) THEN
        CALL ps_diff("Z_mid_ant",ss1%Z_mid_ant,ss2%Z_mid_ant,icheck,iout,ierr)
        CALL ps_conformal("Z_mid_ant",ss1%Z_mid_ant,ss3%Z_mid_ant,iout,ierr)
        if(ierr.eq.0) ss3%Z_mid_ant = ss1%Z_mid_ant
     ELSE IF(ALLOCATED(ss1%Z_mid_ant)) THEN
        CALL ps_conformal("Z_mid_ant",ss1%Z_mid_ant,ss3%Z_mid_ant,iout,ierr)
        ss3%Z_mid_ant = ss1%Z_mid_ant
     ELSE IF(ALLOCATED(ss2%Z_mid_ant)) THEN
        CALL ps_conformal("Z_mid_ant",ss2%Z_mid_ant,ss3%Z_mid_ant,iout,ierr)
        ss3%Z_mid_ant = ss2%Z_mid_ant
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN

     CALL ps_diff("Z_min_box",ss1%Z_min_box,ss2%Z_min_box,icheck,iout,ierr)
     ss3%Z_min_box = ss1%Z_min_box
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%Z_min_lcfs = w1*ss1%Z_min_lcfs + (1.0_rspec-w1)*ss2%Z_min_lcfs
  ENDIF

  IF((ALLOCATED(ss3%Z_ripple)).AND.(cclist(ps_cnum_RIPPLE).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_ripple).AND.ALLOCATED(ss2%Z_ripple)) THEN
        CALL ps_diff("Z_ripple",ss1%Z_ripple,ss2%Z_ripple,ps_error,iout,ierr)
        CALL ps_conformal("Z_ripple",ss1%Z_ripple,ss3%Z_ripple,iout,ierr)
        if(ierr.eq.0) ss3%Z_ripple = ss1%Z_ripple
     ELSE IF(ALLOCATED(ss1%Z_ripple)) THEN
        CALL ps_conformal("Z_ripple",ss1%Z_ripple,ss3%Z_ripple,iout,ierr)
        ss3%Z_ripple = ss1%Z_ripple
     ELSE IF(ALLOCATED(ss2%Z_ripple)) THEN
        CALL ps_conformal("Z_ripple",ss2%Z_ripple,ss3%Z_ripple,iout,ierr)
        ss3%Z_ripple = ss2%Z_ripple
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_surfMax)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_surfMax).AND.ALLOCATED(ss2%Z_surfMax)) THEN
        CALL ps_conformal("Z_surfMax",ss2%Z_surfMax,ss3%Z_surfMax,iout,ierr)
        CALL ps_conformal("Z_surfMax",ss1%Z_surfMax,ss3%Z_surfMax,iout,ierr)
        if(ierr.eq.0) ss3%Z_surfMax = w1*ss1%Z_surfMax + (1.0_rspec-w1)*ss2%Z_surfMax
     ELSE IF(ALLOCATED(ss1%Z_surfMax)) THEN
        CALL ps_conformal("Z_surfMax",ss1%Z_surfMax,ss3%Z_surfMax,iout,ierr)
        ss3%Z_surfMax = ss1%Z_surfMax
     ELSE IF(ALLOCATED(ss2%Z_surfMax)) THEN
        CALL ps_conformal("Z_surfMax",ss2%Z_surfMax,ss3%Z_surfMax,iout,ierr)
        ss3%Z_surfMax = ss2%Z_surfMax
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Z_surfMin)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%Z_surfMin).AND.ALLOCATED(ss2%Z_surfMin)) THEN
        CALL ps_conformal("Z_surfMin",ss2%Z_surfMin,ss3%Z_surfMin,iout,ierr)
        CALL ps_conformal("Z_surfMin",ss1%Z_surfMin,ss3%Z_surfMin,iout,ierr)
        if(ierr.eq.0) ss3%Z_surfMin = w1*ss1%Z_surfMin + (1.0_rspec-w1)*ss2%Z_surfMin
     ELSE IF(ALLOCATED(ss1%Z_surfMin)) THEN
        CALL ps_conformal("Z_surfMin",ss1%Z_surfMin,ss3%Z_surfMin,iout,ierr)
        ss3%Z_surfMin = ss1%Z_surfMin
     ELSE IF(ALLOCATED(ss2%Z_surfMin)) THEN
        CALL ps_conformal("Z_surfMin",ss2%Z_surfMin,ss3%Z_surfMin,iout,ierr)
        ss3%Z_surfMin = ss2%Z_surfMin
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_9

subroutine tdb_nzones(nzones,nrmaj,nrsym)
  !
  !  from basic grid size produce midplane grid sizes used by the trdatbuf
  !  profile interpolation routines

  integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)

  integer, intent(out) :: nrmaj  ! (2*nzones+1) no. of flux surface
  !                                midplane intercepts
  integer, intent(out) :: nrsym  ! (4*nzones+5) size of midplane test
  !                                grid (zone bdys & surfaces + 2
  !                                extrapolation points at each end).

  nrmaj = 2*nzones + 1
  nrsym = 4*nzones + 5

end subroutine tdb_nzones

subroutine tdb_xilmp(nzones,xibdys,xilmp)

  integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)
  real*8, dimension(:), intent(in) :: xibdys  ! (nzones+1) x @ zone bdys

  real*8, dimension(:), intent(out) :: xilmp  ! (2*nzones+1) x @midplane
  !                                flux surface intercepts

  integer :: inzp1,i2nzp1,ierr,i,inc
  integer :: lunmsg_tdb

  !--------------------------------

  inzp1 = nzones+1
  i2nzp1 = inzp1 + nzones

  ierr=0
  if(size(xibdys).ne.inzp1) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xilmp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(xibdys) = nzones + 1, but found:',&
          'size(xibdys) = ',size(xibdys)
     ierr = ierr+1
  endif

  if(size(xilmp).ne.i2nzp1) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xilmp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(xilmp) = 2*nzones + 1, but found:',&
          ' size(xilmp) = ',size(xilmp)
     ierr = ierr+1
  endif
 
  if(ierr.gt.0) then
     xilmp = 0
     return
  endif

  xilmp(inzp1)=xibdys(1)

  inc=0
  do i=1,nzones
     inc=inc+1
     xilmp(inzp1+inc)=xibdys(i+1)
     xilmp(inzp1-inc)=-xibdys(i+1)
  enddo

end subroutine tdb_xilmp


subroutine tdb_xisymp(nzones,xibdys,rmajmp,xirsym,rmjsym)
  
  !  generate test grids for looking at symmetrization of profile data

  use trdatbuf_iface, only: tdb_xilmp
  implicit NONE

  integer, intent(in) :: nzones  ! target grid, no. of flux zones (in)
  real*8, dimension(:), intent(in) :: xibdys  ! (nzones+1) x @ zone bdys
  real*8, dimension(:), intent(in) :: rmajmp  ! (2*nzones+1) major radius
  !         at flux surface midplane intercepts (cm)
  real*8, dimension(:), intent(out) :: xirsym ! (4*nzones+5) x @midplane
  !         (double-density grid with 2 pt extension @ bdys)
  real*8, dimension(:), intent(out) :: rmjsym ! (4*nzones+5) R @midplane
  !         (double-density grid with 2 pt extension @ bdys) (cm)

  integer :: inzp1,i2nzp1,i4nzp5,ierr
  integer :: icen,icenr,inc,incr,j,incrp,incri,ir,i4,i3,i2,i1
  integer :: lunmsg_tdb

  real*8, dimension(:), allocatable :: xilmp
  real*8 :: zdr,zdx

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  !--------------------------------

  inzp1 = nzones+1
  i2nzp1 = 2*nzones+1
  i4nzp5 = 4*nzones+5

  ierr=0
  if(size(xibdys).ne.inzp1) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xisymp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(xibdys) = nzones + 1, but found:',&
          'size(xibdys) = ',size(xibdys)
     ierr = ierr+1
  endif

  if(size(rmajmp).ne.i2nzp1) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xisymp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(rmajmp) = 2*nzones + 1, but found:',&
          ' size(rmajmp) = ',size(rmajmp)
     ierr = ierr+1
  endif

  if(size(xirsym).ne.i4nzp5) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xisymp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(xirsym) = 4*nzones + 5, but found:',&
          ' size(xirsym) = ',size(xirsym)
     ierr = ierr+1
  endif

  if(size(rmjsym).ne.i4nzp5) then
     write(lunmsg_tdb(0),*) ' ?trdatbuf_lib/tdb_xisymp: with nzones = ',nzones
     write(lunmsg_tdb(0),*) '  expected size(rmjsym) = 4*nzones + 5, but found:',&
          ' size(rmjsym) = ',size(rmjsym)
     ierr = ierr+1
  endif

  if(ierr.ne.0) then
     xirsym=0
     rmjsym=0
     return
  endif

  allocate(xilmp(i2nzp1))
  call tdb_xilmp(nzones,xibdys,xilmp)

  ICEN=NZONES+1  ! CENTER OF RMAJMP GRID (MAGNETIC AXIS)

  ICENR=2*NZONES+3  ! CENTER OF RMJSYM GRID

  !  at axis

  RMJSYM(ICENR)=RMAJMP(ICEN)
  XIRSYM(ICENR)=XILMP(ICEN)

  !  WITHIN THE PLASMA:
 
  INC=0
  INCR=0
  DO J=1,NZONES
     INC=INC+1
     INCRP=INCR
     INCR=INCR+2

     !  THE FLUX SURFACES:

     RMJSYM(ICENR+INCR)=RMAJMP(ICEN+INC)
     XIRSYM(ICENR+INCR)=XILMP(ICEN+INC)

     RMJSYM(ICENR-INCR)=RMAJMP(ICEN-INC)
     XIRSYM(ICENR-INCR)=XILMP(ICEN-INC)

     !  BTW THE FLUX SURFACES:

     INCRI=INCR-1
     RMJSYM(ICENR+INCRI)= &
          0.5_R8*(RMJSYM(ICENR+INCRP)+RMJSYM(ICENR+INCR))
     XIRSYM(ICENR+INCRI)= &
          0.5_R8*(XIRSYM(ICENR+INCRP)+XIRSYM(ICENR+INCR))
     RMJSYM(ICENR-INCRI)= &
          0.5_R8*(RMJSYM(ICENR-INCRP)+RMJSYM(ICENR-INCR))
     XIRSYM(ICENR-INCRI)= &
          0.5_R8*(XIRSYM(ICENR-INCRP)+XIRSYM(ICENR-INCR))

  enddo

  !  BEYOND THE PLASMA BDY

  !  INSIDE
  ZDR=RMJSYM(4)-RMJSYM(3)
  ZDX=XIRSYM(4)-XIRSYM(3)
  RMJSYM(2)=RMJSYM(3)-ZDR
  RMJSYM(1)=RMJSYM(2)-ZDR
  XIRSYM(2)=XIRSYM(3)-ZDX
  XIRSYM(1)=XIRSYM(2)-ZDX

  !  OUTSIDE
  I4=4*NZONES+2
  I3=4*NZONES+3
  I2=4*NZONES+4
  I1=4*NZONES+5
  ZDR=RMJSYM(I4)-RMJSYM(I3)
  ZDX=XIRSYM(I4)-XIRSYM(I3)
  RMJSYM(I2)=RMJSYM(I3)-ZDR
  RMJSYM(I1)=RMJSYM(I2)-ZDR
  XIRSYM(I2)=XIRSYM(I3)-ZDX
  XIRSYM(I1)=XIRSYM(I2)-ZDX

  deallocate(xilmp)

end subroutine tdb_xisymp

C---------------------------------------------------------
C  TDB_DATALO
C
C  ALLOCATE SPACE IN PHYSICS (MEASURED) DATA BUFFER
C  (TRANSP COMMON BLOCK 5.2)
C
C  BOMB OUT IF NONE IS AVAILABLE
C
C  INPUT ISIZE = AMOUNT OF SPACE (NO. WORDS) NEEDED
C  OUTPUT ILOC = LOCATION OF FIRST WORD OF ALLOCATED SPACE
C
C  COMMON QUANTITY LFREE IS INCREMENTED TO NEXT FREE SEGMENT
C
      SUBROUTINE TDB_DATALO(d,ISIZE,ILOC)
C
      use trdatbuf_obj
      IMPLICIT NONE
      type (trdatbuf) :: d          ! data buffer
      integer, intent(in) :: isize  ! size of chunk to allocate
      integer, intent(out) :: iloc  ! address of chunk allocated
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER iend,isizb
!============

! 12/04/08 CLF: don't allocate size=0 
      if (isize .le. 0) return
!
      IEND=d%LFREE+ISIZE
C
C  check if need to expand buffer
C
      call datbuf_expand(d,iend,isizb)
C
C  ALLOCATE SPACE in buffer
C
      ILOC=d%LFREE
      d%LFREE=d%LFREE+ISIZE
C
      RETURN
      END

!  The trdatbuf data may contain information of varying levels of detail on
!  plasma impurity content.
!
!  The traditional, simple model is to use a single "model impurity" known
!  as "tokamakium".  The charge number and atomic weight of this impurity
!  were allowed to be non-integers and vary in time, since "tokamakium"
!  represented a composite of some more complex mix of actual impurities
!  in a real tokamak.  If time variation is present, Zimp is a function of
!  time and the relation Aimp(t) = 2*Zimp(t) is assumed.
!
!  The more detailed model allows explicit specification of multi-species
!  impurity data.  In this case, there are multiple impurity elements and
!  also multiple charge states for each element, although the relative
!  concentrations of the various charge states may be estimated by a
!  "coronal equilibrium" approximation...

logical function tdb_tokamakium(d)

  ! return TRUE if the "tokamakium" model of impurity data is in effect

  use trdatbuf_obj
  type (trdatbuf) :: d

  tdb_tokamakium = ( d%NMIMP .eq. 0 )

end function tdb_tokamakium

!  multi impurity model:
!  return Z & A of impurity *elements*; see also tdb_imp_ions
!  vectors filled with zeroes if "tokamakium" model is in effect.

subroutine tdb_imp_elems(d,xzimps,aimps)
  use trdatbuf_obj
  use tdbsub_uts
  use periodic_table_mod
  implicit NONE
  INTEGER, PARAMETER  :: R8=SELECTED_REAL_KIND(12,100)
  type (trdatbuf) :: d
  real*8, dimension(:) :: xzimps,aimps  ! Z & A vectors
  !  fill in Z & A of impurity elements

  integer :: i,isize,imimps,lunmsg_tdb
  integer :: iz, ia,  ier
  real*8 :: r_mass, q_atom, q_ch

  if(d%nmimp.eq.0) return  ! tokamakium

  imimps = tdb_get_mimps(0)

  xzimps = ZERO
  aimps = ZERO

  isize=min(size(xzimps),size(aimps))
  if(isize.lt.imimps) then
     write(lunmsg_tdb(0),*) ' ?tdb_imp_elems: A & Z vectors too small:'
     write(lunmsg_tdb(0),*) '  size = ',isize,' expected = ',imimps
     return
  endif

  DO I = 1, imimps
     AIMPS(I)  = d%DATBUF(d%LAIMPS+I-1) ! load data -- assume good
     XZIMPS(I) = d%DATBUF(d%LXZIMPS+I-1)
     iz=XZIMPS(I) + 0.1_r8
     ia=AIMPS(I) + 0.5_r8
     call tr_species_convert(iz,iz,AIMPS(I),q_atom,q_ch,r_mass,ier)
     AIMPS(I)=r_mass/1.6726E-27_R8

  END DO

end subroutine tdb_imp_elems

!  multi impurity model:
!  return charge & atomic no. Z & and atomic weight A of impurity *ionss*; 
!  see also tdb_imp_elems
!  vectors filled with zeroes if "tokamakium" model is in effect.

subroutine tdb_imp_ions(d,xzimpx,xzimpxs,aimpx)
  use trdatbuf_obj
  use tdbsub_uts
  use periodic_table_mod
  implicit NONE
  INTEGER, PARAMETER  :: R8=SELECTED_REAL_KIND(12,100)
  type (trdatbuf) :: d
  real*8, dimension(:) :: xzimpx !  charge on ion e.g. Z(C+4)=4
  real*8, dimension(:) :: xzimpxs !  atomic number e.g. Z(C+4)=6
  real*8, dimension(:) :: aimpx  !  atomic weight e.g. A(C+4)=14 if Carbon-14

  !  fill in Z & A of impurity ions

  integer :: i,isize,imimpt,lunmsg_tdb
  integer :: iz, ia,  ier, iz_ch
  real*8 :: r_mass, q_atom, q_ch

  if(d%nmimp.eq.0) return  ! tokamakium

  imimpt = tdb_get_mimpt(0)

  xzimpx = ZERO
  xzimpxs = ZERO
  aimpx = ZERO

  isize=min(size(xzimpx),size(xzimpxs),size(aimpx))
  if(isize.lt.imimpt) then
     write(lunmsg_tdb(0),*) ' ?tdb_imp_ions: A & Z vectors too small:'
     write(lunmsg_tdb(0),*) '  size = ',isize,' expected = ',imimpt
     return
  endif
 
  DO I = 1, iMIMPT
     XZIMPX(I)  = d%DATBUF(d%LXZIMPX +I-1)
     XZIMPXS(I) = d%DATBUF(d%LXZIMPXS+I-1)
     AIMPX(I)   = d%DATBUF(d%LAIMPX  +I-1)
     iz=XZIMPXS(I) + 0.1_r8 !atomic #
     iz_ch=XZIMPXS(I) + 0.1_r8 !atomic charge of impurity
     ia=AIMPX(I) + 0.5_r8
     call tr_species_convert(iz,iz_ch,AIMPX(I),q_atom,q_ch,r_mass,ier)
     AIMPX(I)=r_mass/1.6726E-27_R8

  enddo

end subroutine tdb_imp_ions

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_1(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  IF(ALLOCATED(ss%chii_ntm)) THEN
     status = nf90_inq_varid(icdf,"chii_ntm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_ntm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_ntm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_ntm = 0.0_rspec
           CALL ncerr_name(2,status,"chii_ntm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_tglf)) THEN
     status = nf90_inq_varid(icdf,"chii_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"chii_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_trans)) THEN
     status = nf90_inq_varid(icdf,"chii_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_trans = 0.0_rspec
           CALL ncerr_name(2,status,"chii_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_transcat)) THEN
     status = nf90_inq_varid(icdf,"chii_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"chii_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chii_w19)) THEN
     status = nf90_inq_varid(icdf,"chii_w19",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chii_w19")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chii_w19)
        IF(status.NE.NF90_NOERR) THEN
           ss%chii_w19 = 0.0_rspec
           CALL ncerr_name(2,status,"chii_w19")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chimo_trans)) THEN
     status = nf90_inq_varid(icdf,"chimo_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chimo_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chimo_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%chimo_trans = 0.0_rspec
           CALL ncerr_name(2,status,"chimo_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chimo_transcat)) THEN
     status = nf90_inq_varid(icdf,"chimo_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chimo_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chimo_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%chimo_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"chimo_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_anom)) THEN
     status = nf90_inq_varid(icdf,"chiphi_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_anom = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_drbm)) THEN
     status = nf90_inq_varid(icdf,"chiphi_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_glf)) THEN
     status = nf90_inq_varid(icdf,"chiphi_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_glf = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"chiphi_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chiphi_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_neo)) THEN
     status = nf90_inq_varid(icdf,"chiphi_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_neo = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_tglf)) THEN
     status = nf90_inq_varid(icdf,"chiphi_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chiphi_w19)) THEN
     status = nf90_inq_varid(icdf,"chiphi_w19",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chiphi_w19")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chiphi_w19)
        IF(status.NE.NF90_NOERR) THEN
           ss%chiphi_w19 = 0.0_rspec
           CALL ncerr_name(2,status,"chiphi_w19")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%chitheta_mmm71)) THEN
     status = nf90_inq_varid(icdf,"chitheta_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"chitheta_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%chitheta_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%chitheta_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"chitheta_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%circuit_name)) THEN
     status = nf90_inq_varid(icdf,"circuit_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"circuit_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%circuit_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%circuit_name = " "
           CALL ncerr_name(2,status,"circuit_name")
        ELSE
           CALL denull_vec(ss%circuit_name,ss%ncircuits)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_apt)) THEN
     status = nf90_inq_varid(icdf,"coil_apt",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"coil_apt")
     ELSE
        status = nf90_get_var(icdf,varid,ss%coil_apt)
        IF(status.NE.NF90_NOERR) THEN
           ss%coil_apt = 0.0_rspec
           CALL ncerr_name(2,status,"coil_apt")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     status = nf90_inq_varid(icdf,"coil_in_circuit",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"coil_in_circuit")
     ELSE
        status = nf90_get_var(icdf,varid,ss%coil_in_circuit)
        IF(status.NE.NF90_NOERR) THEN
           ss%coil_in_circuit = " "
           CALL ncerr_name(2,status,"coil_in_circuit")
        ELSE
           CALL denull_vec(ss%coil_in_circuit,ss%ncoils)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_name)) THEN
     status = nf90_inq_varid(icdf,"coil_name",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"coil_name")
     ELSE
        status = nf90_get_var(icdf,varid,ss%coil_name)
        IF(status.NE.NF90_NOERR) THEN
           ss%coil_name = " "
           CALL ncerr_name(2,status,"coil_name")
        ELSE
           CALL denull_vec(ss%coil_name,ss%ncoils)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%coil_resispt)) THEN
     status = nf90_inq_varid(icdf,"coil_resispt",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"coil_resispt")
     ELSE
        status = nf90_get_var(icdf,varid,ss%coil_resispt)
        IF(status.NE.NF90_NOERR) THEN
           ss%coil_resispt = 0.0_rspec
           CALL ncerr_name(2,status,"coil_resispt")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curbeam)) THEN
     status = nf90_inq_varid(icdf,"curbeam",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curbeam")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curbeam)
        IF(status.NE.NF90_NOERR) THEN
           ss%curbeam = 0.0_rspec
           CALL ncerr_name(2,status,"curbeam")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curech)) THEN
     status = nf90_inq_varid(icdf,"curech",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curech")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curech)
        IF(status.NE.NF90_NOERR) THEN
           ss%curech = 0.0_rspec
           CALL ncerr_name(2,status,"curech")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curech_src)) THEN
     status = nf90_inq_varid(icdf,"curech_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curech_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curech_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%curech_src = 0.0_rspec
           CALL ncerr_name(2,status,"curech_src")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curfusn)) THEN
     status = nf90_inq_varid(icdf,"curfusn",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curfusn")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curfusn)
        IF(status.NE.NF90_NOERR) THEN
           ss%curfusn = 0.0_rspec
           CALL ncerr_name(2,status,"curfusn")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curich)) THEN
     status = nf90_inq_varid(icdf,"curich",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curich")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curich)
        IF(status.NE.NF90_NOERR) THEN
           ss%curich = 0.0_rspec
           CALL ncerr_name(2,status,"curich")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curlh)) THEN
     status = nf90_inq_varid(icdf,"curlh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curlh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curlh)
        IF(status.NE.NF90_NOERR) THEN
           ss%curlh = 0.0_rspec
           CALL ncerr_name(2,status,"curlh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curlh_src)) THEN
     status = nf90_inq_varid(icdf,"curlh_src",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curlh_src")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curlh_src)
        IF(status.NE.NF90_NOERR) THEN
           ss%curlh_src = 0.0_rspec
           CALL ncerr_name(2,status,"curlh_src")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curmino)) THEN
     status = nf90_inq_varid(icdf,"curmino",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curmino")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curmino)
        IF(status.NE.NF90_NOERR) THEN
           ss%curmino = 0.0_rspec
           CALL ncerr_name(2,status,"curmino")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curr_bootstrap)) THEN
     status = nf90_inq_varid(icdf,"curr_bootstrap",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curr_bootstrap")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curr_bootstrap)
        IF(status.NE.NF90_NOERR) THEN
           ss%curr_bootstrap = 0.0_rspec
           CALL ncerr_name(2,status,"curr_bootstrap")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curr_ohmic)) THEN
     status = nf90_inq_varid(icdf,"curr_ohmic",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curr_ohmic")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curr_ohmic)
        IF(status.NE.NF90_NOERR) THEN
           ss%curr_ohmic = 0.0_rspec
           CALL ncerr_name(2,status,"curr_ohmic")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%curt)) THEN
     status = nf90_inq_varid(icdf,"curt",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"curt")
     ELSE
        status = nf90_get_var(icdf,varid,ss%curt)
        IF(status.NE.NF90_NOERR) THEN
           ss%curt = 0.0_rspec
           CALL ncerr_name(2,status,"curt")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"CUR_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"CUR_Data_Info")
  ELSE
     ilen = len(ss%CUR_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%CUR_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%CUR_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%CUR_Data_Info = " "
        CALL ncerr_name(2,status,"CUR_Data_Info")
     ELSE
        CALL denull(ss%CUR_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%cur_rw)) THEN
     status = nf90_inq_varid(icdf,"cur_rw",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"cur_rw")
     ELSE
        status = nf90_get_var(icdf,varid,ss%cur_rw)
        IF(status.NE.NF90_NOERR) THEN
           ss%cur_rw = 0.0_rspec
           CALL ncerr_name(2,status,"cur_rw")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) THEN
     status = nf90_inq_varid(icdf,"d2R_geo_dRHOdTH",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"d2R_geo_dRHOdTH")
     ELSE
        status = nf90_get_var(icdf,varid,ss%d2R_geo_dRHOdTH)
        IF(status.NE.NF90_NOERR) THEN
           ss%d2R_geo_dRHOdTH = 0.0_rspec
           CALL ncerr_name(2,status,"d2R_geo_dRHOdTH")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) THEN
     status = nf90_inq_varid(icdf,"d2Z_geo_dRHOdTH",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"d2Z_geo_dRHOdTH")
     ELSE
        status = nf90_get_var(icdf,varid,ss%d2Z_geo_dRHOdTH)
        IF(status.NE.NF90_NOERR) THEN
           ss%d2Z_geo_dRHOdTH = 0.0_rspec
           CALL ncerr_name(2,status,"d2Z_geo_dRHOdTH")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%db_mtm)) THEN
     status = nf90_inq_varid(icdf,"db_mtm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"db_mtm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%db_mtm)
        IF(status.NE.NF90_NOERR) THEN
           ss%db_mtm = 0.0_rspec
           CALL ncerr_name(2,status,"db_mtm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dcur_rw_dVloop)) THEN
     status = nf90_inq_varid(icdf,"dcur_rw_dVloop",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dcur_rw_dVloop")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dcur_rw_dVloop)
        IF(status.NE.NF90_NOERR) THEN
           ss%dcur_rw_dVloop = 0.0_rspec
           CALL ncerr_name(2,status,"dcur_rw_dVloop")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_code)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_code",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"DeltaW_code")
     ELSE
        status = nf90_get_var(icdf,varid,ss%DeltaW_code)
        IF(status.NE.NF90_NOERR) THEN
           ss%DeltaW_code = " "
           CALL ncerr_name(2,status,"DeltaW_code")
        ELSE
           CALL denull_vec(ss%DeltaW_code,ss%ndelta_w)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_mapper)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_mapper",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"DeltaW_mapper")
     ELSE
        status = nf90_get_var(icdf,varid,ss%DeltaW_mapper)
        IF(status.NE.NF90_NOERR) THEN
           ss%DeltaW_mapper = " "
           CALL ncerr_name(2,status,"DeltaW_mapper")
        ELSE
           CALL denull_vec(ss%DeltaW_mapper,ss%ndelta_w)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_stable)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_stable",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"DeltaW_stable")
     ELSE
        status = nf90_get_var(icdf,varid,ss%DeltaW_stable)
        IF(status.NE.NF90_NOERR) THEN
           ss%DeltaW_stable = 0
           CALL ncerr_name(2,status,"DeltaW_stable")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%DeltaW_status)) THEN
     status = nf90_inq_varid(icdf,"DeltaW_status",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"DeltaW_status")
     ELSE
        status = nf90_get_var(icdf,varid,ss%DeltaW_status)
        IF(status.NE.NF90_NOERR) THEN
           ss%DeltaW_status = 0
           CALL ncerr_name(2,status,"DeltaW_status")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_fusi)) THEN
     status = nf90_inq_varid(icdf,"difb_fusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difb_fusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difb_fusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%difb_fusi = 0.0_rspec
           CALL ncerr_name(2,status,"difb_fusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_nbi)) THEN
     status = nf90_inq_varid(icdf,"difb_nbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difb_nbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difb_nbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%difb_nbi = 0.0_rspec
           CALL ncerr_name(2,status,"difb_nbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difb_rfmi)) THEN
     status = nf90_inq_varid(icdf,"difb_rfmi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difb_rfmi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difb_rfmi)
        IF(status.NE.NF90_NOERR) THEN
           ss%difb_rfmi = 0.0_rspec
           CALL ncerr_name(2,status,"difb_rfmi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%diff_trans)) THEN
     status = nf90_inq_varid(icdf,"diff_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"diff_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%diff_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%diff_trans = 0.0_rspec
           CALL ncerr_name(2,status,"diff_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%diff_transcat)) THEN
     status = nf90_inq_varid(icdf,"diff_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"diff_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%diff_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%diff_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"diff_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difne_nclass)) THEN
     status = nf90_inq_varid(icdf,"difne_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difne_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difne_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%difne_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"difne_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnh_nclass)) THEN
     status = nf90_inq_varid(icdf,"difnh_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difnh_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difnh_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%difnh_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"difnh_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_anom)) THEN
     status = nf90_inq_varid(icdf,"difns_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_anom = 0.0_rspec
           CALL ncerr_name(2,status,"difns_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_drbm)) THEN
     status = nf90_inq_varid(icdf,"difns_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"difns_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_glf)) THEN
     status = nf90_inq_varid(icdf,"difns_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_glf = 0.0_rspec
           CALL ncerr_name(2,status,"difns_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"difns_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"difns_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_mmm71)) THEN
     status = nf90_inq_varid(icdf,"difns_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"difns_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_nclass)) THEN
     status = nf90_inq_varid(icdf,"difns_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"difns_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_neo)) THEN
     status = nf90_inq_varid(icdf,"difns_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_neo = 0.0_rspec
           CALL ncerr_name(2,status,"difns_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_tglf)) THEN
     status = nf90_inq_varid(icdf,"difns_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"difns_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difns_w19)) THEN
     status = nf90_inq_varid(icdf,"difns_w19",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difns_w19")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difns_w19)
        IF(status.NE.NF90_NOERR) THEN
           ss%difns_w19 = 0.0_rspec
           CALL ncerr_name(2,status,"difns_w19")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnx_nclass)) THEN
     status = nf90_inq_varid(icdf,"difnx_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difnx_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difnx_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%difnx_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"difnx_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%difnz_mmm71)) THEN
     status = nf90_inq_varid(icdf,"difnz_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"difnz_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%difnz_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%difnz_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"difnz_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dist_fun)) THEN
     status = nf90_inq_varid(icdf,"dist_fun",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dist_fun")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dist_fun)
        IF(status.NE.NF90_NOERR) THEN
           ss%dist_fun = " "
           CALL ncerr_name(2,status,"dist_fun")
        ELSE
           CALL denull_vec(ss%dist_fun,ss%nspec_alla+1)
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"dn0out",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"dn0out")
  ELSE
     status = nf90_get_var(icdf,varid,ss%dn0out)
     IF(status.NE.NF90_NOERR) THEN
        ss%dn0out = 0.0_rspec
        CALL ncerr_name(2,status,"dn0out")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQedGrdte_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQedGrdte_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dQedGrdte_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dQedGrdte_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%dQedGrdte_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"dQedGrdte_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQedGrdti_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQedGrdti_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dQedGrdti_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dQedGrdti_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%dQedGrdti_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"dQedGrdti_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQidGrdte_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQidGrdte_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dQidGrdte_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dQidGrdte_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%dQidGrdte_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"dQidGrdte_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dQidGrdti_tglf)) THEN
     status = nf90_inq_varid(icdf,"dQidGrdti_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dQidGrdti_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dQidGrdti_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%dQidGrdti_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"dQidGrdti_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR0_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dR0_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dR0_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dR0_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dR0_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dR0_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dR_geo_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dR_geo_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dR_geo_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dR_geo_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dR_geo_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dR_geo_dTH)) THEN
     status = nf90_inq_varid(icdf,"dR_geo_dTH",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dR_geo_dTH")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dR_geo_dTH)
        IF(status.NE.NF90_NOERR) THEN
           ss%dR_geo_dTH = 0.0_rspec
           CALL ncerr_name(2,status,"dR_geo_dTH")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxRjcos_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dxRjcos_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dxRjcos_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dxRjcos_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dxRjcos_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxRjsin_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dxRjsin_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dxRjsin_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dxRjsin_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dxRjsin_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxZjcos_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dxZjcos_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dxZjcos_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dxZjcos_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dxZjcos_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dxZjsin_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dxZjsin_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dxZjsin_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dxZjsin_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dxZjsin_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dx_fshield)) THEN
     status = nf90_inq_varid(icdf,"dx_fshield",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dx_fshield")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dx_fshield)
        IF(status.NE.NF90_NOERR) THEN
           ss%dx_fshield = 0.0_rspec
           CALL ncerr_name(2,status,"dx_fshield")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ0_momeq_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dZ0_momeq_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dZ0_momeq_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dZ0_momeq_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dZ0_momeq_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dZ0_momeq_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dRHO)) THEN
     status = nf90_inq_varid(icdf,"dZ_geo_dRHO",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dZ_geo_dRHO")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dZ_geo_dRHO)
        IF(status.NE.NF90_NOERR) THEN
           ss%dZ_geo_dRHO = 0.0_rspec
           CALL ncerr_name(2,status,"dZ_geo_dRHO")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%dZ_geo_dTH)) THEN
     status = nf90_inq_varid(icdf,"dZ_geo_dTH",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"dZ_geo_dTH")
     ELSE
        status = nf90_get_var(icdf,varid,ss%dZ_geo_dTH)
        IF(status.NE.NF90_NOERR) THEN
           ss%dZ_geo_dTH = 0.0_rspec
           CALL ncerr_name(2,status,"dZ_geo_dTH")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_1

subroutine tdb_get_psirz(d,ztime,inumR,inumZ,PsiRZ,ier)

  !  get R and Z grids -- but, passed argument grid sizes must match or
  !  an error code is set and a message is printed.

  !  see sister subroutine "tdb_get_rzsizes"...

  use trdatbuf_obj
  use tdbsub_uts
  implicit NONE

  type (trdatbuf) :: d

  real*8, intent(in) :: ztime         ! time to which to interpolate
  integer,intent(in) :: inumR,inumZ   ! the grid sizes
  real*8 :: PsiRZ(inumR,inumZ)        ! Psi(R,Z) returned if sizes are correct
  integer, intent(out) :: ier         ! status code: 0=OK

  !------------------------------------
  integer :: nonlin,lunmsg_tdb,iloct,inumt,it1,ir,iz,ia1,ia2
  integer :: iloc_psi
  real*8 :: zfrac1,zfrac2
  !------------------------------------

  ier = 0

  nonlin = lunmsg_tdb(0)

  if(inumR.ne.d%nRpsi) then
     ier = ier + 1
     write(nonlin,*) ' ?tdb_get_Psirz: R grid size mismatch.'
     write(nonlin,*) '  Correct size is: ',d%nRpsi,'; passed size is: ',inumR
  endif

  if(inumZ.ne.d%nZpsi) then
     ier = ier + 1
     write(nonlin,*) ' ?tdb_get_Psirz: Z grid size mismatch.'
     write(nonlin,*) '  Correct size is: ',d%nZpsi,'; passed size is: ',inumZ
  endif

  if(ier.ne.0) return

  if(min(inumR,inumZ).le.0) then
     write(nonlin,*) ' %tdb_get_psirz: [R,Z] grids not found.'
     return
  endif

  iloct = d%ltpsi
  inumt = d%ntpsi

  if((iloct.eq.0).or.(inumt.eq.0)) then
     write(nonlin,*) '  Psi(t,R,Z) timebase address: ',iloct
     write(nonlin,*) '             timebase size:    ',inumt
     write(nonlin,*) '  --> zero not expected.'
     ier=2
     return
  endif

  call tdbsub_lookup(d%datbuf(iloct:iloct+inumt-1),inumt,ztime,it1,zfrac2)

  zfrac1 = ONE-zfrac2

  iloc_psi = d%lfpsi

  do iz=1,inumZ
     do ir=1,inumR
        ia1 = iloc_psi + (iz-1)*inumR*inumt + (ir-1)*inumt + (it1-1)
        ia2 = ia1 + 1
        PsiRZ(ir,iz)=zfrac1*d%datbuf(ia1) + zfrac2*d%datbuf(ia2)
     enddo
  enddo

end subroutine tdb_get_psirz

subroutine ps2echin(ss,iant,idamp,inray,iout,filenam,ierr)

  ! from a Plasma State (ss) create an echin file for TORAY, for ECH
  ! antenna #iant.

  ! any messages are written on unit iout; status code returned in ierr.

  use plasma_state_mod
  implicit NONE

  type (plasma_state) :: ss

  integer, intent(in) :: iant  ! ECH antenna number
  integer, intent(in) :: idamp ! damping model number
  integer, intent(in) :: inray ! number of rays to be traced, this antenna

  integer, intent(in) :: iout  ! fortarn I/O unit number for messages
  character*(*), intent(in) :: filenam  ! filename.  If blank, use "echin"

  integer, intent(out) :: ierr ! return status code, 0=OK

  !--------------------------------------
  integer :: inprof,inm1,io,ios,inbfld,inmin,istat,inside

  ! profiles interpolated to TORAY grid:
  real*8 :: znorm,zbzxr,zr0,zb0,zrmins,ztflux
  real*8 :: zpi
  real*8, dimension(:), allocatable :: zne_tor,zte_tor,zef_tor,zplflx_tor,zwk
  real*8, dimension(:), allocatable :: znewk

  real*8, parameter :: zgfac = 0.10d0  ! for patch routine

  character*100 zfilenam
  !--------------------------------------

  call find_io_unit(io)

  if(filenam.eq.' ') then
     zfilenam='echin'
  else
     zfilenam=filenam
  endif

  ierr = 0

  zpi = 3.1415926535897931D+00

  !------------------------------
  ! interpolate input profiles...

  inprof = ss%nrho_ecrf
  inm1 = inprof-1

  allocate(zne_tor(inprof),zte_tor(inprof),zef_tor(inprof),zplflx_tor(inprof))
  allocate(zwk(inm1))

  ! interpolate the Psi(rho) 1d spline...
  call ps_intrp_1d_vec(ss%rho_ecrf, ss%id_psipol, zplflx_tor, ierr, &
       state=ss)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps2echin: Psi(rho) spline interpolation error.'
     return
  endif

  ! convert to normalized poloidal flux profile

  znorm = 1.0d0/zplflx_tor(inprof)
  zplflx_tor(1:inprof) = zplflx_tor(1:inprof)*znorm

  ! smoothed rezone of plasma parameter profiles...
  !   rezone to zone ctr then shift to bdys... CONTAINED subroutine...

  call rezone_intrp(ss%id_ns(0),zne_tor)  ! density...
  call rezone_intrp(ss%id_Ts(0),zTe_tor)  ! temperature: KeV ok
  call rezone_intrp(ss%id_Zeff,zef_tor)   ! Zeff

  zne_tor = 1.0d-6*zne_tor  ! -> cm**-3

  !------------------------------
  ! open the file

  open(unit=io,file=zfilenam,status='unknown',iostat=ios)
  if(ios.ne.0) then
     write(iout,*) ' ?ps2echin: "'//trim(zfilenam)//'" file open failure.'
     ierr=1
     return
  endif

  !------------------------------
  ! scalars...

  zbzxr = ss%g_eq(ss%nrho_eq)  ! vacuum R*B_phi (always positive), T*m
  zr0 = ss%r_axis              ! axis location, m
  zb0 = zbzxr/zr0              ! vacuum |B_phi|, T

  ztflux = ss%phit(ss%nrho_eq) ! enclosed toroidal flux, Wb
  zrmins = 100.0d0*sqrt(ztflux/(zpi*zb0)) ! nominal radius, cm

  zr0 = 100.0d0*zr0   ! ->cm
  zb0 = 1.0d4*zb0     ! ->Gauss

  inbfld = 3

  write(io, 1001) ss%t0
  write(io, 1000) idamp,inprof,inray,inbfld

  !RGA, give toray the same sign of B0 as in the psiin file.  Correct
  !     driven current sign in ps2trcom_ech()

  if (ss%kccw_Bphi<0) zb0=-zb0

  write(io, 1001) ss%freq_ec(iant), ss%ec_Omode_Fraction(iant), &
       100.0d0*ss%R_ec_launch(iant), 100.0d0*ss%Z_ec_launch(iant), &
       ss%ec_theta_aim(iant), ss%ec_phi_aim(iant), &
       ss%ec_half_power_angle(iant), ss%ec_beam_elongation(iant), &
       zr0,zb0,zrmins

  ! DMC Dec 2010: patch density to prevent dne/dx > 0 in edge

  if(allocated(znewk)) deallocate(znewk)
  allocate(znewk(inprof))
  znewk = zne_tor

  call find_inmin(ss%rho_ecrf,znewk,inside,inmin)

  call makedens_gneg(inprof,ss%rho_ecrf,znewk,zne_tor,zgfac, &
       inside,inprof,inmin, iout, istat)


  if(istat.ne.0) then
     call errmsg_exit(' ?ps2echin: error in density patch, makedens_gneg!')
  endif

  write(io, 1001) zplflx_tor(1:inprof)
  write(io, 1001) zef_tor(1:inprof)
  write(io, 1001) zne_tor(1:inprof)
  write(io, 1001) zte_tor(1:inprof)

1000 format (20i4)
1001 format (5e16.9)

  close(unit=io)

CONTAINS
  subroutine rezone_intrp(id,zans)
    integer, intent(in) :: id
    real*8, dimension(:) :: zans

    ! smoothed rezone to zone ctrs in "zwk"

    !------------
    real*8 :: zlim1,zlim2
    integer :: ix
    !------------

    call ps_rho_rezone(ss%rho_ecrf, id, zwk, ierr, &
         state=ss, zonesmoo=.TRUE.)

    ! interpolation to interior boundaries

    do ix=2,inprof-1
       zans(ix)=0.5d0*(zwk(ix-1)+zwk(ix))
    enddo

    ! constrained parabolic extrapolation to boundaries
    ! note: all profiles are positive quantities: {n,T,Zeff}

    zlim1=0.5d0*zwk(1)
    zlim2=1.5d0*zwk(1)

    zans(1)=(9*zwk(1)-zwk(2))/8
    zans(1)=max(zlim1,min(zlim2,zans(1)))

    zlim1=0.5d0*zwk(inm1)
    zlim2=1.5d0*zwk(inm1)

    zans(inprof)=(9*zwk(inm1)-zwk(inm1-1))/8
    zans(inprof)=max(zlim1,min(zlim2,zans(inprof)))

  end subroutine rezone_intrp

  subroutine find_inmin(zx,zne,ix1,inmin)

    ! find first point that is both inside x=0.9 and inboard of a point
    ! which is different from the edge value by more than 1/5 * (nmax-nmin)

    real*8, intent(in), dimension(:) :: zx,zne
    integer, intent(out) :: inmin

    integer :: ix,ix1,istart
    real*8 :: znmin,znmax,zdeln

    logical :: idiff_found,il_gneg

    do ix1=inprof-1,2,-1
       if(zx(ix1).le.0.9d0) exit
    enddo
    il_gneg=((zne(ix1)-zne(2)).lt.0d0) !Rough estimation of gradient sign: 
                                      !.true. negative gradient in 0<x<0.9

    if(il_gneg) then
       istart=2
       ix1=1
    else
       istart=ix1
    endif
    znmin=zne(ix1)
    znmax=znmin
    do ix=istart,inprof
       znmin=min(znmin,zne(ix))
       znmax=max(znmax,zne(ix))
    enddo
    
    zdeln = (znmax-znmin)/5
    
    idiff_found = .FALSE.
    
    if(il_gneg) then
       do ix=inprof-1,istart,-1
          if(abs(zne(ix)-zne(inprof)).gt.zdeln) idiff_found = .TRUE.
          if(idiff_found.AND.(zx(ix).le.0.9d0)) then
             inmin=ix
             exit
          endif
       enddo
    else
       do ix=inprof-1,istart,-1
          if(abs(zne(ix)-zne(inprof)).gt.zdeln) idiff_found = .TRUE.
          if(idiff_found) then
             inmin=ix
             exit
          endif
       enddo
    endif

  end subroutine find_inmin

end subroutine ps2echin

subroutine echin_ck_dampmod(nant,ndamp_in,ndamp_use,iout)

  implicit NONE

  ! check damping model selection

  integer, intent(in) :: nant   ! number of antennas
  integer, intent(in) :: ndamp_in(nant)   ! input damping model selection
  integer, intent(out) :: ndamp_use(nant) ! output selections to be used
  integer, intent(in) :: iout   ! Fortran I/O unit for messages
  
  ! these rules are based on the presumption that the same damping model
  ! is desirable for all antennas, in most simulations.

  ! Rules:

  !   (a) find the first antenna index iant such that ndamp_in(iant).gt.0;
  !       if no such index exists set idamp=0 otherwise idamp=ndamp_in(iant).
  !   (b) for all indices jant, the selected damping model is:
  !           idamp if ndamp_in(jant).gt.0
  !           abs(ndamp_in(jant)) if ndamp_in(jant).le.0

  !----------------
  integer :: iant,jant,idamp,iwarn
  !----------------

  ndamp_use = 0

  idamp = 0
  iwarn = 0

  do iant=1,nant
     if(ndamp_in(iant).gt.0) then
        idamp=ndamp_in(iant)
        exit
     endif
  enddo

  do jant=1,nant
     if(ndamp_in(jant).gt.0) then
        ndamp_use(jant)=idamp
     else
        ndamp_use(jant)=abs(ndamp_in(jant))
     endif
     if(ndamp_use(jant).ne.ndamp_in(jant)) iwarn = iwarn + 1
  enddo

  if(iwarn.gt.0) then
     write(iout,*) ' %echin_ck_dampmod: damping models adjusted: '
     write(iout,*) '  antenna#  input     use'
     do jant=1,nant
        write(iout,'(3(4x,i6))') jant,ndamp_in(jant),ndamp_use(jant)
     enddo
  endif

end subroutine echin_ck_dampmod

subroutine trx_ready(zsub,ierr)
!
!  check if we are connected to a run; if not, set error flag
!  and write message
!
!  also check if desired time has been set
!
  use trx_module
  implicit NONE
!
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
  character(*), intent(in) :: zsub    ! calling subroutine name for msgs
  integer, intent(out)     :: ierr    ! completion code, 0 = no error
!
  integer lunzer
!----------------------
!
  if(nsurf.eq.0) then
     write(lunzer(0),*) ' ?',zsub,': nsurf=0:  use trx_connect first!'
     ierr=1
     return
  endif
!
  if(itset.eq.0) then
     write(lunzer(0),*) ' ?',zsub,': itset=0:  use trx_time first!'
     ierr=1
     return
  endif
!
  ierr=0
  return
!
end subroutine trx_ready

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)

SUBROUTINE plasma_state_contents_sdata(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !local:

  INTEGER :: id,inum
  INTEGER :: i1,i2,i3,i4

  !----------------

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Balloon_stable
        w%list_elems(isize) = "Balloon_stable"
        w%elem_descr(isize) = "0: stable everywhere; =1: unstable somewhere"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nballoon)"
        IF(ALLOCATED(ss%Balloon_stable)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nballoon
              IF((ss%Balloon_stable(I1).NE.0).AND.(ss%Balloon_stable(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Balloon_status
        w%list_elems(isize) = "Balloon_status"
        w%elem_descr(isize) = "completion status: Ballooning codes"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nballoon)"
        IF(ALLOCATED(ss%Balloon_status)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nballoon
              IF((ss%Balloon_status(I1).NE.0).AND.(ss%Balloon_status(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_axis
        w%list_elems(isize) = "B_axis"
        w%elem_descr(isize) = "|B| at magnetic axis"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        IF(ss%B_axis.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_axis_vac
        w%list_elems(isize) = "B_axis_vac"
        w%elem_descr(isize) = "vacuum B field at axis"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        IF(ss%B_axis_vac.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_max_lcfs
        w%list_elems(isize) = "B_max_lcfs"
        w%elem_descr(isize) = "|B|_max of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        IF(ss%B_max_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! B_min_lcfs
        w%list_elems(isize) = "B_min_lcfs"
        w%elem_descr(isize) = "|B|_min of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "T"
        w%c256val(isize) = "scalar"
        IF(ss%B_min_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! coil_apt
        w%list_elems(isize) = "coil_apt"
        w%elem_descr(isize) = "SIGNED circuit current"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "amps/turn"
        w%c256val(isize) = "(ncircuits)"
        IF(ALLOCATED(ss%coil_apt)) THEN
           IF(MAXVAL(ABS(ss%coil_apt)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! DeltaW_stable
        w%list_elems(isize) = "DeltaW_stable"
        w%elem_descr(isize) = "0: stable; 1: unstable;"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(mmodes,ndelta_w)"
        IF(ALLOCATED(ss%DeltaW_stable)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%ndelta_w
              DO I1 = 1,ss%mmodes
                 IF((ss%DeltaW_stable(I1,I2).NE.0).AND.(ss%DeltaW_stable(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! DeltaW_status
        w%list_elems(isize) = "DeltaW_status"
        w%elem_descr(isize) = "completion status: Delta(W) codes"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(ndelta_w)"
        IF(ALLOCATED(ss%DeltaW_status)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%ndelta_w
              IF((ss%DeltaW_status(I1).NE.0).AND.(ss%DeltaW_status(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! dist_fun
        w%list_elems(isize) = "dist_fun"
        w%elem_descr(isize) = "distribution function filenames"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(0:nspec_alla)"
        IF(ALLOCATED(ss%dist_fun)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_alla
              IF(ss%dist_fun(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! dn0out
        w%list_elems(isize) = "dn0out"
        w%elem_descr(isize) = "Hydrogenic neutral density in scrape off region"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "scalar"
        IF(ss%dn0out.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! e0_av
        w%list_elems(isize) = "e0_av"
        w%elem_descr(isize) = 'average energy of neutral sources, "(3/2)*T0"'
        w%component(isize) = "GAS"
        w%elem_units(isize) = "KeV"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%e0_av)) THEN
           IF(MAXVAL(ABS(ss%e0_av)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! eldot
        w%list_elems(isize) = "eldot"
        w%elem_descr(isize) = "[d(Philim)/dt]/[2*Philim]"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "scalar"
        IF(ss%eldot.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! eqdsk_file
        w%list_elems(isize) = "eqdsk_file"
        w%elem_descr(isize) = "EFIT G-eqdsk file: psi(R,Z), g(psi), etc."
        w%component(isize) = "EQ"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "scalar"
        IF(ss%eqdsk_file.EQ." ") THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! frac_full
        w%list_elems(isize) = "frac_full"
        w%elem_descr(isize) = "fraction of beam current at full voltage"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%frac_full)) THEN
           IF(MAXVAL(ABS(ss%frac_full)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! frac_half
        w%list_elems(isize) = "frac_half"
        w%elem_descr(isize) = "fraction of beam current at half voltage"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%frac_half)) THEN
           IF(MAXVAL(ABS(ss%frac_half)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! gamma_lmhd
        w%list_elems(isize) = "gamma_lmhd"
        w%elem_descr(isize) = "ideal growth rate"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(mmodes,ndelta_w)"
        IF(ALLOCATED(ss%gamma_lmhd)) THEN
           IF(MAXVAL(ABS(ss%gamma_lmhd)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! isThermal
        w%list_elems(isize) = "isThermal"
        w%elem_descr(isize) = "=1 if minority specie is thermalized"
        w%component(isize) = "IC"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nspec_rfmin)"
        IF(ALLOCATED(ss%isThermal)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nspec_rfmin
              IF((ss%isThermal(I1).NE.0).AND.(ss%isThermal(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! kvolt_nbi
        w%list_elems(isize) = "kvolt_nbi"
        w%elem_descr(isize) = "energy of each beam source **keV**"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%kvolt_nbi)) THEN
           IF(MAXVAL(ABS(ss%kvolt_nbi)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! LMHD_status
        w%list_elems(isize) = "LMHD_status"
        w%elem_descr(isize) = "0: OK; =1: at least one code error occurred."
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%LMHD_status.EQ.0).OR.(ss%LMHD_status.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_machine_descr
        w%list_elems(isize) = "lock_machine_descr"
        w%elem_descr(isize) = "Machine_Description section lock"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%lock_machine_descr.EQ.0).OR.(ss%lock_machine_descr.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_shot_config
        w%list_elems(isize) = "lock_shot_config"
        w%elem_descr(isize) = "Shot_Configuration section lock"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%lock_shot_config.EQ.0).OR.(ss%lock_shot_config.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! lock_sim_init
        w%list_elems(isize) = "lock_sim_init"
        w%elem_descr(isize) = "Simulation_Init section lock"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%lock_sim_init.EQ.0).OR.(ss%lock_sim_init.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Mercier_stable
        w%list_elems(isize) = "Mercier_stable"
        w%elem_descr(isize) = "0: stable everywhere; =1: unstable somewhere"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nballoon)"
        IF(ALLOCATED(ss%Mercier_stable)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nballoon
              IF((ss%Mercier_stable(I1).NE.0).AND.(ss%Mercier_stable(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! MHD_eq_status
        w%list_elems(isize) = "MHD_eq_status"
        w%elem_descr(isize) = "0: OK; =1: MHD equilibrium refinement failed"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%MHD_eq_status.EQ.0).OR.(ss%MHD_eq_status.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nbeami_bdy
        w%list_elems(isize) = "nbeami_bdy"
        w%elem_descr(isize) = "beam ion densities at/beyond boundary"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nspec_beam)"
        IF(ALLOCATED(ss%nbeami_bdy)) THEN
           IF(MAXVAL(ABS(ss%nbeami_bdy)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nebar
        w%list_elems(isize) = "nebar"
        w%elem_descr(isize) = "line-averaged electron density"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "#/m^2"
        w%c256val(isize) = "scalar"
        IF(ss%nebar.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Newcomb_stable
        w%list_elems(isize) = "Newcomb_stable"
        w%elem_descr(isize) = "0: stable; 1: unstable;"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(mmodes,nnewcomb)"
        IF(ALLOCATED(ss%Newcomb_stable)) THEN
           w%ival(isize) = 0
           DO I2 = 1,ss%nnewcomb
              DO I1 = 1,ss%mmodes
                 IF((ss%Newcomb_stable(I1,I2).NE.0).AND.(ss%Newcomb_stable(I1,I2).NE.ps_unInit)) THEN
                    w%ival(isize) = 1
                    exit
                 ENDIF
              ENDDO   ! I1
           ENDDO   ! I2
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Newcomb_status
        w%list_elems(isize) = "Newcomb_status"
        w%elem_descr(isize) = "completion status: Newcomb codes"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nnewcomb)"
        IF(ALLOCATED(ss%Newcomb_status)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nnewcomb
              IF((ss%Newcomb_status(I1).NE.0).AND.(ss%Newcomb_status(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nfusi_bdy
        w%list_elems(isize) = "nfusi_bdy"
        w%elem_descr(isize) = "fusion ion densities at/beyond boundary"
        w%component(isize) = "IC"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nspec_fusion)"
        IF(ALLOCATED(ss%nfusi_bdy)) THEN
           IF(MAXVAL(ABS(ss%nfusi_bdy)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmdifb
        w%list_elems(isize) = "nmdifb"
        w%elem_descr(isize) = "type of fast ion diffusivity"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "scalar"
        IF((ss%nmdifb.EQ.0).OR.(ss%nmdifb.EQ.ps_unInit)) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmini_bdy
        w%list_elems(isize) = "nmini_bdy"
        w%elem_descr(isize) = "RF minority ion densities at/beyond boundary"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(nspec_rfmin)"
        IF(ALLOCATED(ss%nmini_bdy)) THEN
           IF(MAXVAL(ABS(ss%nmini_bdy)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! nmodel_bdy
        w%list_elems(isize) = "nmodel_bdy"
        w%elem_descr(isize) = "model density, boundary value"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "scalar"
        IF(ss%nmodel_bdy.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ns_bdy
        w%list_elems(isize) = "ns_bdy"
        w%elem_descr(isize) = "specie densities at/beyond boundary"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "m^-3"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%ns_bdy)) THEN
           IF(MAXVAL(ABS(ss%ns_bdy)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ns_is_input
        w%list_elems(isize) = "ns_is_input"
        w%elem_descr(isize) = "specie density measurement flag"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%ns_is_input)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_th
              IF((ss%ns_is_input(I1).NE.0).AND.(ss%ns_is_input(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! omegat_bdy
        w%list_elems(isize) = "omegat_bdy"
        w%elem_descr(isize) = "toroidal angular velocity at/beyond boundary"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "rad/sec"
        w%c256val(isize) = "scalar"
        IF(ss%omegat_bdy.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! picrf_abs
        w%list_elems(isize) = "picrf_abs"
        w%elem_descr(isize) = "RF power absorbed inside plasma"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%picrf_abs)) THEN
           IF(MAXVAL(ABS(ss%picrf_abs)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! picrf_ext
        w%list_elems(isize) = "picrf_ext"
        w%elem_descr(isize) = "RF power deposited outside plasma"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%picrf_ext)) THEN
           IF(MAXVAL(ABS(ss%picrf_ext)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_ec
        w%list_elems(isize) = "power_ec"
        w%elem_descr(isize) = "power on each ECRF source"
        w%component(isize) = "EC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(necrf_src)"
        IF(ALLOCATED(ss%power_ec)) THEN
           IF(MAXVAL(ABS(ss%power_ec)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_ic
        w%list_elems(isize) = "power_ic"
        w%elem_descr(isize) = "power on each ICRF source"
        w%component(isize) = "IC"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nicrf_src)"
        IF(ALLOCATED(ss%power_ic)) THEN
           IF(MAXVAL(ABS(ss%power_ic)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LH).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_lh
        w%list_elems(isize) = "power_lh"
        w%elem_descr(isize) = "power on each LHRF source"
        w%component(isize) = "LH"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nlhrf_src)"
        IF(ALLOCATED(ss%power_lh)) THEN
           IF(MAXVAL(ABS(ss%power_lh)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_nbi
        w%list_elems(isize) = "power_nbi"
        w%elem_descr(isize) = "power on each beam source"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%power_nbi)) THEN
           IF(MAXVAL(ABS(ss%power_nbi)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! power_nbi_trace
        w%list_elems(isize) = "power_nbi_trace"
        w%elem_descr(isize) = "power injected as trace element (if any)"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nbeam)"
        IF(ALLOCATED(ss%power_nbi_trace)) THEN
           IF(MAXVAL(ABS(ss%power_nbi_trace)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Psi_to_machine_axis
        w%list_elems(isize) = "Psi_to_machine_axis"
        w%elem_descr(isize) = "delta(Psi) from magnetic axis to machine axis"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "Wb/rad"
        w%c256val(isize) = "scalar"
        IF(ss%Psi_to_machine_axis.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! ql_operator
        w%list_elems(isize) = "ql_operator"
        w%elem_descr(isize) = "quasilinear operator filenames"
        w%component(isize) = "IC"
        w%elem_units(isize) = "character"
        w%c256val(isize) = "(0:nspec_alla)"
        IF(ALLOCATED(ss%ql_operator)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_alla
              IF(ss%ql_operator(I1).NE." ") THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_ns
        w%list_elems(isize) = "rho_bdy_ns"
        w%elem_descr(isize) = "locations beyond which densities are known"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%rho_bdy_ns)) THEN
           IF(MAXVAL(ABS(ss%rho_bdy_ns)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_omegat
        w%list_elems(isize) = "rho_bdy_omegat"
        w%elem_descr(isize) = "location beyond which angular velocity is known"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "scalar"
        IF(ss%rho_bdy_omegat.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_Te
        w%list_elems(isize) = "rho_bdy_Te"
        w%elem_descr(isize) = "location beyond which Te is known"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "scalar"
        IF(ss%rho_bdy_Te.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! rho_bdy_Ti
        w%list_elems(isize) = "rho_bdy_Ti"
        w%elem_descr(isize) = "location beyond which Ti is known"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "scalar"
        IF(ss%rho_bdy_Ti.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_axis
        w%list_elems(isize) = "R_axis"
        w%elem_descr(isize) = "R of magnetic axis"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%R_axis.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_max_lcfs
        w%list_elems(isize) = "R_max_lcfs"
        w%elem_descr(isize) = "R_max of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%R_max_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! R_min_lcfs
        w%list_elems(isize) = "R_min_lcfs"
        w%elem_descr(isize) = "R_min of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%R_min_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! sc0
        w%list_elems(isize) = "sc0"
        w%elem_descr(isize) = "edge neutral sources (atoms/sec)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%sc0)) THEN
           IF(MAXVAL(ABS(ss%sc0)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! t0
        w%list_elems(isize) = "t0"
        w%elem_descr(isize) = "time at beginning of IPS macro timestep"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        IF(ss%t0.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! t1
        w%list_elems(isize) = "t1"
        w%elem_descr(isize) = "time at end of IPS macro timestep"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "sec"
        w%c256val(isize) = "scalar"
        IF(ss%t1.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Te_bdy
        w%list_elems(isize) = "Te_bdy"
        w%elem_descr(isize) = "Electron temperature at/beyond boundary"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "KeV"
        w%c256val(isize) = "scalar"
        IF(ss%Te_bdy.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Ti_bdy
        w%list_elems(isize) = "Ti_bdy"
        w%elem_descr(isize) = "Ion temperature at/beyond boundary"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "KeV"
        w%c256val(isize) = "scalar"
        IF(ss%Ti_bdy.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! tmodel_bdy
        w%list_elems(isize) = "tmodel_bdy"
        w%elem_descr(isize) = "model temperature, boundary value"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "keV"
        w%c256val(isize) = "scalar"
        IF(ss%tmodel_bdy.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_LMHD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Tornum_balcrit
        w%list_elems(isize) = "Tornum_balcrit"
        w%elem_descr(isize) = "critical toroidal mode number for ballooning"
        w%component(isize) = "LMHD"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(nballoon)"
        IF(ALLOCATED(ss%Tornum_balcrit)) THEN
           w%ival(isize) = 0
           DO I1 = 1,ss%nballoon
              IF((ss%Tornum_balcrit(I1).NE.0).AND.(ss%Tornum_balcrit(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Ts_is_input
        w%list_elems(isize) = "Ts_is_input"
        w%elem_descr(isize) = "specie temperature measurement flag"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%Ts_is_input)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_th
              IF((ss%Ts_is_input(I1).NE.0).AND.(ss%Ts_is_input(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vphi0_av
        w%list_elems(isize) = "vphi0_av"
        w%elem_descr(isize) = "average toroidal velocity of neutral source"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "m/sec"
        w%c256val(isize) = "(ngsc0)"
        IF(ALLOCATED(ss%vphi0_av)) THEN
           IF(MAXVAL(ABS(ss%vphi0_av)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vpol_is_input
        w%list_elems(isize) = "vpol_is_input"
        w%elem_descr(isize) = "specie outer midplane poloidal velocit flag"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%vpol_is_input)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_th
              IF((ss%vpol_is_input(I1).NE.0).AND.(ss%vpol_is_input(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vsur
        w%list_elems(isize) = "vsur"
        w%elem_descr(isize) = "toroidal voltage at surface"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Volts"
        w%c256val(isize) = "scalar"
        IF(ss%vsur.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! vtor_is_input
        w%list_elems(isize) = "vtor_is_input"
        w%elem_descr(isize) = "specie outer midplane toroidal velocit flag"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "integer"
        w%c256val(isize) = "(0:nspec_th)"
        IF(ALLOCATED(ss%vtor_is_input)) THEN
           w%ival(isize) = 0
           DO I1 = 0,ss%nspec_th
              IF((ss%vtor_is_input(I1).NE.0).AND.(ss%vtor_is_input(I1).NE.ps_unInit)) THEN
                 w%ival(isize) = 1
                 exit
              ENDIF
           ENDDO   ! I1
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! wt_nphi_abs
        w%list_elems(isize) = "wt_nphi_abs"
        w%elem_descr(isize) = "absorbed spectrum n_phi weight"
        w%component(isize) = "IC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_num_nphi,nicrf_src)"
        IF(ALLOCATED(ss%wt_nphi_abs)) THEN
           IF(MAXVAL(ABS(ss%wt_nphi_abs)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_IC).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! wt_nphi_ext
        w%list_elems(isize) = "wt_nphi_ext"
        w%elem_descr(isize) = "fraction of power deposited outside"
        w%component(isize) = "IC"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(max_num_nphi,nicrf_src)"
        IF(ALLOCATED(ss%wt_nphi_ext)) THEN
           IF(MAXVAL(ABS(ss%wt_nphi_ext)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_RAD).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! xs
        w%list_elems(isize) = "xs"
        w%elem_descr(isize) = "impurity source magnitude (atoms/sec)"
        w%component(isize) = "RAD"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nxs)"
        IF(ALLOCATED(ss%xs)) THEN
           IF(MAXVAL(ABS(ss%xs)).EQ.0.0_rspec) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_axis
        w%list_elems(isize) = "Z_axis"
        w%elem_descr(isize) = "Z of magnetic axis"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%Z_axis.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_max_lcfs
        w%list_elems(isize) = "Z_max_lcfs"
        w%elem_descr(isize) = "Z_max of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%Z_max_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_data) THEN
        isize = isize + 1  ! Z_min_lcfs
        w%list_elems(isize) = "Z_min_lcfs"
        w%elem_descr(isize) = "Z_min of last closed flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "scalar"
        IF(ss%Z_min_lcfs.EQ.0.0_rspec) THEN
           w%ival(isize) = 0
        ELSE
           w%ival(isize) = 1
        ENDIF
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_sdata

C******************** START FILE UFSCPR.FOR ; GROUP UFSCLK *************
C---------------------------------------------------------------
C  UFSCPR
C  PRINT SCALARS ON PLOT DEVICE
C
      SUBROUTINE UFSCPR(ZFILE,SCLAB,SCVAL,IORDER,NSC,ICONT)
C
      CHARACTER*80 ZLINE
      CHARACTER*40 ZFILE
      CHARACTER*10 SCLAB(3,NSC)
      REAL SCVAL(NSC)
      INTEGER IORDER(NSC)
C
C  DRAW FRAME
      JCONT=MAX0(0,ICONT)
C  STARTING NEW OR CONTINUING OLD PAGE?
      IF(JCONT.EQ.0) GO TO 100
      IY=IY+IDY
      ILINE=ILINE+1
      IPT=0
      GO TO 115
 100  CONTINUE
C
      IPAGE=0
      IPT=0
 110  CONTINUE
      IPAGE=IPAGE+1
      CALL UBINIT(0)
      CALL DPLOFR(20,1020,20,760,0)
      IX=30
      IY=730
      IDY=-23
      IMAX=27
 115  CONTINUE
 3001 FORMAT(' SCALARS IN "',A40,'"     PAGE ',I2,'$')
      WRITE(ZLINE,3001) ZFILE,IPAGE
      IDOLLR=INDEX(ZLINE,'$')-1
      CALL AGTMHS(IX,IY,ZLINE,IDOLLR)
      IY=IY+2*IDY
 3002 FORMAT(
     >  '     KEYWORD     VALUE         LABEL       PHYSICAL UNITS$')
 3003 FORMAT(
     >  '     ----------  ------------  ----------  ----------$')
 3004 FORMAT(
     >  '     ',A10,   '  ',1PE12.5, '  ',A10,   '  ',A10,'$')
      WRITE(ZLINE,3002)
      IDOLLR=INDEX(ZLINE,'$')-1
      CALL AGTMHS(IX,IY,ZLINE,IDOLLR)
      IY=IY+IDY
      WRITE(ZLINE,3003)
      IDOLLR=INDEX(ZLINE,'$')-1
      CALL AGTMHS(IX,IY,ZLINE,IDOLLR)
      IY=IY+IDY
C  FETCH NEXT SCALAR
      IF(JCONT.EQ.0) ILINE=0
      JCONT=0
 120  CONTINUE
      IPT=IPT+1
      IF(IPT.GT.NSC) GO TO 190
      ILINE=ILINE+1
      IF(ILINE.LT.IMAX) GO TO 125
      IPT=IPT-1
      GO TO 130
 125  CONTINUE
      ISC=IORDER(IPT)
      WRITE(ZLINE,3004) SCLAB(1,ISC),SCVAL(ISC),SCLAB(2,ISC),
     >     SCLAB(3,ISC)
      IDOLLR=INDEX(ZLINE,'$')-1
      CALL AGTMHS(IX,IY,ZLINE,IDOLLR)
      IY=IY+IDY
      GO TO 120
C  END OF PAGE
 130  CONTINUE
      CALL UPAUST(2)
      GO TO 110
C  END OF LIST
 190  CONTINUE
      IF(ICONT.GT.-1)  CALL UPAUST(2)
      RETURN
C---------
      END
C******************** END FILE UFSCPR.FOR ; GROUP UFSCLK ***************

!.........................................................
!            SUBROUTINE TR_ADD_REPLACE
!.........................................................
 
subroutine tr_add_replace(zline,znew,zpat)
!
  use tr_getnl
  implicit NONE
!
  integer iline,jline,kline
  character*(*), intent(in) :: zline,znew,zpat
  character(120) :: sltext
! real, intent(in) :: rvar
!------------------------------
!
! print *,'In the routine tr_add_replace'
! print *,zline,znew
 
 
! If the pattern zline is in any string, replace it.
 
  do iline=1,mltext_nlines
   if (index(mltext(iline),zline).ne.0) then
     mltext(iline)=zline//'='//znew
   endif
  enddo
 
! If the pattern zline is not in any string, add a line.
! If zpat is not a null string, add the string containing
! zline after the line with the pattern zpat.
 
  jline=0
  do iline=1,mltext_nlines
   if (index(mltext(iline),zline).eq.0) then
     jline=jline+1
   endif
  enddo
 
  kline=0
  if (zpat.ne." ") then
   do iline=1,mltext_nlines
    if (index(mltext(iline),trim(zpat)).ne.0) then
     kline=iline
    endif
   enddo
  endif
 
  if((jline.eq.mltext_nlines).and.(kline.eq.0)) then
     mltext_nlines=mltext_nlines+1
     mltext(mltext_nlines)=zline//'='//znew
  elseif ((jline.eq.mltext_nlines).and.(kline.ne.0)) then
     sltext=zline//'='//znew
     do iline=mltext_nlines,kline+1,-1
      mltext(iline+1)=mltext(iline)
     enddo
     mltext(kline+1)=sltext
     mltext_nlines=mltext_nlines+1
  endif
 
  return
end subroutine tr_add_replace

subroutine trx_nspec(n_species)
!
!  return the number of plasma species (including electrons) present
!  in the currently open run.
!
!  if no run is open, return n_species=0.
!
  use trx_module
!
  implicit NONE
!
  integer, intent(out) :: n_species
!
!------------------------------------------------
!
  integer n_thi,n_thx,n_bi,n_rfi,n_fusi
  integer lunzer
!
!------------------------------------------------
!
  if(nsurf.eq.0) then
     write(lunzer(0),*) '?trx_nspec:  use trx_connect to open a run, first!'
     n_species=0
  else
     call rd_nspecies(n_species,n_thi,n_thx,n_bi,n_rfi,n_fusi)
  endif
end subroutine trx_nspec

subroutine trx_calc(zname,zdescr,zunits,zexpr,iwarn,ierr)
!
!  invoke the rplot calculator -- return no data
!  the calculator can create named items, to be retrieved by
!  subsequent calls...
!
  implicit NONE
  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
!
!  input:
  character*(*) zname  ! name of item to define in computation
  character*(*) zdescr ! description of item
  character*(*) zunits ! physical units
  character*(*) zexpr  ! calculator expression
!
!  output:
  integer iwarn,ierr   ! rpcalc warning and error flags
!
!  local...
!
  integer istype
  real zdum(2)
  integer idum
!
  character*500 zbig_expr
!
!----------------------
!
  zbig_expr = zname//','//zdescr//','//zunits//' = '//zexpr
  call rpcalc(zbig_expr,zdum,0,idum,istype,iwarn,ierr)
!
  return
end subroutine trx_calc

C******************** START FILE INT2D.FOR ; GROUP INT2D ***************
C****************************************************
C  REV D. MC CUNE AUG 1982 - NO SIGN CHECK IS MADE.  ROUTINE
C  GENERALIZED TO HANDLE FUNCTIONS WHICH ARE NOT POSITIVE-DEFINITE
C
C  dmc 3/2008 -- clean up some FORMAT stmts
C
      SUBROUTINE INT2D(ZTDAT , ITDAT1,
     1			 ZRDAT , IRDAT1,
     2			 ZDAT2D, ITIM2D, IRDAT2,
     3			 ZTINT ,
     4			 ZRINT , IZRINT, ZOUT1D,
     5			 ZSLOPI,
     6			 INTTYP, ILDBUG, IERR, IOUT)
C
C   2.25   INTERPOLATE A 2-D ARRAY FNC. OF T&R TO GET
C	   A 1-D VECTOR FNC. OF R AT A GIVEN TIME
C
C=======
C  D. MC CUNE 11 JUNE 1981-- ADDED OUTPUT CHANNEL "IOUT"
C  REPLACES "TYPE" STATEMENTS
C=======
C   AUTHOR: BOB MCCANN, JAN.81
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER irdat1,itim2d,irdat2,izrint,iout,itdat1,iclass,isub
      INTEGER icall,ihuge,i,iminr,imaxr,irev,jt,j,jt1,jt2,irdm1,ilb
      INTEGER iub,mark,jub,jlb
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 ztint,zmin,zrmin,zrmax,zright,zsign,zzmin,zdr,zleft,zr
      REAL*8 zr2,zr1,zdt,zdt1,zdt2,zrg2,zlf2,zdr1,zdr2
!============
      INTEGER	INTTYP		!INPUT CONTROL FOR B.C.'S
C				!AND INTERPOLATION TYPE(SPLINE,
C				!LINEAR, ETC.)
C
      REAL*8	ZTDAT(ITDAT1)	!INPUT TIME VECTOR
      REAL*8	ZRDAT(IRDAT1)	!INPUT RADIUS VECTOR
      REAL*8	ZDAT2D(ITIM2D,IRDAT2)	!INPUT 2D ARRAY
      REAL*8	ZRINT(IZRINT)	!RADIUS VECTOR FOR OUTPUT
      REAL*8	ZOUT1D(IZRINT)	!OUTPUT 1D VECTOR FNC. OF RADIUS
      REAL*8	ZSLOPE,ZSLOPI   !SLOPE FOR EXTRAP. BEYOND EDGES
C				!IN RADIAL DIRECTION
      LOGICAL	ILDBUG		!LOGICAL SWITCH FOR DEBUGGING
C
      INTEGER	IERR		!ERROR FLAG FOR RETURN
C
C****	INCLUDE 'TRCOM/NOLIST'	!THIS SHOULDN'T BE NECESSARY
C
C   THIS SUBROUTINE INTERPOLATES THE 2D ARRAY ZDAT2D TO GET
C   A SLICE AT CONSTANT TIME=ZTINT AS A FUNCTION OF RADIUS
C
C   IF ZTINT IS BEFORE ZTDAT(1) OR AFTER ZTDAT(ITDAT1), THEN
C   THE FIRST OR LAST SLICE AVAILABLE IS USED. OTHERWISE LINEAR
C   INTERPOLATION IS USED IN TIME AND RADIUS TO GET THE VALUES
C   TO BE PUT INTO ZOUT1D.
C
C   IF ANY ZRINT(J) RADII ARE OUTSIDE ZRDAT(J) THEN THE END-
C   POINT VALUES ARE USED ACCORDING TO THE VALUES OF  INTTYP
C   AS FOLLOWS:
C
C	INTTYP.EQ.0     !no extrapolation -- out of range data = 0.0
C	INTTYP.EQ. 1	!FLAT EXTRAP. IN R
C	INTTYP.EQ.2	!LINEAR EXTRAPOLATION WITH SLOPE=ZSLOPI
C       INTTYP.EQ.3     !EXTRAP. WITH CONSTANT SLOPE.
C			!FOR BOTH SIDES IN R
C
C
      DATA	IHUGE/1000000/		!CRAZY TO INT.THIS MANY
C
C  PARM. TO PREVENT EXTRAPOLATION TO NEGATIVE NUMBERS
C  QUICK FIX D. MC CUNE 2 FEB 1982
C   EXTRAPOLATION TO .LT. ZMIN*EDGE VALUE EXTRAPOLATED FROM DISALLOWED
      DATA ZMIN/.05_R8/
C****************************************************
C
      ZSLOPE=ZSLOPI
      IERR = 0
C
C-----------------------
C   CHECK FOR BAD INPUTS
C-----------------------
C
      IF(IRDAT1.LT.2 .OR. IRDAT1.GT.IHUGE)GO TO 40100
      IF(IRDAT2.LT.2 .OR. IRDAT2.GT.IHUGE)GO TO 40120
      IF(IZRINT.LT.1 .OR. IZRINT.GT.IHUGE)GO TO 40200
      IF(ITDAT1.LT.1 .OR. ITDAT1.GT.IHUGE)GO TO 40300
      IF(ITIM2D.LT.1 .OR. ITIM2D.GT.IHUGE)GO TO 40320
      IF(IRDAT1.GT.IRDAT2)GO TO 40330
      IF(ITDAT1.GT.ITIM2D)GO TO 40340
C
      IF((INTTYP.LT.0).OR.(INTTYP.GT.3)) GO TO 40800
C
C   CHECK THE ORDER OF THE VECTORS
C
      DO 10 I = 1, IRDAT1-1
        IF(ZRDAT(I).GE.ZRDAT(I+1))GO TO 40400
10    CONTINUE
C
      IF(IZRINT.LE.1)GO TO 30
      DO 20 I = 1, IZRINT-1
        IF(ZRINT(I).GE.ZRINT(I+1))GO TO 40500
20    CONTINUE
C
30    CONTINUE
C
      IF(ITDAT1.LE.1)GO TO 50
      DO 40 I = 1, ITDAT1-1
        IF(ZTDAT(I).GE.ZTDAT(I+1))GO TO 40600
40    CONTINUE
C
50    CONTINUE
C
C-------------------------------
C   SET UP FOR THE INTERPOLATION
C-------------------------------
C
C
C   FIND THE INDICES FOR WHICH RADIAL INTERP IS DEFAULTED
C
      ZRMIN = ZRDAT(1)
      IMINR = 0
      ZRMAX = ZRDAT(IRDAT1)
      IMAXR = IZRINT + 1
C
      DO 100 I = 1, IZRINT
        IREV = IZRINT+1-I
        IF(ZRDAT(1).GT.ZRINT(I)) IMINR = I
        IF(ZRDAT(IRDAT1).LT.ZRINT(IREV)) IMAXR = IREV
100   CONTINUE
C
      IF(ILDBUG)WRITE(IOUT,101) ZRDAT(1),ZRDAT(IRDAT1),IMINR,IMAXR,
     1			  ZRINT(1),ZRINT(IZRINT)
C
101   FORMAT(' INT2D DBUG: ZRDATMIN,ZRDATMAX,IMINR,IMAXR,',/,
     1		' ZRLEFT,ZRIGHT=',2(1PE13.6),2I5,2(1PE13.6))
C
C   FIND THE TIME INDEX. I.E. INTERP BETWEEN JT1 & JT2
C
      JT = 0
C
      DO 200 J = 1, ITDAT1
        IF(ZTDAT(J).LE.ZTINT)JT = J
200   CONTINUE
C
      JT1 = max(1,JT)
      JT2 = min(ITDAT1,JT+1)
C
C   DO THE DEFAULT ANSWERS IF OUT OF BOUNDS
C   THE RADIAL VALUES ARE DEFAULTED FOR  I.LE.IMINR  AND  I.GE.IMAXR
C   THE ENTIRE VECTOR IS DEFAULTED IF JT=0 OR JT=ITDAT1
C
C
C---------------------------------------------------------
C   DO THE TIME DEFAULTED CASE FIRST (ZTINT OUT OF RANGE)
C---------------------------------------------------------
C
C
      IF(JT1.NE.JT2)GO TO 5000	!DO THE 4-POINT THERE
C
C	DO THE LEFT SIDE DEFAULT FIRST
C
      IF(IMINR.LT.1)GO TO 1000
C
      ZRIGHT = ZDAT2D(JT1,1)
      IF(INTTYP.EQ.3) ZSLOPE=(ZDAT2D(JT1,2)-ZDAT2D(JT1,1))/
     >                          (ZRDAT(2)-ZRDAT(1))
C  SIGN GENERALIZATION - EXTRAPOLATION NOT ALLOWED TO CHANGE SIGN
C  (PREVIOUSLY FORCED POSITIVE)
      ZSIGN=SIGN(1.0_R8,ZRIGHT)
      ZZMIN=ZMIN*ZRIGHT*ZSIGN
      ZDR = ZRDAT(1) - ZRINT(1)
      ZLEFT = ZDAT2D(JT1,1) - ZSLOPE*ZDR	!RMAJOR SIDE
C
      DO 500 I = 1, IMINR
        IF(INTTYP.EQ.0) THEN
          ZOUT1D(I)=0.0_R8
        ELSE IF(INTTYP.EQ.1) THEN
          ZOUT1D(I) = ZRIGHT	    !CONST.EXTRAP
        ELSE
          ZOUT1D(I) =  ZSIGN * max(ZZMIN,
     1		ZSIGN * ((ZRDAT(1)-ZRINT(I))*ZLEFT/ZDR +
     2		(ZRINT(I) - ZRINT(1))*ZRIGHT/ZDR)  )
        ENDIF
C	THAT'S THE LINEAR EXTRAP.
500   CONTINUE
C
1000  CONTINUE
C
C   	DO THE RIGHT SIDE DEFAULT NEXT
C
      IF(IMAXR.GT.IZRINT)GO TO 2000	!THEN DO THE INTERIOR
C
      IRDM1=IRDAT1-1
      IF(INTTYP.EQ.3) ZSLOPE=(ZDAT2D(JT1,IRDAT1)-ZDAT2D(JT1,IRDM1))/
     >                          (ZRDAT(IRDAT1)-ZRDAT(IRDM1))
      ZLEFT  = ZDAT2D(JT1,IRDAT1)
      ZSIGN=SIGN(1.0_R8,ZLEFT)
      ZZMIN=ZMIN*ZLEFT*ZSIGN
      ZDR = ZRINT(IZRINT) - ZRDAT(IRDAT1)
      ZRIGHT = ZLEFT + ZSLOPE*ZDR
C
      DO 1500 I = IMAXR, IZRINT
        IF(INTTYP.EQ.0) THEN
          ZOUT1D(I)=0.0_R8
        ELSE IF(INTTYP.EQ.1) THEN
          ZOUT1D(I) = ZLEFT	!CONST.EXTRAP
        ELSE
          ZOUT1D(I) = ZSIGN * max(ZZMIN,
     1		ZSIGN * ((ZRINT(IZRINT)-ZRINT(I))*ZLEFT/ZDR +
     2		(ZRINT(I) - ZRDAT(IRDAT1))*ZRIGHT/ZDR)  )
        ENDIF
C	THAT'S THE LINEAR EXTRAP
1500  CONTINUE
C
C	THEN DO THE INTERIOR
C
2000  CONTINUE
C
      IF( (IMINR+1).GT.(IMAXR-1) )GO TO 10000	!DONE
C
      ILB = IMINR+1
      IUB = IMAXR-1
      MARK = 1		!WE'LL BE MOVING THE L.B.
      JUB = IRDAT1 - 1
C
      DO 3000 I = ILB, IUB
        ZR = ZRINT(I)
        JLB = MARK		!NEVER DECREASE LOWER BOUND
C
        DO 3100 J = JLB, JUB
          MARK = J
          IF(ZRDAT(J).LE.ZR .AND. ZR.LE.ZRDAT(J+1))GO TO 3200
3100    CONTINUE
C
C		IF IT GOT HERE WE'RE IN DEEP TROUBLE
C
        GO TO 41000		!ERROR EXIT
C
C   DO THE INTERPOLATION HERE
C
3200    CONTINUE
C
        ZDR = ZRDAT(MARK+1) - ZRDAT(MARK)
        ZR2= (ZRDAT(MARK+1) - ZR)/ZDR
        ZR1 = (ZR - ZRDAT(MARK))/ZDR
C
        ZOUT1D(I)=ZR2*ZDAT2D(JT1,MARK)+ZR1*ZDAT2D(JT1,MARK+1)
C
3000  CONTINUE
C
      GO TO 10000				!DONE
C
C
C------------------------------------
C   DO THE FULL 2D INTERPOLATION HERE
C------------------------------------
C
C
5000  CONTINUE
C
      ZDT = ZTDAT(JT2) - ZTDAT(JT1)
      ZDT1 = (ZTINT - ZTDAT(JT1))/ZDT
      ZDT2 = (ZTDAT(JT2) - ZTINT)/ZDT
C
C	DO THE LEFT SIDE DEFAULT FIRST
C
      IF(IMINR.LT.1)GO TO 5200
C
      ZRIGHT = ZDT2*ZDAT2D(JT1,1) + ZDT1*ZDAT2D(JT2,1)
      IF(INTTYP.EQ.3) THEN
        ZRG2= ZDT2*ZDAT2D(JT1,2)+ZDT1*ZDAT2D(JT2,2)
        ZSLOPE=(ZRG2-ZRIGHT)/(ZRDAT(2)-ZRDAT(1))
      ENDIF
      ZSIGN=SIGN(1.0_R8,ZRIGHT)
      ZZMIN=ZMIN*ZRIGHT*ZSIGN
      ZDR = ZRDAT(1) - ZRINT(1)
      ZLEFT = ZDAT2D(JT1,1) - ZSLOPE*ZDR
C
      DO 5100 I = 1, IMINR
        IF(INTTYP.EQ.0) THEN
          ZOUT1D(I)=0.0_R8
        ELSE IF(INTTYP.EQ.1) THEN
          ZOUT1D(I) = ZRIGHT	!CONST. EXTRAP
        ELSE
      	ZOUT1D(I) = ZSIGN*max(ZZMIN,
     >             ZSIGN * ((ZRDAT(1)-ZRINT(I))*ZLEFT/ZDR
     2			+   (ZRINT(I)-ZRINT(1))*ZRIGHT/ZDR)  )
        ENDIF
C	THAT'S THE LINEAR EXTRAP
5100  CONTINUE
C
5200  CONTINUE
C
C	DO THE RIGHT SIDE DEFAULT NEXT
C
      IF(IMAXR.GT.IZRINT)GO TO 5400
C
      ZLEFT = ZDT2*ZDAT2D(JT1,IRDAT1)+ZDT1*ZDAT2D(JT2,IRDAT1)
      IF(INTTYP.EQ.3) THEN
        IRDM1=IRDAT1-1
        ZLF2=ZDT2*ZDAT2D(JT1,IRDM1)+ZDT1*ZDAT2D(JT2,IRDM1)
        ZSLOPE=(ZLEFT-ZLF2)/(ZRDAT(IRDAT1)-ZRDAT(IRDM1))
      ENDIF
      ZSIGN=SIGN(1.0_R8,ZLEFT)
      ZZMIN=ZMIN*ZLEFT*ZSIGN
      ZDR = ZRINT(IZRINT) - ZRDAT(IRDAT1)
      ZRIGHT = ZLEFT + ZSLOPE*ZDR
C
      DO 5300 I = IMAXR, IZRINT
        IF(INTTYP.EQ.0) THEN
          ZOUT1D(I)=0.0_R8
        ELSE IF(INTTYP.EQ.1) THEN
          ZOUT1D(I) = ZLEFT	!CONST. EXTRAP
        ELSE
          ZOUT1D(I) = ZSIGN*max(ZZMIN,
     1		ZSIGN*((ZRINT(IZRINT)-ZRINT(I))*ZLEFT/ZDR +
     2		(ZRINT(I) - ZRDAT(IRDAT1))*ZRIGHT/ZDR)  )
        ENDIF
C	THAT'S THE LINEAR EXTRAP
5300  CONTINUE
C
5400  CONTINUE
C
C	THEN DO THE INTERIOR
C
      ILB = IMINR + 1
      IUB = IMAXR - 1
      MARK = 1
      JUB = IRDAT1 - 1
C
      IF(ILB.GT.IUB)GO TO 10000	!DONE
C
      DO 6000 I = ILB, IUB
        ZR = ZRINT(I)
        JLB = MARK		!NEVER STEP BACKWARDS
C
        DO 6100 J = JLB, JUB
          MARK = J
          IF(ZRDAT(J).LE.ZR .AND. ZR.LE.ZRDAT(J+1))GO TO 6200
6100    CONTINUE
C
C	IF IT GOT HERE WE'RE IN DEEP TROUBLE
C
      GO TO 41100		!ERROR EXIT
C
C   DO THE 4-POINT INTERPOLATION
C
6200    CONTINUE
C
        ZDR = ZRDAT(MARK+1) - ZRDAT(MARK)
        ZDR1 = (ZR - ZRDAT(MARK))/ZDR
        ZDR2 = (ZRDAT(MARK+1) - ZR)/ZDR
C
        ZOUT1D(I) = ZDT2*(ZDR2*ZDAT2D(JT1,MARK) +
     1			    ZDR1*ZDAT2D(JT1,MARK+1) )  +
     2		      ZDT1*(ZDR2*ZDAT2D(JT2,MARK) +
     3			    ZDR1*ZDAT2D(JT2,MARK+1) )
C
6000  CONTINUE
C
C   DONE!
C
10000 CONTINUE
C
C---------------------------------
C   FINAL CLEAN-UP & ERROR CHECK
C---------------------------------
C
CT	DO 10100 I = 1, IZRINT
CT	  ISAVE = I			!BOTH NE & TE MUST BE POS.
CT	  IF(ZOUT1D(I).LE.0.0)GO TO 40700
CT10100	CONTINUE
C
20000 CONTINUE		!GO HERE AFTER ERROR MSG.
      RETURN
C
C
C---------------------------------
C   ERROR HANDLING, MESSAGES, ETC.
C---------------------------------
C
C
40100 CONTINUE
      WRITE(IOUT,40101) IRDAT1, IHUGE
40101 FORMAT(' INT2D ERROR: IRDAT1 OUT OF BOUNDS. IRDAT1=',
     1		I10,/,' IRDAT1 RANGE=2 TO ',I10)
C
      IERR = 1
      GO TO 20000
C
40120 CONTINUE
      WRITE(IOUT,40121) IRDAT2, IHUGE
40121 FORMAT(' INT2D ERROR: IRDAT2 OUT OF BOUNDS. IRDAT2=',
     1		I10,/,' IRDAT2 RANGE=2 TO ',I10)
C
      IERR = 2
      GO TO 20000
C
40200 CONTINUE
      WRITE(IOUT,40201) IZRINT, IHUGE
40201 FORMAT(' INT2D ERROR: IZRINT OUT OF BOUNDS. IZRINT=',
     1		I10,/,' IZRINT RANGE=1 TO ',I10)
C
      IERR = 3
      GO TO 20000
C
40300 CONTINUE
      WRITE(IOUT,40301) ITDAT1, IHUGE
40301 FORMAT(' INT2D ERROR: ITDAT1 OUT OF BOUNDS. ITDAT1=',
     1		I10,/,' ITDAT1 RANGE=1 TO ',I10)
C
      IERR = 4
      GO TO 20000
C
40320 CONTINUE
      WRITE(IOUT,40321) ITIM2D, IHUGE
40321 FORMAT(' INT2D ERROR: ITIM2D OUT OF BOUNDS. ITIM2D=',
     1		I10,/,' ITIM2D RANGE=1 TO ',I10)
C
      IERR = 5
      GO TO 20000
C
40330 CONTINUE
      WRITE(IOUT,40331) IRDAT1, IRDAT2
40331 FORMAT(' INT2D ERROR: ARRAY DIMENSION ERROR;',/,
     1		' 1D RADIAL DIM. MUST BE .LE. 2D DIM.',/,
     2		' 1D DIM=',I6,' 2D DIM=',I6)
C
      IERR = 6
      GO TO 20000
C
40340 CONTINUE
      WRITE(IOUT,40341) ITDAT1, ITIM2D
40341 FORMAT(' INT2D ERROR: ARRAY DIMENSION ERROR;',/,
     1		' 1D TIME DIM. MUST BE .LE. 2D DIM.',/,
     2		' 1D DIM=',I6,' 2D DIM=',I6)
C
      IERR = 7
      GO TO 20000
C
40400 CONTINUE
      WRITE(IOUT,40401) ZRDAT
40401 FORMAT(' INT2D ERROR: ZRDAT MUST BE IN ASCENDING ORDER.'
     1		,/,' ZRDAT = ',/,(' ',5(1PE13.6)))
      write(iout,40699) 'ZRDAT',i,zrdat(i),'ZRDAT',i+1,zrdat(i+1)
C
      IERR = 8
      GO TO 20000
C
40500 CONTINUE
      WRITE(IOUT,40501) ZRINT
40501 FORMAT(' INT2D ERROR: ZRINT MUST HAVE ASCENDING ORDER.'
     1		,/,' ZRINT = ',/,(' ',5(1PE13.6)))
      write(iout,40699) 'ZRINT',i,zrint(i),'ZRINT',i+1,zrint(i+1)
C
      IERR = 9
      GO TO 20000
C
40600 CONTINUE
      WRITE(IOUT,40601) ZTDAT
40601 FORMAT(' INT2D ERROR: ZTDAT MUST HAVE ASCENDING ORDER.'
     1		,/,' ZTDAT = ',/,(' ',5(1PE13.6)))
      write(iout,40699) 'ZTDAT',i,ztdat(i),'ZTDAT',i+1,ztdat(i+1)
C
40699 format(4x,a,'(',i5,')=',1pe13.6,4x,a,'(',i5,')=',1pe13.6)
C
      IERR = 10
      GO TO 20000
C
CT40700	CONTINUE
CT	WRITE(IOUT,40701) ISAVE, (ZOUT1D(I),I=1,IZRINT)
CT40701	FORMAT(' INT2D ERROR: VAL(INDEX) MUST BE POSITIVE,',/,
CT     1		' INDEX=',I5,' VALUES=',/,(' ',5(1PE13.6)) )
C
CT	IERR = 11
CT	GO TO 20000
C
40800 CONTINUE
      WRITE(IOUT,40801) INTTYP
40801 FORMAT(' INT2D ERROR: INTERPOLATION TYPE =',I5,' NOT',
     1		' SUPPORTED')
C
      IERR = 12
      GO TO 20000
C
41000 CONTINUE
      WRITE(IOUT,41001) ZR, ZRDAT(1), ZRDAT(IRDAT1)
41001 FORMAT(' INT2D ERROR: R=',1pe13.6,' NOT IN RANGE',/,
     1		' ',1pe13.6,' .LE. R .LE. ',1pe13.6,/,
     2		' @TIME DEFAULT RADIAL EXTRAP. SOMETHING ',/,
     3		' IS LIKELY TO BE WRONG WITH IMINR OR IMAXR',/,
     4		' OR THEIR USE.')
C
      IERR = 13
      GO TO 20000
C
41100 CONTINUE
      WRITE(IOUT,41101) ZR, ZRDAT(1), ZRDAT(IRDAT1)
41101 FORMAT(' INT2D ERROR: R=',1pe13.6,' NOT IN RANGE',/,
     1		' ',1pe13.6,' .LE. R .LE. ',1pe13.6,/,
     2		' @FULL 2D RADIAL EXTRAP. SOMETHING IS LIKELY',
     3	    /,' TO BE WRONG WITH IMINR OR IMAXR OR THEIR USE.')
C
      IERR = 14
      GO TO 20000
C
      END
C******************** END FILE INT2D.FOR ; GROUP INT2D *****************
! 19jan2003 fgtok -s r8_precision.sub all.sub "r8con.csh conversion"

module trdatbuf_obj
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  ! module to define the trdatbuf data type -- container variable
  !    for trdat data (transp physics input data -- diagnostic, measured data)
  !
  ! only a data type is defined here...
 
  integer, parameter, private :: MIMPS = 8
  integer, parameter, private :: MIMPT = 300
 
  type trdatbuf
 
    real*8, dimension(:), pointer :: DATBUF
    integer :: LADR_ZA
    integer :: LADR_ZAF
    integer :: LAEPDE
    integer :: LAEPDP
    integer :: LAEPE
    integer :: LAEPMAP
    integer :: LAEPMU
    integer :: LAEPP
    integer :: LAEPSP
    integer :: LAEPTS
    integer :: LAIMPS
    integer :: LAIMPX
    integer :: LBX(8)
    integer :: LDATALP
    integer :: LDATBDI
    integer :: LDATCUR
    integer :: LDATDFL
    integer :: LDATDTG
    integer :: LDATDTS
    integer :: LDATDTX
    integer :: LDATEDI
    integer :: LDATEHP
    integer :: LDATELI
    integer :: LDATFGW
    integer :: LDATFIE
    integer :: LDATFMN
    integer :: LDATFMX
    integer :: LDATGAS
    integer :: LDATGF3
    integer :: LDATGF4
    integer :: LDATGF6
    integer :: LDATGFD
    integer :: LDATGFH
    integer :: LDATGFT
    integer :: LDATGIE
    integer :: LDATHAL
    integer :: LDATIBM
    integer :: LDATIEC
    integer :: LDATIIC
    integer :: LDATILH
    integer :: LDATL2B
    integer :: LDATLAD
    integer :: LDATLID
    integer :: LDATNTX
    integer :: LDATOGF
    integer :: LDATORC
    integer :: LDATPBE
    integer :: LDATPBI
    integer :: LDATPEB
    integer :: LDATPEC
    integer :: LDATPF0
    integer :: LDATPFH
    integer :: LDATPFL
    integer :: LDATPIB
    integer :: LDATPIC
    integer :: LDATPLF
    integer :: LDATPLH
    integer :: LDATPOS
    integer :: LDATRBZ
    integer :: LDATRC3
    integer :: LDATRC4
    integer :: LDATRC6
    integer :: LDATRCD
    integer :: LDATRCH
    integer :: LDATRCT
    integer :: LDATRCY
    integer :: LDATRMN
    integer :: LDATRTP
    integer :: LDATSBT
    integer :: LDATSF3
    integer :: LDATSFA
    integer :: LDATSFL
    integer :: LDATSFP
    integer :: LDATSFT
    integer :: LDATSP3
    integer :: LDATTET
    integer :: LDATTGF
    integer :: LDATTIT
    integer :: LDATTPI
    integer :: LDATTQT
    integer :: LDATTRC
    integer :: LDATTRF
    integer :: LDATTXI
    integer :: LDATVPH
    integer :: LDATVSB
    integer :: LDATVSF
    integer :: LDATXKF
    integer :: LDATZEF
    integer :: LDATZFA
    integer :: LDATZIM
    integer :: LDATZPL
    integer :: LDMDF
    integer :: LDMFR
    integer :: LDMMX
    integer :: LDMSE
    integer :: LDPFC
    integer :: LDPFC_PRE
    integer :: LEFD0
    integer :: LEFDB
    integer :: LEFDP
    integer :: LEFDQ
    integer :: LEFDR
    integer :: LEFDS
    integer :: LFAEPA
    integer :: LFAEPP
    integer :: LFAXR
    integer :: LFBOL
    integer :: LFBPA
    integer :: LFBPB
    integer :: LFD2F
    integer :: LFDE2
    integer :: LFDF3
    integer :: LFDF4
    integer :: LFDF6
    integer :: LFDFD
    integer :: LFDFH
    integer :: LFDFT
    integer :: LFECA
    integer :: LFECB
    integer :: LFECF
    integer :: LFFD0
    integer :: LFFDB
    integer :: LFFDP
    integer :: LFFDQ
    integer :: LFFDR
    integer :: LFFDS
    integer :: LFFEH
    integer :: LFFEL
    integer :: LFGRB
    integer :: LFIBE
    integer :: LFIBI
    integer :: LFJBM
    integer :: LFJEC
    integer :: LFJIC
    integer :: LFLF3
    integer :: LFLF4
    integer :: LFLF6
    integer :: LFLFD
    integer :: LFLFH
    integer :: LFLFT
    integer :: LFLHE
    integer :: LFLHJ
    integer :: LFMSE
    integer :: LFNER
    integer :: LFNI3
    integer :: LFNI4
    integer :: LFNI6
    integer :: LFNID
    integer :: LFNIH
    integer :: LFNIM
    integer :: LFNIT
    integer :: LFNMR
    integer :: LFOMG
    integer :: LFPRS
    integer :: LFPSI
    integer :: LFQBE
    integer :: LFQBI
    integer :: LFQEC
    integer :: LFQIC
    integer :: LFQPR
    integer :: LFREE
    integer :: LFREE_W
    integer :: LFRES
    integer :: LFRQRFF
    integer :: LFSBI
    integer :: LFSIM(MIMPT)
    integer :: LFSYAXR
    integer :: LFSYBOL
    integer :: LFSYBPA
    integer :: LFSYBPB
    integer :: LFSYD2F
    integer :: LFSYDE2
    integer :: LFSYDF3
    integer :: LFSYDF4
    integer :: LFSYDF6
    integer :: LFSYDFD
    integer :: LFSYDFH
    integer :: LFSYDFT
    integer :: LFSYECF
    integer :: LFSYFEH
    integer :: LFSYFEL
    integer :: LFSYGRB
    integer :: LFSYIBE
    integer :: LFSYIBI
    integer :: LFSYJBM
    integer :: LFSYJEC
    integer :: LFSYJIC
    integer :: LFSYLF3
    integer :: LFSYLF4
    integer :: LFSYLF6
    integer :: LFSYLFD
    integer :: LFSYLFH
    integer :: LFSYLFT
    integer :: LFSYLHE
    integer :: LFSYLHJ
    integer :: LFSYMSE
    integer :: LFSYNER
    integer :: LFSYNI3
    integer :: LFSYNI4
    integer :: LFSYNI6
    integer :: LFSYNID
    integer :: LFSYNIH
    integer :: LFSYNIM
    integer :: LFSYNIT
    integer :: LFSYNMR
    integer :: LFSYOMG
    integer :: LFSYPRS
    integer :: LFSYQBE
    integer :: LFSYQBI
    integer :: LFSYQEC
    integer :: LFSYQIC
    integer :: LFSYQPR
    integer :: LFSYRES
    integer :: LFSYSBI
    integer :: LFSYSIM(MIMPT)
    integer :: LFSYTER
    integer :: LFSYTI2
    integer :: LFSYTQI
    integer :: LFSYV2F
    integer :: LFSYVB2
    integer :: LFSYVC3
    integer :: LFSYVC4
    integer :: LFSYVC6
    integer :: LFSYVCD
    integer :: LFSYVCH
    integer :: LFSYVCT
    integer :: LFSYVEE
    integer :: LFSYVIE
    integer :: LFSYVMO
    integer :: LFSYVP2
    integer :: LFSYVPO
    integer :: LFSYVPR
    integer :: LFSYVTR
    integer :: LFSYZF2
    integer :: LFSYZXR
    integer :: LFTER
    integer :: LFTI2
    integer :: LFTQI
    integer :: LFULNB
    integer :: LFV2F
    integer :: LFVB2
    integer :: LFVC3
    integer :: LFVC4
    integer :: LFVC6
    integer :: LFVCD
    integer :: LFVCH
    integer :: LFVCT
    integer :: LFVEE
    integer :: LFVIE
    integer :: LFVMO
    integer :: LFVP2
    integer :: LFVPO
    integer :: LFVPR
    integer :: LFVTR
    integer :: LFZF2
    integer :: LFZXR
    integer :: LHLFNB
    integer :: LLIM
    integer :: LMOMD
    integer :: LPELDA
    integer :: LPHSLH
    integer :: LPMDF
    integer :: LPMSE
    integer :: LPWREC
    integer :: LPWRLH
    integer :: LPWRNB
    integer :: LPWRRF
    integer :: LRFS
    integer :: LRMFR
    integer :: LRMP_BDY1
    integer :: LRMP_BDY2
    integer :: LRMSE
    integer :: LRP2
    integer :: LRPL
    integer :: LRPSI
    integer :: LSEVENT
    integer :: LSSYAXR
    integer :: LSSYBOL
    integer :: LSSYBPA
    integer :: LSSYBPB
    integer :: LSSYD2F
    integer :: LSSYDE2
    integer :: LSSYDF3
    integer :: LSSYDF4
    integer :: LSSYDF6
    integer :: LSSYDFD
    integer :: LSSYDFH
    integer :: LSSYDFT
    integer :: LSSYECF
    integer :: LSSYFEH
    integer :: LSSYFEL
    integer :: LSSYGRB
    integer :: LSSYIBE
    integer :: LSSYIBI
    integer :: LSSYJBM
    integer :: LSSYJEC
    integer :: LSSYJIC
    integer :: LSSYLF3
    integer :: LSSYLF4
    integer :: LSSYLF6
    integer :: LSSYLFD
    integer :: LSSYLFH
    integer :: LSSYLFT
    integer :: LSSYLHE
    integer :: LSSYLHJ
    integer :: LSSYMSE
    integer :: LSSYNER
    integer :: LSSYNI3
    integer :: LSSYNI4
    integer :: LSSYNI6
    integer :: LSSYNID
    integer :: LSSYNIH
    integer :: LSSYNIM
    integer :: LSSYNIT
    integer :: LSSYNMR
    integer :: LSSYOMG
    integer :: LSSYPRS
    integer :: LSSYQBE
    integer :: LSSYQBI
    integer :: LSSYQEC
    integer :: LSSYQIC
    integer :: LSSYQPR
    integer :: LSSYRES
    integer :: LSSYSBI
    integer :: LSSYSIM(MIMPT)
    integer :: LSSYTER
    integer :: LSSYTI2
    integer :: LSSYTQI
    integer :: LSSYV2F
    integer :: LSSYVB2
    integer :: LSSYVC3
    integer :: LSSYVC4
    integer :: LSSYVC6
    integer :: LSSYVCD
    integer :: LSSYVCH
    integer :: LSSYVCT
    integer :: LSSYVEE
    integer :: LSSYVIE
    integer :: LSSYVMO
    integer :: LSSYVP2
    integer :: LSSYVPO
    integer :: LSSYVPR
    integer :: LSSYVTR
    integer :: LSSYZF2
    integer :: LSSYZXR
    integer :: LTABORT
    integer :: LTAEP
    integer :: LTFD0
    integer :: LTFDB
    integer :: LTFDP
    integer :: LTFDQ
    integer :: LTFDR
    integer :: LTFDS
    integer :: LTHFS
    integer :: LTIME1
    integer :: LTIME2
    integer :: LTIMEC
    integer :: LTIMECA
    integer :: LTIMECB
    integer :: LTIMLH
    integer :: LTIMNB
    integer :: LTIMRF
    integer :: LTIMRFF
    integer :: LTPSI
    integer :: LTSAW
    integer :: LVLTNB
    integer :: LXAXR
    integer :: LXBOL
    integer :: LXBPA
    integer :: LXBPB
    integer :: LXD2F
    integer :: LXDE2
    integer :: LXDF3
    integer :: LXDF4
    integer :: LXDF6
    integer :: LXDFD
    integer :: LXDFH
    integer :: LXDFT
    integer :: LXECF
    integer :: LXFD0
    integer :: LXFDB
    integer :: LXFDP
    integer :: LXFDQ
    integer :: LXFDR
    integer :: LXFDS
    integer :: LXFEH
    integer :: LXFEL
    integer :: LXFS
    integer :: LXGRB
    integer :: LXIBE
    integer :: LXIBI
    integer :: LXJBM
    integer :: LXJEC
    integer :: LXJIC
    integer :: LXLF3
    integer :: LXLF4
    integer :: LXLF6
    integer :: LXLFD
    integer :: LXLFH
    integer :: LXLFT
    integer :: LXLHE
    integer :: LXLHJ
    integer :: LXMMX
    integer :: LXMSE
    integer :: LXNER
    integer :: LXNI3
    integer :: LXNI4
    integer :: LXNI6
    integer :: LXNID
    integer :: LXNIH
    integer :: LXNIM
    integer :: LXNIT
    integer :: LXNMR
    integer :: LXOMG
    integer :: LXPFC
    integer :: LXPRS
    integer :: LXQBE
    integer :: LXQBI
    integer :: LXQEC
    integer :: LXQIC
    integer :: LXQPR
    integer :: LXRES
    integer :: LXRP2
    integer :: LXRPL
    integer :: LXSBI
    integer :: LXSIM(MIMPS)
    integer :: LXSYAXR
    integer :: LXSYBOL
    integer :: LXSYBPA
    integer :: LXSYBPB
    integer :: LXSYD2F
    integer :: LXSYDE2
    integer :: LXSYDF3
    integer :: LXSYDF4
    integer :: LXSYDF6
    integer :: LXSYDFD
    integer :: LXSYDFH
    integer :: LXSYDFT
    integer :: LXSYECF
    integer :: LXSYFEH
    integer :: LXSYFEL
    integer :: LXSYGRB
    integer :: LXSYIBE
    integer :: LXSYIBI
    integer :: LXSYJBM
    integer :: LXSYJEC
    integer :: LXSYJIC
    integer :: LXSYLF3
    integer :: LXSYLF4
    integer :: LXSYLF6
    integer :: LXSYLFD
    integer :: LXSYLFH
    integer :: LXSYLFT
    integer :: LXSYLHE
    integer :: LXSYLHJ
    integer :: LXSYMSE
    integer :: LXSYNER
    integer :: LXSYNI3
    integer :: LXSYNI4
    integer :: LXSYNI6
    integer :: LXSYNID
    integer :: LXSYNIH
    integer :: LXSYNIM
    integer :: LXSYNIT
    integer :: LXSYNMR
    integer :: LXSYOMG
    integer :: LXSYPRS
    integer :: LXSYQBE
    integer :: LXSYQBI
    integer :: LXSYQEC
    integer :: LXSYQIC
    integer :: LXSYQPR
    integer :: LXSYRES
    integer :: LXSYSBI
    integer :: LXSYSIM(MIMPS)
    integer :: LXSYTER
    integer :: LXSYTI2
    integer :: LXSYTQI
    integer :: LXSYV2F
    integer :: LXSYVB2
    integer :: LXSYVC3
    integer :: LXSYVC4
    integer :: LXSYVC6
    integer :: LXSYVCD
    integer :: LXSYVCH
    integer :: LXSYVCT
    integer :: LXSYVEE
    integer :: LXSYVIE
    integer :: LXSYVMO
    integer :: LXSYVP2
    integer :: LXSYVPO
    integer :: LXSYVPR
    integer :: LXSYVTR
    integer :: LXSYZF2
    integer :: LXSYZXR
    integer :: LXTER
    integer :: LXTI2
    integer :: LXTQI
    integer :: LXV2F
    integer :: LXVB2
    integer :: LXVC3
    integer :: LXVC4
    integer :: LXVC6
    integer :: LXVCD
    integer :: LXVCH
    integer :: LXVCT
    integer :: LXVEE
    integer :: LXVIE
    integer :: LXVMO
    integer :: LXVP2
    integer :: LXVPO
    integer :: LXVPR
    integer :: LXVTR
    integer :: LXZF2
    integer :: LXZIMPS
    integer :: LXZIMPX
    integer :: LXZIMPXS
    integer :: LXZXR
    integer :: LYRP2
    integer :: LYRPL
    integer :: LYSIM
    integer :: LZFS
    integer :: LZPSI
    integer :: MMAX
    integer :: MMX_MAXE
    integer :: MTRP2
    integer :: MTRPL
    integer :: NANTECH_D
    integer :: NANTICH_D
    integer :: NANTLH_D
    integer :: NBDATA
    integer :: NBX(8)
    integer :: NDEAEP
    integer :: NDFS
    integer :: NDMDF
    integer :: NDMFR
    integer :: NDMMX
    integer :: NDMSE
    integer :: NDPAEP
    integer :: NDPFC
    integer :: NDPFC_PRE
    integer :: NEAEP
    integer :: NEFD0
    integer :: NEFDB
    integer :: NEFDP
    integer :: NEFDQ
    integer :: NEFDR
    integer :: NEFDS
    integer :: NFRBCODE
    integer :: NFRBMODE
    integer :: NGMAX_D
    integer :: NHECFT
    integer :: NHFMX
    integer :: NIMDF
    integer :: NISSIM(MIMPT)
    integer :: NISX(MIMPT)
    integer :: NITSIM(MIMPS)
    integer :: NITX(MIMPS)
    integer :: NKAEP
    integer :: NLIM
    integer :: NMAPSIM(MIMPT)
    integer :: NMDXKF
    integer :: NMIMP
    integer :: NMOMD
    integer :: NMUAEP
    integer :: NMZEFF
    integer :: NNSIM
    integer :: NPACK
    integer :: NPAEP
    integer :: NPELDA
    integer :: NPMDF
    integer :: NPMSE
    integer :: NRHIS
    integer :: NRHIX
    integer :: NRIAXR
    integer :: NRIBOL
    integer :: NRIBPA
    integer :: NRIBPB
    integer :: NRID2F
    integer :: NRIDE2
    integer :: NRIDF3
    integer :: NRIDF4
    integer :: NRIDF6
    integer :: NRIDFD
    integer :: NRIDFH
    integer :: NRIDFT
    integer :: NRIECF
    integer :: NRIFD0
    integer :: NRIFDB
    integer :: NRIFDP
    integer :: NRIFDQ
    integer :: NRIFDR
    integer :: NRIFDS
    integer :: NRIFEH
    integer :: NRIFEL
    integer :: NRIGRB
    integer :: NRIIBE
    integer :: NRIIBI
    integer :: NRIJBM
    integer :: NRIJEC
    integer :: NRIJIC
    integer :: NRILF3
    integer :: NRILF4
    integer :: NRILF6
    integer :: NRILFD
    integer :: NRILFH
    integer :: NRILFT
    integer :: NRILHE
    integer :: NRILHJ
    integer :: NRIMSE
    integer :: NRINER
    integer :: NRINI3
    integer :: NRINI4
    integer :: NRINI6
    integer :: NRINID
    integer :: NRINIH
    integer :: NRINIM
    integer :: NRINIT
    integer :: NRINMR
    integer :: NRIOMG
    integer :: NRIPRS
    integer :: NRIQBE
    integer :: NRIQBI
    integer :: NRIQEC
    integer :: NRIQIC
    integer :: NRIQPR
    integer :: NRIRES
    integer :: NRISBI
    integer :: NRISIM(MIMPS)
    integer :: NRITER
    integer :: NRITI2
    integer :: NRITQI
    integer :: NRIV2F
    integer :: NRIVB2
    integer :: NRIVC3
    integer :: NRIVC4
    integer :: NRIVC6
    integer :: NRIVCD
    integer :: NRIVCH
    integer :: NRIVCT
    integer :: NRIVEE
    integer :: NRIVIE
    integer :: NRIVMO
    integer :: NRIVP2
    integer :: NRIVPO
    integer :: NRIVPR
    integer :: NRIVTR
    integer :: NRIZF2
    integer :: NRIZXR
    integer :: NRMFR
    integer :: NRMSE
    integer :: NRP2
    integer :: NRPL
    integer :: NRPSI
    integer :: NSAWFLAG
    integer :: NSC
    integer :: NSC_FMT
    integer :: NSEVENT
    integer :: NSEVPER
    integer :: NSEVTBL
    integer :: NSEVWDS
    integer :: NSFAST_D
    integer :: NSYAXR
    integer :: NSYBOL
    integer :: NSYBPA
    integer :: NSYBPB
    integer :: NSYD2F
    integer :: NSYDE2
    integer :: NSYDF3
    integer :: NSYDF4
    integer :: NSYDF6
    integer :: NSYDFD
    integer :: NSYDFH
    integer :: NSYDFT
    integer :: NSYECF
    integer :: NSYFEH
    integer :: NSYFEL
    integer :: NSYGRB
    integer :: NSYIBE
    integer :: NSYIBI
    integer :: NSYJBM
    integer :: NSYJEC
    integer :: NSYJIC
    integer :: NSYLF3
    integer :: NSYLF4
    integer :: NSYLF6
    integer :: NSYLFD
    integer :: NSYLFH
    integer :: NSYLFT
    integer :: NSYLHE
    integer :: NSYLHJ
    integer :: NSYMSE
    integer :: NSYNER
    integer :: NSYNI3
    integer :: NSYNI4
    integer :: NSYNI6
    integer :: NSYNID
    integer :: NSYNIH
    integer :: NSYNIM
    integer :: NSYNIT
    integer :: NSYNMR
    integer :: NSYOMG
    integer :: NSYPRS
    integer :: NSYQBE
    integer :: NSYQBI
    integer :: NSYQEC
    integer :: NSYQIC
    integer :: NSYQPR
    integer :: NSYRES
    integer :: NSYSBI
    integer :: NSYSIM(MIMPS)
    integer :: NSYTER
    integer :: NSYTI2
    integer :: NSYTQI
    integer :: NSYV2F
    integer :: NSYVB2
    integer :: NSYVC3
    integer :: NSYVC4
    integer :: NSYVC6
    integer :: NSYVCD
    integer :: NSYVCH
    integer :: NSYVCT
    integer :: NSYVEE
    integer :: NSYVIE
    integer :: NSYVMO
    integer :: NSYVP2
    integer :: NSYVPO
    integer :: NSYVPR
    integer :: NSYVTR
    integer :: NSYZF2
    integer :: NSYZXR
    integer :: NTABORT
    integer :: NTAEP
    integer :: NTFD0
    integer :: NTFDB
    integer :: NTFDP
    integer :: NTFDQ
    integer :: NTFDR
    integer :: NTFDS
    integer :: NTHFS
    integer :: NTIME1
    integer :: NTIME2
    integer :: NTIMEC
    integer :: NTIMECA
    integer :: NTIMECB
    integer :: NTIMLH
    integer :: NTIMNB
    integer :: NTIMRF
    integer :: NTIMRFF
    integer :: NTPSI
    integer :: NTSAW
    integer :: NXAXR
    integer :: NXBOL
    integer :: NXBPA
    integer :: NXBPB
    integer :: NXD2F
    integer :: NXDE2
    integer :: NXDF3
    integer :: NXDF4
    integer :: NXDF6
    integer :: NXDFD
    integer :: NXDFH
    integer :: NXDFT
    integer :: NXECF
    integer :: NXFD0
    integer :: NXFDB
    integer :: NXFDP
    integer :: NXFDQ
    integer :: NXFDR
    integer :: NXFDS
    integer :: NXFEH
    integer :: NXFEL
    integer :: NXFS
    integer :: NXGRB
    integer :: NXIBE
    integer :: NXIBI
    integer :: NXJBM
    integer :: NXJEC
    integer :: NXJIC
    integer :: NXLF3
    integer :: NXLF4
    integer :: NXLF6
    integer :: NXLFD
    integer :: NXLFH
    integer :: NXLFT
    integer :: NXLHE
    integer :: NXLHJ
    integer :: NXMMX
    integer :: NXMSE
    integer :: NXNE0
    integer :: NXNER
    integer :: NXNI3
    integer :: NXNI4
    integer :: NXNI6
    integer :: NXNID
    integer :: NXNIH
    integer :: NXNIM
    integer :: NXNIT
    integer :: NXNM0
    integer :: NXNMR
    integer :: NXOMG
    integer :: NXPFC
    integer :: NXPRS
    integer :: NXQBE
    integer :: NXQBI
    integer :: NXQEC
    integer :: NXQIC
    integer :: NXQPR
    integer :: NXRES
    integer :: NXRP2
    integer :: NXRPL
    integer :: NXSBI
    integer :: NXSIM(MIMPS)
    integer :: NXSYAXR
    integer :: NXSYBOL
    integer :: NXSYBPA
    integer :: NXSYBPB
    integer :: NXSYD2F
    integer :: NXSYDE2
    integer :: NXSYDF3
    integer :: NXSYDF4
    integer :: NXSYDF6
    integer :: NXSYDFD
    integer :: NXSYDFH
    integer :: NXSYDFT
    integer :: NXSYECF
    integer :: NXSYFEH
    integer :: NXSYFEL
    integer :: NXSYGRB
    integer :: NXSYIBE
    integer :: NXSYIBI
    integer :: NXSYJBM
    integer :: NXSYJEC
    integer :: NXSYJIC
    integer :: NXSYLF3
    integer :: NXSYLF4
    integer :: NXSYLF6
    integer :: NXSYLFD
    integer :: NXSYLFH
    integer :: NXSYLFT
    integer :: NXSYLHE
    integer :: NXSYLHJ
    integer :: NXSYMSE
    integer :: NXSYNER
    integer :: NXSYNI3
    integer :: NXSYNI4
    integer :: NXSYNI6
    integer :: NXSYNID
    integer :: NXSYNIH
    integer :: NXSYNIM
    integer :: NXSYNIT
    integer :: NXSYNMR
    integer :: NXSYOMG
    integer :: NXSYPRS
    integer :: NXSYQBE
    integer :: NXSYQBI
    integer :: NXSYQEC
    integer :: NXSYQIC
    integer :: NXSYQPR
    integer :: NXSYRES
    integer :: NXSYSBI
    integer :: NXSYSIM(MIMPS)
    integer :: NXSYTER
    integer :: NXSYTI2
    integer :: NXSYTQI
    integer :: NXSYV2F
    integer :: NXSYVB2
    integer :: NXSYVC3
    integer :: NXSYVC4
    integer :: NXSYVC6
    integer :: NXSYVCD
    integer :: NXSYVCH
    integer :: NXSYVCT
    integer :: NXSYVEE
    integer :: NXSYVIE
    integer :: NXSYVMO
    integer :: NXSYVP2
    integer :: NXSYVPO
    integer :: NXSYVPR
    integer :: NXSYVTR
    integer :: NXSYZF2
    integer :: NXSYZXR
    integer :: NXTE0
    integer :: NXTER
    integer :: NXTI2
    integer :: NXTQI
    integer :: NXV2F
    integer :: NXVB2
    integer :: NXVC3
    integer :: NXVC4
    integer :: NXVC6
    integer :: NXVCD
    integer :: NXVCH
    integer :: NXVCT
    integer :: NXVEE
    integer :: NXVIE
    integer :: NXVMO
    integer :: NXVP2
    integer :: NXVPO
    integer :: NXVPR
    integer :: NXVTR
    integer :: NXZEF2
    integer :: NXZF2
    integer :: NXZXR
    integer :: NYRP2
    integer :: NYRPL
    integer :: NZPSI
    real*8, dimension(:), pointer :: WORKBUF
 
  end type trdatbuf
 
  contains
    integer function tdb_get_MIMPS(idum)
      integer, intent(in) :: idum
 
      tdb_get_MIMPS = MIMPS
 
    end function tdb_get_MIMPS
    integer function tdb_get_MIMPT(idum)
      integer, intent(in) :: idum
 
      tdb_get_MIMPT = MIMPT
 
    end function tdb_get_MIMPT
 
    subroutine trdatbuf_reInit(s)
      type (trdatbuf) :: s
 
      deallocate(s%DATBUF)
      deallocate(s%WORKBUF)
 
      call trdatbuf_init(s)
    end subroutine trdatbuf_reInit
 
    subroutine trdatbuf_init(s)
      type (trdatbuf) :: s
 
      allocate(s%DATBUF(100000)); s%DATBUF = 0
      allocate(s%WORKBUF(100000)); s%WORKBUF = 0
      s%LADR_ZA = 0
      s%LADR_ZAF = 0
      s%LAEPDE = 0
      s%LAEPDP = 0
      s%LAEPE = 0
      s%LAEPMAP = 0
      s%LAEPMU = 0
      s%LAEPP = 0
      s%LAEPSP = 0
      s%LAEPTS = 0
      s%LAIMPS = 0
      s%LAIMPX = 0
      s%LBX = 0
      s%LDATALP = 0
      s%LDATBDI = 0
      s%LDATCUR = 0
      s%LDATDFL = 0
      s%LDATDTG = 0
      s%LDATDTS = 0
      s%LDATDTX = 0
      s%LDATEDI = 0
      s%LDATEHP = 0
      s%LDATELI = 0
      s%LDATFGW = 0
      s%LDATFIE = 0
      s%LDATFMN = 0
      s%LDATFMX = 0
      s%LDATGAS = 0
      s%LDATGF3 = 0
      s%LDATGF4 = 0
      s%LDATGF6 = 0
      s%LDATGFD = 0
      s%LDATGFH = 0
      s%LDATGFT = 0
      s%LDATGIE = 0
      s%LDATHAL = 0
      s%LDATIBM = 0
      s%LDATIEC = 0
      s%LDATIIC = 0
      s%LDATILH = 0
      s%LDATL2B = 0
      s%LDATLAD = 0
      s%LDATLID = 0
      s%LDATNTX = 0
      s%LDATOGF = 0
      s%LDATORC = 0
      s%LDATPBE = 0
      s%LDATPBI = 0
      s%LDATPEB = 0
      s%LDATPEC = 0
      s%LDATPF0 = 0
      s%LDATPFH = 0
      s%LDATPFL = 0
      s%LDATPIB = 0
      s%LDATPIC = 0
      s%LDATPLF = 0
      s%LDATPLH = 0
      s%LDATPOS = 0
      s%LDATRBZ = 0
      s%LDATRC3 = 0
      s%LDATRC4 = 0
      s%LDATRC6 = 0
      s%LDATRCD = 0
      s%LDATRCH = 0
      s%LDATRCT = 0
      s%LDATRCY = 0
      s%LDATRMN = 0
      s%LDATRTP = 0
      s%LDATSBT = 0
      s%LDATSF3 = 0
      s%LDATSFA = 0
      s%LDATSFL = 0
      s%LDATSFP = 0
      s%LDATSFT = 0
      s%LDATSP3 = 0
      s%LDATTET = 0
      s%LDATTGF = 0
      s%LDATTIT = 0
      s%LDATTPI = 0
      s%LDATTQT = 0
      s%LDATTRC = 0
      s%LDATTRF = 0
      s%LDATTXI = 0
      s%LDATVPH = 0
      s%LDATVSB = 0
      s%LDATVSF = 0
      s%LDATXKF = 0
      s%LDATZEF = 0
      s%LDATZFA = 0
      s%LDATZIM = 0
      s%LDATZPL = 0
      s%LDMDF = 0
      s%LDMFR = 0
      s%LDMMX = 0
      s%LDMSE = 0
      s%LDPFC = 0
      s%LDPFC_PRE = 0
      s%LEFD0 = 0
      s%LEFDB = 0
      s%LEFDP = 0
      s%LEFDQ = 0
      s%LEFDR = 0
      s%LEFDS = 0
      s%LFAEPA = 0
      s%LFAEPP = 0
      s%LFAXR = 0
      s%LFBOL = 0
      s%LFBPA = 0
      s%LFBPB = 0
      s%LFD2F = 0
      s%LFDE2 = 0
      s%LFDF3 = 0
      s%LFDF4 = 0
      s%LFDF6 = 0
      s%LFDFD = 0
      s%LFDFH = 0
      s%LFDFT = 0
      s%LFECA = 0
      s%LFECB = 0
      s%LFECF = 0
      s%LFFD0 = 0
      s%LFFDB = 0
      s%LFFDP = 0
      s%LFFDQ = 0
      s%LFFDR = 0
      s%LFFDS = 0
      s%LFFEH = 0
      s%LFFEL = 0
      s%LFGRB = 0
      s%LFIBE = 0
      s%LFIBI = 0
      s%LFJBM = 0
      s%LFJEC = 0
      s%LFJIC = 0
      s%LFLF3 = 0
      s%LFLF4 = 0
      s%LFLF6 = 0
      s%LFLFD = 0
      s%LFLFH = 0
      s%LFLFT = 0
      s%LFLHE = 0
      s%LFLHJ = 0
      s%LFMSE = 0
      s%LFNER = 0
      s%LFNI3 = 0
      s%LFNI4 = 0
      s%LFNI6 = 0
      s%LFNID = 0
      s%LFNIH = 0
      s%LFNIM = 0
      s%LFNIT = 0
      s%LFNMR = 0
      s%LFOMG = 0
      s%LFPRS = 0
      s%LFPSI = 0
      s%LFQBE = 0
      s%LFQBI = 0
      s%LFQEC = 0
      s%LFQIC = 0
      s%LFQPR = 0
      s%LFREE = 1
      s%LFREE_W = 1
      s%LFRES = 0
      s%LFRQRFF = 0
      s%LFSBI = 0
      s%LFSIM = 0
      s%LFSYAXR = 0
      s%LFSYBOL = 0
      s%LFSYBPA = 0
      s%LFSYBPB = 0
      s%LFSYD2F = 0
      s%LFSYDE2 = 0
      s%LFSYDF3 = 0
      s%LFSYDF4 = 0
      s%LFSYDF6 = 0
      s%LFSYDFD = 0
      s%LFSYDFH = 0
      s%LFSYDFT = 0
      s%LFSYECF = 0
      s%LFSYFEH = 0
      s%LFSYFEL = 0
      s%LFSYGRB = 0
      s%LFSYIBE = 0
      s%LFSYIBI = 0
      s%LFSYJBM = 0
      s%LFSYJEC = 0
      s%LFSYJIC = 0
      s%LFSYLF3 = 0
      s%LFSYLF4 = 0
      s%LFSYLF6 = 0
      s%LFSYLFD = 0
      s%LFSYLFH = 0
      s%LFSYLFT = 0
      s%LFSYLHE = 0
      s%LFSYLHJ = 0
      s%LFSYMSE = 0
      s%LFSYNER = 0
      s%LFSYNI3 = 0
      s%LFSYNI4 = 0
      s%LFSYNI6 = 0
      s%LFSYNID = 0
      s%LFSYNIH = 0
      s%LFSYNIM = 0
      s%LFSYNIT = 0
      s%LFSYNMR = 0
      s%LFSYOMG = 0
      s%LFSYPRS = 0
      s%LFSYQBE = 0
      s%LFSYQBI = 0
      s%LFSYQEC = 0
      s%LFSYQIC = 0
      s%LFSYQPR = 0
      s%LFSYRES = 0
      s%LFSYSBI = 0
      s%LFSYSIM = 0
      s%LFSYTER = 0
      s%LFSYTI2 = 0
      s%LFSYTQI = 0
      s%LFSYV2F = 0
      s%LFSYVB2 = 0
      s%LFSYVC3 = 0
      s%LFSYVC4 = 0
      s%LFSYVC6 = 0
      s%LFSYVCD = 0
      s%LFSYVCH = 0
      s%LFSYVCT = 0
      s%LFSYVEE = 0
      s%LFSYVIE = 0
      s%LFSYVMO = 0
      s%LFSYVP2 = 0
      s%LFSYVPO = 0
      s%LFSYVPR = 0
      s%LFSYVTR = 0
      s%LFSYZF2 = 0
      s%LFSYZXR = 0
      s%LFTER = 0
      s%LFTI2 = 0
      s%LFTQI = 0
      s%LFULNB = 0
      s%LFV2F = 0
      s%LFVB2 = 0
      s%LFVC3 = 0
      s%LFVC4 = 0
      s%LFVC6 = 0
      s%LFVCD = 0
      s%LFVCH = 0
      s%LFVCT = 0
      s%LFVEE = 0
      s%LFVIE = 0
      s%LFVMO = 0
      s%LFVP2 = 0
      s%LFVPO = 0
      s%LFVPR = 0
      s%LFVTR = 0
      s%LFZF2 = 0
      s%LFZXR = 0
      s%LHLFNB = 0
      s%LLIM = 0
      s%LMOMD = 0
      s%LPELDA = 0
      s%LPHSLH = 0
      s%LPMDF = 0
      s%LPMSE = 0
      s%LPWREC = 0
      s%LPWRLH = 0
      s%LPWRNB = 0
      s%LPWRRF = 0
      s%LRFS = 0
      s%LRMFR = 0
      s%LRMP_BDY1 = 0
      s%LRMP_BDY2 = 0
      s%LRMSE = 0
      s%LRP2 = 0
      s%LRPL = 0
      s%LRPSI = 0
      s%LSEVENT = 0
      s%LSSYAXR = 0
      s%LSSYBOL = 0
      s%LSSYBPA = 0
      s%LSSYBPB = 0
      s%LSSYD2F = 0
      s%LSSYDE2 = 0
      s%LSSYDF3 = 0
      s%LSSYDF4 = 0
      s%LSSYDF6 = 0
      s%LSSYDFD = 0
      s%LSSYDFH = 0
      s%LSSYDFT = 0
      s%LSSYECF = 0
      s%LSSYFEH = 0
      s%LSSYFEL = 0
      s%LSSYGRB = 0
      s%LSSYIBE = 0
      s%LSSYIBI = 0
      s%LSSYJBM = 0
      s%LSSYJEC = 0
      s%LSSYJIC = 0
      s%LSSYLF3 = 0
      s%LSSYLF4 = 0
      s%LSSYLF6 = 0
      s%LSSYLFD = 0
      s%LSSYLFH = 0
      s%LSSYLFT = 0
      s%LSSYLHE = 0
      s%LSSYLHJ = 0
      s%LSSYMSE = 0
      s%LSSYNER = 0
      s%LSSYNI3 = 0
      s%LSSYNI4 = 0
      s%LSSYNI6 = 0
      s%LSSYNID = 0
      s%LSSYNIH = 0
      s%LSSYNIM = 0
      s%LSSYNIT = 0
      s%LSSYNMR = 0
      s%LSSYOMG = 0
      s%LSSYPRS = 0
      s%LSSYQBE = 0
      s%LSSYQBI = 0
      s%LSSYQEC = 0
      s%LSSYQIC = 0
      s%LSSYQPR = 0
      s%LSSYRES = 0
      s%LSSYSBI = 0
      s%LSSYSIM = 0
      s%LSSYTER = 0
      s%LSSYTI2 = 0
      s%LSSYTQI = 0
      s%LSSYV2F = 0
      s%LSSYVB2 = 0
      s%LSSYVC3 = 0
      s%LSSYVC4 = 0
      s%LSSYVC6 = 0
      s%LSSYVCD = 0
      s%LSSYVCH = 0
      s%LSSYVCT = 0
      s%LSSYVEE = 0
      s%LSSYVIE = 0
      s%LSSYVMO = 0
      s%LSSYVP2 = 0
      s%LSSYVPO = 0
      s%LSSYVPR = 0
      s%LSSYVTR = 0
      s%LSSYZF2 = 0
      s%LSSYZXR = 0
      s%LTABORT = 0
      s%LTAEP = 0
      s%LTFD0 = 0
      s%LTFDB = 0
      s%LTFDP = 0
      s%LTFDQ = 0
      s%LTFDR = 0
      s%LTFDS = 0
      s%LTHFS = 0
      s%LTIME1 = 0
      s%LTIME2 = 0
      s%LTIMEC = 0
      s%LTIMECA = 0
      s%LTIMECB = 0
      s%LTIMLH = 0
      s%LTIMNB = 0
      s%LTIMRF = 0
      s%LTIMRFF = 0
      s%LTPSI = 0
      s%LTSAW = 0
      s%LVLTNB = 0
      s%LXAXR = 0
      s%LXBOL = 0
      s%LXBPA = 0
      s%LXBPB = 0
      s%LXD2F = 0
      s%LXDE2 = 0
      s%LXDF3 = 0
      s%LXDF4 = 0
      s%LXDF6 = 0
      s%LXDFD = 0
      s%LXDFH = 0
      s%LXDFT = 0
      s%LXECF = 0
      s%LXFD0 = 0
      s%LXFDB = 0
      s%LXFDP = 0
      s%LXFDQ = 0
      s%LXFDR = 0
      s%LXFDS = 0
      s%LXFEH = 0
      s%LXFEL = 0
      s%LXFS = 0
      s%LXGRB = 0
      s%LXIBE = 0
      s%LXIBI = 0
      s%LXJBM = 0
      s%LXJEC = 0
      s%LXJIC = 0
      s%LXLF3 = 0
      s%LXLF4 = 0
      s%LXLF6 = 0
      s%LXLFD = 0
      s%LXLFH = 0
      s%LXLFT = 0
      s%LXLHE = 0
      s%LXLHJ = 0
      s%LXMMX = 0
      s%LXMSE = 0
      s%LXNER = 0
      s%LXNI3 = 0
      s%LXNI4 = 0
      s%LXNI6 = 0
      s%LXNID = 0
      s%LXNIH = 0
      s%LXNIM = 0
      s%LXNIT = 0
      s%LXNMR = 0
      s%LXOMG = 0
      s%LXPFC = 0
      s%LXPRS = 0
      s%LXQBE = 0
      s%LXQBI = 0
      s%LXQEC = 0
      s%LXQIC = 0
      s%LXQPR = 0
      s%LXRES = 0
      s%LXRP2 = 0
      s%LXRPL = 0
      s%LXSBI = 0
      s%LXSIM = 0
      s%LXSYAXR = 0
      s%LXSYBOL = 0
      s%LXSYBPA = 0
      s%LXSYBPB = 0
      s%LXSYD2F = 0
      s%LXSYDE2 = 0
      s%LXSYDF3 = 0
      s%LXSYDF4 = 0
      s%LXSYDF6 = 0
      s%LXSYDFD = 0
      s%LXSYDFH = 0
      s%LXSYDFT = 0
      s%LXSYECF = 0
      s%LXSYFEH = 0
      s%LXSYFEL = 0
      s%LXSYGRB = 0
      s%LXSYIBE = 0
      s%LXSYIBI = 0
      s%LXSYJBM = 0
      s%LXSYJEC = 0
      s%LXSYJIC = 0
      s%LXSYLF3 = 0
      s%LXSYLF4 = 0
      s%LXSYLF6 = 0
      s%LXSYLFD = 0
      s%LXSYLFH = 0
      s%LXSYLFT = 0
      s%LXSYLHE = 0
      s%LXSYLHJ = 0
      s%LXSYMSE = 0
      s%LXSYNER = 0
      s%LXSYNI3 = 0
      s%LXSYNI4 = 0
      s%LXSYNI6 = 0
      s%LXSYNID = 0
      s%LXSYNIH = 0
      s%LXSYNIM = 0
      s%LXSYNIT = 0
      s%LXSYNMR = 0
      s%LXSYOMG = 0
      s%LXSYPRS = 0
      s%LXSYQBE = 0
      s%LXSYQBI = 0
      s%LXSYQEC = 0
      s%LXSYQIC = 0
      s%LXSYQPR = 0
      s%LXSYRES = 0
      s%LXSYSBI = 0
      s%LXSYSIM = 0
      s%LXSYTER = 0
      s%LXSYTI2 = 0
      s%LXSYTQI = 0
      s%LXSYV2F = 0
      s%LXSYVB2 = 0
      s%LXSYVC3 = 0
      s%LXSYVC4 = 0
      s%LXSYVC6 = 0
      s%LXSYVCD = 0
      s%LXSYVCH = 0
      s%LXSYVCT = 0
      s%LXSYVEE = 0
      s%LXSYVIE = 0
      s%LXSYVMO = 0
      s%LXSYVP2 = 0
      s%LXSYVPO = 0
      s%LXSYVPR = 0
      s%LXSYVTR = 0
      s%LXSYZF2 = 0
      s%LXSYZXR = 0
      s%LXTER = 0
      s%LXTI2 = 0
      s%LXTQI = 0
      s%LXV2F = 0
      s%LXVB2 = 0
      s%LXVC3 = 0
      s%LXVC4 = 0
      s%LXVC6 = 0
      s%LXVCD = 0
      s%LXVCH = 0
      s%LXVCT = 0
      s%LXVEE = 0
      s%LXVIE = 0
      s%LXVMO = 0
      s%LXVP2 = 0
      s%LXVPO = 0
      s%LXVPR = 0
      s%LXVTR = 0
      s%LXZF2 = 0
      s%LXZIMPS = 0
      s%LXZIMPX = 0
      s%LXZIMPXS = 0
      s%LXZXR = 0
      s%LYRP2 = 0
      s%LYRPL = 0
      s%LYSIM = 0
      s%LZFS = 0
      s%LZPSI = 0
      s%MMAX = 0
      s%MMX_MAXE = 0
      s%MTRP2 = 0
      s%MTRPL = 0
      s%NANTECH_D = 0
      s%NANTICH_D = 0
      s%NANTLH_D = 0
      s%NBDATA = 0
      s%NBX = 0
      s%NDEAEP = 0
      s%NDFS = 0
      s%NDMDF = 0
      s%NDMFR = 0
      s%NDMMX = 0
      s%NDMSE = 0
      s%NDPAEP = 0
      s%NDPFC = 0
      s%NDPFC_PRE = 0
      s%NEAEP = 0
      s%NEFD0 = 0
      s%NEFDB = 0
      s%NEFDP = 0
      s%NEFDQ = 0
      s%NEFDR = 0
      s%NEFDS = 0
      s%NFRBCODE = 0
      s%NFRBMODE = 0
      s%NGMAX_D = 0
      s%NHECFT = 0
      s%NHFMX = 0
      s%NIMDF = 0
      s%NISSIM = 0
      s%NISX = 0
      s%NITSIM = 0
      s%NITX = 0
      s%NKAEP = 0
      s%NLIM = 0
      s%NMAPSIM = 0
      s%NMDXKF = 0
      s%NMIMP = 0
      s%NMOMD = 0
      s%NMUAEP = 0
      s%NMZEFF = 0
      s%NNSIM = 0
      s%NPACK = 0
      s%NPAEP = 0
      s%NPELDA = 0
      s%NPMDF = 0
      s%NPMSE = 0
      s%NRHIS = 0
      s%NRHIX = 0
      s%NRIAXR = -9999
      s%NRIBOL = -9999
      s%NRIBPA = -9999
      s%NRIBPB = -9999
      s%NRID2F = -9999
      s%NRIDE2 = -9999
      s%NRIDF3 = -9999
      s%NRIDF4 = -9999
      s%NRIDF6 = -9999
      s%NRIDFD = -9999
      s%NRIDFH = -9999
      s%NRIDFT = -9999
      s%NRIECF = -9999
      s%NRIFD0 = -9999
      s%NRIFDB = -9999
      s%NRIFDP = -9999
      s%NRIFDQ = -9999
      s%NRIFDR = -9999
      s%NRIFDS = -9999
      s%NRIFEH = -9999
      s%NRIFEL = -9999
      s%NRIGRB = -9999
      s%NRIIBE = -9999
      s%NRIIBI = -9999
      s%NRIJBM = -9999
      s%NRIJEC = -9999
      s%NRIJIC = -9999
      s%NRILF3 = -9999
      s%NRILF4 = -9999
      s%NRILF6 = -9999
      s%NRILFD = -9999
      s%NRILFH = -9999
      s%NRILFT = -9999
      s%NRILHE = -9999
      s%NRILHJ = -9999
      s%NRIMSE = -9999
      s%NRINER = -9999
      s%NRINI3 = -9999
      s%NRINI4 = -9999
      s%NRINI6 = -9999
      s%NRINID = -9999
      s%NRINIH = -9999
      s%NRINIM = -9999
      s%NRINIT = -9999
      s%NRINMR = -9999
      s%NRIOMG = -9999
      s%NRIPRS = -9999
      s%NRIQBE = -9999
      s%NRIQBI = -9999
      s%NRIQEC = -9999
      s%NRIQIC = -9999
      s%NRIQPR = -9999
      s%NRIRES = -9999
      s%NRISBI = -9999
      s%NRISIM = -9999
      s%NRITER = -9999
      s%NRITI2 = -9999
      s%NRITQI = -9999
      s%NRIV2F = -9999
      s%NRIVB2 = -9999
      s%NRIVC3 = -9999
      s%NRIVC4 = -9999
      s%NRIVC6 = -9999
      s%NRIVCD = -9999
      s%NRIVCH = -9999
      s%NRIVCT = -9999
      s%NRIVEE = -9999
      s%NRIVIE = -9999
      s%NRIVMO = -9999
      s%NRIVP2 = -9999
      s%NRIVPO = -9999
      s%NRIVPR = -9999
      s%NRIVTR = -9999
      s%NRIZF2 = -9999
      s%NRIZXR = -9999
      s%NRMFR = 0
      s%NRMSE = 0
      s%NRP2 = 0
      s%NRPL = 0
      s%NRPSI = 0
      s%NSAWFLAG = 0
      s%NSC = 0
      s%NSC_FMT = 0
      s%NSEVENT = 0
      s%NSEVPER = 0
      s%NSEVTBL = 0
      s%NSEVWDS = 0
      s%NSFAST_D = 0
      s%NSYAXR = -9999
      s%NSYBOL = -9999
      s%NSYBPA = -9999
      s%NSYBPB = -9999
      s%NSYD2F = -9999
      s%NSYDE2 = -9999
      s%NSYDF3 = -9999
      s%NSYDF4 = -9999
      s%NSYDF6 = -9999
      s%NSYDFD = -9999
      s%NSYDFH = -9999
      s%NSYDFT = -9999
      s%NSYECF = -9999
      s%NSYFEH = -9999
      s%NSYFEL = -9999
      s%NSYGRB = -9999
      s%NSYIBE = -9999
      s%NSYIBI = -9999
      s%NSYJBM = -9999
      s%NSYJEC = -9999
      s%NSYJIC = -9999
      s%NSYLF3 = -9999
      s%NSYLF4 = -9999
      s%NSYLF6 = -9999
      s%NSYLFD = -9999
      s%NSYLFH = -9999
      s%NSYLFT = -9999
      s%NSYLHE = -9999
      s%NSYLHJ = -9999
      s%NSYMSE = -9999
      s%NSYNER = -9999
      s%NSYNI3 = -9999
      s%NSYNI4 = -9999
      s%NSYNI6 = -9999
      s%NSYNID = -9999
      s%NSYNIH = -9999
      s%NSYNIM = -9999
      s%NSYNIT = -9999
      s%NSYNMR = -9999
      s%NSYOMG = -9999
      s%NSYPRS = -9999
      s%NSYQBE = -9999
      s%NSYQBI = -9999
      s%NSYQEC = -9999
      s%NSYQIC = -9999
      s%NSYQPR = -9999
      s%NSYRES = -9999
      s%NSYSBI = -9999
      s%NSYSIM = -9999
      s%NSYTER = -9999
      s%NSYTI2 = -9999
      s%NSYTQI = -9999
      s%NSYV2F = -9999
      s%NSYVB2 = -9999
      s%NSYVC3 = -9999
      s%NSYVC4 = -9999
      s%NSYVC6 = -9999
      s%NSYVCD = -9999
      s%NSYVCH = -9999
      s%NSYVCT = -9999
      s%NSYVEE = -9999
      s%NSYVIE = -9999
      s%NSYVMO = -9999
      s%NSYVP2 = -9999
      s%NSYVPO = -9999
      s%NSYVPR = -9999
      s%NSYVTR = -9999
      s%NSYZF2 = -9999
      s%NSYZXR = -9999
      s%NTABORT = 0
      s%NTAEP = 0
      s%NTFD0 = 0
      s%NTFDB = 0
      s%NTFDP = 0
      s%NTFDQ = 0
      s%NTFDR = 0
      s%NTFDS = 0
      s%NTHFS = 0
      s%NTIME1 = 0
      s%NTIME2 = 0
      s%NTIMEC = 0
      s%NTIMECA = 0
      s%NTIMECB = 0
      s%NTIMLH = 0
      s%NTIMNB = 0
      s%NTIMRF = 0
      s%NTIMRFF = 0
      s%NTPSI = 0
      s%NTSAW = 0
      s%NXAXR = -9999
      s%NXBOL = -9999
      s%NXBPA = -9999
      s%NXBPB = -9999
      s%NXD2F = -9999
      s%NXDE2 = -9999
      s%NXDF3 = -9999
      s%NXDF4 = -9999
      s%NXDF6 = -9999
      s%NXDFD = -9999
      s%NXDFH = -9999
      s%NXDFT = -9999
      s%NXECF = -9999
      s%NXFD0 = 0
      s%NXFDB = 0
      s%NXFDP = 0
      s%NXFDQ = 0
      s%NXFDR = 0
      s%NXFDS = 0
      s%NXFEH = -9999
      s%NXFEL = -9999
      s%NXFS = 0
      s%NXGRB = -9999
      s%NXIBE = -9999
      s%NXIBI = -9999
      s%NXJBM = -9999
      s%NXJEC = -9999
      s%NXJIC = -9999
      s%NXLF3 = -9999
      s%NXLF4 = -9999
      s%NXLF6 = -9999
      s%NXLFD = -9999
      s%NXLFH = -9999
      s%NXLFT = -9999
      s%NXLHE = -9999
      s%NXLHJ = -9999
      s%NXMMX = 0
      s%NXMSE = -9999
      s%NXNE0 = -9999
      s%NXNER = -9999
      s%NXNI3 = -9999
      s%NXNI4 = -9999
      s%NXNI6 = -9999
      s%NXNID = -9999
      s%NXNIH = -9999
      s%NXNIM = -9999
      s%NXNIT = -9999
      s%NXNM0 = -9999
      s%NXNMR = -9999
      s%NXOMG = -9999
      s%NXPFC = 0
      s%NXPRS = -9999
      s%NXQBE = -9999
      s%NXQBI = -9999
      s%NXQEC = -9999
      s%NXQIC = -9999
      s%NXQPR = -9999
      s%NXRES = -9999
      s%NXRP2 = 0
      s%NXRPL = 0
      s%NXSBI = -9999
      s%NXSIM = -9999
      s%NXSYAXR = 0
      s%NXSYBOL = 0
      s%NXSYBPA = 0
      s%NXSYBPB = 0
      s%NXSYD2F = 0
      s%NXSYDE2 = 0
      s%NXSYDF3 = 0
      s%NXSYDF4 = 0
      s%NXSYDF6 = 0
      s%NXSYDFD = 0
      s%NXSYDFH = 0
      s%NXSYDFT = 0
      s%NXSYECF = 0
      s%NXSYFEH = 0
      s%NXSYFEL = 0
      s%NXSYGRB = 0
      s%NXSYIBE = 0
      s%NXSYIBI = 0
      s%NXSYJBM = 0
      s%NXSYJEC = 0
      s%NXSYJIC = 0
      s%NXSYLF3 = 0
      s%NXSYLF4 = 0
      s%NXSYLF6 = 0
      s%NXSYLFD = 0
      s%NXSYLFH = 0
      s%NXSYLFT = 0
      s%NXSYLHE = 0
      s%NXSYLHJ = 0
      s%NXSYMSE = 0
      s%NXSYNER = 0
      s%NXSYNI3 = 0
      s%NXSYNI4 = 0
      s%NXSYNI6 = 0
      s%NXSYNID = 0
      s%NXSYNIH = 0
      s%NXSYNIM = 0
      s%NXSYNIT = 0
      s%NXSYNMR = 0
      s%NXSYOMG = 0
      s%NXSYPRS = 0
      s%NXSYQBE = 0
      s%NXSYQBI = 0
      s%NXSYQEC = 0
      s%NXSYQIC = 0
      s%NXSYQPR = 0
      s%NXSYRES = 0
      s%NXSYSBI = 0
      s%NXSYSIM = 0
      s%NXSYTER = 0
      s%NXSYTI2 = 0
      s%NXSYTQI = 0
      s%NXSYV2F = 0
      s%NXSYVB2 = 0
      s%NXSYVC3 = 0
      s%NXSYVC4 = 0
      s%NXSYVC6 = 0
      s%NXSYVCD = 0
      s%NXSYVCH = 0
      s%NXSYVCT = 0
      s%NXSYVEE = 0
      s%NXSYVIE = 0
      s%NXSYVMO = 0
      s%NXSYVP2 = 0
      s%NXSYVPO = 0
      s%NXSYVPR = 0
      s%NXSYVTR = 0
      s%NXSYZF2 = 0
      s%NXSYZXR = 0
      s%NXTE0 = -9999
      s%NXTER = -9999
      s%NXTI2 = -9999
      s%NXTQI = -9999
      s%NXV2F = -9999
      s%NXVB2 = -9999
      s%NXVC3 = -9999
      s%NXVC4 = -9999
      s%NXVC6 = -9999
      s%NXVCD = -9999
      s%NXVCH = -9999
      s%NXVCT = -9999
      s%NXVEE = -9999
      s%NXVIE = -9999
      s%NXVMO = -9999
      s%NXVP2 = -9999
      s%NXVPO = -9999
      s%NXVPR = -9999
      s%NXVTR = -9999
      s%NXZEF2 = -9999
      s%NXZF2 = -9999
      s%NXZXR = -9999
      s%NYRP2 = 0
      s%NYRPL = 0
      s%NZPSI = 0
 
    end subroutine trdatbuf_init
    subroutine trdatbuf_copy(a,b,ierr)
 
      type (trdatbuf) :: a   ! copy from a...
      type (trdatbuf) :: b   ! copy to b...
      integer, intent(out) :: ierr  ! error flag
 
      integer :: lunmsg_tdb  ! function to get LUN for messages...
      integer :: isize
 
      !-----------------
 
      ierr=0
      if((a%lfree.le.1).or.(a%ladr_za.le.0)) then
         write(lunmsg_tdb(0),*) &
            ' ?trdatbuf_copy: "from" object appears to be empty.'
         ierr=1
      endif
 
      if((b%lfree.ne.1).or.(b%ladr_za.ne.0)) then
         write(lunmsg_tdb(0),*) &
            ' ?trdatbuf_copy: "to" object appears in use or not initialized.'
         ierr=1
      endif
 
      if(ierr.ne.0) return
 
      call datbuf_expand(b,size(a%datbuf),isize); b%datbuf = 0
      isize=a%lfree - 1
      if(isize.gt.0) b%datbuf(1:isize)=a%datbuf(1:isize)
 
      call workbuf_expand(b,size(a%workbuf),isize); b%workbuf = 0
      isize=a%lfree_w - 1
      if(isize.gt.0) b%workbuf(1:isize)=a%workbuf(1:isize)
 
      b%LADR_ZA = a%LADR_ZA
      b%LADR_ZAF = a%LADR_ZAF
      b%LAEPDE = a%LAEPDE
      b%LAEPDP = a%LAEPDP
      b%LAEPE = a%LAEPE
      b%LAEPMAP = a%LAEPMAP
      b%LAEPMU = a%LAEPMU
      b%LAEPP = a%LAEPP
      b%LAEPSP = a%LAEPSP
      b%LAEPTS = a%LAEPTS
      b%LAIMPS = a%LAIMPS
      b%LAIMPX = a%LAIMPX
      b%LBX = a%LBX
      b%LDATALP = a%LDATALP
      b%LDATBDI = a%LDATBDI
      b%LDATCUR = a%LDATCUR
      b%LDATDFL = a%LDATDFL
      b%LDATDTG = a%LDATDTG
      b%LDATDTS = a%LDATDTS
      b%LDATDTX = a%LDATDTX
      b%LDATEDI = a%LDATEDI
      b%LDATEHP = a%LDATEHP
      b%LDATELI = a%LDATELI
      b%LDATFGW = a%LDATFGW
      b%LDATFIE = a%LDATFIE
      b%LDATFMN = a%LDATFMN
      b%LDATFMX = a%LDATFMX
      b%LDATGAS = a%LDATGAS
      b%LDATGF3 = a%LDATGF3
      b%LDATGF4 = a%LDATGF4
      b%LDATGF6 = a%LDATGF6
      b%LDATGFD = a%LDATGFD
      b%LDATGFH = a%LDATGFH
      b%LDATGFT = a%LDATGFT
      b%LDATGIE = a%LDATGIE
      b%LDATHAL = a%LDATHAL
      b%LDATIBM = a%LDATIBM
      b%LDATIEC = a%LDATIEC
      b%LDATIIC = a%LDATIIC
      b%LDATILH = a%LDATILH
      b%LDATL2B = a%LDATL2B
      b%LDATLAD = a%LDATLAD
      b%LDATLID = a%LDATLID
      b%LDATNTX = a%LDATNTX
      b%LDATOGF = a%LDATOGF
      b%LDATORC = a%LDATORC
      b%LDATPBE = a%LDATPBE
      b%LDATPBI = a%LDATPBI
      b%LDATPEB = a%LDATPEB
      b%LDATPEC = a%LDATPEC
      b%LDATPF0 = a%LDATPF0
      b%LDATPFH = a%LDATPFH
      b%LDATPFL = a%LDATPFL
      b%LDATPIB = a%LDATPIB
      b%LDATPIC = a%LDATPIC
      b%LDATPLF = a%LDATPLF
      b%LDATPLH = a%LDATPLH
      b%LDATPOS = a%LDATPOS
      b%LDATRBZ = a%LDATRBZ
      b%LDATRC3 = a%LDATRC3
      b%LDATRC4 = a%LDATRC4
      b%LDATRC6 = a%LDATRC6
      b%LDATRCD = a%LDATRCD
      b%LDATRCH = a%LDATRCH
      b%LDATRCT = a%LDATRCT
      b%LDATRCY = a%LDATRCY
      b%LDATRMN = a%LDATRMN
      b%LDATRTP = a%LDATRTP
      b%LDATSBT = a%LDATSBT
      b%LDATSF3 = a%LDATSF3
      b%LDATSFA = a%LDATSFA
      b%LDATSFL = a%LDATSFL
      b%LDATSFP = a%LDATSFP
      b%LDATSFT = a%LDATSFT
      b%LDATSP3 = a%LDATSP3
      b%LDATTET = a%LDATTET
      b%LDATTGF = a%LDATTGF
      b%LDATTIT = a%LDATTIT
      b%LDATTPI = a%LDATTPI
      b%LDATTQT = a%LDATTQT
      b%LDATTRC = a%LDATTRC
      b%LDATTRF = a%LDATTRF
      b%LDATTXI = a%LDATTXI
      b%LDATVPH = a%LDATVPH
      b%LDATVSB = a%LDATVSB
      b%LDATVSF = a%LDATVSF
      b%LDATXKF = a%LDATXKF
      b%LDATZEF = a%LDATZEF
      b%LDATZFA = a%LDATZFA
      b%LDATZIM = a%LDATZIM
      b%LDATZPL = a%LDATZPL
      b%LDMDF = a%LDMDF
      b%LDMFR = a%LDMFR
      b%LDMMX = a%LDMMX
      b%LDMSE = a%LDMSE
      b%LDPFC = a%LDPFC
      b%LDPFC_PRE = a%LDPFC_PRE
      b%LEFD0 = a%LEFD0
      b%LEFDB = a%LEFDB
      b%LEFDP = a%LEFDP
      b%LEFDQ = a%LEFDQ
      b%LEFDR = a%LEFDR
      b%LEFDS = a%LEFDS
      b%LFAEPA = a%LFAEPA
      b%LFAEPP = a%LFAEPP
      b%LFAXR = a%LFAXR
      b%LFBOL = a%LFBOL
      b%LFBPA = a%LFBPA
      b%LFBPB = a%LFBPB
      b%LFD2F = a%LFD2F
      b%LFDE2 = a%LFDE2
      b%LFDF3 = a%LFDF3
      b%LFDF4 = a%LFDF4
      b%LFDF6 = a%LFDF6
      b%LFDFD = a%LFDFD
      b%LFDFH = a%LFDFH
      b%LFDFT = a%LFDFT
      b%LFECA = a%LFECA
      b%LFECB = a%LFECB
      b%LFECF = a%LFECF
      b%LFFD0 = a%LFFD0
      b%LFFDB = a%LFFDB
      b%LFFDP = a%LFFDP
      b%LFFDQ = a%LFFDQ
      b%LFFDR = a%LFFDR
      b%LFFDS = a%LFFDS
      b%LFFEH = a%LFFEH
      b%LFFEL = a%LFFEL
      b%LFGRB = a%LFGRB
      b%LFIBE = a%LFIBE
      b%LFIBI = a%LFIBI
      b%LFJBM = a%LFJBM
      b%LFJEC = a%LFJEC
      b%LFJIC = a%LFJIC
      b%LFLF3 = a%LFLF3
      b%LFLF4 = a%LFLF4
      b%LFLF6 = a%LFLF6
      b%LFLFD = a%LFLFD
      b%LFLFH = a%LFLFH
      b%LFLFT = a%LFLFT
      b%LFLHE = a%LFLHE
      b%LFLHJ = a%LFLHJ
      b%LFMSE = a%LFMSE
      b%LFNER = a%LFNER
      b%LFNI3 = a%LFNI3
      b%LFNI4 = a%LFNI4
      b%LFNI6 = a%LFNI6
      b%LFNID = a%LFNID
      b%LFNIH = a%LFNIH
      b%LFNIM = a%LFNIM
      b%LFNIT = a%LFNIT
      b%LFNMR = a%LFNMR
      b%LFOMG = a%LFOMG
      b%LFPRS = a%LFPRS
      b%LFPSI = a%LFPSI
      b%LFQBE = a%LFQBE
      b%LFQBI = a%LFQBI
      b%LFQEC = a%LFQEC
      b%LFQIC = a%LFQIC
      b%LFQPR = a%LFQPR
      b%LFREE = a%LFREE
      b%LFREE_W = a%LFREE_W
      b%LFRES = a%LFRES
      b%LFRQRFF = a%LFRQRFF
      b%LFSBI = a%LFSBI
      b%LFSIM = a%LFSIM
      b%LFSYAXR = a%LFSYAXR
      b%LFSYBOL = a%LFSYBOL
      b%LFSYBPA = a%LFSYBPA
      b%LFSYBPB = a%LFSYBPB
      b%LFSYD2F = a%LFSYD2F
      b%LFSYDE2 = a%LFSYDE2
      b%LFSYDF3 = a%LFSYDF3
      b%LFSYDF4 = a%LFSYDF4
      b%LFSYDF6 = a%LFSYDF6
      b%LFSYDFD = a%LFSYDFD
      b%LFSYDFH = a%LFSYDFH
      b%LFSYDFT = a%LFSYDFT
      b%LFSYECF = a%LFSYECF
      b%LFSYFEH = a%LFSYFEH
      b%LFSYFEL = a%LFSYFEL
      b%LFSYGRB = a%LFSYGRB
      b%LFSYIBE = a%LFSYIBE
      b%LFSYIBI = a%LFSYIBI
      b%LFSYJBM = a%LFSYJBM
      b%LFSYJEC = a%LFSYJEC
      b%LFSYJIC = a%LFSYJIC
      b%LFSYLF3 = a%LFSYLF3
      b%LFSYLF4 = a%LFSYLF4
      b%LFSYLF6 = a%LFSYLF6
      b%LFSYLFD = a%LFSYLFD
      b%LFSYLFH = a%LFSYLFH
      b%LFSYLFT = a%LFSYLFT
      b%LFSYLHE = a%LFSYLHE
      b%LFSYLHJ = a%LFSYLHJ
      b%LFSYMSE = a%LFSYMSE
      b%LFSYNER = a%LFSYNER
      b%LFSYNI3 = a%LFSYNI3
      b%LFSYNI4 = a%LFSYNI4
      b%LFSYNI6 = a%LFSYNI6
      b%LFSYNID = a%LFSYNID
      b%LFSYNIH = a%LFSYNIH
      b%LFSYNIM = a%LFSYNIM
      b%LFSYNIT = a%LFSYNIT
      b%LFSYNMR = a%LFSYNMR
      b%LFSYOMG = a%LFSYOMG
      b%LFSYPRS = a%LFSYPRS
      b%LFSYQBE = a%LFSYQBE
      b%LFSYQBI = a%LFSYQBI
      b%LFSYQEC = a%LFSYQEC
      b%LFSYQIC = a%LFSYQIC
      b%LFSYQPR = a%LFSYQPR
      b%LFSYRES = a%LFSYRES
      b%LFSYSBI = a%LFSYSBI
      b%LFSYSIM = a%LFSYSIM
      b%LFSYTER = a%LFSYTER
      b%LFSYTI2 = a%LFSYTI2
      b%LFSYTQI = a%LFSYTQI
      b%LFSYV2F = a%LFSYV2F
      b%LFSYVB2 = a%LFSYVB2
      b%LFSYVC3 = a%LFSYVC3
      b%LFSYVC4 = a%LFSYVC4
      b%LFSYVC6 = a%LFSYVC6
      b%LFSYVCD = a%LFSYVCD
      b%LFSYVCH = a%LFSYVCH
      b%LFSYVCT = a%LFSYVCT
      b%LFSYVEE = a%LFSYVEE
      b%LFSYVIE = a%LFSYVIE
      b%LFSYVMO = a%LFSYVMO
      b%LFSYVP2 = a%LFSYVP2
      b%LFSYVPO = a%LFSYVPO
      b%LFSYVPR = a%LFSYVPR
      b%LFSYVTR = a%LFSYVTR
      b%LFSYZF2 = a%LFSYZF2
      b%LFSYZXR = a%LFSYZXR
      b%LFTER = a%LFTER
      b%LFTI2 = a%LFTI2
      b%LFTQI = a%LFTQI
      b%LFULNB = a%LFULNB
      b%LFV2F = a%LFV2F
      b%LFVB2 = a%LFVB2
      b%LFVC3 = a%LFVC3
      b%LFVC4 = a%LFVC4
      b%LFVC6 = a%LFVC6
      b%LFVCD = a%LFVCD
      b%LFVCH = a%LFVCH
      b%LFVCT = a%LFVCT
      b%LFVEE = a%LFVEE
      b%LFVIE = a%LFVIE
      b%LFVMO = a%LFVMO
      b%LFVP2 = a%LFVP2
      b%LFVPO = a%LFVPO
      b%LFVPR = a%LFVPR
      b%LFVTR = a%LFVTR
      b%LFZF2 = a%LFZF2
      b%LFZXR = a%LFZXR
      b%LHLFNB = a%LHLFNB
      b%LLIM = a%LLIM
      b%LMOMD = a%LMOMD
      b%LPELDA = a%LPELDA
      b%LPHSLH = a%LPHSLH
      b%LPMDF = a%LPMDF
      b%LPMSE = a%LPMSE
      b%LPWREC = a%LPWREC
      b%LPWRLH = a%LPWRLH
      b%LPWRNB = a%LPWRNB
      b%LPWRRF = a%LPWRRF
      b%LRFS = a%LRFS
      b%LRMFR = a%LRMFR
      b%LRMP_BDY1 = a%LRMP_BDY1
      b%LRMP_BDY2 = a%LRMP_BDY2
      b%LRMSE = a%LRMSE
      b%LRP2 = a%LRP2
      b%LRPL = a%LRPL
      b%LRPSI = a%LRPSI
      b%LSEVENT = a%LSEVENT
      b%LSSYAXR = a%LSSYAXR
      b%LSSYBOL = a%LSSYBOL
      b%LSSYBPA = a%LSSYBPA
      b%LSSYBPB = a%LSSYBPB
      b%LSSYD2F = a%LSSYD2F
      b%LSSYDE2 = a%LSSYDE2
      b%LSSYDF3 = a%LSSYDF3
      b%LSSYDF4 = a%LSSYDF4
      b%LSSYDF6 = a%LSSYDF6
      b%LSSYDFD = a%LSSYDFD
      b%LSSYDFH = a%LSSYDFH
      b%LSSYDFT = a%LSSYDFT
      b%LSSYECF = a%LSSYECF
      b%LSSYFEH = a%LSSYFEH
      b%LSSYFEL = a%LSSYFEL
      b%LSSYGRB = a%LSSYGRB
      b%LSSYIBE = a%LSSYIBE
      b%LSSYIBI = a%LSSYIBI
      b%LSSYJBM = a%LSSYJBM
      b%LSSYJEC = a%LSSYJEC
      b%LSSYJIC = a%LSSYJIC
      b%LSSYLF3 = a%LSSYLF3
      b%LSSYLF4 = a%LSSYLF4
      b%LSSYLF6 = a%LSSYLF6
      b%LSSYLFD = a%LSSYLFD
      b%LSSYLFH = a%LSSYLFH
      b%LSSYLFT = a%LSSYLFT
      b%LSSYLHE = a%LSSYLHE
      b%LSSYLHJ = a%LSSYLHJ
      b%LSSYMSE = a%LSSYMSE
      b%LSSYNER = a%LSSYNER
      b%LSSYNI3 = a%LSSYNI3
      b%LSSYNI4 = a%LSSYNI4
      b%LSSYNI6 = a%LSSYNI6
      b%LSSYNID = a%LSSYNID
      b%LSSYNIH = a%LSSYNIH
      b%LSSYNIM = a%LSSYNIM
      b%LSSYNIT = a%LSSYNIT
      b%LSSYNMR = a%LSSYNMR
      b%LSSYOMG = a%LSSYOMG
      b%LSSYPRS = a%LSSYPRS
      b%LSSYQBE = a%LSSYQBE
      b%LSSYQBI = a%LSSYQBI
      b%LSSYQEC = a%LSSYQEC
      b%LSSYQIC = a%LSSYQIC
      b%LSSYQPR = a%LSSYQPR
      b%LSSYRES = a%LSSYRES
      b%LSSYSBI = a%LSSYSBI
      b%LSSYSIM = a%LSSYSIM
      b%LSSYTER = a%LSSYTER
      b%LSSYTI2 = a%LSSYTI2
      b%LSSYTQI = a%LSSYTQI
      b%LSSYV2F = a%LSSYV2F
      b%LSSYVB2 = a%LSSYVB2
      b%LSSYVC3 = a%LSSYVC3
      b%LSSYVC4 = a%LSSYVC4
      b%LSSYVC6 = a%LSSYVC6
      b%LSSYVCD = a%LSSYVCD
      b%LSSYVCH = a%LSSYVCH
      b%LSSYVCT = a%LSSYVCT
      b%LSSYVEE = a%LSSYVEE
      b%LSSYVIE = a%LSSYVIE
      b%LSSYVMO = a%LSSYVMO
      b%LSSYVP2 = a%LSSYVP2
      b%LSSYVPO = a%LSSYVPO
      b%LSSYVPR = a%LSSYVPR
      b%LSSYVTR = a%LSSYVTR
      b%LSSYZF2 = a%LSSYZF2
      b%LSSYZXR = a%LSSYZXR
      b%LTABORT = a%LTABORT
      b%LTAEP = a%LTAEP
      b%LTFD0 = a%LTFD0
      b%LTFDB = a%LTFDB
      b%LTFDP = a%LTFDP
      b%LTFDQ = a%LTFDQ
      b%LTFDR = a%LTFDR
      b%LTFDS = a%LTFDS
      b%LTHFS = a%LTHFS
      b%LTIME1 = a%LTIME1
      b%LTIME2 = a%LTIME2
      b%LTIMEC = a%LTIMEC
      b%LTIMECA = a%LTIMECA
      b%LTIMECB = a%LTIMECB
      b%LTIMLH = a%LTIMLH
      b%LTIMNB = a%LTIMNB
      b%LTIMRF = a%LTIMRF
      b%LTIMRFF = a%LTIMRFF
      b%LTPSI = a%LTPSI
      b%LTSAW = a%LTSAW
      b%LVLTNB = a%LVLTNB
      b%LXAXR = a%LXAXR
      b%LXBOL = a%LXBOL
      b%LXBPA = a%LXBPA
      b%LXBPB = a%LXBPB
      b%LXD2F = a%LXD2F
      b%LXDE2 = a%LXDE2
      b%LXDF3 = a%LXDF3
      b%LXDF4 = a%LXDF4
      b%LXDF6 = a%LXDF6
      b%LXDFD = a%LXDFD
      b%LXDFH = a%LXDFH
      b%LXDFT = a%LXDFT
      b%LXECF = a%LXECF
      b%LXFD0 = a%LXFD0
      b%LXFDB = a%LXFDB
      b%LXFDP = a%LXFDP
      b%LXFDQ = a%LXFDQ
      b%LXFDR = a%LXFDR
      b%LXFDS = a%LXFDS
      b%LXFEH = a%LXFEH
      b%LXFEL = a%LXFEL
      b%LXFS = a%LXFS
      b%LXGRB = a%LXGRB
      b%LXIBE = a%LXIBE
      b%LXIBI = a%LXIBI
      b%LXJBM = a%LXJBM
      b%LXJEC = a%LXJEC
      b%LXJIC = a%LXJIC
      b%LXLF3 = a%LXLF3
      b%LXLF4 = a%LXLF4
      b%LXLF6 = a%LXLF6
      b%LXLFD = a%LXLFD
      b%LXLFH = a%LXLFH
      b%LXLFT = a%LXLFT
      b%LXLHE = a%LXLHE
      b%LXLHJ = a%LXLHJ
      b%LXMMX = a%LXMMX
      b%LXMSE = a%LXMSE
      b%LXNER = a%LXNER
      b%LXNI3 = a%LXNI3
      b%LXNI4 = a%LXNI4
      b%LXNI6 = a%LXNI6
      b%LXNID = a%LXNID
      b%LXNIH = a%LXNIH
      b%LXNIM = a%LXNIM
      b%LXNIT = a%LXNIT
      b%LXNMR = a%LXNMR
      b%LXOMG = a%LXOMG
      b%LXPFC = a%LXPFC
      b%LXPRS = a%LXPRS
      b%LXQBE = a%LXQBE
      b%LXQBI = a%LXQBI
      b%LXQEC = a%LXQEC
      b%LXQIC = a%LXQIC
      b%LXQPR = a%LXQPR
      b%LXRES = a%LXRES
      b%LXRP2 = a%LXRP2
      b%LXRPL = a%LXRPL
      b%LXSBI = a%LXSBI
      b%LXSIM = a%LXSIM
      b%LXSYAXR = a%LXSYAXR
      b%LXSYBOL = a%LXSYBOL
      b%LXSYBPA = a%LXSYBPA
      b%LXSYBPB = a%LXSYBPB
      b%LXSYD2F = a%LXSYD2F
      b%LXSYDE2 = a%LXSYDE2
      b%LXSYDF3 = a%LXSYDF3
      b%LXSYDF4 = a%LXSYDF4
      b%LXSYDF6 = a%LXSYDF6
      b%LXSYDFD = a%LXSYDFD
      b%LXSYDFH = a%LXSYDFH
      b%LXSYDFT = a%LXSYDFT
      b%LXSYECF = a%LXSYECF
      b%LXSYFEH = a%LXSYFEH
      b%LXSYFEL = a%LXSYFEL
      b%LXSYGRB = a%LXSYGRB
      b%LXSYIBE = a%LXSYIBE
      b%LXSYIBI = a%LXSYIBI
      b%LXSYJBM = a%LXSYJBM
      b%LXSYJEC = a%LXSYJEC
      b%LXSYJIC = a%LXSYJIC
      b%LXSYLF3 = a%LXSYLF3
      b%LXSYLF4 = a%LXSYLF4
      b%LXSYLF6 = a%LXSYLF6
      b%LXSYLFD = a%LXSYLFD
      b%LXSYLFH = a%LXSYLFH
      b%LXSYLFT = a%LXSYLFT
      b%LXSYLHE = a%LXSYLHE
      b%LXSYLHJ = a%LXSYLHJ
      b%LXSYMSE = a%LXSYMSE
      b%LXSYNER = a%LXSYNER
      b%LXSYNI3 = a%LXSYNI3
      b%LXSYNI4 = a%LXSYNI4
      b%LXSYNI6 = a%LXSYNI6
      b%LXSYNID = a%LXSYNID
      b%LXSYNIH = a%LXSYNIH
      b%LXSYNIM = a%LXSYNIM
      b%LXSYNIT = a%LXSYNIT
      b%LXSYNMR = a%LXSYNMR
      b%LXSYOMG = a%LXSYOMG
      b%LXSYPRS = a%LXSYPRS
      b%LXSYQBE = a%LXSYQBE
      b%LXSYQBI = a%LXSYQBI
      b%LXSYQEC = a%LXSYQEC
      b%LXSYQIC = a%LXSYQIC
      b%LXSYQPR = a%LXSYQPR
      b%LXSYRES = a%LXSYRES
      b%LXSYSBI = a%LXSYSBI
      b%LXSYSIM = a%LXSYSIM
      b%LXSYTER = a%LXSYTER
      b%LXSYTI2 = a%LXSYTI2
      b%LXSYTQI = a%LXSYTQI
      b%LXSYV2F = a%LXSYV2F
      b%LXSYVB2 = a%LXSYVB2
      b%LXSYVC3 = a%LXSYVC3
      b%LXSYVC4 = a%LXSYVC4
      b%LXSYVC6 = a%LXSYVC6
      b%LXSYVCD = a%LXSYVCD
      b%LXSYVCH = a%LXSYVCH
      b%LXSYVCT = a%LXSYVCT
      b%LXSYVEE = a%LXSYVEE
      b%LXSYVIE = a%LXSYVIE
      b%LXSYVMO = a%LXSYVMO
      b%LXSYVP2 = a%LXSYVP2
      b%LXSYVPO = a%LXSYVPO
      b%LXSYVPR = a%LXSYVPR
      b%LXSYVTR = a%LXSYVTR
      b%LXSYZF2 = a%LXSYZF2
      b%LXSYZXR = a%LXSYZXR
      b%LXTER = a%LXTER
      b%LXTI2 = a%LXTI2
      b%LXTQI = a%LXTQI
      b%LXV2F = a%LXV2F
      b%LXVB2 = a%LXVB2
      b%LXVC3 = a%LXVC3
      b%LXVC4 = a%LXVC4
      b%LXVC6 = a%LXVC6
      b%LXVCD = a%LXVCD
      b%LXVCH = a%LXVCH
      b%LXVCT = a%LXVCT
      b%LXVEE = a%LXVEE
      b%LXVIE = a%LXVIE
      b%LXVMO = a%LXVMO
      b%LXVP2 = a%LXVP2
      b%LXVPO = a%LXVPO
      b%LXVPR = a%LXVPR
      b%LXVTR = a%LXVTR
      b%LXZF2 = a%LXZF2
      b%LXZIMPS = a%LXZIMPS
      b%LXZIMPX = a%LXZIMPX
      b%LXZIMPXS = a%LXZIMPXS
      b%LXZXR = a%LXZXR
      b%LYRP2 = a%LYRP2
      b%LYRPL = a%LYRPL
      b%LYSIM = a%LYSIM
      b%LZFS = a%LZFS
      b%LZPSI = a%LZPSI
      b%MMAX = a%MMAX
      b%MMX_MAXE = a%MMX_MAXE
      b%MTRP2 = a%MTRP2
      b%MTRPL = a%MTRPL
      b%NANTECH_D = a%NANTECH_D
      b%NANTICH_D = a%NANTICH_D
      b%NANTLH_D = a%NANTLH_D
      b%NBDATA = a%NBDATA
      b%NBX = a%NBX
      b%NDEAEP = a%NDEAEP
      b%NDFS = a%NDFS
      b%NDMDF = a%NDMDF
      b%NDMFR = a%NDMFR
      b%NDMMX = a%NDMMX
      b%NDMSE = a%NDMSE
      b%NDPAEP = a%NDPAEP
      b%NDPFC = a%NDPFC
      b%NDPFC_PRE = a%NDPFC_PRE
      b%NEAEP = a%NEAEP
      b%NEFD0 = a%NEFD0
      b%NEFDB = a%NEFDB
      b%NEFDP = a%NEFDP
      b%NEFDQ = a%NEFDQ
      b%NEFDR = a%NEFDR
      b%NEFDS = a%NEFDS
      b%NFRBCODE = a%NFRBCODE
      b%NFRBMODE = a%NFRBMODE
      b%NGMAX_D = a%NGMAX_D
      b%NHECFT = a%NHECFT
      b%NHFMX = a%NHFMX
      b%NIMDF = a%NIMDF
      b%NISSIM = a%NISSIM
      b%NISX = a%NISX
      b%NITSIM = a%NITSIM
      b%NITX = a%NITX
      b%NKAEP = a%NKAEP
      b%NLIM = a%NLIM
      b%NMAPSIM = a%NMAPSIM
      b%NMDXKF = a%NMDXKF
      b%NMIMP = a%NMIMP
      b%NMOMD = a%NMOMD
      b%NMUAEP = a%NMUAEP
      b%NMZEFF = a%NMZEFF
      b%NNSIM = a%NNSIM
      b%NPACK = a%NPACK
      b%NPAEP = a%NPAEP
      b%NPELDA = a%NPELDA
      b%NPMDF = a%NPMDF
      b%NPMSE = a%NPMSE
      b%NRHIS = a%NRHIS
      b%NRHIX = a%NRHIX
      b%NRIAXR = a%NRIAXR
      b%NRIBOL = a%NRIBOL
      b%NRIBPA = a%NRIBPA
      b%NRIBPB = a%NRIBPB
      b%NRID2F = a%NRID2F
      b%NRIDE2 = a%NRIDE2
      b%NRIDF3 = a%NRIDF3
      b%NRIDF4 = a%NRIDF4
      b%NRIDF6 = a%NRIDF6
      b%NRIDFD = a%NRIDFD
      b%NRIDFH = a%NRIDFH
      b%NRIDFT = a%NRIDFT
      b%NRIECF = a%NRIECF
      b%NRIFD0 = a%NRIFD0
      b%NRIFDB = a%NRIFDB
      b%NRIFDP = a%NRIFDP
      b%NRIFDQ = a%NRIFDQ
      b%NRIFDR = a%NRIFDR
      b%NRIFDS = a%NRIFDS
      b%NRIFEH = a%NRIFEH
      b%NRIFEL = a%NRIFEL
      b%NRIGRB = a%NRIGRB
      b%NRIIBE = a%NRIIBE
      b%NRIIBI = a%NRIIBI
      b%NRIJBM = a%NRIJBM
      b%NRIJEC = a%NRIJEC
      b%NRIJIC = a%NRIJIC
      b%NRILF3 = a%NRILF3
      b%NRILF4 = a%NRILF4
      b%NRILF6 = a%NRILF6
      b%NRILFD = a%NRILFD
      b%NRILFH = a%NRILFH
      b%NRILFT = a%NRILFT
      b%NRILHE = a%NRILHE
      b%NRILHJ = a%NRILHJ
      b%NRIMSE = a%NRIMSE
      b%NRINER = a%NRINER
      b%NRINI3 = a%NRINI3
      b%NRINI4 = a%NRINI4
      b%NRINI6 = a%NRINI6
      b%NRINID = a%NRINID
      b%NRINIH = a%NRINIH
      b%NRINIM = a%NRINIM
      b%NRINIT = a%NRINIT
      b%NRINMR = a%NRINMR
      b%NRIOMG = a%NRIOMG
      b%NRIPRS = a%NRIPRS
      b%NRIQBE = a%NRIQBE
      b%NRIQBI = a%NRIQBI
      b%NRIQEC = a%NRIQEC
      b%NRIQIC = a%NRIQIC
      b%NRIQPR = a%NRIQPR
      b%NRIRES = a%NRIRES
      b%NRISBI = a%NRISBI
      b%NRISIM = a%NRISIM
      b%NRITER = a%NRITER
      b%NRITI2 = a%NRITI2
      b%NRITQI = a%NRITQI
      b%NRIV2F = a%NRIV2F
      b%NRIVB2 = a%NRIVB2
      b%NRIVC3 = a%NRIVC3
      b%NRIVC4 = a%NRIVC4
      b%NRIVC6 = a%NRIVC6
      b%NRIVCD = a%NRIVCD
      b%NRIVCH = a%NRIVCH
      b%NRIVCT = a%NRIVCT
      b%NRIVEE = a%NRIVEE
      b%NRIVIE = a%NRIVIE
      b%NRIVMO = a%NRIVMO
      b%NRIVP2 = a%NRIVP2
      b%NRIVPO = a%NRIVPO
      b%NRIVPR = a%NRIVPR
      b%NRIVTR = a%NRIVTR
      b%NRIZF2 = a%NRIZF2
      b%NRIZXR = a%NRIZXR
      b%NRMFR = a%NRMFR
      b%NRMSE = a%NRMSE
      b%NRP2 = a%NRP2
      b%NRPL = a%NRPL
      b%NRPSI = a%NRPSI
      b%NSAWFLAG = a%NSAWFLAG
      b%NSC = a%NSC
      b%NSC_FMT = a%NSC_FMT
      b%NSEVENT = a%NSEVENT
      b%NSEVPER = a%NSEVPER
      b%NSEVTBL = a%NSEVTBL
      b%NSEVWDS = a%NSEVWDS
      b%NSFAST_D = a%NSFAST_D
      b%NSYAXR = a%NSYAXR
      b%NSYBOL = a%NSYBOL
      b%NSYBPA = a%NSYBPA
      b%NSYBPB = a%NSYBPB
      b%NSYD2F = a%NSYD2F
      b%NSYDE2 = a%NSYDE2
      b%NSYDF3 = a%NSYDF3
      b%NSYDF4 = a%NSYDF4
      b%NSYDF6 = a%NSYDF6
      b%NSYDFD = a%NSYDFD
      b%NSYDFH = a%NSYDFH
      b%NSYDFT = a%NSYDFT
      b%NSYECF = a%NSYECF
      b%NSYFEH = a%NSYFEH
      b%NSYFEL = a%NSYFEL
      b%NSYGRB = a%NSYGRB
      b%NSYIBE = a%NSYIBE
      b%NSYIBI = a%NSYIBI
      b%NSYJBM = a%NSYJBM
      b%NSYJEC = a%NSYJEC
      b%NSYJIC = a%NSYJIC
      b%NSYLF3 = a%NSYLF3
      b%NSYLF4 = a%NSYLF4
      b%NSYLF6 = a%NSYLF6
      b%NSYLFD = a%NSYLFD
      b%NSYLFH = a%NSYLFH
      b%NSYLFT = a%NSYLFT
      b%NSYLHE = a%NSYLHE
      b%NSYLHJ = a%NSYLHJ
      b%NSYMSE = a%NSYMSE
      b%NSYNER = a%NSYNER
      b%NSYNI3 = a%NSYNI3
      b%NSYNI4 = a%NSYNI4
      b%NSYNI6 = a%NSYNI6
      b%NSYNID = a%NSYNID
      b%NSYNIH = a%NSYNIH
      b%NSYNIM = a%NSYNIM
      b%NSYNIT = a%NSYNIT
      b%NSYNMR = a%NSYNMR
      b%NSYOMG = a%NSYOMG
      b%NSYPRS = a%NSYPRS
      b%NSYQBE = a%NSYQBE
      b%NSYQBI = a%NSYQBI
      b%NSYQEC = a%NSYQEC
      b%NSYQIC = a%NSYQIC
      b%NSYQPR = a%NSYQPR
      b%NSYRES = a%NSYRES
      b%NSYSBI = a%NSYSBI
      b%NSYSIM = a%NSYSIM
      b%NSYTER = a%NSYTER
      b%NSYTI2 = a%NSYTI2
      b%NSYTQI = a%NSYTQI
      b%NSYV2F = a%NSYV2F
      b%NSYVB2 = a%NSYVB2
      b%NSYVC3 = a%NSYVC3
      b%NSYVC4 = a%NSYVC4
      b%NSYVC6 = a%NSYVC6
      b%NSYVCD = a%NSYVCD
      b%NSYVCH = a%NSYVCH
      b%NSYVCT = a%NSYVCT
      b%NSYVEE = a%NSYVEE
      b%NSYVIE = a%NSYVIE
      b%NSYVMO = a%NSYVMO
      b%NSYVP2 = a%NSYVP2
      b%NSYVPO = a%NSYVPO
      b%NSYVPR = a%NSYVPR
      b%NSYVTR = a%NSYVTR
      b%NSYZF2 = a%NSYZF2
      b%NSYZXR = a%NSYZXR
      b%NTABORT = a%NTABORT
      b%NTAEP = a%NTAEP
      b%NTFD0 = a%NTFD0
      b%NTFDB = a%NTFDB
      b%NTFDP = a%NTFDP
      b%NTFDQ = a%NTFDQ
      b%NTFDR = a%NTFDR
      b%NTFDS = a%NTFDS
      b%NTHFS = a%NTHFS
      b%NTIME1 = a%NTIME1
      b%NTIME2 = a%NTIME2
      b%NTIMEC = a%NTIMEC
      b%NTIMECA = a%NTIMECA
      b%NTIMECB = a%NTIMECB
      b%NTIMLH = a%NTIMLH
      b%NTIMNB = a%NTIMNB
      b%NTIMRF = a%NTIMRF
      b%NTIMRFF = a%NTIMRFF
      b%NTPSI = a%NTPSI
      b%NTSAW = a%NTSAW
      b%NXAXR = a%NXAXR
      b%NXBOL = a%NXBOL
      b%NXBPA = a%NXBPA
      b%NXBPB = a%NXBPB
      b%NXD2F = a%NXD2F
      b%NXDE2 = a%NXDE2
      b%NXDF3 = a%NXDF3
      b%NXDF4 = a%NXDF4
      b%NXDF6 = a%NXDF6
      b%NXDFD = a%NXDFD
      b%NXDFH = a%NXDFH
      b%NXDFT = a%NXDFT
      b%NXECF = a%NXECF
      b%NXFD0 = a%NXFD0
      b%NXFDB = a%NXFDB
      b%NXFDP = a%NXFDP
      b%NXFDQ = a%NXFDQ
      b%NXFDR = a%NXFDR
      b%NXFDS = a%NXFDS
      b%NXFEH = a%NXFEH
      b%NXFEL = a%NXFEL
      b%NXFS = a%NXFS
      b%NXGRB = a%NXGRB
      b%NXIBE = a%NXIBE
      b%NXIBI = a%NXIBI
      b%NXJBM = a%NXJBM
      b%NXJEC = a%NXJEC
      b%NXJIC = a%NXJIC
      b%NXLF3 = a%NXLF3
      b%NXLF4 = a%NXLF4
      b%NXLF6 = a%NXLF6
      b%NXLFD = a%NXLFD
      b%NXLFH = a%NXLFH
      b%NXLFT = a%NXLFT
      b%NXLHE = a%NXLHE
      b%NXLHJ = a%NXLHJ
      b%NXMMX = a%NXMMX
      b%NXMSE = a%NXMSE
      b%NXNE0 = a%NXNE0
      b%NXNER = a%NXNER
      b%NXNI3 = a%NXNI3
      b%NXNI4 = a%NXNI4
      b%NXNI6 = a%NXNI6
      b%NXNID = a%NXNID
      b%NXNIH = a%NXNIH
      b%NXNIM = a%NXNIM
      b%NXNIT = a%NXNIT
      b%NXNM0 = a%NXNM0
      b%NXNMR = a%NXNMR
      b%NXOMG = a%NXOMG
      b%NXPFC = a%NXPFC
      b%NXPRS = a%NXPRS
      b%NXQBE = a%NXQBE
      b%NXQBI = a%NXQBI
      b%NXQEC = a%NXQEC
      b%NXQIC = a%NXQIC
      b%NXQPR = a%NXQPR
      b%NXRES = a%NXRES
      b%NXRP2 = a%NXRP2
      b%NXRPL = a%NXRPL
      b%NXSBI = a%NXSBI
      b%NXSIM = a%NXSIM
      b%NXSYAXR = a%NXSYAXR
      b%NXSYBOL = a%NXSYBOL
      b%NXSYBPA = a%NXSYBPA
      b%NXSYBPB = a%NXSYBPB
      b%NXSYD2F = a%NXSYD2F
      b%NXSYDE2 = a%NXSYDE2
      b%NXSYDF3 = a%NXSYDF3
      b%NXSYDF4 = a%NXSYDF4
      b%NXSYDF6 = a%NXSYDF6
      b%NXSYDFD = a%NXSYDFD
      b%NXSYDFH = a%NXSYDFH
      b%NXSYDFT = a%NXSYDFT
      b%NXSYECF = a%NXSYECF
      b%NXSYFEH = a%NXSYFEH
      b%NXSYFEL = a%NXSYFEL
      b%NXSYGRB = a%NXSYGRB
      b%NXSYIBE = a%NXSYIBE
      b%NXSYIBI = a%NXSYIBI
      b%NXSYJBM = a%NXSYJBM
      b%NXSYJEC = a%NXSYJEC
      b%NXSYJIC = a%NXSYJIC
      b%NXSYLF3 = a%NXSYLF3
      b%NXSYLF4 = a%NXSYLF4
      b%NXSYLF6 = a%NXSYLF6
      b%NXSYLFD = a%NXSYLFD
      b%NXSYLFH = a%NXSYLFH
      b%NXSYLFT = a%NXSYLFT
      b%NXSYLHE = a%NXSYLHE
      b%NXSYLHJ = a%NXSYLHJ
      b%NXSYMSE = a%NXSYMSE
      b%NXSYNER = a%NXSYNER
      b%NXSYNI3 = a%NXSYNI3
      b%NXSYNI4 = a%NXSYNI4
      b%NXSYNI6 = a%NXSYNI6
      b%NXSYNID = a%NXSYNID
      b%NXSYNIH = a%NXSYNIH
      b%NXSYNIM = a%NXSYNIM
      b%NXSYNIT = a%NXSYNIT
      b%NXSYNMR = a%NXSYNMR
      b%NXSYOMG = a%NXSYOMG
      b%NXSYPRS = a%NXSYPRS
      b%NXSYQBE = a%NXSYQBE
      b%NXSYQBI = a%NXSYQBI
      b%NXSYQEC = a%NXSYQEC
      b%NXSYQIC = a%NXSYQIC
      b%NXSYQPR = a%NXSYQPR
      b%NXSYRES = a%NXSYRES
      b%NXSYSBI = a%NXSYSBI
      b%NXSYSIM = a%NXSYSIM
      b%NXSYTER = a%NXSYTER
      b%NXSYTI2 = a%NXSYTI2
      b%NXSYTQI = a%NXSYTQI
      b%NXSYV2F = a%NXSYV2F
      b%NXSYVB2 = a%NXSYVB2
      b%NXSYVC3 = a%NXSYVC3
      b%NXSYVC4 = a%NXSYVC4
      b%NXSYVC6 = a%NXSYVC6
      b%NXSYVCD = a%NXSYVCD
      b%NXSYVCH = a%NXSYVCH
      b%NXSYVCT = a%NXSYVCT
      b%NXSYVEE = a%NXSYVEE
      b%NXSYVIE = a%NXSYVIE
      b%NXSYVMO = a%NXSYVMO
      b%NXSYVP2 = a%NXSYVP2
      b%NXSYVPO = a%NXSYVPO
      b%NXSYVPR = a%NXSYVPR
      b%NXSYVTR = a%NXSYVTR
      b%NXSYZF2 = a%NXSYZF2
      b%NXSYZXR = a%NXSYZXR
      b%NXTE0 = a%NXTE0
      b%NXTER = a%NXTER
      b%NXTI2 = a%NXTI2
      b%NXTQI = a%NXTQI
      b%NXV2F = a%NXV2F
      b%NXVB2 = a%NXVB2
      b%NXVC3 = a%NXVC3
      b%NXVC4 = a%NXVC4
      b%NXVC6 = a%NXVC6
      b%NXVCD = a%NXVCD
      b%NXVCH = a%NXVCH
      b%NXVCT = a%NXVCT
      b%NXVEE = a%NXVEE
      b%NXVIE = a%NXVIE
      b%NXVMO = a%NXVMO
      b%NXVP2 = a%NXVP2
      b%NXVPO = a%NXVPO
      b%NXVPR = a%NXVPR
      b%NXVTR = a%NXVTR
      b%NXZEF2 = a%NXZEF2
      b%NXZF2 = a%NXZF2
      b%NXZXR = a%NXZXR
      b%NYRP2 = a%NYRP2
      b%NYRPL = a%NYRPL
      b%NZPSI = a%NZPSI
 
    end subroutine trdatbuf_copy
    logical function tdb_defined1(d,ztrigraph)
      type (trdatbuf) :: d
      character*(*), intent(in) :: ztrigraph
 
      character*3 ztri
 
      ztri = ztrigraph(1:min(3,len(ztrigraph)))
      call uupper(ztri)  ! convert to upper case (portlib routine)
 
      tdb_defined1 = .FALSE.
 
      if(ztri.eq.'ALP') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'BDI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'CUR') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'DFL') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'DTG') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'DTS') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'DTX') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'EDI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'EHP') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ELI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'FGW') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'FIE') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'FMN') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'FMX') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GAS') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GF3') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GF4') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GF6') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GFD') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GFH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GFT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'GIE') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'HAL') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'IBM') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'IEC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'IIC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ILH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'L2B') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'LAD') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'LID') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'NTX') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'OGF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ORC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PBE') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PBI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PEB') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PEC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PF0') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PFH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PFL') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PIB') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PIC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PLF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'PLH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'POS') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RBZ') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RC3') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RC4') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RC6') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RCD') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RCH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RCT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RCY') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RMN') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'RTP') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SBT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SF3') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SFA') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SFL') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SFP') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SFT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'SP3') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TET') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TGF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TIT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TPI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TQT') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TRC') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TRF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'TXI') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'VPH') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'VSB') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'VSF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'XKF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ZEF') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ZFA') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ZIM') then
         tdb_defined1 = .TRUE.
      endif
      if(ztri.eq.'ZPL') then
         tdb_defined1 = .TRUE.
      endif
 
    end function tdb_defined1
    logical function tdb_defined2(d,ztrigraph)
      type (trdatbuf) :: d
      character*(*), intent(in) :: ztrigraph
 
      character*3 ztri
 
      ztri = ztrigraph(1:min(3,len(ztrigraph)))
      call uupper(ztri)  ! convert to upper case (portlib routine)
 
      tdb_defined2 = .FALSE.
 
      if(ztri.eq.'AXR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'BOL') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'BPA') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'BPB') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'D2F') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DE2') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DF3') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DF4') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DF6') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DFD') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DFH') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'DFT') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'ECF') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FD0') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FDB') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FDP') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FDQ') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FDR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FDS') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FEH') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'FEL') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'GRB') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'IBE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'IBI') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'JBM') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'JEC') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'JIC') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LF3') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LF4') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LF6') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LFD') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LFH') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LFT') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LHE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'LHJ') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'MSE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NER') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NI3') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NI4') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NI6') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NID') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NIH') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NIM') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NIT') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'NMR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'OMG') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'PRS') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'QBE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'QBI') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'QEC') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'QIC') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'QPR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'RES') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'SBI') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'SIM') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'TER') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'TI2') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'TQI') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'V2F') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VB2') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VC3') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VC4') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VC6') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VCD') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VCH') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VCT') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VEE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VIE') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VMO') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VP2') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VPO') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VPR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'VTR') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'ZF2') then
         tdb_defined2 = .TRUE.
      endif
      if(ztri.eq.'ZXR') then
         tdb_defined2 = .TRUE.
      endif
 
    end function tdb_defined2
    logical function tdb_present1(d,ztrigraph,iaddr)
      type (trdatbuf) :: d
      character*(*), intent(in) :: ztrigraph
      integer, intent(out), optional :: iaddr
 
      integer :: iadr
      character*3 ztri
      integer :: lunmsg_tdb ! integer function lunmsg_tdb(idum)
 
      iadr = -1
      ztri = ztrigraph(1:min(3,len(ztrigraph)))
      call uupper(ztri)  ! convert to upper case (portlib routine)
 
      if(ztri.eq.'ALP') then
         iadr = d%LDATALP
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'BDI') then
         iadr = d%LDATBDI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'CUR') then
         iadr = d%LDATCUR
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'DFL') then
         iadr = d%LDATDFL
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'DTG') then
         iadr = d%LDATDTG
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'DTS') then
         iadr = d%LDATDTS
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'DTX') then
         iadr = d%LDATDTX
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'EDI') then
         iadr = d%LDATEDI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'EHP') then
         iadr = d%LDATEHP
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ELI') then
         iadr = d%LDATELI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'FGW') then
         iadr = d%LDATFGW
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'FIE') then
         iadr = d%LDATFIE
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'FMN') then
         iadr = d%LDATFMN
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'FMX') then
         iadr = d%LDATFMX
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GAS') then
         iadr = d%LDATGAS
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GF3') then
         iadr = d%LDATGF3
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GF4') then
         iadr = d%LDATGF4
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GF6') then
         iadr = d%LDATGF6
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GFD') then
         iadr = d%LDATGFD
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GFH') then
         iadr = d%LDATGFH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GFT') then
         iadr = d%LDATGFT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'GIE') then
         iadr = d%LDATGIE
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'HAL') then
         iadr = d%LDATHAL
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'IBM') then
         iadr = d%LDATIBM
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'IEC') then
         iadr = d%LDATIEC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'IIC') then
         iadr = d%LDATIIC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ILH') then
         iadr = d%LDATILH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'L2B') then
         iadr = d%LDATL2B
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'LAD') then
         iadr = d%LDATLAD
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'LID') then
         iadr = d%LDATLID
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'NTX') then
         iadr = d%LDATNTX
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'OGF') then
         iadr = d%LDATOGF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ORC') then
         iadr = d%LDATORC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PBE') then
         iadr = d%LDATPBE
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PBI') then
         iadr = d%LDATPBI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PEB') then
         iadr = d%LDATPEB
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PEC') then
         iadr = d%LDATPEC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PF0') then
         iadr = d%LDATPF0
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PFH') then
         iadr = d%LDATPFH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PFL') then
         iadr = d%LDATPFL
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PIB') then
         iadr = d%LDATPIB
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PIC') then
         iadr = d%LDATPIC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PLF') then
         iadr = d%LDATPLF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'PLH') then
         iadr = d%LDATPLH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'POS') then
         iadr = d%LDATPOS
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RBZ') then
         iadr = d%LDATRBZ
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RC3') then
         iadr = d%LDATRC3
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RC4') then
         iadr = d%LDATRC4
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RC6') then
         iadr = d%LDATRC6
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RCD') then
         iadr = d%LDATRCD
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RCH') then
         iadr = d%LDATRCH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RCT') then
         iadr = d%LDATRCT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RCY') then
         iadr = d%LDATRCY
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RMN') then
         iadr = d%LDATRMN
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'RTP') then
         iadr = d%LDATRTP
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SBT') then
         iadr = d%LDATSBT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SF3') then
         iadr = d%LDATSF3
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SFA') then
         iadr = d%LDATSFA
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SFL') then
         iadr = d%LDATSFL
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SFP') then
         iadr = d%LDATSFP
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SFT') then
         iadr = d%LDATSFT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'SP3') then
         iadr = d%LDATSP3
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TET') then
         iadr = d%LDATTET
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TGF') then
         iadr = d%LDATTGF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TIT') then
         iadr = d%LDATTIT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TPI') then
         iadr = d%LDATTPI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TQT') then
         iadr = d%LDATTQT
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TRC') then
         iadr = d%LDATTRC
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TRF') then
         iadr = d%LDATTRF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'TXI') then
         iadr = d%LDATTXI
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'VPH') then
         iadr = d%LDATVPH
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'VSB') then
         iadr = d%LDATVSB
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'VSF') then
         iadr = d%LDATVSF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'XKF') then
         iadr = d%LDATXKF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZEF') then
         iadr = d%LDATZEF
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZFA') then
         iadr = d%LDATZFA
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZIM') then
         iadr = d%LDATZIM
         tdb_present1 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZPL') then
         iadr = d%LDATZPL
         tdb_present1 = (iadr.gt.0)
      endif
 
      if(iadr.eq.-1) then
         write(lunmsg_tdb(0),*) ' ?tdb_present1: unknown scalar data type: ', &
               ztri
         tdb_present1 = .FALSE.
      endif
      if(present(iaddr)) iaddr=iadr
    end function tdb_present1
    logical function tdb_present2(d,ztrigraph,iaddr,iaddx,inumx)
      type (trdatbuf) :: d
      character*(*), intent(in) :: ztrigraph
      integer, intent(out),optional :: iaddr,iaddx,inumx
 
      integer :: iadr,iadx,inx
      character*3 ztri
      integer :: lunmsg_tdb ! integer function lunmsg_tdb(idum)
 
      iadr = -1
      ztri = ztrigraph(1:min(3,len(ztrigraph)))
      call uupper(ztri)  ! convert to upper case (portlib routine)
 
      if(ztri.eq.'AXR') then
         iadr = d%LFAXR
         iadx = d%LXAXR
         inx = d%NXAXR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'BOL') then
         iadr = d%LFBOL
         iadx = d%LXBOL
         inx = d%NXBOL
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'BPA') then
         iadr = d%LFBPA
         iadx = d%LXBPA
         inx = d%NXBPA
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'BPB') then
         iadr = d%LFBPB
         iadx = d%LXBPB
         inx = d%NXBPB
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'D2F') then
         iadr = d%LFD2F
         iadx = d%LXD2F
         inx = d%NXD2F
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DE2') then
         iadr = d%LFDE2
         iadx = d%LXDE2
         inx = d%NXDE2
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DF3') then
         iadr = d%LFDF3
         iadx = d%LXDF3
         inx = d%NXDF3
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DF4') then
         iadr = d%LFDF4
         iadx = d%LXDF4
         inx = d%NXDF4
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DF6') then
         iadr = d%LFDF6
         iadx = d%LXDF6
         inx = d%NXDF6
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DFD') then
         iadr = d%LFDFD
         iadx = d%LXDFD
         inx = d%NXDFD
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DFH') then
         iadr = d%LFDFH
         iadx = d%LXDFH
         inx = d%NXDFH
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'DFT') then
         iadr = d%LFDFT
         iadx = d%LXDFT
         inx = d%NXDFT
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'ECF') then
         iadr = d%LFECF
         iadx = d%LXECF
         inx = d%NXECF
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FD0') then
         iadr = d%LFFD0
         iadx = d%LXFD0
         inx = d%NXFD0
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FDB') then
         iadr = d%LFFDB
         iadx = d%LXFDB
         inx = d%NXFDB
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FDP') then
         iadr = d%LFFDP
         iadx = d%LXFDP
         inx = d%NXFDP
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FDQ') then
         iadr = d%LFFDQ
         iadx = d%LXFDQ
         inx = d%NXFDQ
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FDR') then
         iadr = d%LFFDR
         iadx = d%LXFDR
         inx = d%NXFDR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FDS') then
         iadr = d%LFFDS
         iadx = d%LXFDS
         inx = d%NXFDS
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FEH') then
         iadr = d%LFFEH
         iadx = d%LXFEH
         inx = d%NXFEH
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'FEL') then
         iadr = d%LFFEL
         iadx = d%LXFEL
         inx = d%NXFEL
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'GRB') then
         iadr = d%LFGRB
         iadx = d%LXGRB
         inx = d%NXGRB
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'IBE') then
         iadr = d%LFIBE
         iadx = d%LXIBE
         inx = d%NXIBE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'IBI') then
         iadr = d%LFIBI
         iadx = d%LXIBI
         inx = d%NXIBI
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'JBM') then
         iadr = d%LFJBM
         iadx = d%LXJBM
         inx = d%NXJBM
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'JEC') then
         iadr = d%LFJEC
         iadx = d%LXJEC
         inx = d%NXJEC
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'JIC') then
         iadr = d%LFJIC
         iadx = d%LXJIC
         inx = d%NXJIC
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LF3') then
         iadr = d%LFLF3
         iadx = d%LXLF3
         inx = d%NXLF3
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LF4') then
         iadr = d%LFLF4
         iadx = d%LXLF4
         inx = d%NXLF4
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LF6') then
         iadr = d%LFLF6
         iadx = d%LXLF6
         inx = d%NXLF6
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LFD') then
         iadr = d%LFLFD
         iadx = d%LXLFD
         inx = d%NXLFD
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LFH') then
         iadr = d%LFLFH
         iadx = d%LXLFH
         inx = d%NXLFH
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LFT') then
         iadr = d%LFLFT
         iadx = d%LXLFT
         inx = d%NXLFT
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LHE') then
         iadr = d%LFLHE
         iadx = d%LXLHE
         inx = d%NXLHE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'LHJ') then
         iadr = d%LFLHJ
         iadx = d%LXLHJ
         inx = d%NXLHJ
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'MSE') then
         iadr = d%LFMSE
         iadx = d%LXMSE
         inx = d%NXMSE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NER') then
         iadr = d%LFNER
         iadx = d%LXNER
         inx = d%NXNER
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NI3') then
         iadr = d%LFNI3
         iadx = d%LXNI3
         inx = d%NXNI3
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NI4') then
         iadr = d%LFNI4
         iadx = d%LXNI4
         inx = d%NXNI4
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NI6') then
         iadr = d%LFNI6
         iadx = d%LXNI6
         inx = d%NXNI6
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NID') then
         iadr = d%LFNID
         iadx = d%LXNID
         inx = d%NXNID
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NIH') then
         iadr = d%LFNIH
         iadx = d%LXNIH
         inx = d%NXNIH
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NIM') then
         iadr = d%LFNIM
         iadx = d%LXNIM
         inx = d%NXNIM
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NIT') then
         iadr = d%LFNIT
         iadx = d%LXNIT
         inx = d%NXNIT
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'NMR') then
         iadr = d%LFNMR
         iadx = d%LXNMR
         inx = d%NXNMR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'OMG') then
         iadr = d%LFOMG
         iadx = d%LXOMG
         inx = d%NXOMG
         if(iadr.eq.0) then
            iadr = d%LFVP2
            iadx = d%LXVP2
            inx = d%NXVP2
         endif
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'PRS') then
         iadr = d%LFPRS
         iadx = d%LXPRS
         inx = d%NXPRS
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'QBE') then
         iadr = d%LFQBE
         iadx = d%LXQBE
         inx = d%NXQBE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'QBI') then
         iadr = d%LFQBI
         iadx = d%LXQBI
         inx = d%NXQBI
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'QEC') then
         iadr = d%LFQEC
         iadx = d%LXQEC
         inx = d%NXQEC
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'QIC') then
         iadr = d%LFQIC
         iadx = d%LXQIC
         inx = d%NXQIC
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'QPR') then
         iadr = d%LFQPR
         iadx = d%LXQPR
         inx = d%NXQPR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'RES') then
         iadr = d%LFRES
         iadx = d%LXRES
         inx = d%NXRES
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'SBI') then
         iadr = d%LFSBI
         iadx = d%LXSBI
         inx = d%NXSBI
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'SIM') then
         iadr = maxval(d%LFSIM)
         iadx = 0
         inx = 0
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'TER') then
         iadr = d%LFTER
         iadx = d%LXTER
         inx = d%NXTER
         if(iadr.eq.0) then
            iadr = d%LFECF
            iadx = d%LXECF
            inx = d%NXECF
         endif
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'TI2') then
         iadr = d%LFTI2
         iadx = d%LXTI2
         inx = d%NXTI2
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'TQI') then
         iadr = d%LFTQI
         iadx = d%LXTQI
         inx = d%NXTQI
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'V2F') then
         iadr = d%LFV2F
         iadx = d%LXV2F
         inx = d%NXV2F
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VB2') then
         iadr = d%LFVB2
         iadx = d%LXVB2
         inx = d%NXVB2
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VC3') then
         iadr = d%LFVC3
         iadx = d%LXVC3
         inx = d%NXVC3
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VC4') then
         iadr = d%LFVC4
         iadx = d%LXVC4
         inx = d%NXVC4
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VC6') then
         iadr = d%LFVC6
         iadx = d%LXVC6
         inx = d%NXVC6
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VCD') then
         iadr = d%LFVCD
         iadx = d%LXVCD
         inx = d%NXVCD
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VCH') then
         iadr = d%LFVCH
         iadx = d%LXVCH
         inx = d%NXVCH
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VCT') then
         iadr = d%LFVCT
         iadx = d%LXVCT
         inx = d%NXVCT
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VEE') then
         iadr = d%LFVEE
         iadx = d%LXVEE
         inx = d%NXVEE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VIE') then
         iadr = d%LFVIE
         iadx = d%LXVIE
         inx = d%NXVIE
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VMO') then
         iadr = d%LFVMO
         iadx = d%LXVMO
         inx = d%NXVMO
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VP2') then
         iadr = d%LFVP2
         iadx = d%LXVP2
         inx = d%NXVP2
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VPO') then
         iadr = d%LFVPO
         iadx = d%LXVPO
         inx = d%NXVPO
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VPR') then
         iadr = d%LFVPR
         iadx = d%LXVPR
         inx = d%NXVPR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'VTR') then
         iadr = d%LFVTR
         iadx = d%LXVTR
         inx = d%NXVTR
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZF2') then
         iadr = d%LFZF2
         iadx = d%LXZF2
         inx = d%NXZF2
         tdb_present2 = (iadr.gt.0)
      endif
      if(ztri.eq.'ZXR') then
         iadr = d%LFZXR
         iadx = d%LXZXR
         inx = d%NXZXR
         tdb_present2 = (iadr.gt.0)
      endif
 
      if(iadr.eq.-1) then
         write(lunmsg_tdb(0),*) ' ?tdb_present2: unknown profile data type: ', &
               ztri
         tdb_present2 = .FALSE.
      endif
      if(present(iaddr)) iaddr = iadr
      if(present(iaddx)) iaddx = iadx
      if(present(inumx)) inumx = inx
    end function tdb_present2
    subroutine trdatbuf_expand(arr,ineed,isize_new)
 
      ! check size of 1d pointer array; expand & copy if necessary
 
      real*8, dimension(:), pointer :: arr
      integer, intent(in) :: ineed      ! min. size datbuf needed
      integer, intent(out) :: isize_new ! actual datbuf size
 
      integer :: isize_old,istat
      real*8, dimension(:), pointer :: ztmp
      real*8, parameter :: ZERO = 0.0d0
 
      !-----------------------------------------
 
      isize_new = size(arr)
      if(ineed.le.isize_new) return
 
      !  bigger buffer needed
 
      isize_old = isize_new
 
      do
        isize_new = 2*isize_new
        if(isize_new.gt.ineed) exit
      enddo
 
      allocate(ztmp(isize_new),stat=istat)
      if(istat.ne.0) then
        call errmsg_exit(' ?? trdatbuf_expand: memory alloc failed.')
      endif
 
      ztmp(1:isize_old) = arr
      ztmp(isize_old+1:isize_new) = ZERO
      deallocate(arr)
 
      arr => ztmp
    end subroutine trdatbuf_expand
 
    subroutine DATBUF_expand(s,ineed,isize_new)
 
      type (trdatbuf) :: s
      integer, intent(in) :: ineed       ! min. size datbuf needed
      integer, intent(out) :: isize_new  ! actual datbuf size
 
      call trdatbuf_expand(s%DATBUF,ineed,isize_new)
    end subroutine DATBUF_expand
    subroutine WORKBUF_expand(s,ineed,isize_new)
 
      type (trdatbuf) :: s
      integer, intent(in) :: ineed       ! min. size datbuf needed
      integer, intent(out) :: isize_new  ! actual datbuf size
 
      call trdatbuf_expand(s%WORKBUF,ineed,isize_new)
    end subroutine WORKBUF_expand
 
end module trdatbuf_obj

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_empty_alloc_1(ss,iout,ierr)


  ! Allocate array data for which all dimensions are provided

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize,jsize
  !-------------------


  !-----------------------------------------------
  ! allocate arrays...

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_ntm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_ntm)
  ENDIF
  IF(ALLOCATED(ss%chii_ntm)) then
     jsize = SIZE(ss%chii_ntm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_ntm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_ntm(ss%nrho_anomth))
     ss%chii_ntm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_tglf)
  ENDIF
  IF(ALLOCATED(ss%chii_tglf)) then
     jsize = SIZE(ss%chii_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_tglf(ss%nrho_anomth))
     ss%chii_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%chii_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_trans)
  ENDIF
  IF(ALLOCATED(ss%chii_trans)) then
     jsize = SIZE(ss%chii_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_trans(ss%nrho))
     ss%chii_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%chii_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_transcat)
  ENDIF
  IF(ALLOCATED(ss%chii_transcat)) then
     jsize = SIZE(ss%chii_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_transcat(ss%nrho,ss%ntrcat))
     ss%chii_transcat = 0.0_rspec
     ALLOCATE(ss%id_chii_transcat(ss%ntrcat))
     ss%id_chii_transcat = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chii_w19).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chii_w19)
  ENDIF
  IF(ALLOCATED(ss%chii_w19)) then
     jsize = SIZE(ss%chii_w19)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chii_w19 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chii_w19(ss%nrho_anomth))
     ss%chii_w19 = 0.0_rspec
  ENDIF

  isize = (ss%nrho)
  IF(ALLOCATED(ss%chimo_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chimo_trans)
  ENDIF
  IF(ALLOCATED(ss%chimo_trans)) then
     jsize = SIZE(ss%chimo_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chimo_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chimo_trans(ss%nrho))
     ss%chimo_trans = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%ntrcat)
  IF(ALLOCATED(ss%chimo_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chimo_transcat)
  ENDIF
  IF(ALLOCATED(ss%chimo_transcat)) then
     jsize = SIZE(ss%chimo_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chimo_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chimo_transcat(ss%nrho,ss%ntrcat))
     ss%chimo_transcat = 0.0_rspec
     ALLOCATE(ss%id_chimo_transcat(ss%ntrcat))
     ss%id_chimo_transcat = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_anom)
  ENDIF
  IF(ALLOCATED(ss%chiphi_anom)) then
     jsize = SIZE(ss%chiphi_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_anom(ss%nrho_anomth))
     ss%chiphi_anom = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_drbm)
  ENDIF
  IF(ALLOCATED(ss%chiphi_drbm)) then
     jsize = SIZE(ss%chiphi_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_drbm(ss%nrho_anomth))
     ss%chiphi_drbm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_glf)
  ENDIF
  IF(ALLOCATED(ss%chiphi_glf)) then
     jsize = SIZE(ss%chiphi_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_glf(ss%nrho_anomth))
     ss%chiphi_glf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%chiphi_gtcneo)) then
     jsize = SIZE(ss%chiphi_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_gtcneo(ss%nrho_anomth))
     ss%chiphi_gtcneo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_mmm71)
  ENDIF
  IF(ALLOCATED(ss%chiphi_mmm71)) then
     jsize = SIZE(ss%chiphi_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_mmm71(ss%nrho_anomth))
     ss%chiphi_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_neo)
  ENDIF
  IF(ALLOCATED(ss%chiphi_neo)) then
     jsize = SIZE(ss%chiphi_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_neo(ss%nrho_anomth))
     ss%chiphi_neo = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_tglf)
  ENDIF
  IF(ALLOCATED(ss%chiphi_tglf)) then
     jsize = SIZE(ss%chiphi_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_tglf(ss%nrho_anomth))
     ss%chiphi_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chiphi_w19).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chiphi_w19)
  ENDIF
  IF(ALLOCATED(ss%chiphi_w19)) then
     jsize = SIZE(ss%chiphi_w19)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chiphi_w19 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chiphi_w19(ss%nrho_anomth))
     ss%chiphi_w19 = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%chitheta_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%chitheta_mmm71)
  ENDIF
  IF(ALLOCATED(ss%chitheta_mmm71)) then
     jsize = SIZE(ss%chitheta_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: chitheta_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%chitheta_mmm71(ss%nrho_anomth))
     ss%chitheta_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%ncircuits)
  IF(ALLOCATED(ss%circuit_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%circuit_name)
  ENDIF
  IF(ALLOCATED(ss%circuit_name)) then
     jsize = SIZE(ss%circuit_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: circuit_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%circuit_name(ss%ncircuits))
     ss%circuit_name = " "
  ENDIF

  isize = (ss%ncircuits)
  IF(ALLOCATED(ss%coil_apt).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%coil_apt)
  ENDIF
  IF(ALLOCATED(ss%coil_apt)) then
     jsize = SIZE(ss%coil_apt)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: coil_apt already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%coil_apt(ss%ncircuits))
     ss%coil_apt = 0.0_rspec
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%coil_in_circuit).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%coil_in_circuit)
  ENDIF
  IF(ALLOCATED(ss%coil_in_circuit)) then
     jsize = SIZE(ss%coil_in_circuit)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: coil_in_circuit already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%coil_in_circuit(ss%ncoils))
     ss%coil_in_circuit = " "
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%coil_name).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%coil_name)
  ENDIF
  IF(ALLOCATED(ss%coil_name)) then
     jsize = SIZE(ss%coil_name)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: coil_name already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%coil_name(ss%ncoils))
     ss%coil_name = " "
  ENDIF

  isize = (ss%ncoils)
  IF(ALLOCATED(ss%coil_resispt).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%coil_resispt)
  ENDIF
  IF(ALLOCATED(ss%coil_resispt)) then
     jsize = SIZE(ss%coil_resispt)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: coil_resispt already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%coil_resispt(ss%ncoils))
     ss%coil_resispt = 0.0_rspec
  ENDIF

  isize = (ss%nrho_nbi-1)
  IF(ALLOCATED(ss%curbeam).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curbeam)
  ENDIF
  IF(ALLOCATED(ss%curbeam)) then
     jsize = SIZE(ss%curbeam)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curbeam already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curbeam(ss%nrho_nbi-1))
     ss%curbeam = 0.0_rspec
  ENDIF

  isize = (ss%nrho_ecrf-1)
  IF(ALLOCATED(ss%curech).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curech)
  ENDIF
  IF(ALLOCATED(ss%curech)) then
     jsize = SIZE(ss%curech)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curech already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curech(ss%nrho_ecrf-1))
     ss%curech = 0.0_rspec
  ENDIF

  isize = (ss%nrho_ecrf-1)*(ss%necrf_src)
  IF(ALLOCATED(ss%curech_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curech_src)
  ENDIF
  IF(ALLOCATED(ss%curech_src)) then
     jsize = SIZE(ss%curech_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curech_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curech_src(ss%nrho_ecrf-1,ss%necrf_src))
     ss%curech_src = 0.0_rspec
     ALLOCATE(ss%id_curech_src(ss%necrf_src))
     ss%id_curech_src = 0
  ENDIF

  isize = (ss%nrho_fus-1)
  IF(ALLOCATED(ss%curfusn).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curfusn)
  ENDIF
  IF(ALLOCATED(ss%curfusn)) then
     jsize = SIZE(ss%curfusn)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curfusn already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curfusn(ss%nrho_fus-1))
     ss%curfusn = 0.0_rspec
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%curich).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curich)
  ENDIF
  IF(ALLOCATED(ss%curich)) then
     jsize = SIZE(ss%curich)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curich already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curich(ss%nrho_icrf-1))
     ss%curich = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf-1)
  IF(ALLOCATED(ss%curlh).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curlh)
  ENDIF
  IF(ALLOCATED(ss%curlh)) then
     jsize = SIZE(ss%curlh)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curlh already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curlh(ss%nrho_lhrf-1))
     ss%curlh = 0.0_rspec
  ENDIF

  isize = (ss%nrho_lhrf-1)*(ss%nlhrf_src)
  IF(ALLOCATED(ss%curlh_src).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curlh_src)
  ENDIF
  IF(ALLOCATED(ss%curlh_src)) then
     jsize = SIZE(ss%curlh_src)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curlh_src already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curlh_src(ss%nrho_lhrf-1,ss%nlhrf_src))
     ss%curlh_src = 0.0_rspec
     ALLOCATE(ss%id_curlh_src(ss%nlhrf_src))
     ss%id_curlh_src = 0
  ENDIF

  isize = (ss%nrho_icrf-1)
  IF(ALLOCATED(ss%curmino).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curmino)
  ENDIF
  IF(ALLOCATED(ss%curmino)) then
     jsize = SIZE(ss%curmino)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curmino already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curmino(ss%nrho_icrf-1))
     ss%curmino = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%curr_bootstrap).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curr_bootstrap)
  ENDIF
  IF(ALLOCATED(ss%curr_bootstrap)) then
     jsize = SIZE(ss%curr_bootstrap)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curr_bootstrap already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curr_bootstrap(ss%nrho-1))
     ss%curr_bootstrap = 0.0_rspec
  ENDIF

  isize = (ss%nrho-1)
  IF(ALLOCATED(ss%curr_ohmic).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curr_ohmic)
  ENDIF
  IF(ALLOCATED(ss%curr_ohmic)) then
     jsize = SIZE(ss%curr_ohmic)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curr_ohmic already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curr_ohmic(ss%nrho-1))
     ss%curr_ohmic = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%curt).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%curt)
  ENDIF
  IF(ALLOCATED(ss%curt)) then
     jsize = SIZE(ss%curt)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: curt already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%curt(ss%nrho_eq))
     ss%curt = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rw-1)
  IF(ALLOCATED(ss%cur_rw).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%cur_rw)
  ENDIF
  IF(ALLOCATED(ss%cur_rw)) then
     jsize = SIZE(ss%cur_rw)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: cur_rw already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%cur_rw(ss%nrho_rw-1))
     ss%cur_rw = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%d2R_geo_dRHOdTH).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%d2R_geo_dRHOdTH)
  ENDIF
  IF(ALLOCATED(ss%d2R_geo_dRHOdTH)) then
     jsize = SIZE(ss%d2R_geo_dRHOdTH)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: d2R_geo_dRHOdTH already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%d2R_geo_dRHOdTH(ss%nrho_eq,ss%nth_eq))
     ss%d2R_geo_dRHOdTH = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%d2Z_geo_dRHOdTH)
  ENDIF
  IF(ALLOCATED(ss%d2Z_geo_dRHOdTH)) then
     jsize = SIZE(ss%d2Z_geo_dRHOdTH)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: d2Z_geo_dRHOdTH already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%d2Z_geo_dRHOdTH(ss%nrho_eq,ss%nth_eq))
     ss%d2Z_geo_dRHOdTH = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%db_mtm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%db_mtm)
  ENDIF
  IF(ALLOCATED(ss%db_mtm)) then
     jsize = SIZE(ss%db_mtm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: db_mtm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%db_mtm(ss%nrho_anomth))
     ss%db_mtm = 0.0_rspec
  ENDIF

  isize = (ss%nrho_rw-1)
  IF(ALLOCATED(ss%dcur_rw_dVloop).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dcur_rw_dVloop)
  ENDIF
  IF(ALLOCATED(ss%dcur_rw_dVloop)) then
     jsize = SIZE(ss%dcur_rw_dVloop)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dcur_rw_dVloop already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dcur_rw_dVloop(ss%nrho_rw-1))
     ss%dcur_rw_dVloop = 0.0_rspec
  ENDIF

  isize = (ss%ndelta_w)
  IF(ALLOCATED(ss%DeltaW_code).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%DeltaW_code)
  ENDIF
  IF(ALLOCATED(ss%DeltaW_code)) then
     jsize = SIZE(ss%DeltaW_code)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: DeltaW_code already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%DeltaW_code(ss%ndelta_w))
     ss%DeltaW_code = " "
  ENDIF

  isize = (ss%ndelta_w)
  IF(ALLOCATED(ss%DeltaW_mapper).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%DeltaW_mapper)
  ENDIF
  IF(ALLOCATED(ss%DeltaW_mapper)) then
     jsize = SIZE(ss%DeltaW_mapper)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: DeltaW_mapper already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%DeltaW_mapper(ss%ndelta_w))
     ss%DeltaW_mapper = " "
  ENDIF

  isize = (ss%mmodes)*(ss%ndelta_w)
  IF(ALLOCATED(ss%DeltaW_stable).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%DeltaW_stable)
  ENDIF
  IF(ALLOCATED(ss%DeltaW_stable)) then
     jsize = SIZE(ss%DeltaW_stable)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: DeltaW_stable already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%DeltaW_stable(ss%mmodes,ss%ndelta_w))
     ss%DeltaW_stable = 0
  ENDIF

  isize = (ss%ndelta_w)
  IF(ALLOCATED(ss%DeltaW_status).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%DeltaW_status)
  ENDIF
  IF(ALLOCATED(ss%DeltaW_status)) then
     jsize = SIZE(ss%DeltaW_status)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: DeltaW_status already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%DeltaW_status(ss%ndelta_w))
     ss%DeltaW_status = 0
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%difb_fusi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difb_fusi)
  ENDIF
  IF(ALLOCATED(ss%difb_fusi)) then
     jsize = SIZE(ss%difb_fusi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difb_fusi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difb_fusi(ss%nrho_anom))
     ss%difb_fusi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%difb_nbi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difb_nbi)
  ENDIF
  IF(ALLOCATED(ss%difb_nbi)) then
     jsize = SIZE(ss%difb_nbi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difb_nbi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difb_nbi(ss%nrho_anom))
     ss%difb_nbi = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anom)
  IF(ALLOCATED(ss%difb_rfmi).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difb_rfmi)
  ENDIF
  IF(ALLOCATED(ss%difb_rfmi)) then
     jsize = SIZE(ss%difb_rfmi)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difb_rfmi already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difb_rfmi(ss%nrho_anom))
     ss%difb_rfmi = 0.0_rspec
  ENDIF

  isize = (ss%nrho)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%diff_trans).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%diff_trans)
  ENDIF
  IF(ALLOCATED(ss%diff_trans)) then
     jsize = SIZE(ss%diff_trans)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: diff_trans already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%diff_trans(ss%nrho,0:ss%nspec_th))
     ss%diff_trans = 0.0_rspec
     ALLOCATE(ss%id_diff_trans(0:ss%nspec_th))
     ss%id_diff_trans = 0
  ENDIF

  isize = (ss%nrho)*(ss%nspec_th+1)*(ss%ntrcat)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%diff_transcat).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%diff_transcat)
  ENDIF
  IF(ALLOCATED(ss%diff_transcat)) then
     jsize = SIZE(ss%diff_transcat)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: diff_transcat already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%diff_transcat(ss%nrho,0:ss%nspec_th,ss%ntrcat))
     ss%diff_transcat = 0.0_rspec
     ALLOCATE(ss%id_diff_transcat(0:ss%nspec_th,ss%ntrcat))
     ss%id_diff_transcat = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%difne_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difne_nclass)
  ENDIF
  IF(ALLOCATED(ss%difne_nclass)) then
     jsize = SIZE(ss%difne_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difne_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difne_nclass(ss%nrho_anomth))
     ss%difne_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%difnh_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difnh_nclass)
  ENDIF
  IF(ALLOCATED(ss%difnh_nclass)) then
     jsize = SIZE(ss%difnh_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difnh_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difnh_nclass(ss%nrho_anomth))
     ss%difnh_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_anom).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_anom)
  ENDIF
  IF(ALLOCATED(ss%difns_anom)) then
     jsize = SIZE(ss%difns_anom)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_anom already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_anom(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_anom = 0.0_rspec
     ALLOCATE(ss%id_difns_anom(0:ss%nspec_th))
     ss%id_difns_anom = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_drbm).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_drbm)
  ENDIF
  IF(ALLOCATED(ss%difns_drbm)) then
     jsize = SIZE(ss%difns_drbm)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_drbm already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_drbm(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_drbm = 0.0_rspec
     ALLOCATE(ss%id_difns_drbm(0:ss%nspec_th))
     ss%id_difns_drbm = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_glf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_glf)
  ENDIF
  IF(ALLOCATED(ss%difns_glf)) then
     jsize = SIZE(ss%difns_glf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_glf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_glf(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_glf = 0.0_rspec
     ALLOCATE(ss%id_difns_glf(0:ss%nspec_th))
     ss%id_difns_glf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_gtcneo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_gtcneo)
  ENDIF
  IF(ALLOCATED(ss%difns_gtcneo)) then
     jsize = SIZE(ss%difns_gtcneo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_gtcneo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_gtcneo(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_gtcneo = 0.0_rspec
     ALLOCATE(ss%id_difns_gtcneo(0:ss%nspec_th))
     ss%id_difns_gtcneo = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_mmm71)
  ENDIF
  IF(ALLOCATED(ss%difns_mmm71)) then
     jsize = SIZE(ss%difns_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_mmm71(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_mmm71 = 0.0_rspec
     ALLOCATE(ss%id_difns_mmm71(0:ss%nspec_th))
     ss%id_difns_mmm71 = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_nclass)
  ENDIF
  IF(ALLOCATED(ss%difns_nclass)) then
     jsize = SIZE(ss%difns_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_nclass(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_nclass = 0.0_rspec
     ALLOCATE(ss%id_difns_nclass(0:ss%nspec_th))
     ss%id_difns_nclass = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_neo).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_neo)
  ENDIF
  IF(ALLOCATED(ss%difns_neo)) then
     jsize = SIZE(ss%difns_neo)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_neo already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_neo(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_neo = 0.0_rspec
     ALLOCATE(ss%id_difns_neo(0:ss%nspec_th))
     ss%id_difns_neo = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_tglf)
  ENDIF
  IF(ALLOCATED(ss%difns_tglf)) then
     jsize = SIZE(ss%difns_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_tglf(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_tglf = 0.0_rspec
     ALLOCATE(ss%id_difns_tglf(0:ss%nspec_th))
     ss%id_difns_tglf = 0
  ENDIF

  isize = (ss%nrho_anomth)*(ss%nspec_th+1)
  IF(ss%nspec_th.LE.0) isize = 0
  IF(ALLOCATED(ss%difns_w19).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difns_w19)
  ENDIF
  IF(ALLOCATED(ss%difns_w19)) then
     jsize = SIZE(ss%difns_w19)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difns_w19 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difns_w19(ss%nrho_anomth,0:ss%nspec_th))
     ss%difns_w19 = 0.0_rspec
     ALLOCATE(ss%id_difns_w19(0:ss%nspec_th))
     ss%id_difns_w19 = 0
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%difnx_nclass).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difnx_nclass)
  ENDIF
  IF(ALLOCATED(ss%difnx_nclass)) then
     jsize = SIZE(ss%difnx_nclass)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difnx_nclass already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difnx_nclass(ss%nrho_anomth))
     ss%difnx_nclass = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%difnz_mmm71).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%difnz_mmm71)
  ENDIF
  IF(ALLOCATED(ss%difnz_mmm71)) then
     jsize = SIZE(ss%difnz_mmm71)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: difnz_mmm71 already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%difnz_mmm71(ss%nrho_anomth))
     ss%difnz_mmm71 = 0.0_rspec
  ENDIF

  isize = (ss%nspec_alla+1)
  IF(ss%nspec_alla.LE.0) isize = 0
  IF(ALLOCATED(ss%dist_fun).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dist_fun)
  ENDIF
  IF(ALLOCATED(ss%dist_fun)) then
     jsize = SIZE(ss%dist_fun)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dist_fun already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dist_fun(0:ss%nspec_alla))
     ss%dist_fun = " "
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%dQedGrdte_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dQedGrdte_tglf)
  ENDIF
  IF(ALLOCATED(ss%dQedGrdte_tglf)) then
     jsize = SIZE(ss%dQedGrdte_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dQedGrdte_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dQedGrdte_tglf(ss%nrho_anomth))
     ss%dQedGrdte_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%dQedGrdti_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dQedGrdti_tglf)
  ENDIF
  IF(ALLOCATED(ss%dQedGrdti_tglf)) then
     jsize = SIZE(ss%dQedGrdti_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dQedGrdti_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dQedGrdti_tglf(ss%nrho_anomth))
     ss%dQedGrdti_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%dQidGrdte_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dQidGrdte_tglf)
  ENDIF
  IF(ALLOCATED(ss%dQidGrdte_tglf)) then
     jsize = SIZE(ss%dQidGrdte_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dQidGrdte_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dQidGrdte_tglf(ss%nrho_anomth))
     ss%dQidGrdte_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_anomth)
  IF(ALLOCATED(ss%dQidGrdti_tglf).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dQidGrdti_tglf)
  ENDIF
  IF(ALLOCATED(ss%dQidGrdti_tglf)) then
     jsize = SIZE(ss%dQidGrdti_tglf)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dQidGrdti_tglf already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dQidGrdti_tglf(ss%nrho_anomth))
     ss%dQidGrdti_tglf = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%dR0_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dR0_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dR0_momeq_dRHO)) then
     jsize = SIZE(ss%dR0_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dR0_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dR0_momeq_dRHO(ss%nrho_eq))
     ss%dR0_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%dR_geo_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dR_geo_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dR_geo_dRHO)) then
     jsize = SIZE(ss%dR_geo_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dR_geo_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dR_geo_dRHO(ss%nrho_eq,ss%nth_eq))
     ss%dR_geo_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%dR_geo_dTH).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dR_geo_dTH)
  ENDIF
  IF(ALLOCATED(ss%dR_geo_dTH)) then
     jsize = SIZE(ss%dR_geo_dTH)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dR_geo_dTH already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dR_geo_dTH(ss%nrho_eq,ss%nth_eq))
     ss%dR_geo_dTH = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dxRjcos_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dxRjcos_momeq_dRHO)) then
     jsize = SIZE(ss%dxRjcos_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dxRjcos_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dxRjcos_momeq_dRHO(ss%nrho_eq,ss%neqmom))
     ss%dxRjcos_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dxRjsin_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dxRjsin_momeq_dRHO)) then
     jsize = SIZE(ss%dxRjsin_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dxRjsin_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dxRjsin_momeq_dRHO(ss%nrho_eq,ss%neqmom))
     ss%dxRjsin_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dxZjcos_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dxZjcos_momeq_dRHO)) then
     jsize = SIZE(ss%dxZjcos_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dxZjcos_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dxZjcos_momeq_dRHO(ss%nrho_eq,ss%neqmom))
     ss%dxZjcos_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%neqmom)
  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dxZjsin_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dxZjsin_momeq_dRHO)) then
     jsize = SIZE(ss%dxZjsin_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dxZjsin_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dxZjsin_momeq_dRHO(ss%nrho_eq,ss%neqmom))
     ss%dxZjsin_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nicrf_src)
  IF(ALLOCATED(ss%dx_fshield).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dx_fshield)
  ENDIF
  IF(ALLOCATED(ss%dx_fshield)) then
     jsize = SIZE(ss%dx_fshield)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dx_fshield already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dx_fshield(ss%nicrf_src))
     ss%dx_fshield = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)
  IF(ALLOCATED(ss%dZ0_momeq_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dZ0_momeq_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dZ0_momeq_dRHO)) then
     jsize = SIZE(ss%dZ0_momeq_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dZ0_momeq_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dZ0_momeq_dRHO(ss%nrho_eq))
     ss%dZ0_momeq_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%dZ_geo_dRHO).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dZ_geo_dRHO)
  ENDIF
  IF(ALLOCATED(ss%dZ_geo_dRHO)) then
     jsize = SIZE(ss%dZ_geo_dRHO)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dZ_geo_dRHO already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dZ_geo_dRHO(ss%nrho_eq,ss%nth_eq))
     ss%dZ_geo_dRHO = 0.0_rspec
  ENDIF

  isize = (ss%nrho_eq)*(ss%nth_eq)
  IF(ALLOCATED(ss%dZ_geo_dTH).AND.(isize.EQ.0)) then
     DEALLOCATE(ss%dZ_geo_dTH)
  ENDIF
  IF(ALLOCATED(ss%dZ_geo_dTH)) then
     jsize = SIZE(ss%dZ_geo_dTH)
     IF(isize.NE.jsize) THEN
        WRITE(iout,*) &
             " ?plasma_state_empty_alloc: dZ_geo_dTH already allocated with size:"
        WRITE(iout,*) "    old size: ",jsize
        WRITE(iout,*) "    requested new size: ",isize
        ierr=999
     ENDIF
  ELSE IF (isize.GT.0) THEN
     ALLOCATE(ss%dZ_geo_dTH(ss%nrho_eq,ss%nth_eq))
     ss%dZ_geo_dTH = 0.0_rspec
  ENDIF

END SUBROUTINE plasma_state_empty_alloc_1

subroutine splitn_edit_enable(program_name)

  use splitn_module
  implicit NONE

  ! activate editing capability

  character*(*) program_name

  !-------------------------------------

  if(edit_started) then
     write(6,*) ' %splitn_edit_enable: edit already enabled & started by: ', &
          trim(edit_program)
     edit_started = edit_program.eq.program_name
  endif

  edit_program = program_name
  edit_enabled = .TRUE.

end subroutine splitn_edit_enable

subroutine ps_tagchk(caller_str,itag,iout,ierr)

  use plasma_state_constants_mod
  implicit NONE

  !  quick error check

  character*(*), intent(in) :: caller_str
  integer, intent(in) :: itag   ! = ps_unInit means not initialized...
  integer, intent(in) :: iout   ! unit for error message
  integer, intent(out) :: ierr  ! status code, 0=OK

  !-------------------------

  if(itag.eq.ps_unInit) then
     write(iout,*) ' ?'//trim(caller_str)// &
          ': passed plasma state was never initialized.'
     ierr=999
  else
     ierr=0
  endif

end subroutine ps_tagchk

subroutine tr_getnl_clear
!
!  clear the namelist module
!
  use tr_getnl
  implicit NONE
!
!  OK... init namelist status (read not yet tried)
!
  nltext_status=-1
  nltext_nlines=0
  if(allocated(nltext)) deallocate(nltext)
  if(allocated(nltext_lens)) deallocate(nltext_lens)
!
  return
!
end subroutine tr_getnl_clear

c----------------------------------------------------------------------
      subroutine trxpl_gs2fas(itype,zmulti,znroot,ztroot,ztrat,
     >   ierr)
c
c  acquire fast species based on contents of standard TRANSP multigraph
c
      use trxpl_gs2_module
c
      implicit NONE
c
      integer, intent(in) :: itype      ! fast ion type beam/rf/fusion prod.
      character*(*), intent(in) :: zmulti  ! multigraph name
      character*(*), intent(in) :: znroot  ! root of density profile names
      character*(*), intent(in) :: ztroot  ! root of temperature prof names
      real*8, intent(in) :: ztrat       ! factor to get temperature or 2/3<E>
c
      integer, intent(out) :: ierr      ! completion code, 0=OK
c
c  zmulti refers to the multigraph of fast ion specie densities
c  znroot refers to the expected root of name of individual density profiles
c    full name will be <znroot>_<species-code>, where
c
c       <species-code>     means
c         H or P            hydrogen,  Z=1,A=1
c         D                 deuterium, Z=1,A=2
c         T                 tritium,   Z=1,A=3
c         3                 helium-3,  Z=2,A=3
c         4                 helium-4,  Z=2,A=4
c
c  ztroot refers to the expected root of name of individual temperature or
c  average energy profile.  The species-code found in the density multigraph
c  will also be used for the temperature profile
c
c  ztrat*[<ztroot>_<species-code>] gives the temperature or 2/3<E> profile
c    we expect ztrat=1.0 or ztrat=2/3
c
c
c  ierr -- the error flag will be set if the multigraph contains a density
c    profile name with form <root>_<species> where either <root> or <species>
c    has an unexpected value.  Also, if a density profile exists but the
c    corresponding temperature or <E> profile is absent, the error flag will
c    be set.
c
c------------------------------------------
c
      integer, parameter :: ns=6
      character*1 scodes(ns)
      character*3 sclabl(ns)
      integer izz(ns),iaa(ns)
c
      character*20 lbl_types(3:5)
c
      integer i,j,k,kt,is,imulti,istype
      integer nomatch
c
      character*64 zlabel
      character*32 zunits
c
      integer infuns
      character*10 zmembs(max_species),ztest1,ztest2,zname1,zname2
      integer isigns(max_species)
c
      data scodes/'H','P','D','T','3','4'/
      data sclabl/'H','H','D','T','He3','He4'/
      data izz   / 1 , 1 , 1 , 1 , 2   , 2   /
      data iaa   / 1 , 1 , 2 , 3 , 3   , 4   /
c
      data lbl_types/'beam ion','RF minority ion','fusion product'/
c
c------------------------------------------
c
      call rplabel(zmulti,zlabel,zunits,imulti,istype)
      if(imulti.eq.-1000) return        ! no such fast species this run
c
      call rpmulti(zmulti,istype,zlabel,zunits,infuns,isigns,zmembs,
     >   ierr)
      if(ierr.ne.0) then
         call uermsg('?trxpl_mkgs2:  multigraph read error: ',zmulti,0)
         return
      endif
c
      ztest1=znroot
      kt=len_trim(znroot)+1
      ztest1(kt:kt)='_'
      call uupper(ztest1)
c
      nomatch=0
c
      do i=1,infuns
         ztest2=zmembs(i)
         call uupper(ztest2)
         if(ztest1(1:kt).ne.ztest2(1:kt)) then
            nomatch=nomatch+1
            if(nomatch.gt.1) then
               write(6,*)
     >            ' ?trxpl_mkgs2:  too many multigraph members with'
               write(6,*)
     >            '  names not starting with:  ',ztest1
               write(6,*) '  multigraph is:  ',zmulti
               write(6,*) '  contents:  ',(zmembs(j),j=1,infuns)
               ierr=1
               return
            endif
         else
            is=0
            do j=1,ns
               if(ztest2(kt+1:10).eq.scodes(j)) then
                  is=j
               endif
            enddo
            if(is.eq.0) then
               write(6,*)
     >            ' ?trxpl_mkgs2: unrecognized species code: ',ztest2
               write(6,*)
     >            '  in multigraph:  ',zmulti
               ierr=1
               return
            endif
c
            zname1=znroot(1:len_trim(znroot))//'_'//scodes(is)
            zname2=ztroot(1:len_trim(ztroot))//'_'//scodes(is)
            call uupper(zname1)
            call uupper(zname2)
c
            num_species=num_species+1
            j=num_species
            ltype(j)=itype
            Aplas(j)=iaa(is)/mass_ref
            Zplas(j)=izz(is)
            Tconv(j)=ztrat
            call trx_prof(zname1,zunits,iorder,id_norig(j),ierr)
            if(ierr.ne.0) then
               call uermsg('TRANSP profile access failed',
     >            zname1,0)
               return
            endif
            call trx_prof(zname2,zunits,iorder,id_torig(j),ierr)
            if(ierr.ne.0) then
               call uermsg('TRANSP profile access failed',
     >            zname2,0)
               return
            endif
            slabel(j)=sclabl(is)
            k=len_trim(slabel(j))+2
            slabel(j)(k:)=lbl_types(itype)
         endif
      enddo
c
      ierr=0
      return
c
      end

subroutine ps_varchk(ss,varname,icdf,varid,iout)

  !  hand coded variable check
  !  this routine is invoked e.g. for variables whose units definitions
  !  have changed over the history of the definition of the Plasma State

  use plasma_state_definition_mod
  use netcdf
  implicit NONE

  !---------------------------------------
  !  passed arguments:

  type (plasma_state) :: ss
  character*(*), intent(in) :: varname

  integer, intent(in) :: icdf   ! NetCDF file ID, open file
  integer, intent(in) :: varid  ! NetCDF variable ID
  integer, intent(in) :: iout   ! LUN for messages

  !---------------------------------------
  !  local:
  character*40 att_value
  integer :: istat
  !-----------------------

  if((varname.eq.'freq_ec').or.(varname.eq.'freq_ic').or. &
       (varname.eq.'freq_lh')) then
     att_value=' '
     istat=nf90_get_att(icdf,varid,"units",att_value)

     if(trim(att_value).eq.'MHz') then
        write(iout,*) ' %ps_varchk: '//trim(varname)// &
             ' element converted, MHz -> Hz.'
        if(varname.eq.'freq_ec') then
           ss%freq_ec = ss%freq_ec * 1.0d6
        else if(varname.eq.'freq_ic') then
           ss%freq_ic = ss%freq_ic * 1.0d6
        else if(varname.eq.'freq_lh') then
           ss%freq_lh = ss%freq_lh * 1.0d6
        endif

     else if(trim(att_value).eq.'GHz') then
        write(iout,*) ' %ps_varchk: '//trim(varname)// &
             ' element converted, GHz -> Hz.'
        if(varname.eq.'freq_ec') then
           ss%freq_ec = ss%freq_ec * 1.0d9
        else if(varname.eq.'freq_ic') then
           ss%freq_ic = ss%freq_ic * 1.0d9
        else if(varname.eq.'freq_lh') then
           ss%freq_lh = ss%freq_lh * 1.0d9
        endif

     else if(trim(att_value).eq.'Hz') then
        continue

     else
        if(istat.ne.NF90_NOERR) then
           write(iout,*) ' %ps_varchk: nf90_get_att error.'
        else
           write(iout,*) ' %ps_varchk: unexpected '//trim(varname)// &
                ' element units: "'// &
                trim(att_value)//'".'
        endif
     endif

  else
     write(iout,*) ' %ps_varchk: unexpected call, varname = "'// &
          trim(varname)//'".'
  endif

end subroutine ps_varchk

program trxpl2ps

  !  DMC Nov 2010: added machine description input capability
  !  DMC July 2010: generate plasma states from TRANSP archives

  !  The functionality is similar to "trxpl", but, this program has no
  !  graphics and no interactive interface.  It is controlled entirely
  !  with command line arguments.  It uses a simple set of trxplib routines
  !  to connect to a run and select the state output times and option--
  !  it illustrates a "subroutine library" interface to TRANSP data in
  !  Plasma State format

  !  this program takes command line arguments.  Syntax:

  !     trxpl2ps FILE|MDS+ <data-path> <output-path> [-mhdeq] [-test] \
  !                 [-mdescr:<mdescr_filename> (multiple -mdescr files OK)] \
  !                 [-prefix:<prefix>  -all_times]
  !                 <time1> <file1>   <time2> <file2>  ... ...

  !  these argument(s) are optional and can be positioned anywhere
  !      -mhdeq   (if present, write Plasma States with all available MHD
  !                equilibrium data; if not, write reduced states with 1d
  !                profiles only).
  !      -test    (if present some additional debugging tests are done;
  !                this is for the benefit of code developers).
  !  (additional option arguments may be added, see error message printout...)

  !  these arguments are required and must be in order.  It what follows
  !  "first (second) (third) argument" means first (second) (third) 
  !  non-optional argument.

  !     1st argument:  literal, either FILE or MDS+
  !     indicates path to TRANSP data is through FILES or through an MDS+
  !     server

  !     2nd argument:  <data-path> -- path to TRANSP data; syntax depends
  !     on 1st argument.  
  !        If 1st argument is "FILE": 2nd argument is of
  !     the form <directory-path>/<runid> and the run files are expected
  !     to be found in <runid>* at the indicated <directory-path>.  If the
  !     <directory-path> is omitted, the program looks in the current 
  !     working directory for files <runid>*.  The files that will be
  !     read (as of July 2010) are:  <runid>.CDF  <runid>PH.CDF  <runid>TR.DAT
  !     It is usually possible to download these files, for sites without
  !     MDS+ client capability.
  !        If 1st argument is "MDS+": 2nd argument is a TRANSP-enhanced
  !     MDS+ path.  This has a general syntax of <server>:<tree>(<runid>)
  !     but some details vary depending on the server:
  !        ...PPPL server: transpgrid.pppl.gov:TRANSP_<tok>(<tok>,<runid>)
  !        ...MIT server:  cmoda.psfc.mit.edu:<treename>(<shot-number>)
  !        ...GA server:   atlas.gat.com:TRANSP(<transp-number>)
  !     Caution: as of July 2010 only the PPPL path has been tested!
  !     Here are specific examples of valid paths:
  !        "transpgrid.pppl.gov:TRANSP_TFTR(TFTR,37065P35)"
  !        "transpgrid.pppl.gov:TRANSP_D3D(D3D,133137B04)"
  !     NOTE, to find a TRANSP appropriate for research use, it is important
  !     to consult with the run author or somebody with detailed familiarity
  !     with the data.

  !     3rd argument:  <output-path> -- directory where output data can
  !     be written.  Can be "."; but in any case, a valid, writable path 
  !     must be provided.

  !     remaining arguments come in pairs and there can be as many or as
  !     few as desired:

  !     4th and 5th arguments  <time1> <file1> 
  !     ...the time at which to extract data, and
  !     ...the file root name to write
  !     Example:  1.234  ps1x234
  !        ---> data from time t=1.234 seconds in the TRANSP run is written
  !             into a Plasma State NetCDF file <output-path>/ps1x234.cdf

  !     6th and 7th arguments  <time2> <file2>

  !     8th and 9th arguments  <time3> <file3>

  !     10th and 11th arguments  <time4> <file4>

  !         --etc--

  !--------------------------------------------------------------------------
  USE plasma_state_mod
  implicit NONE

  !-------------------------------------------

  type (plasma_state) :: ss

  integer :: iarg,nargs   ! command line arguments
  integer :: iargct       ! non-option command argument counter
  integer :: ilen         ! non-blank length of argument string

  integer :: ierr         ! error indicator

  character*250 :: argval,save_argval ! argument value
  character*250 :: dpath,opath  ! <data-path> and <output-path>

  logical :: mds_mode     ! .TRUE. if 1st arg is MDS+
  character*4 :: mode_str

  logical :: test_flag    ! -test indicator
  logical :: mhdeq_flag   ! -mhdeq indicator
  logical :: all_times    ! -all_times indicator

  integer :: iBccw        ! B field direction option
  integer :: iJccw        ! current direction option

  logical :: found_filename
  integer :: istat,ierloc

  character*60 ztest,all_times_prefix
  character*20 zvalr8

  integer :: ntimes  ! number of time values found
  integer :: itime
  real*8, dimension(:), allocatable :: timevals  ! the time values
  character*200, dimension(:), allocatable :: filenams  ! the filename roots

  integer, parameter :: nonlin = 6  ! output unit for messages

  !-------------------------------------------
  !  Part 1: parse command line arguments
  !-------------------------------------------

  write(nonlin,*) ' => this is trxpl2ps version DMC 16-Dec-2010'
  write(nonlin,*) '    (TRANSP archives Plasma State Extractor)'
  test_flag = .FALSE.
  mhdeq_flag = .FALSE.
  mds_mode = .FALSE.
  all_times = .FALSE.
  all_times_prefix = "trps_"

  iBccw = 0
  iJccw = 0

  dpath = '.'
  opath = '.'

  call trxplib_clear_mdescr

  call get_arg_count(nargs)

  ntimes=0

  !  here, more are allocated than are needed...
  allocate(timevals(nargs),filenams(nargs))
  timevals=0.0d0
  filenams=" "

  ierr = 0
  iargct = 0

  iarg = 0
  do 
     iarg = iarg+1
     if(iarg.gt.nargs) exit

     call get_arg(iarg,argval)
     ilen = len(trim(argval))

     ! parse arguments

     if(argval(1:1).eq.'-') then
        ztest=argval(2:)
        call opt_parse
        cycle
     endif

     !  not a "-" optional argument 
     iargct = iargct + 1

     if(iargct.eq.1) then
        !  MDS+ or FILE expected...

        ztest=argval
        if(ztest.eq.'MDS+') then
           mds_mode = .TRUE.
        else if(ztest.eq.'FILE') then
           mds_mode = .FALSE.
        else
           write(nonlin,*) ' ?trxpl2ps: invalid lead argument (expected: FILE or MDS+)'
           ierr=ierr+1
           exit
        endif
     endif

     if(iargct.eq.2) then
        !  path to run...
        dpath = argval
        cycle
     endif

     if(iargct.eq.3) then
        !  output path...
        opath = argval
        cycle
     endif

     if(iargct.gt.3) then
        !  looking for <time> <state_file> pairs...
        
        call time_parse    ! increment ntimes, store value, if successful
        if(ierr.ne.0) exit
        
        !  look for matching argument, skipping over -<opt> arguments
        
        save_argval = argval
        found_filename = .FALSE.
        
        do 
           iarg = iarg+1
           if(iarg.gt.nargs) exit
           
           call get_arg(iarg,argval)
           ilen = len(trim(argval))

           !  check here, too, for -opt arguments
           if(argval(1:1).eq.'-') then
              ztest=argval(2:)
              call opt_parse
              cycle
           endif

           !  OK, have filename argument

           filenams(ntimes) = trim(opath)//'/'//trim(argval)
           found_filename = .TRUE.
           exit
        enddo

        if(.NOT.found_filename) then
           write(nonlin,*) ' ?trxpl2ps: no filename argument found to match time: '//trim(save_argval)
           ierr=1
           exit
        endif

     endif

  enddo

  !-------------------------------------------
  !  2. check results of parse; write messages, exit if necessary
  !-------------------------------------------

  if(ierr.eq.0) then
     if(iargct.lt.3) then
        write(nonlin,*) ' ?trxpl2ps: too few arguments... '
        ierr = 1
     endif
     if(iargct.eq.3) then
        write(nonlin,*) ' %trxpl2ps: no output files specified (OK).'
     endif
  endif

  if(ierr.gt.0) then
     write(nonlin,*) ' '
     write(nonlin,*) 'trxpl2ps syntax:'
     write(nonlin,*) '  trxpl2ps  FILE|MDS+  <data-path>  <output-directory> \ '
     write(nonlin,*) '          [-test]  \ (for extra message output) '
     write(nonlin,*) '          [-mhdeq] \ (to include 2d MHD flux surfaces in state file output)'
     write(nonlin,*) '          [-Bccw]   [-Bcw] \ (to specify toroidal B field orientation) '
     write(nonlin,*) '             (if neither is set, use TRANSP data)'
     write(nonlin,*) '          [-Jccw]   [-Jcw] \ (to specify toroidal current orientation) '
     write(nonlin,*) '             (if neither is set, use TRANSP data)'
     write(nonlin,*) '          [-all_times] \ (for all available times in <prefix><timestamp>.cdf'
     write(nonlin,*) '              state files)'
     write(nonlin,*) '          [-prefix:<prefix> \ (prefix for -all_times files; default "trps_")'
     write(nonlin,*) '          [-mdescr:<machine-description-filename>] \ '
     write(nonlin,*) '             (more than one can be given)'
     write(nonlin,*) '          <time1> <state_file1> \ (".cdf" appended to filenames)'
     write(nonlin,*) '          <time2> <state_file2> \ '
     write(nonlin,*) '          <time3> <state_file3> \ '
     write(nonlin,*) '          <time4> <state_file4> \ '
     write(nonlin,*) '            ...     ...'
     write(nonlin,*) '  FILE <data-path> has form <directory>/<runid>, for example:'
     write(nonlin,*) '     FILE /p/transpusers/dmccune/output/TFTR.88/37065Y06'
     write(nonlin,*) '  MDS+ <data-path> syntax depends on server; PPPL example:'
     write(nonlin,*) '     MDS+ "transpgrid.pppl.gov:TRANSP_TFTR(TFTR,37065P36)"'
     write(nonlin,*) '     (hint: enclose path in quotes)'
     write(nonlin,*) '  if -all_times is used, <output>/protimes.dat contains the times'
     write(nonlin,*) '  at which state files are written, along with the file names.'
     call exit(ierr)
  endif

  if(test_flag) then
     write(nonlin,*) ' '
     if(mds_mode) then
        write(nonlin,*) ' data mode: MDS+ '
     else
        write(nonlin,*) ' data mode: FILE '
     endif
     write(nonlin,*) ' data path: '//trim(dpath)
     write(nonlin,*) ' output path: '//trim(opath)

     if(mhdeq_flag) then
        write(nonlin,*) ' -mhdeq option: SET'
     else
        write(nonlin,*) ' -mhdeq option: INACTIVE'
     endif

     if(ntimes.gt.0) then
        write(nonlin,*) ' '
        write(nonlin,*) '   #    time          filename_root'
     endif

     do itime=1,ntimes
        write(nonlin,'(1x,i4,4x,1pe12.5,3x,a)') itime,timevals(itime),filenams(itime)
     enddo
  endif

  !-------------------------------------------
  !  3.  OK: init working state; set options & connect to run
  !--------------------------------------------

  call ps_init_user_state(ss, "trxpl2ps", ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxpl2ps: work state initialization failure.'
     call exit(10)
  endif

  call trxplib_ps_reset
  call trxplib_mhdeq_opt(mhdeq_flag)
  call trxplib_ccw_options(iBccw,iJccw)

  if(mds_mode) then
     mode_str = "MDS+"
  else
     mode_str = "FILE"
  endif

  call trxplib_ps_open(mode_str, dpath, opath, all_times_prefix, ierr)
  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxpl2ps: connect failure.'
     call exit(11)
  endif

  !-------------------------------------------
  !  4.  OK: process requested times of interest
  !      (explicitly requested on command line)
  !-------------------------------------------

  do itime=1,ntimes

     call trxplib_ps_get(timevals(itime), ss, ierr)
     if(ierr.ne.0) exit

     call ps_store_plasma_state(ierr, state=ss, &
          filename=trim(filenams(itime))//'.cdf')
     if(ierr.ne.0) exit

  enddo

  if(ierr.ne.0) then
     write(nonlin,*) ' ?trxpl2ps: error during state extraction time loop. '
     call exit(12)
  endif

  !-------------------------------------------
  !  5.  OK: process requested times of interest
  !      (via -all_times command line option)
  !-------------------------------------------

  if(all_times) then
     call load_times

     do itime=1,ntimes

        call trxplib_ps_get(timevals(itime), ss, ierr)
        if(ierr.ne.0) exit

        call ps_store_plasma_state(ierr, state=ss, &
             filename=trim(filenams(itime))//'.cdf')
        if(ierr.ne.0) exit

     enddo

     if(ierr.ne.0) then
        write(nonlin,*) ' ?trxpl2ps: error during all_times time loop. '
        call exit(13)
     endif
  endif

  !-------------------------------------------
  !  6.  Cleanup and exit
  !-------------------------------------------

  call ps_free_user_state(ss, ierloc)
  if(ierloc.ne.0) then
     write(nonlin,*) ' ?trxpl2ps: error deallocating work state (ignored).'
  endif

  call trxplib_ps_close
  stop

  !---------------------------------------------------
CONTAINS
  !---------------------------------------------------
  !  parse subroutines

  subroutine opt_parse

    integer :: ierloc

    if(ztest.eq.'mhdeq') then
       mhdeq_flag = .TRUE.
    else if(ztest.eq.'test') then
       test_flag = .TRUE.
    else if(ztest.eq.'Bccw') then
       iBccw=1
    else if(ztest.eq.'Bcw') then
       iBccw=-1
    else if(ztest.eq.'Jccw') then
       iJccw=1
    else if(ztest.eq.'Jcw') then
       iJccw=-1
    else if(ztest.eq.'all_times') then
       all_times=.TRUE.
    else if(ztest(1:7).eq.'mdescr:') then
       if(ztest(8:8).eq.' ') then
          write(nonlin,*) ' ?trxpl2ps: -mdescr: missing name.'
          ierr=ierr+1
       else
          call trxplib_add_mdescr(argval(9:),ierloc)
          if(ierloc.ne.0) then
             write(nonlin,*) ' ?trxpl2ps: machine description not found: '// &
                  trim(argval)
             ierr=ierr+1
          endif
       endif
    else if(ztest(1:7).eq.'prefix:') then
       all_times_prefix = ztest(8:)
    else
       ierr=ierr+1
       write(nonlin,*) ' ?trxpl2ps: unrecognized: '//trim(argval)
    endif

  end subroutine opt_parse

  subroutine time_parse

    real*8 :: r8val

    if(ilen.gt.20) then
       ierr=ierr+1
       write(nonlin,*) ' ?trxpl2ps: time-value argument too long: '//trim(argval)
    else
       zvalr8=' '
       zvalr8(20-ilen+1:20) = argval(1:ilen)
       read(zvalr8,'(G20.0)',iostat=istat) r8val
       if(istat.ne.0) then
          ierr=ierr+1
          write(nonlin,*) ' ?trxpl2ps: decode failed on time-value argument: '//trim(argval)
       else
          ntimes = ntimes + 1
          timevals(ntimes) = r8val
       endif
    endif

  end subroutine time_parse

  subroutine load_times

    ! read <output>/protimes.dat

    integer :: ilun,istat,it,idot
    character*50 ptfile,tmpfile

    !-------------------------

    ierr = 0

    ntimes=0
    if(allocated(timevals)) deallocate(timevals)
    if(allocated(filenams)) deallocate(filenams)

    call find_io_unit(ilun)
    ptfile = trim(opath)//'/'//'protimes.dat'
    open(ilun,file=ptfile,status='old',iostat=istat)

    if(istat.ne.0) then
       write(nonlin,*) ' ?trxpl2ps: open failure: '//trim(ptfile)
       ierr = 1
       return
    endif

    ! get #pts

    read(unit=ilun,fmt='(1x,i5)',iostat=istat) ntimes
    if(istat.ne.0) then
       write(nonlin,*) ' ?trxpl2ps: #times read failure: '//trim(ptfile)
       close(unit=ilun)
       ierr = 1
       return
    endif

    allocate(timevals(ntimes))
    allocate(filenams(ntimes))

    do it=1,ntimes
       read(unit=ilun,fmt='(1x,1pe13.6,6x,a)',iostat=istat) &
            timevals(it),tmpfile
       if(istat.ne.0) then
          write(nonlin,*) ' ?trxpl2ps: time point read failure: '//trim(ptfile)
          write(nonlin,*) '  time index counter: ',it
          ierr = 1
          exit
       endif
       ! trim suffix
       idot = index(tmpfile,'.cdf')
       if(idot.gt.0) then
          tmpfile(idot:) = ' '
       endif
       filenams(it) = trim(opath)//'/'//trim(tmpfile)
    enddo

    close(unit=ilun)

  end subroutine load_times

end program trxpl2ps

subroutine trx_chk_saw_r8(ztime,ievent)

  ! check time (call single precision routine)
  ! see trx_chk_saw comments

  implicit NONE

  real*8, intent(inout) :: ztime ! time to (possibly) be adjusted
  integer, intent(in) :: ievent  ! pre/post sawtooth hint

  real :: ztime_r4,ztime_r4_save

  ztime_r4=ztime
  ztime_r4_save=ztime

  call trx_chk_saw(ztime_r4,ievent)

  if(ztime_r4.ne.ztime_r4_save) then
     ztime = ztime_r4  ! time was adjusted
  endif

end subroutine trx_chk_saw_r8

subroutine trx_chk_saw(ztime,ievent)

  ! check time -- prevent a time that falls between a pre-sawtooth record
  ! and a post-sawtooth record

  ! if ievent=1: favor pre-sawtooth record
  ! if ievent=2: favor post-sawtooth record
  ! otherwise take the nearest record

  use trx_module
  implicit NONE

  real, intent(inout) :: ztime  ! data time (possibly to be adjusted)
  integer, intent(in) :: ievent ! event code (see comments)

  !------------------------------------------
  real, parameter :: zrtol = 2.0e-7 
  real, parameter :: zdtmin= 2.0e-6

  real :: zdtol,zt1,zt2
  integer :: it,jt,ikmax,ikmin
  !------------------------------------------

  if(ztime.lt.time_sc(1)) ztime=time_sc(1)
  if(ztime.gt.time_sc(nsctime)) ztime=time_sc(nsctime)

  do it=1,nsctime-1
     if((time_sc(it).le.ztime).and.(ztime.le.time_sc(it+1))) then
        jt=it
        exit
     endif
  enddo

  ikmin=min(kevent(jt),kevent(jt+1))
  ikmax=max(kevent(jt),kevent(jt+1))
  if(ikmax.eq.0) return

  ! time is in, or adjacent to, a sawtooth interval

  if((ievent.lt.1).or.(ievent.gt.2)) then
     ! no hint
     if(ikmin.eq.0) return  ! not actually in the interval

     ! choose closer time at either end of event transition interval
     if((ztime-time_sc(jt)).le.(time_sc(jt+1)-ztime)) then
        ztime=time_sc(jt)
     else
        ztime=time_sc(jt+1)
     endif
     return
  endif

  ! OK event hint is present; find event range

  zdtol=max(zdtmin,zrtol*max(abs(time_sc(jt)),abs(time_sc(jt+1))))

  if(ikmin.gt.0) then
     ! inside interval
     if(ievent.eq.1) then
        ztime=time_sc(jt)
     else
        ztime=time_sc(jt+1)
     endif
     return
  else if(kevent(jt+1).eq.1) then
     if(ievent.eq.1) return
     !  hint: after sawtooth; accepted only if within zdtol of the interval
     zt1=time_sc(jt+1)-zdtol
     if(ztime.le.zt1) then
        return
     else
        ztime=time_sc(jt+2)
        return
     endif
  else
     if(ievent.eq.2) return
     !  hint: before sawtooth; accept only if within zdtol of the interval
     zt2=time_sc(jt)+zdtol
     if(ztime.ge.zt2) then
        return
     else
        ztime=time_sc(jt-1)
     endif
  endif

end subroutine trx_chk_saw

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_store_def_3(ss,icdf,iout,iertot)


  !  define subset of variables and arrays for NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  define variables...


  IF(ALLOCATED(ss%grho2b2i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grho2b2i","R",indim,idims, &
            "<|grad(rho)|^2/B^2>", &
            "T^-2*m^-2","EQ","STATE_PROFILES", &
            "R|units=T^-2*m^-2|pclin grho2b2i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%grho2r2i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grho2r2i","R",indim,idims, &
            "<|grad(rho)|^2/R^2>", &
            "m^-4","EQ","STATE_PROFILES", &
            "R|units=m^-4|pclin grho2r2i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%grho2r3i)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grho2r3i","R",indim,idims, &
            "<|grad(rho)|^2/R^3>", &
            "m^-5","EQ","STATE_PROFILES", &
            "R|units=m^-5|pclin grho2r3i(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%gri)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("gri","R",indim,idims, &
            "<1/R>", &
            "m^-2","EQ","STATE_PROFILES", &
            "R|units=m^-2|pclin gri(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%grirhoi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq_geo",idims(indim))
     CALL define_var("grirhoi","R",indim,idims, &
            "<1/(R*|grad(rho)|)>", &
            "-","EQ","STATE_PROFILES", &
            "R|units=-|pclin grirhoi(nrho_eq_geo)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_drbm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("growthrate_drbm","R",indim,idims, &
            "growthrate from DRBM model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_drbm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_glf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("growthrate_glf","R",indim,idims, &
            "growthrate from GLF23 model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_glf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_max_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("growthrate_max_tglf","R",indim,idims, &
            "maximum growthrate from TGLF model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_max_tglf(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_mmm71)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_mmm",idims(indim))
     CALL define_var("growthrate_mmm71","R",indim,idims, &
            "growthrate from mmm71 model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_mmm71(nrho_anomth,nky_mmm)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_mtm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("growthrate_mtm","R",indim,idims, &
            "growthrate from MTM model", &
            "1/sec","ANOM","STATE_PROFILES", &
            "R|units=1/sec|pclin growthrate_mtm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("growthrate_tglf","R",indim,idims, &
            "growthrate from TGLF model", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%growthrate_vpar)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("growthrate_vpar","R",indim,idims, &
            "growthrate from parallel velocity shear", &
            "GB","ANOM","STATE_PROFILES", &
            "R|units=GB|pclin growthrate_vpar(nrho_anomth,0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%gs_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("gs_name","N",indim,idims, &
            "number & name of edge neutral gas sources", &
            "__NONE","GAS","SHOT_CONFIGURATION", &
            "L|gas_source    gs_name(ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%g_eq)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("g_eq","R",indim,idims, &
            "equilibrium R*|B_phi|", &
            "T*m","EQ","STATE_PROFILES", &
            "R|units=T*m|Spline_00      g_eq(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%hegrilh)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_nspectrumlh_src",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("hegrilh","R",indim,idims, &
            "need description", &
            "-","LH","SHOT_CONFIGURATION", &
            "R|units=- hegrilh(nspectrumlh_src(),nlhrf_src)")
  ENDIF

  IF(ALLOCATED(ss%Hsize_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("Hsize_coil","R",indim,idims, &
            "(Rotatable) Horizontal coil base size", &
            "m","EQ","MACHINE_DESCRIPTION", &
            "R|units=m  Hsize_coil(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%H_einj_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_h_einj_standard",idims(indim))
     CALL define_var("H_einj_standard","R",indim,idims, &
            "H beam table energies", &
            "keV","NBI","MACHINE_DESCRIPTION", &
            "R|units=keV H_einj_standard(n_H_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_h_einj_standard",idims(indim))
     CALL define_var("H_ffull_standard","R",indim,idims, &
            "H beam full energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- H_ffull_standard(n_H_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_n_h_einj_standard",idims(indim))
     CALL define_var("H_fhalf_standard","R",indim,idims, &
            "H beam half energy fractions", &
            "-","NBI","MACHINE_DESCRIPTION", &
            "R|units=- H_fhalf_standard(n_H_einj_standard)")
  ENDIF

  IF(ALLOCATED(ss%icircuit_coil)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ncoils",idims(indim))
     CALL define_var("icircuit_coil","I",indim,idims, &
            "index of circuit to which each coil belongs", &
            "__NONE","EQ","SIMULATION_INIT", &
            "I  icircuit_coil(ncoils)")
  ENDIF

  IF(ALLOCATED(ss%icrf_src_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("icrf_src_name","N",indim,idims, &
            "number & name of ICRF sources", &
            "__NONE","IC","MACHINE_DESCRIPTION", &
            "L|icrf_source   icrf_src_name(nicrf_src)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("IC_Code_Info","C*80",indim,idims, &
         "Information: code implementing IC component", &
         "__NONE","IC","SIMULATION_INIT", &
         "C*80   IC_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("IC_Data_Info","C*80",indim,idims, &
         "information on source of ICRF power data", &
         "__NONE","IC","SIMULATION_INIT", &
         "C*80   IC_Data_Info")

  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_max_num_nphi_vac",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nicrf_src",idims(indim))
     CALL define_var("Imag_ant_coef","R",indim,idims, &
            "imag part of Fourier Coef", &
            "Amps/m","IC","SHOT_CONFIGURATION", &
            "R|units=Amps/m Imag_ant_coef(num_nphi_vac(),nicrf_src)")
  ENDIF

  IF(ALLOCATED(ss%iota)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho",idims(indim))
     CALL define_var("iota","R",indim,idims, &
            "iota profile (1/q)", &
            "-","PLASMA","STATE_PROFILES", &
            "R|units=-|Spline_00  iota(nrho)")
  ENDIF

  IF(ALLOCATED(ss%isThermal)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("isThermal","I",indim,idims, &
            "=1 if minority specie is thermalized", &
            "__NONE","IC","STATE_DATA", &
            "I  isThermal(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%is_recycling)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("is_recycling","I",indim,idims, &
            "0/1; =1 to for recycling sources", &
            "__NONE","GAS","SHOT_CONFIGURATION", &
            "I  is_recycling(ngsc0)")
  ENDIF

  indim = 0
  CALL define_var("i_npoloidal","I",indim,idims, &
         "need description", &
         "__NONE","LH","SHOT_CONFIGURATION", &
         "I i_npoloidal")

  IF(ALLOCATED(ss%jdotb)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("jdotb","R",indim,idims, &
            "<J.B>", &
            "A*T/m^2","EQ","STATE_PROFILES", &
            "R|units=A*T/m^2|Hermite_00     jdotb(nrho_eq)")
  ENDIF

  indim = 0
  CALL define_var("kccw_Bphi","I",indim,idims, &
         "B_phi orientation: +1 means CCW viewed from above", &
         "__NONE","EQ","SHOT_CONFIGURATION", &
         "I  kccw_Bphi = 0")

  indim = 0
  CALL define_var("kccw_Jphi","I",indim,idims, &
         "J_phi orientation: +1 means CCW viewed from above", &
         "__NONE","EQ","SHOT_CONFIGURATION", &
         "I  kccw_Jphi = 0")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
  CALL define_var("kdens_rfmin","N",indim,idims, &
         '= "fraction" => nmini(i) = fracmin(i)*ne', &
         "__NONE","IC","SIMULATION_INIT", &
         'N  kdens_rfmin = "data"')

  IF(ALLOCATED(ss%kvolt_nbi)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("kvolt_nbi","R",indim,idims, &
            "energy of each beam source **keV**", &
            "keV","NBI","STATE_DATA", &
            "R|units=keV kvolt_nbi(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%kyrhos_mtm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     CALL define_var("kyrhos_mtm","R",indim,idims, &
            "ky*rhos at max growth rate for MTM model", &
            "-","ANOM","STATE_PROFILES", &
            "R|units=-|pclin kyrhos_mtm(nrho_anomth)")
  ENDIF

  IF(ALLOCATED(ss%kyspectrum_tglf)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_anomth",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nky_anomth",idims(indim))
     CALL define_var("kyspectrum_tglf","R",indim,idims, &
            "ky-spectrum from TGLF model", &
            "-","ANOM","STATE_PROFILES", &
            "R|units=-|pclin kyspectrum_tglf(nrho_anomth,nky_anomth)")
  ENDIF

  IF(ALLOCATED(ss%Lbscap)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Lbscap","R",indim,idims, &
            "distance, source to aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       Lbscap(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%Lbscap2)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Lbscap2","R",indim,idims, &
            "distance, source to 2nd aperture", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       Lbscap2(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%Lbsctan)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("Lbsctan","R",indim,idims, &
            "distance, source to tangency point", &
            "m","NBI","MACHINE_DESCRIPTION", &
            "R|units=m       Lbsctan(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nlhrf_src",idims(indim))
     CALL define_var("lhrf_src_name","N",indim,idims, &
            "number & name of LHRF sources", &
            "__NONE","LH","MACHINE_DESCRIPTION", &
            "L|lhrf_source   lhrf_src_name(nlhrf_src)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("LH_Code_Info","C*80",indim,idims, &
         "Information: code implementing LH component", &
         "__NONE","LH","SIMULATION_INIT", &
         "C*80   LH_Code_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("LH_Data_Info","C*80",indim,idims, &
         "Information on source of LHRF power data", &
         "__NONE","LH","SIMULATION_INIT", &
         "C*80   LH_Data_Info")

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
  CALL define_var("LMHD_eq_code","N",indim,idims, &
         "name of MHD equilibrium refinement code used", &
         "__NONE","LMHD","SIMULATION_INIT", &
         "N  LMHD_eq_code")

  indim = 0
  CALL define_var("LMHD_status","I",indim,idims, &
         "0: OK; =1: at least one code error occurred.", &
         "__NONE","LMHD","STATE_DATA", &
         "I   LMHD_status")

  indim = 0
  CALL define_var("lock_machine_descr","I",indim,idims, &
         "Machine_Description section lock", &
         "__NONE","PLASMA","STATE_DATA", &
         "I  lock_machine_descr = 0")

  indim = 0
  CALL define_var("lock_shot_config","I",indim,idims, &
         "Shot_Configuration section lock", &
         "__NONE","PLASMA","STATE_DATA", &
         "I  lock_shot_config = 0")

  indim = 0
  CALL define_var("lock_sim_init","I",indim,idims, &
         "Simulation_Init section lock", &
         "__NONE","PLASMA","STATE_DATA", &
         "I  lock_sim_init = 0")

  IF(ALLOCATED(ss%Lpol)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nrho_eq",idims(indim))
     CALL define_var("Lpol","R",indim,idims, &
            "poloidal path length", &
            "m","EQ","STATE_PROFILES", &
            "R|units=m|Spline Lpol(nrho_eq)")
  ENDIF

  IF(ALLOCATED(ss%Mercier_stable)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nballoon",idims(indim))
     CALL define_var("Mercier_stable","I",indim,idims, &
            "0: stable everywhere; =1: unstable somewhere", &
            "__NONE","LMHD","STATE_DATA", &
            "I   Mercier_stable(nballoon)")
  ENDIF

  indim = 0
  CALL define_var("MHD_eq_status","I",indim,idims, &
         "0: OK; =1: MHD equilibrium refinement failed", &
         "__NONE","LMHD","STATE_DATA", &
         "I   MHD_eq_status")

  IF(ALLOCATED(ss%m_ALL)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_all",idims(indim))
     CALL define_var("m_ALL","R",indim,idims, &
            "ALL specie mass", &
            "kg","PLASMA","SIMULATION_INIT", &
            "S|specie  ALL(0:nspec_all)")
  ENDIF

  IF(ALLOCATED(ss%m_ALLA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_alla",idims(indim))
     CALL define_var("m_ALLA","R",indim,idims, &
            "ALLA specie mass", &
            "kg","PLASMA","SIMULATION_INIT", &
            "S|specie  ALLA(0:nspec_alla)")
  ENDIF

  IF(ALLOCATED(ss%m_RFMIN)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_rfmin",idims(indim))
     CALL define_var("m_RFMIN","R",indim,idims, &
            "RFMIN specie mass", &
            "kg","IC","SHOT_CONFIGURATION", &
            "S|RF_minority  RFMIN(nspec_rfmin)")
  ENDIF

  IF(ALLOCATED(ss%m_S)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_th",idims(indim))
     CALL define_var("m_S","R",indim,idims, &
            "S specie mass", &
            "kg","PLASMA","SHOT_CONFIGURATION", &
            "S|thermal_specie  S(0:nspec_th)")
  ENDIF

  IF(ALLOCATED(ss%m_SA)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dp1_nspec_tha",idims(indim))
     CALL define_var("m_SA","R",indim,idims, &
            "SA specie mass", &
            "kg","PLASMA","SIMULATION_INIT", &
            "S|thermal_specie  SA(0:nspec_tha)")
  ENDIF

  IF(ALLOCATED(ss%m_SFUS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_fusion",idims(indim))
     CALL define_var("m_SFUS","R",indim,idims, &
            "SFUS specie mass", &
            "kg","FUS","SHOT_CONFIGURATION", &
            "S|fusion_ion   SFUS(nspec_fusion)")
  ENDIF

  IF(ALLOCATED(ss%m_SGAS)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("m_SGAS","R",indim,idims, &
            "SGAS specie mass", &
            "kg","GAS","SIMULATION_INIT", &
            "S|neutral_gas  SGAS(nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%m_SIMP0)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_imp0",idims(indim))
     CALL define_var("m_SIMP0","R",indim,idims, &
            "SIMP0 specie mass", &
            "kg","GAS","SIMULATION_INIT", &
            "S|impurity_atoms SIMP0(nspec_imp0)")
  ENDIF

  IF(ALLOCATED(ss%m_SIMPI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_impi",idims(indim))
     CALL define_var("m_SIMPI","R",indim,idims, &
            "SIMPI specie mass", &
            "kg","PLASMA","SIMULATION_INIT", &
            "S|impurity_atoms SIMPI(nspec_impi)")
  ENDIF

  IF(ALLOCATED(ss%m_SNBI)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("m_SNBI","R",indim,idims, &
            "SNBI specie mass", &
            "kg","NBI","SIMULATION_INIT", &
            "S|beam_ion     SNBI(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%n0norm)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_ngsc0",idims(indim))
     CALL define_var("n0norm","R",indim,idims, &
            "neutral density per unit gas influx (sc0)", &
            "(m^-3)/(#/sec)","GAS","STATE_PROFILES", &
            "R|step|units=(m^-3)/(#/sec)    n0norm(~nrho_gas,nspec_gas,ngsc0)")
  ENDIF

  IF(ALLOCATED(ss%n0_halo)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("n0_halo","R",indim,idims, &
            "halo thermal neutral density", &
            "m^-3","NBI","STATE_PROFILES", &
            "R|units=m^-3|step         n0_halo(~nrho_nbi,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%n0_reco)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_gas",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_gas",idims(indim))
     CALL define_var("n0_reco","R",indim,idims, &
            "reco thermal neutral density", &
            "m^-3","GAS","STATE_PROFILES", &
            "R|units=m^-3|step         n0_reco(~nrho_gas,nspec_gas)")
  ENDIF

  IF(ALLOCATED(ss%nbap2_shape)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbap2_shape","N",indim,idims, &
            "keyword for optional 2nd aperture", &
            "__NONE","NBI","MACHINE_DESCRIPTION", &
            "N     nbap2_shape(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%nbap_shape)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbap_shape","N",indim,idims, &
            "shape keyword for beam aperture", &
            "__NONE","NBI","MACHINE_DESCRIPTION", &
            "N     nbap_shape(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%nbeami)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dm1_nrho_nbi",idims(indim))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("nbeami","R",indim,idims, &
            "beam species density", &
            "m^-3","NBI","STATE_PROFILES", &
            "R|units=m^-3|alias=n|step  nbeami(~nrho_nbi,nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%nbeami_bdy)) THEN
     indim = 0
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nspec_beam",idims(indim))
     CALL define_var("nbeami_bdy","R",indim,idims, &
            "beam ion densities at/beyond boundary", &
            "m^-3","NBI","STATE_DATA", &
            "R|units=m^-3  nbeami_bdy(nspec_beam)")
  ENDIF

  IF(ALLOCATED(ss%nbion)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbion","N",indim,idims, &
            "name of species injected by each beam.", &
            "__NONE","NBI","SHOT_CONFIGURATION", &
            "N  nbion(nbeam)")
  ENDIF

  IF(ALLOCATED(ss%nbion_trace)) THEN
     indim = 1
     status = nf90_inq_dimid(icdf,"ps_clen_32",idims(1))
     indim = indim + 1
     status = nf90_inq_dimid(icdf,"dim_nbeam",idims(indim))
     CALL define_var("nbion_trace","N",indim,idims, &
            "(if non-blank) beam trace element", &
            "__NONE","NBI","SHOT_CONFIGURATION", &
            "N  nbion_trace(nbeam)")
  ENDIF

  indim = 1
  status = nf90_inq_dimid(icdf,"ps_clen_80",idims(1))
  CALL define_var("NBI_Code_Info","C*80",indim,idims, &
         "Information: code implementing NBI component", &
         "__NONE","NBI","SIMULATION_INIT", &
         "C*80   NBI_Code_Info")

  CONTAINS


     SUBROUTINE define_var(name,dtype,indim,idims, &
          long_name,units,component,section,spec)

        CHARACTER*(*), INTENT(in) :: name
        CHARACTER*(*), INTENT(in) :: dtype
        INTEGER, INTENT(in) :: indim
        INTEGER, dimension(:), INTENT(in) :: idims
        CHARACTER*(*), INTENT(in) :: long_name
        CHARACTER*(*), INTENT(in) :: units
        CHARACTER*(*), INTENT(in) :: component
        CHARACTER*(*), INTENT(in) :: section
        CHARACTER*(*), INTENT(in) :: spec

        integer :: itype

        IF(dtype.EQ.'R') THEN
           itype = NF90_DOUBLE

        ELSE IF (dtype.EQ.'I') THEN
           itype = NF90_INT

        ELSE
           itype = NF90_CHAR

        ENDIF

        IF(indim.EQ.0) THEN
           status=nf90_def_var(icdf,name,itype, varid=varid)

        ELSE
           status=nf90_def_var(icdf,name,itype, dimids=idims(1:indim),varid=varid)

        ENDIF

        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining variable: "//trim(name)
           CALL ncerr(status)
           iertot = iertot + 1
           RETURN
        ENDIF

        ! Variable OK, now add attributes:

        CALL add_attrib("long_name",long_name)
        IF(dtype.EQ.'R') CALL add_attrib("units",units)
        CALL add_attrib("component",component)
        CALL add_attrib("section",section)
        CALL add_attrib("specification",spec)

     END SUBROUTINE define_var

     SUBROUTINE add_attrib(name,value)
        CHARACTER*(*), intent(in) :: name
        CHARACTER*(*), intent(in) :: value

        status=nf90_put_att(icdf,varid,name,value)
        IF(status.NE.NF90_NOERR) THEN
           WRITE(iout,*) " ?plasma_state_store: error defining attribute: "//trim(name)//' = '//trim(value)
           CALL ncerr(status)
           iertot = iertot + 1
        ENDIF
     END SUBROUTINE add_attrib

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_def_3


SUBROUTINE plasma_state_store_3(ss,icdf,iout,iertot)


  !  write subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ival,idims(20),indim
  CHARACTER*80 :: nc_errmsg

  !--------------
  !  write variables...


  IF(ALLOCATED(ss%grho2b2i)) THEN
     status = nf90_inq_varid(icdf,"grho2b2i",varid)
     status = nf90_put_var(icdf,varid,ss%grho2b2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grho2b2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2r2i)) THEN
     status = nf90_inq_varid(icdf,"grho2r2i",varid)
     status = nf90_put_var(icdf,varid,ss%grho2r2i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grho2r2i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grho2r3i)) THEN
     status = nf90_inq_varid(icdf,"grho2r3i",varid)
     status = nf90_put_var(icdf,varid,ss%grho2r3i)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grho2r3i"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gri)) THEN
     status = nf90_inq_varid(icdf,"gri",varid)
     status = nf90_put_var(icdf,varid,ss%gri)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gri"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%grirhoi)) THEN
     status = nf90_inq_varid(icdf,"grirhoi",varid)
     status = nf90_put_var(icdf,varid,ss%grirhoi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: grirhoi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_drbm)) THEN
     status = nf90_inq_varid(icdf,"growthrate_drbm",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_glf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_glf",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_glf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_max_tglf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_max_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_max_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_max_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_mmm71)) THEN
     status = nf90_inq_varid(icdf,"growthrate_mmm71",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_mtm)) THEN
     status = nf90_inq_varid(icdf,"growthrate_mtm",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_tglf)) THEN
     status = nf90_inq_varid(icdf,"growthrate_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%growthrate_vpar)) THEN
     status = nf90_inq_varid(icdf,"growthrate_vpar",varid)
     status = nf90_put_var(icdf,varid,ss%growthrate_vpar)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: growthrate_vpar"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%gs_name)) THEN
     status = nf90_inq_varid(icdf,"gs_name",varid)
     status = nf90_put_var(icdf,varid,ss%gs_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: gs_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%g_eq)) THEN
     status = nf90_inq_varid(icdf,"g_eq",varid)
     status = nf90_put_var(icdf,varid,ss%g_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: g_eq"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%hegrilh)) THEN
     status = nf90_inq_varid(icdf,"hegrilh",varid)
     status = nf90_put_var(icdf,varid,ss%hegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: hegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Hsize_coil)) THEN
     status = nf90_inq_varid(icdf,"Hsize_coil",varid)
     status = nf90_put_var(icdf,varid,ss%Hsize_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Hsize_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"H_einj_standard",varid)
     status = nf90_put_var(icdf,varid,ss%H_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: H_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"H_ffull_standard",varid)
     status = nf90_put_var(icdf,varid,ss%H_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: H_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"H_fhalf_standard",varid)
     status = nf90_put_var(icdf,varid,ss%H_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: H_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%icircuit_coil)) THEN
     status = nf90_inq_varid(icdf,"icircuit_coil",varid)
     status = nf90_put_var(icdf,varid,ss%icircuit_coil)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: icircuit_coil"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%icrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"icrf_src_name",varid)
     status = nf90_put_var(icdf,varid,ss%icrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: icrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%IC_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: IC_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"IC_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%IC_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: IC_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Imag_ant_coef)) THEN
     status = nf90_inq_varid(icdf,"Imag_ant_coef",varid)
     status = nf90_put_var(icdf,varid,ss%Imag_ant_coef)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Imag_ant_coef"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%iota)) THEN
     status = nf90_inq_varid(icdf,"iota",varid)
     status = nf90_put_var(icdf,varid,ss%iota)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: iota"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%isThermal)) THEN
     status = nf90_inq_varid(icdf,"isThermal",varid)
     status = nf90_put_var(icdf,varid,ss%isThermal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: isThermal"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%is_recycling)) THEN
     status = nf90_inq_varid(icdf,"is_recycling",varid)
     status = nf90_put_var(icdf,varid,ss%is_recycling)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: is_recycling"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"i_npoloidal",varid)
  status = nf90_put_var(icdf,varid,ss%i_npoloidal)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: i_npoloidal"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%jdotb)) THEN
     status = nf90_inq_varid(icdf,"jdotb",varid)
     status = nf90_put_var(icdf,varid,ss%jdotb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: jdotb"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Bphi",varid)
  status = nf90_put_var(icdf,varid,ss%kccw_Bphi)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: kccw_Bphi"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"kccw_Jphi",varid)
  status = nf90_put_var(icdf,varid,ss%kccw_Jphi)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: kccw_Jphi"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"kdens_rfmin",varid)
  status = nf90_put_var(icdf,varid,ss%kdens_rfmin)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: kdens_rfmin"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%kvolt_nbi)) THEN
     status = nf90_inq_varid(icdf,"kvolt_nbi",varid)
     status = nf90_put_var(icdf,varid,ss%kvolt_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: kvolt_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%kyrhos_mtm)) THEN
     status = nf90_inq_varid(icdf,"kyrhos_mtm",varid)
     status = nf90_put_var(icdf,varid,ss%kyrhos_mtm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: kyrhos_mtm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%kyspectrum_tglf)) THEN
     status = nf90_inq_varid(icdf,"kyspectrum_tglf",varid)
     status = nf90_put_var(icdf,varid,ss%kyspectrum_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: kyspectrum_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbscap)) THEN
     status = nf90_inq_varid(icdf,"Lbscap",varid)
     status = nf90_put_var(icdf,varid,ss%Lbscap)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Lbscap"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbscap2)) THEN
     status = nf90_inq_varid(icdf,"Lbscap2",varid)
     status = nf90_put_var(icdf,varid,ss%Lbscap2)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Lbscap2"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Lbsctan)) THEN
     status = nf90_inq_varid(icdf,"Lbsctan",varid)
     status = nf90_put_var(icdf,varid,ss%Lbsctan)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Lbsctan"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     status = nf90_inq_varid(icdf,"lhrf_src_name",varid)
     status = nf90_put_var(icdf,varid,ss%lhrf_src_name)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: lhrf_src_name"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%LH_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: LH_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"LH_Data_Info",varid)
  status = nf90_put_var(icdf,varid,ss%LH_Data_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: LH_Data_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_eq_code",varid)
  status = nf90_put_var(icdf,varid,ss%LMHD_eq_code)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: LMHD_eq_code"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"LMHD_status",varid)
  status = nf90_put_var(icdf,varid,ss%LMHD_status)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: LMHD_status"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"lock_machine_descr",varid)
  status = nf90_put_var(icdf,varid,ss%lock_machine_descr)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: lock_machine_descr"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"lock_shot_config",varid)
  status = nf90_put_var(icdf,varid,ss%lock_shot_config)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: lock_shot_config"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  status = nf90_inq_varid(icdf,"lock_sim_init",varid)
  status = nf90_put_var(icdf,varid,ss%lock_sim_init)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: lock_sim_init"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%Lpol)) THEN
     status = nf90_inq_varid(icdf,"Lpol",varid)
     status = nf90_put_var(icdf,varid,ss%Lpol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Lpol"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Mercier_stable)) THEN
     status = nf90_inq_varid(icdf,"Mercier_stable",varid)
     status = nf90_put_var(icdf,varid,ss%Mercier_stable)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: Mercier_stable"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"MHD_eq_status",varid)
  status = nf90_put_var(icdf,varid,ss%MHD_eq_status)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: MHD_eq_status"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  IF(ALLOCATED(ss%m_ALL)) THEN
     status = nf90_inq_varid(icdf,"m_ALL",varid)
     status = nf90_put_var(icdf,varid,ss%m_ALL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_ALL"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_ALLA)) THEN
     status = nf90_inq_varid(icdf,"m_ALLA",varid)
     status = nf90_put_var(icdf,varid,ss%m_ALLA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_ALLA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_RFMIN)) THEN
     status = nf90_inq_varid(icdf,"m_RFMIN",varid)
     status = nf90_put_var(icdf,varid,ss%m_RFMIN)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_RFMIN"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_S)) THEN
     status = nf90_inq_varid(icdf,"m_S",varid)
     status = nf90_put_var(icdf,varid,ss%m_S)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_S"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SA)) THEN
     status = nf90_inq_varid(icdf,"m_SA",varid)
     status = nf90_put_var(icdf,varid,ss%m_SA)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SA"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SFUS)) THEN
     status = nf90_inq_varid(icdf,"m_SFUS",varid)
     status = nf90_put_var(icdf,varid,ss%m_SFUS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SFUS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SGAS)) THEN
     status = nf90_inq_varid(icdf,"m_SGAS",varid)
     status = nf90_put_var(icdf,varid,ss%m_SGAS)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SGAS"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SIMP0)) THEN
     status = nf90_inq_varid(icdf,"m_SIMP0",varid)
     status = nf90_put_var(icdf,varid,ss%m_SIMP0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SIMP0"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SIMPI)) THEN
     status = nf90_inq_varid(icdf,"m_SIMPI",varid)
     status = nf90_put_var(icdf,varid,ss%m_SIMPI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SIMPI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%m_SNBI)) THEN
     status = nf90_inq_varid(icdf,"m_SNBI",varid)
     status = nf90_put_var(icdf,varid,ss%m_SNBI)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: m_SNBI"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0norm)) THEN
     status = nf90_inq_varid(icdf,"n0norm",varid)
     status = nf90_put_var(icdf,varid,ss%n0norm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: n0norm"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0_halo)) THEN
     status = nf90_inq_varid(icdf,"n0_halo",varid)
     status = nf90_put_var(icdf,varid,ss%n0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: n0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%n0_reco)) THEN
     status = nf90_inq_varid(icdf,"n0_reco",varid)
     status = nf90_put_var(icdf,varid,ss%n0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: n0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbap2_shape)) THEN
     status = nf90_inq_varid(icdf,"nbap2_shape",varid)
     status = nf90_put_var(icdf,varid,ss%nbap2_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbap2_shape"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbap_shape)) THEN
     status = nf90_inq_varid(icdf,"nbap_shape",varid)
     status = nf90_put_var(icdf,varid,ss%nbap_shape)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbap_shape"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbeami)) THEN
     status = nf90_inq_varid(icdf,"nbeami",varid)
     status = nf90_put_var(icdf,varid,ss%nbeami)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbeami"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbeami_bdy)) THEN
     status = nf90_inq_varid(icdf,"nbeami_bdy",varid)
     status = nf90_put_var(icdf,varid,ss%nbeami_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbeami_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbion)) THEN
     status = nf90_inq_varid(icdf,"nbion",varid)
     status = nf90_put_var(icdf,varid,ss%nbion)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbion"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%nbion_trace)) THEN
     status = nf90_inq_varid(icdf,"nbion_trace",varid)
     status = nf90_put_var(icdf,varid,ss%nbion_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?plasma_state_store: error storing: nbion_trace"
        CALL ncerr(status)
        iertot = iertot + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"NBI_Code_Info",varid)
  status = nf90_put_var(icdf,varid,ss%NBI_Code_Info)
  IF(status.NE.NF90_NOERR) THEN
     WRITE(iout,*) " ?plasma_state_store: error storing: NBI_Code_Info"
     CALL ncerr(status)
     iertot = iertot + 1
  ENDIF

  CONTAINS


     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_store_3

subroutine tr_getnl_strvals(zname,svalues,maxval,nvalues,ierr)
!
!  find values (as character strings) associated with namelist
!  vector item named by "zname".
!
!  all namelist items are considered to be 1d vectors; scalars are
!  1d vectors of length 1.
!
!  syntax "zname = value"  means assignment to zname(1)
!  syntax "zname = val1,val2" means zname(1)=val1, zname(2)=val2
!  syntax "zname(2) = val1,val2" means zname(2)=val1, zname(3)=val2
!  syntax "zname(3) = 2*val1,val2" means zname(3)=val1, zname(4)=val1, and,
!                                        zname(5)=val2.
!
!  this code is oriented towards parsing of TRANSP namelist (TR.DAT) files.
!  this is *not* a general purpose namelist parser
!
!  the TRANSP namelist TR.DAT files contains comments (starting with "!")
!  the files also contain no more than 1 left-hand-side,
!     and 1 or more assigned values per line
!
  use tr_getnl
  implicit NONE
!
! input:
!
  character*(*) zname       ! name of item wanted
  integer maxval            ! size of value buffer
!
! output:
!
  character*(*) svalues(maxval) ! buffer of values for named item
  integer nvalues           ! largest element of "zname" assigned
!
  integer ierr              ! completion code (0=OK)
!
!   ierr=1 -- namelist not ready (never was read)
!   ierr=2 -- number of values exceeds maxval
!
!   note: nvalues=0 means no values corresponding to "zname" were
!   found.  This is *not* considered an error.
!
!-------------------------------------------------
  integer i,ilen,ic,ier1
!-------------------------------------------------
!
  if((nltext_nlines.eq.0).or.(nltext_status.ne.0)) then
     ierr=1
     return
  else
     ierr=0
  endif
!
! clear values
!
  nvalues=0
  do i=1,maxval
     svalues(i)=' '
  enddo
!
  do i=1,nltext_nlines
     ilen=nltext_lens(i)
     do ic=1,ilen
        if(nltext(i)(ic:ic).eq.'!') exit
        if(nltext(i)(ic:ic).eq.'=') then
           call tr_getnl_1line(i,ic,zname,svalues,maxval,nvalues,ier1)
           ierr=max(ierr,ier1)
        endif
     enddo
  enddo
!
  return
end subroutine tr_getnl_strvals
!--------------------------------------------------------
subroutine tr_getnl_1line(iline,ieqs,zname,svalues,maxval,nvalues,ierr)
!
!  parse one line of the namelist, where ieqs gives location of = sign
!  if LHS matches zname, then determine max index assigned to
!     this could involve parsing the element specification on the LHS
!     and counting the number of values on the RHS
!
  use tr_getnl
  implicit NONE
!
! input:
!
  integer iline             ! line in namelist being scanned
  integer ieqs              ! location of "=" sign.
  character*(*) zname       ! name of item wanted
  integer maxval            ! size of value buffer
!
! output:
!
  character*(*) svalues(maxval) ! buffer of values for named item
  integer nvalues           ! largest element of "zname" assigned
!
  integer ierr              ! completion code (0=OK)
!
!   ierr=1 -- namelist not ready (never was read)
!   ierr=2 -- number of values exceeds maxval
!
!   note: nvalues=0 means no values corresponding to "zname" were
!   found.  This is *not* considered an error.
!
!-------------------------------------------------
  integer ilen,ic,icc,ilparen,irparen
  integer ie1,ie2,ivals,ierck,iblank,icln,irepeat
  integer iv,iv1,iv2
  integer lt,lunzer
!
  character(32) :: ztest1,ztest2
!
!-------------------------------------------------
!
  ierr=0
!
  lt=lunzer(0)
!
  ilen=nltext_lens(iline)
!
  ztest1=zname
  call uupper(ztest1)
!
! get name on LHS (bound by "(" or "=")
!
  ztest2=' '
  icc=0
  ilparen=0
  do ic=1,ieqs-1
     if(nltext(iline)(ic:ic).eq.'(') then
        ilparen=ic
        exit
     endif
     if(nltext(iline)(ic:ic).ne.' ') then
        icc=icc+1
        ztest2(icc:icc)=nltext(iline)(ic:ic)
     endif
  enddo
!
  call uupper(ztest2)
!
! see if name matches...
!
  if(ztest1.ne.ztest2) return        ! not the right item
!
! OK... have a line that assigns to the desired named item
!
  ie1=1
  ie2=0
!
! see if parentheses indicates elements or range of elements in LHS
!
  if(ilparen.gt.0) then
     irparen=0
     do ic=ilparen+1,ieqs-1
        if(nltext(iline)(ic:ic).eq.')') then
           irparen=ic
           exit
        endif
     enddo
     if(irparen.eq.0) then
!
!  oops...
!
        write(lt,*) ' ?tr_getnl_strvalues:  syntax error in line:'
        write(lt,*) ' "',nltext(iline)(1:ilen),'"'
        write(lt,*) ' parentheses left of equal sign.'
        ierr=1
        return
     endif
     if(irparen.lt.(ieqs-1)) then
        if(nltext(iline)(irparen+1:ieqs-1).ne.' ') then
!
!  oops...
!
           write(lt,*) ' ?tr_getnl_strvalues:  syntax error in line:'
           write(lt,*) ' "',nltext(iline)(1:ilen),'"'
           write(lt,*) ' extra chars after closing paren, left of equal sign.'
           ierr=1
           return
        endif
     endif
     iblank=0
     if(irparen.eq.ilparen+1) then
        iblank=1
     else if(nltext(iline)(ilparen+1:irparen-1).eq.' ') then
        iblank=1
     endif
     if(iblank.eq.1) then
!
!  oops...
!
        write(lt,*) ' ?tr_getnl_strvalues:  syntax error in line:'
        write(lt,*) ' "',nltext(iline)(1:ilen),'"'
        write(lt,*) ' nothing between parentheses left of equal sign.'
        ierr=1
        return
     endif
!
!  OK, parse #s btw parens
!
     icln=index(nltext(iline)(ilparen:irparen),':')
     if(icln.eq.0) then
        ztest1=nltext(iline)(ilparen+1:irparen-1)
        read(ztest1,'(I10)',iostat=ierck) ie1
        ierr=max(ierr,ierck)
     else
        ztest1=nltext(iline)(ilparen+1:max((ilparen+1),(icln-1)))
        read(ztest1,'(I10)',iostat=ierck) ie1
        ierr=max(ierr,ierck)
        ztest2=nltext(iline)(icln+1:max((icln+1),(irparen-1)))
        read(ztest2,'(I10)',iostat=ierck) ie2
        ierr=max(ierr,ierck)
        if(ie2.lt.ie1) then
           write(lt,*) ' %2nd index less than first.'
           ierr=1
        endif
        if(ie1.lt.1) then
           write(lt,*) ' %1st index not positive.'
           ierr=1
        endif
        if(ie1.gt.maxval) then
           write(lt,*) ' %1st index exceeds maxval = ',maxval
           ierr=1
        endif
        if(ie2.gt.maxval) then
           write(lt,*) ' %2nd index exceeds maxval = ',maxval
           ierr=1
        endif
     endif
!
     if(ierr.ne.0) then
!
!  oops...
!
        write(lt,*) ' ?tr_getnl_strvalues:  syntax error in line:'
        write(lt,*) ' "',nltext(iline)(1:ilen),'"'
        write(lt,*) ' error reading "',zname,'" element indexing'
        ierr=1
        return
     endif
  endif
!
!  OK...
!    now, ie1=1 & ie2 = 0 if just the name appeared left of = sign
!         ie1=n & ie2 = 0 if "name(n)" appeared left of = sign
!         ie1=n & ie2 = m if "name(n:m)" appeared left of = sign
!
!    now scan values (treated as char strings) right of = sign
!    find the total number of values; if ie2.ne.0 it should match m-n+1.
!    values are delimited by commas
!    values can be repeated by N* syntax
!    blank values not allowed.
!
  ivals=0
  ic=ieqs
  do while(ic.lt.ilen)
     ic=ic+1
     call tr_getnl_nexval(iline,ic,ilen,irepeat,ztest1,ierr)
     if(ierr.ne.0) return       ! blank value
     iv1=ie1+ivals
     iv2=ie1+ivals+irepeat-1
     if(iv2.gt.maxval) then
!
!  oops...
!
        write(lt,*) ' ?tr_getnl_strvalues:  syntax error in line:'
        write(lt,*) ' "',nltext(iline)(1:ilen),'"'
        write(lt,*) ' too many values right of equals sign.'
        write(lt,*) ' maxval = ',maxval
        ierr=1
        return
     endif
     do iv=iv1,iv2
        svalues(iv)=ztest1
     enddo
     nvalues=iv2
     ivals=ivals+irepeat
  enddo
!
  return
end subroutine tr_getnl_1line
!--------------------------------------------------------
subroutine tr_getnl_nexval(iline,ic,ilen,irepeat,zval,ierr)
!
!  find next value for namelist item.  Must be non-blank
!  start scan at char. posn. "ic".
!
  use tr_getnl
  implicit NONE
!
! input:
!
  integer iline            ! index to namelist text line
!
! input/output
!
  integer ic               ! line scanning index
!
! on input:  start of scan
! on output:  loc. of delimitting comma or last non-blank char. +1
!
! input:
!
  integer ilen             ! loc. last non-blank char.
!
! output:
!
  integer irepeat          ! repeat count on value (default: 1)
  character*(*) zval       ! the value (string)
!
  integer ierr             ! completion code, 0=OK
!
! this routine writes an error message and sets ierr if no non-blank
! value is found.
!
!---------------------------------------------
  integer icc,ilval,iq0,imul
  integer lt,lunzer
!
  character*1 zquot
  character*20 zmul
!---------------------------------------------
!
  ierr=0
  irepeat=0
  iq0=0
  zval=' '
  zquot=' '
!
  ilval=len(zval)
!
  icc=0
  ic=ic-1
10 continue
  ic=ic+1
  if(ic.gt.ilen) go to 100
  if(zquot.eq.' ') then
     if(nltext(iline)(ic:ic).eq.',') go to 100
     if(nltext(iline)(ic:ic).eq.'!') then
        ic=ilen+1
        go to 100
     endif
     if(nltext(iline)(ic:ic).eq.'''') zquot=''''
     if(nltext(iline)(ic:ic).eq.'"') zquot='"'
     if(zquot.ne.' ') then
        if(iq0.eq.0) iq0=ic
     endif
  else
     if(nltext(iline)(ic:ic).eq.zquot) zquot=' '
  endif
  if((nltext(iline)(ic:ic).ne.' ').or.(zquot.ne.' ')) then
     icc=icc+1
     if(icc.le.ilval) zval(icc:icc)=nltext(iline)(ic:ic)
  endif
  go to 10
100 continue
  if(icc.eq.0) then
     ierr=1
     lt=lunzer(0)
     write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
     write(lt,*) ' "',nltext(iline)(1:ilen),'"'
     write(lt,*) ' blank where value was expected.'
     return
  endif
  if(zquot.ne.' ') then
     ierr=1
     lt=lunzer(0)
     write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
     write(lt,*) ' "',nltext(iline)(1:ilen),'"'
     write(lt,*) ' unterminated quote string.'
     return
  endif
  if(icc.gt.ilval) then
     ierr=1
     lt=lunzer(0)
     write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
     write(lt,*) ' "',nltext(iline)(1:ilen),'"'
     write(lt,*) ' value field too long.'
     return
  endif
!
! OK -- check for repeat count
!
  if(iq0.eq.0) iq0=icc
  imul=index(zval(1:iq0),'*')
  if(imul.eq.0) then
     irepeat=1
  else if(imul.eq.1) then
     ierr=1
     lt=lunzer(0)
     write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
     write(lt,*) ' "',nltext(iline)(1:ilen),'"'
     write(lt,*) ' missing repeat count.'
     return
  else if(imul.eq.icc) then
     ierr=1
     lt=lunzer(0)
     write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
     write(lt,*) ' "',nltext(iline)(1:ilen),'"'
     write(lt,*) ' blank value after repeat count.'
     return
  else
     zmul=zval(1:imul-1)
     read(zmul,'(I10)',iostat=ierr) irepeat
     if(ierr.ne.0) then
        ierr=1
        lt=lunzer(0)
        write(lt,*) ' ?tr_getnl_strvals:  syntax error in line:'
        write(lt,*) ' "',nltext(iline)(1:ilen),'"'
        write(lt,*) ' repeat count read error.'
        return
     endif
     zval=zval(imul+1:icc)
  endif
  ierr=0
  return
end subroutine tr_getnl_nexval

subroutine ps_2dx_prof_store(iobj, profname, gridname1, gridname2, &
     units, iauthor, label, &
     n1, n2, k_ccw1, k_ccw2, &
     profdata, dprofdx1, dprofdx2, d2profdx1dx2, &
     id, imod, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a 2d profile, return its ID, perform error checking

  ! Here, store a bi-Hermite profile with derivatives provided as input.

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: profname    ! NAME of profile to store
  character*(*), intent(in) :: gridname1,gridname2
                                           ! NAMEs of profile's grids
  character*(*), intent(in) :: units       ! units label
  integer, intent(in) :: iauthor           ! author ID

  character*(*), intent(in) :: label       ! profile label

  integer, intent(in) :: n1,n2             ! profile data dimensions
  integer, intent(in) :: k_ccw1,k_ccw2     ! CCW flags

  REAL(KIND=rspec) :: profdata(n1,n2)      ! profile data to be stored
  REAL(KIND=rspec) :: dprofdx1(n1,n2)      ! profile derivative to be stored
  REAL(KIND=rspec) :: dprofdx2(n1,n2)      ! profile derivative to be stored
  REAL(KIND=rspec) :: d2profdx1dx2(n1,n2)  ! profile derivative to be stored

  integer, intent(out) :: id               ! profile ID (interpolation handle)

  integer, intent(out) :: imod             ! =1 if profile is new or modified
  !  =0 on output if profile was not changed.

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: irank,idg1,idg2,icoord,iertmp,diff_code
  integer :: ispline
  logical :: ccwflag,ccwflag1,ccwflag2
  logical :: rewrite
  integer :: ibc1a,ibc1b,ibc2a,ibc2b
  character*32 zunits
  REAL(KIND=rspec), dimension(:,:,:), allocatable :: coeffs
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  zunits = ' '
  imod = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2dx_prof_store: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname1,idg1)
  if(idg1.eq.0) then
     ierr=300
     write(iout,*) ' ?ps_2dx_prof_store: grid name 1 not recognized: "', &
          trim(gridname1),'".'
     write(iout,*) '  error on call to store profile "',profname,'".'
  endif

  call xplasma_gridId(s,gridname2,idg2)
  if(idg2.eq.0) then
     ierr=300
     write(iout,*) ' ?ps_2dx_prof_store: grid name 2 not recognized: "', &
          trim(gridname2),'".'
     write(iout,*) '  error on call to store profile "',profname,'".'
  endif
  if(ierr.ne.0) return

  ccwflag1 = .TRUE.
  ccwflag2 = .TRUE.

  ccwflag = (k_ccw1.ne.ps_ccw_reverse)

  call xplasma_grid_info(s,idg1,iertmp, coord=icoord)

  if(icoord.eq.xplasma_theta_coord) then
     ccwflag1=ccwflag
  endif

  ccwflag = (k_ccw2.ne.ps_ccw_reverse)

  call xplasma_grid_info(s,idg2,iertmp, coord=icoord)

  if(icoord.eq.xplasma_theta_coord) then
     ccwflag2=ccwflag
  endif

  ispline=1

  !--------------------------------------------------
  !  with derivatives provided: must assume profile data
  !  has changed...
  !--------------------------------------------------
  !  store the modified profile...

  !  set author...

  imod = 1

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2dx_prof_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
     return
  endif

  !  write profile...

  allocate(coeffs(3,n1,n2))
  coeffs(1,:,:) = dprofdx1
  coeffs(2,:,:) = dprofdx2
  coeffs(3,:,:) = d2profdx1dx2

  call xplasma_create_2dprof(s,profname,idg1,idg2,profdata,id,ierr, &
       ispline=ispline, coeffs=coeffs, &
       ccwflag1=ccwflag1,ccwflag2=ccwflag2, &
       label=label,units=zunits)

  deallocate(coeffs)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2dx_prof_store: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=302
  endif

  !  clear author...

  call xplasma_author_clear(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2dx_prof_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
  endif

end subroutine ps_2dx_prof_store

! collection of private auxilliar subroutines for trdatbuf data lookup,
! averaging and interpolation

real*8 function tdbsub_i1(zt1,zt2,zt,int,zf)

  use tdbsub_uts

  ! time integrate piecewise linear interpolant zf(1:int) at times zt(1:int)
  ! over time range zt1 to zt2

  real*8, intent(in) :: zt1,zt2
  real*8, intent(in) :: zt(int)
  real*8, intent(in) :: zf(int)

  !  zt is assumed to be monotonic increasing.  this is NOT checked.
  !  zt1 is assumed .ge. zt2

  integer :: it1,it2
  real*8 :: zfrac1,zfrac2,zfrac,zdt

  tdbsub_i1=0
  if (zt1.ge.zt(int)) return
  if (zt2.le.zt(1)) return
  if (zt2.le.zt1) return

  if(zt1.le.zt(1)) then
     it1=1
     zfrac1=0
  else
     call tdbsub_lookup(zt,int,zt1,it1,zfrac1)
  endif

  if(zt2.ge.zt(int)) then
     it2=int-1
     zfrac2=1
  else
     call tdbsub_lookup(zt,int,zt2,it2,zfrac2)
  endif

  if(it1.eq.it2) then
     zfrac = (zfrac1+zfrac2)*HALF
     tdbsub_i1 = (zf(it1)+zfrac*(zf(it1+1)-zf(it1)))*(zt2-zt1)
  else
     tdbsub_i1 = ZERO
     do it=it1,it2
        if(it.eq.it1) then
           zdt=zt(it1+1)-zt1
           zfrac=(ONE+zfrac1)*HALF
        else if(it.eq.it2) then
           zdt=zt2-zt(it2)
           zfrac=zfrac2*HALF
        else
           zdt=zt(it+1)-zt(it)
           zfrac=HALF
        endif
        tdbsub_i1=tdbsub_i1 + zdt*(zf(it)+zfrac*(zf(it+1)-zf(it)))
     enddo
  endif

end function tdbsub_i1

real*8 function tdbsub_i2(zt1,zt2,zt,int,zf1,zf2)

  use tdbsub_uts

  ! time integrate piecewise linear interpolant zf1(1:int)*zf2(1:int)
  ! at times zt(1:int) over time range zt1 to zt2

  real*8, intent(in) :: zt1,zt2
  real*8, intent(in) :: zt(int)
  real*8, intent(in) :: zf1(int),zf2(int)

  !  zt is assumed to be monotonic increasing.  this is NOT checked.
  !  zt1 is assumed .ge. zt2

  integer :: it1,it2
  real*8 :: zfrac1,zfrac2,zfrac,zdt,zf12

  tdbsub_i2=0
  if (zt1.ge.zt(int)) return
  if (zt2.le.zt(1)) return
  if (zt2.le.zt1) return

  if(zt1.le.zt(1)) then
     it1=1
     zfrac1=0
  else
     call tdbsub_lookup(zt,int,zt1,it1,zfrac1)
  endif

  if(zt2.ge.zt(int)) then
     it2=int-1
     zfrac2=1
  else
     call tdbsub_lookup(zt,int,zt2,it2,zfrac2)
  endif

  if(it1.eq.it2) then
     zfrac = (zfrac1+zfrac2)*HALF
     zf12 = (zf1(it1)*zf2(it1)+ &
          zfrac*(zf1(it1+1)*zf2(it1+1)-zf1(it1)*zf2(it1)))
     tdbsub_i2 = zf12*(zt2-zt1)
  else
     tdbsub_i2 = ZERO
     do it=it1,it2
        if(it.eq.it1) then
           zdt=zt(it1+1)-zt1
           zfrac=(ONE+zfrac1)*HALF
        else if(it.eq.it2) then
           zdt=zt2-zt(it2)
           zfrac=zfrac2*HALF
        else
           zdt=zt(it+1)-zt(it)
           zfrac=HALF
        endif
        zf12 = zf1(it)*zf2(it)+ &
             zfrac*(zf1(it+1)*zf2(it+1)-zf1(it)*zf2(it))
        tdbsub_i2=tdbsub_i2 + zdt*zf12
     enddo
  endif

end function tdbsub_i2

subroutine splitn_rhs(zline,zrhs,jj,indx,inx,ios)

  ! parse RHS of namelist assignment to an array or range of array
  ! elements.

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zline  ! namelist line being analyzed.
  character*(*), intent(in) :: zrhs   ! RHS (no leading/trailing blanks)
  integer, intent(in) :: jj           ! index to namelist item being read
  
  integer, intent(in) :: inx          ! size of indx(...) array
  integer, intent(in) :: indx(inx)    ! indices to first array element to set

  integer, intent(out) :: ios         ! status code, 0=OK, on exit.

  !-------------------------------------------
  ! although namelist arrays can have multiple dimensions (up to 4 as
  ! of Jan. 2003), the storage associated with them in splitn_module is
  ! associated with flat singly dimensioned storage arrays-- a separate
  ! array for each data type.  So, address translation is done:
  !
  !   if a is declared a(i0:i1,j0:j1,k0:k1,m0:m1)
  !           with N1=(i1-i0+1), N2=(j1-j0+1), N3=(k1-k0+1), then,
  !
  !   a(i,j,k,m) is stored at a location offset from a base address 
  !           by this amount:
  !
  !           [[[(m-m0)*N3 + (k-k0)]*N2 + (j-j0)]*N1 + (i-i0)]*N0
  !
  !           with N0=1
  !
  ! arrays of lower dimensionality can still use this formula by 
  ! treating e.g. m0=m1=m=0
  !-------------------------------------------

  integer indims(inx)  ! Nj's
  integer idims(2,inx) ! actual array dimensioning information

  integer iadr_base    ! base address for array object
  integer iadr0        ! address of first element to be set from RHS
  integer iadrmax      ! maximum allowable address settable from RHS
                       ! (determined by size of namelist array object)
  integer iadrvmx      ! maximum address staying within the same array
                       ! row, i.e. without changing any but the first
                       ! of the array element indices.

  integer iadrnlin     ! address (in ilines array) for storing current
                       ! line number (associating data with file line no.)

  integer i,ix,iscan,ilen
  integer iw1,iw2,idelim,ir1,ir2,irepeat,iextra
  integer icura,imaxa,icurl,imaxl,iwarn,iwarn1,iwarn2,ier
  integer :: itmp
  integer :: iadls

  real, dimension(:), allocatable :: rsave
  real*8, dimension(:), allocatable :: dsave
  integer, dimension(:), allocatable :: isave
  logical, dimension(:), allocatable :: lsave
  character*150, dimension(:), allocatable :: chsave
  integer, dimension(:), allocatable :: ichange
  integer ii,iparen,inam2
  !-------------------------------------------

  iwarn=0
  iwarn1=0
  iwarn2=0
  ios=0

  ilen=len(zrhs)
  if(inx.ne.maxrank) then
     ios=-99
     write(6,*) ' ?splitn: internal error, maximum array rank inconsistency.'
     return
  endif

  idims = varlist(jj)%dims

  itmp = varlist(jj)%addr_st
  if(kupdate.eq.0) then
     iadr_base = varlist(jj)%addr
  else
     iadr_base = itmp
     if(varlist(jj)%type.eq.'R') then
        iadr_base = nreal + (kupdate-1)*nreal_st + iadr_base
     else if(varlist(jj)%type.eq.'I') then
        iadr_base = nint + (kupdate-1)*nint_st + iadr_base
     else if(varlist(jj)%type.eq.'L') then
        iadr_base = nlog + (kupdate-1)*nlog_st + iadr_base
     else if(varlist(jj)%type.eq.'D') then
        iadr_base = nr8 + (kupdate-1)*nr8_st + iadr_base
     else if(varlist(jj)%type.eq.'C') then
        iadr_base = nchv + (kupdate-1)*nchv_st + iadr_base
     endif
  endif

  indims(1)=1
  do i=1,inx-1
     indims(i+1)=(idims(2,i)-idims(1,i))+1
  enddo

  ! calculate addresses as offsets first

  iadr0=0
  iadrvmx=0
  iadrmax=0

  do i=inx,1,-1
     iadr0=(iadr0+(indx(i)-idims(1,i)))*indims(i)
     iadrmax=(iadrmax+(idims(2,i)-idims(1,i)))*indims(i)
     if(i.eq.1) then
        ix=idims(2,i)
     else
        ix=indx(i)
     endif
     iadrvmx=(iadrvmx+(ix-idims(1,i)))*indims(i)
  enddo

  ! add in base to get actual addresses

  iadrnlin=iadr0+varlist(jj)%nlinadr   ! file line no. storage address
  if(kupdate.gt.0) then
     iadrnlin = iadr0+varlist(jj)%nlinadr_st
     iadrnlin = nreal+nint+nlog+nr8+nchv + &
          (kupdate-1)*(nreal_st+nint_st+nlog_st+nr8_st+nchv_st) + iadrnlin
  endif

  itmp=iadr0+itmp
  iadr0=iadr0+iadr_base
  iadrmax=iadrmax+iadr_base
  iadrvmx=iadrvmx+iadr_base

  allocate(ichange(iadr0:iadrmax))

  !---------------
  ! OK now scan the RHS

  ichange=0   ! note any real changes in value...

  icura=iadr0

  iscan=0
  do

     call splitn_nxgrp(zrhs,iscan,iw1,iw2,idelim,ir1,ir2,irepeat,iextra)
     if(iextra.gt.0) then
        write(6,*) ' ?splitn_rhs: extraneous characters after quote string.'
        return
     endif

     imaxa=icura+irepeat-1
     if(imaxa.gt.iadrmax) then
        write(6,*) ' ?splitn_rhs: namelist assignment exceeds array size.'
        write(6,*) zline
        ios=1
        return
     else if(imaxa.gt.iadrvmx) then
        if(iwarn.eq.0) then
           iwarn=iwarn+1
           write(6,*) ' ------------- '
           write(6,*) &
                ' %splitn_rhs: warning: namelist assign spans multiple', &
                ' rows of array.'
           write(6,*) zline
        endif
     endif

     ! addresses appear to be OK

     if(iw2.ge.iw1) then
        ! non null value; decode according to type
        if(varlist(jj)%type.eq.'R') then
           allocate(rsave(icura:imaxa))
           rsave=rbuf(icura:imaxa)
           call splitn_rdcod(zrhs(iw1:iw2),rbuf(icura:imaxa),irepeat,ier)
           do ii=icura,imaxa
              if(rbuf(ii).ne.rsave(ii)) ichange(ii)=1
           enddo
           deallocate(rsave)
           if(varlist(jj)%steerable.eq.2) then
              iadls = varlist(jj)%nlinadr_st
              call rset_ucop(rbuf,icura,irepeat,itmp,iadls,kupdate,nupdate_max)
           endif
        else if(varlist(jj)%type.eq.'I') then
           allocate(isave(icura:imaxa))
           isave=intbuf(icura:imaxa)
           call splitn_idcod(zrhs(iw1:iw2),intbuf(icura:imaxa),irepeat,ier)
           do ii=icura,imaxa
              if(intbuf(ii).ne.isave(ii)) ichange(ii)=1
           enddo
           deallocate(isave)
           if(varlist(jj)%steerable.eq.2) then
              iadls = varlist(jj)%nlinadr_st
              call iset_ucop(intbuf,icura,irepeat,itmp,iadls,kupdate,nupdate_max)
           endif
        else if(varlist(jj)%type.eq.'L') then
           allocate(lsave(icura:imaxa))
           lsave=logbuf(icura:imaxa)
           call splitn_ldcod(zrhs(iw1:iw2),logbuf(icura:imaxa),irepeat,ier)
           do ii=icura,imaxa
              if(lsave(ii)) then
                 if(.not.logbuf(ii)) ichange(ii)=1
              else
                 if(logbuf(ii)) ichange(ii)=1
              endif
           enddo
           deallocate(lsave)
           if(varlist(jj)%steerable.eq.2) then
              iadls = varlist(jj)%nlinadr_st
              call lset_ucop(logbuf,icura,irepeat,itmp,iadls,kupdate,nupdate_max)
           endif
        else if(varlist(jj)%type.eq.'D') then
           allocate(dsave(icura:imaxa))
           dsave=dbuf(icura:imaxa)
           call splitn_ddcod(zrhs(iw1:iw2),dbuf(icura:imaxa),irepeat,ier)
           do ii=icura,imaxa
              if(dbuf(ii).ne.dsave(ii)) ichange(ii)=1
           enddo
           deallocate(dsave)
           if(varlist(jj)%steerable.eq.2) then
              iadls = varlist(jj)%nlinadr_st
              call dset_ucop(dbuf,icura,irepeat,itmp,iadls,kupdate,nupdate_max)
           endif
        else if(varlist(jj)%type(1:1).eq.'C') then
           allocate(chsave(icura:imaxa))
           chsave=chbuf(icura:imaxa)
           call splitn_cdcod(zrhs(iw1:iw2), &
                varlist(jj)%chsize,chbuf(icura:imaxa),irepeat,ier)
           do ii=icura,imaxa
              if(chbuf(ii).ne.chsave(ii)) ichange(ii)=1
           enddo
           deallocate(chsave)
           if(varlist(jj)%steerable.eq.2) then
              iadls = varlist(jj)%nlinadr_st
              call chset_ucop(chbuf,icura,irepeat,itmp,iadls,kupdate,nupdate_max)
           endif
        endif
        if(ier.ne.0) then
           write(6,*) ' ?splitn_rhs: error parsing namelist array values:'
           write(6,*) zline
           ios=1
           return
        endif
     else
        write(6,*) ' ?splitn_rhs: null value field.'
        write(6,*) '  line starts: ',trim(zline)
        ier=1
        ios=1
        return
     endif
     iscan = idelim

     ! data values have been assigned.  Now put in links back to the file
     ! line-- set sign bit in case of null value assignment.

     ios=0
     icurl=iadrnlin+(icura-iadr0)
     imaxl=iadrnlin+(imaxa-iadr0)
     do i=icurl,imaxl
        ii=i-iadrnlin+iadr0
        if(ilines(i).ne.0) then
           if(ichange(ii).eq.1) then  ! detect multiply assigned elements
              iwarn2=iwarn2+1         ! WITH change in value
           else
              iwarn1=iwarn1+1         ! NO change in value
           endif
        endif

        iline_nstack = iline_nstack + 1
        iline_stack(1,iline_nstack) = i
        iline_stack(2,iline_nstack) = newline

        !xxxx   ilines(i)=newline  -- deferred, see add_nl_line in module

        ivrange(:,i)=0
        irrange(:,i)=0
        krepeat(i)=0

        if(iw2.ge.iw1) then           ! last assignment wins
           ivrange(1,i)=iw1+val1-1
           ivrange(2,i)=iw2+val1-1
        endif
        if(ir1.gt.0) then
           krepeat(i)=irepeat
           irrange(1,i)=ir1+val1-1
           irrange(2,i)=ir2+val1-1
        endif
     enddo

     if(idelim.ge.ilen) exit
     icura=icura+irepeat
     itmp =itmp +irepeat

  enddo

  if(max(iwarn1,iwarn2).gt.0) then
     iparen=index(zline,'(')
     if(iparen.le.nam1) iparen=nam2+1
     if(iparen.lt.nam2) then
        inam2=iparen-1
     else
        inam2=nam2
     endif
  endif

  if(iwarn1.gt.0) call splitn_addwarn(zline(nam1:inam2),dblasg1,ndblasg1, &
       len(dblasg1(1)),kdblasg1,maxwarn)
  if(iwarn2.gt.0) call splitn_addwarn(zline(nam1:inam2),dblasg2,ndblasg2, &
       len(dblasg2(1)),kdblasg2,maxwarn)

  deallocate(ichange)

end subroutine splitn_rhs

module plasma_state_xpobj

  !------------------------------------------------------
  ! D. McCune  ... revised Jan 2008
  !   define "interp_object" to implement interpolation
  !   capability for plasma state, using xplasma.
  !------------------------------------------------------

  use xplasma_definitions

  implicit NONE
  public

  type :: interp_object

     type (xplasma), pointer :: s_xpobj => NULL()

  end type interp_object

  character*32, parameter :: xpobj_hash_name = 'ps_xplasma_hash'
  integer, parameter :: r8hash_size = 1

  contains

    subroutine xpobj_blkbx(xobj, &
         name,isize,r8size,inew,id,ia_ptr,r8a_ptr,iout,ierr)

      ! fetch or create blackbox of indicated sizes 
      ! s pointer assumed to already be set

      type(interp_object) :: xobj

      character*(*), intent(in) :: name   ! name of black box (bb)
      integer, intent(in) :: isize,r8size ! integer and real*8 sizes of bb
      logical, intent(out) :: inew        ! .TRUE. if bb is new in xplasma
      integer, intent(out) :: id          ! ID of xplasma object
      integer, dimension(:), pointer :: ia_ptr   ! integer data pointer
      real*8, dimension(:), pointer :: r8a_ptr   ! real*8 data pointer
      integer, intent(in) :: iout         ! LUN for messages
      integer, intent(out) :: ierr        ! completion code; 0=OK

      !----------------------------
      integer :: isize_loc,r8size_loc
      integer, parameter :: loctype = 12345

      type (xplasma), pointer :: s
      !----------------------------

      ierr=0
      
      ! set "s" pointer
      if(.not.associated(xobj%s_xpobj)) then
         write(iout,*) ' ?xpobj_blkbx: xobj has not been initialized.'
         ierr=999
         return
      endif

      s => xobj%s_xpobj

      inew=.FALSE.
      nullify(ia_ptr)
      nullify(r8a_ptr)

      call xplasma_blkbxId(s,name,id)
      if(id.gt.0) then
         call xplasma_blackbox_info(s,id,ierr, &
              r8size=r8size_loc, isize=isize_loc)

         if(ierr.ne.0) then
            write(iout,*) ' ?xpobj_blkbx: xplasma_blackbox_info error:'
            call xplasma_error(s,iout,ierr)
            return
         endif

         if((r8size.eq.r8size_loc).and.(isize.eq.isize_loc)) then
            call xplasma_blackBox_retrieve(s,id,ierr, &
                 ia_ptr=ia_ptr, r8a_ptr=r8a_ptr)
            if(ierr.ne.0) then
               write(iout,*) ' ?xpobj_blkbx: xplasma_blackbox_info error:'
               call xplasma_error(s,iout,ierr)
            endif
         else
            inew = .TRUE.  ! sizes differ
         endif

      else
         inew = .TRUE.  ! did not exist
      endif

      if(inew) then
         call xplasma_author_set(s,'plasma_state_xpobj',ierr)
         if(ierr.ne.0) then
            write(iout,*) ' ?xpobj_blkbx: xplasma_author_set error:'
            call xplasma_error(s,iout,ierr)
            return
         endif

         call xplasma_create_blackBox(s,name,loctype,id,ierr, &
              iasize=isize, r8asize=r8size, ia_ptr=ia_ptr, r8a_ptr=r8a_ptr)
         if(ierr.ne.0) then
            write(iout,*) ' ?xpobj_blkbx: xplasma_create_blackbox error:'
            call xplasma_error(s,iout,ierr)
            return
         endif

         call xplasma_author_clear(s,'plasma_state_xpobj',ierr)
         if(ierr.ne.0) then
            write(iout,*) ' ?xpobj_blkbx: xplasma_author_clear error:'
            call xplasma_error(s,iout,ierr)
            return
         endif
      endif

    end subroutine xpobj_blkbx

end module plasma_state_xpobj

      subroutine trxpl_species(nspec,iorder,ztype,ids)
 
      !  get species list and acquire profiles; add to lists
 
      implicit NONE
 
      integer, intent(in) :: nspec      ! no. of species (prior trx_nspec call)
      integer, intent(in) :: iorder     ! fit order (e.g. 1 for Hermite)
      character*(*), intent(in) :: ztype  ! type of data: "N", "T", ...
 
      integer, intent(out) :: ids(nspec) ! xplasma ids
 
      include 'trxpl.blk'
 
      !-------------------------------------
      integer :: igot   ! no. of species found (will match nspec)
      integer :: i,j,ierr,idum1,idum2,idup,ixid
      character*20 zlbl
      character*10 zuns
      !-------------------------------------
 
c  Acquire the ids for species densities
 
      ids=0
 
      call trx_spec_prof(nspec,igot,iorder,ztype,ids(1:nspec),
     >   ierr)
 
      if(ierr.ne.0) then
         write(6,*) ' ?trxpl_species:  error getting "'//ztype//
     >      '" profile ids'
      endif
 
      do i=1,nspec
         if(ids(i).gt.0) then
            call trx_uget(ids(i),ixid,zlbl,zuns,idum1,idum2)
            idup=0
            do j=1,numpro
               if(prolabs(1,j)//prolabs(2,j).eq.zlbl) idup=j
            enddo
            if(idup.eq.0) then
               numpro=numpro+1
               prolabs(1,numpro)=zlbl(1:10)
               prolabs(2,numpro)=zlbl(11:20)
               prolabs(3,numpro)=zuns
               id_pros(numpro)=ids(i)
               id_xaxis(numpro)=ixid
            endif
         endif
      enddo
 
      return
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


subroutine ps_mdescr_namelist_read(init,filename,tmp_filename,g_filename,ss, &
                                   ierr)

  ! read machine description namelist, copy into state
  ! if state is not empty, namelist input must not change existing
  ! non-zero array dimensions.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  LOGICAL, INTENT(IN) :: init                  ! .TRUE. to pre-initialize
  ! state variables prior to namelist read (caution -- could cause problems
  ! if partial machine description is already in the state).

  CHARACTER*(*), INTENT(IN) :: filename        ! file to contain namelist
  CHARACTER*(*), INTENT(IN) :: tmp_filename    ! namelist (comments removed)
  !  (leave tmp_filename blank to get internally generated filename)
  CHARACTER*(*), INTENT(IN) :: g_filename      ! if non-blank: G-EQDSK filename

  ! if G-eqdsk filename is provided, limiter and bounding box in G-EQDSK
  ! file will override that given in the machine description namelist.;

  TYPE (plasma_state) :: ss     ! state containing data to read
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-------------------------------
  INTEGER :: iout,iertmp,isize,isiz0,ii
  INTEGER :: ilun_namel
  !-------------------------------
  CHARACTER*32 :: tokamak_id
  CHARACTER*256 :: geometry
  INTEGER :: num_rzlim
  REAL(KIND=rspec), dimension(ps_max_static) :: rlim
  REAL(KIND=rspec), dimension(ps_max_static) :: zlim
  REAL(KIND=rspec) :: R_min_box
  REAL(KIND=rspec) :: R_max_box
  REAL(KIND=rspec) :: Z_min_box
  REAL(KIND=rspec) :: Z_max_box
  CHARACTER*32, dimension(ps_max_static) :: circuit_name
  CHARACTER*32, dimension(ps_max_static) :: coil_name
  CHARACTER*32, dimension(ps_max_static) :: coil_in_circuit
  REAL(KIND=rspec), dimension(ps_max_static) :: Rloc_coil
  REAL(KIND=rspec), dimension(ps_max_static) :: Zloc_coil
  REAL(KIND=rspec), dimension(ps_max_static) :: Hsize_coil
  REAL(KIND=rspec), dimension(ps_max_static) :: Ang_Href_coil
  REAL(KIND=rspec), dimension(ps_max_static) :: Vsize_coil
  REAL(KIND=rspec), dimension(ps_max_static) :: Ang_Vref_coil
  INTEGER, dimension(ps_max_static) :: Nturns
  INTEGER, dimension(ps_max_static) :: VRep_coil_count
  REAL(KIND=rspec), dimension(ps_max_static) :: Vrep_coil_spacing
  REAL(KIND=rspec), dimension(ps_max_static) :: coil_resispt
  CHARACTER*32, dimension(ps_max_static) :: nbi_src_name
  CHARACTER*32, dimension(ps_max_static) :: beam_type
  REAL(KIND=rspec), dimension(ps_max_static) :: sRtcen
  REAL(KIND=rspec), dimension(ps_max_static) :: Lbsctan
  REAL(KIND=rspec), dimension(ps_max_static) :: Zbsc
  REAL(KIND=rspec), dimension(ps_max_static) :: Phibsc
  REAL(KIND=rspec), dimension(ps_max_static) :: Lbscap
  REAL(KIND=rspec), dimension(ps_max_static) :: Zbap
  CHARACTER*32, dimension(ps_max_static) :: nbshape
  REAL(KIND=rspec), dimension(ps_max_static) :: b_halfwidth
  REAL(KIND=rspec), dimension(ps_max_static) :: b_halfHeight
  REAL(KIND=rspec), dimension(ps_max_static) :: b_Hfocal_length
  REAL(KIND=rspec), dimension(ps_max_static) :: b_Vfocal_length
  REAL(KIND=rspec), dimension(ps_max_static) :: b_Hdivergence
  REAL(KIND=rspec), dimension(ps_max_static) :: b_Vdivergence
  CHARACTER*32, dimension(ps_max_static) :: nbap_shape
  REAL(KIND=rspec), dimension(ps_max_static) :: ap_halfwidth
  REAL(KIND=rspec), dimension(ps_max_static) :: ap_halfheight
  REAL(KIND=rspec), dimension(ps_max_static) :: ap_horiz_offset
  REAL(KIND=rspec), dimension(ps_max_static) :: ap_vert_offset
  CHARACTER*32, dimension(ps_max_static) :: nbap2_shape
  REAL(KIND=rspec), dimension(ps_max_static) :: Lbscap2
  REAL(KIND=rspec), dimension(ps_max_static) :: ap2_halfwidth
  REAL(KIND=rspec), dimension(ps_max_static) :: ap2_halfheight
  REAL(KIND=rspec), dimension(ps_max_static) :: ap2_horiz_offset
  REAL(KIND=rspec), dimension(ps_max_static) :: ap2_vert_offset
  REAL(KIND=rspec), dimension(ps_max_static) :: Einj_min
  REAL(KIND=rspec), dimension(ps_max_static) :: Einj_max
  INTEGER :: n_H_einj_standard
  INTEGER :: n_D_einj_standard
  INTEGER :: n_T_einj_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: H_einj_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: H_ffull_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: H_fhalf_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: D_einj_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: D_ffull_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: D_fhalf_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: T_einj_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: T_ffull_standard
  REAL(KIND=rspec), dimension(ps_max_static) :: T_fhalf_standard
  CHARACTER*32, dimension(ps_max_static_2d) :: icrf_src_name
  CHARACTER*256, dimension(ps_max_static_2d) :: ant_model
  INTEGER, dimension(ps_max_static_2d) :: nrz_antgeo
  INTEGER :: max_nrz_antgeo
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: R_antgeo
  REAL(KIND=rspec), dimension(ps_max_static_2d,ps_max_static_2d) :: Z_antgeo
  REAL(KIND=rspec), dimension(ps_max_static_2d) :: dx_fshield
  CHARACTER*32, dimension(ps_max_static) :: ecrf_src_name
  REAL(KIND=rspec), dimension(ps_max_static) :: R_EC_launch
  REAL(KIND=rspec), dimension(ps_max_static) :: Z_EC_launch
  REAL(KIND=rspec), dimension(ps_max_static) :: Phi_EC_launch
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_PRINC_WIDTH_HOR
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_PRINC_WIDTH_VERT
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_PRINC_CURV_HOR
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_PRINC_CURV_VERT
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_Half_Power_Angle
  REAL(KIND=rspec), dimension(ps_max_static) :: EC_Beam_Elongation
  CHARACTER*32, dimension(ps_max_static) :: lhrf_src_name
  INTEGER :: ntf_coils
  INTEGER :: ntf_coil2

  NAMELIST /mdescr/ &
       tokamak_id, &
       geometry, &
       num_rzlim, &
       rlim, &
       zlim, &
       R_min_box, &
       R_max_box, &
       Z_min_box, &
       Z_max_box, &
       circuit_name, &
       coil_name, &
       coil_in_circuit, &
       Rloc_coil, &
       Zloc_coil, &
       Hsize_coil, &
       Ang_Href_coil, &
       Vsize_coil, &
       Ang_Vref_coil, &
       Nturns, &
       VRep_coil_count, &
       Vrep_coil_spacing, &
       coil_resispt, &
       nbi_src_name, &
       beam_type, &
       sRtcen, &
       Lbsctan, &
       Zbsc, &
       Phibsc, &
       Lbscap, &
       Zbap, &
       nbshape, &
       b_halfwidth, &
       b_halfHeight, &
       b_Hfocal_length, &
       b_Vfocal_length, &
       b_Hdivergence, &
       b_Vdivergence, &
       nbap_shape, &
       ap_halfwidth, &
       ap_halfheight, &
       ap_horiz_offset, &
       ap_vert_offset, &
       nbap2_shape, &
       Lbscap2, &
       ap2_halfwidth, &
       ap2_halfheight, &
       ap2_horiz_offset, &
       ap2_vert_offset, &
       Einj_min, &
       Einj_max, &
       n_H_einj_standard, &
       n_D_einj_standard, &
       n_T_einj_standard, &
       H_einj_standard, &
       H_ffull_standard, &
       H_fhalf_standard, &
       D_einj_standard, &
       D_ffull_standard, &
       D_fhalf_standard, &
       T_einj_standard, &
       T_ffull_standard, &
       T_fhalf_standard, &
       icrf_src_name, &
       ant_model, &
       nrz_antgeo, &
       max_nrz_antgeo, &
       R_antgeo, &
       Z_antgeo, &
       dx_fshield, &
       ecrf_src_name, &
       R_EC_launch, &
       Z_EC_launch, &
       Phi_EC_launch, &
       EC_PRINC_WIDTH_HOR, &
       EC_PRINC_WIDTH_VERT, &
       EC_PRINC_CURV_HOR, &
       EC_PRINC_CURV_VERT, &
       EC_Half_Power_Angle, &
       EC_Beam_Elongation, &
       lhrf_src_name, &
       ntf_coils, &
       ntf_coil2
  !---------------------------------------

  iout = SWIM_err_out_file

  ierr = 0

  ! initialize local namelist variables to state values
  IF(init) ss%tokamak_id = " "
  tokamak_id = ss%tokamak_id
  IF(init) ss%geometry = " "
  geometry = ss%geometry
  IF(init) ss%num_rzlim = 0
  num_rzlim = ss%num_rzlim
  rlim = 0.0_rspec
  IF(ALLOCATED(ss%rlim)) THEN
     isize = size(rlim)
     IF(init) THEN
        ss%rlim(1:isize) = rlim(1:isize)
     ELSE
        rlim(1:isize) = ss%rlim(1:isize)
     ENDIF
  ENDIF
  zlim = 0.0_rspec
  IF(ALLOCATED(ss%zlim)) THEN
     isize = size(zlim)
     IF(init) THEN
        ss%zlim(1:isize) = zlim(1:isize)
     ELSE
        zlim(1:isize) = ss%zlim(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%R_min_box = 0.0_rspec
  R_min_box = ss%R_min_box
  IF(init) ss%R_max_box = 0.0_rspec
  R_max_box = ss%R_max_box
  IF(init) ss%Z_min_box = 0.0_rspec
  Z_min_box = ss%Z_min_box
  IF(init) ss%Z_max_box = 0.0_rspec
  Z_max_box = ss%Z_max_box
  circuit_name = " "
  IF(ALLOCATED(ss%circuit_name)) THEN
     isize = size(circuit_name)
     IF(init) THEN
        ss%circuit_name(1:isize) = circuit_name(1:isize)
     ELSE
        circuit_name(1:isize) = ss%circuit_name(1:isize)
     ENDIF
  ENDIF
  coil_name = " "
  IF(ALLOCATED(ss%coil_name)) THEN
     isize = size(coil_name)
     IF(init) THEN
        ss%coil_name(1:isize) = coil_name(1:isize)
     ELSE
        coil_name(1:isize) = ss%coil_name(1:isize)
     ENDIF
  ENDIF
  coil_in_circuit = " "
  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     isize = size(coil_in_circuit)
     IF(init) THEN
        ss%coil_in_circuit(1:isize) = coil_in_circuit(1:isize)
     ELSE
        coil_in_circuit(1:isize) = ss%coil_in_circuit(1:isize)
     ENDIF
  ENDIF
  Rloc_coil = 0.0_rspec
  IF(ALLOCATED(ss%Rloc_coil)) THEN
     isize = size(Rloc_coil)
     IF(init) THEN
        ss%Rloc_coil(1:isize) = Rloc_coil(1:isize)
     ELSE
        Rloc_coil(1:isize) = ss%Rloc_coil(1:isize)
     ENDIF
  ENDIF
  Zloc_coil = 0.0_rspec
  IF(ALLOCATED(ss%Zloc_coil)) THEN
     isize = size(Zloc_coil)
     IF(init) THEN
        ss%Zloc_coil(1:isize) = Zloc_coil(1:isize)
     ELSE
        Zloc_coil(1:isize) = ss%Zloc_coil(1:isize)
     ENDIF
  ENDIF
  Hsize_coil = 0.0_rspec
  IF(ALLOCATED(ss%Hsize_coil)) THEN
     isize = size(Hsize_coil)
     IF(init) THEN
        ss%Hsize_coil(1:isize) = Hsize_coil(1:isize)
     ELSE
        Hsize_coil(1:isize) = ss%Hsize_coil(1:isize)
     ENDIF
  ENDIF
  Ang_Href_coil = 0.0_rspec
  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     isize = size(Ang_Href_coil)
     IF(init) THEN
        ss%Ang_Href_coil(1:isize) = Ang_Href_coil(1:isize)
     ELSE
        Ang_Href_coil(1:isize) = ss%Ang_Href_coil(1:isize)
     ENDIF
  ENDIF
  Vsize_coil = 0.0_rspec
  IF(ALLOCATED(ss%Vsize_coil)) THEN
     isize = size(Vsize_coil)
     IF(init) THEN
        ss%Vsize_coil(1:isize) = Vsize_coil(1:isize)
     ELSE
        Vsize_coil(1:isize) = ss%Vsize_coil(1:isize)
     ENDIF
  ENDIF
  Ang_Vref_coil = 0.0_rspec
  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     isize = size(Ang_Vref_coil)
     IF(init) THEN
        ss%Ang_Vref_coil(1:isize) = Ang_Vref_coil(1:isize)
     ELSE
        Ang_Vref_coil(1:isize) = ss%Ang_Vref_coil(1:isize)
     ENDIF
  ENDIF
  Nturns = ps_unInit
  IF(ALLOCATED(ss%Nturns)) THEN
     isize = size(Nturns)
     IF(init) THEN
        ss%Nturns(1:isize) = Nturns(1:isize)
     ELSE
        Nturns(1:isize) = ss%Nturns(1:isize)
     ENDIF
  ENDIF
  VRep_coil_count = ps_unInit
  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     isize = size(VRep_coil_count)
     IF(init) THEN
        ss%VRep_coil_count(1:isize) = VRep_coil_count(1:isize)
     ELSE
        VRep_coil_count(1:isize) = ss%VRep_coil_count(1:isize)
     ENDIF
  ENDIF
  Vrep_coil_spacing = 0.0_rspec
  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     isize = size(Vrep_coil_spacing)
     IF(init) THEN
        ss%Vrep_coil_spacing(1:isize) = Vrep_coil_spacing(1:isize)
     ELSE
        Vrep_coil_spacing(1:isize) = ss%Vrep_coil_spacing(1:isize)
     ENDIF
  ENDIF
  coil_resispt = 0.0_rspec
  IF(ALLOCATED(ss%coil_resispt)) THEN
     isize = size(coil_resispt)
     IF(init) THEN
        ss%coil_resispt(1:isize) = coil_resispt(1:isize)
     ELSE
        coil_resispt(1:isize) = ss%coil_resispt(1:isize)
     ENDIF
  ENDIF
  nbi_src_name = " "
  IF(ALLOCATED(ss%nbi_src_name)) THEN
     isize = size(nbi_src_name)
     IF(init) THEN
        ss%nbi_src_name(1:isize) = nbi_src_name(1:isize)
     ELSE
        nbi_src_name(1:isize) = ss%nbi_src_name(1:isize)
     ENDIF
  ENDIF
  beam_type = " "
  IF(ALLOCATED(ss%beam_type)) THEN
     isize = size(beam_type)
     IF(init) THEN
        ss%beam_type(1:isize) = beam_type(1:isize)
     ELSE
        beam_type(1:isize) = ss%beam_type(1:isize)
     ENDIF
  ENDIF
  sRtcen = 0.0_rspec
  IF(ALLOCATED(ss%sRtcen)) THEN
     isize = size(sRtcen)
     IF(init) THEN
        ss%sRtcen(1:isize) = sRtcen(1:isize)
     ELSE
        sRtcen(1:isize) = ss%sRtcen(1:isize)
     ENDIF
  ENDIF
  Lbsctan = 0.0_rspec
  IF(ALLOCATED(ss%Lbsctan)) THEN
     isize = size(Lbsctan)
     IF(init) THEN
        ss%Lbsctan(1:isize) = Lbsctan(1:isize)
     ELSE
        Lbsctan(1:isize) = ss%Lbsctan(1:isize)
     ENDIF
  ENDIF
  Zbsc = 0.0_rspec
  IF(ALLOCATED(ss%Zbsc)) THEN
     isize = size(Zbsc)
     IF(init) THEN
        ss%Zbsc(1:isize) = Zbsc(1:isize)
     ELSE
        Zbsc(1:isize) = ss%Zbsc(1:isize)
     ENDIF
  ENDIF
  Phibsc = 0.0_rspec
  IF(ALLOCATED(ss%Phibsc)) THEN
     isize = size(Phibsc)
     IF(init) THEN
        ss%Phibsc(1:isize) = Phibsc(1:isize)
     ELSE
        Phibsc(1:isize) = ss%Phibsc(1:isize)
     ENDIF
  ENDIF
  Lbscap = 0.0_rspec
  IF(ALLOCATED(ss%Lbscap)) THEN
     isize = size(Lbscap)
     IF(init) THEN
        ss%Lbscap(1:isize) = Lbscap(1:isize)
     ELSE
        Lbscap(1:isize) = ss%Lbscap(1:isize)
     ENDIF
  ENDIF
  Zbap = 0.0_rspec
  IF(ALLOCATED(ss%Zbap)) THEN
     isize = size(Zbap)
     IF(init) THEN
        ss%Zbap(1:isize) = Zbap(1:isize)
     ELSE
        Zbap(1:isize) = ss%Zbap(1:isize)
     ENDIF
  ENDIF
  nbshape = " "
  IF(ALLOCATED(ss%nbshape)) THEN
     isize = size(nbshape)
     IF(init) THEN
        ss%nbshape(1:isize) = nbshape(1:isize)
     ELSE
        nbshape(1:isize) = ss%nbshape(1:isize)
     ENDIF
  ENDIF
  b_halfwidth = 0.0_rspec
  IF(ALLOCATED(ss%b_halfwidth)) THEN
     isize = size(b_halfwidth)
     IF(init) THEN
        ss%b_halfwidth(1:isize) = b_halfwidth(1:isize)
     ELSE
        b_halfwidth(1:isize) = ss%b_halfwidth(1:isize)
     ENDIF
  ENDIF
  b_halfHeight = 0.0_rspec
  IF(ALLOCATED(ss%b_halfHeight)) THEN
     isize = size(b_halfHeight)
     IF(init) THEN
        ss%b_halfHeight(1:isize) = b_halfHeight(1:isize)
     ELSE
        b_halfHeight(1:isize) = ss%b_halfHeight(1:isize)
     ENDIF
  ENDIF
  b_Hfocal_length = 0.0_rspec
  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     isize = size(b_Hfocal_length)
     IF(init) THEN
        ss%b_Hfocal_length(1:isize) = b_Hfocal_length(1:isize)
     ELSE
        b_Hfocal_length(1:isize) = ss%b_Hfocal_length(1:isize)
     ENDIF
  ENDIF
  b_Vfocal_length = 0.0_rspec
  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     isize = size(b_Vfocal_length)
     IF(init) THEN
        ss%b_Vfocal_length(1:isize) = b_Vfocal_length(1:isize)
     ELSE
        b_Vfocal_length(1:isize) = ss%b_Vfocal_length(1:isize)
     ENDIF
  ENDIF
  b_Hdivergence = 0.0_rspec
  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     isize = size(b_Hdivergence)
     IF(init) THEN
        ss%b_Hdivergence(1:isize) = b_Hdivergence(1:isize)
     ELSE
        b_Hdivergence(1:isize) = ss%b_Hdivergence(1:isize)
     ENDIF
  ENDIF
  b_Vdivergence = 0.0_rspec
  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     isize = size(b_Vdivergence)
     IF(init) THEN
        ss%b_Vdivergence(1:isize) = b_Vdivergence(1:isize)
     ELSE
        b_Vdivergence(1:isize) = ss%b_Vdivergence(1:isize)
     ENDIF
  ENDIF
  nbap_shape = " "
  IF(ALLOCATED(ss%nbap_shape)) THEN
     isize = size(nbap_shape)
     IF(init) THEN
        ss%nbap_shape(1:isize) = nbap_shape(1:isize)
     ELSE
        nbap_shape(1:isize) = ss%nbap_shape(1:isize)
     ENDIF
  ENDIF
  ap_halfwidth = 0.0_rspec
  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     isize = size(ap_halfwidth)
     IF(init) THEN
        ss%ap_halfwidth(1:isize) = ap_halfwidth(1:isize)
     ELSE
        ap_halfwidth(1:isize) = ss%ap_halfwidth(1:isize)
     ENDIF
  ENDIF
  ap_halfheight = 0.0_rspec
  IF(ALLOCATED(ss%ap_halfheight)) THEN
     isize = size(ap_halfheight)
     IF(init) THEN
        ss%ap_halfheight(1:isize) = ap_halfheight(1:isize)
     ELSE
        ap_halfheight(1:isize) = ss%ap_halfheight(1:isize)
     ENDIF
  ENDIF
  ap_horiz_offset = 0.0_rspec
  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     isize = size(ap_horiz_offset)
     IF(init) THEN
        ss%ap_horiz_offset(1:isize) = ap_horiz_offset(1:isize)
     ELSE
        ap_horiz_offset(1:isize) = ss%ap_horiz_offset(1:isize)
     ENDIF
  ENDIF
  ap_vert_offset = 0.0_rspec
  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     isize = size(ap_vert_offset)
     IF(init) THEN
        ss%ap_vert_offset(1:isize) = ap_vert_offset(1:isize)
     ELSE
        ap_vert_offset(1:isize) = ss%ap_vert_offset(1:isize)
     ENDIF
  ENDIF
  nbap2_shape = " "
  IF(ALLOCATED(ss%nbap2_shape)) THEN
     isize = size(nbap2_shape)
     IF(init) THEN
        ss%nbap2_shape(1:isize) = nbap2_shape(1:isize)
     ELSE
        nbap2_shape(1:isize) = ss%nbap2_shape(1:isize)
     ENDIF
  ENDIF
  Lbscap2 = 0.0_rspec
  IF(ALLOCATED(ss%Lbscap2)) THEN
     isize = size(Lbscap2)
     IF(init) THEN
        ss%Lbscap2(1:isize) = Lbscap2(1:isize)
     ELSE
        Lbscap2(1:isize) = ss%Lbscap2(1:isize)
     ENDIF
  ENDIF
  ap2_halfwidth = 0.0_rspec
  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     isize = size(ap2_halfwidth)
     IF(init) THEN
        ss%ap2_halfwidth(1:isize) = ap2_halfwidth(1:isize)
     ELSE
        ap2_halfwidth(1:isize) = ss%ap2_halfwidth(1:isize)
     ENDIF
  ENDIF
  ap2_halfheight = 0.0_rspec
  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     isize = size(ap2_halfheight)
     IF(init) THEN
        ss%ap2_halfheight(1:isize) = ap2_halfheight(1:isize)
     ELSE
        ap2_halfheight(1:isize) = ss%ap2_halfheight(1:isize)
     ENDIF
  ENDIF
  ap2_horiz_offset = 0.0_rspec
  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     isize = size(ap2_horiz_offset)
     IF(init) THEN
        ss%ap2_horiz_offset(1:isize) = ap2_horiz_offset(1:isize)
     ELSE
        ap2_horiz_offset(1:isize) = ss%ap2_horiz_offset(1:isize)
     ENDIF
  ENDIF
  ap2_vert_offset = 0.0_rspec
  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     isize = size(ap2_vert_offset)
     IF(init) THEN
        ss%ap2_vert_offset(1:isize) = ap2_vert_offset(1:isize)
     ELSE
        ap2_vert_offset(1:isize) = ss%ap2_vert_offset(1:isize)
     ENDIF
  ENDIF
  Einj_min = 0.0_rspec
  IF(ALLOCATED(ss%Einj_min)) THEN
     isize = size(Einj_min)
     IF(init) THEN
        ss%Einj_min(1:isize) = Einj_min(1:isize)
     ELSE
        Einj_min(1:isize) = ss%Einj_min(1:isize)
     ENDIF
  ENDIF
  Einj_max = 0.0_rspec
  IF(ALLOCATED(ss%Einj_max)) THEN
     isize = size(Einj_max)
     IF(init) THEN
        ss%Einj_max(1:isize) = Einj_max(1:isize)
     ELSE
        Einj_max(1:isize) = ss%Einj_max(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%n_H_einj_standard = 0
  n_H_einj_standard = ss%n_H_einj_standard
  IF(init) ss%n_D_einj_standard = 0
  n_D_einj_standard = ss%n_D_einj_standard
  IF(init) ss%n_T_einj_standard = 0
  n_T_einj_standard = ss%n_T_einj_standard
  H_einj_standard = 0.0_rspec
  IF(ALLOCATED(ss%H_einj_standard)) THEN
     isize = size(H_einj_standard)
     IF(init) THEN
        ss%H_einj_standard(1:isize) = H_einj_standard(1:isize)
     ELSE
        H_einj_standard(1:isize) = ss%H_einj_standard(1:isize)
     ENDIF
  ENDIF
  H_ffull_standard = 0.0_rspec
  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     isize = size(H_ffull_standard)
     IF(init) THEN
        ss%H_ffull_standard(1:isize) = H_ffull_standard(1:isize)
     ELSE
        H_ffull_standard(1:isize) = ss%H_ffull_standard(1:isize)
     ENDIF
  ENDIF
  H_fhalf_standard = 0.0_rspec
  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     isize = size(H_fhalf_standard)
     IF(init) THEN
        ss%H_fhalf_standard(1:isize) = H_fhalf_standard(1:isize)
     ELSE
        H_fhalf_standard(1:isize) = ss%H_fhalf_standard(1:isize)
     ENDIF
  ENDIF
  D_einj_standard = 0.0_rspec
  IF(ALLOCATED(ss%D_einj_standard)) THEN
     isize = size(D_einj_standard)
     IF(init) THEN
        ss%D_einj_standard(1:isize) = D_einj_standard(1:isize)
     ELSE
        D_einj_standard(1:isize) = ss%D_einj_standard(1:isize)
     ENDIF
  ENDIF
  D_ffull_standard = 0.0_rspec
  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     isize = size(D_ffull_standard)
     IF(init) THEN
        ss%D_ffull_standard(1:isize) = D_ffull_standard(1:isize)
     ELSE
        D_ffull_standard(1:isize) = ss%D_ffull_standard(1:isize)
     ENDIF
  ENDIF
  D_fhalf_standard = 0.0_rspec
  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     isize = size(D_fhalf_standard)
     IF(init) THEN
        ss%D_fhalf_standard(1:isize) = D_fhalf_standard(1:isize)
     ELSE
        D_fhalf_standard(1:isize) = ss%D_fhalf_standard(1:isize)
     ENDIF
  ENDIF
  T_einj_standard = 0.0_rspec
  IF(ALLOCATED(ss%T_einj_standard)) THEN
     isize = size(T_einj_standard)
     IF(init) THEN
        ss%T_einj_standard(1:isize) = T_einj_standard(1:isize)
     ELSE
        T_einj_standard(1:isize) = ss%T_einj_standard(1:isize)
     ENDIF
  ENDIF
  T_ffull_standard = 0.0_rspec
  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     isize = size(T_ffull_standard)
     IF(init) THEN
        ss%T_ffull_standard(1:isize) = T_ffull_standard(1:isize)
     ELSE
        T_ffull_standard(1:isize) = ss%T_ffull_standard(1:isize)
     ENDIF
  ENDIF
  T_fhalf_standard = 0.0_rspec
  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     isize = size(T_fhalf_standard)
     IF(init) THEN
        ss%T_fhalf_standard(1:isize) = T_fhalf_standard(1:isize)
     ELSE
        T_fhalf_standard(1:isize) = ss%T_fhalf_standard(1:isize)
     ENDIF
  ENDIF
  icrf_src_name = " "
  IF(ALLOCATED(ss%icrf_src_name)) THEN
     isize = size(icrf_src_name)
     IF(init) THEN
        ss%icrf_src_name(1:isize) = icrf_src_name(1:isize)
     ELSE
        icrf_src_name(1:isize) = ss%icrf_src_name(1:isize)
     ENDIF
  ENDIF
  ant_model = " "
  IF(ALLOCATED(ss%ant_model)) THEN
     isize = size(ant_model)
     IF(init) THEN
        ss%ant_model(1:isize) = ant_model(1:isize)
     ELSE
        ant_model(1:isize) = ss%ant_model(1:isize)
     ENDIF
  ENDIF
  nrz_antgeo = ps_unInit
  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     isize = size(nrz_antgeo)
     IF(init) THEN
        ss%nrz_antgeo(1:isize) = nrz_antgeo(1:isize)
     ELSE
        nrz_antgeo(1:isize) = ss%nrz_antgeo(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%max_nrz_antgeo = 0
  max_nrz_antgeo = ss%max_nrz_antgeo
  R_antgeo = 0.0_rspec
  IF(ALLOCATED(ss%R_antgeo)) THEN
     isiz0 = size(R_antgeo,1)
     isize = size(R_antgeo,2)
     IF(init) THEN
        ss%R_antgeo(1:isiz0,1:isize) = R_antgeo(1:isiz0,1:isize)
     ELSE
        R_antgeo(1:isiz0,1:isize) = ss%R_antgeo(1:isiz0,1:isize)
     ENDIF
  ENDIF
  Z_antgeo = 0.0_rspec
  IF(ALLOCATED(ss%Z_antgeo)) THEN
     isiz0 = size(Z_antgeo,1)
     isize = size(Z_antgeo,2)
     IF(init) THEN
        ss%Z_antgeo(1:isiz0,1:isize) = Z_antgeo(1:isiz0,1:isize)
     ELSE
        Z_antgeo(1:isiz0,1:isize) = ss%Z_antgeo(1:isiz0,1:isize)
     ENDIF
  ENDIF
  dx_fshield = 0.0_rspec
  IF(ALLOCATED(ss%dx_fshield)) THEN
     isize = size(dx_fshield)
     IF(init) THEN
        ss%dx_fshield(1:isize) = dx_fshield(1:isize)
     ELSE
        dx_fshield(1:isize) = ss%dx_fshield(1:isize)
     ENDIF
  ENDIF
  ecrf_src_name = " "
  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     isize = size(ecrf_src_name)
     IF(init) THEN
        ss%ecrf_src_name(1:isize) = ecrf_src_name(1:isize)
     ELSE
        ecrf_src_name(1:isize) = ss%ecrf_src_name(1:isize)
     ENDIF
  ENDIF
  R_EC_launch = 0.0_rspec
  IF(ALLOCATED(ss%R_EC_launch)) THEN
     isize = size(R_EC_launch)
     IF(init) THEN
        ss%R_EC_launch(1:isize) = R_EC_launch(1:isize)
     ELSE
        R_EC_launch(1:isize) = ss%R_EC_launch(1:isize)
     ENDIF
  ENDIF
  Z_EC_launch = 0.0_rspec
  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     isize = size(Z_EC_launch)
     IF(init) THEN
        ss%Z_EC_launch(1:isize) = Z_EC_launch(1:isize)
     ELSE
        Z_EC_launch(1:isize) = ss%Z_EC_launch(1:isize)
     ENDIF
  ENDIF
  Phi_EC_launch = 0.0_rspec
  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     isize = size(Phi_EC_launch)
     IF(init) THEN
        ss%Phi_EC_launch(1:isize) = Phi_EC_launch(1:isize)
     ELSE
        Phi_EC_launch(1:isize) = ss%Phi_EC_launch(1:isize)
     ENDIF
  ENDIF
  EC_PRINC_WIDTH_HOR = 0.0_rspec
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     isize = size(EC_PRINC_WIDTH_HOR)
     IF(init) THEN
        ss%EC_PRINC_WIDTH_HOR(1:isize) = EC_PRINC_WIDTH_HOR(1:isize)
     ELSE
        EC_PRINC_WIDTH_HOR(1:isize) = ss%EC_PRINC_WIDTH_HOR(1:isize)
     ENDIF
  ENDIF
  EC_PRINC_WIDTH_VERT = 0.0_rspec
  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     isize = size(EC_PRINC_WIDTH_VERT)
     IF(init) THEN
        ss%EC_PRINC_WIDTH_VERT(1:isize) = EC_PRINC_WIDTH_VERT(1:isize)
     ELSE
        EC_PRINC_WIDTH_VERT(1:isize) = ss%EC_PRINC_WIDTH_VERT(1:isize)
     ENDIF
  ENDIF
  EC_PRINC_CURV_HOR = 0.0_rspec
  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     isize = size(EC_PRINC_CURV_HOR)
     IF(init) THEN
        ss%EC_PRINC_CURV_HOR(1:isize) = EC_PRINC_CURV_HOR(1:isize)
     ELSE
        EC_PRINC_CURV_HOR(1:isize) = ss%EC_PRINC_CURV_HOR(1:isize)
     ENDIF
  ENDIF
  EC_PRINC_CURV_VERT = 0.0_rspec
  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     isize = size(EC_PRINC_CURV_VERT)
     IF(init) THEN
        ss%EC_PRINC_CURV_VERT(1:isize) = EC_PRINC_CURV_VERT(1:isize)
     ELSE
        EC_PRINC_CURV_VERT(1:isize) = ss%EC_PRINC_CURV_VERT(1:isize)
     ENDIF
  ENDIF
  EC_Half_Power_Angle = 0.0_rspec
  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     isize = size(EC_Half_Power_Angle)
     IF(init) THEN
        ss%EC_Half_Power_Angle(1:isize) = EC_Half_Power_Angle(1:isize)
     ELSE
        EC_Half_Power_Angle(1:isize) = ss%EC_Half_Power_Angle(1:isize)
     ENDIF
  ENDIF
  EC_Beam_Elongation = 0.0_rspec
  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     isize = size(EC_Beam_Elongation)
     IF(init) THEN
        ss%EC_Beam_Elongation(1:isize) = EC_Beam_Elongation(1:isize)
     ELSE
        EC_Beam_Elongation(1:isize) = ss%EC_Beam_Elongation(1:isize)
     ENDIF
  ENDIF
  lhrf_src_name = " "
  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     isize = size(lhrf_src_name)
     IF(init) THEN
        ss%lhrf_src_name(1:isize) = lhrf_src_name(1:isize)
     ELSE
        lhrf_src_name(1:isize) = ss%lhrf_src_name(1:isize)
     ENDIF
  ENDIF
  IF(init) ss%ntf_coils = 0
  ntf_coils = ss%ntf_coils
  IF(init) ss%ntf_coil2 = 0
  ntf_coil2 = ss%ntf_coil2

  IF(ierr.GT.0) RETURN

  ! OK: open namelist file, strip comments.
  !     namelist to be read on ilun_namel after this call:

  CALL ps_namel_strip(filename,tmp_filename,ilun_namel,iout,ierr)

  IF(ierr.NE.0) THEN
     WRITE(iout,*) ' ?namelist file OPEN or READ error: '//trim(filename)
     RETURN
  ENDIF

  READ(UNIT=ilun_namel,NML=mdescr)

  CLOSE(UNIT=ilun_namel,status="DELETE")

  ! check list quantities; infer dimensions

  ss%num_rzlim = num_rzlim

  CALL ps_namrd_ilist_chk("circuit_name", &
       ps_max_static,circuit_name,ss%NCIRCUITS,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_ilist_chk("coil_name", &
       ps_max_static,coil_name,ss%NCOILS,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_ilist_chk("nbi_src_name", &
       ps_max_static,nbi_src_name,ss%NBEAM,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  ss%n_H_einj_standard = n_H_einj_standard

  ss%n_D_einj_standard = n_D_einj_standard

  ss%n_T_einj_standard = n_T_einj_standard

  CALL ps_namrd_ilist_chk("icrf_src_name", &
       ps_max_static_2d,icrf_src_name,ss%NICRF_SRC,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  ss%max_nrz_antgeo = max_nrz_antgeo

  CALL ps_namrd_ilist_chk("ecrf_src_name", &
       ps_max_static,ecrf_src_name,ss%NECRF_SRC,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  CALL ps_namrd_ilist_chk("lhrf_src_name", &
       ps_max_static,lhrf_src_name,ss%NLHRF_SRC,iout,iertmp)
  IF(iertmp.NE.0) ierr = ierr + 1

  IF(ierr.NE.0) THEN
     WRITE(iout,*) " ?mdescr namelist list check errors after read."
     RETURN
  ENDIF

  ! OK, allocate arrays per dimensioning in namelist
  CALL plasma_state_empty_alloc(ss,ierr)
  IF(ierr.NE.0) RETURN

  ! Now pick up any vector dimensions

  isize = ss%NCOILS
  ss%Nturns(1:isize) = Nturns(1:isize)

  isize = ss%NCOILS
  ss%VRep_coil_count(1:isize) = VRep_coil_count(1:isize)

  isize = ss%NICRF_SRC
  ss%nrz_antgeo(1:isize) = nrz_antgeo(1:isize)

  ! OK, allocate arrays per vector dimensioning in namelist
  CALL plasma_state_empty_alloc(ss,ierr)
  IF(ierr.NE.0) RETURN

  ! Now copy namelist variables into state
  ss%tokamak_id = tokamak_id
  ss%geometry = geometry

  IF(ALLOCATED(ss%rlim)) THEN
     isize = ss%NUM_RZLIM
     ss%rlim(1:isize) = rlim(1:isize)
  ENDIF

  IF(ALLOCATED(ss%zlim)) THEN
     isize = ss%NUM_RZLIM
     ss%zlim(1:isize) = zlim(1:isize)
  ENDIF
  ss%R_min_box = R_min_box
  ss%R_max_box = R_max_box
  ss%Z_min_box = Z_min_box
  ss%Z_max_box = Z_max_box

  IF(ALLOCATED(ss%circuit_name)) THEN
     isize = ss%NCIRCUITS
     ss%circuit_name(1:isize) = circuit_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%coil_name)) THEN
     isize = ss%NCOILS
     ss%coil_name(1:isize) = coil_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%coil_in_circuit)) THEN
     isize = ss%NCOILS
     ss%coil_in_circuit(1:isize) = coil_in_circuit(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Rloc_coil)) THEN
     isize = ss%NCOILS
     ss%Rloc_coil(1:isize) = Rloc_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Zloc_coil)) THEN
     isize = ss%NCOILS
     ss%Zloc_coil(1:isize) = Zloc_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Hsize_coil)) THEN
     isize = ss%NCOILS
     ss%Hsize_coil(1:isize) = Hsize_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Ang_Href_coil)) THEN
     isize = ss%NCOILS
     ss%Ang_Href_coil(1:isize) = Ang_Href_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Vsize_coil)) THEN
     isize = ss%NCOILS
     ss%Vsize_coil(1:isize) = Vsize_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Ang_Vref_coil)) THEN
     isize = ss%NCOILS
     ss%Ang_Vref_coil(1:isize) = Ang_Vref_coil(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Nturns)) THEN
     isize = ss%NCOILS
     ss%Nturns(1:isize) = Nturns(1:isize)
  ENDIF

  IF(ALLOCATED(ss%VRep_coil_count)) THEN
     isize = ss%NCOILS
     ss%VRep_coil_count(1:isize) = VRep_coil_count(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Vrep_coil_spacing)) THEN
     isize = ss%NCOILS
     ss%Vrep_coil_spacing(1:isize) = Vrep_coil_spacing(1:isize)
  ENDIF

  IF(ALLOCATED(ss%coil_resispt)) THEN
     isize = ss%NCOILS
     ss%coil_resispt(1:isize) = coil_resispt(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nbi_src_name)) THEN
     isize = ss%NBEAM
     ss%nbi_src_name(1:isize) = nbi_src_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%beam_type)) THEN
     isize = ss%NBEAM
     ss%beam_type(1:isize) = beam_type(1:isize)
  ENDIF

  IF(ALLOCATED(ss%sRtcen)) THEN
     isize = ss%NBEAM
     ss%sRtcen(1:isize) = sRtcen(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Lbsctan)) THEN
     isize = ss%NBEAM
     ss%Lbsctan(1:isize) = Lbsctan(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Zbsc)) THEN
     isize = ss%NBEAM
     ss%Zbsc(1:isize) = Zbsc(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Phibsc)) THEN
     isize = ss%NBEAM
     ss%Phibsc(1:isize) = Phibsc(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Lbscap)) THEN
     isize = ss%NBEAM
     ss%Lbscap(1:isize) = Lbscap(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Zbap)) THEN
     isize = ss%NBEAM
     ss%Zbap(1:isize) = Zbap(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nbshape)) THEN
     isize = ss%NBEAM
     ss%nbshape(1:isize) = nbshape(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_halfwidth)) THEN
     isize = ss%NBEAM
     ss%b_halfwidth(1:isize) = b_halfwidth(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_halfHeight)) THEN
     isize = ss%NBEAM
     ss%b_halfHeight(1:isize) = b_halfHeight(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_Hfocal_length)) THEN
     isize = ss%NBEAM
     ss%b_Hfocal_length(1:isize) = b_Hfocal_length(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_Vfocal_length)) THEN
     isize = ss%NBEAM
     ss%b_Vfocal_length(1:isize) = b_Vfocal_length(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_Hdivergence)) THEN
     isize = ss%NBEAM
     ss%b_Hdivergence(1:isize) = b_Hdivergence(1:isize)
  ENDIF

  IF(ALLOCATED(ss%b_Vdivergence)) THEN
     isize = ss%NBEAM
     ss%b_Vdivergence(1:isize) = b_Vdivergence(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nbap_shape)) THEN
     isize = ss%NBEAM
     ss%nbap_shape(1:isize) = nbap_shape(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap_halfwidth)) THEN
     isize = ss%NBEAM
     ss%ap_halfwidth(1:isize) = ap_halfwidth(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap_halfheight)) THEN
     isize = ss%NBEAM
     ss%ap_halfheight(1:isize) = ap_halfheight(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap_horiz_offset)) THEN
     isize = ss%NBEAM
     ss%ap_horiz_offset(1:isize) = ap_horiz_offset(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap_vert_offset)) THEN
     isize = ss%NBEAM
     ss%ap_vert_offset(1:isize) = ap_vert_offset(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nbap2_shape)) THEN
     isize = ss%NBEAM
     ss%nbap2_shape(1:isize) = nbap2_shape(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Lbscap2)) THEN
     isize = ss%NBEAM
     ss%Lbscap2(1:isize) = Lbscap2(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap2_halfwidth)) THEN
     isize = ss%NBEAM
     ss%ap2_halfwidth(1:isize) = ap2_halfwidth(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap2_halfheight)) THEN
     isize = ss%NBEAM
     ss%ap2_halfheight(1:isize) = ap2_halfheight(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap2_horiz_offset)) THEN
     isize = ss%NBEAM
     ss%ap2_horiz_offset(1:isize) = ap2_horiz_offset(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ap2_vert_offset)) THEN
     isize = ss%NBEAM
     ss%ap2_vert_offset(1:isize) = ap2_vert_offset(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Einj_min)) THEN
     isize = ss%NBEAM
     ss%Einj_min(1:isize) = Einj_min(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Einj_max)) THEN
     isize = ss%NBEAM
     ss%Einj_max(1:isize) = Einj_max(1:isize)
  ENDIF

  IF(ALLOCATED(ss%H_einj_standard)) THEN
     isize = ss%N_H_EINJ_STANDARD
     ss%H_einj_standard(1:isize) = H_einj_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%H_ffull_standard)) THEN
     isize = ss%N_H_EINJ_STANDARD
     ss%H_ffull_standard(1:isize) = H_ffull_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%H_fhalf_standard)) THEN
     isize = ss%N_H_EINJ_STANDARD
     ss%H_fhalf_standard(1:isize) = H_fhalf_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%D_einj_standard)) THEN
     isize = ss%N_D_EINJ_STANDARD
     ss%D_einj_standard(1:isize) = D_einj_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%D_ffull_standard)) THEN
     isize = ss%N_D_EINJ_STANDARD
     ss%D_ffull_standard(1:isize) = D_ffull_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%D_fhalf_standard)) THEN
     isize = ss%N_D_EINJ_STANDARD
     ss%D_fhalf_standard(1:isize) = D_fhalf_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%T_einj_standard)) THEN
     isize = ss%N_T_EINJ_STANDARD
     ss%T_einj_standard(1:isize) = T_einj_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     isize = ss%N_T_EINJ_STANDARD
     ss%T_ffull_standard(1:isize) = T_ffull_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     isize = ss%N_T_EINJ_STANDARD
     ss%T_fhalf_standard(1:isize) = T_fhalf_standard(1:isize)
  ENDIF

  IF(ALLOCATED(ss%icrf_src_name)) THEN
     isize = ss%NICRF_SRC
     ss%icrf_src_name(1:isize) = icrf_src_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ant_model)) THEN
     isize = ss%NICRF_SRC
     ss%ant_model(1:isize) = ant_model(1:isize)
  ENDIF

  IF(ALLOCATED(ss%nrz_antgeo)) THEN
     isize = ss%NICRF_SRC
     ss%nrz_antgeo(1:isize) = nrz_antgeo(1:isize)
  ENDIF

  IF(ALLOCATED(ss%R_antgeo)) THEN
     isiz0 = maxval(ss%NRZ_ANTGEO)
     isize = ss%NICRF_SRC
     ss%R_antgeo(1:isiz0,1:isize) = R_antgeo(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%Z_antgeo)) THEN
     isiz0 = maxval(ss%NRZ_ANTGEO)
     isize = ss%NICRF_SRC
     ss%Z_antgeo(1:isiz0,1:isize) = Z_antgeo(1:isiz0,1:isize)
  ENDIF

  IF(ALLOCATED(ss%dx_fshield)) THEN
     isize = ss%NICRF_SRC
     ss%dx_fshield(1:isize) = dx_fshield(1:isize)
  ENDIF

  IF(ALLOCATED(ss%ecrf_src_name)) THEN
     isize = ss%NECRF_SRC
     ss%ecrf_src_name(1:isize) = ecrf_src_name(1:isize)
  ENDIF

  IF(ALLOCATED(ss%R_EC_launch)) THEN
     isize = ss%NECRF_SRC
     ss%R_EC_launch(1:isize) = R_EC_launch(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Z_EC_launch)) THEN
     isize = ss%NECRF_SRC
     ss%Z_EC_launch(1:isize) = Z_EC_launch(1:isize)
  ENDIF

  IF(ALLOCATED(ss%Phi_EC_launch)) THEN
     isize = ss%NECRF_SRC
     ss%Phi_EC_launch(1:isize) = Phi_EC_launch(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_HOR)) THEN
     isize = ss%NECRF_SRC
     ss%EC_PRINC_WIDTH_HOR(1:isize) = EC_PRINC_WIDTH_HOR(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_WIDTH_VERT)) THEN
     isize = ss%NECRF_SRC
     ss%EC_PRINC_WIDTH_VERT(1:isize) = EC_PRINC_WIDTH_VERT(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_HOR)) THEN
     isize = ss%NECRF_SRC
     ss%EC_PRINC_CURV_HOR(1:isize) = EC_PRINC_CURV_HOR(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_PRINC_CURV_VERT)) THEN
     isize = ss%NECRF_SRC
     ss%EC_PRINC_CURV_VERT(1:isize) = EC_PRINC_CURV_VERT(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_Half_Power_Angle)) THEN
     isize = ss%NECRF_SRC
     ss%EC_Half_Power_Angle(1:isize) = EC_Half_Power_Angle(1:isize)
  ENDIF

  IF(ALLOCATED(ss%EC_Beam_Elongation)) THEN
     isize = ss%NECRF_SRC
     ss%EC_Beam_Elongation(1:isize) = EC_Beam_Elongation(1:isize)
  ENDIF

  IF(ALLOCATED(ss%lhrf_src_name)) THEN
     isize = ss%NLHRF_SRC
     ss%lhrf_src_name(1:isize) = lhrf_src_name(1:isize)
  ENDIF
  ss%ntf_coils = ntf_coils
  ss%ntf_coil2 = ntf_coil2


  IF(g_filename.NE.' ') THEN
     CALL ps_mdescr_gfile_read(g_filename,ss,ierr)
     IF(ierr.NE.0) THEN
        WRITE(iout,*) ' ?ps_mdescr_namelist_read: gfile read error.'
     ENDIF
  ENDIF

END SUBROUTINE ps_mdescr_namelist_read

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_contents_profs_6(itype,icomponent,ss,w,isize)


  ! fill window structure with requested table of contents

  USE plasma_state_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: itype   ! type of table of contents
                                 ! values such as ps_grid_dims or ps_profiles

  INTEGER, INTENT(IN) :: icomponent(ps_ccount) ! component flags
             ! icomponent(j).eq.1 => component j active
             ! e.g. icomponent(ps_cnum_EQ).eq.1 => EQ component is active

  TYPE (plasma_state) :: ss      ! state examined
  TYPE (ps_list_window) :: w     ! list window structure filled

  INTEGER, INTENT(INOUT) :: isize  ! incremented size...

  !----------------

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qcomp_i
        w%list_elems(isize) = "qcomp_i"
        w%elem_descr(isize) = "Compressional ion heating"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qcomp_i)) THEN
           IF(ss%hash_codes(ps_phash_qcomp_i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qie
        w%list_elems(isize) = "qie"
        w%elem_descr(isize) = "Ion->Electron heat coupling"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qie)) THEN
           IF(ss%hash_codes(ps_phash_qie).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qioniz
        w%list_elems(isize) = "qioniz"
        w%elem_descr(isize) = "ionization power per unit influx (sc0)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W/(#/sec)"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%qioniz)) THEN
           IF(ss%hash_codes(ps_phash_qioniz).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qqcx
        w%list_elems(isize) = "qqcx"
        w%elem_descr(isize) = "cx power per unit influx per (T0-Ti)"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "W/(#/sec)/keV"
        w%c256val(isize) = "(nrho_gas-1,ngsc0)"
        IF(ALLOCATED(ss%qqcx)) THEN
           IF(ss%hash_codes(ps_phash_qqcx).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qrot_conv
        w%list_elems(isize) = "qrot_conv"
        w%elem_descr(isize) = "rotational energy dissipation (convective)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qrot_conv)) THEN
           IF(ss%hash_codes(ps_phash_qrot_conv).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! qrot_diff
        w%list_elems(isize) = "qrot_diff"
        w%elem_descr(isize) = "rotational energy dissipation (diffusive)"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "W"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%qrot_diff)) THEN
           IF(ss%hash_codes(ps_phash_qrot_diff).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! q_eq
        w%list_elems(isize) = "q_eq"
        w%elem_descr(isize) = "equilibrium q profile"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "-"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%q_eq)) THEN
           IF(ss%hash_codes(ps_phash_q_eq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "SPLINE"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R0_momeq
        w%list_elems(isize) = "R0_momeq"
        w%elem_descr(isize) = "R0 of flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq)"
        IF(ALLOCATED(ss%R0_momeq)) THEN
           IF(ss%hash_codes(ps_phash_R0_momeq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0i
        w%list_elems(isize) = "rate_sinb0i"
        w%elem_descr(isize) = "sink rate due to ionization by beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%rate_sinb0i)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinb0i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0x
        w%list_elems(isize) = "rate_sinb0x"
        w%elem_descr(isize) = "sink rate due to CX with beam ions (total)"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%rate_sinb0x)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinb0x).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinb0xs
        w%list_elems(isize) = "rate_sinb0xs"
        w%elem_descr(isize) = "sink rate due to CX with beam ions"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas,nspec_beam)"
        IF(ALLOCATED(ss%rate_sinb0xs)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinb0xs).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0i
        w%list_elems(isize) = "rate_sinf0i"
        w%elem_descr(isize) = "sink rate due to ionization by fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_fus-1,nspec_gas)"
        IF(ALLOCATED(ss%rate_sinf0i)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinf0i).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0x
        w%list_elems(isize) = "rate_sinf0x"
        w%elem_descr(isize) = "sink rate due to CX with fusion ions (total)"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_fus-1,nspec_gas)"
        IF(ALLOCATED(ss%rate_sinf0x)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinf0x).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rate_sinf0xs
        w%list_elems(isize) = "rate_sinf0xs"
        w%elem_descr(isize) = "sink rate due to CX with fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "1/sec"
        w%c256val(isize) = "(nrho_fus-1,nspec_gas,nspec_fusion)"
        IF(ALLOCATED(ss%rate_sinf0xs)) THEN
           IF(ss%hash_codes(ps_phash_rate_sinf0xs).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_sn
        w%list_elems(isize) = "res_sn"
        w%elem_descr(isize) = "residuals for particle transport eqn"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Norm"
        w%c256val(isize) = "(nrho-1,0:nspec_th)"
        IF(ALLOCATED(ss%res_sn)) THEN
           IF(ss%hash_codes(ps_phash_res_sn).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_te
        w%list_elems(isize) = "res_te"
        w%elem_descr(isize) = "residuals for electron transport eqn"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Norm"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%res_te)) THEN
           IF(ss%hash_codes(ps_phash_res_te).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_ti
        w%list_elems(isize) = "res_ti"
        w%elem_descr(isize) = "residuals for ion transport eqn"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Norm"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%res_ti)) THEN
           IF(ss%hash_codes(ps_phash_res_ti).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_PLASMA).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! res_tq
        w%list_elems(isize) = "res_tq"
        w%elem_descr(isize) = "rediduals for angular momentum transport eqn"
        w%component(isize) = "PLASMA"
        w%elem_units(isize) = "Norm"
        w%c256val(isize) = "(nrho-1)"
        IF(ALLOCATED(ss%res_tq)) THEN
           IF(ss%hash_codes(ps_phash_res_tq).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! Rmajor_mean
        w%list_elems(isize) = "Rmajor_mean"
        w%elem_descr(isize) = "Rmajor_mean = (R_Surfmax+R_surfmin)/2"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%Rmajor_mean)) THEN
           IF(ss%hash_codes(ps_phash_Rmajor_mean).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! rMinor_mean
        w%list_elems(isize) = "rMinor_mean"
        w%elem_descr(isize) = "rMinor_mean = (R_Surfmax-R_surfmin)/2"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%rMinor_mean)) THEN
           IF(ss%hash_codes(ps_phash_rMinor_mean).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_geo
        w%list_elems(isize) = "R_geo"
        w%elem_descr(isize) = "flux surfaces R(rho,theta)"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq,nth_eq)"
        IF(ALLOCATED(ss%R_geo)) THEN
           IF(ss%hash_codes(ps_phash_R_geo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "HERMITE_EXPLICIT"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_midp_in
        w%list_elems(isize) = "R_midp_in"
        w%elem_descr(isize) = "R (high field side) midplane intercept"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%R_midp_in)) THEN
           IF(ss%hash_codes(ps_phash_R_midp_in).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_midp_out
        w%list_elems(isize) = "R_midp_out"
        w%elem_descr(isize) = "R (low field side) midplane intercept"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%R_midp_out)) THEN
           IF(ss%hash_codes(ps_phash_R_midp_out).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_surfMax
        w%list_elems(isize) = "R_surfMax"
        w%elem_descr(isize) = "max R on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%R_surfMax)) THEN
           IF(ss%hash_codes(ps_phash_R_surfMax).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_EQ).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! R_surfMin
        w%list_elems(isize) = "R_surfMin"
        w%elem_descr(isize) = "min R on flux surface"
        w%component(isize) = "EQ"
        w%elem_units(isize) = "m"
        w%c256val(isize) = "(nrho_eq_geo)"
        IF(ALLOCATED(ss%R_surfMin)) THEN
           IF(ss%hash_codes(ps_phash_R_surfMin).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "PCLIN"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco
        w%list_elems(isize) = "s0reco"
        w%elem_descr(isize) = "recombination neutral sce"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas)"
        IF(ALLOCATED(ss%s0reco)) THEN
           IF(ss%hash_codes(ps_phash_s0reco).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco_e
        w%list_elems(isize) = "s0reco_e"
        w%elem_descr(isize) = "net electron source associated with recombination:"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_gas-1)"
        IF(ALLOCATED(ss%s0reco_e)) THEN
           IF(ss%hash_codes(ps_phash_s0reco_e).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_GAS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! s0reco_recap
        w%list_elems(isize) = "s0reco_recap"
        w%elem_descr(isize) = "recombination neutrals recapture"
        w%component(isize) = "GAS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_gas-1,nspec_gas)"
        IF(ALLOCATED(ss%s0reco_recap)) THEN
           IF(ss%hash_codes(ps_phash_s0reco_recap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sb0halo
        w%list_elems(isize) = "sb0halo"
        w%elem_descr(isize) = "beam dep cx sink"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%sb0halo)) THEN
           IF(ss%hash_codes(ps_phash_sb0halo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sb0halo_recap
        w%list_elems(isize) = "sb0halo_recap"
        w%elem_descr(isize) = "cx neutral recapture"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_gas)"
        IF(ALLOCATED(ss%sb0halo_recap)) THEN
           IF(ss%hash_codes(ps_phash_sb0halo_recap).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbedep
        w%list_elems(isize) = "sbedep"
        w%elem_descr(isize) = "beam deposition cold electron sce"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%sbedep)) THEN
           IF(ss%hash_codes(ps_phash_sbedep).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbehalo
        w%list_elems(isize) = "sbehalo"
        w%elem_descr(isize) = "cold electron sce due to"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1)"
        IF(ALLOCATED(ss%sbehalo)) THEN
           IF(ss%hash_codes(ps_phash_sbehalo).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbsce
        w%list_elems(isize) = "sbsce"
        w%elem_descr(isize) = "net source, thermal ions & electrons"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1,0:nspec_tha)"
        IF(ALLOCATED(ss%sbsce)) THEN
           IF(ss%hash_codes(ps_phash_sbsce).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_NBI).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sbtherm
        w%list_elems(isize) = "sbtherm"
        w%elem_descr(isize) = "beam ion thermalization"
        w%component(isize) = "NBI"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_nbi-1,nspec_beam)"
        IF(ALLOCATED(ss%sbtherm)) THEN
           IF(ss%hash_codes(ps_phash_sbtherm).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_ANOM).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sc_anom
        w%list_elems(isize) = "sc_anom"
        w%elem_descr(isize) = "anomalous sources"
        w%component(isize) = "ANOM"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_anomth-1,0:nspec_th)"
        IF(ALLOCATED(ss%sc_anom)) THEN
           IF(ss%hash_codes(ps_phash_sc_anom).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF

  IF(icomponent(ps_cnum_FUS).EQ.1) THEN
     IF(itype.EQ.ps_profiles) THEN
        isize = isize + 1  ! sfsce
        w%list_elems(isize) = "sfsce"
        w%elem_descr(isize) = "net thermalization source of fusion ions"
        w%component(isize) = "FUS"
        w%elem_units(isize) = "#/sec"
        w%c256val(isize) = "(nrho_fus-1,0:nspec_tha)"
        IF(ALLOCATED(ss%sfsce)) THEN
           IF(ss%hash_codes(ps_phash_sfsce).LT.0) THEN
              w%ival(isize) = 0
           ELSE
              w%ival(isize) = 1
           ENDIF
        ELSE
           w%ival(isize) = -1
        ENDIF
        w%val_field(isize) = "STEP*DV"
     ENDIF
  ENDIF
END SUBROUTINE plasma_state_contents_profs_6

C******************** START FILE DATCPU.FOR ; GROUP DATCPU ******************
      SUBROUTINE DATCPU(ZTIME)
C
C  THIS ROUTINE RETURNS THE AMOUNT OF CPU TIME USED UP UNTIL
C  THIS TIME IN SECONDS.
C
C  THIS VERSION FOR USE OUTSIDE OF TRANSP
C
C--------------------------------------
C
      call cpu_time(ztime)
C
      RETURN
      END
C******************** END FILE DATCPU.FOR ; GROUP DATCPU ******************

subroutine splitn_merge_write(merge_input_filename, &
     backup_filename,output_filename, tagname, ios)

  ! save backup of current namelist, if backup_filename.ne.' '

  ! merge namelist text with text from a namelist section
  !   (in file merge_input_filename)

  ! write merged list to output_filename
  ! read merged file back in if no error so far.
  
  ! tag merged lines with "!$<tagname>".

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: merge_input_filename
  character*(*), intent(in) :: backup_filename
  character*(*), intent(in) :: output_filename
  character*(*), intent(in) :: tagname

  integer, intent(out) :: ios   ! status code on exit, 0=normal

  !----------------------------------
  !----------------------------------

  ios=0
  if(backup_filename.ne.' ') then

     call write_nl(backup_filename,ios)
     if(ios.ne.0) return

  endif

  call merge_read_nl(merge_input_filename,tagname,ios)
  if(ios.ne.0) return

  call write_nl(output_filename,ios)

  if(ios.ne.0) then

     call init_nl(.TRUE.)  ! leaving empty namelist -- error occurred.

  else

     call read_nl(output_filename,ios)

  endif

end subroutine splitn_merge_write

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_copy_8(cclist,ss,ss2,icopy_lists,iwant_1deq,partial_copy,ierr)


  ! Copy scalars, and, arrays that are allocated
  !   ss2 <-- ss

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  TYPE (plasma_state) :: ss     ! state data to copy *from*
  TYPE (plasma_state) :: ss2    ! state data to copy *to*

  INTEGER, INTENT(IN) :: icopy_lists ! =1 to require copying of all lists

  INTEGER, INTENT(IN) :: iwant_1deq  ! =1 to request fcns of (rho_eq)
                                     !  even if cclist(ps_cnum_EQ).eq.0

  LOGICAL, INTENT(IN) :: partial_copy ! .TRUE. if full state copy not in effect

  INTEGER, INTENT(INOUT) :: ierr  ! completion flag (not cleared, set by error)

  !-------------------
  INTEGER :: iout
  !-------------------

  iout = SWIM_err_out_file


  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%tfinal = ss%tfinal
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tfrip2_log = 0
  ENDIF
  IF((ALLOCATED(ss%tfrip2_log).AND.ALLOCATED(ss2%tfrip2_log)).AND. &
        ((cclist(ps_cnum_RIPPLE).EQ.1))) THEN
     ss2%tfrip2_log = ss%tfrip2_log
     IF(.not.partial_copy) THEN
        ss2%id_tfrip2_log = ss%id_tfrip2_log
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tfrip_log = 0
  ENDIF
  IF((ALLOCATED(ss%tfrip_log).AND.ALLOCATED(ss2%tfrip_log)).AND. &
        ((cclist(ps_cnum_RIPPLE).EQ.1))) THEN
     ss2%tfrip_log = ss%tfrip_log
     IF(.not.partial_copy) THEN
        ss2%id_tfrip_log = ss%id_tfrip_log
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%TF_Data_Info = ss%TF_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%thegrilh)).AND.(ALLOCATED(ss%thegrilh))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LH).EQ.1)) ) THEN
     ss2%thegrilh = ss%thegrilh
  ENDIF
  IF((ALLOCATED(ss%th_eq).AND.ALLOCATED(ss2%th_eq)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%th_eq = ss%th_eq
  ENDIF
  IF(partial_copy) THEN
     ss2%id_Ti = 0
  ENDIF
  IF((ALLOCATED(ss%Ti).AND.ALLOCATED(ss2%Ti)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Ti = ss%Ti
     IF(.not.partial_copy) THEN
        ss2%id_Ti = ss%id_Ti
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_tiflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_tiflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tiflux_ky_tglf).AND.ALLOCATED(ss2%tiflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%tiflux_ky_tglf = ss%tiflux_ky_tglf
     IF(ALLOCATED(ss2%id_tiflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tiflux_ky_tglf = ss%id_tiflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%tinit = ss%tinit
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Ti_bdy = ss%Ti_bdy
  ENDIF
  IF(ALLOCATED(ss2%id_ti_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_ti_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%ti_ky_tglf).AND.ALLOCATED(ss2%ti_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%ti_ky_tglf = ss%ti_ky_tglf
     IF(ALLOCATED(ss2%id_ti_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_ti_ky_tglf = ss%id_ti_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tmodel = 0
  ENDIF
  IF((ALLOCATED(ss%tmodel).AND.ALLOCATED(ss2%tmodel)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%tmodel = ss%tmodel
     IF(.not.partial_copy) THEN
        ss2%id_tmodel = ss%id_tmodel
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_ANOM).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%tmodel_bdy = ss%tmodel_bdy
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%tokamak_id = ss%tokamak_id
  ENDIF
  IF( ((ALLOCATED(ss2%Tornum_balcrit)).AND.(ALLOCATED(ss%Tornum_balcrit))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Tornum_balcrit = ss%Tornum_balcrit
  ENDIF
  IF( ((ALLOCATED(ss2%Tor_mode_label)).AND.(ALLOCATED(ss%Tor_mode_label))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Tor_mode_label = ss%Tor_mode_label
  ENDIF
  IF( ((ALLOCATED(ss2%Tor_mode_No)).AND.(ALLOCATED(ss%Tor_mode_No))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_LMHD).EQ.1)) ) THEN
     ss2%Tor_mode_No = ss%Tor_mode_No
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tq0_reco = 0
  ENDIF
  IF((ALLOCATED(ss%tq0_reco).AND.ALLOCATED(ss2%tq0_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%tq0_reco = ss%tq0_reco
     IF(.not.partial_copy) THEN
        ss2%id_tq0_reco = ss%id_tq0_reco
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqb0_halo = 0
  ENDIF
  IF((ALLOCATED(ss%tqb0_halo).AND.ALLOCATED(ss2%tqb0_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqb0_halo = ss%tqb0_halo
     IF(.not.partial_copy) THEN
        ss2%id_tqb0_halo = ss%id_tqb0_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqbe = 0
  ENDIF
  IF((ALLOCATED(ss%tqbe).AND.ALLOCATED(ss2%tqbe)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqbe = ss%tqbe
     IF(.not.partial_copy) THEN
        ss2%id_tqbe = ss%id_tqbe
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqbi = 0
  ENDIF
  IF((ALLOCATED(ss%tqbi).AND.ALLOCATED(ss2%tqbi)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqbi = ss%tqbi
     IF(.not.partial_copy) THEN
        ss2%id_tqbi = ss%id_tqbi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqbjxb = 0
  ENDIF
  IF((ALLOCATED(ss%tqbjxb).AND.ALLOCATED(ss2%tqbjxb)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqbjxb = ss%tqbjxb
     IF(.not.partial_copy) THEN
        ss2%id_tqbjxb = ss%id_tqbjxb
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqbth = 0
  ENDIF
  IF((ALLOCATED(ss%tqbth).AND.ALLOCATED(ss2%tqbth)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqbth = ss%tqbth
     IF(.not.partial_copy) THEN
        ss2%id_tqbth = ss%id_tqbth
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqcx_halo = 0
  ENDIF
  IF((ALLOCATED(ss%tqcx_halo).AND.ALLOCATED(ss2%tqcx_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqcx_halo = ss%tqcx_halo
     IF(.not.partial_copy) THEN
        ss2%id_tqcx_halo = ss%id_tqcx_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqcx_reco = 0
  ENDIF
  IF((ALLOCATED(ss%tqcx_reco).AND.ALLOCATED(ss2%tqcx_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%tqcx_reco = ss%tqcx_reco
     IF(.not.partial_copy) THEN
        ss2%id_tqcx_reco = ss%id_tqcx_reco
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_tqioniz)) THEN
     IF(partial_copy) THEN
        ss2%id_tqioniz = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tqioniz).AND.ALLOCATED(ss2%tqioniz)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%tqioniz = ss%tqioniz
     IF(ALLOCATED(ss2%id_tqioniz)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tqioniz = ss%id_tqioniz
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_tqqcx)) THEN
     IF(partial_copy) THEN
        ss2%id_tqqcx = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tqqcx).AND.ALLOCATED(ss2%tqqcx)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%tqqcx = ss%tqqcx
     IF(ALLOCATED(ss2%id_tqqcx)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tqqcx = ss%id_tqqcx
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqsc_halo = 0
  ENDIF
  IF((ALLOCATED(ss%tqsc_halo).AND.ALLOCATED(ss2%tqsc_halo)).AND. &
        ((cclist(ps_cnum_NBI).EQ.1))) THEN
     ss2%tqsc_halo = ss%tqsc_halo
     IF(.not.partial_copy) THEN
        ss2%id_tqsc_halo = ss%id_tqsc_halo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tqsc_reco = 0
  ENDIF
  IF((ALLOCATED(ss%tqsc_reco).AND.ALLOCATED(ss2%tqsc_reco)).AND. &
        ((cclist(ps_cnum_GAS).EQ.1))) THEN
     ss2%tqsc_reco = ss%tqsc_reco
     IF(.not.partial_copy) THEN
        ss2%id_tqsc_reco = ss%id_tqsc_reco
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tq_anom = 0
  ENDIF
  IF((ALLOCATED(ss%tq_anom).AND.ALLOCATED(ss2%tq_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%tq_anom = ss%tq_anom
     IF(.not.partial_copy) THEN
        ss2%id_tq_anom = ss%id_tq_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_tq_trans = 0
  ENDIF
  IF((ALLOCATED(ss%tq_trans).AND.ALLOCATED(ss2%tq_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%tq_trans = ss%tq_trans
     IF(.not.partial_copy) THEN
        ss2%id_tq_trans = ss%id_tq_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_tq_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_tq_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tq_transcat).AND.ALLOCATED(ss2%tq_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%tq_transcat = ss%tq_transcat
     IF(ALLOCATED(ss2%id_tq_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tq_transcat = ss%id_tq_transcat
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%trace_flag)).AND.(ALLOCATED(ss%trace_flag))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%trace_flag = ss%trace_flag
  ENDIF
  IF( ((ALLOCATED(ss2%trcat)).AND.(ALLOCATED(ss%trcat))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%trcat = ss%trcat
  ENDIF
  IF(partial_copy) THEN
     ss2%id_triang = 0
  ENDIF
  IF((ALLOCATED(ss%triang).AND.ALLOCATED(ss2%triang)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%triang = ss%triang
     IF(.not.partial_copy) THEN
        ss2%id_triang = ss%id_triang
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_triangL = 0
  ENDIF
  IF((ALLOCATED(ss%triangL).AND.ALLOCATED(ss2%triangL)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%triangL = ss%triangL
     IF(.not.partial_copy) THEN
        ss2%id_triangL = ss%id_triangL
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_triangU = 0
  ENDIF
  IF((ALLOCATED(ss%triangU).AND.ALLOCATED(ss2%triangU)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%triangU = ss%triangU
     IF(.not.partial_copy) THEN
        ss2%id_triangU = ss%id_triangU
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_triang_miller_L = 0
  ENDIF
  IF((ALLOCATED(ss%triang_miller_L).AND.ALLOCATED(ss2%triang_miller_L)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%triang_miller_L = ss%triang_miller_L
     IF(.not.partial_copy) THEN
        ss2%id_triang_miller_L = ss%id_triang_miller_L
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_triang_miller_U = 0
  ENDIF
  IF((ALLOCATED(ss%triang_miller_U).AND.ALLOCATED(ss2%triang_miller_U)).AND. &
        ((cclist(ps_cnum_EQ).EQ.1))) THEN
     ss2%triang_miller_U = ss%triang_miller_U
     IF(.not.partial_copy) THEN
        ss2%id_triang_miller_U = ss%id_triang_miller_U
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%trmodels)).AND.(ALLOCATED(ss%trmodels))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%trmodels = ss%trmodels
  ENDIF
  IF(ALLOCATED(ss2%id_Ts)) THEN
     IF(partial_copy) THEN
        ss2%id_Ts = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%Ts).AND.ALLOCATED(ss2%Ts)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%Ts = ss%Ts
     IF(ALLOCATED(ss2%id_Ts)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_Ts = ss%id_Ts
        ENDIF
     ENDIF
  ENDIF
  IF((cclist(ps_cnum_PLASMA).EQ.1).OR.(icopy_lists.EQ.1)) THEN
     ss2%Ts_Data_Info = ss%Ts_Data_Info
  ENDIF
  IF( ((ALLOCATED(ss2%Ts_is_input)).AND.(ALLOCATED(ss%Ts_is_input))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_PLASMA).EQ.1)) ) THEN
     ss2%Ts_is_input = ss%Ts_is_input
  ENDIF
  IF(ALLOCATED(ss2%id_tzflux_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_tzflux_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tzflux_ky_tglf).AND.ALLOCATED(ss2%tzflux_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%tzflux_ky_tglf = ss%tzflux_ky_tglf
     IF(ALLOCATED(ss2%id_tzflux_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tzflux_ky_tglf = ss%id_tzflux_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_tz_ky_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_tz_ky_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%tz_ky_tglf).AND.ALLOCATED(ss2%tz_ky_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%tz_ky_tglf = ss%tz_ky_tglf
     IF(ALLOCATED(ss2%id_tz_ky_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_tz_ky_tglf = ss%id_tz_ky_tglf
        ENDIF
     ENDIF
  ENDIF
  IF( ((ALLOCATED(ss2%T_einj_standard)).AND.(ALLOCATED(ss%T_einj_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%T_einj_standard = ss%T_einj_standard
  ENDIF
  IF( ((ALLOCATED(ss2%T_ffull_standard)).AND.(ALLOCATED(ss%T_ffull_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%T_ffull_standard = ss%T_ffull_standard
  ENDIF
  IF( ((ALLOCATED(ss2%T_fhalf_standard)).AND.(ALLOCATED(ss%T_fhalf_standard))).AND. &
       ((icopy_lists.eq.1).OR.(cclist(ps_cnum_NBI).EQ.1)) ) THEN
     ss2%T_fhalf_standard = ss%T_fhalf_standard
  ENDIF
  IF(ALLOCATED(ss2%id_upwind_pfrac_ns)) THEN
     IF(partial_copy) THEN
        ss2%id_upwind_pfrac_ns = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%upwind_pfrac_ns).AND.ALLOCATED(ss2%upwind_pfrac_ns)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%upwind_pfrac_ns = ss%upwind_pfrac_ns
     IF(ALLOCATED(ss2%id_upwind_pfrac_ns)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_upwind_pfrac_ns = ss%id_upwind_pfrac_ns
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_upwind_pfrac_omega = 0
  ENDIF
  IF((ALLOCATED(ss%upwind_pfrac_omega).AND.ALLOCATED(ss2%upwind_pfrac_omega)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%upwind_pfrac_omega = ss%upwind_pfrac_omega
     IF(.not.partial_copy) THEN
        ss2%id_upwind_pfrac_omega = ss%id_upwind_pfrac_omega
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_upwind_pfrac_Te = 0
  ENDIF
  IF((ALLOCATED(ss%upwind_pfrac_Te).AND.ALLOCATED(ss2%upwind_pfrac_Te)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%upwind_pfrac_Te = ss%upwind_pfrac_Te
     IF(.not.partial_copy) THEN
        ss2%id_upwind_pfrac_Te = ss%id_upwind_pfrac_Te
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_upwind_pfrac_Ti = 0
  ENDIF
  IF((ALLOCATED(ss%upwind_pfrac_Ti).AND.ALLOCATED(ss2%upwind_pfrac_Ti)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%upwind_pfrac_Ti = ss%upwind_pfrac_Ti
     IF(.not.partial_copy) THEN
        ss2%id_upwind_pfrac_Ti = ss%id_upwind_pfrac_Ti
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_vee_trans = 0
  ENDIF
  IF((ALLOCATED(ss%vee_trans).AND.ALLOCATED(ss2%vee_trans)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vee_trans = ss%vee_trans
     IF(.not.partial_copy) THEN
        ss2%id_vee_trans = ss%id_vee_trans
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_vee_transcat)) THEN
     IF(partial_copy) THEN
        ss2%id_vee_transcat = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%vee_transcat).AND.ALLOCATED(ss2%vee_transcat)).AND. &
        ((cclist(ps_cnum_PLASMA).EQ.1))) THEN
     ss2%vee_transcat = ss%vee_transcat
     IF(ALLOCATED(ss2%id_vee_transcat)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_vee_transcat = ss%id_vee_transcat
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velb_fusi = 0
  ENDIF
  IF((ALLOCATED(ss%velb_fusi).AND.ALLOCATED(ss2%velb_fusi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velb_fusi = ss%velb_fusi
     IF(.not.partial_copy) THEN
        ss2%id_velb_fusi = ss%id_velb_fusi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velb_nbi = 0
  ENDIF
  IF((ALLOCATED(ss%velb_nbi).AND.ALLOCATED(ss2%velb_nbi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velb_nbi = ss%velb_nbi
     IF(.not.partial_copy) THEN
        ss2%id_velb_nbi = ss%id_velb_nbi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velb_rfmi = 0
  ENDIF
  IF((ALLOCATED(ss%velb_rfmi).AND.ALLOCATED(ss2%velb_rfmi)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velb_rfmi = ss%velb_rfmi
     IF(.not.partial_copy) THEN
        ss2%id_velb_rfmi = ss%id_velb_rfmi
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velne_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%velne_nclass).AND.ALLOCATED(ss2%velne_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velne_nclass = ss%velne_nclass
     IF(.not.partial_copy) THEN
        ss2%id_velne_nclass = ss%id_velne_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velnh_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%velnh_nclass).AND.ALLOCATED(ss2%velnh_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velnh_nclass = ss%velnh_nclass
     IF(.not.partial_copy) THEN
        ss2%id_velnh_nclass = ss%id_velnh_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velni_drbm = 0
  ENDIF
  IF((ALLOCATED(ss%velni_drbm).AND.ALLOCATED(ss2%velni_drbm)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velni_drbm = ss%velni_drbm
     IF(.not.partial_copy) THEN
        ss2%id_velni_drbm = ss%id_velni_drbm
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_anom)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_anom = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_anom).AND.ALLOCATED(ss2%velns_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_anom = ss%velns_anom
     IF(ALLOCATED(ss2%id_velns_anom)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_anom = ss%id_velns_anom
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_glf)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_glf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_glf).AND.ALLOCATED(ss2%velns_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_glf = ss%velns_glf
     IF(ALLOCATED(ss2%id_velns_glf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_glf = ss%id_velns_glf
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_gtcneo)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_gtcneo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_gtcneo).AND.ALLOCATED(ss2%velns_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_gtcneo = ss%velns_gtcneo
     IF(ALLOCATED(ss2%id_velns_gtcneo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_gtcneo = ss%id_velns_gtcneo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_mmm71)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_mmm71 = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_mmm71).AND.ALLOCATED(ss2%velns_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_mmm71 = ss%velns_mmm71
     IF(ALLOCATED(ss2%id_velns_mmm71)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_mmm71 = ss%id_velns_mmm71
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_nclass)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_nclass = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_nclass).AND.ALLOCATED(ss2%velns_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_nclass = ss%velns_nclass
     IF(ALLOCATED(ss2%id_velns_nclass)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_nclass = ss%id_velns_nclass
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_neo)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_neo = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_neo).AND.ALLOCATED(ss2%velns_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_neo = ss%velns_neo
     IF(ALLOCATED(ss2%id_velns_neo)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_neo = ss%id_velns_neo
        ENDIF
     ENDIF
  ENDIF
  IF(ALLOCATED(ss2%id_velns_tglf)) THEN
     IF(partial_copy) THEN
        ss2%id_velns_tglf = 0
     ENDIF
  ENDIF
  IF((ALLOCATED(ss%velns_tglf).AND.ALLOCATED(ss2%velns_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velns_tglf = ss%velns_tglf
     IF(ALLOCATED(ss2%id_velns_tglf)) THEN
        IF(.not.partial_copy) THEN
           ss2%id_velns_tglf = ss%id_velns_tglf
        ENDIF
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velnx_nclass = 0
  ENDIF
  IF((ALLOCATED(ss%velnx_nclass).AND.ALLOCATED(ss2%velnx_nclass)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velnx_nclass = ss%velnx_nclass
     IF(.not.partial_copy) THEN
        ss2%id_velnx_nclass = ss%id_velnx_nclass
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_anom = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_anom).AND.ALLOCATED(ss2%velpphi_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_anom = ss%velpphi_anom
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_anom = ss%id_velpphi_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_glf = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_glf).AND.ALLOCATED(ss2%velpphi_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_glf = ss%velpphi_glf
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_glf = ss%id_velpphi_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_gtcneo).AND.ALLOCATED(ss2%velpphi_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_gtcneo = ss%velpphi_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_gtcneo = ss%id_velpphi_gtcneo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_mmm71 = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_mmm71).AND.ALLOCATED(ss2%velpphi_mmm71)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_mmm71 = ss%velpphi_mmm71
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_mmm71 = ss%id_velpphi_mmm71
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_neo = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_neo).AND.ALLOCATED(ss2%velpphi_neo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_neo = ss%velpphi_neo
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_neo = ss%id_velpphi_neo
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velpphi_tglf = 0
  ENDIF
  IF((ALLOCATED(ss%velpphi_tglf).AND.ALLOCATED(ss2%velpphi_tglf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velpphi_tglf = ss%velpphi_tglf
     IF(.not.partial_copy) THEN
        ss2%id_velpphi_tglf = ss%id_velpphi_tglf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_anom = 0
  ENDIF
  IF((ALLOCATED(ss%velte_anom).AND.ALLOCATED(ss2%velte_anom)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_anom = ss%velte_anom
     IF(.not.partial_copy) THEN
        ss2%id_velte_anom = ss%id_velte_anom
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_glf = 0
  ENDIF
  IF((ALLOCATED(ss%velte_glf).AND.ALLOCATED(ss2%velte_glf)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_glf = ss%velte_glf
     IF(.not.partial_copy) THEN
        ss2%id_velte_glf = ss%id_velte_glf
     ENDIF
  ENDIF
  IF(partial_copy) THEN
     ss2%id_velte_gtcneo = 0
  ENDIF
  IF((ALLOCATED(ss%velte_gtcneo).AND.ALLOCATED(ss2%velte_gtcneo)).AND. &
        ((cclist(ps_cnum_ANOM).EQ.1))) THEN
     ss2%velte_gtcneo = ss%velte_gtcneo
     IF(.not.partial_copy) THEN
        ss2%id_velte_gtcneo = ss%id_velte_gtcneo
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_copy_8

subroutine tdb_merge_chk(a,b,iok)
  !
  ! **generated by gensis_f90.py -- do not edit!
  !
  use trdatbuf_obj
  implicit NONE
 
  type(trdatbuf) :: a,b        ! objects to be compared for merge-ability
  logical, intent(out) :: iok  ! T iff objects can be merged
 
  call tdb_merge_test('LADR_ZA',a%LADR_ZA,b%LADR_ZA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LADR_ZAF',a%LADR_ZAF,b%LADR_ZAF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPDE',a%LAEPDE,b%LAEPDE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPDP',a%LAEPDP,b%LAEPDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPE',a%LAEPE,b%LAEPE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPMAP',a%LAEPMAP,b%LAEPMAP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPMU',a%LAEPMU,b%LAEPMU,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPP',a%LAEPP,b%LAEPP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPSP',a%LAEPSP,b%LAEPSP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAEPTS',a%LAEPTS,b%LAEPTS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAIMPS',a%LAIMPS,b%LAIMPS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LAIMPX',a%LAIMPX,b%LAIMPX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATALP',a%LDATALP,b%LDATALP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATBDI',a%LDATBDI,b%LDATBDI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATCUR',a%LDATCUR,b%LDATCUR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATDFL',a%LDATDFL,b%LDATDFL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATDTG',a%LDATDTG,b%LDATDTG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATDTS',a%LDATDTS,b%LDATDTS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATDTX',a%LDATDTX,b%LDATDTX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATEDI',a%LDATEDI,b%LDATEDI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATEHP',a%LDATEHP,b%LDATEHP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATELI',a%LDATELI,b%LDATELI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATFGW',a%LDATFGW,b%LDATFGW,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATFIE',a%LDATFIE,b%LDATFIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATFMN',a%LDATFMN,b%LDATFMN,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATFMX',a%LDATFMX,b%LDATFMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGAS',a%LDATGAS,b%LDATGAS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGF3',a%LDATGF3,b%LDATGF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGF4',a%LDATGF4,b%LDATGF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGF6',a%LDATGF6,b%LDATGF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGFD',a%LDATGFD,b%LDATGFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGFH',a%LDATGFH,b%LDATGFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGFT',a%LDATGFT,b%LDATGFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATGIE',a%LDATGIE,b%LDATGIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATHAL',a%LDATHAL,b%LDATHAL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATIBM',a%LDATIBM,b%LDATIBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATIEC',a%LDATIEC,b%LDATIEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATIIC',a%LDATIIC,b%LDATIIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATILH',a%LDATILH,b%LDATILH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATL2B',a%LDATL2B,b%LDATL2B,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATLAD',a%LDATLAD,b%LDATLAD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATLID',a%LDATLID,b%LDATLID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATNTX',a%LDATNTX,b%LDATNTX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATOGF',a%LDATOGF,b%LDATOGF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATORC',a%LDATORC,b%LDATORC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPBE',a%LDATPBE,b%LDATPBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPBI',a%LDATPBI,b%LDATPBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPEB',a%LDATPEB,b%LDATPEB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPEC',a%LDATPEC,b%LDATPEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPF0',a%LDATPF0,b%LDATPF0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPFH',a%LDATPFH,b%LDATPFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPFL',a%LDATPFL,b%LDATPFL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPIB',a%LDATPIB,b%LDATPIB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPIC',a%LDATPIC,b%LDATPIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPLF',a%LDATPLF,b%LDATPLF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPLH',a%LDATPLH,b%LDATPLH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATPOS',a%LDATPOS,b%LDATPOS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRBZ',a%LDATRBZ,b%LDATRBZ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRC3',a%LDATRC3,b%LDATRC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRC4',a%LDATRC4,b%LDATRC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRC6',a%LDATRC6,b%LDATRC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRCD',a%LDATRCD,b%LDATRCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRCH',a%LDATRCH,b%LDATRCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRCT',a%LDATRCT,b%LDATRCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRCY',a%LDATRCY,b%LDATRCY,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRMN',a%LDATRMN,b%LDATRMN,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATRTP',a%LDATRTP,b%LDATRTP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSBT',a%LDATSBT,b%LDATSBT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSF3',a%LDATSF3,b%LDATSF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSFA',a%LDATSFA,b%LDATSFA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSFL',a%LDATSFL,b%LDATSFL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSFP',a%LDATSFP,b%LDATSFP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSFT',a%LDATSFT,b%LDATSFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATSP3',a%LDATSP3,b%LDATSP3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTET',a%LDATTET,b%LDATTET,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTGF',a%LDATTGF,b%LDATTGF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTIT',a%LDATTIT,b%LDATTIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTPI',a%LDATTPI,b%LDATTPI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTQT',a%LDATTQT,b%LDATTQT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTRC',a%LDATTRC,b%LDATTRC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTRF',a%LDATTRF,b%LDATTRF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATTXI',a%LDATTXI,b%LDATTXI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATVPH',a%LDATVPH,b%LDATVPH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATVSB',a%LDATVSB,b%LDATVSB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATVSF',a%LDATVSF,b%LDATVSF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATXKF',a%LDATXKF,b%LDATXKF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATZEF',a%LDATZEF,b%LDATZEF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATZFA',a%LDATZFA,b%LDATZFA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATZIM',a%LDATZIM,b%LDATZIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDATZPL',a%LDATZPL,b%LDATZPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDMDF',a%LDMDF,b%LDMDF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDMFR',a%LDMFR,b%LDMFR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDMMX',a%LDMMX,b%LDMMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDMSE',a%LDMSE,b%LDMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDPFC',a%LDPFC,b%LDPFC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LDPFC_PRE',a%LDPFC_PRE,b%LDPFC_PRE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFD0',a%LEFD0,b%LEFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFDB',a%LEFDB,b%LEFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFDP',a%LEFDP,b%LEFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFDQ',a%LEFDQ,b%LEFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFDR',a%LEFDR,b%LEFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LEFDS',a%LEFDS,b%LEFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFAEPA',a%LFAEPA,b%LFAEPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFAEPP',a%LFAEPP,b%LFAEPP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFAXR',a%LFAXR,b%LFAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFBOL',a%LFBOL,b%LFBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFBPA',a%LFBPA,b%LFBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFBPB',a%LFBPB,b%LFBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFD2F',a%LFD2F,b%LFD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDE2',a%LFDE2,b%LFDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDF3',a%LFDF3,b%LFDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDF4',a%LFDF4,b%LFDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDF6',a%LFDF6,b%LFDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDFD',a%LFDFD,b%LFDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDFH',a%LFDFH,b%LFDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFDFT',a%LFDFT,b%LFDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFECA',a%LFECA,b%LFECA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFECB',a%LFECB,b%LFECB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFECF',a%LFECF,b%LFECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFD0',a%LFFD0,b%LFFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFDB',a%LFFDB,b%LFFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFDP',a%LFFDP,b%LFFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFDQ',a%LFFDQ,b%LFFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFDR',a%LFFDR,b%LFFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFDS',a%LFFDS,b%LFFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFEH',a%LFFEH,b%LFFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFFEL',a%LFFEL,b%LFFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFGRB',a%LFGRB,b%LFGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFIBE',a%LFIBE,b%LFIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFIBI',a%LFIBI,b%LFIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFJBM',a%LFJBM,b%LFJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFJEC',a%LFJEC,b%LFJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFJIC',a%LFJIC,b%LFJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLF3',a%LFLF3,b%LFLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLF4',a%LFLF4,b%LFLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLF6',a%LFLF6,b%LFLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLFD',a%LFLFD,b%LFLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLFH',a%LFLFH,b%LFLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLFT',a%LFLFT,b%LFLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLHE',a%LFLHE,b%LFLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFLHJ',a%LFLHJ,b%LFLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFMSE',a%LFMSE,b%LFMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNER',a%LFNER,b%LFNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNI3',a%LFNI3,b%LFNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNI4',a%LFNI4,b%LFNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNI6',a%LFNI6,b%LFNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNID',a%LFNID,b%LFNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNIH',a%LFNIH,b%LFNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNIM',a%LFNIM,b%LFNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNIT',a%LFNIT,b%LFNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFNMR',a%LFNMR,b%LFNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFOMG',a%LFOMG,b%LFOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFPRS',a%LFPRS,b%LFPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFPSI',a%LFPSI,b%LFPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFQBE',a%LFQBE,b%LFQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFQBI',a%LFQBI,b%LFQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFQEC',a%LFQEC,b%LFQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFQIC',a%LFQIC,b%LFQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFQPR',a%LFQPR,b%LFQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFREE',a%LFREE,b%LFREE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFRES',a%LFRES,b%LFRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFRQRFF',a%LFRQRFF,b%LFRQRFF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSBI',a%LFSBI,b%LFSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSIM',a%LFSIM,b%LFSIM,300,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYAXR',a%LFSYAXR,b%LFSYAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYBOL',a%LFSYBOL,b%LFSYBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYBPA',a%LFSYBPA,b%LFSYBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYBPB',a%LFSYBPB,b%LFSYBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYD2F',a%LFSYD2F,b%LFSYD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDE2',a%LFSYDE2,b%LFSYDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDF3',a%LFSYDF3,b%LFSYDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDF4',a%LFSYDF4,b%LFSYDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDF6',a%LFSYDF6,b%LFSYDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDFD',a%LFSYDFD,b%LFSYDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDFH',a%LFSYDFH,b%LFSYDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYDFT',a%LFSYDFT,b%LFSYDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYECF',a%LFSYECF,b%LFSYECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYFEH',a%LFSYFEH,b%LFSYFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYFEL',a%LFSYFEL,b%LFSYFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYGRB',a%LFSYGRB,b%LFSYGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYIBE',a%LFSYIBE,b%LFSYIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYIBI',a%LFSYIBI,b%LFSYIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYJBM',a%LFSYJBM,b%LFSYJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYJEC',a%LFSYJEC,b%LFSYJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYJIC',a%LFSYJIC,b%LFSYJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLF3',a%LFSYLF3,b%LFSYLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLF4',a%LFSYLF4,b%LFSYLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLF6',a%LFSYLF6,b%LFSYLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLFD',a%LFSYLFD,b%LFSYLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLFH',a%LFSYLFH,b%LFSYLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLFT',a%LFSYLFT,b%LFSYLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLHE',a%LFSYLHE,b%LFSYLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYLHJ',a%LFSYLHJ,b%LFSYLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYMSE',a%LFSYMSE,b%LFSYMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNER',a%LFSYNER,b%LFSYNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNI3',a%LFSYNI3,b%LFSYNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNI4',a%LFSYNI4,b%LFSYNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNI6',a%LFSYNI6,b%LFSYNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNID',a%LFSYNID,b%LFSYNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNIH',a%LFSYNIH,b%LFSYNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNIM',a%LFSYNIM,b%LFSYNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNIT',a%LFSYNIT,b%LFSYNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYNMR',a%LFSYNMR,b%LFSYNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYOMG',a%LFSYOMG,b%LFSYOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYPRS',a%LFSYPRS,b%LFSYPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYQBE',a%LFSYQBE,b%LFSYQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYQBI',a%LFSYQBI,b%LFSYQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYQEC',a%LFSYQEC,b%LFSYQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYQIC',a%LFSYQIC,b%LFSYQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYQPR',a%LFSYQPR,b%LFSYQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYRES',a%LFSYRES,b%LFSYRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYSBI',a%LFSYSBI,b%LFSYSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYSIM',a%LFSYSIM,b%LFSYSIM,300,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYTER',a%LFSYTER,b%LFSYTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYTI2',a%LFSYTI2,b%LFSYTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYTQI',a%LFSYTQI,b%LFSYTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYV2F',a%LFSYV2F,b%LFSYV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVB2',a%LFSYVB2,b%LFSYVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVC3',a%LFSYVC3,b%LFSYVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVC4',a%LFSYVC4,b%LFSYVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVC6',a%LFSYVC6,b%LFSYVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVCD',a%LFSYVCD,b%LFSYVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVCH',a%LFSYVCH,b%LFSYVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVCT',a%LFSYVCT,b%LFSYVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVEE',a%LFSYVEE,b%LFSYVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVIE',a%LFSYVIE,b%LFSYVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVMO',a%LFSYVMO,b%LFSYVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVP2',a%LFSYVP2,b%LFSYVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVPO',a%LFSYVPO,b%LFSYVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVPR',a%LFSYVPR,b%LFSYVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYVTR',a%LFSYVTR,b%LFSYVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYZF2',a%LFSYZF2,b%LFSYZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFSYZXR',a%LFSYZXR,b%LFSYZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFTER',a%LFTER,b%LFTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFTI2',a%LFTI2,b%LFTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFTQI',a%LFTQI,b%LFTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFULNB',a%LFULNB,b%LFULNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFV2F',a%LFV2F,b%LFV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVB2',a%LFVB2,b%LFVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVC3',a%LFVC3,b%LFVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVC4',a%LFVC4,b%LFVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVC6',a%LFVC6,b%LFVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVCD',a%LFVCD,b%LFVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVCH',a%LFVCH,b%LFVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVCT',a%LFVCT,b%LFVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVEE',a%LFVEE,b%LFVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVIE',a%LFVIE,b%LFVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVMO',a%LFVMO,b%LFVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVP2',a%LFVP2,b%LFVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVPO',a%LFVPO,b%LFVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVPR',a%LFVPR,b%LFVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFVTR',a%LFVTR,b%LFVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFZF2',a%LFZF2,b%LFZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LFZXR',a%LFZXR,b%LFZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LHLFNB',a%LHLFNB,b%LHLFNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LLIM',a%LLIM,b%LLIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LMOMD',a%LMOMD,b%LMOMD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPELDA',a%LPELDA,b%LPELDA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPHSLH',a%LPHSLH,b%LPHSLH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPMDF',a%LPMDF,b%LPMDF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPMSE',a%LPMSE,b%LPMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPWREC',a%LPWREC,b%LPWREC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPWRLH',a%LPWRLH,b%LPWRLH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPWRNB',a%LPWRNB,b%LPWRNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LPWRRF',a%LPWRRF,b%LPWRRF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRFS',a%LRFS,b%LRFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRMFR',a%LRMFR,b%LRMFR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRMP_BDY1',a%LRMP_BDY1,b%LRMP_BDY1,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRMP_BDY2',a%LRMP_BDY2,b%LRMP_BDY2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRMSE',a%LRMSE,b%LRMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRP2',a%LRP2,b%LRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRPL',a%LRPL,b%LRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LRPSI',a%LRPSI,b%LRPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSEVENT',a%LSEVENT,b%LSEVENT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYAXR',a%LSSYAXR,b%LSSYAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYBOL',a%LSSYBOL,b%LSSYBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYBPA',a%LSSYBPA,b%LSSYBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYBPB',a%LSSYBPB,b%LSSYBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYD2F',a%LSSYD2F,b%LSSYD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDE2',a%LSSYDE2,b%LSSYDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDF3',a%LSSYDF3,b%LSSYDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDF4',a%LSSYDF4,b%LSSYDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDF6',a%LSSYDF6,b%LSSYDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDFD',a%LSSYDFD,b%LSSYDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDFH',a%LSSYDFH,b%LSSYDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYDFT',a%LSSYDFT,b%LSSYDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYECF',a%LSSYECF,b%LSSYECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYFEH',a%LSSYFEH,b%LSSYFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYFEL',a%LSSYFEL,b%LSSYFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYGRB',a%LSSYGRB,b%LSSYGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYIBE',a%LSSYIBE,b%LSSYIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYIBI',a%LSSYIBI,b%LSSYIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYJBM',a%LSSYJBM,b%LSSYJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYJEC',a%LSSYJEC,b%LSSYJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYJIC',a%LSSYJIC,b%LSSYJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLF3',a%LSSYLF3,b%LSSYLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLF4',a%LSSYLF4,b%LSSYLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLF6',a%LSSYLF6,b%LSSYLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLFD',a%LSSYLFD,b%LSSYLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLFH',a%LSSYLFH,b%LSSYLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLFT',a%LSSYLFT,b%LSSYLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLHE',a%LSSYLHE,b%LSSYLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYLHJ',a%LSSYLHJ,b%LSSYLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYMSE',a%LSSYMSE,b%LSSYMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNER',a%LSSYNER,b%LSSYNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNI3',a%LSSYNI3,b%LSSYNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNI4',a%LSSYNI4,b%LSSYNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNI6',a%LSSYNI6,b%LSSYNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNID',a%LSSYNID,b%LSSYNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNIH',a%LSSYNIH,b%LSSYNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNIM',a%LSSYNIM,b%LSSYNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNIT',a%LSSYNIT,b%LSSYNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYNMR',a%LSSYNMR,b%LSSYNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYOMG',a%LSSYOMG,b%LSSYOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYPRS',a%LSSYPRS,b%LSSYPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYQBE',a%LSSYQBE,b%LSSYQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYQBI',a%LSSYQBI,b%LSSYQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYQEC',a%LSSYQEC,b%LSSYQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYQIC',a%LSSYQIC,b%LSSYQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYQPR',a%LSSYQPR,b%LSSYQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYRES',a%LSSYRES,b%LSSYRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYSBI',a%LSSYSBI,b%LSSYSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYSIM',a%LSSYSIM,b%LSSYSIM,300,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYTER',a%LSSYTER,b%LSSYTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYTI2',a%LSSYTI2,b%LSSYTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYTQI',a%LSSYTQI,b%LSSYTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYV2F',a%LSSYV2F,b%LSSYV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVB2',a%LSSYVB2,b%LSSYVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVC3',a%LSSYVC3,b%LSSYVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVC4',a%LSSYVC4,b%LSSYVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVC6',a%LSSYVC6,b%LSSYVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVCD',a%LSSYVCD,b%LSSYVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVCH',a%LSSYVCH,b%LSSYVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVCT',a%LSSYVCT,b%LSSYVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVEE',a%LSSYVEE,b%LSSYVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVIE',a%LSSYVIE,b%LSSYVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVMO',a%LSSYVMO,b%LSSYVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVP2',a%LSSYVP2,b%LSSYVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVPO',a%LSSYVPO,b%LSSYVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVPR',a%LSSYVPR,b%LSSYVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYVTR',a%LSSYVTR,b%LSSYVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYZF2',a%LSSYZF2,b%LSSYZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LSSYZXR',a%LSSYZXR,b%LSSYZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTABORT',a%LTABORT,b%LTABORT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTAEP',a%LTAEP,b%LTAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFD0',a%LTFD0,b%LTFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFDB',a%LTFDB,b%LTFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFDP',a%LTFDP,b%LTFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFDQ',a%LTFDQ,b%LTFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFDR',a%LTFDR,b%LTFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTFDS',a%LTFDS,b%LTFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTHFS',a%LTHFS,b%LTHFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIME1',a%LTIME1,b%LTIME1,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIME2',a%LTIME2,b%LTIME2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMEC',a%LTIMEC,b%LTIMEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMECA',a%LTIMECA,b%LTIMECA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMECB',a%LTIMECB,b%LTIMECB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMLH',a%LTIMLH,b%LTIMLH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMNB',a%LTIMNB,b%LTIMNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMRF',a%LTIMRF,b%LTIMRF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTIMRFF',a%LTIMRFF,b%LTIMRFF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTPSI',a%LTPSI,b%LTPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LTSAW',a%LTSAW,b%LTSAW,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LVLTNB',a%LVLTNB,b%LVLTNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXAXR',a%LXAXR,b%LXAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXBOL',a%LXBOL,b%LXBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXBPA',a%LXBPA,b%LXBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXBPB',a%LXBPB,b%LXBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXD2F',a%LXD2F,b%LXD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDE2',a%LXDE2,b%LXDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDF3',a%LXDF3,b%LXDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDF4',a%LXDF4,b%LXDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDF6',a%LXDF6,b%LXDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDFD',a%LXDFD,b%LXDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDFH',a%LXDFH,b%LXDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXDFT',a%LXDFT,b%LXDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXECF',a%LXECF,b%LXECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFD0',a%LXFD0,b%LXFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFDB',a%LXFDB,b%LXFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFDP',a%LXFDP,b%LXFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFDQ',a%LXFDQ,b%LXFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFDR',a%LXFDR,b%LXFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFDS',a%LXFDS,b%LXFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFEH',a%LXFEH,b%LXFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFEL',a%LXFEL,b%LXFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXFS',a%LXFS,b%LXFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXGRB',a%LXGRB,b%LXGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXIBE',a%LXIBE,b%LXIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXIBI',a%LXIBI,b%LXIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXJBM',a%LXJBM,b%LXJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXJEC',a%LXJEC,b%LXJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXJIC',a%LXJIC,b%LXJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLF3',a%LXLF3,b%LXLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLF4',a%LXLF4,b%LXLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLF6',a%LXLF6,b%LXLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLFD',a%LXLFD,b%LXLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLFH',a%LXLFH,b%LXLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLFT',a%LXLFT,b%LXLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLHE',a%LXLHE,b%LXLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXLHJ',a%LXLHJ,b%LXLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXMMX',a%LXMMX,b%LXMMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXMSE',a%LXMSE,b%LXMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNER',a%LXNER,b%LXNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNI3',a%LXNI3,b%LXNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNI4',a%LXNI4,b%LXNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNI6',a%LXNI6,b%LXNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNID',a%LXNID,b%LXNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNIH',a%LXNIH,b%LXNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNIM',a%LXNIM,b%LXNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNIT',a%LXNIT,b%LXNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXNMR',a%LXNMR,b%LXNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXOMG',a%LXOMG,b%LXOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXPFC',a%LXPFC,b%LXPFC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXPRS',a%LXPRS,b%LXPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXQBE',a%LXQBE,b%LXQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXQBI',a%LXQBI,b%LXQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXQEC',a%LXQEC,b%LXQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXQIC',a%LXQIC,b%LXQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXQPR',a%LXQPR,b%LXQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXRES',a%LXRES,b%LXRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXRP2',a%LXRP2,b%LXRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXRPL',a%LXRPL,b%LXRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSBI',a%LXSBI,b%LXSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSIM',a%LXSIM,b%LXSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYAXR',a%LXSYAXR,b%LXSYAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYBOL',a%LXSYBOL,b%LXSYBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYBPA',a%LXSYBPA,b%LXSYBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYBPB',a%LXSYBPB,b%LXSYBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYD2F',a%LXSYD2F,b%LXSYD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDE2',a%LXSYDE2,b%LXSYDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDF3',a%LXSYDF3,b%LXSYDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDF4',a%LXSYDF4,b%LXSYDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDF6',a%LXSYDF6,b%LXSYDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDFD',a%LXSYDFD,b%LXSYDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDFH',a%LXSYDFH,b%LXSYDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYDFT',a%LXSYDFT,b%LXSYDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYECF',a%LXSYECF,b%LXSYECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYFEH',a%LXSYFEH,b%LXSYFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYFEL',a%LXSYFEL,b%LXSYFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYGRB',a%LXSYGRB,b%LXSYGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYIBE',a%LXSYIBE,b%LXSYIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYIBI',a%LXSYIBI,b%LXSYIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYJBM',a%LXSYJBM,b%LXSYJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYJEC',a%LXSYJEC,b%LXSYJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYJIC',a%LXSYJIC,b%LXSYJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLF3',a%LXSYLF3,b%LXSYLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLF4',a%LXSYLF4,b%LXSYLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLF6',a%LXSYLF6,b%LXSYLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLFD',a%LXSYLFD,b%LXSYLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLFH',a%LXSYLFH,b%LXSYLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLFT',a%LXSYLFT,b%LXSYLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLHE',a%LXSYLHE,b%LXSYLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYLHJ',a%LXSYLHJ,b%LXSYLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYMSE',a%LXSYMSE,b%LXSYMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNER',a%LXSYNER,b%LXSYNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNI3',a%LXSYNI3,b%LXSYNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNI4',a%LXSYNI4,b%LXSYNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNI6',a%LXSYNI6,b%LXSYNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNID',a%LXSYNID,b%LXSYNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNIH',a%LXSYNIH,b%LXSYNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNIM',a%LXSYNIM,b%LXSYNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNIT',a%LXSYNIT,b%LXSYNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYNMR',a%LXSYNMR,b%LXSYNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYOMG',a%LXSYOMG,b%LXSYOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYPRS',a%LXSYPRS,b%LXSYPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYQBE',a%LXSYQBE,b%LXSYQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYQBI',a%LXSYQBI,b%LXSYQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYQEC',a%LXSYQEC,b%LXSYQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYQIC',a%LXSYQIC,b%LXSYQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYQPR',a%LXSYQPR,b%LXSYQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYRES',a%LXSYRES,b%LXSYRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYSBI',a%LXSYSBI,b%LXSYSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYSIM',a%LXSYSIM,b%LXSYSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYTER',a%LXSYTER,b%LXSYTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYTI2',a%LXSYTI2,b%LXSYTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYTQI',a%LXSYTQI,b%LXSYTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYV2F',a%LXSYV2F,b%LXSYV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVB2',a%LXSYVB2,b%LXSYVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVC3',a%LXSYVC3,b%LXSYVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVC4',a%LXSYVC4,b%LXSYVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVC6',a%LXSYVC6,b%LXSYVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVCD',a%LXSYVCD,b%LXSYVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVCH',a%LXSYVCH,b%LXSYVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVCT',a%LXSYVCT,b%LXSYVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVEE',a%LXSYVEE,b%LXSYVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVIE',a%LXSYVIE,b%LXSYVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVMO',a%LXSYVMO,b%LXSYVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVP2',a%LXSYVP2,b%LXSYVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVPO',a%LXSYVPO,b%LXSYVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVPR',a%LXSYVPR,b%LXSYVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYVTR',a%LXSYVTR,b%LXSYVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYZF2',a%LXSYZF2,b%LXSYZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXSYZXR',a%LXSYZXR,b%LXSYZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXTER',a%LXTER,b%LXTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXTI2',a%LXTI2,b%LXTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXTQI',a%LXTQI,b%LXTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXV2F',a%LXV2F,b%LXV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVB2',a%LXVB2,b%LXVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVC3',a%LXVC3,b%LXVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVC4',a%LXVC4,b%LXVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVC6',a%LXVC6,b%LXVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVCD',a%LXVCD,b%LXVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVCH',a%LXVCH,b%LXVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVCT',a%LXVCT,b%LXVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVEE',a%LXVEE,b%LXVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVIE',a%LXVIE,b%LXVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVMO',a%LXVMO,b%LXVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVP2',a%LXVP2,b%LXVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVPO',a%LXVPO,b%LXVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVPR',a%LXVPR,b%LXVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXVTR',a%LXVTR,b%LXVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXZF2',a%LXZF2,b%LXZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXZIMPS',a%LXZIMPS,b%LXZIMPS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXZIMPX',a%LXZIMPX,b%LXZIMPX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXZIMPXS',a%LXZIMPXS,b%LXZIMPXS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LXZXR',a%LXZXR,b%LXZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LYRP2',a%LYRP2,b%LYRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LYRPL',a%LYRPL,b%LYRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LYSIM',a%LYSIM,b%LYSIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LZFS',a%LZFS,b%LZFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('LZPSI',a%LZPSI,b%LZPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('MMAX',a%MMAX,b%MMAX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('MMX_MAXE',a%MMX_MAXE,b%MMX_MAXE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('MTRP2',a%MTRP2,b%MTRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('MTRPL',a%MTRPL,b%MTRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NANTECH_D',a%NANTECH_D,b%NANTECH_D,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NANTICH_D',a%NANTICH_D,b%NANTICH_D,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NANTLH_D',a%NANTLH_D,b%NANTLH_D,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NBDATA',a%NBDATA,b%NBDATA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDEAEP',a%NDEAEP,b%NDEAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDFS',a%NDFS,b%NDFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDMDF',a%NDMDF,b%NDMDF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDMFR',a%NDMFR,b%NDMFR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDMMX',a%NDMMX,b%NDMMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDMSE',a%NDMSE,b%NDMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDPAEP',a%NDPAEP,b%NDPAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDPFC',a%NDPFC,b%NDPFC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NDPFC_PRE',a%NDPFC_PRE,b%NDPFC_PRE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEAEP',a%NEAEP,b%NEAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFD0',a%NEFD0,b%NEFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFDB',a%NEFDB,b%NEFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFDP',a%NEFDP,b%NEFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFDQ',a%NEFDQ,b%NEFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFDR',a%NEFDR,b%NEFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NEFDS',a%NEFDS,b%NEFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NFRBCODE',a%NFRBCODE,b%NFRBCODE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NFRBMODE',a%NFRBMODE,b%NFRBMODE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NGMAX_D',a%NGMAX_D,b%NGMAX_D,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NHECFT',a%NHECFT,b%NHECFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NHFMX',a%NHFMX,b%NHFMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NIMDF',a%NIMDF,b%NIMDF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NISSIM',a%NISSIM,b%NISSIM,300,iok)
  if(.not.iok) return
  call tdb_merge_test('NISX',a%NISX,b%NISX,300,iok)
  if(.not.iok) return
  call tdb_merge_test('NITSIM',a%NITSIM,b%NITSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NITX',a%NITX,b%NITX,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NKAEP',a%NKAEP,b%NKAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NLIM',a%NLIM,b%NLIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NMAPSIM',a%NMAPSIM,b%NMAPSIM,300,iok)
  if(.not.iok) return
  call tdb_merge_test('NMDXKF',a%NMDXKF,b%NMDXKF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NMIMP',a%NMIMP,b%NMIMP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NMOMD',a%NMOMD,b%NMOMD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NMUAEP',a%NMUAEP,b%NMUAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NMZEFF',a%NMZEFF,b%NMZEFF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NNSIM',a%NNSIM,b%NNSIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NPACK',a%NPACK,b%NPACK,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NPAEP',a%NPAEP,b%NPAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NPELDA',a%NPELDA,b%NPELDA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NPMDF',a%NPMDF,b%NPMDF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NPMSE',a%NPMSE,b%NPMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRHIS',a%NRHIS,b%NRHIS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRHIX',a%NRHIX,b%NRHIX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIAXR',a%NRIAXR,b%NRIAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIBOL',a%NRIBOL,b%NRIBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIBPA',a%NRIBPA,b%NRIBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIBPB',a%NRIBPB,b%NRIBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRID2F',a%NRID2F,b%NRID2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDE2',a%NRIDE2,b%NRIDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDF3',a%NRIDF3,b%NRIDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDF4',a%NRIDF4,b%NRIDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDF6',a%NRIDF6,b%NRIDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDFD',a%NRIDFD,b%NRIDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDFH',a%NRIDFH,b%NRIDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIDFT',a%NRIDFT,b%NRIDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIECF',a%NRIECF,b%NRIECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFD0',a%NRIFD0,b%NRIFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFDB',a%NRIFDB,b%NRIFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFDP',a%NRIFDP,b%NRIFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFDQ',a%NRIFDQ,b%NRIFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFDR',a%NRIFDR,b%NRIFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFDS',a%NRIFDS,b%NRIFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFEH',a%NRIFEH,b%NRIFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIFEL',a%NRIFEL,b%NRIFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIGRB',a%NRIGRB,b%NRIGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIIBE',a%NRIIBE,b%NRIIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIIBI',a%NRIIBI,b%NRIIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIJBM',a%NRIJBM,b%NRIJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIJEC',a%NRIJEC,b%NRIJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIJIC',a%NRIJIC,b%NRIJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILF3',a%NRILF3,b%NRILF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILF4',a%NRILF4,b%NRILF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILF6',a%NRILF6,b%NRILF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILFD',a%NRILFD,b%NRILFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILFH',a%NRILFH,b%NRILFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILFT',a%NRILFT,b%NRILFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILHE',a%NRILHE,b%NRILHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRILHJ',a%NRILHJ,b%NRILHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIMSE',a%NRIMSE,b%NRIMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINER',a%NRINER,b%NRINER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINI3',a%NRINI3,b%NRINI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINI4',a%NRINI4,b%NRINI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINI6',a%NRINI6,b%NRINI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINID',a%NRINID,b%NRINID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINIH',a%NRINIH,b%NRINIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINIM',a%NRINIM,b%NRINIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINIT',a%NRINIT,b%NRINIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRINMR',a%NRINMR,b%NRINMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIOMG',a%NRIOMG,b%NRIOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIPRS',a%NRIPRS,b%NRIPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIQBE',a%NRIQBE,b%NRIQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIQBI',a%NRIQBI,b%NRIQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIQEC',a%NRIQEC,b%NRIQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIQIC',a%NRIQIC,b%NRIQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIQPR',a%NRIQPR,b%NRIQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIRES',a%NRIRES,b%NRIRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRISBI',a%NRISBI,b%NRISBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRISIM',a%NRISIM,b%NRISIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NRITER',a%NRITER,b%NRITER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRITI2',a%NRITI2,b%NRITI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRITQI',a%NRITQI,b%NRITQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIV2F',a%NRIV2F,b%NRIV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVB2',a%NRIVB2,b%NRIVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVC3',a%NRIVC3,b%NRIVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVC4',a%NRIVC4,b%NRIVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVC6',a%NRIVC6,b%NRIVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVCD',a%NRIVCD,b%NRIVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVCH',a%NRIVCH,b%NRIVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVCT',a%NRIVCT,b%NRIVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVEE',a%NRIVEE,b%NRIVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVIE',a%NRIVIE,b%NRIVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVMO',a%NRIVMO,b%NRIVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVP2',a%NRIVP2,b%NRIVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVPO',a%NRIVPO,b%NRIVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVPR',a%NRIVPR,b%NRIVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIVTR',a%NRIVTR,b%NRIVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIZF2',a%NRIZF2,b%NRIZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRIZXR',a%NRIZXR,b%NRIZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRMFR',a%NRMFR,b%NRMFR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRMSE',a%NRMSE,b%NRMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRP2',a%NRP2,b%NRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRPL',a%NRPL,b%NRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NRPSI',a%NRPSI,b%NRPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSAWFLAG',a%NSAWFLAG,b%NSAWFLAG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSC',a%NSC,b%NSC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSC_FMT',a%NSC_FMT,b%NSC_FMT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSEVENT',a%NSEVENT,b%NSEVENT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSEVPER',a%NSEVPER,b%NSEVPER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSEVTBL',a%NSEVTBL,b%NSEVTBL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSEVWDS',a%NSEVWDS,b%NSEVWDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSFAST_D',a%NSFAST_D,b%NSFAST_D,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYAXR',a%NSYAXR,b%NSYAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYBOL',a%NSYBOL,b%NSYBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYBPA',a%NSYBPA,b%NSYBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYBPB',a%NSYBPB,b%NSYBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYD2F',a%NSYD2F,b%NSYD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDE2',a%NSYDE2,b%NSYDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDF3',a%NSYDF3,b%NSYDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDF4',a%NSYDF4,b%NSYDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDF6',a%NSYDF6,b%NSYDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDFD',a%NSYDFD,b%NSYDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDFH',a%NSYDFH,b%NSYDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYDFT',a%NSYDFT,b%NSYDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYECF',a%NSYECF,b%NSYECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYFEH',a%NSYFEH,b%NSYFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYFEL',a%NSYFEL,b%NSYFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYGRB',a%NSYGRB,b%NSYGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYIBE',a%NSYIBE,b%NSYIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYIBI',a%NSYIBI,b%NSYIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYJBM',a%NSYJBM,b%NSYJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYJEC',a%NSYJEC,b%NSYJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYJIC',a%NSYJIC,b%NSYJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLF3',a%NSYLF3,b%NSYLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLF4',a%NSYLF4,b%NSYLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLF6',a%NSYLF6,b%NSYLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLFD',a%NSYLFD,b%NSYLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLFH',a%NSYLFH,b%NSYLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLFT',a%NSYLFT,b%NSYLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLHE',a%NSYLHE,b%NSYLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYLHJ',a%NSYLHJ,b%NSYLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYMSE',a%NSYMSE,b%NSYMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNER',a%NSYNER,b%NSYNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNI3',a%NSYNI3,b%NSYNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNI4',a%NSYNI4,b%NSYNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNI6',a%NSYNI6,b%NSYNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNID',a%NSYNID,b%NSYNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNIH',a%NSYNIH,b%NSYNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNIM',a%NSYNIM,b%NSYNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNIT',a%NSYNIT,b%NSYNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYNMR',a%NSYNMR,b%NSYNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYOMG',a%NSYOMG,b%NSYOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYPRS',a%NSYPRS,b%NSYPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYQBE',a%NSYQBE,b%NSYQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYQBI',a%NSYQBI,b%NSYQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYQEC',a%NSYQEC,b%NSYQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYQIC',a%NSYQIC,b%NSYQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYQPR',a%NSYQPR,b%NSYQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYRES',a%NSYRES,b%NSYRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYSBI',a%NSYSBI,b%NSYSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYSIM',a%NSYSIM,b%NSYSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYTER',a%NSYTER,b%NSYTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYTI2',a%NSYTI2,b%NSYTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYTQI',a%NSYTQI,b%NSYTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYV2F',a%NSYV2F,b%NSYV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVB2',a%NSYVB2,b%NSYVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVC3',a%NSYVC3,b%NSYVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVC4',a%NSYVC4,b%NSYVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVC6',a%NSYVC6,b%NSYVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVCD',a%NSYVCD,b%NSYVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVCH',a%NSYVCH,b%NSYVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVCT',a%NSYVCT,b%NSYVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVEE',a%NSYVEE,b%NSYVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVIE',a%NSYVIE,b%NSYVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVMO',a%NSYVMO,b%NSYVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVP2',a%NSYVP2,b%NSYVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVPO',a%NSYVPO,b%NSYVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVPR',a%NSYVPR,b%NSYVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYVTR',a%NSYVTR,b%NSYVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYZF2',a%NSYZF2,b%NSYZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NSYZXR',a%NSYZXR,b%NSYZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTABORT',a%NTABORT,b%NTABORT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTAEP',a%NTAEP,b%NTAEP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFD0',a%NTFD0,b%NTFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFDB',a%NTFDB,b%NTFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFDP',a%NTFDP,b%NTFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFDQ',a%NTFDQ,b%NTFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFDR',a%NTFDR,b%NTFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTFDS',a%NTFDS,b%NTFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTHFS',a%NTHFS,b%NTHFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIME1',a%NTIME1,b%NTIME1,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIME2',a%NTIME2,b%NTIME2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMEC',a%NTIMEC,b%NTIMEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMECA',a%NTIMECA,b%NTIMECA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMECB',a%NTIMECB,b%NTIMECB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMLH',a%NTIMLH,b%NTIMLH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMNB',a%NTIMNB,b%NTIMNB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMRF',a%NTIMRF,b%NTIMRF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTIMRFF',a%NTIMRFF,b%NTIMRFF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTPSI',a%NTPSI,b%NTPSI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NTSAW',a%NTSAW,b%NTSAW,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXAXR',a%NXAXR,b%NXAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXBOL',a%NXBOL,b%NXBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXBPA',a%NXBPA,b%NXBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXBPB',a%NXBPB,b%NXBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXD2F',a%NXD2F,b%NXD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDE2',a%NXDE2,b%NXDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDF3',a%NXDF3,b%NXDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDF4',a%NXDF4,b%NXDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDF6',a%NXDF6,b%NXDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDFD',a%NXDFD,b%NXDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDFH',a%NXDFH,b%NXDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXDFT',a%NXDFT,b%NXDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXECF',a%NXECF,b%NXECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFD0',a%NXFD0,b%NXFD0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFDB',a%NXFDB,b%NXFDB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFDP',a%NXFDP,b%NXFDP,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFDQ',a%NXFDQ,b%NXFDQ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFDR',a%NXFDR,b%NXFDR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFDS',a%NXFDS,b%NXFDS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFEH',a%NXFEH,b%NXFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFEL',a%NXFEL,b%NXFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXFS',a%NXFS,b%NXFS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXGRB',a%NXGRB,b%NXGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXIBE',a%NXIBE,b%NXIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXIBI',a%NXIBI,b%NXIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXJBM',a%NXJBM,b%NXJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXJEC',a%NXJEC,b%NXJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXJIC',a%NXJIC,b%NXJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLF3',a%NXLF3,b%NXLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLF4',a%NXLF4,b%NXLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLF6',a%NXLF6,b%NXLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLFD',a%NXLFD,b%NXLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLFH',a%NXLFH,b%NXLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLFT',a%NXLFT,b%NXLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLHE',a%NXLHE,b%NXLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXLHJ',a%NXLHJ,b%NXLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXMMX',a%NXMMX,b%NXMMX,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXMSE',a%NXMSE,b%NXMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNE0',a%NXNE0,b%NXNE0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNER',a%NXNER,b%NXNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNI3',a%NXNI3,b%NXNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNI4',a%NXNI4,b%NXNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNI6',a%NXNI6,b%NXNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNID',a%NXNID,b%NXNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNIH',a%NXNIH,b%NXNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNIM',a%NXNIM,b%NXNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNIT',a%NXNIT,b%NXNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNM0',a%NXNM0,b%NXNM0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXNMR',a%NXNMR,b%NXNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXOMG',a%NXOMG,b%NXOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXPFC',a%NXPFC,b%NXPFC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXPRS',a%NXPRS,b%NXPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXQBE',a%NXQBE,b%NXQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXQBI',a%NXQBI,b%NXQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXQEC',a%NXQEC,b%NXQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXQIC',a%NXQIC,b%NXQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXQPR',a%NXQPR,b%NXQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXRES',a%NXRES,b%NXRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXRP2',a%NXRP2,b%NXRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXRPL',a%NXRPL,b%NXRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSBI',a%NXSBI,b%NXSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSIM',a%NXSIM,b%NXSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYAXR',a%NXSYAXR,b%NXSYAXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYBOL',a%NXSYBOL,b%NXSYBOL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYBPA',a%NXSYBPA,b%NXSYBPA,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYBPB',a%NXSYBPB,b%NXSYBPB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYD2F',a%NXSYD2F,b%NXSYD2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDE2',a%NXSYDE2,b%NXSYDE2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDF3',a%NXSYDF3,b%NXSYDF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDF4',a%NXSYDF4,b%NXSYDF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDF6',a%NXSYDF6,b%NXSYDF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDFD',a%NXSYDFD,b%NXSYDFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDFH',a%NXSYDFH,b%NXSYDFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYDFT',a%NXSYDFT,b%NXSYDFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYECF',a%NXSYECF,b%NXSYECF,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYFEH',a%NXSYFEH,b%NXSYFEH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYFEL',a%NXSYFEL,b%NXSYFEL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYGRB',a%NXSYGRB,b%NXSYGRB,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYIBE',a%NXSYIBE,b%NXSYIBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYIBI',a%NXSYIBI,b%NXSYIBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYJBM',a%NXSYJBM,b%NXSYJBM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYJEC',a%NXSYJEC,b%NXSYJEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYJIC',a%NXSYJIC,b%NXSYJIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLF3',a%NXSYLF3,b%NXSYLF3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLF4',a%NXSYLF4,b%NXSYLF4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLF6',a%NXSYLF6,b%NXSYLF6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLFD',a%NXSYLFD,b%NXSYLFD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLFH',a%NXSYLFH,b%NXSYLFH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLFT',a%NXSYLFT,b%NXSYLFT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLHE',a%NXSYLHE,b%NXSYLHE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYLHJ',a%NXSYLHJ,b%NXSYLHJ,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYMSE',a%NXSYMSE,b%NXSYMSE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNER',a%NXSYNER,b%NXSYNER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNI3',a%NXSYNI3,b%NXSYNI3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNI4',a%NXSYNI4,b%NXSYNI4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNI6',a%NXSYNI6,b%NXSYNI6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNID',a%NXSYNID,b%NXSYNID,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNIH',a%NXSYNIH,b%NXSYNIH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNIM',a%NXSYNIM,b%NXSYNIM,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNIT',a%NXSYNIT,b%NXSYNIT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYNMR',a%NXSYNMR,b%NXSYNMR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYOMG',a%NXSYOMG,b%NXSYOMG,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYPRS',a%NXSYPRS,b%NXSYPRS,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYQBE',a%NXSYQBE,b%NXSYQBE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYQBI',a%NXSYQBI,b%NXSYQBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYQEC',a%NXSYQEC,b%NXSYQEC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYQIC',a%NXSYQIC,b%NXSYQIC,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYQPR',a%NXSYQPR,b%NXSYQPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYRES',a%NXSYRES,b%NXSYRES,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYSBI',a%NXSYSBI,b%NXSYSBI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYSIM',a%NXSYSIM,b%NXSYSIM,8,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYTER',a%NXSYTER,b%NXSYTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYTI2',a%NXSYTI2,b%NXSYTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYTQI',a%NXSYTQI,b%NXSYTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYV2F',a%NXSYV2F,b%NXSYV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVB2',a%NXSYVB2,b%NXSYVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVC3',a%NXSYVC3,b%NXSYVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVC4',a%NXSYVC4,b%NXSYVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVC6',a%NXSYVC6,b%NXSYVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVCD',a%NXSYVCD,b%NXSYVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVCH',a%NXSYVCH,b%NXSYVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVCT',a%NXSYVCT,b%NXSYVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVEE',a%NXSYVEE,b%NXSYVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVIE',a%NXSYVIE,b%NXSYVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVMO',a%NXSYVMO,b%NXSYVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVP2',a%NXSYVP2,b%NXSYVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVPO',a%NXSYVPO,b%NXSYVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVPR',a%NXSYVPR,b%NXSYVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYVTR',a%NXSYVTR,b%NXSYVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYZF2',a%NXSYZF2,b%NXSYZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXSYZXR',a%NXSYZXR,b%NXSYZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXTE0',a%NXTE0,b%NXTE0,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXTER',a%NXTER,b%NXTER,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXTI2',a%NXTI2,b%NXTI2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXTQI',a%NXTQI,b%NXTQI,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXV2F',a%NXV2F,b%NXV2F,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVB2',a%NXVB2,b%NXVB2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVC3',a%NXVC3,b%NXVC3,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVC4',a%NXVC4,b%NXVC4,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVC6',a%NXVC6,b%NXVC6,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVCD',a%NXVCD,b%NXVCD,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVCH',a%NXVCH,b%NXVCH,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVCT',a%NXVCT,b%NXVCT,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVEE',a%NXVEE,b%NXVEE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVIE',a%NXVIE,b%NXVIE,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVMO',a%NXVMO,b%NXVMO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVP2',a%NXVP2,b%NXVP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVPO',a%NXVPO,b%NXVPO,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVPR',a%NXVPR,b%NXVPR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXVTR',a%NXVTR,b%NXVTR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXZEF2',a%NXZEF2,b%NXZEF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXZF2',a%NXZF2,b%NXZF2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NXZXR',a%NXZXR,b%NXZXR,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NYRP2',a%NYRP2,b%NYRP2,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NYRPL',a%NYRPL,b%NYRPL,1,iok)
  if(.not.iok) return
  call tdb_merge_test('NZPSI',a%NZPSI,b%NZPSI,1,iok)
  if(.not.iok) return
 
end subroutine tdb_merge_chk

module tdbsub_uts

  include 'trdatbuf_constants.incl'

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: HALF = 0.5d0
  real*8, parameter :: EPSINV = 1.0d34

  contains
    subroutine tdbsub_lookup(zt,int,zt1,it1,zfrac1)
      ! in ordered time vector zt(1:int) find zone containing zt1
      ! return index and offset fraction in it1 and zfrac1

      ! **zt ordered & zt1 btw zt(1) and zt(int) assumed w/o checking!!

      implicit NONE
      integer, intent(in) :: int
      real*8, intent(in)  :: zt(int)
      real*8, intent(in) :: zt1
      integer, intent(out) :: it1
      real*8, intent(out) :: zfrac1

      if(zt1.le.zt(1)) then
         it1=1
         zfrac1=0
         return
      else if(zt1.ge.zt(int)) then
         it1=int-1
         zfrac1=1
         return
      endif

      it1 = 1 + (zt1-zt(1))*(int-1)/(zt(int)-zt(1))
      it1 = max(1,min((int-1),it1))
      do
         if(zt1.lt.zt(it1)) then
            it1=it1-1
         else if(zt1.gt.zt(it1+1)) then
            it1=it1+1
         else
            exit
         endif
      enddo
      zfrac1=(zt1-zt(it1))/(zt(it1+1)-zt(it1))

    end subroutine tdbsub_lookup

end module tdbsub_uts

subroutine splitn_f77(zfile,ios)

  use splitn_module
  implicit NONE

  character*(*), intent(in) :: zfile   ! filename of file to write
  integer, intent(out) :: ios          ! status code, 0=OK

  !  write f77-style fortran-readable TRANSP namelist (TR.ZDA file)
  !  only namelist elements with non-default values are written.  All
  !  namelists are written but some may be empty.

  !----------------------------
  integer i,inaml,ivar,jj,ilen,ilenp,ilname,isize,irank,inrank
  integer ilina0,ilina1,ilina,ilin,iw1,iw2
  integer indx(maxrank)
  character*10 ibuf
  character*40 indxbuf
  character*40 zname
  !----------------------------

  open(unit=lun,file=zfile,status='new',iostat=ios)
  if(ios.ne.0) return

  do inaml=1,nnamls
     ! loop over individual namelists

     cur_naml=all_namls(inaml)
     write(lun,'(1x,"&",a)') cur_naml(1:len_trim(cur_naml))

     do ivar = 1,nvars
        jj = var_order(ivar)  ! in alphabetic order

        ! loop over all namelist variables, selecting those from the
        ! current namelist

        if(cur_naml.eq.varlist(jj)%naml) then

           ! got one.  Compute size & initial indexing
           zname = varlist(jj)%name
           ilname = len_trim(zname)

           inrank=varlist(jj)%rank
           isize=1
           indx=0
           do irank=1,inrank
              isize= isize* &
                   (varlist(jj)%dims(2,irank)-varlist(jj)%dims(1,irank)+1)
              indx(irank)=varlist(jj)%dims(1,irank)
           enddo
           if(inrank.gt.0) indx(1)=indx(1)-1

           ilina0=varlist(jj)%nlinadr
           ilina1=ilina0+isize-1

           do ilina=ilina0,ilina1
              !  loop over elements (indexing; bounds check was done
              !  when namelist was read).

              if(inrank.gt.0) then
                 irank=1
                 do
                    indx(irank)=indx(irank)+1
                    if(indx(irank).le.varlist(jj)%dims(2,irank)) then
                       exit
                    else
                       indx(irank)=varlist(jj)%dims(1,irank)
                       irank=irank+1   ! carry to next dimension
                    endif
                 enddo
              endif
              !  loop over elements (line references)
              if(ilines(ilina).gt.0) then
                 ilin=ordl(ilines(ilina))
                 if(ivrange(1,ilina).gt.0) then
                    iw1=ivrange(1,ilina)
                    iw2=ivrange(2,ilina)
                    ! we have a non-default value to write...

                    if(inrank.eq.0) then
                       ! scalar write

                       write(lun,'(2x,a,"=",a)') &
                            zname(1:ilname),textnl(ilin)(iw1:iw2)

                    else
                       ! array element write: generate index;
                       ! no imbedded blanks.
                       indxbuf='('  ! start of index expression in char form

                       ilen=1
                       do irank=1,inrank
                          ibuf=' '
                          write(ibuf,'(I10)') indx(irank) ! right justified
                          do i=10,1,-1
                             if(ibuf(i:i).eq.' ') then
                                ilenp=ilen
                                ilen=ilenp+(10-i)
                                indxbuf(ilenp+1:ilen)=ibuf(i+1:10) ! copy in
                                exit
                             endif
                          enddo
                          ilen=ilen+1
                          if(irank.lt.inrank) then
                             indxbuf(ilen:ilen)=','
                          else
                             indxbuf(ilen:ilen)=')'
                          endif
                       enddo

                       write(lun,'(1x,a,a,"=",a)') &
                            zname(1:ilname),indxbuf(1:ilen), &
                            textnl(ilin)(iw1:iw2)
                    endif  ! scalar/array
                 endif  ! value in file
              endif  ! element reference in file

           enddo  ! loop over elements of namelist item

        endif  ! item is in current namelist
     enddo  ! loop over all  namelist items

     write(lun,'(1x,"/")')

  enddo  ! loop over all namelists

  close(unit=lun)

end subroutine splitn_f77

subroutine trx_spec_lbl(maxn,n_species,slbl,itype,Zr8,Ar8,IZc)
!
!  return the number of plasma species, and,
!  return a character*20 label for each plasma species present in the run, and,
!  return a (real*8) Z and A for each specie and IZc atomic number
!
!  for some model species, Z and A vary in time; therefore the time must
!  be selected before this routine is called.
!
  use trx_module
!
  implicit NONE
  integer, intent(in) :: maxn   ! max no. of species (dimension of slbl)
  integer, intent(out) :: n_species   ! actual no. of species found
  character*20, intent(out) :: slbl(maxn)   ! the species labels
  integer, intent(out) :: itype(maxn) ! type code of species (see below)
  real*8, intent(out) :: Zr8(maxn)    ! Z of species
  real*8, intent(out) :: Ar8(maxn)    ! A of species
  integer,intent(out) :: IZc(maxn)    ! atomic number of species
!
! return n_species=0 if an error occurs
!
! itype codes:  for j'th specie:
!
!   itype(j)=-1  -- electrons
!
!   itype(j)=+1  -- non-impurity thermal specie, usually H or He isotope
!                   can be Li
!   itype(j)=+2  -- impurity thermal specie:  Z and A are known, constant
!
!   itype(j)=+3  -- impurity thermal specie:  Z and A are functions of time
!                   "model impurity" -- could represent a hybrid; non-integer
!                   Z and A values possible.
!
!   itype(j)=+4  -- beam ion specie
!   itype(j)=+5  -- rf tail ion specie
!   itype(j)=+6  -- fusion product ion specie
!
!   NOTE ordering on output lists:
!     electrons
!     then non-impurity thermal ions
!     them impurity thermal ions
!     then non-thermal ions
!---------------------------------------
  character*10, dimension(:,:), allocatable :: abray
  integer, dimension(:), allocatable :: ifast
  real, dimension(:), allocatable :: aar4,zzr4
  integer i,iersum,ierr
  integer lunzer
  character*16 zunits
!---------------------------------------
!
  slbl=' '
  call trx_nspec(n_species)
  if(n_species.eq.0) return
  if(n_species.gt.maxn) then
     write(lunzer(0),*) '?trx_spec_lbl:  maxn=',maxn,' but: n_species=', &
          n_species
     n_species=0
     return
  endif
!
  if(itset.eq.0) then
     write(lunzer(0),*) '?trx_spec_lbl:  "time of interest" not yet selected.'
     n_species=0
     return
  endif
!
  allocate(abray(4,n_species))
  allocate(ifast(n_species))
  allocate(aar4(n_species),zzr4(n_species))
!
  call rd_species(n_species,n_species,slbl,abray,itype,ifast,zzr4,aar4,IZc)
  if(n_species.le.0) then
     n_species=0
  else
     iersum=0
     Zr8(1:n_species)=zzr4
     Ar8(1:n_species)=aar4
     do i=1,n_species
        if(itype(i).eq.3) then
           call trx_scal('XZIMP',zunits,Zr8(i),ierr)
           if(ierr.ne.0) iersum=iersum+1
           call trx_scal('AIMP',zunits,Ar8(i),ierr)
           if(ierr.ne.0) iersum=iersum+1
           IZc(i) = nint(Zr8(i))
        endif
     enddo
     if(iersum.gt.0) then
        write(lunzer(0),*) &
             '?trx_spec_lbl:  "AIMP" or "XZIMP" signals (f(t)) not found.'
        n_species=0
     endif
  endif
!
  deallocate(abray)
  deallocate(ifast)
  deallocate(aar4,zzr4)
!
end subroutine trx_spec_lbl

subroutine phcdf_define_int(ncid,name,inval)
  !  phcdf_define -- Define Variables and Dimensions for NetCDF Dataset
  !    routine is called from generated subroutine trdatbuf_def_cdf
  !   Routine supports only scalar and 1D array integer data
  !
  implicit none
  include 'netcdf.inc'
 
  integer ncid, inval, nvdims, dimid, status, varid
  character*(*) name
  integer, dimension(1) :: vdims ! vector of dimension IDs corresponding to variable dimensions
  character*13 :: dimnam
  integer :: lunmsg_tdb ! integer function lunmsg_tdb(idum)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to write
  !  inval -- dimension  of item (integer array) to write
 
  if(inval.eq.1)then ! define integer scalar
    nvdims = 0
  elseif(inval.gt.1)then ! define 1D integer array
    nvdims = 1
    !
    !  Create and Define Dimension
    if(inval.le.99999)then
      write(dimnam,"('dim_',i5.5)") inval
    elseif(inval.le.999999999)then
      write(dimnam,"('dim_',i9.9)") inval
    else
      write(lunmsg_tdb(0),*) ' ?phcdf_define_int: dimension > 1e9 not supported '
      return
    endif
    !
    status = nf_inq_dimid(ncid, dimnam, dimid)
    if(status .ne. NF_NOERR)then   ! define dimension
       status = nf_def_dim(ncid, dimnam, inval, dimid)
    endif
    vdims(1) = dimid  ! dimension ID for first (and only) dimension
  else
      write(lunmsg_tdb(0),*) ' ?phcdf_define_int: dimension < 0 not supported '
      return
  endif
  status = nf_def_var(ncid, name, NF_INT, nvdims, vdims, varid)
  !
  return
end subroutine phcdf_define_int
 
subroutine phcdf_write_int(ncid,name,ival,inval)
  !  phcdf_write -- write operation on ph.cdf file
  !    routine is called from generated subroutine trdatbuf_wr_cdf
  !
  implicit none
  include 'netcdf.inc'
 
  integer inval,ncid, status, varid
  character*(*) name
  integer ival(inval)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to write
  !  ival(inval) -- dimension and value of item (integer array) to write
 
  status = nf_inq_varid(ncid, name, varid)
  status = nf_put_var_int(ncid, varid, ival)
  !
  return
end subroutine phcdf_write_int
 
subroutine phcdf_read_int(ncid,name,ival,inval,ier)
  !  phcdf_read -- read operation on ph.cdf file
  !    routine is called from generated subroutine trdatbuf_rd_cdf
  !
  implicit none
  include 'netcdf.inc'
 
  integer inval,ier,ncid, status, varid
  character*(*) name
  integer ival(inval)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to read
  !  ival(inval) -- dimension and value of item (integer array) to read
  !  ier -- error code 0=OK, 1=Data Not Found, 2=Error Reading Data
 
  ier = 0
  ival = 0 ! clear item to zero
  status = nf_inq_varid(ncid, name, varid)
  if(status.eq.NF_NOERR)then ! data present, now read it
    status = nf_get_var_int(ncid, varid, ival)
    if(status.ne.NF_NOERR)ier = 2 ! error reading data
  else
    ier = 1 ! no data found
    return
  endif
  !
  return
end subroutine phcdf_read_int
 
 
subroutine phcdf_define_double(ncid,name,inval)
  !  phcdf_define -- Define Variables and Dimensions for NetCDF Dataset
  !    routine is called from generated subroutine trdatbuf_def_cdf
  !   Routine supports only scalar and 1D array double data
  !
  implicit none
  include 'netcdf.inc'
 
  integer ncid, inval, nvdims, dimid, status, varid
  character*(*) name
  integer, dimension(1) :: vdims ! vector of dimension IDs corresponding to variable dimensions
  character*13 :: dimnam
     integer :: lunmsg_tdb ! integer function lunmsg_tdb(idum)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to write
  !  inval -- dimension  of item (real*8 array) to write
 
  if(inval.eq.1)then ! define real*8 scalar
    nvdims = 0
  elseif(inval.gt.1)then ! define 1D real*8 array
    nvdims = 1
    !
    !  Create and Define Dimension
    if(inval.le.99999)then
      write(dimnam,"('dim_',i5.5)") inval
    elseif(inval.le.999999999)then
      write(dimnam,"('dim_',i9.9)") inval
    else
      write(lunmsg_tdb(0),*) ' ?phcdf_define_double: dimension > 1e9 not supported '
      return
    endif
    !
    status = nf_inq_dimid(ncid, dimnam, dimid)
    if(status .ne. NF_NOERR)then   ! define dimension
       status = nf_def_dim(ncid, dimnam, inval, dimid)
    endif
    vdims(1) = dimid  ! dimension ID for first (and only) dimension
  else
      write(lunmsg_tdb(0),*) ' ?phcdf_define_double: dimension < 0 not supported '
      return
  endif
  status = nf_def_var(ncid, name, NF_DOUBLE, nvdims, vdims, varid)
  !
  return
end subroutine phcdf_define_double
 
subroutine phcdf_write_double(ncid,name,val,inval)
  !  phcdf_write -- write operation on ph.cdf file
  !    routine is called from generated subroutine trdatbuf_wr_cdf
  !
  implicit none
  include 'netcdf.inc'
 
  integer inval,ncid, status, varid
  character*(*) name
  real*8 val(inval)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to write
  !  val(inval) -- dimension and value of item (real*8 array) to write
 
  status = nf_inq_varid(ncid, name, varid)
  status = nf_put_var_double(ncid, varid, val)
  !
  return
end subroutine phcdf_write_double
 
subroutine phcdf_read_double(ncid,name,val,inval,ier)
  !  phcdf_read -- read operation on ph.cdf file
  !    routine is called from generated subroutine trdatbuf_rd_cdf
  !
  implicit none
  include 'netcdf.inc'
 
  integer inval,ier,ncid, status, varid
  character*(*) name
  real*8 val(inval)
  !
  !  ncid -- identifier of open ph.cdf file
  !  name -- character*(*) name of item to read
  !  val(inval) -- dimension and value of item (real*8 array) to read
  !  ier -- error code 0=OK, 1=Data Not Found, 2=Error Reading Data
 
  ier = 0
  status = nf_inq_varid(ncid, name, varid)
  if(status.eq.NF_NOERR)then ! data present, now read it
    status = nf_get_var_double(ncid, varid, val)
    if(status.ne.NF_NOERR)ier = 2 ! error reading data
  else
    ier = 1 ! no data found
    return
  endif
  !
  return
end subroutine phcdf_read_double
subroutine trdatbuf_open(filename,mode,ncid)
  !
  ! OPEN trdatbuf NetCDF file
  !
  implicit none
  include 'netcdf.inc'
  character*(*), intent(in) :: filename ! path to NetCDF file
  character*(*), intent(in) :: mode     ! "r" or "R" for read
                                        ! "w" or "W" for write
  integer, intent(out) :: ncid          ! NetCDF channel # returned
  ! note: if the NetCDF open fails, ncid=0 is returned.

  integer :: status
 
  ncid=0
  if(mode.eq.'w' .or.  mode.eq.'W')then
    status = nf_create(filename, NF_CLOBBER, ncid)
    if(status.ne.NF_NOERR) ncid=0
  elseif(mode.eq.'r' .or.  mode.eq.'R')then
    status = nf_open(filename, NF_NOWRITE, ncid)
    if(status.ne.NF_NOERR) ncid=0
  endif
 
end subroutine trdatbuf_open
 
!-----------------------------------------
 
subroutine trdatbuf_close(ncid)
  !
  ! CLOSE trdatbuf NetCDF file
  !
  implicit none
  include 'netcdf.inc'
  integer, intent(inout) :: ncid

  integer :: status
 
  status = nf_close(ncid)
  ncid=0
 
end subroutine trdatbuf_close

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_get_8(ss,icdf,version_change,iout,iertot)


  !  read subset of variables and arrays from NetCDF file

  USE plasma_state_definition_mod
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to read
  INTEGER, INTENT(IN) :: icdf   ! NetCDF file ID
  LOGICAL, INTENT(IN) :: version_change  ! flag file/software version mismatch
  INTEGER, INTENT(IN) :: iout   ! message LUN
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !--------------

  INTEGER :: varid,dimid,status,ilen,jlen,idims(20),indim
  INTEGER :: ii,iflag_alloc2,iflag_loc2,isize
  CHARACTER*80 :: nc_errmsg

  !--------------


  !-----------------------------------------------
  ! NetCDF reads...

  status = nf90_inq_varid(icdf,"tfinal",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"tfinal")
  ELSE
     status = nf90_get_var(icdf,varid,ss%tfinal)
     IF(status.NE.NF90_NOERR) THEN
        ss%tfinal = 0.0_rspec
        CALL ncerr_name(2,status,"tfinal")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tfrip2_log)) THEN
     status = nf90_inq_varid(icdf,"tfrip2_log",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tfrip2_log")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tfrip2_log)
        IF(status.NE.NF90_NOERR) THEN
           ss%tfrip2_log = 0.0_rspec
           CALL ncerr_name(2,status,"tfrip2_log")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tfrip_log)) THEN
     status = nf90_inq_varid(icdf,"tfrip_log",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tfrip_log")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tfrip_log)
        IF(status.NE.NF90_NOERR) THEN
           ss%tfrip_log = 0.0_rspec
           CALL ncerr_name(2,status,"tfrip_log")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"TF_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"TF_Data_Info")
  ELSE
     ilen = len(ss%TF_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%TF_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%TF_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%TF_Data_Info = " "
        CALL ncerr_name(2,status,"TF_Data_Info")
     ELSE
        CALL denull(ss%TF_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%thegrilh)) THEN
     status = nf90_inq_varid(icdf,"thegrilh",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"thegrilh")
     ELSE
        status = nf90_get_var(icdf,varid,ss%thegrilh)
        IF(status.NE.NF90_NOERR) THEN
           ss%thegrilh = 0.0_rspec
           CALL ncerr_name(2,status,"thegrilh")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%th_eq)) THEN
     status = nf90_inq_varid(icdf,"th_eq",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"th_eq")
     ELSE
        status = nf90_get_var(icdf,varid,ss%th_eq)
        IF(status.NE.NF90_NOERR) THEN
           ss%th_eq = 0.0_rspec
           CALL ncerr_name(2,status,"th_eq")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ti)) THEN
     status = nf90_inq_varid(icdf,"Ti",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Ti")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Ti)
        IF(status.NE.NF90_NOERR) THEN
           ss%Ti = 0.0_rspec
           CALL ncerr_name(2,status,"Ti")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tiflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tiflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tiflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tiflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%tiflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"tiflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tinit",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"tinit")
  ELSE
     status = nf90_get_var(icdf,varid,ss%tinit)
     IF(status.NE.NF90_NOERR) THEN
        ss%tinit = 0.0_rspec
        CALL ncerr_name(2,status,"tinit")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ti_bdy",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Ti_bdy")
  ELSE
     status = nf90_get_var(icdf,varid,ss%Ti_bdy)
     IF(status.NE.NF90_NOERR) THEN
        ss%Ti_bdy = 0.0_rspec
        CALL ncerr_name(2,status,"Ti_bdy")
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%ti_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"ti_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"ti_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%ti_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%ti_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"ti_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tmodel)) THEN
     status = nf90_inq_varid(icdf,"tmodel",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tmodel")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tmodel)
        IF(status.NE.NF90_NOERR) THEN
           ss%tmodel = 0.0_rspec
           CALL ncerr_name(2,status,"tmodel")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel_bdy",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"tmodel_bdy")
  ELSE
     status = nf90_get_var(icdf,varid,ss%tmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        ss%tmodel_bdy = 0.0_rspec
        CALL ncerr_name(2,status,"tmodel_bdy")
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tokamak_id",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"tokamak_id")
  ELSE
     ilen = len(ss%tokamak_id)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%tokamak_id = " "
     status = nf90_get_var(icdf,varid,ss%tokamak_id(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%tokamak_id = " "
        CALL ncerr_name(2,status,"tokamak_id")
     ELSE
        CALL denull(ss%tokamak_id)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Tornum_balcrit)) THEN
     status = nf90_inq_varid(icdf,"Tornum_balcrit",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Tornum_balcrit")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Tornum_balcrit)
        IF(status.NE.NF90_NOERR) THEN
           ss%Tornum_balcrit = 0
           CALL ncerr_name(2,status,"Tornum_balcrit")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_label)) THEN
     status = nf90_inq_varid(icdf,"Tor_mode_label",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Tor_mode_label")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Tor_mode_label)
        IF(status.NE.NF90_NOERR) THEN
           ss%Tor_mode_label = " "
           CALL ncerr_name(2,status,"Tor_mode_label")
        ELSE
           CALL denull_vec(ss%Tor_mode_label,ss%mmodes)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Tor_mode_No)) THEN
     status = nf90_inq_varid(icdf,"Tor_mode_No",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Tor_mode_No")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Tor_mode_No)
        IF(status.NE.NF90_NOERR) THEN
           ss%Tor_mode_No = 0
           CALL ncerr_name(2,status,"Tor_mode_No")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq0_reco)) THEN
     status = nf90_inq_varid(icdf,"tq0_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tq0_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tq0_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%tq0_reco = 0.0_rspec
           CALL ncerr_name(2,status,"tq0_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqb0_halo)) THEN
     status = nf90_inq_varid(icdf,"tqb0_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqb0_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqb0_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqb0_halo = 0.0_rspec
           CALL ncerr_name(2,status,"tqb0_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbe)) THEN
     status = nf90_inq_varid(icdf,"tqbe",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqbe")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqbe)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqbe = 0.0_rspec
           CALL ncerr_name(2,status,"tqbe")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbi)) THEN
     status = nf90_inq_varid(icdf,"tqbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqbi = 0.0_rspec
           CALL ncerr_name(2,status,"tqbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbjxb)) THEN
     status = nf90_inq_varid(icdf,"tqbjxb",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqbjxb")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqbjxb)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqbjxb = 0.0_rspec
           CALL ncerr_name(2,status,"tqbjxb")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqbth)) THEN
     status = nf90_inq_varid(icdf,"tqbth",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqbth")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqbth)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqbth = 0.0_rspec
           CALL ncerr_name(2,status,"tqbth")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqcx_halo)) THEN
     status = nf90_inq_varid(icdf,"tqcx_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqcx_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqcx_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqcx_halo = 0.0_rspec
           CALL ncerr_name(2,status,"tqcx_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqcx_reco)) THEN
     status = nf90_inq_varid(icdf,"tqcx_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqcx_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqcx_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqcx_reco = 0.0_rspec
           CALL ncerr_name(2,status,"tqcx_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqioniz)) THEN
     status = nf90_inq_varid(icdf,"tqioniz",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqioniz")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqioniz)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqioniz = 0.0_rspec
           CALL ncerr_name(2,status,"tqioniz")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqqcx)) THEN
     status = nf90_inq_varid(icdf,"tqqcx",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqqcx")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqqcx)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqqcx = 0.0_rspec
           CALL ncerr_name(2,status,"tqqcx")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqsc_halo)) THEN
     status = nf90_inq_varid(icdf,"tqsc_halo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqsc_halo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqsc_halo)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqsc_halo = 0.0_rspec
           CALL ncerr_name(2,status,"tqsc_halo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tqsc_reco)) THEN
     status = nf90_inq_varid(icdf,"tqsc_reco",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tqsc_reco")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tqsc_reco)
        IF(status.NE.NF90_NOERR) THEN
           ss%tqsc_reco = 0.0_rspec
           CALL ncerr_name(2,status,"tqsc_reco")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_anom)) THEN
     status = nf90_inq_varid(icdf,"tq_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tq_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tq_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%tq_anom = 0.0_rspec
           CALL ncerr_name(2,status,"tq_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_trans)) THEN
     status = nf90_inq_varid(icdf,"tq_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tq_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tq_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%tq_trans = 0.0_rspec
           CALL ncerr_name(2,status,"tq_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tq_transcat)) THEN
     status = nf90_inq_varid(icdf,"tq_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tq_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tq_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%tq_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"tq_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trace_flag)) THEN
     status = nf90_inq_varid(icdf,"trace_flag",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"trace_flag")
     ELSE
        status = nf90_get_var(icdf,varid,ss%trace_flag)
        IF(status.NE.NF90_NOERR) THEN
           ss%trace_flag = 0
           CALL ncerr_name(2,status,"trace_flag")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trcat)) THEN
     status = nf90_inq_varid(icdf,"trcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"trcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%trcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%trcat = " "
           CALL ncerr_name(2,status,"trcat")
        ELSE
           CALL denull_vec(ss%trcat,ss%ntrcat)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang)) THEN
     status = nf90_inq_varid(icdf,"triang",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"triang")
     ELSE
        status = nf90_get_var(icdf,varid,ss%triang)
        IF(status.NE.NF90_NOERR) THEN
           ss%triang = 0.0_rspec
           CALL ncerr_name(2,status,"triang")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triangL)) THEN
     status = nf90_inq_varid(icdf,"triangL",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"triangL")
     ELSE
        status = nf90_get_var(icdf,varid,ss%triangL)
        IF(status.NE.NF90_NOERR) THEN
           ss%triangL = 0.0_rspec
           CALL ncerr_name(2,status,"triangL")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triangU)) THEN
     status = nf90_inq_varid(icdf,"triangU",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"triangU")
     ELSE
        status = nf90_get_var(icdf,varid,ss%triangU)
        IF(status.NE.NF90_NOERR) THEN
           ss%triangU = 0.0_rspec
           CALL ncerr_name(2,status,"triangU")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang_miller_L)) THEN
     status = nf90_inq_varid(icdf,"triang_miller_L",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"triang_miller_L")
     ELSE
        status = nf90_get_var(icdf,varid,ss%triang_miller_L)
        IF(status.NE.NF90_NOERR) THEN
           ss%triang_miller_L = 0.0_rspec
           CALL ncerr_name(2,status,"triang_miller_L")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%triang_miller_U)) THEN
     status = nf90_inq_varid(icdf,"triang_miller_U",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"triang_miller_U")
     ELSE
        status = nf90_get_var(icdf,varid,ss%triang_miller_U)
        IF(status.NE.NF90_NOERR) THEN
           ss%triang_miller_U = 0.0_rspec
           CALL ncerr_name(2,status,"triang_miller_U")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%trmodels)) THEN
     status = nf90_inq_varid(icdf,"trmodels",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"trmodels")
     ELSE
        status = nf90_get_var(icdf,varid,ss%trmodels)
        IF(status.NE.NF90_NOERR) THEN
           ss%trmodels = " "
           CALL ncerr_name(2,status,"trmodels")
        ELSE
           CALL denull_vec(ss%trmodels,ss%ntrcat)
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ts)) THEN
     status = nf90_inq_varid(icdf,"Ts",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Ts")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Ts)
        IF(status.NE.NF90_NOERR) THEN
           ss%Ts = 0.0_rspec
           CALL ncerr_name(2,status,"Ts")
        ENDIF
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_Data_Info",varid)
  IF(status.NE.NF90_NOERR) THEN
     CALL ncerr_name(1,status,"Ts_Data_Info")
  ELSE
     ilen = len(ss%Ts_Data_Info)
     status = nf90_inquire_variable(icdf,varid,ndims=indim,dimids=idims)
     IF((status.EQ.NF90_NOERR).AND.(indim.eq.1)) THEN
        status = nf90_inquire_dimension(icdf,idims(1),len=jlen)
        IF(status.EQ.NF90_NOERR) ilen=min(ilen,jlen)
     ENDIF
     ss%Ts_Data_Info = " "
     status = nf90_get_var(icdf,varid,ss%Ts_Data_Info(1:ilen))
     IF(status.NE.NF90_NOERR) THEN
        ss%Ts_Data_Info = " "
        CALL ncerr_name(2,status,"Ts_Data_Info")
     ELSE
        CALL denull(ss%Ts_Data_Info)
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%Ts_is_input)) THEN
     status = nf90_inq_varid(icdf,"Ts_is_input",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"Ts_is_input")
     ELSE
        status = nf90_get_var(icdf,varid,ss%Ts_is_input)
        IF(status.NE.NF90_NOERR) THEN
           ss%Ts_is_input = 0
           CALL ncerr_name(2,status,"Ts_is_input")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tzflux_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tzflux_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tzflux_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tzflux_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%tzflux_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"tzflux_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%tz_ky_tglf)) THEN
     status = nf90_inq_varid(icdf,"tz_ky_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"tz_ky_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%tz_ky_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%tz_ky_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"tz_ky_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_einj_standard)) THEN
     status = nf90_inq_varid(icdf,"T_einj_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T_einj_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T_einj_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%T_einj_standard = 0.0_rspec
           CALL ncerr_name(2,status,"T_einj_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_ffull_standard)) THEN
     status = nf90_inq_varid(icdf,"T_ffull_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T_ffull_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T_ffull_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%T_ffull_standard = 0.0_rspec
           CALL ncerr_name(2,status,"T_ffull_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%T_fhalf_standard)) THEN
     status = nf90_inq_varid(icdf,"T_fhalf_standard",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"T_fhalf_standard")
     ELSE
        status = nf90_get_var(icdf,varid,ss%T_fhalf_standard)
        IF(status.NE.NF90_NOERR) THEN
           ss%T_fhalf_standard = 0.0_rspec
           CALL ncerr_name(2,status,"T_fhalf_standard")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_ns)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_ns",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"upwind_pfrac_ns")
     ELSE
        status = nf90_get_var(icdf,varid,ss%upwind_pfrac_ns)
        IF(status.NE.NF90_NOERR) THEN
           ss%upwind_pfrac_ns = 0.0_rspec
           CALL ncerr_name(2,status,"upwind_pfrac_ns")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_omega)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_omega",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"upwind_pfrac_omega")
     ELSE
        status = nf90_get_var(icdf,varid,ss%upwind_pfrac_omega)
        IF(status.NE.NF90_NOERR) THEN
           ss%upwind_pfrac_omega = 0.0_rspec
           CALL ncerr_name(2,status,"upwind_pfrac_omega")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Te)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_Te",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"upwind_pfrac_Te")
     ELSE
        status = nf90_get_var(icdf,varid,ss%upwind_pfrac_Te)
        IF(status.NE.NF90_NOERR) THEN
           ss%upwind_pfrac_Te = 0.0_rspec
           CALL ncerr_name(2,status,"upwind_pfrac_Te")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%upwind_pfrac_Ti)) THEN
     status = nf90_inq_varid(icdf,"upwind_pfrac_Ti",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"upwind_pfrac_Ti")
     ELSE
        status = nf90_get_var(icdf,varid,ss%upwind_pfrac_Ti)
        IF(status.NE.NF90_NOERR) THEN
           ss%upwind_pfrac_Ti = 0.0_rspec
           CALL ncerr_name(2,status,"upwind_pfrac_Ti")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vee_trans)) THEN
     status = nf90_inq_varid(icdf,"vee_trans",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vee_trans")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vee_trans)
        IF(status.NE.NF90_NOERR) THEN
           ss%vee_trans = 0.0_rspec
           CALL ncerr_name(2,status,"vee_trans")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%vee_transcat)) THEN
     status = nf90_inq_varid(icdf,"vee_transcat",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"vee_transcat")
     ELSE
        status = nf90_get_var(icdf,varid,ss%vee_transcat)
        IF(status.NE.NF90_NOERR) THEN
           ss%vee_transcat = 0.0_rspec
           CALL ncerr_name(2,status,"vee_transcat")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_fusi)) THEN
     status = nf90_inq_varid(icdf,"velb_fusi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velb_fusi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velb_fusi)
        IF(status.NE.NF90_NOERR) THEN
           ss%velb_fusi = 0.0_rspec
           CALL ncerr_name(2,status,"velb_fusi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_nbi)) THEN
     status = nf90_inq_varid(icdf,"velb_nbi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velb_nbi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velb_nbi)
        IF(status.NE.NF90_NOERR) THEN
           ss%velb_nbi = 0.0_rspec
           CALL ncerr_name(2,status,"velb_nbi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velb_rfmi)) THEN
     status = nf90_inq_varid(icdf,"velb_rfmi",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velb_rfmi")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velb_rfmi)
        IF(status.NE.NF90_NOERR) THEN
           ss%velb_rfmi = 0.0_rspec
           CALL ncerr_name(2,status,"velb_rfmi")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velne_nclass)) THEN
     status = nf90_inq_varid(icdf,"velne_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velne_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velne_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velne_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velne_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velnh_nclass)) THEN
     status = nf90_inq_varid(icdf,"velnh_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velnh_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velnh_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velnh_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velnh_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velni_drbm)) THEN
     status = nf90_inq_varid(icdf,"velni_drbm",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velni_drbm")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velni_drbm)
        IF(status.NE.NF90_NOERR) THEN
           ss%velni_drbm = 0.0_rspec
           CALL ncerr_name(2,status,"velni_drbm")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_anom)) THEN
     status = nf90_inq_varid(icdf,"velns_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_anom = 0.0_rspec
           CALL ncerr_name(2,status,"velns_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_glf)) THEN
     status = nf90_inq_varid(icdf,"velns_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_glf = 0.0_rspec
           CALL ncerr_name(2,status,"velns_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velns_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"velns_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velns_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"velns_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_nclass)) THEN
     status = nf90_inq_varid(icdf,"velns_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velns_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_neo)) THEN
     status = nf90_inq_varid(icdf,"velns_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_neo = 0.0_rspec
           CALL ncerr_name(2,status,"velns_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velns_tglf)) THEN
     status = nf90_inq_varid(icdf,"velns_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velns_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velns_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velns_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"velns_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velnx_nclass)) THEN
     status = nf90_inq_varid(icdf,"velnx_nclass",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velnx_nclass")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velnx_nclass)
        IF(status.NE.NF90_NOERR) THEN
           ss%velnx_nclass = 0.0_rspec
           CALL ncerr_name(2,status,"velnx_nclass")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_anom)) THEN
     status = nf90_inq_varid(icdf,"velpphi_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_anom = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_glf)) THEN
     status = nf90_inq_varid(icdf,"velpphi_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_glf = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velpphi_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_mmm71)) THEN
     status = nf90_inq_varid(icdf,"velpphi_mmm71",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_mmm71")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_mmm71)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_mmm71 = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_mmm71")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_neo)) THEN
     status = nf90_inq_varid(icdf,"velpphi_neo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_neo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_neo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_neo = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_neo")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velpphi_tglf)) THEN
     status = nf90_inq_varid(icdf,"velpphi_tglf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velpphi_tglf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velpphi_tglf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velpphi_tglf = 0.0_rspec
           CALL ncerr_name(2,status,"velpphi_tglf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_anom)) THEN
     status = nf90_inq_varid(icdf,"velte_anom",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_anom")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_anom)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_anom = 0.0_rspec
           CALL ncerr_name(2,status,"velte_anom")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_glf)) THEN
     status = nf90_inq_varid(icdf,"velte_glf",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_glf")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_glf)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_glf = 0.0_rspec
           CALL ncerr_name(2,status,"velte_glf")
        ENDIF
     ENDIF
  ENDIF

  IF(ALLOCATED(ss%velte_gtcneo)) THEN
     status = nf90_inq_varid(icdf,"velte_gtcneo",varid)
     IF(status.NE.NF90_NOERR) THEN
        CALL ncerr_name(1,status,"velte_gtcneo")
     ELSE
        status = nf90_get_var(icdf,varid,ss%velte_gtcneo)
        IF(status.NE.NF90_NOERR) THEN
           ss%velte_gtcneo = 0.0_rspec
           CALL ncerr_name(2,status,"velte_gtcneo")
        ENDIF
     ENDIF
  ENDIF

  CONTAINS
     SUBROUTINE denull_vec(vstr,isize)
        INTEGER, intent(in) :: isize
        CHARACTER*(*) :: vstr(isize)
        INTEGER :: i

        do i=1,isize
           call denull(vstr(i))
        enddo
     END SUBROUTINE denull_vec

     SUBROUTINE denull(str)
        ! convert null characters to blank
        CHARACTER*(*) :: str
        INTEGER :: i

        do i=1,len(str)
           if(ichar(str(i:i)).eq.0) str(i:i)=' '
        enddo
     END SUBROUTINE denull

     SUBROUTINE ncerr_name(itype,status,name)
        INTEGER, INTENT(in) :: itype
        INTEGER, INTENT(in) :: status
        CHARACTER*(*), INTENT(in) :: name

        if(itype.eq.1) then
           write(iout,*) ' %plasma_state_get: warning: variable name = "'// &
                  trim(name)//'":'
        else
           write(iout,*) ' ?plasma_state_get: error: variable name = "'// &
                  trim(name)//'":'
           if(version_change) then
              write(iout,*) '   => version change RECOVERY: variable reset to initial value.'
           else
              iertot = iertot + 1
           endif
        endif
        call ncerr(status)
     END SUBROUTINE ncerr_name

     SUBROUTINE ncerr(status)
        INTEGER, INTENT(in) :: status

        nc_errmsg = NF90_strerror(status)
        write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
     END SUBROUTINE ncerr

END SUBROUTINE plasma_state_get_8

subroutine trx_rzbc_fdiff

  use trx_module
  implicit NONE

  isign_rzbc=-1   ! use finite difference BC on R,Z equilibrium profiles

end subroutine trx_rzbc_fdiff

subroutine trx_rzbc_nknot

  use trx_module
  implicit NONE

  isign_rzbc=1    ! use not a knot BC on R,Z equilibrium profiles

end subroutine trx_rzbc_nknot

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_5(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"ntf_coils",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ntf_coils)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ntf_coils"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nthinlh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nthinlh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nthinlh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Nturns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Nturns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Nturns"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"num_nphi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%num_nphi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: num_nphi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"num_nphi_vac",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%num_nphi_vac)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: num_nphi_vac"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nzflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"nz_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%nz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: nz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"n_straps",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%n_straps)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: n_straps"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0cx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omeg0cx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omeg0cx"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0sc0",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omeg0sc0)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omeg0sc0"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omeg0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omeg0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omeg0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omeg0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omeg0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omegat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omegat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omegat_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omegat_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omegat_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"omega_exb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%omega_exb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: omega_exb"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"p0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%p0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: p0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pb0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbe",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pbe"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pbth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pbth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pcx_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pcx_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"peech",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%peech)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: peech"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"peech_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%peech_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: peech_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pelh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pelh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pelh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pelh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pelh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pelh_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%PEL_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: PEL_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PEL_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%PEL_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: PEL_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pe_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pe_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pe_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pe_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pe_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pe_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pe_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfuse",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pfuse)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pfuse"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pfusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pfusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pfusth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pfusth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pfusth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Phibsc",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Phibsc)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Phibsc"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phiflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%phiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: phiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phigrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%phigrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: phigrilh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"phit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%phit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: phit"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Phi_EC_launch",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Phi_EC_launch)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Phi_EC_launch"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_abs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picrf_abs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picrf_abs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_ext",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picrf_ext)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picrf_ext"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_nphi_srcs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picrf_nphi_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picrf_nphi_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_srcs",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picrf_srcs)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picrf_srcs"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picrf_totals",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picrf_totals)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picrf_totals"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"picth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%picth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: picth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pilh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pilh_src",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pilh_src)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pilh_src"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pi_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pi_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pi_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pi_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pi_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"PLASMA_Code_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%PLASMA_Code_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: PLASMA_Code_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pmine",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pmine)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pmine"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pmini",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pmini)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pmini"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pminth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pminth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pminth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pohme",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pohme)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pohme"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"pot_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%pot_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: pot_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_ec",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%power_ec)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: power_ec"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_ic",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%power_ic)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: power_ic"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_lh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%power_lh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: power_lh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%power_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: power_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"power_nbi_trace",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%power_nbi_trace)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: power_nbi_trace"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%prad)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: prad"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_br",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%prad_br)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: prad_br"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_cy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%prad_cy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: prad_cy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"prad_li",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%prad_li)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: prad_li"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psc_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%psc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psc_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%psc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"psipol",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%psipol)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: psipol"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_5

program trdatbuf_test

  !  test program for trdatbuf module (dmc May 2005 -- rough draft)
  !  zfile passed as first (and only) argument (awb June 2005)

  use trdatbuf_module
  implicit NONE

  type (trdatbuf) :: d    ! trdatbuf buffer object
  type (profget) :: t1    ! object to aid profile interpolation
  type (pwrget) :: zpwr   ! specification of desired power parameters

  !  File containing trdatbuf buffer object (from an NSTX TRANSP run)

  character*20 :: zfile = '112989Z11PH.CDF'
  character*3 :: ext

  integer :: tty = 6
  integer :: lunfile = 99, icdf
  integer :: errct = 0

  integer :: ierr,iwarn,idum,iacur,iavsf,iarbz,iaddr,iz
  integer :: narg, id, iargc, getarg, nlen ! command line arguments

  real*8 :: ztimea,ztimeb     ! start and stop times
  integer :: intime1,intime2  ! time grid sizes

  real*8 :: zta               ! target time for interpolation
  real*8 :: zitem,zrbza

  !  interpolation info:
  integer :: it1,it2
  real*8 :: zf1,zf2

  real*8 :: zr1a,zr2a         ! midplane bdy intercept radii at zta

  logical :: ipresent,iquery

  !----------------------------------------------------
  !  species info

  real*8, dimension(:), allocatable :: aa,zz
  real*8 :: zz1,aa1
  integer :: ilev

  !----------------------------------------------------
  !  a coarse profile grid...
  
  integer, parameter :: nzones = 10

  real*8 :: xi_bdy(nzones+1)
  real*8 :: xi_cen(nzones+1)
  real*8 :: rmajmp(2*nzones+1)
  real*8 :: bmidp(2*nzones+1)

  real*8 :: shif,rcen,rmin,rmin1,shif1

  !----------------------------------------------------
  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE  = 1.0d0
  real*8, parameter :: HALF = 0.5d0
  !----------------------------------------------------

  ! moments info

  !  boundary
  integer :: nmom, im ! total number and index of moments
  integer :: icirc ! flag for circular flux surfaces
  integer :: it  ! time index
  real*8 :: zt  ! time
  real*8 :: zf  ! time scale (offset) factor
  real*8, dimension(:,:), allocatable :: rmcb, ymcb

  ! equilibrium (boundary and interior surfaces)

  real*8, dimension(:,:,:), allocatable :: zrmc2,zymc2 ! asymmetric Fourier moments set at xi bdys
  real*8 :: zdrshaf(nzones+1) ! "Shafranov" shift of interior surfaces
                              ! relative to the boundary surface
  integer :: mj            ! flux surface array dimension for zrmc2,zymc2
  integer :: lcentr        ! index to magnetic axis
  integer :: nzp1          ! no. of surfaces including mag. axis
  integer :: j ! index

  !----------------------------------------------------
  !
  real*8 :: zRi, zYi, rpld ! location for TF ripple and value of ripple

  !----------------------------------------------------
  !
  integer :: ntsaw ! number of sawtooth times in trdatbuf
  integer :: inum ! index for sawtooth time
  real*8, dimension(:), allocatable :: ztimes !  sawtooth times in trdatbuf
  real*8 ::  ztime_prev, ztime ! preceding sawtooth time and next time
  real*8 :: ztime_pre, ztime_post ! sawtooth start and end time

  !----------------------------------------------------
  ! power-channel data
  !
  integer ::  nbeam, ib ! number of beams (or antenna) and index
  real*8, dimension(:), allocatable :: tonarr,toffarr ! on and off time arrays for data channel
  real*8 :: ton, toff !  min on and max off time for power-channel data
  real*8 :: zthresh ! on/off power threshhold
  real*8 :: zdtfix !  time to search from threshhold

  !----------------------------------------------------
  ! look for command line arguments - physics data file
  !
  !RGA: narg = iargc()
  call get_arg_count(narg)
  if(narg.lt.1)then
     write(tty,*) 'usage: trdatbuf_test <run-id>PH.CDF'
     stop
  endif

  !RGA: id=getarg(1,zfile)
  call get_arg(1,zfile)

  !----------------------------------------------------
  !  (re)init trdatbuf object
  
  write(tty,*) ' initializing trdatbuf object... '

  call trdatbuf_init(d)   ! initialize new object (allocate buffers)

  call trdatbuf_reInit(d) ! re-initialize object (deallocate buffers then
  !  execute a call to trdatbuf_init(d)

  !---------------------------------------------------
  !  calls test presence of data -- should be .FALSE., nothing read yet.

  if(.not.tdb_present1(d,'CUR',iaddr)) then
     write(tty,*) ' CUR 1d data not in trdatbuf object (file not yet read)'
  else
     write(tty,*) ' ?? tdb_present1 unexpectedly returned TRUE'
     errct = errct + 1
  endif

  if(.not.tdb_present1(d,'VSF',iaddr)) then
     write(tty,*) ' VSF 1d data not in trdatbuf object (file not yet read)'
  else
     write(tty,*) ' ?? tdb_present1 unexpectedly returned TRUE'
     errct = errct + 1
  endif

  if(.not.tdb_present2(d,'TER',iaddr)) then
     write(tty,*) ' TER 2d data not in trdatbuf object (file not yet read)'
  else
     write(tty,*) ' ?? tdb_present2 unexpectedly returned TRUE'
     errct = errct + 1
  endif

  !---------------------------------------------------
  !  read data

  nlen = len_trim(zfile)
  ext = zfile(nlen-2:nlen)

  if(ext.eq."DAT" .or. ext.eq."dat")then
    open(unit=lunfile,file=zfile,status='old')
    call  trdatbuf_read(lunfile,d,ierr)
    close(lunfile)
  elseif(ext.eq."CDF" .or. ext.eq."cdf")then
    call trdatbuf_open(zfile,"r",icdf)
    call trdatbuf_rd_cdf(icdf,d,ierr)
    call trdatbuf_close(icdf)
  else
     write(tty,*)  ext, ' extension not recognized'
     write(tty,*) 'Please supply a .DAT (ascii) of .cdf (NetCDF) extension'
      stop
  endif

  if(ierr.ne.0) then
     write(tty,*) ' ?? error reading data: ', trim(zfile)
     stop
  else
     write(tty,*) ' '
     write(tty,*) ' file read successful: ', trim(zfile)
     write(tty,*) ' '
  endif

  !---------------------------------------------------
  !  calls test presence of data -- should be .TRUE., data was read.

  if(.not.tdb_present1(d,'CUR',iaddr)) then
     write(tty,*) ' ?? tdb_present1 unexpectedly returned FALSE'
     errct = errct + 1
  else
     write(tty,*) ' CUR 1d data detected in trdatbuf object.'
  endif

  if(.not.tdb_present1(d,'VSF',iaddr)) then
     write(tty,*) ' ?? tdb_present1 unexpectedly returned FALSE'
     errct = errct + 1
  else
     write(tty,*) ' VSF 1d data detected in trdatbuf object.'
  endif

  if(.not.tdb_present1(d,'RBZ',iaddr)) then
     write(tty,*) ' ?? tdb_present1 unexpectedly returned FALSE'
     errct = errct + 1
  else
     write(tty,*) ' RBZ 1d data detected in trdatbuf object.'
  endif

  write(tty,*) ' '

  if(.not.tdb_present2(d,'TER',iaddr)) then
     write(tty,*) ' ?? tdb_present2 unexpectedly returned FALSE'
     errct = errct + 1
  else
     write(tty,*) ' TER 2d data detected in trdatbuf object.'
  endif

  if(.not.tdb_present2(d,'NER',iaddr)) then
     write(tty,*) ' ?? tdb_present2 unexpectedly returned FALSE'
     errct = errct + 1
  else
     write(tty,*) ' NER 2d data detected in trdatbuf object.'
  endif

  !---------------------------------------------------
  !  summary timebase information

  write(tty,*) ' '

  call tdb_tlims(d,ztimea,ztimeb)
  write(tty,*) ' time range of trdatbuf data: ',ztimea,ztimeb

  call tdb_ntimes(d,intime1,intime2)
  write(tty,*) '   no. of pts in f(t) timebase:   ',intime1
  write(tty,*) '   no. of pts in f(x,t) timebase: ',intime2

  zta = (ztimea + ztimeb)*HALF
  write(tty,*) ' time for profile testing:'
  write(tty,*) '   zta = ',zta,' seconds.'

  !---------------------------------------------------
  !  species information

  write(tty,*) ' '

  call tdb_nplas(d,inum)
  write(tty,*) ' Number of (non-impurity) thermal plasma species: ',inum

  allocate(zz(inum),aa(inum))
  call tdb_plas(d,inum,zz,aa,ierr)
  if(ierr.ne.0) then
     write(tty,*) ' ?? tdb_plas returned error code: ',ierr
     errct = errct + 1
  else
     write(tty,*) '   thermal plasma Z values: ',zz
     write(tty,*) '   thermal plasma A values: ',aa
  endif
  deallocate(zz,aa)

  call tdb_nfast(d,inum)
  write(tty,*) ' Number of fast ion species: ',inum

  allocate(zz(inum),aa(inum))
  call tdb_fast(d,inum,zz,aa,ierr)
  if(ierr.ne.0) then
     write(tty,*) ' ?? tdb_plas returned error code: ',ierr
     errct = errct + 1
  else
     write(tty,*) '   fast ion Z values: ',zz
     write(tty,*) '   fast ion A values: ',aa
  endif
  deallocate(zz,aa)

  iquery = tdb_zeff_simple(d,ilev)
  if(iquery) then
     if(ilev.eq.1) then
        write(tty,*) ' tdb_zeff_simple:'
        write(tty,*) '   get Zeff via interpolation of scalar "ZEF" data.'
     else if(ilev.eq.2) then
        write(tty,*) ' tdb_zeff_simple:'
        write(tty,*) '   get Zeff via interpolation of profile "ZF2" data.'
     else
        write(tty,*) ' ?? tdb_zeff_simple should have returned ilev = 1 or 2'
        errct = errct + 1
     endif
  else
     write(tty,*) ' tdb_zeff_simple: Zeff not available by simple interpolation.'
  endif

  iquery = tdb_imp_single(d,zz1,aa1)
  if(iquery) then
     write(tty,*) ' tdb_imp_single: TRANSP run contains a single impurity specie:'
     if(zz1.gt.0.5d0) then
        write(tty,*) '   Z and A of impurity: ',zz1,aa1
     else
        write(tty,*) '   Z and A are scalar functions of time:'
        write(tty,*) '     A=2*Z, Z from "ZIM" data.'
     endif
  else
     write(tty,*) ' tdb_imp_single: TRANSP run contains multiple impurity species.'
  endif

  !---------------------------------------------------
  !  1d data lookup at time zta
  !  note: for efficiency, key lookup should only be done once
  !    per trdatbuf object read, and, one time zone lookup should
  !    be amortized over several 1d time interpolation calls...

  write(tty,*) ' '

  ipresent = tdb_present1(d,'CUR',iacur)   ! iacur returned
  ipresent = tdb_present1(d,'VSF',iavsf)   ! iavsf returned
  ipresent = tdb_present1(d,'RBZ',iarbz)   ! iarbz returned

  call tdb_lookup1(d,zta,it1,it2,zf1,zf2)  ! lookup up time zta
  !  interpolation indices & factors returned: it1,it2,zf1,zf2

  write(tty,*) ' at time: ',zta

  zitem = tdb_fintrp1(d,iacur,it1,it2,zf1,zf2)
  write(tty,*) ' plasma current (A):  ',zitem

  zitem = tdb_fintrp1(d,iavsf,it1,it2,zf1,zf2)
  write(tty,*) ' surface voltage (V): ',zitem

  zitem = tdb_fintrp1(d,iarbz,it1,it2,zf1,zf2)
  write(tty,*) ' R*B_vacuum (cm*T):   ',zitem

  ! save this item for future reference...
  zrbza = zitem 

  !---------------------------------------------------
  call tdb_rmp_bdy(d,zta,zr1a,zr2a)

  write(tty,*) ' at time ',zta,' (s):'
  write(tty,*) '    inner midplane boundary intercept radius (cm): ',zr1a
  write(tty,*) '    outer midplane boundary intercept radius (cm): ',zr2a
  write(tty,*) ' '

  !---------------------------------------------------
  !  profile testing...

  !  INITIALIZATION call -- to support data mapping, this call must
  !  give an upper limit on the number of zones that will ever occur in
  !  a run; it is called once at the start or restart of a simulation...

  call tdb_symini(d,nzones)  ! nzones does not vary in this test program...

  !  sqrt(Phi/Philim) [(normalized toroidal flux)**0.5] radial grid...

  xi_bdy(1)=ZERO
  do iz=1,nzones
     xi_bdy(iz+1)=xi_bdy(iz)+ONE/nzones  ! .1, .2, ... , 1.0
     xi_cen(iz)=HALF*(xi_bdy(iz)+xi_bdy(iz+1))
  enddo
  xi_cen(nzones+1)=xi_bdy(nzones+1)+HALF/nzones  ! half zone beyond boundary...

  !  SIMPLIFICATIONS:
  !  instead of using a real equilibrium, we'll just a shafranof shift
  !  on the midplane; instead of using a real field we'll just use the
  !  vacuum field

  !  at time zta...
  shif=0.15
  rcen = HALF*(zr1a+zr2a)
  rmin = HALF*(zr2a-zr1a)

  !  major radius grid on midplane -- note indices:
  !    1 --> inner plasma midplane boundary intercept
  !    nzones+1 --> magnetic axis
  !    2*nzones+1 --> outer plasma midplane boundary intercept

  rmajmp(nzones+1)=rcen + shif*rmin
  do iz=1,nzones
     rmin1=xi_bdy(iz+1)*rmin
     shif1=(ONE-xi_bdy(iz+1)**2)*shif
     rmajmp(nzones+1-iz) = rcen + shif1*rmin - rmin1
     rmajmp(nzones+1+iz) = rcen + shif1*rmin + rmin1
  enddo

  !  vacuum field:

  bmidp = zrbza/rmajmp

  !  ** profget structure for time zta **

  call tdb_profget_init(t1,nzones,.FALSE.)
  t1%time = zta
  t1%xibdys = xi_bdy
  t1%rmajmp = rmajmp
  t1%bmidp = bmidp

  t1%ibdy = .FALSE.   ! interpolate to zone centers; bdy values set to
                      ! half the sum of values of the adjacent zones

  t1%item = 'NER'     ! identifier for electron density...

  call tdb_profin(d,t1,ierr)
  if(ierr.ne.0) then
     write(tty,*) ' ?? tdb_profin "NER" call failed.'
     errct = errct + 1
  else
     write(tty,*) ' '
     write(tty,*) ' "NER" (electron density) at zone centers & bdys (cm**-3):'
     write(tty,*) ' ...(data mapped to zone centers; bdys interpolated)'
     do iz=1,nzones+1
        write(tty,8888) iz,xi_bdy(iz),t1%data_zb(iz),xi_cen(iz),t1%data_zc(iz)
     enddo
     ! t1%data_zb(1:nzones+1) is also available -- boundary centered data
  endif

  ! now, get the electron temeperature, with a different interpolation option:

  t1%ibdy = .TRUE.    ! interpolate to zone bdys; center values set to 
                      ! half the sum of values of the adjacent bdys

  t1%item = 'TER'

  call tdb_profin(d,t1,ierr)
  if(ierr.ne.0) then
     write(tty,*) ' ?? tdb_profin "NER" call failed.'
     errct = errct + 1
  else
     write(tty,*) ' '
     write(tty,*) ' "TER" (electron temperature) at zone centers & bdys (eV):'
     write(tty,*) ' ...(data mapped to zone bdys; centers interpolated)'
     do iz=1,nzones+1
        write(tty,8888) iz,xi_bdy(iz),t1%data_zb(iz),xi_cen(iz),t1%data_zc(iz)
     enddo
     ! t1%data_zc(1:nzones+1) is also available -- zone centered data
  endif

8888 format(1x,i4,2(2x,2(1x,1pe13.6)))
  write(tty,*) ' '

  !  cleanup... avoid memory leaks!

  call tdb_profget_free(t1)

  !---------------------------------------------------
  !  more queries as to file contents

  ipresent = tdb_logchk_special(d,'RPL',iwarn)
  write(tty,*) ' -> TF field ripple vs. (R,Z) in data file: ',ipresent
  errct = errct + iwarn
  if(ipresent)then
    zRi = zr2a
    zYi = 0.
    rpld=tdb_get_rpld(d,zta,zRi,zYi,ierr)  ! time argument added dmc June 2007
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_get_rpld call failed.'
       errct = errct + 1
    else
      write(tty,*) " TF field ripple ln(B~/B) = ", rpld, " at R,Z = ", zRi,zYi
    endif
  endif

  ipresent = tdb_logchk_special(d,'SAW',iwarn)
  write(tty,*) ' -> sawtooth event times in data file: ',ipresent
  errct = errct + iwarn
  if(ipresent)then
    call tdb_num_sawtimes(d,ntsaw)
    write(tty,*) 'number of sawtooth times in trdat buffer = ', ntsaw

    inum=ntsaw
    allocate(ztimes(ntsaw))
    call tdb_sawtimes(d,ztimes,inum)
    write(tty,*) 'sawtooth times = ', ztimes(1:inum)

    ztime_prev = ztimes(1)
    call tdb_find_next_sawtime(d,ztime_prev,ztime)
    write(tty,*) 'sawtooth time following ', ztime_prev, ' is ', ztime

    ztime_pre = ztimes(1)
    call tdb_post_sawtime(d,ztime_pre,ztime_post,iwarn)
    write(tty,*) ' for sawtooth start time = ', ztime_pre, ' end time = ', ztime_post

    call tdb_post_peltime(d,ztime_pre,ztime_post,iwarn)
    write(tty,*) ' for pellet start time = ', ztime_pre, ' end time = ', ztime_post
  endif

  write(tty,*) ' '

  !--------------------------------------------
  !
  !   ECH/ECCD antenna powers

  ipresent = tdb_logchk_special(d,'ECP',iwarn)
  write(tty,*) ' -> ECH/ECCD antenna powers in data file: ',ipresent
  errct = errct + iwarn
  if(ipresent)then
    nbeam = tdb_nchan_find(d,"EC")
    write(tty,*) 'Number of ECH/ECCD antennae: ', nbeam

    zthresh = 0.10
    zdtfix = 10.
    allocate(tonarr(nbeam), toffarr(nbeam))
    call tdb_onoff_atime(d,"EC",zthresh,zdtfix,ton   ,toff   ,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_atime call failed.'
       errct = errct + 1
    else
       write(tty,*) "EC min on/max off time = ", ton, toff
    endif
    call tdb_onoff_times(d,"EC",zthresh,zdtfix,tonarr,toffarr,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_times call failed.'
       errct = errct + 1
    endif

    call tdb_pwrget_init(zpwr)
    zpwr%item = 'ECP'
    zpwr%ztime1 = ton
    zpwr%ztime2 = toff
    zpwr%pweight = .FALSE.
    zpwr%nbeam = nbeam
    zpwr%tbon(1:nbeam) = tonarr(1:nbeam)
    zpwr%tboff(1:nbeam) = toffarr(1:nbeam)

    call tdb_pwrdata_avg(d,zpwr,ierr)

    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_pwrdata_avg "ECP" call failed.'
       errct = errct + 1
    else
       write(tty,*) 'Average Power over time interval ', ton, toff
       do ib=1,nbeam
         write(tty,*) 'Antenna ', ib, ' : ', zpwr%zparam(ib)
       enddo
    endif
  endif

  !--------------------------------------------
  !
  !  ICRF antenna powers

  ipresent = tdb_logchk_special(d,'RFP',iwarn)
  write(tty,*) ' -> ICRF antenna powers in data file: ',ipresent
  errct = errct + iwarn
  if(ipresent)then
    nbeam = tdb_nchan_find(d,"RF")
    write(tty,*) 'Number of ICRF antennae: ', nbeam

    zthresh = 0.10
    zdtfix = 10.
    allocate(tonarr(nbeam), toffarr(nbeam))
    call tdb_onoff_atime(d,"RF",zthresh,zdtfix,ton   ,toff   ,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_atime call failed.'
       errct = errct + 1
    else
       write(tty,*) "RF min on/max off time = ", ton, toff
    endif
    call tdb_onoff_times(d,"RF",zthresh,zdtfix,tonarr,toffarr,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_times call failed.'
       errct = errct + 1
    endif

    call tdb_pwrget_init(zpwr)
    zpwr%item = 'RFP'
    zpwr%ztime1 = ton
    zpwr%ztime2 = toff
    zpwr%pweight = .FALSE.
    zpwr%nbeam = nbeam
    zpwr%tbon(1:nbeam) = tonarr(1:nbeam)
    zpwr%tboff(1:nbeam) = toffarr(1:nbeam)

    call tdb_pwrdata_avg(d,zpwr,ierr)

    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_pwrdata_avg "RFP" call failed.'
       errct = errct + 1
    else
       write(tty,*) 'Average Power over time interval ', ton, toff
       do ib=1,nbeam
         write(tty,*) 'Antenna ', ib, ' : ', zpwr%zparam(ib)
       enddo
    endif
    !
    !  ICRF antenna frequencies
    !
     ipresent = tdb_logchk_special(d,'RFF',iwarn)
     write(tty,*) '    -> ICRF frequencies vs time: ',ipresent
     errct = errct + iwarn
     if(ipresent)then
       zpwr%item = 'RFF'

       call tdb_pwrdata_avg(d,zpwr,ierr)

       if(ierr.ne.0) then
          write(tty,*) ' ?? tdb_pwrdata_avg "RFF" call failed.'
          errct = errct + 1
       else
          write(tty,*) 'Average frequencies over time interval ', ton, toff
          do ib=1,nbeam
            write(tty,*) 'Antenna ', ib, ' : ', zpwr%zparam(ib)
          enddo
       endif
     endif
  endif

  !--------------------------------------------
  !
  !  Lower Hybrid antenna powers

  ipresent = tdb_logchk_special(d,'LHP',iwarn)
  write(tty,*) ' -> Lower Hybrid antenna powers in data file: ',ipresent
  errct = errct + iwarn
  if(ipresent)then
    nbeam = tdb_nchan_find(d,"LH")
    write(tty,*) 'Number of Lower Hybrid antennae: ', nbeam

    zthresh = 0.10
    zdtfix = 10.
    allocate(tonarr(nbeam), toffarr(nbeam))
    call tdb_onoff_atime(d,"LH",zthresh,zdtfix,ton   ,toff   ,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_atime call failed.'
       errct = errct + 1
    else
       write(tty,*) "LH min on/max off time = ", ton, toff
    endif
    call tdb_onoff_times(d,"LH",zthresh,zdtfix,tonarr,toffarr,ierr)
    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_onoff_times call failed.'
       errct = errct + 1
    endif

    call tdb_pwrget_init(zpwr)
    zpwr%item = 'LHP'
    zpwr%ztime1 = ton
    zpwr%ztime2 = toff
    zpwr%pweight = .FALSE.
    zpwr%nbeam = nbeam
    zpwr%tbon(1:nbeam) = tonarr(1:nbeam)
    zpwr%tboff(1:nbeam) = toffarr(1:nbeam)

    call tdb_pwrdata_avg(d,zpwr,ierr)

    if(ierr.ne.0) then
       write(tty,*) ' ?? tdb_pwrdata_avg "LHP" call failed.'
       errct = errct + 1
    else
       write(tty,*) 'Average Power over time interval ', ton, toff
       do ib=1,nbeam
         write(tty,*) 'Antenna ', ib, ' : ', zpwr%zparam(ib)
       enddo
    endif
  endif

  !--------------------------------------------
  !
  !  NB data

  ipresent = tdb_logchk_special(d,'NB2',iwarn)
  write(tty,*) ' -> neutral beam injection powers in data file: ',ipresent
  errct = errct + iwarn

  if(ipresent) then
     nbeam = tdb_nchan_find(d,"NB")
     write(tty,*) 'Number of Neutral Beams: ', nbeam

     zthresh = 0.01
     zdtfix = 10.
     allocate(tonarr(nbeam), toffarr(nbeam))

     call tdb_onoff_atime(d,"NB",zthresh,zdtfix,ton   ,toff   ,ierr)
     if(ierr.ne.0) then
        write(tty,*) ' ?? tdb_onoff_atime call failed.'
        errct = errct + 1
     else
        write(tty,*) "NB min on/max off time = ", ton, toff
     endif

     call tdb_onoff_times(d,"NB",zthresh,zdtfix,tonarr,toffarr,ierr)
     if(ierr.ne.0) then
        write(tty,*) ' ?? tdb_onoff_times call failed.'
        errct = errct + 1
     endif

     call tdb_pwrget_init(zpwr)
     zpwr%ztime1 = ton
     zpwr%ztime2 = toff
     zpwr%pweight = .FALSE.
     zpwr%nbeam = nbeam
     zpwr%tbon(1:nbeam) = tonarr(1:nbeam)
     zpwr%tboff(1:nbeam) = toffarr(1:nbeam)

    !--------------------------------------------
    !
    !  NB Power data

     ipresent = tdb_logchk_nbi(d,'PWR',iwarn)
     write(tty,*) '    NBI powers vs. time: ',ipresent
     errct = errct + iwarn
     if(ipresent) then
       zpwr%item = 'PWR'

       call tdb_pwrdata_avg(d,zpwr,ierr)

       if(ierr.ne.0) then
          write(tty,*) ' PWR tdb_pwrdata_avg call failed.'
          errct = errct + 1
       else
          write(tty,*) 'Average NB Power over time interval ', ton, toff
          do ib=1,nbeam
          write(tty,*) 'Neutral Beam ', ib, ' : ', zpwr%zparam(ib)
          enddo
       endif
     endif
    !--------------------------------------------
    !
    !  NB Voltage data

  
     zpwr%pweight = .TRUE.

     ipresent = tdb_logchk_nbi(d,'VLT',iwarn)
     write(tty,*) '    NBI voltages vs. time: ',ipresent
     errct = errct + iwarn
     if(ipresent) then
       zpwr%item = 'VLT'

       call tdb_pwrdata_avg(d,zpwr,ierr)

       if(ierr.ne.0) then
          write(tty,*) ' ?? tdb_pwrdata_avg "VLT" call failed.'
          errct = errct + 1
       else
          write(tty,*) 'Average NB Voltages over time interval ', ton, toff
          do ib=1,nbeam
          write(tty,*) 'Neutral Beam ', ib, ' : ', zpwr%zparam(ib)
          enddo
       endif
     endif
  
    !--------------------------------------------
    !
    !  NB Full Energy data

     ipresent = tdb_logchk_nbi(d,'FUL',iwarn)
     write(tty,*) '    NBI full energy fractions vs. time: ',ipresent
     errct = errct + iwarn
     if(ipresent) then
       zpwr%item = 'FUL'

       call tdb_pwrdata_avg(d,zpwr,ierr)

       if(ierr.ne.0) then
          write(tty,*) ' ?? tdb_pwrdata_avg "FUL" call failed.'
          errct = errct + 1
       else
          write(tty,*) 'Average NB full energy fraction over time interval ', ton, toff
          do ib=1,nbeam
          write(tty,*) 'Neutral Beam ', ib, ' : ', zpwr%zparam(ib)
          enddo
       endif
     endif
  
    !--------------------------------------------
    !
    !  NB Half Energy data

     ipresent = tdb_logchk_nbi(d,'HLF',iwarn)
     write(tty,*) '    NBI half energy fractions vs. time: ',ipresent
     errct = errct + iwarn
     if(ipresent) then
       zpwr%item = 'HLF'

       call tdb_pwrdata_avg(d,zpwr,ierr)

       if(ierr.ne.0) then
          write(tty,*) ' ?? tdb_pwrdata_avg "HLF" call failed.'
          errct = errct + 1
       else
          write(tty,*) 'Average NB half energy fraction over time interval ', ton, toff
          do ib=1,nbeam
          write(tty,*) 'Neutral Beam ', ib, ' : ', zpwr%zparam(ib)
          enddo
       endif
     endif
  endif

  write(tty,*) ' '

  !--------------------------------------------
  !
  !  plasma boundary position and shape...
  !
  ! First find number of moments
  !

  call tdb_find_nmoms(d,nmom,icirc)
  if(icirc.eq.1) then
     write(tty,*) ' Circular Flux Surfaces being used'
  endif

  ! for time zt get time index, it and scale (offset) factor, zf

      zt = zta
  call tdb_bdy_timefac(d,zt,it,zf)
    !
  allocate(rmcb(0:nmom,2), ymcb(0:nmom,2) )
  !  do im=0,nmom
  !     rmcb(im,1)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_RCOS) ! Rcos mom.
  !     rmcb(im,2)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_RSIN)
  !     ymcb(im,1)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_ZCOS)
  !     ymcb(im,2)=tdb_bdy_getmom(d,it,zf,im,TDB_MOMS_ZSIN) ! Zsin mom.
  !  enddo

  call tdb_bdy_getmoms(d,it,zf,rmcb,ymcb,nmom)

  write(tty,*) ' Plasma Boundary moments '
  write(tty,*) ' m            rmc            rms            zmc            zms'
  do im=0,nmom
     write(tty,"(1x,i4,1p4e15.6)") im, rmcb(im,1), rmcb(im,2), ymcb(im,1), ymcb(im,2)
  enddo

  !
  !--------------------------------------------
  !
  !  Equilibrium Geometry
  ! using the MMX data, fetch the current equilibrium geometry.
  ! this routine MUST NOT be called unless the MMX data exists.
  !

  ipresent = tdb_logchk_special(d,'MMX',iwarn)
  write(tty,*) ' -> MHD equilibrium vs. time in data file: ',ipresent
  write(tty,*) '    (if F, FALSE, equilibrium bdy vs. time is available).'
  errct = errct + iwarn
  
  if(ipresent) then
     nzp1 = nzones + 1
     lcentr = 1  ! axis index (can differ from 1 if needed)
     mj = lcentr + nzones
     allocate(zrmc2(mj,0:nmom,2), zymc2(mj,0:nmom,2) )

     call tdb_getmmx(d,zt,xi_bdy,zrmc2,zymc2,mj,nmom,lcentr,nzp1,zdrshaf)

     write(tty,*) ' Equilibrium Geometry moments '
     write(tty,*)
     do j=lcentr,lcentr+nzones
       write(tty,*)
       write(tty,*) ' Surface index ', j,  '  Surfaces from axis ', j-lcentr
       write(tty,*) '  xi = ', xi_bdy(j-lcentr+1)
       write(tty,*) '  Shafranov shift = ', zdrshaf(j)
       write(tty,*)
       write(tty,*) ' m          rmc            rms            zmc            zms'
       do im=0,nmom
          write(tty,"(1x,i4,1p4e15.6)") im, zrmc2(j,im,1), zrmc2(j,im,2), zymc2(j,im,1), zymc2(j,im,2)
       enddo
     enddo

  endif

  write(tty,*) '-----------------------'
  write(tty,*) ' trdatbuf_test exit, errct = ',errct

end program trdatbuf_test

subroutine trx_psirz_load(ierr)

  use trx_module
  use xplasma_obj_instance
  implicit NONE

  ! load trxplib Psi(R,Z) (from TRANSP free bdy run) into xplasma2

  integer, intent(out) :: ierr

  !----------------------------------------------------
  ! local:

  integer :: id_psi,idprev,id_Rgrid,id_Zgrid,iertmp
  integer :: lunzer
  !----------------------------------------------------
  ierr = 0

  call xplasma_profID(s,'psi',id_psi)
  if(id_psi.eq.0) then
     ierr=1
     write(lunzer(0),*) ' ?trx_psirz_load: 1d psi(rho) not found.'
     return
  endif

  idprev = id_psi

  call xplasma_gridID(s,'__Rgrid',id_Rgrid)
  call xplasma_gridID(s,'__Zgrid',id_Zgrid)

  if(id_Rgrid.eq.0) then
     ierr=1
     write(lunzer(0),*) ' ?trx_psirz_load: __Rgrid ID: not found.'
  endif

  if(id_Zgrid.eq.0) then
     ierr=1
     write(lunzer(0),*) ' ?trx_psirz_load: __Zgrid ID: not found.'
  endif

  if(ierr.ne.0) return

  ! OK:

  call xplasma_author_set(s,'trxplib',iertmp)

  call xplasma_create_2dprof(s,'PSI_RZ', &
       id_Rgrid,id_Zgrid, PsiRZ_free, id_psi, ierr, &
       ispline=1, assoc_id=idprev, &
       label='Poloidal Flux',units='Wb/rad')

  call xplasma_author_clear(s,'trxplib',iertmp)

  if(ierr.ne.0) then
     write(lunzer(0),*) &
          ' ?trx_psirz_load: Psi(R,Z) xplasma_create_2dprof error:'
     call xplasma_error(s,ierr,lunzer(0))
  endif

end subroutine trx_psirz_load

subroutine splitn_seek_update(tmin,filename,inum_found,inum_skipped,ierr)

  ! Look for a file with update blocks for an existing namelist; apply the
  ! updates if found.

  ! Read the set of update blocks -- screen out those before time tmin (sec).
  ! If there is a single block with no time label, assign it the time tmin.
  ! If there are multiple blocks, all must have associated time labels
  !   " ~update_time = <time-value> ";
  ! a leading block with no time label will be taken to be at time tmin, if
  ! there are no subsequent blocks with t < tmin that are screened out.

  ! The ~update_time recorded times in the file must be in ascending order.

  ! NOTE: if no file is found this is considered normal: no updates found.

  use splitn_module
  implicit NONE

  !----------------------------------------
  !  arguments:

  real*8, intent(in) :: tmin   ! minimum time -- screen times before tmin.
  ! if there are data records unassociated with an ~update_time, tmin is
  ! assigned to these records.

  character*(*), intent(in) :: filename   ! file containing updates

  integer, intent(out) :: inum_found      ! number of update blocks found

  integer, intent(out) :: inum_skipped    ! number of update blocks skipped
  !                                       ! (t < tmin); will also be set to
  !                                       ! one (1) if file exists but
  !                                       ! inum_found=0.

  integer, intent(out) :: ierr            ! exit status (0=OK)

  !  an error status could occur (a) if a temporary file I/O operation fails
  !  or (b) if the file contains updates to non-updatable namelist quantities,
  !  or (c) if there is a syntax error or times are in non-ascending order in
  !  the input file.

  !----------------------------------------
  !  local:
  integer :: ilun1,ilun2,io_list(2),ios
  character*20 z20
  character*150 tmp_filename
  integer :: irec,irec0,irec_t0,ic,ilen,ilenv,iexcl,itilda,ieqs
  integer :: icmt,irec_d0,iblock
  logical :: tmin_leader
  integer :: in1,in2,iv1,ilz
  real*8 :: ztime,ztime0,ztimep
  real*8 :: zdtmin = 1.0d-5  ! seconds
  !----------------------------------------

  inum_found = 0
  inum_skipped = 0
  ierr = 0

  if(.not.have_database) then
     write(6,*) ' ?splitn_seek_update: a base namelist must be read prior'
     write(6,*) '  to calling this routine.'
     ierr = 1
     return
  endif

  call find_io_unit_list(2,io_list)
  ilun1 = io_list(1)
  ilun2 = io_list(2)

  open(unit=ilun1,file=filename,status='old',iostat=ios)
  if(ios.ne.0) then
#ifdef __DEBUG
     write(6,*) ' %splitn_seek_update: update file not found: ',trim(filename)
     write(6,*) '  it is assumed that no updates are intended.'
#endif
     return     ! normally, this is done silently: no file found, no update.
  endif

  !  file found: scan for update times
  irec = 0      ! record count
  irec_t0 = 0   ! record count of first qualified ~time_update record.
  irec_d0 = 0   ! record count of first qualified data record, if (a) no prior
                ! ~time_update record is found and (b) no subsequent 
                ! ~time_update record is screened out for t < tmin.

  tmin_leader = .FALSE. ! set .TRUE. if leading records are to be assigned tmin

  ztime0 = -tlarge  ! time of first qualified ~update_time; -infinity initially
  ztimep = -tlarge

  do
     irec = irec + 1
     read(ilun1,'(A)',iostat=ios) aline
     if(ios.ne.0) exit  ! assume EOF

     bline = aline      ! save for messages (aline will be manipulated).

     itilda=0
     icmt=0
     ilen=len(trim(aline))
     do ic=1,ilen
        if(.NOT.iswhite(aline(ic:ic))) then
           if(aline(ic:ic).eq.'~') then
              ! looks like an ~update_time
              itilda=ic
              exit
           else
              if(aline(ic:ic).eq.'!') then
                 icmt=ic
              else
                 if((irec_d0.eq.0).and.(inum_skipped.eq.0)) then
                    ! this records presence of non-comment data prior to first
                    ! ~update_time record
                    if(irec_t0.eq.0) irec_d0=irec ! data, not starting with "~"
                 endif
              endif
              exit
           endif
        endif
     enddo

     if(itilda.eq.0) cycle

     ! look for update time  " ~update_time = <time-value>   ! cmt "
     ! screen out comment if it exists

     ieqs = index(aline,'=')
     if(ieqs.le.0) then
        ierr=1
        write(6,*) ' ?splitn_seek_update: "=" assignment syntax not found: '
        write(6,*) '  '//trim(bline)
        exit
     endif

     iexcl = index(aline,'!')
     if(iexcl.gt.0) then
        aline(iexcl:)=' '
        ilen=len(trim(aline))
     endif

     call uupper(aline)

     in1=0  ! name indices
     in2=0

     iv1=0  ! value index (ilen is the 2nd index, as comment field was removed)

     do ic=1,ilen
        if(in1.eq.0) then
           if(.NOT.iswhite(aline(ic:ic))) then
              in1=ic
           endif
           cycle
        endif
        if(in2.eq.0) then
           if(iswhite(aline(ic:ic)).or.(ic.eq.ieqs)) then
              in2=ic-1
           endif
           cycle
        endif

        if(ic.le.ieqs) cycle

        if(.NOT.iswhite(aline(ic:ic))) then
           iv1=ic
           exit
        endif
     enddo

     if((in1.eq.ieqs).or.(in2.eq.0).or.(iv1.eq.0)) then
        ierr=1
        write(6,*) ' ?splitn_seek_update: "=" assignment syntax parse error: '
        write(6,*) '  '//trim(bline)
        exit
     endif

     if(aline(in1:in2).ne.'~UPDATE_TIME') then
        ierr=1
        write(6,*) ' ?splitn_seek_update: "~" variable must be "~update_time":'
        write(6,*) '  '//trim(bline)
        exit
     endif

     ilenv=ilen-iv1+1
     if(ilenv.gt.20) then
        ierr=1
        write(6,*) ' ?splitn_seek_update: "~update_time" value field too long:'
        write(6,*) '  '//trim(bline)
        exit
     endif

     z20=' '
     z20(20-ilenv+1:20) = aline(iv1:ilen)

     read(z20,'(G20.0)',iostat=ierr) ztime
     if(ierr.ne.0) then
        write(6,*) ' ?splitn_seek_update: "~update_time" value field decode failed:'
        write(6,*) '  '//trim(bline)
        exit
     endif

     if(ztime.lt.tmin) then
        inum_skipped = inum_skipped + 1
        if(inum_skipped.eq.1) write(6,*) '  tmin = ',tmin
        write(6,*) ' %splitn_seek_update: skipped update block (t < tmin): ', &
             ztime
        irec_d0 = 0 ! any leading data (prior to skipped time) is ignored;
        irec_t0 = 0 ! still looking for first good time record.
     else if(ztime.le.ztimep) then
        ierr=1
        write(6,*) &
             ' ?splitn_seek_update: ~update_time times not in ascending order:'
        write(6,*) '  current time: ',ztime,'; prior time: ',ztimep
        exit
     else
        inum_found = inum_found + 1
        if(irec_t0.eq.0) then
           ztime0=ztime
           irec_t0=irec
        endif
        ztimep = ztime
     endif
  enddo
  if(ierr.ne.0) then
     close(unit=ilun1)
     return
  endif

  if((irec_d0.gt.0).and.(irec_d0.lt.irec_t0)) then
     if((ztime0-tmin).gt.zdtmin) then
        inum_found = inum_found + 1
        tmin_leader = .TRUE.
        write(6,*) &
             ' %splitn_seek_update: data records prior to first ~update_time'
        write(6,*) &
             '  are assigned to ~update_time (tmin) = ',tmin
     else
        write(6,*) ' %splitn_seek_update: leading data records skipped:'
        write(6,*) '  The first ~update_time = ',ztime0,' is too soon after'
        write(6,*) '  the minimum time  tmin = ',tmin
     endif
  endif

  write(6,*) ' %splitn_seek_update: ',inum_found,' update blocks found in ', &
       trim(filename)

  if(inum_found.eq.0) then
     ! no updates, but, be sure to signal that a file was read...
     inum_skipped=max(1,inum_skipped)
     close(unit=ilun1)
     return
  endif

  rewind(unit=ilun1)

  call tmpfile_d('splitn_seek_update',tmp_filename,ilz)

  open(unit=ilun2,file=tmp_filename,status='unknown',iostat=ierr)
  if(ierr.ne.0) then
     write(6,*) ' ?splitn_seek_update: could not open temporary file: '
     write(6,*) '  '//tmp_filename(1:ilz)

     close(unit=ilun1)

  else
     ! OK, copy eligible records

     if(tmin_leader) then
        z20=' '
        write(z20,'(1pd19.12)') tmin
        call splitn_fput_clean(z20,'d')

        write(ilun2,'(" ~UPDATE_TIME = ",a)') trim(z20)
     endif

     irec = 0

     irec0=1
     if(inum_skipped.gt.0) then
        irec0 = irec_t0
     endif

     do
        irec = irec + 1
        read(ilun1,'(A)',iostat=ios) aline
        if(ios.ne.0) exit  ! assume EOF

        if(irec.ge.irec0) then
           write(ilun2,'(A)') trim(aline)
        endif
     enddo

     close(unit=ilun1)

     rewind(unit=ilun2)

     if(nupdate.gt.0) then
        if(tmin.le.tup(nupdate)) then
           write(6,*) ' %splitn_seek_update: old updates @ t.ge.tmin removed.'
           call splitn_update_remove(tmin,ierr)
           if(ierr.ne.0) then
              write(6,*) ' ?splitn_seek_update: unexpected splitn_update_remove error (ignored).'
           endif
        else
           kupdate=0
           nxblock=1
        endif
     else
        kupdate=0
        nxblock=1
     endif

     efitin_flag=.FALSE.

     ndblasg1 = 0
     ndblasg2 = 0
     nlackdp = 0

     do
        read(ilun2,'(A)',iostat=ios) aline
        if(ios.ne.0) exit  ! assume EOF

         iblock=nxblock

         newline= nlines+1

         call parse_line(aline,.TRUE.,ierr)
         if(ierr.ne.0) exit  ! this is an actual error

         call add_nl_line(aline)

         if(iblock.lt.nxblock) then
            ! an update block was detected -- mark line position
            linup(iblock)=nlines  ! =newline
         endif

      enddo

      if(ierr.eq.0) then
         call splitn_check_misc(ierr)
      endif

      if(ierr.eq.0) then
         close(unit=ilun2,status='delete')
      else
         write(6,*) ' ?splitn_seek_update: error detected.'
         write(6,*) '  temporary file retained here: ',trim(tmp_filename)
         close(unit=ilun2)
      endif

   endif

CONTAINS
  logical function iswhite(ichar)
    character*1 :: ichar

    ! .TRUE. if blank or TAB

    iswhite = ichar.eq.' ' .OR. ichar.eq.char(9)

  end function iswhite

end subroutine splitn_seek_update

! $Id: key_access.f90,v 1.7 2006-01-13 18:04:37 Rob_Andre Exp $
#include "fpreproc/byte_declare.h"

module key_access

  interface ka_init
     ! initialize or re-initialize table
     subroutine key2_init
     end subroutine key2_init
  end interface

  interface ka_free
     ! clear table
     subroutine key2_free
     end subroutine key2_free
  end interface

  interface ka_set
     ! set 
     module procedure key2double_set, key2int_set, key2bool_set
     module procedure key2doublearray_set, key2intarray_set, key2boolarray_set
  end interface

  interface ka_get
     ! get 
     module procedure key2double_get, key2int_get, key2bool_get
     module procedure key2doublearray_get, key2intarray_get, key2boolarray_get
  end interface

  interface ka_print
     subroutine key2print
     end subroutine key2print
  end interface

  interface ka_write_namelist
     module procedure key2write_namelist
  end interface

contains
  subroutine key2double_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    real*8,        intent(in) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2double_set(cname, val)
  end subroutine key2double_set

  subroutine key2doublearray_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    real*8,        intent(in) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2doublearray_set(cname, val, size(val))
  end subroutine key2doublearray_set

  subroutine key2int_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    integer,       intent(in) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2int_set(cname, val)
  end subroutine key2int_set

  subroutine key2intarray_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    integer,       intent(in) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2intarray_set(cname, val, size(val))
  end subroutine key2intarray_set

  subroutine key2bool_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    logical,       intent(in) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C
    integer :: ival

    ival=0
    if (val) ival=1

    call cstring(var_name, cname, '2C')
    call c_key2bool_set(cname, ival)
  end subroutine key2bool_set

  subroutine key2boolarray_set(var_name, val)
    character*(*), intent(in) :: var_name  ! name of variable
    logical,       intent(in) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C
    integer :: ival(size(val))

    ival=0
    where (val)
       ival=1
    elsewhere
       ival=0
    end where

    call cstring(var_name, cname, '2C')
    call c_key2boolarray_set(cname, ival, size(val))
  end subroutine key2boolarray_set

  subroutine key2double_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    real*8,        intent(out) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2double_get(cname, val)
  end subroutine key2double_get

  subroutine key2doublearray_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    real*8,        intent(out) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2doublearray_get(cname, val, size(val))
  end subroutine key2doublearray_get


  subroutine key2int_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    integer,       intent(out) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2int_get(cname, val)
  end subroutine key2int_get

  subroutine key2intarray_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    integer,       intent(out) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C

    call cstring(var_name, cname, '2C')
    call c_key2intarray_get(cname, val, size(val))
  end subroutine key2intarray_get

  subroutine key2bool_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    logical,       intent(out) :: val       ! value

    byte_declare :: cname(len(var_name)+1) ! name for C
    integer      :: ival

    ival=0
    call cstring(var_name, cname, '2C')
    call c_key2bool_get(cname, ival)
    val = ival/=0
  end subroutine key2bool_get

  subroutine key2boolarray_get(var_name, val)
    character*(*), intent(in)  :: var_name  ! name of variable
    logical,       intent(out) :: val(:)    ! value

    byte_declare :: cname(len(var_name)+1) ! name for C
    integer      :: ival(size(val))

    ival=0
    call cstring(var_name, cname, '2C')
    call c_key2boolarray_get(cname, ival, size(val))
    val = ival/=0
  end subroutine key2boolarray_get

  subroutine key2write_namelist(filename, namelist_name, mode)
    character(*), intent(in) :: filename
    character(*), intent(in) :: namelist_name
    character(*), intent(in) :: mode              ! 'a' for append

    byte_declare :: cfname(len(filename)+1)       ! C file name
    byte_declare :: cnname(len(namelist_name)+1)  ! C namelist name
    byte_declare :: cmode(len(mode)+1)            ! C mode

    call cstring(filename,      cfname, '2C')
    call cstring(namelist_name, cnname, '2C')
    call cstring(mode,          cmode,  '2C')

    call c_key2write_namelist(cfname, cnname, cmode)
  end subroutine key2write_namelist

end module key_access

subroutine ps_mhdeq_grho2r2i(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium:
  !     flux surface averages <1/R**2> (gr2i)
  !                           <|grad(rho)|**2/R**2> (grho2r2i)

  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: idi,kf1,kf2,idiff,iaddr,iertot

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg
  real(KIND=rspec), dimension(:), allocatable :: zwk
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_grho2r2i',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%grho2r2i(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_grho2r2i: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        idiff=1
     else
        iaddr=ps_hash_aux2
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux2
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  call ps_rhowk_integ(ps,nwk,rhowk,idi,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  iertot=0
  if(intrp) then
     allocate(zxpkg(nwk,4),zwk(nwk))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_grho2r2i: unexpected error, genxpkg.'
        deallocate(zxpkg,zwk)
        return
     endif

     call xplasma_rho_zonint(s,idi,'<1/R^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gr2i)
     endif
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/R^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grho2r2i)
     endif
     deallocate(zxpkg,zwk)

  else
     call xplasma_rho_zonint(s,idi,'<1/R^2>S',ps%gr2i,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/R^2>S',ps%grho2r2i,ierr)
     if(ierr.ne.0) iertot=iertot+1
  endif

  if(iertot.gt.0) then
     ierr=9999
     write(iout,*) ' ?ps_mhdeq_grho2r2i: error during flux surface integration'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_mhdeq_grho2r2i

subroutine ps_mhdeq_geoprof(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium:
  !     flux surface averages <1/R>,<R>,<R**2>, etc.
  !                           <|grad(rho)|>,<|grad(rho)|**2> & more
  !  All derivable from {R,Z}surface only-- averages involving powers
  !  of R and grad(rho).

  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: idi,kf1,kf2,idiff,iaddr,iertot

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg
  real(KIND=rspec), dimension(:), allocatable :: zwk
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_geoprof',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%gri(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_geoprof: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        idiff=1
     else
        iaddr=ps_hash_aux3
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux3
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  call ps_rhowk_integ(ps,nwk,rhowk,idi,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  iertot=0
  if(intrp) then
     allocate(zxpkg(nwk,4),zwk(nwk))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_geoprof: unexpected error, genxpkg.'
        deallocate(zxpkg,zwk)
        return
     endif

     call xplasma_rho_zonint(s,idi,'<1/R>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gri)
     endif
     call xplasma_rho_zonint(s,idi,'<grad(rho)>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grho1)
     endif
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grho2)
     endif
     call xplasma_rho_zonint(s,idi,'<R>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gr1)
     endif
     call xplasma_rho_zonint(s,idi,'<R^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gr2)
     endif
     call xplasma_rho_zonint(s,idi,'<1/R^3>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gr3i)
     endif
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/R^3>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grho2r3i)
     endif
     call xplasma_rho_zonint(s,idi,'<R^2*grad(rho)^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gr2rho2)
     endif
     call xplasma_rho_zonint(s,idi,'<1/(R*grad(rho))>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grirhoi)
     endif

     deallocate(zxpkg,zwk)

  else
     call xplasma_rho_zonint(s,idi,'<1/R>S',ps%gri,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<grad(rho)>S',ps%grho1,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2>S',ps%grho2,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<R>S',ps%gr1,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<R^2>S',ps%gr2,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<1/R^3>S',ps%gr3i,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/R^3>S',ps%grho2r3i,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<R^2*grad(rho)^2>S',ps%gr2rho2,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<1/(R*grad(rho))>S',ps%grirhoi,ierr)
     if(ierr.ne.0) iertot=iertot+1
  endif

  if(iertot.gt.0) then
     ierr=9999
     write(iout,*) ' ?ps_mhdeq_geoprof: error during flux surface integration'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_mhdeq_geoprof

subroutine ps_mhdeq_nclass(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with field and geometry
  !     flux surface averages <B**2> (gb2) and Pfirsch-Schlutter moments
  !  Also update other flux surface averages involving powers of B

  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  use plasma_hash_code

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: idi,ii,kf1,kf2,idiff,iaddr,iertot,ipair(2)

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg,zpsmom
  real(KIND=rspec), dimension(:), allocatable :: zwk,zgamma,zgb2,zb2,zerrck
  real(KIND=rspec) :: zrhomin
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  integer :: id_Bmod,id_BR,id_BZ
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_nclass',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%gb2(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_nclass: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        idiff=1
     else
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        iaddr=ps_hash_aux4
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  else
     call addpair(ps_phash_g_eq)
     call addpair(ps_phash_psipol)
     call addpair(ps_phash_phit)
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux4
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  if(ps%npsmom.eq.0) then
     write(iout,*) ' %ps_mhdeq_nclass: allocating 16 Pfirsch-Schlutter moments profiles.'
     ps%npsmom=16
     call plasma_state_empty_alloc(ps,ierr)
     if(ierr.ne.0) return
     do ii=1,ps%npsmom
        ps%psmom_num(ii)=' '
        if(ii.lt.10) then
           write(ps%psmom_num(ii)(1:1),'(I1)') ii
        else
           write(ps%psmom_num(ii)(1:2),'(I2)') ii
        endif
     enddo
  endif

  zrhomin = rhowk(2)*0.001_rspec

  call ps_rhowk_integ(ps,nwk,rhowk,idi,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  ! sanity check
  call xplasma_common_ids(s,ierr,id_Bmod=id_Bmod,id_BR=id_BR,id_BZ=id_BZ)
  if(min(id_Bmod,id_BR,id_BZ).eq.0) then
     write(iout,*) ' ?ps_mhdeq_nclass: data missing in xplasma; equilibrium may not be complete.'
     ierr=999
     return
  endif

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  iertot=0
  if(intrp) then
     allocate(zxpkg(nwk,4),zwk(nwk))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_nclass: unexpected error, genxpkg.'
        deallocate(zxpkg,zwk)
        return
     endif

     call xplasma_rho_zonint(s,idi,'<B*R^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gbr2)
     endif
     call xplasma_rho_zonint(s,idi,'<B>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gb1)
     endif
     call xplasma_rho_zonint(s,idi,'<1/B^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%gb2i)
     endif
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/B^2>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%grho2b2i)
     endif

     allocate(zpsmom(ps%npsmom,nwk),zgamma(nwk),zgb2(nwk),zb2(nwk),zerrck(nwk))
     call xplasma_psmom(s,rhowk,zrhomin, &
          zpsmom,zgamma,zgb2,zb2,zerrck, &
          ierr)
     if(ierr.ne.0) iertot=iertot+1

     do ii=1,ps%npsmom
        call ps_mhdeq_intrp(nwk,zxpkg,zpsmom(ii,:), &
             ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%psmom_nc(:,ii))
     enddo
     call ps_mhdeq_intrp(nwk,zxpkg,zgamma,ps%nrho_eq_geo,ps%rho_eq_geo, &
          ispline,iout,ps%gamma_nc)
     call ps_mhdeq_intrp(nwk,zxpkg,zgb2,ps%nrho_eq_geo,ps%rho_eq_geo, &
          ispline,iout,ps%ngradb2_av)
     call ps_mhdeq_intrp(nwk,zxpkg,zb2,ps%nrho_eq_geo,ps%rho_eq_geo, &
          ispline,iout,ps%gb2)
     call ps_mhdeq_intrp(nwk,zxpkg,zerrck,ps%nrho_eq_geo,ps%rho_eq_geo, &
          ilinear,iout,ps%psmom_errck)
     deallocate(zpsmom,zgamma,zgb2,zb2,zerrck)
  else
     call xplasma_rho_zonint(s,idi,'<B*R^2>S',ps%gbr2,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<B>S',ps%gb1,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<1/B^2>S',ps%gb2i,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<grad(rho)^2/B^2>S',ps%grho2b2i,ierr)
     if(ierr.ne.0) iertot=iertot+1

     allocate(zpsmom(ps%npsmom,ps%nrho_eq_geo))
     call xplasma_psmom(s,ps%rho_eq_geo,zrhomin, &
          zpsmom,ps%gamma_nc,ps%ngradb2_av,ps%gb2,ps%psmom_errck, &
          ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
        ps%psmom_nc=ZERO
     else
        do ii=1,ps%npsmom
           ps%psmom_nc(1:ps%nrho_eq_geo,ii)=zpsmom(ii,1:ps%nrho_eq_geo)
        enddo
     endif
     deallocate(zpsmom)
  endif

  if(iertot.gt.0) then
     ierr=9999
     write(iout,*) ' ?ps_mhdeq_nclass: error during flux surface integration'
     call xplasma_error(s,ierr,iout)
  endif

  contains
    subroutine addpair(iarg)
      integer :: iarg

      iaddr=iarg
      ipair(1)=ps%new_hash_codes(iaddr)
      ipair(2)=ps%new_hash_codes(iaddr+1)

      call hashCode(ipair,kf1,kf2)
    end subroutine addpair

end subroutine ps_mhdeq_nclass

subroutine ps_mhdeq_geosing(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium and
  !     field -- singular integrals involving expressions with sqrt(1-B/Bmax).

  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  use plasma_hash_code

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: idi,kf1,kf2,idiff,iaddr,iertot,ipair(2)

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg
  real(KIND=rspec), dimension(:), allocatable :: zwk
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  integer :: id_Bmod,id_BR,id_BZ
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_geosing',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%gncfh(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_geosing: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        idiff=1
     else
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        iaddr=ps_hash_aux5
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  else
     call addpair(ps_phash_g_eq)
     call addpair(ps_phash_psipol)
     call addpair(ps_phash_phit)
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux5
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  call ps_rhowk_integ(ps,nwk,rhowk,idi,iout,ierr)
  if(ierr.ne.0) return

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  ! sanity check
  call xplasma_common_ids(s,ierr,id_Bmod=id_Bmod,id_BR=id_BR,id_BZ=id_BZ)
  if(min(id_Bmod,id_BR,id_BZ).eq.0) then
     write(iout,*) ' ?ps_mhdeq_geosing: data missing in xplasma; equilibrium may not be complete.'
     ierr=999
     return
  endif

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  iertot=0
  if(intrp) then
     allocate(zxpkg(nwk,4),zwk(nwk))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_geosing: unexpected error, genxpkg.'
        deallocate(zxpkg,zwk)
        return
     endif

     call xplasma_rho_zonint(s,idi,'<f(h)NCLASS>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ilinear,iout,ps%gncfh)
     endif
     call xplasma_rho_zonint(s,idi,'<f(h)NC_TSC>S',zwk,ierr)
     if(ierr.ne.0) then
        iertot=iertot+1
     else
        call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ilinear,iout,ps%gncfb2h)
     endif
  else
     call xplasma_rho_zonint(s,idi,'<f(h)NCLASS>S',ps%gncfh,ierr)
     if(ierr.ne.0) iertot=iertot+1
     call xplasma_rho_zonint(s,idi,'<f(h)NC_TSC>S',ps%gncfb2h,ierr)
     if(ierr.ne.0) iertot=iertot+1
  endif

  if(iertot.gt.0) then
     ierr=9999
     write(iout,*) ' ?ps_mhdeq_geosing: error during flux surface integration'
     call xplasma_error(s,ierr,iout)
  endif

  contains
    subroutine addpair(iarg)
      integer :: iarg

      iaddr=iarg
      ipair(1)=ps%new_hash_codes(iaddr)
      ipair(2)=ps%new_hash_codes(iaddr+1)

      call hashCode(ipair,kf1,kf2)
    end subroutine addpair

end subroutine ps_mhdeq_geosing

subroutine ps_rhowk_integ(ps,nwk,rhowk,idi,iout,ierr)

  !  Called from ps_mhdeq_flxint subroutines

  !  Create an integrator for flux surface integrals and averages
  !  on the passed grid rhowk(1:nwk).  Integrator may already exist
  !  but grid match must be tested.

  !  Integrator ownership set to xplasma_xmhd --> removed when equilibrium
  !  changes.

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps       ! plasma state object to be updated

  integer, intent(in) :: nwk      ! rhowk grid size
  Real(kind=rspec) :: rhowk(nwk)  ! rhowk grid

  integer, intent(out) :: idi     ! ID of integrator, returned (0 if error)

  integer, intent(in) :: iout     ! Fortran LUN for messages
  integer, intent(out) :: ierr    ! exit status code 0=OK

  !-----------------------
  !  local:
  integer :: iertmp
  character*32, parameter :: iiname = '_ps_mhdeq_rhowk_integ'

  integer, dimension(:), pointer :: iptr
  real(kind=rspec), dimension(:), pointer :: r8ptr
  real(kind=rspec) :: zdiffa,ztol

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
  ztol=1.0d-10
  if((abs(rhowk(1)).gt.ztol).or.(abs(1.0_rspec-rhowk(nwk)).gt.ztol)) then
     ierr=9999
     write(iout,*) ' ?ps_rhowk_integ: integration grid must span range [0,1]:'
     write(iout,*) '  rhowk(1)=',rhowk(1),'; rhowk(nwk)=',rhowk(nwk)
     return
  endif

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_blkbxId(s,iiname,idi)
  if(idi.gt.0) then
     call xplasma_blackBox_retrieve(s,idi,ierr, ia_ptr=iptr, r8a_ptr=r8ptr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_rhowk_integ: xplasma blackBox retrieve error:'
        call xplasma_error(s,ierr,iout)
        ierr=9999
        return
     endif
     if((size(iptr).ge.12).and.(size(r8ptr).gt.(nwk+1))) then
        if(iptr(12).eq.nwk) then
           zdiffa=maxval(abs(rhowk(1:nwk)-r8ptr(2:nwk+1)))
           if(zdiffa.lt.ztol) then
              return  !  accept existing integrator -- grid matches
           endif
        endif
     endif
  endif
  !  integrator not found: create it...

  call xplasma_author_set(s,xplasma_xmhd,iertmp)

  call xplasma_create_integ(s,trim(iiname),rhowk,idi,ierr, &
       cache_enable = .TRUE.)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_rhowk_integ: unexpected xplasma error:'
     call xplasma_error(s,ierr,iout)
     ierr=9999
  endif

  call xplasma_author_clear(s,xplasma_xmhd,iertmp)

end subroutine ps_rhowk_integ

subroutine ps_mhdeq_intrp(nwk,zxpkg,zf,nxtarg,xtarg,imethod,iout,zftarg)

  ! linear or spline interpolation for ps_mhdeq_flxint
  ! take data zf[1:nwk] defined on grid [zxpkg(1:nwk,4)] 
  ! to target data zftarg(1:nxtarg) over grid xtarg(1:nxtarg).

  ! zxpkg is to have been prepared by a prior call to genxpkg

  ! imethod specifies interpolation method (spline with not-a-knot BC, or,
  ! piecewise linear).

  implicit NONE

  integer, intent(in) :: nwk          ! # of points in source data
  real*8, intent(in) :: zxpkg(nwk,4)  ! x grid description
  !                     (built from 1d grid array by "genxpkg" call)
  real*8, intent(in) :: zf(nwk)       ! data to be interpolated

  integer, intent(in) :: nxtarg       ! target data size
  real*8, intent(in) :: xtarg(nxtarg) ! points to which to interpolate data
  integer, intent(in) :: imethod      ! interpolation method

  integer, intent(in) :: iout         ! I/O LUN for messages
  ! (none should occur -- messages indicate a code bug)

  real*8, intent(out) :: zftarg(nxtarg)  ! results of interpolation, output

  !----------------------------------
  ! local:

  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: ibc=0
  real*8, parameter :: ZERO = 0.0d0
  real*8 :: zbc=ZERO

  integer idum,ict(3),iwarn,ierr

  real*8 :: zspl(4,nwk),zwk(nwk)

  data ict/1,0,0/

  !----------------------------------
  !  spline setup

  if(imethod.eq.ispline) then

     ! spline

     zspl(1,1:nwk)=zf(1:nwk)

     call cspline(zxpkg(:,1),nwk,zspl,ibc,zbc,ibc,zbc,zwk,nwk,idum,ierr)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_intrp: internal error (cspline call), results set to ZERO'
     else
        call spvec(ict,nxtarg,xtarg,nxtarg,zftarg,nwk,zxpkg,zspl,idum,ierr)
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_mhdeq_intrp: internal error (spvec call), results set to ZERO'
        endif
     endif

  else
     ! piecewise linear interpolation

     call vecpc1(ict,nxtarg,xtarg,nxtarg,zftarg,nwk,zxpkg,zf,iwarn,ierr)
     if(iwarn.ne.0) ierr=iwarn
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_mhdeq_intrp: internal error (vecpc1 call), results set to ZERO'
     endif
  endif

  if(ierr.ne.0) zftarg = ZERO

end subroutine ps_mhdeq_intrp

!--------------------------------------
! remaining routines compute surface quantities other than
! numerically integrated flux surface averages -- e.g. elongation,
! triangularity...

subroutine ps_mhdeq_surfparam(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium:
  !     Rmin, Rmax, Zmin, Zmax
  !
  !     elongation  =  (Zmax-Zmin)/(Rmax-Rmin)
  !        let R0=(Rmax+Rmin)/2; let a = (Rmax-Rmin)/2
  !
  !     triangularity  =  (R0 - min(R(Zmin),R(Zmax)))/a
  !     upper triangularity  =  (R0 - R(Zmax))/a
  !     lower triangularity  =  (R0 - R(Zmin))/a
  !
  !        R(Zmax) = major radius where Zmax occurs on flux surface
  !        R(Zmin) = major radius where Zmin occurs on flux surface
  !
  !     Approximate:
  !     midplane elevation Z_midp = Z location such that half the area
  !        enclose by a flux surface is above, and half below;
  !        R_midp_in and R_midp_out are the flux surface intercepts
  !        at Z=Z_midp, on high field and low field sides, respectively.

  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: kf1,kf2,idiff,iaddr,iertot,iwk,ivec,ith

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg
  real(kind=rspec), parameter :: Z2PI = 6.2831853071795862_rspec

  integer, parameter :: vecsize=401
  real(KIND=rspec) :: rhovec(vecsize),thvec(vecsize)
  real(KIND=rspec) :: rvec(vecsize),zvec(vecsize)

  real(KIND=rspec), dimension(:), allocatable :: Zmidp,Rmidp_in,Rmidp_out
  real(KIND=rspec), dimension(:), allocatable :: Rmin,Rmax,Zmin,Zmax
  real(KIND=rspec), dimension(:), allocatable :: th_Zmin,th_Zmax
  real(KIND=rspec), dimension(:), allocatable :: R_Zmin,R_Zmax,zgeo,zR0,za0
  real(KIND=rspec), dimension(:), allocatable :: th_Rmin,th_Rmax
  real(KIND=rspec), dimension(:), allocatable :: Z_Rmin,Z_Rmax,zgeo2

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------
  !  for squareness evaluation
  
  real(KIND=rspec) :: zlen,zlen_ab,zlen_ac,zlen_cd,zsqi2
  real(KIND=rspec) :: ra(2),za(2),phia(2)
  real(KIND=rspec) :: rb(2),zb(2),phib(2)
  real(KIND=rspec) :: rx(2),zx(2),phix(2)
  integer :: istat(2)
  integer, parameter :: ibdy_type=1
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_surfparam',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  !-----------------------
  !  for squareness...

  zsqi2 = sqrt(0.5_rspec)
  phia = 0.0_rspec; phib=0.0_rspec; phix=0.0_rspec

  !-----------------------

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%R_midp_out(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_surfparam: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        idiff=1
     else
        iaddr=ps_hash_aux6
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux6
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  if(intrp) then
     allocate(zxpkg(nwk,4))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
  endif

  !------------------------------------------------------------
  !  compute midplane
  allocate(Zmidp(nwk),Rmidp_in(nwk),Rmidp_out(nwk))

  do
     call xplasma_mag_axis(s,ierr, Raxis=Rmidp_in(1),Zaxis=Zmidp(1))
     if(ierr.ne.0) exit

     Rmidp_out(1)=Rmidp_in(1)

     do ith=1,vecsize
        thvec(ith)=(ith-1)*Z2PI/(vecsize-1)
     enddo

     do iwk=2,nwk
        rhovec = rhowk(iwk)

        call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
             rho_in=rhovec, theta_in=thvec, &
             r_out=rvec, z_out=zvec)
        if(ierr.ne.0) exit

        call r8_getmpa_ry(rvec,zvec,vecsize, &
             Rmidp_in(iwk),Rmidp_out(iwk),Zmidp(iwk))
     enddo

     if(intrp) then
        call ps_mhdeq_intrp(nwk,zxpkg,Rmidp_in,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%R_midp_in)
        call ps_mhdeq_intrp(nwk,zxpkg,Rmidp_out,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%R_midp_out)
        call ps_mhdeq_intrp(nwk,zxpkg,Zmidp,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%Z_midp)

     else
        ps%R_midp_in = Rmidp_in
        ps%R_midp_out= Rmidp_out
        ps%Z_midp    = Zmidp

     endif

     exit
  enddo

  deallocate(Rmidp_in,Rmidp_out,Zmidp)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_surfparam: xplasma error while computing midplane:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  !------------------------------------------------------------
  ! compute R & Z min/max; also get data for elongation & triangularity
  !  DMC 14 Aug 2009 -- adding upper and lower outer squareness, per request.
  !  definition: Holcomb et al., Phys. Plasmas 16, 056116 (2009) Fig. 1

  allocate(Rmin(nwk),Rmax(nwk),Zmin(nwk),Zmax(nwk))
  allocate(th_Zmin(nwk),th_Zmax(nwk))
  allocate(R_Zmin(nwk),R_Zmax(nwk),zgeo(nwk),zR0(nwk),za0(nwk))
  allocate(th_Rmin(nwk),th_Rmax(nwk))
  allocate(Z_Rmin(nwk),Z_Rmax(nwk),zgeo2(nwk))

  do
     ! evaluate at non-singular surfaces
     do iwk=2,nwk
        call xplasma_RZminmax(s,rhowk(iwk),ierr, &
             i2pi=2,rmin=Rmin(iwk),rmax=Rmax(iwk), &
             thRmin=th_Rmin(iwk),thRmax=th_Rmax(iwk), &
             zmin=Zmin(iwk),thZmin=th_Zmin(iwk), &
             zmax=Zmax(iwk),thZmax=th_Zmax(iwk))
        if(ierr.ne.0) exit
     enddo
     if(ierr.ne.0) exit

     ! convert (rho,theta) -> R_Zmin,max, etc.

     call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
          rho_in=rhowk(2:nwk), theta_in=th_Zmin(2:nwk), &
             r_out=R_Zmin(2:nwk), z_out=zgeo(2:nwk))
     if(ierr.ne.0) exit

     call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
          rho_in=rhowk(2:nwk), theta_in=th_Zmax(2:nwk), &
             r_out=R_Zmax(2:nwk), z_out=zgeo(2:nwk))
     if(ierr.ne.0) exit

     call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
          rho_in=rhowk(2:nwk), theta_in=th_Rmin(2:nwk), &
             r_out=zgeo(2:nwk), z_out=Z_Rmin(2:nwk))
     if(ierr.ne.0) exit

     call xplasma_ctrans(s,xp_use_coord_vecsize,ierr, &
          rho_in=rhowk(2:nwk), theta_in=th_Rmax(2:nwk), &
             r_out=zgeo(2:nwk), z_out=Z_Rmax(2:nwk))
     if(ierr.ne.0) exit

     ! extrapolate to axis and copy or interpolate results

     Rmin(1)=ps%R_midp_in(1)
     Rmax(1)=ps%R_midp_in(1)
     call fini(Rmin,ps%R_surfmin,0)
     call fini(Rmax,ps%R_surfmax,0)

     Zmin(1)=ps%Z_midp(1)
     Zmax(1)=ps%Z_midp(1)
     call fini(Zmin,ps%Z_surfmin,0)
     call fini(Zmax,ps%Z_surfmax,0)

     do iwk=2,nwk
        zgeo(iwk)=(Zmax(iwk)-Zmin(iwk))/(Rmax(iwk)-Rmin(iwk))
        zR0(iwk) =(Rmin(iwk)+Rmax(iwk))*0.5_rspec
        za0(iwk) =(Rmax(iwk)-Rmin(iwk))*0.5_rspec
     enddo

     zR0(1)=Rmin(1)
     call fini(zR0, ps%Rmajor_mean, 0)
     za0(1)=0.0_Rspec
     call fini(za0, ps%Rminor_mean, 0)

     call fini(zgeo,ps%elong,1)  ! quad. extrap. to axis

     do iwk=2,nwk
        zgeo(iwk)=(zR0(iwk)-min(R_Zmin(iwk),R_Zmax(iwk)))/za0(iwk)
     enddo
     zgeo(1)=0.0_Rspec
     call fini(zgeo,ps%triang,0)

     do iwk=2,nwk
        zgeo(iwk)=(zR0(iwk)-R_Zmax(iwk))/za0(iwk)
     enddo
     zgeo(1)=0.0_Rspec
     call fini(zgeo,ps%triangU,0)

     do iwk=2,nwk
        zgeo(iwk)=(zR0(iwk)-R_Zmin(iwk))/za0(iwk)
     enddo
     zgeo(1)=0.0_Rspec
     call fini(zgeo,ps%triangL,0)

     do iwk=2,nwk
        zgeo(iwk)=sin(acos((R_Zmax(iwk)-zR0(iwk))/za0(iwk))-z2pi/4)
     enddo
     zgeo(1)=0.0_Rspec
     call fini(zgeo,ps%triang_miller_U,0)

     do iwk=2,nwk
        zgeo(iwk)=sin(acos((R_Zmin(iwk)-zR0(iwk))/za0(iwk))-z2pi/4)
     enddo
     zgeo(1)=0.0_Rspec
     call fini(zgeo,ps%triang_miller_L,0)

     !  squareness
     zgeo(1)=0.0_rspec
     zgeo2(1)=0.0_rspec
     do iwk=2,nwk
        ! do bdy search two at a time: upper, lower...
        ra(1)=R_Zmax(iwk)
        ra(2)=R_Zmin(iwk)
        za(1:2)=Z_Rmax(iwk)
        rb(1:2)=Rmax(iwk)
        zb(1)=Zmax(iwk)
        zb(2)=Zmin(iwk)

        call xplasma_fxcep(s,ibdy_type, &
             ra,za,phia, rb,zb,phib, rx,zx,phix, istat, ierr, &
             rhosurf=rhowk(iwk))
        if(ierr.ne.0) then
           write(iout,*) ' ?ps_mhdeq_surfparam: xplasma_fxcep error:'
           call xplasma_error(s,ierr,iout)
           exit
        endif

        !  upper:
        zlen = sqrt( (ra(1)-rb(1))**2 + (za(1)-zb(1))**2 )
        zlen_ac = zsqi2*zlen
        zlen_cd = zlen-zlen_ac
        zlen_ab = sqrt( (ra(1)-rx(1))**2 + (za(1)-zx(1))**2 )

        zgeo(iwk)=(zlen_ab-zlen_ac)/zlen_cd

        !  lower:
        zlen = sqrt( (ra(2)-rb(2))**2 + (za(2)-zb(2))**2 )
        zlen_ac = zsqi2*zlen
        zlen_cd = zlen-zlen_ac
        zlen_ab = sqrt( (ra(2)-rx(2))**2 + (za(2)-zx(2))**2 )

        zgeo2(iwk)=(zlen_ab-zlen_ac)/zlen_cd
        
     enddo

     call fini(zgeo,ps%squareUO,0)
     call fini(zgeo2,ps%squareLO,0)

     exit
  enddo

  deallocate(Rmin,Rmax,Zmin,Zmax)
  deallocate(th_Zmin,th_Zmax)
  deallocate(R_Zmin,R_Zmax,zgeo,zR0,za0)
  deallocate(th_Rmin,th_Rmax)
  deallocate(Z_Rmin,Z_Rmax,zgeo2)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_surfparam: xplasma error while computing [R,Z]minmax:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  contains
    subroutine fini(zwk,result,iextrap)
      
      real(kind=rspec), dimension(:) :: zwk
      real(kind=rspec), dimension(:) :: result
      integer, intent(in) :: iextrap

      !  quadratic extrapolation to axis; assume rhowk(1)=ZERO

      if(iextrap.eq.1) then
         zwk(1) = zwk(2) - &
              rhowk(2)**2/(rhowk(3)**2-rhowk(2)**2)*(zwk(3)-zwk(2))
      endif

      if(intrp) then
         call ps_mhdeq_intrp(nwk,zxpkg,zwk,ps%nrho_eq_geo,ps%rho_eq_geo, &
              ispline,iout,result)
      else
         result = zwk
      endif

    end subroutine fini

end subroutine ps_mhdeq_surfparam

subroutine ps_mhdeq_Bminmax(ps,nwk,rhowk,iout,ierr)

  !  Update plasma state "ps" with derived profiles from equilibrium:
  !     Bmin, Bmax, Bmin, Bmax on each flux surface
  !
  !  Profiles are mapped to ps%rho_eq_geo by interpolation from the 
  !  (presumably coarser) grid rhowk(1:nwk) -- computing flux surface
  !  averages on a coarser grid is a way to speed the calculation.
  !  (From TRANSP experience it is a good idea of rhowk and ps%rho_eq_geo
  !  points match near the axis and edge).  To avoid the approximation
  !  associated with interpolation, simply set rhowk = ps%rho_eq_geo.

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod
  use plasma_hash_code

  implicit NONE

  !-----------------------
  !  passed:

  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  !-----------------------
  !  local:

  integer :: kf1,kf2,idiff,iaddr,iertot,iwk

  logical :: intrp  ! .TRUE. if rhowk(1:nwk) not identical to ps%rho_eq_geo

  real(KIND=rspec), parameter :: ZERO = 0.0_rspec
  real(KIND=rspec), parameter :: ZTOL = 5.0e-7_rspec  ! for genxpkg

  real(KIND=rspec), dimension(:), allocatable :: Bmin,Bmax

  real(KIND=rspec), dimension(:,:), allocatable :: zxpkg
  integer, parameter :: ispline=1
  integer, parameter :: ilinear=0

  integer :: loc_cclist(ps_ccount),ipair(2)
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  call ps_mhdflx_errchk('ps_mhdeq_Bminmax',ps,nwk,rhowk,iout,ierr)
  if(ierr.ne.0) return

  call ps_rzsurf_hash(ps,kf1,kf2)

  idiff=1
  if(ps%B_surfMax(1).gt.ZERO) then

     !-----------------------
     !  hash code test

     loc_cclist = ps_cczero
     loc_cclist(ps_cnum_EQ)=ps_chkProfs  ! update EQ profile hashcodes only...
     call plasma_state_hash_code(ps,loc_cclist,ierr)
     if(ierr.ne.0) return

     idiff=0

     iaddr=ps_hash_aux1
     if((kf1.ne.ps%hash_codes(iaddr)).or.(kf2.ne.ps%hash_codes(iaddr+1))) then
        write(iout,*) ' %ps_mhdeq_Bminmax: volumes need updating...'
        call ps_mhdeq_volumes(ps,iout,ierr)
        if(ierr.ne.0) return
        call ps_mhdeq_fsmoms(ps,iout,ierr)
        if(ierr.ne.0) return
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        idiff=1
     else
        call addpair(ps_phash_g_eq)
        call addpair(ps_phash_psipol)
        call addpair(ps_phash_phit)
        iaddr=ps_hash_aux7
        if(kf1.ne.ps%hash_codes(iaddr)) idiff=idiff+1

        iaddr=iaddr+1
        if(kf2.ne.ps%hash_codes(iaddr)) idiff=idiff+1
     endif
  else
     call addpair(ps_phash_g_eq)
     call addpair(ps_phash_psipol)
     call addpair(ps_phash_phit)
  endif

  if(idiff.eq.0) return

  iaddr=ps_hash_aux7
  ps%new_hash_codes(iaddr)=kf1
  ps%new_hash_codes(iaddr+1)=kf2
  ps%hash_codes(iaddr)=kf1
  ps%hash_codes(iaddr+1)=kf2

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  intrp=.TRUE.
  if(nwk.eq.ps%nrho_eq_geo) then
     if(maxval(abs(ps%rho_eq_geo-rhowk)).lt.1.0e-12_rspec) intrp=.FALSE.
  endif

  if(intrp) then
     allocate(zxpkg(nwk,4))
     call genxpkg(nwk,rhowk,zxpkg,0,1,1,ztol,3,ierr)
  endif

  !------------------------------------------------------------
  ! compute mod(B) min/max

  allocate(Bmin(nwk),Bmax(nwk))

  do
     call xplasma_mag_axis(s,ierr, baxis=Bmin(1))
     if(ierr.ne.0) exit
     Bmax(1)=Bmin(1)

     do iwk = 2,nwk
        call xplasma_Bminmax(s,rhowk(iwk),ierr, bmin=Bmin(iwk), bmax=Bmax(iwk))
        if(ierr.ne.0) exit
     enddo
     if(ierr.ne.0) exit

     if(intrp) then
        call ps_mhdeq_intrp(nwk,zxpkg,Bmin,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%B_surfmin)
        call ps_mhdeq_intrp(nwk,zxpkg,Bmax,ps%nrho_eq_geo,ps%rho_eq_geo, &
             ispline,iout,ps%B_surfmax)
     else
        ps%B_surfmin = Bmin
        ps%B_surfmax = Bmax
     endif

     exit
  enddo

  deallocate(Bmin,Bmax)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_mhdeq_Bminmax: xplasma error while computing [R,Z]minmax:'
     call xplasma_error(s,ierr,iout)
     return
  endif

  contains

    subroutine addpair(iarg)
      integer :: iarg

      iaddr=iarg
      ipair(1)=ps%new_hash_codes(iaddr)
      ipair(2)=ps%new_hash_codes(iaddr+1)

      call hashCode(ipair,kf1,kf2)
    end subroutine addpair

end subroutine ps_mhdeq_Bminmax

subroutine ps_mhdflx_errchk(subname,ps,nwk,rhowk,iout,ierr)

  ! perform some common error checks

  !------------------------------------------------------------

  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  !-----------------------
  !  passed:

  character*(*), intent(in) :: subname    ! name of calling subroutine
  type (plasma_state) :: ps               ! plasma state object to be updated
  integer, intent(in) :: nwk              ! size of working grid
  real(KIND=rspec), intent(in) :: rhowk(nwk) ! working grid for integrations
  integer, intent(in) :: iout             ! Fortran LUN for messages
  integer, intent(out) :: ierr            ! exit status code 0=OK

  real(KIND=rspec), parameter :: ZTOL = 1.0e-10_rspec  ! grid range

  !-----------------------
  !  local:

  integer :: ii
  !-----------------------

  call ps_tagchk(subname,ps%itag,iout,ierr)
  if(ierr.ne.0) return

  if(ps%nrho_eq_geo.eq.0) then
     ierr=1
     write(iout,*) ' '//trim(subname)//': called but no rho_eq_geo grid found.'
     return
  endif

  if((abs(rhowk(1)).gt.ZTOL).or.(abs(rhowk(nwk)-1.0_rspec).gt.ZTOL)) then
     write(iout,*) ' ?'//trim(subname)//': rhowk grid does not span [0,1].'
     ierr=1
     return
  endif

  do ii=2,nwk
     if(rhowk(ii).le.rhowk(ii-1)) then
        write(iout,*) ' ?'//trim(subname)//': rhowk grid not in ascending order.'
        ierr=1
        return
     endif
  enddo

end subroutine ps_mhdflx_errchk
        

subroutine trxplib_clear_mdescr

  ! clear list of machine description files

  use trxplib_ps_options
  implicit NONE

  !---------------------------

  naux_mdescr = 0
  aux_mdescr = ' '

end subroutine trxplib_clear_mdescr

subroutine trxplib_add_mdescr(mdescr_file,ierr)

  ! add to list of machine description files.
  ! re-initialize ps_aux & ps -- if error occurs, restore list to prior state

  !   *** side effects: ps & ps_aux modified in plasma_state_mod ***
  !   For use with trxpl and trxpl2ps only...

  use trxplib_ps_options
  implicit NONE

  character*(*), intent(in) :: mdescr_file
  integer, intent(out) :: ierr

  !-------------------------------

  if(naux_mdescr.eq.max_naux) then
     write(0,*) ' ?? trxplib_ms_mdescr:  too many machine description files. '
     ierr=99
     return
  endif

  naux_mdescr = naux_mdescr + 1
  aux_mdescr(naux_mdescr) = mdescr_file

  call trx_init_state(ierr)

  if(ierr.ne.0) then
     ierr = 1
     aux_mdescr(naux_mdescr) = ' '
     naux_mdescr = naux_mdescr - 1
  endif

end subroutine trxplib_add_mdescr

subroutine trxplib_getnum_mdescr(inum)

  ! return number of recorded machine description files

  use trxplib_ps_options
  implicit NONE

  integer, intent(out) :: inum
  !---------------------------

  inum =  naux_mdescr

end subroutine trxplib_getnum_mdescr

subroutine trxplib_getfull_mdescr(indx,mdescr,ierr)

  ! return the indx'th mdescr file, full file path.
  ! ierr=2 and mdescr is returned blank if indx is out of range
  ! ierr=1 and mdescr is returned blank if no file is found in the
  !   (quasi-hard coded) search path

  use trxplib_ps_options
  implicit NONE

  integer, intent(in) :: indx
  character*(*), intent(out) :: mdescr
  integer,intent(out) :: ierr

  !---------------------------
  !  local...

  integer, parameter :: nsrch = 4
  character*30 :: dpath(nsrch) = (/ "LOCAL/tables/mdescr_nbi       ", &
                                    "CODESYSDIR/tables/mdescr_nbi  ", &
                                    "TRANSP_LOCATION/mdescr        ", &
                                    "                              "/)

  integer :: isrch,ilun,istat,ilen
  character*150 :: locdescr
  !---------------------------

  mdescr = ' '
  if((indx.le.0).OR.(indx.gt.naux_mdescr)) then
     ierr=1
     return
  endif

  locdescr = aux_mdescr(indx)

  call find_io_unit(ilun)

  do isrch=1,nsrch
     ilen=max(1,len(trim(dpath(isrch))))
     call ufilnam(dpath(isrch)(1:ilen),trim(locdescr),mdescr)
     open(unit=ilun,file=mdescr,status='old',action='read',iostat=istat)
     if(istat.eq.0) exit ! success
  enddo

  if(istat.eq.0) then
     close(unit=ilun)
     return  ! found file that exists
  else
     mdescr=' '
     ierr=1
  endif

end subroutine trxplib_getfull_mdescr

subroutine trxplib_getname_mdescr(indx,mdescr)

  ! return the indx'th mdescr file, full file path.
  ! return blank if indx out of range


  use trxplib_ps_options
  implicit NONE

  integer, intent(in) :: indx
  character*(*), intent(out) :: mdescr
  
  !--------------------

  mdescr = ' '
  if(indx.le.0) return
  if(indx.gt.naux_mdescr) return

  mdescr = aux_mdescr(indx)

end subroutine trxplib_getname_mdescr

subroutine ps_wrgeq_chk(ps,lbl_sub,iout,ierr)

  !---------------------------------------------------------------------
  ! check if PS object contains data needed to generate geqdsk output
  !---------------------------------------------------------------------

  use plasma_state_definition_mod
  implicit NONE

  !-----------------------
  ! arguments:

  type (plasma_state) :: ps            ! plasma state instance
  character*(*), intent(in) :: lbl_sub ! label to identify caller subroutine
  integer, intent(in) :: iout          ! I/O unit for messages
  integer, intent(out) :: ierr         ! status code output

  !-----------------------

  ierr = 0
  if(.not.allocated(ps%psirz)) then
     ierr = ierr + 1
     write(iout,*) ' ?'//trim(lbl_sub)//': not found: Psi(R,Z)'
  endif

  if(.not.allocated(ps%R_geo)) then
     ierr = ierr + 1
     write(iout,*) ' ?'//trim(lbl_sub)//': not found: R_geo'
  endif

  if(.not.allocated(ps%Z_geo)) then
     ierr = ierr + 1
     write(iout,*) ' ?'//trim(lbl_sub)//': not found: Z_geo'
  endif

  if(.not.allocated(ps%Rlim)) then
     ierr = ierr + 1
     write(iout,*) ' ?'//trim(lbl_sub)//': not found: limiter [R,Z] contour.'
  endif

end subroutine ps_wrgeq_chk

!--------------------------------------------------------------------
      subroutine trxpl_get_scalar(zname)
 
      implicit NONE
 
      include 'trxpl.blk'
      character*10, intent(inout) :: zname   ! name of scalar
 
      ! get a scalar (named by user); add it to the list.
 
      !---------------------
      logical lxout
      integer lnout
      !---------------------
 
      do
         if(lxout(0)) write(lnout(0),*)
     >      ' %trxpl: enter ".Q" to exit loop.'
 
         call ureadw('trxpl:  enter name of TRANSP/RPLOT scalar:$',
     >      zname)
 
         if(zname.eq.'.Q') exit
 
         call trxpl_add_scalar(zname)
 
      enddo
 
      return
      end
 

    subroutine splitn_io_list(  ixspl, cspl, nspl, ncspl, istat )
!.. splitn_io_list                      Return list of variables defining transp inputs
!
!
!     Author                            jim.conboy@jet.uk
!     Version                           1.11,  29Aug2007
!     Modifications
!
!     1.11  29Aug2007                   jim.conboy@jet.uk
!                                       Extracted from splitn_module
!
!     1.10  31Jul2007                   jim.conboy@jet.uk
!                                       ReWritten
!----_^---------------------------------=========================================|

      use splitn_module                                ! namelist interface ( iorder, splitn_cget
!
      implicit  none
!
!..GLOBAL
!--   variable                       :: name           ! description
!
!..Arguments
!
      integer, intent(inout)         :: ixspl          ! index to next entry
                                                       ! 0  => Start
                                                       ! -1 => end
      integer, intent(in)            :: nspl, &        ! dimension of cspl
                                        ncspl          ! length of (element of ) cspl

      character(len=ncspl),                        &
       dimension(1:nspl),intent(out) :: cspl           ! Array of
                                                       ! Ctri//Cpre//Cext

      integer, intent(out)           :: istat          ! return status, 0=OK
!
!..local
      integer, save                  :: iobg,  &       ! 1st io index
                                        ioen           ! Last io index
!
      integer                           i,     &
                                        im1,   &       ! 1st match flag
                                        im2,   &       ! 2nd match flag
                                        iv,    &       ! variable index
                                        ivo,   &       ! ordered variable ix
                                        idt,   &       ! chdatum index
                                        isz,   &       ! char array size
                                        ios,   &       ! io status
                                        ixcspl         ! index into cspl
!
      character(len=64)              :: cbuf
      character(len=nc_pre)         & 
                       ,dimension(8) :: cdatpre        ! Returned pre array
      character(len=nc_ext)         &
                       ,dimension(8) :: cdatext
!
      character(len=16)              :: cbl  = '                '
      character(len=12)               :: cix  = ' 12345678   '
      character(len=*),parameter     :: zcr='splitn_io_list'
!     character(len=*),parameter     :: cStop=cM//cr
!----_^------------------------------::================!.........................|
!
! nspl  =  size( cspl, 1 )                             ! only if in module
!
  if( ixspl == 0 )                                      then
     
!  find start & end of list

     call iorder( 'PREAAA', iobg, im1 )
     call iorder( 'PREZZZ', ioen, im2 )
                                                        endif

!d  write(6,*) iobg, ioen, im1, im2
 

     ixcspl  =  0
     istat   =  1
l_spec:  do                              ! loop over potential file specifiers
!
     idt = mod(ixspl, 8)
     if( idt == 0 )                      then
         ixspl = ixspl + 8
     else
         idt = idt + 1
     endif
     iv  = iobg+ixspl/8
!d   print *,ixcspl, ixspl/8
     if( iv >= ioen )                    then
!                          All done
        do i=ixcspl+1,nspl
           cspl(i)(1:4) = '   '
        enddo
        istat  =  0 ; ixcspl = -1
                                         exit l_spec
                                         endif
!
     ivo = var_order(iv)
     if( varlist(ivo)%rank > 0 )         then
       isz = varlist(ivo)%dims(2,1)
       if( idt == 0 ) idt = 1
       if( idt > isz)                 then
          idt = 0
                                      cycle l_spec
                                      endif
                                         else
       isz = 1 
       idt = 0
                                         endif
     ixspl = ixspl + idt
!
     if(     ixcspl == 0                     &
        .or. idt < 2           )                                then
        cdatpre = cbl
        cdatext = repeat(cbl(:8),nc_ext/8)
        call splitn_cget(varlist(ivo)%name,  &
                      len(cdatpre(1)), isz, cdatpre, ios)
        if( ios /= 0 ) &
          print *,zcr,': ',iv,ivo, varlist(ivo)%name

        call splitn_cget('EXT'//varlist(ivo)%name(4:6),  &
                      len(cdatext(1)), isz, cdatext, ios)
        if( ios /= 0 ) &
          print *,zcr,': ',iv,ivo, 'EXT'//varlist(ivo)%name(4:6) &
                          ,varlist(ivo)%name, cdatpre
                                                                endif
     if( cdatpre(max(1,idt))(:8) .eq. 'ZZZZZZZZ' )              then
        ixspl = 8*(ixspl/8)
                                                                cycle l_spec  ! skip if defaulted
                                                                endif

!
     ixcspl  =  ixcspl + 1
!d*  print *,ixcspl,ixspl,idt,ivo,varlist(ivo)%name
     cspl(ixcspl)(              1:nc_tri+1)        = varlist(ivo)%name(4:6)//cix(idt+1:idt+1)  ! trigraph
     cspl(ixcspl)(       nc_tri+2:nc_tri+1+nc_pre) = cdatpre(max(1,idt))                       ! pre
     cspl(ixcspl)(nc_tri+nc_pre+2:)                = cdatext(max(1,idt))                       ! ext
!
     if( ixcspl >= nspl)                 then
                                         exit l_spec
                                         endif
!
!d   print *,trim(cspl(ixcspl))
!
  enddo  l_spec

  end subroutine splitn_io_list

subroutine ps_species_list_store(iobj, listname, iauthor, dim1, dim2, &
     elem_names, qatoms, qvals, mvals, itypes, imod, iout,ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a species list, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)     ! xplasma opaque container

  character*(*), intent(in) :: listname    ! NAME of list to store

  integer, intent(in) :: iauthor           ! author ID

  integer, intent(in) :: dim1,dim2         ! array dimension limits

  character*(*), intent(in) :: elem_names(dim1:dim2) ! specie names

  REAL(kind=rspec), intent(in) :: qatoms(dim1:dim2)  ! atomic charges (C)
  REAL(kind=rspec), intent(in) :: qvals(dim1:dim2)   ! specie charges (C)
  REAL(kind=rspec), intent(in) :: mvals(dim1:dim2)   ! specie masses (kg)
  integer, intent(in) :: itypes(dim1:dim2)           ! specie type

  integer, intent(out) :: imod             ! =1 if profile is new or modified
  !  =0 on output if profile was not changed.

  integer, intent(in) :: iout              ! Fortran LUN for messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: ielems,ie,id,iertmp,inum,idiff,iz,itype,ilen
  character*32 units,section
  character*32 tmp_label
  integer, dimension(:), allocatable :: ivals,ichek
  REAL(kind=rspec), dimension(:), allocatable :: r8vals,r8chek
  character*32, dimension(:), allocatable :: chvals
  character*32, dimension(:), allocatable :: namchek

  REAL(kind=rspec) :: zdiff,zdenom
  REAL(kind=rspec), parameter :: ztol = 1.0e-12_rspec

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  imod = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' %ps_species_list_store: invalid or unitialized xplasma object.'
     return
  endif

  !--------------------------------------------------
  if(dim2.lt.dim1) then
     ierr=901
     write(iout,*) ' ?ps_species_list_store: dimensioning error:'
     write(iout,*) '  list dimension lower limit: ',dim1
     write(iout,*) '  list dimension upper limit: ',dim2
     write(iout,*) '  list name: ',trim(listname)
     return
  endif

  !--------------------------------------------------
  !  set up to use ps_list_store call

  allocate(ivals(dim1:dim2),r8vals(dim1:dim2),chvals(dim1:dim2))
  allocate(ichek(dim1:dim2),r8chek(dim1:dim2),namchek(dim1:dim2))
  chvals = ' '
  ilen=len(chvals(1))

  do ie=dim1,dim2
     if(qvals(ie).lt.0.0_rspec) then
        ivals(ie)=-int(abs(qvals(ie))/ps_xe + 0.1_rspec)
     else
        ivals(ie)=qvals(ie)/ps_xe + 0.1_rspec
     endif
     r8vals(ie)=mvals(ie)/ps_mp

     !  store atomic no. and type in character buffer
     if(qatoms(ie).lt.0.0_rspec) then
        iz=-int(abs(qatoms(ie))/ps_xe + 0.1_rspec)
     else
        iz=qatoms(ie)/ps_xe + 0.1_rspec
     endif
     itype = itypes(ie)

     write(chvals(ie),'("Z:",i3," Type:",i3)') iz,itype
     if(itype.eq.ps_electron) then
        chvals(ie)(16:ilen)='(electrons)'
     else if(itype.eq.ps_therm_ion) then
        chvals(ie)(16:ilen)='(thermal ion)'
     else if(itype.eq.ps_impurity) then
        chvals(ie)(16:ilen)='(impurity)'
     else if(itype.eq.ps_tokamakium) then
        chvals(ie)(16:ilen)='(Tokamakium)'
     else if(itype.eq.ps_beam_ion) then
        chvals(ie)(16:ilen)='(beam ion)'
     else if(itype.eq.ps_rf_minority) then
        chvals(ie)(16:ilen)='(RF minority)'
     else if(itype.eq.ps_fusion_ion) then
        chvals(ie)(16:ilen)='(fusion ion)'
     else
        ierr=99
        write(iout,*) ' ?ps_species_list_store: specie #',ie
        write(iout,*) '  unrecognized type code: ',itype
        write(iout,*) '  list name: ',trim(listname)
     endif
  enddo
  if(ierr.ne.0) return

  ielems = dim2 - dim1 + 1

  section = 'SPECIES_LIST'
  units = ' '
  tmp_label = 'species list'

  !  read list first if available; check for data match with tolerance.
  !  this to avoid spurious reports of change in speciel list values.

  idiff=1
  call xplasma_listId(s,listname,id)
  if(id.gt.0) then
     call xplasma_list_info(s,id,iertmp, nelems=inum)
     if(inum.eq.ielems) then
        call xplasma_getList_names(s,id,namchek(dim1:dim2),iertmp, &
             ivals=ichek(dim1:dim2),r8vals=r8chek(dim1:dim2))
        if(iertmp.eq.0) then
           idiff=0
           do ie=dim1,dim2
              if(namchek(ie).ne.elem_names(ie)) then
                 idiff=1
                 exit
              endif
              if(ichek(ie).ne.ivals(ie)) then
                 idiff=1
                 exit
              endif
              zdenom=max(abs(r8vals(ie)),abs(r8chek(ie)))
              zdenom=max(zdenom,(ztol*ztol))
              zdiff=abs(r8vals(ie)-r8chek(ie))/zdenom
              if(zdiff.gt.ztol) then
                 idiff=1
                 exit
              endif
           enddo
        endif
     endif
  endif

  if(idiff.eq.0) then
     imod=0

  else
     call ps_list_store(section, iobj, listname, &
          iauthor, units, tmp_label, &
          ielems, elem_names, ivals, r8vals, chvals, &
          imod, iout, ierr)
  endif

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_species_list_store: error code = ',ierr
     write(iout,*) '  returned by ps_list_store call.'
  endif

  deallocate(ivals,r8vals,chvals,ichek,r8chek,namchek)

end subroutine ps_species_list_store

c--------------------------------------------------
      subroutine trxpl_mkgs2_write(tlabel)
c
c  write namelists
c
      use trxpl_gs2_module
      implicit NONE
c
      character*(*) tlabel   ! TRANSP time label
c
c----------------------
c
      real*8 zrho,zeff
      character*24 zdate
c
      character*120 zfile1,zfile2
c
      integer luni,luno
      integer ipass,ierr,istat
      integer i,j,k,ilp
c
      integer lparams,lsknobs,lzeff,lbeta,lgrid(4),lgrd2(2)
      integer iflag_cwd
c
      logical lxout
      integer lnout
c----------------------
c
      luni=88                           ! template (input) namelist
      luno=89                           ! output namelist
c
 10   continue
c
c----------------------------
c  get (or skip) template file
c
      if(lxout(0).and.(mpath0.eq.' ')) write(lnout(0),*)
     >   'enter "S" to skip, i.e. not to use a template file.'
      call trxpl_gs2_file('TEMPLATE_FILE',mpath0,mpath,zfile1)
      if(zfile1.eq.'q') return
      if(zfile1.eq.'Q') return
      if((zfile1.eq.'s').or.(zfile1.eq.'S')) then
         luni=0
      else
         ierr=1
         call ufopen(luni,zfile1,1,ierr,0)
         if(ierr.ne.0) then
            call uermsg('trxpl_mkgs2_write:  open failure: ',zfile1,0)
            go to 10
         endif
      endif
c
c------------------------------
c
c  in a loop, specify rho values and output filenames
c
      ipass=0
c
 100  continue
c
      ipass=ipass+1
      if((ipass.gt.1).and.(luni.gt.0)) then
         rewind luni
      endif
c
c  get rho value
c
 110  continue
      zrho=-99.0d0
      if(lxout(0))
     >   write(lnout(0),*) 'enter negative number to exit write loop.'
      call ureadr8('enter "rho" flux surface coordinate:$',zrho)
      if(zrho.lt.0.0d0) then
         if(luni.gt.0) close(unit=luni)
         return
      endif
c
      if(zrho.gt.1.0d0) then
         call uermsg(' ?rho must be between 0.0 and 1.0 ',' ',0)
         go to 110
      endif
c
      transp_x = zrho
c
      call trxpl_gs2_get(zrho,ierr)
      if(ierr.ne.0) then
         call uermsg('?trxpl_gs2_get data error.',' ',0)
         go to 110
      endif
c
      zeff=0.0
      do i=2,num_species
         zeff=zeff+nvec(i)*zvec(i)*zvec(i)
      enddo
      zeff=zeff/nvec(1)
c
c  get output filename
c
      call trxpl_gs2_file('OUTPUT_FILE',opath0,opath,zfile2)
      if(zfile2.eq.'q') go to 110
      if(zfile2.eq.'Q') go to 110
c
      open(unit=luno,file=zfile2,status='old',iostat=istat)
      if(istat.eq.0) then
         close(unit=luno)
         i=len_trim(zfile2)
         call frename(zfile2(1:i),zfile2(1:i)//'~',ierr)
      endif
      call ufopen(luno,zfile2,2,ierr,0)
      if(ierr.ne.0) then
         call uermsg('?trxpl_mkgs2:  open failure.',zfile2,0)
         go to 110
      endif
c
      call fdate(zdate)
c
      i=len_trim(transp_path)
      j=len_trim(tlabel)
      write(luno,1001) zdate,username,hostname,
     >   transp_path(1:i),tlabel(1:j),zrho,
     >   tref_lbl,mass_ref,aminor,tref,tref_lbl,nref,
     >   zeff_tr,zeff_calc,renorm_nz,renorm_gradnz,fast_aggr
 1001 format(/
     >   '!_trxpl: GS2 namelist'/
     >   '!_trxpl: written on ',a,' by "trxpl"'/
     >   '!_trxpl: username: ',a/
     >   '!_trxpl: hostname: ',a/
     >   '!_trxpl: TRANSP run: ',a/
     >   '!_trxpl: at: ',a/
     >   '!_trxpl: and: rho surface: ',1pe16.9,' (norm.sqrt.tor.flux)'//
     >   '!_trxpl: Tref=',a,', nref=ne, mass_ref=',1pe11.4,
     >       ' a=',1pe11.4,' meters.'/
     >   '!_trxpl:     Tref = ',1pe11.4,' KeV   (',a,')'/
     >   '!_trxpl:     nref = ',1pe11.4,' m**-3 (ne)'/
     >   '!_trxpl: Z_ref= 1.0000 ',
     >       ' Zeff(transp)=',1pe11.4,' Zeff(calc)=',1pe11.4/
     >   '!_trxpl: quasineutrality ne/sum(nZ) renormalization:',1pe11.4/
     >   '!_trxpl: quasineutrality grad(ne)/grad(sum(nZ))',
     >       ' renormalization:',1pe11.4/
     >   '!_trxpl: fast/thermal aggregation option: ',L1)
      if(luni.gt.0) then
         i=len_trim(zfile1)
         write(luno,1002) zfile1(1:i)
 1002    format('!_trxpl:  template file:  ',a)
      endif
c
      if(luni.eq.0) then
c
         call trxpl_nlist_write_all(luno,.TRUE.,.TRUE.,.TRUE.)
c
      else
         call trxpl_nlist_find(luni,lparams,lzeff,lbeta,lsknobs,lgrid,
     >        lgrd2)
         call trxpl_nlist_copy(luni,luno,lparams,lzeff,lbeta,lsknobs,
     >        lgrid,lgrd2)
      endif
c
      close(unit=luno)
      go to 100
c
      end

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_xload(ss,ierr)

  ! store plasma state data in xplasma
  ! enable interpolation services

  ! scalar data is written if section hashes indicate change, or if tests
  ! indicate t

  ! grid data items are written if hashes indicate change, or if grid IDs
  ! cannot be found in xplasma

  ! profile data is written if hashes indicate change of id ss%id_<profile>
  ! variables are zero.

  USE plasma_state_definition_mod
  IMPLICIT NONE

  TYPE (plasma_state) :: ss     ! state data to write into xplasma
  INTEGER, INTENT(OUT) :: ierr  ! completion code (0=OK)

  !-----------------------
  ! local:

  INTEGER, PARAMETER :: max_itemlist = ps_max_static

  CHARACTER*32 :: listname,gridname,profname,enum_name,units,list_units
  CHARACTER*80 :: label,plabel,list_label
  INTEGER :: icomponent

  INTEGER :: nitems
  CHARACTER*32 :: item_names(max_itemlist)
  INTEGER :: item_ivals(max_itemlist)
  REAL(KIND=rspec) :: item_r8vals(max_itemlist)
  CHARACTER*256 :: item_c256(max_itemlist)

  INTEGER :: i1,i2,i3,i4,indx,itype,isize
  CHARACTER*32 :: nam1,nam2,nam3,nam4,iiencod,tmpnam,vid_found
  CHARACTER*80 :: ilab1,ilab2,ilab3,ilab4
  INTEGER :: iout,imod,jmod,iconvert,iertmp,iwarn,idchk

  INTEGER :: xhash(ps_hash_total)
  INTEGER :: ahash(ps_max_static)

  !-----------------------
  ! for enumeration labeling...
  CHARACTER*32, DIMENSION(:), ALLOCATABLE :: enum_lbl_1d
  CHARACTER*32, DIMENSION(:,:), ALLOCATABLE :: enum_lbl_NPHI

  !-----------------------
  ! for ps_rezone_rho(...)

  REAL(KIND=rspec), dimension(2) :: x01 = (/ 0.0_rspec, 1.0_rspec /)
  INTEGER :: idvec(1),idwvec(1)
  REAL(KIND=rspec) :: ansvec(1,1),dvvec(1)
  INTEGER :: id_intg

  !-----------------------

  iout = SWIM_err_out_file

  CALL ps_xhashes_get(ss%iobj,xhash,iout,ierr)
  IF(ierr.NE.0) RETURN

  !----------------------------------------------------
  ! check for valid sets of names, non-coordinate dimensions:
  ierr = 0

  ahash(1) = ps_dhash_MMODES
  IF(ALLOCATED(ss%Tor_mode_label).AND.hcheck(1,1)) THEN
     CALL ps_name_check("Tor_mode_label",1,ss%mmodes,ss%Tor_mode_label,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NBALLOON
  IF(ALLOCATED(ss%Balloon_code).AND.hcheck(1,1)) THEN
     CALL ps_name_check("Balloon_code",1,ss%nballoon,ss%Balloon_code,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NBEAM
  IF(ALLOCATED(ss%nbi_src_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("nbi_src_name",1,ss%nbeam,ss%nbi_src_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NCIRCUITS
  IF(ALLOCATED(ss%circuit_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("circuit_name",1,ss%ncircuits,ss%circuit_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NCOILS
  IF(ALLOCATED(ss%coil_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("coil_name",1,ss%ncoils,ss%coil_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NDELTA_W
  IF(ALLOCATED(ss%DeltaW_code).AND.hcheck(1,1)) THEN
     CALL ps_name_check("DeltaW_code",1,ss%ndelta_w,ss%DeltaW_code,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NECRF_SRC
  IF(ALLOCATED(ss%ecrf_src_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("ecrf_src_name",1,ss%necrf_src,ss%ecrf_src_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NEQMOM
  IF(ALLOCATED(ss%eqmom_num).AND.hcheck(1,1)) THEN
     CALL ps_name_check("eqmom_num",1,ss%neqmom,ss%eqmom_num,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NGSC0
  IF(ALLOCATED(ss%gs_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("gs_name",1,ss%ngsc0,ss%gs_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NICRF_SRC
  IF(ALLOCATED(ss%icrf_src_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("icrf_src_name",1,ss%nicrf_src,ss%icrf_src_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NLHRF_SRC
  IF(ALLOCATED(ss%lhrf_src_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("lhrf_src_name",1,ss%nlhrf_src,ss%lhrf_src_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NNEWCOMB
  IF(ALLOCATED(ss%Newcomb_code).AND.hcheck(1,1)) THEN
     CALL ps_name_check("Newcomb_code",1,ss%nnewcomb,ss%Newcomb_code,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NPSMOM
  IF(ALLOCATED(ss%psmom_num).AND.hcheck(1,1)) THEN
     CALL ps_name_check("psmom_num",1,ss%npsmom,ss%psmom_num,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_ALL
  IF(ALLOCATED(ss%ALL_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("ALL_name",0,ss%nspec_all,ss%ALL_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_ALLA
  IF(ALLOCATED(ss%ALLA_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("ALLA_name",0,ss%nspec_alla,ss%ALLA_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_BEAM
  IF(ALLOCATED(ss%SNBI_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SNBI_name",1,ss%nspec_beam,ss%SNBI_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_FUSION
  IF(ALLOCATED(ss%SFUS_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SFUS_name",1,ss%nspec_fusion,ss%SFUS_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_GAS
  IF(ALLOCATED(ss%SGAS_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SGAS_name",1,ss%nspec_gas,ss%SGAS_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_IMP0
  IF(ALLOCATED(ss%SIMP0_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SIMP0_name",1,ss%nspec_imp0,ss%SIMP0_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_IMPI
  IF(ALLOCATED(ss%SIMPI_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SIMPI_name",1,ss%nspec_impi,ss%SIMPI_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_RFMIN
  IF(ALLOCATED(ss%RFMIN_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("RFMIN_name",1,ss%nspec_rfmin,ss%RFMIN_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_TH
  IF(ALLOCATED(ss%S_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("S_name",0,ss%nspec_th,ss%S_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NSPEC_THA
  IF(ALLOCATED(ss%SA_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("SA_name",0,ss%nspec_tha,ss%SA_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NTRCAT
  IF(ALLOCATED(ss%trcat).AND.hcheck(1,1)) THEN
     CALL ps_name_check("trcat",1,ss%ntrcat,ss%trcat,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  ahash(1) = ps_dhash_NXS
  IF(ALLOCATED(ss%xs_name).AND.hcheck(1,1)) THEN
     CALL ps_name_check("xs_name",1,ss%nxs,ss%xs_name,iout,iertmp)
     ierr = max(ierr,iertmp)
  ENDIF

  !----------------------------------------------------
  ! generated integer enumeration labels
  isize = 1
  isize = max(isize,ss%num_rzlim)
  isize = max(isize,ss%n_h_einj_standard)
  isize = max(isize,ss%n_d_einj_standard)
  isize = max(isize,ss%n_t_einj_standard)
  isize = max(isize,ss%max_nrz_antgeo)
  isize = max(isize,ss%max_n_straps)
  isize = max(isize,ss%max_num_nphi_vac)
  isize = max(isize,ss%max_nspectrumlh_src)
  isize = max(isize,ss%nky_anomth)
  isize = max(isize,ss%nky_mmm)

  ALLOCATE(enum_lbl_1d(isize))
  DO i1 = 1,isize
     enum_lbl_1d(i1) = " "
     WRITE(enum_lbl_1d(i1),"(I8)") i1
     CALL lefpack(enum_lbl_1d(i1))
  ENDDO

  IF(ALLOCATED(ss%nphi)) THEN
     ALLOCATE(enum_lbl_nphi(ss%max_num_nphi,ss%nicrf_src))
     enum_lbl_nphi = " "
     CALL load_lbl_2d(ss%num_nphi,ss%nphi,enum_lbl_nphi)
  ENDIF

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store and perform error check on coordinate grids

  CALL plasma_state_xload_grids(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store species lists

  CALL plasma_state_xload_slists(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store the time (t1)

  call ps_time_set(ss%iobj,ss%t1,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store scalar groups as lists

  CALL plasma_state_xload_sgrps(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store standalone scalars as single valued lists
  ! store 1d enumerated arrays: list + blackbox

  CALL plasma_state_xload_singl(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store allocatable scalar arrays (non-profile data)
  ! this includes 2d enumerations.

  CALL plasma_state_xload_sarrays(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store singleton profiles with single valued lists

  CALL plasma_state_xload_psingl(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store profiles in groups; groups themselves as lists

  CALL plasma_state_xload_pgrps(ss,xhash,iout,ierr)

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! store indexed arrays of profiles
  ! "parrays" subroutine handles non-enumerated subset.

  CALL plasma_state_xload_parrays(ss,xhash,iout,ierr)

  ahash(1) = ps_phash_CDICRF_NPHI
  idchk = 0
  IF(ALLOCATED(ss%id_cdicrf_nphi)) idchk = ss%id_cdicrf_nphi(1,1)
  IF(ALLOCATED(ss%cdicrf_nphi).AND.hcheck(1,idchk)) THEN
     listname = "CDICRF_NPHI_LIST"
     icomponent = ps_cnum_IC
     units = "A"
     label = "ICRF current drive"
     ! for assoc. scalar list:
     list_units = "A"
     list_label = "area int: cdicrf_nphi"

     nitems = 0
     jmod = 0
     DO I2 = 1,ss%nicrf_src
        NAM2 = TRIM(ss%icrf_src_name(I2))
        ILAB2 = 'icrf_source: '//TRIM(ss%icrf_src_name(I2))
        DO I1 = 1,ss%max_num_nphi
           IF(enum_lbl_nphi(I1,I2)(1:1).eq.' ') CYCLE
           NAM1 = TRIM(enum_lbl_nphi(I1,I2))//'_'//TRIM(NAM2)
           iiencod = ' '
           WRITE(iiencod,'(I8)') ss%nphi(I1,I2)
           CALL lefpack(iiencod)
           ILAB1 = 'nphi='//TRIM(iiencod)//' '//TRIM(ILAB2)
           nitems = nitems + 1
           IF(nitems.GT.max_itemlist) THEN
              WRITE(iout,*) " ?plasma_state_xload:  max list size (",max_itemlist,") exceeded."
              WRITE(iout,*) "  regen plasma state software with larger value of ps_max_static in plasma_state_spec.dat"
              ierr = 9999
              RETURN
           ENDIF
           item_names(nitems) = "cdicrf_nphi_"//TRIM(NAM1)
           item_c256(nitems) = ILAB1
           plabel = TRIM(label)//": "//TRIM(nam1)
           profname = "cdicrf_nphi_"//TRIM(nam1)
           CALL ps_1d_prof_store(ss%iobj,profname,"RHO_ICRF", &
                units,icomponent,plabel,ps_stepda,ps_bc_dflt, &
                ss%nrho_icrf-1,0, &
                ss%cdicrf_nphi(:,I1,I2),ss%id_cdicrf_nphi(I1,I2), &
                imod,iout,ierr)
           IF(ierr.NE.0) RETURN
           IF(imod.gt.0) jmod = 1
           item_r8vals(nitems) = 0.0_rspec
           item_ivals(nitems) = ss%id_cdicrf_nphi(I1,I2)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,list_label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICRF_NPHI_SRCS
  idchk = 0
  IF(ALLOCATED(ss%id_picrf_nphi_srcs)) idchk = ss%id_picrf_nphi_srcs(1,1,1)
  IF(ALLOCATED(ss%picrf_nphi_srcs).AND.hcheck(1,idchk)) THEN
     listname = "PICRF_NPHI_SRCS_LIST"
     icomponent = ps_cnum_IC
     units = "W"
     label = "direct ICRF power deposition"
     ! for assoc. scalar list:
     list_units = "W"
     list_label = "vol int: PICRF_NPHI"

     nitems = 0
     jmod = 0
     DO I3 = 0,ss%nspec_alla
        NAM3 = TRIM(ss%ALLA_name(I3))
        ILAB3 = 'specie: '//TRIM(ss%ALLA_name(I3))
        DO I2 = 1,ss%nicrf_src
           NAM2 = TRIM(ss%icrf_src_name(I2))//'_'//TRIM(NAM3)
           ILAB2 = 'icrf_source: '//TRIM(ss%icrf_src_name(I2))//' '//TRIM(ILAB3)
           DO I1 = 1,ss%max_num_nphi
              IF(enum_lbl_nphi(I1,I2)(1:1).eq.' ') CYCLE
              NAM1 = TRIM(enum_lbl_nphi(I1,I2))//'_'//TRIM(NAM2)
              iiencod = ' '
              WRITE(iiencod,'(I8)') ss%nphi(I1,I2)
              CALL lefpack(iiencod)
              ILAB1 = 'nphi='//TRIM(iiencod)//' '//TRIM(ILAB2)
              nitems = nitems + 1
              IF(nitems.GT.max_itemlist) THEN
                 WRITE(iout,*) " ?plasma_state_xload:  max list size (",max_itemlist,") exceeded."
                 WRITE(iout,*) "  regen plasma state software with larger value of ps_max_static in plasma_state_spec.dat"
                 ierr = 9999
                 RETURN
              ENDIF
              item_names(nitems) = "PICRF_NPHI_"//TRIM(NAM1)
              item_c256(nitems) = ILAB1
              plabel = TRIM(label)//": "//TRIM(nam1)
              profname = "PICRF_NPHI_"//TRIM(nam1)
              CALL ps_1d_prof_store(ss%iobj,profname,"RHO_ICRF", &
                   units,icomponent,plabel,ps_stepdv,ps_bc_dflt, &
                   ss%nrho_icrf-1,0, &
                   ss%picrf_nphi_srcs(:,I1,I2,I3),ss%id_picrf_nphi_srcs(I1,I2,I3), &
                   imod,iout,ierr)
              IF(ierr.NE.0) RETURN
              IF(imod.gt.0) jmod = 1
              item_r8vals(nitems) = 0.0_rspec
              item_ivals(nitems) = ss%id_picrf_nphi_srcs(I1,I2,I3)
           ENDDO   ! I1
        ENDDO   ! I2
     ENDDO   ! I3

     CALL ps_list_store("STATE_PROFILES", ss%iobj, &
          listname,icomponent,list_units,list_label, &
          nitems,item_names,item_ivals,item_r8vals, &
          item_c256,imod,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  IF(ierr.GT.0) RETURN

  !----------------------------------------------------
  ! ALL PROFILES STORED -- update weight IDs

  CALL plasma_state_zonwt_update(ss,ierr)
  IF(ierr.NE.0) return

  !  check if rezone integrals are available (this depends on an equilibrium
  !  being included in the state).

  CALL ps_rezone_chk(ss,id_intg,iout,ierr)
  IF(ierr.NE.0) return

  !  id_intg=0 indicates no rezone available.

  !----------------------------------------------------
  ! profile group list values updated here...

  ahash(1) = ps_phash_DIFB_NBI
  ahash(2) = ps_phash_DIFB_FUSI
  ahash(3) = ps_phash_DIFB_RFMI
  IF(ALLOCATED(ss%difb_nbi).AND.hcheck(3,1)) THEN
     listname = "ANOM_DIFFUS"
     icomponent = ps_cnum_ANOM
     nitems = 3
     ansvec(1,1) = sum(ss%difb_nbi)/size(ss%difb_nbi)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%difb_fusi)/size(ss%difb_fusi)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = sum(ss%difb_rfmi)/size(ss%difb_rfmi)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELB_NBI
  ahash(2) = ps_phash_VELB_FUSI
  ahash(3) = ps_phash_VELB_RFMI
  IF(ALLOCATED(ss%velb_nbi).AND.hcheck(3,1)) THEN
     listname = "ANOM_VELOC"
     icomponent = ps_cnum_ANOM
     nitems = 3
     ansvec(1,1) = sum(ss%velb_nbi)/size(ss%velb_nbi)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%velb_fusi)/size(ss%velb_fusi)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = sum(ss%velb_rfmi)/size(ss%velb_rfmi)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PB0_HALO
  ahash(2) = ps_phash_PSC_HALO
  ahash(3) = ps_phash_PCX_HALO
  IF(ALLOCATED(ss%pb0_halo).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "BEAM_HALO_POWER"
     icomponent = ps_cnum_NBI
     nitems = 3
     idvec(1) = ss%id_pb0_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_psc_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_pcx_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQB0_HALO
  ahash(2) = ps_phash_TQSC_HALO
  ahash(3) = ps_phash_TQCX_HALO
  IF(ALLOCATED(ss%tqb0_halo).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "BEAM_HALO_TORQUE"
     icomponent = ps_cnum_NBI
     nitems = 3
     idvec(1) = ss%id_tqb0_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_tqsc_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_tqcx_halo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PBE
  ahash(2) = ps_phash_PBI
  ahash(3) = ps_phash_PBTH
  IF(ALLOCATED(ss%pbe).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "BEAM_HEATING"
     icomponent = ps_cnum_NBI
     nitems = 3
     idvec(1) = ss%id_pbe
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_pbi
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_pbth
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQBE
  ahash(2) = ps_phash_TQBI
  ahash(3) = ps_phash_TQBJXB
  ahash(4) = ps_phash_TQBTH
  IF(ALLOCATED(ss%tqbe).AND.(id_intg.GT.0).AND.hcheck(4,1)) THEN
     listname = "BEAM_TORQUE"
     icomponent = ps_cnum_NBI
     nitems = 4
     idvec(1) = ss%id_tqbe
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_tqbi
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_tqbjxb
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)
     idvec(1) = ss%id_tqbth
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(4) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_B_SURFMAX
  ahash(2) = ps_phash_B_SURFMIN
  IF(ALLOCATED(ss%B_surfMax).AND.hcheck(2,1)) THEN
     listname = "BMINMAX"
     icomponent = ps_cnum_EQ
     nitems = 2
     ansvec(1,1) = ss%B_surfMax(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%B_surfMin(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QCOMP_E
  ahash(2) = ps_phash_QCOMP_I
  IF(ALLOCATED(ss%qcomp_e).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "COMPRESSION"
     icomponent = ps_cnum_PLASMA
     nitems = 2
     idvec(1) = ss%id_qcomp_e
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_qcomp_i
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_TRANS
  ahash(2) = ps_phash_CHII_TRANS
  ahash(3) = ps_phash_CHIMO_TRANS
  IF(ALLOCATED(ss%chie_trans).AND.hcheck(3,1)) THEN
     listname = "DIFFUSIVITY"
     icomponent = ps_cnum_PLASMA
     nitems = 3
     ansvec(1,1) = sum(ss%chie_trans)/size(ss%chie_trans)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%chii_trans)/size(ss%chii_trans)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = sum(ss%chimo_trans)/size(ss%chimo_trans)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PFUSE
  ahash(2) = ps_phash_PFUSI
  ahash(3) = ps_phash_PFUSTH
  IF(ALLOCATED(ss%pfuse).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "FUSION_HEATING"
     icomponent = ps_cnum_FUS
     nitems = 3
     idvec(1) = ss%id_pfuse
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_pfusi
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_pfusth
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PELH
  ahash(2) = ps_phash_PILH
  IF(ALLOCATED(ss%pelh).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "LOWER_HYBRID_HEATING"
     icomponent = ps_cnum_LH
     nitems = 2
     idvec(1) = ss%id_pelh
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_pilh
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z_MIDP
  ahash(2) = ps_phash_R_MIDP_IN
  ahash(3) = ps_phash_R_MIDP_OUT
  IF(ALLOCATED(ss%Z_midp).AND.hcheck(3,1)) THEN
     listname = "MIDPLANE"
     icomponent = ps_cnum_EQ
     nitems = 3
     ansvec(1,1) = ss%Z_midp(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%R_midp_in(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = ss%R_midp_out(ss%nrho_eq_geo)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PMINE
  ahash(2) = ps_phash_PMINI
  ahash(3) = ps_phash_PMINTH
  IF(ALLOCATED(ss%pmine).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "MINORITY_HEATING"
     icomponent = ps_cnum_IC
     nitems = 3
     idvec(1) = ss%id_pmine
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_pmini
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_pminth
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VEE_TRANS
  ahash(2) = ps_phash_VIE_TRANS
  ahash(3) = ps_phash_VMO_TRANS
  IF(ALLOCATED(ss%vee_trans).AND.hcheck(3,1)) THEN
     listname = "RADIAL_VELOCITY"
     icomponent = ps_cnum_PLASMA
     nitems = 3
     ansvec(1,1) = sum(ss%vee_trans)/size(ss%vee_trans)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%vie_trans)/size(ss%vie_trans)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = sum(ss%vmo_trans)/size(ss%vmo_trans)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PRAD
  ahash(2) = ps_phash_PRAD_CY
  ahash(3) = ps_phash_PRAD_BR
  ahash(4) = ps_phash_PRAD_LI
  IF(ALLOCATED(ss%prad).AND.(id_intg.GT.0).AND.hcheck(4,1)) THEN
     listname = "RADIATED_POWERS"
     icomponent = ps_cnum_RAD
     nitems = 4
     idvec(1) = ss%id_prad
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_prad_cy
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_prad_br
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)
     idvec(1) = ss%id_prad_li
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(4) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_P0_RECO
  ahash(2) = ps_phash_PSC_RECO
  ahash(3) = ps_phash_PCX_RECO
  IF(ALLOCATED(ss%p0_reco).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "RECO_POWER"
     icomponent = ps_cnum_GAS
     nitems = 3
     idvec(1) = ss%id_p0_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_psc_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_pcx_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ0_RECO
  ahash(2) = ps_phash_TQSC_RECO
  ahash(3) = ps_phash_TQCX_RECO
  IF(ALLOCATED(ss%tq0_reco).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "RECO_TORQUE"
     icomponent = ps_cnum_GAS
     nitems = 3
     idvec(1) = ss%id_tq0_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_tqsc_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_tqcx_reco
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RES_TE
  ahash(2) = ps_phash_RES_TI
  IF(ALLOCATED(ss%res_te).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "RESIDUAL"
     icomponent = ps_cnum_PLASMA
     nitems = 2
     idvec(1) = ss%id_res_te
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_res_ti
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TFRIP_LOG
  ahash(2) = ps_phash_TFRIP2_LOG
  IF(ALLOCATED(ss%tfrip_log).AND.hcheck(2,1)) THEN
     listname = "RIPPLE_FIELDS"
     icomponent = ps_cnum_RIPPLE
     nitems = 2
     ansvec(1,1) = sum(ss%tfrip_log)/size(ss%tfrip_log)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%tfrip2_log)/size(ss%tfrip2_log)
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RMAJOR_MEAN
  ahash(2) = ps_phash_RMINOR_MEAN
  IF(ALLOCATED(ss%Rmajor_mean).AND.hcheck(2,1)) THEN
     listname = "RMAJMIN"
     icomponent = ps_cnum_EQ
     nitems = 2
     ansvec(1,1) = ss%Rmajor_mean(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%rMinor_mean(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QROT_CONV
  ahash(2) = ps_phash_QROT_DIFF
  IF(ALLOCATED(ss%qrot_conv).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "ROTATION_DISSIPATION"
     icomponent = ps_cnum_PLASMA
     nitems = 2
     idvec(1) = ss%id_qrot_conv
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_qrot_diff
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R_SURFMAX
  ahash(2) = ps_phash_R_SURFMIN
  ahash(3) = ps_phash_Z_SURFMAX
  ahash(4) = ps_phash_Z_SURFMIN
  IF(ALLOCATED(ss%R_surfMax).AND.hcheck(4,1)) THEN
     listname = "RZMINMAX"
     icomponent = ps_cnum_EQ
     nitems = 4
     ansvec(1,1) = ss%R_surfMax(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%R_surfMin(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = ss%Z_surfMax(ss%nrho_eq_geo)
     item_r8vals(3) = ansvec(1,1)
     ansvec(1,1) = ss%Z_surfMin(ss%nrho_eq_geo)
     item_r8vals(4) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ELONG
  ahash(2) = ps_phash_TRIANG
  ahash(3) = ps_phash_TRIANGU
  ahash(4) = ps_phash_TRIANGL
  ahash(5) = ps_phash_SQUAREUO
  ahash(6) = ps_phash_SQUARELO
  IF(ALLOCATED(ss%elong).AND.hcheck(6,1)) THEN
     listname = "SURFSHAPE"
     icomponent = ps_cnum_EQ
     nitems = 6
     ansvec(1,1) = ss%elong(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%triang(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = ss%triangU(ss%nrho_eq_geo)
     item_r8vals(3) = ansvec(1,1)
     ansvec(1,1) = ss%triangL(ss%nrho_eq_geo)
     item_r8vals(4) = ansvec(1,1)
     ansvec(1,1) = ss%squareUO(ss%nrho_eq_geo)
     item_r8vals(5) = ansvec(1,1)
     ansvec(1,1) = ss%squareLO(ss%nrho_eq_geo)
     item_r8vals(6) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PE_TRANS
  ahash(2) = ps_phash_PI_TRANS
  IF(ALLOCATED(ss%pe_trans).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "TRANSPORT"
     icomponent = ps_cnum_PLASMA
     nitems = 2
     idvec(1) = ss%id_pe_trans
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_pi_trans
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TRIANG_MILLER_U
  ahash(2) = ps_phash_TRIANG_MILLER_L
  IF(ALLOCATED(ss%triang_miller_U).AND.hcheck(2,1)) THEN
     listname = "TRIANG_MILLER"
     icomponent = ps_cnum_EQ
     nitems = 2
     ansvec(1,1) = ss%triang_miller_U(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = ss%triang_miller_L(ss%nrho_eq_geo)
     item_r8vals(2) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_UPWIND_PFRAC_TE
  ahash(2) = ps_phash_UPWIND_PFRAC_TI
  ahash(3) = ps_phash_UPWIND_PFRAC_OMEGA
  IF(ALLOCATED(ss%upwind_pfrac_Te).AND.hcheck(3,1)) THEN
     listname = "UPWIND_FORWARD_FRACTIONS"
     icomponent = ps_cnum_PLASMA
     nitems = 3
     ansvec(1,1) = sum(ss%upwind_pfrac_Te)/size(ss%upwind_pfrac_Te)
     item_r8vals(1) = ansvec(1,1)
     ansvec(1,1) = sum(ss%upwind_pfrac_Ti)/size(ss%upwind_pfrac_Ti)
     item_r8vals(2) = ansvec(1,1)
     ansvec(1,1) = sum(ss%upwind_pfrac_omega)/size(ss%upwind_pfrac_omega)
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ZEFF
  ahash(2) = ps_phash_ZEFF_TH
  ahash(3) = ps_phash_ZEFF_FI
  IF(ALLOCATED(ss%Zeff).AND.(id_intg.GT.0).AND.hcheck(3,1)) THEN
     listname = "ZEFF_GROUP"
     icomponent = ps_cnum_PLASMA
     nitems = 3
     idvec(1) = ss%id_Zeff
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)
     idvec(1) = ss%id_Zeff_th
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(2) = ansvec(1,1)
     idvec(1) = ss%id_Zeff_fi
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(3) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  !----------------------------------------------------
  ! list values for singleton profiles

  ahash(1) = ps_phash_VOL
  IF(ALLOCATED(ss%vol).AND.hcheck(1,1)) THEN
     listname = "VOL_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%vol(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_AREA
  IF(ALLOCATED(ss%area).AND.hcheck(1,1)) THEN
     listname = "AREA_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%area(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ANOM_EVAR
  IF(ALLOCATED(ss%anom_evar).AND.hcheck(1,1)) THEN
     listname = "ANOM_EVAR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%anom_evar)/size(ss%anom_evar)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BALSTAB
  IF(ALLOCATED(ss%balstab).AND.hcheck(1,1)) THEN
     listname = "BALSTAB_LIST"
     icomponent = ps_cnum_LMHD
     nitems = 1
     ansvec(1,1) = sum(ss%balstab)/size(ss%balstab)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BPHIRZ
  IF(ALLOCATED(ss%BphiRZ).AND.hcheck(1,1)) THEN
     listname = "BPHIRZ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%BphiRZ)/size(ss%BphiRZ)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BRRZ
  IF(ALLOCATED(ss%BRRZ).AND.hcheck(1,1)) THEN
     listname = "BRRZ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%BRRZ)/size(ss%BRRZ)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BZRZ
  IF(ALLOCATED(ss%BZRZ).AND.hcheck(1,1)) THEN
     listname = "BZRZ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%BZRZ)/size(ss%BZRZ)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_ANOM
  IF(ALLOCATED(ss%chie_anom).AND.hcheck(1,1)) THEN
     listname = "CHIE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_anom)/size(ss%chie_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_DRBM
  IF(ALLOCATED(ss%chie_drbm).AND.hcheck(1,1)) THEN
     listname = "CHIE_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_drbm)/size(ss%chie_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_ETG
  IF(ALLOCATED(ss%chie_etg).AND.hcheck(1,1)) THEN
     listname = "CHIE_ETG_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_etg)/size(ss%chie_etg)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_GLF
  IF(ALLOCATED(ss%chie_glf).AND.hcheck(1,1)) THEN
     listname = "CHIE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_glf)/size(ss%chie_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_GTCNEO
  IF(ALLOCATED(ss%chie_gtcneo).AND.hcheck(1,1)) THEN
     listname = "CHIE_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_gtcneo)/size(ss%chie_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_MMM71
  IF(ALLOCATED(ss%chie_mmm71).AND.hcheck(1,1)) THEN
     listname = "CHIE_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_mmm71)/size(ss%chie_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_MTM
  IF(ALLOCATED(ss%chie_mtm).AND.hcheck(1,1)) THEN
     listname = "CHIE_MTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_mtm)/size(ss%chie_mtm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NCLASS
  IF(ALLOCATED(ss%chie_nclass).AND.hcheck(1,1)) THEN
     listname = "CHIE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_nclass)/size(ss%chie_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NEO
  IF(ALLOCATED(ss%chie_neo).AND.hcheck(1,1)) THEN
     listname = "CHIE_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_neo)/size(ss%chie_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_NTM
  IF(ALLOCATED(ss%chie_ntm).AND.hcheck(1,1)) THEN
     listname = "CHIE_NTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_ntm)/size(ss%chie_ntm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_PALEO
  IF(ALLOCATED(ss%chie_paleo).AND.hcheck(1,1)) THEN
     listname = "CHIE_PALEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_paleo)/size(ss%chie_paleo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_TGLF
  IF(ALLOCATED(ss%chie_tglf).AND.hcheck(1,1)) THEN
     listname = "CHIE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_tglf)/size(ss%chie_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_W19
  IF(ALLOCATED(ss%chie_w19).AND.hcheck(1,1)) THEN
     listname = "CHIE_W19_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chie_w19)/size(ss%chie_w19)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_ANOM
  IF(ALLOCATED(ss%chii_anom).AND.hcheck(1,1)) THEN
     listname = "CHII_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_anom)/size(ss%chii_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_DRBM
  IF(ALLOCATED(ss%chii_drbm).AND.hcheck(1,1)) THEN
     listname = "CHII_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_drbm)/size(ss%chii_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_GLF
  IF(ALLOCATED(ss%chii_glf).AND.hcheck(1,1)) THEN
     listname = "CHII_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_glf)/size(ss%chii_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_GTCNEO
  IF(ALLOCATED(ss%chii_gtcneo).AND.hcheck(1,1)) THEN
     listname = "CHII_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_gtcneo)/size(ss%chii_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_MMM71
  IF(ALLOCATED(ss%chii_mmm71).AND.hcheck(1,1)) THEN
     listname = "CHII_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_mmm71)/size(ss%chii_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NCLASS
  IF(ALLOCATED(ss%chii_nclass).AND.hcheck(1,1)) THEN
     listname = "CHII_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_nclass)/size(ss%chii_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NEO
  IF(ALLOCATED(ss%chii_neo).AND.hcheck(1,1)) THEN
     listname = "CHII_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_neo)/size(ss%chii_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_NTM
  IF(ALLOCATED(ss%chii_ntm).AND.hcheck(1,1)) THEN
     listname = "CHII_NTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_ntm)/size(ss%chii_ntm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_TGLF
  IF(ALLOCATED(ss%chii_tglf).AND.hcheck(1,1)) THEN
     listname = "CHII_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_tglf)/size(ss%chii_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_W19
  IF(ALLOCATED(ss%chii_w19).AND.hcheck(1,1)) THEN
     listname = "CHII_W19_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chii_w19)/size(ss%chii_w19)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_ANOM
  IF(ALLOCATED(ss%chiphi_anom).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_anom)/size(ss%chiphi_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_DRBM
  IF(ALLOCATED(ss%chiphi_drbm).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_drbm)/size(ss%chiphi_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_GLF
  IF(ALLOCATED(ss%chiphi_glf).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_glf)/size(ss%chiphi_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_GTCNEO
  IF(ALLOCATED(ss%chiphi_gtcneo).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_gtcneo)/size(ss%chiphi_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_MMM71
  IF(ALLOCATED(ss%chiphi_mmm71).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_mmm71)/size(ss%chiphi_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_NEO
  IF(ALLOCATED(ss%chiphi_neo).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_neo)/size(ss%chiphi_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_TGLF
  IF(ALLOCATED(ss%chiphi_tglf).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_tglf)/size(ss%chiphi_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIPHI_W19
  IF(ALLOCATED(ss%chiphi_w19).AND.hcheck(1,1)) THEN
     listname = "CHIPHI_W19_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chiphi_w19)/size(ss%chiphi_w19)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHITHETA_MMM71
  IF(ALLOCATED(ss%chitheta_mmm71).AND.hcheck(1,1)) THEN
     listname = "CHITHETA_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%chitheta_mmm71)/size(ss%chitheta_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURBEAM
  IF(ALLOCATED(ss%curbeam).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURBEAM_LIST"
     icomponent = ps_cnum_NBI
     nitems = 1
     idvec(1) = ss%id_curbeam
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURECH
  IF(ALLOCATED(ss%curech).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURECH_LIST"
     icomponent = ps_cnum_EC
     nitems = 1
     idvec(1) = ss%id_curech
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURFUSN
  IF(ALLOCATED(ss%curfusn).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURFUSN_LIST"
     icomponent = ps_cnum_FUS
     nitems = 1
     idvec(1) = ss%id_curfusn
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURICH
  IF(ALLOCATED(ss%curich).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURICH_LIST"
     icomponent = ps_cnum_IC
     nitems = 1
     idvec(1) = ss%id_curich
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURLH
  IF(ALLOCATED(ss%curlh).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURLH_LIST"
     icomponent = ps_cnum_LH
     nitems = 1
     idvec(1) = ss%id_curlh
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURMINO
  IF(ALLOCATED(ss%curmino).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURMINO_LIST"
     icomponent = ps_cnum_IC
     nitems = 1
     idvec(1) = ss%id_curmino
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURR_BOOTSTRAP
  IF(ALLOCATED(ss%curr_bootstrap).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURR_BOOTSTRAP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_curr_bootstrap
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURR_OHMIC
  IF(ALLOCATED(ss%curr_ohmic).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURR_OHMIC_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_curr_ohmic
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURT
  IF(ALLOCATED(ss%curt).AND.hcheck(1,1)) THEN
     listname = "CURT_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%curt(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CUR_RW
  IF(ALLOCATED(ss%cur_rw).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CUR_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     nitems = 1
     idvec(1) = ss%id_cur_rw
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DB_MTM
  IF(ALLOCATED(ss%db_mtm).AND.hcheck(1,1)) THEN
     listname = "DB_MTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%db_mtm)/size(ss%db_mtm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DCUR_RW_DVLOOP
  IF(ALLOCATED(ss%dcur_rw_dVloop).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "DCUR_RW_DVLOOP_LIST"
     icomponent = ps_cnum_RUNAWAY
     nitems = 1
     idvec(1) = ss%id_dcur_rw_dVloop
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNE_NCLASS
  IF(ALLOCATED(ss%difne_nclass).AND.hcheck(1,1)) THEN
     listname = "DIFNE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%difne_nclass)/size(ss%difne_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNH_NCLASS
  IF(ALLOCATED(ss%difnh_nclass).AND.hcheck(1,1)) THEN
     listname = "DIFNH_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%difnh_nclass)/size(ss%difnh_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNX_NCLASS
  IF(ALLOCATED(ss%difnx_nclass).AND.hcheck(1,1)) THEN
     listname = "DIFNX_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%difnx_nclass)/size(ss%difnx_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNZ_MMM71
  IF(ALLOCATED(ss%difnz_mmm71).AND.hcheck(1,1)) THEN
     listname = "DIFNZ_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%difnz_mmm71)/size(ss%difnz_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQEDGRDTE_TGLF
  IF(ALLOCATED(ss%dQedGrdte_tglf).AND.hcheck(1,1)) THEN
     listname = "DQEDGRDTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%dQedGrdte_tglf)/size(ss%dQedGrdte_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQEDGRDTI_TGLF
  IF(ALLOCATED(ss%dQedGrdti_tglf).AND.hcheck(1,1)) THEN
     listname = "DQEDGRDTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%dQedGrdti_tglf)/size(ss%dQedGrdti_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQIDGRDTE_TGLF
  IF(ALLOCATED(ss%dQidGrdte_tglf).AND.hcheck(1,1)) THEN
     listname = "DQIDGRDTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%dQidGrdte_tglf)/size(ss%dQidGrdte_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DQIDGRDTI_TGLF
  IF(ALLOCATED(ss%dQidGrdti_tglf).AND.hcheck(1,1)) THEN
     listname = "DQIDGRDTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%dQidGrdti_tglf)/size(ss%dQidGrdti_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EE_MOBILITY_FACTOR
  IF(ALLOCATED(ss%ee_mobility_factor).AND.hcheck(1,1)) THEN
     listname = "EE_MOBILITY_FACTOR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%ee_mobility_factor)/size(ss%ee_mobility_factor)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPERP_RW
  IF(ALLOCATED(ss%eperp_rw).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPERP_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     nitems = 1
     idvec(1) = ss%id_eperp_rw
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPLL_RW
  IF(ALLOCATED(ss%epll_rw).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPLL_RW_LIST"
     icomponent = ps_cnum_RUNAWAY
     nitems = 1
     idvec(1) = ss%id_epll_rw
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPOT
  IF(ALLOCATED(ss%Epot).AND.hcheck(1,1)) THEN
     listname = "EPOT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     ansvec(1,1) = sum(ss%Epot)/size(ss%Epot)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_ETA_PARALLEL
  IF(ALLOCATED(ss%eta_parallel).AND.hcheck(1,1)) THEN
     listname = "ETA_PARALLEL_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     ansvec(1,1) = sum(ss%eta_parallel)/size(ss%eta_parallel)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FI_DEPLETION
  IF(ALLOCATED(ss%Fi_depletion).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "FI_DEPLETION_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_Fi_depletion
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_DRBM
  IF(ALLOCATED(ss%freq_drbm).AND.hcheck(1,1)) THEN
     listname = "FREQ_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%freq_drbm)/size(ss%freq_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_GLF
  IF(ALLOCATED(ss%freq_glf).AND.hcheck(1,1)) THEN
     listname = "FREQ_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%freq_glf)/size(ss%freq_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_MAX_TGLF
  IF(ALLOCATED(ss%freq_max_tglf).AND.hcheck(1,1)) THEN
     listname = "FREQ_MAX_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%freq_max_tglf)/size(ss%freq_max_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_MTM
  IF(ALLOCATED(ss%freq_mtm).AND.hcheck(1,1)) THEN
     listname = "FREQ_MTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%freq_mtm)/size(ss%freq_mtm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GAMMA_NC
  IF(ALLOCATED(ss%gamma_nc).AND.hcheck(1,1)) THEN
     listname = "GAMMA_NC_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gamma_nc(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB1
  IF(ALLOCATED(ss%gb1).AND.hcheck(1,1)) THEN
     listname = "GB1_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gb1(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB2
  IF(ALLOCATED(ss%gb2).AND.hcheck(1,1)) THEN
     listname = "GB2_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gb2(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GB2I
  IF(ALLOCATED(ss%gb2i).AND.hcheck(1,1)) THEN
     listname = "GB2I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gb2i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GBR2
  IF(ALLOCATED(ss%gbr2).AND.hcheck(1,1)) THEN
     listname = "GBR2_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gbr2(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GNCFB2H
  IF(ALLOCATED(ss%gncfb2h).AND.hcheck(1,1)) THEN
     listname = "GNCFB2H_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gncfb2h(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GNCFH
  IF(ALLOCATED(ss%gncfh).AND.hcheck(1,1)) THEN
     listname = "GNCFH_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gncfh(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR1
  IF(ALLOCATED(ss%gr1).AND.hcheck(1,1)) THEN
     listname = "GR1_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gr1(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2
  IF(ALLOCATED(ss%gr2).AND.hcheck(1,1)) THEN
     listname = "GR2_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gr2(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2I
  IF(ALLOCATED(ss%gr2i).AND.hcheck(1,1)) THEN
     listname = "GR2I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gr2i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR2RHO2
  IF(ALLOCATED(ss%gr2rho2).AND.hcheck(1,1)) THEN
     listname = "GR2RHO2_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gr2rho2(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GR3I
  IF(ALLOCATED(ss%gr3i).AND.hcheck(1,1)) THEN
     listname = "GR3I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gr3i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO1
  IF(ALLOCATED(ss%grho1).AND.hcheck(1,1)) THEN
     listname = "GRHO1_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grho1(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2
  IF(ALLOCATED(ss%grho2).AND.hcheck(1,1)) THEN
     listname = "GRHO2_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grho2(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2B2I
  IF(ALLOCATED(ss%grho2b2i).AND.hcheck(1,1)) THEN
     listname = "GRHO2B2I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grho2b2i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2R2I
  IF(ALLOCATED(ss%grho2r2i).AND.hcheck(1,1)) THEN
     listname = "GRHO2R2I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grho2r2i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRHO2R3I
  IF(ALLOCATED(ss%grho2r3i).AND.hcheck(1,1)) THEN
     listname = "GRHO2R3I_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grho2r3i(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRI
  IF(ALLOCATED(ss%gri).AND.hcheck(1,1)) THEN
     listname = "GRI_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%gri(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GRIRHOI
  IF(ALLOCATED(ss%grirhoi).AND.hcheck(1,1)) THEN
     listname = "GRIRHOI_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%grirhoi(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_DRBM
  IF(ALLOCATED(ss%growthrate_drbm).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%growthrate_drbm)/size(ss%growthrate_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_GLF
  IF(ALLOCATED(ss%growthrate_glf).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%growthrate_glf)/size(ss%growthrate_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_MAX_TGLF
  IF(ALLOCATED(ss%growthrate_max_tglf).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_MAX_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%growthrate_max_tglf)/size(ss%growthrate_max_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_MTM
  IF(ALLOCATED(ss%growthrate_mtm).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_MTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%growthrate_mtm)/size(ss%growthrate_mtm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_G_EQ
  IF(ALLOCATED(ss%g_eq).AND.hcheck(1,1)) THEN
     listname = "G_EQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%g_eq(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_IOTA
  IF(ALLOCATED(ss%iota).AND.hcheck(1,1)) THEN
     listname = "IOTA_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     ansvec(1,1) = sum(ss%iota)/size(ss%iota)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_JDOTB
  IF(ALLOCATED(ss%jdotb).AND.hcheck(1,1)) THEN
     listname = "JDOTB_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%jdotb(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_KYRHOS_MTM
  IF(ALLOCATED(ss%kyrhos_mtm).AND.hcheck(1,1)) THEN
     listname = "KYRHOS_MTM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%kyrhos_mtm)/size(ss%kyrhos_mtm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_LPOL
  IF(ALLOCATED(ss%Lpol).AND.hcheck(1,1)) THEN
     listname = "LPOL_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%Lpol(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NGRADB2_AV
  IF(ALLOCATED(ss%ngradb2_av).AND.hcheck(1,1)) THEN
     listname = "NGRADB2_AV_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%ngradb2_av(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NI
  IF(ALLOCATED(ss%ni).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NI_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_ni
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NMODEL
  IF(ALLOCATED(ss%nmodel).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NMODEL_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     idvec(1) = ss%id_nmodel
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NRW
  IF(ALLOCATED(ss%nrw).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NRW_LIST"
     icomponent = ps_cnum_RUNAWAY
     nitems = 1
     idvec(1) = ss%id_nrw
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEGAT
  IF(ALLOCATED(ss%omegat).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "OMEGAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_omegat
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEGA_EXB
  IF(ALLOCATED(ss%omega_exb).AND.hcheck(1,1)) THEN
     listname = "OMEGA_EXB_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%omega_exb)/size(ss%omega_exb)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PEECH
  IF(ALLOCATED(ss%peech).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PEECH_LIST"
     icomponent = ps_cnum_EC
     nitems = 1
     idvec(1) = ss%id_peech
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PE_ANOM
  IF(ALLOCATED(ss%pe_anom).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     idvec(1) = ss%id_pe_anom
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PHIT
  IF(ALLOCATED(ss%phit).AND.hcheck(1,1)) THEN
     listname = "PHIT_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%phit(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICTH
  IF(ALLOCATED(ss%picth).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PICTH_LIST"
     icomponent = ps_cnum_IC
     nitems = 1
     idvec(1) = ss%id_picth
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PI_ANOM
  IF(ALLOCATED(ss%pi_anom).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     idvec(1) = ss%id_pi_anom
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_POHME
  IF(ALLOCATED(ss%pohme).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "POHME_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_pohme
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSIPOL
  IF(ALLOCATED(ss%psipol).AND.hcheck(1,1)) THEN
     listname = "PSIPOL_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%psipol(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSIRZ
  IF(ALLOCATED(ss%PsiRZ).AND.hcheck(1,1)) THEN
     listname = "PSIRZ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%PsiRZ)/size(ss%PsiRZ)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSMOM_ERRCK
  IF(ALLOCATED(ss%psmom_errck).AND.hcheck(1,1)) THEN
     listname = "PSMOM_ERRCK_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%psmom_errck(ss%nrho_eq_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_P_EQ
  IF(ALLOCATED(ss%P_eq).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "P_EQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     idvec(1) = ss%id_P_eq
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QIE
  IF(ALLOCATED(ss%qie).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "QIE_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_qie
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Q_EQ
  IF(ALLOCATED(ss%q_eq).AND.hcheck(1,1)) THEN
     listname = "Q_EQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%q_eq(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R0_MOMEQ
  ahash(2) = ps_phash_DR0_MOMEQ_DRHO
  IF(ALLOCATED(ss%R0_momeq).AND.hcheck(2,1)) THEN
     listname = "R0_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%R0_momeq(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RES_TQ
  IF(ALLOCATED(ss%res_tq).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "RES_TQ_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_res_tq
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_R_GEO
  ahash(2) = ps_phash_DR_GEO_DRHO
  ahash(3) = ps_phash_DR_GEO_DTH
  ahash(4) = ps_phash_D2R_GEO_DRHODTH
  IF(ALLOCATED(ss%R_geo).AND.hcheck(4,1)) THEN
     listname = "R_GEO_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%R_geo)/size(ss%R_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_S0RECO_E
  IF(ALLOCATED(ss%s0reco_e).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "S0RECO_E_LIST"
     icomponent = ps_cnum_GAS
     nitems = 1
     idvec(1) = ss%id_s0reco_e
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBEDEP
  IF(ALLOCATED(ss%sbedep).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SBEDEP_LIST"
     icomponent = ps_cnum_NBI
     nitems = 1
     idvec(1) = ss%id_sbedep
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBEHALO
  IF(ALLOCATED(ss%sbehalo).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SBEHALO_LIST"
     icomponent = ps_cnum_NBI
     nitems = 1
     idvec(1) = ss%id_sbehalo
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SURF
  IF(ALLOCATED(ss%surf).AND.hcheck(1,1)) THEN
     listname = "SURF_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%surf(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TI
  IF(ALLOCATED(ss%Ti).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TI_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_Ti
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TMODEL
  IF(ALLOCATED(ss%tmodel).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TMODEL_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     idvec(1) = ss%id_tmodel
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ_ANOM
  IF(ALLOCATED(ss%tq_anom).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TQ_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     idvec(1) = ss%id_tq_anom
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ_TRANS
  IF(ALLOCATED(ss%tq_trans).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TQ_TRANS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     idvec(1) = ss%id_tq_trans
     idwvec(1) = ss%id_zonwt(idvec(1))
     call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
          .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
     IF(ierr.NE.0) RETURN
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNE_NCLASS
  IF(ALLOCATED(ss%velne_nclass).AND.hcheck(1,1)) THEN
     listname = "VELNE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velne_nclass)/size(ss%velne_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNH_NCLASS
  IF(ALLOCATED(ss%velnh_nclass).AND.hcheck(1,1)) THEN
     listname = "VELNH_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velnh_nclass)/size(ss%velnh_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNI_DRBM
  IF(ALLOCATED(ss%velni_drbm).AND.hcheck(1,1)) THEN
     listname = "VELNI_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velni_drbm)/size(ss%velni_drbm)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNX_NCLASS
  IF(ALLOCATED(ss%velnx_nclass).AND.hcheck(1,1)) THEN
     listname = "VELNX_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velnx_nclass)/size(ss%velnx_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_ANOM
  IF(ALLOCATED(ss%velpphi_anom).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_anom)/size(ss%velpphi_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_GLF
  IF(ALLOCATED(ss%velpphi_glf).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_glf)/size(ss%velpphi_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_GTCNEO
  IF(ALLOCATED(ss%velpphi_gtcneo).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_gtcneo)/size(ss%velpphi_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_MMM71
  IF(ALLOCATED(ss%velpphi_mmm71).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_mmm71)/size(ss%velpphi_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_NEO
  IF(ALLOCATED(ss%velpphi_neo).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_neo)/size(ss%velpphi_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELPPHI_TGLF
  IF(ALLOCATED(ss%velpphi_tglf).AND.hcheck(1,1)) THEN
     listname = "VELPPHI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velpphi_tglf)/size(ss%velpphi_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_ANOM
  IF(ALLOCATED(ss%velte_anom).AND.hcheck(1,1)) THEN
     listname = "VELTE_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_anom)/size(ss%velte_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_GLF
  IF(ALLOCATED(ss%velte_glf).AND.hcheck(1,1)) THEN
     listname = "VELTE_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_glf)/size(ss%velte_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_GTCNEO
  IF(ALLOCATED(ss%velte_gtcneo).AND.hcheck(1,1)) THEN
     listname = "VELTE_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_gtcneo)/size(ss%velte_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_MMM71
  IF(ALLOCATED(ss%velte_mmm71).AND.hcheck(1,1)) THEN
     listname = "VELTE_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_mmm71)/size(ss%velte_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_NCLASS
  IF(ALLOCATED(ss%velte_nclass).AND.hcheck(1,1)) THEN
     listname = "VELTE_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_nclass)/size(ss%velte_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_NEO
  IF(ALLOCATED(ss%velte_neo).AND.hcheck(1,1)) THEN
     listname = "VELTE_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_neo)/size(ss%velte_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_PALEO
  IF(ALLOCATED(ss%velte_paleo).AND.hcheck(1,1)) THEN
     listname = "VELTE_PALEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_paleo)/size(ss%velte_paleo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTE_TGLF
  IF(ALLOCATED(ss%velte_tglf).AND.hcheck(1,1)) THEN
     listname = "VELTE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velte_tglf)/size(ss%velte_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_ANOM
  IF(ALLOCATED(ss%velti_anom).AND.hcheck(1,1)) THEN
     listname = "VELTI_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_anom)/size(ss%velti_anom)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_GLF
  IF(ALLOCATED(ss%velti_glf).AND.hcheck(1,1)) THEN
     listname = "VELTI_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_glf)/size(ss%velti_glf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_GTCNEO
  IF(ALLOCATED(ss%velti_gtcneo).AND.hcheck(1,1)) THEN
     listname = "VELTI_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_gtcneo)/size(ss%velti_gtcneo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_MMM71
  IF(ALLOCATED(ss%velti_mmm71).AND.hcheck(1,1)) THEN
     listname = "VELTI_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_mmm71)/size(ss%velti_mmm71)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_NCLASS
  IF(ALLOCATED(ss%velti_nclass).AND.hcheck(1,1)) THEN
     listname = "VELTI_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_nclass)/size(ss%velti_nclass)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_NEO
  IF(ALLOCATED(ss%velti_neo).AND.hcheck(1,1)) THEN
     listname = "VELTI_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_neo)/size(ss%velti_neo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELTI_TGLF
  IF(ALLOCATED(ss%velti_tglf).AND.hcheck(1,1)) THEN
     listname = "VELTI_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 1
     ansvec(1,1) = sum(ss%velti_tglf)/size(ss%velti_tglf)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_V_LOOP
  IF(ALLOCATED(ss%V_loop).AND.hcheck(1,1)) THEN
     listname = "V_LOOP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 1
     ansvec(1,1) = sum(ss%V_loop)/size(ss%V_loop)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z0_MOMEQ
  ahash(2) = ps_phash_DZ0_MOMEQ_DRHO
  IF(ALLOCATED(ss%Z0_momeq).AND.hcheck(2,1)) THEN
     listname = "Z0_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = ss%Z0_momeq(ss%nrho_eq)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_Z_GEO
  ahash(2) = ps_phash_DZ_GEO_DRHO
  ahash(3) = ps_phash_DZ_GEO_DTH
  ahash(4) = ps_phash_D2Z_GEO_DRHODTH
  IF(ALLOCATED(ss%Z_geo).AND.hcheck(4,1)) THEN
     listname = "Z_GEO_LIST"
     icomponent = ps_cnum_EQ
     nitems = 1
     ansvec(1,1) = sum(ss%Z_geo)/size(ss%Z_geo)
     item_r8vals(1) = ansvec(1,1)

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  !----------------------------------------------------
  ! update list data on indexed arrays of profiles

  ahash(1) = ps_phash_BIDIFF_BPASS_CO
  IF(ALLOCATED(ss%bidiff_bpass_co).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_BPASS_CO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_bpass_co(:,:,I1))/size(ss%bidiff_bpass_co(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BIDIFF_BPASS_CTR
  IF(ALLOCATED(ss%bidiff_bpass_ctr).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_BPASS_CTR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_bpass_ctr(:,:,I1))/size(ss%bidiff_bpass_ctr(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BIDIFF_BTRAP
  IF(ALLOCATED(ss%bidiff_btrap).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_BTRAP_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_btrap(:,:,I1))/size(ss%bidiff_btrap(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BIDIFF_DPASS_CO
  IF(ALLOCATED(ss%bidiff_dpass_co).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_DPASS_CO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_dpass_co(:,:,I1))/size(ss%bidiff_dpass_co(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BIDIFF_DPASS_CTR
  IF(ALLOCATED(ss%bidiff_dpass_ctr).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_DPASS_CTR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_dpass_ctr(:,:,I1))/size(ss%bidiff_dpass_ctr(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_BIDIFF_DTRAP
  IF(ALLOCATED(ss%bidiff_dtrap).AND.hcheck(1,1)) THEN
     listname = "BIDIFF_DTRAP_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%bidiff_dtrap(:,:,I1))/size(ss%bidiff_dtrap(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CDICRF
  IF(ALLOCATED(ss%cdicrf).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CDICRF_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I1 = 1,ss%nicrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_cdicrf(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CDICRF_NPHI
  IF(ALLOCATED(ss%cdicrf_nphi).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CDICRF_NPHI_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I2 = 1,ss%nicrf_src
        DO I1 = 1,ss%max_num_nphi
           idvec(1) = ss%id_cdicrf_nphi(I1,I2)
           IF(idvec(1).EQ.0) CYCLE
           nitems = nitems + 1
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIE_TRANSCAT
  IF(ALLOCATED(ss%chie_transcat).AND.hcheck(1,1)) THEN
     listname = "CHIE_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%chie_transcat(:,I1))/size(ss%chie_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHII_TRANSCAT
  IF(ALLOCATED(ss%chii_transcat).AND.hcheck(1,1)) THEN
     listname = "CHII_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%chii_transcat(:,I1))/size(ss%chii_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CHIMO_TRANSCAT
  IF(ALLOCATED(ss%chimo_transcat).AND.hcheck(1,1)) THEN
     listname = "CHIMO_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%chimo_transcat(:,I1))/size(ss%chimo_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURECH_SRC
  IF(ALLOCATED(ss%curech_src).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURECH_SRC_LIST"
     icomponent = ps_cnum_EC
     nitems = 0
     DO I1 = 1,ss%necrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_curech_src(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_CURLH_SRC
  IF(ALLOCATED(ss%curlh_src).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "CURLH_SRC_LIST"
     icomponent = ps_cnum_LH
     nitems = 0
     DO I1 = 1,ss%nlhrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_curlh_src(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .TRUE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFF_TRANS
  IF(ALLOCATED(ss%diff_trans).AND.hcheck(1,1)) THEN
     listname = "DIFF_TRANS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%diff_trans(:,I1))/size(ss%diff_trans(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFF_TRANSCAT
  IF(ALLOCATED(ss%diff_transcat).AND.hcheck(1,1)) THEN
     listname = "DIFF_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I2 = 1,ss%ntrcat
        DO I1 = 0,ss%nspec_th
           nitems = nitems + 1
           ansvec(1,1) = sum(ss%diff_transcat(:,I1,I2))/size(ss%diff_transcat(:,I1,I2))
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_ANOM
  IF(ALLOCATED(ss%difns_anom).AND.hcheck(1,1)) THEN
     listname = "DIFNS_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_anom(:,I1))/size(ss%difns_anom(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_DRBM
  IF(ALLOCATED(ss%difns_drbm).AND.hcheck(1,1)) THEN
     listname = "DIFNS_DRBM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_drbm(:,I1))/size(ss%difns_drbm(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_GLF
  IF(ALLOCATED(ss%difns_glf).AND.hcheck(1,1)) THEN
     listname = "DIFNS_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_glf(:,I1))/size(ss%difns_glf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_GTCNEO
  IF(ALLOCATED(ss%difns_gtcneo).AND.hcheck(1,1)) THEN
     listname = "DIFNS_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_gtcneo(:,I1))/size(ss%difns_gtcneo(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_MMM71
  IF(ALLOCATED(ss%difns_mmm71).AND.hcheck(1,1)) THEN
     listname = "DIFNS_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_mmm71(:,I1))/size(ss%difns_mmm71(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_NCLASS
  IF(ALLOCATED(ss%difns_nclass).AND.hcheck(1,1)) THEN
     listname = "DIFNS_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_nclass(:,I1))/size(ss%difns_nclass(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_NEO
  IF(ALLOCATED(ss%difns_neo).AND.hcheck(1,1)) THEN
     listname = "DIFNS_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_neo(:,I1))/size(ss%difns_neo(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_TGLF
  IF(ALLOCATED(ss%difns_tglf).AND.hcheck(1,1)) THEN
     listname = "DIFNS_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_tglf(:,I1))/size(ss%difns_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_DIFNS_W19
  IF(ALLOCATED(ss%difns_w19).AND.hcheck(1,1)) THEN
     listname = "DIFNS_W19_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%difns_w19(:,I1))/size(ss%difns_w19(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPERP_BEAMI
  IF(ALLOCATED(ss%eperp_beami).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPERP_BEAMI_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        idvec(1) = ss%id_eperp_beami(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPERP_FUSI
  IF(ALLOCATED(ss%eperp_fusi).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPERP_FUSI_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        idvec(1) = ss%id_eperp_fusi(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPERP_MINI
  IF(ALLOCATED(ss%eperp_mini).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPERP_MINI_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I1 = 1,ss%nspec_rfmin
        nitems = nitems + 1
        idvec(1) = ss%id_eperp_mini(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPLL_BEAMI
  IF(ALLOCATED(ss%epll_beami).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPLL_BEAMI_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        idvec(1) = ss%id_epll_beami(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPLL_FUSI
  IF(ALLOCATED(ss%epll_fusi).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPLL_FUSI_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        idvec(1) = ss%id_epll_fusi(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_EPLL_MINI
  IF(ALLOCATED(ss%epll_mini).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "EPLL_MINI_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I1 = 1,ss%nspec_rfmin
        nitems = nitems + 1
        idvec(1) = ss%id_epll_mini(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_BPASS_CO
  IF(ALLOCATED(ss%fidiff_bpass_co).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_BPASS_CO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_bpass_co(:,:,I1))/size(ss%fidiff_bpass_co(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_BPASS_CTR
  IF(ALLOCATED(ss%fidiff_bpass_ctr).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_BPASS_CTR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_bpass_ctr(:,:,I1))/size(ss%fidiff_bpass_ctr(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_BTRAP
  IF(ALLOCATED(ss%fidiff_btrap).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_BTRAP_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_btrap(:,:,I1))/size(ss%fidiff_btrap(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_DPASS_CO
  IF(ALLOCATED(ss%fidiff_dpass_co).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_DPASS_CO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_dpass_co(:,:,I1))/size(ss%fidiff_dpass_co(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_DPASS_CTR
  IF(ALLOCATED(ss%fidiff_dpass_ctr).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_DPASS_CTR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_dpass_ctr(:,:,I1))/size(ss%fidiff_dpass_ctr(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FIDIFF_DTRAP
  IF(ALLOCATED(ss%fidiff_dtrap).AND.hcheck(1,1)) THEN
     listname = "FIDIFF_DTRAP_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%fidiff_dtrap(:,:,I1))/size(ss%fidiff_dtrap(:,:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_MMM71
  IF(ALLOCATED(ss%freq_mmm71).AND.hcheck(1,1)) THEN
     listname = "FREQ_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_mmm
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%freq_mmm71(:,I1))/size(ss%freq_mmm71(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_FREQ_TGLF
  IF(ALLOCATED(ss%freq_tglf).AND.hcheck(1,1)) THEN
     listname = "FREQ_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%freq_tglf(:,I1))/size(ss%freq_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_MMM71
  IF(ALLOCATED(ss%growthrate_mmm71).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_mmm
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%growthrate_mmm71(:,I1))/size(ss%growthrate_mmm71(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_TGLF
  IF(ALLOCATED(ss%growthrate_tglf).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%growthrate_tglf(:,I1))/size(ss%growthrate_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_GROWTHRATE_VPAR
  IF(ALLOCATED(ss%growthrate_vpar).AND.hcheck(1,1)) THEN
     listname = "GROWTHRATE_VPAR_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%growthrate_vpar(:,I1))/size(ss%growthrate_vpar(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_KYSPECTRUM_TGLF
  IF(ALLOCATED(ss%kyspectrum_tglf).AND.hcheck(1,1)) THEN
     listname = "KYSPECTRUM_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%kyspectrum_tglf(:,I1))/size(ss%kyspectrum_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_N0NORM
  IF(ALLOCATED(ss%n0norm).AND.hcheck(1,1)) THEN
     listname = "N0NORM_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           ansvec(1,1) = sum(ss%n0norm(:,I1,I2))/size(ss%n0norm(:,I1,I2))
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_N0_HALO
  IF(ALLOCATED(ss%n0_halo).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "N0_HALO_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_n0_halo(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_N0_RECO
  IF(ALLOCATED(ss%n0_reco).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "N0_RECO_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_n0_reco(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NBEAMI
  IF(ALLOCATED(ss%nbeami).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NBEAMI_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        idvec(1) = ss%id_nbeami(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NEFLUX_KY_TGLF
  IF(ALLOCATED(ss%neflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NEFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%neflux_ky_tglf(:,I1))/size(ss%neflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NE_KY_TGLF
  IF(ALLOCATED(ss%ne_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NE_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%ne_ky_tglf(:,I1))/size(ss%ne_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NFUSI
  IF(ALLOCATED(ss%nfusi).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NFUSI_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        idvec(1) = ss%id_nfusi(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NIFLUX_KY_TGLF
  IF(ALLOCATED(ss%niflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NIFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%niflux_ky_tglf(:,I1))/size(ss%niflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NI_KY_TGLF
  IF(ALLOCATED(ss%ni_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NI_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%ni_ky_tglf(:,I1))/size(ss%ni_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NMINI
  IF(ALLOCATED(ss%nmini).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NMINI_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I1 = 1,ss%nspec_rfmin
        nitems = nitems + 1
        idvec(1) = ss%id_nmini(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NS
  IF(ALLOCATED(ss%ns).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "NS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_ns(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NZFLUX_KY_TGLF
  IF(ALLOCATED(ss%nzflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NZFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%nzflux_ky_tglf(:,I1))/size(ss%nzflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_NZ_KY_TGLF
  IF(ALLOCATED(ss%nz_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "NZ_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%nz_ky_tglf(:,I1))/size(ss%nz_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEG0CX
  IF(ALLOCATED(ss%omeg0cx).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "OMEG0CX_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_omeg0cx(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEG0SC0
  IF(ALLOCATED(ss%omeg0sc0).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "OMEG0SC0_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           idvec(1) = ss%id_omeg0sc0(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEG0_HALO
  IF(ALLOCATED(ss%omeg0_halo).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "OMEG0_HALO_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_omeg0_halo(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_OMEG0_RECO
  IF(ALLOCATED(ss%omeg0_reco).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "OMEG0_RECO_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_omeg0_reco(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PEECH_SRC
  IF(ALLOCATED(ss%peech_src).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PEECH_SRC_LIST"
     icomponent = ps_cnum_EC
     nitems = 0
     DO I1 = 1,ss%necrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_peech_src(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PELH_SRC
  IF(ALLOCATED(ss%pelh_src).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PELH_SRC_LIST"
     icomponent = ps_cnum_LH
     nitems = 0
     DO I1 = 1,ss%nlhrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_pelh_src(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PE_TRANSCAT
  IF(ALLOCATED(ss%pe_transcat).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PE_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        idvec(1) = ss%id_pe_transcat(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PHIFLUX_KY_TGLF
  IF(ALLOCATED(ss%phiflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "PHIFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%phiflux_ky_tglf(:,I1))/size(ss%phiflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICRF_NPHI_SRCS
  IF(ALLOCATED(ss%picrf_nphi_srcs).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PICRF_NPHI_SRCS_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I3 = 0,ss%nspec_alla
        DO I2 = 1,ss%nicrf_src
           DO I1 = 1,ss%max_num_nphi
              idvec(1) = ss%id_picrf_nphi_srcs(I1,I2,I3)
              IF(idvec(1).EQ.0) CYCLE
              nitems = nitems + 1
              idwvec(1) = ss%id_zonwt(idvec(1))
              call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                   .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
              IF(ierr.NE.0) RETURN
              item_r8vals(nitems) = ansvec(1,1)
           ENDDO   ! I1
        ENDDO   ! I2
     ENDDO   ! I3

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICRF_SRCS
  IF(ALLOCATED(ss%picrf_srcs).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PICRF_SRCS_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I2 = 0,ss%nspec_alla
        DO I1 = 1,ss%nicrf_src
           nitems = nitems + 1
           idvec(1) = ss%id_picrf_srcs(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PICRF_TOTALS
  IF(ALLOCATED(ss%picrf_totals).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PICRF_TOTALS_LIST"
     icomponent = ps_cnum_IC
     nitems = 0
     DO I1 = 0,ss%nspec_alla
        nitems = nitems + 1
        idvec(1) = ss%id_picrf_totals(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PILH_SRC
  IF(ALLOCATED(ss%pilh_src).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PILH_SRC_LIST"
     icomponent = ps_cnum_LH
     nitems = 0
     DO I1 = 1,ss%nlhrf_src
        nitems = nitems + 1
        idvec(1) = ss%id_pilh_src(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PI_TRANSCAT
  IF(ALLOCATED(ss%pi_transcat).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PI_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        idvec(1) = ss%id_pi_transcat(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_POT_KY_TGLF
  IF(ALLOCATED(ss%pot_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "POT_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%pot_ky_tglf(:,I1))/size(ss%pot_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_PSMOM_NC
  IF(ALLOCATED(ss%psmom_nc).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "PSMOM_NC_LIST"
     icomponent = ps_cnum_EQ
     nitems = 0
     DO I1 = 1,ss%npsmom
        nitems = nitems + 1
        idvec(1) = ss%id_psmom_nc(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QBEAMI
  IF(ALLOCATED(ss%qbeami).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "QBEAMI_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        idvec(1) = ss%id_qbeami(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QIONIZ
  IF(ALLOCATED(ss%qioniz).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "QIONIZ_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_qioniz(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_QQCX
  IF(ALLOCATED(ss%qqcx).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "QQCX_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_qqcx(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINB0I
  IF(ALLOCATED(ss%rate_sinb0i).AND.hcheck(1,1)) THEN
     listname = "RATE_SINB0I_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%rate_sinb0i(:,I1))/size(ss%rate_sinb0i(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINB0X
  IF(ALLOCATED(ss%rate_sinb0x).AND.hcheck(1,1)) THEN
     listname = "RATE_SINB0X_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%rate_sinb0x(:,I1))/size(ss%rate_sinb0x(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINB0XS
  IF(ALLOCATED(ss%rate_sinb0xs).AND.hcheck(1,1)) THEN
     listname = "RATE_SINB0XS_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I2 = 1,ss%nspec_beam
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           ansvec(1,1) = sum(ss%rate_sinb0xs(:,I1,I2))/size(ss%rate_sinb0xs(:,I1,I2))
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINF0I
  IF(ALLOCATED(ss%rate_sinf0i).AND.hcheck(1,1)) THEN
     listname = "RATE_SINF0I_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%rate_sinf0i(:,I1))/size(ss%rate_sinf0i(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINF0X
  IF(ALLOCATED(ss%rate_sinf0x).AND.hcheck(1,1)) THEN
     listname = "RATE_SINF0X_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%rate_sinf0x(:,I1))/size(ss%rate_sinf0x(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RATE_SINF0XS
  IF(ALLOCATED(ss%rate_sinf0xs).AND.hcheck(1,1)) THEN
     listname = "RATE_SINF0XS_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I2 = 1,ss%nspec_fusion
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           ansvec(1,1) = sum(ss%rate_sinf0xs(:,I1,I2))/size(ss%rate_sinf0xs(:,I1,I2))
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_RES_SN
  IF(ALLOCATED(ss%res_sn).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "RES_SN_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_res_sn(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_S0RECO
  IF(ALLOCATED(ss%s0reco).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "S0RECO_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_s0reco(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_S0RECO_RECAP
  IF(ALLOCATED(ss%s0reco_recap).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "S0RECO_RECAP_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_s0reco_recap(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SB0HALO
  IF(ALLOCATED(ss%sb0halo).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SB0HALO_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_sb0halo(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SB0HALO_RECAP
  IF(ALLOCATED(ss%sb0halo_recap).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SB0HALO_RECAP_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_sb0halo_recap(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBSCE
  IF(ALLOCATED(ss%sbsce).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SBSCE_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 0,ss%nspec_tha
        nitems = nitems + 1
        idvec(1) = ss%id_sbsce(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SBTHERM
  IF(ALLOCATED(ss%sbtherm).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SBTHERM_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_beam
        nitems = nitems + 1
        idvec(1) = ss%id_sbtherm(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SC_ANOM
  IF(ALLOCATED(ss%sc_anom).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SC_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_sc_anom(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SFSCE
  IF(ALLOCATED(ss%sfsce).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SFSCE_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 0,ss%nspec_tha
        nitems = nitems + 1
        idvec(1) = ss%id_sfsce(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SFTHERM
  IF(ALLOCATED(ss%sftherm).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SFTHERM_LIST"
     icomponent = ps_cnum_FUS
     nitems = 0
     DO I1 = 1,ss%nspec_fusion
        nitems = nitems + 1
        idvec(1) = ss%id_sftherm(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SII_XS
  IF(ALLOCATED(ss%sii_xs).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SII_XS_LIST"
     icomponent = ps_cnum_RAD
     nitems = 0
     DO I2 = 1,ss%nxs
        DO I1 = 0,ss%nspec_th
           nitems = nitems + 1
           idvec(1) = ss%id_sii_xs(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SN_TRANS
  IF(ALLOCATED(ss%sn_trans).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SN_TRANS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_sn_trans(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SN_TRANSCAT
  IF(ALLOCATED(ss%sn_transcat).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SN_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I2 = 1,ss%ntrcat
        DO I1 = 0,ss%nspec_th
           nitems = nitems + 1
           idvec(1) = ss%id_sn_transcat(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SPROF0
  IF(ALLOCATED(ss%sprof0).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SPROF0_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           idvec(1) = ss%id_sprof0(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SPROF0E
  IF(ALLOCATED(ss%sprof0e).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SPROF0E_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_sprof0e(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_SPSCE
  IF(ALLOCATED(ss%spsce).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "SPSCE_LIST"
     icomponent = ps_cnum_PEL
     nitems = 0
     DO I1 = 0,ss%nspec_tha
        nitems = nitems + 1
        idvec(1) = ss%id_spsce(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_T0CX
  IF(ALLOCATED(ss%T0cx).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "T0CX_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_T0cx(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_T0SC0
  IF(ALLOCATED(ss%T0sc0).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "T0SC0_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I2 = 1,ss%ngsc0
        DO I1 = 1,ss%nspec_gas
           nitems = nitems + 1
           idvec(1) = ss%id_T0sc0(I1,I2)
           idwvec(1) = ss%id_zonwt(idvec(1))
           call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
                .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
           IF(ierr.NE.0) RETURN
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_T0_HALO
  IF(ALLOCATED(ss%T0_halo).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "T0_HALO_LIST"
     icomponent = ps_cnum_NBI
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_T0_halo(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_T0_RECO
  IF(ALLOCATED(ss%T0_reco).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "T0_RECO_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%nspec_gas
        nitems = nitems + 1
        idvec(1) = ss%id_T0_reco(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TEFLUX_KY_TGLF
  IF(ALLOCATED(ss%teflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TEFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%teflux_ky_tglf(:,I1))/size(ss%teflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TE_KY_TGLF
  IF(ALLOCATED(ss%te_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TE_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%te_ky_tglf(:,I1))/size(ss%te_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TIFLUX_KY_TGLF
  IF(ALLOCATED(ss%tiflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TIFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%tiflux_ky_tglf(:,I1))/size(ss%tiflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TI_KY_TGLF
  IF(ALLOCATED(ss%ti_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TI_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%ti_ky_tglf(:,I1))/size(ss%ti_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQIONIZ
  IF(ALLOCATED(ss%tqioniz).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TQIONIZ_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_tqioniz(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQQCX
  IF(ALLOCATED(ss%tqqcx).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TQQCX_LIST"
     icomponent = ps_cnum_GAS
     nitems = 0
     DO I1 = 1,ss%ngsc0
        nitems = nitems + 1
        idvec(1) = ss%id_tqqcx(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TQ_TRANSCAT
  IF(ALLOCATED(ss%tq_transcat).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TQ_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        idvec(1) = ss%id_tq_transcat(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.TRUE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TS
  IF(ALLOCATED(ss%Ts).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "TS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_Ts(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TZFLUX_KY_TGLF
  IF(ALLOCATED(ss%tzflux_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TZFLUX_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%tzflux_ky_tglf(:,I1))/size(ss%tzflux_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_TZ_KY_TGLF
  IF(ALLOCATED(ss%tz_ky_tglf).AND.hcheck(1,1)) THEN
     listname = "TZ_KY_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 1,ss%nky_anomth
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%tz_ky_tglf(:,I1))/size(ss%tz_ky_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_UPWIND_PFRAC_NS
  IF(ALLOCATED(ss%upwind_pfrac_ns).AND.hcheck(1,1)) THEN
     listname = "UPWIND_PFRAC_NS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%upwind_pfrac_ns(:,I1))/size(ss%upwind_pfrac_ns(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VEE_TRANSCAT
  IF(ALLOCATED(ss%vee_transcat).AND.hcheck(1,1)) THEN
     listname = "VEE_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%vee_transcat(:,I1))/size(ss%vee_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_ANOM
  IF(ALLOCATED(ss%velns_anom).AND.hcheck(1,1)) THEN
     listname = "VELNS_ANOM_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_anom(:,I1))/size(ss%velns_anom(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_GLF
  IF(ALLOCATED(ss%velns_glf).AND.hcheck(1,1)) THEN
     listname = "VELNS_GLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_glf(:,I1))/size(ss%velns_glf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_GTCNEO
  IF(ALLOCATED(ss%velns_gtcneo).AND.hcheck(1,1)) THEN
     listname = "VELNS_GTCNEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_gtcneo(:,I1))/size(ss%velns_gtcneo(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_MMM71
  IF(ALLOCATED(ss%velns_mmm71).AND.hcheck(1,1)) THEN
     listname = "VELNS_MMM71_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_mmm71(:,I1))/size(ss%velns_mmm71(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_NCLASS
  IF(ALLOCATED(ss%velns_nclass).AND.hcheck(1,1)) THEN
     listname = "VELNS_NCLASS_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_nclass(:,I1))/size(ss%velns_nclass(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_NEO
  IF(ALLOCATED(ss%velns_neo).AND.hcheck(1,1)) THEN
     listname = "VELNS_NEO_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_neo(:,I1))/size(ss%velns_neo(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VELNS_TGLF
  IF(ALLOCATED(ss%velns_tglf).AND.hcheck(1,1)) THEN
     listname = "VELNS_TGLF_LIST"
     icomponent = ps_cnum_ANOM
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%velns_tglf(:,I1))/size(ss%velns_tglf(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VIE_TRANSCAT
  IF(ALLOCATED(ss%vie_transcat).AND.hcheck(1,1)) THEN
     listname = "VIE_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%vie_transcat(:,I1))/size(ss%vie_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VMO_TRANSCAT
  IF(ALLOCATED(ss%vmo_transcat).AND.hcheck(1,1)) THEN
     listname = "VMO_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 1,ss%ntrcat
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%vmo_transcat(:,I1))/size(ss%vmo_transcat(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VN_TRANS
  IF(ALLOCATED(ss%vn_trans).AND.hcheck(1,1)) THEN
     listname = "VN_TRANS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        ansvec(1,1) = sum(ss%vn_trans(:,I1))/size(ss%vn_trans(:,I1))
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VN_TRANSCAT
  IF(ALLOCATED(ss%vn_transcat).AND.hcheck(1,1)) THEN
     listname = "VN_TRANSCAT_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I2 = 1,ss%ntrcat
        DO I1 = 0,ss%nspec_th
           nitems = nitems + 1
           ansvec(1,1) = sum(ss%vn_transcat(:,I1,I2))/size(ss%vn_transcat(:,I1,I2))
           item_r8vals(nitems) = ansvec(1,1)
        ENDDO   ! I1
     ENDDO   ! I2

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VPOL_INMP
  IF(ALLOCATED(ss%vpol_inmp).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "VPOL_INMP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_vpol_inmp(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VPOL_OMP
  IF(ALLOCATED(ss%vpol_omp).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "VPOL_OMP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_vpol_omp(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VTOR_INMP
  IF(ALLOCATED(ss%vtor_inmp).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "VTOR_INMP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_vtor_inmp(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_VTOR_OMP
  IF(ALLOCATED(ss%vtor_omp).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "VTOR_OMP_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_vtor_omp(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_V_PARS
  IF(ALLOCATED(ss%v_pars).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "V_PARS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_v_pars(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_V_PERS
  IF(ALLOCATED(ss%v_pers).AND.(id_intg.GT.0).AND.hcheck(1,1)) THEN
     listname = "V_PERS_LIST"
     icomponent = ps_cnum_PLASMA
     nitems = 0
     DO I1 = 0,ss%nspec_th
        nitems = nitems + 1
        idvec(1) = ss%id_v_pers(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_XRJCOS_MOMEQ
  ahash(2) = ps_phash_DXRJCOS_MOMEQ_DRHO
  IF(ALLOCATED(ss%xRjcos_momeq).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "XRJCOS_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 0
     DO I1 = 1,ss%neqmom
        nitems = nitems + 1
        idvec(1) = ss%id_xRjcos_momeq(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_XRJSIN_MOMEQ
  ahash(2) = ps_phash_DXRJSIN_MOMEQ_DRHO
  IF(ALLOCATED(ss%xRjsin_momeq).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "XRJSIN_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 0
     DO I1 = 1,ss%neqmom
        nitems = nitems + 1
        idvec(1) = ss%id_xRjsin_momeq(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_XZJCOS_MOMEQ
  ahash(2) = ps_phash_DXZJCOS_MOMEQ_DRHO
  IF(ALLOCATED(ss%xZjcos_momeq).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "XZJCOS_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 0
     DO I1 = 1,ss%neqmom
        nitems = nitems + 1
        idvec(1) = ss%id_xZjcos_momeq(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  ahash(1) = ps_phash_XZJSIN_MOMEQ
  ahash(2) = ps_phash_DXZJSIN_MOMEQ_DRHO
  IF(ALLOCATED(ss%xZjsin_momeq).AND.(id_intg.GT.0).AND.hcheck(2,1)) THEN
     listname = "XZJSIN_MOMEQ_LIST"
     icomponent = ps_cnum_EQ
     nitems = 0
     DO I1 = 1,ss%neqmom
        nitems = nitems + 1
        idvec(1) = ss%id_xZjsin_momeq(I1)
        idwvec(1) = ss%id_zonwt(idvec(1))
        call ps_rezone_rho(ss,2,x01,1,idvec,idwvec, &
             .FALSE.,.FALSE.,.FALSE.,ansvec,dvvec,iout,ierr)
        IF(ierr.NE.0) RETURN
        item_r8vals(nitems) = ansvec(1,1)
     ENDDO   ! I1

     CALL ps_list_update_r8(ss%iobj,listname,icomponent, &
          nitems,item_r8vals,iout,ierr)
     IF(ierr.NE.0) RETURN
  ENDIF

  IF(ALLOCATED(ss%nphi)) THEN
     DEALLOCATE(enum_lbl_nphi)
  ENDIF

  ! OK ALL DONE: update hash codes

  ss%hash_codes = ss%new_hash_codes
  xhash = ss%new_hash_codes

  call ps_xhashes_put(ss%iobj,xhash,iout,ierr)

  deallocate(enum_lbl_1d)

CONTAINS

  LOGICAL FUNCTION hcheck(inum,idchk)
     INTEGER, intent(in) :: inum
     INTEGER, intent(in) :: idchk

     !  check all hash codes: set function value TRUE if any show changes.
     !  also set TRUE if idchk = 0

     INTEGER :: ia1,ia2,ii

     if(idchk.eq.0) then
        hcheck=.TRUE.
        return
     endif

     hcheck = .FALSE.
     DO ii=1,inum
        hcheck = .TRUE.
        ia1 = ahash(ii)
        ia2 = ia1 + 1
        IF(ss%hash_codes(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(ss%hash_codes(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        IF(xhash(ia1).NE.ss%new_hash_codes(ia1)) EXIT
        IF(xhash(ia2).NE.ss%new_hash_codes(ia2)) EXIT
        hcheck = .FALSE.
     ENDDO
  END FUNCTION hcheck

  SUBROUTINE load_lbl_1d(indx_1d,elabel)
     integer, dimension(:), intent(in) :: indx_1d
     character*32, dimension(:), intent(inout) :: elabel

     integer :: iwarn,idup,ii,jj

     iwarn=0
     do ii=1,size(indx_1d)
        if(indx_1d(ii).lt.0) then
           write(elabel(ii),'("m",i8)') -indx_1d(ii)
        else
           write(elabel(ii),'("p",i8)') indx_1d(ii)
        endif

        idup=0
        do jj=1,ii-1
           if(indx_1d(ii).eq.indx_1d(jj)) idup=idup+1
        enddo

        if(idup.gt.0) then
           if(iwarn.eq.0) then
              iwarn=1
              write(iout,*) ' %plasma_state_xload: enumeration index values not unique (patch applied).'
           endif
           write(elabel(ii)(10:18),'("x",i8)') idup+1
        endif

        call lefpack(elabel(ii))
     enddo
  END SUBROUTINE load_lbl_1d

  SUBROUTINE load_lbl_2d(indx_num,indx_2d,elabel)
     integer, dimension(:), intent(in) :: indx_num
     integer, dimension(:,:), intent(in) :: indx_2d
     character*32, dimension(:,:), intent(inout) :: elabel

     integer :: kk,inum

     do kk=1,size(indx_num)
        inum = indx_num(kk)
        if(inum.gt.0) then
           call load_lbl_1d(indx_2d(1:inum,kk),elabel(1:inum,kk))
        endif
     enddo
  END SUBROUTINE load_lbl_2d

  SUBROUTINE lefpack(str)
     CHARACTER*(*), intent(inout) :: str
     !  left pack non-blank characters in str

     INTEGER :: ii,jj
     ii=0
     DO jj=1,len(str)
        IF(str(jj:jj).NE.' ') THEN
           ii = ii + 1
           str(ii:ii) = str(jj:jj)
        ENDIF
     ENDDO
     str(ii+1:) = ' '
  END SUBROUTINE lefpack

END SUBROUTINE plasma_state_xload

subroutine ps_2d_prof_store(iobj, profname, gridname1, gridname2, &
     units, iauthor, label, isplini, bc_opt, &
     n1, n2, k_ccw1, k_ccw2, profdata, id, imod, iout, ierr)

  !------------------------------------------------------------
  ! D. McCune 8 Oct 2006

  ! XPLASMA2 implementation of plasma_state subroutine
  ! store a 2d profile, return its ID, perform error checking

  ! This routine is called by generated code associated with the
  ! plasma state.  Component codes will not call this directly.
  !------------------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  integer :: iobj(ps_container_size)  ! opaque container for xplasma object

  character*(*), intent(in) :: profname    ! NAME of profile to store
  character*(*), intent(in) :: gridname1,gridname2
                                           ! NAMEs of profile's grids
  character*(*), intent(in) :: units       ! units label
  integer, intent(in) :: iauthor           ! author ID

  character*(*), intent(in) :: label       ! profile label
  integer, intent(in) :: isplini           ! profile interpolation method

  integer, intent(in) :: bc_opt            ! spline Bdy Cond option

  integer, intent(in) :: n1,n2             ! profile data dimensions
  integer, intent(in) :: k_ccw1,k_ccw2     ! CCW flags

  REAL(KIND=rspec) :: profdata(n1,n2)      ! profile data to be stored

  integer, intent(out) :: id               ! profile ID (interpolation handle)

  integer, intent(out) :: imod             ! =1 if profile is new or modified
  !  =0 on output if profile was not changed.

  integer, intent(in) :: iout              ! LUN for error messages
  integer, intent(out) :: ierr             ! error status code returned 0 = OK

  !--------------------------------------------------
  ! local...

  integer :: irank,idg1,idg2,icoord,iertmp,diff_code
  integer :: ispline
  logical :: ccwflag,ccwflag1,ccwflag2
  logical :: rewrite
  integer :: ibc1a,ibc1b,ibc2a,ibc2b
  REAL(KIND=rspec), dimension(:,:), allocatable :: zprof
  character*32 zunits
  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !--------------------------------------------------

  imod = 0

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2d_prof_store: invalid or unitialized xplasma object.'
     return
  endif

  call xplasma_gridId(s,gridname1,idg1)
  if(idg1.eq.0) then
     ierr=300
     write(iout,*) ' ?ps_2d_prof_store: grid name 1 not recognized: "', &
          trim(gridname1),'".'
     write(iout,*) '  error on call to store profile "',profname,'".'
  endif

  call xplasma_gridId(s,gridname2,idg2)
  if(idg2.eq.0) then
     ierr=300
     write(iout,*) ' ?ps_2d_prof_store: grid name 2 not recognized: "', &
          trim(gridname2),'".'
     write(iout,*) '  error on call to store profile "',profname,'".'
  endif
  if(ierr.ne.0) return

  ccwflag1 = .TRUE.
  ccwflag2 = .TRUE.

  ccwflag = (k_ccw1.ne.ps_ccw_reverse)

  call xplasma_grid_info(s,idg1,iertmp, coord=icoord)

  if(icoord.eq.xplasma_theta_coord) then
     ccwflag1=ccwflag
  endif

  ibc1a=0
  ibc1b=0

  if(bc_opt.ne.ps_bc_dflt) then
     if(icoord.eq.xplasma_rho_coord) then
        if(bc_opt.eq.ps_bc_grad00) then
           ibc1a=1  ! 1st derivative to -> 0 as rho -> 0
           ibc1b=0  ! still the default at bdy
        endif
     endif
  endif

  ccwflag = (k_ccw2.ne.ps_ccw_reverse)

  call xplasma_grid_info(s,idg2,iertmp, coord=icoord)

  if(icoord.eq.xplasma_theta_coord) then
     ccwflag2=ccwflag
  endif

  ibc2a=0
  ibc2b=0

  if(bc_opt.ne.ps_bc_dflt) then
     if(icoord.eq.xplasma_rho_coord) then
        if(bc_opt.eq.ps_bc_grad00) then
           ibc2a=1  ! 1st derivative to -> 0 as rho -> 0
           ibc2b=0  ! still the default at bdy
        endif
     endif
  endif

  allocate(zprof(n1,n2))

  ispline=max(ps_stepfun,isplini)
  if(ispline.ne.isplini) then
     call norm2(isplini,profdata,zprof)
     if(ierr.ne.0) return
     if(isplini.eq.ps_stepdv) then
        zunits=trim(units)//'/m^3'
     else if(isplini.eq.ps_stepda) then
        zunits=trim(units)//'/m^2'
     endif
  else
     zprof=profdata
     zunits=units
  endif

  !--------------------------------------------------
  !  find if profile ID already defined

  call xplasma_profId(s,profname,id)
  if(id.gt.0) then
     !  profile exists -- see if it is the same...
     call xplasma_prof_info(s,id,ierr, rank=irank)
     if(ierr.ne.0) then
        write(iout,*) ' ?ps_2d_prof_store: unexpected XPLASMA2 error:'
        call xplasma_error(s,ierr,iout)
        ierr=301
        rewrite=.FALSE.
     else
        if(irank.ne.2) then
           rewrite=.TRUE.
        else
           call xplasma_diff_prof(s,id,zprof,diff_code,ierr, &
                splineType=ispline, units=zunits, &
                ccwflag1=ccwflag1, ccwflag2=ccwflag2)
           if(ierr.ne.0) then
              write(iout,*) ' ?ps_2d_prof_store: unexpected XPLASMA2 error:'
              call xplasma_error(s,ierr,iout)
              ierr=301
              rewrite=.FALSE.
           else
              if(diff_code.eq.0) then
                 rewrite=.FALSE.
              else
                 rewrite=.TRUE.
              endif
           endif
        endif
     endif
  else
     rewrite=.TRUE.  ! actually, write for first time...
  endif

  if(.not.rewrite) then
     deallocate(zprof)
     return
  endif

  !--------------------------------------------------
  !  store the modified profile...

  !  set author...

  imod = 1

  call xplasma_author_set(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2d_prof_store: unexpected xplasma_author_set error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
     deallocate(zprof)
     return
  endif

  !  write profile...

  call xplasma_create_2dprof(s,profname,idg1,idg2,zprof,id,ierr, &
       ispline=ispline,ibcx1a=ibc1a,ibcx1b=ibc1b,ibcx2a=ibc2a,ibcx2b=ibc2b, &
       ccwflag1=ccwflag1,ccwflag2=ccwflag2, &
       label=label,units=zunits)

  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2d_prof_store: unexpected XPLASMA2 error:'
     call xplasma_error(s,ierr,iout)
     ierr=302
  endif

  !  clear author...

  call xplasma_author_clear(s,ps_cnames(iauthor),ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_2d_prof_store: unexpected xplasma_author_clear error:'
     call xplasma_error(s,ierr,iout)
     ierr=301
  endif

  deallocate(zprof)

  contains
    subroutine norm2(itype,zfdv,zf)

      integer, intent(in) :: itype
      REAL(KIND=rspec), intent(in) :: zfdv(n1,n2)   ! input f*dV or f*dA
      REAL(KIND=rspec), intent(out) :: zf(n1,n2)    ! output f

      ! divide out area or volume element, depending on "itype"

      REAL(KIND=rspec), dimension(:,:), allocatable :: zdv

      allocate(zdv(n1,n2))

      ierr=0

      if(itype.eq.ps_stepdv) then
         call xplasma_rhoth_grid_dva(s,idg1,idg2,ierr, dvol=zdv, &
              ccwflag=ccwflag)
         if(ierr.ne.0) then
            write(iout,*) ' ?ps_2d_prof_store: xplasma_rhoth_grid_dva error:'
            call xplasma_error(s,ierr,iout)
            zf=0.0d0
         endif

      else if(itype.eq.ps_stepda) then
         call xplasma_rhoth_grid_dva(s,idg1,idg2,ierr, darea=zdv, &
              ccwflag=ccwflag)
         if(ierr.ne.0) then
            write(iout,*) ' ?ps_2d_prof_store: xplasma_rhoth_grid_dva error:'
            call xplasma_error(s,ierr,iout)
            zf=0.0d0
         endif

      else
         ierr=302
         zf=0.0d0
         write(iout,*) ' ?ps_2d_prof_store internal error: bad norm2 call.'
      endif

      if(ierr.eq.0) then
         zf = zfdv/zdv
      endif

      deallocate(zdv)

    end subroutine norm2

end subroutine ps_2d_prof_store

subroutine ps_psiin_write(ps,nonlin,zeqdsk,zpsiin,inprof,zgafsep, ierr)

  !  DMC 24 Jan 2007 -- make psiin from eqdsk
  !  for GA TORAY

  !  DMC 18 Jun 2010 -- adapt for use w/ Plasma State
  !  heatlib/psiin_write.f90 -> ps_xplasma2/ps_psiin_write.f90

  !  The psiin file is a file related to the eqdsk file; it is an ascii
  !  file with format and contents specified by GA physicists.

  use geqdsk_nomds_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  use plasma_state_definition_mod

  implicit NONE

  INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)

  !------------------------
  !  subroutine arguments:

  type (plasma_state) :: ps        ! plasma state instance
  !  (expected to contain MHD equilibrium data matching (zeqdsk) data).

  integer, intent(in) :: nonlin    ! LUN for messages

  character*(*), intent(in) :: zeqdsk   ! path to existing GEQDSK file to read
  character*(*), intent(in) :: zpsiin   ! path to psiin file to write

  integer, intent(in) :: inprof    ! size of (bdy-oriented) TORAY grid
  real(R8), intent(in) :: zgafsep  ! Separatrix gap: a datum needed for psiin

  integer, intent(out) :: ierr     ! completion status code, 0=normal

  !------------------------
  !  local data:

  type(geqdsk) :: zg
  integer :: id_psi,icentr,ii,jj,ix,idi,lunphd,ilun_save

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, dimension(inprof) :: zx,zpsi  ! sqrt(Phi/Philim) grid, & Psi(x)

  !  normalized flux surface averages for TORAY 1.8
  integer :: inps
  real*8 :: zb0,zr0,zdelpsi,zpsi00,zpsirz_min
  real*8, dimension(:), allocatable :: zpsif,zxpsi,zhmmx,zb2n,zb1n,zrin

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !------------------------

  call ps_tagchk('ps_psiin_write',ps%itag,nonlin,ierr)
  if(ierr.ne.0) return

  ! check contents

  call ps_wrgeq_chk(ps,'ps_psiin_write',nonlin,ierr)
  if(ierr.ne.0) return

  ! OK basics seems to be there...

  ! get xplasma pointer

  xobj = transfer(ps%iobj,xobj)
  s => xobj%s_xpobj

  ! find available fortran I/O unit number
  call find_io_unit(lunphd)

  call geq_getlun(ilun_save)  ! GEQ module I/O unit saved off; restored later

  do
     ! read 
     call geq_setlun(lunphd)
     call geq_init(zg, zeqdsk, ierr)
     if(ierr.ne.0) then
        write(nonlin,*) ' ?psiin_write: failed to read G-eqdsk file: ', &
             trim(zeqdsk)
        exit
     endif

     if(abs(zg%ZMID_M).gt.1.0d-3) then
        write(nonlin,*) ' ?psiin_write: G-eqdsk file Zmid non-zero: ',zg%ZMID_M
        write(nonlin,*) '  error reading file: ',trim(zeqdsk)
        ierr=1
        exit
     endif

     ! make sure Psi(0)=0; delta(Psi) unchanged

     zpsi00 = zg%simag_Wb__Rad
     zdelpsi= zg%sibry_Wb__Rad - zg%simag_Wb__Rad

     zpsirz_min = minval(zg%psirz_Wb__Rad)
     
     ! RGA, if simag and sibry are being adjusted then psirz must also
     !      be adjusted to maintain consistency (TRANSP call to toray bug fix)
     if(.true. .or. abs(zpsirz_min).gt.0.05d0*abs(zdelpsi)) then
        write(nonlin,*) ' %psiin_write: apply Psi(0) correction to Psi(R,Z)'
        zg%psirz_Wb__Rad = zg%psirz_Wb__rad - zg%simag_Wb__Rad
     endif

     zg%sibry_Wb__Rad = zdelpsi
     zg%simag_Wb__Rad = 0.0d0

     ! compute Psi(x) on equispaced x grid

     do ix=1,inprof
        zx(ix)=(ix-1)*ONE/(inprof-1)
     enddo

     call xplasma_common_ids(s,ierr, id_psi=id_psi)
     call ckerr('xplasma_common_ids'); if(ierr.ne.0) exit

     call xplasma_eval_prof(s,id_psi,zx,zpsi,ierr)
     call ckerr('xplasma_eval_prof'); if(ierr.ne.0) exit

     !-------------------------------
     !  allocate profiles for flux surface averages
  
     zb0 = zg%bcentr_t
     zr0 = zg%rcentr_m

     inps = zg%nw
     allocate(zpsif(inps))  ! equispaced Psi grid
     allocate(zxpsi(inps))  ! corresponding x values

     call xplasma_rhopsi_gen(s,inps,ierr, psivals=zpsif, rhovals=zxpsi)
     call ckerr('xplasma_rhopsi_gen'); if(ierr.ne.0) exit

     !  ** normalize the Psi vector ** to match G-eqdsk

     zpsi(1:inprof) = zpsi(1:inprof)*(zdelpsi/zpsi(inprof))

     !  the flux surface averages:
     allocate(zhmmx(inps))  ! <sqrt(1-B/Bmax)>
     allocate(zb2n(inps))   ! <B^2>/B0^2
     allocate(zb1n(inps))   ! <B>/B0
     allocate(zrin(inps))   ! R0*<1/R>

     !  set up for numerical integration on this grid

     call xplasma_author_set(s,'psiin_write',ierr)
     call ckerr('xplasma_author_set'); if(ierr.ne.0) exit

     call xplasma_create_integ(s,'psiin_write_integ',zxpsi,idi,ierr, &
          cache_enable=.TRUE.)
     call ckerr('xplasma_create_integ'); if(ierr.ne.0) exit

     call xplasma_rho_zonint(s,idi,'<sqrt(1-B/Bmax)>S',zhmmx,ierr)
     call ckerr('xplasma_rho_zonint (1)'); if(ierr.ne.0) exit

     call xplasma_rho_zonint(s,idi,'<B^2>S',zb2n,ierr)
     call ckerr('xplasma_rho_zonint (2)'); if(ierr.ne.0) exit
     zb2n = zb2n/(zb0*zb0)

     call xplasma_rho_zonint(s,idi,'<B>S',zb1n,ierr)
     call ckerr('xplasma_rho_zonint (3)'); if(ierr.ne.0) exit
     zb1n = abs(zb1n/zb0)

     call xplasma_rho_zonint(s,idi,'<1/R>S',zrin,ierr)
     call ckerr('xplasma_rho_zonint (4)'); if(ierr.ne.0) exit
     zrin = zr0*zrin

     !  all done; clean up...

     call xplasma_remove_item(s,idi,ierr)
     call ckerr('xplasma_remove_item'); if(ierr.ne.0) exit

     call xplasma_author_clear(s,'psiin_write',ierr)
     call ckerr('xplasma_author_clear'); if(ierr.ne.0) exit

     !-------------------------------
     zpsi = zpsi * 1.0d5   ! T*m**2/rad --> kGauss*cm**2/rad
     !-------------------------------

     ierr=0
     exit  ! normal exit

  enddo

  call geq_setlun(ilun_save)  ! GEQ module I/O unit restored
  if(ierr.ne.0) return

  !-------------------------------
  ! write psiin

  open(unit=lunphd, file=zpsiin, status='unknown')

200 format(5e16.9)

  icentr=2
  write(lunphd, '(4i4)') icentr,inprof,inps,zg%nh

  write(lunphd, 200) zg%rdim_m, zg%zdim_m, zg%rcentr_m, zg%rleft_m, ZERO
  write(lunphd, 200) zg%rmaxis_m, zg%zmaxis_m, &
       zg%simag_Wb__Rad, zg%sibry_Wb__Rad, zg%bcentr_t

  write(lunphd, 200) zgafsep
  write(lunphd, 200) (zg%fpol_tm(ii),ii=1,inps)
  write(lunphd, 200) ((zg%psirz_Wb__Rad(ii,jj),ii=1,inps),jj=1,zg%nh)

  write(lunphd, 200) (zpsi(ii),ii=1,inprof)  ! Psi on "transport" grid

  write(lunphd, 200) (zg%qpsi(ii),ii=1,inps)

  write(lunphd, '(2i5)') zg%nbbbs,zg%limitr
  write(lunphd, 200) (zg%rbbbs_m(ii),zg%zbbbs_m(ii),ii=1,zg%nbbbs)
  write(lunphd, 200) (zg%rlim_m(ii),zg%zlim_m(ii),ii=1,zg%limitr)

  !---------------------------------
  !  append flux surface averages...

  write(lunphd, 200) (zhmmx(ii),ii=1,inps)
  write(lunphd, 200) (zb2n(ii),ii=1,inps)
  write(lunphd, 200) (zb1n(ii),ii=1,inps)
  write(lunphd, 200) (zrin(ii),ii=1,inps)

  !---------------------------------
  close(unit=lunphd)

  deallocate(zpsif,zxpsi,zhmmx,zb2n,zb1n,zrin)

CONTAINS

  subroutine ckerr(zname)
    character*(*) zname  ! xplasma call that failed

    if(ierr.ne.0) then
       write(nonlin,*) ' ?psiin_write: error in xplasma: ',trim(zname)
       call xplasma_error(s,ierr,nonlin)
    endif

  end subroutine ckerr

end subroutine ps_psiin_write

subroutine trxpl_imaswr2d_cdf(tpath,ztime0,ztavg,nbccw,npccw)

  !  write NetCDF file containing data for IMAS database, namely:
  ! 
  !   nR, nZ, & R & Z grids: Rr, Zz, [m]
  !   BR(R,Z), BZ(R,Z), Btor(R,Z), all in  [T]
  !   G(R,Z) - Gfun = R*Bt, [m*T]
  !   psi(R,Z) - poloidal flux, tflux(R,Z) - toroidal flux, in [Wb]
  !   theta(R,Z) - equilibrium poloidal angle, [rad]
  !   curt(R,Z) - total enclosed toroidal current(R,Z) density, [A/m**2]
  !   curpll(R,Z) -  parallel current(R,Z) density , ~<J.B>/|B|', [A/m**2] ...
  ! 

  implicit NONE

  character*(*), intent(in) :: tpath    ! TRANSP run specification
  real*8, intent(in) :: ztime0          ! time of interest
  real*8, intent(in) :: ztavg           ! +/- delta(t) time averaging
  integer, intent(in) :: nbccw          ! Btoroidal orientation
  integer, intent(in) :: npccw          ! Plasma current orientation
  ! convention is +1 "ccw" means "counter-clockwise looking down from above"
  !               -1  for clockwise orientation
  include 'trxpl.blk'  !... to communicate with trxpl_add_profile

  real*8 Rminx,Rmaxx,Zminx,Zmaxx      ! limits of xplasma grid
  real*8 Rminpl,Rmaxpl,Zminpl,Zmaxpl  ! limits of plasma boundary
  real*8 Rmin,Rmax,Zmin,Zmax          ! limits of grid for IMASWR2D

  real*8 dxtend                       ! amount of extension of grid beyond
                                      ! plasma bdy, subject to conditions

  integer :: nR,nZ                    ! gridsizes
  integer :: nbdy                     ! bdy contour size

  real*8, dimension(:), allocatable :: Rr,Zz  ! grids

  real*8, dimension(:), allocatable :: Rbdy,Zbdy    ! plasma bdy sequence

  !  (R,Z) variables, as described above:

  real*8, dimension(:,:), allocatable :: br,bz,bb,bt,psi,tflux,gfun,curt,curpll,theq

  !  constants, as described above, and...

  real*8, parameter :: ZERO = 0.0d0
  real*8, parameter :: ONE = 1.0d0
  real*8, parameter :: XPI = 3.1415926535897931D+00
  real*8, parameter :: TWOPI = 6.2831853071795862D+00   ! 2.0*PI

  !  additional items

  integer, parameter :: igmin = 10      ! sanity limits on gridsizes
  integer, parameter :: igmax = 2000

  integer ierr,lnout
  logical lxout,lchar,lyes
  character*120 zfile
  character*35 tlabel
  character*10 zname

  real*8 zrhomin,zrhomax
  integer :: idq
  real*8 r_mag_axis,z_mag_axis

  integer ingen

  !-------------------------------------------------------------------

  tlabel=' '
  write(tlabel,999) ztime0,ztavg
999 format('t = ',1pd11.4,' +/- ',1pd11.4,' s.')
  !-------------------------------------------------------------------
  !  xplasma has already been set up
  !-------------------------------------------------------------------

  !  get plasma & grid R,Z limits

  call eq_rholim(zrhomin,zrhomax)  ! axis & bdy rho

  call eq_rzlims(Rminx,Rmaxx,Zminx,Zmaxx,ierr)  ! xplasma grid limits
  if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eq_rzlims error.')

  call eq_glimrz(zrhomax,Rminpl,Rmaxpl,Zminpl,Zmaxpl,ierr)  ! plasma bdy limits
  if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eq_glimrz error.')

  !--------------------------------
  !  set default controls

  dxtend = 0.05d0     ! grid extension beyond plasma boundary, m
  nR = 101            ! number of R grid points
  nZ = 101            ! number of Z grid points

  !--------------------------------
  !  user specification of controls

  do

     Rmin=max(Rminx,Rminpl/2,Rminpl-dxtend)
     Rmax=min(Rmaxx,Rmaxpl+dxtend)
     Zmin=max(Zminx,Zminpl-dxtend)
     Zmax=min(Zmaxx,Zmaxpl+dxtend)

     if(lxout(0)) then
        write(lnout(0),1001) nR,Rmin,Rmax, &
             nZ,Zmin,Zmax,dxtend
1001    format(/' IMASWR2D grid (meters):'/ &
             5x,i4,' R points with Rmin=',1pd11.4,' & Rmax=',1pd11.4/ &
             5x,i4,' Z points with Zmin=',1pd11.4,' & Zmax=',1pd11.4/ &
             ' based on nominal extension of ',1pd11.4,' m beyond plasma bdy.'/ &
             /'trxpl_imaswr2d options:'/ &
             ' "R" -- change number of R grid points'/ &
             ' "Z" -- change number of Z grid points'/ &
             ' "X" -- change extension distance beyond plasma boundary'/ &
             '        (extension constrained by xplasma grid limits)'/ &
             ' "A" -- accept parameters and proceed'/ &
             ' "Q" -- quit (without writing data).'/)
     endif

     call uread('trxpl_imaswr2d: choose option:$')

     if(lchar('Q')) then
        return   ! do not write data

     else if(lchar('A')) then
        exit     ! proceed with parameters as selected

     else if(lchar('R')) then
        ! set nR
        if(lxout(0)) write(lnout(0),1004) igmin,igmax
        call ureadi('number of R grid points (nR):$',nR)
        nR=max(igmin,min(igmax,nR))

     else if(lchar('Z')) then
        ! set nZ
        if(lxout(0)) write(lnout(0),1004) igmin,igmax
        call ureadi('number of Z grid points (nZ):$',nZ)
        nZ=max(igmin,min(igmax,nZ))

     else if(lchar('X')) then
        ! set dxtend
        call ureadr8('grid extension beyond plasma bdy (m):$',dxtend)
        dxtend=abs(dxtend)

     else
        call uermsg('?trxpl_imaswr2d: unrecognized option code.',' ',0)
     endif

1004    format(' minimum gridsize: ',i4,' maximum gridsize: ',i4)
  enddo
  ixtnd=1
  iordr=1
  zlamda=1.0d30

  zname='CUR'
  call trxpl_add_profile(zname)
  if(numpro.ne.1) return
  
  zname='PLJB'
  call trxpl_add_profile(zname)
  if(numpro.ne.2) return

  zname='PLFLX2PI'
  call trxpl_add_profile(zname)
  if(numpro.ne.3) return

  zname='TRFLX'
  call trxpl_add_profile(zname)
  if(numpro.ne.4) return

  !----------------------------------
  !  allocate local arrays

  nbdy=2*(nR+nZ)
  allocate(Rr(nR),Zz(nZ))
  allocate(Rbdy(nbdy),Zbdy(nbdy))
  allocate(br(nR,nZ),bz(nR,nZ),bb(nR,nZ),bt(nR,nZ),psi(nR,nZ),tflux(nR,nZ),curt(nR,nZ))
  allocate(curpll(nR,nZ),theq(nR,nZ),gfun(nR,nZ))
  call calculate

  call display

  call uread(' write NetCDF file for IMASWR2D? (Y/N):$')

  if(lyes(0)) then
     zfile=' '
     call unixfile('trxpl_imaswr2d',zfile)
     call write_cdf
!     call trxpl_imasrd2d_cdf(zfile)
  endif

  deallocate(Rr,Zz)
  deallocate(Rbdy,Zbdy)
  deallocate(br,bz,bb,bt,psi,tflux,curt,curpll,theq,gfun)

contains

  !====================================================================
  subroutine calculate

    !  compute 2d profiles wanted by imaswr2d

    real*8 rhovec(nbdy),thvec(nbdy),phivec(nbdy)
    real*8 zwk(nR,8)
    integer i,j,k
    integer :: iregion(nbdy) !region for xplasma calls
    integer :: id_BR=0,id_BZ=0,id_Bphi=0,id_g=0,ids(8)
    integer :: id_psi=0,id_tflux=0,id_curt=0,id_curpll=0
    real*8 ztmp(nr)
    real*8, parameter :: tol=1.e-8
    real*8 zrho(1),zth(1),th1(1) ! for xplasma call
 
    !  mag axis...

    rhovec(1)=zrhomin
    thvec(1)=ZERO
    phivec(1)=ZERO
    call eq_rzget(1,rhovec(1:1),thvec(1:1),phivec(1:1),rbdy(1:1),zbdy(1:1), &
         iregion(1:1),ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eq_rzget error @axis.')
    r_mag_axis=rbdy(1)
    z_mag_axis=zbdy(1)

    !  ids ...

    call eq_gfnum('BR',id_br); ids(1)=id_br
    call eq_gfnum('BZ',id_bz); ids(2)=id_bz
    call eq_gfnum('Bphi',id_bphi); ids(3)=id_bphi
    ! psi:  poloidal flux, Webers   
    call eq_gfnum('PLFLX2PI',id_psi); ids(4)=id_psi
    ! plasma total toroidal current density A/m**2
    call eq_gfnum('CUR', id_curt); ids(5)=id_curt
    ! <j.B> current density A*T/m**2
    call eq_gfnum('PLJB', id_curpll); ids(6)=id_curpll
    ! toroidal flux (Webers)
    call eq_gfnum('TRFLX', id_tflux); ids(7)=id_tflux

    ! R*Bt (T*m)
    call eq_gfnum('G', id_g)
    if(id_g.gt.0) then
       call eqm_rzfun(id_g,zlamda,1,ZERO,ierr)
       if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eqm_rzfun error.')
    else
       call errmsg_exit('?trxpl_imaswr2d: no G profile data.')
    endif
    ids(8)=id_g
    

    rhovec = zrhomax
    phivec = 0
    do i=1,nbdy
       thvec(i) = (i-1)*twopi/(nbdy-1)
    enddo

    call eq_rzget(nbdy,rhovec,thvec,phivec,rbdy,zbdy,iregion,ierr)
    if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eq_rzget error.')

    rbdy(nbdy)=rbdy(1)  ! guarantee exact closure of the bdy contour
    zbdy(nbdy)=zbdy(1)

    !  form R & Z grids

    do i=1,nR
       Rr(i)=(Rmin*(nR-i)+Rmax*(i-1))/(nR-1)
    enddo

    do i=1,nZ
       Zz(i)=(Zmin*(nZ-i)+Zmax*(i-1))/(nZ-1)
    enddo

    theq=ZERO
    zrho=ZERO
    zth=ZERO
    do i=1,nR
       do j=1,nZ
          call eq_inv(1,Rr(i),Zz(j),zth(1),tol,zrho(1),th1(1),iregion(1:1),ierr)
          do while(th1(1) < -xpi)
             th1(1) = th1(1) + twopi
          enddo
          do while(th1(1) > xpi)
             th1(1) = th1(1) - twopi
          enddo
          theq(i,j)=th1(1)
       enddo
    enddo
    !  interpolate B field data ... 1 row at a time

    do i=1,nZ
       ztmp=Zz(i)
       call eq_frz(nR,Rr,ztmp,8,ids,nR,zwk,ierr)
       if(ierr.ne.0) call errmsg_exit('?trxpl_imaswr2d: eq_frz error.')

       br(1:nr,i)=zwk(1:nR,1)
       bz(1:nr,i)=zwk(1:nR,2)
       bb(1:nr,i)=sqrt( zwk(1:nR,1)**2 + zwk(1:nR,2)**2 + zwk(1:nR,3)**2 ) !Bmod
       psi(1:nr,i)=zwk(1:nR,4)
       tflux(1:nr,i)=zwk(1:nR,7)
       gfun(1:nr,i)=zwk(1:nR,8)
       bt(1:nR,i)=zwk(1:nR,8)/Rr(1:nR)
       curt(1:nR,i)=zwk(1:nR,5)
       curpll(1:nR,i)=zwk(1:nR,6)/bb(1:nr,i)

    enddo


  end subroutine calculate

  !====================================================================
  subroutine display

    real*8 wk(max(nR,nZ))

    wk = 0

    do
 
       if(lxout(0)) then
          write(lnout(0),1001) r_mag_axis,z_mag_axis
1001      format(' (R,Z) of magnetic axis (m):',2(1x,1pe11.4)/ &
               /'display options:'/ &
               ' "A" -- Br(R,Z)'/ &
               ' "B" -- Bz(R,Z)'/ &
               ' "C" -- Bt(R,Z)'/ &
               ' "D" -- |B|(R,Z)'/ &
               ' "G" -- GFUN(R,Z)'/ &
               ' "T" -- Tflux(R,Z)'/ &
               ' "P" -- Polflux(R,Z)'/ &
               ' "H" -- ThetaT(R,Z)'/ &
               ' "J" -- CurT(R,Z)'/ &
               ' "L" -- CurPll(R,Z)'/ &
               ' "X" -- xplasma debug plots.'/ &
               ' "Q" -- quit plotting menu.'/ &
               )
       endif

       call uread('trxpl_imaswr2d(display): specify plotting option:$')

       if(lchar('A')) then
          call r8_grf3f1(Rr,br,Zz,wk,nR,nZ,nR, &
               'R','Br','Z', &
               'm','T','m', tpath,tlabel,0)

       else if(lchar('B')) then
          call r8_grf3f1(Rr,bz,Zz,wk,nR,nZ,nR, &
               'R','Bz','Z', &
               'm','T','m', tpath,tlabel,0)

       else if(lchar('C')) then
          call r8_grf3f1(Rr,bt,Zz,wk,nR,nZ,nR, &
               'R','Bt','Z', &
               'm','T','m', tpath,tlabel,0)

        else if(lchar('D')) then
          call r8_grf3f1(Rr,bb,Zz,wk,nR,nZ,nR, &
               'R','|B|','Z', &
               'm','T','m', tpath,tlabel,0)

      else if(lchar('G')) then
          call r8_grf3f1(Rr,gfun,Zz,wk,nR,nZ,nR, &
               'R','G','Z', &
               'm','T*m','m', tpath,tlabel,0)

       else if(lchar('T')) then
          call r8_grf3f1(Rr,tflux,Zz,wk,nR,nZ,nR, &
               'R','Trflux','Z', &
               'm','Wb','m', tpath,tlabel,0)

       else if(lchar('P')) then
          call r8_grf3f1(Rr,psi,Zz,wk,nR,nZ,nR, &
               'R','Plflux','Z', &
               'm','Wb','m', tpath,tlabel,0)

       else if(lchar('H')) then
          call r8_grf3f1(Rr,theq,Zz,wk,nR,nZ,nR, &
               'R','Theta','Z', &
               'm','rad','m', tpath,tlabel,0)

       else if(lchar('J')) then
          call r8_grf3f1(Rr,curt,Zz,wk,nR,nZ,nR, &
               'R','curt','Z', &
               'm','A/m2','m', tpath,tlabel,0)
 
       else if(lchar('L')) then
          call r8_grf3f1(Rr,curpll,Zz,wk,nR,nZ,nR, &
               'R','curPll','Z', &
               'm','A/m2','m', tpath,tlabel,0)
          
          
       else if(lchar('X')) then
          call eqdbg_plot

       else if(lchar('Q')) then
          exit
       else
          call uermsg('?trxpl_imaswr2d(display): unrecogized option.',' ',0)
       endif

    enddo

  end subroutine display

  subroutine write_cdf

    use ezcdf

    integer ncid,ierr,ilf

    !  write NetCDF file for IMASWR2D

    ilf=len_trim(zfile)

    call cdf_open(ncid,zfile(1:ilf),'w',ierr)
    if(ierr.ne.0) then
       write(lnout(0),*) ' ?trxpl_imaswr2d: NetCDF open failure: ',zfile(1:ilf)

    else

       !  ** NetCDF definitions **

       !  TRANSP data source info
       call cdf_define(ncid,'TRANSP_path',tpath)
       call cdf_define(ncid,'time',ztime0)
       call cdf_define(ncid,'avg_delta_t',ztavg)
       
       !  grids
       call cdf_define(ncid,'nr',nR)
       call cdf_define(ncid,'nz',nZ)
       call cdf_define(ncid,'rr',Rr)
       call cdf_define(ncid,'zz',Zz)

       !  main data
       call cdf_define(ncid,'nbccw',nbccw)
       call cdf_define(ncid,'npccw',npccw)
       call cdf_define(ncid,'br',br)
       call cdf_define(ncid,'bz',bz)
       call cdf_define(ncid,'bt',bt)
       call cdf_define(ncid,'gfun',gfun)
       call cdf_define(ncid,'theta',theq)
       call cdf_define(ncid,'psi',psi)
       call cdf_define(ncid,'tflux',tflux)
       call cdf_define(ncid,'curt',curt)
       call cdf_define(ncid,'curpll',curpll)
       !  plasma bdy & scrape-off information
       call cdf_define(ncid,'r_mag_axis',r_mag_axis)
       call cdf_define(ncid,'z_mag_axis',z_mag_axis)
       call cdf_define(ncid,'dxtend',dxtend)
       call cdf_define(ncid,'nbdy',nbdy)
       call cdf_define(ncid,'rbdy',Rbdy)
       call cdf_define(ncid,'zbdy',Zbdy)
       
       !  addl labeling/attributes
       call cdf_setatt(ncid,'time','time slice from TRANSP', 'sec')
       call cdf_setatt(ncid,'avg_delta_t','delta(time), +/- for averaging', 'sec')
       call cdf_setatt(ncid,'nz','grid size, Z')
       call cdf_setatt(ncid,'nr','grid size, R')
       call cdf_setatt(ncid,'nz','grid size, Z')
       call cdf_setatt(ncid,'rr','Cartesian grid, R major radius', 'm')
       call cdf_setatt(ncid,'zz','Cartesian grid, Z coordinate', 'm')
       call cdf_setatt(ncid,'nbccw','Btoroidal orientation; +1 ccw looking down from above; -1 clockwise')
       call cdf_setatt(ncid,'npccw','Plasma current orientation; +1 ccw looking down from above; -1 clockwise')
       call cdf_setatt(ncid,'br','magnetic field BR(R,Z) component', 'T')
       call cdf_setatt(ncid,'bz','magnetic field BZ(R,Z) component', 'T')
       call cdf_setatt(ncid,'bt','magnetic field Bt(R,Z) toroidal component', 'T')
       call cdf_setatt(ncid,'gfun','g-function,R*Bt(R,Z)', 'T*m')
       call cdf_setatt(ncid,'theta','equilibrium poloidal angle(R,Z)', 'rad')
       call cdf_setatt(ncid,'psi','poloidal flux(R,Z)', 'Wb')
       call cdf_setatt(ncid,'tflux','toroidal flux(R,Z)', 'Wb')
       call cdf_setatt(ncid,'curt','total enclosed toroidal current(R,Z) density', 'A/m**2')
       call cdf_setatt(ncid,'curpll','parallel current(R,Z) density , ~<J.B>/|B|', 'A/m**2')
       call cdf_setatt(ncid,'r_mag_axis','R magnetic axis', 'm')
       call cdf_setatt(ncid,'z_mag_axis','Z magnetic axis', 'm')
       call cdf_setatt(ncid,'dxtend','grid extension beyond plasma bdoundary','m')
       call cdf_setatt(ncid,'nbdy','bdy contour size')
       call cdf_setatt(ncid,'rbdy','R bdy, guarantee exact closure of the bdy contour', 'm')
       call cdf_setatt(ncid,'zbdy','Z bdy, guarantee exact closure of the bdy contour', 'm')
      !  ** NetCDF writes **

       !  TRANSP data source info
       call cdf_write(ncid,'TRANSP_path',tpath)
       call cdf_write(ncid,'time',ztime0)
       call cdf_write(ncid,'avg_delta_t',ztavg)

       !  grids
       call cdf_write(ncid,'nr',nR)
       call cdf_write(ncid,'nz',nZ)
       call cdf_write(ncid,'rr',Rr)
       call cdf_write(ncid,'zz',Zz)

       !  main data
       call cdf_write(ncid,'nbccw',nbccw)
       call cdf_write(ncid,'npccw',npccw)
       call cdf_write(ncid,'bz',bz)
       call cdf_write(ncid,'br',br)
       call cdf_write(ncid,'bz',bz)
       call cdf_write(ncid,'bt',bt)
       call cdf_write(ncid,'gfun',gfun)
       call cdf_write(ncid,'theta',theq)
       call cdf_write(ncid,'psi',psi)
       call cdf_write(ncid,'tflux',tflux)
       call cdf_write(ncid,'curt',curt)
       call cdf_write(ncid,'curpll',curpll)

       !  plasma bdy & scrape-off information
       call cdf_write(ncid,'r_mag_axis',r_mag_axis)
       call cdf_write(ncid,'z_mag_axis',z_mag_axis)
       call cdf_write(ncid,'dxtend',dxtend)
       call cdf_write(ncid,'nbdy',nbdy)
       call cdf_write(ncid,'rbdy',Rbdy)
       call cdf_write(ncid,'zbdy',Zbdy)

       !  ** all done **

       call cdf_close(ncid)

    endif

  end subroutine write_cdf

end subroutine trxpl_imaswr2d_cdf

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE plasma_state_merge_6(cclist,w1,ss1,ss2,ss3,icheck,iout,ierr)


  ! Merge floating point data
  !   ss3 <-- w1*ss1 + (1-w1)*ss2

  USE plasma_state_definition_mod
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: cclist(ps_ccount)
                                ! list of components to merge
                                ! use ps_cc_all to merge all components

  REAL(KIND=rspec) :: w1        ! weight on ss1
  TYPE (plasma_state) :: ss1    ! state data to copy *from* with weight (w1)
  TYPE (plasma_state) :: ss2    ! state data to copy *from* with weight (1-w1)
  TYPE (plasma_state) :: ss3    ! state to which data is copied.
  INTEGER, INTENT(IN) :: icheck ! control for checking match of non-floating-
  !  point data: ps_ignore, ps_warn, or ps_error on mismatch.

  INTEGER, INTENT(IN) :: iout
  INTEGER, INTENT(INOUT) :: ierr  ! completion code (not cleared,set on error)

  !-------------------
  INTEGER :: isize
  !-------------------

  !-----------------------------------------------
  ! copy scalars and arrays that are allocated...

  IF((ALLOCATED(ss3%PsiRZ)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%PsiRZ).AND.ALLOCATED(ss2%PsiRZ)) THEN
        CALL ps_conformal("PsiRZ",ss2%PsiRZ,ss3%PsiRZ,iout,ierr)
        CALL ps_conformal("PsiRZ",ss1%PsiRZ,ss3%PsiRZ,iout,ierr)
        if(ierr.eq.0) ss3%PsiRZ = w1*ss1%PsiRZ + (1.0_rspec-w1)*ss2%PsiRZ
     ELSE IF(ALLOCATED(ss1%PsiRZ)) THEN
        CALL ps_conformal("PsiRZ",ss1%PsiRZ,ss3%PsiRZ,iout,ierr)
        ss3%PsiRZ = ss1%PsiRZ
     ELSE IF(ALLOCATED(ss2%PsiRZ)) THEN
        CALL ps_conformal("PsiRZ",ss2%PsiRZ,ss3%PsiRZ,iout,ierr)
        ss3%PsiRZ = ss2%PsiRZ
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_EQ).EQ.1) THEN
     ss3%Psi_to_machine_axis = w1*ss1%Psi_to_machine_axis + (1.0_rspec-w1)*ss2%Psi_to_machine_axis
  ENDIF

  IF((ALLOCATED(ss3%psmom_errck)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%psmom_errck).AND.ALLOCATED(ss2%psmom_errck)) THEN
        CALL ps_conformal("psmom_errck",ss2%psmom_errck,ss3%psmom_errck,iout,ierr)
        CALL ps_conformal("psmom_errck",ss1%psmom_errck,ss3%psmom_errck,iout,ierr)
        if(ierr.eq.0) ss3%psmom_errck = w1*ss1%psmom_errck + (1.0_rspec-w1)*ss2%psmom_errck
     ELSE IF(ALLOCATED(ss1%psmom_errck)) THEN
        CALL ps_conformal("psmom_errck",ss1%psmom_errck,ss3%psmom_errck,iout,ierr)
        ss3%psmom_errck = ss1%psmom_errck
     ELSE IF(ALLOCATED(ss2%psmom_errck)) THEN
        CALL ps_conformal("psmom_errck",ss2%psmom_errck,ss3%psmom_errck,iout,ierr)
        ss3%psmom_errck = ss2%psmom_errck
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%psmom_nc)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%psmom_nc).AND.ALLOCATED(ss2%psmom_nc)) THEN
        CALL ps_conformal("psmom_nc",ss2%psmom_nc,ss3%psmom_nc,iout,ierr)
        CALL ps_conformal("psmom_nc",ss1%psmom_nc,ss3%psmom_nc,iout,ierr)
        if(ierr.eq.0) ss3%psmom_nc = w1*ss1%psmom_nc + (1.0_rspec-w1)*ss2%psmom_nc
     ELSE IF(ALLOCATED(ss1%psmom_nc)) THEN
        CALL ps_conformal("psmom_nc",ss1%psmom_nc,ss3%psmom_nc,iout,ierr)
        ss3%psmom_nc = ss1%psmom_nc
     ELSE IF(ALLOCATED(ss2%psmom_nc)) THEN
        CALL ps_conformal("psmom_nc",ss2%psmom_nc,ss3%psmom_nc,iout,ierr)
        ss3%psmom_nc = ss2%psmom_nc
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%psmom_num)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%psmom_num).AND.ALLOCATED(ss2%psmom_num)) THEN
        CALL ps_diff("psmom_num",ss1%psmom_num,ss2%psmom_num,icheck,iout,ierr)
        CALL ps_conformal("psmom_num",ss1%psmom_num,ss3%psmom_num,iout,ierr)
        if(ierr.eq.0) ss3%psmom_num = ss1%psmom_num
     ELSE IF(ALLOCATED(ss1%psmom_num)) THEN
        CALL ps_conformal("psmom_num",ss1%psmom_num,ss3%psmom_num,iout,ierr)
        ss3%psmom_num = ss1%psmom_num
     ELSE IF(ALLOCATED(ss2%psmom_num)) THEN
        CALL ps_conformal("psmom_num",ss2%psmom_num,ss3%psmom_num,iout,ierr)
        ss3%psmom_num = ss2%psmom_num
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%P_eq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%P_eq).AND.ALLOCATED(ss2%P_eq)) THEN
        CALL ps_conformal("P_eq",ss2%P_eq,ss3%P_eq,iout,ierr)
        CALL ps_conformal("P_eq",ss1%P_eq,ss3%P_eq,iout,ierr)
        if(ierr.eq.0) ss3%P_eq = w1*ss1%P_eq + (1.0_rspec-w1)*ss2%P_eq
     ELSE IF(ALLOCATED(ss1%P_eq)) THEN
        CALL ps_conformal("P_eq",ss1%P_eq,ss3%P_eq,iout,ierr)
        ss3%P_eq = ss1%P_eq
     ELSE IF(ALLOCATED(ss2%P_eq)) THEN
        CALL ps_conformal("P_eq",ss2%P_eq,ss3%P_eq,iout,ierr)
        ss3%P_eq = ss2%P_eq
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_ALL)) THEN
     IF(ALLOCATED(ss1%qatom_ALL).AND.ALLOCATED(ss2%qatom_ALL)) THEN
        CALL ps_diff("qatom_ALL",ss1%qatom_ALL,ss2%qatom_ALL,ps_error,iout,ierr)
        CALL ps_conformal("qatom_ALL",ss1%qatom_ALL,ss3%qatom_ALL,iout,ierr)
        if(ierr.eq.0) ss3%qatom_ALL = ss1%qatom_ALL
     ELSE IF(ALLOCATED(ss1%qatom_ALL)) THEN
        CALL ps_conformal("qatom_ALL",ss1%qatom_ALL,ss3%qatom_ALL,iout,ierr)
        ss3%qatom_ALL = ss1%qatom_ALL
     ELSE IF(ALLOCATED(ss2%qatom_ALL)) THEN
        CALL ps_conformal("qatom_ALL",ss2%qatom_ALL,ss3%qatom_ALL,iout,ierr)
        ss3%qatom_ALL = ss2%qatom_ALL
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_ALLA)) THEN
     IF(ALLOCATED(ss1%qatom_ALLA).AND.ALLOCATED(ss2%qatom_ALLA)) THEN
        CALL ps_diff("qatom_ALLA",ss1%qatom_ALLA,ss2%qatom_ALLA,ps_error,iout,ierr)
        CALL ps_conformal("qatom_ALLA",ss1%qatom_ALLA,ss3%qatom_ALLA,iout,ierr)
        if(ierr.eq.0) ss3%qatom_ALLA = ss1%qatom_ALLA
     ELSE IF(ALLOCATED(ss1%qatom_ALLA)) THEN
        CALL ps_conformal("qatom_ALLA",ss1%qatom_ALLA,ss3%qatom_ALLA,iout,ierr)
        ss3%qatom_ALLA = ss1%qatom_ALLA
     ELSE IF(ALLOCATED(ss2%qatom_ALLA)) THEN
        CALL ps_conformal("qatom_ALLA",ss2%qatom_ALLA,ss3%qatom_ALLA,iout,ierr)
        ss3%qatom_ALLA = ss2%qatom_ALLA
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_RFMIN)) THEN
     IF(ALLOCATED(ss1%qatom_RFMIN).AND.ALLOCATED(ss2%qatom_RFMIN)) THEN
        CALL ps_diff("qatom_RFMIN",ss1%qatom_RFMIN,ss2%qatom_RFMIN,ps_error,iout,ierr)
        CALL ps_conformal("qatom_RFMIN",ss1%qatom_RFMIN,ss3%qatom_RFMIN,iout,ierr)
        if(ierr.eq.0) ss3%qatom_RFMIN = ss1%qatom_RFMIN
     ELSE IF(ALLOCATED(ss1%qatom_RFMIN)) THEN
        CALL ps_conformal("qatom_RFMIN",ss1%qatom_RFMIN,ss3%qatom_RFMIN,iout,ierr)
        ss3%qatom_RFMIN = ss1%qatom_RFMIN
     ELSE IF(ALLOCATED(ss2%qatom_RFMIN)) THEN
        CALL ps_conformal("qatom_RFMIN",ss2%qatom_RFMIN,ss3%qatom_RFMIN,iout,ierr)
        ss3%qatom_RFMIN = ss2%qatom_RFMIN
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_S)) THEN
     IF(ALLOCATED(ss1%qatom_S).AND.ALLOCATED(ss2%qatom_S)) THEN
        CALL ps_diff("qatom_S",ss1%qatom_S,ss2%qatom_S,ps_error,iout,ierr)
        CALL ps_conformal("qatom_S",ss1%qatom_S,ss3%qatom_S,iout,ierr)
        if(ierr.eq.0) ss3%qatom_S = ss1%qatom_S
     ELSE IF(ALLOCATED(ss1%qatom_S)) THEN
        CALL ps_conformal("qatom_S",ss1%qatom_S,ss3%qatom_S,iout,ierr)
        ss3%qatom_S = ss1%qatom_S
     ELSE IF(ALLOCATED(ss2%qatom_S)) THEN
        CALL ps_conformal("qatom_S",ss2%qatom_S,ss3%qatom_S,iout,ierr)
        ss3%qatom_S = ss2%qatom_S
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SA)) THEN
     IF(ALLOCATED(ss1%qatom_SA).AND.ALLOCATED(ss2%qatom_SA)) THEN
        CALL ps_diff("qatom_SA",ss1%qatom_SA,ss2%qatom_SA,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SA",ss1%qatom_SA,ss3%qatom_SA,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SA = ss1%qatom_SA
     ELSE IF(ALLOCATED(ss1%qatom_SA)) THEN
        CALL ps_conformal("qatom_SA",ss1%qatom_SA,ss3%qatom_SA,iout,ierr)
        ss3%qatom_SA = ss1%qatom_SA
     ELSE IF(ALLOCATED(ss2%qatom_SA)) THEN
        CALL ps_conformal("qatom_SA",ss2%qatom_SA,ss3%qatom_SA,iout,ierr)
        ss3%qatom_SA = ss2%qatom_SA
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SFUS)) THEN
     IF(ALLOCATED(ss1%qatom_SFUS).AND.ALLOCATED(ss2%qatom_SFUS)) THEN
        CALL ps_diff("qatom_SFUS",ss1%qatom_SFUS,ss2%qatom_SFUS,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SFUS",ss1%qatom_SFUS,ss3%qatom_SFUS,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SFUS = ss1%qatom_SFUS
     ELSE IF(ALLOCATED(ss1%qatom_SFUS)) THEN
        CALL ps_conformal("qatom_SFUS",ss1%qatom_SFUS,ss3%qatom_SFUS,iout,ierr)
        ss3%qatom_SFUS = ss1%qatom_SFUS
     ELSE IF(ALLOCATED(ss2%qatom_SFUS)) THEN
        CALL ps_conformal("qatom_SFUS",ss2%qatom_SFUS,ss3%qatom_SFUS,iout,ierr)
        ss3%qatom_SFUS = ss2%qatom_SFUS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SGAS)) THEN
     IF(ALLOCATED(ss1%qatom_SGAS).AND.ALLOCATED(ss2%qatom_SGAS)) THEN
        CALL ps_diff("qatom_SGAS",ss1%qatom_SGAS,ss2%qatom_SGAS,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SGAS",ss1%qatom_SGAS,ss3%qatom_SGAS,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SGAS = ss1%qatom_SGAS
     ELSE IF(ALLOCATED(ss1%qatom_SGAS)) THEN
        CALL ps_conformal("qatom_SGAS",ss1%qatom_SGAS,ss3%qatom_SGAS,iout,ierr)
        ss3%qatom_SGAS = ss1%qatom_SGAS
     ELSE IF(ALLOCATED(ss2%qatom_SGAS)) THEN
        CALL ps_conformal("qatom_SGAS",ss2%qatom_SGAS,ss3%qatom_SGAS,iout,ierr)
        ss3%qatom_SGAS = ss2%qatom_SGAS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SIMP0)) THEN
     IF(ALLOCATED(ss1%qatom_SIMP0).AND.ALLOCATED(ss2%qatom_SIMP0)) THEN
        CALL ps_diff("qatom_SIMP0",ss1%qatom_SIMP0,ss2%qatom_SIMP0,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SIMP0",ss1%qatom_SIMP0,ss3%qatom_SIMP0,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SIMP0 = ss1%qatom_SIMP0
     ELSE IF(ALLOCATED(ss1%qatom_SIMP0)) THEN
        CALL ps_conformal("qatom_SIMP0",ss1%qatom_SIMP0,ss3%qatom_SIMP0,iout,ierr)
        ss3%qatom_SIMP0 = ss1%qatom_SIMP0
     ELSE IF(ALLOCATED(ss2%qatom_SIMP0)) THEN
        CALL ps_conformal("qatom_SIMP0",ss2%qatom_SIMP0,ss3%qatom_SIMP0,iout,ierr)
        ss3%qatom_SIMP0 = ss2%qatom_SIMP0
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SIMPI)) THEN
     IF(ALLOCATED(ss1%qatom_SIMPI).AND.ALLOCATED(ss2%qatom_SIMPI)) THEN
        CALL ps_diff("qatom_SIMPI",ss1%qatom_SIMPI,ss2%qatom_SIMPI,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SIMPI",ss1%qatom_SIMPI,ss3%qatom_SIMPI,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SIMPI = ss1%qatom_SIMPI
     ELSE IF(ALLOCATED(ss1%qatom_SIMPI)) THEN
        CALL ps_conformal("qatom_SIMPI",ss1%qatom_SIMPI,ss3%qatom_SIMPI,iout,ierr)
        ss3%qatom_SIMPI = ss1%qatom_SIMPI
     ELSE IF(ALLOCATED(ss2%qatom_SIMPI)) THEN
        CALL ps_conformal("qatom_SIMPI",ss2%qatom_SIMPI,ss3%qatom_SIMPI,iout,ierr)
        ss3%qatom_SIMPI = ss2%qatom_SIMPI
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%qatom_SNBI)) THEN
     IF(ALLOCATED(ss1%qatom_SNBI).AND.ALLOCATED(ss2%qatom_SNBI)) THEN
        CALL ps_diff("qatom_SNBI",ss1%qatom_SNBI,ss2%qatom_SNBI,ps_error,iout,ierr)
        CALL ps_conformal("qatom_SNBI",ss1%qatom_SNBI,ss3%qatom_SNBI,iout,ierr)
        if(ierr.eq.0) ss3%qatom_SNBI = ss1%qatom_SNBI
     ELSE IF(ALLOCATED(ss1%qatom_SNBI)) THEN
        CALL ps_conformal("qatom_SNBI",ss1%qatom_SNBI,ss3%qatom_SNBI,iout,ierr)
        ss3%qatom_SNBI = ss1%qatom_SNBI
     ELSE IF(ALLOCATED(ss2%qatom_SNBI)) THEN
        CALL ps_conformal("qatom_SNBI",ss2%qatom_SNBI,ss3%qatom_SNBI,iout,ierr)
        ss3%qatom_SNBI = ss2%qatom_SNBI
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qbeami)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%qbeami).AND.ALLOCATED(ss2%qbeami)) THEN
        CALL ps_conformal("qbeami",ss2%qbeami,ss3%qbeami,iout,ierr)
        CALL ps_conformal("qbeami",ss1%qbeami,ss3%qbeami,iout,ierr)
        if(ierr.eq.0) ss3%qbeami = w1*ss1%qbeami + (1.0_rspec-w1)*ss2%qbeami
     ELSE IF(ALLOCATED(ss1%qbeami)) THEN
        CALL ps_conformal("qbeami",ss1%qbeami,ss3%qbeami,iout,ierr)
        ss3%qbeami = ss1%qbeami
     ELSE IF(ALLOCATED(ss2%qbeami)) THEN
        CALL ps_conformal("qbeami",ss2%qbeami,ss3%qbeami,iout,ierr)
        ss3%qbeami = ss2%qbeami
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qcomp_e)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%qcomp_e).AND.ALLOCATED(ss2%qcomp_e)) THEN
        CALL ps_conformal("qcomp_e",ss2%qcomp_e,ss3%qcomp_e,iout,ierr)
        CALL ps_conformal("qcomp_e",ss1%qcomp_e,ss3%qcomp_e,iout,ierr)
        if(ierr.eq.0) ss3%qcomp_e = w1*ss1%qcomp_e + (1.0_rspec-w1)*ss2%qcomp_e
     ELSE IF(ALLOCATED(ss1%qcomp_e)) THEN
        CALL ps_conformal("qcomp_e",ss1%qcomp_e,ss3%qcomp_e,iout,ierr)
        ss3%qcomp_e = ss1%qcomp_e
     ELSE IF(ALLOCATED(ss2%qcomp_e)) THEN
        CALL ps_conformal("qcomp_e",ss2%qcomp_e,ss3%qcomp_e,iout,ierr)
        ss3%qcomp_e = ss2%qcomp_e
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qcomp_i)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%qcomp_i).AND.ALLOCATED(ss2%qcomp_i)) THEN
        CALL ps_conformal("qcomp_i",ss2%qcomp_i,ss3%qcomp_i,iout,ierr)
        CALL ps_conformal("qcomp_i",ss1%qcomp_i,ss3%qcomp_i,iout,ierr)
        if(ierr.eq.0) ss3%qcomp_i = w1*ss1%qcomp_i + (1.0_rspec-w1)*ss2%qcomp_i
     ELSE IF(ALLOCATED(ss1%qcomp_i)) THEN
        CALL ps_conformal("qcomp_i",ss1%qcomp_i,ss3%qcomp_i,iout,ierr)
        ss3%qcomp_i = ss1%qcomp_i
     ELSE IF(ALLOCATED(ss2%qcomp_i)) THEN
        CALL ps_conformal("qcomp_i",ss2%qcomp_i,ss3%qcomp_i,iout,ierr)
        ss3%qcomp_i = ss2%qcomp_i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qie)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%qie).AND.ALLOCATED(ss2%qie)) THEN
        CALL ps_conformal("qie",ss2%qie,ss3%qie,iout,ierr)
        CALL ps_conformal("qie",ss1%qie,ss3%qie,iout,ierr)
        if(ierr.eq.0) ss3%qie = w1*ss1%qie + (1.0_rspec-w1)*ss2%qie
     ELSE IF(ALLOCATED(ss1%qie)) THEN
        CALL ps_conformal("qie",ss1%qie,ss3%qie,iout,ierr)
        ss3%qie = ss1%qie
     ELSE IF(ALLOCATED(ss2%qie)) THEN
        CALL ps_conformal("qie",ss2%qie,ss3%qie,iout,ierr)
        ss3%qie = ss2%qie
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qioniz)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%qioniz).AND.ALLOCATED(ss2%qioniz)) THEN
        CALL ps_conformal("qioniz",ss2%qioniz,ss3%qioniz,iout,ierr)
        CALL ps_conformal("qioniz",ss1%qioniz,ss3%qioniz,iout,ierr)
        if(ierr.eq.0) ss3%qioniz = w1*ss1%qioniz + (1.0_rspec-w1)*ss2%qioniz
     ELSE IF(ALLOCATED(ss1%qioniz)) THEN
        CALL ps_conformal("qioniz",ss1%qioniz,ss3%qioniz,iout,ierr)
        ss3%qioniz = ss1%qioniz
     ELSE IF(ALLOCATED(ss2%qioniz)) THEN
        CALL ps_conformal("qioniz",ss2%qioniz,ss3%qioniz,iout,ierr)
        ss3%qioniz = ss2%qioniz
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%ql_operator)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%ql_operator).AND.ALLOCATED(ss2%ql_operator)) THEN
        CALL ps_diff("ql_operator",ss1%ql_operator,ss2%ql_operator,icheck,iout,ierr)
        CALL ps_conformal("ql_operator",ss1%ql_operator,ss3%ql_operator,iout,ierr)
        if(ierr.eq.0) ss3%ql_operator = ss1%ql_operator
     ELSE IF(ALLOCATED(ss1%ql_operator)) THEN
        CALL ps_conformal("ql_operator",ss1%ql_operator,ss3%ql_operator,iout,ierr)
        ss3%ql_operator = ss1%ql_operator
     ELSE IF(ALLOCATED(ss2%ql_operator)) THEN
        CALL ps_conformal("ql_operator",ss2%ql_operator,ss3%ql_operator,iout,ierr)
        ss3%ql_operator = ss2%ql_operator
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qqcx)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%qqcx).AND.ALLOCATED(ss2%qqcx)) THEN
        CALL ps_conformal("qqcx",ss2%qqcx,ss3%qqcx,iout,ierr)
        CALL ps_conformal("qqcx",ss1%qqcx,ss3%qqcx,iout,ierr)
        if(ierr.eq.0) ss3%qqcx = w1*ss1%qqcx + (1.0_rspec-w1)*ss2%qqcx
     ELSE IF(ALLOCATED(ss1%qqcx)) THEN
        CALL ps_conformal("qqcx",ss1%qqcx,ss3%qqcx,iout,ierr)
        ss3%qqcx = ss1%qqcx
     ELSE IF(ALLOCATED(ss2%qqcx)) THEN
        CALL ps_conformal("qqcx",ss2%qqcx,ss3%qqcx,iout,ierr)
        ss3%qqcx = ss2%qqcx
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qrot_conv)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%qrot_conv).AND.ALLOCATED(ss2%qrot_conv)) THEN
        CALL ps_conformal("qrot_conv",ss2%qrot_conv,ss3%qrot_conv,iout,ierr)
        CALL ps_conformal("qrot_conv",ss1%qrot_conv,ss3%qrot_conv,iout,ierr)
        if(ierr.eq.0) ss3%qrot_conv = w1*ss1%qrot_conv + (1.0_rspec-w1)*ss2%qrot_conv
     ELSE IF(ALLOCATED(ss1%qrot_conv)) THEN
        CALL ps_conformal("qrot_conv",ss1%qrot_conv,ss3%qrot_conv,iout,ierr)
        ss3%qrot_conv = ss1%qrot_conv
     ELSE IF(ALLOCATED(ss2%qrot_conv)) THEN
        CALL ps_conformal("qrot_conv",ss2%qrot_conv,ss3%qrot_conv,iout,ierr)
        ss3%qrot_conv = ss2%qrot_conv
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%qrot_diff)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%qrot_diff).AND.ALLOCATED(ss2%qrot_diff)) THEN
        CALL ps_conformal("qrot_diff",ss2%qrot_diff,ss3%qrot_diff,iout,ierr)
        CALL ps_conformal("qrot_diff",ss1%qrot_diff,ss3%qrot_diff,iout,ierr)
        if(ierr.eq.0) ss3%qrot_diff = w1*ss1%qrot_diff + (1.0_rspec-w1)*ss2%qrot_diff
     ELSE IF(ALLOCATED(ss1%qrot_diff)) THEN
        CALL ps_conformal("qrot_diff",ss1%qrot_diff,ss3%qrot_diff,iout,ierr)
        ss3%qrot_diff = ss1%qrot_diff
     ELSE IF(ALLOCATED(ss2%qrot_diff)) THEN
        CALL ps_conformal("qrot_diff",ss2%qrot_diff,ss3%qrot_diff,iout,ierr)
        ss3%qrot_diff = ss2%qrot_diff
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_ALL)) THEN
     IF(ALLOCATED(ss1%q_ALL).AND.ALLOCATED(ss2%q_ALL)) THEN
        CALL ps_diff("q_ALL",ss1%q_ALL,ss2%q_ALL,ps_error,iout,ierr)
        CALL ps_conformal("q_ALL",ss1%q_ALL,ss3%q_ALL,iout,ierr)
        if(ierr.eq.0) ss3%q_ALL = ss1%q_ALL
     ELSE IF(ALLOCATED(ss1%q_ALL)) THEN
        CALL ps_conformal("q_ALL",ss1%q_ALL,ss3%q_ALL,iout,ierr)
        ss3%q_ALL = ss1%q_ALL
     ELSE IF(ALLOCATED(ss2%q_ALL)) THEN
        CALL ps_conformal("q_ALL",ss2%q_ALL,ss3%q_ALL,iout,ierr)
        ss3%q_ALL = ss2%q_ALL
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_ALLA)) THEN
     IF(ALLOCATED(ss1%q_ALLA).AND.ALLOCATED(ss2%q_ALLA)) THEN
        CALL ps_diff("q_ALLA",ss1%q_ALLA,ss2%q_ALLA,ps_error,iout,ierr)
        CALL ps_conformal("q_ALLA",ss1%q_ALLA,ss3%q_ALLA,iout,ierr)
        if(ierr.eq.0) ss3%q_ALLA = ss1%q_ALLA
     ELSE IF(ALLOCATED(ss1%q_ALLA)) THEN
        CALL ps_conformal("q_ALLA",ss1%q_ALLA,ss3%q_ALLA,iout,ierr)
        ss3%q_ALLA = ss1%q_ALLA
     ELSE IF(ALLOCATED(ss2%q_ALLA)) THEN
        CALL ps_conformal("q_ALLA",ss2%q_ALLA,ss3%q_ALLA,iout,ierr)
        ss3%q_ALLA = ss2%q_ALLA
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%q_eq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%q_eq).AND.ALLOCATED(ss2%q_eq)) THEN
        CALL ps_conformal("q_eq",ss2%q_eq,ss3%q_eq,iout,ierr)
        CALL ps_conformal("q_eq",ss1%q_eq,ss3%q_eq,iout,ierr)
        if(ierr.eq.0) ss3%q_eq = w1*ss1%q_eq + (1.0_rspec-w1)*ss2%q_eq
     ELSE IF(ALLOCATED(ss1%q_eq)) THEN
        CALL ps_conformal("q_eq",ss1%q_eq,ss3%q_eq,iout,ierr)
        ss3%q_eq = ss1%q_eq
     ELSE IF(ALLOCATED(ss2%q_eq)) THEN
        CALL ps_conformal("q_eq",ss2%q_eq,ss3%q_eq,iout,ierr)
        ss3%q_eq = ss2%q_eq
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_RFMIN)) THEN
     IF(ALLOCATED(ss1%q_RFMIN).AND.ALLOCATED(ss2%q_RFMIN)) THEN
        CALL ps_diff("q_RFMIN",ss1%q_RFMIN,ss2%q_RFMIN,ps_error,iout,ierr)
        CALL ps_conformal("q_RFMIN",ss1%q_RFMIN,ss3%q_RFMIN,iout,ierr)
        if(ierr.eq.0) ss3%q_RFMIN = ss1%q_RFMIN
     ELSE IF(ALLOCATED(ss1%q_RFMIN)) THEN
        CALL ps_conformal("q_RFMIN",ss1%q_RFMIN,ss3%q_RFMIN,iout,ierr)
        ss3%q_RFMIN = ss1%q_RFMIN
     ELSE IF(ALLOCATED(ss2%q_RFMIN)) THEN
        CALL ps_conformal("q_RFMIN",ss2%q_RFMIN,ss3%q_RFMIN,iout,ierr)
        ss3%q_RFMIN = ss2%q_RFMIN
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_S)) THEN
     IF(ALLOCATED(ss1%q_S).AND.ALLOCATED(ss2%q_S)) THEN
        CALL ps_diff("q_S",ss1%q_S,ss2%q_S,ps_error,iout,ierr)
        CALL ps_conformal("q_S",ss1%q_S,ss3%q_S,iout,ierr)
        if(ierr.eq.0) ss3%q_S = ss1%q_S
     ELSE IF(ALLOCATED(ss1%q_S)) THEN
        CALL ps_conformal("q_S",ss1%q_S,ss3%q_S,iout,ierr)
        ss3%q_S = ss1%q_S
     ELSE IF(ALLOCATED(ss2%q_S)) THEN
        CALL ps_conformal("q_S",ss2%q_S,ss3%q_S,iout,ierr)
        ss3%q_S = ss2%q_S
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SA)) THEN
     IF(ALLOCATED(ss1%q_SA).AND.ALLOCATED(ss2%q_SA)) THEN
        CALL ps_diff("q_SA",ss1%q_SA,ss2%q_SA,ps_error,iout,ierr)
        CALL ps_conformal("q_SA",ss1%q_SA,ss3%q_SA,iout,ierr)
        if(ierr.eq.0) ss3%q_SA = ss1%q_SA
     ELSE IF(ALLOCATED(ss1%q_SA)) THEN
        CALL ps_conformal("q_SA",ss1%q_SA,ss3%q_SA,iout,ierr)
        ss3%q_SA = ss1%q_SA
     ELSE IF(ALLOCATED(ss2%q_SA)) THEN
        CALL ps_conformal("q_SA",ss2%q_SA,ss3%q_SA,iout,ierr)
        ss3%q_SA = ss2%q_SA
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SFUS)) THEN
     IF(ALLOCATED(ss1%q_SFUS).AND.ALLOCATED(ss2%q_SFUS)) THEN
        CALL ps_diff("q_SFUS",ss1%q_SFUS,ss2%q_SFUS,ps_error,iout,ierr)
        CALL ps_conformal("q_SFUS",ss1%q_SFUS,ss3%q_SFUS,iout,ierr)
        if(ierr.eq.0) ss3%q_SFUS = ss1%q_SFUS
     ELSE IF(ALLOCATED(ss1%q_SFUS)) THEN
        CALL ps_conformal("q_SFUS",ss1%q_SFUS,ss3%q_SFUS,iout,ierr)
        ss3%q_SFUS = ss1%q_SFUS
     ELSE IF(ALLOCATED(ss2%q_SFUS)) THEN
        CALL ps_conformal("q_SFUS",ss2%q_SFUS,ss3%q_SFUS,iout,ierr)
        ss3%q_SFUS = ss2%q_SFUS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SGAS)) THEN
     IF(ALLOCATED(ss1%q_SGAS).AND.ALLOCATED(ss2%q_SGAS)) THEN
        CALL ps_diff("q_SGAS",ss1%q_SGAS,ss2%q_SGAS,ps_error,iout,ierr)
        CALL ps_conformal("q_SGAS",ss1%q_SGAS,ss3%q_SGAS,iout,ierr)
        if(ierr.eq.0) ss3%q_SGAS = ss1%q_SGAS
     ELSE IF(ALLOCATED(ss1%q_SGAS)) THEN
        CALL ps_conformal("q_SGAS",ss1%q_SGAS,ss3%q_SGAS,iout,ierr)
        ss3%q_SGAS = ss1%q_SGAS
     ELSE IF(ALLOCATED(ss2%q_SGAS)) THEN
        CALL ps_conformal("q_SGAS",ss2%q_SGAS,ss3%q_SGAS,iout,ierr)
        ss3%q_SGAS = ss2%q_SGAS
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SIMP0)) THEN
     IF(ALLOCATED(ss1%q_SIMP0).AND.ALLOCATED(ss2%q_SIMP0)) THEN
        CALL ps_diff("q_SIMP0",ss1%q_SIMP0,ss2%q_SIMP0,ps_error,iout,ierr)
        CALL ps_conformal("q_SIMP0",ss1%q_SIMP0,ss3%q_SIMP0,iout,ierr)
        if(ierr.eq.0) ss3%q_SIMP0 = ss1%q_SIMP0
     ELSE IF(ALLOCATED(ss1%q_SIMP0)) THEN
        CALL ps_conformal("q_SIMP0",ss1%q_SIMP0,ss3%q_SIMP0,iout,ierr)
        ss3%q_SIMP0 = ss1%q_SIMP0
     ELSE IF(ALLOCATED(ss2%q_SIMP0)) THEN
        CALL ps_conformal("q_SIMP0",ss2%q_SIMP0,ss3%q_SIMP0,iout,ierr)
        ss3%q_SIMP0 = ss2%q_SIMP0
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SIMPI)) THEN
     IF(ALLOCATED(ss1%q_SIMPI).AND.ALLOCATED(ss2%q_SIMPI)) THEN
        CALL ps_diff("q_SIMPI",ss1%q_SIMPI,ss2%q_SIMPI,ps_error,iout,ierr)
        CALL ps_conformal("q_SIMPI",ss1%q_SIMPI,ss3%q_SIMPI,iout,ierr)
        if(ierr.eq.0) ss3%q_SIMPI = ss1%q_SIMPI
     ELSE IF(ALLOCATED(ss1%q_SIMPI)) THEN
        CALL ps_conformal("q_SIMPI",ss1%q_SIMPI,ss3%q_SIMPI,iout,ierr)
        ss3%q_SIMPI = ss1%q_SIMPI
     ELSE IF(ALLOCATED(ss2%q_SIMPI)) THEN
        CALL ps_conformal("q_SIMPI",ss2%q_SIMPI,ss3%q_SIMPI,iout,ierr)
        ss3%q_SIMPI = ss2%q_SIMPI
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%q_SNBI)) THEN
     IF(ALLOCATED(ss1%q_SNBI).AND.ALLOCATED(ss2%q_SNBI)) THEN
        CALL ps_diff("q_SNBI",ss1%q_SNBI,ss2%q_SNBI,ps_error,iout,ierr)
        CALL ps_conformal("q_SNBI",ss1%q_SNBI,ss3%q_SNBI,iout,ierr)
        if(ierr.eq.0) ss3%q_SNBI = ss1%q_SNBI
     ELSE IF(ALLOCATED(ss1%q_SNBI)) THEN
        CALL ps_conformal("q_SNBI",ss1%q_SNBI,ss3%q_SNBI,iout,ierr)
        ss3%q_SNBI = ss1%q_SNBI
     ELSE IF(ALLOCATED(ss2%q_SNBI)) THEN
        CALL ps_conformal("q_SNBI",ss2%q_SNBI,ss3%q_SNBI,iout,ierr)
        ss3%q_SNBI = ss2%q_SNBI
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%R0_momeq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%R0_momeq).AND.ALLOCATED(ss2%R0_momeq)) THEN
        CALL ps_conformal("R0_momeq",ss2%R0_momeq,ss3%R0_momeq,iout,ierr)
        CALL ps_conformal("R0_momeq",ss1%R0_momeq,ss3%R0_momeq,iout,ierr)
        if(ierr.eq.0) ss3%R0_momeq = w1*ss1%R0_momeq + (1.0_rspec-w1)*ss2%R0_momeq
     ELSE IF(ALLOCATED(ss1%R0_momeq)) THEN
        CALL ps_conformal("R0_momeq",ss1%R0_momeq,ss3%R0_momeq,iout,ierr)
        ss3%R0_momeq = ss1%R0_momeq
     ELSE IF(ALLOCATED(ss2%R0_momeq)) THEN
        CALL ps_conformal("R0_momeq",ss2%R0_momeq,ss3%R0_momeq,iout,ierr)
        ss3%R0_momeq = ss2%R0_momeq
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_RAD).EQ.1) THEN

     CALL ps_diff("RAD_Code_Info",ss1%RAD_Code_Info,ss2%RAD_Code_Info,icheck,iout,ierr)
     ss3%RAD_Code_Info = ss1%RAD_Code_Info
  ENDIF

  IF(cclist(ps_cnum_RAD).EQ.1) THEN

     CALL ps_diff("RAD_Data_Info",ss1%RAD_Data_Info,ss2%RAD_Data_Info,icheck,iout,ierr)
     ss3%RAD_Data_Info = ss1%RAD_Data_Info
  ENDIF

  IF((ALLOCATED(ss3%rate_sinb0i)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinb0i).AND.ALLOCATED(ss2%rate_sinb0i)) THEN
        CALL ps_conformal("rate_sinb0i",ss2%rate_sinb0i,ss3%rate_sinb0i,iout,ierr)
        CALL ps_conformal("rate_sinb0i",ss1%rate_sinb0i,ss3%rate_sinb0i,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinb0i = w1*ss1%rate_sinb0i + (1.0_rspec-w1)*ss2%rate_sinb0i
     ELSE IF(ALLOCATED(ss1%rate_sinb0i)) THEN
        CALL ps_conformal("rate_sinb0i",ss1%rate_sinb0i,ss3%rate_sinb0i,iout,ierr)
        ss3%rate_sinb0i = ss1%rate_sinb0i
     ELSE IF(ALLOCATED(ss2%rate_sinb0i)) THEN
        CALL ps_conformal("rate_sinb0i",ss2%rate_sinb0i,ss3%rate_sinb0i,iout,ierr)
        ss3%rate_sinb0i = ss2%rate_sinb0i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rate_sinb0x)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinb0x).AND.ALLOCATED(ss2%rate_sinb0x)) THEN
        CALL ps_conformal("rate_sinb0x",ss2%rate_sinb0x,ss3%rate_sinb0x,iout,ierr)
        CALL ps_conformal("rate_sinb0x",ss1%rate_sinb0x,ss3%rate_sinb0x,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinb0x = w1*ss1%rate_sinb0x + (1.0_rspec-w1)*ss2%rate_sinb0x
     ELSE IF(ALLOCATED(ss1%rate_sinb0x)) THEN
        CALL ps_conformal("rate_sinb0x",ss1%rate_sinb0x,ss3%rate_sinb0x,iout,ierr)
        ss3%rate_sinb0x = ss1%rate_sinb0x
     ELSE IF(ALLOCATED(ss2%rate_sinb0x)) THEN
        CALL ps_conformal("rate_sinb0x",ss2%rate_sinb0x,ss3%rate_sinb0x,iout,ierr)
        ss3%rate_sinb0x = ss2%rate_sinb0x
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rate_sinb0xs)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinb0xs).AND.ALLOCATED(ss2%rate_sinb0xs)) THEN
        CALL ps_conformal("rate_sinb0xs",ss2%rate_sinb0xs,ss3%rate_sinb0xs,iout,ierr)
        CALL ps_conformal("rate_sinb0xs",ss1%rate_sinb0xs,ss3%rate_sinb0xs,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinb0xs = w1*ss1%rate_sinb0xs + (1.0_rspec-w1)*ss2%rate_sinb0xs
     ELSE IF(ALLOCATED(ss1%rate_sinb0xs)) THEN
        CALL ps_conformal("rate_sinb0xs",ss1%rate_sinb0xs,ss3%rate_sinb0xs,iout,ierr)
        ss3%rate_sinb0xs = ss1%rate_sinb0xs
     ELSE IF(ALLOCATED(ss2%rate_sinb0xs)) THEN
        CALL ps_conformal("rate_sinb0xs",ss2%rate_sinb0xs,ss3%rate_sinb0xs,iout,ierr)
        ss3%rate_sinb0xs = ss2%rate_sinb0xs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rate_sinf0i)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinf0i).AND.ALLOCATED(ss2%rate_sinf0i)) THEN
        CALL ps_conformal("rate_sinf0i",ss2%rate_sinf0i,ss3%rate_sinf0i,iout,ierr)
        CALL ps_conformal("rate_sinf0i",ss1%rate_sinf0i,ss3%rate_sinf0i,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinf0i = w1*ss1%rate_sinf0i + (1.0_rspec-w1)*ss2%rate_sinf0i
     ELSE IF(ALLOCATED(ss1%rate_sinf0i)) THEN
        CALL ps_conformal("rate_sinf0i",ss1%rate_sinf0i,ss3%rate_sinf0i,iout,ierr)
        ss3%rate_sinf0i = ss1%rate_sinf0i
     ELSE IF(ALLOCATED(ss2%rate_sinf0i)) THEN
        CALL ps_conformal("rate_sinf0i",ss2%rate_sinf0i,ss3%rate_sinf0i,iout,ierr)
        ss3%rate_sinf0i = ss2%rate_sinf0i
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rate_sinf0x)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinf0x).AND.ALLOCATED(ss2%rate_sinf0x)) THEN
        CALL ps_conformal("rate_sinf0x",ss2%rate_sinf0x,ss3%rate_sinf0x,iout,ierr)
        CALL ps_conformal("rate_sinf0x",ss1%rate_sinf0x,ss3%rate_sinf0x,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinf0x = w1*ss1%rate_sinf0x + (1.0_rspec-w1)*ss2%rate_sinf0x
     ELSE IF(ALLOCATED(ss1%rate_sinf0x)) THEN
        CALL ps_conformal("rate_sinf0x",ss1%rate_sinf0x,ss3%rate_sinf0x,iout,ierr)
        ss3%rate_sinf0x = ss1%rate_sinf0x
     ELSE IF(ALLOCATED(ss2%rate_sinf0x)) THEN
        CALL ps_conformal("rate_sinf0x",ss2%rate_sinf0x,ss3%rate_sinf0x,iout,ierr)
        ss3%rate_sinf0x = ss2%rate_sinf0x
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rate_sinf0xs)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%rate_sinf0xs).AND.ALLOCATED(ss2%rate_sinf0xs)) THEN
        CALL ps_conformal("rate_sinf0xs",ss2%rate_sinf0xs,ss3%rate_sinf0xs,iout,ierr)
        CALL ps_conformal("rate_sinf0xs",ss1%rate_sinf0xs,ss3%rate_sinf0xs,iout,ierr)
        if(ierr.eq.0) ss3%rate_sinf0xs = w1*ss1%rate_sinf0xs + (1.0_rspec-w1)*ss2%rate_sinf0xs
     ELSE IF(ALLOCATED(ss1%rate_sinf0xs)) THEN
        CALL ps_conformal("rate_sinf0xs",ss1%rate_sinf0xs,ss3%rate_sinf0xs,iout,ierr)
        ss3%rate_sinf0xs = ss1%rate_sinf0xs
     ELSE IF(ALLOCATED(ss2%rate_sinf0xs)) THEN
        CALL ps_conformal("rate_sinf0xs",ss2%rate_sinf0xs,ss3%rate_sinf0xs,iout,ierr)
        ss3%rate_sinf0xs = ss2%rate_sinf0xs
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%Real_ant_coef)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%Real_ant_coef).AND.ALLOCATED(ss2%Real_ant_coef)) THEN
        CALL ps_diff("Real_ant_coef",ss1%Real_ant_coef,ss2%Real_ant_coef,icheck,iout,ierr)
        CALL ps_conformal("Real_ant_coef",ss1%Real_ant_coef,ss3%Real_ant_coef,iout,ierr)
        if(ierr.eq.0) ss3%Real_ant_coef = ss1%Real_ant_coef
     ELSE IF(ALLOCATED(ss1%Real_ant_coef)) THEN
        CALL ps_conformal("Real_ant_coef",ss1%Real_ant_coef,ss3%Real_ant_coef,iout,ierr)
        ss3%Real_ant_coef = ss1%Real_ant_coef
     ELSE IF(ALLOCATED(ss2%Real_ant_coef)) THEN
        CALL ps_conformal("Real_ant_coef",ss2%Real_ant_coef,ss3%Real_ant_coef,iout,ierr)
        ss3%Real_ant_coef = ss2%Real_ant_coef
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%res_sn)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%res_sn).AND.ALLOCATED(ss2%res_sn)) THEN
        CALL ps_conformal("res_sn",ss2%res_sn,ss3%res_sn,iout,ierr)
        CALL ps_conformal("res_sn",ss1%res_sn,ss3%res_sn,iout,ierr)
        if(ierr.eq.0) ss3%res_sn = w1*ss1%res_sn + (1.0_rspec-w1)*ss2%res_sn
     ELSE IF(ALLOCATED(ss1%res_sn)) THEN
        CALL ps_conformal("res_sn",ss1%res_sn,ss3%res_sn,iout,ierr)
        ss3%res_sn = ss1%res_sn
     ELSE IF(ALLOCATED(ss2%res_sn)) THEN
        CALL ps_conformal("res_sn",ss2%res_sn,ss3%res_sn,iout,ierr)
        ss3%res_sn = ss2%res_sn
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%res_te)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%res_te).AND.ALLOCATED(ss2%res_te)) THEN
        CALL ps_conformal("res_te",ss2%res_te,ss3%res_te,iout,ierr)
        CALL ps_conformal("res_te",ss1%res_te,ss3%res_te,iout,ierr)
        if(ierr.eq.0) ss3%res_te = w1*ss1%res_te + (1.0_rspec-w1)*ss2%res_te
     ELSE IF(ALLOCATED(ss1%res_te)) THEN
        CALL ps_conformal("res_te",ss1%res_te,ss3%res_te,iout,ierr)
        ss3%res_te = ss1%res_te
     ELSE IF(ALLOCATED(ss2%res_te)) THEN
        CALL ps_conformal("res_te",ss2%res_te,ss3%res_te,iout,ierr)
        ss3%res_te = ss2%res_te
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%res_ti)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%res_ti).AND.ALLOCATED(ss2%res_ti)) THEN
        CALL ps_conformal("res_ti",ss2%res_ti,ss3%res_ti,iout,ierr)
        CALL ps_conformal("res_ti",ss1%res_ti,ss3%res_ti,iout,ierr)
        if(ierr.eq.0) ss3%res_ti = w1*ss1%res_ti + (1.0_rspec-w1)*ss2%res_ti
     ELSE IF(ALLOCATED(ss1%res_ti)) THEN
        CALL ps_conformal("res_ti",ss1%res_ti,ss3%res_ti,iout,ierr)
        ss3%res_ti = ss1%res_ti
     ELSE IF(ALLOCATED(ss2%res_ti)) THEN
        CALL ps_conformal("res_ti",ss2%res_ti,ss3%res_ti,iout,ierr)
        ss3%res_ti = ss2%res_ti
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%res_tq)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%res_tq).AND.ALLOCATED(ss2%res_tq)) THEN
        CALL ps_conformal("res_tq",ss2%res_tq,ss3%res_tq,iout,ierr)
        CALL ps_conformal("res_tq",ss1%res_tq,ss3%res_tq,iout,ierr)
        if(ierr.eq.0) ss3%res_tq = w1*ss1%res_tq + (1.0_rspec-w1)*ss2%res_tq
     ELSE IF(ALLOCATED(ss1%res_tq)) THEN
        CALL ps_conformal("res_tq",ss1%res_tq,ss3%res_tq,iout,ierr)
        ss3%res_tq = ss1%res_tq
     ELSE IF(ALLOCATED(ss2%res_tq)) THEN
        CALL ps_conformal("res_tq",ss2%res_tq,ss3%res_tq,iout,ierr)
        ss3%res_tq = ss2%res_tq
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%RFMIN_name)) THEN
     IF(ALLOCATED(ss1%RFMIN_name).AND.ALLOCATED(ss2%RFMIN_name)) THEN
        CALL ps_diff("RFMIN_name",ss1%RFMIN_name,ss2%RFMIN_name,ps_error,iout,ierr)
        CALL ps_conformal("RFMIN_name",ss1%RFMIN_name,ss3%RFMIN_name,iout,ierr)
        if(ierr.eq.0) ss3%RFMIN_name = ss1%RFMIN_name
     ELSE IF(ALLOCATED(ss1%RFMIN_name)) THEN
        CALL ps_conformal("RFMIN_name",ss1%RFMIN_name,ss3%RFMIN_name,iout,ierr)
        ss3%RFMIN_name = ss1%RFMIN_name
     ELSE IF(ALLOCATED(ss2%RFMIN_name)) THEN
        CALL ps_conformal("RFMIN_name",ss2%RFMIN_name,ss3%RFMIN_name,iout,ierr)
        ss3%RFMIN_name = ss2%RFMIN_name
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%rfmin_to_all)) THEN
     IF(ALLOCATED(ss1%rfmin_to_all).AND.ALLOCATED(ss2%rfmin_to_all)) THEN
        CALL ps_diff("rfmin_to_all",ss1%rfmin_to_all,ss2%rfmin_to_all,ps_error,iout,ierr)
        CALL ps_conformal("rfmin_to_all",ss1%rfmin_to_all,ss3%rfmin_to_all,iout,ierr)
        if(ierr.eq.0) ss3%rfmin_to_all = ss1%rfmin_to_all
     ELSE IF(ALLOCATED(ss1%rfmin_to_all)) THEN
        CALL ps_conformal("rfmin_to_all",ss1%rfmin_to_all,ss3%rfmin_to_all,iout,ierr)
        ss3%rfmin_to_all = ss1%rfmin_to_all
     ELSE IF(ALLOCATED(ss2%rfmin_to_all)) THEN
        CALL ps_conformal("rfmin_to_all",ss2%rfmin_to_all,ss3%rfmin_to_all,iout,ierr)
        ss3%rfmin_to_all = ss2%rfmin_to_all
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%rfmin_to_alla)) THEN
     IF(ALLOCATED(ss1%rfmin_to_alla).AND.ALLOCATED(ss2%rfmin_to_alla)) THEN
        CALL ps_diff("rfmin_to_alla",ss1%rfmin_to_alla,ss2%rfmin_to_alla,ps_error,iout,ierr)
        CALL ps_conformal("rfmin_to_alla",ss1%rfmin_to_alla,ss3%rfmin_to_alla,iout,ierr)
        if(ierr.eq.0) ss3%rfmin_to_alla = ss1%rfmin_to_alla
     ELSE IF(ALLOCATED(ss1%rfmin_to_alla)) THEN
        CALL ps_conformal("rfmin_to_alla",ss1%rfmin_to_alla,ss3%rfmin_to_alla,iout,ierr)
        ss3%rfmin_to_alla = ss1%rfmin_to_alla
     ELSE IF(ALLOCATED(ss2%rfmin_to_alla)) THEN
        CALL ps_conformal("rfmin_to_alla",ss2%rfmin_to_alla,ss3%rfmin_to_alla,iout,ierr)
        ss3%rfmin_to_alla = ss2%rfmin_to_alla
     ENDIF
  ENDIF

  IF(ALLOCATED(ss3%RFMIN_type)) THEN
     IF(ALLOCATED(ss1%RFMIN_type).AND.ALLOCATED(ss2%RFMIN_type)) THEN
        CALL ps_diff("RFMIN_type",ss1%RFMIN_type,ss2%RFMIN_type,ps_error,iout,ierr)
        CALL ps_conformal("RFMIN_type",ss1%RFMIN_type,ss3%RFMIN_type,iout,ierr)
        if(ierr.eq.0) ss3%RFMIN_type = ss1%RFMIN_type
     ELSE IF(ALLOCATED(ss1%RFMIN_type)) THEN
        CALL ps_conformal("RFMIN_type",ss1%RFMIN_type,ss3%RFMIN_type,iout,ierr)
        ss3%RFMIN_type = ss1%RFMIN_type
     ELSE IF(ALLOCATED(ss2%RFMIN_type)) THEN
        CALL ps_conformal("RFMIN_type",ss2%RFMIN_type,ss3%RFMIN_type,iout,ierr)
        ss3%RFMIN_type = ss2%RFMIN_type
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho).AND.ALLOCATED(ss2%rho)) THEN
        CALL ps_diff("rho",ss1%rho,ss2%rho,ps_error,iout,ierr)
        CALL ps_conformal("rho",ss1%rho,ss3%rho,iout,ierr)
        if(ierr.eq.0) ss3%rho = ss1%rho
     ELSE IF(ALLOCATED(ss1%rho)) THEN
        CALL ps_conformal("rho",ss1%rho,ss3%rho,iout,ierr)
        ss3%rho = ss1%rho
     ELSE IF(ALLOCATED(ss2%rho)) THEN
        CALL ps_conformal("rho",ss2%rho,ss3%rho,iout,ierr)
        ss3%rho = ss2%rho
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rhopsi0lh)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%rhopsi0lh).AND.ALLOCATED(ss2%rhopsi0lh)) THEN
        CALL ps_diff("rhopsi0lh",ss1%rhopsi0lh,ss2%rhopsi0lh,icheck,iout,ierr)
        CALL ps_conformal("rhopsi0lh",ss1%rhopsi0lh,ss3%rhopsi0lh,iout,ierr)
        if(ierr.eq.0) ss3%rhopsi0lh = ss1%rhopsi0lh
     ELSE IF(ALLOCATED(ss1%rhopsi0lh)) THEN
        CALL ps_conformal("rhopsi0lh",ss1%rhopsi0lh,ss3%rhopsi0lh,iout,ierr)
        ss3%rhopsi0lh = ss1%rhopsi0lh
     ELSE IF(ALLOCATED(ss2%rhopsi0lh)) THEN
        CALL ps_conformal("rhopsi0lh",ss2%rhopsi0lh,ss3%rhopsi0lh,iout,ierr)
        ss3%rhopsi0lh = ss2%rhopsi0lh
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_anom)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_anom).AND.ALLOCATED(ss2%rho_anom)) THEN
        CALL ps_diff("rho_anom",ss1%rho_anom,ss2%rho_anom,ps_error,iout,ierr)
        CALL ps_conformal("rho_anom",ss1%rho_anom,ss3%rho_anom,iout,ierr)
        if(ierr.eq.0) ss3%rho_anom = ss1%rho_anom
     ELSE IF(ALLOCATED(ss1%rho_anom)) THEN
        CALL ps_conformal("rho_anom",ss1%rho_anom,ss3%rho_anom,iout,ierr)
        ss3%rho_anom = ss1%rho_anom
     ELSE IF(ALLOCATED(ss2%rho_anom)) THEN
        CALL ps_conformal("rho_anom",ss2%rho_anom,ss3%rho_anom,iout,ierr)
        ss3%rho_anom = ss2%rho_anom
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_anom2)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_anom2).AND.ALLOCATED(ss2%rho_anom2)) THEN
        CALL ps_diff("rho_anom2",ss1%rho_anom2,ss2%rho_anom2,ps_error,iout,ierr)
        CALL ps_conformal("rho_anom2",ss1%rho_anom2,ss3%rho_anom2,iout,ierr)
        if(ierr.eq.0) ss3%rho_anom2 = ss1%rho_anom2
     ELSE IF(ALLOCATED(ss1%rho_anom2)) THEN
        CALL ps_conformal("rho_anom2",ss1%rho_anom2,ss3%rho_anom2,iout,ierr)
        ss3%rho_anom2 = ss1%rho_anom2
     ELSE IF(ALLOCATED(ss2%rho_anom2)) THEN
        CALL ps_conformal("rho_anom2",ss2%rho_anom2,ss3%rho_anom2,iout,ierr)
        ss3%rho_anom2 = ss2%rho_anom2
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_anomth)).AND.(cclist(ps_cnum_ANOM).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_anomth).AND.ALLOCATED(ss2%rho_anomth)) THEN
        CALL ps_diff("rho_anomth",ss1%rho_anomth,ss2%rho_anomth,ps_error,iout,ierr)
        CALL ps_conformal("rho_anomth",ss1%rho_anomth,ss3%rho_anomth,iout,ierr)
        if(ierr.eq.0) ss3%rho_anomth = ss1%rho_anomth
     ELSE IF(ALLOCATED(ss1%rho_anomth)) THEN
        CALL ps_conformal("rho_anomth",ss1%rho_anomth,ss3%rho_anomth,iout,ierr)
        ss3%rho_anomth = ss1%rho_anomth
     ELSE IF(ALLOCATED(ss2%rho_anomth)) THEN
        CALL ps_conformal("rho_anomth",ss2%rho_anomth,ss3%rho_anomth,iout,ierr)
        ss3%rho_anomth = ss2%rho_anomth
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_bdy_ns)).AND.(cclist(ps_cnum_PLASMA).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_bdy_ns).AND.ALLOCATED(ss2%rho_bdy_ns)) THEN
        CALL ps_conformal("rho_bdy_ns",ss2%rho_bdy_ns,ss3%rho_bdy_ns,iout,ierr)
        CALL ps_conformal("rho_bdy_ns",ss1%rho_bdy_ns,ss3%rho_bdy_ns,iout,ierr)
        if(ierr.eq.0) ss3%rho_bdy_ns = w1*ss1%rho_bdy_ns + (1.0_rspec-w1)*ss2%rho_bdy_ns
     ELSE IF(ALLOCATED(ss1%rho_bdy_ns)) THEN
        CALL ps_conformal("rho_bdy_ns",ss1%rho_bdy_ns,ss3%rho_bdy_ns,iout,ierr)
        ss3%rho_bdy_ns = ss1%rho_bdy_ns
     ELSE IF(ALLOCATED(ss2%rho_bdy_ns)) THEN
        CALL ps_conformal("rho_bdy_ns",ss2%rho_bdy_ns,ss3%rho_bdy_ns,iout,ierr)
        ss3%rho_bdy_ns = ss2%rho_bdy_ns
     ENDIF
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%rho_bdy_omegat = w1*ss1%rho_bdy_omegat + (1.0_rspec-w1)*ss2%rho_bdy_omegat
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%rho_bdy_Te = w1*ss1%rho_bdy_Te + (1.0_rspec-w1)*ss2%rho_bdy_Te
  ENDIF

  IF(cclist(ps_cnum_PLASMA).EQ.1) THEN
     ss3%rho_bdy_Ti = w1*ss1%rho_bdy_Ti + (1.0_rspec-w1)*ss2%rho_bdy_Ti
  ENDIF

  IF((ALLOCATED(ss3%rho_ecrf)).AND.(cclist(ps_cnum_EC).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_ecrf).AND.ALLOCATED(ss2%rho_ecrf)) THEN
        CALL ps_diff("rho_ecrf",ss1%rho_ecrf,ss2%rho_ecrf,ps_error,iout,ierr)
        CALL ps_conformal("rho_ecrf",ss1%rho_ecrf,ss3%rho_ecrf,iout,ierr)
        if(ierr.eq.0) ss3%rho_ecrf = ss1%rho_ecrf
     ELSE IF(ALLOCATED(ss1%rho_ecrf)) THEN
        CALL ps_conformal("rho_ecrf",ss1%rho_ecrf,ss3%rho_ecrf,iout,ierr)
        ss3%rho_ecrf = ss1%rho_ecrf
     ELSE IF(ALLOCATED(ss2%rho_ecrf)) THEN
        CALL ps_conformal("rho_ecrf",ss2%rho_ecrf,ss3%rho_ecrf,iout,ierr)
        ss3%rho_ecrf = ss2%rho_ecrf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_eq)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_eq).AND.ALLOCATED(ss2%rho_eq)) THEN
        CALL ps_diff("rho_eq",ss1%rho_eq,ss2%rho_eq,ps_error,iout,ierr)
        CALL ps_conformal("rho_eq",ss1%rho_eq,ss3%rho_eq,iout,ierr)
        if(ierr.eq.0) ss3%rho_eq = ss1%rho_eq
     ELSE IF(ALLOCATED(ss1%rho_eq)) THEN
        CALL ps_conformal("rho_eq",ss1%rho_eq,ss3%rho_eq,iout,ierr)
        ss3%rho_eq = ss1%rho_eq
     ELSE IF(ALLOCATED(ss2%rho_eq)) THEN
        CALL ps_conformal("rho_eq",ss2%rho_eq,ss3%rho_eq,iout,ierr)
        ss3%rho_eq = ss2%rho_eq
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_eq_geo)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_eq_geo).AND.ALLOCATED(ss2%rho_eq_geo)) THEN
        CALL ps_diff("rho_eq_geo",ss1%rho_eq_geo,ss2%rho_eq_geo,ps_error,iout,ierr)
        CALL ps_conformal("rho_eq_geo",ss1%rho_eq_geo,ss3%rho_eq_geo,iout,ierr)
        if(ierr.eq.0) ss3%rho_eq_geo = ss1%rho_eq_geo
     ELSE IF(ALLOCATED(ss1%rho_eq_geo)) THEN
        CALL ps_conformal("rho_eq_geo",ss1%rho_eq_geo,ss3%rho_eq_geo,iout,ierr)
        ss3%rho_eq_geo = ss1%rho_eq_geo
     ELSE IF(ALLOCATED(ss2%rho_eq_geo)) THEN
        CALL ps_conformal("rho_eq_geo",ss2%rho_eq_geo,ss3%rho_eq_geo,iout,ierr)
        ss3%rho_eq_geo = ss2%rho_eq_geo
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_fus)).AND.(cclist(ps_cnum_FUS).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_fus).AND.ALLOCATED(ss2%rho_fus)) THEN
        CALL ps_diff("rho_fus",ss1%rho_fus,ss2%rho_fus,ps_error,iout,ierr)
        CALL ps_conformal("rho_fus",ss1%rho_fus,ss3%rho_fus,iout,ierr)
        if(ierr.eq.0) ss3%rho_fus = ss1%rho_fus
     ELSE IF(ALLOCATED(ss1%rho_fus)) THEN
        CALL ps_conformal("rho_fus",ss1%rho_fus,ss3%rho_fus,iout,ierr)
        ss3%rho_fus = ss1%rho_fus
     ELSE IF(ALLOCATED(ss2%rho_fus)) THEN
        CALL ps_conformal("rho_fus",ss2%rho_fus,ss3%rho_fus,iout,ierr)
        ss3%rho_fus = ss2%rho_fus
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_gas)).AND.(cclist(ps_cnum_GAS).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_gas).AND.ALLOCATED(ss2%rho_gas)) THEN
        CALL ps_diff("rho_gas",ss1%rho_gas,ss2%rho_gas,ps_error,iout,ierr)
        CALL ps_conformal("rho_gas",ss1%rho_gas,ss3%rho_gas,iout,ierr)
        if(ierr.eq.0) ss3%rho_gas = ss1%rho_gas
     ELSE IF(ALLOCATED(ss1%rho_gas)) THEN
        CALL ps_conformal("rho_gas",ss1%rho_gas,ss3%rho_gas,iout,ierr)
        ss3%rho_gas = ss1%rho_gas
     ELSE IF(ALLOCATED(ss2%rho_gas)) THEN
        CALL ps_conformal("rho_gas",ss2%rho_gas,ss3%rho_gas,iout,ierr)
        ss3%rho_gas = ss2%rho_gas
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_icrf)).AND.(cclist(ps_cnum_IC).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_icrf).AND.ALLOCATED(ss2%rho_icrf)) THEN
        CALL ps_diff("rho_icrf",ss1%rho_icrf,ss2%rho_icrf,ps_error,iout,ierr)
        CALL ps_conformal("rho_icrf",ss1%rho_icrf,ss3%rho_icrf,iout,ierr)
        if(ierr.eq.0) ss3%rho_icrf = ss1%rho_icrf
     ELSE IF(ALLOCATED(ss1%rho_icrf)) THEN
        CALL ps_conformal("rho_icrf",ss1%rho_icrf,ss3%rho_icrf,iout,ierr)
        ss3%rho_icrf = ss1%rho_icrf
     ELSE IF(ALLOCATED(ss2%rho_icrf)) THEN
        CALL ps_conformal("rho_icrf",ss2%rho_icrf,ss3%rho_icrf,iout,ierr)
        ss3%rho_icrf = ss2%rho_icrf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_lhrf)).AND.(cclist(ps_cnum_LH).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_lhrf).AND.ALLOCATED(ss2%rho_lhrf)) THEN
        CALL ps_diff("rho_lhrf",ss1%rho_lhrf,ss2%rho_lhrf,ps_error,iout,ierr)
        CALL ps_conformal("rho_lhrf",ss1%rho_lhrf,ss3%rho_lhrf,iout,ierr)
        if(ierr.eq.0) ss3%rho_lhrf = ss1%rho_lhrf
     ELSE IF(ALLOCATED(ss1%rho_lhrf)) THEN
        CALL ps_conformal("rho_lhrf",ss1%rho_lhrf,ss3%rho_lhrf,iout,ierr)
        ss3%rho_lhrf = ss1%rho_lhrf
     ELSE IF(ALLOCATED(ss2%rho_lhrf)) THEN
        CALL ps_conformal("rho_lhrf",ss2%rho_lhrf,ss3%rho_lhrf,iout,ierr)
        ss3%rho_lhrf = ss2%rho_lhrf
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_lmhd)).AND.(cclist(ps_cnum_LMHD).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_lmhd).AND.ALLOCATED(ss2%rho_lmhd)) THEN
        CALL ps_diff("rho_lmhd",ss1%rho_lmhd,ss2%rho_lmhd,ps_error,iout,ierr)
        CALL ps_conformal("rho_lmhd",ss1%rho_lmhd,ss3%rho_lmhd,iout,ierr)
        if(ierr.eq.0) ss3%rho_lmhd = ss1%rho_lmhd
     ELSE IF(ALLOCATED(ss1%rho_lmhd)) THEN
        CALL ps_conformal("rho_lmhd",ss1%rho_lmhd,ss3%rho_lmhd,iout,ierr)
        ss3%rho_lmhd = ss1%rho_lmhd
     ELSE IF(ALLOCATED(ss2%rho_lmhd)) THEN
        CALL ps_conformal("rho_lmhd",ss2%rho_lmhd,ss3%rho_lmhd,iout,ierr)
        ss3%rho_lmhd = ss2%rho_lmhd
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_mist)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_mist).AND.ALLOCATED(ss2%rho_mist)) THEN
        CALL ps_diff("rho_mist",ss1%rho_mist,ss2%rho_mist,ps_error,iout,ierr)
        CALL ps_conformal("rho_mist",ss1%rho_mist,ss3%rho_mist,iout,ierr)
        if(ierr.eq.0) ss3%rho_mist = ss1%rho_mist
     ELSE IF(ALLOCATED(ss1%rho_mist)) THEN
        CALL ps_conformal("rho_mist",ss1%rho_mist,ss3%rho_mist,iout,ierr)
        ss3%rho_mist = ss1%rho_mist
     ELSE IF(ALLOCATED(ss2%rho_mist)) THEN
        CALL ps_conformal("rho_mist",ss2%rho_mist,ss3%rho_mist,iout,ierr)
        ss3%rho_mist = ss2%rho_mist
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_nbi)).AND.(cclist(ps_cnum_NBI).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_nbi).AND.ALLOCATED(ss2%rho_nbi)) THEN
        CALL ps_diff("rho_nbi",ss1%rho_nbi,ss2%rho_nbi,ps_error,iout,ierr)
        CALL ps_conformal("rho_nbi",ss1%rho_nbi,ss3%rho_nbi,iout,ierr)
        if(ierr.eq.0) ss3%rho_nbi = ss1%rho_nbi
     ELSE IF(ALLOCATED(ss1%rho_nbi)) THEN
        CALL ps_conformal("rho_nbi",ss1%rho_nbi,ss3%rho_nbi,iout,ierr)
        ss3%rho_nbi = ss1%rho_nbi
     ELSE IF(ALLOCATED(ss2%rho_nbi)) THEN
        CALL ps_conformal("rho_nbi",ss2%rho_nbi,ss3%rho_nbi,iout,ierr)
        ss3%rho_nbi = ss2%rho_nbi
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_pel)).AND.(cclist(ps_cnum_PEL).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_pel).AND.ALLOCATED(ss2%rho_pel)) THEN
        CALL ps_diff("rho_pel",ss1%rho_pel,ss2%rho_pel,ps_error,iout,ierr)
        CALL ps_conformal("rho_pel",ss1%rho_pel,ss3%rho_pel,iout,ierr)
        if(ierr.eq.0) ss3%rho_pel = ss1%rho_pel
     ELSE IF(ALLOCATED(ss1%rho_pel)) THEN
        CALL ps_conformal("rho_pel",ss1%rho_pel,ss3%rho_pel,iout,ierr)
        ss3%rho_pel = ss1%rho_pel
     ELSE IF(ALLOCATED(ss2%rho_pel)) THEN
        CALL ps_conformal("rho_pel",ss2%rho_pel,ss3%rho_pel,iout,ierr)
        ss3%rho_pel = ss2%rho_pel
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_rad)).AND.(cclist(ps_cnum_RAD).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_rad).AND.ALLOCATED(ss2%rho_rad)) THEN
        CALL ps_diff("rho_rad",ss1%rho_rad,ss2%rho_rad,ps_error,iout,ierr)
        CALL ps_conformal("rho_rad",ss1%rho_rad,ss3%rho_rad,iout,ierr)
        if(ierr.eq.0) ss3%rho_rad = ss1%rho_rad
     ELSE IF(ALLOCATED(ss1%rho_rad)) THEN
        CALL ps_conformal("rho_rad",ss1%rho_rad,ss3%rho_rad,iout,ierr)
        ss3%rho_rad = ss1%rho_rad
     ELSE IF(ALLOCATED(ss2%rho_rad)) THEN
        CALL ps_conformal("rho_rad",ss2%rho_rad,ss3%rho_rad,iout,ierr)
        ss3%rho_rad = ss2%rho_rad
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rho_rw)).AND.(cclist(ps_cnum_RUNAWAY).EQ.1)) THEN
     IF(ALLOCATED(ss1%rho_rw).AND.ALLOCATED(ss2%rho_rw)) THEN
        CALL ps_diff("rho_rw",ss1%rho_rw,ss2%rho_rw,ps_error,iout,ierr)
        CALL ps_conformal("rho_rw",ss1%rho_rw,ss3%rho_rw,iout,ierr)
        if(ierr.eq.0) ss3%rho_rw = ss1%rho_rw
     ELSE IF(ALLOCATED(ss1%rho_rw)) THEN
        CALL ps_conformal("rho_rw",ss1%rho_rw,ss3%rho_rw,iout,ierr)
        ss3%rho_rw = ss1%rho_rw
     ELSE IF(ALLOCATED(ss2%rho_rw)) THEN
        CALL ps_conformal("rho_rw",ss2%rho_rw,ss3%rho_rw,iout,ierr)
        ss3%rho_rw = ss2%rho_rw
     ENDIF
  ENDIF

  IF((ALLOCATED(ss3%rlim)).AND.(cclist(ps_cnum_EQ).EQ.1)) THEN
     IF(ALLOCATED(ss1%rlim).AND.ALLOCATED(ss2%rlim)) THEN
        CALL ps_diff("rlim",ss1%rlim,ss2%rlim,icheck,iout,ierr)
        CALL ps_conformal("rlim",ss1%rlim,ss3%rlim,iout,ierr)
        if(ierr.eq.0) ss3%rlim = ss1%rlim
     ELSE IF(ALLOCATED(ss1%rlim)) THEN
        CALL ps_conformal("rlim",ss1%rlim,ss3%rlim,iout,ierr)
        ss3%rlim = ss1%rlim
     ELSE IF(ALLOCATED(ss2%rlim)) THEN
        CALL ps_conformal("rlim",ss2%rlim,ss3%rlim,iout,ierr)
        ss3%rlim = ss2%rlim
     ENDIF
  ENDIF

END SUBROUTINE plasma_state_merge_6

module echmod_typedef

  ! define datasets used by TRANSP-related tools, to communicate with
  ! ECH models

  integer, parameter :: imaxan_tor = 7 ! max no. of Gaussian anulli (TORAY)

  type :: toray_numeric

     ! GA-TORAY numerical and logical controls
     !  (names originally from TRANSP, trcom, freeshare/port.spec)

     INTEGER :: igafit = 1     ! Switch to call gafit efit interface
     REAL*8  :: smax = 0.0d0   ! max arclength of array
     REAL*8  :: ds = 0.5d0     ! initial step size (cm)
     REAL*8  :: dsmin = 0.25d0 ! min step size (cm)

     REAL*8  :: fdout = 5.00d0 ! ray output step (every fdouttor cm)
     REAL*8  :: powinc = 1.0d13  ! for CQL3D J/P profile
     REAL*8  :: relerr = 5.0d-5  ! rel. error tolerance, y solution 
     REAL*8  :: abserr = 5.0d-5  ! abs. error tolerance in ODE solver

     INTEGER :: nharm = 2      ! harmonic; freq = nharm*[fundamental freq].
     INTEGER :: mn0 = 32       ! number of mesh pts in Gaussian integration
     !                           ...of Green's function in J/P resonance calc.

     INTEGER :: gauszone = 4   ! no. of annulli for Gaussian ray pattern

     INTEGER :: mray(imaxan_tor)   ! no. of rays in each Gaussian annulus
     REAL*8 :: cr(imaxan_tor)      ! azimuthal phase in each Gaussian annulus

     INTEGER :: modelc = 4     ! ECCD model selector (Lin-Liu = 4)
     REAL*8 :: pwrfmin = 0.001d0   ! cutoff power fraction

     LOGICAL :: netcdfdat = .TRUE. ! T for NetCDF output
     LOGICAL :: cqldat = .FALSE.   ! T for CQL3D output

     REAL*8 :: ezeff = 2.0d0   ! Default Zeff (usually overridden by data)
     REAL*8 :: bsratio = 1.0d0 ! Default beam elongation (1=circle)

  end type toray_numeric

  type :: toray_gafit

     ! GA-TORAY information on Psi(R,Z) & equilibrium input

     INTEGER :: ipsi = 0          ! 0 for psiin; 1 for g-eqdsk
     REAL*8 :: gafsep = 1.0d-2 
     REAL*8 :: dsrat = 2.0d-1
     REAL*8 :: percenflux = 1.0d0 ! ...to separatrix
     REAL*8 :: tolmap = 1.0d-10
     LOGICAL :: newbdry = .FALSE.

  end type toray_gafit

CONTAINS

  subroutine toray_numeric_adflts(tn)

    ! set array defaults 
    !   (scalar defaults set in declarations)

    type (toray_numeric) :: tn

    tn%mray(1) = 1
    tn%mray(2) = 5
    tn%mray(3) = 12
    tn%mray(4) = 12
    tn%mray(5) = 20
    tn%mray(6) = 24
    tn%mray(7) = 26

    tn%cr(1) = 0.0d0
    tn%cr(2) = 0.1d0
    tn%cr(3) = 0.05d0
    tn%cr(4) = -0.05d0
    tn%cr(5) = 0.05d0
    tn%cr(6) = -0.025d0
    tn%cr(7) = 0.025d0

  end subroutine toray_numeric_adflts

  subroutine toray_namelist_wr(zlabel, tn, tg, ier)

    !----------------------------------
    ! write "toray.in" and "gafit.in" namelist files for TORAY standalone code
    !----------------------------------

    use key_access

    !----------------------------------
    character*(*), intent(in) :: zlabel
    type (toray_numeric), intent(in) :: tn
    type (toray_gafit), intent(in) :: tg
    integer, intent(out) :: ier
    !----------------------------------
  
    integer :: ios,ilun

    !----------------------------------
    ier = 0
  
    call ka_init

    ! numerics
    call ka_set('igafit', tn%igafit) ! must be 1 for geqdsk 
    call ka_set('smax', tn%smax)   ! max arclength in cm
    call ka_set('ds', tn%ds)       ! initial step size in cm
    call ka_set('dsmin', tn%dsmin) ! adjustable step size in cm

    call ka_set('fdout', tn%fdout) ! ray output every fdout step 
    call ka_set('powinc', tn%powinc) ! for getting J/P profile 
    call ka_set('relerr', tn%relerr) ! Relative error 
    call ka_set('abserr', tn%abserr) ! absolute error

    call ka_set('pwrfmin', tn%pwrfmin) ! stop following when reach this fraction
    call ka_set('cqldat', tn%cqldat) ! Files for CQL3D 
    call ka_set('mn0', tn%mn0)     ! no of points in Gauss integration

    ! physics
    call ka_set('ezeff', tn%ezeff) ! Zrmeff
    call ka_set('nharm', tn%nharm) ! harmonic number
    call ka_set('bsratio', tn%bsratio) ! antenna elongation
    call ka_set('modelc', tn%modelc) ! model for ECCD calculation

    ! rays
    call ka_set('gauszone', tn%gauszone) ! no of zones 

    call ka_set('mray(1)',tn%mray(1))
    call ka_set('mray(2)',tn%mray(2))
    call ka_set('mray(3)',tn%mray(3))
    call ka_set('mray(4)',tn%mray(4))
    call ka_set('mray(5)',tn%mray(5))
    call ka_set('mray(6)',tn%mray(6))
    call ka_set('mray(7)',tn%mray(7))

    call ka_set('cr(1)',tn%cr(1))
    call ka_set('cr(2)',tn%cr(2))
    call ka_set('cr(3)',tn%cr(3))
    call ka_set('cr(4)',tn%cr(4))
    call ka_set('cr(5)',tn%cr(5))
    call ka_set('cr(6)',tn%cr(6))
    call ka_set('cr(7)',tn%cr(7))

    ! netcdf output
    call ka_set('netcdfdat', tn%netcdfdat)

    !------------------------------
    ! write toray.in ...

    call find_io_unit(ilun)

    open(ilun, file='toray.in', status='unknown', iostat=ios)
    if(ios.eq.0) then
       write(ilun,'(a)') trim(zlabel)
       close(ilun)
    else
       write(6,*) ' ?toray_namelist_wr: open failure: toray.in '
       ier=1
       return
    endif

    call ka_write_namelist('toray.in', 'EDATA', 'a') ! append mode
  
    call ka_free

    !-----------------------
    !  write gafit.in ...

    call ka_init
  
    call ka_set('ipsi', tg%ipsi)   ! 0 to use psiin generated above

    call ka_set('gafsep',tg%gafsep)
    call ka_set('dsrat', tg%dsrat)
    call ka_set('tolmap',tg%tolmap) ! tolerance
    call ka_set('percenflux', tg%percenflux) ! to separatrix
    call ka_set('newbdry', tg%newbdry)
    
    call ka_write_namelist('gafit.in', 'FITDAT', 'w')

    call ka_free

  end subroutine toray_namelist_wr

end module echmod_typedef

C-----------------------------------------------------------------------
C  TDBSUB_CK2A -- CHECK THE POINTERS AND CONTROLS ON A TRDAT PROFILE
C
C  DMC MAY 1991 -- FOR NEW TRDAT/TRANSP INTERFACE
C
      SUBROUTINE TDBSUB_CK2A(d,ZDATID,IFPTR,IXPTR,IXLEN,INRI,INSY,IER)
C
C  PASSED INPUT:
C
C    ZDATID -- DATA PROFILE ID
C    IFPTR  -- PTR TO DATA -- NONZERO IF DATA EXISTS
C    IXPTR  -- PTR TO X AXIS IF DATA EXISTS
C    IXLEN  -- NO. PTS IN X AXIS IF DATA EXISTS
C    INRI   -- X AXIS TYPE CODE IF DATA EXISTS
C    INSY   -- DATA SYMMETRIZATION CODE IF DATA EXISTS
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      use trdatbuf_obj
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER ixptr,ixlen,inri,insy,ier,ifptr,ia,iabs,ix,iwarn
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zxmin,zxmax,zxatest
!============
      type (trdatbuf) :: d
      character*(*) ZDATID
C
      integer :: nonlin,lunmsg_tdb
C
C-----------------------------------------------------------------------
C
      IER=0
C
      nonlin=lunmsg_tdb(0)
C
      IF(IFPTR.LE.0) GO TO 1000
C
      IF((IXPTR.LE.0).OR.(IXLEN.LE.0)) THEN
         IER=1
         WRITE(NONLIN,9901) ZDATID,IXPTR,IXLEN
 9901    FORMAT(
     >        ' ?TDBSUB_CK2A -- ERROR IN TRDAT? -- "',A,
     >        '" X AXIS DATA INVALID'/
     >        '   ADDRESS = ',I10,'  LENGTH = ',I10)
      ENDIF
C
      IA=IABS(INRI)
      IF((IA.EQ.0).OR.(IA.GT.8)) THEN
         IER=1
 
         WRITE(NONLIN,9902) ZDATID,INRI
 9902    FORMAT(
     >        ' ?TDBSUB_CK2A:  NAMELIST CONTROL NRI',A,
     >        ' = ',I10,' ** INVALID **')
      ENDIF
C
      IF((IA.EQ.3).AND.((INSY.LE.0).OR.(INSY.GT.4))) THEN
         IER=1
 
         WRITE(NONLIN,9903) ZDATID,INRI,ZDATID,INSY
 9903    FORMAT(
     >        ' ?TDBSUB_CK2A:  NAMELIST ERROR:  ',
     >        'SYMMETRIZATION CONTROL NOT SET'/
     >        '  NRI',A,' = ',I2,' ... BUT NSY',A,' = ',I10)
      ENDIF
C
      IF((IA.NE.3).AND.(INSY.NE.0)) THEN
         IER=1
 
         WRITE(NONLIN,9904) ZDATID,INRI,ZDATID,INSY
 9904    FORMAT(
     >        ' ?TDBSUB_CK2A:  NAMELIST ERROR:  ',
     >        'SYMMETRIZATION CONTROL *IS* SET'/
     >        '  NRI',A,' = ',I2,' (not 2-sided) ... BUT NSY',A,
     >        ' = ',I10)
      ENDIF
C
C  if IER=0 to this point, check X axis values and ordering also...
C
      if(ier.eq.0) then
         zxmin=1.0d34
         zxmax=-zxmin
         iwarn=0
         do ix=1,ixlen
            if(ix.gt.1) then
               if(d%DATBUF(ixptr+ix-1).le.d%DATBUF(ixptr+ix-2)) then
                  iwarn=iwarn+1
                  if(iwarn.eq.1) then
                     write(nonlin,*) ' ?TDBSUB_CK2A: "',trim(zdatid),
     >                    '" x axis not in strict ascending order:'
                     write(nonlin,
     >                    '(a,i4,a,i4,a,1pe12.5,a,i4,a,1pe12.5,a)')
     >                    '  nx=',ixlen,'  x(',ix-1,')=',
     >                    d%DATBUF(ixptr+ix-2),'  x(',ix,')=',
     >                    d%DATBUF(ixptr+ix-1),'.'
                  else if(iwarn.eq.2) then
                     write(nonlin,*) ' [...multiple violations...]'
                  endif
                  ier=1
               endif
            endif
            zxmin=min(zxmin,d%DATBUF(ixptr+ix-1))
            zxmax=max(zxmin,d%DATBUF(ixptr+ix-1))
         enddo
C
         zxatest = max(abs(zxmin),abs(zxmax))
         if(zxatest.gt.5.0_R8) then
            if((inri.ge.5).or.(inri.lt.0)) then
               ier=1
 
               write(nonlin,9910) zdatid,inri,zxatest
            endif
         endif
 9910    format(' ?TDBSUB_CK2A:  NRI',A,' = ',I2,
     >        ' specifies a normalized'/
     >        '  X axis (abs(x(i)) btw 0 and 1 + epsilon), but:'/
     >        '  max(abs(x(i))) = ',1pe11.4,' in data, i=1 to nx.')
C
      endif
C
 1000 CONTINUE
      RETURN
      END

subroutine ps_copy_xpl(iobjp,iobj,iout,ierr)

  !-----------------------------------------------------
  ! D. McCune 26 Nov 2007
  !
  ! Copy xplasma object associated with state (iobjp) to that
  ! associated with state (iobj)
  !-----------------------------------------------------

  use plasma_state_definition_mod
  use plasma_state_xpobj  ! XPLASMA2 state object definitions
  implicit NONE

  !-----------------------
  !  passed arguments:

  integer :: iobjp(ps_container_size)    ! xplasma opaque container (copy from...)
  integer :: iobj(ps_container_size)     ! xplasma opaque container (copy to...)

  integer, intent(in) :: iout     ! Fortran LUN of file for messages
  integer, intent(out) :: ierr    ! completion status code (0=OK)
  
  type (interp_object) :: xobjp
  type (xplasma), pointer :: sp

  type (interp_object) :: xobj
  type (xplasma), pointer :: s
  !-----------------------

  xobjp = transfer(iobjp,xobjp)
  sp => xobjp%s_xpobj

  call xplasma_global_info(sp,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_copy_xpl: invalid or unitialized xplasma object (iobjp).'
     return
  endif

  xobj = transfer(iobj,xobj)
  s => xobj%s_xpobj

  call xplasma_global_info(s,ierr, init_check=.TRUE.)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_copy_xpl: invalid or unitialized xplasma object (iobj).'
     return
  endif

  call xplasma_copy(sp,s,ierr)
  if(ierr.ne.0) then
     write(iout,*) ' ?ps_copy_xpl: xplasma_copy error:'
     call xplasma_error(s,ierr,iout)
  endif

end subroutine ps_copy_xpl

! written by plasma_state_gen.py
!   input: plasma_state_spec.dat, version id: 2.055
! *** do not edit *** (use code generator instead)


SUBROUTINE ps_update_file_read_8(ss,icdf,iout,iucount,iertot)


  ! Read updated data

  USE plasma_state_definition_mod
  USE plasma_hash_code
  USE netcdf
  IMPLICIT NONE

  TYPE (plasma_state) :: ss  ! state containing array elements to be allocated
  INTEGER, INTENT(IN) :: icdf  ! NetCDF file ID
  INTEGER, INTENT(IN) :: iout  ! LUN for messages
  INTEGER, INTENT(INOUT) :: iucount ! update count
  INTEGER, INTENT(INOUT) :: iertot  ! error count

  !-------------------

  INTEGER :: varid,status
  INTEGER :: ival,jval,ii
  INTEGER :: prehash1,prehash2
  INTEGER :: posthash1,posthash2
  CHARACTER*80 :: nc_errmsg
  LOGICAL :: izero

  !-------------------


  status = nf90_inq_varid(icdf,"tfinal",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tfinal)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tfinal"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tfrip2_log",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tfrip2_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tfrip2_log"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tfrip_log",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tfrip_log)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tfrip_log"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"TF_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%TF_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: TF_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"thegrilh",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%thegrilh)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: thegrilh"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"th_eq",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL rchk_zero(ss%th_eq)
     status = nf90_get_var(icdf,varid,ss%th_eq)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: th_eq"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL rchk_hash("th_eq",ss%th_eq)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ti"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tiflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tiflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tiflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tinit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tinit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tinit"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ti_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ti_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ti_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"ti_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%ti_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: ti_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tmodel)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tmodel"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tmodel_bdy",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tmodel_bdy)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tmodel_bdy"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tokamak_id",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tokamak_id)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tokamak_id"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tornum_balcrit",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Tornum_balcrit)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Tornum_balcrit"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tor_mode_label",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%Tor_mode_label)
     status = nf90_get_var(icdf,varid,ss%Tor_mode_label)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Tor_mode_label"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("Tor_mode_label",ss%Tor_mode_label)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Tor_mode_No",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Tor_mode_No)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Tor_mode_No"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq0_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tq0_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tq0_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqb0_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqb0_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqb0_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbe",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqbe)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqbe"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbjxb",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqbjxb)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqbjxb"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqbth",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqbth)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqbth"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqcx_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqcx_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqcx_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqcx_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqcx_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqcx_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqioniz",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqioniz)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqioniz"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqqcx",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqqcx)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqqcx"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqsc_halo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqsc_halo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqsc_halo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tqsc_reco",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tqsc_reco)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tqsc_reco"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tq_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tq_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tq_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tq_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tq_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tq_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tq_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trace_flag",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%trace_flag)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: trace_flag"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     CALL cchk_zero(ss%trcat)
     status = nf90_get_var(icdf,varid,ss%trcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: trcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
     IF(.NOT.izero) THEN
        CALL cchk_hash("trcat",ss%trcat)
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%triang)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: triang"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triangL",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%triangL)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: triangL"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triangU",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%triangU)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: triangU"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang_miller_L",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%triang_miller_L)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: triang_miller_L"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"triang_miller_U",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%triang_miller_U)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: triang_miller_U"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"trmodels",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%trmodels)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: trmodels"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ts)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ts"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_Data_Info",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ts_Data_Info)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ts_Data_Info"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"Ts_is_input",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%Ts_is_input)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: Ts_is_input"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tzflux_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tzflux_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tzflux_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"tz_ky_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%tz_ky_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: tz_ky_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_einj_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T_einj_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T_einj_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_ffull_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T_ffull_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T_ffull_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"T_fhalf_standard",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%T_fhalf_standard)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: T_fhalf_standard"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_ns",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%upwind_pfrac_ns)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: upwind_pfrac_ns"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_omega",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%upwind_pfrac_omega)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: upwind_pfrac_omega"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_Te",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%upwind_pfrac_Te)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: upwind_pfrac_Te"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"upwind_pfrac_Ti",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%upwind_pfrac_Ti)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: upwind_pfrac_Ti"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vee_trans",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vee_trans)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vee_trans"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"vee_transcat",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%vee_transcat)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: vee_transcat"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_fusi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velb_fusi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velb_fusi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_nbi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velb_nbi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velb_nbi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velb_rfmi",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velb_rfmi)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velb_rfmi"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velne_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velne_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velne_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velnh_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velnh_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velnh_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velni_drbm",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velni_drbm)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velni_drbm"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velns_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velns_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velns_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velnx_nclass",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velnx_nclass)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velnx_nclass"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_mmm71",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_mmm71)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_mmm71"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_neo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_neo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_neo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velpphi_tglf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velpphi_tglf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velpphi_tglf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_anom",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_anom)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_anom"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_glf",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_glf)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_glf"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

  status = nf90_inq_varid(icdf,"velte_gtcneo",varid)
  IF(status.EQ.NF90_NOERR) THEN
     status = nf90_get_var(icdf,varid,ss%velte_gtcneo)
     IF(status.NE.NF90_NOERR) THEN
        WRITE(iout,*) " ?ps_update_file_read: error reading variable: velte_gtcneo"
        CALL ncerr(status)
        iertot = iertot + 1
        izero=.TRUE.
     ELSE
        iucount = iucount + 1
     ENDIF
  ENDIF

CONTAINS

  subroutine ichk_zero(iarray)
     integer, dimension(:), intent(in) :: iarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(iarray)
        if(iarray(ii).ne.0) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(iarray,prehash1,prehash2)
     endif

  end subroutine ichk_zero

  subroutine rchk_zero(rarray)
     real(kind=rspec), dimension(:), intent(in) :: rarray

     integer :: ii

     izero=.TRUE.
     do ii=1,size(rarray)
        if(rarray(ii).ne.0.0_rspec) then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(rarray,prehash1,prehash2)
     endif

  end subroutine rchk_zero

  subroutine cchk_zero(c32array)
     character*32, dimension(:), intent(in) :: c32array

     integer :: ii

     izero=.TRUE.
     do ii=1,size(c32array)
        if(c32array(ii).ne." ") then
           izero=.FALSE.
           exit
        endif
     enddo

     if(.not.izero) then
        prehash1=17
        prehash2=23
        call hashCode(c32array,prehash1,prehash2)
     endif

  end subroutine cchk_zero

  subroutine ichk_hash(itemName,iarray)
     character*(*), intent(in) :: itemName
     integer, dimension(:), intent(in) :: iarray

     posthash1=17
     posthash2=23
     call hashCode(iarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine ichk_hash

  subroutine rchk_hash(itemName,rarray)
     character*(*), intent(in) :: itemName
     real(kind=rspec), dimension(:), intent(in) :: rarray

     posthash1=17
     posthash2=23
     call hashCode(rarray,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine rchk_hash

  subroutine cchk_hash(itemName,c32array)
     character*(*), intent(in) :: itemName
     character*32, dimension(:), intent(in) :: c32array

     posthash1=17
     posthash2=23
     call hashCode(c32array,posthash1,posthash2)

     if((prehash1.ne.posthash1).OR.(prehash2.ne.posthash2)) then
        write(iout,*) ' ?ps_update_file_read: value change detected in dimension quantity: '//trim(itemName)
        iertot = iertot + 1
     endif

  end subroutine cchk_hash

  SUBROUTINE ichk_dim(ival,jval,dname)
     INTEGER, intent(in) :: ival  ! file dimension value
     INTEGER, intent(in) :: jval  ! state dimension value
     CHARACTER*(*), intent(in) :: dname

     IF(ival.ne.jval) THEN
        WRITE(iout,*) ' ?ps_update_file_read: update file dimension not consistent with state:'
        WRITE(iout,*) '  file value:  ',ival
        WRITE(iout,*) '  state value: ',jval
        WRITE(iout,*) '  dimension name: '//trim(dname)
        iertot = iertot + 1
     ENDIF
  END SUBROUTINE ichk_dim

  SUBROUTINE ncerr(status)
     INTEGER, INTENT(in) :: status

     nc_errmsg = NF90_strerror(status)
     write(iout,*) '  NetCDF message: ',trim(nc_errmsg)
  END SUBROUTINE ncerr

  SUBROUTINE denull(str)
     ! convert null characters to blank
     CHARACTER*(*) :: str
     INTEGER :: i

     do i=1,len(str)
        if(ichar(str(i:i)).eq.0) str(i:i)=' '
     enddo
  END SUBROUTINE denull

END SUBROUTINE ps_update_file_read_8

subroutine tr_getnl_ready(iflag)

  !  return iflag = .TRUE. if the tr_getnl module contains a namelist

  use tr_getnl
  implicit NONE

  logical, intent(out) :: iflag



  iflag = (mltext_nlines.gt.0)

end subroutine tr_getnl_ready

C-----------------------------------------------------------------------
C  TDB_PFSETR
C
C  SET UP (OPTIONALLY SHIFTED) INTERPOLATION TARGET X VECTOR
C  FOR ELECTRON TEMPERATURE OR DENSITY DATA -- or other profile data
C
C  dmc May 2005 -- modular version: no trcom...
C
C  dmc Feb 1997 -- support INRI=6 for data vs. normalized poloidal flux
C  dmc Feb 2002 -- support INRI=7 for data vs. sqrt(normalized poloidal flux)
C  dmc Feb 2002 -- support INRI=8 for data vs. normalized toroidal flux
C        (INRI=5 supports data vs. sqrt(normalized toroidal flux), as always)
C
C  dmc revised Oct 1995 -- to tolerate interior B(R) non-monotonicity
C    singularity
C
C  NEW VERSION DMC OCT 1983 -- X COORDINATE FOR GENERALIZED GEOMETRY
C
C  REVISED DMC MAR 1992 -- FOR USE WITH PROFLI
C    ARGUMENTS VARIABLES ARE FOR THE MOST PART DESCRIBED IN PROFLI.FOR
C
C    INPUTS:  INRI,INSY,IHECFT(THE ECE HARMONIC IF >0),IBDY
C    OUTPUTS:  ILOOP,INOUT
C
      SUBROUTINE TDB_PFSETR(d,t,INRI,INSY,IHECFT,IBDY,ILOOP,INOUT)
C
      use trdatbuf_obj
      use trdatbuf_aux
      IMPLICIT NONE

      type (trdatbuf) :: d
      type (profget) :: t

      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
C
!============
! idecl:  explicitize implicit INTEGER declarations:
      INTEGER insy,ihecft,ibdy,iloop,inri,ishift,izb,inria,il,jz,j
      INTEGER jp1,iadr,izp1,inm1,jr,istart,nrmaj,nzones,iarat
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zdr0,zsign,zshaf,zpf,zfp0,zfp,zdr,zr,zfbdy,zfn,zftol
      real*8 :: rminrd
!============
      INTEGER INOUT(2),lunmsg_tdb,nonlin
C
C  REV DMC FEB 1987
C   IF IBDY.EQ.1 SETUP FOR DATA INTERPOLATION TO ZONE BDY'S NOT ZONE
C   CTR'S
C
C  REV DMC JUNE 1984
C
C  IF IHECFT.GT.0 THEN:
C------------------------------
C  INTERPRET STORED DATA AS ECE DATA VS. FREQUENCY
C
C  IHECFT IS THE HARMONIC
C
C  COMMON VECTOR RMAJMP CONTAINS A SERIES OF MIDPLANE RADII COVERING
C  THE ENTIRE PLASMA; COMMON VECTOR FBX WHEN MULTIPLIED WITH THE
C  EXTERNAL FIELD YIELDS THE LOCAL FIELD STRENGTH AT THESE MAJOR RADIAL
C  LOCATIONS
C
C   THIS FEATURE MAY BE USED ONLY IF LEVGEO.GT.1 AND AT LEAST A
C  SHAFRANOV SHIFTED CIRCLES EQUILIBRIUM IS CALCULATED, INCLUDING A
C  PARA/DIAMAGNETIC EFFECT ON THE TOROIDAL FIELD
C
C   SUBROUTINE FBCALM WAS CALLED TO CALCULATE THE RATIO FBX OF |B|
C  THE TOTAL FIELD TO THE EXTERNAL FIELD (BZXR/R) AT EACH
C  MAJOR RADIUS POINT ALONG THE MIDPLANE AS STORED IN ARRAY RMAJMP
C
C   THE TOTAL FIELD STRENGTH INCLUDES THE EFFECT OF THE POLOIDAL
C  FIELD INDUCED BY TOROIDAL PLASMA CURRENT, AS WELL AS THE PARA/DIA
C  MAGNETIC EFFECT DUE TO POLOIDAL PLASMA CURRENT.
C
C  dmc Oct 18 1995:  in presence of strong enough pressure local Beta,
C   the B(R) gradient can reverse, causing a gap in Te coverage.  Now
C   fill this gap with interpolation instead of aborting.  Save the
C   gap indices here
C
C  dmc Nov 8, 1998:  now use pfsetsng to patch the ECE map -- old
C   ztdb_pfsetr COMMON and patching code was removed.
C
C----------------------------
      REAL*8, dimension(:), allocatable :: zwk1,zwk2,zx,drshaf
C----------------------------
C
C  PASSED INPUT ARGUMENTS:
C   INRI-- TYPE OF X VECTOR OF DATA TO BE INTERPOLATED (FROM COMMON
C     NRITER (TEMPERATURE) OR NRINER (DENSITY))
C     =1 OR 4:  DATA COVERS RANGE 0 TO 1 OF X = (R-R0)/A
C         IF ECE DATA - COVERS OUTSIDE HALF OF PLASMA MIDPLANE
C         =4:  data was originally vs. "minor radius".
C     =2     :  DATA COVERS RANGE -1 TO 0  OF X
C         IF ECE DATA - COVERS INSIDE HALF OF PLASMA MIDPLANE
C     =3     :  DATA COVERS RANGE -1 TO +1 (I.E. SYMMETRIZABLE
C               2-SIDED DATA)
C     =5     :  DATA HAS ALREADY BEEN MAPPED TO "XI" FLUX SURFACES
C     =6     :  data is mapped on surfaces labeled by normalized
C               poloidal magnetic flux
C     =7     :  data is mapped on surfaces labeled by normalized
C               SQRT(poloidal magnetic flux)
C     =8     :  data is mapped on surfaces labed by normalized
C               toroidal flux (no SQRT).
C
C  PASSED OUTPUT ARGUMENTS:
C   ILOOP= LOOP LIMIT =1 IF DATA IS SINGLE SIDED; 2 IF 2-SIDED
C     IJ=1 TO ILOOP ...
C   INOUT(IJ) FLAG FOR IJ'TH TARGET X VECTOR
C     =1 -- COVERS RANGE 0 TO 1 AND IS MONOTONIC INCREASING
C     =2 -- COVERS RANGE -1 TO 0 AND IS MONOTONIC INCREASING X:
C           INDEX REVERSAL NEEDED TO GET INCREASING MINOR RADIUS INDEX
C  ECE DATA - =1: COVERS INSIDE HALF OF MIDPLANE, MONOTONIC INCREASING
C             =2:  COVERS OUTSIDE HALF, IS MONOTONIC INCREASING IN
C             FREQUENCY SPACE - REVERSE INDICES TO GET MONOTONIC
C             INCREASING MINOR RADIUS ZONE INDEX
C
C  COMMON OUTPUT:
C   WORKBUF(LBX(IJ)...)  IS THE IJ'TH TARGET X VECTOR
C
C  MONOTONIC INCREASING TARGETS ARE REQUIRED FOR INTERPOLATION ROUTINE
C  INT2D USED IN PROFE1
C
C----------------------------------------------------------------------
C
C  FLUX SURFACE SHIFT EFFECT IS INCLUDED UNLESS
C   (1) THE DATA IS ABEL INVERTED, STORED VS. NORMALIZED MINOR RADIUS
C   (2) THE DATA HAS BEEN PRESYMMETRIZED AND MAPPED TO NORMALIZED
C         MINOR RADIUS
C
C  ISHIFT IS NOT USED IN CASE OF ECE DATA MAPPING
C
      nonlin=lunmsg_tdb(0)
C
      nrmaj=t%nrmaj
      nzones = t%nzones
      izp1 = nzones + 1
C
      iarat=0
      IF(IHECFT.LE.0) THEN
         ISHIFT=1
         IF(INRI.GE.4) ISHIFT=0
         IF((INRI.EQ.3).AND.(INSY.EQ.1)) then
                                !  data was presymmetrized...
            ISHIFT=0
            iarat=1             ! use normalized aspect ratio
            if(ihecft.lt.0) then
                                !  presymmetrized data was ECE originally;
               iarat=-1         ! use (1/B) version of aspect ratio
            endif
         endif
      ENDIF
C
      IF((INRI.EQ.3).AND.(INSY.EQ.2 .or. INSY.EQ.3 .or. INSY.EQ.4)) THEN
        ILOOP=2
        INOUT(1)=1
        INOUT(2)=2
      ELSE
        ILOOP=1
        IF(INRI.EQ.2) THEN
          INOUT(1)=2
        ELSE
          INOUT(1)=1
        ENDIF
        IF(IHECFT.GT.0) INOUT(1)=3-INOUT(1)
      ENDIF
C
C  NORMALIZED POSITION (X) SPACE MAP:
      allocate(zx(izp1),drshaf(izp1))
      CALL TDB_ROVERA(t,INRI,iarat,ZX,drshaf,izp1)
      if(ishift.eq.1) then
         rminrd=0.5_R8*(t%rmajmp(nrmaj)-t%rmajmp(1))
      endif
C
      IZB=2-IBDY  ! ZONE/BDY SHIFT INDEX
C
      inria=abs(inri)
      IF(IHECFT.LE.0) THEN
C------------------------------------------------
        if((inria.lt.6).or.(inria.gt.7)) then
           ZDR0=0.0_R8          ! may need to adjust for free bdy at some pt.
           DO 100 IL=1,ILOOP
C
              DO 99 JZ=1,izp1
C IN/OUT MAPPING
                 IF(INOUT(IL).EQ.1) THEN
                    ZSIGN=1.0_R8
                    J=JZ
                 ELSE
                    ZSIGN=-1.0_R8
                    J=izp1+1-JZ
                 ENDIF
C NORMALIZED SHIFT
                 IF(ISHIFT.EQ.1) THEN
C  MHD EQUILIBRIUM
                    zshaf = (zdr0 + drshaf(j))/rminrd
                 ELSE
C  NO SHIFT
                    ZSHAF=0.0_R8
                 ENDIF
C ADDRESS OF TARGET X
                 IADR=d%LBX(IL)+JZ-1
C TARGET X
                 d%WORKBUF(IADR)=ZSIGN*ZX(J)+ZSHAF
                 if(inria.eq.8) d%WORKBUF(iadr)=
     >              d%WORKBUF(iadr)*d%WORKBUF(iadr)
C LOOP END
 99           CONTINUE
 100       CONTINUE
        else
C-------------------------------------------
C  poloidal flux mapping (inria=6,7)
C
           if(iloop.ne.1) then
              write(nonlin,*)
     1           ' ?tdb_pfsetr:  inria=6 or 7 & iloop.ne.1 unexpected.'
              iloop=0
              go to 999
           endif
           do j=1,izp1
              iadr=d%LBX(iloop)+j-1
              if(ibdy.eq.1) then
C     pol. flux @ bdy
                 zpf=t%plflxg(j)
              else
C     pol. flux @ zone ctr
                 jp1=j+1
                 if(j.le.nzones) then
                    zpf=0.5_R8*(t%plflxg(j)+t%plflxg(jp1))
                 else
C  extrapolate
                    zpf=t%plflxg(izp1)+
     >                   0.5_R8*(t%plflxg(izp1)-t%plflxg(nzones))
                 endif
              endif
C  normalize
              zpf=max(0.0_R8,zpf)
              zpf=zpf/t%plflxg(izp1)
C  store
              d%WORKBUF(iadr)=zpf
              if(inria.eq.7) d%WORKBUF(iadr)=sqrt(zpf)
           enddo
        endif
C-------------------------------------------
C  FREQUENCY SPACE MAP
      ELSE
C
        IZP1=NZONES+1
C
        ZFP0=28.0_R8*IHECFT*t%BMIDP(IZP1)
C
        allocate(zwk1(izp1),zwk2(izp1))
C
        DO 200 IL=1,ILOOP
C
C  ZFBDY IS A FREQUENCY PAST THE EDGE OF THE PLASMA;
C  ZFP IS THE FREQUENCY AT THE PREVIOUS ZONE BDY
C
C  IN THIS DOUBLE LOOP A MONOTONICALLY INCREASING SEQUENCE OF
C  FREQUENCIES ARE DEFINED WHICH CORRESPOND TO TRANSP ZONE CTRS.
C  HOWEVER THE ORDERING WILL BE REVERSED (I.E. MOVING FROM EDGE TO
C  CENTER OF PLASMA) IF INOUT(IL)=2 AND THE FREQUENCIES CORRESPOND
C  TO THE OUTER HALF OF THE PLASMA MIDPLANE INTERSECTION
C
           ZFP=ZFP0
C
           IF(INOUT(IL).EQ.1) THEN
              ZFBDY=28.0_R8*IHECFT*
     >             (t%bmidp(1)-0.5_R8*(t%bmidp(2)-t%bmidp(1)))
              d%WORKBUF(d%LBX(IL)+nzones)=ZFBDY
           ELSE
              INM1=NRMAJ-1
              ZFBDY=28.0_R8*IHECFT*
     >             (t%bmidp(nrmaj)+
     >             0.5_R8*(t%bmidp(nrmaj)-t%bmidp(inm1)))
              d%WORKBUF(d%LBX(IL))=ZFBDY
           ENDIF
C
           DO 199 J=1,nzones
C
              IF(INOUT(IL).EQ.1) THEN
                 IADR=d%LBX(IL)+J-1
                 JR=izp1-J
              ELSE
                 IADR=d%LBX(IL)+izp1-J
                 JR=IZP1+J
              ENDIF
C
              ZFN=28.0_R8*IHECFT*t%bmidp(JR)
              d%WORKBUF(IADR)=0.5_R8*(ZFN+ZFP)
C
              ZFP=ZFN
C
 199       CONTINUE
C
           zftol=1.000001_R8
           istart=0
C
           call tdb_pfsetsng(d%WORKBUF(d%LBX(il)),zx,izp1,
     1          zwk1,zwk2,'tdb_pfsetr',nonlin)
C
C  the pfsetsng routine now enforces monotonicity of the ECE
C  freq->R map, so the non-monotonicity patch loop previously
C  coded is no longer needed.  It turned out to be a continuity
C  hazard with respect to Te (and hence Zeff in certain operational
C  modes).
C
 200    CONTINUE
        deallocate(zwk1,zwk2)
C------------------------------------------------
      ENDIF
C
 999  continue
      deallocate(zx,drshaf)
      RETURN
      END
C-----------------------------------------------------------------------
C
C  this routine removes flat spots, from an expected monotonic function,
C  preventing any slope less than a fixed amount below the average
C  slope from happening anywhere.
C  dmc 8 Nov 1998
C
      subroutine tdb_pfsetsng(zfdata,zx,inum,zwk1,zwk2,runid,nonlin)
c
!============
! idecl:  explicitize implicit INTEGER declarations:
      IMPLICIT NONE
      INTEGER, PARAMETER :: R8=SELECTED_REAL_KIND(12,100)
      INTEGER nonlin,inum,itmax,iter,ict,i,ip
!============
! idecl:  explicitize implicit REAL declarations:
      REAL*8 zfac,zmark,zsmin,zs,zdf
!============
      REAL*8 zfdata(inum)		! frequencies
      REAL*8 zx(inum)			! indep. coordinate
      REAL*8 zwk1(inum),zwk2(inum)	! work arrays
      character*(*) runid		! runid label
c
      data zfac/0.1_R8/
      data zmark/-1.0E35_R8/
      data itmax/1000/
c
c------------------------------------------
c
      zsmin=zfac*(zfdata(inum)-zfdata(1))/(zx(inum)-zx(1))
c
      iter=0
 10   continue
      iter=iter+1
      if(iter.gt.itmax) then
         write(nonlin,9901) itmax
 9901    format(
     >        ' ?tdb_pfsetr:  more than ',i5,' iterations in pfsetsng')
         call bad_exit
      endif
      ict=0
      zwk1(inum)=zfdata(inum)
      do i=1,inum-1
         zwk1(i)=zfdata(i)
         zwk2(i)=zmark
         ip=i+1
         zs=(zfdata(ip)-zfdata(i))/(zx(ip)-zx(i))
         if(zs.lt.zsmin) then
            ict=ict+1
            zwk2(i)=0.5_R8*(zfdata(i)+zfdata(ip))
         endif
      enddo
      if(ict.eq.0) go to 100
      do i=1,inum-1
         if(zwk2(i).ne.zmark) then
            ip=i+1
            zs=(zfdata(ip)-zfdata(i))/(zx(ip)-zx(i))
            zdf=0.5_R8*(1.0001_R8*zsmin-zs)*(zx(ip)-zx(i))
            zdf=max(zdf,0.00001_R8*max(abs(zwk1(i)),abs(zwk1(ip))))
            zwk1(i)=zwk1(i)-zdf
            zwk1(ip)=zwk1(ip)+zdf
         endif
      enddo
c
      do i=1,inum
         zfdata(i)=zwk1(i)
      enddo
      go to 10
c
 100  continue
      return
      end
